-- gh -- a compiler for Generic Haskell.
-- Copyright (c) 2001 -- 2005  The Generic Haskell Team. Utrecht University
-- 
-- This library is free software; you can redistribute it and/or modify
-- it under the terms of the GNU Lesser General Public License as
-- published by the Free Software Foundation; either version 2.1 of the
-- License, or (at your option) any later version.
-- 
-- This library is distributed in the hope that it will be useful, but
-- WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-- Lesser General Public License for more details.
-- 
-- You should have received a copy of the GNU Lesser General Public
-- License along with this library; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
--
-- $Id: Types.hs 194 2005-01-12 09:16:08Z andres $
--
-- author: Andres Loeh (andres@cs.uu.nl)

module Types 
  ( module TypeConstruction
  , module TypeVars
  , module TypeParens
  , module TypeAlpha
  , module TypeNormalize
  , module TypeReduce
  , module TypeReplace
  , module TypeUtils
  , module UHA_Parser
  ) where

import Set
import Name
import TypeConstruction
import TypeVars (freeVars, freeVarsCtx, allVars, quantify, quantifyLambda)
import TypeParens (strip, parenthesize, parenthesizeIf)
import TypeAlpha (alpha)
import TypeNormalize (normalize, countArguments)
import TypeReduce (reduce, substitute, makeLambdaType, forcePlainType)
import TypeReplace (replace, replaceLambda
                   ,applyKindIndexedType
                   ,deriveKindIndexedType
                   ,makeKindIndexedType
                   ,liftKindIndexedType
                   ,enrichType
                   )
import TypeUtils
import UHA_Parser (parseType)
