
ToDo: Parsing floats is a *real* hack...
ToDo: Introduce different tokens for decimal, octal and hexadecimal (?)
ToDo: FloatTok should have three parts (integer part, fraction, exponent)
ToDo: Use a lexical analyser generator (lx?)

> module UHA_Lexer (Token(..), get, isSymbol, errshow) where
> 
> import UHA_ParseMonad
> import UHA_ParseUtils
> import AbstractSyntax    {- for the ranges -}
> import UHA_Range
> -- import IOExts
> 
> import Char
> import Maybe

> data Token 
>         = VarId        String !Range
>         | QVarId       ([String],String) !Range
>         | ConId        String !Range
>         | QConId       ([String],String) !Range
>         | VarSym       String !Range
>         | ConSym       String !Range
>         | QVarSym      ([String],String) !Range
>         | QConSym      ([String],String) !Range
>         | IntTok       String !Range
>         | FloatTok     String !Range
>         | Character    Char !Range
>         | StringTok    String !Range
> 
> -- Symbols
> 
>         | LeftParen    !Range
>         | RightParen   !Range
>         | SemiColon    !Range
>         | LeftCurly    !Range
>         | RightCurly   !Range
>         | VRightCurly   -- a virtual close brace
>         | LeftSquare   !Range
>         | RightSquare  !Range
>         | Comma        !Range
>         | Underscore   !Range
>         | BackQuote    !Range

<generic-haskell>

>         | LeftTyParen  !Range
>         | RightTyParen !Range
>         | LeftKiParen  !Range
>         | RightKiParen !Range

</generic-haskell>

> 
> -- Reserved operators
> 

<generic-haskell>

>         | Dot          !Range

</generic-haskell>

> 	  | DotDot       !Range
> 	  | DoubleColon  !Range
> 	  | Equals       !Range
> 	  | Backslash    !Range
> 	  | Bar          !Range
> 	  | LeftArrow    !Range
> 	  | RightArrow   !Range
> 	  | At           !Range
> 	  | Tilde        !Range
> 	  | DoubleArrow  !Range
> 	  | Minus        !Range
> 	  | Exclamation  !Range
> 
> -- Reserved Ids
> 
> 	  | KW_As        !Range
> 	  | KW_Case      !Range
> 	  | KW_Class     !Range
> 	  | KW_Data      !Range
> 	  | KW_Default   !Range

<generic-haskell>

>         | KW_Dependency !Range

</generic-haskell>

> 	  | KW_Deriving  !Range
> 	  | KW_Do        !Range
> 	  | KW_Else      !Range

<generic-haskell>

>         | KW_Extends   !Range
>         | KW_Forall    !Range

</generic-haskell>

>         | KW_Hiding    !Range
> 	  | KW_If        !Range
> 	  | KW_Import    !Range
> 	  | KW_In        !Range
> 	  | KW_Infix     !Range
> 	  | KW_InfixL    !Range
> 	  | KW_InfixR    !Range
> 	  | KW_Instance  !Range
> 	  | KW_Let       !Range
> 	  | KW_Module    !Range
> 	  | KW_NewType   !Range
>         | KW_Of        !Range
>         | KW_Then      !Range
>         | KW_Type      !Range
>         | KW_Where     !Range
>         | KW_Qualified !Range
>         | EOF

<generic-haskell>

>         | KW_Interface !Range
>         | KW_ExportTypes !Range
>         | KW_ExportValues !Range
>         | KW_Abstract  !Range
>         | KW_Binding   !Range
>         | KW_Consig    !Range
>         | KW_InterfaceImport !Range
>         | KW_SetModule !Range
>         | KW_GADependency !Range
>         deriving (Eq,Show)

For error messages.

> errshow :: Token -> String
> errshow (VarId _ _) = "<varid>"
> errshow (QVarId _ _) = "<qvarid>"
> errshow (ConId _ _) = "<conid>"
> errshow (QConId _ _) = "<qconid>"
> errshow (VarSym _ _) = "<varsym>"
> errshow (ConSym _ _) = "<consym>"
> errshow (QVarSym _ _) = "<qvarsym>"
> errshow (QConSym _ _) = "<qconsym>"
> errshow (IntTok _ _) = "<integer literal>"
> errshow (FloatTok _ _) = "<float literal>"
> errshow (Character _ _) = "<character literal>"
> errshow (StringTok _ _) = "<string literal>"
> errshow (LeftParen _) = "'('"
> errshow (RightParen _) = "')'"
> errshow (SemiColon _) = "';'"
> errshow (LeftCurly _) = "'{'"
> errshow (RightCurly _) = "'}'"
> errshow (VRightCurly) = "virtual '}'"
> errshow (LeftSquare _) = "'['"
> errshow (RightSquare _) = "']'"
> errshow (Comma _) = "','"
> errshow (Underscore _) = "'_'"
> errshow (BackQuote _) = "'`'"

<generic-haskell>

> errshow (LeftTyParen _) = "'{|'"
> errshow (RightTyParen _) = "'|}'"
> errshow (LeftKiParen _) = "'{['"
> errshow (RightKiParen _) = "']}'"
> errshow (Dot _) = "'.'"

</generic-haskell>

> errshow (DotDot _) = "'..'"
> errshow (DoubleColon _) = "'::'"
> errshow (Equals _) = "'='"
> errshow (Backslash _) = "'\'"
> errshow (Bar _) = "'|'"
> errshow (LeftArrow _) = "'<-'"
> errshow (RightArrow _) = "'->'"
> errshow (At _) = "'@'"
> errshow (Tilde _) = "'~'"
> errshow (DoubleArrow _) = "'=>'"
> errshow (Minus _) = "'-'"
> errshow (Exclamation _) = "'!'"
> errshow (KW_As _) = "\"as\""
> errshow (KW_Case _) = "\"case\""
> errshow (KW_Class _) = "\"class\""
> errshow (KW_Data _) = "\"data\""
> errshow (KW_Default _) = "\"default\""
> errshow (KW_Dependency _) = "\"dependency\""
> errshow (KW_Deriving _) = "\"deriving\""
> errshow (KW_Do _) = "\"do\""
> errshow (KW_Else _) = "\"else\""
> errshow (KW_Extends _) = "\"extends\""
> errshow (KW_Forall _) = "\"forall\""
> errshow (KW_Hiding _) = "\"hiding\""
> errshow (KW_If _) = "\"if\""
> errshow (KW_Import _) = "\"import\""
> errshow (KW_In _) = "\"in\""
> errshow (KW_Infix _) = "\"infix\""
> errshow (KW_InfixL _) = "\"infixl\""
> errshow (KW_InfixR _) = "\"infixr\""
> errshow (KW_Instance _) = "\"instance\""
> errshow (KW_Let _) = "\"let\""
> errshow (KW_Module _) = "\"module\""
> errshow (KW_NewType _) = "\"newtype\""
> errshow (KW_Of _) = "\"of\""
> errshow (KW_Then _) = "\"then\""
> errshow (KW_Type _) = "\"type\""
> errshow (KW_Where _) = "\"where\""
> errshow (KW_Qualified _) = "\"qualified\""
> errshow (KW_Interface _) = "\"__ghi_interface\""
> errshow (KW_ExportTypes _) = "\"__ghi_export_types\""
> errshow (KW_ExportValues _) = "\"__ghi_export_values\""
> errshow (KW_Abstract _) = "\"__ghi_abstract\""
> errshow (KW_Binding _) = "\"__ghi_binding\""
> errshow (KW_Consig _) = "\"__ghi_consig\""
> errshow (KW_InterfaceImport _) = "\"__ghi_import\""
> errshow (KW_SetModule _) = "\"__ghi_set_module\""
> errshow (KW_GADependency _) = "\"__ghi_dependency\""
> errshow (EOF) = "<end of file>"
> 
> reserved_ops :: [(String, Range -> Token)] -- FM.FiniteMap Char Token
> -- reserved_ops = FM.fromList [
> reserved_ops = [
>  ( "..", DotDot ),    
>  ( "::", DoubleColon ),
>  ( "=",  Equals ),    
>  ( "\\", Backslash ), 
>  ( "|",  Bar ),       
>  ( "<-", LeftArrow ), 
>  ( "->", RightArrow ),
>  ( "@",  At ),        
>  ( "~",  Tilde ),     
>  ( "=>", DoubleArrow )
>  ]

<generic-haskell>
(only the Dot is really specific to GH)

> ext_reserved_ops =
>  ( ".", Dot ) : 
>  ( "-", Minus ) :
>  ( "!", Exclamation ) :
>  reserved_ops

</generic-haskell>

> 
> reserved_ids :: LexMode -> [(String, Range -> Token)] -- FM.FiniteMap Char Token
> -- reserved_ids = FM.fromList [
> reserved_ids mode = case mode of
>   PlainUHA                -> module_id ++ haskell_ids
>   GenericHaskell          -> module_id ++ gh_extra_ids ++ haskell_ids
>   GenericHaskellInterface -> ghi_extra_ids ++ gh_extra_ids ++ haskell_ids
>  where haskell_ids = 
>            [
>             ( "_",         Underscore ),
>             ( "case",      KW_Case ),     
>             ( "class",     KW_Class ),    
>             ( "data",      KW_Data ),     
>             ( "default",   KW_Default ),  
>             ( "deriving",  KW_Deriving ), 
>             ( "do",        KW_Do ),       
>             ( "else",      KW_Else ),     
>             ( "if",    	KW_If ),       
>             ( "import",    KW_Import ),   
>             ( "in", 	KW_In ),       
>             ( "infix", 	KW_Infix ),    
>             ( "infixl", 	KW_InfixL ),   
>             ( "infixr", 	KW_InfixR ),   
>             ( "instance",  KW_Instance ), 
>             ( "let", 	KW_Let ),      
>             ( "newtype",   KW_NewType ),  
>             ( "of", 	KW_Of ),       
>             ( "then", 	KW_Then ),     
>             ( "type", 	KW_Type ),     
>             ( "where", 	KW_Where ),    
>             ( "as", 	KW_As ),       
>             ( "qualified", KW_Qualified ),
>             ( "hiding", 	KW_Hiding )
>            ]
>        module_id =
>            [( "module", 	KW_Module )]
>        gh_extra_ids =
>            [
>             ( "dependency",KW_Dependency ),
>             ( "forall",    KW_Forall ),
>             ( "extends",   KW_Extends )
>            ]
>        ghi_extra_ids =
>            [
>             ( "__ghi_interface", KW_Interface),
>             ( "__ghi_export_types", KW_ExportTypes),
>             ( "__ghi_export_values", KW_ExportValues),
>             ( "__ghi_abstract", KW_Abstract),
>             ( "__ghi_binding", KW_Binding),
>             ( "__ghi_consig", KW_Consig),
>             ( "__ghi_import", KW_InterfaceImport),
>             ( "__ghi_set_module", KW_SetModule),
>             ( "__ghi_dependency", KW_GADependency)
>            ]

> 
> isIdent  c = isAlpha c || isDigit c || c == '\'' || c == '_'
> isSymbol c = elem c ":!#$%&*+./<=>?@\\^|-~"
> isWhite  c = elem c " \n\r\t\v\f"
> 
> data IntKind
>         = Decimal     (String,String)
>         | Octal       (String,String)
>         | Hexadecimal (String,String)
> 
> tAB_LENGTH = 8 :: Int

The source location, (y,x), is the coordinates of the previous token.
col is the current column in the source file.  If col is 0, we are
somewhere at the beginning of the line before the first token.

Setting col to 0 is used in two places: just after emitting a virtual
close brace due to layout, so that next time through we check whether
we also need to emit a semi-colon, and at the beginning of the file,
to kick off the lexer.

> get :: Lex Token
> get =  Lex lexer
> 
> lexer :: (Token -> P a) -> P a
> lexer cont input mode (Position_Position f y x) col =
>          if col == 0
>             then tab y x True  input
>             else tab y col False input -- throw away old x
>   where
>    	-- move past whitespace and comments
>         tab y x bol [] = 
>         	cont EOF [] mode (Position_Position f y x) col
>         tab y x bol ('\t':s) =
>         	tab y (nextTab x) bol s
>         tab y x bol ('\n':s) =
>                 newLine cont s y
>         tab y x bol ('-':'-':s) = 
>         	newLine cont (drop 1 (dropWhile (/= '\n') s)) y
>         tab y x bol ('{':'-':s) = nestedComment tab y x bol s
>         tab y x bol (c:s)
>         	| isWhite c = tab y (x+1) bol s
>         	| otherwise = 
>         		if bol 	then lexBOL   cont (c:s) mode (Position_Position f y x) x
>         			else lexToken cont (c:s) mode (Position_Position f y x) x
> 
> 	  newLine cont s y =  tab (y+1) 1 True s
> 
> nextTab x = x + (tAB_LENGTH - (x-1) `mod` tAB_LENGTH)

When we are lexing the first token of a line, check whether we need to
insert virtual semicolons or close braces due to layout.

> lexBOL :: (Token -> P a) -> P a
> lexBOL cont s mode loc x context =
>         if need_close_curly then 
>               -- trace ("layout: inserting '}' at " ++ show loc ++ "\ncontext: " ++ show context ++ "\n") $
>         	-- Set col to 0, indicating that we're still at the
>         	-- beginning of the line, in case we need a semi-colon too.
>         	-- Also pop the context here, so that we don't insert
>         	-- another close brace before the parser can pop it.
>         	cont (VRightCurly) s mode loc 0 (tail context)
>         else if need_semi_colon then
>               -- trace ("layout: inserting ';' at " ++ show loc ++ "\ncontext: " ++ show context ++ "\n") $
>         	cont (SemiColon (Range_Range loc loc)) s mode loc x context
>         else
>         	lexToken cont s mode loc x context
>  where
>         need_close_curly =
>         	case context of
>         		[] -> False
>         		(i:_) -> case i of
>         			    NoLayout -> False
>         			    Layout n -> x < n
>         need_semi_colon =
>         	case context of
>         		[] -> False
>         		(i:_) -> case i of
>         			    NoLayout -> False
>         			    Layout n -> x == n
> 
> lexToken :: (Token -> P a) -> P a

added indirection to deal with two-character tokens {[, ]}, {|, |}

> lexToken cont (c:[])  mode loc x = lexToken' cont c mode (Nothing) [] loc x
> lexToken cont (c:d:s) mode loc x = lexToken' cont c mode (Just d)  s  loc x
> lexToken _ _ _ _ _ = error "Internal error: empty input in lexToken"
> 
> lexToken' cont c mode d r loc@(Position_Position f y x') x =
>    -- trace ("lexer: y="++show y++" x="++show x++"\n") $ 
>    case (c,d) of
>         -- First the special symbols
>         ('(',_) -> special LeftParen
>         (')',_) -> special RightParen
>         (',',_) -> special Comma
>         (';',_) -> special SemiColon
>         ('[',_) -> special LeftSquare
>         ('|',Just '}') | mode /= PlainUHA -> special2 RightTyParen
>         (']',Just '}') | mode /= PlainUHA -> special2 RightKiParen
>         (']',_) -> special RightSquare
>         ('`',_) -> special BackQuote
>         ('{',Just '|') | mode /= PlainUHA -> special2 LeftTyParen
>         ('{',Just '[') | mode /= PlainUHA -> special2 LeftKiParen
>         ('{',_) -> \stk -> special LeftCurly (NoLayout : stk)
>         ('}',_) -> \stk -> case stk of
>                         (_:ctxt) -> special RightCurly ctxt -- pop context on '}'
>                         []       -> special RightCurly (error "Internal error: empty context in lexToken")
> 
>         ('\'',_) -> lexChar cont s mode loc (x+1)
>         ('\"'{-"-},_) -> lexString cont s mode loc (x+1)
> 
>         (c,_) | isLower c || c == '_' ->
>         	let 
>         	    (idtail, rest) = span isIdent s
>         	    id = c:idtail
>         	    l_id = 1 + length idtail
>         	in
>         	case lookup id (reserved_ids_for_mode) of
>         		Just keyword -> forward l_id keyword rest
>         		Nothing -> forward l_id (VarId id) rest
> 
>           | isUpper c ->
>               lexConIdOrQual [] cont (c:s) mode loc x
> 
>           | isSymbol c ->
>         	let
>         	    (symtail, rest) = span isSymbol s
>         	    sym = c : symtail
>         	    l_sym = 1 + length symtail
>         	in

<generic-haskell>
(was: reserved_ops)

>         	case lookup sym ext_reserved_ops of

</generic-haskell>

>         	    Just t  -> forward l_sym t rest
>         	    Nothing -> case c of
>         			':' -> forward l_sym (ConSym sym) rest
>         			_   -> forward l_sym (VarSym sym) rest
> 
>           | isDigit c ->
>         	case lexInt (c:s) of
>         	    Decimal     (n,rest) ->
>         		case rest of
>         		    ('.':c2:rest2) | isDigit c2 ->
>         			case lexFloatRest (c2:rest2) of
>                                   Nothing -> \ stk -> fail "Illegal float"
>                                   Just (n2,rest3) -> let f = n ++ ('.':n2)
>         			                       in forward (length f) (FloatTok f) rest3
>                     	    _ -> forward (length n) (IntTok n) rest
>         	    Octal       (n,rest) -> forward (length n) (IntTok n) rest
>         	    Hexadecimal (n,rest) -> forward (length n) (IntTok n) rest
> 
>           | otherwise ->
>         	\ stk -> fail ("illegal character \'" ++ show c ++ "\'\n")
> 
>  where s = maybeToList d ++ r            {- added (ks) -}
>        special t = forward 1 t s
>        special2 t = cont (t $ rangeX 2 loc) r mode loc (x+2)   {- added (ks) -}
>        forward n t s = cont (t $ rangeX n loc) s mode loc (x+n)
>        rangeX n p@(Position_Position f l c) = Range_Range p (Position_Position f l (c+n))
>        reserved_ids_for_mode = reserved_ids mode
> 
>        lexFloatRest r = case span isDigit r of
>         		      (r2, 'e':r3) -> lexFloatExp (r2 ++ "e") r3
>         		      (r2, 'E':r3) -> lexFloatExp (r2 ++ "e") r3
>         		      f@(r2,   r3) -> Just f
> 
>        lexFloatExp r1 ('-':r2) = lexFloatExp2 (r1 ++ "-") r2
>        lexFloatExp r1 ('+':r2) = lexFloatExp2 (r1 ++ "+") r2
>        lexFloatExp r1      r2  = lexFloatExp2 r1          r2
> 
>        lexFloatExp2 r1 r2 = case span isDigit r2 of
>                                 ("", _ ) -> Nothing
>                                 (ds, r3) -> Just (r1++ds,r3)
> 			      
> lexInt ('0':o:d:r) | toLower o == 'o' && isOctDigit d = let (ds,rs)= span isOctDigit r in Octal       ('0':'o':d:ds,rs)
> lexInt ('0':x:d:r) | toLower x == 'x' && isHexDigit d = let (ds,rs)= span isHexDigit r in Hexadecimal ('0':'x':d:ds,rs)
> lexInt r					        = Decimal (span isDigit r)
>
> lexConIdOrQual :: [String] -> (Token -> P a) -> P a
> lexConIdOrQual qual cont s mode loc x =
>         	let
>                   (con,rest) = span isIdent s
>                   conid | null qual = ConId con
>                         | otherwise = QConId (qual,con)
>                   qual'             = qual ++ [con]
>         	    l_con = length con
>         	in
>         	case rest of
>         	    '.':c1:s1 
>         	     | isLower c1 || c1 == '_' ->  -- qualified varid?
>         		let
>         		    (idtail, rest1) = span isIdent s1
>         		    id = c1:idtail
>         		    l_id = 1 + length idtail
>         		in
>         		case lookup id (reserved_ids_for_mode) of
>         		   -- cannot qualify a reserved word
>         		   Just keyword ->
>         			forward l_con conid rest
>         		   Nothing ->
>         			forward (l_con+l_id+1) (QVarId (qual', id))
>         				rest1
> 
>         	     | isUpper c1 ->	-- qualified conid?
>                       lexConIdOrQual qual' cont (c1:s1) mode loc (x+1)
> 
>         	     | isSymbol c1 ->	-- qualified symbol?
>         		let
>         		    (symtail, rest1) = span isSymbol s1
>         		    sym = c1 : symtail
>         		    l_sym = 1 + length symtail
>         		in
>         		case lookup sym reserved_ops of
>         		    -- cannot qualify a reserved operator
>         		    Just _  -> 
>         			forward l_con conid rest
>         		    Nothing -> case c1 of
>         				':' -> forward (l_con+l_sym+1) 
>         					(QConSym (qual', sym)) rest1
>         				_   -> forward (l_con+l_sym+1)
>         					(QVarSym (qual', sym)) rest1
> 
>         	    _ -> -- not a qualified object
>         		forward l_con conid rest
>    where
>        forward n t s = cont (t $ rangeX n loc) s mode loc (x+n)
>        rangeX n p@(Position_Position f l c) = Range_Range p (Position_Position f l (c+n))
>        reserved_ids_for_mode = reserved_ids mode
> 
> lexChar :: (Token -> P a) -> P a
> lexChar cont s mode loc x stk = case s of
>                     '\\':s -> escapeChar s >>= \(e, s', i) ->
>                               charEnd e s' loc (x + i) stk
>                     c:s    -> charEnd c s  loc (x + 1) stk
>                     []     -> error "Internal error: lexChar"
> 
>   where charEnd c ('\'':s) loc@(Position_Position f y _) x 
>                                  = cont (Character c (Range_Range loc (Position_Position f y (x+1)))) s mode loc (x+1)
>         charEnd c s        loc x = \ stk -> fail "Improperly terminated character constant"
> 
> lexString :: (Token -> P a) -> P a
> lexString cont s mode loc@(Position_Position f y _) x = loop "" s x y
>   where
>      loop e s x y = case s of
>             '\\':'&':s  -> loop e s (x+2) y
>             '\\':c:s | isSpace c -> stringGap e s (x+2) y
>                      | otherwise -> \ stk -> escapeChar (c : s) >>= \(e', s', i) ->
>                                              loop (e':e) s' (x + i) y stk
>             '\"':s{-"-} -> cont (StringTok (reverse e) (Range_Range loc (Position_Position f y (x+1)))) s mode loc (x+1)
>             c:s               -> loop (c:e) s (x+1) y
>             []          -> \ stk -> fail "Improperly terminated string"
> 
>      stringGap e s x y = case s of
>         	'\n':s -> stringGap e s 1 (y+1)
>         	'\\':s -> loop e s (x+1) y
>         	c:s' | isSpace c -> stringGap e s' (x+1) y
>         	     | otherwise -> 
>         	       \ stk -> fail "Illegal character in string gap"
>               []     -> error "Internal error: stringGap"

ToDo: \o, \x, \<octal> things.

> escapeChar :: String -> Result (Char, String, Int)
> escapeChar s = case s of

Production charesc from section B.2 (Note: \& is handled by caller)

>   'a':s 	  -> return ('\a',s,2)
>   'b':s 	  -> return ('\b',s,2)
>   'f':s 	  -> return ('\f',s,2)
>   'n':s 	  -> return ('\n',s,2)
>   'r':s 	  -> return ('\r',s,2)
>   't':s 	  -> return ('\t',s,2)
>   'v':s 	  -> return ('\v',s,2)
>   '\\':s        -> return ('\\',s,2)
>   '"':s         -> return ('\"',s,2)
>   '\'':s        -> return ('\'',s,2)

Production ascii from section B.2

>   '^':x@(c:s)   -> cntrl x
>   'N':'U':'L':s -> return ('\NUL',s,4)
>   'S':'O':'H':s -> return ('\SOH',s,4)
>   'S':'T':'X':s -> return ('\STX',s,4)
>   'E':'T':'X':s -> return ('\ETX',s,4)
>   'E':'O':'T':s -> return ('\EOT',s,4)
>   'E':'N':'Q':s -> return ('\ENQ',s,4)
>   'A':'C':'K':s -> return ('\ACK',s,4)
>   'B':'E':'L':s -> return ('\BEL',s,4)
>   'B':'S':s     -> return ('\BS', s,3)
>   'H':'T':s  	  -> return ('\HT', s,3)
>   'L':'F':s 	  -> return ('\LF', s,3)
>   'V':'T':s 	  -> return ('\VT', s,3)
>   'F':'F':s 	  -> return ('\FF', s,3)
>   'C':'R':s 	  -> return ('\CR', s,3)
>   'S':'O':s 	  -> return ('\SO', s,3)
>   'S':'I':s 	  -> return ('\SI', s,3)
>   'D':'L':'E':s -> return ('\DLE',s,4)
>   'D':'C':'1':s -> return ('\DC1',s,4)
>   'D':'C':'2':s -> return ('\DC2',s,4)
>   'D':'C':'3':s -> return ('\DC3',s,4)
>   'D':'C':'4':s -> return ('\DC4',s,4)
>   'N':'A':'K':s -> return ('\NAK',s,4)
>   'S':'Y':'N':s -> return ('\SYN',s,4)
>   'E':'T':'B':s -> return ('\ETB',s,4)
>   'C':'A':'N':s -> return ('\CAN',s,4)
>   'E':'M':s     -> return ('\EM', s,3)
>   'S':'U':'B':s -> return ('\SUB',s,4)
>   'E':'S':'C':s -> return ('\ESC',s,4)
>   'F':'S':s     -> return ('\FS', s,3)
>   'G':'S':s     -> return ('\GS', s,3)
>   'R':'S':s     -> return ('\RS', s,3)
>   'U':'S':s     -> return ('\US', s,3)
>   'S':'P':s     -> return ('\SP', s,3)
>   'D':'E':'L':s -> return ('\DEL',s,4)

Escaped numbers are missing here..

>   _             -> fail "Illegal escape sequence"

Production cntrl from section B.2

> cntrl :: String -> Result (Char, String, Int)
> cntrl (c   :s) | isUpper c = return (chr (ord c - ord 'A'), s,2)
> cntrl ('@' :s)             = return ('\^@', s,2)
> cntrl ('[' :s)             = return ('\^[', s,2)
> cntrl ('\\':s)             = return ('\^\', s,2)
> cntrl (']' :s)             = return ('\^]', s,2)
> cntrl ('^' :s)             = return ('\^^', s,2)
> cntrl ('_' :s)             = return ('\^_', s,2)
> cntrl _                    = fail "Illegal control character"
> 
> nestedComment cont y x bol s =
>    case s of
>       '-':'}':s -> cont y (x+2) bol s
>       '{':'-':s -> nestedComment (nestedComment cont) y (x+2) bol s
>       '\t':s    -> nestedComment cont y (nextTab x) bol s
>       '\n':s    -> nestedComment cont (y+1) 1 True s
>       c:s       -> nestedComment cont y (x+1) bol s
>       []        -> error "Internal error: nestedComment"
