
SOURCEFILES    += UHA_Parser.lg

RELPATH   := ./src/uha
RELSOURCE := $(topdir)/$(RELPATH)

ALL_HS_TARGETS := $(ALL_HS_TARGETS) $(RELPATH)/UHA_Parser.hs

# the parser really benefits from optimizing
$(RELPATH)/UHA_Parser_GHCFLAGS := $(GHCFLAGS) -O

NOAUTO := $(NOAUTO) $(RELPATH)/AbstractSyntax.lag
ifdef AGC
$(RELPATH)/AbstractSyntax.pre.hs : $(RELSOURCE)/AbstractSyntax.lag $(RELSOURCE)/AbstractSyntax.inc.ag
	$(call debug,"[pag] $(patsubst $(topdir)/%,%,$<)")
	cd $(<D) && $(AGC) -mdr --modcopy --output=$(BUILDDIR)/$@ $(<F)

endif

ifdef DRIFT

$(RELPATH)/AbstractSyntax.hs : $(RELPATH)/AbstractSyntax.pre.hs
	$(call debug,"[dri] $(patsubst $(topdir)/%,%,$<)")
	$(DRIFT) -g ATermConvertible -o $@ $< +RTS -H7M -RTS

else

$(RELPATH)/AbstractSyntax.hs :
	@echo "*** You need DrIFT to regenerate AbstractSyntax.hs correctly."
	@exit 1

endif

ifdef FROWN

FROWNMODE := -cstackless
#FROWNMODE := -cstackless -i -v

ifeq ($(DISTTYPE),win32)
# -cstackless is too much for Windows ...
FROWNMODE := -ccompact
endif

$(RELPATH)/UHA_Parser.hs : $(RELSOURCE)/UHA_Parser.lg
	${call debug,"[:-(] ${patsubst ${topdir}/%,%,$<}"}
	-$(RM_F) $(@:.lg=.hs)*
	$(LN_SF) $< $(@D)
	$(FROWN) -l -o -p120 $(FROWNMODE) --expected $(@:.hs=.lg)

endif
