module XConNames
    (XConNames.add
    ,XConNames.addCon
    ,XConNames.ghc_collectConNames__GHK_ABS
    ,XConNames.ghc_collectConNamesStr__GHK_ABS
    ,XConNames.ghc_collectConNamesTot__GHK_ABS
    ,XConNames.ghc_conNames__Prelude_String
    ,XConNames.ghc_conNames__GH_Prelude_Label
    ,XConNames.ghc_conNames__GH_Prelude_Con
    ,XConNames.ghc_conNames__GH_Prelude_Prod
    ,XConNames.ghc_conNames__GH_Prelude_Sum
    ,XConNames.ghc_conNames__GH_Prelude_Unit
    ,XConNames.max_depth
    ) where

import List 
import Maybe 
import Monad 
import Prelude 
import GH.Prelude 
import qualified Prelude 
import qualified Monad 
import qualified Maybe 
import qualified List 
import qualified GH.Prelude 
max_depth = 2 :: Int


-- cp(conNames,Unit)      component of conNames for Unit
ghc_conNames__GH_Prelude_Unit
    :: Int
         -> String
              -> ([(String,[String])],[String])
                   -> ([(String,[String])],[String])
ghc_conNames__GH_Prelude_Unit d cc css@(cs,ss) = css
-- cp(conNames,GH.Prelude.Sum)      component of conNames for GH.Prelude.Sum
ghc_conNames__GH_Prelude_Sum
    :: (Int
          -> String
               -> ([(String,[String])],[String])
                    -> ([(String,[String])],[String]))
         -> (Int
               -> String
                    -> ([(String,[String])],[String])
                         -> ([(String,[String])],[String]))
              -> Int
                   -> String
                        -> ([(String,[String])],[String])
                             -> ([(String,[String])],[String])
ghc_conNames__GH_Prelude_Sum csA csB d cc css@(cs,ss) = csA d cc (csB d
                                                                    cc css)
-- cp(conNames,GH.Prelude.Prod)      component of conNames for GH.Prelude.Prod
ghc_conNames__GH_Prelude_Prod
    :: (Int
          -> String
               -> ([(String,[String])],[String])
                    -> ([(String,[String])],[String]))
         -> (Int
               -> String
                    -> ([(String,[String])],[String])
                         -> ([(String,[String])],[String]))
              -> Int
                   -> String
                        -> ([(String,[String])],[String])
                             -> ([(String,[String])],[String])
ghc_conNames__GH_Prelude_Prod csA csB d cc css@(cs,ss) = csA d cc (csB d
                                                                     cc css)
-- cp(conNames,GH.Prelude.Con)      component of conNames for GH.Prelude.Con
ghc_conNames__GH_Prelude_Con
    :: ConDescr
         -> (Int
               -> String
                    -> ([(String,[String])],[String])
                         -> ([(String,[String])],[String]))
              -> Int
                   -> String
                        -> ([(String,[String])],[String])
                             -> ([(String,[String])],[String])
ghc_conNames__GH_Prelude_Con c csA d cc css@(cs,ss) = maybe res (\ cs'
                                                                   -> csA
                                                                        max_depth
                                                                        name
                                                                        (cs'
                                                                        ,ss
                                                                        ))
                                                        (addCon (conType c,name)
                                                           cs)
  where
    { res = if d > 0 then csA (d - 1) name css else css; name = conName c
    }
-- cp(conNames,GH.Prelude.Label)      component of conNames for GH.Prelude.Label
ghc_conNames__GH_Prelude_Label
    :: LabelDescr
         -> (Int
               -> String
                    -> ([(String,[String])],[String])
                         -> ([(String,[String])],[String]))
              -> Int
                   -> String
                        -> ([(String,[String])],[String])
                             -> ([(String,[String])],[String])
ghc_conNames__GH_Prelude_Label l csA d cc css@(cs,ss) = csA d cc css
-- cp(conNames,String)      component of conNames for String
ghc_conNames__Prelude_String
    :: Int
         -> String
              -> ([(String,[String])],[String])
                   -> ([(String,[String])],[String])
ghc_conNames__Prelude_String d cc css@(cs,ss) = (cs
                                                ,maybe ss id (cc `add` ss)
                                                )
addCon (t,n) [] = Just [(t,[n])]
addCon (t,n) ((t',ns) : cs) | t == t' = (n `add` ns) >>= \ ns' -> return
                                                                    ((t',ns')
                                                                       : cs)
  | otherwise = (addCon (t,n) cs) >>= \ cs' -> return ((t',ns) : cs')
add n [] = Just [n]
add n (x : xs) | n == x = Nothing
  | otherwise = (n `add` xs) >>= \ xs' -> return (x : xs')

-- cp(collectConNamesTot,t)      component of collectConNamesTot for t
ghc_collectConNamesTot__GHK_ABS
    :: (Int
          -> String
               -> ([(String,[String])],[String])
                    -> ([(String,[String])],[String]))
         -> ([(String,[String])],[String])
ghc_collectConNamesTot__GHK_ABS ghs_XConNames_conNames__t
  = ghs_XConNames_conNames__t max_depth "" ([],[])

-- cp(collectConNames,t)      component of collectConNames for t
ghc_collectConNames__GHK_ABS
    :: (Int
          -> String
               -> ([(String,[String])],[String])
                    -> ([(String,[String])],[String]))
         -> [(String,[String])]
ghc_collectConNames__GHK_ABS ghs_XConNames_conNames__t = fst
                                                           (XConNames.ghc_collectConNamesTot__GHK_ABS
                                                              ghs_XConNames_conNames__t)

-- cp(collectConNamesStr,t)      component of collectConNamesStr for t
ghc_collectConNamesStr__GHK_ABS
    :: (Int
          -> String
               -> ([(String,[String])],[String])
                    -> ([(String,[String])],[String]))
         -> [String]
ghc_collectConNamesStr__GHK_ABS ghs_XConNames_conNames__t = snd
                                                              (XConNames.ghc_collectConNamesTot__GHK_ABS
                                                                 ghs_XConNames_conNames__t)
--  
-- ***
-- normal/MPC specialisations
-- ***
--  
ghs_GH_Prelude_bimap__GH_Prelude_EP
    :: GH.Prelude.EP a1 a2
         -> GH.Prelude.EP a3 a4
              -> GH.Prelude.EP (GH.Prelude.EP a1 a3) (GH.Prelude.EP a2 a4)
ghs_GH_Prelude_bimap__GH_Prelude_EP gh_a gh_b
  = GH.Prelude.ghc_bimap__GH_Prelude_EP gh_a gh_b
ghs_GH_Prelude_bimap__GHX_mngt
    :: GH.Prelude.EP a1 a2
         -> GH.Prelude.EP a3 a4 -> GH.Prelude.EP ((->) a1 a3) ((->) a2 a4)
ghs_GH_Prelude_bimap__GHX_mngt gh_a gh_b
  = GH.Prelude.ghc_bimap__GHX_mngt gh_a gh_b
ghs_GH_Prelude_bimap__Prelude_String :: GH.Prelude.EP String String
ghs_GH_Prelude_bimap__Prelude_String 
  = GH.Prelude.ghc_bimap__Prelude_String 
ghs_GH_Prelude_bimap__GHX_pocmpc
    :: GH.Prelude.EP a1 a2
         -> GH.Prelude.EP a3 a4 -> GH.Prelude.EP ((,) a1 a3) ((,) a2 a4)
ghs_GH_Prelude_bimap__GHX_pocmpc gh_a gh_b
  = GH.Prelude.ghc_bimap__GHX_pocmpc gh_a gh_b
ghs_GH_Prelude_bimap__GHX_bobc
    :: GH.Prelude.EP a1 a2 -> GH.Prelude.EP ([] a1) ([] a2)
ghs_GH_Prelude_bimap__GHX_bobc gh_a = GH.Prelude.ghc_bimap__GHX_bobc
                                        gh_a
ghs_XConNames_conNames__Prelude_String
    :: Int
         -> String
              -> ([(String,[String])],[String])
                   -> ([(String,[String])],[String])
ghs_XConNames_conNames__Prelude_String gh_a gh_b gh_c
  = XConNames.ghc_conNames__Prelude_String gh_a gh_b gh_c
ghs_XConNames_conNames__GH_Prelude_Label
    :: LabelDescr
         -> (Int
               -> String
                    -> ([(String,[String])],[String])
                         -> ([(String,[String])],[String]))
              -> Int
                   -> String
                        -> ([(String,[String])],[String])
                             -> ([(String,[String])],[String])
ghs_XConNames_conNames__GH_Prelude_Label gh_a gh_b gh_c gh_d gh_e
  = XConNames.ghc_conNames__GH_Prelude_Label gh_a gh_b gh_c gh_d gh_e
ghs_XConNames_conNames__GH_Prelude_Con
    :: ConDescr
         -> (Int
               -> String
                    -> ([(String,[String])],[String])
                         -> ([(String,[String])],[String]))
              -> Int
                   -> String
                        -> ([(String,[String])],[String])
                             -> ([(String,[String])],[String])
ghs_XConNames_conNames__GH_Prelude_Con gh_a gh_b gh_c gh_d gh_e
  = XConNames.ghc_conNames__GH_Prelude_Con gh_a gh_b gh_c gh_d gh_e
ghs_XConNames_conNames__GH_Prelude_Prod
    :: (Int
          -> String
               -> ([(String,[String])],[String])
                    -> ([(String,[String])],[String]))
         -> (Int
               -> String
                    -> ([(String,[String])],[String])
                         -> ([(String,[String])],[String]))
              -> Int
                   -> String
                        -> ([(String,[String])],[String])
                             -> ([(String,[String])],[String])
ghs_XConNames_conNames__GH_Prelude_Prod gh_a gh_b gh_c gh_d gh_e
  = XConNames.ghc_conNames__GH_Prelude_Prod gh_a gh_b gh_c gh_d gh_e
ghs_XConNames_conNames__GH_Prelude_Sum
    :: (Int
          -> String
               -> ([(String,[String])],[String])
                    -> ([(String,[String])],[String]))
         -> (Int
               -> String
                    -> ([(String,[String])],[String])
                         -> ([(String,[String])],[String]))
              -> Int
                   -> String
                        -> ([(String,[String])],[String])
                             -> ([(String,[String])],[String])
ghs_XConNames_conNames__GH_Prelude_Sum gh_a gh_b gh_c gh_d gh_e
  = XConNames.ghc_conNames__GH_Prelude_Sum gh_a gh_b gh_c gh_d gh_e
ghs_XConNames_conNames__GH_Prelude_Unit
    :: Int
         -> String
              -> ([(String,[String])],[String])
                   -> ([(String,[String])],[String])
ghs_XConNames_conNames__GH_Prelude_Unit gh_a gh_b gh_c
  = XConNames.ghc_conNames__GH_Prelude_Unit gh_a gh_b gh_c
ghs_GH_Prelude_bimap__Prelude_Int :: GH.Prelude.EP Int Int
ghs_GH_Prelude_bimap__Prelude_Int  = GH.Prelude.ghc_bimap__GHK_S 
--  
-- ***
-- type-indexed type specialisations
-- ***
--  