-- do not edit; automatically generated by UU.AG
module GH where


import Configure
import AbstractSyntax
import UHA_Range
import BuildSyntax


import Maybe

import Utils
import ErrorUtils
-- import ImportUtils
import FMap
import qualified Pretty as PP
import qualified PPrint as PP
import Name
-- import qualified PrettyPrint as PP
import ErrorMessages
import qualified List
import qualified Set
import Set (Set)
import qualified Maybe


import qualified StructureTypes as ST



import Types

import qualified TypeIndexedTypes as TIT



import qualified ExprReplace as ER



import qualified ScanDependencies as SD


import RequestUtils


import qualified Specialise as SPEC
{-
import qualified Optimizer
import OptimizerUtils
-}



import KindUtils (isRestricted)
import qualified List
import Monad (msum)


import Maybe(isJust)

import KindUtils
import List (nubBy)
-- import IOExts

import Types


import Maybe (isNothing)



import ComponentUtils



import Maybe (isJust)


import qualified Pretty as PP
import FMap
import KindUtils
import RequestUtils


mkKindComment                    :: Name -> Kind -> PP.Doc
mkKindComment name kind          = PP.ppComment $ concat $
                                      [PP.unPretty $ PP.ppName name
                                      ," :: "
                                      ,PP.unPretty $ PP.ppKind kind
                                      ]

mkStrTypeComment                 :: Name -> PP.Doc
mkStrTypeComment name            = PP.ppComment $ concat $
                                      ["structure type for "
                                      ,PP.unPretty $ PP.ppName name
                                      ]

mkEPComment                      :: Name -> PP.Doc
mkEPComment name                 = PP.ppComment $ concat $
                                      ["embedding-projection pair for "
                                      ,PP.unPretty $ PP.ppName name
                                      ]

mkDescrComment                   :: Name -> PP.Doc
mkDescrComment name              = PP.ppComment $ concat $
                                      ["constructor/label descriptors for "
                                      ,PP.unPretty $ PP.ppName name
                                      ]

mkComponentComment                 ::  Name -> Maybe TypeArgument -> PP.Doc
mkComponentComment name Nothing    =   PP.ppComment $ 
                                         "default case redirections"
mkComponentComment name (Just tp)  =   PP.ppComment $ concat $
                                         ["cp(",pname,",",ptp,")      "
                                         ,"component of ",pname," for ",ptp
                                         ]
  where pname  =  PP.unPretty $ PP.ppName name
        ptp    =  PP.unPretty $ PP.ppType $ typeArgumentToType tp



computeExportValues              :: FMap Name Kind     -- generic abstractions
                                 -> Signatures
                                 -> FMap Name Names    -- methods
                                 -> FMap Name Names    -- constructors
                                 -> FMap Name Names    -- labels
                                 -> Set Name           -- exported types
                                 -> Set Name           -- exported values
                                 -> [Export]
computeExportValues genericAbstractions signatures methods constructors labels
                    exportedTypes exportedValues =
    concatMap computeExportValue (Set.setToList exportedValues)
  where
    converseMethods              =  fromList
                                 $  concatMap (\(c,ms) ->
                                                   [(m,c) | m <- ms]
                                              )
                                 $  toList methods
    converseConstructorsLabels   =  fromList
                                 $  concatMap (\(t,cs) ->
                                                   [(c,t) | c <- cs]
                                              )
                                 $  (toList constructors ++ toList labels)
    computeExportValue value
      | isJust (find genericAbstractions value)
                                 =  [ varX (componentName value absName) ]
      | not (null signatureForValue)
                                 =  [ varX (componentName value tp)
                                    | tp <- signatureForValue
                                    ] 
      | maybe
          False
          (\x -> Set.elementOf x exportedTypes)
          (find converseMethods value)
                                 =  []
      | maybe
          False
          (\x -> Set.elementOf x exportedTypes)
          (find converseConstructorsLabels value)
                                 =  []
      | otherwise                =  [varX value]
            {- we treat constructors as variables here, shouldn't matter -}
      where
        signatureForValue = map typeArgumentName (findL signatures value)



computeExportTypes               :: Signatures
                                 -> FMap Name KindIndexedType
                                 -> FMap Name Names    -- methods
                                 -> FMap Name Names    -- constructors
                                 -> FMap Name Names    -- labels
                                 -> Set Name           -- exported types
                                 -> Set Name           -- exported values
                                 -> Set Name           -- abstract types
                                 -> [Export]
computeExportTypes signatures kindIndexedTypes methods constructors labels
                   exportedTypes exportedValues abstractTypes =
    concatMap computeExportType (Set.setToList exportedTypes)
  where
    domainKindIndexedTypes       =  domain kindIndexedTypes
    domainMethods                =  domain methods
    computeExportType tp
      | elem tp (domainKindIndexedTypes)
                                 =  []
      | not (null signatureForType)
                                 =  [ tyccompleteX (componentTITName tp ct)
                                    | ct <- signatureForType
                                    ]
      | elem tp (domainMethods)  =  [ tycX 
                                        tp
                                        (MaybeNames_Just
                                           [ m  |  m <- applyFM' methods tp
                                                ,  Set.elementOf
                                                     m exportedValues
                                           ]
                                        )
                                    ]
      | length conlabelsForType == length exportedConLabels
          && not (Set.elementOf tp abstractTypes)        
                                 =  [ if null exportedConLabels then
                                        tycX tp MaybeNames_Nothing
                                      else
                                        tyccompleteX tp
                                    , tycX (strName tp) MaybeNames_Nothing
                                    , varX (epName tp)
                                    ] ++ concat
                                      [ [ tycX 
                                            (concaseName c)
                                            MaybeNames_Nothing
                                        , tycX
                                            (strName (concaseName c))
                                            MaybeNames_Nothing
                                        , varX (epName (concaseName c))
                                        , varX (cdName c)
                                        ]
                                      | c <- exportedConLabels
                                      , isCon c -- not for labels
                                      ]
      -- the following line is for hugs compatibility
      -- hugs does not accept type synonyms with ()
      | Set.elementOf tp abstractTypes
                                 =  [ tycX tp MaybeNames_Nothing ]
      | otherwise                =  [ tycX  tp 
                                            (MaybeNames_Just exportedConLabels)
                                    ]
      where
        signatureForType         =  map typeArgumentName (findL signatures tp)
        conlabelsForType         =  findL constructors tp ++ findL labels tp
        exportedConLabels        =  [ c
                                    | c <- conlabelsForType
                                    , Set.elementOf
                                        c exportedValues
                                    ]



-- move to @TypeReplace@ or somewhere else?

deriveKITContext :: Type -> [Name] -> [ContextItem]
deriveKITContext (Type_Qualified _ ct _)  psn  =  concatMap stripContextItem ct
  where  stripContextItem c@(ContextItem_ContextItem _ _ _)
           | Set.isEmptySet (Set.minusSet (freeVarsCtx c) (Set.mkSet psn)) = [c]
         stripContextItem _                                                = []
deriveKITContext t                        _    = []



differentEither                  :: [Either a b] -> Bool
differentEither [Left _,Right _] =  True
differentEither [Right _,Left _] =  True
differentEither _                =  False



type PreSignatures  =  FMap Name PreSignature
type Signatures     =  FMap Name Signature
type PreSignature   =  (Signature,(Maybe Name))
type Signature      =  [TypeArgument]



expandSignatures :: PreSignatures -> Signatures -> Signatures
expandSignatures pss ss = mapFM expandSignature pss
  where
  expandSignature :: PreSignature -> Signature
  expandSignature (stps,  Nothing  )  =  stps
  expandSignature (stps,  Just n   )  = 
    let  stps' = applyOrSignatureError ss n "Signature.expandSignature: no signature"
    in   {- trace (" unifying: " ++ show stps ++ "\n and: " ++ show stps') $ -}
         stps `List.union` stps'



simplifyTypeArgument :: TypeArgument -> TypeArgument
simplifyTypeArgument (TypeArgument_DependencyStyle _ n (MaybeName_Just d) _)
  | n == conName    =  TypeArgument_Constructor  unknownRange d
  | n == labelName  =  TypeArgument_Label        unknownRange d
  | otherwise =
     internalError $
       "Signature.simplifyTypeArgument: illegal type argument with descriptor"
simplifyTypeArgument (TypeArgument_DependencyStyle _ n _ _) 
  = TypeArgument_NamedType unknownRange n
simplifyTypeArgument x = x



isGASignature :: Signatures -> Name -> Bool
isGASignature sigs n = 
    case sig of
      [TypeArgument_Variable _ _]  ->  True
      _                            ->  False
  where  sig = applyFMM sigs err n
         err = internalError $
                 "ScanDependencies.isGASignature: no signature for " ++
                 PP.unPretty (PP.ppName n)



dependenciesTofunImps :: FMap Name [(Name,Name)] -> [Request_FunImply]
dependenciesTofunImps deps = 
  [ Request_FunImply (n,map turnIntoRawRequest dnames)
  | (n,ndeps) <- toList deps,
    let dnames = map fst ndeps ]

turnIntoRawRequest n = (var,RawRequest (n,Types.varT var))
  where var = head varNames {- locally fresh name -}



extractStructureTypes            :: [Declaration] -> [(Name,LambdaType)]
extractStructureTypes            =  concatMap extract
  where
    extract (Declaration_Type _ 
               (SimpleType_SimpleType _ n annotvars)
               tp
            ) = let vars = map (\(KindAnnotatedName_KindAnnotatedName _ n _) -> n)
                               annotvars
                in  [(n,makeLambdaType vars tp)]
    extract _ = []



kindIndexedTypeMissingError      :: Name -> a
kindIndexedTypeMissingError v    =
  unstaticError $
    "KindIndexedType.TypeIndexedValue: "
      ++ "Generic function " ++ PP.unPretty (PP.ppName v) 
      ++ " has no type signature."



applyOrSignatureError sigs name errmsg =
  applyFMM sigs
    (const $ internalError $
       errmsg ++ " " ++
       (PP.unPretty $ PP.ppName name)
{-
       "\navailable names:\n" ++
       (PP.unPretty $ 
          PP.prettyFM PP.ppName (PP.hsep . map (PP.ppType . typeArgumentToType))
            sigs)
-}
    )
    name

doubleDefaultCaseError           ::  Name -> a
doubleDefaultCaseError v         =
  unstaticError $
    "Signature.TypeIndexedValue: "
      ++ "Multiple default cases in generic function " 
      ++ PP.unPretty (PP.ppName v)
      ++ "."

illegalDefaultCaseError          ::  Name -> a
illegalDefaultCaseError v        =
  unstaticError $
    "Signature.TypeIndexedValue: "
      ++ "Illegal default case in generic function " 
      ++ PP.unPretty (PP.ppName v)
      ++ "."



data Root = Root_Root ModuleSystem



type GHInType                    = (Int      {- verbosity -}
                                   ,Bool     {- prelude? -}
                                   ,Int      {- maximum iterations in specialisation -}
                                   ,Bool     {- ghc? -}
                                   ,Set Name {- exported values -}
                                   ,Set Name {- exported types -}
                                   ,Set Name {- exported structures -}
                                   ,[(Set Name,Set Name)] 
                                             {- imported entities -}
                                   ,[(Set Name,Set Name)] 
                                             {- hidden entities -}
                                   ,Set Strings  
                                             {- module names -}
                                   ,Bool     {- optimizer? -}
				   ,[Declaration]
                                             {- optimizer prelude decls -}
                                   )



type GHOutType                   = (PP.Doc {- errors -}
                                   ,Bool   {- stop -}
                                   ,PP.Doc {- debug -}
                                   ,PP.Doc {- generated Haskell output -}
                                   ,PP.Doc {- interface file -}
                                   )



mkKindVar                       :: Int -> Name
mkKindVar n                     =  Name_Special unknownRange [] $ "_kv" ++ show n
                                          {- special? -}

mkKindVar'                      :: Int -> Kind
mkKindVar'                      =  varK .  mkKindVar



unifyToplevel                    :: Range -> Name -> String 
                                 -> Kind -> Kind -> KSubst -> (KSubst,[GHError])
unifyToplevel r n d k1 k2 s      =  unifyWithError 
				      (GHError_KindUTError r n d 
				         (applyKind s k2) 
                                         (applyKind s k1)
                                      ) 
				      k1 k2 s

unifyWithError                   :: GHError -> Kind -> Kind -> KSubst -> (KSubst,[GHError])
unifyWithError e k1 k2 s         =  let (sub,succeed) = unify k1 k2 s 
                                    in  (sub,if succeed then [] else [e])



extractTypeIndexedTypes          :: LambdaType -> [(Name,RawRequest)]
extractTypeIndexedTypes ([v],b)  =  [ (v,rrs) | rrs <- extract b ]
  where
    extract                      :: Type -> [RawRequest]
    extract (Type_TypeApplication _ n tp) 
                                 =  [RawRequest (n,tp)]
    extract (Type_Application _ _ f a)
                                 =  extract f ++ concatMap extract a
    extract (Type_Qualified _ _ t)
                                 =  extract t {- ?? -}
    extract (Type_Forall _ _ t)  =  extract t {- ?? -}
    extract (Type_Exists _ _ t)  =  extract t {- ?? -}
    extract (Type_Parenthesized _ t)
                                 =  extract t
    extract _                    =  []

-- Alternative -------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      exportedStructures   : Set Name
      exportedTypes        : Set Name
      exportedValues       : Set Name
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures
      rawRequests_collect  : [RawRequest]
      structureTypes_collect : FMap Name LambdaType
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      kind_errors          : [GHError]
      self                 : SELF
      staticErrors         : [GHError]

-}
{-
   local variables for Alternative.Alternative:
      self

-}
{-
   local variables for Alternative.Empty:
      self

-}
-- semantic domain
type T_Alternative = (Set Name) ->
                     ([Request_BimapImply]) ->
                     (Maybe Name) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Strings) ->
                     (FMap Name [(Name,Name)]) ->
                     (Set Name) ->
                     (Set Name) ->
                     (Set Name) ->
                     ([Request_FunImply]) ->
                     (FMap Name Kind) ->
                     (FMap Name Kind) ->
                     (Bool) ->
                     (Bool) ->
                     (Maybe Name) ->
                     (KSubst) ->
                     (FMap Name KindIndexedType) ->
                     (FMap Name KindIndexedType) ->
                     (KSubst) ->
                     (Int) ->
                     (KSubst) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Bool) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Set Strings) ->
                     (Bool) ->
                     (Declarations) ->
                     (KSubst) ->
                     (Bool) ->
                     (PreSignatures) ->
                     (PreSignatures) ->
                     ([RawRequest]) ->
                     (Signatures) ->
                     (FMap Name LambdaType) ->
                     (Bool) ->
                     ([Request_TypeImply]) ->
                     (Int) ->
                     ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(PreSignatures),([RawRequest]),(Alternative),([GHError]),(FMap Name LambdaType),([Request_TypeImply]))
-- cata
sem_Alternative :: (Alternative) ->
                   (T_Alternative)
sem_Alternative ((Alternative_Alternative (_range) (_pattern) (_righthandside))) =
    (sem_Alternative_Alternative ((sem_Range (_range))) ((sem_Pattern (_pattern))) ((sem_RightHandSide (_righthandside))))
sem_Alternative ((Alternative_Empty (_range))) =
    (sem_Alternative_Empty ((sem_Range (_range))))
sem_Alternative_Alternative :: (T_Range) ->
                               (T_Pattern) ->
                               (T_RightHandSide) ->
                               (T_Alternative)
sem_Alternative_Alternative (range_) (pattern_) (righthandside_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Alternative)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _patternIconstructors_collect :: (FMap Name Names)
            _patternIgenericAbstractions_collect :: (FMap Name Kind)
            _patternIlabels_collect :: (FMap Name Names)
            _patternImethods_collect :: (FMap Name Names)
            _patternIname :: (Name)
            _patternIself :: (Pattern)
            _patternOclassname :: (Maybe Name)
            _patternOconstructors_collect :: (FMap Name Names)
            _patternOconstructors_dist :: (FMap Name Names)
            _patternOcurrentModule :: (Strings)
            _patternOgenericAbstractions :: (FMap Name Kind)
            _patternOgenericAbstractions_collect :: (FMap Name Kind)
            _patternOghc :: (Bool)
            _patternOimportedModule :: (Bool)
            _patternOinstancename :: (Maybe Name)
            _patternOlabels_collect :: (FMap Name Names)
            _patternOlabels_dist :: (FMap Name Names)
            _patternOlocal :: (Bool)
            _patternOmethods_collect :: (FMap Name Names)
            _patternOmethods_dist :: (FMap Name Names)
            _patternOmodules :: (Set Strings)
            _patternOoptimizer :: (Bool)
            _patternOoptimizerPrelude :: (Declarations)
            _patternOprelude :: (Bool)
            _patternOtoplevel :: (Bool)
            _patternOverbosity :: (Int)
            _righthandsideIabstractTypes_collect :: (Set Name)
            _righthandsideIbimapImps_collect :: ([Request_BimapImply])
            _righthandsideIconstructors_collect :: (FMap Name Names)
            _righthandsideIdepConstraints_collect :: ([DepConstraint])
            _righthandsideIfunImps_collect :: ([Request_FunImply])
            _righthandsideIgenericAbstractions_collect :: (FMap Name Kind)
            _righthandsideIkinames :: (KSubst)
            _righthandsideIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _righthandsideIkind_errors :: ([GHError])
            _righthandsideIkindvar :: (Int)
            _righthandsideIksubst :: (KSubst)
            _righthandsideIlabels_collect :: (FMap Name Names)
            _righthandsideImethods_collect :: (FMap Name Names)
            _righthandsideIpresignatures_collect :: (PreSignatures)
            _righthandsideIrawRequests_collect :: ([RawRequest])
            _righthandsideIself :: (RightHandSide)
            _righthandsideIstaticErrors :: ([GHError])
            _righthandsideIstructureTypes_collect :: (FMap Name LambdaType)
            _righthandsideItypeImps_collect :: ([Request_TypeImply])
            _righthandsideOabstractTypes_collect :: (Set Name)
            _righthandsideObimapImps_collect :: ([Request_BimapImply])
            _righthandsideOclassname :: (Maybe Name)
            _righthandsideOconstructors_collect :: (FMap Name Names)
            _righthandsideOconstructors_dist :: (FMap Name Names)
            _righthandsideOcurrentModule :: (Strings)
            _righthandsideOdependencies :: (FMap Name [(Name,Name)])
            _righthandsideOexportedStructures :: (Set Name)
            _righthandsideOexportedTypes :: (Set Name)
            _righthandsideOexportedValues :: (Set Name)
            _righthandsideOfunImps_collect :: ([Request_FunImply])
            _righthandsideOgenericAbstractions :: (FMap Name Kind)
            _righthandsideOgenericAbstractions_collect :: (FMap Name Kind)
            _righthandsideOghc :: (Bool)
            _righthandsideOimportedModule :: (Bool)
            _righthandsideOinstancename :: (Maybe Name)
            _righthandsideOkinames :: (KSubst)
            _righthandsideOkindIndexedTypes :: (FMap Name KindIndexedType)
            _righthandsideOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _righthandsideOkinds :: (KSubst)
            _righthandsideOkindvar :: (Int)
            _righthandsideOksubst :: (KSubst)
            _righthandsideOlabels_collect :: (FMap Name Names)
            _righthandsideOlabels_dist :: (FMap Name Names)
            _righthandsideOlocal :: (Bool)
            _righthandsideOmethods_collect :: (FMap Name Names)
            _righthandsideOmethods_dist :: (FMap Name Names)
            _righthandsideOmodules :: (Set Strings)
            _righthandsideOoptimizer :: (Bool)
            _righthandsideOoptimizerPrelude :: (Declarations)
            _righthandsideOprekind :: (KSubst)
            _righthandsideOprelude :: (Bool)
            _righthandsideOpresignatures :: (PreSignatures)
            _righthandsideOpresignatures_collect :: (PreSignatures)
            _righthandsideOrawRequests_collect :: ([RawRequest])
            _righthandsideOsignatures :: (Signatures)
            _righthandsideOstructureTypes_collect :: (FMap Name LambdaType)
            _righthandsideOtoplevel :: (Bool)
            _righthandsideOtypeImps_collect :: ([Request_TypeImply])
            _righthandsideOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _patternIconstructors_collect,_patternIgenericAbstractions_collect,_patternIlabels_collect,_patternImethods_collect,_patternIname,_patternIself) =
                (pattern_ (_patternOclassname)
                          (_patternOconstructors_collect)
                          (_patternOconstructors_dist)
                          (_patternOcurrentModule)
                          (_patternOgenericAbstractions)
                          (_patternOgenericAbstractions_collect)
                          (_patternOghc)
                          (_patternOimportedModule)
                          (_patternOinstancename)
                          (_patternOlabels_collect)
                          (_patternOlabels_dist)
                          (_patternOlocal)
                          (_patternOmethods_collect)
                          (_patternOmethods_dist)
                          (_patternOmodules)
                          (_patternOoptimizer)
                          (_patternOoptimizerPrelude)
                          (_patternOprelude)
                          (_patternOtoplevel)
                          (_patternOverbosity))
            ( _righthandsideIabstractTypes_collect
             ,_righthandsideIbimapImps_collect
             ,_righthandsideIconstructors_collect
             ,_righthandsideIdepConstraints_collect
             ,_righthandsideIfunImps_collect
             ,_righthandsideIgenericAbstractions_collect
             ,_righthandsideIkinames
             ,_righthandsideIkindIndexedTypes_collect
             ,_righthandsideIkind_errors
             ,_righthandsideIkindvar
             ,_righthandsideIksubst
             ,_righthandsideIlabels_collect
             ,_righthandsideImethods_collect
             ,_righthandsideIpresignatures_collect
             ,_righthandsideIrawRequests_collect
             ,_righthandsideIself
             ,_righthandsideIstaticErrors
             ,_righthandsideIstructureTypes_collect
             ,_righthandsideItypeImps_collect
             ) =
                (righthandside_ (_righthandsideOabstractTypes_collect)
                                (_righthandsideObimapImps_collect)
                                (_righthandsideOclassname)
                                (_righthandsideOconstructors_collect)
                                (_righthandsideOconstructors_dist)
                                (_righthandsideOcurrentModule)
                                (_righthandsideOdependencies)
                                (_righthandsideOexportedStructures)
                                (_righthandsideOexportedTypes)
                                (_righthandsideOexportedValues)
                                (_righthandsideOfunImps_collect)
                                (_righthandsideOgenericAbstractions)
                                (_righthandsideOgenericAbstractions_collect)
                                (_righthandsideOghc)
                                (_righthandsideOimportedModule)
                                (_righthandsideOinstancename)
                                (_righthandsideOkinames)
                                (_righthandsideOkindIndexedTypes)
                                (_righthandsideOkindIndexedTypes_collect)
                                (_righthandsideOkinds)
                                (_righthandsideOkindvar)
                                (_righthandsideOksubst)
                                (_righthandsideOlabels_collect)
                                (_righthandsideOlabels_dist)
                                (_righthandsideOlocal)
                                (_righthandsideOmethods_collect)
                                (_righthandsideOmethods_dist)
                                (_righthandsideOmodules)
                                (_righthandsideOoptimizer)
                                (_righthandsideOoptimizerPrelude)
                                (_righthandsideOprekind)
                                (_righthandsideOprelude)
                                (_righthandsideOpresignatures)
                                (_righthandsideOpresignatures_collect)
                                (_righthandsideOrawRequests_collect)
                                (_righthandsideOsignatures)
                                (_righthandsideOstructureTypes_collect)
                                (_righthandsideOtoplevel)
                                (_righthandsideOtypeImps_collect)
                                (_righthandsideOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _righthandsideIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _righthandsideIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _righthandsideIstaticErrors
            -- self rule
            (_self@_) =
                Alternative_Alternative _rangeIself _patternIself _righthandsideIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _righthandsideIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _righthandsideIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _righthandsideIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _righthandsideIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _righthandsideIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _righthandsideIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _righthandsideIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _righthandsideIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _righthandsideIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _righthandsideIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _righthandsideImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _righthandsideIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _righthandsideIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _righthandsideIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _righthandsideItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_patternOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_patternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_patternOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_patternOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_patternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_patternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_patternOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_patternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_patternOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_patternOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_patternOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_patternOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_righthandsideOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_righthandsideObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_righthandsideOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_righthandsideOconstructors_collect@_) =
                _patternIconstructors_collect
            -- copy rule (down)
            (_righthandsideOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_righthandsideOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_righthandsideOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_righthandsideOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_righthandsideOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_righthandsideOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_righthandsideOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_righthandsideOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_righthandsideOgenericAbstractions_collect@_) =
                _patternIgenericAbstractions_collect
            -- copy rule (down)
            (_righthandsideOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_righthandsideOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_righthandsideOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_righthandsideOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_righthandsideOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_righthandsideOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_righthandsideOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_righthandsideOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_righthandsideOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_righthandsideOlabels_collect@_) =
                _patternIlabels_collect
            -- copy rule (down)
            (_righthandsideOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_righthandsideOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_righthandsideOmethods_collect@_) =
                _patternImethods_collect
            -- copy rule (down)
            (_righthandsideOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_righthandsideOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_righthandsideOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_righthandsideOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_righthandsideOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_righthandsideOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_righthandsideOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_righthandsideOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_righthandsideOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_righthandsideOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_righthandsideOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_righthandsideOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_righthandsideOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_righthandsideOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Alternative_Empty :: (T_Range) ->
                         (T_Alternative)
sem_Alternative_Empty (range_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Alternative)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                Alternative_Empty _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
-- Alternatives ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      exportedStructures   : Set Name
      exportedTypes        : Set Name
      exportedValues       : Set Name
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures
      rawRequests_collect  : [RawRequest]
      structureTypes_collect : FMap Name LambdaType
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      kind_errors          : [GHError]
      self                 : SELF
      staticErrors         : [GHError]

-}
{-
   local variables for Alternatives.Cons:
      self

-}
{-
   local variables for Alternatives.Nil:
      self

-}
-- semantic domain
type T_Alternatives = (Set Name) ->
                      ([Request_BimapImply]) ->
                      (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Strings) ->
                      (FMap Name [(Name,Name)]) ->
                      (Set Name) ->
                      (Set Name) ->
                      (Set Name) ->
                      ([Request_FunImply]) ->
                      (FMap Name Kind) ->
                      (FMap Name Kind) ->
                      (Bool) ->
                      (Bool) ->
                      (Maybe Name) ->
                      (KSubst) ->
                      (FMap Name KindIndexedType) ->
                      (FMap Name KindIndexedType) ->
                      (KSubst) ->
                      (Int) ->
                      (KSubst) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Set Strings) ->
                      (Bool) ->
                      (Declarations) ->
                      (KSubst) ->
                      (Bool) ->
                      (PreSignatures) ->
                      (PreSignatures) ->
                      ([RawRequest]) ->
                      (Signatures) ->
                      (FMap Name LambdaType) ->
                      (Bool) ->
                      ([Request_TypeImply]) ->
                      (Int) ->
                      ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(PreSignatures),([RawRequest]),(Alternatives),([GHError]),(FMap Name LambdaType),([Request_TypeImply]))
-- cata
sem_Alternatives :: (Alternatives) ->
                    (T_Alternatives)
sem_Alternatives (list) =
    (foldr (sem_Alternatives_Cons) (sem_Alternatives_Nil) ((map sem_Alternative list)))
sem_Alternatives_Cons :: (T_Alternative) ->
                         (T_Alternatives) ->
                         (T_Alternatives)
sem_Alternatives_Cons (hd_) (tl_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Alternatives)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _hdIabstractTypes_collect :: (Set Name)
            _hdIbimapImps_collect :: ([Request_BimapImply])
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdepConstraints_collect :: ([DepConstraint])
            _hdIfunImps_collect :: ([Request_FunImply])
            _hdIgenericAbstractions_collect :: (FMap Name Kind)
            _hdIkinames :: (KSubst)
            _hdIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _hdIkind_errors :: ([GHError])
            _hdIkindvar :: (Int)
            _hdIksubst :: (KSubst)
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIpresignatures_collect :: (PreSignatures)
            _hdIrawRequests_collect :: ([RawRequest])
            _hdIself :: (Alternative)
            _hdIstaticErrors :: ([GHError])
            _hdIstructureTypes_collect :: (FMap Name LambdaType)
            _hdItypeImps_collect :: ([Request_TypeImply])
            _hdOabstractTypes_collect :: (Set Name)
            _hdObimapImps_collect :: ([Request_BimapImply])
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies :: (FMap Name [(Name,Name)])
            _hdOexportedStructures :: (Set Name)
            _hdOexportedTypes :: (Set Name)
            _hdOexportedValues :: (Set Name)
            _hdOfunImps_collect :: ([Request_FunImply])
            _hdOgenericAbstractions :: (FMap Name Kind)
            _hdOgenericAbstractions_collect :: (FMap Name Kind)
            _hdOghc :: (Bool)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOkinames :: (KSubst)
            _hdOkindIndexedTypes :: (FMap Name KindIndexedType)
            _hdOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _hdOkinds :: (KSubst)
            _hdOkindvar :: (Int)
            _hdOksubst :: (KSubst)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmodules :: (Set Strings)
            _hdOoptimizer :: (Bool)
            _hdOoptimizerPrelude :: (Declarations)
            _hdOprekind :: (KSubst)
            _hdOprelude :: (Bool)
            _hdOpresignatures :: (PreSignatures)
            _hdOpresignatures_collect :: (PreSignatures)
            _hdOrawRequests_collect :: ([RawRequest])
            _hdOsignatures :: (Signatures)
            _hdOstructureTypes_collect :: (FMap Name LambdaType)
            _hdOtoplevel :: (Bool)
            _hdOtypeImps_collect :: ([Request_TypeImply])
            _hdOverbosity :: (Int)
            _tlIabstractTypes_collect :: (Set Name)
            _tlIbimapImps_collect :: ([Request_BimapImply])
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdepConstraints_collect :: ([DepConstraint])
            _tlIfunImps_collect :: ([Request_FunImply])
            _tlIgenericAbstractions_collect :: (FMap Name Kind)
            _tlIkinames :: (KSubst)
            _tlIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _tlIkind_errors :: ([GHError])
            _tlIkindvar :: (Int)
            _tlIksubst :: (KSubst)
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIpresignatures_collect :: (PreSignatures)
            _tlIrawRequests_collect :: ([RawRequest])
            _tlIself :: (Alternatives)
            _tlIstaticErrors :: ([GHError])
            _tlIstructureTypes_collect :: (FMap Name LambdaType)
            _tlItypeImps_collect :: ([Request_TypeImply])
            _tlOabstractTypes_collect :: (Set Name)
            _tlObimapImps_collect :: ([Request_BimapImply])
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies :: (FMap Name [(Name,Name)])
            _tlOexportedStructures :: (Set Name)
            _tlOexportedTypes :: (Set Name)
            _tlOexportedValues :: (Set Name)
            _tlOfunImps_collect :: ([Request_FunImply])
            _tlOgenericAbstractions :: (FMap Name Kind)
            _tlOgenericAbstractions_collect :: (FMap Name Kind)
            _tlOghc :: (Bool)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOkinames :: (KSubst)
            _tlOkindIndexedTypes :: (FMap Name KindIndexedType)
            _tlOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _tlOkinds :: (KSubst)
            _tlOkindvar :: (Int)
            _tlOksubst :: (KSubst)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmodules :: (Set Strings)
            _tlOoptimizer :: (Bool)
            _tlOoptimizerPrelude :: (Declarations)
            _tlOprekind :: (KSubst)
            _tlOprelude :: (Bool)
            _tlOpresignatures :: (PreSignatures)
            _tlOpresignatures_collect :: (PreSignatures)
            _tlOrawRequests_collect :: ([RawRequest])
            _tlOsignatures :: (Signatures)
            _tlOstructureTypes_collect :: (FMap Name LambdaType)
            _tlOtoplevel :: (Bool)
            _tlOtypeImps_collect :: ([Request_TypeImply])
            _tlOverbosity :: (Int)
            ( _hdIabstractTypes_collect,_hdIbimapImps_collect,_hdIconstructors_collect,_hdIdepConstraints_collect,_hdIfunImps_collect,_hdIgenericAbstractions_collect,_hdIkinames,_hdIkindIndexedTypes_collect,_hdIkind_errors,_hdIkindvar,_hdIksubst,_hdIlabels_collect,_hdImethods_collect,_hdIpresignatures_collect,_hdIrawRequests_collect,_hdIself,_hdIstaticErrors,_hdIstructureTypes_collect,_hdItypeImps_collect) =
                (hd_ (_hdOabstractTypes_collect)
                     (_hdObimapImps_collect)
                     (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOdependencies)
                     (_hdOexportedStructures)
                     (_hdOexportedTypes)
                     (_hdOexportedValues)
                     (_hdOfunImps_collect)
                     (_hdOgenericAbstractions)
                     (_hdOgenericAbstractions_collect)
                     (_hdOghc)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOkinames)
                     (_hdOkindIndexedTypes)
                     (_hdOkindIndexedTypes_collect)
                     (_hdOkinds)
                     (_hdOkindvar)
                     (_hdOksubst)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmodules)
                     (_hdOoptimizer)
                     (_hdOoptimizerPrelude)
                     (_hdOprekind)
                     (_hdOprelude)
                     (_hdOpresignatures)
                     (_hdOpresignatures_collect)
                     (_hdOrawRequests_collect)
                     (_hdOsignatures)
                     (_hdOstructureTypes_collect)
                     (_hdOtoplevel)
                     (_hdOtypeImps_collect)
                     (_hdOverbosity))
            ( _tlIabstractTypes_collect,_tlIbimapImps_collect,_tlIconstructors_collect,_tlIdepConstraints_collect,_tlIfunImps_collect,_tlIgenericAbstractions_collect,_tlIkinames,_tlIkindIndexedTypes_collect,_tlIkind_errors,_tlIkindvar,_tlIksubst,_tlIlabels_collect,_tlImethods_collect,_tlIpresignatures_collect,_tlIrawRequests_collect,_tlIself,_tlIstaticErrors,_tlIstructureTypes_collect,_tlItypeImps_collect) =
                (tl_ (_tlOabstractTypes_collect)
                     (_tlObimapImps_collect)
                     (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOdependencies)
                     (_tlOexportedStructures)
                     (_tlOexportedTypes)
                     (_tlOexportedValues)
                     (_tlOfunImps_collect)
                     (_tlOgenericAbstractions)
                     (_tlOgenericAbstractions_collect)
                     (_tlOghc)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOkinames)
                     (_tlOkindIndexedTypes)
                     (_tlOkindIndexedTypes_collect)
                     (_tlOkinds)
                     (_tlOkindvar)
                     (_tlOksubst)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmodules)
                     (_tlOoptimizer)
                     (_tlOoptimizerPrelude)
                     (_tlOprekind)
                     (_tlOprelude)
                     (_tlOpresignatures)
                     (_tlOpresignatures_collect)
                     (_tlOrawRequests_collect)
                     (_tlOsignatures)
                     (_tlOstructureTypes_collect)
                     (_tlOtoplevel)
                     (_tlOtypeImps_collect)
                     (_tlOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _hdIdepConstraints_collect ++ _tlIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _hdIkind_errors ++ _tlIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _hdIstaticErrors ++ _tlIstaticErrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _tlIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _tlIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _tlIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _tlIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _tlIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _tlIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _tlIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _tlIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _tlIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _tlIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _tlIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _tlItypeImps_collect
            -- copy rule (down)
            (_hdOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_hdObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_hdOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_hdOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_hdOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_hdOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_hdOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_hdOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_hdOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_hdOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_hdOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_hdOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_hdOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_hdOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_hdOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_hdOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_hdOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_hdOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_hdOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_hdOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_hdOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_hdOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_hdOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_hdOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_hdOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_tlOabstractTypes_collect@_) =
                _hdIabstractTypes_collect
            -- copy rule (chain)
            (_tlObimapImps_collect@_) =
                _hdIbimapImps_collect
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_tlOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_tlOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_tlOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (chain)
            (_tlOfunImps_collect@_) =
                _hdIfunImps_collect
            -- copy rule (down)
            (_tlOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_tlOgenericAbstractions_collect@_) =
                _hdIgenericAbstractions_collect
            -- copy rule (down)
            (_tlOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOkinames@_) =
                _hdIkinames
            -- copy rule (down)
            (_tlOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (chain)
            (_tlOkindIndexedTypes_collect@_) =
                _hdIkindIndexedTypes_collect
            -- copy rule (down)
            (_tlOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_tlOkindvar@_) =
                _hdIkindvar
            -- copy rule (chain)
            (_tlOksubst@_) =
                _hdIksubst
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_tlOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_tlOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_tlOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_tlOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_tlOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_tlOpresignatures_collect@_) =
                _hdIpresignatures_collect
            -- copy rule (chain)
            (_tlOrawRequests_collect@_) =
                _hdIrawRequests_collect
            -- copy rule (down)
            (_tlOsignatures@_) =
                _lhsIsignatures
            -- copy rule (chain)
            (_tlOstructureTypes_collect@_) =
                _hdIstructureTypes_collect
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_tlOtypeImps_collect@_) =
                _hdItypeImps_collect
            -- copy rule (down)
            (_tlOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Alternatives_Nil :: (T_Alternatives)
sem_Alternatives_Nil  =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Alternatives)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
-- AnnotatedType -----------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kinds                : KSubst
      klabels              : Names
      kname                : Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      rawRequests_collect  : [RawRequest]
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      kind_errors          : [GHError]
      self                 : SELF
      staticErrors         : [GHError]
      typeImps             : [Type]

-}
{-
   local variables for AnnotatedType.AnnotatedType:
      ks
      kind_errors
      self

-}
-- semantic domain
type T_AnnotatedType = (Set Name) ->
                       ([Request_BimapImply]) ->
                       (Maybe Name) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (Strings) ->
                       (FMap Name [(Name,Name)]) ->
                       ([Request_FunImply]) ->
                       (FMap Name Kind) ->
                       (FMap Name Kind) ->
                       (Bool) ->
                       (Bool) ->
                       (Maybe Name) ->
                       (KSubst) ->
                       (KSubst) ->
                       (Int) ->
                       (Names) ->
                       (Name) ->
                       (KSubst) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (Bool) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (Set Strings) ->
                       (Bool) ->
                       (Declarations) ->
                       (KSubst) ->
                       (Bool) ->
                       ([RawRequest]) ->
                       (Bool) ->
                       ([Request_TypeImply]) ->
                       (Int) ->
                       ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),([RawRequest]),(AnnotatedType),([GHError]),([Type]),([Request_TypeImply]))
-- cata
sem_AnnotatedType :: (AnnotatedType) ->
                     (T_AnnotatedType)
sem_AnnotatedType ((AnnotatedType_AnnotatedType (_range) (_strict) (_type))) =
    (sem_AnnotatedType_AnnotatedType ((sem_Range (_range))) (_strict) ((sem_Type (_type))))
sem_AnnotatedType_AnnotatedType :: (T_Range) ->
                                   (Bool) ->
                                   (T_Type) ->
                                   (T_AnnotatedType)
sem_AnnotatedType_AnnotatedType (range_) (strict_) (type_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIklabels
      _lhsIkname
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (AnnotatedType)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps :: ([Type])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _typeIabstractTypes_collect :: (Set Name)
            _typeIbimapImps_collect :: ([Request_BimapImply])
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIdepConstraints_collect :: ([DepConstraint])
            _typeIfunImps_collect :: ([Request_FunImply])
            _typeIgenericAbstractions_collect :: (FMap Name Kind)
            _typeIinferkind :: (Kind)
            _typeIkinames :: (KSubst)
            _typeIkind_errors :: ([GHError])
            _typeIkindvar :: (Int)
            _typeIksubst :: (KSubst)
            _typeIlabels_collect :: (FMap Name Names)
            _typeImethods_collect :: (FMap Name Names)
            _typeIrawRequests_collect :: ([RawRequest])
            _typeIself :: (Type)
            _typeIstaticErrors :: ([GHError])
            _typeItypeImps_collect :: ([Request_TypeImply])
            _typeOabstractTypes_collect :: (Set Name)
            _typeObimapImps_collect :: ([Request_BimapImply])
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOdependencies :: (FMap Name [(Name,Name)])
            _typeOfunImps_collect :: ([Request_FunImply])
            _typeOgenericAbstractions :: (FMap Name Kind)
            _typeOgenericAbstractions_collect :: (FMap Name Kind)
            _typeOghc :: (Bool)
            _typeOimportedModule :: (Bool)
            _typeOinstancename :: (Maybe Name)
            _typeOkinames :: (KSubst)
            _typeOkinds :: (KSubst)
            _typeOkindvar :: (Int)
            _typeOksubst :: (KSubst)
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOmodules :: (Set Strings)
            _typeOoptimizer :: (Bool)
            _typeOoptimizerPrelude :: (Declarations)
            _typeOprekind :: (KSubst)
            _typeOprelude :: (Bool)
            _typeOrawRequests_collect :: ([RawRequest])
            _typeOtoplevel :: (Bool)
            _typeOtypeImps_collect :: ([Request_TypeImply])
            _typeOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _typeIabstractTypes_collect,_typeIbimapImps_collect,_typeIconstructors_collect,_typeIdepConstraints_collect,_typeIfunImps_collect,_typeIgenericAbstractions_collect,_typeIinferkind,_typeIkinames,_typeIkind_errors,_typeIkindvar,_typeIksubst,_typeIlabels_collect,_typeImethods_collect,_typeIrawRequests_collect,_typeIself,_typeIstaticErrors,_typeItypeImps_collect) =
                (type_ (_typeOabstractTypes_collect)
                       (_typeObimapImps_collect)
                       (_typeOclassname)
                       (_typeOconstructors_collect)
                       (_typeOconstructors_dist)
                       (_typeOcurrentModule)
                       (_typeOdependencies)
                       (_typeOfunImps_collect)
                       (_typeOgenericAbstractions)
                       (_typeOgenericAbstractions_collect)
                       (_typeOghc)
                       (_typeOimportedModule)
                       (_typeOinstancename)
                       (_typeOkinames)
                       (_typeOkinds)
                       (_typeOkindvar)
                       (_typeOksubst)
                       (_typeOlabels_collect)
                       (_typeOlabels_dist)
                       (_typeOlocal)
                       (_typeOmethods_collect)
                       (_typeOmethods_dist)
                       (_typeOmodules)
                       (_typeOoptimizer)
                       (_typeOoptimizerPrelude)
                       (_typeOprekind)
                       (_typeOprelude)
                       (_typeOrawRequests_collect)
                       (_typeOtoplevel)
                       (_typeOtypeImps_collect)
                       (_typeOverbosity))
            -- "./ModuleInformation.inc.lag"(line 203, column 8)
            (_typeOtoplevel@_) =
                False
            -- "./Kind.inc.lag"(line 566, column 9)
            (_lhsOksubst@_) =
                _ks
            -- "./Kind.inc.lag"(line 565, column 9)
            (_lhsOkind_errors@_) =
                _typeIkind_errors ++ _kind_errors
            -- "./Kind.inc.lag"(line 558, column 13)
            ((_ks@_,_kind_errors@_)) =
                unifyWithError
                  (GHError_KindUCError _rangeIself
                     _lhsIkname
                     _lhsIklabels
                     (applyKind _typeIksubst _typeIinferkind)
                  )
                  _typeIinferkind starK _typeIksubst
            -- "./Request.inc.lag"(line 250, column 9)
            (_lhsOtypeImps@_) =
                [_typeIself]
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _typeIdepConstraints_collect
            -- use rule
            (_lhsOstaticErrors@_) =
                _typeIstaticErrors
            -- self rule
            (_self@_) =
                AnnotatedType_AnnotatedType _rangeIself strict_ _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _typeIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _typeIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _typeIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _typeIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _typeIkinames
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _typeIkindvar
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _typeIrawRequests_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _typeItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_typeObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_typeOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_typeOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_typeOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_typeOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_typeOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typeOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_typeOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_typeOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_typeOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_typeOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_typeOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typeOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_typeOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_typeOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_typeOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_typeOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_typeOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_typeOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_typeOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps,_lhsOtypeImps_collect)
-- AnnotatedTypes ----------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kinds                : KSubst
      klabels              : Names
      kname                : Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      rawRequests_collect  : [RawRequest]
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      kind_errors          : [GHError]
      self                 : SELF
      staticErrors         : [GHError]
      typeImps             : [Type]

-}
{-
   local variables for AnnotatedTypes.Cons:
      self

-}
{-
   local variables for AnnotatedTypes.Nil:
      self

-}
-- semantic domain
type T_AnnotatedTypes = (Set Name) ->
                        ([Request_BimapImply]) ->
                        (Maybe Name) ->
                        (FMap Name Names) ->
                        (FMap Name Names) ->
                        (Strings) ->
                        (FMap Name [(Name,Name)]) ->
                        ([Request_FunImply]) ->
                        (FMap Name Kind) ->
                        (FMap Name Kind) ->
                        (Bool) ->
                        (Bool) ->
                        (Maybe Name) ->
                        (KSubst) ->
                        (KSubst) ->
                        (Int) ->
                        (Names) ->
                        (Name) ->
                        (KSubst) ->
                        (FMap Name Names) ->
                        (FMap Name Names) ->
                        (Bool) ->
                        (FMap Name Names) ->
                        (FMap Name Names) ->
                        (Set Strings) ->
                        (Bool) ->
                        (Declarations) ->
                        (KSubst) ->
                        (Bool) ->
                        ([RawRequest]) ->
                        (Bool) ->
                        ([Request_TypeImply]) ->
                        (Int) ->
                        ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),([RawRequest]),(AnnotatedTypes),([GHError]),([Type]),([Request_TypeImply]))
-- cata
sem_AnnotatedTypes :: (AnnotatedTypes) ->
                      (T_AnnotatedTypes)
sem_AnnotatedTypes (list) =
    (foldr (sem_AnnotatedTypes_Cons) (sem_AnnotatedTypes_Nil) ((map sem_AnnotatedType list)))
sem_AnnotatedTypes_Cons :: (T_AnnotatedType) ->
                           (T_AnnotatedTypes) ->
                           (T_AnnotatedTypes)
sem_AnnotatedTypes_Cons (hd_) (tl_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIklabels
      _lhsIkname
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (AnnotatedTypes)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps :: ([Type])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _hdIabstractTypes_collect :: (Set Name)
            _hdIbimapImps_collect :: ([Request_BimapImply])
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdepConstraints_collect :: ([DepConstraint])
            _hdIfunImps_collect :: ([Request_FunImply])
            _hdIgenericAbstractions_collect :: (FMap Name Kind)
            _hdIkinames :: (KSubst)
            _hdIkind_errors :: ([GHError])
            _hdIkindvar :: (Int)
            _hdIksubst :: (KSubst)
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIrawRequests_collect :: ([RawRequest])
            _hdIself :: (AnnotatedType)
            _hdIstaticErrors :: ([GHError])
            _hdItypeImps :: ([Type])
            _hdItypeImps_collect :: ([Request_TypeImply])
            _hdOabstractTypes_collect :: (Set Name)
            _hdObimapImps_collect :: ([Request_BimapImply])
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies :: (FMap Name [(Name,Name)])
            _hdOfunImps_collect :: ([Request_FunImply])
            _hdOgenericAbstractions :: (FMap Name Kind)
            _hdOgenericAbstractions_collect :: (FMap Name Kind)
            _hdOghc :: (Bool)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOkinames :: (KSubst)
            _hdOkinds :: (KSubst)
            _hdOkindvar :: (Int)
            _hdOklabels :: (Names)
            _hdOkname :: (Name)
            _hdOksubst :: (KSubst)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmodules :: (Set Strings)
            _hdOoptimizer :: (Bool)
            _hdOoptimizerPrelude :: (Declarations)
            _hdOprekind :: (KSubst)
            _hdOprelude :: (Bool)
            _hdOrawRequests_collect :: ([RawRequest])
            _hdOtoplevel :: (Bool)
            _hdOtypeImps_collect :: ([Request_TypeImply])
            _hdOverbosity :: (Int)
            _tlIabstractTypes_collect :: (Set Name)
            _tlIbimapImps_collect :: ([Request_BimapImply])
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdepConstraints_collect :: ([DepConstraint])
            _tlIfunImps_collect :: ([Request_FunImply])
            _tlIgenericAbstractions_collect :: (FMap Name Kind)
            _tlIkinames :: (KSubst)
            _tlIkind_errors :: ([GHError])
            _tlIkindvar :: (Int)
            _tlIksubst :: (KSubst)
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIrawRequests_collect :: ([RawRequest])
            _tlIself :: (AnnotatedTypes)
            _tlIstaticErrors :: ([GHError])
            _tlItypeImps :: ([Type])
            _tlItypeImps_collect :: ([Request_TypeImply])
            _tlOabstractTypes_collect :: (Set Name)
            _tlObimapImps_collect :: ([Request_BimapImply])
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies :: (FMap Name [(Name,Name)])
            _tlOfunImps_collect :: ([Request_FunImply])
            _tlOgenericAbstractions :: (FMap Name Kind)
            _tlOgenericAbstractions_collect :: (FMap Name Kind)
            _tlOghc :: (Bool)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOkinames :: (KSubst)
            _tlOkinds :: (KSubst)
            _tlOkindvar :: (Int)
            _tlOklabels :: (Names)
            _tlOkname :: (Name)
            _tlOksubst :: (KSubst)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmodules :: (Set Strings)
            _tlOoptimizer :: (Bool)
            _tlOoptimizerPrelude :: (Declarations)
            _tlOprekind :: (KSubst)
            _tlOprelude :: (Bool)
            _tlOrawRequests_collect :: ([RawRequest])
            _tlOtoplevel :: (Bool)
            _tlOtypeImps_collect :: ([Request_TypeImply])
            _tlOverbosity :: (Int)
            ( _hdIabstractTypes_collect,_hdIbimapImps_collect,_hdIconstructors_collect,_hdIdepConstraints_collect,_hdIfunImps_collect,_hdIgenericAbstractions_collect,_hdIkinames,_hdIkind_errors,_hdIkindvar,_hdIksubst,_hdIlabels_collect,_hdImethods_collect,_hdIrawRequests_collect,_hdIself,_hdIstaticErrors,_hdItypeImps,_hdItypeImps_collect) =
                (hd_ (_hdOabstractTypes_collect)
                     (_hdObimapImps_collect)
                     (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOdependencies)
                     (_hdOfunImps_collect)
                     (_hdOgenericAbstractions)
                     (_hdOgenericAbstractions_collect)
                     (_hdOghc)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOkinames)
                     (_hdOkinds)
                     (_hdOkindvar)
                     (_hdOklabels)
                     (_hdOkname)
                     (_hdOksubst)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmodules)
                     (_hdOoptimizer)
                     (_hdOoptimizerPrelude)
                     (_hdOprekind)
                     (_hdOprelude)
                     (_hdOrawRequests_collect)
                     (_hdOtoplevel)
                     (_hdOtypeImps_collect)
                     (_hdOverbosity))
            ( _tlIabstractTypes_collect,_tlIbimapImps_collect,_tlIconstructors_collect,_tlIdepConstraints_collect,_tlIfunImps_collect,_tlIgenericAbstractions_collect,_tlIkinames,_tlIkind_errors,_tlIkindvar,_tlIksubst,_tlIlabels_collect,_tlImethods_collect,_tlIrawRequests_collect,_tlIself,_tlIstaticErrors,_tlItypeImps,_tlItypeImps_collect) =
                (tl_ (_tlOabstractTypes_collect)
                     (_tlObimapImps_collect)
                     (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOdependencies)
                     (_tlOfunImps_collect)
                     (_tlOgenericAbstractions)
                     (_tlOgenericAbstractions_collect)
                     (_tlOghc)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOkinames)
                     (_tlOkinds)
                     (_tlOkindvar)
                     (_tlOklabels)
                     (_tlOkname)
                     (_tlOksubst)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmodules)
                     (_tlOoptimizer)
                     (_tlOoptimizerPrelude)
                     (_tlOprekind)
                     (_tlOprelude)
                     (_tlOrawRequests_collect)
                     (_tlOtoplevel)
                     (_tlOtypeImps_collect)
                     (_tlOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _hdIdepConstraints_collect ++ _tlIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _hdIkind_errors ++ _tlIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _hdIstaticErrors ++ _tlIstaticErrors
            -- use rule
            (_lhsOtypeImps@_) =
                _hdItypeImps ++ _tlItypeImps
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _tlIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _tlIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _tlIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _tlIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _tlIkinames
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _tlIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _tlIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _tlIrawRequests_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _tlItypeImps_collect
            -- copy rule (down)
            (_hdOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_hdObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_hdOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_hdOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_hdOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_hdOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_hdOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_hdOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_hdOklabels@_) =
                _lhsIklabels
            -- copy rule (down)
            (_hdOkname@_) =
                _lhsIkname
            -- copy rule (down)
            (_hdOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_hdOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_hdOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_hdOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_hdOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_hdOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_hdOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_hdOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_tlOabstractTypes_collect@_) =
                _hdIabstractTypes_collect
            -- copy rule (chain)
            (_tlObimapImps_collect@_) =
                _hdIbimapImps_collect
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOdependencies@_) =
                _lhsIdependencies
            -- copy rule (chain)
            (_tlOfunImps_collect@_) =
                _hdIfunImps_collect
            -- copy rule (down)
            (_tlOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_tlOgenericAbstractions_collect@_) =
                _hdIgenericAbstractions_collect
            -- copy rule (down)
            (_tlOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOkinames@_) =
                _hdIkinames
            -- copy rule (down)
            (_tlOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_tlOkindvar@_) =
                _hdIkindvar
            -- copy rule (down)
            (_tlOklabels@_) =
                _lhsIklabels
            -- copy rule (down)
            (_tlOkname@_) =
                _lhsIkname
            -- copy rule (chain)
            (_tlOksubst@_) =
                _hdIksubst
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_tlOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_tlOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_tlOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_tlOprelude@_) =
                _lhsIprelude
            -- copy rule (chain)
            (_tlOrawRequests_collect@_) =
                _hdIrawRequests_collect
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_tlOtypeImps_collect@_) =
                _hdItypeImps_collect
            -- copy rule (down)
            (_tlOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps,_lhsOtypeImps_collect)
sem_AnnotatedTypes_Nil :: (T_AnnotatedTypes)
sem_AnnotatedTypes_Nil  =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIklabels
      _lhsIkname
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (AnnotatedTypes)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps :: ([Type])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- use rule
            (_lhsOtypeImps@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps,_lhsOtypeImps_collect)
-- Body --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      exportedStructures   : Set Name
      exportedTypes        : Set Name
      exportedValues       : Set Name
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      output               : [PP.Doc]
      presignatures_collect : PreSignatures
      rawRequests_collect  : [RawRequest]
      structureTypes_collect : FMap Name LambdaType
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      kind_errors          : [GHError]
      outputi              : [PP.Doc]
      self                 : SELF
      staticErrors         : [GHError]

-}
{-
   local variables for Body.Body:
      self

-}
-- semantic domain
type T_Body = (Set Name) ->
              ([Request_BimapImply]) ->
              (Maybe Name) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (Strings) ->
              (FMap Name [(Name,Name)]) ->
              (Set Name) ->
              (Set Name) ->
              (Set Name) ->
              ([Request_FunImply]) ->
              (FMap Name Kind) ->
              (FMap Name Kind) ->
              (Bool) ->
              (Bool) ->
              (Maybe Name) ->
              (KSubst) ->
              (FMap Name KindIndexedType) ->
              (FMap Name KindIndexedType) ->
              (KSubst) ->
              (Int) ->
              (KSubst) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (Bool) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (Set Strings) ->
              (Bool) ->
              (Declarations) ->
              ([PP.Doc]) ->
              (KSubst) ->
              (Bool) ->
              (PreSignatures) ->
              (PreSignatures) ->
              ([RawRequest]) ->
              (Signatures) ->
              (FMap Name LambdaType) ->
              (Bool) ->
              ([Request_TypeImply]) ->
              (Int) ->
              ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),([PP.Doc]),([PP.Doc]),(PreSignatures),([RawRequest]),(Body),([GHError]),(FMap Name LambdaType),([Request_TypeImply]))
-- cata
sem_Body :: (Body) ->
            (T_Body)
sem_Body ((Body_Body (_range) (_importdeclarations) (_declarations))) =
    (sem_Body_Body ((sem_Range (_range))) ((sem_ImportDeclarations (_importdeclarations))) ((sem_Declarations (_declarations))))
sem_Body_Body :: (T_Range) ->
                 (T_ImportDeclarations) ->
                 (T_Declarations) ->
                 (T_Body)
sem_Body_Body (range_) (importdeclarations_) (declarations_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIoutput
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: ([PP.Doc])
            _lhsOoutputi :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Body)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _importdeclarationsIconstructors_collect :: (FMap Name Names)
            _importdeclarationsIgenericAbstractions_collect :: (FMap Name Kind)
            _importdeclarationsIkinames :: (KSubst)
            _importdeclarationsIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _importdeclarationsIkind_errors :: ([GHError])
            _importdeclarationsIkindvar :: (Int)
            _importdeclarationsIksubst :: (KSubst)
            _importdeclarationsIlabels_collect :: (FMap Name Names)
            _importdeclarationsImethods_collect :: (FMap Name Names)
            _importdeclarationsIoutput :: ([PP.Doc])
            _importdeclarationsIoutputi :: ([PP.Doc])
            _importdeclarationsIpresignatures_collect :: (PreSignatures)
            _importdeclarationsIself :: (ImportDeclarations)
            _importdeclarationsOclassname :: (Maybe Name)
            _importdeclarationsOconstructors_collect :: (FMap Name Names)
            _importdeclarationsOconstructors_dist :: (FMap Name Names)
            _importdeclarationsOcurrentModule :: (Strings)
            _importdeclarationsOgenericAbstractions :: (FMap Name Kind)
            _importdeclarationsOgenericAbstractions_collect :: (FMap Name Kind)
            _importdeclarationsOghc :: (Bool)
            _importdeclarationsOimportedModule :: (Bool)
            _importdeclarationsOinstancename :: (Maybe Name)
            _importdeclarationsOkinames :: (KSubst)
            _importdeclarationsOkindIndexedTypes :: (FMap Name KindIndexedType)
            _importdeclarationsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _importdeclarationsOkinds :: (KSubst)
            _importdeclarationsOkindvar :: (Int)
            _importdeclarationsOksubst :: (KSubst)
            _importdeclarationsOlabels_collect :: (FMap Name Names)
            _importdeclarationsOlabels_dist :: (FMap Name Names)
            _importdeclarationsOlocal :: (Bool)
            _importdeclarationsOmethods_collect :: (FMap Name Names)
            _importdeclarationsOmethods_dist :: (FMap Name Names)
            _importdeclarationsOmodules :: (Set Strings)
            _importdeclarationsOoptimizer :: (Bool)
            _importdeclarationsOoptimizerPrelude :: (Declarations)
            _importdeclarationsOoutput :: ([PP.Doc])
            _importdeclarationsOprekind :: (KSubst)
            _importdeclarationsOprelude :: (Bool)
            _importdeclarationsOpresignatures :: (PreSignatures)
            _importdeclarationsOpresignatures_collect :: (PreSignatures)
            _importdeclarationsOsignatures :: (Signatures)
            _importdeclarationsOtoplevel :: (Bool)
            _importdeclarationsOverbosity :: (Int)
            _declarationsIabstractTypes_collect :: (Set Name)
            _declarationsIbimapImps_collect :: ([Request_BimapImply])
            _declarationsIconstructors_collect :: (FMap Name Names)
            _declarationsIdepConstraints_collect :: ([DepConstraint])
            _declarationsIdepConstraints_defined :: ([DepConstraint])
            _declarationsIexportedDeclarations :: (Declarations)
            _declarationsIfunImps_collect :: ([Request_FunImply])
            _declarationsIgenericAbstractions_collect :: (FMap Name Kind)
            _declarationsIkinames :: (KSubst)
            _declarationsIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _declarationsIkind_errors :: ([GHError])
            _declarationsIkindvar :: (Int)
            _declarationsIksubst :: (KSubst)
            _declarationsIlabels_collect :: (FMap Name Names)
            _declarationsImethods_collect :: (FMap Name Names)
            _declarationsIoutput :: ([PP.Doc])
            _declarationsIoutputi :: ([PP.Doc])
            _declarationsIpresignatures_collect :: (PreSignatures)
            _declarationsIrawRequests_collect :: ([RawRequest])
            _declarationsIself :: (Declarations)
            _declarationsIstaticErrors :: ([GHError])
            _declarationsIstructureTypes_collect :: (FMap Name LambdaType)
            _declarationsItypeImps_collect :: ([Request_TypeImply])
            _declarationsOabstractTypes_collect :: (Set Name)
            _declarationsObimapImps_collect :: ([Request_BimapImply])
            _declarationsOclassname :: (Maybe Name)
            _declarationsOconstructors_collect :: (FMap Name Names)
            _declarationsOconstructors_dist :: (FMap Name Names)
            _declarationsOcurrentModule :: (Strings)
            _declarationsOdependencies :: (FMap Name [(Name,Name)])
            _declarationsOexportedStructures :: (Set Name)
            _declarationsOexportedTypes :: (Set Name)
            _declarationsOexportedValues :: (Set Name)
            _declarationsOfunImps_collect :: ([Request_FunImply])
            _declarationsOgenericAbstractions :: (FMap Name Kind)
            _declarationsOgenericAbstractions_collect :: (FMap Name Kind)
            _declarationsOghc :: (Bool)
            _declarationsOimportedModule :: (Bool)
            _declarationsOinstancename :: (Maybe Name)
            _declarationsOkinames :: (KSubst)
            _declarationsOkindIndexedTypes :: (FMap Name KindIndexedType)
            _declarationsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _declarationsOkinds :: (KSubst)
            _declarationsOkindvar :: (Int)
            _declarationsOksubst :: (KSubst)
            _declarationsOlabels_collect :: (FMap Name Names)
            _declarationsOlabels_dist :: (FMap Name Names)
            _declarationsOlocal :: (Bool)
            _declarationsOmethods_collect :: (FMap Name Names)
            _declarationsOmethods_dist :: (FMap Name Names)
            _declarationsOmodules :: (Set Strings)
            _declarationsOoptimizer :: (Bool)
            _declarationsOoptimizerPrelude :: (Declarations)
            _declarationsOoutput :: ([PP.Doc])
            _declarationsOprekind :: (KSubst)
            _declarationsOprelude :: (Bool)
            _declarationsOpresignatures :: (PreSignatures)
            _declarationsOpresignatures_collect :: (PreSignatures)
            _declarationsOrawRequests_collect :: ([RawRequest])
            _declarationsOsignatures :: (Signatures)
            _declarationsOstructureTypes_collect :: (FMap Name LambdaType)
            _declarationsOtoplevel :: (Bool)
            _declarationsOtypeImps_collect :: ([Request_TypeImply])
            _declarationsOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _importdeclarationsIconstructors_collect
             ,_importdeclarationsIgenericAbstractions_collect
             ,_importdeclarationsIkinames
             ,_importdeclarationsIkindIndexedTypes_collect
             ,_importdeclarationsIkind_errors
             ,_importdeclarationsIkindvar
             ,_importdeclarationsIksubst
             ,_importdeclarationsIlabels_collect
             ,_importdeclarationsImethods_collect
             ,_importdeclarationsIoutput
             ,_importdeclarationsIoutputi
             ,_importdeclarationsIpresignatures_collect
             ,_importdeclarationsIself
             ) =
                (importdeclarations_ (_importdeclarationsOclassname)
                                     (_importdeclarationsOconstructors_collect)
                                     (_importdeclarationsOconstructors_dist)
                                     (_importdeclarationsOcurrentModule)
                                     (_importdeclarationsOgenericAbstractions)
                                     (_importdeclarationsOgenericAbstractions_collect)
                                     (_importdeclarationsOghc)
                                     (_importdeclarationsOimportedModule)
                                     (_importdeclarationsOinstancename)
                                     (_importdeclarationsOkinames)
                                     (_importdeclarationsOkindIndexedTypes)
                                     (_importdeclarationsOkindIndexedTypes_collect)
                                     (_importdeclarationsOkinds)
                                     (_importdeclarationsOkindvar)
                                     (_importdeclarationsOksubst)
                                     (_importdeclarationsOlabels_collect)
                                     (_importdeclarationsOlabels_dist)
                                     (_importdeclarationsOlocal)
                                     (_importdeclarationsOmethods_collect)
                                     (_importdeclarationsOmethods_dist)
                                     (_importdeclarationsOmodules)
                                     (_importdeclarationsOoptimizer)
                                     (_importdeclarationsOoptimizerPrelude)
                                     (_importdeclarationsOoutput)
                                     (_importdeclarationsOprekind)
                                     (_importdeclarationsOprelude)
                                     (_importdeclarationsOpresignatures)
                                     (_importdeclarationsOpresignatures_collect)
                                     (_importdeclarationsOsignatures)
                                     (_importdeclarationsOtoplevel)
                                     (_importdeclarationsOverbosity))
            ( _declarationsIabstractTypes_collect
             ,_declarationsIbimapImps_collect
             ,_declarationsIconstructors_collect
             ,_declarationsIdepConstraints_collect
             ,_declarationsIdepConstraints_defined
             ,_declarationsIexportedDeclarations
             ,_declarationsIfunImps_collect
             ,_declarationsIgenericAbstractions_collect
             ,_declarationsIkinames
             ,_declarationsIkindIndexedTypes_collect
             ,_declarationsIkind_errors
             ,_declarationsIkindvar
             ,_declarationsIksubst
             ,_declarationsIlabels_collect
             ,_declarationsImethods_collect
             ,_declarationsIoutput
             ,_declarationsIoutputi
             ,_declarationsIpresignatures_collect
             ,_declarationsIrawRequests_collect
             ,_declarationsIself
             ,_declarationsIstaticErrors
             ,_declarationsIstructureTypes_collect
             ,_declarationsItypeImps_collect
             ) =
                (declarations_ (_declarationsOabstractTypes_collect)
                               (_declarationsObimapImps_collect)
                               (_declarationsOclassname)
                               (_declarationsOconstructors_collect)
                               (_declarationsOconstructors_dist)
                               (_declarationsOcurrentModule)
                               (_declarationsOdependencies)
                               (_declarationsOexportedStructures)
                               (_declarationsOexportedTypes)
                               (_declarationsOexportedValues)
                               (_declarationsOfunImps_collect)
                               (_declarationsOgenericAbstractions)
                               (_declarationsOgenericAbstractions_collect)
                               (_declarationsOghc)
                               (_declarationsOimportedModule)
                               (_declarationsOinstancename)
                               (_declarationsOkinames)
                               (_declarationsOkindIndexedTypes)
                               (_declarationsOkindIndexedTypes_collect)
                               (_declarationsOkinds)
                               (_declarationsOkindvar)
                               (_declarationsOksubst)
                               (_declarationsOlabels_collect)
                               (_declarationsOlabels_dist)
                               (_declarationsOlocal)
                               (_declarationsOmethods_collect)
                               (_declarationsOmethods_dist)
                               (_declarationsOmodules)
                               (_declarationsOoptimizer)
                               (_declarationsOoptimizerPrelude)
                               (_declarationsOoutput)
                               (_declarationsOprekind)
                               (_declarationsOprelude)
                               (_declarationsOpresignatures)
                               (_declarationsOpresignatures_collect)
                               (_declarationsOrawRequests_collect)
                               (_declarationsOsignatures)
                               (_declarationsOstructureTypes_collect)
                               (_declarationsOtoplevel)
                               (_declarationsOtypeImps_collect)
                               (_declarationsOverbosity))
            -- "./OutputI.inc.lag"(line 92, column 9)
            (_lhsOoutputi@_) =
                [PP.ppComment " \nimports\n "
                ,PP.text ""
                ]
                ++ _importdeclarationsIoutputi ++
                [PP.text ""
                ,PP.ppComment " \ninterface\n "
                ,PP.text ""
                ]
                ++ _declarationsIoutputi
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _declarationsIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _importdeclarationsIkind_errors ++ _declarationsIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _declarationsIstaticErrors
            -- self rule
            (_self@_) =
                Body_Body _rangeIself _importdeclarationsIself _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _declarationsIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _declarationsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _declarationsIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _declarationsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _declarationsIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _declarationsIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _declarationsIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _declarationsIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _declarationsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _declarationsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _declarationsImethods_collect
            -- copy rule (up)
            (_lhsOoutput@_) =
                _declarationsIoutput
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _declarationsIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _declarationsIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _declarationsIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _declarationsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_importdeclarationsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_importdeclarationsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_importdeclarationsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_importdeclarationsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_importdeclarationsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_importdeclarationsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_importdeclarationsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_importdeclarationsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_importdeclarationsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_importdeclarationsOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_importdeclarationsOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_importdeclarationsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_importdeclarationsOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_importdeclarationsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_importdeclarationsOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_importdeclarationsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_importdeclarationsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_importdeclarationsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_importdeclarationsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_importdeclarationsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_importdeclarationsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_importdeclarationsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_importdeclarationsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_importdeclarationsOoutput@_) =
                _lhsIoutput
            -- copy rule (down)
            (_importdeclarationsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_importdeclarationsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_importdeclarationsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_importdeclarationsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_importdeclarationsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_importdeclarationsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_importdeclarationsOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_declarationsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_declarationsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_declarationsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_declarationsOconstructors_collect@_) =
                _importdeclarationsIconstructors_collect
            -- copy rule (down)
            (_declarationsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_declarationsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_declarationsOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_declarationsOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_declarationsOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_declarationsOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_declarationsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_declarationsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_declarationsOgenericAbstractions_collect@_) =
                _importdeclarationsIgenericAbstractions_collect
            -- copy rule (down)
            (_declarationsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_declarationsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_declarationsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_declarationsOkinames@_) =
                _importdeclarationsIkinames
            -- copy rule (down)
            (_declarationsOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (chain)
            (_declarationsOkindIndexedTypes_collect@_) =
                _importdeclarationsIkindIndexedTypes_collect
            -- copy rule (down)
            (_declarationsOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_declarationsOkindvar@_) =
                _importdeclarationsIkindvar
            -- copy rule (chain)
            (_declarationsOksubst@_) =
                _importdeclarationsIksubst
            -- copy rule (chain)
            (_declarationsOlabels_collect@_) =
                _importdeclarationsIlabels_collect
            -- copy rule (down)
            (_declarationsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_declarationsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_declarationsOmethods_collect@_) =
                _importdeclarationsImethods_collect
            -- copy rule (down)
            (_declarationsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_declarationsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_declarationsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_declarationsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (chain)
            (_declarationsOoutput@_) =
                _importdeclarationsIoutput
            -- copy rule (down)
            (_declarationsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_declarationsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_declarationsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_declarationsOpresignatures_collect@_) =
                _importdeclarationsIpresignatures_collect
            -- copy rule (down)
            (_declarationsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_declarationsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_declarationsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_declarationsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_declarationsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_declarationsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect
             ,_lhsObimapImps_collect
             ,_lhsOconstructors_collect
             ,_lhsOdepConstraints_collect
             ,_lhsOfunImps_collect
             ,_lhsOgenericAbstractions_collect
             ,_lhsOkinames
             ,_lhsOkindIndexedTypes_collect
             ,_lhsOkind_errors
             ,_lhsOkindvar
             ,_lhsOksubst
             ,_lhsOlabels_collect
             ,_lhsOmethods_collect
             ,_lhsOoutput
             ,_lhsOoutputi
             ,_lhsOpresignatures_collect
             ,_lhsOrawRequests_collect
             ,_lhsOself
             ,_lhsOstaticErrors
             ,_lhsOstructureTypes_collect
             ,_lhsOtypeImps_collect
             )
-- Constructor -------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      rawRequests_collect  : [RawRequest]
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      consname             : Name
      constructors         : Names
      depConstraints_collect : [DepConstraint]
      kind_errors          : [GHError]
      labels               : Names
      self                 : SELF
      staticErrors         : [GHError]
      typeImps             : [Type]

-}
{-
   local variables for Constructor.Constructor:
      typeImps
      imply_ConCase
      imply_UnitOrProd
      self

-}
{-
   local variables for Constructor.Infix:
      typeImps
      imply_ConCase
      imply_UnitOrProd
      self

-}
{-
   local variables for Constructor.Record:
      typeImps
      imply_ConCase
      imply_UnitOrProd
      imply_Label
      self

-}
-- semantic domain
type T_Constructor = (Set Name) ->
                     ([Request_BimapImply]) ->
                     (Maybe Name) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Strings) ->
                     (FMap Name [(Name,Name)]) ->
                     ([Request_FunImply]) ->
                     (FMap Name Kind) ->
                     (FMap Name Kind) ->
                     (Bool) ->
                     (Bool) ->
                     (Maybe Name) ->
                     (KSubst) ->
                     (KSubst) ->
                     (Int) ->
                     (KSubst) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Bool) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Set Strings) ->
                     (Bool) ->
                     (Declarations) ->
                     (KSubst) ->
                     (Bool) ->
                     ([RawRequest]) ->
                     (Bool) ->
                     ([Request_TypeImply]) ->
                     (Int) ->
                     ( (Set Name),([Request_BimapImply]),(Name),(Names),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),([GHError]),(Int),(KSubst),(Names),(FMap Name Names),(FMap Name Names),([RawRequest]),(Constructor),([GHError]),([Type]),([Request_TypeImply]))
-- cata
sem_Constructor :: (Constructor) ->
                   (T_Constructor)
sem_Constructor ((Constructor_Constructor (_range) (_constructor) (_types))) =
    (sem_Constructor_Constructor ((sem_Range (_range))) ((sem_Name (_constructor))) ((sem_AnnotatedTypes (_types))))
sem_Constructor ((Constructor_Infix (_range) (_leftType) (_constructorOperator) (_rightType))) =
    (sem_Constructor_Infix ((sem_Range (_range))) ((sem_AnnotatedType (_leftType))) ((sem_Name (_constructorOperator))) ((sem_AnnotatedType (_rightType))))
sem_Constructor ((Constructor_Record (_range) (_constructor) (_fieldDeclarations))) =
    (sem_Constructor_Record ((sem_Range (_range))) ((sem_Name (_constructor))) ((sem_FieldDeclarations (_fieldDeclarations))))
sem_Constructor_Constructor :: (T_Range) ->
                               (T_Name) ->
                               (T_AnnotatedTypes) ->
                               (T_Constructor)
sem_Constructor_Constructor (range_) (constructor_) (types_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconsname :: (Name)
            _lhsOconstructors :: (Names)
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels :: (Names)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Constructor)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps :: ([Type])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _constructorIconstructors_collect :: (FMap Name Names)
            _constructorIgenericAbstractions_collect :: (FMap Name Kind)
            _constructorIlabels_collect :: (FMap Name Names)
            _constructorImethods_collect :: (FMap Name Names)
            _constructorIself :: (Name)
            _constructorOclassname :: (Maybe Name)
            _constructorOconstructors_collect :: (FMap Name Names)
            _constructorOconstructors_dist :: (FMap Name Names)
            _constructorOcurrentModule :: (Strings)
            _constructorOgenericAbstractions :: (FMap Name Kind)
            _constructorOgenericAbstractions_collect :: (FMap Name Kind)
            _constructorOghc :: (Bool)
            _constructorOimportedModule :: (Bool)
            _constructorOinstancename :: (Maybe Name)
            _constructorOlabels_collect :: (FMap Name Names)
            _constructorOlabels_dist :: (FMap Name Names)
            _constructorOlocal :: (Bool)
            _constructorOmethods_collect :: (FMap Name Names)
            _constructorOmethods_dist :: (FMap Name Names)
            _constructorOmodules :: (Set Strings)
            _constructorOoptimizer :: (Bool)
            _constructorOoptimizerPrelude :: (Declarations)
            _constructorOprelude :: (Bool)
            _constructorOtoplevel :: (Bool)
            _constructorOverbosity :: (Int)
            _typesIabstractTypes_collect :: (Set Name)
            _typesIbimapImps_collect :: ([Request_BimapImply])
            _typesIconstructors_collect :: (FMap Name Names)
            _typesIdepConstraints_collect :: ([DepConstraint])
            _typesIfunImps_collect :: ([Request_FunImply])
            _typesIgenericAbstractions_collect :: (FMap Name Kind)
            _typesIkinames :: (KSubst)
            _typesIkind_errors :: ([GHError])
            _typesIkindvar :: (Int)
            _typesIksubst :: (KSubst)
            _typesIlabels_collect :: (FMap Name Names)
            _typesImethods_collect :: (FMap Name Names)
            _typesIrawRequests_collect :: ([RawRequest])
            _typesIself :: (AnnotatedTypes)
            _typesIstaticErrors :: ([GHError])
            _typesItypeImps :: ([Type])
            _typesItypeImps_collect :: ([Request_TypeImply])
            _typesOabstractTypes_collect :: (Set Name)
            _typesObimapImps_collect :: ([Request_BimapImply])
            _typesOclassname :: (Maybe Name)
            _typesOconstructors_collect :: (FMap Name Names)
            _typesOconstructors_dist :: (FMap Name Names)
            _typesOcurrentModule :: (Strings)
            _typesOdependencies :: (FMap Name [(Name,Name)])
            _typesOfunImps_collect :: ([Request_FunImply])
            _typesOgenericAbstractions :: (FMap Name Kind)
            _typesOgenericAbstractions_collect :: (FMap Name Kind)
            _typesOghc :: (Bool)
            _typesOimportedModule :: (Bool)
            _typesOinstancename :: (Maybe Name)
            _typesOkinames :: (KSubst)
            _typesOkinds :: (KSubst)
            _typesOkindvar :: (Int)
            _typesOklabels :: (Names)
            _typesOkname :: (Name)
            _typesOksubst :: (KSubst)
            _typesOlabels_collect :: (FMap Name Names)
            _typesOlabels_dist :: (FMap Name Names)
            _typesOlocal :: (Bool)
            _typesOmethods_collect :: (FMap Name Names)
            _typesOmethods_dist :: (FMap Name Names)
            _typesOmodules :: (Set Strings)
            _typesOoptimizer :: (Bool)
            _typesOoptimizerPrelude :: (Declarations)
            _typesOprekind :: (KSubst)
            _typesOprelude :: (Bool)
            _typesOrawRequests_collect :: ([RawRequest])
            _typesOtoplevel :: (Bool)
            _typesOtypeImps_collect :: ([Request_TypeImply])
            _typesOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _constructorIconstructors_collect,_constructorIgenericAbstractions_collect,_constructorIlabels_collect,_constructorImethods_collect,_constructorIself) =
                (constructor_ (_constructorOclassname)
                              (_constructorOconstructors_collect)
                              (_constructorOconstructors_dist)
                              (_constructorOcurrentModule)
                              (_constructorOgenericAbstractions)
                              (_constructorOgenericAbstractions_collect)
                              (_constructorOghc)
                              (_constructorOimportedModule)
                              (_constructorOinstancename)
                              (_constructorOlabels_collect)
                              (_constructorOlabels_dist)
                              (_constructorOlocal)
                              (_constructorOmethods_collect)
                              (_constructorOmethods_dist)
                              (_constructorOmodules)
                              (_constructorOoptimizer)
                              (_constructorOoptimizerPrelude)
                              (_constructorOprelude)
                              (_constructorOtoplevel)
                              (_constructorOverbosity))
            ( _typesIabstractTypes_collect,_typesIbimapImps_collect,_typesIconstructors_collect,_typesIdepConstraints_collect,_typesIfunImps_collect,_typesIgenericAbstractions_collect,_typesIkinames,_typesIkind_errors,_typesIkindvar,_typesIksubst,_typesIlabels_collect,_typesImethods_collect,_typesIrawRequests_collect,_typesIself,_typesIstaticErrors,_typesItypeImps,_typesItypeImps_collect) =
                (types_ (_typesOabstractTypes_collect)
                        (_typesObimapImps_collect)
                        (_typesOclassname)
                        (_typesOconstructors_collect)
                        (_typesOconstructors_dist)
                        (_typesOcurrentModule)
                        (_typesOdependencies)
                        (_typesOfunImps_collect)
                        (_typesOgenericAbstractions)
                        (_typesOgenericAbstractions_collect)
                        (_typesOghc)
                        (_typesOimportedModule)
                        (_typesOinstancename)
                        (_typesOkinames)
                        (_typesOkinds)
                        (_typesOkindvar)
                        (_typesOklabels)
                        (_typesOkname)
                        (_typesOksubst)
                        (_typesOlabels_collect)
                        (_typesOlabels_dist)
                        (_typesOlocal)
                        (_typesOmethods_collect)
                        (_typesOmethods_dist)
                        (_typesOmodules)
                        (_typesOoptimizer)
                        (_typesOoptimizerPrelude)
                        (_typesOprekind)
                        (_typesOprelude)
                        (_typesOrawRequests_collect)
                        (_typesOtoplevel)
                        (_typesOtypeImps_collect)
                        (_typesOverbosity))
            -- "./ModuleInformation.inc.lag"(line 360, column 9)
            (_lhsOconstructors@_) =
                [_constructorIself]
            -- "./Kind.inc.lag"(line 155, column 9)
            (_lhsOconsname@_) =
                concaseName _constructorIself
            -- "./Kind.inc.lag"(line 543, column 9)
            (_typesOklabels@_) =
                []
            -- "./Kind.inc.lag"(line 542, column 9)
            (_typesOkname@_) =
                _constructorIself
            -- "./Request.inc.lag"(line 218, column 9)
            (_typeImps@_) =
                _imply_UnitOrProd ++ _imply_ConCase
                  ++ _typesItypeImps
            -- "./Request.inc.lag"(line 216, column 9)
            (_imply_ConCase@_) =
                [concaseT _constructorIself]
            -- "./Request.inc.lag"(line 210, column 9)
            (_imply_UnitOrProd@_) =
                if null _typesIself then
                  [Types.conT unitName]
                else if length _typesIself > 1 then
                  [Types.conT prodName]
                else
                  []
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _typesIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _typesIkind_errors
            -- use rule
            (_lhsOlabels@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                _typesIstaticErrors
            -- use rule
            (_lhsOtypeImps@_) =
                _typeImps
            -- self rule
            (_self@_) =
                Constructor_Constructor _rangeIself _constructorIself _typesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _typesIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _typesIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typesIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _typesIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _typesIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _typesIkinames
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _typesIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _typesIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typesIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typesImethods_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _typesIrawRequests_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _typesItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_constructorOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_constructorOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_constructorOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_constructorOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_constructorOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_constructorOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_constructorOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_constructorOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_constructorOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_constructorOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_constructorOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_constructorOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_constructorOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_constructorOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_constructorOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_constructorOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_constructorOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_constructorOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_constructorOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_constructorOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_typesOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_typesObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_typesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typesOconstructors_collect@_) =
                _constructorIconstructors_collect
            -- copy rule (down)
            (_typesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typesOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_typesOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_typesOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_typesOgenericAbstractions_collect@_) =
                _constructorIgenericAbstractions_collect
            -- copy rule (down)
            (_typesOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_typesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typesOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_typesOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_typesOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_typesOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_typesOlabels_collect@_) =
                _constructorIlabels_collect
            -- copy rule (down)
            (_typesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typesOmethods_collect@_) =
                _constructorImethods_collect
            -- copy rule (down)
            (_typesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typesOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_typesOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_typesOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_typesOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_typesOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_typesOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_typesOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typesOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_typesOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconsname,_lhsOconstructors,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps,_lhsOtypeImps_collect)
sem_Constructor_Infix :: (T_Range) ->
                         (T_AnnotatedType) ->
                         (T_Name) ->
                         (T_AnnotatedType) ->
                         (T_Constructor)
sem_Constructor_Infix (range_) (leftType_) (constructorOperator_) (rightType_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconsname :: (Name)
            _lhsOconstructors :: (Names)
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels :: (Names)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Constructor)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps :: ([Type])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _leftTypeIabstractTypes_collect :: (Set Name)
            _leftTypeIbimapImps_collect :: ([Request_BimapImply])
            _leftTypeIconstructors_collect :: (FMap Name Names)
            _leftTypeIdepConstraints_collect :: ([DepConstraint])
            _leftTypeIfunImps_collect :: ([Request_FunImply])
            _leftTypeIgenericAbstractions_collect :: (FMap Name Kind)
            _leftTypeIkinames :: (KSubst)
            _leftTypeIkind_errors :: ([GHError])
            _leftTypeIkindvar :: (Int)
            _leftTypeIksubst :: (KSubst)
            _leftTypeIlabels_collect :: (FMap Name Names)
            _leftTypeImethods_collect :: (FMap Name Names)
            _leftTypeIrawRequests_collect :: ([RawRequest])
            _leftTypeIself :: (AnnotatedType)
            _leftTypeIstaticErrors :: ([GHError])
            _leftTypeItypeImps :: ([Type])
            _leftTypeItypeImps_collect :: ([Request_TypeImply])
            _leftTypeOabstractTypes_collect :: (Set Name)
            _leftTypeObimapImps_collect :: ([Request_BimapImply])
            _leftTypeOclassname :: (Maybe Name)
            _leftTypeOconstructors_collect :: (FMap Name Names)
            _leftTypeOconstructors_dist :: (FMap Name Names)
            _leftTypeOcurrentModule :: (Strings)
            _leftTypeOdependencies :: (FMap Name [(Name,Name)])
            _leftTypeOfunImps_collect :: ([Request_FunImply])
            _leftTypeOgenericAbstractions :: (FMap Name Kind)
            _leftTypeOgenericAbstractions_collect :: (FMap Name Kind)
            _leftTypeOghc :: (Bool)
            _leftTypeOimportedModule :: (Bool)
            _leftTypeOinstancename :: (Maybe Name)
            _leftTypeOkinames :: (KSubst)
            _leftTypeOkinds :: (KSubst)
            _leftTypeOkindvar :: (Int)
            _leftTypeOklabels :: (Names)
            _leftTypeOkname :: (Name)
            _leftTypeOksubst :: (KSubst)
            _leftTypeOlabels_collect :: (FMap Name Names)
            _leftTypeOlabels_dist :: (FMap Name Names)
            _leftTypeOlocal :: (Bool)
            _leftTypeOmethods_collect :: (FMap Name Names)
            _leftTypeOmethods_dist :: (FMap Name Names)
            _leftTypeOmodules :: (Set Strings)
            _leftTypeOoptimizer :: (Bool)
            _leftTypeOoptimizerPrelude :: (Declarations)
            _leftTypeOprekind :: (KSubst)
            _leftTypeOprelude :: (Bool)
            _leftTypeOrawRequests_collect :: ([RawRequest])
            _leftTypeOtoplevel :: (Bool)
            _leftTypeOtypeImps_collect :: ([Request_TypeImply])
            _leftTypeOverbosity :: (Int)
            _constructorOperatorIconstructors_collect :: (FMap Name Names)
            _constructorOperatorIgenericAbstractions_collect :: (FMap Name Kind)
            _constructorOperatorIlabels_collect :: (FMap Name Names)
            _constructorOperatorImethods_collect :: (FMap Name Names)
            _constructorOperatorIself :: (Name)
            _constructorOperatorOclassname :: (Maybe Name)
            _constructorOperatorOconstructors_collect :: (FMap Name Names)
            _constructorOperatorOconstructors_dist :: (FMap Name Names)
            _constructorOperatorOcurrentModule :: (Strings)
            _constructorOperatorOgenericAbstractions :: (FMap Name Kind)
            _constructorOperatorOgenericAbstractions_collect :: (FMap Name Kind)
            _constructorOperatorOghc :: (Bool)
            _constructorOperatorOimportedModule :: (Bool)
            _constructorOperatorOinstancename :: (Maybe Name)
            _constructorOperatorOlabels_collect :: (FMap Name Names)
            _constructorOperatorOlabels_dist :: (FMap Name Names)
            _constructorOperatorOlocal :: (Bool)
            _constructorOperatorOmethods_collect :: (FMap Name Names)
            _constructorOperatorOmethods_dist :: (FMap Name Names)
            _constructorOperatorOmodules :: (Set Strings)
            _constructorOperatorOoptimizer :: (Bool)
            _constructorOperatorOoptimizerPrelude :: (Declarations)
            _constructorOperatorOprelude :: (Bool)
            _constructorOperatorOtoplevel :: (Bool)
            _constructorOperatorOverbosity :: (Int)
            _rightTypeIabstractTypes_collect :: (Set Name)
            _rightTypeIbimapImps_collect :: ([Request_BimapImply])
            _rightTypeIconstructors_collect :: (FMap Name Names)
            _rightTypeIdepConstraints_collect :: ([DepConstraint])
            _rightTypeIfunImps_collect :: ([Request_FunImply])
            _rightTypeIgenericAbstractions_collect :: (FMap Name Kind)
            _rightTypeIkinames :: (KSubst)
            _rightTypeIkind_errors :: ([GHError])
            _rightTypeIkindvar :: (Int)
            _rightTypeIksubst :: (KSubst)
            _rightTypeIlabels_collect :: (FMap Name Names)
            _rightTypeImethods_collect :: (FMap Name Names)
            _rightTypeIrawRequests_collect :: ([RawRequest])
            _rightTypeIself :: (AnnotatedType)
            _rightTypeIstaticErrors :: ([GHError])
            _rightTypeItypeImps :: ([Type])
            _rightTypeItypeImps_collect :: ([Request_TypeImply])
            _rightTypeOabstractTypes_collect :: (Set Name)
            _rightTypeObimapImps_collect :: ([Request_BimapImply])
            _rightTypeOclassname :: (Maybe Name)
            _rightTypeOconstructors_collect :: (FMap Name Names)
            _rightTypeOconstructors_dist :: (FMap Name Names)
            _rightTypeOcurrentModule :: (Strings)
            _rightTypeOdependencies :: (FMap Name [(Name,Name)])
            _rightTypeOfunImps_collect :: ([Request_FunImply])
            _rightTypeOgenericAbstractions :: (FMap Name Kind)
            _rightTypeOgenericAbstractions_collect :: (FMap Name Kind)
            _rightTypeOghc :: (Bool)
            _rightTypeOimportedModule :: (Bool)
            _rightTypeOinstancename :: (Maybe Name)
            _rightTypeOkinames :: (KSubst)
            _rightTypeOkinds :: (KSubst)
            _rightTypeOkindvar :: (Int)
            _rightTypeOklabels :: (Names)
            _rightTypeOkname :: (Name)
            _rightTypeOksubst :: (KSubst)
            _rightTypeOlabels_collect :: (FMap Name Names)
            _rightTypeOlabels_dist :: (FMap Name Names)
            _rightTypeOlocal :: (Bool)
            _rightTypeOmethods_collect :: (FMap Name Names)
            _rightTypeOmethods_dist :: (FMap Name Names)
            _rightTypeOmodules :: (Set Strings)
            _rightTypeOoptimizer :: (Bool)
            _rightTypeOoptimizerPrelude :: (Declarations)
            _rightTypeOprekind :: (KSubst)
            _rightTypeOprelude :: (Bool)
            _rightTypeOrawRequests_collect :: ([RawRequest])
            _rightTypeOtoplevel :: (Bool)
            _rightTypeOtypeImps_collect :: ([Request_TypeImply])
            _rightTypeOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _leftTypeIabstractTypes_collect,_leftTypeIbimapImps_collect,_leftTypeIconstructors_collect,_leftTypeIdepConstraints_collect,_leftTypeIfunImps_collect,_leftTypeIgenericAbstractions_collect,_leftTypeIkinames,_leftTypeIkind_errors,_leftTypeIkindvar,_leftTypeIksubst,_leftTypeIlabels_collect,_leftTypeImethods_collect,_leftTypeIrawRequests_collect,_leftTypeIself,_leftTypeIstaticErrors,_leftTypeItypeImps,_leftTypeItypeImps_collect) =
                (leftType_ (_leftTypeOabstractTypes_collect)
                           (_leftTypeObimapImps_collect)
                           (_leftTypeOclassname)
                           (_leftTypeOconstructors_collect)
                           (_leftTypeOconstructors_dist)
                           (_leftTypeOcurrentModule)
                           (_leftTypeOdependencies)
                           (_leftTypeOfunImps_collect)
                           (_leftTypeOgenericAbstractions)
                           (_leftTypeOgenericAbstractions_collect)
                           (_leftTypeOghc)
                           (_leftTypeOimportedModule)
                           (_leftTypeOinstancename)
                           (_leftTypeOkinames)
                           (_leftTypeOkinds)
                           (_leftTypeOkindvar)
                           (_leftTypeOklabels)
                           (_leftTypeOkname)
                           (_leftTypeOksubst)
                           (_leftTypeOlabels_collect)
                           (_leftTypeOlabels_dist)
                           (_leftTypeOlocal)
                           (_leftTypeOmethods_collect)
                           (_leftTypeOmethods_dist)
                           (_leftTypeOmodules)
                           (_leftTypeOoptimizer)
                           (_leftTypeOoptimizerPrelude)
                           (_leftTypeOprekind)
                           (_leftTypeOprelude)
                           (_leftTypeOrawRequests_collect)
                           (_leftTypeOtoplevel)
                           (_leftTypeOtypeImps_collect)
                           (_leftTypeOverbosity))
            ( _constructorOperatorIconstructors_collect,_constructorOperatorIgenericAbstractions_collect,_constructorOperatorIlabels_collect,_constructorOperatorImethods_collect,_constructorOperatorIself) =
                (constructorOperator_ (_constructorOperatorOclassname)
                                      (_constructorOperatorOconstructors_collect)
                                      (_constructorOperatorOconstructors_dist)
                                      (_constructorOperatorOcurrentModule)
                                      (_constructorOperatorOgenericAbstractions)
                                      (_constructorOperatorOgenericAbstractions_collect)
                                      (_constructorOperatorOghc)
                                      (_constructorOperatorOimportedModule)
                                      (_constructorOperatorOinstancename)
                                      (_constructorOperatorOlabels_collect)
                                      (_constructorOperatorOlabels_dist)
                                      (_constructorOperatorOlocal)
                                      (_constructorOperatorOmethods_collect)
                                      (_constructorOperatorOmethods_dist)
                                      (_constructorOperatorOmodules)
                                      (_constructorOperatorOoptimizer)
                                      (_constructorOperatorOoptimizerPrelude)
                                      (_constructorOperatorOprelude)
                                      (_constructorOperatorOtoplevel)
                                      (_constructorOperatorOverbosity))
            ( _rightTypeIabstractTypes_collect
             ,_rightTypeIbimapImps_collect
             ,_rightTypeIconstructors_collect
             ,_rightTypeIdepConstraints_collect
             ,_rightTypeIfunImps_collect
             ,_rightTypeIgenericAbstractions_collect
             ,_rightTypeIkinames
             ,_rightTypeIkind_errors
             ,_rightTypeIkindvar
             ,_rightTypeIksubst
             ,_rightTypeIlabels_collect
             ,_rightTypeImethods_collect
             ,_rightTypeIrawRequests_collect
             ,_rightTypeIself
             ,_rightTypeIstaticErrors
             ,_rightTypeItypeImps
             ,_rightTypeItypeImps_collect
             ) =
                (rightType_ (_rightTypeOabstractTypes_collect)
                            (_rightTypeObimapImps_collect)
                            (_rightTypeOclassname)
                            (_rightTypeOconstructors_collect)
                            (_rightTypeOconstructors_dist)
                            (_rightTypeOcurrentModule)
                            (_rightTypeOdependencies)
                            (_rightTypeOfunImps_collect)
                            (_rightTypeOgenericAbstractions)
                            (_rightTypeOgenericAbstractions_collect)
                            (_rightTypeOghc)
                            (_rightTypeOimportedModule)
                            (_rightTypeOinstancename)
                            (_rightTypeOkinames)
                            (_rightTypeOkinds)
                            (_rightTypeOkindvar)
                            (_rightTypeOklabels)
                            (_rightTypeOkname)
                            (_rightTypeOksubst)
                            (_rightTypeOlabels_collect)
                            (_rightTypeOlabels_dist)
                            (_rightTypeOlocal)
                            (_rightTypeOmethods_collect)
                            (_rightTypeOmethods_dist)
                            (_rightTypeOmodules)
                            (_rightTypeOoptimizer)
                            (_rightTypeOoptimizerPrelude)
                            (_rightTypeOprekind)
                            (_rightTypeOprelude)
                            (_rightTypeOrawRequests_collect)
                            (_rightTypeOtoplevel)
                            (_rightTypeOtypeImps_collect)
                            (_rightTypeOverbosity))
            -- "./ModuleInformation.inc.lag"(line 362, column 9)
            (_lhsOconstructors@_) =
                [_constructorOperatorIself]
            -- "./Kind.inc.lag"(line 157, column 9)
            (_lhsOconsname@_) =
                concaseName _constructorOperatorIself
            -- "./Kind.inc.lag"(line 548, column 9)
            (_rightTypeOklabels@_) =
                []
            -- "./Kind.inc.lag"(line 547, column 9)
            (_rightTypeOkname@_) =
                _constructorOperatorIself
            -- "./Kind.inc.lag"(line 546, column 9)
            (_leftTypeOklabels@_) =
                []
            -- "./Kind.inc.lag"(line 545, column 9)
            (_leftTypeOkname@_) =
                _constructorOperatorIself
            -- "./Request.inc.lag"(line 225, column 9)
            (_typeImps@_) =
                _imply_UnitOrProd ++ _imply_ConCase
                  ++ _leftTypeItypeImps
                  ++ _rightTypeItypeImps
            -- "./Request.inc.lag"(line 223, column 9)
            (_imply_ConCase@_) =
                [concaseT _constructorOperatorIself]
            -- "./Request.inc.lag"(line 222, column 9)
            (_imply_UnitOrProd@_) =
                [conT prodName]
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _leftTypeIdepConstraints_collect ++ _rightTypeIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _leftTypeIkind_errors ++ _rightTypeIkind_errors
            -- use rule
            (_lhsOlabels@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                _leftTypeIstaticErrors ++ _rightTypeIstaticErrors
            -- use rule
            (_lhsOtypeImps@_) =
                _typeImps
            -- self rule
            (_self@_) =
                Constructor_Infix _rangeIself _leftTypeIself _constructorOperatorIself _rightTypeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _rightTypeIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _rightTypeIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _rightTypeIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _rightTypeIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _rightTypeIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _rightTypeIkinames
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _rightTypeIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _rightTypeIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _rightTypeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _rightTypeImethods_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _rightTypeIrawRequests_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _rightTypeItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_leftTypeOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_leftTypeObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_leftTypeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_leftTypeOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_leftTypeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_leftTypeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_leftTypeOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_leftTypeOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_leftTypeOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_leftTypeOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_leftTypeOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_leftTypeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_leftTypeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_leftTypeOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_leftTypeOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_leftTypeOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_leftTypeOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_leftTypeOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_leftTypeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_leftTypeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_leftTypeOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_leftTypeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_leftTypeOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_leftTypeOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_leftTypeOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_leftTypeOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_leftTypeOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_leftTypeOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_leftTypeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_leftTypeOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_leftTypeOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_constructorOperatorOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_constructorOperatorOconstructors_collect@_) =
                _leftTypeIconstructors_collect
            -- copy rule (down)
            (_constructorOperatorOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_constructorOperatorOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_constructorOperatorOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_constructorOperatorOgenericAbstractions_collect@_) =
                _leftTypeIgenericAbstractions_collect
            -- copy rule (down)
            (_constructorOperatorOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_constructorOperatorOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_constructorOperatorOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_constructorOperatorOlabels_collect@_) =
                _leftTypeIlabels_collect
            -- copy rule (down)
            (_constructorOperatorOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_constructorOperatorOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_constructorOperatorOmethods_collect@_) =
                _leftTypeImethods_collect
            -- copy rule (down)
            (_constructorOperatorOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_constructorOperatorOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_constructorOperatorOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_constructorOperatorOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_constructorOperatorOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_constructorOperatorOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_constructorOperatorOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_rightTypeOabstractTypes_collect@_) =
                _leftTypeIabstractTypes_collect
            -- copy rule (chain)
            (_rightTypeObimapImps_collect@_) =
                _leftTypeIbimapImps_collect
            -- copy rule (down)
            (_rightTypeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_rightTypeOconstructors_collect@_) =
                _constructorOperatorIconstructors_collect
            -- copy rule (down)
            (_rightTypeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_rightTypeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rightTypeOdependencies@_) =
                _lhsIdependencies
            -- copy rule (chain)
            (_rightTypeOfunImps_collect@_) =
                _leftTypeIfunImps_collect
            -- copy rule (down)
            (_rightTypeOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_rightTypeOgenericAbstractions_collect@_) =
                _constructorOperatorIgenericAbstractions_collect
            -- copy rule (down)
            (_rightTypeOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_rightTypeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rightTypeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_rightTypeOkinames@_) =
                _leftTypeIkinames
            -- copy rule (down)
            (_rightTypeOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_rightTypeOkindvar@_) =
                _leftTypeIkindvar
            -- copy rule (chain)
            (_rightTypeOksubst@_) =
                _leftTypeIksubst
            -- copy rule (chain)
            (_rightTypeOlabels_collect@_) =
                _constructorOperatorIlabels_collect
            -- copy rule (down)
            (_rightTypeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_rightTypeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_rightTypeOmethods_collect@_) =
                _constructorOperatorImethods_collect
            -- copy rule (down)
            (_rightTypeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_rightTypeOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_rightTypeOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_rightTypeOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_rightTypeOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_rightTypeOprelude@_) =
                _lhsIprelude
            -- copy rule (chain)
            (_rightTypeOrawRequests_collect@_) =
                _leftTypeIrawRequests_collect
            -- copy rule (down)
            (_rightTypeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_rightTypeOtypeImps_collect@_) =
                _leftTypeItypeImps_collect
            -- copy rule (down)
            (_rightTypeOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconsname,_lhsOconstructors,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps,_lhsOtypeImps_collect)
sem_Constructor_Record :: (T_Range) ->
                          (T_Name) ->
                          (T_FieldDeclarations) ->
                          (T_Constructor)
sem_Constructor_Record (range_) (constructor_) (fieldDeclarations_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconsname :: (Name)
            _lhsOconstructors :: (Names)
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels :: (Names)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Constructor)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps :: ([Type])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _constructorIconstructors_collect :: (FMap Name Names)
            _constructorIgenericAbstractions_collect :: (FMap Name Kind)
            _constructorIlabels_collect :: (FMap Name Names)
            _constructorImethods_collect :: (FMap Name Names)
            _constructorIself :: (Name)
            _constructorOclassname :: (Maybe Name)
            _constructorOconstructors_collect :: (FMap Name Names)
            _constructorOconstructors_dist :: (FMap Name Names)
            _constructorOcurrentModule :: (Strings)
            _constructorOgenericAbstractions :: (FMap Name Kind)
            _constructorOgenericAbstractions_collect :: (FMap Name Kind)
            _constructorOghc :: (Bool)
            _constructorOimportedModule :: (Bool)
            _constructorOinstancename :: (Maybe Name)
            _constructorOlabels_collect :: (FMap Name Names)
            _constructorOlabels_dist :: (FMap Name Names)
            _constructorOlocal :: (Bool)
            _constructorOmethods_collect :: (FMap Name Names)
            _constructorOmethods_dist :: (FMap Name Names)
            _constructorOmodules :: (Set Strings)
            _constructorOoptimizer :: (Bool)
            _constructorOoptimizerPrelude :: (Declarations)
            _constructorOprelude :: (Bool)
            _constructorOtoplevel :: (Bool)
            _constructorOverbosity :: (Int)
            _fieldDeclarationsIabstractTypes_collect :: (Set Name)
            _fieldDeclarationsIbimapImps_collect :: ([Request_BimapImply])
            _fieldDeclarationsIconstructors :: (Names)
            _fieldDeclarationsIconstructors_collect :: (FMap Name Names)
            _fieldDeclarationsIdepConstraints_collect :: ([DepConstraint])
            _fieldDeclarationsIfunImps_collect :: ([Request_FunImply])
            _fieldDeclarationsIgenericAbstractions_collect :: (FMap Name Kind)
            _fieldDeclarationsIkinames :: (KSubst)
            _fieldDeclarationsIkind_errors :: ([GHError])
            _fieldDeclarationsIkindvar :: (Int)
            _fieldDeclarationsIksubst :: (KSubst)
            _fieldDeclarationsIlabels :: (Names)
            _fieldDeclarationsIlabels_collect :: (FMap Name Names)
            _fieldDeclarationsImethods_collect :: (FMap Name Names)
            _fieldDeclarationsIrawRequests_collect :: ([RawRequest])
            _fieldDeclarationsIself :: (FieldDeclarations)
            _fieldDeclarationsIstaticErrors :: ([GHError])
            _fieldDeclarationsItypeImps :: ([Type])
            _fieldDeclarationsItypeImps_collect :: ([Request_TypeImply])
            _fieldDeclarationsOabstractTypes_collect :: (Set Name)
            _fieldDeclarationsObimapImps_collect :: ([Request_BimapImply])
            _fieldDeclarationsOclassname :: (Maybe Name)
            _fieldDeclarationsOconstructors_collect :: (FMap Name Names)
            _fieldDeclarationsOconstructors_dist :: (FMap Name Names)
            _fieldDeclarationsOcurrentModule :: (Strings)
            _fieldDeclarationsOdependencies :: (FMap Name [(Name,Name)])
            _fieldDeclarationsOfunImps_collect :: ([Request_FunImply])
            _fieldDeclarationsOgenericAbstractions :: (FMap Name Kind)
            _fieldDeclarationsOgenericAbstractions_collect :: (FMap Name Kind)
            _fieldDeclarationsOghc :: (Bool)
            _fieldDeclarationsOimportedModule :: (Bool)
            _fieldDeclarationsOinstancename :: (Maybe Name)
            _fieldDeclarationsOkinames :: (KSubst)
            _fieldDeclarationsOkinds :: (KSubst)
            _fieldDeclarationsOkindvar :: (Int)
            _fieldDeclarationsOkname :: (Name)
            _fieldDeclarationsOksubst :: (KSubst)
            _fieldDeclarationsOlabels_collect :: (FMap Name Names)
            _fieldDeclarationsOlabels_dist :: (FMap Name Names)
            _fieldDeclarationsOlocal :: (Bool)
            _fieldDeclarationsOmethods_collect :: (FMap Name Names)
            _fieldDeclarationsOmethods_dist :: (FMap Name Names)
            _fieldDeclarationsOmodules :: (Set Strings)
            _fieldDeclarationsOoptimizer :: (Bool)
            _fieldDeclarationsOoptimizerPrelude :: (Declarations)
            _fieldDeclarationsOprekind :: (KSubst)
            _fieldDeclarationsOprelude :: (Bool)
            _fieldDeclarationsOrawRequests_collect :: ([RawRequest])
            _fieldDeclarationsOtoplevel :: (Bool)
            _fieldDeclarationsOtypeImps_collect :: ([Request_TypeImply])
            _fieldDeclarationsOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _constructorIconstructors_collect,_constructorIgenericAbstractions_collect,_constructorIlabels_collect,_constructorImethods_collect,_constructorIself) =
                (constructor_ (_constructorOclassname)
                              (_constructorOconstructors_collect)
                              (_constructorOconstructors_dist)
                              (_constructorOcurrentModule)
                              (_constructorOgenericAbstractions)
                              (_constructorOgenericAbstractions_collect)
                              (_constructorOghc)
                              (_constructorOimportedModule)
                              (_constructorOinstancename)
                              (_constructorOlabels_collect)
                              (_constructorOlabels_dist)
                              (_constructorOlocal)
                              (_constructorOmethods_collect)
                              (_constructorOmethods_dist)
                              (_constructorOmodules)
                              (_constructorOoptimizer)
                              (_constructorOoptimizerPrelude)
                              (_constructorOprelude)
                              (_constructorOtoplevel)
                              (_constructorOverbosity))
            ( _fieldDeclarationsIabstractTypes_collect
             ,_fieldDeclarationsIbimapImps_collect
             ,_fieldDeclarationsIconstructors
             ,_fieldDeclarationsIconstructors_collect
             ,_fieldDeclarationsIdepConstraints_collect
             ,_fieldDeclarationsIfunImps_collect
             ,_fieldDeclarationsIgenericAbstractions_collect
             ,_fieldDeclarationsIkinames
             ,_fieldDeclarationsIkind_errors
             ,_fieldDeclarationsIkindvar
             ,_fieldDeclarationsIksubst
             ,_fieldDeclarationsIlabels
             ,_fieldDeclarationsIlabels_collect
             ,_fieldDeclarationsImethods_collect
             ,_fieldDeclarationsIrawRequests_collect
             ,_fieldDeclarationsIself
             ,_fieldDeclarationsIstaticErrors
             ,_fieldDeclarationsItypeImps
             ,_fieldDeclarationsItypeImps_collect
             ) =
                (fieldDeclarations_ (_fieldDeclarationsOabstractTypes_collect)
                                    (_fieldDeclarationsObimapImps_collect)
                                    (_fieldDeclarationsOclassname)
                                    (_fieldDeclarationsOconstructors_collect)
                                    (_fieldDeclarationsOconstructors_dist)
                                    (_fieldDeclarationsOcurrentModule)
                                    (_fieldDeclarationsOdependencies)
                                    (_fieldDeclarationsOfunImps_collect)
                                    (_fieldDeclarationsOgenericAbstractions)
                                    (_fieldDeclarationsOgenericAbstractions_collect)
                                    (_fieldDeclarationsOghc)
                                    (_fieldDeclarationsOimportedModule)
                                    (_fieldDeclarationsOinstancename)
                                    (_fieldDeclarationsOkinames)
                                    (_fieldDeclarationsOkinds)
                                    (_fieldDeclarationsOkindvar)
                                    (_fieldDeclarationsOkname)
                                    (_fieldDeclarationsOksubst)
                                    (_fieldDeclarationsOlabels_collect)
                                    (_fieldDeclarationsOlabels_dist)
                                    (_fieldDeclarationsOlocal)
                                    (_fieldDeclarationsOmethods_collect)
                                    (_fieldDeclarationsOmethods_dist)
                                    (_fieldDeclarationsOmodules)
                                    (_fieldDeclarationsOoptimizer)
                                    (_fieldDeclarationsOoptimizerPrelude)
                                    (_fieldDeclarationsOprekind)
                                    (_fieldDeclarationsOprelude)
                                    (_fieldDeclarationsOrawRequests_collect)
                                    (_fieldDeclarationsOtoplevel)
                                    (_fieldDeclarationsOtypeImps_collect)
                                    (_fieldDeclarationsOverbosity))
            -- "./ModuleInformation.inc.lag"(line 364, column 9)
            (_lhsOconstructors@_) =
                [_constructorIself]
            -- "./Kind.inc.lag"(line 159, column 9)
            (_lhsOconsname@_) =
                concaseName _constructorIself
            -- "./Kind.inc.lag"(line 550, column 9)
            (_fieldDeclarationsOkname@_) =
                _constructorIself
            -- "./Request.inc.lag"(line 244, column 9)
            (_typeImps@_) =
                _imply_Label ++ _imply_UnitOrProd
                  ++ _imply_ConCase
                  ++ _fieldDeclarationsItypeImps
            -- "./Request.inc.lag"(line 242, column 9)
            (_imply_ConCase@_) =
                [concaseT _constructorIself]
            -- "./Request.inc.lag"(line 231, column 9)
            (_imply_UnitOrProd@_) =
                if null _fieldDeclarationsIself then
                  [Types.conT unitName]
                else
                  if length
                       _fieldDeclarationsItypeImps > 1 then
                  [Types.conT prodName]
                else
                  []
            -- "./Request.inc.lag"(line 230, column 9)
            (_imply_Label@_) =
                [Types.conT labelName]
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _fieldDeclarationsIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _fieldDeclarationsIkind_errors
            -- use rule
            (_lhsOlabels@_) =
                _fieldDeclarationsIlabels
            -- use rule
            (_lhsOstaticErrors@_) =
                _fieldDeclarationsIstaticErrors
            -- use rule
            (_lhsOtypeImps@_) =
                _typeImps
            -- self rule
            (_self@_) =
                Constructor_Record _rangeIself _constructorIself _fieldDeclarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _fieldDeclarationsIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _fieldDeclarationsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _fieldDeclarationsIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _fieldDeclarationsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _fieldDeclarationsIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _fieldDeclarationsIkinames
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _fieldDeclarationsIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _fieldDeclarationsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _fieldDeclarationsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _fieldDeclarationsImethods_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _fieldDeclarationsIrawRequests_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _fieldDeclarationsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_constructorOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_constructorOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_constructorOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_constructorOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_constructorOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_constructorOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_constructorOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_constructorOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_constructorOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_constructorOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_constructorOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_constructorOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_constructorOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_constructorOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_constructorOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_constructorOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_constructorOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_constructorOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_constructorOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_constructorOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_fieldDeclarationsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_fieldDeclarationsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_fieldDeclarationsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_fieldDeclarationsOconstructors_collect@_) =
                _constructorIconstructors_collect
            -- copy rule (down)
            (_fieldDeclarationsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_fieldDeclarationsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_fieldDeclarationsOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_fieldDeclarationsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_fieldDeclarationsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_fieldDeclarationsOgenericAbstractions_collect@_) =
                _constructorIgenericAbstractions_collect
            -- copy rule (down)
            (_fieldDeclarationsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_fieldDeclarationsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_fieldDeclarationsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_fieldDeclarationsOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_fieldDeclarationsOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_fieldDeclarationsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_fieldDeclarationsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_fieldDeclarationsOlabels_collect@_) =
                _constructorIlabels_collect
            -- copy rule (down)
            (_fieldDeclarationsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_fieldDeclarationsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_fieldDeclarationsOmethods_collect@_) =
                _constructorImethods_collect
            -- copy rule (down)
            (_fieldDeclarationsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_fieldDeclarationsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_fieldDeclarationsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_fieldDeclarationsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_fieldDeclarationsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_fieldDeclarationsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_fieldDeclarationsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_fieldDeclarationsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_fieldDeclarationsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_fieldDeclarationsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconsname,_lhsOconstructors,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps,_lhsOtypeImps_collect)
-- Constructors ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      rawRequests_collect  : [RawRequest]
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      consname             : Names
      constructors         : Names
      depConstraints_collect : [DepConstraint]
      kind_errors          : [GHError]
      labels               : Names
      self                 : SELF
      staticErrors         : [GHError]
      typeImps             : [Type]

-}
{-
   local variables for Constructors.Cons:
      self

-}
{-
   local variables for Constructors.Nil:
      self

-}
-- semantic domain
type T_Constructors = (Set Name) ->
                      ([Request_BimapImply]) ->
                      (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Strings) ->
                      (FMap Name [(Name,Name)]) ->
                      ([Request_FunImply]) ->
                      (FMap Name Kind) ->
                      (FMap Name Kind) ->
                      (Bool) ->
                      (Bool) ->
                      (Maybe Name) ->
                      (KSubst) ->
                      (KSubst) ->
                      (Int) ->
                      (KSubst) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Set Strings) ->
                      (Bool) ->
                      (Declarations) ->
                      (KSubst) ->
                      (Bool) ->
                      ([RawRequest]) ->
                      (Bool) ->
                      ([Request_TypeImply]) ->
                      (Int) ->
                      ( (Set Name),([Request_BimapImply]),(Names),(Names),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),([GHError]),(Int),(KSubst),(Names),(FMap Name Names),(FMap Name Names),([RawRequest]),(Constructors),([GHError]),([Type]),([Request_TypeImply]))
-- cata
sem_Constructors :: (Constructors) ->
                    (T_Constructors)
sem_Constructors (list) =
    (foldr (sem_Constructors_Cons) (sem_Constructors_Nil) ((map sem_Constructor list)))
sem_Constructors_Cons :: (T_Constructor) ->
                         (T_Constructors) ->
                         (T_Constructors)
sem_Constructors_Cons (hd_) (tl_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconsname :: (Names)
            _lhsOconstructors :: (Names)
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels :: (Names)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Constructors)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps :: ([Type])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _hdIabstractTypes_collect :: (Set Name)
            _hdIbimapImps_collect :: ([Request_BimapImply])
            _hdIconsname :: (Name)
            _hdIconstructors :: (Names)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdepConstraints_collect :: ([DepConstraint])
            _hdIfunImps_collect :: ([Request_FunImply])
            _hdIgenericAbstractions_collect :: (FMap Name Kind)
            _hdIkinames :: (KSubst)
            _hdIkind_errors :: ([GHError])
            _hdIkindvar :: (Int)
            _hdIksubst :: (KSubst)
            _hdIlabels :: (Names)
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIrawRequests_collect :: ([RawRequest])
            _hdIself :: (Constructor)
            _hdIstaticErrors :: ([GHError])
            _hdItypeImps :: ([Type])
            _hdItypeImps_collect :: ([Request_TypeImply])
            _hdOabstractTypes_collect :: (Set Name)
            _hdObimapImps_collect :: ([Request_BimapImply])
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies :: (FMap Name [(Name,Name)])
            _hdOfunImps_collect :: ([Request_FunImply])
            _hdOgenericAbstractions :: (FMap Name Kind)
            _hdOgenericAbstractions_collect :: (FMap Name Kind)
            _hdOghc :: (Bool)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOkinames :: (KSubst)
            _hdOkinds :: (KSubst)
            _hdOkindvar :: (Int)
            _hdOksubst :: (KSubst)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmodules :: (Set Strings)
            _hdOoptimizer :: (Bool)
            _hdOoptimizerPrelude :: (Declarations)
            _hdOprekind :: (KSubst)
            _hdOprelude :: (Bool)
            _hdOrawRequests_collect :: ([RawRequest])
            _hdOtoplevel :: (Bool)
            _hdOtypeImps_collect :: ([Request_TypeImply])
            _hdOverbosity :: (Int)
            _tlIabstractTypes_collect :: (Set Name)
            _tlIbimapImps_collect :: ([Request_BimapImply])
            _tlIconsname :: (Names)
            _tlIconstructors :: (Names)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdepConstraints_collect :: ([DepConstraint])
            _tlIfunImps_collect :: ([Request_FunImply])
            _tlIgenericAbstractions_collect :: (FMap Name Kind)
            _tlIkinames :: (KSubst)
            _tlIkind_errors :: ([GHError])
            _tlIkindvar :: (Int)
            _tlIksubst :: (KSubst)
            _tlIlabels :: (Names)
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIrawRequests_collect :: ([RawRequest])
            _tlIself :: (Constructors)
            _tlIstaticErrors :: ([GHError])
            _tlItypeImps :: ([Type])
            _tlItypeImps_collect :: ([Request_TypeImply])
            _tlOabstractTypes_collect :: (Set Name)
            _tlObimapImps_collect :: ([Request_BimapImply])
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies :: (FMap Name [(Name,Name)])
            _tlOfunImps_collect :: ([Request_FunImply])
            _tlOgenericAbstractions :: (FMap Name Kind)
            _tlOgenericAbstractions_collect :: (FMap Name Kind)
            _tlOghc :: (Bool)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOkinames :: (KSubst)
            _tlOkinds :: (KSubst)
            _tlOkindvar :: (Int)
            _tlOksubst :: (KSubst)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmodules :: (Set Strings)
            _tlOoptimizer :: (Bool)
            _tlOoptimizerPrelude :: (Declarations)
            _tlOprekind :: (KSubst)
            _tlOprelude :: (Bool)
            _tlOrawRequests_collect :: ([RawRequest])
            _tlOtoplevel :: (Bool)
            _tlOtypeImps_collect :: ([Request_TypeImply])
            _tlOverbosity :: (Int)
            ( _hdIabstractTypes_collect,_hdIbimapImps_collect,_hdIconsname,_hdIconstructors,_hdIconstructors_collect,_hdIdepConstraints_collect,_hdIfunImps_collect,_hdIgenericAbstractions_collect,_hdIkinames,_hdIkind_errors,_hdIkindvar,_hdIksubst,_hdIlabels,_hdIlabels_collect,_hdImethods_collect,_hdIrawRequests_collect,_hdIself,_hdIstaticErrors,_hdItypeImps,_hdItypeImps_collect) =
                (hd_ (_hdOabstractTypes_collect)
                     (_hdObimapImps_collect)
                     (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOdependencies)
                     (_hdOfunImps_collect)
                     (_hdOgenericAbstractions)
                     (_hdOgenericAbstractions_collect)
                     (_hdOghc)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOkinames)
                     (_hdOkinds)
                     (_hdOkindvar)
                     (_hdOksubst)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmodules)
                     (_hdOoptimizer)
                     (_hdOoptimizerPrelude)
                     (_hdOprekind)
                     (_hdOprelude)
                     (_hdOrawRequests_collect)
                     (_hdOtoplevel)
                     (_hdOtypeImps_collect)
                     (_hdOverbosity))
            ( _tlIabstractTypes_collect,_tlIbimapImps_collect,_tlIconsname,_tlIconstructors,_tlIconstructors_collect,_tlIdepConstraints_collect,_tlIfunImps_collect,_tlIgenericAbstractions_collect,_tlIkinames,_tlIkind_errors,_tlIkindvar,_tlIksubst,_tlIlabels,_tlIlabels_collect,_tlImethods_collect,_tlIrawRequests_collect,_tlIself,_tlIstaticErrors,_tlItypeImps,_tlItypeImps_collect) =
                (tl_ (_tlOabstractTypes_collect)
                     (_tlObimapImps_collect)
                     (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOdependencies)
                     (_tlOfunImps_collect)
                     (_tlOgenericAbstractions)
                     (_tlOgenericAbstractions_collect)
                     (_tlOghc)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOkinames)
                     (_tlOkinds)
                     (_tlOkindvar)
                     (_tlOksubst)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmodules)
                     (_tlOoptimizer)
                     (_tlOoptimizerPrelude)
                     (_tlOprekind)
                     (_tlOprelude)
                     (_tlOrawRequests_collect)
                     (_tlOtoplevel)
                     (_tlOtypeImps_collect)
                     (_tlOverbosity))
            -- use rule
            (_lhsOconsname@_) =
                _hdIconsname : _tlIconsname
            -- use rule
            (_lhsOconstructors@_) =
                _hdIconstructors ++ _tlIconstructors
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _hdIdepConstraints_collect ++ _tlIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _hdIkind_errors ++ _tlIkind_errors
            -- use rule
            (_lhsOlabels@_) =
                _hdIlabels `List.union` _tlIlabels
            -- use rule
            (_lhsOstaticErrors@_) =
                _hdIstaticErrors ++ _tlIstaticErrors
            -- use rule
            (_lhsOtypeImps@_) =
                _hdItypeImps ++ _tlItypeImps
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _tlIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _tlIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _tlIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _tlIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _tlIkinames
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _tlIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _tlIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _tlIrawRequests_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _tlItypeImps_collect
            -- copy rule (down)
            (_hdOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_hdObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_hdOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_hdOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_hdOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_hdOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_hdOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_hdOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_hdOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_hdOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_hdOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_hdOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_hdOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_hdOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_hdOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_hdOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_tlOabstractTypes_collect@_) =
                _hdIabstractTypes_collect
            -- copy rule (chain)
            (_tlObimapImps_collect@_) =
                _hdIbimapImps_collect
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOdependencies@_) =
                _lhsIdependencies
            -- copy rule (chain)
            (_tlOfunImps_collect@_) =
                _hdIfunImps_collect
            -- copy rule (down)
            (_tlOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_tlOgenericAbstractions_collect@_) =
                _hdIgenericAbstractions_collect
            -- copy rule (down)
            (_tlOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOkinames@_) =
                _hdIkinames
            -- copy rule (down)
            (_tlOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_tlOkindvar@_) =
                _hdIkindvar
            -- copy rule (chain)
            (_tlOksubst@_) =
                _hdIksubst
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_tlOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_tlOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_tlOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_tlOprelude@_) =
                _lhsIprelude
            -- copy rule (chain)
            (_tlOrawRequests_collect@_) =
                _hdIrawRequests_collect
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_tlOtypeImps_collect@_) =
                _hdItypeImps_collect
            -- copy rule (down)
            (_tlOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconsname,_lhsOconstructors,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps,_lhsOtypeImps_collect)
sem_Constructors_Nil :: (T_Constructors)
sem_Constructors_Nil  =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconsname :: (Names)
            _lhsOconstructors :: (Names)
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels :: (Names)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Constructors)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps :: ([Type])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            -- use rule
            (_lhsOconsname@_) =
                []
            -- use rule
            (_lhsOconstructors@_) =
                []
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOlabels@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- use rule
            (_lhsOtypeImps@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconsname,_lhsOconstructors,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps,_lhsOtypeImps_collect)
-- ContextItem -------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      rawRequests_collect  : [RawRequest]
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      kind_errors          : [GHError]
      self                 : SELF
      staticErrors         : [GHError]

-}
{-
   local variables for ContextItem.ContextItem:
      self

-}
{-
   local variables for ContextItem.DependencyConstraint:
      self

-}
{-
   local variables for ContextItem.DependencyItem:
      self

-}
-- semantic domain
type T_ContextItem = (Set Name) ->
                     ([Request_BimapImply]) ->
                     (Maybe Name) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Strings) ->
                     (FMap Name [(Name,Name)]) ->
                     ([Request_FunImply]) ->
                     (FMap Name Kind) ->
                     (FMap Name Kind) ->
                     (Bool) ->
                     (Bool) ->
                     (Maybe Name) ->
                     (KSubst) ->
                     (KSubst) ->
                     (Int) ->
                     (KSubst) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Bool) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Set Strings) ->
                     (Bool) ->
                     (Declarations) ->
                     (KSubst) ->
                     (Bool) ->
                     ([RawRequest]) ->
                     (Bool) ->
                     ([Request_TypeImply]) ->
                     (Int) ->
                     ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),([RawRequest]),(ContextItem),([GHError]),([Request_TypeImply]))
-- cata
sem_ContextItem :: (ContextItem) ->
                   (T_ContextItem)
sem_ContextItem ((ContextItem_ContextItem (_range) (_name) (_types))) =
    (sem_ContextItem_ContextItem ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Types (_types))))
sem_ContextItem ((ContextItem_DependencyConstraint (_range) (_name) (_typevariable) (_type))) =
    (sem_ContextItem_DependencyConstraint ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Name (_typevariable))) ((sem_Type (_type))))
sem_ContextItem ((ContextItem_DependencyItem (_range) (_name) (_generics) (_parametrics) (_asname))) =
    (sem_ContextItem_DependencyItem ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Names (_generics))) ((sem_Types (_parametrics))) ((sem_MaybeName (_asname))))
sem_ContextItem_ContextItem :: (T_Range) ->
                               (T_Name) ->
                               (T_Types) ->
                               (T_ContextItem)
sem_ContextItem_ContextItem (range_) (name_) (types_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (ContextItem)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _typesIabstractTypes_collect :: (Set Name)
            _typesIbimapImps_collect :: ([Request_BimapImply])
            _typesIconstructors_collect :: (FMap Name Names)
            _typesIdepConstraints_collect :: ([DepConstraint])
            _typesIfunImps_collect :: ([Request_FunImply])
            _typesIgenericAbstractions_collect :: (FMap Name Kind)
            _typesIinferkind :: ([Kind])
            _typesIkinames :: (KSubst)
            _typesIkind_errors :: ([GHError])
            _typesIkindvar :: (Int)
            _typesIksubst :: (KSubst)
            _typesIlabels_collect :: (FMap Name Names)
            _typesImethods_collect :: (FMap Name Names)
            _typesIrawRequests_collect :: ([RawRequest])
            _typesIself :: (Types)
            _typesIstaticErrors :: ([GHError])
            _typesItypeImps_collect :: ([Request_TypeImply])
            _typesOabstractTypes_collect :: (Set Name)
            _typesObimapImps_collect :: ([Request_BimapImply])
            _typesOclassname :: (Maybe Name)
            _typesOconstructors_collect :: (FMap Name Names)
            _typesOconstructors_dist :: (FMap Name Names)
            _typesOcurrentModule :: (Strings)
            _typesOdependencies :: (FMap Name [(Name,Name)])
            _typesOfunImps_collect :: ([Request_FunImply])
            _typesOgenericAbstractions :: (FMap Name Kind)
            _typesOgenericAbstractions_collect :: (FMap Name Kind)
            _typesOghc :: (Bool)
            _typesOimportedModule :: (Bool)
            _typesOinstancename :: (Maybe Name)
            _typesOkinames :: (KSubst)
            _typesOkinds :: (KSubst)
            _typesOkindvar :: (Int)
            _typesOksubst :: (KSubst)
            _typesOlabels_collect :: (FMap Name Names)
            _typesOlabels_dist :: (FMap Name Names)
            _typesOlocal :: (Bool)
            _typesOmethods_collect :: (FMap Name Names)
            _typesOmethods_dist :: (FMap Name Names)
            _typesOmodules :: (Set Strings)
            _typesOoptimizer :: (Bool)
            _typesOoptimizerPrelude :: (Declarations)
            _typesOprekind :: (KSubst)
            _typesOprelude :: (Bool)
            _typesOrawRequests_collect :: ([RawRequest])
            _typesOtoplevel :: (Bool)
            _typesOtypeImps_collect :: ([Request_TypeImply])
            _typesOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _typesIabstractTypes_collect,_typesIbimapImps_collect,_typesIconstructors_collect,_typesIdepConstraints_collect,_typesIfunImps_collect,_typesIgenericAbstractions_collect,_typesIinferkind,_typesIkinames,_typesIkind_errors,_typesIkindvar,_typesIksubst,_typesIlabels_collect,_typesImethods_collect,_typesIrawRequests_collect,_typesIself,_typesIstaticErrors,_typesItypeImps_collect) =
                (types_ (_typesOabstractTypes_collect)
                        (_typesObimapImps_collect)
                        (_typesOclassname)
                        (_typesOconstructors_collect)
                        (_typesOconstructors_dist)
                        (_typesOcurrentModule)
                        (_typesOdependencies)
                        (_typesOfunImps_collect)
                        (_typesOgenericAbstractions)
                        (_typesOgenericAbstractions_collect)
                        (_typesOghc)
                        (_typesOimportedModule)
                        (_typesOinstancename)
                        (_typesOkinames)
                        (_typesOkinds)
                        (_typesOkindvar)
                        (_typesOksubst)
                        (_typesOlabels_collect)
                        (_typesOlabels_dist)
                        (_typesOlocal)
                        (_typesOmethods_collect)
                        (_typesOmethods_dist)
                        (_typesOmodules)
                        (_typesOoptimizer)
                        (_typesOoptimizerPrelude)
                        (_typesOprekind)
                        (_typesOprelude)
                        (_typesOrawRequests_collect)
                        (_typesOtoplevel)
                        (_typesOtypeImps_collect)
                        (_typesOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _typesIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _typesIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _typesIstaticErrors
            -- self rule
            (_self@_) =
                ContextItem_ContextItem _rangeIself _nameIself _typesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _typesIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _typesIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typesIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _typesIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _typesIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _typesIkinames
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _typesIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _typesIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typesIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typesImethods_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _typesIrawRequests_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _typesItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_typesOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_typesObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_typesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typesOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_typesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typesOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_typesOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_typesOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_typesOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_typesOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_typesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typesOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_typesOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_typesOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_typesOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_typesOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_typesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typesOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_typesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typesOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_typesOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_typesOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_typesOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_typesOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_typesOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_typesOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typesOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_typesOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps_collect)
sem_ContextItem_DependencyConstraint :: (T_Range) ->
                                        (T_Name) ->
                                        (T_Name) ->
                                        (T_Type) ->
                                        (T_ContextItem)
sem_ContextItem_DependencyConstraint (range_) (name_) (typevariable_) (type_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (ContextItem)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _typevariableIconstructors_collect :: (FMap Name Names)
            _typevariableIgenericAbstractions_collect :: (FMap Name Kind)
            _typevariableIlabels_collect :: (FMap Name Names)
            _typevariableImethods_collect :: (FMap Name Names)
            _typevariableIself :: (Name)
            _typevariableOclassname :: (Maybe Name)
            _typevariableOconstructors_collect :: (FMap Name Names)
            _typevariableOconstructors_dist :: (FMap Name Names)
            _typevariableOcurrentModule :: (Strings)
            _typevariableOgenericAbstractions :: (FMap Name Kind)
            _typevariableOgenericAbstractions_collect :: (FMap Name Kind)
            _typevariableOghc :: (Bool)
            _typevariableOimportedModule :: (Bool)
            _typevariableOinstancename :: (Maybe Name)
            _typevariableOlabels_collect :: (FMap Name Names)
            _typevariableOlabels_dist :: (FMap Name Names)
            _typevariableOlocal :: (Bool)
            _typevariableOmethods_collect :: (FMap Name Names)
            _typevariableOmethods_dist :: (FMap Name Names)
            _typevariableOmodules :: (Set Strings)
            _typevariableOoptimizer :: (Bool)
            _typevariableOoptimizerPrelude :: (Declarations)
            _typevariableOprelude :: (Bool)
            _typevariableOtoplevel :: (Bool)
            _typevariableOverbosity :: (Int)
            _typeIabstractTypes_collect :: (Set Name)
            _typeIbimapImps_collect :: ([Request_BimapImply])
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIdepConstraints_collect :: ([DepConstraint])
            _typeIfunImps_collect :: ([Request_FunImply])
            _typeIgenericAbstractions_collect :: (FMap Name Kind)
            _typeIinferkind :: (Kind)
            _typeIkinames :: (KSubst)
            _typeIkind_errors :: ([GHError])
            _typeIkindvar :: (Int)
            _typeIksubst :: (KSubst)
            _typeIlabels_collect :: (FMap Name Names)
            _typeImethods_collect :: (FMap Name Names)
            _typeIrawRequests_collect :: ([RawRequest])
            _typeIself :: (Type)
            _typeIstaticErrors :: ([GHError])
            _typeItypeImps_collect :: ([Request_TypeImply])
            _typeOabstractTypes_collect :: (Set Name)
            _typeObimapImps_collect :: ([Request_BimapImply])
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOdependencies :: (FMap Name [(Name,Name)])
            _typeOfunImps_collect :: ([Request_FunImply])
            _typeOgenericAbstractions :: (FMap Name Kind)
            _typeOgenericAbstractions_collect :: (FMap Name Kind)
            _typeOghc :: (Bool)
            _typeOimportedModule :: (Bool)
            _typeOinstancename :: (Maybe Name)
            _typeOkinames :: (KSubst)
            _typeOkinds :: (KSubst)
            _typeOkindvar :: (Int)
            _typeOksubst :: (KSubst)
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOmodules :: (Set Strings)
            _typeOoptimizer :: (Bool)
            _typeOoptimizerPrelude :: (Declarations)
            _typeOprekind :: (KSubst)
            _typeOprelude :: (Bool)
            _typeOrawRequests_collect :: ([RawRequest])
            _typeOtoplevel :: (Bool)
            _typeOtypeImps_collect :: ([Request_TypeImply])
            _typeOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _typevariableIconstructors_collect,_typevariableIgenericAbstractions_collect,_typevariableIlabels_collect,_typevariableImethods_collect,_typevariableIself) =
                (typevariable_ (_typevariableOclassname)
                               (_typevariableOconstructors_collect)
                               (_typevariableOconstructors_dist)
                               (_typevariableOcurrentModule)
                               (_typevariableOgenericAbstractions)
                               (_typevariableOgenericAbstractions_collect)
                               (_typevariableOghc)
                               (_typevariableOimportedModule)
                               (_typevariableOinstancename)
                               (_typevariableOlabels_collect)
                               (_typevariableOlabels_dist)
                               (_typevariableOlocal)
                               (_typevariableOmethods_collect)
                               (_typevariableOmethods_dist)
                               (_typevariableOmodules)
                               (_typevariableOoptimizer)
                               (_typevariableOoptimizerPrelude)
                               (_typevariableOprelude)
                               (_typevariableOtoplevel)
                               (_typevariableOverbosity))
            ( _typeIabstractTypes_collect,_typeIbimapImps_collect,_typeIconstructors_collect,_typeIdepConstraints_collect,_typeIfunImps_collect,_typeIgenericAbstractions_collect,_typeIinferkind,_typeIkinames,_typeIkind_errors,_typeIkindvar,_typeIksubst,_typeIlabels_collect,_typeImethods_collect,_typeIrawRequests_collect,_typeIself,_typeIstaticErrors,_typeItypeImps_collect) =
                (type_ (_typeOabstractTypes_collect)
                       (_typeObimapImps_collect)
                       (_typeOclassname)
                       (_typeOconstructors_collect)
                       (_typeOconstructors_dist)
                       (_typeOcurrentModule)
                       (_typeOdependencies)
                       (_typeOfunImps_collect)
                       (_typeOgenericAbstractions)
                       (_typeOgenericAbstractions_collect)
                       (_typeOghc)
                       (_typeOimportedModule)
                       (_typeOinstancename)
                       (_typeOkinames)
                       (_typeOkinds)
                       (_typeOkindvar)
                       (_typeOksubst)
                       (_typeOlabels_collect)
                       (_typeOlabels_dist)
                       (_typeOlocal)
                       (_typeOmethods_collect)
                       (_typeOmethods_dist)
                       (_typeOmodules)
                       (_typeOoptimizer)
                       (_typeOoptimizerPrelude)
                       (_typeOprekind)
                       (_typeOprelude)
                       (_typeOrawRequests_collect)
                       (_typeOtoplevel)
                       (_typeOtypeImps_collect)
                       (_typeOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _typeIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _typeIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _typeIstaticErrors
            -- self rule
            (_self@_) =
                ContextItem_DependencyConstraint _rangeIself _nameIself _typevariableIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _typeIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _typeIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _typeIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _typeIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _typeIkinames
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _typeIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _typeIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _typeIrawRequests_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _typeItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_typevariableOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typevariableOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_typevariableOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typevariableOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typevariableOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_typevariableOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_typevariableOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_typevariableOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typevariableOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typevariableOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_typevariableOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typevariableOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typevariableOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_typevariableOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typevariableOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_typevariableOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_typevariableOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_typevariableOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_typevariableOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typevariableOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_typeOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_typeObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _typevariableIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_typeOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_typeOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_typeOgenericAbstractions_collect@_) =
                _typevariableIgenericAbstractions_collect
            -- copy rule (down)
            (_typeOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typeOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_typeOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_typeOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_typeOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _typevariableIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _typevariableImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typeOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_typeOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_typeOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_typeOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_typeOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_typeOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_typeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_typeOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps_collect)
sem_ContextItem_DependencyItem :: (T_Range) ->
                                  (T_Name) ->
                                  (T_Names) ->
                                  (T_Types) ->
                                  (T_MaybeName) ->
                                  (T_ContextItem)
sem_ContextItem_DependencyItem (range_) (name_) (generics_) (parametrics_) (asname_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (ContextItem)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _genericsIconstructors_collect :: (FMap Name Names)
            _genericsIgenericAbstractions_collect :: (FMap Name Kind)
            _genericsIinferkind :: (Kind)
            _genericsIkinames :: (KSubst)
            _genericsIkind_errors :: ([GHError])
            _genericsIkindvar :: (Int)
            _genericsIksubst :: (KSubst)
            _genericsIlabels_collect :: (FMap Name Names)
            _genericsImethods_collect :: (FMap Name Names)
            _genericsIself :: (Names)
            _genericsOclassname :: (Maybe Name)
            _genericsOconstructors_collect :: (FMap Name Names)
            _genericsOconstructors_dist :: (FMap Name Names)
            _genericsOcurrentModule :: (Strings)
            _genericsOgenericAbstractions :: (FMap Name Kind)
            _genericsOgenericAbstractions_collect :: (FMap Name Kind)
            _genericsOghc :: (Bool)
            _genericsOimportedModule :: (Bool)
            _genericsOinstancename :: (Maybe Name)
            _genericsOkinames :: (KSubst)
            _genericsOkinds :: (KSubst)
            _genericsOkindvar :: (Int)
            _genericsOksubst :: (KSubst)
            _genericsOlabels_collect :: (FMap Name Names)
            _genericsOlabels_dist :: (FMap Name Names)
            _genericsOlocal :: (Bool)
            _genericsOmethods_collect :: (FMap Name Names)
            _genericsOmethods_dist :: (FMap Name Names)
            _genericsOmodules :: (Set Strings)
            _genericsOoptimizer :: (Bool)
            _genericsOoptimizerPrelude :: (Declarations)
            _genericsOprekind :: (KSubst)
            _genericsOprelude :: (Bool)
            _genericsOtoplevel :: (Bool)
            _genericsOverbosity :: (Int)
            _parametricsIabstractTypes_collect :: (Set Name)
            _parametricsIbimapImps_collect :: ([Request_BimapImply])
            _parametricsIconstructors_collect :: (FMap Name Names)
            _parametricsIdepConstraints_collect :: ([DepConstraint])
            _parametricsIfunImps_collect :: ([Request_FunImply])
            _parametricsIgenericAbstractions_collect :: (FMap Name Kind)
            _parametricsIinferkind :: ([Kind])
            _parametricsIkinames :: (KSubst)
            _parametricsIkind_errors :: ([GHError])
            _parametricsIkindvar :: (Int)
            _parametricsIksubst :: (KSubst)
            _parametricsIlabels_collect :: (FMap Name Names)
            _parametricsImethods_collect :: (FMap Name Names)
            _parametricsIrawRequests_collect :: ([RawRequest])
            _parametricsIself :: (Types)
            _parametricsIstaticErrors :: ([GHError])
            _parametricsItypeImps_collect :: ([Request_TypeImply])
            _parametricsOabstractTypes_collect :: (Set Name)
            _parametricsObimapImps_collect :: ([Request_BimapImply])
            _parametricsOclassname :: (Maybe Name)
            _parametricsOconstructors_collect :: (FMap Name Names)
            _parametricsOconstructors_dist :: (FMap Name Names)
            _parametricsOcurrentModule :: (Strings)
            _parametricsOdependencies :: (FMap Name [(Name,Name)])
            _parametricsOfunImps_collect :: ([Request_FunImply])
            _parametricsOgenericAbstractions :: (FMap Name Kind)
            _parametricsOgenericAbstractions_collect :: (FMap Name Kind)
            _parametricsOghc :: (Bool)
            _parametricsOimportedModule :: (Bool)
            _parametricsOinstancename :: (Maybe Name)
            _parametricsOkinames :: (KSubst)
            _parametricsOkinds :: (KSubst)
            _parametricsOkindvar :: (Int)
            _parametricsOksubst :: (KSubst)
            _parametricsOlabels_collect :: (FMap Name Names)
            _parametricsOlabels_dist :: (FMap Name Names)
            _parametricsOlocal :: (Bool)
            _parametricsOmethods_collect :: (FMap Name Names)
            _parametricsOmethods_dist :: (FMap Name Names)
            _parametricsOmodules :: (Set Strings)
            _parametricsOoptimizer :: (Bool)
            _parametricsOoptimizerPrelude :: (Declarations)
            _parametricsOprekind :: (KSubst)
            _parametricsOprelude :: (Bool)
            _parametricsOrawRequests_collect :: ([RawRequest])
            _parametricsOtoplevel :: (Bool)
            _parametricsOtypeImps_collect :: ([Request_TypeImply])
            _parametricsOverbosity :: (Int)
            _asnameIconstructors_collect :: (FMap Name Names)
            _asnameIgenericAbstractions_collect :: (FMap Name Kind)
            _asnameIlabels_collect :: (FMap Name Names)
            _asnameImethods_collect :: (FMap Name Names)
            _asnameIself :: (MaybeName)
            _asnameOclassname :: (Maybe Name)
            _asnameOconstructors_collect :: (FMap Name Names)
            _asnameOconstructors_dist :: (FMap Name Names)
            _asnameOcurrentModule :: (Strings)
            _asnameOgenericAbstractions :: (FMap Name Kind)
            _asnameOgenericAbstractions_collect :: (FMap Name Kind)
            _asnameOghc :: (Bool)
            _asnameOimportedModule :: (Bool)
            _asnameOinstancename :: (Maybe Name)
            _asnameOlabels_collect :: (FMap Name Names)
            _asnameOlabels_dist :: (FMap Name Names)
            _asnameOlocal :: (Bool)
            _asnameOmethods_collect :: (FMap Name Names)
            _asnameOmethods_dist :: (FMap Name Names)
            _asnameOmodules :: (Set Strings)
            _asnameOoptimizer :: (Bool)
            _asnameOoptimizerPrelude :: (Declarations)
            _asnameOprelude :: (Bool)
            _asnameOtoplevel :: (Bool)
            _asnameOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _genericsIconstructors_collect,_genericsIgenericAbstractions_collect,_genericsIinferkind,_genericsIkinames,_genericsIkind_errors,_genericsIkindvar,_genericsIksubst,_genericsIlabels_collect,_genericsImethods_collect,_genericsIself) =
                (generics_ (_genericsOclassname)
                           (_genericsOconstructors_collect)
                           (_genericsOconstructors_dist)
                           (_genericsOcurrentModule)
                           (_genericsOgenericAbstractions)
                           (_genericsOgenericAbstractions_collect)
                           (_genericsOghc)
                           (_genericsOimportedModule)
                           (_genericsOinstancename)
                           (_genericsOkinames)
                           (_genericsOkinds)
                           (_genericsOkindvar)
                           (_genericsOksubst)
                           (_genericsOlabels_collect)
                           (_genericsOlabels_dist)
                           (_genericsOlocal)
                           (_genericsOmethods_collect)
                           (_genericsOmethods_dist)
                           (_genericsOmodules)
                           (_genericsOoptimizer)
                           (_genericsOoptimizerPrelude)
                           (_genericsOprekind)
                           (_genericsOprelude)
                           (_genericsOtoplevel)
                           (_genericsOverbosity))
            ( _parametricsIabstractTypes_collect
             ,_parametricsIbimapImps_collect
             ,_parametricsIconstructors_collect
             ,_parametricsIdepConstraints_collect
             ,_parametricsIfunImps_collect
             ,_parametricsIgenericAbstractions_collect
             ,_parametricsIinferkind
             ,_parametricsIkinames
             ,_parametricsIkind_errors
             ,_parametricsIkindvar
             ,_parametricsIksubst
             ,_parametricsIlabels_collect
             ,_parametricsImethods_collect
             ,_parametricsIrawRequests_collect
             ,_parametricsIself
             ,_parametricsIstaticErrors
             ,_parametricsItypeImps_collect
             ) =
                (parametrics_ (_parametricsOabstractTypes_collect)
                              (_parametricsObimapImps_collect)
                              (_parametricsOclassname)
                              (_parametricsOconstructors_collect)
                              (_parametricsOconstructors_dist)
                              (_parametricsOcurrentModule)
                              (_parametricsOdependencies)
                              (_parametricsOfunImps_collect)
                              (_parametricsOgenericAbstractions)
                              (_parametricsOgenericAbstractions_collect)
                              (_parametricsOghc)
                              (_parametricsOimportedModule)
                              (_parametricsOinstancename)
                              (_parametricsOkinames)
                              (_parametricsOkinds)
                              (_parametricsOkindvar)
                              (_parametricsOksubst)
                              (_parametricsOlabels_collect)
                              (_parametricsOlabels_dist)
                              (_parametricsOlocal)
                              (_parametricsOmethods_collect)
                              (_parametricsOmethods_dist)
                              (_parametricsOmodules)
                              (_parametricsOoptimizer)
                              (_parametricsOoptimizerPrelude)
                              (_parametricsOprekind)
                              (_parametricsOprelude)
                              (_parametricsOrawRequests_collect)
                              (_parametricsOtoplevel)
                              (_parametricsOtypeImps_collect)
                              (_parametricsOverbosity))
            ( _asnameIconstructors_collect,_asnameIgenericAbstractions_collect,_asnameIlabels_collect,_asnameImethods_collect,_asnameIself) =
                (asname_ (_asnameOclassname)
                         (_asnameOconstructors_collect)
                         (_asnameOconstructors_dist)
                         (_asnameOcurrentModule)
                         (_asnameOgenericAbstractions)
                         (_asnameOgenericAbstractions_collect)
                         (_asnameOghc)
                         (_asnameOimportedModule)
                         (_asnameOinstancename)
                         (_asnameOlabels_collect)
                         (_asnameOlabels_dist)
                         (_asnameOlocal)
                         (_asnameOmethods_collect)
                         (_asnameOmethods_dist)
                         (_asnameOmodules)
                         (_asnameOoptimizer)
                         (_asnameOoptimizerPrelude)
                         (_asnameOprelude)
                         (_asnameOtoplevel)
                         (_asnameOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _parametricsIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _genericsIkind_errors ++ _parametricsIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _parametricsIstaticErrors
            -- self rule
            (_self@_) =
                ContextItem_DependencyItem _rangeIself _nameIself _genericsIself _parametricsIself _asnameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _parametricsIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _parametricsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _asnameIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _parametricsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _asnameIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _parametricsIkinames
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _parametricsIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _parametricsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _asnameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _asnameImethods_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _parametricsIrawRequests_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _parametricsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_genericsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_genericsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_genericsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_genericsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_genericsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_genericsOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_genericsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_genericsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_genericsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_genericsOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_genericsOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_genericsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_genericsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_genericsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_genericsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_genericsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_genericsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_genericsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_genericsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_genericsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_genericsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_genericsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_genericsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_genericsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_genericsOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_parametricsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_parametricsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_parametricsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_parametricsOconstructors_collect@_) =
                _genericsIconstructors_collect
            -- copy rule (down)
            (_parametricsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_parametricsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_parametricsOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_parametricsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_parametricsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_parametricsOgenericAbstractions_collect@_) =
                _genericsIgenericAbstractions_collect
            -- copy rule (down)
            (_parametricsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_parametricsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_parametricsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_parametricsOkinames@_) =
                _genericsIkinames
            -- copy rule (down)
            (_parametricsOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_parametricsOkindvar@_) =
                _genericsIkindvar
            -- copy rule (chain)
            (_parametricsOksubst@_) =
                _genericsIksubst
            -- copy rule (chain)
            (_parametricsOlabels_collect@_) =
                _genericsIlabels_collect
            -- copy rule (down)
            (_parametricsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_parametricsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_parametricsOmethods_collect@_) =
                _genericsImethods_collect
            -- copy rule (down)
            (_parametricsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_parametricsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_parametricsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_parametricsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_parametricsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_parametricsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_parametricsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_parametricsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_parametricsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_parametricsOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_asnameOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_asnameOconstructors_collect@_) =
                _parametricsIconstructors_collect
            -- copy rule (down)
            (_asnameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_asnameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_asnameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_asnameOgenericAbstractions_collect@_) =
                _parametricsIgenericAbstractions_collect
            -- copy rule (down)
            (_asnameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_asnameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_asnameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_asnameOlabels_collect@_) =
                _parametricsIlabels_collect
            -- copy rule (down)
            (_asnameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_asnameOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_asnameOmethods_collect@_) =
                _parametricsImethods_collect
            -- copy rule (down)
            (_asnameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_asnameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_asnameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_asnameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_asnameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_asnameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_asnameOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps_collect)
-- ContextItems ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      rawRequests_collect  : [RawRequest]
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      kind_errors          : [GHError]
      self                 : SELF
      staticErrors         : [GHError]

-}
{-
   local variables for ContextItems.Cons:
      self

-}
{-
   local variables for ContextItems.Nil:
      self

-}
-- semantic domain
type T_ContextItems = (Set Name) ->
                      ([Request_BimapImply]) ->
                      (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Strings) ->
                      (FMap Name [(Name,Name)]) ->
                      ([Request_FunImply]) ->
                      (FMap Name Kind) ->
                      (FMap Name Kind) ->
                      (Bool) ->
                      (Bool) ->
                      (Maybe Name) ->
                      (KSubst) ->
                      (KSubst) ->
                      (Int) ->
                      (KSubst) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Set Strings) ->
                      (Bool) ->
                      (Declarations) ->
                      (KSubst) ->
                      (Bool) ->
                      ([RawRequest]) ->
                      (Bool) ->
                      ([Request_TypeImply]) ->
                      (Int) ->
                      ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),([RawRequest]),(ContextItems),([GHError]),([Request_TypeImply]))
-- cata
sem_ContextItems :: (ContextItems) ->
                    (T_ContextItems)
sem_ContextItems (list) =
    (foldr (sem_ContextItems_Cons) (sem_ContextItems_Nil) ((map sem_ContextItem list)))
sem_ContextItems_Cons :: (T_ContextItem) ->
                         (T_ContextItems) ->
                         (T_ContextItems)
sem_ContextItems_Cons (hd_) (tl_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (ContextItems)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _hdIabstractTypes_collect :: (Set Name)
            _hdIbimapImps_collect :: ([Request_BimapImply])
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdepConstraints_collect :: ([DepConstraint])
            _hdIfunImps_collect :: ([Request_FunImply])
            _hdIgenericAbstractions_collect :: (FMap Name Kind)
            _hdIkinames :: (KSubst)
            _hdIkind_errors :: ([GHError])
            _hdIkindvar :: (Int)
            _hdIksubst :: (KSubst)
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIrawRequests_collect :: ([RawRequest])
            _hdIself :: (ContextItem)
            _hdIstaticErrors :: ([GHError])
            _hdItypeImps_collect :: ([Request_TypeImply])
            _hdOabstractTypes_collect :: (Set Name)
            _hdObimapImps_collect :: ([Request_BimapImply])
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies :: (FMap Name [(Name,Name)])
            _hdOfunImps_collect :: ([Request_FunImply])
            _hdOgenericAbstractions :: (FMap Name Kind)
            _hdOgenericAbstractions_collect :: (FMap Name Kind)
            _hdOghc :: (Bool)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOkinames :: (KSubst)
            _hdOkinds :: (KSubst)
            _hdOkindvar :: (Int)
            _hdOksubst :: (KSubst)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmodules :: (Set Strings)
            _hdOoptimizer :: (Bool)
            _hdOoptimizerPrelude :: (Declarations)
            _hdOprekind :: (KSubst)
            _hdOprelude :: (Bool)
            _hdOrawRequests_collect :: ([RawRequest])
            _hdOtoplevel :: (Bool)
            _hdOtypeImps_collect :: ([Request_TypeImply])
            _hdOverbosity :: (Int)
            _tlIabstractTypes_collect :: (Set Name)
            _tlIbimapImps_collect :: ([Request_BimapImply])
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdepConstraints_collect :: ([DepConstraint])
            _tlIfunImps_collect :: ([Request_FunImply])
            _tlIgenericAbstractions_collect :: (FMap Name Kind)
            _tlIkinames :: (KSubst)
            _tlIkind_errors :: ([GHError])
            _tlIkindvar :: (Int)
            _tlIksubst :: (KSubst)
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIrawRequests_collect :: ([RawRequest])
            _tlIself :: (ContextItems)
            _tlIstaticErrors :: ([GHError])
            _tlItypeImps_collect :: ([Request_TypeImply])
            _tlOabstractTypes_collect :: (Set Name)
            _tlObimapImps_collect :: ([Request_BimapImply])
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies :: (FMap Name [(Name,Name)])
            _tlOfunImps_collect :: ([Request_FunImply])
            _tlOgenericAbstractions :: (FMap Name Kind)
            _tlOgenericAbstractions_collect :: (FMap Name Kind)
            _tlOghc :: (Bool)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOkinames :: (KSubst)
            _tlOkinds :: (KSubst)
            _tlOkindvar :: (Int)
            _tlOksubst :: (KSubst)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmodules :: (Set Strings)
            _tlOoptimizer :: (Bool)
            _tlOoptimizerPrelude :: (Declarations)
            _tlOprekind :: (KSubst)
            _tlOprelude :: (Bool)
            _tlOrawRequests_collect :: ([RawRequest])
            _tlOtoplevel :: (Bool)
            _tlOtypeImps_collect :: ([Request_TypeImply])
            _tlOverbosity :: (Int)
            ( _hdIabstractTypes_collect,_hdIbimapImps_collect,_hdIconstructors_collect,_hdIdepConstraints_collect,_hdIfunImps_collect,_hdIgenericAbstractions_collect,_hdIkinames,_hdIkind_errors,_hdIkindvar,_hdIksubst,_hdIlabels_collect,_hdImethods_collect,_hdIrawRequests_collect,_hdIself,_hdIstaticErrors,_hdItypeImps_collect) =
                (hd_ (_hdOabstractTypes_collect)
                     (_hdObimapImps_collect)
                     (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOdependencies)
                     (_hdOfunImps_collect)
                     (_hdOgenericAbstractions)
                     (_hdOgenericAbstractions_collect)
                     (_hdOghc)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOkinames)
                     (_hdOkinds)
                     (_hdOkindvar)
                     (_hdOksubst)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmodules)
                     (_hdOoptimizer)
                     (_hdOoptimizerPrelude)
                     (_hdOprekind)
                     (_hdOprelude)
                     (_hdOrawRequests_collect)
                     (_hdOtoplevel)
                     (_hdOtypeImps_collect)
                     (_hdOverbosity))
            ( _tlIabstractTypes_collect,_tlIbimapImps_collect,_tlIconstructors_collect,_tlIdepConstraints_collect,_tlIfunImps_collect,_tlIgenericAbstractions_collect,_tlIkinames,_tlIkind_errors,_tlIkindvar,_tlIksubst,_tlIlabels_collect,_tlImethods_collect,_tlIrawRequests_collect,_tlIself,_tlIstaticErrors,_tlItypeImps_collect) =
                (tl_ (_tlOabstractTypes_collect)
                     (_tlObimapImps_collect)
                     (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOdependencies)
                     (_tlOfunImps_collect)
                     (_tlOgenericAbstractions)
                     (_tlOgenericAbstractions_collect)
                     (_tlOghc)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOkinames)
                     (_tlOkinds)
                     (_tlOkindvar)
                     (_tlOksubst)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmodules)
                     (_tlOoptimizer)
                     (_tlOoptimizerPrelude)
                     (_tlOprekind)
                     (_tlOprelude)
                     (_tlOrawRequests_collect)
                     (_tlOtoplevel)
                     (_tlOtypeImps_collect)
                     (_tlOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _hdIdepConstraints_collect ++ _tlIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _hdIkind_errors ++ _tlIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _hdIstaticErrors ++ _tlIstaticErrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _tlIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _tlIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _tlIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _tlIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _tlIkinames
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _tlIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _tlIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _tlIrawRequests_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _tlItypeImps_collect
            -- copy rule (down)
            (_hdOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_hdObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_hdOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_hdOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_hdOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_hdOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_hdOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_hdOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_hdOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_hdOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_hdOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_hdOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_hdOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_hdOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_hdOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_hdOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_tlOabstractTypes_collect@_) =
                _hdIabstractTypes_collect
            -- copy rule (chain)
            (_tlObimapImps_collect@_) =
                _hdIbimapImps_collect
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOdependencies@_) =
                _lhsIdependencies
            -- copy rule (chain)
            (_tlOfunImps_collect@_) =
                _hdIfunImps_collect
            -- copy rule (down)
            (_tlOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_tlOgenericAbstractions_collect@_) =
                _hdIgenericAbstractions_collect
            -- copy rule (down)
            (_tlOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOkinames@_) =
                _hdIkinames
            -- copy rule (down)
            (_tlOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_tlOkindvar@_) =
                _hdIkindvar
            -- copy rule (chain)
            (_tlOksubst@_) =
                _hdIksubst
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_tlOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_tlOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_tlOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_tlOprelude@_) =
                _lhsIprelude
            -- copy rule (chain)
            (_tlOrawRequests_collect@_) =
                _hdIrawRequests_collect
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_tlOtypeImps_collect@_) =
                _hdItypeImps_collect
            -- copy rule (down)
            (_tlOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps_collect)
sem_ContextItems_Nil :: (T_ContextItems)
sem_ContextItems_Nil  =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (ContextItems)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps_collect)
-- Declaration -------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      exportedStructures   : Set Name
      exportedTypes        : Set Name
      exportedValues       : Set Name
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures
      rawRequests_collect  : [RawRequest]
      structureTypes_collect : FMap Name LambdaType
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      depConstraints_defined : [DepConstraint]
      exportedDeclarations : Declarations
      kind_errors          : [GHError]
      output               : PP.Doc
      outputi              : [PP.Doc]
      self                 : SELF
      staticErrors         : [GHError]

-}
{-
   local variables for Declaration.Class:
      classname
      is_exported
      self

-}
{-
   local variables for Declaration.Data:
      strtype
      ep
      contype
      descriptors
      subs_exported
      structure_exported
      is_exported
      is_implied
      kinames
      new_kinames
      kvar
      kindvar
      ksubstKV
      kind_errors
      kind
      typeImps
      imply_Sum
      imply_Con
      self

-}
{-
   local variables for Declaration.Default:
      self

-}
{-
   local variables for Declaration.Dependency:
      is_exported
      is_implied
      self

-}
{-
   local variables for Declaration.Empty:
      self

-}
{-
   local variables for Declaration.Fixity:
      self

-}
{-
   local variables for Declaration.FunctionBindings:
      self

-}
{-
   local variables for Declaration.GenericTypeSignature:
      isMPCstyle
      is_exported
      dependencyEnriched
      is_implied
      qvars'
      qvars
      kinames
      kvar
      kindvar
      ksubst'
      kind_errors
      ksubstKV
      kind_errors'
      kind_errors''
      pkinds
      gkind
      argkinds
      kind
      arity
      nkitlifted
      nkit
      underlyingKIT
      liftedKIT
      okitlifted
      typevariable
      vkind
      staticErrors
      signature
      isGenericAbstraction
      genericAbstractionOutput
      basetype
      self

-}
{-
   local variables for Declaration.Instance:
      instancename
      self

-}
{-
   local variables for Declaration.KindIndexedType:
      is_exported
      self

-}
{-
   local variables for Declaration.Newtype:
      strtype
      ep
      contype
      descriptors
      subs_exported
      structure_exported
      is_exported
      is_implied
      kinames
      new_kinames
      kvar
      kindvar
      ksubstKV
      kind_errors
      kind
      typeImps
      imply_Con
      self

-}
{-
   local variables for Declaration.PatternBinding:
      self

-}
{-
   local variables for Declaration.Type:
      strtype
      ep
      is_exported
      is_implied
      kinames
      kvar
      kindvar
      ksubst'
      kind_errors
      ksubstKV
      kind_errors'
      kind
      self

-}
{-
   local variables for Declaration.TypeIndexedType:
      is_exported
      kinames
      kvar
      kindvar
      ksubstKV
      kind_errors
      signature
      presignatures_collect
      first
      componentName
      component
      self

-}
{-
   local variables for Declaration.TypeIndexedValue:
      is_exported
      is_implied
      kindIndexedType
      linkname
      signature_link
      presignature
      signature
      typeargument
      defaultcase
      presignatures_collect
      first
      component
      kindOfTypeArgument
      finaltypeargument
      signature_difference
      dependencies_
      genericAbstractionOutput
      isGenericAbstraction
      variable
      self

-}
{-
   local variables for Declaration.TypeSignature:
      names_exported
      is_exported
      self

-}
-- semantic domain
type T_Declaration = (Set Name) ->
                     ([Request_BimapImply]) ->
                     (Maybe Name) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Strings) ->
                     (FMap Name [(Name,Name)]) ->
                     (Set Name) ->
                     (Set Name) ->
                     (Set Name) ->
                     ([Request_FunImply]) ->
                     (FMap Name Kind) ->
                     (FMap Name Kind) ->
                     (Bool) ->
                     (Bool) ->
                     (Maybe Name) ->
                     (KSubst) ->
                     (FMap Name KindIndexedType) ->
                     (FMap Name KindIndexedType) ->
                     (KSubst) ->
                     (Int) ->
                     (KSubst) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Bool) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Set Strings) ->
                     (Bool) ->
                     (Declarations) ->
                     (KSubst) ->
                     (Bool) ->
                     (PreSignatures) ->
                     (PreSignatures) ->
                     ([RawRequest]) ->
                     (Signatures) ->
                     (FMap Name LambdaType) ->
                     (Bool) ->
                     ([Request_TypeImply]) ->
                     (Int) ->
                     ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([DepConstraint]),(Declarations),([Request_FunImply]),(FMap Name Kind),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(PP.Doc),([PP.Doc]),(PreSignatures),([RawRequest]),(Declaration),([GHError]),(FMap Name LambdaType),([Request_TypeImply]))
-- cata
sem_Declaration :: (Declaration) ->
                   (T_Declaration)
sem_Declaration ((Declaration_Class (_range) (_context) (_simpletype) (_where))) =
    (sem_Declaration_Class ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_SimpleType (_simpletype))) ((sem_MaybeDeclarations (_where))))
sem_Declaration ((Declaration_Data (_range) (_context) (_simpletype) (_constructors) (_derivings))) =
    (sem_Declaration_Data ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_SimpleType (_simpletype))) ((sem_Constructors (_constructors))) ((sem_Names (_derivings))))
sem_Declaration ((Declaration_Default (_range) (_types))) =
    (sem_Declaration_Default ((sem_Range (_range))) ((sem_Types (_types))))
sem_Declaration ((Declaration_Dependency (_range) (_typelevel) (_name) (_bindings))) =
    (sem_Declaration_Dependency ((sem_Range (_range))) (_typelevel) ((sem_Name (_name))) ((sem_DependencyBindings (_bindings))))
sem_Declaration ((Declaration_Empty (_range))) =
    (sem_Declaration_Empty ((sem_Range (_range))))
sem_Declaration ((Declaration_Fixity (_range) (_fixity) (_priority) (_operators))) =
    (sem_Declaration_Fixity ((sem_Range (_range))) ((sem_Fixity (_fixity))) ((sem_MaybeInt (_priority))) ((sem_Names (_operators))))
sem_Declaration ((Declaration_FunctionBindings (_range) (_bindings))) =
    (sem_Declaration_FunctionBindings ((sem_Range (_range))) ((sem_FunctionBindings (_bindings))))
sem_Declaration ((Declaration_GenericTypeSignature (_range) (_name) (_generics) (_parametrics) (_type))) =
    (sem_Declaration_GenericTypeSignature ((sem_Range (_range))) ((sem_Name (_name))) ((sem_KindAnnotatedNames (_generics))) ((sem_KindAnnotatedNames (_parametrics))) ((sem_Type (_type))))
sem_Declaration ((Declaration_Instance (_range) (_context) (_name) (_types) (_where))) =
    (sem_Declaration_Instance ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_Name (_name))) ((sem_Types (_types))) ((sem_MaybeDeclarations (_where))))
sem_Declaration ((Declaration_KindIndexedType (_range) (_bindings))) =
    (sem_Declaration_KindIndexedType ((sem_Range (_range))) ((sem_KindIndexedBindings (_bindings))))
sem_Declaration ((Declaration_Newtype (_range) (_context) (_simpletype) (_constructor) (_derivings))) =
    (sem_Declaration_Newtype ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_SimpleType (_simpletype))) ((sem_Constructor (_constructor))) ((sem_Names (_derivings))))
sem_Declaration ((Declaration_PatternBinding (_range) (_pattern) (_righthandside))) =
    (sem_Declaration_PatternBinding ((sem_Range (_range))) ((sem_Pattern (_pattern))) ((sem_RightHandSide (_righthandside))))
sem_Declaration ((Declaration_Type (_range) (_simpletype) (_type))) =
    (sem_Declaration_Type ((sem_Range (_range))) ((sem_SimpleType (_simpletype))) ((sem_Type (_type))))
sem_Declaration ((Declaration_TypeIndexedType (_range) (_name) (_typeargument) (_typevariables) (_constructor) (_derivings))) =
    (sem_Declaration_TypeIndexedType ((sem_Range (_range))) ((sem_Name (_name))) ((sem_TypeArgument (_typeargument))) ((sem_Names (_typevariables))) ((sem_Constructor (_constructor))) ((sem_Names (_derivings))))
sem_Declaration ((Declaration_TypeIndexedValue (_range) (_bindings))) =
    (sem_Declaration_TypeIndexedValue ((sem_Range (_range))) ((sem_TypeIndexedBindings (_bindings))))
sem_Declaration ((Declaration_TypeSignature (_range) (_names) (_type))) =
    (sem_Declaration_TypeSignature ((sem_Range (_range))) ((sem_Names (_names))) ((sem_Type (_type))))
sem_Declaration_Class :: (T_Range) ->
                         (T_ContextItems) ->
                         (T_SimpleType) ->
                         (T_MaybeDeclarations) ->
                         (T_Declaration)
sem_Declaration_Class (range_) (context_) (simpletype_) (where_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOdepConstraints_defined :: ([DepConstraint])
            _lhsOexportedDeclarations :: (Declarations)
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: (PP.Doc)
            _lhsOoutputi :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Declaration)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _contextIabstractTypes_collect :: (Set Name)
            _contextIbimapImps_collect :: ([Request_BimapImply])
            _contextIconstructors_collect :: (FMap Name Names)
            _contextIdepConstraints_collect :: ([DepConstraint])
            _contextIfunImps_collect :: ([Request_FunImply])
            _contextIgenericAbstractions_collect :: (FMap Name Kind)
            _contextIkinames :: (KSubst)
            _contextIkind_errors :: ([GHError])
            _contextIkindvar :: (Int)
            _contextIksubst :: (KSubst)
            _contextIlabels_collect :: (FMap Name Names)
            _contextImethods_collect :: (FMap Name Names)
            _contextIrawRequests_collect :: ([RawRequest])
            _contextIself :: (ContextItems)
            _contextIstaticErrors :: ([GHError])
            _contextItypeImps_collect :: ([Request_TypeImply])
            _contextOabstractTypes_collect :: (Set Name)
            _contextObimapImps_collect :: ([Request_BimapImply])
            _contextOclassname :: (Maybe Name)
            _contextOconstructors_collect :: (FMap Name Names)
            _contextOconstructors_dist :: (FMap Name Names)
            _contextOcurrentModule :: (Strings)
            _contextOdependencies :: (FMap Name [(Name,Name)])
            _contextOfunImps_collect :: ([Request_FunImply])
            _contextOgenericAbstractions :: (FMap Name Kind)
            _contextOgenericAbstractions_collect :: (FMap Name Kind)
            _contextOghc :: (Bool)
            _contextOimportedModule :: (Bool)
            _contextOinstancename :: (Maybe Name)
            _contextOkinames :: (KSubst)
            _contextOkinds :: (KSubst)
            _contextOkindvar :: (Int)
            _contextOksubst :: (KSubst)
            _contextOlabels_collect :: (FMap Name Names)
            _contextOlabels_dist :: (FMap Name Names)
            _contextOlocal :: (Bool)
            _contextOmethods_collect :: (FMap Name Names)
            _contextOmethods_dist :: (FMap Name Names)
            _contextOmodules :: (Set Strings)
            _contextOoptimizer :: (Bool)
            _contextOoptimizerPrelude :: (Declarations)
            _contextOprekind :: (KSubst)
            _contextOprelude :: (Bool)
            _contextOrawRequests_collect :: ([RawRequest])
            _contextOtoplevel :: (Bool)
            _contextOtypeImps_collect :: ([Request_TypeImply])
            _contextOverbosity :: (Int)
            _simpletypeIconstructors_collect :: (FMap Name Names)
            _simpletypeIgenericAbstractions_collect :: (FMap Name Kind)
            _simpletypeIinferkind :: (Kind)
            _simpletypeIkinames :: (KSubst)
            _simpletypeIkind_errors :: ([GHError])
            _simpletypeIkindvar :: (Int)
            _simpletypeIksubst :: (KSubst)
            _simpletypeIlabels_collect :: (FMap Name Names)
            _simpletypeImethods_collect :: (FMap Name Names)
            _simpletypeIname :: (Name)
            _simpletypeIself :: (SimpleType)
            _simpletypeOclassname :: (Maybe Name)
            _simpletypeOconstructors_collect :: (FMap Name Names)
            _simpletypeOconstructors_dist :: (FMap Name Names)
            _simpletypeOcurrentModule :: (Strings)
            _simpletypeOgenericAbstractions :: (FMap Name Kind)
            _simpletypeOgenericAbstractions_collect :: (FMap Name Kind)
            _simpletypeOghc :: (Bool)
            _simpletypeOimportedModule :: (Bool)
            _simpletypeOinstancename :: (Maybe Name)
            _simpletypeOkinames :: (KSubst)
            _simpletypeOkinds :: (KSubst)
            _simpletypeOkindvar :: (Int)
            _simpletypeOksubst :: (KSubst)
            _simpletypeOlabels_collect :: (FMap Name Names)
            _simpletypeOlabels_dist :: (FMap Name Names)
            _simpletypeOlocal :: (Bool)
            _simpletypeOmethods_collect :: (FMap Name Names)
            _simpletypeOmethods_dist :: (FMap Name Names)
            _simpletypeOmodules :: (Set Strings)
            _simpletypeOoptimizer :: (Bool)
            _simpletypeOoptimizerPrelude :: (Declarations)
            _simpletypeOprekind :: (KSubst)
            _simpletypeOprelude :: (Bool)
            _simpletypeOtoplevel :: (Bool)
            _simpletypeOverbosity :: (Int)
            _whereIabstractTypes_collect :: (Set Name)
            _whereIbimapImps_collect :: ([Request_BimapImply])
            _whereIconstructors_collect :: (FMap Name Names)
            _whereIdepConstraints_collect :: ([DepConstraint])
            _whereIexportedDeclarations :: (MaybeDeclarations)
            _whereIfunImps_collect :: ([Request_FunImply])
            _whereIgenericAbstractions_collect :: (FMap Name Kind)
            _whereIkinames :: (KSubst)
            _whereIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _whereIkind_errors :: ([GHError])
            _whereIkindvar :: (Int)
            _whereIksubst :: (KSubst)
            _whereIlabels_collect :: (FMap Name Names)
            _whereImethods_collect :: (FMap Name Names)
            _whereIpresignatures_collect :: (PreSignatures)
            _whereIrawRequests_collect :: ([RawRequest])
            _whereIself :: (MaybeDeclarations)
            _whereIstaticErrors :: ([GHError])
            _whereIstructureTypes_collect :: (FMap Name LambdaType)
            _whereItypeImps_collect :: ([Request_TypeImply])
            _whereOabstractTypes_collect :: (Set Name)
            _whereObimapImps_collect :: ([Request_BimapImply])
            _whereOclassname :: (Maybe Name)
            _whereOconstructors_collect :: (FMap Name Names)
            _whereOconstructors_dist :: (FMap Name Names)
            _whereOcurrentModule :: (Strings)
            _whereOdependencies :: (FMap Name [(Name,Name)])
            _whereOexportedStructures :: (Set Name)
            _whereOexportedTypes :: (Set Name)
            _whereOexportedValues :: (Set Name)
            _whereOfunImps_collect :: ([Request_FunImply])
            _whereOgenericAbstractions :: (FMap Name Kind)
            _whereOgenericAbstractions_collect :: (FMap Name Kind)
            _whereOghc :: (Bool)
            _whereOimportedModule :: (Bool)
            _whereOinstancename :: (Maybe Name)
            _whereOkinames :: (KSubst)
            _whereOkindIndexedTypes :: (FMap Name KindIndexedType)
            _whereOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _whereOkinds :: (KSubst)
            _whereOkindvar :: (Int)
            _whereOksubst :: (KSubst)
            _whereOlabels_collect :: (FMap Name Names)
            _whereOlabels_dist :: (FMap Name Names)
            _whereOlocal :: (Bool)
            _whereOmethods_collect :: (FMap Name Names)
            _whereOmethods_dist :: (FMap Name Names)
            _whereOmodules :: (Set Strings)
            _whereOoptimizer :: (Bool)
            _whereOoptimizerPrelude :: (Declarations)
            _whereOprekind :: (KSubst)
            _whereOprelude :: (Bool)
            _whereOpresignatures :: (PreSignatures)
            _whereOpresignatures_collect :: (PreSignatures)
            _whereOrawRequests_collect :: ([RawRequest])
            _whereOsignatures :: (Signatures)
            _whereOstructureTypes_collect :: (FMap Name LambdaType)
            _whereOtoplevel :: (Bool)
            _whereOtypeImps_collect :: ([Request_TypeImply])
            _whereOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _contextIabstractTypes_collect,_contextIbimapImps_collect,_contextIconstructors_collect,_contextIdepConstraints_collect,_contextIfunImps_collect,_contextIgenericAbstractions_collect,_contextIkinames,_contextIkind_errors,_contextIkindvar,_contextIksubst,_contextIlabels_collect,_contextImethods_collect,_contextIrawRequests_collect,_contextIself,_contextIstaticErrors,_contextItypeImps_collect) =
                (context_ (_contextOabstractTypes_collect)
                          (_contextObimapImps_collect)
                          (_contextOclassname)
                          (_contextOconstructors_collect)
                          (_contextOconstructors_dist)
                          (_contextOcurrentModule)
                          (_contextOdependencies)
                          (_contextOfunImps_collect)
                          (_contextOgenericAbstractions)
                          (_contextOgenericAbstractions_collect)
                          (_contextOghc)
                          (_contextOimportedModule)
                          (_contextOinstancename)
                          (_contextOkinames)
                          (_contextOkinds)
                          (_contextOkindvar)
                          (_contextOksubst)
                          (_contextOlabels_collect)
                          (_contextOlabels_dist)
                          (_contextOlocal)
                          (_contextOmethods_collect)
                          (_contextOmethods_dist)
                          (_contextOmodules)
                          (_contextOoptimizer)
                          (_contextOoptimizerPrelude)
                          (_contextOprekind)
                          (_contextOprelude)
                          (_contextOrawRequests_collect)
                          (_contextOtoplevel)
                          (_contextOtypeImps_collect)
                          (_contextOverbosity))
            ( _simpletypeIconstructors_collect,_simpletypeIgenericAbstractions_collect,_simpletypeIinferkind,_simpletypeIkinames,_simpletypeIkind_errors,_simpletypeIkindvar,_simpletypeIksubst,_simpletypeIlabels_collect,_simpletypeImethods_collect,_simpletypeIname,_simpletypeIself) =
                (simpletype_ (_simpletypeOclassname)
                             (_simpletypeOconstructors_collect)
                             (_simpletypeOconstructors_dist)
                             (_simpletypeOcurrentModule)
                             (_simpletypeOgenericAbstractions)
                             (_simpletypeOgenericAbstractions_collect)
                             (_simpletypeOghc)
                             (_simpletypeOimportedModule)
                             (_simpletypeOinstancename)
                             (_simpletypeOkinames)
                             (_simpletypeOkinds)
                             (_simpletypeOkindvar)
                             (_simpletypeOksubst)
                             (_simpletypeOlabels_collect)
                             (_simpletypeOlabels_dist)
                             (_simpletypeOlocal)
                             (_simpletypeOmethods_collect)
                             (_simpletypeOmethods_dist)
                             (_simpletypeOmodules)
                             (_simpletypeOoptimizer)
                             (_simpletypeOoptimizerPrelude)
                             (_simpletypeOprekind)
                             (_simpletypeOprelude)
                             (_simpletypeOtoplevel)
                             (_simpletypeOverbosity))
            ( _whereIabstractTypes_collect
             ,_whereIbimapImps_collect
             ,_whereIconstructors_collect
             ,_whereIdepConstraints_collect
             ,_whereIexportedDeclarations
             ,_whereIfunImps_collect
             ,_whereIgenericAbstractions_collect
             ,_whereIkinames
             ,_whereIkindIndexedTypes_collect
             ,_whereIkind_errors
             ,_whereIkindvar
             ,_whereIksubst
             ,_whereIlabels_collect
             ,_whereImethods_collect
             ,_whereIpresignatures_collect
             ,_whereIrawRequests_collect
             ,_whereIself
             ,_whereIstaticErrors
             ,_whereIstructureTypes_collect
             ,_whereItypeImps_collect
             ) =
                (where_ (_whereOabstractTypes_collect)
                        (_whereObimapImps_collect)
                        (_whereOclassname)
                        (_whereOconstructors_collect)
                        (_whereOconstructors_dist)
                        (_whereOcurrentModule)
                        (_whereOdependencies)
                        (_whereOexportedStructures)
                        (_whereOexportedTypes)
                        (_whereOexportedValues)
                        (_whereOfunImps_collect)
                        (_whereOgenericAbstractions)
                        (_whereOgenericAbstractions_collect)
                        (_whereOghc)
                        (_whereOimportedModule)
                        (_whereOinstancename)
                        (_whereOkinames)
                        (_whereOkindIndexedTypes)
                        (_whereOkindIndexedTypes_collect)
                        (_whereOkinds)
                        (_whereOkindvar)
                        (_whereOksubst)
                        (_whereOlabels_collect)
                        (_whereOlabels_dist)
                        (_whereOlocal)
                        (_whereOmethods_collect)
                        (_whereOmethods_dist)
                        (_whereOmodules)
                        (_whereOoptimizer)
                        (_whereOoptimizerPrelude)
                        (_whereOprekind)
                        (_whereOprelude)
                        (_whereOpresignatures)
                        (_whereOpresignatures_collect)
                        (_whereOrawRequests_collect)
                        (_whereOsignatures)
                        (_whereOstructureTypes_collect)
                        (_whereOtoplevel)
                        (_whereOtypeImps_collect)
                        (_whereOverbosity))
            -- "./ModuleInformation.inc.lag"(line 138, column 8)
            (_classname@_) =
                Just _simpletypeIname
            -- "./ModuleInformation.inc.lag"(line 331, column 9)
            (_whereOmethods_collect@_) =
                add _lhsImethods_collect
                    (_simpletypeIname,[])
            -- "./Output.inc.lag"(line 208, column 9)
            (_lhsOoutput@_) =
                if _lhsIimportedModule then
                  PP.emptyPP
                else
                  PP.ppDeclaration False
                    (ER.replaceDeclaration
                       _lhsIdependencies
                       FMap.emptyFM
                       _lhsIgenericAbstractions
                       _self
                    )
            -- "./Exports.inc.lag"(line 530, column 9)
            (_is_exported@_) =
                Set.elementOf _simpletypeIname _lhsIexportedTypes
            -- "./OutputI.inc.lag"(line 177, column 9)
            (_lhsOexportedDeclarations@_) =
                []
            -- "./OutputI.inc.lag"(line 166, column 9)
            (_lhsOoutputi@_) =
                if _is_exported then
                  [PP.ppDeclaration True
                     (Declaration_Class
                        _rangeIself
                        _contextIself
                        _simpletypeIself
                        _whereIexportedDeclarations
                     )
                  ]
                else
                  []
            -- "./Kind.inc.lag"(line 213, column 9)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- "./Kind.inc.lag"(line 212, column 9)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- "./Kind.inc.lag"(line 656, column 9)
            (_lhsOkind_errors@_) =
                []
            -- "./Kind.inc.lag"(line 655, column 9)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _contextIdepConstraints_collect ++ _whereIdepConstraints_collect
            -- use rule
            (_lhsOdepConstraints_defined@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                _contextIstaticErrors ++ _whereIstaticErrors
            -- self rule
            (_self@_) =
                Declaration_Class _rangeIself _contextIself _simpletypeIself _whereIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _whereIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _whereIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _whereIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _whereIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _whereIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _whereIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _whereIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _whereImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _whereIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _whereIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _whereIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _whereItypeImps_collect
            -- copy rule (chain)
            (_rangeOclassname@_) =
                _classname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_contextOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_contextObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (chain)
            (_contextOclassname@_) =
                _classname
            -- copy rule (down)
            (_contextOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_contextOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_contextOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_contextOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_contextOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_contextOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_contextOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_contextOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_contextOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_contextOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_contextOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_contextOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_contextOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_contextOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_contextOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_contextOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_contextOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_contextOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_contextOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_contextOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_contextOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_contextOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_contextOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_contextOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_contextOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_contextOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_contextOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_contextOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_simpletypeOclassname@_) =
                _classname
            -- copy rule (chain)
            (_simpletypeOconstructors_collect@_) =
                _contextIconstructors_collect
            -- copy rule (down)
            (_simpletypeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_simpletypeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_simpletypeOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_simpletypeOgenericAbstractions_collect@_) =
                _contextIgenericAbstractions_collect
            -- copy rule (down)
            (_simpletypeOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_simpletypeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_simpletypeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_simpletypeOkinames@_) =
                _contextIkinames
            -- copy rule (down)
            (_simpletypeOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_simpletypeOkindvar@_) =
                _contextIkindvar
            -- copy rule (chain)
            (_simpletypeOksubst@_) =
                _contextIksubst
            -- copy rule (chain)
            (_simpletypeOlabels_collect@_) =
                _contextIlabels_collect
            -- copy rule (down)
            (_simpletypeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_simpletypeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_simpletypeOmethods_collect@_) =
                _contextImethods_collect
            -- copy rule (down)
            (_simpletypeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_simpletypeOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_simpletypeOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_simpletypeOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_simpletypeOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_simpletypeOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_simpletypeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_simpletypeOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_whereOabstractTypes_collect@_) =
                _contextIabstractTypes_collect
            -- copy rule (chain)
            (_whereObimapImps_collect@_) =
                _contextIbimapImps_collect
            -- copy rule (chain)
            (_whereOclassname@_) =
                _classname
            -- copy rule (chain)
            (_whereOconstructors_collect@_) =
                _simpletypeIconstructors_collect
            -- copy rule (down)
            (_whereOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_whereOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_whereOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_whereOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_whereOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_whereOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (chain)
            (_whereOfunImps_collect@_) =
                _contextIfunImps_collect
            -- copy rule (down)
            (_whereOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_whereOgenericAbstractions_collect@_) =
                _simpletypeIgenericAbstractions_collect
            -- copy rule (down)
            (_whereOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_whereOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_whereOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_whereOkinames@_) =
                _simpletypeIkinames
            -- copy rule (down)
            (_whereOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_whereOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_whereOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_whereOkindvar@_) =
                _simpletypeIkindvar
            -- copy rule (chain)
            (_whereOksubst@_) =
                _simpletypeIksubst
            -- copy rule (chain)
            (_whereOlabels_collect@_) =
                _simpletypeIlabels_collect
            -- copy rule (down)
            (_whereOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_whereOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_whereOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_whereOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_whereOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_whereOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_whereOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_whereOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_whereOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_whereOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (chain)
            (_whereOrawRequests_collect@_) =
                _contextIrawRequests_collect
            -- copy rule (down)
            (_whereOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_whereOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_whereOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_whereOtypeImps_collect@_) =
                _contextItypeImps_collect
            -- copy rule (down)
            (_whereOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect
             ,_lhsObimapImps_collect
             ,_lhsOconstructors_collect
             ,_lhsOdepConstraints_collect
             ,_lhsOdepConstraints_defined
             ,_lhsOexportedDeclarations
             ,_lhsOfunImps_collect
             ,_lhsOgenericAbstractions_collect
             ,_lhsOkinames
             ,_lhsOkindIndexedTypes_collect
             ,_lhsOkind_errors
             ,_lhsOkindvar
             ,_lhsOksubst
             ,_lhsOlabels_collect
             ,_lhsOmethods_collect
             ,_lhsOoutput
             ,_lhsOoutputi
             ,_lhsOpresignatures_collect
             ,_lhsOrawRequests_collect
             ,_lhsOself
             ,_lhsOstaticErrors
             ,_lhsOstructureTypes_collect
             ,_lhsOtypeImps_collect
             )
sem_Declaration_Data :: (T_Range) ->
                        (T_ContextItems) ->
                        (T_SimpleType) ->
                        (T_Constructors) ->
                        (T_Names) ->
                        (T_Declaration)
sem_Declaration_Data (range_) (context_) (simpletype_) (constructors_) (derivings_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOdepConstraints_defined :: ([DepConstraint])
            _lhsOexportedDeclarations :: (Declarations)
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: (PP.Doc)
            _lhsOoutputi :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Declaration)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _contextIabstractTypes_collect :: (Set Name)
            _contextIbimapImps_collect :: ([Request_BimapImply])
            _contextIconstructors_collect :: (FMap Name Names)
            _contextIdepConstraints_collect :: ([DepConstraint])
            _contextIfunImps_collect :: ([Request_FunImply])
            _contextIgenericAbstractions_collect :: (FMap Name Kind)
            _contextIkinames :: (KSubst)
            _contextIkind_errors :: ([GHError])
            _contextIkindvar :: (Int)
            _contextIksubst :: (KSubst)
            _contextIlabels_collect :: (FMap Name Names)
            _contextImethods_collect :: (FMap Name Names)
            _contextIrawRequests_collect :: ([RawRequest])
            _contextIself :: (ContextItems)
            _contextIstaticErrors :: ([GHError])
            _contextItypeImps_collect :: ([Request_TypeImply])
            _contextOabstractTypes_collect :: (Set Name)
            _contextObimapImps_collect :: ([Request_BimapImply])
            _contextOclassname :: (Maybe Name)
            _contextOconstructors_collect :: (FMap Name Names)
            _contextOconstructors_dist :: (FMap Name Names)
            _contextOcurrentModule :: (Strings)
            _contextOdependencies :: (FMap Name [(Name,Name)])
            _contextOfunImps_collect :: ([Request_FunImply])
            _contextOgenericAbstractions :: (FMap Name Kind)
            _contextOgenericAbstractions_collect :: (FMap Name Kind)
            _contextOghc :: (Bool)
            _contextOimportedModule :: (Bool)
            _contextOinstancename :: (Maybe Name)
            _contextOkinames :: (KSubst)
            _contextOkinds :: (KSubst)
            _contextOkindvar :: (Int)
            _contextOksubst :: (KSubst)
            _contextOlabels_collect :: (FMap Name Names)
            _contextOlabels_dist :: (FMap Name Names)
            _contextOlocal :: (Bool)
            _contextOmethods_collect :: (FMap Name Names)
            _contextOmethods_dist :: (FMap Name Names)
            _contextOmodules :: (Set Strings)
            _contextOoptimizer :: (Bool)
            _contextOoptimizerPrelude :: (Declarations)
            _contextOprekind :: (KSubst)
            _contextOprelude :: (Bool)
            _contextOrawRequests_collect :: ([RawRequest])
            _contextOtoplevel :: (Bool)
            _contextOtypeImps_collect :: ([Request_TypeImply])
            _contextOverbosity :: (Int)
            _simpletypeIconstructors_collect :: (FMap Name Names)
            _simpletypeIgenericAbstractions_collect :: (FMap Name Kind)
            _simpletypeIinferkind :: (Kind)
            _simpletypeIkinames :: (KSubst)
            _simpletypeIkind_errors :: ([GHError])
            _simpletypeIkindvar :: (Int)
            _simpletypeIksubst :: (KSubst)
            _simpletypeIlabels_collect :: (FMap Name Names)
            _simpletypeImethods_collect :: (FMap Name Names)
            _simpletypeIname :: (Name)
            _simpletypeIself :: (SimpleType)
            _simpletypeOclassname :: (Maybe Name)
            _simpletypeOconstructors_collect :: (FMap Name Names)
            _simpletypeOconstructors_dist :: (FMap Name Names)
            _simpletypeOcurrentModule :: (Strings)
            _simpletypeOgenericAbstractions :: (FMap Name Kind)
            _simpletypeOgenericAbstractions_collect :: (FMap Name Kind)
            _simpletypeOghc :: (Bool)
            _simpletypeOimportedModule :: (Bool)
            _simpletypeOinstancename :: (Maybe Name)
            _simpletypeOkinames :: (KSubst)
            _simpletypeOkinds :: (KSubst)
            _simpletypeOkindvar :: (Int)
            _simpletypeOksubst :: (KSubst)
            _simpletypeOlabels_collect :: (FMap Name Names)
            _simpletypeOlabels_dist :: (FMap Name Names)
            _simpletypeOlocal :: (Bool)
            _simpletypeOmethods_collect :: (FMap Name Names)
            _simpletypeOmethods_dist :: (FMap Name Names)
            _simpletypeOmodules :: (Set Strings)
            _simpletypeOoptimizer :: (Bool)
            _simpletypeOoptimizerPrelude :: (Declarations)
            _simpletypeOprekind :: (KSubst)
            _simpletypeOprelude :: (Bool)
            _simpletypeOtoplevel :: (Bool)
            _simpletypeOverbosity :: (Int)
            _constructorsIabstractTypes_collect :: (Set Name)
            _constructorsIbimapImps_collect :: ([Request_BimapImply])
            _constructorsIconsname :: (Names)
            _constructorsIconstructors :: (Names)
            _constructorsIconstructors_collect :: (FMap Name Names)
            _constructorsIdepConstraints_collect :: ([DepConstraint])
            _constructorsIfunImps_collect :: ([Request_FunImply])
            _constructorsIgenericAbstractions_collect :: (FMap Name Kind)
            _constructorsIkinames :: (KSubst)
            _constructorsIkind_errors :: ([GHError])
            _constructorsIkindvar :: (Int)
            _constructorsIksubst :: (KSubst)
            _constructorsIlabels :: (Names)
            _constructorsIlabels_collect :: (FMap Name Names)
            _constructorsImethods_collect :: (FMap Name Names)
            _constructorsIrawRequests_collect :: ([RawRequest])
            _constructorsIself :: (Constructors)
            _constructorsIstaticErrors :: ([GHError])
            _constructorsItypeImps :: ([Type])
            _constructorsItypeImps_collect :: ([Request_TypeImply])
            _constructorsOabstractTypes_collect :: (Set Name)
            _constructorsObimapImps_collect :: ([Request_BimapImply])
            _constructorsOclassname :: (Maybe Name)
            _constructorsOconstructors_collect :: (FMap Name Names)
            _constructorsOconstructors_dist :: (FMap Name Names)
            _constructorsOcurrentModule :: (Strings)
            _constructorsOdependencies :: (FMap Name [(Name,Name)])
            _constructorsOfunImps_collect :: ([Request_FunImply])
            _constructorsOgenericAbstractions :: (FMap Name Kind)
            _constructorsOgenericAbstractions_collect :: (FMap Name Kind)
            _constructorsOghc :: (Bool)
            _constructorsOimportedModule :: (Bool)
            _constructorsOinstancename :: (Maybe Name)
            _constructorsOkinames :: (KSubst)
            _constructorsOkinds :: (KSubst)
            _constructorsOkindvar :: (Int)
            _constructorsOksubst :: (KSubst)
            _constructorsOlabels_collect :: (FMap Name Names)
            _constructorsOlabels_dist :: (FMap Name Names)
            _constructorsOlocal :: (Bool)
            _constructorsOmethods_collect :: (FMap Name Names)
            _constructorsOmethods_dist :: (FMap Name Names)
            _constructorsOmodules :: (Set Strings)
            _constructorsOoptimizer :: (Bool)
            _constructorsOoptimizerPrelude :: (Declarations)
            _constructorsOprekind :: (KSubst)
            _constructorsOprelude :: (Bool)
            _constructorsOrawRequests_collect :: ([RawRequest])
            _constructorsOtoplevel :: (Bool)
            _constructorsOtypeImps_collect :: ([Request_TypeImply])
            _constructorsOverbosity :: (Int)
            _derivingsIconstructors_collect :: (FMap Name Names)
            _derivingsIgenericAbstractions_collect :: (FMap Name Kind)
            _derivingsIinferkind :: (Kind)
            _derivingsIkinames :: (KSubst)
            _derivingsIkind_errors :: ([GHError])
            _derivingsIkindvar :: (Int)
            _derivingsIksubst :: (KSubst)
            _derivingsIlabels_collect :: (FMap Name Names)
            _derivingsImethods_collect :: (FMap Name Names)
            _derivingsIself :: (Names)
            _derivingsOclassname :: (Maybe Name)
            _derivingsOconstructors_collect :: (FMap Name Names)
            _derivingsOconstructors_dist :: (FMap Name Names)
            _derivingsOcurrentModule :: (Strings)
            _derivingsOgenericAbstractions :: (FMap Name Kind)
            _derivingsOgenericAbstractions_collect :: (FMap Name Kind)
            _derivingsOghc :: (Bool)
            _derivingsOimportedModule :: (Bool)
            _derivingsOinstancename :: (Maybe Name)
            _derivingsOkinames :: (KSubst)
            _derivingsOkinds :: (KSubst)
            _derivingsOkindvar :: (Int)
            _derivingsOksubst :: (KSubst)
            _derivingsOlabels_collect :: (FMap Name Names)
            _derivingsOlabels_dist :: (FMap Name Names)
            _derivingsOlocal :: (Bool)
            _derivingsOmethods_collect :: (FMap Name Names)
            _derivingsOmethods_dist :: (FMap Name Names)
            _derivingsOmodules :: (Set Strings)
            _derivingsOoptimizer :: (Bool)
            _derivingsOoptimizerPrelude :: (Declarations)
            _derivingsOprekind :: (KSubst)
            _derivingsOprelude :: (Bool)
            _derivingsOtoplevel :: (Bool)
            _derivingsOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _contextIabstractTypes_collect,_contextIbimapImps_collect,_contextIconstructors_collect,_contextIdepConstraints_collect,_contextIfunImps_collect,_contextIgenericAbstractions_collect,_contextIkinames,_contextIkind_errors,_contextIkindvar,_contextIksubst,_contextIlabels_collect,_contextImethods_collect,_contextIrawRequests_collect,_contextIself,_contextIstaticErrors,_contextItypeImps_collect) =
                (context_ (_contextOabstractTypes_collect)
                          (_contextObimapImps_collect)
                          (_contextOclassname)
                          (_contextOconstructors_collect)
                          (_contextOconstructors_dist)
                          (_contextOcurrentModule)
                          (_contextOdependencies)
                          (_contextOfunImps_collect)
                          (_contextOgenericAbstractions)
                          (_contextOgenericAbstractions_collect)
                          (_contextOghc)
                          (_contextOimportedModule)
                          (_contextOinstancename)
                          (_contextOkinames)
                          (_contextOkinds)
                          (_contextOkindvar)
                          (_contextOksubst)
                          (_contextOlabels_collect)
                          (_contextOlabels_dist)
                          (_contextOlocal)
                          (_contextOmethods_collect)
                          (_contextOmethods_dist)
                          (_contextOmodules)
                          (_contextOoptimizer)
                          (_contextOoptimizerPrelude)
                          (_contextOprekind)
                          (_contextOprelude)
                          (_contextOrawRequests_collect)
                          (_contextOtoplevel)
                          (_contextOtypeImps_collect)
                          (_contextOverbosity))
            ( _simpletypeIconstructors_collect,_simpletypeIgenericAbstractions_collect,_simpletypeIinferkind,_simpletypeIkinames,_simpletypeIkind_errors,_simpletypeIkindvar,_simpletypeIksubst,_simpletypeIlabels_collect,_simpletypeImethods_collect,_simpletypeIname,_simpletypeIself) =
                (simpletype_ (_simpletypeOclassname)
                             (_simpletypeOconstructors_collect)
                             (_simpletypeOconstructors_dist)
                             (_simpletypeOcurrentModule)
                             (_simpletypeOgenericAbstractions)
                             (_simpletypeOgenericAbstractions_collect)
                             (_simpletypeOghc)
                             (_simpletypeOimportedModule)
                             (_simpletypeOinstancename)
                             (_simpletypeOkinames)
                             (_simpletypeOkinds)
                             (_simpletypeOkindvar)
                             (_simpletypeOksubst)
                             (_simpletypeOlabels_collect)
                             (_simpletypeOlabels_dist)
                             (_simpletypeOlocal)
                             (_simpletypeOmethods_collect)
                             (_simpletypeOmethods_dist)
                             (_simpletypeOmodules)
                             (_simpletypeOoptimizer)
                             (_simpletypeOoptimizerPrelude)
                             (_simpletypeOprekind)
                             (_simpletypeOprelude)
                             (_simpletypeOtoplevel)
                             (_simpletypeOverbosity))
            ( _constructorsIabstractTypes_collect
             ,_constructorsIbimapImps_collect
             ,_constructorsIconsname
             ,_constructorsIconstructors
             ,_constructorsIconstructors_collect
             ,_constructorsIdepConstraints_collect
             ,_constructorsIfunImps_collect
             ,_constructorsIgenericAbstractions_collect
             ,_constructorsIkinames
             ,_constructorsIkind_errors
             ,_constructorsIkindvar
             ,_constructorsIksubst
             ,_constructorsIlabels
             ,_constructorsIlabels_collect
             ,_constructorsImethods_collect
             ,_constructorsIrawRequests_collect
             ,_constructorsIself
             ,_constructorsIstaticErrors
             ,_constructorsItypeImps
             ,_constructorsItypeImps_collect
             ) =
                (constructors_ (_constructorsOabstractTypes_collect)
                               (_constructorsObimapImps_collect)
                               (_constructorsOclassname)
                               (_constructorsOconstructors_collect)
                               (_constructorsOconstructors_dist)
                               (_constructorsOcurrentModule)
                               (_constructorsOdependencies)
                               (_constructorsOfunImps_collect)
                               (_constructorsOgenericAbstractions)
                               (_constructorsOgenericAbstractions_collect)
                               (_constructorsOghc)
                               (_constructorsOimportedModule)
                               (_constructorsOinstancename)
                               (_constructorsOkinames)
                               (_constructorsOkinds)
                               (_constructorsOkindvar)
                               (_constructorsOksubst)
                               (_constructorsOlabels_collect)
                               (_constructorsOlabels_dist)
                               (_constructorsOlocal)
                               (_constructorsOmethods_collect)
                               (_constructorsOmethods_dist)
                               (_constructorsOmodules)
                               (_constructorsOoptimizer)
                               (_constructorsOoptimizerPrelude)
                               (_constructorsOprekind)
                               (_constructorsOprelude)
                               (_constructorsOrawRequests_collect)
                               (_constructorsOtoplevel)
                               (_constructorsOtypeImps_collect)
                               (_constructorsOverbosity))
            ( _derivingsIconstructors_collect,_derivingsIgenericAbstractions_collect,_derivingsIinferkind,_derivingsIkinames,_derivingsIkind_errors,_derivingsIkindvar,_derivingsIksubst,_derivingsIlabels_collect,_derivingsImethods_collect,_derivingsIself) =
                (derivings_ (_derivingsOclassname)
                            (_derivingsOconstructors_collect)
                            (_derivingsOconstructors_dist)
                            (_derivingsOcurrentModule)
                            (_derivingsOgenericAbstractions)
                            (_derivingsOgenericAbstractions_collect)
                            (_derivingsOghc)
                            (_derivingsOimportedModule)
                            (_derivingsOinstancename)
                            (_derivingsOkinames)
                            (_derivingsOkinds)
                            (_derivingsOkindvar)
                            (_derivingsOksubst)
                            (_derivingsOlabels_collect)
                            (_derivingsOlabels_dist)
                            (_derivingsOlocal)
                            (_derivingsOmethods_collect)
                            (_derivingsOmethods_dist)
                            (_derivingsOmodules)
                            (_derivingsOoptimizer)
                            (_derivingsOoptimizerPrelude)
                            (_derivingsOprekind)
                            (_derivingsOprelude)
                            (_derivingsOtoplevel)
                            (_derivingsOverbosity))
            -- "GH.lag"(line 356, column 13)
            ((_strtype@_,_ep@_,_contype@_,_descriptors@_)) =
                ST.all _self
            -- "./ModuleInformation.inc.lag"(line 317, column 9)
            (_lhsOlabels_collect@_) =
                add _lhsIlabels_collect
                    (_simpletypeIname,_constructorsIlabels)
            -- "./ModuleInformation.inc.lag"(line 315, column 9)
            (_lhsOconstructors_collect@_) =
                add _lhsIconstructors_collect
                    (_simpletypeIname,_constructorsIconstructors)
            -- "./Output.inc.lag"(line 168, column 9)
            (_lhsOoutput@_) =
                let kc = [mkKindComment
                            _simpletypeIname
                            _kind
                         ]
                    sc = [mkStrTypeComment _simpletypeIname]
                    ec = [mkEPComment _simpletypeIname]
                    dc = [mkDescrComment _simpletypeIname]
                in  PP.vcat . concat $
                      [ kc
                      , if _lhsIimportedModule then
                          []
                        else
                          [PP.ppDeclarationWithKind False _self _kind _lhsIghc]
                      , PP.ppDeclarationsWithKind False _contype _kind _lhsIghc
                      , sc, PP.ppDeclarationsWithKind False _strtype _kind _lhsIghc
                      , ec, PP.ppDeclarations False _ep
                      , dc, PP.ppDeclarations False _descriptors
                      ]
            -- "./Exports.inc.lag"(line 509, column 9)
            (_subs_exported@_) =
                filter
                  (\n -> Set.elementOf n _lhsIexportedValues)
                  _constructorsIconstructors
            -- "./Exports.inc.lag"(line 501, column 9)
            (_structure_exported@_) =
                Set.elementOf
                  _simpletypeIname
                  _lhsIexportedStructures
            -- "./Exports.inc.lag"(line 498, column 9)
            (_is_exported@_) =
                Set.elementOf
                  _simpletypeIname
                  _lhsIexportedTypes
            -- "./OutputI.inc.lag"(line 146, column 9)
            (_is_implied@_) =
                False
            -- "./OutputI.inc.lag"(line 132, column 9)
            (_lhsOoutputi@_) =
                if _is_implied || _structure_exported then
                  [PP.ppDeclarationWithKind True _self _kind True]
                else
                  [PP.ppInterfaceDeclaration True
                     (InterfaceDeclaration_Abstract
                        unknownRange
                        _simpletypeIname
                        _subs_exported
                        (replicate (length _subs_exported)
                                   (faNT ["a"] $ varNT "a")
                        )
                        _kind
                     )
                  ]
            -- "./Kind.inc.lag"(line 170, column 9)
            (_constructorsOprekind@_) =
                _simpletypeIkinames
            -- "./Kind.inc.lag"(line 169, column 9)
            (_simpletypeOkinames@_) =
                _lhsIprekind
            -- "./Kind.inc.lag"(line 168, column 9)
            (_lhsOkinames@_) =
                _kinames
            -- "./Kind.inc.lag"(line 167, column 9)
            (_kinames@_) =
                foldl add _lhsIkinames _new_kinames
            -- "./Kind.inc.lag"(line 165, column 9)
            (_new_kinames@_) =
                map (\ n -> (n,_kvar))
                  (_simpletypeIname : _constructorsIconsname)
            -- "./Kind.inc.lag"(line 164, column 9)
            (_kvar@_) =
                mkKindVar' _kindvar
            -- "./Kind.inc.lag"(line 163, column 9)
            (_kindvar@_) =
                _lhsIkindvar + 1
            -- "./Kind.inc.lag"(line 585, column 9)
            (_lhsOkind_errors@_) =
                _constructorsIkind_errors ++ _kind_errors
            -- "./Kind.inc.lag"(line 584, column 9)
            (_lhsOksubst@_) =
                removeKindVars _kvar _ksubstKV
            -- "./Kind.inc.lag"(line 579, column 13)
            ((_ksubstKV@_,_kind_errors@_)) =
                unifyToplevel _rangeIself
                  _simpletypeIname "data"
                  _kvar _simpletypeIinferkind
                  _constructorsIksubst
            -- "./Kind.inc.lag"(line 744, column 9)
            (_kind@_) =
                fromJust $ find _lhsIkinds _simpletypeIname
            -- "./Request.inc.lag"(line 146, column 9)
            (_lhsOtypeImps_collect@_) =
                Request_TypeImply
                  (Types.conT _simpletypeIname
                  ,_typeImps
                  )
                  : _lhsItypeImps_collect
            -- "./Request.inc.lag"(line 191, column 9)
            (_typeImps@_) =
                List.nubBy
                  matchType
                  (_imply_Con ++ _imply_Sum
                     ++ _constructorsItypeImps
                  )
            -- "./Request.inc.lag"(line 187, column 9)
            (_imply_Sum@_) =
                if length _constructorsIself > 1 then
                  [Types.conT sumName]
                else
                  []
            -- "./Request.inc.lag"(line 186, column 9)
            (_imply_Con@_) =
                [Types.conT conName]
            -- "./Request.inc.lag"(line 525, column 9)
            (_lhsOstructureTypes_collect@_) =
                foldl add
                  _lhsIstructureTypes_collect
                  (extractStructureTypes _strtype)
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _contextIdepConstraints_collect ++ _constructorsIdepConstraints_collect
            -- use rule
            (_lhsOdepConstraints_defined@_) =
                []
            -- use rule
            (_lhsOexportedDeclarations@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                _contextIstaticErrors ++ _constructorsIstaticErrors
            -- self rule
            (_self@_) =
                Declaration_Data _rangeIself _contextIself _simpletypeIself _constructorsIself _derivingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _constructorsIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _constructorsIbimapImps_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _constructorsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _derivingsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- modified copy rule
            (_lhsOkindvar@_) =
                _derivingsIkindvar
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _derivingsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _constructorsIrawRequests_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_contextOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_contextObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_contextOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_contextOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_contextOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_contextOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_contextOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_contextOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_contextOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_contextOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_contextOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_contextOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_contextOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_contextOkinames@_) =
                _kinames
            -- copy rule (down)
            (_contextOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_contextOkindvar@_) =
                _kindvar
            -- copy rule (down)
            (_contextOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_contextOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_contextOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_contextOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_contextOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_contextOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_contextOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_contextOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_contextOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_contextOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_contextOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_contextOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_contextOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_contextOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_contextOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_simpletypeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_simpletypeOconstructors_collect@_) =
                _contextIconstructors_collect
            -- copy rule (down)
            (_simpletypeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_simpletypeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_simpletypeOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_simpletypeOgenericAbstractions_collect@_) =
                _contextIgenericAbstractions_collect
            -- copy rule (down)
            (_simpletypeOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_simpletypeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_simpletypeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_simpletypeOkinds@_) =
                _lhsIkinds
            -- modified copy rule
            (_simpletypeOkindvar@_) =
                _contextIkindvar
            -- copy rule (chain)
            (_simpletypeOksubst@_) =
                _contextIksubst
            -- copy rule (chain)
            (_simpletypeOlabels_collect@_) =
                _contextIlabels_collect
            -- copy rule (down)
            (_simpletypeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_simpletypeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_simpletypeOmethods_collect@_) =
                _contextImethods_collect
            -- copy rule (down)
            (_simpletypeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_simpletypeOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_simpletypeOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_simpletypeOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_simpletypeOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_simpletypeOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_simpletypeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_simpletypeOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_constructorsOabstractTypes_collect@_) =
                _contextIabstractTypes_collect
            -- copy rule (chain)
            (_constructorsObimapImps_collect@_) =
                _contextIbimapImps_collect
            -- copy rule (down)
            (_constructorsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_constructorsOconstructors_collect@_) =
                _simpletypeIconstructors_collect
            -- copy rule (down)
            (_constructorsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_constructorsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_constructorsOdependencies@_) =
                _lhsIdependencies
            -- copy rule (chain)
            (_constructorsOfunImps_collect@_) =
                _contextIfunImps_collect
            -- copy rule (down)
            (_constructorsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_constructorsOgenericAbstractions_collect@_) =
                _simpletypeIgenericAbstractions_collect
            -- copy rule (down)
            (_constructorsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_constructorsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_constructorsOinstancename@_) =
                _lhsIinstancename
            -- modified copy rule
            (_constructorsOkinames@_) =
                _simpletypeIkinames
            -- copy rule (down)
            (_constructorsOkinds@_) =
                _lhsIkinds
            -- modified copy rule
            (_constructorsOkindvar@_) =
                _simpletypeIkindvar
            -- copy rule (chain)
            (_constructorsOksubst@_) =
                _simpletypeIksubst
            -- copy rule (chain)
            (_constructorsOlabels_collect@_) =
                _simpletypeIlabels_collect
            -- copy rule (down)
            (_constructorsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_constructorsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_constructorsOmethods_collect@_) =
                _simpletypeImethods_collect
            -- copy rule (down)
            (_constructorsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_constructorsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_constructorsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_constructorsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_constructorsOprelude@_) =
                _lhsIprelude
            -- copy rule (chain)
            (_constructorsOrawRequests_collect@_) =
                _contextIrawRequests_collect
            -- copy rule (down)
            (_constructorsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_constructorsOtypeImps_collect@_) =
                _contextItypeImps_collect
            -- copy rule (down)
            (_constructorsOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_derivingsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_derivingsOconstructors_collect@_) =
                _constructorsIconstructors_collect
            -- copy rule (down)
            (_derivingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_derivingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_derivingsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_derivingsOgenericAbstractions_collect@_) =
                _constructorsIgenericAbstractions_collect
            -- copy rule (down)
            (_derivingsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_derivingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_derivingsOinstancename@_) =
                _lhsIinstancename
            -- modified copy rule
            (_derivingsOkinames@_) =
                _constructorsIkinames
            -- copy rule (down)
            (_derivingsOkinds@_) =
                _lhsIkinds
            -- modified copy rule
            (_derivingsOkindvar@_) =
                _constructorsIkindvar
            -- copy rule (chain)
            (_derivingsOksubst@_) =
                _constructorsIksubst
            -- copy rule (chain)
            (_derivingsOlabels_collect@_) =
                _constructorsIlabels_collect
            -- copy rule (down)
            (_derivingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_derivingsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_derivingsOmethods_collect@_) =
                _constructorsImethods_collect
            -- copy rule (down)
            (_derivingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_derivingsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_derivingsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_derivingsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_derivingsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_derivingsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_derivingsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_derivingsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect
             ,_lhsObimapImps_collect
             ,_lhsOconstructors_collect
             ,_lhsOdepConstraints_collect
             ,_lhsOdepConstraints_defined
             ,_lhsOexportedDeclarations
             ,_lhsOfunImps_collect
             ,_lhsOgenericAbstractions_collect
             ,_lhsOkinames
             ,_lhsOkindIndexedTypes_collect
             ,_lhsOkind_errors
             ,_lhsOkindvar
             ,_lhsOksubst
             ,_lhsOlabels_collect
             ,_lhsOmethods_collect
             ,_lhsOoutput
             ,_lhsOoutputi
             ,_lhsOpresignatures_collect
             ,_lhsOrawRequests_collect
             ,_lhsOself
             ,_lhsOstaticErrors
             ,_lhsOstructureTypes_collect
             ,_lhsOtypeImps_collect
             )
sem_Declaration_Default :: (T_Range) ->
                           (T_Types) ->
                           (T_Declaration)
sem_Declaration_Default (range_) (types_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOdepConstraints_defined :: ([DepConstraint])
            _lhsOexportedDeclarations :: (Declarations)
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: (PP.Doc)
            _lhsOoutputi :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Declaration)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _typesIabstractTypes_collect :: (Set Name)
            _typesIbimapImps_collect :: ([Request_BimapImply])
            _typesIconstructors_collect :: (FMap Name Names)
            _typesIdepConstraints_collect :: ([DepConstraint])
            _typesIfunImps_collect :: ([Request_FunImply])
            _typesIgenericAbstractions_collect :: (FMap Name Kind)
            _typesIinferkind :: ([Kind])
            _typesIkinames :: (KSubst)
            _typesIkind_errors :: ([GHError])
            _typesIkindvar :: (Int)
            _typesIksubst :: (KSubst)
            _typesIlabels_collect :: (FMap Name Names)
            _typesImethods_collect :: (FMap Name Names)
            _typesIrawRequests_collect :: ([RawRequest])
            _typesIself :: (Types)
            _typesIstaticErrors :: ([GHError])
            _typesItypeImps_collect :: ([Request_TypeImply])
            _typesOabstractTypes_collect :: (Set Name)
            _typesObimapImps_collect :: ([Request_BimapImply])
            _typesOclassname :: (Maybe Name)
            _typesOconstructors_collect :: (FMap Name Names)
            _typesOconstructors_dist :: (FMap Name Names)
            _typesOcurrentModule :: (Strings)
            _typesOdependencies :: (FMap Name [(Name,Name)])
            _typesOfunImps_collect :: ([Request_FunImply])
            _typesOgenericAbstractions :: (FMap Name Kind)
            _typesOgenericAbstractions_collect :: (FMap Name Kind)
            _typesOghc :: (Bool)
            _typesOimportedModule :: (Bool)
            _typesOinstancename :: (Maybe Name)
            _typesOkinames :: (KSubst)
            _typesOkinds :: (KSubst)
            _typesOkindvar :: (Int)
            _typesOksubst :: (KSubst)
            _typesOlabels_collect :: (FMap Name Names)
            _typesOlabels_dist :: (FMap Name Names)
            _typesOlocal :: (Bool)
            _typesOmethods_collect :: (FMap Name Names)
            _typesOmethods_dist :: (FMap Name Names)
            _typesOmodules :: (Set Strings)
            _typesOoptimizer :: (Bool)
            _typesOoptimizerPrelude :: (Declarations)
            _typesOprekind :: (KSubst)
            _typesOprelude :: (Bool)
            _typesOrawRequests_collect :: ([RawRequest])
            _typesOtoplevel :: (Bool)
            _typesOtypeImps_collect :: ([Request_TypeImply])
            _typesOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _typesIabstractTypes_collect,_typesIbimapImps_collect,_typesIconstructors_collect,_typesIdepConstraints_collect,_typesIfunImps_collect,_typesIgenericAbstractions_collect,_typesIinferkind,_typesIkinames,_typesIkind_errors,_typesIkindvar,_typesIksubst,_typesIlabels_collect,_typesImethods_collect,_typesIrawRequests_collect,_typesIself,_typesIstaticErrors,_typesItypeImps_collect) =
                (types_ (_typesOabstractTypes_collect)
                        (_typesObimapImps_collect)
                        (_typesOclassname)
                        (_typesOconstructors_collect)
                        (_typesOconstructors_dist)
                        (_typesOcurrentModule)
                        (_typesOdependencies)
                        (_typesOfunImps_collect)
                        (_typesOgenericAbstractions)
                        (_typesOgenericAbstractions_collect)
                        (_typesOghc)
                        (_typesOimportedModule)
                        (_typesOinstancename)
                        (_typesOkinames)
                        (_typesOkinds)
                        (_typesOkindvar)
                        (_typesOksubst)
                        (_typesOlabels_collect)
                        (_typesOlabels_dist)
                        (_typesOlocal)
                        (_typesOmethods_collect)
                        (_typesOmethods_dist)
                        (_typesOmodules)
                        (_typesOoptimizer)
                        (_typesOoptimizerPrelude)
                        (_typesOprekind)
                        (_typesOprelude)
                        (_typesOrawRequests_collect)
                        (_typesOtoplevel)
                        (_typesOtypeImps_collect)
                        (_typesOverbosity))
            -- "./Output.inc.lag"(line 248, column 9)
            (_lhsOoutput@_) =
                if _lhsIimportedModule then
                  PP.emptyPP
                else
                  PP.ppDeclaration False _self
            -- "./Kind.inc.lag"(line 221, column 9)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- "./Kind.inc.lag"(line 220, column 9)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- "./Kind.inc.lag"(line 664, column 9)
            (_lhsOkind_errors@_) =
                []
            -- "./Kind.inc.lag"(line 663, column 9)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _typesIdepConstraints_collect
            -- use rule
            (_lhsOdepConstraints_defined@_) =
                []
            -- use rule
            (_lhsOexportedDeclarations@_) =
                []
            -- use rule
            (_lhsOoutputi@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                _typesIstaticErrors
            -- self rule
            (_self@_) =
                Declaration_Default _rangeIself _typesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _typesIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _typesIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typesIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _typesIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _typesIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typesIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typesImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _typesIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _typesItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typesOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_typesObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_typesOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_typesOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_typesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typesOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_typesOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_typesOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_typesOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_typesOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_typesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typesOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_typesOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_typesOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_typesOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_typesOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_typesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typesOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_typesOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_typesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typesOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_typesOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_typesOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_typesOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_typesOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_typesOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_typesOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typesOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_typesOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect
             ,_lhsObimapImps_collect
             ,_lhsOconstructors_collect
             ,_lhsOdepConstraints_collect
             ,_lhsOdepConstraints_defined
             ,_lhsOexportedDeclarations
             ,_lhsOfunImps_collect
             ,_lhsOgenericAbstractions_collect
             ,_lhsOkinames
             ,_lhsOkindIndexedTypes_collect
             ,_lhsOkind_errors
             ,_lhsOkindvar
             ,_lhsOksubst
             ,_lhsOlabels_collect
             ,_lhsOmethods_collect
             ,_lhsOoutput
             ,_lhsOoutputi
             ,_lhsOpresignatures_collect
             ,_lhsOrawRequests_collect
             ,_lhsOself
             ,_lhsOstaticErrors
             ,_lhsOstructureTypes_collect
             ,_lhsOtypeImps_collect
             )
sem_Declaration_Dependency :: (T_Range) ->
                              (Bool) ->
                              (T_Name) ->
                              (T_DependencyBindings) ->
                              (T_Declaration)
sem_Declaration_Dependency (range_) (typelevel_) (name_) (bindings_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOdepConstraints_defined :: ([DepConstraint])
            _lhsOexportedDeclarations :: (Declarations)
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: (PP.Doc)
            _lhsOoutputi :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Declaration)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _bindingsIconstructors_collect :: (FMap Name Names)
            _bindingsIgenericAbstractions_collect :: (FMap Name Kind)
            _bindingsIlabels_collect :: (FMap Name Names)
            _bindingsImethods_collect :: (FMap Name Names)
            _bindingsInames :: (Names)
            _bindingsIself :: (DependencyBindings)
            _bindingsOclassname :: (Maybe Name)
            _bindingsOconstructors_collect :: (FMap Name Names)
            _bindingsOconstructors_dist :: (FMap Name Names)
            _bindingsOcurrentModule :: (Strings)
            _bindingsOgenericAbstractions :: (FMap Name Kind)
            _bindingsOgenericAbstractions_collect :: (FMap Name Kind)
            _bindingsOghc :: (Bool)
            _bindingsOimportedModule :: (Bool)
            _bindingsOinstancename :: (Maybe Name)
            _bindingsOlabels_collect :: (FMap Name Names)
            _bindingsOlabels_dist :: (FMap Name Names)
            _bindingsOlocal :: (Bool)
            _bindingsOmethods_collect :: (FMap Name Names)
            _bindingsOmethods_dist :: (FMap Name Names)
            _bindingsOmodules :: (Set Strings)
            _bindingsOoptimizer :: (Bool)
            _bindingsOoptimizerPrelude :: (Declarations)
            _bindingsOprelude :: (Bool)
            _bindingsOtoplevel :: (Bool)
            _bindingsOtypelevel :: (Bool)
            _bindingsOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _bindingsIconstructors_collect,_bindingsIgenericAbstractions_collect,_bindingsIlabels_collect,_bindingsImethods_collect,_bindingsInames,_bindingsIself) =
                (bindings_ (_bindingsOclassname)
                           (_bindingsOconstructors_collect)
                           (_bindingsOconstructors_dist)
                           (_bindingsOcurrentModule)
                           (_bindingsOgenericAbstractions)
                           (_bindingsOgenericAbstractions_collect)
                           (_bindingsOghc)
                           (_bindingsOimportedModule)
                           (_bindingsOinstancename)
                           (_bindingsOlabels_collect)
                           (_bindingsOlabels_dist)
                           (_bindingsOlocal)
                           (_bindingsOmethods_collect)
                           (_bindingsOmethods_dist)
                           (_bindingsOmodules)
                           (_bindingsOoptimizer)
                           (_bindingsOoptimizerPrelude)
                           (_bindingsOprelude)
                           (_bindingsOtoplevel)
                           (_bindingsOtypelevel)
                           (_bindingsOverbosity))
            -- "./ModuleInformation.inc.lag"(line 223, column 9)
            (_bindingsOtypelevel@_) =
                typelevel_
            -- "./Output.inc.lag"(line 303, column 9)
            (_lhsOoutput@_) =
                PP.empty
            -- "./Exports.inc.lag"(line 547, column 9)
            (_is_exported@_) =
                if typelevel_ then
                  Set.elementOf _nameIself _lhsIexportedTypes
                else
                  Set.elementOf
                    _nameIself
                    _lhsIexportedValues
            -- "./OutputI.inc.lag"(line 255, column 9)
            (_is_implied@_) =
                False
            -- "./OutputI.inc.lag"(line 251, column 9)
            (_lhsOoutputi@_) =
                if _is_implied || _is_exported then
                  [PP.ppDeclaration True _self]
                else
                  []
            -- "./Kind.inc.lag"(line 247, column 9)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- "./Kind.inc.lag"(line 246, column 9)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- "./Kind.inc.lag"(line 676, column 9)
            (_lhsOkind_errors@_) =
                []
            -- "./Kind.inc.lag"(line 675, column 9)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOdepConstraints_defined@_) =
                []
            -- use rule
            (_lhsOexportedDeclarations@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                Declaration_Dependency _rangeIself typelevel_ _nameIself _bindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _bindingsIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _bindingsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _bindingsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _bindingsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_bindingsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_bindingsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_bindingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_bindingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_bindingsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_bindingsOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_bindingsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_bindingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_bindingsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_bindingsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_bindingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_bindingsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_bindingsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_bindingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_bindingsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_bindingsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_bindingsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_bindingsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_bindingsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_bindingsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect
             ,_lhsObimapImps_collect
             ,_lhsOconstructors_collect
             ,_lhsOdepConstraints_collect
             ,_lhsOdepConstraints_defined
             ,_lhsOexportedDeclarations
             ,_lhsOfunImps_collect
             ,_lhsOgenericAbstractions_collect
             ,_lhsOkinames
             ,_lhsOkindIndexedTypes_collect
             ,_lhsOkind_errors
             ,_lhsOkindvar
             ,_lhsOksubst
             ,_lhsOlabels_collect
             ,_lhsOmethods_collect
             ,_lhsOoutput
             ,_lhsOoutputi
             ,_lhsOpresignatures_collect
             ,_lhsOrawRequests_collect
             ,_lhsOself
             ,_lhsOstaticErrors
             ,_lhsOstructureTypes_collect
             ,_lhsOtypeImps_collect
             )
sem_Declaration_Empty :: (T_Range) ->
                         (T_Declaration)
sem_Declaration_Empty (range_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOdepConstraints_defined :: ([DepConstraint])
            _lhsOexportedDeclarations :: (Declarations)
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: (PP.Doc)
            _lhsOoutputi :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Declaration)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- "./Output.inc.lag"(line 337, column 9)
            (_lhsOoutput@_) =
                if _lhsIimportedModule then
                  PP.emptyPP
                else
                  PP.ppDeclaration False _self
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOdepConstraints_defined@_) =
                []
            -- use rule
            (_lhsOexportedDeclarations@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOoutputi@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                Declaration_Empty _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOabstractTypes_collect
             ,_lhsObimapImps_collect
             ,_lhsOconstructors_collect
             ,_lhsOdepConstraints_collect
             ,_lhsOdepConstraints_defined
             ,_lhsOexportedDeclarations
             ,_lhsOfunImps_collect
             ,_lhsOgenericAbstractions_collect
             ,_lhsOkinames
             ,_lhsOkindIndexedTypes_collect
             ,_lhsOkind_errors
             ,_lhsOkindvar
             ,_lhsOksubst
             ,_lhsOlabels_collect
             ,_lhsOmethods_collect
             ,_lhsOoutput
             ,_lhsOoutputi
             ,_lhsOpresignatures_collect
             ,_lhsOrawRequests_collect
             ,_lhsOself
             ,_lhsOstaticErrors
             ,_lhsOstructureTypes_collect
             ,_lhsOtypeImps_collect
             )
sem_Declaration_Fixity :: (T_Range) ->
                          (T_Fixity) ->
                          (T_MaybeInt) ->
                          (T_Names) ->
                          (T_Declaration)
sem_Declaration_Fixity (range_) (fixity_) (priority_) (operators_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOdepConstraints_defined :: ([DepConstraint])
            _lhsOexportedDeclarations :: (Declarations)
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: (PP.Doc)
            _lhsOoutputi :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Declaration)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _fixityIconstructors_collect :: (FMap Name Names)
            _fixityIgenericAbstractions_collect :: (FMap Name Kind)
            _fixityIlabels_collect :: (FMap Name Names)
            _fixityImethods_collect :: (FMap Name Names)
            _fixityIself :: (Fixity)
            _fixityOclassname :: (Maybe Name)
            _fixityOconstructors_collect :: (FMap Name Names)
            _fixityOconstructors_dist :: (FMap Name Names)
            _fixityOcurrentModule :: (Strings)
            _fixityOgenericAbstractions :: (FMap Name Kind)
            _fixityOgenericAbstractions_collect :: (FMap Name Kind)
            _fixityOghc :: (Bool)
            _fixityOimportedModule :: (Bool)
            _fixityOinstancename :: (Maybe Name)
            _fixityOlabels_collect :: (FMap Name Names)
            _fixityOlabels_dist :: (FMap Name Names)
            _fixityOlocal :: (Bool)
            _fixityOmethods_collect :: (FMap Name Names)
            _fixityOmethods_dist :: (FMap Name Names)
            _fixityOmodules :: (Set Strings)
            _fixityOoptimizer :: (Bool)
            _fixityOoptimizerPrelude :: (Declarations)
            _fixityOprelude :: (Bool)
            _fixityOtoplevel :: (Bool)
            _fixityOverbosity :: (Int)
            _priorityIconstructors_collect :: (FMap Name Names)
            _priorityIgenericAbstractions_collect :: (FMap Name Kind)
            _priorityIlabels_collect :: (FMap Name Names)
            _priorityImethods_collect :: (FMap Name Names)
            _priorityIself :: (MaybeInt)
            _priorityOclassname :: (Maybe Name)
            _priorityOconstructors_collect :: (FMap Name Names)
            _priorityOconstructors_dist :: (FMap Name Names)
            _priorityOcurrentModule :: (Strings)
            _priorityOgenericAbstractions :: (FMap Name Kind)
            _priorityOgenericAbstractions_collect :: (FMap Name Kind)
            _priorityOghc :: (Bool)
            _priorityOimportedModule :: (Bool)
            _priorityOinstancename :: (Maybe Name)
            _priorityOlabels_collect :: (FMap Name Names)
            _priorityOlabels_dist :: (FMap Name Names)
            _priorityOlocal :: (Bool)
            _priorityOmethods_collect :: (FMap Name Names)
            _priorityOmethods_dist :: (FMap Name Names)
            _priorityOmodules :: (Set Strings)
            _priorityOoptimizer :: (Bool)
            _priorityOoptimizerPrelude :: (Declarations)
            _priorityOprelude :: (Bool)
            _priorityOtoplevel :: (Bool)
            _priorityOverbosity :: (Int)
            _operatorsIconstructors_collect :: (FMap Name Names)
            _operatorsIgenericAbstractions_collect :: (FMap Name Kind)
            _operatorsIinferkind :: (Kind)
            _operatorsIkinames :: (KSubst)
            _operatorsIkind_errors :: ([GHError])
            _operatorsIkindvar :: (Int)
            _operatorsIksubst :: (KSubst)
            _operatorsIlabels_collect :: (FMap Name Names)
            _operatorsImethods_collect :: (FMap Name Names)
            _operatorsIself :: (Names)
            _operatorsOclassname :: (Maybe Name)
            _operatorsOconstructors_collect :: (FMap Name Names)
            _operatorsOconstructors_dist :: (FMap Name Names)
            _operatorsOcurrentModule :: (Strings)
            _operatorsOgenericAbstractions :: (FMap Name Kind)
            _operatorsOgenericAbstractions_collect :: (FMap Name Kind)
            _operatorsOghc :: (Bool)
            _operatorsOimportedModule :: (Bool)
            _operatorsOinstancename :: (Maybe Name)
            _operatorsOkinames :: (KSubst)
            _operatorsOkinds :: (KSubst)
            _operatorsOkindvar :: (Int)
            _operatorsOksubst :: (KSubst)
            _operatorsOlabels_collect :: (FMap Name Names)
            _operatorsOlabels_dist :: (FMap Name Names)
            _operatorsOlocal :: (Bool)
            _operatorsOmethods_collect :: (FMap Name Names)
            _operatorsOmethods_dist :: (FMap Name Names)
            _operatorsOmodules :: (Set Strings)
            _operatorsOoptimizer :: (Bool)
            _operatorsOoptimizerPrelude :: (Declarations)
            _operatorsOprekind :: (KSubst)
            _operatorsOprelude :: (Bool)
            _operatorsOtoplevel :: (Bool)
            _operatorsOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _fixityIconstructors_collect,_fixityIgenericAbstractions_collect,_fixityIlabels_collect,_fixityImethods_collect,_fixityIself) =
                (fixity_ (_fixityOclassname)
                         (_fixityOconstructors_collect)
                         (_fixityOconstructors_dist)
                         (_fixityOcurrentModule)
                         (_fixityOgenericAbstractions)
                         (_fixityOgenericAbstractions_collect)
                         (_fixityOghc)
                         (_fixityOimportedModule)
                         (_fixityOinstancename)
                         (_fixityOlabels_collect)
                         (_fixityOlabels_dist)
                         (_fixityOlocal)
                         (_fixityOmethods_collect)
                         (_fixityOmethods_dist)
                         (_fixityOmodules)
                         (_fixityOoptimizer)
                         (_fixityOoptimizerPrelude)
                         (_fixityOprelude)
                         (_fixityOtoplevel)
                         (_fixityOverbosity))
            ( _priorityIconstructors_collect,_priorityIgenericAbstractions_collect,_priorityIlabels_collect,_priorityImethods_collect,_priorityIself) =
                (priority_ (_priorityOclassname)
                           (_priorityOconstructors_collect)
                           (_priorityOconstructors_dist)
                           (_priorityOcurrentModule)
                           (_priorityOgenericAbstractions)
                           (_priorityOgenericAbstractions_collect)
                           (_priorityOghc)
                           (_priorityOimportedModule)
                           (_priorityOinstancename)
                           (_priorityOlabels_collect)
                           (_priorityOlabels_dist)
                           (_priorityOlocal)
                           (_priorityOmethods_collect)
                           (_priorityOmethods_dist)
                           (_priorityOmodules)
                           (_priorityOoptimizer)
                           (_priorityOoptimizerPrelude)
                           (_priorityOprelude)
                           (_priorityOtoplevel)
                           (_priorityOverbosity))
            ( _operatorsIconstructors_collect,_operatorsIgenericAbstractions_collect,_operatorsIinferkind,_operatorsIkinames,_operatorsIkind_errors,_operatorsIkindvar,_operatorsIksubst,_operatorsIlabels_collect,_operatorsImethods_collect,_operatorsIself) =
                (operators_ (_operatorsOclassname)
                            (_operatorsOconstructors_collect)
                            (_operatorsOconstructors_dist)
                            (_operatorsOcurrentModule)
                            (_operatorsOgenericAbstractions)
                            (_operatorsOgenericAbstractions_collect)
                            (_operatorsOghc)
                            (_operatorsOimportedModule)
                            (_operatorsOinstancename)
                            (_operatorsOkinames)
                            (_operatorsOkinds)
                            (_operatorsOkindvar)
                            (_operatorsOksubst)
                            (_operatorsOlabels_collect)
                            (_operatorsOlabels_dist)
                            (_operatorsOlocal)
                            (_operatorsOmethods_collect)
                            (_operatorsOmethods_dist)
                            (_operatorsOmodules)
                            (_operatorsOoptimizer)
                            (_operatorsOoptimizerPrelude)
                            (_operatorsOprekind)
                            (_operatorsOprelude)
                            (_operatorsOtoplevel)
                            (_operatorsOverbosity))
            -- "./Output.inc.lag"(line 331, column 9)
            (_lhsOoutput@_) =
                if _lhsIimportedModule then
                  PP.emptyPP
                else
                  PP.ppDeclaration False _self
            -- "./Kind.inc.lag"(line 255, column 9)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- "./Kind.inc.lag"(line 254, column 9)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- "./Kind.inc.lag"(line 684, column 9)
            (_lhsOkind_errors@_) =
                []
            -- "./Kind.inc.lag"(line 683, column 9)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOdepConstraints_defined@_) =
                []
            -- use rule
            (_lhsOexportedDeclarations@_) =
                []
            -- use rule
            (_lhsOoutputi@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                Declaration_Fixity _rangeIself _fixityIself _priorityIself _operatorsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _operatorsIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _operatorsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _operatorsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _operatorsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_fixityOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_fixityOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_fixityOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_fixityOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_fixityOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_fixityOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_fixityOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_fixityOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_fixityOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_fixityOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_fixityOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_fixityOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_fixityOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_fixityOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_fixityOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_fixityOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_fixityOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_fixityOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_fixityOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_fixityOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_priorityOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_priorityOconstructors_collect@_) =
                _fixityIconstructors_collect
            -- copy rule (down)
            (_priorityOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_priorityOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_priorityOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_priorityOgenericAbstractions_collect@_) =
                _fixityIgenericAbstractions_collect
            -- copy rule (down)
            (_priorityOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_priorityOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_priorityOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_priorityOlabels_collect@_) =
                _fixityIlabels_collect
            -- copy rule (down)
            (_priorityOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_priorityOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_priorityOmethods_collect@_) =
                _fixityImethods_collect
            -- copy rule (down)
            (_priorityOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_priorityOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_priorityOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_priorityOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_priorityOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_priorityOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_priorityOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_operatorsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_operatorsOconstructors_collect@_) =
                _priorityIconstructors_collect
            -- copy rule (down)
            (_operatorsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_operatorsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_operatorsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_operatorsOgenericAbstractions_collect@_) =
                _priorityIgenericAbstractions_collect
            -- copy rule (down)
            (_operatorsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_operatorsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_operatorsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_operatorsOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_operatorsOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_operatorsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_operatorsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_operatorsOlabels_collect@_) =
                _priorityIlabels_collect
            -- copy rule (down)
            (_operatorsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_operatorsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_operatorsOmethods_collect@_) =
                _priorityImethods_collect
            -- copy rule (down)
            (_operatorsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_operatorsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_operatorsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_operatorsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_operatorsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_operatorsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_operatorsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_operatorsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect
             ,_lhsObimapImps_collect
             ,_lhsOconstructors_collect
             ,_lhsOdepConstraints_collect
             ,_lhsOdepConstraints_defined
             ,_lhsOexportedDeclarations
             ,_lhsOfunImps_collect
             ,_lhsOgenericAbstractions_collect
             ,_lhsOkinames
             ,_lhsOkindIndexedTypes_collect
             ,_lhsOkind_errors
             ,_lhsOkindvar
             ,_lhsOksubst
             ,_lhsOlabels_collect
             ,_lhsOmethods_collect
             ,_lhsOoutput
             ,_lhsOoutputi
             ,_lhsOpresignatures_collect
             ,_lhsOrawRequests_collect
             ,_lhsOself
             ,_lhsOstaticErrors
             ,_lhsOstructureTypes_collect
             ,_lhsOtypeImps_collect
             )
sem_Declaration_FunctionBindings :: (T_Range) ->
                                    (T_FunctionBindings) ->
                                    (T_Declaration)
sem_Declaration_FunctionBindings (range_) (bindings_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOdepConstraints_defined :: ([DepConstraint])
            _lhsOexportedDeclarations :: (Declarations)
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: (PP.Doc)
            _lhsOoutputi :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Declaration)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _bindingsIabstractTypes_collect :: (Set Name)
            _bindingsIbimapImps_collect :: ([Request_BimapImply])
            _bindingsIconstructors_collect :: (FMap Name Names)
            _bindingsIdepConstraints_collect :: ([DepConstraint])
            _bindingsIfunImps_collect :: ([Request_FunImply])
            _bindingsIgenericAbstractions_collect :: (FMap Name Kind)
            _bindingsIkinames :: (KSubst)
            _bindingsIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _bindingsIkind_errors :: ([GHError])
            _bindingsIkindvar :: (Int)
            _bindingsIksubst :: (KSubst)
            _bindingsIlabels_collect :: (FMap Name Names)
            _bindingsImethods_collect :: (FMap Name Names)
            _bindingsIname :: (Name)
            _bindingsIpresignatures_collect :: (PreSignatures)
            _bindingsIrawRequests_collect :: ([RawRequest])
            _bindingsIself :: (FunctionBindings)
            _bindingsIstaticErrors :: ([GHError])
            _bindingsIstructureTypes_collect :: (FMap Name LambdaType)
            _bindingsItypeImps_collect :: ([Request_TypeImply])
            _bindingsOabstractTypes_collect :: (Set Name)
            _bindingsObimapImps_collect :: ([Request_BimapImply])
            _bindingsOclassname :: (Maybe Name)
            _bindingsOconstructors_collect :: (FMap Name Names)
            _bindingsOconstructors_dist :: (FMap Name Names)
            _bindingsOcurrentModule :: (Strings)
            _bindingsOdependencies :: (FMap Name [(Name,Name)])
            _bindingsOexportedStructures :: (Set Name)
            _bindingsOexportedTypes :: (Set Name)
            _bindingsOexportedValues :: (Set Name)
            _bindingsOfunImps_collect :: ([Request_FunImply])
            _bindingsOgenericAbstractions :: (FMap Name Kind)
            _bindingsOgenericAbstractions_collect :: (FMap Name Kind)
            _bindingsOghc :: (Bool)
            _bindingsOimportedModule :: (Bool)
            _bindingsOinstancename :: (Maybe Name)
            _bindingsOkinames :: (KSubst)
            _bindingsOkindIndexedTypes :: (FMap Name KindIndexedType)
            _bindingsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _bindingsOkinds :: (KSubst)
            _bindingsOkindvar :: (Int)
            _bindingsOksubst :: (KSubst)
            _bindingsOlabels_collect :: (FMap Name Names)
            _bindingsOlabels_dist :: (FMap Name Names)
            _bindingsOlocal :: (Bool)
            _bindingsOmethods_collect :: (FMap Name Names)
            _bindingsOmethods_dist :: (FMap Name Names)
            _bindingsOmodules :: (Set Strings)
            _bindingsOoptimizer :: (Bool)
            _bindingsOoptimizerPrelude :: (Declarations)
            _bindingsOprekind :: (KSubst)
            _bindingsOprelude :: (Bool)
            _bindingsOpresignatures :: (PreSignatures)
            _bindingsOpresignatures_collect :: (PreSignatures)
            _bindingsOrawRequests_collect :: ([RawRequest])
            _bindingsOsignatures :: (Signatures)
            _bindingsOstructureTypes_collect :: (FMap Name LambdaType)
            _bindingsOtoplevel :: (Bool)
            _bindingsOtypeImps_collect :: ([Request_TypeImply])
            _bindingsOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _bindingsIabstractTypes_collect
             ,_bindingsIbimapImps_collect
             ,_bindingsIconstructors_collect
             ,_bindingsIdepConstraints_collect
             ,_bindingsIfunImps_collect
             ,_bindingsIgenericAbstractions_collect
             ,_bindingsIkinames
             ,_bindingsIkindIndexedTypes_collect
             ,_bindingsIkind_errors
             ,_bindingsIkindvar
             ,_bindingsIksubst
             ,_bindingsIlabels_collect
             ,_bindingsImethods_collect
             ,_bindingsIname
             ,_bindingsIpresignatures_collect
             ,_bindingsIrawRequests_collect
             ,_bindingsIself
             ,_bindingsIstaticErrors
             ,_bindingsIstructureTypes_collect
             ,_bindingsItypeImps_collect
             ) =
                (bindings_ (_bindingsOabstractTypes_collect)
                           (_bindingsObimapImps_collect)
                           (_bindingsOclassname)
                           (_bindingsOconstructors_collect)
                           (_bindingsOconstructors_dist)
                           (_bindingsOcurrentModule)
                           (_bindingsOdependencies)
                           (_bindingsOexportedStructures)
                           (_bindingsOexportedTypes)
                           (_bindingsOexportedValues)
                           (_bindingsOfunImps_collect)
                           (_bindingsOgenericAbstractions)
                           (_bindingsOgenericAbstractions_collect)
                           (_bindingsOghc)
                           (_bindingsOimportedModule)
                           (_bindingsOinstancename)
                           (_bindingsOkinames)
                           (_bindingsOkindIndexedTypes)
                           (_bindingsOkindIndexedTypes_collect)
                           (_bindingsOkinds)
                           (_bindingsOkindvar)
                           (_bindingsOksubst)
                           (_bindingsOlabels_collect)
                           (_bindingsOlabels_dist)
                           (_bindingsOlocal)
                           (_bindingsOmethods_collect)
                           (_bindingsOmethods_dist)
                           (_bindingsOmodules)
                           (_bindingsOoptimizer)
                           (_bindingsOoptimizerPrelude)
                           (_bindingsOprekind)
                           (_bindingsOprelude)
                           (_bindingsOpresignatures)
                           (_bindingsOpresignatures_collect)
                           (_bindingsOrawRequests_collect)
                           (_bindingsOsignatures)
                           (_bindingsOstructureTypes_collect)
                           (_bindingsOtoplevel)
                           (_bindingsOtypeImps_collect)
                           (_bindingsOverbosity))
            -- "./Output.inc.lag"(line 254, column 9)
            (_lhsOoutput@_) =
                if _lhsIimportedModule then
                  PP.emptyPP
                else
                  PP.ppDeclaration False
                    (ER.replaceDeclaration
                       _lhsIdependencies
                       FMap.emptyFM
                       _lhsIgenericAbstractions
                       _self
                    )
            -- "./Kind.inc.lag"(line 225, column 9)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- "./Kind.inc.lag"(line 224, column 9)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- "./Kind.inc.lag"(line 668, column 9)
            (_lhsOkind_errors@_) =
                []
            -- "./Kind.inc.lag"(line 667, column 9)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _bindingsIdepConstraints_collect
            -- use rule
            (_lhsOdepConstraints_defined@_) =
                []
            -- use rule
            (_lhsOexportedDeclarations@_) =
                []
            -- use rule
            (_lhsOoutputi@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                _bindingsIstaticErrors
            -- self rule
            (_self@_) =
                Declaration_FunctionBindings _rangeIself _bindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _bindingsIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _bindingsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _bindingsIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _bindingsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _bindingsIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _bindingsIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _bindingsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _bindingsImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _bindingsIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _bindingsIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _bindingsIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _bindingsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_bindingsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_bindingsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_bindingsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_bindingsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_bindingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_bindingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_bindingsOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_bindingsOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_bindingsOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_bindingsOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_bindingsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_bindingsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_bindingsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_bindingsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_bindingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_bindingsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_bindingsOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_bindingsOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_bindingsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_bindingsOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_bindingsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_bindingsOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_bindingsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_bindingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_bindingsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_bindingsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_bindingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_bindingsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_bindingsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_bindingsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_bindingsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_bindingsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_bindingsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_bindingsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_bindingsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_bindingsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_bindingsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_bindingsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_bindingsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_bindingsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect
             ,_lhsObimapImps_collect
             ,_lhsOconstructors_collect
             ,_lhsOdepConstraints_collect
             ,_lhsOdepConstraints_defined
             ,_lhsOexportedDeclarations
             ,_lhsOfunImps_collect
             ,_lhsOgenericAbstractions_collect
             ,_lhsOkinames
             ,_lhsOkindIndexedTypes_collect
             ,_lhsOkind_errors
             ,_lhsOkindvar
             ,_lhsOksubst
             ,_lhsOlabels_collect
             ,_lhsOmethods_collect
             ,_lhsOoutput
             ,_lhsOoutputi
             ,_lhsOpresignatures_collect
             ,_lhsOrawRequests_collect
             ,_lhsOself
             ,_lhsOstaticErrors
             ,_lhsOstructureTypes_collect
             ,_lhsOtypeImps_collect
             )
sem_Declaration_GenericTypeSignature :: (T_Range) ->
                                        (T_Name) ->
                                        (T_KindAnnotatedNames) ->
                                        (T_KindAnnotatedNames) ->
                                        (T_Type) ->
                                        (T_Declaration)
sem_Declaration_GenericTypeSignature (range_) (name_) (generics_) (parametrics_) (type_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOdepConstraints_defined :: ([DepConstraint])
            _lhsOexportedDeclarations :: (Declarations)
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: (PP.Doc)
            _lhsOoutputi :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Declaration)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _genericsIakinds :: ([MaybeKind])
            _genericsIconstructors_collect :: (FMap Name Names)
            _genericsIgenericAbstractions_collect :: (FMap Name Kind)
            _genericsIinferkind :: (Kind)
            _genericsIkinames :: (KSubst)
            _genericsIkind_errors :: ([GHError])
            _genericsIkindvar :: (Int)
            _genericsIksubst :: (KSubst)
            _genericsIlabels_collect :: (FMap Name Names)
            _genericsImethods_collect :: (FMap Name Names)
            _genericsImkinds :: ([MaybeKind])
            _genericsIself :: (KindAnnotatedNames)
            _genericsOclassname :: (Maybe Name)
            _genericsOconstructors_collect :: (FMap Name Names)
            _genericsOconstructors_dist :: (FMap Name Names)
            _genericsOcurrentModule :: (Strings)
            _genericsOgenericAbstractions :: (FMap Name Kind)
            _genericsOgenericAbstractions_collect :: (FMap Name Kind)
            _genericsOghc :: (Bool)
            _genericsOimportedModule :: (Bool)
            _genericsOinstancename :: (Maybe Name)
            _genericsOkinames :: (KSubst)
            _genericsOkinds :: (KSubst)
            _genericsOkindvar :: (Int)
            _genericsOksubst :: (KSubst)
            _genericsOlabels_collect :: (FMap Name Names)
            _genericsOlabels_dist :: (FMap Name Names)
            _genericsOlocal :: (Bool)
            _genericsOmethods_collect :: (FMap Name Names)
            _genericsOmethods_dist :: (FMap Name Names)
            _genericsOmodules :: (Set Strings)
            _genericsOoptimizer :: (Bool)
            _genericsOoptimizerPrelude :: (Declarations)
            _genericsOprekind :: (KSubst)
            _genericsOprelude :: (Bool)
            _genericsOtoplevel :: (Bool)
            _genericsOverbosity :: (Int)
            _parametricsIakinds :: ([MaybeKind])
            _parametricsIconstructors_collect :: (FMap Name Names)
            _parametricsIgenericAbstractions_collect :: (FMap Name Kind)
            _parametricsIinferkind :: (Kind)
            _parametricsIkinames :: (KSubst)
            _parametricsIkind_errors :: ([GHError])
            _parametricsIkindvar :: (Int)
            _parametricsIksubst :: (KSubst)
            _parametricsIlabels_collect :: (FMap Name Names)
            _parametricsImethods_collect :: (FMap Name Names)
            _parametricsImkinds :: ([MaybeKind])
            _parametricsIself :: (KindAnnotatedNames)
            _parametricsOclassname :: (Maybe Name)
            _parametricsOconstructors_collect :: (FMap Name Names)
            _parametricsOconstructors_dist :: (FMap Name Names)
            _parametricsOcurrentModule :: (Strings)
            _parametricsOgenericAbstractions :: (FMap Name Kind)
            _parametricsOgenericAbstractions_collect :: (FMap Name Kind)
            _parametricsOghc :: (Bool)
            _parametricsOimportedModule :: (Bool)
            _parametricsOinstancename :: (Maybe Name)
            _parametricsOkinames :: (KSubst)
            _parametricsOkinds :: (KSubst)
            _parametricsOkindvar :: (Int)
            _parametricsOksubst :: (KSubst)
            _parametricsOlabels_collect :: (FMap Name Names)
            _parametricsOlabels_dist :: (FMap Name Names)
            _parametricsOlocal :: (Bool)
            _parametricsOmethods_collect :: (FMap Name Names)
            _parametricsOmethods_dist :: (FMap Name Names)
            _parametricsOmodules :: (Set Strings)
            _parametricsOoptimizer :: (Bool)
            _parametricsOoptimizerPrelude :: (Declarations)
            _parametricsOprekind :: (KSubst)
            _parametricsOprelude :: (Bool)
            _parametricsOtoplevel :: (Bool)
            _parametricsOverbosity :: (Int)
            _typeIabstractTypes_collect :: (Set Name)
            _typeIbimapImps_collect :: ([Request_BimapImply])
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIdepConstraints_collect :: ([DepConstraint])
            _typeIfunImps_collect :: ([Request_FunImply])
            _typeIgenericAbstractions_collect :: (FMap Name Kind)
            _typeIinferkind :: (Kind)
            _typeIkinames :: (KSubst)
            _typeIkind_errors :: ([GHError])
            _typeIkindvar :: (Int)
            _typeIksubst :: (KSubst)
            _typeIlabels_collect :: (FMap Name Names)
            _typeImethods_collect :: (FMap Name Names)
            _typeIrawRequests_collect :: ([RawRequest])
            _typeIself :: (Type)
            _typeIstaticErrors :: ([GHError])
            _typeItypeImps_collect :: ([Request_TypeImply])
            _typeOabstractTypes_collect :: (Set Name)
            _typeObimapImps_collect :: ([Request_BimapImply])
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOdependencies :: (FMap Name [(Name,Name)])
            _typeOfunImps_collect :: ([Request_FunImply])
            _typeOgenericAbstractions :: (FMap Name Kind)
            _typeOgenericAbstractions_collect :: (FMap Name Kind)
            _typeOghc :: (Bool)
            _typeOimportedModule :: (Bool)
            _typeOinstancename :: (Maybe Name)
            _typeOkinames :: (KSubst)
            _typeOkinds :: (KSubst)
            _typeOkindvar :: (Int)
            _typeOksubst :: (KSubst)
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOmodules :: (Set Strings)
            _typeOoptimizer :: (Bool)
            _typeOoptimizerPrelude :: (Declarations)
            _typeOprekind :: (KSubst)
            _typeOprelude :: (Bool)
            _typeOrawRequests_collect :: ([RawRequest])
            _typeOtoplevel :: (Bool)
            _typeOtypeImps_collect :: ([Request_TypeImply])
            _typeOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _genericsIakinds,_genericsIconstructors_collect,_genericsIgenericAbstractions_collect,_genericsIinferkind,_genericsIkinames,_genericsIkind_errors,_genericsIkindvar,_genericsIksubst,_genericsIlabels_collect,_genericsImethods_collect,_genericsImkinds,_genericsIself) =
                (generics_ (_genericsOclassname)
                           (_genericsOconstructors_collect)
                           (_genericsOconstructors_dist)
                           (_genericsOcurrentModule)
                           (_genericsOgenericAbstractions)
                           (_genericsOgenericAbstractions_collect)
                           (_genericsOghc)
                           (_genericsOimportedModule)
                           (_genericsOinstancename)
                           (_genericsOkinames)
                           (_genericsOkinds)
                           (_genericsOkindvar)
                           (_genericsOksubst)
                           (_genericsOlabels_collect)
                           (_genericsOlabels_dist)
                           (_genericsOlocal)
                           (_genericsOmethods_collect)
                           (_genericsOmethods_dist)
                           (_genericsOmodules)
                           (_genericsOoptimizer)
                           (_genericsOoptimizerPrelude)
                           (_genericsOprekind)
                           (_genericsOprelude)
                           (_genericsOtoplevel)
                           (_genericsOverbosity))
            ( _parametricsIakinds,_parametricsIconstructors_collect,_parametricsIgenericAbstractions_collect,_parametricsIinferkind,_parametricsIkinames,_parametricsIkind_errors,_parametricsIkindvar,_parametricsIksubst,_parametricsIlabels_collect,_parametricsImethods_collect,_parametricsImkinds,_parametricsIself) =
                (parametrics_ (_parametricsOclassname)
                              (_parametricsOconstructors_collect)
                              (_parametricsOconstructors_dist)
                              (_parametricsOcurrentModule)
                              (_parametricsOgenericAbstractions)
                              (_parametricsOgenericAbstractions_collect)
                              (_parametricsOghc)
                              (_parametricsOimportedModule)
                              (_parametricsOinstancename)
                              (_parametricsOkinames)
                              (_parametricsOkinds)
                              (_parametricsOkindvar)
                              (_parametricsOksubst)
                              (_parametricsOlabels_collect)
                              (_parametricsOlabels_dist)
                              (_parametricsOlocal)
                              (_parametricsOmethods_collect)
                              (_parametricsOmethods_dist)
                              (_parametricsOmodules)
                              (_parametricsOoptimizer)
                              (_parametricsOoptimizerPrelude)
                              (_parametricsOprekind)
                              (_parametricsOprelude)
                              (_parametricsOtoplevel)
                              (_parametricsOverbosity))
            ( _typeIabstractTypes_collect,_typeIbimapImps_collect,_typeIconstructors_collect,_typeIdepConstraints_collect,_typeIfunImps_collect,_typeIgenericAbstractions_collect,_typeIinferkind,_typeIkinames,_typeIkind_errors,_typeIkindvar,_typeIksubst,_typeIlabels_collect,_typeImethods_collect,_typeIrawRequests_collect,_typeIself,_typeIstaticErrors,_typeItypeImps_collect) =
                (type_ (_typeOabstractTypes_collect)
                       (_typeObimapImps_collect)
                       (_typeOclassname)
                       (_typeOconstructors_collect)
                       (_typeOconstructors_dist)
                       (_typeOcurrentModule)
                       (_typeOdependencies)
                       (_typeOfunImps_collect)
                       (_typeOgenericAbstractions)
                       (_typeOgenericAbstractions_collect)
                       (_typeOghc)
                       (_typeOimportedModule)
                       (_typeOinstancename)
                       (_typeOkinames)
                       (_typeOkinds)
                       (_typeOkindvar)
                       (_typeOksubst)
                       (_typeOlabels_collect)
                       (_typeOlabels_dist)
                       (_typeOlocal)
                       (_typeOmethods_collect)
                       (_typeOmethods_dist)
                       (_typeOmodules)
                       (_typeOoptimizer)
                       (_typeOoptimizerPrelude)
                       (_typeOprekind)
                       (_typeOprelude)
                       (_typeOrawRequests_collect)
                       (_typeOtoplevel)
                       (_typeOtypeImps_collect)
                       (_typeOverbosity))
            -- "./ModuleInformation.inc.lag"(line 152, column 8)
            (_typeOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 151, column 8)
            (_parametricsOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 150, column 8)
            (_genericsOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 244, column 9)
            (_isMPCstyle@_) =
                length _genericsIself == 1 && length _parametricsIself == 0
                  && let  (KindAnnotatedName_KindAnnotatedName _ t k) = head _genericsIself
                     in   case k of
                            MaybeKind_Just j   ->  not (isRestricted j)
                            MaybeKind_Nothing  ->  False
            -- "./Output.inc.lag"(line 278, column 9)
            (_lhsOoutput@_) =
                PP.empty
            -- "./Exports.inc.lag"(line 533, column 9)
            (_is_exported@_) =
                Set.elementOf _nameIself _lhsIexportedValues
            -- "./OutputI.inc.lag"(line 201, column 9)
            (_dependencyEnriched@_) =
                Declaration_GenericTypeSignature
                  unknownRange
                  _nameIself _genericsIself _parametricsIself
                  (enrichType  _lhsIkindIndexedTypes
                               _lhsIdependencies
                               _nameIself _genericsIself _typeIself)
            -- "./OutputI.inc.lag"(line 199, column 9)
            (_is_implied@_) =
                False
            -- "./OutputI.inc.lag"(line 183, column 9)
            (_lhsOoutputi@_) =
                if _is_implied || _is_exported then
                  [PP.ppInterfaceDeclaration True
                        (InterfaceDeclaration_Consig
                           unknownRange
                           False
                           _nameIself
                           _signature
                        )
                  ]
                  ++ if _isMPCstyle
                     then  [PP.ppDeclaration True _self]
                     else  [PP.ppDeclarationWithKind True _dependencyEnriched _kind True]
                else
                  []
            -- "./Kind.inc.lag"(line 243, column 9)
            (_typeOkindvar@_) =
                _parametricsIkindvar + length _qvars
            -- "./Kind.inc.lag"(line 242, column 9)
            (_qvars'@_) =
                zip _qvars (map mkKindVar' [(_parametricsIkindvar+1)..])
            -- "./Kind.inc.lag"(line 239, column 9)
            (_qvars@_) =
                Set.setToList $
                  Set.minusSet  (freeVars _typeIself)
                                (Set.mkSet $ domain _parametricsIkinames)
            -- "./Kind.inc.lag"(line 237, column 9)
            (_typeOprekind@_) =
                foldl add _parametricsIkinames _qvars'
            -- "./Kind.inc.lag"(line 236, column 9)
            (_genericsOkinames@_) =
                _lhsIprekind
            -- "./Kind.inc.lag"(line 235, column 9)
            (_lhsOkinames@_) =
                _kinames
            -- "./Kind.inc.lag"(line 234, column 9)
            (_kinames@_) =
                add _lhsIkinames (_nameIself,_kvar)
            -- "./Kind.inc.lag"(line 233, column 9)
            (_kvar@_) =
                mkKindVar' _kindvar
            -- "./Kind.inc.lag"(line 232, column 9)
            (_kindvar@_) =
                _lhsIkindvar + 1
            -- "./Kind.inc.lag"(line 526, column 13)
            ((_ksubst'@_,_kind_errors@_)) =
                unifyWithError
                  (GHError_KindUGError _rangeIself
                     _nameIself
                     (applyKind _typeIksubst _typeIinferkind)
                  )
                  _typeIinferkind starK _typeIksubst
            -- "./Kind.inc.lag"(line 634, column 9)
            (_lhsOkind_errors@_) =
                _typeIkind_errors ++ _kind_errors
                  ++ _kind_errors' ++ _kind_errors''
            -- "./Kind.inc.lag"(line 633, column 9)
            (_lhsOksubst@_) =
                removeKindVars _kvar _ksubstKV
            -- "./Kind.inc.lag"(line 623, column 13)
            ((_ksubstKV@_,_kind_errors'@_)) =
                let  inferkind =
                       foldr arrK starK $
                       splitKind _genericsIinferkind
                         ++
                       splitKind _parametricsIinferkind
                in   unifyToplevel _rangeIself
                       _nameIself "generic type signature"
                       _kvar inferkind
                       _ksubst'
            -- "./Kind.inc.lag"(line 719, column 9)
            (_kind_errors''@_) =
                let  gkinds = nubBy unifyable $ take (fst _arity) _argkinds
                in   if length gkinds == 1
                     then  []
                     else  [GHError_KindIncGError _rangeIself _nameIself _arity gkinds]
            -- "./Kind.inc.lag"(line 717, column 9)
            (_pkinds@_) =
                take (snd _arity) . drop (fst _arity) $
                  _argkinds
            -- "./Kind.inc.lag"(line 712, column 9)
            (_gkind@_) =
                case _argkinds of
                  []     ->  internalError
                               "Kind.Declaration.GenericTypeSignature: illegal arity"
                  (x:_)  ->  x
            -- "./Kind.inc.lag"(line 710, column 9)
            (_argkinds@_) =
                splitKind _kind
            -- "./Kind.inc.lag"(line 709, column 9)
            (_kind@_) =
                fromJust $ find _lhsIkinds _nameIself
            -- "./Kind.inc.lag"(line 707, column 9)
            (_arity@_) =
                (length _genericsIself
                ,length _parametricsIself)
            -- "./KindIndexedType.inc.lag"(line 140, column 9)
            (_nkitlifted@_) =
                let (k:t:_)  =  prefixedVarNames
                    psn      =  map  (\(KindAnnotatedName_KindAnnotatedName _ n _) -> n)
                                     _parametricsIself
                in  Types.liftKindIndexedType
                      _lhsIkindIndexedTypes
                      (Just _arity)
                      t (varK k)
                      (faT psn $
                         qualT (deriveKITContext _typeIself psn) $
                           appT  (kappT (kitName _nameIself) (varK k))
                                 (replicate (fst _arity) (varT t)
                                   ++ map varT psn))
            -- "./KindIndexedType.inc.lag"(line 131, column 9)
            (_nkit@_) =
                Types.deriveKindIndexedType
                  _lhsIkindIndexedTypes
                  _lhsIdependencies
                  (_nameIself
                  ,_genericsIself
                  ,_parametricsIself
                  ,_typeIself
                  )
            -- "./KindIndexedType.inc.lag"(line 128, column 9)
            (_underlyingKIT@_) =
                if _isMPCstyle  then _okitlifted
                                else _nkit
            -- "./KindIndexedType.inc.lag"(line 126, column 9)
            (_liftedKIT@_) =
                if _isMPCstyle  then _okitlifted
                                else _nkitlifted
            -- "./KindIndexedType.inc.lag"(line 120, column 9)
            (_okitlifted@_) =
                Types.liftKindIndexedType
                  _lhsIkindIndexedTypes
                  Nothing
                  _typevariable
                  _vkind
                  _typeIself
            -- "./KindIndexedType.inc.lag"(line 114, column 9)
            (_lhsOkindIndexedTypes_collect@_) =
                foldl add
                  _lhsIkindIndexedTypes_collect
                  [(_nameIself,          _liftedKIT)
                  ,(kitName _nameIself,  _underlyingKIT)
                  ]
            -- "./KindIndexedType.inc.lag"(line 111, column 13)
            ((_typevariable@_,_vkind@_)) =
                let  (KindAnnotatedName_KindAnnotatedName _ t k) = head _genericsIself
                     (MaybeKind_Just j)                          = k
                in   (t,j)
            -- "./KindIndexedType.inc.lag"(line 184, column 10)
            (_staticErrors@_) =
                if    _isMPCstyle && hasDependencyItems _typeIself
                then  [GHError_MPCTypeSigDepItemError _rangeIself _nameIself]
                else  []
            -- "./Signature.inc.lag"(line 289, column 9)
            (_signature@_) =
                applyOrSignatureError _lhsIsignatures _nameIself $
                  "Signature.Declaration.GenericTypeSignature: " ++
                  "no signature"
            -- "./GenericAbstraction.inc.lag"(line 70, column 9)
            (_isGenericAbstraction@_) =
                isGASignature _lhsIsignatures _nameIself
            -- "./GenericAbstraction.inc.lag"(line 63, column 9)
            (_lhsOgenericAbstractions_collect@_) =
                if _isGenericAbstraction
                then  add  _lhsIgenericAbstractions_collect
                           (_nameIself,_gkind)
                else  _lhsIgenericAbstractions_collect
            -- "./GenericAbstraction.inc.lag"(line 95, column 9)
            (_genericAbstractionOutput@_) =
                Declaration_TypeSignature
                  unknownRange
                  [_nameIself]
                  (Types.parenthesize $ Types.haskell98Type $
                   Types.normalize $
                   TIT.handleTypeIndexedTypes _lhsIdependencies $
                   Types.normalize $
                     foldr
                       funAT
                       _typeIself
                       [ tpa
                       | let kind  =  applyFMM  _lhsIgenericAbstractions
                                                (const starK)
                                                _nameIself
                       , let deps  =  applyFMM  _lhsIdependencies
                                                (const [])
                                                _nameIself
                       , (dep,_) <- deps
                       , let kit = applyFMM
                                     _lhsIkindIndexedTypes
                                     (internalError $ "GenericAbstraction: "
                                       ++ "no kind-indexed type for "
                                       ++ PP.unPretty (PP.ppName dep)
                                     )
                                     dep
                       , let tpa = Types.forcePlainType "GenericAbstraction"
                                     $ Types.reduce
                                         (Types.applyKindIndexedType kit kind)
                                         [varT _typevariable]
                       ]
                  )
            -- "./Request.inc.lag"(line 355, column 9)
            (_lhsObimapImps_collect@_) =
                if _isGenericAbstraction then
                  _lhsIbimapImps_collect
                else
                  Request_BimapImply
                    (_nameIself,snd _basetype)
                    : _lhsIbimapImps_collect
            -- "./Request.inc.lag"(line 351, column 9)
            (_basetype@_) =
                Types.applyKindIndexedType
                  _liftedKIT
                  starK
            -- "./Request.inc.lag"(line 382, column 9)
            (_lhsOdepConstraints_collect@_) =
                filter
                  (\(DepConstraint (_,_,v)) -> _typevariable /= v)
                  _typeIdepConstraints_collect
            -- "./Request.inc.lag"(line 374, column 9)
            (_lhsOfunImps_collect@_) =
                let calls            = extractTypeIndexedTypes _basetype
                in  (if null calls then
                       []
                     else
                       [Request_FunImply (_nameIself,calls)]
                    ) ++ _lhsIfunImps_collect
            -- use rule
            (_lhsOdepConstraints_defined@_) =
                []
            -- use rule
            (_lhsOexportedDeclarations@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                _staticErrors
            -- self rule
            (_self@_) =
                Declaration_GenericTypeSignature _rangeIself _nameIself _genericsIself _parametricsIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _typeIabstractTypes_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- modified copy rule
            (_lhsOkindvar@_) =
                _typeIkindvar
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _typeIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _typeItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_genericsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_genericsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_genericsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_genericsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_genericsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_genericsOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_genericsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_genericsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_genericsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_genericsOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_genericsOkindvar@_) =
                _kindvar
            -- copy rule (down)
            (_genericsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_genericsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_genericsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_genericsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_genericsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_genericsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_genericsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_genericsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_genericsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_genericsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_genericsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_genericsOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_parametricsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_parametricsOconstructors_collect@_) =
                _genericsIconstructors_collect
            -- copy rule (down)
            (_parametricsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_parametricsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_parametricsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_parametricsOgenericAbstractions_collect@_) =
                _genericsIgenericAbstractions_collect
            -- copy rule (down)
            (_parametricsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_parametricsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_parametricsOinstancename@_) =
                _lhsIinstancename
            -- modified copy rule
            (_parametricsOkinames@_) =
                _genericsIkinames
            -- copy rule (down)
            (_parametricsOkinds@_) =
                _lhsIkinds
            -- modified copy rule
            (_parametricsOkindvar@_) =
                _genericsIkindvar
            -- copy rule (chain)
            (_parametricsOksubst@_) =
                _genericsIksubst
            -- copy rule (chain)
            (_parametricsOlabels_collect@_) =
                _genericsIlabels_collect
            -- copy rule (down)
            (_parametricsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_parametricsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_parametricsOmethods_collect@_) =
                _genericsImethods_collect
            -- copy rule (down)
            (_parametricsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_parametricsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_parametricsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_parametricsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_parametricsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_parametricsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_parametricsOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_typeOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_typeObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _parametricsIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_typeOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_typeOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_typeOgenericAbstractions_collect@_) =
                _parametricsIgenericAbstractions_collect
            -- copy rule (down)
            (_typeOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- modified copy rule
            (_typeOkinames@_) =
                _parametricsIkinames
            -- copy rule (down)
            (_typeOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_typeOksubst@_) =
                _parametricsIksubst
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _parametricsIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _parametricsImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typeOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_typeOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_typeOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_typeOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_typeOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_typeOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_typeOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect
             ,_lhsObimapImps_collect
             ,_lhsOconstructors_collect
             ,_lhsOdepConstraints_collect
             ,_lhsOdepConstraints_defined
             ,_lhsOexportedDeclarations
             ,_lhsOfunImps_collect
             ,_lhsOgenericAbstractions_collect
             ,_lhsOkinames
             ,_lhsOkindIndexedTypes_collect
             ,_lhsOkind_errors
             ,_lhsOkindvar
             ,_lhsOksubst
             ,_lhsOlabels_collect
             ,_lhsOmethods_collect
             ,_lhsOoutput
             ,_lhsOoutputi
             ,_lhsOpresignatures_collect
             ,_lhsOrawRequests_collect
             ,_lhsOself
             ,_lhsOstaticErrors
             ,_lhsOstructureTypes_collect
             ,_lhsOtypeImps_collect
             )
sem_Declaration_Instance :: (T_Range) ->
                            (T_ContextItems) ->
                            (T_Name) ->
                            (T_Types) ->
                            (T_MaybeDeclarations) ->
                            (T_Declaration)
sem_Declaration_Instance (range_) (context_) (name_) (types_) (where_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOdepConstraints_defined :: ([DepConstraint])
            _lhsOexportedDeclarations :: (Declarations)
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: (PP.Doc)
            _lhsOoutputi :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Declaration)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _contextIabstractTypes_collect :: (Set Name)
            _contextIbimapImps_collect :: ([Request_BimapImply])
            _contextIconstructors_collect :: (FMap Name Names)
            _contextIdepConstraints_collect :: ([DepConstraint])
            _contextIfunImps_collect :: ([Request_FunImply])
            _contextIgenericAbstractions_collect :: (FMap Name Kind)
            _contextIkinames :: (KSubst)
            _contextIkind_errors :: ([GHError])
            _contextIkindvar :: (Int)
            _contextIksubst :: (KSubst)
            _contextIlabels_collect :: (FMap Name Names)
            _contextImethods_collect :: (FMap Name Names)
            _contextIrawRequests_collect :: ([RawRequest])
            _contextIself :: (ContextItems)
            _contextIstaticErrors :: ([GHError])
            _contextItypeImps_collect :: ([Request_TypeImply])
            _contextOabstractTypes_collect :: (Set Name)
            _contextObimapImps_collect :: ([Request_BimapImply])
            _contextOclassname :: (Maybe Name)
            _contextOconstructors_collect :: (FMap Name Names)
            _contextOconstructors_dist :: (FMap Name Names)
            _contextOcurrentModule :: (Strings)
            _contextOdependencies :: (FMap Name [(Name,Name)])
            _contextOfunImps_collect :: ([Request_FunImply])
            _contextOgenericAbstractions :: (FMap Name Kind)
            _contextOgenericAbstractions_collect :: (FMap Name Kind)
            _contextOghc :: (Bool)
            _contextOimportedModule :: (Bool)
            _contextOinstancename :: (Maybe Name)
            _contextOkinames :: (KSubst)
            _contextOkinds :: (KSubst)
            _contextOkindvar :: (Int)
            _contextOksubst :: (KSubst)
            _contextOlabels_collect :: (FMap Name Names)
            _contextOlabels_dist :: (FMap Name Names)
            _contextOlocal :: (Bool)
            _contextOmethods_collect :: (FMap Name Names)
            _contextOmethods_dist :: (FMap Name Names)
            _contextOmodules :: (Set Strings)
            _contextOoptimizer :: (Bool)
            _contextOoptimizerPrelude :: (Declarations)
            _contextOprekind :: (KSubst)
            _contextOprelude :: (Bool)
            _contextOrawRequests_collect :: ([RawRequest])
            _contextOtoplevel :: (Bool)
            _contextOtypeImps_collect :: ([Request_TypeImply])
            _contextOverbosity :: (Int)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _typesIabstractTypes_collect :: (Set Name)
            _typesIbimapImps_collect :: ([Request_BimapImply])
            _typesIconstructors_collect :: (FMap Name Names)
            _typesIdepConstraints_collect :: ([DepConstraint])
            _typesIfunImps_collect :: ([Request_FunImply])
            _typesIgenericAbstractions_collect :: (FMap Name Kind)
            _typesIinferkind :: ([Kind])
            _typesIkinames :: (KSubst)
            _typesIkind_errors :: ([GHError])
            _typesIkindvar :: (Int)
            _typesIksubst :: (KSubst)
            _typesIlabels_collect :: (FMap Name Names)
            _typesImethods_collect :: (FMap Name Names)
            _typesIrawRequests_collect :: ([RawRequest])
            _typesIself :: (Types)
            _typesIstaticErrors :: ([GHError])
            _typesItypeImps_collect :: ([Request_TypeImply])
            _typesOabstractTypes_collect :: (Set Name)
            _typesObimapImps_collect :: ([Request_BimapImply])
            _typesOclassname :: (Maybe Name)
            _typesOconstructors_collect :: (FMap Name Names)
            _typesOconstructors_dist :: (FMap Name Names)
            _typesOcurrentModule :: (Strings)
            _typesOdependencies :: (FMap Name [(Name,Name)])
            _typesOfunImps_collect :: ([Request_FunImply])
            _typesOgenericAbstractions :: (FMap Name Kind)
            _typesOgenericAbstractions_collect :: (FMap Name Kind)
            _typesOghc :: (Bool)
            _typesOimportedModule :: (Bool)
            _typesOinstancename :: (Maybe Name)
            _typesOkinames :: (KSubst)
            _typesOkinds :: (KSubst)
            _typesOkindvar :: (Int)
            _typesOksubst :: (KSubst)
            _typesOlabels_collect :: (FMap Name Names)
            _typesOlabels_dist :: (FMap Name Names)
            _typesOlocal :: (Bool)
            _typesOmethods_collect :: (FMap Name Names)
            _typesOmethods_dist :: (FMap Name Names)
            _typesOmodules :: (Set Strings)
            _typesOoptimizer :: (Bool)
            _typesOoptimizerPrelude :: (Declarations)
            _typesOprekind :: (KSubst)
            _typesOprelude :: (Bool)
            _typesOrawRequests_collect :: ([RawRequest])
            _typesOtoplevel :: (Bool)
            _typesOtypeImps_collect :: ([Request_TypeImply])
            _typesOverbosity :: (Int)
            _whereIabstractTypes_collect :: (Set Name)
            _whereIbimapImps_collect :: ([Request_BimapImply])
            _whereIconstructors_collect :: (FMap Name Names)
            _whereIdepConstraints_collect :: ([DepConstraint])
            _whereIexportedDeclarations :: (MaybeDeclarations)
            _whereIfunImps_collect :: ([Request_FunImply])
            _whereIgenericAbstractions_collect :: (FMap Name Kind)
            _whereIkinames :: (KSubst)
            _whereIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _whereIkind_errors :: ([GHError])
            _whereIkindvar :: (Int)
            _whereIksubst :: (KSubst)
            _whereIlabels_collect :: (FMap Name Names)
            _whereImethods_collect :: (FMap Name Names)
            _whereIpresignatures_collect :: (PreSignatures)
            _whereIrawRequests_collect :: ([RawRequest])
            _whereIself :: (MaybeDeclarations)
            _whereIstaticErrors :: ([GHError])
            _whereIstructureTypes_collect :: (FMap Name LambdaType)
            _whereItypeImps_collect :: ([Request_TypeImply])
            _whereOabstractTypes_collect :: (Set Name)
            _whereObimapImps_collect :: ([Request_BimapImply])
            _whereOclassname :: (Maybe Name)
            _whereOconstructors_collect :: (FMap Name Names)
            _whereOconstructors_dist :: (FMap Name Names)
            _whereOcurrentModule :: (Strings)
            _whereOdependencies :: (FMap Name [(Name,Name)])
            _whereOexportedStructures :: (Set Name)
            _whereOexportedTypes :: (Set Name)
            _whereOexportedValues :: (Set Name)
            _whereOfunImps_collect :: ([Request_FunImply])
            _whereOgenericAbstractions :: (FMap Name Kind)
            _whereOgenericAbstractions_collect :: (FMap Name Kind)
            _whereOghc :: (Bool)
            _whereOimportedModule :: (Bool)
            _whereOinstancename :: (Maybe Name)
            _whereOkinames :: (KSubst)
            _whereOkindIndexedTypes :: (FMap Name KindIndexedType)
            _whereOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _whereOkinds :: (KSubst)
            _whereOkindvar :: (Int)
            _whereOksubst :: (KSubst)
            _whereOlabels_collect :: (FMap Name Names)
            _whereOlabels_dist :: (FMap Name Names)
            _whereOlocal :: (Bool)
            _whereOmethods_collect :: (FMap Name Names)
            _whereOmethods_dist :: (FMap Name Names)
            _whereOmodules :: (Set Strings)
            _whereOoptimizer :: (Bool)
            _whereOoptimizerPrelude :: (Declarations)
            _whereOprekind :: (KSubst)
            _whereOprelude :: (Bool)
            _whereOpresignatures :: (PreSignatures)
            _whereOpresignatures_collect :: (PreSignatures)
            _whereOrawRequests_collect :: ([RawRequest])
            _whereOsignatures :: (Signatures)
            _whereOstructureTypes_collect :: (FMap Name LambdaType)
            _whereOtoplevel :: (Bool)
            _whereOtypeImps_collect :: ([Request_TypeImply])
            _whereOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _contextIabstractTypes_collect,_contextIbimapImps_collect,_contextIconstructors_collect,_contextIdepConstraints_collect,_contextIfunImps_collect,_contextIgenericAbstractions_collect,_contextIkinames,_contextIkind_errors,_contextIkindvar,_contextIksubst,_contextIlabels_collect,_contextImethods_collect,_contextIrawRequests_collect,_contextIself,_contextIstaticErrors,_contextItypeImps_collect) =
                (context_ (_contextOabstractTypes_collect)
                          (_contextObimapImps_collect)
                          (_contextOclassname)
                          (_contextOconstructors_collect)
                          (_contextOconstructors_dist)
                          (_contextOcurrentModule)
                          (_contextOdependencies)
                          (_contextOfunImps_collect)
                          (_contextOgenericAbstractions)
                          (_contextOgenericAbstractions_collect)
                          (_contextOghc)
                          (_contextOimportedModule)
                          (_contextOinstancename)
                          (_contextOkinames)
                          (_contextOkinds)
                          (_contextOkindvar)
                          (_contextOksubst)
                          (_contextOlabels_collect)
                          (_contextOlabels_dist)
                          (_contextOlocal)
                          (_contextOmethods_collect)
                          (_contextOmethods_dist)
                          (_contextOmodules)
                          (_contextOoptimizer)
                          (_contextOoptimizerPrelude)
                          (_contextOprekind)
                          (_contextOprelude)
                          (_contextOrawRequests_collect)
                          (_contextOtoplevel)
                          (_contextOtypeImps_collect)
                          (_contextOverbosity))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _typesIabstractTypes_collect,_typesIbimapImps_collect,_typesIconstructors_collect,_typesIdepConstraints_collect,_typesIfunImps_collect,_typesIgenericAbstractions_collect,_typesIinferkind,_typesIkinames,_typesIkind_errors,_typesIkindvar,_typesIksubst,_typesIlabels_collect,_typesImethods_collect,_typesIrawRequests_collect,_typesIself,_typesIstaticErrors,_typesItypeImps_collect) =
                (types_ (_typesOabstractTypes_collect)
                        (_typesObimapImps_collect)
                        (_typesOclassname)
                        (_typesOconstructors_collect)
                        (_typesOconstructors_dist)
                        (_typesOcurrentModule)
                        (_typesOdependencies)
                        (_typesOfunImps_collect)
                        (_typesOgenericAbstractions)
                        (_typesOgenericAbstractions_collect)
                        (_typesOghc)
                        (_typesOimportedModule)
                        (_typesOinstancename)
                        (_typesOkinames)
                        (_typesOkinds)
                        (_typesOkindvar)
                        (_typesOksubst)
                        (_typesOlabels_collect)
                        (_typesOlabels_dist)
                        (_typesOlocal)
                        (_typesOmethods_collect)
                        (_typesOmethods_dist)
                        (_typesOmodules)
                        (_typesOoptimizer)
                        (_typesOoptimizerPrelude)
                        (_typesOprekind)
                        (_typesOprelude)
                        (_typesOrawRequests_collect)
                        (_typesOtoplevel)
                        (_typesOtypeImps_collect)
                        (_typesOverbosity))
            ( _whereIabstractTypes_collect
             ,_whereIbimapImps_collect
             ,_whereIconstructors_collect
             ,_whereIdepConstraints_collect
             ,_whereIexportedDeclarations
             ,_whereIfunImps_collect
             ,_whereIgenericAbstractions_collect
             ,_whereIkinames
             ,_whereIkindIndexedTypes_collect
             ,_whereIkind_errors
             ,_whereIkindvar
             ,_whereIksubst
             ,_whereIlabels_collect
             ,_whereImethods_collect
             ,_whereIpresignatures_collect
             ,_whereIrawRequests_collect
             ,_whereIself
             ,_whereIstaticErrors
             ,_whereIstructureTypes_collect
             ,_whereItypeImps_collect
             ) =
                (where_ (_whereOabstractTypes_collect)
                        (_whereObimapImps_collect)
                        (_whereOclassname)
                        (_whereOconstructors_collect)
                        (_whereOconstructors_dist)
                        (_whereOcurrentModule)
                        (_whereOdependencies)
                        (_whereOexportedStructures)
                        (_whereOexportedTypes)
                        (_whereOexportedValues)
                        (_whereOfunImps_collect)
                        (_whereOgenericAbstractions)
                        (_whereOgenericAbstractions_collect)
                        (_whereOghc)
                        (_whereOimportedModule)
                        (_whereOinstancename)
                        (_whereOkinames)
                        (_whereOkindIndexedTypes)
                        (_whereOkindIndexedTypes_collect)
                        (_whereOkinds)
                        (_whereOkindvar)
                        (_whereOksubst)
                        (_whereOlabels_collect)
                        (_whereOlabels_dist)
                        (_whereOlocal)
                        (_whereOmethods_collect)
                        (_whereOmethods_dist)
                        (_whereOmodules)
                        (_whereOoptimizer)
                        (_whereOoptimizerPrelude)
                        (_whereOprekind)
                        (_whereOprelude)
                        (_whereOpresignatures)
                        (_whereOpresignatures_collect)
                        (_whereOrawRequests_collect)
                        (_whereOsignatures)
                        (_whereOstructureTypes_collect)
                        (_whereOtoplevel)
                        (_whereOtypeImps_collect)
                        (_whereOverbosity))
            -- "./ModuleInformation.inc.lag"(line 140, column 8)
            (_instancename@_) =
                Just _nameIself
            -- "./Output.inc.lag"(line 228, column 9)
            (_lhsOoutput@_) =
                if _lhsIimportedModule then
                  PP.emptyPP
                else
                  PP.ppDeclaration False
                    (ER.replaceDeclaration
                       _lhsIdependencies
                       FMap.emptyFM
                       _lhsIgenericAbstractions
                       _self
                    )
            -- "./OutputI.inc.lag"(line 180, column 9)
            (_lhsOexportedDeclarations@_) =
                []
            -- "./Kind.inc.lag"(line 217, column 9)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- "./Kind.inc.lag"(line 216, column 9)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- "./Kind.inc.lag"(line 660, column 9)
            (_lhsOkind_errors@_) =
                []
            -- "./Kind.inc.lag"(line 659, column 9)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _contextIdepConstraints_collect ++ _typesIdepConstraints_collect ++ _whereIdepConstraints_collect
            -- use rule
            (_lhsOdepConstraints_defined@_) =
                []
            -- use rule
            (_lhsOoutputi@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                _contextIstaticErrors ++ _typesIstaticErrors ++ _whereIstaticErrors
            -- self rule
            (_self@_) =
                Declaration_Instance _rangeIself _contextIself _nameIself _typesIself _whereIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _whereIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _whereIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _whereIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _whereIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _whereIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _whereIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _whereIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _whereImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _whereIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _whereIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _whereIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _whereItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (chain)
            (_rangeOinstancename@_) =
                _instancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_contextOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_contextObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_contextOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_contextOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_contextOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_contextOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_contextOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_contextOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_contextOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_contextOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_contextOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_contextOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (chain)
            (_contextOinstancename@_) =
                _instancename
            -- copy rule (down)
            (_contextOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_contextOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_contextOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_contextOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_contextOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_contextOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_contextOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_contextOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_contextOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_contextOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_contextOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_contextOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_contextOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_contextOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_contextOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_contextOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_contextOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_contextOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_nameOconstructors_collect@_) =
                _contextIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_nameOgenericAbstractions_collect@_) =
                _contextIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (chain)
            (_nameOinstancename@_) =
                _instancename
            -- copy rule (chain)
            (_nameOlabels_collect@_) =
                _contextIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_nameOmethods_collect@_) =
                _contextImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_typesOabstractTypes_collect@_) =
                _contextIabstractTypes_collect
            -- copy rule (chain)
            (_typesObimapImps_collect@_) =
                _contextIbimapImps_collect
            -- copy rule (down)
            (_typesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typesOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_typesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typesOdependencies@_) =
                _lhsIdependencies
            -- copy rule (chain)
            (_typesOfunImps_collect@_) =
                _contextIfunImps_collect
            -- copy rule (down)
            (_typesOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_typesOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_typesOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_typesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (chain)
            (_typesOinstancename@_) =
                _instancename
            -- copy rule (chain)
            (_typesOkinames@_) =
                _contextIkinames
            -- copy rule (down)
            (_typesOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_typesOkindvar@_) =
                _contextIkindvar
            -- copy rule (chain)
            (_typesOksubst@_) =
                _contextIksubst
            -- copy rule (chain)
            (_typesOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_typesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typesOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_typesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typesOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_typesOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_typesOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_typesOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_typesOprelude@_) =
                _lhsIprelude
            -- copy rule (chain)
            (_typesOrawRequests_collect@_) =
                _contextIrawRequests_collect
            -- copy rule (down)
            (_typesOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_typesOtypeImps_collect@_) =
                _contextItypeImps_collect
            -- copy rule (down)
            (_typesOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_whereOabstractTypes_collect@_) =
                _typesIabstractTypes_collect
            -- copy rule (chain)
            (_whereObimapImps_collect@_) =
                _typesIbimapImps_collect
            -- copy rule (down)
            (_whereOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_whereOconstructors_collect@_) =
                _typesIconstructors_collect
            -- copy rule (down)
            (_whereOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_whereOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_whereOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_whereOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_whereOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_whereOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (chain)
            (_whereOfunImps_collect@_) =
                _typesIfunImps_collect
            -- copy rule (down)
            (_whereOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_whereOgenericAbstractions_collect@_) =
                _typesIgenericAbstractions_collect
            -- copy rule (down)
            (_whereOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_whereOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (chain)
            (_whereOinstancename@_) =
                _instancename
            -- copy rule (chain)
            (_whereOkinames@_) =
                _typesIkinames
            -- copy rule (down)
            (_whereOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_whereOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_whereOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_whereOkindvar@_) =
                _typesIkindvar
            -- copy rule (chain)
            (_whereOksubst@_) =
                _typesIksubst
            -- copy rule (chain)
            (_whereOlabels_collect@_) =
                _typesIlabels_collect
            -- copy rule (down)
            (_whereOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_whereOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_whereOmethods_collect@_) =
                _typesImethods_collect
            -- copy rule (down)
            (_whereOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_whereOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_whereOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_whereOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_whereOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_whereOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_whereOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_whereOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (chain)
            (_whereOrawRequests_collect@_) =
                _typesIrawRequests_collect
            -- copy rule (down)
            (_whereOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_whereOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_whereOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_whereOtypeImps_collect@_) =
                _typesItypeImps_collect
            -- copy rule (down)
            (_whereOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect
             ,_lhsObimapImps_collect
             ,_lhsOconstructors_collect
             ,_lhsOdepConstraints_collect
             ,_lhsOdepConstraints_defined
             ,_lhsOexportedDeclarations
             ,_lhsOfunImps_collect
             ,_lhsOgenericAbstractions_collect
             ,_lhsOkinames
             ,_lhsOkindIndexedTypes_collect
             ,_lhsOkind_errors
             ,_lhsOkindvar
             ,_lhsOksubst
             ,_lhsOlabels_collect
             ,_lhsOmethods_collect
             ,_lhsOoutput
             ,_lhsOoutputi
             ,_lhsOpresignatures_collect
             ,_lhsOrawRequests_collect
             ,_lhsOself
             ,_lhsOstaticErrors
             ,_lhsOstructureTypes_collect
             ,_lhsOtypeImps_collect
             )
sem_Declaration_KindIndexedType :: (T_Range) ->
                                   (T_KindIndexedBindings) ->
                                   (T_Declaration)
sem_Declaration_KindIndexedType (range_) (bindings_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOdepConstraints_defined :: ([DepConstraint])
            _lhsOexportedDeclarations :: (Declarations)
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: (PP.Doc)
            _lhsOoutputi :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Declaration)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _bindingsIabstractTypes_collect :: (Set Name)
            _bindingsIbimapImps_collect :: ([Request_BimapImply])
            _bindingsIconstructors_collect :: (FMap Name Names)
            _bindingsIdepConstraints_collect :: ([DepConstraint])
            _bindingsIfunImps_collect :: ([Request_FunImply])
            _bindingsIgenericAbstractions_collect :: (FMap Name Kind)
            _bindingsIkinames :: (KSubst)
            _bindingsIkindIndexedBindings :: ([Either LambdaType ((Name,Name),LambdaType)])
            _bindingsIkindIndexedType :: (KindIndexedType)
            _bindingsIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _bindingsIkind_errors :: ([GHError])
            _bindingsIkindvar :: (Int)
            _bindingsIksubst :: (KSubst)
            _bindingsIlabels_collect :: (FMap Name Names)
            _bindingsImethods_collect :: (FMap Name Names)
            _bindingsIname :: (Name)
            _bindingsIrawRequests_collect :: ([RawRequest])
            _bindingsIself :: (KindIndexedBindings)
            _bindingsIstaticErrors :: ([GHError])
            _bindingsItypeImps_collect :: ([Request_TypeImply])
            _bindingsIwellformed :: (Bool)
            _bindingsOabstractTypes_collect :: (Set Name)
            _bindingsObimapImps_collect :: ([Request_BimapImply])
            _bindingsOclassname :: (Maybe Name)
            _bindingsOconstructors_collect :: (FMap Name Names)
            _bindingsOconstructors_dist :: (FMap Name Names)
            _bindingsOcurrentModule :: (Strings)
            _bindingsOdependencies :: (FMap Name [(Name,Name)])
            _bindingsOfunImps_collect :: ([Request_FunImply])
            _bindingsOgenericAbstractions :: (FMap Name Kind)
            _bindingsOgenericAbstractions_collect :: (FMap Name Kind)
            _bindingsOghc :: (Bool)
            _bindingsOimportedModule :: (Bool)
            _bindingsOinstancename :: (Maybe Name)
            _bindingsOkinames :: (KSubst)
            _bindingsOkindIndexedTypes :: (FMap Name KindIndexedType)
            _bindingsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _bindingsOkinds :: (KSubst)
            _bindingsOkindvar :: (Int)
            _bindingsOksubst :: (KSubst)
            _bindingsOlabels_collect :: (FMap Name Names)
            _bindingsOlabels_dist :: (FMap Name Names)
            _bindingsOlocal :: (Bool)
            _bindingsOmethods_collect :: (FMap Name Names)
            _bindingsOmethods_dist :: (FMap Name Names)
            _bindingsOmodules :: (Set Strings)
            _bindingsOoptimizer :: (Bool)
            _bindingsOoptimizerPrelude :: (Declarations)
            _bindingsOprekind :: (KSubst)
            _bindingsOprelude :: (Bool)
            _bindingsOrawRequests_collect :: ([RawRequest])
            _bindingsOtoplevel :: (Bool)
            _bindingsOtypeImps_collect :: ([Request_TypeImply])
            _bindingsOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _bindingsIabstractTypes_collect
             ,_bindingsIbimapImps_collect
             ,_bindingsIconstructors_collect
             ,_bindingsIdepConstraints_collect
             ,_bindingsIfunImps_collect
             ,_bindingsIgenericAbstractions_collect
             ,_bindingsIkinames
             ,_bindingsIkindIndexedBindings
             ,_bindingsIkindIndexedType
             ,_bindingsIkindIndexedTypes_collect
             ,_bindingsIkind_errors
             ,_bindingsIkindvar
             ,_bindingsIksubst
             ,_bindingsIlabels_collect
             ,_bindingsImethods_collect
             ,_bindingsIname
             ,_bindingsIrawRequests_collect
             ,_bindingsIself
             ,_bindingsIstaticErrors
             ,_bindingsItypeImps_collect
             ,_bindingsIwellformed
             ) =
                (bindings_ (_bindingsOabstractTypes_collect)
                           (_bindingsObimapImps_collect)
                           (_bindingsOclassname)
                           (_bindingsOconstructors_collect)
                           (_bindingsOconstructors_dist)
                           (_bindingsOcurrentModule)
                           (_bindingsOdependencies)
                           (_bindingsOfunImps_collect)
                           (_bindingsOgenericAbstractions)
                           (_bindingsOgenericAbstractions_collect)
                           (_bindingsOghc)
                           (_bindingsOimportedModule)
                           (_bindingsOinstancename)
                           (_bindingsOkinames)
                           (_bindingsOkindIndexedTypes)
                           (_bindingsOkindIndexedTypes_collect)
                           (_bindingsOkinds)
                           (_bindingsOkindvar)
                           (_bindingsOksubst)
                           (_bindingsOlabels_collect)
                           (_bindingsOlabels_dist)
                           (_bindingsOlocal)
                           (_bindingsOmethods_collect)
                           (_bindingsOmethods_dist)
                           (_bindingsOmodules)
                           (_bindingsOoptimizer)
                           (_bindingsOoptimizerPrelude)
                           (_bindingsOprekind)
                           (_bindingsOprelude)
                           (_bindingsOrawRequests_collect)
                           (_bindingsOtoplevel)
                           (_bindingsOtypeImps_collect)
                           (_bindingsOverbosity))
            -- "./Output.inc.lag"(line 288, column 9)
            (_lhsOoutput@_) =
                PP.empty
            -- "./Exports.inc.lag"(line 536, column 9)
            (_is_exported@_) =
                Set.elementOf
                  _bindingsIname
                  _lhsIexportedTypes
            -- "./OutputI.inc.lag"(line 210, column 9)
            (_lhsOoutputi@_) =
                if _is_exported then
                  [PP.ppDeclaration True _self]
                else
                  []
            -- "./Kind.inc.lag"(line 192, column 9)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- "./Kind.inc.lag"(line 191, column 9)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- "./Kind.inc.lag"(line 648, column 9)
            (_lhsOkind_errors@_) =
                []
            -- "./Kind.inc.lag"(line 647, column 9)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- "./KindIndexedType.inc.lag"(line 79, column 9)
            (_lhsOkindIndexedTypes_collect@_) =
                if _bindingsIwellformed then
                  add
                    _lhsIkindIndexedTypes_collect
                    (_bindingsIname
                    ,_bindingsIkindIndexedType
                    )
                else
                   _lhsIkindIndexedTypes_collect
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _bindingsIdepConstraints_collect
            -- use rule
            (_lhsOdepConstraints_defined@_) =
                []
            -- use rule
            (_lhsOexportedDeclarations@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                _bindingsIstaticErrors
            -- self rule
            (_self@_) =
                Declaration_KindIndexedType _rangeIself _bindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _bindingsIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _bindingsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _bindingsIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _bindingsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _bindingsIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _bindingsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _bindingsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _bindingsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _bindingsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_bindingsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_bindingsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_bindingsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_bindingsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_bindingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_bindingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_bindingsOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_bindingsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_bindingsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_bindingsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_bindingsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_bindingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_bindingsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_bindingsOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_bindingsOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_bindingsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_bindingsOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_bindingsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_bindingsOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_bindingsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_bindingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_bindingsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_bindingsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_bindingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_bindingsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_bindingsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_bindingsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_bindingsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_bindingsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_bindingsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_bindingsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_bindingsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_bindingsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect
             ,_lhsObimapImps_collect
             ,_lhsOconstructors_collect
             ,_lhsOdepConstraints_collect
             ,_lhsOdepConstraints_defined
             ,_lhsOexportedDeclarations
             ,_lhsOfunImps_collect
             ,_lhsOgenericAbstractions_collect
             ,_lhsOkinames
             ,_lhsOkindIndexedTypes_collect
             ,_lhsOkind_errors
             ,_lhsOkindvar
             ,_lhsOksubst
             ,_lhsOlabels_collect
             ,_lhsOmethods_collect
             ,_lhsOoutput
             ,_lhsOoutputi
             ,_lhsOpresignatures_collect
             ,_lhsOrawRequests_collect
             ,_lhsOself
             ,_lhsOstaticErrors
             ,_lhsOstructureTypes_collect
             ,_lhsOtypeImps_collect
             )
sem_Declaration_Newtype :: (T_Range) ->
                           (T_ContextItems) ->
                           (T_SimpleType) ->
                           (T_Constructor) ->
                           (T_Names) ->
                           (T_Declaration)
sem_Declaration_Newtype (range_) (context_) (simpletype_) (constructor_) (derivings_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOdepConstraints_defined :: ([DepConstraint])
            _lhsOexportedDeclarations :: (Declarations)
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: (PP.Doc)
            _lhsOoutputi :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Declaration)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _contextIabstractTypes_collect :: (Set Name)
            _contextIbimapImps_collect :: ([Request_BimapImply])
            _contextIconstructors_collect :: (FMap Name Names)
            _contextIdepConstraints_collect :: ([DepConstraint])
            _contextIfunImps_collect :: ([Request_FunImply])
            _contextIgenericAbstractions_collect :: (FMap Name Kind)
            _contextIkinames :: (KSubst)
            _contextIkind_errors :: ([GHError])
            _contextIkindvar :: (Int)
            _contextIksubst :: (KSubst)
            _contextIlabels_collect :: (FMap Name Names)
            _contextImethods_collect :: (FMap Name Names)
            _contextIrawRequests_collect :: ([RawRequest])
            _contextIself :: (ContextItems)
            _contextIstaticErrors :: ([GHError])
            _contextItypeImps_collect :: ([Request_TypeImply])
            _contextOabstractTypes_collect :: (Set Name)
            _contextObimapImps_collect :: ([Request_BimapImply])
            _contextOclassname :: (Maybe Name)
            _contextOconstructors_collect :: (FMap Name Names)
            _contextOconstructors_dist :: (FMap Name Names)
            _contextOcurrentModule :: (Strings)
            _contextOdependencies :: (FMap Name [(Name,Name)])
            _contextOfunImps_collect :: ([Request_FunImply])
            _contextOgenericAbstractions :: (FMap Name Kind)
            _contextOgenericAbstractions_collect :: (FMap Name Kind)
            _contextOghc :: (Bool)
            _contextOimportedModule :: (Bool)
            _contextOinstancename :: (Maybe Name)
            _contextOkinames :: (KSubst)
            _contextOkinds :: (KSubst)
            _contextOkindvar :: (Int)
            _contextOksubst :: (KSubst)
            _contextOlabels_collect :: (FMap Name Names)
            _contextOlabels_dist :: (FMap Name Names)
            _contextOlocal :: (Bool)
            _contextOmethods_collect :: (FMap Name Names)
            _contextOmethods_dist :: (FMap Name Names)
            _contextOmodules :: (Set Strings)
            _contextOoptimizer :: (Bool)
            _contextOoptimizerPrelude :: (Declarations)
            _contextOprekind :: (KSubst)
            _contextOprelude :: (Bool)
            _contextOrawRequests_collect :: ([RawRequest])
            _contextOtoplevel :: (Bool)
            _contextOtypeImps_collect :: ([Request_TypeImply])
            _contextOverbosity :: (Int)
            _simpletypeIconstructors_collect :: (FMap Name Names)
            _simpletypeIgenericAbstractions_collect :: (FMap Name Kind)
            _simpletypeIinferkind :: (Kind)
            _simpletypeIkinames :: (KSubst)
            _simpletypeIkind_errors :: ([GHError])
            _simpletypeIkindvar :: (Int)
            _simpletypeIksubst :: (KSubst)
            _simpletypeIlabels_collect :: (FMap Name Names)
            _simpletypeImethods_collect :: (FMap Name Names)
            _simpletypeIname :: (Name)
            _simpletypeIself :: (SimpleType)
            _simpletypeOclassname :: (Maybe Name)
            _simpletypeOconstructors_collect :: (FMap Name Names)
            _simpletypeOconstructors_dist :: (FMap Name Names)
            _simpletypeOcurrentModule :: (Strings)
            _simpletypeOgenericAbstractions :: (FMap Name Kind)
            _simpletypeOgenericAbstractions_collect :: (FMap Name Kind)
            _simpletypeOghc :: (Bool)
            _simpletypeOimportedModule :: (Bool)
            _simpletypeOinstancename :: (Maybe Name)
            _simpletypeOkinames :: (KSubst)
            _simpletypeOkinds :: (KSubst)
            _simpletypeOkindvar :: (Int)
            _simpletypeOksubst :: (KSubst)
            _simpletypeOlabels_collect :: (FMap Name Names)
            _simpletypeOlabels_dist :: (FMap Name Names)
            _simpletypeOlocal :: (Bool)
            _simpletypeOmethods_collect :: (FMap Name Names)
            _simpletypeOmethods_dist :: (FMap Name Names)
            _simpletypeOmodules :: (Set Strings)
            _simpletypeOoptimizer :: (Bool)
            _simpletypeOoptimizerPrelude :: (Declarations)
            _simpletypeOprekind :: (KSubst)
            _simpletypeOprelude :: (Bool)
            _simpletypeOtoplevel :: (Bool)
            _simpletypeOverbosity :: (Int)
            _constructorIabstractTypes_collect :: (Set Name)
            _constructorIbimapImps_collect :: ([Request_BimapImply])
            _constructorIconsname :: (Name)
            _constructorIconstructors :: (Names)
            _constructorIconstructors_collect :: (FMap Name Names)
            _constructorIdepConstraints_collect :: ([DepConstraint])
            _constructorIfunImps_collect :: ([Request_FunImply])
            _constructorIgenericAbstractions_collect :: (FMap Name Kind)
            _constructorIkinames :: (KSubst)
            _constructorIkind_errors :: ([GHError])
            _constructorIkindvar :: (Int)
            _constructorIksubst :: (KSubst)
            _constructorIlabels :: (Names)
            _constructorIlabels_collect :: (FMap Name Names)
            _constructorImethods_collect :: (FMap Name Names)
            _constructorIrawRequests_collect :: ([RawRequest])
            _constructorIself :: (Constructor)
            _constructorIstaticErrors :: ([GHError])
            _constructorItypeImps :: ([Type])
            _constructorItypeImps_collect :: ([Request_TypeImply])
            _constructorOabstractTypes_collect :: (Set Name)
            _constructorObimapImps_collect :: ([Request_BimapImply])
            _constructorOclassname :: (Maybe Name)
            _constructorOconstructors_collect :: (FMap Name Names)
            _constructorOconstructors_dist :: (FMap Name Names)
            _constructorOcurrentModule :: (Strings)
            _constructorOdependencies :: (FMap Name [(Name,Name)])
            _constructorOfunImps_collect :: ([Request_FunImply])
            _constructorOgenericAbstractions :: (FMap Name Kind)
            _constructorOgenericAbstractions_collect :: (FMap Name Kind)
            _constructorOghc :: (Bool)
            _constructorOimportedModule :: (Bool)
            _constructorOinstancename :: (Maybe Name)
            _constructorOkinames :: (KSubst)
            _constructorOkinds :: (KSubst)
            _constructorOkindvar :: (Int)
            _constructorOksubst :: (KSubst)
            _constructorOlabels_collect :: (FMap Name Names)
            _constructorOlabels_dist :: (FMap Name Names)
            _constructorOlocal :: (Bool)
            _constructorOmethods_collect :: (FMap Name Names)
            _constructorOmethods_dist :: (FMap Name Names)
            _constructorOmodules :: (Set Strings)
            _constructorOoptimizer :: (Bool)
            _constructorOoptimizerPrelude :: (Declarations)
            _constructorOprekind :: (KSubst)
            _constructorOprelude :: (Bool)
            _constructorOrawRequests_collect :: ([RawRequest])
            _constructorOtoplevel :: (Bool)
            _constructorOtypeImps_collect :: ([Request_TypeImply])
            _constructorOverbosity :: (Int)
            _derivingsIconstructors_collect :: (FMap Name Names)
            _derivingsIgenericAbstractions_collect :: (FMap Name Kind)
            _derivingsIinferkind :: (Kind)
            _derivingsIkinames :: (KSubst)
            _derivingsIkind_errors :: ([GHError])
            _derivingsIkindvar :: (Int)
            _derivingsIksubst :: (KSubst)
            _derivingsIlabels_collect :: (FMap Name Names)
            _derivingsImethods_collect :: (FMap Name Names)
            _derivingsIself :: (Names)
            _derivingsOclassname :: (Maybe Name)
            _derivingsOconstructors_collect :: (FMap Name Names)
            _derivingsOconstructors_dist :: (FMap Name Names)
            _derivingsOcurrentModule :: (Strings)
            _derivingsOgenericAbstractions :: (FMap Name Kind)
            _derivingsOgenericAbstractions_collect :: (FMap Name Kind)
            _derivingsOghc :: (Bool)
            _derivingsOimportedModule :: (Bool)
            _derivingsOinstancename :: (Maybe Name)
            _derivingsOkinames :: (KSubst)
            _derivingsOkinds :: (KSubst)
            _derivingsOkindvar :: (Int)
            _derivingsOksubst :: (KSubst)
            _derivingsOlabels_collect :: (FMap Name Names)
            _derivingsOlabels_dist :: (FMap Name Names)
            _derivingsOlocal :: (Bool)
            _derivingsOmethods_collect :: (FMap Name Names)
            _derivingsOmethods_dist :: (FMap Name Names)
            _derivingsOmodules :: (Set Strings)
            _derivingsOoptimizer :: (Bool)
            _derivingsOoptimizerPrelude :: (Declarations)
            _derivingsOprekind :: (KSubst)
            _derivingsOprelude :: (Bool)
            _derivingsOtoplevel :: (Bool)
            _derivingsOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _contextIabstractTypes_collect,_contextIbimapImps_collect,_contextIconstructors_collect,_contextIdepConstraints_collect,_contextIfunImps_collect,_contextIgenericAbstractions_collect,_contextIkinames,_contextIkind_errors,_contextIkindvar,_contextIksubst,_contextIlabels_collect,_contextImethods_collect,_contextIrawRequests_collect,_contextIself,_contextIstaticErrors,_contextItypeImps_collect) =
                (context_ (_contextOabstractTypes_collect)
                          (_contextObimapImps_collect)
                          (_contextOclassname)
                          (_contextOconstructors_collect)
                          (_contextOconstructors_dist)
                          (_contextOcurrentModule)
                          (_contextOdependencies)
                          (_contextOfunImps_collect)
                          (_contextOgenericAbstractions)
                          (_contextOgenericAbstractions_collect)
                          (_contextOghc)
                          (_contextOimportedModule)
                          (_contextOinstancename)
                          (_contextOkinames)
                          (_contextOkinds)
                          (_contextOkindvar)
                          (_contextOksubst)
                          (_contextOlabels_collect)
                          (_contextOlabels_dist)
                          (_contextOlocal)
                          (_contextOmethods_collect)
                          (_contextOmethods_dist)
                          (_contextOmodules)
                          (_contextOoptimizer)
                          (_contextOoptimizerPrelude)
                          (_contextOprekind)
                          (_contextOprelude)
                          (_contextOrawRequests_collect)
                          (_contextOtoplevel)
                          (_contextOtypeImps_collect)
                          (_contextOverbosity))
            ( _simpletypeIconstructors_collect,_simpletypeIgenericAbstractions_collect,_simpletypeIinferkind,_simpletypeIkinames,_simpletypeIkind_errors,_simpletypeIkindvar,_simpletypeIksubst,_simpletypeIlabels_collect,_simpletypeImethods_collect,_simpletypeIname,_simpletypeIself) =
                (simpletype_ (_simpletypeOclassname)
                             (_simpletypeOconstructors_collect)
                             (_simpletypeOconstructors_dist)
                             (_simpletypeOcurrentModule)
                             (_simpletypeOgenericAbstractions)
                             (_simpletypeOgenericAbstractions_collect)
                             (_simpletypeOghc)
                             (_simpletypeOimportedModule)
                             (_simpletypeOinstancename)
                             (_simpletypeOkinames)
                             (_simpletypeOkinds)
                             (_simpletypeOkindvar)
                             (_simpletypeOksubst)
                             (_simpletypeOlabels_collect)
                             (_simpletypeOlabels_dist)
                             (_simpletypeOlocal)
                             (_simpletypeOmethods_collect)
                             (_simpletypeOmethods_dist)
                             (_simpletypeOmodules)
                             (_simpletypeOoptimizer)
                             (_simpletypeOoptimizerPrelude)
                             (_simpletypeOprekind)
                             (_simpletypeOprelude)
                             (_simpletypeOtoplevel)
                             (_simpletypeOverbosity))
            ( _constructorIabstractTypes_collect
             ,_constructorIbimapImps_collect
             ,_constructorIconsname
             ,_constructorIconstructors
             ,_constructorIconstructors_collect
             ,_constructorIdepConstraints_collect
             ,_constructorIfunImps_collect
             ,_constructorIgenericAbstractions_collect
             ,_constructorIkinames
             ,_constructorIkind_errors
             ,_constructorIkindvar
             ,_constructorIksubst
             ,_constructorIlabels
             ,_constructorIlabels_collect
             ,_constructorImethods_collect
             ,_constructorIrawRequests_collect
             ,_constructorIself
             ,_constructorIstaticErrors
             ,_constructorItypeImps
             ,_constructorItypeImps_collect
             ) =
                (constructor_ (_constructorOabstractTypes_collect)
                              (_constructorObimapImps_collect)
                              (_constructorOclassname)
                              (_constructorOconstructors_collect)
                              (_constructorOconstructors_dist)
                              (_constructorOcurrentModule)
                              (_constructorOdependencies)
                              (_constructorOfunImps_collect)
                              (_constructorOgenericAbstractions)
                              (_constructorOgenericAbstractions_collect)
                              (_constructorOghc)
                              (_constructorOimportedModule)
                              (_constructorOinstancename)
                              (_constructorOkinames)
                              (_constructorOkinds)
                              (_constructorOkindvar)
                              (_constructorOksubst)
                              (_constructorOlabels_collect)
                              (_constructorOlabels_dist)
                              (_constructorOlocal)
                              (_constructorOmethods_collect)
                              (_constructorOmethods_dist)
                              (_constructorOmodules)
                              (_constructorOoptimizer)
                              (_constructorOoptimizerPrelude)
                              (_constructorOprekind)
                              (_constructorOprelude)
                              (_constructorOrawRequests_collect)
                              (_constructorOtoplevel)
                              (_constructorOtypeImps_collect)
                              (_constructorOverbosity))
            ( _derivingsIconstructors_collect,_derivingsIgenericAbstractions_collect,_derivingsIinferkind,_derivingsIkinames,_derivingsIkind_errors,_derivingsIkindvar,_derivingsIksubst,_derivingsIlabels_collect,_derivingsImethods_collect,_derivingsIself) =
                (derivings_ (_derivingsOclassname)
                            (_derivingsOconstructors_collect)
                            (_derivingsOconstructors_dist)
                            (_derivingsOcurrentModule)
                            (_derivingsOgenericAbstractions)
                            (_derivingsOgenericAbstractions_collect)
                            (_derivingsOghc)
                            (_derivingsOimportedModule)
                            (_derivingsOinstancename)
                            (_derivingsOkinames)
                            (_derivingsOkinds)
                            (_derivingsOkindvar)
                            (_derivingsOksubst)
                            (_derivingsOlabels_collect)
                            (_derivingsOlabels_dist)
                            (_derivingsOlocal)
                            (_derivingsOmethods_collect)
                            (_derivingsOmethods_dist)
                            (_derivingsOmodules)
                            (_derivingsOoptimizer)
                            (_derivingsOoptimizerPrelude)
                            (_derivingsOprekind)
                            (_derivingsOprelude)
                            (_derivingsOtoplevel)
                            (_derivingsOverbosity))
            -- "GH.lag"(line 360, column 13)
            ((_strtype@_,_ep@_,_contype@_,_descriptors@_)) =
                ST.all _self
            -- "./ModuleInformation.inc.lag"(line 323, column 9)
            (_lhsOlabels_collect@_) =
                add _lhsIlabels_collect
                    (_simpletypeIname,_constructorIlabels)
            -- "./ModuleInformation.inc.lag"(line 321, column 9)
            (_lhsOconstructors_collect@_) =
                add _lhsIconstructors_collect
                    (_simpletypeIname,_constructorIconstructors)
            -- "./Output.inc.lag"(line 188, column 9)
            (_lhsOoutput@_) =
                let kc = [mkKindComment
                            _simpletypeIname
                            _kind
                         ]
                    sc = [mkStrTypeComment _simpletypeIname]
                    ec = [mkEPComment _simpletypeIname]
                    dc = [mkDescrComment _simpletypeIname]
                in  PP.vcat . concat $
                      [ kc
                      , if _lhsIimportedModule then
                          []
                        else
                          [PP.ppDeclarationWithKind False _self _kind _lhsIghc]
                      , PP.ppDeclarationsWithKind False _contype _kind _lhsIghc
                      , sc, PP.ppDeclarationsWithKind False _strtype _kind _lhsIghc
                      , ec, PP.ppDeclarations False _ep
                      , dc, PP.ppDeclarations False _descriptors
                      ]
            -- "./Exports.inc.lag"(line 525, column 9)
            (_subs_exported@_) =
                filter
                  (\n -> Set.elementOf n _lhsIexportedValues)
                  _constructorIconstructors
            -- "./Exports.inc.lag"(line 517, column 9)
            (_structure_exported@_) =
                Set.elementOf
                  _simpletypeIname
                  _lhsIexportedStructures
            -- "./Exports.inc.lag"(line 514, column 9)
            (_is_exported@_) =
                Set.elementOf
                  _simpletypeIname
                  _lhsIexportedTypes
            -- "./OutputI.inc.lag"(line 163, column 9)
            (_is_implied@_) =
                False
            -- "./OutputI.inc.lag"(line 149, column 9)
            (_lhsOoutputi@_) =
                if _is_implied || _structure_exported then
                  [PP.ppDeclarationWithKind True _self _kind True]
                else
                  [PP.ppInterfaceDeclaration True
                     (InterfaceDeclaration_Abstract
                        unknownRange
                        _simpletypeIname
                        _subs_exported
                        (replicate (length _subs_exported)
                                   (faNT ["a"] $ varNT "a")
                        )
                        _kind
                     )
                  ]
            -- "./Kind.inc.lag"(line 188, column 9)
            (_constructorOprekind@_) =
                _simpletypeIkinames
            -- "./Kind.inc.lag"(line 187, column 9)
            (_simpletypeOkinames@_) =
                _lhsIprekind
            -- "./Kind.inc.lag"(line 186, column 9)
            (_lhsOkinames@_) =
                _kinames
            -- "./Kind.inc.lag"(line 185, column 9)
            (_kinames@_) =
                foldl add _lhsIkinames _new_kinames
            -- "./Kind.inc.lag"(line 183, column 9)
            (_new_kinames@_) =
                map (\ n -> (n,_kvar))
                  [_simpletypeIname,_constructorIconsname]
            -- "./Kind.inc.lag"(line 182, column 9)
            (_kvar@_) =
                mkKindVar' _kindvar
            -- "./Kind.inc.lag"(line 181, column 9)
            (_kindvar@_) =
                _lhsIkindvar + 1
            -- "./Kind.inc.lag"(line 594, column 9)
            (_lhsOkind_errors@_) =
                _constructorIkind_errors ++ _kind_errors
            -- "./Kind.inc.lag"(line 593, column 9)
            (_lhsOksubst@_) =
                removeKindVars _kvar _ksubstKV
            -- "./Kind.inc.lag"(line 588, column 13)
            ((_ksubstKV@_,_kind_errors@_)) =
                unifyToplevel _rangeIself
                  _simpletypeIname "newtype"
                  _kvar _simpletypeIinferkind
                  _constructorIksubst
            -- "./Kind.inc.lag"(line 746, column 9)
            (_kind@_) =
                fromJust $ find _lhsIkinds _simpletypeIname
            -- "./Request.inc.lag"(line 153, column 9)
            (_lhsOtypeImps_collect@_) =
                Request_TypeImply
                  (Types.conT _simpletypeIname
                  ,_typeImps
                  )
                  : _lhsItypeImps_collect
            -- "./Request.inc.lag"(line 199, column 9)
            (_typeImps@_) =
                if elem
                     _simpletypeIname
                     [conName,labelName]
                then
                  []
                else
                  _imply_Con ++ _constructorItypeImps
            -- "./Request.inc.lag"(line 198, column 9)
            (_imply_Con@_) =
                [Types.conT conName]
            -- "./Request.inc.lag"(line 531, column 9)
            (_lhsOstructureTypes_collect@_) =
                foldl add
                  _lhsIstructureTypes_collect
                  (extractStructureTypes _strtype)
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _contextIdepConstraints_collect ++ _constructorIdepConstraints_collect
            -- use rule
            (_lhsOdepConstraints_defined@_) =
                []
            -- use rule
            (_lhsOexportedDeclarations@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                _contextIstaticErrors ++ _constructorIstaticErrors
            -- self rule
            (_self@_) =
                Declaration_Newtype _rangeIself _contextIself _simpletypeIself _constructorIself _derivingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _constructorIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _constructorIbimapImps_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _constructorIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _derivingsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- modified copy rule
            (_lhsOkindvar@_) =
                _derivingsIkindvar
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _derivingsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _constructorIrawRequests_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_contextOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_contextObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_contextOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_contextOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_contextOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_contextOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_contextOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_contextOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_contextOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_contextOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_contextOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_contextOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_contextOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_contextOkinames@_) =
                _kinames
            -- copy rule (down)
            (_contextOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_contextOkindvar@_) =
                _kindvar
            -- copy rule (down)
            (_contextOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_contextOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_contextOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_contextOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_contextOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_contextOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_contextOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_contextOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_contextOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_contextOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_contextOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_contextOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_contextOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_contextOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_contextOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_simpletypeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_simpletypeOconstructors_collect@_) =
                _contextIconstructors_collect
            -- copy rule (down)
            (_simpletypeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_simpletypeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_simpletypeOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_simpletypeOgenericAbstractions_collect@_) =
                _contextIgenericAbstractions_collect
            -- copy rule (down)
            (_simpletypeOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_simpletypeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_simpletypeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_simpletypeOkinds@_) =
                _lhsIkinds
            -- modified copy rule
            (_simpletypeOkindvar@_) =
                _contextIkindvar
            -- copy rule (chain)
            (_simpletypeOksubst@_) =
                _contextIksubst
            -- copy rule (chain)
            (_simpletypeOlabels_collect@_) =
                _contextIlabels_collect
            -- copy rule (down)
            (_simpletypeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_simpletypeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_simpletypeOmethods_collect@_) =
                _contextImethods_collect
            -- copy rule (down)
            (_simpletypeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_simpletypeOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_simpletypeOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_simpletypeOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_simpletypeOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_simpletypeOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_simpletypeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_simpletypeOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_constructorOabstractTypes_collect@_) =
                _contextIabstractTypes_collect
            -- copy rule (chain)
            (_constructorObimapImps_collect@_) =
                _contextIbimapImps_collect
            -- copy rule (down)
            (_constructorOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_constructorOconstructors_collect@_) =
                _simpletypeIconstructors_collect
            -- copy rule (down)
            (_constructorOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_constructorOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_constructorOdependencies@_) =
                _lhsIdependencies
            -- copy rule (chain)
            (_constructorOfunImps_collect@_) =
                _contextIfunImps_collect
            -- copy rule (down)
            (_constructorOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_constructorOgenericAbstractions_collect@_) =
                _simpletypeIgenericAbstractions_collect
            -- copy rule (down)
            (_constructorOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_constructorOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_constructorOinstancename@_) =
                _lhsIinstancename
            -- modified copy rule
            (_constructorOkinames@_) =
                _simpletypeIkinames
            -- copy rule (down)
            (_constructorOkinds@_) =
                _lhsIkinds
            -- modified copy rule
            (_constructorOkindvar@_) =
                _simpletypeIkindvar
            -- copy rule (chain)
            (_constructorOksubst@_) =
                _simpletypeIksubst
            -- copy rule (chain)
            (_constructorOlabels_collect@_) =
                _simpletypeIlabels_collect
            -- copy rule (down)
            (_constructorOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_constructorOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_constructorOmethods_collect@_) =
                _simpletypeImethods_collect
            -- copy rule (down)
            (_constructorOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_constructorOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_constructorOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_constructorOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_constructorOprelude@_) =
                _lhsIprelude
            -- copy rule (chain)
            (_constructorOrawRequests_collect@_) =
                _contextIrawRequests_collect
            -- copy rule (down)
            (_constructorOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_constructorOtypeImps_collect@_) =
                _contextItypeImps_collect
            -- copy rule (down)
            (_constructorOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_derivingsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_derivingsOconstructors_collect@_) =
                _constructorIconstructors_collect
            -- copy rule (down)
            (_derivingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_derivingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_derivingsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_derivingsOgenericAbstractions_collect@_) =
                _constructorIgenericAbstractions_collect
            -- copy rule (down)
            (_derivingsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_derivingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_derivingsOinstancename@_) =
                _lhsIinstancename
            -- modified copy rule
            (_derivingsOkinames@_) =
                _constructorIkinames
            -- copy rule (down)
            (_derivingsOkinds@_) =
                _lhsIkinds
            -- modified copy rule
            (_derivingsOkindvar@_) =
                _constructorIkindvar
            -- copy rule (chain)
            (_derivingsOksubst@_) =
                _constructorIksubst
            -- copy rule (chain)
            (_derivingsOlabels_collect@_) =
                _constructorIlabels_collect
            -- copy rule (down)
            (_derivingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_derivingsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_derivingsOmethods_collect@_) =
                _constructorImethods_collect
            -- copy rule (down)
            (_derivingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_derivingsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_derivingsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_derivingsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_derivingsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_derivingsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_derivingsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_derivingsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect
             ,_lhsObimapImps_collect
             ,_lhsOconstructors_collect
             ,_lhsOdepConstraints_collect
             ,_lhsOdepConstraints_defined
             ,_lhsOexportedDeclarations
             ,_lhsOfunImps_collect
             ,_lhsOgenericAbstractions_collect
             ,_lhsOkinames
             ,_lhsOkindIndexedTypes_collect
             ,_lhsOkind_errors
             ,_lhsOkindvar
             ,_lhsOksubst
             ,_lhsOlabels_collect
             ,_lhsOmethods_collect
             ,_lhsOoutput
             ,_lhsOoutputi
             ,_lhsOpresignatures_collect
             ,_lhsOrawRequests_collect
             ,_lhsOself
             ,_lhsOstaticErrors
             ,_lhsOstructureTypes_collect
             ,_lhsOtypeImps_collect
             )
sem_Declaration_PatternBinding :: (T_Range) ->
                                  (T_Pattern) ->
                                  (T_RightHandSide) ->
                                  (T_Declaration)
sem_Declaration_PatternBinding (range_) (pattern_) (righthandside_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOdepConstraints_defined :: ([DepConstraint])
            _lhsOexportedDeclarations :: (Declarations)
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: (PP.Doc)
            _lhsOoutputi :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Declaration)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _patternIconstructors_collect :: (FMap Name Names)
            _patternIgenericAbstractions_collect :: (FMap Name Kind)
            _patternIlabels_collect :: (FMap Name Names)
            _patternImethods_collect :: (FMap Name Names)
            _patternIname :: (Name)
            _patternIself :: (Pattern)
            _patternOclassname :: (Maybe Name)
            _patternOconstructors_collect :: (FMap Name Names)
            _patternOconstructors_dist :: (FMap Name Names)
            _patternOcurrentModule :: (Strings)
            _patternOgenericAbstractions :: (FMap Name Kind)
            _patternOgenericAbstractions_collect :: (FMap Name Kind)
            _patternOghc :: (Bool)
            _patternOimportedModule :: (Bool)
            _patternOinstancename :: (Maybe Name)
            _patternOlabels_collect :: (FMap Name Names)
            _patternOlabels_dist :: (FMap Name Names)
            _patternOlocal :: (Bool)
            _patternOmethods_collect :: (FMap Name Names)
            _patternOmethods_dist :: (FMap Name Names)
            _patternOmodules :: (Set Strings)
            _patternOoptimizer :: (Bool)
            _patternOoptimizerPrelude :: (Declarations)
            _patternOprelude :: (Bool)
            _patternOtoplevel :: (Bool)
            _patternOverbosity :: (Int)
            _righthandsideIabstractTypes_collect :: (Set Name)
            _righthandsideIbimapImps_collect :: ([Request_BimapImply])
            _righthandsideIconstructors_collect :: (FMap Name Names)
            _righthandsideIdepConstraints_collect :: ([DepConstraint])
            _righthandsideIfunImps_collect :: ([Request_FunImply])
            _righthandsideIgenericAbstractions_collect :: (FMap Name Kind)
            _righthandsideIkinames :: (KSubst)
            _righthandsideIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _righthandsideIkind_errors :: ([GHError])
            _righthandsideIkindvar :: (Int)
            _righthandsideIksubst :: (KSubst)
            _righthandsideIlabels_collect :: (FMap Name Names)
            _righthandsideImethods_collect :: (FMap Name Names)
            _righthandsideIpresignatures_collect :: (PreSignatures)
            _righthandsideIrawRequests_collect :: ([RawRequest])
            _righthandsideIself :: (RightHandSide)
            _righthandsideIstaticErrors :: ([GHError])
            _righthandsideIstructureTypes_collect :: (FMap Name LambdaType)
            _righthandsideItypeImps_collect :: ([Request_TypeImply])
            _righthandsideOabstractTypes_collect :: (Set Name)
            _righthandsideObimapImps_collect :: ([Request_BimapImply])
            _righthandsideOclassname :: (Maybe Name)
            _righthandsideOconstructors_collect :: (FMap Name Names)
            _righthandsideOconstructors_dist :: (FMap Name Names)
            _righthandsideOcurrentModule :: (Strings)
            _righthandsideOdependencies :: (FMap Name [(Name,Name)])
            _righthandsideOexportedStructures :: (Set Name)
            _righthandsideOexportedTypes :: (Set Name)
            _righthandsideOexportedValues :: (Set Name)
            _righthandsideOfunImps_collect :: ([Request_FunImply])
            _righthandsideOgenericAbstractions :: (FMap Name Kind)
            _righthandsideOgenericAbstractions_collect :: (FMap Name Kind)
            _righthandsideOghc :: (Bool)
            _righthandsideOimportedModule :: (Bool)
            _righthandsideOinstancename :: (Maybe Name)
            _righthandsideOkinames :: (KSubst)
            _righthandsideOkindIndexedTypes :: (FMap Name KindIndexedType)
            _righthandsideOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _righthandsideOkinds :: (KSubst)
            _righthandsideOkindvar :: (Int)
            _righthandsideOksubst :: (KSubst)
            _righthandsideOlabels_collect :: (FMap Name Names)
            _righthandsideOlabels_dist :: (FMap Name Names)
            _righthandsideOlocal :: (Bool)
            _righthandsideOmethods_collect :: (FMap Name Names)
            _righthandsideOmethods_dist :: (FMap Name Names)
            _righthandsideOmodules :: (Set Strings)
            _righthandsideOoptimizer :: (Bool)
            _righthandsideOoptimizerPrelude :: (Declarations)
            _righthandsideOprekind :: (KSubst)
            _righthandsideOprelude :: (Bool)
            _righthandsideOpresignatures :: (PreSignatures)
            _righthandsideOpresignatures_collect :: (PreSignatures)
            _righthandsideOrawRequests_collect :: ([RawRequest])
            _righthandsideOsignatures :: (Signatures)
            _righthandsideOstructureTypes_collect :: (FMap Name LambdaType)
            _righthandsideOtoplevel :: (Bool)
            _righthandsideOtypeImps_collect :: ([Request_TypeImply])
            _righthandsideOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _patternIconstructors_collect,_patternIgenericAbstractions_collect,_patternIlabels_collect,_patternImethods_collect,_patternIname,_patternIself) =
                (pattern_ (_patternOclassname)
                          (_patternOconstructors_collect)
                          (_patternOconstructors_dist)
                          (_patternOcurrentModule)
                          (_patternOgenericAbstractions)
                          (_patternOgenericAbstractions_collect)
                          (_patternOghc)
                          (_patternOimportedModule)
                          (_patternOinstancename)
                          (_patternOlabels_collect)
                          (_patternOlabels_dist)
                          (_patternOlocal)
                          (_patternOmethods_collect)
                          (_patternOmethods_dist)
                          (_patternOmodules)
                          (_patternOoptimizer)
                          (_patternOoptimizerPrelude)
                          (_patternOprelude)
                          (_patternOtoplevel)
                          (_patternOverbosity))
            ( _righthandsideIabstractTypes_collect
             ,_righthandsideIbimapImps_collect
             ,_righthandsideIconstructors_collect
             ,_righthandsideIdepConstraints_collect
             ,_righthandsideIfunImps_collect
             ,_righthandsideIgenericAbstractions_collect
             ,_righthandsideIkinames
             ,_righthandsideIkindIndexedTypes_collect
             ,_righthandsideIkind_errors
             ,_righthandsideIkindvar
             ,_righthandsideIksubst
             ,_righthandsideIlabels_collect
             ,_righthandsideImethods_collect
             ,_righthandsideIpresignatures_collect
             ,_righthandsideIrawRequests_collect
             ,_righthandsideIself
             ,_righthandsideIstaticErrors
             ,_righthandsideIstructureTypes_collect
             ,_righthandsideItypeImps_collect
             ) =
                (righthandside_ (_righthandsideOabstractTypes_collect)
                                (_righthandsideObimapImps_collect)
                                (_righthandsideOclassname)
                                (_righthandsideOconstructors_collect)
                                (_righthandsideOconstructors_dist)
                                (_righthandsideOcurrentModule)
                                (_righthandsideOdependencies)
                                (_righthandsideOexportedStructures)
                                (_righthandsideOexportedTypes)
                                (_righthandsideOexportedValues)
                                (_righthandsideOfunImps_collect)
                                (_righthandsideOgenericAbstractions)
                                (_righthandsideOgenericAbstractions_collect)
                                (_righthandsideOghc)
                                (_righthandsideOimportedModule)
                                (_righthandsideOinstancename)
                                (_righthandsideOkinames)
                                (_righthandsideOkindIndexedTypes)
                                (_righthandsideOkindIndexedTypes_collect)
                                (_righthandsideOkinds)
                                (_righthandsideOkindvar)
                                (_righthandsideOksubst)
                                (_righthandsideOlabels_collect)
                                (_righthandsideOlabels_dist)
                                (_righthandsideOlocal)
                                (_righthandsideOmethods_collect)
                                (_righthandsideOmethods_dist)
                                (_righthandsideOmodules)
                                (_righthandsideOoptimizer)
                                (_righthandsideOoptimizerPrelude)
                                (_righthandsideOprekind)
                                (_righthandsideOprelude)
                                (_righthandsideOpresignatures)
                                (_righthandsideOpresignatures_collect)
                                (_righthandsideOrawRequests_collect)
                                (_righthandsideOsignatures)
                                (_righthandsideOstructureTypes_collect)
                                (_righthandsideOtoplevel)
                                (_righthandsideOtypeImps_collect)
                                (_righthandsideOverbosity))
            -- "./ModuleInformation.inc.lag"(line 148, column 8)
            (_righthandsideOtoplevel@_) =
                False
            -- "./Output.inc.lag"(line 266, column 9)
            (_lhsOoutput@_) =
                if _lhsIimportedModule then
                  PP.emptyPP
                else
                  PP.ppDeclaration False
                    (ER.replaceDeclaration
                       _lhsIdependencies
                       FMap.emptyFM
                       _lhsIgenericAbstractions
                       _self
                    )
            -- "./Kind.inc.lag"(line 229, column 9)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- "./Kind.inc.lag"(line 228, column 9)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- "./Kind.inc.lag"(line 672, column 9)
            (_lhsOkind_errors@_) =
                []
            -- "./Kind.inc.lag"(line 671, column 9)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _righthandsideIdepConstraints_collect
            -- use rule
            (_lhsOdepConstraints_defined@_) =
                []
            -- use rule
            (_lhsOexportedDeclarations@_) =
                []
            -- use rule
            (_lhsOoutputi@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                _righthandsideIstaticErrors
            -- self rule
            (_self@_) =
                Declaration_PatternBinding _rangeIself _patternIself _righthandsideIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _righthandsideIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _righthandsideIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _righthandsideIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _righthandsideIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _righthandsideIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _righthandsideIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _righthandsideIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _righthandsideImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _righthandsideIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _righthandsideIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _righthandsideIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _righthandsideItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_patternOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_patternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_patternOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_patternOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_patternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_patternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_patternOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_patternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_patternOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_patternOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_patternOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_patternOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_righthandsideOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_righthandsideObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_righthandsideOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_righthandsideOconstructors_collect@_) =
                _patternIconstructors_collect
            -- copy rule (down)
            (_righthandsideOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_righthandsideOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_righthandsideOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_righthandsideOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_righthandsideOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_righthandsideOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_righthandsideOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_righthandsideOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_righthandsideOgenericAbstractions_collect@_) =
                _patternIgenericAbstractions_collect
            -- copy rule (down)
            (_righthandsideOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_righthandsideOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_righthandsideOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_righthandsideOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_righthandsideOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_righthandsideOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_righthandsideOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_righthandsideOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_righthandsideOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_righthandsideOlabels_collect@_) =
                _patternIlabels_collect
            -- copy rule (down)
            (_righthandsideOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_righthandsideOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_righthandsideOmethods_collect@_) =
                _patternImethods_collect
            -- copy rule (down)
            (_righthandsideOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_righthandsideOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_righthandsideOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_righthandsideOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_righthandsideOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_righthandsideOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_righthandsideOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_righthandsideOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_righthandsideOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_righthandsideOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_righthandsideOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_righthandsideOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_righthandsideOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect
             ,_lhsObimapImps_collect
             ,_lhsOconstructors_collect
             ,_lhsOdepConstraints_collect
             ,_lhsOdepConstraints_defined
             ,_lhsOexportedDeclarations
             ,_lhsOfunImps_collect
             ,_lhsOgenericAbstractions_collect
             ,_lhsOkinames
             ,_lhsOkindIndexedTypes_collect
             ,_lhsOkind_errors
             ,_lhsOkindvar
             ,_lhsOksubst
             ,_lhsOlabels_collect
             ,_lhsOmethods_collect
             ,_lhsOoutput
             ,_lhsOoutputi
             ,_lhsOpresignatures_collect
             ,_lhsOrawRequests_collect
             ,_lhsOself
             ,_lhsOstaticErrors
             ,_lhsOstructureTypes_collect
             ,_lhsOtypeImps_collect
             )
sem_Declaration_Type :: (T_Range) ->
                        (T_SimpleType) ->
                        (T_Type) ->
                        (T_Declaration)
sem_Declaration_Type (range_) (simpletype_) (type_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOdepConstraints_defined :: ([DepConstraint])
            _lhsOexportedDeclarations :: (Declarations)
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: (PP.Doc)
            _lhsOoutputi :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Declaration)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _simpletypeIconstructors_collect :: (FMap Name Names)
            _simpletypeIgenericAbstractions_collect :: (FMap Name Kind)
            _simpletypeIinferkind :: (Kind)
            _simpletypeIkinames :: (KSubst)
            _simpletypeIkind_errors :: ([GHError])
            _simpletypeIkindvar :: (Int)
            _simpletypeIksubst :: (KSubst)
            _simpletypeIlabels_collect :: (FMap Name Names)
            _simpletypeImethods_collect :: (FMap Name Names)
            _simpletypeIname :: (Name)
            _simpletypeIself :: (SimpleType)
            _simpletypeOclassname :: (Maybe Name)
            _simpletypeOconstructors_collect :: (FMap Name Names)
            _simpletypeOconstructors_dist :: (FMap Name Names)
            _simpletypeOcurrentModule :: (Strings)
            _simpletypeOgenericAbstractions :: (FMap Name Kind)
            _simpletypeOgenericAbstractions_collect :: (FMap Name Kind)
            _simpletypeOghc :: (Bool)
            _simpletypeOimportedModule :: (Bool)
            _simpletypeOinstancename :: (Maybe Name)
            _simpletypeOkinames :: (KSubst)
            _simpletypeOkinds :: (KSubst)
            _simpletypeOkindvar :: (Int)
            _simpletypeOksubst :: (KSubst)
            _simpletypeOlabels_collect :: (FMap Name Names)
            _simpletypeOlabels_dist :: (FMap Name Names)
            _simpletypeOlocal :: (Bool)
            _simpletypeOmethods_collect :: (FMap Name Names)
            _simpletypeOmethods_dist :: (FMap Name Names)
            _simpletypeOmodules :: (Set Strings)
            _simpletypeOoptimizer :: (Bool)
            _simpletypeOoptimizerPrelude :: (Declarations)
            _simpletypeOprekind :: (KSubst)
            _simpletypeOprelude :: (Bool)
            _simpletypeOtoplevel :: (Bool)
            _simpletypeOverbosity :: (Int)
            _typeIabstractTypes_collect :: (Set Name)
            _typeIbimapImps_collect :: ([Request_BimapImply])
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIdepConstraints_collect :: ([DepConstraint])
            _typeIfunImps_collect :: ([Request_FunImply])
            _typeIgenericAbstractions_collect :: (FMap Name Kind)
            _typeIinferkind :: (Kind)
            _typeIkinames :: (KSubst)
            _typeIkind_errors :: ([GHError])
            _typeIkindvar :: (Int)
            _typeIksubst :: (KSubst)
            _typeIlabels_collect :: (FMap Name Names)
            _typeImethods_collect :: (FMap Name Names)
            _typeIrawRequests_collect :: ([RawRequest])
            _typeIself :: (Type)
            _typeIstaticErrors :: ([GHError])
            _typeItypeImps_collect :: ([Request_TypeImply])
            _typeOabstractTypes_collect :: (Set Name)
            _typeObimapImps_collect :: ([Request_BimapImply])
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOdependencies :: (FMap Name [(Name,Name)])
            _typeOfunImps_collect :: ([Request_FunImply])
            _typeOgenericAbstractions :: (FMap Name Kind)
            _typeOgenericAbstractions_collect :: (FMap Name Kind)
            _typeOghc :: (Bool)
            _typeOimportedModule :: (Bool)
            _typeOinstancename :: (Maybe Name)
            _typeOkinames :: (KSubst)
            _typeOkinds :: (KSubst)
            _typeOkindvar :: (Int)
            _typeOksubst :: (KSubst)
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOmodules :: (Set Strings)
            _typeOoptimizer :: (Bool)
            _typeOoptimizerPrelude :: (Declarations)
            _typeOprekind :: (KSubst)
            _typeOprelude :: (Bool)
            _typeOrawRequests_collect :: ([RawRequest])
            _typeOtoplevel :: (Bool)
            _typeOtypeImps_collect :: ([Request_TypeImply])
            _typeOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _simpletypeIconstructors_collect,_simpletypeIgenericAbstractions_collect,_simpletypeIinferkind,_simpletypeIkinames,_simpletypeIkind_errors,_simpletypeIkindvar,_simpletypeIksubst,_simpletypeIlabels_collect,_simpletypeImethods_collect,_simpletypeIname,_simpletypeIself) =
                (simpletype_ (_simpletypeOclassname)
                             (_simpletypeOconstructors_collect)
                             (_simpletypeOconstructors_dist)
                             (_simpletypeOcurrentModule)
                             (_simpletypeOgenericAbstractions)
                             (_simpletypeOgenericAbstractions_collect)
                             (_simpletypeOghc)
                             (_simpletypeOimportedModule)
                             (_simpletypeOinstancename)
                             (_simpletypeOkinames)
                             (_simpletypeOkinds)
                             (_simpletypeOkindvar)
                             (_simpletypeOksubst)
                             (_simpletypeOlabels_collect)
                             (_simpletypeOlabels_dist)
                             (_simpletypeOlocal)
                             (_simpletypeOmethods_collect)
                             (_simpletypeOmethods_dist)
                             (_simpletypeOmodules)
                             (_simpletypeOoptimizer)
                             (_simpletypeOoptimizerPrelude)
                             (_simpletypeOprekind)
                             (_simpletypeOprelude)
                             (_simpletypeOtoplevel)
                             (_simpletypeOverbosity))
            ( _typeIabstractTypes_collect,_typeIbimapImps_collect,_typeIconstructors_collect,_typeIdepConstraints_collect,_typeIfunImps_collect,_typeIgenericAbstractions_collect,_typeIinferkind,_typeIkinames,_typeIkind_errors,_typeIkindvar,_typeIksubst,_typeIlabels_collect,_typeImethods_collect,_typeIrawRequests_collect,_typeIself,_typeIstaticErrors,_typeItypeImps_collect) =
                (type_ (_typeOabstractTypes_collect)
                       (_typeObimapImps_collect)
                       (_typeOclassname)
                       (_typeOconstructors_collect)
                       (_typeOconstructors_dist)
                       (_typeOcurrentModule)
                       (_typeOdependencies)
                       (_typeOfunImps_collect)
                       (_typeOgenericAbstractions)
                       (_typeOgenericAbstractions_collect)
                       (_typeOghc)
                       (_typeOimportedModule)
                       (_typeOinstancename)
                       (_typeOkinames)
                       (_typeOkinds)
                       (_typeOkindvar)
                       (_typeOksubst)
                       (_typeOlabels_collect)
                       (_typeOlabels_dist)
                       (_typeOlocal)
                       (_typeOmethods_collect)
                       (_typeOmethods_dist)
                       (_typeOmodules)
                       (_typeOoptimizer)
                       (_typeOoptimizerPrelude)
                       (_typeOprekind)
                       (_typeOprelude)
                       (_typeOrawRequests_collect)
                       (_typeOtoplevel)
                       (_typeOtypeImps_collect)
                       (_typeOverbosity))
            -- "GH.lag"(line 353, column 13)
            ((_strtype@_,_ep@_,_,_)) =
                ST.all _self
            -- "./ModuleInformation.inc.lag"(line 142, column 8)
            (_typeOtoplevel@_) =
                False
            -- "./Output.inc.lag"(line 151, column 9)
            (_lhsOoutput@_) =
                let kc = [mkKindComment
                            _simpletypeIname
                            _kind
                         ]
                    sc = [mkStrTypeComment _simpletypeIname]
                    ec = [mkEPComment _simpletypeIname]
                in  PP.vcat . concat $
                      [ kc
                      , if _lhsIimportedModule then
                          []
                        else
                          [PP.ppDeclarationWithKind False _self _kind _lhsIghc]
                      , sc, PP.ppDeclarationsWithKind False _strtype _kind _lhsIghc
                      , ec, PP.ppDeclarations False _ep
                      ]
            -- "./Exports.inc.lag"(line 493, column 9)
            (_is_exported@_) =
                Set.elementOf
                  _simpletypeIname
                  _lhsIexportedTypes
            -- "./OutputI.inc.lag"(line 129, column 9)
            (_is_implied@_) =
                False
            -- "./OutputI.inc.lag"(line 125, column 9)
            (_lhsOoutputi@_) =
                if _is_implied || _is_exported then
                  [PP.ppDeclarationWithKind True _self _kind True]
                else
                  []
            -- "./Kind.inc.lag"(line 178, column 9)
            (_typeOprekind@_) =
                _simpletypeIkinames
            -- "./Kind.inc.lag"(line 177, column 9)
            (_simpletypeOkinames@_) =
                _lhsIprekind
            -- "./Kind.inc.lag"(line 176, column 9)
            (_lhsOkinames@_) =
                _kinames
            -- "./Kind.inc.lag"(line 175, column 9)
            (_kinames@_) =
                add _lhsIkinames (_simpletypeIname,_kvar)
            -- "./Kind.inc.lag"(line 174, column 9)
            (_kvar@_) =
                mkKindVar' _kindvar
            -- "./Kind.inc.lag"(line 173, column 9)
            (_kindvar@_) =
                _lhsIkindvar + 1
            -- "./Kind.inc.lag"(line 517, column 13)
            ((_ksubst'@_,_kind_errors@_)) =
                unifyWithError
                  (GHError_KindUTsError _rangeIself
                     _simpletypeIname
                     (applyKind _typeIksubst _typeIinferkind)
                  )
                  _typeIinferkind starK _typeIksubst
            -- "./Kind.inc.lag"(line 603, column 9)
            (_lhsOkind_errors@_) =
                _typeIkind_errors ++ _kind_errors ++ _kind_errors'
            -- "./Kind.inc.lag"(line 602, column 9)
            (_lhsOksubst@_) =
                removeKindVars _kvar _ksubstKV
            -- "./Kind.inc.lag"(line 597, column 13)
            ((_ksubstKV@_,_kind_errors'@_)) =
                unifyToplevel _rangeIself
                  _simpletypeIname "type"
                  _kvar _simpletypeIinferkind
                  _ksubst'
            -- "./Kind.inc.lag"(line 742, column 9)
            (_kind@_) =
                fromJust $ find _lhsIkinds _simpletypeIname
            -- "./Request.inc.lag"(line 139, column 9)
            (_lhsOtypeImps_collect@_) =
                Request_TypeImply
                  (Types.conT _simpletypeIname
                  ,[_typeIself]
                  )
                  : _lhsItypeImps_collect
            -- "./Request.inc.lag"(line 519, column 9)
            (_lhsOstructureTypes_collect@_) =
                foldl add
                  _lhsIstructureTypes_collect
                  (extractStructureTypes _strtype)
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _typeIdepConstraints_collect
            -- use rule
            (_lhsOdepConstraints_defined@_) =
                []
            -- use rule
            (_lhsOexportedDeclarations@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                _typeIstaticErrors
            -- self rule
            (_self@_) =
                Declaration_Type _rangeIself _simpletypeIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _typeIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _typeIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _typeIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _typeIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- modified copy rule
            (_lhsOkindvar@_) =
                _typeIkindvar
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _typeIrawRequests_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_simpletypeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_simpletypeOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_simpletypeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_simpletypeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_simpletypeOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_simpletypeOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_simpletypeOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_simpletypeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_simpletypeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_simpletypeOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_simpletypeOkindvar@_) =
                _kindvar
            -- copy rule (down)
            (_simpletypeOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_simpletypeOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_simpletypeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_simpletypeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_simpletypeOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_simpletypeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_simpletypeOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_simpletypeOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_simpletypeOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_simpletypeOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_simpletypeOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_simpletypeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_simpletypeOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_typeOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_typeObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _simpletypeIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_typeOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_typeOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_typeOgenericAbstractions_collect@_) =
                _simpletypeIgenericAbstractions_collect
            -- copy rule (down)
            (_typeOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- modified copy rule
            (_typeOkinames@_) =
                _simpletypeIkinames
            -- copy rule (down)
            (_typeOkinds@_) =
                _lhsIkinds
            -- modified copy rule
            (_typeOkindvar@_) =
                _simpletypeIkindvar
            -- copy rule (chain)
            (_typeOksubst@_) =
                _simpletypeIksubst
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _simpletypeIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _simpletypeImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typeOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_typeOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_typeOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_typeOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_typeOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_typeOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_typeOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect
             ,_lhsObimapImps_collect
             ,_lhsOconstructors_collect
             ,_lhsOdepConstraints_collect
             ,_lhsOdepConstraints_defined
             ,_lhsOexportedDeclarations
             ,_lhsOfunImps_collect
             ,_lhsOgenericAbstractions_collect
             ,_lhsOkinames
             ,_lhsOkindIndexedTypes_collect
             ,_lhsOkind_errors
             ,_lhsOkindvar
             ,_lhsOksubst
             ,_lhsOlabels_collect
             ,_lhsOmethods_collect
             ,_lhsOoutput
             ,_lhsOoutputi
             ,_lhsOpresignatures_collect
             ,_lhsOrawRequests_collect
             ,_lhsOself
             ,_lhsOstaticErrors
             ,_lhsOstructureTypes_collect
             ,_lhsOtypeImps_collect
             )
sem_Declaration_TypeIndexedType :: (T_Range) ->
                                   (T_Name) ->
                                   (T_TypeArgument) ->
                                   (T_Names) ->
                                   (T_Constructor) ->
                                   (T_Names) ->
                                   (T_Declaration)
sem_Declaration_TypeIndexedType (range_) (name_) (typeargument_) (typevariables_) (constructor_) (derivings_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOdepConstraints_defined :: ([DepConstraint])
            _lhsOexportedDeclarations :: (Declarations)
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: (PP.Doc)
            _lhsOoutputi :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Declaration)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _typeargumentIconstructors_collect :: (FMap Name Names)
            _typeargumentIgenericAbstractions_collect :: (FMap Name Kind)
            _typeargumentIkinames :: (KSubst)
            _typeargumentIkind_errors :: ([GHError])
            _typeargumentIkindvar :: (Int)
            _typeargumentIksubst :: (KSubst)
            _typeargumentIlabels_collect :: (FMap Name Names)
            _typeargumentImethods_collect :: (FMap Name Names)
            _typeargumentIself :: (TypeArgument)
            _typeargumentOclassname :: (Maybe Name)
            _typeargumentOconstructors_collect :: (FMap Name Names)
            _typeargumentOconstructors_dist :: (FMap Name Names)
            _typeargumentOcurrentModule :: (Strings)
            _typeargumentOgenericAbstractions :: (FMap Name Kind)
            _typeargumentOgenericAbstractions_collect :: (FMap Name Kind)
            _typeargumentOghc :: (Bool)
            _typeargumentOimportedModule :: (Bool)
            _typeargumentOinstancename :: (Maybe Name)
            _typeargumentOkinames :: (KSubst)
            _typeargumentOkinds :: (KSubst)
            _typeargumentOkindvar :: (Int)
            _typeargumentOksubst :: (KSubst)
            _typeargumentOlabels_collect :: (FMap Name Names)
            _typeargumentOlabels_dist :: (FMap Name Names)
            _typeargumentOlocal :: (Bool)
            _typeargumentOmethods_collect :: (FMap Name Names)
            _typeargumentOmethods_dist :: (FMap Name Names)
            _typeargumentOmodules :: (Set Strings)
            _typeargumentOoptimizer :: (Bool)
            _typeargumentOoptimizerPrelude :: (Declarations)
            _typeargumentOprekind :: (KSubst)
            _typeargumentOprelude :: (Bool)
            _typeargumentOtoplevel :: (Bool)
            _typeargumentOverbosity :: (Int)
            _typevariablesIconstructors_collect :: (FMap Name Names)
            _typevariablesIgenericAbstractions_collect :: (FMap Name Kind)
            _typevariablesIinferkind :: (Kind)
            _typevariablesIkinames :: (KSubst)
            _typevariablesIkind_errors :: ([GHError])
            _typevariablesIkindvar :: (Int)
            _typevariablesIksubst :: (KSubst)
            _typevariablesIlabels_collect :: (FMap Name Names)
            _typevariablesImethods_collect :: (FMap Name Names)
            _typevariablesIself :: (Names)
            _typevariablesOclassname :: (Maybe Name)
            _typevariablesOconstructors_collect :: (FMap Name Names)
            _typevariablesOconstructors_dist :: (FMap Name Names)
            _typevariablesOcurrentModule :: (Strings)
            _typevariablesOgenericAbstractions :: (FMap Name Kind)
            _typevariablesOgenericAbstractions_collect :: (FMap Name Kind)
            _typevariablesOghc :: (Bool)
            _typevariablesOimportedModule :: (Bool)
            _typevariablesOinstancename :: (Maybe Name)
            _typevariablesOkinames :: (KSubst)
            _typevariablesOkinds :: (KSubst)
            _typevariablesOkindvar :: (Int)
            _typevariablesOksubst :: (KSubst)
            _typevariablesOlabels_collect :: (FMap Name Names)
            _typevariablesOlabels_dist :: (FMap Name Names)
            _typevariablesOlocal :: (Bool)
            _typevariablesOmethods_collect :: (FMap Name Names)
            _typevariablesOmethods_dist :: (FMap Name Names)
            _typevariablesOmodules :: (Set Strings)
            _typevariablesOoptimizer :: (Bool)
            _typevariablesOoptimizerPrelude :: (Declarations)
            _typevariablesOprekind :: (KSubst)
            _typevariablesOprelude :: (Bool)
            _typevariablesOtoplevel :: (Bool)
            _typevariablesOverbosity :: (Int)
            _constructorIabstractTypes_collect :: (Set Name)
            _constructorIbimapImps_collect :: ([Request_BimapImply])
            _constructorIconsname :: (Name)
            _constructorIconstructors :: (Names)
            _constructorIconstructors_collect :: (FMap Name Names)
            _constructorIdepConstraints_collect :: ([DepConstraint])
            _constructorIfunImps_collect :: ([Request_FunImply])
            _constructorIgenericAbstractions_collect :: (FMap Name Kind)
            _constructorIkinames :: (KSubst)
            _constructorIkind_errors :: ([GHError])
            _constructorIkindvar :: (Int)
            _constructorIksubst :: (KSubst)
            _constructorIlabels :: (Names)
            _constructorIlabels_collect :: (FMap Name Names)
            _constructorImethods_collect :: (FMap Name Names)
            _constructorIrawRequests_collect :: ([RawRequest])
            _constructorIself :: (Constructor)
            _constructorIstaticErrors :: ([GHError])
            _constructorItypeImps :: ([Type])
            _constructorItypeImps_collect :: ([Request_TypeImply])
            _constructorOabstractTypes_collect :: (Set Name)
            _constructorObimapImps_collect :: ([Request_BimapImply])
            _constructorOclassname :: (Maybe Name)
            _constructorOconstructors_collect :: (FMap Name Names)
            _constructorOconstructors_dist :: (FMap Name Names)
            _constructorOcurrentModule :: (Strings)
            _constructorOdependencies :: (FMap Name [(Name,Name)])
            _constructorOfunImps_collect :: ([Request_FunImply])
            _constructorOgenericAbstractions :: (FMap Name Kind)
            _constructorOgenericAbstractions_collect :: (FMap Name Kind)
            _constructorOghc :: (Bool)
            _constructorOimportedModule :: (Bool)
            _constructorOinstancename :: (Maybe Name)
            _constructorOkinames :: (KSubst)
            _constructorOkinds :: (KSubst)
            _constructorOkindvar :: (Int)
            _constructorOksubst :: (KSubst)
            _constructorOlabels_collect :: (FMap Name Names)
            _constructorOlabels_dist :: (FMap Name Names)
            _constructorOlocal :: (Bool)
            _constructorOmethods_collect :: (FMap Name Names)
            _constructorOmethods_dist :: (FMap Name Names)
            _constructorOmodules :: (Set Strings)
            _constructorOoptimizer :: (Bool)
            _constructorOoptimizerPrelude :: (Declarations)
            _constructorOprekind :: (KSubst)
            _constructorOprelude :: (Bool)
            _constructorOrawRequests_collect :: ([RawRequest])
            _constructorOtoplevel :: (Bool)
            _constructorOtypeImps_collect :: ([Request_TypeImply])
            _constructorOverbosity :: (Int)
            _derivingsIconstructors_collect :: (FMap Name Names)
            _derivingsIgenericAbstractions_collect :: (FMap Name Kind)
            _derivingsIinferkind :: (Kind)
            _derivingsIkinames :: (KSubst)
            _derivingsIkind_errors :: ([GHError])
            _derivingsIkindvar :: (Int)
            _derivingsIksubst :: (KSubst)
            _derivingsIlabels_collect :: (FMap Name Names)
            _derivingsImethods_collect :: (FMap Name Names)
            _derivingsIself :: (Names)
            _derivingsOclassname :: (Maybe Name)
            _derivingsOconstructors_collect :: (FMap Name Names)
            _derivingsOconstructors_dist :: (FMap Name Names)
            _derivingsOcurrentModule :: (Strings)
            _derivingsOgenericAbstractions :: (FMap Name Kind)
            _derivingsOgenericAbstractions_collect :: (FMap Name Kind)
            _derivingsOghc :: (Bool)
            _derivingsOimportedModule :: (Bool)
            _derivingsOinstancename :: (Maybe Name)
            _derivingsOkinames :: (KSubst)
            _derivingsOkinds :: (KSubst)
            _derivingsOkindvar :: (Int)
            _derivingsOksubst :: (KSubst)
            _derivingsOlabels_collect :: (FMap Name Names)
            _derivingsOlabels_dist :: (FMap Name Names)
            _derivingsOlocal :: (Bool)
            _derivingsOmethods_collect :: (FMap Name Names)
            _derivingsOmethods_dist :: (FMap Name Names)
            _derivingsOmodules :: (Set Strings)
            _derivingsOoptimizer :: (Bool)
            _derivingsOoptimizerPrelude :: (Declarations)
            _derivingsOprekind :: (KSubst)
            _derivingsOprelude :: (Bool)
            _derivingsOtoplevel :: (Bool)
            _derivingsOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _typeargumentIconstructors_collect,_typeargumentIgenericAbstractions_collect,_typeargumentIkinames,_typeargumentIkind_errors,_typeargumentIkindvar,_typeargumentIksubst,_typeargumentIlabels_collect,_typeargumentImethods_collect,_typeargumentIself) =
                (typeargument_ (_typeargumentOclassname)
                               (_typeargumentOconstructors_collect)
                               (_typeargumentOconstructors_dist)
                               (_typeargumentOcurrentModule)
                               (_typeargumentOgenericAbstractions)
                               (_typeargumentOgenericAbstractions_collect)
                               (_typeargumentOghc)
                               (_typeargumentOimportedModule)
                               (_typeargumentOinstancename)
                               (_typeargumentOkinames)
                               (_typeargumentOkinds)
                               (_typeargumentOkindvar)
                               (_typeargumentOksubst)
                               (_typeargumentOlabels_collect)
                               (_typeargumentOlabels_dist)
                               (_typeargumentOlocal)
                               (_typeargumentOmethods_collect)
                               (_typeargumentOmethods_dist)
                               (_typeargumentOmodules)
                               (_typeargumentOoptimizer)
                               (_typeargumentOoptimizerPrelude)
                               (_typeargumentOprekind)
                               (_typeargumentOprelude)
                               (_typeargumentOtoplevel)
                               (_typeargumentOverbosity))
            ( _typevariablesIconstructors_collect,_typevariablesIgenericAbstractions_collect,_typevariablesIinferkind,_typevariablesIkinames,_typevariablesIkind_errors,_typevariablesIkindvar,_typevariablesIksubst,_typevariablesIlabels_collect,_typevariablesImethods_collect,_typevariablesIself) =
                (typevariables_ (_typevariablesOclassname)
                                (_typevariablesOconstructors_collect)
                                (_typevariablesOconstructors_dist)
                                (_typevariablesOcurrentModule)
                                (_typevariablesOgenericAbstractions)
                                (_typevariablesOgenericAbstractions_collect)
                                (_typevariablesOghc)
                                (_typevariablesOimportedModule)
                                (_typevariablesOinstancename)
                                (_typevariablesOkinames)
                                (_typevariablesOkinds)
                                (_typevariablesOkindvar)
                                (_typevariablesOksubst)
                                (_typevariablesOlabels_collect)
                                (_typevariablesOlabels_dist)
                                (_typevariablesOlocal)
                                (_typevariablesOmethods_collect)
                                (_typevariablesOmethods_dist)
                                (_typevariablesOmodules)
                                (_typevariablesOoptimizer)
                                (_typevariablesOoptimizerPrelude)
                                (_typevariablesOprekind)
                                (_typevariablesOprelude)
                                (_typevariablesOtoplevel)
                                (_typevariablesOverbosity))
            ( _constructorIabstractTypes_collect
             ,_constructorIbimapImps_collect
             ,_constructorIconsname
             ,_constructorIconstructors
             ,_constructorIconstructors_collect
             ,_constructorIdepConstraints_collect
             ,_constructorIfunImps_collect
             ,_constructorIgenericAbstractions_collect
             ,_constructorIkinames
             ,_constructorIkind_errors
             ,_constructorIkindvar
             ,_constructorIksubst
             ,_constructorIlabels
             ,_constructorIlabels_collect
             ,_constructorImethods_collect
             ,_constructorIrawRequests_collect
             ,_constructorIself
             ,_constructorIstaticErrors
             ,_constructorItypeImps
             ,_constructorItypeImps_collect
             ) =
                (constructor_ (_constructorOabstractTypes_collect)
                              (_constructorObimapImps_collect)
                              (_constructorOclassname)
                              (_constructorOconstructors_collect)
                              (_constructorOconstructors_dist)
                              (_constructorOcurrentModule)
                              (_constructorOdependencies)
                              (_constructorOfunImps_collect)
                              (_constructorOgenericAbstractions)
                              (_constructorOgenericAbstractions_collect)
                              (_constructorOghc)
                              (_constructorOimportedModule)
                              (_constructorOinstancename)
                              (_constructorOkinames)
                              (_constructorOkinds)
                              (_constructorOkindvar)
                              (_constructorOksubst)
                              (_constructorOlabels_collect)
                              (_constructorOlabels_dist)
                              (_constructorOlocal)
                              (_constructorOmethods_collect)
                              (_constructorOmethods_dist)
                              (_constructorOmodules)
                              (_constructorOoptimizer)
                              (_constructorOoptimizerPrelude)
                              (_constructorOprekind)
                              (_constructorOprelude)
                              (_constructorOrawRequests_collect)
                              (_constructorOtoplevel)
                              (_constructorOtypeImps_collect)
                              (_constructorOverbosity))
            ( _derivingsIconstructors_collect,_derivingsIgenericAbstractions_collect,_derivingsIinferkind,_derivingsIkinames,_derivingsIkind_errors,_derivingsIkindvar,_derivingsIksubst,_derivingsIlabels_collect,_derivingsImethods_collect,_derivingsIself) =
                (derivings_ (_derivingsOclassname)
                            (_derivingsOconstructors_collect)
                            (_derivingsOconstructors_dist)
                            (_derivingsOcurrentModule)
                            (_derivingsOgenericAbstractions)
                            (_derivingsOgenericAbstractions_collect)
                            (_derivingsOghc)
                            (_derivingsOimportedModule)
                            (_derivingsOinstancename)
                            (_derivingsOkinames)
                            (_derivingsOkinds)
                            (_derivingsOkindvar)
                            (_derivingsOksubst)
                            (_derivingsOlabels_collect)
                            (_derivingsOlabels_dist)
                            (_derivingsOlocal)
                            (_derivingsOmethods_collect)
                            (_derivingsOmethods_dist)
                            (_derivingsOmodules)
                            (_derivingsOoptimizer)
                            (_derivingsOoptimizerPrelude)
                            (_derivingsOprekind)
                            (_derivingsOprelude)
                            (_derivingsOtoplevel)
                            (_derivingsOverbosity))
            -- "./ModuleInformation.inc.lag"(line 144, column 8)
            (_typevariablesOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 327, column 9)
            (_lhsOconstructors_collect@_) =
                addLBack _lhsIconstructors_collect
                         (_nameIself,_constructorIconstructors)
            -- "./Output.inc.lag"(line 306, column 9)
            (_lhsOoutput@_) =
                PP.vcat $
                  PP.ppComment
                    ("component of type-indexed type "
                      ++ PP.unPretty
                           (PP.ppName _nameIself)
                    )
                    : [PP.ppDeclaration False _component]
            -- "./Exports.inc.lag"(line 555, column 9)
            (_is_exported@_) =
                Set.elementOf _nameIself _lhsIexportedTypes
            -- "./OutputI.inc.lag"(line 266, column 9)
            (_lhsOoutputi@_) =
                if _is_exported then
                  (if _first then
                     [PP.ppInterfaceDeclaration True
                        (InterfaceDeclaration_Consig
                           unknownRange
                           True
                           _nameIself
                           _signature
                        )
                     ]
                   else
                     []
                  ) ++ [PP.ppDeclaration True _self]
                else
                  []
            -- "./Kind.inc.lag"(line 209, column 9)
            (_constructorOprekind@_) =
                _typevariablesIkinames
            -- "./Kind.inc.lag"(line 208, column 9)
            (_typevariablesOkinames@_) =
                _lhsIprekind
            -- "./Kind.inc.lag"(line 207, column 9)
            (_lhsOkinames@_) =
                _kinames
            -- "./Kind.inc.lag"(line 201, column 9)
            (_kinames@_) =
                add _lhsIkinames
                  (componentTITName
                     _nameIself
                     (typeArgumentName _typeargumentIself)
                  ,_kvar
                  )
            -- "./Kind.inc.lag"(line 200, column 9)
            (_kvar@_) =
                mkKindVar' _kindvar
            -- "./Kind.inc.lag"(line 199, column 9)
            (_kindvar@_) =
                _lhsIkindvar + 1
            -- "./Kind.inc.lag"(line 612, column 9)
            (_lhsOkind_errors@_) =
                _constructorIkind_errors ++ _kind_errors
            -- "./Kind.inc.lag"(line 611, column 9)
            (_lhsOksubst@_) =
                removeKindVars _kvar _ksubstKV
            -- "./Kind.inc.lag"(line 606, column 13)
            ((_ksubstKV@_,_kind_errors@_)) =
                unifyToplevel _rangeIself
                  _nameIself "type-indexed type"
                  _kvar _typevariablesIinferkind
                  _constructorIksubst
            -- "./Signature.inc.lag"(line 177, column 9)
            (_signature@_) =
                applyFMM
                  _lhsIsignatures
                  (const $ internalError $
                     "Signature.Declaration.TypeIndexedType: "
                     ++ "no signature"
                  )
                  _nameIself
            -- "./Signature.inc.lag"(line 171, column 9)
            (_lhsOpresignatures_collect@_) =
                modify
                  _presignatures_collect
                  _nameIself
                  (\(types,link) -> (simplifyTypeArgument _typeargumentIself:types,link))
            -- "./Signature.inc.lag"(line 155, column 9)
            (_presignatures_collect@_) =
                if _first then
                  add
                    _lhsIpresignatures_collect
                    (_nameIself,([],Nothing))
                 else
                  _lhsIpresignatures_collect
            -- "./Signature.inc.lag"(line 148, column 9)
            (_first@_) =
                case  find
                        _lhsIpresignatures_collect
                        _nameIself
                of
                  Nothing  ->  True
                  Just _   ->  False
            -- "./Components.inc.lag"(line 154, column 9)
            (_componentName@_) =
                componentTITName
                  _nameIself
                  (Types.typeArgumentName
                     _typeargumentIself
                  )
            -- "./Components.inc.lag"(line 139, column 9)
            (_component@_) =
                Declaration_Newtype
                  _rangeIself
                  []
                  (mkSimpleType
                     _componentName
                     _typevariablesIself
                  )
                  _constructorIself
                  _derivingsIself
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _constructorIdepConstraints_collect
            -- use rule
            (_lhsOdepConstraints_defined@_) =
                []
            -- use rule
            (_lhsOexportedDeclarations@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                _constructorIstaticErrors
            -- self rule
            (_self@_) =
                Declaration_TypeIndexedType _rangeIself _nameIself _typeargumentIself _typevariablesIself _constructorIself _derivingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _constructorIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _constructorIbimapImps_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _constructorIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _derivingsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- modified copy rule
            (_lhsOkindvar@_) =
                _derivingsIkindvar
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _derivingsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _derivingsImethods_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _constructorIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _constructorItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_typeargumentOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeargumentOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_typeargumentOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeargumentOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeargumentOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_typeargumentOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_typeargumentOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_typeargumentOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeargumentOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typeargumentOkinames@_) =
                _kinames
            -- copy rule (down)
            (_typeargumentOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_typeargumentOkindvar@_) =
                _kindvar
            -- copy rule (down)
            (_typeargumentOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_typeargumentOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_typeargumentOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeargumentOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeargumentOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_typeargumentOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typeargumentOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_typeargumentOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_typeargumentOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_typeargumentOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_typeargumentOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_typeargumentOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeargumentOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_typevariablesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typevariablesOconstructors_collect@_) =
                _typeargumentIconstructors_collect
            -- copy rule (down)
            (_typevariablesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typevariablesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typevariablesOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_typevariablesOgenericAbstractions_collect@_) =
                _typeargumentIgenericAbstractions_collect
            -- copy rule (down)
            (_typevariablesOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_typevariablesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typevariablesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typevariablesOkinds@_) =
                _lhsIkinds
            -- modified copy rule
            (_typevariablesOkindvar@_) =
                _typeargumentIkindvar
            -- copy rule (chain)
            (_typevariablesOksubst@_) =
                _typeargumentIksubst
            -- copy rule (chain)
            (_typevariablesOlabels_collect@_) =
                _typeargumentIlabels_collect
            -- copy rule (down)
            (_typevariablesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typevariablesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typevariablesOmethods_collect@_) =
                _typeargumentImethods_collect
            -- copy rule (down)
            (_typevariablesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typevariablesOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_typevariablesOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_typevariablesOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_typevariablesOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_typevariablesOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_typevariablesOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_constructorOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_constructorObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_constructorOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_constructorOconstructors_collect@_) =
                _typevariablesIconstructors_collect
            -- copy rule (down)
            (_constructorOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_constructorOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_constructorOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_constructorOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_constructorOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_constructorOgenericAbstractions_collect@_) =
                _typevariablesIgenericAbstractions_collect
            -- copy rule (down)
            (_constructorOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_constructorOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_constructorOinstancename@_) =
                _lhsIinstancename
            -- modified copy rule
            (_constructorOkinames@_) =
                _typevariablesIkinames
            -- copy rule (down)
            (_constructorOkinds@_) =
                _lhsIkinds
            -- modified copy rule
            (_constructorOkindvar@_) =
                _typevariablesIkindvar
            -- copy rule (chain)
            (_constructorOksubst@_) =
                _typevariablesIksubst
            -- copy rule (chain)
            (_constructorOlabels_collect@_) =
                _typevariablesIlabels_collect
            -- copy rule (down)
            (_constructorOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_constructorOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_constructorOmethods_collect@_) =
                _typevariablesImethods_collect
            -- copy rule (down)
            (_constructorOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_constructorOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_constructorOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_constructorOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_constructorOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_constructorOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_constructorOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_constructorOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_constructorOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_derivingsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_derivingsOconstructors_collect@_) =
                _constructorIconstructors_collect
            -- copy rule (down)
            (_derivingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_derivingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_derivingsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_derivingsOgenericAbstractions_collect@_) =
                _constructorIgenericAbstractions_collect
            -- copy rule (down)
            (_derivingsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_derivingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_derivingsOinstancename@_) =
                _lhsIinstancename
            -- modified copy rule
            (_derivingsOkinames@_) =
                _constructorIkinames
            -- copy rule (down)
            (_derivingsOkinds@_) =
                _lhsIkinds
            -- modified copy rule
            (_derivingsOkindvar@_) =
                _constructorIkindvar
            -- copy rule (chain)
            (_derivingsOksubst@_) =
                _constructorIksubst
            -- copy rule (chain)
            (_derivingsOlabels_collect@_) =
                _constructorIlabels_collect
            -- copy rule (down)
            (_derivingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_derivingsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_derivingsOmethods_collect@_) =
                _constructorImethods_collect
            -- copy rule (down)
            (_derivingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_derivingsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_derivingsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_derivingsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_derivingsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_derivingsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_derivingsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_derivingsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect
             ,_lhsObimapImps_collect
             ,_lhsOconstructors_collect
             ,_lhsOdepConstraints_collect
             ,_lhsOdepConstraints_defined
             ,_lhsOexportedDeclarations
             ,_lhsOfunImps_collect
             ,_lhsOgenericAbstractions_collect
             ,_lhsOkinames
             ,_lhsOkindIndexedTypes_collect
             ,_lhsOkind_errors
             ,_lhsOkindvar
             ,_lhsOksubst
             ,_lhsOlabels_collect
             ,_lhsOmethods_collect
             ,_lhsOoutput
             ,_lhsOoutputi
             ,_lhsOpresignatures_collect
             ,_lhsOrawRequests_collect
             ,_lhsOself
             ,_lhsOstaticErrors
             ,_lhsOstructureTypes_collect
             ,_lhsOtypeImps_collect
             )
sem_Declaration_TypeIndexedValue :: (T_Range) ->
                                    (T_TypeIndexedBindings) ->
                                    (T_Declaration)
sem_Declaration_TypeIndexedValue (range_) (bindings_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOdepConstraints_defined :: ([DepConstraint])
            _lhsOexportedDeclarations :: (Declarations)
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: (PP.Doc)
            _lhsOoutputi :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Declaration)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _bindingsIabstractTypes_collect :: (Set Name)
            _bindingsIbimapImps_collect :: ([Request_BimapImply])
            _bindingsIconstructors_collect :: (FMap Name Names)
            _bindingsIdepConstraints_collect :: ([DepConstraint])
            _bindingsIdepConstraints_defined :: ([DepConstraint])
            _bindingsIfunImps_collect :: ([Request_FunImply])
            _bindingsIgenericAbstractionBindings :: (FunctionBindings)
            _bindingsIgenericAbstractions_collect :: (FMap Name Kind)
            _bindingsIkinames :: (KSubst)
            _bindingsIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _bindingsIkind_errors :: ([GHError])
            _bindingsIkindvar :: (Int)
            _bindingsIksubst :: (KSubst)
            _bindingsIlabels_collect :: (FMap Name Names)
            _bindingsIlinkname :: (Maybe Name)
            _bindingsImethods_collect :: (FMap Name Names)
            _bindingsIname :: (Name)
            _bindingsIpresignatures_collect :: (PreSignatures)
            _bindingsIrawRequests_collect :: ([RawRequest])
            _bindingsIself :: (TypeIndexedBindings)
            _bindingsIstaticErrors :: ([GHError])
            _bindingsIstructureTypes_collect :: (FMap Name LambdaType)
            _bindingsItypeImps_collect :: ([Request_TypeImply])
            _bindingsItypeargument :: (Maybe TypeArgument)
            _bindingsOabstractTypes_collect :: (Set Name)
            _bindingsObimapImps_collect :: ([Request_BimapImply])
            _bindingsOclassname :: (Maybe Name)
            _bindingsOconstructors_collect :: (FMap Name Names)
            _bindingsOconstructors_dist :: (FMap Name Names)
            _bindingsOcurrentModule :: (Strings)
            _bindingsOdependencies :: (FMap Name [(Name,Name)])
            _bindingsOexportedStructures :: (Set Name)
            _bindingsOexportedTypes :: (Set Name)
            _bindingsOexportedValues :: (Set Name)
            _bindingsOfunImps_collect :: ([Request_FunImply])
            _bindingsOgenericAbstractions :: (FMap Name Kind)
            _bindingsOgenericAbstractions_collect :: (FMap Name Kind)
            _bindingsOghc :: (Bool)
            _bindingsOimportedModule :: (Bool)
            _bindingsOinstancename :: (Maybe Name)
            _bindingsOkinames :: (KSubst)
            _bindingsOkindIndexedTypes :: (FMap Name KindIndexedType)
            _bindingsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _bindingsOkinds :: (KSubst)
            _bindingsOkindvar :: (Int)
            _bindingsOksubst :: (KSubst)
            _bindingsOlabels_collect :: (FMap Name Names)
            _bindingsOlabels_dist :: (FMap Name Names)
            _bindingsOlocal :: (Bool)
            _bindingsOmethods_collect :: (FMap Name Names)
            _bindingsOmethods_dist :: (FMap Name Names)
            _bindingsOmodules :: (Set Strings)
            _bindingsOoptimizer :: (Bool)
            _bindingsOoptimizerPrelude :: (Declarations)
            _bindingsOprekind :: (KSubst)
            _bindingsOprelude :: (Bool)
            _bindingsOpresignatures :: (PreSignatures)
            _bindingsOpresignatures_collect :: (PreSignatures)
            _bindingsOrawRequests_collect :: ([RawRequest])
            _bindingsOsignatures :: (Signatures)
            _bindingsOstructureTypes_collect :: (FMap Name LambdaType)
            _bindingsOtoplevel :: (Bool)
            _bindingsOtypeImps_collect :: ([Request_TypeImply])
            _bindingsOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _bindingsIabstractTypes_collect
             ,_bindingsIbimapImps_collect
             ,_bindingsIconstructors_collect
             ,_bindingsIdepConstraints_collect
             ,_bindingsIdepConstraints_defined
             ,_bindingsIfunImps_collect
             ,_bindingsIgenericAbstractionBindings
             ,_bindingsIgenericAbstractions_collect
             ,_bindingsIkinames
             ,_bindingsIkindIndexedTypes_collect
             ,_bindingsIkind_errors
             ,_bindingsIkindvar
             ,_bindingsIksubst
             ,_bindingsIlabels_collect
             ,_bindingsIlinkname
             ,_bindingsImethods_collect
             ,_bindingsIname
             ,_bindingsIpresignatures_collect
             ,_bindingsIrawRequests_collect
             ,_bindingsIself
             ,_bindingsIstaticErrors
             ,_bindingsIstructureTypes_collect
             ,_bindingsItypeImps_collect
             ,_bindingsItypeargument
             ) =
                (bindings_ (_bindingsOabstractTypes_collect)
                           (_bindingsObimapImps_collect)
                           (_bindingsOclassname)
                           (_bindingsOconstructors_collect)
                           (_bindingsOconstructors_dist)
                           (_bindingsOcurrentModule)
                           (_bindingsOdependencies)
                           (_bindingsOexportedStructures)
                           (_bindingsOexportedTypes)
                           (_bindingsOexportedValues)
                           (_bindingsOfunImps_collect)
                           (_bindingsOgenericAbstractions)
                           (_bindingsOgenericAbstractions_collect)
                           (_bindingsOghc)
                           (_bindingsOimportedModule)
                           (_bindingsOinstancename)
                           (_bindingsOkinames)
                           (_bindingsOkindIndexedTypes)
                           (_bindingsOkindIndexedTypes_collect)
                           (_bindingsOkinds)
                           (_bindingsOkindvar)
                           (_bindingsOksubst)
                           (_bindingsOlabels_collect)
                           (_bindingsOlabels_dist)
                           (_bindingsOlocal)
                           (_bindingsOmethods_collect)
                           (_bindingsOmethods_dist)
                           (_bindingsOmodules)
                           (_bindingsOoptimizer)
                           (_bindingsOoptimizerPrelude)
                           (_bindingsOprekind)
                           (_bindingsOprelude)
                           (_bindingsOpresignatures)
                           (_bindingsOpresignatures_collect)
                           (_bindingsOrawRequests_collect)
                           (_bindingsOsignatures)
                           (_bindingsOstructureTypes_collect)
                           (_bindingsOtoplevel)
                           (_bindingsOtypeImps_collect)
                           (_bindingsOverbosity))
            -- "./Output.inc.lag"(line 291, column 9)
            (_lhsOoutput@_) =
                PP.vcat $
                  mkComponentComment
                    _bindingsIname
                    _bindingsItypeargument
                  : PP.ppDeclarations False _component
            -- "./Exports.inc.lag"(line 541, column 9)
            (_is_exported@_) =
                Set.elementOf
                  _bindingsIname
                  _lhsIexportedValues
                  && _isGenericAbstraction
            -- "./OutputI.inc.lag"(line 231, column 9)
            (_is_implied@_) =
                False
            -- "./OutputI.inc.lag"(line 226, column 9)
            (_lhsOoutputi@_) =
                []
            -- "./Kind.inc.lag"(line 196, column 9)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- "./Kind.inc.lag"(line 195, column 9)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- "./Kind.inc.lag"(line 652, column 9)
            (_lhsOkind_errors@_) =
                []
            -- "./Kind.inc.lag"(line 651, column 9)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- "./KindIndexedType.inc.lag"(line 198, column 9)
            (_kindIndexedType@_) =
                applyFMM
                  _lhsIkindIndexedTypes
                  kindIndexedTypeMissingError
                  _bindingsIname
            -- "./Signature.inc.lag"(line 283, column 9)
            (_linkname@_) =
                maybe
                  (illegalDefaultCaseError _bindingsIname)
                  id
                  _bindingsIlinkname
            -- "./Signature.inc.lag"(line 269, column 9)
            (_signature_link@_) =
                applyOrSignatureError _lhsIsignatures _linkname $
                  "Signature.Declaration.TypeIndexedValue: " ++
                  "no signature for link"
            -- "./Signature.inc.lag"(line 264, column 9)
            (_presignature@_) =
                applyOrSignatureError _lhsIpresignatures _bindingsIname $
                  "Signature.Declaration.TypeIndexedValue: " ++
                  "no presignature for "
            -- "./Signature.inc.lag"(line 259, column 9)
            (_signature@_) =
                applyOrSignatureError _lhsIsignatures _bindingsIname $
                  "Signature.Declaration.TypeIndexedValue: " ++
                  "no signature for "
            -- "./Signature.inc.lag"(line 238, column 9)
            (_lhsOpresignatures_collect@_) =
                if not _lhsItoplevel then
                  _presignatures_collect
                 else if _defaultcase then
                  modify
                    _presignatures_collect
                    _bindingsIname
                    (\(types,link) ->
                        case link of
                          Nothing  ->  (types,Just _linkname)
                          _        ->  doubleDefaultCaseError
                                         _bindingsIname
                    )
                 else
                  modify
                    _presignatures_collect
                    _bindingsIname
                    (\(types,link) ->
                        (simplifyTypeArgument _typeargument:types,link)
                    )
            -- "./Signature.inc.lag"(line 220, column 9)
            (_typeargument@_) =
                case _bindingsItypeargument of
                  Nothing  ->
                    internalError $
                      "Signature.TypeIndexedValue.typeargument: " ++
                      "type argument accessed in a default case"
                  Just t   ->  t
            -- "./Signature.inc.lag"(line 218, column 9)
            (_defaultcase@_) =
                isNothing _bindingsItypeargument
            -- "./Signature.inc.lag"(line 202, column 9)
            (_presignatures_collect@_) =
                if _first then
                  add
                    _lhsIpresignatures_collect
                    (_bindingsIname,([],Nothing))
                 else
                  _lhsIpresignatures_collect
            -- "./Signature.inc.lag"(line 195, column 9)
            (_first@_) =
                case  find
                        _lhsIpresignatures_collect
                        _bindingsIname
                of
                      Nothing  ->  True
                      Just _   ->  False
            -- "./Components.inc.lag"(line 98, column 9)
            (_component@_) =
                if _defaultcase then
                  concatMap
                    (\tp ->  makeComponent
                               (kindOfTypeArgument _lhsIkinds tp)
                               _kindIndexedType
                               _bindingsIname
                               tp
                               (extraArguments tp _dependencies_)
                               _lhsIdependencies
                               _bindingsIself
                    )
                    _signature_difference
                 else
                  makeComponent
                    _kindOfTypeArgument
                    _kindIndexedType
                    _bindingsIname
                    _finaltypeargument
                    (extraArguments _finaltypeargument _dependencies_)
                    _lhsIdependencies
                    (ER.replaceTypeIndexedBindings
                       _lhsIdependencies
                       emptyFM
                       _lhsIgenericAbstractions
                       _bindingsIself
                    )
            -- "./Components.inc.lag"(line 93, column 9)
            (_kindOfTypeArgument@_) =
                case find _lhsIgenericAbstractions _bindingsIname of
                  Nothing  ->  kindOfTypeArgument _lhsIkinds _typeargument
                  Just k   ->  arrK k starK
            -- "./Components.inc.lag"(line 86, column 9)
            (_finaltypeargument@_) =
                case _typeargument of
                  TypeArgument_Variable r n
                    | _isGenericAbstraction ->
                        TypeArgument_DependencyStyle r absName MaybeName_Nothing [n]
                  _                           ->  _typeargument
            -- "./Components.inc.lag"(line 75, column 9)
            (_signature_difference@_) =
                _signature_link List.\\ fst _presignature
            -- "./Components.inc.lag"(line 71, column 9)
            (_dependencies_@_) =
                applyFMM  _lhsIdependencies
                          (\n -> [(n,n)])
                          _bindingsIname
            -- "./GenericAbstraction.inc.lag"(line 131, column 9)
            (_genericAbstractionOutput@_) =
                Declaration_FunctionBindings
                      unknownRange
                      _bindingsIgenericAbstractionBindings
            -- "./GenericAbstraction.inc.lag"(line 129, column 9)
            (_isGenericAbstraction@_) =
                isJust (find _lhsIgenericAbstractions _bindingsIname)
            -- "./Request.inc.lag"(line 397, column 9)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- "./Request.inc.lag"(line 389, column 9)
            (_variable@_) =
                case _typeargument of
                  TypeArgument_Variable _ n  ->  n
                  _                          ->
                    internalError $
                      "Request.TypeIndexedValue.variable: " ++
                      "type variable accessed in a constant case"
            -- "./Request.inc.lag"(line 436, column 9)
            (_bindingsOrawRequests_collect@_) =
                case _bindingsItypeargument of
                  Nothing                           ->  []
                  _                                 ->  _lhsIrawRequests_collect
            -- "./Request.inc.lag"(line 417, column 9)
            (_lhsOrawRequests_collect@_) =
                case _bindingsItypeargument of
                  Nothing
                    ->
                       let calls = _bindingsIrawRequests_collect
                       in  [RawRequest (_linkname,typeArgumentToType ta)
                           |ta <- _signature_difference]
                           ++ _lhsIrawRequests_collect
                  Just (TypeArgument_KindStarCase _)
                    -> _bindingsIrawRequests_collect
                  _ -> RawRequest
                         (_bindingsIname,typeArgumentToType _typeargument)
                         : _bindingsIrawRequests_collect
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _bindingsIdepConstraints_collect
            -- use rule
            (_lhsOdepConstraints_defined@_) =
                _bindingsIdepConstraints_defined
            -- use rule
            (_lhsOexportedDeclarations@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                _bindingsIstaticErrors
            -- self rule
            (_self@_) =
                Declaration_TypeIndexedValue _rangeIself _bindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _bindingsIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _bindingsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _bindingsIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _bindingsIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _bindingsIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _bindingsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _bindingsImethods_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _bindingsIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _bindingsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_bindingsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_bindingsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_bindingsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_bindingsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_bindingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_bindingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_bindingsOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_bindingsOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_bindingsOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_bindingsOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_bindingsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_bindingsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_bindingsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_bindingsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_bindingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_bindingsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_bindingsOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_bindingsOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_bindingsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_bindingsOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_bindingsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_bindingsOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_bindingsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_bindingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_bindingsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_bindingsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_bindingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_bindingsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_bindingsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_bindingsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_bindingsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_bindingsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_bindingsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_bindingsOpresignatures_collect@_) =
                _presignatures_collect
            -- copy rule (down)
            (_bindingsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_bindingsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_bindingsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_bindingsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_bindingsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect
             ,_lhsObimapImps_collect
             ,_lhsOconstructors_collect
             ,_lhsOdepConstraints_collect
             ,_lhsOdepConstraints_defined
             ,_lhsOexportedDeclarations
             ,_lhsOfunImps_collect
             ,_lhsOgenericAbstractions_collect
             ,_lhsOkinames
             ,_lhsOkindIndexedTypes_collect
             ,_lhsOkind_errors
             ,_lhsOkindvar
             ,_lhsOksubst
             ,_lhsOlabels_collect
             ,_lhsOmethods_collect
             ,_lhsOoutput
             ,_lhsOoutputi
             ,_lhsOpresignatures_collect
             ,_lhsOrawRequests_collect
             ,_lhsOself
             ,_lhsOstaticErrors
             ,_lhsOstructureTypes_collect
             ,_lhsOtypeImps_collect
             )
sem_Declaration_TypeSignature :: (T_Range) ->
                                 (T_Names) ->
                                 (T_Type) ->
                                 (T_Declaration)
sem_Declaration_TypeSignature (range_) (names_) (type_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOdepConstraints_defined :: ([DepConstraint])
            _lhsOexportedDeclarations :: (Declarations)
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: (PP.Doc)
            _lhsOoutputi :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Declaration)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _namesIconstructors_collect :: (FMap Name Names)
            _namesIgenericAbstractions_collect :: (FMap Name Kind)
            _namesIinferkind :: (Kind)
            _namesIkinames :: (KSubst)
            _namesIkind_errors :: ([GHError])
            _namesIkindvar :: (Int)
            _namesIksubst :: (KSubst)
            _namesIlabels_collect :: (FMap Name Names)
            _namesImethods_collect :: (FMap Name Names)
            _namesIself :: (Names)
            _namesOclassname :: (Maybe Name)
            _namesOconstructors_collect :: (FMap Name Names)
            _namesOconstructors_dist :: (FMap Name Names)
            _namesOcurrentModule :: (Strings)
            _namesOgenericAbstractions :: (FMap Name Kind)
            _namesOgenericAbstractions_collect :: (FMap Name Kind)
            _namesOghc :: (Bool)
            _namesOimportedModule :: (Bool)
            _namesOinstancename :: (Maybe Name)
            _namesOkinames :: (KSubst)
            _namesOkinds :: (KSubst)
            _namesOkindvar :: (Int)
            _namesOksubst :: (KSubst)
            _namesOlabels_collect :: (FMap Name Names)
            _namesOlabels_dist :: (FMap Name Names)
            _namesOlocal :: (Bool)
            _namesOmethods_collect :: (FMap Name Names)
            _namesOmethods_dist :: (FMap Name Names)
            _namesOmodules :: (Set Strings)
            _namesOoptimizer :: (Bool)
            _namesOoptimizerPrelude :: (Declarations)
            _namesOprekind :: (KSubst)
            _namesOprelude :: (Bool)
            _namesOtoplevel :: (Bool)
            _namesOverbosity :: (Int)
            _typeIabstractTypes_collect :: (Set Name)
            _typeIbimapImps_collect :: ([Request_BimapImply])
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIdepConstraints_collect :: ([DepConstraint])
            _typeIfunImps_collect :: ([Request_FunImply])
            _typeIgenericAbstractions_collect :: (FMap Name Kind)
            _typeIinferkind :: (Kind)
            _typeIkinames :: (KSubst)
            _typeIkind_errors :: ([GHError])
            _typeIkindvar :: (Int)
            _typeIksubst :: (KSubst)
            _typeIlabels_collect :: (FMap Name Names)
            _typeImethods_collect :: (FMap Name Names)
            _typeIrawRequests_collect :: ([RawRequest])
            _typeIself :: (Type)
            _typeIstaticErrors :: ([GHError])
            _typeItypeImps_collect :: ([Request_TypeImply])
            _typeOabstractTypes_collect :: (Set Name)
            _typeObimapImps_collect :: ([Request_BimapImply])
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOdependencies :: (FMap Name [(Name,Name)])
            _typeOfunImps_collect :: ([Request_FunImply])
            _typeOgenericAbstractions :: (FMap Name Kind)
            _typeOgenericAbstractions_collect :: (FMap Name Kind)
            _typeOghc :: (Bool)
            _typeOimportedModule :: (Bool)
            _typeOinstancename :: (Maybe Name)
            _typeOkinames :: (KSubst)
            _typeOkinds :: (KSubst)
            _typeOkindvar :: (Int)
            _typeOksubst :: (KSubst)
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOmodules :: (Set Strings)
            _typeOoptimizer :: (Bool)
            _typeOoptimizerPrelude :: (Declarations)
            _typeOprekind :: (KSubst)
            _typeOprelude :: (Bool)
            _typeOrawRequests_collect :: ([RawRequest])
            _typeOtoplevel :: (Bool)
            _typeOtypeImps_collect :: ([Request_TypeImply])
            _typeOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _namesIconstructors_collect,_namesIgenericAbstractions_collect,_namesIinferkind,_namesIkinames,_namesIkind_errors,_namesIkindvar,_namesIksubst,_namesIlabels_collect,_namesImethods_collect,_namesIself) =
                (names_ (_namesOclassname)
                        (_namesOconstructors_collect)
                        (_namesOconstructors_dist)
                        (_namesOcurrentModule)
                        (_namesOgenericAbstractions)
                        (_namesOgenericAbstractions_collect)
                        (_namesOghc)
                        (_namesOimportedModule)
                        (_namesOinstancename)
                        (_namesOkinames)
                        (_namesOkinds)
                        (_namesOkindvar)
                        (_namesOksubst)
                        (_namesOlabels_collect)
                        (_namesOlabels_dist)
                        (_namesOlocal)
                        (_namesOmethods_collect)
                        (_namesOmethods_dist)
                        (_namesOmodules)
                        (_namesOoptimizer)
                        (_namesOoptimizerPrelude)
                        (_namesOprekind)
                        (_namesOprelude)
                        (_namesOtoplevel)
                        (_namesOverbosity))
            ( _typeIabstractTypes_collect,_typeIbimapImps_collect,_typeIconstructors_collect,_typeIdepConstraints_collect,_typeIfunImps_collect,_typeIgenericAbstractions_collect,_typeIinferkind,_typeIkinames,_typeIkind_errors,_typeIkindvar,_typeIksubst,_typeIlabels_collect,_typeImethods_collect,_typeIrawRequests_collect,_typeIself,_typeIstaticErrors,_typeItypeImps_collect) =
                (type_ (_typeOabstractTypes_collect)
                       (_typeObimapImps_collect)
                       (_typeOclassname)
                       (_typeOconstructors_collect)
                       (_typeOconstructors_dist)
                       (_typeOcurrentModule)
                       (_typeOdependencies)
                       (_typeOfunImps_collect)
                       (_typeOgenericAbstractions)
                       (_typeOgenericAbstractions_collect)
                       (_typeOghc)
                       (_typeOimportedModule)
                       (_typeOinstancename)
                       (_typeOkinames)
                       (_typeOkinds)
                       (_typeOkindvar)
                       (_typeOksubst)
                       (_typeOlabels_collect)
                       (_typeOlabels_dist)
                       (_typeOlocal)
                       (_typeOmethods_collect)
                       (_typeOmethods_dist)
                       (_typeOmodules)
                       (_typeOoptimizer)
                       (_typeOoptimizerPrelude)
                       (_typeOprekind)
                       (_typeOprelude)
                       (_typeOrawRequests_collect)
                       (_typeOtoplevel)
                       (_typeOtypeImps_collect)
                       (_typeOverbosity))
            -- "./ModuleInformation.inc.lag"(line 146, column 8)
            (_typeOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 335, column 9)
            (_lhsOmethods_collect@_) =
                case _lhsIclassname of
                  Nothing -> _lhsImethods_collect
                  Just c  -> addLBack _lhsImethods_collect
                                      (c,_namesIself)
            -- "./Output.inc.lag"(line 315, column 9)
            (_lhsOoutput@_) =
                if _lhsIimportedModule then
                  PP.emptyPP
                else
                  PP.ppDeclaration
                    False
                    (Declaration_TypeSignature
                       _rangeIself
                       _namesIself
                       (TIT.handleTypeIndexedTypes
                          _lhsIdependencies
                          _typeIself
                       )
                    )
            -- "./Exports.inc.lag"(line 560, column 9)
            (_names_exported@_) =
                filter
                  (\n -> Set.elementOf n _lhsIexportedValues)
                  _namesIself
            -- "./Exports.inc.lag"(line 559, column 9)
            (_is_exported@_) =
                not . null $ _names_exported
            -- "./OutputI.inc.lag"(line 245, column 9)
            (_lhsOexportedDeclarations@_) =
                if _is_exported then
                  [_self]
                else
                  []
            -- "./OutputI.inc.lag"(line 234, column 9)
            (_lhsOoutputi@_) =
                if _is_exported then
                  [PP.ppDeclaration True $
                     Declaration_TypeSignature
                     _rangeIself
                     _names_exported
                     _typeIself
                  ]
                else
                  []
            -- "./Kind.inc.lag"(line 251, column 9)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- "./Kind.inc.lag"(line 250, column 9)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- "./Kind.inc.lag"(line 680, column 9)
            (_lhsOkind_errors@_) =
                []
            -- "./Kind.inc.lag"(line 679, column 9)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _typeIdepConstraints_collect
            -- use rule
            (_lhsOdepConstraints_defined@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                _typeIstaticErrors
            -- self rule
            (_self@_) =
                Declaration_TypeSignature _rangeIself _namesIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _typeIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _typeIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _typeIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _typeIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _typeIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _typeItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_namesOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_namesOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_namesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_namesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_namesOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_namesOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_namesOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_namesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_namesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_namesOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_namesOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_namesOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_namesOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_namesOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_namesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_namesOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_namesOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_namesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_namesOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_namesOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_namesOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_namesOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_namesOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_namesOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_namesOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_typeOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_typeObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _namesIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_typeOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_typeOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_typeOgenericAbstractions_collect@_) =
                _namesIgenericAbstractions_collect
            -- copy rule (down)
            (_typeOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typeOkinames@_) =
                _namesIkinames
            -- copy rule (down)
            (_typeOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_typeOkindvar@_) =
                _namesIkindvar
            -- copy rule (chain)
            (_typeOksubst@_) =
                _namesIksubst
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _namesIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _namesImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typeOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_typeOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_typeOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_typeOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_typeOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_typeOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_typeOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_typeOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect
             ,_lhsObimapImps_collect
             ,_lhsOconstructors_collect
             ,_lhsOdepConstraints_collect
             ,_lhsOdepConstraints_defined
             ,_lhsOexportedDeclarations
             ,_lhsOfunImps_collect
             ,_lhsOgenericAbstractions_collect
             ,_lhsOkinames
             ,_lhsOkindIndexedTypes_collect
             ,_lhsOkind_errors
             ,_lhsOkindvar
             ,_lhsOksubst
             ,_lhsOlabels_collect
             ,_lhsOmethods_collect
             ,_lhsOoutput
             ,_lhsOoutputi
             ,_lhsOpresignatures_collect
             ,_lhsOrawRequests_collect
             ,_lhsOself
             ,_lhsOstaticErrors
             ,_lhsOstructureTypes_collect
             ,_lhsOtypeImps_collect
             )
-- Declarations ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      exportedStructures   : Set Name
      exportedTypes        : Set Name
      exportedValues       : Set Name
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      output               : [PP.Doc]
      presignatures_collect : PreSignatures
      rawRequests_collect  : [RawRequest]
      structureTypes_collect : FMap Name LambdaType
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      depConstraints_defined : [DepConstraint]
      exportedDeclarations : Declarations
      kind_errors          : [GHError]
      outputi              : [PP.Doc]
      self                 : SELF
      staticErrors         : [GHError]

-}
{-
   local variables for Declarations.Cons:
      self

-}
{-
   local variables for Declarations.Nil:
      self

-}
-- semantic domain
type T_Declarations = (Set Name) ->
                      ([Request_BimapImply]) ->
                      (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Strings) ->
                      (FMap Name [(Name,Name)]) ->
                      (Set Name) ->
                      (Set Name) ->
                      (Set Name) ->
                      ([Request_FunImply]) ->
                      (FMap Name Kind) ->
                      (FMap Name Kind) ->
                      (Bool) ->
                      (Bool) ->
                      (Maybe Name) ->
                      (KSubst) ->
                      (FMap Name KindIndexedType) ->
                      (FMap Name KindIndexedType) ->
                      (KSubst) ->
                      (Int) ->
                      (KSubst) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Set Strings) ->
                      (Bool) ->
                      (Declarations) ->
                      ([PP.Doc]) ->
                      (KSubst) ->
                      (Bool) ->
                      (PreSignatures) ->
                      (PreSignatures) ->
                      ([RawRequest]) ->
                      (Signatures) ->
                      (FMap Name LambdaType) ->
                      (Bool) ->
                      ([Request_TypeImply]) ->
                      (Int) ->
                      ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([DepConstraint]),(Declarations),([Request_FunImply]),(FMap Name Kind),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),([PP.Doc]),([PP.Doc]),(PreSignatures),([RawRequest]),(Declarations),([GHError]),(FMap Name LambdaType),([Request_TypeImply]))
-- cata
sem_Declarations :: (Declarations) ->
                    (T_Declarations)
sem_Declarations (list) =
    (foldr (sem_Declarations_Cons) (sem_Declarations_Nil) ((map sem_Declaration list)))
sem_Declarations_Cons :: (T_Declaration) ->
                         (T_Declarations) ->
                         (T_Declarations)
sem_Declarations_Cons (hd_) (tl_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIoutput
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOdepConstraints_defined :: ([DepConstraint])
            _lhsOexportedDeclarations :: (Declarations)
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: ([PP.Doc])
            _lhsOoutputi :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Declarations)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _hdIabstractTypes_collect :: (Set Name)
            _hdIbimapImps_collect :: ([Request_BimapImply])
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdepConstraints_collect :: ([DepConstraint])
            _hdIdepConstraints_defined :: ([DepConstraint])
            _hdIexportedDeclarations :: (Declarations)
            _hdIfunImps_collect :: ([Request_FunImply])
            _hdIgenericAbstractions_collect :: (FMap Name Kind)
            _hdIkinames :: (KSubst)
            _hdIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _hdIkind_errors :: ([GHError])
            _hdIkindvar :: (Int)
            _hdIksubst :: (KSubst)
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIoutput :: (PP.Doc)
            _hdIoutputi :: ([PP.Doc])
            _hdIpresignatures_collect :: (PreSignatures)
            _hdIrawRequests_collect :: ([RawRequest])
            _hdIself :: (Declaration)
            _hdIstaticErrors :: ([GHError])
            _hdIstructureTypes_collect :: (FMap Name LambdaType)
            _hdItypeImps_collect :: ([Request_TypeImply])
            _hdOabstractTypes_collect :: (Set Name)
            _hdObimapImps_collect :: ([Request_BimapImply])
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies :: (FMap Name [(Name,Name)])
            _hdOexportedStructures :: (Set Name)
            _hdOexportedTypes :: (Set Name)
            _hdOexportedValues :: (Set Name)
            _hdOfunImps_collect :: ([Request_FunImply])
            _hdOgenericAbstractions :: (FMap Name Kind)
            _hdOgenericAbstractions_collect :: (FMap Name Kind)
            _hdOghc :: (Bool)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOkinames :: (KSubst)
            _hdOkindIndexedTypes :: (FMap Name KindIndexedType)
            _hdOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _hdOkinds :: (KSubst)
            _hdOkindvar :: (Int)
            _hdOksubst :: (KSubst)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmodules :: (Set Strings)
            _hdOoptimizer :: (Bool)
            _hdOoptimizerPrelude :: (Declarations)
            _hdOprekind :: (KSubst)
            _hdOprelude :: (Bool)
            _hdOpresignatures :: (PreSignatures)
            _hdOpresignatures_collect :: (PreSignatures)
            _hdOrawRequests_collect :: ([RawRequest])
            _hdOsignatures :: (Signatures)
            _hdOstructureTypes_collect :: (FMap Name LambdaType)
            _hdOtoplevel :: (Bool)
            _hdOtypeImps_collect :: ([Request_TypeImply])
            _hdOverbosity :: (Int)
            _tlIabstractTypes_collect :: (Set Name)
            _tlIbimapImps_collect :: ([Request_BimapImply])
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdepConstraints_collect :: ([DepConstraint])
            _tlIdepConstraints_defined :: ([DepConstraint])
            _tlIexportedDeclarations :: (Declarations)
            _tlIfunImps_collect :: ([Request_FunImply])
            _tlIgenericAbstractions_collect :: (FMap Name Kind)
            _tlIkinames :: (KSubst)
            _tlIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _tlIkind_errors :: ([GHError])
            _tlIkindvar :: (Int)
            _tlIksubst :: (KSubst)
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIoutput :: ([PP.Doc])
            _tlIoutputi :: ([PP.Doc])
            _tlIpresignatures_collect :: (PreSignatures)
            _tlIrawRequests_collect :: ([RawRequest])
            _tlIself :: (Declarations)
            _tlIstaticErrors :: ([GHError])
            _tlIstructureTypes_collect :: (FMap Name LambdaType)
            _tlItypeImps_collect :: ([Request_TypeImply])
            _tlOabstractTypes_collect :: (Set Name)
            _tlObimapImps_collect :: ([Request_BimapImply])
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies :: (FMap Name [(Name,Name)])
            _tlOexportedStructures :: (Set Name)
            _tlOexportedTypes :: (Set Name)
            _tlOexportedValues :: (Set Name)
            _tlOfunImps_collect :: ([Request_FunImply])
            _tlOgenericAbstractions :: (FMap Name Kind)
            _tlOgenericAbstractions_collect :: (FMap Name Kind)
            _tlOghc :: (Bool)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOkinames :: (KSubst)
            _tlOkindIndexedTypes :: (FMap Name KindIndexedType)
            _tlOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _tlOkinds :: (KSubst)
            _tlOkindvar :: (Int)
            _tlOksubst :: (KSubst)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmodules :: (Set Strings)
            _tlOoptimizer :: (Bool)
            _tlOoptimizerPrelude :: (Declarations)
            _tlOoutput :: ([PP.Doc])
            _tlOprekind :: (KSubst)
            _tlOprelude :: (Bool)
            _tlOpresignatures :: (PreSignatures)
            _tlOpresignatures_collect :: (PreSignatures)
            _tlOrawRequests_collect :: ([RawRequest])
            _tlOsignatures :: (Signatures)
            _tlOstructureTypes_collect :: (FMap Name LambdaType)
            _tlOtoplevel :: (Bool)
            _tlOtypeImps_collect :: ([Request_TypeImply])
            _tlOverbosity :: (Int)
            ( _hdIabstractTypes_collect
             ,_hdIbimapImps_collect
             ,_hdIconstructors_collect
             ,_hdIdepConstraints_collect
             ,_hdIdepConstraints_defined
             ,_hdIexportedDeclarations
             ,_hdIfunImps_collect
             ,_hdIgenericAbstractions_collect
             ,_hdIkinames
             ,_hdIkindIndexedTypes_collect
             ,_hdIkind_errors
             ,_hdIkindvar
             ,_hdIksubst
             ,_hdIlabels_collect
             ,_hdImethods_collect
             ,_hdIoutput
             ,_hdIoutputi
             ,_hdIpresignatures_collect
             ,_hdIrawRequests_collect
             ,_hdIself
             ,_hdIstaticErrors
             ,_hdIstructureTypes_collect
             ,_hdItypeImps_collect
             ) =
                (hd_ (_hdOabstractTypes_collect)
                     (_hdObimapImps_collect)
                     (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOdependencies)
                     (_hdOexportedStructures)
                     (_hdOexportedTypes)
                     (_hdOexportedValues)
                     (_hdOfunImps_collect)
                     (_hdOgenericAbstractions)
                     (_hdOgenericAbstractions_collect)
                     (_hdOghc)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOkinames)
                     (_hdOkindIndexedTypes)
                     (_hdOkindIndexedTypes_collect)
                     (_hdOkinds)
                     (_hdOkindvar)
                     (_hdOksubst)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmodules)
                     (_hdOoptimizer)
                     (_hdOoptimizerPrelude)
                     (_hdOprekind)
                     (_hdOprelude)
                     (_hdOpresignatures)
                     (_hdOpresignatures_collect)
                     (_hdOrawRequests_collect)
                     (_hdOsignatures)
                     (_hdOstructureTypes_collect)
                     (_hdOtoplevel)
                     (_hdOtypeImps_collect)
                     (_hdOverbosity))
            ( _tlIabstractTypes_collect
             ,_tlIbimapImps_collect
             ,_tlIconstructors_collect
             ,_tlIdepConstraints_collect
             ,_tlIdepConstraints_defined
             ,_tlIexportedDeclarations
             ,_tlIfunImps_collect
             ,_tlIgenericAbstractions_collect
             ,_tlIkinames
             ,_tlIkindIndexedTypes_collect
             ,_tlIkind_errors
             ,_tlIkindvar
             ,_tlIksubst
             ,_tlIlabels_collect
             ,_tlImethods_collect
             ,_tlIoutput
             ,_tlIoutputi
             ,_tlIpresignatures_collect
             ,_tlIrawRequests_collect
             ,_tlIself
             ,_tlIstaticErrors
             ,_tlIstructureTypes_collect
             ,_tlItypeImps_collect
             ) =
                (tl_ (_tlOabstractTypes_collect)
                     (_tlObimapImps_collect)
                     (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOdependencies)
                     (_tlOexportedStructures)
                     (_tlOexportedTypes)
                     (_tlOexportedValues)
                     (_tlOfunImps_collect)
                     (_tlOgenericAbstractions)
                     (_tlOgenericAbstractions_collect)
                     (_tlOghc)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOkinames)
                     (_tlOkindIndexedTypes)
                     (_tlOkindIndexedTypes_collect)
                     (_tlOkinds)
                     (_tlOkindvar)
                     (_tlOksubst)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmodules)
                     (_tlOoptimizer)
                     (_tlOoptimizerPrelude)
                     (_tlOoutput)
                     (_tlOprekind)
                     (_tlOprelude)
                     (_tlOpresignatures)
                     (_tlOpresignatures_collect)
                     (_tlOrawRequests_collect)
                     (_tlOsignatures)
                     (_tlOstructureTypes_collect)
                     (_tlOtoplevel)
                     (_tlOtypeImps_collect)
                     (_tlOverbosity))
            -- "./Output.inc.lag"(line 147, column 9)
            (_lhsOoutput@_) =
                _tlIoutput
            -- "./Output.inc.lag"(line 146, column 9)
            (_tlOoutput@_) =
                _hdIoutput : _lhsIoutput
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _hdIdepConstraints_collect ++ _tlIdepConstraints_collect
            -- use rule
            (_lhsOdepConstraints_defined@_) =
                _hdIdepConstraints_defined ++ _tlIdepConstraints_defined
            -- use rule
            (_lhsOexportedDeclarations@_) =
                _hdIexportedDeclarations ++ _tlIexportedDeclarations
            -- use rule
            (_lhsOkind_errors@_) =
                _hdIkind_errors ++ _tlIkind_errors
            -- use rule
            (_lhsOoutputi@_) =
                _hdIoutputi ++ _tlIoutputi
            -- use rule
            (_lhsOstaticErrors@_) =
                _hdIstaticErrors ++ _tlIstaticErrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _tlIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _tlIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _tlIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _tlIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _tlIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _tlIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _tlIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _tlIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _tlIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _tlIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _tlIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _tlItypeImps_collect
            -- copy rule (down)
            (_hdOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_hdObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_hdOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_hdOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_hdOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_hdOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_hdOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_hdOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_hdOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_hdOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_hdOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_hdOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_hdOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_hdOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_hdOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_hdOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_hdOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_hdOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_hdOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_hdOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_hdOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_hdOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_hdOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_hdOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_hdOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_tlOabstractTypes_collect@_) =
                _hdIabstractTypes_collect
            -- copy rule (chain)
            (_tlObimapImps_collect@_) =
                _hdIbimapImps_collect
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_tlOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_tlOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_tlOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (chain)
            (_tlOfunImps_collect@_) =
                _hdIfunImps_collect
            -- copy rule (down)
            (_tlOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_tlOgenericAbstractions_collect@_) =
                _hdIgenericAbstractions_collect
            -- copy rule (down)
            (_tlOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOkinames@_) =
                _hdIkinames
            -- copy rule (down)
            (_tlOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (chain)
            (_tlOkindIndexedTypes_collect@_) =
                _hdIkindIndexedTypes_collect
            -- copy rule (down)
            (_tlOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_tlOkindvar@_) =
                _hdIkindvar
            -- copy rule (chain)
            (_tlOksubst@_) =
                _hdIksubst
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_tlOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_tlOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_tlOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_tlOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_tlOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_tlOpresignatures_collect@_) =
                _hdIpresignatures_collect
            -- copy rule (chain)
            (_tlOrawRequests_collect@_) =
                _hdIrawRequests_collect
            -- copy rule (down)
            (_tlOsignatures@_) =
                _lhsIsignatures
            -- copy rule (chain)
            (_tlOstructureTypes_collect@_) =
                _hdIstructureTypes_collect
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_tlOtypeImps_collect@_) =
                _hdItypeImps_collect
            -- copy rule (down)
            (_tlOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect
             ,_lhsObimapImps_collect
             ,_lhsOconstructors_collect
             ,_lhsOdepConstraints_collect
             ,_lhsOdepConstraints_defined
             ,_lhsOexportedDeclarations
             ,_lhsOfunImps_collect
             ,_lhsOgenericAbstractions_collect
             ,_lhsOkinames
             ,_lhsOkindIndexedTypes_collect
             ,_lhsOkind_errors
             ,_lhsOkindvar
             ,_lhsOksubst
             ,_lhsOlabels_collect
             ,_lhsOmethods_collect
             ,_lhsOoutput
             ,_lhsOoutputi
             ,_lhsOpresignatures_collect
             ,_lhsOrawRequests_collect
             ,_lhsOself
             ,_lhsOstaticErrors
             ,_lhsOstructureTypes_collect
             ,_lhsOtypeImps_collect
             )
sem_Declarations_Nil :: (T_Declarations)
sem_Declarations_Nil  =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIoutput
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOdepConstraints_defined :: ([DepConstraint])
            _lhsOexportedDeclarations :: (Declarations)
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: ([PP.Doc])
            _lhsOoutputi :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Declarations)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOdepConstraints_defined@_) =
                []
            -- use rule
            (_lhsOexportedDeclarations@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOoutputi@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOoutput@_) =
                _lhsIoutput
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
        in  ( _lhsOabstractTypes_collect
             ,_lhsObimapImps_collect
             ,_lhsOconstructors_collect
             ,_lhsOdepConstraints_collect
             ,_lhsOdepConstraints_defined
             ,_lhsOexportedDeclarations
             ,_lhsOfunImps_collect
             ,_lhsOgenericAbstractions_collect
             ,_lhsOkinames
             ,_lhsOkindIndexedTypes_collect
             ,_lhsOkind_errors
             ,_lhsOkindvar
             ,_lhsOksubst
             ,_lhsOlabels_collect
             ,_lhsOmethods_collect
             ,_lhsOoutput
             ,_lhsOoutputi
             ,_lhsOpresignatures_collect
             ,_lhsOrawRequests_collect
             ,_lhsOself
             ,_lhsOstaticErrors
             ,_lhsOstructureTypes_collect
             ,_lhsOtypeImps_collect
             )
-- DependencyBinding -------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prelude              : Bool
      toplevel             : Bool
      typelevel            : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      names                : Names
      self                 : SELF

-}
{-
   local variables for DependencyBinding.Rename:
      self

-}
{-
   local variables for DependencyBinding.Simple:
      self

-}
-- semantic domain
type T_DependencyBinding = (Maybe Name) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Strings) ->
                           (FMap Name Kind) ->
                           (FMap Name Kind) ->
                           (Bool) ->
                           (Bool) ->
                           (Maybe Name) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Bool) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Set Strings) ->
                           (Bool) ->
                           (Declarations) ->
                           (Bool) ->
                           (Bool) ->
                           (Bool) ->
                           (Int) ->
                           ( (FMap Name Names),(FMap Name Kind),(FMap Name Names),(FMap Name Names),(Names),(DependencyBinding))
-- cata
sem_DependencyBinding :: (DependencyBinding) ->
                         (T_DependencyBinding)
sem_DependencyBinding ((DependencyBinding_Rename (_range) (_name) (_as))) =
    (sem_DependencyBinding_Rename ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Name (_as))))
sem_DependencyBinding ((DependencyBinding_Simple (_range) (_name))) =
    (sem_DependencyBinding_Simple ((sem_Range (_range))) ((sem_Name (_name))))
sem_DependencyBinding_Rename :: (T_Range) ->
                                (T_Name) ->
                                (T_Name) ->
                                (T_DependencyBinding)
sem_DependencyBinding_Rename (range_) (name_) (as_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsItypelevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOnames :: (Names)
            _lhsOself :: (DependencyBinding)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _asIconstructors_collect :: (FMap Name Names)
            _asIgenericAbstractions_collect :: (FMap Name Kind)
            _asIlabels_collect :: (FMap Name Names)
            _asImethods_collect :: (FMap Name Names)
            _asIself :: (Name)
            _asOclassname :: (Maybe Name)
            _asOconstructors_collect :: (FMap Name Names)
            _asOconstructors_dist :: (FMap Name Names)
            _asOcurrentModule :: (Strings)
            _asOgenericAbstractions :: (FMap Name Kind)
            _asOgenericAbstractions_collect :: (FMap Name Kind)
            _asOghc :: (Bool)
            _asOimportedModule :: (Bool)
            _asOinstancename :: (Maybe Name)
            _asOlabels_collect :: (FMap Name Names)
            _asOlabels_dist :: (FMap Name Names)
            _asOlocal :: (Bool)
            _asOmethods_collect :: (FMap Name Names)
            _asOmethods_dist :: (FMap Name Names)
            _asOmodules :: (Set Strings)
            _asOoptimizer :: (Bool)
            _asOoptimizerPrelude :: (Declarations)
            _asOprelude :: (Bool)
            _asOtoplevel :: (Bool)
            _asOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _asIconstructors_collect,_asIgenericAbstractions_collect,_asIlabels_collect,_asImethods_collect,_asIself) =
                (as_ (_asOclassname) (_asOconstructors_collect) (_asOconstructors_dist) (_asOcurrentModule) (_asOgenericAbstractions) (_asOgenericAbstractions_collect) (_asOghc) (_asOimportedModule) (_asOinstancename) (_asOlabels_collect) (_asOlabels_dist) (_asOlocal) (_asOmethods_collect) (_asOmethods_dist) (_asOmodules) (_asOoptimizer) (_asOoptimizerPrelude) (_asOprelude) (_asOtoplevel) (_asOverbosity))
            -- "./Request.inc.lag"(line 173, column 9)
            (_lhsOnames@_) =
                [_nameIself]
            -- self rule
            (_self@_) =
                DependencyBinding_Rename _rangeIself _nameIself _asIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _asIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _asIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _asIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _asImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_asOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_asOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_asOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_asOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_asOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_asOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_asOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_asOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_asOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_asOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_asOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_asOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_asOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_asOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_asOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_asOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_asOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_asOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_asOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_asOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOnames,_lhsOself)
sem_DependencyBinding_Simple :: (T_Range) ->
                                (T_Name) ->
                                (T_DependencyBinding)
sem_DependencyBinding_Simple (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsItypelevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOnames :: (Names)
            _lhsOself :: (DependencyBinding)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            -- "./Request.inc.lag"(line 171, column 9)
            (_lhsOnames@_) =
                [_nameIself]
            -- self rule
            (_self@_) =
                DependencyBinding_Simple _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOnames,_lhsOself)
-- DependencyBindings ------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prelude              : Bool
      toplevel             : Bool
      typelevel            : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      names                : Names
      self                 : SELF

-}
{-
   local variables for DependencyBindings.Cons:
      self

-}
{-
   local variables for DependencyBindings.Nil:
      self

-}
-- semantic domain
type T_DependencyBindings = (Maybe Name) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Strings) ->
                            (FMap Name Kind) ->
                            (FMap Name Kind) ->
                            (Bool) ->
                            (Bool) ->
                            (Maybe Name) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Bool) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Set Strings) ->
                            (Bool) ->
                            (Declarations) ->
                            (Bool) ->
                            (Bool) ->
                            (Bool) ->
                            (Int) ->
                            ( (FMap Name Names),(FMap Name Kind),(FMap Name Names),(FMap Name Names),(Names),(DependencyBindings))
-- cata
sem_DependencyBindings :: (DependencyBindings) ->
                          (T_DependencyBindings)
sem_DependencyBindings (list) =
    (foldr (sem_DependencyBindings_Cons) (sem_DependencyBindings_Nil) ((map sem_DependencyBinding list)))
sem_DependencyBindings_Cons :: (T_DependencyBinding) ->
                               (T_DependencyBindings) ->
                               (T_DependencyBindings)
sem_DependencyBindings_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsItypelevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOnames :: (Names)
            _lhsOself :: (DependencyBindings)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIgenericAbstractions_collect :: (FMap Name Kind)
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdInames :: (Names)
            _hdIself :: (DependencyBinding)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOgenericAbstractions :: (FMap Name Kind)
            _hdOgenericAbstractions_collect :: (FMap Name Kind)
            _hdOghc :: (Bool)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmodules :: (Set Strings)
            _hdOoptimizer :: (Bool)
            _hdOoptimizerPrelude :: (Declarations)
            _hdOprelude :: (Bool)
            _hdOtoplevel :: (Bool)
            _hdOtypelevel :: (Bool)
            _hdOverbosity :: (Int)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIgenericAbstractions_collect :: (FMap Name Kind)
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlInames :: (Names)
            _tlIself :: (DependencyBindings)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOgenericAbstractions :: (FMap Name Kind)
            _tlOgenericAbstractions_collect :: (FMap Name Kind)
            _tlOghc :: (Bool)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmodules :: (Set Strings)
            _tlOoptimizer :: (Bool)
            _tlOoptimizerPrelude :: (Declarations)
            _tlOprelude :: (Bool)
            _tlOtoplevel :: (Bool)
            _tlOtypelevel :: (Bool)
            _tlOverbosity :: (Int)
            ( _hdIconstructors_collect,_hdIgenericAbstractions_collect,_hdIlabels_collect,_hdImethods_collect,_hdInames,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOgenericAbstractions) (_hdOgenericAbstractions_collect) (_hdOghc) (_hdOimportedModule) (_hdOinstancename) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOmodules) (_hdOoptimizer) (_hdOoptimizerPrelude) (_hdOprelude) (_hdOtoplevel) (_hdOtypelevel) (_hdOverbosity))
            ( _tlIconstructors_collect,_tlIgenericAbstractions_collect,_tlIlabels_collect,_tlImethods_collect,_tlInames,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOgenericAbstractions) (_tlOgenericAbstractions_collect) (_tlOghc) (_tlOimportedModule) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOmodules) (_tlOoptimizer) (_tlOoptimizerPrelude) (_tlOprelude) (_tlOtoplevel) (_tlOtypelevel) (_tlOverbosity))
            -- use rule
            (_lhsOnames@_) =
                _hdInames ++ _tlInames
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _tlIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_hdOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_hdOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_hdOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_hdOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_hdOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_hdOtypelevel@_) =
                _lhsItypelevel
            -- copy rule (down)
            (_hdOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_tlOgenericAbstractions_collect@_) =
                _hdIgenericAbstractions_collect
            -- copy rule (down)
            (_tlOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_tlOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_tlOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_tlOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOtypelevel@_) =
                _lhsItypelevel
            -- copy rule (down)
            (_tlOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOnames,_lhsOself)
sem_DependencyBindings_Nil :: (T_DependencyBindings)
sem_DependencyBindings_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsItypelevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOnames :: (Names)
            _lhsOself :: (DependencyBindings)
            -- use rule
            (_lhsOnames@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOnames,_lhsOself)
-- Export ------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      kind_errors          : [GHError]
      self                 : SELF

-}
{-
   local variables for Export.Module:
      self

-}
{-
   local variables for Export.TypeOrClass:
      self

-}
{-
   local variables for Export.TypeOrClassComplete:
      self

-}
{-
   local variables for Export.Variable:
      self

-}
-- semantic domain
type T_Export = (Maybe Name) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (Strings) ->
                (FMap Name Kind) ->
                (FMap Name Kind) ->
                (Bool) ->
                (Bool) ->
                (Maybe Name) ->
                (KSubst) ->
                (KSubst) ->
                (Int) ->
                (KSubst) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (Bool) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (Set Strings) ->
                (Bool) ->
                (Declarations) ->
                (KSubst) ->
                (Bool) ->
                (Bool) ->
                (Int) ->
                ( (FMap Name Names),(FMap Name Kind),(KSubst),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(Export))
-- cata
sem_Export :: (Export) ->
              (T_Export)
sem_Export ((Export_Module (_range) (_name))) =
    (sem_Export_Module ((sem_Range (_range))) ((sem_ModuleName (_name))))
sem_Export ((Export_TypeOrClass (_range) (_name) (_names))) =
    (sem_Export_TypeOrClass ((sem_Range (_range))) ((sem_Name (_name))) ((sem_MaybeNames (_names))))
sem_Export ((Export_TypeOrClassComplete (_range) (_name))) =
    (sem_Export_TypeOrClassComplete ((sem_Range (_range))) ((sem_Name (_name))))
sem_Export ((Export_Variable (_range) (_name))) =
    (sem_Export_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Export_Module :: (T_Range) ->
                     (T_ModuleName) ->
                     (T_Export)
sem_Export_Module (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Export)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (ModuleName)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- self rule
            (_self@_) =
                Export_Module _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Export_TypeOrClass :: (T_Range) ->
                          (T_Name) ->
                          (T_MaybeNames) ->
                          (T_Export)
sem_Export_TypeOrClass (range_) (name_) (names_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Export)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _namesIconstructors_collect :: (FMap Name Names)
            _namesIgenericAbstractions_collect :: (FMap Name Kind)
            _namesIkinames :: (KSubst)
            _namesIkind_errors :: ([GHError])
            _namesIkindvar :: (Int)
            _namesIksubst :: (KSubst)
            _namesIlabels_collect :: (FMap Name Names)
            _namesImethods_collect :: (FMap Name Names)
            _namesIself :: (MaybeNames)
            _namesOclassname :: (Maybe Name)
            _namesOconstructors_collect :: (FMap Name Names)
            _namesOconstructors_dist :: (FMap Name Names)
            _namesOcurrentModule :: (Strings)
            _namesOgenericAbstractions :: (FMap Name Kind)
            _namesOgenericAbstractions_collect :: (FMap Name Kind)
            _namesOghc :: (Bool)
            _namesOimportedModule :: (Bool)
            _namesOinstancename :: (Maybe Name)
            _namesOkinames :: (KSubst)
            _namesOkinds :: (KSubst)
            _namesOkindvar :: (Int)
            _namesOksubst :: (KSubst)
            _namesOlabels_collect :: (FMap Name Names)
            _namesOlabels_dist :: (FMap Name Names)
            _namesOlocal :: (Bool)
            _namesOmethods_collect :: (FMap Name Names)
            _namesOmethods_dist :: (FMap Name Names)
            _namesOmodules :: (Set Strings)
            _namesOoptimizer :: (Bool)
            _namesOoptimizerPrelude :: (Declarations)
            _namesOprekind :: (KSubst)
            _namesOprelude :: (Bool)
            _namesOtoplevel :: (Bool)
            _namesOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _namesIconstructors_collect,_namesIgenericAbstractions_collect,_namesIkinames,_namesIkind_errors,_namesIkindvar,_namesIksubst,_namesIlabels_collect,_namesImethods_collect,_namesIself) =
                (names_ (_namesOclassname)
                        (_namesOconstructors_collect)
                        (_namesOconstructors_dist)
                        (_namesOcurrentModule)
                        (_namesOgenericAbstractions)
                        (_namesOgenericAbstractions_collect)
                        (_namesOghc)
                        (_namesOimportedModule)
                        (_namesOinstancename)
                        (_namesOkinames)
                        (_namesOkinds)
                        (_namesOkindvar)
                        (_namesOksubst)
                        (_namesOlabels_collect)
                        (_namesOlabels_dist)
                        (_namesOlocal)
                        (_namesOmethods_collect)
                        (_namesOmethods_dist)
                        (_namesOmodules)
                        (_namesOoptimizer)
                        (_namesOoptimizerPrelude)
                        (_namesOprekind)
                        (_namesOprelude)
                        (_namesOtoplevel)
                        (_namesOverbosity))
            -- use rule
            (_lhsOkind_errors@_) =
                _namesIkind_errors
            -- self rule
            (_self@_) =
                Export_TypeOrClass _rangeIself _nameIself _namesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _namesIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _namesIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _namesIkinames
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _namesIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _namesIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _namesIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _namesImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_namesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_namesOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_namesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_namesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_namesOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_namesOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_namesOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_namesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_namesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_namesOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_namesOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_namesOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_namesOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_namesOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_namesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_namesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_namesOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_namesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_namesOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_namesOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_namesOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_namesOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_namesOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_namesOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_namesOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Export_TypeOrClassComplete :: (T_Range) ->
                                  (T_Name) ->
                                  (T_Export)
sem_Export_TypeOrClassComplete (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Export)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- self rule
            (_self@_) =
                Export_TypeOrClassComplete _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Export_Variable :: (T_Range) ->
                       (T_Name) ->
                       (T_Export)
sem_Export_Variable (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Export)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- self rule
            (_self@_) =
                Export_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- Exports -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      kind_errors          : [GHError]
      self                 : SELF

-}
{-
   local variables for Exports.Cons:
      self

-}
{-
   local variables for Exports.Nil:
      self

-}
-- semantic domain
type T_Exports = (Maybe Name) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Strings) ->
                 (FMap Name Kind) ->
                 (FMap Name Kind) ->
                 (Bool) ->
                 (Bool) ->
                 (Maybe Name) ->
                 (KSubst) ->
                 (KSubst) ->
                 (Int) ->
                 (KSubst) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Bool) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Set Strings) ->
                 (Bool) ->
                 (Declarations) ->
                 (KSubst) ->
                 (Bool) ->
                 (Bool) ->
                 (Int) ->
                 ( (FMap Name Names),(FMap Name Kind),(KSubst),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(Exports))
-- cata
sem_Exports :: (Exports) ->
               (T_Exports)
sem_Exports (list) =
    (foldr (sem_Exports_Cons) (sem_Exports_Nil) ((map sem_Export list)))
sem_Exports_Cons :: (T_Export) ->
                    (T_Exports) ->
                    (T_Exports)
sem_Exports_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Exports)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIgenericAbstractions_collect :: (FMap Name Kind)
            _hdIkinames :: (KSubst)
            _hdIkind_errors :: ([GHError])
            _hdIkindvar :: (Int)
            _hdIksubst :: (KSubst)
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIself :: (Export)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOgenericAbstractions :: (FMap Name Kind)
            _hdOgenericAbstractions_collect :: (FMap Name Kind)
            _hdOghc :: (Bool)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOkinames :: (KSubst)
            _hdOkinds :: (KSubst)
            _hdOkindvar :: (Int)
            _hdOksubst :: (KSubst)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmodules :: (Set Strings)
            _hdOoptimizer :: (Bool)
            _hdOoptimizerPrelude :: (Declarations)
            _hdOprekind :: (KSubst)
            _hdOprelude :: (Bool)
            _hdOtoplevel :: (Bool)
            _hdOverbosity :: (Int)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIgenericAbstractions_collect :: (FMap Name Kind)
            _tlIkinames :: (KSubst)
            _tlIkind_errors :: ([GHError])
            _tlIkindvar :: (Int)
            _tlIksubst :: (KSubst)
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIself :: (Exports)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOgenericAbstractions :: (FMap Name Kind)
            _tlOgenericAbstractions_collect :: (FMap Name Kind)
            _tlOghc :: (Bool)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOkinames :: (KSubst)
            _tlOkinds :: (KSubst)
            _tlOkindvar :: (Int)
            _tlOksubst :: (KSubst)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmodules :: (Set Strings)
            _tlOoptimizer :: (Bool)
            _tlOoptimizerPrelude :: (Declarations)
            _tlOprekind :: (KSubst)
            _tlOprelude :: (Bool)
            _tlOtoplevel :: (Bool)
            _tlOverbosity :: (Int)
            ( _hdIconstructors_collect,_hdIgenericAbstractions_collect,_hdIkinames,_hdIkind_errors,_hdIkindvar,_hdIksubst,_hdIlabels_collect,_hdImethods_collect,_hdIself) =
                (hd_ (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOgenericAbstractions)
                     (_hdOgenericAbstractions_collect)
                     (_hdOghc)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOkinames)
                     (_hdOkinds)
                     (_hdOkindvar)
                     (_hdOksubst)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmodules)
                     (_hdOoptimizer)
                     (_hdOoptimizerPrelude)
                     (_hdOprekind)
                     (_hdOprelude)
                     (_hdOtoplevel)
                     (_hdOverbosity))
            ( _tlIconstructors_collect,_tlIgenericAbstractions_collect,_tlIkinames,_tlIkind_errors,_tlIkindvar,_tlIksubst,_tlIlabels_collect,_tlImethods_collect,_tlIself) =
                (tl_ (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOgenericAbstractions)
                     (_tlOgenericAbstractions_collect)
                     (_tlOghc)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOkinames)
                     (_tlOkinds)
                     (_tlOkindvar)
                     (_tlOksubst)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmodules)
                     (_tlOoptimizer)
                     (_tlOoptimizerPrelude)
                     (_tlOprekind)
                     (_tlOprelude)
                     (_tlOtoplevel)
                     (_tlOverbosity))
            -- use rule
            (_lhsOkind_errors@_) =
                _hdIkind_errors ++ _tlIkind_errors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _tlIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _tlIkinames
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _tlIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _tlIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_hdOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_hdOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_hdOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_hdOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_hdOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_hdOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_hdOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_hdOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_hdOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_hdOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_tlOgenericAbstractions_collect@_) =
                _hdIgenericAbstractions_collect
            -- copy rule (down)
            (_tlOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOkinames@_) =
                _hdIkinames
            -- copy rule (down)
            (_tlOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_tlOkindvar@_) =
                _hdIkindvar
            -- copy rule (chain)
            (_tlOksubst@_) =
                _hdIksubst
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_tlOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_tlOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_tlOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_tlOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Exports_Nil :: (T_Exports)
sem_Exports_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Exports)
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- Expression --------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      exportedStructures   : Set Name
      exportedTypes        : Set Name
      exportedValues       : Set Name
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures
      rawRequests_collect  : [RawRequest]
      structureTypes_collect : FMap Name LambdaType
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      kind_errors          : [GHError]
      self                 : SELF
      staticErrors         : [GHError]

-}
{-
   local variables for Expression.As:
      self

-}
{-
   local variables for Expression.Case:
      self

-}
{-
   local variables for Expression.Comprehension:
      self

-}
{-
   local variables for Expression.Constructor:
      self

-}
{-
   local variables for Expression.Do:
      self

-}
{-
   local variables for Expression.Enum:
      self

-}
{-
   local variables for Expression.If:
      self

-}
{-
   local variables for Expression.InfixApplication:
      self

-}
{-
   local variables for Expression.Irrefutable:
      self

-}
{-
   local variables for Expression.Lambda:
      self

-}
{-
   local variables for Expression.Let:
      self

-}
{-
   local variables for Expression.List:
      self

-}
{-
   local variables for Expression.Literal:
      self

-}
{-
   local variables for Expression.Negate:
      self

-}
{-
   local variables for Expression.NormalApplication:
      self

-}
{-
   local variables for Expression.Parenthesized:
      self

-}
{-
   local variables for Expression.RecordConstruction:
      self

-}
{-
   local variables for Expression.RecordUpdate:
      self

-}
{-
   local variables for Expression.Tuple:
      self

-}
{-
   local variables for Expression.TypeApplication:
      self

-}
{-
   local variables for Expression.Typed:
      self

-}
{-
   local variables for Expression.Variable:
      self

-}
{-
   local variables for Expression.Wildcard:
      self

-}
-- semantic domain
type T_Expression = (Set Name) ->
                    ([Request_BimapImply]) ->
                    (Maybe Name) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Strings) ->
                    (FMap Name [(Name,Name)]) ->
                    (Set Name) ->
                    (Set Name) ->
                    (Set Name) ->
                    ([Request_FunImply]) ->
                    (FMap Name Kind) ->
                    (FMap Name Kind) ->
                    (Bool) ->
                    (Bool) ->
                    (Maybe Name) ->
                    (KSubst) ->
                    (FMap Name KindIndexedType) ->
                    (FMap Name KindIndexedType) ->
                    (KSubst) ->
                    (Int) ->
                    (KSubst) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Bool) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Set Strings) ->
                    (Bool) ->
                    (Declarations) ->
                    (KSubst) ->
                    (Bool) ->
                    (PreSignatures) ->
                    (PreSignatures) ->
                    ([RawRequest]) ->
                    (Signatures) ->
                    (FMap Name LambdaType) ->
                    (Bool) ->
                    ([Request_TypeImply]) ->
                    (Int) ->
                    ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(PreSignatures),([RawRequest]),(Expression),([GHError]),(FMap Name LambdaType),([Request_TypeImply]))
-- cata
sem_Expression :: (Expression) ->
                  (T_Expression)
sem_Expression ((Expression_As (_range) (_name) (_expression))) =
    (sem_Expression_As ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Expression (_expression))))
sem_Expression ((Expression_Case (_range) (_expression) (_alternatives))) =
    (sem_Expression_Case ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_Alternatives (_alternatives))))
sem_Expression ((Expression_Comprehension (_range) (_expression) (_qualifiers))) =
    (sem_Expression_Comprehension ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_Qualifiers (_qualifiers))))
sem_Expression ((Expression_Constructor (_range) (_name))) =
    (sem_Expression_Constructor ((sem_Range (_range))) ((sem_Name (_name))))
sem_Expression ((Expression_Do (_range) (_statements))) =
    (sem_Expression_Do ((sem_Range (_range))) ((sem_Statements (_statements))))
sem_Expression ((Expression_Enum (_range) (_from) (_then) (_to))) =
    (sem_Expression_Enum ((sem_Range (_range))) ((sem_Expression (_from))) ((sem_MaybeExpression (_then))) ((sem_MaybeExpression (_to))))
sem_Expression ((Expression_If (_range) (_guardExpression) (_thenExpression) (_elseExpression))) =
    (sem_Expression_If ((sem_Range (_range))) ((sem_Expression (_guardExpression))) ((sem_Expression (_thenExpression))) ((sem_Expression (_elseExpression))))
sem_Expression ((Expression_InfixApplication (_range) (_leftExpression) (_operator) (_rightExpression))) =
    (sem_Expression_InfixApplication ((sem_Range (_range))) ((sem_MaybeExpression (_leftExpression))) ((sem_Expression (_operator))) ((sem_MaybeExpression (_rightExpression))))
sem_Expression ((Expression_Irrefutable (_range) (_expression))) =
    (sem_Expression_Irrefutable ((sem_Range (_range))) ((sem_Expression (_expression))))
sem_Expression ((Expression_Lambda (_range) (_patterns) (_expression))) =
    (sem_Expression_Lambda ((sem_Range (_range))) ((sem_Patterns (_patterns))) ((sem_Expression (_expression))))
sem_Expression ((Expression_Let (_range) (_declarations) (_expression))) =
    (sem_Expression_Let ((sem_Range (_range))) ((sem_Declarations (_declarations))) ((sem_Expression (_expression))))
sem_Expression ((Expression_List (_range) (_expressions))) =
    (sem_Expression_List ((sem_Range (_range))) ((sem_Expressions (_expressions))))
sem_Expression ((Expression_Literal (_range) (_literal))) =
    (sem_Expression_Literal ((sem_Range (_range))) ((sem_Literal (_literal))))
sem_Expression ((Expression_Negate (_range) (_expression))) =
    (sem_Expression_Negate ((sem_Range (_range))) ((sem_Expression (_expression))))
sem_Expression ((Expression_NormalApplication (_range) (_function) (_arguments))) =
    (sem_Expression_NormalApplication ((sem_Range (_range))) ((sem_Expression (_function))) ((sem_Expressions (_arguments))))
sem_Expression ((Expression_Parenthesized (_range) (_expression))) =
    (sem_Expression_Parenthesized ((sem_Range (_range))) ((sem_Expression (_expression))))
sem_Expression ((Expression_RecordConstruction (_range) (_name) (_recordExpressionBindings))) =
    (sem_Expression_RecordConstruction ((sem_Range (_range))) ((sem_Name (_name))) ((sem_RecordExpressionBindings (_recordExpressionBindings))))
sem_Expression ((Expression_RecordUpdate (_range) (_expression) (_recordExpressionBindings))) =
    (sem_Expression_RecordUpdate ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_RecordExpressionBindings (_recordExpressionBindings))))
sem_Expression ((Expression_Tuple (_range) (_expressions))) =
    (sem_Expression_Tuple ((sem_Range (_range))) ((sem_Expressions (_expressions))))
sem_Expression ((Expression_TypeApplication (_range) (_name) (_type))) =
    (sem_Expression_TypeApplication ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Type (_type))))
sem_Expression ((Expression_Typed (_range) (_expression) (_type))) =
    (sem_Expression_Typed ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_Type (_type))))
sem_Expression ((Expression_Variable (_range) (_name))) =
    (sem_Expression_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Expression ((Expression_Wildcard (_range))) =
    (sem_Expression_Wildcard ((sem_Range (_range))))
sem_Expression_As :: (T_Range) ->
                     (T_Name) ->
                     (T_Expression) ->
                     (T_Expression)
sem_Expression_As (range_) (name_) (expression_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Expression)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _expressionIabstractTypes_collect :: (Set Name)
            _expressionIbimapImps_collect :: ([Request_BimapImply])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdepConstraints_collect :: ([DepConstraint])
            _expressionIfunImps_collect :: ([Request_FunImply])
            _expressionIgenericAbstractions_collect :: (FMap Name Kind)
            _expressionIkinames :: (KSubst)
            _expressionIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionIkind_errors :: ([GHError])
            _expressionIkindvar :: (Int)
            _expressionIksubst :: (KSubst)
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIrawRequests_collect :: ([RawRequest])
            _expressionIself :: (Expression)
            _expressionIstaticErrors :: ([GHError])
            _expressionIstructureTypes_collect :: (FMap Name LambdaType)
            _expressionItypeImps_collect :: ([Request_TypeImply])
            _expressionOabstractTypes_collect :: (Set Name)
            _expressionObimapImps_collect :: ([Request_BimapImply])
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies :: (FMap Name [(Name,Name)])
            _expressionOexportedStructures :: (Set Name)
            _expressionOexportedTypes :: (Set Name)
            _expressionOexportedValues :: (Set Name)
            _expressionOfunImps_collect :: ([Request_FunImply])
            _expressionOgenericAbstractions :: (FMap Name Kind)
            _expressionOgenericAbstractions_collect :: (FMap Name Kind)
            _expressionOghc :: (Bool)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOkinames :: (KSubst)
            _expressionOkindIndexedTypes :: (FMap Name KindIndexedType)
            _expressionOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionOkinds :: (KSubst)
            _expressionOkindvar :: (Int)
            _expressionOksubst :: (KSubst)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmodules :: (Set Strings)
            _expressionOoptimizer :: (Bool)
            _expressionOoptimizerPrelude :: (Declarations)
            _expressionOprekind :: (KSubst)
            _expressionOprelude :: (Bool)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOrawRequests_collect :: ([RawRequest])
            _expressionOsignatures :: (Signatures)
            _expressionOstructureTypes_collect :: (FMap Name LambdaType)
            _expressionOtoplevel :: (Bool)
            _expressionOtypeImps_collect :: ([Request_TypeImply])
            _expressionOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _expressionIabstractTypes_collect
             ,_expressionIbimapImps_collect
             ,_expressionIconstructors_collect
             ,_expressionIdepConstraints_collect
             ,_expressionIfunImps_collect
             ,_expressionIgenericAbstractions_collect
             ,_expressionIkinames
             ,_expressionIkindIndexedTypes_collect
             ,_expressionIkind_errors
             ,_expressionIkindvar
             ,_expressionIksubst
             ,_expressionIlabels_collect
             ,_expressionImethods_collect
             ,_expressionIpresignatures_collect
             ,_expressionIrawRequests_collect
             ,_expressionIself
             ,_expressionIstaticErrors
             ,_expressionIstructureTypes_collect
             ,_expressionItypeImps_collect
             ) =
                (expression_ (_expressionOabstractTypes_collect)
                             (_expressionObimapImps_collect)
                             (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies)
                             (_expressionOexportedStructures)
                             (_expressionOexportedTypes)
                             (_expressionOexportedValues)
                             (_expressionOfunImps_collect)
                             (_expressionOgenericAbstractions)
                             (_expressionOgenericAbstractions_collect)
                             (_expressionOghc)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOkinames)
                             (_expressionOkindIndexedTypes)
                             (_expressionOkindIndexedTypes_collect)
                             (_expressionOkinds)
                             (_expressionOkindvar)
                             (_expressionOksubst)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmodules)
                             (_expressionOoptimizer)
                             (_expressionOoptimizerPrelude)
                             (_expressionOprekind)
                             (_expressionOprelude)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOrawRequests_collect)
                             (_expressionOsignatures)
                             (_expressionOstructureTypes_collect)
                             (_expressionOtoplevel)
                             (_expressionOtypeImps_collect)
                             (_expressionOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _expressionIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _expressionIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _expressionIstaticErrors
            -- self rule
            (_self@_) =
                Expression_As _rangeIself _nameIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _expressionIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _expressionIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _expressionIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _expressionIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _expressionIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _expressionIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _expressionIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _expressionIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _expressionIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _expressionIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _expressionItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_expressionOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_expressionObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_expressionOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_expressionOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_expressionOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_expressionOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_expressionOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_expressionOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_expressionOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_expressionOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_expressionOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_expressionOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_expressionOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_expressionOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_expressionOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_expressionOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_expressionOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_expressionOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_expressionOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_expressionOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_expressionOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_expressionOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Expression_Case :: (T_Range) ->
                       (T_Expression) ->
                       (T_Alternatives) ->
                       (T_Expression)
sem_Expression_Case (range_) (expression_) (alternatives_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Expression)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionIabstractTypes_collect :: (Set Name)
            _expressionIbimapImps_collect :: ([Request_BimapImply])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdepConstraints_collect :: ([DepConstraint])
            _expressionIfunImps_collect :: ([Request_FunImply])
            _expressionIgenericAbstractions_collect :: (FMap Name Kind)
            _expressionIkinames :: (KSubst)
            _expressionIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionIkind_errors :: ([GHError])
            _expressionIkindvar :: (Int)
            _expressionIksubst :: (KSubst)
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIrawRequests_collect :: ([RawRequest])
            _expressionIself :: (Expression)
            _expressionIstaticErrors :: ([GHError])
            _expressionIstructureTypes_collect :: (FMap Name LambdaType)
            _expressionItypeImps_collect :: ([Request_TypeImply])
            _expressionOabstractTypes_collect :: (Set Name)
            _expressionObimapImps_collect :: ([Request_BimapImply])
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies :: (FMap Name [(Name,Name)])
            _expressionOexportedStructures :: (Set Name)
            _expressionOexportedTypes :: (Set Name)
            _expressionOexportedValues :: (Set Name)
            _expressionOfunImps_collect :: ([Request_FunImply])
            _expressionOgenericAbstractions :: (FMap Name Kind)
            _expressionOgenericAbstractions_collect :: (FMap Name Kind)
            _expressionOghc :: (Bool)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOkinames :: (KSubst)
            _expressionOkindIndexedTypes :: (FMap Name KindIndexedType)
            _expressionOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionOkinds :: (KSubst)
            _expressionOkindvar :: (Int)
            _expressionOksubst :: (KSubst)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmodules :: (Set Strings)
            _expressionOoptimizer :: (Bool)
            _expressionOoptimizerPrelude :: (Declarations)
            _expressionOprekind :: (KSubst)
            _expressionOprelude :: (Bool)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOrawRequests_collect :: ([RawRequest])
            _expressionOsignatures :: (Signatures)
            _expressionOstructureTypes_collect :: (FMap Name LambdaType)
            _expressionOtoplevel :: (Bool)
            _expressionOtypeImps_collect :: ([Request_TypeImply])
            _expressionOverbosity :: (Int)
            _alternativesIabstractTypes_collect :: (Set Name)
            _alternativesIbimapImps_collect :: ([Request_BimapImply])
            _alternativesIconstructors_collect :: (FMap Name Names)
            _alternativesIdepConstraints_collect :: ([DepConstraint])
            _alternativesIfunImps_collect :: ([Request_FunImply])
            _alternativesIgenericAbstractions_collect :: (FMap Name Kind)
            _alternativesIkinames :: (KSubst)
            _alternativesIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _alternativesIkind_errors :: ([GHError])
            _alternativesIkindvar :: (Int)
            _alternativesIksubst :: (KSubst)
            _alternativesIlabels_collect :: (FMap Name Names)
            _alternativesImethods_collect :: (FMap Name Names)
            _alternativesIpresignatures_collect :: (PreSignatures)
            _alternativesIrawRequests_collect :: ([RawRequest])
            _alternativesIself :: (Alternatives)
            _alternativesIstaticErrors :: ([GHError])
            _alternativesIstructureTypes_collect :: (FMap Name LambdaType)
            _alternativesItypeImps_collect :: ([Request_TypeImply])
            _alternativesOabstractTypes_collect :: (Set Name)
            _alternativesObimapImps_collect :: ([Request_BimapImply])
            _alternativesOclassname :: (Maybe Name)
            _alternativesOconstructors_collect :: (FMap Name Names)
            _alternativesOconstructors_dist :: (FMap Name Names)
            _alternativesOcurrentModule :: (Strings)
            _alternativesOdependencies :: (FMap Name [(Name,Name)])
            _alternativesOexportedStructures :: (Set Name)
            _alternativesOexportedTypes :: (Set Name)
            _alternativesOexportedValues :: (Set Name)
            _alternativesOfunImps_collect :: ([Request_FunImply])
            _alternativesOgenericAbstractions :: (FMap Name Kind)
            _alternativesOgenericAbstractions_collect :: (FMap Name Kind)
            _alternativesOghc :: (Bool)
            _alternativesOimportedModule :: (Bool)
            _alternativesOinstancename :: (Maybe Name)
            _alternativesOkinames :: (KSubst)
            _alternativesOkindIndexedTypes :: (FMap Name KindIndexedType)
            _alternativesOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _alternativesOkinds :: (KSubst)
            _alternativesOkindvar :: (Int)
            _alternativesOksubst :: (KSubst)
            _alternativesOlabels_collect :: (FMap Name Names)
            _alternativesOlabels_dist :: (FMap Name Names)
            _alternativesOlocal :: (Bool)
            _alternativesOmethods_collect :: (FMap Name Names)
            _alternativesOmethods_dist :: (FMap Name Names)
            _alternativesOmodules :: (Set Strings)
            _alternativesOoptimizer :: (Bool)
            _alternativesOoptimizerPrelude :: (Declarations)
            _alternativesOprekind :: (KSubst)
            _alternativesOprelude :: (Bool)
            _alternativesOpresignatures :: (PreSignatures)
            _alternativesOpresignatures_collect :: (PreSignatures)
            _alternativesOrawRequests_collect :: ([RawRequest])
            _alternativesOsignatures :: (Signatures)
            _alternativesOstructureTypes_collect :: (FMap Name LambdaType)
            _alternativesOtoplevel :: (Bool)
            _alternativesOtypeImps_collect :: ([Request_TypeImply])
            _alternativesOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionIabstractTypes_collect
             ,_expressionIbimapImps_collect
             ,_expressionIconstructors_collect
             ,_expressionIdepConstraints_collect
             ,_expressionIfunImps_collect
             ,_expressionIgenericAbstractions_collect
             ,_expressionIkinames
             ,_expressionIkindIndexedTypes_collect
             ,_expressionIkind_errors
             ,_expressionIkindvar
             ,_expressionIksubst
             ,_expressionIlabels_collect
             ,_expressionImethods_collect
             ,_expressionIpresignatures_collect
             ,_expressionIrawRequests_collect
             ,_expressionIself
             ,_expressionIstaticErrors
             ,_expressionIstructureTypes_collect
             ,_expressionItypeImps_collect
             ) =
                (expression_ (_expressionOabstractTypes_collect)
                             (_expressionObimapImps_collect)
                             (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies)
                             (_expressionOexportedStructures)
                             (_expressionOexportedTypes)
                             (_expressionOexportedValues)
                             (_expressionOfunImps_collect)
                             (_expressionOgenericAbstractions)
                             (_expressionOgenericAbstractions_collect)
                             (_expressionOghc)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOkinames)
                             (_expressionOkindIndexedTypes)
                             (_expressionOkindIndexedTypes_collect)
                             (_expressionOkinds)
                             (_expressionOkindvar)
                             (_expressionOksubst)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmodules)
                             (_expressionOoptimizer)
                             (_expressionOoptimizerPrelude)
                             (_expressionOprekind)
                             (_expressionOprelude)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOrawRequests_collect)
                             (_expressionOsignatures)
                             (_expressionOstructureTypes_collect)
                             (_expressionOtoplevel)
                             (_expressionOtypeImps_collect)
                             (_expressionOverbosity))
            ( _alternativesIabstractTypes_collect
             ,_alternativesIbimapImps_collect
             ,_alternativesIconstructors_collect
             ,_alternativesIdepConstraints_collect
             ,_alternativesIfunImps_collect
             ,_alternativesIgenericAbstractions_collect
             ,_alternativesIkinames
             ,_alternativesIkindIndexedTypes_collect
             ,_alternativesIkind_errors
             ,_alternativesIkindvar
             ,_alternativesIksubst
             ,_alternativesIlabels_collect
             ,_alternativesImethods_collect
             ,_alternativesIpresignatures_collect
             ,_alternativesIrawRequests_collect
             ,_alternativesIself
             ,_alternativesIstaticErrors
             ,_alternativesIstructureTypes_collect
             ,_alternativesItypeImps_collect
             ) =
                (alternatives_ (_alternativesOabstractTypes_collect)
                               (_alternativesObimapImps_collect)
                               (_alternativesOclassname)
                               (_alternativesOconstructors_collect)
                               (_alternativesOconstructors_dist)
                               (_alternativesOcurrentModule)
                               (_alternativesOdependencies)
                               (_alternativesOexportedStructures)
                               (_alternativesOexportedTypes)
                               (_alternativesOexportedValues)
                               (_alternativesOfunImps_collect)
                               (_alternativesOgenericAbstractions)
                               (_alternativesOgenericAbstractions_collect)
                               (_alternativesOghc)
                               (_alternativesOimportedModule)
                               (_alternativesOinstancename)
                               (_alternativesOkinames)
                               (_alternativesOkindIndexedTypes)
                               (_alternativesOkindIndexedTypes_collect)
                               (_alternativesOkinds)
                               (_alternativesOkindvar)
                               (_alternativesOksubst)
                               (_alternativesOlabels_collect)
                               (_alternativesOlabels_dist)
                               (_alternativesOlocal)
                               (_alternativesOmethods_collect)
                               (_alternativesOmethods_dist)
                               (_alternativesOmodules)
                               (_alternativesOoptimizer)
                               (_alternativesOoptimizerPrelude)
                               (_alternativesOprekind)
                               (_alternativesOprelude)
                               (_alternativesOpresignatures)
                               (_alternativesOpresignatures_collect)
                               (_alternativesOrawRequests_collect)
                               (_alternativesOsignatures)
                               (_alternativesOstructureTypes_collect)
                               (_alternativesOtoplevel)
                               (_alternativesOtypeImps_collect)
                               (_alternativesOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _expressionIdepConstraints_collect ++ _alternativesIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _expressionIkind_errors ++ _alternativesIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _expressionIstaticErrors ++ _alternativesIstaticErrors
            -- self rule
            (_self@_) =
                Expression_Case _rangeIself _expressionIself _alternativesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _alternativesIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _alternativesIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _alternativesIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _alternativesIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _alternativesIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _alternativesIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _alternativesIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _alternativesIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _alternativesIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _alternativesIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _alternativesImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _alternativesIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _alternativesIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _alternativesIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _alternativesItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_expressionObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_expressionOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_expressionOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_expressionOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_expressionOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_expressionOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_expressionOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_expressionOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_expressionOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_expressionOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_expressionOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_expressionOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_expressionOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_expressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_expressionOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_expressionOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_expressionOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_expressionOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_expressionOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_alternativesOabstractTypes_collect@_) =
                _expressionIabstractTypes_collect
            -- copy rule (chain)
            (_alternativesObimapImps_collect@_) =
                _expressionIbimapImps_collect
            -- copy rule (down)
            (_alternativesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_alternativesOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (down)
            (_alternativesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_alternativesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_alternativesOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_alternativesOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_alternativesOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_alternativesOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (chain)
            (_alternativesOfunImps_collect@_) =
                _expressionIfunImps_collect
            -- copy rule (down)
            (_alternativesOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_alternativesOgenericAbstractions_collect@_) =
                _expressionIgenericAbstractions_collect
            -- copy rule (down)
            (_alternativesOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_alternativesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_alternativesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_alternativesOkinames@_) =
                _expressionIkinames
            -- copy rule (down)
            (_alternativesOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (chain)
            (_alternativesOkindIndexedTypes_collect@_) =
                _expressionIkindIndexedTypes_collect
            -- copy rule (down)
            (_alternativesOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_alternativesOkindvar@_) =
                _expressionIkindvar
            -- copy rule (chain)
            (_alternativesOksubst@_) =
                _expressionIksubst
            -- copy rule (chain)
            (_alternativesOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (down)
            (_alternativesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_alternativesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_alternativesOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (down)
            (_alternativesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_alternativesOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_alternativesOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_alternativesOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_alternativesOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_alternativesOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_alternativesOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_alternativesOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (chain)
            (_alternativesOrawRequests_collect@_) =
                _expressionIrawRequests_collect
            -- copy rule (down)
            (_alternativesOsignatures@_) =
                _lhsIsignatures
            -- copy rule (chain)
            (_alternativesOstructureTypes_collect@_) =
                _expressionIstructureTypes_collect
            -- copy rule (down)
            (_alternativesOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_alternativesOtypeImps_collect@_) =
                _expressionItypeImps_collect
            -- copy rule (down)
            (_alternativesOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Expression_Comprehension :: (T_Range) ->
                                (T_Expression) ->
                                (T_Qualifiers) ->
                                (T_Expression)
sem_Expression_Comprehension (range_) (expression_) (qualifiers_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Expression)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionIabstractTypes_collect :: (Set Name)
            _expressionIbimapImps_collect :: ([Request_BimapImply])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdepConstraints_collect :: ([DepConstraint])
            _expressionIfunImps_collect :: ([Request_FunImply])
            _expressionIgenericAbstractions_collect :: (FMap Name Kind)
            _expressionIkinames :: (KSubst)
            _expressionIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionIkind_errors :: ([GHError])
            _expressionIkindvar :: (Int)
            _expressionIksubst :: (KSubst)
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIrawRequests_collect :: ([RawRequest])
            _expressionIself :: (Expression)
            _expressionIstaticErrors :: ([GHError])
            _expressionIstructureTypes_collect :: (FMap Name LambdaType)
            _expressionItypeImps_collect :: ([Request_TypeImply])
            _expressionOabstractTypes_collect :: (Set Name)
            _expressionObimapImps_collect :: ([Request_BimapImply])
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies :: (FMap Name [(Name,Name)])
            _expressionOexportedStructures :: (Set Name)
            _expressionOexportedTypes :: (Set Name)
            _expressionOexportedValues :: (Set Name)
            _expressionOfunImps_collect :: ([Request_FunImply])
            _expressionOgenericAbstractions :: (FMap Name Kind)
            _expressionOgenericAbstractions_collect :: (FMap Name Kind)
            _expressionOghc :: (Bool)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOkinames :: (KSubst)
            _expressionOkindIndexedTypes :: (FMap Name KindIndexedType)
            _expressionOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionOkinds :: (KSubst)
            _expressionOkindvar :: (Int)
            _expressionOksubst :: (KSubst)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmodules :: (Set Strings)
            _expressionOoptimizer :: (Bool)
            _expressionOoptimizerPrelude :: (Declarations)
            _expressionOprekind :: (KSubst)
            _expressionOprelude :: (Bool)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOrawRequests_collect :: ([RawRequest])
            _expressionOsignatures :: (Signatures)
            _expressionOstructureTypes_collect :: (FMap Name LambdaType)
            _expressionOtoplevel :: (Bool)
            _expressionOtypeImps_collect :: ([Request_TypeImply])
            _expressionOverbosity :: (Int)
            _qualifiersIabstractTypes_collect :: (Set Name)
            _qualifiersIbimapImps_collect :: ([Request_BimapImply])
            _qualifiersIconstructors_collect :: (FMap Name Names)
            _qualifiersIdepConstraints_collect :: ([DepConstraint])
            _qualifiersIfunImps_collect :: ([Request_FunImply])
            _qualifiersIgenericAbstractions_collect :: (FMap Name Kind)
            _qualifiersIkinames :: (KSubst)
            _qualifiersIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _qualifiersIkind_errors :: ([GHError])
            _qualifiersIkindvar :: (Int)
            _qualifiersIksubst :: (KSubst)
            _qualifiersIlabels_collect :: (FMap Name Names)
            _qualifiersImethods_collect :: (FMap Name Names)
            _qualifiersIpresignatures_collect :: (PreSignatures)
            _qualifiersIrawRequests_collect :: ([RawRequest])
            _qualifiersIself :: (Qualifiers)
            _qualifiersIstaticErrors :: ([GHError])
            _qualifiersIstructureTypes_collect :: (FMap Name LambdaType)
            _qualifiersItypeImps_collect :: ([Request_TypeImply])
            _qualifiersOabstractTypes_collect :: (Set Name)
            _qualifiersObimapImps_collect :: ([Request_BimapImply])
            _qualifiersOclassname :: (Maybe Name)
            _qualifiersOconstructors_collect :: (FMap Name Names)
            _qualifiersOconstructors_dist :: (FMap Name Names)
            _qualifiersOcurrentModule :: (Strings)
            _qualifiersOdependencies :: (FMap Name [(Name,Name)])
            _qualifiersOexportedStructures :: (Set Name)
            _qualifiersOexportedTypes :: (Set Name)
            _qualifiersOexportedValues :: (Set Name)
            _qualifiersOfunImps_collect :: ([Request_FunImply])
            _qualifiersOgenericAbstractions :: (FMap Name Kind)
            _qualifiersOgenericAbstractions_collect :: (FMap Name Kind)
            _qualifiersOghc :: (Bool)
            _qualifiersOimportedModule :: (Bool)
            _qualifiersOinstancename :: (Maybe Name)
            _qualifiersOkinames :: (KSubst)
            _qualifiersOkindIndexedTypes :: (FMap Name KindIndexedType)
            _qualifiersOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _qualifiersOkinds :: (KSubst)
            _qualifiersOkindvar :: (Int)
            _qualifiersOksubst :: (KSubst)
            _qualifiersOlabels_collect :: (FMap Name Names)
            _qualifiersOlabels_dist :: (FMap Name Names)
            _qualifiersOlocal :: (Bool)
            _qualifiersOmethods_collect :: (FMap Name Names)
            _qualifiersOmethods_dist :: (FMap Name Names)
            _qualifiersOmodules :: (Set Strings)
            _qualifiersOoptimizer :: (Bool)
            _qualifiersOoptimizerPrelude :: (Declarations)
            _qualifiersOprekind :: (KSubst)
            _qualifiersOprelude :: (Bool)
            _qualifiersOpresignatures :: (PreSignatures)
            _qualifiersOpresignatures_collect :: (PreSignatures)
            _qualifiersOrawRequests_collect :: ([RawRequest])
            _qualifiersOsignatures :: (Signatures)
            _qualifiersOstructureTypes_collect :: (FMap Name LambdaType)
            _qualifiersOtoplevel :: (Bool)
            _qualifiersOtypeImps_collect :: ([Request_TypeImply])
            _qualifiersOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionIabstractTypes_collect
             ,_expressionIbimapImps_collect
             ,_expressionIconstructors_collect
             ,_expressionIdepConstraints_collect
             ,_expressionIfunImps_collect
             ,_expressionIgenericAbstractions_collect
             ,_expressionIkinames
             ,_expressionIkindIndexedTypes_collect
             ,_expressionIkind_errors
             ,_expressionIkindvar
             ,_expressionIksubst
             ,_expressionIlabels_collect
             ,_expressionImethods_collect
             ,_expressionIpresignatures_collect
             ,_expressionIrawRequests_collect
             ,_expressionIself
             ,_expressionIstaticErrors
             ,_expressionIstructureTypes_collect
             ,_expressionItypeImps_collect
             ) =
                (expression_ (_expressionOabstractTypes_collect)
                             (_expressionObimapImps_collect)
                             (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies)
                             (_expressionOexportedStructures)
                             (_expressionOexportedTypes)
                             (_expressionOexportedValues)
                             (_expressionOfunImps_collect)
                             (_expressionOgenericAbstractions)
                             (_expressionOgenericAbstractions_collect)
                             (_expressionOghc)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOkinames)
                             (_expressionOkindIndexedTypes)
                             (_expressionOkindIndexedTypes_collect)
                             (_expressionOkinds)
                             (_expressionOkindvar)
                             (_expressionOksubst)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmodules)
                             (_expressionOoptimizer)
                             (_expressionOoptimizerPrelude)
                             (_expressionOprekind)
                             (_expressionOprelude)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOrawRequests_collect)
                             (_expressionOsignatures)
                             (_expressionOstructureTypes_collect)
                             (_expressionOtoplevel)
                             (_expressionOtypeImps_collect)
                             (_expressionOverbosity))
            ( _qualifiersIabstractTypes_collect
             ,_qualifiersIbimapImps_collect
             ,_qualifiersIconstructors_collect
             ,_qualifiersIdepConstraints_collect
             ,_qualifiersIfunImps_collect
             ,_qualifiersIgenericAbstractions_collect
             ,_qualifiersIkinames
             ,_qualifiersIkindIndexedTypes_collect
             ,_qualifiersIkind_errors
             ,_qualifiersIkindvar
             ,_qualifiersIksubst
             ,_qualifiersIlabels_collect
             ,_qualifiersImethods_collect
             ,_qualifiersIpresignatures_collect
             ,_qualifiersIrawRequests_collect
             ,_qualifiersIself
             ,_qualifiersIstaticErrors
             ,_qualifiersIstructureTypes_collect
             ,_qualifiersItypeImps_collect
             ) =
                (qualifiers_ (_qualifiersOabstractTypes_collect)
                             (_qualifiersObimapImps_collect)
                             (_qualifiersOclassname)
                             (_qualifiersOconstructors_collect)
                             (_qualifiersOconstructors_dist)
                             (_qualifiersOcurrentModule)
                             (_qualifiersOdependencies)
                             (_qualifiersOexportedStructures)
                             (_qualifiersOexportedTypes)
                             (_qualifiersOexportedValues)
                             (_qualifiersOfunImps_collect)
                             (_qualifiersOgenericAbstractions)
                             (_qualifiersOgenericAbstractions_collect)
                             (_qualifiersOghc)
                             (_qualifiersOimportedModule)
                             (_qualifiersOinstancename)
                             (_qualifiersOkinames)
                             (_qualifiersOkindIndexedTypes)
                             (_qualifiersOkindIndexedTypes_collect)
                             (_qualifiersOkinds)
                             (_qualifiersOkindvar)
                             (_qualifiersOksubst)
                             (_qualifiersOlabels_collect)
                             (_qualifiersOlabels_dist)
                             (_qualifiersOlocal)
                             (_qualifiersOmethods_collect)
                             (_qualifiersOmethods_dist)
                             (_qualifiersOmodules)
                             (_qualifiersOoptimizer)
                             (_qualifiersOoptimizerPrelude)
                             (_qualifiersOprekind)
                             (_qualifiersOprelude)
                             (_qualifiersOpresignatures)
                             (_qualifiersOpresignatures_collect)
                             (_qualifiersOrawRequests_collect)
                             (_qualifiersOsignatures)
                             (_qualifiersOstructureTypes_collect)
                             (_qualifiersOtoplevel)
                             (_qualifiersOtypeImps_collect)
                             (_qualifiersOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _expressionIdepConstraints_collect ++ _qualifiersIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _expressionIkind_errors ++ _qualifiersIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _expressionIstaticErrors ++ _qualifiersIstaticErrors
            -- self rule
            (_self@_) =
                Expression_Comprehension _rangeIself _expressionIself _qualifiersIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _qualifiersIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _qualifiersIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _qualifiersIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _qualifiersIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _qualifiersIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _qualifiersIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _qualifiersIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _qualifiersIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _qualifiersIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _qualifiersIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _qualifiersImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _qualifiersIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _qualifiersIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _qualifiersIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _qualifiersItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_expressionObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_expressionOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_expressionOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_expressionOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_expressionOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_expressionOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_expressionOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_expressionOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_expressionOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_expressionOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_expressionOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_expressionOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_expressionOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_expressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_expressionOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_expressionOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_expressionOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_expressionOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_expressionOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_qualifiersOabstractTypes_collect@_) =
                _expressionIabstractTypes_collect
            -- copy rule (chain)
            (_qualifiersObimapImps_collect@_) =
                _expressionIbimapImps_collect
            -- copy rule (down)
            (_qualifiersOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_qualifiersOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (down)
            (_qualifiersOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_qualifiersOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_qualifiersOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_qualifiersOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_qualifiersOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_qualifiersOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (chain)
            (_qualifiersOfunImps_collect@_) =
                _expressionIfunImps_collect
            -- copy rule (down)
            (_qualifiersOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_qualifiersOgenericAbstractions_collect@_) =
                _expressionIgenericAbstractions_collect
            -- copy rule (down)
            (_qualifiersOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_qualifiersOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_qualifiersOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_qualifiersOkinames@_) =
                _expressionIkinames
            -- copy rule (down)
            (_qualifiersOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (chain)
            (_qualifiersOkindIndexedTypes_collect@_) =
                _expressionIkindIndexedTypes_collect
            -- copy rule (down)
            (_qualifiersOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_qualifiersOkindvar@_) =
                _expressionIkindvar
            -- copy rule (chain)
            (_qualifiersOksubst@_) =
                _expressionIksubst
            -- copy rule (chain)
            (_qualifiersOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (down)
            (_qualifiersOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_qualifiersOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_qualifiersOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (down)
            (_qualifiersOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_qualifiersOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_qualifiersOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_qualifiersOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_qualifiersOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_qualifiersOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_qualifiersOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_qualifiersOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (chain)
            (_qualifiersOrawRequests_collect@_) =
                _expressionIrawRequests_collect
            -- copy rule (down)
            (_qualifiersOsignatures@_) =
                _lhsIsignatures
            -- copy rule (chain)
            (_qualifiersOstructureTypes_collect@_) =
                _expressionIstructureTypes_collect
            -- copy rule (down)
            (_qualifiersOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_qualifiersOtypeImps_collect@_) =
                _expressionItypeImps_collect
            -- copy rule (down)
            (_qualifiersOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Expression_Constructor :: (T_Range) ->
                              (T_Name) ->
                              (T_Expression)
sem_Expression_Constructor (range_) (name_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Expression)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                Expression_Constructor _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Expression_Do :: (T_Range) ->
                     (T_Statements) ->
                     (T_Expression)
sem_Expression_Do (range_) (statements_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Expression)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _statementsIabstractTypes_collect :: (Set Name)
            _statementsIbimapImps_collect :: ([Request_BimapImply])
            _statementsIconstructors_collect :: (FMap Name Names)
            _statementsIdepConstraints_collect :: ([DepConstraint])
            _statementsIfunImps_collect :: ([Request_FunImply])
            _statementsIgenericAbstractions_collect :: (FMap Name Kind)
            _statementsIkinames :: (KSubst)
            _statementsIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _statementsIkind_errors :: ([GHError])
            _statementsIkindvar :: (Int)
            _statementsIksubst :: (KSubst)
            _statementsIlabels_collect :: (FMap Name Names)
            _statementsImethods_collect :: (FMap Name Names)
            _statementsIpresignatures_collect :: (PreSignatures)
            _statementsIrawRequests_collect :: ([RawRequest])
            _statementsIself :: (Statements)
            _statementsIstaticErrors :: ([GHError])
            _statementsIstructureTypes_collect :: (FMap Name LambdaType)
            _statementsItypeImps_collect :: ([Request_TypeImply])
            _statementsOabstractTypes_collect :: (Set Name)
            _statementsObimapImps_collect :: ([Request_BimapImply])
            _statementsOclassname :: (Maybe Name)
            _statementsOconstructors_collect :: (FMap Name Names)
            _statementsOconstructors_dist :: (FMap Name Names)
            _statementsOcurrentModule :: (Strings)
            _statementsOdependencies :: (FMap Name [(Name,Name)])
            _statementsOexportedStructures :: (Set Name)
            _statementsOexportedTypes :: (Set Name)
            _statementsOexportedValues :: (Set Name)
            _statementsOfunImps_collect :: ([Request_FunImply])
            _statementsOgenericAbstractions :: (FMap Name Kind)
            _statementsOgenericAbstractions_collect :: (FMap Name Kind)
            _statementsOghc :: (Bool)
            _statementsOimportedModule :: (Bool)
            _statementsOinstancename :: (Maybe Name)
            _statementsOkinames :: (KSubst)
            _statementsOkindIndexedTypes :: (FMap Name KindIndexedType)
            _statementsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _statementsOkinds :: (KSubst)
            _statementsOkindvar :: (Int)
            _statementsOksubst :: (KSubst)
            _statementsOlabels_collect :: (FMap Name Names)
            _statementsOlabels_dist :: (FMap Name Names)
            _statementsOlocal :: (Bool)
            _statementsOmethods_collect :: (FMap Name Names)
            _statementsOmethods_dist :: (FMap Name Names)
            _statementsOmodules :: (Set Strings)
            _statementsOoptimizer :: (Bool)
            _statementsOoptimizerPrelude :: (Declarations)
            _statementsOprekind :: (KSubst)
            _statementsOprelude :: (Bool)
            _statementsOpresignatures :: (PreSignatures)
            _statementsOpresignatures_collect :: (PreSignatures)
            _statementsOrawRequests_collect :: ([RawRequest])
            _statementsOsignatures :: (Signatures)
            _statementsOstructureTypes_collect :: (FMap Name LambdaType)
            _statementsOtoplevel :: (Bool)
            _statementsOtypeImps_collect :: ([Request_TypeImply])
            _statementsOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _statementsIabstractTypes_collect
             ,_statementsIbimapImps_collect
             ,_statementsIconstructors_collect
             ,_statementsIdepConstraints_collect
             ,_statementsIfunImps_collect
             ,_statementsIgenericAbstractions_collect
             ,_statementsIkinames
             ,_statementsIkindIndexedTypes_collect
             ,_statementsIkind_errors
             ,_statementsIkindvar
             ,_statementsIksubst
             ,_statementsIlabels_collect
             ,_statementsImethods_collect
             ,_statementsIpresignatures_collect
             ,_statementsIrawRequests_collect
             ,_statementsIself
             ,_statementsIstaticErrors
             ,_statementsIstructureTypes_collect
             ,_statementsItypeImps_collect
             ) =
                (statements_ (_statementsOabstractTypes_collect)
                             (_statementsObimapImps_collect)
                             (_statementsOclassname)
                             (_statementsOconstructors_collect)
                             (_statementsOconstructors_dist)
                             (_statementsOcurrentModule)
                             (_statementsOdependencies)
                             (_statementsOexportedStructures)
                             (_statementsOexportedTypes)
                             (_statementsOexportedValues)
                             (_statementsOfunImps_collect)
                             (_statementsOgenericAbstractions)
                             (_statementsOgenericAbstractions_collect)
                             (_statementsOghc)
                             (_statementsOimportedModule)
                             (_statementsOinstancename)
                             (_statementsOkinames)
                             (_statementsOkindIndexedTypes)
                             (_statementsOkindIndexedTypes_collect)
                             (_statementsOkinds)
                             (_statementsOkindvar)
                             (_statementsOksubst)
                             (_statementsOlabels_collect)
                             (_statementsOlabels_dist)
                             (_statementsOlocal)
                             (_statementsOmethods_collect)
                             (_statementsOmethods_dist)
                             (_statementsOmodules)
                             (_statementsOoptimizer)
                             (_statementsOoptimizerPrelude)
                             (_statementsOprekind)
                             (_statementsOprelude)
                             (_statementsOpresignatures)
                             (_statementsOpresignatures_collect)
                             (_statementsOrawRequests_collect)
                             (_statementsOsignatures)
                             (_statementsOstructureTypes_collect)
                             (_statementsOtoplevel)
                             (_statementsOtypeImps_collect)
                             (_statementsOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _statementsIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _statementsIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _statementsIstaticErrors
            -- self rule
            (_self@_) =
                Expression_Do _rangeIself _statementsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _statementsIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _statementsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _statementsIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _statementsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _statementsIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _statementsIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _statementsIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _statementsIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _statementsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _statementsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _statementsImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _statementsIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _statementsIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _statementsIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _statementsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_statementsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_statementsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_statementsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_statementsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_statementsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_statementsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_statementsOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_statementsOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_statementsOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_statementsOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_statementsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_statementsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_statementsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_statementsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_statementsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_statementsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_statementsOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_statementsOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_statementsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_statementsOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_statementsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_statementsOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_statementsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_statementsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_statementsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_statementsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_statementsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_statementsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_statementsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_statementsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_statementsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_statementsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_statementsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_statementsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_statementsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_statementsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_statementsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_statementsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_statementsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_statementsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Expression_Enum :: (T_Range) ->
                       (T_Expression) ->
                       (T_MaybeExpression) ->
                       (T_MaybeExpression) ->
                       (T_Expression)
sem_Expression_Enum (range_) (from_) (then_) (to_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Expression)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _fromIabstractTypes_collect :: (Set Name)
            _fromIbimapImps_collect :: ([Request_BimapImply])
            _fromIconstructors_collect :: (FMap Name Names)
            _fromIdepConstraints_collect :: ([DepConstraint])
            _fromIfunImps_collect :: ([Request_FunImply])
            _fromIgenericAbstractions_collect :: (FMap Name Kind)
            _fromIkinames :: (KSubst)
            _fromIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _fromIkind_errors :: ([GHError])
            _fromIkindvar :: (Int)
            _fromIksubst :: (KSubst)
            _fromIlabels_collect :: (FMap Name Names)
            _fromImethods_collect :: (FMap Name Names)
            _fromIpresignatures_collect :: (PreSignatures)
            _fromIrawRequests_collect :: ([RawRequest])
            _fromIself :: (Expression)
            _fromIstaticErrors :: ([GHError])
            _fromIstructureTypes_collect :: (FMap Name LambdaType)
            _fromItypeImps_collect :: ([Request_TypeImply])
            _fromOabstractTypes_collect :: (Set Name)
            _fromObimapImps_collect :: ([Request_BimapImply])
            _fromOclassname :: (Maybe Name)
            _fromOconstructors_collect :: (FMap Name Names)
            _fromOconstructors_dist :: (FMap Name Names)
            _fromOcurrentModule :: (Strings)
            _fromOdependencies :: (FMap Name [(Name,Name)])
            _fromOexportedStructures :: (Set Name)
            _fromOexportedTypes :: (Set Name)
            _fromOexportedValues :: (Set Name)
            _fromOfunImps_collect :: ([Request_FunImply])
            _fromOgenericAbstractions :: (FMap Name Kind)
            _fromOgenericAbstractions_collect :: (FMap Name Kind)
            _fromOghc :: (Bool)
            _fromOimportedModule :: (Bool)
            _fromOinstancename :: (Maybe Name)
            _fromOkinames :: (KSubst)
            _fromOkindIndexedTypes :: (FMap Name KindIndexedType)
            _fromOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _fromOkinds :: (KSubst)
            _fromOkindvar :: (Int)
            _fromOksubst :: (KSubst)
            _fromOlabels_collect :: (FMap Name Names)
            _fromOlabels_dist :: (FMap Name Names)
            _fromOlocal :: (Bool)
            _fromOmethods_collect :: (FMap Name Names)
            _fromOmethods_dist :: (FMap Name Names)
            _fromOmodules :: (Set Strings)
            _fromOoptimizer :: (Bool)
            _fromOoptimizerPrelude :: (Declarations)
            _fromOprekind :: (KSubst)
            _fromOprelude :: (Bool)
            _fromOpresignatures :: (PreSignatures)
            _fromOpresignatures_collect :: (PreSignatures)
            _fromOrawRequests_collect :: ([RawRequest])
            _fromOsignatures :: (Signatures)
            _fromOstructureTypes_collect :: (FMap Name LambdaType)
            _fromOtoplevel :: (Bool)
            _fromOtypeImps_collect :: ([Request_TypeImply])
            _fromOverbosity :: (Int)
            _thenIabstractTypes_collect :: (Set Name)
            _thenIbimapImps_collect :: ([Request_BimapImply])
            _thenIconstructors_collect :: (FMap Name Names)
            _thenIdepConstraints_collect :: ([DepConstraint])
            _thenIfunImps_collect :: ([Request_FunImply])
            _thenIgenericAbstractions_collect :: (FMap Name Kind)
            _thenIkinames :: (KSubst)
            _thenIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _thenIkind_errors :: ([GHError])
            _thenIkindvar :: (Int)
            _thenIksubst :: (KSubst)
            _thenIlabels_collect :: (FMap Name Names)
            _thenImethods_collect :: (FMap Name Names)
            _thenIpresignatures_collect :: (PreSignatures)
            _thenIrawRequests_collect :: ([RawRequest])
            _thenIself :: (MaybeExpression)
            _thenIstaticErrors :: ([GHError])
            _thenIstructureTypes_collect :: (FMap Name LambdaType)
            _thenItypeImps_collect :: ([Request_TypeImply])
            _thenOabstractTypes_collect :: (Set Name)
            _thenObimapImps_collect :: ([Request_BimapImply])
            _thenOclassname :: (Maybe Name)
            _thenOconstructors_collect :: (FMap Name Names)
            _thenOconstructors_dist :: (FMap Name Names)
            _thenOcurrentModule :: (Strings)
            _thenOdependencies :: (FMap Name [(Name,Name)])
            _thenOexportedStructures :: (Set Name)
            _thenOexportedTypes :: (Set Name)
            _thenOexportedValues :: (Set Name)
            _thenOfunImps_collect :: ([Request_FunImply])
            _thenOgenericAbstractions :: (FMap Name Kind)
            _thenOgenericAbstractions_collect :: (FMap Name Kind)
            _thenOghc :: (Bool)
            _thenOimportedModule :: (Bool)
            _thenOinstancename :: (Maybe Name)
            _thenOkinames :: (KSubst)
            _thenOkindIndexedTypes :: (FMap Name KindIndexedType)
            _thenOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _thenOkinds :: (KSubst)
            _thenOkindvar :: (Int)
            _thenOksubst :: (KSubst)
            _thenOlabels_collect :: (FMap Name Names)
            _thenOlabels_dist :: (FMap Name Names)
            _thenOlocal :: (Bool)
            _thenOmethods_collect :: (FMap Name Names)
            _thenOmethods_dist :: (FMap Name Names)
            _thenOmodules :: (Set Strings)
            _thenOoptimizer :: (Bool)
            _thenOoptimizerPrelude :: (Declarations)
            _thenOprekind :: (KSubst)
            _thenOprelude :: (Bool)
            _thenOpresignatures :: (PreSignatures)
            _thenOpresignatures_collect :: (PreSignatures)
            _thenOrawRequests_collect :: ([RawRequest])
            _thenOsignatures :: (Signatures)
            _thenOstructureTypes_collect :: (FMap Name LambdaType)
            _thenOtoplevel :: (Bool)
            _thenOtypeImps_collect :: ([Request_TypeImply])
            _thenOverbosity :: (Int)
            _toIabstractTypes_collect :: (Set Name)
            _toIbimapImps_collect :: ([Request_BimapImply])
            _toIconstructors_collect :: (FMap Name Names)
            _toIdepConstraints_collect :: ([DepConstraint])
            _toIfunImps_collect :: ([Request_FunImply])
            _toIgenericAbstractions_collect :: (FMap Name Kind)
            _toIkinames :: (KSubst)
            _toIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _toIkind_errors :: ([GHError])
            _toIkindvar :: (Int)
            _toIksubst :: (KSubst)
            _toIlabels_collect :: (FMap Name Names)
            _toImethods_collect :: (FMap Name Names)
            _toIpresignatures_collect :: (PreSignatures)
            _toIrawRequests_collect :: ([RawRequest])
            _toIself :: (MaybeExpression)
            _toIstaticErrors :: ([GHError])
            _toIstructureTypes_collect :: (FMap Name LambdaType)
            _toItypeImps_collect :: ([Request_TypeImply])
            _toOabstractTypes_collect :: (Set Name)
            _toObimapImps_collect :: ([Request_BimapImply])
            _toOclassname :: (Maybe Name)
            _toOconstructors_collect :: (FMap Name Names)
            _toOconstructors_dist :: (FMap Name Names)
            _toOcurrentModule :: (Strings)
            _toOdependencies :: (FMap Name [(Name,Name)])
            _toOexportedStructures :: (Set Name)
            _toOexportedTypes :: (Set Name)
            _toOexportedValues :: (Set Name)
            _toOfunImps_collect :: ([Request_FunImply])
            _toOgenericAbstractions :: (FMap Name Kind)
            _toOgenericAbstractions_collect :: (FMap Name Kind)
            _toOghc :: (Bool)
            _toOimportedModule :: (Bool)
            _toOinstancename :: (Maybe Name)
            _toOkinames :: (KSubst)
            _toOkindIndexedTypes :: (FMap Name KindIndexedType)
            _toOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _toOkinds :: (KSubst)
            _toOkindvar :: (Int)
            _toOksubst :: (KSubst)
            _toOlabels_collect :: (FMap Name Names)
            _toOlabels_dist :: (FMap Name Names)
            _toOlocal :: (Bool)
            _toOmethods_collect :: (FMap Name Names)
            _toOmethods_dist :: (FMap Name Names)
            _toOmodules :: (Set Strings)
            _toOoptimizer :: (Bool)
            _toOoptimizerPrelude :: (Declarations)
            _toOprekind :: (KSubst)
            _toOprelude :: (Bool)
            _toOpresignatures :: (PreSignatures)
            _toOpresignatures_collect :: (PreSignatures)
            _toOrawRequests_collect :: ([RawRequest])
            _toOsignatures :: (Signatures)
            _toOstructureTypes_collect :: (FMap Name LambdaType)
            _toOtoplevel :: (Bool)
            _toOtypeImps_collect :: ([Request_TypeImply])
            _toOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _fromIabstractTypes_collect,_fromIbimapImps_collect,_fromIconstructors_collect,_fromIdepConstraints_collect,_fromIfunImps_collect,_fromIgenericAbstractions_collect,_fromIkinames,_fromIkindIndexedTypes_collect,_fromIkind_errors,_fromIkindvar,_fromIksubst,_fromIlabels_collect,_fromImethods_collect,_fromIpresignatures_collect,_fromIrawRequests_collect,_fromIself,_fromIstaticErrors,_fromIstructureTypes_collect,_fromItypeImps_collect) =
                (from_ (_fromOabstractTypes_collect)
                       (_fromObimapImps_collect)
                       (_fromOclassname)
                       (_fromOconstructors_collect)
                       (_fromOconstructors_dist)
                       (_fromOcurrentModule)
                       (_fromOdependencies)
                       (_fromOexportedStructures)
                       (_fromOexportedTypes)
                       (_fromOexportedValues)
                       (_fromOfunImps_collect)
                       (_fromOgenericAbstractions)
                       (_fromOgenericAbstractions_collect)
                       (_fromOghc)
                       (_fromOimportedModule)
                       (_fromOinstancename)
                       (_fromOkinames)
                       (_fromOkindIndexedTypes)
                       (_fromOkindIndexedTypes_collect)
                       (_fromOkinds)
                       (_fromOkindvar)
                       (_fromOksubst)
                       (_fromOlabels_collect)
                       (_fromOlabels_dist)
                       (_fromOlocal)
                       (_fromOmethods_collect)
                       (_fromOmethods_dist)
                       (_fromOmodules)
                       (_fromOoptimizer)
                       (_fromOoptimizerPrelude)
                       (_fromOprekind)
                       (_fromOprelude)
                       (_fromOpresignatures)
                       (_fromOpresignatures_collect)
                       (_fromOrawRequests_collect)
                       (_fromOsignatures)
                       (_fromOstructureTypes_collect)
                       (_fromOtoplevel)
                       (_fromOtypeImps_collect)
                       (_fromOverbosity))
            ( _thenIabstractTypes_collect,_thenIbimapImps_collect,_thenIconstructors_collect,_thenIdepConstraints_collect,_thenIfunImps_collect,_thenIgenericAbstractions_collect,_thenIkinames,_thenIkindIndexedTypes_collect,_thenIkind_errors,_thenIkindvar,_thenIksubst,_thenIlabels_collect,_thenImethods_collect,_thenIpresignatures_collect,_thenIrawRequests_collect,_thenIself,_thenIstaticErrors,_thenIstructureTypes_collect,_thenItypeImps_collect) =
                (then_ (_thenOabstractTypes_collect)
                       (_thenObimapImps_collect)
                       (_thenOclassname)
                       (_thenOconstructors_collect)
                       (_thenOconstructors_dist)
                       (_thenOcurrentModule)
                       (_thenOdependencies)
                       (_thenOexportedStructures)
                       (_thenOexportedTypes)
                       (_thenOexportedValues)
                       (_thenOfunImps_collect)
                       (_thenOgenericAbstractions)
                       (_thenOgenericAbstractions_collect)
                       (_thenOghc)
                       (_thenOimportedModule)
                       (_thenOinstancename)
                       (_thenOkinames)
                       (_thenOkindIndexedTypes)
                       (_thenOkindIndexedTypes_collect)
                       (_thenOkinds)
                       (_thenOkindvar)
                       (_thenOksubst)
                       (_thenOlabels_collect)
                       (_thenOlabels_dist)
                       (_thenOlocal)
                       (_thenOmethods_collect)
                       (_thenOmethods_dist)
                       (_thenOmodules)
                       (_thenOoptimizer)
                       (_thenOoptimizerPrelude)
                       (_thenOprekind)
                       (_thenOprelude)
                       (_thenOpresignatures)
                       (_thenOpresignatures_collect)
                       (_thenOrawRequests_collect)
                       (_thenOsignatures)
                       (_thenOstructureTypes_collect)
                       (_thenOtoplevel)
                       (_thenOtypeImps_collect)
                       (_thenOverbosity))
            ( _toIabstractTypes_collect,_toIbimapImps_collect,_toIconstructors_collect,_toIdepConstraints_collect,_toIfunImps_collect,_toIgenericAbstractions_collect,_toIkinames,_toIkindIndexedTypes_collect,_toIkind_errors,_toIkindvar,_toIksubst,_toIlabels_collect,_toImethods_collect,_toIpresignatures_collect,_toIrawRequests_collect,_toIself,_toIstaticErrors,_toIstructureTypes_collect,_toItypeImps_collect) =
                (to_ (_toOabstractTypes_collect)
                     (_toObimapImps_collect)
                     (_toOclassname)
                     (_toOconstructors_collect)
                     (_toOconstructors_dist)
                     (_toOcurrentModule)
                     (_toOdependencies)
                     (_toOexportedStructures)
                     (_toOexportedTypes)
                     (_toOexportedValues)
                     (_toOfunImps_collect)
                     (_toOgenericAbstractions)
                     (_toOgenericAbstractions_collect)
                     (_toOghc)
                     (_toOimportedModule)
                     (_toOinstancename)
                     (_toOkinames)
                     (_toOkindIndexedTypes)
                     (_toOkindIndexedTypes_collect)
                     (_toOkinds)
                     (_toOkindvar)
                     (_toOksubst)
                     (_toOlabels_collect)
                     (_toOlabels_dist)
                     (_toOlocal)
                     (_toOmethods_collect)
                     (_toOmethods_dist)
                     (_toOmodules)
                     (_toOoptimizer)
                     (_toOoptimizerPrelude)
                     (_toOprekind)
                     (_toOprelude)
                     (_toOpresignatures)
                     (_toOpresignatures_collect)
                     (_toOrawRequests_collect)
                     (_toOsignatures)
                     (_toOstructureTypes_collect)
                     (_toOtoplevel)
                     (_toOtypeImps_collect)
                     (_toOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _fromIdepConstraints_collect ++ _thenIdepConstraints_collect ++ _toIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _fromIkind_errors ++ _thenIkind_errors ++ _toIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _fromIstaticErrors ++ _thenIstaticErrors ++ _toIstaticErrors
            -- self rule
            (_self@_) =
                Expression_Enum _rangeIself _fromIself _thenIself _toIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _toIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _toIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _toIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _toIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _toIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _toIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _toIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _toIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _toIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _toIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _toImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _toIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _toIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _toIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _toItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_fromOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_fromObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_fromOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_fromOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_fromOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_fromOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_fromOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_fromOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_fromOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_fromOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_fromOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_fromOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_fromOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_fromOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_fromOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_fromOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_fromOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_fromOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_fromOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_fromOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_fromOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_fromOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_fromOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_fromOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_fromOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_fromOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_fromOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_fromOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_fromOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_fromOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_fromOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_fromOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_fromOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_fromOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_fromOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_fromOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_fromOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_fromOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_fromOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_fromOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_thenOabstractTypes_collect@_) =
                _fromIabstractTypes_collect
            -- copy rule (chain)
            (_thenObimapImps_collect@_) =
                _fromIbimapImps_collect
            -- copy rule (down)
            (_thenOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_thenOconstructors_collect@_) =
                _fromIconstructors_collect
            -- copy rule (down)
            (_thenOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_thenOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_thenOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_thenOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_thenOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_thenOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (chain)
            (_thenOfunImps_collect@_) =
                _fromIfunImps_collect
            -- copy rule (down)
            (_thenOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_thenOgenericAbstractions_collect@_) =
                _fromIgenericAbstractions_collect
            -- copy rule (down)
            (_thenOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_thenOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_thenOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_thenOkinames@_) =
                _fromIkinames
            -- copy rule (down)
            (_thenOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (chain)
            (_thenOkindIndexedTypes_collect@_) =
                _fromIkindIndexedTypes_collect
            -- copy rule (down)
            (_thenOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_thenOkindvar@_) =
                _fromIkindvar
            -- copy rule (chain)
            (_thenOksubst@_) =
                _fromIksubst
            -- copy rule (chain)
            (_thenOlabels_collect@_) =
                _fromIlabels_collect
            -- copy rule (down)
            (_thenOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_thenOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_thenOmethods_collect@_) =
                _fromImethods_collect
            -- copy rule (down)
            (_thenOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_thenOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_thenOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_thenOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_thenOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_thenOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_thenOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_thenOpresignatures_collect@_) =
                _fromIpresignatures_collect
            -- copy rule (chain)
            (_thenOrawRequests_collect@_) =
                _fromIrawRequests_collect
            -- copy rule (down)
            (_thenOsignatures@_) =
                _lhsIsignatures
            -- copy rule (chain)
            (_thenOstructureTypes_collect@_) =
                _fromIstructureTypes_collect
            -- copy rule (down)
            (_thenOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_thenOtypeImps_collect@_) =
                _fromItypeImps_collect
            -- copy rule (down)
            (_thenOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_toOabstractTypes_collect@_) =
                _thenIabstractTypes_collect
            -- copy rule (chain)
            (_toObimapImps_collect@_) =
                _thenIbimapImps_collect
            -- copy rule (down)
            (_toOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_toOconstructors_collect@_) =
                _thenIconstructors_collect
            -- copy rule (down)
            (_toOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_toOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_toOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_toOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_toOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_toOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (chain)
            (_toOfunImps_collect@_) =
                _thenIfunImps_collect
            -- copy rule (down)
            (_toOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_toOgenericAbstractions_collect@_) =
                _thenIgenericAbstractions_collect
            -- copy rule (down)
            (_toOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_toOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_toOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_toOkinames@_) =
                _thenIkinames
            -- copy rule (down)
            (_toOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (chain)
            (_toOkindIndexedTypes_collect@_) =
                _thenIkindIndexedTypes_collect
            -- copy rule (down)
            (_toOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_toOkindvar@_) =
                _thenIkindvar
            -- copy rule (chain)
            (_toOksubst@_) =
                _thenIksubst
            -- copy rule (chain)
            (_toOlabels_collect@_) =
                _thenIlabels_collect
            -- copy rule (down)
            (_toOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_toOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_toOmethods_collect@_) =
                _thenImethods_collect
            -- copy rule (down)
            (_toOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_toOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_toOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_toOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_toOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_toOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_toOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_toOpresignatures_collect@_) =
                _thenIpresignatures_collect
            -- copy rule (chain)
            (_toOrawRequests_collect@_) =
                _thenIrawRequests_collect
            -- copy rule (down)
            (_toOsignatures@_) =
                _lhsIsignatures
            -- copy rule (chain)
            (_toOstructureTypes_collect@_) =
                _thenIstructureTypes_collect
            -- copy rule (down)
            (_toOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_toOtypeImps_collect@_) =
                _thenItypeImps_collect
            -- copy rule (down)
            (_toOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Expression_If :: (T_Range) ->
                     (T_Expression) ->
                     (T_Expression) ->
                     (T_Expression) ->
                     (T_Expression)
sem_Expression_If (range_) (guardExpression_) (thenExpression_) (elseExpression_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Expression)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _guardExpressionIabstractTypes_collect :: (Set Name)
            _guardExpressionIbimapImps_collect :: ([Request_BimapImply])
            _guardExpressionIconstructors_collect :: (FMap Name Names)
            _guardExpressionIdepConstraints_collect :: ([DepConstraint])
            _guardExpressionIfunImps_collect :: ([Request_FunImply])
            _guardExpressionIgenericAbstractions_collect :: (FMap Name Kind)
            _guardExpressionIkinames :: (KSubst)
            _guardExpressionIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _guardExpressionIkind_errors :: ([GHError])
            _guardExpressionIkindvar :: (Int)
            _guardExpressionIksubst :: (KSubst)
            _guardExpressionIlabels_collect :: (FMap Name Names)
            _guardExpressionImethods_collect :: (FMap Name Names)
            _guardExpressionIpresignatures_collect :: (PreSignatures)
            _guardExpressionIrawRequests_collect :: ([RawRequest])
            _guardExpressionIself :: (Expression)
            _guardExpressionIstaticErrors :: ([GHError])
            _guardExpressionIstructureTypes_collect :: (FMap Name LambdaType)
            _guardExpressionItypeImps_collect :: ([Request_TypeImply])
            _guardExpressionOabstractTypes_collect :: (Set Name)
            _guardExpressionObimapImps_collect :: ([Request_BimapImply])
            _guardExpressionOclassname :: (Maybe Name)
            _guardExpressionOconstructors_collect :: (FMap Name Names)
            _guardExpressionOconstructors_dist :: (FMap Name Names)
            _guardExpressionOcurrentModule :: (Strings)
            _guardExpressionOdependencies :: (FMap Name [(Name,Name)])
            _guardExpressionOexportedStructures :: (Set Name)
            _guardExpressionOexportedTypes :: (Set Name)
            _guardExpressionOexportedValues :: (Set Name)
            _guardExpressionOfunImps_collect :: ([Request_FunImply])
            _guardExpressionOgenericAbstractions :: (FMap Name Kind)
            _guardExpressionOgenericAbstractions_collect :: (FMap Name Kind)
            _guardExpressionOghc :: (Bool)
            _guardExpressionOimportedModule :: (Bool)
            _guardExpressionOinstancename :: (Maybe Name)
            _guardExpressionOkinames :: (KSubst)
            _guardExpressionOkindIndexedTypes :: (FMap Name KindIndexedType)
            _guardExpressionOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _guardExpressionOkinds :: (KSubst)
            _guardExpressionOkindvar :: (Int)
            _guardExpressionOksubst :: (KSubst)
            _guardExpressionOlabels_collect :: (FMap Name Names)
            _guardExpressionOlabels_dist :: (FMap Name Names)
            _guardExpressionOlocal :: (Bool)
            _guardExpressionOmethods_collect :: (FMap Name Names)
            _guardExpressionOmethods_dist :: (FMap Name Names)
            _guardExpressionOmodules :: (Set Strings)
            _guardExpressionOoptimizer :: (Bool)
            _guardExpressionOoptimizerPrelude :: (Declarations)
            _guardExpressionOprekind :: (KSubst)
            _guardExpressionOprelude :: (Bool)
            _guardExpressionOpresignatures :: (PreSignatures)
            _guardExpressionOpresignatures_collect :: (PreSignatures)
            _guardExpressionOrawRequests_collect :: ([RawRequest])
            _guardExpressionOsignatures :: (Signatures)
            _guardExpressionOstructureTypes_collect :: (FMap Name LambdaType)
            _guardExpressionOtoplevel :: (Bool)
            _guardExpressionOtypeImps_collect :: ([Request_TypeImply])
            _guardExpressionOverbosity :: (Int)
            _thenExpressionIabstractTypes_collect :: (Set Name)
            _thenExpressionIbimapImps_collect :: ([Request_BimapImply])
            _thenExpressionIconstructors_collect :: (FMap Name Names)
            _thenExpressionIdepConstraints_collect :: ([DepConstraint])
            _thenExpressionIfunImps_collect :: ([Request_FunImply])
            _thenExpressionIgenericAbstractions_collect :: (FMap Name Kind)
            _thenExpressionIkinames :: (KSubst)
            _thenExpressionIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _thenExpressionIkind_errors :: ([GHError])
            _thenExpressionIkindvar :: (Int)
            _thenExpressionIksubst :: (KSubst)
            _thenExpressionIlabels_collect :: (FMap Name Names)
            _thenExpressionImethods_collect :: (FMap Name Names)
            _thenExpressionIpresignatures_collect :: (PreSignatures)
            _thenExpressionIrawRequests_collect :: ([RawRequest])
            _thenExpressionIself :: (Expression)
            _thenExpressionIstaticErrors :: ([GHError])
            _thenExpressionIstructureTypes_collect :: (FMap Name LambdaType)
            _thenExpressionItypeImps_collect :: ([Request_TypeImply])
            _thenExpressionOabstractTypes_collect :: (Set Name)
            _thenExpressionObimapImps_collect :: ([Request_BimapImply])
            _thenExpressionOclassname :: (Maybe Name)
            _thenExpressionOconstructors_collect :: (FMap Name Names)
            _thenExpressionOconstructors_dist :: (FMap Name Names)
            _thenExpressionOcurrentModule :: (Strings)
            _thenExpressionOdependencies :: (FMap Name [(Name,Name)])
            _thenExpressionOexportedStructures :: (Set Name)
            _thenExpressionOexportedTypes :: (Set Name)
            _thenExpressionOexportedValues :: (Set Name)
            _thenExpressionOfunImps_collect :: ([Request_FunImply])
            _thenExpressionOgenericAbstractions :: (FMap Name Kind)
            _thenExpressionOgenericAbstractions_collect :: (FMap Name Kind)
            _thenExpressionOghc :: (Bool)
            _thenExpressionOimportedModule :: (Bool)
            _thenExpressionOinstancename :: (Maybe Name)
            _thenExpressionOkinames :: (KSubst)
            _thenExpressionOkindIndexedTypes :: (FMap Name KindIndexedType)
            _thenExpressionOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _thenExpressionOkinds :: (KSubst)
            _thenExpressionOkindvar :: (Int)
            _thenExpressionOksubst :: (KSubst)
            _thenExpressionOlabels_collect :: (FMap Name Names)
            _thenExpressionOlabels_dist :: (FMap Name Names)
            _thenExpressionOlocal :: (Bool)
            _thenExpressionOmethods_collect :: (FMap Name Names)
            _thenExpressionOmethods_dist :: (FMap Name Names)
            _thenExpressionOmodules :: (Set Strings)
            _thenExpressionOoptimizer :: (Bool)
            _thenExpressionOoptimizerPrelude :: (Declarations)
            _thenExpressionOprekind :: (KSubst)
            _thenExpressionOprelude :: (Bool)
            _thenExpressionOpresignatures :: (PreSignatures)
            _thenExpressionOpresignatures_collect :: (PreSignatures)
            _thenExpressionOrawRequests_collect :: ([RawRequest])
            _thenExpressionOsignatures :: (Signatures)
            _thenExpressionOstructureTypes_collect :: (FMap Name LambdaType)
            _thenExpressionOtoplevel :: (Bool)
            _thenExpressionOtypeImps_collect :: ([Request_TypeImply])
            _thenExpressionOverbosity :: (Int)
            _elseExpressionIabstractTypes_collect :: (Set Name)
            _elseExpressionIbimapImps_collect :: ([Request_BimapImply])
            _elseExpressionIconstructors_collect :: (FMap Name Names)
            _elseExpressionIdepConstraints_collect :: ([DepConstraint])
            _elseExpressionIfunImps_collect :: ([Request_FunImply])
            _elseExpressionIgenericAbstractions_collect :: (FMap Name Kind)
            _elseExpressionIkinames :: (KSubst)
            _elseExpressionIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _elseExpressionIkind_errors :: ([GHError])
            _elseExpressionIkindvar :: (Int)
            _elseExpressionIksubst :: (KSubst)
            _elseExpressionIlabels_collect :: (FMap Name Names)
            _elseExpressionImethods_collect :: (FMap Name Names)
            _elseExpressionIpresignatures_collect :: (PreSignatures)
            _elseExpressionIrawRequests_collect :: ([RawRequest])
            _elseExpressionIself :: (Expression)
            _elseExpressionIstaticErrors :: ([GHError])
            _elseExpressionIstructureTypes_collect :: (FMap Name LambdaType)
            _elseExpressionItypeImps_collect :: ([Request_TypeImply])
            _elseExpressionOabstractTypes_collect :: (Set Name)
            _elseExpressionObimapImps_collect :: ([Request_BimapImply])
            _elseExpressionOclassname :: (Maybe Name)
            _elseExpressionOconstructors_collect :: (FMap Name Names)
            _elseExpressionOconstructors_dist :: (FMap Name Names)
            _elseExpressionOcurrentModule :: (Strings)
            _elseExpressionOdependencies :: (FMap Name [(Name,Name)])
            _elseExpressionOexportedStructures :: (Set Name)
            _elseExpressionOexportedTypes :: (Set Name)
            _elseExpressionOexportedValues :: (Set Name)
            _elseExpressionOfunImps_collect :: ([Request_FunImply])
            _elseExpressionOgenericAbstractions :: (FMap Name Kind)
            _elseExpressionOgenericAbstractions_collect :: (FMap Name Kind)
            _elseExpressionOghc :: (Bool)
            _elseExpressionOimportedModule :: (Bool)
            _elseExpressionOinstancename :: (Maybe Name)
            _elseExpressionOkinames :: (KSubst)
            _elseExpressionOkindIndexedTypes :: (FMap Name KindIndexedType)
            _elseExpressionOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _elseExpressionOkinds :: (KSubst)
            _elseExpressionOkindvar :: (Int)
            _elseExpressionOksubst :: (KSubst)
            _elseExpressionOlabels_collect :: (FMap Name Names)
            _elseExpressionOlabels_dist :: (FMap Name Names)
            _elseExpressionOlocal :: (Bool)
            _elseExpressionOmethods_collect :: (FMap Name Names)
            _elseExpressionOmethods_dist :: (FMap Name Names)
            _elseExpressionOmodules :: (Set Strings)
            _elseExpressionOoptimizer :: (Bool)
            _elseExpressionOoptimizerPrelude :: (Declarations)
            _elseExpressionOprekind :: (KSubst)
            _elseExpressionOprelude :: (Bool)
            _elseExpressionOpresignatures :: (PreSignatures)
            _elseExpressionOpresignatures_collect :: (PreSignatures)
            _elseExpressionOrawRequests_collect :: ([RawRequest])
            _elseExpressionOsignatures :: (Signatures)
            _elseExpressionOstructureTypes_collect :: (FMap Name LambdaType)
            _elseExpressionOtoplevel :: (Bool)
            _elseExpressionOtypeImps_collect :: ([Request_TypeImply])
            _elseExpressionOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _guardExpressionIabstractTypes_collect
             ,_guardExpressionIbimapImps_collect
             ,_guardExpressionIconstructors_collect
             ,_guardExpressionIdepConstraints_collect
             ,_guardExpressionIfunImps_collect
             ,_guardExpressionIgenericAbstractions_collect
             ,_guardExpressionIkinames
             ,_guardExpressionIkindIndexedTypes_collect
             ,_guardExpressionIkind_errors
             ,_guardExpressionIkindvar
             ,_guardExpressionIksubst
             ,_guardExpressionIlabels_collect
             ,_guardExpressionImethods_collect
             ,_guardExpressionIpresignatures_collect
             ,_guardExpressionIrawRequests_collect
             ,_guardExpressionIself
             ,_guardExpressionIstaticErrors
             ,_guardExpressionIstructureTypes_collect
             ,_guardExpressionItypeImps_collect
             ) =
                (guardExpression_ (_guardExpressionOabstractTypes_collect)
                                  (_guardExpressionObimapImps_collect)
                                  (_guardExpressionOclassname)
                                  (_guardExpressionOconstructors_collect)
                                  (_guardExpressionOconstructors_dist)
                                  (_guardExpressionOcurrentModule)
                                  (_guardExpressionOdependencies)
                                  (_guardExpressionOexportedStructures)
                                  (_guardExpressionOexportedTypes)
                                  (_guardExpressionOexportedValues)
                                  (_guardExpressionOfunImps_collect)
                                  (_guardExpressionOgenericAbstractions)
                                  (_guardExpressionOgenericAbstractions_collect)
                                  (_guardExpressionOghc)
                                  (_guardExpressionOimportedModule)
                                  (_guardExpressionOinstancename)
                                  (_guardExpressionOkinames)
                                  (_guardExpressionOkindIndexedTypes)
                                  (_guardExpressionOkindIndexedTypes_collect)
                                  (_guardExpressionOkinds)
                                  (_guardExpressionOkindvar)
                                  (_guardExpressionOksubst)
                                  (_guardExpressionOlabels_collect)
                                  (_guardExpressionOlabels_dist)
                                  (_guardExpressionOlocal)
                                  (_guardExpressionOmethods_collect)
                                  (_guardExpressionOmethods_dist)
                                  (_guardExpressionOmodules)
                                  (_guardExpressionOoptimizer)
                                  (_guardExpressionOoptimizerPrelude)
                                  (_guardExpressionOprekind)
                                  (_guardExpressionOprelude)
                                  (_guardExpressionOpresignatures)
                                  (_guardExpressionOpresignatures_collect)
                                  (_guardExpressionOrawRequests_collect)
                                  (_guardExpressionOsignatures)
                                  (_guardExpressionOstructureTypes_collect)
                                  (_guardExpressionOtoplevel)
                                  (_guardExpressionOtypeImps_collect)
                                  (_guardExpressionOverbosity))
            ( _thenExpressionIabstractTypes_collect
             ,_thenExpressionIbimapImps_collect
             ,_thenExpressionIconstructors_collect
             ,_thenExpressionIdepConstraints_collect
             ,_thenExpressionIfunImps_collect
             ,_thenExpressionIgenericAbstractions_collect
             ,_thenExpressionIkinames
             ,_thenExpressionIkindIndexedTypes_collect
             ,_thenExpressionIkind_errors
             ,_thenExpressionIkindvar
             ,_thenExpressionIksubst
             ,_thenExpressionIlabels_collect
             ,_thenExpressionImethods_collect
             ,_thenExpressionIpresignatures_collect
             ,_thenExpressionIrawRequests_collect
             ,_thenExpressionIself
             ,_thenExpressionIstaticErrors
             ,_thenExpressionIstructureTypes_collect
             ,_thenExpressionItypeImps_collect
             ) =
                (thenExpression_ (_thenExpressionOabstractTypes_collect)
                                 (_thenExpressionObimapImps_collect)
                                 (_thenExpressionOclassname)
                                 (_thenExpressionOconstructors_collect)
                                 (_thenExpressionOconstructors_dist)
                                 (_thenExpressionOcurrentModule)
                                 (_thenExpressionOdependencies)
                                 (_thenExpressionOexportedStructures)
                                 (_thenExpressionOexportedTypes)
                                 (_thenExpressionOexportedValues)
                                 (_thenExpressionOfunImps_collect)
                                 (_thenExpressionOgenericAbstractions)
                                 (_thenExpressionOgenericAbstractions_collect)
                                 (_thenExpressionOghc)
                                 (_thenExpressionOimportedModule)
                                 (_thenExpressionOinstancename)
                                 (_thenExpressionOkinames)
                                 (_thenExpressionOkindIndexedTypes)
                                 (_thenExpressionOkindIndexedTypes_collect)
                                 (_thenExpressionOkinds)
                                 (_thenExpressionOkindvar)
                                 (_thenExpressionOksubst)
                                 (_thenExpressionOlabels_collect)
                                 (_thenExpressionOlabels_dist)
                                 (_thenExpressionOlocal)
                                 (_thenExpressionOmethods_collect)
                                 (_thenExpressionOmethods_dist)
                                 (_thenExpressionOmodules)
                                 (_thenExpressionOoptimizer)
                                 (_thenExpressionOoptimizerPrelude)
                                 (_thenExpressionOprekind)
                                 (_thenExpressionOprelude)
                                 (_thenExpressionOpresignatures)
                                 (_thenExpressionOpresignatures_collect)
                                 (_thenExpressionOrawRequests_collect)
                                 (_thenExpressionOsignatures)
                                 (_thenExpressionOstructureTypes_collect)
                                 (_thenExpressionOtoplevel)
                                 (_thenExpressionOtypeImps_collect)
                                 (_thenExpressionOverbosity))
            ( _elseExpressionIabstractTypes_collect
             ,_elseExpressionIbimapImps_collect
             ,_elseExpressionIconstructors_collect
             ,_elseExpressionIdepConstraints_collect
             ,_elseExpressionIfunImps_collect
             ,_elseExpressionIgenericAbstractions_collect
             ,_elseExpressionIkinames
             ,_elseExpressionIkindIndexedTypes_collect
             ,_elseExpressionIkind_errors
             ,_elseExpressionIkindvar
             ,_elseExpressionIksubst
             ,_elseExpressionIlabels_collect
             ,_elseExpressionImethods_collect
             ,_elseExpressionIpresignatures_collect
             ,_elseExpressionIrawRequests_collect
             ,_elseExpressionIself
             ,_elseExpressionIstaticErrors
             ,_elseExpressionIstructureTypes_collect
             ,_elseExpressionItypeImps_collect
             ) =
                (elseExpression_ (_elseExpressionOabstractTypes_collect)
                                 (_elseExpressionObimapImps_collect)
                                 (_elseExpressionOclassname)
                                 (_elseExpressionOconstructors_collect)
                                 (_elseExpressionOconstructors_dist)
                                 (_elseExpressionOcurrentModule)
                                 (_elseExpressionOdependencies)
                                 (_elseExpressionOexportedStructures)
                                 (_elseExpressionOexportedTypes)
                                 (_elseExpressionOexportedValues)
                                 (_elseExpressionOfunImps_collect)
                                 (_elseExpressionOgenericAbstractions)
                                 (_elseExpressionOgenericAbstractions_collect)
                                 (_elseExpressionOghc)
                                 (_elseExpressionOimportedModule)
                                 (_elseExpressionOinstancename)
                                 (_elseExpressionOkinames)
                                 (_elseExpressionOkindIndexedTypes)
                                 (_elseExpressionOkindIndexedTypes_collect)
                                 (_elseExpressionOkinds)
                                 (_elseExpressionOkindvar)
                                 (_elseExpressionOksubst)
                                 (_elseExpressionOlabels_collect)
                                 (_elseExpressionOlabels_dist)
                                 (_elseExpressionOlocal)
                                 (_elseExpressionOmethods_collect)
                                 (_elseExpressionOmethods_dist)
                                 (_elseExpressionOmodules)
                                 (_elseExpressionOoptimizer)
                                 (_elseExpressionOoptimizerPrelude)
                                 (_elseExpressionOprekind)
                                 (_elseExpressionOprelude)
                                 (_elseExpressionOpresignatures)
                                 (_elseExpressionOpresignatures_collect)
                                 (_elseExpressionOrawRequests_collect)
                                 (_elseExpressionOsignatures)
                                 (_elseExpressionOstructureTypes_collect)
                                 (_elseExpressionOtoplevel)
                                 (_elseExpressionOtypeImps_collect)
                                 (_elseExpressionOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _guardExpressionIdepConstraints_collect ++ _thenExpressionIdepConstraints_collect ++ _elseExpressionIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _guardExpressionIkind_errors ++ _thenExpressionIkind_errors ++ _elseExpressionIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _guardExpressionIstaticErrors ++ _thenExpressionIstaticErrors ++ _elseExpressionIstaticErrors
            -- self rule
            (_self@_) =
                Expression_If _rangeIself _guardExpressionIself _thenExpressionIself _elseExpressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _elseExpressionIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _elseExpressionIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _elseExpressionIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _elseExpressionIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _elseExpressionIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _elseExpressionIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _elseExpressionIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _elseExpressionIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _elseExpressionIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _elseExpressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _elseExpressionImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _elseExpressionIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _elseExpressionIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _elseExpressionIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _elseExpressionItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_guardExpressionOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_guardExpressionObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_guardExpressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_guardExpressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_guardExpressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_guardExpressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_guardExpressionOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_guardExpressionOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_guardExpressionOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_guardExpressionOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_guardExpressionOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_guardExpressionOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_guardExpressionOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_guardExpressionOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_guardExpressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_guardExpressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_guardExpressionOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_guardExpressionOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_guardExpressionOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_guardExpressionOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_guardExpressionOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_guardExpressionOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_guardExpressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_guardExpressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_guardExpressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_guardExpressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_guardExpressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_guardExpressionOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_guardExpressionOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_guardExpressionOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_guardExpressionOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_guardExpressionOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_guardExpressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_guardExpressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_guardExpressionOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_guardExpressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_guardExpressionOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_guardExpressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_guardExpressionOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_guardExpressionOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_thenExpressionOabstractTypes_collect@_) =
                _guardExpressionIabstractTypes_collect
            -- copy rule (chain)
            (_thenExpressionObimapImps_collect@_) =
                _guardExpressionIbimapImps_collect
            -- copy rule (down)
            (_thenExpressionOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_thenExpressionOconstructors_collect@_) =
                _guardExpressionIconstructors_collect
            -- copy rule (down)
            (_thenExpressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_thenExpressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_thenExpressionOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_thenExpressionOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_thenExpressionOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_thenExpressionOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (chain)
            (_thenExpressionOfunImps_collect@_) =
                _guardExpressionIfunImps_collect
            -- copy rule (down)
            (_thenExpressionOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_thenExpressionOgenericAbstractions_collect@_) =
                _guardExpressionIgenericAbstractions_collect
            -- copy rule (down)
            (_thenExpressionOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_thenExpressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_thenExpressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_thenExpressionOkinames@_) =
                _guardExpressionIkinames
            -- copy rule (down)
            (_thenExpressionOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (chain)
            (_thenExpressionOkindIndexedTypes_collect@_) =
                _guardExpressionIkindIndexedTypes_collect
            -- copy rule (down)
            (_thenExpressionOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_thenExpressionOkindvar@_) =
                _guardExpressionIkindvar
            -- copy rule (chain)
            (_thenExpressionOksubst@_) =
                _guardExpressionIksubst
            -- copy rule (chain)
            (_thenExpressionOlabels_collect@_) =
                _guardExpressionIlabels_collect
            -- copy rule (down)
            (_thenExpressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_thenExpressionOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_thenExpressionOmethods_collect@_) =
                _guardExpressionImethods_collect
            -- copy rule (down)
            (_thenExpressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_thenExpressionOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_thenExpressionOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_thenExpressionOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_thenExpressionOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_thenExpressionOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_thenExpressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_thenExpressionOpresignatures_collect@_) =
                _guardExpressionIpresignatures_collect
            -- copy rule (chain)
            (_thenExpressionOrawRequests_collect@_) =
                _guardExpressionIrawRequests_collect
            -- copy rule (down)
            (_thenExpressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (chain)
            (_thenExpressionOstructureTypes_collect@_) =
                _guardExpressionIstructureTypes_collect
            -- copy rule (down)
            (_thenExpressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_thenExpressionOtypeImps_collect@_) =
                _guardExpressionItypeImps_collect
            -- copy rule (down)
            (_thenExpressionOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_elseExpressionOabstractTypes_collect@_) =
                _thenExpressionIabstractTypes_collect
            -- copy rule (chain)
            (_elseExpressionObimapImps_collect@_) =
                _thenExpressionIbimapImps_collect
            -- copy rule (down)
            (_elseExpressionOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_elseExpressionOconstructors_collect@_) =
                _thenExpressionIconstructors_collect
            -- copy rule (down)
            (_elseExpressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_elseExpressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_elseExpressionOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_elseExpressionOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_elseExpressionOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_elseExpressionOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (chain)
            (_elseExpressionOfunImps_collect@_) =
                _thenExpressionIfunImps_collect
            -- copy rule (down)
            (_elseExpressionOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_elseExpressionOgenericAbstractions_collect@_) =
                _thenExpressionIgenericAbstractions_collect
            -- copy rule (down)
            (_elseExpressionOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_elseExpressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_elseExpressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_elseExpressionOkinames@_) =
                _thenExpressionIkinames
            -- copy rule (down)
            (_elseExpressionOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (chain)
            (_elseExpressionOkindIndexedTypes_collect@_) =
                _thenExpressionIkindIndexedTypes_collect
            -- copy rule (down)
            (_elseExpressionOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_elseExpressionOkindvar@_) =
                _thenExpressionIkindvar
            -- copy rule (chain)
            (_elseExpressionOksubst@_) =
                _thenExpressionIksubst
            -- copy rule (chain)
            (_elseExpressionOlabels_collect@_) =
                _thenExpressionIlabels_collect
            -- copy rule (down)
            (_elseExpressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_elseExpressionOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_elseExpressionOmethods_collect@_) =
                _thenExpressionImethods_collect
            -- copy rule (down)
            (_elseExpressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_elseExpressionOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_elseExpressionOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_elseExpressionOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_elseExpressionOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_elseExpressionOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_elseExpressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_elseExpressionOpresignatures_collect@_) =
                _thenExpressionIpresignatures_collect
            -- copy rule (chain)
            (_elseExpressionOrawRequests_collect@_) =
                _thenExpressionIrawRequests_collect
            -- copy rule (down)
            (_elseExpressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (chain)
            (_elseExpressionOstructureTypes_collect@_) =
                _thenExpressionIstructureTypes_collect
            -- copy rule (down)
            (_elseExpressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_elseExpressionOtypeImps_collect@_) =
                _thenExpressionItypeImps_collect
            -- copy rule (down)
            (_elseExpressionOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Expression_InfixApplication :: (T_Range) ->
                                   (T_MaybeExpression) ->
                                   (T_Expression) ->
                                   (T_MaybeExpression) ->
                                   (T_Expression)
sem_Expression_InfixApplication (range_) (leftExpression_) (operator_) (rightExpression_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Expression)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _leftExpressionIabstractTypes_collect :: (Set Name)
            _leftExpressionIbimapImps_collect :: ([Request_BimapImply])
            _leftExpressionIconstructors_collect :: (FMap Name Names)
            _leftExpressionIdepConstraints_collect :: ([DepConstraint])
            _leftExpressionIfunImps_collect :: ([Request_FunImply])
            _leftExpressionIgenericAbstractions_collect :: (FMap Name Kind)
            _leftExpressionIkinames :: (KSubst)
            _leftExpressionIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _leftExpressionIkind_errors :: ([GHError])
            _leftExpressionIkindvar :: (Int)
            _leftExpressionIksubst :: (KSubst)
            _leftExpressionIlabels_collect :: (FMap Name Names)
            _leftExpressionImethods_collect :: (FMap Name Names)
            _leftExpressionIpresignatures_collect :: (PreSignatures)
            _leftExpressionIrawRequests_collect :: ([RawRequest])
            _leftExpressionIself :: (MaybeExpression)
            _leftExpressionIstaticErrors :: ([GHError])
            _leftExpressionIstructureTypes_collect :: (FMap Name LambdaType)
            _leftExpressionItypeImps_collect :: ([Request_TypeImply])
            _leftExpressionOabstractTypes_collect :: (Set Name)
            _leftExpressionObimapImps_collect :: ([Request_BimapImply])
            _leftExpressionOclassname :: (Maybe Name)
            _leftExpressionOconstructors_collect :: (FMap Name Names)
            _leftExpressionOconstructors_dist :: (FMap Name Names)
            _leftExpressionOcurrentModule :: (Strings)
            _leftExpressionOdependencies :: (FMap Name [(Name,Name)])
            _leftExpressionOexportedStructures :: (Set Name)
            _leftExpressionOexportedTypes :: (Set Name)
            _leftExpressionOexportedValues :: (Set Name)
            _leftExpressionOfunImps_collect :: ([Request_FunImply])
            _leftExpressionOgenericAbstractions :: (FMap Name Kind)
            _leftExpressionOgenericAbstractions_collect :: (FMap Name Kind)
            _leftExpressionOghc :: (Bool)
            _leftExpressionOimportedModule :: (Bool)
            _leftExpressionOinstancename :: (Maybe Name)
            _leftExpressionOkinames :: (KSubst)
            _leftExpressionOkindIndexedTypes :: (FMap Name KindIndexedType)
            _leftExpressionOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _leftExpressionOkinds :: (KSubst)
            _leftExpressionOkindvar :: (Int)
            _leftExpressionOksubst :: (KSubst)
            _leftExpressionOlabels_collect :: (FMap Name Names)
            _leftExpressionOlabels_dist :: (FMap Name Names)
            _leftExpressionOlocal :: (Bool)
            _leftExpressionOmethods_collect :: (FMap Name Names)
            _leftExpressionOmethods_dist :: (FMap Name Names)
            _leftExpressionOmodules :: (Set Strings)
            _leftExpressionOoptimizer :: (Bool)
            _leftExpressionOoptimizerPrelude :: (Declarations)
            _leftExpressionOprekind :: (KSubst)
            _leftExpressionOprelude :: (Bool)
            _leftExpressionOpresignatures :: (PreSignatures)
            _leftExpressionOpresignatures_collect :: (PreSignatures)
            _leftExpressionOrawRequests_collect :: ([RawRequest])
            _leftExpressionOsignatures :: (Signatures)
            _leftExpressionOstructureTypes_collect :: (FMap Name LambdaType)
            _leftExpressionOtoplevel :: (Bool)
            _leftExpressionOtypeImps_collect :: ([Request_TypeImply])
            _leftExpressionOverbosity :: (Int)
            _operatorIabstractTypes_collect :: (Set Name)
            _operatorIbimapImps_collect :: ([Request_BimapImply])
            _operatorIconstructors_collect :: (FMap Name Names)
            _operatorIdepConstraints_collect :: ([DepConstraint])
            _operatorIfunImps_collect :: ([Request_FunImply])
            _operatorIgenericAbstractions_collect :: (FMap Name Kind)
            _operatorIkinames :: (KSubst)
            _operatorIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _operatorIkind_errors :: ([GHError])
            _operatorIkindvar :: (Int)
            _operatorIksubst :: (KSubst)
            _operatorIlabels_collect :: (FMap Name Names)
            _operatorImethods_collect :: (FMap Name Names)
            _operatorIpresignatures_collect :: (PreSignatures)
            _operatorIrawRequests_collect :: ([RawRequest])
            _operatorIself :: (Expression)
            _operatorIstaticErrors :: ([GHError])
            _operatorIstructureTypes_collect :: (FMap Name LambdaType)
            _operatorItypeImps_collect :: ([Request_TypeImply])
            _operatorOabstractTypes_collect :: (Set Name)
            _operatorObimapImps_collect :: ([Request_BimapImply])
            _operatorOclassname :: (Maybe Name)
            _operatorOconstructors_collect :: (FMap Name Names)
            _operatorOconstructors_dist :: (FMap Name Names)
            _operatorOcurrentModule :: (Strings)
            _operatorOdependencies :: (FMap Name [(Name,Name)])
            _operatorOexportedStructures :: (Set Name)
            _operatorOexportedTypes :: (Set Name)
            _operatorOexportedValues :: (Set Name)
            _operatorOfunImps_collect :: ([Request_FunImply])
            _operatorOgenericAbstractions :: (FMap Name Kind)
            _operatorOgenericAbstractions_collect :: (FMap Name Kind)
            _operatorOghc :: (Bool)
            _operatorOimportedModule :: (Bool)
            _operatorOinstancename :: (Maybe Name)
            _operatorOkinames :: (KSubst)
            _operatorOkindIndexedTypes :: (FMap Name KindIndexedType)
            _operatorOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _operatorOkinds :: (KSubst)
            _operatorOkindvar :: (Int)
            _operatorOksubst :: (KSubst)
            _operatorOlabels_collect :: (FMap Name Names)
            _operatorOlabels_dist :: (FMap Name Names)
            _operatorOlocal :: (Bool)
            _operatorOmethods_collect :: (FMap Name Names)
            _operatorOmethods_dist :: (FMap Name Names)
            _operatorOmodules :: (Set Strings)
            _operatorOoptimizer :: (Bool)
            _operatorOoptimizerPrelude :: (Declarations)
            _operatorOprekind :: (KSubst)
            _operatorOprelude :: (Bool)
            _operatorOpresignatures :: (PreSignatures)
            _operatorOpresignatures_collect :: (PreSignatures)
            _operatorOrawRequests_collect :: ([RawRequest])
            _operatorOsignatures :: (Signatures)
            _operatorOstructureTypes_collect :: (FMap Name LambdaType)
            _operatorOtoplevel :: (Bool)
            _operatorOtypeImps_collect :: ([Request_TypeImply])
            _operatorOverbosity :: (Int)
            _rightExpressionIabstractTypes_collect :: (Set Name)
            _rightExpressionIbimapImps_collect :: ([Request_BimapImply])
            _rightExpressionIconstructors_collect :: (FMap Name Names)
            _rightExpressionIdepConstraints_collect :: ([DepConstraint])
            _rightExpressionIfunImps_collect :: ([Request_FunImply])
            _rightExpressionIgenericAbstractions_collect :: (FMap Name Kind)
            _rightExpressionIkinames :: (KSubst)
            _rightExpressionIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _rightExpressionIkind_errors :: ([GHError])
            _rightExpressionIkindvar :: (Int)
            _rightExpressionIksubst :: (KSubst)
            _rightExpressionIlabels_collect :: (FMap Name Names)
            _rightExpressionImethods_collect :: (FMap Name Names)
            _rightExpressionIpresignatures_collect :: (PreSignatures)
            _rightExpressionIrawRequests_collect :: ([RawRequest])
            _rightExpressionIself :: (MaybeExpression)
            _rightExpressionIstaticErrors :: ([GHError])
            _rightExpressionIstructureTypes_collect :: (FMap Name LambdaType)
            _rightExpressionItypeImps_collect :: ([Request_TypeImply])
            _rightExpressionOabstractTypes_collect :: (Set Name)
            _rightExpressionObimapImps_collect :: ([Request_BimapImply])
            _rightExpressionOclassname :: (Maybe Name)
            _rightExpressionOconstructors_collect :: (FMap Name Names)
            _rightExpressionOconstructors_dist :: (FMap Name Names)
            _rightExpressionOcurrentModule :: (Strings)
            _rightExpressionOdependencies :: (FMap Name [(Name,Name)])
            _rightExpressionOexportedStructures :: (Set Name)
            _rightExpressionOexportedTypes :: (Set Name)
            _rightExpressionOexportedValues :: (Set Name)
            _rightExpressionOfunImps_collect :: ([Request_FunImply])
            _rightExpressionOgenericAbstractions :: (FMap Name Kind)
            _rightExpressionOgenericAbstractions_collect :: (FMap Name Kind)
            _rightExpressionOghc :: (Bool)
            _rightExpressionOimportedModule :: (Bool)
            _rightExpressionOinstancename :: (Maybe Name)
            _rightExpressionOkinames :: (KSubst)
            _rightExpressionOkindIndexedTypes :: (FMap Name KindIndexedType)
            _rightExpressionOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _rightExpressionOkinds :: (KSubst)
            _rightExpressionOkindvar :: (Int)
            _rightExpressionOksubst :: (KSubst)
            _rightExpressionOlabels_collect :: (FMap Name Names)
            _rightExpressionOlabels_dist :: (FMap Name Names)
            _rightExpressionOlocal :: (Bool)
            _rightExpressionOmethods_collect :: (FMap Name Names)
            _rightExpressionOmethods_dist :: (FMap Name Names)
            _rightExpressionOmodules :: (Set Strings)
            _rightExpressionOoptimizer :: (Bool)
            _rightExpressionOoptimizerPrelude :: (Declarations)
            _rightExpressionOprekind :: (KSubst)
            _rightExpressionOprelude :: (Bool)
            _rightExpressionOpresignatures :: (PreSignatures)
            _rightExpressionOpresignatures_collect :: (PreSignatures)
            _rightExpressionOrawRequests_collect :: ([RawRequest])
            _rightExpressionOsignatures :: (Signatures)
            _rightExpressionOstructureTypes_collect :: (FMap Name LambdaType)
            _rightExpressionOtoplevel :: (Bool)
            _rightExpressionOtypeImps_collect :: ([Request_TypeImply])
            _rightExpressionOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _leftExpressionIabstractTypes_collect
             ,_leftExpressionIbimapImps_collect
             ,_leftExpressionIconstructors_collect
             ,_leftExpressionIdepConstraints_collect
             ,_leftExpressionIfunImps_collect
             ,_leftExpressionIgenericAbstractions_collect
             ,_leftExpressionIkinames
             ,_leftExpressionIkindIndexedTypes_collect
             ,_leftExpressionIkind_errors
             ,_leftExpressionIkindvar
             ,_leftExpressionIksubst
             ,_leftExpressionIlabels_collect
             ,_leftExpressionImethods_collect
             ,_leftExpressionIpresignatures_collect
             ,_leftExpressionIrawRequests_collect
             ,_leftExpressionIself
             ,_leftExpressionIstaticErrors
             ,_leftExpressionIstructureTypes_collect
             ,_leftExpressionItypeImps_collect
             ) =
                (leftExpression_ (_leftExpressionOabstractTypes_collect)
                                 (_leftExpressionObimapImps_collect)
                                 (_leftExpressionOclassname)
                                 (_leftExpressionOconstructors_collect)
                                 (_leftExpressionOconstructors_dist)
                                 (_leftExpressionOcurrentModule)
                                 (_leftExpressionOdependencies)
                                 (_leftExpressionOexportedStructures)
                                 (_leftExpressionOexportedTypes)
                                 (_leftExpressionOexportedValues)
                                 (_leftExpressionOfunImps_collect)
                                 (_leftExpressionOgenericAbstractions)
                                 (_leftExpressionOgenericAbstractions_collect)
                                 (_leftExpressionOghc)
                                 (_leftExpressionOimportedModule)
                                 (_leftExpressionOinstancename)
                                 (_leftExpressionOkinames)
                                 (_leftExpressionOkindIndexedTypes)
                                 (_leftExpressionOkindIndexedTypes_collect)
                                 (_leftExpressionOkinds)
                                 (_leftExpressionOkindvar)
                                 (_leftExpressionOksubst)
                                 (_leftExpressionOlabels_collect)
                                 (_leftExpressionOlabels_dist)
                                 (_leftExpressionOlocal)
                                 (_leftExpressionOmethods_collect)
                                 (_leftExpressionOmethods_dist)
                                 (_leftExpressionOmodules)
                                 (_leftExpressionOoptimizer)
                                 (_leftExpressionOoptimizerPrelude)
                                 (_leftExpressionOprekind)
                                 (_leftExpressionOprelude)
                                 (_leftExpressionOpresignatures)
                                 (_leftExpressionOpresignatures_collect)
                                 (_leftExpressionOrawRequests_collect)
                                 (_leftExpressionOsignatures)
                                 (_leftExpressionOstructureTypes_collect)
                                 (_leftExpressionOtoplevel)
                                 (_leftExpressionOtypeImps_collect)
                                 (_leftExpressionOverbosity))
            ( _operatorIabstractTypes_collect
             ,_operatorIbimapImps_collect
             ,_operatorIconstructors_collect
             ,_operatorIdepConstraints_collect
             ,_operatorIfunImps_collect
             ,_operatorIgenericAbstractions_collect
             ,_operatorIkinames
             ,_operatorIkindIndexedTypes_collect
             ,_operatorIkind_errors
             ,_operatorIkindvar
             ,_operatorIksubst
             ,_operatorIlabels_collect
             ,_operatorImethods_collect
             ,_operatorIpresignatures_collect
             ,_operatorIrawRequests_collect
             ,_operatorIself
             ,_operatorIstaticErrors
             ,_operatorIstructureTypes_collect
             ,_operatorItypeImps_collect
             ) =
                (operator_ (_operatorOabstractTypes_collect)
                           (_operatorObimapImps_collect)
                           (_operatorOclassname)
                           (_operatorOconstructors_collect)
                           (_operatorOconstructors_dist)
                           (_operatorOcurrentModule)
                           (_operatorOdependencies)
                           (_operatorOexportedStructures)
                           (_operatorOexportedTypes)
                           (_operatorOexportedValues)
                           (_operatorOfunImps_collect)
                           (_operatorOgenericAbstractions)
                           (_operatorOgenericAbstractions_collect)
                           (_operatorOghc)
                           (_operatorOimportedModule)
                           (_operatorOinstancename)
                           (_operatorOkinames)
                           (_operatorOkindIndexedTypes)
                           (_operatorOkindIndexedTypes_collect)
                           (_operatorOkinds)
                           (_operatorOkindvar)
                           (_operatorOksubst)
                           (_operatorOlabels_collect)
                           (_operatorOlabels_dist)
                           (_operatorOlocal)
                           (_operatorOmethods_collect)
                           (_operatorOmethods_dist)
                           (_operatorOmodules)
                           (_operatorOoptimizer)
                           (_operatorOoptimizerPrelude)
                           (_operatorOprekind)
                           (_operatorOprelude)
                           (_operatorOpresignatures)
                           (_operatorOpresignatures_collect)
                           (_operatorOrawRequests_collect)
                           (_operatorOsignatures)
                           (_operatorOstructureTypes_collect)
                           (_operatorOtoplevel)
                           (_operatorOtypeImps_collect)
                           (_operatorOverbosity))
            ( _rightExpressionIabstractTypes_collect
             ,_rightExpressionIbimapImps_collect
             ,_rightExpressionIconstructors_collect
             ,_rightExpressionIdepConstraints_collect
             ,_rightExpressionIfunImps_collect
             ,_rightExpressionIgenericAbstractions_collect
             ,_rightExpressionIkinames
             ,_rightExpressionIkindIndexedTypes_collect
             ,_rightExpressionIkind_errors
             ,_rightExpressionIkindvar
             ,_rightExpressionIksubst
             ,_rightExpressionIlabels_collect
             ,_rightExpressionImethods_collect
             ,_rightExpressionIpresignatures_collect
             ,_rightExpressionIrawRequests_collect
             ,_rightExpressionIself
             ,_rightExpressionIstaticErrors
             ,_rightExpressionIstructureTypes_collect
             ,_rightExpressionItypeImps_collect
             ) =
                (rightExpression_ (_rightExpressionOabstractTypes_collect)
                                  (_rightExpressionObimapImps_collect)
                                  (_rightExpressionOclassname)
                                  (_rightExpressionOconstructors_collect)
                                  (_rightExpressionOconstructors_dist)
                                  (_rightExpressionOcurrentModule)
                                  (_rightExpressionOdependencies)
                                  (_rightExpressionOexportedStructures)
                                  (_rightExpressionOexportedTypes)
                                  (_rightExpressionOexportedValues)
                                  (_rightExpressionOfunImps_collect)
                                  (_rightExpressionOgenericAbstractions)
                                  (_rightExpressionOgenericAbstractions_collect)
                                  (_rightExpressionOghc)
                                  (_rightExpressionOimportedModule)
                                  (_rightExpressionOinstancename)
                                  (_rightExpressionOkinames)
                                  (_rightExpressionOkindIndexedTypes)
                                  (_rightExpressionOkindIndexedTypes_collect)
                                  (_rightExpressionOkinds)
                                  (_rightExpressionOkindvar)
                                  (_rightExpressionOksubst)
                                  (_rightExpressionOlabels_collect)
                                  (_rightExpressionOlabels_dist)
                                  (_rightExpressionOlocal)
                                  (_rightExpressionOmethods_collect)
                                  (_rightExpressionOmethods_dist)
                                  (_rightExpressionOmodules)
                                  (_rightExpressionOoptimizer)
                                  (_rightExpressionOoptimizerPrelude)
                                  (_rightExpressionOprekind)
                                  (_rightExpressionOprelude)
                                  (_rightExpressionOpresignatures)
                                  (_rightExpressionOpresignatures_collect)
                                  (_rightExpressionOrawRequests_collect)
                                  (_rightExpressionOsignatures)
                                  (_rightExpressionOstructureTypes_collect)
                                  (_rightExpressionOtoplevel)
                                  (_rightExpressionOtypeImps_collect)
                                  (_rightExpressionOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _leftExpressionIdepConstraints_collect ++ _operatorIdepConstraints_collect ++ _rightExpressionIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _leftExpressionIkind_errors ++ _operatorIkind_errors ++ _rightExpressionIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _leftExpressionIstaticErrors ++ _operatorIstaticErrors ++ _rightExpressionIstaticErrors
            -- self rule
            (_self@_) =
                Expression_InfixApplication _rangeIself _leftExpressionIself _operatorIself _rightExpressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _rightExpressionIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _rightExpressionIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _rightExpressionIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _rightExpressionIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _rightExpressionIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _rightExpressionIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _rightExpressionIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _rightExpressionIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _rightExpressionIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _rightExpressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _rightExpressionImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _rightExpressionIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _rightExpressionIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _rightExpressionIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _rightExpressionItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_leftExpressionOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_leftExpressionObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_leftExpressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_leftExpressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_leftExpressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_leftExpressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_leftExpressionOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_leftExpressionOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_leftExpressionOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_leftExpressionOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_leftExpressionOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_leftExpressionOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_leftExpressionOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_leftExpressionOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_leftExpressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_leftExpressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_leftExpressionOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_leftExpressionOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_leftExpressionOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_leftExpressionOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_leftExpressionOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_leftExpressionOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_leftExpressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_leftExpressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_leftExpressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_leftExpressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_leftExpressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_leftExpressionOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_leftExpressionOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_leftExpressionOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_leftExpressionOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_leftExpressionOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_leftExpressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_leftExpressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_leftExpressionOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_leftExpressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_leftExpressionOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_leftExpressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_leftExpressionOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_leftExpressionOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_operatorOabstractTypes_collect@_) =
                _leftExpressionIabstractTypes_collect
            -- copy rule (chain)
            (_operatorObimapImps_collect@_) =
                _leftExpressionIbimapImps_collect
            -- copy rule (down)
            (_operatorOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_operatorOconstructors_collect@_) =
                _leftExpressionIconstructors_collect
            -- copy rule (down)
            (_operatorOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_operatorOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_operatorOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_operatorOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_operatorOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_operatorOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (chain)
            (_operatorOfunImps_collect@_) =
                _leftExpressionIfunImps_collect
            -- copy rule (down)
            (_operatorOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_operatorOgenericAbstractions_collect@_) =
                _leftExpressionIgenericAbstractions_collect
            -- copy rule (down)
            (_operatorOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_operatorOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_operatorOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_operatorOkinames@_) =
                _leftExpressionIkinames
            -- copy rule (down)
            (_operatorOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (chain)
            (_operatorOkindIndexedTypes_collect@_) =
                _leftExpressionIkindIndexedTypes_collect
            -- copy rule (down)
            (_operatorOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_operatorOkindvar@_) =
                _leftExpressionIkindvar
            -- copy rule (chain)
            (_operatorOksubst@_) =
                _leftExpressionIksubst
            -- copy rule (chain)
            (_operatorOlabels_collect@_) =
                _leftExpressionIlabels_collect
            -- copy rule (down)
            (_operatorOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_operatorOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_operatorOmethods_collect@_) =
                _leftExpressionImethods_collect
            -- copy rule (down)
            (_operatorOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_operatorOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_operatorOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_operatorOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_operatorOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_operatorOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_operatorOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_operatorOpresignatures_collect@_) =
                _leftExpressionIpresignatures_collect
            -- copy rule (chain)
            (_operatorOrawRequests_collect@_) =
                _leftExpressionIrawRequests_collect
            -- copy rule (down)
            (_operatorOsignatures@_) =
                _lhsIsignatures
            -- copy rule (chain)
            (_operatorOstructureTypes_collect@_) =
                _leftExpressionIstructureTypes_collect
            -- copy rule (down)
            (_operatorOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_operatorOtypeImps_collect@_) =
                _leftExpressionItypeImps_collect
            -- copy rule (down)
            (_operatorOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_rightExpressionOabstractTypes_collect@_) =
                _operatorIabstractTypes_collect
            -- copy rule (chain)
            (_rightExpressionObimapImps_collect@_) =
                _operatorIbimapImps_collect
            -- copy rule (down)
            (_rightExpressionOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_rightExpressionOconstructors_collect@_) =
                _operatorIconstructors_collect
            -- copy rule (down)
            (_rightExpressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_rightExpressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rightExpressionOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_rightExpressionOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_rightExpressionOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_rightExpressionOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (chain)
            (_rightExpressionOfunImps_collect@_) =
                _operatorIfunImps_collect
            -- copy rule (down)
            (_rightExpressionOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_rightExpressionOgenericAbstractions_collect@_) =
                _operatorIgenericAbstractions_collect
            -- copy rule (down)
            (_rightExpressionOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_rightExpressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rightExpressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_rightExpressionOkinames@_) =
                _operatorIkinames
            -- copy rule (down)
            (_rightExpressionOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (chain)
            (_rightExpressionOkindIndexedTypes_collect@_) =
                _operatorIkindIndexedTypes_collect
            -- copy rule (down)
            (_rightExpressionOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_rightExpressionOkindvar@_) =
                _operatorIkindvar
            -- copy rule (chain)
            (_rightExpressionOksubst@_) =
                _operatorIksubst
            -- copy rule (chain)
            (_rightExpressionOlabels_collect@_) =
                _operatorIlabels_collect
            -- copy rule (down)
            (_rightExpressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_rightExpressionOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_rightExpressionOmethods_collect@_) =
                _operatorImethods_collect
            -- copy rule (down)
            (_rightExpressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_rightExpressionOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_rightExpressionOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_rightExpressionOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_rightExpressionOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_rightExpressionOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_rightExpressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_rightExpressionOpresignatures_collect@_) =
                _operatorIpresignatures_collect
            -- copy rule (chain)
            (_rightExpressionOrawRequests_collect@_) =
                _operatorIrawRequests_collect
            -- copy rule (down)
            (_rightExpressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (chain)
            (_rightExpressionOstructureTypes_collect@_) =
                _operatorIstructureTypes_collect
            -- copy rule (down)
            (_rightExpressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_rightExpressionOtypeImps_collect@_) =
                _operatorItypeImps_collect
            -- copy rule (down)
            (_rightExpressionOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Expression_Irrefutable :: (T_Range) ->
                              (T_Expression) ->
                              (T_Expression)
sem_Expression_Irrefutable (range_) (expression_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Expression)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionIabstractTypes_collect :: (Set Name)
            _expressionIbimapImps_collect :: ([Request_BimapImply])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdepConstraints_collect :: ([DepConstraint])
            _expressionIfunImps_collect :: ([Request_FunImply])
            _expressionIgenericAbstractions_collect :: (FMap Name Kind)
            _expressionIkinames :: (KSubst)
            _expressionIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionIkind_errors :: ([GHError])
            _expressionIkindvar :: (Int)
            _expressionIksubst :: (KSubst)
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIrawRequests_collect :: ([RawRequest])
            _expressionIself :: (Expression)
            _expressionIstaticErrors :: ([GHError])
            _expressionIstructureTypes_collect :: (FMap Name LambdaType)
            _expressionItypeImps_collect :: ([Request_TypeImply])
            _expressionOabstractTypes_collect :: (Set Name)
            _expressionObimapImps_collect :: ([Request_BimapImply])
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies :: (FMap Name [(Name,Name)])
            _expressionOexportedStructures :: (Set Name)
            _expressionOexportedTypes :: (Set Name)
            _expressionOexportedValues :: (Set Name)
            _expressionOfunImps_collect :: ([Request_FunImply])
            _expressionOgenericAbstractions :: (FMap Name Kind)
            _expressionOgenericAbstractions_collect :: (FMap Name Kind)
            _expressionOghc :: (Bool)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOkinames :: (KSubst)
            _expressionOkindIndexedTypes :: (FMap Name KindIndexedType)
            _expressionOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionOkinds :: (KSubst)
            _expressionOkindvar :: (Int)
            _expressionOksubst :: (KSubst)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmodules :: (Set Strings)
            _expressionOoptimizer :: (Bool)
            _expressionOoptimizerPrelude :: (Declarations)
            _expressionOprekind :: (KSubst)
            _expressionOprelude :: (Bool)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOrawRequests_collect :: ([RawRequest])
            _expressionOsignatures :: (Signatures)
            _expressionOstructureTypes_collect :: (FMap Name LambdaType)
            _expressionOtoplevel :: (Bool)
            _expressionOtypeImps_collect :: ([Request_TypeImply])
            _expressionOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionIabstractTypes_collect
             ,_expressionIbimapImps_collect
             ,_expressionIconstructors_collect
             ,_expressionIdepConstraints_collect
             ,_expressionIfunImps_collect
             ,_expressionIgenericAbstractions_collect
             ,_expressionIkinames
             ,_expressionIkindIndexedTypes_collect
             ,_expressionIkind_errors
             ,_expressionIkindvar
             ,_expressionIksubst
             ,_expressionIlabels_collect
             ,_expressionImethods_collect
             ,_expressionIpresignatures_collect
             ,_expressionIrawRequests_collect
             ,_expressionIself
             ,_expressionIstaticErrors
             ,_expressionIstructureTypes_collect
             ,_expressionItypeImps_collect
             ) =
                (expression_ (_expressionOabstractTypes_collect)
                             (_expressionObimapImps_collect)
                             (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies)
                             (_expressionOexportedStructures)
                             (_expressionOexportedTypes)
                             (_expressionOexportedValues)
                             (_expressionOfunImps_collect)
                             (_expressionOgenericAbstractions)
                             (_expressionOgenericAbstractions_collect)
                             (_expressionOghc)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOkinames)
                             (_expressionOkindIndexedTypes)
                             (_expressionOkindIndexedTypes_collect)
                             (_expressionOkinds)
                             (_expressionOkindvar)
                             (_expressionOksubst)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmodules)
                             (_expressionOoptimizer)
                             (_expressionOoptimizerPrelude)
                             (_expressionOprekind)
                             (_expressionOprelude)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOrawRequests_collect)
                             (_expressionOsignatures)
                             (_expressionOstructureTypes_collect)
                             (_expressionOtoplevel)
                             (_expressionOtypeImps_collect)
                             (_expressionOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _expressionIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _expressionIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _expressionIstaticErrors
            -- self rule
            (_self@_) =
                Expression_Irrefutable _rangeIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _expressionIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _expressionIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _expressionIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _expressionIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _expressionIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _expressionIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _expressionIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _expressionIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _expressionIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _expressionIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _expressionItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_expressionObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_expressionOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_expressionOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_expressionOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_expressionOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_expressionOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_expressionOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_expressionOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_expressionOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_expressionOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_expressionOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_expressionOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_expressionOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_expressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_expressionOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_expressionOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_expressionOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_expressionOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_expressionOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Expression_Lambda :: (T_Range) ->
                         (T_Patterns) ->
                         (T_Expression) ->
                         (T_Expression)
sem_Expression_Lambda (range_) (patterns_) (expression_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Expression)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _patternsIconstructors_collect :: (FMap Name Names)
            _patternsIgenericAbstractions_collect :: (FMap Name Kind)
            _patternsIlabels_collect :: (FMap Name Names)
            _patternsImethods_collect :: (FMap Name Names)
            _patternsIself :: (Patterns)
            _patternsOclassname :: (Maybe Name)
            _patternsOconstructors_collect :: (FMap Name Names)
            _patternsOconstructors_dist :: (FMap Name Names)
            _patternsOcurrentModule :: (Strings)
            _patternsOgenericAbstractions :: (FMap Name Kind)
            _patternsOgenericAbstractions_collect :: (FMap Name Kind)
            _patternsOghc :: (Bool)
            _patternsOimportedModule :: (Bool)
            _patternsOinstancename :: (Maybe Name)
            _patternsOlabels_collect :: (FMap Name Names)
            _patternsOlabels_dist :: (FMap Name Names)
            _patternsOlocal :: (Bool)
            _patternsOmethods_collect :: (FMap Name Names)
            _patternsOmethods_dist :: (FMap Name Names)
            _patternsOmodules :: (Set Strings)
            _patternsOoptimizer :: (Bool)
            _patternsOoptimizerPrelude :: (Declarations)
            _patternsOprelude :: (Bool)
            _patternsOtoplevel :: (Bool)
            _patternsOverbosity :: (Int)
            _expressionIabstractTypes_collect :: (Set Name)
            _expressionIbimapImps_collect :: ([Request_BimapImply])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdepConstraints_collect :: ([DepConstraint])
            _expressionIfunImps_collect :: ([Request_FunImply])
            _expressionIgenericAbstractions_collect :: (FMap Name Kind)
            _expressionIkinames :: (KSubst)
            _expressionIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionIkind_errors :: ([GHError])
            _expressionIkindvar :: (Int)
            _expressionIksubst :: (KSubst)
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIrawRequests_collect :: ([RawRequest])
            _expressionIself :: (Expression)
            _expressionIstaticErrors :: ([GHError])
            _expressionIstructureTypes_collect :: (FMap Name LambdaType)
            _expressionItypeImps_collect :: ([Request_TypeImply])
            _expressionOabstractTypes_collect :: (Set Name)
            _expressionObimapImps_collect :: ([Request_BimapImply])
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies :: (FMap Name [(Name,Name)])
            _expressionOexportedStructures :: (Set Name)
            _expressionOexportedTypes :: (Set Name)
            _expressionOexportedValues :: (Set Name)
            _expressionOfunImps_collect :: ([Request_FunImply])
            _expressionOgenericAbstractions :: (FMap Name Kind)
            _expressionOgenericAbstractions_collect :: (FMap Name Kind)
            _expressionOghc :: (Bool)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOkinames :: (KSubst)
            _expressionOkindIndexedTypes :: (FMap Name KindIndexedType)
            _expressionOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionOkinds :: (KSubst)
            _expressionOkindvar :: (Int)
            _expressionOksubst :: (KSubst)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmodules :: (Set Strings)
            _expressionOoptimizer :: (Bool)
            _expressionOoptimizerPrelude :: (Declarations)
            _expressionOprekind :: (KSubst)
            _expressionOprelude :: (Bool)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOrawRequests_collect :: ([RawRequest])
            _expressionOsignatures :: (Signatures)
            _expressionOstructureTypes_collect :: (FMap Name LambdaType)
            _expressionOtoplevel :: (Bool)
            _expressionOtypeImps_collect :: ([Request_TypeImply])
            _expressionOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _patternsIconstructors_collect,_patternsIgenericAbstractions_collect,_patternsIlabels_collect,_patternsImethods_collect,_patternsIself) =
                (patterns_ (_patternsOclassname)
                           (_patternsOconstructors_collect)
                           (_patternsOconstructors_dist)
                           (_patternsOcurrentModule)
                           (_patternsOgenericAbstractions)
                           (_patternsOgenericAbstractions_collect)
                           (_patternsOghc)
                           (_patternsOimportedModule)
                           (_patternsOinstancename)
                           (_patternsOlabels_collect)
                           (_patternsOlabels_dist)
                           (_patternsOlocal)
                           (_patternsOmethods_collect)
                           (_patternsOmethods_dist)
                           (_patternsOmodules)
                           (_patternsOoptimizer)
                           (_patternsOoptimizerPrelude)
                           (_patternsOprelude)
                           (_patternsOtoplevel)
                           (_patternsOverbosity))
            ( _expressionIabstractTypes_collect
             ,_expressionIbimapImps_collect
             ,_expressionIconstructors_collect
             ,_expressionIdepConstraints_collect
             ,_expressionIfunImps_collect
             ,_expressionIgenericAbstractions_collect
             ,_expressionIkinames
             ,_expressionIkindIndexedTypes_collect
             ,_expressionIkind_errors
             ,_expressionIkindvar
             ,_expressionIksubst
             ,_expressionIlabels_collect
             ,_expressionImethods_collect
             ,_expressionIpresignatures_collect
             ,_expressionIrawRequests_collect
             ,_expressionIself
             ,_expressionIstaticErrors
             ,_expressionIstructureTypes_collect
             ,_expressionItypeImps_collect
             ) =
                (expression_ (_expressionOabstractTypes_collect)
                             (_expressionObimapImps_collect)
                             (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies)
                             (_expressionOexportedStructures)
                             (_expressionOexportedTypes)
                             (_expressionOexportedValues)
                             (_expressionOfunImps_collect)
                             (_expressionOgenericAbstractions)
                             (_expressionOgenericAbstractions_collect)
                             (_expressionOghc)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOkinames)
                             (_expressionOkindIndexedTypes)
                             (_expressionOkindIndexedTypes_collect)
                             (_expressionOkinds)
                             (_expressionOkindvar)
                             (_expressionOksubst)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmodules)
                             (_expressionOoptimizer)
                             (_expressionOoptimizerPrelude)
                             (_expressionOprekind)
                             (_expressionOprelude)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOrawRequests_collect)
                             (_expressionOsignatures)
                             (_expressionOstructureTypes_collect)
                             (_expressionOtoplevel)
                             (_expressionOtypeImps_collect)
                             (_expressionOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _expressionIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _expressionIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _expressionIstaticErrors
            -- self rule
            (_self@_) =
                Expression_Lambda _rangeIself _patternsIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _expressionIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _expressionIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _expressionIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _expressionIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _expressionIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _expressionIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _expressionIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _expressionIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _expressionIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _expressionIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _expressionItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_patternsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_patternsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_patternsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_patternsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_patternsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_patternsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_patternsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_patternsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_patternsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_patternsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_patternsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_patternsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternsOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_expressionOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_expressionObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_expressionOconstructors_collect@_) =
                _patternsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_expressionOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_expressionOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_expressionOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_expressionOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_expressionOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_expressionOgenericAbstractions_collect@_) =
                _patternsIgenericAbstractions_collect
            -- copy rule (down)
            (_expressionOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_expressionOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_expressionOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_expressionOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_expressionOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_expressionOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_expressionOlabels_collect@_) =
                _patternsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_expressionOmethods_collect@_) =
                _patternsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_expressionOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_expressionOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_expressionOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_expressionOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_expressionOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Expression_Let :: (T_Range) ->
                      (T_Declarations) ->
                      (T_Expression) ->
                      (T_Expression)
sem_Expression_Let (range_) (declarations_) (expression_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Expression)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _declarationsIabstractTypes_collect :: (Set Name)
            _declarationsIbimapImps_collect :: ([Request_BimapImply])
            _declarationsIconstructors_collect :: (FMap Name Names)
            _declarationsIdepConstraints_collect :: ([DepConstraint])
            _declarationsIdepConstraints_defined :: ([DepConstraint])
            _declarationsIexportedDeclarations :: (Declarations)
            _declarationsIfunImps_collect :: ([Request_FunImply])
            _declarationsIgenericAbstractions_collect :: (FMap Name Kind)
            _declarationsIkinames :: (KSubst)
            _declarationsIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _declarationsIkind_errors :: ([GHError])
            _declarationsIkindvar :: (Int)
            _declarationsIksubst :: (KSubst)
            _declarationsIlabels_collect :: (FMap Name Names)
            _declarationsImethods_collect :: (FMap Name Names)
            _declarationsIoutput :: ([PP.Doc])
            _declarationsIoutputi :: ([PP.Doc])
            _declarationsIpresignatures_collect :: (PreSignatures)
            _declarationsIrawRequests_collect :: ([RawRequest])
            _declarationsIself :: (Declarations)
            _declarationsIstaticErrors :: ([GHError])
            _declarationsIstructureTypes_collect :: (FMap Name LambdaType)
            _declarationsItypeImps_collect :: ([Request_TypeImply])
            _declarationsOabstractTypes_collect :: (Set Name)
            _declarationsObimapImps_collect :: ([Request_BimapImply])
            _declarationsOclassname :: (Maybe Name)
            _declarationsOconstructors_collect :: (FMap Name Names)
            _declarationsOconstructors_dist :: (FMap Name Names)
            _declarationsOcurrentModule :: (Strings)
            _declarationsOdependencies :: (FMap Name [(Name,Name)])
            _declarationsOexportedStructures :: (Set Name)
            _declarationsOexportedTypes :: (Set Name)
            _declarationsOexportedValues :: (Set Name)
            _declarationsOfunImps_collect :: ([Request_FunImply])
            _declarationsOgenericAbstractions :: (FMap Name Kind)
            _declarationsOgenericAbstractions_collect :: (FMap Name Kind)
            _declarationsOghc :: (Bool)
            _declarationsOimportedModule :: (Bool)
            _declarationsOinstancename :: (Maybe Name)
            _declarationsOkinames :: (KSubst)
            _declarationsOkindIndexedTypes :: (FMap Name KindIndexedType)
            _declarationsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _declarationsOkinds :: (KSubst)
            _declarationsOkindvar :: (Int)
            _declarationsOksubst :: (KSubst)
            _declarationsOlabels_collect :: (FMap Name Names)
            _declarationsOlabels_dist :: (FMap Name Names)
            _declarationsOlocal :: (Bool)
            _declarationsOmethods_collect :: (FMap Name Names)
            _declarationsOmethods_dist :: (FMap Name Names)
            _declarationsOmodules :: (Set Strings)
            _declarationsOoptimizer :: (Bool)
            _declarationsOoptimizerPrelude :: (Declarations)
            _declarationsOoutput :: ([PP.Doc])
            _declarationsOprekind :: (KSubst)
            _declarationsOprelude :: (Bool)
            _declarationsOpresignatures :: (PreSignatures)
            _declarationsOpresignatures_collect :: (PreSignatures)
            _declarationsOrawRequests_collect :: ([RawRequest])
            _declarationsOsignatures :: (Signatures)
            _declarationsOstructureTypes_collect :: (FMap Name LambdaType)
            _declarationsOtoplevel :: (Bool)
            _declarationsOtypeImps_collect :: ([Request_TypeImply])
            _declarationsOverbosity :: (Int)
            _expressionIabstractTypes_collect :: (Set Name)
            _expressionIbimapImps_collect :: ([Request_BimapImply])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdepConstraints_collect :: ([DepConstraint])
            _expressionIfunImps_collect :: ([Request_FunImply])
            _expressionIgenericAbstractions_collect :: (FMap Name Kind)
            _expressionIkinames :: (KSubst)
            _expressionIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionIkind_errors :: ([GHError])
            _expressionIkindvar :: (Int)
            _expressionIksubst :: (KSubst)
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIrawRequests_collect :: ([RawRequest])
            _expressionIself :: (Expression)
            _expressionIstaticErrors :: ([GHError])
            _expressionIstructureTypes_collect :: (FMap Name LambdaType)
            _expressionItypeImps_collect :: ([Request_TypeImply])
            _expressionOabstractTypes_collect :: (Set Name)
            _expressionObimapImps_collect :: ([Request_BimapImply])
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies :: (FMap Name [(Name,Name)])
            _expressionOexportedStructures :: (Set Name)
            _expressionOexportedTypes :: (Set Name)
            _expressionOexportedValues :: (Set Name)
            _expressionOfunImps_collect :: ([Request_FunImply])
            _expressionOgenericAbstractions :: (FMap Name Kind)
            _expressionOgenericAbstractions_collect :: (FMap Name Kind)
            _expressionOghc :: (Bool)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOkinames :: (KSubst)
            _expressionOkindIndexedTypes :: (FMap Name KindIndexedType)
            _expressionOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionOkinds :: (KSubst)
            _expressionOkindvar :: (Int)
            _expressionOksubst :: (KSubst)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmodules :: (Set Strings)
            _expressionOoptimizer :: (Bool)
            _expressionOoptimizerPrelude :: (Declarations)
            _expressionOprekind :: (KSubst)
            _expressionOprelude :: (Bool)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOrawRequests_collect :: ([RawRequest])
            _expressionOsignatures :: (Signatures)
            _expressionOstructureTypes_collect :: (FMap Name LambdaType)
            _expressionOtoplevel :: (Bool)
            _expressionOtypeImps_collect :: ([Request_TypeImply])
            _expressionOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _declarationsIabstractTypes_collect
             ,_declarationsIbimapImps_collect
             ,_declarationsIconstructors_collect
             ,_declarationsIdepConstraints_collect
             ,_declarationsIdepConstraints_defined
             ,_declarationsIexportedDeclarations
             ,_declarationsIfunImps_collect
             ,_declarationsIgenericAbstractions_collect
             ,_declarationsIkinames
             ,_declarationsIkindIndexedTypes_collect
             ,_declarationsIkind_errors
             ,_declarationsIkindvar
             ,_declarationsIksubst
             ,_declarationsIlabels_collect
             ,_declarationsImethods_collect
             ,_declarationsIoutput
             ,_declarationsIoutputi
             ,_declarationsIpresignatures_collect
             ,_declarationsIrawRequests_collect
             ,_declarationsIself
             ,_declarationsIstaticErrors
             ,_declarationsIstructureTypes_collect
             ,_declarationsItypeImps_collect
             ) =
                (declarations_ (_declarationsOabstractTypes_collect)
                               (_declarationsObimapImps_collect)
                               (_declarationsOclassname)
                               (_declarationsOconstructors_collect)
                               (_declarationsOconstructors_dist)
                               (_declarationsOcurrentModule)
                               (_declarationsOdependencies)
                               (_declarationsOexportedStructures)
                               (_declarationsOexportedTypes)
                               (_declarationsOexportedValues)
                               (_declarationsOfunImps_collect)
                               (_declarationsOgenericAbstractions)
                               (_declarationsOgenericAbstractions_collect)
                               (_declarationsOghc)
                               (_declarationsOimportedModule)
                               (_declarationsOinstancename)
                               (_declarationsOkinames)
                               (_declarationsOkindIndexedTypes)
                               (_declarationsOkindIndexedTypes_collect)
                               (_declarationsOkinds)
                               (_declarationsOkindvar)
                               (_declarationsOksubst)
                               (_declarationsOlabels_collect)
                               (_declarationsOlabels_dist)
                               (_declarationsOlocal)
                               (_declarationsOmethods_collect)
                               (_declarationsOmethods_dist)
                               (_declarationsOmodules)
                               (_declarationsOoptimizer)
                               (_declarationsOoptimizerPrelude)
                               (_declarationsOoutput)
                               (_declarationsOprekind)
                               (_declarationsOprelude)
                               (_declarationsOpresignatures)
                               (_declarationsOpresignatures_collect)
                               (_declarationsOrawRequests_collect)
                               (_declarationsOsignatures)
                               (_declarationsOstructureTypes_collect)
                               (_declarationsOtoplevel)
                               (_declarationsOtypeImps_collect)
                               (_declarationsOverbosity))
            ( _expressionIabstractTypes_collect
             ,_expressionIbimapImps_collect
             ,_expressionIconstructors_collect
             ,_expressionIdepConstraints_collect
             ,_expressionIfunImps_collect
             ,_expressionIgenericAbstractions_collect
             ,_expressionIkinames
             ,_expressionIkindIndexedTypes_collect
             ,_expressionIkind_errors
             ,_expressionIkindvar
             ,_expressionIksubst
             ,_expressionIlabels_collect
             ,_expressionImethods_collect
             ,_expressionIpresignatures_collect
             ,_expressionIrawRequests_collect
             ,_expressionIself
             ,_expressionIstaticErrors
             ,_expressionIstructureTypes_collect
             ,_expressionItypeImps_collect
             ) =
                (expression_ (_expressionOabstractTypes_collect)
                             (_expressionObimapImps_collect)
                             (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies)
                             (_expressionOexportedStructures)
                             (_expressionOexportedTypes)
                             (_expressionOexportedValues)
                             (_expressionOfunImps_collect)
                             (_expressionOgenericAbstractions)
                             (_expressionOgenericAbstractions_collect)
                             (_expressionOghc)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOkinames)
                             (_expressionOkindIndexedTypes)
                             (_expressionOkindIndexedTypes_collect)
                             (_expressionOkinds)
                             (_expressionOkindvar)
                             (_expressionOksubst)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmodules)
                             (_expressionOoptimizer)
                             (_expressionOoptimizerPrelude)
                             (_expressionOprekind)
                             (_expressionOprelude)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOrawRequests_collect)
                             (_expressionOsignatures)
                             (_expressionOstructureTypes_collect)
                             (_expressionOtoplevel)
                             (_expressionOtypeImps_collect)
                             (_expressionOverbosity))
            -- "./Output.inc.lag"(line 390, column 9)
            (_declarationsOoutput@_) =
                []
            -- "./Request.inc.lag"(line 338, column 9)
            (_lhsOdepConstraints_collect@_) =
                filter
                  (\d -> not (d `elem` _declarationsIdepConstraints_defined))
                  _expressionIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _declarationsIkind_errors ++ _expressionIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _declarationsIstaticErrors ++ _expressionIstaticErrors
            -- self rule
            (_self@_) =
                Expression_Let _rangeIself _declarationsIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _expressionIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _expressionIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _expressionIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _expressionIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _expressionIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _expressionIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _expressionIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _expressionIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _expressionIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _expressionIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _expressionItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_declarationsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_declarationsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_declarationsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_declarationsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_declarationsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_declarationsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_declarationsOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_declarationsOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_declarationsOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_declarationsOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_declarationsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_declarationsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_declarationsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_declarationsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_declarationsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_declarationsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_declarationsOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_declarationsOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_declarationsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_declarationsOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_declarationsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_declarationsOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_declarationsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_declarationsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_declarationsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_declarationsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_declarationsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_declarationsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_declarationsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_declarationsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_declarationsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_declarationsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_declarationsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_declarationsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_declarationsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_declarationsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_declarationsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_declarationsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_declarationsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_declarationsOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_expressionOabstractTypes_collect@_) =
                _declarationsIabstractTypes_collect
            -- copy rule (chain)
            (_expressionObimapImps_collect@_) =
                _declarationsIbimapImps_collect
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_expressionOconstructors_collect@_) =
                _declarationsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_expressionOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_expressionOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_expressionOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (chain)
            (_expressionOfunImps_collect@_) =
                _declarationsIfunImps_collect
            -- copy rule (down)
            (_expressionOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_expressionOgenericAbstractions_collect@_) =
                _declarationsIgenericAbstractions_collect
            -- copy rule (down)
            (_expressionOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_expressionOkinames@_) =
                _declarationsIkinames
            -- copy rule (down)
            (_expressionOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (chain)
            (_expressionOkindIndexedTypes_collect@_) =
                _declarationsIkindIndexedTypes_collect
            -- copy rule (down)
            (_expressionOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_expressionOkindvar@_) =
                _declarationsIkindvar
            -- copy rule (chain)
            (_expressionOksubst@_) =
                _declarationsIksubst
            -- copy rule (chain)
            (_expressionOlabels_collect@_) =
                _declarationsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_expressionOmethods_collect@_) =
                _declarationsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_expressionOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_expressionOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_expressionOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_expressionOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_expressionOpresignatures_collect@_) =
                _declarationsIpresignatures_collect
            -- copy rule (chain)
            (_expressionOrawRequests_collect@_) =
                _declarationsIrawRequests_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (chain)
            (_expressionOstructureTypes_collect@_) =
                _declarationsIstructureTypes_collect
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_expressionOtypeImps_collect@_) =
                _declarationsItypeImps_collect
            -- copy rule (down)
            (_expressionOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Expression_List :: (T_Range) ->
                       (T_Expressions) ->
                       (T_Expression)
sem_Expression_List (range_) (expressions_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Expression)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionsIabstractTypes_collect :: (Set Name)
            _expressionsIbimapImps_collect :: ([Request_BimapImply])
            _expressionsIconstructors_collect :: (FMap Name Names)
            _expressionsIdepConstraints_collect :: ([DepConstraint])
            _expressionsIfunImps_collect :: ([Request_FunImply])
            _expressionsIgenericAbstractions_collect :: (FMap Name Kind)
            _expressionsIkinames :: (KSubst)
            _expressionsIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionsIkind_errors :: ([GHError])
            _expressionsIkindvar :: (Int)
            _expressionsIksubst :: (KSubst)
            _expressionsIlabels_collect :: (FMap Name Names)
            _expressionsImethods_collect :: (FMap Name Names)
            _expressionsIpresignatures_collect :: (PreSignatures)
            _expressionsIrawRequests_collect :: ([RawRequest])
            _expressionsIself :: (Expressions)
            _expressionsIstaticErrors :: ([GHError])
            _expressionsIstructureTypes_collect :: (FMap Name LambdaType)
            _expressionsItypeImps_collect :: ([Request_TypeImply])
            _expressionsOabstractTypes_collect :: (Set Name)
            _expressionsObimapImps_collect :: ([Request_BimapImply])
            _expressionsOclassname :: (Maybe Name)
            _expressionsOconstructors_collect :: (FMap Name Names)
            _expressionsOconstructors_dist :: (FMap Name Names)
            _expressionsOcurrentModule :: (Strings)
            _expressionsOdependencies :: (FMap Name [(Name,Name)])
            _expressionsOexportedStructures :: (Set Name)
            _expressionsOexportedTypes :: (Set Name)
            _expressionsOexportedValues :: (Set Name)
            _expressionsOfunImps_collect :: ([Request_FunImply])
            _expressionsOgenericAbstractions :: (FMap Name Kind)
            _expressionsOgenericAbstractions_collect :: (FMap Name Kind)
            _expressionsOghc :: (Bool)
            _expressionsOimportedModule :: (Bool)
            _expressionsOinstancename :: (Maybe Name)
            _expressionsOkinames :: (KSubst)
            _expressionsOkindIndexedTypes :: (FMap Name KindIndexedType)
            _expressionsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionsOkinds :: (KSubst)
            _expressionsOkindvar :: (Int)
            _expressionsOksubst :: (KSubst)
            _expressionsOlabels_collect :: (FMap Name Names)
            _expressionsOlabels_dist :: (FMap Name Names)
            _expressionsOlocal :: (Bool)
            _expressionsOmethods_collect :: (FMap Name Names)
            _expressionsOmethods_dist :: (FMap Name Names)
            _expressionsOmodules :: (Set Strings)
            _expressionsOoptimizer :: (Bool)
            _expressionsOoptimizerPrelude :: (Declarations)
            _expressionsOprekind :: (KSubst)
            _expressionsOprelude :: (Bool)
            _expressionsOpresignatures :: (PreSignatures)
            _expressionsOpresignatures_collect :: (PreSignatures)
            _expressionsOrawRequests_collect :: ([RawRequest])
            _expressionsOsignatures :: (Signatures)
            _expressionsOstructureTypes_collect :: (FMap Name LambdaType)
            _expressionsOtoplevel :: (Bool)
            _expressionsOtypeImps_collect :: ([Request_TypeImply])
            _expressionsOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionsIabstractTypes_collect
             ,_expressionsIbimapImps_collect
             ,_expressionsIconstructors_collect
             ,_expressionsIdepConstraints_collect
             ,_expressionsIfunImps_collect
             ,_expressionsIgenericAbstractions_collect
             ,_expressionsIkinames
             ,_expressionsIkindIndexedTypes_collect
             ,_expressionsIkind_errors
             ,_expressionsIkindvar
             ,_expressionsIksubst
             ,_expressionsIlabels_collect
             ,_expressionsImethods_collect
             ,_expressionsIpresignatures_collect
             ,_expressionsIrawRequests_collect
             ,_expressionsIself
             ,_expressionsIstaticErrors
             ,_expressionsIstructureTypes_collect
             ,_expressionsItypeImps_collect
             ) =
                (expressions_ (_expressionsOabstractTypes_collect)
                              (_expressionsObimapImps_collect)
                              (_expressionsOclassname)
                              (_expressionsOconstructors_collect)
                              (_expressionsOconstructors_dist)
                              (_expressionsOcurrentModule)
                              (_expressionsOdependencies)
                              (_expressionsOexportedStructures)
                              (_expressionsOexportedTypes)
                              (_expressionsOexportedValues)
                              (_expressionsOfunImps_collect)
                              (_expressionsOgenericAbstractions)
                              (_expressionsOgenericAbstractions_collect)
                              (_expressionsOghc)
                              (_expressionsOimportedModule)
                              (_expressionsOinstancename)
                              (_expressionsOkinames)
                              (_expressionsOkindIndexedTypes)
                              (_expressionsOkindIndexedTypes_collect)
                              (_expressionsOkinds)
                              (_expressionsOkindvar)
                              (_expressionsOksubst)
                              (_expressionsOlabels_collect)
                              (_expressionsOlabels_dist)
                              (_expressionsOlocal)
                              (_expressionsOmethods_collect)
                              (_expressionsOmethods_dist)
                              (_expressionsOmodules)
                              (_expressionsOoptimizer)
                              (_expressionsOoptimizerPrelude)
                              (_expressionsOprekind)
                              (_expressionsOprelude)
                              (_expressionsOpresignatures)
                              (_expressionsOpresignatures_collect)
                              (_expressionsOrawRequests_collect)
                              (_expressionsOsignatures)
                              (_expressionsOstructureTypes_collect)
                              (_expressionsOtoplevel)
                              (_expressionsOtypeImps_collect)
                              (_expressionsOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _expressionsIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _expressionsIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _expressionsIstaticErrors
            -- self rule
            (_self@_) =
                Expression_List _rangeIself _expressionsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _expressionsIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _expressionsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionsIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _expressionsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _expressionsIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _expressionsIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _expressionsIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _expressionsIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _expressionsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionsImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _expressionsIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _expressionsIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _expressionsIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _expressionsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_expressionsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_expressionsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionsOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_expressionsOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_expressionsOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_expressionsOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_expressionsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_expressionsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_expressionsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_expressionsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_expressionsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionsOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_expressionsOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_expressionsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_expressionsOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_expressionsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_expressionsOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_expressionsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_expressionsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_expressionsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_expressionsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_expressionsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_expressionsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_expressionsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_expressionsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_expressionsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Expression_Literal :: (T_Range) ->
                          (T_Literal) ->
                          (T_Expression)
sem_Expression_Literal (range_) (literal_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Expression)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _literalIconstructors_collect :: (FMap Name Names)
            _literalIgenericAbstractions_collect :: (FMap Name Kind)
            _literalIlabels_collect :: (FMap Name Names)
            _literalImethods_collect :: (FMap Name Names)
            _literalIself :: (Literal)
            _literalOclassname :: (Maybe Name)
            _literalOconstructors_collect :: (FMap Name Names)
            _literalOconstructors_dist :: (FMap Name Names)
            _literalOcurrentModule :: (Strings)
            _literalOgenericAbstractions :: (FMap Name Kind)
            _literalOgenericAbstractions_collect :: (FMap Name Kind)
            _literalOghc :: (Bool)
            _literalOimportedModule :: (Bool)
            _literalOinstancename :: (Maybe Name)
            _literalOlabels_collect :: (FMap Name Names)
            _literalOlabels_dist :: (FMap Name Names)
            _literalOlocal :: (Bool)
            _literalOmethods_collect :: (FMap Name Names)
            _literalOmethods_dist :: (FMap Name Names)
            _literalOmodules :: (Set Strings)
            _literalOoptimizer :: (Bool)
            _literalOoptimizerPrelude :: (Declarations)
            _literalOprelude :: (Bool)
            _literalOtoplevel :: (Bool)
            _literalOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _literalIconstructors_collect,_literalIgenericAbstractions_collect,_literalIlabels_collect,_literalImethods_collect,_literalIself) =
                (literal_ (_literalOclassname)
                          (_literalOconstructors_collect)
                          (_literalOconstructors_dist)
                          (_literalOcurrentModule)
                          (_literalOgenericAbstractions)
                          (_literalOgenericAbstractions_collect)
                          (_literalOghc)
                          (_literalOimportedModule)
                          (_literalOinstancename)
                          (_literalOlabels_collect)
                          (_literalOlabels_dist)
                          (_literalOlocal)
                          (_literalOmethods_collect)
                          (_literalOmethods_dist)
                          (_literalOmodules)
                          (_literalOoptimizer)
                          (_literalOoptimizerPrelude)
                          (_literalOprelude)
                          (_literalOtoplevel)
                          (_literalOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                Expression_Literal _rangeIself _literalIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _literalIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _literalIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _literalIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _literalImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_literalOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_literalOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_literalOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_literalOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_literalOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_literalOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_literalOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_literalOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_literalOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_literalOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_literalOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_literalOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_literalOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_literalOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_literalOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_literalOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_literalOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_literalOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_literalOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_literalOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Expression_Negate :: (T_Range) ->
                         (T_Expression) ->
                         (T_Expression)
sem_Expression_Negate (range_) (expression_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Expression)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionIabstractTypes_collect :: (Set Name)
            _expressionIbimapImps_collect :: ([Request_BimapImply])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdepConstraints_collect :: ([DepConstraint])
            _expressionIfunImps_collect :: ([Request_FunImply])
            _expressionIgenericAbstractions_collect :: (FMap Name Kind)
            _expressionIkinames :: (KSubst)
            _expressionIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionIkind_errors :: ([GHError])
            _expressionIkindvar :: (Int)
            _expressionIksubst :: (KSubst)
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIrawRequests_collect :: ([RawRequest])
            _expressionIself :: (Expression)
            _expressionIstaticErrors :: ([GHError])
            _expressionIstructureTypes_collect :: (FMap Name LambdaType)
            _expressionItypeImps_collect :: ([Request_TypeImply])
            _expressionOabstractTypes_collect :: (Set Name)
            _expressionObimapImps_collect :: ([Request_BimapImply])
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies :: (FMap Name [(Name,Name)])
            _expressionOexportedStructures :: (Set Name)
            _expressionOexportedTypes :: (Set Name)
            _expressionOexportedValues :: (Set Name)
            _expressionOfunImps_collect :: ([Request_FunImply])
            _expressionOgenericAbstractions :: (FMap Name Kind)
            _expressionOgenericAbstractions_collect :: (FMap Name Kind)
            _expressionOghc :: (Bool)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOkinames :: (KSubst)
            _expressionOkindIndexedTypes :: (FMap Name KindIndexedType)
            _expressionOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionOkinds :: (KSubst)
            _expressionOkindvar :: (Int)
            _expressionOksubst :: (KSubst)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmodules :: (Set Strings)
            _expressionOoptimizer :: (Bool)
            _expressionOoptimizerPrelude :: (Declarations)
            _expressionOprekind :: (KSubst)
            _expressionOprelude :: (Bool)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOrawRequests_collect :: ([RawRequest])
            _expressionOsignatures :: (Signatures)
            _expressionOstructureTypes_collect :: (FMap Name LambdaType)
            _expressionOtoplevel :: (Bool)
            _expressionOtypeImps_collect :: ([Request_TypeImply])
            _expressionOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionIabstractTypes_collect
             ,_expressionIbimapImps_collect
             ,_expressionIconstructors_collect
             ,_expressionIdepConstraints_collect
             ,_expressionIfunImps_collect
             ,_expressionIgenericAbstractions_collect
             ,_expressionIkinames
             ,_expressionIkindIndexedTypes_collect
             ,_expressionIkind_errors
             ,_expressionIkindvar
             ,_expressionIksubst
             ,_expressionIlabels_collect
             ,_expressionImethods_collect
             ,_expressionIpresignatures_collect
             ,_expressionIrawRequests_collect
             ,_expressionIself
             ,_expressionIstaticErrors
             ,_expressionIstructureTypes_collect
             ,_expressionItypeImps_collect
             ) =
                (expression_ (_expressionOabstractTypes_collect)
                             (_expressionObimapImps_collect)
                             (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies)
                             (_expressionOexportedStructures)
                             (_expressionOexportedTypes)
                             (_expressionOexportedValues)
                             (_expressionOfunImps_collect)
                             (_expressionOgenericAbstractions)
                             (_expressionOgenericAbstractions_collect)
                             (_expressionOghc)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOkinames)
                             (_expressionOkindIndexedTypes)
                             (_expressionOkindIndexedTypes_collect)
                             (_expressionOkinds)
                             (_expressionOkindvar)
                             (_expressionOksubst)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmodules)
                             (_expressionOoptimizer)
                             (_expressionOoptimizerPrelude)
                             (_expressionOprekind)
                             (_expressionOprelude)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOrawRequests_collect)
                             (_expressionOsignatures)
                             (_expressionOstructureTypes_collect)
                             (_expressionOtoplevel)
                             (_expressionOtypeImps_collect)
                             (_expressionOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _expressionIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _expressionIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _expressionIstaticErrors
            -- self rule
            (_self@_) =
                Expression_Negate _rangeIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _expressionIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _expressionIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _expressionIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _expressionIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _expressionIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _expressionIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _expressionIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _expressionIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _expressionIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _expressionIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _expressionItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_expressionObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_expressionOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_expressionOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_expressionOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_expressionOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_expressionOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_expressionOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_expressionOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_expressionOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_expressionOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_expressionOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_expressionOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_expressionOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_expressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_expressionOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_expressionOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_expressionOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_expressionOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_expressionOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Expression_NormalApplication :: (T_Range) ->
                                    (T_Expression) ->
                                    (T_Expressions) ->
                                    (T_Expression)
sem_Expression_NormalApplication (range_) (function_) (arguments_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Expression)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _functionIabstractTypes_collect :: (Set Name)
            _functionIbimapImps_collect :: ([Request_BimapImply])
            _functionIconstructors_collect :: (FMap Name Names)
            _functionIdepConstraints_collect :: ([DepConstraint])
            _functionIfunImps_collect :: ([Request_FunImply])
            _functionIgenericAbstractions_collect :: (FMap Name Kind)
            _functionIkinames :: (KSubst)
            _functionIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _functionIkind_errors :: ([GHError])
            _functionIkindvar :: (Int)
            _functionIksubst :: (KSubst)
            _functionIlabels_collect :: (FMap Name Names)
            _functionImethods_collect :: (FMap Name Names)
            _functionIpresignatures_collect :: (PreSignatures)
            _functionIrawRequests_collect :: ([RawRequest])
            _functionIself :: (Expression)
            _functionIstaticErrors :: ([GHError])
            _functionIstructureTypes_collect :: (FMap Name LambdaType)
            _functionItypeImps_collect :: ([Request_TypeImply])
            _functionOabstractTypes_collect :: (Set Name)
            _functionObimapImps_collect :: ([Request_BimapImply])
            _functionOclassname :: (Maybe Name)
            _functionOconstructors_collect :: (FMap Name Names)
            _functionOconstructors_dist :: (FMap Name Names)
            _functionOcurrentModule :: (Strings)
            _functionOdependencies :: (FMap Name [(Name,Name)])
            _functionOexportedStructures :: (Set Name)
            _functionOexportedTypes :: (Set Name)
            _functionOexportedValues :: (Set Name)
            _functionOfunImps_collect :: ([Request_FunImply])
            _functionOgenericAbstractions :: (FMap Name Kind)
            _functionOgenericAbstractions_collect :: (FMap Name Kind)
            _functionOghc :: (Bool)
            _functionOimportedModule :: (Bool)
            _functionOinstancename :: (Maybe Name)
            _functionOkinames :: (KSubst)
            _functionOkindIndexedTypes :: (FMap Name KindIndexedType)
            _functionOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _functionOkinds :: (KSubst)
            _functionOkindvar :: (Int)
            _functionOksubst :: (KSubst)
            _functionOlabels_collect :: (FMap Name Names)
            _functionOlabels_dist :: (FMap Name Names)
            _functionOlocal :: (Bool)
            _functionOmethods_collect :: (FMap Name Names)
            _functionOmethods_dist :: (FMap Name Names)
            _functionOmodules :: (Set Strings)
            _functionOoptimizer :: (Bool)
            _functionOoptimizerPrelude :: (Declarations)
            _functionOprekind :: (KSubst)
            _functionOprelude :: (Bool)
            _functionOpresignatures :: (PreSignatures)
            _functionOpresignatures_collect :: (PreSignatures)
            _functionOrawRequests_collect :: ([RawRequest])
            _functionOsignatures :: (Signatures)
            _functionOstructureTypes_collect :: (FMap Name LambdaType)
            _functionOtoplevel :: (Bool)
            _functionOtypeImps_collect :: ([Request_TypeImply])
            _functionOverbosity :: (Int)
            _argumentsIabstractTypes_collect :: (Set Name)
            _argumentsIbimapImps_collect :: ([Request_BimapImply])
            _argumentsIconstructors_collect :: (FMap Name Names)
            _argumentsIdepConstraints_collect :: ([DepConstraint])
            _argumentsIfunImps_collect :: ([Request_FunImply])
            _argumentsIgenericAbstractions_collect :: (FMap Name Kind)
            _argumentsIkinames :: (KSubst)
            _argumentsIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _argumentsIkind_errors :: ([GHError])
            _argumentsIkindvar :: (Int)
            _argumentsIksubst :: (KSubst)
            _argumentsIlabels_collect :: (FMap Name Names)
            _argumentsImethods_collect :: (FMap Name Names)
            _argumentsIpresignatures_collect :: (PreSignatures)
            _argumentsIrawRequests_collect :: ([RawRequest])
            _argumentsIself :: (Expressions)
            _argumentsIstaticErrors :: ([GHError])
            _argumentsIstructureTypes_collect :: (FMap Name LambdaType)
            _argumentsItypeImps_collect :: ([Request_TypeImply])
            _argumentsOabstractTypes_collect :: (Set Name)
            _argumentsObimapImps_collect :: ([Request_BimapImply])
            _argumentsOclassname :: (Maybe Name)
            _argumentsOconstructors_collect :: (FMap Name Names)
            _argumentsOconstructors_dist :: (FMap Name Names)
            _argumentsOcurrentModule :: (Strings)
            _argumentsOdependencies :: (FMap Name [(Name,Name)])
            _argumentsOexportedStructures :: (Set Name)
            _argumentsOexportedTypes :: (Set Name)
            _argumentsOexportedValues :: (Set Name)
            _argumentsOfunImps_collect :: ([Request_FunImply])
            _argumentsOgenericAbstractions :: (FMap Name Kind)
            _argumentsOgenericAbstractions_collect :: (FMap Name Kind)
            _argumentsOghc :: (Bool)
            _argumentsOimportedModule :: (Bool)
            _argumentsOinstancename :: (Maybe Name)
            _argumentsOkinames :: (KSubst)
            _argumentsOkindIndexedTypes :: (FMap Name KindIndexedType)
            _argumentsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _argumentsOkinds :: (KSubst)
            _argumentsOkindvar :: (Int)
            _argumentsOksubst :: (KSubst)
            _argumentsOlabels_collect :: (FMap Name Names)
            _argumentsOlabels_dist :: (FMap Name Names)
            _argumentsOlocal :: (Bool)
            _argumentsOmethods_collect :: (FMap Name Names)
            _argumentsOmethods_dist :: (FMap Name Names)
            _argumentsOmodules :: (Set Strings)
            _argumentsOoptimizer :: (Bool)
            _argumentsOoptimizerPrelude :: (Declarations)
            _argumentsOprekind :: (KSubst)
            _argumentsOprelude :: (Bool)
            _argumentsOpresignatures :: (PreSignatures)
            _argumentsOpresignatures_collect :: (PreSignatures)
            _argumentsOrawRequests_collect :: ([RawRequest])
            _argumentsOsignatures :: (Signatures)
            _argumentsOstructureTypes_collect :: (FMap Name LambdaType)
            _argumentsOtoplevel :: (Bool)
            _argumentsOtypeImps_collect :: ([Request_TypeImply])
            _argumentsOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _functionIabstractTypes_collect
             ,_functionIbimapImps_collect
             ,_functionIconstructors_collect
             ,_functionIdepConstraints_collect
             ,_functionIfunImps_collect
             ,_functionIgenericAbstractions_collect
             ,_functionIkinames
             ,_functionIkindIndexedTypes_collect
             ,_functionIkind_errors
             ,_functionIkindvar
             ,_functionIksubst
             ,_functionIlabels_collect
             ,_functionImethods_collect
             ,_functionIpresignatures_collect
             ,_functionIrawRequests_collect
             ,_functionIself
             ,_functionIstaticErrors
             ,_functionIstructureTypes_collect
             ,_functionItypeImps_collect
             ) =
                (function_ (_functionOabstractTypes_collect)
                           (_functionObimapImps_collect)
                           (_functionOclassname)
                           (_functionOconstructors_collect)
                           (_functionOconstructors_dist)
                           (_functionOcurrentModule)
                           (_functionOdependencies)
                           (_functionOexportedStructures)
                           (_functionOexportedTypes)
                           (_functionOexportedValues)
                           (_functionOfunImps_collect)
                           (_functionOgenericAbstractions)
                           (_functionOgenericAbstractions_collect)
                           (_functionOghc)
                           (_functionOimportedModule)
                           (_functionOinstancename)
                           (_functionOkinames)
                           (_functionOkindIndexedTypes)
                           (_functionOkindIndexedTypes_collect)
                           (_functionOkinds)
                           (_functionOkindvar)
                           (_functionOksubst)
                           (_functionOlabels_collect)
                           (_functionOlabels_dist)
                           (_functionOlocal)
                           (_functionOmethods_collect)
                           (_functionOmethods_dist)
                           (_functionOmodules)
                           (_functionOoptimizer)
                           (_functionOoptimizerPrelude)
                           (_functionOprekind)
                           (_functionOprelude)
                           (_functionOpresignatures)
                           (_functionOpresignatures_collect)
                           (_functionOrawRequests_collect)
                           (_functionOsignatures)
                           (_functionOstructureTypes_collect)
                           (_functionOtoplevel)
                           (_functionOtypeImps_collect)
                           (_functionOverbosity))
            ( _argumentsIabstractTypes_collect
             ,_argumentsIbimapImps_collect
             ,_argumentsIconstructors_collect
             ,_argumentsIdepConstraints_collect
             ,_argumentsIfunImps_collect
             ,_argumentsIgenericAbstractions_collect
             ,_argumentsIkinames
             ,_argumentsIkindIndexedTypes_collect
             ,_argumentsIkind_errors
             ,_argumentsIkindvar
             ,_argumentsIksubst
             ,_argumentsIlabels_collect
             ,_argumentsImethods_collect
             ,_argumentsIpresignatures_collect
             ,_argumentsIrawRequests_collect
             ,_argumentsIself
             ,_argumentsIstaticErrors
             ,_argumentsIstructureTypes_collect
             ,_argumentsItypeImps_collect
             ) =
                (arguments_ (_argumentsOabstractTypes_collect)
                            (_argumentsObimapImps_collect)
                            (_argumentsOclassname)
                            (_argumentsOconstructors_collect)
                            (_argumentsOconstructors_dist)
                            (_argumentsOcurrentModule)
                            (_argumentsOdependencies)
                            (_argumentsOexportedStructures)
                            (_argumentsOexportedTypes)
                            (_argumentsOexportedValues)
                            (_argumentsOfunImps_collect)
                            (_argumentsOgenericAbstractions)
                            (_argumentsOgenericAbstractions_collect)
                            (_argumentsOghc)
                            (_argumentsOimportedModule)
                            (_argumentsOinstancename)
                            (_argumentsOkinames)
                            (_argumentsOkindIndexedTypes)
                            (_argumentsOkindIndexedTypes_collect)
                            (_argumentsOkinds)
                            (_argumentsOkindvar)
                            (_argumentsOksubst)
                            (_argumentsOlabels_collect)
                            (_argumentsOlabels_dist)
                            (_argumentsOlocal)
                            (_argumentsOmethods_collect)
                            (_argumentsOmethods_dist)
                            (_argumentsOmodules)
                            (_argumentsOoptimizer)
                            (_argumentsOoptimizerPrelude)
                            (_argumentsOprekind)
                            (_argumentsOprelude)
                            (_argumentsOpresignatures)
                            (_argumentsOpresignatures_collect)
                            (_argumentsOrawRequests_collect)
                            (_argumentsOsignatures)
                            (_argumentsOstructureTypes_collect)
                            (_argumentsOtoplevel)
                            (_argumentsOtypeImps_collect)
                            (_argumentsOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _functionIdepConstraints_collect ++ _argumentsIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _functionIkind_errors ++ _argumentsIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _functionIstaticErrors ++ _argumentsIstaticErrors
            -- self rule
            (_self@_) =
                Expression_NormalApplication _rangeIself _functionIself _argumentsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _argumentsIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _argumentsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _argumentsIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _argumentsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _argumentsIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _argumentsIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _argumentsIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _argumentsIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _argumentsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _argumentsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _argumentsImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _argumentsIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _argumentsIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _argumentsIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _argumentsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_functionOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_functionObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_functionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_functionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_functionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_functionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_functionOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_functionOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_functionOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_functionOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_functionOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_functionOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_functionOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_functionOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_functionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_functionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_functionOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_functionOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_functionOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_functionOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_functionOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_functionOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_functionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_functionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_functionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_functionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_functionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_functionOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_functionOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_functionOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_functionOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_functionOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_functionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_functionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_functionOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_functionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_functionOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_functionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_functionOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_functionOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_argumentsOabstractTypes_collect@_) =
                _functionIabstractTypes_collect
            -- copy rule (chain)
            (_argumentsObimapImps_collect@_) =
                _functionIbimapImps_collect
            -- copy rule (down)
            (_argumentsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_argumentsOconstructors_collect@_) =
                _functionIconstructors_collect
            -- copy rule (down)
            (_argumentsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_argumentsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_argumentsOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_argumentsOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_argumentsOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_argumentsOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (chain)
            (_argumentsOfunImps_collect@_) =
                _functionIfunImps_collect
            -- copy rule (down)
            (_argumentsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_argumentsOgenericAbstractions_collect@_) =
                _functionIgenericAbstractions_collect
            -- copy rule (down)
            (_argumentsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_argumentsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_argumentsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_argumentsOkinames@_) =
                _functionIkinames
            -- copy rule (down)
            (_argumentsOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (chain)
            (_argumentsOkindIndexedTypes_collect@_) =
                _functionIkindIndexedTypes_collect
            -- copy rule (down)
            (_argumentsOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_argumentsOkindvar@_) =
                _functionIkindvar
            -- copy rule (chain)
            (_argumentsOksubst@_) =
                _functionIksubst
            -- copy rule (chain)
            (_argumentsOlabels_collect@_) =
                _functionIlabels_collect
            -- copy rule (down)
            (_argumentsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_argumentsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_argumentsOmethods_collect@_) =
                _functionImethods_collect
            -- copy rule (down)
            (_argumentsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_argumentsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_argumentsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_argumentsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_argumentsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_argumentsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_argumentsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_argumentsOpresignatures_collect@_) =
                _functionIpresignatures_collect
            -- copy rule (chain)
            (_argumentsOrawRequests_collect@_) =
                _functionIrawRequests_collect
            -- copy rule (down)
            (_argumentsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (chain)
            (_argumentsOstructureTypes_collect@_) =
                _functionIstructureTypes_collect
            -- copy rule (down)
            (_argumentsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_argumentsOtypeImps_collect@_) =
                _functionItypeImps_collect
            -- copy rule (down)
            (_argumentsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Expression_Parenthesized :: (T_Range) ->
                                (T_Expression) ->
                                (T_Expression)
sem_Expression_Parenthesized (range_) (expression_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Expression)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionIabstractTypes_collect :: (Set Name)
            _expressionIbimapImps_collect :: ([Request_BimapImply])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdepConstraints_collect :: ([DepConstraint])
            _expressionIfunImps_collect :: ([Request_FunImply])
            _expressionIgenericAbstractions_collect :: (FMap Name Kind)
            _expressionIkinames :: (KSubst)
            _expressionIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionIkind_errors :: ([GHError])
            _expressionIkindvar :: (Int)
            _expressionIksubst :: (KSubst)
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIrawRequests_collect :: ([RawRequest])
            _expressionIself :: (Expression)
            _expressionIstaticErrors :: ([GHError])
            _expressionIstructureTypes_collect :: (FMap Name LambdaType)
            _expressionItypeImps_collect :: ([Request_TypeImply])
            _expressionOabstractTypes_collect :: (Set Name)
            _expressionObimapImps_collect :: ([Request_BimapImply])
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies :: (FMap Name [(Name,Name)])
            _expressionOexportedStructures :: (Set Name)
            _expressionOexportedTypes :: (Set Name)
            _expressionOexportedValues :: (Set Name)
            _expressionOfunImps_collect :: ([Request_FunImply])
            _expressionOgenericAbstractions :: (FMap Name Kind)
            _expressionOgenericAbstractions_collect :: (FMap Name Kind)
            _expressionOghc :: (Bool)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOkinames :: (KSubst)
            _expressionOkindIndexedTypes :: (FMap Name KindIndexedType)
            _expressionOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionOkinds :: (KSubst)
            _expressionOkindvar :: (Int)
            _expressionOksubst :: (KSubst)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmodules :: (Set Strings)
            _expressionOoptimizer :: (Bool)
            _expressionOoptimizerPrelude :: (Declarations)
            _expressionOprekind :: (KSubst)
            _expressionOprelude :: (Bool)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOrawRequests_collect :: ([RawRequest])
            _expressionOsignatures :: (Signatures)
            _expressionOstructureTypes_collect :: (FMap Name LambdaType)
            _expressionOtoplevel :: (Bool)
            _expressionOtypeImps_collect :: ([Request_TypeImply])
            _expressionOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionIabstractTypes_collect
             ,_expressionIbimapImps_collect
             ,_expressionIconstructors_collect
             ,_expressionIdepConstraints_collect
             ,_expressionIfunImps_collect
             ,_expressionIgenericAbstractions_collect
             ,_expressionIkinames
             ,_expressionIkindIndexedTypes_collect
             ,_expressionIkind_errors
             ,_expressionIkindvar
             ,_expressionIksubst
             ,_expressionIlabels_collect
             ,_expressionImethods_collect
             ,_expressionIpresignatures_collect
             ,_expressionIrawRequests_collect
             ,_expressionIself
             ,_expressionIstaticErrors
             ,_expressionIstructureTypes_collect
             ,_expressionItypeImps_collect
             ) =
                (expression_ (_expressionOabstractTypes_collect)
                             (_expressionObimapImps_collect)
                             (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies)
                             (_expressionOexportedStructures)
                             (_expressionOexportedTypes)
                             (_expressionOexportedValues)
                             (_expressionOfunImps_collect)
                             (_expressionOgenericAbstractions)
                             (_expressionOgenericAbstractions_collect)
                             (_expressionOghc)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOkinames)
                             (_expressionOkindIndexedTypes)
                             (_expressionOkindIndexedTypes_collect)
                             (_expressionOkinds)
                             (_expressionOkindvar)
                             (_expressionOksubst)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmodules)
                             (_expressionOoptimizer)
                             (_expressionOoptimizerPrelude)
                             (_expressionOprekind)
                             (_expressionOprelude)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOrawRequests_collect)
                             (_expressionOsignatures)
                             (_expressionOstructureTypes_collect)
                             (_expressionOtoplevel)
                             (_expressionOtypeImps_collect)
                             (_expressionOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _expressionIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _expressionIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _expressionIstaticErrors
            -- self rule
            (_self@_) =
                Expression_Parenthesized _rangeIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _expressionIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _expressionIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _expressionIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _expressionIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _expressionIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _expressionIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _expressionIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _expressionIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _expressionIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _expressionIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _expressionItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_expressionObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_expressionOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_expressionOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_expressionOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_expressionOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_expressionOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_expressionOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_expressionOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_expressionOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_expressionOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_expressionOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_expressionOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_expressionOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_expressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_expressionOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_expressionOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_expressionOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_expressionOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_expressionOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Expression_RecordConstruction :: (T_Range) ->
                                     (T_Name) ->
                                     (T_RecordExpressionBindings) ->
                                     (T_Expression)
sem_Expression_RecordConstruction (range_) (name_) (recordExpressionBindings_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Expression)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _recordExpressionBindingsIabstractTypes_collect :: (Set Name)
            _recordExpressionBindingsIbimapImps_collect :: ([Request_BimapImply])
            _recordExpressionBindingsIconstructors_collect :: (FMap Name Names)
            _recordExpressionBindingsIdepConstraints_collect :: ([DepConstraint])
            _recordExpressionBindingsIfunImps_collect :: ([Request_FunImply])
            _recordExpressionBindingsIgenericAbstractions_collect :: (FMap Name Kind)
            _recordExpressionBindingsIkinames :: (KSubst)
            _recordExpressionBindingsIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _recordExpressionBindingsIkind_errors :: ([GHError])
            _recordExpressionBindingsIkindvar :: (Int)
            _recordExpressionBindingsIksubst :: (KSubst)
            _recordExpressionBindingsIlabels_collect :: (FMap Name Names)
            _recordExpressionBindingsImethods_collect :: (FMap Name Names)
            _recordExpressionBindingsIpresignatures_collect :: (PreSignatures)
            _recordExpressionBindingsIrawRequests_collect :: ([RawRequest])
            _recordExpressionBindingsIself :: (RecordExpressionBindings)
            _recordExpressionBindingsIstaticErrors :: ([GHError])
            _recordExpressionBindingsIstructureTypes_collect :: (FMap Name LambdaType)
            _recordExpressionBindingsItypeImps_collect :: ([Request_TypeImply])
            _recordExpressionBindingsOabstractTypes_collect :: (Set Name)
            _recordExpressionBindingsObimapImps_collect :: ([Request_BimapImply])
            _recordExpressionBindingsOclassname :: (Maybe Name)
            _recordExpressionBindingsOconstructors_collect :: (FMap Name Names)
            _recordExpressionBindingsOconstructors_dist :: (FMap Name Names)
            _recordExpressionBindingsOcurrentModule :: (Strings)
            _recordExpressionBindingsOdependencies :: (FMap Name [(Name,Name)])
            _recordExpressionBindingsOexportedStructures :: (Set Name)
            _recordExpressionBindingsOexportedTypes :: (Set Name)
            _recordExpressionBindingsOexportedValues :: (Set Name)
            _recordExpressionBindingsOfunImps_collect :: ([Request_FunImply])
            _recordExpressionBindingsOgenericAbstractions :: (FMap Name Kind)
            _recordExpressionBindingsOgenericAbstractions_collect :: (FMap Name Kind)
            _recordExpressionBindingsOghc :: (Bool)
            _recordExpressionBindingsOimportedModule :: (Bool)
            _recordExpressionBindingsOinstancename :: (Maybe Name)
            _recordExpressionBindingsOkinames :: (KSubst)
            _recordExpressionBindingsOkindIndexedTypes :: (FMap Name KindIndexedType)
            _recordExpressionBindingsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _recordExpressionBindingsOkinds :: (KSubst)
            _recordExpressionBindingsOkindvar :: (Int)
            _recordExpressionBindingsOksubst :: (KSubst)
            _recordExpressionBindingsOlabels_collect :: (FMap Name Names)
            _recordExpressionBindingsOlabels_dist :: (FMap Name Names)
            _recordExpressionBindingsOlocal :: (Bool)
            _recordExpressionBindingsOmethods_collect :: (FMap Name Names)
            _recordExpressionBindingsOmethods_dist :: (FMap Name Names)
            _recordExpressionBindingsOmodules :: (Set Strings)
            _recordExpressionBindingsOoptimizer :: (Bool)
            _recordExpressionBindingsOoptimizerPrelude :: (Declarations)
            _recordExpressionBindingsOprekind :: (KSubst)
            _recordExpressionBindingsOprelude :: (Bool)
            _recordExpressionBindingsOpresignatures :: (PreSignatures)
            _recordExpressionBindingsOpresignatures_collect :: (PreSignatures)
            _recordExpressionBindingsOrawRequests_collect :: ([RawRequest])
            _recordExpressionBindingsOsignatures :: (Signatures)
            _recordExpressionBindingsOstructureTypes_collect :: (FMap Name LambdaType)
            _recordExpressionBindingsOtoplevel :: (Bool)
            _recordExpressionBindingsOtypeImps_collect :: ([Request_TypeImply])
            _recordExpressionBindingsOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _recordExpressionBindingsIabstractTypes_collect
             ,_recordExpressionBindingsIbimapImps_collect
             ,_recordExpressionBindingsIconstructors_collect
             ,_recordExpressionBindingsIdepConstraints_collect
             ,_recordExpressionBindingsIfunImps_collect
             ,_recordExpressionBindingsIgenericAbstractions_collect
             ,_recordExpressionBindingsIkinames
             ,_recordExpressionBindingsIkindIndexedTypes_collect
             ,_recordExpressionBindingsIkind_errors
             ,_recordExpressionBindingsIkindvar
             ,_recordExpressionBindingsIksubst
             ,_recordExpressionBindingsIlabels_collect
             ,_recordExpressionBindingsImethods_collect
             ,_recordExpressionBindingsIpresignatures_collect
             ,_recordExpressionBindingsIrawRequests_collect
             ,_recordExpressionBindingsIself
             ,_recordExpressionBindingsIstaticErrors
             ,_recordExpressionBindingsIstructureTypes_collect
             ,_recordExpressionBindingsItypeImps_collect
             ) =
                (recordExpressionBindings_ (_recordExpressionBindingsOabstractTypes_collect)
                                           (_recordExpressionBindingsObimapImps_collect)
                                           (_recordExpressionBindingsOclassname)
                                           (_recordExpressionBindingsOconstructors_collect)
                                           (_recordExpressionBindingsOconstructors_dist)
                                           (_recordExpressionBindingsOcurrentModule)
                                           (_recordExpressionBindingsOdependencies)
                                           (_recordExpressionBindingsOexportedStructures)
                                           (_recordExpressionBindingsOexportedTypes)
                                           (_recordExpressionBindingsOexportedValues)
                                           (_recordExpressionBindingsOfunImps_collect)
                                           (_recordExpressionBindingsOgenericAbstractions)
                                           (_recordExpressionBindingsOgenericAbstractions_collect)
                                           (_recordExpressionBindingsOghc)
                                           (_recordExpressionBindingsOimportedModule)
                                           (_recordExpressionBindingsOinstancename)
                                           (_recordExpressionBindingsOkinames)
                                           (_recordExpressionBindingsOkindIndexedTypes)
                                           (_recordExpressionBindingsOkindIndexedTypes_collect)
                                           (_recordExpressionBindingsOkinds)
                                           (_recordExpressionBindingsOkindvar)
                                           (_recordExpressionBindingsOksubst)
                                           (_recordExpressionBindingsOlabels_collect)
                                           (_recordExpressionBindingsOlabels_dist)
                                           (_recordExpressionBindingsOlocal)
                                           (_recordExpressionBindingsOmethods_collect)
                                           (_recordExpressionBindingsOmethods_dist)
                                           (_recordExpressionBindingsOmodules)
                                           (_recordExpressionBindingsOoptimizer)
                                           (_recordExpressionBindingsOoptimizerPrelude)
                                           (_recordExpressionBindingsOprekind)
                                           (_recordExpressionBindingsOprelude)
                                           (_recordExpressionBindingsOpresignatures)
                                           (_recordExpressionBindingsOpresignatures_collect)
                                           (_recordExpressionBindingsOrawRequests_collect)
                                           (_recordExpressionBindingsOsignatures)
                                           (_recordExpressionBindingsOstructureTypes_collect)
                                           (_recordExpressionBindingsOtoplevel)
                                           (_recordExpressionBindingsOtypeImps_collect)
                                           (_recordExpressionBindingsOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _recordExpressionBindingsIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _recordExpressionBindingsIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _recordExpressionBindingsIstaticErrors
            -- self rule
            (_self@_) =
                Expression_RecordConstruction _rangeIself _nameIself _recordExpressionBindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _recordExpressionBindingsIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _recordExpressionBindingsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _recordExpressionBindingsIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _recordExpressionBindingsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _recordExpressionBindingsIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _recordExpressionBindingsIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _recordExpressionBindingsIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _recordExpressionBindingsIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _recordExpressionBindingsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _recordExpressionBindingsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _recordExpressionBindingsImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _recordExpressionBindingsIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _recordExpressionBindingsIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _recordExpressionBindingsIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _recordExpressionBindingsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_recordExpressionBindingsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_recordExpressionBindingsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_recordExpressionBindingsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_recordExpressionBindingsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_recordExpressionBindingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_recordExpressionBindingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_recordExpressionBindingsOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_recordExpressionBindingsOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_recordExpressionBindingsOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_recordExpressionBindingsOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_recordExpressionBindingsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_recordExpressionBindingsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_recordExpressionBindingsOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_recordExpressionBindingsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_recordExpressionBindingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_recordExpressionBindingsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_recordExpressionBindingsOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_recordExpressionBindingsOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_recordExpressionBindingsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_recordExpressionBindingsOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_recordExpressionBindingsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_recordExpressionBindingsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_recordExpressionBindingsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_recordExpressionBindingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_recordExpressionBindingsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_recordExpressionBindingsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_recordExpressionBindingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_recordExpressionBindingsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_recordExpressionBindingsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_recordExpressionBindingsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_recordExpressionBindingsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_recordExpressionBindingsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_recordExpressionBindingsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_recordExpressionBindingsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_recordExpressionBindingsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_recordExpressionBindingsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_recordExpressionBindingsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_recordExpressionBindingsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_recordExpressionBindingsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_recordExpressionBindingsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Expression_RecordUpdate :: (T_Range) ->
                               (T_Expression) ->
                               (T_RecordExpressionBindings) ->
                               (T_Expression)
sem_Expression_RecordUpdate (range_) (expression_) (recordExpressionBindings_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Expression)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionIabstractTypes_collect :: (Set Name)
            _expressionIbimapImps_collect :: ([Request_BimapImply])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdepConstraints_collect :: ([DepConstraint])
            _expressionIfunImps_collect :: ([Request_FunImply])
            _expressionIgenericAbstractions_collect :: (FMap Name Kind)
            _expressionIkinames :: (KSubst)
            _expressionIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionIkind_errors :: ([GHError])
            _expressionIkindvar :: (Int)
            _expressionIksubst :: (KSubst)
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIrawRequests_collect :: ([RawRequest])
            _expressionIself :: (Expression)
            _expressionIstaticErrors :: ([GHError])
            _expressionIstructureTypes_collect :: (FMap Name LambdaType)
            _expressionItypeImps_collect :: ([Request_TypeImply])
            _expressionOabstractTypes_collect :: (Set Name)
            _expressionObimapImps_collect :: ([Request_BimapImply])
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies :: (FMap Name [(Name,Name)])
            _expressionOexportedStructures :: (Set Name)
            _expressionOexportedTypes :: (Set Name)
            _expressionOexportedValues :: (Set Name)
            _expressionOfunImps_collect :: ([Request_FunImply])
            _expressionOgenericAbstractions :: (FMap Name Kind)
            _expressionOgenericAbstractions_collect :: (FMap Name Kind)
            _expressionOghc :: (Bool)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOkinames :: (KSubst)
            _expressionOkindIndexedTypes :: (FMap Name KindIndexedType)
            _expressionOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionOkinds :: (KSubst)
            _expressionOkindvar :: (Int)
            _expressionOksubst :: (KSubst)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmodules :: (Set Strings)
            _expressionOoptimizer :: (Bool)
            _expressionOoptimizerPrelude :: (Declarations)
            _expressionOprekind :: (KSubst)
            _expressionOprelude :: (Bool)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOrawRequests_collect :: ([RawRequest])
            _expressionOsignatures :: (Signatures)
            _expressionOstructureTypes_collect :: (FMap Name LambdaType)
            _expressionOtoplevel :: (Bool)
            _expressionOtypeImps_collect :: ([Request_TypeImply])
            _expressionOverbosity :: (Int)
            _recordExpressionBindingsIabstractTypes_collect :: (Set Name)
            _recordExpressionBindingsIbimapImps_collect :: ([Request_BimapImply])
            _recordExpressionBindingsIconstructors_collect :: (FMap Name Names)
            _recordExpressionBindingsIdepConstraints_collect :: ([DepConstraint])
            _recordExpressionBindingsIfunImps_collect :: ([Request_FunImply])
            _recordExpressionBindingsIgenericAbstractions_collect :: (FMap Name Kind)
            _recordExpressionBindingsIkinames :: (KSubst)
            _recordExpressionBindingsIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _recordExpressionBindingsIkind_errors :: ([GHError])
            _recordExpressionBindingsIkindvar :: (Int)
            _recordExpressionBindingsIksubst :: (KSubst)
            _recordExpressionBindingsIlabels_collect :: (FMap Name Names)
            _recordExpressionBindingsImethods_collect :: (FMap Name Names)
            _recordExpressionBindingsIpresignatures_collect :: (PreSignatures)
            _recordExpressionBindingsIrawRequests_collect :: ([RawRequest])
            _recordExpressionBindingsIself :: (RecordExpressionBindings)
            _recordExpressionBindingsIstaticErrors :: ([GHError])
            _recordExpressionBindingsIstructureTypes_collect :: (FMap Name LambdaType)
            _recordExpressionBindingsItypeImps_collect :: ([Request_TypeImply])
            _recordExpressionBindingsOabstractTypes_collect :: (Set Name)
            _recordExpressionBindingsObimapImps_collect :: ([Request_BimapImply])
            _recordExpressionBindingsOclassname :: (Maybe Name)
            _recordExpressionBindingsOconstructors_collect :: (FMap Name Names)
            _recordExpressionBindingsOconstructors_dist :: (FMap Name Names)
            _recordExpressionBindingsOcurrentModule :: (Strings)
            _recordExpressionBindingsOdependencies :: (FMap Name [(Name,Name)])
            _recordExpressionBindingsOexportedStructures :: (Set Name)
            _recordExpressionBindingsOexportedTypes :: (Set Name)
            _recordExpressionBindingsOexportedValues :: (Set Name)
            _recordExpressionBindingsOfunImps_collect :: ([Request_FunImply])
            _recordExpressionBindingsOgenericAbstractions :: (FMap Name Kind)
            _recordExpressionBindingsOgenericAbstractions_collect :: (FMap Name Kind)
            _recordExpressionBindingsOghc :: (Bool)
            _recordExpressionBindingsOimportedModule :: (Bool)
            _recordExpressionBindingsOinstancename :: (Maybe Name)
            _recordExpressionBindingsOkinames :: (KSubst)
            _recordExpressionBindingsOkindIndexedTypes :: (FMap Name KindIndexedType)
            _recordExpressionBindingsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _recordExpressionBindingsOkinds :: (KSubst)
            _recordExpressionBindingsOkindvar :: (Int)
            _recordExpressionBindingsOksubst :: (KSubst)
            _recordExpressionBindingsOlabels_collect :: (FMap Name Names)
            _recordExpressionBindingsOlabels_dist :: (FMap Name Names)
            _recordExpressionBindingsOlocal :: (Bool)
            _recordExpressionBindingsOmethods_collect :: (FMap Name Names)
            _recordExpressionBindingsOmethods_dist :: (FMap Name Names)
            _recordExpressionBindingsOmodules :: (Set Strings)
            _recordExpressionBindingsOoptimizer :: (Bool)
            _recordExpressionBindingsOoptimizerPrelude :: (Declarations)
            _recordExpressionBindingsOprekind :: (KSubst)
            _recordExpressionBindingsOprelude :: (Bool)
            _recordExpressionBindingsOpresignatures :: (PreSignatures)
            _recordExpressionBindingsOpresignatures_collect :: (PreSignatures)
            _recordExpressionBindingsOrawRequests_collect :: ([RawRequest])
            _recordExpressionBindingsOsignatures :: (Signatures)
            _recordExpressionBindingsOstructureTypes_collect :: (FMap Name LambdaType)
            _recordExpressionBindingsOtoplevel :: (Bool)
            _recordExpressionBindingsOtypeImps_collect :: ([Request_TypeImply])
            _recordExpressionBindingsOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionIabstractTypes_collect
             ,_expressionIbimapImps_collect
             ,_expressionIconstructors_collect
             ,_expressionIdepConstraints_collect
             ,_expressionIfunImps_collect
             ,_expressionIgenericAbstractions_collect
             ,_expressionIkinames
             ,_expressionIkindIndexedTypes_collect
             ,_expressionIkind_errors
             ,_expressionIkindvar
             ,_expressionIksubst
             ,_expressionIlabels_collect
             ,_expressionImethods_collect
             ,_expressionIpresignatures_collect
             ,_expressionIrawRequests_collect
             ,_expressionIself
             ,_expressionIstaticErrors
             ,_expressionIstructureTypes_collect
             ,_expressionItypeImps_collect
             ) =
                (expression_ (_expressionOabstractTypes_collect)
                             (_expressionObimapImps_collect)
                             (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies)
                             (_expressionOexportedStructures)
                             (_expressionOexportedTypes)
                             (_expressionOexportedValues)
                             (_expressionOfunImps_collect)
                             (_expressionOgenericAbstractions)
                             (_expressionOgenericAbstractions_collect)
                             (_expressionOghc)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOkinames)
                             (_expressionOkindIndexedTypes)
                             (_expressionOkindIndexedTypes_collect)
                             (_expressionOkinds)
                             (_expressionOkindvar)
                             (_expressionOksubst)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmodules)
                             (_expressionOoptimizer)
                             (_expressionOoptimizerPrelude)
                             (_expressionOprekind)
                             (_expressionOprelude)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOrawRequests_collect)
                             (_expressionOsignatures)
                             (_expressionOstructureTypes_collect)
                             (_expressionOtoplevel)
                             (_expressionOtypeImps_collect)
                             (_expressionOverbosity))
            ( _recordExpressionBindingsIabstractTypes_collect
             ,_recordExpressionBindingsIbimapImps_collect
             ,_recordExpressionBindingsIconstructors_collect
             ,_recordExpressionBindingsIdepConstraints_collect
             ,_recordExpressionBindingsIfunImps_collect
             ,_recordExpressionBindingsIgenericAbstractions_collect
             ,_recordExpressionBindingsIkinames
             ,_recordExpressionBindingsIkindIndexedTypes_collect
             ,_recordExpressionBindingsIkind_errors
             ,_recordExpressionBindingsIkindvar
             ,_recordExpressionBindingsIksubst
             ,_recordExpressionBindingsIlabels_collect
             ,_recordExpressionBindingsImethods_collect
             ,_recordExpressionBindingsIpresignatures_collect
             ,_recordExpressionBindingsIrawRequests_collect
             ,_recordExpressionBindingsIself
             ,_recordExpressionBindingsIstaticErrors
             ,_recordExpressionBindingsIstructureTypes_collect
             ,_recordExpressionBindingsItypeImps_collect
             ) =
                (recordExpressionBindings_ (_recordExpressionBindingsOabstractTypes_collect)
                                           (_recordExpressionBindingsObimapImps_collect)
                                           (_recordExpressionBindingsOclassname)
                                           (_recordExpressionBindingsOconstructors_collect)
                                           (_recordExpressionBindingsOconstructors_dist)
                                           (_recordExpressionBindingsOcurrentModule)
                                           (_recordExpressionBindingsOdependencies)
                                           (_recordExpressionBindingsOexportedStructures)
                                           (_recordExpressionBindingsOexportedTypes)
                                           (_recordExpressionBindingsOexportedValues)
                                           (_recordExpressionBindingsOfunImps_collect)
                                           (_recordExpressionBindingsOgenericAbstractions)
                                           (_recordExpressionBindingsOgenericAbstractions_collect)
                                           (_recordExpressionBindingsOghc)
                                           (_recordExpressionBindingsOimportedModule)
                                           (_recordExpressionBindingsOinstancename)
                                           (_recordExpressionBindingsOkinames)
                                           (_recordExpressionBindingsOkindIndexedTypes)
                                           (_recordExpressionBindingsOkindIndexedTypes_collect)
                                           (_recordExpressionBindingsOkinds)
                                           (_recordExpressionBindingsOkindvar)
                                           (_recordExpressionBindingsOksubst)
                                           (_recordExpressionBindingsOlabels_collect)
                                           (_recordExpressionBindingsOlabels_dist)
                                           (_recordExpressionBindingsOlocal)
                                           (_recordExpressionBindingsOmethods_collect)
                                           (_recordExpressionBindingsOmethods_dist)
                                           (_recordExpressionBindingsOmodules)
                                           (_recordExpressionBindingsOoptimizer)
                                           (_recordExpressionBindingsOoptimizerPrelude)
                                           (_recordExpressionBindingsOprekind)
                                           (_recordExpressionBindingsOprelude)
                                           (_recordExpressionBindingsOpresignatures)
                                           (_recordExpressionBindingsOpresignatures_collect)
                                           (_recordExpressionBindingsOrawRequests_collect)
                                           (_recordExpressionBindingsOsignatures)
                                           (_recordExpressionBindingsOstructureTypes_collect)
                                           (_recordExpressionBindingsOtoplevel)
                                           (_recordExpressionBindingsOtypeImps_collect)
                                           (_recordExpressionBindingsOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _expressionIdepConstraints_collect ++ _recordExpressionBindingsIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _expressionIkind_errors ++ _recordExpressionBindingsIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _expressionIstaticErrors ++ _recordExpressionBindingsIstaticErrors
            -- self rule
            (_self@_) =
                Expression_RecordUpdate _rangeIself _expressionIself _recordExpressionBindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _recordExpressionBindingsIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _recordExpressionBindingsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _recordExpressionBindingsIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _recordExpressionBindingsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _recordExpressionBindingsIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _recordExpressionBindingsIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _recordExpressionBindingsIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _recordExpressionBindingsIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _recordExpressionBindingsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _recordExpressionBindingsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _recordExpressionBindingsImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _recordExpressionBindingsIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _recordExpressionBindingsIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _recordExpressionBindingsIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _recordExpressionBindingsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_expressionObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_expressionOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_expressionOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_expressionOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_expressionOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_expressionOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_expressionOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_expressionOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_expressionOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_expressionOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_expressionOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_expressionOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_expressionOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_expressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_expressionOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_expressionOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_expressionOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_expressionOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_expressionOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_recordExpressionBindingsOabstractTypes_collect@_) =
                _expressionIabstractTypes_collect
            -- copy rule (chain)
            (_recordExpressionBindingsObimapImps_collect@_) =
                _expressionIbimapImps_collect
            -- copy rule (down)
            (_recordExpressionBindingsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_recordExpressionBindingsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (down)
            (_recordExpressionBindingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_recordExpressionBindingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_recordExpressionBindingsOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_recordExpressionBindingsOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_recordExpressionBindingsOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_recordExpressionBindingsOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (chain)
            (_recordExpressionBindingsOfunImps_collect@_) =
                _expressionIfunImps_collect
            -- copy rule (down)
            (_recordExpressionBindingsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_recordExpressionBindingsOgenericAbstractions_collect@_) =
                _expressionIgenericAbstractions_collect
            -- copy rule (down)
            (_recordExpressionBindingsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_recordExpressionBindingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_recordExpressionBindingsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_recordExpressionBindingsOkinames@_) =
                _expressionIkinames
            -- copy rule (down)
            (_recordExpressionBindingsOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (chain)
            (_recordExpressionBindingsOkindIndexedTypes_collect@_) =
                _expressionIkindIndexedTypes_collect
            -- copy rule (down)
            (_recordExpressionBindingsOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_recordExpressionBindingsOkindvar@_) =
                _expressionIkindvar
            -- copy rule (chain)
            (_recordExpressionBindingsOksubst@_) =
                _expressionIksubst
            -- copy rule (chain)
            (_recordExpressionBindingsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (down)
            (_recordExpressionBindingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_recordExpressionBindingsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_recordExpressionBindingsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (down)
            (_recordExpressionBindingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_recordExpressionBindingsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_recordExpressionBindingsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_recordExpressionBindingsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_recordExpressionBindingsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_recordExpressionBindingsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_recordExpressionBindingsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_recordExpressionBindingsOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (chain)
            (_recordExpressionBindingsOrawRequests_collect@_) =
                _expressionIrawRequests_collect
            -- copy rule (down)
            (_recordExpressionBindingsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (chain)
            (_recordExpressionBindingsOstructureTypes_collect@_) =
                _expressionIstructureTypes_collect
            -- copy rule (down)
            (_recordExpressionBindingsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_recordExpressionBindingsOtypeImps_collect@_) =
                _expressionItypeImps_collect
            -- copy rule (down)
            (_recordExpressionBindingsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Expression_Tuple :: (T_Range) ->
                        (T_Expressions) ->
                        (T_Expression)
sem_Expression_Tuple (range_) (expressions_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Expression)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionsIabstractTypes_collect :: (Set Name)
            _expressionsIbimapImps_collect :: ([Request_BimapImply])
            _expressionsIconstructors_collect :: (FMap Name Names)
            _expressionsIdepConstraints_collect :: ([DepConstraint])
            _expressionsIfunImps_collect :: ([Request_FunImply])
            _expressionsIgenericAbstractions_collect :: (FMap Name Kind)
            _expressionsIkinames :: (KSubst)
            _expressionsIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionsIkind_errors :: ([GHError])
            _expressionsIkindvar :: (Int)
            _expressionsIksubst :: (KSubst)
            _expressionsIlabels_collect :: (FMap Name Names)
            _expressionsImethods_collect :: (FMap Name Names)
            _expressionsIpresignatures_collect :: (PreSignatures)
            _expressionsIrawRequests_collect :: ([RawRequest])
            _expressionsIself :: (Expressions)
            _expressionsIstaticErrors :: ([GHError])
            _expressionsIstructureTypes_collect :: (FMap Name LambdaType)
            _expressionsItypeImps_collect :: ([Request_TypeImply])
            _expressionsOabstractTypes_collect :: (Set Name)
            _expressionsObimapImps_collect :: ([Request_BimapImply])
            _expressionsOclassname :: (Maybe Name)
            _expressionsOconstructors_collect :: (FMap Name Names)
            _expressionsOconstructors_dist :: (FMap Name Names)
            _expressionsOcurrentModule :: (Strings)
            _expressionsOdependencies :: (FMap Name [(Name,Name)])
            _expressionsOexportedStructures :: (Set Name)
            _expressionsOexportedTypes :: (Set Name)
            _expressionsOexportedValues :: (Set Name)
            _expressionsOfunImps_collect :: ([Request_FunImply])
            _expressionsOgenericAbstractions :: (FMap Name Kind)
            _expressionsOgenericAbstractions_collect :: (FMap Name Kind)
            _expressionsOghc :: (Bool)
            _expressionsOimportedModule :: (Bool)
            _expressionsOinstancename :: (Maybe Name)
            _expressionsOkinames :: (KSubst)
            _expressionsOkindIndexedTypes :: (FMap Name KindIndexedType)
            _expressionsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionsOkinds :: (KSubst)
            _expressionsOkindvar :: (Int)
            _expressionsOksubst :: (KSubst)
            _expressionsOlabels_collect :: (FMap Name Names)
            _expressionsOlabels_dist :: (FMap Name Names)
            _expressionsOlocal :: (Bool)
            _expressionsOmethods_collect :: (FMap Name Names)
            _expressionsOmethods_dist :: (FMap Name Names)
            _expressionsOmodules :: (Set Strings)
            _expressionsOoptimizer :: (Bool)
            _expressionsOoptimizerPrelude :: (Declarations)
            _expressionsOprekind :: (KSubst)
            _expressionsOprelude :: (Bool)
            _expressionsOpresignatures :: (PreSignatures)
            _expressionsOpresignatures_collect :: (PreSignatures)
            _expressionsOrawRequests_collect :: ([RawRequest])
            _expressionsOsignatures :: (Signatures)
            _expressionsOstructureTypes_collect :: (FMap Name LambdaType)
            _expressionsOtoplevel :: (Bool)
            _expressionsOtypeImps_collect :: ([Request_TypeImply])
            _expressionsOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionsIabstractTypes_collect
             ,_expressionsIbimapImps_collect
             ,_expressionsIconstructors_collect
             ,_expressionsIdepConstraints_collect
             ,_expressionsIfunImps_collect
             ,_expressionsIgenericAbstractions_collect
             ,_expressionsIkinames
             ,_expressionsIkindIndexedTypes_collect
             ,_expressionsIkind_errors
             ,_expressionsIkindvar
             ,_expressionsIksubst
             ,_expressionsIlabels_collect
             ,_expressionsImethods_collect
             ,_expressionsIpresignatures_collect
             ,_expressionsIrawRequests_collect
             ,_expressionsIself
             ,_expressionsIstaticErrors
             ,_expressionsIstructureTypes_collect
             ,_expressionsItypeImps_collect
             ) =
                (expressions_ (_expressionsOabstractTypes_collect)
                              (_expressionsObimapImps_collect)
                              (_expressionsOclassname)
                              (_expressionsOconstructors_collect)
                              (_expressionsOconstructors_dist)
                              (_expressionsOcurrentModule)
                              (_expressionsOdependencies)
                              (_expressionsOexportedStructures)
                              (_expressionsOexportedTypes)
                              (_expressionsOexportedValues)
                              (_expressionsOfunImps_collect)
                              (_expressionsOgenericAbstractions)
                              (_expressionsOgenericAbstractions_collect)
                              (_expressionsOghc)
                              (_expressionsOimportedModule)
                              (_expressionsOinstancename)
                              (_expressionsOkinames)
                              (_expressionsOkindIndexedTypes)
                              (_expressionsOkindIndexedTypes_collect)
                              (_expressionsOkinds)
                              (_expressionsOkindvar)
                              (_expressionsOksubst)
                              (_expressionsOlabels_collect)
                              (_expressionsOlabels_dist)
                              (_expressionsOlocal)
                              (_expressionsOmethods_collect)
                              (_expressionsOmethods_dist)
                              (_expressionsOmodules)
                              (_expressionsOoptimizer)
                              (_expressionsOoptimizerPrelude)
                              (_expressionsOprekind)
                              (_expressionsOprelude)
                              (_expressionsOpresignatures)
                              (_expressionsOpresignatures_collect)
                              (_expressionsOrawRequests_collect)
                              (_expressionsOsignatures)
                              (_expressionsOstructureTypes_collect)
                              (_expressionsOtoplevel)
                              (_expressionsOtypeImps_collect)
                              (_expressionsOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _expressionsIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _expressionsIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _expressionsIstaticErrors
            -- self rule
            (_self@_) =
                Expression_Tuple _rangeIself _expressionsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _expressionsIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _expressionsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionsIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _expressionsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _expressionsIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _expressionsIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _expressionsIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _expressionsIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _expressionsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionsImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _expressionsIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _expressionsIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _expressionsIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _expressionsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_expressionsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_expressionsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionsOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_expressionsOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_expressionsOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_expressionsOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_expressionsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_expressionsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_expressionsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_expressionsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_expressionsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionsOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_expressionsOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_expressionsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_expressionsOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_expressionsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_expressionsOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_expressionsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_expressionsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_expressionsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_expressionsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_expressionsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_expressionsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_expressionsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_expressionsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_expressionsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Expression_TypeApplication :: (T_Range) ->
                                  (T_Name) ->
                                  (T_Type) ->
                                  (T_Expression)
sem_Expression_TypeApplication (range_) (name_) (type_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Expression)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _typeIabstractTypes_collect :: (Set Name)
            _typeIbimapImps_collect :: ([Request_BimapImply])
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIdepConstraints_collect :: ([DepConstraint])
            _typeIfunImps_collect :: ([Request_FunImply])
            _typeIgenericAbstractions_collect :: (FMap Name Kind)
            _typeIinferkind :: (Kind)
            _typeIkinames :: (KSubst)
            _typeIkind_errors :: ([GHError])
            _typeIkindvar :: (Int)
            _typeIksubst :: (KSubst)
            _typeIlabels_collect :: (FMap Name Names)
            _typeImethods_collect :: (FMap Name Names)
            _typeIrawRequests_collect :: ([RawRequest])
            _typeIself :: (Type)
            _typeIstaticErrors :: ([GHError])
            _typeItypeImps_collect :: ([Request_TypeImply])
            _typeOabstractTypes_collect :: (Set Name)
            _typeObimapImps_collect :: ([Request_BimapImply])
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOdependencies :: (FMap Name [(Name,Name)])
            _typeOfunImps_collect :: ([Request_FunImply])
            _typeOgenericAbstractions :: (FMap Name Kind)
            _typeOgenericAbstractions_collect :: (FMap Name Kind)
            _typeOghc :: (Bool)
            _typeOimportedModule :: (Bool)
            _typeOinstancename :: (Maybe Name)
            _typeOkinames :: (KSubst)
            _typeOkinds :: (KSubst)
            _typeOkindvar :: (Int)
            _typeOksubst :: (KSubst)
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOmodules :: (Set Strings)
            _typeOoptimizer :: (Bool)
            _typeOoptimizerPrelude :: (Declarations)
            _typeOprekind :: (KSubst)
            _typeOprelude :: (Bool)
            _typeOrawRequests_collect :: ([RawRequest])
            _typeOtoplevel :: (Bool)
            _typeOtypeImps_collect :: ([Request_TypeImply])
            _typeOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _typeIabstractTypes_collect,_typeIbimapImps_collect,_typeIconstructors_collect,_typeIdepConstraints_collect,_typeIfunImps_collect,_typeIgenericAbstractions_collect,_typeIinferkind,_typeIkinames,_typeIkind_errors,_typeIkindvar,_typeIksubst,_typeIlabels_collect,_typeImethods_collect,_typeIrawRequests_collect,_typeIself,_typeIstaticErrors,_typeItypeImps_collect) =
                (type_ (_typeOabstractTypes_collect)
                       (_typeObimapImps_collect)
                       (_typeOclassname)
                       (_typeOconstructors_collect)
                       (_typeOconstructors_dist)
                       (_typeOcurrentModule)
                       (_typeOdependencies)
                       (_typeOfunImps_collect)
                       (_typeOgenericAbstractions)
                       (_typeOgenericAbstractions_collect)
                       (_typeOghc)
                       (_typeOimportedModule)
                       (_typeOinstancename)
                       (_typeOkinames)
                       (_typeOkinds)
                       (_typeOkindvar)
                       (_typeOksubst)
                       (_typeOlabels_collect)
                       (_typeOlabels_dist)
                       (_typeOlocal)
                       (_typeOmethods_collect)
                       (_typeOmethods_dist)
                       (_typeOmodules)
                       (_typeOoptimizer)
                       (_typeOoptimizerPrelude)
                       (_typeOprekind)
                       (_typeOprelude)
                       (_typeOrawRequests_collect)
                       (_typeOtoplevel)
                       (_typeOtypeImps_collect)
                       (_typeOverbosity))
            -- "./Request.inc.lag"(line 256, column 9)
            (_lhsOdepConstraints_collect@_) =
                [ DepConstraint (_rangeIself,as_n,var)
                | n <- applyFMM  _lhsIdependencies
                                 (\n -> [(n,n)])
                                 _nameIself
                , let as_n = snd n
                , var <- Set.setToList (freeVars _typeIself) ]
            -- "./Request.inc.lag"(line 254, column 9)
            (_lhsOrawRequests_collect@_) =
                RawRequest (_nameIself,_typeIself)
                  : _typeIrawRequests_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _typeIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _typeIstaticErrors
            -- self rule
            (_self@_) =
                Expression_TypeApplication _rangeIself _nameIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _typeIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _typeIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _typeIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _typeIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _typeIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _typeIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _typeIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _typeItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_typeOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_typeObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_typeOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_typeOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_typeOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_typeOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typeOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_typeOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_typeOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_typeOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typeOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_typeOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_typeOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_typeOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_typeOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_typeOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_typeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_typeOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Expression_Typed :: (T_Range) ->
                        (T_Expression) ->
                        (T_Type) ->
                        (T_Expression)
sem_Expression_Typed (range_) (expression_) (type_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Expression)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionIabstractTypes_collect :: (Set Name)
            _expressionIbimapImps_collect :: ([Request_BimapImply])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdepConstraints_collect :: ([DepConstraint])
            _expressionIfunImps_collect :: ([Request_FunImply])
            _expressionIgenericAbstractions_collect :: (FMap Name Kind)
            _expressionIkinames :: (KSubst)
            _expressionIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionIkind_errors :: ([GHError])
            _expressionIkindvar :: (Int)
            _expressionIksubst :: (KSubst)
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIrawRequests_collect :: ([RawRequest])
            _expressionIself :: (Expression)
            _expressionIstaticErrors :: ([GHError])
            _expressionIstructureTypes_collect :: (FMap Name LambdaType)
            _expressionItypeImps_collect :: ([Request_TypeImply])
            _expressionOabstractTypes_collect :: (Set Name)
            _expressionObimapImps_collect :: ([Request_BimapImply])
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies :: (FMap Name [(Name,Name)])
            _expressionOexportedStructures :: (Set Name)
            _expressionOexportedTypes :: (Set Name)
            _expressionOexportedValues :: (Set Name)
            _expressionOfunImps_collect :: ([Request_FunImply])
            _expressionOgenericAbstractions :: (FMap Name Kind)
            _expressionOgenericAbstractions_collect :: (FMap Name Kind)
            _expressionOghc :: (Bool)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOkinames :: (KSubst)
            _expressionOkindIndexedTypes :: (FMap Name KindIndexedType)
            _expressionOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionOkinds :: (KSubst)
            _expressionOkindvar :: (Int)
            _expressionOksubst :: (KSubst)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmodules :: (Set Strings)
            _expressionOoptimizer :: (Bool)
            _expressionOoptimizerPrelude :: (Declarations)
            _expressionOprekind :: (KSubst)
            _expressionOprelude :: (Bool)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOrawRequests_collect :: ([RawRequest])
            _expressionOsignatures :: (Signatures)
            _expressionOstructureTypes_collect :: (FMap Name LambdaType)
            _expressionOtoplevel :: (Bool)
            _expressionOtypeImps_collect :: ([Request_TypeImply])
            _expressionOverbosity :: (Int)
            _typeIabstractTypes_collect :: (Set Name)
            _typeIbimapImps_collect :: ([Request_BimapImply])
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIdepConstraints_collect :: ([DepConstraint])
            _typeIfunImps_collect :: ([Request_FunImply])
            _typeIgenericAbstractions_collect :: (FMap Name Kind)
            _typeIinferkind :: (Kind)
            _typeIkinames :: (KSubst)
            _typeIkind_errors :: ([GHError])
            _typeIkindvar :: (Int)
            _typeIksubst :: (KSubst)
            _typeIlabels_collect :: (FMap Name Names)
            _typeImethods_collect :: (FMap Name Names)
            _typeIrawRequests_collect :: ([RawRequest])
            _typeIself :: (Type)
            _typeIstaticErrors :: ([GHError])
            _typeItypeImps_collect :: ([Request_TypeImply])
            _typeOabstractTypes_collect :: (Set Name)
            _typeObimapImps_collect :: ([Request_BimapImply])
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOdependencies :: (FMap Name [(Name,Name)])
            _typeOfunImps_collect :: ([Request_FunImply])
            _typeOgenericAbstractions :: (FMap Name Kind)
            _typeOgenericAbstractions_collect :: (FMap Name Kind)
            _typeOghc :: (Bool)
            _typeOimportedModule :: (Bool)
            _typeOinstancename :: (Maybe Name)
            _typeOkinames :: (KSubst)
            _typeOkinds :: (KSubst)
            _typeOkindvar :: (Int)
            _typeOksubst :: (KSubst)
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOmodules :: (Set Strings)
            _typeOoptimizer :: (Bool)
            _typeOoptimizerPrelude :: (Declarations)
            _typeOprekind :: (KSubst)
            _typeOprelude :: (Bool)
            _typeOrawRequests_collect :: ([RawRequest])
            _typeOtoplevel :: (Bool)
            _typeOtypeImps_collect :: ([Request_TypeImply])
            _typeOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionIabstractTypes_collect
             ,_expressionIbimapImps_collect
             ,_expressionIconstructors_collect
             ,_expressionIdepConstraints_collect
             ,_expressionIfunImps_collect
             ,_expressionIgenericAbstractions_collect
             ,_expressionIkinames
             ,_expressionIkindIndexedTypes_collect
             ,_expressionIkind_errors
             ,_expressionIkindvar
             ,_expressionIksubst
             ,_expressionIlabels_collect
             ,_expressionImethods_collect
             ,_expressionIpresignatures_collect
             ,_expressionIrawRequests_collect
             ,_expressionIself
             ,_expressionIstaticErrors
             ,_expressionIstructureTypes_collect
             ,_expressionItypeImps_collect
             ) =
                (expression_ (_expressionOabstractTypes_collect)
                             (_expressionObimapImps_collect)
                             (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies)
                             (_expressionOexportedStructures)
                             (_expressionOexportedTypes)
                             (_expressionOexportedValues)
                             (_expressionOfunImps_collect)
                             (_expressionOgenericAbstractions)
                             (_expressionOgenericAbstractions_collect)
                             (_expressionOghc)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOkinames)
                             (_expressionOkindIndexedTypes)
                             (_expressionOkindIndexedTypes_collect)
                             (_expressionOkinds)
                             (_expressionOkindvar)
                             (_expressionOksubst)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmodules)
                             (_expressionOoptimizer)
                             (_expressionOoptimizerPrelude)
                             (_expressionOprekind)
                             (_expressionOprelude)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOrawRequests_collect)
                             (_expressionOsignatures)
                             (_expressionOstructureTypes_collect)
                             (_expressionOtoplevel)
                             (_expressionOtypeImps_collect)
                             (_expressionOverbosity))
            ( _typeIabstractTypes_collect,_typeIbimapImps_collect,_typeIconstructors_collect,_typeIdepConstraints_collect,_typeIfunImps_collect,_typeIgenericAbstractions_collect,_typeIinferkind,_typeIkinames,_typeIkind_errors,_typeIkindvar,_typeIksubst,_typeIlabels_collect,_typeImethods_collect,_typeIrawRequests_collect,_typeIself,_typeIstaticErrors,_typeItypeImps_collect) =
                (type_ (_typeOabstractTypes_collect)
                       (_typeObimapImps_collect)
                       (_typeOclassname)
                       (_typeOconstructors_collect)
                       (_typeOconstructors_dist)
                       (_typeOcurrentModule)
                       (_typeOdependencies)
                       (_typeOfunImps_collect)
                       (_typeOgenericAbstractions)
                       (_typeOgenericAbstractions_collect)
                       (_typeOghc)
                       (_typeOimportedModule)
                       (_typeOinstancename)
                       (_typeOkinames)
                       (_typeOkinds)
                       (_typeOkindvar)
                       (_typeOksubst)
                       (_typeOlabels_collect)
                       (_typeOlabels_dist)
                       (_typeOlocal)
                       (_typeOmethods_collect)
                       (_typeOmethods_dist)
                       (_typeOmodules)
                       (_typeOoptimizer)
                       (_typeOoptimizerPrelude)
                       (_typeOprekind)
                       (_typeOprelude)
                       (_typeOrawRequests_collect)
                       (_typeOtoplevel)
                       (_typeOtypeImps_collect)
                       (_typeOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _expressionIdepConstraints_collect ++ _typeIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _expressionIkind_errors ++ _typeIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _expressionIstaticErrors ++ _typeIstaticErrors
            -- self rule
            (_self@_) =
                Expression_Typed _rangeIself _expressionIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _typeIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _typeIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _typeIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _typeIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _typeIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _expressionIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _typeIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _typeIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _typeIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _expressionIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _typeItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_expressionObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_expressionOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_expressionOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_expressionOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_expressionOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_expressionOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_expressionOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_expressionOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_expressionOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_expressionOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_expressionOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_expressionOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_expressionOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_expressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_expressionOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_expressionOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_expressionOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_expressionOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_expressionOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_typeOabstractTypes_collect@_) =
                _expressionIabstractTypes_collect
            -- copy rule (chain)
            (_typeObimapImps_collect@_) =
                _expressionIbimapImps_collect
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeOdependencies@_) =
                _lhsIdependencies
            -- copy rule (chain)
            (_typeOfunImps_collect@_) =
                _expressionIfunImps_collect
            -- copy rule (down)
            (_typeOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_typeOgenericAbstractions_collect@_) =
                _expressionIgenericAbstractions_collect
            -- copy rule (down)
            (_typeOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typeOkinames@_) =
                _expressionIkinames
            -- copy rule (down)
            (_typeOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_typeOkindvar@_) =
                _expressionIkindvar
            -- copy rule (chain)
            (_typeOksubst@_) =
                _expressionIksubst
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typeOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_typeOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_typeOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_typeOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_typeOprelude@_) =
                _lhsIprelude
            -- copy rule (chain)
            (_typeOrawRequests_collect@_) =
                _expressionIrawRequests_collect
            -- copy rule (down)
            (_typeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_typeOtypeImps_collect@_) =
                _expressionItypeImps_collect
            -- copy rule (down)
            (_typeOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Expression_Variable :: (T_Range) ->
                           (T_Name) ->
                           (T_Expression)
sem_Expression_Variable (range_) (name_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Expression)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                Expression_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Expression_Wildcard :: (T_Range) ->
                           (T_Expression)
sem_Expression_Wildcard (range_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Expression)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                Expression_Wildcard _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
-- Expressions -------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      exportedStructures   : Set Name
      exportedTypes        : Set Name
      exportedValues       : Set Name
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures
      rawRequests_collect  : [RawRequest]
      structureTypes_collect : FMap Name LambdaType
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      kind_errors          : [GHError]
      self                 : SELF
      staticErrors         : [GHError]

-}
{-
   local variables for Expressions.Cons:
      self

-}
{-
   local variables for Expressions.Nil:
      self

-}
-- semantic domain
type T_Expressions = (Set Name) ->
                     ([Request_BimapImply]) ->
                     (Maybe Name) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Strings) ->
                     (FMap Name [(Name,Name)]) ->
                     (Set Name) ->
                     (Set Name) ->
                     (Set Name) ->
                     ([Request_FunImply]) ->
                     (FMap Name Kind) ->
                     (FMap Name Kind) ->
                     (Bool) ->
                     (Bool) ->
                     (Maybe Name) ->
                     (KSubst) ->
                     (FMap Name KindIndexedType) ->
                     (FMap Name KindIndexedType) ->
                     (KSubst) ->
                     (Int) ->
                     (KSubst) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Bool) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Set Strings) ->
                     (Bool) ->
                     (Declarations) ->
                     (KSubst) ->
                     (Bool) ->
                     (PreSignatures) ->
                     (PreSignatures) ->
                     ([RawRequest]) ->
                     (Signatures) ->
                     (FMap Name LambdaType) ->
                     (Bool) ->
                     ([Request_TypeImply]) ->
                     (Int) ->
                     ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(PreSignatures),([RawRequest]),(Expressions),([GHError]),(FMap Name LambdaType),([Request_TypeImply]))
-- cata
sem_Expressions :: (Expressions) ->
                   (T_Expressions)
sem_Expressions (list) =
    (foldr (sem_Expressions_Cons) (sem_Expressions_Nil) ((map sem_Expression list)))
sem_Expressions_Cons :: (T_Expression) ->
                        (T_Expressions) ->
                        (T_Expressions)
sem_Expressions_Cons (hd_) (tl_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Expressions)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _hdIabstractTypes_collect :: (Set Name)
            _hdIbimapImps_collect :: ([Request_BimapImply])
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdepConstraints_collect :: ([DepConstraint])
            _hdIfunImps_collect :: ([Request_FunImply])
            _hdIgenericAbstractions_collect :: (FMap Name Kind)
            _hdIkinames :: (KSubst)
            _hdIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _hdIkind_errors :: ([GHError])
            _hdIkindvar :: (Int)
            _hdIksubst :: (KSubst)
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIpresignatures_collect :: (PreSignatures)
            _hdIrawRequests_collect :: ([RawRequest])
            _hdIself :: (Expression)
            _hdIstaticErrors :: ([GHError])
            _hdIstructureTypes_collect :: (FMap Name LambdaType)
            _hdItypeImps_collect :: ([Request_TypeImply])
            _hdOabstractTypes_collect :: (Set Name)
            _hdObimapImps_collect :: ([Request_BimapImply])
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies :: (FMap Name [(Name,Name)])
            _hdOexportedStructures :: (Set Name)
            _hdOexportedTypes :: (Set Name)
            _hdOexportedValues :: (Set Name)
            _hdOfunImps_collect :: ([Request_FunImply])
            _hdOgenericAbstractions :: (FMap Name Kind)
            _hdOgenericAbstractions_collect :: (FMap Name Kind)
            _hdOghc :: (Bool)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOkinames :: (KSubst)
            _hdOkindIndexedTypes :: (FMap Name KindIndexedType)
            _hdOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _hdOkinds :: (KSubst)
            _hdOkindvar :: (Int)
            _hdOksubst :: (KSubst)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmodules :: (Set Strings)
            _hdOoptimizer :: (Bool)
            _hdOoptimizerPrelude :: (Declarations)
            _hdOprekind :: (KSubst)
            _hdOprelude :: (Bool)
            _hdOpresignatures :: (PreSignatures)
            _hdOpresignatures_collect :: (PreSignatures)
            _hdOrawRequests_collect :: ([RawRequest])
            _hdOsignatures :: (Signatures)
            _hdOstructureTypes_collect :: (FMap Name LambdaType)
            _hdOtoplevel :: (Bool)
            _hdOtypeImps_collect :: ([Request_TypeImply])
            _hdOverbosity :: (Int)
            _tlIabstractTypes_collect :: (Set Name)
            _tlIbimapImps_collect :: ([Request_BimapImply])
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdepConstraints_collect :: ([DepConstraint])
            _tlIfunImps_collect :: ([Request_FunImply])
            _tlIgenericAbstractions_collect :: (FMap Name Kind)
            _tlIkinames :: (KSubst)
            _tlIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _tlIkind_errors :: ([GHError])
            _tlIkindvar :: (Int)
            _tlIksubst :: (KSubst)
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIpresignatures_collect :: (PreSignatures)
            _tlIrawRequests_collect :: ([RawRequest])
            _tlIself :: (Expressions)
            _tlIstaticErrors :: ([GHError])
            _tlIstructureTypes_collect :: (FMap Name LambdaType)
            _tlItypeImps_collect :: ([Request_TypeImply])
            _tlOabstractTypes_collect :: (Set Name)
            _tlObimapImps_collect :: ([Request_BimapImply])
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies :: (FMap Name [(Name,Name)])
            _tlOexportedStructures :: (Set Name)
            _tlOexportedTypes :: (Set Name)
            _tlOexportedValues :: (Set Name)
            _tlOfunImps_collect :: ([Request_FunImply])
            _tlOgenericAbstractions :: (FMap Name Kind)
            _tlOgenericAbstractions_collect :: (FMap Name Kind)
            _tlOghc :: (Bool)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOkinames :: (KSubst)
            _tlOkindIndexedTypes :: (FMap Name KindIndexedType)
            _tlOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _tlOkinds :: (KSubst)
            _tlOkindvar :: (Int)
            _tlOksubst :: (KSubst)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmodules :: (Set Strings)
            _tlOoptimizer :: (Bool)
            _tlOoptimizerPrelude :: (Declarations)
            _tlOprekind :: (KSubst)
            _tlOprelude :: (Bool)
            _tlOpresignatures :: (PreSignatures)
            _tlOpresignatures_collect :: (PreSignatures)
            _tlOrawRequests_collect :: ([RawRequest])
            _tlOsignatures :: (Signatures)
            _tlOstructureTypes_collect :: (FMap Name LambdaType)
            _tlOtoplevel :: (Bool)
            _tlOtypeImps_collect :: ([Request_TypeImply])
            _tlOverbosity :: (Int)
            ( _hdIabstractTypes_collect,_hdIbimapImps_collect,_hdIconstructors_collect,_hdIdepConstraints_collect,_hdIfunImps_collect,_hdIgenericAbstractions_collect,_hdIkinames,_hdIkindIndexedTypes_collect,_hdIkind_errors,_hdIkindvar,_hdIksubst,_hdIlabels_collect,_hdImethods_collect,_hdIpresignatures_collect,_hdIrawRequests_collect,_hdIself,_hdIstaticErrors,_hdIstructureTypes_collect,_hdItypeImps_collect) =
                (hd_ (_hdOabstractTypes_collect)
                     (_hdObimapImps_collect)
                     (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOdependencies)
                     (_hdOexportedStructures)
                     (_hdOexportedTypes)
                     (_hdOexportedValues)
                     (_hdOfunImps_collect)
                     (_hdOgenericAbstractions)
                     (_hdOgenericAbstractions_collect)
                     (_hdOghc)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOkinames)
                     (_hdOkindIndexedTypes)
                     (_hdOkindIndexedTypes_collect)
                     (_hdOkinds)
                     (_hdOkindvar)
                     (_hdOksubst)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmodules)
                     (_hdOoptimizer)
                     (_hdOoptimizerPrelude)
                     (_hdOprekind)
                     (_hdOprelude)
                     (_hdOpresignatures)
                     (_hdOpresignatures_collect)
                     (_hdOrawRequests_collect)
                     (_hdOsignatures)
                     (_hdOstructureTypes_collect)
                     (_hdOtoplevel)
                     (_hdOtypeImps_collect)
                     (_hdOverbosity))
            ( _tlIabstractTypes_collect,_tlIbimapImps_collect,_tlIconstructors_collect,_tlIdepConstraints_collect,_tlIfunImps_collect,_tlIgenericAbstractions_collect,_tlIkinames,_tlIkindIndexedTypes_collect,_tlIkind_errors,_tlIkindvar,_tlIksubst,_tlIlabels_collect,_tlImethods_collect,_tlIpresignatures_collect,_tlIrawRequests_collect,_tlIself,_tlIstaticErrors,_tlIstructureTypes_collect,_tlItypeImps_collect) =
                (tl_ (_tlOabstractTypes_collect)
                     (_tlObimapImps_collect)
                     (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOdependencies)
                     (_tlOexportedStructures)
                     (_tlOexportedTypes)
                     (_tlOexportedValues)
                     (_tlOfunImps_collect)
                     (_tlOgenericAbstractions)
                     (_tlOgenericAbstractions_collect)
                     (_tlOghc)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOkinames)
                     (_tlOkindIndexedTypes)
                     (_tlOkindIndexedTypes_collect)
                     (_tlOkinds)
                     (_tlOkindvar)
                     (_tlOksubst)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmodules)
                     (_tlOoptimizer)
                     (_tlOoptimizerPrelude)
                     (_tlOprekind)
                     (_tlOprelude)
                     (_tlOpresignatures)
                     (_tlOpresignatures_collect)
                     (_tlOrawRequests_collect)
                     (_tlOsignatures)
                     (_tlOstructureTypes_collect)
                     (_tlOtoplevel)
                     (_tlOtypeImps_collect)
                     (_tlOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _hdIdepConstraints_collect ++ _tlIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _hdIkind_errors ++ _tlIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _hdIstaticErrors ++ _tlIstaticErrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _tlIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _tlIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _tlIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _tlIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _tlIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _tlIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _tlIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _tlIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _tlIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _tlIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _tlIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _tlItypeImps_collect
            -- copy rule (down)
            (_hdOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_hdObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_hdOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_hdOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_hdOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_hdOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_hdOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_hdOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_hdOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_hdOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_hdOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_hdOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_hdOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_hdOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_hdOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_hdOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_hdOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_hdOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_hdOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_hdOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_hdOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_hdOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_hdOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_hdOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_hdOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_tlOabstractTypes_collect@_) =
                _hdIabstractTypes_collect
            -- copy rule (chain)
            (_tlObimapImps_collect@_) =
                _hdIbimapImps_collect
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_tlOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_tlOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_tlOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (chain)
            (_tlOfunImps_collect@_) =
                _hdIfunImps_collect
            -- copy rule (down)
            (_tlOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_tlOgenericAbstractions_collect@_) =
                _hdIgenericAbstractions_collect
            -- copy rule (down)
            (_tlOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOkinames@_) =
                _hdIkinames
            -- copy rule (down)
            (_tlOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (chain)
            (_tlOkindIndexedTypes_collect@_) =
                _hdIkindIndexedTypes_collect
            -- copy rule (down)
            (_tlOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_tlOkindvar@_) =
                _hdIkindvar
            -- copy rule (chain)
            (_tlOksubst@_) =
                _hdIksubst
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_tlOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_tlOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_tlOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_tlOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_tlOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_tlOpresignatures_collect@_) =
                _hdIpresignatures_collect
            -- copy rule (chain)
            (_tlOrawRequests_collect@_) =
                _hdIrawRequests_collect
            -- copy rule (down)
            (_tlOsignatures@_) =
                _lhsIsignatures
            -- copy rule (chain)
            (_tlOstructureTypes_collect@_) =
                _hdIstructureTypes_collect
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_tlOtypeImps_collect@_) =
                _hdItypeImps_collect
            -- copy rule (down)
            (_tlOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Expressions_Nil :: (T_Expressions)
sem_Expressions_Nil  =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Expressions)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
-- FieldDeclaration --------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kinds                : KSubst
      kname                : Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      rawRequests_collect  : [RawRequest]
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      constructors         : Names
      depConstraints_collect : [DepConstraint]
      kind_errors          : [GHError]
      labels               : Names
      self                 : SELF
      staticErrors         : [GHError]
      typeImps             : [Type]

-}
{-
   local variables for FieldDeclaration.FieldDeclaration:
      self

-}
-- semantic domain
type T_FieldDeclaration = (Set Name) ->
                          ([Request_BimapImply]) ->
                          (Maybe Name) ->
                          (FMap Name Names) ->
                          (FMap Name Names) ->
                          (Strings) ->
                          (FMap Name [(Name,Name)]) ->
                          ([Request_FunImply]) ->
                          (FMap Name Kind) ->
                          (FMap Name Kind) ->
                          (Bool) ->
                          (Bool) ->
                          (Maybe Name) ->
                          (KSubst) ->
                          (KSubst) ->
                          (Int) ->
                          (Name) ->
                          (KSubst) ->
                          (FMap Name Names) ->
                          (FMap Name Names) ->
                          (Bool) ->
                          (FMap Name Names) ->
                          (FMap Name Names) ->
                          (Set Strings) ->
                          (Bool) ->
                          (Declarations) ->
                          (KSubst) ->
                          (Bool) ->
                          ([RawRequest]) ->
                          (Bool) ->
                          ([Request_TypeImply]) ->
                          (Int) ->
                          ( (Set Name),([Request_BimapImply]),(Names),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),([GHError]),(Int),(KSubst),(Names),(FMap Name Names),(FMap Name Names),([RawRequest]),(FieldDeclaration),([GHError]),([Type]),([Request_TypeImply]))
-- cata
sem_FieldDeclaration :: (FieldDeclaration) ->
                        (T_FieldDeclaration)
sem_FieldDeclaration ((FieldDeclaration_FieldDeclaration (_range) (_names) (_type))) =
    (sem_FieldDeclaration_FieldDeclaration ((sem_Range (_range))) ((sem_Names (_names))) ((sem_AnnotatedType (_type))))
sem_FieldDeclaration_FieldDeclaration :: (T_Range) ->
                                         (T_Names) ->
                                         (T_AnnotatedType) ->
                                         (T_FieldDeclaration)
sem_FieldDeclaration_FieldDeclaration (range_) (names_) (type_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIkname
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors :: (Names)
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels :: (Names)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (FieldDeclaration)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps :: ([Type])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _namesIconstructors_collect :: (FMap Name Names)
            _namesIgenericAbstractions_collect :: (FMap Name Kind)
            _namesIinferkind :: (Kind)
            _namesIkinames :: (KSubst)
            _namesIkind_errors :: ([GHError])
            _namesIkindvar :: (Int)
            _namesIksubst :: (KSubst)
            _namesIlabels_collect :: (FMap Name Names)
            _namesImethods_collect :: (FMap Name Names)
            _namesIself :: (Names)
            _namesOclassname :: (Maybe Name)
            _namesOconstructors_collect :: (FMap Name Names)
            _namesOconstructors_dist :: (FMap Name Names)
            _namesOcurrentModule :: (Strings)
            _namesOgenericAbstractions :: (FMap Name Kind)
            _namesOgenericAbstractions_collect :: (FMap Name Kind)
            _namesOghc :: (Bool)
            _namesOimportedModule :: (Bool)
            _namesOinstancename :: (Maybe Name)
            _namesOkinames :: (KSubst)
            _namesOkinds :: (KSubst)
            _namesOkindvar :: (Int)
            _namesOksubst :: (KSubst)
            _namesOlabels_collect :: (FMap Name Names)
            _namesOlabels_dist :: (FMap Name Names)
            _namesOlocal :: (Bool)
            _namesOmethods_collect :: (FMap Name Names)
            _namesOmethods_dist :: (FMap Name Names)
            _namesOmodules :: (Set Strings)
            _namesOoptimizer :: (Bool)
            _namesOoptimizerPrelude :: (Declarations)
            _namesOprekind :: (KSubst)
            _namesOprelude :: (Bool)
            _namesOtoplevel :: (Bool)
            _namesOverbosity :: (Int)
            _typeIabstractTypes_collect :: (Set Name)
            _typeIbimapImps_collect :: ([Request_BimapImply])
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIdepConstraints_collect :: ([DepConstraint])
            _typeIfunImps_collect :: ([Request_FunImply])
            _typeIgenericAbstractions_collect :: (FMap Name Kind)
            _typeIkinames :: (KSubst)
            _typeIkind_errors :: ([GHError])
            _typeIkindvar :: (Int)
            _typeIksubst :: (KSubst)
            _typeIlabels_collect :: (FMap Name Names)
            _typeImethods_collect :: (FMap Name Names)
            _typeIrawRequests_collect :: ([RawRequest])
            _typeIself :: (AnnotatedType)
            _typeIstaticErrors :: ([GHError])
            _typeItypeImps :: ([Type])
            _typeItypeImps_collect :: ([Request_TypeImply])
            _typeOabstractTypes_collect :: (Set Name)
            _typeObimapImps_collect :: ([Request_BimapImply])
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOdependencies :: (FMap Name [(Name,Name)])
            _typeOfunImps_collect :: ([Request_FunImply])
            _typeOgenericAbstractions :: (FMap Name Kind)
            _typeOgenericAbstractions_collect :: (FMap Name Kind)
            _typeOghc :: (Bool)
            _typeOimportedModule :: (Bool)
            _typeOinstancename :: (Maybe Name)
            _typeOkinames :: (KSubst)
            _typeOkinds :: (KSubst)
            _typeOkindvar :: (Int)
            _typeOklabels :: (Names)
            _typeOkname :: (Name)
            _typeOksubst :: (KSubst)
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOmodules :: (Set Strings)
            _typeOoptimizer :: (Bool)
            _typeOoptimizerPrelude :: (Declarations)
            _typeOprekind :: (KSubst)
            _typeOprelude :: (Bool)
            _typeOrawRequests_collect :: ([RawRequest])
            _typeOtoplevel :: (Bool)
            _typeOtypeImps_collect :: ([Request_TypeImply])
            _typeOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _namesIconstructors_collect,_namesIgenericAbstractions_collect,_namesIinferkind,_namesIkinames,_namesIkind_errors,_namesIkindvar,_namesIksubst,_namesIlabels_collect,_namesImethods_collect,_namesIself) =
                (names_ (_namesOclassname)
                        (_namesOconstructors_collect)
                        (_namesOconstructors_dist)
                        (_namesOcurrentModule)
                        (_namesOgenericAbstractions)
                        (_namesOgenericAbstractions_collect)
                        (_namesOghc)
                        (_namesOimportedModule)
                        (_namesOinstancename)
                        (_namesOkinames)
                        (_namesOkinds)
                        (_namesOkindvar)
                        (_namesOksubst)
                        (_namesOlabels_collect)
                        (_namesOlabels_dist)
                        (_namesOlocal)
                        (_namesOmethods_collect)
                        (_namesOmethods_dist)
                        (_namesOmodules)
                        (_namesOoptimizer)
                        (_namesOoptimizerPrelude)
                        (_namesOprekind)
                        (_namesOprelude)
                        (_namesOtoplevel)
                        (_namesOverbosity))
            ( _typeIabstractTypes_collect,_typeIbimapImps_collect,_typeIconstructors_collect,_typeIdepConstraints_collect,_typeIfunImps_collect,_typeIgenericAbstractions_collect,_typeIkinames,_typeIkind_errors,_typeIkindvar,_typeIksubst,_typeIlabels_collect,_typeImethods_collect,_typeIrawRequests_collect,_typeIself,_typeIstaticErrors,_typeItypeImps,_typeItypeImps_collect) =
                (type_ (_typeOabstractTypes_collect)
                       (_typeObimapImps_collect)
                       (_typeOclassname)
                       (_typeOconstructors_collect)
                       (_typeOconstructors_dist)
                       (_typeOcurrentModule)
                       (_typeOdependencies)
                       (_typeOfunImps_collect)
                       (_typeOgenericAbstractions)
                       (_typeOgenericAbstractions_collect)
                       (_typeOghc)
                       (_typeOimportedModule)
                       (_typeOinstancename)
                       (_typeOkinames)
                       (_typeOkinds)
                       (_typeOkindvar)
                       (_typeOklabels)
                       (_typeOkname)
                       (_typeOksubst)
                       (_typeOlabels_collect)
                       (_typeOlabels_dist)
                       (_typeOlocal)
                       (_typeOmethods_collect)
                       (_typeOmethods_dist)
                       (_typeOmodules)
                       (_typeOoptimizer)
                       (_typeOoptimizerPrelude)
                       (_typeOprekind)
                       (_typeOprelude)
                       (_typeOrawRequests_collect)
                       (_typeOtoplevel)
                       (_typeOtypeImps_collect)
                       (_typeOverbosity))
            -- "./ModuleInformation.inc.lag"(line 369, column 9)
            (_lhsOlabels@_) =
                _namesIself
            -- "./ModuleInformation.inc.lag"(line 368, column 9)
            (_lhsOconstructors@_) =
                _namesIself
            -- "./Kind.inc.lag"(line 554, column 9)
            (_typeOklabels@_) =
                _namesIself
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _typeIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _namesIkind_errors ++ _typeIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _typeIstaticErrors
            -- use rule
            (_lhsOtypeImps@_) =
                _typeItypeImps
            -- self rule
            (_self@_) =
                FieldDeclaration_FieldDeclaration _rangeIself _namesIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _typeIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _typeIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _typeIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _typeIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _typeIkinames
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _typeIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _typeIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _typeIrawRequests_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _typeItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_namesOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_namesOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_namesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_namesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_namesOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_namesOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_namesOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_namesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_namesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_namesOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_namesOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_namesOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_namesOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_namesOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_namesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_namesOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_namesOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_namesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_namesOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_namesOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_namesOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_namesOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_namesOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_namesOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_namesOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_typeOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_typeObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _namesIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_typeOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_typeOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_typeOgenericAbstractions_collect@_) =
                _namesIgenericAbstractions_collect
            -- copy rule (down)
            (_typeOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typeOkinames@_) =
                _namesIkinames
            -- copy rule (down)
            (_typeOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_typeOkindvar@_) =
                _namesIkindvar
            -- copy rule (down)
            (_typeOkname@_) =
                _lhsIkname
            -- copy rule (chain)
            (_typeOksubst@_) =
                _namesIksubst
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _namesIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _namesImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typeOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_typeOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_typeOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_typeOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_typeOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_typeOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_typeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_typeOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps,_lhsOtypeImps_collect)
-- FieldDeclarations -------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kinds                : KSubst
      kname                : Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      rawRequests_collect  : [RawRequest]
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      constructors         : Names
      depConstraints_collect : [DepConstraint]
      kind_errors          : [GHError]
      labels               : Names
      self                 : SELF
      staticErrors         : [GHError]
      typeImps             : [Type]

-}
{-
   local variables for FieldDeclarations.Cons:
      self

-}
{-
   local variables for FieldDeclarations.Nil:
      self

-}
-- semantic domain
type T_FieldDeclarations = (Set Name) ->
                           ([Request_BimapImply]) ->
                           (Maybe Name) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Strings) ->
                           (FMap Name [(Name,Name)]) ->
                           ([Request_FunImply]) ->
                           (FMap Name Kind) ->
                           (FMap Name Kind) ->
                           (Bool) ->
                           (Bool) ->
                           (Maybe Name) ->
                           (KSubst) ->
                           (KSubst) ->
                           (Int) ->
                           (Name) ->
                           (KSubst) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Bool) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Set Strings) ->
                           (Bool) ->
                           (Declarations) ->
                           (KSubst) ->
                           (Bool) ->
                           ([RawRequest]) ->
                           (Bool) ->
                           ([Request_TypeImply]) ->
                           (Int) ->
                           ( (Set Name),([Request_BimapImply]),(Names),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),([GHError]),(Int),(KSubst),(Names),(FMap Name Names),(FMap Name Names),([RawRequest]),(FieldDeclarations),([GHError]),([Type]),([Request_TypeImply]))
-- cata
sem_FieldDeclarations :: (FieldDeclarations) ->
                         (T_FieldDeclarations)
sem_FieldDeclarations (list) =
    (foldr (sem_FieldDeclarations_Cons) (sem_FieldDeclarations_Nil) ((map sem_FieldDeclaration list)))
sem_FieldDeclarations_Cons :: (T_FieldDeclaration) ->
                              (T_FieldDeclarations) ->
                              (T_FieldDeclarations)
sem_FieldDeclarations_Cons (hd_) (tl_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIkname
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors :: (Names)
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels :: (Names)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (FieldDeclarations)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps :: ([Type])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _hdIabstractTypes_collect :: (Set Name)
            _hdIbimapImps_collect :: ([Request_BimapImply])
            _hdIconstructors :: (Names)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdepConstraints_collect :: ([DepConstraint])
            _hdIfunImps_collect :: ([Request_FunImply])
            _hdIgenericAbstractions_collect :: (FMap Name Kind)
            _hdIkinames :: (KSubst)
            _hdIkind_errors :: ([GHError])
            _hdIkindvar :: (Int)
            _hdIksubst :: (KSubst)
            _hdIlabels :: (Names)
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIrawRequests_collect :: ([RawRequest])
            _hdIself :: (FieldDeclaration)
            _hdIstaticErrors :: ([GHError])
            _hdItypeImps :: ([Type])
            _hdItypeImps_collect :: ([Request_TypeImply])
            _hdOabstractTypes_collect :: (Set Name)
            _hdObimapImps_collect :: ([Request_BimapImply])
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies :: (FMap Name [(Name,Name)])
            _hdOfunImps_collect :: ([Request_FunImply])
            _hdOgenericAbstractions :: (FMap Name Kind)
            _hdOgenericAbstractions_collect :: (FMap Name Kind)
            _hdOghc :: (Bool)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOkinames :: (KSubst)
            _hdOkinds :: (KSubst)
            _hdOkindvar :: (Int)
            _hdOkname :: (Name)
            _hdOksubst :: (KSubst)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmodules :: (Set Strings)
            _hdOoptimizer :: (Bool)
            _hdOoptimizerPrelude :: (Declarations)
            _hdOprekind :: (KSubst)
            _hdOprelude :: (Bool)
            _hdOrawRequests_collect :: ([RawRequest])
            _hdOtoplevel :: (Bool)
            _hdOtypeImps_collect :: ([Request_TypeImply])
            _hdOverbosity :: (Int)
            _tlIabstractTypes_collect :: (Set Name)
            _tlIbimapImps_collect :: ([Request_BimapImply])
            _tlIconstructors :: (Names)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdepConstraints_collect :: ([DepConstraint])
            _tlIfunImps_collect :: ([Request_FunImply])
            _tlIgenericAbstractions_collect :: (FMap Name Kind)
            _tlIkinames :: (KSubst)
            _tlIkind_errors :: ([GHError])
            _tlIkindvar :: (Int)
            _tlIksubst :: (KSubst)
            _tlIlabels :: (Names)
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIrawRequests_collect :: ([RawRequest])
            _tlIself :: (FieldDeclarations)
            _tlIstaticErrors :: ([GHError])
            _tlItypeImps :: ([Type])
            _tlItypeImps_collect :: ([Request_TypeImply])
            _tlOabstractTypes_collect :: (Set Name)
            _tlObimapImps_collect :: ([Request_BimapImply])
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies :: (FMap Name [(Name,Name)])
            _tlOfunImps_collect :: ([Request_FunImply])
            _tlOgenericAbstractions :: (FMap Name Kind)
            _tlOgenericAbstractions_collect :: (FMap Name Kind)
            _tlOghc :: (Bool)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOkinames :: (KSubst)
            _tlOkinds :: (KSubst)
            _tlOkindvar :: (Int)
            _tlOkname :: (Name)
            _tlOksubst :: (KSubst)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmodules :: (Set Strings)
            _tlOoptimizer :: (Bool)
            _tlOoptimizerPrelude :: (Declarations)
            _tlOprekind :: (KSubst)
            _tlOprelude :: (Bool)
            _tlOrawRequests_collect :: ([RawRequest])
            _tlOtoplevel :: (Bool)
            _tlOtypeImps_collect :: ([Request_TypeImply])
            _tlOverbosity :: (Int)
            ( _hdIabstractTypes_collect,_hdIbimapImps_collect,_hdIconstructors,_hdIconstructors_collect,_hdIdepConstraints_collect,_hdIfunImps_collect,_hdIgenericAbstractions_collect,_hdIkinames,_hdIkind_errors,_hdIkindvar,_hdIksubst,_hdIlabels,_hdIlabels_collect,_hdImethods_collect,_hdIrawRequests_collect,_hdIself,_hdIstaticErrors,_hdItypeImps,_hdItypeImps_collect) =
                (hd_ (_hdOabstractTypes_collect)
                     (_hdObimapImps_collect)
                     (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOdependencies)
                     (_hdOfunImps_collect)
                     (_hdOgenericAbstractions)
                     (_hdOgenericAbstractions_collect)
                     (_hdOghc)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOkinames)
                     (_hdOkinds)
                     (_hdOkindvar)
                     (_hdOkname)
                     (_hdOksubst)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmodules)
                     (_hdOoptimizer)
                     (_hdOoptimizerPrelude)
                     (_hdOprekind)
                     (_hdOprelude)
                     (_hdOrawRequests_collect)
                     (_hdOtoplevel)
                     (_hdOtypeImps_collect)
                     (_hdOverbosity))
            ( _tlIabstractTypes_collect,_tlIbimapImps_collect,_tlIconstructors,_tlIconstructors_collect,_tlIdepConstraints_collect,_tlIfunImps_collect,_tlIgenericAbstractions_collect,_tlIkinames,_tlIkind_errors,_tlIkindvar,_tlIksubst,_tlIlabels,_tlIlabels_collect,_tlImethods_collect,_tlIrawRequests_collect,_tlIself,_tlIstaticErrors,_tlItypeImps,_tlItypeImps_collect) =
                (tl_ (_tlOabstractTypes_collect)
                     (_tlObimapImps_collect)
                     (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOdependencies)
                     (_tlOfunImps_collect)
                     (_tlOgenericAbstractions)
                     (_tlOgenericAbstractions_collect)
                     (_tlOghc)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOkinames)
                     (_tlOkinds)
                     (_tlOkindvar)
                     (_tlOkname)
                     (_tlOksubst)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmodules)
                     (_tlOoptimizer)
                     (_tlOoptimizerPrelude)
                     (_tlOprekind)
                     (_tlOprelude)
                     (_tlOrawRequests_collect)
                     (_tlOtoplevel)
                     (_tlOtypeImps_collect)
                     (_tlOverbosity))
            -- use rule
            (_lhsOconstructors@_) =
                _hdIconstructors ++ _tlIconstructors
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _hdIdepConstraints_collect ++ _tlIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _hdIkind_errors ++ _tlIkind_errors
            -- use rule
            (_lhsOlabels@_) =
                _hdIlabels `List.union` _tlIlabels
            -- use rule
            (_lhsOstaticErrors@_) =
                _hdIstaticErrors ++ _tlIstaticErrors
            -- use rule
            (_lhsOtypeImps@_) =
                _hdItypeImps ++ _tlItypeImps
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _tlIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _tlIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _tlIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _tlIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _tlIkinames
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _tlIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _tlIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _tlIrawRequests_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _tlItypeImps_collect
            -- copy rule (down)
            (_hdOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_hdObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_hdOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_hdOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_hdOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_hdOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_hdOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_hdOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_hdOkname@_) =
                _lhsIkname
            -- copy rule (down)
            (_hdOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_hdOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_hdOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_hdOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_hdOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_hdOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_hdOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_hdOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_tlOabstractTypes_collect@_) =
                _hdIabstractTypes_collect
            -- copy rule (chain)
            (_tlObimapImps_collect@_) =
                _hdIbimapImps_collect
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOdependencies@_) =
                _lhsIdependencies
            -- copy rule (chain)
            (_tlOfunImps_collect@_) =
                _hdIfunImps_collect
            -- copy rule (down)
            (_tlOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_tlOgenericAbstractions_collect@_) =
                _hdIgenericAbstractions_collect
            -- copy rule (down)
            (_tlOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOkinames@_) =
                _hdIkinames
            -- copy rule (down)
            (_tlOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_tlOkindvar@_) =
                _hdIkindvar
            -- copy rule (down)
            (_tlOkname@_) =
                _lhsIkname
            -- copy rule (chain)
            (_tlOksubst@_) =
                _hdIksubst
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_tlOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_tlOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_tlOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_tlOprelude@_) =
                _lhsIprelude
            -- copy rule (chain)
            (_tlOrawRequests_collect@_) =
                _hdIrawRequests_collect
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_tlOtypeImps_collect@_) =
                _hdItypeImps_collect
            -- copy rule (down)
            (_tlOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps,_lhsOtypeImps_collect)
sem_FieldDeclarations_Nil :: (T_FieldDeclarations)
sem_FieldDeclarations_Nil  =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIkname
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors :: (Names)
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels :: (Names)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (FieldDeclarations)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps :: ([Type])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            -- use rule
            (_lhsOconstructors@_) =
                []
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOlabels@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- use rule
            (_lhsOtypeImps@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps,_lhsOtypeImps_collect)
-- Fixity ------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Fixity.Infix:
      self

-}
{-
   local variables for Fixity.Infixl:
      self

-}
{-
   local variables for Fixity.Infixr:
      self

-}
-- semantic domain
type T_Fixity = (Maybe Name) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (Strings) ->
                (FMap Name Kind) ->
                (FMap Name Kind) ->
                (Bool) ->
                (Bool) ->
                (Maybe Name) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (Bool) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (Set Strings) ->
                (Bool) ->
                (Declarations) ->
                (Bool) ->
                (Bool) ->
                (Int) ->
                ( (FMap Name Names),(FMap Name Kind),(FMap Name Names),(FMap Name Names),(Fixity))
-- cata
sem_Fixity :: (Fixity) ->
              (T_Fixity)
sem_Fixity ((Fixity_Infix (_range))) =
    (sem_Fixity_Infix ((sem_Range (_range))))
sem_Fixity ((Fixity_Infixl (_range))) =
    (sem_Fixity_Infixl ((sem_Range (_range))))
sem_Fixity ((Fixity_Infixr (_range))) =
    (sem_Fixity_Infixr ((sem_Range (_range))))
sem_Fixity_Infix :: (T_Range) ->
                    (T_Fixity)
sem_Fixity_Infix (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Fixity)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- self rule
            (_self@_) =
                Fixity_Infix _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Fixity_Infixl :: (T_Range) ->
                     (T_Fixity)
sem_Fixity_Infixl (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Fixity)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- self rule
            (_self@_) =
                Fixity_Infixl _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Fixity_Infixr :: (T_Range) ->
                     (T_Fixity)
sem_Fixity_Infixr (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Fixity)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- self rule
            (_self@_) =
                Fixity_Infixr _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- FunctionBinding ---------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      exportedStructures   : Set Name
      exportedTypes        : Set Name
      exportedValues       : Set Name
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures
      rawRequests_collect  : [RawRequest]
      structureTypes_collect : FMap Name LambdaType
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      kind_errors          : [GHError]
      name                 : Name
      self                 : SELF
      staticErrors         : [GHError]

-}
{-
   local variables for FunctionBinding.FunctionBinding:
      self

-}
-- semantic domain
type T_FunctionBinding = (Set Name) ->
                         ([Request_BimapImply]) ->
                         (Maybe Name) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (Strings) ->
                         (FMap Name [(Name,Name)]) ->
                         (Set Name) ->
                         (Set Name) ->
                         (Set Name) ->
                         ([Request_FunImply]) ->
                         (FMap Name Kind) ->
                         (FMap Name Kind) ->
                         (Bool) ->
                         (Bool) ->
                         (Maybe Name) ->
                         (KSubst) ->
                         (FMap Name KindIndexedType) ->
                         (FMap Name KindIndexedType) ->
                         (KSubst) ->
                         (Int) ->
                         (KSubst) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (Bool) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (Set Strings) ->
                         (Bool) ->
                         (Declarations) ->
                         (KSubst) ->
                         (Bool) ->
                         (PreSignatures) ->
                         (PreSignatures) ->
                         ([RawRequest]) ->
                         (Signatures) ->
                         (FMap Name LambdaType) ->
                         (Bool) ->
                         ([Request_TypeImply]) ->
                         (Int) ->
                         ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(Name),(PreSignatures),([RawRequest]),(FunctionBinding),([GHError]),(FMap Name LambdaType),([Request_TypeImply]))
-- cata
sem_FunctionBinding :: (FunctionBinding) ->
                       (T_FunctionBinding)
sem_FunctionBinding ((FunctionBinding_FunctionBinding (_range) (_lefthandside) (_righthandside))) =
    (sem_FunctionBinding_FunctionBinding ((sem_Range (_range))) ((sem_LeftHandSide (_lefthandside))) ((sem_RightHandSide (_righthandside))))
sem_FunctionBinding_FunctionBinding :: (T_Range) ->
                                       (T_LeftHandSide) ->
                                       (T_RightHandSide) ->
                                       (T_FunctionBinding)
sem_FunctionBinding_FunctionBinding (range_) (lefthandside_) (righthandside_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (FunctionBinding)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _lefthandsideIconstructors_collect :: (FMap Name Names)
            _lefthandsideIgenericAbstractions_collect :: (FMap Name Kind)
            _lefthandsideIlabels_collect :: (FMap Name Names)
            _lefthandsideImethods_collect :: (FMap Name Names)
            _lefthandsideIname :: (Name)
            _lefthandsideIself :: (LeftHandSide)
            _lefthandsideOclassname :: (Maybe Name)
            _lefthandsideOconstructors_collect :: (FMap Name Names)
            _lefthandsideOconstructors_dist :: (FMap Name Names)
            _lefthandsideOcurrentModule :: (Strings)
            _lefthandsideOgenericAbstractions :: (FMap Name Kind)
            _lefthandsideOgenericAbstractions_collect :: (FMap Name Kind)
            _lefthandsideOghc :: (Bool)
            _lefthandsideOimportedModule :: (Bool)
            _lefthandsideOinstancename :: (Maybe Name)
            _lefthandsideOlabels_collect :: (FMap Name Names)
            _lefthandsideOlabels_dist :: (FMap Name Names)
            _lefthandsideOlocal :: (Bool)
            _lefthandsideOmethods_collect :: (FMap Name Names)
            _lefthandsideOmethods_dist :: (FMap Name Names)
            _lefthandsideOmodules :: (Set Strings)
            _lefthandsideOoptimizer :: (Bool)
            _lefthandsideOoptimizerPrelude :: (Declarations)
            _lefthandsideOprelude :: (Bool)
            _lefthandsideOtoplevel :: (Bool)
            _lefthandsideOverbosity :: (Int)
            _righthandsideIabstractTypes_collect :: (Set Name)
            _righthandsideIbimapImps_collect :: ([Request_BimapImply])
            _righthandsideIconstructors_collect :: (FMap Name Names)
            _righthandsideIdepConstraints_collect :: ([DepConstraint])
            _righthandsideIfunImps_collect :: ([Request_FunImply])
            _righthandsideIgenericAbstractions_collect :: (FMap Name Kind)
            _righthandsideIkinames :: (KSubst)
            _righthandsideIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _righthandsideIkind_errors :: ([GHError])
            _righthandsideIkindvar :: (Int)
            _righthandsideIksubst :: (KSubst)
            _righthandsideIlabels_collect :: (FMap Name Names)
            _righthandsideImethods_collect :: (FMap Name Names)
            _righthandsideIpresignatures_collect :: (PreSignatures)
            _righthandsideIrawRequests_collect :: ([RawRequest])
            _righthandsideIself :: (RightHandSide)
            _righthandsideIstaticErrors :: ([GHError])
            _righthandsideIstructureTypes_collect :: (FMap Name LambdaType)
            _righthandsideItypeImps_collect :: ([Request_TypeImply])
            _righthandsideOabstractTypes_collect :: (Set Name)
            _righthandsideObimapImps_collect :: ([Request_BimapImply])
            _righthandsideOclassname :: (Maybe Name)
            _righthandsideOconstructors_collect :: (FMap Name Names)
            _righthandsideOconstructors_dist :: (FMap Name Names)
            _righthandsideOcurrentModule :: (Strings)
            _righthandsideOdependencies :: (FMap Name [(Name,Name)])
            _righthandsideOexportedStructures :: (Set Name)
            _righthandsideOexportedTypes :: (Set Name)
            _righthandsideOexportedValues :: (Set Name)
            _righthandsideOfunImps_collect :: ([Request_FunImply])
            _righthandsideOgenericAbstractions :: (FMap Name Kind)
            _righthandsideOgenericAbstractions_collect :: (FMap Name Kind)
            _righthandsideOghc :: (Bool)
            _righthandsideOimportedModule :: (Bool)
            _righthandsideOinstancename :: (Maybe Name)
            _righthandsideOkinames :: (KSubst)
            _righthandsideOkindIndexedTypes :: (FMap Name KindIndexedType)
            _righthandsideOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _righthandsideOkinds :: (KSubst)
            _righthandsideOkindvar :: (Int)
            _righthandsideOksubst :: (KSubst)
            _righthandsideOlabels_collect :: (FMap Name Names)
            _righthandsideOlabels_dist :: (FMap Name Names)
            _righthandsideOlocal :: (Bool)
            _righthandsideOmethods_collect :: (FMap Name Names)
            _righthandsideOmethods_dist :: (FMap Name Names)
            _righthandsideOmodules :: (Set Strings)
            _righthandsideOoptimizer :: (Bool)
            _righthandsideOoptimizerPrelude :: (Declarations)
            _righthandsideOprekind :: (KSubst)
            _righthandsideOprelude :: (Bool)
            _righthandsideOpresignatures :: (PreSignatures)
            _righthandsideOpresignatures_collect :: (PreSignatures)
            _righthandsideOrawRequests_collect :: ([RawRequest])
            _righthandsideOsignatures :: (Signatures)
            _righthandsideOstructureTypes_collect :: (FMap Name LambdaType)
            _righthandsideOtoplevel :: (Bool)
            _righthandsideOtypeImps_collect :: ([Request_TypeImply])
            _righthandsideOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _lefthandsideIconstructors_collect,_lefthandsideIgenericAbstractions_collect,_lefthandsideIlabels_collect,_lefthandsideImethods_collect,_lefthandsideIname,_lefthandsideIself) =
                (lefthandside_ (_lefthandsideOclassname)
                               (_lefthandsideOconstructors_collect)
                               (_lefthandsideOconstructors_dist)
                               (_lefthandsideOcurrentModule)
                               (_lefthandsideOgenericAbstractions)
                               (_lefthandsideOgenericAbstractions_collect)
                               (_lefthandsideOghc)
                               (_lefthandsideOimportedModule)
                               (_lefthandsideOinstancename)
                               (_lefthandsideOlabels_collect)
                               (_lefthandsideOlabels_dist)
                               (_lefthandsideOlocal)
                               (_lefthandsideOmethods_collect)
                               (_lefthandsideOmethods_dist)
                               (_lefthandsideOmodules)
                               (_lefthandsideOoptimizer)
                               (_lefthandsideOoptimizerPrelude)
                               (_lefthandsideOprelude)
                               (_lefthandsideOtoplevel)
                               (_lefthandsideOverbosity))
            ( _righthandsideIabstractTypes_collect
             ,_righthandsideIbimapImps_collect
             ,_righthandsideIconstructors_collect
             ,_righthandsideIdepConstraints_collect
             ,_righthandsideIfunImps_collect
             ,_righthandsideIgenericAbstractions_collect
             ,_righthandsideIkinames
             ,_righthandsideIkindIndexedTypes_collect
             ,_righthandsideIkind_errors
             ,_righthandsideIkindvar
             ,_righthandsideIksubst
             ,_righthandsideIlabels_collect
             ,_righthandsideImethods_collect
             ,_righthandsideIpresignatures_collect
             ,_righthandsideIrawRequests_collect
             ,_righthandsideIself
             ,_righthandsideIstaticErrors
             ,_righthandsideIstructureTypes_collect
             ,_righthandsideItypeImps_collect
             ) =
                (righthandside_ (_righthandsideOabstractTypes_collect)
                                (_righthandsideObimapImps_collect)
                                (_righthandsideOclassname)
                                (_righthandsideOconstructors_collect)
                                (_righthandsideOconstructors_dist)
                                (_righthandsideOcurrentModule)
                                (_righthandsideOdependencies)
                                (_righthandsideOexportedStructures)
                                (_righthandsideOexportedTypes)
                                (_righthandsideOexportedValues)
                                (_righthandsideOfunImps_collect)
                                (_righthandsideOgenericAbstractions)
                                (_righthandsideOgenericAbstractions_collect)
                                (_righthandsideOghc)
                                (_righthandsideOimportedModule)
                                (_righthandsideOinstancename)
                                (_righthandsideOkinames)
                                (_righthandsideOkindIndexedTypes)
                                (_righthandsideOkindIndexedTypes_collect)
                                (_righthandsideOkinds)
                                (_righthandsideOkindvar)
                                (_righthandsideOksubst)
                                (_righthandsideOlabels_collect)
                                (_righthandsideOlabels_dist)
                                (_righthandsideOlocal)
                                (_righthandsideOmethods_collect)
                                (_righthandsideOmethods_dist)
                                (_righthandsideOmodules)
                                (_righthandsideOoptimizer)
                                (_righthandsideOoptimizerPrelude)
                                (_righthandsideOprekind)
                                (_righthandsideOprelude)
                                (_righthandsideOpresignatures)
                                (_righthandsideOpresignatures_collect)
                                (_righthandsideOrawRequests_collect)
                                (_righthandsideOsignatures)
                                (_righthandsideOstructureTypes_collect)
                                (_righthandsideOtoplevel)
                                (_righthandsideOtypeImps_collect)
                                (_righthandsideOverbosity))
            -- "./ModuleInformation.inc.lag"(line 166, column 8)
            (_righthandsideOtoplevel@_) =
                False
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _righthandsideIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _righthandsideIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _righthandsideIstaticErrors
            -- self rule
            (_self@_) =
                FunctionBinding_FunctionBinding _rangeIself _lefthandsideIself _righthandsideIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _righthandsideIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _righthandsideIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _righthandsideIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _righthandsideIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _righthandsideIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _righthandsideIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _righthandsideIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _righthandsideIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _righthandsideIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _righthandsideIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _righthandsideImethods_collect
            -- copy rule (up)
            (_lhsOname@_) =
                _lefthandsideIname
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _righthandsideIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _righthandsideIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _righthandsideIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _righthandsideItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_lefthandsideOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_lefthandsideOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_lefthandsideOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_lefthandsideOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_lefthandsideOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_lefthandsideOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_lefthandsideOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_lefthandsideOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_lefthandsideOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_lefthandsideOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_lefthandsideOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_lefthandsideOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_lefthandsideOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_lefthandsideOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_lefthandsideOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_lefthandsideOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_lefthandsideOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_lefthandsideOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_lefthandsideOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_lefthandsideOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_righthandsideOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_righthandsideObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_righthandsideOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_righthandsideOconstructors_collect@_) =
                _lefthandsideIconstructors_collect
            -- copy rule (down)
            (_righthandsideOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_righthandsideOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_righthandsideOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_righthandsideOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_righthandsideOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_righthandsideOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_righthandsideOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_righthandsideOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_righthandsideOgenericAbstractions_collect@_) =
                _lefthandsideIgenericAbstractions_collect
            -- copy rule (down)
            (_righthandsideOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_righthandsideOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_righthandsideOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_righthandsideOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_righthandsideOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_righthandsideOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_righthandsideOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_righthandsideOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_righthandsideOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_righthandsideOlabels_collect@_) =
                _lefthandsideIlabels_collect
            -- copy rule (down)
            (_righthandsideOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_righthandsideOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_righthandsideOmethods_collect@_) =
                _lefthandsideImethods_collect
            -- copy rule (down)
            (_righthandsideOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_righthandsideOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_righthandsideOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_righthandsideOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_righthandsideOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_righthandsideOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_righthandsideOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_righthandsideOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_righthandsideOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_righthandsideOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_righthandsideOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_righthandsideOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_righthandsideOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
-- FunctionBindings --------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      exportedStructures   : Set Name
      exportedTypes        : Set Name
      exportedValues       : Set Name
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures
      rawRequests_collect  : [RawRequest]
      structureTypes_collect : FMap Name LambdaType
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      kind_errors          : [GHError]
      name                 : Name
      self                 : SELF
      staticErrors         : [GHError]

-}
{-
   local variables for FunctionBindings.Cons:
      self

-}
{-
   local variables for FunctionBindings.Nil:
      self

-}
-- semantic domain
type T_FunctionBindings = (Set Name) ->
                          ([Request_BimapImply]) ->
                          (Maybe Name) ->
                          (FMap Name Names) ->
                          (FMap Name Names) ->
                          (Strings) ->
                          (FMap Name [(Name,Name)]) ->
                          (Set Name) ->
                          (Set Name) ->
                          (Set Name) ->
                          ([Request_FunImply]) ->
                          (FMap Name Kind) ->
                          (FMap Name Kind) ->
                          (Bool) ->
                          (Bool) ->
                          (Maybe Name) ->
                          (KSubst) ->
                          (FMap Name KindIndexedType) ->
                          (FMap Name KindIndexedType) ->
                          (KSubst) ->
                          (Int) ->
                          (KSubst) ->
                          (FMap Name Names) ->
                          (FMap Name Names) ->
                          (Bool) ->
                          (FMap Name Names) ->
                          (FMap Name Names) ->
                          (Set Strings) ->
                          (Bool) ->
                          (Declarations) ->
                          (KSubst) ->
                          (Bool) ->
                          (PreSignatures) ->
                          (PreSignatures) ->
                          ([RawRequest]) ->
                          (Signatures) ->
                          (FMap Name LambdaType) ->
                          (Bool) ->
                          ([Request_TypeImply]) ->
                          (Int) ->
                          ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(Name),(PreSignatures),([RawRequest]),(FunctionBindings),([GHError]),(FMap Name LambdaType),([Request_TypeImply]))
-- cata
sem_FunctionBindings :: (FunctionBindings) ->
                        (T_FunctionBindings)
sem_FunctionBindings (list) =
    (foldr (sem_FunctionBindings_Cons) (sem_FunctionBindings_Nil) ((map sem_FunctionBinding list)))
sem_FunctionBindings_Cons :: (T_FunctionBinding) ->
                             (T_FunctionBindings) ->
                             (T_FunctionBindings)
sem_FunctionBindings_Cons (hd_) (tl_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (FunctionBindings)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _hdIabstractTypes_collect :: (Set Name)
            _hdIbimapImps_collect :: ([Request_BimapImply])
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdepConstraints_collect :: ([DepConstraint])
            _hdIfunImps_collect :: ([Request_FunImply])
            _hdIgenericAbstractions_collect :: (FMap Name Kind)
            _hdIkinames :: (KSubst)
            _hdIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _hdIkind_errors :: ([GHError])
            _hdIkindvar :: (Int)
            _hdIksubst :: (KSubst)
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIname :: (Name)
            _hdIpresignatures_collect :: (PreSignatures)
            _hdIrawRequests_collect :: ([RawRequest])
            _hdIself :: (FunctionBinding)
            _hdIstaticErrors :: ([GHError])
            _hdIstructureTypes_collect :: (FMap Name LambdaType)
            _hdItypeImps_collect :: ([Request_TypeImply])
            _hdOabstractTypes_collect :: (Set Name)
            _hdObimapImps_collect :: ([Request_BimapImply])
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies :: (FMap Name [(Name,Name)])
            _hdOexportedStructures :: (Set Name)
            _hdOexportedTypes :: (Set Name)
            _hdOexportedValues :: (Set Name)
            _hdOfunImps_collect :: ([Request_FunImply])
            _hdOgenericAbstractions :: (FMap Name Kind)
            _hdOgenericAbstractions_collect :: (FMap Name Kind)
            _hdOghc :: (Bool)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOkinames :: (KSubst)
            _hdOkindIndexedTypes :: (FMap Name KindIndexedType)
            _hdOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _hdOkinds :: (KSubst)
            _hdOkindvar :: (Int)
            _hdOksubst :: (KSubst)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmodules :: (Set Strings)
            _hdOoptimizer :: (Bool)
            _hdOoptimizerPrelude :: (Declarations)
            _hdOprekind :: (KSubst)
            _hdOprelude :: (Bool)
            _hdOpresignatures :: (PreSignatures)
            _hdOpresignatures_collect :: (PreSignatures)
            _hdOrawRequests_collect :: ([RawRequest])
            _hdOsignatures :: (Signatures)
            _hdOstructureTypes_collect :: (FMap Name LambdaType)
            _hdOtoplevel :: (Bool)
            _hdOtypeImps_collect :: ([Request_TypeImply])
            _hdOverbosity :: (Int)
            _tlIabstractTypes_collect :: (Set Name)
            _tlIbimapImps_collect :: ([Request_BimapImply])
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdepConstraints_collect :: ([DepConstraint])
            _tlIfunImps_collect :: ([Request_FunImply])
            _tlIgenericAbstractions_collect :: (FMap Name Kind)
            _tlIkinames :: (KSubst)
            _tlIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _tlIkind_errors :: ([GHError])
            _tlIkindvar :: (Int)
            _tlIksubst :: (KSubst)
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIname :: (Name)
            _tlIpresignatures_collect :: (PreSignatures)
            _tlIrawRequests_collect :: ([RawRequest])
            _tlIself :: (FunctionBindings)
            _tlIstaticErrors :: ([GHError])
            _tlIstructureTypes_collect :: (FMap Name LambdaType)
            _tlItypeImps_collect :: ([Request_TypeImply])
            _tlOabstractTypes_collect :: (Set Name)
            _tlObimapImps_collect :: ([Request_BimapImply])
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies :: (FMap Name [(Name,Name)])
            _tlOexportedStructures :: (Set Name)
            _tlOexportedTypes :: (Set Name)
            _tlOexportedValues :: (Set Name)
            _tlOfunImps_collect :: ([Request_FunImply])
            _tlOgenericAbstractions :: (FMap Name Kind)
            _tlOgenericAbstractions_collect :: (FMap Name Kind)
            _tlOghc :: (Bool)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOkinames :: (KSubst)
            _tlOkindIndexedTypes :: (FMap Name KindIndexedType)
            _tlOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _tlOkinds :: (KSubst)
            _tlOkindvar :: (Int)
            _tlOksubst :: (KSubst)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmodules :: (Set Strings)
            _tlOoptimizer :: (Bool)
            _tlOoptimizerPrelude :: (Declarations)
            _tlOprekind :: (KSubst)
            _tlOprelude :: (Bool)
            _tlOpresignatures :: (PreSignatures)
            _tlOpresignatures_collect :: (PreSignatures)
            _tlOrawRequests_collect :: ([RawRequest])
            _tlOsignatures :: (Signatures)
            _tlOstructureTypes_collect :: (FMap Name LambdaType)
            _tlOtoplevel :: (Bool)
            _tlOtypeImps_collect :: ([Request_TypeImply])
            _tlOverbosity :: (Int)
            ( _hdIabstractTypes_collect,_hdIbimapImps_collect,_hdIconstructors_collect,_hdIdepConstraints_collect,_hdIfunImps_collect,_hdIgenericAbstractions_collect,_hdIkinames,_hdIkindIndexedTypes_collect,_hdIkind_errors,_hdIkindvar,_hdIksubst,_hdIlabels_collect,_hdImethods_collect,_hdIname,_hdIpresignatures_collect,_hdIrawRequests_collect,_hdIself,_hdIstaticErrors,_hdIstructureTypes_collect,_hdItypeImps_collect) =
                (hd_ (_hdOabstractTypes_collect)
                     (_hdObimapImps_collect)
                     (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOdependencies)
                     (_hdOexportedStructures)
                     (_hdOexportedTypes)
                     (_hdOexportedValues)
                     (_hdOfunImps_collect)
                     (_hdOgenericAbstractions)
                     (_hdOgenericAbstractions_collect)
                     (_hdOghc)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOkinames)
                     (_hdOkindIndexedTypes)
                     (_hdOkindIndexedTypes_collect)
                     (_hdOkinds)
                     (_hdOkindvar)
                     (_hdOksubst)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmodules)
                     (_hdOoptimizer)
                     (_hdOoptimizerPrelude)
                     (_hdOprekind)
                     (_hdOprelude)
                     (_hdOpresignatures)
                     (_hdOpresignatures_collect)
                     (_hdOrawRequests_collect)
                     (_hdOsignatures)
                     (_hdOstructureTypes_collect)
                     (_hdOtoplevel)
                     (_hdOtypeImps_collect)
                     (_hdOverbosity))
            ( _tlIabstractTypes_collect,_tlIbimapImps_collect,_tlIconstructors_collect,_tlIdepConstraints_collect,_tlIfunImps_collect,_tlIgenericAbstractions_collect,_tlIkinames,_tlIkindIndexedTypes_collect,_tlIkind_errors,_tlIkindvar,_tlIksubst,_tlIlabels_collect,_tlImethods_collect,_tlIname,_tlIpresignatures_collect,_tlIrawRequests_collect,_tlIself,_tlIstaticErrors,_tlIstructureTypes_collect,_tlItypeImps_collect) =
                (tl_ (_tlOabstractTypes_collect)
                     (_tlObimapImps_collect)
                     (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOdependencies)
                     (_tlOexportedStructures)
                     (_tlOexportedTypes)
                     (_tlOexportedValues)
                     (_tlOfunImps_collect)
                     (_tlOgenericAbstractions)
                     (_tlOgenericAbstractions_collect)
                     (_tlOghc)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOkinames)
                     (_tlOkindIndexedTypes)
                     (_tlOkindIndexedTypes_collect)
                     (_tlOkinds)
                     (_tlOkindvar)
                     (_tlOksubst)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmodules)
                     (_tlOoptimizer)
                     (_tlOoptimizerPrelude)
                     (_tlOprekind)
                     (_tlOprelude)
                     (_tlOpresignatures)
                     (_tlOpresignatures_collect)
                     (_tlOrawRequests_collect)
                     (_tlOsignatures)
                     (_tlOstructureTypes_collect)
                     (_tlOtoplevel)
                     (_tlOtypeImps_collect)
                     (_tlOverbosity))
            -- "./ModuleInformation.inc.lag"(line 397, column 9)
            (_lhsOname@_) =
                _hdIname
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _hdIdepConstraints_collect ++ _tlIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _hdIkind_errors ++ _tlIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _hdIstaticErrors ++ _tlIstaticErrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _tlIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _tlIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _tlIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _tlIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _tlIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _tlIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _tlIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _tlIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _tlIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _tlIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _tlIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _tlItypeImps_collect
            -- copy rule (down)
            (_hdOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_hdObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_hdOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_hdOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_hdOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_hdOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_hdOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_hdOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_hdOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_hdOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_hdOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_hdOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_hdOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_hdOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_hdOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_hdOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_hdOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_hdOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_hdOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_hdOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_hdOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_hdOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_hdOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_hdOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_hdOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_tlOabstractTypes_collect@_) =
                _hdIabstractTypes_collect
            -- copy rule (chain)
            (_tlObimapImps_collect@_) =
                _hdIbimapImps_collect
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_tlOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_tlOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_tlOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (chain)
            (_tlOfunImps_collect@_) =
                _hdIfunImps_collect
            -- copy rule (down)
            (_tlOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_tlOgenericAbstractions_collect@_) =
                _hdIgenericAbstractions_collect
            -- copy rule (down)
            (_tlOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOkinames@_) =
                _hdIkinames
            -- copy rule (down)
            (_tlOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (chain)
            (_tlOkindIndexedTypes_collect@_) =
                _hdIkindIndexedTypes_collect
            -- copy rule (down)
            (_tlOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_tlOkindvar@_) =
                _hdIkindvar
            -- copy rule (chain)
            (_tlOksubst@_) =
                _hdIksubst
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_tlOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_tlOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_tlOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_tlOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_tlOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_tlOpresignatures_collect@_) =
                _hdIpresignatures_collect
            -- copy rule (chain)
            (_tlOrawRequests_collect@_) =
                _hdIrawRequests_collect
            -- copy rule (down)
            (_tlOsignatures@_) =
                _lhsIsignatures
            -- copy rule (chain)
            (_tlOstructureTypes_collect@_) =
                _hdIstructureTypes_collect
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_tlOtypeImps_collect@_) =
                _hdItypeImps_collect
            -- copy rule (down)
            (_tlOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_FunctionBindings_Nil :: (T_FunctionBindings)
sem_FunctionBindings_Nil  =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (FunctionBindings)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            -- "./ModuleInformation.inc.lag"(line 399, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.FunctionBindings.Nil.lhs.name: no bindings"
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
-- GuardedExpression -------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      exportedStructures   : Set Name
      exportedTypes        : Set Name
      exportedValues       : Set Name
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures
      rawRequests_collect  : [RawRequest]
      structureTypes_collect : FMap Name LambdaType
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      kind_errors          : [GHError]
      self                 : SELF
      staticErrors         : [GHError]

-}
{-
   local variables for GuardedExpression.GuardedExpression:
      self

-}
-- semantic domain
type T_GuardedExpression = (Set Name) ->
                           ([Request_BimapImply]) ->
                           (Maybe Name) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Strings) ->
                           (FMap Name [(Name,Name)]) ->
                           (Set Name) ->
                           (Set Name) ->
                           (Set Name) ->
                           ([Request_FunImply]) ->
                           (FMap Name Kind) ->
                           (FMap Name Kind) ->
                           (Bool) ->
                           (Bool) ->
                           (Maybe Name) ->
                           (KSubst) ->
                           (FMap Name KindIndexedType) ->
                           (FMap Name KindIndexedType) ->
                           (KSubst) ->
                           (Int) ->
                           (KSubst) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Bool) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Set Strings) ->
                           (Bool) ->
                           (Declarations) ->
                           (KSubst) ->
                           (Bool) ->
                           (PreSignatures) ->
                           (PreSignatures) ->
                           ([RawRequest]) ->
                           (Signatures) ->
                           (FMap Name LambdaType) ->
                           (Bool) ->
                           ([Request_TypeImply]) ->
                           (Int) ->
                           ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(PreSignatures),([RawRequest]),(GuardedExpression),([GHError]),(FMap Name LambdaType),([Request_TypeImply]))
-- cata
sem_GuardedExpression :: (GuardedExpression) ->
                         (T_GuardedExpression)
sem_GuardedExpression ((GuardedExpression_GuardedExpression (_range) (_guard) (_expression))) =
    (sem_GuardedExpression_GuardedExpression ((sem_Range (_range))) ((sem_Expression (_guard))) ((sem_Expression (_expression))))
sem_GuardedExpression_GuardedExpression :: (T_Range) ->
                                           (T_Expression) ->
                                           (T_Expression) ->
                                           (T_GuardedExpression)
sem_GuardedExpression_GuardedExpression (range_) (guard_) (expression_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (GuardedExpression)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _guardIabstractTypes_collect :: (Set Name)
            _guardIbimapImps_collect :: ([Request_BimapImply])
            _guardIconstructors_collect :: (FMap Name Names)
            _guardIdepConstraints_collect :: ([DepConstraint])
            _guardIfunImps_collect :: ([Request_FunImply])
            _guardIgenericAbstractions_collect :: (FMap Name Kind)
            _guardIkinames :: (KSubst)
            _guardIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _guardIkind_errors :: ([GHError])
            _guardIkindvar :: (Int)
            _guardIksubst :: (KSubst)
            _guardIlabels_collect :: (FMap Name Names)
            _guardImethods_collect :: (FMap Name Names)
            _guardIpresignatures_collect :: (PreSignatures)
            _guardIrawRequests_collect :: ([RawRequest])
            _guardIself :: (Expression)
            _guardIstaticErrors :: ([GHError])
            _guardIstructureTypes_collect :: (FMap Name LambdaType)
            _guardItypeImps_collect :: ([Request_TypeImply])
            _guardOabstractTypes_collect :: (Set Name)
            _guardObimapImps_collect :: ([Request_BimapImply])
            _guardOclassname :: (Maybe Name)
            _guardOconstructors_collect :: (FMap Name Names)
            _guardOconstructors_dist :: (FMap Name Names)
            _guardOcurrentModule :: (Strings)
            _guardOdependencies :: (FMap Name [(Name,Name)])
            _guardOexportedStructures :: (Set Name)
            _guardOexportedTypes :: (Set Name)
            _guardOexportedValues :: (Set Name)
            _guardOfunImps_collect :: ([Request_FunImply])
            _guardOgenericAbstractions :: (FMap Name Kind)
            _guardOgenericAbstractions_collect :: (FMap Name Kind)
            _guardOghc :: (Bool)
            _guardOimportedModule :: (Bool)
            _guardOinstancename :: (Maybe Name)
            _guardOkinames :: (KSubst)
            _guardOkindIndexedTypes :: (FMap Name KindIndexedType)
            _guardOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _guardOkinds :: (KSubst)
            _guardOkindvar :: (Int)
            _guardOksubst :: (KSubst)
            _guardOlabels_collect :: (FMap Name Names)
            _guardOlabels_dist :: (FMap Name Names)
            _guardOlocal :: (Bool)
            _guardOmethods_collect :: (FMap Name Names)
            _guardOmethods_dist :: (FMap Name Names)
            _guardOmodules :: (Set Strings)
            _guardOoptimizer :: (Bool)
            _guardOoptimizerPrelude :: (Declarations)
            _guardOprekind :: (KSubst)
            _guardOprelude :: (Bool)
            _guardOpresignatures :: (PreSignatures)
            _guardOpresignatures_collect :: (PreSignatures)
            _guardOrawRequests_collect :: ([RawRequest])
            _guardOsignatures :: (Signatures)
            _guardOstructureTypes_collect :: (FMap Name LambdaType)
            _guardOtoplevel :: (Bool)
            _guardOtypeImps_collect :: ([Request_TypeImply])
            _guardOverbosity :: (Int)
            _expressionIabstractTypes_collect :: (Set Name)
            _expressionIbimapImps_collect :: ([Request_BimapImply])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdepConstraints_collect :: ([DepConstraint])
            _expressionIfunImps_collect :: ([Request_FunImply])
            _expressionIgenericAbstractions_collect :: (FMap Name Kind)
            _expressionIkinames :: (KSubst)
            _expressionIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionIkind_errors :: ([GHError])
            _expressionIkindvar :: (Int)
            _expressionIksubst :: (KSubst)
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIrawRequests_collect :: ([RawRequest])
            _expressionIself :: (Expression)
            _expressionIstaticErrors :: ([GHError])
            _expressionIstructureTypes_collect :: (FMap Name LambdaType)
            _expressionItypeImps_collect :: ([Request_TypeImply])
            _expressionOabstractTypes_collect :: (Set Name)
            _expressionObimapImps_collect :: ([Request_BimapImply])
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies :: (FMap Name [(Name,Name)])
            _expressionOexportedStructures :: (Set Name)
            _expressionOexportedTypes :: (Set Name)
            _expressionOexportedValues :: (Set Name)
            _expressionOfunImps_collect :: ([Request_FunImply])
            _expressionOgenericAbstractions :: (FMap Name Kind)
            _expressionOgenericAbstractions_collect :: (FMap Name Kind)
            _expressionOghc :: (Bool)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOkinames :: (KSubst)
            _expressionOkindIndexedTypes :: (FMap Name KindIndexedType)
            _expressionOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionOkinds :: (KSubst)
            _expressionOkindvar :: (Int)
            _expressionOksubst :: (KSubst)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmodules :: (Set Strings)
            _expressionOoptimizer :: (Bool)
            _expressionOoptimizerPrelude :: (Declarations)
            _expressionOprekind :: (KSubst)
            _expressionOprelude :: (Bool)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOrawRequests_collect :: ([RawRequest])
            _expressionOsignatures :: (Signatures)
            _expressionOstructureTypes_collect :: (FMap Name LambdaType)
            _expressionOtoplevel :: (Bool)
            _expressionOtypeImps_collect :: ([Request_TypeImply])
            _expressionOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _guardIabstractTypes_collect
             ,_guardIbimapImps_collect
             ,_guardIconstructors_collect
             ,_guardIdepConstraints_collect
             ,_guardIfunImps_collect
             ,_guardIgenericAbstractions_collect
             ,_guardIkinames
             ,_guardIkindIndexedTypes_collect
             ,_guardIkind_errors
             ,_guardIkindvar
             ,_guardIksubst
             ,_guardIlabels_collect
             ,_guardImethods_collect
             ,_guardIpresignatures_collect
             ,_guardIrawRequests_collect
             ,_guardIself
             ,_guardIstaticErrors
             ,_guardIstructureTypes_collect
             ,_guardItypeImps_collect
             ) =
                (guard_ (_guardOabstractTypes_collect)
                        (_guardObimapImps_collect)
                        (_guardOclassname)
                        (_guardOconstructors_collect)
                        (_guardOconstructors_dist)
                        (_guardOcurrentModule)
                        (_guardOdependencies)
                        (_guardOexportedStructures)
                        (_guardOexportedTypes)
                        (_guardOexportedValues)
                        (_guardOfunImps_collect)
                        (_guardOgenericAbstractions)
                        (_guardOgenericAbstractions_collect)
                        (_guardOghc)
                        (_guardOimportedModule)
                        (_guardOinstancename)
                        (_guardOkinames)
                        (_guardOkindIndexedTypes)
                        (_guardOkindIndexedTypes_collect)
                        (_guardOkinds)
                        (_guardOkindvar)
                        (_guardOksubst)
                        (_guardOlabels_collect)
                        (_guardOlabels_dist)
                        (_guardOlocal)
                        (_guardOmethods_collect)
                        (_guardOmethods_dist)
                        (_guardOmodules)
                        (_guardOoptimizer)
                        (_guardOoptimizerPrelude)
                        (_guardOprekind)
                        (_guardOprelude)
                        (_guardOpresignatures)
                        (_guardOpresignatures_collect)
                        (_guardOrawRequests_collect)
                        (_guardOsignatures)
                        (_guardOstructureTypes_collect)
                        (_guardOtoplevel)
                        (_guardOtypeImps_collect)
                        (_guardOverbosity))
            ( _expressionIabstractTypes_collect
             ,_expressionIbimapImps_collect
             ,_expressionIconstructors_collect
             ,_expressionIdepConstraints_collect
             ,_expressionIfunImps_collect
             ,_expressionIgenericAbstractions_collect
             ,_expressionIkinames
             ,_expressionIkindIndexedTypes_collect
             ,_expressionIkind_errors
             ,_expressionIkindvar
             ,_expressionIksubst
             ,_expressionIlabels_collect
             ,_expressionImethods_collect
             ,_expressionIpresignatures_collect
             ,_expressionIrawRequests_collect
             ,_expressionIself
             ,_expressionIstaticErrors
             ,_expressionIstructureTypes_collect
             ,_expressionItypeImps_collect
             ) =
                (expression_ (_expressionOabstractTypes_collect)
                             (_expressionObimapImps_collect)
                             (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies)
                             (_expressionOexportedStructures)
                             (_expressionOexportedTypes)
                             (_expressionOexportedValues)
                             (_expressionOfunImps_collect)
                             (_expressionOgenericAbstractions)
                             (_expressionOgenericAbstractions_collect)
                             (_expressionOghc)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOkinames)
                             (_expressionOkindIndexedTypes)
                             (_expressionOkindIndexedTypes_collect)
                             (_expressionOkinds)
                             (_expressionOkindvar)
                             (_expressionOksubst)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmodules)
                             (_expressionOoptimizer)
                             (_expressionOoptimizerPrelude)
                             (_expressionOprekind)
                             (_expressionOprelude)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOrawRequests_collect)
                             (_expressionOsignatures)
                             (_expressionOstructureTypes_collect)
                             (_expressionOtoplevel)
                             (_expressionOtypeImps_collect)
                             (_expressionOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _guardIdepConstraints_collect ++ _expressionIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _guardIkind_errors ++ _expressionIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _guardIstaticErrors ++ _expressionIstaticErrors
            -- self rule
            (_self@_) =
                GuardedExpression_GuardedExpression _rangeIself _guardIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _expressionIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _expressionIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _expressionIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _expressionIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _expressionIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _expressionIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _expressionIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _expressionIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _expressionIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _expressionIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _expressionItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_guardOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_guardObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_guardOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_guardOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_guardOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_guardOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_guardOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_guardOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_guardOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_guardOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_guardOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_guardOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_guardOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_guardOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_guardOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_guardOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_guardOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_guardOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_guardOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_guardOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_guardOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_guardOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_guardOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_guardOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_guardOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_guardOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_guardOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_guardOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_guardOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_guardOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_guardOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_guardOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_guardOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_guardOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_guardOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_guardOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_guardOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_guardOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_guardOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_guardOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_expressionOabstractTypes_collect@_) =
                _guardIabstractTypes_collect
            -- copy rule (chain)
            (_expressionObimapImps_collect@_) =
                _guardIbimapImps_collect
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_expressionOconstructors_collect@_) =
                _guardIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_expressionOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_expressionOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_expressionOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (chain)
            (_expressionOfunImps_collect@_) =
                _guardIfunImps_collect
            -- copy rule (down)
            (_expressionOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_expressionOgenericAbstractions_collect@_) =
                _guardIgenericAbstractions_collect
            -- copy rule (down)
            (_expressionOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_expressionOkinames@_) =
                _guardIkinames
            -- copy rule (down)
            (_expressionOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (chain)
            (_expressionOkindIndexedTypes_collect@_) =
                _guardIkindIndexedTypes_collect
            -- copy rule (down)
            (_expressionOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_expressionOkindvar@_) =
                _guardIkindvar
            -- copy rule (chain)
            (_expressionOksubst@_) =
                _guardIksubst
            -- copy rule (chain)
            (_expressionOlabels_collect@_) =
                _guardIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_expressionOmethods_collect@_) =
                _guardImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_expressionOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_expressionOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_expressionOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_expressionOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_expressionOpresignatures_collect@_) =
                _guardIpresignatures_collect
            -- copy rule (chain)
            (_expressionOrawRequests_collect@_) =
                _guardIrawRequests_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (chain)
            (_expressionOstructureTypes_collect@_) =
                _guardIstructureTypes_collect
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_expressionOtypeImps_collect@_) =
                _guardItypeImps_collect
            -- copy rule (down)
            (_expressionOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
-- GuardedExpressions ------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      exportedStructures   : Set Name
      exportedTypes        : Set Name
      exportedValues       : Set Name
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures
      rawRequests_collect  : [RawRequest]
      structureTypes_collect : FMap Name LambdaType
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      kind_errors          : [GHError]
      self                 : SELF
      staticErrors         : [GHError]

-}
{-
   local variables for GuardedExpressions.Cons:
      self

-}
{-
   local variables for GuardedExpressions.Nil:
      self

-}
-- semantic domain
type T_GuardedExpressions = (Set Name) ->
                            ([Request_BimapImply]) ->
                            (Maybe Name) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Strings) ->
                            (FMap Name [(Name,Name)]) ->
                            (Set Name) ->
                            (Set Name) ->
                            (Set Name) ->
                            ([Request_FunImply]) ->
                            (FMap Name Kind) ->
                            (FMap Name Kind) ->
                            (Bool) ->
                            (Bool) ->
                            (Maybe Name) ->
                            (KSubst) ->
                            (FMap Name KindIndexedType) ->
                            (FMap Name KindIndexedType) ->
                            (KSubst) ->
                            (Int) ->
                            (KSubst) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Bool) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Set Strings) ->
                            (Bool) ->
                            (Declarations) ->
                            (KSubst) ->
                            (Bool) ->
                            (PreSignatures) ->
                            (PreSignatures) ->
                            ([RawRequest]) ->
                            (Signatures) ->
                            (FMap Name LambdaType) ->
                            (Bool) ->
                            ([Request_TypeImply]) ->
                            (Int) ->
                            ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(PreSignatures),([RawRequest]),(GuardedExpressions),([GHError]),(FMap Name LambdaType),([Request_TypeImply]))
-- cata
sem_GuardedExpressions :: (GuardedExpressions) ->
                          (T_GuardedExpressions)
sem_GuardedExpressions (list) =
    (foldr (sem_GuardedExpressions_Cons) (sem_GuardedExpressions_Nil) ((map sem_GuardedExpression list)))
sem_GuardedExpressions_Cons :: (T_GuardedExpression) ->
                               (T_GuardedExpressions) ->
                               (T_GuardedExpressions)
sem_GuardedExpressions_Cons (hd_) (tl_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (GuardedExpressions)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _hdIabstractTypes_collect :: (Set Name)
            _hdIbimapImps_collect :: ([Request_BimapImply])
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdepConstraints_collect :: ([DepConstraint])
            _hdIfunImps_collect :: ([Request_FunImply])
            _hdIgenericAbstractions_collect :: (FMap Name Kind)
            _hdIkinames :: (KSubst)
            _hdIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _hdIkind_errors :: ([GHError])
            _hdIkindvar :: (Int)
            _hdIksubst :: (KSubst)
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIpresignatures_collect :: (PreSignatures)
            _hdIrawRequests_collect :: ([RawRequest])
            _hdIself :: (GuardedExpression)
            _hdIstaticErrors :: ([GHError])
            _hdIstructureTypes_collect :: (FMap Name LambdaType)
            _hdItypeImps_collect :: ([Request_TypeImply])
            _hdOabstractTypes_collect :: (Set Name)
            _hdObimapImps_collect :: ([Request_BimapImply])
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies :: (FMap Name [(Name,Name)])
            _hdOexportedStructures :: (Set Name)
            _hdOexportedTypes :: (Set Name)
            _hdOexportedValues :: (Set Name)
            _hdOfunImps_collect :: ([Request_FunImply])
            _hdOgenericAbstractions :: (FMap Name Kind)
            _hdOgenericAbstractions_collect :: (FMap Name Kind)
            _hdOghc :: (Bool)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOkinames :: (KSubst)
            _hdOkindIndexedTypes :: (FMap Name KindIndexedType)
            _hdOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _hdOkinds :: (KSubst)
            _hdOkindvar :: (Int)
            _hdOksubst :: (KSubst)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmodules :: (Set Strings)
            _hdOoptimizer :: (Bool)
            _hdOoptimizerPrelude :: (Declarations)
            _hdOprekind :: (KSubst)
            _hdOprelude :: (Bool)
            _hdOpresignatures :: (PreSignatures)
            _hdOpresignatures_collect :: (PreSignatures)
            _hdOrawRequests_collect :: ([RawRequest])
            _hdOsignatures :: (Signatures)
            _hdOstructureTypes_collect :: (FMap Name LambdaType)
            _hdOtoplevel :: (Bool)
            _hdOtypeImps_collect :: ([Request_TypeImply])
            _hdOverbosity :: (Int)
            _tlIabstractTypes_collect :: (Set Name)
            _tlIbimapImps_collect :: ([Request_BimapImply])
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdepConstraints_collect :: ([DepConstraint])
            _tlIfunImps_collect :: ([Request_FunImply])
            _tlIgenericAbstractions_collect :: (FMap Name Kind)
            _tlIkinames :: (KSubst)
            _tlIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _tlIkind_errors :: ([GHError])
            _tlIkindvar :: (Int)
            _tlIksubst :: (KSubst)
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIpresignatures_collect :: (PreSignatures)
            _tlIrawRequests_collect :: ([RawRequest])
            _tlIself :: (GuardedExpressions)
            _tlIstaticErrors :: ([GHError])
            _tlIstructureTypes_collect :: (FMap Name LambdaType)
            _tlItypeImps_collect :: ([Request_TypeImply])
            _tlOabstractTypes_collect :: (Set Name)
            _tlObimapImps_collect :: ([Request_BimapImply])
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies :: (FMap Name [(Name,Name)])
            _tlOexportedStructures :: (Set Name)
            _tlOexportedTypes :: (Set Name)
            _tlOexportedValues :: (Set Name)
            _tlOfunImps_collect :: ([Request_FunImply])
            _tlOgenericAbstractions :: (FMap Name Kind)
            _tlOgenericAbstractions_collect :: (FMap Name Kind)
            _tlOghc :: (Bool)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOkinames :: (KSubst)
            _tlOkindIndexedTypes :: (FMap Name KindIndexedType)
            _tlOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _tlOkinds :: (KSubst)
            _tlOkindvar :: (Int)
            _tlOksubst :: (KSubst)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmodules :: (Set Strings)
            _tlOoptimizer :: (Bool)
            _tlOoptimizerPrelude :: (Declarations)
            _tlOprekind :: (KSubst)
            _tlOprelude :: (Bool)
            _tlOpresignatures :: (PreSignatures)
            _tlOpresignatures_collect :: (PreSignatures)
            _tlOrawRequests_collect :: ([RawRequest])
            _tlOsignatures :: (Signatures)
            _tlOstructureTypes_collect :: (FMap Name LambdaType)
            _tlOtoplevel :: (Bool)
            _tlOtypeImps_collect :: ([Request_TypeImply])
            _tlOverbosity :: (Int)
            ( _hdIabstractTypes_collect,_hdIbimapImps_collect,_hdIconstructors_collect,_hdIdepConstraints_collect,_hdIfunImps_collect,_hdIgenericAbstractions_collect,_hdIkinames,_hdIkindIndexedTypes_collect,_hdIkind_errors,_hdIkindvar,_hdIksubst,_hdIlabels_collect,_hdImethods_collect,_hdIpresignatures_collect,_hdIrawRequests_collect,_hdIself,_hdIstaticErrors,_hdIstructureTypes_collect,_hdItypeImps_collect) =
                (hd_ (_hdOabstractTypes_collect)
                     (_hdObimapImps_collect)
                     (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOdependencies)
                     (_hdOexportedStructures)
                     (_hdOexportedTypes)
                     (_hdOexportedValues)
                     (_hdOfunImps_collect)
                     (_hdOgenericAbstractions)
                     (_hdOgenericAbstractions_collect)
                     (_hdOghc)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOkinames)
                     (_hdOkindIndexedTypes)
                     (_hdOkindIndexedTypes_collect)
                     (_hdOkinds)
                     (_hdOkindvar)
                     (_hdOksubst)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmodules)
                     (_hdOoptimizer)
                     (_hdOoptimizerPrelude)
                     (_hdOprekind)
                     (_hdOprelude)
                     (_hdOpresignatures)
                     (_hdOpresignatures_collect)
                     (_hdOrawRequests_collect)
                     (_hdOsignatures)
                     (_hdOstructureTypes_collect)
                     (_hdOtoplevel)
                     (_hdOtypeImps_collect)
                     (_hdOverbosity))
            ( _tlIabstractTypes_collect,_tlIbimapImps_collect,_tlIconstructors_collect,_tlIdepConstraints_collect,_tlIfunImps_collect,_tlIgenericAbstractions_collect,_tlIkinames,_tlIkindIndexedTypes_collect,_tlIkind_errors,_tlIkindvar,_tlIksubst,_tlIlabels_collect,_tlImethods_collect,_tlIpresignatures_collect,_tlIrawRequests_collect,_tlIself,_tlIstaticErrors,_tlIstructureTypes_collect,_tlItypeImps_collect) =
                (tl_ (_tlOabstractTypes_collect)
                     (_tlObimapImps_collect)
                     (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOdependencies)
                     (_tlOexportedStructures)
                     (_tlOexportedTypes)
                     (_tlOexportedValues)
                     (_tlOfunImps_collect)
                     (_tlOgenericAbstractions)
                     (_tlOgenericAbstractions_collect)
                     (_tlOghc)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOkinames)
                     (_tlOkindIndexedTypes)
                     (_tlOkindIndexedTypes_collect)
                     (_tlOkinds)
                     (_tlOkindvar)
                     (_tlOksubst)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmodules)
                     (_tlOoptimizer)
                     (_tlOoptimizerPrelude)
                     (_tlOprekind)
                     (_tlOprelude)
                     (_tlOpresignatures)
                     (_tlOpresignatures_collect)
                     (_tlOrawRequests_collect)
                     (_tlOsignatures)
                     (_tlOstructureTypes_collect)
                     (_tlOtoplevel)
                     (_tlOtypeImps_collect)
                     (_tlOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _hdIdepConstraints_collect ++ _tlIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _hdIkind_errors ++ _tlIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _hdIstaticErrors ++ _tlIstaticErrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _tlIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _tlIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _tlIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _tlIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _tlIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _tlIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _tlIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _tlIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _tlIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _tlIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _tlIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _tlItypeImps_collect
            -- copy rule (down)
            (_hdOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_hdObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_hdOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_hdOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_hdOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_hdOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_hdOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_hdOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_hdOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_hdOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_hdOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_hdOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_hdOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_hdOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_hdOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_hdOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_hdOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_hdOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_hdOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_hdOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_hdOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_hdOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_hdOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_hdOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_hdOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_tlOabstractTypes_collect@_) =
                _hdIabstractTypes_collect
            -- copy rule (chain)
            (_tlObimapImps_collect@_) =
                _hdIbimapImps_collect
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_tlOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_tlOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_tlOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (chain)
            (_tlOfunImps_collect@_) =
                _hdIfunImps_collect
            -- copy rule (down)
            (_tlOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_tlOgenericAbstractions_collect@_) =
                _hdIgenericAbstractions_collect
            -- copy rule (down)
            (_tlOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOkinames@_) =
                _hdIkinames
            -- copy rule (down)
            (_tlOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (chain)
            (_tlOkindIndexedTypes_collect@_) =
                _hdIkindIndexedTypes_collect
            -- copy rule (down)
            (_tlOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_tlOkindvar@_) =
                _hdIkindvar
            -- copy rule (chain)
            (_tlOksubst@_) =
                _hdIksubst
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_tlOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_tlOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_tlOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_tlOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_tlOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_tlOpresignatures_collect@_) =
                _hdIpresignatures_collect
            -- copy rule (chain)
            (_tlOrawRequests_collect@_) =
                _hdIrawRequests_collect
            -- copy rule (down)
            (_tlOsignatures@_) =
                _lhsIsignatures
            -- copy rule (chain)
            (_tlOstructureTypes_collect@_) =
                _hdIstructureTypes_collect
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_tlOtypeImps_collect@_) =
                _hdItypeImps_collect
            -- copy rule (down)
            (_tlOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_GuardedExpressions_Nil :: (T_GuardedExpressions)
sem_GuardedExpressions_Nil  =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (GuardedExpressions)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
-- Import ------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      imports_collect      : Imports
      kind_errors          : [GHError]
      self                 : SELF

-}
{-
   local variables for Import.TypeOrClass:
      signatureForVar
      self

-}
{-
   local variables for Import.TypeOrClassComplete:
      signatureForVar
      self

-}
{-
   local variables for Import.Variable:
      isGenericAbstraction
      signatureForVar
      self

-}
-- semantic domain
type T_Import = (Maybe Name) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (Strings) ->
                (FMap Name Kind) ->
                (FMap Name Kind) ->
                (Bool) ->
                (Bool) ->
                (Maybe Name) ->
                (KSubst) ->
                (FMap Name KindIndexedType) ->
                (FMap Name KindIndexedType) ->
                (KSubst) ->
                (Int) ->
                (KSubst) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (Bool) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (Set Strings) ->
                (Bool) ->
                (Declarations) ->
                (KSubst) ->
                (Bool) ->
                (PreSignatures) ->
                (PreSignatures) ->
                (Signatures) ->
                (Bool) ->
                (Int) ->
                ( (FMap Name Names),(FMap Name Kind),(Imports),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(PreSignatures),(Import))
-- cata
sem_Import :: (Import) ->
              (T_Import)
sem_Import ((Import_TypeOrClass (_range) (_name) (_names))) =
    (sem_Import_TypeOrClass ((sem_Range (_range))) ((sem_Name (_name))) ((sem_MaybeNames (_names))))
sem_Import ((Import_TypeOrClassComplete (_range) (_name))) =
    (sem_Import_TypeOrClassComplete ((sem_Range (_range))) ((sem_Name (_name))))
sem_Import ((Import_Variable (_range) (_name))) =
    (sem_Import_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Import_TypeOrClass :: (T_Range) ->
                          (T_Name) ->
                          (T_MaybeNames) ->
                          (T_Import)
sem_Import_TypeOrClass (range_) (name_) (names_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOimports_collect :: (Imports)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Import)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _namesIconstructors_collect :: (FMap Name Names)
            _namesIgenericAbstractions_collect :: (FMap Name Kind)
            _namesIkinames :: (KSubst)
            _namesIkind_errors :: ([GHError])
            _namesIkindvar :: (Int)
            _namesIksubst :: (KSubst)
            _namesIlabels_collect :: (FMap Name Names)
            _namesImethods_collect :: (FMap Name Names)
            _namesIself :: (MaybeNames)
            _namesOclassname :: (Maybe Name)
            _namesOconstructors_collect :: (FMap Name Names)
            _namesOconstructors_dist :: (FMap Name Names)
            _namesOcurrentModule :: (Strings)
            _namesOgenericAbstractions :: (FMap Name Kind)
            _namesOgenericAbstractions_collect :: (FMap Name Kind)
            _namesOghc :: (Bool)
            _namesOimportedModule :: (Bool)
            _namesOinstancename :: (Maybe Name)
            _namesOkinames :: (KSubst)
            _namesOkinds :: (KSubst)
            _namesOkindvar :: (Int)
            _namesOksubst :: (KSubst)
            _namesOlabels_collect :: (FMap Name Names)
            _namesOlabels_dist :: (FMap Name Names)
            _namesOlocal :: (Bool)
            _namesOmethods_collect :: (FMap Name Names)
            _namesOmethods_dist :: (FMap Name Names)
            _namesOmodules :: (Set Strings)
            _namesOoptimizer :: (Bool)
            _namesOoptimizerPrelude :: (Declarations)
            _namesOprekind :: (KSubst)
            _namesOprelude :: (Bool)
            _namesOtoplevel :: (Bool)
            _namesOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _namesIconstructors_collect,_namesIgenericAbstractions_collect,_namesIkinames,_namesIkind_errors,_namesIkindvar,_namesIksubst,_namesIlabels_collect,_namesImethods_collect,_namesIself) =
                (names_ (_namesOclassname)
                        (_namesOconstructors_collect)
                        (_namesOconstructors_dist)
                        (_namesOcurrentModule)
                        (_namesOgenericAbstractions)
                        (_namesOgenericAbstractions_collect)
                        (_namesOghc)
                        (_namesOimportedModule)
                        (_namesOinstancename)
                        (_namesOkinames)
                        (_namesOkinds)
                        (_namesOkindvar)
                        (_namesOksubst)
                        (_namesOlabels_collect)
                        (_namesOlabels_dist)
                        (_namesOlocal)
                        (_namesOmethods_collect)
                        (_namesOmethods_dist)
                        (_namesOmodules)
                        (_namesOoptimizer)
                        (_namesOoptimizerPrelude)
                        (_namesOprekind)
                        (_namesOprelude)
                        (_namesOtoplevel)
                        (_namesOverbosity))
            -- "./Exports.inc.lag"(line 238, column 9)
            (_lhsOimports_collect@_) =
                if elem
                     _nameIself
                     (domain _lhsIkindIndexedTypes)
                then
                  []
                else if not (null _signatureForVar) then
                  []
                else
                  [_self]
            -- "./Exports.inc.lag"(line 236, column 9)
            (_signatureForVar@_) =
                map typeArgumentName
                  $ findL _lhsIsignatures _nameIself
            -- use rule
            (_lhsOkind_errors@_) =
                _namesIkind_errors
            -- self rule
            (_self@_) =
                Import_TypeOrClass _rangeIself _nameIself _namesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _namesIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _namesIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _namesIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _namesIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _namesIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _namesIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _namesImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_namesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_namesOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_namesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_namesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_namesOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_namesOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_namesOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_namesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_namesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_namesOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_namesOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_namesOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_namesOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_namesOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_namesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_namesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_namesOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_namesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_namesOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_namesOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_namesOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_namesOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_namesOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_namesOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_namesOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOimports_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Import_TypeOrClassComplete :: (T_Range) ->
                                  (T_Name) ->
                                  (T_Import)
sem_Import_TypeOrClassComplete (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOimports_collect :: (Imports)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Import)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            -- "./Exports.inc.lag"(line 254, column 9)
            (_lhsOimports_collect@_) =
                if elem
                     _nameIself
                     (domain _lhsIkindIndexedTypes)
                then
                  []
                else if not (null _signatureForVar) then
                  []
                else
                  [_self]
            -- "./Exports.inc.lag"(line 252, column 9)
            (_signatureForVar@_) =
                map typeArgumentName
                  $ findL _lhsIsignatures _nameIself
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- self rule
            (_self@_) =
                Import_TypeOrClassComplete _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOimports_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Import_Variable :: (T_Range) ->
                       (T_Name) ->
                       (T_Import)
sem_Import_Variable (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOimports_collect :: (Imports)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Import)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            -- "./Exports.inc.lag"(line 183, column 9)
            (_lhsOimports_collect@_) =
                if _isGenericAbstraction
                then
                  []
                else if not (null _signatureForVar) then
                  []
                else
                  [_self]
            -- "./Exports.inc.lag"(line 182, column 9)
            (_isGenericAbstraction@_) =
                isJust (find _lhsIgenericAbstractions _nameIself)
            -- "./Exports.inc.lag"(line 180, column 9)
            (_signatureForVar@_) =
                map typeArgumentName
                  $ findL _lhsIsignatures _nameIself
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- self rule
            (_self@_) =
                Import_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOimports_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- ImportDeclaration -------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      kind_errors          : [GHError]
      output               : PP.Doc
      outputi              : [PP.Doc]
      self                 : SELF

-}
{-
   local variables for ImportDeclaration.Empty:
      self

-}
{-
   local variables for ImportDeclaration.Import:
      local
      currentModule
      self

-}
-- semantic domain
type T_ImportDeclaration = (Maybe Name) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Strings) ->
                           (FMap Name Kind) ->
                           (FMap Name Kind) ->
                           (Bool) ->
                           (Bool) ->
                           (Maybe Name) ->
                           (KSubst) ->
                           (FMap Name KindIndexedType) ->
                           (FMap Name KindIndexedType) ->
                           (KSubst) ->
                           (Int) ->
                           (KSubst) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Bool) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Set Strings) ->
                           (Bool) ->
                           (Declarations) ->
                           (KSubst) ->
                           (Bool) ->
                           (PreSignatures) ->
                           (PreSignatures) ->
                           (Signatures) ->
                           (Bool) ->
                           (Int) ->
                           ( (FMap Name Names),(FMap Name Kind),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(PP.Doc),([PP.Doc]),(PreSignatures),(ImportDeclaration))
-- cata
sem_ImportDeclaration :: (ImportDeclaration) ->
                         (T_ImportDeclaration)
sem_ImportDeclaration ((ImportDeclaration_Empty (_range))) =
    (sem_ImportDeclaration_Empty ((sem_Range (_range))))
sem_ImportDeclaration ((ImportDeclaration_Import (_range) (_qualified) (_name) (_asname) (_importspecification))) =
    (sem_ImportDeclaration_Import ((sem_Range (_range))) (_qualified) ((sem_ModuleName (_name))) ((sem_MaybeModuleName (_asname))) ((sem_MaybeImportSpecification (_importspecification))))
sem_ImportDeclaration_Empty :: (T_Range) ->
                               (T_ImportDeclaration)
sem_ImportDeclaration_Empty (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: (PP.Doc)
            _lhsOoutputi :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (ImportDeclaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- "./Output.inc.lag"(line 119, column 9)
            (_lhsOoutput@_) =
                PP.empty
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOoutputi@_) =
                []
            -- self rule
            (_self@_) =
                ImportDeclaration_Empty _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOoutput,_lhsOoutputi,_lhsOpresignatures_collect,_lhsOself)
sem_ImportDeclaration_Import :: (T_Range) ->
                                (Bool) ->
                                (T_ModuleName) ->
                                (T_MaybeModuleName) ->
                                (T_MaybeImportSpecification) ->
                                (T_ImportDeclaration)
sem_ImportDeclaration_Import (range_) (qualified_) (name_) (asname_) (importspecification_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: (PP.Doc)
            _lhsOoutputi :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (ImportDeclaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (ModuleName)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _asnameIconstructors_collect :: (FMap Name Names)
            _asnameIgenericAbstractions_collect :: (FMap Name Kind)
            _asnameIlabels_collect :: (FMap Name Names)
            _asnameImethods_collect :: (FMap Name Names)
            _asnameIself :: (MaybeModuleName)
            _asnameOclassname :: (Maybe Name)
            _asnameOconstructors_collect :: (FMap Name Names)
            _asnameOconstructors_dist :: (FMap Name Names)
            _asnameOcurrentModule :: (Strings)
            _asnameOgenericAbstractions :: (FMap Name Kind)
            _asnameOgenericAbstractions_collect :: (FMap Name Kind)
            _asnameOghc :: (Bool)
            _asnameOimportedModule :: (Bool)
            _asnameOinstancename :: (Maybe Name)
            _asnameOlabels_collect :: (FMap Name Names)
            _asnameOlabels_dist :: (FMap Name Names)
            _asnameOlocal :: (Bool)
            _asnameOmethods_collect :: (FMap Name Names)
            _asnameOmethods_dist :: (FMap Name Names)
            _asnameOmodules :: (Set Strings)
            _asnameOoptimizer :: (Bool)
            _asnameOoptimizerPrelude :: (Declarations)
            _asnameOprelude :: (Bool)
            _asnameOtoplevel :: (Bool)
            _asnameOverbosity :: (Int)
            _importspecificationIconstructors_collect :: (FMap Name Names)
            _importspecificationIfinalImports :: (MaybeImportSpecification)
            _importspecificationIgenericAbstractions_collect :: (FMap Name Kind)
            _importspecificationIkinames :: (KSubst)
            _importspecificationIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _importspecificationIkind_errors :: ([GHError])
            _importspecificationIkindvar :: (Int)
            _importspecificationIksubst :: (KSubst)
            _importspecificationIlabels_collect :: (FMap Name Names)
            _importspecificationImethods_collect :: (FMap Name Names)
            _importspecificationIpresignatures_collect :: (PreSignatures)
            _importspecificationIself :: (MaybeImportSpecification)
            _importspecificationOclassname :: (Maybe Name)
            _importspecificationOconstructors_collect :: (FMap Name Names)
            _importspecificationOconstructors_dist :: (FMap Name Names)
            _importspecificationOcurrentModule :: (Strings)
            _importspecificationOgenericAbstractions :: (FMap Name Kind)
            _importspecificationOgenericAbstractions_collect :: (FMap Name Kind)
            _importspecificationOghc :: (Bool)
            _importspecificationOimportedModule :: (Bool)
            _importspecificationOinstancename :: (Maybe Name)
            _importspecificationOkinames :: (KSubst)
            _importspecificationOkindIndexedTypes :: (FMap Name KindIndexedType)
            _importspecificationOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _importspecificationOkinds :: (KSubst)
            _importspecificationOkindvar :: (Int)
            _importspecificationOksubst :: (KSubst)
            _importspecificationOlabels_collect :: (FMap Name Names)
            _importspecificationOlabels_dist :: (FMap Name Names)
            _importspecificationOlocal :: (Bool)
            _importspecificationOmethods_collect :: (FMap Name Names)
            _importspecificationOmethods_dist :: (FMap Name Names)
            _importspecificationOmodules :: (Set Strings)
            _importspecificationOoptimizer :: (Bool)
            _importspecificationOoptimizerPrelude :: (Declarations)
            _importspecificationOprekind :: (KSubst)
            _importspecificationOprelude :: (Bool)
            _importspecificationOpresignatures :: (PreSignatures)
            _importspecificationOpresignatures_collect :: (PreSignatures)
            _importspecificationOsignatures :: (Signatures)
            _importspecificationOtoplevel :: (Bool)
            _importspecificationOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _asnameIconstructors_collect,_asnameIgenericAbstractions_collect,_asnameIlabels_collect,_asnameImethods_collect,_asnameIself) =
                (asname_ (_asnameOclassname)
                         (_asnameOconstructors_collect)
                         (_asnameOconstructors_dist)
                         (_asnameOcurrentModule)
                         (_asnameOgenericAbstractions)
                         (_asnameOgenericAbstractions_collect)
                         (_asnameOghc)
                         (_asnameOimportedModule)
                         (_asnameOinstancename)
                         (_asnameOlabels_collect)
                         (_asnameOlabels_dist)
                         (_asnameOlocal)
                         (_asnameOmethods_collect)
                         (_asnameOmethods_dist)
                         (_asnameOmodules)
                         (_asnameOoptimizer)
                         (_asnameOoptimizerPrelude)
                         (_asnameOprelude)
                         (_asnameOtoplevel)
                         (_asnameOverbosity))
            ( _importspecificationIconstructors_collect,_importspecificationIfinalImports,_importspecificationIgenericAbstractions_collect,_importspecificationIkinames,_importspecificationIkindIndexedTypes_collect,_importspecificationIkind_errors,_importspecificationIkindvar,_importspecificationIksubst,_importspecificationIlabels_collect,_importspecificationImethods_collect,_importspecificationIpresignatures_collect,_importspecificationIself) =
                (importspecification_ (_importspecificationOclassname)
                                      (_importspecificationOconstructors_collect)
                                      (_importspecificationOconstructors_dist)
                                      (_importspecificationOcurrentModule)
                                      (_importspecificationOgenericAbstractions)
                                      (_importspecificationOgenericAbstractions_collect)
                                      (_importspecificationOghc)
                                      (_importspecificationOimportedModule)
                                      (_importspecificationOinstancename)
                                      (_importspecificationOkinames)
                                      (_importspecificationOkindIndexedTypes)
                                      (_importspecificationOkindIndexedTypes_collect)
                                      (_importspecificationOkinds)
                                      (_importspecificationOkindvar)
                                      (_importspecificationOksubst)
                                      (_importspecificationOlabels_collect)
                                      (_importspecificationOlabels_dist)
                                      (_importspecificationOlocal)
                                      (_importspecificationOmethods_collect)
                                      (_importspecificationOmethods_dist)
                                      (_importspecificationOmodules)
                                      (_importspecificationOoptimizer)
                                      (_importspecificationOoptimizerPrelude)
                                      (_importspecificationOprekind)
                                      (_importspecificationOprelude)
                                      (_importspecificationOpresignatures)
                                      (_importspecificationOpresignatures_collect)
                                      (_importspecificationOsignatures)
                                      (_importspecificationOtoplevel)
                                      (_importspecificationOverbosity))
            -- "./ModuleInformation.inc.lag"(line 118, column 8)
            (_local@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 117, column 8)
            (_currentModule@_) =
                getModuleName _nameIself
            -- "./Output.inc.lag"(line 109, column 9)
            (_lhsOoutput@_) =
                PP.ppImportDeclaration False
                  (ImportDeclaration_Import
                     _rangeIself
                     qualified_
                     _nameIself
                     MaybeModuleName_Nothing
                     _importspecificationIfinalImports
                  )
            -- "./OutputI.inc.lag"(line 109, column 9)
            (_lhsOoutputi@_) =
                [PP.ppInterfaceDeclaration True
                   (InterfaceDeclaration_Import
                      unknownRange
                      _nameIself
                   )
                ]
            -- use rule
            (_lhsOkind_errors@_) =
                _importspecificationIkind_errors
            -- self rule
            (_self@_) =
                ImportDeclaration_Import _rangeIself qualified_ _nameIself _asnameIself _importspecificationIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _importspecificationIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _importspecificationIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _importspecificationIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _importspecificationIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _importspecificationIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _importspecificationIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _importspecificationIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _importspecificationImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _importspecificationIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_rangeOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_rangeOlocal@_) =
                _local
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_nameOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_nameOlocal@_) =
                _local
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_asnameOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_asnameOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_asnameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_asnameOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_asnameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_asnameOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_asnameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_asnameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_asnameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_asnameOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_asnameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_asnameOlocal@_) =
                _local
            -- copy rule (chain)
            (_asnameOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_asnameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_asnameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_asnameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_asnameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_asnameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_asnameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_asnameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_importspecificationOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_importspecificationOconstructors_collect@_) =
                _asnameIconstructors_collect
            -- copy rule (down)
            (_importspecificationOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_importspecificationOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_importspecificationOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_importspecificationOgenericAbstractions_collect@_) =
                _asnameIgenericAbstractions_collect
            -- copy rule (down)
            (_importspecificationOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_importspecificationOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_importspecificationOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_importspecificationOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_importspecificationOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_importspecificationOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_importspecificationOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_importspecificationOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_importspecificationOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_importspecificationOlabels_collect@_) =
                _asnameIlabels_collect
            -- copy rule (down)
            (_importspecificationOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_importspecificationOlocal@_) =
                _local
            -- copy rule (chain)
            (_importspecificationOmethods_collect@_) =
                _asnameImethods_collect
            -- copy rule (down)
            (_importspecificationOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_importspecificationOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_importspecificationOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_importspecificationOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_importspecificationOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_importspecificationOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_importspecificationOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_importspecificationOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_importspecificationOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_importspecificationOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_importspecificationOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOoutput,_lhsOoutputi,_lhsOpresignatures_collect,_lhsOself)
-- ImportDeclarations ------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      output               : [PP.Doc]
      presignatures_collect : PreSignatures

   synthesised attributes:
      kind_errors          : [GHError]
      outputi              : [PP.Doc]
      self                 : SELF

-}
{-
   local variables for ImportDeclarations.Cons:
      self

-}
{-
   local variables for ImportDeclarations.Nil:
      self

-}
-- semantic domain
type T_ImportDeclarations = (Maybe Name) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Strings) ->
                            (FMap Name Kind) ->
                            (FMap Name Kind) ->
                            (Bool) ->
                            (Bool) ->
                            (Maybe Name) ->
                            (KSubst) ->
                            (FMap Name KindIndexedType) ->
                            (FMap Name KindIndexedType) ->
                            (KSubst) ->
                            (Int) ->
                            (KSubst) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Bool) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Set Strings) ->
                            (Bool) ->
                            (Declarations) ->
                            ([PP.Doc]) ->
                            (KSubst) ->
                            (Bool) ->
                            (PreSignatures) ->
                            (PreSignatures) ->
                            (Signatures) ->
                            (Bool) ->
                            (Int) ->
                            ( (FMap Name Names),(FMap Name Kind),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),([PP.Doc]),([PP.Doc]),(PreSignatures),(ImportDeclarations))
-- cata
sem_ImportDeclarations :: (ImportDeclarations) ->
                          (T_ImportDeclarations)
sem_ImportDeclarations (list) =
    (foldr (sem_ImportDeclarations_Cons) (sem_ImportDeclarations_Nil) ((map sem_ImportDeclaration list)))
sem_ImportDeclarations_Cons :: (T_ImportDeclaration) ->
                               (T_ImportDeclarations) ->
                               (T_ImportDeclarations)
sem_ImportDeclarations_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIoutput
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: ([PP.Doc])
            _lhsOoutputi :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (ImportDeclarations)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIgenericAbstractions_collect :: (FMap Name Kind)
            _hdIkinames :: (KSubst)
            _hdIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _hdIkind_errors :: ([GHError])
            _hdIkindvar :: (Int)
            _hdIksubst :: (KSubst)
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIoutput :: (PP.Doc)
            _hdIoutputi :: ([PP.Doc])
            _hdIpresignatures_collect :: (PreSignatures)
            _hdIself :: (ImportDeclaration)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOgenericAbstractions :: (FMap Name Kind)
            _hdOgenericAbstractions_collect :: (FMap Name Kind)
            _hdOghc :: (Bool)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOkinames :: (KSubst)
            _hdOkindIndexedTypes :: (FMap Name KindIndexedType)
            _hdOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _hdOkinds :: (KSubst)
            _hdOkindvar :: (Int)
            _hdOksubst :: (KSubst)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmodules :: (Set Strings)
            _hdOoptimizer :: (Bool)
            _hdOoptimizerPrelude :: (Declarations)
            _hdOprekind :: (KSubst)
            _hdOprelude :: (Bool)
            _hdOpresignatures :: (PreSignatures)
            _hdOpresignatures_collect :: (PreSignatures)
            _hdOsignatures :: (Signatures)
            _hdOtoplevel :: (Bool)
            _hdOverbosity :: (Int)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIgenericAbstractions_collect :: (FMap Name Kind)
            _tlIkinames :: (KSubst)
            _tlIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _tlIkind_errors :: ([GHError])
            _tlIkindvar :: (Int)
            _tlIksubst :: (KSubst)
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIoutput :: ([PP.Doc])
            _tlIoutputi :: ([PP.Doc])
            _tlIpresignatures_collect :: (PreSignatures)
            _tlIself :: (ImportDeclarations)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOgenericAbstractions :: (FMap Name Kind)
            _tlOgenericAbstractions_collect :: (FMap Name Kind)
            _tlOghc :: (Bool)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOkinames :: (KSubst)
            _tlOkindIndexedTypes :: (FMap Name KindIndexedType)
            _tlOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _tlOkinds :: (KSubst)
            _tlOkindvar :: (Int)
            _tlOksubst :: (KSubst)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmodules :: (Set Strings)
            _tlOoptimizer :: (Bool)
            _tlOoptimizerPrelude :: (Declarations)
            _tlOoutput :: ([PP.Doc])
            _tlOprekind :: (KSubst)
            _tlOprelude :: (Bool)
            _tlOpresignatures :: (PreSignatures)
            _tlOpresignatures_collect :: (PreSignatures)
            _tlOsignatures :: (Signatures)
            _tlOtoplevel :: (Bool)
            _tlOverbosity :: (Int)
            ( _hdIconstructors_collect,_hdIgenericAbstractions_collect,_hdIkinames,_hdIkindIndexedTypes_collect,_hdIkind_errors,_hdIkindvar,_hdIksubst,_hdIlabels_collect,_hdImethods_collect,_hdIoutput,_hdIoutputi,_hdIpresignatures_collect,_hdIself) =
                (hd_ (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOgenericAbstractions)
                     (_hdOgenericAbstractions_collect)
                     (_hdOghc)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOkinames)
                     (_hdOkindIndexedTypes)
                     (_hdOkindIndexedTypes_collect)
                     (_hdOkinds)
                     (_hdOkindvar)
                     (_hdOksubst)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmodules)
                     (_hdOoptimizer)
                     (_hdOoptimizerPrelude)
                     (_hdOprekind)
                     (_hdOprelude)
                     (_hdOpresignatures)
                     (_hdOpresignatures_collect)
                     (_hdOsignatures)
                     (_hdOtoplevel)
                     (_hdOverbosity))
            ( _tlIconstructors_collect,_tlIgenericAbstractions_collect,_tlIkinames,_tlIkindIndexedTypes_collect,_tlIkind_errors,_tlIkindvar,_tlIksubst,_tlIlabels_collect,_tlImethods_collect,_tlIoutput,_tlIoutputi,_tlIpresignatures_collect,_tlIself) =
                (tl_ (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOgenericAbstractions)
                     (_tlOgenericAbstractions_collect)
                     (_tlOghc)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOkinames)
                     (_tlOkindIndexedTypes)
                     (_tlOkindIndexedTypes_collect)
                     (_tlOkinds)
                     (_tlOkindvar)
                     (_tlOksubst)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmodules)
                     (_tlOoptimizer)
                     (_tlOoptimizerPrelude)
                     (_tlOoutput)
                     (_tlOprekind)
                     (_tlOprelude)
                     (_tlOpresignatures)
                     (_tlOpresignatures_collect)
                     (_tlOsignatures)
                     (_tlOtoplevel)
                     (_tlOverbosity))
            -- "./Output.inc.lag"(line 124, column 9)
            (_lhsOoutput@_) =
                _tlIoutput
            -- "./Output.inc.lag"(line 123, column 9)
            (_tlOoutput@_) =
                _hdIoutput : _lhsIoutput
            -- use rule
            (_lhsOkind_errors@_) =
                _hdIkind_errors ++ _tlIkind_errors
            -- use rule
            (_lhsOoutputi@_) =
                _hdIoutputi ++ _tlIoutputi
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _tlIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _tlIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _tlIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _tlIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _tlIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _tlIpresignatures_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_hdOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_hdOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_hdOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_hdOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_hdOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_hdOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_hdOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_hdOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_hdOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_hdOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_hdOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_hdOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_hdOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_hdOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_hdOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_tlOgenericAbstractions_collect@_) =
                _hdIgenericAbstractions_collect
            -- copy rule (down)
            (_tlOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOkinames@_) =
                _hdIkinames
            -- copy rule (down)
            (_tlOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (chain)
            (_tlOkindIndexedTypes_collect@_) =
                _hdIkindIndexedTypes_collect
            -- copy rule (down)
            (_tlOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_tlOkindvar@_) =
                _hdIkindvar
            -- copy rule (chain)
            (_tlOksubst@_) =
                _hdIksubst
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_tlOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_tlOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_tlOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_tlOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_tlOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_tlOpresignatures_collect@_) =
                _hdIpresignatures_collect
            -- copy rule (down)
            (_tlOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOoutput,_lhsOoutputi,_lhsOpresignatures_collect,_lhsOself)
sem_ImportDeclarations_Nil :: (T_ImportDeclarations)
sem_ImportDeclarations_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIoutput
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: ([PP.Doc])
            _lhsOoutputi :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (ImportDeclarations)
            -- "./Output.inc.lag"(line 127, column 9)
            (_lhsOoutput@_) =
                map
                  (\x ->
                     PP.ppImportDeclaration False
                       (ImportDeclaration_Import
                          unknownRange
                          True
                          (ModuleName_ModuleName
                             unknownRange
                             x
                          )
                          MaybeModuleName_Nothing
                          MaybeImportSpecification_Nothing
                       )
                  )
                  (Set.setToList _lhsImodules)
                ++ _lhsIoutput
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOoutputi@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOoutput,_lhsOoutputi,_lhsOpresignatures_collect,_lhsOself)
-- ImportSpecification -----------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      finalImports         : ImportSpecification
      kind_errors          : [GHError]
      self                 : SELF

-}
{-
   local variables for ImportSpecification.Import:
      self

-}
-- semantic domain
type T_ImportSpecification = (Maybe Name) ->
                             (FMap Name Names) ->
                             (FMap Name Names) ->
                             (Strings) ->
                             (FMap Name Kind) ->
                             (FMap Name Kind) ->
                             (Bool) ->
                             (Bool) ->
                             (Maybe Name) ->
                             (KSubst) ->
                             (FMap Name KindIndexedType) ->
                             (FMap Name KindIndexedType) ->
                             (KSubst) ->
                             (Int) ->
                             (KSubst) ->
                             (FMap Name Names) ->
                             (FMap Name Names) ->
                             (Bool) ->
                             (FMap Name Names) ->
                             (FMap Name Names) ->
                             (Set Strings) ->
                             (Bool) ->
                             (Declarations) ->
                             (KSubst) ->
                             (Bool) ->
                             (PreSignatures) ->
                             (PreSignatures) ->
                             (Signatures) ->
                             (Bool) ->
                             (Int) ->
                             ( (FMap Name Names),(ImportSpecification),(FMap Name Kind),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(PreSignatures),(ImportSpecification))
-- cata
sem_ImportSpecification :: (ImportSpecification) ->
                           (T_ImportSpecification)
sem_ImportSpecification ((ImportSpecification_Import (_range) (_hiding) (_imports))) =
    (sem_ImportSpecification_Import ((sem_Range (_range))) (_hiding) ((sem_Imports (_imports))))
sem_ImportSpecification_Import :: (T_Range) ->
                                  (Bool) ->
                                  (T_Imports) ->
                                  (T_ImportSpecification)
sem_ImportSpecification_Import (range_) (hiding_) (imports_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOfinalImports :: (ImportSpecification)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (ImportSpecification)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _importsIconstructors_collect :: (FMap Name Names)
            _importsIgenericAbstractions_collect :: (FMap Name Kind)
            _importsIimports_collect :: (Imports)
            _importsIkinames :: (KSubst)
            _importsIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _importsIkind_errors :: ([GHError])
            _importsIkindvar :: (Int)
            _importsIksubst :: (KSubst)
            _importsIlabels_collect :: (FMap Name Names)
            _importsImethods_collect :: (FMap Name Names)
            _importsIpresignatures_collect :: (PreSignatures)
            _importsIself :: (Imports)
            _importsOclassname :: (Maybe Name)
            _importsOconstructors_collect :: (FMap Name Names)
            _importsOconstructors_dist :: (FMap Name Names)
            _importsOcurrentModule :: (Strings)
            _importsOgenericAbstractions :: (FMap Name Kind)
            _importsOgenericAbstractions_collect :: (FMap Name Kind)
            _importsOghc :: (Bool)
            _importsOimportedModule :: (Bool)
            _importsOinstancename :: (Maybe Name)
            _importsOkinames :: (KSubst)
            _importsOkindIndexedTypes :: (FMap Name KindIndexedType)
            _importsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _importsOkinds :: (KSubst)
            _importsOkindvar :: (Int)
            _importsOksubst :: (KSubst)
            _importsOlabels_collect :: (FMap Name Names)
            _importsOlabels_dist :: (FMap Name Names)
            _importsOlocal :: (Bool)
            _importsOmethods_collect :: (FMap Name Names)
            _importsOmethods_dist :: (FMap Name Names)
            _importsOmodules :: (Set Strings)
            _importsOoptimizer :: (Bool)
            _importsOoptimizerPrelude :: (Declarations)
            _importsOprekind :: (KSubst)
            _importsOprelude :: (Bool)
            _importsOpresignatures :: (PreSignatures)
            _importsOpresignatures_collect :: (PreSignatures)
            _importsOsignatures :: (Signatures)
            _importsOtoplevel :: (Bool)
            _importsOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _importsIconstructors_collect,_importsIgenericAbstractions_collect,_importsIimports_collect,_importsIkinames,_importsIkindIndexedTypes_collect,_importsIkind_errors,_importsIkindvar,_importsIksubst,_importsIlabels_collect,_importsImethods_collect,_importsIpresignatures_collect,_importsIself) =
                (imports_ (_importsOclassname)
                          (_importsOconstructors_collect)
                          (_importsOconstructors_dist)
                          (_importsOcurrentModule)
                          (_importsOgenericAbstractions)
                          (_importsOgenericAbstractions_collect)
                          (_importsOghc)
                          (_importsOimportedModule)
                          (_importsOinstancename)
                          (_importsOkinames)
                          (_importsOkindIndexedTypes)
                          (_importsOkindIndexedTypes_collect)
                          (_importsOkinds)
                          (_importsOkindvar)
                          (_importsOksubst)
                          (_importsOlabels_collect)
                          (_importsOlabels_dist)
                          (_importsOlocal)
                          (_importsOmethods_collect)
                          (_importsOmethods_dist)
                          (_importsOmodules)
                          (_importsOoptimizer)
                          (_importsOoptimizerPrelude)
                          (_importsOprekind)
                          (_importsOprelude)
                          (_importsOpresignatures)
                          (_importsOpresignatures_collect)
                          (_importsOsignatures)
                          (_importsOtoplevel)
                          (_importsOverbosity))
            -- "./Exports.inc.lag"(line 229, column 9)
            (_lhsOfinalImports@_) =
                ImportSpecification_Import
                  _rangeIself
                  hiding_
                  _importsIimports_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _importsIkind_errors
            -- self rule
            (_self@_) =
                ImportSpecification_Import _rangeIself hiding_ _importsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _importsIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _importsIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _importsIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _importsIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _importsIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _importsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _importsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _importsImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _importsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_importsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_importsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_importsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_importsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_importsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_importsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_importsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_importsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_importsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_importsOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_importsOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_importsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_importsOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_importsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_importsOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_importsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_importsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_importsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_importsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_importsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_importsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_importsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_importsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_importsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_importsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_importsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_importsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_importsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_importsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_importsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOfinalImports,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- Imports -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      imports_collect      : Imports
      kind_errors          : [GHError]
      self                 : SELF

-}
{-
   local variables for Imports.Cons:
      self

-}
{-
   local variables for Imports.Nil:
      self

-}
-- semantic domain
type T_Imports = (Maybe Name) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Strings) ->
                 (FMap Name Kind) ->
                 (FMap Name Kind) ->
                 (Bool) ->
                 (Bool) ->
                 (Maybe Name) ->
                 (KSubst) ->
                 (FMap Name KindIndexedType) ->
                 (FMap Name KindIndexedType) ->
                 (KSubst) ->
                 (Int) ->
                 (KSubst) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Bool) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Set Strings) ->
                 (Bool) ->
                 (Declarations) ->
                 (KSubst) ->
                 (Bool) ->
                 (PreSignatures) ->
                 (PreSignatures) ->
                 (Signatures) ->
                 (Bool) ->
                 (Int) ->
                 ( (FMap Name Names),(FMap Name Kind),(Imports),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(PreSignatures),(Imports))
-- cata
sem_Imports :: (Imports) ->
               (T_Imports)
sem_Imports (list) =
    (foldr (sem_Imports_Cons) (sem_Imports_Nil) ((map sem_Import list)))
sem_Imports_Cons :: (T_Import) ->
                    (T_Imports) ->
                    (T_Imports)
sem_Imports_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOimports_collect :: (Imports)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Imports)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIgenericAbstractions_collect :: (FMap Name Kind)
            _hdIimports_collect :: (Imports)
            _hdIkinames :: (KSubst)
            _hdIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _hdIkind_errors :: ([GHError])
            _hdIkindvar :: (Int)
            _hdIksubst :: (KSubst)
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIpresignatures_collect :: (PreSignatures)
            _hdIself :: (Import)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOgenericAbstractions :: (FMap Name Kind)
            _hdOgenericAbstractions_collect :: (FMap Name Kind)
            _hdOghc :: (Bool)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOkinames :: (KSubst)
            _hdOkindIndexedTypes :: (FMap Name KindIndexedType)
            _hdOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _hdOkinds :: (KSubst)
            _hdOkindvar :: (Int)
            _hdOksubst :: (KSubst)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmodules :: (Set Strings)
            _hdOoptimizer :: (Bool)
            _hdOoptimizerPrelude :: (Declarations)
            _hdOprekind :: (KSubst)
            _hdOprelude :: (Bool)
            _hdOpresignatures :: (PreSignatures)
            _hdOpresignatures_collect :: (PreSignatures)
            _hdOsignatures :: (Signatures)
            _hdOtoplevel :: (Bool)
            _hdOverbosity :: (Int)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIgenericAbstractions_collect :: (FMap Name Kind)
            _tlIimports_collect :: (Imports)
            _tlIkinames :: (KSubst)
            _tlIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _tlIkind_errors :: ([GHError])
            _tlIkindvar :: (Int)
            _tlIksubst :: (KSubst)
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIpresignatures_collect :: (PreSignatures)
            _tlIself :: (Imports)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOgenericAbstractions :: (FMap Name Kind)
            _tlOgenericAbstractions_collect :: (FMap Name Kind)
            _tlOghc :: (Bool)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOkinames :: (KSubst)
            _tlOkindIndexedTypes :: (FMap Name KindIndexedType)
            _tlOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _tlOkinds :: (KSubst)
            _tlOkindvar :: (Int)
            _tlOksubst :: (KSubst)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmodules :: (Set Strings)
            _tlOoptimizer :: (Bool)
            _tlOoptimizerPrelude :: (Declarations)
            _tlOprekind :: (KSubst)
            _tlOprelude :: (Bool)
            _tlOpresignatures :: (PreSignatures)
            _tlOpresignatures_collect :: (PreSignatures)
            _tlOsignatures :: (Signatures)
            _tlOtoplevel :: (Bool)
            _tlOverbosity :: (Int)
            ( _hdIconstructors_collect,_hdIgenericAbstractions_collect,_hdIimports_collect,_hdIkinames,_hdIkindIndexedTypes_collect,_hdIkind_errors,_hdIkindvar,_hdIksubst,_hdIlabels_collect,_hdImethods_collect,_hdIpresignatures_collect,_hdIself) =
                (hd_ (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOgenericAbstractions)
                     (_hdOgenericAbstractions_collect)
                     (_hdOghc)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOkinames)
                     (_hdOkindIndexedTypes)
                     (_hdOkindIndexedTypes_collect)
                     (_hdOkinds)
                     (_hdOkindvar)
                     (_hdOksubst)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmodules)
                     (_hdOoptimizer)
                     (_hdOoptimizerPrelude)
                     (_hdOprekind)
                     (_hdOprelude)
                     (_hdOpresignatures)
                     (_hdOpresignatures_collect)
                     (_hdOsignatures)
                     (_hdOtoplevel)
                     (_hdOverbosity))
            ( _tlIconstructors_collect,_tlIgenericAbstractions_collect,_tlIimports_collect,_tlIkinames,_tlIkindIndexedTypes_collect,_tlIkind_errors,_tlIkindvar,_tlIksubst,_tlIlabels_collect,_tlImethods_collect,_tlIpresignatures_collect,_tlIself) =
                (tl_ (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOgenericAbstractions)
                     (_tlOgenericAbstractions_collect)
                     (_tlOghc)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOkinames)
                     (_tlOkindIndexedTypes)
                     (_tlOkindIndexedTypes_collect)
                     (_tlOkinds)
                     (_tlOkindvar)
                     (_tlOksubst)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmodules)
                     (_tlOoptimizer)
                     (_tlOoptimizerPrelude)
                     (_tlOprekind)
                     (_tlOprelude)
                     (_tlOpresignatures)
                     (_tlOpresignatures_collect)
                     (_tlOsignatures)
                     (_tlOtoplevel)
                     (_tlOverbosity))
            -- use rule
            (_lhsOimports_collect@_) =
                _hdIimports_collect ++ _tlIimports_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _hdIkind_errors ++ _tlIkind_errors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _tlIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _tlIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _tlIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _tlIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _tlIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _tlIpresignatures_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_hdOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_hdOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_hdOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_hdOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_hdOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_hdOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_hdOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_hdOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_hdOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_hdOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_hdOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_hdOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_hdOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_hdOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_hdOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_tlOgenericAbstractions_collect@_) =
                _hdIgenericAbstractions_collect
            -- copy rule (down)
            (_tlOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOkinames@_) =
                _hdIkinames
            -- copy rule (down)
            (_tlOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (chain)
            (_tlOkindIndexedTypes_collect@_) =
                _hdIkindIndexedTypes_collect
            -- copy rule (down)
            (_tlOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_tlOkindvar@_) =
                _hdIkindvar
            -- copy rule (chain)
            (_tlOksubst@_) =
                _hdIksubst
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_tlOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_tlOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_tlOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_tlOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_tlOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_tlOpresignatures_collect@_) =
                _hdIpresignatures_collect
            -- copy rule (down)
            (_tlOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOimports_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Imports_Nil :: (T_Imports)
sem_Imports_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOimports_collect :: (Imports)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Imports)
            -- use rule
            (_lhsOimports_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOimports_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- InterfaceDeclaration ----------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      exportedStructures   : Set Name
      exportedTypes        : Set Name
      exportedValues       : Set Name
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      output               : [PP.Doc]
      presignatures_collect : PreSignatures
      rawRequests_collect  : [RawRequest]
      structureTypes_collect : FMap Name LambdaType
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      kind_errors          : [GHError]
      self                 : SELF
      staticErrors         : [GHError]

-}
{-
   local variables for InterfaceDeclaration.Abstract:
      subs_exported
      is_exported
      kinames
      self

-}
{-
   local variables for InterfaceDeclaration.Binding:
      is_exported
      self

-}
{-
   local variables for InterfaceDeclaration.Consig:
      is_exported
      self

-}
{-
   local variables for InterfaceDeclaration.Declarations:
      self

-}
{-
   local variables for InterfaceDeclaration.Dependency:
      self

-}
{-
   local variables for InterfaceDeclaration.Import:
      self

-}
{-
   local variables for InterfaceDeclaration.SetModule:
      currentModule
      self

-}
-- semantic domain
type T_InterfaceDeclaration = (Set Name) ->
                              ([Request_BimapImply]) ->
                              (Maybe Name) ->
                              (FMap Name Names) ->
                              (FMap Name Names) ->
                              (Strings) ->
                              (FMap Name [(Name,Name)]) ->
                              (Set Name) ->
                              (Set Name) ->
                              (Set Name) ->
                              ([Request_FunImply]) ->
                              (FMap Name Kind) ->
                              (FMap Name Kind) ->
                              (Bool) ->
                              (Bool) ->
                              (Maybe Name) ->
                              (KSubst) ->
                              (FMap Name KindIndexedType) ->
                              (FMap Name KindIndexedType) ->
                              (KSubst) ->
                              (Int) ->
                              (KSubst) ->
                              (FMap Name Names) ->
                              (FMap Name Names) ->
                              (Bool) ->
                              (FMap Name Names) ->
                              (FMap Name Names) ->
                              (Set Strings) ->
                              (Bool) ->
                              (Declarations) ->
                              ([PP.Doc]) ->
                              (KSubst) ->
                              (Bool) ->
                              (PreSignatures) ->
                              (PreSignatures) ->
                              ([RawRequest]) ->
                              (Signatures) ->
                              (FMap Name LambdaType) ->
                              (Bool) ->
                              ([Request_TypeImply]) ->
                              (Int) ->
                              ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),([PP.Doc]),(PreSignatures),([RawRequest]),(InterfaceDeclaration),([GHError]),(FMap Name LambdaType),([Request_TypeImply]))
-- cata
sem_InterfaceDeclaration :: (InterfaceDeclaration) ->
                            (T_InterfaceDeclaration)
sem_InterfaceDeclaration ((InterfaceDeclaration_Abstract (_range) (_name) (_constructors) (_types) (_kind))) =
    (sem_InterfaceDeclaration_Abstract ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Names (_constructors))) ((sem_Types (_types))) ((sem_Kind (_kind))))
sem_InterfaceDeclaration ((InterfaceDeclaration_Binding (_range) (_name))) =
    (sem_InterfaceDeclaration_Binding ((sem_Range (_range))) ((sem_Name (_name))))
sem_InterfaceDeclaration ((InterfaceDeclaration_Consig (_range) (_typelevel) (_name) (_types))) =
    (sem_InterfaceDeclaration_Consig ((sem_Range (_range))) (_typelevel) ((sem_Name (_name))) ((sem_TypeArguments (_types))))
sem_InterfaceDeclaration ((InterfaceDeclaration_Declarations (_range) (_declarations))) =
    (sem_InterfaceDeclaration_Declarations ((sem_Range (_range))) ((sem_Declarations (_declarations))))
sem_InterfaceDeclaration ((InterfaceDeclaration_Dependency (_range) (_name) (_kind) (_bindings))) =
    (sem_InterfaceDeclaration_Dependency ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Kind (_kind))) ((sem_DependencyBindings (_bindings))))
sem_InterfaceDeclaration ((InterfaceDeclaration_Import (_range) (_module))) =
    (sem_InterfaceDeclaration_Import ((sem_Range (_range))) ((sem_ModuleName (_module))))
sem_InterfaceDeclaration ((InterfaceDeclaration_SetModule (_range) (_module) (_declarations))) =
    (sem_InterfaceDeclaration_SetModule ((sem_Range (_range))) ((sem_ModuleName (_module))) ((sem_InterfaceDeclarations (_declarations))))
sem_InterfaceDeclaration_Abstract :: (T_Range) ->
                                     (T_Name) ->
                                     (T_Names) ->
                                     (T_Types) ->
                                     (T_Kind) ->
                                     (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Abstract (range_) (name_) (constructors_) (types_) (kind_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIoutput
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (InterfaceDeclaration)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _constructorsIconstructors_collect :: (FMap Name Names)
            _constructorsIgenericAbstractions_collect :: (FMap Name Kind)
            _constructorsIinferkind :: (Kind)
            _constructorsIkinames :: (KSubst)
            _constructorsIkind_errors :: ([GHError])
            _constructorsIkindvar :: (Int)
            _constructorsIksubst :: (KSubst)
            _constructorsIlabels_collect :: (FMap Name Names)
            _constructorsImethods_collect :: (FMap Name Names)
            _constructorsIself :: (Names)
            _constructorsOclassname :: (Maybe Name)
            _constructorsOconstructors_collect :: (FMap Name Names)
            _constructorsOconstructors_dist :: (FMap Name Names)
            _constructorsOcurrentModule :: (Strings)
            _constructorsOgenericAbstractions :: (FMap Name Kind)
            _constructorsOgenericAbstractions_collect :: (FMap Name Kind)
            _constructorsOghc :: (Bool)
            _constructorsOimportedModule :: (Bool)
            _constructorsOinstancename :: (Maybe Name)
            _constructorsOkinames :: (KSubst)
            _constructorsOkinds :: (KSubst)
            _constructorsOkindvar :: (Int)
            _constructorsOksubst :: (KSubst)
            _constructorsOlabels_collect :: (FMap Name Names)
            _constructorsOlabels_dist :: (FMap Name Names)
            _constructorsOlocal :: (Bool)
            _constructorsOmethods_collect :: (FMap Name Names)
            _constructorsOmethods_dist :: (FMap Name Names)
            _constructorsOmodules :: (Set Strings)
            _constructorsOoptimizer :: (Bool)
            _constructorsOoptimizerPrelude :: (Declarations)
            _constructorsOprekind :: (KSubst)
            _constructorsOprelude :: (Bool)
            _constructorsOtoplevel :: (Bool)
            _constructorsOverbosity :: (Int)
            _typesIabstractTypes_collect :: (Set Name)
            _typesIbimapImps_collect :: ([Request_BimapImply])
            _typesIconstructors_collect :: (FMap Name Names)
            _typesIdepConstraints_collect :: ([DepConstraint])
            _typesIfunImps_collect :: ([Request_FunImply])
            _typesIgenericAbstractions_collect :: (FMap Name Kind)
            _typesIinferkind :: ([Kind])
            _typesIkinames :: (KSubst)
            _typesIkind_errors :: ([GHError])
            _typesIkindvar :: (Int)
            _typesIksubst :: (KSubst)
            _typesIlabels_collect :: (FMap Name Names)
            _typesImethods_collect :: (FMap Name Names)
            _typesIrawRequests_collect :: ([RawRequest])
            _typesIself :: (Types)
            _typesIstaticErrors :: ([GHError])
            _typesItypeImps_collect :: ([Request_TypeImply])
            _typesOabstractTypes_collect :: (Set Name)
            _typesObimapImps_collect :: ([Request_BimapImply])
            _typesOclassname :: (Maybe Name)
            _typesOconstructors_collect :: (FMap Name Names)
            _typesOconstructors_dist :: (FMap Name Names)
            _typesOcurrentModule :: (Strings)
            _typesOdependencies :: (FMap Name [(Name,Name)])
            _typesOfunImps_collect :: ([Request_FunImply])
            _typesOgenericAbstractions :: (FMap Name Kind)
            _typesOgenericAbstractions_collect :: (FMap Name Kind)
            _typesOghc :: (Bool)
            _typesOimportedModule :: (Bool)
            _typesOinstancename :: (Maybe Name)
            _typesOkinames :: (KSubst)
            _typesOkinds :: (KSubst)
            _typesOkindvar :: (Int)
            _typesOksubst :: (KSubst)
            _typesOlabels_collect :: (FMap Name Names)
            _typesOlabels_dist :: (FMap Name Names)
            _typesOlocal :: (Bool)
            _typesOmethods_collect :: (FMap Name Names)
            _typesOmethods_dist :: (FMap Name Names)
            _typesOmodules :: (Set Strings)
            _typesOoptimizer :: (Bool)
            _typesOoptimizerPrelude :: (Declarations)
            _typesOprekind :: (KSubst)
            _typesOprelude :: (Bool)
            _typesOrawRequests_collect :: ([RawRequest])
            _typesOtoplevel :: (Bool)
            _typesOtypeImps_collect :: ([Request_TypeImply])
            _typesOverbosity :: (Int)
            _kindIconstructors_collect :: (FMap Name Names)
            _kindIgenericAbstractions_collect :: (FMap Name Kind)
            _kindIkinames :: (KSubst)
            _kindIkind_errors :: ([GHError])
            _kindIkindvar :: (Int)
            _kindIksubst :: (KSubst)
            _kindIlabels_collect :: (FMap Name Names)
            _kindImethods_collect :: (FMap Name Names)
            _kindIself :: (Kind)
            _kindOclassname :: (Maybe Name)
            _kindOconstructors_collect :: (FMap Name Names)
            _kindOconstructors_dist :: (FMap Name Names)
            _kindOcurrentModule :: (Strings)
            _kindOgenericAbstractions :: (FMap Name Kind)
            _kindOgenericAbstractions_collect :: (FMap Name Kind)
            _kindOghc :: (Bool)
            _kindOimportedModule :: (Bool)
            _kindOinstancename :: (Maybe Name)
            _kindOkinames :: (KSubst)
            _kindOkinds :: (KSubst)
            _kindOkindvar :: (Int)
            _kindOksubst :: (KSubst)
            _kindOlabels_collect :: (FMap Name Names)
            _kindOlabels_dist :: (FMap Name Names)
            _kindOlocal :: (Bool)
            _kindOmethods_collect :: (FMap Name Names)
            _kindOmethods_dist :: (FMap Name Names)
            _kindOmodules :: (Set Strings)
            _kindOoptimizer :: (Bool)
            _kindOoptimizerPrelude :: (Declarations)
            _kindOprekind :: (KSubst)
            _kindOprelude :: (Bool)
            _kindOtoplevel :: (Bool)
            _kindOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _constructorsIconstructors_collect,_constructorsIgenericAbstractions_collect,_constructorsIinferkind,_constructorsIkinames,_constructorsIkind_errors,_constructorsIkindvar,_constructorsIksubst,_constructorsIlabels_collect,_constructorsImethods_collect,_constructorsIself) =
                (constructors_ (_constructorsOclassname)
                               (_constructorsOconstructors_collect)
                               (_constructorsOconstructors_dist)
                               (_constructorsOcurrentModule)
                               (_constructorsOgenericAbstractions)
                               (_constructorsOgenericAbstractions_collect)
                               (_constructorsOghc)
                               (_constructorsOimportedModule)
                               (_constructorsOinstancename)
                               (_constructorsOkinames)
                               (_constructorsOkinds)
                               (_constructorsOkindvar)
                               (_constructorsOksubst)
                               (_constructorsOlabels_collect)
                               (_constructorsOlabels_dist)
                               (_constructorsOlocal)
                               (_constructorsOmethods_collect)
                               (_constructorsOmethods_dist)
                               (_constructorsOmodules)
                               (_constructorsOoptimizer)
                               (_constructorsOoptimizerPrelude)
                               (_constructorsOprekind)
                               (_constructorsOprelude)
                               (_constructorsOtoplevel)
                               (_constructorsOverbosity))
            ( _typesIabstractTypes_collect,_typesIbimapImps_collect,_typesIconstructors_collect,_typesIdepConstraints_collect,_typesIfunImps_collect,_typesIgenericAbstractions_collect,_typesIinferkind,_typesIkinames,_typesIkind_errors,_typesIkindvar,_typesIksubst,_typesIlabels_collect,_typesImethods_collect,_typesIrawRequests_collect,_typesIself,_typesIstaticErrors,_typesItypeImps_collect) =
                (types_ (_typesOabstractTypes_collect)
                        (_typesObimapImps_collect)
                        (_typesOclassname)
                        (_typesOconstructors_collect)
                        (_typesOconstructors_dist)
                        (_typesOcurrentModule)
                        (_typesOdependencies)
                        (_typesOfunImps_collect)
                        (_typesOgenericAbstractions)
                        (_typesOgenericAbstractions_collect)
                        (_typesOghc)
                        (_typesOimportedModule)
                        (_typesOinstancename)
                        (_typesOkinames)
                        (_typesOkinds)
                        (_typesOkindvar)
                        (_typesOksubst)
                        (_typesOlabels_collect)
                        (_typesOlabels_dist)
                        (_typesOlocal)
                        (_typesOmethods_collect)
                        (_typesOmethods_dist)
                        (_typesOmodules)
                        (_typesOoptimizer)
                        (_typesOoptimizerPrelude)
                        (_typesOprekind)
                        (_typesOprelude)
                        (_typesOrawRequests_collect)
                        (_typesOtoplevel)
                        (_typesOtypeImps_collect)
                        (_typesOverbosity))
            ( _kindIconstructors_collect,_kindIgenericAbstractions_collect,_kindIkinames,_kindIkind_errors,_kindIkindvar,_kindIksubst,_kindIlabels_collect,_kindImethods_collect,_kindIself) =
                (kind_ (_kindOclassname)
                       (_kindOconstructors_collect)
                       (_kindOconstructors_dist)
                       (_kindOcurrentModule)
                       (_kindOgenericAbstractions)
                       (_kindOgenericAbstractions_collect)
                       (_kindOghc)
                       (_kindOimportedModule)
                       (_kindOinstancename)
                       (_kindOkinames)
                       (_kindOkinds)
                       (_kindOkindvar)
                       (_kindOksubst)
                       (_kindOlabels_collect)
                       (_kindOlabels_dist)
                       (_kindOlocal)
                       (_kindOmethods_collect)
                       (_kindOmethods_dist)
                       (_kindOmodules)
                       (_kindOoptimizer)
                       (_kindOoptimizerPrelude)
                       (_kindOprekind)
                       (_kindOprelude)
                       (_kindOtoplevel)
                       (_kindOverbosity))
            -- "./Exports.inc.lag"(line 481, column 9)
            (_subs_exported@_) =
                filter
                  (\n -> Set.elementOf n _lhsIexportedValues)
                  _constructorsIself
            -- "./Exports.inc.lag"(line 480, column 9)
            (_is_exported@_) =
                Set.elementOf _nameIself _lhsIexportedTypes
            -- "./Kind.inc.lag"(line 151, column 9)
            (_lhsOkinames@_) =
                _kinames
            -- "./Kind.inc.lag"(line 150, column 9)
            (_kinames@_) =
                add _lhsIkinames (_nameIself,_kindIself)
            -- "./Kind.inc.lag"(line 689, column 9)
            (_lhsOkind_errors@_) =
                []
            -- "./Kind.inc.lag"(line 688, column 9)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- "./Request.inc.lag"(line 345, column 9)
            (_lhsOabstractTypes_collect@_) =
                Set.union
                  (Set.unitSet _nameIself)
                  _lhsIabstractTypes_collect
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _typesIdepConstraints_collect
            -- use rule
            (_lhsOstaticErrors@_) =
                _typesIstaticErrors
            -- self rule
            (_self@_) =
                InterfaceDeclaration_Abstract _rangeIself _nameIself _constructorsIself _typesIself _kindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _typesIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _kindIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _typesIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _kindIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _kindIkindvar
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _kindIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _kindImethods_collect
            -- copy rule (chain)
            (_lhsOoutput@_) =
                _lhsIoutput
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _typesIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _typesItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_constructorsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_constructorsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_constructorsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_constructorsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_constructorsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_constructorsOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_constructorsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_constructorsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_constructorsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_constructorsOkinames@_) =
                _kinames
            -- copy rule (down)
            (_constructorsOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_constructorsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_constructorsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_constructorsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_constructorsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_constructorsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_constructorsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_constructorsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_constructorsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_constructorsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_constructorsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_constructorsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_constructorsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_constructorsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_constructorsOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_typesOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_typesObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_typesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typesOconstructors_collect@_) =
                _constructorsIconstructors_collect
            -- copy rule (down)
            (_typesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typesOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_typesOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_typesOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_typesOgenericAbstractions_collect@_) =
                _constructorsIgenericAbstractions_collect
            -- copy rule (down)
            (_typesOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_typesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typesOinstancename@_) =
                _lhsIinstancename
            -- modified copy rule
            (_typesOkinames@_) =
                _constructorsIkinames
            -- copy rule (down)
            (_typesOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_typesOkindvar@_) =
                _constructorsIkindvar
            -- copy rule (chain)
            (_typesOksubst@_) =
                _constructorsIksubst
            -- copy rule (chain)
            (_typesOlabels_collect@_) =
                _constructorsIlabels_collect
            -- copy rule (down)
            (_typesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typesOmethods_collect@_) =
                _constructorsImethods_collect
            -- copy rule (down)
            (_typesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typesOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_typesOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_typesOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_typesOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_typesOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_typesOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_typesOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typesOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_typesOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_kindOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_kindOconstructors_collect@_) =
                _typesIconstructors_collect
            -- copy rule (down)
            (_kindOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_kindOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_kindOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_kindOgenericAbstractions_collect@_) =
                _typesIgenericAbstractions_collect
            -- copy rule (down)
            (_kindOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_kindOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_kindOinstancename@_) =
                _lhsIinstancename
            -- modified copy rule
            (_kindOkinames@_) =
                _typesIkinames
            -- copy rule (down)
            (_kindOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_kindOkindvar@_) =
                _typesIkindvar
            -- copy rule (chain)
            (_kindOksubst@_) =
                _typesIksubst
            -- copy rule (chain)
            (_kindOlabels_collect@_) =
                _typesIlabels_collect
            -- copy rule (down)
            (_kindOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_kindOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_kindOmethods_collect@_) =
                _typesImethods_collect
            -- copy rule (down)
            (_kindOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_kindOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_kindOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_kindOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_kindOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_kindOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_kindOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_kindOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOoutput,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_InterfaceDeclaration_Binding :: (T_Range) ->
                                    (T_Name) ->
                                    (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Binding (range_) (name_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIoutput
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (InterfaceDeclaration)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            -- "./Exports.inc.lag"(line 489, column 9)
            (_is_exported@_) =
                Set.elementOf _nameIself _lhsIexportedValues
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                InterfaceDeclaration_Binding _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (chain)
            (_lhsOoutput@_) =
                _lhsIoutput
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOoutput,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_InterfaceDeclaration_Consig :: (T_Range) ->
                                   (Bool) ->
                                   (T_Name) ->
                                   (T_TypeArguments) ->
                                   (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Consig (range_) (typelevel_) (name_) (types_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIoutput
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (InterfaceDeclaration)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _typesIconstructors_collect :: (FMap Name Names)
            _typesIgenericAbstractions_collect :: (FMap Name Kind)
            _typesIkinames :: (KSubst)
            _typesIkind_errors :: ([GHError])
            _typesIkindvar :: (Int)
            _typesIksubst :: (KSubst)
            _typesIlabels_collect :: (FMap Name Names)
            _typesImethods_collect :: (FMap Name Names)
            _typesIself :: (TypeArguments)
            _typesOclassname :: (Maybe Name)
            _typesOconstructors_collect :: (FMap Name Names)
            _typesOconstructors_dist :: (FMap Name Names)
            _typesOcurrentModule :: (Strings)
            _typesOgenericAbstractions :: (FMap Name Kind)
            _typesOgenericAbstractions_collect :: (FMap Name Kind)
            _typesOghc :: (Bool)
            _typesOimportedModule :: (Bool)
            _typesOinstancename :: (Maybe Name)
            _typesOkinames :: (KSubst)
            _typesOkinds :: (KSubst)
            _typesOkindvar :: (Int)
            _typesOksubst :: (KSubst)
            _typesOlabels_collect :: (FMap Name Names)
            _typesOlabels_dist :: (FMap Name Names)
            _typesOlocal :: (Bool)
            _typesOmethods_collect :: (FMap Name Names)
            _typesOmethods_dist :: (FMap Name Names)
            _typesOmodules :: (Set Strings)
            _typesOoptimizer :: (Bool)
            _typesOoptimizerPrelude :: (Declarations)
            _typesOprekind :: (KSubst)
            _typesOprelude :: (Bool)
            _typesOtoplevel :: (Bool)
            _typesOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _typesIconstructors_collect,_typesIgenericAbstractions_collect,_typesIkinames,_typesIkind_errors,_typesIkindvar,_typesIksubst,_typesIlabels_collect,_typesImethods_collect,_typesIself) =
                (types_ (_typesOclassname)
                        (_typesOconstructors_collect)
                        (_typesOconstructors_dist)
                        (_typesOcurrentModule)
                        (_typesOgenericAbstractions)
                        (_typesOgenericAbstractions_collect)
                        (_typesOghc)
                        (_typesOimportedModule)
                        (_typesOinstancename)
                        (_typesOkinames)
                        (_typesOkinds)
                        (_typesOkindvar)
                        (_typesOksubst)
                        (_typesOlabels_collect)
                        (_typesOlabels_dist)
                        (_typesOlocal)
                        (_typesOmethods_collect)
                        (_typesOmethods_dist)
                        (_typesOmodules)
                        (_typesOoptimizer)
                        (_typesOoptimizerPrelude)
                        (_typesOprekind)
                        (_typesOprelude)
                        (_typesOtoplevel)
                        (_typesOverbosity))
            -- "./Exports.inc.lag"(line 486, column 9)
            (_is_exported@_) =
                Set.elementOf _nameIself _lhsIexportedTypes
            -- "./Signature.inc.lag"(line 121, column 9)
            (_lhsOpresignatures_collect@_) =
                case  find
                        _lhsIpresignatures_collect
                        _nameIself
                of
                  Nothing  ->  add _lhsIpresignatures_collect
                                   (_nameIself,(_typesIself,Nothing))
                  Just _   ->  _lhsIpresignatures_collect
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                _typesIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                InterfaceDeclaration_Consig _rangeIself typelevel_ _nameIself _typesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typesIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _typesIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _typesIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _typesIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _typesIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typesIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typesImethods_collect
            -- copy rule (chain)
            (_lhsOoutput@_) =
                _lhsIoutput
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_typesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typesOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_typesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typesOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_typesOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_typesOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_typesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typesOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_typesOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_typesOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_typesOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_typesOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_typesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typesOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_typesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typesOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_typesOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_typesOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_typesOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_typesOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_typesOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typesOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOoutput,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_InterfaceDeclaration_Declarations :: (T_Range) ->
                                         (T_Declarations) ->
                                         (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Declarations (range_) (declarations_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIoutput
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (InterfaceDeclaration)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _declarationsIabstractTypes_collect :: (Set Name)
            _declarationsIbimapImps_collect :: ([Request_BimapImply])
            _declarationsIconstructors_collect :: (FMap Name Names)
            _declarationsIdepConstraints_collect :: ([DepConstraint])
            _declarationsIdepConstraints_defined :: ([DepConstraint])
            _declarationsIexportedDeclarations :: (Declarations)
            _declarationsIfunImps_collect :: ([Request_FunImply])
            _declarationsIgenericAbstractions_collect :: (FMap Name Kind)
            _declarationsIkinames :: (KSubst)
            _declarationsIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _declarationsIkind_errors :: ([GHError])
            _declarationsIkindvar :: (Int)
            _declarationsIksubst :: (KSubst)
            _declarationsIlabels_collect :: (FMap Name Names)
            _declarationsImethods_collect :: (FMap Name Names)
            _declarationsIoutput :: ([PP.Doc])
            _declarationsIoutputi :: ([PP.Doc])
            _declarationsIpresignatures_collect :: (PreSignatures)
            _declarationsIrawRequests_collect :: ([RawRequest])
            _declarationsIself :: (Declarations)
            _declarationsIstaticErrors :: ([GHError])
            _declarationsIstructureTypes_collect :: (FMap Name LambdaType)
            _declarationsItypeImps_collect :: ([Request_TypeImply])
            _declarationsOabstractTypes_collect :: (Set Name)
            _declarationsObimapImps_collect :: ([Request_BimapImply])
            _declarationsOclassname :: (Maybe Name)
            _declarationsOconstructors_collect :: (FMap Name Names)
            _declarationsOconstructors_dist :: (FMap Name Names)
            _declarationsOcurrentModule :: (Strings)
            _declarationsOdependencies :: (FMap Name [(Name,Name)])
            _declarationsOexportedStructures :: (Set Name)
            _declarationsOexportedTypes :: (Set Name)
            _declarationsOexportedValues :: (Set Name)
            _declarationsOfunImps_collect :: ([Request_FunImply])
            _declarationsOgenericAbstractions :: (FMap Name Kind)
            _declarationsOgenericAbstractions_collect :: (FMap Name Kind)
            _declarationsOghc :: (Bool)
            _declarationsOimportedModule :: (Bool)
            _declarationsOinstancename :: (Maybe Name)
            _declarationsOkinames :: (KSubst)
            _declarationsOkindIndexedTypes :: (FMap Name KindIndexedType)
            _declarationsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _declarationsOkinds :: (KSubst)
            _declarationsOkindvar :: (Int)
            _declarationsOksubst :: (KSubst)
            _declarationsOlabels_collect :: (FMap Name Names)
            _declarationsOlabels_dist :: (FMap Name Names)
            _declarationsOlocal :: (Bool)
            _declarationsOmethods_collect :: (FMap Name Names)
            _declarationsOmethods_dist :: (FMap Name Names)
            _declarationsOmodules :: (Set Strings)
            _declarationsOoptimizer :: (Bool)
            _declarationsOoptimizerPrelude :: (Declarations)
            _declarationsOoutput :: ([PP.Doc])
            _declarationsOprekind :: (KSubst)
            _declarationsOprelude :: (Bool)
            _declarationsOpresignatures :: (PreSignatures)
            _declarationsOpresignatures_collect :: (PreSignatures)
            _declarationsOrawRequests_collect :: ([RawRequest])
            _declarationsOsignatures :: (Signatures)
            _declarationsOstructureTypes_collect :: (FMap Name LambdaType)
            _declarationsOtoplevel :: (Bool)
            _declarationsOtypeImps_collect :: ([Request_TypeImply])
            _declarationsOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _declarationsIabstractTypes_collect
             ,_declarationsIbimapImps_collect
             ,_declarationsIconstructors_collect
             ,_declarationsIdepConstraints_collect
             ,_declarationsIdepConstraints_defined
             ,_declarationsIexportedDeclarations
             ,_declarationsIfunImps_collect
             ,_declarationsIgenericAbstractions_collect
             ,_declarationsIkinames
             ,_declarationsIkindIndexedTypes_collect
             ,_declarationsIkind_errors
             ,_declarationsIkindvar
             ,_declarationsIksubst
             ,_declarationsIlabels_collect
             ,_declarationsImethods_collect
             ,_declarationsIoutput
             ,_declarationsIoutputi
             ,_declarationsIpresignatures_collect
             ,_declarationsIrawRequests_collect
             ,_declarationsIself
             ,_declarationsIstaticErrors
             ,_declarationsIstructureTypes_collect
             ,_declarationsItypeImps_collect
             ) =
                (declarations_ (_declarationsOabstractTypes_collect)
                               (_declarationsObimapImps_collect)
                               (_declarationsOclassname)
                               (_declarationsOconstructors_collect)
                               (_declarationsOconstructors_dist)
                               (_declarationsOcurrentModule)
                               (_declarationsOdependencies)
                               (_declarationsOexportedStructures)
                               (_declarationsOexportedTypes)
                               (_declarationsOexportedValues)
                               (_declarationsOfunImps_collect)
                               (_declarationsOgenericAbstractions)
                               (_declarationsOgenericAbstractions_collect)
                               (_declarationsOghc)
                               (_declarationsOimportedModule)
                               (_declarationsOinstancename)
                               (_declarationsOkinames)
                               (_declarationsOkindIndexedTypes)
                               (_declarationsOkindIndexedTypes_collect)
                               (_declarationsOkinds)
                               (_declarationsOkindvar)
                               (_declarationsOksubst)
                               (_declarationsOlabels_collect)
                               (_declarationsOlabels_dist)
                               (_declarationsOlocal)
                               (_declarationsOmethods_collect)
                               (_declarationsOmethods_dist)
                               (_declarationsOmodules)
                               (_declarationsOoptimizer)
                               (_declarationsOoptimizerPrelude)
                               (_declarationsOoutput)
                               (_declarationsOprekind)
                               (_declarationsOprelude)
                               (_declarationsOpresignatures)
                               (_declarationsOpresignatures_collect)
                               (_declarationsOrawRequests_collect)
                               (_declarationsOsignatures)
                               (_declarationsOstructureTypes_collect)
                               (_declarationsOtoplevel)
                               (_declarationsOtypeImps_collect)
                               (_declarationsOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _declarationsIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _declarationsIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _declarationsIstaticErrors
            -- self rule
            (_self@_) =
                InterfaceDeclaration_Declarations _rangeIself _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _declarationsIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _declarationsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _declarationsIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _declarationsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _declarationsIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _declarationsIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _declarationsIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _declarationsIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _declarationsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _declarationsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _declarationsImethods_collect
            -- copy rule (up)
            (_lhsOoutput@_) =
                _declarationsIoutput
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _declarationsIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _declarationsIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _declarationsIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _declarationsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_declarationsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_declarationsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_declarationsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_declarationsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_declarationsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_declarationsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_declarationsOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_declarationsOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_declarationsOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_declarationsOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_declarationsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_declarationsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_declarationsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_declarationsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_declarationsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_declarationsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_declarationsOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_declarationsOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_declarationsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_declarationsOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_declarationsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_declarationsOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_declarationsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_declarationsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_declarationsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_declarationsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_declarationsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_declarationsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_declarationsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_declarationsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_declarationsOoutput@_) =
                _lhsIoutput
            -- copy rule (down)
            (_declarationsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_declarationsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_declarationsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_declarationsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_declarationsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_declarationsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_declarationsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_declarationsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_declarationsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_declarationsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOoutput,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_InterfaceDeclaration_Dependency :: (T_Range) ->
                                       (T_Name) ->
                                       (T_Kind) ->
                                       (T_DependencyBindings) ->
                                       (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Dependency (range_) (name_) (kind_) (bindings_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIoutput
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (InterfaceDeclaration)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _kindIconstructors_collect :: (FMap Name Names)
            _kindIgenericAbstractions_collect :: (FMap Name Kind)
            _kindIkinames :: (KSubst)
            _kindIkind_errors :: ([GHError])
            _kindIkindvar :: (Int)
            _kindIksubst :: (KSubst)
            _kindIlabels_collect :: (FMap Name Names)
            _kindImethods_collect :: (FMap Name Names)
            _kindIself :: (Kind)
            _kindOclassname :: (Maybe Name)
            _kindOconstructors_collect :: (FMap Name Names)
            _kindOconstructors_dist :: (FMap Name Names)
            _kindOcurrentModule :: (Strings)
            _kindOgenericAbstractions :: (FMap Name Kind)
            _kindOgenericAbstractions_collect :: (FMap Name Kind)
            _kindOghc :: (Bool)
            _kindOimportedModule :: (Bool)
            _kindOinstancename :: (Maybe Name)
            _kindOkinames :: (KSubst)
            _kindOkinds :: (KSubst)
            _kindOkindvar :: (Int)
            _kindOksubst :: (KSubst)
            _kindOlabels_collect :: (FMap Name Names)
            _kindOlabels_dist :: (FMap Name Names)
            _kindOlocal :: (Bool)
            _kindOmethods_collect :: (FMap Name Names)
            _kindOmethods_dist :: (FMap Name Names)
            _kindOmodules :: (Set Strings)
            _kindOoptimizer :: (Bool)
            _kindOoptimizerPrelude :: (Declarations)
            _kindOprekind :: (KSubst)
            _kindOprelude :: (Bool)
            _kindOtoplevel :: (Bool)
            _kindOverbosity :: (Int)
            _bindingsIconstructors_collect :: (FMap Name Names)
            _bindingsIgenericAbstractions_collect :: (FMap Name Kind)
            _bindingsIlabels_collect :: (FMap Name Names)
            _bindingsImethods_collect :: (FMap Name Names)
            _bindingsInames :: (Names)
            _bindingsIself :: (DependencyBindings)
            _bindingsOclassname :: (Maybe Name)
            _bindingsOconstructors_collect :: (FMap Name Names)
            _bindingsOconstructors_dist :: (FMap Name Names)
            _bindingsOcurrentModule :: (Strings)
            _bindingsOgenericAbstractions :: (FMap Name Kind)
            _bindingsOgenericAbstractions_collect :: (FMap Name Kind)
            _bindingsOghc :: (Bool)
            _bindingsOimportedModule :: (Bool)
            _bindingsOinstancename :: (Maybe Name)
            _bindingsOlabels_collect :: (FMap Name Names)
            _bindingsOlabels_dist :: (FMap Name Names)
            _bindingsOlocal :: (Bool)
            _bindingsOmethods_collect :: (FMap Name Names)
            _bindingsOmethods_dist :: (FMap Name Names)
            _bindingsOmodules :: (Set Strings)
            _bindingsOoptimizer :: (Bool)
            _bindingsOoptimizerPrelude :: (Declarations)
            _bindingsOprelude :: (Bool)
            _bindingsOtoplevel :: (Bool)
            _bindingsOtypelevel :: (Bool)
            _bindingsOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _kindIconstructors_collect,_kindIgenericAbstractions_collect,_kindIkinames,_kindIkind_errors,_kindIkindvar,_kindIksubst,_kindIlabels_collect,_kindImethods_collect,_kindIself) =
                (kind_ (_kindOclassname)
                       (_kindOconstructors_collect)
                       (_kindOconstructors_dist)
                       (_kindOcurrentModule)
                       (_kindOgenericAbstractions)
                       (_kindOgenericAbstractions_collect)
                       (_kindOghc)
                       (_kindOimportedModule)
                       (_kindOinstancename)
                       (_kindOkinames)
                       (_kindOkinds)
                       (_kindOkindvar)
                       (_kindOksubst)
                       (_kindOlabels_collect)
                       (_kindOlabels_dist)
                       (_kindOlocal)
                       (_kindOmethods_collect)
                       (_kindOmethods_dist)
                       (_kindOmodules)
                       (_kindOoptimizer)
                       (_kindOoptimizerPrelude)
                       (_kindOprekind)
                       (_kindOprelude)
                       (_kindOtoplevel)
                       (_kindOverbosity))
            ( _bindingsIconstructors_collect,_bindingsIgenericAbstractions_collect,_bindingsIlabels_collect,_bindingsImethods_collect,_bindingsInames,_bindingsIself) =
                (bindings_ (_bindingsOclassname)
                           (_bindingsOconstructors_collect)
                           (_bindingsOconstructors_dist)
                           (_bindingsOcurrentModule)
                           (_bindingsOgenericAbstractions)
                           (_bindingsOgenericAbstractions_collect)
                           (_bindingsOghc)
                           (_bindingsOimportedModule)
                           (_bindingsOinstancename)
                           (_bindingsOlabels_collect)
                           (_bindingsOlabels_dist)
                           (_bindingsOlocal)
                           (_bindingsOmethods_collect)
                           (_bindingsOmethods_dist)
                           (_bindingsOmodules)
                           (_bindingsOoptimizer)
                           (_bindingsOoptimizerPrelude)
                           (_bindingsOprelude)
                           (_bindingsOtoplevel)
                           (_bindingsOtypelevel)
                           (_bindingsOverbosity))
            -- "./ModuleInformation.inc.lag"(line 219, column 9)
            (_bindingsOtypelevel@_) =
                False
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                _kindIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                InterfaceDeclaration_Dependency _rangeIself _nameIself _kindIself _bindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _bindingsIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _bindingsIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _kindIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _kindIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _kindIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _bindingsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _bindingsImethods_collect
            -- copy rule (chain)
            (_lhsOoutput@_) =
                _lhsIoutput
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_kindOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_kindOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_kindOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_kindOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_kindOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_kindOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_kindOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_kindOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_kindOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_kindOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_kindOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_kindOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_kindOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_kindOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_kindOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_kindOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_kindOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_kindOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_kindOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_kindOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_kindOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_kindOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_kindOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_kindOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_kindOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_bindingsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_bindingsOconstructors_collect@_) =
                _kindIconstructors_collect
            -- copy rule (down)
            (_bindingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_bindingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_bindingsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_bindingsOgenericAbstractions_collect@_) =
                _kindIgenericAbstractions_collect
            -- copy rule (down)
            (_bindingsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_bindingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_bindingsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_bindingsOlabels_collect@_) =
                _kindIlabels_collect
            -- copy rule (down)
            (_bindingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_bindingsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_bindingsOmethods_collect@_) =
                _kindImethods_collect
            -- copy rule (down)
            (_bindingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_bindingsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_bindingsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_bindingsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_bindingsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_bindingsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_bindingsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOoutput,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_InterfaceDeclaration_Import :: (T_Range) ->
                                   (T_ModuleName) ->
                                   (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Import (range_) (module_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIoutput
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (InterfaceDeclaration)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _moduleIconstructors_collect :: (FMap Name Names)
            _moduleIgenericAbstractions_collect :: (FMap Name Kind)
            _moduleIlabels_collect :: (FMap Name Names)
            _moduleImethods_collect :: (FMap Name Names)
            _moduleIself :: (ModuleName)
            _moduleOclassname :: (Maybe Name)
            _moduleOconstructors_collect :: (FMap Name Names)
            _moduleOconstructors_dist :: (FMap Name Names)
            _moduleOcurrentModule :: (Strings)
            _moduleOgenericAbstractions :: (FMap Name Kind)
            _moduleOgenericAbstractions_collect :: (FMap Name Kind)
            _moduleOghc :: (Bool)
            _moduleOimportedModule :: (Bool)
            _moduleOinstancename :: (Maybe Name)
            _moduleOlabels_collect :: (FMap Name Names)
            _moduleOlabels_dist :: (FMap Name Names)
            _moduleOlocal :: (Bool)
            _moduleOmethods_collect :: (FMap Name Names)
            _moduleOmethods_dist :: (FMap Name Names)
            _moduleOmodules :: (Set Strings)
            _moduleOoptimizer :: (Bool)
            _moduleOoptimizerPrelude :: (Declarations)
            _moduleOprelude :: (Bool)
            _moduleOtoplevel :: (Bool)
            _moduleOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _moduleIconstructors_collect,_moduleIgenericAbstractions_collect,_moduleIlabels_collect,_moduleImethods_collect,_moduleIself) =
                (module_ (_moduleOclassname)
                         (_moduleOconstructors_collect)
                         (_moduleOconstructors_dist)
                         (_moduleOcurrentModule)
                         (_moduleOgenericAbstractions)
                         (_moduleOgenericAbstractions_collect)
                         (_moduleOghc)
                         (_moduleOimportedModule)
                         (_moduleOinstancename)
                         (_moduleOlabels_collect)
                         (_moduleOlabels_dist)
                         (_moduleOlocal)
                         (_moduleOmethods_collect)
                         (_moduleOmethods_dist)
                         (_moduleOmodules)
                         (_moduleOoptimizer)
                         (_moduleOoptimizerPrelude)
                         (_moduleOprelude)
                         (_moduleOtoplevel)
                         (_moduleOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                InterfaceDeclaration_Import _rangeIself _moduleIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _moduleIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _moduleIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _moduleIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _moduleImethods_collect
            -- copy rule (chain)
            (_lhsOoutput@_) =
                _lhsIoutput
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_moduleOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_moduleOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_moduleOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_moduleOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_moduleOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_moduleOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_moduleOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_moduleOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_moduleOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_moduleOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_moduleOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_moduleOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_moduleOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_moduleOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_moduleOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_moduleOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_moduleOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_moduleOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_moduleOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_moduleOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOoutput,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_InterfaceDeclaration_SetModule :: (T_Range) ->
                                      (T_ModuleName) ->
                                      (T_InterfaceDeclarations) ->
                                      (T_InterfaceDeclaration)
sem_InterfaceDeclaration_SetModule (range_) (module_) (declarations_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIoutput
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (InterfaceDeclaration)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _moduleIconstructors_collect :: (FMap Name Names)
            _moduleIgenericAbstractions_collect :: (FMap Name Kind)
            _moduleIlabels_collect :: (FMap Name Names)
            _moduleImethods_collect :: (FMap Name Names)
            _moduleIself :: (ModuleName)
            _moduleOclassname :: (Maybe Name)
            _moduleOconstructors_collect :: (FMap Name Names)
            _moduleOconstructors_dist :: (FMap Name Names)
            _moduleOcurrentModule :: (Strings)
            _moduleOgenericAbstractions :: (FMap Name Kind)
            _moduleOgenericAbstractions_collect :: (FMap Name Kind)
            _moduleOghc :: (Bool)
            _moduleOimportedModule :: (Bool)
            _moduleOinstancename :: (Maybe Name)
            _moduleOlabels_collect :: (FMap Name Names)
            _moduleOlabels_dist :: (FMap Name Names)
            _moduleOlocal :: (Bool)
            _moduleOmethods_collect :: (FMap Name Names)
            _moduleOmethods_dist :: (FMap Name Names)
            _moduleOmodules :: (Set Strings)
            _moduleOoptimizer :: (Bool)
            _moduleOoptimizerPrelude :: (Declarations)
            _moduleOprelude :: (Bool)
            _moduleOtoplevel :: (Bool)
            _moduleOverbosity :: (Int)
            _declarationsIabstractTypes_collect :: (Set Name)
            _declarationsIbimapImps_collect :: ([Request_BimapImply])
            _declarationsIconstructors_collect :: (FMap Name Names)
            _declarationsIdepConstraints_collect :: ([DepConstraint])
            _declarationsIfunImps_collect :: ([Request_FunImply])
            _declarationsIgenericAbstractions_collect :: (FMap Name Kind)
            _declarationsIkinames :: (KSubst)
            _declarationsIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _declarationsIkind_errors :: ([GHError])
            _declarationsIkindvar :: (Int)
            _declarationsIksubst :: (KSubst)
            _declarationsIlabels_collect :: (FMap Name Names)
            _declarationsImethods_collect :: (FMap Name Names)
            _declarationsIoutput :: ([PP.Doc])
            _declarationsIpresignatures_collect :: (PreSignatures)
            _declarationsIrawRequests_collect :: ([RawRequest])
            _declarationsIself :: (InterfaceDeclarations)
            _declarationsIstaticErrors :: ([GHError])
            _declarationsIstructureTypes_collect :: (FMap Name LambdaType)
            _declarationsItypeImps_collect :: ([Request_TypeImply])
            _declarationsOabstractTypes_collect :: (Set Name)
            _declarationsObimapImps_collect :: ([Request_BimapImply])
            _declarationsOclassname :: (Maybe Name)
            _declarationsOconstructors_collect :: (FMap Name Names)
            _declarationsOconstructors_dist :: (FMap Name Names)
            _declarationsOcurrentModule :: (Strings)
            _declarationsOdependencies :: (FMap Name [(Name,Name)])
            _declarationsOexportedStructures :: (Set Name)
            _declarationsOexportedTypes :: (Set Name)
            _declarationsOexportedValues :: (Set Name)
            _declarationsOfunImps_collect :: ([Request_FunImply])
            _declarationsOgenericAbstractions :: (FMap Name Kind)
            _declarationsOgenericAbstractions_collect :: (FMap Name Kind)
            _declarationsOghc :: (Bool)
            _declarationsOimportedModule :: (Bool)
            _declarationsOinstancename :: (Maybe Name)
            _declarationsOkinames :: (KSubst)
            _declarationsOkindIndexedTypes :: (FMap Name KindIndexedType)
            _declarationsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _declarationsOkinds :: (KSubst)
            _declarationsOkindvar :: (Int)
            _declarationsOksubst :: (KSubst)
            _declarationsOlabels_collect :: (FMap Name Names)
            _declarationsOlabels_dist :: (FMap Name Names)
            _declarationsOlocal :: (Bool)
            _declarationsOmethods_collect :: (FMap Name Names)
            _declarationsOmethods_dist :: (FMap Name Names)
            _declarationsOmodules :: (Set Strings)
            _declarationsOoptimizer :: (Bool)
            _declarationsOoptimizerPrelude :: (Declarations)
            _declarationsOoutput :: ([PP.Doc])
            _declarationsOprekind :: (KSubst)
            _declarationsOprelude :: (Bool)
            _declarationsOpresignatures :: (PreSignatures)
            _declarationsOpresignatures_collect :: (PreSignatures)
            _declarationsOrawRequests_collect :: ([RawRequest])
            _declarationsOsignatures :: (Signatures)
            _declarationsOstructureTypes_collect :: (FMap Name LambdaType)
            _declarationsOtoplevel :: (Bool)
            _declarationsOtypeImps_collect :: ([Request_TypeImply])
            _declarationsOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _moduleIconstructors_collect,_moduleIgenericAbstractions_collect,_moduleIlabels_collect,_moduleImethods_collect,_moduleIself) =
                (module_ (_moduleOclassname)
                         (_moduleOconstructors_collect)
                         (_moduleOconstructors_dist)
                         (_moduleOcurrentModule)
                         (_moduleOgenericAbstractions)
                         (_moduleOgenericAbstractions_collect)
                         (_moduleOghc)
                         (_moduleOimportedModule)
                         (_moduleOinstancename)
                         (_moduleOlabels_collect)
                         (_moduleOlabels_dist)
                         (_moduleOlocal)
                         (_moduleOmethods_collect)
                         (_moduleOmethods_dist)
                         (_moduleOmodules)
                         (_moduleOoptimizer)
                         (_moduleOoptimizerPrelude)
                         (_moduleOprelude)
                         (_moduleOtoplevel)
                         (_moduleOverbosity))
            ( _declarationsIabstractTypes_collect
             ,_declarationsIbimapImps_collect
             ,_declarationsIconstructors_collect
             ,_declarationsIdepConstraints_collect
             ,_declarationsIfunImps_collect
             ,_declarationsIgenericAbstractions_collect
             ,_declarationsIkinames
             ,_declarationsIkindIndexedTypes_collect
             ,_declarationsIkind_errors
             ,_declarationsIkindvar
             ,_declarationsIksubst
             ,_declarationsIlabels_collect
             ,_declarationsImethods_collect
             ,_declarationsIoutput
             ,_declarationsIpresignatures_collect
             ,_declarationsIrawRequests_collect
             ,_declarationsIself
             ,_declarationsIstaticErrors
             ,_declarationsIstructureTypes_collect
             ,_declarationsItypeImps_collect
             ) =
                (declarations_ (_declarationsOabstractTypes_collect)
                               (_declarationsObimapImps_collect)
                               (_declarationsOclassname)
                               (_declarationsOconstructors_collect)
                               (_declarationsOconstructors_dist)
                               (_declarationsOcurrentModule)
                               (_declarationsOdependencies)
                               (_declarationsOexportedStructures)
                               (_declarationsOexportedTypes)
                               (_declarationsOexportedValues)
                               (_declarationsOfunImps_collect)
                               (_declarationsOgenericAbstractions)
                               (_declarationsOgenericAbstractions_collect)
                               (_declarationsOghc)
                               (_declarationsOimportedModule)
                               (_declarationsOinstancename)
                               (_declarationsOkinames)
                               (_declarationsOkindIndexedTypes)
                               (_declarationsOkindIndexedTypes_collect)
                               (_declarationsOkinds)
                               (_declarationsOkindvar)
                               (_declarationsOksubst)
                               (_declarationsOlabels_collect)
                               (_declarationsOlabels_dist)
                               (_declarationsOlocal)
                               (_declarationsOmethods_collect)
                               (_declarationsOmethods_dist)
                               (_declarationsOmodules)
                               (_declarationsOoptimizer)
                               (_declarationsOoptimizerPrelude)
                               (_declarationsOoutput)
                               (_declarationsOprekind)
                               (_declarationsOprelude)
                               (_declarationsOpresignatures)
                               (_declarationsOpresignatures_collect)
                               (_declarationsOrawRequests_collect)
                               (_declarationsOsignatures)
                               (_declarationsOstructureTypes_collect)
                               (_declarationsOtoplevel)
                               (_declarationsOtypeImps_collect)
                               (_declarationsOverbosity))
            -- "./ModuleInformation.inc.lag"(line 134, column 8)
            (_currentModule@_) =
                getModuleName _moduleIself
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _declarationsIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _declarationsIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _declarationsIstaticErrors
            -- self rule
            (_self@_) =
                InterfaceDeclaration_SetModule _rangeIself _moduleIself _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _declarationsIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _declarationsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _declarationsIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _declarationsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _declarationsIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _declarationsIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _declarationsIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _declarationsIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _declarationsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _declarationsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _declarationsImethods_collect
            -- copy rule (up)
            (_lhsOoutput@_) =
                _declarationsIoutput
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _declarationsIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _declarationsIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _declarationsIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _declarationsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_rangeOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_moduleOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_moduleOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_moduleOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_moduleOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_moduleOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_moduleOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_moduleOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_moduleOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_moduleOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_moduleOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_moduleOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_moduleOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_moduleOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_moduleOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_moduleOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_moduleOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_moduleOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_moduleOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_moduleOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_moduleOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_declarationsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_declarationsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_declarationsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_declarationsOconstructors_collect@_) =
                _moduleIconstructors_collect
            -- copy rule (down)
            (_declarationsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_declarationsOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_declarationsOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_declarationsOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_declarationsOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_declarationsOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_declarationsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_declarationsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_declarationsOgenericAbstractions_collect@_) =
                _moduleIgenericAbstractions_collect
            -- copy rule (down)
            (_declarationsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_declarationsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_declarationsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_declarationsOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_declarationsOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_declarationsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_declarationsOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_declarationsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_declarationsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_declarationsOlabels_collect@_) =
                _moduleIlabels_collect
            -- copy rule (down)
            (_declarationsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_declarationsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_declarationsOmethods_collect@_) =
                _moduleImethods_collect
            -- copy rule (down)
            (_declarationsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_declarationsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_declarationsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_declarationsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_declarationsOoutput@_) =
                _lhsIoutput
            -- copy rule (down)
            (_declarationsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_declarationsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_declarationsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_declarationsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_declarationsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_declarationsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_declarationsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_declarationsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_declarationsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_declarationsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOoutput,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
-- InterfaceDeclarations ---------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      exportedStructures   : Set Name
      exportedTypes        : Set Name
      exportedValues       : Set Name
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      output               : [PP.Doc]
      presignatures_collect : PreSignatures
      rawRequests_collect  : [RawRequest]
      structureTypes_collect : FMap Name LambdaType
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      kind_errors          : [GHError]
      self                 : SELF
      staticErrors         : [GHError]

-}
{-
   local variables for InterfaceDeclarations.Cons:
      self

-}
{-
   local variables for InterfaceDeclarations.Nil:
      self

-}
-- semantic domain
type T_InterfaceDeclarations = (Set Name) ->
                               ([Request_BimapImply]) ->
                               (Maybe Name) ->
                               (FMap Name Names) ->
                               (FMap Name Names) ->
                               (Strings) ->
                               (FMap Name [(Name,Name)]) ->
                               (Set Name) ->
                               (Set Name) ->
                               (Set Name) ->
                               ([Request_FunImply]) ->
                               (FMap Name Kind) ->
                               (FMap Name Kind) ->
                               (Bool) ->
                               (Bool) ->
                               (Maybe Name) ->
                               (KSubst) ->
                               (FMap Name KindIndexedType) ->
                               (FMap Name KindIndexedType) ->
                               (KSubst) ->
                               (Int) ->
                               (KSubst) ->
                               (FMap Name Names) ->
                               (FMap Name Names) ->
                               (Bool) ->
                               (FMap Name Names) ->
                               (FMap Name Names) ->
                               (Set Strings) ->
                               (Bool) ->
                               (Declarations) ->
                               ([PP.Doc]) ->
                               (KSubst) ->
                               (Bool) ->
                               (PreSignatures) ->
                               (PreSignatures) ->
                               ([RawRequest]) ->
                               (Signatures) ->
                               (FMap Name LambdaType) ->
                               (Bool) ->
                               ([Request_TypeImply]) ->
                               (Int) ->
                               ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),([PP.Doc]),(PreSignatures),([RawRequest]),(InterfaceDeclarations),([GHError]),(FMap Name LambdaType),([Request_TypeImply]))
-- cata
sem_InterfaceDeclarations :: (InterfaceDeclarations) ->
                             (T_InterfaceDeclarations)
sem_InterfaceDeclarations (list) =
    (foldr (sem_InterfaceDeclarations_Cons) (sem_InterfaceDeclarations_Nil) ((map sem_InterfaceDeclaration list)))
sem_InterfaceDeclarations_Cons :: (T_InterfaceDeclaration) ->
                                  (T_InterfaceDeclarations) ->
                                  (T_InterfaceDeclarations)
sem_InterfaceDeclarations_Cons (hd_) (tl_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIoutput
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (InterfaceDeclarations)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _hdIabstractTypes_collect :: (Set Name)
            _hdIbimapImps_collect :: ([Request_BimapImply])
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdepConstraints_collect :: ([DepConstraint])
            _hdIfunImps_collect :: ([Request_FunImply])
            _hdIgenericAbstractions_collect :: (FMap Name Kind)
            _hdIkinames :: (KSubst)
            _hdIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _hdIkind_errors :: ([GHError])
            _hdIkindvar :: (Int)
            _hdIksubst :: (KSubst)
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIoutput :: ([PP.Doc])
            _hdIpresignatures_collect :: (PreSignatures)
            _hdIrawRequests_collect :: ([RawRequest])
            _hdIself :: (InterfaceDeclaration)
            _hdIstaticErrors :: ([GHError])
            _hdIstructureTypes_collect :: (FMap Name LambdaType)
            _hdItypeImps_collect :: ([Request_TypeImply])
            _hdOabstractTypes_collect :: (Set Name)
            _hdObimapImps_collect :: ([Request_BimapImply])
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies :: (FMap Name [(Name,Name)])
            _hdOexportedStructures :: (Set Name)
            _hdOexportedTypes :: (Set Name)
            _hdOexportedValues :: (Set Name)
            _hdOfunImps_collect :: ([Request_FunImply])
            _hdOgenericAbstractions :: (FMap Name Kind)
            _hdOgenericAbstractions_collect :: (FMap Name Kind)
            _hdOghc :: (Bool)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOkinames :: (KSubst)
            _hdOkindIndexedTypes :: (FMap Name KindIndexedType)
            _hdOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _hdOkinds :: (KSubst)
            _hdOkindvar :: (Int)
            _hdOksubst :: (KSubst)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmodules :: (Set Strings)
            _hdOoptimizer :: (Bool)
            _hdOoptimizerPrelude :: (Declarations)
            _hdOoutput :: ([PP.Doc])
            _hdOprekind :: (KSubst)
            _hdOprelude :: (Bool)
            _hdOpresignatures :: (PreSignatures)
            _hdOpresignatures_collect :: (PreSignatures)
            _hdOrawRequests_collect :: ([RawRequest])
            _hdOsignatures :: (Signatures)
            _hdOstructureTypes_collect :: (FMap Name LambdaType)
            _hdOtoplevel :: (Bool)
            _hdOtypeImps_collect :: ([Request_TypeImply])
            _hdOverbosity :: (Int)
            _tlIabstractTypes_collect :: (Set Name)
            _tlIbimapImps_collect :: ([Request_BimapImply])
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdepConstraints_collect :: ([DepConstraint])
            _tlIfunImps_collect :: ([Request_FunImply])
            _tlIgenericAbstractions_collect :: (FMap Name Kind)
            _tlIkinames :: (KSubst)
            _tlIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _tlIkind_errors :: ([GHError])
            _tlIkindvar :: (Int)
            _tlIksubst :: (KSubst)
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIoutput :: ([PP.Doc])
            _tlIpresignatures_collect :: (PreSignatures)
            _tlIrawRequests_collect :: ([RawRequest])
            _tlIself :: (InterfaceDeclarations)
            _tlIstaticErrors :: ([GHError])
            _tlIstructureTypes_collect :: (FMap Name LambdaType)
            _tlItypeImps_collect :: ([Request_TypeImply])
            _tlOabstractTypes_collect :: (Set Name)
            _tlObimapImps_collect :: ([Request_BimapImply])
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies :: (FMap Name [(Name,Name)])
            _tlOexportedStructures :: (Set Name)
            _tlOexportedTypes :: (Set Name)
            _tlOexportedValues :: (Set Name)
            _tlOfunImps_collect :: ([Request_FunImply])
            _tlOgenericAbstractions :: (FMap Name Kind)
            _tlOgenericAbstractions_collect :: (FMap Name Kind)
            _tlOghc :: (Bool)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOkinames :: (KSubst)
            _tlOkindIndexedTypes :: (FMap Name KindIndexedType)
            _tlOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _tlOkinds :: (KSubst)
            _tlOkindvar :: (Int)
            _tlOksubst :: (KSubst)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmodules :: (Set Strings)
            _tlOoptimizer :: (Bool)
            _tlOoptimizerPrelude :: (Declarations)
            _tlOoutput :: ([PP.Doc])
            _tlOprekind :: (KSubst)
            _tlOprelude :: (Bool)
            _tlOpresignatures :: (PreSignatures)
            _tlOpresignatures_collect :: (PreSignatures)
            _tlOrawRequests_collect :: ([RawRequest])
            _tlOsignatures :: (Signatures)
            _tlOstructureTypes_collect :: (FMap Name LambdaType)
            _tlOtoplevel :: (Bool)
            _tlOtypeImps_collect :: ([Request_TypeImply])
            _tlOverbosity :: (Int)
            ( _hdIabstractTypes_collect,_hdIbimapImps_collect,_hdIconstructors_collect,_hdIdepConstraints_collect,_hdIfunImps_collect,_hdIgenericAbstractions_collect,_hdIkinames,_hdIkindIndexedTypes_collect,_hdIkind_errors,_hdIkindvar,_hdIksubst,_hdIlabels_collect,_hdImethods_collect,_hdIoutput,_hdIpresignatures_collect,_hdIrawRequests_collect,_hdIself,_hdIstaticErrors,_hdIstructureTypes_collect,_hdItypeImps_collect) =
                (hd_ (_hdOabstractTypes_collect)
                     (_hdObimapImps_collect)
                     (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOdependencies)
                     (_hdOexportedStructures)
                     (_hdOexportedTypes)
                     (_hdOexportedValues)
                     (_hdOfunImps_collect)
                     (_hdOgenericAbstractions)
                     (_hdOgenericAbstractions_collect)
                     (_hdOghc)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOkinames)
                     (_hdOkindIndexedTypes)
                     (_hdOkindIndexedTypes_collect)
                     (_hdOkinds)
                     (_hdOkindvar)
                     (_hdOksubst)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmodules)
                     (_hdOoptimizer)
                     (_hdOoptimizerPrelude)
                     (_hdOoutput)
                     (_hdOprekind)
                     (_hdOprelude)
                     (_hdOpresignatures)
                     (_hdOpresignatures_collect)
                     (_hdOrawRequests_collect)
                     (_hdOsignatures)
                     (_hdOstructureTypes_collect)
                     (_hdOtoplevel)
                     (_hdOtypeImps_collect)
                     (_hdOverbosity))
            ( _tlIabstractTypes_collect,_tlIbimapImps_collect,_tlIconstructors_collect,_tlIdepConstraints_collect,_tlIfunImps_collect,_tlIgenericAbstractions_collect,_tlIkinames,_tlIkindIndexedTypes_collect,_tlIkind_errors,_tlIkindvar,_tlIksubst,_tlIlabels_collect,_tlImethods_collect,_tlIoutput,_tlIpresignatures_collect,_tlIrawRequests_collect,_tlIself,_tlIstaticErrors,_tlIstructureTypes_collect,_tlItypeImps_collect) =
                (tl_ (_tlOabstractTypes_collect)
                     (_tlObimapImps_collect)
                     (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOdependencies)
                     (_tlOexportedStructures)
                     (_tlOexportedTypes)
                     (_tlOexportedValues)
                     (_tlOfunImps_collect)
                     (_tlOgenericAbstractions)
                     (_tlOgenericAbstractions_collect)
                     (_tlOghc)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOkinames)
                     (_tlOkindIndexedTypes)
                     (_tlOkindIndexedTypes_collect)
                     (_tlOkinds)
                     (_tlOkindvar)
                     (_tlOksubst)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmodules)
                     (_tlOoptimizer)
                     (_tlOoptimizerPrelude)
                     (_tlOoutput)
                     (_tlOprekind)
                     (_tlOprelude)
                     (_tlOpresignatures)
                     (_tlOpresignatures_collect)
                     (_tlOrawRequests_collect)
                     (_tlOsignatures)
                     (_tlOstructureTypes_collect)
                     (_tlOtoplevel)
                     (_tlOtypeImps_collect)
                     (_tlOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _hdIdepConstraints_collect ++ _tlIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _hdIkind_errors ++ _tlIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _hdIstaticErrors ++ _tlIstaticErrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _tlIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _tlIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _tlIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _tlIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _tlIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _tlIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _tlIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _tlIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOoutput@_) =
                _tlIoutput
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _tlIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _tlIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _tlIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _tlItypeImps_collect
            -- copy rule (down)
            (_hdOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_hdObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_hdOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_hdOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_hdOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_hdOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_hdOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_hdOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_hdOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_hdOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_hdOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_hdOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_hdOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_hdOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_hdOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_hdOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_hdOoutput@_) =
                _lhsIoutput
            -- copy rule (down)
            (_hdOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_hdOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_hdOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_hdOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_hdOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_hdOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_hdOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_hdOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_hdOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_tlOabstractTypes_collect@_) =
                _hdIabstractTypes_collect
            -- copy rule (chain)
            (_tlObimapImps_collect@_) =
                _hdIbimapImps_collect
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_tlOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_tlOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_tlOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (chain)
            (_tlOfunImps_collect@_) =
                _hdIfunImps_collect
            -- copy rule (down)
            (_tlOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_tlOgenericAbstractions_collect@_) =
                _hdIgenericAbstractions_collect
            -- copy rule (down)
            (_tlOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOkinames@_) =
                _hdIkinames
            -- copy rule (down)
            (_tlOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (chain)
            (_tlOkindIndexedTypes_collect@_) =
                _hdIkindIndexedTypes_collect
            -- copy rule (down)
            (_tlOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_tlOkindvar@_) =
                _hdIkindvar
            -- copy rule (chain)
            (_tlOksubst@_) =
                _hdIksubst
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_tlOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_tlOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (chain)
            (_tlOoutput@_) =
                _hdIoutput
            -- copy rule (down)
            (_tlOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_tlOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_tlOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_tlOpresignatures_collect@_) =
                _hdIpresignatures_collect
            -- copy rule (chain)
            (_tlOrawRequests_collect@_) =
                _hdIrawRequests_collect
            -- copy rule (down)
            (_tlOsignatures@_) =
                _lhsIsignatures
            -- copy rule (chain)
            (_tlOstructureTypes_collect@_) =
                _hdIstructureTypes_collect
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_tlOtypeImps_collect@_) =
                _hdItypeImps_collect
            -- copy rule (down)
            (_tlOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOoutput,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_InterfaceDeclarations_Nil :: (T_InterfaceDeclarations)
sem_InterfaceDeclarations_Nil  =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIoutput
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (InterfaceDeclarations)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOoutput@_) =
                _lhsIoutput
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOoutput,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
-- Kind --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      kind_errors          : [GHError]
      self                 : SELF

-}
{-
   local variables for Kind.Arrow:
      self

-}
{-
   local variables for Kind.Error:
      self

-}
{-
   local variables for Kind.Parenthesized:
      self

-}
{-
   local variables for Kind.Star:
      self

-}
{-
   local variables for Kind.Variable:
      self

-}
-- semantic domain
type T_Kind = (Maybe Name) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (Strings) ->
              (FMap Name Kind) ->
              (FMap Name Kind) ->
              (Bool) ->
              (Bool) ->
              (Maybe Name) ->
              (KSubst) ->
              (KSubst) ->
              (Int) ->
              (KSubst) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (Bool) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (Set Strings) ->
              (Bool) ->
              (Declarations) ->
              (KSubst) ->
              (Bool) ->
              (Bool) ->
              (Int) ->
              ( (FMap Name Names),(FMap Name Kind),(KSubst),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(Kind))
-- cata
sem_Kind :: (Kind) ->
            (T_Kind)
sem_Kind ((Kind_Arrow (_range) (_leftKind) (_rightKind))) =
    (sem_Kind_Arrow ((sem_Range (_range))) ((sem_Kind (_leftKind))) ((sem_Kind (_rightKind))))
sem_Kind ((Kind_Error )) =
    (sem_Kind_Error )
sem_Kind ((Kind_Parenthesized (_range) (_kind))) =
    (sem_Kind_Parenthesized ((sem_Range (_range))) ((sem_Kind (_kind))))
sem_Kind ((Kind_Star (_range))) =
    (sem_Kind_Star ((sem_Range (_range))))
sem_Kind ((Kind_Variable (_range) (_name))) =
    (sem_Kind_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Kind_Arrow :: (T_Range) ->
                  (T_Kind) ->
                  (T_Kind) ->
                  (T_Kind)
sem_Kind_Arrow (range_) (leftKind_) (rightKind_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Kind)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _leftKindIconstructors_collect :: (FMap Name Names)
            _leftKindIgenericAbstractions_collect :: (FMap Name Kind)
            _leftKindIkinames :: (KSubst)
            _leftKindIkind_errors :: ([GHError])
            _leftKindIkindvar :: (Int)
            _leftKindIksubst :: (KSubst)
            _leftKindIlabels_collect :: (FMap Name Names)
            _leftKindImethods_collect :: (FMap Name Names)
            _leftKindIself :: (Kind)
            _leftKindOclassname :: (Maybe Name)
            _leftKindOconstructors_collect :: (FMap Name Names)
            _leftKindOconstructors_dist :: (FMap Name Names)
            _leftKindOcurrentModule :: (Strings)
            _leftKindOgenericAbstractions :: (FMap Name Kind)
            _leftKindOgenericAbstractions_collect :: (FMap Name Kind)
            _leftKindOghc :: (Bool)
            _leftKindOimportedModule :: (Bool)
            _leftKindOinstancename :: (Maybe Name)
            _leftKindOkinames :: (KSubst)
            _leftKindOkinds :: (KSubst)
            _leftKindOkindvar :: (Int)
            _leftKindOksubst :: (KSubst)
            _leftKindOlabels_collect :: (FMap Name Names)
            _leftKindOlabels_dist :: (FMap Name Names)
            _leftKindOlocal :: (Bool)
            _leftKindOmethods_collect :: (FMap Name Names)
            _leftKindOmethods_dist :: (FMap Name Names)
            _leftKindOmodules :: (Set Strings)
            _leftKindOoptimizer :: (Bool)
            _leftKindOoptimizerPrelude :: (Declarations)
            _leftKindOprekind :: (KSubst)
            _leftKindOprelude :: (Bool)
            _leftKindOtoplevel :: (Bool)
            _leftKindOverbosity :: (Int)
            _rightKindIconstructors_collect :: (FMap Name Names)
            _rightKindIgenericAbstractions_collect :: (FMap Name Kind)
            _rightKindIkinames :: (KSubst)
            _rightKindIkind_errors :: ([GHError])
            _rightKindIkindvar :: (Int)
            _rightKindIksubst :: (KSubst)
            _rightKindIlabels_collect :: (FMap Name Names)
            _rightKindImethods_collect :: (FMap Name Names)
            _rightKindIself :: (Kind)
            _rightKindOclassname :: (Maybe Name)
            _rightKindOconstructors_collect :: (FMap Name Names)
            _rightKindOconstructors_dist :: (FMap Name Names)
            _rightKindOcurrentModule :: (Strings)
            _rightKindOgenericAbstractions :: (FMap Name Kind)
            _rightKindOgenericAbstractions_collect :: (FMap Name Kind)
            _rightKindOghc :: (Bool)
            _rightKindOimportedModule :: (Bool)
            _rightKindOinstancename :: (Maybe Name)
            _rightKindOkinames :: (KSubst)
            _rightKindOkinds :: (KSubst)
            _rightKindOkindvar :: (Int)
            _rightKindOksubst :: (KSubst)
            _rightKindOlabels_collect :: (FMap Name Names)
            _rightKindOlabels_dist :: (FMap Name Names)
            _rightKindOlocal :: (Bool)
            _rightKindOmethods_collect :: (FMap Name Names)
            _rightKindOmethods_dist :: (FMap Name Names)
            _rightKindOmodules :: (Set Strings)
            _rightKindOoptimizer :: (Bool)
            _rightKindOoptimizerPrelude :: (Declarations)
            _rightKindOprekind :: (KSubst)
            _rightKindOprelude :: (Bool)
            _rightKindOtoplevel :: (Bool)
            _rightKindOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _leftKindIconstructors_collect,_leftKindIgenericAbstractions_collect,_leftKindIkinames,_leftKindIkind_errors,_leftKindIkindvar,_leftKindIksubst,_leftKindIlabels_collect,_leftKindImethods_collect,_leftKindIself) =
                (leftKind_ (_leftKindOclassname)
                           (_leftKindOconstructors_collect)
                           (_leftKindOconstructors_dist)
                           (_leftKindOcurrentModule)
                           (_leftKindOgenericAbstractions)
                           (_leftKindOgenericAbstractions_collect)
                           (_leftKindOghc)
                           (_leftKindOimportedModule)
                           (_leftKindOinstancename)
                           (_leftKindOkinames)
                           (_leftKindOkinds)
                           (_leftKindOkindvar)
                           (_leftKindOksubst)
                           (_leftKindOlabels_collect)
                           (_leftKindOlabels_dist)
                           (_leftKindOlocal)
                           (_leftKindOmethods_collect)
                           (_leftKindOmethods_dist)
                           (_leftKindOmodules)
                           (_leftKindOoptimizer)
                           (_leftKindOoptimizerPrelude)
                           (_leftKindOprekind)
                           (_leftKindOprelude)
                           (_leftKindOtoplevel)
                           (_leftKindOverbosity))
            ( _rightKindIconstructors_collect,_rightKindIgenericAbstractions_collect,_rightKindIkinames,_rightKindIkind_errors,_rightKindIkindvar,_rightKindIksubst,_rightKindIlabels_collect,_rightKindImethods_collect,_rightKindIself) =
                (rightKind_ (_rightKindOclassname)
                            (_rightKindOconstructors_collect)
                            (_rightKindOconstructors_dist)
                            (_rightKindOcurrentModule)
                            (_rightKindOgenericAbstractions)
                            (_rightKindOgenericAbstractions_collect)
                            (_rightKindOghc)
                            (_rightKindOimportedModule)
                            (_rightKindOinstancename)
                            (_rightKindOkinames)
                            (_rightKindOkinds)
                            (_rightKindOkindvar)
                            (_rightKindOksubst)
                            (_rightKindOlabels_collect)
                            (_rightKindOlabels_dist)
                            (_rightKindOlocal)
                            (_rightKindOmethods_collect)
                            (_rightKindOmethods_dist)
                            (_rightKindOmodules)
                            (_rightKindOoptimizer)
                            (_rightKindOoptimizerPrelude)
                            (_rightKindOprekind)
                            (_rightKindOprelude)
                            (_rightKindOtoplevel)
                            (_rightKindOverbosity))
            -- use rule
            (_lhsOkind_errors@_) =
                _leftKindIkind_errors ++ _rightKindIkind_errors
            -- self rule
            (_self@_) =
                Kind_Arrow _rangeIself _leftKindIself _rightKindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _rightKindIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _rightKindIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _rightKindIkinames
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _rightKindIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _rightKindIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _rightKindIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _rightKindImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_leftKindOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_leftKindOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_leftKindOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_leftKindOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_leftKindOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_leftKindOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_leftKindOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_leftKindOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_leftKindOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_leftKindOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_leftKindOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_leftKindOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_leftKindOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_leftKindOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_leftKindOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_leftKindOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_leftKindOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_leftKindOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_leftKindOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_leftKindOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_leftKindOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_leftKindOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_leftKindOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_leftKindOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_leftKindOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_rightKindOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_rightKindOconstructors_collect@_) =
                _leftKindIconstructors_collect
            -- copy rule (down)
            (_rightKindOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_rightKindOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rightKindOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_rightKindOgenericAbstractions_collect@_) =
                _leftKindIgenericAbstractions_collect
            -- copy rule (down)
            (_rightKindOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_rightKindOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rightKindOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_rightKindOkinames@_) =
                _leftKindIkinames
            -- copy rule (down)
            (_rightKindOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_rightKindOkindvar@_) =
                _leftKindIkindvar
            -- copy rule (chain)
            (_rightKindOksubst@_) =
                _leftKindIksubst
            -- copy rule (chain)
            (_rightKindOlabels_collect@_) =
                _leftKindIlabels_collect
            -- copy rule (down)
            (_rightKindOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_rightKindOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_rightKindOmethods_collect@_) =
                _leftKindImethods_collect
            -- copy rule (down)
            (_rightKindOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_rightKindOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_rightKindOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_rightKindOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_rightKindOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_rightKindOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_rightKindOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_rightKindOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Kind_Error :: (T_Kind)
sem_Kind_Error  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Kind)
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- self rule
            (_self@_) =
                Kind_Error
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Kind_Parenthesized :: (T_Range) ->
                          (T_Kind) ->
                          (T_Kind)
sem_Kind_Parenthesized (range_) (kind_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Kind)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _kindIconstructors_collect :: (FMap Name Names)
            _kindIgenericAbstractions_collect :: (FMap Name Kind)
            _kindIkinames :: (KSubst)
            _kindIkind_errors :: ([GHError])
            _kindIkindvar :: (Int)
            _kindIksubst :: (KSubst)
            _kindIlabels_collect :: (FMap Name Names)
            _kindImethods_collect :: (FMap Name Names)
            _kindIself :: (Kind)
            _kindOclassname :: (Maybe Name)
            _kindOconstructors_collect :: (FMap Name Names)
            _kindOconstructors_dist :: (FMap Name Names)
            _kindOcurrentModule :: (Strings)
            _kindOgenericAbstractions :: (FMap Name Kind)
            _kindOgenericAbstractions_collect :: (FMap Name Kind)
            _kindOghc :: (Bool)
            _kindOimportedModule :: (Bool)
            _kindOinstancename :: (Maybe Name)
            _kindOkinames :: (KSubst)
            _kindOkinds :: (KSubst)
            _kindOkindvar :: (Int)
            _kindOksubst :: (KSubst)
            _kindOlabels_collect :: (FMap Name Names)
            _kindOlabels_dist :: (FMap Name Names)
            _kindOlocal :: (Bool)
            _kindOmethods_collect :: (FMap Name Names)
            _kindOmethods_dist :: (FMap Name Names)
            _kindOmodules :: (Set Strings)
            _kindOoptimizer :: (Bool)
            _kindOoptimizerPrelude :: (Declarations)
            _kindOprekind :: (KSubst)
            _kindOprelude :: (Bool)
            _kindOtoplevel :: (Bool)
            _kindOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _kindIconstructors_collect,_kindIgenericAbstractions_collect,_kindIkinames,_kindIkind_errors,_kindIkindvar,_kindIksubst,_kindIlabels_collect,_kindImethods_collect,_kindIself) =
                (kind_ (_kindOclassname)
                       (_kindOconstructors_collect)
                       (_kindOconstructors_dist)
                       (_kindOcurrentModule)
                       (_kindOgenericAbstractions)
                       (_kindOgenericAbstractions_collect)
                       (_kindOghc)
                       (_kindOimportedModule)
                       (_kindOinstancename)
                       (_kindOkinames)
                       (_kindOkinds)
                       (_kindOkindvar)
                       (_kindOksubst)
                       (_kindOlabels_collect)
                       (_kindOlabels_dist)
                       (_kindOlocal)
                       (_kindOmethods_collect)
                       (_kindOmethods_dist)
                       (_kindOmodules)
                       (_kindOoptimizer)
                       (_kindOoptimizerPrelude)
                       (_kindOprekind)
                       (_kindOprelude)
                       (_kindOtoplevel)
                       (_kindOverbosity))
            -- use rule
            (_lhsOkind_errors@_) =
                _kindIkind_errors
            -- self rule
            (_self@_) =
                Kind_Parenthesized _rangeIself _kindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _kindIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _kindIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _kindIkinames
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _kindIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _kindIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _kindIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _kindImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_kindOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_kindOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_kindOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_kindOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_kindOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_kindOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_kindOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_kindOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_kindOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_kindOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_kindOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_kindOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_kindOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_kindOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_kindOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_kindOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_kindOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_kindOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_kindOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_kindOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_kindOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_kindOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_kindOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_kindOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_kindOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Kind_Star :: (T_Range) ->
                 (T_Kind)
sem_Kind_Star (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Kind)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- self rule
            (_self@_) =
                Kind_Star _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Kind_Variable :: (T_Range) ->
                     (T_Name) ->
                     (T_Kind)
sem_Kind_Variable (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Kind)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- self rule
            (_self@_) =
                Kind_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- KindAnnotatedName -------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      akinds               : [MaybeKind]
      inferkind            : Kind
      kind_errors          : [GHError]
      mkinds               : [MaybeKind]
      self                 : SELF

-}
{-
   local variables for KindAnnotatedName.KindAnnotatedName:
      kinames
      self

-}
-- semantic domain
type T_KindAnnotatedName = (Maybe Name) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Strings) ->
                           (FMap Name Kind) ->
                           (FMap Name Kind) ->
                           (Bool) ->
                           (Bool) ->
                           (Maybe Name) ->
                           (KSubst) ->
                           (KSubst) ->
                           (Int) ->
                           (KSubst) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Bool) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Set Strings) ->
                           (Bool) ->
                           (Declarations) ->
                           (KSubst) ->
                           (Bool) ->
                           (Bool) ->
                           (Int) ->
                           ( ([MaybeKind]),(FMap Name Names),(FMap Name Kind),(Kind),(KSubst),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),([MaybeKind]),(KindAnnotatedName))
-- cata
sem_KindAnnotatedName :: (KindAnnotatedName) ->
                         (T_KindAnnotatedName)
sem_KindAnnotatedName ((KindAnnotatedName_KindAnnotatedName (_range) (_name) (_kind))) =
    (sem_KindAnnotatedName_KindAnnotatedName ((sem_Range (_range))) ((sem_Name (_name))) ((sem_MaybeKind (_kind))))
sem_KindAnnotatedName_KindAnnotatedName :: (T_Range) ->
                                           (T_Name) ->
                                           (T_MaybeKind) ->
                                           (T_KindAnnotatedName)
sem_KindAnnotatedName_KindAnnotatedName (range_) (name_) (kind_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOakinds :: ([MaybeKind])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOinferkind :: (Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmkinds :: ([MaybeKind])
            _lhsOself :: (KindAnnotatedName)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _kindIconstructors_collect :: (FMap Name Names)
            _kindIgenericAbstractions_collect :: (FMap Name Kind)
            _kindIinferkind :: (Kind)
            _kindIkinames :: (KSubst)
            _kindIkind_errors :: ([GHError])
            _kindIkindvar :: (Int)
            _kindIksubst :: (KSubst)
            _kindIlabels_collect :: (FMap Name Names)
            _kindImethods_collect :: (FMap Name Names)
            _kindIself :: (MaybeKind)
            _kindOclassname :: (Maybe Name)
            _kindOconstructors_collect :: (FMap Name Names)
            _kindOconstructors_dist :: (FMap Name Names)
            _kindOcurrentModule :: (Strings)
            _kindOgenericAbstractions :: (FMap Name Kind)
            _kindOgenericAbstractions_collect :: (FMap Name Kind)
            _kindOghc :: (Bool)
            _kindOimportedModule :: (Bool)
            _kindOinstancename :: (Maybe Name)
            _kindOkinames :: (KSubst)
            _kindOkinds :: (KSubst)
            _kindOkindvar :: (Int)
            _kindOksubst :: (KSubst)
            _kindOlabels_collect :: (FMap Name Names)
            _kindOlabels_dist :: (FMap Name Names)
            _kindOlocal :: (Bool)
            _kindOmethods_collect :: (FMap Name Names)
            _kindOmethods_dist :: (FMap Name Names)
            _kindOmodules :: (Set Strings)
            _kindOoptimizer :: (Bool)
            _kindOoptimizerPrelude :: (Declarations)
            _kindOprekind :: (KSubst)
            _kindOprelude :: (Bool)
            _kindOtoplevel :: (Bool)
            _kindOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _kindIconstructors_collect,_kindIgenericAbstractions_collect,_kindIinferkind,_kindIkinames,_kindIkind_errors,_kindIkindvar,_kindIksubst,_kindIlabels_collect,_kindImethods_collect,_kindIself) =
                (kind_ (_kindOclassname)
                       (_kindOconstructors_collect)
                       (_kindOconstructors_dist)
                       (_kindOcurrentModule)
                       (_kindOgenericAbstractions)
                       (_kindOgenericAbstractions_collect)
                       (_kindOghc)
                       (_kindOimportedModule)
                       (_kindOinstancename)
                       (_kindOkinames)
                       (_kindOkinds)
                       (_kindOkindvar)
                       (_kindOksubst)
                       (_kindOlabels_collect)
                       (_kindOlabels_dist)
                       (_kindOlocal)
                       (_kindOmethods_collect)
                       (_kindOmethods_dist)
                       (_kindOmodules)
                       (_kindOoptimizer)
                       (_kindOoptimizerPrelude)
                       (_kindOprekind)
                       (_kindOprelude)
                       (_kindOtoplevel)
                       (_kindOverbosity))
            -- "./ModuleInformation.inc.lag"(line 272, column 9)
            (_lhsOakinds@_) =
                [_kindIself]
            -- "./Kind.inc.lag"(line 332, column 9)
            (_kinames@_) =
                add _lhsIkinames (_nameIself,_kindIinferkind)
            -- "./GenericAbstraction.inc.lag"(line 44, column 9)
            (_lhsOmkinds@_) =
                [_kindIself]
            -- use rule
            (_lhsOkind_errors@_) =
                _kindIkind_errors
            -- self rule
            (_self@_) =
                KindAnnotatedName_KindAnnotatedName _rangeIself _nameIself _kindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _kindIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _kindIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOinferkind@_) =
                _kindIinferkind
            -- modified copy rule
            (_lhsOkinames@_) =
                _kindIkinames
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _kindIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _kindIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _kindIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _kindImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_kindOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_kindOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_kindOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_kindOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_kindOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_kindOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_kindOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_kindOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_kindOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_kindOkinames@_) =
                _kinames
            -- copy rule (down)
            (_kindOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_kindOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_kindOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_kindOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_kindOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_kindOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_kindOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_kindOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_kindOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_kindOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_kindOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_kindOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_kindOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_kindOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_kindOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOakinds,_lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOinferkind,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmkinds,_lhsOself)
-- KindAnnotatedNames ------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      akinds               : [MaybeKind]
      inferkind            : Kind
      kind_errors          : [GHError]
      mkinds               : [MaybeKind]
      self                 : SELF

-}
{-
   local variables for KindAnnotatedNames.Cons:
      self

-}
{-
   local variables for KindAnnotatedNames.Nil:
      self

-}
-- semantic domain
type T_KindAnnotatedNames = (Maybe Name) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Strings) ->
                            (FMap Name Kind) ->
                            (FMap Name Kind) ->
                            (Bool) ->
                            (Bool) ->
                            (Maybe Name) ->
                            (KSubst) ->
                            (KSubst) ->
                            (Int) ->
                            (KSubst) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Bool) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Set Strings) ->
                            (Bool) ->
                            (Declarations) ->
                            (KSubst) ->
                            (Bool) ->
                            (Bool) ->
                            (Int) ->
                            ( ([MaybeKind]),(FMap Name Names),(FMap Name Kind),(Kind),(KSubst),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),([MaybeKind]),(KindAnnotatedNames))
-- cata
sem_KindAnnotatedNames :: (KindAnnotatedNames) ->
                          (T_KindAnnotatedNames)
sem_KindAnnotatedNames (list) =
    (foldr (sem_KindAnnotatedNames_Cons) (sem_KindAnnotatedNames_Nil) ((map sem_KindAnnotatedName list)))
sem_KindAnnotatedNames_Cons :: (T_KindAnnotatedName) ->
                               (T_KindAnnotatedNames) ->
                               (T_KindAnnotatedNames)
sem_KindAnnotatedNames_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOakinds :: ([MaybeKind])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOinferkind :: (Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmkinds :: ([MaybeKind])
            _lhsOself :: (KindAnnotatedNames)
            _hdIakinds :: ([MaybeKind])
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIgenericAbstractions_collect :: (FMap Name Kind)
            _hdIinferkind :: (Kind)
            _hdIkinames :: (KSubst)
            _hdIkind_errors :: ([GHError])
            _hdIkindvar :: (Int)
            _hdIksubst :: (KSubst)
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdImkinds :: ([MaybeKind])
            _hdIself :: (KindAnnotatedName)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOgenericAbstractions :: (FMap Name Kind)
            _hdOgenericAbstractions_collect :: (FMap Name Kind)
            _hdOghc :: (Bool)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOkinames :: (KSubst)
            _hdOkinds :: (KSubst)
            _hdOkindvar :: (Int)
            _hdOksubst :: (KSubst)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmodules :: (Set Strings)
            _hdOoptimizer :: (Bool)
            _hdOoptimizerPrelude :: (Declarations)
            _hdOprekind :: (KSubst)
            _hdOprelude :: (Bool)
            _hdOtoplevel :: (Bool)
            _hdOverbosity :: (Int)
            _tlIakinds :: ([MaybeKind])
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIgenericAbstractions_collect :: (FMap Name Kind)
            _tlIinferkind :: (Kind)
            _tlIkinames :: (KSubst)
            _tlIkind_errors :: ([GHError])
            _tlIkindvar :: (Int)
            _tlIksubst :: (KSubst)
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlImkinds :: ([MaybeKind])
            _tlIself :: (KindAnnotatedNames)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOgenericAbstractions :: (FMap Name Kind)
            _tlOgenericAbstractions_collect :: (FMap Name Kind)
            _tlOghc :: (Bool)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOkinames :: (KSubst)
            _tlOkinds :: (KSubst)
            _tlOkindvar :: (Int)
            _tlOksubst :: (KSubst)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmodules :: (Set Strings)
            _tlOoptimizer :: (Bool)
            _tlOoptimizerPrelude :: (Declarations)
            _tlOprekind :: (KSubst)
            _tlOprelude :: (Bool)
            _tlOtoplevel :: (Bool)
            _tlOverbosity :: (Int)
            ( _hdIakinds,_hdIconstructors_collect,_hdIgenericAbstractions_collect,_hdIinferkind,_hdIkinames,_hdIkind_errors,_hdIkindvar,_hdIksubst,_hdIlabels_collect,_hdImethods_collect,_hdImkinds,_hdIself) =
                (hd_ (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOgenericAbstractions)
                     (_hdOgenericAbstractions_collect)
                     (_hdOghc)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOkinames)
                     (_hdOkinds)
                     (_hdOkindvar)
                     (_hdOksubst)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmodules)
                     (_hdOoptimizer)
                     (_hdOoptimizerPrelude)
                     (_hdOprekind)
                     (_hdOprelude)
                     (_hdOtoplevel)
                     (_hdOverbosity))
            ( _tlIakinds,_tlIconstructors_collect,_tlIgenericAbstractions_collect,_tlIinferkind,_tlIkinames,_tlIkind_errors,_tlIkindvar,_tlIksubst,_tlIlabels_collect,_tlImethods_collect,_tlImkinds,_tlIself) =
                (tl_ (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOgenericAbstractions)
                     (_tlOgenericAbstractions_collect)
                     (_tlOghc)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOkinames)
                     (_tlOkinds)
                     (_tlOkindvar)
                     (_tlOksubst)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmodules)
                     (_tlOoptimizer)
                     (_tlOoptimizerPrelude)
                     (_tlOprekind)
                     (_tlOprelude)
                     (_tlOtoplevel)
                     (_tlOverbosity))
            -- "./Kind.inc.lag"(line 328, column 9)
            (_lhsOinferkind@_) =
                arrK _hdIinferkind _tlIinferkind
            -- use rule
            (_lhsOakinds@_) =
                _hdIakinds ++ _tlIakinds
            -- use rule
            (_lhsOkind_errors@_) =
                _hdIkind_errors ++ _tlIkind_errors
            -- use rule
            (_lhsOmkinds@_) =
                _hdImkinds ++ _tlImkinds
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _tlIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _tlIkinames
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _tlIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _tlIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_hdOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_hdOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_hdOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_hdOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_hdOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_hdOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_hdOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_hdOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_hdOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_hdOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_tlOgenericAbstractions_collect@_) =
                _hdIgenericAbstractions_collect
            -- copy rule (down)
            (_tlOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOkinames@_) =
                _hdIkinames
            -- copy rule (down)
            (_tlOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_tlOkindvar@_) =
                _hdIkindvar
            -- copy rule (chain)
            (_tlOksubst@_) =
                _hdIksubst
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_tlOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_tlOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_tlOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_tlOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOakinds,_lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOinferkind,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmkinds,_lhsOself)
sem_KindAnnotatedNames_Nil :: (T_KindAnnotatedNames)
sem_KindAnnotatedNames_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOakinds :: ([MaybeKind])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOinferkind :: (Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmkinds :: ([MaybeKind])
            _lhsOself :: (KindAnnotatedNames)
            -- "./Kind.inc.lag"(line 326, column 9)
            (_lhsOinferkind@_) =
                starK
            -- use rule
            (_lhsOakinds@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOmkinds@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOakinds,_lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOinferkind,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmkinds,_lhsOself)
-- KindArgument ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      kind_errors          : [GHError]
      self                 : SELF

-}
{-
   local variables for KindArgument.Arrow:
      self

-}
{-
   local variables for KindArgument.Star:
      self

-}
-- semantic domain
type T_KindArgument = (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Strings) ->
                      (FMap Name Kind) ->
                      (FMap Name Kind) ->
                      (Bool) ->
                      (Bool) ->
                      (Maybe Name) ->
                      (KSubst) ->
                      (KSubst) ->
                      (Int) ->
                      (KSubst) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Set Strings) ->
                      (Bool) ->
                      (Declarations) ->
                      (KSubst) ->
                      (Bool) ->
                      (Bool) ->
                      (Int) ->
                      ( (FMap Name Names),(FMap Name Kind),(KSubst),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(KindArgument))
-- cata
sem_KindArgument :: (KindArgument) ->
                    (T_KindArgument)
sem_KindArgument ((KindArgument_Arrow (_range) (_leftkindvariable) (_rightkindvariable))) =
    (sem_KindArgument_Arrow ((sem_Range (_range))) ((sem_Name (_leftkindvariable))) ((sem_Name (_rightkindvariable))))
sem_KindArgument ((KindArgument_Star (_range))) =
    (sem_KindArgument_Star ((sem_Range (_range))))
sem_KindArgument_Arrow :: (T_Range) ->
                          (T_Name) ->
                          (T_Name) ->
                          (T_KindArgument)
sem_KindArgument_Arrow (range_) (leftkindvariable_) (rightkindvariable_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (KindArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _leftkindvariableIconstructors_collect :: (FMap Name Names)
            _leftkindvariableIgenericAbstractions_collect :: (FMap Name Kind)
            _leftkindvariableIlabels_collect :: (FMap Name Names)
            _leftkindvariableImethods_collect :: (FMap Name Names)
            _leftkindvariableIself :: (Name)
            _leftkindvariableOclassname :: (Maybe Name)
            _leftkindvariableOconstructors_collect :: (FMap Name Names)
            _leftkindvariableOconstructors_dist :: (FMap Name Names)
            _leftkindvariableOcurrentModule :: (Strings)
            _leftkindvariableOgenericAbstractions :: (FMap Name Kind)
            _leftkindvariableOgenericAbstractions_collect :: (FMap Name Kind)
            _leftkindvariableOghc :: (Bool)
            _leftkindvariableOimportedModule :: (Bool)
            _leftkindvariableOinstancename :: (Maybe Name)
            _leftkindvariableOlabels_collect :: (FMap Name Names)
            _leftkindvariableOlabels_dist :: (FMap Name Names)
            _leftkindvariableOlocal :: (Bool)
            _leftkindvariableOmethods_collect :: (FMap Name Names)
            _leftkindvariableOmethods_dist :: (FMap Name Names)
            _leftkindvariableOmodules :: (Set Strings)
            _leftkindvariableOoptimizer :: (Bool)
            _leftkindvariableOoptimizerPrelude :: (Declarations)
            _leftkindvariableOprelude :: (Bool)
            _leftkindvariableOtoplevel :: (Bool)
            _leftkindvariableOverbosity :: (Int)
            _rightkindvariableIconstructors_collect :: (FMap Name Names)
            _rightkindvariableIgenericAbstractions_collect :: (FMap Name Kind)
            _rightkindvariableIlabels_collect :: (FMap Name Names)
            _rightkindvariableImethods_collect :: (FMap Name Names)
            _rightkindvariableIself :: (Name)
            _rightkindvariableOclassname :: (Maybe Name)
            _rightkindvariableOconstructors_collect :: (FMap Name Names)
            _rightkindvariableOconstructors_dist :: (FMap Name Names)
            _rightkindvariableOcurrentModule :: (Strings)
            _rightkindvariableOgenericAbstractions :: (FMap Name Kind)
            _rightkindvariableOgenericAbstractions_collect :: (FMap Name Kind)
            _rightkindvariableOghc :: (Bool)
            _rightkindvariableOimportedModule :: (Bool)
            _rightkindvariableOinstancename :: (Maybe Name)
            _rightkindvariableOlabels_collect :: (FMap Name Names)
            _rightkindvariableOlabels_dist :: (FMap Name Names)
            _rightkindvariableOlocal :: (Bool)
            _rightkindvariableOmethods_collect :: (FMap Name Names)
            _rightkindvariableOmethods_dist :: (FMap Name Names)
            _rightkindvariableOmodules :: (Set Strings)
            _rightkindvariableOoptimizer :: (Bool)
            _rightkindvariableOoptimizerPrelude :: (Declarations)
            _rightkindvariableOprelude :: (Bool)
            _rightkindvariableOtoplevel :: (Bool)
            _rightkindvariableOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _leftkindvariableIconstructors_collect,_leftkindvariableIgenericAbstractions_collect,_leftkindvariableIlabels_collect,_leftkindvariableImethods_collect,_leftkindvariableIself) =
                (leftkindvariable_ (_leftkindvariableOclassname)
                                   (_leftkindvariableOconstructors_collect)
                                   (_leftkindvariableOconstructors_dist)
                                   (_leftkindvariableOcurrentModule)
                                   (_leftkindvariableOgenericAbstractions)
                                   (_leftkindvariableOgenericAbstractions_collect)
                                   (_leftkindvariableOghc)
                                   (_leftkindvariableOimportedModule)
                                   (_leftkindvariableOinstancename)
                                   (_leftkindvariableOlabels_collect)
                                   (_leftkindvariableOlabels_dist)
                                   (_leftkindvariableOlocal)
                                   (_leftkindvariableOmethods_collect)
                                   (_leftkindvariableOmethods_dist)
                                   (_leftkindvariableOmodules)
                                   (_leftkindvariableOoptimizer)
                                   (_leftkindvariableOoptimizerPrelude)
                                   (_leftkindvariableOprelude)
                                   (_leftkindvariableOtoplevel)
                                   (_leftkindvariableOverbosity))
            ( _rightkindvariableIconstructors_collect,_rightkindvariableIgenericAbstractions_collect,_rightkindvariableIlabels_collect,_rightkindvariableImethods_collect,_rightkindvariableIself) =
                (rightkindvariable_ (_rightkindvariableOclassname)
                                    (_rightkindvariableOconstructors_collect)
                                    (_rightkindvariableOconstructors_dist)
                                    (_rightkindvariableOcurrentModule)
                                    (_rightkindvariableOgenericAbstractions)
                                    (_rightkindvariableOgenericAbstractions_collect)
                                    (_rightkindvariableOghc)
                                    (_rightkindvariableOimportedModule)
                                    (_rightkindvariableOinstancename)
                                    (_rightkindvariableOlabels_collect)
                                    (_rightkindvariableOlabels_dist)
                                    (_rightkindvariableOlocal)
                                    (_rightkindvariableOmethods_collect)
                                    (_rightkindvariableOmethods_dist)
                                    (_rightkindvariableOmodules)
                                    (_rightkindvariableOoptimizer)
                                    (_rightkindvariableOoptimizerPrelude)
                                    (_rightkindvariableOprelude)
                                    (_rightkindvariableOtoplevel)
                                    (_rightkindvariableOverbosity))
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- self rule
            (_self@_) =
                KindArgument_Arrow _rangeIself _leftkindvariableIself _rightkindvariableIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _rightkindvariableIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _rightkindvariableIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _rightkindvariableIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _rightkindvariableImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_leftkindvariableOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_leftkindvariableOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_leftkindvariableOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_leftkindvariableOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_leftkindvariableOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_leftkindvariableOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_leftkindvariableOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_leftkindvariableOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_leftkindvariableOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_leftkindvariableOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_leftkindvariableOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_leftkindvariableOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_leftkindvariableOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_leftkindvariableOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_leftkindvariableOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_leftkindvariableOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_leftkindvariableOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_leftkindvariableOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_leftkindvariableOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_leftkindvariableOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_rightkindvariableOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_rightkindvariableOconstructors_collect@_) =
                _leftkindvariableIconstructors_collect
            -- copy rule (down)
            (_rightkindvariableOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_rightkindvariableOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rightkindvariableOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_rightkindvariableOgenericAbstractions_collect@_) =
                _leftkindvariableIgenericAbstractions_collect
            -- copy rule (down)
            (_rightkindvariableOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_rightkindvariableOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rightkindvariableOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_rightkindvariableOlabels_collect@_) =
                _leftkindvariableIlabels_collect
            -- copy rule (down)
            (_rightkindvariableOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_rightkindvariableOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_rightkindvariableOmethods_collect@_) =
                _leftkindvariableImethods_collect
            -- copy rule (down)
            (_rightkindvariableOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_rightkindvariableOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_rightkindvariableOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_rightkindvariableOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_rightkindvariableOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_rightkindvariableOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_rightkindvariableOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_KindArgument_Star :: (T_Range) ->
                         (T_KindArgument)
sem_KindArgument_Star (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (KindArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- self rule
            (_self@_) =
                KindArgument_Star _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- KindIndexedBinding ------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      rawRequests_collect  : [RawRequest]
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      kindIndexedType      : Either LambdaType ((Name,Name),LambdaType)
      kind_errors          : [GHError]
      name                 : Name
      self                 : SELF
      staticErrors         : [GHError]

-}
{-
   local variables for KindIndexedBinding.KindIndexedBinding:
      normalizedType
      self

-}
-- semantic domain
type T_KindIndexedBinding = (Set Name) ->
                            ([Request_BimapImply]) ->
                            (Maybe Name) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Strings) ->
                            (FMap Name [(Name,Name)]) ->
                            ([Request_FunImply]) ->
                            (FMap Name Kind) ->
                            (FMap Name Kind) ->
                            (Bool) ->
                            (Bool) ->
                            (Maybe Name) ->
                            (KSubst) ->
                            (KSubst) ->
                            (Int) ->
                            (KSubst) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Bool) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Set Strings) ->
                            (Bool) ->
                            (Declarations) ->
                            (KSubst) ->
                            (Bool) ->
                            ([RawRequest]) ->
                            (Bool) ->
                            ([Request_TypeImply]) ->
                            (Int) ->
                            ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),(Either LambdaType ((Name,Name),LambdaType)),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(Name),([RawRequest]),(KindIndexedBinding),([GHError]),([Request_TypeImply]))
-- cata
sem_KindIndexedBinding :: (KindIndexedBinding) ->
                          (T_KindIndexedBinding)
sem_KindIndexedBinding ((KindIndexedBinding_KindIndexedBinding (_range) (_name) (_kindargument) (_typevariables) (_type))) =
    (sem_KindIndexedBinding_KindIndexedBinding ((sem_Range (_range))) ((sem_Name (_name))) ((sem_KindArgument (_kindargument))) ((sem_Names (_typevariables))) ((sem_Type (_type))))
sem_KindIndexedBinding_KindIndexedBinding :: (T_Range) ->
                                             (T_Name) ->
                                             (T_KindArgument) ->
                                             (T_Names) ->
                                             (T_Type) ->
                                             (T_KindIndexedBinding)
sem_KindIndexedBinding_KindIndexedBinding (range_) (name_) (kindargument_) (typevariables_) (type_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedType :: (Either LambdaType ((Name,Name),LambdaType))
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (KindIndexedBinding)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _kindargumentIconstructors_collect :: (FMap Name Names)
            _kindargumentIgenericAbstractions_collect :: (FMap Name Kind)
            _kindargumentIkinames :: (KSubst)
            _kindargumentIkind_errors :: ([GHError])
            _kindargumentIkindvar :: (Int)
            _kindargumentIksubst :: (KSubst)
            _kindargumentIlabels_collect :: (FMap Name Names)
            _kindargumentImethods_collect :: (FMap Name Names)
            _kindargumentIself :: (KindArgument)
            _kindargumentOclassname :: (Maybe Name)
            _kindargumentOconstructors_collect :: (FMap Name Names)
            _kindargumentOconstructors_dist :: (FMap Name Names)
            _kindargumentOcurrentModule :: (Strings)
            _kindargumentOgenericAbstractions :: (FMap Name Kind)
            _kindargumentOgenericAbstractions_collect :: (FMap Name Kind)
            _kindargumentOghc :: (Bool)
            _kindargumentOimportedModule :: (Bool)
            _kindargumentOinstancename :: (Maybe Name)
            _kindargumentOkinames :: (KSubst)
            _kindargumentOkinds :: (KSubst)
            _kindargumentOkindvar :: (Int)
            _kindargumentOksubst :: (KSubst)
            _kindargumentOlabels_collect :: (FMap Name Names)
            _kindargumentOlabels_dist :: (FMap Name Names)
            _kindargumentOlocal :: (Bool)
            _kindargumentOmethods_collect :: (FMap Name Names)
            _kindargumentOmethods_dist :: (FMap Name Names)
            _kindargumentOmodules :: (Set Strings)
            _kindargumentOoptimizer :: (Bool)
            _kindargumentOoptimizerPrelude :: (Declarations)
            _kindargumentOprekind :: (KSubst)
            _kindargumentOprelude :: (Bool)
            _kindargumentOtoplevel :: (Bool)
            _kindargumentOverbosity :: (Int)
            _typevariablesIconstructors_collect :: (FMap Name Names)
            _typevariablesIgenericAbstractions_collect :: (FMap Name Kind)
            _typevariablesIinferkind :: (Kind)
            _typevariablesIkinames :: (KSubst)
            _typevariablesIkind_errors :: ([GHError])
            _typevariablesIkindvar :: (Int)
            _typevariablesIksubst :: (KSubst)
            _typevariablesIlabels_collect :: (FMap Name Names)
            _typevariablesImethods_collect :: (FMap Name Names)
            _typevariablesIself :: (Names)
            _typevariablesOclassname :: (Maybe Name)
            _typevariablesOconstructors_collect :: (FMap Name Names)
            _typevariablesOconstructors_dist :: (FMap Name Names)
            _typevariablesOcurrentModule :: (Strings)
            _typevariablesOgenericAbstractions :: (FMap Name Kind)
            _typevariablesOgenericAbstractions_collect :: (FMap Name Kind)
            _typevariablesOghc :: (Bool)
            _typevariablesOimportedModule :: (Bool)
            _typevariablesOinstancename :: (Maybe Name)
            _typevariablesOkinames :: (KSubst)
            _typevariablesOkinds :: (KSubst)
            _typevariablesOkindvar :: (Int)
            _typevariablesOksubst :: (KSubst)
            _typevariablesOlabels_collect :: (FMap Name Names)
            _typevariablesOlabels_dist :: (FMap Name Names)
            _typevariablesOlocal :: (Bool)
            _typevariablesOmethods_collect :: (FMap Name Names)
            _typevariablesOmethods_dist :: (FMap Name Names)
            _typevariablesOmodules :: (Set Strings)
            _typevariablesOoptimizer :: (Bool)
            _typevariablesOoptimizerPrelude :: (Declarations)
            _typevariablesOprekind :: (KSubst)
            _typevariablesOprelude :: (Bool)
            _typevariablesOtoplevel :: (Bool)
            _typevariablesOverbosity :: (Int)
            _typeIabstractTypes_collect :: (Set Name)
            _typeIbimapImps_collect :: ([Request_BimapImply])
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIdepConstraints_collect :: ([DepConstraint])
            _typeIfunImps_collect :: ([Request_FunImply])
            _typeIgenericAbstractions_collect :: (FMap Name Kind)
            _typeIinferkind :: (Kind)
            _typeIkinames :: (KSubst)
            _typeIkind_errors :: ([GHError])
            _typeIkindvar :: (Int)
            _typeIksubst :: (KSubst)
            _typeIlabels_collect :: (FMap Name Names)
            _typeImethods_collect :: (FMap Name Names)
            _typeIrawRequests_collect :: ([RawRequest])
            _typeIself :: (Type)
            _typeIstaticErrors :: ([GHError])
            _typeItypeImps_collect :: ([Request_TypeImply])
            _typeOabstractTypes_collect :: (Set Name)
            _typeObimapImps_collect :: ([Request_BimapImply])
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOdependencies :: (FMap Name [(Name,Name)])
            _typeOfunImps_collect :: ([Request_FunImply])
            _typeOgenericAbstractions :: (FMap Name Kind)
            _typeOgenericAbstractions_collect :: (FMap Name Kind)
            _typeOghc :: (Bool)
            _typeOimportedModule :: (Bool)
            _typeOinstancename :: (Maybe Name)
            _typeOkinames :: (KSubst)
            _typeOkinds :: (KSubst)
            _typeOkindvar :: (Int)
            _typeOksubst :: (KSubst)
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOmodules :: (Set Strings)
            _typeOoptimizer :: (Bool)
            _typeOoptimizerPrelude :: (Declarations)
            _typeOprekind :: (KSubst)
            _typeOprelude :: (Bool)
            _typeOrawRequests_collect :: ([RawRequest])
            _typeOtoplevel :: (Bool)
            _typeOtypeImps_collect :: ([Request_TypeImply])
            _typeOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _kindargumentIconstructors_collect,_kindargumentIgenericAbstractions_collect,_kindargumentIkinames,_kindargumentIkind_errors,_kindargumentIkindvar,_kindargumentIksubst,_kindargumentIlabels_collect,_kindargumentImethods_collect,_kindargumentIself) =
                (kindargument_ (_kindargumentOclassname)
                               (_kindargumentOconstructors_collect)
                               (_kindargumentOconstructors_dist)
                               (_kindargumentOcurrentModule)
                               (_kindargumentOgenericAbstractions)
                               (_kindargumentOgenericAbstractions_collect)
                               (_kindargumentOghc)
                               (_kindargumentOimportedModule)
                               (_kindargumentOinstancename)
                               (_kindargumentOkinames)
                               (_kindargumentOkinds)
                               (_kindargumentOkindvar)
                               (_kindargumentOksubst)
                               (_kindargumentOlabels_collect)
                               (_kindargumentOlabels_dist)
                               (_kindargumentOlocal)
                               (_kindargumentOmethods_collect)
                               (_kindargumentOmethods_dist)
                               (_kindargumentOmodules)
                               (_kindargumentOoptimizer)
                               (_kindargumentOoptimizerPrelude)
                               (_kindargumentOprekind)
                               (_kindargumentOprelude)
                               (_kindargumentOtoplevel)
                               (_kindargumentOverbosity))
            ( _typevariablesIconstructors_collect,_typevariablesIgenericAbstractions_collect,_typevariablesIinferkind,_typevariablesIkinames,_typevariablesIkind_errors,_typevariablesIkindvar,_typevariablesIksubst,_typevariablesIlabels_collect,_typevariablesImethods_collect,_typevariablesIself) =
                (typevariables_ (_typevariablesOclassname)
                                (_typevariablesOconstructors_collect)
                                (_typevariablesOconstructors_dist)
                                (_typevariablesOcurrentModule)
                                (_typevariablesOgenericAbstractions)
                                (_typevariablesOgenericAbstractions_collect)
                                (_typevariablesOghc)
                                (_typevariablesOimportedModule)
                                (_typevariablesOinstancename)
                                (_typevariablesOkinames)
                                (_typevariablesOkinds)
                                (_typevariablesOkindvar)
                                (_typevariablesOksubst)
                                (_typevariablesOlabels_collect)
                                (_typevariablesOlabels_dist)
                                (_typevariablesOlocal)
                                (_typevariablesOmethods_collect)
                                (_typevariablesOmethods_dist)
                                (_typevariablesOmodules)
                                (_typevariablesOoptimizer)
                                (_typevariablesOoptimizerPrelude)
                                (_typevariablesOprekind)
                                (_typevariablesOprelude)
                                (_typevariablesOtoplevel)
                                (_typevariablesOverbosity))
            ( _typeIabstractTypes_collect,_typeIbimapImps_collect,_typeIconstructors_collect,_typeIdepConstraints_collect,_typeIfunImps_collect,_typeIgenericAbstractions_collect,_typeIinferkind,_typeIkinames,_typeIkind_errors,_typeIkindvar,_typeIksubst,_typeIlabels_collect,_typeImethods_collect,_typeIrawRequests_collect,_typeIself,_typeIstaticErrors,_typeItypeImps_collect) =
                (type_ (_typeOabstractTypes_collect)
                       (_typeObimapImps_collect)
                       (_typeOclassname)
                       (_typeOconstructors_collect)
                       (_typeOconstructors_dist)
                       (_typeOcurrentModule)
                       (_typeOdependencies)
                       (_typeOfunImps_collect)
                       (_typeOgenericAbstractions)
                       (_typeOgenericAbstractions_collect)
                       (_typeOghc)
                       (_typeOimportedModule)
                       (_typeOinstancename)
                       (_typeOkinames)
                       (_typeOkinds)
                       (_typeOkindvar)
                       (_typeOksubst)
                       (_typeOlabels_collect)
                       (_typeOlabels_dist)
                       (_typeOlocal)
                       (_typeOmethods_collect)
                       (_typeOmethods_dist)
                       (_typeOmodules)
                       (_typeOoptimizer)
                       (_typeOoptimizerPrelude)
                       (_typeOprekind)
                       (_typeOprelude)
                       (_typeOrawRequests_collect)
                       (_typeOtoplevel)
                       (_typeOtypeImps_collect)
                       (_typeOverbosity))
            -- "./ModuleInformation.inc.lag"(line 162, column 8)
            (_typeOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 161, column 8)
            (_typevariablesOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 160, column 8)
            (_kindargumentOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 417, column 9)
            (_lhsOname@_) =
                _nameIself
            -- "./KindIndexedType.inc.lag"(line 247, column 9)
            (_lhsOkindIndexedType@_) =
                case _kindargumentIself of
                  KindArgument_Star _
                    -> Left (_typevariablesIself
                            ,_normalizedType
                            )
                  KindArgument_Arrow _ kl kr
                    -> Right ((kl,kr)
                             ,(_typevariablesIself
                              ,_normalizedType
                              )
                             )
            -- "./KindIndexedType.inc.lag"(line 242, column 9)
            (_normalizedType@_) =
                Types.normalize $ Types.quantifyLambda
                  (makeLambdaType
                     _typevariablesIself
                     (Types.strip _typeIself)
                  )
            -- "./Request.inc.lag"(line 284, column 9)
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                _kindargumentIkind_errors ++ _typevariablesIkind_errors ++ _typeIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _typeIstaticErrors
            -- self rule
            (_self@_) =
                KindIndexedBinding_KindIndexedBinding _rangeIself _nameIself _kindargumentIself _typevariablesIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _typeIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _typeIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _typeIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _typeIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _typeIkinames
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _typeIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _typeIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _typeIrawRequests_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _typeItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_kindargumentOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_kindargumentOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_kindargumentOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_kindargumentOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_kindargumentOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_kindargumentOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_kindargumentOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_kindargumentOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_kindargumentOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_kindargumentOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_kindargumentOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_kindargumentOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_kindargumentOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_kindargumentOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_kindargumentOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_kindargumentOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_kindargumentOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_kindargumentOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_kindargumentOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_kindargumentOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_kindargumentOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_kindargumentOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_kindargumentOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_kindargumentOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_typevariablesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typevariablesOconstructors_collect@_) =
                _kindargumentIconstructors_collect
            -- copy rule (down)
            (_typevariablesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typevariablesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typevariablesOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_typevariablesOgenericAbstractions_collect@_) =
                _kindargumentIgenericAbstractions_collect
            -- copy rule (down)
            (_typevariablesOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_typevariablesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typevariablesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typevariablesOkinames@_) =
                _kindargumentIkinames
            -- copy rule (down)
            (_typevariablesOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_typevariablesOkindvar@_) =
                _kindargumentIkindvar
            -- copy rule (chain)
            (_typevariablesOksubst@_) =
                _kindargumentIksubst
            -- copy rule (chain)
            (_typevariablesOlabels_collect@_) =
                _kindargumentIlabels_collect
            -- copy rule (down)
            (_typevariablesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typevariablesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typevariablesOmethods_collect@_) =
                _kindargumentImethods_collect
            -- copy rule (down)
            (_typevariablesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typevariablesOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_typevariablesOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_typevariablesOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_typevariablesOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_typevariablesOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_typevariablesOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_typeOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_typeObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _typevariablesIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_typeOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_typeOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_typeOgenericAbstractions_collect@_) =
                _typevariablesIgenericAbstractions_collect
            -- copy rule (down)
            (_typeOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typeOkinames@_) =
                _typevariablesIkinames
            -- copy rule (down)
            (_typeOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_typeOkindvar@_) =
                _typevariablesIkindvar
            -- copy rule (chain)
            (_typeOksubst@_) =
                _typevariablesIksubst
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _typevariablesIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _typevariablesImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typeOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_typeOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_typeOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_typeOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_typeOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_typeOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_typeOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_typeOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedType,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps_collect)
-- KindIndexedBindings -----------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      rawRequests_collect  : [RawRequest]
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      kindIndexedBindings  : [Either LambdaType ((Name,Name),LambdaType)]
      kindIndexedType      : KindIndexedType
      kind_errors          : [GHError]
      name                 : Name
      self                 : SELF
      staticErrors         : [GHError]
      wellformed           : Bool

-}
{-
   local variables for KindIndexedBindings.Cons:
      kindIndexedBindings
      self

-}
{-
   local variables for KindIndexedBindings.Nil:
      self

-}
-- semantic domain
type T_KindIndexedBindings = (Set Name) ->
                             ([Request_BimapImply]) ->
                             (Maybe Name) ->
                             (FMap Name Names) ->
                             (FMap Name Names) ->
                             (Strings) ->
                             (FMap Name [(Name,Name)]) ->
                             ([Request_FunImply]) ->
                             (FMap Name Kind) ->
                             (FMap Name Kind) ->
                             (Bool) ->
                             (Bool) ->
                             (Maybe Name) ->
                             (KSubst) ->
                             (FMap Name KindIndexedType) ->
                             (FMap Name KindIndexedType) ->
                             (KSubst) ->
                             (Int) ->
                             (KSubst) ->
                             (FMap Name Names) ->
                             (FMap Name Names) ->
                             (Bool) ->
                             (FMap Name Names) ->
                             (FMap Name Names) ->
                             (Set Strings) ->
                             (Bool) ->
                             (Declarations) ->
                             (KSubst) ->
                             (Bool) ->
                             ([RawRequest]) ->
                             (Bool) ->
                             ([Request_TypeImply]) ->
                             (Int) ->
                             ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),([Either LambdaType ((Name,Name),LambdaType)]),(KindIndexedType),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(Name),([RawRequest]),(KindIndexedBindings),([GHError]),([Request_TypeImply]),(Bool))
-- cata
sem_KindIndexedBindings :: (KindIndexedBindings) ->
                           (T_KindIndexedBindings)
sem_KindIndexedBindings (list) =
    (foldr (sem_KindIndexedBindings_Cons) (sem_KindIndexedBindings_Nil) ((map sem_KindIndexedBinding list)))
sem_KindIndexedBindings_Cons :: (T_KindIndexedBinding) ->
                                (T_KindIndexedBindings) ->
                                (T_KindIndexedBindings)
sem_KindIndexedBindings_Cons (hd_) (tl_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedBindings :: ([Either LambdaType ((Name,Name),LambdaType)])
            _lhsOkindIndexedType :: (KindIndexedType)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (KindIndexedBindings)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _lhsOwellformed :: (Bool)
            _hdIabstractTypes_collect :: (Set Name)
            _hdIbimapImps_collect :: ([Request_BimapImply])
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdepConstraints_collect :: ([DepConstraint])
            _hdIfunImps_collect :: ([Request_FunImply])
            _hdIgenericAbstractions_collect :: (FMap Name Kind)
            _hdIkinames :: (KSubst)
            _hdIkindIndexedType :: (Either LambdaType ((Name,Name),LambdaType))
            _hdIkind_errors :: ([GHError])
            _hdIkindvar :: (Int)
            _hdIksubst :: (KSubst)
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIname :: (Name)
            _hdIrawRequests_collect :: ([RawRequest])
            _hdIself :: (KindIndexedBinding)
            _hdIstaticErrors :: ([GHError])
            _hdItypeImps_collect :: ([Request_TypeImply])
            _hdOabstractTypes_collect :: (Set Name)
            _hdObimapImps_collect :: ([Request_BimapImply])
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies :: (FMap Name [(Name,Name)])
            _hdOfunImps_collect :: ([Request_FunImply])
            _hdOgenericAbstractions :: (FMap Name Kind)
            _hdOgenericAbstractions_collect :: (FMap Name Kind)
            _hdOghc :: (Bool)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOkinames :: (KSubst)
            _hdOkinds :: (KSubst)
            _hdOkindvar :: (Int)
            _hdOksubst :: (KSubst)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmodules :: (Set Strings)
            _hdOoptimizer :: (Bool)
            _hdOoptimizerPrelude :: (Declarations)
            _hdOprekind :: (KSubst)
            _hdOprelude :: (Bool)
            _hdOrawRequests_collect :: ([RawRequest])
            _hdOtoplevel :: (Bool)
            _hdOtypeImps_collect :: ([Request_TypeImply])
            _hdOverbosity :: (Int)
            _tlIabstractTypes_collect :: (Set Name)
            _tlIbimapImps_collect :: ([Request_BimapImply])
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdepConstraints_collect :: ([DepConstraint])
            _tlIfunImps_collect :: ([Request_FunImply])
            _tlIgenericAbstractions_collect :: (FMap Name Kind)
            _tlIkinames :: (KSubst)
            _tlIkindIndexedBindings :: ([Either LambdaType ((Name,Name),LambdaType)])
            _tlIkindIndexedType :: (KindIndexedType)
            _tlIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _tlIkind_errors :: ([GHError])
            _tlIkindvar :: (Int)
            _tlIksubst :: (KSubst)
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIname :: (Name)
            _tlIrawRequests_collect :: ([RawRequest])
            _tlIself :: (KindIndexedBindings)
            _tlIstaticErrors :: ([GHError])
            _tlItypeImps_collect :: ([Request_TypeImply])
            _tlIwellformed :: (Bool)
            _tlOabstractTypes_collect :: (Set Name)
            _tlObimapImps_collect :: ([Request_BimapImply])
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies :: (FMap Name [(Name,Name)])
            _tlOfunImps_collect :: ([Request_FunImply])
            _tlOgenericAbstractions :: (FMap Name Kind)
            _tlOgenericAbstractions_collect :: (FMap Name Kind)
            _tlOghc :: (Bool)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOkinames :: (KSubst)
            _tlOkindIndexedTypes :: (FMap Name KindIndexedType)
            _tlOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _tlOkinds :: (KSubst)
            _tlOkindvar :: (Int)
            _tlOksubst :: (KSubst)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmodules :: (Set Strings)
            _tlOoptimizer :: (Bool)
            _tlOoptimizerPrelude :: (Declarations)
            _tlOprekind :: (KSubst)
            _tlOprelude :: (Bool)
            _tlOrawRequests_collect :: ([RawRequest])
            _tlOtoplevel :: (Bool)
            _tlOtypeImps_collect :: ([Request_TypeImply])
            _tlOverbosity :: (Int)
            ( _hdIabstractTypes_collect,_hdIbimapImps_collect,_hdIconstructors_collect,_hdIdepConstraints_collect,_hdIfunImps_collect,_hdIgenericAbstractions_collect,_hdIkinames,_hdIkindIndexedType,_hdIkind_errors,_hdIkindvar,_hdIksubst,_hdIlabels_collect,_hdImethods_collect,_hdIname,_hdIrawRequests_collect,_hdIself,_hdIstaticErrors,_hdItypeImps_collect) =
                (hd_ (_hdOabstractTypes_collect)
                     (_hdObimapImps_collect)
                     (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOdependencies)
                     (_hdOfunImps_collect)
                     (_hdOgenericAbstractions)
                     (_hdOgenericAbstractions_collect)
                     (_hdOghc)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOkinames)
                     (_hdOkinds)
                     (_hdOkindvar)
                     (_hdOksubst)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmodules)
                     (_hdOoptimizer)
                     (_hdOoptimizerPrelude)
                     (_hdOprekind)
                     (_hdOprelude)
                     (_hdOrawRequests_collect)
                     (_hdOtoplevel)
                     (_hdOtypeImps_collect)
                     (_hdOverbosity))
            ( _tlIabstractTypes_collect,_tlIbimapImps_collect,_tlIconstructors_collect,_tlIdepConstraints_collect,_tlIfunImps_collect,_tlIgenericAbstractions_collect,_tlIkinames,_tlIkindIndexedBindings,_tlIkindIndexedType,_tlIkindIndexedTypes_collect,_tlIkind_errors,_tlIkindvar,_tlIksubst,_tlIlabels_collect,_tlImethods_collect,_tlIname,_tlIrawRequests_collect,_tlIself,_tlIstaticErrors,_tlItypeImps_collect,_tlIwellformed) =
                (tl_ (_tlOabstractTypes_collect)
                     (_tlObimapImps_collect)
                     (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOdependencies)
                     (_tlOfunImps_collect)
                     (_tlOgenericAbstractions)
                     (_tlOgenericAbstractions_collect)
                     (_tlOghc)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOkinames)
                     (_tlOkindIndexedTypes)
                     (_tlOkindIndexedTypes_collect)
                     (_tlOkinds)
                     (_tlOkindvar)
                     (_tlOksubst)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmodules)
                     (_tlOoptimizer)
                     (_tlOoptimizerPrelude)
                     (_tlOprekind)
                     (_tlOprelude)
                     (_tlOrawRequests_collect)
                     (_tlOtoplevel)
                     (_tlOtypeImps_collect)
                     (_tlOverbosity))
            -- "./ModuleInformation.inc.lag"(line 410, column 9)
            (_lhsOname@_) =
                _hdIname
            -- "./KindIndexedType.inc.lag"(line 272, column 9)
            (_lhsOkindIndexedType@_) =
                Types.makeKindIndexedType
                  _hdIname
                  _lhsIkindIndexedTypes
                  Nothing
                  _kindIndexedBindings
            -- "./KindIndexedType.inc.lag"(line 271, column 9)
            (_lhsOwellformed@_) =
                differentEither _kindIndexedBindings
            -- "./KindIndexedType.inc.lag"(line 269, column 9)
            (_lhsOkindIndexedBindings@_) =
                _kindIndexedBindings
            -- "./KindIndexedType.inc.lag"(line 268, column 9)
            (_kindIndexedBindings@_) =
                _hdIkindIndexedType : _tlIkindIndexedBindings
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _hdIdepConstraints_collect ++ _tlIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _hdIkind_errors ++ _tlIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _hdIstaticErrors ++ _tlIstaticErrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _tlIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _tlIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _tlIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _tlIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _tlIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _tlIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _tlIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _tlIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _tlIrawRequests_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _tlItypeImps_collect
            -- copy rule (down)
            (_hdOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_hdObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_hdOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_hdOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_hdOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_hdOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_hdOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_hdOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_hdOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_hdOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_hdOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_hdOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_hdOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_hdOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_hdOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_hdOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_tlOabstractTypes_collect@_) =
                _hdIabstractTypes_collect
            -- copy rule (chain)
            (_tlObimapImps_collect@_) =
                _hdIbimapImps_collect
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOdependencies@_) =
                _lhsIdependencies
            -- copy rule (chain)
            (_tlOfunImps_collect@_) =
                _hdIfunImps_collect
            -- copy rule (down)
            (_tlOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_tlOgenericAbstractions_collect@_) =
                _hdIgenericAbstractions_collect
            -- copy rule (down)
            (_tlOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOkinames@_) =
                _hdIkinames
            -- copy rule (down)
            (_tlOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_tlOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_tlOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_tlOkindvar@_) =
                _hdIkindvar
            -- copy rule (chain)
            (_tlOksubst@_) =
                _hdIksubst
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_tlOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_tlOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_tlOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_tlOprelude@_) =
                _lhsIprelude
            -- copy rule (chain)
            (_tlOrawRequests_collect@_) =
                _hdIrawRequests_collect
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_tlOtypeImps_collect@_) =
                _hdItypeImps_collect
            -- copy rule (down)
            (_tlOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedBindings,_lhsOkindIndexedType,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps_collect,_lhsOwellformed)
sem_KindIndexedBindings_Nil :: (T_KindIndexedBindings)
sem_KindIndexedBindings_Nil  =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedBindings :: ([Either LambdaType ((Name,Name),LambdaType)])
            _lhsOkindIndexedType :: (KindIndexedType)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (KindIndexedBindings)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _lhsOwellformed :: (Bool)
            -- "./ModuleInformation.inc.lag"(line 412, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.KindIndexedBindings.Nil.lhs.name: no bindings"
            -- "./KindIndexedType.inc.lag"(line 263, column 9)
            (_lhsOkindIndexedType@_) =
                internalError $
                  "KindIndexedType.KindIndexedBindings.kindIndexedType: "
                    ++ "not wellformed"
            -- "./KindIndexedType.inc.lag"(line 262, column 9)
            (_lhsOwellformed@_) =
                False
            -- "./KindIndexedType.inc.lag"(line 261, column 9)
            (_lhsOkindIndexedBindings@_) =
                []
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedBindings,_lhsOkindIndexedType,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps_collect,_lhsOwellformed)
-- LeftHandSide ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      name                 : Name
      self                 : SELF

-}
{-
   local variables for LeftHandSide.Function:
      self

-}
{-
   local variables for LeftHandSide.Infix:
      self

-}
{-
   local variables for LeftHandSide.Parenthesized:
      self

-}
-- semantic domain
type T_LeftHandSide = (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Strings) ->
                      (FMap Name Kind) ->
                      (FMap Name Kind) ->
                      (Bool) ->
                      (Bool) ->
                      (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Set Strings) ->
                      (Bool) ->
                      (Declarations) ->
                      (Bool) ->
                      (Bool) ->
                      (Int) ->
                      ( (FMap Name Names),(FMap Name Kind),(FMap Name Names),(FMap Name Names),(Name),(LeftHandSide))
-- cata
sem_LeftHandSide :: (LeftHandSide) ->
                    (T_LeftHandSide)
sem_LeftHandSide ((LeftHandSide_Function (_range) (_name) (_patterns))) =
    (sem_LeftHandSide_Function ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Patterns (_patterns))))
sem_LeftHandSide ((LeftHandSide_Infix (_range) (_leftPattern) (_operator) (_rightPattern))) =
    (sem_LeftHandSide_Infix ((sem_Range (_range))) ((sem_Pattern (_leftPattern))) ((sem_Name (_operator))) ((sem_Pattern (_rightPattern))))
sem_LeftHandSide ((LeftHandSide_Parenthesized (_range) (_lefthandside) (_patterns))) =
    (sem_LeftHandSide_Parenthesized ((sem_Range (_range))) ((sem_LeftHandSide (_lefthandside))) ((sem_Patterns (_patterns))))
sem_LeftHandSide_Function :: (T_Range) ->
                             (T_Name) ->
                             (T_Patterns) ->
                             (T_LeftHandSide)
sem_LeftHandSide_Function (range_) (name_) (patterns_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (LeftHandSide)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _patternsIconstructors_collect :: (FMap Name Names)
            _patternsIgenericAbstractions_collect :: (FMap Name Kind)
            _patternsIlabels_collect :: (FMap Name Names)
            _patternsImethods_collect :: (FMap Name Names)
            _patternsIself :: (Patterns)
            _patternsOclassname :: (Maybe Name)
            _patternsOconstructors_collect :: (FMap Name Names)
            _patternsOconstructors_dist :: (FMap Name Names)
            _patternsOcurrentModule :: (Strings)
            _patternsOgenericAbstractions :: (FMap Name Kind)
            _patternsOgenericAbstractions_collect :: (FMap Name Kind)
            _patternsOghc :: (Bool)
            _patternsOimportedModule :: (Bool)
            _patternsOinstancename :: (Maybe Name)
            _patternsOlabels_collect :: (FMap Name Names)
            _patternsOlabels_dist :: (FMap Name Names)
            _patternsOlocal :: (Bool)
            _patternsOmethods_collect :: (FMap Name Names)
            _patternsOmethods_dist :: (FMap Name Names)
            _patternsOmodules :: (Set Strings)
            _patternsOoptimizer :: (Bool)
            _patternsOoptimizerPrelude :: (Declarations)
            _patternsOprelude :: (Bool)
            _patternsOtoplevel :: (Bool)
            _patternsOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _patternsIconstructors_collect,_patternsIgenericAbstractions_collect,_patternsIlabels_collect,_patternsImethods_collect,_patternsIself) =
                (patterns_ (_patternsOclassname)
                           (_patternsOconstructors_collect)
                           (_patternsOconstructors_dist)
                           (_patternsOcurrentModule)
                           (_patternsOgenericAbstractions)
                           (_patternsOgenericAbstractions_collect)
                           (_patternsOghc)
                           (_patternsOimportedModule)
                           (_patternsOinstancename)
                           (_patternsOlabels_collect)
                           (_patternsOlabels_dist)
                           (_patternsOlocal)
                           (_patternsOmethods_collect)
                           (_patternsOmethods_dist)
                           (_patternsOmodules)
                           (_patternsOoptimizer)
                           (_patternsOoptimizerPrelude)
                           (_patternsOprelude)
                           (_patternsOtoplevel)
                           (_patternsOverbosity))
            -- "./ModuleInformation.inc.lag"(line 176, column 8)
            (_patternsOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 404, column 9)
            (_lhsOname@_) =
                _nameIself
            -- self rule
            (_self@_) =
                LeftHandSide_Function _rangeIself _nameIself _patternsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _patternsIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _patternsIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _patternsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _patternsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_patternsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_patternsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_patternsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_patternsOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_patternsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_patternsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_patternsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_patternsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_patternsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_patternsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_patternsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_patternsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_patternsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_patternsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
sem_LeftHandSide_Infix :: (T_Range) ->
                          (T_Pattern) ->
                          (T_Name) ->
                          (T_Pattern) ->
                          (T_LeftHandSide)
sem_LeftHandSide_Infix (range_) (leftPattern_) (operator_) (rightPattern_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (LeftHandSide)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _leftPatternIconstructors_collect :: (FMap Name Names)
            _leftPatternIgenericAbstractions_collect :: (FMap Name Kind)
            _leftPatternIlabels_collect :: (FMap Name Names)
            _leftPatternImethods_collect :: (FMap Name Names)
            _leftPatternIname :: (Name)
            _leftPatternIself :: (Pattern)
            _leftPatternOclassname :: (Maybe Name)
            _leftPatternOconstructors_collect :: (FMap Name Names)
            _leftPatternOconstructors_dist :: (FMap Name Names)
            _leftPatternOcurrentModule :: (Strings)
            _leftPatternOgenericAbstractions :: (FMap Name Kind)
            _leftPatternOgenericAbstractions_collect :: (FMap Name Kind)
            _leftPatternOghc :: (Bool)
            _leftPatternOimportedModule :: (Bool)
            _leftPatternOinstancename :: (Maybe Name)
            _leftPatternOlabels_collect :: (FMap Name Names)
            _leftPatternOlabels_dist :: (FMap Name Names)
            _leftPatternOlocal :: (Bool)
            _leftPatternOmethods_collect :: (FMap Name Names)
            _leftPatternOmethods_dist :: (FMap Name Names)
            _leftPatternOmodules :: (Set Strings)
            _leftPatternOoptimizer :: (Bool)
            _leftPatternOoptimizerPrelude :: (Declarations)
            _leftPatternOprelude :: (Bool)
            _leftPatternOtoplevel :: (Bool)
            _leftPatternOverbosity :: (Int)
            _operatorIconstructors_collect :: (FMap Name Names)
            _operatorIgenericAbstractions_collect :: (FMap Name Kind)
            _operatorIlabels_collect :: (FMap Name Names)
            _operatorImethods_collect :: (FMap Name Names)
            _operatorIself :: (Name)
            _operatorOclassname :: (Maybe Name)
            _operatorOconstructors_collect :: (FMap Name Names)
            _operatorOconstructors_dist :: (FMap Name Names)
            _operatorOcurrentModule :: (Strings)
            _operatorOgenericAbstractions :: (FMap Name Kind)
            _operatorOgenericAbstractions_collect :: (FMap Name Kind)
            _operatorOghc :: (Bool)
            _operatorOimportedModule :: (Bool)
            _operatorOinstancename :: (Maybe Name)
            _operatorOlabels_collect :: (FMap Name Names)
            _operatorOlabels_dist :: (FMap Name Names)
            _operatorOlocal :: (Bool)
            _operatorOmethods_collect :: (FMap Name Names)
            _operatorOmethods_dist :: (FMap Name Names)
            _operatorOmodules :: (Set Strings)
            _operatorOoptimizer :: (Bool)
            _operatorOoptimizerPrelude :: (Declarations)
            _operatorOprelude :: (Bool)
            _operatorOtoplevel :: (Bool)
            _operatorOverbosity :: (Int)
            _rightPatternIconstructors_collect :: (FMap Name Names)
            _rightPatternIgenericAbstractions_collect :: (FMap Name Kind)
            _rightPatternIlabels_collect :: (FMap Name Names)
            _rightPatternImethods_collect :: (FMap Name Names)
            _rightPatternIname :: (Name)
            _rightPatternIself :: (Pattern)
            _rightPatternOclassname :: (Maybe Name)
            _rightPatternOconstructors_collect :: (FMap Name Names)
            _rightPatternOconstructors_dist :: (FMap Name Names)
            _rightPatternOcurrentModule :: (Strings)
            _rightPatternOgenericAbstractions :: (FMap Name Kind)
            _rightPatternOgenericAbstractions_collect :: (FMap Name Kind)
            _rightPatternOghc :: (Bool)
            _rightPatternOimportedModule :: (Bool)
            _rightPatternOinstancename :: (Maybe Name)
            _rightPatternOlabels_collect :: (FMap Name Names)
            _rightPatternOlabels_dist :: (FMap Name Names)
            _rightPatternOlocal :: (Bool)
            _rightPatternOmethods_collect :: (FMap Name Names)
            _rightPatternOmethods_dist :: (FMap Name Names)
            _rightPatternOmodules :: (Set Strings)
            _rightPatternOoptimizer :: (Bool)
            _rightPatternOoptimizerPrelude :: (Declarations)
            _rightPatternOprelude :: (Bool)
            _rightPatternOtoplevel :: (Bool)
            _rightPatternOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _leftPatternIconstructors_collect,_leftPatternIgenericAbstractions_collect,_leftPatternIlabels_collect,_leftPatternImethods_collect,_leftPatternIname,_leftPatternIself) =
                (leftPattern_ (_leftPatternOclassname)
                              (_leftPatternOconstructors_collect)
                              (_leftPatternOconstructors_dist)
                              (_leftPatternOcurrentModule)
                              (_leftPatternOgenericAbstractions)
                              (_leftPatternOgenericAbstractions_collect)
                              (_leftPatternOghc)
                              (_leftPatternOimportedModule)
                              (_leftPatternOinstancename)
                              (_leftPatternOlabels_collect)
                              (_leftPatternOlabels_dist)
                              (_leftPatternOlocal)
                              (_leftPatternOmethods_collect)
                              (_leftPatternOmethods_dist)
                              (_leftPatternOmodules)
                              (_leftPatternOoptimizer)
                              (_leftPatternOoptimizerPrelude)
                              (_leftPatternOprelude)
                              (_leftPatternOtoplevel)
                              (_leftPatternOverbosity))
            ( _operatorIconstructors_collect,_operatorIgenericAbstractions_collect,_operatorIlabels_collect,_operatorImethods_collect,_operatorIself) =
                (operator_ (_operatorOclassname)
                           (_operatorOconstructors_collect)
                           (_operatorOconstructors_dist)
                           (_operatorOcurrentModule)
                           (_operatorOgenericAbstractions)
                           (_operatorOgenericAbstractions_collect)
                           (_operatorOghc)
                           (_operatorOimportedModule)
                           (_operatorOinstancename)
                           (_operatorOlabels_collect)
                           (_operatorOlabels_dist)
                           (_operatorOlocal)
                           (_operatorOmethods_collect)
                           (_operatorOmethods_dist)
                           (_operatorOmodules)
                           (_operatorOoptimizer)
                           (_operatorOoptimizerPrelude)
                           (_operatorOprelude)
                           (_operatorOtoplevel)
                           (_operatorOverbosity))
            ( _rightPatternIconstructors_collect,_rightPatternIgenericAbstractions_collect,_rightPatternIlabels_collect,_rightPatternImethods_collect,_rightPatternIname,_rightPatternIself) =
                (rightPattern_ (_rightPatternOclassname)
                               (_rightPatternOconstructors_collect)
                               (_rightPatternOconstructors_dist)
                               (_rightPatternOcurrentModule)
                               (_rightPatternOgenericAbstractions)
                               (_rightPatternOgenericAbstractions_collect)
                               (_rightPatternOghc)
                               (_rightPatternOimportedModule)
                               (_rightPatternOinstancename)
                               (_rightPatternOlabels_collect)
                               (_rightPatternOlabels_dist)
                               (_rightPatternOlocal)
                               (_rightPatternOmethods_collect)
                               (_rightPatternOmethods_dist)
                               (_rightPatternOmodules)
                               (_rightPatternOoptimizer)
                               (_rightPatternOoptimizerPrelude)
                               (_rightPatternOprelude)
                               (_rightPatternOtoplevel)
                               (_rightPatternOverbosity))
            -- "./ModuleInformation.inc.lag"(line 179, column 8)
            (_rightPatternOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 178, column 8)
            (_leftPatternOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 406, column 9)
            (_lhsOname@_) =
                _operatorIself
            -- self rule
            (_self@_) =
                LeftHandSide_Infix _rangeIself _leftPatternIself _operatorIself _rightPatternIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _rightPatternIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _rightPatternIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _rightPatternIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _rightPatternImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_leftPatternOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_leftPatternOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_leftPatternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_leftPatternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_leftPatternOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_leftPatternOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_leftPatternOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_leftPatternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_leftPatternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_leftPatternOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_leftPatternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_leftPatternOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_leftPatternOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_leftPatternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_leftPatternOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_leftPatternOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_leftPatternOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_leftPatternOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_leftPatternOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_operatorOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_operatorOconstructors_collect@_) =
                _leftPatternIconstructors_collect
            -- copy rule (down)
            (_operatorOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_operatorOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_operatorOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_operatorOgenericAbstractions_collect@_) =
                _leftPatternIgenericAbstractions_collect
            -- copy rule (down)
            (_operatorOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_operatorOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_operatorOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_operatorOlabels_collect@_) =
                _leftPatternIlabels_collect
            -- copy rule (down)
            (_operatorOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_operatorOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_operatorOmethods_collect@_) =
                _leftPatternImethods_collect
            -- copy rule (down)
            (_operatorOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_operatorOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_operatorOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_operatorOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_operatorOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_operatorOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_operatorOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_rightPatternOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_rightPatternOconstructors_collect@_) =
                _operatorIconstructors_collect
            -- copy rule (down)
            (_rightPatternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_rightPatternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rightPatternOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_rightPatternOgenericAbstractions_collect@_) =
                _operatorIgenericAbstractions_collect
            -- copy rule (down)
            (_rightPatternOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_rightPatternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rightPatternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_rightPatternOlabels_collect@_) =
                _operatorIlabels_collect
            -- copy rule (down)
            (_rightPatternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_rightPatternOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_rightPatternOmethods_collect@_) =
                _operatorImethods_collect
            -- copy rule (down)
            (_rightPatternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_rightPatternOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_rightPatternOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_rightPatternOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_rightPatternOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_rightPatternOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
sem_LeftHandSide_Parenthesized :: (T_Range) ->
                                  (T_LeftHandSide) ->
                                  (T_Patterns) ->
                                  (T_LeftHandSide)
sem_LeftHandSide_Parenthesized (range_) (lefthandside_) (patterns_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (LeftHandSide)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _lefthandsideIconstructors_collect :: (FMap Name Names)
            _lefthandsideIgenericAbstractions_collect :: (FMap Name Kind)
            _lefthandsideIlabels_collect :: (FMap Name Names)
            _lefthandsideImethods_collect :: (FMap Name Names)
            _lefthandsideIname :: (Name)
            _lefthandsideIself :: (LeftHandSide)
            _lefthandsideOclassname :: (Maybe Name)
            _lefthandsideOconstructors_collect :: (FMap Name Names)
            _lefthandsideOconstructors_dist :: (FMap Name Names)
            _lefthandsideOcurrentModule :: (Strings)
            _lefthandsideOgenericAbstractions :: (FMap Name Kind)
            _lefthandsideOgenericAbstractions_collect :: (FMap Name Kind)
            _lefthandsideOghc :: (Bool)
            _lefthandsideOimportedModule :: (Bool)
            _lefthandsideOinstancename :: (Maybe Name)
            _lefthandsideOlabels_collect :: (FMap Name Names)
            _lefthandsideOlabels_dist :: (FMap Name Names)
            _lefthandsideOlocal :: (Bool)
            _lefthandsideOmethods_collect :: (FMap Name Names)
            _lefthandsideOmethods_dist :: (FMap Name Names)
            _lefthandsideOmodules :: (Set Strings)
            _lefthandsideOoptimizer :: (Bool)
            _lefthandsideOoptimizerPrelude :: (Declarations)
            _lefthandsideOprelude :: (Bool)
            _lefthandsideOtoplevel :: (Bool)
            _lefthandsideOverbosity :: (Int)
            _patternsIconstructors_collect :: (FMap Name Names)
            _patternsIgenericAbstractions_collect :: (FMap Name Kind)
            _patternsIlabels_collect :: (FMap Name Names)
            _patternsImethods_collect :: (FMap Name Names)
            _patternsIself :: (Patterns)
            _patternsOclassname :: (Maybe Name)
            _patternsOconstructors_collect :: (FMap Name Names)
            _patternsOconstructors_dist :: (FMap Name Names)
            _patternsOcurrentModule :: (Strings)
            _patternsOgenericAbstractions :: (FMap Name Kind)
            _patternsOgenericAbstractions_collect :: (FMap Name Kind)
            _patternsOghc :: (Bool)
            _patternsOimportedModule :: (Bool)
            _patternsOinstancename :: (Maybe Name)
            _patternsOlabels_collect :: (FMap Name Names)
            _patternsOlabels_dist :: (FMap Name Names)
            _patternsOlocal :: (Bool)
            _patternsOmethods_collect :: (FMap Name Names)
            _patternsOmethods_dist :: (FMap Name Names)
            _patternsOmodules :: (Set Strings)
            _patternsOoptimizer :: (Bool)
            _patternsOoptimizerPrelude :: (Declarations)
            _patternsOprelude :: (Bool)
            _patternsOtoplevel :: (Bool)
            _patternsOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _lefthandsideIconstructors_collect,_lefthandsideIgenericAbstractions_collect,_lefthandsideIlabels_collect,_lefthandsideImethods_collect,_lefthandsideIname,_lefthandsideIself) =
                (lefthandside_ (_lefthandsideOclassname)
                               (_lefthandsideOconstructors_collect)
                               (_lefthandsideOconstructors_dist)
                               (_lefthandsideOcurrentModule)
                               (_lefthandsideOgenericAbstractions)
                               (_lefthandsideOgenericAbstractions_collect)
                               (_lefthandsideOghc)
                               (_lefthandsideOimportedModule)
                               (_lefthandsideOinstancename)
                               (_lefthandsideOlabels_collect)
                               (_lefthandsideOlabels_dist)
                               (_lefthandsideOlocal)
                               (_lefthandsideOmethods_collect)
                               (_lefthandsideOmethods_dist)
                               (_lefthandsideOmodules)
                               (_lefthandsideOoptimizer)
                               (_lefthandsideOoptimizerPrelude)
                               (_lefthandsideOprelude)
                               (_lefthandsideOtoplevel)
                               (_lefthandsideOverbosity))
            ( _patternsIconstructors_collect,_patternsIgenericAbstractions_collect,_patternsIlabels_collect,_patternsImethods_collect,_patternsIself) =
                (patterns_ (_patternsOclassname)
                           (_patternsOconstructors_collect)
                           (_patternsOconstructors_dist)
                           (_patternsOcurrentModule)
                           (_patternsOgenericAbstractions)
                           (_patternsOgenericAbstractions_collect)
                           (_patternsOghc)
                           (_patternsOimportedModule)
                           (_patternsOinstancename)
                           (_patternsOlabels_collect)
                           (_patternsOlabels_dist)
                           (_patternsOlocal)
                           (_patternsOmethods_collect)
                           (_patternsOmethods_dist)
                           (_patternsOmodules)
                           (_patternsOoptimizer)
                           (_patternsOoptimizerPrelude)
                           (_patternsOprelude)
                           (_patternsOtoplevel)
                           (_patternsOverbosity))
            -- "./ModuleInformation.inc.lag"(line 181, column 8)
            (_patternsOtoplevel@_) =
                False
            -- self rule
            (_self@_) =
                LeftHandSide_Parenthesized _rangeIself _lefthandsideIself _patternsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _patternsIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _patternsIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _patternsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _patternsImethods_collect
            -- copy rule (up)
            (_lhsOname@_) =
                _lefthandsideIname
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_lefthandsideOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_lefthandsideOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_lefthandsideOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_lefthandsideOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_lefthandsideOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_lefthandsideOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_lefthandsideOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_lefthandsideOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_lefthandsideOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_lefthandsideOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_lefthandsideOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_lefthandsideOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_lefthandsideOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_lefthandsideOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_lefthandsideOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_lefthandsideOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_lefthandsideOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_lefthandsideOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_lefthandsideOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_lefthandsideOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_patternsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_patternsOconstructors_collect@_) =
                _lefthandsideIconstructors_collect
            -- copy rule (down)
            (_patternsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_patternsOgenericAbstractions_collect@_) =
                _lefthandsideIgenericAbstractions_collect
            -- copy rule (down)
            (_patternsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_patternsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_patternsOlabels_collect@_) =
                _lefthandsideIlabels_collect
            -- copy rule (down)
            (_patternsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_patternsOmethods_collect@_) =
                _lefthandsideImethods_collect
            -- copy rule (down)
            (_patternsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_patternsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_patternsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_patternsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_patternsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
-- Literal -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Literal.Char:
      self

-}
{-
   local variables for Literal.Float:
      self

-}
{-
   local variables for Literal.Int:
      self

-}
{-
   local variables for Literal.String:
      self

-}
-- semantic domain
type T_Literal = (Maybe Name) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Strings) ->
                 (FMap Name Kind) ->
                 (FMap Name Kind) ->
                 (Bool) ->
                 (Bool) ->
                 (Maybe Name) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Bool) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Set Strings) ->
                 (Bool) ->
                 (Declarations) ->
                 (Bool) ->
                 (Bool) ->
                 (Int) ->
                 ( (FMap Name Names),(FMap Name Kind),(FMap Name Names),(FMap Name Names),(Literal))
-- cata
sem_Literal :: (Literal) ->
               (T_Literal)
sem_Literal ((Literal_Char (_range) (_value))) =
    (sem_Literal_Char ((sem_Range (_range))) (_value))
sem_Literal ((Literal_Float (_range) (_value))) =
    (sem_Literal_Float ((sem_Range (_range))) (_value))
sem_Literal ((Literal_Int (_range) (_value))) =
    (sem_Literal_Int ((sem_Range (_range))) (_value))
sem_Literal ((Literal_String (_range) (_value))) =
    (sem_Literal_String ((sem_Range (_range))) (_value))
sem_Literal_Char :: (T_Range) ->
                    (String) ->
                    (T_Literal)
sem_Literal_Char (range_) (value_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Literal)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- self rule
            (_self@_) =
                Literal_Char _rangeIself value_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Literal_Float :: (T_Range) ->
                     (String) ->
                     (T_Literal)
sem_Literal_Float (range_) (value_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Literal)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- self rule
            (_self@_) =
                Literal_Float _rangeIself value_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Literal_Int :: (T_Range) ->
                   (String) ->
                   (T_Literal)
sem_Literal_Int (range_) (value_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Literal)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- self rule
            (_self@_) =
                Literal_Int _rangeIself value_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Literal_String :: (T_Range) ->
                      (String) ->
                      (T_Literal)
sem_Literal_String (range_) (value_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Literal)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- self rule
            (_self@_) =
                Literal_String _rangeIself value_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- MaybeDeclarations -------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      exportedStructures   : Set Name
      exportedTypes        : Set Name
      exportedValues       : Set Name
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures
      rawRequests_collect  : [RawRequest]
      structureTypes_collect : FMap Name LambdaType
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      exportedDeclarations : MaybeDeclarations
      kind_errors          : [GHError]
      self                 : SELF
      staticErrors         : [GHError]

-}
{-
   local variables for MaybeDeclarations.Just:
      self

-}
{-
   local variables for MaybeDeclarations.Nothing:
      self

-}
-- semantic domain
type T_MaybeDeclarations = (Set Name) ->
                           ([Request_BimapImply]) ->
                           (Maybe Name) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Strings) ->
                           (FMap Name [(Name,Name)]) ->
                           (Set Name) ->
                           (Set Name) ->
                           (Set Name) ->
                           ([Request_FunImply]) ->
                           (FMap Name Kind) ->
                           (FMap Name Kind) ->
                           (Bool) ->
                           (Bool) ->
                           (Maybe Name) ->
                           (KSubst) ->
                           (FMap Name KindIndexedType) ->
                           (FMap Name KindIndexedType) ->
                           (KSubst) ->
                           (Int) ->
                           (KSubst) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Bool) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Set Strings) ->
                           (Bool) ->
                           (Declarations) ->
                           (KSubst) ->
                           (Bool) ->
                           (PreSignatures) ->
                           (PreSignatures) ->
                           ([RawRequest]) ->
                           (Signatures) ->
                           (FMap Name LambdaType) ->
                           (Bool) ->
                           ([Request_TypeImply]) ->
                           (Int) ->
                           ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),(MaybeDeclarations),([Request_FunImply]),(FMap Name Kind),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(PreSignatures),([RawRequest]),(MaybeDeclarations),([GHError]),(FMap Name LambdaType),([Request_TypeImply]))
-- cata
sem_MaybeDeclarations :: (MaybeDeclarations) ->
                         (T_MaybeDeclarations)
sem_MaybeDeclarations ((MaybeDeclarations_Just (_declarations))) =
    (sem_MaybeDeclarations_Just ((sem_Declarations (_declarations))))
sem_MaybeDeclarations ((MaybeDeclarations_Nothing )) =
    (sem_MaybeDeclarations_Nothing )
sem_MaybeDeclarations_Just :: (T_Declarations) ->
                              (T_MaybeDeclarations)
sem_MaybeDeclarations_Just (declarations_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOexportedDeclarations :: (MaybeDeclarations)
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (MaybeDeclarations)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _declarationsIabstractTypes_collect :: (Set Name)
            _declarationsIbimapImps_collect :: ([Request_BimapImply])
            _declarationsIconstructors_collect :: (FMap Name Names)
            _declarationsIdepConstraints_collect :: ([DepConstraint])
            _declarationsIdepConstraints_defined :: ([DepConstraint])
            _declarationsIexportedDeclarations :: (Declarations)
            _declarationsIfunImps_collect :: ([Request_FunImply])
            _declarationsIgenericAbstractions_collect :: (FMap Name Kind)
            _declarationsIkinames :: (KSubst)
            _declarationsIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _declarationsIkind_errors :: ([GHError])
            _declarationsIkindvar :: (Int)
            _declarationsIksubst :: (KSubst)
            _declarationsIlabels_collect :: (FMap Name Names)
            _declarationsImethods_collect :: (FMap Name Names)
            _declarationsIoutput :: ([PP.Doc])
            _declarationsIoutputi :: ([PP.Doc])
            _declarationsIpresignatures_collect :: (PreSignatures)
            _declarationsIrawRequests_collect :: ([RawRequest])
            _declarationsIself :: (Declarations)
            _declarationsIstaticErrors :: ([GHError])
            _declarationsIstructureTypes_collect :: (FMap Name LambdaType)
            _declarationsItypeImps_collect :: ([Request_TypeImply])
            _declarationsOabstractTypes_collect :: (Set Name)
            _declarationsObimapImps_collect :: ([Request_BimapImply])
            _declarationsOclassname :: (Maybe Name)
            _declarationsOconstructors_collect :: (FMap Name Names)
            _declarationsOconstructors_dist :: (FMap Name Names)
            _declarationsOcurrentModule :: (Strings)
            _declarationsOdependencies :: (FMap Name [(Name,Name)])
            _declarationsOexportedStructures :: (Set Name)
            _declarationsOexportedTypes :: (Set Name)
            _declarationsOexportedValues :: (Set Name)
            _declarationsOfunImps_collect :: ([Request_FunImply])
            _declarationsOgenericAbstractions :: (FMap Name Kind)
            _declarationsOgenericAbstractions_collect :: (FMap Name Kind)
            _declarationsOghc :: (Bool)
            _declarationsOimportedModule :: (Bool)
            _declarationsOinstancename :: (Maybe Name)
            _declarationsOkinames :: (KSubst)
            _declarationsOkindIndexedTypes :: (FMap Name KindIndexedType)
            _declarationsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _declarationsOkinds :: (KSubst)
            _declarationsOkindvar :: (Int)
            _declarationsOksubst :: (KSubst)
            _declarationsOlabels_collect :: (FMap Name Names)
            _declarationsOlabels_dist :: (FMap Name Names)
            _declarationsOlocal :: (Bool)
            _declarationsOmethods_collect :: (FMap Name Names)
            _declarationsOmethods_dist :: (FMap Name Names)
            _declarationsOmodules :: (Set Strings)
            _declarationsOoptimizer :: (Bool)
            _declarationsOoptimizerPrelude :: (Declarations)
            _declarationsOoutput :: ([PP.Doc])
            _declarationsOprekind :: (KSubst)
            _declarationsOprelude :: (Bool)
            _declarationsOpresignatures :: (PreSignatures)
            _declarationsOpresignatures_collect :: (PreSignatures)
            _declarationsOrawRequests_collect :: ([RawRequest])
            _declarationsOsignatures :: (Signatures)
            _declarationsOstructureTypes_collect :: (FMap Name LambdaType)
            _declarationsOtoplevel :: (Bool)
            _declarationsOtypeImps_collect :: ([Request_TypeImply])
            _declarationsOverbosity :: (Int)
            ( _declarationsIabstractTypes_collect
             ,_declarationsIbimapImps_collect
             ,_declarationsIconstructors_collect
             ,_declarationsIdepConstraints_collect
             ,_declarationsIdepConstraints_defined
             ,_declarationsIexportedDeclarations
             ,_declarationsIfunImps_collect
             ,_declarationsIgenericAbstractions_collect
             ,_declarationsIkinames
             ,_declarationsIkindIndexedTypes_collect
             ,_declarationsIkind_errors
             ,_declarationsIkindvar
             ,_declarationsIksubst
             ,_declarationsIlabels_collect
             ,_declarationsImethods_collect
             ,_declarationsIoutput
             ,_declarationsIoutputi
             ,_declarationsIpresignatures_collect
             ,_declarationsIrawRequests_collect
             ,_declarationsIself
             ,_declarationsIstaticErrors
             ,_declarationsIstructureTypes_collect
             ,_declarationsItypeImps_collect
             ) =
                (declarations_ (_declarationsOabstractTypes_collect)
                               (_declarationsObimapImps_collect)
                               (_declarationsOclassname)
                               (_declarationsOconstructors_collect)
                               (_declarationsOconstructors_dist)
                               (_declarationsOcurrentModule)
                               (_declarationsOdependencies)
                               (_declarationsOexportedStructures)
                               (_declarationsOexportedTypes)
                               (_declarationsOexportedValues)
                               (_declarationsOfunImps_collect)
                               (_declarationsOgenericAbstractions)
                               (_declarationsOgenericAbstractions_collect)
                               (_declarationsOghc)
                               (_declarationsOimportedModule)
                               (_declarationsOinstancename)
                               (_declarationsOkinames)
                               (_declarationsOkindIndexedTypes)
                               (_declarationsOkindIndexedTypes_collect)
                               (_declarationsOkinds)
                               (_declarationsOkindvar)
                               (_declarationsOksubst)
                               (_declarationsOlabels_collect)
                               (_declarationsOlabels_dist)
                               (_declarationsOlocal)
                               (_declarationsOmethods_collect)
                               (_declarationsOmethods_dist)
                               (_declarationsOmodules)
                               (_declarationsOoptimizer)
                               (_declarationsOoptimizerPrelude)
                               (_declarationsOoutput)
                               (_declarationsOprekind)
                               (_declarationsOprelude)
                               (_declarationsOpresignatures)
                               (_declarationsOpresignatures_collect)
                               (_declarationsOrawRequests_collect)
                               (_declarationsOsignatures)
                               (_declarationsOstructureTypes_collect)
                               (_declarationsOtoplevel)
                               (_declarationsOtypeImps_collect)
                               (_declarationsOverbosity))
            -- "./Output.inc.lag"(line 394, column 9)
            (_declarationsOoutput@_) =
                []
            -- "./OutputI.inc.lag"(line 118, column 9)
            (_lhsOexportedDeclarations@_) =
                MaybeDeclarations_Just
                  _declarationsIexportedDeclarations
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _declarationsIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _declarationsIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _declarationsIstaticErrors
            -- self rule
            (_self@_) =
                MaybeDeclarations_Just _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _declarationsIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _declarationsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _declarationsIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _declarationsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _declarationsIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _declarationsIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _declarationsIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _declarationsIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _declarationsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _declarationsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _declarationsImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _declarationsIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _declarationsIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _declarationsIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _declarationsItypeImps_collect
            -- copy rule (down)
            (_declarationsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_declarationsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_declarationsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_declarationsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_declarationsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_declarationsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_declarationsOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_declarationsOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_declarationsOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_declarationsOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_declarationsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_declarationsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_declarationsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_declarationsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_declarationsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_declarationsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_declarationsOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_declarationsOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_declarationsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_declarationsOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_declarationsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_declarationsOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_declarationsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_declarationsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_declarationsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_declarationsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_declarationsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_declarationsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_declarationsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_declarationsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_declarationsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_declarationsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_declarationsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_declarationsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_declarationsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_declarationsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_declarationsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_declarationsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_declarationsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_declarationsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect
             ,_lhsObimapImps_collect
             ,_lhsOconstructors_collect
             ,_lhsOdepConstraints_collect
             ,_lhsOexportedDeclarations
             ,_lhsOfunImps_collect
             ,_lhsOgenericAbstractions_collect
             ,_lhsOkinames
             ,_lhsOkindIndexedTypes_collect
             ,_lhsOkind_errors
             ,_lhsOkindvar
             ,_lhsOksubst
             ,_lhsOlabels_collect
             ,_lhsOmethods_collect
             ,_lhsOpresignatures_collect
             ,_lhsOrawRequests_collect
             ,_lhsOself
             ,_lhsOstaticErrors
             ,_lhsOstructureTypes_collect
             ,_lhsOtypeImps_collect
             )
sem_MaybeDeclarations_Nothing :: (T_MaybeDeclarations)
sem_MaybeDeclarations_Nothing  =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOexportedDeclarations :: (MaybeDeclarations)
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (MaybeDeclarations)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            -- "./OutputI.inc.lag"(line 121, column 9)
            (_lhsOexportedDeclarations@_) =
                MaybeDeclarations_Nothing
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                MaybeDeclarations_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
        in  ( _lhsOabstractTypes_collect
             ,_lhsObimapImps_collect
             ,_lhsOconstructors_collect
             ,_lhsOdepConstraints_collect
             ,_lhsOexportedDeclarations
             ,_lhsOfunImps_collect
             ,_lhsOgenericAbstractions_collect
             ,_lhsOkinames
             ,_lhsOkindIndexedTypes_collect
             ,_lhsOkind_errors
             ,_lhsOkindvar
             ,_lhsOksubst
             ,_lhsOlabels_collect
             ,_lhsOmethods_collect
             ,_lhsOpresignatures_collect
             ,_lhsOrawRequests_collect
             ,_lhsOself
             ,_lhsOstaticErrors
             ,_lhsOstructureTypes_collect
             ,_lhsOtypeImps_collect
             )
-- MaybeExports ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      kind_errors          : [GHError]
      self                 : SELF

-}
{-
   local variables for MaybeExports.Just:
      self

-}
{-
   local variables for MaybeExports.Nothing:
      self

-}
-- semantic domain
type T_MaybeExports = (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Strings) ->
                      (FMap Name Kind) ->
                      (FMap Name Kind) ->
                      (Bool) ->
                      (Bool) ->
                      (Maybe Name) ->
                      (KSubst) ->
                      (KSubst) ->
                      (Int) ->
                      (KSubst) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Set Strings) ->
                      (Bool) ->
                      (Declarations) ->
                      (KSubst) ->
                      (Bool) ->
                      (Bool) ->
                      (Int) ->
                      ( (FMap Name Names),(FMap Name Kind),(KSubst),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(MaybeExports))
-- cata
sem_MaybeExports :: (MaybeExports) ->
                    (T_MaybeExports)
sem_MaybeExports ((MaybeExports_Just (_exports))) =
    (sem_MaybeExports_Just ((sem_Exports (_exports))))
sem_MaybeExports ((MaybeExports_Nothing )) =
    (sem_MaybeExports_Nothing )
sem_MaybeExports_Just :: (T_Exports) ->
                         (T_MaybeExports)
sem_MaybeExports_Just (exports_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (MaybeExports)
            _exportsIconstructors_collect :: (FMap Name Names)
            _exportsIgenericAbstractions_collect :: (FMap Name Kind)
            _exportsIkinames :: (KSubst)
            _exportsIkind_errors :: ([GHError])
            _exportsIkindvar :: (Int)
            _exportsIksubst :: (KSubst)
            _exportsIlabels_collect :: (FMap Name Names)
            _exportsImethods_collect :: (FMap Name Names)
            _exportsIself :: (Exports)
            _exportsOclassname :: (Maybe Name)
            _exportsOconstructors_collect :: (FMap Name Names)
            _exportsOconstructors_dist :: (FMap Name Names)
            _exportsOcurrentModule :: (Strings)
            _exportsOgenericAbstractions :: (FMap Name Kind)
            _exportsOgenericAbstractions_collect :: (FMap Name Kind)
            _exportsOghc :: (Bool)
            _exportsOimportedModule :: (Bool)
            _exportsOinstancename :: (Maybe Name)
            _exportsOkinames :: (KSubst)
            _exportsOkinds :: (KSubst)
            _exportsOkindvar :: (Int)
            _exportsOksubst :: (KSubst)
            _exportsOlabels_collect :: (FMap Name Names)
            _exportsOlabels_dist :: (FMap Name Names)
            _exportsOlocal :: (Bool)
            _exportsOmethods_collect :: (FMap Name Names)
            _exportsOmethods_dist :: (FMap Name Names)
            _exportsOmodules :: (Set Strings)
            _exportsOoptimizer :: (Bool)
            _exportsOoptimizerPrelude :: (Declarations)
            _exportsOprekind :: (KSubst)
            _exportsOprelude :: (Bool)
            _exportsOtoplevel :: (Bool)
            _exportsOverbosity :: (Int)
            ( _exportsIconstructors_collect,_exportsIgenericAbstractions_collect,_exportsIkinames,_exportsIkind_errors,_exportsIkindvar,_exportsIksubst,_exportsIlabels_collect,_exportsImethods_collect,_exportsIself) =
                (exports_ (_exportsOclassname)
                          (_exportsOconstructors_collect)
                          (_exportsOconstructors_dist)
                          (_exportsOcurrentModule)
                          (_exportsOgenericAbstractions)
                          (_exportsOgenericAbstractions_collect)
                          (_exportsOghc)
                          (_exportsOimportedModule)
                          (_exportsOinstancename)
                          (_exportsOkinames)
                          (_exportsOkinds)
                          (_exportsOkindvar)
                          (_exportsOksubst)
                          (_exportsOlabels_collect)
                          (_exportsOlabels_dist)
                          (_exportsOlocal)
                          (_exportsOmethods_collect)
                          (_exportsOmethods_dist)
                          (_exportsOmodules)
                          (_exportsOoptimizer)
                          (_exportsOoptimizerPrelude)
                          (_exportsOprekind)
                          (_exportsOprelude)
                          (_exportsOtoplevel)
                          (_exportsOverbosity))
            -- use rule
            (_lhsOkind_errors@_) =
                _exportsIkind_errors
            -- self rule
            (_self@_) =
                MaybeExports_Just _exportsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _exportsIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _exportsIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _exportsIkinames
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _exportsIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _exportsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _exportsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _exportsImethods_collect
            -- copy rule (down)
            (_exportsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_exportsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_exportsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_exportsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_exportsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_exportsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_exportsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_exportsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_exportsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_exportsOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_exportsOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_exportsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_exportsOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_exportsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_exportsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_exportsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_exportsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_exportsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_exportsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_exportsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_exportsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_exportsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_exportsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_exportsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_exportsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_MaybeExports_Nothing :: (T_MaybeExports)
sem_MaybeExports_Nothing  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (MaybeExports)
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- self rule
            (_self@_) =
                MaybeExports_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- MaybeExpression ---------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      exportedStructures   : Set Name
      exportedTypes        : Set Name
      exportedValues       : Set Name
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures
      rawRequests_collect  : [RawRequest]
      structureTypes_collect : FMap Name LambdaType
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      kind_errors          : [GHError]
      self                 : SELF
      staticErrors         : [GHError]

-}
{-
   local variables for MaybeExpression.Just:
      self

-}
{-
   local variables for MaybeExpression.Nothing:
      self

-}
-- semantic domain
type T_MaybeExpression = (Set Name) ->
                         ([Request_BimapImply]) ->
                         (Maybe Name) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (Strings) ->
                         (FMap Name [(Name,Name)]) ->
                         (Set Name) ->
                         (Set Name) ->
                         (Set Name) ->
                         ([Request_FunImply]) ->
                         (FMap Name Kind) ->
                         (FMap Name Kind) ->
                         (Bool) ->
                         (Bool) ->
                         (Maybe Name) ->
                         (KSubst) ->
                         (FMap Name KindIndexedType) ->
                         (FMap Name KindIndexedType) ->
                         (KSubst) ->
                         (Int) ->
                         (KSubst) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (Bool) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (Set Strings) ->
                         (Bool) ->
                         (Declarations) ->
                         (KSubst) ->
                         (Bool) ->
                         (PreSignatures) ->
                         (PreSignatures) ->
                         ([RawRequest]) ->
                         (Signatures) ->
                         (FMap Name LambdaType) ->
                         (Bool) ->
                         ([Request_TypeImply]) ->
                         (Int) ->
                         ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(PreSignatures),([RawRequest]),(MaybeExpression),([GHError]),(FMap Name LambdaType),([Request_TypeImply]))
-- cata
sem_MaybeExpression :: (MaybeExpression) ->
                       (T_MaybeExpression)
sem_MaybeExpression ((MaybeExpression_Just (_expression))) =
    (sem_MaybeExpression_Just ((sem_Expression (_expression))))
sem_MaybeExpression ((MaybeExpression_Nothing )) =
    (sem_MaybeExpression_Nothing )
sem_MaybeExpression_Just :: (T_Expression) ->
                            (T_MaybeExpression)
sem_MaybeExpression_Just (expression_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (MaybeExpression)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _expressionIabstractTypes_collect :: (Set Name)
            _expressionIbimapImps_collect :: ([Request_BimapImply])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdepConstraints_collect :: ([DepConstraint])
            _expressionIfunImps_collect :: ([Request_FunImply])
            _expressionIgenericAbstractions_collect :: (FMap Name Kind)
            _expressionIkinames :: (KSubst)
            _expressionIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionIkind_errors :: ([GHError])
            _expressionIkindvar :: (Int)
            _expressionIksubst :: (KSubst)
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIrawRequests_collect :: ([RawRequest])
            _expressionIself :: (Expression)
            _expressionIstaticErrors :: ([GHError])
            _expressionIstructureTypes_collect :: (FMap Name LambdaType)
            _expressionItypeImps_collect :: ([Request_TypeImply])
            _expressionOabstractTypes_collect :: (Set Name)
            _expressionObimapImps_collect :: ([Request_BimapImply])
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies :: (FMap Name [(Name,Name)])
            _expressionOexportedStructures :: (Set Name)
            _expressionOexportedTypes :: (Set Name)
            _expressionOexportedValues :: (Set Name)
            _expressionOfunImps_collect :: ([Request_FunImply])
            _expressionOgenericAbstractions :: (FMap Name Kind)
            _expressionOgenericAbstractions_collect :: (FMap Name Kind)
            _expressionOghc :: (Bool)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOkinames :: (KSubst)
            _expressionOkindIndexedTypes :: (FMap Name KindIndexedType)
            _expressionOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionOkinds :: (KSubst)
            _expressionOkindvar :: (Int)
            _expressionOksubst :: (KSubst)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmodules :: (Set Strings)
            _expressionOoptimizer :: (Bool)
            _expressionOoptimizerPrelude :: (Declarations)
            _expressionOprekind :: (KSubst)
            _expressionOprelude :: (Bool)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOrawRequests_collect :: ([RawRequest])
            _expressionOsignatures :: (Signatures)
            _expressionOstructureTypes_collect :: (FMap Name LambdaType)
            _expressionOtoplevel :: (Bool)
            _expressionOtypeImps_collect :: ([Request_TypeImply])
            _expressionOverbosity :: (Int)
            ( _expressionIabstractTypes_collect
             ,_expressionIbimapImps_collect
             ,_expressionIconstructors_collect
             ,_expressionIdepConstraints_collect
             ,_expressionIfunImps_collect
             ,_expressionIgenericAbstractions_collect
             ,_expressionIkinames
             ,_expressionIkindIndexedTypes_collect
             ,_expressionIkind_errors
             ,_expressionIkindvar
             ,_expressionIksubst
             ,_expressionIlabels_collect
             ,_expressionImethods_collect
             ,_expressionIpresignatures_collect
             ,_expressionIrawRequests_collect
             ,_expressionIself
             ,_expressionIstaticErrors
             ,_expressionIstructureTypes_collect
             ,_expressionItypeImps_collect
             ) =
                (expression_ (_expressionOabstractTypes_collect)
                             (_expressionObimapImps_collect)
                             (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies)
                             (_expressionOexportedStructures)
                             (_expressionOexportedTypes)
                             (_expressionOexportedValues)
                             (_expressionOfunImps_collect)
                             (_expressionOgenericAbstractions)
                             (_expressionOgenericAbstractions_collect)
                             (_expressionOghc)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOkinames)
                             (_expressionOkindIndexedTypes)
                             (_expressionOkindIndexedTypes_collect)
                             (_expressionOkinds)
                             (_expressionOkindvar)
                             (_expressionOksubst)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmodules)
                             (_expressionOoptimizer)
                             (_expressionOoptimizerPrelude)
                             (_expressionOprekind)
                             (_expressionOprelude)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOrawRequests_collect)
                             (_expressionOsignatures)
                             (_expressionOstructureTypes_collect)
                             (_expressionOtoplevel)
                             (_expressionOtypeImps_collect)
                             (_expressionOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _expressionIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _expressionIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _expressionIstaticErrors
            -- self rule
            (_self@_) =
                MaybeExpression_Just _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _expressionIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _expressionIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _expressionIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _expressionIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _expressionIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _expressionIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _expressionIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _expressionIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _expressionIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _expressionIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _expressionItypeImps_collect
            -- copy rule (down)
            (_expressionOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_expressionObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_expressionOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_expressionOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_expressionOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_expressionOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_expressionOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_expressionOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_expressionOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_expressionOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_expressionOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_expressionOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_expressionOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_expressionOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_expressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_expressionOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_expressionOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_expressionOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_expressionOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_expressionOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_MaybeExpression_Nothing :: (T_MaybeExpression)
sem_MaybeExpression_Nothing  =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (MaybeExpression)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                MaybeExpression_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
-- MaybeImportSpecification ------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      finalImports         : MaybeImportSpecification
      kind_errors          : [GHError]
      self                 : SELF

-}
{-
   local variables for MaybeImportSpecification.Just:
      self

-}
{-
   local variables for MaybeImportSpecification.Nothing:
      self

-}
-- semantic domain
type T_MaybeImportSpecification = (Maybe Name) ->
                                  (FMap Name Names) ->
                                  (FMap Name Names) ->
                                  (Strings) ->
                                  (FMap Name Kind) ->
                                  (FMap Name Kind) ->
                                  (Bool) ->
                                  (Bool) ->
                                  (Maybe Name) ->
                                  (KSubst) ->
                                  (FMap Name KindIndexedType) ->
                                  (FMap Name KindIndexedType) ->
                                  (KSubst) ->
                                  (Int) ->
                                  (KSubst) ->
                                  (FMap Name Names) ->
                                  (FMap Name Names) ->
                                  (Bool) ->
                                  (FMap Name Names) ->
                                  (FMap Name Names) ->
                                  (Set Strings) ->
                                  (Bool) ->
                                  (Declarations) ->
                                  (KSubst) ->
                                  (Bool) ->
                                  (PreSignatures) ->
                                  (PreSignatures) ->
                                  (Signatures) ->
                                  (Bool) ->
                                  (Int) ->
                                  ( (FMap Name Names),(MaybeImportSpecification),(FMap Name Kind),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(PreSignatures),(MaybeImportSpecification))
-- cata
sem_MaybeImportSpecification :: (MaybeImportSpecification) ->
                                (T_MaybeImportSpecification)
sem_MaybeImportSpecification ((MaybeImportSpecification_Just (_importspecification))) =
    (sem_MaybeImportSpecification_Just ((sem_ImportSpecification (_importspecification))))
sem_MaybeImportSpecification ((MaybeImportSpecification_Nothing )) =
    (sem_MaybeImportSpecification_Nothing )
sem_MaybeImportSpecification_Just :: (T_ImportSpecification) ->
                                     (T_MaybeImportSpecification)
sem_MaybeImportSpecification_Just (importspecification_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOfinalImports :: (MaybeImportSpecification)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (MaybeImportSpecification)
            _importspecificationIconstructors_collect :: (FMap Name Names)
            _importspecificationIfinalImports :: (ImportSpecification)
            _importspecificationIgenericAbstractions_collect :: (FMap Name Kind)
            _importspecificationIkinames :: (KSubst)
            _importspecificationIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _importspecificationIkind_errors :: ([GHError])
            _importspecificationIkindvar :: (Int)
            _importspecificationIksubst :: (KSubst)
            _importspecificationIlabels_collect :: (FMap Name Names)
            _importspecificationImethods_collect :: (FMap Name Names)
            _importspecificationIpresignatures_collect :: (PreSignatures)
            _importspecificationIself :: (ImportSpecification)
            _importspecificationOclassname :: (Maybe Name)
            _importspecificationOconstructors_collect :: (FMap Name Names)
            _importspecificationOconstructors_dist :: (FMap Name Names)
            _importspecificationOcurrentModule :: (Strings)
            _importspecificationOgenericAbstractions :: (FMap Name Kind)
            _importspecificationOgenericAbstractions_collect :: (FMap Name Kind)
            _importspecificationOghc :: (Bool)
            _importspecificationOimportedModule :: (Bool)
            _importspecificationOinstancename :: (Maybe Name)
            _importspecificationOkinames :: (KSubst)
            _importspecificationOkindIndexedTypes :: (FMap Name KindIndexedType)
            _importspecificationOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _importspecificationOkinds :: (KSubst)
            _importspecificationOkindvar :: (Int)
            _importspecificationOksubst :: (KSubst)
            _importspecificationOlabels_collect :: (FMap Name Names)
            _importspecificationOlabels_dist :: (FMap Name Names)
            _importspecificationOlocal :: (Bool)
            _importspecificationOmethods_collect :: (FMap Name Names)
            _importspecificationOmethods_dist :: (FMap Name Names)
            _importspecificationOmodules :: (Set Strings)
            _importspecificationOoptimizer :: (Bool)
            _importspecificationOoptimizerPrelude :: (Declarations)
            _importspecificationOprekind :: (KSubst)
            _importspecificationOprelude :: (Bool)
            _importspecificationOpresignatures :: (PreSignatures)
            _importspecificationOpresignatures_collect :: (PreSignatures)
            _importspecificationOsignatures :: (Signatures)
            _importspecificationOtoplevel :: (Bool)
            _importspecificationOverbosity :: (Int)
            ( _importspecificationIconstructors_collect,_importspecificationIfinalImports,_importspecificationIgenericAbstractions_collect,_importspecificationIkinames,_importspecificationIkindIndexedTypes_collect,_importspecificationIkind_errors,_importspecificationIkindvar,_importspecificationIksubst,_importspecificationIlabels_collect,_importspecificationImethods_collect,_importspecificationIpresignatures_collect,_importspecificationIself) =
                (importspecification_ (_importspecificationOclassname)
                                      (_importspecificationOconstructors_collect)
                                      (_importspecificationOconstructors_dist)
                                      (_importspecificationOcurrentModule)
                                      (_importspecificationOgenericAbstractions)
                                      (_importspecificationOgenericAbstractions_collect)
                                      (_importspecificationOghc)
                                      (_importspecificationOimportedModule)
                                      (_importspecificationOinstancename)
                                      (_importspecificationOkinames)
                                      (_importspecificationOkindIndexedTypes)
                                      (_importspecificationOkindIndexedTypes_collect)
                                      (_importspecificationOkinds)
                                      (_importspecificationOkindvar)
                                      (_importspecificationOksubst)
                                      (_importspecificationOlabels_collect)
                                      (_importspecificationOlabels_dist)
                                      (_importspecificationOlocal)
                                      (_importspecificationOmethods_collect)
                                      (_importspecificationOmethods_dist)
                                      (_importspecificationOmodules)
                                      (_importspecificationOoptimizer)
                                      (_importspecificationOoptimizerPrelude)
                                      (_importspecificationOprekind)
                                      (_importspecificationOprelude)
                                      (_importspecificationOpresignatures)
                                      (_importspecificationOpresignatures_collect)
                                      (_importspecificationOsignatures)
                                      (_importspecificationOtoplevel)
                                      (_importspecificationOverbosity))
            -- "./Exports.inc.lag"(line 222, column 9)
            (_lhsOfinalImports@_) =
                MaybeImportSpecification_Just
                  _importspecificationIfinalImports
            -- use rule
            (_lhsOkind_errors@_) =
                _importspecificationIkind_errors
            -- self rule
            (_self@_) =
                MaybeImportSpecification_Just _importspecificationIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _importspecificationIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _importspecificationIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _importspecificationIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _importspecificationIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _importspecificationIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _importspecificationIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _importspecificationIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _importspecificationImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _importspecificationIpresignatures_collect
            -- copy rule (down)
            (_importspecificationOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_importspecificationOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_importspecificationOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_importspecificationOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_importspecificationOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_importspecificationOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_importspecificationOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_importspecificationOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_importspecificationOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_importspecificationOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_importspecificationOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_importspecificationOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_importspecificationOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_importspecificationOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_importspecificationOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_importspecificationOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_importspecificationOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_importspecificationOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_importspecificationOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_importspecificationOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_importspecificationOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_importspecificationOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_importspecificationOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_importspecificationOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_importspecificationOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_importspecificationOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_importspecificationOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_importspecificationOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_importspecificationOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_importspecificationOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOfinalImports,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_MaybeImportSpecification_Nothing :: (T_MaybeImportSpecification)
sem_MaybeImportSpecification_Nothing  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOfinalImports :: (MaybeImportSpecification)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (MaybeImportSpecification)
            -- "./Exports.inc.lag"(line 225, column 9)
            (_lhsOfinalImports@_) =
                MaybeImportSpecification_Nothing
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- self rule
            (_self@_) =
                MaybeImportSpecification_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
        in  ( _lhsOconstructors_collect,_lhsOfinalImports,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- MaybeInt ----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for MaybeInt.Just:
      self

-}
{-
   local variables for MaybeInt.Nothing:
      self

-}
-- semantic domain
type T_MaybeInt = (Maybe Name) ->
                  (FMap Name Names) ->
                  (FMap Name Names) ->
                  (Strings) ->
                  (FMap Name Kind) ->
                  (FMap Name Kind) ->
                  (Bool) ->
                  (Bool) ->
                  (Maybe Name) ->
                  (FMap Name Names) ->
                  (FMap Name Names) ->
                  (Bool) ->
                  (FMap Name Names) ->
                  (FMap Name Names) ->
                  (Set Strings) ->
                  (Bool) ->
                  (Declarations) ->
                  (Bool) ->
                  (Bool) ->
                  (Int) ->
                  ( (FMap Name Names),(FMap Name Kind),(FMap Name Names),(FMap Name Names),(MaybeInt))
-- cata
sem_MaybeInt :: (MaybeInt) ->
                (T_MaybeInt)
sem_MaybeInt ((MaybeInt_Just (_int))) =
    (sem_MaybeInt_Just (_int))
sem_MaybeInt ((MaybeInt_Nothing )) =
    (sem_MaybeInt_Nothing )
sem_MaybeInt_Just :: (Int) ->
                     (T_MaybeInt)
sem_MaybeInt_Just (int_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (MaybeInt)
            -- self rule
            (_self@_) =
                MaybeInt_Just int_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_MaybeInt_Nothing :: (T_MaybeInt)
sem_MaybeInt_Nothing  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (MaybeInt)
            -- self rule
            (_self@_) =
                MaybeInt_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- MaybeKind ---------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      inferkind            : Kind
      kind_errors          : [GHError]
      self                 : SELF

-}
{-
   local variables for MaybeKind.Just:
      self

-}
{-
   local variables for MaybeKind.Nothing:
      kvar
      kindvar
      self

-}
-- semantic domain
type T_MaybeKind = (Maybe Name) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (Strings) ->
                   (FMap Name Kind) ->
                   (FMap Name Kind) ->
                   (Bool) ->
                   (Bool) ->
                   (Maybe Name) ->
                   (KSubst) ->
                   (KSubst) ->
                   (Int) ->
                   (KSubst) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (Bool) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (Set Strings) ->
                   (Bool) ->
                   (Declarations) ->
                   (KSubst) ->
                   (Bool) ->
                   (Bool) ->
                   (Int) ->
                   ( (FMap Name Names),(FMap Name Kind),(Kind),(KSubst),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(MaybeKind))
-- cata
sem_MaybeKind :: (MaybeKind) ->
                 (T_MaybeKind)
sem_MaybeKind ((MaybeKind_Just (_kind))) =
    (sem_MaybeKind_Just ((sem_Kind (_kind))))
sem_MaybeKind ((MaybeKind_Nothing )) =
    (sem_MaybeKind_Nothing )
sem_MaybeKind_Just :: (T_Kind) ->
                      (T_MaybeKind)
sem_MaybeKind_Just (kind_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOinferkind :: (Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (MaybeKind)
            _kindIconstructors_collect :: (FMap Name Names)
            _kindIgenericAbstractions_collect :: (FMap Name Kind)
            _kindIkinames :: (KSubst)
            _kindIkind_errors :: ([GHError])
            _kindIkindvar :: (Int)
            _kindIksubst :: (KSubst)
            _kindIlabels_collect :: (FMap Name Names)
            _kindImethods_collect :: (FMap Name Names)
            _kindIself :: (Kind)
            _kindOclassname :: (Maybe Name)
            _kindOconstructors_collect :: (FMap Name Names)
            _kindOconstructors_dist :: (FMap Name Names)
            _kindOcurrentModule :: (Strings)
            _kindOgenericAbstractions :: (FMap Name Kind)
            _kindOgenericAbstractions_collect :: (FMap Name Kind)
            _kindOghc :: (Bool)
            _kindOimportedModule :: (Bool)
            _kindOinstancename :: (Maybe Name)
            _kindOkinames :: (KSubst)
            _kindOkinds :: (KSubst)
            _kindOkindvar :: (Int)
            _kindOksubst :: (KSubst)
            _kindOlabels_collect :: (FMap Name Names)
            _kindOlabels_dist :: (FMap Name Names)
            _kindOlocal :: (Bool)
            _kindOmethods_collect :: (FMap Name Names)
            _kindOmethods_dist :: (FMap Name Names)
            _kindOmodules :: (Set Strings)
            _kindOoptimizer :: (Bool)
            _kindOoptimizerPrelude :: (Declarations)
            _kindOprekind :: (KSubst)
            _kindOprelude :: (Bool)
            _kindOtoplevel :: (Bool)
            _kindOverbosity :: (Int)
            ( _kindIconstructors_collect,_kindIgenericAbstractions_collect,_kindIkinames,_kindIkind_errors,_kindIkindvar,_kindIksubst,_kindIlabels_collect,_kindImethods_collect,_kindIself) =
                (kind_ (_kindOclassname)
                       (_kindOconstructors_collect)
                       (_kindOconstructors_dist)
                       (_kindOcurrentModule)
                       (_kindOgenericAbstractions)
                       (_kindOgenericAbstractions_collect)
                       (_kindOghc)
                       (_kindOimportedModule)
                       (_kindOinstancename)
                       (_kindOkinames)
                       (_kindOkinds)
                       (_kindOkindvar)
                       (_kindOksubst)
                       (_kindOlabels_collect)
                       (_kindOlabels_dist)
                       (_kindOlocal)
                       (_kindOmethods_collect)
                       (_kindOmethods_dist)
                       (_kindOmodules)
                       (_kindOoptimizer)
                       (_kindOoptimizerPrelude)
                       (_kindOprekind)
                       (_kindOprelude)
                       (_kindOtoplevel)
                       (_kindOverbosity))
            -- "./Kind.inc.lag"(line 338, column 9)
            (_lhsOinferkind@_) =
                _kindIself
            -- use rule
            (_lhsOkind_errors@_) =
                _kindIkind_errors
            -- self rule
            (_self@_) =
                MaybeKind_Just _kindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _kindIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _kindIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _kindIkinames
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _kindIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _kindIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _kindIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _kindImethods_collect
            -- copy rule (down)
            (_kindOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_kindOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_kindOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_kindOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_kindOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_kindOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_kindOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_kindOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_kindOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_kindOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_kindOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_kindOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_kindOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_kindOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_kindOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_kindOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_kindOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_kindOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_kindOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_kindOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_kindOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_kindOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_kindOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_kindOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_kindOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOinferkind,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_MaybeKind_Nothing :: (T_MaybeKind)
sem_MaybeKind_Nothing  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOinferkind :: (Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (MaybeKind)
            -- "./Kind.inc.lag"(line 266, column 9)
            (_kvar@_) =
                mkKindVar' _kindvar
            -- "./Kind.inc.lag"(line 265, column 9)
            (_kindvar@_) =
                _lhsIkindvar + 1
            -- "./Kind.inc.lag"(line 336, column 9)
            (_lhsOinferkind@_) =
                _kvar
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- self rule
            (_self@_) =
                MaybeKind_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _kindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOinferkind,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- MaybeModuleName ---------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for MaybeModuleName.Just:
      self

-}
{-
   local variables for MaybeModuleName.Nothing:
      self

-}
-- semantic domain
type T_MaybeModuleName = (Maybe Name) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (Strings) ->
                         (FMap Name Kind) ->
                         (FMap Name Kind) ->
                         (Bool) ->
                         (Bool) ->
                         (Maybe Name) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (Bool) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (Set Strings) ->
                         (Bool) ->
                         (Declarations) ->
                         (Bool) ->
                         (Bool) ->
                         (Int) ->
                         ( (FMap Name Names),(FMap Name Kind),(FMap Name Names),(FMap Name Names),(MaybeModuleName))
-- cata
sem_MaybeModuleName :: (MaybeModuleName) ->
                       (T_MaybeModuleName)
sem_MaybeModuleName ((MaybeModuleName_Just (_modulename))) =
    (sem_MaybeModuleName_Just ((sem_ModuleName (_modulename))))
sem_MaybeModuleName ((MaybeModuleName_Nothing )) =
    (sem_MaybeModuleName_Nothing )
sem_MaybeModuleName_Just :: (T_ModuleName) ->
                            (T_MaybeModuleName)
sem_MaybeModuleName_Just (modulename_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (MaybeModuleName)
            _modulenameIconstructors_collect :: (FMap Name Names)
            _modulenameIgenericAbstractions_collect :: (FMap Name Kind)
            _modulenameIlabels_collect :: (FMap Name Names)
            _modulenameImethods_collect :: (FMap Name Names)
            _modulenameIself :: (ModuleName)
            _modulenameOclassname :: (Maybe Name)
            _modulenameOconstructors_collect :: (FMap Name Names)
            _modulenameOconstructors_dist :: (FMap Name Names)
            _modulenameOcurrentModule :: (Strings)
            _modulenameOgenericAbstractions :: (FMap Name Kind)
            _modulenameOgenericAbstractions_collect :: (FMap Name Kind)
            _modulenameOghc :: (Bool)
            _modulenameOimportedModule :: (Bool)
            _modulenameOinstancename :: (Maybe Name)
            _modulenameOlabels_collect :: (FMap Name Names)
            _modulenameOlabels_dist :: (FMap Name Names)
            _modulenameOlocal :: (Bool)
            _modulenameOmethods_collect :: (FMap Name Names)
            _modulenameOmethods_dist :: (FMap Name Names)
            _modulenameOmodules :: (Set Strings)
            _modulenameOoptimizer :: (Bool)
            _modulenameOoptimizerPrelude :: (Declarations)
            _modulenameOprelude :: (Bool)
            _modulenameOtoplevel :: (Bool)
            _modulenameOverbosity :: (Int)
            ( _modulenameIconstructors_collect,_modulenameIgenericAbstractions_collect,_modulenameIlabels_collect,_modulenameImethods_collect,_modulenameIself) =
                (modulename_ (_modulenameOclassname)
                             (_modulenameOconstructors_collect)
                             (_modulenameOconstructors_dist)
                             (_modulenameOcurrentModule)
                             (_modulenameOgenericAbstractions)
                             (_modulenameOgenericAbstractions_collect)
                             (_modulenameOghc)
                             (_modulenameOimportedModule)
                             (_modulenameOinstancename)
                             (_modulenameOlabels_collect)
                             (_modulenameOlabels_dist)
                             (_modulenameOlocal)
                             (_modulenameOmethods_collect)
                             (_modulenameOmethods_dist)
                             (_modulenameOmodules)
                             (_modulenameOoptimizer)
                             (_modulenameOoptimizerPrelude)
                             (_modulenameOprelude)
                             (_modulenameOtoplevel)
                             (_modulenameOverbosity))
            -- self rule
            (_self@_) =
                MaybeModuleName_Just _modulenameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _modulenameIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _modulenameIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _modulenameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _modulenameImethods_collect
            -- copy rule (down)
            (_modulenameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_modulenameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_modulenameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_modulenameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_modulenameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_modulenameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_modulenameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_modulenameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_modulenameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_modulenameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_modulenameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_modulenameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_modulenameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_modulenameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_modulenameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_modulenameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_modulenameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_modulenameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_modulenameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_modulenameOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_MaybeModuleName_Nothing :: (T_MaybeModuleName)
sem_MaybeModuleName_Nothing  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (MaybeModuleName)
            -- self rule
            (_self@_) =
                MaybeModuleName_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- MaybeName ---------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for MaybeName.Just:
      self

-}
{-
   local variables for MaybeName.Nothing:
      self

-}
-- semantic domain
type T_MaybeName = (Maybe Name) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (Strings) ->
                   (FMap Name Kind) ->
                   (FMap Name Kind) ->
                   (Bool) ->
                   (Bool) ->
                   (Maybe Name) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (Bool) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (Set Strings) ->
                   (Bool) ->
                   (Declarations) ->
                   (Bool) ->
                   (Bool) ->
                   (Int) ->
                   ( (FMap Name Names),(FMap Name Kind),(FMap Name Names),(FMap Name Names),(MaybeName))
-- cata
sem_MaybeName :: (MaybeName) ->
                 (T_MaybeName)
sem_MaybeName ((MaybeName_Just (_name))) =
    (sem_MaybeName_Just ((sem_Name (_name))))
sem_MaybeName ((MaybeName_Nothing )) =
    (sem_MaybeName_Nothing )
sem_MaybeName_Just :: (T_Name) ->
                      (T_MaybeName)
sem_MaybeName_Just (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (MaybeName)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            -- self rule
            (_self@_) =
                MaybeName_Just _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_MaybeName_Nothing :: (T_MaybeName)
sem_MaybeName_Nothing  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (MaybeName)
            -- self rule
            (_self@_) =
                MaybeName_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- MaybeNames --------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      kind_errors          : [GHError]
      self                 : SELF

-}
{-
   local variables for MaybeNames.Just:
      self

-}
{-
   local variables for MaybeNames.Nothing:
      self

-}
-- semantic domain
type T_MaybeNames = (Maybe Name) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Strings) ->
                    (FMap Name Kind) ->
                    (FMap Name Kind) ->
                    (Bool) ->
                    (Bool) ->
                    (Maybe Name) ->
                    (KSubst) ->
                    (KSubst) ->
                    (Int) ->
                    (KSubst) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Bool) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Set Strings) ->
                    (Bool) ->
                    (Declarations) ->
                    (KSubst) ->
                    (Bool) ->
                    (Bool) ->
                    (Int) ->
                    ( (FMap Name Names),(FMap Name Kind),(KSubst),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(MaybeNames))
-- cata
sem_MaybeNames :: (MaybeNames) ->
                  (T_MaybeNames)
sem_MaybeNames ((MaybeNames_Just (_names))) =
    (sem_MaybeNames_Just ((sem_Names (_names))))
sem_MaybeNames ((MaybeNames_Nothing )) =
    (sem_MaybeNames_Nothing )
sem_MaybeNames_Just :: (T_Names) ->
                       (T_MaybeNames)
sem_MaybeNames_Just (names_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (MaybeNames)
            _namesIconstructors_collect :: (FMap Name Names)
            _namesIgenericAbstractions_collect :: (FMap Name Kind)
            _namesIinferkind :: (Kind)
            _namesIkinames :: (KSubst)
            _namesIkind_errors :: ([GHError])
            _namesIkindvar :: (Int)
            _namesIksubst :: (KSubst)
            _namesIlabels_collect :: (FMap Name Names)
            _namesImethods_collect :: (FMap Name Names)
            _namesIself :: (Names)
            _namesOclassname :: (Maybe Name)
            _namesOconstructors_collect :: (FMap Name Names)
            _namesOconstructors_dist :: (FMap Name Names)
            _namesOcurrentModule :: (Strings)
            _namesOgenericAbstractions :: (FMap Name Kind)
            _namesOgenericAbstractions_collect :: (FMap Name Kind)
            _namesOghc :: (Bool)
            _namesOimportedModule :: (Bool)
            _namesOinstancename :: (Maybe Name)
            _namesOkinames :: (KSubst)
            _namesOkinds :: (KSubst)
            _namesOkindvar :: (Int)
            _namesOksubst :: (KSubst)
            _namesOlabels_collect :: (FMap Name Names)
            _namesOlabels_dist :: (FMap Name Names)
            _namesOlocal :: (Bool)
            _namesOmethods_collect :: (FMap Name Names)
            _namesOmethods_dist :: (FMap Name Names)
            _namesOmodules :: (Set Strings)
            _namesOoptimizer :: (Bool)
            _namesOoptimizerPrelude :: (Declarations)
            _namesOprekind :: (KSubst)
            _namesOprelude :: (Bool)
            _namesOtoplevel :: (Bool)
            _namesOverbosity :: (Int)
            ( _namesIconstructors_collect,_namesIgenericAbstractions_collect,_namesIinferkind,_namesIkinames,_namesIkind_errors,_namesIkindvar,_namesIksubst,_namesIlabels_collect,_namesImethods_collect,_namesIself) =
                (names_ (_namesOclassname)
                        (_namesOconstructors_collect)
                        (_namesOconstructors_dist)
                        (_namesOcurrentModule)
                        (_namesOgenericAbstractions)
                        (_namesOgenericAbstractions_collect)
                        (_namesOghc)
                        (_namesOimportedModule)
                        (_namesOinstancename)
                        (_namesOkinames)
                        (_namesOkinds)
                        (_namesOkindvar)
                        (_namesOksubst)
                        (_namesOlabels_collect)
                        (_namesOlabels_dist)
                        (_namesOlocal)
                        (_namesOmethods_collect)
                        (_namesOmethods_dist)
                        (_namesOmodules)
                        (_namesOoptimizer)
                        (_namesOoptimizerPrelude)
                        (_namesOprekind)
                        (_namesOprelude)
                        (_namesOtoplevel)
                        (_namesOverbosity))
            -- use rule
            (_lhsOkind_errors@_) =
                _namesIkind_errors
            -- self rule
            (_self@_) =
                MaybeNames_Just _namesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _namesIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _namesIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _namesIkinames
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _namesIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _namesIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _namesIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _namesImethods_collect
            -- copy rule (down)
            (_namesOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_namesOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_namesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_namesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_namesOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_namesOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_namesOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_namesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_namesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_namesOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_namesOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_namesOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_namesOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_namesOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_namesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_namesOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_namesOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_namesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_namesOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_namesOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_namesOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_namesOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_namesOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_namesOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_namesOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_MaybeNames_Nothing :: (T_MaybeNames)
sem_MaybeNames_Nothing  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (MaybeNames)
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- self rule
            (_self@_) =
                MaybeNames_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- MaybeReassignments ------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for MaybeReassignments.Just:
      self

-}
{-
   local variables for MaybeReassignments.Nothing:
      self

-}
-- semantic domain
type T_MaybeReassignments = (Maybe Name) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Strings) ->
                            (FMap Name Kind) ->
                            (FMap Name Kind) ->
                            (Bool) ->
                            (Bool) ->
                            (Maybe Name) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Bool) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Set Strings) ->
                            (Bool) ->
                            (Declarations) ->
                            (Bool) ->
                            (Bool) ->
                            (Int) ->
                            ( (FMap Name Names),(FMap Name Kind),(FMap Name Names),(FMap Name Names),(MaybeReassignments))
-- cata
sem_MaybeReassignments :: (MaybeReassignments) ->
                          (T_MaybeReassignments)
sem_MaybeReassignments ((MaybeReassignments_Just (_reassignments))) =
    (sem_MaybeReassignments_Just ((sem_Reassignments (_reassignments))))
sem_MaybeReassignments ((MaybeReassignments_Nothing )) =
    (sem_MaybeReassignments_Nothing )
sem_MaybeReassignments_Just :: (T_Reassignments) ->
                               (T_MaybeReassignments)
sem_MaybeReassignments_Just (reassignments_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (MaybeReassignments)
            _reassignmentsIconstructors_collect :: (FMap Name Names)
            _reassignmentsIgenericAbstractions_collect :: (FMap Name Kind)
            _reassignmentsIlabels_collect :: (FMap Name Names)
            _reassignmentsImethods_collect :: (FMap Name Names)
            _reassignmentsIself :: (Reassignments)
            _reassignmentsOclassname :: (Maybe Name)
            _reassignmentsOconstructors_collect :: (FMap Name Names)
            _reassignmentsOconstructors_dist :: (FMap Name Names)
            _reassignmentsOcurrentModule :: (Strings)
            _reassignmentsOgenericAbstractions :: (FMap Name Kind)
            _reassignmentsOgenericAbstractions_collect :: (FMap Name Kind)
            _reassignmentsOghc :: (Bool)
            _reassignmentsOimportedModule :: (Bool)
            _reassignmentsOinstancename :: (Maybe Name)
            _reassignmentsOlabels_collect :: (FMap Name Names)
            _reassignmentsOlabels_dist :: (FMap Name Names)
            _reassignmentsOlocal :: (Bool)
            _reassignmentsOmethods_collect :: (FMap Name Names)
            _reassignmentsOmethods_dist :: (FMap Name Names)
            _reassignmentsOmodules :: (Set Strings)
            _reassignmentsOoptimizer :: (Bool)
            _reassignmentsOoptimizerPrelude :: (Declarations)
            _reassignmentsOprelude :: (Bool)
            _reassignmentsOtoplevel :: (Bool)
            _reassignmentsOverbosity :: (Int)
            ( _reassignmentsIconstructors_collect,_reassignmentsIgenericAbstractions_collect,_reassignmentsIlabels_collect,_reassignmentsImethods_collect,_reassignmentsIself) =
                (reassignments_ (_reassignmentsOclassname)
                                (_reassignmentsOconstructors_collect)
                                (_reassignmentsOconstructors_dist)
                                (_reassignmentsOcurrentModule)
                                (_reassignmentsOgenericAbstractions)
                                (_reassignmentsOgenericAbstractions_collect)
                                (_reassignmentsOghc)
                                (_reassignmentsOimportedModule)
                                (_reassignmentsOinstancename)
                                (_reassignmentsOlabels_collect)
                                (_reassignmentsOlabels_dist)
                                (_reassignmentsOlocal)
                                (_reassignmentsOmethods_collect)
                                (_reassignmentsOmethods_dist)
                                (_reassignmentsOmodules)
                                (_reassignmentsOoptimizer)
                                (_reassignmentsOoptimizerPrelude)
                                (_reassignmentsOprelude)
                                (_reassignmentsOtoplevel)
                                (_reassignmentsOverbosity))
            -- self rule
            (_self@_) =
                MaybeReassignments_Just _reassignmentsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _reassignmentsIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _reassignmentsIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _reassignmentsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _reassignmentsImethods_collect
            -- copy rule (down)
            (_reassignmentsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_reassignmentsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_reassignmentsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_reassignmentsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_reassignmentsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_reassignmentsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_reassignmentsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_reassignmentsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_reassignmentsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_reassignmentsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_reassignmentsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_reassignmentsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_reassignmentsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_reassignmentsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_reassignmentsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_reassignmentsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_reassignmentsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_reassignmentsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_reassignmentsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_reassignmentsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_MaybeReassignments_Nothing :: (T_MaybeReassignments)
sem_MaybeReassignments_Nothing  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (MaybeReassignments)
            -- self rule
            (_self@_) =
                MaybeReassignments_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- Module ------------------------------------------------------
{-
   inherited attributes:
      abstractTypes        : Set Name
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      dependencies         : FMap Name [(Name,Name)]
      exportedStructures   : Set Name
      exportedTypes        : Set Name
      exportedValues       : Set Name
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      output               : [PP.Doc]
      presignatures_collect : PreSignatures
      rawRequests_collect  : [RawRequest]
      structureTypes_collect : FMap Name LambdaType
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      compiledModule       : Strings
      depConstraints_collect : [DepConstraint]
      kind_errors          : [GHError]
      outputi              : [PP.Doc]
      self                 : SELF
      staticErrors         : [GHError]

-}
{-
   local variables for Module.Module:
      local
      compiledModule
      currentModule
      moduleName
      moduleName_
      finalExports
      self

-}
-- semantic domain
type T_Module = (Set Name) ->
                (Set Name) ->
                ([Request_BimapImply]) ->
                (Maybe Name) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (FMap Name [(Name,Name)]) ->
                (Set Name) ->
                (Set Name) ->
                (Set Name) ->
                ([Request_FunImply]) ->
                (FMap Name Kind) ->
                (FMap Name Kind) ->
                (Bool) ->
                (Bool) ->
                (Maybe Name) ->
                (KSubst) ->
                (FMap Name KindIndexedType) ->
                (FMap Name KindIndexedType) ->
                (KSubst) ->
                (Int) ->
                (KSubst) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (Set Strings) ->
                (Bool) ->
                (Declarations) ->
                ([PP.Doc]) ->
                (KSubst) ->
                (Bool) ->
                (PreSignatures) ->
                (PreSignatures) ->
                ([RawRequest]) ->
                (Signatures) ->
                (FMap Name LambdaType) ->
                (Bool) ->
                ([Request_TypeImply]) ->
                (Int) ->
                ( (Set Name),([Request_BimapImply]),(Strings),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),([PP.Doc]),([PP.Doc]),(PreSignatures),([RawRequest]),(Module),([GHError]),(FMap Name LambdaType),([Request_TypeImply]))
-- cata
sem_Module :: (Module) ->
              (T_Module)
sem_Module ((Module_Module (_range) (_name) (_exports) (_body))) =
    (sem_Module_Module ((sem_Range (_range))) ((sem_MaybeModuleName (_name))) ((sem_MaybeExports (_exports))) ((sem_Body (_body))))
sem_Module_Module :: (T_Range) ->
                     (T_MaybeModuleName) ->
                     (T_MaybeExports) ->
                     (T_Body) ->
                     (T_Module)
sem_Module_Module (range_) (name_) (exports_) (body_) =
    \ _lhsIabstractTypes
      _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIoutput
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOcompiledModule :: (Strings)
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: ([PP.Doc])
            _lhsOoutputi :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Module)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (MaybeModuleName)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _exportsIconstructors_collect :: (FMap Name Names)
            _exportsIgenericAbstractions_collect :: (FMap Name Kind)
            _exportsIkinames :: (KSubst)
            _exportsIkind_errors :: ([GHError])
            _exportsIkindvar :: (Int)
            _exportsIksubst :: (KSubst)
            _exportsIlabels_collect :: (FMap Name Names)
            _exportsImethods_collect :: (FMap Name Names)
            _exportsIself :: (MaybeExports)
            _exportsOclassname :: (Maybe Name)
            _exportsOconstructors_collect :: (FMap Name Names)
            _exportsOconstructors_dist :: (FMap Name Names)
            _exportsOcurrentModule :: (Strings)
            _exportsOgenericAbstractions :: (FMap Name Kind)
            _exportsOgenericAbstractions_collect :: (FMap Name Kind)
            _exportsOghc :: (Bool)
            _exportsOimportedModule :: (Bool)
            _exportsOinstancename :: (Maybe Name)
            _exportsOkinames :: (KSubst)
            _exportsOkinds :: (KSubst)
            _exportsOkindvar :: (Int)
            _exportsOksubst :: (KSubst)
            _exportsOlabels_collect :: (FMap Name Names)
            _exportsOlabels_dist :: (FMap Name Names)
            _exportsOlocal :: (Bool)
            _exportsOmethods_collect :: (FMap Name Names)
            _exportsOmethods_dist :: (FMap Name Names)
            _exportsOmodules :: (Set Strings)
            _exportsOoptimizer :: (Bool)
            _exportsOoptimizerPrelude :: (Declarations)
            _exportsOprekind :: (KSubst)
            _exportsOprelude :: (Bool)
            _exportsOtoplevel :: (Bool)
            _exportsOverbosity :: (Int)
            _bodyIabstractTypes_collect :: (Set Name)
            _bodyIbimapImps_collect :: ([Request_BimapImply])
            _bodyIconstructors_collect :: (FMap Name Names)
            _bodyIdepConstraints_collect :: ([DepConstraint])
            _bodyIfunImps_collect :: ([Request_FunImply])
            _bodyIgenericAbstractions_collect :: (FMap Name Kind)
            _bodyIkinames :: (KSubst)
            _bodyIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _bodyIkind_errors :: ([GHError])
            _bodyIkindvar :: (Int)
            _bodyIksubst :: (KSubst)
            _bodyIlabels_collect :: (FMap Name Names)
            _bodyImethods_collect :: (FMap Name Names)
            _bodyIoutput :: ([PP.Doc])
            _bodyIoutputi :: ([PP.Doc])
            _bodyIpresignatures_collect :: (PreSignatures)
            _bodyIrawRequests_collect :: ([RawRequest])
            _bodyIself :: (Body)
            _bodyIstaticErrors :: ([GHError])
            _bodyIstructureTypes_collect :: (FMap Name LambdaType)
            _bodyItypeImps_collect :: ([Request_TypeImply])
            _bodyOabstractTypes_collect :: (Set Name)
            _bodyObimapImps_collect :: ([Request_BimapImply])
            _bodyOclassname :: (Maybe Name)
            _bodyOconstructors_collect :: (FMap Name Names)
            _bodyOconstructors_dist :: (FMap Name Names)
            _bodyOcurrentModule :: (Strings)
            _bodyOdependencies :: (FMap Name [(Name,Name)])
            _bodyOexportedStructures :: (Set Name)
            _bodyOexportedTypes :: (Set Name)
            _bodyOexportedValues :: (Set Name)
            _bodyOfunImps_collect :: ([Request_FunImply])
            _bodyOgenericAbstractions :: (FMap Name Kind)
            _bodyOgenericAbstractions_collect :: (FMap Name Kind)
            _bodyOghc :: (Bool)
            _bodyOimportedModule :: (Bool)
            _bodyOinstancename :: (Maybe Name)
            _bodyOkinames :: (KSubst)
            _bodyOkindIndexedTypes :: (FMap Name KindIndexedType)
            _bodyOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _bodyOkinds :: (KSubst)
            _bodyOkindvar :: (Int)
            _bodyOksubst :: (KSubst)
            _bodyOlabels_collect :: (FMap Name Names)
            _bodyOlabels_dist :: (FMap Name Names)
            _bodyOlocal :: (Bool)
            _bodyOmethods_collect :: (FMap Name Names)
            _bodyOmethods_dist :: (FMap Name Names)
            _bodyOmodules :: (Set Strings)
            _bodyOoptimizer :: (Bool)
            _bodyOoptimizerPrelude :: (Declarations)
            _bodyOoutput :: ([PP.Doc])
            _bodyOprekind :: (KSubst)
            _bodyOprelude :: (Bool)
            _bodyOpresignatures :: (PreSignatures)
            _bodyOpresignatures_collect :: (PreSignatures)
            _bodyOrawRequests_collect :: ([RawRequest])
            _bodyOsignatures :: (Signatures)
            _bodyOstructureTypes_collect :: (FMap Name LambdaType)
            _bodyOtoplevel :: (Bool)
            _bodyOtypeImps_collect :: ([Request_TypeImply])
            _bodyOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _exportsIconstructors_collect,_exportsIgenericAbstractions_collect,_exportsIkinames,_exportsIkind_errors,_exportsIkindvar,_exportsIksubst,_exportsIlabels_collect,_exportsImethods_collect,_exportsIself) =
                (exports_ (_exportsOclassname)
                          (_exportsOconstructors_collect)
                          (_exportsOconstructors_dist)
                          (_exportsOcurrentModule)
                          (_exportsOgenericAbstractions)
                          (_exportsOgenericAbstractions_collect)
                          (_exportsOghc)
                          (_exportsOimportedModule)
                          (_exportsOinstancename)
                          (_exportsOkinames)
                          (_exportsOkinds)
                          (_exportsOkindvar)
                          (_exportsOksubst)
                          (_exportsOlabels_collect)
                          (_exportsOlabels_dist)
                          (_exportsOlocal)
                          (_exportsOmethods_collect)
                          (_exportsOmethods_dist)
                          (_exportsOmodules)
                          (_exportsOoptimizer)
                          (_exportsOoptimizerPrelude)
                          (_exportsOprekind)
                          (_exportsOprelude)
                          (_exportsOtoplevel)
                          (_exportsOverbosity))
            ( _bodyIabstractTypes_collect
             ,_bodyIbimapImps_collect
             ,_bodyIconstructors_collect
             ,_bodyIdepConstraints_collect
             ,_bodyIfunImps_collect
             ,_bodyIgenericAbstractions_collect
             ,_bodyIkinames
             ,_bodyIkindIndexedTypes_collect
             ,_bodyIkind_errors
             ,_bodyIkindvar
             ,_bodyIksubst
             ,_bodyIlabels_collect
             ,_bodyImethods_collect
             ,_bodyIoutput
             ,_bodyIoutputi
             ,_bodyIpresignatures_collect
             ,_bodyIrawRequests_collect
             ,_bodyIself
             ,_bodyIstaticErrors
             ,_bodyIstructureTypes_collect
             ,_bodyItypeImps_collect
             ) =
                (body_ (_bodyOabstractTypes_collect)
                       (_bodyObimapImps_collect)
                       (_bodyOclassname)
                       (_bodyOconstructors_collect)
                       (_bodyOconstructors_dist)
                       (_bodyOcurrentModule)
                       (_bodyOdependencies)
                       (_bodyOexportedStructures)
                       (_bodyOexportedTypes)
                       (_bodyOexportedValues)
                       (_bodyOfunImps_collect)
                       (_bodyOgenericAbstractions)
                       (_bodyOgenericAbstractions_collect)
                       (_bodyOghc)
                       (_bodyOimportedModule)
                       (_bodyOinstancename)
                       (_bodyOkinames)
                       (_bodyOkindIndexedTypes)
                       (_bodyOkindIndexedTypes_collect)
                       (_bodyOkinds)
                       (_bodyOkindvar)
                       (_bodyOksubst)
                       (_bodyOlabels_collect)
                       (_bodyOlabels_dist)
                       (_bodyOlocal)
                       (_bodyOmethods_collect)
                       (_bodyOmethods_dist)
                       (_bodyOmodules)
                       (_bodyOoptimizer)
                       (_bodyOoptimizerPrelude)
                       (_bodyOoutput)
                       (_bodyOprekind)
                       (_bodyOprelude)
                       (_bodyOpresignatures)
                       (_bodyOpresignatures_collect)
                       (_bodyOrawRequests_collect)
                       (_bodyOsignatures)
                       (_bodyOstructureTypes_collect)
                       (_bodyOtoplevel)
                       (_bodyOtypeImps_collect)
                       (_bodyOverbosity))
            -- "./ModuleInformation.inc.lag"(line 113, column 8)
            (_local@_) =
                True
            -- "./ModuleInformation.inc.lag"(line 111, column 8)
            (_lhsOcompiledModule@_) =
                _compiledModule
            -- "./ModuleInformation.inc.lag"(line 110, column 8)
            (_compiledModule@_) =
                _moduleName
            -- "./ModuleInformation.inc.lag"(line 109, column 8)
            (_currentModule@_) =
                _moduleName
            -- "./ModuleInformation.inc.lag"(line 107, column 8)
            (_moduleName@_) =
                getModuleName _moduleName_
            -- "./ModuleInformation.inc.lag"(line 101, column 8)
            (_moduleName_@_) =
                case _nameIself of
                  MaybeModuleName_Nothing -> ModuleName_ModuleName
                                               unknownRange
                                               ["Main"]
                  MaybeModuleName_Just x  -> x
            -- "./Output.inc.lag"(line 100, column 9)
            (_bodyOoutput@_) =
                PP.ppModuleHeader
                    (PP.ppMaybeModuleName False _nameIself)
                    (PP.ppMaybeExports False
                       (MaybeExports_Just _finalExports)
                    )
                  : _lhsIoutput
            -- "./Exports.inc.lag"(line 117, column 9)
            (_finalExports@_) =
                computeExportValues
                  _lhsIgenericAbstractions
                  _lhsIsignatures
                  _lhsImethods_dist
                  _lhsIconstructors_dist
                  _lhsIlabels_dist
                  _lhsIexportedTypes
                  _lhsIexportedValues
                 ++
                computeExportTypes
                  _lhsIsignatures
                  _lhsIkindIndexedTypes
                  _lhsImethods_dist
                  _lhsIconstructors_dist
                  _lhsIlabels_dist
                  _lhsIexportedTypes
                  _lhsIexportedValues
                  _lhsIabstractTypes
            -- "./OutputI.inc.lag"(line 65, column 9)
            (_lhsOoutputi@_) =
                [PP.text "__ghi_interface"
                   PP.<+> PP.text interfaceVersion
                   PP.<+> PP.ppModuleName True _moduleName_
                ,PP.text ""
                ,PP.hang 4 $ PP.text "__ghi_export_types"
                   PP.<$$> PP.fillSep
                          (map PP.ppQEntity
                             (Set.setToList
                                _lhsIexportedTypes
                             )
                          )
                ,PP.text ""
                ,PP.hang 4 $ PP.text "__ghi_export_values"
                   PP.<$$> PP.fillSep
                          (map PP.ppQEntity
                             (Set.setToList
                                _lhsIexportedValues
                             )
                          )
                ,PP.text ""
                ,PP.indent 2 $ PP.text "where"
                ,PP.text ""
                ] ++ _bodyIoutputi
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _bodyIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _exportsIkind_errors ++ _bodyIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _bodyIstaticErrors
            -- self rule
            (_self@_) =
                Module_Module _rangeIself _nameIself _exportsIself _bodyIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _bodyIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _bodyIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _bodyIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _bodyIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _bodyIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _bodyIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _bodyIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _bodyIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _bodyIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _bodyIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _bodyImethods_collect
            -- copy rule (up)
            (_lhsOoutput@_) =
                _bodyIoutput
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _bodyIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _bodyIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _bodyIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _bodyItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_rangeOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_rangeOlocal@_) =
                _local
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_nameOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_nameOlocal@_) =
                _local
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_exportsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_exportsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_exportsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_exportsOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_exportsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_exportsOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_exportsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_exportsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_exportsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_exportsOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_exportsOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_exportsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_exportsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_exportsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_exportsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_exportsOlocal@_) =
                _local
            -- copy rule (chain)
            (_exportsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_exportsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_exportsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_exportsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_exportsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_exportsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_exportsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_exportsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_exportsOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_bodyOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_bodyObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_bodyOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_bodyOconstructors_collect@_) =
                _exportsIconstructors_collect
            -- copy rule (down)
            (_bodyOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_bodyOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_bodyOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_bodyOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_bodyOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_bodyOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_bodyOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_bodyOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_bodyOgenericAbstractions_collect@_) =
                _exportsIgenericAbstractions_collect
            -- copy rule (down)
            (_bodyOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_bodyOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_bodyOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_bodyOkinames@_) =
                _exportsIkinames
            -- copy rule (down)
            (_bodyOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_bodyOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_bodyOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_bodyOkindvar@_) =
                _exportsIkindvar
            -- copy rule (chain)
            (_bodyOksubst@_) =
                _exportsIksubst
            -- copy rule (chain)
            (_bodyOlabels_collect@_) =
                _exportsIlabels_collect
            -- copy rule (down)
            (_bodyOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_bodyOlocal@_) =
                _local
            -- copy rule (chain)
            (_bodyOmethods_collect@_) =
                _exportsImethods_collect
            -- copy rule (down)
            (_bodyOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_bodyOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_bodyOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_bodyOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_bodyOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_bodyOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_bodyOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_bodyOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_bodyOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_bodyOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_bodyOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_bodyOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_bodyOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_bodyOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect
             ,_lhsObimapImps_collect
             ,_lhsOcompiledModule
             ,_lhsOconstructors_collect
             ,_lhsOdepConstraints_collect
             ,_lhsOfunImps_collect
             ,_lhsOgenericAbstractions_collect
             ,_lhsOkinames
             ,_lhsOkindIndexedTypes_collect
             ,_lhsOkind_errors
             ,_lhsOkindvar
             ,_lhsOksubst
             ,_lhsOlabels_collect
             ,_lhsOmethods_collect
             ,_lhsOoutput
             ,_lhsOoutputi
             ,_lhsOpresignatures_collect
             ,_lhsOrawRequests_collect
             ,_lhsOself
             ,_lhsOstaticErrors
             ,_lhsOstructureTypes_collect
             ,_lhsOtypeImps_collect
             )
-- ModuleInterface ---------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      dependencies         : FMap Name [(Name,Name)]
      exportedStructures   : Set Name
      exportedTypes        : Set Name
      exportedValues       : Set Name
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      output               : [PP.Doc]
      presignatures_collect : PreSignatures
      rawRequests_collect  : [RawRequest]
      structureTypes_collect : FMap Name LambdaType
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      kind_errors          : [GHError]
      self                 : SELF
      staticErrors         : [GHError]

-}
{-
   local variables for ModuleInterface.ModuleInterface:
      local
      toplevel
      importedModule
      currentModule
      self

-}
{-
   local variables for ModuleInterface.Unavailable:
      local
      toplevel
      importedModule
      currentModule
      self

-}
-- semantic domain
type T_ModuleInterface = (Set Name) ->
                         ([Request_BimapImply]) ->
                         (Maybe Name) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (FMap Name [(Name,Name)]) ->
                         (Set Name) ->
                         (Set Name) ->
                         (Set Name) ->
                         ([Request_FunImply]) ->
                         (FMap Name Kind) ->
                         (FMap Name Kind) ->
                         (Bool) ->
                         (Bool) ->
                         (Maybe Name) ->
                         (KSubst) ->
                         (FMap Name KindIndexedType) ->
                         (FMap Name KindIndexedType) ->
                         (KSubst) ->
                         (Int) ->
                         (KSubst) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (Set Strings) ->
                         (Bool) ->
                         (Declarations) ->
                         ([PP.Doc]) ->
                         (KSubst) ->
                         (Bool) ->
                         (PreSignatures) ->
                         (PreSignatures) ->
                         ([RawRequest]) ->
                         (Signatures) ->
                         (FMap Name LambdaType) ->
                         (Bool) ->
                         ([Request_TypeImply]) ->
                         (Int) ->
                         ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),([PP.Doc]),(PreSignatures),([RawRequest]),(ModuleInterface),([GHError]),(FMap Name LambdaType),([Request_TypeImply]))
-- cata
sem_ModuleInterface :: (ModuleInterface) ->
                       (T_ModuleInterface)
sem_ModuleInterface ((ModuleInterface_ModuleInterface (_range) (_name) (_exportedTypes) (_exportedValues) (_declarations))) =
    (sem_ModuleInterface_ModuleInterface ((sem_Range (_range))) ((sem_ModuleName (_name))) ((sem_Names (_exportedTypes))) ((sem_Names (_exportedValues))) ((sem_InterfaceDeclarations (_declarations))))
sem_ModuleInterface ((ModuleInterface_Unavailable (_name))) =
    (sem_ModuleInterface_Unavailable ((sem_ModuleName (_name))))
sem_ModuleInterface_ModuleInterface :: (T_Range) ->
                                       (T_ModuleName) ->
                                       (T_Names) ->
                                       (T_Names) ->
                                       (T_InterfaceDeclarations) ->
                                       (T_ModuleInterface)
sem_ModuleInterface_ModuleInterface (range_) (name_) (exportedTypes_) (exportedValues_) (declarations_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIoutput
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (ModuleInterface)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (ModuleName)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _exportedTypesIconstructors_collect :: (FMap Name Names)
            _exportedTypesIgenericAbstractions_collect :: (FMap Name Kind)
            _exportedTypesIinferkind :: (Kind)
            _exportedTypesIkinames :: (KSubst)
            _exportedTypesIkind_errors :: ([GHError])
            _exportedTypesIkindvar :: (Int)
            _exportedTypesIksubst :: (KSubst)
            _exportedTypesIlabels_collect :: (FMap Name Names)
            _exportedTypesImethods_collect :: (FMap Name Names)
            _exportedTypesIself :: (Names)
            _exportedTypesOclassname :: (Maybe Name)
            _exportedTypesOconstructors_collect :: (FMap Name Names)
            _exportedTypesOconstructors_dist :: (FMap Name Names)
            _exportedTypesOcurrentModule :: (Strings)
            _exportedTypesOgenericAbstractions :: (FMap Name Kind)
            _exportedTypesOgenericAbstractions_collect :: (FMap Name Kind)
            _exportedTypesOghc :: (Bool)
            _exportedTypesOimportedModule :: (Bool)
            _exportedTypesOinstancename :: (Maybe Name)
            _exportedTypesOkinames :: (KSubst)
            _exportedTypesOkinds :: (KSubst)
            _exportedTypesOkindvar :: (Int)
            _exportedTypesOksubst :: (KSubst)
            _exportedTypesOlabels_collect :: (FMap Name Names)
            _exportedTypesOlabels_dist :: (FMap Name Names)
            _exportedTypesOlocal :: (Bool)
            _exportedTypesOmethods_collect :: (FMap Name Names)
            _exportedTypesOmethods_dist :: (FMap Name Names)
            _exportedTypesOmodules :: (Set Strings)
            _exportedTypesOoptimizer :: (Bool)
            _exportedTypesOoptimizerPrelude :: (Declarations)
            _exportedTypesOprekind :: (KSubst)
            _exportedTypesOprelude :: (Bool)
            _exportedTypesOtoplevel :: (Bool)
            _exportedTypesOverbosity :: (Int)
            _exportedValuesIconstructors_collect :: (FMap Name Names)
            _exportedValuesIgenericAbstractions_collect :: (FMap Name Kind)
            _exportedValuesIinferkind :: (Kind)
            _exportedValuesIkinames :: (KSubst)
            _exportedValuesIkind_errors :: ([GHError])
            _exportedValuesIkindvar :: (Int)
            _exportedValuesIksubst :: (KSubst)
            _exportedValuesIlabels_collect :: (FMap Name Names)
            _exportedValuesImethods_collect :: (FMap Name Names)
            _exportedValuesIself :: (Names)
            _exportedValuesOclassname :: (Maybe Name)
            _exportedValuesOconstructors_collect :: (FMap Name Names)
            _exportedValuesOconstructors_dist :: (FMap Name Names)
            _exportedValuesOcurrentModule :: (Strings)
            _exportedValuesOgenericAbstractions :: (FMap Name Kind)
            _exportedValuesOgenericAbstractions_collect :: (FMap Name Kind)
            _exportedValuesOghc :: (Bool)
            _exportedValuesOimportedModule :: (Bool)
            _exportedValuesOinstancename :: (Maybe Name)
            _exportedValuesOkinames :: (KSubst)
            _exportedValuesOkinds :: (KSubst)
            _exportedValuesOkindvar :: (Int)
            _exportedValuesOksubst :: (KSubst)
            _exportedValuesOlabels_collect :: (FMap Name Names)
            _exportedValuesOlabels_dist :: (FMap Name Names)
            _exportedValuesOlocal :: (Bool)
            _exportedValuesOmethods_collect :: (FMap Name Names)
            _exportedValuesOmethods_dist :: (FMap Name Names)
            _exportedValuesOmodules :: (Set Strings)
            _exportedValuesOoptimizer :: (Bool)
            _exportedValuesOoptimizerPrelude :: (Declarations)
            _exportedValuesOprekind :: (KSubst)
            _exportedValuesOprelude :: (Bool)
            _exportedValuesOtoplevel :: (Bool)
            _exportedValuesOverbosity :: (Int)
            _declarationsIabstractTypes_collect :: (Set Name)
            _declarationsIbimapImps_collect :: ([Request_BimapImply])
            _declarationsIconstructors_collect :: (FMap Name Names)
            _declarationsIdepConstraints_collect :: ([DepConstraint])
            _declarationsIfunImps_collect :: ([Request_FunImply])
            _declarationsIgenericAbstractions_collect :: (FMap Name Kind)
            _declarationsIkinames :: (KSubst)
            _declarationsIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _declarationsIkind_errors :: ([GHError])
            _declarationsIkindvar :: (Int)
            _declarationsIksubst :: (KSubst)
            _declarationsIlabels_collect :: (FMap Name Names)
            _declarationsImethods_collect :: (FMap Name Names)
            _declarationsIoutput :: ([PP.Doc])
            _declarationsIpresignatures_collect :: (PreSignatures)
            _declarationsIrawRequests_collect :: ([RawRequest])
            _declarationsIself :: (InterfaceDeclarations)
            _declarationsIstaticErrors :: ([GHError])
            _declarationsIstructureTypes_collect :: (FMap Name LambdaType)
            _declarationsItypeImps_collect :: ([Request_TypeImply])
            _declarationsOabstractTypes_collect :: (Set Name)
            _declarationsObimapImps_collect :: ([Request_BimapImply])
            _declarationsOclassname :: (Maybe Name)
            _declarationsOconstructors_collect :: (FMap Name Names)
            _declarationsOconstructors_dist :: (FMap Name Names)
            _declarationsOcurrentModule :: (Strings)
            _declarationsOdependencies :: (FMap Name [(Name,Name)])
            _declarationsOexportedStructures :: (Set Name)
            _declarationsOexportedTypes :: (Set Name)
            _declarationsOexportedValues :: (Set Name)
            _declarationsOfunImps_collect :: ([Request_FunImply])
            _declarationsOgenericAbstractions :: (FMap Name Kind)
            _declarationsOgenericAbstractions_collect :: (FMap Name Kind)
            _declarationsOghc :: (Bool)
            _declarationsOimportedModule :: (Bool)
            _declarationsOinstancename :: (Maybe Name)
            _declarationsOkinames :: (KSubst)
            _declarationsOkindIndexedTypes :: (FMap Name KindIndexedType)
            _declarationsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _declarationsOkinds :: (KSubst)
            _declarationsOkindvar :: (Int)
            _declarationsOksubst :: (KSubst)
            _declarationsOlabels_collect :: (FMap Name Names)
            _declarationsOlabels_dist :: (FMap Name Names)
            _declarationsOlocal :: (Bool)
            _declarationsOmethods_collect :: (FMap Name Names)
            _declarationsOmethods_dist :: (FMap Name Names)
            _declarationsOmodules :: (Set Strings)
            _declarationsOoptimizer :: (Bool)
            _declarationsOoptimizerPrelude :: (Declarations)
            _declarationsOoutput :: ([PP.Doc])
            _declarationsOprekind :: (KSubst)
            _declarationsOprelude :: (Bool)
            _declarationsOpresignatures :: (PreSignatures)
            _declarationsOpresignatures_collect :: (PreSignatures)
            _declarationsOrawRequests_collect :: ([RawRequest])
            _declarationsOsignatures :: (Signatures)
            _declarationsOstructureTypes_collect :: (FMap Name LambdaType)
            _declarationsOtoplevel :: (Bool)
            _declarationsOtypeImps_collect :: ([Request_TypeImply])
            _declarationsOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _exportedTypesIconstructors_collect,_exportedTypesIgenericAbstractions_collect,_exportedTypesIinferkind,_exportedTypesIkinames,_exportedTypesIkind_errors,_exportedTypesIkindvar,_exportedTypesIksubst,_exportedTypesIlabels_collect,_exportedTypesImethods_collect,_exportedTypesIself) =
                (exportedTypes_ (_exportedTypesOclassname)
                                (_exportedTypesOconstructors_collect)
                                (_exportedTypesOconstructors_dist)
                                (_exportedTypesOcurrentModule)
                                (_exportedTypesOgenericAbstractions)
                                (_exportedTypesOgenericAbstractions_collect)
                                (_exportedTypesOghc)
                                (_exportedTypesOimportedModule)
                                (_exportedTypesOinstancename)
                                (_exportedTypesOkinames)
                                (_exportedTypesOkinds)
                                (_exportedTypesOkindvar)
                                (_exportedTypesOksubst)
                                (_exportedTypesOlabels_collect)
                                (_exportedTypesOlabels_dist)
                                (_exportedTypesOlocal)
                                (_exportedTypesOmethods_collect)
                                (_exportedTypesOmethods_dist)
                                (_exportedTypesOmodules)
                                (_exportedTypesOoptimizer)
                                (_exportedTypesOoptimizerPrelude)
                                (_exportedTypesOprekind)
                                (_exportedTypesOprelude)
                                (_exportedTypesOtoplevel)
                                (_exportedTypesOverbosity))
            ( _exportedValuesIconstructors_collect,_exportedValuesIgenericAbstractions_collect,_exportedValuesIinferkind,_exportedValuesIkinames,_exportedValuesIkind_errors,_exportedValuesIkindvar,_exportedValuesIksubst,_exportedValuesIlabels_collect,_exportedValuesImethods_collect,_exportedValuesIself) =
                (exportedValues_ (_exportedValuesOclassname)
                                 (_exportedValuesOconstructors_collect)
                                 (_exportedValuesOconstructors_dist)
                                 (_exportedValuesOcurrentModule)
                                 (_exportedValuesOgenericAbstractions)
                                 (_exportedValuesOgenericAbstractions_collect)
                                 (_exportedValuesOghc)
                                 (_exportedValuesOimportedModule)
                                 (_exportedValuesOinstancename)
                                 (_exportedValuesOkinames)
                                 (_exportedValuesOkinds)
                                 (_exportedValuesOkindvar)
                                 (_exportedValuesOksubst)
                                 (_exportedValuesOlabels_collect)
                                 (_exportedValuesOlabels_dist)
                                 (_exportedValuesOlocal)
                                 (_exportedValuesOmethods_collect)
                                 (_exportedValuesOmethods_dist)
                                 (_exportedValuesOmodules)
                                 (_exportedValuesOoptimizer)
                                 (_exportedValuesOoptimizerPrelude)
                                 (_exportedValuesOprekind)
                                 (_exportedValuesOprelude)
                                 (_exportedValuesOtoplevel)
                                 (_exportedValuesOverbosity))
            ( _declarationsIabstractTypes_collect
             ,_declarationsIbimapImps_collect
             ,_declarationsIconstructors_collect
             ,_declarationsIdepConstraints_collect
             ,_declarationsIfunImps_collect
             ,_declarationsIgenericAbstractions_collect
             ,_declarationsIkinames
             ,_declarationsIkindIndexedTypes_collect
             ,_declarationsIkind_errors
             ,_declarationsIkindvar
             ,_declarationsIksubst
             ,_declarationsIlabels_collect
             ,_declarationsImethods_collect
             ,_declarationsIoutput
             ,_declarationsIpresignatures_collect
             ,_declarationsIrawRequests_collect
             ,_declarationsIself
             ,_declarationsIstaticErrors
             ,_declarationsIstructureTypes_collect
             ,_declarationsItypeImps_collect
             ) =
                (declarations_ (_declarationsOabstractTypes_collect)
                               (_declarationsObimapImps_collect)
                               (_declarationsOclassname)
                               (_declarationsOconstructors_collect)
                               (_declarationsOconstructors_dist)
                               (_declarationsOcurrentModule)
                               (_declarationsOdependencies)
                               (_declarationsOexportedStructures)
                               (_declarationsOexportedTypes)
                               (_declarationsOexportedValues)
                               (_declarationsOfunImps_collect)
                               (_declarationsOgenericAbstractions)
                               (_declarationsOgenericAbstractions_collect)
                               (_declarationsOghc)
                               (_declarationsOimportedModule)
                               (_declarationsOinstancename)
                               (_declarationsOkinames)
                               (_declarationsOkindIndexedTypes)
                               (_declarationsOkindIndexedTypes_collect)
                               (_declarationsOkinds)
                               (_declarationsOkindvar)
                               (_declarationsOksubst)
                               (_declarationsOlabels_collect)
                               (_declarationsOlabels_dist)
                               (_declarationsOlocal)
                               (_declarationsOmethods_collect)
                               (_declarationsOmethods_dist)
                               (_declarationsOmodules)
                               (_declarationsOoptimizer)
                               (_declarationsOoptimizerPrelude)
                               (_declarationsOoutput)
                               (_declarationsOprekind)
                               (_declarationsOprelude)
                               (_declarationsOpresignatures)
                               (_declarationsOpresignatures_collect)
                               (_declarationsOrawRequests_collect)
                               (_declarationsOsignatures)
                               (_declarationsOstructureTypes_collect)
                               (_declarationsOtoplevel)
                               (_declarationsOtypeImps_collect)
                               (_declarationsOverbosity))
            -- "./ModuleInformation.inc.lag"(line 125, column 8)
            (_local@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 124, column 8)
            (_toplevel@_) =
                True
            -- "./ModuleInformation.inc.lag"(line 123, column 8)
            (_importedModule@_) =
                True
            -- "./ModuleInformation.inc.lag"(line 122, column 8)
            (_currentModule@_) =
                getModuleName _nameIself
            -- "./ModuleInformation.inc.lag"(line 348, column 9)
            (_lhsOmethods_collect@_) =
                mergeFM _lhsImethods_collect
                        _declarationsImethods_collect
            -- "./ModuleInformation.inc.lag"(line 346, column 9)
            (_lhsOconstructors_collect@_) =
                mergeFM _lhsIconstructors_collect
                        _declarationsIconstructors_collect
            -- "./ModuleInformation.inc.lag"(line 344, column 9)
            (_declarationsOmethods_collect@_) =
                emptyFM
            -- "./ModuleInformation.inc.lag"(line 343, column 9)
            (_declarationsOconstructors_collect@_) =
                emptyFM
            -- "./Kind.inc.lag"(line 146, column 9)
            (_lhsOkinames@_) =
                _declarationsIkinames
            -- "./Kind.inc.lag"(line 145, column 9)
            (_declarationsOkinames@_) =
                _lhsIkinames
            -- "./Kind.inc.lag"(line 144, column 9)
            (_lhsOkindvar@_) =
                _declarationsIkindvar
            -- "./Kind.inc.lag"(line 143, column 9)
            (_declarationsOkindvar@_) =
                _lhsIkindvar
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _declarationsIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _exportedTypesIkind_errors ++ _exportedValuesIkind_errors ++ _declarationsIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _declarationsIstaticErrors
            -- self rule
            (_self@_) =
                ModuleInterface_ModuleInterface _rangeIself _nameIself _exportedTypesIself _exportedValuesIself _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _declarationsIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _declarationsIbimapImps_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _declarationsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _declarationsIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _declarationsIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOksubst@_) =
                _declarationsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _declarationsIlabels_collect
            -- copy rule (up)
            (_lhsOoutput@_) =
                _declarationsIoutput
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _declarationsIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _declarationsIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _declarationsIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _declarationsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_rangeOcurrentModule@_) =
                _currentModule
            -- copy rule (chain)
            (_rangeOimportedModule@_) =
                _importedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_rangeOlocal@_) =
                _local
            -- copy rule (chain)
            (_rangeOtoplevel@_) =
                _toplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_nameOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (chain)
            (_nameOimportedModule@_) =
                _importedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_nameOlocal@_) =
                _local
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (chain)
            (_nameOtoplevel@_) =
                _toplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_exportedTypesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_exportedTypesOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_exportedTypesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_exportedTypesOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_exportedTypesOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_exportedTypesOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_exportedTypesOghc@_) =
                _lhsIghc
            -- copy rule (chain)
            (_exportedTypesOimportedModule@_) =
                _importedModule
            -- copy rule (down)
            (_exportedTypesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_exportedTypesOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_exportedTypesOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_exportedTypesOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_exportedTypesOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_exportedTypesOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_exportedTypesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_exportedTypesOlocal@_) =
                _local
            -- copy rule (chain)
            (_exportedTypesOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_exportedTypesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_exportedTypesOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_exportedTypesOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_exportedTypesOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_exportedTypesOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_exportedTypesOprelude@_) =
                _lhsIprelude
            -- copy rule (chain)
            (_exportedTypesOtoplevel@_) =
                _toplevel
            -- copy rule (down)
            (_exportedTypesOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_exportedValuesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_exportedValuesOconstructors_collect@_) =
                _exportedTypesIconstructors_collect
            -- copy rule (down)
            (_exportedValuesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_exportedValuesOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_exportedValuesOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_exportedValuesOgenericAbstractions_collect@_) =
                _exportedTypesIgenericAbstractions_collect
            -- copy rule (down)
            (_exportedValuesOghc@_) =
                _lhsIghc
            -- copy rule (chain)
            (_exportedValuesOimportedModule@_) =
                _importedModule
            -- copy rule (down)
            (_exportedValuesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_exportedValuesOkinames@_) =
                _exportedTypesIkinames
            -- copy rule (down)
            (_exportedValuesOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_exportedValuesOkindvar@_) =
                _exportedTypesIkindvar
            -- copy rule (chain)
            (_exportedValuesOksubst@_) =
                _exportedTypesIksubst
            -- copy rule (chain)
            (_exportedValuesOlabels_collect@_) =
                _exportedTypesIlabels_collect
            -- copy rule (down)
            (_exportedValuesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_exportedValuesOlocal@_) =
                _local
            -- copy rule (chain)
            (_exportedValuesOmethods_collect@_) =
                _exportedTypesImethods_collect
            -- copy rule (down)
            (_exportedValuesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_exportedValuesOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_exportedValuesOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_exportedValuesOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_exportedValuesOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_exportedValuesOprelude@_) =
                _lhsIprelude
            -- copy rule (chain)
            (_exportedValuesOtoplevel@_) =
                _toplevel
            -- copy rule (down)
            (_exportedValuesOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_declarationsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_declarationsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_declarationsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_declarationsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_declarationsOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_declarationsOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_declarationsOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_declarationsOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_declarationsOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_declarationsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_declarationsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_declarationsOgenericAbstractions_collect@_) =
                _exportedValuesIgenericAbstractions_collect
            -- copy rule (down)
            (_declarationsOghc@_) =
                _lhsIghc
            -- copy rule (chain)
            (_declarationsOimportedModule@_) =
                _importedModule
            -- copy rule (down)
            (_declarationsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_declarationsOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_declarationsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_declarationsOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_declarationsOksubst@_) =
                _exportedValuesIksubst
            -- copy rule (chain)
            (_declarationsOlabels_collect@_) =
                _exportedValuesIlabels_collect
            -- copy rule (down)
            (_declarationsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_declarationsOlocal@_) =
                _local
            -- copy rule (down)
            (_declarationsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_declarationsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_declarationsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_declarationsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_declarationsOoutput@_) =
                _lhsIoutput
            -- copy rule (down)
            (_declarationsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_declarationsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_declarationsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_declarationsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_declarationsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_declarationsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_declarationsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (chain)
            (_declarationsOtoplevel@_) =
                _toplevel
            -- copy rule (down)
            (_declarationsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_declarationsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOoutput,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_ModuleInterface_Unavailable :: (T_ModuleName) ->
                                   (T_ModuleInterface)
sem_ModuleInterface_Unavailable (name_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIoutput
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (ModuleInterface)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (ModuleName)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            -- "./ModuleInformation.inc.lag"(line 130, column 8)
            (_local@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 129, column 8)
            (_toplevel@_) =
                True
            -- "./ModuleInformation.inc.lag"(line 128, column 8)
            (_importedModule@_) =
                True
            -- "./ModuleInformation.inc.lag"(line 127, column 8)
            (_currentModule@_) =
                getModuleName _nameIself
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                ModuleInterface_Unavailable _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (chain)
            (_lhsOoutput@_) =
                _lhsIoutput
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_nameOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (chain)
            (_nameOimportedModule@_) =
                _importedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_nameOlocal@_) =
                _local
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (chain)
            (_nameOtoplevel@_) =
                _toplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOoutput,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
-- ModuleInterfaces --------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      dependencies         : FMap Name [(Name,Name)]
      exportedStructures   : Set Name
      exportedTypes        : Set Name
      exportedValues       : Set Name
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      output               : [PP.Doc]
      presignatures_collect : PreSignatures
      rawRequests_collect  : [RawRequest]
      structureTypes_collect : FMap Name LambdaType
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      kind_errors          : [GHError]
      self                 : SELF
      staticErrors         : [GHError]

-}
{-
   local variables for ModuleInterfaces.Cons:
      self

-}
{-
   local variables for ModuleInterfaces.Nil:
      self

-}
-- semantic domain
type T_ModuleInterfaces = (Set Name) ->
                          ([Request_BimapImply]) ->
                          (Maybe Name) ->
                          (FMap Name Names) ->
                          (FMap Name Names) ->
                          (FMap Name [(Name,Name)]) ->
                          (Set Name) ->
                          (Set Name) ->
                          (Set Name) ->
                          ([Request_FunImply]) ->
                          (FMap Name Kind) ->
                          (FMap Name Kind) ->
                          (Bool) ->
                          (Bool) ->
                          (Maybe Name) ->
                          (KSubst) ->
                          (FMap Name KindIndexedType) ->
                          (FMap Name KindIndexedType) ->
                          (KSubst) ->
                          (Int) ->
                          (KSubst) ->
                          (FMap Name Names) ->
                          (FMap Name Names) ->
                          (FMap Name Names) ->
                          (FMap Name Names) ->
                          (Set Strings) ->
                          (Bool) ->
                          (Declarations) ->
                          ([PP.Doc]) ->
                          (KSubst) ->
                          (Bool) ->
                          (PreSignatures) ->
                          (PreSignatures) ->
                          ([RawRequest]) ->
                          (Signatures) ->
                          (FMap Name LambdaType) ->
                          (Bool) ->
                          ([Request_TypeImply]) ->
                          (Int) ->
                          ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),([PP.Doc]),(PreSignatures),([RawRequest]),(ModuleInterfaces),([GHError]),(FMap Name LambdaType),([Request_TypeImply]))
-- cata
sem_ModuleInterfaces :: (ModuleInterfaces) ->
                        (T_ModuleInterfaces)
sem_ModuleInterfaces (list) =
    (foldr (sem_ModuleInterfaces_Cons) (sem_ModuleInterfaces_Nil) ((map sem_ModuleInterface list)))
sem_ModuleInterfaces_Cons :: (T_ModuleInterface) ->
                             (T_ModuleInterfaces) ->
                             (T_ModuleInterfaces)
sem_ModuleInterfaces_Cons (hd_) (tl_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIoutput
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (ModuleInterfaces)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _hdIabstractTypes_collect :: (Set Name)
            _hdIbimapImps_collect :: ([Request_BimapImply])
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdepConstraints_collect :: ([DepConstraint])
            _hdIfunImps_collect :: ([Request_FunImply])
            _hdIgenericAbstractions_collect :: (FMap Name Kind)
            _hdIkinames :: (KSubst)
            _hdIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _hdIkind_errors :: ([GHError])
            _hdIkindvar :: (Int)
            _hdIksubst :: (KSubst)
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIoutput :: ([PP.Doc])
            _hdIpresignatures_collect :: (PreSignatures)
            _hdIrawRequests_collect :: ([RawRequest])
            _hdIself :: (ModuleInterface)
            _hdIstaticErrors :: ([GHError])
            _hdIstructureTypes_collect :: (FMap Name LambdaType)
            _hdItypeImps_collect :: ([Request_TypeImply])
            _hdOabstractTypes_collect :: (Set Name)
            _hdObimapImps_collect :: ([Request_BimapImply])
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOdependencies :: (FMap Name [(Name,Name)])
            _hdOexportedStructures :: (Set Name)
            _hdOexportedTypes :: (Set Name)
            _hdOexportedValues :: (Set Name)
            _hdOfunImps_collect :: ([Request_FunImply])
            _hdOgenericAbstractions :: (FMap Name Kind)
            _hdOgenericAbstractions_collect :: (FMap Name Kind)
            _hdOghc :: (Bool)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOkinames :: (KSubst)
            _hdOkindIndexedTypes :: (FMap Name KindIndexedType)
            _hdOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _hdOkinds :: (KSubst)
            _hdOkindvar :: (Int)
            _hdOksubst :: (KSubst)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmodules :: (Set Strings)
            _hdOoptimizer :: (Bool)
            _hdOoptimizerPrelude :: (Declarations)
            _hdOoutput :: ([PP.Doc])
            _hdOprekind :: (KSubst)
            _hdOprelude :: (Bool)
            _hdOpresignatures :: (PreSignatures)
            _hdOpresignatures_collect :: (PreSignatures)
            _hdOrawRequests_collect :: ([RawRequest])
            _hdOsignatures :: (Signatures)
            _hdOstructureTypes_collect :: (FMap Name LambdaType)
            _hdOtoplevel :: (Bool)
            _hdOtypeImps_collect :: ([Request_TypeImply])
            _hdOverbosity :: (Int)
            _tlIabstractTypes_collect :: (Set Name)
            _tlIbimapImps_collect :: ([Request_BimapImply])
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdepConstraints_collect :: ([DepConstraint])
            _tlIfunImps_collect :: ([Request_FunImply])
            _tlIgenericAbstractions_collect :: (FMap Name Kind)
            _tlIkinames :: (KSubst)
            _tlIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _tlIkind_errors :: ([GHError])
            _tlIkindvar :: (Int)
            _tlIksubst :: (KSubst)
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIoutput :: ([PP.Doc])
            _tlIpresignatures_collect :: (PreSignatures)
            _tlIrawRequests_collect :: ([RawRequest])
            _tlIself :: (ModuleInterfaces)
            _tlIstaticErrors :: ([GHError])
            _tlIstructureTypes_collect :: (FMap Name LambdaType)
            _tlItypeImps_collect :: ([Request_TypeImply])
            _tlOabstractTypes_collect :: (Set Name)
            _tlObimapImps_collect :: ([Request_BimapImply])
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOdependencies :: (FMap Name [(Name,Name)])
            _tlOexportedStructures :: (Set Name)
            _tlOexportedTypes :: (Set Name)
            _tlOexportedValues :: (Set Name)
            _tlOfunImps_collect :: ([Request_FunImply])
            _tlOgenericAbstractions :: (FMap Name Kind)
            _tlOgenericAbstractions_collect :: (FMap Name Kind)
            _tlOghc :: (Bool)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOkinames :: (KSubst)
            _tlOkindIndexedTypes :: (FMap Name KindIndexedType)
            _tlOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _tlOkinds :: (KSubst)
            _tlOkindvar :: (Int)
            _tlOksubst :: (KSubst)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmodules :: (Set Strings)
            _tlOoptimizer :: (Bool)
            _tlOoptimizerPrelude :: (Declarations)
            _tlOoutput :: ([PP.Doc])
            _tlOprekind :: (KSubst)
            _tlOprelude :: (Bool)
            _tlOpresignatures :: (PreSignatures)
            _tlOpresignatures_collect :: (PreSignatures)
            _tlOrawRequests_collect :: ([RawRequest])
            _tlOsignatures :: (Signatures)
            _tlOstructureTypes_collect :: (FMap Name LambdaType)
            _tlOtoplevel :: (Bool)
            _tlOtypeImps_collect :: ([Request_TypeImply])
            _tlOverbosity :: (Int)
            ( _hdIabstractTypes_collect,_hdIbimapImps_collect,_hdIconstructors_collect,_hdIdepConstraints_collect,_hdIfunImps_collect,_hdIgenericAbstractions_collect,_hdIkinames,_hdIkindIndexedTypes_collect,_hdIkind_errors,_hdIkindvar,_hdIksubst,_hdIlabels_collect,_hdImethods_collect,_hdIoutput,_hdIpresignatures_collect,_hdIrawRequests_collect,_hdIself,_hdIstaticErrors,_hdIstructureTypes_collect,_hdItypeImps_collect) =
                (hd_ (_hdOabstractTypes_collect)
                     (_hdObimapImps_collect)
                     (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOdependencies)
                     (_hdOexportedStructures)
                     (_hdOexportedTypes)
                     (_hdOexportedValues)
                     (_hdOfunImps_collect)
                     (_hdOgenericAbstractions)
                     (_hdOgenericAbstractions_collect)
                     (_hdOghc)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOkinames)
                     (_hdOkindIndexedTypes)
                     (_hdOkindIndexedTypes_collect)
                     (_hdOkinds)
                     (_hdOkindvar)
                     (_hdOksubst)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmodules)
                     (_hdOoptimizer)
                     (_hdOoptimizerPrelude)
                     (_hdOoutput)
                     (_hdOprekind)
                     (_hdOprelude)
                     (_hdOpresignatures)
                     (_hdOpresignatures_collect)
                     (_hdOrawRequests_collect)
                     (_hdOsignatures)
                     (_hdOstructureTypes_collect)
                     (_hdOtoplevel)
                     (_hdOtypeImps_collect)
                     (_hdOverbosity))
            ( _tlIabstractTypes_collect,_tlIbimapImps_collect,_tlIconstructors_collect,_tlIdepConstraints_collect,_tlIfunImps_collect,_tlIgenericAbstractions_collect,_tlIkinames,_tlIkindIndexedTypes_collect,_tlIkind_errors,_tlIkindvar,_tlIksubst,_tlIlabels_collect,_tlImethods_collect,_tlIoutput,_tlIpresignatures_collect,_tlIrawRequests_collect,_tlIself,_tlIstaticErrors,_tlIstructureTypes_collect,_tlItypeImps_collect) =
                (tl_ (_tlOabstractTypes_collect)
                     (_tlObimapImps_collect)
                     (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOdependencies)
                     (_tlOexportedStructures)
                     (_tlOexportedTypes)
                     (_tlOexportedValues)
                     (_tlOfunImps_collect)
                     (_tlOgenericAbstractions)
                     (_tlOgenericAbstractions_collect)
                     (_tlOghc)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOkinames)
                     (_tlOkindIndexedTypes)
                     (_tlOkindIndexedTypes_collect)
                     (_tlOkinds)
                     (_tlOkindvar)
                     (_tlOksubst)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmodules)
                     (_tlOoptimizer)
                     (_tlOoptimizerPrelude)
                     (_tlOoutput)
                     (_tlOprekind)
                     (_tlOprelude)
                     (_tlOpresignatures)
                     (_tlOpresignatures_collect)
                     (_tlOrawRequests_collect)
                     (_tlOsignatures)
                     (_tlOstructureTypes_collect)
                     (_tlOtoplevel)
                     (_tlOtypeImps_collect)
                     (_tlOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _hdIdepConstraints_collect ++ _tlIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _hdIkind_errors ++ _tlIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _hdIstaticErrors ++ _tlIstaticErrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _tlIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _tlIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _tlIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _tlIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _tlIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _tlIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _tlIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _tlIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOoutput@_) =
                _tlIoutput
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _tlIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _tlIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _tlIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _tlItypeImps_collect
            -- copy rule (down)
            (_hdOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_hdObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_hdOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_hdOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_hdOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_hdOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_hdOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_hdOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_hdOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_hdOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_hdOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_hdOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_hdOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_hdOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_hdOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_hdOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_hdOoutput@_) =
                _lhsIoutput
            -- copy rule (down)
            (_hdOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_hdOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_hdOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_hdOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_hdOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_hdOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_hdOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_hdOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_hdOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_tlOabstractTypes_collect@_) =
                _hdIabstractTypes_collect
            -- copy rule (chain)
            (_tlObimapImps_collect@_) =
                _hdIbimapImps_collect
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_tlOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_tlOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_tlOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (chain)
            (_tlOfunImps_collect@_) =
                _hdIfunImps_collect
            -- copy rule (down)
            (_tlOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_tlOgenericAbstractions_collect@_) =
                _hdIgenericAbstractions_collect
            -- copy rule (down)
            (_tlOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOkinames@_) =
                _hdIkinames
            -- copy rule (down)
            (_tlOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (chain)
            (_tlOkindIndexedTypes_collect@_) =
                _hdIkindIndexedTypes_collect
            -- copy rule (down)
            (_tlOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_tlOkindvar@_) =
                _hdIkindvar
            -- copy rule (chain)
            (_tlOksubst@_) =
                _hdIksubst
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_tlOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_tlOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (chain)
            (_tlOoutput@_) =
                _hdIoutput
            -- copy rule (down)
            (_tlOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_tlOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_tlOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_tlOpresignatures_collect@_) =
                _hdIpresignatures_collect
            -- copy rule (chain)
            (_tlOrawRequests_collect@_) =
                _hdIrawRequests_collect
            -- copy rule (down)
            (_tlOsignatures@_) =
                _lhsIsignatures
            -- copy rule (chain)
            (_tlOstructureTypes_collect@_) =
                _hdIstructureTypes_collect
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_tlOtypeImps_collect@_) =
                _hdItypeImps_collect
            -- copy rule (down)
            (_tlOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOoutput,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_ModuleInterfaces_Nil :: (T_ModuleInterfaces)
sem_ModuleInterfaces_Nil  =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIoutput
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (ModuleInterfaces)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOoutput@_) =
                _lhsIoutput
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOoutput,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
-- ModuleName --------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for ModuleName.ModuleName:
      self

-}
-- semantic domain
type T_ModuleName = (Maybe Name) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Strings) ->
                    (FMap Name Kind) ->
                    (FMap Name Kind) ->
                    (Bool) ->
                    (Bool) ->
                    (Maybe Name) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Bool) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Set Strings) ->
                    (Bool) ->
                    (Declarations) ->
                    (Bool) ->
                    (Bool) ->
                    (Int) ->
                    ( (FMap Name Names),(FMap Name Kind),(FMap Name Names),(FMap Name Names),(ModuleName))
-- cata
sem_ModuleName :: (ModuleName) ->
                  (T_ModuleName)
sem_ModuleName ((ModuleName_ModuleName (_range) (_name))) =
    (sem_ModuleName_ModuleName ((sem_Range (_range))) ((sem_Strings (_name))))
sem_ModuleName_ModuleName :: (T_Range) ->
                             (T_Strings) ->
                             (T_ModuleName)
sem_ModuleName_ModuleName (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (ModuleName)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Strings)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            -- self rule
            (_self@_) =
                ModuleName_ModuleName _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- ModuleSystem ------------------------------------------------
{-
   inherited attributes:
      abstractTypes        : Set Name
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      dependencies         : FMap Name [(Name,Name)]
      exportedStructures   : Set Name
      exportedTypes        : Set Name
      exportedValues       : Set Name
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      output               : [PP.Doc]
      presignatures_collect : PreSignatures
      rawRequests_collect  : [RawRequest]
      structureTypes_collect : FMap Name LambdaType
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      compiledModule       : Strings
      depConstraints_collect : [DepConstraint]
      kind_errors          : [GHError]
      outputi              : [PP.Doc]
      self                 : SELF
      staticErrors         : [GHError]

-}
{-
   local variables for ModuleSystem.ModuleSystem:
      self

-}
-- semantic domain
type T_ModuleSystem = (Set Name) ->
                      (Set Name) ->
                      ([Request_BimapImply]) ->
                      (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (FMap Name [(Name,Name)]) ->
                      (Set Name) ->
                      (Set Name) ->
                      (Set Name) ->
                      ([Request_FunImply]) ->
                      (FMap Name Kind) ->
                      (FMap Name Kind) ->
                      (Bool) ->
                      (Bool) ->
                      (Maybe Name) ->
                      (KSubst) ->
                      (FMap Name KindIndexedType) ->
                      (FMap Name KindIndexedType) ->
                      (KSubst) ->
                      (Int) ->
                      (KSubst) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Set Strings) ->
                      (Bool) ->
                      (Declarations) ->
                      ([PP.Doc]) ->
                      (KSubst) ->
                      (Bool) ->
                      (PreSignatures) ->
                      (PreSignatures) ->
                      ([RawRequest]) ->
                      (Signatures) ->
                      (FMap Name LambdaType) ->
                      (Bool) ->
                      ([Request_TypeImply]) ->
                      (Int) ->
                      ( (Set Name),([Request_BimapImply]),(Strings),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),([PP.Doc]),([PP.Doc]),(PreSignatures),([RawRequest]),(ModuleSystem),([GHError]),(FMap Name LambdaType),([Request_TypeImply]))
-- cata
sem_ModuleSystem :: (ModuleSystem) ->
                    (T_ModuleSystem)
sem_ModuleSystem ((ModuleSystem_ModuleSystem (_interfaces) (_module))) =
    (sem_ModuleSystem_ModuleSystem ((sem_ModuleInterfaces (_interfaces))) ((sem_Module (_module))))
sem_ModuleSystem_ModuleSystem :: (T_ModuleInterfaces) ->
                                 (T_Module) ->
                                 (T_ModuleSystem)
sem_ModuleSystem_ModuleSystem (interfaces_) (module_) =
    \ _lhsIabstractTypes
      _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIoutput
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOcompiledModule :: (Strings)
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOoutput :: ([PP.Doc])
            _lhsOoutputi :: ([PP.Doc])
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (ModuleSystem)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _interfacesIabstractTypes_collect :: (Set Name)
            _interfacesIbimapImps_collect :: ([Request_BimapImply])
            _interfacesIconstructors_collect :: (FMap Name Names)
            _interfacesIdepConstraints_collect :: ([DepConstraint])
            _interfacesIfunImps_collect :: ([Request_FunImply])
            _interfacesIgenericAbstractions_collect :: (FMap Name Kind)
            _interfacesIkinames :: (KSubst)
            _interfacesIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _interfacesIkind_errors :: ([GHError])
            _interfacesIkindvar :: (Int)
            _interfacesIksubst :: (KSubst)
            _interfacesIlabels_collect :: (FMap Name Names)
            _interfacesImethods_collect :: (FMap Name Names)
            _interfacesIoutput :: ([PP.Doc])
            _interfacesIpresignatures_collect :: (PreSignatures)
            _interfacesIrawRequests_collect :: ([RawRequest])
            _interfacesIself :: (ModuleInterfaces)
            _interfacesIstaticErrors :: ([GHError])
            _interfacesIstructureTypes_collect :: (FMap Name LambdaType)
            _interfacesItypeImps_collect :: ([Request_TypeImply])
            _interfacesOabstractTypes_collect :: (Set Name)
            _interfacesObimapImps_collect :: ([Request_BimapImply])
            _interfacesOclassname :: (Maybe Name)
            _interfacesOconstructors_collect :: (FMap Name Names)
            _interfacesOconstructors_dist :: (FMap Name Names)
            _interfacesOdependencies :: (FMap Name [(Name,Name)])
            _interfacesOexportedStructures :: (Set Name)
            _interfacesOexportedTypes :: (Set Name)
            _interfacesOexportedValues :: (Set Name)
            _interfacesOfunImps_collect :: ([Request_FunImply])
            _interfacesOgenericAbstractions :: (FMap Name Kind)
            _interfacesOgenericAbstractions_collect :: (FMap Name Kind)
            _interfacesOghc :: (Bool)
            _interfacesOimportedModule :: (Bool)
            _interfacesOinstancename :: (Maybe Name)
            _interfacesOkinames :: (KSubst)
            _interfacesOkindIndexedTypes :: (FMap Name KindIndexedType)
            _interfacesOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _interfacesOkinds :: (KSubst)
            _interfacesOkindvar :: (Int)
            _interfacesOksubst :: (KSubst)
            _interfacesOlabels_collect :: (FMap Name Names)
            _interfacesOlabels_dist :: (FMap Name Names)
            _interfacesOmethods_collect :: (FMap Name Names)
            _interfacesOmethods_dist :: (FMap Name Names)
            _interfacesOmodules :: (Set Strings)
            _interfacesOoptimizer :: (Bool)
            _interfacesOoptimizerPrelude :: (Declarations)
            _interfacesOoutput :: ([PP.Doc])
            _interfacesOprekind :: (KSubst)
            _interfacesOprelude :: (Bool)
            _interfacesOpresignatures :: (PreSignatures)
            _interfacesOpresignatures_collect :: (PreSignatures)
            _interfacesOrawRequests_collect :: ([RawRequest])
            _interfacesOsignatures :: (Signatures)
            _interfacesOstructureTypes_collect :: (FMap Name LambdaType)
            _interfacesOtoplevel :: (Bool)
            _interfacesOtypeImps_collect :: ([Request_TypeImply])
            _interfacesOverbosity :: (Int)
            _moduleIabstractTypes_collect :: (Set Name)
            _moduleIbimapImps_collect :: ([Request_BimapImply])
            _moduleIcompiledModule :: (Strings)
            _moduleIconstructors_collect :: (FMap Name Names)
            _moduleIdepConstraints_collect :: ([DepConstraint])
            _moduleIfunImps_collect :: ([Request_FunImply])
            _moduleIgenericAbstractions_collect :: (FMap Name Kind)
            _moduleIkinames :: (KSubst)
            _moduleIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _moduleIkind_errors :: ([GHError])
            _moduleIkindvar :: (Int)
            _moduleIksubst :: (KSubst)
            _moduleIlabels_collect :: (FMap Name Names)
            _moduleImethods_collect :: (FMap Name Names)
            _moduleIoutput :: ([PP.Doc])
            _moduleIoutputi :: ([PP.Doc])
            _moduleIpresignatures_collect :: (PreSignatures)
            _moduleIrawRequests_collect :: ([RawRequest])
            _moduleIself :: (Module)
            _moduleIstaticErrors :: ([GHError])
            _moduleIstructureTypes_collect :: (FMap Name LambdaType)
            _moduleItypeImps_collect :: ([Request_TypeImply])
            _moduleOabstractTypes :: (Set Name)
            _moduleOabstractTypes_collect :: (Set Name)
            _moduleObimapImps_collect :: ([Request_BimapImply])
            _moduleOclassname :: (Maybe Name)
            _moduleOconstructors_collect :: (FMap Name Names)
            _moduleOconstructors_dist :: (FMap Name Names)
            _moduleOdependencies :: (FMap Name [(Name,Name)])
            _moduleOexportedStructures :: (Set Name)
            _moduleOexportedTypes :: (Set Name)
            _moduleOexportedValues :: (Set Name)
            _moduleOfunImps_collect :: ([Request_FunImply])
            _moduleOgenericAbstractions :: (FMap Name Kind)
            _moduleOgenericAbstractions_collect :: (FMap Name Kind)
            _moduleOghc :: (Bool)
            _moduleOimportedModule :: (Bool)
            _moduleOinstancename :: (Maybe Name)
            _moduleOkinames :: (KSubst)
            _moduleOkindIndexedTypes :: (FMap Name KindIndexedType)
            _moduleOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _moduleOkinds :: (KSubst)
            _moduleOkindvar :: (Int)
            _moduleOksubst :: (KSubst)
            _moduleOlabels_collect :: (FMap Name Names)
            _moduleOlabels_dist :: (FMap Name Names)
            _moduleOmethods_collect :: (FMap Name Names)
            _moduleOmethods_dist :: (FMap Name Names)
            _moduleOmodules :: (Set Strings)
            _moduleOoptimizer :: (Bool)
            _moduleOoptimizerPrelude :: (Declarations)
            _moduleOoutput :: ([PP.Doc])
            _moduleOprekind :: (KSubst)
            _moduleOprelude :: (Bool)
            _moduleOpresignatures :: (PreSignatures)
            _moduleOpresignatures_collect :: (PreSignatures)
            _moduleOrawRequests_collect :: ([RawRequest])
            _moduleOsignatures :: (Signatures)
            _moduleOstructureTypes_collect :: (FMap Name LambdaType)
            _moduleOtoplevel :: (Bool)
            _moduleOtypeImps_collect :: ([Request_TypeImply])
            _moduleOverbosity :: (Int)
            ( _interfacesIabstractTypes_collect
             ,_interfacesIbimapImps_collect
             ,_interfacesIconstructors_collect
             ,_interfacesIdepConstraints_collect
             ,_interfacesIfunImps_collect
             ,_interfacesIgenericAbstractions_collect
             ,_interfacesIkinames
             ,_interfacesIkindIndexedTypes_collect
             ,_interfacesIkind_errors
             ,_interfacesIkindvar
             ,_interfacesIksubst
             ,_interfacesIlabels_collect
             ,_interfacesImethods_collect
             ,_interfacesIoutput
             ,_interfacesIpresignatures_collect
             ,_interfacesIrawRequests_collect
             ,_interfacesIself
             ,_interfacesIstaticErrors
             ,_interfacesIstructureTypes_collect
             ,_interfacesItypeImps_collect
             ) =
                (interfaces_ (_interfacesOabstractTypes_collect)
                             (_interfacesObimapImps_collect)
                             (_interfacesOclassname)
                             (_interfacesOconstructors_collect)
                             (_interfacesOconstructors_dist)
                             (_interfacesOdependencies)
                             (_interfacesOexportedStructures)
                             (_interfacesOexportedTypes)
                             (_interfacesOexportedValues)
                             (_interfacesOfunImps_collect)
                             (_interfacesOgenericAbstractions)
                             (_interfacesOgenericAbstractions_collect)
                             (_interfacesOghc)
                             (_interfacesOimportedModule)
                             (_interfacesOinstancename)
                             (_interfacesOkinames)
                             (_interfacesOkindIndexedTypes)
                             (_interfacesOkindIndexedTypes_collect)
                             (_interfacesOkinds)
                             (_interfacesOkindvar)
                             (_interfacesOksubst)
                             (_interfacesOlabels_collect)
                             (_interfacesOlabels_dist)
                             (_interfacesOmethods_collect)
                             (_interfacesOmethods_dist)
                             (_interfacesOmodules)
                             (_interfacesOoptimizer)
                             (_interfacesOoptimizerPrelude)
                             (_interfacesOoutput)
                             (_interfacesOprekind)
                             (_interfacesOprelude)
                             (_interfacesOpresignatures)
                             (_interfacesOpresignatures_collect)
                             (_interfacesOrawRequests_collect)
                             (_interfacesOsignatures)
                             (_interfacesOstructureTypes_collect)
                             (_interfacesOtoplevel)
                             (_interfacesOtypeImps_collect)
                             (_interfacesOverbosity))
            ( _moduleIabstractTypes_collect
             ,_moduleIbimapImps_collect
             ,_moduleIcompiledModule
             ,_moduleIconstructors_collect
             ,_moduleIdepConstraints_collect
             ,_moduleIfunImps_collect
             ,_moduleIgenericAbstractions_collect
             ,_moduleIkinames
             ,_moduleIkindIndexedTypes_collect
             ,_moduleIkind_errors
             ,_moduleIkindvar
             ,_moduleIksubst
             ,_moduleIlabels_collect
             ,_moduleImethods_collect
             ,_moduleIoutput
             ,_moduleIoutputi
             ,_moduleIpresignatures_collect
             ,_moduleIrawRequests_collect
             ,_moduleIself
             ,_moduleIstaticErrors
             ,_moduleIstructureTypes_collect
             ,_moduleItypeImps_collect
             ) =
                (module_ (_moduleOabstractTypes)
                         (_moduleOabstractTypes_collect)
                         (_moduleObimapImps_collect)
                         (_moduleOclassname)
                         (_moduleOconstructors_collect)
                         (_moduleOconstructors_dist)
                         (_moduleOdependencies)
                         (_moduleOexportedStructures)
                         (_moduleOexportedTypes)
                         (_moduleOexportedValues)
                         (_moduleOfunImps_collect)
                         (_moduleOgenericAbstractions)
                         (_moduleOgenericAbstractions_collect)
                         (_moduleOghc)
                         (_moduleOimportedModule)
                         (_moduleOinstancename)
                         (_moduleOkinames)
                         (_moduleOkindIndexedTypes)
                         (_moduleOkindIndexedTypes_collect)
                         (_moduleOkinds)
                         (_moduleOkindvar)
                         (_moduleOksubst)
                         (_moduleOlabels_collect)
                         (_moduleOlabels_dist)
                         (_moduleOmethods_collect)
                         (_moduleOmethods_dist)
                         (_moduleOmodules)
                         (_moduleOoptimizer)
                         (_moduleOoptimizerPrelude)
                         (_moduleOoutput)
                         (_moduleOprekind)
                         (_moduleOprelude)
                         (_moduleOpresignatures)
                         (_moduleOpresignatures_collect)
                         (_moduleOrawRequests_collect)
                         (_moduleOsignatures)
                         (_moduleOstructureTypes_collect)
                         (_moduleOtoplevel)
                         (_moduleOtypeImps_collect)
                         (_moduleOverbosity))
            -- "./Output.inc.lag"(line 93, column 9)
            (_lhsOoutput@_) =
                if _lhsIprelude then
                  _interfacesIoutput
                else
                  _moduleIoutput
            -- "./Output.inc.lag"(line 89, column 9)
            (_interfacesOoutput@_) =
                if _lhsIprelude then
                  _moduleIoutput
                else
                  []
            -- "./Output.inc.lag"(line 88, column 9)
            (_moduleOoutput@_) =
                _lhsIoutput
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _interfacesIdepConstraints_collect ++ _moduleIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _interfacesIkind_errors ++ _moduleIkind_errors
            -- use rule
            (_lhsOoutputi@_) =
                _moduleIoutputi
            -- use rule
            (_lhsOstaticErrors@_) =
                _interfacesIstaticErrors ++ _moduleIstaticErrors
            -- self rule
            (_self@_) =
                ModuleSystem_ModuleSystem _interfacesIself _moduleIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _moduleIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _moduleIbimapImps_collect
            -- copy rule (up)
            (_lhsOcompiledModule@_) =
                _moduleIcompiledModule
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _moduleIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _moduleIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _moduleIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _moduleIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _moduleIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _moduleIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _moduleIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _moduleIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _moduleImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _moduleIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _moduleIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _moduleIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _moduleItypeImps_collect
            -- copy rule (down)
            (_interfacesOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_interfacesObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_interfacesOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_interfacesOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_interfacesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_interfacesOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_interfacesOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_interfacesOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_interfacesOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_interfacesOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_interfacesOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_interfacesOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_interfacesOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_interfacesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_interfacesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_interfacesOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_interfacesOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_interfacesOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_interfacesOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_interfacesOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_interfacesOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_interfacesOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_interfacesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_interfacesOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_interfacesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_interfacesOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_interfacesOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_interfacesOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_interfacesOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_interfacesOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_interfacesOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_interfacesOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_interfacesOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_interfacesOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_interfacesOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_interfacesOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_interfacesOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_interfacesOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_moduleOabstractTypes@_) =
                _lhsIabstractTypes
            -- copy rule (chain)
            (_moduleOabstractTypes_collect@_) =
                _interfacesIabstractTypes_collect
            -- copy rule (chain)
            (_moduleObimapImps_collect@_) =
                _interfacesIbimapImps_collect
            -- copy rule (down)
            (_moduleOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_moduleOconstructors_collect@_) =
                _interfacesIconstructors_collect
            -- copy rule (down)
            (_moduleOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_moduleOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_moduleOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_moduleOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_moduleOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (chain)
            (_moduleOfunImps_collect@_) =
                _interfacesIfunImps_collect
            -- copy rule (down)
            (_moduleOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_moduleOgenericAbstractions_collect@_) =
                _interfacesIgenericAbstractions_collect
            -- copy rule (down)
            (_moduleOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_moduleOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_moduleOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_moduleOkinames@_) =
                _interfacesIkinames
            -- copy rule (down)
            (_moduleOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (chain)
            (_moduleOkindIndexedTypes_collect@_) =
                _interfacesIkindIndexedTypes_collect
            -- copy rule (down)
            (_moduleOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_moduleOkindvar@_) =
                _interfacesIkindvar
            -- copy rule (chain)
            (_moduleOksubst@_) =
                _interfacesIksubst
            -- copy rule (chain)
            (_moduleOlabels_collect@_) =
                _interfacesIlabels_collect
            -- copy rule (down)
            (_moduleOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_moduleOmethods_collect@_) =
                _interfacesImethods_collect
            -- copy rule (down)
            (_moduleOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_moduleOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_moduleOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_moduleOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_moduleOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_moduleOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_moduleOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_moduleOpresignatures_collect@_) =
                _interfacesIpresignatures_collect
            -- copy rule (chain)
            (_moduleOrawRequests_collect@_) =
                _interfacesIrawRequests_collect
            -- copy rule (down)
            (_moduleOsignatures@_) =
                _lhsIsignatures
            -- copy rule (chain)
            (_moduleOstructureTypes_collect@_) =
                _interfacesIstructureTypes_collect
            -- copy rule (down)
            (_moduleOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_moduleOtypeImps_collect@_) =
                _interfacesItypeImps_collect
            -- copy rule (down)
            (_moduleOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect
             ,_lhsObimapImps_collect
             ,_lhsOcompiledModule
             ,_lhsOconstructors_collect
             ,_lhsOdepConstraints_collect
             ,_lhsOfunImps_collect
             ,_lhsOgenericAbstractions_collect
             ,_lhsOkinames
             ,_lhsOkindIndexedTypes_collect
             ,_lhsOkind_errors
             ,_lhsOkindvar
             ,_lhsOksubst
             ,_lhsOlabels_collect
             ,_lhsOmethods_collect
             ,_lhsOoutput
             ,_lhsOoutputi
             ,_lhsOpresignatures_collect
             ,_lhsOrawRequests_collect
             ,_lhsOself
             ,_lhsOstaticErrors
             ,_lhsOstructureTypes_collect
             ,_lhsOtypeImps_collect
             )
-- Name --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Name.Entity:
      self

-}
{-
   local variables for Name.Identifier:
      self

-}
{-
   local variables for Name.Operator:
      self

-}
{-
   local variables for Name.Special:
      self

-}
-- semantic domain
type T_Name = (Maybe Name) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (Strings) ->
              (FMap Name Kind) ->
              (FMap Name Kind) ->
              (Bool) ->
              (Bool) ->
              (Maybe Name) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (Bool) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (Set Strings) ->
              (Bool) ->
              (Declarations) ->
              (Bool) ->
              (Bool) ->
              (Int) ->
              ( (FMap Name Names),(FMap Name Kind),(FMap Name Names),(FMap Name Names),(Name))
-- cata
sem_Name :: (Name) ->
            (T_Name)
sem_Name ((Name_Entity (_range) (_entity) (_inscope))) =
    (sem_Name_Entity ((sem_Range (_range))) ((sem_Name (_entity))) ((sem_MaybeName (_inscope))))
sem_Name ((Name_Identifier (_range) (_module) (_name))) =
    (sem_Name_Identifier ((sem_Range (_range))) ((sem_Strings (_module))) (_name))
sem_Name ((Name_Operator (_range) (_module) (_name))) =
    (sem_Name_Operator ((sem_Range (_range))) ((sem_Strings (_module))) (_name))
sem_Name ((Name_Special (_range) (_module) (_name))) =
    (sem_Name_Special ((sem_Range (_range))) ((sem_Strings (_module))) (_name))
sem_Name_Entity :: (T_Range) ->
                   (T_Name) ->
                   (T_MaybeName) ->
                   (T_Name)
sem_Name_Entity (range_) (entity_) (inscope_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Name)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _entityIconstructors_collect :: (FMap Name Names)
            _entityIgenericAbstractions_collect :: (FMap Name Kind)
            _entityIlabels_collect :: (FMap Name Names)
            _entityImethods_collect :: (FMap Name Names)
            _entityIself :: (Name)
            _entityOclassname :: (Maybe Name)
            _entityOconstructors_collect :: (FMap Name Names)
            _entityOconstructors_dist :: (FMap Name Names)
            _entityOcurrentModule :: (Strings)
            _entityOgenericAbstractions :: (FMap Name Kind)
            _entityOgenericAbstractions_collect :: (FMap Name Kind)
            _entityOghc :: (Bool)
            _entityOimportedModule :: (Bool)
            _entityOinstancename :: (Maybe Name)
            _entityOlabels_collect :: (FMap Name Names)
            _entityOlabels_dist :: (FMap Name Names)
            _entityOlocal :: (Bool)
            _entityOmethods_collect :: (FMap Name Names)
            _entityOmethods_dist :: (FMap Name Names)
            _entityOmodules :: (Set Strings)
            _entityOoptimizer :: (Bool)
            _entityOoptimizerPrelude :: (Declarations)
            _entityOprelude :: (Bool)
            _entityOtoplevel :: (Bool)
            _entityOverbosity :: (Int)
            _inscopeIconstructors_collect :: (FMap Name Names)
            _inscopeIgenericAbstractions_collect :: (FMap Name Kind)
            _inscopeIlabels_collect :: (FMap Name Names)
            _inscopeImethods_collect :: (FMap Name Names)
            _inscopeIself :: (MaybeName)
            _inscopeOclassname :: (Maybe Name)
            _inscopeOconstructors_collect :: (FMap Name Names)
            _inscopeOconstructors_dist :: (FMap Name Names)
            _inscopeOcurrentModule :: (Strings)
            _inscopeOgenericAbstractions :: (FMap Name Kind)
            _inscopeOgenericAbstractions_collect :: (FMap Name Kind)
            _inscopeOghc :: (Bool)
            _inscopeOimportedModule :: (Bool)
            _inscopeOinstancename :: (Maybe Name)
            _inscopeOlabels_collect :: (FMap Name Names)
            _inscopeOlabels_dist :: (FMap Name Names)
            _inscopeOlocal :: (Bool)
            _inscopeOmethods_collect :: (FMap Name Names)
            _inscopeOmethods_dist :: (FMap Name Names)
            _inscopeOmodules :: (Set Strings)
            _inscopeOoptimizer :: (Bool)
            _inscopeOoptimizerPrelude :: (Declarations)
            _inscopeOprelude :: (Bool)
            _inscopeOtoplevel :: (Bool)
            _inscopeOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _entityIconstructors_collect,_entityIgenericAbstractions_collect,_entityIlabels_collect,_entityImethods_collect,_entityIself) =
                (entity_ (_entityOclassname)
                         (_entityOconstructors_collect)
                         (_entityOconstructors_dist)
                         (_entityOcurrentModule)
                         (_entityOgenericAbstractions)
                         (_entityOgenericAbstractions_collect)
                         (_entityOghc)
                         (_entityOimportedModule)
                         (_entityOinstancename)
                         (_entityOlabels_collect)
                         (_entityOlabels_dist)
                         (_entityOlocal)
                         (_entityOmethods_collect)
                         (_entityOmethods_dist)
                         (_entityOmodules)
                         (_entityOoptimizer)
                         (_entityOoptimizerPrelude)
                         (_entityOprelude)
                         (_entityOtoplevel)
                         (_entityOverbosity))
            ( _inscopeIconstructors_collect,_inscopeIgenericAbstractions_collect,_inscopeIlabels_collect,_inscopeImethods_collect,_inscopeIself) =
                (inscope_ (_inscopeOclassname)
                          (_inscopeOconstructors_collect)
                          (_inscopeOconstructors_dist)
                          (_inscopeOcurrentModule)
                          (_inscopeOgenericAbstractions)
                          (_inscopeOgenericAbstractions_collect)
                          (_inscopeOghc)
                          (_inscopeOimportedModule)
                          (_inscopeOinstancename)
                          (_inscopeOlabels_collect)
                          (_inscopeOlabels_dist)
                          (_inscopeOlocal)
                          (_inscopeOmethods_collect)
                          (_inscopeOmethods_dist)
                          (_inscopeOmodules)
                          (_inscopeOoptimizer)
                          (_inscopeOoptimizerPrelude)
                          (_inscopeOprelude)
                          (_inscopeOtoplevel)
                          (_inscopeOverbosity))
            -- self rule
            (_self@_) =
                Name_Entity _rangeIself _entityIself _inscopeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _inscopeIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _inscopeIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _inscopeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _inscopeImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_entityOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_entityOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_entityOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_entityOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_entityOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_entityOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_entityOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_entityOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_entityOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_entityOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_entityOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_entityOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_entityOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_entityOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_entityOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_entityOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_entityOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_entityOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_entityOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_entityOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_inscopeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_inscopeOconstructors_collect@_) =
                _entityIconstructors_collect
            -- copy rule (down)
            (_inscopeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_inscopeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_inscopeOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_inscopeOgenericAbstractions_collect@_) =
                _entityIgenericAbstractions_collect
            -- copy rule (down)
            (_inscopeOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_inscopeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_inscopeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_inscopeOlabels_collect@_) =
                _entityIlabels_collect
            -- copy rule (down)
            (_inscopeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_inscopeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_inscopeOmethods_collect@_) =
                _entityImethods_collect
            -- copy rule (down)
            (_inscopeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_inscopeOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_inscopeOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_inscopeOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_inscopeOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_inscopeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_inscopeOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Name_Identifier :: (T_Range) ->
                       (T_Strings) ->
                       (String) ->
                       (T_Name)
sem_Name_Identifier (range_) (module_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Name)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _moduleIconstructors_collect :: (FMap Name Names)
            _moduleIgenericAbstractions_collect :: (FMap Name Kind)
            _moduleIlabels_collect :: (FMap Name Names)
            _moduleImethods_collect :: (FMap Name Names)
            _moduleIself :: (Strings)
            _moduleOclassname :: (Maybe Name)
            _moduleOconstructors_collect :: (FMap Name Names)
            _moduleOconstructors_dist :: (FMap Name Names)
            _moduleOcurrentModule :: (Strings)
            _moduleOgenericAbstractions :: (FMap Name Kind)
            _moduleOgenericAbstractions_collect :: (FMap Name Kind)
            _moduleOghc :: (Bool)
            _moduleOimportedModule :: (Bool)
            _moduleOinstancename :: (Maybe Name)
            _moduleOlabels_collect :: (FMap Name Names)
            _moduleOlabels_dist :: (FMap Name Names)
            _moduleOlocal :: (Bool)
            _moduleOmethods_collect :: (FMap Name Names)
            _moduleOmethods_dist :: (FMap Name Names)
            _moduleOmodules :: (Set Strings)
            _moduleOoptimizer :: (Bool)
            _moduleOoptimizerPrelude :: (Declarations)
            _moduleOprelude :: (Bool)
            _moduleOtoplevel :: (Bool)
            _moduleOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _moduleIconstructors_collect,_moduleIgenericAbstractions_collect,_moduleIlabels_collect,_moduleImethods_collect,_moduleIself) =
                (module_ (_moduleOclassname)
                         (_moduleOconstructors_collect)
                         (_moduleOconstructors_dist)
                         (_moduleOcurrentModule)
                         (_moduleOgenericAbstractions)
                         (_moduleOgenericAbstractions_collect)
                         (_moduleOghc)
                         (_moduleOimportedModule)
                         (_moduleOinstancename)
                         (_moduleOlabels_collect)
                         (_moduleOlabels_dist)
                         (_moduleOlocal)
                         (_moduleOmethods_collect)
                         (_moduleOmethods_dist)
                         (_moduleOmodules)
                         (_moduleOoptimizer)
                         (_moduleOoptimizerPrelude)
                         (_moduleOprelude)
                         (_moduleOtoplevel)
                         (_moduleOverbosity))
            -- self rule
            (_self@_) =
                Name_Identifier _rangeIself _moduleIself name_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _moduleIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _moduleIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _moduleIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _moduleImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_moduleOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_moduleOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_moduleOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_moduleOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_moduleOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_moduleOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_moduleOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_moduleOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_moduleOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_moduleOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_moduleOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_moduleOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_moduleOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_moduleOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_moduleOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_moduleOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_moduleOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_moduleOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_moduleOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_moduleOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Name_Operator :: (T_Range) ->
                     (T_Strings) ->
                     (String) ->
                     (T_Name)
sem_Name_Operator (range_) (module_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Name)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _moduleIconstructors_collect :: (FMap Name Names)
            _moduleIgenericAbstractions_collect :: (FMap Name Kind)
            _moduleIlabels_collect :: (FMap Name Names)
            _moduleImethods_collect :: (FMap Name Names)
            _moduleIself :: (Strings)
            _moduleOclassname :: (Maybe Name)
            _moduleOconstructors_collect :: (FMap Name Names)
            _moduleOconstructors_dist :: (FMap Name Names)
            _moduleOcurrentModule :: (Strings)
            _moduleOgenericAbstractions :: (FMap Name Kind)
            _moduleOgenericAbstractions_collect :: (FMap Name Kind)
            _moduleOghc :: (Bool)
            _moduleOimportedModule :: (Bool)
            _moduleOinstancename :: (Maybe Name)
            _moduleOlabels_collect :: (FMap Name Names)
            _moduleOlabels_dist :: (FMap Name Names)
            _moduleOlocal :: (Bool)
            _moduleOmethods_collect :: (FMap Name Names)
            _moduleOmethods_dist :: (FMap Name Names)
            _moduleOmodules :: (Set Strings)
            _moduleOoptimizer :: (Bool)
            _moduleOoptimizerPrelude :: (Declarations)
            _moduleOprelude :: (Bool)
            _moduleOtoplevel :: (Bool)
            _moduleOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _moduleIconstructors_collect,_moduleIgenericAbstractions_collect,_moduleIlabels_collect,_moduleImethods_collect,_moduleIself) =
                (module_ (_moduleOclassname)
                         (_moduleOconstructors_collect)
                         (_moduleOconstructors_dist)
                         (_moduleOcurrentModule)
                         (_moduleOgenericAbstractions)
                         (_moduleOgenericAbstractions_collect)
                         (_moduleOghc)
                         (_moduleOimportedModule)
                         (_moduleOinstancename)
                         (_moduleOlabels_collect)
                         (_moduleOlabels_dist)
                         (_moduleOlocal)
                         (_moduleOmethods_collect)
                         (_moduleOmethods_dist)
                         (_moduleOmodules)
                         (_moduleOoptimizer)
                         (_moduleOoptimizerPrelude)
                         (_moduleOprelude)
                         (_moduleOtoplevel)
                         (_moduleOverbosity))
            -- self rule
            (_self@_) =
                Name_Operator _rangeIself _moduleIself name_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _moduleIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _moduleIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _moduleIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _moduleImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_moduleOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_moduleOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_moduleOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_moduleOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_moduleOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_moduleOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_moduleOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_moduleOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_moduleOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_moduleOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_moduleOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_moduleOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_moduleOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_moduleOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_moduleOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_moduleOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_moduleOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_moduleOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_moduleOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_moduleOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Name_Special :: (T_Range) ->
                    (T_Strings) ->
                    (String) ->
                    (T_Name)
sem_Name_Special (range_) (module_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Name)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _moduleIconstructors_collect :: (FMap Name Names)
            _moduleIgenericAbstractions_collect :: (FMap Name Kind)
            _moduleIlabels_collect :: (FMap Name Names)
            _moduleImethods_collect :: (FMap Name Names)
            _moduleIself :: (Strings)
            _moduleOclassname :: (Maybe Name)
            _moduleOconstructors_collect :: (FMap Name Names)
            _moduleOconstructors_dist :: (FMap Name Names)
            _moduleOcurrentModule :: (Strings)
            _moduleOgenericAbstractions :: (FMap Name Kind)
            _moduleOgenericAbstractions_collect :: (FMap Name Kind)
            _moduleOghc :: (Bool)
            _moduleOimportedModule :: (Bool)
            _moduleOinstancename :: (Maybe Name)
            _moduleOlabels_collect :: (FMap Name Names)
            _moduleOlabels_dist :: (FMap Name Names)
            _moduleOlocal :: (Bool)
            _moduleOmethods_collect :: (FMap Name Names)
            _moduleOmethods_dist :: (FMap Name Names)
            _moduleOmodules :: (Set Strings)
            _moduleOoptimizer :: (Bool)
            _moduleOoptimizerPrelude :: (Declarations)
            _moduleOprelude :: (Bool)
            _moduleOtoplevel :: (Bool)
            _moduleOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _moduleIconstructors_collect,_moduleIgenericAbstractions_collect,_moduleIlabels_collect,_moduleImethods_collect,_moduleIself) =
                (module_ (_moduleOclassname)
                         (_moduleOconstructors_collect)
                         (_moduleOconstructors_dist)
                         (_moduleOcurrentModule)
                         (_moduleOgenericAbstractions)
                         (_moduleOgenericAbstractions_collect)
                         (_moduleOghc)
                         (_moduleOimportedModule)
                         (_moduleOinstancename)
                         (_moduleOlabels_collect)
                         (_moduleOlabels_dist)
                         (_moduleOlocal)
                         (_moduleOmethods_collect)
                         (_moduleOmethods_dist)
                         (_moduleOmodules)
                         (_moduleOoptimizer)
                         (_moduleOoptimizerPrelude)
                         (_moduleOprelude)
                         (_moduleOtoplevel)
                         (_moduleOverbosity))
            -- self rule
            (_self@_) =
                Name_Special _rangeIself _moduleIself name_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _moduleIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _moduleIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _moduleIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _moduleImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_moduleOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_moduleOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_moduleOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_moduleOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_moduleOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_moduleOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_moduleOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_moduleOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_moduleOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_moduleOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_moduleOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_moduleOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_moduleOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_moduleOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_moduleOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_moduleOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_moduleOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_moduleOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_moduleOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_moduleOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- Names -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      inferkind            : Kind
      kind_errors          : [GHError]
      self                 : SELF

-}
{-
   local variables for Names.Cons:
      kinames
      kvar
      kindvar
      self

-}
{-
   local variables for Names.Nil:
      self

-}
-- semantic domain
type T_Names = (Maybe Name) ->
               (FMap Name Names) ->
               (FMap Name Names) ->
               (Strings) ->
               (FMap Name Kind) ->
               (FMap Name Kind) ->
               (Bool) ->
               (Bool) ->
               (Maybe Name) ->
               (KSubst) ->
               (KSubst) ->
               (Int) ->
               (KSubst) ->
               (FMap Name Names) ->
               (FMap Name Names) ->
               (Bool) ->
               (FMap Name Names) ->
               (FMap Name Names) ->
               (Set Strings) ->
               (Bool) ->
               (Declarations) ->
               (KSubst) ->
               (Bool) ->
               (Bool) ->
               (Int) ->
               ( (FMap Name Names),(FMap Name Kind),(Kind),(KSubst),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(Names))
-- cata
sem_Names :: (Names) ->
             (T_Names)
sem_Names (list) =
    (foldr (sem_Names_Cons) (sem_Names_Nil) ((map sem_Name list)))
sem_Names_Cons :: (T_Name) ->
                  (T_Names) ->
                  (T_Names)
sem_Names_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOinferkind :: (Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Names)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIgenericAbstractions_collect :: (FMap Name Kind)
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIself :: (Name)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOgenericAbstractions :: (FMap Name Kind)
            _hdOgenericAbstractions_collect :: (FMap Name Kind)
            _hdOghc :: (Bool)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmodules :: (Set Strings)
            _hdOoptimizer :: (Bool)
            _hdOoptimizerPrelude :: (Declarations)
            _hdOprelude :: (Bool)
            _hdOtoplevel :: (Bool)
            _hdOverbosity :: (Int)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIgenericAbstractions_collect :: (FMap Name Kind)
            _tlIinferkind :: (Kind)
            _tlIkinames :: (KSubst)
            _tlIkind_errors :: ([GHError])
            _tlIkindvar :: (Int)
            _tlIksubst :: (KSubst)
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIself :: (Names)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOgenericAbstractions :: (FMap Name Kind)
            _tlOgenericAbstractions_collect :: (FMap Name Kind)
            _tlOghc :: (Bool)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOkinames :: (KSubst)
            _tlOkinds :: (KSubst)
            _tlOkindvar :: (Int)
            _tlOksubst :: (KSubst)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmodules :: (Set Strings)
            _tlOoptimizer :: (Bool)
            _tlOoptimizerPrelude :: (Declarations)
            _tlOprekind :: (KSubst)
            _tlOprelude :: (Bool)
            _tlOtoplevel :: (Bool)
            _tlOverbosity :: (Int)
            ( _hdIconstructors_collect,_hdIgenericAbstractions_collect,_hdIlabels_collect,_hdImethods_collect,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOgenericAbstractions) (_hdOgenericAbstractions_collect) (_hdOghc) (_hdOimportedModule) (_hdOinstancename) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOmodules) (_hdOoptimizer) (_hdOoptimizerPrelude) (_hdOprelude) (_hdOtoplevel) (_hdOverbosity))
            ( _tlIconstructors_collect,_tlIgenericAbstractions_collect,_tlIinferkind,_tlIkinames,_tlIkind_errors,_tlIkindvar,_tlIksubst,_tlIlabels_collect,_tlImethods_collect,_tlIself) =
                (tl_ (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOgenericAbstractions)
                     (_tlOgenericAbstractions_collect)
                     (_tlOghc)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOkinames)
                     (_tlOkinds)
                     (_tlOkindvar)
                     (_tlOksubst)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmodules)
                     (_tlOoptimizer)
                     (_tlOoptimizerPrelude)
                     (_tlOprekind)
                     (_tlOprelude)
                     (_tlOtoplevel)
                     (_tlOverbosity))
            -- "./Kind.inc.lag"(line 261, column 9)
            (_kinames@_) =
                add _lhsIkinames (_hdIself,_kvar)
            -- "./Kind.inc.lag"(line 260, column 9)
            (_kvar@_) =
                mkKindVar' _kindvar
            -- "./Kind.inc.lag"(line 259, column 9)
            (_kindvar@_) =
                _lhsIkindvar + 1
            -- "./Kind.inc.lag"(line 344, column 9)
            (_lhsOinferkind@_) =
                arrK _kvar _tlIinferkind
            -- use rule
            (_lhsOkind_errors@_) =
                _tlIkind_errors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _tlIgenericAbstractions_collect
            -- modified copy rule
            (_lhsOkinames@_) =
                _tlIkinames
            -- modified copy rule
            (_lhsOkindvar@_) =
                _tlIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _tlIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_hdOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_hdOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_hdOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_hdOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_hdOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_hdOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_tlOgenericAbstractions_collect@_) =
                _hdIgenericAbstractions_collect
            -- copy rule (down)
            (_tlOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOkinames@_) =
                _kinames
            -- copy rule (down)
            (_tlOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_tlOkindvar@_) =
                _kindvar
            -- copy rule (down)
            (_tlOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_tlOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_tlOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_tlOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_tlOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOinferkind,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Names_Nil :: (T_Names)
sem_Names_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOinferkind :: (Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Names)
            -- "./Kind.inc.lag"(line 342, column 9)
            (_lhsOinferkind@_) =
                starK
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOinferkind,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- Pattern -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      name                 : Name
      self                 : SELF

-}
{-
   local variables for Pattern.As:
      self

-}
{-
   local variables for Pattern.Constructor:
      self

-}
{-
   local variables for Pattern.InfixConstructor:
      self

-}
{-
   local variables for Pattern.Irrefutable:
      self

-}
{-
   local variables for Pattern.List:
      self

-}
{-
   local variables for Pattern.Literal:
      self

-}
{-
   local variables for Pattern.Negate:
      self

-}
{-
   local variables for Pattern.Parenthesized:
      self

-}
{-
   local variables for Pattern.Record:
      self

-}
{-
   local variables for Pattern.Successor:
      self

-}
{-
   local variables for Pattern.Tuple:
      self

-}
{-
   local variables for Pattern.Variable:
      self

-}
{-
   local variables for Pattern.Wildcard:
      self

-}
-- semantic domain
type T_Pattern = (Maybe Name) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Strings) ->
                 (FMap Name Kind) ->
                 (FMap Name Kind) ->
                 (Bool) ->
                 (Bool) ->
                 (Maybe Name) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Bool) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Set Strings) ->
                 (Bool) ->
                 (Declarations) ->
                 (Bool) ->
                 (Bool) ->
                 (Int) ->
                 ( (FMap Name Names),(FMap Name Kind),(FMap Name Names),(FMap Name Names),(Name),(Pattern))
-- cata
sem_Pattern :: (Pattern) ->
               (T_Pattern)
sem_Pattern ((Pattern_As (_range) (_name) (_pattern))) =
    (sem_Pattern_As ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_Constructor (_range) (_name) (_patterns))) =
    (sem_Pattern_Constructor ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Patterns (_patterns))))
sem_Pattern ((Pattern_InfixConstructor (_range) (_leftPattern) (_constructorOperator) (_rightPattern))) =
    (sem_Pattern_InfixConstructor ((sem_Range (_range))) ((sem_Pattern (_leftPattern))) ((sem_Name (_constructorOperator))) ((sem_Pattern (_rightPattern))))
sem_Pattern ((Pattern_Irrefutable (_range) (_pattern))) =
    (sem_Pattern_Irrefutable ((sem_Range (_range))) ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_List (_range) (_patterns))) =
    (sem_Pattern_List ((sem_Range (_range))) ((sem_Patterns (_patterns))))
sem_Pattern ((Pattern_Literal (_range) (_literal))) =
    (sem_Pattern_Literal ((sem_Range (_range))) ((sem_Literal (_literal))))
sem_Pattern ((Pattern_Negate (_range) (_literal))) =
    (sem_Pattern_Negate ((sem_Range (_range))) ((sem_Literal (_literal))))
sem_Pattern ((Pattern_Parenthesized (_range) (_pattern))) =
    (sem_Pattern_Parenthesized ((sem_Range (_range))) ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_Record (_range) (_name) (_recordPatternBindings))) =
    (sem_Pattern_Record ((sem_Range (_range))) ((sem_Name (_name))) ((sem_RecordPatternBindings (_recordPatternBindings))))
sem_Pattern ((Pattern_Successor (_range) (_name) (_literal))) =
    (sem_Pattern_Successor ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Literal (_literal))))
sem_Pattern ((Pattern_Tuple (_range) (_patterns))) =
    (sem_Pattern_Tuple ((sem_Range (_range))) ((sem_Patterns (_patterns))))
sem_Pattern ((Pattern_Variable (_range) (_name))) =
    (sem_Pattern_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Pattern ((Pattern_Wildcard (_range))) =
    (sem_Pattern_Wildcard ((sem_Range (_range))))
sem_Pattern_As :: (T_Range) ->
                  (T_Name) ->
                  (T_Pattern) ->
                  (T_Pattern)
sem_Pattern_As (range_) (name_) (pattern_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _patternIconstructors_collect :: (FMap Name Names)
            _patternIgenericAbstractions_collect :: (FMap Name Kind)
            _patternIlabels_collect :: (FMap Name Names)
            _patternImethods_collect :: (FMap Name Names)
            _patternIname :: (Name)
            _patternIself :: (Pattern)
            _patternOclassname :: (Maybe Name)
            _patternOconstructors_collect :: (FMap Name Names)
            _patternOconstructors_dist :: (FMap Name Names)
            _patternOcurrentModule :: (Strings)
            _patternOgenericAbstractions :: (FMap Name Kind)
            _patternOgenericAbstractions_collect :: (FMap Name Kind)
            _patternOghc :: (Bool)
            _patternOimportedModule :: (Bool)
            _patternOinstancename :: (Maybe Name)
            _patternOlabels_collect :: (FMap Name Names)
            _patternOlabels_dist :: (FMap Name Names)
            _patternOlocal :: (Bool)
            _patternOmethods_collect :: (FMap Name Names)
            _patternOmethods_dist :: (FMap Name Names)
            _patternOmodules :: (Set Strings)
            _patternOoptimizer :: (Bool)
            _patternOoptimizerPrelude :: (Declarations)
            _patternOprelude :: (Bool)
            _patternOtoplevel :: (Bool)
            _patternOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _patternIconstructors_collect,_patternIgenericAbstractions_collect,_patternIlabels_collect,_patternImethods_collect,_patternIname,_patternIself) =
                (pattern_ (_patternOclassname)
                          (_patternOconstructors_collect)
                          (_patternOconstructors_dist)
                          (_patternOcurrentModule)
                          (_patternOgenericAbstractions)
                          (_patternOgenericAbstractions_collect)
                          (_patternOghc)
                          (_patternOimportedModule)
                          (_patternOinstancename)
                          (_patternOlabels_collect)
                          (_patternOlabels_dist)
                          (_patternOlocal)
                          (_patternOmethods_collect)
                          (_patternOmethods_dist)
                          (_patternOmodules)
                          (_patternOoptimizer)
                          (_patternOoptimizerPrelude)
                          (_patternOprelude)
                          (_patternOtoplevel)
                          (_patternOverbosity))
            -- "./ModuleInformation.inc.lag"(line 462, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.Pattern.As.name: pattern binding in class/instance"
            -- self rule
            (_self@_) =
                Pattern_As _rangeIself _nameIself _patternIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _patternIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _patternIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _patternIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _patternImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_patternOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_patternOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_patternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_patternOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_patternOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_patternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_patternOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_patternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_patternOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_patternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_patternOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_patternOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_patternOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_patternOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
sem_Pattern_Constructor :: (T_Range) ->
                           (T_Name) ->
                           (T_Patterns) ->
                           (T_Pattern)
sem_Pattern_Constructor (range_) (name_) (patterns_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _patternsIconstructors_collect :: (FMap Name Names)
            _patternsIgenericAbstractions_collect :: (FMap Name Kind)
            _patternsIlabels_collect :: (FMap Name Names)
            _patternsImethods_collect :: (FMap Name Names)
            _patternsIself :: (Patterns)
            _patternsOclassname :: (Maybe Name)
            _patternsOconstructors_collect :: (FMap Name Names)
            _patternsOconstructors_dist :: (FMap Name Names)
            _patternsOcurrentModule :: (Strings)
            _patternsOgenericAbstractions :: (FMap Name Kind)
            _patternsOgenericAbstractions_collect :: (FMap Name Kind)
            _patternsOghc :: (Bool)
            _patternsOimportedModule :: (Bool)
            _patternsOinstancename :: (Maybe Name)
            _patternsOlabels_collect :: (FMap Name Names)
            _patternsOlabels_dist :: (FMap Name Names)
            _patternsOlocal :: (Bool)
            _patternsOmethods_collect :: (FMap Name Names)
            _patternsOmethods_dist :: (FMap Name Names)
            _patternsOmodules :: (Set Strings)
            _patternsOoptimizer :: (Bool)
            _patternsOoptimizerPrelude :: (Declarations)
            _patternsOprelude :: (Bool)
            _patternsOtoplevel :: (Bool)
            _patternsOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _patternsIconstructors_collect,_patternsIgenericAbstractions_collect,_patternsIlabels_collect,_patternsImethods_collect,_patternsIself) =
                (patterns_ (_patternsOclassname)
                           (_patternsOconstructors_collect)
                           (_patternsOconstructors_dist)
                           (_patternsOcurrentModule)
                           (_patternsOgenericAbstractions)
                           (_patternsOgenericAbstractions_collect)
                           (_patternsOghc)
                           (_patternsOimportedModule)
                           (_patternsOinstancename)
                           (_patternsOlabels_collect)
                           (_patternsOlabels_dist)
                           (_patternsOlocal)
                           (_patternsOmethods_collect)
                           (_patternsOmethods_dist)
                           (_patternsOmodules)
                           (_patternsOoptimizer)
                           (_patternsOoptimizerPrelude)
                           (_patternsOprelude)
                           (_patternsOtoplevel)
                           (_patternsOverbosity))
            -- "./ModuleInformation.inc.lag"(line 444, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.Pattern.Constructor.name: pattern binding in class/instance"
            -- self rule
            (_self@_) =
                Pattern_Constructor _rangeIself _nameIself _patternsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _patternsIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _patternsIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _patternsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _patternsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_patternsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_patternsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_patternsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_patternsOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_patternsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_patternsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_patternsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_patternsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_patternsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_patternsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_patternsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_patternsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_patternsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_patternsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
sem_Pattern_InfixConstructor :: (T_Range) ->
                                (T_Pattern) ->
                                (T_Name) ->
                                (T_Pattern) ->
                                (T_Pattern)
sem_Pattern_InfixConstructor (range_) (leftPattern_) (constructorOperator_) (rightPattern_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _leftPatternIconstructors_collect :: (FMap Name Names)
            _leftPatternIgenericAbstractions_collect :: (FMap Name Kind)
            _leftPatternIlabels_collect :: (FMap Name Names)
            _leftPatternImethods_collect :: (FMap Name Names)
            _leftPatternIname :: (Name)
            _leftPatternIself :: (Pattern)
            _leftPatternOclassname :: (Maybe Name)
            _leftPatternOconstructors_collect :: (FMap Name Names)
            _leftPatternOconstructors_dist :: (FMap Name Names)
            _leftPatternOcurrentModule :: (Strings)
            _leftPatternOgenericAbstractions :: (FMap Name Kind)
            _leftPatternOgenericAbstractions_collect :: (FMap Name Kind)
            _leftPatternOghc :: (Bool)
            _leftPatternOimportedModule :: (Bool)
            _leftPatternOinstancename :: (Maybe Name)
            _leftPatternOlabels_collect :: (FMap Name Names)
            _leftPatternOlabels_dist :: (FMap Name Names)
            _leftPatternOlocal :: (Bool)
            _leftPatternOmethods_collect :: (FMap Name Names)
            _leftPatternOmethods_dist :: (FMap Name Names)
            _leftPatternOmodules :: (Set Strings)
            _leftPatternOoptimizer :: (Bool)
            _leftPatternOoptimizerPrelude :: (Declarations)
            _leftPatternOprelude :: (Bool)
            _leftPatternOtoplevel :: (Bool)
            _leftPatternOverbosity :: (Int)
            _constructorOperatorIconstructors_collect :: (FMap Name Names)
            _constructorOperatorIgenericAbstractions_collect :: (FMap Name Kind)
            _constructorOperatorIlabels_collect :: (FMap Name Names)
            _constructorOperatorImethods_collect :: (FMap Name Names)
            _constructorOperatorIself :: (Name)
            _constructorOperatorOclassname :: (Maybe Name)
            _constructorOperatorOconstructors_collect :: (FMap Name Names)
            _constructorOperatorOconstructors_dist :: (FMap Name Names)
            _constructorOperatorOcurrentModule :: (Strings)
            _constructorOperatorOgenericAbstractions :: (FMap Name Kind)
            _constructorOperatorOgenericAbstractions_collect :: (FMap Name Kind)
            _constructorOperatorOghc :: (Bool)
            _constructorOperatorOimportedModule :: (Bool)
            _constructorOperatorOinstancename :: (Maybe Name)
            _constructorOperatorOlabels_collect :: (FMap Name Names)
            _constructorOperatorOlabels_dist :: (FMap Name Names)
            _constructorOperatorOlocal :: (Bool)
            _constructorOperatorOmethods_collect :: (FMap Name Names)
            _constructorOperatorOmethods_dist :: (FMap Name Names)
            _constructorOperatorOmodules :: (Set Strings)
            _constructorOperatorOoptimizer :: (Bool)
            _constructorOperatorOoptimizerPrelude :: (Declarations)
            _constructorOperatorOprelude :: (Bool)
            _constructorOperatorOtoplevel :: (Bool)
            _constructorOperatorOverbosity :: (Int)
            _rightPatternIconstructors_collect :: (FMap Name Names)
            _rightPatternIgenericAbstractions_collect :: (FMap Name Kind)
            _rightPatternIlabels_collect :: (FMap Name Names)
            _rightPatternImethods_collect :: (FMap Name Names)
            _rightPatternIname :: (Name)
            _rightPatternIself :: (Pattern)
            _rightPatternOclassname :: (Maybe Name)
            _rightPatternOconstructors_collect :: (FMap Name Names)
            _rightPatternOconstructors_dist :: (FMap Name Names)
            _rightPatternOcurrentModule :: (Strings)
            _rightPatternOgenericAbstractions :: (FMap Name Kind)
            _rightPatternOgenericAbstractions_collect :: (FMap Name Kind)
            _rightPatternOghc :: (Bool)
            _rightPatternOimportedModule :: (Bool)
            _rightPatternOinstancename :: (Maybe Name)
            _rightPatternOlabels_collect :: (FMap Name Names)
            _rightPatternOlabels_dist :: (FMap Name Names)
            _rightPatternOlocal :: (Bool)
            _rightPatternOmethods_collect :: (FMap Name Names)
            _rightPatternOmethods_dist :: (FMap Name Names)
            _rightPatternOmodules :: (Set Strings)
            _rightPatternOoptimizer :: (Bool)
            _rightPatternOoptimizerPrelude :: (Declarations)
            _rightPatternOprelude :: (Bool)
            _rightPatternOtoplevel :: (Bool)
            _rightPatternOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _leftPatternIconstructors_collect,_leftPatternIgenericAbstractions_collect,_leftPatternIlabels_collect,_leftPatternImethods_collect,_leftPatternIname,_leftPatternIself) =
                (leftPattern_ (_leftPatternOclassname)
                              (_leftPatternOconstructors_collect)
                              (_leftPatternOconstructors_dist)
                              (_leftPatternOcurrentModule)
                              (_leftPatternOgenericAbstractions)
                              (_leftPatternOgenericAbstractions_collect)
                              (_leftPatternOghc)
                              (_leftPatternOimportedModule)
                              (_leftPatternOinstancename)
                              (_leftPatternOlabels_collect)
                              (_leftPatternOlabels_dist)
                              (_leftPatternOlocal)
                              (_leftPatternOmethods_collect)
                              (_leftPatternOmethods_dist)
                              (_leftPatternOmodules)
                              (_leftPatternOoptimizer)
                              (_leftPatternOoptimizerPrelude)
                              (_leftPatternOprelude)
                              (_leftPatternOtoplevel)
                              (_leftPatternOverbosity))
            ( _constructorOperatorIconstructors_collect,_constructorOperatorIgenericAbstractions_collect,_constructorOperatorIlabels_collect,_constructorOperatorImethods_collect,_constructorOperatorIself) =
                (constructorOperator_ (_constructorOperatorOclassname)
                                      (_constructorOperatorOconstructors_collect)
                                      (_constructorOperatorOconstructors_dist)
                                      (_constructorOperatorOcurrentModule)
                                      (_constructorOperatorOgenericAbstractions)
                                      (_constructorOperatorOgenericAbstractions_collect)
                                      (_constructorOperatorOghc)
                                      (_constructorOperatorOimportedModule)
                                      (_constructorOperatorOinstancename)
                                      (_constructorOperatorOlabels_collect)
                                      (_constructorOperatorOlabels_dist)
                                      (_constructorOperatorOlocal)
                                      (_constructorOperatorOmethods_collect)
                                      (_constructorOperatorOmethods_dist)
                                      (_constructorOperatorOmodules)
                                      (_constructorOperatorOoptimizer)
                                      (_constructorOperatorOoptimizerPrelude)
                                      (_constructorOperatorOprelude)
                                      (_constructorOperatorOtoplevel)
                                      (_constructorOperatorOverbosity))
            ( _rightPatternIconstructors_collect,_rightPatternIgenericAbstractions_collect,_rightPatternIlabels_collect,_rightPatternImethods_collect,_rightPatternIname,_rightPatternIself) =
                (rightPattern_ (_rightPatternOclassname)
                               (_rightPatternOconstructors_collect)
                               (_rightPatternOconstructors_dist)
                               (_rightPatternOcurrentModule)
                               (_rightPatternOgenericAbstractions)
                               (_rightPatternOgenericAbstractions_collect)
                               (_rightPatternOghc)
                               (_rightPatternOimportedModule)
                               (_rightPatternOinstancename)
                               (_rightPatternOlabels_collect)
                               (_rightPatternOlabels_dist)
                               (_rightPatternOlocal)
                               (_rightPatternOmethods_collect)
                               (_rightPatternOmethods_dist)
                               (_rightPatternOmodules)
                               (_rightPatternOoptimizer)
                               (_rightPatternOoptimizerPrelude)
                               (_rightPatternOprelude)
                               (_rightPatternOtoplevel)
                               (_rightPatternOverbosity))
            -- "./ModuleInformation.inc.lag"(line 447, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.Pattern.InfixConstructor.name: pattern binding in class/instance"
            -- self rule
            (_self@_) =
                Pattern_InfixConstructor _rangeIself _leftPatternIself _constructorOperatorIself _rightPatternIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _rightPatternIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _rightPatternIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _rightPatternIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _rightPatternImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_leftPatternOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_leftPatternOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_leftPatternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_leftPatternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_leftPatternOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_leftPatternOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_leftPatternOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_leftPatternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_leftPatternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_leftPatternOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_leftPatternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_leftPatternOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_leftPatternOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_leftPatternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_leftPatternOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_leftPatternOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_leftPatternOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_leftPatternOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_leftPatternOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_leftPatternOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_constructorOperatorOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_constructorOperatorOconstructors_collect@_) =
                _leftPatternIconstructors_collect
            -- copy rule (down)
            (_constructorOperatorOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_constructorOperatorOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_constructorOperatorOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_constructorOperatorOgenericAbstractions_collect@_) =
                _leftPatternIgenericAbstractions_collect
            -- copy rule (down)
            (_constructorOperatorOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_constructorOperatorOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_constructorOperatorOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_constructorOperatorOlabels_collect@_) =
                _leftPatternIlabels_collect
            -- copy rule (down)
            (_constructorOperatorOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_constructorOperatorOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_constructorOperatorOmethods_collect@_) =
                _leftPatternImethods_collect
            -- copy rule (down)
            (_constructorOperatorOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_constructorOperatorOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_constructorOperatorOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_constructorOperatorOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_constructorOperatorOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_constructorOperatorOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_constructorOperatorOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_rightPatternOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_rightPatternOconstructors_collect@_) =
                _constructorOperatorIconstructors_collect
            -- copy rule (down)
            (_rightPatternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_rightPatternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rightPatternOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_rightPatternOgenericAbstractions_collect@_) =
                _constructorOperatorIgenericAbstractions_collect
            -- copy rule (down)
            (_rightPatternOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_rightPatternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rightPatternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_rightPatternOlabels_collect@_) =
                _constructorOperatorIlabels_collect
            -- copy rule (down)
            (_rightPatternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_rightPatternOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_rightPatternOmethods_collect@_) =
                _constructorOperatorImethods_collect
            -- copy rule (down)
            (_rightPatternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_rightPatternOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_rightPatternOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_rightPatternOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_rightPatternOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_rightPatternOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_rightPatternOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
sem_Pattern_Irrefutable :: (T_Range) ->
                           (T_Pattern) ->
                           (T_Pattern)
sem_Pattern_Irrefutable (range_) (pattern_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _patternIconstructors_collect :: (FMap Name Names)
            _patternIgenericAbstractions_collect :: (FMap Name Kind)
            _patternIlabels_collect :: (FMap Name Names)
            _patternImethods_collect :: (FMap Name Names)
            _patternIname :: (Name)
            _patternIself :: (Pattern)
            _patternOclassname :: (Maybe Name)
            _patternOconstructors_collect :: (FMap Name Names)
            _patternOconstructors_dist :: (FMap Name Names)
            _patternOcurrentModule :: (Strings)
            _patternOgenericAbstractions :: (FMap Name Kind)
            _patternOgenericAbstractions_collect :: (FMap Name Kind)
            _patternOghc :: (Bool)
            _patternOimportedModule :: (Bool)
            _patternOinstancename :: (Maybe Name)
            _patternOlabels_collect :: (FMap Name Names)
            _patternOlabels_dist :: (FMap Name Names)
            _patternOlocal :: (Bool)
            _patternOmethods_collect :: (FMap Name Names)
            _patternOmethods_dist :: (FMap Name Names)
            _patternOmodules :: (Set Strings)
            _patternOoptimizer :: (Bool)
            _patternOoptimizerPrelude :: (Declarations)
            _patternOprelude :: (Bool)
            _patternOtoplevel :: (Bool)
            _patternOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _patternIconstructors_collect,_patternIgenericAbstractions_collect,_patternIlabels_collect,_patternImethods_collect,_patternIname,_patternIself) =
                (pattern_ (_patternOclassname)
                          (_patternOconstructors_collect)
                          (_patternOconstructors_dist)
                          (_patternOcurrentModule)
                          (_patternOgenericAbstractions)
                          (_patternOgenericAbstractions_collect)
                          (_patternOghc)
                          (_patternOimportedModule)
                          (_patternOinstancename)
                          (_patternOlabels_collect)
                          (_patternOlabels_dist)
                          (_patternOlocal)
                          (_patternOmethods_collect)
                          (_patternOmethods_dist)
                          (_patternOmodules)
                          (_patternOoptimizer)
                          (_patternOoptimizerPrelude)
                          (_patternOprelude)
                          (_patternOtoplevel)
                          (_patternOverbosity))
            -- self rule
            (_self@_) =
                Pattern_Irrefutable _rangeIself _patternIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _patternIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _patternIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _patternIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _patternImethods_collect
            -- copy rule (up)
            (_lhsOname@_) =
                _patternIname
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_patternOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_patternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_patternOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_patternOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_patternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_patternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_patternOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_patternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_patternOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_patternOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_patternOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_patternOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
sem_Pattern_List :: (T_Range) ->
                    (T_Patterns) ->
                    (T_Pattern)
sem_Pattern_List (range_) (patterns_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _patternsIconstructors_collect :: (FMap Name Names)
            _patternsIgenericAbstractions_collect :: (FMap Name Kind)
            _patternsIlabels_collect :: (FMap Name Names)
            _patternsImethods_collect :: (FMap Name Names)
            _patternsIself :: (Patterns)
            _patternsOclassname :: (Maybe Name)
            _patternsOconstructors_collect :: (FMap Name Names)
            _patternsOconstructors_dist :: (FMap Name Names)
            _patternsOcurrentModule :: (Strings)
            _patternsOgenericAbstractions :: (FMap Name Kind)
            _patternsOgenericAbstractions_collect :: (FMap Name Kind)
            _patternsOghc :: (Bool)
            _patternsOimportedModule :: (Bool)
            _patternsOinstancename :: (Maybe Name)
            _patternsOlabels_collect :: (FMap Name Names)
            _patternsOlabels_dist :: (FMap Name Names)
            _patternsOlocal :: (Bool)
            _patternsOmethods_collect :: (FMap Name Names)
            _patternsOmethods_dist :: (FMap Name Names)
            _patternsOmodules :: (Set Strings)
            _patternsOoptimizer :: (Bool)
            _patternsOoptimizerPrelude :: (Declarations)
            _patternsOprelude :: (Bool)
            _patternsOtoplevel :: (Bool)
            _patternsOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _patternsIconstructors_collect,_patternsIgenericAbstractions_collect,_patternsIlabels_collect,_patternsImethods_collect,_patternsIself) =
                (patterns_ (_patternsOclassname)
                           (_patternsOconstructors_collect)
                           (_patternsOconstructors_dist)
                           (_patternsOcurrentModule)
                           (_patternsOgenericAbstractions)
                           (_patternsOgenericAbstractions_collect)
                           (_patternsOghc)
                           (_patternsOimportedModule)
                           (_patternsOinstancename)
                           (_patternsOlabels_collect)
                           (_patternsOlabels_dist)
                           (_patternsOlocal)
                           (_patternsOmethods_collect)
                           (_patternsOmethods_dist)
                           (_patternsOmodules)
                           (_patternsOoptimizer)
                           (_patternsOoptimizerPrelude)
                           (_patternsOprelude)
                           (_patternsOtoplevel)
                           (_patternsOverbosity))
            -- "./ModuleInformation.inc.lag"(line 450, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.Pattern.List.name: pattern binding in class/instance"
            -- self rule
            (_self@_) =
                Pattern_List _rangeIself _patternsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _patternsIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _patternsIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _patternsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _patternsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_patternsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_patternsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_patternsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_patternsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_patternsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_patternsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_patternsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_patternsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_patternsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_patternsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_patternsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_patternsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
sem_Pattern_Literal :: (T_Range) ->
                       (T_Literal) ->
                       (T_Pattern)
sem_Pattern_Literal (range_) (literal_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _literalIconstructors_collect :: (FMap Name Names)
            _literalIgenericAbstractions_collect :: (FMap Name Kind)
            _literalIlabels_collect :: (FMap Name Names)
            _literalImethods_collect :: (FMap Name Names)
            _literalIself :: (Literal)
            _literalOclassname :: (Maybe Name)
            _literalOconstructors_collect :: (FMap Name Names)
            _literalOconstructors_dist :: (FMap Name Names)
            _literalOcurrentModule :: (Strings)
            _literalOgenericAbstractions :: (FMap Name Kind)
            _literalOgenericAbstractions_collect :: (FMap Name Kind)
            _literalOghc :: (Bool)
            _literalOimportedModule :: (Bool)
            _literalOinstancename :: (Maybe Name)
            _literalOlabels_collect :: (FMap Name Names)
            _literalOlabels_dist :: (FMap Name Names)
            _literalOlocal :: (Bool)
            _literalOmethods_collect :: (FMap Name Names)
            _literalOmethods_dist :: (FMap Name Names)
            _literalOmodules :: (Set Strings)
            _literalOoptimizer :: (Bool)
            _literalOoptimizerPrelude :: (Declarations)
            _literalOprelude :: (Bool)
            _literalOtoplevel :: (Bool)
            _literalOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _literalIconstructors_collect,_literalIgenericAbstractions_collect,_literalIlabels_collect,_literalImethods_collect,_literalIself) =
                (literal_ (_literalOclassname)
                          (_literalOconstructors_collect)
                          (_literalOconstructors_dist)
                          (_literalOcurrentModule)
                          (_literalOgenericAbstractions)
                          (_literalOgenericAbstractions_collect)
                          (_literalOghc)
                          (_literalOimportedModule)
                          (_literalOinstancename)
                          (_literalOlabels_collect)
                          (_literalOlabels_dist)
                          (_literalOlocal)
                          (_literalOmethods_collect)
                          (_literalOmethods_dist)
                          (_literalOmodules)
                          (_literalOoptimizer)
                          (_literalOoptimizerPrelude)
                          (_literalOprelude)
                          (_literalOtoplevel)
                          (_literalOverbosity))
            -- "./ModuleInformation.inc.lag"(line 441, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.Pattern.Literal.name: pattern binding in class/instance"
            -- self rule
            (_self@_) =
                Pattern_Literal _rangeIself _literalIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _literalIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _literalIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _literalIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _literalImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_literalOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_literalOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_literalOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_literalOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_literalOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_literalOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_literalOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_literalOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_literalOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_literalOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_literalOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_literalOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_literalOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_literalOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_literalOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_literalOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_literalOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_literalOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_literalOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_literalOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
sem_Pattern_Negate :: (T_Range) ->
                      (T_Literal) ->
                      (T_Pattern)
sem_Pattern_Negate (range_) (literal_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _literalIconstructors_collect :: (FMap Name Names)
            _literalIgenericAbstractions_collect :: (FMap Name Kind)
            _literalIlabels_collect :: (FMap Name Names)
            _literalImethods_collect :: (FMap Name Names)
            _literalIself :: (Literal)
            _literalOclassname :: (Maybe Name)
            _literalOconstructors_collect :: (FMap Name Names)
            _literalOconstructors_dist :: (FMap Name Names)
            _literalOcurrentModule :: (Strings)
            _literalOgenericAbstractions :: (FMap Name Kind)
            _literalOgenericAbstractions_collect :: (FMap Name Kind)
            _literalOghc :: (Bool)
            _literalOimportedModule :: (Bool)
            _literalOinstancename :: (Maybe Name)
            _literalOlabels_collect :: (FMap Name Names)
            _literalOlabels_dist :: (FMap Name Names)
            _literalOlocal :: (Bool)
            _literalOmethods_collect :: (FMap Name Names)
            _literalOmethods_dist :: (FMap Name Names)
            _literalOmodules :: (Set Strings)
            _literalOoptimizer :: (Bool)
            _literalOoptimizerPrelude :: (Declarations)
            _literalOprelude :: (Bool)
            _literalOtoplevel :: (Bool)
            _literalOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _literalIconstructors_collect,_literalIgenericAbstractions_collect,_literalIlabels_collect,_literalImethods_collect,_literalIself) =
                (literal_ (_literalOclassname)
                          (_literalOconstructors_collect)
                          (_literalOconstructors_dist)
                          (_literalOcurrentModule)
                          (_literalOgenericAbstractions)
                          (_literalOgenericAbstractions_collect)
                          (_literalOghc)
                          (_literalOimportedModule)
                          (_literalOinstancename)
                          (_literalOlabels_collect)
                          (_literalOlabels_dist)
                          (_literalOlocal)
                          (_literalOmethods_collect)
                          (_literalOmethods_dist)
                          (_literalOmodules)
                          (_literalOoptimizer)
                          (_literalOoptimizerPrelude)
                          (_literalOprelude)
                          (_literalOtoplevel)
                          (_literalOverbosity))
            -- "./ModuleInformation.inc.lag"(line 459, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.Pattern.Negate.name: pattern binding in class/instance"
            -- self rule
            (_self@_) =
                Pattern_Negate _rangeIself _literalIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _literalIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _literalIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _literalIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _literalImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_literalOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_literalOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_literalOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_literalOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_literalOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_literalOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_literalOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_literalOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_literalOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_literalOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_literalOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_literalOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_literalOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_literalOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_literalOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_literalOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_literalOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_literalOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_literalOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_literalOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
sem_Pattern_Parenthesized :: (T_Range) ->
                             (T_Pattern) ->
                             (T_Pattern)
sem_Pattern_Parenthesized (range_) (pattern_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _patternIconstructors_collect :: (FMap Name Names)
            _patternIgenericAbstractions_collect :: (FMap Name Kind)
            _patternIlabels_collect :: (FMap Name Names)
            _patternImethods_collect :: (FMap Name Names)
            _patternIname :: (Name)
            _patternIself :: (Pattern)
            _patternOclassname :: (Maybe Name)
            _patternOconstructors_collect :: (FMap Name Names)
            _patternOconstructors_dist :: (FMap Name Names)
            _patternOcurrentModule :: (Strings)
            _patternOgenericAbstractions :: (FMap Name Kind)
            _patternOgenericAbstractions_collect :: (FMap Name Kind)
            _patternOghc :: (Bool)
            _patternOimportedModule :: (Bool)
            _patternOinstancename :: (Maybe Name)
            _patternOlabels_collect :: (FMap Name Names)
            _patternOlabels_dist :: (FMap Name Names)
            _patternOlocal :: (Bool)
            _patternOmethods_collect :: (FMap Name Names)
            _patternOmethods_dist :: (FMap Name Names)
            _patternOmodules :: (Set Strings)
            _patternOoptimizer :: (Bool)
            _patternOoptimizerPrelude :: (Declarations)
            _patternOprelude :: (Bool)
            _patternOtoplevel :: (Bool)
            _patternOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _patternIconstructors_collect,_patternIgenericAbstractions_collect,_patternIlabels_collect,_patternImethods_collect,_patternIname,_patternIself) =
                (pattern_ (_patternOclassname)
                          (_patternOconstructors_collect)
                          (_patternOconstructors_dist)
                          (_patternOcurrentModule)
                          (_patternOgenericAbstractions)
                          (_patternOgenericAbstractions_collect)
                          (_patternOghc)
                          (_patternOimportedModule)
                          (_patternOinstancename)
                          (_patternOlabels_collect)
                          (_patternOlabels_dist)
                          (_patternOlocal)
                          (_patternOmethods_collect)
                          (_patternOmethods_dist)
                          (_patternOmodules)
                          (_patternOoptimizer)
                          (_patternOoptimizerPrelude)
                          (_patternOprelude)
                          (_patternOtoplevel)
                          (_patternOverbosity))
            -- self rule
            (_self@_) =
                Pattern_Parenthesized _rangeIself _patternIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _patternIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _patternIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _patternIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _patternImethods_collect
            -- copy rule (up)
            (_lhsOname@_) =
                _patternIname
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_patternOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_patternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_patternOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_patternOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_patternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_patternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_patternOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_patternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_patternOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_patternOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_patternOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_patternOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
sem_Pattern_Record :: (T_Range) ->
                      (T_Name) ->
                      (T_RecordPatternBindings) ->
                      (T_Pattern)
sem_Pattern_Record (range_) (name_) (recordPatternBindings_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _recordPatternBindingsIconstructors_collect :: (FMap Name Names)
            _recordPatternBindingsIgenericAbstractions_collect :: (FMap Name Kind)
            _recordPatternBindingsIlabels_collect :: (FMap Name Names)
            _recordPatternBindingsImethods_collect :: (FMap Name Names)
            _recordPatternBindingsIself :: (RecordPatternBindings)
            _recordPatternBindingsOclassname :: (Maybe Name)
            _recordPatternBindingsOconstructors_collect :: (FMap Name Names)
            _recordPatternBindingsOconstructors_dist :: (FMap Name Names)
            _recordPatternBindingsOcurrentModule :: (Strings)
            _recordPatternBindingsOgenericAbstractions :: (FMap Name Kind)
            _recordPatternBindingsOgenericAbstractions_collect :: (FMap Name Kind)
            _recordPatternBindingsOghc :: (Bool)
            _recordPatternBindingsOimportedModule :: (Bool)
            _recordPatternBindingsOinstancename :: (Maybe Name)
            _recordPatternBindingsOlabels_collect :: (FMap Name Names)
            _recordPatternBindingsOlabels_dist :: (FMap Name Names)
            _recordPatternBindingsOlocal :: (Bool)
            _recordPatternBindingsOmethods_collect :: (FMap Name Names)
            _recordPatternBindingsOmethods_dist :: (FMap Name Names)
            _recordPatternBindingsOmodules :: (Set Strings)
            _recordPatternBindingsOoptimizer :: (Bool)
            _recordPatternBindingsOoptimizerPrelude :: (Declarations)
            _recordPatternBindingsOprelude :: (Bool)
            _recordPatternBindingsOtoplevel :: (Bool)
            _recordPatternBindingsOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _recordPatternBindingsIconstructors_collect,_recordPatternBindingsIgenericAbstractions_collect,_recordPatternBindingsIlabels_collect,_recordPatternBindingsImethods_collect,_recordPatternBindingsIself) =
                (recordPatternBindings_ (_recordPatternBindingsOclassname)
                                        (_recordPatternBindingsOconstructors_collect)
                                        (_recordPatternBindingsOconstructors_dist)
                                        (_recordPatternBindingsOcurrentModule)
                                        (_recordPatternBindingsOgenericAbstractions)
                                        (_recordPatternBindingsOgenericAbstractions_collect)
                                        (_recordPatternBindingsOghc)
                                        (_recordPatternBindingsOimportedModule)
                                        (_recordPatternBindingsOinstancename)
                                        (_recordPatternBindingsOlabels_collect)
                                        (_recordPatternBindingsOlabels_dist)
                                        (_recordPatternBindingsOlocal)
                                        (_recordPatternBindingsOmethods_collect)
                                        (_recordPatternBindingsOmethods_dist)
                                        (_recordPatternBindingsOmodules)
                                        (_recordPatternBindingsOoptimizer)
                                        (_recordPatternBindingsOoptimizerPrelude)
                                        (_recordPatternBindingsOprelude)
                                        (_recordPatternBindingsOtoplevel)
                                        (_recordPatternBindingsOverbosity))
            -- "./ModuleInformation.inc.lag"(line 456, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.Pattern.Record.name: pattern binding in class/instance"
            -- self rule
            (_self@_) =
                Pattern_Record _rangeIself _nameIself _recordPatternBindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _recordPatternBindingsIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _recordPatternBindingsIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _recordPatternBindingsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _recordPatternBindingsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_recordPatternBindingsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_recordPatternBindingsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_recordPatternBindingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_recordPatternBindingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_recordPatternBindingsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_recordPatternBindingsOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_recordPatternBindingsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_recordPatternBindingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_recordPatternBindingsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_recordPatternBindingsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_recordPatternBindingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_recordPatternBindingsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_recordPatternBindingsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_recordPatternBindingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_recordPatternBindingsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_recordPatternBindingsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_recordPatternBindingsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_recordPatternBindingsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_recordPatternBindingsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_recordPatternBindingsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
sem_Pattern_Successor :: (T_Range) ->
                         (T_Name) ->
                         (T_Literal) ->
                         (T_Pattern)
sem_Pattern_Successor (range_) (name_) (literal_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _literalIconstructors_collect :: (FMap Name Names)
            _literalIgenericAbstractions_collect :: (FMap Name Kind)
            _literalIlabels_collect :: (FMap Name Names)
            _literalImethods_collect :: (FMap Name Names)
            _literalIself :: (Literal)
            _literalOclassname :: (Maybe Name)
            _literalOconstructors_collect :: (FMap Name Names)
            _literalOconstructors_dist :: (FMap Name Names)
            _literalOcurrentModule :: (Strings)
            _literalOgenericAbstractions :: (FMap Name Kind)
            _literalOgenericAbstractions_collect :: (FMap Name Kind)
            _literalOghc :: (Bool)
            _literalOimportedModule :: (Bool)
            _literalOinstancename :: (Maybe Name)
            _literalOlabels_collect :: (FMap Name Names)
            _literalOlabels_dist :: (FMap Name Names)
            _literalOlocal :: (Bool)
            _literalOmethods_collect :: (FMap Name Names)
            _literalOmethods_dist :: (FMap Name Names)
            _literalOmodules :: (Set Strings)
            _literalOoptimizer :: (Bool)
            _literalOoptimizerPrelude :: (Declarations)
            _literalOprelude :: (Bool)
            _literalOtoplevel :: (Bool)
            _literalOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _literalIconstructors_collect,_literalIgenericAbstractions_collect,_literalIlabels_collect,_literalImethods_collect,_literalIself) =
                (literal_ (_literalOclassname)
                          (_literalOconstructors_collect)
                          (_literalOconstructors_dist)
                          (_literalOcurrentModule)
                          (_literalOgenericAbstractions)
                          (_literalOgenericAbstractions_collect)
                          (_literalOghc)
                          (_literalOimportedModule)
                          (_literalOinstancename)
                          (_literalOlabels_collect)
                          (_literalOlabels_dist)
                          (_literalOlocal)
                          (_literalOmethods_collect)
                          (_literalOmethods_dist)
                          (_literalOmodules)
                          (_literalOoptimizer)
                          (_literalOoptimizerPrelude)
                          (_literalOprelude)
                          (_literalOtoplevel)
                          (_literalOverbosity))
            -- "./ModuleInformation.inc.lag"(line 468, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.Pattern.Successor.name: pattern binding in class/instance"
            -- self rule
            (_self@_) =
                Pattern_Successor _rangeIself _nameIself _literalIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _literalIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _literalIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _literalIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _literalImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_literalOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_literalOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_literalOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_literalOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_literalOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_literalOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_literalOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_literalOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_literalOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_literalOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_literalOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_literalOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_literalOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_literalOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_literalOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_literalOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_literalOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_literalOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_literalOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_literalOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
sem_Pattern_Tuple :: (T_Range) ->
                     (T_Patterns) ->
                     (T_Pattern)
sem_Pattern_Tuple (range_) (patterns_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _patternsIconstructors_collect :: (FMap Name Names)
            _patternsIgenericAbstractions_collect :: (FMap Name Kind)
            _patternsIlabels_collect :: (FMap Name Names)
            _patternsImethods_collect :: (FMap Name Names)
            _patternsIself :: (Patterns)
            _patternsOclassname :: (Maybe Name)
            _patternsOconstructors_collect :: (FMap Name Names)
            _patternsOconstructors_dist :: (FMap Name Names)
            _patternsOcurrentModule :: (Strings)
            _patternsOgenericAbstractions :: (FMap Name Kind)
            _patternsOgenericAbstractions_collect :: (FMap Name Kind)
            _patternsOghc :: (Bool)
            _patternsOimportedModule :: (Bool)
            _patternsOinstancename :: (Maybe Name)
            _patternsOlabels_collect :: (FMap Name Names)
            _patternsOlabels_dist :: (FMap Name Names)
            _patternsOlocal :: (Bool)
            _patternsOmethods_collect :: (FMap Name Names)
            _patternsOmethods_dist :: (FMap Name Names)
            _patternsOmodules :: (Set Strings)
            _patternsOoptimizer :: (Bool)
            _patternsOoptimizerPrelude :: (Declarations)
            _patternsOprelude :: (Bool)
            _patternsOtoplevel :: (Bool)
            _patternsOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _patternsIconstructors_collect,_patternsIgenericAbstractions_collect,_patternsIlabels_collect,_patternsImethods_collect,_patternsIself) =
                (patterns_ (_patternsOclassname)
                           (_patternsOconstructors_collect)
                           (_patternsOconstructors_dist)
                           (_patternsOcurrentModule)
                           (_patternsOgenericAbstractions)
                           (_patternsOgenericAbstractions_collect)
                           (_patternsOghc)
                           (_patternsOimportedModule)
                           (_patternsOinstancename)
                           (_patternsOlabels_collect)
                           (_patternsOlabels_dist)
                           (_patternsOlocal)
                           (_patternsOmethods_collect)
                           (_patternsOmethods_dist)
                           (_patternsOmodules)
                           (_patternsOoptimizer)
                           (_patternsOoptimizerPrelude)
                           (_patternsOprelude)
                           (_patternsOtoplevel)
                           (_patternsOverbosity))
            -- "./ModuleInformation.inc.lag"(line 453, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.Pattern.Tuple.name: pattern binding in class/instance"
            -- self rule
            (_self@_) =
                Pattern_Tuple _rangeIself _patternsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _patternsIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _patternsIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _patternsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _patternsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_patternsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_patternsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_patternsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_patternsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_patternsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_patternsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_patternsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_patternsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_patternsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_patternsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_patternsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_patternsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
sem_Pattern_Variable :: (T_Range) ->
                        (T_Name) ->
                        (T_Pattern)
sem_Pattern_Variable (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            -- "./ModuleInformation.inc.lag"(line 439, column 9)
            (_lhsOname@_) =
                _nameIself
            -- self rule
            (_self@_) =
                Pattern_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
sem_Pattern_Wildcard :: (T_Range) ->
                        (T_Pattern)
sem_Pattern_Wildcard (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 465, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.Pattern.Wildcard.name: pattern binding in class/instance"
            -- self rule
            (_self@_) =
                Pattern_Wildcard _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
-- Patterns ----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Patterns.Cons:
      self

-}
{-
   local variables for Patterns.Nil:
      self

-}
-- semantic domain
type T_Patterns = (Maybe Name) ->
                  (FMap Name Names) ->
                  (FMap Name Names) ->
                  (Strings) ->
                  (FMap Name Kind) ->
                  (FMap Name Kind) ->
                  (Bool) ->
                  (Bool) ->
                  (Maybe Name) ->
                  (FMap Name Names) ->
                  (FMap Name Names) ->
                  (Bool) ->
                  (FMap Name Names) ->
                  (FMap Name Names) ->
                  (Set Strings) ->
                  (Bool) ->
                  (Declarations) ->
                  (Bool) ->
                  (Bool) ->
                  (Int) ->
                  ( (FMap Name Names),(FMap Name Kind),(FMap Name Names),(FMap Name Names),(Patterns))
-- cata
sem_Patterns :: (Patterns) ->
                (T_Patterns)
sem_Patterns (list) =
    (foldr (sem_Patterns_Cons) (sem_Patterns_Nil) ((map sem_Pattern list)))
sem_Patterns_Cons :: (T_Pattern) ->
                     (T_Patterns) ->
                     (T_Patterns)
sem_Patterns_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Patterns)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIgenericAbstractions_collect :: (FMap Name Kind)
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIname :: (Name)
            _hdIself :: (Pattern)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOgenericAbstractions :: (FMap Name Kind)
            _hdOgenericAbstractions_collect :: (FMap Name Kind)
            _hdOghc :: (Bool)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmodules :: (Set Strings)
            _hdOoptimizer :: (Bool)
            _hdOoptimizerPrelude :: (Declarations)
            _hdOprelude :: (Bool)
            _hdOtoplevel :: (Bool)
            _hdOverbosity :: (Int)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIgenericAbstractions_collect :: (FMap Name Kind)
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIself :: (Patterns)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOgenericAbstractions :: (FMap Name Kind)
            _tlOgenericAbstractions_collect :: (FMap Name Kind)
            _tlOghc :: (Bool)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmodules :: (Set Strings)
            _tlOoptimizer :: (Bool)
            _tlOoptimizerPrelude :: (Declarations)
            _tlOprelude :: (Bool)
            _tlOtoplevel :: (Bool)
            _tlOverbosity :: (Int)
            ( _hdIconstructors_collect,_hdIgenericAbstractions_collect,_hdIlabels_collect,_hdImethods_collect,_hdIname,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOgenericAbstractions) (_hdOgenericAbstractions_collect) (_hdOghc) (_hdOimportedModule) (_hdOinstancename) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOmodules) (_hdOoptimizer) (_hdOoptimizerPrelude) (_hdOprelude) (_hdOtoplevel) (_hdOverbosity))
            ( _tlIconstructors_collect,_tlIgenericAbstractions_collect,_tlIlabels_collect,_tlImethods_collect,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOgenericAbstractions) (_tlOgenericAbstractions_collect) (_tlOghc) (_tlOimportedModule) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOmodules) (_tlOoptimizer) (_tlOoptimizerPrelude) (_tlOprelude) (_tlOtoplevel) (_tlOverbosity))
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _tlIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_hdOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_hdOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_hdOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_hdOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_hdOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_hdOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_tlOgenericAbstractions_collect@_) =
                _hdIgenericAbstractions_collect
            -- copy rule (down)
            (_tlOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_tlOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_tlOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_tlOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Patterns_Nil :: (T_Patterns)
sem_Patterns_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Patterns)
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- Position ----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      local                : Bool
      toplevel             : Bool

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Position.Position:
      self

-}
{-
   local variables for Position.Unknown:
      self

-}
-- semantic domain
type T_Position = (Maybe Name) ->
                  (Strings) ->
                  (Bool) ->
                  (Maybe Name) ->
                  (Bool) ->
                  (Bool) ->
                  ( (Position))
-- cata
sem_Position :: (Position) ->
                (T_Position)
sem_Position ((Position_Position (_filename) (_line) (_column))) =
    (sem_Position_Position (_filename) (_line) (_column))
sem_Position ((Position_Unknown )) =
    (sem_Position_Unknown )
sem_Position_Position :: (String) ->
                         (Int) ->
                         (Int) ->
                         (T_Position)
sem_Position_Position (filename_) (line_) (column_) =
    \ _lhsIclassname
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlocal
      _lhsItoplevel ->
        let _lhsOself :: (Position)
            -- self rule
            (_self@_) =
                Position_Position filename_ line_ column_
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOself)
sem_Position_Unknown :: (T_Position)
sem_Position_Unknown  =
    \ _lhsIclassname
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlocal
      _lhsItoplevel ->
        let _lhsOself :: (Position)
            -- self rule
            (_self@_) =
                Position_Unknown
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOself)
-- Qualifier ---------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      exportedStructures   : Set Name
      exportedTypes        : Set Name
      exportedValues       : Set Name
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures
      rawRequests_collect  : [RawRequest]
      structureTypes_collect : FMap Name LambdaType
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      kind_errors          : [GHError]
      self                 : SELF
      staticErrors         : [GHError]

-}
{-
   local variables for Qualifier.Empty:
      self

-}
{-
   local variables for Qualifier.Generator:
      self

-}
{-
   local variables for Qualifier.Guard:
      self

-}
{-
   local variables for Qualifier.Let:
      self

-}
-- semantic domain
type T_Qualifier = (Set Name) ->
                   ([Request_BimapImply]) ->
                   (Maybe Name) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (Strings) ->
                   (FMap Name [(Name,Name)]) ->
                   (Set Name) ->
                   (Set Name) ->
                   (Set Name) ->
                   ([Request_FunImply]) ->
                   (FMap Name Kind) ->
                   (FMap Name Kind) ->
                   (Bool) ->
                   (Bool) ->
                   (Maybe Name) ->
                   (KSubst) ->
                   (FMap Name KindIndexedType) ->
                   (FMap Name KindIndexedType) ->
                   (KSubst) ->
                   (Int) ->
                   (KSubst) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (Bool) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (Set Strings) ->
                   (Bool) ->
                   (Declarations) ->
                   (KSubst) ->
                   (Bool) ->
                   (PreSignatures) ->
                   (PreSignatures) ->
                   ([RawRequest]) ->
                   (Signatures) ->
                   (FMap Name LambdaType) ->
                   (Bool) ->
                   ([Request_TypeImply]) ->
                   (Int) ->
                   ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(PreSignatures),([RawRequest]),(Qualifier),([GHError]),(FMap Name LambdaType),([Request_TypeImply]))
-- cata
sem_Qualifier :: (Qualifier) ->
                 (T_Qualifier)
sem_Qualifier ((Qualifier_Empty (_range))) =
    (sem_Qualifier_Empty ((sem_Range (_range))))
sem_Qualifier ((Qualifier_Generator (_range) (_pattern) (_expression))) =
    (sem_Qualifier_Generator ((sem_Range (_range))) ((sem_Pattern (_pattern))) ((sem_Expression (_expression))))
sem_Qualifier ((Qualifier_Guard (_range) (_guard))) =
    (sem_Qualifier_Guard ((sem_Range (_range))) ((sem_Expression (_guard))))
sem_Qualifier ((Qualifier_Let (_range) (_declarations))) =
    (sem_Qualifier_Let ((sem_Range (_range))) ((sem_Declarations (_declarations))))
sem_Qualifier_Empty :: (T_Range) ->
                       (T_Qualifier)
sem_Qualifier_Empty (range_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Qualifier)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                Qualifier_Empty _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Qualifier_Generator :: (T_Range) ->
                           (T_Pattern) ->
                           (T_Expression) ->
                           (T_Qualifier)
sem_Qualifier_Generator (range_) (pattern_) (expression_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Qualifier)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _patternIconstructors_collect :: (FMap Name Names)
            _patternIgenericAbstractions_collect :: (FMap Name Kind)
            _patternIlabels_collect :: (FMap Name Names)
            _patternImethods_collect :: (FMap Name Names)
            _patternIname :: (Name)
            _patternIself :: (Pattern)
            _patternOclassname :: (Maybe Name)
            _patternOconstructors_collect :: (FMap Name Names)
            _patternOconstructors_dist :: (FMap Name Names)
            _patternOcurrentModule :: (Strings)
            _patternOgenericAbstractions :: (FMap Name Kind)
            _patternOgenericAbstractions_collect :: (FMap Name Kind)
            _patternOghc :: (Bool)
            _patternOimportedModule :: (Bool)
            _patternOinstancename :: (Maybe Name)
            _patternOlabels_collect :: (FMap Name Names)
            _patternOlabels_dist :: (FMap Name Names)
            _patternOlocal :: (Bool)
            _patternOmethods_collect :: (FMap Name Names)
            _patternOmethods_dist :: (FMap Name Names)
            _patternOmodules :: (Set Strings)
            _patternOoptimizer :: (Bool)
            _patternOoptimizerPrelude :: (Declarations)
            _patternOprelude :: (Bool)
            _patternOtoplevel :: (Bool)
            _patternOverbosity :: (Int)
            _expressionIabstractTypes_collect :: (Set Name)
            _expressionIbimapImps_collect :: ([Request_BimapImply])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdepConstraints_collect :: ([DepConstraint])
            _expressionIfunImps_collect :: ([Request_FunImply])
            _expressionIgenericAbstractions_collect :: (FMap Name Kind)
            _expressionIkinames :: (KSubst)
            _expressionIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionIkind_errors :: ([GHError])
            _expressionIkindvar :: (Int)
            _expressionIksubst :: (KSubst)
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIrawRequests_collect :: ([RawRequest])
            _expressionIself :: (Expression)
            _expressionIstaticErrors :: ([GHError])
            _expressionIstructureTypes_collect :: (FMap Name LambdaType)
            _expressionItypeImps_collect :: ([Request_TypeImply])
            _expressionOabstractTypes_collect :: (Set Name)
            _expressionObimapImps_collect :: ([Request_BimapImply])
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies :: (FMap Name [(Name,Name)])
            _expressionOexportedStructures :: (Set Name)
            _expressionOexportedTypes :: (Set Name)
            _expressionOexportedValues :: (Set Name)
            _expressionOfunImps_collect :: ([Request_FunImply])
            _expressionOgenericAbstractions :: (FMap Name Kind)
            _expressionOgenericAbstractions_collect :: (FMap Name Kind)
            _expressionOghc :: (Bool)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOkinames :: (KSubst)
            _expressionOkindIndexedTypes :: (FMap Name KindIndexedType)
            _expressionOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionOkinds :: (KSubst)
            _expressionOkindvar :: (Int)
            _expressionOksubst :: (KSubst)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmodules :: (Set Strings)
            _expressionOoptimizer :: (Bool)
            _expressionOoptimizerPrelude :: (Declarations)
            _expressionOprekind :: (KSubst)
            _expressionOprelude :: (Bool)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOrawRequests_collect :: ([RawRequest])
            _expressionOsignatures :: (Signatures)
            _expressionOstructureTypes_collect :: (FMap Name LambdaType)
            _expressionOtoplevel :: (Bool)
            _expressionOtypeImps_collect :: ([Request_TypeImply])
            _expressionOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _patternIconstructors_collect,_patternIgenericAbstractions_collect,_patternIlabels_collect,_patternImethods_collect,_patternIname,_patternIself) =
                (pattern_ (_patternOclassname)
                          (_patternOconstructors_collect)
                          (_patternOconstructors_dist)
                          (_patternOcurrentModule)
                          (_patternOgenericAbstractions)
                          (_patternOgenericAbstractions_collect)
                          (_patternOghc)
                          (_patternOimportedModule)
                          (_patternOinstancename)
                          (_patternOlabels_collect)
                          (_patternOlabels_dist)
                          (_patternOlocal)
                          (_patternOmethods_collect)
                          (_patternOmethods_dist)
                          (_patternOmodules)
                          (_patternOoptimizer)
                          (_patternOoptimizerPrelude)
                          (_patternOprelude)
                          (_patternOtoplevel)
                          (_patternOverbosity))
            ( _expressionIabstractTypes_collect
             ,_expressionIbimapImps_collect
             ,_expressionIconstructors_collect
             ,_expressionIdepConstraints_collect
             ,_expressionIfunImps_collect
             ,_expressionIgenericAbstractions_collect
             ,_expressionIkinames
             ,_expressionIkindIndexedTypes_collect
             ,_expressionIkind_errors
             ,_expressionIkindvar
             ,_expressionIksubst
             ,_expressionIlabels_collect
             ,_expressionImethods_collect
             ,_expressionIpresignatures_collect
             ,_expressionIrawRequests_collect
             ,_expressionIself
             ,_expressionIstaticErrors
             ,_expressionIstructureTypes_collect
             ,_expressionItypeImps_collect
             ) =
                (expression_ (_expressionOabstractTypes_collect)
                             (_expressionObimapImps_collect)
                             (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies)
                             (_expressionOexportedStructures)
                             (_expressionOexportedTypes)
                             (_expressionOexportedValues)
                             (_expressionOfunImps_collect)
                             (_expressionOgenericAbstractions)
                             (_expressionOgenericAbstractions_collect)
                             (_expressionOghc)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOkinames)
                             (_expressionOkindIndexedTypes)
                             (_expressionOkindIndexedTypes_collect)
                             (_expressionOkinds)
                             (_expressionOkindvar)
                             (_expressionOksubst)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmodules)
                             (_expressionOoptimizer)
                             (_expressionOoptimizerPrelude)
                             (_expressionOprekind)
                             (_expressionOprelude)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOrawRequests_collect)
                             (_expressionOsignatures)
                             (_expressionOstructureTypes_collect)
                             (_expressionOtoplevel)
                             (_expressionOtypeImps_collect)
                             (_expressionOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _expressionIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _expressionIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _expressionIstaticErrors
            -- self rule
            (_self@_) =
                Qualifier_Generator _rangeIself _patternIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _expressionIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _expressionIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _expressionIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _expressionIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _expressionIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _expressionIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _expressionIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _expressionIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _expressionIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _expressionIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _expressionItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_patternOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_patternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_patternOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_patternOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_patternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_patternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_patternOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_patternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_patternOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_patternOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_patternOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_patternOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_expressionOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_expressionObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_expressionOconstructors_collect@_) =
                _patternIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_expressionOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_expressionOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_expressionOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_expressionOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_expressionOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_expressionOgenericAbstractions_collect@_) =
                _patternIgenericAbstractions_collect
            -- copy rule (down)
            (_expressionOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_expressionOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_expressionOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_expressionOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_expressionOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_expressionOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_expressionOlabels_collect@_) =
                _patternIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_expressionOmethods_collect@_) =
                _patternImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_expressionOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_expressionOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_expressionOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_expressionOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_expressionOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Qualifier_Guard :: (T_Range) ->
                       (T_Expression) ->
                       (T_Qualifier)
sem_Qualifier_Guard (range_) (guard_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Qualifier)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _guardIabstractTypes_collect :: (Set Name)
            _guardIbimapImps_collect :: ([Request_BimapImply])
            _guardIconstructors_collect :: (FMap Name Names)
            _guardIdepConstraints_collect :: ([DepConstraint])
            _guardIfunImps_collect :: ([Request_FunImply])
            _guardIgenericAbstractions_collect :: (FMap Name Kind)
            _guardIkinames :: (KSubst)
            _guardIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _guardIkind_errors :: ([GHError])
            _guardIkindvar :: (Int)
            _guardIksubst :: (KSubst)
            _guardIlabels_collect :: (FMap Name Names)
            _guardImethods_collect :: (FMap Name Names)
            _guardIpresignatures_collect :: (PreSignatures)
            _guardIrawRequests_collect :: ([RawRequest])
            _guardIself :: (Expression)
            _guardIstaticErrors :: ([GHError])
            _guardIstructureTypes_collect :: (FMap Name LambdaType)
            _guardItypeImps_collect :: ([Request_TypeImply])
            _guardOabstractTypes_collect :: (Set Name)
            _guardObimapImps_collect :: ([Request_BimapImply])
            _guardOclassname :: (Maybe Name)
            _guardOconstructors_collect :: (FMap Name Names)
            _guardOconstructors_dist :: (FMap Name Names)
            _guardOcurrentModule :: (Strings)
            _guardOdependencies :: (FMap Name [(Name,Name)])
            _guardOexportedStructures :: (Set Name)
            _guardOexportedTypes :: (Set Name)
            _guardOexportedValues :: (Set Name)
            _guardOfunImps_collect :: ([Request_FunImply])
            _guardOgenericAbstractions :: (FMap Name Kind)
            _guardOgenericAbstractions_collect :: (FMap Name Kind)
            _guardOghc :: (Bool)
            _guardOimportedModule :: (Bool)
            _guardOinstancename :: (Maybe Name)
            _guardOkinames :: (KSubst)
            _guardOkindIndexedTypes :: (FMap Name KindIndexedType)
            _guardOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _guardOkinds :: (KSubst)
            _guardOkindvar :: (Int)
            _guardOksubst :: (KSubst)
            _guardOlabels_collect :: (FMap Name Names)
            _guardOlabels_dist :: (FMap Name Names)
            _guardOlocal :: (Bool)
            _guardOmethods_collect :: (FMap Name Names)
            _guardOmethods_dist :: (FMap Name Names)
            _guardOmodules :: (Set Strings)
            _guardOoptimizer :: (Bool)
            _guardOoptimizerPrelude :: (Declarations)
            _guardOprekind :: (KSubst)
            _guardOprelude :: (Bool)
            _guardOpresignatures :: (PreSignatures)
            _guardOpresignatures_collect :: (PreSignatures)
            _guardOrawRequests_collect :: ([RawRequest])
            _guardOsignatures :: (Signatures)
            _guardOstructureTypes_collect :: (FMap Name LambdaType)
            _guardOtoplevel :: (Bool)
            _guardOtypeImps_collect :: ([Request_TypeImply])
            _guardOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _guardIabstractTypes_collect
             ,_guardIbimapImps_collect
             ,_guardIconstructors_collect
             ,_guardIdepConstraints_collect
             ,_guardIfunImps_collect
             ,_guardIgenericAbstractions_collect
             ,_guardIkinames
             ,_guardIkindIndexedTypes_collect
             ,_guardIkind_errors
             ,_guardIkindvar
             ,_guardIksubst
             ,_guardIlabels_collect
             ,_guardImethods_collect
             ,_guardIpresignatures_collect
             ,_guardIrawRequests_collect
             ,_guardIself
             ,_guardIstaticErrors
             ,_guardIstructureTypes_collect
             ,_guardItypeImps_collect
             ) =
                (guard_ (_guardOabstractTypes_collect)
                        (_guardObimapImps_collect)
                        (_guardOclassname)
                        (_guardOconstructors_collect)
                        (_guardOconstructors_dist)
                        (_guardOcurrentModule)
                        (_guardOdependencies)
                        (_guardOexportedStructures)
                        (_guardOexportedTypes)
                        (_guardOexportedValues)
                        (_guardOfunImps_collect)
                        (_guardOgenericAbstractions)
                        (_guardOgenericAbstractions_collect)
                        (_guardOghc)
                        (_guardOimportedModule)
                        (_guardOinstancename)
                        (_guardOkinames)
                        (_guardOkindIndexedTypes)
                        (_guardOkindIndexedTypes_collect)
                        (_guardOkinds)
                        (_guardOkindvar)
                        (_guardOksubst)
                        (_guardOlabels_collect)
                        (_guardOlabels_dist)
                        (_guardOlocal)
                        (_guardOmethods_collect)
                        (_guardOmethods_dist)
                        (_guardOmodules)
                        (_guardOoptimizer)
                        (_guardOoptimizerPrelude)
                        (_guardOprekind)
                        (_guardOprelude)
                        (_guardOpresignatures)
                        (_guardOpresignatures_collect)
                        (_guardOrawRequests_collect)
                        (_guardOsignatures)
                        (_guardOstructureTypes_collect)
                        (_guardOtoplevel)
                        (_guardOtypeImps_collect)
                        (_guardOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _guardIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _guardIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _guardIstaticErrors
            -- self rule
            (_self@_) =
                Qualifier_Guard _rangeIself _guardIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _guardIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _guardIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _guardIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _guardIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _guardIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _guardIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _guardIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _guardIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _guardIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _guardIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _guardImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _guardIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _guardIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _guardIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _guardItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_guardOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_guardObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_guardOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_guardOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_guardOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_guardOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_guardOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_guardOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_guardOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_guardOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_guardOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_guardOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_guardOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_guardOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_guardOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_guardOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_guardOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_guardOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_guardOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_guardOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_guardOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_guardOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_guardOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_guardOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_guardOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_guardOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_guardOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_guardOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_guardOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_guardOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_guardOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_guardOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_guardOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_guardOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_guardOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_guardOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_guardOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_guardOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_guardOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_guardOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Qualifier_Let :: (T_Range) ->
                     (T_Declarations) ->
                     (T_Qualifier)
sem_Qualifier_Let (range_) (declarations_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Qualifier)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _declarationsIabstractTypes_collect :: (Set Name)
            _declarationsIbimapImps_collect :: ([Request_BimapImply])
            _declarationsIconstructors_collect :: (FMap Name Names)
            _declarationsIdepConstraints_collect :: ([DepConstraint])
            _declarationsIdepConstraints_defined :: ([DepConstraint])
            _declarationsIexportedDeclarations :: (Declarations)
            _declarationsIfunImps_collect :: ([Request_FunImply])
            _declarationsIgenericAbstractions_collect :: (FMap Name Kind)
            _declarationsIkinames :: (KSubst)
            _declarationsIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _declarationsIkind_errors :: ([GHError])
            _declarationsIkindvar :: (Int)
            _declarationsIksubst :: (KSubst)
            _declarationsIlabels_collect :: (FMap Name Names)
            _declarationsImethods_collect :: (FMap Name Names)
            _declarationsIoutput :: ([PP.Doc])
            _declarationsIoutputi :: ([PP.Doc])
            _declarationsIpresignatures_collect :: (PreSignatures)
            _declarationsIrawRequests_collect :: ([RawRequest])
            _declarationsIself :: (Declarations)
            _declarationsIstaticErrors :: ([GHError])
            _declarationsIstructureTypes_collect :: (FMap Name LambdaType)
            _declarationsItypeImps_collect :: ([Request_TypeImply])
            _declarationsOabstractTypes_collect :: (Set Name)
            _declarationsObimapImps_collect :: ([Request_BimapImply])
            _declarationsOclassname :: (Maybe Name)
            _declarationsOconstructors_collect :: (FMap Name Names)
            _declarationsOconstructors_dist :: (FMap Name Names)
            _declarationsOcurrentModule :: (Strings)
            _declarationsOdependencies :: (FMap Name [(Name,Name)])
            _declarationsOexportedStructures :: (Set Name)
            _declarationsOexportedTypes :: (Set Name)
            _declarationsOexportedValues :: (Set Name)
            _declarationsOfunImps_collect :: ([Request_FunImply])
            _declarationsOgenericAbstractions :: (FMap Name Kind)
            _declarationsOgenericAbstractions_collect :: (FMap Name Kind)
            _declarationsOghc :: (Bool)
            _declarationsOimportedModule :: (Bool)
            _declarationsOinstancename :: (Maybe Name)
            _declarationsOkinames :: (KSubst)
            _declarationsOkindIndexedTypes :: (FMap Name KindIndexedType)
            _declarationsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _declarationsOkinds :: (KSubst)
            _declarationsOkindvar :: (Int)
            _declarationsOksubst :: (KSubst)
            _declarationsOlabels_collect :: (FMap Name Names)
            _declarationsOlabels_dist :: (FMap Name Names)
            _declarationsOlocal :: (Bool)
            _declarationsOmethods_collect :: (FMap Name Names)
            _declarationsOmethods_dist :: (FMap Name Names)
            _declarationsOmodules :: (Set Strings)
            _declarationsOoptimizer :: (Bool)
            _declarationsOoptimizerPrelude :: (Declarations)
            _declarationsOoutput :: ([PP.Doc])
            _declarationsOprekind :: (KSubst)
            _declarationsOprelude :: (Bool)
            _declarationsOpresignatures :: (PreSignatures)
            _declarationsOpresignatures_collect :: (PreSignatures)
            _declarationsOrawRequests_collect :: ([RawRequest])
            _declarationsOsignatures :: (Signatures)
            _declarationsOstructureTypes_collect :: (FMap Name LambdaType)
            _declarationsOtoplevel :: (Bool)
            _declarationsOtypeImps_collect :: ([Request_TypeImply])
            _declarationsOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _declarationsIabstractTypes_collect
             ,_declarationsIbimapImps_collect
             ,_declarationsIconstructors_collect
             ,_declarationsIdepConstraints_collect
             ,_declarationsIdepConstraints_defined
             ,_declarationsIexportedDeclarations
             ,_declarationsIfunImps_collect
             ,_declarationsIgenericAbstractions_collect
             ,_declarationsIkinames
             ,_declarationsIkindIndexedTypes_collect
             ,_declarationsIkind_errors
             ,_declarationsIkindvar
             ,_declarationsIksubst
             ,_declarationsIlabels_collect
             ,_declarationsImethods_collect
             ,_declarationsIoutput
             ,_declarationsIoutputi
             ,_declarationsIpresignatures_collect
             ,_declarationsIrawRequests_collect
             ,_declarationsIself
             ,_declarationsIstaticErrors
             ,_declarationsIstructureTypes_collect
             ,_declarationsItypeImps_collect
             ) =
                (declarations_ (_declarationsOabstractTypes_collect)
                               (_declarationsObimapImps_collect)
                               (_declarationsOclassname)
                               (_declarationsOconstructors_collect)
                               (_declarationsOconstructors_dist)
                               (_declarationsOcurrentModule)
                               (_declarationsOdependencies)
                               (_declarationsOexportedStructures)
                               (_declarationsOexportedTypes)
                               (_declarationsOexportedValues)
                               (_declarationsOfunImps_collect)
                               (_declarationsOgenericAbstractions)
                               (_declarationsOgenericAbstractions_collect)
                               (_declarationsOghc)
                               (_declarationsOimportedModule)
                               (_declarationsOinstancename)
                               (_declarationsOkinames)
                               (_declarationsOkindIndexedTypes)
                               (_declarationsOkindIndexedTypes_collect)
                               (_declarationsOkinds)
                               (_declarationsOkindvar)
                               (_declarationsOksubst)
                               (_declarationsOlabels_collect)
                               (_declarationsOlabels_dist)
                               (_declarationsOlocal)
                               (_declarationsOmethods_collect)
                               (_declarationsOmethods_dist)
                               (_declarationsOmodules)
                               (_declarationsOoptimizer)
                               (_declarationsOoptimizerPrelude)
                               (_declarationsOoutput)
                               (_declarationsOprekind)
                               (_declarationsOprelude)
                               (_declarationsOpresignatures)
                               (_declarationsOpresignatures_collect)
                               (_declarationsOrawRequests_collect)
                               (_declarationsOsignatures)
                               (_declarationsOstructureTypes_collect)
                               (_declarationsOtoplevel)
                               (_declarationsOtypeImps_collect)
                               (_declarationsOverbosity))
            -- "./Output.inc.lag"(line 398, column 9)
            (_declarationsOoutput@_) =
                []
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _declarationsIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _declarationsIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _declarationsIstaticErrors
            -- self rule
            (_self@_) =
                Qualifier_Let _rangeIself _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _declarationsIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _declarationsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _declarationsIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _declarationsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _declarationsIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _declarationsIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _declarationsIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _declarationsIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _declarationsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _declarationsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _declarationsImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _declarationsIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _declarationsIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _declarationsIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _declarationsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_declarationsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_declarationsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_declarationsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_declarationsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_declarationsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_declarationsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_declarationsOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_declarationsOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_declarationsOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_declarationsOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_declarationsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_declarationsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_declarationsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_declarationsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_declarationsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_declarationsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_declarationsOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_declarationsOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_declarationsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_declarationsOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_declarationsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_declarationsOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_declarationsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_declarationsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_declarationsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_declarationsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_declarationsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_declarationsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_declarationsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_declarationsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_declarationsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_declarationsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_declarationsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_declarationsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_declarationsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_declarationsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_declarationsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_declarationsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_declarationsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_declarationsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
-- Qualifiers --------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      exportedStructures   : Set Name
      exportedTypes        : Set Name
      exportedValues       : Set Name
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures
      rawRequests_collect  : [RawRequest]
      structureTypes_collect : FMap Name LambdaType
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      kind_errors          : [GHError]
      self                 : SELF
      staticErrors         : [GHError]

-}
{-
   local variables for Qualifiers.Cons:
      self

-}
{-
   local variables for Qualifiers.Nil:
      self

-}
-- semantic domain
type T_Qualifiers = (Set Name) ->
                    ([Request_BimapImply]) ->
                    (Maybe Name) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Strings) ->
                    (FMap Name [(Name,Name)]) ->
                    (Set Name) ->
                    (Set Name) ->
                    (Set Name) ->
                    ([Request_FunImply]) ->
                    (FMap Name Kind) ->
                    (FMap Name Kind) ->
                    (Bool) ->
                    (Bool) ->
                    (Maybe Name) ->
                    (KSubst) ->
                    (FMap Name KindIndexedType) ->
                    (FMap Name KindIndexedType) ->
                    (KSubst) ->
                    (Int) ->
                    (KSubst) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Bool) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Set Strings) ->
                    (Bool) ->
                    (Declarations) ->
                    (KSubst) ->
                    (Bool) ->
                    (PreSignatures) ->
                    (PreSignatures) ->
                    ([RawRequest]) ->
                    (Signatures) ->
                    (FMap Name LambdaType) ->
                    (Bool) ->
                    ([Request_TypeImply]) ->
                    (Int) ->
                    ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(PreSignatures),([RawRequest]),(Qualifiers),([GHError]),(FMap Name LambdaType),([Request_TypeImply]))
-- cata
sem_Qualifiers :: (Qualifiers) ->
                  (T_Qualifiers)
sem_Qualifiers (list) =
    (foldr (sem_Qualifiers_Cons) (sem_Qualifiers_Nil) ((map sem_Qualifier list)))
sem_Qualifiers_Cons :: (T_Qualifier) ->
                       (T_Qualifiers) ->
                       (T_Qualifiers)
sem_Qualifiers_Cons (hd_) (tl_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Qualifiers)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _hdIabstractTypes_collect :: (Set Name)
            _hdIbimapImps_collect :: ([Request_BimapImply])
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdepConstraints_collect :: ([DepConstraint])
            _hdIfunImps_collect :: ([Request_FunImply])
            _hdIgenericAbstractions_collect :: (FMap Name Kind)
            _hdIkinames :: (KSubst)
            _hdIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _hdIkind_errors :: ([GHError])
            _hdIkindvar :: (Int)
            _hdIksubst :: (KSubst)
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIpresignatures_collect :: (PreSignatures)
            _hdIrawRequests_collect :: ([RawRequest])
            _hdIself :: (Qualifier)
            _hdIstaticErrors :: ([GHError])
            _hdIstructureTypes_collect :: (FMap Name LambdaType)
            _hdItypeImps_collect :: ([Request_TypeImply])
            _hdOabstractTypes_collect :: (Set Name)
            _hdObimapImps_collect :: ([Request_BimapImply])
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies :: (FMap Name [(Name,Name)])
            _hdOexportedStructures :: (Set Name)
            _hdOexportedTypes :: (Set Name)
            _hdOexportedValues :: (Set Name)
            _hdOfunImps_collect :: ([Request_FunImply])
            _hdOgenericAbstractions :: (FMap Name Kind)
            _hdOgenericAbstractions_collect :: (FMap Name Kind)
            _hdOghc :: (Bool)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOkinames :: (KSubst)
            _hdOkindIndexedTypes :: (FMap Name KindIndexedType)
            _hdOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _hdOkinds :: (KSubst)
            _hdOkindvar :: (Int)
            _hdOksubst :: (KSubst)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmodules :: (Set Strings)
            _hdOoptimizer :: (Bool)
            _hdOoptimizerPrelude :: (Declarations)
            _hdOprekind :: (KSubst)
            _hdOprelude :: (Bool)
            _hdOpresignatures :: (PreSignatures)
            _hdOpresignatures_collect :: (PreSignatures)
            _hdOrawRequests_collect :: ([RawRequest])
            _hdOsignatures :: (Signatures)
            _hdOstructureTypes_collect :: (FMap Name LambdaType)
            _hdOtoplevel :: (Bool)
            _hdOtypeImps_collect :: ([Request_TypeImply])
            _hdOverbosity :: (Int)
            _tlIabstractTypes_collect :: (Set Name)
            _tlIbimapImps_collect :: ([Request_BimapImply])
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdepConstraints_collect :: ([DepConstraint])
            _tlIfunImps_collect :: ([Request_FunImply])
            _tlIgenericAbstractions_collect :: (FMap Name Kind)
            _tlIkinames :: (KSubst)
            _tlIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _tlIkind_errors :: ([GHError])
            _tlIkindvar :: (Int)
            _tlIksubst :: (KSubst)
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIpresignatures_collect :: (PreSignatures)
            _tlIrawRequests_collect :: ([RawRequest])
            _tlIself :: (Qualifiers)
            _tlIstaticErrors :: ([GHError])
            _tlIstructureTypes_collect :: (FMap Name LambdaType)
            _tlItypeImps_collect :: ([Request_TypeImply])
            _tlOabstractTypes_collect :: (Set Name)
            _tlObimapImps_collect :: ([Request_BimapImply])
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies :: (FMap Name [(Name,Name)])
            _tlOexportedStructures :: (Set Name)
            _tlOexportedTypes :: (Set Name)
            _tlOexportedValues :: (Set Name)
            _tlOfunImps_collect :: ([Request_FunImply])
            _tlOgenericAbstractions :: (FMap Name Kind)
            _tlOgenericAbstractions_collect :: (FMap Name Kind)
            _tlOghc :: (Bool)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOkinames :: (KSubst)
            _tlOkindIndexedTypes :: (FMap Name KindIndexedType)
            _tlOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _tlOkinds :: (KSubst)
            _tlOkindvar :: (Int)
            _tlOksubst :: (KSubst)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmodules :: (Set Strings)
            _tlOoptimizer :: (Bool)
            _tlOoptimizerPrelude :: (Declarations)
            _tlOprekind :: (KSubst)
            _tlOprelude :: (Bool)
            _tlOpresignatures :: (PreSignatures)
            _tlOpresignatures_collect :: (PreSignatures)
            _tlOrawRequests_collect :: ([RawRequest])
            _tlOsignatures :: (Signatures)
            _tlOstructureTypes_collect :: (FMap Name LambdaType)
            _tlOtoplevel :: (Bool)
            _tlOtypeImps_collect :: ([Request_TypeImply])
            _tlOverbosity :: (Int)
            ( _hdIabstractTypes_collect,_hdIbimapImps_collect,_hdIconstructors_collect,_hdIdepConstraints_collect,_hdIfunImps_collect,_hdIgenericAbstractions_collect,_hdIkinames,_hdIkindIndexedTypes_collect,_hdIkind_errors,_hdIkindvar,_hdIksubst,_hdIlabels_collect,_hdImethods_collect,_hdIpresignatures_collect,_hdIrawRequests_collect,_hdIself,_hdIstaticErrors,_hdIstructureTypes_collect,_hdItypeImps_collect) =
                (hd_ (_hdOabstractTypes_collect)
                     (_hdObimapImps_collect)
                     (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOdependencies)
                     (_hdOexportedStructures)
                     (_hdOexportedTypes)
                     (_hdOexportedValues)
                     (_hdOfunImps_collect)
                     (_hdOgenericAbstractions)
                     (_hdOgenericAbstractions_collect)
                     (_hdOghc)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOkinames)
                     (_hdOkindIndexedTypes)
                     (_hdOkindIndexedTypes_collect)
                     (_hdOkinds)
                     (_hdOkindvar)
                     (_hdOksubst)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmodules)
                     (_hdOoptimizer)
                     (_hdOoptimizerPrelude)
                     (_hdOprekind)
                     (_hdOprelude)
                     (_hdOpresignatures)
                     (_hdOpresignatures_collect)
                     (_hdOrawRequests_collect)
                     (_hdOsignatures)
                     (_hdOstructureTypes_collect)
                     (_hdOtoplevel)
                     (_hdOtypeImps_collect)
                     (_hdOverbosity))
            ( _tlIabstractTypes_collect,_tlIbimapImps_collect,_tlIconstructors_collect,_tlIdepConstraints_collect,_tlIfunImps_collect,_tlIgenericAbstractions_collect,_tlIkinames,_tlIkindIndexedTypes_collect,_tlIkind_errors,_tlIkindvar,_tlIksubst,_tlIlabels_collect,_tlImethods_collect,_tlIpresignatures_collect,_tlIrawRequests_collect,_tlIself,_tlIstaticErrors,_tlIstructureTypes_collect,_tlItypeImps_collect) =
                (tl_ (_tlOabstractTypes_collect)
                     (_tlObimapImps_collect)
                     (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOdependencies)
                     (_tlOexportedStructures)
                     (_tlOexportedTypes)
                     (_tlOexportedValues)
                     (_tlOfunImps_collect)
                     (_tlOgenericAbstractions)
                     (_tlOgenericAbstractions_collect)
                     (_tlOghc)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOkinames)
                     (_tlOkindIndexedTypes)
                     (_tlOkindIndexedTypes_collect)
                     (_tlOkinds)
                     (_tlOkindvar)
                     (_tlOksubst)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmodules)
                     (_tlOoptimizer)
                     (_tlOoptimizerPrelude)
                     (_tlOprekind)
                     (_tlOprelude)
                     (_tlOpresignatures)
                     (_tlOpresignatures_collect)
                     (_tlOrawRequests_collect)
                     (_tlOsignatures)
                     (_tlOstructureTypes_collect)
                     (_tlOtoplevel)
                     (_tlOtypeImps_collect)
                     (_tlOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _hdIdepConstraints_collect ++ _tlIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _hdIkind_errors ++ _tlIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _hdIstaticErrors ++ _tlIstaticErrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _tlIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _tlIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _tlIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _tlIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _tlIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _tlIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _tlIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _tlIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _tlIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _tlIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _tlIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _tlItypeImps_collect
            -- copy rule (down)
            (_hdOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_hdObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_hdOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_hdOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_hdOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_hdOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_hdOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_hdOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_hdOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_hdOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_hdOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_hdOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_hdOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_hdOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_hdOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_hdOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_hdOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_hdOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_hdOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_hdOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_hdOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_hdOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_hdOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_hdOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_hdOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_tlOabstractTypes_collect@_) =
                _hdIabstractTypes_collect
            -- copy rule (chain)
            (_tlObimapImps_collect@_) =
                _hdIbimapImps_collect
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_tlOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_tlOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_tlOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (chain)
            (_tlOfunImps_collect@_) =
                _hdIfunImps_collect
            -- copy rule (down)
            (_tlOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_tlOgenericAbstractions_collect@_) =
                _hdIgenericAbstractions_collect
            -- copy rule (down)
            (_tlOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOkinames@_) =
                _hdIkinames
            -- copy rule (down)
            (_tlOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (chain)
            (_tlOkindIndexedTypes_collect@_) =
                _hdIkindIndexedTypes_collect
            -- copy rule (down)
            (_tlOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_tlOkindvar@_) =
                _hdIkindvar
            -- copy rule (chain)
            (_tlOksubst@_) =
                _hdIksubst
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_tlOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_tlOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_tlOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_tlOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_tlOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_tlOpresignatures_collect@_) =
                _hdIpresignatures_collect
            -- copy rule (chain)
            (_tlOrawRequests_collect@_) =
                _hdIrawRequests_collect
            -- copy rule (down)
            (_tlOsignatures@_) =
                _lhsIsignatures
            -- copy rule (chain)
            (_tlOstructureTypes_collect@_) =
                _hdIstructureTypes_collect
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_tlOtypeImps_collect@_) =
                _hdItypeImps_collect
            -- copy rule (down)
            (_tlOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Qualifiers_Nil :: (T_Qualifiers)
sem_Qualifiers_Nil  =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Qualifiers)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
-- Range -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      local                : Bool
      toplevel             : Bool

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Range.Range:
      self

-}
-- semantic domain
type T_Range = (Maybe Name) ->
               (Strings) ->
               (Bool) ->
               (Maybe Name) ->
               (Bool) ->
               (Bool) ->
               ( (Range))
-- cata
sem_Range :: (Range) ->
             (T_Range)
sem_Range ((Range_Range (_start) (_stop))) =
    (sem_Range_Range ((sem_Position (_start))) ((sem_Position (_stop))))
sem_Range_Range :: (T_Position) ->
                   (T_Position) ->
                   (T_Range)
sem_Range_Range (start_) (stop_) =
    \ _lhsIclassname
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlocal
      _lhsItoplevel ->
        let _lhsOself :: (Range)
            _startIself :: (Position)
            _startOclassname :: (Maybe Name)
            _startOcurrentModule :: (Strings)
            _startOimportedModule :: (Bool)
            _startOinstancename :: (Maybe Name)
            _startOlocal :: (Bool)
            _startOtoplevel :: (Bool)
            _stopIself :: (Position)
            _stopOclassname :: (Maybe Name)
            _stopOcurrentModule :: (Strings)
            _stopOimportedModule :: (Bool)
            _stopOinstancename :: (Maybe Name)
            _stopOlocal :: (Bool)
            _stopOtoplevel :: (Bool)
            ( _startIself) =
                (start_ (_startOclassname) (_startOcurrentModule) (_startOimportedModule) (_startOinstancename) (_startOlocal) (_startOtoplevel))
            ( _stopIself) =
                (stop_ (_stopOclassname) (_stopOcurrentModule) (_stopOimportedModule) (_stopOinstancename) (_stopOlocal) (_stopOtoplevel))
            -- self rule
            (_self@_) =
                Range_Range _startIself _stopIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_startOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_startOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_startOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_startOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_startOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_startOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_stopOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_stopOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_stopOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_stopOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_stopOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_stopOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOself)
-- Reassignment ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Reassignment.Reassignment:
      self

-}
-- semantic domain
type T_Reassignment = (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Strings) ->
                      (FMap Name Kind) ->
                      (FMap Name Kind) ->
                      (Bool) ->
                      (Bool) ->
                      (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Set Strings) ->
                      (Bool) ->
                      (Declarations) ->
                      (Bool) ->
                      (Bool) ->
                      (Int) ->
                      ( (FMap Name Names),(FMap Name Kind),(FMap Name Names),(FMap Name Names),(Reassignment))
-- cata
sem_Reassignment :: (Reassignment) ->
                    (T_Reassignment)
sem_Reassignment ((Reassignment_Reassignment (_range) (_name) (_as))) =
    (sem_Reassignment_Reassignment ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Name (_as))))
sem_Reassignment_Reassignment :: (T_Range) ->
                                 (T_Name) ->
                                 (T_Name) ->
                                 (T_Reassignment)
sem_Reassignment_Reassignment (range_) (name_) (as_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Reassignment)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _asIconstructors_collect :: (FMap Name Names)
            _asIgenericAbstractions_collect :: (FMap Name Kind)
            _asIlabels_collect :: (FMap Name Names)
            _asImethods_collect :: (FMap Name Names)
            _asIself :: (Name)
            _asOclassname :: (Maybe Name)
            _asOconstructors_collect :: (FMap Name Names)
            _asOconstructors_dist :: (FMap Name Names)
            _asOcurrentModule :: (Strings)
            _asOgenericAbstractions :: (FMap Name Kind)
            _asOgenericAbstractions_collect :: (FMap Name Kind)
            _asOghc :: (Bool)
            _asOimportedModule :: (Bool)
            _asOinstancename :: (Maybe Name)
            _asOlabels_collect :: (FMap Name Names)
            _asOlabels_dist :: (FMap Name Names)
            _asOlocal :: (Bool)
            _asOmethods_collect :: (FMap Name Names)
            _asOmethods_dist :: (FMap Name Names)
            _asOmodules :: (Set Strings)
            _asOoptimizer :: (Bool)
            _asOoptimizerPrelude :: (Declarations)
            _asOprelude :: (Bool)
            _asOtoplevel :: (Bool)
            _asOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _asIconstructors_collect,_asIgenericAbstractions_collect,_asIlabels_collect,_asImethods_collect,_asIself) =
                (as_ (_asOclassname) (_asOconstructors_collect) (_asOconstructors_dist) (_asOcurrentModule) (_asOgenericAbstractions) (_asOgenericAbstractions_collect) (_asOghc) (_asOimportedModule) (_asOinstancename) (_asOlabels_collect) (_asOlabels_dist) (_asOlocal) (_asOmethods_collect) (_asOmethods_dist) (_asOmodules) (_asOoptimizer) (_asOoptimizerPrelude) (_asOprelude) (_asOtoplevel) (_asOverbosity))
            -- self rule
            (_self@_) =
                Reassignment_Reassignment _rangeIself _nameIself _asIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _asIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _asIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _asIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _asImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_asOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_asOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_asOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_asOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_asOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_asOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_asOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_asOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_asOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_asOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_asOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_asOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_asOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_asOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_asOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_asOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_asOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_asOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_asOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_asOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- Reassignments -----------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Reassignments.Cons:
      self

-}
{-
   local variables for Reassignments.Nil:
      self

-}
-- semantic domain
type T_Reassignments = (Maybe Name) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (Strings) ->
                       (FMap Name Kind) ->
                       (FMap Name Kind) ->
                       (Bool) ->
                       (Bool) ->
                       (Maybe Name) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (Bool) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (Set Strings) ->
                       (Bool) ->
                       (Declarations) ->
                       (Bool) ->
                       (Bool) ->
                       (Int) ->
                       ( (FMap Name Names),(FMap Name Kind),(FMap Name Names),(FMap Name Names),(Reassignments))
-- cata
sem_Reassignments :: (Reassignments) ->
                     (T_Reassignments)
sem_Reassignments (list) =
    (foldr (sem_Reassignments_Cons) (sem_Reassignments_Nil) ((map sem_Reassignment list)))
sem_Reassignments_Cons :: (T_Reassignment) ->
                          (T_Reassignments) ->
                          (T_Reassignments)
sem_Reassignments_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Reassignments)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIgenericAbstractions_collect :: (FMap Name Kind)
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIself :: (Reassignment)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOgenericAbstractions :: (FMap Name Kind)
            _hdOgenericAbstractions_collect :: (FMap Name Kind)
            _hdOghc :: (Bool)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmodules :: (Set Strings)
            _hdOoptimizer :: (Bool)
            _hdOoptimizerPrelude :: (Declarations)
            _hdOprelude :: (Bool)
            _hdOtoplevel :: (Bool)
            _hdOverbosity :: (Int)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIgenericAbstractions_collect :: (FMap Name Kind)
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIself :: (Reassignments)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOgenericAbstractions :: (FMap Name Kind)
            _tlOgenericAbstractions_collect :: (FMap Name Kind)
            _tlOghc :: (Bool)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmodules :: (Set Strings)
            _tlOoptimizer :: (Bool)
            _tlOoptimizerPrelude :: (Declarations)
            _tlOprelude :: (Bool)
            _tlOtoplevel :: (Bool)
            _tlOverbosity :: (Int)
            ( _hdIconstructors_collect,_hdIgenericAbstractions_collect,_hdIlabels_collect,_hdImethods_collect,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOgenericAbstractions) (_hdOgenericAbstractions_collect) (_hdOghc) (_hdOimportedModule) (_hdOinstancename) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOmodules) (_hdOoptimizer) (_hdOoptimizerPrelude) (_hdOprelude) (_hdOtoplevel) (_hdOverbosity))
            ( _tlIconstructors_collect,_tlIgenericAbstractions_collect,_tlIlabels_collect,_tlImethods_collect,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOgenericAbstractions) (_tlOgenericAbstractions_collect) (_tlOghc) (_tlOimportedModule) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOmodules) (_tlOoptimizer) (_tlOoptimizerPrelude) (_tlOprelude) (_tlOtoplevel) (_tlOverbosity))
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _tlIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_hdOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_hdOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_hdOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_hdOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_hdOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_hdOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_tlOgenericAbstractions_collect@_) =
                _hdIgenericAbstractions_collect
            -- copy rule (down)
            (_tlOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_tlOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_tlOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_tlOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Reassignments_Nil :: (T_Reassignments)
sem_Reassignments_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Reassignments)
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- RecordExpressionBinding -------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      exportedStructures   : Set Name
      exportedTypes        : Set Name
      exportedValues       : Set Name
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures
      rawRequests_collect  : [RawRequest]
      structureTypes_collect : FMap Name LambdaType
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      kind_errors          : [GHError]
      self                 : SELF
      staticErrors         : [GHError]

-}
{-
   local variables for RecordExpressionBinding.RecordExpressionBinding:
      self

-}
-- semantic domain
type T_RecordExpressionBinding = (Set Name) ->
                                 ([Request_BimapImply]) ->
                                 (Maybe Name) ->
                                 (FMap Name Names) ->
                                 (FMap Name Names) ->
                                 (Strings) ->
                                 (FMap Name [(Name,Name)]) ->
                                 (Set Name) ->
                                 (Set Name) ->
                                 (Set Name) ->
                                 ([Request_FunImply]) ->
                                 (FMap Name Kind) ->
                                 (FMap Name Kind) ->
                                 (Bool) ->
                                 (Bool) ->
                                 (Maybe Name) ->
                                 (KSubst) ->
                                 (FMap Name KindIndexedType) ->
                                 (FMap Name KindIndexedType) ->
                                 (KSubst) ->
                                 (Int) ->
                                 (KSubst) ->
                                 (FMap Name Names) ->
                                 (FMap Name Names) ->
                                 (Bool) ->
                                 (FMap Name Names) ->
                                 (FMap Name Names) ->
                                 (Set Strings) ->
                                 (Bool) ->
                                 (Declarations) ->
                                 (KSubst) ->
                                 (Bool) ->
                                 (PreSignatures) ->
                                 (PreSignatures) ->
                                 ([RawRequest]) ->
                                 (Signatures) ->
                                 (FMap Name LambdaType) ->
                                 (Bool) ->
                                 ([Request_TypeImply]) ->
                                 (Int) ->
                                 ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(PreSignatures),([RawRequest]),(RecordExpressionBinding),([GHError]),(FMap Name LambdaType),([Request_TypeImply]))
-- cata
sem_RecordExpressionBinding :: (RecordExpressionBinding) ->
                               (T_RecordExpressionBinding)
sem_RecordExpressionBinding ((RecordExpressionBinding_RecordExpressionBinding (_range) (_name) (_expression))) =
    (sem_RecordExpressionBinding_RecordExpressionBinding ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Expression (_expression))))
sem_RecordExpressionBinding_RecordExpressionBinding :: (T_Range) ->
                                                       (T_Name) ->
                                                       (T_Expression) ->
                                                       (T_RecordExpressionBinding)
sem_RecordExpressionBinding_RecordExpressionBinding (range_) (name_) (expression_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (RecordExpressionBinding)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _expressionIabstractTypes_collect :: (Set Name)
            _expressionIbimapImps_collect :: ([Request_BimapImply])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdepConstraints_collect :: ([DepConstraint])
            _expressionIfunImps_collect :: ([Request_FunImply])
            _expressionIgenericAbstractions_collect :: (FMap Name Kind)
            _expressionIkinames :: (KSubst)
            _expressionIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionIkind_errors :: ([GHError])
            _expressionIkindvar :: (Int)
            _expressionIksubst :: (KSubst)
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIrawRequests_collect :: ([RawRequest])
            _expressionIself :: (Expression)
            _expressionIstaticErrors :: ([GHError])
            _expressionIstructureTypes_collect :: (FMap Name LambdaType)
            _expressionItypeImps_collect :: ([Request_TypeImply])
            _expressionOabstractTypes_collect :: (Set Name)
            _expressionObimapImps_collect :: ([Request_BimapImply])
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies :: (FMap Name [(Name,Name)])
            _expressionOexportedStructures :: (Set Name)
            _expressionOexportedTypes :: (Set Name)
            _expressionOexportedValues :: (Set Name)
            _expressionOfunImps_collect :: ([Request_FunImply])
            _expressionOgenericAbstractions :: (FMap Name Kind)
            _expressionOgenericAbstractions_collect :: (FMap Name Kind)
            _expressionOghc :: (Bool)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOkinames :: (KSubst)
            _expressionOkindIndexedTypes :: (FMap Name KindIndexedType)
            _expressionOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionOkinds :: (KSubst)
            _expressionOkindvar :: (Int)
            _expressionOksubst :: (KSubst)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmodules :: (Set Strings)
            _expressionOoptimizer :: (Bool)
            _expressionOoptimizerPrelude :: (Declarations)
            _expressionOprekind :: (KSubst)
            _expressionOprelude :: (Bool)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOrawRequests_collect :: ([RawRequest])
            _expressionOsignatures :: (Signatures)
            _expressionOstructureTypes_collect :: (FMap Name LambdaType)
            _expressionOtoplevel :: (Bool)
            _expressionOtypeImps_collect :: ([Request_TypeImply])
            _expressionOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _expressionIabstractTypes_collect
             ,_expressionIbimapImps_collect
             ,_expressionIconstructors_collect
             ,_expressionIdepConstraints_collect
             ,_expressionIfunImps_collect
             ,_expressionIgenericAbstractions_collect
             ,_expressionIkinames
             ,_expressionIkindIndexedTypes_collect
             ,_expressionIkind_errors
             ,_expressionIkindvar
             ,_expressionIksubst
             ,_expressionIlabels_collect
             ,_expressionImethods_collect
             ,_expressionIpresignatures_collect
             ,_expressionIrawRequests_collect
             ,_expressionIself
             ,_expressionIstaticErrors
             ,_expressionIstructureTypes_collect
             ,_expressionItypeImps_collect
             ) =
                (expression_ (_expressionOabstractTypes_collect)
                             (_expressionObimapImps_collect)
                             (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies)
                             (_expressionOexportedStructures)
                             (_expressionOexportedTypes)
                             (_expressionOexportedValues)
                             (_expressionOfunImps_collect)
                             (_expressionOgenericAbstractions)
                             (_expressionOgenericAbstractions_collect)
                             (_expressionOghc)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOkinames)
                             (_expressionOkindIndexedTypes)
                             (_expressionOkindIndexedTypes_collect)
                             (_expressionOkinds)
                             (_expressionOkindvar)
                             (_expressionOksubst)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmodules)
                             (_expressionOoptimizer)
                             (_expressionOoptimizerPrelude)
                             (_expressionOprekind)
                             (_expressionOprelude)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOrawRequests_collect)
                             (_expressionOsignatures)
                             (_expressionOstructureTypes_collect)
                             (_expressionOtoplevel)
                             (_expressionOtypeImps_collect)
                             (_expressionOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _expressionIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _expressionIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _expressionIstaticErrors
            -- self rule
            (_self@_) =
                RecordExpressionBinding_RecordExpressionBinding _rangeIself _nameIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _expressionIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _expressionIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _expressionIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _expressionIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _expressionIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _expressionIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _expressionIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _expressionIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _expressionIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _expressionIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _expressionItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_expressionOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_expressionObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_expressionOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_expressionOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_expressionOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_expressionOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_expressionOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_expressionOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_expressionOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_expressionOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_expressionOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_expressionOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_expressionOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_expressionOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_expressionOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_expressionOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_expressionOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_expressionOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_expressionOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_expressionOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_expressionOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_expressionOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
-- RecordExpressionBindings ------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      exportedStructures   : Set Name
      exportedTypes        : Set Name
      exportedValues       : Set Name
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures
      rawRequests_collect  : [RawRequest]
      structureTypes_collect : FMap Name LambdaType
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      kind_errors          : [GHError]
      self                 : SELF
      staticErrors         : [GHError]

-}
{-
   local variables for RecordExpressionBindings.Cons:
      self

-}
{-
   local variables for RecordExpressionBindings.Nil:
      self

-}
-- semantic domain
type T_RecordExpressionBindings = (Set Name) ->
                                  ([Request_BimapImply]) ->
                                  (Maybe Name) ->
                                  (FMap Name Names) ->
                                  (FMap Name Names) ->
                                  (Strings) ->
                                  (FMap Name [(Name,Name)]) ->
                                  (Set Name) ->
                                  (Set Name) ->
                                  (Set Name) ->
                                  ([Request_FunImply]) ->
                                  (FMap Name Kind) ->
                                  (FMap Name Kind) ->
                                  (Bool) ->
                                  (Bool) ->
                                  (Maybe Name) ->
                                  (KSubst) ->
                                  (FMap Name KindIndexedType) ->
                                  (FMap Name KindIndexedType) ->
                                  (KSubst) ->
                                  (Int) ->
                                  (KSubst) ->
                                  (FMap Name Names) ->
                                  (FMap Name Names) ->
                                  (Bool) ->
                                  (FMap Name Names) ->
                                  (FMap Name Names) ->
                                  (Set Strings) ->
                                  (Bool) ->
                                  (Declarations) ->
                                  (KSubst) ->
                                  (Bool) ->
                                  (PreSignatures) ->
                                  (PreSignatures) ->
                                  ([RawRequest]) ->
                                  (Signatures) ->
                                  (FMap Name LambdaType) ->
                                  (Bool) ->
                                  ([Request_TypeImply]) ->
                                  (Int) ->
                                  ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(PreSignatures),([RawRequest]),(RecordExpressionBindings),([GHError]),(FMap Name LambdaType),([Request_TypeImply]))
-- cata
sem_RecordExpressionBindings :: (RecordExpressionBindings) ->
                                (T_RecordExpressionBindings)
sem_RecordExpressionBindings (list) =
    (foldr (sem_RecordExpressionBindings_Cons) (sem_RecordExpressionBindings_Nil) ((map sem_RecordExpressionBinding list)))
sem_RecordExpressionBindings_Cons :: (T_RecordExpressionBinding) ->
                                     (T_RecordExpressionBindings) ->
                                     (T_RecordExpressionBindings)
sem_RecordExpressionBindings_Cons (hd_) (tl_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (RecordExpressionBindings)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _hdIabstractTypes_collect :: (Set Name)
            _hdIbimapImps_collect :: ([Request_BimapImply])
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdepConstraints_collect :: ([DepConstraint])
            _hdIfunImps_collect :: ([Request_FunImply])
            _hdIgenericAbstractions_collect :: (FMap Name Kind)
            _hdIkinames :: (KSubst)
            _hdIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _hdIkind_errors :: ([GHError])
            _hdIkindvar :: (Int)
            _hdIksubst :: (KSubst)
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIpresignatures_collect :: (PreSignatures)
            _hdIrawRequests_collect :: ([RawRequest])
            _hdIself :: (RecordExpressionBinding)
            _hdIstaticErrors :: ([GHError])
            _hdIstructureTypes_collect :: (FMap Name LambdaType)
            _hdItypeImps_collect :: ([Request_TypeImply])
            _hdOabstractTypes_collect :: (Set Name)
            _hdObimapImps_collect :: ([Request_BimapImply])
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies :: (FMap Name [(Name,Name)])
            _hdOexportedStructures :: (Set Name)
            _hdOexportedTypes :: (Set Name)
            _hdOexportedValues :: (Set Name)
            _hdOfunImps_collect :: ([Request_FunImply])
            _hdOgenericAbstractions :: (FMap Name Kind)
            _hdOgenericAbstractions_collect :: (FMap Name Kind)
            _hdOghc :: (Bool)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOkinames :: (KSubst)
            _hdOkindIndexedTypes :: (FMap Name KindIndexedType)
            _hdOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _hdOkinds :: (KSubst)
            _hdOkindvar :: (Int)
            _hdOksubst :: (KSubst)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmodules :: (Set Strings)
            _hdOoptimizer :: (Bool)
            _hdOoptimizerPrelude :: (Declarations)
            _hdOprekind :: (KSubst)
            _hdOprelude :: (Bool)
            _hdOpresignatures :: (PreSignatures)
            _hdOpresignatures_collect :: (PreSignatures)
            _hdOrawRequests_collect :: ([RawRequest])
            _hdOsignatures :: (Signatures)
            _hdOstructureTypes_collect :: (FMap Name LambdaType)
            _hdOtoplevel :: (Bool)
            _hdOtypeImps_collect :: ([Request_TypeImply])
            _hdOverbosity :: (Int)
            _tlIabstractTypes_collect :: (Set Name)
            _tlIbimapImps_collect :: ([Request_BimapImply])
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdepConstraints_collect :: ([DepConstraint])
            _tlIfunImps_collect :: ([Request_FunImply])
            _tlIgenericAbstractions_collect :: (FMap Name Kind)
            _tlIkinames :: (KSubst)
            _tlIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _tlIkind_errors :: ([GHError])
            _tlIkindvar :: (Int)
            _tlIksubst :: (KSubst)
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIpresignatures_collect :: (PreSignatures)
            _tlIrawRequests_collect :: ([RawRequest])
            _tlIself :: (RecordExpressionBindings)
            _tlIstaticErrors :: ([GHError])
            _tlIstructureTypes_collect :: (FMap Name LambdaType)
            _tlItypeImps_collect :: ([Request_TypeImply])
            _tlOabstractTypes_collect :: (Set Name)
            _tlObimapImps_collect :: ([Request_BimapImply])
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies :: (FMap Name [(Name,Name)])
            _tlOexportedStructures :: (Set Name)
            _tlOexportedTypes :: (Set Name)
            _tlOexportedValues :: (Set Name)
            _tlOfunImps_collect :: ([Request_FunImply])
            _tlOgenericAbstractions :: (FMap Name Kind)
            _tlOgenericAbstractions_collect :: (FMap Name Kind)
            _tlOghc :: (Bool)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOkinames :: (KSubst)
            _tlOkindIndexedTypes :: (FMap Name KindIndexedType)
            _tlOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _tlOkinds :: (KSubst)
            _tlOkindvar :: (Int)
            _tlOksubst :: (KSubst)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmodules :: (Set Strings)
            _tlOoptimizer :: (Bool)
            _tlOoptimizerPrelude :: (Declarations)
            _tlOprekind :: (KSubst)
            _tlOprelude :: (Bool)
            _tlOpresignatures :: (PreSignatures)
            _tlOpresignatures_collect :: (PreSignatures)
            _tlOrawRequests_collect :: ([RawRequest])
            _tlOsignatures :: (Signatures)
            _tlOstructureTypes_collect :: (FMap Name LambdaType)
            _tlOtoplevel :: (Bool)
            _tlOtypeImps_collect :: ([Request_TypeImply])
            _tlOverbosity :: (Int)
            ( _hdIabstractTypes_collect,_hdIbimapImps_collect,_hdIconstructors_collect,_hdIdepConstraints_collect,_hdIfunImps_collect,_hdIgenericAbstractions_collect,_hdIkinames,_hdIkindIndexedTypes_collect,_hdIkind_errors,_hdIkindvar,_hdIksubst,_hdIlabels_collect,_hdImethods_collect,_hdIpresignatures_collect,_hdIrawRequests_collect,_hdIself,_hdIstaticErrors,_hdIstructureTypes_collect,_hdItypeImps_collect) =
                (hd_ (_hdOabstractTypes_collect)
                     (_hdObimapImps_collect)
                     (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOdependencies)
                     (_hdOexportedStructures)
                     (_hdOexportedTypes)
                     (_hdOexportedValues)
                     (_hdOfunImps_collect)
                     (_hdOgenericAbstractions)
                     (_hdOgenericAbstractions_collect)
                     (_hdOghc)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOkinames)
                     (_hdOkindIndexedTypes)
                     (_hdOkindIndexedTypes_collect)
                     (_hdOkinds)
                     (_hdOkindvar)
                     (_hdOksubst)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmodules)
                     (_hdOoptimizer)
                     (_hdOoptimizerPrelude)
                     (_hdOprekind)
                     (_hdOprelude)
                     (_hdOpresignatures)
                     (_hdOpresignatures_collect)
                     (_hdOrawRequests_collect)
                     (_hdOsignatures)
                     (_hdOstructureTypes_collect)
                     (_hdOtoplevel)
                     (_hdOtypeImps_collect)
                     (_hdOverbosity))
            ( _tlIabstractTypes_collect,_tlIbimapImps_collect,_tlIconstructors_collect,_tlIdepConstraints_collect,_tlIfunImps_collect,_tlIgenericAbstractions_collect,_tlIkinames,_tlIkindIndexedTypes_collect,_tlIkind_errors,_tlIkindvar,_tlIksubst,_tlIlabels_collect,_tlImethods_collect,_tlIpresignatures_collect,_tlIrawRequests_collect,_tlIself,_tlIstaticErrors,_tlIstructureTypes_collect,_tlItypeImps_collect) =
                (tl_ (_tlOabstractTypes_collect)
                     (_tlObimapImps_collect)
                     (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOdependencies)
                     (_tlOexportedStructures)
                     (_tlOexportedTypes)
                     (_tlOexportedValues)
                     (_tlOfunImps_collect)
                     (_tlOgenericAbstractions)
                     (_tlOgenericAbstractions_collect)
                     (_tlOghc)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOkinames)
                     (_tlOkindIndexedTypes)
                     (_tlOkindIndexedTypes_collect)
                     (_tlOkinds)
                     (_tlOkindvar)
                     (_tlOksubst)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmodules)
                     (_tlOoptimizer)
                     (_tlOoptimizerPrelude)
                     (_tlOprekind)
                     (_tlOprelude)
                     (_tlOpresignatures)
                     (_tlOpresignatures_collect)
                     (_tlOrawRequests_collect)
                     (_tlOsignatures)
                     (_tlOstructureTypes_collect)
                     (_tlOtoplevel)
                     (_tlOtypeImps_collect)
                     (_tlOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _hdIdepConstraints_collect ++ _tlIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _hdIkind_errors ++ _tlIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _hdIstaticErrors ++ _tlIstaticErrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _tlIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _tlIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _tlIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _tlIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _tlIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _tlIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _tlIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _tlIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _tlIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _tlIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _tlIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _tlItypeImps_collect
            -- copy rule (down)
            (_hdOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_hdObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_hdOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_hdOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_hdOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_hdOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_hdOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_hdOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_hdOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_hdOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_hdOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_hdOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_hdOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_hdOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_hdOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_hdOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_hdOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_hdOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_hdOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_hdOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_hdOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_hdOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_hdOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_hdOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_hdOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_tlOabstractTypes_collect@_) =
                _hdIabstractTypes_collect
            -- copy rule (chain)
            (_tlObimapImps_collect@_) =
                _hdIbimapImps_collect
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_tlOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_tlOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_tlOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (chain)
            (_tlOfunImps_collect@_) =
                _hdIfunImps_collect
            -- copy rule (down)
            (_tlOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_tlOgenericAbstractions_collect@_) =
                _hdIgenericAbstractions_collect
            -- copy rule (down)
            (_tlOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOkinames@_) =
                _hdIkinames
            -- copy rule (down)
            (_tlOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (chain)
            (_tlOkindIndexedTypes_collect@_) =
                _hdIkindIndexedTypes_collect
            -- copy rule (down)
            (_tlOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_tlOkindvar@_) =
                _hdIkindvar
            -- copy rule (chain)
            (_tlOksubst@_) =
                _hdIksubst
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_tlOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_tlOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_tlOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_tlOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_tlOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_tlOpresignatures_collect@_) =
                _hdIpresignatures_collect
            -- copy rule (chain)
            (_tlOrawRequests_collect@_) =
                _hdIrawRequests_collect
            -- copy rule (down)
            (_tlOsignatures@_) =
                _lhsIsignatures
            -- copy rule (chain)
            (_tlOstructureTypes_collect@_) =
                _hdIstructureTypes_collect
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_tlOtypeImps_collect@_) =
                _hdItypeImps_collect
            -- copy rule (down)
            (_tlOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_RecordExpressionBindings_Nil :: (T_RecordExpressionBindings)
sem_RecordExpressionBindings_Nil  =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (RecordExpressionBindings)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
-- RecordPatternBinding ----------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for RecordPatternBinding.RecordPatternBinding:
      self

-}
-- semantic domain
type T_RecordPatternBinding = (Maybe Name) ->
                              (FMap Name Names) ->
                              (FMap Name Names) ->
                              (Strings) ->
                              (FMap Name Kind) ->
                              (FMap Name Kind) ->
                              (Bool) ->
                              (Bool) ->
                              (Maybe Name) ->
                              (FMap Name Names) ->
                              (FMap Name Names) ->
                              (Bool) ->
                              (FMap Name Names) ->
                              (FMap Name Names) ->
                              (Set Strings) ->
                              (Bool) ->
                              (Declarations) ->
                              (Bool) ->
                              (Bool) ->
                              (Int) ->
                              ( (FMap Name Names),(FMap Name Kind),(FMap Name Names),(FMap Name Names),(RecordPatternBinding))
-- cata
sem_RecordPatternBinding :: (RecordPatternBinding) ->
                            (T_RecordPatternBinding)
sem_RecordPatternBinding ((RecordPatternBinding_RecordPatternBinding (_range) (_name) (_pattern))) =
    (sem_RecordPatternBinding_RecordPatternBinding ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Pattern (_pattern))))
sem_RecordPatternBinding_RecordPatternBinding :: (T_Range) ->
                                                 (T_Name) ->
                                                 (T_Pattern) ->
                                                 (T_RecordPatternBinding)
sem_RecordPatternBinding_RecordPatternBinding (range_) (name_) (pattern_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (RecordPatternBinding)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _patternIconstructors_collect :: (FMap Name Names)
            _patternIgenericAbstractions_collect :: (FMap Name Kind)
            _patternIlabels_collect :: (FMap Name Names)
            _patternImethods_collect :: (FMap Name Names)
            _patternIname :: (Name)
            _patternIself :: (Pattern)
            _patternOclassname :: (Maybe Name)
            _patternOconstructors_collect :: (FMap Name Names)
            _patternOconstructors_dist :: (FMap Name Names)
            _patternOcurrentModule :: (Strings)
            _patternOgenericAbstractions :: (FMap Name Kind)
            _patternOgenericAbstractions_collect :: (FMap Name Kind)
            _patternOghc :: (Bool)
            _patternOimportedModule :: (Bool)
            _patternOinstancename :: (Maybe Name)
            _patternOlabels_collect :: (FMap Name Names)
            _patternOlabels_dist :: (FMap Name Names)
            _patternOlocal :: (Bool)
            _patternOmethods_collect :: (FMap Name Names)
            _patternOmethods_dist :: (FMap Name Names)
            _patternOmodules :: (Set Strings)
            _patternOoptimizer :: (Bool)
            _patternOoptimizerPrelude :: (Declarations)
            _patternOprelude :: (Bool)
            _patternOtoplevel :: (Bool)
            _patternOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _patternIconstructors_collect,_patternIgenericAbstractions_collect,_patternIlabels_collect,_patternImethods_collect,_patternIname,_patternIself) =
                (pattern_ (_patternOclassname)
                          (_patternOconstructors_collect)
                          (_patternOconstructors_dist)
                          (_patternOcurrentModule)
                          (_patternOgenericAbstractions)
                          (_patternOgenericAbstractions_collect)
                          (_patternOghc)
                          (_patternOimportedModule)
                          (_patternOinstancename)
                          (_patternOlabels_collect)
                          (_patternOlabels_dist)
                          (_patternOlocal)
                          (_patternOmethods_collect)
                          (_patternOmethods_dist)
                          (_patternOmodules)
                          (_patternOoptimizer)
                          (_patternOoptimizerPrelude)
                          (_patternOprelude)
                          (_patternOtoplevel)
                          (_patternOverbosity))
            -- self rule
            (_self@_) =
                RecordPatternBinding_RecordPatternBinding _rangeIself _nameIself _patternIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _patternIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _patternIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _patternIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _patternImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_patternOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_patternOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_patternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_patternOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_patternOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_patternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_patternOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_patternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_patternOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_patternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_patternOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_patternOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_patternOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_patternOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- RecordPatternBindings ---------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for RecordPatternBindings.Cons:
      self

-}
{-
   local variables for RecordPatternBindings.Nil:
      self

-}
-- semantic domain
type T_RecordPatternBindings = (Maybe Name) ->
                               (FMap Name Names) ->
                               (FMap Name Names) ->
                               (Strings) ->
                               (FMap Name Kind) ->
                               (FMap Name Kind) ->
                               (Bool) ->
                               (Bool) ->
                               (Maybe Name) ->
                               (FMap Name Names) ->
                               (FMap Name Names) ->
                               (Bool) ->
                               (FMap Name Names) ->
                               (FMap Name Names) ->
                               (Set Strings) ->
                               (Bool) ->
                               (Declarations) ->
                               (Bool) ->
                               (Bool) ->
                               (Int) ->
                               ( (FMap Name Names),(FMap Name Kind),(FMap Name Names),(FMap Name Names),(RecordPatternBindings))
-- cata
sem_RecordPatternBindings :: (RecordPatternBindings) ->
                             (T_RecordPatternBindings)
sem_RecordPatternBindings (list) =
    (foldr (sem_RecordPatternBindings_Cons) (sem_RecordPatternBindings_Nil) ((map sem_RecordPatternBinding list)))
sem_RecordPatternBindings_Cons :: (T_RecordPatternBinding) ->
                                  (T_RecordPatternBindings) ->
                                  (T_RecordPatternBindings)
sem_RecordPatternBindings_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (RecordPatternBindings)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIgenericAbstractions_collect :: (FMap Name Kind)
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIself :: (RecordPatternBinding)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOgenericAbstractions :: (FMap Name Kind)
            _hdOgenericAbstractions_collect :: (FMap Name Kind)
            _hdOghc :: (Bool)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmodules :: (Set Strings)
            _hdOoptimizer :: (Bool)
            _hdOoptimizerPrelude :: (Declarations)
            _hdOprelude :: (Bool)
            _hdOtoplevel :: (Bool)
            _hdOverbosity :: (Int)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIgenericAbstractions_collect :: (FMap Name Kind)
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIself :: (RecordPatternBindings)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOgenericAbstractions :: (FMap Name Kind)
            _tlOgenericAbstractions_collect :: (FMap Name Kind)
            _tlOghc :: (Bool)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmodules :: (Set Strings)
            _tlOoptimizer :: (Bool)
            _tlOoptimizerPrelude :: (Declarations)
            _tlOprelude :: (Bool)
            _tlOtoplevel :: (Bool)
            _tlOverbosity :: (Int)
            ( _hdIconstructors_collect,_hdIgenericAbstractions_collect,_hdIlabels_collect,_hdImethods_collect,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOgenericAbstractions) (_hdOgenericAbstractions_collect) (_hdOghc) (_hdOimportedModule) (_hdOinstancename) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOmodules) (_hdOoptimizer) (_hdOoptimizerPrelude) (_hdOprelude) (_hdOtoplevel) (_hdOverbosity))
            ( _tlIconstructors_collect,_tlIgenericAbstractions_collect,_tlIlabels_collect,_tlImethods_collect,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOgenericAbstractions) (_tlOgenericAbstractions_collect) (_tlOghc) (_tlOimportedModule) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOmodules) (_tlOoptimizer) (_tlOoptimizerPrelude) (_tlOprelude) (_tlOtoplevel) (_tlOverbosity))
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _tlIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_hdOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_hdOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_hdOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_hdOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_hdOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_hdOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_tlOgenericAbstractions_collect@_) =
                _hdIgenericAbstractions_collect
            -- copy rule (down)
            (_tlOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_tlOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_tlOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_tlOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_RecordPatternBindings_Nil :: (T_RecordPatternBindings)
sem_RecordPatternBindings_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (RecordPatternBindings)
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- RightHandSide -----------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      exportedStructures   : Set Name
      exportedTypes        : Set Name
      exportedValues       : Set Name
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures
      rawRequests_collect  : [RawRequest]
      structureTypes_collect : FMap Name LambdaType
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      kind_errors          : [GHError]
      self                 : SELF
      staticErrors         : [GHError]

-}
{-
   local variables for RightHandSide.Expression:
      instancename
      classname
      self

-}
{-
   local variables for RightHandSide.Guarded:
      instancename
      classname
      self

-}
-- semantic domain
type T_RightHandSide = (Set Name) ->
                       ([Request_BimapImply]) ->
                       (Maybe Name) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (Strings) ->
                       (FMap Name [(Name,Name)]) ->
                       (Set Name) ->
                       (Set Name) ->
                       (Set Name) ->
                       ([Request_FunImply]) ->
                       (FMap Name Kind) ->
                       (FMap Name Kind) ->
                       (Bool) ->
                       (Bool) ->
                       (Maybe Name) ->
                       (KSubst) ->
                       (FMap Name KindIndexedType) ->
                       (FMap Name KindIndexedType) ->
                       (KSubst) ->
                       (Int) ->
                       (KSubst) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (Bool) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (Set Strings) ->
                       (Bool) ->
                       (Declarations) ->
                       (KSubst) ->
                       (Bool) ->
                       (PreSignatures) ->
                       (PreSignatures) ->
                       ([RawRequest]) ->
                       (Signatures) ->
                       (FMap Name LambdaType) ->
                       (Bool) ->
                       ([Request_TypeImply]) ->
                       (Int) ->
                       ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(PreSignatures),([RawRequest]),(RightHandSide),([GHError]),(FMap Name LambdaType),([Request_TypeImply]))
-- cata
sem_RightHandSide :: (RightHandSide) ->
                     (T_RightHandSide)
sem_RightHandSide ((RightHandSide_Expression (_range) (_expression) (_where))) =
    (sem_RightHandSide_Expression ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_MaybeDeclarations (_where))))
sem_RightHandSide ((RightHandSide_Guarded (_range) (_guardedexpressions) (_where))) =
    (sem_RightHandSide_Guarded ((sem_Range (_range))) ((sem_GuardedExpressions (_guardedexpressions))) ((sem_MaybeDeclarations (_where))))
sem_RightHandSide_Expression :: (T_Range) ->
                                (T_Expression) ->
                                (T_MaybeDeclarations) ->
                                (T_RightHandSide)
sem_RightHandSide_Expression (range_) (expression_) (where_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (RightHandSide)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionIabstractTypes_collect :: (Set Name)
            _expressionIbimapImps_collect :: ([Request_BimapImply])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdepConstraints_collect :: ([DepConstraint])
            _expressionIfunImps_collect :: ([Request_FunImply])
            _expressionIgenericAbstractions_collect :: (FMap Name Kind)
            _expressionIkinames :: (KSubst)
            _expressionIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionIkind_errors :: ([GHError])
            _expressionIkindvar :: (Int)
            _expressionIksubst :: (KSubst)
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIrawRequests_collect :: ([RawRequest])
            _expressionIself :: (Expression)
            _expressionIstaticErrors :: ([GHError])
            _expressionIstructureTypes_collect :: (FMap Name LambdaType)
            _expressionItypeImps_collect :: ([Request_TypeImply])
            _expressionOabstractTypes_collect :: (Set Name)
            _expressionObimapImps_collect :: ([Request_BimapImply])
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies :: (FMap Name [(Name,Name)])
            _expressionOexportedStructures :: (Set Name)
            _expressionOexportedTypes :: (Set Name)
            _expressionOexportedValues :: (Set Name)
            _expressionOfunImps_collect :: ([Request_FunImply])
            _expressionOgenericAbstractions :: (FMap Name Kind)
            _expressionOgenericAbstractions_collect :: (FMap Name Kind)
            _expressionOghc :: (Bool)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOkinames :: (KSubst)
            _expressionOkindIndexedTypes :: (FMap Name KindIndexedType)
            _expressionOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionOkinds :: (KSubst)
            _expressionOkindvar :: (Int)
            _expressionOksubst :: (KSubst)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmodules :: (Set Strings)
            _expressionOoptimizer :: (Bool)
            _expressionOoptimizerPrelude :: (Declarations)
            _expressionOprekind :: (KSubst)
            _expressionOprelude :: (Bool)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOrawRequests_collect :: ([RawRequest])
            _expressionOsignatures :: (Signatures)
            _expressionOstructureTypes_collect :: (FMap Name LambdaType)
            _expressionOtoplevel :: (Bool)
            _expressionOtypeImps_collect :: ([Request_TypeImply])
            _expressionOverbosity :: (Int)
            _whereIabstractTypes_collect :: (Set Name)
            _whereIbimapImps_collect :: ([Request_BimapImply])
            _whereIconstructors_collect :: (FMap Name Names)
            _whereIdepConstraints_collect :: ([DepConstraint])
            _whereIexportedDeclarations :: (MaybeDeclarations)
            _whereIfunImps_collect :: ([Request_FunImply])
            _whereIgenericAbstractions_collect :: (FMap Name Kind)
            _whereIkinames :: (KSubst)
            _whereIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _whereIkind_errors :: ([GHError])
            _whereIkindvar :: (Int)
            _whereIksubst :: (KSubst)
            _whereIlabels_collect :: (FMap Name Names)
            _whereImethods_collect :: (FMap Name Names)
            _whereIpresignatures_collect :: (PreSignatures)
            _whereIrawRequests_collect :: ([RawRequest])
            _whereIself :: (MaybeDeclarations)
            _whereIstaticErrors :: ([GHError])
            _whereIstructureTypes_collect :: (FMap Name LambdaType)
            _whereItypeImps_collect :: ([Request_TypeImply])
            _whereOabstractTypes_collect :: (Set Name)
            _whereObimapImps_collect :: ([Request_BimapImply])
            _whereOclassname :: (Maybe Name)
            _whereOconstructors_collect :: (FMap Name Names)
            _whereOconstructors_dist :: (FMap Name Names)
            _whereOcurrentModule :: (Strings)
            _whereOdependencies :: (FMap Name [(Name,Name)])
            _whereOexportedStructures :: (Set Name)
            _whereOexportedTypes :: (Set Name)
            _whereOexportedValues :: (Set Name)
            _whereOfunImps_collect :: ([Request_FunImply])
            _whereOgenericAbstractions :: (FMap Name Kind)
            _whereOgenericAbstractions_collect :: (FMap Name Kind)
            _whereOghc :: (Bool)
            _whereOimportedModule :: (Bool)
            _whereOinstancename :: (Maybe Name)
            _whereOkinames :: (KSubst)
            _whereOkindIndexedTypes :: (FMap Name KindIndexedType)
            _whereOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _whereOkinds :: (KSubst)
            _whereOkindvar :: (Int)
            _whereOksubst :: (KSubst)
            _whereOlabels_collect :: (FMap Name Names)
            _whereOlabels_dist :: (FMap Name Names)
            _whereOlocal :: (Bool)
            _whereOmethods_collect :: (FMap Name Names)
            _whereOmethods_dist :: (FMap Name Names)
            _whereOmodules :: (Set Strings)
            _whereOoptimizer :: (Bool)
            _whereOoptimizerPrelude :: (Declarations)
            _whereOprekind :: (KSubst)
            _whereOprelude :: (Bool)
            _whereOpresignatures :: (PreSignatures)
            _whereOpresignatures_collect :: (PreSignatures)
            _whereOrawRequests_collect :: ([RawRequest])
            _whereOsignatures :: (Signatures)
            _whereOstructureTypes_collect :: (FMap Name LambdaType)
            _whereOtoplevel :: (Bool)
            _whereOtypeImps_collect :: ([Request_TypeImply])
            _whereOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionIabstractTypes_collect
             ,_expressionIbimapImps_collect
             ,_expressionIconstructors_collect
             ,_expressionIdepConstraints_collect
             ,_expressionIfunImps_collect
             ,_expressionIgenericAbstractions_collect
             ,_expressionIkinames
             ,_expressionIkindIndexedTypes_collect
             ,_expressionIkind_errors
             ,_expressionIkindvar
             ,_expressionIksubst
             ,_expressionIlabels_collect
             ,_expressionImethods_collect
             ,_expressionIpresignatures_collect
             ,_expressionIrawRequests_collect
             ,_expressionIself
             ,_expressionIstaticErrors
             ,_expressionIstructureTypes_collect
             ,_expressionItypeImps_collect
             ) =
                (expression_ (_expressionOabstractTypes_collect)
                             (_expressionObimapImps_collect)
                             (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies)
                             (_expressionOexportedStructures)
                             (_expressionOexportedTypes)
                             (_expressionOexportedValues)
                             (_expressionOfunImps_collect)
                             (_expressionOgenericAbstractions)
                             (_expressionOgenericAbstractions_collect)
                             (_expressionOghc)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOkinames)
                             (_expressionOkindIndexedTypes)
                             (_expressionOkindIndexedTypes_collect)
                             (_expressionOkinds)
                             (_expressionOkindvar)
                             (_expressionOksubst)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmodules)
                             (_expressionOoptimizer)
                             (_expressionOoptimizerPrelude)
                             (_expressionOprekind)
                             (_expressionOprelude)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOrawRequests_collect)
                             (_expressionOsignatures)
                             (_expressionOstructureTypes_collect)
                             (_expressionOtoplevel)
                             (_expressionOtypeImps_collect)
                             (_expressionOverbosity))
            ( _whereIabstractTypes_collect
             ,_whereIbimapImps_collect
             ,_whereIconstructors_collect
             ,_whereIdepConstraints_collect
             ,_whereIexportedDeclarations
             ,_whereIfunImps_collect
             ,_whereIgenericAbstractions_collect
             ,_whereIkinames
             ,_whereIkindIndexedTypes_collect
             ,_whereIkind_errors
             ,_whereIkindvar
             ,_whereIksubst
             ,_whereIlabels_collect
             ,_whereImethods_collect
             ,_whereIpresignatures_collect
             ,_whereIrawRequests_collect
             ,_whereIself
             ,_whereIstaticErrors
             ,_whereIstructureTypes_collect
             ,_whereItypeImps_collect
             ) =
                (where_ (_whereOabstractTypes_collect)
                        (_whereObimapImps_collect)
                        (_whereOclassname)
                        (_whereOconstructors_collect)
                        (_whereOconstructors_dist)
                        (_whereOcurrentModule)
                        (_whereOdependencies)
                        (_whereOexportedStructures)
                        (_whereOexportedTypes)
                        (_whereOexportedValues)
                        (_whereOfunImps_collect)
                        (_whereOgenericAbstractions)
                        (_whereOgenericAbstractions_collect)
                        (_whereOghc)
                        (_whereOimportedModule)
                        (_whereOinstancename)
                        (_whereOkinames)
                        (_whereOkindIndexedTypes)
                        (_whereOkindIndexedTypes_collect)
                        (_whereOkinds)
                        (_whereOkindvar)
                        (_whereOksubst)
                        (_whereOlabels_collect)
                        (_whereOlabels_dist)
                        (_whereOlocal)
                        (_whereOmethods_collect)
                        (_whereOmethods_dist)
                        (_whereOmodules)
                        (_whereOoptimizer)
                        (_whereOoptimizerPrelude)
                        (_whereOprekind)
                        (_whereOprelude)
                        (_whereOpresignatures)
                        (_whereOpresignatures_collect)
                        (_whereOrawRequests_collect)
                        (_whereOsignatures)
                        (_whereOstructureTypes_collect)
                        (_whereOtoplevel)
                        (_whereOtypeImps_collect)
                        (_whereOverbosity))
            -- "./ModuleInformation.inc.lag"(line 196, column 8)
            (_instancename@_) =
                Nothing
            -- "./ModuleInformation.inc.lag"(line 195, column 8)
            (_classname@_) =
                Nothing
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _expressionIdepConstraints_collect ++ _whereIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _expressionIkind_errors ++ _whereIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _expressionIstaticErrors ++ _whereIstaticErrors
            -- self rule
            (_self@_) =
                RightHandSide_Expression _rangeIself _expressionIself _whereIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _whereIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _whereIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _whereIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _whereIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _whereIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _whereIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _whereIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _whereIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _whereIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _whereIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _whereImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _whereIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _whereIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _whereIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _whereItypeImps_collect
            -- copy rule (chain)
            (_rangeOclassname@_) =
                _classname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (chain)
            (_rangeOinstancename@_) =
                _instancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_expressionObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (chain)
            (_expressionOclassname@_) =
                _classname
            -- copy rule (down)
            (_expressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_expressionOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_expressionOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_expressionOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_expressionOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_expressionOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_expressionOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_expressionOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (chain)
            (_expressionOinstancename@_) =
                _instancename
            -- copy rule (down)
            (_expressionOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_expressionOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_expressionOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_expressionOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_expressionOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_expressionOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_expressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_expressionOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_expressionOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_expressionOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_expressionOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_expressionOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_whereOabstractTypes_collect@_) =
                _expressionIabstractTypes_collect
            -- copy rule (chain)
            (_whereObimapImps_collect@_) =
                _expressionIbimapImps_collect
            -- copy rule (chain)
            (_whereOclassname@_) =
                _classname
            -- copy rule (chain)
            (_whereOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (down)
            (_whereOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_whereOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_whereOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_whereOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_whereOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_whereOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (chain)
            (_whereOfunImps_collect@_) =
                _expressionIfunImps_collect
            -- copy rule (down)
            (_whereOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_whereOgenericAbstractions_collect@_) =
                _expressionIgenericAbstractions_collect
            -- copy rule (down)
            (_whereOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_whereOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (chain)
            (_whereOinstancename@_) =
                _instancename
            -- copy rule (chain)
            (_whereOkinames@_) =
                _expressionIkinames
            -- copy rule (down)
            (_whereOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (chain)
            (_whereOkindIndexedTypes_collect@_) =
                _expressionIkindIndexedTypes_collect
            -- copy rule (down)
            (_whereOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_whereOkindvar@_) =
                _expressionIkindvar
            -- copy rule (chain)
            (_whereOksubst@_) =
                _expressionIksubst
            -- copy rule (chain)
            (_whereOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (down)
            (_whereOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_whereOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_whereOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (down)
            (_whereOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_whereOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_whereOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_whereOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_whereOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_whereOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_whereOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_whereOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (chain)
            (_whereOrawRequests_collect@_) =
                _expressionIrawRequests_collect
            -- copy rule (down)
            (_whereOsignatures@_) =
                _lhsIsignatures
            -- copy rule (chain)
            (_whereOstructureTypes_collect@_) =
                _expressionIstructureTypes_collect
            -- copy rule (down)
            (_whereOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_whereOtypeImps_collect@_) =
                _expressionItypeImps_collect
            -- copy rule (down)
            (_whereOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_RightHandSide_Guarded :: (T_Range) ->
                             (T_GuardedExpressions) ->
                             (T_MaybeDeclarations) ->
                             (T_RightHandSide)
sem_RightHandSide_Guarded (range_) (guardedexpressions_) (where_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (RightHandSide)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _guardedexpressionsIabstractTypes_collect :: (Set Name)
            _guardedexpressionsIbimapImps_collect :: ([Request_BimapImply])
            _guardedexpressionsIconstructors_collect :: (FMap Name Names)
            _guardedexpressionsIdepConstraints_collect :: ([DepConstraint])
            _guardedexpressionsIfunImps_collect :: ([Request_FunImply])
            _guardedexpressionsIgenericAbstractions_collect :: (FMap Name Kind)
            _guardedexpressionsIkinames :: (KSubst)
            _guardedexpressionsIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _guardedexpressionsIkind_errors :: ([GHError])
            _guardedexpressionsIkindvar :: (Int)
            _guardedexpressionsIksubst :: (KSubst)
            _guardedexpressionsIlabels_collect :: (FMap Name Names)
            _guardedexpressionsImethods_collect :: (FMap Name Names)
            _guardedexpressionsIpresignatures_collect :: (PreSignatures)
            _guardedexpressionsIrawRequests_collect :: ([RawRequest])
            _guardedexpressionsIself :: (GuardedExpressions)
            _guardedexpressionsIstaticErrors :: ([GHError])
            _guardedexpressionsIstructureTypes_collect :: (FMap Name LambdaType)
            _guardedexpressionsItypeImps_collect :: ([Request_TypeImply])
            _guardedexpressionsOabstractTypes_collect :: (Set Name)
            _guardedexpressionsObimapImps_collect :: ([Request_BimapImply])
            _guardedexpressionsOclassname :: (Maybe Name)
            _guardedexpressionsOconstructors_collect :: (FMap Name Names)
            _guardedexpressionsOconstructors_dist :: (FMap Name Names)
            _guardedexpressionsOcurrentModule :: (Strings)
            _guardedexpressionsOdependencies :: (FMap Name [(Name,Name)])
            _guardedexpressionsOexportedStructures :: (Set Name)
            _guardedexpressionsOexportedTypes :: (Set Name)
            _guardedexpressionsOexportedValues :: (Set Name)
            _guardedexpressionsOfunImps_collect :: ([Request_FunImply])
            _guardedexpressionsOgenericAbstractions :: (FMap Name Kind)
            _guardedexpressionsOgenericAbstractions_collect :: (FMap Name Kind)
            _guardedexpressionsOghc :: (Bool)
            _guardedexpressionsOimportedModule :: (Bool)
            _guardedexpressionsOinstancename :: (Maybe Name)
            _guardedexpressionsOkinames :: (KSubst)
            _guardedexpressionsOkindIndexedTypes :: (FMap Name KindIndexedType)
            _guardedexpressionsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _guardedexpressionsOkinds :: (KSubst)
            _guardedexpressionsOkindvar :: (Int)
            _guardedexpressionsOksubst :: (KSubst)
            _guardedexpressionsOlabels_collect :: (FMap Name Names)
            _guardedexpressionsOlabels_dist :: (FMap Name Names)
            _guardedexpressionsOlocal :: (Bool)
            _guardedexpressionsOmethods_collect :: (FMap Name Names)
            _guardedexpressionsOmethods_dist :: (FMap Name Names)
            _guardedexpressionsOmodules :: (Set Strings)
            _guardedexpressionsOoptimizer :: (Bool)
            _guardedexpressionsOoptimizerPrelude :: (Declarations)
            _guardedexpressionsOprekind :: (KSubst)
            _guardedexpressionsOprelude :: (Bool)
            _guardedexpressionsOpresignatures :: (PreSignatures)
            _guardedexpressionsOpresignatures_collect :: (PreSignatures)
            _guardedexpressionsOrawRequests_collect :: ([RawRequest])
            _guardedexpressionsOsignatures :: (Signatures)
            _guardedexpressionsOstructureTypes_collect :: (FMap Name LambdaType)
            _guardedexpressionsOtoplevel :: (Bool)
            _guardedexpressionsOtypeImps_collect :: ([Request_TypeImply])
            _guardedexpressionsOverbosity :: (Int)
            _whereIabstractTypes_collect :: (Set Name)
            _whereIbimapImps_collect :: ([Request_BimapImply])
            _whereIconstructors_collect :: (FMap Name Names)
            _whereIdepConstraints_collect :: ([DepConstraint])
            _whereIexportedDeclarations :: (MaybeDeclarations)
            _whereIfunImps_collect :: ([Request_FunImply])
            _whereIgenericAbstractions_collect :: (FMap Name Kind)
            _whereIkinames :: (KSubst)
            _whereIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _whereIkind_errors :: ([GHError])
            _whereIkindvar :: (Int)
            _whereIksubst :: (KSubst)
            _whereIlabels_collect :: (FMap Name Names)
            _whereImethods_collect :: (FMap Name Names)
            _whereIpresignatures_collect :: (PreSignatures)
            _whereIrawRequests_collect :: ([RawRequest])
            _whereIself :: (MaybeDeclarations)
            _whereIstaticErrors :: ([GHError])
            _whereIstructureTypes_collect :: (FMap Name LambdaType)
            _whereItypeImps_collect :: ([Request_TypeImply])
            _whereOabstractTypes_collect :: (Set Name)
            _whereObimapImps_collect :: ([Request_BimapImply])
            _whereOclassname :: (Maybe Name)
            _whereOconstructors_collect :: (FMap Name Names)
            _whereOconstructors_dist :: (FMap Name Names)
            _whereOcurrentModule :: (Strings)
            _whereOdependencies :: (FMap Name [(Name,Name)])
            _whereOexportedStructures :: (Set Name)
            _whereOexportedTypes :: (Set Name)
            _whereOexportedValues :: (Set Name)
            _whereOfunImps_collect :: ([Request_FunImply])
            _whereOgenericAbstractions :: (FMap Name Kind)
            _whereOgenericAbstractions_collect :: (FMap Name Kind)
            _whereOghc :: (Bool)
            _whereOimportedModule :: (Bool)
            _whereOinstancename :: (Maybe Name)
            _whereOkinames :: (KSubst)
            _whereOkindIndexedTypes :: (FMap Name KindIndexedType)
            _whereOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _whereOkinds :: (KSubst)
            _whereOkindvar :: (Int)
            _whereOksubst :: (KSubst)
            _whereOlabels_collect :: (FMap Name Names)
            _whereOlabels_dist :: (FMap Name Names)
            _whereOlocal :: (Bool)
            _whereOmethods_collect :: (FMap Name Names)
            _whereOmethods_dist :: (FMap Name Names)
            _whereOmodules :: (Set Strings)
            _whereOoptimizer :: (Bool)
            _whereOoptimizerPrelude :: (Declarations)
            _whereOprekind :: (KSubst)
            _whereOprelude :: (Bool)
            _whereOpresignatures :: (PreSignatures)
            _whereOpresignatures_collect :: (PreSignatures)
            _whereOrawRequests_collect :: ([RawRequest])
            _whereOsignatures :: (Signatures)
            _whereOstructureTypes_collect :: (FMap Name LambdaType)
            _whereOtoplevel :: (Bool)
            _whereOtypeImps_collect :: ([Request_TypeImply])
            _whereOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _guardedexpressionsIabstractTypes_collect
             ,_guardedexpressionsIbimapImps_collect
             ,_guardedexpressionsIconstructors_collect
             ,_guardedexpressionsIdepConstraints_collect
             ,_guardedexpressionsIfunImps_collect
             ,_guardedexpressionsIgenericAbstractions_collect
             ,_guardedexpressionsIkinames
             ,_guardedexpressionsIkindIndexedTypes_collect
             ,_guardedexpressionsIkind_errors
             ,_guardedexpressionsIkindvar
             ,_guardedexpressionsIksubst
             ,_guardedexpressionsIlabels_collect
             ,_guardedexpressionsImethods_collect
             ,_guardedexpressionsIpresignatures_collect
             ,_guardedexpressionsIrawRequests_collect
             ,_guardedexpressionsIself
             ,_guardedexpressionsIstaticErrors
             ,_guardedexpressionsIstructureTypes_collect
             ,_guardedexpressionsItypeImps_collect
             ) =
                (guardedexpressions_ (_guardedexpressionsOabstractTypes_collect)
                                     (_guardedexpressionsObimapImps_collect)
                                     (_guardedexpressionsOclassname)
                                     (_guardedexpressionsOconstructors_collect)
                                     (_guardedexpressionsOconstructors_dist)
                                     (_guardedexpressionsOcurrentModule)
                                     (_guardedexpressionsOdependencies)
                                     (_guardedexpressionsOexportedStructures)
                                     (_guardedexpressionsOexportedTypes)
                                     (_guardedexpressionsOexportedValues)
                                     (_guardedexpressionsOfunImps_collect)
                                     (_guardedexpressionsOgenericAbstractions)
                                     (_guardedexpressionsOgenericAbstractions_collect)
                                     (_guardedexpressionsOghc)
                                     (_guardedexpressionsOimportedModule)
                                     (_guardedexpressionsOinstancename)
                                     (_guardedexpressionsOkinames)
                                     (_guardedexpressionsOkindIndexedTypes)
                                     (_guardedexpressionsOkindIndexedTypes_collect)
                                     (_guardedexpressionsOkinds)
                                     (_guardedexpressionsOkindvar)
                                     (_guardedexpressionsOksubst)
                                     (_guardedexpressionsOlabels_collect)
                                     (_guardedexpressionsOlabels_dist)
                                     (_guardedexpressionsOlocal)
                                     (_guardedexpressionsOmethods_collect)
                                     (_guardedexpressionsOmethods_dist)
                                     (_guardedexpressionsOmodules)
                                     (_guardedexpressionsOoptimizer)
                                     (_guardedexpressionsOoptimizerPrelude)
                                     (_guardedexpressionsOprekind)
                                     (_guardedexpressionsOprelude)
                                     (_guardedexpressionsOpresignatures)
                                     (_guardedexpressionsOpresignatures_collect)
                                     (_guardedexpressionsOrawRequests_collect)
                                     (_guardedexpressionsOsignatures)
                                     (_guardedexpressionsOstructureTypes_collect)
                                     (_guardedexpressionsOtoplevel)
                                     (_guardedexpressionsOtypeImps_collect)
                                     (_guardedexpressionsOverbosity))
            ( _whereIabstractTypes_collect
             ,_whereIbimapImps_collect
             ,_whereIconstructors_collect
             ,_whereIdepConstraints_collect
             ,_whereIexportedDeclarations
             ,_whereIfunImps_collect
             ,_whereIgenericAbstractions_collect
             ,_whereIkinames
             ,_whereIkindIndexedTypes_collect
             ,_whereIkind_errors
             ,_whereIkindvar
             ,_whereIksubst
             ,_whereIlabels_collect
             ,_whereImethods_collect
             ,_whereIpresignatures_collect
             ,_whereIrawRequests_collect
             ,_whereIself
             ,_whereIstaticErrors
             ,_whereIstructureTypes_collect
             ,_whereItypeImps_collect
             ) =
                (where_ (_whereOabstractTypes_collect)
                        (_whereObimapImps_collect)
                        (_whereOclassname)
                        (_whereOconstructors_collect)
                        (_whereOconstructors_dist)
                        (_whereOcurrentModule)
                        (_whereOdependencies)
                        (_whereOexportedStructures)
                        (_whereOexportedTypes)
                        (_whereOexportedValues)
                        (_whereOfunImps_collect)
                        (_whereOgenericAbstractions)
                        (_whereOgenericAbstractions_collect)
                        (_whereOghc)
                        (_whereOimportedModule)
                        (_whereOinstancename)
                        (_whereOkinames)
                        (_whereOkindIndexedTypes)
                        (_whereOkindIndexedTypes_collect)
                        (_whereOkinds)
                        (_whereOkindvar)
                        (_whereOksubst)
                        (_whereOlabels_collect)
                        (_whereOlabels_dist)
                        (_whereOlocal)
                        (_whereOmethods_collect)
                        (_whereOmethods_dist)
                        (_whereOmodules)
                        (_whereOoptimizer)
                        (_whereOoptimizerPrelude)
                        (_whereOprekind)
                        (_whereOprelude)
                        (_whereOpresignatures)
                        (_whereOpresignatures_collect)
                        (_whereOrawRequests_collect)
                        (_whereOsignatures)
                        (_whereOstructureTypes_collect)
                        (_whereOtoplevel)
                        (_whereOtypeImps_collect)
                        (_whereOverbosity))
            -- "./ModuleInformation.inc.lag"(line 199, column 8)
            (_instancename@_) =
                Nothing
            -- "./ModuleInformation.inc.lag"(line 198, column 8)
            (_classname@_) =
                Nothing
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _guardedexpressionsIdepConstraints_collect ++ _whereIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _guardedexpressionsIkind_errors ++ _whereIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _guardedexpressionsIstaticErrors ++ _whereIstaticErrors
            -- self rule
            (_self@_) =
                RightHandSide_Guarded _rangeIself _guardedexpressionsIself _whereIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _whereIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _whereIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _whereIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _whereIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _whereIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _whereIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _whereIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _whereIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _whereIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _whereIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _whereImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _whereIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _whereIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _whereIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _whereItypeImps_collect
            -- copy rule (chain)
            (_rangeOclassname@_) =
                _classname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (chain)
            (_rangeOinstancename@_) =
                _instancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_guardedexpressionsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_guardedexpressionsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (chain)
            (_guardedexpressionsOclassname@_) =
                _classname
            -- copy rule (down)
            (_guardedexpressionsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_guardedexpressionsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_guardedexpressionsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_guardedexpressionsOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_guardedexpressionsOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_guardedexpressionsOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_guardedexpressionsOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_guardedexpressionsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_guardedexpressionsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_guardedexpressionsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_guardedexpressionsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_guardedexpressionsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (chain)
            (_guardedexpressionsOinstancename@_) =
                _instancename
            -- copy rule (down)
            (_guardedexpressionsOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_guardedexpressionsOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_guardedexpressionsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_guardedexpressionsOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_guardedexpressionsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_guardedexpressionsOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_guardedexpressionsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_guardedexpressionsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_guardedexpressionsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_guardedexpressionsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_guardedexpressionsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_guardedexpressionsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_guardedexpressionsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_guardedexpressionsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_guardedexpressionsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_guardedexpressionsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_guardedexpressionsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_guardedexpressionsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_guardedexpressionsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_guardedexpressionsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_guardedexpressionsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_guardedexpressionsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_guardedexpressionsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_guardedexpressionsOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_whereOabstractTypes_collect@_) =
                _guardedexpressionsIabstractTypes_collect
            -- copy rule (chain)
            (_whereObimapImps_collect@_) =
                _guardedexpressionsIbimapImps_collect
            -- copy rule (chain)
            (_whereOclassname@_) =
                _classname
            -- copy rule (chain)
            (_whereOconstructors_collect@_) =
                _guardedexpressionsIconstructors_collect
            -- copy rule (down)
            (_whereOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_whereOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_whereOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_whereOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_whereOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_whereOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (chain)
            (_whereOfunImps_collect@_) =
                _guardedexpressionsIfunImps_collect
            -- copy rule (down)
            (_whereOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_whereOgenericAbstractions_collect@_) =
                _guardedexpressionsIgenericAbstractions_collect
            -- copy rule (down)
            (_whereOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_whereOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (chain)
            (_whereOinstancename@_) =
                _instancename
            -- copy rule (chain)
            (_whereOkinames@_) =
                _guardedexpressionsIkinames
            -- copy rule (down)
            (_whereOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (chain)
            (_whereOkindIndexedTypes_collect@_) =
                _guardedexpressionsIkindIndexedTypes_collect
            -- copy rule (down)
            (_whereOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_whereOkindvar@_) =
                _guardedexpressionsIkindvar
            -- copy rule (chain)
            (_whereOksubst@_) =
                _guardedexpressionsIksubst
            -- copy rule (chain)
            (_whereOlabels_collect@_) =
                _guardedexpressionsIlabels_collect
            -- copy rule (down)
            (_whereOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_whereOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_whereOmethods_collect@_) =
                _guardedexpressionsImethods_collect
            -- copy rule (down)
            (_whereOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_whereOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_whereOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_whereOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_whereOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_whereOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_whereOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_whereOpresignatures_collect@_) =
                _guardedexpressionsIpresignatures_collect
            -- copy rule (chain)
            (_whereOrawRequests_collect@_) =
                _guardedexpressionsIrawRequests_collect
            -- copy rule (down)
            (_whereOsignatures@_) =
                _lhsIsignatures
            -- copy rule (chain)
            (_whereOstructureTypes_collect@_) =
                _guardedexpressionsIstructureTypes_collect
            -- copy rule (down)
            (_whereOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_whereOtypeImps_collect@_) =
                _guardedexpressionsItypeImps_collect
            -- copy rule (down)
            (_whereOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
-- Root --------------------------------------------------------
{-
   inherited attributes:
      in                   : GHInType

   chained attributes:

   synthesised attributes:
      output               : GHOutType
      self                 : SELF

-}
{-
   local variables for Root.Root:
      verbosity
      prelude
      maximumIterations
      ghc
      exportedValues
      exportedTypes
      exportedStructures
      importedEntities
      hiddenEntities
      modules
      optimizer
      optimizerPrelude
      kistop
      kioutput
      staticstop
      dependencyOutput
      dependencies
      reqstop
      requestsOutput
      specialisationsTIT
      specialisations
      output
      outputi
      prekind
      kinds
      kindIndexedTypes
      signatures
      genericAbstractions
      structureTypes
      iterationsNeeded
      normalRequests
      componentRequests
      kindcaseRequests
      genericabstractionRequests
      normalTITRequests
      componentTITRequests
      requestErrors'
      requestErrors
      depErrors
      rawRequests
      self

-}
-- semantic domain
type T_Root = (GHInType) ->
              ( (GHOutType),(Root))
-- cata
sem_Root :: (Root) ->
            (T_Root)
sem_Root ((Root_Root (_contents))) =
    (sem_Root_Root ((sem_ModuleSystem (_contents))))
sem_Root_Root :: (T_ModuleSystem) ->
                 (T_Root)
sem_Root_Root (contents_) =
    \ _lhsIin ->
        let _lhsOoutput :: (GHOutType)
            _lhsOself :: (Root)
            _contentsIabstractTypes_collect :: (Set Name)
            _contentsIbimapImps_collect :: ([Request_BimapImply])
            _contentsIcompiledModule :: (Strings)
            _contentsIconstructors_collect :: (FMap Name Names)
            _contentsIdepConstraints_collect :: ([DepConstraint])
            _contentsIfunImps_collect :: ([Request_FunImply])
            _contentsIgenericAbstractions_collect :: (FMap Name Kind)
            _contentsIkinames :: (KSubst)
            _contentsIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _contentsIkind_errors :: ([GHError])
            _contentsIkindvar :: (Int)
            _contentsIksubst :: (KSubst)
            _contentsIlabels_collect :: (FMap Name Names)
            _contentsImethods_collect :: (FMap Name Names)
            _contentsIoutput :: ([PP.Doc])
            _contentsIoutputi :: ([PP.Doc])
            _contentsIpresignatures_collect :: (PreSignatures)
            _contentsIrawRequests_collect :: ([RawRequest])
            _contentsIself :: (ModuleSystem)
            _contentsIstaticErrors :: ([GHError])
            _contentsIstructureTypes_collect :: (FMap Name LambdaType)
            _contentsItypeImps_collect :: ([Request_TypeImply])
            _contentsOabstractTypes :: (Set Name)
            _contentsOabstractTypes_collect :: (Set Name)
            _contentsObimapImps_collect :: ([Request_BimapImply])
            _contentsOclassname :: (Maybe Name)
            _contentsOconstructors_collect :: (FMap Name Names)
            _contentsOconstructors_dist :: (FMap Name Names)
            _contentsOdependencies :: (FMap Name [(Name,Name)])
            _contentsOexportedStructures :: (Set Name)
            _contentsOexportedTypes :: (Set Name)
            _contentsOexportedValues :: (Set Name)
            _contentsOfunImps_collect :: ([Request_FunImply])
            _contentsOgenericAbstractions :: (FMap Name Kind)
            _contentsOgenericAbstractions_collect :: (FMap Name Kind)
            _contentsOghc :: (Bool)
            _contentsOimportedModule :: (Bool)
            _contentsOinstancename :: (Maybe Name)
            _contentsOkinames :: (KSubst)
            _contentsOkindIndexedTypes :: (FMap Name KindIndexedType)
            _contentsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _contentsOkinds :: (KSubst)
            _contentsOkindvar :: (Int)
            _contentsOksubst :: (KSubst)
            _contentsOlabels_collect :: (FMap Name Names)
            _contentsOlabels_dist :: (FMap Name Names)
            _contentsOmethods_collect :: (FMap Name Names)
            _contentsOmethods_dist :: (FMap Name Names)
            _contentsOmodules :: (Set Strings)
            _contentsOoptimizer :: (Bool)
            _contentsOoptimizerPrelude :: (Declarations)
            _contentsOoutput :: ([PP.Doc])
            _contentsOprekind :: (KSubst)
            _contentsOprelude :: (Bool)
            _contentsOpresignatures :: (PreSignatures)
            _contentsOpresignatures_collect :: (PreSignatures)
            _contentsOrawRequests_collect :: ([RawRequest])
            _contentsOsignatures :: (Signatures)
            _contentsOstructureTypes_collect :: (FMap Name LambdaType)
            _contentsOtoplevel :: (Bool)
            _contentsOtypeImps_collect :: ([Request_TypeImply])
            _contentsOverbosity :: (Int)
            ( _contentsIabstractTypes_collect
             ,_contentsIbimapImps_collect
             ,_contentsIcompiledModule
             ,_contentsIconstructors_collect
             ,_contentsIdepConstraints_collect
             ,_contentsIfunImps_collect
             ,_contentsIgenericAbstractions_collect
             ,_contentsIkinames
             ,_contentsIkindIndexedTypes_collect
             ,_contentsIkind_errors
             ,_contentsIkindvar
             ,_contentsIksubst
             ,_contentsIlabels_collect
             ,_contentsImethods_collect
             ,_contentsIoutput
             ,_contentsIoutputi
             ,_contentsIpresignatures_collect
             ,_contentsIrawRequests_collect
             ,_contentsIself
             ,_contentsIstaticErrors
             ,_contentsIstructureTypes_collect
             ,_contentsItypeImps_collect
             ) =
                (contents_ (_contentsOabstractTypes)
                           (_contentsOabstractTypes_collect)
                           (_contentsObimapImps_collect)
                           (_contentsOclassname)
                           (_contentsOconstructors_collect)
                           (_contentsOconstructors_dist)
                           (_contentsOdependencies)
                           (_contentsOexportedStructures)
                           (_contentsOexportedTypes)
                           (_contentsOexportedValues)
                           (_contentsOfunImps_collect)
                           (_contentsOgenericAbstractions)
                           (_contentsOgenericAbstractions_collect)
                           (_contentsOghc)
                           (_contentsOimportedModule)
                           (_contentsOinstancename)
                           (_contentsOkinames)
                           (_contentsOkindIndexedTypes)
                           (_contentsOkindIndexedTypes_collect)
                           (_contentsOkinds)
                           (_contentsOkindvar)
                           (_contentsOksubst)
                           (_contentsOlabels_collect)
                           (_contentsOlabels_dist)
                           (_contentsOmethods_collect)
                           (_contentsOmethods_dist)
                           (_contentsOmodules)
                           (_contentsOoptimizer)
                           (_contentsOoptimizerPrelude)
                           (_contentsOoutput)
                           (_contentsOprekind)
                           (_contentsOprelude)
                           (_contentsOpresignatures)
                           (_contentsOpresignatures_collect)
                           (_contentsOrawRequests_collect)
                           (_contentsOsignatures)
                           (_contentsOstructureTypes_collect)
                           (_contentsOtoplevel)
                           (_contentsOtypeImps_collect)
                           (_contentsOverbosity))
            -- "GH.lag"(line 146, column 13)
            ((_verbosity@_,_prelude@_,_maximumIterations@_,_ghc@_,_exportedValues@_,_exportedTypes@_,_exportedStructures@_,_importedEntities@_,_hiddenEntities@_,_modules@_,_optimizer@_,_optimizerPrelude@_)) =
                _lhsIin
            -- "GH.lag"(line 220, column 9)
            (_lhsOoutput@_) =
                (printErrorsV _verbosity (_contentsIkind_errors ++ _contentsIstaticErrors ++ _requestErrors)
                ,_kistop || _staticstop || _reqstop
                ,PP.vcat $
                   _kioutput ++ maybe [] (:[]) _dependencyOutput
                             ++ if null _requestsOutput then
                                  []
                                else [PP.text _requestsOutput]
                ,PP.vcat $ _output
                ,PP.vcat $ _outputi
                )
            -- "GH.lag"(line 312, column 9)
            (_kistop@_) =
                any isError _contentsIkind_errors
            -- "GH.lag"(line 302, column 9)
            (_kioutput@_) =
                if _verbosity >= 2 then
                  [PP.empty
                     PP.<$> PP.text "Results of kind inference:"
                     PP.<$> PP.ppKSubst
                              _contentsIcompiledModule
                              _kinds
                  ]
                else
                  []
            -- "GH.lag"(line 332, column 9)
            (_staticstop@_) =
                any isError _contentsIstaticErrors
            -- "GH.lag"(line 433, column 9)
            (_dependencyOutput@_) =
                if _verbosity >= 2 then
                  Just $
                      PP.text "Dependencies:"
                  PP.<$> PP.prettyFM PP.ppName
                           (PP.sep . map (\(n,asn) -> PP.parens (PP.ppName n PP.<+> PP.text "as" PP.<+> PP.ppName asn)))
                           _dependencies
                  PP.<$> PP.text ""
                  PP.<$> PP.text "Generic abstractions:"
                  PP.<$> PP.prettyFM PP.ppName PP.ppKind
                           _genericAbstractions
                else
                  Nothing
            -- "GH.lag"(line 431, column 9)
            (_contentsOdependencies@_) =
                _dependencies
            -- "GH.lag"(line 429, column 9)
            (_dependencies@_) =
                SD.scanDependencies _contentsIself
            -- "GH.lag"(line 526, column 9)
            (_reqstop@_) =
                any isError _requestErrors
            -- "GH.lag"(line 468, column 9)
            (_requestsOutput@_) =
                (if _verbosity >= 3 then
                   "\nRaw requests collected:\n"
                     ++ unlines (map showRawRequest _rawRequests)
                     ++ "\nImplications from source:\n"
                     ++ unlines (map showTypeImply  _contentsItypeImps_collect)
                     ++ unlines (map showBimapImply _contentsIbimapImps_collect)
                     ++ unlines (map showFunImply   _contentsIfunImps_collect)
                     ++ "\nComponent requests:\n"
                     ++ unlines (map showComponentRequest    _componentRequests)
                     ++ unlines (map showKindCaseRequest     _kindcaseRequests)
                     ++ (if null _componentTITRequests then "" else
                           "(type-indexed types:)\n"
                        )
                     ++ unlines (map showComponentTITRequest _componentTITRequests)
                 else ""
                )
                ++
                (if _verbosity >= 2 then
                   "\nSpecialisation requests:\n"
                     ++ unlines (map showNormalRequest       _normalRequests)
                     ++ (if null _genericabstractionRequests then "" else
                           "(generic abstractions:)\n"
                        )
                     ++ unlines (map
                                   showGenericAbstractionRequest
                                   _genericabstractionRequests
                                )
                     ++ (if null _normalTITRequests then "" else
                           "(type-indexed types:)\n"
                        )
                     ++ unlines (map showNormalTITRequest    _normalTITRequests)
                     ++ "\n"
                 else ""
                )
                ++
                (if _verbosity >= 1 then
                   let nrComponent   = length _componentRequests
                                     + length _kindcaseRequests
                                     + length _componentTITRequests
                       nrNormal      = length _normalRequests
                       nrGA          = length _genericabstractionRequests
                       nrNormalTIT   = length _normalTITRequests
                       total         = nrComponent + nrNormal + nrGA + nrNormalTIT
                   in
                       show total ++ " specialisation requests after "
                         ++ show _iterationsNeeded ++ " iterations.\n"
                         ++ "(" ++ show nrComponent ++ " components, "
                                ++ show nrNormal    ++ " MPC/normal, "
                                ++ show nrGA        ++ " generic abstractions, "
                                ++ show nrNormalTIT ++ " type-indexed types.)\n"
                 else ""
                )
            -- "GH.lag"(line 580, column 9)
            (_specialisationsTIT@_) =
                concat
                  [concatMap
                     (SPEC.specialiseNormalTIT    _kinds _dependencies)
                     _normalTITRequests
                  ,concatMap
                     SPEC.specialiseComponentTIT
                     _componentTITRequests
                  ]
            -- "GH.lag"(line 550, column 9)
            (_specialisations@_) =
                let specialization_decls
                        = concat
                          [concatMap
                           (SPEC.specialiseNormal       _kinds _dependencies
                                                        _genericAbstractions)
                           _normalRequests
                          ,concatMap
                           (SPEC.specialiseComponent    _kinds _dependencies)
                           _componentRequests
                          ,concatMap
                           (SPEC.specialiseKindCase            _dependencies)
                           _kindcaseRequests
                          ]
                    decls = specialization_decls
                    optimized_decls = []
                    in if _optimizer
                       then optimized_decls
                       else specialization_decls
            -- "./ModuleInformation.inc.lag"(line 97, column 8)
            (_contentsOinstancename@_) =
                Nothing
            -- "./ModuleInformation.inc.lag"(line 96, column 8)
            (_contentsOclassname@_) =
                Nothing
            -- "./ModuleInformation.inc.lag"(line 95, column 8)
            (_contentsOtoplevel@_) =
                True
            -- "./ModuleInformation.inc.lag"(line 94, column 8)
            (_contentsOimportedModule@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 311, column 9)
            (_contentsOlabels_dist@_) =
                _contentsIlabels_collect
            -- "./ModuleInformation.inc.lag"(line 310, column 9)
            (_contentsOmethods_dist@_) =
                _contentsImethods_collect
            -- "./ModuleInformation.inc.lag"(line 309, column 9)
            (_contentsOconstructors_dist@_) =
                _contentsIconstructors_collect
            -- "./ModuleInformation.inc.lag"(line 307, column 9)
            (_contentsOlabels_collect@_) =
                emptyFM
            -- "./ModuleInformation.inc.lag"(line 306, column 9)
            (_contentsOmethods_collect@_) =
                emptyFM
            -- "./ModuleInformation.inc.lag"(line 305, column 9)
            (_contentsOconstructors_collect@_) =
                emptyFM
            -- "./Output.inc.lag"(line 62, column 9)
            (_output@_) =
                concat
                  [ reverse _contentsIoutput
                  , [PP.ppComment " \n***\nnormal/MPC specialisations\n***\n "]
                  , PP.ppDeclarations False _specialisations
                  , [PP.ppComment " \n***\ntype-indexed type specialisations\n***\n "]
                  , PP.ppDeclarations False _specialisationsTIT
                  ]
            -- "./Output.inc.lag"(line 60, column 9)
            (_contentsOoutput@_) =
                []
            -- "./Exports.inc.lag"(line 113, column 9)
            (_contentsOabstractTypes@_) =
                _contentsIabstractTypes_collect
            -- "./OutputI.inc.lag"(line 61, column 9)
            (_outputi@_) =
                _contentsIoutputi
            -- "./Kind.inc.lag"(line 279, column 9)
            (_prekind@_) =
                _contentsIkinames
            -- "./Kind.inc.lag"(line 278, column 9)
            (_contentsOkinames@_) =
                emptyFM
            -- "./Kind.inc.lag"(line 277, column 9)
            (_contentsOkindvar@_) =
                0
            -- "./Kind.inc.lag"(line 314, column 9)
            (_contentsOksubst@_) =
                emptyFM
            -- "./Kind.inc.lag"(line 738, column 9)
            (_kinds@_) =
                _prekind `compKind` _contentsIksubst
            -- "./KindIndexedType.inc.lag"(line 75, column 9)
            (_kindIndexedTypes@_) =
                _contentsIkindIndexedTypes_collect
            -- "./KindIndexedType.inc.lag"(line 73, column 9)
            (_contentsOkindIndexedTypes_collect@_) =
                emptyFM
            -- "./Signature.inc.lag"(line 104, column 9)
            (_contentsOsignatures@_) =
                _signatures
            -- "./Signature.inc.lag"(line 101, column 9)
            (_signatures@_) =
                expandSignatures
                  _contentsIpresignatures_collect
                  _signatures
            -- "./Signature.inc.lag"(line 100, column 9)
            (_contentsOpresignatures@_) =
                _contentsIpresignatures_collect
            -- "./Signature.inc.lag"(line 98, column 9)
            (_contentsOpresignatures_collect@_) =
                emptyFM
            -- "./GenericAbstraction.inc.lag"(line 80, column 9)
            (_contentsOgenericAbstractions@_) =
                _genericAbstractions
            -- "./GenericAbstraction.inc.lag"(line 79, column 9)
            (_genericAbstractions@_) =
                _contentsIgenericAbstractions_collect
            -- "./GenericAbstraction.inc.lag"(line 76, column 9)
            (_contentsOgenericAbstractions_collect@_) =
                emptyFM
            -- "./Request.inc.lag"(line 117, column 9)
            (_contentsOabstractTypes_collect@_) =
                Set.emptySet
            -- "./Request.inc.lag"(line 116, column 9)
            (_contentsOrawRequests_collect@_) =
                []
            -- "./Request.inc.lag"(line 113, column 9)
            (_contentsOfunImps_collect@_) =
                dependenciesTofunImps _dependencies
            -- "./Request.inc.lag"(line 112, column 9)
            (_contentsObimapImps_collect@_) =
                []
            -- "./Request.inc.lag"(line 111, column 9)
            (_contentsOtypeImps_collect@_) =
                []
            -- "./Request.inc.lag"(line 515, column 9)
            (_structureTypes@_) =
                _contentsIstructureTypes_collect
            -- "./Request.inc.lag"(line 513, column 9)
            (_contentsOstructureTypes_collect@_) =
                emptyFM
            -- "./Request.inc.lag"(line 577, column 13)
            ((_iterationsNeeded@_,_normalRequests@_,_componentRequests@_,_kindcaseRequests@_,_genericabstractionRequests@_,_normalTITRequests@_,_componentTITRequests@_,_requestErrors'@_)) =
                buildRequests
                  _maximumIterations
                  _rawRequests
                  _genericAbstractions
                  _contentsItypeImps_collect
                  _contentsIbimapImps_collect
                  _contentsIfunImps_collect
                  _signatures
                  _kinds
                  _kindIndexedTypes
                  _structureTypes
                  _contentsIabstractTypes_collect
            -- "./Request.inc.lag"(line 575, column 9)
            (_requestErrors@_) =
                _depErrors ++ _requestErrors'
            -- "./Request.inc.lag"(line 571, column 9)
            (_depErrors@_) =
                map
                  (\(DepConstraint (r,n,v)) -> GHError_ResolveDepError r n v)
                  _contentsIdepConstraints_collect
            -- "./Request.inc.lag"(line 569, column 9)
            (_rawRequests@_) =
                _contentsIrawRequests_collect
            -- self rule
            (_self@_) =
                Root_Root _contentsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_contentsOexportedStructures@_) =
                _exportedStructures
            -- copy rule (chain)
            (_contentsOexportedTypes@_) =
                _exportedTypes
            -- copy rule (chain)
            (_contentsOexportedValues@_) =
                _exportedValues
            -- copy rule (chain)
            (_contentsOghc@_) =
                _ghc
            -- copy rule (chain)
            (_contentsOkindIndexedTypes@_) =
                _kindIndexedTypes
            -- copy rule (chain)
            (_contentsOkinds@_) =
                _kinds
            -- copy rule (chain)
            (_contentsOmodules@_) =
                _modules
            -- copy rule (chain)
            (_contentsOoptimizer@_) =
                _optimizer
            -- copy rule (chain)
            (_contentsOoptimizerPrelude@_) =
                _optimizerPrelude
            -- copy rule (chain)
            (_contentsOprekind@_) =
                _prekind
            -- copy rule (chain)
            (_contentsOprelude@_) =
                _prelude
            -- copy rule (chain)
            (_contentsOverbosity@_) =
                _verbosity
        in  ( _lhsOoutput,_lhsOself)
-- SimpleType --------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      inferkind            : Kind
      kind_errors          : [GHError]
      name                 : Name
      self                 : SELF

-}
{-
   local variables for SimpleType.SimpleType:
      self

-}
-- semantic domain
type T_SimpleType = (Maybe Name) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Strings) ->
                    (FMap Name Kind) ->
                    (FMap Name Kind) ->
                    (Bool) ->
                    (Bool) ->
                    (Maybe Name) ->
                    (KSubst) ->
                    (KSubst) ->
                    (Int) ->
                    (KSubst) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Bool) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Set Strings) ->
                    (Bool) ->
                    (Declarations) ->
                    (KSubst) ->
                    (Bool) ->
                    (Bool) ->
                    (Int) ->
                    ( (FMap Name Names),(FMap Name Kind),(Kind),(KSubst),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(Name),(SimpleType))
-- cata
sem_SimpleType :: (SimpleType) ->
                  (T_SimpleType)
sem_SimpleType ((SimpleType_SimpleType (_range) (_name) (_typevariables))) =
    (sem_SimpleType_SimpleType ((sem_Range (_range))) ((sem_Name (_name))) ((sem_KindAnnotatedNames (_typevariables))))
sem_SimpleType_SimpleType :: (T_Range) ->
                             (T_Name) ->
                             (T_KindAnnotatedNames) ->
                             (T_SimpleType)
sem_SimpleType_SimpleType (range_) (name_) (typevariables_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOinferkind :: (Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (SimpleType)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _typevariablesIakinds :: ([MaybeKind])
            _typevariablesIconstructors_collect :: (FMap Name Names)
            _typevariablesIgenericAbstractions_collect :: (FMap Name Kind)
            _typevariablesIinferkind :: (Kind)
            _typevariablesIkinames :: (KSubst)
            _typevariablesIkind_errors :: ([GHError])
            _typevariablesIkindvar :: (Int)
            _typevariablesIksubst :: (KSubst)
            _typevariablesIlabels_collect :: (FMap Name Names)
            _typevariablesImethods_collect :: (FMap Name Names)
            _typevariablesImkinds :: ([MaybeKind])
            _typevariablesIself :: (KindAnnotatedNames)
            _typevariablesOclassname :: (Maybe Name)
            _typevariablesOconstructors_collect :: (FMap Name Names)
            _typevariablesOconstructors_dist :: (FMap Name Names)
            _typevariablesOcurrentModule :: (Strings)
            _typevariablesOgenericAbstractions :: (FMap Name Kind)
            _typevariablesOgenericAbstractions_collect :: (FMap Name Kind)
            _typevariablesOghc :: (Bool)
            _typevariablesOimportedModule :: (Bool)
            _typevariablesOinstancename :: (Maybe Name)
            _typevariablesOkinames :: (KSubst)
            _typevariablesOkinds :: (KSubst)
            _typevariablesOkindvar :: (Int)
            _typevariablesOksubst :: (KSubst)
            _typevariablesOlabels_collect :: (FMap Name Names)
            _typevariablesOlabels_dist :: (FMap Name Names)
            _typevariablesOlocal :: (Bool)
            _typevariablesOmethods_collect :: (FMap Name Names)
            _typevariablesOmethods_dist :: (FMap Name Names)
            _typevariablesOmodules :: (Set Strings)
            _typevariablesOoptimizer :: (Bool)
            _typevariablesOoptimizerPrelude :: (Declarations)
            _typevariablesOprekind :: (KSubst)
            _typevariablesOprelude :: (Bool)
            _typevariablesOtoplevel :: (Bool)
            _typevariablesOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _typevariablesIakinds,_typevariablesIconstructors_collect,_typevariablesIgenericAbstractions_collect,_typevariablesIinferkind,_typevariablesIkinames,_typevariablesIkind_errors,_typevariablesIkindvar,_typevariablesIksubst,_typevariablesIlabels_collect,_typevariablesImethods_collect,_typevariablesImkinds,_typevariablesIself) =
                (typevariables_ (_typevariablesOclassname)
                                (_typevariablesOconstructors_collect)
                                (_typevariablesOconstructors_dist)
                                (_typevariablesOcurrentModule)
                                (_typevariablesOgenericAbstractions)
                                (_typevariablesOgenericAbstractions_collect)
                                (_typevariablesOghc)
                                (_typevariablesOimportedModule)
                                (_typevariablesOinstancename)
                                (_typevariablesOkinames)
                                (_typevariablesOkinds)
                                (_typevariablesOkindvar)
                                (_typevariablesOksubst)
                                (_typevariablesOlabels_collect)
                                (_typevariablesOlabels_dist)
                                (_typevariablesOlocal)
                                (_typevariablesOmethods_collect)
                                (_typevariablesOmethods_dist)
                                (_typevariablesOmodules)
                                (_typevariablesOoptimizer)
                                (_typevariablesOoptimizerPrelude)
                                (_typevariablesOprekind)
                                (_typevariablesOprelude)
                                (_typevariablesOtoplevel)
                                (_typevariablesOverbosity))
            -- "./ModuleInformation.inc.lag"(line 156, column 8)
            (_typevariablesOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 393, column 9)
            (_lhsOname@_) =
                _nameIself
            -- use rule
            (_lhsOkind_errors@_) =
                _typevariablesIkind_errors
            -- self rule
            (_self@_) =
                SimpleType_SimpleType _rangeIself _nameIself _typevariablesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typevariablesIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _typevariablesIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOinferkind@_) =
                _typevariablesIinferkind
            -- copy rule (up)
            (_lhsOkinames@_) =
                _typevariablesIkinames
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _typevariablesIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _typevariablesIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typevariablesIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typevariablesImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_typevariablesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typevariablesOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_typevariablesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typevariablesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typevariablesOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_typevariablesOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_typevariablesOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_typevariablesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typevariablesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typevariablesOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_typevariablesOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_typevariablesOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_typevariablesOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_typevariablesOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_typevariablesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typevariablesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typevariablesOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_typevariablesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typevariablesOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_typevariablesOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_typevariablesOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_typevariablesOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_typevariablesOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_typevariablesOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOinferkind,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
-- Statement ---------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      exportedStructures   : Set Name
      exportedTypes        : Set Name
      exportedValues       : Set Name
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures
      rawRequests_collect  : [RawRequest]
      structureTypes_collect : FMap Name LambdaType
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      kind_errors          : [GHError]
      self                 : SELF
      staticErrors         : [GHError]

-}
{-
   local variables for Statement.Empty:
      self

-}
{-
   local variables for Statement.Expression:
      self

-}
{-
   local variables for Statement.Generator:
      self

-}
{-
   local variables for Statement.Let:
      self

-}
-- semantic domain
type T_Statement = (Set Name) ->
                   ([Request_BimapImply]) ->
                   (Maybe Name) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (Strings) ->
                   (FMap Name [(Name,Name)]) ->
                   (Set Name) ->
                   (Set Name) ->
                   (Set Name) ->
                   ([Request_FunImply]) ->
                   (FMap Name Kind) ->
                   (FMap Name Kind) ->
                   (Bool) ->
                   (Bool) ->
                   (Maybe Name) ->
                   (KSubst) ->
                   (FMap Name KindIndexedType) ->
                   (FMap Name KindIndexedType) ->
                   (KSubst) ->
                   (Int) ->
                   (KSubst) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (Bool) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (Set Strings) ->
                   (Bool) ->
                   (Declarations) ->
                   (KSubst) ->
                   (Bool) ->
                   (PreSignatures) ->
                   (PreSignatures) ->
                   ([RawRequest]) ->
                   (Signatures) ->
                   (FMap Name LambdaType) ->
                   (Bool) ->
                   ([Request_TypeImply]) ->
                   (Int) ->
                   ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(PreSignatures),([RawRequest]),(Statement),([GHError]),(FMap Name LambdaType),([Request_TypeImply]))
-- cata
sem_Statement :: (Statement) ->
                 (T_Statement)
sem_Statement ((Statement_Empty (_range))) =
    (sem_Statement_Empty ((sem_Range (_range))))
sem_Statement ((Statement_Expression (_range) (_expression))) =
    (sem_Statement_Expression ((sem_Range (_range))) ((sem_Expression (_expression))))
sem_Statement ((Statement_Generator (_range) (_pattern) (_expression))) =
    (sem_Statement_Generator ((sem_Range (_range))) ((sem_Pattern (_pattern))) ((sem_Expression (_expression))))
sem_Statement ((Statement_Let (_range) (_declarations))) =
    (sem_Statement_Let ((sem_Range (_range))) ((sem_Declarations (_declarations))))
sem_Statement_Empty :: (T_Range) ->
                       (T_Statement)
sem_Statement_Empty (range_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Statement)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                Statement_Empty _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Statement_Expression :: (T_Range) ->
                            (T_Expression) ->
                            (T_Statement)
sem_Statement_Expression (range_) (expression_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Statement)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionIabstractTypes_collect :: (Set Name)
            _expressionIbimapImps_collect :: ([Request_BimapImply])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdepConstraints_collect :: ([DepConstraint])
            _expressionIfunImps_collect :: ([Request_FunImply])
            _expressionIgenericAbstractions_collect :: (FMap Name Kind)
            _expressionIkinames :: (KSubst)
            _expressionIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionIkind_errors :: ([GHError])
            _expressionIkindvar :: (Int)
            _expressionIksubst :: (KSubst)
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIrawRequests_collect :: ([RawRequest])
            _expressionIself :: (Expression)
            _expressionIstaticErrors :: ([GHError])
            _expressionIstructureTypes_collect :: (FMap Name LambdaType)
            _expressionItypeImps_collect :: ([Request_TypeImply])
            _expressionOabstractTypes_collect :: (Set Name)
            _expressionObimapImps_collect :: ([Request_BimapImply])
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies :: (FMap Name [(Name,Name)])
            _expressionOexportedStructures :: (Set Name)
            _expressionOexportedTypes :: (Set Name)
            _expressionOexportedValues :: (Set Name)
            _expressionOfunImps_collect :: ([Request_FunImply])
            _expressionOgenericAbstractions :: (FMap Name Kind)
            _expressionOgenericAbstractions_collect :: (FMap Name Kind)
            _expressionOghc :: (Bool)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOkinames :: (KSubst)
            _expressionOkindIndexedTypes :: (FMap Name KindIndexedType)
            _expressionOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionOkinds :: (KSubst)
            _expressionOkindvar :: (Int)
            _expressionOksubst :: (KSubst)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmodules :: (Set Strings)
            _expressionOoptimizer :: (Bool)
            _expressionOoptimizerPrelude :: (Declarations)
            _expressionOprekind :: (KSubst)
            _expressionOprelude :: (Bool)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOrawRequests_collect :: ([RawRequest])
            _expressionOsignatures :: (Signatures)
            _expressionOstructureTypes_collect :: (FMap Name LambdaType)
            _expressionOtoplevel :: (Bool)
            _expressionOtypeImps_collect :: ([Request_TypeImply])
            _expressionOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionIabstractTypes_collect
             ,_expressionIbimapImps_collect
             ,_expressionIconstructors_collect
             ,_expressionIdepConstraints_collect
             ,_expressionIfunImps_collect
             ,_expressionIgenericAbstractions_collect
             ,_expressionIkinames
             ,_expressionIkindIndexedTypes_collect
             ,_expressionIkind_errors
             ,_expressionIkindvar
             ,_expressionIksubst
             ,_expressionIlabels_collect
             ,_expressionImethods_collect
             ,_expressionIpresignatures_collect
             ,_expressionIrawRequests_collect
             ,_expressionIself
             ,_expressionIstaticErrors
             ,_expressionIstructureTypes_collect
             ,_expressionItypeImps_collect
             ) =
                (expression_ (_expressionOabstractTypes_collect)
                             (_expressionObimapImps_collect)
                             (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies)
                             (_expressionOexportedStructures)
                             (_expressionOexportedTypes)
                             (_expressionOexportedValues)
                             (_expressionOfunImps_collect)
                             (_expressionOgenericAbstractions)
                             (_expressionOgenericAbstractions_collect)
                             (_expressionOghc)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOkinames)
                             (_expressionOkindIndexedTypes)
                             (_expressionOkindIndexedTypes_collect)
                             (_expressionOkinds)
                             (_expressionOkindvar)
                             (_expressionOksubst)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmodules)
                             (_expressionOoptimizer)
                             (_expressionOoptimizerPrelude)
                             (_expressionOprekind)
                             (_expressionOprelude)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOrawRequests_collect)
                             (_expressionOsignatures)
                             (_expressionOstructureTypes_collect)
                             (_expressionOtoplevel)
                             (_expressionOtypeImps_collect)
                             (_expressionOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _expressionIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _expressionIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _expressionIstaticErrors
            -- self rule
            (_self@_) =
                Statement_Expression _rangeIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _expressionIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _expressionIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _expressionIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _expressionIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _expressionIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _expressionIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _expressionIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _expressionIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _expressionIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _expressionIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _expressionItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_expressionObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_expressionOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_expressionOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_expressionOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_expressionOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_expressionOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_expressionOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_expressionOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_expressionOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_expressionOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_expressionOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_expressionOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_expressionOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_expressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_expressionOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_expressionOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_expressionOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_expressionOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_expressionOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Statement_Generator :: (T_Range) ->
                           (T_Pattern) ->
                           (T_Expression) ->
                           (T_Statement)
sem_Statement_Generator (range_) (pattern_) (expression_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Statement)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _patternIconstructors_collect :: (FMap Name Names)
            _patternIgenericAbstractions_collect :: (FMap Name Kind)
            _patternIlabels_collect :: (FMap Name Names)
            _patternImethods_collect :: (FMap Name Names)
            _patternIname :: (Name)
            _patternIself :: (Pattern)
            _patternOclassname :: (Maybe Name)
            _patternOconstructors_collect :: (FMap Name Names)
            _patternOconstructors_dist :: (FMap Name Names)
            _patternOcurrentModule :: (Strings)
            _patternOgenericAbstractions :: (FMap Name Kind)
            _patternOgenericAbstractions_collect :: (FMap Name Kind)
            _patternOghc :: (Bool)
            _patternOimportedModule :: (Bool)
            _patternOinstancename :: (Maybe Name)
            _patternOlabels_collect :: (FMap Name Names)
            _patternOlabels_dist :: (FMap Name Names)
            _patternOlocal :: (Bool)
            _patternOmethods_collect :: (FMap Name Names)
            _patternOmethods_dist :: (FMap Name Names)
            _patternOmodules :: (Set Strings)
            _patternOoptimizer :: (Bool)
            _patternOoptimizerPrelude :: (Declarations)
            _patternOprelude :: (Bool)
            _patternOtoplevel :: (Bool)
            _patternOverbosity :: (Int)
            _expressionIabstractTypes_collect :: (Set Name)
            _expressionIbimapImps_collect :: ([Request_BimapImply])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdepConstraints_collect :: ([DepConstraint])
            _expressionIfunImps_collect :: ([Request_FunImply])
            _expressionIgenericAbstractions_collect :: (FMap Name Kind)
            _expressionIkinames :: (KSubst)
            _expressionIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionIkind_errors :: ([GHError])
            _expressionIkindvar :: (Int)
            _expressionIksubst :: (KSubst)
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIrawRequests_collect :: ([RawRequest])
            _expressionIself :: (Expression)
            _expressionIstaticErrors :: ([GHError])
            _expressionIstructureTypes_collect :: (FMap Name LambdaType)
            _expressionItypeImps_collect :: ([Request_TypeImply])
            _expressionOabstractTypes_collect :: (Set Name)
            _expressionObimapImps_collect :: ([Request_BimapImply])
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies :: (FMap Name [(Name,Name)])
            _expressionOexportedStructures :: (Set Name)
            _expressionOexportedTypes :: (Set Name)
            _expressionOexportedValues :: (Set Name)
            _expressionOfunImps_collect :: ([Request_FunImply])
            _expressionOgenericAbstractions :: (FMap Name Kind)
            _expressionOgenericAbstractions_collect :: (FMap Name Kind)
            _expressionOghc :: (Bool)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOkinames :: (KSubst)
            _expressionOkindIndexedTypes :: (FMap Name KindIndexedType)
            _expressionOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _expressionOkinds :: (KSubst)
            _expressionOkindvar :: (Int)
            _expressionOksubst :: (KSubst)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmodules :: (Set Strings)
            _expressionOoptimizer :: (Bool)
            _expressionOoptimizerPrelude :: (Declarations)
            _expressionOprekind :: (KSubst)
            _expressionOprelude :: (Bool)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOrawRequests_collect :: ([RawRequest])
            _expressionOsignatures :: (Signatures)
            _expressionOstructureTypes_collect :: (FMap Name LambdaType)
            _expressionOtoplevel :: (Bool)
            _expressionOtypeImps_collect :: ([Request_TypeImply])
            _expressionOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _patternIconstructors_collect,_patternIgenericAbstractions_collect,_patternIlabels_collect,_patternImethods_collect,_patternIname,_patternIself) =
                (pattern_ (_patternOclassname)
                          (_patternOconstructors_collect)
                          (_patternOconstructors_dist)
                          (_patternOcurrentModule)
                          (_patternOgenericAbstractions)
                          (_patternOgenericAbstractions_collect)
                          (_patternOghc)
                          (_patternOimportedModule)
                          (_patternOinstancename)
                          (_patternOlabels_collect)
                          (_patternOlabels_dist)
                          (_patternOlocal)
                          (_patternOmethods_collect)
                          (_patternOmethods_dist)
                          (_patternOmodules)
                          (_patternOoptimizer)
                          (_patternOoptimizerPrelude)
                          (_patternOprelude)
                          (_patternOtoplevel)
                          (_patternOverbosity))
            ( _expressionIabstractTypes_collect
             ,_expressionIbimapImps_collect
             ,_expressionIconstructors_collect
             ,_expressionIdepConstraints_collect
             ,_expressionIfunImps_collect
             ,_expressionIgenericAbstractions_collect
             ,_expressionIkinames
             ,_expressionIkindIndexedTypes_collect
             ,_expressionIkind_errors
             ,_expressionIkindvar
             ,_expressionIksubst
             ,_expressionIlabels_collect
             ,_expressionImethods_collect
             ,_expressionIpresignatures_collect
             ,_expressionIrawRequests_collect
             ,_expressionIself
             ,_expressionIstaticErrors
             ,_expressionIstructureTypes_collect
             ,_expressionItypeImps_collect
             ) =
                (expression_ (_expressionOabstractTypes_collect)
                             (_expressionObimapImps_collect)
                             (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies)
                             (_expressionOexportedStructures)
                             (_expressionOexportedTypes)
                             (_expressionOexportedValues)
                             (_expressionOfunImps_collect)
                             (_expressionOgenericAbstractions)
                             (_expressionOgenericAbstractions_collect)
                             (_expressionOghc)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOkinames)
                             (_expressionOkindIndexedTypes)
                             (_expressionOkindIndexedTypes_collect)
                             (_expressionOkinds)
                             (_expressionOkindvar)
                             (_expressionOksubst)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmodules)
                             (_expressionOoptimizer)
                             (_expressionOoptimizerPrelude)
                             (_expressionOprekind)
                             (_expressionOprelude)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOrawRequests_collect)
                             (_expressionOsignatures)
                             (_expressionOstructureTypes_collect)
                             (_expressionOtoplevel)
                             (_expressionOtypeImps_collect)
                             (_expressionOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _expressionIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _expressionIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _expressionIstaticErrors
            -- self rule
            (_self@_) =
                Statement_Generator _rangeIself _patternIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _expressionIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _expressionIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _expressionIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _expressionIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _expressionIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _expressionIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _expressionIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _expressionIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _expressionIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _expressionIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _expressionItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_patternOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_patternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_patternOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_patternOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_patternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_patternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_patternOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_patternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_patternOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_patternOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_patternOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_patternOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_expressionOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_expressionObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_expressionOconstructors_collect@_) =
                _patternIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_expressionOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_expressionOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_expressionOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_expressionOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_expressionOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_expressionOgenericAbstractions_collect@_) =
                _patternIgenericAbstractions_collect
            -- copy rule (down)
            (_expressionOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_expressionOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_expressionOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_expressionOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_expressionOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_expressionOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_expressionOlabels_collect@_) =
                _patternIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_expressionOmethods_collect@_) =
                _patternImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_expressionOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_expressionOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_expressionOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_expressionOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_expressionOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Statement_Let :: (T_Range) ->
                     (T_Declarations) ->
                     (T_Statement)
sem_Statement_Let (range_) (declarations_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Statement)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _declarationsIabstractTypes_collect :: (Set Name)
            _declarationsIbimapImps_collect :: ([Request_BimapImply])
            _declarationsIconstructors_collect :: (FMap Name Names)
            _declarationsIdepConstraints_collect :: ([DepConstraint])
            _declarationsIdepConstraints_defined :: ([DepConstraint])
            _declarationsIexportedDeclarations :: (Declarations)
            _declarationsIfunImps_collect :: ([Request_FunImply])
            _declarationsIgenericAbstractions_collect :: (FMap Name Kind)
            _declarationsIkinames :: (KSubst)
            _declarationsIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _declarationsIkind_errors :: ([GHError])
            _declarationsIkindvar :: (Int)
            _declarationsIksubst :: (KSubst)
            _declarationsIlabels_collect :: (FMap Name Names)
            _declarationsImethods_collect :: (FMap Name Names)
            _declarationsIoutput :: ([PP.Doc])
            _declarationsIoutputi :: ([PP.Doc])
            _declarationsIpresignatures_collect :: (PreSignatures)
            _declarationsIrawRequests_collect :: ([RawRequest])
            _declarationsIself :: (Declarations)
            _declarationsIstaticErrors :: ([GHError])
            _declarationsIstructureTypes_collect :: (FMap Name LambdaType)
            _declarationsItypeImps_collect :: ([Request_TypeImply])
            _declarationsOabstractTypes_collect :: (Set Name)
            _declarationsObimapImps_collect :: ([Request_BimapImply])
            _declarationsOclassname :: (Maybe Name)
            _declarationsOconstructors_collect :: (FMap Name Names)
            _declarationsOconstructors_dist :: (FMap Name Names)
            _declarationsOcurrentModule :: (Strings)
            _declarationsOdependencies :: (FMap Name [(Name,Name)])
            _declarationsOexportedStructures :: (Set Name)
            _declarationsOexportedTypes :: (Set Name)
            _declarationsOexportedValues :: (Set Name)
            _declarationsOfunImps_collect :: ([Request_FunImply])
            _declarationsOgenericAbstractions :: (FMap Name Kind)
            _declarationsOgenericAbstractions_collect :: (FMap Name Kind)
            _declarationsOghc :: (Bool)
            _declarationsOimportedModule :: (Bool)
            _declarationsOinstancename :: (Maybe Name)
            _declarationsOkinames :: (KSubst)
            _declarationsOkindIndexedTypes :: (FMap Name KindIndexedType)
            _declarationsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _declarationsOkinds :: (KSubst)
            _declarationsOkindvar :: (Int)
            _declarationsOksubst :: (KSubst)
            _declarationsOlabels_collect :: (FMap Name Names)
            _declarationsOlabels_dist :: (FMap Name Names)
            _declarationsOlocal :: (Bool)
            _declarationsOmethods_collect :: (FMap Name Names)
            _declarationsOmethods_dist :: (FMap Name Names)
            _declarationsOmodules :: (Set Strings)
            _declarationsOoptimizer :: (Bool)
            _declarationsOoptimizerPrelude :: (Declarations)
            _declarationsOoutput :: ([PP.Doc])
            _declarationsOprekind :: (KSubst)
            _declarationsOprelude :: (Bool)
            _declarationsOpresignatures :: (PreSignatures)
            _declarationsOpresignatures_collect :: (PreSignatures)
            _declarationsOrawRequests_collect :: ([RawRequest])
            _declarationsOsignatures :: (Signatures)
            _declarationsOstructureTypes_collect :: (FMap Name LambdaType)
            _declarationsOtoplevel :: (Bool)
            _declarationsOtypeImps_collect :: ([Request_TypeImply])
            _declarationsOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _declarationsIabstractTypes_collect
             ,_declarationsIbimapImps_collect
             ,_declarationsIconstructors_collect
             ,_declarationsIdepConstraints_collect
             ,_declarationsIdepConstraints_defined
             ,_declarationsIexportedDeclarations
             ,_declarationsIfunImps_collect
             ,_declarationsIgenericAbstractions_collect
             ,_declarationsIkinames
             ,_declarationsIkindIndexedTypes_collect
             ,_declarationsIkind_errors
             ,_declarationsIkindvar
             ,_declarationsIksubst
             ,_declarationsIlabels_collect
             ,_declarationsImethods_collect
             ,_declarationsIoutput
             ,_declarationsIoutputi
             ,_declarationsIpresignatures_collect
             ,_declarationsIrawRequests_collect
             ,_declarationsIself
             ,_declarationsIstaticErrors
             ,_declarationsIstructureTypes_collect
             ,_declarationsItypeImps_collect
             ) =
                (declarations_ (_declarationsOabstractTypes_collect)
                               (_declarationsObimapImps_collect)
                               (_declarationsOclassname)
                               (_declarationsOconstructors_collect)
                               (_declarationsOconstructors_dist)
                               (_declarationsOcurrentModule)
                               (_declarationsOdependencies)
                               (_declarationsOexportedStructures)
                               (_declarationsOexportedTypes)
                               (_declarationsOexportedValues)
                               (_declarationsOfunImps_collect)
                               (_declarationsOgenericAbstractions)
                               (_declarationsOgenericAbstractions_collect)
                               (_declarationsOghc)
                               (_declarationsOimportedModule)
                               (_declarationsOinstancename)
                               (_declarationsOkinames)
                               (_declarationsOkindIndexedTypes)
                               (_declarationsOkindIndexedTypes_collect)
                               (_declarationsOkinds)
                               (_declarationsOkindvar)
                               (_declarationsOksubst)
                               (_declarationsOlabels_collect)
                               (_declarationsOlabels_dist)
                               (_declarationsOlocal)
                               (_declarationsOmethods_collect)
                               (_declarationsOmethods_dist)
                               (_declarationsOmodules)
                               (_declarationsOoptimizer)
                               (_declarationsOoptimizerPrelude)
                               (_declarationsOoutput)
                               (_declarationsOprekind)
                               (_declarationsOprelude)
                               (_declarationsOpresignatures)
                               (_declarationsOpresignatures_collect)
                               (_declarationsOrawRequests_collect)
                               (_declarationsOsignatures)
                               (_declarationsOstructureTypes_collect)
                               (_declarationsOtoplevel)
                               (_declarationsOtypeImps_collect)
                               (_declarationsOverbosity))
            -- "./Output.inc.lag"(line 402, column 9)
            (_declarationsOoutput@_) =
                []
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _declarationsIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _declarationsIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _declarationsIstaticErrors
            -- self rule
            (_self@_) =
                Statement_Let _rangeIself _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _declarationsIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _declarationsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _declarationsIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _declarationsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _declarationsIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _declarationsIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _declarationsIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _declarationsIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _declarationsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _declarationsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _declarationsImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _declarationsIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _declarationsIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _declarationsIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _declarationsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_declarationsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_declarationsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_declarationsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_declarationsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_declarationsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_declarationsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_declarationsOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_declarationsOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_declarationsOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_declarationsOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_declarationsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_declarationsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_declarationsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_declarationsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_declarationsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_declarationsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_declarationsOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_declarationsOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_declarationsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_declarationsOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_declarationsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_declarationsOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_declarationsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_declarationsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_declarationsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_declarationsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_declarationsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_declarationsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_declarationsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_declarationsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_declarationsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_declarationsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_declarationsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_declarationsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_declarationsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_declarationsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_declarationsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_declarationsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_declarationsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_declarationsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
-- Statements --------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      exportedStructures   : Set Name
      exportedTypes        : Set Name
      exportedValues       : Set Name
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures
      rawRequests_collect  : [RawRequest]
      structureTypes_collect : FMap Name LambdaType
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      kind_errors          : [GHError]
      self                 : SELF
      staticErrors         : [GHError]

-}
{-
   local variables for Statements.Cons:
      self

-}
{-
   local variables for Statements.Nil:
      self

-}
-- semantic domain
type T_Statements = (Set Name) ->
                    ([Request_BimapImply]) ->
                    (Maybe Name) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Strings) ->
                    (FMap Name [(Name,Name)]) ->
                    (Set Name) ->
                    (Set Name) ->
                    (Set Name) ->
                    ([Request_FunImply]) ->
                    (FMap Name Kind) ->
                    (FMap Name Kind) ->
                    (Bool) ->
                    (Bool) ->
                    (Maybe Name) ->
                    (KSubst) ->
                    (FMap Name KindIndexedType) ->
                    (FMap Name KindIndexedType) ->
                    (KSubst) ->
                    (Int) ->
                    (KSubst) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Bool) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Set Strings) ->
                    (Bool) ->
                    (Declarations) ->
                    (KSubst) ->
                    (Bool) ->
                    (PreSignatures) ->
                    (PreSignatures) ->
                    ([RawRequest]) ->
                    (Signatures) ->
                    (FMap Name LambdaType) ->
                    (Bool) ->
                    ([Request_TypeImply]) ->
                    (Int) ->
                    ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(PreSignatures),([RawRequest]),(Statements),([GHError]),(FMap Name LambdaType),([Request_TypeImply]))
-- cata
sem_Statements :: (Statements) ->
                  (T_Statements)
sem_Statements (list) =
    (foldr (sem_Statements_Cons) (sem_Statements_Nil) ((map sem_Statement list)))
sem_Statements_Cons :: (T_Statement) ->
                       (T_Statements) ->
                       (T_Statements)
sem_Statements_Cons (hd_) (tl_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Statements)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _hdIabstractTypes_collect :: (Set Name)
            _hdIbimapImps_collect :: ([Request_BimapImply])
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdepConstraints_collect :: ([DepConstraint])
            _hdIfunImps_collect :: ([Request_FunImply])
            _hdIgenericAbstractions_collect :: (FMap Name Kind)
            _hdIkinames :: (KSubst)
            _hdIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _hdIkind_errors :: ([GHError])
            _hdIkindvar :: (Int)
            _hdIksubst :: (KSubst)
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIpresignatures_collect :: (PreSignatures)
            _hdIrawRequests_collect :: ([RawRequest])
            _hdIself :: (Statement)
            _hdIstaticErrors :: ([GHError])
            _hdIstructureTypes_collect :: (FMap Name LambdaType)
            _hdItypeImps_collect :: ([Request_TypeImply])
            _hdOabstractTypes_collect :: (Set Name)
            _hdObimapImps_collect :: ([Request_BimapImply])
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies :: (FMap Name [(Name,Name)])
            _hdOexportedStructures :: (Set Name)
            _hdOexportedTypes :: (Set Name)
            _hdOexportedValues :: (Set Name)
            _hdOfunImps_collect :: ([Request_FunImply])
            _hdOgenericAbstractions :: (FMap Name Kind)
            _hdOgenericAbstractions_collect :: (FMap Name Kind)
            _hdOghc :: (Bool)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOkinames :: (KSubst)
            _hdOkindIndexedTypes :: (FMap Name KindIndexedType)
            _hdOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _hdOkinds :: (KSubst)
            _hdOkindvar :: (Int)
            _hdOksubst :: (KSubst)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmodules :: (Set Strings)
            _hdOoptimizer :: (Bool)
            _hdOoptimizerPrelude :: (Declarations)
            _hdOprekind :: (KSubst)
            _hdOprelude :: (Bool)
            _hdOpresignatures :: (PreSignatures)
            _hdOpresignatures_collect :: (PreSignatures)
            _hdOrawRequests_collect :: ([RawRequest])
            _hdOsignatures :: (Signatures)
            _hdOstructureTypes_collect :: (FMap Name LambdaType)
            _hdOtoplevel :: (Bool)
            _hdOtypeImps_collect :: ([Request_TypeImply])
            _hdOverbosity :: (Int)
            _tlIabstractTypes_collect :: (Set Name)
            _tlIbimapImps_collect :: ([Request_BimapImply])
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdepConstraints_collect :: ([DepConstraint])
            _tlIfunImps_collect :: ([Request_FunImply])
            _tlIgenericAbstractions_collect :: (FMap Name Kind)
            _tlIkinames :: (KSubst)
            _tlIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _tlIkind_errors :: ([GHError])
            _tlIkindvar :: (Int)
            _tlIksubst :: (KSubst)
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIpresignatures_collect :: (PreSignatures)
            _tlIrawRequests_collect :: ([RawRequest])
            _tlIself :: (Statements)
            _tlIstaticErrors :: ([GHError])
            _tlIstructureTypes_collect :: (FMap Name LambdaType)
            _tlItypeImps_collect :: ([Request_TypeImply])
            _tlOabstractTypes_collect :: (Set Name)
            _tlObimapImps_collect :: ([Request_BimapImply])
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies :: (FMap Name [(Name,Name)])
            _tlOexportedStructures :: (Set Name)
            _tlOexportedTypes :: (Set Name)
            _tlOexportedValues :: (Set Name)
            _tlOfunImps_collect :: ([Request_FunImply])
            _tlOgenericAbstractions :: (FMap Name Kind)
            _tlOgenericAbstractions_collect :: (FMap Name Kind)
            _tlOghc :: (Bool)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOkinames :: (KSubst)
            _tlOkindIndexedTypes :: (FMap Name KindIndexedType)
            _tlOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _tlOkinds :: (KSubst)
            _tlOkindvar :: (Int)
            _tlOksubst :: (KSubst)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmodules :: (Set Strings)
            _tlOoptimizer :: (Bool)
            _tlOoptimizerPrelude :: (Declarations)
            _tlOprekind :: (KSubst)
            _tlOprelude :: (Bool)
            _tlOpresignatures :: (PreSignatures)
            _tlOpresignatures_collect :: (PreSignatures)
            _tlOrawRequests_collect :: ([RawRequest])
            _tlOsignatures :: (Signatures)
            _tlOstructureTypes_collect :: (FMap Name LambdaType)
            _tlOtoplevel :: (Bool)
            _tlOtypeImps_collect :: ([Request_TypeImply])
            _tlOverbosity :: (Int)
            ( _hdIabstractTypes_collect,_hdIbimapImps_collect,_hdIconstructors_collect,_hdIdepConstraints_collect,_hdIfunImps_collect,_hdIgenericAbstractions_collect,_hdIkinames,_hdIkindIndexedTypes_collect,_hdIkind_errors,_hdIkindvar,_hdIksubst,_hdIlabels_collect,_hdImethods_collect,_hdIpresignatures_collect,_hdIrawRequests_collect,_hdIself,_hdIstaticErrors,_hdIstructureTypes_collect,_hdItypeImps_collect) =
                (hd_ (_hdOabstractTypes_collect)
                     (_hdObimapImps_collect)
                     (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOdependencies)
                     (_hdOexportedStructures)
                     (_hdOexportedTypes)
                     (_hdOexportedValues)
                     (_hdOfunImps_collect)
                     (_hdOgenericAbstractions)
                     (_hdOgenericAbstractions_collect)
                     (_hdOghc)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOkinames)
                     (_hdOkindIndexedTypes)
                     (_hdOkindIndexedTypes_collect)
                     (_hdOkinds)
                     (_hdOkindvar)
                     (_hdOksubst)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmodules)
                     (_hdOoptimizer)
                     (_hdOoptimizerPrelude)
                     (_hdOprekind)
                     (_hdOprelude)
                     (_hdOpresignatures)
                     (_hdOpresignatures_collect)
                     (_hdOrawRequests_collect)
                     (_hdOsignatures)
                     (_hdOstructureTypes_collect)
                     (_hdOtoplevel)
                     (_hdOtypeImps_collect)
                     (_hdOverbosity))
            ( _tlIabstractTypes_collect,_tlIbimapImps_collect,_tlIconstructors_collect,_tlIdepConstraints_collect,_tlIfunImps_collect,_tlIgenericAbstractions_collect,_tlIkinames,_tlIkindIndexedTypes_collect,_tlIkind_errors,_tlIkindvar,_tlIksubst,_tlIlabels_collect,_tlImethods_collect,_tlIpresignatures_collect,_tlIrawRequests_collect,_tlIself,_tlIstaticErrors,_tlIstructureTypes_collect,_tlItypeImps_collect) =
                (tl_ (_tlOabstractTypes_collect)
                     (_tlObimapImps_collect)
                     (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOdependencies)
                     (_tlOexportedStructures)
                     (_tlOexportedTypes)
                     (_tlOexportedValues)
                     (_tlOfunImps_collect)
                     (_tlOgenericAbstractions)
                     (_tlOgenericAbstractions_collect)
                     (_tlOghc)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOkinames)
                     (_tlOkindIndexedTypes)
                     (_tlOkindIndexedTypes_collect)
                     (_tlOkinds)
                     (_tlOkindvar)
                     (_tlOksubst)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmodules)
                     (_tlOoptimizer)
                     (_tlOoptimizerPrelude)
                     (_tlOprekind)
                     (_tlOprelude)
                     (_tlOpresignatures)
                     (_tlOpresignatures_collect)
                     (_tlOrawRequests_collect)
                     (_tlOsignatures)
                     (_tlOstructureTypes_collect)
                     (_tlOtoplevel)
                     (_tlOtypeImps_collect)
                     (_tlOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _hdIdepConstraints_collect ++ _tlIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _hdIkind_errors ++ _tlIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _hdIstaticErrors ++ _tlIstaticErrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _tlIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _tlIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _tlIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _tlIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _tlIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _tlIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _tlIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _tlIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _tlIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _tlIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _tlIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _tlItypeImps_collect
            -- copy rule (down)
            (_hdOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_hdObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_hdOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_hdOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_hdOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_hdOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_hdOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_hdOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_hdOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_hdOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_hdOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_hdOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_hdOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_hdOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_hdOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_hdOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_hdOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_hdOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_hdOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_hdOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_hdOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_hdOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_hdOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_hdOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_hdOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_tlOabstractTypes_collect@_) =
                _hdIabstractTypes_collect
            -- copy rule (chain)
            (_tlObimapImps_collect@_) =
                _hdIbimapImps_collect
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_tlOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_tlOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_tlOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (chain)
            (_tlOfunImps_collect@_) =
                _hdIfunImps_collect
            -- copy rule (down)
            (_tlOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_tlOgenericAbstractions_collect@_) =
                _hdIgenericAbstractions_collect
            -- copy rule (down)
            (_tlOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOkinames@_) =
                _hdIkinames
            -- copy rule (down)
            (_tlOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (chain)
            (_tlOkindIndexedTypes_collect@_) =
                _hdIkindIndexedTypes_collect
            -- copy rule (down)
            (_tlOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_tlOkindvar@_) =
                _hdIkindvar
            -- copy rule (chain)
            (_tlOksubst@_) =
                _hdIksubst
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_tlOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_tlOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_tlOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_tlOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_tlOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_tlOpresignatures_collect@_) =
                _hdIpresignatures_collect
            -- copy rule (chain)
            (_tlOrawRequests_collect@_) =
                _hdIrawRequests_collect
            -- copy rule (down)
            (_tlOsignatures@_) =
                _lhsIsignatures
            -- copy rule (chain)
            (_tlOstructureTypes_collect@_) =
                _hdIstructureTypes_collect
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_tlOtypeImps_collect@_) =
                _hdItypeImps_collect
            -- copy rule (down)
            (_tlOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
sem_Statements_Nil :: (T_Statements)
sem_Statements_Nil  =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Statements)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkindIndexedTypes_collect,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOstructureTypes_collect,_lhsOtypeImps_collect)
-- Strings -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Strings.Cons:
      self

-}
{-
   local variables for Strings.Nil:
      self

-}
-- semantic domain
type T_Strings = (Maybe Name) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Strings) ->
                 (FMap Name Kind) ->
                 (FMap Name Kind) ->
                 (Bool) ->
                 (Bool) ->
                 (Maybe Name) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Bool) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Set Strings) ->
                 (Bool) ->
                 (Declarations) ->
                 (Bool) ->
                 (Bool) ->
                 (Int) ->
                 ( (FMap Name Names),(FMap Name Kind),(FMap Name Names),(FMap Name Names),(Strings))
-- cata
sem_Strings :: (Strings) ->
               (T_Strings)
sem_Strings (list) =
    (foldr (sem_Strings_Cons) (sem_Strings_Nil) (list))
sem_Strings_Cons :: (String) ->
                    (T_Strings) ->
                    (T_Strings)
sem_Strings_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Strings)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIgenericAbstractions_collect :: (FMap Name Kind)
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIself :: (Strings)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOgenericAbstractions :: (FMap Name Kind)
            _tlOgenericAbstractions_collect :: (FMap Name Kind)
            _tlOghc :: (Bool)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmodules :: (Set Strings)
            _tlOoptimizer :: (Bool)
            _tlOoptimizerPrelude :: (Declarations)
            _tlOprelude :: (Bool)
            _tlOtoplevel :: (Bool)
            _tlOverbosity :: (Int)
            ( _tlIconstructors_collect,_tlIgenericAbstractions_collect,_tlIlabels_collect,_tlImethods_collect,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOgenericAbstractions) (_tlOgenericAbstractions_collect) (_tlOghc) (_tlOimportedModule) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOmodules) (_tlOoptimizer) (_tlOoptimizerPrelude) (_tlOprelude) (_tlOtoplevel) (_tlOverbosity))
            -- self rule
            (_self@_) =
                (:) hd_ _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _tlIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_tlOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_tlOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_tlOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_tlOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_tlOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_tlOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_tlOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_tlOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Strings_Nil :: (T_Strings)
sem_Strings_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Strings)
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- Type --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      rawRequests_collect  : [RawRequest]
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      inferkind            : Kind
      kind_errors          : [GHError]
      self                 : SELF
      staticErrors         : [GHError]

-}
{-
   local variables for Type.Application:
      ks
      kind_errors
      kvar
      kindvar
      self

-}
{-
   local variables for Type.Con:
      self

-}
{-
   local variables for Type.Constructor:
      known_kind
      self

-}
{-
   local variables for Type.ConstructorCase:
      self

-}
{-
   local variables for Type.Exists:
      self

-}
{-
   local variables for Type.Forall:
      ksubst'
      kind_errors
      self

-}
{-
   local variables for Type.KindApplication:
      kvar
      kindvar
      self

-}
{-
   local variables for Type.KindStarCase:
      self

-}
{-
   local variables for Type.Kinded:
      self

-}
{-
   local variables for Type.Label:
      self

-}
{-
   local variables for Type.Parenthesized:
      self

-}
{-
   local variables for Type.Qualified:
      self

-}
{-
   local variables for Type.TypeApplication:
      kvar
      kindvar
      self

-}
{-
   local variables for Type.TypeSignature:
      self

-}
{-
   local variables for Type.Variable:
      known_kind
      self

-}
-- semantic domain
type T_Type = (Set Name) ->
              ([Request_BimapImply]) ->
              (Maybe Name) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (Strings) ->
              (FMap Name [(Name,Name)]) ->
              ([Request_FunImply]) ->
              (FMap Name Kind) ->
              (FMap Name Kind) ->
              (Bool) ->
              (Bool) ->
              (Maybe Name) ->
              (KSubst) ->
              (KSubst) ->
              (Int) ->
              (KSubst) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (Bool) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (Set Strings) ->
              (Bool) ->
              (Declarations) ->
              (KSubst) ->
              (Bool) ->
              ([RawRequest]) ->
              (Bool) ->
              ([Request_TypeImply]) ->
              (Int) ->
              ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),(Kind),(KSubst),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),([RawRequest]),(Type),([GHError]),([Request_TypeImply]))
-- cata
sem_Type :: (Type) ->
            (T_Type)
sem_Type ((Type_Application (_range) (_prefix) (_function) (_arguments))) =
    (sem_Type_Application ((sem_Range (_range))) (_prefix) ((sem_Type (_function))) ((sem_Types (_arguments))))
sem_Type ((Type_Con (_range) (_name))) =
    (sem_Type_Con ((sem_Range (_range))) ((sem_Name (_name))))
sem_Type ((Type_Constructor (_range) (_name))) =
    (sem_Type_Constructor ((sem_Range (_range))) ((sem_Name (_name))))
sem_Type ((Type_ConstructorCase (_range) (_name))) =
    (sem_Type_ConstructorCase ((sem_Range (_range))) ((sem_Name (_name))))
sem_Type ((Type_Exists (_range) (_typevariables) (_type))) =
    (sem_Type_Exists ((sem_Range (_range))) ((sem_Names (_typevariables))) ((sem_Type (_type))))
sem_Type ((Type_Forall (_range) (_typevariables) (_type))) =
    (sem_Type_Forall ((sem_Range (_range))) ((sem_Names (_typevariables))) ((sem_Type (_type))))
sem_Type ((Type_KindApplication (_range) (_name) (_kind))) =
    (sem_Type_KindApplication ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Kind (_kind))))
sem_Type ((Type_KindStarCase (_range))) =
    (sem_Type_KindStarCase ((sem_Range (_range))))
sem_Type ((Type_Kinded (_range) (_name) (_kind))) =
    (sem_Type_Kinded ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Kind (_kind))))
sem_Type ((Type_Label (_range) (_name))) =
    (sem_Type_Label ((sem_Range (_range))) ((sem_Name (_name))))
sem_Type ((Type_Parenthesized (_range) (_type))) =
    (sem_Type_Parenthesized ((sem_Range (_range))) ((sem_Type (_type))))
sem_Type ((Type_Qualified (_range) (_context) (_type))) =
    (sem_Type_Qualified ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_Type (_type))))
sem_Type ((Type_TypeApplication (_range) (_name) (_type))) =
    (sem_Type_TypeApplication ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Type (_type))))
sem_Type ((Type_TypeSignature (_range) (_generics) (_parametrics))) =
    (sem_Type_TypeSignature ((sem_Range (_range))) ((sem_KindAnnotatedNames (_generics))) ((sem_Types (_parametrics))))
sem_Type ((Type_Variable (_range) (_name))) =
    (sem_Type_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Type_Application :: (T_Range) ->
                        (Bool) ->
                        (T_Type) ->
                        (T_Types) ->
                        (T_Type)
sem_Type_Application (range_) (prefix_) (function_) (arguments_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOinferkind :: (Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Type)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _functionIabstractTypes_collect :: (Set Name)
            _functionIbimapImps_collect :: ([Request_BimapImply])
            _functionIconstructors_collect :: (FMap Name Names)
            _functionIdepConstraints_collect :: ([DepConstraint])
            _functionIfunImps_collect :: ([Request_FunImply])
            _functionIgenericAbstractions_collect :: (FMap Name Kind)
            _functionIinferkind :: (Kind)
            _functionIkinames :: (KSubst)
            _functionIkind_errors :: ([GHError])
            _functionIkindvar :: (Int)
            _functionIksubst :: (KSubst)
            _functionIlabels_collect :: (FMap Name Names)
            _functionImethods_collect :: (FMap Name Names)
            _functionIrawRequests_collect :: ([RawRequest])
            _functionIself :: (Type)
            _functionIstaticErrors :: ([GHError])
            _functionItypeImps_collect :: ([Request_TypeImply])
            _functionOabstractTypes_collect :: (Set Name)
            _functionObimapImps_collect :: ([Request_BimapImply])
            _functionOclassname :: (Maybe Name)
            _functionOconstructors_collect :: (FMap Name Names)
            _functionOconstructors_dist :: (FMap Name Names)
            _functionOcurrentModule :: (Strings)
            _functionOdependencies :: (FMap Name [(Name,Name)])
            _functionOfunImps_collect :: ([Request_FunImply])
            _functionOgenericAbstractions :: (FMap Name Kind)
            _functionOgenericAbstractions_collect :: (FMap Name Kind)
            _functionOghc :: (Bool)
            _functionOimportedModule :: (Bool)
            _functionOinstancename :: (Maybe Name)
            _functionOkinames :: (KSubst)
            _functionOkinds :: (KSubst)
            _functionOkindvar :: (Int)
            _functionOksubst :: (KSubst)
            _functionOlabels_collect :: (FMap Name Names)
            _functionOlabels_dist :: (FMap Name Names)
            _functionOlocal :: (Bool)
            _functionOmethods_collect :: (FMap Name Names)
            _functionOmethods_dist :: (FMap Name Names)
            _functionOmodules :: (Set Strings)
            _functionOoptimizer :: (Bool)
            _functionOoptimizerPrelude :: (Declarations)
            _functionOprekind :: (KSubst)
            _functionOprelude :: (Bool)
            _functionOrawRequests_collect :: ([RawRequest])
            _functionOtoplevel :: (Bool)
            _functionOtypeImps_collect :: ([Request_TypeImply])
            _functionOverbosity :: (Int)
            _argumentsIabstractTypes_collect :: (Set Name)
            _argumentsIbimapImps_collect :: ([Request_BimapImply])
            _argumentsIconstructors_collect :: (FMap Name Names)
            _argumentsIdepConstraints_collect :: ([DepConstraint])
            _argumentsIfunImps_collect :: ([Request_FunImply])
            _argumentsIgenericAbstractions_collect :: (FMap Name Kind)
            _argumentsIinferkind :: ([Kind])
            _argumentsIkinames :: (KSubst)
            _argumentsIkind_errors :: ([GHError])
            _argumentsIkindvar :: (Int)
            _argumentsIksubst :: (KSubst)
            _argumentsIlabels_collect :: (FMap Name Names)
            _argumentsImethods_collect :: (FMap Name Names)
            _argumentsIrawRequests_collect :: ([RawRequest])
            _argumentsIself :: (Types)
            _argumentsIstaticErrors :: ([GHError])
            _argumentsItypeImps_collect :: ([Request_TypeImply])
            _argumentsOabstractTypes_collect :: (Set Name)
            _argumentsObimapImps_collect :: ([Request_BimapImply])
            _argumentsOclassname :: (Maybe Name)
            _argumentsOconstructors_collect :: (FMap Name Names)
            _argumentsOconstructors_dist :: (FMap Name Names)
            _argumentsOcurrentModule :: (Strings)
            _argumentsOdependencies :: (FMap Name [(Name,Name)])
            _argumentsOfunImps_collect :: ([Request_FunImply])
            _argumentsOgenericAbstractions :: (FMap Name Kind)
            _argumentsOgenericAbstractions_collect :: (FMap Name Kind)
            _argumentsOghc :: (Bool)
            _argumentsOimportedModule :: (Bool)
            _argumentsOinstancename :: (Maybe Name)
            _argumentsOkinames :: (KSubst)
            _argumentsOkinds :: (KSubst)
            _argumentsOkindvar :: (Int)
            _argumentsOksubst :: (KSubst)
            _argumentsOlabels_collect :: (FMap Name Names)
            _argumentsOlabels_dist :: (FMap Name Names)
            _argumentsOlocal :: (Bool)
            _argumentsOmethods_collect :: (FMap Name Names)
            _argumentsOmethods_dist :: (FMap Name Names)
            _argumentsOmodules :: (Set Strings)
            _argumentsOoptimizer :: (Bool)
            _argumentsOoptimizerPrelude :: (Declarations)
            _argumentsOprekind :: (KSubst)
            _argumentsOprelude :: (Bool)
            _argumentsOrawRequests_collect :: ([RawRequest])
            _argumentsOtoplevel :: (Bool)
            _argumentsOtypeImps_collect :: ([Request_TypeImply])
            _argumentsOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _functionIabstractTypes_collect,_functionIbimapImps_collect,_functionIconstructors_collect,_functionIdepConstraints_collect,_functionIfunImps_collect,_functionIgenericAbstractions_collect,_functionIinferkind,_functionIkinames,_functionIkind_errors,_functionIkindvar,_functionIksubst,_functionIlabels_collect,_functionImethods_collect,_functionIrawRequests_collect,_functionIself,_functionIstaticErrors,_functionItypeImps_collect) =
                (function_ (_functionOabstractTypes_collect)
                           (_functionObimapImps_collect)
                           (_functionOclassname)
                           (_functionOconstructors_collect)
                           (_functionOconstructors_dist)
                           (_functionOcurrentModule)
                           (_functionOdependencies)
                           (_functionOfunImps_collect)
                           (_functionOgenericAbstractions)
                           (_functionOgenericAbstractions_collect)
                           (_functionOghc)
                           (_functionOimportedModule)
                           (_functionOinstancename)
                           (_functionOkinames)
                           (_functionOkinds)
                           (_functionOkindvar)
                           (_functionOksubst)
                           (_functionOlabels_collect)
                           (_functionOlabels_dist)
                           (_functionOlocal)
                           (_functionOmethods_collect)
                           (_functionOmethods_dist)
                           (_functionOmodules)
                           (_functionOoptimizer)
                           (_functionOoptimizerPrelude)
                           (_functionOprekind)
                           (_functionOprelude)
                           (_functionOrawRequests_collect)
                           (_functionOtoplevel)
                           (_functionOtypeImps_collect)
                           (_functionOverbosity))
            ( _argumentsIabstractTypes_collect
             ,_argumentsIbimapImps_collect
             ,_argumentsIconstructors_collect
             ,_argumentsIdepConstraints_collect
             ,_argumentsIfunImps_collect
             ,_argumentsIgenericAbstractions_collect
             ,_argumentsIinferkind
             ,_argumentsIkinames
             ,_argumentsIkind_errors
             ,_argumentsIkindvar
             ,_argumentsIksubst
             ,_argumentsIlabels_collect
             ,_argumentsImethods_collect
             ,_argumentsIrawRequests_collect
             ,_argumentsIself
             ,_argumentsIstaticErrors
             ,_argumentsItypeImps_collect
             ) =
                (arguments_ (_argumentsOabstractTypes_collect)
                            (_argumentsObimapImps_collect)
                            (_argumentsOclassname)
                            (_argumentsOconstructors_collect)
                            (_argumentsOconstructors_dist)
                            (_argumentsOcurrentModule)
                            (_argumentsOdependencies)
                            (_argumentsOfunImps_collect)
                            (_argumentsOgenericAbstractions)
                            (_argumentsOgenericAbstractions_collect)
                            (_argumentsOghc)
                            (_argumentsOimportedModule)
                            (_argumentsOinstancename)
                            (_argumentsOkinames)
                            (_argumentsOkinds)
                            (_argumentsOkindvar)
                            (_argumentsOksubst)
                            (_argumentsOlabels_collect)
                            (_argumentsOlabels_dist)
                            (_argumentsOlocal)
                            (_argumentsOmethods_collect)
                            (_argumentsOmethods_dist)
                            (_argumentsOmodules)
                            (_argumentsOoptimizer)
                            (_argumentsOoptimizerPrelude)
                            (_argumentsOprekind)
                            (_argumentsOprelude)
                            (_argumentsOrawRequests_collect)
                            (_argumentsOtoplevel)
                            (_argumentsOtypeImps_collect)
                            (_argumentsOverbosity))
            -- "./Kind.inc.lag"(line 407, column 9)
            (_lhsOinferkind@_) =
                _kvar
            -- "./Kind.inc.lag"(line 406, column 9)
            (_lhsOksubst@_) =
                _ks
            -- "./Kind.inc.lag"(line 405, column 9)
            (_lhsOkind_errors@_) =
                _functionIkind_errors ++ _argumentsIkind_errors ++ _kind_errors
            -- "./Kind.inc.lag"(line 397, column 13)
            ((_ks@_,_kind_errors@_)) =
                let kr = foldr arrK _kvar _argumentsIinferkind
                    kl = _functionIinferkind
                    err= GHError_KindUAError _rangeIself
                           _functionIself
                           _argumentsIself
                           (applyKind _argumentsIksubst _functionIinferkind)
                           (map (applyKind _argumentsIksubst) _argumentsIinferkind)
                 in unifyWithError err kl kr _argumentsIksubst
            -- "./Kind.inc.lag"(line 396, column 9)
            (_kvar@_) =
                mkKindVar' _kindvar
            -- "./Kind.inc.lag"(line 395, column 9)
            (_kindvar@_) =
                _lhsIkindvar + 1
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _functionIdepConstraints_collect ++ _argumentsIdepConstraints_collect
            -- use rule
            (_lhsOstaticErrors@_) =
                _functionIstaticErrors ++ _argumentsIstaticErrors
            -- self rule
            (_self@_) =
                Type_Application _rangeIself prefix_ _functionIself _argumentsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _argumentsIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _argumentsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _argumentsIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _argumentsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _argumentsIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _argumentsIkinames
            -- modified copy rule
            (_lhsOkindvar@_) =
                _argumentsIkindvar
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _argumentsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _argumentsImethods_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _argumentsIrawRequests_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _argumentsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_functionOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_functionObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_functionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_functionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_functionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_functionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_functionOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_functionOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_functionOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_functionOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_functionOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_functionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_functionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_functionOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_functionOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_functionOkindvar@_) =
                _kindvar
            -- copy rule (down)
            (_functionOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_functionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_functionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_functionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_functionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_functionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_functionOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_functionOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_functionOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_functionOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_functionOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_functionOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_functionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_functionOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_functionOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_argumentsOabstractTypes_collect@_) =
                _functionIabstractTypes_collect
            -- copy rule (chain)
            (_argumentsObimapImps_collect@_) =
                _functionIbimapImps_collect
            -- copy rule (down)
            (_argumentsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_argumentsOconstructors_collect@_) =
                _functionIconstructors_collect
            -- copy rule (down)
            (_argumentsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_argumentsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_argumentsOdependencies@_) =
                _lhsIdependencies
            -- copy rule (chain)
            (_argumentsOfunImps_collect@_) =
                _functionIfunImps_collect
            -- copy rule (down)
            (_argumentsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_argumentsOgenericAbstractions_collect@_) =
                _functionIgenericAbstractions_collect
            -- copy rule (down)
            (_argumentsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_argumentsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_argumentsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_argumentsOkinames@_) =
                _functionIkinames
            -- copy rule (down)
            (_argumentsOkinds@_) =
                _lhsIkinds
            -- modified copy rule
            (_argumentsOkindvar@_) =
                _functionIkindvar
            -- copy rule (chain)
            (_argumentsOksubst@_) =
                _functionIksubst
            -- copy rule (chain)
            (_argumentsOlabels_collect@_) =
                _functionIlabels_collect
            -- copy rule (down)
            (_argumentsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_argumentsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_argumentsOmethods_collect@_) =
                _functionImethods_collect
            -- copy rule (down)
            (_argumentsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_argumentsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_argumentsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_argumentsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_argumentsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_argumentsOprelude@_) =
                _lhsIprelude
            -- copy rule (chain)
            (_argumentsOrawRequests_collect@_) =
                _functionIrawRequests_collect
            -- copy rule (down)
            (_argumentsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_argumentsOtypeImps_collect@_) =
                _functionItypeImps_collect
            -- copy rule (down)
            (_argumentsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOinferkind,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps_collect)
sem_Type_Con :: (T_Range) ->
                (T_Name) ->
                (T_Type)
sem_Type_Con (range_) (name_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOinferkind :: (Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Type)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            -- "./Kind.inc.lag"(line 475, column 9)
            (_lhsOinferkind@_) =
                internalError
                   "Con should not occur in a type"
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                Type_Con _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOinferkind,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps_collect)
sem_Type_Constructor :: (T_Range) ->
                        (T_Name) ->
                        (T_Type)
sem_Type_Constructor (range_) (name_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOinferkind :: (Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Type)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            -- "./Kind.inc.lag"(line 379, column 9)
            (_lhsOkind_errors@_) =
                case _known_kind of
                  Just k  -> []
                  Nothing -> [GHError_KindUnkTWarn _rangeIself _nameIself]
            -- "./Kind.inc.lag"(line 375, column 9)
            (_lhsOinferkind@_) =
                case _known_kind of
                  Just k  -> k
                  Nothing -> Kind_Error
            -- "./Kind.inc.lag"(line 373, column 9)
            (_known_kind@_) =
                find _lhsIprekind _nameIself
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                Type_Constructor _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOinferkind,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps_collect)
sem_Type_ConstructorCase :: (T_Range) ->
                            (T_Name) ->
                            (T_Type)
sem_Type_ConstructorCase (range_) (name_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOinferkind :: (Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Type)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            -- "./Kind.inc.lag"(line 471, column 9)
            (_lhsOinferkind@_) =
                internalError
                   "constructor case should not need kind inference"
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                Type_ConstructorCase _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOinferkind,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps_collect)
sem_Type_Exists :: (T_Range) ->
                   (T_Names) ->
                   (T_Type) ->
                   (T_Type)
sem_Type_Exists (range_) (typevariables_) (type_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOinferkind :: (Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Type)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _typevariablesIconstructors_collect :: (FMap Name Names)
            _typevariablesIgenericAbstractions_collect :: (FMap Name Kind)
            _typevariablesIinferkind :: (Kind)
            _typevariablesIkinames :: (KSubst)
            _typevariablesIkind_errors :: ([GHError])
            _typevariablesIkindvar :: (Int)
            _typevariablesIksubst :: (KSubst)
            _typevariablesIlabels_collect :: (FMap Name Names)
            _typevariablesImethods_collect :: (FMap Name Names)
            _typevariablesIself :: (Names)
            _typevariablesOclassname :: (Maybe Name)
            _typevariablesOconstructors_collect :: (FMap Name Names)
            _typevariablesOconstructors_dist :: (FMap Name Names)
            _typevariablesOcurrentModule :: (Strings)
            _typevariablesOgenericAbstractions :: (FMap Name Kind)
            _typevariablesOgenericAbstractions_collect :: (FMap Name Kind)
            _typevariablesOghc :: (Bool)
            _typevariablesOimportedModule :: (Bool)
            _typevariablesOinstancename :: (Maybe Name)
            _typevariablesOkinames :: (KSubst)
            _typevariablesOkinds :: (KSubst)
            _typevariablesOkindvar :: (Int)
            _typevariablesOksubst :: (KSubst)
            _typevariablesOlabels_collect :: (FMap Name Names)
            _typevariablesOlabels_dist :: (FMap Name Names)
            _typevariablesOlocal :: (Bool)
            _typevariablesOmethods_collect :: (FMap Name Names)
            _typevariablesOmethods_dist :: (FMap Name Names)
            _typevariablesOmodules :: (Set Strings)
            _typevariablesOoptimizer :: (Bool)
            _typevariablesOoptimizerPrelude :: (Declarations)
            _typevariablesOprekind :: (KSubst)
            _typevariablesOprelude :: (Bool)
            _typevariablesOtoplevel :: (Bool)
            _typevariablesOverbosity :: (Int)
            _typeIabstractTypes_collect :: (Set Name)
            _typeIbimapImps_collect :: ([Request_BimapImply])
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIdepConstraints_collect :: ([DepConstraint])
            _typeIfunImps_collect :: ([Request_FunImply])
            _typeIgenericAbstractions_collect :: (FMap Name Kind)
            _typeIinferkind :: (Kind)
            _typeIkinames :: (KSubst)
            _typeIkind_errors :: ([GHError])
            _typeIkindvar :: (Int)
            _typeIksubst :: (KSubst)
            _typeIlabels_collect :: (FMap Name Names)
            _typeImethods_collect :: (FMap Name Names)
            _typeIrawRequests_collect :: ([RawRequest])
            _typeIself :: (Type)
            _typeIstaticErrors :: ([GHError])
            _typeItypeImps_collect :: ([Request_TypeImply])
            _typeOabstractTypes_collect :: (Set Name)
            _typeObimapImps_collect :: ([Request_BimapImply])
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOdependencies :: (FMap Name [(Name,Name)])
            _typeOfunImps_collect :: ([Request_FunImply])
            _typeOgenericAbstractions :: (FMap Name Kind)
            _typeOgenericAbstractions_collect :: (FMap Name Kind)
            _typeOghc :: (Bool)
            _typeOimportedModule :: (Bool)
            _typeOinstancename :: (Maybe Name)
            _typeOkinames :: (KSubst)
            _typeOkinds :: (KSubst)
            _typeOkindvar :: (Int)
            _typeOksubst :: (KSubst)
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOmodules :: (Set Strings)
            _typeOoptimizer :: (Bool)
            _typeOoptimizerPrelude :: (Declarations)
            _typeOprekind :: (KSubst)
            _typeOprelude :: (Bool)
            _typeOrawRequests_collect :: ([RawRequest])
            _typeOtoplevel :: (Bool)
            _typeOtypeImps_collect :: ([Request_TypeImply])
            _typeOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _typevariablesIconstructors_collect,_typevariablesIgenericAbstractions_collect,_typevariablesIinferkind,_typevariablesIkinames,_typevariablesIkind_errors,_typevariablesIkindvar,_typevariablesIksubst,_typevariablesIlabels_collect,_typevariablesImethods_collect,_typevariablesIself) =
                (typevariables_ (_typevariablesOclassname)
                                (_typevariablesOconstructors_collect)
                                (_typevariablesOconstructors_dist)
                                (_typevariablesOcurrentModule)
                                (_typevariablesOgenericAbstractions)
                                (_typevariablesOgenericAbstractions_collect)
                                (_typevariablesOghc)
                                (_typevariablesOimportedModule)
                                (_typevariablesOinstancename)
                                (_typevariablesOkinames)
                                (_typevariablesOkinds)
                                (_typevariablesOkindvar)
                                (_typevariablesOksubst)
                                (_typevariablesOlabels_collect)
                                (_typevariablesOlabels_dist)
                                (_typevariablesOlocal)
                                (_typevariablesOmethods_collect)
                                (_typevariablesOmethods_dist)
                                (_typevariablesOmodules)
                                (_typevariablesOoptimizer)
                                (_typevariablesOoptimizerPrelude)
                                (_typevariablesOprekind)
                                (_typevariablesOprelude)
                                (_typevariablesOtoplevel)
                                (_typevariablesOverbosity))
            ( _typeIabstractTypes_collect,_typeIbimapImps_collect,_typeIconstructors_collect,_typeIdepConstraints_collect,_typeIfunImps_collect,_typeIgenericAbstractions_collect,_typeIinferkind,_typeIkinames,_typeIkind_errors,_typeIkindvar,_typeIksubst,_typeIlabels_collect,_typeImethods_collect,_typeIrawRequests_collect,_typeIself,_typeIstaticErrors,_typeItypeImps_collect) =
                (type_ (_typeOabstractTypes_collect)
                       (_typeObimapImps_collect)
                       (_typeOclassname)
                       (_typeOconstructors_collect)
                       (_typeOconstructors_dist)
                       (_typeOcurrentModule)
                       (_typeOdependencies)
                       (_typeOfunImps_collect)
                       (_typeOgenericAbstractions)
                       (_typeOgenericAbstractions_collect)
                       (_typeOghc)
                       (_typeOimportedModule)
                       (_typeOinstancename)
                       (_typeOkinames)
                       (_typeOkinds)
                       (_typeOkindvar)
                       (_typeOksubst)
                       (_typeOlabels_collect)
                       (_typeOlabels_dist)
                       (_typeOlocal)
                       (_typeOmethods_collect)
                       (_typeOmethods_dist)
                       (_typeOmodules)
                       (_typeOoptimizer)
                       (_typeOoptimizerPrelude)
                       (_typeOprekind)
                       (_typeOprelude)
                       (_typeOrawRequests_collect)
                       (_typeOtoplevel)
                       (_typeOtypeImps_collect)
                       (_typeOverbosity))
            -- "./Kind.inc.lag"(line 416, column 9)
            (_lhsOinferkind@_) =
                internalError
                   "Exists should not occur in a type"
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _typeIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _typevariablesIkind_errors ++ _typeIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _typeIstaticErrors
            -- self rule
            (_self@_) =
                Type_Exists _rangeIself _typevariablesIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _typeIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _typeIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _typeIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _typeIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _typeIkinames
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _typeIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _typeIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _typeIrawRequests_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _typeItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typevariablesOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_typevariablesOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_typevariablesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typevariablesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typevariablesOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_typevariablesOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_typevariablesOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_typevariablesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typevariablesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typevariablesOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_typevariablesOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_typevariablesOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_typevariablesOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_typevariablesOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_typevariablesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typevariablesOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_typevariablesOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_typevariablesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typevariablesOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_typevariablesOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_typevariablesOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_typevariablesOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_typevariablesOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_typevariablesOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typevariablesOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_typeOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_typeObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _typevariablesIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_typeOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_typeOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_typeOgenericAbstractions_collect@_) =
                _typevariablesIgenericAbstractions_collect
            -- copy rule (down)
            (_typeOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typeOkinames@_) =
                _typevariablesIkinames
            -- copy rule (down)
            (_typeOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_typeOkindvar@_) =
                _typevariablesIkindvar
            -- copy rule (chain)
            (_typeOksubst@_) =
                _typevariablesIksubst
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _typevariablesIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _typevariablesImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typeOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_typeOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_typeOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_typeOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_typeOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_typeOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_typeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_typeOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOinferkind,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps_collect)
sem_Type_Forall :: (T_Range) ->
                   (T_Names) ->
                   (T_Type) ->
                   (T_Type)
sem_Type_Forall (range_) (typevariables_) (type_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOinferkind :: (Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Type)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _typevariablesIconstructors_collect :: (FMap Name Names)
            _typevariablesIgenericAbstractions_collect :: (FMap Name Kind)
            _typevariablesIinferkind :: (Kind)
            _typevariablesIkinames :: (KSubst)
            _typevariablesIkind_errors :: ([GHError])
            _typevariablesIkindvar :: (Int)
            _typevariablesIksubst :: (KSubst)
            _typevariablesIlabels_collect :: (FMap Name Names)
            _typevariablesImethods_collect :: (FMap Name Names)
            _typevariablesIself :: (Names)
            _typevariablesOclassname :: (Maybe Name)
            _typevariablesOconstructors_collect :: (FMap Name Names)
            _typevariablesOconstructors_dist :: (FMap Name Names)
            _typevariablesOcurrentModule :: (Strings)
            _typevariablesOgenericAbstractions :: (FMap Name Kind)
            _typevariablesOgenericAbstractions_collect :: (FMap Name Kind)
            _typevariablesOghc :: (Bool)
            _typevariablesOimportedModule :: (Bool)
            _typevariablesOinstancename :: (Maybe Name)
            _typevariablesOkinames :: (KSubst)
            _typevariablesOkinds :: (KSubst)
            _typevariablesOkindvar :: (Int)
            _typevariablesOksubst :: (KSubst)
            _typevariablesOlabels_collect :: (FMap Name Names)
            _typevariablesOlabels_dist :: (FMap Name Names)
            _typevariablesOlocal :: (Bool)
            _typevariablesOmethods_collect :: (FMap Name Names)
            _typevariablesOmethods_dist :: (FMap Name Names)
            _typevariablesOmodules :: (Set Strings)
            _typevariablesOoptimizer :: (Bool)
            _typevariablesOoptimizerPrelude :: (Declarations)
            _typevariablesOprekind :: (KSubst)
            _typevariablesOprelude :: (Bool)
            _typevariablesOtoplevel :: (Bool)
            _typevariablesOverbosity :: (Int)
            _typeIabstractTypes_collect :: (Set Name)
            _typeIbimapImps_collect :: ([Request_BimapImply])
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIdepConstraints_collect :: ([DepConstraint])
            _typeIfunImps_collect :: ([Request_FunImply])
            _typeIgenericAbstractions_collect :: (FMap Name Kind)
            _typeIinferkind :: (Kind)
            _typeIkinames :: (KSubst)
            _typeIkind_errors :: ([GHError])
            _typeIkindvar :: (Int)
            _typeIksubst :: (KSubst)
            _typeIlabels_collect :: (FMap Name Names)
            _typeImethods_collect :: (FMap Name Names)
            _typeIrawRequests_collect :: ([RawRequest])
            _typeIself :: (Type)
            _typeIstaticErrors :: ([GHError])
            _typeItypeImps_collect :: ([Request_TypeImply])
            _typeOabstractTypes_collect :: (Set Name)
            _typeObimapImps_collect :: ([Request_BimapImply])
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOdependencies :: (FMap Name [(Name,Name)])
            _typeOfunImps_collect :: ([Request_FunImply])
            _typeOgenericAbstractions :: (FMap Name Kind)
            _typeOgenericAbstractions_collect :: (FMap Name Kind)
            _typeOghc :: (Bool)
            _typeOimportedModule :: (Bool)
            _typeOinstancename :: (Maybe Name)
            _typeOkinames :: (KSubst)
            _typeOkinds :: (KSubst)
            _typeOkindvar :: (Int)
            _typeOksubst :: (KSubst)
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOmodules :: (Set Strings)
            _typeOoptimizer :: (Bool)
            _typeOoptimizerPrelude :: (Declarations)
            _typeOprekind :: (KSubst)
            _typeOprelude :: (Bool)
            _typeOrawRequests_collect :: ([RawRequest])
            _typeOtoplevel :: (Bool)
            _typeOtypeImps_collect :: ([Request_TypeImply])
            _typeOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _typevariablesIconstructors_collect,_typevariablesIgenericAbstractions_collect,_typevariablesIinferkind,_typevariablesIkinames,_typevariablesIkind_errors,_typevariablesIkindvar,_typevariablesIksubst,_typevariablesIlabels_collect,_typevariablesImethods_collect,_typevariablesIself) =
                (typevariables_ (_typevariablesOclassname)
                                (_typevariablesOconstructors_collect)
                                (_typevariablesOconstructors_dist)
                                (_typevariablesOcurrentModule)
                                (_typevariablesOgenericAbstractions)
                                (_typevariablesOgenericAbstractions_collect)
                                (_typevariablesOghc)
                                (_typevariablesOimportedModule)
                                (_typevariablesOinstancename)
                                (_typevariablesOkinames)
                                (_typevariablesOkinds)
                                (_typevariablesOkindvar)
                                (_typevariablesOksubst)
                                (_typevariablesOlabels_collect)
                                (_typevariablesOlabels_dist)
                                (_typevariablesOlocal)
                                (_typevariablesOmethods_collect)
                                (_typevariablesOmethods_dist)
                                (_typevariablesOmodules)
                                (_typevariablesOoptimizer)
                                (_typevariablesOoptimizerPrelude)
                                (_typevariablesOprekind)
                                (_typevariablesOprelude)
                                (_typevariablesOtoplevel)
                                (_typevariablesOverbosity))
            ( _typeIabstractTypes_collect,_typeIbimapImps_collect,_typeIconstructors_collect,_typeIdepConstraints_collect,_typeIfunImps_collect,_typeIgenericAbstractions_collect,_typeIinferkind,_typeIkinames,_typeIkind_errors,_typeIkindvar,_typeIksubst,_typeIlabels_collect,_typeImethods_collect,_typeIrawRequests_collect,_typeIself,_typeIstaticErrors,_typeItypeImps_collect) =
                (type_ (_typeOabstractTypes_collect)
                       (_typeObimapImps_collect)
                       (_typeOclassname)
                       (_typeOconstructors_collect)
                       (_typeOconstructors_dist)
                       (_typeOcurrentModule)
                       (_typeOdependencies)
                       (_typeOfunImps_collect)
                       (_typeOgenericAbstractions)
                       (_typeOgenericAbstractions_collect)
                       (_typeOghc)
                       (_typeOimportedModule)
                       (_typeOinstancename)
                       (_typeOkinames)
                       (_typeOkinds)
                       (_typeOkindvar)
                       (_typeOksubst)
                       (_typeOlabels_collect)
                       (_typeOlabels_dist)
                       (_typeOlocal)
                       (_typeOmethods_collect)
                       (_typeOmethods_dist)
                       (_typeOmodules)
                       (_typeOoptimizer)
                       (_typeOoptimizerPrelude)
                       (_typeOprekind)
                       (_typeOprelude)
                       (_typeOrawRequests_collect)
                       (_typeOtoplevel)
                       (_typeOtypeImps_collect)
                       (_typeOverbosity))
            -- "./Kind.inc.lag"(line 461, column 9)
            (_lhsOksubst@_) =
                _ksubst'
            -- "./Kind.inc.lag"(line 460, column 9)
            (_lhsOkind_errors@_) =
                _typeIkind_errors ++ _kind_errors
            -- "./Kind.inc.lag"(line 454, column 13)
            ((_ksubst'@_,_kind_errors@_)) =
                unifyWithError
                  (GHError_KindUFError _rangeIself
                     (applyKind _typeIksubst _typeIinferkind)
                  )
                  _typeIinferkind starK _typeIksubst
            -- "./Kind.inc.lag"(line 453, column 9)
            (_lhsOinferkind@_) =
                _typeIinferkind
            -- "./Kind.inc.lag"(line 452, column 9)
            (_typeOprekind@_) =
                _typevariablesIkinames
            -- "./Kind.inc.lag"(line 451, column 9)
            (_typevariablesOkinames@_) =
                _lhsIprekind
            -- "./Kind.inc.lag"(line 450, column 9)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _typeIdepConstraints_collect
            -- use rule
            (_lhsOstaticErrors@_) =
                _typeIstaticErrors
            -- self rule
            (_self@_) =
                Type_Forall _rangeIself _typevariablesIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _typeIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _typeIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _typeIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _typeIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _typeIkindvar
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _typeIrawRequests_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _typeItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typevariablesOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_typevariablesOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_typevariablesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typevariablesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typevariablesOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_typevariablesOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_typevariablesOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_typevariablesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typevariablesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typevariablesOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_typevariablesOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_typevariablesOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_typevariablesOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_typevariablesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typevariablesOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_typevariablesOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_typevariablesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typevariablesOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_typevariablesOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_typevariablesOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_typevariablesOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_typevariablesOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_typevariablesOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typevariablesOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_typeOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_typeObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _typevariablesIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_typeOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_typeOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_typeOgenericAbstractions_collect@_) =
                _typevariablesIgenericAbstractions_collect
            -- copy rule (down)
            (_typeOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typeOkinames@_) =
                _typevariablesIkinames
            -- copy rule (down)
            (_typeOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_typeOkindvar@_) =
                _typevariablesIkindvar
            -- copy rule (chain)
            (_typeOksubst@_) =
                _typevariablesIksubst
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _typevariablesIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _typevariablesImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typeOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_typeOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_typeOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_typeOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_typeOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_typeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_typeOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOinferkind,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps_collect)
sem_Type_KindApplication :: (T_Range) ->
                            (T_Name) ->
                            (T_Kind) ->
                            (T_Type)
sem_Type_KindApplication (range_) (name_) (kind_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOinferkind :: (Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Type)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _kindIconstructors_collect :: (FMap Name Names)
            _kindIgenericAbstractions_collect :: (FMap Name Kind)
            _kindIkinames :: (KSubst)
            _kindIkind_errors :: ([GHError])
            _kindIkindvar :: (Int)
            _kindIksubst :: (KSubst)
            _kindIlabels_collect :: (FMap Name Names)
            _kindImethods_collect :: (FMap Name Names)
            _kindIself :: (Kind)
            _kindOclassname :: (Maybe Name)
            _kindOconstructors_collect :: (FMap Name Names)
            _kindOconstructors_dist :: (FMap Name Names)
            _kindOcurrentModule :: (Strings)
            _kindOgenericAbstractions :: (FMap Name Kind)
            _kindOgenericAbstractions_collect :: (FMap Name Kind)
            _kindOghc :: (Bool)
            _kindOimportedModule :: (Bool)
            _kindOinstancename :: (Maybe Name)
            _kindOkinames :: (KSubst)
            _kindOkinds :: (KSubst)
            _kindOkindvar :: (Int)
            _kindOksubst :: (KSubst)
            _kindOlabels_collect :: (FMap Name Names)
            _kindOlabels_dist :: (FMap Name Names)
            _kindOlocal :: (Bool)
            _kindOmethods_collect :: (FMap Name Names)
            _kindOmethods_dist :: (FMap Name Names)
            _kindOmodules :: (Set Strings)
            _kindOoptimizer :: (Bool)
            _kindOoptimizerPrelude :: (Declarations)
            _kindOprekind :: (KSubst)
            _kindOprelude :: (Bool)
            _kindOtoplevel :: (Bool)
            _kindOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _kindIconstructors_collect,_kindIgenericAbstractions_collect,_kindIkinames,_kindIkind_errors,_kindIkindvar,_kindIksubst,_kindIlabels_collect,_kindImethods_collect,_kindIself) =
                (kind_ (_kindOclassname)
                       (_kindOconstructors_collect)
                       (_kindOconstructors_dist)
                       (_kindOcurrentModule)
                       (_kindOgenericAbstractions)
                       (_kindOgenericAbstractions_collect)
                       (_kindOghc)
                       (_kindOimportedModule)
                       (_kindOinstancename)
                       (_kindOkinames)
                       (_kindOkinds)
                       (_kindOkindvar)
                       (_kindOksubst)
                       (_kindOlabels_collect)
                       (_kindOlabels_dist)
                       (_kindOlocal)
                       (_kindOmethods_collect)
                       (_kindOmethods_dist)
                       (_kindOmodules)
                       (_kindOoptimizer)
                       (_kindOoptimizerPrelude)
                       (_kindOprekind)
                       (_kindOprelude)
                       (_kindOtoplevel)
                       (_kindOverbosity))
            -- "./Kind.inc.lag"(line 447, column 9)
            (_lhsOinferkind@_) =
                _kvar
            -- "./Kind.inc.lag"(line 446, column 9)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- "./Kind.inc.lag"(line 445, column 9)
            (_lhsOkind_errors@_) =
                []
            -- "./Kind.inc.lag"(line 444, column 9)
            (_kvar@_) =
                mkKindVar' _kindvar
            -- "./Kind.inc.lag"(line 443, column 9)
            (_kindvar@_) =
                _lhsIkindvar + 1
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                Type_KindApplication _rangeIself _nameIself _kindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _kindIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _kindIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _kindIkinames
            -- modified copy rule
            (_lhsOkindvar@_) =
                _kindIkindvar
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _kindIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _kindImethods_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_kindOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_kindOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_kindOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_kindOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_kindOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_kindOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_kindOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_kindOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_kindOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_kindOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_kindOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_kindOkindvar@_) =
                _kindvar
            -- copy rule (down)
            (_kindOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_kindOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_kindOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_kindOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_kindOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_kindOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_kindOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_kindOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_kindOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_kindOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_kindOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_kindOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_kindOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOinferkind,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps_collect)
sem_Type_KindStarCase :: (T_Range) ->
                         (T_Type)
sem_Type_KindStarCase (range_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOinferkind :: (Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Type)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- "./Kind.inc.lag"(line 483, column 9)
            (_lhsOinferkind@_) =
                internalError
                   "KindStarCase should not occur in a type"
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                Type_KindStarCase _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOinferkind,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps_collect)
sem_Type_Kinded :: (T_Range) ->
                   (T_Name) ->
                   (T_Kind) ->
                   (T_Type)
sem_Type_Kinded (range_) (name_) (kind_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOinferkind :: (Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Type)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _kindIconstructors_collect :: (FMap Name Names)
            _kindIgenericAbstractions_collect :: (FMap Name Kind)
            _kindIkinames :: (KSubst)
            _kindIkind_errors :: ([GHError])
            _kindIkindvar :: (Int)
            _kindIksubst :: (KSubst)
            _kindIlabels_collect :: (FMap Name Names)
            _kindImethods_collect :: (FMap Name Names)
            _kindIself :: (Kind)
            _kindOclassname :: (Maybe Name)
            _kindOconstructors_collect :: (FMap Name Names)
            _kindOconstructors_dist :: (FMap Name Names)
            _kindOcurrentModule :: (Strings)
            _kindOgenericAbstractions :: (FMap Name Kind)
            _kindOgenericAbstractions_collect :: (FMap Name Kind)
            _kindOghc :: (Bool)
            _kindOimportedModule :: (Bool)
            _kindOinstancename :: (Maybe Name)
            _kindOkinames :: (KSubst)
            _kindOkinds :: (KSubst)
            _kindOkindvar :: (Int)
            _kindOksubst :: (KSubst)
            _kindOlabels_collect :: (FMap Name Names)
            _kindOlabels_dist :: (FMap Name Names)
            _kindOlocal :: (Bool)
            _kindOmethods_collect :: (FMap Name Names)
            _kindOmethods_dist :: (FMap Name Names)
            _kindOmodules :: (Set Strings)
            _kindOoptimizer :: (Bool)
            _kindOoptimizerPrelude :: (Declarations)
            _kindOprekind :: (KSubst)
            _kindOprelude :: (Bool)
            _kindOtoplevel :: (Bool)
            _kindOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _kindIconstructors_collect,_kindIgenericAbstractions_collect,_kindIkinames,_kindIkind_errors,_kindIkindvar,_kindIksubst,_kindIlabels_collect,_kindImethods_collect,_kindIself) =
                (kind_ (_kindOclassname)
                       (_kindOconstructors_collect)
                       (_kindOconstructors_dist)
                       (_kindOcurrentModule)
                       (_kindOgenericAbstractions)
                       (_kindOgenericAbstractions_collect)
                       (_kindOghc)
                       (_kindOimportedModule)
                       (_kindOinstancename)
                       (_kindOkinames)
                       (_kindOkinds)
                       (_kindOkindvar)
                       (_kindOksubst)
                       (_kindOlabels_collect)
                       (_kindOlabels_dist)
                       (_kindOlocal)
                       (_kindOmethods_collect)
                       (_kindOmethods_dist)
                       (_kindOmodules)
                       (_kindOoptimizer)
                       (_kindOoptimizerPrelude)
                       (_kindOprekind)
                       (_kindOprelude)
                       (_kindOtoplevel)
                       (_kindOverbosity))
            -- "./Kind.inc.lag"(line 419, column 9)
            (_lhsOinferkind@_) =
                internalError
                   "Kinded should not occur in a type"
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                _kindIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                Type_Kinded _rangeIself _nameIself _kindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _kindIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _kindIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _kindIkinames
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _kindIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _kindIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _kindIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _kindImethods_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_kindOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_kindOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_kindOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_kindOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_kindOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_kindOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_kindOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_kindOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_kindOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_kindOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_kindOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_kindOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_kindOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_kindOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_kindOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_kindOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_kindOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_kindOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_kindOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_kindOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_kindOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_kindOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_kindOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_kindOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_kindOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOinferkind,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps_collect)
sem_Type_Label :: (T_Range) ->
                  (T_Name) ->
                  (T_Type)
sem_Type_Label (range_) (name_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOinferkind :: (Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Type)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            -- "./Kind.inc.lag"(line 479, column 9)
            (_lhsOinferkind@_) =
                internalError
                   "Label should not occur in a type"
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                Type_Label _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOinferkind,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps_collect)
sem_Type_Parenthesized :: (T_Range) ->
                          (T_Type) ->
                          (T_Type)
sem_Type_Parenthesized (range_) (type_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOinferkind :: (Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Type)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _typeIabstractTypes_collect :: (Set Name)
            _typeIbimapImps_collect :: ([Request_BimapImply])
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIdepConstraints_collect :: ([DepConstraint])
            _typeIfunImps_collect :: ([Request_FunImply])
            _typeIgenericAbstractions_collect :: (FMap Name Kind)
            _typeIinferkind :: (Kind)
            _typeIkinames :: (KSubst)
            _typeIkind_errors :: ([GHError])
            _typeIkindvar :: (Int)
            _typeIksubst :: (KSubst)
            _typeIlabels_collect :: (FMap Name Names)
            _typeImethods_collect :: (FMap Name Names)
            _typeIrawRequests_collect :: ([RawRequest])
            _typeIself :: (Type)
            _typeIstaticErrors :: ([GHError])
            _typeItypeImps_collect :: ([Request_TypeImply])
            _typeOabstractTypes_collect :: (Set Name)
            _typeObimapImps_collect :: ([Request_BimapImply])
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOdependencies :: (FMap Name [(Name,Name)])
            _typeOfunImps_collect :: ([Request_FunImply])
            _typeOgenericAbstractions :: (FMap Name Kind)
            _typeOgenericAbstractions_collect :: (FMap Name Kind)
            _typeOghc :: (Bool)
            _typeOimportedModule :: (Bool)
            _typeOinstancename :: (Maybe Name)
            _typeOkinames :: (KSubst)
            _typeOkinds :: (KSubst)
            _typeOkindvar :: (Int)
            _typeOksubst :: (KSubst)
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOmodules :: (Set Strings)
            _typeOoptimizer :: (Bool)
            _typeOoptimizerPrelude :: (Declarations)
            _typeOprekind :: (KSubst)
            _typeOprelude :: (Bool)
            _typeOrawRequests_collect :: ([RawRequest])
            _typeOtoplevel :: (Bool)
            _typeOtypeImps_collect :: ([Request_TypeImply])
            _typeOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _typeIabstractTypes_collect,_typeIbimapImps_collect,_typeIconstructors_collect,_typeIdepConstraints_collect,_typeIfunImps_collect,_typeIgenericAbstractions_collect,_typeIinferkind,_typeIkinames,_typeIkind_errors,_typeIkindvar,_typeIksubst,_typeIlabels_collect,_typeImethods_collect,_typeIrawRequests_collect,_typeIself,_typeIstaticErrors,_typeItypeImps_collect) =
                (type_ (_typeOabstractTypes_collect)
                       (_typeObimapImps_collect)
                       (_typeOclassname)
                       (_typeOconstructors_collect)
                       (_typeOconstructors_dist)
                       (_typeOcurrentModule)
                       (_typeOdependencies)
                       (_typeOfunImps_collect)
                       (_typeOgenericAbstractions)
                       (_typeOgenericAbstractions_collect)
                       (_typeOghc)
                       (_typeOimportedModule)
                       (_typeOinstancename)
                       (_typeOkinames)
                       (_typeOkinds)
                       (_typeOkindvar)
                       (_typeOksubst)
                       (_typeOlabels_collect)
                       (_typeOlabels_dist)
                       (_typeOlocal)
                       (_typeOmethods_collect)
                       (_typeOmethods_dist)
                       (_typeOmodules)
                       (_typeOoptimizer)
                       (_typeOoptimizerPrelude)
                       (_typeOprekind)
                       (_typeOprelude)
                       (_typeOrawRequests_collect)
                       (_typeOtoplevel)
                       (_typeOtypeImps_collect)
                       (_typeOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _typeIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _typeIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _typeIstaticErrors
            -- self rule
            (_self@_) =
                Type_Parenthesized _rangeIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _typeIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _typeIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _typeIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _typeIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOinferkind@_) =
                _typeIinferkind
            -- copy rule (up)
            (_lhsOkinames@_) =
                _typeIkinames
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _typeIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _typeIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _typeIrawRequests_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _typeItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_typeObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_typeOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_typeOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_typeOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_typeOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_typeOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typeOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_typeOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_typeOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_typeOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_typeOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_typeOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typeOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_typeOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_typeOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_typeOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_typeOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_typeOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_typeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_typeOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOinferkind,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps_collect)
sem_Type_Qualified :: (T_Range) ->
                      (T_ContextItems) ->
                      (T_Type) ->
                      (T_Type)
sem_Type_Qualified (range_) (context_) (type_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOinferkind :: (Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Type)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _contextIabstractTypes_collect :: (Set Name)
            _contextIbimapImps_collect :: ([Request_BimapImply])
            _contextIconstructors_collect :: (FMap Name Names)
            _contextIdepConstraints_collect :: ([DepConstraint])
            _contextIfunImps_collect :: ([Request_FunImply])
            _contextIgenericAbstractions_collect :: (FMap Name Kind)
            _contextIkinames :: (KSubst)
            _contextIkind_errors :: ([GHError])
            _contextIkindvar :: (Int)
            _contextIksubst :: (KSubst)
            _contextIlabels_collect :: (FMap Name Names)
            _contextImethods_collect :: (FMap Name Names)
            _contextIrawRequests_collect :: ([RawRequest])
            _contextIself :: (ContextItems)
            _contextIstaticErrors :: ([GHError])
            _contextItypeImps_collect :: ([Request_TypeImply])
            _contextOabstractTypes_collect :: (Set Name)
            _contextObimapImps_collect :: ([Request_BimapImply])
            _contextOclassname :: (Maybe Name)
            _contextOconstructors_collect :: (FMap Name Names)
            _contextOconstructors_dist :: (FMap Name Names)
            _contextOcurrentModule :: (Strings)
            _contextOdependencies :: (FMap Name [(Name,Name)])
            _contextOfunImps_collect :: ([Request_FunImply])
            _contextOgenericAbstractions :: (FMap Name Kind)
            _contextOgenericAbstractions_collect :: (FMap Name Kind)
            _contextOghc :: (Bool)
            _contextOimportedModule :: (Bool)
            _contextOinstancename :: (Maybe Name)
            _contextOkinames :: (KSubst)
            _contextOkinds :: (KSubst)
            _contextOkindvar :: (Int)
            _contextOksubst :: (KSubst)
            _contextOlabels_collect :: (FMap Name Names)
            _contextOlabels_dist :: (FMap Name Names)
            _contextOlocal :: (Bool)
            _contextOmethods_collect :: (FMap Name Names)
            _contextOmethods_dist :: (FMap Name Names)
            _contextOmodules :: (Set Strings)
            _contextOoptimizer :: (Bool)
            _contextOoptimizerPrelude :: (Declarations)
            _contextOprekind :: (KSubst)
            _contextOprelude :: (Bool)
            _contextOrawRequests_collect :: ([RawRequest])
            _contextOtoplevel :: (Bool)
            _contextOtypeImps_collect :: ([Request_TypeImply])
            _contextOverbosity :: (Int)
            _typeIabstractTypes_collect :: (Set Name)
            _typeIbimapImps_collect :: ([Request_BimapImply])
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIdepConstraints_collect :: ([DepConstraint])
            _typeIfunImps_collect :: ([Request_FunImply])
            _typeIgenericAbstractions_collect :: (FMap Name Kind)
            _typeIinferkind :: (Kind)
            _typeIkinames :: (KSubst)
            _typeIkind_errors :: ([GHError])
            _typeIkindvar :: (Int)
            _typeIksubst :: (KSubst)
            _typeIlabels_collect :: (FMap Name Names)
            _typeImethods_collect :: (FMap Name Names)
            _typeIrawRequests_collect :: ([RawRequest])
            _typeIself :: (Type)
            _typeIstaticErrors :: ([GHError])
            _typeItypeImps_collect :: ([Request_TypeImply])
            _typeOabstractTypes_collect :: (Set Name)
            _typeObimapImps_collect :: ([Request_BimapImply])
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOdependencies :: (FMap Name [(Name,Name)])
            _typeOfunImps_collect :: ([Request_FunImply])
            _typeOgenericAbstractions :: (FMap Name Kind)
            _typeOgenericAbstractions_collect :: (FMap Name Kind)
            _typeOghc :: (Bool)
            _typeOimportedModule :: (Bool)
            _typeOinstancename :: (Maybe Name)
            _typeOkinames :: (KSubst)
            _typeOkinds :: (KSubst)
            _typeOkindvar :: (Int)
            _typeOksubst :: (KSubst)
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOmodules :: (Set Strings)
            _typeOoptimizer :: (Bool)
            _typeOoptimizerPrelude :: (Declarations)
            _typeOprekind :: (KSubst)
            _typeOprelude :: (Bool)
            _typeOrawRequests_collect :: ([RawRequest])
            _typeOtoplevel :: (Bool)
            _typeOtypeImps_collect :: ([Request_TypeImply])
            _typeOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _contextIabstractTypes_collect,_contextIbimapImps_collect,_contextIconstructors_collect,_contextIdepConstraints_collect,_contextIfunImps_collect,_contextIgenericAbstractions_collect,_contextIkinames,_contextIkind_errors,_contextIkindvar,_contextIksubst,_contextIlabels_collect,_contextImethods_collect,_contextIrawRequests_collect,_contextIself,_contextIstaticErrors,_contextItypeImps_collect) =
                (context_ (_contextOabstractTypes_collect)
                          (_contextObimapImps_collect)
                          (_contextOclassname)
                          (_contextOconstructors_collect)
                          (_contextOconstructors_dist)
                          (_contextOcurrentModule)
                          (_contextOdependencies)
                          (_contextOfunImps_collect)
                          (_contextOgenericAbstractions)
                          (_contextOgenericAbstractions_collect)
                          (_contextOghc)
                          (_contextOimportedModule)
                          (_contextOinstancename)
                          (_contextOkinames)
                          (_contextOkinds)
                          (_contextOkindvar)
                          (_contextOksubst)
                          (_contextOlabels_collect)
                          (_contextOlabels_dist)
                          (_contextOlocal)
                          (_contextOmethods_collect)
                          (_contextOmethods_dist)
                          (_contextOmodules)
                          (_contextOoptimizer)
                          (_contextOoptimizerPrelude)
                          (_contextOprekind)
                          (_contextOprelude)
                          (_contextOrawRequests_collect)
                          (_contextOtoplevel)
                          (_contextOtypeImps_collect)
                          (_contextOverbosity))
            ( _typeIabstractTypes_collect,_typeIbimapImps_collect,_typeIconstructors_collect,_typeIdepConstraints_collect,_typeIfunImps_collect,_typeIgenericAbstractions_collect,_typeIinferkind,_typeIkinames,_typeIkind_errors,_typeIkindvar,_typeIksubst,_typeIlabels_collect,_typeImethods_collect,_typeIrawRequests_collect,_typeIself,_typeIstaticErrors,_typeItypeImps_collect) =
                (type_ (_typeOabstractTypes_collect)
                       (_typeObimapImps_collect)
                       (_typeOclassname)
                       (_typeOconstructors_collect)
                       (_typeOconstructors_dist)
                       (_typeOcurrentModule)
                       (_typeOdependencies)
                       (_typeOfunImps_collect)
                       (_typeOgenericAbstractions)
                       (_typeOgenericAbstractions_collect)
                       (_typeOghc)
                       (_typeOimportedModule)
                       (_typeOinstancename)
                       (_typeOkinames)
                       (_typeOkinds)
                       (_typeOkindvar)
                       (_typeOksubst)
                       (_typeOlabels_collect)
                       (_typeOlabels_dist)
                       (_typeOlocal)
                       (_typeOmethods_collect)
                       (_typeOmethods_dist)
                       (_typeOmodules)
                       (_typeOoptimizer)
                       (_typeOoptimizerPrelude)
                       (_typeOprekind)
                       (_typeOprelude)
                       (_typeOrawRequests_collect)
                       (_typeOtoplevel)
                       (_typeOtypeImps_collect)
                       (_typeOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _contextIdepConstraints_collect ++ _typeIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _contextIkind_errors ++ _typeIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _contextIstaticErrors ++ _typeIstaticErrors
            -- self rule
            (_self@_) =
                Type_Qualified _rangeIself _contextIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _typeIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _typeIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _typeIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _typeIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOinferkind@_) =
                _typeIinferkind
            -- copy rule (up)
            (_lhsOkinames@_) =
                _typeIkinames
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _typeIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _typeIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _typeIrawRequests_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _typeItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_contextOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_contextObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_contextOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_contextOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_contextOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_contextOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_contextOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_contextOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_contextOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_contextOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_contextOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_contextOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_contextOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_contextOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_contextOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_contextOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_contextOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_contextOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_contextOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_contextOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_contextOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_contextOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_contextOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_contextOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_contextOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_contextOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_contextOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_contextOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_contextOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_contextOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_contextOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_typeOabstractTypes_collect@_) =
                _contextIabstractTypes_collect
            -- copy rule (chain)
            (_typeObimapImps_collect@_) =
                _contextIbimapImps_collect
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _contextIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeOdependencies@_) =
                _lhsIdependencies
            -- copy rule (chain)
            (_typeOfunImps_collect@_) =
                _contextIfunImps_collect
            -- copy rule (down)
            (_typeOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_typeOgenericAbstractions_collect@_) =
                _contextIgenericAbstractions_collect
            -- copy rule (down)
            (_typeOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typeOkinames@_) =
                _contextIkinames
            -- copy rule (down)
            (_typeOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_typeOkindvar@_) =
                _contextIkindvar
            -- copy rule (chain)
            (_typeOksubst@_) =
                _contextIksubst
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _contextIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _contextImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typeOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_typeOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_typeOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_typeOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_typeOprelude@_) =
                _lhsIprelude
            -- copy rule (chain)
            (_typeOrawRequests_collect@_) =
                _contextIrawRequests_collect
            -- copy rule (down)
            (_typeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_typeOtypeImps_collect@_) =
                _contextItypeImps_collect
            -- copy rule (down)
            (_typeOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOinferkind,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps_collect)
sem_Type_TypeApplication :: (T_Range) ->
                            (T_Name) ->
                            (T_Type) ->
                            (T_Type)
sem_Type_TypeApplication (range_) (name_) (type_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOinferkind :: (Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Type)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _typeIabstractTypes_collect :: (Set Name)
            _typeIbimapImps_collect :: ([Request_BimapImply])
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIdepConstraints_collect :: ([DepConstraint])
            _typeIfunImps_collect :: ([Request_FunImply])
            _typeIgenericAbstractions_collect :: (FMap Name Kind)
            _typeIinferkind :: (Kind)
            _typeIkinames :: (KSubst)
            _typeIkind_errors :: ([GHError])
            _typeIkindvar :: (Int)
            _typeIksubst :: (KSubst)
            _typeIlabels_collect :: (FMap Name Names)
            _typeImethods_collect :: (FMap Name Names)
            _typeIrawRequests_collect :: ([RawRequest])
            _typeIself :: (Type)
            _typeIstaticErrors :: ([GHError])
            _typeItypeImps_collect :: ([Request_TypeImply])
            _typeOabstractTypes_collect :: (Set Name)
            _typeObimapImps_collect :: ([Request_BimapImply])
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOdependencies :: (FMap Name [(Name,Name)])
            _typeOfunImps_collect :: ([Request_FunImply])
            _typeOgenericAbstractions :: (FMap Name Kind)
            _typeOgenericAbstractions_collect :: (FMap Name Kind)
            _typeOghc :: (Bool)
            _typeOimportedModule :: (Bool)
            _typeOinstancename :: (Maybe Name)
            _typeOkinames :: (KSubst)
            _typeOkinds :: (KSubst)
            _typeOkindvar :: (Int)
            _typeOksubst :: (KSubst)
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOmodules :: (Set Strings)
            _typeOoptimizer :: (Bool)
            _typeOoptimizerPrelude :: (Declarations)
            _typeOprekind :: (KSubst)
            _typeOprelude :: (Bool)
            _typeOrawRequests_collect :: ([RawRequest])
            _typeOtoplevel :: (Bool)
            _typeOtypeImps_collect :: ([Request_TypeImply])
            _typeOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _typeIabstractTypes_collect,_typeIbimapImps_collect,_typeIconstructors_collect,_typeIdepConstraints_collect,_typeIfunImps_collect,_typeIgenericAbstractions_collect,_typeIinferkind,_typeIkinames,_typeIkind_errors,_typeIkindvar,_typeIksubst,_typeIlabels_collect,_typeImethods_collect,_typeIrawRequests_collect,_typeIself,_typeIstaticErrors,_typeItypeImps_collect) =
                (type_ (_typeOabstractTypes_collect)
                       (_typeObimapImps_collect)
                       (_typeOclassname)
                       (_typeOconstructors_collect)
                       (_typeOconstructors_dist)
                       (_typeOcurrentModule)
                       (_typeOdependencies)
                       (_typeOfunImps_collect)
                       (_typeOgenericAbstractions)
                       (_typeOgenericAbstractions_collect)
                       (_typeOghc)
                       (_typeOimportedModule)
                       (_typeOinstancename)
                       (_typeOkinames)
                       (_typeOkinds)
                       (_typeOkindvar)
                       (_typeOksubst)
                       (_typeOlabels_collect)
                       (_typeOlabels_dist)
                       (_typeOlocal)
                       (_typeOmethods_collect)
                       (_typeOmethods_dist)
                       (_typeOmodules)
                       (_typeOoptimizer)
                       (_typeOoptimizerPrelude)
                       (_typeOprekind)
                       (_typeOprelude)
                       (_typeOrawRequests_collect)
                       (_typeOtoplevel)
                       (_typeOtypeImps_collect)
                       (_typeOverbosity))
            -- "./Kind.inc.lag"(line 440, column 9)
            (_lhsOinferkind@_) =
                _kvar
            -- "./Kind.inc.lag"(line 439, column 9)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- "./Kind.inc.lag"(line 438, column 9)
            (_lhsOkind_errors@_) =
                []
            -- "./Kind.inc.lag"(line 437, column 9)
            (_kvar@_) =
                mkKindVar' _kindvar
            -- "./Kind.inc.lag"(line 436, column 9)
            (_kindvar@_) =
                _lhsIkindvar + 1
            -- "./Request.inc.lag"(line 292, column 9)
            (_lhsOdepConstraints_collect@_) =
                [ DepConstraint (_rangeIself,as_n,var)
                | n <- applyFMM _lhsIdependencies (\n -> [(n,n)]) _nameIself
                , let as_n = snd n
                , var <- Set.setToList (freeVars _typeIself) ]
            -- "./Request.inc.lag"(line 290, column 9)
            (_lhsOrawRequests_collect@_) =
                RawRequest (_nameIself,_typeIself)
                  : _typeIrawRequests_collect
            -- use rule
            (_lhsOstaticErrors@_) =
                _typeIstaticErrors
            -- self rule
            (_self@_) =
                Type_TypeApplication _rangeIself _nameIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _typeIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _typeIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _typeIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _typeIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _typeIkinames
            -- modified copy rule
            (_lhsOkindvar@_) =
                _typeIkindvar
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _typeItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_typeOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_typeObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_typeOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_typeOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_typeOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_typeOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typeOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_typeOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_typeOkindvar@_) =
                _kindvar
            -- copy rule (down)
            (_typeOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typeOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_typeOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_typeOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_typeOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_typeOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_typeOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_typeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_typeOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOinferkind,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps_collect)
sem_Type_TypeSignature :: (T_Range) ->
                          (T_KindAnnotatedNames) ->
                          (T_Types) ->
                          (T_Type)
sem_Type_TypeSignature (range_) (generics_) (parametrics_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOinferkind :: (Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Type)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _genericsIakinds :: ([MaybeKind])
            _genericsIconstructors_collect :: (FMap Name Names)
            _genericsIgenericAbstractions_collect :: (FMap Name Kind)
            _genericsIinferkind :: (Kind)
            _genericsIkinames :: (KSubst)
            _genericsIkind_errors :: ([GHError])
            _genericsIkindvar :: (Int)
            _genericsIksubst :: (KSubst)
            _genericsIlabels_collect :: (FMap Name Names)
            _genericsImethods_collect :: (FMap Name Names)
            _genericsImkinds :: ([MaybeKind])
            _genericsIself :: (KindAnnotatedNames)
            _genericsOclassname :: (Maybe Name)
            _genericsOconstructors_collect :: (FMap Name Names)
            _genericsOconstructors_dist :: (FMap Name Names)
            _genericsOcurrentModule :: (Strings)
            _genericsOgenericAbstractions :: (FMap Name Kind)
            _genericsOgenericAbstractions_collect :: (FMap Name Kind)
            _genericsOghc :: (Bool)
            _genericsOimportedModule :: (Bool)
            _genericsOinstancename :: (Maybe Name)
            _genericsOkinames :: (KSubst)
            _genericsOkinds :: (KSubst)
            _genericsOkindvar :: (Int)
            _genericsOksubst :: (KSubst)
            _genericsOlabels_collect :: (FMap Name Names)
            _genericsOlabels_dist :: (FMap Name Names)
            _genericsOlocal :: (Bool)
            _genericsOmethods_collect :: (FMap Name Names)
            _genericsOmethods_dist :: (FMap Name Names)
            _genericsOmodules :: (Set Strings)
            _genericsOoptimizer :: (Bool)
            _genericsOoptimizerPrelude :: (Declarations)
            _genericsOprekind :: (KSubst)
            _genericsOprelude :: (Bool)
            _genericsOtoplevel :: (Bool)
            _genericsOverbosity :: (Int)
            _parametricsIabstractTypes_collect :: (Set Name)
            _parametricsIbimapImps_collect :: ([Request_BimapImply])
            _parametricsIconstructors_collect :: (FMap Name Names)
            _parametricsIdepConstraints_collect :: ([DepConstraint])
            _parametricsIfunImps_collect :: ([Request_FunImply])
            _parametricsIgenericAbstractions_collect :: (FMap Name Kind)
            _parametricsIinferkind :: ([Kind])
            _parametricsIkinames :: (KSubst)
            _parametricsIkind_errors :: ([GHError])
            _parametricsIkindvar :: (Int)
            _parametricsIksubst :: (KSubst)
            _parametricsIlabels_collect :: (FMap Name Names)
            _parametricsImethods_collect :: (FMap Name Names)
            _parametricsIrawRequests_collect :: ([RawRequest])
            _parametricsIself :: (Types)
            _parametricsIstaticErrors :: ([GHError])
            _parametricsItypeImps_collect :: ([Request_TypeImply])
            _parametricsOabstractTypes_collect :: (Set Name)
            _parametricsObimapImps_collect :: ([Request_BimapImply])
            _parametricsOclassname :: (Maybe Name)
            _parametricsOconstructors_collect :: (FMap Name Names)
            _parametricsOconstructors_dist :: (FMap Name Names)
            _parametricsOcurrentModule :: (Strings)
            _parametricsOdependencies :: (FMap Name [(Name,Name)])
            _parametricsOfunImps_collect :: ([Request_FunImply])
            _parametricsOgenericAbstractions :: (FMap Name Kind)
            _parametricsOgenericAbstractions_collect :: (FMap Name Kind)
            _parametricsOghc :: (Bool)
            _parametricsOimportedModule :: (Bool)
            _parametricsOinstancename :: (Maybe Name)
            _parametricsOkinames :: (KSubst)
            _parametricsOkinds :: (KSubst)
            _parametricsOkindvar :: (Int)
            _parametricsOksubst :: (KSubst)
            _parametricsOlabels_collect :: (FMap Name Names)
            _parametricsOlabels_dist :: (FMap Name Names)
            _parametricsOlocal :: (Bool)
            _parametricsOmethods_collect :: (FMap Name Names)
            _parametricsOmethods_dist :: (FMap Name Names)
            _parametricsOmodules :: (Set Strings)
            _parametricsOoptimizer :: (Bool)
            _parametricsOoptimizerPrelude :: (Declarations)
            _parametricsOprekind :: (KSubst)
            _parametricsOprelude :: (Bool)
            _parametricsOrawRequests_collect :: ([RawRequest])
            _parametricsOtoplevel :: (Bool)
            _parametricsOtypeImps_collect :: ([Request_TypeImply])
            _parametricsOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _genericsIakinds,_genericsIconstructors_collect,_genericsIgenericAbstractions_collect,_genericsIinferkind,_genericsIkinames,_genericsIkind_errors,_genericsIkindvar,_genericsIksubst,_genericsIlabels_collect,_genericsImethods_collect,_genericsImkinds,_genericsIself) =
                (generics_ (_genericsOclassname)
                           (_genericsOconstructors_collect)
                           (_genericsOconstructors_dist)
                           (_genericsOcurrentModule)
                           (_genericsOgenericAbstractions)
                           (_genericsOgenericAbstractions_collect)
                           (_genericsOghc)
                           (_genericsOimportedModule)
                           (_genericsOinstancename)
                           (_genericsOkinames)
                           (_genericsOkinds)
                           (_genericsOkindvar)
                           (_genericsOksubst)
                           (_genericsOlabels_collect)
                           (_genericsOlabels_dist)
                           (_genericsOlocal)
                           (_genericsOmethods_collect)
                           (_genericsOmethods_dist)
                           (_genericsOmodules)
                           (_genericsOoptimizer)
                           (_genericsOoptimizerPrelude)
                           (_genericsOprekind)
                           (_genericsOprelude)
                           (_genericsOtoplevel)
                           (_genericsOverbosity))
            ( _parametricsIabstractTypes_collect
             ,_parametricsIbimapImps_collect
             ,_parametricsIconstructors_collect
             ,_parametricsIdepConstraints_collect
             ,_parametricsIfunImps_collect
             ,_parametricsIgenericAbstractions_collect
             ,_parametricsIinferkind
             ,_parametricsIkinames
             ,_parametricsIkind_errors
             ,_parametricsIkindvar
             ,_parametricsIksubst
             ,_parametricsIlabels_collect
             ,_parametricsImethods_collect
             ,_parametricsIrawRequests_collect
             ,_parametricsIself
             ,_parametricsIstaticErrors
             ,_parametricsItypeImps_collect
             ) =
                (parametrics_ (_parametricsOabstractTypes_collect)
                              (_parametricsObimapImps_collect)
                              (_parametricsOclassname)
                              (_parametricsOconstructors_collect)
                              (_parametricsOconstructors_dist)
                              (_parametricsOcurrentModule)
                              (_parametricsOdependencies)
                              (_parametricsOfunImps_collect)
                              (_parametricsOgenericAbstractions)
                              (_parametricsOgenericAbstractions_collect)
                              (_parametricsOghc)
                              (_parametricsOimportedModule)
                              (_parametricsOinstancename)
                              (_parametricsOkinames)
                              (_parametricsOkinds)
                              (_parametricsOkindvar)
                              (_parametricsOksubst)
                              (_parametricsOlabels_collect)
                              (_parametricsOlabels_dist)
                              (_parametricsOlocal)
                              (_parametricsOmethods_collect)
                              (_parametricsOmethods_dist)
                              (_parametricsOmodules)
                              (_parametricsOoptimizer)
                              (_parametricsOoptimizerPrelude)
                              (_parametricsOprekind)
                              (_parametricsOprelude)
                              (_parametricsOrawRequests_collect)
                              (_parametricsOtoplevel)
                              (_parametricsOtypeImps_collect)
                              (_parametricsOverbosity))
            -- "./Kind.inc.lag"(line 422, column 9)
            (_lhsOinferkind@_) =
                internalError
                   "TypeSignature should not occur in a type"
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _parametricsIdepConstraints_collect
            -- use rule
            (_lhsOkind_errors@_) =
                _genericsIkind_errors ++ _parametricsIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _parametricsIstaticErrors
            -- self rule
            (_self@_) =
                Type_TypeSignature _rangeIself _genericsIself _parametricsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _parametricsIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _parametricsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _parametricsIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _parametricsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _parametricsIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _parametricsIkinames
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _parametricsIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _parametricsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _parametricsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _parametricsImethods_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _parametricsIrawRequests_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _parametricsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_genericsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_genericsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_genericsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_genericsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_genericsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_genericsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_genericsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_genericsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_genericsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_genericsOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_genericsOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_genericsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_genericsOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_genericsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_genericsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_genericsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_genericsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_genericsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_genericsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_genericsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_genericsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_genericsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_genericsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_genericsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_genericsOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_parametricsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_parametricsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_parametricsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_parametricsOconstructors_collect@_) =
                _genericsIconstructors_collect
            -- copy rule (down)
            (_parametricsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_parametricsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_parametricsOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_parametricsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_parametricsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_parametricsOgenericAbstractions_collect@_) =
                _genericsIgenericAbstractions_collect
            -- copy rule (down)
            (_parametricsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_parametricsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_parametricsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_parametricsOkinames@_) =
                _genericsIkinames
            -- copy rule (down)
            (_parametricsOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_parametricsOkindvar@_) =
                _genericsIkindvar
            -- copy rule (chain)
            (_parametricsOksubst@_) =
                _genericsIksubst
            -- copy rule (chain)
            (_parametricsOlabels_collect@_) =
                _genericsIlabels_collect
            -- copy rule (down)
            (_parametricsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_parametricsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_parametricsOmethods_collect@_) =
                _genericsImethods_collect
            -- copy rule (down)
            (_parametricsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_parametricsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_parametricsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_parametricsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_parametricsOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_parametricsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_parametricsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_parametricsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_parametricsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_parametricsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOinferkind,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps_collect)
sem_Type_Variable :: (T_Range) ->
                     (T_Name) ->
                     (T_Type)
sem_Type_Variable (range_) (name_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOinferkind :: (Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Type)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            -- "./Kind.inc.lag"(line 360, column 9)
            (_lhsOkind_errors@_) =
                case _known_kind of
                  Just k  -> []
                  Nothing -> [GHError_KindUnkIError _rangeIself _nameIself]
            -- "./Kind.inc.lag"(line 356, column 9)
            (_lhsOinferkind@_) =
                case _known_kind of
                  Just k  -> k
                  Nothing -> Kind_Error
            -- "./Kind.inc.lag"(line 354, column 9)
            (_known_kind@_) =
                find _lhsIprekind _nameIself
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                Type_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOinferkind,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps_collect)
-- TypeArgument ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      kind_errors          : [GHError]
      self                 : SELF

-}
{-
   local variables for TypeArgument.Constructor:
      self

-}
{-
   local variables for TypeArgument.ConstructorCase:
      self

-}
{-
   local variables for TypeArgument.DependencyStyle:
      self

-}
{-
   local variables for TypeArgument.KindStarCase:
      self

-}
{-
   local variables for TypeArgument.Label:
      self

-}
{-
   local variables for TypeArgument.NamedType:
      self

-}
{-
   local variables for TypeArgument.Variable:
      self

-}
-- semantic domain
type T_TypeArgument = (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Strings) ->
                      (FMap Name Kind) ->
                      (FMap Name Kind) ->
                      (Bool) ->
                      (Bool) ->
                      (Maybe Name) ->
                      (KSubst) ->
                      (KSubst) ->
                      (Int) ->
                      (KSubst) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Set Strings) ->
                      (Bool) ->
                      (Declarations) ->
                      (KSubst) ->
                      (Bool) ->
                      (Bool) ->
                      (Int) ->
                      ( (FMap Name Names),(FMap Name Kind),(KSubst),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(TypeArgument))
-- cata
sem_TypeArgument :: (TypeArgument) ->
                    (T_TypeArgument)
sem_TypeArgument ((TypeArgument_Constructor (_range) (_variable))) =
    (sem_TypeArgument_Constructor ((sem_Range (_range))) ((sem_Name (_variable))))
sem_TypeArgument ((TypeArgument_ConstructorCase (_range) (_name))) =
    (sem_TypeArgument_ConstructorCase ((sem_Range (_range))) ((sem_Name (_name))))
sem_TypeArgument ((TypeArgument_DependencyStyle (_range) (_name) (_descriptor) (_variables))) =
    (sem_TypeArgument_DependencyStyle ((sem_Range (_range))) ((sem_Name (_name))) ((sem_MaybeName (_descriptor))) ((sem_Names (_variables))))
sem_TypeArgument ((TypeArgument_KindStarCase (_range))) =
    (sem_TypeArgument_KindStarCase ((sem_Range (_range))))
sem_TypeArgument ((TypeArgument_Label (_range) (_variable))) =
    (sem_TypeArgument_Label ((sem_Range (_range))) ((sem_Name (_variable))))
sem_TypeArgument ((TypeArgument_NamedType (_range) (_name))) =
    (sem_TypeArgument_NamedType ((sem_Range (_range))) ((sem_Name (_name))))
sem_TypeArgument ((TypeArgument_Variable (_range) (_name))) =
    (sem_TypeArgument_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_TypeArgument_Constructor :: (T_Range) ->
                                (T_Name) ->
                                (T_TypeArgument)
sem_TypeArgument_Constructor (range_) (variable_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (TypeArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _variableIconstructors_collect :: (FMap Name Names)
            _variableIgenericAbstractions_collect :: (FMap Name Kind)
            _variableIlabels_collect :: (FMap Name Names)
            _variableImethods_collect :: (FMap Name Names)
            _variableIself :: (Name)
            _variableOclassname :: (Maybe Name)
            _variableOconstructors_collect :: (FMap Name Names)
            _variableOconstructors_dist :: (FMap Name Names)
            _variableOcurrentModule :: (Strings)
            _variableOgenericAbstractions :: (FMap Name Kind)
            _variableOgenericAbstractions_collect :: (FMap Name Kind)
            _variableOghc :: (Bool)
            _variableOimportedModule :: (Bool)
            _variableOinstancename :: (Maybe Name)
            _variableOlabels_collect :: (FMap Name Names)
            _variableOlabels_dist :: (FMap Name Names)
            _variableOlocal :: (Bool)
            _variableOmethods_collect :: (FMap Name Names)
            _variableOmethods_dist :: (FMap Name Names)
            _variableOmodules :: (Set Strings)
            _variableOoptimizer :: (Bool)
            _variableOoptimizerPrelude :: (Declarations)
            _variableOprelude :: (Bool)
            _variableOtoplevel :: (Bool)
            _variableOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _variableIconstructors_collect,_variableIgenericAbstractions_collect,_variableIlabels_collect,_variableImethods_collect,_variableIself) =
                (variable_ (_variableOclassname)
                           (_variableOconstructors_collect)
                           (_variableOconstructors_dist)
                           (_variableOcurrentModule)
                           (_variableOgenericAbstractions)
                           (_variableOgenericAbstractions_collect)
                           (_variableOghc)
                           (_variableOimportedModule)
                           (_variableOinstancename)
                           (_variableOlabels_collect)
                           (_variableOlabels_dist)
                           (_variableOlocal)
                           (_variableOmethods_collect)
                           (_variableOmethods_dist)
                           (_variableOmodules)
                           (_variableOoptimizer)
                           (_variableOoptimizerPrelude)
                           (_variableOprelude)
                           (_variableOtoplevel)
                           (_variableOverbosity))
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- self rule
            (_self@_) =
                TypeArgument_Constructor _rangeIself _variableIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _variableIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _variableIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _variableIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _variableImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_variableOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_variableOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_variableOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_variableOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_variableOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_variableOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_variableOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_variableOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_variableOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_variableOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_variableOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_variableOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_variableOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_variableOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_variableOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_variableOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_variableOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_variableOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_variableOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_variableOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_TypeArgument_ConstructorCase :: (T_Range) ->
                                    (T_Name) ->
                                    (T_TypeArgument)
sem_TypeArgument_ConstructorCase (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (TypeArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- self rule
            (_self@_) =
                TypeArgument_ConstructorCase _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_TypeArgument_DependencyStyle :: (T_Range) ->
                                    (T_Name) ->
                                    (T_MaybeName) ->
                                    (T_Names) ->
                                    (T_TypeArgument)
sem_TypeArgument_DependencyStyle (range_) (name_) (descriptor_) (variables_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (TypeArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _descriptorIconstructors_collect :: (FMap Name Names)
            _descriptorIgenericAbstractions_collect :: (FMap Name Kind)
            _descriptorIlabels_collect :: (FMap Name Names)
            _descriptorImethods_collect :: (FMap Name Names)
            _descriptorIself :: (MaybeName)
            _descriptorOclassname :: (Maybe Name)
            _descriptorOconstructors_collect :: (FMap Name Names)
            _descriptorOconstructors_dist :: (FMap Name Names)
            _descriptorOcurrentModule :: (Strings)
            _descriptorOgenericAbstractions :: (FMap Name Kind)
            _descriptorOgenericAbstractions_collect :: (FMap Name Kind)
            _descriptorOghc :: (Bool)
            _descriptorOimportedModule :: (Bool)
            _descriptorOinstancename :: (Maybe Name)
            _descriptorOlabels_collect :: (FMap Name Names)
            _descriptorOlabels_dist :: (FMap Name Names)
            _descriptorOlocal :: (Bool)
            _descriptorOmethods_collect :: (FMap Name Names)
            _descriptorOmethods_dist :: (FMap Name Names)
            _descriptorOmodules :: (Set Strings)
            _descriptorOoptimizer :: (Bool)
            _descriptorOoptimizerPrelude :: (Declarations)
            _descriptorOprelude :: (Bool)
            _descriptorOtoplevel :: (Bool)
            _descriptorOverbosity :: (Int)
            _variablesIconstructors_collect :: (FMap Name Names)
            _variablesIgenericAbstractions_collect :: (FMap Name Kind)
            _variablesIinferkind :: (Kind)
            _variablesIkinames :: (KSubst)
            _variablesIkind_errors :: ([GHError])
            _variablesIkindvar :: (Int)
            _variablesIksubst :: (KSubst)
            _variablesIlabels_collect :: (FMap Name Names)
            _variablesImethods_collect :: (FMap Name Names)
            _variablesIself :: (Names)
            _variablesOclassname :: (Maybe Name)
            _variablesOconstructors_collect :: (FMap Name Names)
            _variablesOconstructors_dist :: (FMap Name Names)
            _variablesOcurrentModule :: (Strings)
            _variablesOgenericAbstractions :: (FMap Name Kind)
            _variablesOgenericAbstractions_collect :: (FMap Name Kind)
            _variablesOghc :: (Bool)
            _variablesOimportedModule :: (Bool)
            _variablesOinstancename :: (Maybe Name)
            _variablesOkinames :: (KSubst)
            _variablesOkinds :: (KSubst)
            _variablesOkindvar :: (Int)
            _variablesOksubst :: (KSubst)
            _variablesOlabels_collect :: (FMap Name Names)
            _variablesOlabels_dist :: (FMap Name Names)
            _variablesOlocal :: (Bool)
            _variablesOmethods_collect :: (FMap Name Names)
            _variablesOmethods_dist :: (FMap Name Names)
            _variablesOmodules :: (Set Strings)
            _variablesOoptimizer :: (Bool)
            _variablesOoptimizerPrelude :: (Declarations)
            _variablesOprekind :: (KSubst)
            _variablesOprelude :: (Bool)
            _variablesOtoplevel :: (Bool)
            _variablesOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _descriptorIconstructors_collect,_descriptorIgenericAbstractions_collect,_descriptorIlabels_collect,_descriptorImethods_collect,_descriptorIself) =
                (descriptor_ (_descriptorOclassname)
                             (_descriptorOconstructors_collect)
                             (_descriptorOconstructors_dist)
                             (_descriptorOcurrentModule)
                             (_descriptorOgenericAbstractions)
                             (_descriptorOgenericAbstractions_collect)
                             (_descriptorOghc)
                             (_descriptorOimportedModule)
                             (_descriptorOinstancename)
                             (_descriptorOlabels_collect)
                             (_descriptorOlabels_dist)
                             (_descriptorOlocal)
                             (_descriptorOmethods_collect)
                             (_descriptorOmethods_dist)
                             (_descriptorOmodules)
                             (_descriptorOoptimizer)
                             (_descriptorOoptimizerPrelude)
                             (_descriptorOprelude)
                             (_descriptorOtoplevel)
                             (_descriptorOverbosity))
            ( _variablesIconstructors_collect,_variablesIgenericAbstractions_collect,_variablesIinferkind,_variablesIkinames,_variablesIkind_errors,_variablesIkindvar,_variablesIksubst,_variablesIlabels_collect,_variablesImethods_collect,_variablesIself) =
                (variables_ (_variablesOclassname)
                            (_variablesOconstructors_collect)
                            (_variablesOconstructors_dist)
                            (_variablesOcurrentModule)
                            (_variablesOgenericAbstractions)
                            (_variablesOgenericAbstractions_collect)
                            (_variablesOghc)
                            (_variablesOimportedModule)
                            (_variablesOinstancename)
                            (_variablesOkinames)
                            (_variablesOkinds)
                            (_variablesOkindvar)
                            (_variablesOksubst)
                            (_variablesOlabels_collect)
                            (_variablesOlabels_dist)
                            (_variablesOlocal)
                            (_variablesOmethods_collect)
                            (_variablesOmethods_dist)
                            (_variablesOmodules)
                            (_variablesOoptimizer)
                            (_variablesOoptimizerPrelude)
                            (_variablesOprekind)
                            (_variablesOprelude)
                            (_variablesOtoplevel)
                            (_variablesOverbosity))
            -- use rule
            (_lhsOkind_errors@_) =
                _variablesIkind_errors
            -- self rule
            (_self@_) =
                TypeArgument_DependencyStyle _rangeIself _nameIself _descriptorIself _variablesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _variablesIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _variablesIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _variablesIkinames
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _variablesIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _variablesIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _variablesIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _variablesImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_descriptorOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_descriptorOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_descriptorOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_descriptorOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_descriptorOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_descriptorOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_descriptorOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_descriptorOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_descriptorOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_descriptorOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_descriptorOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_descriptorOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_descriptorOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_descriptorOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_descriptorOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_descriptorOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_descriptorOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_descriptorOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_descriptorOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_descriptorOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_variablesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_variablesOconstructors_collect@_) =
                _descriptorIconstructors_collect
            -- copy rule (down)
            (_variablesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_variablesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_variablesOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_variablesOgenericAbstractions_collect@_) =
                _descriptorIgenericAbstractions_collect
            -- copy rule (down)
            (_variablesOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_variablesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_variablesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_variablesOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_variablesOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_variablesOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_variablesOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_variablesOlabels_collect@_) =
                _descriptorIlabels_collect
            -- copy rule (down)
            (_variablesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_variablesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_variablesOmethods_collect@_) =
                _descriptorImethods_collect
            -- copy rule (down)
            (_variablesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_variablesOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_variablesOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_variablesOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_variablesOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_variablesOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_variablesOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_variablesOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_TypeArgument_KindStarCase :: (T_Range) ->
                                 (T_TypeArgument)
sem_TypeArgument_KindStarCase (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (TypeArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- self rule
            (_self@_) =
                TypeArgument_KindStarCase _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_TypeArgument_Label :: (T_Range) ->
                          (T_Name) ->
                          (T_TypeArgument)
sem_TypeArgument_Label (range_) (variable_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (TypeArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _variableIconstructors_collect :: (FMap Name Names)
            _variableIgenericAbstractions_collect :: (FMap Name Kind)
            _variableIlabels_collect :: (FMap Name Names)
            _variableImethods_collect :: (FMap Name Names)
            _variableIself :: (Name)
            _variableOclassname :: (Maybe Name)
            _variableOconstructors_collect :: (FMap Name Names)
            _variableOconstructors_dist :: (FMap Name Names)
            _variableOcurrentModule :: (Strings)
            _variableOgenericAbstractions :: (FMap Name Kind)
            _variableOgenericAbstractions_collect :: (FMap Name Kind)
            _variableOghc :: (Bool)
            _variableOimportedModule :: (Bool)
            _variableOinstancename :: (Maybe Name)
            _variableOlabels_collect :: (FMap Name Names)
            _variableOlabels_dist :: (FMap Name Names)
            _variableOlocal :: (Bool)
            _variableOmethods_collect :: (FMap Name Names)
            _variableOmethods_dist :: (FMap Name Names)
            _variableOmodules :: (Set Strings)
            _variableOoptimizer :: (Bool)
            _variableOoptimizerPrelude :: (Declarations)
            _variableOprelude :: (Bool)
            _variableOtoplevel :: (Bool)
            _variableOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _variableIconstructors_collect,_variableIgenericAbstractions_collect,_variableIlabels_collect,_variableImethods_collect,_variableIself) =
                (variable_ (_variableOclassname)
                           (_variableOconstructors_collect)
                           (_variableOconstructors_dist)
                           (_variableOcurrentModule)
                           (_variableOgenericAbstractions)
                           (_variableOgenericAbstractions_collect)
                           (_variableOghc)
                           (_variableOimportedModule)
                           (_variableOinstancename)
                           (_variableOlabels_collect)
                           (_variableOlabels_dist)
                           (_variableOlocal)
                           (_variableOmethods_collect)
                           (_variableOmethods_dist)
                           (_variableOmodules)
                           (_variableOoptimizer)
                           (_variableOoptimizerPrelude)
                           (_variableOprelude)
                           (_variableOtoplevel)
                           (_variableOverbosity))
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- self rule
            (_self@_) =
                TypeArgument_Label _rangeIself _variableIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _variableIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _variableIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _variableIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _variableImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_variableOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_variableOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_variableOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_variableOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_variableOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_variableOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_variableOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_variableOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_variableOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_variableOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_variableOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_variableOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_variableOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_variableOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_variableOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_variableOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_variableOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_variableOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_variableOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_variableOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_TypeArgument_NamedType :: (T_Range) ->
                              (T_Name) ->
                              (T_TypeArgument)
sem_TypeArgument_NamedType (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (TypeArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- self rule
            (_self@_) =
                TypeArgument_NamedType _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_TypeArgument_Variable :: (T_Range) ->
                             (T_Name) ->
                             (T_TypeArgument)
sem_TypeArgument_Variable (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (TypeArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- self rule
            (_self@_) =
                TypeArgument_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- TypeArguments -----------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      constructors_collect : FMap Name Names
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      kind_errors          : [GHError]
      self                 : SELF

-}
{-
   local variables for TypeArguments.Cons:
      self

-}
{-
   local variables for TypeArguments.Nil:
      self

-}
-- semantic domain
type T_TypeArguments = (Maybe Name) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (Strings) ->
                       (FMap Name Kind) ->
                       (FMap Name Kind) ->
                       (Bool) ->
                       (Bool) ->
                       (Maybe Name) ->
                       (KSubst) ->
                       (KSubst) ->
                       (Int) ->
                       (KSubst) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (Bool) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (Set Strings) ->
                       (Bool) ->
                       (Declarations) ->
                       (KSubst) ->
                       (Bool) ->
                       (Bool) ->
                       (Int) ->
                       ( (FMap Name Names),(FMap Name Kind),(KSubst),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),(TypeArguments))
-- cata
sem_TypeArguments :: (TypeArguments) ->
                     (T_TypeArguments)
sem_TypeArguments (list) =
    (foldr (sem_TypeArguments_Cons) (sem_TypeArguments_Nil) ((map sem_TypeArgument list)))
sem_TypeArguments_Cons :: (T_TypeArgument) ->
                          (T_TypeArguments) ->
                          (T_TypeArguments)
sem_TypeArguments_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (TypeArguments)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIgenericAbstractions_collect :: (FMap Name Kind)
            _hdIkinames :: (KSubst)
            _hdIkind_errors :: ([GHError])
            _hdIkindvar :: (Int)
            _hdIksubst :: (KSubst)
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIself :: (TypeArgument)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOgenericAbstractions :: (FMap Name Kind)
            _hdOgenericAbstractions_collect :: (FMap Name Kind)
            _hdOghc :: (Bool)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOkinames :: (KSubst)
            _hdOkinds :: (KSubst)
            _hdOkindvar :: (Int)
            _hdOksubst :: (KSubst)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmodules :: (Set Strings)
            _hdOoptimizer :: (Bool)
            _hdOoptimizerPrelude :: (Declarations)
            _hdOprekind :: (KSubst)
            _hdOprelude :: (Bool)
            _hdOtoplevel :: (Bool)
            _hdOverbosity :: (Int)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIgenericAbstractions_collect :: (FMap Name Kind)
            _tlIkinames :: (KSubst)
            _tlIkind_errors :: ([GHError])
            _tlIkindvar :: (Int)
            _tlIksubst :: (KSubst)
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIself :: (TypeArguments)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOgenericAbstractions :: (FMap Name Kind)
            _tlOgenericAbstractions_collect :: (FMap Name Kind)
            _tlOghc :: (Bool)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOkinames :: (KSubst)
            _tlOkinds :: (KSubst)
            _tlOkindvar :: (Int)
            _tlOksubst :: (KSubst)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmodules :: (Set Strings)
            _tlOoptimizer :: (Bool)
            _tlOoptimizerPrelude :: (Declarations)
            _tlOprekind :: (KSubst)
            _tlOprelude :: (Bool)
            _tlOtoplevel :: (Bool)
            _tlOverbosity :: (Int)
            ( _hdIconstructors_collect,_hdIgenericAbstractions_collect,_hdIkinames,_hdIkind_errors,_hdIkindvar,_hdIksubst,_hdIlabels_collect,_hdImethods_collect,_hdIself) =
                (hd_ (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOgenericAbstractions)
                     (_hdOgenericAbstractions_collect)
                     (_hdOghc)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOkinames)
                     (_hdOkinds)
                     (_hdOkindvar)
                     (_hdOksubst)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmodules)
                     (_hdOoptimizer)
                     (_hdOoptimizerPrelude)
                     (_hdOprekind)
                     (_hdOprelude)
                     (_hdOtoplevel)
                     (_hdOverbosity))
            ( _tlIconstructors_collect,_tlIgenericAbstractions_collect,_tlIkinames,_tlIkind_errors,_tlIkindvar,_tlIksubst,_tlIlabels_collect,_tlImethods_collect,_tlIself) =
                (tl_ (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOgenericAbstractions)
                     (_tlOgenericAbstractions_collect)
                     (_tlOghc)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOkinames)
                     (_tlOkinds)
                     (_tlOkindvar)
                     (_tlOksubst)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmodules)
                     (_tlOoptimizer)
                     (_tlOoptimizerPrelude)
                     (_tlOprekind)
                     (_tlOprelude)
                     (_tlOtoplevel)
                     (_tlOverbosity))
            -- use rule
            (_lhsOkind_errors@_) =
                _hdIkind_errors ++ _tlIkind_errors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _tlIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _tlIkinames
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _tlIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _tlIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_hdOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_hdOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_hdOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_hdOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_hdOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_hdOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_hdOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_hdOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_hdOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_hdOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_tlOgenericAbstractions_collect@_) =
                _hdIgenericAbstractions_collect
            -- copy rule (down)
            (_tlOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOkinames@_) =
                _hdIkinames
            -- copy rule (down)
            (_tlOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_tlOkindvar@_) =
                _hdIkindvar
            -- copy rule (chain)
            (_tlOksubst@_) =
                _hdIksubst
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_tlOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_tlOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_tlOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_tlOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_TypeArguments_Nil :: (T_TypeArguments)
sem_TypeArguments_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsItoplevel
      _lhsIverbosity ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (TypeArguments)
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOgenericAbstractions_collect,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- TypeIndexedBinding ------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      exportedStructures   : Set Name
      exportedTypes        : Set Name
      exportedValues       : Set Name
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures
      rawRequests_collect  : [RawRequest]
      structureTypes_collect : FMap Name LambdaType
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      depConstraints_defined : [DepConstraint]
      genericAbstractionBindings : FunctionBindings
      kind_errors          : [GHError]
      linkname             : Maybe Name
      name                 : Name
      self                 : SELF
      staticErrors         : [GHError]
      typeargument         : Maybe TypeArgument

-}
{-
   local variables for TypeIndexedBinding.DefaultCase:
      self

-}
{-
   local variables for TypeIndexedBinding.TypeIndexedBinding:
      isGenericAbstraction
      finaltypeargument
      as_dependencies_
      self

-}
-- semantic domain
type T_TypeIndexedBinding = (Set Name) ->
                            ([Request_BimapImply]) ->
                            (Maybe Name) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Strings) ->
                            (FMap Name [(Name,Name)]) ->
                            (Set Name) ->
                            (Set Name) ->
                            (Set Name) ->
                            ([Request_FunImply]) ->
                            (FMap Name Kind) ->
                            (FMap Name Kind) ->
                            (Bool) ->
                            (Bool) ->
                            (Maybe Name) ->
                            (KSubst) ->
                            (FMap Name KindIndexedType) ->
                            (FMap Name KindIndexedType) ->
                            (KSubst) ->
                            (Int) ->
                            (KSubst) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Bool) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Set Strings) ->
                            (Bool) ->
                            (Declarations) ->
                            (KSubst) ->
                            (Bool) ->
                            (PreSignatures) ->
                            (PreSignatures) ->
                            ([RawRequest]) ->
                            (Signatures) ->
                            (FMap Name LambdaType) ->
                            (Bool) ->
                            ([Request_TypeImply]) ->
                            (Int) ->
                            ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([DepConstraint]),([Request_FunImply]),(FunctionBindings),(FMap Name Kind),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(Maybe Name),(FMap Name Names),(Name),(PreSignatures),([RawRequest]),(TypeIndexedBinding),([GHError]),(FMap Name LambdaType),([Request_TypeImply]),(Maybe TypeArgument))
-- cata
sem_TypeIndexedBinding :: (TypeIndexedBinding) ->
                          (T_TypeIndexedBinding)
sem_TypeIndexedBinding ((TypeIndexedBinding_DefaultCase (_range) (_name) (_extended) (_reassignments))) =
    (sem_TypeIndexedBinding_DefaultCase ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Name (_extended))) ((sem_MaybeReassignments (_reassignments))))
sem_TypeIndexedBinding ((TypeIndexedBinding_TypeIndexedBinding (_range) (_name) (_typeargument) (_patterns) (_righthandside))) =
    (sem_TypeIndexedBinding_TypeIndexedBinding ((sem_Range (_range))) ((sem_Name (_name))) ((sem_TypeArgument (_typeargument))) ((sem_Patterns (_patterns))) ((sem_RightHandSide (_righthandside))))
sem_TypeIndexedBinding_DefaultCase :: (T_Range) ->
                                      (T_Name) ->
                                      (T_Name) ->
                                      (T_MaybeReassignments) ->
                                      (T_TypeIndexedBinding)
sem_TypeIndexedBinding_DefaultCase (range_) (name_) (extended_) (reassignments_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOdepConstraints_defined :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractionBindings :: (FunctionBindings)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOlinkname :: (Maybe Name)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (TypeIndexedBinding)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _lhsOtypeargument :: (Maybe TypeArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _extendedIconstructors_collect :: (FMap Name Names)
            _extendedIgenericAbstractions_collect :: (FMap Name Kind)
            _extendedIlabels_collect :: (FMap Name Names)
            _extendedImethods_collect :: (FMap Name Names)
            _extendedIself :: (Name)
            _extendedOclassname :: (Maybe Name)
            _extendedOconstructors_collect :: (FMap Name Names)
            _extendedOconstructors_dist :: (FMap Name Names)
            _extendedOcurrentModule :: (Strings)
            _extendedOgenericAbstractions :: (FMap Name Kind)
            _extendedOgenericAbstractions_collect :: (FMap Name Kind)
            _extendedOghc :: (Bool)
            _extendedOimportedModule :: (Bool)
            _extendedOinstancename :: (Maybe Name)
            _extendedOlabels_collect :: (FMap Name Names)
            _extendedOlabels_dist :: (FMap Name Names)
            _extendedOlocal :: (Bool)
            _extendedOmethods_collect :: (FMap Name Names)
            _extendedOmethods_dist :: (FMap Name Names)
            _extendedOmodules :: (Set Strings)
            _extendedOoptimizer :: (Bool)
            _extendedOoptimizerPrelude :: (Declarations)
            _extendedOprelude :: (Bool)
            _extendedOtoplevel :: (Bool)
            _extendedOverbosity :: (Int)
            _reassignmentsIconstructors_collect :: (FMap Name Names)
            _reassignmentsIgenericAbstractions_collect :: (FMap Name Kind)
            _reassignmentsIlabels_collect :: (FMap Name Names)
            _reassignmentsImethods_collect :: (FMap Name Names)
            _reassignmentsIself :: (MaybeReassignments)
            _reassignmentsOclassname :: (Maybe Name)
            _reassignmentsOconstructors_collect :: (FMap Name Names)
            _reassignmentsOconstructors_dist :: (FMap Name Names)
            _reassignmentsOcurrentModule :: (Strings)
            _reassignmentsOgenericAbstractions :: (FMap Name Kind)
            _reassignmentsOgenericAbstractions_collect :: (FMap Name Kind)
            _reassignmentsOghc :: (Bool)
            _reassignmentsOimportedModule :: (Bool)
            _reassignmentsOinstancename :: (Maybe Name)
            _reassignmentsOlabels_collect :: (FMap Name Names)
            _reassignmentsOlabels_dist :: (FMap Name Names)
            _reassignmentsOlocal :: (Bool)
            _reassignmentsOmethods_collect :: (FMap Name Names)
            _reassignmentsOmethods_dist :: (FMap Name Names)
            _reassignmentsOmodules :: (Set Strings)
            _reassignmentsOoptimizer :: (Bool)
            _reassignmentsOoptimizerPrelude :: (Declarations)
            _reassignmentsOprelude :: (Bool)
            _reassignmentsOtoplevel :: (Bool)
            _reassignmentsOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _extendedIconstructors_collect,_extendedIgenericAbstractions_collect,_extendedIlabels_collect,_extendedImethods_collect,_extendedIself) =
                (extended_ (_extendedOclassname)
                           (_extendedOconstructors_collect)
                           (_extendedOconstructors_dist)
                           (_extendedOcurrentModule)
                           (_extendedOgenericAbstractions)
                           (_extendedOgenericAbstractions_collect)
                           (_extendedOghc)
                           (_extendedOimportedModule)
                           (_extendedOinstancename)
                           (_extendedOlabels_collect)
                           (_extendedOlabels_dist)
                           (_extendedOlocal)
                           (_extendedOmethods_collect)
                           (_extendedOmethods_dist)
                           (_extendedOmodules)
                           (_extendedOoptimizer)
                           (_extendedOoptimizerPrelude)
                           (_extendedOprelude)
                           (_extendedOtoplevel)
                           (_extendedOverbosity))
            ( _reassignmentsIconstructors_collect,_reassignmentsIgenericAbstractions_collect,_reassignmentsIlabels_collect,_reassignmentsImethods_collect,_reassignmentsIself) =
                (reassignments_ (_reassignmentsOclassname)
                                (_reassignmentsOconstructors_collect)
                                (_reassignmentsOconstructors_dist)
                                (_reassignmentsOcurrentModule)
                                (_reassignmentsOgenericAbstractions)
                                (_reassignmentsOgenericAbstractions_collect)
                                (_reassignmentsOghc)
                                (_reassignmentsOimportedModule)
                                (_reassignmentsOinstancename)
                                (_reassignmentsOlabels_collect)
                                (_reassignmentsOlabels_dist)
                                (_reassignmentsOlocal)
                                (_reassignmentsOmethods_collect)
                                (_reassignmentsOmethods_dist)
                                (_reassignmentsOmodules)
                                (_reassignmentsOoptimizer)
                                (_reassignmentsOoptimizerPrelude)
                                (_reassignmentsOprelude)
                                (_reassignmentsOtoplevel)
                                (_reassignmentsOverbosity))
            -- "./ModuleInformation.inc.lag"(line 435, column 9)
            (_lhsOtypeargument@_) =
                Nothing
            -- "./ModuleInformation.inc.lag"(line 434, column 9)
            (_lhsOname@_) =
                _nameIself
            -- "./Signature.inc.lag"(line 387, column 10)
            (_lhsOlinkname@_) =
                Just _extendedIself
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOdepConstraints_defined@_) =
                []
            -- use rule
            (_lhsOgenericAbstractionBindings@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                TypeIndexedBinding_DefaultCase _rangeIself _nameIself _extendedIself _reassignmentsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _reassignmentsIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _reassignmentsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _reassignmentsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _reassignmentsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_extendedOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_extendedOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_extendedOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_extendedOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_extendedOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_extendedOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_extendedOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_extendedOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_extendedOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_extendedOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_extendedOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_extendedOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_extendedOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_extendedOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_extendedOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_extendedOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_extendedOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_extendedOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_extendedOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_extendedOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_reassignmentsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_reassignmentsOconstructors_collect@_) =
                _extendedIconstructors_collect
            -- copy rule (down)
            (_reassignmentsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_reassignmentsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_reassignmentsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_reassignmentsOgenericAbstractions_collect@_) =
                _extendedIgenericAbstractions_collect
            -- copy rule (down)
            (_reassignmentsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_reassignmentsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_reassignmentsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_reassignmentsOlabels_collect@_) =
                _extendedIlabels_collect
            -- copy rule (down)
            (_reassignmentsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_reassignmentsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_reassignmentsOmethods_collect@_) =
                _extendedImethods_collect
            -- copy rule (down)
            (_reassignmentsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_reassignmentsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_reassignmentsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_reassignmentsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_reassignmentsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_reassignmentsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_reassignmentsOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect
             ,_lhsObimapImps_collect
             ,_lhsOconstructors_collect
             ,_lhsOdepConstraints_collect
             ,_lhsOdepConstraints_defined
             ,_lhsOfunImps_collect
             ,_lhsOgenericAbstractionBindings
             ,_lhsOgenericAbstractions_collect
             ,_lhsOkinames
             ,_lhsOkindIndexedTypes_collect
             ,_lhsOkind_errors
             ,_lhsOkindvar
             ,_lhsOksubst
             ,_lhsOlabels_collect
             ,_lhsOlinkname
             ,_lhsOmethods_collect
             ,_lhsOname
             ,_lhsOpresignatures_collect
             ,_lhsOrawRequests_collect
             ,_lhsOself
             ,_lhsOstaticErrors
             ,_lhsOstructureTypes_collect
             ,_lhsOtypeImps_collect
             ,_lhsOtypeargument
             )
sem_TypeIndexedBinding_TypeIndexedBinding :: (T_Range) ->
                                             (T_Name) ->
                                             (T_TypeArgument) ->
                                             (T_Patterns) ->
                                             (T_RightHandSide) ->
                                             (T_TypeIndexedBinding)
sem_TypeIndexedBinding_TypeIndexedBinding (range_) (name_) (typeargument_) (patterns_) (righthandside_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOdepConstraints_defined :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractionBindings :: (FunctionBindings)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOlinkname :: (Maybe Name)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (TypeIndexedBinding)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _lhsOtypeargument :: (Maybe TypeArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIgenericAbstractions_collect :: (FMap Name Kind)
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOgenericAbstractions :: (FMap Name Kind)
            _nameOgenericAbstractions_collect :: (FMap Name Kind)
            _nameOghc :: (Bool)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmodules :: (Set Strings)
            _nameOoptimizer :: (Bool)
            _nameOoptimizerPrelude :: (Declarations)
            _nameOprelude :: (Bool)
            _nameOtoplevel :: (Bool)
            _nameOverbosity :: (Int)
            _typeargumentIconstructors_collect :: (FMap Name Names)
            _typeargumentIgenericAbstractions_collect :: (FMap Name Kind)
            _typeargumentIkinames :: (KSubst)
            _typeargumentIkind_errors :: ([GHError])
            _typeargumentIkindvar :: (Int)
            _typeargumentIksubst :: (KSubst)
            _typeargumentIlabels_collect :: (FMap Name Names)
            _typeargumentImethods_collect :: (FMap Name Names)
            _typeargumentIself :: (TypeArgument)
            _typeargumentOclassname :: (Maybe Name)
            _typeargumentOconstructors_collect :: (FMap Name Names)
            _typeargumentOconstructors_dist :: (FMap Name Names)
            _typeargumentOcurrentModule :: (Strings)
            _typeargumentOgenericAbstractions :: (FMap Name Kind)
            _typeargumentOgenericAbstractions_collect :: (FMap Name Kind)
            _typeargumentOghc :: (Bool)
            _typeargumentOimportedModule :: (Bool)
            _typeargumentOinstancename :: (Maybe Name)
            _typeargumentOkinames :: (KSubst)
            _typeargumentOkinds :: (KSubst)
            _typeargumentOkindvar :: (Int)
            _typeargumentOksubst :: (KSubst)
            _typeargumentOlabels_collect :: (FMap Name Names)
            _typeargumentOlabels_dist :: (FMap Name Names)
            _typeargumentOlocal :: (Bool)
            _typeargumentOmethods_collect :: (FMap Name Names)
            _typeargumentOmethods_dist :: (FMap Name Names)
            _typeargumentOmodules :: (Set Strings)
            _typeargumentOoptimizer :: (Bool)
            _typeargumentOoptimizerPrelude :: (Declarations)
            _typeargumentOprekind :: (KSubst)
            _typeargumentOprelude :: (Bool)
            _typeargumentOtoplevel :: (Bool)
            _typeargumentOverbosity :: (Int)
            _patternsIconstructors_collect :: (FMap Name Names)
            _patternsIgenericAbstractions_collect :: (FMap Name Kind)
            _patternsIlabels_collect :: (FMap Name Names)
            _patternsImethods_collect :: (FMap Name Names)
            _patternsIself :: (Patterns)
            _patternsOclassname :: (Maybe Name)
            _patternsOconstructors_collect :: (FMap Name Names)
            _patternsOconstructors_dist :: (FMap Name Names)
            _patternsOcurrentModule :: (Strings)
            _patternsOgenericAbstractions :: (FMap Name Kind)
            _patternsOgenericAbstractions_collect :: (FMap Name Kind)
            _patternsOghc :: (Bool)
            _patternsOimportedModule :: (Bool)
            _patternsOinstancename :: (Maybe Name)
            _patternsOlabels_collect :: (FMap Name Names)
            _patternsOlabels_dist :: (FMap Name Names)
            _patternsOlocal :: (Bool)
            _patternsOmethods_collect :: (FMap Name Names)
            _patternsOmethods_dist :: (FMap Name Names)
            _patternsOmodules :: (Set Strings)
            _patternsOoptimizer :: (Bool)
            _patternsOoptimizerPrelude :: (Declarations)
            _patternsOprelude :: (Bool)
            _patternsOtoplevel :: (Bool)
            _patternsOverbosity :: (Int)
            _righthandsideIabstractTypes_collect :: (Set Name)
            _righthandsideIbimapImps_collect :: ([Request_BimapImply])
            _righthandsideIconstructors_collect :: (FMap Name Names)
            _righthandsideIdepConstraints_collect :: ([DepConstraint])
            _righthandsideIfunImps_collect :: ([Request_FunImply])
            _righthandsideIgenericAbstractions_collect :: (FMap Name Kind)
            _righthandsideIkinames :: (KSubst)
            _righthandsideIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _righthandsideIkind_errors :: ([GHError])
            _righthandsideIkindvar :: (Int)
            _righthandsideIksubst :: (KSubst)
            _righthandsideIlabels_collect :: (FMap Name Names)
            _righthandsideImethods_collect :: (FMap Name Names)
            _righthandsideIpresignatures_collect :: (PreSignatures)
            _righthandsideIrawRequests_collect :: ([RawRequest])
            _righthandsideIself :: (RightHandSide)
            _righthandsideIstaticErrors :: ([GHError])
            _righthandsideIstructureTypes_collect :: (FMap Name LambdaType)
            _righthandsideItypeImps_collect :: ([Request_TypeImply])
            _righthandsideOabstractTypes_collect :: (Set Name)
            _righthandsideObimapImps_collect :: ([Request_BimapImply])
            _righthandsideOclassname :: (Maybe Name)
            _righthandsideOconstructors_collect :: (FMap Name Names)
            _righthandsideOconstructors_dist :: (FMap Name Names)
            _righthandsideOcurrentModule :: (Strings)
            _righthandsideOdependencies :: (FMap Name [(Name,Name)])
            _righthandsideOexportedStructures :: (Set Name)
            _righthandsideOexportedTypes :: (Set Name)
            _righthandsideOexportedValues :: (Set Name)
            _righthandsideOfunImps_collect :: ([Request_FunImply])
            _righthandsideOgenericAbstractions :: (FMap Name Kind)
            _righthandsideOgenericAbstractions_collect :: (FMap Name Kind)
            _righthandsideOghc :: (Bool)
            _righthandsideOimportedModule :: (Bool)
            _righthandsideOinstancename :: (Maybe Name)
            _righthandsideOkinames :: (KSubst)
            _righthandsideOkindIndexedTypes :: (FMap Name KindIndexedType)
            _righthandsideOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _righthandsideOkinds :: (KSubst)
            _righthandsideOkindvar :: (Int)
            _righthandsideOksubst :: (KSubst)
            _righthandsideOlabels_collect :: (FMap Name Names)
            _righthandsideOlabels_dist :: (FMap Name Names)
            _righthandsideOlocal :: (Bool)
            _righthandsideOmethods_collect :: (FMap Name Names)
            _righthandsideOmethods_dist :: (FMap Name Names)
            _righthandsideOmodules :: (Set Strings)
            _righthandsideOoptimizer :: (Bool)
            _righthandsideOoptimizerPrelude :: (Declarations)
            _righthandsideOprekind :: (KSubst)
            _righthandsideOprelude :: (Bool)
            _righthandsideOpresignatures :: (PreSignatures)
            _righthandsideOpresignatures_collect :: (PreSignatures)
            _righthandsideOrawRequests_collect :: ([RawRequest])
            _righthandsideOsignatures :: (Signatures)
            _righthandsideOstructureTypes_collect :: (FMap Name LambdaType)
            _righthandsideOtoplevel :: (Bool)
            _righthandsideOtypeImps_collect :: ([Request_TypeImply])
            _righthandsideOverbosity :: (Int)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIgenericAbstractions_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOgenericAbstractions) (_nameOgenericAbstractions_collect) (_nameOghc) (_nameOimportedModule) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOmodules) (_nameOoptimizer) (_nameOoptimizerPrelude) (_nameOprelude) (_nameOtoplevel) (_nameOverbosity))
            ( _typeargumentIconstructors_collect,_typeargumentIgenericAbstractions_collect,_typeargumentIkinames,_typeargumentIkind_errors,_typeargumentIkindvar,_typeargumentIksubst,_typeargumentIlabels_collect,_typeargumentImethods_collect,_typeargumentIself) =
                (typeargument_ (_typeargumentOclassname)
                               (_typeargumentOconstructors_collect)
                               (_typeargumentOconstructors_dist)
                               (_typeargumentOcurrentModule)
                               (_typeargumentOgenericAbstractions)
                               (_typeargumentOgenericAbstractions_collect)
                               (_typeargumentOghc)
                               (_typeargumentOimportedModule)
                               (_typeargumentOinstancename)
                               (_typeargumentOkinames)
                               (_typeargumentOkinds)
                               (_typeargumentOkindvar)
                               (_typeargumentOksubst)
                               (_typeargumentOlabels_collect)
                               (_typeargumentOlabels_dist)
                               (_typeargumentOlocal)
                               (_typeargumentOmethods_collect)
                               (_typeargumentOmethods_dist)
                               (_typeargumentOmodules)
                               (_typeargumentOoptimizer)
                               (_typeargumentOoptimizerPrelude)
                               (_typeargumentOprekind)
                               (_typeargumentOprelude)
                               (_typeargumentOtoplevel)
                               (_typeargumentOverbosity))
            ( _patternsIconstructors_collect,_patternsIgenericAbstractions_collect,_patternsIlabels_collect,_patternsImethods_collect,_patternsIself) =
                (patterns_ (_patternsOclassname)
                           (_patternsOconstructors_collect)
                           (_patternsOconstructors_dist)
                           (_patternsOcurrentModule)
                           (_patternsOgenericAbstractions)
                           (_patternsOgenericAbstractions_collect)
                           (_patternsOghc)
                           (_patternsOimportedModule)
                           (_patternsOinstancename)
                           (_patternsOlabels_collect)
                           (_patternsOlabels_dist)
                           (_patternsOlocal)
                           (_patternsOmethods_collect)
                           (_patternsOmethods_dist)
                           (_patternsOmodules)
                           (_patternsOoptimizer)
                           (_patternsOoptimizerPrelude)
                           (_patternsOprelude)
                           (_patternsOtoplevel)
                           (_patternsOverbosity))
            ( _righthandsideIabstractTypes_collect
             ,_righthandsideIbimapImps_collect
             ,_righthandsideIconstructors_collect
             ,_righthandsideIdepConstraints_collect
             ,_righthandsideIfunImps_collect
             ,_righthandsideIgenericAbstractions_collect
             ,_righthandsideIkinames
             ,_righthandsideIkindIndexedTypes_collect
             ,_righthandsideIkind_errors
             ,_righthandsideIkindvar
             ,_righthandsideIksubst
             ,_righthandsideIlabels_collect
             ,_righthandsideImethods_collect
             ,_righthandsideIpresignatures_collect
             ,_righthandsideIrawRequests_collect
             ,_righthandsideIself
             ,_righthandsideIstaticErrors
             ,_righthandsideIstructureTypes_collect
             ,_righthandsideItypeImps_collect
             ) =
                (righthandside_ (_righthandsideOabstractTypes_collect)
                                (_righthandsideObimapImps_collect)
                                (_righthandsideOclassname)
                                (_righthandsideOconstructors_collect)
                                (_righthandsideOconstructors_dist)
                                (_righthandsideOcurrentModule)
                                (_righthandsideOdependencies)
                                (_righthandsideOexportedStructures)
                                (_righthandsideOexportedTypes)
                                (_righthandsideOexportedValues)
                                (_righthandsideOfunImps_collect)
                                (_righthandsideOgenericAbstractions)
                                (_righthandsideOgenericAbstractions_collect)
                                (_righthandsideOghc)
                                (_righthandsideOimportedModule)
                                (_righthandsideOinstancename)
                                (_righthandsideOkinames)
                                (_righthandsideOkindIndexedTypes)
                                (_righthandsideOkindIndexedTypes_collect)
                                (_righthandsideOkinds)
                                (_righthandsideOkindvar)
                                (_righthandsideOksubst)
                                (_righthandsideOlabels_collect)
                                (_righthandsideOlabels_dist)
                                (_righthandsideOlocal)
                                (_righthandsideOmethods_collect)
                                (_righthandsideOmethods_dist)
                                (_righthandsideOmodules)
                                (_righthandsideOoptimizer)
                                (_righthandsideOoptimizerPrelude)
                                (_righthandsideOprekind)
                                (_righthandsideOprelude)
                                (_righthandsideOpresignatures)
                                (_righthandsideOpresignatures_collect)
                                (_righthandsideOrawRequests_collect)
                                (_righthandsideOsignatures)
                                (_righthandsideOstructureTypes_collect)
                                (_righthandsideOtoplevel)
                                (_righthandsideOtypeImps_collect)
                                (_righthandsideOverbosity))
            -- "./ModuleInformation.inc.lag"(line 172, column 8)
            (_righthandsideOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 171, column 8)
            (_patternsOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 170, column 8)
            (_typeargumentOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 432, column 9)
            (_lhsOtypeargument@_) =
                Just _typeargumentIself
            -- "./ModuleInformation.inc.lag"(line 431, column 9)
            (_lhsOname@_) =
                _nameIself
            -- "./GenericAbstraction.inc.lag"(line 140, column 9)
            (_lhsOgenericAbstractionBindings@_) =
                [ funBinding
                    _nameIself
                    ( [ varP n
                      | let var = case _typeargumentIself of
                                    TypeArgument_Variable _ x  ->  x
                                    _                          ->
                                       internalError $ "GenericAbstraction.var"
                      , let deps = applyFMM  _lhsIdependencies
                                             (const [])
                                             _nameIself
                      , (_,fun) <- deps
                      , let n = specName fun var
                      ]
                    ++ _patternsIself
                    )
                    (ER.replaceRightHandSide
                       _lhsIdependencies
                       emptyFM
                       _lhsIgenericAbstractions
                       _righthandsideIself
                    )
                ]
            -- "./Request.inc.lag"(line 326, column 9)
            (_lhsOdepConstraints_defined@_) =
                case _typeargumentIself of
                  TypeArgument_DependencyStyle _ v _ _ | isVar v ->
                    [DepConstraint (_rangeIself,_nameIself,v)]
                  TypeArgument_Variable _ v ->
                    [DepConstraint (_rangeIself,_nameIself,v)]
                  _ -> []
            -- "./Request.inc.lag"(line 316, column 9)
            (_lhsOdepConstraints_collect@_) =
                case _finaltypeargument of
                  TypeArgument_DependencyStyle _ _ _ vs ->
                    filter
                      (\(DepConstraint (_,n,v)) ->
                          not (n `elem` _as_dependencies_ && v `elem` vs)
                      )
                      _righthandsideIdepConstraints_collect
                  _ -> []
            -- "./Request.inc.lag"(line 314, column 9)
            (_isGenericAbstraction@_) =
                isJust (find _lhsIgenericAbstractions _nameIself)
            -- "./Request.inc.lag"(line 308, column 9)
            (_finaltypeargument@_) =
                case _typeargumentIself of
                  TypeArgument_Variable r n
                    | _isGenericAbstraction && _lhsItoplevel ->
                        TypeArgument_DependencyStyle r absName MaybeName_Nothing [n]
                  _ ->  _typeargumentIself
            -- "./Request.inc.lag"(line 301, column 9)
            (_as_dependencies_@_) =
                map snd $
                applyFMM
                  _lhsIdependencies
                  (\n -> [(n,n)])
                  _nameIself
            -- use rule
            (_lhsOkind_errors@_) =
                _typeargumentIkind_errors ++ _righthandsideIkind_errors
            -- use rule
            (_lhsOlinkname@_) =
                Nothing
            -- use rule
            (_lhsOstaticErrors@_) =
                _righthandsideIstaticErrors
            -- self rule
            (_self@_) =
                TypeIndexedBinding_TypeIndexedBinding _rangeIself _nameIself _typeargumentIself _patternsIself _righthandsideIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _righthandsideIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _righthandsideIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _righthandsideIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _righthandsideIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _righthandsideIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _righthandsideIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _righthandsideIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _righthandsideIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _righthandsideIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _righthandsideIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _righthandsideImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _righthandsideIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _righthandsideIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _righthandsideIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _righthandsideItypeImps_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_nameOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_nameOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_nameOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_nameOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_nameOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_typeargumentOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeargumentOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_typeargumentOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeargumentOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeargumentOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_typeargumentOgenericAbstractions_collect@_) =
                _nameIgenericAbstractions_collect
            -- copy rule (down)
            (_typeargumentOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_typeargumentOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeargumentOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typeargumentOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_typeargumentOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_typeargumentOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_typeargumentOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_typeargumentOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_typeargumentOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeargumentOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeargumentOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_typeargumentOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typeargumentOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_typeargumentOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_typeargumentOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_typeargumentOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_typeargumentOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_typeargumentOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_patternsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_patternsOconstructors_collect@_) =
                _typeargumentIconstructors_collect
            -- copy rule (down)
            (_patternsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternsOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_patternsOgenericAbstractions_collect@_) =
                _typeargumentIgenericAbstractions_collect
            -- copy rule (down)
            (_patternsOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_patternsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_patternsOlabels_collect@_) =
                _typeargumentIlabels_collect
            -- copy rule (down)
            (_patternsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_patternsOmethods_collect@_) =
                _typeargumentImethods_collect
            -- copy rule (down)
            (_patternsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternsOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_patternsOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_patternsOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_patternsOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_patternsOverbosity@_) =
                _lhsIverbosity
            -- copy rule (down)
            (_righthandsideOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_righthandsideObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_righthandsideOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_righthandsideOconstructors_collect@_) =
                _patternsIconstructors_collect
            -- copy rule (down)
            (_righthandsideOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_righthandsideOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_righthandsideOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_righthandsideOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_righthandsideOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_righthandsideOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_righthandsideOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_righthandsideOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_righthandsideOgenericAbstractions_collect@_) =
                _patternsIgenericAbstractions_collect
            -- copy rule (down)
            (_righthandsideOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_righthandsideOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_righthandsideOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_righthandsideOkinames@_) =
                _typeargumentIkinames
            -- copy rule (down)
            (_righthandsideOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_righthandsideOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_righthandsideOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_righthandsideOkindvar@_) =
                _typeargumentIkindvar
            -- copy rule (chain)
            (_righthandsideOksubst@_) =
                _typeargumentIksubst
            -- copy rule (chain)
            (_righthandsideOlabels_collect@_) =
                _patternsIlabels_collect
            -- copy rule (down)
            (_righthandsideOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_righthandsideOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_righthandsideOmethods_collect@_) =
                _patternsImethods_collect
            -- copy rule (down)
            (_righthandsideOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_righthandsideOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_righthandsideOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_righthandsideOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_righthandsideOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_righthandsideOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_righthandsideOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_righthandsideOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_righthandsideOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_righthandsideOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_righthandsideOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_righthandsideOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_righthandsideOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect
             ,_lhsObimapImps_collect
             ,_lhsOconstructors_collect
             ,_lhsOdepConstraints_collect
             ,_lhsOdepConstraints_defined
             ,_lhsOfunImps_collect
             ,_lhsOgenericAbstractionBindings
             ,_lhsOgenericAbstractions_collect
             ,_lhsOkinames
             ,_lhsOkindIndexedTypes_collect
             ,_lhsOkind_errors
             ,_lhsOkindvar
             ,_lhsOksubst
             ,_lhsOlabels_collect
             ,_lhsOlinkname
             ,_lhsOmethods_collect
             ,_lhsOname
             ,_lhsOpresignatures_collect
             ,_lhsOrawRequests_collect
             ,_lhsOself
             ,_lhsOstaticErrors
             ,_lhsOstructureTypes_collect
             ,_lhsOtypeImps_collect
             ,_lhsOtypeargument
             )
-- TypeIndexedBindings -----------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      exportedStructures   : Set Name
      exportedTypes        : Set Name
      exportedValues       : Set Name
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kindIndexedTypes     : FMap Name KindIndexedType
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindIndexedTypes_collect : FMap Name KindIndexedType
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures
      rawRequests_collect  : [RawRequest]
      structureTypes_collect : FMap Name LambdaType
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      depConstraints_defined : [DepConstraint]
      genericAbstractionBindings : FunctionBindings
      kind_errors          : [GHError]
      linkname             : Maybe Name
      name                 : Name
      self                 : SELF
      staticErrors         : [GHError]
      typeargument         : Maybe TypeArgument

-}
{-
   local variables for TypeIndexedBindings.Cons:
      self

-}
{-
   local variables for TypeIndexedBindings.Nil:
      self

-}
-- semantic domain
type T_TypeIndexedBindings = (Set Name) ->
                             ([Request_BimapImply]) ->
                             (Maybe Name) ->
                             (FMap Name Names) ->
                             (FMap Name Names) ->
                             (Strings) ->
                             (FMap Name [(Name,Name)]) ->
                             (Set Name) ->
                             (Set Name) ->
                             (Set Name) ->
                             ([Request_FunImply]) ->
                             (FMap Name Kind) ->
                             (FMap Name Kind) ->
                             (Bool) ->
                             (Bool) ->
                             (Maybe Name) ->
                             (KSubst) ->
                             (FMap Name KindIndexedType) ->
                             (FMap Name KindIndexedType) ->
                             (KSubst) ->
                             (Int) ->
                             (KSubst) ->
                             (FMap Name Names) ->
                             (FMap Name Names) ->
                             (Bool) ->
                             (FMap Name Names) ->
                             (FMap Name Names) ->
                             (Set Strings) ->
                             (Bool) ->
                             (Declarations) ->
                             (KSubst) ->
                             (Bool) ->
                             (PreSignatures) ->
                             (PreSignatures) ->
                             ([RawRequest]) ->
                             (Signatures) ->
                             (FMap Name LambdaType) ->
                             (Bool) ->
                             ([Request_TypeImply]) ->
                             (Int) ->
                             ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([DepConstraint]),([Request_FunImply]),(FunctionBindings),(FMap Name Kind),(KSubst),(FMap Name KindIndexedType),([GHError]),(Int),(KSubst),(FMap Name Names),(Maybe Name),(FMap Name Names),(Name),(PreSignatures),([RawRequest]),(TypeIndexedBindings),([GHError]),(FMap Name LambdaType),([Request_TypeImply]),(Maybe TypeArgument))
-- cata
sem_TypeIndexedBindings :: (TypeIndexedBindings) ->
                           (T_TypeIndexedBindings)
sem_TypeIndexedBindings (list) =
    (foldr (sem_TypeIndexedBindings_Cons) (sem_TypeIndexedBindings_Nil) ((map sem_TypeIndexedBinding list)))
sem_TypeIndexedBindings_Cons :: (T_TypeIndexedBinding) ->
                                (T_TypeIndexedBindings) ->
                                (T_TypeIndexedBindings)
sem_TypeIndexedBindings_Cons (hd_) (tl_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOdepConstraints_defined :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractionBindings :: (FunctionBindings)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOlinkname :: (Maybe Name)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (TypeIndexedBindings)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _lhsOtypeargument :: (Maybe TypeArgument)
            _hdIabstractTypes_collect :: (Set Name)
            _hdIbimapImps_collect :: ([Request_BimapImply])
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdepConstraints_collect :: ([DepConstraint])
            _hdIdepConstraints_defined :: ([DepConstraint])
            _hdIfunImps_collect :: ([Request_FunImply])
            _hdIgenericAbstractionBindings :: (FunctionBindings)
            _hdIgenericAbstractions_collect :: (FMap Name Kind)
            _hdIkinames :: (KSubst)
            _hdIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _hdIkind_errors :: ([GHError])
            _hdIkindvar :: (Int)
            _hdIksubst :: (KSubst)
            _hdIlabels_collect :: (FMap Name Names)
            _hdIlinkname :: (Maybe Name)
            _hdImethods_collect :: (FMap Name Names)
            _hdIname :: (Name)
            _hdIpresignatures_collect :: (PreSignatures)
            _hdIrawRequests_collect :: ([RawRequest])
            _hdIself :: (TypeIndexedBinding)
            _hdIstaticErrors :: ([GHError])
            _hdIstructureTypes_collect :: (FMap Name LambdaType)
            _hdItypeImps_collect :: ([Request_TypeImply])
            _hdItypeargument :: (Maybe TypeArgument)
            _hdOabstractTypes_collect :: (Set Name)
            _hdObimapImps_collect :: ([Request_BimapImply])
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies :: (FMap Name [(Name,Name)])
            _hdOexportedStructures :: (Set Name)
            _hdOexportedTypes :: (Set Name)
            _hdOexportedValues :: (Set Name)
            _hdOfunImps_collect :: ([Request_FunImply])
            _hdOgenericAbstractions :: (FMap Name Kind)
            _hdOgenericAbstractions_collect :: (FMap Name Kind)
            _hdOghc :: (Bool)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOkinames :: (KSubst)
            _hdOkindIndexedTypes :: (FMap Name KindIndexedType)
            _hdOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _hdOkinds :: (KSubst)
            _hdOkindvar :: (Int)
            _hdOksubst :: (KSubst)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmodules :: (Set Strings)
            _hdOoptimizer :: (Bool)
            _hdOoptimizerPrelude :: (Declarations)
            _hdOprekind :: (KSubst)
            _hdOprelude :: (Bool)
            _hdOpresignatures :: (PreSignatures)
            _hdOpresignatures_collect :: (PreSignatures)
            _hdOrawRequests_collect :: ([RawRequest])
            _hdOsignatures :: (Signatures)
            _hdOstructureTypes_collect :: (FMap Name LambdaType)
            _hdOtoplevel :: (Bool)
            _hdOtypeImps_collect :: ([Request_TypeImply])
            _hdOverbosity :: (Int)
            _tlIabstractTypes_collect :: (Set Name)
            _tlIbimapImps_collect :: ([Request_BimapImply])
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdepConstraints_collect :: ([DepConstraint])
            _tlIdepConstraints_defined :: ([DepConstraint])
            _tlIfunImps_collect :: ([Request_FunImply])
            _tlIgenericAbstractionBindings :: (FunctionBindings)
            _tlIgenericAbstractions_collect :: (FMap Name Kind)
            _tlIkinames :: (KSubst)
            _tlIkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _tlIkind_errors :: ([GHError])
            _tlIkindvar :: (Int)
            _tlIksubst :: (KSubst)
            _tlIlabels_collect :: (FMap Name Names)
            _tlIlinkname :: (Maybe Name)
            _tlImethods_collect :: (FMap Name Names)
            _tlIname :: (Name)
            _tlIpresignatures_collect :: (PreSignatures)
            _tlIrawRequests_collect :: ([RawRequest])
            _tlIself :: (TypeIndexedBindings)
            _tlIstaticErrors :: ([GHError])
            _tlIstructureTypes_collect :: (FMap Name LambdaType)
            _tlItypeImps_collect :: ([Request_TypeImply])
            _tlItypeargument :: (Maybe TypeArgument)
            _tlOabstractTypes_collect :: (Set Name)
            _tlObimapImps_collect :: ([Request_BimapImply])
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies :: (FMap Name [(Name,Name)])
            _tlOexportedStructures :: (Set Name)
            _tlOexportedTypes :: (Set Name)
            _tlOexportedValues :: (Set Name)
            _tlOfunImps_collect :: ([Request_FunImply])
            _tlOgenericAbstractions :: (FMap Name Kind)
            _tlOgenericAbstractions_collect :: (FMap Name Kind)
            _tlOghc :: (Bool)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOkinames :: (KSubst)
            _tlOkindIndexedTypes :: (FMap Name KindIndexedType)
            _tlOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _tlOkinds :: (KSubst)
            _tlOkindvar :: (Int)
            _tlOksubst :: (KSubst)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmodules :: (Set Strings)
            _tlOoptimizer :: (Bool)
            _tlOoptimizerPrelude :: (Declarations)
            _tlOprekind :: (KSubst)
            _tlOprelude :: (Bool)
            _tlOpresignatures :: (PreSignatures)
            _tlOpresignatures_collect :: (PreSignatures)
            _tlOrawRequests_collect :: ([RawRequest])
            _tlOsignatures :: (Signatures)
            _tlOstructureTypes_collect :: (FMap Name LambdaType)
            _tlOtoplevel :: (Bool)
            _tlOtypeImps_collect :: ([Request_TypeImply])
            _tlOverbosity :: (Int)
            ( _hdIabstractTypes_collect
             ,_hdIbimapImps_collect
             ,_hdIconstructors_collect
             ,_hdIdepConstraints_collect
             ,_hdIdepConstraints_defined
             ,_hdIfunImps_collect
             ,_hdIgenericAbstractionBindings
             ,_hdIgenericAbstractions_collect
             ,_hdIkinames
             ,_hdIkindIndexedTypes_collect
             ,_hdIkind_errors
             ,_hdIkindvar
             ,_hdIksubst
             ,_hdIlabels_collect
             ,_hdIlinkname
             ,_hdImethods_collect
             ,_hdIname
             ,_hdIpresignatures_collect
             ,_hdIrawRequests_collect
             ,_hdIself
             ,_hdIstaticErrors
             ,_hdIstructureTypes_collect
             ,_hdItypeImps_collect
             ,_hdItypeargument
             ) =
                (hd_ (_hdOabstractTypes_collect)
                     (_hdObimapImps_collect)
                     (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOdependencies)
                     (_hdOexportedStructures)
                     (_hdOexportedTypes)
                     (_hdOexportedValues)
                     (_hdOfunImps_collect)
                     (_hdOgenericAbstractions)
                     (_hdOgenericAbstractions_collect)
                     (_hdOghc)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOkinames)
                     (_hdOkindIndexedTypes)
                     (_hdOkindIndexedTypes_collect)
                     (_hdOkinds)
                     (_hdOkindvar)
                     (_hdOksubst)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmodules)
                     (_hdOoptimizer)
                     (_hdOoptimizerPrelude)
                     (_hdOprekind)
                     (_hdOprelude)
                     (_hdOpresignatures)
                     (_hdOpresignatures_collect)
                     (_hdOrawRequests_collect)
                     (_hdOsignatures)
                     (_hdOstructureTypes_collect)
                     (_hdOtoplevel)
                     (_hdOtypeImps_collect)
                     (_hdOverbosity))
            ( _tlIabstractTypes_collect
             ,_tlIbimapImps_collect
             ,_tlIconstructors_collect
             ,_tlIdepConstraints_collect
             ,_tlIdepConstraints_defined
             ,_tlIfunImps_collect
             ,_tlIgenericAbstractionBindings
             ,_tlIgenericAbstractions_collect
             ,_tlIkinames
             ,_tlIkindIndexedTypes_collect
             ,_tlIkind_errors
             ,_tlIkindvar
             ,_tlIksubst
             ,_tlIlabels_collect
             ,_tlIlinkname
             ,_tlImethods_collect
             ,_tlIname
             ,_tlIpresignatures_collect
             ,_tlIrawRequests_collect
             ,_tlIself
             ,_tlIstaticErrors
             ,_tlIstructureTypes_collect
             ,_tlItypeImps_collect
             ,_tlItypeargument
             ) =
                (tl_ (_tlOabstractTypes_collect)
                     (_tlObimapImps_collect)
                     (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOdependencies)
                     (_tlOexportedStructures)
                     (_tlOexportedTypes)
                     (_tlOexportedValues)
                     (_tlOfunImps_collect)
                     (_tlOgenericAbstractions)
                     (_tlOgenericAbstractions_collect)
                     (_tlOghc)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOkinames)
                     (_tlOkindIndexedTypes)
                     (_tlOkindIndexedTypes_collect)
                     (_tlOkinds)
                     (_tlOkindvar)
                     (_tlOksubst)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmodules)
                     (_tlOoptimizer)
                     (_tlOoptimizerPrelude)
                     (_tlOprekind)
                     (_tlOprelude)
                     (_tlOpresignatures)
                     (_tlOpresignatures_collect)
                     (_tlOrawRequests_collect)
                     (_tlOsignatures)
                     (_tlOstructureTypes_collect)
                     (_tlOtoplevel)
                     (_tlOtypeImps_collect)
                     (_tlOverbosity))
            -- "./ModuleInformation.inc.lag"(line 422, column 9)
            (_lhsOtypeargument@_) =
                _hdItypeargument
            -- "./ModuleInformation.inc.lag"(line 421, column 9)
            (_lhsOname@_) =
                _hdIname
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _hdIdepConstraints_collect ++ _tlIdepConstraints_collect
            -- use rule
            (_lhsOdepConstraints_defined@_) =
                _hdIdepConstraints_defined ++ _tlIdepConstraints_defined
            -- use rule
            (_lhsOgenericAbstractionBindings@_) =
                _hdIgenericAbstractionBindings ++ _tlIgenericAbstractionBindings
            -- use rule
            (_lhsOkind_errors@_) =
                _hdIkind_errors ++ _tlIkind_errors
            -- use rule
            (_lhsOlinkname@_) =
                _hdIlinkname `const` _tlIlinkname
            -- use rule
            (_lhsOstaticErrors@_) =
                _hdIstaticErrors ++ _tlIstaticErrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _tlIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _tlIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _tlIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _tlIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _tlIkinames
            -- copy rule (up)
            (_lhsOkindIndexedTypes_collect@_) =
                _tlIkindIndexedTypes_collect
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _tlIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _tlIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _tlIpresignatures_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _tlIrawRequests_collect
            -- copy rule (up)
            (_lhsOstructureTypes_collect@_) =
                _tlIstructureTypes_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _tlItypeImps_collect
            -- copy rule (down)
            (_hdOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_hdObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_hdOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_hdOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_hdOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (down)
            (_hdOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_hdOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_hdOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_hdOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_hdOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (down)
            (_hdOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (down)
            (_hdOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_hdOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_hdOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_hdOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_hdOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_hdOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_hdOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_hdOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_hdOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_hdOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_hdOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_hdOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_hdOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_hdOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_tlOabstractTypes_collect@_) =
                _hdIabstractTypes_collect
            -- copy rule (chain)
            (_tlObimapImps_collect@_) =
                _hdIbimapImps_collect
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_tlOexportedStructures@_) =
                _lhsIexportedStructures
            -- copy rule (down)
            (_tlOexportedTypes@_) =
                _lhsIexportedTypes
            -- copy rule (down)
            (_tlOexportedValues@_) =
                _lhsIexportedValues
            -- copy rule (chain)
            (_tlOfunImps_collect@_) =
                _hdIfunImps_collect
            -- copy rule (down)
            (_tlOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_tlOgenericAbstractions_collect@_) =
                _hdIgenericAbstractions_collect
            -- copy rule (down)
            (_tlOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOkinames@_) =
                _hdIkinames
            -- copy rule (down)
            (_tlOkindIndexedTypes@_) =
                _lhsIkindIndexedTypes
            -- copy rule (chain)
            (_tlOkindIndexedTypes_collect@_) =
                _hdIkindIndexedTypes_collect
            -- copy rule (down)
            (_tlOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_tlOkindvar@_) =
                _hdIkindvar
            -- copy rule (chain)
            (_tlOksubst@_) =
                _hdIksubst
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_tlOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_tlOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_tlOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_tlOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_tlOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_tlOpresignatures_collect@_) =
                _hdIpresignatures_collect
            -- copy rule (chain)
            (_tlOrawRequests_collect@_) =
                _hdIrawRequests_collect
            -- copy rule (down)
            (_tlOsignatures@_) =
                _lhsIsignatures
            -- copy rule (chain)
            (_tlOstructureTypes_collect@_) =
                _hdIstructureTypes_collect
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_tlOtypeImps_collect@_) =
                _hdItypeImps_collect
            -- copy rule (down)
            (_tlOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect
             ,_lhsObimapImps_collect
             ,_lhsOconstructors_collect
             ,_lhsOdepConstraints_collect
             ,_lhsOdepConstraints_defined
             ,_lhsOfunImps_collect
             ,_lhsOgenericAbstractionBindings
             ,_lhsOgenericAbstractions_collect
             ,_lhsOkinames
             ,_lhsOkindIndexedTypes_collect
             ,_lhsOkind_errors
             ,_lhsOkindvar
             ,_lhsOksubst
             ,_lhsOlabels_collect
             ,_lhsOlinkname
             ,_lhsOmethods_collect
             ,_lhsOname
             ,_lhsOpresignatures_collect
             ,_lhsOrawRequests_collect
             ,_lhsOself
             ,_lhsOstaticErrors
             ,_lhsOstructureTypes_collect
             ,_lhsOtypeImps_collect
             ,_lhsOtypeargument
             )
sem_TypeIndexedBindings_Nil :: (T_TypeIndexedBindings)
sem_TypeIndexedBindings_Nil  =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIexportedStructures
      _lhsIexportedTypes
      _lhsIexportedValues
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkindIndexedTypes
      _lhsIkindIndexedTypes_collect
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIrawRequests_collect
      _lhsIsignatures
      _lhsIstructureTypes_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOdepConstraints_defined :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractionBindings :: (FunctionBindings)
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOkinames :: (KSubst)
            _lhsOkindIndexedTypes_collect :: (FMap Name KindIndexedType)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOlinkname :: (Maybe Name)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (TypeIndexedBindings)
            _lhsOstaticErrors :: ([GHError])
            _lhsOstructureTypes_collect :: (FMap Name LambdaType)
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _lhsOtypeargument :: (Maybe TypeArgument)
            -- "./ModuleInformation.inc.lag"(line 426, column 9)
            (_lhsOtypeargument@_) =
                internalError $
                  "ModuleInformation.TypeIndexedBindings.Nil.lhs.typeargument: no bindings"
            -- "./ModuleInformation.inc.lag"(line 424, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.TypeIndexedBindings.Nil.lhs.name: no bindings"
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOdepConstraints_defined@_) =
                []
            -- use rule
            (_lhsOgenericAbstractionBindings@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOlinkname@_) =
                Nothing
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindIndexedTypes_collect@_) =
                _lhsIkindIndexedTypes_collect
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOstructureTypes_collect@_) =
                _lhsIstructureTypes_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
        in  ( _lhsOabstractTypes_collect
             ,_lhsObimapImps_collect
             ,_lhsOconstructors_collect
             ,_lhsOdepConstraints_collect
             ,_lhsOdepConstraints_defined
             ,_lhsOfunImps_collect
             ,_lhsOgenericAbstractionBindings
             ,_lhsOgenericAbstractions_collect
             ,_lhsOkinames
             ,_lhsOkindIndexedTypes_collect
             ,_lhsOkind_errors
             ,_lhsOkindvar
             ,_lhsOksubst
             ,_lhsOlabels_collect
             ,_lhsOlinkname
             ,_lhsOmethods_collect
             ,_lhsOname
             ,_lhsOpresignatures_collect
             ,_lhsOrawRequests_collect
             ,_lhsOself
             ,_lhsOstaticErrors
             ,_lhsOstructureTypes_collect
             ,_lhsOtypeImps_collect
             ,_lhsOtypeargument
             )
-- Types -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      dependencies         : FMap Name [(Name,Name)]
      genericAbstractions  : FMap Name Kind
      ghc                  : Bool
      importedModule       : Bool
      instancename         : Maybe Name
      kinds                : KSubst
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      modules              : Set Strings
      optimizer            : Bool
      optimizerPrelude     : Declarations
      prekind              : KSubst
      prelude              : Bool
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstractTypes_collect : Set Name
      bimapImps_collect    : [Request_BimapImply]
      constructors_collect : FMap Name Names
      funImps_collect      : [Request_FunImply]
      genericAbstractions_collect : FMap Name Kind
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      rawRequests_collect  : [RawRequest]
      typeImps_collect     : [Request_TypeImply]

   synthesised attributes:
      depConstraints_collect : [DepConstraint]
      inferkind            : [Kind]
      kind_errors          : [GHError]
      self                 : SELF
      staticErrors         : [GHError]

-}
{-
   local variables for Types.Cons:
      self

-}
{-
   local variables for Types.Nil:
      self

-}
-- semantic domain
type T_Types = (Set Name) ->
               ([Request_BimapImply]) ->
               (Maybe Name) ->
               (FMap Name Names) ->
               (FMap Name Names) ->
               (Strings) ->
               (FMap Name [(Name,Name)]) ->
               ([Request_FunImply]) ->
               (FMap Name Kind) ->
               (FMap Name Kind) ->
               (Bool) ->
               (Bool) ->
               (Maybe Name) ->
               (KSubst) ->
               (KSubst) ->
               (Int) ->
               (KSubst) ->
               (FMap Name Names) ->
               (FMap Name Names) ->
               (Bool) ->
               (FMap Name Names) ->
               (FMap Name Names) ->
               (Set Strings) ->
               (Bool) ->
               (Declarations) ->
               (KSubst) ->
               (Bool) ->
               ([RawRequest]) ->
               (Bool) ->
               ([Request_TypeImply]) ->
               (Int) ->
               ( (Set Name),([Request_BimapImply]),(FMap Name Names),([DepConstraint]),([Request_FunImply]),(FMap Name Kind),([Kind]),(KSubst),([GHError]),(Int),(KSubst),(FMap Name Names),(FMap Name Names),([RawRequest]),(Types),([GHError]),([Request_TypeImply]))
-- cata
sem_Types :: (Types) ->
             (T_Types)
sem_Types (list) =
    (foldr (sem_Types_Cons) (sem_Types_Nil) ((map sem_Type list)))
sem_Types_Cons :: (T_Type) ->
                  (T_Types) ->
                  (T_Types)
sem_Types_Cons (hd_) (tl_) =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOinferkind :: ([Kind])
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Types)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            _hdIabstractTypes_collect :: (Set Name)
            _hdIbimapImps_collect :: ([Request_BimapImply])
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdepConstraints_collect :: ([DepConstraint])
            _hdIfunImps_collect :: ([Request_FunImply])
            _hdIgenericAbstractions_collect :: (FMap Name Kind)
            _hdIinferkind :: (Kind)
            _hdIkinames :: (KSubst)
            _hdIkind_errors :: ([GHError])
            _hdIkindvar :: (Int)
            _hdIksubst :: (KSubst)
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIrawRequests_collect :: ([RawRequest])
            _hdIself :: (Type)
            _hdIstaticErrors :: ([GHError])
            _hdItypeImps_collect :: ([Request_TypeImply])
            _hdOabstractTypes_collect :: (Set Name)
            _hdObimapImps_collect :: ([Request_BimapImply])
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies :: (FMap Name [(Name,Name)])
            _hdOfunImps_collect :: ([Request_FunImply])
            _hdOgenericAbstractions :: (FMap Name Kind)
            _hdOgenericAbstractions_collect :: (FMap Name Kind)
            _hdOghc :: (Bool)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOkinames :: (KSubst)
            _hdOkinds :: (KSubst)
            _hdOkindvar :: (Int)
            _hdOksubst :: (KSubst)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmodules :: (Set Strings)
            _hdOoptimizer :: (Bool)
            _hdOoptimizerPrelude :: (Declarations)
            _hdOprekind :: (KSubst)
            _hdOprelude :: (Bool)
            _hdOrawRequests_collect :: ([RawRequest])
            _hdOtoplevel :: (Bool)
            _hdOtypeImps_collect :: ([Request_TypeImply])
            _hdOverbosity :: (Int)
            _tlIabstractTypes_collect :: (Set Name)
            _tlIbimapImps_collect :: ([Request_BimapImply])
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdepConstraints_collect :: ([DepConstraint])
            _tlIfunImps_collect :: ([Request_FunImply])
            _tlIgenericAbstractions_collect :: (FMap Name Kind)
            _tlIinferkind :: ([Kind])
            _tlIkinames :: (KSubst)
            _tlIkind_errors :: ([GHError])
            _tlIkindvar :: (Int)
            _tlIksubst :: (KSubst)
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIrawRequests_collect :: ([RawRequest])
            _tlIself :: (Types)
            _tlIstaticErrors :: ([GHError])
            _tlItypeImps_collect :: ([Request_TypeImply])
            _tlOabstractTypes_collect :: (Set Name)
            _tlObimapImps_collect :: ([Request_BimapImply])
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies :: (FMap Name [(Name,Name)])
            _tlOfunImps_collect :: ([Request_FunImply])
            _tlOgenericAbstractions :: (FMap Name Kind)
            _tlOgenericAbstractions_collect :: (FMap Name Kind)
            _tlOghc :: (Bool)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOkinames :: (KSubst)
            _tlOkinds :: (KSubst)
            _tlOkindvar :: (Int)
            _tlOksubst :: (KSubst)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmodules :: (Set Strings)
            _tlOoptimizer :: (Bool)
            _tlOoptimizerPrelude :: (Declarations)
            _tlOprekind :: (KSubst)
            _tlOprelude :: (Bool)
            _tlOrawRequests_collect :: ([RawRequest])
            _tlOtoplevel :: (Bool)
            _tlOtypeImps_collect :: ([Request_TypeImply])
            _tlOverbosity :: (Int)
            ( _hdIabstractTypes_collect,_hdIbimapImps_collect,_hdIconstructors_collect,_hdIdepConstraints_collect,_hdIfunImps_collect,_hdIgenericAbstractions_collect,_hdIinferkind,_hdIkinames,_hdIkind_errors,_hdIkindvar,_hdIksubst,_hdIlabels_collect,_hdImethods_collect,_hdIrawRequests_collect,_hdIself,_hdIstaticErrors,_hdItypeImps_collect) =
                (hd_ (_hdOabstractTypes_collect)
                     (_hdObimapImps_collect)
                     (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOdependencies)
                     (_hdOfunImps_collect)
                     (_hdOgenericAbstractions)
                     (_hdOgenericAbstractions_collect)
                     (_hdOghc)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOkinames)
                     (_hdOkinds)
                     (_hdOkindvar)
                     (_hdOksubst)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmodules)
                     (_hdOoptimizer)
                     (_hdOoptimizerPrelude)
                     (_hdOprekind)
                     (_hdOprelude)
                     (_hdOrawRequests_collect)
                     (_hdOtoplevel)
                     (_hdOtypeImps_collect)
                     (_hdOverbosity))
            ( _tlIabstractTypes_collect,_tlIbimapImps_collect,_tlIconstructors_collect,_tlIdepConstraints_collect,_tlIfunImps_collect,_tlIgenericAbstractions_collect,_tlIinferkind,_tlIkinames,_tlIkind_errors,_tlIkindvar,_tlIksubst,_tlIlabels_collect,_tlImethods_collect,_tlIrawRequests_collect,_tlIself,_tlIstaticErrors,_tlItypeImps_collect) =
                (tl_ (_tlOabstractTypes_collect)
                     (_tlObimapImps_collect)
                     (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOdependencies)
                     (_tlOfunImps_collect)
                     (_tlOgenericAbstractions)
                     (_tlOgenericAbstractions_collect)
                     (_tlOghc)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOkinames)
                     (_tlOkinds)
                     (_tlOkindvar)
                     (_tlOksubst)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmodules)
                     (_tlOoptimizer)
                     (_tlOoptimizerPrelude)
                     (_tlOprekind)
                     (_tlOprelude)
                     (_tlOrawRequests_collect)
                     (_tlOtoplevel)
                     (_tlOtypeImps_collect)
                     (_tlOverbosity))
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                _hdIdepConstraints_collect ++ _tlIdepConstraints_collect
            -- use rule
            (_lhsOinferkind@_) =
                _hdIinferkind : _tlIinferkind
            -- use rule
            (_lhsOkind_errors@_) =
                _hdIkind_errors ++ _tlIkind_errors
            -- use rule
            (_lhsOstaticErrors@_) =
                _hdIstaticErrors ++ _tlIstaticErrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOabstractTypes_collect@_) =
                _tlIabstractTypes_collect
            -- copy rule (up)
            (_lhsObimapImps_collect@_) =
                _tlIbimapImps_collect
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOfunImps_collect@_) =
                _tlIfunImps_collect
            -- copy rule (up)
            (_lhsOgenericAbstractions_collect@_) =
                _tlIgenericAbstractions_collect
            -- copy rule (up)
            (_lhsOkinames@_) =
                _tlIkinames
            -- copy rule (up)
            (_lhsOkindvar@_) =
                _tlIkindvar
            -- copy rule (up)
            (_lhsOksubst@_) =
                _tlIksubst
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOrawRequests_collect@_) =
                _tlIrawRequests_collect
            -- copy rule (up)
            (_lhsOtypeImps_collect@_) =
                _tlItypeImps_collect
            -- copy rule (down)
            (_hdOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (down)
            (_hdObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies@_) =
                _lhsIdependencies
            -- copy rule (down)
            (_hdOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (down)
            (_hdOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (down)
            (_hdOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (down)
            (_hdOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOkinames@_) =
                _lhsIkinames
            -- copy rule (down)
            (_hdOkinds@_) =
                _lhsIkinds
            -- copy rule (down)
            (_hdOkindvar@_) =
                _lhsIkindvar
            -- copy rule (down)
            (_hdOksubst@_) =
                _lhsIksubst
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_hdOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_hdOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_hdOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_hdOprelude@_) =
                _lhsIprelude
            -- copy rule (down)
            (_hdOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_hdOtypeImps_collect@_) =
                _lhsItypeImps_collect
            -- copy rule (down)
            (_hdOverbosity@_) =
                _lhsIverbosity
            -- copy rule (chain)
            (_tlOabstractTypes_collect@_) =
                _hdIabstractTypes_collect
            -- copy rule (chain)
            (_tlObimapImps_collect@_) =
                _hdIbimapImps_collect
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOdependencies@_) =
                _lhsIdependencies
            -- copy rule (chain)
            (_tlOfunImps_collect@_) =
                _hdIfunImps_collect
            -- copy rule (down)
            (_tlOgenericAbstractions@_) =
                _lhsIgenericAbstractions
            -- copy rule (chain)
            (_tlOgenericAbstractions_collect@_) =
                _hdIgenericAbstractions_collect
            -- copy rule (down)
            (_tlOghc@_) =
                _lhsIghc
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOkinames@_) =
                _hdIkinames
            -- copy rule (down)
            (_tlOkinds@_) =
                _lhsIkinds
            -- copy rule (chain)
            (_tlOkindvar@_) =
                _hdIkindvar
            -- copy rule (chain)
            (_tlOksubst@_) =
                _hdIksubst
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOmodules@_) =
                _lhsImodules
            -- copy rule (down)
            (_tlOoptimizer@_) =
                _lhsIoptimizer
            -- copy rule (down)
            (_tlOoptimizerPrelude@_) =
                _lhsIoptimizerPrelude
            -- copy rule (down)
            (_tlOprekind@_) =
                _lhsIprekind
            -- copy rule (down)
            (_tlOprelude@_) =
                _lhsIprelude
            -- copy rule (chain)
            (_tlOrawRequests_collect@_) =
                _hdIrawRequests_collect
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_tlOtypeImps_collect@_) =
                _hdItypeImps_collect
            -- copy rule (down)
            (_tlOverbosity@_) =
                _lhsIverbosity
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOinferkind,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps_collect)
sem_Types_Nil :: (T_Types)
sem_Types_Nil  =
    \ _lhsIabstractTypes_collect
      _lhsIbimapImps_collect
      _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies
      _lhsIfunImps_collect
      _lhsIgenericAbstractions
      _lhsIgenericAbstractions_collect
      _lhsIghc
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIkinames
      _lhsIkinds
      _lhsIkindvar
      _lhsIksubst
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImodules
      _lhsIoptimizer
      _lhsIoptimizerPrelude
      _lhsIprekind
      _lhsIprelude
      _lhsIrawRequests_collect
      _lhsItoplevel
      _lhsItypeImps_collect
      _lhsIverbosity ->
        let _lhsOabstractTypes_collect :: (Set Name)
            _lhsObimapImps_collect :: ([Request_BimapImply])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdepConstraints_collect :: ([DepConstraint])
            _lhsOfunImps_collect :: ([Request_FunImply])
            _lhsOgenericAbstractions_collect :: (FMap Name Kind)
            _lhsOinferkind :: ([Kind])
            _lhsOkinames :: (KSubst)
            _lhsOkind_errors :: ([GHError])
            _lhsOkindvar :: (Int)
            _lhsOksubst :: (KSubst)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOrawRequests_collect :: ([RawRequest])
            _lhsOself :: (Types)
            _lhsOstaticErrors :: ([GHError])
            _lhsOtypeImps_collect :: ([Request_TypeImply])
            -- use rule
            (_lhsOdepConstraints_collect@_) =
                []
            -- use rule
            (_lhsOinferkind@_) =
                []
            -- use rule
            (_lhsOkind_errors@_) =
                []
            -- use rule
            (_lhsOstaticErrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOabstractTypes_collect@_) =
                _lhsIabstractTypes_collect
            -- copy rule (chain)
            (_lhsObimapImps_collect@_) =
                _lhsIbimapImps_collect
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOfunImps_collect@_) =
                _lhsIfunImps_collect
            -- copy rule (chain)
            (_lhsOgenericAbstractions_collect@_) =
                _lhsIgenericAbstractions_collect
            -- copy rule (chain)
            (_lhsOkinames@_) =
                _lhsIkinames
            -- copy rule (chain)
            (_lhsOkindvar@_) =
                _lhsIkindvar
            -- copy rule (chain)
            (_lhsOksubst@_) =
                _lhsIksubst
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOrawRequests_collect@_) =
                _lhsIrawRequests_collect
            -- copy rule (chain)
            (_lhsOtypeImps_collect@_) =
                _lhsItypeImps_collect
        in  ( _lhsOabstractTypes_collect,_lhsObimapImps_collect,_lhsOconstructors_collect,_lhsOdepConstraints_collect,_lhsOfunImps_collect,_lhsOgenericAbstractions_collect,_lhsOinferkind,_lhsOkinames,_lhsOkind_errors,_lhsOkindvar,_lhsOksubst,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOrawRequests_collect,_lhsOself,_lhsOstaticErrors,_lhsOtypeImps_collect)


