-- do not edit; automatically generated by UU.AG
module NameReplace where


import FMap
import ErrorUtils
import ErrorMessages
import Name

import qualified List
import qualified Set
import qualified Maybe
import Set (mkSet,Set())

import AbstractSyntax
import UHA_Range
import PPrint
import Pretty (ppModuleName,ppName,ppEntity,unPretty,prettyFM)

{- import Debug.Trace -}


import KindUtils (isRestricted)
import qualified List
import Monad (msum)



makeRelevant                     :: Strings
                                 -> FMap Name Names
                                 -> Names
makeRelevant m known             =  
    concatMap 
      (\ (n,es) ->
           if getModule n == m then
             -- 28.01.2003: I do not really understand the following
             -- code, so I remove it ...
             -- let uq = makePlainName n
             -- in  ( map (\ e -> case findL known uq of
             --                    [e'] | e == e' -> Name_Entity 
             --                                        (getRange e) e 
             --                                        (MaybeName_Just uq)
             --                    _              -> Name_Entity 
             --                                        (getRange e) e 
             --                                        (MaybeName_Just n)
             --          ) 
             -- {- . filter (\ e -> m == getModule e) 
             --      ( this was contained in some of the calls, but I can't see why ...) -}
             --    ) es
             map (\e -> Name_Entity (getRange e) e (MaybeName_Just n)) es
           else
             []
      )
      (toList known)

prepareExportList                :: [Name]                -- values
                                 -> [Name]                -- types
                                 -> FMap Name [Name]  -- constructors
                                 -> FMap Name [Name]  -- methods
                                 -> Exports

prepareExportList vals types conss meths
                                 =  prepare vals types
  where
    prepare vals []            =  {- trace (show $ map (unPretty . ppName) vals) $ -} 
                                  map (Export_Variable unknownRange) vals
    prepare vals (t:ts)        =  let 
                                    cms = findL conss t ++ findL meths t
                                    (rcms,others) = List.partition (`elem` cms) vals
                                  in  
                                    ( if null rcms then
                                        Export_TypeOrClass unknownRange t MaybeNames_Nothing
                                      else 
                                        if length rcms == length cms then
                                           Export_TypeOrClassComplete unknownRange t
                                        else 
                                           Export_TypeOrClass unknownRange t (MaybeNames_Just rcms)
                                    ) : prepare others ts



selectEFromV                     :: FMap Name [Name]    {- known values -} 
                                 -> FMap Name [Name]    {- known types -}
                                 -> Exports 
                                 -> FMap Name Names     {- constructor map -}
                                 -> FMap Name Names     {- methods map -}
                                 -> FMap Name Names     {- labels map -}
                                 -> Set Name
selectEFromV known knownT fs cs ms ls
                                 =  Set.mkSet
                                      . filter select
                                      . map makeEntity
                                      . concat . map snd . toList $ known
  where 
    select                       :: Name -> Bool
    select e                     =  or $ map (coveredBy e) fs

    coveredBy                    :: Name -> Export -> Bool
    coveredBy m (Export_Variable _ n)  
                                 =  m == n
    coveredBy m (Export_TypeOrClassComplete _ t)
                                 =  let {- find all constructors/methods for this type -}
                                        vs = findL cs t 
                                              ++ findL ms t
                                              ++ findL ls t
                                    in  m `elem` vs
    coveredBy m (Export_TypeOrClass _ _ MaybeNames_Nothing)
                                 =  False  {- only on type level -}
    coveredBy m (Export_TypeOrClass _ _ (MaybeNames_Just ns)) =  m `elem` ns
    coveredBy _ (Export_Module _ _)
                                 =  internalError "NameReplace.selectEFromV: unresolved module"


selectEFromT                     :: FMap Name [Name] -> Exports
                                 -> Set Name
selectEFromT known fs            =  mkSet
                                      . filter select 
                                      . map makeEntity
                                      . concat . map snd . toList $ known
  where 
    select                       :: Name -> Bool
    select e                     =  or $ map (coveredBy e) fs 

    coveredBy                    :: Name -> Export -> Bool
    coveredBy m (Export_Variable _ n)
                                 =  m == n {- not . null $ findL known m `List.intersect` findL known n -}
    coveredBy m (Export_TypeOrClassComplete _ n)
                                 =  m == n {- not . null $ findL known m `List.intersect` findL known n -}
    coveredBy m (Export_TypeOrClass _ n _)
                                 =  m == n {- not . null $ findL known m `List.intersect` findL known n -}
    coveredBy _ (Export_Module _ _)
                                 =  internalError "NameReplace.selectEFromT: unresolved module"


selectEFromS                     :: FMap Name [Name] -> Exports
                                 -> Set Name
selectEFromS known fs            =  mkSet
                                      . filter select 
                                      . map makeEntity
                                      . concat . map snd . toList $ known
  where 
    select                       :: Name -> Bool
    select e                     =  or $ map (coveredBy e) fs 

    coveredBy                    :: Name -> Export -> Bool
    coveredBy m (Export_TypeOrClassComplete _ n)
                                 =  m == n
    coveredBy _ _                =  False



filterResolveError               :: ResolveResult -> [GHError]
filterResolveError (UnResolved _ _ e) 
                                 = [e]
filterResolveError (Collision _ _ e)
                                 = [e]
filterResolveError _             = []

filterMessages                   :: ResolveResult -> Doc
filterMessages (Resolved n e)    =  fill 40 (text "RES" <+> (text $ show $ getRange n) <+> ppName n)
                                      <+> text "-->" <+> ppEntity e
filterMessages (Defined e)       =  text "DEF" <+> (text $ show $ getRange e) <+> ppEntity e
filterMessages (Collision n e err) 
                                 =  text "*** COLL ***"
                                      <+> (text $ show $ getRange n)
                                      <+> ppName n
                                      <+> text "defines"
                                      <+> ppEntity e
                                      <+> text "again"
filterMessages (UnResolved n ns e)  
                                 =  text "*** UNRES ***" 
                                      <+> (text $ show $ getRange n) 
                                      <+> ppName n
                                      <+> text "not found among:"
                                      <$> indent 10 (vsep (map ppName ns))
filterMessages (Mapping s m)     =  empty <$> text s 
                                      <$> prettyFM ppName (sep . map ppEntity) m <$> empty
filterMessages (Set s m)         =  empty <$> text s
                                      <$> vcat (map ppEntity (Set.setToList m))



mergeImports :: FMap Name [Name] -> FMap Name [Name] -> FMap Name [Name]

{- It would be much better to find an implementation that does not go via lists ... -}

mergeImports ns os = let news = toList ns
                     in  foldr (\e fm -> addLUnion fm e) os news



selectFromV                      :: (Bool -> Bool) 
                                 -> FMap Name [Name]  {- known values -} 
                                 -> FMap Name [Name]  {- known types -}
                                 -> Imports 
                                 -> FMap Name [Name]  {- constructor map -}
                                 -> FMap Name [Name]  {- methods map -}
                                 -> FMap Name [Name]  {- labels map -}
                                 -> FMap Name [Name]
selectFromV b known knownT fs cs ms ls =  
    fromList . filter (b . select) . toList $ known

  where 

    select                       :: (Name,[Name]) -> Bool
    select (n,(e:_))             =  or . map (coveredBy (makeEntity e)) $ fs
    select _                     =  False

    coveredBy                    :: Name -> Import -> Bool
    coveredBy m (Import_Variable _ n)   
                                 =  makePlainName m == makePlainName n
    coveredBy m (Import_TypeOrClassComplete _ t) 
                                 =  let {- find all constructors/methods/labels for this type -}
                                        vs = findL cs t 
                                              ++ findL ms t 
                                              ++ findL ls t
                                    in  or . map (== m) $ vs
    coveredBy m (Import_TypeOrClass _ _ MaybeNames_Nothing)
                                 =  False {- only on type level -}
    coveredBy m (Import_TypeOrClass _ _ (MaybeNames_Just ns)) 
                                 =  or . map (coveredBy m . Import_Variable unknownRange) $ ns

selectFromT                      :: (Bool -> Bool) -> FMap Name [Name] -> Imports 
                                 -> FMap Name [Name]
selectFromT b known fs           =  fromList . filter (b . select) . toList $ known

  where 
    
    select                       :: (Name,[Name]) -> Bool
    select (n,(e:_))             =  or . map (coveredBy (makeEntity e)) $ fs
    select _                     =  False

    coveredBy                    :: Name -> Import -> Bool
    coveredBy m (Import_Variable _ n)         
                                 =  makePlainName m == makePlainName n
    coveredBy m (Import_TypeOrClassComplete _ n)     
                                 =  makePlainName m == makePlainName n
    coveredBy m (Import_TypeOrClass _ n _)  
                                 =  makePlainName m == makePlainName n



prefixEntity                     :: Strings -> Name -> (Name,[Name])
prefixEntity p name@(Name_Identifier r m n)
                                 =  (Name_Identifier r p n,[name])
prefixEntity p name@(Name_Operator r m n)
                                 =  (Name_Operator r p n,[name])
prefixEntity p name@(Name_Special r m n)
                                 =  (Name_Special r p n,[name])
prefixEntity p name@(Name_Entity _ e _)
                                 =  prefixEntity p e

getEntity                        :: Name -> Name
getEntity (Name_Entity _ e _)    =  e
getEntity _                      =  internalError "Names.getEntity: unresolved name found"

makeEntity                       :: Name -> Name
makeEntity n                     =  Name_Entity (getRange n) n MaybeName_Nothing

makeAvailableUnqualified         :: [Name] -> FMap Name [Name]
makeAvailableUnqualified         =  fromList . map (\ n -> (makePlainName n, [n]))

classMethods                     :: Maybe Name -> FMap Name [Name] -> FMap Name [Name] 
                                 -> FMap Name [Name]
classMethods inst knownV meth    =  case inst of
                                      Nothing -> knownV
                                      Just c  -> makeAvailableUnqualified
                                                   $ findL meth c



resolve                          :: ModuleSystem -> Int 
                                 -> NameReplaceType
resolve msys vbty                =  fst $ sem_Root (Root_Root msys) vbty
                                      {- the |fst| is to forget the |self| generated for |Root| -}



data NameType 
    = Def_Val     {- it defines a value -}
    | Def_Typ     {- it defines a type  -}
    | Def_Kind    {- it defines a kind  -}
    | Ref_Val  { softRef :: Bool }   {- it refers to a value -}
    | Ref_Typ  { softRef :: Bool }   {- it refers to a type -}
    | Ref_Kind { softRef :: Bool }   {- it refers to a kind -}
    | DefOrRef_Typ { softRef :: Bool } {- used for type-indexed types; define at first, ref later -}
    | NameType_None  {- somehow none of the above -}
  deriving (Eq,Show)

isDef                            :: NameType -> Bool
isDef Def_Val                    =  True
isDef Def_Typ                    =  True
isDef Def_Kind                   =  True
isDef _                          =  False

isRef                            :: NameType -> Bool
isRef (Ref_Val _)                =  True
isRef (Ref_Typ _)                =  True
isRef (Ref_Kind  _)              =  True
isRef _                          =  False

isDefRef                         :: NameType -> Bool
isDefRef (DefOrRef_Typ _)        =  True
isDefRef _                       =  False

ref_Val                          = Ref_Val      False
ref_Typ                          = Ref_Typ      False
ref_Kind                         = Ref_Kind     False
deforref_Typ                     = DefOrRef_Typ False
softref_Val                      = Ref_Val      True
softref_Typ                      = Ref_Typ      True
softref_Kind                     = Ref_Kind     True
softdeforref_Typ                 = DefOrRef_Typ True



data ResolveResult
    = Resolved   {- name: -} Name {- entity: -} Name
        {- name refers to entity -}
    | Defined    {- entity: -} Name
        {- entity defined here -}
    | Collision  {- name: -} Name {- entity: -} Name GHError
    | UnResolved Name [Name] GHError 
    | Mapping    String (FMap Name [Name])
    | Set        String (Set Name)


data Root = Root_Root ModuleSystem

type NameReplaceType = (Doc            {- error messages -}
                       ,Bool           {- stop after this phase? -}
                       ,ModuleSystem   {- the resolved tree -}
                       ,Set Name       {- exported values -}
                       ,Set Name       {- exported types -}
                       ,Set Name       {- exported structures -}
                       ,[(Set Name,Set Name)] {- imported entities -}
                       ,[(Set Name,Set Name)] {- hidden entities -}
                       ,Set Strings    {- modules -}
                       )
-- Alternative -------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for Alternative.Alternative:
      knownValues
      self

-}
{-
   local variables for Alternative.Empty:
      self

-}
-- semantic domain
type T_Alternative = (Maybe Name) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Strings) ->
                     (Bool) ->
                     (Maybe Name) ->
                     (FMap Name [Name]) ->
                     (FMap Name [Name]) ->
                     (FMap Name [Name]) ->
                     (FMap Name [Name]) ->
                     (FMap Name [Name]) ->
                     (FMap Name [Name]) ->
                     (FMap Name [Name]) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Bool) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (FMap ModuleName [Name]) ->
                     (FMap ModuleName [Name]) ->
                     (NameType) ->
                     (Bool) ->
                     ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(Alternative))
-- cata
sem_Alternative :: (Alternative) ->
                   (T_Alternative)
sem_Alternative ((Alternative_Alternative (_range) (_pattern) (_righthandside))) =
    (sem_Alternative_Alternative ((sem_Range (_range))) ((sem_Pattern (_pattern))) ((sem_RightHandSide (_righthandside))))
sem_Alternative ((Alternative_Empty (_range))) =
    (sem_Alternative_Empty ((sem_Range (_range))))
sem_Alternative_Alternative :: (T_Range) ->
                               (T_Pattern) ->
                               (T_RightHandSide) ->
                               (T_Alternative)
sem_Alternative_Alternative (range_) (pattern_) (righthandside_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Alternative)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _patternIconstructors_collect :: (FMap Name Names)
            _patternIknownKinds_collect :: (FMap Name [Name])
            _patternIknownTypes_collect :: (FMap Name [Name])
            _patternIknownValues_collect :: (FMap Name [Name])
            _patternIlabels_collect :: (FMap Name Names)
            _patternImethods_collect :: (FMap Name Names)
            _patternImoduleTypes :: (FMap ModuleName [Name])
            _patternImoduleValues :: (FMap ModuleName [Name])
            _patternImodules :: (Set.Set Strings)
            _patternIname :: (Name)
            _patternIres :: ([ResolveResult])
            _patternIself :: (Pattern)
            _patternOclassname :: (Maybe Name)
            _patternOconstructors_collect :: (FMap Name Names)
            _patternOconstructors_dist :: (FMap Name Names)
            _patternOcurrentModule :: (Strings)
            _patternOimportedModule :: (Bool)
            _patternOinstancename :: (Maybe Name)
            _patternOknownKinds :: (FMap Name [Name])
            _patternOknownKinds_collect :: (FMap Name [Name])
            _patternOknownTypes :: (FMap Name [Name])
            _patternOknownTypes_collect :: (FMap Name [Name])
            _patternOknownValues :: (FMap Name [Name])
            _patternOknownValues_collect :: (FMap Name [Name])
            _patternOlabels_collect :: (FMap Name Names)
            _patternOlabels_dist :: (FMap Name Names)
            _patternOlocal :: (Bool)
            _patternOmethods_collect :: (FMap Name Names)
            _patternOmethods_dist :: (FMap Name Names)
            _patternOmoduleTypes :: (FMap ModuleName [Name])
            _patternOmoduleValues :: (FMap ModuleName [Name])
            _patternOnameType :: (NameType)
            _patternOtoplevel :: (Bool)
            _righthandsideIconstructors_collect :: (FMap Name Names)
            _righthandsideIknownKinds_collect :: (FMap Name [Name])
            _righthandsideIknownTypes_collect :: (FMap Name [Name])
            _righthandsideIknownValues_collect :: (FMap Name [Name])
            _righthandsideIlabels_collect :: (FMap Name Names)
            _righthandsideImethods_collect :: (FMap Name Names)
            _righthandsideImoduleTypes :: (FMap ModuleName [Name])
            _righthandsideImoduleValues :: (FMap ModuleName [Name])
            _righthandsideImodules :: (Set.Set Strings)
            _righthandsideIres :: ([ResolveResult])
            _righthandsideIself :: (RightHandSide)
            _righthandsideOclassname :: (Maybe Name)
            _righthandsideOconstructors_collect :: (FMap Name Names)
            _righthandsideOconstructors_dist :: (FMap Name Names)
            _righthandsideOcurrentModule :: (Strings)
            _righthandsideOimportedModule :: (Bool)
            _righthandsideOinstancename :: (Maybe Name)
            _righthandsideOknownGenerics :: (FMap Name [Name])
            _righthandsideOknownKinds :: (FMap Name [Name])
            _righthandsideOknownKinds_collect :: (FMap Name [Name])
            _righthandsideOknownTypes :: (FMap Name [Name])
            _righthandsideOknownTypes_collect :: (FMap Name [Name])
            _righthandsideOknownValues :: (FMap Name [Name])
            _righthandsideOknownValues_collect :: (FMap Name [Name])
            _righthandsideOlabels_collect :: (FMap Name Names)
            _righthandsideOlabels_dist :: (FMap Name Names)
            _righthandsideOlocal :: (Bool)
            _righthandsideOmethods_collect :: (FMap Name Names)
            _righthandsideOmethods_dist :: (FMap Name Names)
            _righthandsideOmoduleTypes :: (FMap ModuleName [Name])
            _righthandsideOmoduleValues :: (FMap ModuleName [Name])
            _righthandsideOnameType :: (NameType)
            _righthandsideOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _patternIconstructors_collect,_patternIknownKinds_collect,_patternIknownTypes_collect,_patternIknownValues_collect,_patternIlabels_collect,_patternImethods_collect,_patternImoduleTypes,_patternImoduleValues,_patternImodules,_patternIname,_patternIres,_patternIself) =
                (pattern_ (_patternOclassname)
                          (_patternOconstructors_collect)
                          (_patternOconstructors_dist)
                          (_patternOcurrentModule)
                          (_patternOimportedModule)
                          (_patternOinstancename)
                          (_patternOknownKinds)
                          (_patternOknownKinds_collect)
                          (_patternOknownTypes)
                          (_patternOknownTypes_collect)
                          (_patternOknownValues)
                          (_patternOknownValues_collect)
                          (_patternOlabels_collect)
                          (_patternOlabels_dist)
                          (_patternOlocal)
                          (_patternOmethods_collect)
                          (_patternOmethods_dist)
                          (_patternOmoduleTypes)
                          (_patternOmoduleValues)
                          (_patternOnameType)
                          (_patternOtoplevel))
            ( _righthandsideIconstructors_collect,_righthandsideIknownKinds_collect,_righthandsideIknownTypes_collect,_righthandsideIknownValues_collect,_righthandsideIlabels_collect,_righthandsideImethods_collect,_righthandsideImoduleTypes,_righthandsideImoduleValues,_righthandsideImodules,_righthandsideIres,_righthandsideIself) =
                (righthandside_ (_righthandsideOclassname)
                                (_righthandsideOconstructors_collect)
                                (_righthandsideOconstructors_dist)
                                (_righthandsideOcurrentModule)
                                (_righthandsideOimportedModule)
                                (_righthandsideOinstancename)
                                (_righthandsideOknownGenerics)
                                (_righthandsideOknownKinds)
                                (_righthandsideOknownKinds_collect)
                                (_righthandsideOknownTypes)
                                (_righthandsideOknownTypes_collect)
                                (_righthandsideOknownValues)
                                (_righthandsideOknownValues_collect)
                                (_righthandsideOlabels_collect)
                                (_righthandsideOlabels_dist)
                                (_righthandsideOlocal)
                                (_righthandsideOmethods_collect)
                                (_righthandsideOmethods_dist)
                                (_righthandsideOmoduleTypes)
                                (_righthandsideOmoduleValues)
                                (_righthandsideOnameType)
                                (_righthandsideOtoplevel))
            -- "./Names.inc.lag"(line 629, column 9)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- "./Names.inc.lag"(line 628, column 9)
            (_knownValues@_) =
                _patternIknownValues_collect `mergeFM` _lhsIknownValues
            -- "./Names.inc.lag"(line 627, column 9)
            (_patternOknownValues_collect@_) =
                emptyFM
            -- "./NameTypes.inc.lag"(line 360, column 9)
            (_patternOnameType@_) =
                Def_Val
            -- use rule
            (_lhsOmodules@_) =
                _patternImodules `Set.union` _righthandsideImodules
            -- use rule
            (_lhsOres@_) =
                _patternIres ++ _righthandsideIres
            -- self rule
            (_self@_) =
                Alternative_Alternative _rangeIself _patternIself _righthandsideIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _righthandsideIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _righthandsideIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _righthandsideIknownTypes_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _righthandsideIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _righthandsideImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _righthandsideImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _righthandsideImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_patternOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_patternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_patternOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_patternOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_patternOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_patternOknownValues@_) =
                _knownValues
            -- copy rule (down)
            (_patternOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_patternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_patternOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_patternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_patternOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_patternOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_righthandsideOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_righthandsideOconstructors_collect@_) =
                _patternIconstructors_collect
            -- copy rule (down)
            (_righthandsideOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_righthandsideOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_righthandsideOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_righthandsideOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_righthandsideOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_righthandsideOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_righthandsideOknownKinds_collect@_) =
                _patternIknownKinds_collect
            -- copy rule (down)
            (_righthandsideOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_righthandsideOknownTypes_collect@_) =
                _patternIknownTypes_collect
            -- copy rule (chain)
            (_righthandsideOknownValues@_) =
                _knownValues
            -- copy rule (chain)
            (_righthandsideOknownValues_collect@_) =
                _patternIknownValues_collect
            -- copy rule (chain)
            (_righthandsideOlabels_collect@_) =
                _patternIlabels_collect
            -- copy rule (down)
            (_righthandsideOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_righthandsideOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_righthandsideOmethods_collect@_) =
                _patternImethods_collect
            -- copy rule (down)
            (_righthandsideOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_righthandsideOmoduleTypes@_) =
                _patternImoduleTypes
            -- copy rule (chain)
            (_righthandsideOmoduleValues@_) =
                _patternImoduleValues
            -- copy rule (down)
            (_righthandsideOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_righthandsideOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Alternative_Empty :: (T_Range) ->
                         (T_Alternative)
sem_Alternative_Empty (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Alternative)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                Alternative_Empty _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- Alternatives ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for Alternatives.Cons:
      self

-}
{-
   local variables for Alternatives.Nil:
      self

-}
-- semantic domain
type T_Alternatives = (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Strings) ->
                      (Bool) ->
                      (Maybe Name) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (FMap ModuleName [Name]) ->
                      (FMap ModuleName [Name]) ->
                      (NameType) ->
                      (Bool) ->
                      ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(Alternatives))
-- cata
sem_Alternatives :: (Alternatives) ->
                    (T_Alternatives)
sem_Alternatives (list) =
    (foldr (sem_Alternatives_Cons) (sem_Alternatives_Nil) ((map sem_Alternative list)))
sem_Alternatives_Cons :: (T_Alternative) ->
                         (T_Alternatives) ->
                         (T_Alternatives)
sem_Alternatives_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Alternatives)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIknownKinds_collect :: (FMap Name [Name])
            _hdIknownTypes_collect :: (FMap Name [Name])
            _hdIknownValues_collect :: (FMap Name [Name])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdImoduleTypes :: (FMap ModuleName [Name])
            _hdImoduleValues :: (FMap ModuleName [Name])
            _hdImodules :: (Set.Set Strings)
            _hdIres :: ([ResolveResult])
            _hdIself :: (Alternative)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOknownGenerics :: (FMap Name [Name])
            _hdOknownKinds :: (FMap Name [Name])
            _hdOknownKinds_collect :: (FMap Name [Name])
            _hdOknownTypes :: (FMap Name [Name])
            _hdOknownTypes_collect :: (FMap Name [Name])
            _hdOknownValues :: (FMap Name [Name])
            _hdOknownValues_collect :: (FMap Name [Name])
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmoduleTypes :: (FMap ModuleName [Name])
            _hdOmoduleValues :: (FMap ModuleName [Name])
            _hdOnameType :: (NameType)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIknownKinds_collect :: (FMap Name [Name])
            _tlIknownTypes_collect :: (FMap Name [Name])
            _tlIknownValues_collect :: (FMap Name [Name])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlImoduleTypes :: (FMap ModuleName [Name])
            _tlImoduleValues :: (FMap ModuleName [Name])
            _tlImodules :: (Set.Set Strings)
            _tlIres :: ([ResolveResult])
            _tlIself :: (Alternatives)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOknownGenerics :: (FMap Name [Name])
            _tlOknownKinds :: (FMap Name [Name])
            _tlOknownKinds_collect :: (FMap Name [Name])
            _tlOknownTypes :: (FMap Name [Name])
            _tlOknownTypes_collect :: (FMap Name [Name])
            _tlOknownValues :: (FMap Name [Name])
            _tlOknownValues_collect :: (FMap Name [Name])
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmoduleTypes :: (FMap ModuleName [Name])
            _tlOmoduleValues :: (FMap ModuleName [Name])
            _tlOnameType :: (NameType)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIknownKinds_collect,_hdIknownTypes_collect,_hdIknownValues_collect,_hdIlabels_collect,_hdImethods_collect,_hdImoduleTypes,_hdImoduleValues,_hdImodules,_hdIres,_hdIself) =
                (hd_ (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOknownGenerics)
                     (_hdOknownKinds)
                     (_hdOknownKinds_collect)
                     (_hdOknownTypes)
                     (_hdOknownTypes_collect)
                     (_hdOknownValues)
                     (_hdOknownValues_collect)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmoduleTypes)
                     (_hdOmoduleValues)
                     (_hdOnameType)
                     (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIknownKinds_collect,_tlIknownTypes_collect,_tlIknownValues_collect,_tlIlabels_collect,_tlImethods_collect,_tlImoduleTypes,_tlImoduleValues,_tlImodules,_tlIres,_tlIself) =
                (tl_ (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOknownGenerics)
                     (_tlOknownKinds)
                     (_tlOknownKinds_collect)
                     (_tlOknownTypes)
                     (_tlOknownTypes_collect)
                     (_tlOknownValues)
                     (_tlOknownValues_collect)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmoduleTypes)
                     (_tlOmoduleValues)
                     (_tlOnameType)
                     (_tlOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _hdImodules `Set.union` _tlImodules
            -- use rule
            (_lhsOres@_) =
                _hdIres ++ _tlIres
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _tlIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _tlIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _tlIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _tlImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _tlImoduleValues
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_hdOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_hdOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_hdOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_hdOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_hdOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_hdOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_hdOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_hdOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_tlOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_tlOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_tlOknownKinds_collect@_) =
                _hdIknownKinds_collect
            -- copy rule (down)
            (_tlOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_tlOknownTypes_collect@_) =
                _hdIknownTypes_collect
            -- copy rule (down)
            (_tlOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_tlOknownValues_collect@_) =
                _hdIknownValues_collect
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_tlOmoduleTypes@_) =
                _hdImoduleTypes
            -- copy rule (chain)
            (_tlOmoduleValues@_) =
                _hdImoduleValues
            -- copy rule (down)
            (_tlOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Alternatives_Nil :: (T_Alternatives)
sem_Alternatives_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Alternatives)
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- AnnotatedType -----------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for AnnotatedType.AnnotatedType:
      self

-}
-- semantic domain
type T_AnnotatedType = (Maybe Name) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (Strings) ->
                       (Bool) ->
                       (Maybe Name) ->
                       (FMap Name [Name]) ->
                       (FMap Name [Name]) ->
                       (FMap Name [Name]) ->
                       (FMap Name [Name]) ->
                       (FMap Name [Name]) ->
                       (FMap Name [Name]) ->
                       (FMap Name [Name]) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (Bool) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (FMap ModuleName [Name]) ->
                       (FMap ModuleName [Name]) ->
                       (NameType) ->
                       (Bool) ->
                       ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(AnnotatedType))
-- cata
sem_AnnotatedType :: (AnnotatedType) ->
                     (T_AnnotatedType)
sem_AnnotatedType ((AnnotatedType_AnnotatedType (_range) (_strict) (_type))) =
    (sem_AnnotatedType_AnnotatedType ((sem_Range (_range))) (_strict) ((sem_Type (_type))))
sem_AnnotatedType_AnnotatedType :: (T_Range) ->
                                   (Bool) ->
                                   (T_Type) ->
                                   (T_AnnotatedType)
sem_AnnotatedType_AnnotatedType (range_) (strict_) (type_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (AnnotatedType)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIknownKinds_collect :: (FMap Name [Name])
            _typeIknownTypes_collect :: (FMap Name [Name])
            _typeIknownValues_collect :: (FMap Name [Name])
            _typeIlabels_collect :: (FMap Name Names)
            _typeImethods_collect :: (FMap Name Names)
            _typeImoduleTypes :: (FMap ModuleName [Name])
            _typeImoduleValues :: (FMap ModuleName [Name])
            _typeImodules :: (Set.Set Strings)
            _typeIres :: ([ResolveResult])
            _typeIself :: (Type)
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOimportedModule :: (Bool)
            _typeOinstancename :: (Maybe Name)
            _typeOknownGenerics :: (FMap Name [Name])
            _typeOknownKinds :: (FMap Name [Name])
            _typeOknownKinds_collect :: (FMap Name [Name])
            _typeOknownTypes :: (FMap Name [Name])
            _typeOknownTypes_collect :: (FMap Name [Name])
            _typeOknownValues :: (FMap Name [Name])
            _typeOknownValues_collect :: (FMap Name [Name])
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOmoduleTypes :: (FMap ModuleName [Name])
            _typeOmoduleValues :: (FMap ModuleName [Name])
            _typeOnameType :: (NameType)
            _typeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _typeIconstructors_collect,_typeIknownKinds_collect,_typeIknownTypes_collect,_typeIknownValues_collect,_typeIlabels_collect,_typeImethods_collect,_typeImoduleTypes,_typeImoduleValues,_typeImodules,_typeIres,_typeIself) =
                (type_ (_typeOclassname)
                       (_typeOconstructors_collect)
                       (_typeOconstructors_dist)
                       (_typeOcurrentModule)
                       (_typeOimportedModule)
                       (_typeOinstancename)
                       (_typeOknownGenerics)
                       (_typeOknownKinds)
                       (_typeOknownKinds_collect)
                       (_typeOknownTypes)
                       (_typeOknownTypes_collect)
                       (_typeOknownValues)
                       (_typeOknownValues_collect)
                       (_typeOlabels_collect)
                       (_typeOlabels_dist)
                       (_typeOlocal)
                       (_typeOmethods_collect)
                       (_typeOmethods_dist)
                       (_typeOmoduleTypes)
                       (_typeOmoduleValues)
                       (_typeOnameType)
                       (_typeOtoplevel))
            -- "./NameTypes.inc.lag"(line 138, column 9)
            (_typeOnameType@_) =
                ref_Typ
            -- "./ModuleInformation.inc.lag"(line 203, column 8)
            (_typeOtoplevel@_) =
                False
            -- use rule
            (_lhsOmodules@_) =
                _typeImodules
            -- use rule
            (_lhsOres@_) =
                _typeIres
            -- self rule
            (_self@_) =
                AnnotatedType_AnnotatedType _rangeIself strict_ _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _typeIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _typeIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _typeIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _typeImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _typeImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_typeOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typeOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_typeOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_typeOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_typeOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_typeOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_typeOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_typeOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_typeOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_typeOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typeOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_typeOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- AnnotatedTypes ----------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for AnnotatedTypes.Cons:
      self

-}
{-
   local variables for AnnotatedTypes.Nil:
      self

-}
-- semantic domain
type T_AnnotatedTypes = (Maybe Name) ->
                        (FMap Name Names) ->
                        (FMap Name Names) ->
                        (Strings) ->
                        (Bool) ->
                        (Maybe Name) ->
                        (FMap Name [Name]) ->
                        (FMap Name [Name]) ->
                        (FMap Name [Name]) ->
                        (FMap Name [Name]) ->
                        (FMap Name [Name]) ->
                        (FMap Name [Name]) ->
                        (FMap Name [Name]) ->
                        (FMap Name Names) ->
                        (FMap Name Names) ->
                        (Bool) ->
                        (FMap Name Names) ->
                        (FMap Name Names) ->
                        (FMap ModuleName [Name]) ->
                        (FMap ModuleName [Name]) ->
                        (NameType) ->
                        (Bool) ->
                        ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(AnnotatedTypes))
-- cata
sem_AnnotatedTypes :: (AnnotatedTypes) ->
                      (T_AnnotatedTypes)
sem_AnnotatedTypes (list) =
    (foldr (sem_AnnotatedTypes_Cons) (sem_AnnotatedTypes_Nil) ((map sem_AnnotatedType list)))
sem_AnnotatedTypes_Cons :: (T_AnnotatedType) ->
                           (T_AnnotatedTypes) ->
                           (T_AnnotatedTypes)
sem_AnnotatedTypes_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (AnnotatedTypes)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIknownKinds_collect :: (FMap Name [Name])
            _hdIknownTypes_collect :: (FMap Name [Name])
            _hdIknownValues_collect :: (FMap Name [Name])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdImoduleTypes :: (FMap ModuleName [Name])
            _hdImoduleValues :: (FMap ModuleName [Name])
            _hdImodules :: (Set.Set Strings)
            _hdIres :: ([ResolveResult])
            _hdIself :: (AnnotatedType)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOknownGenerics :: (FMap Name [Name])
            _hdOknownKinds :: (FMap Name [Name])
            _hdOknownKinds_collect :: (FMap Name [Name])
            _hdOknownTypes :: (FMap Name [Name])
            _hdOknownTypes_collect :: (FMap Name [Name])
            _hdOknownValues :: (FMap Name [Name])
            _hdOknownValues_collect :: (FMap Name [Name])
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmoduleTypes :: (FMap ModuleName [Name])
            _hdOmoduleValues :: (FMap ModuleName [Name])
            _hdOnameType :: (NameType)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIknownKinds_collect :: (FMap Name [Name])
            _tlIknownTypes_collect :: (FMap Name [Name])
            _tlIknownValues_collect :: (FMap Name [Name])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlImoduleTypes :: (FMap ModuleName [Name])
            _tlImoduleValues :: (FMap ModuleName [Name])
            _tlImodules :: (Set.Set Strings)
            _tlIres :: ([ResolveResult])
            _tlIself :: (AnnotatedTypes)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOknownGenerics :: (FMap Name [Name])
            _tlOknownKinds :: (FMap Name [Name])
            _tlOknownKinds_collect :: (FMap Name [Name])
            _tlOknownTypes :: (FMap Name [Name])
            _tlOknownTypes_collect :: (FMap Name [Name])
            _tlOknownValues :: (FMap Name [Name])
            _tlOknownValues_collect :: (FMap Name [Name])
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmoduleTypes :: (FMap ModuleName [Name])
            _tlOmoduleValues :: (FMap ModuleName [Name])
            _tlOnameType :: (NameType)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIknownKinds_collect,_hdIknownTypes_collect,_hdIknownValues_collect,_hdIlabels_collect,_hdImethods_collect,_hdImoduleTypes,_hdImoduleValues,_hdImodules,_hdIres,_hdIself) =
                (hd_ (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOknownGenerics)
                     (_hdOknownKinds)
                     (_hdOknownKinds_collect)
                     (_hdOknownTypes)
                     (_hdOknownTypes_collect)
                     (_hdOknownValues)
                     (_hdOknownValues_collect)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmoduleTypes)
                     (_hdOmoduleValues)
                     (_hdOnameType)
                     (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIknownKinds_collect,_tlIknownTypes_collect,_tlIknownValues_collect,_tlIlabels_collect,_tlImethods_collect,_tlImoduleTypes,_tlImoduleValues,_tlImodules,_tlIres,_tlIself) =
                (tl_ (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOknownGenerics)
                     (_tlOknownKinds)
                     (_tlOknownKinds_collect)
                     (_tlOknownTypes)
                     (_tlOknownTypes_collect)
                     (_tlOknownValues)
                     (_tlOknownValues_collect)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmoduleTypes)
                     (_tlOmoduleValues)
                     (_tlOnameType)
                     (_tlOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _hdImodules `Set.union` _tlImodules
            -- use rule
            (_lhsOres@_) =
                _hdIres ++ _tlIres
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _tlIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _tlIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _tlIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _tlImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _tlImoduleValues
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_hdOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_hdOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_hdOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_hdOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_hdOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_hdOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_hdOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_hdOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_tlOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_tlOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_tlOknownKinds_collect@_) =
                _hdIknownKinds_collect
            -- copy rule (down)
            (_tlOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_tlOknownTypes_collect@_) =
                _hdIknownTypes_collect
            -- copy rule (down)
            (_tlOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_tlOknownValues_collect@_) =
                _hdIknownValues_collect
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_tlOmoduleTypes@_) =
                _hdImoduleTypes
            -- copy rule (chain)
            (_tlOmoduleValues@_) =
                _hdImoduleValues
            -- copy rule (down)
            (_tlOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_AnnotatedTypes_Nil :: (T_AnnotatedTypes)
sem_AnnotatedTypes_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (AnnotatedTypes)
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- Body --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      hiddenEntities       : [(Set Name,Set Name)]
      importedEntities     : [(Set Name,Set Name)]
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for Body.Body:
      mapping
      self

-}
-- semantic domain
type T_Body = (Maybe Name) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (Strings) ->
              (Bool) ->
              (Maybe Name) ->
              (FMap Name [Name]) ->
              (FMap Name [Name]) ->
              (FMap Name [Name]) ->
              (FMap Name [Name]) ->
              (FMap Name [Name]) ->
              (FMap Name [Name]) ->
              (FMap Name [Name]) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (Bool) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (FMap ModuleName [Name]) ->
              (FMap ModuleName [Name]) ->
              (NameType) ->
              (Bool) ->
              ( (FMap Name Names),([(Set Name,Set Name)]),([(Set Name,Set Name)]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(Body))
-- cata
sem_Body :: (Body) ->
            (T_Body)
sem_Body ((Body_Body (_range) (_importdeclarations) (_declarations))) =
    (sem_Body_Body ((sem_Range (_range))) ((sem_ImportDeclarations (_importdeclarations))) ((sem_Declarations (_declarations))))
sem_Body_Body :: (T_Range) ->
                 (T_ImportDeclarations) ->
                 (T_Declarations) ->
                 (T_Body)
sem_Body_Body (range_) (importdeclarations_) (declarations_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOhiddenEntities :: ([(Set Name,Set Name)])
            _lhsOimportedEntities :: ([(Set Name,Set Name)])
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Body)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _importdeclarationsIconstructors_collect :: (FMap Name Names)
            _importdeclarationsIhiddenEntities :: ([(Set Name,Set Name)])
            _importdeclarationsIimportedEntities :: ([(Set Name,Set Name)])
            _importdeclarationsIknownKinds_collect :: (FMap Name [Name])
            _importdeclarationsIknownTypes_collect :: (FMap Name [Name])
            _importdeclarationsIknownValues_collect :: (FMap Name [Name])
            _importdeclarationsIlabels_collect :: (FMap Name Names)
            _importdeclarationsImethods_collect :: (FMap Name Names)
            _importdeclarationsImoduleTypes :: (FMap ModuleName [Name])
            _importdeclarationsImoduleValues :: (FMap ModuleName [Name])
            _importdeclarationsImodules :: (Set.Set Strings)
            _importdeclarationsIres :: ([ResolveResult])
            _importdeclarationsIself :: (ImportDeclarations)
            _importdeclarationsOclassname :: (Maybe Name)
            _importdeclarationsOconstructors_collect :: (FMap Name Names)
            _importdeclarationsOconstructors_dist :: (FMap Name Names)
            _importdeclarationsOcurrentModule :: (Strings)
            _importdeclarationsOimportedModule :: (Bool)
            _importdeclarationsOinstancename :: (Maybe Name)
            _importdeclarationsOknownKinds :: (FMap Name [Name])
            _importdeclarationsOknownKinds_collect :: (FMap Name [Name])
            _importdeclarationsOknownTypes :: (FMap Name [Name])
            _importdeclarationsOknownTypes_collect :: (FMap Name [Name])
            _importdeclarationsOknownValues :: (FMap Name [Name])
            _importdeclarationsOknownValues_collect :: (FMap Name [Name])
            _importdeclarationsOlabels_collect :: (FMap Name Names)
            _importdeclarationsOlabels_dist :: (FMap Name Names)
            _importdeclarationsOlocal :: (Bool)
            _importdeclarationsOmethods_collect :: (FMap Name Names)
            _importdeclarationsOmethods_dist :: (FMap Name Names)
            _importdeclarationsOmoduleTypes :: (FMap ModuleName [Name])
            _importdeclarationsOmoduleValues :: (FMap ModuleName [Name])
            _importdeclarationsOnameType :: (NameType)
            _importdeclarationsOtoplevel :: (Bool)
            _declarationsIconstructors_collect :: (FMap Name Names)
            _declarationsIknownKinds_collect :: (FMap Name [Name])
            _declarationsIknownTypes_collect :: (FMap Name [Name])
            _declarationsIknownValues_collect :: (FMap Name [Name])
            _declarationsIlabels_collect :: (FMap Name Names)
            _declarationsImethods_collect :: (FMap Name Names)
            _declarationsImoduleTypes :: (FMap ModuleName [Name])
            _declarationsImoduleValues :: (FMap ModuleName [Name])
            _declarationsImodules :: (Set.Set Strings)
            _declarationsIres :: ([ResolveResult])
            _declarationsIself :: (Declarations)
            _declarationsOclassname :: (Maybe Name)
            _declarationsOconstructors_collect :: (FMap Name Names)
            _declarationsOconstructors_dist :: (FMap Name Names)
            _declarationsOcurrentModule :: (Strings)
            _declarationsOimportedModule :: (Bool)
            _declarationsOinstancename :: (Maybe Name)
            _declarationsOknownGenerics :: (FMap Name [Name])
            _declarationsOknownKinds :: (FMap Name [Name])
            _declarationsOknownKinds_collect :: (FMap Name [Name])
            _declarationsOknownTypes :: (FMap Name [Name])
            _declarationsOknownTypes_collect :: (FMap Name [Name])
            _declarationsOknownValues :: (FMap Name [Name])
            _declarationsOknownValues_collect :: (FMap Name [Name])
            _declarationsOlabels_collect :: (FMap Name Names)
            _declarationsOlabels_dist :: (FMap Name Names)
            _declarationsOlocal :: (Bool)
            _declarationsOmethods_collect :: (FMap Name Names)
            _declarationsOmethods_dist :: (FMap Name Names)
            _declarationsOmoduleTypes :: (FMap ModuleName [Name])
            _declarationsOmoduleValues :: (FMap ModuleName [Name])
            _declarationsOnameType :: (NameType)
            _declarationsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _importdeclarationsIconstructors_collect
             ,_importdeclarationsIhiddenEntities
             ,_importdeclarationsIimportedEntities
             ,_importdeclarationsIknownKinds_collect
             ,_importdeclarationsIknownTypes_collect
             ,_importdeclarationsIknownValues_collect
             ,_importdeclarationsIlabels_collect
             ,_importdeclarationsImethods_collect
             ,_importdeclarationsImoduleTypes
             ,_importdeclarationsImoduleValues
             ,_importdeclarationsImodules
             ,_importdeclarationsIres
             ,_importdeclarationsIself
             ) =
                (importdeclarations_ (_importdeclarationsOclassname)
                                     (_importdeclarationsOconstructors_collect)
                                     (_importdeclarationsOconstructors_dist)
                                     (_importdeclarationsOcurrentModule)
                                     (_importdeclarationsOimportedModule)
                                     (_importdeclarationsOinstancename)
                                     (_importdeclarationsOknownKinds)
                                     (_importdeclarationsOknownKinds_collect)
                                     (_importdeclarationsOknownTypes)
                                     (_importdeclarationsOknownTypes_collect)
                                     (_importdeclarationsOknownValues)
                                     (_importdeclarationsOknownValues_collect)
                                     (_importdeclarationsOlabels_collect)
                                     (_importdeclarationsOlabels_dist)
                                     (_importdeclarationsOlocal)
                                     (_importdeclarationsOmethods_collect)
                                     (_importdeclarationsOmethods_dist)
                                     (_importdeclarationsOmoduleTypes)
                                     (_importdeclarationsOmoduleValues)
                                     (_importdeclarationsOnameType)
                                     (_importdeclarationsOtoplevel))
            ( _declarationsIconstructors_collect,_declarationsIknownKinds_collect,_declarationsIknownTypes_collect,_declarationsIknownValues_collect,_declarationsIlabels_collect,_declarationsImethods_collect,_declarationsImoduleTypes,_declarationsImoduleValues,_declarationsImodules,_declarationsIres,_declarationsIself) =
                (declarations_ (_declarationsOclassname)
                               (_declarationsOconstructors_collect)
                               (_declarationsOconstructors_dist)
                               (_declarationsOcurrentModule)
                               (_declarationsOimportedModule)
                               (_declarationsOinstancename)
                               (_declarationsOknownGenerics)
                               (_declarationsOknownKinds)
                               (_declarationsOknownKinds_collect)
                               (_declarationsOknownTypes)
                               (_declarationsOknownTypes_collect)
                               (_declarationsOknownValues)
                               (_declarationsOknownValues_collect)
                               (_declarationsOlabels_collect)
                               (_declarationsOlabels_dist)
                               (_declarationsOlocal)
                               (_declarationsOmethods_collect)
                               (_declarationsOmethods_dist)
                               (_declarationsOmoduleTypes)
                               (_declarationsOmoduleValues)
                               (_declarationsOnameType)
                               (_declarationsOtoplevel))
            -- "NameReplace.lag"(line 417, column 9)
            (_mapping@_) =
                [Mapping "imported values" _importdeclarationsIknownValues_collect
                ,Mapping "imported types"  _importdeclarationsIknownTypes_collect
                ,Mapping "methods"         _lhsImethods_dist
                ,Mapping "constructors"    _lhsIconstructors_dist
                ,Mapping "labels"          _lhsIlabels_dist
                ]
            -- "NameReplace.lag"(line 416, column 9)
            (_lhsOres@_) =
                _importdeclarationsIres ++ _mapping ++ _declarationsIres
            -- "./Names.inc.lag"(line 916, column 9)
            (_lhsOknownTypes_collect@_) =
                mergeImports
                  _importdeclarationsIknownTypes_collect
                  _declarationsIknownTypes_collect
            -- "./Names.inc.lag"(line 913, column 9)
            (_lhsOknownValues_collect@_) =
                mergeImports
                  _importdeclarationsIknownValues_collect
                  _declarationsIknownValues_collect
            -- "./Names.inc.lag"(line 912, column 9)
            (_declarationsOknownKinds_collect@_) =
                emptyFM
            -- "./Names.inc.lag"(line 911, column 9)
            (_importdeclarationsOknownKinds_collect@_) =
                emptyFM
            -- "./Names.inc.lag"(line 910, column 9)
            (_declarationsOknownTypes_collect@_) =
                emptyFM
            -- "./Names.inc.lag"(line 909, column 9)
            (_importdeclarationsOknownTypes_collect@_) =
                emptyFM
            -- "./Names.inc.lag"(line 908, column 9)
            (_declarationsOknownValues_collect@_) =
                emptyFM
            -- "./Names.inc.lag"(line 907, column 9)
            (_importdeclarationsOknownValues_collect@_) =
                emptyFM
            -- use rule
            (_lhsOhiddenEntities@_) =
                _importdeclarationsIhiddenEntities
            -- use rule
            (_lhsOimportedEntities@_) =
                _importdeclarationsIimportedEntities
            -- use rule
            (_lhsOmodules@_) =
                _importdeclarationsImodules `Set.union` _declarationsImodules
            -- self rule
            (_self@_) =
                Body_Body _rangeIself _importdeclarationsIself _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _declarationsIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _declarationsIknownKinds_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _declarationsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _declarationsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _declarationsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _declarationsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_importdeclarationsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_importdeclarationsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_importdeclarationsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_importdeclarationsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_importdeclarationsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_importdeclarationsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_importdeclarationsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_importdeclarationsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_importdeclarationsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_importdeclarationsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_importdeclarationsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_importdeclarationsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_importdeclarationsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_importdeclarationsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_importdeclarationsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_importdeclarationsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_importdeclarationsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_importdeclarationsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_declarationsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_declarationsOconstructors_collect@_) =
                _importdeclarationsIconstructors_collect
            -- copy rule (down)
            (_declarationsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_declarationsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_declarationsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_declarationsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_declarationsOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_declarationsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_declarationsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_declarationsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_declarationsOlabels_collect@_) =
                _importdeclarationsIlabels_collect
            -- copy rule (down)
            (_declarationsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_declarationsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_declarationsOmethods_collect@_) =
                _importdeclarationsImethods_collect
            -- copy rule (down)
            (_declarationsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_declarationsOmoduleTypes@_) =
                _importdeclarationsImoduleTypes
            -- copy rule (chain)
            (_declarationsOmoduleValues@_) =
                _importdeclarationsImoduleValues
            -- copy rule (down)
            (_declarationsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_declarationsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOhiddenEntities,_lhsOimportedEntities,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- Constructor -------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      constructors         : Names
      labels               : Names
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for Constructor.Constructor:
      self

-}
{-
   local variables for Constructor.Infix:
      self

-}
{-
   local variables for Constructor.Record:
      self

-}
-- semantic domain
type T_Constructor = (Maybe Name) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Strings) ->
                     (Bool) ->
                     (Maybe Name) ->
                     (FMap Name [Name]) ->
                     (FMap Name [Name]) ->
                     (FMap Name [Name]) ->
                     (FMap Name [Name]) ->
                     (FMap Name [Name]) ->
                     (FMap Name [Name]) ->
                     (FMap Name [Name]) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Bool) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (FMap ModuleName [Name]) ->
                     (FMap ModuleName [Name]) ->
                     (NameType) ->
                     (Bool) ->
                     ( (Names),(FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(Names),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(Constructor))
-- cata
sem_Constructor :: (Constructor) ->
                   (T_Constructor)
sem_Constructor ((Constructor_Constructor (_range) (_constructor) (_types))) =
    (sem_Constructor_Constructor ((sem_Range (_range))) ((sem_Name (_constructor))) ((sem_AnnotatedTypes (_types))))
sem_Constructor ((Constructor_Infix (_range) (_leftType) (_constructorOperator) (_rightType))) =
    (sem_Constructor_Infix ((sem_Range (_range))) ((sem_AnnotatedType (_leftType))) ((sem_Name (_constructorOperator))) ((sem_AnnotatedType (_rightType))))
sem_Constructor ((Constructor_Record (_range) (_constructor) (_fieldDeclarations))) =
    (sem_Constructor_Record ((sem_Range (_range))) ((sem_Name (_constructor))) ((sem_FieldDeclarations (_fieldDeclarations))))
sem_Constructor_Constructor :: (T_Range) ->
                               (T_Name) ->
                               (T_AnnotatedTypes) ->
                               (T_Constructor)
sem_Constructor_Constructor (range_) (constructor_) (types_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors :: (Names)
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels :: (Names)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Constructor)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _constructorIconstructors_collect :: (FMap Name Names)
            _constructorIentityName :: (Name)
            _constructorIfullName :: (Name)
            _constructorIknownKinds_collect :: (FMap Name [Name])
            _constructorIknownTypes_collect :: (FMap Name [Name])
            _constructorIknownValues_collect :: (FMap Name [Name])
            _constructorIlabels_collect :: (FMap Name Names)
            _constructorImethods_collect :: (FMap Name Names)
            _constructorImoduleTypes :: (FMap ModuleName [Name])
            _constructorImoduleValues :: (FMap ModuleName [Name])
            _constructorImodules :: (Set.Set Strings)
            _constructorIoriginalSelf :: (Name)
            _constructorIres :: ([ResolveResult])
            _constructorIself :: (Name)
            _constructorOclassname :: (Maybe Name)
            _constructorOconstructors_collect :: (FMap Name Names)
            _constructorOconstructors_dist :: (FMap Name Names)
            _constructorOcurrentModule :: (Strings)
            _constructorOimportedModule :: (Bool)
            _constructorOinstancename :: (Maybe Name)
            _constructorOknownKinds :: (FMap Name [Name])
            _constructorOknownKinds_collect :: (FMap Name [Name])
            _constructorOknownTypes :: (FMap Name [Name])
            _constructorOknownTypes_collect :: (FMap Name [Name])
            _constructorOknownValues :: (FMap Name [Name])
            _constructorOknownValues_collect :: (FMap Name [Name])
            _constructorOlabels_collect :: (FMap Name Names)
            _constructorOlabels_dist :: (FMap Name Names)
            _constructorOlocal :: (Bool)
            _constructorOmethods_collect :: (FMap Name Names)
            _constructorOmethods_dist :: (FMap Name Names)
            _constructorOmoduleTypes :: (FMap ModuleName [Name])
            _constructorOmoduleValues :: (FMap ModuleName [Name])
            _constructorOnameType :: (NameType)
            _constructorOtoplevel :: (Bool)
            _typesIconstructors_collect :: (FMap Name Names)
            _typesIknownKinds_collect :: (FMap Name [Name])
            _typesIknownTypes_collect :: (FMap Name [Name])
            _typesIknownValues_collect :: (FMap Name [Name])
            _typesIlabels_collect :: (FMap Name Names)
            _typesImethods_collect :: (FMap Name Names)
            _typesImoduleTypes :: (FMap ModuleName [Name])
            _typesImoduleValues :: (FMap ModuleName [Name])
            _typesImodules :: (Set.Set Strings)
            _typesIres :: ([ResolveResult])
            _typesIself :: (AnnotatedTypes)
            _typesOclassname :: (Maybe Name)
            _typesOconstructors_collect :: (FMap Name Names)
            _typesOconstructors_dist :: (FMap Name Names)
            _typesOcurrentModule :: (Strings)
            _typesOimportedModule :: (Bool)
            _typesOinstancename :: (Maybe Name)
            _typesOknownGenerics :: (FMap Name [Name])
            _typesOknownKinds :: (FMap Name [Name])
            _typesOknownKinds_collect :: (FMap Name [Name])
            _typesOknownTypes :: (FMap Name [Name])
            _typesOknownTypes_collect :: (FMap Name [Name])
            _typesOknownValues :: (FMap Name [Name])
            _typesOknownValues_collect :: (FMap Name [Name])
            _typesOlabels_collect :: (FMap Name Names)
            _typesOlabels_dist :: (FMap Name Names)
            _typesOlocal :: (Bool)
            _typesOmethods_collect :: (FMap Name Names)
            _typesOmethods_dist :: (FMap Name Names)
            _typesOmoduleTypes :: (FMap ModuleName [Name])
            _typesOmoduleValues :: (FMap ModuleName [Name])
            _typesOnameType :: (NameType)
            _typesOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _constructorIconstructors_collect,_constructorIentityName,_constructorIfullName,_constructorIknownKinds_collect,_constructorIknownTypes_collect,_constructorIknownValues_collect,_constructorIlabels_collect,_constructorImethods_collect,_constructorImoduleTypes,_constructorImoduleValues,_constructorImodules,_constructorIoriginalSelf,_constructorIres,_constructorIself) =
                (constructor_ (_constructorOclassname)
                              (_constructorOconstructors_collect)
                              (_constructorOconstructors_dist)
                              (_constructorOcurrentModule)
                              (_constructorOimportedModule)
                              (_constructorOinstancename)
                              (_constructorOknownKinds)
                              (_constructorOknownKinds_collect)
                              (_constructorOknownTypes)
                              (_constructorOknownTypes_collect)
                              (_constructorOknownValues)
                              (_constructorOknownValues_collect)
                              (_constructorOlabels_collect)
                              (_constructorOlabels_dist)
                              (_constructorOlocal)
                              (_constructorOmethods_collect)
                              (_constructorOmethods_dist)
                              (_constructorOmoduleTypes)
                              (_constructorOmoduleValues)
                              (_constructorOnameType)
                              (_constructorOtoplevel))
            ( _typesIconstructors_collect,_typesIknownKinds_collect,_typesIknownTypes_collect,_typesIknownValues_collect,_typesIlabels_collect,_typesImethods_collect,_typesImoduleTypes,_typesImoduleValues,_typesImodules,_typesIres,_typesIself) =
                (types_ (_typesOclassname)
                        (_typesOconstructors_collect)
                        (_typesOconstructors_dist)
                        (_typesOcurrentModule)
                        (_typesOimportedModule)
                        (_typesOinstancename)
                        (_typesOknownGenerics)
                        (_typesOknownKinds)
                        (_typesOknownKinds_collect)
                        (_typesOknownTypes)
                        (_typesOknownTypes_collect)
                        (_typesOknownValues)
                        (_typesOknownValues_collect)
                        (_typesOlabels_collect)
                        (_typesOlabels_dist)
                        (_typesOlocal)
                        (_typesOmethods_collect)
                        (_typesOmethods_dist)
                        (_typesOmoduleTypes)
                        (_typesOmoduleValues)
                        (_typesOnameType)
                        (_typesOtoplevel))
            -- "./NameTypes.inc.lag"(line 231, column 9)
            (_constructorOnameType@_) =
                Def_Val
            -- "./ModuleInformation.inc.lag"(line 360, column 9)
            (_lhsOconstructors@_) =
                [_constructorIself]
            -- use rule
            (_lhsOlabels@_) =
                []
            -- use rule
            (_lhsOmodules@_) =
                _constructorImodules `Set.union` _typesImodules
            -- use rule
            (_lhsOres@_) =
                _constructorIres ++ _typesIres
            -- self rule
            (_self@_) =
                Constructor_Constructor _rangeIself _constructorIself _typesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typesIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _typesIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _typesIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _typesIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typesIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typesImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _typesImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _typesImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_constructorOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_constructorOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_constructorOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_constructorOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_constructorOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_constructorOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_constructorOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_constructorOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_constructorOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_constructorOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_constructorOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_constructorOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_constructorOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_constructorOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_constructorOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_constructorOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_constructorOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_constructorOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_constructorOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_constructorOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typesOconstructors_collect@_) =
                _constructorIconstructors_collect
            -- copy rule (down)
            (_typesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typesOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_typesOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_typesOknownKinds_collect@_) =
                _constructorIknownKinds_collect
            -- copy rule (down)
            (_typesOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_typesOknownTypes_collect@_) =
                _constructorIknownTypes_collect
            -- copy rule (down)
            (_typesOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_typesOknownValues_collect@_) =
                _constructorIknownValues_collect
            -- copy rule (chain)
            (_typesOlabels_collect@_) =
                _constructorIlabels_collect
            -- copy rule (down)
            (_typesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typesOmethods_collect@_) =
                _constructorImethods_collect
            -- copy rule (down)
            (_typesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_typesOmoduleTypes@_) =
                _constructorImoduleTypes
            -- copy rule (chain)
            (_typesOmoduleValues@_) =
                _constructorImoduleValues
            -- copy rule (down)
            (_typesOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_typesOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors,_lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Constructor_Infix :: (T_Range) ->
                         (T_AnnotatedType) ->
                         (T_Name) ->
                         (T_AnnotatedType) ->
                         (T_Constructor)
sem_Constructor_Infix (range_) (leftType_) (constructorOperator_) (rightType_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors :: (Names)
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels :: (Names)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Constructor)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _leftTypeIconstructors_collect :: (FMap Name Names)
            _leftTypeIknownKinds_collect :: (FMap Name [Name])
            _leftTypeIknownTypes_collect :: (FMap Name [Name])
            _leftTypeIknownValues_collect :: (FMap Name [Name])
            _leftTypeIlabels_collect :: (FMap Name Names)
            _leftTypeImethods_collect :: (FMap Name Names)
            _leftTypeImoduleTypes :: (FMap ModuleName [Name])
            _leftTypeImoduleValues :: (FMap ModuleName [Name])
            _leftTypeImodules :: (Set.Set Strings)
            _leftTypeIres :: ([ResolveResult])
            _leftTypeIself :: (AnnotatedType)
            _leftTypeOclassname :: (Maybe Name)
            _leftTypeOconstructors_collect :: (FMap Name Names)
            _leftTypeOconstructors_dist :: (FMap Name Names)
            _leftTypeOcurrentModule :: (Strings)
            _leftTypeOimportedModule :: (Bool)
            _leftTypeOinstancename :: (Maybe Name)
            _leftTypeOknownGenerics :: (FMap Name [Name])
            _leftTypeOknownKinds :: (FMap Name [Name])
            _leftTypeOknownKinds_collect :: (FMap Name [Name])
            _leftTypeOknownTypes :: (FMap Name [Name])
            _leftTypeOknownTypes_collect :: (FMap Name [Name])
            _leftTypeOknownValues :: (FMap Name [Name])
            _leftTypeOknownValues_collect :: (FMap Name [Name])
            _leftTypeOlabels_collect :: (FMap Name Names)
            _leftTypeOlabels_dist :: (FMap Name Names)
            _leftTypeOlocal :: (Bool)
            _leftTypeOmethods_collect :: (FMap Name Names)
            _leftTypeOmethods_dist :: (FMap Name Names)
            _leftTypeOmoduleTypes :: (FMap ModuleName [Name])
            _leftTypeOmoduleValues :: (FMap ModuleName [Name])
            _leftTypeOnameType :: (NameType)
            _leftTypeOtoplevel :: (Bool)
            _constructorOperatorIconstructors_collect :: (FMap Name Names)
            _constructorOperatorIentityName :: (Name)
            _constructorOperatorIfullName :: (Name)
            _constructorOperatorIknownKinds_collect :: (FMap Name [Name])
            _constructorOperatorIknownTypes_collect :: (FMap Name [Name])
            _constructorOperatorIknownValues_collect :: (FMap Name [Name])
            _constructorOperatorIlabels_collect :: (FMap Name Names)
            _constructorOperatorImethods_collect :: (FMap Name Names)
            _constructorOperatorImoduleTypes :: (FMap ModuleName [Name])
            _constructorOperatorImoduleValues :: (FMap ModuleName [Name])
            _constructorOperatorImodules :: (Set.Set Strings)
            _constructorOperatorIoriginalSelf :: (Name)
            _constructorOperatorIres :: ([ResolveResult])
            _constructorOperatorIself :: (Name)
            _constructorOperatorOclassname :: (Maybe Name)
            _constructorOperatorOconstructors_collect :: (FMap Name Names)
            _constructorOperatorOconstructors_dist :: (FMap Name Names)
            _constructorOperatorOcurrentModule :: (Strings)
            _constructorOperatorOimportedModule :: (Bool)
            _constructorOperatorOinstancename :: (Maybe Name)
            _constructorOperatorOknownKinds :: (FMap Name [Name])
            _constructorOperatorOknownKinds_collect :: (FMap Name [Name])
            _constructorOperatorOknownTypes :: (FMap Name [Name])
            _constructorOperatorOknownTypes_collect :: (FMap Name [Name])
            _constructorOperatorOknownValues :: (FMap Name [Name])
            _constructorOperatorOknownValues_collect :: (FMap Name [Name])
            _constructorOperatorOlabels_collect :: (FMap Name Names)
            _constructorOperatorOlabels_dist :: (FMap Name Names)
            _constructorOperatorOlocal :: (Bool)
            _constructorOperatorOmethods_collect :: (FMap Name Names)
            _constructorOperatorOmethods_dist :: (FMap Name Names)
            _constructorOperatorOmoduleTypes :: (FMap ModuleName [Name])
            _constructorOperatorOmoduleValues :: (FMap ModuleName [Name])
            _constructorOperatorOnameType :: (NameType)
            _constructorOperatorOtoplevel :: (Bool)
            _rightTypeIconstructors_collect :: (FMap Name Names)
            _rightTypeIknownKinds_collect :: (FMap Name [Name])
            _rightTypeIknownTypes_collect :: (FMap Name [Name])
            _rightTypeIknownValues_collect :: (FMap Name [Name])
            _rightTypeIlabels_collect :: (FMap Name Names)
            _rightTypeImethods_collect :: (FMap Name Names)
            _rightTypeImoduleTypes :: (FMap ModuleName [Name])
            _rightTypeImoduleValues :: (FMap ModuleName [Name])
            _rightTypeImodules :: (Set.Set Strings)
            _rightTypeIres :: ([ResolveResult])
            _rightTypeIself :: (AnnotatedType)
            _rightTypeOclassname :: (Maybe Name)
            _rightTypeOconstructors_collect :: (FMap Name Names)
            _rightTypeOconstructors_dist :: (FMap Name Names)
            _rightTypeOcurrentModule :: (Strings)
            _rightTypeOimportedModule :: (Bool)
            _rightTypeOinstancename :: (Maybe Name)
            _rightTypeOknownGenerics :: (FMap Name [Name])
            _rightTypeOknownKinds :: (FMap Name [Name])
            _rightTypeOknownKinds_collect :: (FMap Name [Name])
            _rightTypeOknownTypes :: (FMap Name [Name])
            _rightTypeOknownTypes_collect :: (FMap Name [Name])
            _rightTypeOknownValues :: (FMap Name [Name])
            _rightTypeOknownValues_collect :: (FMap Name [Name])
            _rightTypeOlabels_collect :: (FMap Name Names)
            _rightTypeOlabels_dist :: (FMap Name Names)
            _rightTypeOlocal :: (Bool)
            _rightTypeOmethods_collect :: (FMap Name Names)
            _rightTypeOmethods_dist :: (FMap Name Names)
            _rightTypeOmoduleTypes :: (FMap ModuleName [Name])
            _rightTypeOmoduleValues :: (FMap ModuleName [Name])
            _rightTypeOnameType :: (NameType)
            _rightTypeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _leftTypeIconstructors_collect,_leftTypeIknownKinds_collect,_leftTypeIknownTypes_collect,_leftTypeIknownValues_collect,_leftTypeIlabels_collect,_leftTypeImethods_collect,_leftTypeImoduleTypes,_leftTypeImoduleValues,_leftTypeImodules,_leftTypeIres,_leftTypeIself) =
                (leftType_ (_leftTypeOclassname)
                           (_leftTypeOconstructors_collect)
                           (_leftTypeOconstructors_dist)
                           (_leftTypeOcurrentModule)
                           (_leftTypeOimportedModule)
                           (_leftTypeOinstancename)
                           (_leftTypeOknownGenerics)
                           (_leftTypeOknownKinds)
                           (_leftTypeOknownKinds_collect)
                           (_leftTypeOknownTypes)
                           (_leftTypeOknownTypes_collect)
                           (_leftTypeOknownValues)
                           (_leftTypeOknownValues_collect)
                           (_leftTypeOlabels_collect)
                           (_leftTypeOlabels_dist)
                           (_leftTypeOlocal)
                           (_leftTypeOmethods_collect)
                           (_leftTypeOmethods_dist)
                           (_leftTypeOmoduleTypes)
                           (_leftTypeOmoduleValues)
                           (_leftTypeOnameType)
                           (_leftTypeOtoplevel))
            ( _constructorOperatorIconstructors_collect
             ,_constructorOperatorIentityName
             ,_constructorOperatorIfullName
             ,_constructorOperatorIknownKinds_collect
             ,_constructorOperatorIknownTypes_collect
             ,_constructorOperatorIknownValues_collect
             ,_constructorOperatorIlabels_collect
             ,_constructorOperatorImethods_collect
             ,_constructorOperatorImoduleTypes
             ,_constructorOperatorImoduleValues
             ,_constructorOperatorImodules
             ,_constructorOperatorIoriginalSelf
             ,_constructorOperatorIres
             ,_constructorOperatorIself
             ) =
                (constructorOperator_ (_constructorOperatorOclassname)
                                      (_constructorOperatorOconstructors_collect)
                                      (_constructorOperatorOconstructors_dist)
                                      (_constructorOperatorOcurrentModule)
                                      (_constructorOperatorOimportedModule)
                                      (_constructorOperatorOinstancename)
                                      (_constructorOperatorOknownKinds)
                                      (_constructorOperatorOknownKinds_collect)
                                      (_constructorOperatorOknownTypes)
                                      (_constructorOperatorOknownTypes_collect)
                                      (_constructorOperatorOknownValues)
                                      (_constructorOperatorOknownValues_collect)
                                      (_constructorOperatorOlabels_collect)
                                      (_constructorOperatorOlabels_dist)
                                      (_constructorOperatorOlocal)
                                      (_constructorOperatorOmethods_collect)
                                      (_constructorOperatorOmethods_dist)
                                      (_constructorOperatorOmoduleTypes)
                                      (_constructorOperatorOmoduleValues)
                                      (_constructorOperatorOnameType)
                                      (_constructorOperatorOtoplevel))
            ( _rightTypeIconstructors_collect,_rightTypeIknownKinds_collect,_rightTypeIknownTypes_collect,_rightTypeIknownValues_collect,_rightTypeIlabels_collect,_rightTypeImethods_collect,_rightTypeImoduleTypes,_rightTypeImoduleValues,_rightTypeImodules,_rightTypeIres,_rightTypeIself) =
                (rightType_ (_rightTypeOclassname)
                            (_rightTypeOconstructors_collect)
                            (_rightTypeOconstructors_dist)
                            (_rightTypeOcurrentModule)
                            (_rightTypeOimportedModule)
                            (_rightTypeOinstancename)
                            (_rightTypeOknownGenerics)
                            (_rightTypeOknownKinds)
                            (_rightTypeOknownKinds_collect)
                            (_rightTypeOknownTypes)
                            (_rightTypeOknownTypes_collect)
                            (_rightTypeOknownValues)
                            (_rightTypeOknownValues_collect)
                            (_rightTypeOlabels_collect)
                            (_rightTypeOlabels_dist)
                            (_rightTypeOlocal)
                            (_rightTypeOmethods_collect)
                            (_rightTypeOmethods_dist)
                            (_rightTypeOmoduleTypes)
                            (_rightTypeOmoduleValues)
                            (_rightTypeOnameType)
                            (_rightTypeOtoplevel))
            -- "./NameTypes.inc.lag"(line 233, column 9)
            (_constructorOperatorOnameType@_) =
                Def_Val
            -- "./ModuleInformation.inc.lag"(line 362, column 9)
            (_lhsOconstructors@_) =
                [_constructorOperatorIself]
            -- use rule
            (_lhsOlabels@_) =
                []
            -- use rule
            (_lhsOmodules@_) =
                _leftTypeImodules `Set.union` _constructorOperatorImodules `Set.union` _rightTypeImodules
            -- use rule
            (_lhsOres@_) =
                _leftTypeIres ++ _constructorOperatorIres ++ _rightTypeIres
            -- self rule
            (_self@_) =
                Constructor_Infix _rangeIself _leftTypeIself _constructorOperatorIself _rightTypeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _rightTypeIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _rightTypeIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _rightTypeIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _rightTypeIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _rightTypeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _rightTypeImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _rightTypeImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _rightTypeImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_leftTypeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_leftTypeOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_leftTypeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_leftTypeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_leftTypeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_leftTypeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_leftTypeOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_leftTypeOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_leftTypeOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_leftTypeOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_leftTypeOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_leftTypeOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_leftTypeOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_leftTypeOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_leftTypeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_leftTypeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_leftTypeOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_leftTypeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_leftTypeOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_leftTypeOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_leftTypeOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_leftTypeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_constructorOperatorOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_constructorOperatorOconstructors_collect@_) =
                _leftTypeIconstructors_collect
            -- copy rule (down)
            (_constructorOperatorOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_constructorOperatorOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_constructorOperatorOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_constructorOperatorOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_constructorOperatorOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_constructorOperatorOknownKinds_collect@_) =
                _leftTypeIknownKinds_collect
            -- copy rule (down)
            (_constructorOperatorOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_constructorOperatorOknownTypes_collect@_) =
                _leftTypeIknownTypes_collect
            -- copy rule (down)
            (_constructorOperatorOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_constructorOperatorOknownValues_collect@_) =
                _leftTypeIknownValues_collect
            -- copy rule (chain)
            (_constructorOperatorOlabels_collect@_) =
                _leftTypeIlabels_collect
            -- copy rule (down)
            (_constructorOperatorOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_constructorOperatorOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_constructorOperatorOmethods_collect@_) =
                _leftTypeImethods_collect
            -- copy rule (down)
            (_constructorOperatorOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_constructorOperatorOmoduleTypes@_) =
                _leftTypeImoduleTypes
            -- copy rule (chain)
            (_constructorOperatorOmoduleValues@_) =
                _leftTypeImoduleValues
            -- copy rule (down)
            (_constructorOperatorOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_rightTypeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_rightTypeOconstructors_collect@_) =
                _constructorOperatorIconstructors_collect
            -- copy rule (down)
            (_rightTypeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_rightTypeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rightTypeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rightTypeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rightTypeOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_rightTypeOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_rightTypeOknownKinds_collect@_) =
                _constructorOperatorIknownKinds_collect
            -- copy rule (down)
            (_rightTypeOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_rightTypeOknownTypes_collect@_) =
                _constructorOperatorIknownTypes_collect
            -- copy rule (down)
            (_rightTypeOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_rightTypeOknownValues_collect@_) =
                _constructorOperatorIknownValues_collect
            -- copy rule (chain)
            (_rightTypeOlabels_collect@_) =
                _constructorOperatorIlabels_collect
            -- copy rule (down)
            (_rightTypeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_rightTypeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_rightTypeOmethods_collect@_) =
                _constructorOperatorImethods_collect
            -- copy rule (down)
            (_rightTypeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_rightTypeOmoduleTypes@_) =
                _constructorOperatorImoduleTypes
            -- copy rule (chain)
            (_rightTypeOmoduleValues@_) =
                _constructorOperatorImoduleValues
            -- copy rule (down)
            (_rightTypeOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_rightTypeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors,_lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Constructor_Record :: (T_Range) ->
                          (T_Name) ->
                          (T_FieldDeclarations) ->
                          (T_Constructor)
sem_Constructor_Record (range_) (constructor_) (fieldDeclarations_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors :: (Names)
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels :: (Names)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Constructor)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _constructorIconstructors_collect :: (FMap Name Names)
            _constructorIentityName :: (Name)
            _constructorIfullName :: (Name)
            _constructorIknownKinds_collect :: (FMap Name [Name])
            _constructorIknownTypes_collect :: (FMap Name [Name])
            _constructorIknownValues_collect :: (FMap Name [Name])
            _constructorIlabels_collect :: (FMap Name Names)
            _constructorImethods_collect :: (FMap Name Names)
            _constructorImoduleTypes :: (FMap ModuleName [Name])
            _constructorImoduleValues :: (FMap ModuleName [Name])
            _constructorImodules :: (Set.Set Strings)
            _constructorIoriginalSelf :: (Name)
            _constructorIres :: ([ResolveResult])
            _constructorIself :: (Name)
            _constructorOclassname :: (Maybe Name)
            _constructorOconstructors_collect :: (FMap Name Names)
            _constructorOconstructors_dist :: (FMap Name Names)
            _constructorOcurrentModule :: (Strings)
            _constructorOimportedModule :: (Bool)
            _constructorOinstancename :: (Maybe Name)
            _constructorOknownKinds :: (FMap Name [Name])
            _constructorOknownKinds_collect :: (FMap Name [Name])
            _constructorOknownTypes :: (FMap Name [Name])
            _constructorOknownTypes_collect :: (FMap Name [Name])
            _constructorOknownValues :: (FMap Name [Name])
            _constructorOknownValues_collect :: (FMap Name [Name])
            _constructorOlabels_collect :: (FMap Name Names)
            _constructorOlabels_dist :: (FMap Name Names)
            _constructorOlocal :: (Bool)
            _constructorOmethods_collect :: (FMap Name Names)
            _constructorOmethods_dist :: (FMap Name Names)
            _constructorOmoduleTypes :: (FMap ModuleName [Name])
            _constructorOmoduleValues :: (FMap ModuleName [Name])
            _constructorOnameType :: (NameType)
            _constructorOtoplevel :: (Bool)
            _fieldDeclarationsIconstructors :: (Names)
            _fieldDeclarationsIconstructors_collect :: (FMap Name Names)
            _fieldDeclarationsIknownKinds_collect :: (FMap Name [Name])
            _fieldDeclarationsIknownTypes_collect :: (FMap Name [Name])
            _fieldDeclarationsIknownValues_collect :: (FMap Name [Name])
            _fieldDeclarationsIlabels :: (Names)
            _fieldDeclarationsIlabels_collect :: (FMap Name Names)
            _fieldDeclarationsImethods_collect :: (FMap Name Names)
            _fieldDeclarationsImoduleTypes :: (FMap ModuleName [Name])
            _fieldDeclarationsImoduleValues :: (FMap ModuleName [Name])
            _fieldDeclarationsImodules :: (Set.Set Strings)
            _fieldDeclarationsIres :: ([ResolveResult])
            _fieldDeclarationsIself :: (FieldDeclarations)
            _fieldDeclarationsOclassname :: (Maybe Name)
            _fieldDeclarationsOconstructors_collect :: (FMap Name Names)
            _fieldDeclarationsOconstructors_dist :: (FMap Name Names)
            _fieldDeclarationsOcurrentModule :: (Strings)
            _fieldDeclarationsOimportedModule :: (Bool)
            _fieldDeclarationsOinstancename :: (Maybe Name)
            _fieldDeclarationsOknownGenerics :: (FMap Name [Name])
            _fieldDeclarationsOknownKinds :: (FMap Name [Name])
            _fieldDeclarationsOknownKinds_collect :: (FMap Name [Name])
            _fieldDeclarationsOknownTypes :: (FMap Name [Name])
            _fieldDeclarationsOknownTypes_collect :: (FMap Name [Name])
            _fieldDeclarationsOknownValues :: (FMap Name [Name])
            _fieldDeclarationsOknownValues_collect :: (FMap Name [Name])
            _fieldDeclarationsOlabels_collect :: (FMap Name Names)
            _fieldDeclarationsOlabels_dist :: (FMap Name Names)
            _fieldDeclarationsOlocal :: (Bool)
            _fieldDeclarationsOmethods_collect :: (FMap Name Names)
            _fieldDeclarationsOmethods_dist :: (FMap Name Names)
            _fieldDeclarationsOmoduleTypes :: (FMap ModuleName [Name])
            _fieldDeclarationsOmoduleValues :: (FMap ModuleName [Name])
            _fieldDeclarationsOnameType :: (NameType)
            _fieldDeclarationsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _constructorIconstructors_collect,_constructorIentityName,_constructorIfullName,_constructorIknownKinds_collect,_constructorIknownTypes_collect,_constructorIknownValues_collect,_constructorIlabels_collect,_constructorImethods_collect,_constructorImoduleTypes,_constructorImoduleValues,_constructorImodules,_constructorIoriginalSelf,_constructorIres,_constructorIself) =
                (constructor_ (_constructorOclassname)
                              (_constructorOconstructors_collect)
                              (_constructorOconstructors_dist)
                              (_constructorOcurrentModule)
                              (_constructorOimportedModule)
                              (_constructorOinstancename)
                              (_constructorOknownKinds)
                              (_constructorOknownKinds_collect)
                              (_constructorOknownTypes)
                              (_constructorOknownTypes_collect)
                              (_constructorOknownValues)
                              (_constructorOknownValues_collect)
                              (_constructorOlabels_collect)
                              (_constructorOlabels_dist)
                              (_constructorOlocal)
                              (_constructorOmethods_collect)
                              (_constructorOmethods_dist)
                              (_constructorOmoduleTypes)
                              (_constructorOmoduleValues)
                              (_constructorOnameType)
                              (_constructorOtoplevel))
            ( _fieldDeclarationsIconstructors,_fieldDeclarationsIconstructors_collect,_fieldDeclarationsIknownKinds_collect,_fieldDeclarationsIknownTypes_collect,_fieldDeclarationsIknownValues_collect,_fieldDeclarationsIlabels,_fieldDeclarationsIlabels_collect,_fieldDeclarationsImethods_collect,_fieldDeclarationsImoduleTypes,_fieldDeclarationsImoduleValues,_fieldDeclarationsImodules,_fieldDeclarationsIres,_fieldDeclarationsIself) =
                (fieldDeclarations_ (_fieldDeclarationsOclassname)
                                    (_fieldDeclarationsOconstructors_collect)
                                    (_fieldDeclarationsOconstructors_dist)
                                    (_fieldDeclarationsOcurrentModule)
                                    (_fieldDeclarationsOimportedModule)
                                    (_fieldDeclarationsOinstancename)
                                    (_fieldDeclarationsOknownGenerics)
                                    (_fieldDeclarationsOknownKinds)
                                    (_fieldDeclarationsOknownKinds_collect)
                                    (_fieldDeclarationsOknownTypes)
                                    (_fieldDeclarationsOknownTypes_collect)
                                    (_fieldDeclarationsOknownValues)
                                    (_fieldDeclarationsOknownValues_collect)
                                    (_fieldDeclarationsOlabels_collect)
                                    (_fieldDeclarationsOlabels_dist)
                                    (_fieldDeclarationsOlocal)
                                    (_fieldDeclarationsOmethods_collect)
                                    (_fieldDeclarationsOmethods_dist)
                                    (_fieldDeclarationsOmoduleTypes)
                                    (_fieldDeclarationsOmoduleValues)
                                    (_fieldDeclarationsOnameType)
                                    (_fieldDeclarationsOtoplevel))
            -- "./NameTypes.inc.lag"(line 235, column 9)
            (_constructorOnameType@_) =
                Def_Val
            -- "./ModuleInformation.inc.lag"(line 364, column 9)
            (_lhsOconstructors@_) =
                [_constructorIself]
            -- use rule
            (_lhsOlabels@_) =
                _fieldDeclarationsIlabels
            -- use rule
            (_lhsOmodules@_) =
                _constructorImodules `Set.union` _fieldDeclarationsImodules
            -- use rule
            (_lhsOres@_) =
                _constructorIres ++ _fieldDeclarationsIres
            -- self rule
            (_self@_) =
                Constructor_Record _rangeIself _constructorIself _fieldDeclarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _fieldDeclarationsIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _fieldDeclarationsIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _fieldDeclarationsIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _fieldDeclarationsIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _fieldDeclarationsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _fieldDeclarationsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _fieldDeclarationsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _fieldDeclarationsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_constructorOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_constructorOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_constructorOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_constructorOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_constructorOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_constructorOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_constructorOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_constructorOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_constructorOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_constructorOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_constructorOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_constructorOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_constructorOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_constructorOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_constructorOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_constructorOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_constructorOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_constructorOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_constructorOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_constructorOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_fieldDeclarationsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_fieldDeclarationsOconstructors_collect@_) =
                _constructorIconstructors_collect
            -- copy rule (down)
            (_fieldDeclarationsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_fieldDeclarationsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_fieldDeclarationsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_fieldDeclarationsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_fieldDeclarationsOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_fieldDeclarationsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_fieldDeclarationsOknownKinds_collect@_) =
                _constructorIknownKinds_collect
            -- copy rule (down)
            (_fieldDeclarationsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_fieldDeclarationsOknownTypes_collect@_) =
                _constructorIknownTypes_collect
            -- copy rule (down)
            (_fieldDeclarationsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_fieldDeclarationsOknownValues_collect@_) =
                _constructorIknownValues_collect
            -- copy rule (chain)
            (_fieldDeclarationsOlabels_collect@_) =
                _constructorIlabels_collect
            -- copy rule (down)
            (_fieldDeclarationsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_fieldDeclarationsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_fieldDeclarationsOmethods_collect@_) =
                _constructorImethods_collect
            -- copy rule (down)
            (_fieldDeclarationsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_fieldDeclarationsOmoduleTypes@_) =
                _constructorImoduleTypes
            -- copy rule (chain)
            (_fieldDeclarationsOmoduleValues@_) =
                _constructorImoduleValues
            -- copy rule (down)
            (_fieldDeclarationsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_fieldDeclarationsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors,_lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- Constructors ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      constructors         : Names
      labels               : Names
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for Constructors.Cons:
      self

-}
{-
   local variables for Constructors.Nil:
      self

-}
-- semantic domain
type T_Constructors = (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Strings) ->
                      (Bool) ->
                      (Maybe Name) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (FMap ModuleName [Name]) ->
                      (FMap ModuleName [Name]) ->
                      (NameType) ->
                      (Bool) ->
                      ( (Names),(FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(Names),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(Constructors))
-- cata
sem_Constructors :: (Constructors) ->
                    (T_Constructors)
sem_Constructors (list) =
    (foldr (sem_Constructors_Cons) (sem_Constructors_Nil) ((map sem_Constructor list)))
sem_Constructors_Cons :: (T_Constructor) ->
                         (T_Constructors) ->
                         (T_Constructors)
sem_Constructors_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors :: (Names)
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels :: (Names)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Constructors)
            _hdIconstructors :: (Names)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIknownKinds_collect :: (FMap Name [Name])
            _hdIknownTypes_collect :: (FMap Name [Name])
            _hdIknownValues_collect :: (FMap Name [Name])
            _hdIlabels :: (Names)
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdImoduleTypes :: (FMap ModuleName [Name])
            _hdImoduleValues :: (FMap ModuleName [Name])
            _hdImodules :: (Set.Set Strings)
            _hdIres :: ([ResolveResult])
            _hdIself :: (Constructor)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOknownGenerics :: (FMap Name [Name])
            _hdOknownKinds :: (FMap Name [Name])
            _hdOknownKinds_collect :: (FMap Name [Name])
            _hdOknownTypes :: (FMap Name [Name])
            _hdOknownTypes_collect :: (FMap Name [Name])
            _hdOknownValues :: (FMap Name [Name])
            _hdOknownValues_collect :: (FMap Name [Name])
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmoduleTypes :: (FMap ModuleName [Name])
            _hdOmoduleValues :: (FMap ModuleName [Name])
            _hdOnameType :: (NameType)
            _hdOtoplevel :: (Bool)
            _tlIconstructors :: (Names)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIknownKinds_collect :: (FMap Name [Name])
            _tlIknownTypes_collect :: (FMap Name [Name])
            _tlIknownValues_collect :: (FMap Name [Name])
            _tlIlabels :: (Names)
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlImoduleTypes :: (FMap ModuleName [Name])
            _tlImoduleValues :: (FMap ModuleName [Name])
            _tlImodules :: (Set.Set Strings)
            _tlIres :: ([ResolveResult])
            _tlIself :: (Constructors)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOknownGenerics :: (FMap Name [Name])
            _tlOknownKinds :: (FMap Name [Name])
            _tlOknownKinds_collect :: (FMap Name [Name])
            _tlOknownTypes :: (FMap Name [Name])
            _tlOknownTypes_collect :: (FMap Name [Name])
            _tlOknownValues :: (FMap Name [Name])
            _tlOknownValues_collect :: (FMap Name [Name])
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmoduleTypes :: (FMap ModuleName [Name])
            _tlOmoduleValues :: (FMap ModuleName [Name])
            _tlOnameType :: (NameType)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors,_hdIconstructors_collect,_hdIknownKinds_collect,_hdIknownTypes_collect,_hdIknownValues_collect,_hdIlabels,_hdIlabels_collect,_hdImethods_collect,_hdImoduleTypes,_hdImoduleValues,_hdImodules,_hdIres,_hdIself) =
                (hd_ (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOknownGenerics)
                     (_hdOknownKinds)
                     (_hdOknownKinds_collect)
                     (_hdOknownTypes)
                     (_hdOknownTypes_collect)
                     (_hdOknownValues)
                     (_hdOknownValues_collect)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmoduleTypes)
                     (_hdOmoduleValues)
                     (_hdOnameType)
                     (_hdOtoplevel))
            ( _tlIconstructors,_tlIconstructors_collect,_tlIknownKinds_collect,_tlIknownTypes_collect,_tlIknownValues_collect,_tlIlabels,_tlIlabels_collect,_tlImethods_collect,_tlImoduleTypes,_tlImoduleValues,_tlImodules,_tlIres,_tlIself) =
                (tl_ (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOknownGenerics)
                     (_tlOknownKinds)
                     (_tlOknownKinds_collect)
                     (_tlOknownTypes)
                     (_tlOknownTypes_collect)
                     (_tlOknownValues)
                     (_tlOknownValues_collect)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmoduleTypes)
                     (_tlOmoduleValues)
                     (_tlOnameType)
                     (_tlOtoplevel))
            -- "./Names.inc.lag"(line 623, column 9)
            (_lhsOknownValues_collect@_) =
                _hdIknownValues_collect `mergeFM` _tlIknownValues_collect
            -- "./Names.inc.lag"(line 622, column 9)
            (_tlOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- "./Names.inc.lag"(line 621, column 9)
            (_hdOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- use rule
            (_lhsOconstructors@_) =
                _hdIconstructors ++ _tlIconstructors
            -- use rule
            (_lhsOlabels@_) =
                _hdIlabels `List.union` _tlIlabels
            -- use rule
            (_lhsOmodules@_) =
                _hdImodules `Set.union` _tlImodules
            -- use rule
            (_lhsOres@_) =
                _hdIres ++ _tlIres
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _tlIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _tlIknownTypes_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _tlImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _tlImoduleValues
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_hdOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_hdOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_hdOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_hdOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_hdOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_hdOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_hdOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_tlOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_tlOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_tlOknownKinds_collect@_) =
                _hdIknownKinds_collect
            -- copy rule (down)
            (_tlOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_tlOknownTypes_collect@_) =
                _hdIknownTypes_collect
            -- copy rule (down)
            (_tlOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_tlOmoduleTypes@_) =
                _hdImoduleTypes
            -- copy rule (chain)
            (_tlOmoduleValues@_) =
                _hdImoduleValues
            -- copy rule (down)
            (_tlOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors,_lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Constructors_Nil :: (T_Constructors)
sem_Constructors_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors :: (Names)
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels :: (Names)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Constructors)
            -- use rule
            (_lhsOconstructors@_) =
                []
            -- use rule
            (_lhsOlabels@_) =
                []
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors,_lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- ContextItem -------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for ContextItem.ContextItem:
      self

-}
{-
   local variables for ContextItem.DependencyConstraint:
      self

-}
{-
   local variables for ContextItem.DependencyItem:
      self

-}
-- semantic domain
type T_ContextItem = (Maybe Name) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Strings) ->
                     (Bool) ->
                     (Maybe Name) ->
                     (FMap Name [Name]) ->
                     (FMap Name [Name]) ->
                     (FMap Name [Name]) ->
                     (FMap Name [Name]) ->
                     (FMap Name [Name]) ->
                     (FMap Name [Name]) ->
                     (FMap Name [Name]) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Bool) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (FMap ModuleName [Name]) ->
                     (FMap ModuleName [Name]) ->
                     (NameType) ->
                     (Bool) ->
                     ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(ContextItem))
-- cata
sem_ContextItem :: (ContextItem) ->
                   (T_ContextItem)
sem_ContextItem ((ContextItem_ContextItem (_range) (_name) (_types))) =
    (sem_ContextItem_ContextItem ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Types (_types))))
sem_ContextItem ((ContextItem_DependencyConstraint (_range) (_name) (_typevariable) (_type))) =
    (sem_ContextItem_DependencyConstraint ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Name (_typevariable))) ((sem_Type (_type))))
sem_ContextItem ((ContextItem_DependencyItem (_range) (_name) (_generics) (_parametrics) (_asname))) =
    (sem_ContextItem_DependencyItem ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Names (_generics))) ((sem_Types (_parametrics))) ((sem_MaybeName (_asname))))
sem_ContextItem_ContextItem :: (T_Range) ->
                               (T_Name) ->
                               (T_Types) ->
                               (T_ContextItem)
sem_ContextItem_ContextItem (range_) (name_) (types_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (ContextItem)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _typesIconstructors_collect :: (FMap Name Names)
            _typesIknownKinds_collect :: (FMap Name [Name])
            _typesIknownTypes_collect :: (FMap Name [Name])
            _typesIknownValues_collect :: (FMap Name [Name])
            _typesIlabels_collect :: (FMap Name Names)
            _typesImethods_collect :: (FMap Name Names)
            _typesImoduleTypes :: (FMap ModuleName [Name])
            _typesImoduleValues :: (FMap ModuleName [Name])
            _typesImodules :: (Set.Set Strings)
            _typesIres :: ([ResolveResult])
            _typesIself :: (Types)
            _typesOclassname :: (Maybe Name)
            _typesOconstructors_collect :: (FMap Name Names)
            _typesOconstructors_dist :: (FMap Name Names)
            _typesOcurrentModule :: (Strings)
            _typesOimportedModule :: (Bool)
            _typesOinstancename :: (Maybe Name)
            _typesOknownGenerics :: (FMap Name [Name])
            _typesOknownKinds :: (FMap Name [Name])
            _typesOknownKinds_collect :: (FMap Name [Name])
            _typesOknownTypes :: (FMap Name [Name])
            _typesOknownTypes_collect :: (FMap Name [Name])
            _typesOknownValues :: (FMap Name [Name])
            _typesOknownValues_collect :: (FMap Name [Name])
            _typesOlabels_collect :: (FMap Name Names)
            _typesOlabels_dist :: (FMap Name Names)
            _typesOlocal :: (Bool)
            _typesOmethods_collect :: (FMap Name Names)
            _typesOmethods_dist :: (FMap Name Names)
            _typesOmoduleTypes :: (FMap ModuleName [Name])
            _typesOmoduleValues :: (FMap ModuleName [Name])
            _typesOnameType :: (NameType)
            _typesOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _typesIconstructors_collect,_typesIknownKinds_collect,_typesIknownTypes_collect,_typesIknownValues_collect,_typesIlabels_collect,_typesImethods_collect,_typesImoduleTypes,_typesImoduleValues,_typesImodules,_typesIres,_typesIself) =
                (types_ (_typesOclassname)
                        (_typesOconstructors_collect)
                        (_typesOconstructors_dist)
                        (_typesOcurrentModule)
                        (_typesOimportedModule)
                        (_typesOinstancename)
                        (_typesOknownGenerics)
                        (_typesOknownKinds)
                        (_typesOknownKinds_collect)
                        (_typesOknownTypes)
                        (_typesOknownTypes_collect)
                        (_typesOknownValues)
                        (_typesOknownValues_collect)
                        (_typesOlabels_collect)
                        (_typesOlabels_dist)
                        (_typesOlocal)
                        (_typesOmethods_collect)
                        (_typesOmethods_dist)
                        (_typesOmoduleTypes)
                        (_typesOmoduleValues)
                        (_typesOnameType)
                        (_typesOtoplevel))
            -- "./NameTypes.inc.lag"(line 223, column 9)
            (_nameOnameType@_) =
                ref_Typ
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _typesImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _typesIres
            -- self rule
            (_self@_) =
                ContextItem_ContextItem _rangeIself _nameIself _typesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typesIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _typesIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _typesIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _typesIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typesIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typesImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _typesImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _typesImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typesOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_typesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typesOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_typesOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_typesOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_typesOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_typesOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (down)
            (_typesOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_typesOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_typesOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_typesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typesOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_typesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_typesOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_typesOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_typesOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_typesOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_ContextItem_DependencyConstraint :: (T_Range) ->
                                        (T_Name) ->
                                        (T_Name) ->
                                        (T_Type) ->
                                        (T_ContextItem)
sem_ContextItem_DependencyConstraint (range_) (name_) (typevariable_) (type_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (ContextItem)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _typevariableIconstructors_collect :: (FMap Name Names)
            _typevariableIentityName :: (Name)
            _typevariableIfullName :: (Name)
            _typevariableIknownKinds_collect :: (FMap Name [Name])
            _typevariableIknownTypes_collect :: (FMap Name [Name])
            _typevariableIknownValues_collect :: (FMap Name [Name])
            _typevariableIlabels_collect :: (FMap Name Names)
            _typevariableImethods_collect :: (FMap Name Names)
            _typevariableImoduleTypes :: (FMap ModuleName [Name])
            _typevariableImoduleValues :: (FMap ModuleName [Name])
            _typevariableImodules :: (Set.Set Strings)
            _typevariableIoriginalSelf :: (Name)
            _typevariableIres :: ([ResolveResult])
            _typevariableIself :: (Name)
            _typevariableOclassname :: (Maybe Name)
            _typevariableOconstructors_collect :: (FMap Name Names)
            _typevariableOconstructors_dist :: (FMap Name Names)
            _typevariableOcurrentModule :: (Strings)
            _typevariableOimportedModule :: (Bool)
            _typevariableOinstancename :: (Maybe Name)
            _typevariableOknownKinds :: (FMap Name [Name])
            _typevariableOknownKinds_collect :: (FMap Name [Name])
            _typevariableOknownTypes :: (FMap Name [Name])
            _typevariableOknownTypes_collect :: (FMap Name [Name])
            _typevariableOknownValues :: (FMap Name [Name])
            _typevariableOknownValues_collect :: (FMap Name [Name])
            _typevariableOlabels_collect :: (FMap Name Names)
            _typevariableOlabels_dist :: (FMap Name Names)
            _typevariableOlocal :: (Bool)
            _typevariableOmethods_collect :: (FMap Name Names)
            _typevariableOmethods_dist :: (FMap Name Names)
            _typevariableOmoduleTypes :: (FMap ModuleName [Name])
            _typevariableOmoduleValues :: (FMap ModuleName [Name])
            _typevariableOnameType :: (NameType)
            _typevariableOtoplevel :: (Bool)
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIknownKinds_collect :: (FMap Name [Name])
            _typeIknownTypes_collect :: (FMap Name [Name])
            _typeIknownValues_collect :: (FMap Name [Name])
            _typeIlabels_collect :: (FMap Name Names)
            _typeImethods_collect :: (FMap Name Names)
            _typeImoduleTypes :: (FMap ModuleName [Name])
            _typeImoduleValues :: (FMap ModuleName [Name])
            _typeImodules :: (Set.Set Strings)
            _typeIres :: ([ResolveResult])
            _typeIself :: (Type)
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOimportedModule :: (Bool)
            _typeOinstancename :: (Maybe Name)
            _typeOknownGenerics :: (FMap Name [Name])
            _typeOknownKinds :: (FMap Name [Name])
            _typeOknownKinds_collect :: (FMap Name [Name])
            _typeOknownTypes :: (FMap Name [Name])
            _typeOknownTypes_collect :: (FMap Name [Name])
            _typeOknownValues :: (FMap Name [Name])
            _typeOknownValues_collect :: (FMap Name [Name])
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOmoduleTypes :: (FMap ModuleName [Name])
            _typeOmoduleValues :: (FMap ModuleName [Name])
            _typeOnameType :: (NameType)
            _typeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _typevariableIconstructors_collect,_typevariableIentityName,_typevariableIfullName,_typevariableIknownKinds_collect,_typevariableIknownTypes_collect,_typevariableIknownValues_collect,_typevariableIlabels_collect,_typevariableImethods_collect,_typevariableImoduleTypes,_typevariableImoduleValues,_typevariableImodules,_typevariableIoriginalSelf,_typevariableIres,_typevariableIself) =
                (typevariable_ (_typevariableOclassname)
                               (_typevariableOconstructors_collect)
                               (_typevariableOconstructors_dist)
                               (_typevariableOcurrentModule)
                               (_typevariableOimportedModule)
                               (_typevariableOinstancename)
                               (_typevariableOknownKinds)
                               (_typevariableOknownKinds_collect)
                               (_typevariableOknownTypes)
                               (_typevariableOknownTypes_collect)
                               (_typevariableOknownValues)
                               (_typevariableOknownValues_collect)
                               (_typevariableOlabels_collect)
                               (_typevariableOlabels_dist)
                               (_typevariableOlocal)
                               (_typevariableOmethods_collect)
                               (_typevariableOmethods_dist)
                               (_typevariableOmoduleTypes)
                               (_typevariableOmoduleValues)
                               (_typevariableOnameType)
                               (_typevariableOtoplevel))
            ( _typeIconstructors_collect,_typeIknownKinds_collect,_typeIknownTypes_collect,_typeIknownValues_collect,_typeIlabels_collect,_typeImethods_collect,_typeImoduleTypes,_typeImoduleValues,_typeImodules,_typeIres,_typeIself) =
                (type_ (_typeOclassname)
                       (_typeOconstructors_collect)
                       (_typeOconstructors_dist)
                       (_typeOcurrentModule)
                       (_typeOimportedModule)
                       (_typeOinstancename)
                       (_typeOknownGenerics)
                       (_typeOknownKinds)
                       (_typeOknownKinds_collect)
                       (_typeOknownTypes)
                       (_typeOknownTypes_collect)
                       (_typeOknownValues)
                       (_typeOknownValues_collect)
                       (_typeOlabels_collect)
                       (_typeOlabels_dist)
                       (_typeOlocal)
                       (_typeOmethods_collect)
                       (_typeOmethods_dist)
                       (_typeOmoduleTypes)
                       (_typeOmoduleValues)
                       (_typeOnameType)
                       (_typeOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _typevariableImodules `Set.union` _typeImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _typevariableIres ++ _typeIres
            -- self rule
            (_self@_) =
                ContextItem_DependencyConstraint _rangeIself _nameIself _typevariableIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _typeIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _typeIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _typeIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _typeImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _typeImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typevariableOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typevariableOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_typevariableOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typevariableOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typevariableOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typevariableOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typevariableOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_typevariableOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_typevariableOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_typevariableOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (down)
            (_typevariableOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_typevariableOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_typevariableOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_typevariableOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typevariableOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typevariableOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_typevariableOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_typevariableOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_typevariableOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_typevariableOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_typevariableOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _typevariableIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typeOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_typeOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_typeOknownKinds_collect@_) =
                _typevariableIknownKinds_collect
            -- copy rule (down)
            (_typeOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_typeOknownTypes_collect@_) =
                _typevariableIknownTypes_collect
            -- copy rule (down)
            (_typeOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_typeOknownValues_collect@_) =
                _typevariableIknownValues_collect
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _typevariableIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _typevariableImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_typeOmoduleTypes@_) =
                _typevariableImoduleTypes
            -- copy rule (chain)
            (_typeOmoduleValues@_) =
                _typevariableImoduleValues
            -- copy rule (down)
            (_typeOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_typeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_ContextItem_DependencyItem :: (T_Range) ->
                                  (T_Name) ->
                                  (T_Names) ->
                                  (T_Types) ->
                                  (T_MaybeName) ->
                                  (T_ContextItem)
sem_ContextItem_DependencyItem (range_) (name_) (generics_) (parametrics_) (asname_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (ContextItem)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _genericsIconstructors_collect :: (FMap Name Names)
            _genericsIknownKinds_collect :: (FMap Name [Name])
            _genericsIknownTypes_collect :: (FMap Name [Name])
            _genericsIknownValues_collect :: (FMap Name [Name])
            _genericsIlabels_collect :: (FMap Name Names)
            _genericsImethods_collect :: (FMap Name Names)
            _genericsImoduleTypes :: (FMap ModuleName [Name])
            _genericsImoduleValues :: (FMap ModuleName [Name])
            _genericsImodules :: (Set.Set Strings)
            _genericsIoriginalSelf :: (Names)
            _genericsIres :: ([ResolveResult])
            _genericsIself :: (Names)
            _genericsOclassname :: (Maybe Name)
            _genericsOconstructors_collect :: (FMap Name Names)
            _genericsOconstructors_dist :: (FMap Name Names)
            _genericsOcurrentModule :: (Strings)
            _genericsOimportedModule :: (Bool)
            _genericsOinstancename :: (Maybe Name)
            _genericsOknownKinds :: (FMap Name [Name])
            _genericsOknownKinds_collect :: (FMap Name [Name])
            _genericsOknownTypes :: (FMap Name [Name])
            _genericsOknownTypes_collect :: (FMap Name [Name])
            _genericsOknownValues :: (FMap Name [Name])
            _genericsOknownValues_collect :: (FMap Name [Name])
            _genericsOlabels_collect :: (FMap Name Names)
            _genericsOlabels_dist :: (FMap Name Names)
            _genericsOlocal :: (Bool)
            _genericsOmethods_collect :: (FMap Name Names)
            _genericsOmethods_dist :: (FMap Name Names)
            _genericsOmoduleTypes :: (FMap ModuleName [Name])
            _genericsOmoduleValues :: (FMap ModuleName [Name])
            _genericsOnameType :: (NameType)
            _genericsOtoplevel :: (Bool)
            _parametricsIconstructors_collect :: (FMap Name Names)
            _parametricsIknownKinds_collect :: (FMap Name [Name])
            _parametricsIknownTypes_collect :: (FMap Name [Name])
            _parametricsIknownValues_collect :: (FMap Name [Name])
            _parametricsIlabels_collect :: (FMap Name Names)
            _parametricsImethods_collect :: (FMap Name Names)
            _parametricsImoduleTypes :: (FMap ModuleName [Name])
            _parametricsImoduleValues :: (FMap ModuleName [Name])
            _parametricsImodules :: (Set.Set Strings)
            _parametricsIres :: ([ResolveResult])
            _parametricsIself :: (Types)
            _parametricsOclassname :: (Maybe Name)
            _parametricsOconstructors_collect :: (FMap Name Names)
            _parametricsOconstructors_dist :: (FMap Name Names)
            _parametricsOcurrentModule :: (Strings)
            _parametricsOimportedModule :: (Bool)
            _parametricsOinstancename :: (Maybe Name)
            _parametricsOknownGenerics :: (FMap Name [Name])
            _parametricsOknownKinds :: (FMap Name [Name])
            _parametricsOknownKinds_collect :: (FMap Name [Name])
            _parametricsOknownTypes :: (FMap Name [Name])
            _parametricsOknownTypes_collect :: (FMap Name [Name])
            _parametricsOknownValues :: (FMap Name [Name])
            _parametricsOknownValues_collect :: (FMap Name [Name])
            _parametricsOlabels_collect :: (FMap Name Names)
            _parametricsOlabels_dist :: (FMap Name Names)
            _parametricsOlocal :: (Bool)
            _parametricsOmethods_collect :: (FMap Name Names)
            _parametricsOmethods_dist :: (FMap Name Names)
            _parametricsOmoduleTypes :: (FMap ModuleName [Name])
            _parametricsOmoduleValues :: (FMap ModuleName [Name])
            _parametricsOnameType :: (NameType)
            _parametricsOtoplevel :: (Bool)
            _asnameIconstructors_collect :: (FMap Name Names)
            _asnameIknownKinds_collect :: (FMap Name [Name])
            _asnameIknownTypes_collect :: (FMap Name [Name])
            _asnameIknownValues_collect :: (FMap Name [Name])
            _asnameIlabels_collect :: (FMap Name Names)
            _asnameImethods_collect :: (FMap Name Names)
            _asnameImoduleTypes :: (FMap ModuleName [Name])
            _asnameImoduleValues :: (FMap ModuleName [Name])
            _asnameImodules :: (Set.Set Strings)
            _asnameIoriginalSelf :: (MaybeName)
            _asnameIres :: ([ResolveResult])
            _asnameIself :: (MaybeName)
            _asnameOclassname :: (Maybe Name)
            _asnameOconstructors_collect :: (FMap Name Names)
            _asnameOconstructors_dist :: (FMap Name Names)
            _asnameOcurrentModule :: (Strings)
            _asnameOimportedModule :: (Bool)
            _asnameOinstancename :: (Maybe Name)
            _asnameOknownKinds :: (FMap Name [Name])
            _asnameOknownKinds_collect :: (FMap Name [Name])
            _asnameOknownTypes :: (FMap Name [Name])
            _asnameOknownTypes_collect :: (FMap Name [Name])
            _asnameOknownValues :: (FMap Name [Name])
            _asnameOknownValues_collect :: (FMap Name [Name])
            _asnameOlabels_collect :: (FMap Name Names)
            _asnameOlabels_dist :: (FMap Name Names)
            _asnameOlocal :: (Bool)
            _asnameOmethods_collect :: (FMap Name Names)
            _asnameOmethods_dist :: (FMap Name Names)
            _asnameOmoduleTypes :: (FMap ModuleName [Name])
            _asnameOmoduleValues :: (FMap ModuleName [Name])
            _asnameOnameType :: (NameType)
            _asnameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _genericsIconstructors_collect,_genericsIknownKinds_collect,_genericsIknownTypes_collect,_genericsIknownValues_collect,_genericsIlabels_collect,_genericsImethods_collect,_genericsImoduleTypes,_genericsImoduleValues,_genericsImodules,_genericsIoriginalSelf,_genericsIres,_genericsIself) =
                (generics_ (_genericsOclassname)
                           (_genericsOconstructors_collect)
                           (_genericsOconstructors_dist)
                           (_genericsOcurrentModule)
                           (_genericsOimportedModule)
                           (_genericsOinstancename)
                           (_genericsOknownKinds)
                           (_genericsOknownKinds_collect)
                           (_genericsOknownTypes)
                           (_genericsOknownTypes_collect)
                           (_genericsOknownValues)
                           (_genericsOknownValues_collect)
                           (_genericsOlabels_collect)
                           (_genericsOlabels_dist)
                           (_genericsOlocal)
                           (_genericsOmethods_collect)
                           (_genericsOmethods_dist)
                           (_genericsOmoduleTypes)
                           (_genericsOmoduleValues)
                           (_genericsOnameType)
                           (_genericsOtoplevel))
            ( _parametricsIconstructors_collect,_parametricsIknownKinds_collect,_parametricsIknownTypes_collect,_parametricsIknownValues_collect,_parametricsIlabels_collect,_parametricsImethods_collect,_parametricsImoduleTypes,_parametricsImoduleValues,_parametricsImodules,_parametricsIres,_parametricsIself) =
                (parametrics_ (_parametricsOclassname)
                              (_parametricsOconstructors_collect)
                              (_parametricsOconstructors_dist)
                              (_parametricsOcurrentModule)
                              (_parametricsOimportedModule)
                              (_parametricsOinstancename)
                              (_parametricsOknownGenerics)
                              (_parametricsOknownKinds)
                              (_parametricsOknownKinds_collect)
                              (_parametricsOknownTypes)
                              (_parametricsOknownTypes_collect)
                              (_parametricsOknownValues)
                              (_parametricsOknownValues_collect)
                              (_parametricsOlabels_collect)
                              (_parametricsOlabels_dist)
                              (_parametricsOlocal)
                              (_parametricsOmethods_collect)
                              (_parametricsOmethods_dist)
                              (_parametricsOmoduleTypes)
                              (_parametricsOmoduleValues)
                              (_parametricsOnameType)
                              (_parametricsOtoplevel))
            ( _asnameIconstructors_collect,_asnameIknownKinds_collect,_asnameIknownTypes_collect,_asnameIknownValues_collect,_asnameIlabels_collect,_asnameImethods_collect,_asnameImoduleTypes,_asnameImoduleValues,_asnameImodules,_asnameIoriginalSelf,_asnameIres,_asnameIself) =
                (asname_ (_asnameOclassname)
                         (_asnameOconstructors_collect)
                         (_asnameOconstructors_dist)
                         (_asnameOcurrentModule)
                         (_asnameOimportedModule)
                         (_asnameOinstancename)
                         (_asnameOknownKinds)
                         (_asnameOknownKinds_collect)
                         (_asnameOknownTypes)
                         (_asnameOknownTypes_collect)
                         (_asnameOknownValues)
                         (_asnameOknownValues_collect)
                         (_asnameOlabels_collect)
                         (_asnameOlabels_dist)
                         (_asnameOlocal)
                         (_asnameOmethods_collect)
                         (_asnameOmethods_dist)
                         (_asnameOmoduleTypes)
                         (_asnameOmoduleValues)
                         (_asnameOnameType)
                         (_asnameOtoplevel))
            -- "./Names.inc.lag"(line 617, column 9)
            (_genericsOknownTypes@_) =
                _lhsIknownGenerics
            -- "./NameTypes.inc.lag"(line 227, column 9)
            (_asnameOnameType@_) =
                Def_Val
            -- "./NameTypes.inc.lag"(line 226, column 9)
            (_genericsOnameType@_) =
                ref_Typ
            -- "./NameTypes.inc.lag"(line 225, column 9)
            (_nameOnameType@_) =
                ref_Val
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _genericsImodules `Set.union` _parametricsImodules `Set.union` _asnameImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _genericsIres ++ _parametricsIres ++ _asnameIres
            -- self rule
            (_self@_) =
                ContextItem_DependencyItem _rangeIself _nameIself _genericsIself _parametricsIself _asnameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _asnameIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _asnameIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _asnameIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _asnameIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _asnameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _asnameImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _asnameImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _asnameImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_genericsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_genericsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_genericsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_genericsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_genericsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_genericsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_genericsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_genericsOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (chain)
            (_genericsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (down)
            (_genericsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_genericsOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_genericsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_genericsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_genericsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_genericsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_genericsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_genericsOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_genericsOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_genericsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_parametricsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_parametricsOconstructors_collect@_) =
                _genericsIconstructors_collect
            -- copy rule (down)
            (_parametricsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_parametricsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_parametricsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_parametricsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_parametricsOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_parametricsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_parametricsOknownKinds_collect@_) =
                _genericsIknownKinds_collect
            -- copy rule (down)
            (_parametricsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_parametricsOknownTypes_collect@_) =
                _genericsIknownTypes_collect
            -- copy rule (down)
            (_parametricsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_parametricsOknownValues_collect@_) =
                _genericsIknownValues_collect
            -- copy rule (chain)
            (_parametricsOlabels_collect@_) =
                _genericsIlabels_collect
            -- copy rule (down)
            (_parametricsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_parametricsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_parametricsOmethods_collect@_) =
                _genericsImethods_collect
            -- copy rule (down)
            (_parametricsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_parametricsOmoduleTypes@_) =
                _genericsImoduleTypes
            -- copy rule (chain)
            (_parametricsOmoduleValues@_) =
                _genericsImoduleValues
            -- copy rule (down)
            (_parametricsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_parametricsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_asnameOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_asnameOconstructors_collect@_) =
                _parametricsIconstructors_collect
            -- copy rule (down)
            (_asnameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_asnameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_asnameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_asnameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_asnameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_asnameOknownKinds_collect@_) =
                _parametricsIknownKinds_collect
            -- copy rule (down)
            (_asnameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_asnameOknownTypes_collect@_) =
                _parametricsIknownTypes_collect
            -- copy rule (down)
            (_asnameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_asnameOknownValues_collect@_) =
                _parametricsIknownValues_collect
            -- copy rule (chain)
            (_asnameOlabels_collect@_) =
                _parametricsIlabels_collect
            -- copy rule (down)
            (_asnameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_asnameOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_asnameOmethods_collect@_) =
                _parametricsImethods_collect
            -- copy rule (down)
            (_asnameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_asnameOmoduleTypes@_) =
                _parametricsImoduleTypes
            -- copy rule (chain)
            (_asnameOmoduleValues@_) =
                _parametricsImoduleValues
            -- copy rule (down)
            (_asnameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- ContextItems ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for ContextItems.Cons:
      self

-}
{-
   local variables for ContextItems.Nil:
      self

-}
-- semantic domain
type T_ContextItems = (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Strings) ->
                      (Bool) ->
                      (Maybe Name) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (FMap ModuleName [Name]) ->
                      (FMap ModuleName [Name]) ->
                      (NameType) ->
                      (Bool) ->
                      ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(ContextItems))
-- cata
sem_ContextItems :: (ContextItems) ->
                    (T_ContextItems)
sem_ContextItems (list) =
    (foldr (sem_ContextItems_Cons) (sem_ContextItems_Nil) ((map sem_ContextItem list)))
sem_ContextItems_Cons :: (T_ContextItem) ->
                         (T_ContextItems) ->
                         (T_ContextItems)
sem_ContextItems_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (ContextItems)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIknownKinds_collect :: (FMap Name [Name])
            _hdIknownTypes_collect :: (FMap Name [Name])
            _hdIknownValues_collect :: (FMap Name [Name])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdImoduleTypes :: (FMap ModuleName [Name])
            _hdImoduleValues :: (FMap ModuleName [Name])
            _hdImodules :: (Set.Set Strings)
            _hdIres :: ([ResolveResult])
            _hdIself :: (ContextItem)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOknownGenerics :: (FMap Name [Name])
            _hdOknownKinds :: (FMap Name [Name])
            _hdOknownKinds_collect :: (FMap Name [Name])
            _hdOknownTypes :: (FMap Name [Name])
            _hdOknownTypes_collect :: (FMap Name [Name])
            _hdOknownValues :: (FMap Name [Name])
            _hdOknownValues_collect :: (FMap Name [Name])
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmoduleTypes :: (FMap ModuleName [Name])
            _hdOmoduleValues :: (FMap ModuleName [Name])
            _hdOnameType :: (NameType)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIknownKinds_collect :: (FMap Name [Name])
            _tlIknownTypes_collect :: (FMap Name [Name])
            _tlIknownValues_collect :: (FMap Name [Name])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlImoduleTypes :: (FMap ModuleName [Name])
            _tlImoduleValues :: (FMap ModuleName [Name])
            _tlImodules :: (Set.Set Strings)
            _tlIres :: ([ResolveResult])
            _tlIself :: (ContextItems)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOknownGenerics :: (FMap Name [Name])
            _tlOknownKinds :: (FMap Name [Name])
            _tlOknownKinds_collect :: (FMap Name [Name])
            _tlOknownTypes :: (FMap Name [Name])
            _tlOknownTypes_collect :: (FMap Name [Name])
            _tlOknownValues :: (FMap Name [Name])
            _tlOknownValues_collect :: (FMap Name [Name])
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmoduleTypes :: (FMap ModuleName [Name])
            _tlOmoduleValues :: (FMap ModuleName [Name])
            _tlOnameType :: (NameType)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIknownKinds_collect,_hdIknownTypes_collect,_hdIknownValues_collect,_hdIlabels_collect,_hdImethods_collect,_hdImoduleTypes,_hdImoduleValues,_hdImodules,_hdIres,_hdIself) =
                (hd_ (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOknownGenerics)
                     (_hdOknownKinds)
                     (_hdOknownKinds_collect)
                     (_hdOknownTypes)
                     (_hdOknownTypes_collect)
                     (_hdOknownValues)
                     (_hdOknownValues_collect)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmoduleTypes)
                     (_hdOmoduleValues)
                     (_hdOnameType)
                     (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIknownKinds_collect,_tlIknownTypes_collect,_tlIknownValues_collect,_tlIlabels_collect,_tlImethods_collect,_tlImoduleTypes,_tlImoduleValues,_tlImodules,_tlIres,_tlIself) =
                (tl_ (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOknownGenerics)
                     (_tlOknownKinds)
                     (_tlOknownKinds_collect)
                     (_tlOknownTypes)
                     (_tlOknownTypes_collect)
                     (_tlOknownValues)
                     (_tlOknownValues_collect)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmoduleTypes)
                     (_tlOmoduleValues)
                     (_tlOnameType)
                     (_tlOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _hdImodules `Set.union` _tlImodules
            -- use rule
            (_lhsOres@_) =
                _hdIres ++ _tlIres
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _tlIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _tlIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _tlIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _tlImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _tlImoduleValues
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_hdOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_hdOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_hdOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_hdOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_hdOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_hdOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_hdOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_hdOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_tlOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_tlOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_tlOknownKinds_collect@_) =
                _hdIknownKinds_collect
            -- copy rule (down)
            (_tlOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_tlOknownTypes_collect@_) =
                _hdIknownTypes_collect
            -- copy rule (down)
            (_tlOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_tlOknownValues_collect@_) =
                _hdIknownValues_collect
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_tlOmoduleTypes@_) =
                _hdImoduleTypes
            -- copy rule (chain)
            (_tlOmoduleValues@_) =
                _hdImoduleValues
            -- copy rule (down)
            (_tlOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_ContextItems_Nil :: (T_ContextItems)
sem_ContextItems_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (ContextItems)
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- Declaration -------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for Declaration.Class:
      classname
      self

-}
{-
   local variables for Declaration.Data:
      self

-}
{-
   local variables for Declaration.Default:
      self

-}
{-
   local variables for Declaration.Dependency:
      self

-}
{-
   local variables for Declaration.Empty:
      self

-}
{-
   local variables for Declaration.Fixity:
      self

-}
{-
   local variables for Declaration.FunctionBindings:
      self

-}
{-
   local variables for Declaration.GenericTypeSignature:
      isMPCstyle
      self

-}
{-
   local variables for Declaration.Instance:
      instancename
      self

-}
{-
   local variables for Declaration.KindIndexedType:
      self

-}
{-
   local variables for Declaration.Newtype:
      self

-}
{-
   local variables for Declaration.PatternBinding:
      self

-}
{-
   local variables for Declaration.Type:
      self

-}
{-
   local variables for Declaration.TypeIndexedType:
      self

-}
{-
   local variables for Declaration.TypeIndexedValue:
      self

-}
{-
   local variables for Declaration.TypeSignature:
      self

-}
-- semantic domain
type T_Declaration = (Maybe Name) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Strings) ->
                     (Bool) ->
                     (Maybe Name) ->
                     (FMap Name [Name]) ->
                     (FMap Name [Name]) ->
                     (FMap Name [Name]) ->
                     (FMap Name [Name]) ->
                     (FMap Name [Name]) ->
                     (FMap Name [Name]) ->
                     (FMap Name [Name]) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Bool) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (FMap ModuleName [Name]) ->
                     (FMap ModuleName [Name]) ->
                     (NameType) ->
                     (Bool) ->
                     ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(Declaration))
-- cata
sem_Declaration :: (Declaration) ->
                   (T_Declaration)
sem_Declaration ((Declaration_Class (_range) (_context) (_simpletype) (_where))) =
    (sem_Declaration_Class ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_SimpleType (_simpletype))) ((sem_MaybeDeclarations (_where))))
sem_Declaration ((Declaration_Data (_range) (_context) (_simpletype) (_constructors) (_derivings))) =
    (sem_Declaration_Data ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_SimpleType (_simpletype))) ((sem_Constructors (_constructors))) ((sem_Names (_derivings))))
sem_Declaration ((Declaration_Default (_range) (_types))) =
    (sem_Declaration_Default ((sem_Range (_range))) ((sem_Types (_types))))
sem_Declaration ((Declaration_Dependency (_range) (_typelevel) (_name) (_bindings))) =
    (sem_Declaration_Dependency ((sem_Range (_range))) (_typelevel) ((sem_Name (_name))) ((sem_DependencyBindings (_bindings))))
sem_Declaration ((Declaration_Empty (_range))) =
    (sem_Declaration_Empty ((sem_Range (_range))))
sem_Declaration ((Declaration_Fixity (_range) (_fixity) (_priority) (_operators))) =
    (sem_Declaration_Fixity ((sem_Range (_range))) ((sem_Fixity (_fixity))) ((sem_MaybeInt (_priority))) ((sem_Names (_operators))))
sem_Declaration ((Declaration_FunctionBindings (_range) (_bindings))) =
    (sem_Declaration_FunctionBindings ((sem_Range (_range))) ((sem_FunctionBindings (_bindings))))
sem_Declaration ((Declaration_GenericTypeSignature (_range) (_name) (_generics) (_parametrics) (_type))) =
    (sem_Declaration_GenericTypeSignature ((sem_Range (_range))) ((sem_Name (_name))) ((sem_KindAnnotatedNames (_generics))) ((sem_KindAnnotatedNames (_parametrics))) ((sem_Type (_type))))
sem_Declaration ((Declaration_Instance (_range) (_context) (_name) (_types) (_where))) =
    (sem_Declaration_Instance ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_Name (_name))) ((sem_Types (_types))) ((sem_MaybeDeclarations (_where))))
sem_Declaration ((Declaration_KindIndexedType (_range) (_bindings))) =
    (sem_Declaration_KindIndexedType ((sem_Range (_range))) ((sem_KindIndexedBindings (_bindings))))
sem_Declaration ((Declaration_Newtype (_range) (_context) (_simpletype) (_constructor) (_derivings))) =
    (sem_Declaration_Newtype ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_SimpleType (_simpletype))) ((sem_Constructor (_constructor))) ((sem_Names (_derivings))))
sem_Declaration ((Declaration_PatternBinding (_range) (_pattern) (_righthandside))) =
    (sem_Declaration_PatternBinding ((sem_Range (_range))) ((sem_Pattern (_pattern))) ((sem_RightHandSide (_righthandside))))
sem_Declaration ((Declaration_Type (_range) (_simpletype) (_type))) =
    (sem_Declaration_Type ((sem_Range (_range))) ((sem_SimpleType (_simpletype))) ((sem_Type (_type))))
sem_Declaration ((Declaration_TypeIndexedType (_range) (_name) (_typeargument) (_typevariables) (_constructor) (_derivings))) =
    (sem_Declaration_TypeIndexedType ((sem_Range (_range))) ((sem_Name (_name))) ((sem_TypeArgument (_typeargument))) ((sem_Names (_typevariables))) ((sem_Constructor (_constructor))) ((sem_Names (_derivings))))
sem_Declaration ((Declaration_TypeIndexedValue (_range) (_bindings))) =
    (sem_Declaration_TypeIndexedValue ((sem_Range (_range))) ((sem_TypeIndexedBindings (_bindings))))
sem_Declaration ((Declaration_TypeSignature (_range) (_names) (_type))) =
    (sem_Declaration_TypeSignature ((sem_Range (_range))) ((sem_Names (_names))) ((sem_Type (_type))))
sem_Declaration_Class :: (T_Range) ->
                         (T_ContextItems) ->
                         (T_SimpleType) ->
                         (T_MaybeDeclarations) ->
                         (T_Declaration)
sem_Declaration_Class (range_) (context_) (simpletype_) (where_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _contextIconstructors_collect :: (FMap Name Names)
            _contextIknownKinds_collect :: (FMap Name [Name])
            _contextIknownTypes_collect :: (FMap Name [Name])
            _contextIknownValues_collect :: (FMap Name [Name])
            _contextIlabels_collect :: (FMap Name Names)
            _contextImethods_collect :: (FMap Name Names)
            _contextImoduleTypes :: (FMap ModuleName [Name])
            _contextImoduleValues :: (FMap ModuleName [Name])
            _contextImodules :: (Set.Set Strings)
            _contextIres :: ([ResolveResult])
            _contextIself :: (ContextItems)
            _contextOclassname :: (Maybe Name)
            _contextOconstructors_collect :: (FMap Name Names)
            _contextOconstructors_dist :: (FMap Name Names)
            _contextOcurrentModule :: (Strings)
            _contextOimportedModule :: (Bool)
            _contextOinstancename :: (Maybe Name)
            _contextOknownGenerics :: (FMap Name [Name])
            _contextOknownKinds :: (FMap Name [Name])
            _contextOknownKinds_collect :: (FMap Name [Name])
            _contextOknownTypes :: (FMap Name [Name])
            _contextOknownTypes_collect :: (FMap Name [Name])
            _contextOknownValues :: (FMap Name [Name])
            _contextOknownValues_collect :: (FMap Name [Name])
            _contextOlabels_collect :: (FMap Name Names)
            _contextOlabels_dist :: (FMap Name Names)
            _contextOlocal :: (Bool)
            _contextOmethods_collect :: (FMap Name Names)
            _contextOmethods_dist :: (FMap Name Names)
            _contextOmoduleTypes :: (FMap ModuleName [Name])
            _contextOmoduleValues :: (FMap ModuleName [Name])
            _contextOnameType :: (NameType)
            _contextOtoplevel :: (Bool)
            _simpletypeIconstructors_collect :: (FMap Name Names)
            _simpletypeIknownKinds_collect :: (FMap Name [Name])
            _simpletypeIknownTypesForBody_collect :: (FMap Name [Name])
            _simpletypeIknownTypes_collect :: (FMap Name [Name])
            _simpletypeIknownValues_collect :: (FMap Name [Name])
            _simpletypeIlabels_collect :: (FMap Name Names)
            _simpletypeImethods_collect :: (FMap Name Names)
            _simpletypeImoduleTypes :: (FMap ModuleName [Name])
            _simpletypeImoduleValues :: (FMap ModuleName [Name])
            _simpletypeImodules :: (Set.Set Strings)
            _simpletypeIname :: (Name)
            _simpletypeIres :: ([ResolveResult])
            _simpletypeIself :: (SimpleType)
            _simpletypeOclassname :: (Maybe Name)
            _simpletypeOconstructors_collect :: (FMap Name Names)
            _simpletypeOconstructors_dist :: (FMap Name Names)
            _simpletypeOcurrentModule :: (Strings)
            _simpletypeOimportedModule :: (Bool)
            _simpletypeOinstancename :: (Maybe Name)
            _simpletypeOknownKinds :: (FMap Name [Name])
            _simpletypeOknownKinds_collect :: (FMap Name [Name])
            _simpletypeOknownTypes :: (FMap Name [Name])
            _simpletypeOknownTypesForBody_collect :: (FMap Name [Name])
            _simpletypeOknownTypes_collect :: (FMap Name [Name])
            _simpletypeOknownValues :: (FMap Name [Name])
            _simpletypeOknownValues_collect :: (FMap Name [Name])
            _simpletypeOlabels_collect :: (FMap Name Names)
            _simpletypeOlabels_dist :: (FMap Name Names)
            _simpletypeOlocal :: (Bool)
            _simpletypeOmethods_collect :: (FMap Name Names)
            _simpletypeOmethods_dist :: (FMap Name Names)
            _simpletypeOmoduleTypes :: (FMap ModuleName [Name])
            _simpletypeOmoduleValues :: (FMap ModuleName [Name])
            _simpletypeOnameType :: (NameType)
            _simpletypeOtoplevel :: (Bool)
            _whereIconstructors_collect :: (FMap Name Names)
            _whereIknownKinds_collect :: (FMap Name [Name])
            _whereIknownTypes_collect :: (FMap Name [Name])
            _whereIknownValues_collect :: (FMap Name [Name])
            _whereIlabels_collect :: (FMap Name Names)
            _whereImethods_collect :: (FMap Name Names)
            _whereImoduleTypes :: (FMap ModuleName [Name])
            _whereImoduleValues :: (FMap ModuleName [Name])
            _whereImodules :: (Set.Set Strings)
            _whereIres :: ([ResolveResult])
            _whereIself :: (MaybeDeclarations)
            _whereOclassname :: (Maybe Name)
            _whereOconstructors_collect :: (FMap Name Names)
            _whereOconstructors_dist :: (FMap Name Names)
            _whereOcurrentModule :: (Strings)
            _whereOimportedModule :: (Bool)
            _whereOinstancename :: (Maybe Name)
            _whereOknownGenerics :: (FMap Name [Name])
            _whereOknownKinds :: (FMap Name [Name])
            _whereOknownKinds_collect :: (FMap Name [Name])
            _whereOknownTypes :: (FMap Name [Name])
            _whereOknownTypes_collect :: (FMap Name [Name])
            _whereOknownValues :: (FMap Name [Name])
            _whereOknownValues_collect :: (FMap Name [Name])
            _whereOlabels_collect :: (FMap Name Names)
            _whereOlabels_dist :: (FMap Name Names)
            _whereOlocal :: (Bool)
            _whereOmethods_collect :: (FMap Name Names)
            _whereOmethods_dist :: (FMap Name Names)
            _whereOmoduleTypes :: (FMap ModuleName [Name])
            _whereOmoduleValues :: (FMap ModuleName [Name])
            _whereOnameType :: (NameType)
            _whereOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _contextIconstructors_collect,_contextIknownKinds_collect,_contextIknownTypes_collect,_contextIknownValues_collect,_contextIlabels_collect,_contextImethods_collect,_contextImoduleTypes,_contextImoduleValues,_contextImodules,_contextIres,_contextIself) =
                (context_ (_contextOclassname)
                          (_contextOconstructors_collect)
                          (_contextOconstructors_dist)
                          (_contextOcurrentModule)
                          (_contextOimportedModule)
                          (_contextOinstancename)
                          (_contextOknownGenerics)
                          (_contextOknownKinds)
                          (_contextOknownKinds_collect)
                          (_contextOknownTypes)
                          (_contextOknownTypes_collect)
                          (_contextOknownValues)
                          (_contextOknownValues_collect)
                          (_contextOlabels_collect)
                          (_contextOlabels_dist)
                          (_contextOlocal)
                          (_contextOmethods_collect)
                          (_contextOmethods_dist)
                          (_contextOmoduleTypes)
                          (_contextOmoduleValues)
                          (_contextOnameType)
                          (_contextOtoplevel))
            ( _simpletypeIconstructors_collect,_simpletypeIknownKinds_collect,_simpletypeIknownTypesForBody_collect,_simpletypeIknownTypes_collect,_simpletypeIknownValues_collect,_simpletypeIlabels_collect,_simpletypeImethods_collect,_simpletypeImoduleTypes,_simpletypeImoduleValues,_simpletypeImodules,_simpletypeIname,_simpletypeIres,_simpletypeIself) =
                (simpletype_ (_simpletypeOclassname)
                             (_simpletypeOconstructors_collect)
                             (_simpletypeOconstructors_dist)
                             (_simpletypeOcurrentModule)
                             (_simpletypeOimportedModule)
                             (_simpletypeOinstancename)
                             (_simpletypeOknownKinds)
                             (_simpletypeOknownKinds_collect)
                             (_simpletypeOknownTypes)
                             (_simpletypeOknownTypesForBody_collect)
                             (_simpletypeOknownTypes_collect)
                             (_simpletypeOknownValues)
                             (_simpletypeOknownValues_collect)
                             (_simpletypeOlabels_collect)
                             (_simpletypeOlabels_dist)
                             (_simpletypeOlocal)
                             (_simpletypeOmethods_collect)
                             (_simpletypeOmethods_dist)
                             (_simpletypeOmoduleTypes)
                             (_simpletypeOmoduleValues)
                             (_simpletypeOnameType)
                             (_simpletypeOtoplevel))
            ( _whereIconstructors_collect,_whereIknownKinds_collect,_whereIknownTypes_collect,_whereIknownValues_collect,_whereIlabels_collect,_whereImethods_collect,_whereImoduleTypes,_whereImoduleValues,_whereImodules,_whereIres,_whereIself) =
                (where_ (_whereOclassname)
                        (_whereOconstructors_collect)
                        (_whereOconstructors_dist)
                        (_whereOcurrentModule)
                        (_whereOimportedModule)
                        (_whereOinstancename)
                        (_whereOknownGenerics)
                        (_whereOknownKinds)
                        (_whereOknownKinds_collect)
                        (_whereOknownTypes)
                        (_whereOknownTypes_collect)
                        (_whereOknownValues)
                        (_whereOknownValues_collect)
                        (_whereOlabels_collect)
                        (_whereOlabels_dist)
                        (_whereOlocal)
                        (_whereOmethods_collect)
                        (_whereOmethods_dist)
                        (_whereOmoduleTypes)
                        (_whereOmoduleValues)
                        (_whereOnameType)
                        (_whereOtoplevel))
            -- "./Names.inc.lag"(line 744, column 9)
            (_lhsOknownTypes_collect@_) =
                _simpletypeIknownTypes_collect
            -- "./Names.inc.lag"(line 743, column 9)
            (_contextOknownTypes@_) =
                _simpletypeIknownTypesForBody_collect `mergeFM` _lhsIknownTypes
            -- "./Names.inc.lag"(line 742, column 9)
            (_whereOknownTypes@_) =
                _simpletypeIknownTypesForBody_collect `mergeFM` _lhsIknownTypes
            -- "./Names.inc.lag"(line 741, column 9)
            (_simpletypeOknownTypesForBody_collect@_) =
                emptyFM
            -- "./NameTypes.inc.lag"(line 306, column 9)
            (_simpletypeOnameType@_) =
                Def_Typ
            -- "./NameTypes.inc.lag"(line 305, column 9)
            (_contextOnameType@_) =
                ref_Typ
            -- "./ModuleInformation.inc.lag"(line 138, column 8)
            (_classname@_) =
                Just _simpletypeIname
            -- "./ModuleInformation.inc.lag"(line 331, column 9)
            (_whereOmethods_collect@_) =
                add _lhsImethods_collect
                    (_simpletypeIname,[])
            -- use rule
            (_lhsOmodules@_) =
                _contextImodules `Set.union` _simpletypeImodules `Set.union` _whereImodules
            -- use rule
            (_lhsOres@_) =
                _contextIres ++ _simpletypeIres ++ _whereIres
            -- self rule
            (_self@_) =
                Declaration_Class _rangeIself _contextIself _simpletypeIself _whereIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _whereIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _whereIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _whereIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _whereIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _whereImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _whereImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _whereImoduleValues
            -- copy rule (chain)
            (_rangeOclassname@_) =
                _classname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_contextOclassname@_) =
                _classname
            -- copy rule (down)
            (_contextOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_contextOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_contextOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_contextOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_contextOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_contextOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_contextOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_contextOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_contextOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_contextOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_contextOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_contextOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_contextOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_contextOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_contextOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_contextOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_contextOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_contextOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_contextOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_simpletypeOclassname@_) =
                _classname
            -- copy rule (chain)
            (_simpletypeOconstructors_collect@_) =
                _contextIconstructors_collect
            -- copy rule (down)
            (_simpletypeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_simpletypeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_simpletypeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_simpletypeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_simpletypeOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_simpletypeOknownKinds_collect@_) =
                _contextIknownKinds_collect
            -- copy rule (down)
            (_simpletypeOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_simpletypeOknownTypes_collect@_) =
                _contextIknownTypes_collect
            -- copy rule (down)
            (_simpletypeOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_simpletypeOknownValues_collect@_) =
                _contextIknownValues_collect
            -- copy rule (chain)
            (_simpletypeOlabels_collect@_) =
                _contextIlabels_collect
            -- copy rule (down)
            (_simpletypeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_simpletypeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_simpletypeOmethods_collect@_) =
                _contextImethods_collect
            -- copy rule (down)
            (_simpletypeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_simpletypeOmoduleTypes@_) =
                _contextImoduleTypes
            -- copy rule (chain)
            (_simpletypeOmoduleValues@_) =
                _contextImoduleValues
            -- copy rule (down)
            (_simpletypeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_whereOclassname@_) =
                _classname
            -- copy rule (chain)
            (_whereOconstructors_collect@_) =
                _simpletypeIconstructors_collect
            -- copy rule (down)
            (_whereOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_whereOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_whereOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_whereOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_whereOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_whereOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_whereOknownKinds_collect@_) =
                _simpletypeIknownKinds_collect
            -- copy rule (chain)
            (_whereOknownTypes_collect@_) =
                _simpletypeIknownTypes_collect
            -- copy rule (down)
            (_whereOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_whereOknownValues_collect@_) =
                _simpletypeIknownValues_collect
            -- copy rule (chain)
            (_whereOlabels_collect@_) =
                _simpletypeIlabels_collect
            -- copy rule (down)
            (_whereOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_whereOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_whereOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_whereOmoduleTypes@_) =
                _simpletypeImoduleTypes
            -- copy rule (chain)
            (_whereOmoduleValues@_) =
                _simpletypeImoduleValues
            -- copy rule (down)
            (_whereOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_whereOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Declaration_Data :: (T_Range) ->
                        (T_ContextItems) ->
                        (T_SimpleType) ->
                        (T_Constructors) ->
                        (T_Names) ->
                        (T_Declaration)
sem_Declaration_Data (range_) (context_) (simpletype_) (constructors_) (derivings_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _contextIconstructors_collect :: (FMap Name Names)
            _contextIknownKinds_collect :: (FMap Name [Name])
            _contextIknownTypes_collect :: (FMap Name [Name])
            _contextIknownValues_collect :: (FMap Name [Name])
            _contextIlabels_collect :: (FMap Name Names)
            _contextImethods_collect :: (FMap Name Names)
            _contextImoduleTypes :: (FMap ModuleName [Name])
            _contextImoduleValues :: (FMap ModuleName [Name])
            _contextImodules :: (Set.Set Strings)
            _contextIres :: ([ResolveResult])
            _contextIself :: (ContextItems)
            _contextOclassname :: (Maybe Name)
            _contextOconstructors_collect :: (FMap Name Names)
            _contextOconstructors_dist :: (FMap Name Names)
            _contextOcurrentModule :: (Strings)
            _contextOimportedModule :: (Bool)
            _contextOinstancename :: (Maybe Name)
            _contextOknownGenerics :: (FMap Name [Name])
            _contextOknownKinds :: (FMap Name [Name])
            _contextOknownKinds_collect :: (FMap Name [Name])
            _contextOknownTypes :: (FMap Name [Name])
            _contextOknownTypes_collect :: (FMap Name [Name])
            _contextOknownValues :: (FMap Name [Name])
            _contextOknownValues_collect :: (FMap Name [Name])
            _contextOlabels_collect :: (FMap Name Names)
            _contextOlabels_dist :: (FMap Name Names)
            _contextOlocal :: (Bool)
            _contextOmethods_collect :: (FMap Name Names)
            _contextOmethods_dist :: (FMap Name Names)
            _contextOmoduleTypes :: (FMap ModuleName [Name])
            _contextOmoduleValues :: (FMap ModuleName [Name])
            _contextOnameType :: (NameType)
            _contextOtoplevel :: (Bool)
            _simpletypeIconstructors_collect :: (FMap Name Names)
            _simpletypeIknownKinds_collect :: (FMap Name [Name])
            _simpletypeIknownTypesForBody_collect :: (FMap Name [Name])
            _simpletypeIknownTypes_collect :: (FMap Name [Name])
            _simpletypeIknownValues_collect :: (FMap Name [Name])
            _simpletypeIlabels_collect :: (FMap Name Names)
            _simpletypeImethods_collect :: (FMap Name Names)
            _simpletypeImoduleTypes :: (FMap ModuleName [Name])
            _simpletypeImoduleValues :: (FMap ModuleName [Name])
            _simpletypeImodules :: (Set.Set Strings)
            _simpletypeIname :: (Name)
            _simpletypeIres :: ([ResolveResult])
            _simpletypeIself :: (SimpleType)
            _simpletypeOclassname :: (Maybe Name)
            _simpletypeOconstructors_collect :: (FMap Name Names)
            _simpletypeOconstructors_dist :: (FMap Name Names)
            _simpletypeOcurrentModule :: (Strings)
            _simpletypeOimportedModule :: (Bool)
            _simpletypeOinstancename :: (Maybe Name)
            _simpletypeOknownKinds :: (FMap Name [Name])
            _simpletypeOknownKinds_collect :: (FMap Name [Name])
            _simpletypeOknownTypes :: (FMap Name [Name])
            _simpletypeOknownTypesForBody_collect :: (FMap Name [Name])
            _simpletypeOknownTypes_collect :: (FMap Name [Name])
            _simpletypeOknownValues :: (FMap Name [Name])
            _simpletypeOknownValues_collect :: (FMap Name [Name])
            _simpletypeOlabels_collect :: (FMap Name Names)
            _simpletypeOlabels_dist :: (FMap Name Names)
            _simpletypeOlocal :: (Bool)
            _simpletypeOmethods_collect :: (FMap Name Names)
            _simpletypeOmethods_dist :: (FMap Name Names)
            _simpletypeOmoduleTypes :: (FMap ModuleName [Name])
            _simpletypeOmoduleValues :: (FMap ModuleName [Name])
            _simpletypeOnameType :: (NameType)
            _simpletypeOtoplevel :: (Bool)
            _constructorsIconstructors :: (Names)
            _constructorsIconstructors_collect :: (FMap Name Names)
            _constructorsIknownKinds_collect :: (FMap Name [Name])
            _constructorsIknownTypes_collect :: (FMap Name [Name])
            _constructorsIknownValues_collect :: (FMap Name [Name])
            _constructorsIlabels :: (Names)
            _constructorsIlabels_collect :: (FMap Name Names)
            _constructorsImethods_collect :: (FMap Name Names)
            _constructorsImoduleTypes :: (FMap ModuleName [Name])
            _constructorsImoduleValues :: (FMap ModuleName [Name])
            _constructorsImodules :: (Set.Set Strings)
            _constructorsIres :: ([ResolveResult])
            _constructorsIself :: (Constructors)
            _constructorsOclassname :: (Maybe Name)
            _constructorsOconstructors_collect :: (FMap Name Names)
            _constructorsOconstructors_dist :: (FMap Name Names)
            _constructorsOcurrentModule :: (Strings)
            _constructorsOimportedModule :: (Bool)
            _constructorsOinstancename :: (Maybe Name)
            _constructorsOknownGenerics :: (FMap Name [Name])
            _constructorsOknownKinds :: (FMap Name [Name])
            _constructorsOknownKinds_collect :: (FMap Name [Name])
            _constructorsOknownTypes :: (FMap Name [Name])
            _constructorsOknownTypes_collect :: (FMap Name [Name])
            _constructorsOknownValues :: (FMap Name [Name])
            _constructorsOknownValues_collect :: (FMap Name [Name])
            _constructorsOlabels_collect :: (FMap Name Names)
            _constructorsOlabels_dist :: (FMap Name Names)
            _constructorsOlocal :: (Bool)
            _constructorsOmethods_collect :: (FMap Name Names)
            _constructorsOmethods_dist :: (FMap Name Names)
            _constructorsOmoduleTypes :: (FMap ModuleName [Name])
            _constructorsOmoduleValues :: (FMap ModuleName [Name])
            _constructorsOnameType :: (NameType)
            _constructorsOtoplevel :: (Bool)
            _derivingsIconstructors_collect :: (FMap Name Names)
            _derivingsIknownKinds_collect :: (FMap Name [Name])
            _derivingsIknownTypes_collect :: (FMap Name [Name])
            _derivingsIknownValues_collect :: (FMap Name [Name])
            _derivingsIlabels_collect :: (FMap Name Names)
            _derivingsImethods_collect :: (FMap Name Names)
            _derivingsImoduleTypes :: (FMap ModuleName [Name])
            _derivingsImoduleValues :: (FMap ModuleName [Name])
            _derivingsImodules :: (Set.Set Strings)
            _derivingsIoriginalSelf :: (Names)
            _derivingsIres :: ([ResolveResult])
            _derivingsIself :: (Names)
            _derivingsOclassname :: (Maybe Name)
            _derivingsOconstructors_collect :: (FMap Name Names)
            _derivingsOconstructors_dist :: (FMap Name Names)
            _derivingsOcurrentModule :: (Strings)
            _derivingsOimportedModule :: (Bool)
            _derivingsOinstancename :: (Maybe Name)
            _derivingsOknownKinds :: (FMap Name [Name])
            _derivingsOknownKinds_collect :: (FMap Name [Name])
            _derivingsOknownTypes :: (FMap Name [Name])
            _derivingsOknownTypes_collect :: (FMap Name [Name])
            _derivingsOknownValues :: (FMap Name [Name])
            _derivingsOknownValues_collect :: (FMap Name [Name])
            _derivingsOlabels_collect :: (FMap Name Names)
            _derivingsOlabels_dist :: (FMap Name Names)
            _derivingsOlocal :: (Bool)
            _derivingsOmethods_collect :: (FMap Name Names)
            _derivingsOmethods_dist :: (FMap Name Names)
            _derivingsOmoduleTypes :: (FMap ModuleName [Name])
            _derivingsOmoduleValues :: (FMap ModuleName [Name])
            _derivingsOnameType :: (NameType)
            _derivingsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _contextIconstructors_collect,_contextIknownKinds_collect,_contextIknownTypes_collect,_contextIknownValues_collect,_contextIlabels_collect,_contextImethods_collect,_contextImoduleTypes,_contextImoduleValues,_contextImodules,_contextIres,_contextIself) =
                (context_ (_contextOclassname)
                          (_contextOconstructors_collect)
                          (_contextOconstructors_dist)
                          (_contextOcurrentModule)
                          (_contextOimportedModule)
                          (_contextOinstancename)
                          (_contextOknownGenerics)
                          (_contextOknownKinds)
                          (_contextOknownKinds_collect)
                          (_contextOknownTypes)
                          (_contextOknownTypes_collect)
                          (_contextOknownValues)
                          (_contextOknownValues_collect)
                          (_contextOlabels_collect)
                          (_contextOlabels_dist)
                          (_contextOlocal)
                          (_contextOmethods_collect)
                          (_contextOmethods_dist)
                          (_contextOmoduleTypes)
                          (_contextOmoduleValues)
                          (_contextOnameType)
                          (_contextOtoplevel))
            ( _simpletypeIconstructors_collect,_simpletypeIknownKinds_collect,_simpletypeIknownTypesForBody_collect,_simpletypeIknownTypes_collect,_simpletypeIknownValues_collect,_simpletypeIlabels_collect,_simpletypeImethods_collect,_simpletypeImoduleTypes,_simpletypeImoduleValues,_simpletypeImodules,_simpletypeIname,_simpletypeIres,_simpletypeIself) =
                (simpletype_ (_simpletypeOclassname)
                             (_simpletypeOconstructors_collect)
                             (_simpletypeOconstructors_dist)
                             (_simpletypeOcurrentModule)
                             (_simpletypeOimportedModule)
                             (_simpletypeOinstancename)
                             (_simpletypeOknownKinds)
                             (_simpletypeOknownKinds_collect)
                             (_simpletypeOknownTypes)
                             (_simpletypeOknownTypesForBody_collect)
                             (_simpletypeOknownTypes_collect)
                             (_simpletypeOknownValues)
                             (_simpletypeOknownValues_collect)
                             (_simpletypeOlabels_collect)
                             (_simpletypeOlabels_dist)
                             (_simpletypeOlocal)
                             (_simpletypeOmethods_collect)
                             (_simpletypeOmethods_dist)
                             (_simpletypeOmoduleTypes)
                             (_simpletypeOmoduleValues)
                             (_simpletypeOnameType)
                             (_simpletypeOtoplevel))
            ( _constructorsIconstructors,_constructorsIconstructors_collect,_constructorsIknownKinds_collect,_constructorsIknownTypes_collect,_constructorsIknownValues_collect,_constructorsIlabels,_constructorsIlabels_collect,_constructorsImethods_collect,_constructorsImoduleTypes,_constructorsImoduleValues,_constructorsImodules,_constructorsIres,_constructorsIself) =
                (constructors_ (_constructorsOclassname)
                               (_constructorsOconstructors_collect)
                               (_constructorsOconstructors_dist)
                               (_constructorsOcurrentModule)
                               (_constructorsOimportedModule)
                               (_constructorsOinstancename)
                               (_constructorsOknownGenerics)
                               (_constructorsOknownKinds)
                               (_constructorsOknownKinds_collect)
                               (_constructorsOknownTypes)
                               (_constructorsOknownTypes_collect)
                               (_constructorsOknownValues)
                               (_constructorsOknownValues_collect)
                               (_constructorsOlabels_collect)
                               (_constructorsOlabels_dist)
                               (_constructorsOlocal)
                               (_constructorsOmethods_collect)
                               (_constructorsOmethods_dist)
                               (_constructorsOmoduleTypes)
                               (_constructorsOmoduleValues)
                               (_constructorsOnameType)
                               (_constructorsOtoplevel))
            ( _derivingsIconstructors_collect,_derivingsIknownKinds_collect,_derivingsIknownTypes_collect,_derivingsIknownValues_collect,_derivingsIlabels_collect,_derivingsImethods_collect,_derivingsImoduleTypes,_derivingsImoduleValues,_derivingsImodules,_derivingsIoriginalSelf,_derivingsIres,_derivingsIself) =
                (derivings_ (_derivingsOclassname)
                            (_derivingsOconstructors_collect)
                            (_derivingsOconstructors_dist)
                            (_derivingsOcurrentModule)
                            (_derivingsOimportedModule)
                            (_derivingsOinstancename)
                            (_derivingsOknownKinds)
                            (_derivingsOknownKinds_collect)
                            (_derivingsOknownTypes)
                            (_derivingsOknownTypes_collect)
                            (_derivingsOknownValues)
                            (_derivingsOknownValues_collect)
                            (_derivingsOlabels_collect)
                            (_derivingsOlabels_dist)
                            (_derivingsOlocal)
                            (_derivingsOmethods_collect)
                            (_derivingsOmethods_dist)
                            (_derivingsOmoduleTypes)
                            (_derivingsOmoduleValues)
                            (_derivingsOnameType)
                            (_derivingsOtoplevel))
            -- "./Names.inc.lag"(line 729, column 9)
            (_lhsOknownTypes_collect@_) =
                _simpletypeIknownTypes_collect
            -- "./Names.inc.lag"(line 728, column 9)
            (_simpletypeOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- "./Names.inc.lag"(line 727, column 9)
            (_constructorsOknownTypes@_) =
                _simpletypeIknownTypesForBody_collect `mergeFM` _lhsIknownTypes
            -- "./Names.inc.lag"(line 726, column 9)
            (_simpletypeOknownTypesForBody_collect@_) =
                emptyFM
            -- "./NameTypes.inc.lag"(line 301, column 9)
            (_derivingsOnameType@_) =
                ref_Typ
            -- "./ModuleInformation.inc.lag"(line 317, column 9)
            (_lhsOlabels_collect@_) =
                add _lhsIlabels_collect
                    (_simpletypeIname,_constructorsIlabels)
            -- "./ModuleInformation.inc.lag"(line 315, column 9)
            (_lhsOconstructors_collect@_) =
                add _lhsIconstructors_collect
                    (_simpletypeIname,_constructorsIconstructors)
            -- use rule
            (_lhsOmodules@_) =
                _contextImodules `Set.union` _simpletypeImodules `Set.union` _constructorsImodules `Set.union` _derivingsImodules
            -- use rule
            (_lhsOres@_) =
                _contextIres ++ _simpletypeIres ++ _constructorsIres ++ _derivingsIres
            -- self rule
            (_self@_) =
                Declaration_Data _rangeIself _contextIself _simpletypeIself _constructorsIself _derivingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _derivingsIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _derivingsIknownValues_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _derivingsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _derivingsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _derivingsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_contextOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_contextOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_contextOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_contextOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_contextOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_contextOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_contextOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_contextOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_contextOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_contextOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_contextOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_contextOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_contextOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_contextOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_contextOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_contextOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_contextOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_contextOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_contextOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_contextOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_contextOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_contextOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_simpletypeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_simpletypeOconstructors_collect@_) =
                _contextIconstructors_collect
            -- copy rule (down)
            (_simpletypeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_simpletypeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_simpletypeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_simpletypeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_simpletypeOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_simpletypeOknownKinds_collect@_) =
                _contextIknownKinds_collect
            -- copy rule (down)
            (_simpletypeOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_simpletypeOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_simpletypeOknownValues_collect@_) =
                _contextIknownValues_collect
            -- copy rule (chain)
            (_simpletypeOlabels_collect@_) =
                _contextIlabels_collect
            -- copy rule (down)
            (_simpletypeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_simpletypeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_simpletypeOmethods_collect@_) =
                _contextImethods_collect
            -- copy rule (down)
            (_simpletypeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_simpletypeOmoduleTypes@_) =
                _contextImoduleTypes
            -- copy rule (chain)
            (_simpletypeOmoduleValues@_) =
                _contextImoduleValues
            -- copy rule (down)
            (_simpletypeOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_simpletypeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_constructorsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_constructorsOconstructors_collect@_) =
                _simpletypeIconstructors_collect
            -- copy rule (down)
            (_constructorsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_constructorsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_constructorsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_constructorsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_constructorsOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_constructorsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_constructorsOknownKinds_collect@_) =
                _simpletypeIknownKinds_collect
            -- copy rule (chain)
            (_constructorsOknownTypes_collect@_) =
                _simpletypeIknownTypes_collect
            -- copy rule (down)
            (_constructorsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_constructorsOknownValues_collect@_) =
                _simpletypeIknownValues_collect
            -- copy rule (chain)
            (_constructorsOlabels_collect@_) =
                _simpletypeIlabels_collect
            -- copy rule (down)
            (_constructorsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_constructorsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_constructorsOmethods_collect@_) =
                _simpletypeImethods_collect
            -- copy rule (down)
            (_constructorsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_constructorsOmoduleTypes@_) =
                _simpletypeImoduleTypes
            -- copy rule (chain)
            (_constructorsOmoduleValues@_) =
                _simpletypeImoduleValues
            -- copy rule (down)
            (_constructorsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_constructorsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_derivingsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_derivingsOconstructors_collect@_) =
                _constructorsIconstructors_collect
            -- copy rule (down)
            (_derivingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_derivingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_derivingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_derivingsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_derivingsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_derivingsOknownKinds_collect@_) =
                _constructorsIknownKinds_collect
            -- copy rule (down)
            (_derivingsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_derivingsOknownTypes_collect@_) =
                _constructorsIknownTypes_collect
            -- copy rule (down)
            (_derivingsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_derivingsOknownValues_collect@_) =
                _constructorsIknownValues_collect
            -- copy rule (chain)
            (_derivingsOlabels_collect@_) =
                _constructorsIlabels_collect
            -- copy rule (down)
            (_derivingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_derivingsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_derivingsOmethods_collect@_) =
                _constructorsImethods_collect
            -- copy rule (down)
            (_derivingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_derivingsOmoduleTypes@_) =
                _constructorsImoduleTypes
            -- copy rule (chain)
            (_derivingsOmoduleValues@_) =
                _constructorsImoduleValues
            -- copy rule (down)
            (_derivingsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Declaration_Default :: (T_Range) ->
                           (T_Types) ->
                           (T_Declaration)
sem_Declaration_Default (range_) (types_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _typesIconstructors_collect :: (FMap Name Names)
            _typesIknownKinds_collect :: (FMap Name [Name])
            _typesIknownTypes_collect :: (FMap Name [Name])
            _typesIknownValues_collect :: (FMap Name [Name])
            _typesIlabels_collect :: (FMap Name Names)
            _typesImethods_collect :: (FMap Name Names)
            _typesImoduleTypes :: (FMap ModuleName [Name])
            _typesImoduleValues :: (FMap ModuleName [Name])
            _typesImodules :: (Set.Set Strings)
            _typesIres :: ([ResolveResult])
            _typesIself :: (Types)
            _typesOclassname :: (Maybe Name)
            _typesOconstructors_collect :: (FMap Name Names)
            _typesOconstructors_dist :: (FMap Name Names)
            _typesOcurrentModule :: (Strings)
            _typesOimportedModule :: (Bool)
            _typesOinstancename :: (Maybe Name)
            _typesOknownGenerics :: (FMap Name [Name])
            _typesOknownKinds :: (FMap Name [Name])
            _typesOknownKinds_collect :: (FMap Name [Name])
            _typesOknownTypes :: (FMap Name [Name])
            _typesOknownTypes_collect :: (FMap Name [Name])
            _typesOknownValues :: (FMap Name [Name])
            _typesOknownValues_collect :: (FMap Name [Name])
            _typesOlabels_collect :: (FMap Name Names)
            _typesOlabels_dist :: (FMap Name Names)
            _typesOlocal :: (Bool)
            _typesOmethods_collect :: (FMap Name Names)
            _typesOmethods_dist :: (FMap Name Names)
            _typesOmoduleTypes :: (FMap ModuleName [Name])
            _typesOmoduleValues :: (FMap ModuleName [Name])
            _typesOnameType :: (NameType)
            _typesOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _typesIconstructors_collect,_typesIknownKinds_collect,_typesIknownTypes_collect,_typesIknownValues_collect,_typesIlabels_collect,_typesImethods_collect,_typesImoduleTypes,_typesImoduleValues,_typesImodules,_typesIres,_typesIself) =
                (types_ (_typesOclassname)
                        (_typesOconstructors_collect)
                        (_typesOconstructors_dist)
                        (_typesOcurrentModule)
                        (_typesOimportedModule)
                        (_typesOinstancename)
                        (_typesOknownGenerics)
                        (_typesOknownKinds)
                        (_typesOknownKinds_collect)
                        (_typesOknownTypes)
                        (_typesOknownTypes_collect)
                        (_typesOknownValues)
                        (_typesOknownValues_collect)
                        (_typesOlabels_collect)
                        (_typesOlabels_dist)
                        (_typesOlocal)
                        (_typesOmethods_collect)
                        (_typesOmethods_dist)
                        (_typesOmoduleTypes)
                        (_typesOmoduleValues)
                        (_typesOnameType)
                        (_typesOtoplevel))
            -- "./NameTypes.inc.lag"(line 312, column 9)
            (_typesOnameType@_) =
                ref_Typ
            -- use rule
            (_lhsOmodules@_) =
                _typesImodules
            -- use rule
            (_lhsOres@_) =
                _typesIres
            -- self rule
            (_self@_) =
                Declaration_Default _rangeIself _typesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typesIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _typesIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _typesIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _typesIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typesIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typesImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _typesImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _typesImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typesOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_typesOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_typesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typesOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_typesOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_typesOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_typesOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_typesOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_typesOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_typesOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_typesOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_typesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typesOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_typesOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_typesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typesOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_typesOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_typesOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Declaration_Dependency :: (T_Range) ->
                              (Bool) ->
                              (T_Name) ->
                              (T_DependencyBindings) ->
                              (T_Declaration)
sem_Declaration_Dependency (range_) (typelevel_) (name_) (bindings_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _bindingsIconstructors_collect :: (FMap Name Names)
            _bindingsIknownKinds_collect :: (FMap Name [Name])
            _bindingsIknownTypes_collect :: (FMap Name [Name])
            _bindingsIknownValues_collect :: (FMap Name [Name])
            _bindingsIlabels_collect :: (FMap Name Names)
            _bindingsImethods_collect :: (FMap Name Names)
            _bindingsImoduleTypes :: (FMap ModuleName [Name])
            _bindingsImoduleValues :: (FMap ModuleName [Name])
            _bindingsImodules :: (Set.Set Strings)
            _bindingsIres :: ([ResolveResult])
            _bindingsIself :: (DependencyBindings)
            _bindingsOclassname :: (Maybe Name)
            _bindingsOconstructors_collect :: (FMap Name Names)
            _bindingsOconstructors_dist :: (FMap Name Names)
            _bindingsOcurrentModule :: (Strings)
            _bindingsOimportedModule :: (Bool)
            _bindingsOinstancename :: (Maybe Name)
            _bindingsOknownKinds :: (FMap Name [Name])
            _bindingsOknownKinds_collect :: (FMap Name [Name])
            _bindingsOknownTypes :: (FMap Name [Name])
            _bindingsOknownTypes_collect :: (FMap Name [Name])
            _bindingsOknownValues :: (FMap Name [Name])
            _bindingsOknownValues_collect :: (FMap Name [Name])
            _bindingsOlabels_collect :: (FMap Name Names)
            _bindingsOlabels_dist :: (FMap Name Names)
            _bindingsOlocal :: (Bool)
            _bindingsOmethods_collect :: (FMap Name Names)
            _bindingsOmethods_dist :: (FMap Name Names)
            _bindingsOmoduleTypes :: (FMap ModuleName [Name])
            _bindingsOmoduleValues :: (FMap ModuleName [Name])
            _bindingsOnameType :: (NameType)
            _bindingsOtoplevel :: (Bool)
            _bindingsOtypelevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _bindingsIconstructors_collect,_bindingsIknownKinds_collect,_bindingsIknownTypes_collect,_bindingsIknownValues_collect,_bindingsIlabels_collect,_bindingsImethods_collect,_bindingsImoduleTypes,_bindingsImoduleValues,_bindingsImodules,_bindingsIres,_bindingsIself) =
                (bindings_ (_bindingsOclassname)
                           (_bindingsOconstructors_collect)
                           (_bindingsOconstructors_dist)
                           (_bindingsOcurrentModule)
                           (_bindingsOimportedModule)
                           (_bindingsOinstancename)
                           (_bindingsOknownKinds)
                           (_bindingsOknownKinds_collect)
                           (_bindingsOknownTypes)
                           (_bindingsOknownTypes_collect)
                           (_bindingsOknownValues)
                           (_bindingsOknownValues_collect)
                           (_bindingsOlabels_collect)
                           (_bindingsOlabels_dist)
                           (_bindingsOlocal)
                           (_bindingsOmethods_collect)
                           (_bindingsOmethods_dist)
                           (_bindingsOmoduleTypes)
                           (_bindingsOmoduleValues)
                           (_bindingsOnameType)
                           (_bindingsOtoplevel)
                           (_bindingsOtypelevel))
            -- "./NameTypes.inc.lag"(line 314, column 9)
            (_nameOnameType@_) =
                if typelevel_ then softref_Typ
                              else softref_Val
            -- "./ModuleInformation.inc.lag"(line 223, column 9)
            (_bindingsOtypelevel@_) =
                typelevel_
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _bindingsImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _bindingsIres
            -- self rule
            (_self@_) =
                Declaration_Dependency _rangeIself typelevel_ _nameIself _bindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _bindingsIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _bindingsIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _bindingsIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _bindingsIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _bindingsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _bindingsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _bindingsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _bindingsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_bindingsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_bindingsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_bindingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_bindingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_bindingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_bindingsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_bindingsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_bindingsOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_bindingsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_bindingsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (down)
            (_bindingsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_bindingsOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_bindingsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_bindingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_bindingsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_bindingsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_bindingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_bindingsOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_bindingsOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_bindingsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_bindingsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Declaration_Empty :: (T_Range) ->
                         (T_Declaration)
sem_Declaration_Empty (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                Declaration_Empty _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Declaration_Fixity :: (T_Range) ->
                          (T_Fixity) ->
                          (T_MaybeInt) ->
                          (T_Names) ->
                          (T_Declaration)
sem_Declaration_Fixity (range_) (fixity_) (priority_) (operators_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _fixityIconstructors_collect :: (FMap Name Names)
            _fixityIknownKinds_collect :: (FMap Name [Name])
            _fixityIknownTypes_collect :: (FMap Name [Name])
            _fixityIknownValues_collect :: (FMap Name [Name])
            _fixityIlabels_collect :: (FMap Name Names)
            _fixityImethods_collect :: (FMap Name Names)
            _fixityImoduleTypes :: (FMap ModuleName [Name])
            _fixityImoduleValues :: (FMap ModuleName [Name])
            _fixityImodules :: (Set.Set Strings)
            _fixityIres :: ([ResolveResult])
            _fixityIself :: (Fixity)
            _fixityOclassname :: (Maybe Name)
            _fixityOconstructors_collect :: (FMap Name Names)
            _fixityOconstructors_dist :: (FMap Name Names)
            _fixityOcurrentModule :: (Strings)
            _fixityOimportedModule :: (Bool)
            _fixityOinstancename :: (Maybe Name)
            _fixityOknownKinds :: (FMap Name [Name])
            _fixityOknownKinds_collect :: (FMap Name [Name])
            _fixityOknownTypes :: (FMap Name [Name])
            _fixityOknownTypes_collect :: (FMap Name [Name])
            _fixityOknownValues :: (FMap Name [Name])
            _fixityOknownValues_collect :: (FMap Name [Name])
            _fixityOlabels_collect :: (FMap Name Names)
            _fixityOlabels_dist :: (FMap Name Names)
            _fixityOlocal :: (Bool)
            _fixityOmethods_collect :: (FMap Name Names)
            _fixityOmethods_dist :: (FMap Name Names)
            _fixityOmoduleTypes :: (FMap ModuleName [Name])
            _fixityOmoduleValues :: (FMap ModuleName [Name])
            _fixityOnameType :: (NameType)
            _fixityOtoplevel :: (Bool)
            _priorityIconstructors_collect :: (FMap Name Names)
            _priorityIknownKinds_collect :: (FMap Name [Name])
            _priorityIknownTypes_collect :: (FMap Name [Name])
            _priorityIknownValues_collect :: (FMap Name [Name])
            _priorityIlabels_collect :: (FMap Name Names)
            _priorityImethods_collect :: (FMap Name Names)
            _priorityImoduleTypes :: (FMap ModuleName [Name])
            _priorityImoduleValues :: (FMap ModuleName [Name])
            _priorityImodules :: (Set.Set Strings)
            _priorityIres :: ([ResolveResult])
            _priorityIself :: (MaybeInt)
            _priorityOclassname :: (Maybe Name)
            _priorityOconstructors_collect :: (FMap Name Names)
            _priorityOconstructors_dist :: (FMap Name Names)
            _priorityOcurrentModule :: (Strings)
            _priorityOimportedModule :: (Bool)
            _priorityOinstancename :: (Maybe Name)
            _priorityOknownKinds :: (FMap Name [Name])
            _priorityOknownKinds_collect :: (FMap Name [Name])
            _priorityOknownTypes :: (FMap Name [Name])
            _priorityOknownTypes_collect :: (FMap Name [Name])
            _priorityOknownValues :: (FMap Name [Name])
            _priorityOknownValues_collect :: (FMap Name [Name])
            _priorityOlabels_collect :: (FMap Name Names)
            _priorityOlabels_dist :: (FMap Name Names)
            _priorityOlocal :: (Bool)
            _priorityOmethods_collect :: (FMap Name Names)
            _priorityOmethods_dist :: (FMap Name Names)
            _priorityOmoduleTypes :: (FMap ModuleName [Name])
            _priorityOmoduleValues :: (FMap ModuleName [Name])
            _priorityOnameType :: (NameType)
            _priorityOtoplevel :: (Bool)
            _operatorsIconstructors_collect :: (FMap Name Names)
            _operatorsIknownKinds_collect :: (FMap Name [Name])
            _operatorsIknownTypes_collect :: (FMap Name [Name])
            _operatorsIknownValues_collect :: (FMap Name [Name])
            _operatorsIlabels_collect :: (FMap Name Names)
            _operatorsImethods_collect :: (FMap Name Names)
            _operatorsImoduleTypes :: (FMap ModuleName [Name])
            _operatorsImoduleValues :: (FMap ModuleName [Name])
            _operatorsImodules :: (Set.Set Strings)
            _operatorsIoriginalSelf :: (Names)
            _operatorsIres :: ([ResolveResult])
            _operatorsIself :: (Names)
            _operatorsOclassname :: (Maybe Name)
            _operatorsOconstructors_collect :: (FMap Name Names)
            _operatorsOconstructors_dist :: (FMap Name Names)
            _operatorsOcurrentModule :: (Strings)
            _operatorsOimportedModule :: (Bool)
            _operatorsOinstancename :: (Maybe Name)
            _operatorsOknownKinds :: (FMap Name [Name])
            _operatorsOknownKinds_collect :: (FMap Name [Name])
            _operatorsOknownTypes :: (FMap Name [Name])
            _operatorsOknownTypes_collect :: (FMap Name [Name])
            _operatorsOknownValues :: (FMap Name [Name])
            _operatorsOknownValues_collect :: (FMap Name [Name])
            _operatorsOlabels_collect :: (FMap Name Names)
            _operatorsOlabels_dist :: (FMap Name Names)
            _operatorsOlocal :: (Bool)
            _operatorsOmethods_collect :: (FMap Name Names)
            _operatorsOmethods_dist :: (FMap Name Names)
            _operatorsOmoduleTypes :: (FMap ModuleName [Name])
            _operatorsOmoduleValues :: (FMap ModuleName [Name])
            _operatorsOnameType :: (NameType)
            _operatorsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _fixityIconstructors_collect,_fixityIknownKinds_collect,_fixityIknownTypes_collect,_fixityIknownValues_collect,_fixityIlabels_collect,_fixityImethods_collect,_fixityImoduleTypes,_fixityImoduleValues,_fixityImodules,_fixityIres,_fixityIself) =
                (fixity_ (_fixityOclassname)
                         (_fixityOconstructors_collect)
                         (_fixityOconstructors_dist)
                         (_fixityOcurrentModule)
                         (_fixityOimportedModule)
                         (_fixityOinstancename)
                         (_fixityOknownKinds)
                         (_fixityOknownKinds_collect)
                         (_fixityOknownTypes)
                         (_fixityOknownTypes_collect)
                         (_fixityOknownValues)
                         (_fixityOknownValues_collect)
                         (_fixityOlabels_collect)
                         (_fixityOlabels_dist)
                         (_fixityOlocal)
                         (_fixityOmethods_collect)
                         (_fixityOmethods_dist)
                         (_fixityOmoduleTypes)
                         (_fixityOmoduleValues)
                         (_fixityOnameType)
                         (_fixityOtoplevel))
            ( _priorityIconstructors_collect,_priorityIknownKinds_collect,_priorityIknownTypes_collect,_priorityIknownValues_collect,_priorityIlabels_collect,_priorityImethods_collect,_priorityImoduleTypes,_priorityImoduleValues,_priorityImodules,_priorityIres,_priorityIself) =
                (priority_ (_priorityOclassname)
                           (_priorityOconstructors_collect)
                           (_priorityOconstructors_dist)
                           (_priorityOcurrentModule)
                           (_priorityOimportedModule)
                           (_priorityOinstancename)
                           (_priorityOknownKinds)
                           (_priorityOknownKinds_collect)
                           (_priorityOknownTypes)
                           (_priorityOknownTypes_collect)
                           (_priorityOknownValues)
                           (_priorityOknownValues_collect)
                           (_priorityOlabels_collect)
                           (_priorityOlabels_dist)
                           (_priorityOlocal)
                           (_priorityOmethods_collect)
                           (_priorityOmethods_dist)
                           (_priorityOmoduleTypes)
                           (_priorityOmoduleValues)
                           (_priorityOnameType)
                           (_priorityOtoplevel))
            ( _operatorsIconstructors_collect,_operatorsIknownKinds_collect,_operatorsIknownTypes_collect,_operatorsIknownValues_collect,_operatorsIlabels_collect,_operatorsImethods_collect,_operatorsImoduleTypes,_operatorsImoduleValues,_operatorsImodules,_operatorsIoriginalSelf,_operatorsIres,_operatorsIself) =
                (operators_ (_operatorsOclassname)
                            (_operatorsOconstructors_collect)
                            (_operatorsOconstructors_dist)
                            (_operatorsOcurrentModule)
                            (_operatorsOimportedModule)
                            (_operatorsOinstancename)
                            (_operatorsOknownKinds)
                            (_operatorsOknownKinds_collect)
                            (_operatorsOknownTypes)
                            (_operatorsOknownTypes_collect)
                            (_operatorsOknownValues)
                            (_operatorsOknownValues_collect)
                            (_operatorsOlabels_collect)
                            (_operatorsOlabels_dist)
                            (_operatorsOlocal)
                            (_operatorsOmethods_collect)
                            (_operatorsOmethods_dist)
                            (_operatorsOmoduleTypes)
                            (_operatorsOmoduleValues)
                            (_operatorsOnameType)
                            (_operatorsOtoplevel))
            -- "./NameTypes.inc.lag"(line 333, column 9)
            (_operatorsOnameType@_) =
                softref_Val
            -- use rule
            (_lhsOmodules@_) =
                _fixityImodules `Set.union` _priorityImodules `Set.union` _operatorsImodules
            -- use rule
            (_lhsOres@_) =
                _fixityIres ++ _priorityIres ++ _operatorsIres
            -- self rule
            (_self@_) =
                Declaration_Fixity _rangeIself _fixityIself _priorityIself _operatorsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _operatorsIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _operatorsIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _operatorsIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _operatorsIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _operatorsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _operatorsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _operatorsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _operatorsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_fixityOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_fixityOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_fixityOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_fixityOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_fixityOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_fixityOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_fixityOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_fixityOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_fixityOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_fixityOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_fixityOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_fixityOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_fixityOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_fixityOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_fixityOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_fixityOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_fixityOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_fixityOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_fixityOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_fixityOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_fixityOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_priorityOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_priorityOconstructors_collect@_) =
                _fixityIconstructors_collect
            -- copy rule (down)
            (_priorityOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_priorityOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_priorityOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_priorityOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_priorityOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_priorityOknownKinds_collect@_) =
                _fixityIknownKinds_collect
            -- copy rule (down)
            (_priorityOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_priorityOknownTypes_collect@_) =
                _fixityIknownTypes_collect
            -- copy rule (down)
            (_priorityOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_priorityOknownValues_collect@_) =
                _fixityIknownValues_collect
            -- copy rule (chain)
            (_priorityOlabels_collect@_) =
                _fixityIlabels_collect
            -- copy rule (down)
            (_priorityOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_priorityOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_priorityOmethods_collect@_) =
                _fixityImethods_collect
            -- copy rule (down)
            (_priorityOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_priorityOmoduleTypes@_) =
                _fixityImoduleTypes
            -- copy rule (chain)
            (_priorityOmoduleValues@_) =
                _fixityImoduleValues
            -- copy rule (down)
            (_priorityOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_priorityOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_operatorsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_operatorsOconstructors_collect@_) =
                _priorityIconstructors_collect
            -- copy rule (down)
            (_operatorsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_operatorsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_operatorsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_operatorsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_operatorsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_operatorsOknownKinds_collect@_) =
                _priorityIknownKinds_collect
            -- copy rule (down)
            (_operatorsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_operatorsOknownTypes_collect@_) =
                _priorityIknownTypes_collect
            -- copy rule (down)
            (_operatorsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_operatorsOknownValues_collect@_) =
                _priorityIknownValues_collect
            -- copy rule (chain)
            (_operatorsOlabels_collect@_) =
                _priorityIlabels_collect
            -- copy rule (down)
            (_operatorsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_operatorsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_operatorsOmethods_collect@_) =
                _priorityImethods_collect
            -- copy rule (down)
            (_operatorsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_operatorsOmoduleTypes@_) =
                _priorityImoduleTypes
            -- copy rule (chain)
            (_operatorsOmoduleValues@_) =
                _priorityImoduleValues
            -- copy rule (down)
            (_operatorsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Declaration_FunctionBindings :: (T_Range) ->
                                    (T_FunctionBindings) ->
                                    (T_Declaration)
sem_Declaration_FunctionBindings (range_) (bindings_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _bindingsIconstructors_collect :: (FMap Name Names)
            _bindingsIknownKinds_collect :: (FMap Name [Name])
            _bindingsIknownTypes_collect :: (FMap Name [Name])
            _bindingsIknownValues_collect :: (FMap Name [Name])
            _bindingsIlabels_collect :: (FMap Name Names)
            _bindingsImethods_collect :: (FMap Name Names)
            _bindingsImoduleTypes :: (FMap ModuleName [Name])
            _bindingsImoduleValues :: (FMap ModuleName [Name])
            _bindingsImodules :: (Set.Set Strings)
            _bindingsIname :: (Name)
            _bindingsIres :: ([ResolveResult])
            _bindingsIself :: (FunctionBindings)
            _bindingsOclassname :: (Maybe Name)
            _bindingsOconstructors_collect :: (FMap Name Names)
            _bindingsOconstructors_dist :: (FMap Name Names)
            _bindingsOcurrentModule :: (Strings)
            _bindingsOimportedModule :: (Bool)
            _bindingsOinstancename :: (Maybe Name)
            _bindingsOknownGenerics :: (FMap Name [Name])
            _bindingsOknownKinds :: (FMap Name [Name])
            _bindingsOknownKinds_collect :: (FMap Name [Name])
            _bindingsOknownTypes :: (FMap Name [Name])
            _bindingsOknownTypes_collect :: (FMap Name [Name])
            _bindingsOknownValues :: (FMap Name [Name])
            _bindingsOknownValues_collect :: (FMap Name [Name])
            _bindingsOlabels_collect :: (FMap Name Names)
            _bindingsOlabels_dist :: (FMap Name Names)
            _bindingsOlocal :: (Bool)
            _bindingsOmethods_collect :: (FMap Name Names)
            _bindingsOmethods_dist :: (FMap Name Names)
            _bindingsOmoduleTypes :: (FMap ModuleName [Name])
            _bindingsOmoduleValues :: (FMap ModuleName [Name])
            _bindingsOnameType :: (NameType)
            _bindingsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _bindingsIconstructors_collect,_bindingsIknownKinds_collect,_bindingsIknownTypes_collect,_bindingsIknownValues_collect,_bindingsIlabels_collect,_bindingsImethods_collect,_bindingsImoduleTypes,_bindingsImoduleValues,_bindingsImodules,_bindingsIname,_bindingsIres,_bindingsIself) =
                (bindings_ (_bindingsOclassname)
                           (_bindingsOconstructors_collect)
                           (_bindingsOconstructors_dist)
                           (_bindingsOcurrentModule)
                           (_bindingsOimportedModule)
                           (_bindingsOinstancename)
                           (_bindingsOknownGenerics)
                           (_bindingsOknownKinds)
                           (_bindingsOknownKinds_collect)
                           (_bindingsOknownTypes)
                           (_bindingsOknownTypes_collect)
                           (_bindingsOknownValues)
                           (_bindingsOknownValues_collect)
                           (_bindingsOlabels_collect)
                           (_bindingsOlabels_dist)
                           (_bindingsOlocal)
                           (_bindingsOmethods_collect)
                           (_bindingsOmethods_dist)
                           (_bindingsOmoduleTypes)
                           (_bindingsOmoduleValues)
                           (_bindingsOnameType)
                           (_bindingsOtoplevel))
            -- "./NameTypes.inc.lag"(line 254, column 9)
            (_bindingsOnameType@_) =
                if Maybe.isJust _lhsIinstancename then
                  ref_Val
                else if Maybe.isJust _lhsIclassname then
                  softref_Val
                else
                  Def_Val
            -- use rule
            (_lhsOmodules@_) =
                _bindingsImodules
            -- use rule
            (_lhsOres@_) =
                _bindingsIres
            -- self rule
            (_self@_) =
                Declaration_FunctionBindings _rangeIself _bindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _bindingsIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _bindingsIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _bindingsIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _bindingsIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _bindingsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _bindingsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _bindingsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _bindingsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_bindingsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_bindingsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_bindingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_bindingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_bindingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_bindingsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_bindingsOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_bindingsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_bindingsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_bindingsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_bindingsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_bindingsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_bindingsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_bindingsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_bindingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_bindingsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_bindingsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_bindingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_bindingsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_bindingsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_bindingsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Declaration_GenericTypeSignature :: (T_Range) ->
                                        (T_Name) ->
                                        (T_KindAnnotatedNames) ->
                                        (T_KindAnnotatedNames) ->
                                        (T_Type) ->
                                        (T_Declaration)
sem_Declaration_GenericTypeSignature (range_) (name_) (generics_) (parametrics_) (type_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _genericsIakinds :: ([MaybeKind])
            _genericsIconstructors_collect :: (FMap Name Names)
            _genericsIknownKinds_collect :: (FMap Name [Name])
            _genericsIknownTypes_collect :: (FMap Name [Name])
            _genericsIknownValues_collect :: (FMap Name [Name])
            _genericsIlabels_collect :: (FMap Name Names)
            _genericsImethods_collect :: (FMap Name Names)
            _genericsImoduleTypes :: (FMap ModuleName [Name])
            _genericsImoduleValues :: (FMap ModuleName [Name])
            _genericsImodules :: (Set.Set Strings)
            _genericsIres :: ([ResolveResult])
            _genericsIself :: (KindAnnotatedNames)
            _genericsOclassname :: (Maybe Name)
            _genericsOconstructors_collect :: (FMap Name Names)
            _genericsOconstructors_dist :: (FMap Name Names)
            _genericsOcurrentModule :: (Strings)
            _genericsOimportedModule :: (Bool)
            _genericsOinstancename :: (Maybe Name)
            _genericsOknownKinds :: (FMap Name [Name])
            _genericsOknownKinds_collect :: (FMap Name [Name])
            _genericsOknownTypes :: (FMap Name [Name])
            _genericsOknownTypes_collect :: (FMap Name [Name])
            _genericsOknownValues :: (FMap Name [Name])
            _genericsOknownValues_collect :: (FMap Name [Name])
            _genericsOlabels_collect :: (FMap Name Names)
            _genericsOlabels_dist :: (FMap Name Names)
            _genericsOlocal :: (Bool)
            _genericsOmethods_collect :: (FMap Name Names)
            _genericsOmethods_dist :: (FMap Name Names)
            _genericsOmoduleTypes :: (FMap ModuleName [Name])
            _genericsOmoduleValues :: (FMap ModuleName [Name])
            _genericsOnameType :: (NameType)
            _genericsOtoplevel :: (Bool)
            _parametricsIakinds :: ([MaybeKind])
            _parametricsIconstructors_collect :: (FMap Name Names)
            _parametricsIknownKinds_collect :: (FMap Name [Name])
            _parametricsIknownTypes_collect :: (FMap Name [Name])
            _parametricsIknownValues_collect :: (FMap Name [Name])
            _parametricsIlabels_collect :: (FMap Name Names)
            _parametricsImethods_collect :: (FMap Name Names)
            _parametricsImoduleTypes :: (FMap ModuleName [Name])
            _parametricsImoduleValues :: (FMap ModuleName [Name])
            _parametricsImodules :: (Set.Set Strings)
            _parametricsIres :: ([ResolveResult])
            _parametricsIself :: (KindAnnotatedNames)
            _parametricsOclassname :: (Maybe Name)
            _parametricsOconstructors_collect :: (FMap Name Names)
            _parametricsOconstructors_dist :: (FMap Name Names)
            _parametricsOcurrentModule :: (Strings)
            _parametricsOimportedModule :: (Bool)
            _parametricsOinstancename :: (Maybe Name)
            _parametricsOknownKinds :: (FMap Name [Name])
            _parametricsOknownKinds_collect :: (FMap Name [Name])
            _parametricsOknownTypes :: (FMap Name [Name])
            _parametricsOknownTypes_collect :: (FMap Name [Name])
            _parametricsOknownValues :: (FMap Name [Name])
            _parametricsOknownValues_collect :: (FMap Name [Name])
            _parametricsOlabels_collect :: (FMap Name Names)
            _parametricsOlabels_dist :: (FMap Name Names)
            _parametricsOlocal :: (Bool)
            _parametricsOmethods_collect :: (FMap Name Names)
            _parametricsOmethods_dist :: (FMap Name Names)
            _parametricsOmoduleTypes :: (FMap ModuleName [Name])
            _parametricsOmoduleValues :: (FMap ModuleName [Name])
            _parametricsOnameType :: (NameType)
            _parametricsOtoplevel :: (Bool)
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIknownKinds_collect :: (FMap Name [Name])
            _typeIknownTypes_collect :: (FMap Name [Name])
            _typeIknownValues_collect :: (FMap Name [Name])
            _typeIlabels_collect :: (FMap Name Names)
            _typeImethods_collect :: (FMap Name Names)
            _typeImoduleTypes :: (FMap ModuleName [Name])
            _typeImoduleValues :: (FMap ModuleName [Name])
            _typeImodules :: (Set.Set Strings)
            _typeIres :: ([ResolveResult])
            _typeIself :: (Type)
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOimportedModule :: (Bool)
            _typeOinstancename :: (Maybe Name)
            _typeOknownGenerics :: (FMap Name [Name])
            _typeOknownKinds :: (FMap Name [Name])
            _typeOknownKinds_collect :: (FMap Name [Name])
            _typeOknownTypes :: (FMap Name [Name])
            _typeOknownTypes_collect :: (FMap Name [Name])
            _typeOknownValues :: (FMap Name [Name])
            _typeOknownValues_collect :: (FMap Name [Name])
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOmoduleTypes :: (FMap ModuleName [Name])
            _typeOmoduleValues :: (FMap ModuleName [Name])
            _typeOnameType :: (NameType)
            _typeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _genericsIakinds,_genericsIconstructors_collect,_genericsIknownKinds_collect,_genericsIknownTypes_collect,_genericsIknownValues_collect,_genericsIlabels_collect,_genericsImethods_collect,_genericsImoduleTypes,_genericsImoduleValues,_genericsImodules,_genericsIres,_genericsIself) =
                (generics_ (_genericsOclassname)
                           (_genericsOconstructors_collect)
                           (_genericsOconstructors_dist)
                           (_genericsOcurrentModule)
                           (_genericsOimportedModule)
                           (_genericsOinstancename)
                           (_genericsOknownKinds)
                           (_genericsOknownKinds_collect)
                           (_genericsOknownTypes)
                           (_genericsOknownTypes_collect)
                           (_genericsOknownValues)
                           (_genericsOknownValues_collect)
                           (_genericsOlabels_collect)
                           (_genericsOlabels_dist)
                           (_genericsOlocal)
                           (_genericsOmethods_collect)
                           (_genericsOmethods_dist)
                           (_genericsOmoduleTypes)
                           (_genericsOmoduleValues)
                           (_genericsOnameType)
                           (_genericsOtoplevel))
            ( _parametricsIakinds,_parametricsIconstructors_collect,_parametricsIknownKinds_collect,_parametricsIknownTypes_collect,_parametricsIknownValues_collect,_parametricsIlabels_collect,_parametricsImethods_collect,_parametricsImoduleTypes,_parametricsImoduleValues,_parametricsImodules,_parametricsIres,_parametricsIself) =
                (parametrics_ (_parametricsOclassname)
                              (_parametricsOconstructors_collect)
                              (_parametricsOconstructors_dist)
                              (_parametricsOcurrentModule)
                              (_parametricsOimportedModule)
                              (_parametricsOinstancename)
                              (_parametricsOknownKinds)
                              (_parametricsOknownKinds_collect)
                              (_parametricsOknownTypes)
                              (_parametricsOknownTypes_collect)
                              (_parametricsOknownValues)
                              (_parametricsOknownValues_collect)
                              (_parametricsOlabels_collect)
                              (_parametricsOlabels_dist)
                              (_parametricsOlocal)
                              (_parametricsOmethods_collect)
                              (_parametricsOmethods_dist)
                              (_parametricsOmoduleTypes)
                              (_parametricsOmoduleValues)
                              (_parametricsOnameType)
                              (_parametricsOtoplevel))
            ( _typeIconstructors_collect,_typeIknownKinds_collect,_typeIknownTypes_collect,_typeIknownValues_collect,_typeIlabels_collect,_typeImethods_collect,_typeImoduleTypes,_typeImoduleValues,_typeImodules,_typeIres,_typeIself) =
                (type_ (_typeOclassname)
                       (_typeOconstructors_collect)
                       (_typeOconstructors_dist)
                       (_typeOcurrentModule)
                       (_typeOimportedModule)
                       (_typeOinstancename)
                       (_typeOknownGenerics)
                       (_typeOknownKinds)
                       (_typeOknownKinds_collect)
                       (_typeOknownTypes)
                       (_typeOknownTypes_collect)
                       (_typeOknownValues)
                       (_typeOknownValues_collect)
                       (_typeOlabels_collect)
                       (_typeOlabels_dist)
                       (_typeOlocal)
                       (_typeOmethods_collect)
                       (_typeOmethods_dist)
                       (_typeOmoduleTypes)
                       (_typeOmoduleValues)
                       (_typeOnameType)
                       (_typeOtoplevel))
            -- "./Names.inc.lag"(line 773, column 9)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- "./Names.inc.lag"(line 772, column 9)
            (_typeOknownKinds@_) =
                _parametricsIknownKinds_collect `mergeFM` _lhsIknownKinds
            -- "./Names.inc.lag"(line 771, column 9)
            (_genericsOknownKinds_collect@_) =
                emptyFM
            -- "./Names.inc.lag"(line 769, column 9)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- "./Names.inc.lag"(line 767, column 9)
            (_typeOknownGenerics@_) =
                _genericsIknownTypes_collect
            -- "./Names.inc.lag"(line 766, column 9)
            (_typeOknownTypes@_) =
                _parametricsIknownTypes_collect `mergeFM` _lhsIknownTypes
            -- "./Names.inc.lag"(line 765, column 9)
            (_genericsOknownTypes_collect@_) =
                emptyFM
            -- "./NameTypes.inc.lag"(line 324, column 9)
            (_typeOnameType@_) =
                deforref_Typ
            -- "./NameTypes.inc.lag"(line 323, column 9)
            (_parametricsOnameType@_) =
                Def_Typ
            -- "./NameTypes.inc.lag"(line 322, column 9)
            (_genericsOnameType@_) =
                Def_Typ
            -- "./NameTypes.inc.lag"(line 321, column 9)
            (_nameOnameType@_) =
                Def_Val
            -- "./ModuleInformation.inc.lag"(line 152, column 8)
            (_typeOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 151, column 8)
            (_parametricsOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 150, column 8)
            (_genericsOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 244, column 9)
            (_isMPCstyle@_) =
                length _genericsIself == 1 && length _parametricsIself == 0
                  && let  (KindAnnotatedName_KindAnnotatedName _ t k) = head _genericsIself
                     in   case k of
                            MaybeKind_Just j   ->  not (isRestricted j)
                            MaybeKind_Nothing  ->  False
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _genericsImodules `Set.union` _parametricsImodules `Set.union` _typeImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _genericsIres ++ _parametricsIres ++ _typeIres
            -- self rule
            (_self@_) =
                Declaration_GenericTypeSignature _rangeIself _nameIself _genericsIself _parametricsIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _typeIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _typeImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _typeImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_genericsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_genericsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_genericsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_genericsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_genericsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_genericsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_genericsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_genericsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_genericsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_genericsOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_genericsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_genericsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_genericsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_genericsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_genericsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_genericsOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_genericsOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_parametricsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_parametricsOconstructors_collect@_) =
                _genericsIconstructors_collect
            -- copy rule (down)
            (_parametricsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_parametricsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_parametricsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_parametricsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_parametricsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_parametricsOknownKinds_collect@_) =
                _genericsIknownKinds_collect
            -- copy rule (down)
            (_parametricsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_parametricsOknownTypes_collect@_) =
                _genericsIknownTypes_collect
            -- copy rule (down)
            (_parametricsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_parametricsOknownValues_collect@_) =
                _genericsIknownValues_collect
            -- copy rule (chain)
            (_parametricsOlabels_collect@_) =
                _genericsIlabels_collect
            -- copy rule (down)
            (_parametricsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_parametricsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_parametricsOmethods_collect@_) =
                _genericsImethods_collect
            -- copy rule (down)
            (_parametricsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_parametricsOmoduleTypes@_) =
                _genericsImoduleTypes
            -- copy rule (chain)
            (_parametricsOmoduleValues@_) =
                _genericsImoduleValues
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _parametricsIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typeOknownKinds_collect@_) =
                _parametricsIknownKinds_collect
            -- copy rule (chain)
            (_typeOknownTypes_collect@_) =
                _parametricsIknownTypes_collect
            -- copy rule (down)
            (_typeOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_typeOknownValues_collect@_) =
                _parametricsIknownValues_collect
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _parametricsIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _parametricsImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_typeOmoduleTypes@_) =
                _parametricsImoduleTypes
            -- copy rule (chain)
            (_typeOmoduleValues@_) =
                _parametricsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Declaration_Instance :: (T_Range) ->
                            (T_ContextItems) ->
                            (T_Name) ->
                            (T_Types) ->
                            (T_MaybeDeclarations) ->
                            (T_Declaration)
sem_Declaration_Instance (range_) (context_) (name_) (types_) (where_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _contextIconstructors_collect :: (FMap Name Names)
            _contextIknownKinds_collect :: (FMap Name [Name])
            _contextIknownTypes_collect :: (FMap Name [Name])
            _contextIknownValues_collect :: (FMap Name [Name])
            _contextIlabels_collect :: (FMap Name Names)
            _contextImethods_collect :: (FMap Name Names)
            _contextImoduleTypes :: (FMap ModuleName [Name])
            _contextImoduleValues :: (FMap ModuleName [Name])
            _contextImodules :: (Set.Set Strings)
            _contextIres :: ([ResolveResult])
            _contextIself :: (ContextItems)
            _contextOclassname :: (Maybe Name)
            _contextOconstructors_collect :: (FMap Name Names)
            _contextOconstructors_dist :: (FMap Name Names)
            _contextOcurrentModule :: (Strings)
            _contextOimportedModule :: (Bool)
            _contextOinstancename :: (Maybe Name)
            _contextOknownGenerics :: (FMap Name [Name])
            _contextOknownKinds :: (FMap Name [Name])
            _contextOknownKinds_collect :: (FMap Name [Name])
            _contextOknownTypes :: (FMap Name [Name])
            _contextOknownTypes_collect :: (FMap Name [Name])
            _contextOknownValues :: (FMap Name [Name])
            _contextOknownValues_collect :: (FMap Name [Name])
            _contextOlabels_collect :: (FMap Name Names)
            _contextOlabels_dist :: (FMap Name Names)
            _contextOlocal :: (Bool)
            _contextOmethods_collect :: (FMap Name Names)
            _contextOmethods_dist :: (FMap Name Names)
            _contextOmoduleTypes :: (FMap ModuleName [Name])
            _contextOmoduleValues :: (FMap ModuleName [Name])
            _contextOnameType :: (NameType)
            _contextOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _typesIconstructors_collect :: (FMap Name Names)
            _typesIknownKinds_collect :: (FMap Name [Name])
            _typesIknownTypes_collect :: (FMap Name [Name])
            _typesIknownValues_collect :: (FMap Name [Name])
            _typesIlabels_collect :: (FMap Name Names)
            _typesImethods_collect :: (FMap Name Names)
            _typesImoduleTypes :: (FMap ModuleName [Name])
            _typesImoduleValues :: (FMap ModuleName [Name])
            _typesImodules :: (Set.Set Strings)
            _typesIres :: ([ResolveResult])
            _typesIself :: (Types)
            _typesOclassname :: (Maybe Name)
            _typesOconstructors_collect :: (FMap Name Names)
            _typesOconstructors_dist :: (FMap Name Names)
            _typesOcurrentModule :: (Strings)
            _typesOimportedModule :: (Bool)
            _typesOinstancename :: (Maybe Name)
            _typesOknownGenerics :: (FMap Name [Name])
            _typesOknownKinds :: (FMap Name [Name])
            _typesOknownKinds_collect :: (FMap Name [Name])
            _typesOknownTypes :: (FMap Name [Name])
            _typesOknownTypes_collect :: (FMap Name [Name])
            _typesOknownValues :: (FMap Name [Name])
            _typesOknownValues_collect :: (FMap Name [Name])
            _typesOlabels_collect :: (FMap Name Names)
            _typesOlabels_dist :: (FMap Name Names)
            _typesOlocal :: (Bool)
            _typesOmethods_collect :: (FMap Name Names)
            _typesOmethods_dist :: (FMap Name Names)
            _typesOmoduleTypes :: (FMap ModuleName [Name])
            _typesOmoduleValues :: (FMap ModuleName [Name])
            _typesOnameType :: (NameType)
            _typesOtoplevel :: (Bool)
            _whereIconstructors_collect :: (FMap Name Names)
            _whereIknownKinds_collect :: (FMap Name [Name])
            _whereIknownTypes_collect :: (FMap Name [Name])
            _whereIknownValues_collect :: (FMap Name [Name])
            _whereIlabels_collect :: (FMap Name Names)
            _whereImethods_collect :: (FMap Name Names)
            _whereImoduleTypes :: (FMap ModuleName [Name])
            _whereImoduleValues :: (FMap ModuleName [Name])
            _whereImodules :: (Set.Set Strings)
            _whereIres :: ([ResolveResult])
            _whereIself :: (MaybeDeclarations)
            _whereOclassname :: (Maybe Name)
            _whereOconstructors_collect :: (FMap Name Names)
            _whereOconstructors_dist :: (FMap Name Names)
            _whereOcurrentModule :: (Strings)
            _whereOimportedModule :: (Bool)
            _whereOinstancename :: (Maybe Name)
            _whereOknownGenerics :: (FMap Name [Name])
            _whereOknownKinds :: (FMap Name [Name])
            _whereOknownKinds_collect :: (FMap Name [Name])
            _whereOknownTypes :: (FMap Name [Name])
            _whereOknownTypes_collect :: (FMap Name [Name])
            _whereOknownValues :: (FMap Name [Name])
            _whereOknownValues_collect :: (FMap Name [Name])
            _whereOlabels_collect :: (FMap Name Names)
            _whereOlabels_dist :: (FMap Name Names)
            _whereOlocal :: (Bool)
            _whereOmethods_collect :: (FMap Name Names)
            _whereOmethods_dist :: (FMap Name Names)
            _whereOmoduleTypes :: (FMap ModuleName [Name])
            _whereOmoduleValues :: (FMap ModuleName [Name])
            _whereOnameType :: (NameType)
            _whereOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _contextIconstructors_collect,_contextIknownKinds_collect,_contextIknownTypes_collect,_contextIknownValues_collect,_contextIlabels_collect,_contextImethods_collect,_contextImoduleTypes,_contextImoduleValues,_contextImodules,_contextIres,_contextIself) =
                (context_ (_contextOclassname)
                          (_contextOconstructors_collect)
                          (_contextOconstructors_dist)
                          (_contextOcurrentModule)
                          (_contextOimportedModule)
                          (_contextOinstancename)
                          (_contextOknownGenerics)
                          (_contextOknownKinds)
                          (_contextOknownKinds_collect)
                          (_contextOknownTypes)
                          (_contextOknownTypes_collect)
                          (_contextOknownValues)
                          (_contextOknownValues_collect)
                          (_contextOlabels_collect)
                          (_contextOlabels_dist)
                          (_contextOlocal)
                          (_contextOmethods_collect)
                          (_contextOmethods_dist)
                          (_contextOmoduleTypes)
                          (_contextOmoduleValues)
                          (_contextOnameType)
                          (_contextOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _typesIconstructors_collect,_typesIknownKinds_collect,_typesIknownTypes_collect,_typesIknownValues_collect,_typesIlabels_collect,_typesImethods_collect,_typesImoduleTypes,_typesImoduleValues,_typesImodules,_typesIres,_typesIself) =
                (types_ (_typesOclassname)
                        (_typesOconstructors_collect)
                        (_typesOconstructors_dist)
                        (_typesOcurrentModule)
                        (_typesOimportedModule)
                        (_typesOinstancename)
                        (_typesOknownGenerics)
                        (_typesOknownKinds)
                        (_typesOknownKinds_collect)
                        (_typesOknownTypes)
                        (_typesOknownTypes_collect)
                        (_typesOknownValues)
                        (_typesOknownValues_collect)
                        (_typesOlabels_collect)
                        (_typesOlabels_dist)
                        (_typesOlocal)
                        (_typesOmethods_collect)
                        (_typesOmethods_dist)
                        (_typesOmoduleTypes)
                        (_typesOmoduleValues)
                        (_typesOnameType)
                        (_typesOtoplevel))
            ( _whereIconstructors_collect,_whereIknownKinds_collect,_whereIknownTypes_collect,_whereIknownValues_collect,_whereIlabels_collect,_whereImethods_collect,_whereImoduleTypes,_whereImoduleValues,_whereImodules,_whereIres,_whereIself) =
                (where_ (_whereOclassname)
                        (_whereOconstructors_collect)
                        (_whereOconstructors_dist)
                        (_whereOcurrentModule)
                        (_whereOimportedModule)
                        (_whereOinstancename)
                        (_whereOknownGenerics)
                        (_whereOknownKinds)
                        (_whereOknownKinds_collect)
                        (_whereOknownTypes)
                        (_whereOknownTypes_collect)
                        (_whereOknownValues)
                        (_whereOknownValues_collect)
                        (_whereOlabels_collect)
                        (_whereOlabels_dist)
                        (_whereOlocal)
                        (_whereOmethods_collect)
                        (_whereOmethods_dist)
                        (_whereOmoduleTypes)
                        (_whereOmoduleValues)
                        (_whereOnameType)
                        (_whereOtoplevel))
            -- "./Names.inc.lag"(line 752, column 9)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- "./Names.inc.lag"(line 751, column 9)
            (_contextOknownTypes@_) =
                _typesIknownTypes_collect `mergeFM` _lhsIknownTypes
            -- "./Names.inc.lag"(line 750, column 9)
            (_typesOknownTypes_collect@_) =
                emptyFM
            -- "./NameTypes.inc.lag"(line 310, column 9)
            (_typesOnameType@_) =
                Def_Typ
            -- "./NameTypes.inc.lag"(line 309, column 9)
            (_contextOnameType@_) =
                ref_Typ
            -- "./NameTypes.inc.lag"(line 308, column 9)
            (_nameOnameType@_) =
                ref_Typ
            -- "./ModuleInformation.inc.lag"(line 140, column 8)
            (_instancename@_) =
                Just _nameIself
            -- use rule
            (_lhsOmodules@_) =
                _contextImodules `Set.union` _nameImodules `Set.union` _typesImodules `Set.union` _whereImodules
            -- use rule
            (_lhsOres@_) =
                _contextIres ++ _nameIres ++ _typesIres ++ _whereIres
            -- self rule
            (_self@_) =
                Declaration_Instance _rangeIself _contextIself _nameIself _typesIself _whereIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _whereIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _whereIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _whereIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _whereIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _whereImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _whereImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _whereImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (chain)
            (_rangeOinstancename@_) =
                _instancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_contextOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_contextOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_contextOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_contextOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_contextOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (chain)
            (_contextOinstancename@_) =
                _instancename
            -- copy rule (down)
            (_contextOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_contextOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_contextOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_contextOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_contextOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_contextOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_contextOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_contextOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_contextOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_contextOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_contextOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_contextOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_contextOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_contextOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_nameOconstructors_collect@_) =
                _contextIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (chain)
            (_nameOinstancename@_) =
                _instancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_nameOknownKinds_collect@_) =
                _contextIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_nameOknownTypes_collect@_) =
                _contextIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_nameOknownValues_collect@_) =
                _contextIknownValues_collect
            -- copy rule (chain)
            (_nameOlabels_collect@_) =
                _contextIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_nameOmethods_collect@_) =
                _contextImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_nameOmoduleTypes@_) =
                _contextImoduleTypes
            -- copy rule (chain)
            (_nameOmoduleValues@_) =
                _contextImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typesOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_typesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (chain)
            (_typesOinstancename@_) =
                _instancename
            -- copy rule (down)
            (_typesOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_typesOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_typesOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_typesOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_typesOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_typesOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_typesOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_typesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typesOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_typesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_typesOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_typesOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_typesOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_whereOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_whereOconstructors_collect@_) =
                _typesIconstructors_collect
            -- copy rule (down)
            (_whereOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_whereOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_whereOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (chain)
            (_whereOinstancename@_) =
                _instancename
            -- copy rule (down)
            (_whereOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_whereOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_whereOknownKinds_collect@_) =
                _typesIknownKinds_collect
            -- copy rule (down)
            (_whereOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_whereOknownTypes_collect@_) =
                _typesIknownTypes_collect
            -- copy rule (down)
            (_whereOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_whereOknownValues_collect@_) =
                _typesIknownValues_collect
            -- copy rule (chain)
            (_whereOlabels_collect@_) =
                _typesIlabels_collect
            -- copy rule (down)
            (_whereOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_whereOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_whereOmethods_collect@_) =
                _typesImethods_collect
            -- copy rule (down)
            (_whereOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_whereOmoduleTypes@_) =
                _typesImoduleTypes
            -- copy rule (chain)
            (_whereOmoduleValues@_) =
                _typesImoduleValues
            -- copy rule (down)
            (_whereOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_whereOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Declaration_KindIndexedType :: (T_Range) ->
                                   (T_KindIndexedBindings) ->
                                   (T_Declaration)
sem_Declaration_KindIndexedType (range_) (bindings_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _bindingsIconstructors_collect :: (FMap Name Names)
            _bindingsIknownKinds_collect :: (FMap Name [Name])
            _bindingsIknownTypes_collect :: (FMap Name [Name])
            _bindingsIknownValues_collect :: (FMap Name [Name])
            _bindingsIlabels_collect :: (FMap Name Names)
            _bindingsImethods_collect :: (FMap Name Names)
            _bindingsImoduleTypes :: (FMap ModuleName [Name])
            _bindingsImoduleValues :: (FMap ModuleName [Name])
            _bindingsImodules :: (Set.Set Strings)
            _bindingsIname :: (Name)
            _bindingsIres :: ([ResolveResult])
            _bindingsIself :: (KindIndexedBindings)
            _bindingsOclassname :: (Maybe Name)
            _bindingsOconstructors_collect :: (FMap Name Names)
            _bindingsOconstructors_dist :: (FMap Name Names)
            _bindingsOcurrentModule :: (Strings)
            _bindingsOimportedModule :: (Bool)
            _bindingsOinstancename :: (Maybe Name)
            _bindingsOknownGenerics :: (FMap Name [Name])
            _bindingsOknownKinds :: (FMap Name [Name])
            _bindingsOknownKinds_collect :: (FMap Name [Name])
            _bindingsOknownTypes :: (FMap Name [Name])
            _bindingsOknownTypes_collect :: (FMap Name [Name])
            _bindingsOknownValues :: (FMap Name [Name])
            _bindingsOknownValues_collect :: (FMap Name [Name])
            _bindingsOlabels_collect :: (FMap Name Names)
            _bindingsOlabels_dist :: (FMap Name Names)
            _bindingsOlocal :: (Bool)
            _bindingsOmethods_collect :: (FMap Name Names)
            _bindingsOmethods_dist :: (FMap Name Names)
            _bindingsOmoduleTypes :: (FMap ModuleName [Name])
            _bindingsOmoduleValues :: (FMap ModuleName [Name])
            _bindingsOnameType :: (NameType)
            _bindingsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _bindingsIconstructors_collect,_bindingsIknownKinds_collect,_bindingsIknownTypes_collect,_bindingsIknownValues_collect,_bindingsIlabels_collect,_bindingsImethods_collect,_bindingsImoduleTypes,_bindingsImoduleValues,_bindingsImodules,_bindingsIname,_bindingsIres,_bindingsIself) =
                (bindings_ (_bindingsOclassname)
                           (_bindingsOconstructors_collect)
                           (_bindingsOconstructors_dist)
                           (_bindingsOcurrentModule)
                           (_bindingsOimportedModule)
                           (_bindingsOinstancename)
                           (_bindingsOknownGenerics)
                           (_bindingsOknownKinds)
                           (_bindingsOknownKinds_collect)
                           (_bindingsOknownTypes)
                           (_bindingsOknownTypes_collect)
                           (_bindingsOknownValues)
                           (_bindingsOknownValues_collect)
                           (_bindingsOlabels_collect)
                           (_bindingsOlabels_dist)
                           (_bindingsOlocal)
                           (_bindingsOmethods_collect)
                           (_bindingsOmethods_dist)
                           (_bindingsOmoduleTypes)
                           (_bindingsOmoduleValues)
                           (_bindingsOnameType)
                           (_bindingsOtoplevel))
            -- "./NameTypes.inc.lag"(line 268, column 9)
            (_bindingsOnameType@_) =
                Def_Typ
            -- use rule
            (_lhsOmodules@_) =
                _bindingsImodules
            -- use rule
            (_lhsOres@_) =
                _bindingsIres
            -- self rule
            (_self@_) =
                Declaration_KindIndexedType _rangeIself _bindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _bindingsIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _bindingsIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _bindingsIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _bindingsIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _bindingsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _bindingsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _bindingsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _bindingsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_bindingsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_bindingsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_bindingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_bindingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_bindingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_bindingsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_bindingsOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_bindingsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_bindingsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_bindingsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_bindingsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_bindingsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_bindingsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_bindingsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_bindingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_bindingsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_bindingsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_bindingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_bindingsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_bindingsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_bindingsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Declaration_Newtype :: (T_Range) ->
                           (T_ContextItems) ->
                           (T_SimpleType) ->
                           (T_Constructor) ->
                           (T_Names) ->
                           (T_Declaration)
sem_Declaration_Newtype (range_) (context_) (simpletype_) (constructor_) (derivings_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _contextIconstructors_collect :: (FMap Name Names)
            _contextIknownKinds_collect :: (FMap Name [Name])
            _contextIknownTypes_collect :: (FMap Name [Name])
            _contextIknownValues_collect :: (FMap Name [Name])
            _contextIlabels_collect :: (FMap Name Names)
            _contextImethods_collect :: (FMap Name Names)
            _contextImoduleTypes :: (FMap ModuleName [Name])
            _contextImoduleValues :: (FMap ModuleName [Name])
            _contextImodules :: (Set.Set Strings)
            _contextIres :: ([ResolveResult])
            _contextIself :: (ContextItems)
            _contextOclassname :: (Maybe Name)
            _contextOconstructors_collect :: (FMap Name Names)
            _contextOconstructors_dist :: (FMap Name Names)
            _contextOcurrentModule :: (Strings)
            _contextOimportedModule :: (Bool)
            _contextOinstancename :: (Maybe Name)
            _contextOknownGenerics :: (FMap Name [Name])
            _contextOknownKinds :: (FMap Name [Name])
            _contextOknownKinds_collect :: (FMap Name [Name])
            _contextOknownTypes :: (FMap Name [Name])
            _contextOknownTypes_collect :: (FMap Name [Name])
            _contextOknownValues :: (FMap Name [Name])
            _contextOknownValues_collect :: (FMap Name [Name])
            _contextOlabels_collect :: (FMap Name Names)
            _contextOlabels_dist :: (FMap Name Names)
            _contextOlocal :: (Bool)
            _contextOmethods_collect :: (FMap Name Names)
            _contextOmethods_dist :: (FMap Name Names)
            _contextOmoduleTypes :: (FMap ModuleName [Name])
            _contextOmoduleValues :: (FMap ModuleName [Name])
            _contextOnameType :: (NameType)
            _contextOtoplevel :: (Bool)
            _simpletypeIconstructors_collect :: (FMap Name Names)
            _simpletypeIknownKinds_collect :: (FMap Name [Name])
            _simpletypeIknownTypesForBody_collect :: (FMap Name [Name])
            _simpletypeIknownTypes_collect :: (FMap Name [Name])
            _simpletypeIknownValues_collect :: (FMap Name [Name])
            _simpletypeIlabels_collect :: (FMap Name Names)
            _simpletypeImethods_collect :: (FMap Name Names)
            _simpletypeImoduleTypes :: (FMap ModuleName [Name])
            _simpletypeImoduleValues :: (FMap ModuleName [Name])
            _simpletypeImodules :: (Set.Set Strings)
            _simpletypeIname :: (Name)
            _simpletypeIres :: ([ResolveResult])
            _simpletypeIself :: (SimpleType)
            _simpletypeOclassname :: (Maybe Name)
            _simpletypeOconstructors_collect :: (FMap Name Names)
            _simpletypeOconstructors_dist :: (FMap Name Names)
            _simpletypeOcurrentModule :: (Strings)
            _simpletypeOimportedModule :: (Bool)
            _simpletypeOinstancename :: (Maybe Name)
            _simpletypeOknownKinds :: (FMap Name [Name])
            _simpletypeOknownKinds_collect :: (FMap Name [Name])
            _simpletypeOknownTypes :: (FMap Name [Name])
            _simpletypeOknownTypesForBody_collect :: (FMap Name [Name])
            _simpletypeOknownTypes_collect :: (FMap Name [Name])
            _simpletypeOknownValues :: (FMap Name [Name])
            _simpletypeOknownValues_collect :: (FMap Name [Name])
            _simpletypeOlabels_collect :: (FMap Name Names)
            _simpletypeOlabels_dist :: (FMap Name Names)
            _simpletypeOlocal :: (Bool)
            _simpletypeOmethods_collect :: (FMap Name Names)
            _simpletypeOmethods_dist :: (FMap Name Names)
            _simpletypeOmoduleTypes :: (FMap ModuleName [Name])
            _simpletypeOmoduleValues :: (FMap ModuleName [Name])
            _simpletypeOnameType :: (NameType)
            _simpletypeOtoplevel :: (Bool)
            _constructorIconstructors :: (Names)
            _constructorIconstructors_collect :: (FMap Name Names)
            _constructorIknownKinds_collect :: (FMap Name [Name])
            _constructorIknownTypes_collect :: (FMap Name [Name])
            _constructorIknownValues_collect :: (FMap Name [Name])
            _constructorIlabels :: (Names)
            _constructorIlabels_collect :: (FMap Name Names)
            _constructorImethods_collect :: (FMap Name Names)
            _constructorImoduleTypes :: (FMap ModuleName [Name])
            _constructorImoduleValues :: (FMap ModuleName [Name])
            _constructorImodules :: (Set.Set Strings)
            _constructorIres :: ([ResolveResult])
            _constructorIself :: (Constructor)
            _constructorOclassname :: (Maybe Name)
            _constructorOconstructors_collect :: (FMap Name Names)
            _constructorOconstructors_dist :: (FMap Name Names)
            _constructorOcurrentModule :: (Strings)
            _constructorOimportedModule :: (Bool)
            _constructorOinstancename :: (Maybe Name)
            _constructorOknownGenerics :: (FMap Name [Name])
            _constructorOknownKinds :: (FMap Name [Name])
            _constructorOknownKinds_collect :: (FMap Name [Name])
            _constructorOknownTypes :: (FMap Name [Name])
            _constructorOknownTypes_collect :: (FMap Name [Name])
            _constructorOknownValues :: (FMap Name [Name])
            _constructorOknownValues_collect :: (FMap Name [Name])
            _constructorOlabels_collect :: (FMap Name Names)
            _constructorOlabels_dist :: (FMap Name Names)
            _constructorOlocal :: (Bool)
            _constructorOmethods_collect :: (FMap Name Names)
            _constructorOmethods_dist :: (FMap Name Names)
            _constructorOmoduleTypes :: (FMap ModuleName [Name])
            _constructorOmoduleValues :: (FMap ModuleName [Name])
            _constructorOnameType :: (NameType)
            _constructorOtoplevel :: (Bool)
            _derivingsIconstructors_collect :: (FMap Name Names)
            _derivingsIknownKinds_collect :: (FMap Name [Name])
            _derivingsIknownTypes_collect :: (FMap Name [Name])
            _derivingsIknownValues_collect :: (FMap Name [Name])
            _derivingsIlabels_collect :: (FMap Name Names)
            _derivingsImethods_collect :: (FMap Name Names)
            _derivingsImoduleTypes :: (FMap ModuleName [Name])
            _derivingsImoduleValues :: (FMap ModuleName [Name])
            _derivingsImodules :: (Set.Set Strings)
            _derivingsIoriginalSelf :: (Names)
            _derivingsIres :: ([ResolveResult])
            _derivingsIself :: (Names)
            _derivingsOclassname :: (Maybe Name)
            _derivingsOconstructors_collect :: (FMap Name Names)
            _derivingsOconstructors_dist :: (FMap Name Names)
            _derivingsOcurrentModule :: (Strings)
            _derivingsOimportedModule :: (Bool)
            _derivingsOinstancename :: (Maybe Name)
            _derivingsOknownKinds :: (FMap Name [Name])
            _derivingsOknownKinds_collect :: (FMap Name [Name])
            _derivingsOknownTypes :: (FMap Name [Name])
            _derivingsOknownTypes_collect :: (FMap Name [Name])
            _derivingsOknownValues :: (FMap Name [Name])
            _derivingsOknownValues_collect :: (FMap Name [Name])
            _derivingsOlabels_collect :: (FMap Name Names)
            _derivingsOlabels_dist :: (FMap Name Names)
            _derivingsOlocal :: (Bool)
            _derivingsOmethods_collect :: (FMap Name Names)
            _derivingsOmethods_dist :: (FMap Name Names)
            _derivingsOmoduleTypes :: (FMap ModuleName [Name])
            _derivingsOmoduleValues :: (FMap ModuleName [Name])
            _derivingsOnameType :: (NameType)
            _derivingsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _contextIconstructors_collect,_contextIknownKinds_collect,_contextIknownTypes_collect,_contextIknownValues_collect,_contextIlabels_collect,_contextImethods_collect,_contextImoduleTypes,_contextImoduleValues,_contextImodules,_contextIres,_contextIself) =
                (context_ (_contextOclassname)
                          (_contextOconstructors_collect)
                          (_contextOconstructors_dist)
                          (_contextOcurrentModule)
                          (_contextOimportedModule)
                          (_contextOinstancename)
                          (_contextOknownGenerics)
                          (_contextOknownKinds)
                          (_contextOknownKinds_collect)
                          (_contextOknownTypes)
                          (_contextOknownTypes_collect)
                          (_contextOknownValues)
                          (_contextOknownValues_collect)
                          (_contextOlabels_collect)
                          (_contextOlabels_dist)
                          (_contextOlocal)
                          (_contextOmethods_collect)
                          (_contextOmethods_dist)
                          (_contextOmoduleTypes)
                          (_contextOmoduleValues)
                          (_contextOnameType)
                          (_contextOtoplevel))
            ( _simpletypeIconstructors_collect,_simpletypeIknownKinds_collect,_simpletypeIknownTypesForBody_collect,_simpletypeIknownTypes_collect,_simpletypeIknownValues_collect,_simpletypeIlabels_collect,_simpletypeImethods_collect,_simpletypeImoduleTypes,_simpletypeImoduleValues,_simpletypeImodules,_simpletypeIname,_simpletypeIres,_simpletypeIself) =
                (simpletype_ (_simpletypeOclassname)
                             (_simpletypeOconstructors_collect)
                             (_simpletypeOconstructors_dist)
                             (_simpletypeOcurrentModule)
                             (_simpletypeOimportedModule)
                             (_simpletypeOinstancename)
                             (_simpletypeOknownKinds)
                             (_simpletypeOknownKinds_collect)
                             (_simpletypeOknownTypes)
                             (_simpletypeOknownTypesForBody_collect)
                             (_simpletypeOknownTypes_collect)
                             (_simpletypeOknownValues)
                             (_simpletypeOknownValues_collect)
                             (_simpletypeOlabels_collect)
                             (_simpletypeOlabels_dist)
                             (_simpletypeOlocal)
                             (_simpletypeOmethods_collect)
                             (_simpletypeOmethods_dist)
                             (_simpletypeOmoduleTypes)
                             (_simpletypeOmoduleValues)
                             (_simpletypeOnameType)
                             (_simpletypeOtoplevel))
            ( _constructorIconstructors,_constructorIconstructors_collect,_constructorIknownKinds_collect,_constructorIknownTypes_collect,_constructorIknownValues_collect,_constructorIlabels,_constructorIlabels_collect,_constructorImethods_collect,_constructorImoduleTypes,_constructorImoduleValues,_constructorImodules,_constructorIres,_constructorIself) =
                (constructor_ (_constructorOclassname)
                              (_constructorOconstructors_collect)
                              (_constructorOconstructors_dist)
                              (_constructorOcurrentModule)
                              (_constructorOimportedModule)
                              (_constructorOinstancename)
                              (_constructorOknownGenerics)
                              (_constructorOknownKinds)
                              (_constructorOknownKinds_collect)
                              (_constructorOknownTypes)
                              (_constructorOknownTypes_collect)
                              (_constructorOknownValues)
                              (_constructorOknownValues_collect)
                              (_constructorOlabels_collect)
                              (_constructorOlabels_dist)
                              (_constructorOlocal)
                              (_constructorOmethods_collect)
                              (_constructorOmethods_dist)
                              (_constructorOmoduleTypes)
                              (_constructorOmoduleValues)
                              (_constructorOnameType)
                              (_constructorOtoplevel))
            ( _derivingsIconstructors_collect,_derivingsIknownKinds_collect,_derivingsIknownTypes_collect,_derivingsIknownValues_collect,_derivingsIlabels_collect,_derivingsImethods_collect,_derivingsImoduleTypes,_derivingsImoduleValues,_derivingsImodules,_derivingsIoriginalSelf,_derivingsIres,_derivingsIself) =
                (derivings_ (_derivingsOclassname)
                            (_derivingsOconstructors_collect)
                            (_derivingsOconstructors_dist)
                            (_derivingsOcurrentModule)
                            (_derivingsOimportedModule)
                            (_derivingsOinstancename)
                            (_derivingsOknownKinds)
                            (_derivingsOknownKinds_collect)
                            (_derivingsOknownTypes)
                            (_derivingsOknownTypes_collect)
                            (_derivingsOknownValues)
                            (_derivingsOknownValues_collect)
                            (_derivingsOlabels_collect)
                            (_derivingsOlabels_dist)
                            (_derivingsOlocal)
                            (_derivingsOmethods_collect)
                            (_derivingsOmethods_dist)
                            (_derivingsOmoduleTypes)
                            (_derivingsOmoduleValues)
                            (_derivingsOnameType)
                            (_derivingsOtoplevel))
            -- "./Names.inc.lag"(line 735, column 9)
            (_lhsOknownTypes_collect@_) =
                _simpletypeIknownTypes_collect
            -- "./Names.inc.lag"(line 734, column 9)
            (_simpletypeOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- "./Names.inc.lag"(line 733, column 9)
            (_constructorOknownTypes@_) =
                _simpletypeIknownTypesForBody_collect `mergeFM` _lhsIknownTypes
            -- "./Names.inc.lag"(line 732, column 9)
            (_simpletypeOknownTypesForBody_collect@_) =
                emptyFM
            -- "./NameTypes.inc.lag"(line 303, column 9)
            (_derivingsOnameType@_) =
                ref_Typ
            -- "./ModuleInformation.inc.lag"(line 323, column 9)
            (_lhsOlabels_collect@_) =
                add _lhsIlabels_collect
                    (_simpletypeIname,_constructorIlabels)
            -- "./ModuleInformation.inc.lag"(line 321, column 9)
            (_lhsOconstructors_collect@_) =
                add _lhsIconstructors_collect
                    (_simpletypeIname,_constructorIconstructors)
            -- use rule
            (_lhsOmodules@_) =
                _contextImodules `Set.union` _simpletypeImodules `Set.union` _constructorImodules `Set.union` _derivingsImodules
            -- use rule
            (_lhsOres@_) =
                _contextIres ++ _simpletypeIres ++ _constructorIres ++ _derivingsIres
            -- self rule
            (_self@_) =
                Declaration_Newtype _rangeIself _contextIself _simpletypeIself _constructorIself _derivingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _derivingsIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _derivingsIknownValues_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _derivingsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _derivingsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _derivingsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_contextOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_contextOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_contextOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_contextOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_contextOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_contextOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_contextOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_contextOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_contextOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_contextOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_contextOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_contextOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_contextOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_contextOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_contextOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_contextOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_contextOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_contextOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_contextOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_contextOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_contextOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_contextOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_simpletypeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_simpletypeOconstructors_collect@_) =
                _contextIconstructors_collect
            -- copy rule (down)
            (_simpletypeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_simpletypeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_simpletypeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_simpletypeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_simpletypeOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_simpletypeOknownKinds_collect@_) =
                _contextIknownKinds_collect
            -- copy rule (down)
            (_simpletypeOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_simpletypeOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_simpletypeOknownValues_collect@_) =
                _contextIknownValues_collect
            -- copy rule (chain)
            (_simpletypeOlabels_collect@_) =
                _contextIlabels_collect
            -- copy rule (down)
            (_simpletypeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_simpletypeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_simpletypeOmethods_collect@_) =
                _contextImethods_collect
            -- copy rule (down)
            (_simpletypeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_simpletypeOmoduleTypes@_) =
                _contextImoduleTypes
            -- copy rule (chain)
            (_simpletypeOmoduleValues@_) =
                _contextImoduleValues
            -- copy rule (down)
            (_simpletypeOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_simpletypeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_constructorOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_constructorOconstructors_collect@_) =
                _simpletypeIconstructors_collect
            -- copy rule (down)
            (_constructorOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_constructorOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_constructorOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_constructorOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_constructorOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_constructorOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_constructorOknownKinds_collect@_) =
                _simpletypeIknownKinds_collect
            -- copy rule (chain)
            (_constructorOknownTypes_collect@_) =
                _simpletypeIknownTypes_collect
            -- copy rule (down)
            (_constructorOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_constructorOknownValues_collect@_) =
                _simpletypeIknownValues_collect
            -- copy rule (chain)
            (_constructorOlabels_collect@_) =
                _simpletypeIlabels_collect
            -- copy rule (down)
            (_constructorOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_constructorOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_constructorOmethods_collect@_) =
                _simpletypeImethods_collect
            -- copy rule (down)
            (_constructorOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_constructorOmoduleTypes@_) =
                _simpletypeImoduleTypes
            -- copy rule (chain)
            (_constructorOmoduleValues@_) =
                _simpletypeImoduleValues
            -- copy rule (down)
            (_constructorOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_constructorOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_derivingsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_derivingsOconstructors_collect@_) =
                _constructorIconstructors_collect
            -- copy rule (down)
            (_derivingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_derivingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_derivingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_derivingsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_derivingsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_derivingsOknownKinds_collect@_) =
                _constructorIknownKinds_collect
            -- copy rule (down)
            (_derivingsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_derivingsOknownTypes_collect@_) =
                _constructorIknownTypes_collect
            -- copy rule (down)
            (_derivingsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_derivingsOknownValues_collect@_) =
                _constructorIknownValues_collect
            -- copy rule (chain)
            (_derivingsOlabels_collect@_) =
                _constructorIlabels_collect
            -- copy rule (down)
            (_derivingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_derivingsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_derivingsOmethods_collect@_) =
                _constructorImethods_collect
            -- copy rule (down)
            (_derivingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_derivingsOmoduleTypes@_) =
                _constructorImoduleTypes
            -- copy rule (chain)
            (_derivingsOmoduleValues@_) =
                _constructorImoduleValues
            -- copy rule (down)
            (_derivingsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Declaration_PatternBinding :: (T_Range) ->
                                  (T_Pattern) ->
                                  (T_RightHandSide) ->
                                  (T_Declaration)
sem_Declaration_PatternBinding (range_) (pattern_) (righthandside_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _patternIconstructors_collect :: (FMap Name Names)
            _patternIknownKinds_collect :: (FMap Name [Name])
            _patternIknownTypes_collect :: (FMap Name [Name])
            _patternIknownValues_collect :: (FMap Name [Name])
            _patternIlabels_collect :: (FMap Name Names)
            _patternImethods_collect :: (FMap Name Names)
            _patternImoduleTypes :: (FMap ModuleName [Name])
            _patternImoduleValues :: (FMap ModuleName [Name])
            _patternImodules :: (Set.Set Strings)
            _patternIname :: (Name)
            _patternIres :: ([ResolveResult])
            _patternIself :: (Pattern)
            _patternOclassname :: (Maybe Name)
            _patternOconstructors_collect :: (FMap Name Names)
            _patternOconstructors_dist :: (FMap Name Names)
            _patternOcurrentModule :: (Strings)
            _patternOimportedModule :: (Bool)
            _patternOinstancename :: (Maybe Name)
            _patternOknownKinds :: (FMap Name [Name])
            _patternOknownKinds_collect :: (FMap Name [Name])
            _patternOknownTypes :: (FMap Name [Name])
            _patternOknownTypes_collect :: (FMap Name [Name])
            _patternOknownValues :: (FMap Name [Name])
            _patternOknownValues_collect :: (FMap Name [Name])
            _patternOlabels_collect :: (FMap Name Names)
            _patternOlabels_dist :: (FMap Name Names)
            _patternOlocal :: (Bool)
            _patternOmethods_collect :: (FMap Name Names)
            _patternOmethods_dist :: (FMap Name Names)
            _patternOmoduleTypes :: (FMap ModuleName [Name])
            _patternOmoduleValues :: (FMap ModuleName [Name])
            _patternOnameType :: (NameType)
            _patternOtoplevel :: (Bool)
            _righthandsideIconstructors_collect :: (FMap Name Names)
            _righthandsideIknownKinds_collect :: (FMap Name [Name])
            _righthandsideIknownTypes_collect :: (FMap Name [Name])
            _righthandsideIknownValues_collect :: (FMap Name [Name])
            _righthandsideIlabels_collect :: (FMap Name Names)
            _righthandsideImethods_collect :: (FMap Name Names)
            _righthandsideImoduleTypes :: (FMap ModuleName [Name])
            _righthandsideImoduleValues :: (FMap ModuleName [Name])
            _righthandsideImodules :: (Set.Set Strings)
            _righthandsideIres :: ([ResolveResult])
            _righthandsideIself :: (RightHandSide)
            _righthandsideOclassname :: (Maybe Name)
            _righthandsideOconstructors_collect :: (FMap Name Names)
            _righthandsideOconstructors_dist :: (FMap Name Names)
            _righthandsideOcurrentModule :: (Strings)
            _righthandsideOimportedModule :: (Bool)
            _righthandsideOinstancename :: (Maybe Name)
            _righthandsideOknownGenerics :: (FMap Name [Name])
            _righthandsideOknownKinds :: (FMap Name [Name])
            _righthandsideOknownKinds_collect :: (FMap Name [Name])
            _righthandsideOknownTypes :: (FMap Name [Name])
            _righthandsideOknownTypes_collect :: (FMap Name [Name])
            _righthandsideOknownValues :: (FMap Name [Name])
            _righthandsideOknownValues_collect :: (FMap Name [Name])
            _righthandsideOlabels_collect :: (FMap Name Names)
            _righthandsideOlabels_dist :: (FMap Name Names)
            _righthandsideOlocal :: (Bool)
            _righthandsideOmethods_collect :: (FMap Name Names)
            _righthandsideOmethods_dist :: (FMap Name Names)
            _righthandsideOmoduleTypes :: (FMap ModuleName [Name])
            _righthandsideOmoduleValues :: (FMap ModuleName [Name])
            _righthandsideOnameType :: (NameType)
            _righthandsideOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _patternIconstructors_collect,_patternIknownKinds_collect,_patternIknownTypes_collect,_patternIknownValues_collect,_patternIlabels_collect,_patternImethods_collect,_patternImoduleTypes,_patternImoduleValues,_patternImodules,_patternIname,_patternIres,_patternIself) =
                (pattern_ (_patternOclassname)
                          (_patternOconstructors_collect)
                          (_patternOconstructors_dist)
                          (_patternOcurrentModule)
                          (_patternOimportedModule)
                          (_patternOinstancename)
                          (_patternOknownKinds)
                          (_patternOknownKinds_collect)
                          (_patternOknownTypes)
                          (_patternOknownTypes_collect)
                          (_patternOknownValues)
                          (_patternOknownValues_collect)
                          (_patternOlabels_collect)
                          (_patternOlabels_dist)
                          (_patternOlocal)
                          (_patternOmethods_collect)
                          (_patternOmethods_dist)
                          (_patternOmoduleTypes)
                          (_patternOmoduleValues)
                          (_patternOnameType)
                          (_patternOtoplevel))
            ( _righthandsideIconstructors_collect,_righthandsideIknownKinds_collect,_righthandsideIknownTypes_collect,_righthandsideIknownValues_collect,_righthandsideIlabels_collect,_righthandsideImethods_collect,_righthandsideImoduleTypes,_righthandsideImoduleValues,_righthandsideImodules,_righthandsideIres,_righthandsideIself) =
                (righthandside_ (_righthandsideOclassname)
                                (_righthandsideOconstructors_collect)
                                (_righthandsideOconstructors_dist)
                                (_righthandsideOcurrentModule)
                                (_righthandsideOimportedModule)
                                (_righthandsideOinstancename)
                                (_righthandsideOknownGenerics)
                                (_righthandsideOknownKinds)
                                (_righthandsideOknownKinds_collect)
                                (_righthandsideOknownTypes)
                                (_righthandsideOknownTypes_collect)
                                (_righthandsideOknownValues)
                                (_righthandsideOknownValues_collect)
                                (_righthandsideOlabels_collect)
                                (_righthandsideOlabels_dist)
                                (_righthandsideOlocal)
                                (_righthandsideOmethods_collect)
                                (_righthandsideOmethods_dist)
                                (_righthandsideOmoduleTypes)
                                (_righthandsideOmoduleValues)
                                (_righthandsideOnameType)
                                (_righthandsideOtoplevel))
            -- "./Names.inc.lag"(line 758, column 9)
            (_patternOknownValues@_) =
                classMethods
                  _lhsIinstancename
                  _lhsIknownValues
                  _lhsImethods_dist
            -- "./Names.inc.lag"(line 756, column 9)
            (_lhsOknownValues_collect@_) =
                _patternIknownValues_collect
            -- "./Names.inc.lag"(line 755, column 9)
            (_patternOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- "./NameTypes.inc.lag"(line 261, column 9)
            (_patternOnameType@_) =
                if Maybe.isJust _lhsIinstancename then
                  ref_Val
                else if Maybe.isJust _lhsIclassname then
                  softref_Val
                else
                  Def_Val
            -- "./ModuleInformation.inc.lag"(line 148, column 8)
            (_righthandsideOtoplevel@_) =
                False
            -- use rule
            (_lhsOmodules@_) =
                _patternImodules `Set.union` _righthandsideImodules
            -- use rule
            (_lhsOres@_) =
                _patternIres ++ _righthandsideIres
            -- self rule
            (_self@_) =
                Declaration_PatternBinding _rangeIself _patternIself _righthandsideIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _righthandsideIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _righthandsideIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _righthandsideIknownTypes_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _righthandsideIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _righthandsideImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _righthandsideImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _righthandsideImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_patternOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_patternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_patternOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_patternOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_patternOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_patternOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_patternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_patternOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_patternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_patternOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_patternOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_righthandsideOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_righthandsideOconstructors_collect@_) =
                _patternIconstructors_collect
            -- copy rule (down)
            (_righthandsideOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_righthandsideOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_righthandsideOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_righthandsideOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_righthandsideOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_righthandsideOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_righthandsideOknownKinds_collect@_) =
                _patternIknownKinds_collect
            -- copy rule (down)
            (_righthandsideOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_righthandsideOknownTypes_collect@_) =
                _patternIknownTypes_collect
            -- copy rule (down)
            (_righthandsideOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_righthandsideOknownValues_collect@_) =
                _patternIknownValues_collect
            -- copy rule (chain)
            (_righthandsideOlabels_collect@_) =
                _patternIlabels_collect
            -- copy rule (down)
            (_righthandsideOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_righthandsideOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_righthandsideOmethods_collect@_) =
                _patternImethods_collect
            -- copy rule (down)
            (_righthandsideOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_righthandsideOmoduleTypes@_) =
                _patternImoduleTypes
            -- copy rule (chain)
            (_righthandsideOmoduleValues@_) =
                _patternImoduleValues
            -- copy rule (down)
            (_righthandsideOnameType@_) =
                _lhsInameType
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Declaration_Type :: (T_Range) ->
                        (T_SimpleType) ->
                        (T_Type) ->
                        (T_Declaration)
sem_Declaration_Type (range_) (simpletype_) (type_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _simpletypeIconstructors_collect :: (FMap Name Names)
            _simpletypeIknownKinds_collect :: (FMap Name [Name])
            _simpletypeIknownTypesForBody_collect :: (FMap Name [Name])
            _simpletypeIknownTypes_collect :: (FMap Name [Name])
            _simpletypeIknownValues_collect :: (FMap Name [Name])
            _simpletypeIlabels_collect :: (FMap Name Names)
            _simpletypeImethods_collect :: (FMap Name Names)
            _simpletypeImoduleTypes :: (FMap ModuleName [Name])
            _simpletypeImoduleValues :: (FMap ModuleName [Name])
            _simpletypeImodules :: (Set.Set Strings)
            _simpletypeIname :: (Name)
            _simpletypeIres :: ([ResolveResult])
            _simpletypeIself :: (SimpleType)
            _simpletypeOclassname :: (Maybe Name)
            _simpletypeOconstructors_collect :: (FMap Name Names)
            _simpletypeOconstructors_dist :: (FMap Name Names)
            _simpletypeOcurrentModule :: (Strings)
            _simpletypeOimportedModule :: (Bool)
            _simpletypeOinstancename :: (Maybe Name)
            _simpletypeOknownKinds :: (FMap Name [Name])
            _simpletypeOknownKinds_collect :: (FMap Name [Name])
            _simpletypeOknownTypes :: (FMap Name [Name])
            _simpletypeOknownTypesForBody_collect :: (FMap Name [Name])
            _simpletypeOknownTypes_collect :: (FMap Name [Name])
            _simpletypeOknownValues :: (FMap Name [Name])
            _simpletypeOknownValues_collect :: (FMap Name [Name])
            _simpletypeOlabels_collect :: (FMap Name Names)
            _simpletypeOlabels_dist :: (FMap Name Names)
            _simpletypeOlocal :: (Bool)
            _simpletypeOmethods_collect :: (FMap Name Names)
            _simpletypeOmethods_dist :: (FMap Name Names)
            _simpletypeOmoduleTypes :: (FMap ModuleName [Name])
            _simpletypeOmoduleValues :: (FMap ModuleName [Name])
            _simpletypeOnameType :: (NameType)
            _simpletypeOtoplevel :: (Bool)
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIknownKinds_collect :: (FMap Name [Name])
            _typeIknownTypes_collect :: (FMap Name [Name])
            _typeIknownValues_collect :: (FMap Name [Name])
            _typeIlabels_collect :: (FMap Name Names)
            _typeImethods_collect :: (FMap Name Names)
            _typeImoduleTypes :: (FMap ModuleName [Name])
            _typeImoduleValues :: (FMap ModuleName [Name])
            _typeImodules :: (Set.Set Strings)
            _typeIres :: ([ResolveResult])
            _typeIself :: (Type)
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOimportedModule :: (Bool)
            _typeOinstancename :: (Maybe Name)
            _typeOknownGenerics :: (FMap Name [Name])
            _typeOknownKinds :: (FMap Name [Name])
            _typeOknownKinds_collect :: (FMap Name [Name])
            _typeOknownTypes :: (FMap Name [Name])
            _typeOknownTypes_collect :: (FMap Name [Name])
            _typeOknownValues :: (FMap Name [Name])
            _typeOknownValues_collect :: (FMap Name [Name])
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOmoduleTypes :: (FMap ModuleName [Name])
            _typeOmoduleValues :: (FMap ModuleName [Name])
            _typeOnameType :: (NameType)
            _typeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _simpletypeIconstructors_collect,_simpletypeIknownKinds_collect,_simpletypeIknownTypesForBody_collect,_simpletypeIknownTypes_collect,_simpletypeIknownValues_collect,_simpletypeIlabels_collect,_simpletypeImethods_collect,_simpletypeImoduleTypes,_simpletypeImoduleValues,_simpletypeImodules,_simpletypeIname,_simpletypeIres,_simpletypeIself) =
                (simpletype_ (_simpletypeOclassname)
                             (_simpletypeOconstructors_collect)
                             (_simpletypeOconstructors_dist)
                             (_simpletypeOcurrentModule)
                             (_simpletypeOimportedModule)
                             (_simpletypeOinstancename)
                             (_simpletypeOknownKinds)
                             (_simpletypeOknownKinds_collect)
                             (_simpletypeOknownTypes)
                             (_simpletypeOknownTypesForBody_collect)
                             (_simpletypeOknownTypes_collect)
                             (_simpletypeOknownValues)
                             (_simpletypeOknownValues_collect)
                             (_simpletypeOlabels_collect)
                             (_simpletypeOlabels_dist)
                             (_simpletypeOlocal)
                             (_simpletypeOmethods_collect)
                             (_simpletypeOmethods_dist)
                             (_simpletypeOmoduleTypes)
                             (_simpletypeOmoduleValues)
                             (_simpletypeOnameType)
                             (_simpletypeOtoplevel))
            ( _typeIconstructors_collect,_typeIknownKinds_collect,_typeIknownTypes_collect,_typeIknownValues_collect,_typeIlabels_collect,_typeImethods_collect,_typeImoduleTypes,_typeImoduleValues,_typeImodules,_typeIres,_typeIself) =
                (type_ (_typeOclassname)
                       (_typeOconstructors_collect)
                       (_typeOconstructors_dist)
                       (_typeOcurrentModule)
                       (_typeOimportedModule)
                       (_typeOinstancename)
                       (_typeOknownGenerics)
                       (_typeOknownKinds)
                       (_typeOknownKinds_collect)
                       (_typeOknownTypes)
                       (_typeOknownTypes_collect)
                       (_typeOknownValues)
                       (_typeOknownValues_collect)
                       (_typeOlabels_collect)
                       (_typeOlabels_dist)
                       (_typeOlocal)
                       (_typeOmethods_collect)
                       (_typeOmethods_dist)
                       (_typeOmoduleTypes)
                       (_typeOmoduleValues)
                       (_typeOnameType)
                       (_typeOtoplevel))
            -- "./Names.inc.lag"(line 723, column 9)
            (_lhsOknownTypes_collect@_) =
                _simpletypeIknownTypes_collect
            -- "./Names.inc.lag"(line 722, column 9)
            (_typeOknownTypes@_) =
                _simpletypeIknownTypesForBody_collect `mergeFM` _lhsIknownTypes
            -- "./Names.inc.lag"(line 721, column 9)
            (_simpletypeOknownTypesForBody_collect@_) =
                emptyFM
            -- "./NameTypes.inc.lag"(line 299, column 9)
            (_typeOnameType@_) =
                ref_Typ
            -- "./ModuleInformation.inc.lag"(line 142, column 8)
            (_typeOtoplevel@_) =
                False
            -- use rule
            (_lhsOmodules@_) =
                _simpletypeImodules `Set.union` _typeImodules
            -- use rule
            (_lhsOres@_) =
                _simpletypeIres ++ _typeIres
            -- self rule
            (_self@_) =
                Declaration_Type _rangeIself _simpletypeIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _typeIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _typeIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _typeImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _typeImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_simpletypeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_simpletypeOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_simpletypeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_simpletypeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_simpletypeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_simpletypeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_simpletypeOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_simpletypeOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_simpletypeOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_simpletypeOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_simpletypeOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_simpletypeOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_simpletypeOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_simpletypeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_simpletypeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_simpletypeOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_simpletypeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_simpletypeOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_simpletypeOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_simpletypeOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_simpletypeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _simpletypeIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typeOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_typeOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_typeOknownKinds_collect@_) =
                _simpletypeIknownKinds_collect
            -- copy rule (chain)
            (_typeOknownTypes_collect@_) =
                _simpletypeIknownTypes_collect
            -- copy rule (down)
            (_typeOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_typeOknownValues_collect@_) =
                _simpletypeIknownValues_collect
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _simpletypeIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _simpletypeImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_typeOmoduleTypes@_) =
                _simpletypeImoduleTypes
            -- copy rule (chain)
            (_typeOmoduleValues@_) =
                _simpletypeImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Declaration_TypeIndexedType :: (T_Range) ->
                                   (T_Name) ->
                                   (T_TypeArgument) ->
                                   (T_Names) ->
                                   (T_Constructor) ->
                                   (T_Names) ->
                                   (T_Declaration)
sem_Declaration_TypeIndexedType (range_) (name_) (typeargument_) (typevariables_) (constructor_) (derivings_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _typeargumentIconstructors_collect :: (FMap Name Names)
            _typeargumentIknownKinds_collect :: (FMap Name [Name])
            _typeargumentIknownTypes_collect :: (FMap Name [Name])
            _typeargumentIknownValues_collect :: (FMap Name [Name])
            _typeargumentIlabels_collect :: (FMap Name Names)
            _typeargumentImethods_collect :: (FMap Name Names)
            _typeargumentImoduleTypes :: (FMap ModuleName [Name])
            _typeargumentImoduleValues :: (FMap ModuleName [Name])
            _typeargumentImodules :: (Set.Set Strings)
            _typeargumentIres :: ([ResolveResult])
            _typeargumentIself :: (TypeArgument)
            _typeargumentOclassname :: (Maybe Name)
            _typeargumentOconstructors_collect :: (FMap Name Names)
            _typeargumentOconstructors_dist :: (FMap Name Names)
            _typeargumentOcurrentModule :: (Strings)
            _typeargumentOimportedModule :: (Bool)
            _typeargumentOinstancename :: (Maybe Name)
            _typeargumentOknownKinds :: (FMap Name [Name])
            _typeargumentOknownKinds_collect :: (FMap Name [Name])
            _typeargumentOknownTypes :: (FMap Name [Name])
            _typeargumentOknownTypes_collect :: (FMap Name [Name])
            _typeargumentOknownValues :: (FMap Name [Name])
            _typeargumentOknownValues_collect :: (FMap Name [Name])
            _typeargumentOlabels_collect :: (FMap Name Names)
            _typeargumentOlabels_dist :: (FMap Name Names)
            _typeargumentOlocal :: (Bool)
            _typeargumentOmethods_collect :: (FMap Name Names)
            _typeargumentOmethods_dist :: (FMap Name Names)
            _typeargumentOmoduleTypes :: (FMap ModuleName [Name])
            _typeargumentOmoduleValues :: (FMap ModuleName [Name])
            _typeargumentOnameType :: (NameType)
            _typeargumentOtoplevel :: (Bool)
            _typevariablesIconstructors_collect :: (FMap Name Names)
            _typevariablesIknownKinds_collect :: (FMap Name [Name])
            _typevariablesIknownTypes_collect :: (FMap Name [Name])
            _typevariablesIknownValues_collect :: (FMap Name [Name])
            _typevariablesIlabels_collect :: (FMap Name Names)
            _typevariablesImethods_collect :: (FMap Name Names)
            _typevariablesImoduleTypes :: (FMap ModuleName [Name])
            _typevariablesImoduleValues :: (FMap ModuleName [Name])
            _typevariablesImodules :: (Set.Set Strings)
            _typevariablesIoriginalSelf :: (Names)
            _typevariablesIres :: ([ResolveResult])
            _typevariablesIself :: (Names)
            _typevariablesOclassname :: (Maybe Name)
            _typevariablesOconstructors_collect :: (FMap Name Names)
            _typevariablesOconstructors_dist :: (FMap Name Names)
            _typevariablesOcurrentModule :: (Strings)
            _typevariablesOimportedModule :: (Bool)
            _typevariablesOinstancename :: (Maybe Name)
            _typevariablesOknownKinds :: (FMap Name [Name])
            _typevariablesOknownKinds_collect :: (FMap Name [Name])
            _typevariablesOknownTypes :: (FMap Name [Name])
            _typevariablesOknownTypes_collect :: (FMap Name [Name])
            _typevariablesOknownValues :: (FMap Name [Name])
            _typevariablesOknownValues_collect :: (FMap Name [Name])
            _typevariablesOlabels_collect :: (FMap Name Names)
            _typevariablesOlabels_dist :: (FMap Name Names)
            _typevariablesOlocal :: (Bool)
            _typevariablesOmethods_collect :: (FMap Name Names)
            _typevariablesOmethods_dist :: (FMap Name Names)
            _typevariablesOmoduleTypes :: (FMap ModuleName [Name])
            _typevariablesOmoduleValues :: (FMap ModuleName [Name])
            _typevariablesOnameType :: (NameType)
            _typevariablesOtoplevel :: (Bool)
            _constructorIconstructors :: (Names)
            _constructorIconstructors_collect :: (FMap Name Names)
            _constructorIknownKinds_collect :: (FMap Name [Name])
            _constructorIknownTypes_collect :: (FMap Name [Name])
            _constructorIknownValues_collect :: (FMap Name [Name])
            _constructorIlabels :: (Names)
            _constructorIlabels_collect :: (FMap Name Names)
            _constructorImethods_collect :: (FMap Name Names)
            _constructorImoduleTypes :: (FMap ModuleName [Name])
            _constructorImoduleValues :: (FMap ModuleName [Name])
            _constructorImodules :: (Set.Set Strings)
            _constructorIres :: ([ResolveResult])
            _constructorIself :: (Constructor)
            _constructorOclassname :: (Maybe Name)
            _constructorOconstructors_collect :: (FMap Name Names)
            _constructorOconstructors_dist :: (FMap Name Names)
            _constructorOcurrentModule :: (Strings)
            _constructorOimportedModule :: (Bool)
            _constructorOinstancename :: (Maybe Name)
            _constructorOknownGenerics :: (FMap Name [Name])
            _constructorOknownKinds :: (FMap Name [Name])
            _constructorOknownKinds_collect :: (FMap Name [Name])
            _constructorOknownTypes :: (FMap Name [Name])
            _constructorOknownTypes_collect :: (FMap Name [Name])
            _constructorOknownValues :: (FMap Name [Name])
            _constructorOknownValues_collect :: (FMap Name [Name])
            _constructorOlabels_collect :: (FMap Name Names)
            _constructorOlabels_dist :: (FMap Name Names)
            _constructorOlocal :: (Bool)
            _constructorOmethods_collect :: (FMap Name Names)
            _constructorOmethods_dist :: (FMap Name Names)
            _constructorOmoduleTypes :: (FMap ModuleName [Name])
            _constructorOmoduleValues :: (FMap ModuleName [Name])
            _constructorOnameType :: (NameType)
            _constructorOtoplevel :: (Bool)
            _derivingsIconstructors_collect :: (FMap Name Names)
            _derivingsIknownKinds_collect :: (FMap Name [Name])
            _derivingsIknownTypes_collect :: (FMap Name [Name])
            _derivingsIknownValues_collect :: (FMap Name [Name])
            _derivingsIlabels_collect :: (FMap Name Names)
            _derivingsImethods_collect :: (FMap Name Names)
            _derivingsImoduleTypes :: (FMap ModuleName [Name])
            _derivingsImoduleValues :: (FMap ModuleName [Name])
            _derivingsImodules :: (Set.Set Strings)
            _derivingsIoriginalSelf :: (Names)
            _derivingsIres :: ([ResolveResult])
            _derivingsIself :: (Names)
            _derivingsOclassname :: (Maybe Name)
            _derivingsOconstructors_collect :: (FMap Name Names)
            _derivingsOconstructors_dist :: (FMap Name Names)
            _derivingsOcurrentModule :: (Strings)
            _derivingsOimportedModule :: (Bool)
            _derivingsOinstancename :: (Maybe Name)
            _derivingsOknownKinds :: (FMap Name [Name])
            _derivingsOknownKinds_collect :: (FMap Name [Name])
            _derivingsOknownTypes :: (FMap Name [Name])
            _derivingsOknownTypes_collect :: (FMap Name [Name])
            _derivingsOknownValues :: (FMap Name [Name])
            _derivingsOknownValues_collect :: (FMap Name [Name])
            _derivingsOlabels_collect :: (FMap Name Names)
            _derivingsOlabels_dist :: (FMap Name Names)
            _derivingsOlocal :: (Bool)
            _derivingsOmethods_collect :: (FMap Name Names)
            _derivingsOmethods_dist :: (FMap Name Names)
            _derivingsOmoduleTypes :: (FMap ModuleName [Name])
            _derivingsOmoduleValues :: (FMap ModuleName [Name])
            _derivingsOnameType :: (NameType)
            _derivingsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _typeargumentIconstructors_collect,_typeargumentIknownKinds_collect,_typeargumentIknownTypes_collect,_typeargumentIknownValues_collect,_typeargumentIlabels_collect,_typeargumentImethods_collect,_typeargumentImoduleTypes,_typeargumentImoduleValues,_typeargumentImodules,_typeargumentIres,_typeargumentIself) =
                (typeargument_ (_typeargumentOclassname)
                               (_typeargumentOconstructors_collect)
                               (_typeargumentOconstructors_dist)
                               (_typeargumentOcurrentModule)
                               (_typeargumentOimportedModule)
                               (_typeargumentOinstancename)
                               (_typeargumentOknownKinds)
                               (_typeargumentOknownKinds_collect)
                               (_typeargumentOknownTypes)
                               (_typeargumentOknownTypes_collect)
                               (_typeargumentOknownValues)
                               (_typeargumentOknownValues_collect)
                               (_typeargumentOlabels_collect)
                               (_typeargumentOlabels_dist)
                               (_typeargumentOlocal)
                               (_typeargumentOmethods_collect)
                               (_typeargumentOmethods_dist)
                               (_typeargumentOmoduleTypes)
                               (_typeargumentOmoduleValues)
                               (_typeargumentOnameType)
                               (_typeargumentOtoplevel))
            ( _typevariablesIconstructors_collect,_typevariablesIknownKinds_collect,_typevariablesIknownTypes_collect,_typevariablesIknownValues_collect,_typevariablesIlabels_collect,_typevariablesImethods_collect,_typevariablesImoduleTypes,_typevariablesImoduleValues,_typevariablesImodules,_typevariablesIoriginalSelf,_typevariablesIres,_typevariablesIself) =
                (typevariables_ (_typevariablesOclassname)
                                (_typevariablesOconstructors_collect)
                                (_typevariablesOconstructors_dist)
                                (_typevariablesOcurrentModule)
                                (_typevariablesOimportedModule)
                                (_typevariablesOinstancename)
                                (_typevariablesOknownKinds)
                                (_typevariablesOknownKinds_collect)
                                (_typevariablesOknownTypes)
                                (_typevariablesOknownTypes_collect)
                                (_typevariablesOknownValues)
                                (_typevariablesOknownValues_collect)
                                (_typevariablesOlabels_collect)
                                (_typevariablesOlabels_dist)
                                (_typevariablesOlocal)
                                (_typevariablesOmethods_collect)
                                (_typevariablesOmethods_dist)
                                (_typevariablesOmoduleTypes)
                                (_typevariablesOmoduleValues)
                                (_typevariablesOnameType)
                                (_typevariablesOtoplevel))
            ( _constructorIconstructors,_constructorIconstructors_collect,_constructorIknownKinds_collect,_constructorIknownTypes_collect,_constructorIknownValues_collect,_constructorIlabels,_constructorIlabels_collect,_constructorImethods_collect,_constructorImoduleTypes,_constructorImoduleValues,_constructorImodules,_constructorIres,_constructorIself) =
                (constructor_ (_constructorOclassname)
                              (_constructorOconstructors_collect)
                              (_constructorOconstructors_dist)
                              (_constructorOcurrentModule)
                              (_constructorOimportedModule)
                              (_constructorOinstancename)
                              (_constructorOknownGenerics)
                              (_constructorOknownKinds)
                              (_constructorOknownKinds_collect)
                              (_constructorOknownTypes)
                              (_constructorOknownTypes_collect)
                              (_constructorOknownValues)
                              (_constructorOknownValues_collect)
                              (_constructorOlabels_collect)
                              (_constructorOlabels_dist)
                              (_constructorOlocal)
                              (_constructorOmethods_collect)
                              (_constructorOmethods_dist)
                              (_constructorOmoduleTypes)
                              (_constructorOmoduleValues)
                              (_constructorOnameType)
                              (_constructorOtoplevel))
            ( _derivingsIconstructors_collect,_derivingsIknownKinds_collect,_derivingsIknownTypes_collect,_derivingsIknownValues_collect,_derivingsIlabels_collect,_derivingsImethods_collect,_derivingsImoduleTypes,_derivingsImoduleValues,_derivingsImodules,_derivingsIoriginalSelf,_derivingsIres,_derivingsIself) =
                (derivings_ (_derivingsOclassname)
                            (_derivingsOconstructors_collect)
                            (_derivingsOconstructors_dist)
                            (_derivingsOcurrentModule)
                            (_derivingsOimportedModule)
                            (_derivingsOinstancename)
                            (_derivingsOknownKinds)
                            (_derivingsOknownKinds_collect)
                            (_derivingsOknownTypes)
                            (_derivingsOknownTypes_collect)
                            (_derivingsOknownValues)
                            (_derivingsOknownValues_collect)
                            (_derivingsOlabels_collect)
                            (_derivingsOlabels_dist)
                            (_derivingsOlocal)
                            (_derivingsOmethods_collect)
                            (_derivingsOmethods_dist)
                            (_derivingsOmoduleTypes)
                            (_derivingsOmoduleValues)
                            (_derivingsOnameType)
                            (_derivingsOtoplevel))
            -- "./Names.inc.lag"(line 784, column 9)
            (_lhsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- "./Names.inc.lag"(line 783, column 9)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- "./Names.inc.lag"(line 782, column 9)
            (_constructorOknownTypes@_) =
                _typevariablesIknownTypes_collect `mergeFM` _lhsIknownTypes
            -- "./Names.inc.lag"(line 781, column 9)
            (_typevariablesOknownTypes_collect@_) =
                _typeargumentIknownTypes_collect
            -- "./Names.inc.lag"(line 780, column 9)
            (_typeargumentOknownTypes_collect@_) =
                emptyFM
            -- "./NameTypes.inc.lag"(line 319, column 9)
            (_derivingsOnameType@_) =
                ref_Typ
            -- "./NameTypes.inc.lag"(line 318, column 9)
            (_typevariablesOnameType@_) =
                Def_Typ
            -- "./NameTypes.inc.lag"(line 317, column 9)
            (_nameOnameType@_) =
                softdeforref_Typ
            -- "./ModuleInformation.inc.lag"(line 144, column 8)
            (_typevariablesOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 327, column 9)
            (_lhsOconstructors_collect@_) =
                addLBack _lhsIconstructors_collect
                         (_nameIself,_constructorIconstructors)
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _typeargumentImodules `Set.union` _typevariablesImodules `Set.union` _constructorImodules `Set.union` _derivingsImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _typeargumentIres ++ _typevariablesIres ++ _constructorIres ++ _derivingsIres
            -- self rule
            (_self@_) =
                Declaration_TypeIndexedType _rangeIself _nameIself _typeargumentIself _typevariablesIself _constructorIself _derivingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _derivingsIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _derivingsIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _derivingsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _derivingsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _derivingsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _derivingsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeargumentOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeargumentOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_typeargumentOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeargumentOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeargumentOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeargumentOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typeargumentOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_typeargumentOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_typeargumentOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_typeargumentOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_typeargumentOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_typeargumentOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_typeargumentOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeargumentOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeargumentOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_typeargumentOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_typeargumentOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_typeargumentOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_typeargumentOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_typeargumentOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typevariablesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typevariablesOconstructors_collect@_) =
                _typeargumentIconstructors_collect
            -- copy rule (down)
            (_typevariablesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typevariablesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typevariablesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typevariablesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typevariablesOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_typevariablesOknownKinds_collect@_) =
                _typeargumentIknownKinds_collect
            -- copy rule (down)
            (_typevariablesOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_typevariablesOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_typevariablesOknownValues_collect@_) =
                _typeargumentIknownValues_collect
            -- copy rule (chain)
            (_typevariablesOlabels_collect@_) =
                _typeargumentIlabels_collect
            -- copy rule (down)
            (_typevariablesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typevariablesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typevariablesOmethods_collect@_) =
                _typeargumentImethods_collect
            -- copy rule (down)
            (_typevariablesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_typevariablesOmoduleTypes@_) =
                _typeargumentImoduleTypes
            -- copy rule (chain)
            (_typevariablesOmoduleValues@_) =
                _typeargumentImoduleValues
            -- copy rule (down)
            (_constructorOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_constructorOconstructors_collect@_) =
                _typevariablesIconstructors_collect
            -- copy rule (down)
            (_constructorOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_constructorOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_constructorOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_constructorOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_constructorOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_constructorOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_constructorOknownKinds_collect@_) =
                _typevariablesIknownKinds_collect
            -- copy rule (chain)
            (_constructorOknownTypes_collect@_) =
                _typevariablesIknownTypes_collect
            -- copy rule (down)
            (_constructorOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_constructorOknownValues_collect@_) =
                _typevariablesIknownValues_collect
            -- copy rule (chain)
            (_constructorOlabels_collect@_) =
                _typevariablesIlabels_collect
            -- copy rule (down)
            (_constructorOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_constructorOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_constructorOmethods_collect@_) =
                _typevariablesImethods_collect
            -- copy rule (down)
            (_constructorOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_constructorOmoduleTypes@_) =
                _typevariablesImoduleTypes
            -- copy rule (chain)
            (_constructorOmoduleValues@_) =
                _typevariablesImoduleValues
            -- copy rule (down)
            (_constructorOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_constructorOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_derivingsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_derivingsOconstructors_collect@_) =
                _constructorIconstructors_collect
            -- copy rule (down)
            (_derivingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_derivingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_derivingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_derivingsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_derivingsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_derivingsOknownKinds_collect@_) =
                _constructorIknownKinds_collect
            -- copy rule (down)
            (_derivingsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_derivingsOknownTypes_collect@_) =
                _constructorIknownTypes_collect
            -- copy rule (down)
            (_derivingsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_derivingsOknownValues_collect@_) =
                _constructorIknownValues_collect
            -- copy rule (chain)
            (_derivingsOlabels_collect@_) =
                _constructorIlabels_collect
            -- copy rule (down)
            (_derivingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_derivingsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_derivingsOmethods_collect@_) =
                _constructorImethods_collect
            -- copy rule (down)
            (_derivingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_derivingsOmoduleTypes@_) =
                _constructorImoduleTypes
            -- copy rule (chain)
            (_derivingsOmoduleValues@_) =
                _constructorImoduleValues
            -- copy rule (down)
            (_derivingsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Declaration_TypeIndexedValue :: (T_Range) ->
                                    (T_TypeIndexedBindings) ->
                                    (T_Declaration)
sem_Declaration_TypeIndexedValue (range_) (bindings_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _bindingsIconstructors_collect :: (FMap Name Names)
            _bindingsIknownKinds_collect :: (FMap Name [Name])
            _bindingsIknownTypes_collect :: (FMap Name [Name])
            _bindingsIknownValues_collect :: (FMap Name [Name])
            _bindingsIlabels_collect :: (FMap Name Names)
            _bindingsImethods_collect :: (FMap Name Names)
            _bindingsImoduleTypes :: (FMap ModuleName [Name])
            _bindingsImoduleValues :: (FMap ModuleName [Name])
            _bindingsImodules :: (Set.Set Strings)
            _bindingsIname :: (Name)
            _bindingsIres :: ([ResolveResult])
            _bindingsIself :: (TypeIndexedBindings)
            _bindingsItypeargument :: (Maybe TypeArgument)
            _bindingsOclassname :: (Maybe Name)
            _bindingsOconstructors_collect :: (FMap Name Names)
            _bindingsOconstructors_dist :: (FMap Name Names)
            _bindingsOcurrentModule :: (Strings)
            _bindingsOimportedModule :: (Bool)
            _bindingsOinstancename :: (Maybe Name)
            _bindingsOknownGenerics :: (FMap Name [Name])
            _bindingsOknownKinds :: (FMap Name [Name])
            _bindingsOknownKinds_collect :: (FMap Name [Name])
            _bindingsOknownTypes :: (FMap Name [Name])
            _bindingsOknownTypes_collect :: (FMap Name [Name])
            _bindingsOknownValues :: (FMap Name [Name])
            _bindingsOknownValues_collect :: (FMap Name [Name])
            _bindingsOlabels_collect :: (FMap Name Names)
            _bindingsOlabels_dist :: (FMap Name Names)
            _bindingsOlocal :: (Bool)
            _bindingsOmethods_collect :: (FMap Name Names)
            _bindingsOmethods_dist :: (FMap Name Names)
            _bindingsOmoduleTypes :: (FMap ModuleName [Name])
            _bindingsOmoduleValues :: (FMap ModuleName [Name])
            _bindingsOnameType :: (NameType)
            _bindingsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _bindingsIconstructors_collect,_bindingsIknownKinds_collect,_bindingsIknownTypes_collect,_bindingsIknownValues_collect,_bindingsIlabels_collect,_bindingsImethods_collect,_bindingsImoduleTypes,_bindingsImoduleValues,_bindingsImodules,_bindingsIname,_bindingsIres,_bindingsIself,_bindingsItypeargument) =
                (bindings_ (_bindingsOclassname)
                           (_bindingsOconstructors_collect)
                           (_bindingsOconstructors_dist)
                           (_bindingsOcurrentModule)
                           (_bindingsOimportedModule)
                           (_bindingsOinstancename)
                           (_bindingsOknownGenerics)
                           (_bindingsOknownKinds)
                           (_bindingsOknownKinds_collect)
                           (_bindingsOknownTypes)
                           (_bindingsOknownTypes_collect)
                           (_bindingsOknownValues)
                           (_bindingsOknownValues_collect)
                           (_bindingsOlabels_collect)
                           (_bindingsOlabels_dist)
                           (_bindingsOlocal)
                           (_bindingsOmethods_collect)
                           (_bindingsOmethods_dist)
                           (_bindingsOmoduleTypes)
                           (_bindingsOmoduleValues)
                           (_bindingsOnameType)
                           (_bindingsOtoplevel))
            -- "./NameTypes.inc.lag"(line 270, column 9)
            (_bindingsOnameType@_) =
                Def_Val
            -- use rule
            (_lhsOmodules@_) =
                _bindingsImodules
            -- use rule
            (_lhsOres@_) =
                _bindingsIres
            -- self rule
            (_self@_) =
                Declaration_TypeIndexedValue _rangeIself _bindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _bindingsIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _bindingsIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _bindingsIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _bindingsIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _bindingsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _bindingsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _bindingsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _bindingsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_bindingsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_bindingsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_bindingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_bindingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_bindingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_bindingsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_bindingsOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_bindingsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_bindingsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_bindingsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_bindingsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_bindingsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_bindingsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_bindingsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_bindingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_bindingsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_bindingsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_bindingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_bindingsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_bindingsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_bindingsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Declaration_TypeSignature :: (T_Range) ->
                                 (T_Names) ->
                                 (T_Type) ->
                                 (T_Declaration)
sem_Declaration_TypeSignature (range_) (names_) (type_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _namesIconstructors_collect :: (FMap Name Names)
            _namesIknownKinds_collect :: (FMap Name [Name])
            _namesIknownTypes_collect :: (FMap Name [Name])
            _namesIknownValues_collect :: (FMap Name [Name])
            _namesIlabels_collect :: (FMap Name Names)
            _namesImethods_collect :: (FMap Name Names)
            _namesImoduleTypes :: (FMap ModuleName [Name])
            _namesImoduleValues :: (FMap ModuleName [Name])
            _namesImodules :: (Set.Set Strings)
            _namesIoriginalSelf :: (Names)
            _namesIres :: ([ResolveResult])
            _namesIself :: (Names)
            _namesOclassname :: (Maybe Name)
            _namesOconstructors_collect :: (FMap Name Names)
            _namesOconstructors_dist :: (FMap Name Names)
            _namesOcurrentModule :: (Strings)
            _namesOimportedModule :: (Bool)
            _namesOinstancename :: (Maybe Name)
            _namesOknownKinds :: (FMap Name [Name])
            _namesOknownKinds_collect :: (FMap Name [Name])
            _namesOknownTypes :: (FMap Name [Name])
            _namesOknownTypes_collect :: (FMap Name [Name])
            _namesOknownValues :: (FMap Name [Name])
            _namesOknownValues_collect :: (FMap Name [Name])
            _namesOlabels_collect :: (FMap Name Names)
            _namesOlabels_dist :: (FMap Name Names)
            _namesOlocal :: (Bool)
            _namesOmethods_collect :: (FMap Name Names)
            _namesOmethods_dist :: (FMap Name Names)
            _namesOmoduleTypes :: (FMap ModuleName [Name])
            _namesOmoduleValues :: (FMap ModuleName [Name])
            _namesOnameType :: (NameType)
            _namesOtoplevel :: (Bool)
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIknownKinds_collect :: (FMap Name [Name])
            _typeIknownTypes_collect :: (FMap Name [Name])
            _typeIknownValues_collect :: (FMap Name [Name])
            _typeIlabels_collect :: (FMap Name Names)
            _typeImethods_collect :: (FMap Name Names)
            _typeImoduleTypes :: (FMap ModuleName [Name])
            _typeImoduleValues :: (FMap ModuleName [Name])
            _typeImodules :: (Set.Set Strings)
            _typeIres :: ([ResolveResult])
            _typeIself :: (Type)
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOimportedModule :: (Bool)
            _typeOinstancename :: (Maybe Name)
            _typeOknownGenerics :: (FMap Name [Name])
            _typeOknownKinds :: (FMap Name [Name])
            _typeOknownKinds_collect :: (FMap Name [Name])
            _typeOknownTypes :: (FMap Name [Name])
            _typeOknownTypes_collect :: (FMap Name [Name])
            _typeOknownValues :: (FMap Name [Name])
            _typeOknownValues_collect :: (FMap Name [Name])
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOmoduleTypes :: (FMap ModuleName [Name])
            _typeOmoduleValues :: (FMap ModuleName [Name])
            _typeOnameType :: (NameType)
            _typeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _namesIconstructors_collect,_namesIknownKinds_collect,_namesIknownTypes_collect,_namesIknownValues_collect,_namesIlabels_collect,_namesImethods_collect,_namesImoduleTypes,_namesImoduleValues,_namesImodules,_namesIoriginalSelf,_namesIres,_namesIself) =
                (names_ (_namesOclassname)
                        (_namesOconstructors_collect)
                        (_namesOconstructors_dist)
                        (_namesOcurrentModule)
                        (_namesOimportedModule)
                        (_namesOinstancename)
                        (_namesOknownKinds)
                        (_namesOknownKinds_collect)
                        (_namesOknownTypes)
                        (_namesOknownTypes_collect)
                        (_namesOknownValues)
                        (_namesOknownValues_collect)
                        (_namesOlabels_collect)
                        (_namesOlabels_dist)
                        (_namesOlocal)
                        (_namesOmethods_collect)
                        (_namesOmethods_dist)
                        (_namesOmoduleTypes)
                        (_namesOmoduleValues)
                        (_namesOnameType)
                        (_namesOtoplevel))
            ( _typeIconstructors_collect,_typeIknownKinds_collect,_typeIknownTypes_collect,_typeIknownValues_collect,_typeIlabels_collect,_typeImethods_collect,_typeImoduleTypes,_typeImoduleValues,_typeImodules,_typeIres,_typeIself) =
                (type_ (_typeOclassname)
                       (_typeOconstructors_collect)
                       (_typeOconstructors_dist)
                       (_typeOcurrentModule)
                       (_typeOimportedModule)
                       (_typeOinstancename)
                       (_typeOknownGenerics)
                       (_typeOknownKinds)
                       (_typeOknownKinds_collect)
                       (_typeOknownTypes)
                       (_typeOknownTypes_collect)
                       (_typeOknownValues)
                       (_typeOknownValues_collect)
                       (_typeOlabels_collect)
                       (_typeOlabels_dist)
                       (_typeOlocal)
                       (_typeOmethods_collect)
                       (_typeOmethods_dist)
                       (_typeOmoduleTypes)
                       (_typeOmoduleValues)
                       (_typeOnameType)
                       (_typeOtoplevel))
            -- "./Names.inc.lag"(line 776, column 9)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- "./NameTypes.inc.lag"(line 331, column 9)
            (_typeOnameType@_) =
                deforref_Typ
            -- "./NameTypes.inc.lag"(line 326, column 9)
            (_namesOnameType@_) =
                case _lhsIclassname of
                  Nothing -> softref_Val
                  Just _  ->
                             Def_Val
            -- "./ModuleInformation.inc.lag"(line 146, column 8)
            (_typeOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 335, column 9)
            (_lhsOmethods_collect@_) =
                case _lhsIclassname of
                  Nothing -> _lhsImethods_collect
                  Just c  -> addLBack _lhsImethods_collect
                                      (c,_namesIself)
            -- use rule
            (_lhsOmodules@_) =
                _namesImodules `Set.union` _typeImodules
            -- use rule
            (_lhsOres@_) =
                _namesIres ++ _typeIres
            -- self rule
            (_self@_) =
                Declaration_TypeSignature _rangeIself _namesIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _typeIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _typeIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _typeImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _typeImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_namesOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_namesOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_namesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_namesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_namesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_namesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_namesOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_namesOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_namesOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_namesOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_namesOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_namesOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_namesOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_namesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_namesOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_namesOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_namesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_namesOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_namesOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_namesOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _namesIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typeOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_typeOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_typeOknownKinds_collect@_) =
                _namesIknownKinds_collect
            -- copy rule (down)
            (_typeOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_typeOknownTypes_collect@_) =
                _namesIknownTypes_collect
            -- copy rule (down)
            (_typeOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_typeOknownValues_collect@_) =
                _namesIknownValues_collect
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _namesIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _namesImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_typeOmoduleTypes@_) =
                _namesImoduleTypes
            -- copy rule (chain)
            (_typeOmoduleValues@_) =
                _namesImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- Declarations ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for Declarations.Cons:
      self

-}
{-
   local variables for Declarations.Nil:
      self

-}
-- semantic domain
type T_Declarations = (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Strings) ->
                      (Bool) ->
                      (Maybe Name) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (FMap ModuleName [Name]) ->
                      (FMap ModuleName [Name]) ->
                      (NameType) ->
                      (Bool) ->
                      ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(Declarations))
-- cata
sem_Declarations :: (Declarations) ->
                    (T_Declarations)
sem_Declarations (list) =
    (foldr (sem_Declarations_Cons) (sem_Declarations_Nil) ((map sem_Declaration list)))
sem_Declarations_Cons :: (T_Declaration) ->
                         (T_Declarations) ->
                         (T_Declarations)
sem_Declarations_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Declarations)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIknownKinds_collect :: (FMap Name [Name])
            _hdIknownTypes_collect :: (FMap Name [Name])
            _hdIknownValues_collect :: (FMap Name [Name])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdImoduleTypes :: (FMap ModuleName [Name])
            _hdImoduleValues :: (FMap ModuleName [Name])
            _hdImodules :: (Set.Set Strings)
            _hdIres :: ([ResolveResult])
            _hdIself :: (Declaration)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOknownGenerics :: (FMap Name [Name])
            _hdOknownKinds :: (FMap Name [Name])
            _hdOknownKinds_collect :: (FMap Name [Name])
            _hdOknownTypes :: (FMap Name [Name])
            _hdOknownTypes_collect :: (FMap Name [Name])
            _hdOknownValues :: (FMap Name [Name])
            _hdOknownValues_collect :: (FMap Name [Name])
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmoduleTypes :: (FMap ModuleName [Name])
            _hdOmoduleValues :: (FMap ModuleName [Name])
            _hdOnameType :: (NameType)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIknownKinds_collect :: (FMap Name [Name])
            _tlIknownTypes_collect :: (FMap Name [Name])
            _tlIknownValues_collect :: (FMap Name [Name])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlImoduleTypes :: (FMap ModuleName [Name])
            _tlImoduleValues :: (FMap ModuleName [Name])
            _tlImodules :: (Set.Set Strings)
            _tlIres :: ([ResolveResult])
            _tlIself :: (Declarations)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOknownGenerics :: (FMap Name [Name])
            _tlOknownKinds :: (FMap Name [Name])
            _tlOknownKinds_collect :: (FMap Name [Name])
            _tlOknownTypes :: (FMap Name [Name])
            _tlOknownTypes_collect :: (FMap Name [Name])
            _tlOknownValues :: (FMap Name [Name])
            _tlOknownValues_collect :: (FMap Name [Name])
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmoduleTypes :: (FMap ModuleName [Name])
            _tlOmoduleValues :: (FMap ModuleName [Name])
            _tlOnameType :: (NameType)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIknownKinds_collect,_hdIknownTypes_collect,_hdIknownValues_collect,_hdIlabels_collect,_hdImethods_collect,_hdImoduleTypes,_hdImoduleValues,_hdImodules,_hdIres,_hdIself) =
                (hd_ (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOknownGenerics)
                     (_hdOknownKinds)
                     (_hdOknownKinds_collect)
                     (_hdOknownTypes)
                     (_hdOknownTypes_collect)
                     (_hdOknownValues)
                     (_hdOknownValues_collect)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmoduleTypes)
                     (_hdOmoduleValues)
                     (_hdOnameType)
                     (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIknownKinds_collect,_tlIknownTypes_collect,_tlIknownValues_collect,_tlIlabels_collect,_tlImethods_collect,_tlImoduleTypes,_tlImoduleValues,_tlImodules,_tlIres,_tlIself) =
                (tl_ (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOknownGenerics)
                     (_tlOknownKinds)
                     (_tlOknownKinds_collect)
                     (_tlOknownTypes)
                     (_tlOknownTypes_collect)
                     (_tlOknownValues)
                     (_tlOknownValues_collect)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmoduleTypes)
                     (_tlOmoduleValues)
                     (_tlOnameType)
                     (_tlOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _hdImodules `Set.union` _tlImodules
            -- use rule
            (_lhsOres@_) =
                _hdIres ++ _tlIres
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _tlIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _tlIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _tlIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _tlImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _tlImoduleValues
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_hdOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_hdOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_hdOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_hdOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_hdOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_hdOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_hdOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_hdOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_tlOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_tlOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_tlOknownKinds_collect@_) =
                _hdIknownKinds_collect
            -- copy rule (down)
            (_tlOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_tlOknownTypes_collect@_) =
                _hdIknownTypes_collect
            -- copy rule (down)
            (_tlOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_tlOknownValues_collect@_) =
                _hdIknownValues_collect
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_tlOmoduleTypes@_) =
                _hdImoduleTypes
            -- copy rule (chain)
            (_tlOmoduleValues@_) =
                _hdImoduleValues
            -- copy rule (down)
            (_tlOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Declarations_Nil :: (T_Declarations)
sem_Declarations_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Declarations)
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- DependencyBinding -------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool
      typelevel            : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for DependencyBinding.Rename:
      self

-}
{-
   local variables for DependencyBinding.Simple:
      self

-}
-- semantic domain
type T_DependencyBinding = (Maybe Name) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Strings) ->
                           (Bool) ->
                           (Maybe Name) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Bool) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (FMap ModuleName [Name]) ->
                           (FMap ModuleName [Name]) ->
                           (NameType) ->
                           (Bool) ->
                           (Bool) ->
                           ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(DependencyBinding))
-- cata
sem_DependencyBinding :: (DependencyBinding) ->
                         (T_DependencyBinding)
sem_DependencyBinding ((DependencyBinding_Rename (_range) (_name) (_as))) =
    (sem_DependencyBinding_Rename ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Name (_as))))
sem_DependencyBinding ((DependencyBinding_Simple (_range) (_name))) =
    (sem_DependencyBinding_Simple ((sem_Range (_range))) ((sem_Name (_name))))
sem_DependencyBinding_Rename :: (T_Range) ->
                                (T_Name) ->
                                (T_Name) ->
                                (T_DependencyBinding)
sem_DependencyBinding_Rename (range_) (name_) (as_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel
      _lhsItypelevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (DependencyBinding)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _asIconstructors_collect :: (FMap Name Names)
            _asIentityName :: (Name)
            _asIfullName :: (Name)
            _asIknownKinds_collect :: (FMap Name [Name])
            _asIknownTypes_collect :: (FMap Name [Name])
            _asIknownValues_collect :: (FMap Name [Name])
            _asIlabels_collect :: (FMap Name Names)
            _asImethods_collect :: (FMap Name Names)
            _asImoduleTypes :: (FMap ModuleName [Name])
            _asImoduleValues :: (FMap ModuleName [Name])
            _asImodules :: (Set.Set Strings)
            _asIoriginalSelf :: (Name)
            _asIres :: ([ResolveResult])
            _asIself :: (Name)
            _asOclassname :: (Maybe Name)
            _asOconstructors_collect :: (FMap Name Names)
            _asOconstructors_dist :: (FMap Name Names)
            _asOcurrentModule :: (Strings)
            _asOimportedModule :: (Bool)
            _asOinstancename :: (Maybe Name)
            _asOknownKinds :: (FMap Name [Name])
            _asOknownKinds_collect :: (FMap Name [Name])
            _asOknownTypes :: (FMap Name [Name])
            _asOknownTypes_collect :: (FMap Name [Name])
            _asOknownValues :: (FMap Name [Name])
            _asOknownValues_collect :: (FMap Name [Name])
            _asOlabels_collect :: (FMap Name Names)
            _asOlabels_dist :: (FMap Name Names)
            _asOlocal :: (Bool)
            _asOmethods_collect :: (FMap Name Names)
            _asOmethods_dist :: (FMap Name Names)
            _asOmoduleTypes :: (FMap ModuleName [Name])
            _asOmoduleValues :: (FMap ModuleName [Name])
            _asOnameType :: (NameType)
            _asOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _asIconstructors_collect,_asIentityName,_asIfullName,_asIknownKinds_collect,_asIknownTypes_collect,_asIknownValues_collect,_asIlabels_collect,_asImethods_collect,_asImoduleTypes,_asImoduleValues,_asImodules,_asIoriginalSelf,_asIres,_asIself) =
                (as_ (_asOclassname) (_asOconstructors_collect) (_asOconstructors_dist) (_asOcurrentModule) (_asOimportedModule) (_asOinstancename) (_asOknownKinds) (_asOknownKinds_collect) (_asOknownTypes) (_asOknownTypes_collect) (_asOknownValues) (_asOknownValues_collect) (_asOlabels_collect) (_asOlabels_dist) (_asOlocal) (_asOmethods_collect) (_asOmethods_dist) (_asOmoduleTypes) (_asOmoduleValues) (_asOnameType) (_asOtoplevel))
            -- "./NameTypes.inc.lag"(line 342, column 9)
            (_asOnameType@_) =
                if _lhsItypelevel then Def_Typ
                                  else Def_Val
            -- "./NameTypes.inc.lag"(line 340, column 9)
            (_nameOnameType@_) =
                if _lhsItypelevel then ref_Typ
                                  else ref_Val
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _asImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _asIres
            -- self rule
            (_self@_) =
                DependencyBinding_Rename _rangeIself _nameIself _asIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _asIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _asIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _asIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _asIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _asIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _asImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _asImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _asImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_asOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_asOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_asOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_asOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_asOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_asOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_asOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_asOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_asOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_asOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (down)
            (_asOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_asOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_asOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_asOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_asOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_asOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_asOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_asOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_asOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_asOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_DependencyBinding_Simple :: (T_Range) ->
                                (T_Name) ->
                                (T_DependencyBinding)
sem_DependencyBinding_Simple (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel
      _lhsItypelevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (DependencyBinding)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            -- "./NameTypes.inc.lag"(line 337, column 9)
            (_nameOnameType@_) =
                if _lhsItypelevel then ref_Typ
                                  else ref_Val
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres
            -- self rule
            (_self@_) =
                DependencyBinding_Simple _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- DependencyBindings ------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool
      typelevel            : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for DependencyBindings.Cons:
      self

-}
{-
   local variables for DependencyBindings.Nil:
      self

-}
-- semantic domain
type T_DependencyBindings = (Maybe Name) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Strings) ->
                            (Bool) ->
                            (Maybe Name) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Bool) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (FMap ModuleName [Name]) ->
                            (FMap ModuleName [Name]) ->
                            (NameType) ->
                            (Bool) ->
                            (Bool) ->
                            ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(DependencyBindings))
-- cata
sem_DependencyBindings :: (DependencyBindings) ->
                          (T_DependencyBindings)
sem_DependencyBindings (list) =
    (foldr (sem_DependencyBindings_Cons) (sem_DependencyBindings_Nil) ((map sem_DependencyBinding list)))
sem_DependencyBindings_Cons :: (T_DependencyBinding) ->
                               (T_DependencyBindings) ->
                               (T_DependencyBindings)
sem_DependencyBindings_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel
      _lhsItypelevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (DependencyBindings)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIknownKinds_collect :: (FMap Name [Name])
            _hdIknownTypes_collect :: (FMap Name [Name])
            _hdIknownValues_collect :: (FMap Name [Name])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdImoduleTypes :: (FMap ModuleName [Name])
            _hdImoduleValues :: (FMap ModuleName [Name])
            _hdImodules :: (Set.Set Strings)
            _hdIres :: ([ResolveResult])
            _hdIself :: (DependencyBinding)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOknownKinds :: (FMap Name [Name])
            _hdOknownKinds_collect :: (FMap Name [Name])
            _hdOknownTypes :: (FMap Name [Name])
            _hdOknownTypes_collect :: (FMap Name [Name])
            _hdOknownValues :: (FMap Name [Name])
            _hdOknownValues_collect :: (FMap Name [Name])
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmoduleTypes :: (FMap ModuleName [Name])
            _hdOmoduleValues :: (FMap ModuleName [Name])
            _hdOnameType :: (NameType)
            _hdOtoplevel :: (Bool)
            _hdOtypelevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIknownKinds_collect :: (FMap Name [Name])
            _tlIknownTypes_collect :: (FMap Name [Name])
            _tlIknownValues_collect :: (FMap Name [Name])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlImoduleTypes :: (FMap ModuleName [Name])
            _tlImoduleValues :: (FMap ModuleName [Name])
            _tlImodules :: (Set.Set Strings)
            _tlIres :: ([ResolveResult])
            _tlIself :: (DependencyBindings)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOknownKinds :: (FMap Name [Name])
            _tlOknownKinds_collect :: (FMap Name [Name])
            _tlOknownTypes :: (FMap Name [Name])
            _tlOknownTypes_collect :: (FMap Name [Name])
            _tlOknownValues :: (FMap Name [Name])
            _tlOknownValues_collect :: (FMap Name [Name])
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmoduleTypes :: (FMap ModuleName [Name])
            _tlOmoduleValues :: (FMap ModuleName [Name])
            _tlOnameType :: (NameType)
            _tlOtoplevel :: (Bool)
            _tlOtypelevel :: (Bool)
            ( _hdIconstructors_collect,_hdIknownKinds_collect,_hdIknownTypes_collect,_hdIknownValues_collect,_hdIlabels_collect,_hdImethods_collect,_hdImoduleTypes,_hdImoduleValues,_hdImodules,_hdIres,_hdIself) =
                (hd_ (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOknownKinds)
                     (_hdOknownKinds_collect)
                     (_hdOknownTypes)
                     (_hdOknownTypes_collect)
                     (_hdOknownValues)
                     (_hdOknownValues_collect)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmoduleTypes)
                     (_hdOmoduleValues)
                     (_hdOnameType)
                     (_hdOtoplevel)
                     (_hdOtypelevel))
            ( _tlIconstructors_collect,_tlIknownKinds_collect,_tlIknownTypes_collect,_tlIknownValues_collect,_tlIlabels_collect,_tlImethods_collect,_tlImoduleTypes,_tlImoduleValues,_tlImodules,_tlIres,_tlIself) =
                (tl_ (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOknownKinds)
                     (_tlOknownKinds_collect)
                     (_tlOknownTypes)
                     (_tlOknownTypes_collect)
                     (_tlOknownValues)
                     (_tlOknownValues_collect)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmoduleTypes)
                     (_tlOmoduleValues)
                     (_tlOnameType)
                     (_tlOtoplevel)
                     (_tlOtypelevel))
            -- use rule
            (_lhsOmodules@_) =
                _hdImodules `Set.union` _tlImodules
            -- use rule
            (_lhsOres@_) =
                _hdIres ++ _tlIres
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _tlIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _tlIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _tlIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _tlImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _tlImoduleValues
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_hdOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_hdOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_hdOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_hdOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_hdOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_hdOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_hdOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_hdOtypelevel@_) =
                _lhsItypelevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_tlOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_tlOknownKinds_collect@_) =
                _hdIknownKinds_collect
            -- copy rule (down)
            (_tlOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_tlOknownTypes_collect@_) =
                _hdIknownTypes_collect
            -- copy rule (down)
            (_tlOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_tlOknownValues_collect@_) =
                _hdIknownValues_collect
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_tlOmoduleTypes@_) =
                _hdImoduleTypes
            -- copy rule (chain)
            (_tlOmoduleValues@_) =
                _hdImoduleValues
            -- copy rule (down)
            (_tlOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOtypelevel@_) =
                _lhsItypelevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_DependencyBindings_Nil :: (T_DependencyBindings)
sem_DependencyBindings_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel
      _lhsItypelevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (DependencyBindings)
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- Export ------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      replace              : Exports
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for Export.Module:
      relevantValues
      relevantTypes
      self

-}
{-
   local variables for Export.TypeOrClass:
      relevantEntities
      self

-}
{-
   local variables for Export.TypeOrClassComplete:
      self

-}
{-
   local variables for Export.Variable:
      self

-}
-- semantic domain
type T_Export = (Maybe Name) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (Strings) ->
                (Bool) ->
                (Maybe Name) ->
                (FMap Name [Name]) ->
                (FMap Name [Name]) ->
                (FMap Name [Name]) ->
                (FMap Name [Name]) ->
                (FMap Name [Name]) ->
                (FMap Name [Name]) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (Bool) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (FMap ModuleName [Name]) ->
                (FMap ModuleName [Name]) ->
                (NameType) ->
                (Bool) ->
                ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),(Exports),([ResolveResult]),(Export))
-- cata
sem_Export :: (Export) ->
              (T_Export)
sem_Export ((Export_Module (_range) (_name))) =
    (sem_Export_Module ((sem_Range (_range))) ((sem_ModuleName (_name))))
sem_Export ((Export_TypeOrClass (_range) (_name) (_names))) =
    (sem_Export_TypeOrClass ((sem_Range (_range))) ((sem_Name (_name))) ((sem_MaybeNames (_names))))
sem_Export ((Export_TypeOrClassComplete (_range) (_name))) =
    (sem_Export_TypeOrClassComplete ((sem_Range (_range))) ((sem_Name (_name))))
sem_Export ((Export_Variable (_range) (_name))) =
    (sem_Export_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Export_Module :: (T_Range) ->
                     (T_ModuleName) ->
                     (T_Export)
sem_Export_Module (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOreplace :: (Exports)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Export)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIres :: ([ResolveResult])
            _nameIself :: (ModuleName)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            -- "NameReplace.lag"(line 154, column 9)
            (_lhsOreplace@_) =
                prepareExportList
                  _relevantValues
                  _relevantTypes
                  _lhsIconstructors_dist
                  _lhsImethods_dist
            -- "NameReplace.lag"(line 150, column 9)
            (_relevantValues@_) =
                makeRelevant
                  (getModuleName _nameIself)
                  _lhsIknownValues
            -- "NameReplace.lag"(line 147, column 9)
            (_relevantTypes@_) =
                makeRelevant
                  (getModuleName _nameIself)
                  _lhsIknownTypes
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres
            -- self rule
            (_self@_) =
                Export_Module _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOreplace,_lhsOres,_lhsOself)
sem_Export_TypeOrClass :: (T_Range) ->
                          (T_Name) ->
                          (T_MaybeNames) ->
                          (T_Export)
sem_Export_TypeOrClass (range_) (name_) (names_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOreplace :: (Exports)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Export)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _namesIconstructors_collect :: (FMap Name Names)
            _namesIknownKinds_collect :: (FMap Name [Name])
            _namesIknownTypes_collect :: (FMap Name [Name])
            _namesIknownValues_collect :: (FMap Name [Name])
            _namesIlabels_collect :: (FMap Name Names)
            _namesImethods_collect :: (FMap Name Names)
            _namesImoduleTypes :: (FMap ModuleName [Name])
            _namesImoduleValues :: (FMap ModuleName [Name])
            _namesImodules :: (Set.Set Strings)
            _namesIres :: ([ResolveResult])
            _namesIself :: (MaybeNames)
            _namesOclassname :: (Maybe Name)
            _namesOconstructors_collect :: (FMap Name Names)
            _namesOconstructors_dist :: (FMap Name Names)
            _namesOcurrentModule :: (Strings)
            _namesOimportedModule :: (Bool)
            _namesOinstancename :: (Maybe Name)
            _namesOknownKinds :: (FMap Name [Name])
            _namesOknownKinds_collect :: (FMap Name [Name])
            _namesOknownTypes :: (FMap Name [Name])
            _namesOknownTypes_collect :: (FMap Name [Name])
            _namesOknownValues :: (FMap Name [Name])
            _namesOknownValues_collect :: (FMap Name [Name])
            _namesOlabels_collect :: (FMap Name Names)
            _namesOlabels_dist :: (FMap Name Names)
            _namesOlocal :: (Bool)
            _namesOmethods_collect :: (FMap Name Names)
            _namesOmethods_dist :: (FMap Name Names)
            _namesOmoduleTypes :: (FMap ModuleName [Name])
            _namesOmoduleValues :: (FMap ModuleName [Name])
            _namesOnameType :: (NameType)
            _namesOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _namesIconstructors_collect,_namesIknownKinds_collect,_namesIknownTypes_collect,_namesIknownValues_collect,_namesIlabels_collect,_namesImethods_collect,_namesImoduleTypes,_namesImoduleValues,_namesImodules,_namesIres,_namesIself) =
                (names_ (_namesOclassname)
                        (_namesOconstructors_collect)
                        (_namesOconstructors_dist)
                        (_namesOcurrentModule)
                        (_namesOimportedModule)
                        (_namesOinstancename)
                        (_namesOknownKinds)
                        (_namesOknownKinds_collect)
                        (_namesOknownTypes)
                        (_namesOknownTypes_collect)
                        (_namesOknownValues)
                        (_namesOknownValues_collect)
                        (_namesOlabels_collect)
                        (_namesOlabels_dist)
                        (_namesOlocal)
                        (_namesOmethods_collect)
                        (_namesOmethods_dist)
                        (_namesOmoduleTypes)
                        (_namesOmoduleValues)
                        (_namesOnameType)
                        (_namesOtoplevel))
            -- "NameReplace.lag"(line 125, column 9)
            (_lhsOreplace@_) =
                [_self]
            -- "./Names.inc.lag"(line 524, column 9)
            (_namesOknownValues@_) =
                ( fromList
                . filter (\ (_,es) -> not . null $
                                        es `List.intersect` _relevantEntities)
                . toList
                ) _lhsIknownValues
            -- "./Names.inc.lag"(line 517, column 9)
            (_relevantEntities@_) =
                map getEntity $
                  findL _lhsImethods_dist _nameIself
                    ++
                  findL _lhsIconstructors_dist _nameIself
                    ++
                  findL _lhsIlabels_dist _nameIself
            -- "./Names.inc.lag"(line 515, column 9)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- "./NameTypes.inc.lag"(line 101, column 9)
            (_namesOnameType@_) =
                ref_Val
            -- "./NameTypes.inc.lag"(line 100, column 9)
            (_nameOnameType@_) =
                ref_Typ
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _namesImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _namesIres
            -- self rule
            (_self@_) =
                Export_TypeOrClass _rangeIself _nameIself _namesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _namesIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _namesIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _namesIknownTypes_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _namesIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _namesImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _namesImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _namesImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_namesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_namesOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_namesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_namesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_namesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_namesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_namesOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_namesOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_namesOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_namesOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (chain)
            (_namesOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_namesOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_namesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_namesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_namesOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_namesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_namesOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_namesOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_namesOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOreplace,_lhsOres,_lhsOself)
sem_Export_TypeOrClassComplete :: (T_Range) ->
                                  (T_Name) ->
                                  (T_Export)
sem_Export_TypeOrClassComplete (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOreplace :: (Exports)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Export)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            -- "NameReplace.lag"(line 127, column 9)
            (_lhsOreplace@_) =
                [_self]
            -- "./NameTypes.inc.lag"(line 103, column 9)
            (_nameOnameType@_) =
                ref_Typ
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres
            -- self rule
            (_self@_) =
                Export_TypeOrClassComplete _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOreplace,_lhsOres,_lhsOself)
sem_Export_Variable :: (T_Range) ->
                       (T_Name) ->
                       (T_Export)
sem_Export_Variable (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOreplace :: (Exports)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Export)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            -- "NameReplace.lag"(line 123, column 9)
            (_lhsOreplace@_) =
                [_self]
            -- "./NameTypes.inc.lag"(line 98, column 9)
            (_nameOnameType@_) =
                ref_Val
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres
            -- self rule
            (_self@_) =
                Export_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOreplace,_lhsOres,_lhsOself)
-- Exports -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      replace              : Exports
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for Exports.Cons:
      self

-}
{-
   local variables for Exports.Nil:
      self

-}
-- semantic domain
type T_Exports = (Maybe Name) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Strings) ->
                 (Bool) ->
                 (Maybe Name) ->
                 (FMap Name [Name]) ->
                 (FMap Name [Name]) ->
                 (FMap Name [Name]) ->
                 (FMap Name [Name]) ->
                 (FMap Name [Name]) ->
                 (FMap Name [Name]) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Bool) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (FMap ModuleName [Name]) ->
                 (FMap ModuleName [Name]) ->
                 (NameType) ->
                 (Bool) ->
                 ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),(Exports),([ResolveResult]),(Exports))
-- cata
sem_Exports :: (Exports) ->
               (T_Exports)
sem_Exports (list) =
    (foldr (sem_Exports_Cons) (sem_Exports_Nil) ((map sem_Export list)))
sem_Exports_Cons :: (T_Export) ->
                    (T_Exports) ->
                    (T_Exports)
sem_Exports_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOreplace :: (Exports)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Exports)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIknownKinds_collect :: (FMap Name [Name])
            _hdIknownTypes_collect :: (FMap Name [Name])
            _hdIknownValues_collect :: (FMap Name [Name])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdImoduleTypes :: (FMap ModuleName [Name])
            _hdImoduleValues :: (FMap ModuleName [Name])
            _hdImodules :: (Set.Set Strings)
            _hdIreplace :: (Exports)
            _hdIres :: ([ResolveResult])
            _hdIself :: (Export)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOknownKinds :: (FMap Name [Name])
            _hdOknownKinds_collect :: (FMap Name [Name])
            _hdOknownTypes :: (FMap Name [Name])
            _hdOknownTypes_collect :: (FMap Name [Name])
            _hdOknownValues :: (FMap Name [Name])
            _hdOknownValues_collect :: (FMap Name [Name])
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmoduleTypes :: (FMap ModuleName [Name])
            _hdOmoduleValues :: (FMap ModuleName [Name])
            _hdOnameType :: (NameType)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIknownKinds_collect :: (FMap Name [Name])
            _tlIknownTypes_collect :: (FMap Name [Name])
            _tlIknownValues_collect :: (FMap Name [Name])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlImoduleTypes :: (FMap ModuleName [Name])
            _tlImoduleValues :: (FMap ModuleName [Name])
            _tlImodules :: (Set.Set Strings)
            _tlIreplace :: (Exports)
            _tlIres :: ([ResolveResult])
            _tlIself :: (Exports)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOknownKinds :: (FMap Name [Name])
            _tlOknownKinds_collect :: (FMap Name [Name])
            _tlOknownTypes :: (FMap Name [Name])
            _tlOknownTypes_collect :: (FMap Name [Name])
            _tlOknownValues :: (FMap Name [Name])
            _tlOknownValues_collect :: (FMap Name [Name])
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmoduleTypes :: (FMap ModuleName [Name])
            _tlOmoduleValues :: (FMap ModuleName [Name])
            _tlOnameType :: (NameType)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIknownKinds_collect,_hdIknownTypes_collect,_hdIknownValues_collect,_hdIlabels_collect,_hdImethods_collect,_hdImoduleTypes,_hdImoduleValues,_hdImodules,_hdIreplace,_hdIres,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOimportedModule) (_hdOinstancename) (_hdOknownKinds) (_hdOknownKinds_collect) (_hdOknownTypes) (_hdOknownTypes_collect) (_hdOknownValues) (_hdOknownValues_collect) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOmoduleTypes) (_hdOmoduleValues) (_hdOnameType) (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIknownKinds_collect,_tlIknownTypes_collect,_tlIknownValues_collect,_tlIlabels_collect,_tlImethods_collect,_tlImoduleTypes,_tlImoduleValues,_tlImodules,_tlIreplace,_tlIres,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOimportedModule) (_tlOinstancename) (_tlOknownKinds) (_tlOknownKinds_collect) (_tlOknownTypes) (_tlOknownTypes_collect) (_tlOknownValues) (_tlOknownValues_collect) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOmoduleTypes) (_tlOmoduleValues) (_tlOnameType) (_tlOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _hdImodules `Set.union` _tlImodules
            -- use rule
            (_lhsOreplace@_) =
                _hdIreplace ++ _tlIreplace
            -- use rule
            (_lhsOres@_) =
                _hdIres ++ _tlIres
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _tlIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _tlIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _tlIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _tlImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _tlImoduleValues
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_hdOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_hdOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_hdOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_hdOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_hdOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_hdOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_hdOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_tlOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_tlOknownKinds_collect@_) =
                _hdIknownKinds_collect
            -- copy rule (down)
            (_tlOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_tlOknownTypes_collect@_) =
                _hdIknownTypes_collect
            -- copy rule (down)
            (_tlOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_tlOknownValues_collect@_) =
                _hdIknownValues_collect
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_tlOmoduleTypes@_) =
                _hdImoduleTypes
            -- copy rule (chain)
            (_tlOmoduleValues@_) =
                _hdImoduleValues
            -- copy rule (down)
            (_tlOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOreplace,_lhsOres,_lhsOself)
sem_Exports_Nil :: (T_Exports)
sem_Exports_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOreplace :: (Exports)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Exports)
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOreplace@_) =
                []
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOreplace,_lhsOres,_lhsOself)
-- Expression --------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for Expression.As:
      self

-}
{-
   local variables for Expression.Case:
      self

-}
{-
   local variables for Expression.Comprehension:
      self

-}
{-
   local variables for Expression.Constructor:
      self

-}
{-
   local variables for Expression.Do:
      self

-}
{-
   local variables for Expression.Enum:
      self

-}
{-
   local variables for Expression.If:
      self

-}
{-
   local variables for Expression.InfixApplication:
      self

-}
{-
   local variables for Expression.Irrefutable:
      self

-}
{-
   local variables for Expression.Lambda:
      knownValues
      self

-}
{-
   local variables for Expression.Let:
      knownTypes
      knownValues
      self

-}
{-
   local variables for Expression.List:
      self

-}
{-
   local variables for Expression.Literal:
      self

-}
{-
   local variables for Expression.Negate:
      self

-}
{-
   local variables for Expression.NormalApplication:
      self

-}
{-
   local variables for Expression.Parenthesized:
      self

-}
{-
   local variables for Expression.RecordConstruction:
      self

-}
{-
   local variables for Expression.RecordUpdate:
      self

-}
{-
   local variables for Expression.Tuple:
      self

-}
{-
   local variables for Expression.TypeApplication:
      self

-}
{-
   local variables for Expression.Typed:
      self

-}
{-
   local variables for Expression.Variable:
      self

-}
{-
   local variables for Expression.Wildcard:
      self

-}
-- semantic domain
type T_Expression = (Maybe Name) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Strings) ->
                    (Bool) ->
                    (Maybe Name) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Bool) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (FMap ModuleName [Name]) ->
                    (FMap ModuleName [Name]) ->
                    (NameType) ->
                    (Bool) ->
                    ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(Expression))
-- cata
sem_Expression :: (Expression) ->
                  (T_Expression)
sem_Expression ((Expression_As (_range) (_name) (_expression))) =
    (sem_Expression_As ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Expression (_expression))))
sem_Expression ((Expression_Case (_range) (_expression) (_alternatives))) =
    (sem_Expression_Case ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_Alternatives (_alternatives))))
sem_Expression ((Expression_Comprehension (_range) (_expression) (_qualifiers))) =
    (sem_Expression_Comprehension ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_Qualifiers (_qualifiers))))
sem_Expression ((Expression_Constructor (_range) (_name))) =
    (sem_Expression_Constructor ((sem_Range (_range))) ((sem_Name (_name))))
sem_Expression ((Expression_Do (_range) (_statements))) =
    (sem_Expression_Do ((sem_Range (_range))) ((sem_Statements (_statements))))
sem_Expression ((Expression_Enum (_range) (_from) (_then) (_to))) =
    (sem_Expression_Enum ((sem_Range (_range))) ((sem_Expression (_from))) ((sem_MaybeExpression (_then))) ((sem_MaybeExpression (_to))))
sem_Expression ((Expression_If (_range) (_guardExpression) (_thenExpression) (_elseExpression))) =
    (sem_Expression_If ((sem_Range (_range))) ((sem_Expression (_guardExpression))) ((sem_Expression (_thenExpression))) ((sem_Expression (_elseExpression))))
sem_Expression ((Expression_InfixApplication (_range) (_leftExpression) (_operator) (_rightExpression))) =
    (sem_Expression_InfixApplication ((sem_Range (_range))) ((sem_MaybeExpression (_leftExpression))) ((sem_Expression (_operator))) ((sem_MaybeExpression (_rightExpression))))
sem_Expression ((Expression_Irrefutable (_range) (_expression))) =
    (sem_Expression_Irrefutable ((sem_Range (_range))) ((sem_Expression (_expression))))
sem_Expression ((Expression_Lambda (_range) (_patterns) (_expression))) =
    (sem_Expression_Lambda ((sem_Range (_range))) ((sem_Patterns (_patterns))) ((sem_Expression (_expression))))
sem_Expression ((Expression_Let (_range) (_declarations) (_expression))) =
    (sem_Expression_Let ((sem_Range (_range))) ((sem_Declarations (_declarations))) ((sem_Expression (_expression))))
sem_Expression ((Expression_List (_range) (_expressions))) =
    (sem_Expression_List ((sem_Range (_range))) ((sem_Expressions (_expressions))))
sem_Expression ((Expression_Literal (_range) (_literal))) =
    (sem_Expression_Literal ((sem_Range (_range))) ((sem_Literal (_literal))))
sem_Expression ((Expression_Negate (_range) (_expression))) =
    (sem_Expression_Negate ((sem_Range (_range))) ((sem_Expression (_expression))))
sem_Expression ((Expression_NormalApplication (_range) (_function) (_arguments))) =
    (sem_Expression_NormalApplication ((sem_Range (_range))) ((sem_Expression (_function))) ((sem_Expressions (_arguments))))
sem_Expression ((Expression_Parenthesized (_range) (_expression))) =
    (sem_Expression_Parenthesized ((sem_Range (_range))) ((sem_Expression (_expression))))
sem_Expression ((Expression_RecordConstruction (_range) (_name) (_recordExpressionBindings))) =
    (sem_Expression_RecordConstruction ((sem_Range (_range))) ((sem_Name (_name))) ((sem_RecordExpressionBindings (_recordExpressionBindings))))
sem_Expression ((Expression_RecordUpdate (_range) (_expression) (_recordExpressionBindings))) =
    (sem_Expression_RecordUpdate ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_RecordExpressionBindings (_recordExpressionBindings))))
sem_Expression ((Expression_Tuple (_range) (_expressions))) =
    (sem_Expression_Tuple ((sem_Range (_range))) ((sem_Expressions (_expressions))))
sem_Expression ((Expression_TypeApplication (_range) (_name) (_type))) =
    (sem_Expression_TypeApplication ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Type (_type))))
sem_Expression ((Expression_Typed (_range) (_expression) (_type))) =
    (sem_Expression_Typed ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_Type (_type))))
sem_Expression ((Expression_Variable (_range) (_name))) =
    (sem_Expression_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Expression ((Expression_Wildcard (_range))) =
    (sem_Expression_Wildcard ((sem_Range (_range))))
sem_Expression_As :: (T_Range) ->
                     (T_Name) ->
                     (T_Expression) ->
                     (T_Expression)
sem_Expression_As (range_) (name_) (expression_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIknownKinds_collect :: (FMap Name [Name])
            _expressionIknownTypes_collect :: (FMap Name [Name])
            _expressionIknownValues_collect :: (FMap Name [Name])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionImoduleTypes :: (FMap ModuleName [Name])
            _expressionImoduleValues :: (FMap ModuleName [Name])
            _expressionImodules :: (Set.Set Strings)
            _expressionIres :: ([ResolveResult])
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOknownGenerics :: (FMap Name [Name])
            _expressionOknownKinds :: (FMap Name [Name])
            _expressionOknownKinds_collect :: (FMap Name [Name])
            _expressionOknownTypes :: (FMap Name [Name])
            _expressionOknownTypes_collect :: (FMap Name [Name])
            _expressionOknownValues :: (FMap Name [Name])
            _expressionOknownValues_collect :: (FMap Name [Name])
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmoduleTypes :: (FMap ModuleName [Name])
            _expressionOmoduleValues :: (FMap ModuleName [Name])
            _expressionOnameType :: (NameType)
            _expressionOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _expressionIconstructors_collect,_expressionIknownKinds_collect,_expressionIknownTypes_collect,_expressionIknownValues_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionImoduleTypes,_expressionImoduleValues,_expressionImodules,_expressionIres,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOknownGenerics)
                             (_expressionOknownKinds)
                             (_expressionOknownKinds_collect)
                             (_expressionOknownTypes)
                             (_expressionOknownTypes_collect)
                             (_expressionOknownValues)
                             (_expressionOknownValues_collect)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmoduleTypes)
                             (_expressionOmoduleValues)
                             (_expressionOnameType)
                             (_expressionOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _expressionImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _expressionIres
            -- self rule
            (_self@_) =
                Expression_As _rangeIself _nameIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _expressionIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _expressionIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _expressionIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _expressionImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _expressionImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_expressionOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_expressionOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_expressionOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_expressionOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_expressionOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (down)
            (_expressionOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_expressionOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_expressionOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_expressionOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_expressionOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_expressionOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_expressionOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Expression_Case :: (T_Range) ->
                       (T_Expression) ->
                       (T_Alternatives) ->
                       (T_Expression)
sem_Expression_Case (range_) (expression_) (alternatives_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIknownKinds_collect :: (FMap Name [Name])
            _expressionIknownTypes_collect :: (FMap Name [Name])
            _expressionIknownValues_collect :: (FMap Name [Name])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionImoduleTypes :: (FMap ModuleName [Name])
            _expressionImoduleValues :: (FMap ModuleName [Name])
            _expressionImodules :: (Set.Set Strings)
            _expressionIres :: ([ResolveResult])
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOknownGenerics :: (FMap Name [Name])
            _expressionOknownKinds :: (FMap Name [Name])
            _expressionOknownKinds_collect :: (FMap Name [Name])
            _expressionOknownTypes :: (FMap Name [Name])
            _expressionOknownTypes_collect :: (FMap Name [Name])
            _expressionOknownValues :: (FMap Name [Name])
            _expressionOknownValues_collect :: (FMap Name [Name])
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmoduleTypes :: (FMap ModuleName [Name])
            _expressionOmoduleValues :: (FMap ModuleName [Name])
            _expressionOnameType :: (NameType)
            _expressionOtoplevel :: (Bool)
            _alternativesIconstructors_collect :: (FMap Name Names)
            _alternativesIknownKinds_collect :: (FMap Name [Name])
            _alternativesIknownTypes_collect :: (FMap Name [Name])
            _alternativesIknownValues_collect :: (FMap Name [Name])
            _alternativesIlabels_collect :: (FMap Name Names)
            _alternativesImethods_collect :: (FMap Name Names)
            _alternativesImoduleTypes :: (FMap ModuleName [Name])
            _alternativesImoduleValues :: (FMap ModuleName [Name])
            _alternativesImodules :: (Set.Set Strings)
            _alternativesIres :: ([ResolveResult])
            _alternativesIself :: (Alternatives)
            _alternativesOclassname :: (Maybe Name)
            _alternativesOconstructors_collect :: (FMap Name Names)
            _alternativesOconstructors_dist :: (FMap Name Names)
            _alternativesOcurrentModule :: (Strings)
            _alternativesOimportedModule :: (Bool)
            _alternativesOinstancename :: (Maybe Name)
            _alternativesOknownGenerics :: (FMap Name [Name])
            _alternativesOknownKinds :: (FMap Name [Name])
            _alternativesOknownKinds_collect :: (FMap Name [Name])
            _alternativesOknownTypes :: (FMap Name [Name])
            _alternativesOknownTypes_collect :: (FMap Name [Name])
            _alternativesOknownValues :: (FMap Name [Name])
            _alternativesOknownValues_collect :: (FMap Name [Name])
            _alternativesOlabels_collect :: (FMap Name Names)
            _alternativesOlabels_dist :: (FMap Name Names)
            _alternativesOlocal :: (Bool)
            _alternativesOmethods_collect :: (FMap Name Names)
            _alternativesOmethods_dist :: (FMap Name Names)
            _alternativesOmoduleTypes :: (FMap ModuleName [Name])
            _alternativesOmoduleValues :: (FMap ModuleName [Name])
            _alternativesOnameType :: (NameType)
            _alternativesOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionIconstructors_collect,_expressionIknownKinds_collect,_expressionIknownTypes_collect,_expressionIknownValues_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionImoduleTypes,_expressionImoduleValues,_expressionImodules,_expressionIres,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOknownGenerics)
                             (_expressionOknownKinds)
                             (_expressionOknownKinds_collect)
                             (_expressionOknownTypes)
                             (_expressionOknownTypes_collect)
                             (_expressionOknownValues)
                             (_expressionOknownValues_collect)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmoduleTypes)
                             (_expressionOmoduleValues)
                             (_expressionOnameType)
                             (_expressionOtoplevel))
            ( _alternativesIconstructors_collect,_alternativesIknownKinds_collect,_alternativesIknownTypes_collect,_alternativesIknownValues_collect,_alternativesIlabels_collect,_alternativesImethods_collect,_alternativesImoduleTypes,_alternativesImoduleValues,_alternativesImodules,_alternativesIres,_alternativesIself) =
                (alternatives_ (_alternativesOclassname)
                               (_alternativesOconstructors_collect)
                               (_alternativesOconstructors_dist)
                               (_alternativesOcurrentModule)
                               (_alternativesOimportedModule)
                               (_alternativesOinstancename)
                               (_alternativesOknownGenerics)
                               (_alternativesOknownKinds)
                               (_alternativesOknownKinds_collect)
                               (_alternativesOknownTypes)
                               (_alternativesOknownTypes_collect)
                               (_alternativesOknownValues)
                               (_alternativesOknownValues_collect)
                               (_alternativesOlabels_collect)
                               (_alternativesOlabels_dist)
                               (_alternativesOlocal)
                               (_alternativesOmethods_collect)
                               (_alternativesOmethods_dist)
                               (_alternativesOmoduleTypes)
                               (_alternativesOmoduleValues)
                               (_alternativesOnameType)
                               (_alternativesOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _expressionImodules `Set.union` _alternativesImodules
            -- use rule
            (_lhsOres@_) =
                _expressionIres ++ _alternativesIres
            -- self rule
            (_self@_) =
                Expression_Case _rangeIself _expressionIself _alternativesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _alternativesIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _alternativesIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _alternativesIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _alternativesIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _alternativesIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _alternativesImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _alternativesImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _alternativesImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_expressionOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_expressionOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_expressionOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_expressionOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_expressionOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_expressionOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_expressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_expressionOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_expressionOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_alternativesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_alternativesOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (down)
            (_alternativesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_alternativesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_alternativesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_alternativesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_alternativesOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_alternativesOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_alternativesOknownKinds_collect@_) =
                _expressionIknownKinds_collect
            -- copy rule (down)
            (_alternativesOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_alternativesOknownTypes_collect@_) =
                _expressionIknownTypes_collect
            -- copy rule (down)
            (_alternativesOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_alternativesOknownValues_collect@_) =
                _expressionIknownValues_collect
            -- copy rule (chain)
            (_alternativesOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (down)
            (_alternativesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_alternativesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_alternativesOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (down)
            (_alternativesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_alternativesOmoduleTypes@_) =
                _expressionImoduleTypes
            -- copy rule (chain)
            (_alternativesOmoduleValues@_) =
                _expressionImoduleValues
            -- copy rule (down)
            (_alternativesOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_alternativesOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Expression_Comprehension :: (T_Range) ->
                                (T_Expression) ->
                                (T_Qualifiers) ->
                                (T_Expression)
sem_Expression_Comprehension (range_) (expression_) (qualifiers_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIknownKinds_collect :: (FMap Name [Name])
            _expressionIknownTypes_collect :: (FMap Name [Name])
            _expressionIknownValues_collect :: (FMap Name [Name])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionImoduleTypes :: (FMap ModuleName [Name])
            _expressionImoduleValues :: (FMap ModuleName [Name])
            _expressionImodules :: (Set.Set Strings)
            _expressionIres :: ([ResolveResult])
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOknownGenerics :: (FMap Name [Name])
            _expressionOknownKinds :: (FMap Name [Name])
            _expressionOknownKinds_collect :: (FMap Name [Name])
            _expressionOknownTypes :: (FMap Name [Name])
            _expressionOknownTypes_collect :: (FMap Name [Name])
            _expressionOknownValues :: (FMap Name [Name])
            _expressionOknownValues_collect :: (FMap Name [Name])
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmoduleTypes :: (FMap ModuleName [Name])
            _expressionOmoduleValues :: (FMap ModuleName [Name])
            _expressionOnameType :: (NameType)
            _expressionOtoplevel :: (Bool)
            _qualifiersIconstructors_collect :: (FMap Name Names)
            _qualifiersIknownKinds_collect :: (FMap Name [Name])
            _qualifiersIknownTypes_collect :: (FMap Name [Name])
            _qualifiersIknownValues_collect :: (FMap Name [Name])
            _qualifiersIlabels_collect :: (FMap Name Names)
            _qualifiersImethods_collect :: (FMap Name Names)
            _qualifiersImoduleTypes :: (FMap ModuleName [Name])
            _qualifiersImoduleValues :: (FMap ModuleName [Name])
            _qualifiersImodules :: (Set.Set Strings)
            _qualifiersIres :: ([ResolveResult])
            _qualifiersIself :: (Qualifiers)
            _qualifiersOclassname :: (Maybe Name)
            _qualifiersOconstructors_collect :: (FMap Name Names)
            _qualifiersOconstructors_dist :: (FMap Name Names)
            _qualifiersOcurrentModule :: (Strings)
            _qualifiersOimportedModule :: (Bool)
            _qualifiersOinstancename :: (Maybe Name)
            _qualifiersOknownGenerics :: (FMap Name [Name])
            _qualifiersOknownKinds :: (FMap Name [Name])
            _qualifiersOknownKinds_collect :: (FMap Name [Name])
            _qualifiersOknownTypes :: (FMap Name [Name])
            _qualifiersOknownTypes_collect :: (FMap Name [Name])
            _qualifiersOknownValues :: (FMap Name [Name])
            _qualifiersOknownValues_collect :: (FMap Name [Name])
            _qualifiersOlabels_collect :: (FMap Name Names)
            _qualifiersOlabels_dist :: (FMap Name Names)
            _qualifiersOlocal :: (Bool)
            _qualifiersOmethods_collect :: (FMap Name Names)
            _qualifiersOmethods_dist :: (FMap Name Names)
            _qualifiersOmoduleTypes :: (FMap ModuleName [Name])
            _qualifiersOmoduleValues :: (FMap ModuleName [Name])
            _qualifiersOnameType :: (NameType)
            _qualifiersOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionIconstructors_collect,_expressionIknownKinds_collect,_expressionIknownTypes_collect,_expressionIknownValues_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionImoduleTypes,_expressionImoduleValues,_expressionImodules,_expressionIres,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOknownGenerics)
                             (_expressionOknownKinds)
                             (_expressionOknownKinds_collect)
                             (_expressionOknownTypes)
                             (_expressionOknownTypes_collect)
                             (_expressionOknownValues)
                             (_expressionOknownValues_collect)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmoduleTypes)
                             (_expressionOmoduleValues)
                             (_expressionOnameType)
                             (_expressionOtoplevel))
            ( _qualifiersIconstructors_collect,_qualifiersIknownKinds_collect,_qualifiersIknownTypes_collect,_qualifiersIknownValues_collect,_qualifiersIlabels_collect,_qualifiersImethods_collect,_qualifiersImoduleTypes,_qualifiersImoduleValues,_qualifiersImodules,_qualifiersIres,_qualifiersIself) =
                (qualifiers_ (_qualifiersOclassname)
                             (_qualifiersOconstructors_collect)
                             (_qualifiersOconstructors_dist)
                             (_qualifiersOcurrentModule)
                             (_qualifiersOimportedModule)
                             (_qualifiersOinstancename)
                             (_qualifiersOknownGenerics)
                             (_qualifiersOknownKinds)
                             (_qualifiersOknownKinds_collect)
                             (_qualifiersOknownTypes)
                             (_qualifiersOknownTypes_collect)
                             (_qualifiersOknownValues)
                             (_qualifiersOknownValues_collect)
                             (_qualifiersOlabels_collect)
                             (_qualifiersOlabels_dist)
                             (_qualifiersOlocal)
                             (_qualifiersOmethods_collect)
                             (_qualifiersOmethods_dist)
                             (_qualifiersOmoduleTypes)
                             (_qualifiersOmoduleValues)
                             (_qualifiersOnameType)
                             (_qualifiersOtoplevel))
            -- "./Names.inc.lag"(line 595, column 9)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- "./Names.inc.lag"(line 594, column 9)
            (_expressionOknownValues@_) =
                _qualifiersIknownValues_collect
            -- "./Names.inc.lag"(line 593, column 9)
            (_qualifiersOknownValues@_) =
                _lhsIknownValues
            -- "./Names.inc.lag"(line 592, column 9)
            (_qualifiersOknownValues_collect@_) =
                _lhsIknownValues
            -- use rule
            (_lhsOmodules@_) =
                _expressionImodules `Set.union` _qualifiersImodules
            -- use rule
            (_lhsOres@_) =
                _expressionIres ++ _qualifiersIres
            -- self rule
            (_self@_) =
                Expression_Comprehension _rangeIself _expressionIself _qualifiersIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _qualifiersIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _qualifiersIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _qualifiersIknownTypes_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _qualifiersIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _qualifiersImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _qualifiersImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _qualifiersImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_expressionOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_expressionOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_expressionOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_expressionOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_expressionOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_expressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_expressionOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_expressionOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_qualifiersOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_qualifiersOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (down)
            (_qualifiersOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_qualifiersOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_qualifiersOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_qualifiersOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_qualifiersOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_qualifiersOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_qualifiersOknownKinds_collect@_) =
                _expressionIknownKinds_collect
            -- copy rule (down)
            (_qualifiersOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_qualifiersOknownTypes_collect@_) =
                _expressionIknownTypes_collect
            -- copy rule (chain)
            (_qualifiersOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (down)
            (_qualifiersOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_qualifiersOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_qualifiersOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (down)
            (_qualifiersOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_qualifiersOmoduleTypes@_) =
                _expressionImoduleTypes
            -- copy rule (chain)
            (_qualifiersOmoduleValues@_) =
                _expressionImoduleValues
            -- copy rule (down)
            (_qualifiersOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_qualifiersOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Expression_Constructor :: (T_Range) ->
                              (T_Name) ->
                              (T_Expression)
sem_Expression_Constructor (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            -- "./NameTypes.inc.lag"(line 144, column 9)
            (_nameOnameType@_) =
                ref_Val
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres
            -- self rule
            (_self@_) =
                Expression_Constructor _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Expression_Do :: (T_Range) ->
                     (T_Statements) ->
                     (T_Expression)
sem_Expression_Do (range_) (statements_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _statementsIconstructors_collect :: (FMap Name Names)
            _statementsIknownKinds_collect :: (FMap Name [Name])
            _statementsIknownTypes_collect :: (FMap Name [Name])
            _statementsIknownValues_collect :: (FMap Name [Name])
            _statementsIlabels_collect :: (FMap Name Names)
            _statementsImethods_collect :: (FMap Name Names)
            _statementsImoduleTypes :: (FMap ModuleName [Name])
            _statementsImoduleValues :: (FMap ModuleName [Name])
            _statementsImodules :: (Set.Set Strings)
            _statementsIres :: ([ResolveResult])
            _statementsIself :: (Statements)
            _statementsOclassname :: (Maybe Name)
            _statementsOconstructors_collect :: (FMap Name Names)
            _statementsOconstructors_dist :: (FMap Name Names)
            _statementsOcurrentModule :: (Strings)
            _statementsOimportedModule :: (Bool)
            _statementsOinstancename :: (Maybe Name)
            _statementsOknownGenerics :: (FMap Name [Name])
            _statementsOknownKinds :: (FMap Name [Name])
            _statementsOknownKinds_collect :: (FMap Name [Name])
            _statementsOknownTypes :: (FMap Name [Name])
            _statementsOknownTypes_collect :: (FMap Name [Name])
            _statementsOknownValues :: (FMap Name [Name])
            _statementsOknownValues_collect :: (FMap Name [Name])
            _statementsOlabels_collect :: (FMap Name Names)
            _statementsOlabels_dist :: (FMap Name Names)
            _statementsOlocal :: (Bool)
            _statementsOmethods_collect :: (FMap Name Names)
            _statementsOmethods_dist :: (FMap Name Names)
            _statementsOmoduleTypes :: (FMap ModuleName [Name])
            _statementsOmoduleValues :: (FMap ModuleName [Name])
            _statementsOnameType :: (NameType)
            _statementsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _statementsIconstructors_collect,_statementsIknownKinds_collect,_statementsIknownTypes_collect,_statementsIknownValues_collect,_statementsIlabels_collect,_statementsImethods_collect,_statementsImoduleTypes,_statementsImoduleValues,_statementsImodules,_statementsIres,_statementsIself) =
                (statements_ (_statementsOclassname)
                             (_statementsOconstructors_collect)
                             (_statementsOconstructors_dist)
                             (_statementsOcurrentModule)
                             (_statementsOimportedModule)
                             (_statementsOinstancename)
                             (_statementsOknownGenerics)
                             (_statementsOknownKinds)
                             (_statementsOknownKinds_collect)
                             (_statementsOknownTypes)
                             (_statementsOknownTypes_collect)
                             (_statementsOknownValues)
                             (_statementsOknownValues_collect)
                             (_statementsOlabels_collect)
                             (_statementsOlabels_dist)
                             (_statementsOlocal)
                             (_statementsOmethods_collect)
                             (_statementsOmethods_dist)
                             (_statementsOmoduleTypes)
                             (_statementsOmoduleValues)
                             (_statementsOnameType)
                             (_statementsOtoplevel))
            -- "./Names.inc.lag"(line 589, column 9)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- use rule
            (_lhsOmodules@_) =
                _statementsImodules
            -- use rule
            (_lhsOres@_) =
                _statementsIres
            -- self rule
            (_self@_) =
                Expression_Do _rangeIself _statementsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _statementsIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _statementsIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _statementsIknownTypes_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _statementsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _statementsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _statementsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _statementsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_statementsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_statementsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_statementsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_statementsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_statementsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_statementsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_statementsOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_statementsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_statementsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_statementsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_statementsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_statementsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_statementsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_statementsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_statementsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_statementsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_statementsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_statementsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_statementsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_statementsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_statementsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_statementsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Expression_Enum :: (T_Range) ->
                       (T_Expression) ->
                       (T_MaybeExpression) ->
                       (T_MaybeExpression) ->
                       (T_Expression)
sem_Expression_Enum (range_) (from_) (then_) (to_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _fromIconstructors_collect :: (FMap Name Names)
            _fromIknownKinds_collect :: (FMap Name [Name])
            _fromIknownTypes_collect :: (FMap Name [Name])
            _fromIknownValues_collect :: (FMap Name [Name])
            _fromIlabels_collect :: (FMap Name Names)
            _fromImethods_collect :: (FMap Name Names)
            _fromImoduleTypes :: (FMap ModuleName [Name])
            _fromImoduleValues :: (FMap ModuleName [Name])
            _fromImodules :: (Set.Set Strings)
            _fromIres :: ([ResolveResult])
            _fromIself :: (Expression)
            _fromOclassname :: (Maybe Name)
            _fromOconstructors_collect :: (FMap Name Names)
            _fromOconstructors_dist :: (FMap Name Names)
            _fromOcurrentModule :: (Strings)
            _fromOimportedModule :: (Bool)
            _fromOinstancename :: (Maybe Name)
            _fromOknownGenerics :: (FMap Name [Name])
            _fromOknownKinds :: (FMap Name [Name])
            _fromOknownKinds_collect :: (FMap Name [Name])
            _fromOknownTypes :: (FMap Name [Name])
            _fromOknownTypes_collect :: (FMap Name [Name])
            _fromOknownValues :: (FMap Name [Name])
            _fromOknownValues_collect :: (FMap Name [Name])
            _fromOlabels_collect :: (FMap Name Names)
            _fromOlabels_dist :: (FMap Name Names)
            _fromOlocal :: (Bool)
            _fromOmethods_collect :: (FMap Name Names)
            _fromOmethods_dist :: (FMap Name Names)
            _fromOmoduleTypes :: (FMap ModuleName [Name])
            _fromOmoduleValues :: (FMap ModuleName [Name])
            _fromOnameType :: (NameType)
            _fromOtoplevel :: (Bool)
            _thenIconstructors_collect :: (FMap Name Names)
            _thenIknownKinds_collect :: (FMap Name [Name])
            _thenIknownTypes_collect :: (FMap Name [Name])
            _thenIknownValues_collect :: (FMap Name [Name])
            _thenIlabels_collect :: (FMap Name Names)
            _thenImethods_collect :: (FMap Name Names)
            _thenImoduleTypes :: (FMap ModuleName [Name])
            _thenImoduleValues :: (FMap ModuleName [Name])
            _thenImodules :: (Set.Set Strings)
            _thenIres :: ([ResolveResult])
            _thenIself :: (MaybeExpression)
            _thenOclassname :: (Maybe Name)
            _thenOconstructors_collect :: (FMap Name Names)
            _thenOconstructors_dist :: (FMap Name Names)
            _thenOcurrentModule :: (Strings)
            _thenOimportedModule :: (Bool)
            _thenOinstancename :: (Maybe Name)
            _thenOknownGenerics :: (FMap Name [Name])
            _thenOknownKinds :: (FMap Name [Name])
            _thenOknownKinds_collect :: (FMap Name [Name])
            _thenOknownTypes :: (FMap Name [Name])
            _thenOknownTypes_collect :: (FMap Name [Name])
            _thenOknownValues :: (FMap Name [Name])
            _thenOknownValues_collect :: (FMap Name [Name])
            _thenOlabels_collect :: (FMap Name Names)
            _thenOlabels_dist :: (FMap Name Names)
            _thenOlocal :: (Bool)
            _thenOmethods_collect :: (FMap Name Names)
            _thenOmethods_dist :: (FMap Name Names)
            _thenOmoduleTypes :: (FMap ModuleName [Name])
            _thenOmoduleValues :: (FMap ModuleName [Name])
            _thenOnameType :: (NameType)
            _thenOtoplevel :: (Bool)
            _toIconstructors_collect :: (FMap Name Names)
            _toIknownKinds_collect :: (FMap Name [Name])
            _toIknownTypes_collect :: (FMap Name [Name])
            _toIknownValues_collect :: (FMap Name [Name])
            _toIlabels_collect :: (FMap Name Names)
            _toImethods_collect :: (FMap Name Names)
            _toImoduleTypes :: (FMap ModuleName [Name])
            _toImoduleValues :: (FMap ModuleName [Name])
            _toImodules :: (Set.Set Strings)
            _toIres :: ([ResolveResult])
            _toIself :: (MaybeExpression)
            _toOclassname :: (Maybe Name)
            _toOconstructors_collect :: (FMap Name Names)
            _toOconstructors_dist :: (FMap Name Names)
            _toOcurrentModule :: (Strings)
            _toOimportedModule :: (Bool)
            _toOinstancename :: (Maybe Name)
            _toOknownGenerics :: (FMap Name [Name])
            _toOknownKinds :: (FMap Name [Name])
            _toOknownKinds_collect :: (FMap Name [Name])
            _toOknownTypes :: (FMap Name [Name])
            _toOknownTypes_collect :: (FMap Name [Name])
            _toOknownValues :: (FMap Name [Name])
            _toOknownValues_collect :: (FMap Name [Name])
            _toOlabels_collect :: (FMap Name Names)
            _toOlabels_dist :: (FMap Name Names)
            _toOlocal :: (Bool)
            _toOmethods_collect :: (FMap Name Names)
            _toOmethods_dist :: (FMap Name Names)
            _toOmoduleTypes :: (FMap ModuleName [Name])
            _toOmoduleValues :: (FMap ModuleName [Name])
            _toOnameType :: (NameType)
            _toOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _fromIconstructors_collect,_fromIknownKinds_collect,_fromIknownTypes_collect,_fromIknownValues_collect,_fromIlabels_collect,_fromImethods_collect,_fromImoduleTypes,_fromImoduleValues,_fromImodules,_fromIres,_fromIself) =
                (from_ (_fromOclassname)
                       (_fromOconstructors_collect)
                       (_fromOconstructors_dist)
                       (_fromOcurrentModule)
                       (_fromOimportedModule)
                       (_fromOinstancename)
                       (_fromOknownGenerics)
                       (_fromOknownKinds)
                       (_fromOknownKinds_collect)
                       (_fromOknownTypes)
                       (_fromOknownTypes_collect)
                       (_fromOknownValues)
                       (_fromOknownValues_collect)
                       (_fromOlabels_collect)
                       (_fromOlabels_dist)
                       (_fromOlocal)
                       (_fromOmethods_collect)
                       (_fromOmethods_dist)
                       (_fromOmoduleTypes)
                       (_fromOmoduleValues)
                       (_fromOnameType)
                       (_fromOtoplevel))
            ( _thenIconstructors_collect,_thenIknownKinds_collect,_thenIknownTypes_collect,_thenIknownValues_collect,_thenIlabels_collect,_thenImethods_collect,_thenImoduleTypes,_thenImoduleValues,_thenImodules,_thenIres,_thenIself) =
                (then_ (_thenOclassname)
                       (_thenOconstructors_collect)
                       (_thenOconstructors_dist)
                       (_thenOcurrentModule)
                       (_thenOimportedModule)
                       (_thenOinstancename)
                       (_thenOknownGenerics)
                       (_thenOknownKinds)
                       (_thenOknownKinds_collect)
                       (_thenOknownTypes)
                       (_thenOknownTypes_collect)
                       (_thenOknownValues)
                       (_thenOknownValues_collect)
                       (_thenOlabels_collect)
                       (_thenOlabels_dist)
                       (_thenOlocal)
                       (_thenOmethods_collect)
                       (_thenOmethods_dist)
                       (_thenOmoduleTypes)
                       (_thenOmoduleValues)
                       (_thenOnameType)
                       (_thenOtoplevel))
            ( _toIconstructors_collect,_toIknownKinds_collect,_toIknownTypes_collect,_toIknownValues_collect,_toIlabels_collect,_toImethods_collect,_toImoduleTypes,_toImoduleValues,_toImodules,_toIres,_toIself) =
                (to_ (_toOclassname)
                     (_toOconstructors_collect)
                     (_toOconstructors_dist)
                     (_toOcurrentModule)
                     (_toOimportedModule)
                     (_toOinstancename)
                     (_toOknownGenerics)
                     (_toOknownKinds)
                     (_toOknownKinds_collect)
                     (_toOknownTypes)
                     (_toOknownTypes_collect)
                     (_toOknownValues)
                     (_toOknownValues_collect)
                     (_toOlabels_collect)
                     (_toOlabels_dist)
                     (_toOlocal)
                     (_toOmethods_collect)
                     (_toOmethods_dist)
                     (_toOmoduleTypes)
                     (_toOmoduleValues)
                     (_toOnameType)
                     (_toOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _fromImodules `Set.union` _thenImodules `Set.union` _toImodules
            -- use rule
            (_lhsOres@_) =
                _fromIres ++ _thenIres ++ _toIres
            -- self rule
            (_self@_) =
                Expression_Enum _rangeIself _fromIself _thenIself _toIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _toIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _toIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _toIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _toIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _toIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _toImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _toImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _toImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_fromOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_fromOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_fromOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_fromOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_fromOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_fromOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_fromOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_fromOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_fromOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_fromOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_fromOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_fromOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_fromOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_fromOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_fromOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_fromOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_fromOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_fromOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_fromOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_fromOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_fromOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_fromOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_thenOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_thenOconstructors_collect@_) =
                _fromIconstructors_collect
            -- copy rule (down)
            (_thenOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_thenOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_thenOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_thenOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_thenOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_thenOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_thenOknownKinds_collect@_) =
                _fromIknownKinds_collect
            -- copy rule (down)
            (_thenOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_thenOknownTypes_collect@_) =
                _fromIknownTypes_collect
            -- copy rule (down)
            (_thenOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_thenOknownValues_collect@_) =
                _fromIknownValues_collect
            -- copy rule (chain)
            (_thenOlabels_collect@_) =
                _fromIlabels_collect
            -- copy rule (down)
            (_thenOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_thenOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_thenOmethods_collect@_) =
                _fromImethods_collect
            -- copy rule (down)
            (_thenOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_thenOmoduleTypes@_) =
                _fromImoduleTypes
            -- copy rule (chain)
            (_thenOmoduleValues@_) =
                _fromImoduleValues
            -- copy rule (down)
            (_thenOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_thenOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_toOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_toOconstructors_collect@_) =
                _thenIconstructors_collect
            -- copy rule (down)
            (_toOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_toOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_toOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_toOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_toOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_toOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_toOknownKinds_collect@_) =
                _thenIknownKinds_collect
            -- copy rule (down)
            (_toOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_toOknownTypes_collect@_) =
                _thenIknownTypes_collect
            -- copy rule (down)
            (_toOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_toOknownValues_collect@_) =
                _thenIknownValues_collect
            -- copy rule (chain)
            (_toOlabels_collect@_) =
                _thenIlabels_collect
            -- copy rule (down)
            (_toOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_toOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_toOmethods_collect@_) =
                _thenImethods_collect
            -- copy rule (down)
            (_toOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_toOmoduleTypes@_) =
                _thenImoduleTypes
            -- copy rule (chain)
            (_toOmoduleValues@_) =
                _thenImoduleValues
            -- copy rule (down)
            (_toOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_toOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Expression_If :: (T_Range) ->
                     (T_Expression) ->
                     (T_Expression) ->
                     (T_Expression) ->
                     (T_Expression)
sem_Expression_If (range_) (guardExpression_) (thenExpression_) (elseExpression_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _guardExpressionIconstructors_collect :: (FMap Name Names)
            _guardExpressionIknownKinds_collect :: (FMap Name [Name])
            _guardExpressionIknownTypes_collect :: (FMap Name [Name])
            _guardExpressionIknownValues_collect :: (FMap Name [Name])
            _guardExpressionIlabels_collect :: (FMap Name Names)
            _guardExpressionImethods_collect :: (FMap Name Names)
            _guardExpressionImoduleTypes :: (FMap ModuleName [Name])
            _guardExpressionImoduleValues :: (FMap ModuleName [Name])
            _guardExpressionImodules :: (Set.Set Strings)
            _guardExpressionIres :: ([ResolveResult])
            _guardExpressionIself :: (Expression)
            _guardExpressionOclassname :: (Maybe Name)
            _guardExpressionOconstructors_collect :: (FMap Name Names)
            _guardExpressionOconstructors_dist :: (FMap Name Names)
            _guardExpressionOcurrentModule :: (Strings)
            _guardExpressionOimportedModule :: (Bool)
            _guardExpressionOinstancename :: (Maybe Name)
            _guardExpressionOknownGenerics :: (FMap Name [Name])
            _guardExpressionOknownKinds :: (FMap Name [Name])
            _guardExpressionOknownKinds_collect :: (FMap Name [Name])
            _guardExpressionOknownTypes :: (FMap Name [Name])
            _guardExpressionOknownTypes_collect :: (FMap Name [Name])
            _guardExpressionOknownValues :: (FMap Name [Name])
            _guardExpressionOknownValues_collect :: (FMap Name [Name])
            _guardExpressionOlabels_collect :: (FMap Name Names)
            _guardExpressionOlabels_dist :: (FMap Name Names)
            _guardExpressionOlocal :: (Bool)
            _guardExpressionOmethods_collect :: (FMap Name Names)
            _guardExpressionOmethods_dist :: (FMap Name Names)
            _guardExpressionOmoduleTypes :: (FMap ModuleName [Name])
            _guardExpressionOmoduleValues :: (FMap ModuleName [Name])
            _guardExpressionOnameType :: (NameType)
            _guardExpressionOtoplevel :: (Bool)
            _thenExpressionIconstructors_collect :: (FMap Name Names)
            _thenExpressionIknownKinds_collect :: (FMap Name [Name])
            _thenExpressionIknownTypes_collect :: (FMap Name [Name])
            _thenExpressionIknownValues_collect :: (FMap Name [Name])
            _thenExpressionIlabels_collect :: (FMap Name Names)
            _thenExpressionImethods_collect :: (FMap Name Names)
            _thenExpressionImoduleTypes :: (FMap ModuleName [Name])
            _thenExpressionImoduleValues :: (FMap ModuleName [Name])
            _thenExpressionImodules :: (Set.Set Strings)
            _thenExpressionIres :: ([ResolveResult])
            _thenExpressionIself :: (Expression)
            _thenExpressionOclassname :: (Maybe Name)
            _thenExpressionOconstructors_collect :: (FMap Name Names)
            _thenExpressionOconstructors_dist :: (FMap Name Names)
            _thenExpressionOcurrentModule :: (Strings)
            _thenExpressionOimportedModule :: (Bool)
            _thenExpressionOinstancename :: (Maybe Name)
            _thenExpressionOknownGenerics :: (FMap Name [Name])
            _thenExpressionOknownKinds :: (FMap Name [Name])
            _thenExpressionOknownKinds_collect :: (FMap Name [Name])
            _thenExpressionOknownTypes :: (FMap Name [Name])
            _thenExpressionOknownTypes_collect :: (FMap Name [Name])
            _thenExpressionOknownValues :: (FMap Name [Name])
            _thenExpressionOknownValues_collect :: (FMap Name [Name])
            _thenExpressionOlabels_collect :: (FMap Name Names)
            _thenExpressionOlabels_dist :: (FMap Name Names)
            _thenExpressionOlocal :: (Bool)
            _thenExpressionOmethods_collect :: (FMap Name Names)
            _thenExpressionOmethods_dist :: (FMap Name Names)
            _thenExpressionOmoduleTypes :: (FMap ModuleName [Name])
            _thenExpressionOmoduleValues :: (FMap ModuleName [Name])
            _thenExpressionOnameType :: (NameType)
            _thenExpressionOtoplevel :: (Bool)
            _elseExpressionIconstructors_collect :: (FMap Name Names)
            _elseExpressionIknownKinds_collect :: (FMap Name [Name])
            _elseExpressionIknownTypes_collect :: (FMap Name [Name])
            _elseExpressionIknownValues_collect :: (FMap Name [Name])
            _elseExpressionIlabels_collect :: (FMap Name Names)
            _elseExpressionImethods_collect :: (FMap Name Names)
            _elseExpressionImoduleTypes :: (FMap ModuleName [Name])
            _elseExpressionImoduleValues :: (FMap ModuleName [Name])
            _elseExpressionImodules :: (Set.Set Strings)
            _elseExpressionIres :: ([ResolveResult])
            _elseExpressionIself :: (Expression)
            _elseExpressionOclassname :: (Maybe Name)
            _elseExpressionOconstructors_collect :: (FMap Name Names)
            _elseExpressionOconstructors_dist :: (FMap Name Names)
            _elseExpressionOcurrentModule :: (Strings)
            _elseExpressionOimportedModule :: (Bool)
            _elseExpressionOinstancename :: (Maybe Name)
            _elseExpressionOknownGenerics :: (FMap Name [Name])
            _elseExpressionOknownKinds :: (FMap Name [Name])
            _elseExpressionOknownKinds_collect :: (FMap Name [Name])
            _elseExpressionOknownTypes :: (FMap Name [Name])
            _elseExpressionOknownTypes_collect :: (FMap Name [Name])
            _elseExpressionOknownValues :: (FMap Name [Name])
            _elseExpressionOknownValues_collect :: (FMap Name [Name])
            _elseExpressionOlabels_collect :: (FMap Name Names)
            _elseExpressionOlabels_dist :: (FMap Name Names)
            _elseExpressionOlocal :: (Bool)
            _elseExpressionOmethods_collect :: (FMap Name Names)
            _elseExpressionOmethods_dist :: (FMap Name Names)
            _elseExpressionOmoduleTypes :: (FMap ModuleName [Name])
            _elseExpressionOmoduleValues :: (FMap ModuleName [Name])
            _elseExpressionOnameType :: (NameType)
            _elseExpressionOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _guardExpressionIconstructors_collect,_guardExpressionIknownKinds_collect,_guardExpressionIknownTypes_collect,_guardExpressionIknownValues_collect,_guardExpressionIlabels_collect,_guardExpressionImethods_collect,_guardExpressionImoduleTypes,_guardExpressionImoduleValues,_guardExpressionImodules,_guardExpressionIres,_guardExpressionIself) =
                (guardExpression_ (_guardExpressionOclassname)
                                  (_guardExpressionOconstructors_collect)
                                  (_guardExpressionOconstructors_dist)
                                  (_guardExpressionOcurrentModule)
                                  (_guardExpressionOimportedModule)
                                  (_guardExpressionOinstancename)
                                  (_guardExpressionOknownGenerics)
                                  (_guardExpressionOknownKinds)
                                  (_guardExpressionOknownKinds_collect)
                                  (_guardExpressionOknownTypes)
                                  (_guardExpressionOknownTypes_collect)
                                  (_guardExpressionOknownValues)
                                  (_guardExpressionOknownValues_collect)
                                  (_guardExpressionOlabels_collect)
                                  (_guardExpressionOlabels_dist)
                                  (_guardExpressionOlocal)
                                  (_guardExpressionOmethods_collect)
                                  (_guardExpressionOmethods_dist)
                                  (_guardExpressionOmoduleTypes)
                                  (_guardExpressionOmoduleValues)
                                  (_guardExpressionOnameType)
                                  (_guardExpressionOtoplevel))
            ( _thenExpressionIconstructors_collect,_thenExpressionIknownKinds_collect,_thenExpressionIknownTypes_collect,_thenExpressionIknownValues_collect,_thenExpressionIlabels_collect,_thenExpressionImethods_collect,_thenExpressionImoduleTypes,_thenExpressionImoduleValues,_thenExpressionImodules,_thenExpressionIres,_thenExpressionIself) =
                (thenExpression_ (_thenExpressionOclassname)
                                 (_thenExpressionOconstructors_collect)
                                 (_thenExpressionOconstructors_dist)
                                 (_thenExpressionOcurrentModule)
                                 (_thenExpressionOimportedModule)
                                 (_thenExpressionOinstancename)
                                 (_thenExpressionOknownGenerics)
                                 (_thenExpressionOknownKinds)
                                 (_thenExpressionOknownKinds_collect)
                                 (_thenExpressionOknownTypes)
                                 (_thenExpressionOknownTypes_collect)
                                 (_thenExpressionOknownValues)
                                 (_thenExpressionOknownValues_collect)
                                 (_thenExpressionOlabels_collect)
                                 (_thenExpressionOlabels_dist)
                                 (_thenExpressionOlocal)
                                 (_thenExpressionOmethods_collect)
                                 (_thenExpressionOmethods_dist)
                                 (_thenExpressionOmoduleTypes)
                                 (_thenExpressionOmoduleValues)
                                 (_thenExpressionOnameType)
                                 (_thenExpressionOtoplevel))
            ( _elseExpressionIconstructors_collect,_elseExpressionIknownKinds_collect,_elseExpressionIknownTypes_collect,_elseExpressionIknownValues_collect,_elseExpressionIlabels_collect,_elseExpressionImethods_collect,_elseExpressionImoduleTypes,_elseExpressionImoduleValues,_elseExpressionImodules,_elseExpressionIres,_elseExpressionIself) =
                (elseExpression_ (_elseExpressionOclassname)
                                 (_elseExpressionOconstructors_collect)
                                 (_elseExpressionOconstructors_dist)
                                 (_elseExpressionOcurrentModule)
                                 (_elseExpressionOimportedModule)
                                 (_elseExpressionOinstancename)
                                 (_elseExpressionOknownGenerics)
                                 (_elseExpressionOknownKinds)
                                 (_elseExpressionOknownKinds_collect)
                                 (_elseExpressionOknownTypes)
                                 (_elseExpressionOknownTypes_collect)
                                 (_elseExpressionOknownValues)
                                 (_elseExpressionOknownValues_collect)
                                 (_elseExpressionOlabels_collect)
                                 (_elseExpressionOlabels_dist)
                                 (_elseExpressionOlocal)
                                 (_elseExpressionOmethods_collect)
                                 (_elseExpressionOmethods_dist)
                                 (_elseExpressionOmoduleTypes)
                                 (_elseExpressionOmoduleValues)
                                 (_elseExpressionOnameType)
                                 (_elseExpressionOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _guardExpressionImodules `Set.union` _thenExpressionImodules `Set.union` _elseExpressionImodules
            -- use rule
            (_lhsOres@_) =
                _guardExpressionIres ++ _thenExpressionIres ++ _elseExpressionIres
            -- self rule
            (_self@_) =
                Expression_If _rangeIself _guardExpressionIself _thenExpressionIself _elseExpressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _elseExpressionIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _elseExpressionIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _elseExpressionIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _elseExpressionIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _elseExpressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _elseExpressionImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _elseExpressionImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _elseExpressionImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_guardExpressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_guardExpressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_guardExpressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_guardExpressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_guardExpressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_guardExpressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_guardExpressionOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_guardExpressionOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_guardExpressionOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_guardExpressionOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_guardExpressionOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_guardExpressionOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_guardExpressionOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_guardExpressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_guardExpressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_guardExpressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_guardExpressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_guardExpressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_guardExpressionOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_guardExpressionOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_guardExpressionOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_guardExpressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_thenExpressionOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_thenExpressionOconstructors_collect@_) =
                _guardExpressionIconstructors_collect
            -- copy rule (down)
            (_thenExpressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_thenExpressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_thenExpressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_thenExpressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_thenExpressionOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_thenExpressionOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_thenExpressionOknownKinds_collect@_) =
                _guardExpressionIknownKinds_collect
            -- copy rule (down)
            (_thenExpressionOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_thenExpressionOknownTypes_collect@_) =
                _guardExpressionIknownTypes_collect
            -- copy rule (down)
            (_thenExpressionOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_thenExpressionOknownValues_collect@_) =
                _guardExpressionIknownValues_collect
            -- copy rule (chain)
            (_thenExpressionOlabels_collect@_) =
                _guardExpressionIlabels_collect
            -- copy rule (down)
            (_thenExpressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_thenExpressionOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_thenExpressionOmethods_collect@_) =
                _guardExpressionImethods_collect
            -- copy rule (down)
            (_thenExpressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_thenExpressionOmoduleTypes@_) =
                _guardExpressionImoduleTypes
            -- copy rule (chain)
            (_thenExpressionOmoduleValues@_) =
                _guardExpressionImoduleValues
            -- copy rule (down)
            (_thenExpressionOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_thenExpressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_elseExpressionOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_elseExpressionOconstructors_collect@_) =
                _thenExpressionIconstructors_collect
            -- copy rule (down)
            (_elseExpressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_elseExpressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_elseExpressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_elseExpressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_elseExpressionOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_elseExpressionOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_elseExpressionOknownKinds_collect@_) =
                _thenExpressionIknownKinds_collect
            -- copy rule (down)
            (_elseExpressionOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_elseExpressionOknownTypes_collect@_) =
                _thenExpressionIknownTypes_collect
            -- copy rule (down)
            (_elseExpressionOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_elseExpressionOknownValues_collect@_) =
                _thenExpressionIknownValues_collect
            -- copy rule (chain)
            (_elseExpressionOlabels_collect@_) =
                _thenExpressionIlabels_collect
            -- copy rule (down)
            (_elseExpressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_elseExpressionOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_elseExpressionOmethods_collect@_) =
                _thenExpressionImethods_collect
            -- copy rule (down)
            (_elseExpressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_elseExpressionOmoduleTypes@_) =
                _thenExpressionImoduleTypes
            -- copy rule (chain)
            (_elseExpressionOmoduleValues@_) =
                _thenExpressionImoduleValues
            -- copy rule (down)
            (_elseExpressionOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_elseExpressionOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Expression_InfixApplication :: (T_Range) ->
                                   (T_MaybeExpression) ->
                                   (T_Expression) ->
                                   (T_MaybeExpression) ->
                                   (T_Expression)
sem_Expression_InfixApplication (range_) (leftExpression_) (operator_) (rightExpression_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _leftExpressionIconstructors_collect :: (FMap Name Names)
            _leftExpressionIknownKinds_collect :: (FMap Name [Name])
            _leftExpressionIknownTypes_collect :: (FMap Name [Name])
            _leftExpressionIknownValues_collect :: (FMap Name [Name])
            _leftExpressionIlabels_collect :: (FMap Name Names)
            _leftExpressionImethods_collect :: (FMap Name Names)
            _leftExpressionImoduleTypes :: (FMap ModuleName [Name])
            _leftExpressionImoduleValues :: (FMap ModuleName [Name])
            _leftExpressionImodules :: (Set.Set Strings)
            _leftExpressionIres :: ([ResolveResult])
            _leftExpressionIself :: (MaybeExpression)
            _leftExpressionOclassname :: (Maybe Name)
            _leftExpressionOconstructors_collect :: (FMap Name Names)
            _leftExpressionOconstructors_dist :: (FMap Name Names)
            _leftExpressionOcurrentModule :: (Strings)
            _leftExpressionOimportedModule :: (Bool)
            _leftExpressionOinstancename :: (Maybe Name)
            _leftExpressionOknownGenerics :: (FMap Name [Name])
            _leftExpressionOknownKinds :: (FMap Name [Name])
            _leftExpressionOknownKinds_collect :: (FMap Name [Name])
            _leftExpressionOknownTypes :: (FMap Name [Name])
            _leftExpressionOknownTypes_collect :: (FMap Name [Name])
            _leftExpressionOknownValues :: (FMap Name [Name])
            _leftExpressionOknownValues_collect :: (FMap Name [Name])
            _leftExpressionOlabels_collect :: (FMap Name Names)
            _leftExpressionOlabels_dist :: (FMap Name Names)
            _leftExpressionOlocal :: (Bool)
            _leftExpressionOmethods_collect :: (FMap Name Names)
            _leftExpressionOmethods_dist :: (FMap Name Names)
            _leftExpressionOmoduleTypes :: (FMap ModuleName [Name])
            _leftExpressionOmoduleValues :: (FMap ModuleName [Name])
            _leftExpressionOnameType :: (NameType)
            _leftExpressionOtoplevel :: (Bool)
            _operatorIconstructors_collect :: (FMap Name Names)
            _operatorIknownKinds_collect :: (FMap Name [Name])
            _operatorIknownTypes_collect :: (FMap Name [Name])
            _operatorIknownValues_collect :: (FMap Name [Name])
            _operatorIlabels_collect :: (FMap Name Names)
            _operatorImethods_collect :: (FMap Name Names)
            _operatorImoduleTypes :: (FMap ModuleName [Name])
            _operatorImoduleValues :: (FMap ModuleName [Name])
            _operatorImodules :: (Set.Set Strings)
            _operatorIres :: ([ResolveResult])
            _operatorIself :: (Expression)
            _operatorOclassname :: (Maybe Name)
            _operatorOconstructors_collect :: (FMap Name Names)
            _operatorOconstructors_dist :: (FMap Name Names)
            _operatorOcurrentModule :: (Strings)
            _operatorOimportedModule :: (Bool)
            _operatorOinstancename :: (Maybe Name)
            _operatorOknownGenerics :: (FMap Name [Name])
            _operatorOknownKinds :: (FMap Name [Name])
            _operatorOknownKinds_collect :: (FMap Name [Name])
            _operatorOknownTypes :: (FMap Name [Name])
            _operatorOknownTypes_collect :: (FMap Name [Name])
            _operatorOknownValues :: (FMap Name [Name])
            _operatorOknownValues_collect :: (FMap Name [Name])
            _operatorOlabels_collect :: (FMap Name Names)
            _operatorOlabels_dist :: (FMap Name Names)
            _operatorOlocal :: (Bool)
            _operatorOmethods_collect :: (FMap Name Names)
            _operatorOmethods_dist :: (FMap Name Names)
            _operatorOmoduleTypes :: (FMap ModuleName [Name])
            _operatorOmoduleValues :: (FMap ModuleName [Name])
            _operatorOnameType :: (NameType)
            _operatorOtoplevel :: (Bool)
            _rightExpressionIconstructors_collect :: (FMap Name Names)
            _rightExpressionIknownKinds_collect :: (FMap Name [Name])
            _rightExpressionIknownTypes_collect :: (FMap Name [Name])
            _rightExpressionIknownValues_collect :: (FMap Name [Name])
            _rightExpressionIlabels_collect :: (FMap Name Names)
            _rightExpressionImethods_collect :: (FMap Name Names)
            _rightExpressionImoduleTypes :: (FMap ModuleName [Name])
            _rightExpressionImoduleValues :: (FMap ModuleName [Name])
            _rightExpressionImodules :: (Set.Set Strings)
            _rightExpressionIres :: ([ResolveResult])
            _rightExpressionIself :: (MaybeExpression)
            _rightExpressionOclassname :: (Maybe Name)
            _rightExpressionOconstructors_collect :: (FMap Name Names)
            _rightExpressionOconstructors_dist :: (FMap Name Names)
            _rightExpressionOcurrentModule :: (Strings)
            _rightExpressionOimportedModule :: (Bool)
            _rightExpressionOinstancename :: (Maybe Name)
            _rightExpressionOknownGenerics :: (FMap Name [Name])
            _rightExpressionOknownKinds :: (FMap Name [Name])
            _rightExpressionOknownKinds_collect :: (FMap Name [Name])
            _rightExpressionOknownTypes :: (FMap Name [Name])
            _rightExpressionOknownTypes_collect :: (FMap Name [Name])
            _rightExpressionOknownValues :: (FMap Name [Name])
            _rightExpressionOknownValues_collect :: (FMap Name [Name])
            _rightExpressionOlabels_collect :: (FMap Name Names)
            _rightExpressionOlabels_dist :: (FMap Name Names)
            _rightExpressionOlocal :: (Bool)
            _rightExpressionOmethods_collect :: (FMap Name Names)
            _rightExpressionOmethods_dist :: (FMap Name Names)
            _rightExpressionOmoduleTypes :: (FMap ModuleName [Name])
            _rightExpressionOmoduleValues :: (FMap ModuleName [Name])
            _rightExpressionOnameType :: (NameType)
            _rightExpressionOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _leftExpressionIconstructors_collect,_leftExpressionIknownKinds_collect,_leftExpressionIknownTypes_collect,_leftExpressionIknownValues_collect,_leftExpressionIlabels_collect,_leftExpressionImethods_collect,_leftExpressionImoduleTypes,_leftExpressionImoduleValues,_leftExpressionImodules,_leftExpressionIres,_leftExpressionIself) =
                (leftExpression_ (_leftExpressionOclassname)
                                 (_leftExpressionOconstructors_collect)
                                 (_leftExpressionOconstructors_dist)
                                 (_leftExpressionOcurrentModule)
                                 (_leftExpressionOimportedModule)
                                 (_leftExpressionOinstancename)
                                 (_leftExpressionOknownGenerics)
                                 (_leftExpressionOknownKinds)
                                 (_leftExpressionOknownKinds_collect)
                                 (_leftExpressionOknownTypes)
                                 (_leftExpressionOknownTypes_collect)
                                 (_leftExpressionOknownValues)
                                 (_leftExpressionOknownValues_collect)
                                 (_leftExpressionOlabels_collect)
                                 (_leftExpressionOlabels_dist)
                                 (_leftExpressionOlocal)
                                 (_leftExpressionOmethods_collect)
                                 (_leftExpressionOmethods_dist)
                                 (_leftExpressionOmoduleTypes)
                                 (_leftExpressionOmoduleValues)
                                 (_leftExpressionOnameType)
                                 (_leftExpressionOtoplevel))
            ( _operatorIconstructors_collect,_operatorIknownKinds_collect,_operatorIknownTypes_collect,_operatorIknownValues_collect,_operatorIlabels_collect,_operatorImethods_collect,_operatorImoduleTypes,_operatorImoduleValues,_operatorImodules,_operatorIres,_operatorIself) =
                (operator_ (_operatorOclassname)
                           (_operatorOconstructors_collect)
                           (_operatorOconstructors_dist)
                           (_operatorOcurrentModule)
                           (_operatorOimportedModule)
                           (_operatorOinstancename)
                           (_operatorOknownGenerics)
                           (_operatorOknownKinds)
                           (_operatorOknownKinds_collect)
                           (_operatorOknownTypes)
                           (_operatorOknownTypes_collect)
                           (_operatorOknownValues)
                           (_operatorOknownValues_collect)
                           (_operatorOlabels_collect)
                           (_operatorOlabels_dist)
                           (_operatorOlocal)
                           (_operatorOmethods_collect)
                           (_operatorOmethods_dist)
                           (_operatorOmoduleTypes)
                           (_operatorOmoduleValues)
                           (_operatorOnameType)
                           (_operatorOtoplevel))
            ( _rightExpressionIconstructors_collect,_rightExpressionIknownKinds_collect,_rightExpressionIknownTypes_collect,_rightExpressionIknownValues_collect,_rightExpressionIlabels_collect,_rightExpressionImethods_collect,_rightExpressionImoduleTypes,_rightExpressionImoduleValues,_rightExpressionImodules,_rightExpressionIres,_rightExpressionIself) =
                (rightExpression_ (_rightExpressionOclassname)
                                  (_rightExpressionOconstructors_collect)
                                  (_rightExpressionOconstructors_dist)
                                  (_rightExpressionOcurrentModule)
                                  (_rightExpressionOimportedModule)
                                  (_rightExpressionOinstancename)
                                  (_rightExpressionOknownGenerics)
                                  (_rightExpressionOknownKinds)
                                  (_rightExpressionOknownKinds_collect)
                                  (_rightExpressionOknownTypes)
                                  (_rightExpressionOknownTypes_collect)
                                  (_rightExpressionOknownValues)
                                  (_rightExpressionOknownValues_collect)
                                  (_rightExpressionOlabels_collect)
                                  (_rightExpressionOlabels_dist)
                                  (_rightExpressionOlocal)
                                  (_rightExpressionOmethods_collect)
                                  (_rightExpressionOmethods_dist)
                                  (_rightExpressionOmoduleTypes)
                                  (_rightExpressionOmoduleValues)
                                  (_rightExpressionOnameType)
                                  (_rightExpressionOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _leftExpressionImodules `Set.union` _operatorImodules `Set.union` _rightExpressionImodules
            -- use rule
            (_lhsOres@_) =
                _leftExpressionIres ++ _operatorIres ++ _rightExpressionIres
            -- self rule
            (_self@_) =
                Expression_InfixApplication _rangeIself _leftExpressionIself _operatorIself _rightExpressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _rightExpressionIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _rightExpressionIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _rightExpressionIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _rightExpressionIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _rightExpressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _rightExpressionImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _rightExpressionImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _rightExpressionImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_leftExpressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_leftExpressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_leftExpressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_leftExpressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_leftExpressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_leftExpressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_leftExpressionOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_leftExpressionOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_leftExpressionOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_leftExpressionOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_leftExpressionOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_leftExpressionOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_leftExpressionOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_leftExpressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_leftExpressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_leftExpressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_leftExpressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_leftExpressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_leftExpressionOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_leftExpressionOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_leftExpressionOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_leftExpressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_operatorOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_operatorOconstructors_collect@_) =
                _leftExpressionIconstructors_collect
            -- copy rule (down)
            (_operatorOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_operatorOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_operatorOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_operatorOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_operatorOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_operatorOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_operatorOknownKinds_collect@_) =
                _leftExpressionIknownKinds_collect
            -- copy rule (down)
            (_operatorOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_operatorOknownTypes_collect@_) =
                _leftExpressionIknownTypes_collect
            -- copy rule (down)
            (_operatorOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_operatorOknownValues_collect@_) =
                _leftExpressionIknownValues_collect
            -- copy rule (chain)
            (_operatorOlabels_collect@_) =
                _leftExpressionIlabels_collect
            -- copy rule (down)
            (_operatorOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_operatorOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_operatorOmethods_collect@_) =
                _leftExpressionImethods_collect
            -- copy rule (down)
            (_operatorOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_operatorOmoduleTypes@_) =
                _leftExpressionImoduleTypes
            -- copy rule (chain)
            (_operatorOmoduleValues@_) =
                _leftExpressionImoduleValues
            -- copy rule (down)
            (_operatorOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_operatorOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_rightExpressionOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_rightExpressionOconstructors_collect@_) =
                _operatorIconstructors_collect
            -- copy rule (down)
            (_rightExpressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_rightExpressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rightExpressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rightExpressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rightExpressionOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_rightExpressionOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_rightExpressionOknownKinds_collect@_) =
                _operatorIknownKinds_collect
            -- copy rule (down)
            (_rightExpressionOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_rightExpressionOknownTypes_collect@_) =
                _operatorIknownTypes_collect
            -- copy rule (down)
            (_rightExpressionOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_rightExpressionOknownValues_collect@_) =
                _operatorIknownValues_collect
            -- copy rule (chain)
            (_rightExpressionOlabels_collect@_) =
                _operatorIlabels_collect
            -- copy rule (down)
            (_rightExpressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_rightExpressionOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_rightExpressionOmethods_collect@_) =
                _operatorImethods_collect
            -- copy rule (down)
            (_rightExpressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_rightExpressionOmoduleTypes@_) =
                _operatorImoduleTypes
            -- copy rule (chain)
            (_rightExpressionOmoduleValues@_) =
                _operatorImoduleValues
            -- copy rule (down)
            (_rightExpressionOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_rightExpressionOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Expression_Irrefutable :: (T_Range) ->
                              (T_Expression) ->
                              (T_Expression)
sem_Expression_Irrefutable (range_) (expression_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIknownKinds_collect :: (FMap Name [Name])
            _expressionIknownTypes_collect :: (FMap Name [Name])
            _expressionIknownValues_collect :: (FMap Name [Name])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionImoduleTypes :: (FMap ModuleName [Name])
            _expressionImoduleValues :: (FMap ModuleName [Name])
            _expressionImodules :: (Set.Set Strings)
            _expressionIres :: ([ResolveResult])
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOknownGenerics :: (FMap Name [Name])
            _expressionOknownKinds :: (FMap Name [Name])
            _expressionOknownKinds_collect :: (FMap Name [Name])
            _expressionOknownTypes :: (FMap Name [Name])
            _expressionOknownTypes_collect :: (FMap Name [Name])
            _expressionOknownValues :: (FMap Name [Name])
            _expressionOknownValues_collect :: (FMap Name [Name])
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmoduleTypes :: (FMap ModuleName [Name])
            _expressionOmoduleValues :: (FMap ModuleName [Name])
            _expressionOnameType :: (NameType)
            _expressionOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionIconstructors_collect,_expressionIknownKinds_collect,_expressionIknownTypes_collect,_expressionIknownValues_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionImoduleTypes,_expressionImoduleValues,_expressionImodules,_expressionIres,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOknownGenerics)
                             (_expressionOknownKinds)
                             (_expressionOknownKinds_collect)
                             (_expressionOknownTypes)
                             (_expressionOknownTypes_collect)
                             (_expressionOknownValues)
                             (_expressionOknownValues_collect)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmoduleTypes)
                             (_expressionOmoduleValues)
                             (_expressionOnameType)
                             (_expressionOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _expressionImodules
            -- use rule
            (_lhsOres@_) =
                _expressionIres
            -- self rule
            (_self@_) =
                Expression_Irrefutable _rangeIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _expressionIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _expressionIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _expressionIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _expressionImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _expressionImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_expressionOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_expressionOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_expressionOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_expressionOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_expressionOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_expressionOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_expressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_expressionOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_expressionOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Expression_Lambda :: (T_Range) ->
                         (T_Patterns) ->
                         (T_Expression) ->
                         (T_Expression)
sem_Expression_Lambda (range_) (patterns_) (expression_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _patternsIconstructors_collect :: (FMap Name Names)
            _patternsIknownKinds_collect :: (FMap Name [Name])
            _patternsIknownTypes_collect :: (FMap Name [Name])
            _patternsIknownValues_collect :: (FMap Name [Name])
            _patternsIlabels_collect :: (FMap Name Names)
            _patternsImethods_collect :: (FMap Name Names)
            _patternsImoduleTypes :: (FMap ModuleName [Name])
            _patternsImoduleValues :: (FMap ModuleName [Name])
            _patternsImodules :: (Set.Set Strings)
            _patternsIres :: ([ResolveResult])
            _patternsIself :: (Patterns)
            _patternsOclassname :: (Maybe Name)
            _patternsOconstructors_collect :: (FMap Name Names)
            _patternsOconstructors_dist :: (FMap Name Names)
            _patternsOcurrentModule :: (Strings)
            _patternsOimportedModule :: (Bool)
            _patternsOinstancename :: (Maybe Name)
            _patternsOknownKinds :: (FMap Name [Name])
            _patternsOknownKinds_collect :: (FMap Name [Name])
            _patternsOknownTypes :: (FMap Name [Name])
            _patternsOknownTypes_collect :: (FMap Name [Name])
            _patternsOknownValues :: (FMap Name [Name])
            _patternsOknownValues_collect :: (FMap Name [Name])
            _patternsOlabels_collect :: (FMap Name Names)
            _patternsOlabels_dist :: (FMap Name Names)
            _patternsOlocal :: (Bool)
            _patternsOmethods_collect :: (FMap Name Names)
            _patternsOmethods_dist :: (FMap Name Names)
            _patternsOmoduleTypes :: (FMap ModuleName [Name])
            _patternsOmoduleValues :: (FMap ModuleName [Name])
            _patternsOnameType :: (NameType)
            _patternsOtoplevel :: (Bool)
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIknownKinds_collect :: (FMap Name [Name])
            _expressionIknownTypes_collect :: (FMap Name [Name])
            _expressionIknownValues_collect :: (FMap Name [Name])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionImoduleTypes :: (FMap ModuleName [Name])
            _expressionImoduleValues :: (FMap ModuleName [Name])
            _expressionImodules :: (Set.Set Strings)
            _expressionIres :: ([ResolveResult])
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOknownGenerics :: (FMap Name [Name])
            _expressionOknownKinds :: (FMap Name [Name])
            _expressionOknownKinds_collect :: (FMap Name [Name])
            _expressionOknownTypes :: (FMap Name [Name])
            _expressionOknownTypes_collect :: (FMap Name [Name])
            _expressionOknownValues :: (FMap Name [Name])
            _expressionOknownValues_collect :: (FMap Name [Name])
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmoduleTypes :: (FMap ModuleName [Name])
            _expressionOmoduleValues :: (FMap ModuleName [Name])
            _expressionOnameType :: (NameType)
            _expressionOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _patternsIconstructors_collect,_patternsIknownKinds_collect,_patternsIknownTypes_collect,_patternsIknownValues_collect,_patternsIlabels_collect,_patternsImethods_collect,_patternsImoduleTypes,_patternsImoduleValues,_patternsImodules,_patternsIres,_patternsIself) =
                (patterns_ (_patternsOclassname)
                           (_patternsOconstructors_collect)
                           (_patternsOconstructors_dist)
                           (_patternsOcurrentModule)
                           (_patternsOimportedModule)
                           (_patternsOinstancename)
                           (_patternsOknownKinds)
                           (_patternsOknownKinds_collect)
                           (_patternsOknownTypes)
                           (_patternsOknownTypes_collect)
                           (_patternsOknownValues)
                           (_patternsOknownValues_collect)
                           (_patternsOlabels_collect)
                           (_patternsOlabels_dist)
                           (_patternsOlocal)
                           (_patternsOmethods_collect)
                           (_patternsOmethods_dist)
                           (_patternsOmoduleTypes)
                           (_patternsOmoduleValues)
                           (_patternsOnameType)
                           (_patternsOtoplevel))
            ( _expressionIconstructors_collect,_expressionIknownKinds_collect,_expressionIknownTypes_collect,_expressionIknownValues_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionImoduleTypes,_expressionImoduleValues,_expressionImodules,_expressionIres,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOknownGenerics)
                             (_expressionOknownKinds)
                             (_expressionOknownKinds_collect)
                             (_expressionOknownTypes)
                             (_expressionOknownTypes_collect)
                             (_expressionOknownValues)
                             (_expressionOknownValues_collect)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmoduleTypes)
                             (_expressionOmoduleValues)
                             (_expressionOnameType)
                             (_expressionOtoplevel))
            -- "./Names.inc.lag"(line 586, column 9)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- "./Names.inc.lag"(line 585, column 9)
            (_knownValues@_) =
                _patternsIknownValues_collect `mergeFM` _lhsIknownValues
            -- "./Names.inc.lag"(line 584, column 9)
            (_patternsOknownValues_collect@_) =
                emptyFM
            -- use rule
            (_lhsOmodules@_) =
                _patternsImodules `Set.union` _expressionImodules
            -- use rule
            (_lhsOres@_) =
                _patternsIres ++ _expressionIres
            -- self rule
            (_self@_) =
                Expression_Lambda _rangeIself _patternsIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _expressionIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _expressionIknownTypes_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _expressionImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _expressionImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_patternsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_patternsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_patternsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_patternsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_patternsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_patternsOknownValues@_) =
                _knownValues
            -- copy rule (down)
            (_patternsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_patternsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_patternsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_patternsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_patternsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_patternsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_patternsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_expressionOconstructors_collect@_) =
                _patternsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_expressionOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_expressionOknownKinds_collect@_) =
                _patternsIknownKinds_collect
            -- copy rule (down)
            (_expressionOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_expressionOknownTypes_collect@_) =
                _patternsIknownTypes_collect
            -- copy rule (chain)
            (_expressionOknownValues@_) =
                _knownValues
            -- copy rule (chain)
            (_expressionOknownValues_collect@_) =
                _patternsIknownValues_collect
            -- copy rule (chain)
            (_expressionOlabels_collect@_) =
                _patternsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_expressionOmethods_collect@_) =
                _patternsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_expressionOmoduleTypes@_) =
                _patternsImoduleTypes
            -- copy rule (chain)
            (_expressionOmoduleValues@_) =
                _patternsImoduleValues
            -- copy rule (down)
            (_expressionOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Expression_Let :: (T_Range) ->
                      (T_Declarations) ->
                      (T_Expression) ->
                      (T_Expression)
sem_Expression_Let (range_) (declarations_) (expression_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _declarationsIconstructors_collect :: (FMap Name Names)
            _declarationsIknownKinds_collect :: (FMap Name [Name])
            _declarationsIknownTypes_collect :: (FMap Name [Name])
            _declarationsIknownValues_collect :: (FMap Name [Name])
            _declarationsIlabels_collect :: (FMap Name Names)
            _declarationsImethods_collect :: (FMap Name Names)
            _declarationsImoduleTypes :: (FMap ModuleName [Name])
            _declarationsImoduleValues :: (FMap ModuleName [Name])
            _declarationsImodules :: (Set.Set Strings)
            _declarationsIres :: ([ResolveResult])
            _declarationsIself :: (Declarations)
            _declarationsOclassname :: (Maybe Name)
            _declarationsOconstructors_collect :: (FMap Name Names)
            _declarationsOconstructors_dist :: (FMap Name Names)
            _declarationsOcurrentModule :: (Strings)
            _declarationsOimportedModule :: (Bool)
            _declarationsOinstancename :: (Maybe Name)
            _declarationsOknownGenerics :: (FMap Name [Name])
            _declarationsOknownKinds :: (FMap Name [Name])
            _declarationsOknownKinds_collect :: (FMap Name [Name])
            _declarationsOknownTypes :: (FMap Name [Name])
            _declarationsOknownTypes_collect :: (FMap Name [Name])
            _declarationsOknownValues :: (FMap Name [Name])
            _declarationsOknownValues_collect :: (FMap Name [Name])
            _declarationsOlabels_collect :: (FMap Name Names)
            _declarationsOlabels_dist :: (FMap Name Names)
            _declarationsOlocal :: (Bool)
            _declarationsOmethods_collect :: (FMap Name Names)
            _declarationsOmethods_dist :: (FMap Name Names)
            _declarationsOmoduleTypes :: (FMap ModuleName [Name])
            _declarationsOmoduleValues :: (FMap ModuleName [Name])
            _declarationsOnameType :: (NameType)
            _declarationsOtoplevel :: (Bool)
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIknownKinds_collect :: (FMap Name [Name])
            _expressionIknownTypes_collect :: (FMap Name [Name])
            _expressionIknownValues_collect :: (FMap Name [Name])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionImoduleTypes :: (FMap ModuleName [Name])
            _expressionImoduleValues :: (FMap ModuleName [Name])
            _expressionImodules :: (Set.Set Strings)
            _expressionIres :: ([ResolveResult])
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOknownGenerics :: (FMap Name [Name])
            _expressionOknownKinds :: (FMap Name [Name])
            _expressionOknownKinds_collect :: (FMap Name [Name])
            _expressionOknownTypes :: (FMap Name [Name])
            _expressionOknownTypes_collect :: (FMap Name [Name])
            _expressionOknownValues :: (FMap Name [Name])
            _expressionOknownValues_collect :: (FMap Name [Name])
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmoduleTypes :: (FMap ModuleName [Name])
            _expressionOmoduleValues :: (FMap ModuleName [Name])
            _expressionOnameType :: (NameType)
            _expressionOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _declarationsIconstructors_collect,_declarationsIknownKinds_collect,_declarationsIknownTypes_collect,_declarationsIknownValues_collect,_declarationsIlabels_collect,_declarationsImethods_collect,_declarationsImoduleTypes,_declarationsImoduleValues,_declarationsImodules,_declarationsIres,_declarationsIself) =
                (declarations_ (_declarationsOclassname)
                               (_declarationsOconstructors_collect)
                               (_declarationsOconstructors_dist)
                               (_declarationsOcurrentModule)
                               (_declarationsOimportedModule)
                               (_declarationsOinstancename)
                               (_declarationsOknownGenerics)
                               (_declarationsOknownKinds)
                               (_declarationsOknownKinds_collect)
                               (_declarationsOknownTypes)
                               (_declarationsOknownTypes_collect)
                               (_declarationsOknownValues)
                               (_declarationsOknownValues_collect)
                               (_declarationsOlabels_collect)
                               (_declarationsOlabels_dist)
                               (_declarationsOlocal)
                               (_declarationsOmethods_collect)
                               (_declarationsOmethods_dist)
                               (_declarationsOmoduleTypes)
                               (_declarationsOmoduleValues)
                               (_declarationsOnameType)
                               (_declarationsOtoplevel))
            ( _expressionIconstructors_collect,_expressionIknownKinds_collect,_expressionIknownTypes_collect,_expressionIknownValues_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionImoduleTypes,_expressionImoduleValues,_expressionImodules,_expressionIres,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOknownGenerics)
                             (_expressionOknownKinds)
                             (_expressionOknownKinds_collect)
                             (_expressionOknownTypes)
                             (_expressionOknownTypes_collect)
                             (_expressionOknownValues)
                             (_expressionOknownValues_collect)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmoduleTypes)
                             (_expressionOmoduleValues)
                             (_expressionOnameType)
                             (_expressionOtoplevel))
            -- "./Names.inc.lag"(line 581, column 9)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- "./Names.inc.lag"(line 580, column 9)
            (_knownTypes@_) =
                _declarationsIknownTypes_collect `mergeFM` _lhsIknownTypes
            -- "./Names.inc.lag"(line 579, column 9)
            (_declarationsOknownTypes_collect@_) =
                emptyFM
            -- "./Names.inc.lag"(line 575, column 9)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- "./Names.inc.lag"(line 574, column 9)
            (_knownValues@_) =
                _declarationsIknownValues_collect `mergeFM` _lhsIknownValues
            -- "./Names.inc.lag"(line 573, column 9)
            (_declarationsOknownValues_collect@_) =
                emptyFM
            -- use rule
            (_lhsOmodules@_) =
                _declarationsImodules `Set.union` _expressionImodules
            -- use rule
            (_lhsOres@_) =
                _declarationsIres ++ _expressionIres
            -- self rule
            (_self@_) =
                Expression_Let _rangeIself _declarationsIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _expressionIknownKinds_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _expressionImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _expressionImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_declarationsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_declarationsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_declarationsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_declarationsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_declarationsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_declarationsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_declarationsOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_declarationsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_declarationsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_declarationsOknownTypes@_) =
                _knownTypes
            -- copy rule (chain)
            (_declarationsOknownValues@_) =
                _knownValues
            -- copy rule (down)
            (_declarationsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_declarationsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_declarationsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_declarationsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_declarationsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_declarationsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_declarationsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_declarationsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_declarationsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_expressionOconstructors_collect@_) =
                _declarationsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_expressionOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_expressionOknownKinds_collect@_) =
                _declarationsIknownKinds_collect
            -- copy rule (chain)
            (_expressionOknownTypes@_) =
                _knownTypes
            -- copy rule (chain)
            (_expressionOknownTypes_collect@_) =
                _declarationsIknownTypes_collect
            -- copy rule (chain)
            (_expressionOknownValues@_) =
                _knownValues
            -- copy rule (chain)
            (_expressionOknownValues_collect@_) =
                _declarationsIknownValues_collect
            -- copy rule (chain)
            (_expressionOlabels_collect@_) =
                _declarationsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_expressionOmethods_collect@_) =
                _declarationsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_expressionOmoduleTypes@_) =
                _declarationsImoduleTypes
            -- copy rule (chain)
            (_expressionOmoduleValues@_) =
                _declarationsImoduleValues
            -- copy rule (down)
            (_expressionOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Expression_List :: (T_Range) ->
                       (T_Expressions) ->
                       (T_Expression)
sem_Expression_List (range_) (expressions_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionsIconstructors_collect :: (FMap Name Names)
            _expressionsIknownKinds_collect :: (FMap Name [Name])
            _expressionsIknownTypes_collect :: (FMap Name [Name])
            _expressionsIknownValues_collect :: (FMap Name [Name])
            _expressionsIlabels_collect :: (FMap Name Names)
            _expressionsImethods_collect :: (FMap Name Names)
            _expressionsImoduleTypes :: (FMap ModuleName [Name])
            _expressionsImoduleValues :: (FMap ModuleName [Name])
            _expressionsImodules :: (Set.Set Strings)
            _expressionsIres :: ([ResolveResult])
            _expressionsIself :: (Expressions)
            _expressionsOclassname :: (Maybe Name)
            _expressionsOconstructors_collect :: (FMap Name Names)
            _expressionsOconstructors_dist :: (FMap Name Names)
            _expressionsOcurrentModule :: (Strings)
            _expressionsOimportedModule :: (Bool)
            _expressionsOinstancename :: (Maybe Name)
            _expressionsOknownGenerics :: (FMap Name [Name])
            _expressionsOknownKinds :: (FMap Name [Name])
            _expressionsOknownKinds_collect :: (FMap Name [Name])
            _expressionsOknownTypes :: (FMap Name [Name])
            _expressionsOknownTypes_collect :: (FMap Name [Name])
            _expressionsOknownValues :: (FMap Name [Name])
            _expressionsOknownValues_collect :: (FMap Name [Name])
            _expressionsOlabels_collect :: (FMap Name Names)
            _expressionsOlabels_dist :: (FMap Name Names)
            _expressionsOlocal :: (Bool)
            _expressionsOmethods_collect :: (FMap Name Names)
            _expressionsOmethods_dist :: (FMap Name Names)
            _expressionsOmoduleTypes :: (FMap ModuleName [Name])
            _expressionsOmoduleValues :: (FMap ModuleName [Name])
            _expressionsOnameType :: (NameType)
            _expressionsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionsIconstructors_collect,_expressionsIknownKinds_collect,_expressionsIknownTypes_collect,_expressionsIknownValues_collect,_expressionsIlabels_collect,_expressionsImethods_collect,_expressionsImoduleTypes,_expressionsImoduleValues,_expressionsImodules,_expressionsIres,_expressionsIself) =
                (expressions_ (_expressionsOclassname)
                              (_expressionsOconstructors_collect)
                              (_expressionsOconstructors_dist)
                              (_expressionsOcurrentModule)
                              (_expressionsOimportedModule)
                              (_expressionsOinstancename)
                              (_expressionsOknownGenerics)
                              (_expressionsOknownKinds)
                              (_expressionsOknownKinds_collect)
                              (_expressionsOknownTypes)
                              (_expressionsOknownTypes_collect)
                              (_expressionsOknownValues)
                              (_expressionsOknownValues_collect)
                              (_expressionsOlabels_collect)
                              (_expressionsOlabels_dist)
                              (_expressionsOlocal)
                              (_expressionsOmethods_collect)
                              (_expressionsOmethods_dist)
                              (_expressionsOmoduleTypes)
                              (_expressionsOmoduleValues)
                              (_expressionsOnameType)
                              (_expressionsOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _expressionsImodules
            -- use rule
            (_lhsOres@_) =
                _expressionsIres
            -- self rule
            (_self@_) =
                Expression_List _rangeIself _expressionsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionsIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _expressionsIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _expressionsIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _expressionsIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _expressionsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _expressionsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionsOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_expressionsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_expressionsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_expressionsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_expressionsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_expressionsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_expressionsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_expressionsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_expressionsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_expressionsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_expressionsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Expression_Literal :: (T_Range) ->
                          (T_Literal) ->
                          (T_Expression)
sem_Expression_Literal (range_) (literal_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _literalIconstructors_collect :: (FMap Name Names)
            _literalIknownKinds_collect :: (FMap Name [Name])
            _literalIknownTypes_collect :: (FMap Name [Name])
            _literalIknownValues_collect :: (FMap Name [Name])
            _literalIlabels_collect :: (FMap Name Names)
            _literalImethods_collect :: (FMap Name Names)
            _literalImoduleTypes :: (FMap ModuleName [Name])
            _literalImoduleValues :: (FMap ModuleName [Name])
            _literalImodules :: (Set.Set Strings)
            _literalIres :: ([ResolveResult])
            _literalIself :: (Literal)
            _literalOclassname :: (Maybe Name)
            _literalOconstructors_collect :: (FMap Name Names)
            _literalOconstructors_dist :: (FMap Name Names)
            _literalOcurrentModule :: (Strings)
            _literalOimportedModule :: (Bool)
            _literalOinstancename :: (Maybe Name)
            _literalOknownKinds :: (FMap Name [Name])
            _literalOknownKinds_collect :: (FMap Name [Name])
            _literalOknownTypes :: (FMap Name [Name])
            _literalOknownTypes_collect :: (FMap Name [Name])
            _literalOknownValues :: (FMap Name [Name])
            _literalOknownValues_collect :: (FMap Name [Name])
            _literalOlabels_collect :: (FMap Name Names)
            _literalOlabels_dist :: (FMap Name Names)
            _literalOlocal :: (Bool)
            _literalOmethods_collect :: (FMap Name Names)
            _literalOmethods_dist :: (FMap Name Names)
            _literalOmoduleTypes :: (FMap ModuleName [Name])
            _literalOmoduleValues :: (FMap ModuleName [Name])
            _literalOnameType :: (NameType)
            _literalOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _literalIconstructors_collect,_literalIknownKinds_collect,_literalIknownTypes_collect,_literalIknownValues_collect,_literalIlabels_collect,_literalImethods_collect,_literalImoduleTypes,_literalImoduleValues,_literalImodules,_literalIres,_literalIself) =
                (literal_ (_literalOclassname)
                          (_literalOconstructors_collect)
                          (_literalOconstructors_dist)
                          (_literalOcurrentModule)
                          (_literalOimportedModule)
                          (_literalOinstancename)
                          (_literalOknownKinds)
                          (_literalOknownKinds_collect)
                          (_literalOknownTypes)
                          (_literalOknownTypes_collect)
                          (_literalOknownValues)
                          (_literalOknownValues_collect)
                          (_literalOlabels_collect)
                          (_literalOlabels_dist)
                          (_literalOlocal)
                          (_literalOmethods_collect)
                          (_literalOmethods_dist)
                          (_literalOmoduleTypes)
                          (_literalOmoduleValues)
                          (_literalOnameType)
                          (_literalOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _literalImodules
            -- use rule
            (_lhsOres@_) =
                _literalIres
            -- self rule
            (_self@_) =
                Expression_Literal _rangeIself _literalIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _literalIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _literalIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _literalIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _literalIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _literalIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _literalImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _literalImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _literalImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_literalOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_literalOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_literalOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_literalOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_literalOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_literalOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_literalOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_literalOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_literalOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_literalOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_literalOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_literalOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_literalOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_literalOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_literalOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_literalOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_literalOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_literalOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_literalOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_literalOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_literalOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Expression_Negate :: (T_Range) ->
                         (T_Expression) ->
                         (T_Expression)
sem_Expression_Negate (range_) (expression_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIknownKinds_collect :: (FMap Name [Name])
            _expressionIknownTypes_collect :: (FMap Name [Name])
            _expressionIknownValues_collect :: (FMap Name [Name])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionImoduleTypes :: (FMap ModuleName [Name])
            _expressionImoduleValues :: (FMap ModuleName [Name])
            _expressionImodules :: (Set.Set Strings)
            _expressionIres :: ([ResolveResult])
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOknownGenerics :: (FMap Name [Name])
            _expressionOknownKinds :: (FMap Name [Name])
            _expressionOknownKinds_collect :: (FMap Name [Name])
            _expressionOknownTypes :: (FMap Name [Name])
            _expressionOknownTypes_collect :: (FMap Name [Name])
            _expressionOknownValues :: (FMap Name [Name])
            _expressionOknownValues_collect :: (FMap Name [Name])
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmoduleTypes :: (FMap ModuleName [Name])
            _expressionOmoduleValues :: (FMap ModuleName [Name])
            _expressionOnameType :: (NameType)
            _expressionOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionIconstructors_collect,_expressionIknownKinds_collect,_expressionIknownTypes_collect,_expressionIknownValues_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionImoduleTypes,_expressionImoduleValues,_expressionImodules,_expressionIres,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOknownGenerics)
                             (_expressionOknownKinds)
                             (_expressionOknownKinds_collect)
                             (_expressionOknownTypes)
                             (_expressionOknownTypes_collect)
                             (_expressionOknownValues)
                             (_expressionOknownValues_collect)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmoduleTypes)
                             (_expressionOmoduleValues)
                             (_expressionOnameType)
                             (_expressionOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _expressionImodules
            -- use rule
            (_lhsOres@_) =
                _expressionIres
            -- self rule
            (_self@_) =
                Expression_Negate _rangeIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _expressionIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _expressionIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _expressionIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _expressionImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _expressionImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_expressionOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_expressionOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_expressionOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_expressionOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_expressionOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_expressionOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_expressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_expressionOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_expressionOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Expression_NormalApplication :: (T_Range) ->
                                    (T_Expression) ->
                                    (T_Expressions) ->
                                    (T_Expression)
sem_Expression_NormalApplication (range_) (function_) (arguments_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _functionIconstructors_collect :: (FMap Name Names)
            _functionIknownKinds_collect :: (FMap Name [Name])
            _functionIknownTypes_collect :: (FMap Name [Name])
            _functionIknownValues_collect :: (FMap Name [Name])
            _functionIlabels_collect :: (FMap Name Names)
            _functionImethods_collect :: (FMap Name Names)
            _functionImoduleTypes :: (FMap ModuleName [Name])
            _functionImoduleValues :: (FMap ModuleName [Name])
            _functionImodules :: (Set.Set Strings)
            _functionIres :: ([ResolveResult])
            _functionIself :: (Expression)
            _functionOclassname :: (Maybe Name)
            _functionOconstructors_collect :: (FMap Name Names)
            _functionOconstructors_dist :: (FMap Name Names)
            _functionOcurrentModule :: (Strings)
            _functionOimportedModule :: (Bool)
            _functionOinstancename :: (Maybe Name)
            _functionOknownGenerics :: (FMap Name [Name])
            _functionOknownKinds :: (FMap Name [Name])
            _functionOknownKinds_collect :: (FMap Name [Name])
            _functionOknownTypes :: (FMap Name [Name])
            _functionOknownTypes_collect :: (FMap Name [Name])
            _functionOknownValues :: (FMap Name [Name])
            _functionOknownValues_collect :: (FMap Name [Name])
            _functionOlabels_collect :: (FMap Name Names)
            _functionOlabels_dist :: (FMap Name Names)
            _functionOlocal :: (Bool)
            _functionOmethods_collect :: (FMap Name Names)
            _functionOmethods_dist :: (FMap Name Names)
            _functionOmoduleTypes :: (FMap ModuleName [Name])
            _functionOmoduleValues :: (FMap ModuleName [Name])
            _functionOnameType :: (NameType)
            _functionOtoplevel :: (Bool)
            _argumentsIconstructors_collect :: (FMap Name Names)
            _argumentsIknownKinds_collect :: (FMap Name [Name])
            _argumentsIknownTypes_collect :: (FMap Name [Name])
            _argumentsIknownValues_collect :: (FMap Name [Name])
            _argumentsIlabels_collect :: (FMap Name Names)
            _argumentsImethods_collect :: (FMap Name Names)
            _argumentsImoduleTypes :: (FMap ModuleName [Name])
            _argumentsImoduleValues :: (FMap ModuleName [Name])
            _argumentsImodules :: (Set.Set Strings)
            _argumentsIres :: ([ResolveResult])
            _argumentsIself :: (Expressions)
            _argumentsOclassname :: (Maybe Name)
            _argumentsOconstructors_collect :: (FMap Name Names)
            _argumentsOconstructors_dist :: (FMap Name Names)
            _argumentsOcurrentModule :: (Strings)
            _argumentsOimportedModule :: (Bool)
            _argumentsOinstancename :: (Maybe Name)
            _argumentsOknownGenerics :: (FMap Name [Name])
            _argumentsOknownKinds :: (FMap Name [Name])
            _argumentsOknownKinds_collect :: (FMap Name [Name])
            _argumentsOknownTypes :: (FMap Name [Name])
            _argumentsOknownTypes_collect :: (FMap Name [Name])
            _argumentsOknownValues :: (FMap Name [Name])
            _argumentsOknownValues_collect :: (FMap Name [Name])
            _argumentsOlabels_collect :: (FMap Name Names)
            _argumentsOlabels_dist :: (FMap Name Names)
            _argumentsOlocal :: (Bool)
            _argumentsOmethods_collect :: (FMap Name Names)
            _argumentsOmethods_dist :: (FMap Name Names)
            _argumentsOmoduleTypes :: (FMap ModuleName [Name])
            _argumentsOmoduleValues :: (FMap ModuleName [Name])
            _argumentsOnameType :: (NameType)
            _argumentsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _functionIconstructors_collect,_functionIknownKinds_collect,_functionIknownTypes_collect,_functionIknownValues_collect,_functionIlabels_collect,_functionImethods_collect,_functionImoduleTypes,_functionImoduleValues,_functionImodules,_functionIres,_functionIself) =
                (function_ (_functionOclassname)
                           (_functionOconstructors_collect)
                           (_functionOconstructors_dist)
                           (_functionOcurrentModule)
                           (_functionOimportedModule)
                           (_functionOinstancename)
                           (_functionOknownGenerics)
                           (_functionOknownKinds)
                           (_functionOknownKinds_collect)
                           (_functionOknownTypes)
                           (_functionOknownTypes_collect)
                           (_functionOknownValues)
                           (_functionOknownValues_collect)
                           (_functionOlabels_collect)
                           (_functionOlabels_dist)
                           (_functionOlocal)
                           (_functionOmethods_collect)
                           (_functionOmethods_dist)
                           (_functionOmoduleTypes)
                           (_functionOmoduleValues)
                           (_functionOnameType)
                           (_functionOtoplevel))
            ( _argumentsIconstructors_collect,_argumentsIknownKinds_collect,_argumentsIknownTypes_collect,_argumentsIknownValues_collect,_argumentsIlabels_collect,_argumentsImethods_collect,_argumentsImoduleTypes,_argumentsImoduleValues,_argumentsImodules,_argumentsIres,_argumentsIself) =
                (arguments_ (_argumentsOclassname)
                            (_argumentsOconstructors_collect)
                            (_argumentsOconstructors_dist)
                            (_argumentsOcurrentModule)
                            (_argumentsOimportedModule)
                            (_argumentsOinstancename)
                            (_argumentsOknownGenerics)
                            (_argumentsOknownKinds)
                            (_argumentsOknownKinds_collect)
                            (_argumentsOknownTypes)
                            (_argumentsOknownTypes_collect)
                            (_argumentsOknownValues)
                            (_argumentsOknownValues_collect)
                            (_argumentsOlabels_collect)
                            (_argumentsOlabels_dist)
                            (_argumentsOlocal)
                            (_argumentsOmethods_collect)
                            (_argumentsOmethods_dist)
                            (_argumentsOmoduleTypes)
                            (_argumentsOmoduleValues)
                            (_argumentsOnameType)
                            (_argumentsOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _functionImodules `Set.union` _argumentsImodules
            -- use rule
            (_lhsOres@_) =
                _functionIres ++ _argumentsIres
            -- self rule
            (_self@_) =
                Expression_NormalApplication _rangeIself _functionIself _argumentsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _argumentsIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _argumentsIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _argumentsIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _argumentsIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _argumentsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _argumentsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _argumentsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _argumentsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_functionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_functionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_functionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_functionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_functionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_functionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_functionOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_functionOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_functionOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_functionOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_functionOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_functionOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_functionOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_functionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_functionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_functionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_functionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_functionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_functionOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_functionOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_functionOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_functionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_argumentsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_argumentsOconstructors_collect@_) =
                _functionIconstructors_collect
            -- copy rule (down)
            (_argumentsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_argumentsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_argumentsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_argumentsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_argumentsOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_argumentsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_argumentsOknownKinds_collect@_) =
                _functionIknownKinds_collect
            -- copy rule (down)
            (_argumentsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_argumentsOknownTypes_collect@_) =
                _functionIknownTypes_collect
            -- copy rule (down)
            (_argumentsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_argumentsOknownValues_collect@_) =
                _functionIknownValues_collect
            -- copy rule (chain)
            (_argumentsOlabels_collect@_) =
                _functionIlabels_collect
            -- copy rule (down)
            (_argumentsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_argumentsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_argumentsOmethods_collect@_) =
                _functionImethods_collect
            -- copy rule (down)
            (_argumentsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_argumentsOmoduleTypes@_) =
                _functionImoduleTypes
            -- copy rule (chain)
            (_argumentsOmoduleValues@_) =
                _functionImoduleValues
            -- copy rule (down)
            (_argumentsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_argumentsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Expression_Parenthesized :: (T_Range) ->
                                (T_Expression) ->
                                (T_Expression)
sem_Expression_Parenthesized (range_) (expression_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIknownKinds_collect :: (FMap Name [Name])
            _expressionIknownTypes_collect :: (FMap Name [Name])
            _expressionIknownValues_collect :: (FMap Name [Name])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionImoduleTypes :: (FMap ModuleName [Name])
            _expressionImoduleValues :: (FMap ModuleName [Name])
            _expressionImodules :: (Set.Set Strings)
            _expressionIres :: ([ResolveResult])
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOknownGenerics :: (FMap Name [Name])
            _expressionOknownKinds :: (FMap Name [Name])
            _expressionOknownKinds_collect :: (FMap Name [Name])
            _expressionOknownTypes :: (FMap Name [Name])
            _expressionOknownTypes_collect :: (FMap Name [Name])
            _expressionOknownValues :: (FMap Name [Name])
            _expressionOknownValues_collect :: (FMap Name [Name])
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmoduleTypes :: (FMap ModuleName [Name])
            _expressionOmoduleValues :: (FMap ModuleName [Name])
            _expressionOnameType :: (NameType)
            _expressionOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionIconstructors_collect,_expressionIknownKinds_collect,_expressionIknownTypes_collect,_expressionIknownValues_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionImoduleTypes,_expressionImoduleValues,_expressionImodules,_expressionIres,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOknownGenerics)
                             (_expressionOknownKinds)
                             (_expressionOknownKinds_collect)
                             (_expressionOknownTypes)
                             (_expressionOknownTypes_collect)
                             (_expressionOknownValues)
                             (_expressionOknownValues_collect)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmoduleTypes)
                             (_expressionOmoduleValues)
                             (_expressionOnameType)
                             (_expressionOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _expressionImodules
            -- use rule
            (_lhsOres@_) =
                _expressionIres
            -- self rule
            (_self@_) =
                Expression_Parenthesized _rangeIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _expressionIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _expressionIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _expressionIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _expressionImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _expressionImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_expressionOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_expressionOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_expressionOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_expressionOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_expressionOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_expressionOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_expressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_expressionOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_expressionOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Expression_RecordConstruction :: (T_Range) ->
                                     (T_Name) ->
                                     (T_RecordExpressionBindings) ->
                                     (T_Expression)
sem_Expression_RecordConstruction (range_) (name_) (recordExpressionBindings_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _recordExpressionBindingsIconstructors_collect :: (FMap Name Names)
            _recordExpressionBindingsIknownKinds_collect :: (FMap Name [Name])
            _recordExpressionBindingsIknownTypes_collect :: (FMap Name [Name])
            _recordExpressionBindingsIknownValues_collect :: (FMap Name [Name])
            _recordExpressionBindingsIlabels_collect :: (FMap Name Names)
            _recordExpressionBindingsImethods_collect :: (FMap Name Names)
            _recordExpressionBindingsImoduleTypes :: (FMap ModuleName [Name])
            _recordExpressionBindingsImoduleValues :: (FMap ModuleName [Name])
            _recordExpressionBindingsImodules :: (Set.Set Strings)
            _recordExpressionBindingsIres :: ([ResolveResult])
            _recordExpressionBindingsIself :: (RecordExpressionBindings)
            _recordExpressionBindingsOclassname :: (Maybe Name)
            _recordExpressionBindingsOconstructors_collect :: (FMap Name Names)
            _recordExpressionBindingsOconstructors_dist :: (FMap Name Names)
            _recordExpressionBindingsOcurrentModule :: (Strings)
            _recordExpressionBindingsOimportedModule :: (Bool)
            _recordExpressionBindingsOinstancename :: (Maybe Name)
            _recordExpressionBindingsOknownGenerics :: (FMap Name [Name])
            _recordExpressionBindingsOknownKinds :: (FMap Name [Name])
            _recordExpressionBindingsOknownKinds_collect :: (FMap Name [Name])
            _recordExpressionBindingsOknownTypes :: (FMap Name [Name])
            _recordExpressionBindingsOknownTypes_collect :: (FMap Name [Name])
            _recordExpressionBindingsOknownValues :: (FMap Name [Name])
            _recordExpressionBindingsOknownValues_collect :: (FMap Name [Name])
            _recordExpressionBindingsOlabels_collect :: (FMap Name Names)
            _recordExpressionBindingsOlabels_dist :: (FMap Name Names)
            _recordExpressionBindingsOlocal :: (Bool)
            _recordExpressionBindingsOmethods_collect :: (FMap Name Names)
            _recordExpressionBindingsOmethods_dist :: (FMap Name Names)
            _recordExpressionBindingsOmoduleTypes :: (FMap ModuleName [Name])
            _recordExpressionBindingsOmoduleValues :: (FMap ModuleName [Name])
            _recordExpressionBindingsOnameType :: (NameType)
            _recordExpressionBindingsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _recordExpressionBindingsIconstructors_collect
             ,_recordExpressionBindingsIknownKinds_collect
             ,_recordExpressionBindingsIknownTypes_collect
             ,_recordExpressionBindingsIknownValues_collect
             ,_recordExpressionBindingsIlabels_collect
             ,_recordExpressionBindingsImethods_collect
             ,_recordExpressionBindingsImoduleTypes
             ,_recordExpressionBindingsImoduleValues
             ,_recordExpressionBindingsImodules
             ,_recordExpressionBindingsIres
             ,_recordExpressionBindingsIself
             ) =
                (recordExpressionBindings_ (_recordExpressionBindingsOclassname)
                                           (_recordExpressionBindingsOconstructors_collect)
                                           (_recordExpressionBindingsOconstructors_dist)
                                           (_recordExpressionBindingsOcurrentModule)
                                           (_recordExpressionBindingsOimportedModule)
                                           (_recordExpressionBindingsOinstancename)
                                           (_recordExpressionBindingsOknownGenerics)
                                           (_recordExpressionBindingsOknownKinds)
                                           (_recordExpressionBindingsOknownKinds_collect)
                                           (_recordExpressionBindingsOknownTypes)
                                           (_recordExpressionBindingsOknownTypes_collect)
                                           (_recordExpressionBindingsOknownValues)
                                           (_recordExpressionBindingsOknownValues_collect)
                                           (_recordExpressionBindingsOlabels_collect)
                                           (_recordExpressionBindingsOlabels_dist)
                                           (_recordExpressionBindingsOlocal)
                                           (_recordExpressionBindingsOmethods_collect)
                                           (_recordExpressionBindingsOmethods_dist)
                                           (_recordExpressionBindingsOmoduleTypes)
                                           (_recordExpressionBindingsOmoduleValues)
                                           (_recordExpressionBindingsOnameType)
                                           (_recordExpressionBindingsOtoplevel))
            -- "./NameTypes.inc.lag"(line 146, column 9)
            (_nameOnameType@_) =
                ref_Val
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _recordExpressionBindingsImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _recordExpressionBindingsIres
            -- self rule
            (_self@_) =
                Expression_RecordConstruction _rangeIself _nameIself _recordExpressionBindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _recordExpressionBindingsIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _recordExpressionBindingsIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _recordExpressionBindingsIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _recordExpressionBindingsIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _recordExpressionBindingsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _recordExpressionBindingsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _recordExpressionBindingsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _recordExpressionBindingsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_recordExpressionBindingsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_recordExpressionBindingsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_recordExpressionBindingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_recordExpressionBindingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_recordExpressionBindingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_recordExpressionBindingsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_recordExpressionBindingsOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_recordExpressionBindingsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_recordExpressionBindingsOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_recordExpressionBindingsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_recordExpressionBindingsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (down)
            (_recordExpressionBindingsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_recordExpressionBindingsOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_recordExpressionBindingsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_recordExpressionBindingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_recordExpressionBindingsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_recordExpressionBindingsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_recordExpressionBindingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_recordExpressionBindingsOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_recordExpressionBindingsOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_recordExpressionBindingsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_recordExpressionBindingsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Expression_RecordUpdate :: (T_Range) ->
                               (T_Expression) ->
                               (T_RecordExpressionBindings) ->
                               (T_Expression)
sem_Expression_RecordUpdate (range_) (expression_) (recordExpressionBindings_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIknownKinds_collect :: (FMap Name [Name])
            _expressionIknownTypes_collect :: (FMap Name [Name])
            _expressionIknownValues_collect :: (FMap Name [Name])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionImoduleTypes :: (FMap ModuleName [Name])
            _expressionImoduleValues :: (FMap ModuleName [Name])
            _expressionImodules :: (Set.Set Strings)
            _expressionIres :: ([ResolveResult])
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOknownGenerics :: (FMap Name [Name])
            _expressionOknownKinds :: (FMap Name [Name])
            _expressionOknownKinds_collect :: (FMap Name [Name])
            _expressionOknownTypes :: (FMap Name [Name])
            _expressionOknownTypes_collect :: (FMap Name [Name])
            _expressionOknownValues :: (FMap Name [Name])
            _expressionOknownValues_collect :: (FMap Name [Name])
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmoduleTypes :: (FMap ModuleName [Name])
            _expressionOmoduleValues :: (FMap ModuleName [Name])
            _expressionOnameType :: (NameType)
            _expressionOtoplevel :: (Bool)
            _recordExpressionBindingsIconstructors_collect :: (FMap Name Names)
            _recordExpressionBindingsIknownKinds_collect :: (FMap Name [Name])
            _recordExpressionBindingsIknownTypes_collect :: (FMap Name [Name])
            _recordExpressionBindingsIknownValues_collect :: (FMap Name [Name])
            _recordExpressionBindingsIlabels_collect :: (FMap Name Names)
            _recordExpressionBindingsImethods_collect :: (FMap Name Names)
            _recordExpressionBindingsImoduleTypes :: (FMap ModuleName [Name])
            _recordExpressionBindingsImoduleValues :: (FMap ModuleName [Name])
            _recordExpressionBindingsImodules :: (Set.Set Strings)
            _recordExpressionBindingsIres :: ([ResolveResult])
            _recordExpressionBindingsIself :: (RecordExpressionBindings)
            _recordExpressionBindingsOclassname :: (Maybe Name)
            _recordExpressionBindingsOconstructors_collect :: (FMap Name Names)
            _recordExpressionBindingsOconstructors_dist :: (FMap Name Names)
            _recordExpressionBindingsOcurrentModule :: (Strings)
            _recordExpressionBindingsOimportedModule :: (Bool)
            _recordExpressionBindingsOinstancename :: (Maybe Name)
            _recordExpressionBindingsOknownGenerics :: (FMap Name [Name])
            _recordExpressionBindingsOknownKinds :: (FMap Name [Name])
            _recordExpressionBindingsOknownKinds_collect :: (FMap Name [Name])
            _recordExpressionBindingsOknownTypes :: (FMap Name [Name])
            _recordExpressionBindingsOknownTypes_collect :: (FMap Name [Name])
            _recordExpressionBindingsOknownValues :: (FMap Name [Name])
            _recordExpressionBindingsOknownValues_collect :: (FMap Name [Name])
            _recordExpressionBindingsOlabels_collect :: (FMap Name Names)
            _recordExpressionBindingsOlabels_dist :: (FMap Name Names)
            _recordExpressionBindingsOlocal :: (Bool)
            _recordExpressionBindingsOmethods_collect :: (FMap Name Names)
            _recordExpressionBindingsOmethods_dist :: (FMap Name Names)
            _recordExpressionBindingsOmoduleTypes :: (FMap ModuleName [Name])
            _recordExpressionBindingsOmoduleValues :: (FMap ModuleName [Name])
            _recordExpressionBindingsOnameType :: (NameType)
            _recordExpressionBindingsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionIconstructors_collect,_expressionIknownKinds_collect,_expressionIknownTypes_collect,_expressionIknownValues_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionImoduleTypes,_expressionImoduleValues,_expressionImodules,_expressionIres,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOknownGenerics)
                             (_expressionOknownKinds)
                             (_expressionOknownKinds_collect)
                             (_expressionOknownTypes)
                             (_expressionOknownTypes_collect)
                             (_expressionOknownValues)
                             (_expressionOknownValues_collect)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmoduleTypes)
                             (_expressionOmoduleValues)
                             (_expressionOnameType)
                             (_expressionOtoplevel))
            ( _recordExpressionBindingsIconstructors_collect
             ,_recordExpressionBindingsIknownKinds_collect
             ,_recordExpressionBindingsIknownTypes_collect
             ,_recordExpressionBindingsIknownValues_collect
             ,_recordExpressionBindingsIlabels_collect
             ,_recordExpressionBindingsImethods_collect
             ,_recordExpressionBindingsImoduleTypes
             ,_recordExpressionBindingsImoduleValues
             ,_recordExpressionBindingsImodules
             ,_recordExpressionBindingsIres
             ,_recordExpressionBindingsIself
             ) =
                (recordExpressionBindings_ (_recordExpressionBindingsOclassname)
                                           (_recordExpressionBindingsOconstructors_collect)
                                           (_recordExpressionBindingsOconstructors_dist)
                                           (_recordExpressionBindingsOcurrentModule)
                                           (_recordExpressionBindingsOimportedModule)
                                           (_recordExpressionBindingsOinstancename)
                                           (_recordExpressionBindingsOknownGenerics)
                                           (_recordExpressionBindingsOknownKinds)
                                           (_recordExpressionBindingsOknownKinds_collect)
                                           (_recordExpressionBindingsOknownTypes)
                                           (_recordExpressionBindingsOknownTypes_collect)
                                           (_recordExpressionBindingsOknownValues)
                                           (_recordExpressionBindingsOknownValues_collect)
                                           (_recordExpressionBindingsOlabels_collect)
                                           (_recordExpressionBindingsOlabels_dist)
                                           (_recordExpressionBindingsOlocal)
                                           (_recordExpressionBindingsOmethods_collect)
                                           (_recordExpressionBindingsOmethods_dist)
                                           (_recordExpressionBindingsOmoduleTypes)
                                           (_recordExpressionBindingsOmoduleValues)
                                           (_recordExpressionBindingsOnameType)
                                           (_recordExpressionBindingsOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _expressionImodules `Set.union` _recordExpressionBindingsImodules
            -- use rule
            (_lhsOres@_) =
                _expressionIres ++ _recordExpressionBindingsIres
            -- self rule
            (_self@_) =
                Expression_RecordUpdate _rangeIself _expressionIself _recordExpressionBindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _recordExpressionBindingsIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _recordExpressionBindingsIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _recordExpressionBindingsIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _recordExpressionBindingsIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _recordExpressionBindingsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _recordExpressionBindingsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _recordExpressionBindingsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _recordExpressionBindingsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_expressionOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_expressionOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_expressionOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_expressionOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_expressionOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_expressionOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_expressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_expressionOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_expressionOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_recordExpressionBindingsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_recordExpressionBindingsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (down)
            (_recordExpressionBindingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_recordExpressionBindingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_recordExpressionBindingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_recordExpressionBindingsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_recordExpressionBindingsOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_recordExpressionBindingsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_recordExpressionBindingsOknownKinds_collect@_) =
                _expressionIknownKinds_collect
            -- copy rule (down)
            (_recordExpressionBindingsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_recordExpressionBindingsOknownTypes_collect@_) =
                _expressionIknownTypes_collect
            -- copy rule (down)
            (_recordExpressionBindingsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_recordExpressionBindingsOknownValues_collect@_) =
                _expressionIknownValues_collect
            -- copy rule (chain)
            (_recordExpressionBindingsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (down)
            (_recordExpressionBindingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_recordExpressionBindingsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_recordExpressionBindingsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (down)
            (_recordExpressionBindingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_recordExpressionBindingsOmoduleTypes@_) =
                _expressionImoduleTypes
            -- copy rule (chain)
            (_recordExpressionBindingsOmoduleValues@_) =
                _expressionImoduleValues
            -- copy rule (down)
            (_recordExpressionBindingsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_recordExpressionBindingsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Expression_Tuple :: (T_Range) ->
                        (T_Expressions) ->
                        (T_Expression)
sem_Expression_Tuple (range_) (expressions_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionsIconstructors_collect :: (FMap Name Names)
            _expressionsIknownKinds_collect :: (FMap Name [Name])
            _expressionsIknownTypes_collect :: (FMap Name [Name])
            _expressionsIknownValues_collect :: (FMap Name [Name])
            _expressionsIlabels_collect :: (FMap Name Names)
            _expressionsImethods_collect :: (FMap Name Names)
            _expressionsImoduleTypes :: (FMap ModuleName [Name])
            _expressionsImoduleValues :: (FMap ModuleName [Name])
            _expressionsImodules :: (Set.Set Strings)
            _expressionsIres :: ([ResolveResult])
            _expressionsIself :: (Expressions)
            _expressionsOclassname :: (Maybe Name)
            _expressionsOconstructors_collect :: (FMap Name Names)
            _expressionsOconstructors_dist :: (FMap Name Names)
            _expressionsOcurrentModule :: (Strings)
            _expressionsOimportedModule :: (Bool)
            _expressionsOinstancename :: (Maybe Name)
            _expressionsOknownGenerics :: (FMap Name [Name])
            _expressionsOknownKinds :: (FMap Name [Name])
            _expressionsOknownKinds_collect :: (FMap Name [Name])
            _expressionsOknownTypes :: (FMap Name [Name])
            _expressionsOknownTypes_collect :: (FMap Name [Name])
            _expressionsOknownValues :: (FMap Name [Name])
            _expressionsOknownValues_collect :: (FMap Name [Name])
            _expressionsOlabels_collect :: (FMap Name Names)
            _expressionsOlabels_dist :: (FMap Name Names)
            _expressionsOlocal :: (Bool)
            _expressionsOmethods_collect :: (FMap Name Names)
            _expressionsOmethods_dist :: (FMap Name Names)
            _expressionsOmoduleTypes :: (FMap ModuleName [Name])
            _expressionsOmoduleValues :: (FMap ModuleName [Name])
            _expressionsOnameType :: (NameType)
            _expressionsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionsIconstructors_collect,_expressionsIknownKinds_collect,_expressionsIknownTypes_collect,_expressionsIknownValues_collect,_expressionsIlabels_collect,_expressionsImethods_collect,_expressionsImoduleTypes,_expressionsImoduleValues,_expressionsImodules,_expressionsIres,_expressionsIself) =
                (expressions_ (_expressionsOclassname)
                              (_expressionsOconstructors_collect)
                              (_expressionsOconstructors_dist)
                              (_expressionsOcurrentModule)
                              (_expressionsOimportedModule)
                              (_expressionsOinstancename)
                              (_expressionsOknownGenerics)
                              (_expressionsOknownKinds)
                              (_expressionsOknownKinds_collect)
                              (_expressionsOknownTypes)
                              (_expressionsOknownTypes_collect)
                              (_expressionsOknownValues)
                              (_expressionsOknownValues_collect)
                              (_expressionsOlabels_collect)
                              (_expressionsOlabels_dist)
                              (_expressionsOlocal)
                              (_expressionsOmethods_collect)
                              (_expressionsOmethods_dist)
                              (_expressionsOmoduleTypes)
                              (_expressionsOmoduleValues)
                              (_expressionsOnameType)
                              (_expressionsOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _expressionsImodules
            -- use rule
            (_lhsOres@_) =
                _expressionsIres
            -- self rule
            (_self@_) =
                Expression_Tuple _rangeIself _expressionsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionsIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _expressionsIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _expressionsIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _expressionsIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _expressionsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _expressionsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionsOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_expressionsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_expressionsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_expressionsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_expressionsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_expressionsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_expressionsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_expressionsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_expressionsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_expressionsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_expressionsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Expression_TypeApplication :: (T_Range) ->
                                  (T_Name) ->
                                  (T_Type) ->
                                  (T_Expression)
sem_Expression_TypeApplication (range_) (name_) (type_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIknownKinds_collect :: (FMap Name [Name])
            _typeIknownTypes_collect :: (FMap Name [Name])
            _typeIknownValues_collect :: (FMap Name [Name])
            _typeIlabels_collect :: (FMap Name Names)
            _typeImethods_collect :: (FMap Name Names)
            _typeImoduleTypes :: (FMap ModuleName [Name])
            _typeImoduleValues :: (FMap ModuleName [Name])
            _typeImodules :: (Set.Set Strings)
            _typeIres :: ([ResolveResult])
            _typeIself :: (Type)
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOimportedModule :: (Bool)
            _typeOinstancename :: (Maybe Name)
            _typeOknownGenerics :: (FMap Name [Name])
            _typeOknownKinds :: (FMap Name [Name])
            _typeOknownKinds_collect :: (FMap Name [Name])
            _typeOknownTypes :: (FMap Name [Name])
            _typeOknownTypes_collect :: (FMap Name [Name])
            _typeOknownValues :: (FMap Name [Name])
            _typeOknownValues_collect :: (FMap Name [Name])
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOmoduleTypes :: (FMap ModuleName [Name])
            _typeOmoduleValues :: (FMap ModuleName [Name])
            _typeOnameType :: (NameType)
            _typeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _typeIconstructors_collect,_typeIknownKinds_collect,_typeIknownTypes_collect,_typeIknownValues_collect,_typeIlabels_collect,_typeImethods_collect,_typeImoduleTypes,_typeImoduleValues,_typeImodules,_typeIres,_typeIself) =
                (type_ (_typeOclassname)
                       (_typeOconstructors_collect)
                       (_typeOconstructors_dist)
                       (_typeOcurrentModule)
                       (_typeOimportedModule)
                       (_typeOinstancename)
                       (_typeOknownGenerics)
                       (_typeOknownKinds)
                       (_typeOknownKinds_collect)
                       (_typeOknownTypes)
                       (_typeOknownTypes_collect)
                       (_typeOknownValues)
                       (_typeOknownValues_collect)
                       (_typeOlabels_collect)
                       (_typeOlabels_dist)
                       (_typeOlocal)
                       (_typeOmethods_collect)
                       (_typeOmethods_dist)
                       (_typeOmoduleTypes)
                       (_typeOmoduleValues)
                       (_typeOnameType)
                       (_typeOtoplevel))
            -- "./NameTypes.inc.lag"(line 149, column 9)
            (_typeOnameType@_) =
                ref_Typ
            -- "./NameTypes.inc.lag"(line 148, column 9)
            (_nameOnameType@_) =
                ref_Val
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _typeImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _typeIres
            -- self rule
            (_self@_) =
                Expression_TypeApplication _rangeIself _nameIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _typeIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _typeIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _typeIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _typeImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _typeImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typeOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_typeOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_typeOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_typeOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_typeOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (down)
            (_typeOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_typeOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_typeOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_typeOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_typeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Expression_Typed :: (T_Range) ->
                        (T_Expression) ->
                        (T_Type) ->
                        (T_Expression)
sem_Expression_Typed (range_) (expression_) (type_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIknownKinds_collect :: (FMap Name [Name])
            _expressionIknownTypes_collect :: (FMap Name [Name])
            _expressionIknownValues_collect :: (FMap Name [Name])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionImoduleTypes :: (FMap ModuleName [Name])
            _expressionImoduleValues :: (FMap ModuleName [Name])
            _expressionImodules :: (Set.Set Strings)
            _expressionIres :: ([ResolveResult])
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOknownGenerics :: (FMap Name [Name])
            _expressionOknownKinds :: (FMap Name [Name])
            _expressionOknownKinds_collect :: (FMap Name [Name])
            _expressionOknownTypes :: (FMap Name [Name])
            _expressionOknownTypes_collect :: (FMap Name [Name])
            _expressionOknownValues :: (FMap Name [Name])
            _expressionOknownValues_collect :: (FMap Name [Name])
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmoduleTypes :: (FMap ModuleName [Name])
            _expressionOmoduleValues :: (FMap ModuleName [Name])
            _expressionOnameType :: (NameType)
            _expressionOtoplevel :: (Bool)
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIknownKinds_collect :: (FMap Name [Name])
            _typeIknownTypes_collect :: (FMap Name [Name])
            _typeIknownValues_collect :: (FMap Name [Name])
            _typeIlabels_collect :: (FMap Name Names)
            _typeImethods_collect :: (FMap Name Names)
            _typeImoduleTypes :: (FMap ModuleName [Name])
            _typeImoduleValues :: (FMap ModuleName [Name])
            _typeImodules :: (Set.Set Strings)
            _typeIres :: ([ResolveResult])
            _typeIself :: (Type)
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOimportedModule :: (Bool)
            _typeOinstancename :: (Maybe Name)
            _typeOknownGenerics :: (FMap Name [Name])
            _typeOknownKinds :: (FMap Name [Name])
            _typeOknownKinds_collect :: (FMap Name [Name])
            _typeOknownTypes :: (FMap Name [Name])
            _typeOknownTypes_collect :: (FMap Name [Name])
            _typeOknownValues :: (FMap Name [Name])
            _typeOknownValues_collect :: (FMap Name [Name])
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOmoduleTypes :: (FMap ModuleName [Name])
            _typeOmoduleValues :: (FMap ModuleName [Name])
            _typeOnameType :: (NameType)
            _typeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionIconstructors_collect,_expressionIknownKinds_collect,_expressionIknownTypes_collect,_expressionIknownValues_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionImoduleTypes,_expressionImoduleValues,_expressionImodules,_expressionIres,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOknownGenerics)
                             (_expressionOknownKinds)
                             (_expressionOknownKinds_collect)
                             (_expressionOknownTypes)
                             (_expressionOknownTypes_collect)
                             (_expressionOknownValues)
                             (_expressionOknownValues_collect)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmoduleTypes)
                             (_expressionOmoduleValues)
                             (_expressionOnameType)
                             (_expressionOtoplevel))
            ( _typeIconstructors_collect,_typeIknownKinds_collect,_typeIknownTypes_collect,_typeIknownValues_collect,_typeIlabels_collect,_typeImethods_collect,_typeImoduleTypes,_typeImoduleValues,_typeImodules,_typeIres,_typeIself) =
                (type_ (_typeOclassname)
                       (_typeOconstructors_collect)
                       (_typeOconstructors_dist)
                       (_typeOcurrentModule)
                       (_typeOimportedModule)
                       (_typeOinstancename)
                       (_typeOknownGenerics)
                       (_typeOknownKinds)
                       (_typeOknownKinds_collect)
                       (_typeOknownTypes)
                       (_typeOknownTypes_collect)
                       (_typeOknownValues)
                       (_typeOknownValues_collect)
                       (_typeOlabels_collect)
                       (_typeOlabels_dist)
                       (_typeOlocal)
                       (_typeOmethods_collect)
                       (_typeOmethods_dist)
                       (_typeOmoduleTypes)
                       (_typeOmoduleValues)
                       (_typeOnameType)
                       (_typeOtoplevel))
            -- "./NameTypes.inc.lag"(line 151, column 9)
            (_typeOnameType@_) =
                deforref_Typ
            -- use rule
            (_lhsOmodules@_) =
                _expressionImodules `Set.union` _typeImodules
            -- use rule
            (_lhsOres@_) =
                _expressionIres ++ _typeIres
            -- self rule
            (_self@_) =
                Expression_Typed _rangeIself _expressionIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _typeIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _typeIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _typeIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _typeImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _typeImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_expressionOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_expressionOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_expressionOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_expressionOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_expressionOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_expressionOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_expressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_expressionOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_expressionOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typeOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_typeOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_typeOknownKinds_collect@_) =
                _expressionIknownKinds_collect
            -- copy rule (down)
            (_typeOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_typeOknownTypes_collect@_) =
                _expressionIknownTypes_collect
            -- copy rule (down)
            (_typeOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_typeOknownValues_collect@_) =
                _expressionIknownValues_collect
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_typeOmoduleTypes@_) =
                _expressionImoduleTypes
            -- copy rule (chain)
            (_typeOmoduleValues@_) =
                _expressionImoduleValues
            -- copy rule (down)
            (_typeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Expression_Variable :: (T_Range) ->
                           (T_Name) ->
                           (T_Expression)
sem_Expression_Variable (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            -- "./NameTypes.inc.lag"(line 142, column 9)
            (_nameOnameType@_) =
                ref_Val
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres
            -- self rule
            (_self@_) =
                Expression_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Expression_Wildcard :: (T_Range) ->
                           (T_Expression)
sem_Expression_Wildcard (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                Expression_Wildcard _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- Expressions -------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for Expressions.Cons:
      self

-}
{-
   local variables for Expressions.Nil:
      self

-}
-- semantic domain
type T_Expressions = (Maybe Name) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Strings) ->
                     (Bool) ->
                     (Maybe Name) ->
                     (FMap Name [Name]) ->
                     (FMap Name [Name]) ->
                     (FMap Name [Name]) ->
                     (FMap Name [Name]) ->
                     (FMap Name [Name]) ->
                     (FMap Name [Name]) ->
                     (FMap Name [Name]) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Bool) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (FMap ModuleName [Name]) ->
                     (FMap ModuleName [Name]) ->
                     (NameType) ->
                     (Bool) ->
                     ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(Expressions))
-- cata
sem_Expressions :: (Expressions) ->
                   (T_Expressions)
sem_Expressions (list) =
    (foldr (sem_Expressions_Cons) (sem_Expressions_Nil) ((map sem_Expression list)))
sem_Expressions_Cons :: (T_Expression) ->
                        (T_Expressions) ->
                        (T_Expressions)
sem_Expressions_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Expressions)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIknownKinds_collect :: (FMap Name [Name])
            _hdIknownTypes_collect :: (FMap Name [Name])
            _hdIknownValues_collect :: (FMap Name [Name])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdImoduleTypes :: (FMap ModuleName [Name])
            _hdImoduleValues :: (FMap ModuleName [Name])
            _hdImodules :: (Set.Set Strings)
            _hdIres :: ([ResolveResult])
            _hdIself :: (Expression)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOknownGenerics :: (FMap Name [Name])
            _hdOknownKinds :: (FMap Name [Name])
            _hdOknownKinds_collect :: (FMap Name [Name])
            _hdOknownTypes :: (FMap Name [Name])
            _hdOknownTypes_collect :: (FMap Name [Name])
            _hdOknownValues :: (FMap Name [Name])
            _hdOknownValues_collect :: (FMap Name [Name])
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmoduleTypes :: (FMap ModuleName [Name])
            _hdOmoduleValues :: (FMap ModuleName [Name])
            _hdOnameType :: (NameType)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIknownKinds_collect :: (FMap Name [Name])
            _tlIknownTypes_collect :: (FMap Name [Name])
            _tlIknownValues_collect :: (FMap Name [Name])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlImoduleTypes :: (FMap ModuleName [Name])
            _tlImoduleValues :: (FMap ModuleName [Name])
            _tlImodules :: (Set.Set Strings)
            _tlIres :: ([ResolveResult])
            _tlIself :: (Expressions)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOknownGenerics :: (FMap Name [Name])
            _tlOknownKinds :: (FMap Name [Name])
            _tlOknownKinds_collect :: (FMap Name [Name])
            _tlOknownTypes :: (FMap Name [Name])
            _tlOknownTypes_collect :: (FMap Name [Name])
            _tlOknownValues :: (FMap Name [Name])
            _tlOknownValues_collect :: (FMap Name [Name])
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmoduleTypes :: (FMap ModuleName [Name])
            _tlOmoduleValues :: (FMap ModuleName [Name])
            _tlOnameType :: (NameType)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIknownKinds_collect,_hdIknownTypes_collect,_hdIknownValues_collect,_hdIlabels_collect,_hdImethods_collect,_hdImoduleTypes,_hdImoduleValues,_hdImodules,_hdIres,_hdIself) =
                (hd_ (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOknownGenerics)
                     (_hdOknownKinds)
                     (_hdOknownKinds_collect)
                     (_hdOknownTypes)
                     (_hdOknownTypes_collect)
                     (_hdOknownValues)
                     (_hdOknownValues_collect)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmoduleTypes)
                     (_hdOmoduleValues)
                     (_hdOnameType)
                     (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIknownKinds_collect,_tlIknownTypes_collect,_tlIknownValues_collect,_tlIlabels_collect,_tlImethods_collect,_tlImoduleTypes,_tlImoduleValues,_tlImodules,_tlIres,_tlIself) =
                (tl_ (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOknownGenerics)
                     (_tlOknownKinds)
                     (_tlOknownKinds_collect)
                     (_tlOknownTypes)
                     (_tlOknownTypes_collect)
                     (_tlOknownValues)
                     (_tlOknownValues_collect)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmoduleTypes)
                     (_tlOmoduleValues)
                     (_tlOnameType)
                     (_tlOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _hdImodules `Set.union` _tlImodules
            -- use rule
            (_lhsOres@_) =
                _hdIres ++ _tlIres
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _tlIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _tlIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _tlIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _tlImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _tlImoduleValues
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_hdOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_hdOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_hdOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_hdOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_hdOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_hdOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_hdOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_hdOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_tlOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_tlOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_tlOknownKinds_collect@_) =
                _hdIknownKinds_collect
            -- copy rule (down)
            (_tlOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_tlOknownTypes_collect@_) =
                _hdIknownTypes_collect
            -- copy rule (down)
            (_tlOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_tlOknownValues_collect@_) =
                _hdIknownValues_collect
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_tlOmoduleTypes@_) =
                _hdImoduleTypes
            -- copy rule (chain)
            (_tlOmoduleValues@_) =
                _hdImoduleValues
            -- copy rule (down)
            (_tlOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Expressions_Nil :: (T_Expressions)
sem_Expressions_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Expressions)
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- FieldDeclaration --------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      constructors         : Names
      labels               : Names
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for FieldDeclaration.FieldDeclaration:
      self

-}
-- semantic domain
type T_FieldDeclaration = (Maybe Name) ->
                          (FMap Name Names) ->
                          (FMap Name Names) ->
                          (Strings) ->
                          (Bool) ->
                          (Maybe Name) ->
                          (FMap Name [Name]) ->
                          (FMap Name [Name]) ->
                          (FMap Name [Name]) ->
                          (FMap Name [Name]) ->
                          (FMap Name [Name]) ->
                          (FMap Name [Name]) ->
                          (FMap Name [Name]) ->
                          (FMap Name Names) ->
                          (FMap Name Names) ->
                          (Bool) ->
                          (FMap Name Names) ->
                          (FMap Name Names) ->
                          (FMap ModuleName [Name]) ->
                          (FMap ModuleName [Name]) ->
                          (NameType) ->
                          (Bool) ->
                          ( (Names),(FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(Names),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(FieldDeclaration))
-- cata
sem_FieldDeclaration :: (FieldDeclaration) ->
                        (T_FieldDeclaration)
sem_FieldDeclaration ((FieldDeclaration_FieldDeclaration (_range) (_names) (_type))) =
    (sem_FieldDeclaration_FieldDeclaration ((sem_Range (_range))) ((sem_Names (_names))) ((sem_AnnotatedType (_type))))
sem_FieldDeclaration_FieldDeclaration :: (T_Range) ->
                                         (T_Names) ->
                                         (T_AnnotatedType) ->
                                         (T_FieldDeclaration)
sem_FieldDeclaration_FieldDeclaration (range_) (names_) (type_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors :: (Names)
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels :: (Names)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (FieldDeclaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _namesIconstructors_collect :: (FMap Name Names)
            _namesIknownKinds_collect :: (FMap Name [Name])
            _namesIknownTypes_collect :: (FMap Name [Name])
            _namesIknownValues_collect :: (FMap Name [Name])
            _namesIlabels_collect :: (FMap Name Names)
            _namesImethods_collect :: (FMap Name Names)
            _namesImoduleTypes :: (FMap ModuleName [Name])
            _namesImoduleValues :: (FMap ModuleName [Name])
            _namesImodules :: (Set.Set Strings)
            _namesIoriginalSelf :: (Names)
            _namesIres :: ([ResolveResult])
            _namesIself :: (Names)
            _namesOclassname :: (Maybe Name)
            _namesOconstructors_collect :: (FMap Name Names)
            _namesOconstructors_dist :: (FMap Name Names)
            _namesOcurrentModule :: (Strings)
            _namesOimportedModule :: (Bool)
            _namesOinstancename :: (Maybe Name)
            _namesOknownKinds :: (FMap Name [Name])
            _namesOknownKinds_collect :: (FMap Name [Name])
            _namesOknownTypes :: (FMap Name [Name])
            _namesOknownTypes_collect :: (FMap Name [Name])
            _namesOknownValues :: (FMap Name [Name])
            _namesOknownValues_collect :: (FMap Name [Name])
            _namesOlabels_collect :: (FMap Name Names)
            _namesOlabels_dist :: (FMap Name Names)
            _namesOlocal :: (Bool)
            _namesOmethods_collect :: (FMap Name Names)
            _namesOmethods_dist :: (FMap Name Names)
            _namesOmoduleTypes :: (FMap ModuleName [Name])
            _namesOmoduleValues :: (FMap ModuleName [Name])
            _namesOnameType :: (NameType)
            _namesOtoplevel :: (Bool)
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIknownKinds_collect :: (FMap Name [Name])
            _typeIknownTypes_collect :: (FMap Name [Name])
            _typeIknownValues_collect :: (FMap Name [Name])
            _typeIlabels_collect :: (FMap Name Names)
            _typeImethods_collect :: (FMap Name Names)
            _typeImoduleTypes :: (FMap ModuleName [Name])
            _typeImoduleValues :: (FMap ModuleName [Name])
            _typeImodules :: (Set.Set Strings)
            _typeIres :: ([ResolveResult])
            _typeIself :: (AnnotatedType)
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOimportedModule :: (Bool)
            _typeOinstancename :: (Maybe Name)
            _typeOknownGenerics :: (FMap Name [Name])
            _typeOknownKinds :: (FMap Name [Name])
            _typeOknownKinds_collect :: (FMap Name [Name])
            _typeOknownTypes :: (FMap Name [Name])
            _typeOknownTypes_collect :: (FMap Name [Name])
            _typeOknownValues :: (FMap Name [Name])
            _typeOknownValues_collect :: (FMap Name [Name])
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOmoduleTypes :: (FMap ModuleName [Name])
            _typeOmoduleValues :: (FMap ModuleName [Name])
            _typeOnameType :: (NameType)
            _typeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _namesIconstructors_collect,_namesIknownKinds_collect,_namesIknownTypes_collect,_namesIknownValues_collect,_namesIlabels_collect,_namesImethods_collect,_namesImoduleTypes,_namesImoduleValues,_namesImodules,_namesIoriginalSelf,_namesIres,_namesIself) =
                (names_ (_namesOclassname)
                        (_namesOconstructors_collect)
                        (_namesOconstructors_dist)
                        (_namesOcurrentModule)
                        (_namesOimportedModule)
                        (_namesOinstancename)
                        (_namesOknownKinds)
                        (_namesOknownKinds_collect)
                        (_namesOknownTypes)
                        (_namesOknownTypes_collect)
                        (_namesOknownValues)
                        (_namesOknownValues_collect)
                        (_namesOlabels_collect)
                        (_namesOlabels_dist)
                        (_namesOlocal)
                        (_namesOmethods_collect)
                        (_namesOmethods_dist)
                        (_namesOmoduleTypes)
                        (_namesOmoduleValues)
                        (_namesOnameType)
                        (_namesOtoplevel))
            ( _typeIconstructors_collect,_typeIknownKinds_collect,_typeIknownTypes_collect,_typeIknownValues_collect,_typeIlabels_collect,_typeImethods_collect,_typeImoduleTypes,_typeImoduleValues,_typeImodules,_typeIres,_typeIself) =
                (type_ (_typeOclassname)
                       (_typeOconstructors_collect)
                       (_typeOconstructors_dist)
                       (_typeOcurrentModule)
                       (_typeOimportedModule)
                       (_typeOinstancename)
                       (_typeOknownGenerics)
                       (_typeOknownKinds)
                       (_typeOknownKinds_collect)
                       (_typeOknownTypes)
                       (_typeOknownTypes_collect)
                       (_typeOknownValues)
                       (_typeOknownValues_collect)
                       (_typeOlabels_collect)
                       (_typeOlabels_dist)
                       (_typeOlocal)
                       (_typeOmethods_collect)
                       (_typeOmethods_dist)
                       (_typeOmoduleTypes)
                       (_typeOmoduleValues)
                       (_typeOnameType)
                       (_typeOtoplevel))
            -- "./NameTypes.inc.lag"(line 239, column 9)
            (_namesOnameType@_) =
                Def_Val
            -- "./ModuleInformation.inc.lag"(line 369, column 9)
            (_lhsOlabels@_) =
                _namesIself
            -- "./ModuleInformation.inc.lag"(line 368, column 9)
            (_lhsOconstructors@_) =
                _namesIself
            -- use rule
            (_lhsOmodules@_) =
                _namesImodules `Set.union` _typeImodules
            -- use rule
            (_lhsOres@_) =
                _namesIres ++ _typeIres
            -- self rule
            (_self@_) =
                FieldDeclaration_FieldDeclaration _rangeIself _namesIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _typeIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _typeIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _typeIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _typeImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _typeImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_namesOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_namesOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_namesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_namesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_namesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_namesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_namesOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_namesOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_namesOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_namesOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_namesOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_namesOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_namesOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_namesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_namesOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_namesOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_namesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_namesOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_namesOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_namesOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _namesIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typeOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_typeOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_typeOknownKinds_collect@_) =
                _namesIknownKinds_collect
            -- copy rule (down)
            (_typeOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_typeOknownTypes_collect@_) =
                _namesIknownTypes_collect
            -- copy rule (down)
            (_typeOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_typeOknownValues_collect@_) =
                _namesIknownValues_collect
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _namesIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _namesImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_typeOmoduleTypes@_) =
                _namesImoduleTypes
            -- copy rule (chain)
            (_typeOmoduleValues@_) =
                _namesImoduleValues
            -- copy rule (down)
            (_typeOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_typeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors,_lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- FieldDeclarations -------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      constructors         : Names
      labels               : Names
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for FieldDeclarations.Cons:
      self

-}
{-
   local variables for FieldDeclarations.Nil:
      self

-}
-- semantic domain
type T_FieldDeclarations = (Maybe Name) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Strings) ->
                           (Bool) ->
                           (Maybe Name) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Bool) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (FMap ModuleName [Name]) ->
                           (FMap ModuleName [Name]) ->
                           (NameType) ->
                           (Bool) ->
                           ( (Names),(FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(Names),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(FieldDeclarations))
-- cata
sem_FieldDeclarations :: (FieldDeclarations) ->
                         (T_FieldDeclarations)
sem_FieldDeclarations (list) =
    (foldr (sem_FieldDeclarations_Cons) (sem_FieldDeclarations_Nil) ((map sem_FieldDeclaration list)))
sem_FieldDeclarations_Cons :: (T_FieldDeclaration) ->
                              (T_FieldDeclarations) ->
                              (T_FieldDeclarations)
sem_FieldDeclarations_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors :: (Names)
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels :: (Names)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (FieldDeclarations)
            _hdIconstructors :: (Names)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIknownKinds_collect :: (FMap Name [Name])
            _hdIknownTypes_collect :: (FMap Name [Name])
            _hdIknownValues_collect :: (FMap Name [Name])
            _hdIlabels :: (Names)
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdImoduleTypes :: (FMap ModuleName [Name])
            _hdImoduleValues :: (FMap ModuleName [Name])
            _hdImodules :: (Set.Set Strings)
            _hdIres :: ([ResolveResult])
            _hdIself :: (FieldDeclaration)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOknownGenerics :: (FMap Name [Name])
            _hdOknownKinds :: (FMap Name [Name])
            _hdOknownKinds_collect :: (FMap Name [Name])
            _hdOknownTypes :: (FMap Name [Name])
            _hdOknownTypes_collect :: (FMap Name [Name])
            _hdOknownValues :: (FMap Name [Name])
            _hdOknownValues_collect :: (FMap Name [Name])
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmoduleTypes :: (FMap ModuleName [Name])
            _hdOmoduleValues :: (FMap ModuleName [Name])
            _hdOnameType :: (NameType)
            _hdOtoplevel :: (Bool)
            _tlIconstructors :: (Names)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIknownKinds_collect :: (FMap Name [Name])
            _tlIknownTypes_collect :: (FMap Name [Name])
            _tlIknownValues_collect :: (FMap Name [Name])
            _tlIlabels :: (Names)
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlImoduleTypes :: (FMap ModuleName [Name])
            _tlImoduleValues :: (FMap ModuleName [Name])
            _tlImodules :: (Set.Set Strings)
            _tlIres :: ([ResolveResult])
            _tlIself :: (FieldDeclarations)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOknownGenerics :: (FMap Name [Name])
            _tlOknownKinds :: (FMap Name [Name])
            _tlOknownKinds_collect :: (FMap Name [Name])
            _tlOknownTypes :: (FMap Name [Name])
            _tlOknownTypes_collect :: (FMap Name [Name])
            _tlOknownValues :: (FMap Name [Name])
            _tlOknownValues_collect :: (FMap Name [Name])
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmoduleTypes :: (FMap ModuleName [Name])
            _tlOmoduleValues :: (FMap ModuleName [Name])
            _tlOnameType :: (NameType)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors,_hdIconstructors_collect,_hdIknownKinds_collect,_hdIknownTypes_collect,_hdIknownValues_collect,_hdIlabels,_hdIlabels_collect,_hdImethods_collect,_hdImoduleTypes,_hdImoduleValues,_hdImodules,_hdIres,_hdIself) =
                (hd_ (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOknownGenerics)
                     (_hdOknownKinds)
                     (_hdOknownKinds_collect)
                     (_hdOknownTypes)
                     (_hdOknownTypes_collect)
                     (_hdOknownValues)
                     (_hdOknownValues_collect)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmoduleTypes)
                     (_hdOmoduleValues)
                     (_hdOnameType)
                     (_hdOtoplevel))
            ( _tlIconstructors,_tlIconstructors_collect,_tlIknownKinds_collect,_tlIknownTypes_collect,_tlIknownValues_collect,_tlIlabels,_tlIlabels_collect,_tlImethods_collect,_tlImoduleTypes,_tlImoduleValues,_tlImodules,_tlIres,_tlIself) =
                (tl_ (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOknownGenerics)
                     (_tlOknownKinds)
                     (_tlOknownKinds_collect)
                     (_tlOknownTypes)
                     (_tlOknownTypes_collect)
                     (_tlOknownValues)
                     (_tlOknownValues_collect)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmoduleTypes)
                     (_tlOmoduleValues)
                     (_tlOnameType)
                     (_tlOtoplevel))
            -- use rule
            (_lhsOconstructors@_) =
                _hdIconstructors ++ _tlIconstructors
            -- use rule
            (_lhsOlabels@_) =
                _hdIlabels `List.union` _tlIlabels
            -- use rule
            (_lhsOmodules@_) =
                _hdImodules `Set.union` _tlImodules
            -- use rule
            (_lhsOres@_) =
                _hdIres ++ _tlIres
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _tlIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _tlIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _tlIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _tlImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _tlImoduleValues
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_hdOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_hdOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_hdOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_hdOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_hdOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_hdOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_hdOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_hdOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_tlOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_tlOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_tlOknownKinds_collect@_) =
                _hdIknownKinds_collect
            -- copy rule (down)
            (_tlOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_tlOknownTypes_collect@_) =
                _hdIknownTypes_collect
            -- copy rule (down)
            (_tlOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_tlOknownValues_collect@_) =
                _hdIknownValues_collect
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_tlOmoduleTypes@_) =
                _hdImoduleTypes
            -- copy rule (chain)
            (_tlOmoduleValues@_) =
                _hdImoduleValues
            -- copy rule (down)
            (_tlOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors,_lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_FieldDeclarations_Nil :: (T_FieldDeclarations)
sem_FieldDeclarations_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors :: (Names)
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels :: (Names)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (FieldDeclarations)
            -- use rule
            (_lhsOconstructors@_) =
                []
            -- use rule
            (_lhsOlabels@_) =
                []
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors,_lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- Fixity ------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for Fixity.Infix:
      self

-}
{-
   local variables for Fixity.Infixl:
      self

-}
{-
   local variables for Fixity.Infixr:
      self

-}
-- semantic domain
type T_Fixity = (Maybe Name) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (Strings) ->
                (Bool) ->
                (Maybe Name) ->
                (FMap Name [Name]) ->
                (FMap Name [Name]) ->
                (FMap Name [Name]) ->
                (FMap Name [Name]) ->
                (FMap Name [Name]) ->
                (FMap Name [Name]) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (Bool) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (FMap ModuleName [Name]) ->
                (FMap ModuleName [Name]) ->
                (NameType) ->
                (Bool) ->
                ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(Fixity))
-- cata
sem_Fixity :: (Fixity) ->
              (T_Fixity)
sem_Fixity ((Fixity_Infix (_range))) =
    (sem_Fixity_Infix ((sem_Range (_range))))
sem_Fixity ((Fixity_Infixl (_range))) =
    (sem_Fixity_Infixl ((sem_Range (_range))))
sem_Fixity ((Fixity_Infixr (_range))) =
    (sem_Fixity_Infixr ((sem_Range (_range))))
sem_Fixity_Infix :: (T_Range) ->
                    (T_Fixity)
sem_Fixity_Infix (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Fixity)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                Fixity_Infix _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Fixity_Infixl :: (T_Range) ->
                     (T_Fixity)
sem_Fixity_Infixl (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Fixity)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                Fixity_Infixl _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Fixity_Infixr :: (T_Range) ->
                     (T_Fixity)
sem_Fixity_Infixr (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Fixity)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                Fixity_Infixr _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- FunctionBinding ---------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      name                 : Name
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for FunctionBinding.FunctionBinding:
      knownValues
      self

-}
-- semantic domain
type T_FunctionBinding = (Maybe Name) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (Strings) ->
                         (Bool) ->
                         (Maybe Name) ->
                         (FMap Name [Name]) ->
                         (FMap Name [Name]) ->
                         (FMap Name [Name]) ->
                         (FMap Name [Name]) ->
                         (FMap Name [Name]) ->
                         (FMap Name [Name]) ->
                         (FMap Name [Name]) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (Bool) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (FMap ModuleName [Name]) ->
                         (FMap ModuleName [Name]) ->
                         (NameType) ->
                         (Bool) ->
                         ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),(Name),([ResolveResult]),(FunctionBinding))
-- cata
sem_FunctionBinding :: (FunctionBinding) ->
                       (T_FunctionBinding)
sem_FunctionBinding ((FunctionBinding_FunctionBinding (_range) (_lefthandside) (_righthandside))) =
    (sem_FunctionBinding_FunctionBinding ((sem_Range (_range))) ((sem_LeftHandSide (_lefthandside))) ((sem_RightHandSide (_righthandside))))
sem_FunctionBinding_FunctionBinding :: (T_Range) ->
                                       (T_LeftHandSide) ->
                                       (T_RightHandSide) ->
                                       (T_FunctionBinding)
sem_FunctionBinding_FunctionBinding (range_) (lefthandside_) (righthandside_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOname :: (Name)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (FunctionBinding)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _lefthandsideIconstructors_collect :: (FMap Name Names)
            _lefthandsideIknownKinds_collect :: (FMap Name [Name])
            _lefthandsideIknownTypes_collect :: (FMap Name [Name])
            _lefthandsideIknownValuesForBody_collect :: (FMap Name [Name])
            _lefthandsideIknownValues_collect :: (FMap Name [Name])
            _lefthandsideIlabels_collect :: (FMap Name Names)
            _lefthandsideImethods_collect :: (FMap Name Names)
            _lefthandsideImoduleTypes :: (FMap ModuleName [Name])
            _lefthandsideImoduleValues :: (FMap ModuleName [Name])
            _lefthandsideImodules :: (Set.Set Strings)
            _lefthandsideIname :: (Name)
            _lefthandsideIres :: ([ResolveResult])
            _lefthandsideIself :: (LeftHandSide)
            _lefthandsideOclassname :: (Maybe Name)
            _lefthandsideOconstructors_collect :: (FMap Name Names)
            _lefthandsideOconstructors_dist :: (FMap Name Names)
            _lefthandsideOcurrentModule :: (Strings)
            _lefthandsideOimportedModule :: (Bool)
            _lefthandsideOinstancename :: (Maybe Name)
            _lefthandsideOknownKinds :: (FMap Name [Name])
            _lefthandsideOknownKinds_collect :: (FMap Name [Name])
            _lefthandsideOknownTypes :: (FMap Name [Name])
            _lefthandsideOknownTypes_collect :: (FMap Name [Name])
            _lefthandsideOknownValues :: (FMap Name [Name])
            _lefthandsideOknownValuesForBody_collect :: (FMap Name [Name])
            _lefthandsideOknownValues_collect :: (FMap Name [Name])
            _lefthandsideOlabels_collect :: (FMap Name Names)
            _lefthandsideOlabels_dist :: (FMap Name Names)
            _lefthandsideOlocal :: (Bool)
            _lefthandsideOmethods_collect :: (FMap Name Names)
            _lefthandsideOmethods_dist :: (FMap Name Names)
            _lefthandsideOmoduleTypes :: (FMap ModuleName [Name])
            _lefthandsideOmoduleValues :: (FMap ModuleName [Name])
            _lefthandsideOnameType :: (NameType)
            _lefthandsideOtoplevel :: (Bool)
            _righthandsideIconstructors_collect :: (FMap Name Names)
            _righthandsideIknownKinds_collect :: (FMap Name [Name])
            _righthandsideIknownTypes_collect :: (FMap Name [Name])
            _righthandsideIknownValues_collect :: (FMap Name [Name])
            _righthandsideIlabels_collect :: (FMap Name Names)
            _righthandsideImethods_collect :: (FMap Name Names)
            _righthandsideImoduleTypes :: (FMap ModuleName [Name])
            _righthandsideImoduleValues :: (FMap ModuleName [Name])
            _righthandsideImodules :: (Set.Set Strings)
            _righthandsideIres :: ([ResolveResult])
            _righthandsideIself :: (RightHandSide)
            _righthandsideOclassname :: (Maybe Name)
            _righthandsideOconstructors_collect :: (FMap Name Names)
            _righthandsideOconstructors_dist :: (FMap Name Names)
            _righthandsideOcurrentModule :: (Strings)
            _righthandsideOimportedModule :: (Bool)
            _righthandsideOinstancename :: (Maybe Name)
            _righthandsideOknownGenerics :: (FMap Name [Name])
            _righthandsideOknownKinds :: (FMap Name [Name])
            _righthandsideOknownKinds_collect :: (FMap Name [Name])
            _righthandsideOknownTypes :: (FMap Name [Name])
            _righthandsideOknownTypes_collect :: (FMap Name [Name])
            _righthandsideOknownValues :: (FMap Name [Name])
            _righthandsideOknownValues_collect :: (FMap Name [Name])
            _righthandsideOlabels_collect :: (FMap Name Names)
            _righthandsideOlabels_dist :: (FMap Name Names)
            _righthandsideOlocal :: (Bool)
            _righthandsideOmethods_collect :: (FMap Name Names)
            _righthandsideOmethods_dist :: (FMap Name Names)
            _righthandsideOmoduleTypes :: (FMap ModuleName [Name])
            _righthandsideOmoduleValues :: (FMap ModuleName [Name])
            _righthandsideOnameType :: (NameType)
            _righthandsideOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _lefthandsideIconstructors_collect,_lefthandsideIknownKinds_collect,_lefthandsideIknownTypes_collect,_lefthandsideIknownValuesForBody_collect,_lefthandsideIknownValues_collect,_lefthandsideIlabels_collect,_lefthandsideImethods_collect,_lefthandsideImoduleTypes,_lefthandsideImoduleValues,_lefthandsideImodules,_lefthandsideIname,_lefthandsideIres,_lefthandsideIself) =
                (lefthandside_ (_lefthandsideOclassname)
                               (_lefthandsideOconstructors_collect)
                               (_lefthandsideOconstructors_dist)
                               (_lefthandsideOcurrentModule)
                               (_lefthandsideOimportedModule)
                               (_lefthandsideOinstancename)
                               (_lefthandsideOknownKinds)
                               (_lefthandsideOknownKinds_collect)
                               (_lefthandsideOknownTypes)
                               (_lefthandsideOknownTypes_collect)
                               (_lefthandsideOknownValues)
                               (_lefthandsideOknownValuesForBody_collect)
                               (_lefthandsideOknownValues_collect)
                               (_lefthandsideOlabels_collect)
                               (_lefthandsideOlabels_dist)
                               (_lefthandsideOlocal)
                               (_lefthandsideOmethods_collect)
                               (_lefthandsideOmethods_dist)
                               (_lefthandsideOmoduleTypes)
                               (_lefthandsideOmoduleValues)
                               (_lefthandsideOnameType)
                               (_lefthandsideOtoplevel))
            ( _righthandsideIconstructors_collect,_righthandsideIknownKinds_collect,_righthandsideIknownTypes_collect,_righthandsideIknownValues_collect,_righthandsideIlabels_collect,_righthandsideImethods_collect,_righthandsideImoduleTypes,_righthandsideImoduleValues,_righthandsideImodules,_righthandsideIres,_righthandsideIself) =
                (righthandside_ (_righthandsideOclassname)
                                (_righthandsideOconstructors_collect)
                                (_righthandsideOconstructors_dist)
                                (_righthandsideOcurrentModule)
                                (_righthandsideOimportedModule)
                                (_righthandsideOinstancename)
                                (_righthandsideOknownGenerics)
                                (_righthandsideOknownKinds)
                                (_righthandsideOknownKinds_collect)
                                (_righthandsideOknownTypes)
                                (_righthandsideOknownTypes_collect)
                                (_righthandsideOknownValues)
                                (_righthandsideOknownValues_collect)
                                (_righthandsideOlabels_collect)
                                (_righthandsideOlabels_dist)
                                (_righthandsideOlocal)
                                (_righthandsideOmethods_collect)
                                (_righthandsideOmethods_dist)
                                (_righthandsideOmoduleTypes)
                                (_righthandsideOmoduleValues)
                                (_righthandsideOnameType)
                                (_righthandsideOtoplevel))
            -- "./Names.inc.lag"(line 680, column 9)
            (_lhsOknownValues_collect@_) =
                _lefthandsideIknownValues_collect
            -- "./Names.inc.lag"(line 679, column 9)
            (_knownValues@_) =
                _lefthandsideIknownValuesForBody_collect `mergeFM` _lhsIknownValues
            -- "./Names.inc.lag"(line 678, column 9)
            (_lefthandsideOknownValuesForBody_collect@_) =
                emptyFM
            -- "./ModuleInformation.inc.lag"(line 166, column 8)
            (_righthandsideOtoplevel@_) =
                False
            -- use rule
            (_lhsOmodules@_) =
                _lefthandsideImodules `Set.union` _righthandsideImodules
            -- use rule
            (_lhsOres@_) =
                _lefthandsideIres ++ _righthandsideIres
            -- self rule
            (_self@_) =
                FunctionBinding_FunctionBinding _rangeIself _lefthandsideIself _righthandsideIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _righthandsideIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _righthandsideIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _righthandsideIknownTypes_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _righthandsideIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _righthandsideImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _righthandsideImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _righthandsideImoduleValues
            -- copy rule (up)
            (_lhsOname@_) =
                _lefthandsideIname
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_lefthandsideOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_lefthandsideOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_lefthandsideOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_lefthandsideOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_lefthandsideOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_lefthandsideOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_lefthandsideOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_lefthandsideOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_lefthandsideOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_lefthandsideOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lefthandsideOknownValues@_) =
                _knownValues
            -- copy rule (down)
            (_lefthandsideOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_lefthandsideOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_lefthandsideOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_lefthandsideOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_lefthandsideOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_lefthandsideOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_lefthandsideOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_lefthandsideOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_lefthandsideOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_lefthandsideOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_righthandsideOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_righthandsideOconstructors_collect@_) =
                _lefthandsideIconstructors_collect
            -- copy rule (down)
            (_righthandsideOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_righthandsideOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_righthandsideOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_righthandsideOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_righthandsideOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_righthandsideOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_righthandsideOknownKinds_collect@_) =
                _lefthandsideIknownKinds_collect
            -- copy rule (down)
            (_righthandsideOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_righthandsideOknownTypes_collect@_) =
                _lefthandsideIknownTypes_collect
            -- copy rule (chain)
            (_righthandsideOknownValues@_) =
                _knownValues
            -- copy rule (chain)
            (_righthandsideOknownValues_collect@_) =
                _lefthandsideIknownValues_collect
            -- copy rule (chain)
            (_righthandsideOlabels_collect@_) =
                _lefthandsideIlabels_collect
            -- copy rule (down)
            (_righthandsideOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_righthandsideOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_righthandsideOmethods_collect@_) =
                _lefthandsideImethods_collect
            -- copy rule (down)
            (_righthandsideOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_righthandsideOmoduleTypes@_) =
                _lefthandsideImoduleTypes
            -- copy rule (chain)
            (_righthandsideOmoduleValues@_) =
                _lefthandsideImoduleValues
            -- copy rule (down)
            (_righthandsideOnameType@_) =
                _lhsInameType
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOname,_lhsOres,_lhsOself)
-- FunctionBindings --------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      name                 : Name
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for FunctionBindings.Cons:
      self

-}
{-
   local variables for FunctionBindings.Nil:
      self

-}
-- semantic domain
type T_FunctionBindings = (Maybe Name) ->
                          (FMap Name Names) ->
                          (FMap Name Names) ->
                          (Strings) ->
                          (Bool) ->
                          (Maybe Name) ->
                          (FMap Name [Name]) ->
                          (FMap Name [Name]) ->
                          (FMap Name [Name]) ->
                          (FMap Name [Name]) ->
                          (FMap Name [Name]) ->
                          (FMap Name [Name]) ->
                          (FMap Name [Name]) ->
                          (FMap Name Names) ->
                          (FMap Name Names) ->
                          (Bool) ->
                          (FMap Name Names) ->
                          (FMap Name Names) ->
                          (FMap ModuleName [Name]) ->
                          (FMap ModuleName [Name]) ->
                          (NameType) ->
                          (Bool) ->
                          ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),(Name),([ResolveResult]),(FunctionBindings))
-- cata
sem_FunctionBindings :: (FunctionBindings) ->
                        (T_FunctionBindings)
sem_FunctionBindings (list) =
    (foldr (sem_FunctionBindings_Cons) (sem_FunctionBindings_Nil) ((map sem_FunctionBinding list)))
sem_FunctionBindings_Cons :: (T_FunctionBinding) ->
                             (T_FunctionBindings) ->
                             (T_FunctionBindings)
sem_FunctionBindings_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOname :: (Name)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (FunctionBindings)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIknownKinds_collect :: (FMap Name [Name])
            _hdIknownTypes_collect :: (FMap Name [Name])
            _hdIknownValues_collect :: (FMap Name [Name])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdImoduleTypes :: (FMap ModuleName [Name])
            _hdImoduleValues :: (FMap ModuleName [Name])
            _hdImodules :: (Set.Set Strings)
            _hdIname :: (Name)
            _hdIres :: ([ResolveResult])
            _hdIself :: (FunctionBinding)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOknownGenerics :: (FMap Name [Name])
            _hdOknownKinds :: (FMap Name [Name])
            _hdOknownKinds_collect :: (FMap Name [Name])
            _hdOknownTypes :: (FMap Name [Name])
            _hdOknownTypes_collect :: (FMap Name [Name])
            _hdOknownValues :: (FMap Name [Name])
            _hdOknownValues_collect :: (FMap Name [Name])
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmoduleTypes :: (FMap ModuleName [Name])
            _hdOmoduleValues :: (FMap ModuleName [Name])
            _hdOnameType :: (NameType)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIknownKinds_collect :: (FMap Name [Name])
            _tlIknownTypes_collect :: (FMap Name [Name])
            _tlIknownValues_collect :: (FMap Name [Name])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlImoduleTypes :: (FMap ModuleName [Name])
            _tlImoduleValues :: (FMap ModuleName [Name])
            _tlImodules :: (Set.Set Strings)
            _tlIname :: (Name)
            _tlIres :: ([ResolveResult])
            _tlIself :: (FunctionBindings)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOknownGenerics :: (FMap Name [Name])
            _tlOknownKinds :: (FMap Name [Name])
            _tlOknownKinds_collect :: (FMap Name [Name])
            _tlOknownTypes :: (FMap Name [Name])
            _tlOknownTypes_collect :: (FMap Name [Name])
            _tlOknownValues :: (FMap Name [Name])
            _tlOknownValues_collect :: (FMap Name [Name])
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmoduleTypes :: (FMap ModuleName [Name])
            _tlOmoduleValues :: (FMap ModuleName [Name])
            _tlOnameType :: (NameType)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIknownKinds_collect,_hdIknownTypes_collect,_hdIknownValues_collect,_hdIlabels_collect,_hdImethods_collect,_hdImoduleTypes,_hdImoduleValues,_hdImodules,_hdIname,_hdIres,_hdIself) =
                (hd_ (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOknownGenerics)
                     (_hdOknownKinds)
                     (_hdOknownKinds_collect)
                     (_hdOknownTypes)
                     (_hdOknownTypes_collect)
                     (_hdOknownValues)
                     (_hdOknownValues_collect)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmoduleTypes)
                     (_hdOmoduleValues)
                     (_hdOnameType)
                     (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIknownKinds_collect,_tlIknownTypes_collect,_tlIknownValues_collect,_tlIlabels_collect,_tlImethods_collect,_tlImoduleTypes,_tlImoduleValues,_tlImodules,_tlIname,_tlIres,_tlIself) =
                (tl_ (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOknownGenerics)
                     (_tlOknownKinds)
                     (_tlOknownKinds_collect)
                     (_tlOknownTypes)
                     (_tlOknownTypes_collect)
                     (_tlOknownValues)
                     (_tlOknownValues_collect)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmoduleTypes)
                     (_tlOmoduleValues)
                     (_tlOnameType)
                     (_tlOtoplevel))
            -- "./NameTypes.inc.lag"(line 274, column 9)
            (_tlOnameType@_) =
                softref_Val
            -- "./ModuleInformation.inc.lag"(line 397, column 9)
            (_lhsOname@_) =
                _hdIname
            -- use rule
            (_lhsOmodules@_) =
                _hdImodules `Set.union` _tlImodules
            -- use rule
            (_lhsOres@_) =
                _hdIres ++ _tlIres
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _tlIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _tlIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _tlIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _tlImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _tlImoduleValues
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_hdOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_hdOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_hdOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_hdOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_hdOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_hdOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_hdOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_hdOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_tlOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_tlOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_tlOknownKinds_collect@_) =
                _hdIknownKinds_collect
            -- copy rule (down)
            (_tlOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_tlOknownTypes_collect@_) =
                _hdIknownTypes_collect
            -- copy rule (down)
            (_tlOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_tlOknownValues_collect@_) =
                _hdIknownValues_collect
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_tlOmoduleTypes@_) =
                _hdImoduleTypes
            -- copy rule (chain)
            (_tlOmoduleValues@_) =
                _hdImoduleValues
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOname,_lhsOres,_lhsOself)
sem_FunctionBindings_Nil :: (T_FunctionBindings)
sem_FunctionBindings_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOname :: (Name)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (FunctionBindings)
            -- "./ModuleInformation.inc.lag"(line 399, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.FunctionBindings.Nil.lhs.name: no bindings"
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOname,_lhsOres,_lhsOself)
-- GuardedExpression -------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for GuardedExpression.GuardedExpression:
      self

-}
-- semantic domain
type T_GuardedExpression = (Maybe Name) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Strings) ->
                           (Bool) ->
                           (Maybe Name) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Bool) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (FMap ModuleName [Name]) ->
                           (FMap ModuleName [Name]) ->
                           (NameType) ->
                           (Bool) ->
                           ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(GuardedExpression))
-- cata
sem_GuardedExpression :: (GuardedExpression) ->
                         (T_GuardedExpression)
sem_GuardedExpression ((GuardedExpression_GuardedExpression (_range) (_guard) (_expression))) =
    (sem_GuardedExpression_GuardedExpression ((sem_Range (_range))) ((sem_Expression (_guard))) ((sem_Expression (_expression))))
sem_GuardedExpression_GuardedExpression :: (T_Range) ->
                                           (T_Expression) ->
                                           (T_Expression) ->
                                           (T_GuardedExpression)
sem_GuardedExpression_GuardedExpression (range_) (guard_) (expression_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (GuardedExpression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _guardIconstructors_collect :: (FMap Name Names)
            _guardIknownKinds_collect :: (FMap Name [Name])
            _guardIknownTypes_collect :: (FMap Name [Name])
            _guardIknownValues_collect :: (FMap Name [Name])
            _guardIlabels_collect :: (FMap Name Names)
            _guardImethods_collect :: (FMap Name Names)
            _guardImoduleTypes :: (FMap ModuleName [Name])
            _guardImoduleValues :: (FMap ModuleName [Name])
            _guardImodules :: (Set.Set Strings)
            _guardIres :: ([ResolveResult])
            _guardIself :: (Expression)
            _guardOclassname :: (Maybe Name)
            _guardOconstructors_collect :: (FMap Name Names)
            _guardOconstructors_dist :: (FMap Name Names)
            _guardOcurrentModule :: (Strings)
            _guardOimportedModule :: (Bool)
            _guardOinstancename :: (Maybe Name)
            _guardOknownGenerics :: (FMap Name [Name])
            _guardOknownKinds :: (FMap Name [Name])
            _guardOknownKinds_collect :: (FMap Name [Name])
            _guardOknownTypes :: (FMap Name [Name])
            _guardOknownTypes_collect :: (FMap Name [Name])
            _guardOknownValues :: (FMap Name [Name])
            _guardOknownValues_collect :: (FMap Name [Name])
            _guardOlabels_collect :: (FMap Name Names)
            _guardOlabels_dist :: (FMap Name Names)
            _guardOlocal :: (Bool)
            _guardOmethods_collect :: (FMap Name Names)
            _guardOmethods_dist :: (FMap Name Names)
            _guardOmoduleTypes :: (FMap ModuleName [Name])
            _guardOmoduleValues :: (FMap ModuleName [Name])
            _guardOnameType :: (NameType)
            _guardOtoplevel :: (Bool)
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIknownKinds_collect :: (FMap Name [Name])
            _expressionIknownTypes_collect :: (FMap Name [Name])
            _expressionIknownValues_collect :: (FMap Name [Name])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionImoduleTypes :: (FMap ModuleName [Name])
            _expressionImoduleValues :: (FMap ModuleName [Name])
            _expressionImodules :: (Set.Set Strings)
            _expressionIres :: ([ResolveResult])
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOknownGenerics :: (FMap Name [Name])
            _expressionOknownKinds :: (FMap Name [Name])
            _expressionOknownKinds_collect :: (FMap Name [Name])
            _expressionOknownTypes :: (FMap Name [Name])
            _expressionOknownTypes_collect :: (FMap Name [Name])
            _expressionOknownValues :: (FMap Name [Name])
            _expressionOknownValues_collect :: (FMap Name [Name])
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmoduleTypes :: (FMap ModuleName [Name])
            _expressionOmoduleValues :: (FMap ModuleName [Name])
            _expressionOnameType :: (NameType)
            _expressionOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _guardIconstructors_collect,_guardIknownKinds_collect,_guardIknownTypes_collect,_guardIknownValues_collect,_guardIlabels_collect,_guardImethods_collect,_guardImoduleTypes,_guardImoduleValues,_guardImodules,_guardIres,_guardIself) =
                (guard_ (_guardOclassname)
                        (_guardOconstructors_collect)
                        (_guardOconstructors_dist)
                        (_guardOcurrentModule)
                        (_guardOimportedModule)
                        (_guardOinstancename)
                        (_guardOknownGenerics)
                        (_guardOknownKinds)
                        (_guardOknownKinds_collect)
                        (_guardOknownTypes)
                        (_guardOknownTypes_collect)
                        (_guardOknownValues)
                        (_guardOknownValues_collect)
                        (_guardOlabels_collect)
                        (_guardOlabels_dist)
                        (_guardOlocal)
                        (_guardOmethods_collect)
                        (_guardOmethods_dist)
                        (_guardOmoduleTypes)
                        (_guardOmoduleValues)
                        (_guardOnameType)
                        (_guardOtoplevel))
            ( _expressionIconstructors_collect,_expressionIknownKinds_collect,_expressionIknownTypes_collect,_expressionIknownValues_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionImoduleTypes,_expressionImoduleValues,_expressionImodules,_expressionIres,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOknownGenerics)
                             (_expressionOknownKinds)
                             (_expressionOknownKinds_collect)
                             (_expressionOknownTypes)
                             (_expressionOknownTypes_collect)
                             (_expressionOknownValues)
                             (_expressionOknownValues_collect)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmoduleTypes)
                             (_expressionOmoduleValues)
                             (_expressionOnameType)
                             (_expressionOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _guardImodules `Set.union` _expressionImodules
            -- use rule
            (_lhsOres@_) =
                _guardIres ++ _expressionIres
            -- self rule
            (_self@_) =
                GuardedExpression_GuardedExpression _rangeIself _guardIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _expressionIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _expressionIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _expressionIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _expressionImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _expressionImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_guardOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_guardOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_guardOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_guardOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_guardOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_guardOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_guardOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_guardOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_guardOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_guardOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_guardOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_guardOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_guardOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_guardOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_guardOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_guardOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_guardOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_guardOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_guardOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_guardOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_guardOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_guardOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_expressionOconstructors_collect@_) =
                _guardIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_expressionOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_expressionOknownKinds_collect@_) =
                _guardIknownKinds_collect
            -- copy rule (down)
            (_expressionOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_expressionOknownTypes_collect@_) =
                _guardIknownTypes_collect
            -- copy rule (down)
            (_expressionOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_expressionOknownValues_collect@_) =
                _guardIknownValues_collect
            -- copy rule (chain)
            (_expressionOlabels_collect@_) =
                _guardIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_expressionOmethods_collect@_) =
                _guardImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_expressionOmoduleTypes@_) =
                _guardImoduleTypes
            -- copy rule (chain)
            (_expressionOmoduleValues@_) =
                _guardImoduleValues
            -- copy rule (down)
            (_expressionOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- GuardedExpressions ------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for GuardedExpressions.Cons:
      self

-}
{-
   local variables for GuardedExpressions.Nil:
      self

-}
-- semantic domain
type T_GuardedExpressions = (Maybe Name) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Strings) ->
                            (Bool) ->
                            (Maybe Name) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Bool) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (FMap ModuleName [Name]) ->
                            (FMap ModuleName [Name]) ->
                            (NameType) ->
                            (Bool) ->
                            ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(GuardedExpressions))
-- cata
sem_GuardedExpressions :: (GuardedExpressions) ->
                          (T_GuardedExpressions)
sem_GuardedExpressions (list) =
    (foldr (sem_GuardedExpressions_Cons) (sem_GuardedExpressions_Nil) ((map sem_GuardedExpression list)))
sem_GuardedExpressions_Cons :: (T_GuardedExpression) ->
                               (T_GuardedExpressions) ->
                               (T_GuardedExpressions)
sem_GuardedExpressions_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (GuardedExpressions)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIknownKinds_collect :: (FMap Name [Name])
            _hdIknownTypes_collect :: (FMap Name [Name])
            _hdIknownValues_collect :: (FMap Name [Name])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdImoduleTypes :: (FMap ModuleName [Name])
            _hdImoduleValues :: (FMap ModuleName [Name])
            _hdImodules :: (Set.Set Strings)
            _hdIres :: ([ResolveResult])
            _hdIself :: (GuardedExpression)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOknownGenerics :: (FMap Name [Name])
            _hdOknownKinds :: (FMap Name [Name])
            _hdOknownKinds_collect :: (FMap Name [Name])
            _hdOknownTypes :: (FMap Name [Name])
            _hdOknownTypes_collect :: (FMap Name [Name])
            _hdOknownValues :: (FMap Name [Name])
            _hdOknownValues_collect :: (FMap Name [Name])
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmoduleTypes :: (FMap ModuleName [Name])
            _hdOmoduleValues :: (FMap ModuleName [Name])
            _hdOnameType :: (NameType)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIknownKinds_collect :: (FMap Name [Name])
            _tlIknownTypes_collect :: (FMap Name [Name])
            _tlIknownValues_collect :: (FMap Name [Name])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlImoduleTypes :: (FMap ModuleName [Name])
            _tlImoduleValues :: (FMap ModuleName [Name])
            _tlImodules :: (Set.Set Strings)
            _tlIres :: ([ResolveResult])
            _tlIself :: (GuardedExpressions)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOknownGenerics :: (FMap Name [Name])
            _tlOknownKinds :: (FMap Name [Name])
            _tlOknownKinds_collect :: (FMap Name [Name])
            _tlOknownTypes :: (FMap Name [Name])
            _tlOknownTypes_collect :: (FMap Name [Name])
            _tlOknownValues :: (FMap Name [Name])
            _tlOknownValues_collect :: (FMap Name [Name])
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmoduleTypes :: (FMap ModuleName [Name])
            _tlOmoduleValues :: (FMap ModuleName [Name])
            _tlOnameType :: (NameType)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIknownKinds_collect,_hdIknownTypes_collect,_hdIknownValues_collect,_hdIlabels_collect,_hdImethods_collect,_hdImoduleTypes,_hdImoduleValues,_hdImodules,_hdIres,_hdIself) =
                (hd_ (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOknownGenerics)
                     (_hdOknownKinds)
                     (_hdOknownKinds_collect)
                     (_hdOknownTypes)
                     (_hdOknownTypes_collect)
                     (_hdOknownValues)
                     (_hdOknownValues_collect)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmoduleTypes)
                     (_hdOmoduleValues)
                     (_hdOnameType)
                     (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIknownKinds_collect,_tlIknownTypes_collect,_tlIknownValues_collect,_tlIlabels_collect,_tlImethods_collect,_tlImoduleTypes,_tlImoduleValues,_tlImodules,_tlIres,_tlIself) =
                (tl_ (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOknownGenerics)
                     (_tlOknownKinds)
                     (_tlOknownKinds_collect)
                     (_tlOknownTypes)
                     (_tlOknownTypes_collect)
                     (_tlOknownValues)
                     (_tlOknownValues_collect)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmoduleTypes)
                     (_tlOmoduleValues)
                     (_tlOnameType)
                     (_tlOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _hdImodules `Set.union` _tlImodules
            -- use rule
            (_lhsOres@_) =
                _hdIres ++ _tlIres
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _tlIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _tlIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _tlIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _tlImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _tlImoduleValues
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_hdOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_hdOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_hdOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_hdOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_hdOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_hdOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_hdOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_hdOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_tlOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_tlOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_tlOknownKinds_collect@_) =
                _hdIknownKinds_collect
            -- copy rule (down)
            (_tlOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_tlOknownTypes_collect@_) =
                _hdIknownTypes_collect
            -- copy rule (down)
            (_tlOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_tlOknownValues_collect@_) =
                _hdIknownValues_collect
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_tlOmoduleTypes@_) =
                _hdImoduleTypes
            -- copy rule (chain)
            (_tlOmoduleValues@_) =
                _hdImoduleValues
            -- copy rule (down)
            (_tlOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_GuardedExpressions_Nil :: (T_GuardedExpressions)
sem_GuardedExpressions_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (GuardedExpressions)
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- Import ------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for Import.TypeOrClass:
      relevantEntities
      self

-}
{-
   local variables for Import.TypeOrClassComplete:
      self

-}
{-
   local variables for Import.Variable:
      self

-}
-- semantic domain
type T_Import = (Maybe Name) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (Strings) ->
                (Bool) ->
                (Maybe Name) ->
                (FMap Name [Name]) ->
                (FMap Name [Name]) ->
                (FMap Name [Name]) ->
                (FMap Name [Name]) ->
                (FMap Name [Name]) ->
                (FMap Name [Name]) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (Bool) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (FMap ModuleName [Name]) ->
                (FMap ModuleName [Name]) ->
                (NameType) ->
                (Bool) ->
                ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(Import))
-- cata
sem_Import :: (Import) ->
              (T_Import)
sem_Import ((Import_TypeOrClass (_range) (_name) (_names))) =
    (sem_Import_TypeOrClass ((sem_Range (_range))) ((sem_Name (_name))) ((sem_MaybeNames (_names))))
sem_Import ((Import_TypeOrClassComplete (_range) (_name))) =
    (sem_Import_TypeOrClassComplete ((sem_Range (_range))) ((sem_Name (_name))))
sem_Import ((Import_Variable (_range) (_name))) =
    (sem_Import_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Import_TypeOrClass :: (T_Range) ->
                          (T_Name) ->
                          (T_MaybeNames) ->
                          (T_Import)
sem_Import_TypeOrClass (range_) (name_) (names_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Import)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _namesIconstructors_collect :: (FMap Name Names)
            _namesIknownKinds_collect :: (FMap Name [Name])
            _namesIknownTypes_collect :: (FMap Name [Name])
            _namesIknownValues_collect :: (FMap Name [Name])
            _namesIlabels_collect :: (FMap Name Names)
            _namesImethods_collect :: (FMap Name Names)
            _namesImoduleTypes :: (FMap ModuleName [Name])
            _namesImoduleValues :: (FMap ModuleName [Name])
            _namesImodules :: (Set.Set Strings)
            _namesIres :: ([ResolveResult])
            _namesIself :: (MaybeNames)
            _namesOclassname :: (Maybe Name)
            _namesOconstructors_collect :: (FMap Name Names)
            _namesOconstructors_dist :: (FMap Name Names)
            _namesOcurrentModule :: (Strings)
            _namesOimportedModule :: (Bool)
            _namesOinstancename :: (Maybe Name)
            _namesOknownKinds :: (FMap Name [Name])
            _namesOknownKinds_collect :: (FMap Name [Name])
            _namesOknownTypes :: (FMap Name [Name])
            _namesOknownTypes_collect :: (FMap Name [Name])
            _namesOknownValues :: (FMap Name [Name])
            _namesOknownValues_collect :: (FMap Name [Name])
            _namesOlabels_collect :: (FMap Name Names)
            _namesOlabels_dist :: (FMap Name Names)
            _namesOlocal :: (Bool)
            _namesOmethods_collect :: (FMap Name Names)
            _namesOmethods_dist :: (FMap Name Names)
            _namesOmoduleTypes :: (FMap ModuleName [Name])
            _namesOmoduleValues :: (FMap ModuleName [Name])
            _namesOnameType :: (NameType)
            _namesOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _namesIconstructors_collect,_namesIknownKinds_collect,_namesIknownTypes_collect,_namesIknownValues_collect,_namesIlabels_collect,_namesImethods_collect,_namesImoduleTypes,_namesImoduleValues,_namesImodules,_namesIres,_namesIself) =
                (names_ (_namesOclassname)
                        (_namesOconstructors_collect)
                        (_namesOconstructors_dist)
                        (_namesOcurrentModule)
                        (_namesOimportedModule)
                        (_namesOinstancename)
                        (_namesOknownKinds)
                        (_namesOknownKinds_collect)
                        (_namesOknownTypes)
                        (_namesOknownTypes_collect)
                        (_namesOknownValues)
                        (_namesOknownValues_collect)
                        (_namesOlabels_collect)
                        (_namesOlabels_dist)
                        (_namesOlocal)
                        (_namesOmethods_collect)
                        (_namesOmethods_dist)
                        (_namesOmoduleTypes)
                        (_namesOmoduleValues)
                        (_namesOnameType)
                        (_namesOtoplevel))
            -- "./Names.inc.lag"(line 541, column 9)
            (_namesOknownValues@_) =
                ( fromList
                . filter (\ (_,es) -> not . null $
                                        es `List.intersect` _relevantEntities)
                . toList
                ) _lhsIknownValues
            -- "./Names.inc.lag"(line 534, column 9)
            (_relevantEntities@_) =
                map getEntity $
                  findL _lhsImethods_dist _nameIself
                    ++
                  findL _lhsIconstructors_dist _nameIself
                    ++
                  findL _lhsIlabels_dist _nameIself
            -- "./Names.inc.lag"(line 532, column 9)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- "./NameTypes.inc.lag"(line 110, column 9)
            (_namesOnameType@_) =
                ref_Val
            -- "./NameTypes.inc.lag"(line 109, column 9)
            (_nameOnameType@_) =
                ref_Typ
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _namesImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _namesIres
            -- self rule
            (_self@_) =
                Import_TypeOrClass _rangeIself _nameIself _namesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _namesIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _namesIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _namesIknownTypes_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _namesIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _namesImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _namesImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _namesImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_namesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_namesOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_namesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_namesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_namesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_namesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_namesOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_namesOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_namesOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_namesOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (chain)
            (_namesOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_namesOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_namesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_namesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_namesOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_namesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_namesOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_namesOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_namesOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Import_TypeOrClassComplete :: (T_Range) ->
                                  (T_Name) ->
                                  (T_Import)
sem_Import_TypeOrClassComplete (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Import)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            -- "./NameTypes.inc.lag"(line 112, column 9)
            (_nameOnameType@_) =
                ref_Typ
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres
            -- self rule
            (_self@_) =
                Import_TypeOrClassComplete _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Import_Variable :: (T_Range) ->
                       (T_Name) ->
                       (T_Import)
sem_Import_Variable (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Import)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            -- "./NameTypes.inc.lag"(line 107, column 9)
            (_nameOnameType@_) =
                ref_Val
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres
            -- self rule
            (_self@_) =
                Import_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- ImportDeclaration -------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      hiddenEntities       : [(Set Name,Set Name)]
      importedEntities     : [(Set Name,Set Name)]
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for ImportDeclaration.Empty:
      self

-}
{-
   local variables for ImportDeclaration.Import:
      hiddenTypes
      importedTypes
      hiddenValues
      importedValues
      prefixes
      knownTypesForModule
      knownValuesForModule
      local
      currentModule
      self

-}
-- semantic domain
type T_ImportDeclaration = (Maybe Name) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Strings) ->
                           (Bool) ->
                           (Maybe Name) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Bool) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (FMap ModuleName [Name]) ->
                           (FMap ModuleName [Name]) ->
                           (NameType) ->
                           (Bool) ->
                           ( (FMap Name Names),([(Set Name,Set Name)]),([(Set Name,Set Name)]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(ImportDeclaration))
-- cata
sem_ImportDeclaration :: (ImportDeclaration) ->
                         (T_ImportDeclaration)
sem_ImportDeclaration ((ImportDeclaration_Empty (_range))) =
    (sem_ImportDeclaration_Empty ((sem_Range (_range))))
sem_ImportDeclaration ((ImportDeclaration_Import (_range) (_qualified) (_name) (_asname) (_importspecification))) =
    (sem_ImportDeclaration_Import ((sem_Range (_range))) (_qualified) ((sem_ModuleName (_name))) ((sem_MaybeModuleName (_asname))) ((sem_MaybeImportSpecification (_importspecification))))
sem_ImportDeclaration_Empty :: (T_Range) ->
                               (T_ImportDeclaration)
sem_ImportDeclaration_Empty (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOhiddenEntities :: ([(Set Name,Set Name)])
            _lhsOimportedEntities :: ([(Set Name,Set Name)])
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (ImportDeclaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- use rule
            (_lhsOhiddenEntities@_) =
                []
            -- use rule
            (_lhsOimportedEntities@_) =
                []
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                ImportDeclaration_Empty _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOhiddenEntities,_lhsOimportedEntities,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_ImportDeclaration_Import :: (T_Range) ->
                                (Bool) ->
                                (T_ModuleName) ->
                                (T_MaybeModuleName) ->
                                (T_MaybeImportSpecification) ->
                                (T_ImportDeclaration)
sem_ImportDeclaration_Import (range_) (qualified_) (name_) (asname_) (importspecification_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOhiddenEntities :: ([(Set Name,Set Name)])
            _lhsOimportedEntities :: ([(Set Name,Set Name)])
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (ImportDeclaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIres :: ([ResolveResult])
            _nameIself :: (ModuleName)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _asnameIconstructors_collect :: (FMap Name Names)
            _asnameIknownKinds_collect :: (FMap Name [Name])
            _asnameIknownTypes_collect :: (FMap Name [Name])
            _asnameIknownValues_collect :: (FMap Name [Name])
            _asnameIlabels_collect :: (FMap Name Names)
            _asnameImethods_collect :: (FMap Name Names)
            _asnameImoduleTypes :: (FMap ModuleName [Name])
            _asnameImoduleValues :: (FMap ModuleName [Name])
            _asnameImodules :: (Set.Set Strings)
            _asnameIres :: ([ResolveResult])
            _asnameIself :: (MaybeModuleName)
            _asnameOclassname :: (Maybe Name)
            _asnameOconstructors_collect :: (FMap Name Names)
            _asnameOconstructors_dist :: (FMap Name Names)
            _asnameOcurrentModule :: (Strings)
            _asnameOimportedModule :: (Bool)
            _asnameOinstancename :: (Maybe Name)
            _asnameOknownKinds :: (FMap Name [Name])
            _asnameOknownKinds_collect :: (FMap Name [Name])
            _asnameOknownTypes :: (FMap Name [Name])
            _asnameOknownTypes_collect :: (FMap Name [Name])
            _asnameOknownValues :: (FMap Name [Name])
            _asnameOknownValues_collect :: (FMap Name [Name])
            _asnameOlabels_collect :: (FMap Name Names)
            _asnameOlabels_dist :: (FMap Name Names)
            _asnameOlocal :: (Bool)
            _asnameOmethods_collect :: (FMap Name Names)
            _asnameOmethods_dist :: (FMap Name Names)
            _asnameOmoduleTypes :: (FMap ModuleName [Name])
            _asnameOmoduleValues :: (FMap ModuleName [Name])
            _asnameOnameType :: (NameType)
            _asnameOtoplevel :: (Bool)
            _importspecificationIconstructors_collect :: (FMap Name Names)
            _importspecificationIhiddenTypes_collect :: (FMap Name [Name])
            _importspecificationIhiddenValues_collect :: (FMap Name [Name])
            _importspecificationIknownKinds_collect :: (FMap Name [Name])
            _importspecificationIknownTypes_collect :: (FMap Name [Name])
            _importspecificationIknownValues_collect :: (FMap Name [Name])
            _importspecificationIlabels_collect :: (FMap Name Names)
            _importspecificationImethods_collect :: (FMap Name Names)
            _importspecificationImoduleTypes :: (FMap ModuleName [Name])
            _importspecificationImoduleValues :: (FMap ModuleName [Name])
            _importspecificationImodules :: (Set.Set Strings)
            _importspecificationIres :: ([ResolveResult])
            _importspecificationIself :: (MaybeImportSpecification)
            _importspecificationOclassname :: (Maybe Name)
            _importspecificationOconstructors_collect :: (FMap Name Names)
            _importspecificationOconstructors_dist :: (FMap Name Names)
            _importspecificationOcurrentModule :: (Strings)
            _importspecificationOimportedModule :: (Bool)
            _importspecificationOinstancename :: (Maybe Name)
            _importspecificationOknownKinds :: (FMap Name [Name])
            _importspecificationOknownKinds_collect :: (FMap Name [Name])
            _importspecificationOknownTypes :: (FMap Name [Name])
            _importspecificationOknownTypes_collect :: (FMap Name [Name])
            _importspecificationOknownValues :: (FMap Name [Name])
            _importspecificationOknownValues_collect :: (FMap Name [Name])
            _importspecificationOlabels_collect :: (FMap Name Names)
            _importspecificationOlabels_dist :: (FMap Name Names)
            _importspecificationOlocal :: (Bool)
            _importspecificationOmethods_collect :: (FMap Name Names)
            _importspecificationOmethods_dist :: (FMap Name Names)
            _importspecificationOmoduleTypes :: (FMap ModuleName [Name])
            _importspecificationOmoduleValues :: (FMap ModuleName [Name])
            _importspecificationOnameType :: (NameType)
            _importspecificationOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _asnameIconstructors_collect,_asnameIknownKinds_collect,_asnameIknownTypes_collect,_asnameIknownValues_collect,_asnameIlabels_collect,_asnameImethods_collect,_asnameImoduleTypes,_asnameImoduleValues,_asnameImodules,_asnameIres,_asnameIself) =
                (asname_ (_asnameOclassname)
                         (_asnameOconstructors_collect)
                         (_asnameOconstructors_dist)
                         (_asnameOcurrentModule)
                         (_asnameOimportedModule)
                         (_asnameOinstancename)
                         (_asnameOknownKinds)
                         (_asnameOknownKinds_collect)
                         (_asnameOknownTypes)
                         (_asnameOknownTypes_collect)
                         (_asnameOknownValues)
                         (_asnameOknownValues_collect)
                         (_asnameOlabels_collect)
                         (_asnameOlabels_dist)
                         (_asnameOlocal)
                         (_asnameOmethods_collect)
                         (_asnameOmethods_dist)
                         (_asnameOmoduleTypes)
                         (_asnameOmoduleValues)
                         (_asnameOnameType)
                         (_asnameOtoplevel))
            ( _importspecificationIconstructors_collect
             ,_importspecificationIhiddenTypes_collect
             ,_importspecificationIhiddenValues_collect
             ,_importspecificationIknownKinds_collect
             ,_importspecificationIknownTypes_collect
             ,_importspecificationIknownValues_collect
             ,_importspecificationIlabels_collect
             ,_importspecificationImethods_collect
             ,_importspecificationImoduleTypes
             ,_importspecificationImoduleValues
             ,_importspecificationImodules
             ,_importspecificationIres
             ,_importspecificationIself
             ) =
                (importspecification_ (_importspecificationOclassname)
                                      (_importspecificationOconstructors_collect)
                                      (_importspecificationOconstructors_dist)
                                      (_importspecificationOcurrentModule)
                                      (_importspecificationOimportedModule)
                                      (_importspecificationOinstancename)
                                      (_importspecificationOknownKinds)
                                      (_importspecificationOknownKinds_collect)
                                      (_importspecificationOknownTypes)
                                      (_importspecificationOknownTypes_collect)
                                      (_importspecificationOknownValues)
                                      (_importspecificationOknownValues_collect)
                                      (_importspecificationOlabels_collect)
                                      (_importspecificationOlabels_dist)
                                      (_importspecificationOlocal)
                                      (_importspecificationOmethods_collect)
                                      (_importspecificationOmethods_dist)
                                      (_importspecificationOmoduleTypes)
                                      (_importspecificationOmoduleValues)
                                      (_importspecificationOnameType)
                                      (_importspecificationOtoplevel))
            -- "NameReplace.lag"(line 370, column 9)
            (_lhsOhiddenEntities@_) =
                [ (_hiddenValues  ,_hiddenTypes  ) ]
            -- "NameReplace.lag"(line 369, column 9)
            (_lhsOimportedEntities@_) =
                [ (_importedValues,_importedTypes) ]
            -- "./Names.inc.lag"(line 884, column 9)
            (_hiddenTypes@_) =
                Set.mkSet
                  . map (\ x -> Name_Entity (getRange x) x MaybeName_Nothing)
                  . concatMap snd . toList $ _importspecificationIhiddenTypes_collect
            -- "./Names.inc.lag"(line 881, column 9)
            (_importedTypes@_) =
                Set.mkSet
                  . map (\ x -> Name_Entity (getRange x) x MaybeName_Nothing)
                  . concatMap snd . toList $ _importspecificationIknownTypes_collect
            -- "./Names.inc.lag"(line 878, column 9)
            (_hiddenValues@_) =
                Set.mkSet
                  . map (\ x -> Name_Entity (getRange x) x MaybeName_Nothing)
                  . concatMap snd . toList $ _importspecificationIhiddenValues_collect
            -- "./Names.inc.lag"(line 875, column 9)
            (_importedValues@_) =
                Set.mkSet
                  . map (\ x -> Name_Entity (getRange x) x MaybeName_Nothing)
                  . concatMap snd . toList $ _importspecificationIknownValues_collect
            -- "./Names.inc.lag"(line 873, column 9)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- "./Names.inc.lag"(line 868, column 9)
            (_importspecificationOknownTypes@_) =
                fromList $
                  map (\n -> (makePlainName n,[getEntity n]))
                    _knownTypesForModule
            -- "./Names.inc.lag"(line 863, column 9)
            (_importspecificationOknownValues@_) =
                fromList $
                  map (\n -> (makePlainName n,[getEntity n]))
                    _knownValuesForModule
            -- "./Names.inc.lag"(line 857, column 9)
            (_importspecificationOknownTypes_collect@_) =
                let prefixed_tps p  = map (prefixEntity p) _knownTypesForModule
                    all_prefixes    = concatMap prefixed_tps _prefixes
                    add_tps tps     = foldl addLReplace _lhsIknownTypes_collect tps
                in  add_tps all_prefixes
            -- "./Names.inc.lag"(line 849, column 9)
            (_importspecificationOknownValues_collect@_) =
                let prefixed_vals p = map (prefixEntity p) _knownValuesForModule
                    all_prefixes    = concatMap prefixed_vals _prefixes
                    add_vals vals   = foldl addLReplace _lhsIknownValues_collect vals
                in
                    add_vals all_prefixes
            -- "./Names.inc.lag"(line 844, column 9)
            (_prefixes@_) =
                let unqual = if qualified_ then [] else [[]]
                    qual MaybeModuleName_Nothing  = [getModuleName _nameIself]
                    qual (MaybeModuleName_Just x) = [getModuleName x]
                in  unqual ++ qual _asnameIself
            -- "./Names.inc.lag"(line 839, column 9)
            (_lhsOknownTypes_collect@_) =
                _importspecificationIknownTypes_collect
            -- "./Names.inc.lag"(line 838, column 9)
            (_lhsOknownValues_collect@_) =
                _importspecificationIknownValues_collect
            -- "./Names.inc.lag"(line 833, column 9)
            (_knownTypesForModule@_) =
                applyFMM
                  _lhsImoduleTypes
                  (const [])
                  _nameIself
            -- "./Names.inc.lag"(line 828, column 9)
            (_knownValuesForModule@_) =
                applyFMM
                  _lhsImoduleValues
                  (const [])
                  _nameIself
            -- "./ModuleInformation.inc.lag"(line 118, column 8)
            (_local@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 117, column 8)
            (_currentModule@_) =
                getModuleName _nameIself
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _asnameImodules `Set.union` _importspecificationImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _asnameIres ++ _importspecificationIres
            -- self rule
            (_self@_) =
                ImportDeclaration_Import _rangeIself qualified_ _nameIself _asnameIself _importspecificationIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _importspecificationIconstructors_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _importspecificationIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _importspecificationImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _importspecificationImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _importspecificationImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_rangeOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_rangeOlocal@_) =
                _local
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_nameOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_nameOlocal@_) =
                _local
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_asnameOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_asnameOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_asnameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_asnameOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_asnameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_asnameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_asnameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_asnameOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_asnameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_asnameOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (down)
            (_asnameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_asnameOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_asnameOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_asnameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_asnameOlocal@_) =
                _local
            -- copy rule (chain)
            (_asnameOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_asnameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_asnameOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_asnameOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_asnameOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_asnameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_importspecificationOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_importspecificationOconstructors_collect@_) =
                _asnameIconstructors_collect
            -- copy rule (down)
            (_importspecificationOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_importspecificationOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_importspecificationOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_importspecificationOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_importspecificationOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_importspecificationOknownKinds_collect@_) =
                _asnameIknownKinds_collect
            -- copy rule (chain)
            (_importspecificationOlabels_collect@_) =
                _asnameIlabels_collect
            -- copy rule (down)
            (_importspecificationOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_importspecificationOlocal@_) =
                _local
            -- copy rule (chain)
            (_importspecificationOmethods_collect@_) =
                _asnameImethods_collect
            -- copy rule (down)
            (_importspecificationOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_importspecificationOmoduleTypes@_) =
                _asnameImoduleTypes
            -- copy rule (chain)
            (_importspecificationOmoduleValues@_) =
                _asnameImoduleValues
            -- copy rule (down)
            (_importspecificationOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_importspecificationOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOhiddenEntities,_lhsOimportedEntities,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- ImportDeclarations ------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      hiddenEntities       : [(Set Name,Set Name)]
      importedEntities     : [(Set Name,Set Name)]
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for ImportDeclarations.Cons:
      self

-}
{-
   local variables for ImportDeclarations.Nil:
      self

-}
-- semantic domain
type T_ImportDeclarations = (Maybe Name) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Strings) ->
                            (Bool) ->
                            (Maybe Name) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Bool) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (FMap ModuleName [Name]) ->
                            (FMap ModuleName [Name]) ->
                            (NameType) ->
                            (Bool) ->
                            ( (FMap Name Names),([(Set Name,Set Name)]),([(Set Name,Set Name)]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(ImportDeclarations))
-- cata
sem_ImportDeclarations :: (ImportDeclarations) ->
                          (T_ImportDeclarations)
sem_ImportDeclarations (list) =
    (foldr (sem_ImportDeclarations_Cons) (sem_ImportDeclarations_Nil) ((map sem_ImportDeclaration list)))
sem_ImportDeclarations_Cons :: (T_ImportDeclaration) ->
                               (T_ImportDeclarations) ->
                               (T_ImportDeclarations)
sem_ImportDeclarations_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOhiddenEntities :: ([(Set Name,Set Name)])
            _lhsOimportedEntities :: ([(Set Name,Set Name)])
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (ImportDeclarations)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIhiddenEntities :: ([(Set Name,Set Name)])
            _hdIimportedEntities :: ([(Set Name,Set Name)])
            _hdIknownKinds_collect :: (FMap Name [Name])
            _hdIknownTypes_collect :: (FMap Name [Name])
            _hdIknownValues_collect :: (FMap Name [Name])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdImoduleTypes :: (FMap ModuleName [Name])
            _hdImoduleValues :: (FMap ModuleName [Name])
            _hdImodules :: (Set.Set Strings)
            _hdIres :: ([ResolveResult])
            _hdIself :: (ImportDeclaration)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOknownKinds :: (FMap Name [Name])
            _hdOknownKinds_collect :: (FMap Name [Name])
            _hdOknownTypes :: (FMap Name [Name])
            _hdOknownTypes_collect :: (FMap Name [Name])
            _hdOknownValues :: (FMap Name [Name])
            _hdOknownValues_collect :: (FMap Name [Name])
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmoduleTypes :: (FMap ModuleName [Name])
            _hdOmoduleValues :: (FMap ModuleName [Name])
            _hdOnameType :: (NameType)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIhiddenEntities :: ([(Set Name,Set Name)])
            _tlIimportedEntities :: ([(Set Name,Set Name)])
            _tlIknownKinds_collect :: (FMap Name [Name])
            _tlIknownTypes_collect :: (FMap Name [Name])
            _tlIknownValues_collect :: (FMap Name [Name])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlImoduleTypes :: (FMap ModuleName [Name])
            _tlImoduleValues :: (FMap ModuleName [Name])
            _tlImodules :: (Set.Set Strings)
            _tlIres :: ([ResolveResult])
            _tlIself :: (ImportDeclarations)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOknownKinds :: (FMap Name [Name])
            _tlOknownKinds_collect :: (FMap Name [Name])
            _tlOknownTypes :: (FMap Name [Name])
            _tlOknownTypes_collect :: (FMap Name [Name])
            _tlOknownValues :: (FMap Name [Name])
            _tlOknownValues_collect :: (FMap Name [Name])
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmoduleTypes :: (FMap ModuleName [Name])
            _tlOmoduleValues :: (FMap ModuleName [Name])
            _tlOnameType :: (NameType)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIhiddenEntities,_hdIimportedEntities,_hdIknownKinds_collect,_hdIknownTypes_collect,_hdIknownValues_collect,_hdIlabels_collect,_hdImethods_collect,_hdImoduleTypes,_hdImoduleValues,_hdImodules,_hdIres,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOimportedModule) (_hdOinstancename) (_hdOknownKinds) (_hdOknownKinds_collect) (_hdOknownTypes) (_hdOknownTypes_collect) (_hdOknownValues) (_hdOknownValues_collect) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOmoduleTypes) (_hdOmoduleValues) (_hdOnameType) (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIhiddenEntities,_tlIimportedEntities,_tlIknownKinds_collect,_tlIknownTypes_collect,_tlIknownValues_collect,_tlIlabels_collect,_tlImethods_collect,_tlImoduleTypes,_tlImoduleValues,_tlImodules,_tlIres,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOimportedModule) (_tlOinstancename) (_tlOknownKinds) (_tlOknownKinds_collect) (_tlOknownTypes) (_tlOknownTypes_collect) (_tlOknownValues) (_tlOknownValues_collect) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOmoduleTypes) (_tlOmoduleValues) (_tlOnameType) (_tlOtoplevel))
            -- "./Names.inc.lag"(line 897, column 9)
            (_lhsOknownTypes_collect@_) =
                mergeImports _hdIknownTypes_collect  _tlIknownTypes_collect
            -- "./Names.inc.lag"(line 896, column 9)
            (_lhsOknownValues_collect@_) =
                mergeImports _hdIknownValues_collect _tlIknownValues_collect
            -- use rule
            (_lhsOhiddenEntities@_) =
                _hdIhiddenEntities ++ _tlIhiddenEntities
            -- use rule
            (_lhsOimportedEntities@_) =
                _hdIimportedEntities ++ _tlIimportedEntities
            -- use rule
            (_lhsOmodules@_) =
                _hdImodules `Set.union` _tlImodules
            -- use rule
            (_lhsOres@_) =
                _hdIres ++ _tlIres
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _tlIknownKinds_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _tlImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _tlImoduleValues
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_hdOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_hdOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_hdOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_hdOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_hdOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_hdOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_hdOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_tlOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_tlOknownKinds_collect@_) =
                _hdIknownKinds_collect
            -- copy rule (down)
            (_tlOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_tlOknownTypes_collect@_) =
                _hdIknownTypes_collect
            -- copy rule (down)
            (_tlOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_tlOknownValues_collect@_) =
                _hdIknownValues_collect
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_tlOmoduleTypes@_) =
                _hdImoduleTypes
            -- copy rule (chain)
            (_tlOmoduleValues@_) =
                _hdImoduleValues
            -- copy rule (down)
            (_tlOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOhiddenEntities,_lhsOimportedEntities,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_ImportDeclarations_Nil :: (T_ImportDeclarations)
sem_ImportDeclarations_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOhiddenEntities :: ([(Set Name,Set Name)])
            _lhsOimportedEntities :: ([(Set Name,Set Name)])
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (ImportDeclarations)
            -- use rule
            (_lhsOhiddenEntities@_) =
                []
            -- use rule
            (_lhsOimportedEntities@_) =
                []
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOhiddenEntities,_lhsOimportedEntities,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- ImportSpecification -----------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      hiddenTypes_collect  : FMap Name [Name]
      hiddenValues_collect : FMap Name [Name]
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for ImportSpecification.Import:
      f
      self

-}
-- semantic domain
type T_ImportSpecification = (Maybe Name) ->
                             (FMap Name Names) ->
                             (FMap Name Names) ->
                             (Strings) ->
                             (Bool) ->
                             (Maybe Name) ->
                             (FMap Name [Name]) ->
                             (FMap Name [Name]) ->
                             (FMap Name [Name]) ->
                             (FMap Name [Name]) ->
                             (FMap Name [Name]) ->
                             (FMap Name [Name]) ->
                             (FMap Name Names) ->
                             (FMap Name Names) ->
                             (Bool) ->
                             (FMap Name Names) ->
                             (FMap Name Names) ->
                             (FMap ModuleName [Name]) ->
                             (FMap ModuleName [Name]) ->
                             (NameType) ->
                             (Bool) ->
                             ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(ImportSpecification))
-- cata
sem_ImportSpecification :: (ImportSpecification) ->
                           (T_ImportSpecification)
sem_ImportSpecification ((ImportSpecification_Import (_range) (_hiding) (_imports))) =
    (sem_ImportSpecification_Import ((sem_Range (_range))) (_hiding) ((sem_Imports (_imports))))
sem_ImportSpecification_Import :: (T_Range) ->
                                  (Bool) ->
                                  (T_Imports) ->
                                  (T_ImportSpecification)
sem_ImportSpecification_Import (range_) (hiding_) (imports_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOhiddenTypes_collect :: (FMap Name [Name])
            _lhsOhiddenValues_collect :: (FMap Name [Name])
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (ImportSpecification)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _importsIconstructors_collect :: (FMap Name Names)
            _importsIknownKinds_collect :: (FMap Name [Name])
            _importsIknownTypes_collect :: (FMap Name [Name])
            _importsIknownValues_collect :: (FMap Name [Name])
            _importsIlabels_collect :: (FMap Name Names)
            _importsImethods_collect :: (FMap Name Names)
            _importsImoduleTypes :: (FMap ModuleName [Name])
            _importsImoduleValues :: (FMap ModuleName [Name])
            _importsImodules :: (Set.Set Strings)
            _importsIres :: ([ResolveResult])
            _importsIself :: (Imports)
            _importsOclassname :: (Maybe Name)
            _importsOconstructors_collect :: (FMap Name Names)
            _importsOconstructors_dist :: (FMap Name Names)
            _importsOcurrentModule :: (Strings)
            _importsOimportedModule :: (Bool)
            _importsOinstancename :: (Maybe Name)
            _importsOknownKinds :: (FMap Name [Name])
            _importsOknownKinds_collect :: (FMap Name [Name])
            _importsOknownTypes :: (FMap Name [Name])
            _importsOknownTypes_collect :: (FMap Name [Name])
            _importsOknownValues :: (FMap Name [Name])
            _importsOknownValues_collect :: (FMap Name [Name])
            _importsOlabels_collect :: (FMap Name Names)
            _importsOlabels_dist :: (FMap Name Names)
            _importsOlocal :: (Bool)
            _importsOmethods_collect :: (FMap Name Names)
            _importsOmethods_dist :: (FMap Name Names)
            _importsOmoduleTypes :: (FMap ModuleName [Name])
            _importsOmoduleValues :: (FMap ModuleName [Name])
            _importsOnameType :: (NameType)
            _importsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _importsIconstructors_collect,_importsIknownKinds_collect,_importsIknownTypes_collect,_importsIknownValues_collect,_importsIlabels_collect,_importsImethods_collect,_importsImoduleTypes,_importsImoduleValues,_importsImodules,_importsIres,_importsIself) =
                (imports_ (_importsOclassname)
                          (_importsOconstructors_collect)
                          (_importsOconstructors_dist)
                          (_importsOcurrentModule)
                          (_importsOimportedModule)
                          (_importsOinstancename)
                          (_importsOknownKinds)
                          (_importsOknownKinds_collect)
                          (_importsOknownTypes)
                          (_importsOknownTypes_collect)
                          (_importsOknownValues)
                          (_importsOknownValues_collect)
                          (_importsOlabels_collect)
                          (_importsOlabels_dist)
                          (_importsOlocal)
                          (_importsOmethods_collect)
                          (_importsOmethods_dist)
                          (_importsOmoduleTypes)
                          (_importsOmoduleValues)
                          (_importsOnameType)
                          (_importsOtoplevel))
            -- "./Names.inc.lag"(line 973, column 9)
            (_lhsOhiddenTypes_collect@_) =
                selectFromT (not . _f)
                  _importsIknownTypes_collect
                  _importsIself
            -- "./Names.inc.lag"(line 969, column 9)
            (_lhsOknownTypes_collect@_) =
                selectFromT _f
                  _importsIknownTypes_collect
                  _importsIself
            -- "./Names.inc.lag"(line 961, column 9)
            (_lhsOhiddenValues_collect@_) =
                selectFromV (not . _f)
                  _lhsIknownValues_collect
                  _lhsIknownTypes_collect
                  _importsIself
                  _lhsIconstructors_dist
                  _lhsImethods_dist
                  _lhsIlabels_dist
            -- "./Names.inc.lag"(line 952, column 9)
            (_lhsOknownValues_collect@_) =
                selectFromV _f
                  _lhsIknownValues_collect
                  _lhsIknownTypes_collect
                  _importsIself
                  _lhsIconstructors_dist
                  _lhsImethods_dist
                  _lhsIlabels_dist
            -- "./Names.inc.lag"(line 950, column 9)
            (_f@_) =
                if hiding_ then not else id
            -- use rule
            (_lhsOmodules@_) =
                _importsImodules
            -- use rule
            (_lhsOres@_) =
                _importsIres
            -- self rule
            (_self@_) =
                ImportSpecification_Import _rangeIself hiding_ _importsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _importsIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _importsIknownKinds_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _importsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _importsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _importsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _importsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_importsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_importsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_importsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_importsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_importsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_importsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_importsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_importsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_importsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_importsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_importsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_importsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_importsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_importsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_importsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_importsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_importsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_importsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_importsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_importsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_importsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOhiddenTypes_collect,_lhsOhiddenValues_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- Imports -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for Imports.Cons:
      self

-}
{-
   local variables for Imports.Nil:
      self

-}
-- semantic domain
type T_Imports = (Maybe Name) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Strings) ->
                 (Bool) ->
                 (Maybe Name) ->
                 (FMap Name [Name]) ->
                 (FMap Name [Name]) ->
                 (FMap Name [Name]) ->
                 (FMap Name [Name]) ->
                 (FMap Name [Name]) ->
                 (FMap Name [Name]) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Bool) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (FMap ModuleName [Name]) ->
                 (FMap ModuleName [Name]) ->
                 (NameType) ->
                 (Bool) ->
                 ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(Imports))
-- cata
sem_Imports :: (Imports) ->
               (T_Imports)
sem_Imports (list) =
    (foldr (sem_Imports_Cons) (sem_Imports_Nil) ((map sem_Import list)))
sem_Imports_Cons :: (T_Import) ->
                    (T_Imports) ->
                    (T_Imports)
sem_Imports_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Imports)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIknownKinds_collect :: (FMap Name [Name])
            _hdIknownTypes_collect :: (FMap Name [Name])
            _hdIknownValues_collect :: (FMap Name [Name])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdImoduleTypes :: (FMap ModuleName [Name])
            _hdImoduleValues :: (FMap ModuleName [Name])
            _hdImodules :: (Set.Set Strings)
            _hdIres :: ([ResolveResult])
            _hdIself :: (Import)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOknownKinds :: (FMap Name [Name])
            _hdOknownKinds_collect :: (FMap Name [Name])
            _hdOknownTypes :: (FMap Name [Name])
            _hdOknownTypes_collect :: (FMap Name [Name])
            _hdOknownValues :: (FMap Name [Name])
            _hdOknownValues_collect :: (FMap Name [Name])
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmoduleTypes :: (FMap ModuleName [Name])
            _hdOmoduleValues :: (FMap ModuleName [Name])
            _hdOnameType :: (NameType)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIknownKinds_collect :: (FMap Name [Name])
            _tlIknownTypes_collect :: (FMap Name [Name])
            _tlIknownValues_collect :: (FMap Name [Name])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlImoduleTypes :: (FMap ModuleName [Name])
            _tlImoduleValues :: (FMap ModuleName [Name])
            _tlImodules :: (Set.Set Strings)
            _tlIres :: ([ResolveResult])
            _tlIself :: (Imports)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOknownKinds :: (FMap Name [Name])
            _tlOknownKinds_collect :: (FMap Name [Name])
            _tlOknownTypes :: (FMap Name [Name])
            _tlOknownTypes_collect :: (FMap Name [Name])
            _tlOknownValues :: (FMap Name [Name])
            _tlOknownValues_collect :: (FMap Name [Name])
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmoduleTypes :: (FMap ModuleName [Name])
            _tlOmoduleValues :: (FMap ModuleName [Name])
            _tlOnameType :: (NameType)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIknownKinds_collect,_hdIknownTypes_collect,_hdIknownValues_collect,_hdIlabels_collect,_hdImethods_collect,_hdImoduleTypes,_hdImoduleValues,_hdImodules,_hdIres,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOimportedModule) (_hdOinstancename) (_hdOknownKinds) (_hdOknownKinds_collect) (_hdOknownTypes) (_hdOknownTypes_collect) (_hdOknownValues) (_hdOknownValues_collect) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOmoduleTypes) (_hdOmoduleValues) (_hdOnameType) (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIknownKinds_collect,_tlIknownTypes_collect,_tlIknownValues_collect,_tlIlabels_collect,_tlImethods_collect,_tlImoduleTypes,_tlImoduleValues,_tlImodules,_tlIres,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOimportedModule) (_tlOinstancename) (_tlOknownKinds) (_tlOknownKinds_collect) (_tlOknownTypes) (_tlOknownTypes_collect) (_tlOknownValues) (_tlOknownValues_collect) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOmoduleTypes) (_tlOmoduleValues) (_tlOnameType) (_tlOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _hdImodules `Set.union` _tlImodules
            -- use rule
            (_lhsOres@_) =
                _hdIres ++ _tlIres
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _tlIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _tlIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _tlIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _tlImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _tlImoduleValues
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_hdOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_hdOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_hdOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_hdOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_hdOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_hdOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_hdOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_tlOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_tlOknownKinds_collect@_) =
                _hdIknownKinds_collect
            -- copy rule (down)
            (_tlOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_tlOknownTypes_collect@_) =
                _hdIknownTypes_collect
            -- copy rule (down)
            (_tlOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_tlOknownValues_collect@_) =
                _hdIknownValues_collect
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_tlOmoduleTypes@_) =
                _hdImoduleTypes
            -- copy rule (chain)
            (_tlOmoduleValues@_) =
                _hdImoduleValues
            -- copy rule (down)
            (_tlOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Imports_Nil :: (T_Imports)
sem_Imports_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Imports)
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- InterfaceDeclaration ----------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for InterfaceDeclaration.Abstract:
      self

-}
{-
   local variables for InterfaceDeclaration.Binding:
      self

-}
{-
   local variables for InterfaceDeclaration.Consig:
      self

-}
{-
   local variables for InterfaceDeclaration.Declarations:
      self

-}
{-
   local variables for InterfaceDeclaration.Dependency:
      self

-}
{-
   local variables for InterfaceDeclaration.Import:
      self

-}
{-
   local variables for InterfaceDeclaration.SetModule:
      currentModule
      self

-}
-- semantic domain
type T_InterfaceDeclaration = (Maybe Name) ->
                              (FMap Name Names) ->
                              (FMap Name Names) ->
                              (Strings) ->
                              (Bool) ->
                              (Maybe Name) ->
                              (FMap Name [Name]) ->
                              (FMap Name [Name]) ->
                              (FMap Name [Name]) ->
                              (FMap Name [Name]) ->
                              (FMap Name [Name]) ->
                              (FMap Name [Name]) ->
                              (FMap Name [Name]) ->
                              (FMap Name Names) ->
                              (FMap Name Names) ->
                              (Bool) ->
                              (FMap Name Names) ->
                              (FMap Name Names) ->
                              (FMap ModuleName [Name]) ->
                              (FMap ModuleName [Name]) ->
                              (NameType) ->
                              (Bool) ->
                              ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(InterfaceDeclaration))
-- cata
sem_InterfaceDeclaration :: (InterfaceDeclaration) ->
                            (T_InterfaceDeclaration)
sem_InterfaceDeclaration ((InterfaceDeclaration_Abstract (_range) (_name) (_constructors) (_types) (_kind))) =
    (sem_InterfaceDeclaration_Abstract ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Names (_constructors))) ((sem_Types (_types))) ((sem_Kind (_kind))))
sem_InterfaceDeclaration ((InterfaceDeclaration_Binding (_range) (_name))) =
    (sem_InterfaceDeclaration_Binding ((sem_Range (_range))) ((sem_Name (_name))))
sem_InterfaceDeclaration ((InterfaceDeclaration_Consig (_range) (_typelevel) (_name) (_types))) =
    (sem_InterfaceDeclaration_Consig ((sem_Range (_range))) (_typelevel) ((sem_Name (_name))) ((sem_TypeArguments (_types))))
sem_InterfaceDeclaration ((InterfaceDeclaration_Declarations (_range) (_declarations))) =
    (sem_InterfaceDeclaration_Declarations ((sem_Range (_range))) ((sem_Declarations (_declarations))))
sem_InterfaceDeclaration ((InterfaceDeclaration_Dependency (_range) (_name) (_kind) (_bindings))) =
    (sem_InterfaceDeclaration_Dependency ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Kind (_kind))) ((sem_DependencyBindings (_bindings))))
sem_InterfaceDeclaration ((InterfaceDeclaration_Import (_range) (_module))) =
    (sem_InterfaceDeclaration_Import ((sem_Range (_range))) ((sem_ModuleName (_module))))
sem_InterfaceDeclaration ((InterfaceDeclaration_SetModule (_range) (_module) (_declarations))) =
    (sem_InterfaceDeclaration_SetModule ((sem_Range (_range))) ((sem_ModuleName (_module))) ((sem_InterfaceDeclarations (_declarations))))
sem_InterfaceDeclaration_Abstract :: (T_Range) ->
                                     (T_Name) ->
                                     (T_Names) ->
                                     (T_Types) ->
                                     (T_Kind) ->
                                     (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Abstract (range_) (name_) (constructors_) (types_) (kind_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (InterfaceDeclaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _constructorsIconstructors_collect :: (FMap Name Names)
            _constructorsIknownKinds_collect :: (FMap Name [Name])
            _constructorsIknownTypes_collect :: (FMap Name [Name])
            _constructorsIknownValues_collect :: (FMap Name [Name])
            _constructorsIlabels_collect :: (FMap Name Names)
            _constructorsImethods_collect :: (FMap Name Names)
            _constructorsImoduleTypes :: (FMap ModuleName [Name])
            _constructorsImoduleValues :: (FMap ModuleName [Name])
            _constructorsImodules :: (Set.Set Strings)
            _constructorsIoriginalSelf :: (Names)
            _constructorsIres :: ([ResolveResult])
            _constructorsIself :: (Names)
            _constructorsOclassname :: (Maybe Name)
            _constructorsOconstructors_collect :: (FMap Name Names)
            _constructorsOconstructors_dist :: (FMap Name Names)
            _constructorsOcurrentModule :: (Strings)
            _constructorsOimportedModule :: (Bool)
            _constructorsOinstancename :: (Maybe Name)
            _constructorsOknownKinds :: (FMap Name [Name])
            _constructorsOknownKinds_collect :: (FMap Name [Name])
            _constructorsOknownTypes :: (FMap Name [Name])
            _constructorsOknownTypes_collect :: (FMap Name [Name])
            _constructorsOknownValues :: (FMap Name [Name])
            _constructorsOknownValues_collect :: (FMap Name [Name])
            _constructorsOlabels_collect :: (FMap Name Names)
            _constructorsOlabels_dist :: (FMap Name Names)
            _constructorsOlocal :: (Bool)
            _constructorsOmethods_collect :: (FMap Name Names)
            _constructorsOmethods_dist :: (FMap Name Names)
            _constructorsOmoduleTypes :: (FMap ModuleName [Name])
            _constructorsOmoduleValues :: (FMap ModuleName [Name])
            _constructorsOnameType :: (NameType)
            _constructorsOtoplevel :: (Bool)
            _typesIconstructors_collect :: (FMap Name Names)
            _typesIknownKinds_collect :: (FMap Name [Name])
            _typesIknownTypes_collect :: (FMap Name [Name])
            _typesIknownValues_collect :: (FMap Name [Name])
            _typesIlabels_collect :: (FMap Name Names)
            _typesImethods_collect :: (FMap Name Names)
            _typesImoduleTypes :: (FMap ModuleName [Name])
            _typesImoduleValues :: (FMap ModuleName [Name])
            _typesImodules :: (Set.Set Strings)
            _typesIres :: ([ResolveResult])
            _typesIself :: (Types)
            _typesOclassname :: (Maybe Name)
            _typesOconstructors_collect :: (FMap Name Names)
            _typesOconstructors_dist :: (FMap Name Names)
            _typesOcurrentModule :: (Strings)
            _typesOimportedModule :: (Bool)
            _typesOinstancename :: (Maybe Name)
            _typesOknownGenerics :: (FMap Name [Name])
            _typesOknownKinds :: (FMap Name [Name])
            _typesOknownKinds_collect :: (FMap Name [Name])
            _typesOknownTypes :: (FMap Name [Name])
            _typesOknownTypes_collect :: (FMap Name [Name])
            _typesOknownValues :: (FMap Name [Name])
            _typesOknownValues_collect :: (FMap Name [Name])
            _typesOlabels_collect :: (FMap Name Names)
            _typesOlabels_dist :: (FMap Name Names)
            _typesOlocal :: (Bool)
            _typesOmethods_collect :: (FMap Name Names)
            _typesOmethods_dist :: (FMap Name Names)
            _typesOmoduleTypes :: (FMap ModuleName [Name])
            _typesOmoduleValues :: (FMap ModuleName [Name])
            _typesOnameType :: (NameType)
            _typesOtoplevel :: (Bool)
            _kindIconstructors_collect :: (FMap Name Names)
            _kindIknownKinds_collect :: (FMap Name [Name])
            _kindIknownTypes_collect :: (FMap Name [Name])
            _kindIknownValues_collect :: (FMap Name [Name])
            _kindIlabels_collect :: (FMap Name Names)
            _kindImethods_collect :: (FMap Name Names)
            _kindImoduleTypes :: (FMap ModuleName [Name])
            _kindImoduleValues :: (FMap ModuleName [Name])
            _kindImodules :: (Set.Set Strings)
            _kindIres :: ([ResolveResult])
            _kindIself :: (Kind)
            _kindOclassname :: (Maybe Name)
            _kindOconstructors_collect :: (FMap Name Names)
            _kindOconstructors_dist :: (FMap Name Names)
            _kindOcurrentModule :: (Strings)
            _kindOimportedModule :: (Bool)
            _kindOinstancename :: (Maybe Name)
            _kindOknownKinds :: (FMap Name [Name])
            _kindOknownKinds_collect :: (FMap Name [Name])
            _kindOknownTypes :: (FMap Name [Name])
            _kindOknownTypes_collect :: (FMap Name [Name])
            _kindOknownValues :: (FMap Name [Name])
            _kindOknownValues_collect :: (FMap Name [Name])
            _kindOlabels_collect :: (FMap Name Names)
            _kindOlabels_dist :: (FMap Name Names)
            _kindOlocal :: (Bool)
            _kindOmethods_collect :: (FMap Name Names)
            _kindOmethods_dist :: (FMap Name Names)
            _kindOmoduleTypes :: (FMap ModuleName [Name])
            _kindOmoduleValues :: (FMap ModuleName [Name])
            _kindOnameType :: (NameType)
            _kindOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _constructorsIconstructors_collect,_constructorsIknownKinds_collect,_constructorsIknownTypes_collect,_constructorsIknownValues_collect,_constructorsIlabels_collect,_constructorsImethods_collect,_constructorsImoduleTypes,_constructorsImoduleValues,_constructorsImodules,_constructorsIoriginalSelf,_constructorsIres,_constructorsIself) =
                (constructors_ (_constructorsOclassname)
                               (_constructorsOconstructors_collect)
                               (_constructorsOconstructors_dist)
                               (_constructorsOcurrentModule)
                               (_constructorsOimportedModule)
                               (_constructorsOinstancename)
                               (_constructorsOknownKinds)
                               (_constructorsOknownKinds_collect)
                               (_constructorsOknownTypes)
                               (_constructorsOknownTypes_collect)
                               (_constructorsOknownValues)
                               (_constructorsOknownValues_collect)
                               (_constructorsOlabels_collect)
                               (_constructorsOlabels_dist)
                               (_constructorsOlocal)
                               (_constructorsOmethods_collect)
                               (_constructorsOmethods_dist)
                               (_constructorsOmoduleTypes)
                               (_constructorsOmoduleValues)
                               (_constructorsOnameType)
                               (_constructorsOtoplevel))
            ( _typesIconstructors_collect,_typesIknownKinds_collect,_typesIknownTypes_collect,_typesIknownValues_collect,_typesIlabels_collect,_typesImethods_collect,_typesImoduleTypes,_typesImoduleValues,_typesImodules,_typesIres,_typesIself) =
                (types_ (_typesOclassname)
                        (_typesOconstructors_collect)
                        (_typesOconstructors_dist)
                        (_typesOcurrentModule)
                        (_typesOimportedModule)
                        (_typesOinstancename)
                        (_typesOknownGenerics)
                        (_typesOknownKinds)
                        (_typesOknownKinds_collect)
                        (_typesOknownTypes)
                        (_typesOknownTypes_collect)
                        (_typesOknownValues)
                        (_typesOknownValues_collect)
                        (_typesOlabels_collect)
                        (_typesOlabels_dist)
                        (_typesOlocal)
                        (_typesOmethods_collect)
                        (_typesOmethods_dist)
                        (_typesOmoduleTypes)
                        (_typesOmoduleValues)
                        (_typesOnameType)
                        (_typesOtoplevel))
            ( _kindIconstructors_collect,_kindIknownKinds_collect,_kindIknownTypes_collect,_kindIknownValues_collect,_kindIlabels_collect,_kindImethods_collect,_kindImoduleTypes,_kindImoduleValues,_kindImodules,_kindIres,_kindIself) =
                (kind_ (_kindOclassname)
                       (_kindOconstructors_collect)
                       (_kindOconstructors_dist)
                       (_kindOcurrentModule)
                       (_kindOimportedModule)
                       (_kindOinstancename)
                       (_kindOknownKinds)
                       (_kindOknownKinds_collect)
                       (_kindOknownTypes)
                       (_kindOknownTypes_collect)
                       (_kindOknownValues)
                       (_kindOknownValues_collect)
                       (_kindOlabels_collect)
                       (_kindOlabels_dist)
                       (_kindOlocal)
                       (_kindOmethods_collect)
                       (_kindOmethods_dist)
                       (_kindOmoduleTypes)
                       (_kindOmoduleValues)
                       (_kindOnameType)
                       (_kindOtoplevel))
            -- "./NameTypes.inc.lag"(line 130, column 9)
            (_constructorsOnameType@_) =
                Def_Typ
            -- "./NameTypes.inc.lag"(line 129, column 9)
            (_nameOnameType@_) =
                Def_Typ
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _constructorsImodules `Set.union` _typesImodules `Set.union` _kindImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _constructorsIres ++ _typesIres ++ _kindIres
            -- self rule
            (_self@_) =
                InterfaceDeclaration_Abstract _rangeIself _nameIself _constructorsIself _typesIself _kindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _kindIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _kindIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _kindIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _kindIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _kindIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _kindImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _kindImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _kindImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_constructorsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_constructorsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_constructorsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_constructorsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_constructorsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_constructorsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_constructorsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_constructorsOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_constructorsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_constructorsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (down)
            (_constructorsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_constructorsOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_constructorsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_constructorsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_constructorsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_constructorsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_constructorsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_constructorsOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_constructorsOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_constructorsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typesOconstructors_collect@_) =
                _constructorsIconstructors_collect
            -- copy rule (down)
            (_typesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typesOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_typesOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_typesOknownKinds_collect@_) =
                _constructorsIknownKinds_collect
            -- copy rule (down)
            (_typesOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_typesOknownTypes_collect@_) =
                _constructorsIknownTypes_collect
            -- copy rule (down)
            (_typesOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_typesOknownValues_collect@_) =
                _constructorsIknownValues_collect
            -- copy rule (chain)
            (_typesOlabels_collect@_) =
                _constructorsIlabels_collect
            -- copy rule (down)
            (_typesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typesOmethods_collect@_) =
                _constructorsImethods_collect
            -- copy rule (down)
            (_typesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_typesOmoduleTypes@_) =
                _constructorsImoduleTypes
            -- copy rule (chain)
            (_typesOmoduleValues@_) =
                _constructorsImoduleValues
            -- copy rule (down)
            (_typesOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_typesOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_kindOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_kindOconstructors_collect@_) =
                _typesIconstructors_collect
            -- copy rule (down)
            (_kindOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_kindOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_kindOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_kindOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_kindOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_kindOknownKinds_collect@_) =
                _typesIknownKinds_collect
            -- copy rule (down)
            (_kindOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_kindOknownTypes_collect@_) =
                _typesIknownTypes_collect
            -- copy rule (down)
            (_kindOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_kindOknownValues_collect@_) =
                _typesIknownValues_collect
            -- copy rule (chain)
            (_kindOlabels_collect@_) =
                _typesIlabels_collect
            -- copy rule (down)
            (_kindOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_kindOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_kindOmethods_collect@_) =
                _typesImethods_collect
            -- copy rule (down)
            (_kindOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_kindOmoduleTypes@_) =
                _typesImoduleTypes
            -- copy rule (chain)
            (_kindOmoduleValues@_) =
                _typesImoduleValues
            -- copy rule (down)
            (_kindOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_kindOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_InterfaceDeclaration_Binding :: (T_Range) ->
                                    (T_Name) ->
                                    (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Binding (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (InterfaceDeclaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres
            -- self rule
            (_self@_) =
                InterfaceDeclaration_Binding _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_InterfaceDeclaration_Consig :: (T_Range) ->
                                   (Bool) ->
                                   (T_Name) ->
                                   (T_TypeArguments) ->
                                   (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Consig (range_) (typelevel_) (name_) (types_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (InterfaceDeclaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _typesIconstructors_collect :: (FMap Name Names)
            _typesIknownKinds_collect :: (FMap Name [Name])
            _typesIknownTypes_collect :: (FMap Name [Name])
            _typesIknownValues_collect :: (FMap Name [Name])
            _typesIlabels_collect :: (FMap Name Names)
            _typesImethods_collect :: (FMap Name Names)
            _typesImoduleTypes :: (FMap ModuleName [Name])
            _typesImoduleValues :: (FMap ModuleName [Name])
            _typesImodules :: (Set.Set Strings)
            _typesIres :: ([ResolveResult])
            _typesIself :: (TypeArguments)
            _typesOclassname :: (Maybe Name)
            _typesOconstructors_collect :: (FMap Name Names)
            _typesOconstructors_dist :: (FMap Name Names)
            _typesOcurrentModule :: (Strings)
            _typesOimportedModule :: (Bool)
            _typesOinstancename :: (Maybe Name)
            _typesOknownKinds :: (FMap Name [Name])
            _typesOknownKinds_collect :: (FMap Name [Name])
            _typesOknownTypes :: (FMap Name [Name])
            _typesOknownTypes_collect :: (FMap Name [Name])
            _typesOknownValues :: (FMap Name [Name])
            _typesOknownValues_collect :: (FMap Name [Name])
            _typesOlabels_collect :: (FMap Name Names)
            _typesOlabels_dist :: (FMap Name Names)
            _typesOlocal :: (Bool)
            _typesOmethods_collect :: (FMap Name Names)
            _typesOmethods_dist :: (FMap Name Names)
            _typesOmoduleTypes :: (FMap ModuleName [Name])
            _typesOmoduleValues :: (FMap ModuleName [Name])
            _typesOnameType :: (NameType)
            _typesOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _typesIconstructors_collect,_typesIknownKinds_collect,_typesIknownTypes_collect,_typesIknownValues_collect,_typesIlabels_collect,_typesImethods_collect,_typesImoduleTypes,_typesImoduleValues,_typesImodules,_typesIres,_typesIself) =
                (types_ (_typesOclassname)
                        (_typesOconstructors_collect)
                        (_typesOconstructors_dist)
                        (_typesOcurrentModule)
                        (_typesOimportedModule)
                        (_typesOinstancename)
                        (_typesOknownKinds)
                        (_typesOknownKinds_collect)
                        (_typesOknownTypes)
                        (_typesOknownTypes_collect)
                        (_typesOknownValues)
                        (_typesOknownValues_collect)
                        (_typesOlabels_collect)
                        (_typesOlabels_dist)
                        (_typesOlocal)
                        (_typesOmethods_collect)
                        (_typesOmethods_dist)
                        (_typesOmoduleTypes)
                        (_typesOmoduleValues)
                        (_typesOnameType)
                        (_typesOtoplevel))
            -- "./NameTypes.inc.lag"(line 134, column 9)
            (_typesOnameType@_) =
                ref_Typ
            -- "./NameTypes.inc.lag"(line 132, column 9)
            (_nameOnameType@_) =
                if typelevel_ then Def_Typ
                              else Def_Val
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _typesImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _typesIres
            -- self rule
            (_self@_) =
                InterfaceDeclaration_Consig _rangeIself typelevel_ _nameIself _typesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typesIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _typesIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _typesIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _typesIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typesIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typesImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _typesImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _typesImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typesOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_typesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typesOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_typesOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_typesOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_typesOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (down)
            (_typesOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_typesOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_typesOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_typesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typesOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_typesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_typesOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_typesOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_typesOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_InterfaceDeclaration_Declarations :: (T_Range) ->
                                         (T_Declarations) ->
                                         (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Declarations (range_) (declarations_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (InterfaceDeclaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _declarationsIconstructors_collect :: (FMap Name Names)
            _declarationsIknownKinds_collect :: (FMap Name [Name])
            _declarationsIknownTypes_collect :: (FMap Name [Name])
            _declarationsIknownValues_collect :: (FMap Name [Name])
            _declarationsIlabels_collect :: (FMap Name Names)
            _declarationsImethods_collect :: (FMap Name Names)
            _declarationsImoduleTypes :: (FMap ModuleName [Name])
            _declarationsImoduleValues :: (FMap ModuleName [Name])
            _declarationsImodules :: (Set.Set Strings)
            _declarationsIres :: ([ResolveResult])
            _declarationsIself :: (Declarations)
            _declarationsOclassname :: (Maybe Name)
            _declarationsOconstructors_collect :: (FMap Name Names)
            _declarationsOconstructors_dist :: (FMap Name Names)
            _declarationsOcurrentModule :: (Strings)
            _declarationsOimportedModule :: (Bool)
            _declarationsOinstancename :: (Maybe Name)
            _declarationsOknownGenerics :: (FMap Name [Name])
            _declarationsOknownKinds :: (FMap Name [Name])
            _declarationsOknownKinds_collect :: (FMap Name [Name])
            _declarationsOknownTypes :: (FMap Name [Name])
            _declarationsOknownTypes_collect :: (FMap Name [Name])
            _declarationsOknownValues :: (FMap Name [Name])
            _declarationsOknownValues_collect :: (FMap Name [Name])
            _declarationsOlabels_collect :: (FMap Name Names)
            _declarationsOlabels_dist :: (FMap Name Names)
            _declarationsOlocal :: (Bool)
            _declarationsOmethods_collect :: (FMap Name Names)
            _declarationsOmethods_dist :: (FMap Name Names)
            _declarationsOmoduleTypes :: (FMap ModuleName [Name])
            _declarationsOmoduleValues :: (FMap ModuleName [Name])
            _declarationsOnameType :: (NameType)
            _declarationsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _declarationsIconstructors_collect,_declarationsIknownKinds_collect,_declarationsIknownTypes_collect,_declarationsIknownValues_collect,_declarationsIlabels_collect,_declarationsImethods_collect,_declarationsImoduleTypes,_declarationsImoduleValues,_declarationsImodules,_declarationsIres,_declarationsIself) =
                (declarations_ (_declarationsOclassname)
                               (_declarationsOconstructors_collect)
                               (_declarationsOconstructors_dist)
                               (_declarationsOcurrentModule)
                               (_declarationsOimportedModule)
                               (_declarationsOinstancename)
                               (_declarationsOknownGenerics)
                               (_declarationsOknownKinds)
                               (_declarationsOknownKinds_collect)
                               (_declarationsOknownTypes)
                               (_declarationsOknownTypes_collect)
                               (_declarationsOknownValues)
                               (_declarationsOknownValues_collect)
                               (_declarationsOlabels_collect)
                               (_declarationsOlabels_dist)
                               (_declarationsOlocal)
                               (_declarationsOmethods_collect)
                               (_declarationsOmethods_dist)
                               (_declarationsOmoduleTypes)
                               (_declarationsOmoduleValues)
                               (_declarationsOnameType)
                               (_declarationsOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _declarationsImodules
            -- use rule
            (_lhsOres@_) =
                _declarationsIres
            -- self rule
            (_self@_) =
                InterfaceDeclaration_Declarations _rangeIself _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _declarationsIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _declarationsIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _declarationsIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _declarationsIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _declarationsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _declarationsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _declarationsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _declarationsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_declarationsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_declarationsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_declarationsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_declarationsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_declarationsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_declarationsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_declarationsOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_declarationsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_declarationsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_declarationsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_declarationsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_declarationsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_declarationsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_declarationsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_declarationsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_declarationsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_declarationsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_declarationsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_declarationsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_declarationsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_declarationsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_declarationsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_InterfaceDeclaration_Dependency :: (T_Range) ->
                                       (T_Name) ->
                                       (T_Kind) ->
                                       (T_DependencyBindings) ->
                                       (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Dependency (range_) (name_) (kind_) (bindings_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (InterfaceDeclaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _kindIconstructors_collect :: (FMap Name Names)
            _kindIknownKinds_collect :: (FMap Name [Name])
            _kindIknownTypes_collect :: (FMap Name [Name])
            _kindIknownValues_collect :: (FMap Name [Name])
            _kindIlabels_collect :: (FMap Name Names)
            _kindImethods_collect :: (FMap Name Names)
            _kindImoduleTypes :: (FMap ModuleName [Name])
            _kindImoduleValues :: (FMap ModuleName [Name])
            _kindImodules :: (Set.Set Strings)
            _kindIres :: ([ResolveResult])
            _kindIself :: (Kind)
            _kindOclassname :: (Maybe Name)
            _kindOconstructors_collect :: (FMap Name Names)
            _kindOconstructors_dist :: (FMap Name Names)
            _kindOcurrentModule :: (Strings)
            _kindOimportedModule :: (Bool)
            _kindOinstancename :: (Maybe Name)
            _kindOknownKinds :: (FMap Name [Name])
            _kindOknownKinds_collect :: (FMap Name [Name])
            _kindOknownTypes :: (FMap Name [Name])
            _kindOknownTypes_collect :: (FMap Name [Name])
            _kindOknownValues :: (FMap Name [Name])
            _kindOknownValues_collect :: (FMap Name [Name])
            _kindOlabels_collect :: (FMap Name Names)
            _kindOlabels_dist :: (FMap Name Names)
            _kindOlocal :: (Bool)
            _kindOmethods_collect :: (FMap Name Names)
            _kindOmethods_dist :: (FMap Name Names)
            _kindOmoduleTypes :: (FMap ModuleName [Name])
            _kindOmoduleValues :: (FMap ModuleName [Name])
            _kindOnameType :: (NameType)
            _kindOtoplevel :: (Bool)
            _bindingsIconstructors_collect :: (FMap Name Names)
            _bindingsIknownKinds_collect :: (FMap Name [Name])
            _bindingsIknownTypes_collect :: (FMap Name [Name])
            _bindingsIknownValues_collect :: (FMap Name [Name])
            _bindingsIlabels_collect :: (FMap Name Names)
            _bindingsImethods_collect :: (FMap Name Names)
            _bindingsImoduleTypes :: (FMap ModuleName [Name])
            _bindingsImoduleValues :: (FMap ModuleName [Name])
            _bindingsImodules :: (Set.Set Strings)
            _bindingsIres :: ([ResolveResult])
            _bindingsIself :: (DependencyBindings)
            _bindingsOclassname :: (Maybe Name)
            _bindingsOconstructors_collect :: (FMap Name Names)
            _bindingsOconstructors_dist :: (FMap Name Names)
            _bindingsOcurrentModule :: (Strings)
            _bindingsOimportedModule :: (Bool)
            _bindingsOinstancename :: (Maybe Name)
            _bindingsOknownKinds :: (FMap Name [Name])
            _bindingsOknownKinds_collect :: (FMap Name [Name])
            _bindingsOknownTypes :: (FMap Name [Name])
            _bindingsOknownTypes_collect :: (FMap Name [Name])
            _bindingsOknownValues :: (FMap Name [Name])
            _bindingsOknownValues_collect :: (FMap Name [Name])
            _bindingsOlabels_collect :: (FMap Name Names)
            _bindingsOlabels_dist :: (FMap Name Names)
            _bindingsOlocal :: (Bool)
            _bindingsOmethods_collect :: (FMap Name Names)
            _bindingsOmethods_dist :: (FMap Name Names)
            _bindingsOmoduleTypes :: (FMap ModuleName [Name])
            _bindingsOmoduleValues :: (FMap ModuleName [Name])
            _bindingsOnameType :: (NameType)
            _bindingsOtoplevel :: (Bool)
            _bindingsOtypelevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _kindIconstructors_collect,_kindIknownKinds_collect,_kindIknownTypes_collect,_kindIknownValues_collect,_kindIlabels_collect,_kindImethods_collect,_kindImoduleTypes,_kindImoduleValues,_kindImodules,_kindIres,_kindIself) =
                (kind_ (_kindOclassname)
                       (_kindOconstructors_collect)
                       (_kindOconstructors_dist)
                       (_kindOcurrentModule)
                       (_kindOimportedModule)
                       (_kindOinstancename)
                       (_kindOknownKinds)
                       (_kindOknownKinds_collect)
                       (_kindOknownTypes)
                       (_kindOknownTypes_collect)
                       (_kindOknownValues)
                       (_kindOknownValues_collect)
                       (_kindOlabels_collect)
                       (_kindOlabels_dist)
                       (_kindOlocal)
                       (_kindOmethods_collect)
                       (_kindOmethods_dist)
                       (_kindOmoduleTypes)
                       (_kindOmoduleValues)
                       (_kindOnameType)
                       (_kindOtoplevel))
            ( _bindingsIconstructors_collect,_bindingsIknownKinds_collect,_bindingsIknownTypes_collect,_bindingsIknownValues_collect,_bindingsIlabels_collect,_bindingsImethods_collect,_bindingsImoduleTypes,_bindingsImoduleValues,_bindingsImodules,_bindingsIres,_bindingsIself) =
                (bindings_ (_bindingsOclassname)
                           (_bindingsOconstructors_collect)
                           (_bindingsOconstructors_dist)
                           (_bindingsOcurrentModule)
                           (_bindingsOimportedModule)
                           (_bindingsOinstancename)
                           (_bindingsOknownKinds)
                           (_bindingsOknownKinds_collect)
                           (_bindingsOknownTypes)
                           (_bindingsOknownTypes_collect)
                           (_bindingsOknownValues)
                           (_bindingsOknownValues_collect)
                           (_bindingsOlabels_collect)
                           (_bindingsOlabels_dist)
                           (_bindingsOlocal)
                           (_bindingsOmethods_collect)
                           (_bindingsOmethods_dist)
                           (_bindingsOmoduleTypes)
                           (_bindingsOmoduleValues)
                           (_bindingsOnameType)
                           (_bindingsOtoplevel)
                           (_bindingsOtypelevel))
            -- "./ModuleInformation.inc.lag"(line 219, column 9)
            (_bindingsOtypelevel@_) =
                False
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _kindImodules `Set.union` _bindingsImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _kindIres ++ _bindingsIres
            -- self rule
            (_self@_) =
                InterfaceDeclaration_Dependency _rangeIself _nameIself _kindIself _bindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _bindingsIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _bindingsIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _bindingsIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _bindingsIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _bindingsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _bindingsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _bindingsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _bindingsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_kindOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_kindOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_kindOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_kindOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_kindOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_kindOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_kindOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_kindOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_kindOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_kindOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (down)
            (_kindOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_kindOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_kindOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_kindOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_kindOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_kindOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_kindOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_kindOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_kindOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_kindOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_kindOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_bindingsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_bindingsOconstructors_collect@_) =
                _kindIconstructors_collect
            -- copy rule (down)
            (_bindingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_bindingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_bindingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_bindingsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_bindingsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_bindingsOknownKinds_collect@_) =
                _kindIknownKinds_collect
            -- copy rule (down)
            (_bindingsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_bindingsOknownTypes_collect@_) =
                _kindIknownTypes_collect
            -- copy rule (down)
            (_bindingsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_bindingsOknownValues_collect@_) =
                _kindIknownValues_collect
            -- copy rule (chain)
            (_bindingsOlabels_collect@_) =
                _kindIlabels_collect
            -- copy rule (down)
            (_bindingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_bindingsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_bindingsOmethods_collect@_) =
                _kindImethods_collect
            -- copy rule (down)
            (_bindingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_bindingsOmoduleTypes@_) =
                _kindImoduleTypes
            -- copy rule (chain)
            (_bindingsOmoduleValues@_) =
                _kindImoduleValues
            -- copy rule (down)
            (_bindingsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_bindingsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_InterfaceDeclaration_Import :: (T_Range) ->
                                   (T_ModuleName) ->
                                   (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Import (range_) (module_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (InterfaceDeclaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _moduleIconstructors_collect :: (FMap Name Names)
            _moduleIknownKinds_collect :: (FMap Name [Name])
            _moduleIknownTypes_collect :: (FMap Name [Name])
            _moduleIknownValues_collect :: (FMap Name [Name])
            _moduleIlabels_collect :: (FMap Name Names)
            _moduleImethods_collect :: (FMap Name Names)
            _moduleImoduleTypes :: (FMap ModuleName [Name])
            _moduleImoduleValues :: (FMap ModuleName [Name])
            _moduleImodules :: (Set.Set Strings)
            _moduleIres :: ([ResolveResult])
            _moduleIself :: (ModuleName)
            _moduleOclassname :: (Maybe Name)
            _moduleOconstructors_collect :: (FMap Name Names)
            _moduleOconstructors_dist :: (FMap Name Names)
            _moduleOcurrentModule :: (Strings)
            _moduleOimportedModule :: (Bool)
            _moduleOinstancename :: (Maybe Name)
            _moduleOknownKinds :: (FMap Name [Name])
            _moduleOknownKinds_collect :: (FMap Name [Name])
            _moduleOknownTypes :: (FMap Name [Name])
            _moduleOknownTypes_collect :: (FMap Name [Name])
            _moduleOknownValues :: (FMap Name [Name])
            _moduleOknownValues_collect :: (FMap Name [Name])
            _moduleOlabels_collect :: (FMap Name Names)
            _moduleOlabels_dist :: (FMap Name Names)
            _moduleOlocal :: (Bool)
            _moduleOmethods_collect :: (FMap Name Names)
            _moduleOmethods_dist :: (FMap Name Names)
            _moduleOmoduleTypes :: (FMap ModuleName [Name])
            _moduleOmoduleValues :: (FMap ModuleName [Name])
            _moduleOnameType :: (NameType)
            _moduleOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _moduleIconstructors_collect,_moduleIknownKinds_collect,_moduleIknownTypes_collect,_moduleIknownValues_collect,_moduleIlabels_collect,_moduleImethods_collect,_moduleImoduleTypes,_moduleImoduleValues,_moduleImodules,_moduleIres,_moduleIself) =
                (module_ (_moduleOclassname)
                         (_moduleOconstructors_collect)
                         (_moduleOconstructors_dist)
                         (_moduleOcurrentModule)
                         (_moduleOimportedModule)
                         (_moduleOinstancename)
                         (_moduleOknownKinds)
                         (_moduleOknownKinds_collect)
                         (_moduleOknownTypes)
                         (_moduleOknownTypes_collect)
                         (_moduleOknownValues)
                         (_moduleOknownValues_collect)
                         (_moduleOlabels_collect)
                         (_moduleOlabels_dist)
                         (_moduleOlocal)
                         (_moduleOmethods_collect)
                         (_moduleOmethods_dist)
                         (_moduleOmoduleTypes)
                         (_moduleOmoduleValues)
                         (_moduleOnameType)
                         (_moduleOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _moduleImodules
            -- use rule
            (_lhsOres@_) =
                _moduleIres
            -- self rule
            (_self@_) =
                InterfaceDeclaration_Import _rangeIself _moduleIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _moduleIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _moduleIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _moduleIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _moduleIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _moduleIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _moduleImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _moduleImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _moduleImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_moduleOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_moduleOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_moduleOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_moduleOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_moduleOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_moduleOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_moduleOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_moduleOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_moduleOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_moduleOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_moduleOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_moduleOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_moduleOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_moduleOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_moduleOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_moduleOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_moduleOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_moduleOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_moduleOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_moduleOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_moduleOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_InterfaceDeclaration_SetModule :: (T_Range) ->
                                      (T_ModuleName) ->
                                      (T_InterfaceDeclarations) ->
                                      (T_InterfaceDeclaration)
sem_InterfaceDeclaration_SetModule (range_) (module_) (declarations_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (InterfaceDeclaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _moduleIconstructors_collect :: (FMap Name Names)
            _moduleIknownKinds_collect :: (FMap Name [Name])
            _moduleIknownTypes_collect :: (FMap Name [Name])
            _moduleIknownValues_collect :: (FMap Name [Name])
            _moduleIlabels_collect :: (FMap Name Names)
            _moduleImethods_collect :: (FMap Name Names)
            _moduleImoduleTypes :: (FMap ModuleName [Name])
            _moduleImoduleValues :: (FMap ModuleName [Name])
            _moduleImodules :: (Set.Set Strings)
            _moduleIres :: ([ResolveResult])
            _moduleIself :: (ModuleName)
            _moduleOclassname :: (Maybe Name)
            _moduleOconstructors_collect :: (FMap Name Names)
            _moduleOconstructors_dist :: (FMap Name Names)
            _moduleOcurrentModule :: (Strings)
            _moduleOimportedModule :: (Bool)
            _moduleOinstancename :: (Maybe Name)
            _moduleOknownKinds :: (FMap Name [Name])
            _moduleOknownKinds_collect :: (FMap Name [Name])
            _moduleOknownTypes :: (FMap Name [Name])
            _moduleOknownTypes_collect :: (FMap Name [Name])
            _moduleOknownValues :: (FMap Name [Name])
            _moduleOknownValues_collect :: (FMap Name [Name])
            _moduleOlabels_collect :: (FMap Name Names)
            _moduleOlabels_dist :: (FMap Name Names)
            _moduleOlocal :: (Bool)
            _moduleOmethods_collect :: (FMap Name Names)
            _moduleOmethods_dist :: (FMap Name Names)
            _moduleOmoduleTypes :: (FMap ModuleName [Name])
            _moduleOmoduleValues :: (FMap ModuleName [Name])
            _moduleOnameType :: (NameType)
            _moduleOtoplevel :: (Bool)
            _declarationsIconstructors_collect :: (FMap Name Names)
            _declarationsIknownKinds_collect :: (FMap Name [Name])
            _declarationsIknownTypes_collect :: (FMap Name [Name])
            _declarationsIknownValues_collect :: (FMap Name [Name])
            _declarationsIlabels_collect :: (FMap Name Names)
            _declarationsImethods_collect :: (FMap Name Names)
            _declarationsImoduleTypes :: (FMap ModuleName [Name])
            _declarationsImoduleValues :: (FMap ModuleName [Name])
            _declarationsImodules :: (Set.Set Strings)
            _declarationsIres :: ([ResolveResult])
            _declarationsIself :: (InterfaceDeclarations)
            _declarationsOclassname :: (Maybe Name)
            _declarationsOconstructors_collect :: (FMap Name Names)
            _declarationsOconstructors_dist :: (FMap Name Names)
            _declarationsOcurrentModule :: (Strings)
            _declarationsOimportedModule :: (Bool)
            _declarationsOinstancename :: (Maybe Name)
            _declarationsOknownGenerics :: (FMap Name [Name])
            _declarationsOknownKinds :: (FMap Name [Name])
            _declarationsOknownKinds_collect :: (FMap Name [Name])
            _declarationsOknownTypes :: (FMap Name [Name])
            _declarationsOknownTypes_collect :: (FMap Name [Name])
            _declarationsOknownValues :: (FMap Name [Name])
            _declarationsOknownValues_collect :: (FMap Name [Name])
            _declarationsOlabels_collect :: (FMap Name Names)
            _declarationsOlabels_dist :: (FMap Name Names)
            _declarationsOlocal :: (Bool)
            _declarationsOmethods_collect :: (FMap Name Names)
            _declarationsOmethods_dist :: (FMap Name Names)
            _declarationsOmoduleTypes :: (FMap ModuleName [Name])
            _declarationsOmoduleValues :: (FMap ModuleName [Name])
            _declarationsOnameType :: (NameType)
            _declarationsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _moduleIconstructors_collect,_moduleIknownKinds_collect,_moduleIknownTypes_collect,_moduleIknownValues_collect,_moduleIlabels_collect,_moduleImethods_collect,_moduleImoduleTypes,_moduleImoduleValues,_moduleImodules,_moduleIres,_moduleIself) =
                (module_ (_moduleOclassname)
                         (_moduleOconstructors_collect)
                         (_moduleOconstructors_dist)
                         (_moduleOcurrentModule)
                         (_moduleOimportedModule)
                         (_moduleOinstancename)
                         (_moduleOknownKinds)
                         (_moduleOknownKinds_collect)
                         (_moduleOknownTypes)
                         (_moduleOknownTypes_collect)
                         (_moduleOknownValues)
                         (_moduleOknownValues_collect)
                         (_moduleOlabels_collect)
                         (_moduleOlabels_dist)
                         (_moduleOlocal)
                         (_moduleOmethods_collect)
                         (_moduleOmethods_dist)
                         (_moduleOmoduleTypes)
                         (_moduleOmoduleValues)
                         (_moduleOnameType)
                         (_moduleOtoplevel))
            ( _declarationsIconstructors_collect,_declarationsIknownKinds_collect,_declarationsIknownTypes_collect,_declarationsIknownValues_collect,_declarationsIlabels_collect,_declarationsImethods_collect,_declarationsImoduleTypes,_declarationsImoduleValues,_declarationsImodules,_declarationsIres,_declarationsIself) =
                (declarations_ (_declarationsOclassname)
                               (_declarationsOconstructors_collect)
                               (_declarationsOconstructors_dist)
                               (_declarationsOcurrentModule)
                               (_declarationsOimportedModule)
                               (_declarationsOinstancename)
                               (_declarationsOknownGenerics)
                               (_declarationsOknownKinds)
                               (_declarationsOknownKinds_collect)
                               (_declarationsOknownTypes)
                               (_declarationsOknownTypes_collect)
                               (_declarationsOknownValues)
                               (_declarationsOknownValues_collect)
                               (_declarationsOlabels_collect)
                               (_declarationsOlabels_dist)
                               (_declarationsOlocal)
                               (_declarationsOmethods_collect)
                               (_declarationsOmethods_dist)
                               (_declarationsOmoduleTypes)
                               (_declarationsOmoduleValues)
                               (_declarationsOnameType)
                               (_declarationsOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 134, column 8)
            (_currentModule@_) =
                getModuleName _moduleIself
            -- use rule
            (_lhsOmodules@_) =
                _moduleImodules `Set.union` _declarationsImodules
            -- use rule
            (_lhsOres@_) =
                _moduleIres ++ _declarationsIres
            -- self rule
            (_self@_) =
                InterfaceDeclaration_SetModule _rangeIself _moduleIself _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _declarationsIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _declarationsIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _declarationsIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _declarationsIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _declarationsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _declarationsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _declarationsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _declarationsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_rangeOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_moduleOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_moduleOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_moduleOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_moduleOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_moduleOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_moduleOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_moduleOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_moduleOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_moduleOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_moduleOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_moduleOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_moduleOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_moduleOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_moduleOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_moduleOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_moduleOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_moduleOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_moduleOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_moduleOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_moduleOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_moduleOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_declarationsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_declarationsOconstructors_collect@_) =
                _moduleIconstructors_collect
            -- copy rule (down)
            (_declarationsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_declarationsOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_declarationsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_declarationsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_declarationsOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_declarationsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_declarationsOknownKinds_collect@_) =
                _moduleIknownKinds_collect
            -- copy rule (down)
            (_declarationsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_declarationsOknownTypes_collect@_) =
                _moduleIknownTypes_collect
            -- copy rule (down)
            (_declarationsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_declarationsOknownValues_collect@_) =
                _moduleIknownValues_collect
            -- copy rule (chain)
            (_declarationsOlabels_collect@_) =
                _moduleIlabels_collect
            -- copy rule (down)
            (_declarationsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_declarationsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_declarationsOmethods_collect@_) =
                _moduleImethods_collect
            -- copy rule (down)
            (_declarationsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_declarationsOmoduleTypes@_) =
                _moduleImoduleTypes
            -- copy rule (chain)
            (_declarationsOmoduleValues@_) =
                _moduleImoduleValues
            -- copy rule (down)
            (_declarationsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_declarationsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- InterfaceDeclarations ---------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for InterfaceDeclarations.Cons:
      self

-}
{-
   local variables for InterfaceDeclarations.Nil:
      self

-}
-- semantic domain
type T_InterfaceDeclarations = (Maybe Name) ->
                               (FMap Name Names) ->
                               (FMap Name Names) ->
                               (Strings) ->
                               (Bool) ->
                               (Maybe Name) ->
                               (FMap Name [Name]) ->
                               (FMap Name [Name]) ->
                               (FMap Name [Name]) ->
                               (FMap Name [Name]) ->
                               (FMap Name [Name]) ->
                               (FMap Name [Name]) ->
                               (FMap Name [Name]) ->
                               (FMap Name Names) ->
                               (FMap Name Names) ->
                               (Bool) ->
                               (FMap Name Names) ->
                               (FMap Name Names) ->
                               (FMap ModuleName [Name]) ->
                               (FMap ModuleName [Name]) ->
                               (NameType) ->
                               (Bool) ->
                               ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(InterfaceDeclarations))
-- cata
sem_InterfaceDeclarations :: (InterfaceDeclarations) ->
                             (T_InterfaceDeclarations)
sem_InterfaceDeclarations (list) =
    (foldr (sem_InterfaceDeclarations_Cons) (sem_InterfaceDeclarations_Nil) ((map sem_InterfaceDeclaration list)))
sem_InterfaceDeclarations_Cons :: (T_InterfaceDeclaration) ->
                                  (T_InterfaceDeclarations) ->
                                  (T_InterfaceDeclarations)
sem_InterfaceDeclarations_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (InterfaceDeclarations)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIknownKinds_collect :: (FMap Name [Name])
            _hdIknownTypes_collect :: (FMap Name [Name])
            _hdIknownValues_collect :: (FMap Name [Name])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdImoduleTypes :: (FMap ModuleName [Name])
            _hdImoduleValues :: (FMap ModuleName [Name])
            _hdImodules :: (Set.Set Strings)
            _hdIres :: ([ResolveResult])
            _hdIself :: (InterfaceDeclaration)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOknownGenerics :: (FMap Name [Name])
            _hdOknownKinds :: (FMap Name [Name])
            _hdOknownKinds_collect :: (FMap Name [Name])
            _hdOknownTypes :: (FMap Name [Name])
            _hdOknownTypes_collect :: (FMap Name [Name])
            _hdOknownValues :: (FMap Name [Name])
            _hdOknownValues_collect :: (FMap Name [Name])
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmoduleTypes :: (FMap ModuleName [Name])
            _hdOmoduleValues :: (FMap ModuleName [Name])
            _hdOnameType :: (NameType)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIknownKinds_collect :: (FMap Name [Name])
            _tlIknownTypes_collect :: (FMap Name [Name])
            _tlIknownValues_collect :: (FMap Name [Name])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlImoduleTypes :: (FMap ModuleName [Name])
            _tlImoduleValues :: (FMap ModuleName [Name])
            _tlImodules :: (Set.Set Strings)
            _tlIres :: ([ResolveResult])
            _tlIself :: (InterfaceDeclarations)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOknownGenerics :: (FMap Name [Name])
            _tlOknownKinds :: (FMap Name [Name])
            _tlOknownKinds_collect :: (FMap Name [Name])
            _tlOknownTypes :: (FMap Name [Name])
            _tlOknownTypes_collect :: (FMap Name [Name])
            _tlOknownValues :: (FMap Name [Name])
            _tlOknownValues_collect :: (FMap Name [Name])
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmoduleTypes :: (FMap ModuleName [Name])
            _tlOmoduleValues :: (FMap ModuleName [Name])
            _tlOnameType :: (NameType)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIknownKinds_collect,_hdIknownTypes_collect,_hdIknownValues_collect,_hdIlabels_collect,_hdImethods_collect,_hdImoduleTypes,_hdImoduleValues,_hdImodules,_hdIres,_hdIself) =
                (hd_ (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOknownGenerics)
                     (_hdOknownKinds)
                     (_hdOknownKinds_collect)
                     (_hdOknownTypes)
                     (_hdOknownTypes_collect)
                     (_hdOknownValues)
                     (_hdOknownValues_collect)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmoduleTypes)
                     (_hdOmoduleValues)
                     (_hdOnameType)
                     (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIknownKinds_collect,_tlIknownTypes_collect,_tlIknownValues_collect,_tlIlabels_collect,_tlImethods_collect,_tlImoduleTypes,_tlImoduleValues,_tlImodules,_tlIres,_tlIself) =
                (tl_ (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOknownGenerics)
                     (_tlOknownKinds)
                     (_tlOknownKinds_collect)
                     (_tlOknownTypes)
                     (_tlOknownTypes_collect)
                     (_tlOknownValues)
                     (_tlOknownValues_collect)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmoduleTypes)
                     (_tlOmoduleValues)
                     (_tlOnameType)
                     (_tlOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _hdImodules `Set.union` _tlImodules
            -- use rule
            (_lhsOres@_) =
                _hdIres ++ _tlIres
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _tlIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _tlIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _tlIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _tlImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _tlImoduleValues
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_hdOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_hdOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_hdOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_hdOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_hdOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_hdOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_hdOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_hdOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_tlOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_tlOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_tlOknownKinds_collect@_) =
                _hdIknownKinds_collect
            -- copy rule (down)
            (_tlOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_tlOknownTypes_collect@_) =
                _hdIknownTypes_collect
            -- copy rule (down)
            (_tlOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_tlOknownValues_collect@_) =
                _hdIknownValues_collect
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_tlOmoduleTypes@_) =
                _hdImoduleTypes
            -- copy rule (chain)
            (_tlOmoduleValues@_) =
                _hdImoduleValues
            -- copy rule (down)
            (_tlOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_InterfaceDeclarations_Nil :: (T_InterfaceDeclarations)
sem_InterfaceDeclarations_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (InterfaceDeclarations)
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- Kind --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for Kind.Arrow:
      self

-}
{-
   local variables for Kind.Error:
      self

-}
{-
   local variables for Kind.Parenthesized:
      self

-}
{-
   local variables for Kind.Star:
      self

-}
{-
   local variables for Kind.Variable:
      self

-}
-- semantic domain
type T_Kind = (Maybe Name) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (Strings) ->
              (Bool) ->
              (Maybe Name) ->
              (FMap Name [Name]) ->
              (FMap Name [Name]) ->
              (FMap Name [Name]) ->
              (FMap Name [Name]) ->
              (FMap Name [Name]) ->
              (FMap Name [Name]) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (Bool) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (FMap ModuleName [Name]) ->
              (FMap ModuleName [Name]) ->
              (NameType) ->
              (Bool) ->
              ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(Kind))
-- cata
sem_Kind :: (Kind) ->
            (T_Kind)
sem_Kind ((Kind_Arrow (_range) (_leftKind) (_rightKind))) =
    (sem_Kind_Arrow ((sem_Range (_range))) ((sem_Kind (_leftKind))) ((sem_Kind (_rightKind))))
sem_Kind ((Kind_Error )) =
    (sem_Kind_Error )
sem_Kind ((Kind_Parenthesized (_range) (_kind))) =
    (sem_Kind_Parenthesized ((sem_Range (_range))) ((sem_Kind (_kind))))
sem_Kind ((Kind_Star (_range))) =
    (sem_Kind_Star ((sem_Range (_range))))
sem_Kind ((Kind_Variable (_range) (_name))) =
    (sem_Kind_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Kind_Arrow :: (T_Range) ->
                  (T_Kind) ->
                  (T_Kind) ->
                  (T_Kind)
sem_Kind_Arrow (range_) (leftKind_) (rightKind_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Kind)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _leftKindIconstructors_collect :: (FMap Name Names)
            _leftKindIknownKinds_collect :: (FMap Name [Name])
            _leftKindIknownTypes_collect :: (FMap Name [Name])
            _leftKindIknownValues_collect :: (FMap Name [Name])
            _leftKindIlabels_collect :: (FMap Name Names)
            _leftKindImethods_collect :: (FMap Name Names)
            _leftKindImoduleTypes :: (FMap ModuleName [Name])
            _leftKindImoduleValues :: (FMap ModuleName [Name])
            _leftKindImodules :: (Set.Set Strings)
            _leftKindIres :: ([ResolveResult])
            _leftKindIself :: (Kind)
            _leftKindOclassname :: (Maybe Name)
            _leftKindOconstructors_collect :: (FMap Name Names)
            _leftKindOconstructors_dist :: (FMap Name Names)
            _leftKindOcurrentModule :: (Strings)
            _leftKindOimportedModule :: (Bool)
            _leftKindOinstancename :: (Maybe Name)
            _leftKindOknownKinds :: (FMap Name [Name])
            _leftKindOknownKinds_collect :: (FMap Name [Name])
            _leftKindOknownTypes :: (FMap Name [Name])
            _leftKindOknownTypes_collect :: (FMap Name [Name])
            _leftKindOknownValues :: (FMap Name [Name])
            _leftKindOknownValues_collect :: (FMap Name [Name])
            _leftKindOlabels_collect :: (FMap Name Names)
            _leftKindOlabels_dist :: (FMap Name Names)
            _leftKindOlocal :: (Bool)
            _leftKindOmethods_collect :: (FMap Name Names)
            _leftKindOmethods_dist :: (FMap Name Names)
            _leftKindOmoduleTypes :: (FMap ModuleName [Name])
            _leftKindOmoduleValues :: (FMap ModuleName [Name])
            _leftKindOnameType :: (NameType)
            _leftKindOtoplevel :: (Bool)
            _rightKindIconstructors_collect :: (FMap Name Names)
            _rightKindIknownKinds_collect :: (FMap Name [Name])
            _rightKindIknownTypes_collect :: (FMap Name [Name])
            _rightKindIknownValues_collect :: (FMap Name [Name])
            _rightKindIlabels_collect :: (FMap Name Names)
            _rightKindImethods_collect :: (FMap Name Names)
            _rightKindImoduleTypes :: (FMap ModuleName [Name])
            _rightKindImoduleValues :: (FMap ModuleName [Name])
            _rightKindImodules :: (Set.Set Strings)
            _rightKindIres :: ([ResolveResult])
            _rightKindIself :: (Kind)
            _rightKindOclassname :: (Maybe Name)
            _rightKindOconstructors_collect :: (FMap Name Names)
            _rightKindOconstructors_dist :: (FMap Name Names)
            _rightKindOcurrentModule :: (Strings)
            _rightKindOimportedModule :: (Bool)
            _rightKindOinstancename :: (Maybe Name)
            _rightKindOknownKinds :: (FMap Name [Name])
            _rightKindOknownKinds_collect :: (FMap Name [Name])
            _rightKindOknownTypes :: (FMap Name [Name])
            _rightKindOknownTypes_collect :: (FMap Name [Name])
            _rightKindOknownValues :: (FMap Name [Name])
            _rightKindOknownValues_collect :: (FMap Name [Name])
            _rightKindOlabels_collect :: (FMap Name Names)
            _rightKindOlabels_dist :: (FMap Name Names)
            _rightKindOlocal :: (Bool)
            _rightKindOmethods_collect :: (FMap Name Names)
            _rightKindOmethods_dist :: (FMap Name Names)
            _rightKindOmoduleTypes :: (FMap ModuleName [Name])
            _rightKindOmoduleValues :: (FMap ModuleName [Name])
            _rightKindOnameType :: (NameType)
            _rightKindOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _leftKindIconstructors_collect,_leftKindIknownKinds_collect,_leftKindIknownTypes_collect,_leftKindIknownValues_collect,_leftKindIlabels_collect,_leftKindImethods_collect,_leftKindImoduleTypes,_leftKindImoduleValues,_leftKindImodules,_leftKindIres,_leftKindIself) =
                (leftKind_ (_leftKindOclassname)
                           (_leftKindOconstructors_collect)
                           (_leftKindOconstructors_dist)
                           (_leftKindOcurrentModule)
                           (_leftKindOimportedModule)
                           (_leftKindOinstancename)
                           (_leftKindOknownKinds)
                           (_leftKindOknownKinds_collect)
                           (_leftKindOknownTypes)
                           (_leftKindOknownTypes_collect)
                           (_leftKindOknownValues)
                           (_leftKindOknownValues_collect)
                           (_leftKindOlabels_collect)
                           (_leftKindOlabels_dist)
                           (_leftKindOlocal)
                           (_leftKindOmethods_collect)
                           (_leftKindOmethods_dist)
                           (_leftKindOmoduleTypes)
                           (_leftKindOmoduleValues)
                           (_leftKindOnameType)
                           (_leftKindOtoplevel))
            ( _rightKindIconstructors_collect,_rightKindIknownKinds_collect,_rightKindIknownTypes_collect,_rightKindIknownValues_collect,_rightKindIlabels_collect,_rightKindImethods_collect,_rightKindImoduleTypes,_rightKindImoduleValues,_rightKindImodules,_rightKindIres,_rightKindIself) =
                (rightKind_ (_rightKindOclassname)
                            (_rightKindOconstructors_collect)
                            (_rightKindOconstructors_dist)
                            (_rightKindOcurrentModule)
                            (_rightKindOimportedModule)
                            (_rightKindOinstancename)
                            (_rightKindOknownKinds)
                            (_rightKindOknownKinds_collect)
                            (_rightKindOknownTypes)
                            (_rightKindOknownTypes_collect)
                            (_rightKindOknownValues)
                            (_rightKindOknownValues_collect)
                            (_rightKindOlabels_collect)
                            (_rightKindOlabels_dist)
                            (_rightKindOlocal)
                            (_rightKindOmethods_collect)
                            (_rightKindOmethods_dist)
                            (_rightKindOmoduleTypes)
                            (_rightKindOmoduleValues)
                            (_rightKindOnameType)
                            (_rightKindOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _leftKindImodules `Set.union` _rightKindImodules
            -- use rule
            (_lhsOres@_) =
                _leftKindIres ++ _rightKindIres
            -- self rule
            (_self@_) =
                Kind_Arrow _rangeIself _leftKindIself _rightKindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _rightKindIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _rightKindIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _rightKindIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _rightKindIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _rightKindIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _rightKindImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _rightKindImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _rightKindImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_leftKindOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_leftKindOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_leftKindOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_leftKindOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_leftKindOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_leftKindOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_leftKindOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_leftKindOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_leftKindOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_leftKindOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_leftKindOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_leftKindOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_leftKindOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_leftKindOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_leftKindOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_leftKindOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_leftKindOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_leftKindOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_leftKindOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_leftKindOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_leftKindOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_rightKindOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_rightKindOconstructors_collect@_) =
                _leftKindIconstructors_collect
            -- copy rule (down)
            (_rightKindOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_rightKindOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rightKindOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rightKindOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rightKindOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_rightKindOknownKinds_collect@_) =
                _leftKindIknownKinds_collect
            -- copy rule (down)
            (_rightKindOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_rightKindOknownTypes_collect@_) =
                _leftKindIknownTypes_collect
            -- copy rule (down)
            (_rightKindOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_rightKindOknownValues_collect@_) =
                _leftKindIknownValues_collect
            -- copy rule (chain)
            (_rightKindOlabels_collect@_) =
                _leftKindIlabels_collect
            -- copy rule (down)
            (_rightKindOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_rightKindOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_rightKindOmethods_collect@_) =
                _leftKindImethods_collect
            -- copy rule (down)
            (_rightKindOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_rightKindOmoduleTypes@_) =
                _leftKindImoduleTypes
            -- copy rule (chain)
            (_rightKindOmoduleValues@_) =
                _leftKindImoduleValues
            -- copy rule (down)
            (_rightKindOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_rightKindOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Kind_Error :: (T_Kind)
sem_Kind_Error  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Kind)
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                Kind_Error
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Kind_Parenthesized :: (T_Range) ->
                          (T_Kind) ->
                          (T_Kind)
sem_Kind_Parenthesized (range_) (kind_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Kind)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _kindIconstructors_collect :: (FMap Name Names)
            _kindIknownKinds_collect :: (FMap Name [Name])
            _kindIknownTypes_collect :: (FMap Name [Name])
            _kindIknownValues_collect :: (FMap Name [Name])
            _kindIlabels_collect :: (FMap Name Names)
            _kindImethods_collect :: (FMap Name Names)
            _kindImoduleTypes :: (FMap ModuleName [Name])
            _kindImoduleValues :: (FMap ModuleName [Name])
            _kindImodules :: (Set.Set Strings)
            _kindIres :: ([ResolveResult])
            _kindIself :: (Kind)
            _kindOclassname :: (Maybe Name)
            _kindOconstructors_collect :: (FMap Name Names)
            _kindOconstructors_dist :: (FMap Name Names)
            _kindOcurrentModule :: (Strings)
            _kindOimportedModule :: (Bool)
            _kindOinstancename :: (Maybe Name)
            _kindOknownKinds :: (FMap Name [Name])
            _kindOknownKinds_collect :: (FMap Name [Name])
            _kindOknownTypes :: (FMap Name [Name])
            _kindOknownTypes_collect :: (FMap Name [Name])
            _kindOknownValues :: (FMap Name [Name])
            _kindOknownValues_collect :: (FMap Name [Name])
            _kindOlabels_collect :: (FMap Name Names)
            _kindOlabels_dist :: (FMap Name Names)
            _kindOlocal :: (Bool)
            _kindOmethods_collect :: (FMap Name Names)
            _kindOmethods_dist :: (FMap Name Names)
            _kindOmoduleTypes :: (FMap ModuleName [Name])
            _kindOmoduleValues :: (FMap ModuleName [Name])
            _kindOnameType :: (NameType)
            _kindOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _kindIconstructors_collect,_kindIknownKinds_collect,_kindIknownTypes_collect,_kindIknownValues_collect,_kindIlabels_collect,_kindImethods_collect,_kindImoduleTypes,_kindImoduleValues,_kindImodules,_kindIres,_kindIself) =
                (kind_ (_kindOclassname)
                       (_kindOconstructors_collect)
                       (_kindOconstructors_dist)
                       (_kindOcurrentModule)
                       (_kindOimportedModule)
                       (_kindOinstancename)
                       (_kindOknownKinds)
                       (_kindOknownKinds_collect)
                       (_kindOknownTypes)
                       (_kindOknownTypes_collect)
                       (_kindOknownValues)
                       (_kindOknownValues_collect)
                       (_kindOlabels_collect)
                       (_kindOlabels_dist)
                       (_kindOlocal)
                       (_kindOmethods_collect)
                       (_kindOmethods_dist)
                       (_kindOmoduleTypes)
                       (_kindOmoduleValues)
                       (_kindOnameType)
                       (_kindOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _kindImodules
            -- use rule
            (_lhsOres@_) =
                _kindIres
            -- self rule
            (_self@_) =
                Kind_Parenthesized _rangeIself _kindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _kindIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _kindIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _kindIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _kindIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _kindIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _kindImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _kindImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _kindImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_kindOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_kindOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_kindOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_kindOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_kindOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_kindOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_kindOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_kindOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_kindOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_kindOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_kindOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_kindOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_kindOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_kindOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_kindOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_kindOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_kindOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_kindOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_kindOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_kindOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_kindOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Kind_Star :: (T_Range) ->
                 (T_Kind)
sem_Kind_Star (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Kind)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                Kind_Star _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Kind_Variable :: (T_Range) ->
                     (T_Name) ->
                     (T_Kind)
sem_Kind_Variable (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Kind)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres
            -- self rule
            (_self@_) =
                Kind_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- KindAnnotatedName -------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      akinds               : [MaybeKind]
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for KindAnnotatedName.KindAnnotatedName:
      self

-}
-- semantic domain
type T_KindAnnotatedName = (Maybe Name) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Strings) ->
                           (Bool) ->
                           (Maybe Name) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Bool) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (FMap ModuleName [Name]) ->
                           (FMap ModuleName [Name]) ->
                           (NameType) ->
                           (Bool) ->
                           ( ([MaybeKind]),(FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(KindAnnotatedName))
-- cata
sem_KindAnnotatedName :: (KindAnnotatedName) ->
                         (T_KindAnnotatedName)
sem_KindAnnotatedName ((KindAnnotatedName_KindAnnotatedName (_range) (_name) (_kind))) =
    (sem_KindAnnotatedName_KindAnnotatedName ((sem_Range (_range))) ((sem_Name (_name))) ((sem_MaybeKind (_kind))))
sem_KindAnnotatedName_KindAnnotatedName :: (T_Range) ->
                                           (T_Name) ->
                                           (T_MaybeKind) ->
                                           (T_KindAnnotatedName)
sem_KindAnnotatedName_KindAnnotatedName (range_) (name_) (kind_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOakinds :: ([MaybeKind])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (KindAnnotatedName)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _kindIconstructors_collect :: (FMap Name Names)
            _kindIknownKinds_collect :: (FMap Name [Name])
            _kindIknownTypes_collect :: (FMap Name [Name])
            _kindIknownValues_collect :: (FMap Name [Name])
            _kindIlabels_collect :: (FMap Name Names)
            _kindImethods_collect :: (FMap Name Names)
            _kindImoduleTypes :: (FMap ModuleName [Name])
            _kindImoduleValues :: (FMap ModuleName [Name])
            _kindImodules :: (Set.Set Strings)
            _kindIres :: ([ResolveResult])
            _kindIself :: (MaybeKind)
            _kindOclassname :: (Maybe Name)
            _kindOconstructors_collect :: (FMap Name Names)
            _kindOconstructors_dist :: (FMap Name Names)
            _kindOcurrentModule :: (Strings)
            _kindOimportedModule :: (Bool)
            _kindOinstancename :: (Maybe Name)
            _kindOknownKinds :: (FMap Name [Name])
            _kindOknownKinds_collect :: (FMap Name [Name])
            _kindOknownTypes :: (FMap Name [Name])
            _kindOknownTypes_collect :: (FMap Name [Name])
            _kindOknownValues :: (FMap Name [Name])
            _kindOknownValues_collect :: (FMap Name [Name])
            _kindOlabels_collect :: (FMap Name Names)
            _kindOlabels_dist :: (FMap Name Names)
            _kindOlocal :: (Bool)
            _kindOmethods_collect :: (FMap Name Names)
            _kindOmethods_dist :: (FMap Name Names)
            _kindOmoduleTypes :: (FMap ModuleName [Name])
            _kindOmoduleValues :: (FMap ModuleName [Name])
            _kindOnameType :: (NameType)
            _kindOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _kindIconstructors_collect,_kindIknownKinds_collect,_kindIknownTypes_collect,_kindIknownValues_collect,_kindIlabels_collect,_kindImethods_collect,_kindImoduleTypes,_kindImoduleValues,_kindImodules,_kindIres,_kindIself) =
                (kind_ (_kindOclassname)
                       (_kindOconstructors_collect)
                       (_kindOconstructors_dist)
                       (_kindOcurrentModule)
                       (_kindOimportedModule)
                       (_kindOinstancename)
                       (_kindOknownKinds)
                       (_kindOknownKinds_collect)
                       (_kindOknownTypes)
                       (_kindOknownTypes_collect)
                       (_kindOknownValues)
                       (_kindOknownValues_collect)
                       (_kindOlabels_collect)
                       (_kindOlabels_dist)
                       (_kindOlocal)
                       (_kindOmethods_collect)
                       (_kindOmethods_dist)
                       (_kindOmoduleTypes)
                       (_kindOmoduleValues)
                       (_kindOnameType)
                       (_kindOtoplevel))
            -- "./NameTypes.inc.lag"(line 375, column 9)
            (_kindOnameType@_) =
                if    _lhsInameType == ref_Typ
                then  ref_Kind
                else  Def_Kind
            -- "./ModuleInformation.inc.lag"(line 272, column 9)
            (_lhsOakinds@_) =
                [_kindIself]
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _kindImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _kindIres
            -- self rule
            (_self@_) =
                KindAnnotatedName_KindAnnotatedName _rangeIself _nameIself _kindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _kindIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _kindIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _kindIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _kindIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _kindIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _kindImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _kindImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _kindImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_kindOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_kindOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_kindOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_kindOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_kindOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_kindOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_kindOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_kindOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_kindOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_kindOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (down)
            (_kindOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_kindOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_kindOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_kindOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_kindOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_kindOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_kindOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_kindOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_kindOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_kindOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOakinds,_lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- KindAnnotatedNames ------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      akinds               : [MaybeKind]
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for KindAnnotatedNames.Cons:
      self

-}
{-
   local variables for KindAnnotatedNames.Nil:
      self

-}
-- semantic domain
type T_KindAnnotatedNames = (Maybe Name) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Strings) ->
                            (Bool) ->
                            (Maybe Name) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Bool) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (FMap ModuleName [Name]) ->
                            (FMap ModuleName [Name]) ->
                            (NameType) ->
                            (Bool) ->
                            ( ([MaybeKind]),(FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(KindAnnotatedNames))
-- cata
sem_KindAnnotatedNames :: (KindAnnotatedNames) ->
                          (T_KindAnnotatedNames)
sem_KindAnnotatedNames (list) =
    (foldr (sem_KindAnnotatedNames_Cons) (sem_KindAnnotatedNames_Nil) ((map sem_KindAnnotatedName list)))
sem_KindAnnotatedNames_Cons :: (T_KindAnnotatedName) ->
                               (T_KindAnnotatedNames) ->
                               (T_KindAnnotatedNames)
sem_KindAnnotatedNames_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOakinds :: ([MaybeKind])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (KindAnnotatedNames)
            _hdIakinds :: ([MaybeKind])
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIknownKinds_collect :: (FMap Name [Name])
            _hdIknownTypes_collect :: (FMap Name [Name])
            _hdIknownValues_collect :: (FMap Name [Name])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdImoduleTypes :: (FMap ModuleName [Name])
            _hdImoduleValues :: (FMap ModuleName [Name])
            _hdImodules :: (Set.Set Strings)
            _hdIres :: ([ResolveResult])
            _hdIself :: (KindAnnotatedName)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOknownKinds :: (FMap Name [Name])
            _hdOknownKinds_collect :: (FMap Name [Name])
            _hdOknownTypes :: (FMap Name [Name])
            _hdOknownTypes_collect :: (FMap Name [Name])
            _hdOknownValues :: (FMap Name [Name])
            _hdOknownValues_collect :: (FMap Name [Name])
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmoduleTypes :: (FMap ModuleName [Name])
            _hdOmoduleValues :: (FMap ModuleName [Name])
            _hdOnameType :: (NameType)
            _hdOtoplevel :: (Bool)
            _tlIakinds :: ([MaybeKind])
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIknownKinds_collect :: (FMap Name [Name])
            _tlIknownTypes_collect :: (FMap Name [Name])
            _tlIknownValues_collect :: (FMap Name [Name])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlImoduleTypes :: (FMap ModuleName [Name])
            _tlImoduleValues :: (FMap ModuleName [Name])
            _tlImodules :: (Set.Set Strings)
            _tlIres :: ([ResolveResult])
            _tlIself :: (KindAnnotatedNames)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOknownKinds :: (FMap Name [Name])
            _tlOknownKinds_collect :: (FMap Name [Name])
            _tlOknownTypes :: (FMap Name [Name])
            _tlOknownTypes_collect :: (FMap Name [Name])
            _tlOknownValues :: (FMap Name [Name])
            _tlOknownValues_collect :: (FMap Name [Name])
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmoduleTypes :: (FMap ModuleName [Name])
            _tlOmoduleValues :: (FMap ModuleName [Name])
            _tlOnameType :: (NameType)
            _tlOtoplevel :: (Bool)
            ( _hdIakinds,_hdIconstructors_collect,_hdIknownKinds_collect,_hdIknownTypes_collect,_hdIknownValues_collect,_hdIlabels_collect,_hdImethods_collect,_hdImoduleTypes,_hdImoduleValues,_hdImodules,_hdIres,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOimportedModule) (_hdOinstancename) (_hdOknownKinds) (_hdOknownKinds_collect) (_hdOknownTypes) (_hdOknownTypes_collect) (_hdOknownValues) (_hdOknownValues_collect) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOmoduleTypes) (_hdOmoduleValues) (_hdOnameType) (_hdOtoplevel))
            ( _tlIakinds,_tlIconstructors_collect,_tlIknownKinds_collect,_tlIknownTypes_collect,_tlIknownValues_collect,_tlIlabels_collect,_tlImethods_collect,_tlImoduleTypes,_tlImoduleValues,_tlImodules,_tlIres,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOimportedModule) (_tlOinstancename) (_tlOknownKinds) (_tlOknownKinds_collect) (_tlOknownTypes) (_tlOknownTypes_collect) (_tlOknownValues) (_tlOknownValues_collect) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOmoduleTypes) (_tlOmoduleValues) (_tlOnameType) (_tlOtoplevel))
            -- use rule
            (_lhsOakinds@_) =
                _hdIakinds ++ _tlIakinds
            -- use rule
            (_lhsOmodules@_) =
                _hdImodules `Set.union` _tlImodules
            -- use rule
            (_lhsOres@_) =
                _hdIres ++ _tlIres
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _tlIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _tlIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _tlIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _tlImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _tlImoduleValues
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_hdOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_hdOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_hdOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_hdOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_hdOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_hdOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_hdOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_tlOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_tlOknownKinds_collect@_) =
                _hdIknownKinds_collect
            -- copy rule (down)
            (_tlOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_tlOknownTypes_collect@_) =
                _hdIknownTypes_collect
            -- copy rule (down)
            (_tlOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_tlOknownValues_collect@_) =
                _hdIknownValues_collect
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_tlOmoduleTypes@_) =
                _hdImoduleTypes
            -- copy rule (chain)
            (_tlOmoduleValues@_) =
                _hdImoduleValues
            -- copy rule (down)
            (_tlOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOakinds,_lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_KindAnnotatedNames_Nil :: (T_KindAnnotatedNames)
sem_KindAnnotatedNames_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOakinds :: ([MaybeKind])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (KindAnnotatedNames)
            -- use rule
            (_lhsOakinds@_) =
                []
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOakinds,_lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- KindArgument ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for KindArgument.Arrow:
      self

-}
{-
   local variables for KindArgument.Star:
      self

-}
-- semantic domain
type T_KindArgument = (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Strings) ->
                      (Bool) ->
                      (Maybe Name) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (FMap ModuleName [Name]) ->
                      (FMap ModuleName [Name]) ->
                      (NameType) ->
                      (Bool) ->
                      ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(KindArgument))
-- cata
sem_KindArgument :: (KindArgument) ->
                    (T_KindArgument)
sem_KindArgument ((KindArgument_Arrow (_range) (_leftkindvariable) (_rightkindvariable))) =
    (sem_KindArgument_Arrow ((sem_Range (_range))) ((sem_Name (_leftkindvariable))) ((sem_Name (_rightkindvariable))))
sem_KindArgument ((KindArgument_Star (_range))) =
    (sem_KindArgument_Star ((sem_Range (_range))))
sem_KindArgument_Arrow :: (T_Range) ->
                          (T_Name) ->
                          (T_Name) ->
                          (T_KindArgument)
sem_KindArgument_Arrow (range_) (leftkindvariable_) (rightkindvariable_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (KindArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _leftkindvariableIconstructors_collect :: (FMap Name Names)
            _leftkindvariableIentityName :: (Name)
            _leftkindvariableIfullName :: (Name)
            _leftkindvariableIknownKinds_collect :: (FMap Name [Name])
            _leftkindvariableIknownTypes_collect :: (FMap Name [Name])
            _leftkindvariableIknownValues_collect :: (FMap Name [Name])
            _leftkindvariableIlabels_collect :: (FMap Name Names)
            _leftkindvariableImethods_collect :: (FMap Name Names)
            _leftkindvariableImoduleTypes :: (FMap ModuleName [Name])
            _leftkindvariableImoduleValues :: (FMap ModuleName [Name])
            _leftkindvariableImodules :: (Set.Set Strings)
            _leftkindvariableIoriginalSelf :: (Name)
            _leftkindvariableIres :: ([ResolveResult])
            _leftkindvariableIself :: (Name)
            _leftkindvariableOclassname :: (Maybe Name)
            _leftkindvariableOconstructors_collect :: (FMap Name Names)
            _leftkindvariableOconstructors_dist :: (FMap Name Names)
            _leftkindvariableOcurrentModule :: (Strings)
            _leftkindvariableOimportedModule :: (Bool)
            _leftkindvariableOinstancename :: (Maybe Name)
            _leftkindvariableOknownKinds :: (FMap Name [Name])
            _leftkindvariableOknownKinds_collect :: (FMap Name [Name])
            _leftkindvariableOknownTypes :: (FMap Name [Name])
            _leftkindvariableOknownTypes_collect :: (FMap Name [Name])
            _leftkindvariableOknownValues :: (FMap Name [Name])
            _leftkindvariableOknownValues_collect :: (FMap Name [Name])
            _leftkindvariableOlabels_collect :: (FMap Name Names)
            _leftkindvariableOlabels_dist :: (FMap Name Names)
            _leftkindvariableOlocal :: (Bool)
            _leftkindvariableOmethods_collect :: (FMap Name Names)
            _leftkindvariableOmethods_dist :: (FMap Name Names)
            _leftkindvariableOmoduleTypes :: (FMap ModuleName [Name])
            _leftkindvariableOmoduleValues :: (FMap ModuleName [Name])
            _leftkindvariableOnameType :: (NameType)
            _leftkindvariableOtoplevel :: (Bool)
            _rightkindvariableIconstructors_collect :: (FMap Name Names)
            _rightkindvariableIentityName :: (Name)
            _rightkindvariableIfullName :: (Name)
            _rightkindvariableIknownKinds_collect :: (FMap Name [Name])
            _rightkindvariableIknownTypes_collect :: (FMap Name [Name])
            _rightkindvariableIknownValues_collect :: (FMap Name [Name])
            _rightkindvariableIlabels_collect :: (FMap Name Names)
            _rightkindvariableImethods_collect :: (FMap Name Names)
            _rightkindvariableImoduleTypes :: (FMap ModuleName [Name])
            _rightkindvariableImoduleValues :: (FMap ModuleName [Name])
            _rightkindvariableImodules :: (Set.Set Strings)
            _rightkindvariableIoriginalSelf :: (Name)
            _rightkindvariableIres :: ([ResolveResult])
            _rightkindvariableIself :: (Name)
            _rightkindvariableOclassname :: (Maybe Name)
            _rightkindvariableOconstructors_collect :: (FMap Name Names)
            _rightkindvariableOconstructors_dist :: (FMap Name Names)
            _rightkindvariableOcurrentModule :: (Strings)
            _rightkindvariableOimportedModule :: (Bool)
            _rightkindvariableOinstancename :: (Maybe Name)
            _rightkindvariableOknownKinds :: (FMap Name [Name])
            _rightkindvariableOknownKinds_collect :: (FMap Name [Name])
            _rightkindvariableOknownTypes :: (FMap Name [Name])
            _rightkindvariableOknownTypes_collect :: (FMap Name [Name])
            _rightkindvariableOknownValues :: (FMap Name [Name])
            _rightkindvariableOknownValues_collect :: (FMap Name [Name])
            _rightkindvariableOlabels_collect :: (FMap Name Names)
            _rightkindvariableOlabels_dist :: (FMap Name Names)
            _rightkindvariableOlocal :: (Bool)
            _rightkindvariableOmethods_collect :: (FMap Name Names)
            _rightkindvariableOmethods_dist :: (FMap Name Names)
            _rightkindvariableOmoduleTypes :: (FMap ModuleName [Name])
            _rightkindvariableOmoduleValues :: (FMap ModuleName [Name])
            _rightkindvariableOnameType :: (NameType)
            _rightkindvariableOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _leftkindvariableIconstructors_collect
             ,_leftkindvariableIentityName
             ,_leftkindvariableIfullName
             ,_leftkindvariableIknownKinds_collect
             ,_leftkindvariableIknownTypes_collect
             ,_leftkindvariableIknownValues_collect
             ,_leftkindvariableIlabels_collect
             ,_leftkindvariableImethods_collect
             ,_leftkindvariableImoduleTypes
             ,_leftkindvariableImoduleValues
             ,_leftkindvariableImodules
             ,_leftkindvariableIoriginalSelf
             ,_leftkindvariableIres
             ,_leftkindvariableIself
             ) =
                (leftkindvariable_ (_leftkindvariableOclassname)
                                   (_leftkindvariableOconstructors_collect)
                                   (_leftkindvariableOconstructors_dist)
                                   (_leftkindvariableOcurrentModule)
                                   (_leftkindvariableOimportedModule)
                                   (_leftkindvariableOinstancename)
                                   (_leftkindvariableOknownKinds)
                                   (_leftkindvariableOknownKinds_collect)
                                   (_leftkindvariableOknownTypes)
                                   (_leftkindvariableOknownTypes_collect)
                                   (_leftkindvariableOknownValues)
                                   (_leftkindvariableOknownValues_collect)
                                   (_leftkindvariableOlabels_collect)
                                   (_leftkindvariableOlabels_dist)
                                   (_leftkindvariableOlocal)
                                   (_leftkindvariableOmethods_collect)
                                   (_leftkindvariableOmethods_dist)
                                   (_leftkindvariableOmoduleTypes)
                                   (_leftkindvariableOmoduleValues)
                                   (_leftkindvariableOnameType)
                                   (_leftkindvariableOtoplevel))
            ( _rightkindvariableIconstructors_collect
             ,_rightkindvariableIentityName
             ,_rightkindvariableIfullName
             ,_rightkindvariableIknownKinds_collect
             ,_rightkindvariableIknownTypes_collect
             ,_rightkindvariableIknownValues_collect
             ,_rightkindvariableIlabels_collect
             ,_rightkindvariableImethods_collect
             ,_rightkindvariableImoduleTypes
             ,_rightkindvariableImoduleValues
             ,_rightkindvariableImodules
             ,_rightkindvariableIoriginalSelf
             ,_rightkindvariableIres
             ,_rightkindvariableIself
             ) =
                (rightkindvariable_ (_rightkindvariableOclassname)
                                    (_rightkindvariableOconstructors_collect)
                                    (_rightkindvariableOconstructors_dist)
                                    (_rightkindvariableOcurrentModule)
                                    (_rightkindvariableOimportedModule)
                                    (_rightkindvariableOinstancename)
                                    (_rightkindvariableOknownKinds)
                                    (_rightkindvariableOknownKinds_collect)
                                    (_rightkindvariableOknownTypes)
                                    (_rightkindvariableOknownTypes_collect)
                                    (_rightkindvariableOknownValues)
                                    (_rightkindvariableOknownValues_collect)
                                    (_rightkindvariableOlabels_collect)
                                    (_rightkindvariableOlabels_dist)
                                    (_rightkindvariableOlocal)
                                    (_rightkindvariableOmethods_collect)
                                    (_rightkindvariableOmethods_dist)
                                    (_rightkindvariableOmoduleTypes)
                                    (_rightkindvariableOmoduleValues)
                                    (_rightkindvariableOnameType)
                                    (_rightkindvariableOtoplevel))
            -- "./NameTypes.inc.lag"(line 214, column 9)
            (_rightkindvariableOnameType@_) =
                Def_Kind
            -- "./NameTypes.inc.lag"(line 213, column 9)
            (_leftkindvariableOnameType@_) =
                Def_Kind
            -- use rule
            (_lhsOmodules@_) =
                _leftkindvariableImodules `Set.union` _rightkindvariableImodules
            -- use rule
            (_lhsOres@_) =
                _leftkindvariableIres ++ _rightkindvariableIres
            -- self rule
            (_self@_) =
                KindArgument_Arrow _rangeIself _leftkindvariableIself _rightkindvariableIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _rightkindvariableIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _rightkindvariableIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _rightkindvariableIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _rightkindvariableIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _rightkindvariableIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _rightkindvariableImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _rightkindvariableImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _rightkindvariableImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_leftkindvariableOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_leftkindvariableOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_leftkindvariableOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_leftkindvariableOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_leftkindvariableOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_leftkindvariableOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_leftkindvariableOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_leftkindvariableOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_leftkindvariableOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_leftkindvariableOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_leftkindvariableOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_leftkindvariableOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_leftkindvariableOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_leftkindvariableOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_leftkindvariableOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_leftkindvariableOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_leftkindvariableOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_leftkindvariableOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_leftkindvariableOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_leftkindvariableOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_rightkindvariableOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_rightkindvariableOconstructors_collect@_) =
                _leftkindvariableIconstructors_collect
            -- copy rule (down)
            (_rightkindvariableOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_rightkindvariableOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rightkindvariableOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rightkindvariableOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rightkindvariableOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_rightkindvariableOknownKinds_collect@_) =
                _leftkindvariableIknownKinds_collect
            -- copy rule (down)
            (_rightkindvariableOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_rightkindvariableOknownTypes_collect@_) =
                _leftkindvariableIknownTypes_collect
            -- copy rule (down)
            (_rightkindvariableOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_rightkindvariableOknownValues_collect@_) =
                _leftkindvariableIknownValues_collect
            -- copy rule (chain)
            (_rightkindvariableOlabels_collect@_) =
                _leftkindvariableIlabels_collect
            -- copy rule (down)
            (_rightkindvariableOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_rightkindvariableOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_rightkindvariableOmethods_collect@_) =
                _leftkindvariableImethods_collect
            -- copy rule (down)
            (_rightkindvariableOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_rightkindvariableOmoduleTypes@_) =
                _leftkindvariableImoduleTypes
            -- copy rule (chain)
            (_rightkindvariableOmoduleValues@_) =
                _leftkindvariableImoduleValues
            -- copy rule (down)
            (_rightkindvariableOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_KindArgument_Star :: (T_Range) ->
                         (T_KindArgument)
sem_KindArgument_Star (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (KindArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                KindArgument_Star _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- KindIndexedBinding ------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      name                 : Name
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for KindIndexedBinding.KindIndexedBinding:
      self

-}
-- semantic domain
type T_KindIndexedBinding = (Maybe Name) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Strings) ->
                            (Bool) ->
                            (Maybe Name) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Bool) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (FMap ModuleName [Name]) ->
                            (FMap ModuleName [Name]) ->
                            (NameType) ->
                            (Bool) ->
                            ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),(Name),([ResolveResult]),(KindIndexedBinding))
-- cata
sem_KindIndexedBinding :: (KindIndexedBinding) ->
                          (T_KindIndexedBinding)
sem_KindIndexedBinding ((KindIndexedBinding_KindIndexedBinding (_range) (_name) (_kindargument) (_typevariables) (_type))) =
    (sem_KindIndexedBinding_KindIndexedBinding ((sem_Range (_range))) ((sem_Name (_name))) ((sem_KindArgument (_kindargument))) ((sem_Names (_typevariables))) ((sem_Type (_type))))
sem_KindIndexedBinding_KindIndexedBinding :: (T_Range) ->
                                             (T_Name) ->
                                             (T_KindArgument) ->
                                             (T_Names) ->
                                             (T_Type) ->
                                             (T_KindIndexedBinding)
sem_KindIndexedBinding_KindIndexedBinding (range_) (name_) (kindargument_) (typevariables_) (type_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOname :: (Name)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (KindIndexedBinding)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _kindargumentIconstructors_collect :: (FMap Name Names)
            _kindargumentIknownKinds_collect :: (FMap Name [Name])
            _kindargumentIknownTypes_collect :: (FMap Name [Name])
            _kindargumentIknownValues_collect :: (FMap Name [Name])
            _kindargumentIlabels_collect :: (FMap Name Names)
            _kindargumentImethods_collect :: (FMap Name Names)
            _kindargumentImoduleTypes :: (FMap ModuleName [Name])
            _kindargumentImoduleValues :: (FMap ModuleName [Name])
            _kindargumentImodules :: (Set.Set Strings)
            _kindargumentIres :: ([ResolveResult])
            _kindargumentIself :: (KindArgument)
            _kindargumentOclassname :: (Maybe Name)
            _kindargumentOconstructors_collect :: (FMap Name Names)
            _kindargumentOconstructors_dist :: (FMap Name Names)
            _kindargumentOcurrentModule :: (Strings)
            _kindargumentOimportedModule :: (Bool)
            _kindargumentOinstancename :: (Maybe Name)
            _kindargumentOknownKinds :: (FMap Name [Name])
            _kindargumentOknownKinds_collect :: (FMap Name [Name])
            _kindargumentOknownTypes :: (FMap Name [Name])
            _kindargumentOknownTypes_collect :: (FMap Name [Name])
            _kindargumentOknownValues :: (FMap Name [Name])
            _kindargumentOknownValues_collect :: (FMap Name [Name])
            _kindargumentOlabels_collect :: (FMap Name Names)
            _kindargumentOlabels_dist :: (FMap Name Names)
            _kindargumentOlocal :: (Bool)
            _kindargumentOmethods_collect :: (FMap Name Names)
            _kindargumentOmethods_dist :: (FMap Name Names)
            _kindargumentOmoduleTypes :: (FMap ModuleName [Name])
            _kindargumentOmoduleValues :: (FMap ModuleName [Name])
            _kindargumentOnameType :: (NameType)
            _kindargumentOtoplevel :: (Bool)
            _typevariablesIconstructors_collect :: (FMap Name Names)
            _typevariablesIknownKinds_collect :: (FMap Name [Name])
            _typevariablesIknownTypes_collect :: (FMap Name [Name])
            _typevariablesIknownValues_collect :: (FMap Name [Name])
            _typevariablesIlabels_collect :: (FMap Name Names)
            _typevariablesImethods_collect :: (FMap Name Names)
            _typevariablesImoduleTypes :: (FMap ModuleName [Name])
            _typevariablesImoduleValues :: (FMap ModuleName [Name])
            _typevariablesImodules :: (Set.Set Strings)
            _typevariablesIoriginalSelf :: (Names)
            _typevariablesIres :: ([ResolveResult])
            _typevariablesIself :: (Names)
            _typevariablesOclassname :: (Maybe Name)
            _typevariablesOconstructors_collect :: (FMap Name Names)
            _typevariablesOconstructors_dist :: (FMap Name Names)
            _typevariablesOcurrentModule :: (Strings)
            _typevariablesOimportedModule :: (Bool)
            _typevariablesOinstancename :: (Maybe Name)
            _typevariablesOknownKinds :: (FMap Name [Name])
            _typevariablesOknownKinds_collect :: (FMap Name [Name])
            _typevariablesOknownTypes :: (FMap Name [Name])
            _typevariablesOknownTypes_collect :: (FMap Name [Name])
            _typevariablesOknownValues :: (FMap Name [Name])
            _typevariablesOknownValues_collect :: (FMap Name [Name])
            _typevariablesOlabels_collect :: (FMap Name Names)
            _typevariablesOlabels_dist :: (FMap Name Names)
            _typevariablesOlocal :: (Bool)
            _typevariablesOmethods_collect :: (FMap Name Names)
            _typevariablesOmethods_dist :: (FMap Name Names)
            _typevariablesOmoduleTypes :: (FMap ModuleName [Name])
            _typevariablesOmoduleValues :: (FMap ModuleName [Name])
            _typevariablesOnameType :: (NameType)
            _typevariablesOtoplevel :: (Bool)
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIknownKinds_collect :: (FMap Name [Name])
            _typeIknownTypes_collect :: (FMap Name [Name])
            _typeIknownValues_collect :: (FMap Name [Name])
            _typeIlabels_collect :: (FMap Name Names)
            _typeImethods_collect :: (FMap Name Names)
            _typeImoduleTypes :: (FMap ModuleName [Name])
            _typeImoduleValues :: (FMap ModuleName [Name])
            _typeImodules :: (Set.Set Strings)
            _typeIres :: ([ResolveResult])
            _typeIself :: (Type)
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOimportedModule :: (Bool)
            _typeOinstancename :: (Maybe Name)
            _typeOknownGenerics :: (FMap Name [Name])
            _typeOknownKinds :: (FMap Name [Name])
            _typeOknownKinds_collect :: (FMap Name [Name])
            _typeOknownTypes :: (FMap Name [Name])
            _typeOknownTypes_collect :: (FMap Name [Name])
            _typeOknownValues :: (FMap Name [Name])
            _typeOknownValues_collect :: (FMap Name [Name])
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOmoduleTypes :: (FMap ModuleName [Name])
            _typeOmoduleValues :: (FMap ModuleName [Name])
            _typeOnameType :: (NameType)
            _typeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _kindargumentIconstructors_collect,_kindargumentIknownKinds_collect,_kindargumentIknownTypes_collect,_kindargumentIknownValues_collect,_kindargumentIlabels_collect,_kindargumentImethods_collect,_kindargumentImoduleTypes,_kindargumentImoduleValues,_kindargumentImodules,_kindargumentIres,_kindargumentIself) =
                (kindargument_ (_kindargumentOclassname)
                               (_kindargumentOconstructors_collect)
                               (_kindargumentOconstructors_dist)
                               (_kindargumentOcurrentModule)
                               (_kindargumentOimportedModule)
                               (_kindargumentOinstancename)
                               (_kindargumentOknownKinds)
                               (_kindargumentOknownKinds_collect)
                               (_kindargumentOknownTypes)
                               (_kindargumentOknownTypes_collect)
                               (_kindargumentOknownValues)
                               (_kindargumentOknownValues_collect)
                               (_kindargumentOlabels_collect)
                               (_kindargumentOlabels_dist)
                               (_kindargumentOlocal)
                               (_kindargumentOmethods_collect)
                               (_kindargumentOmethods_dist)
                               (_kindargumentOmoduleTypes)
                               (_kindargumentOmoduleValues)
                               (_kindargumentOnameType)
                               (_kindargumentOtoplevel))
            ( _typevariablesIconstructors_collect,_typevariablesIknownKinds_collect,_typevariablesIknownTypes_collect,_typevariablesIknownValues_collect,_typevariablesIlabels_collect,_typevariablesImethods_collect,_typevariablesImoduleTypes,_typevariablesImoduleValues,_typevariablesImodules,_typevariablesIoriginalSelf,_typevariablesIres,_typevariablesIself) =
                (typevariables_ (_typevariablesOclassname)
                                (_typevariablesOconstructors_collect)
                                (_typevariablesOconstructors_dist)
                                (_typevariablesOcurrentModule)
                                (_typevariablesOimportedModule)
                                (_typevariablesOinstancename)
                                (_typevariablesOknownKinds)
                                (_typevariablesOknownKinds_collect)
                                (_typevariablesOknownTypes)
                                (_typevariablesOknownTypes_collect)
                                (_typevariablesOknownValues)
                                (_typevariablesOknownValues_collect)
                                (_typevariablesOlabels_collect)
                                (_typevariablesOlabels_dist)
                                (_typevariablesOlocal)
                                (_typevariablesOmethods_collect)
                                (_typevariablesOmethods_dist)
                                (_typevariablesOmoduleTypes)
                                (_typevariablesOmoduleValues)
                                (_typevariablesOnameType)
                                (_typevariablesOtoplevel))
            ( _typeIconstructors_collect,_typeIknownKinds_collect,_typeIknownTypes_collect,_typeIknownValues_collect,_typeIlabels_collect,_typeImethods_collect,_typeImoduleTypes,_typeImoduleValues,_typeImodules,_typeIres,_typeIself) =
                (type_ (_typeOclassname)
                       (_typeOconstructors_collect)
                       (_typeOconstructors_dist)
                       (_typeOcurrentModule)
                       (_typeOimportedModule)
                       (_typeOinstancename)
                       (_typeOknownGenerics)
                       (_typeOknownKinds)
                       (_typeOknownKinds_collect)
                       (_typeOknownTypes)
                       (_typeOknownTypes_collect)
                       (_typeOknownValues)
                       (_typeOknownValues_collect)
                       (_typeOlabels_collect)
                       (_typeOlabels_dist)
                       (_typeOlocal)
                       (_typeOmethods_collect)
                       (_typeOmethods_dist)
                       (_typeOmoduleTypes)
                       (_typeOmoduleValues)
                       (_typeOnameType)
                       (_typeOtoplevel))
            -- "./Names.inc.lag"(line 796, column 9)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- "./Names.inc.lag"(line 795, column 9)
            (_typeOknownKinds@_) =
                _kindargumentIknownKinds_collect `mergeFM` _lhsIknownKinds
            -- "./Names.inc.lag"(line 794, column 9)
            (_kindargumentOknownKinds_collect@_) =
                emptyFM
            -- "./Names.inc.lag"(line 792, column 9)
            (_lhsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- "./Names.inc.lag"(line 791, column 9)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- "./Names.inc.lag"(line 790, column 9)
            (_typeOknownTypes@_) =
                _typevariablesIknownTypes_collect `mergeFM` _lhsIknownTypes
            -- "./Names.inc.lag"(line 789, column 9)
            (_typevariablesOknownTypes_collect@_) =
                emptyFM
            -- "./NameTypes.inc.lag"(line 295, column 9)
            (_typeOnameType@_) =
                deforref_Typ
            -- "./NameTypes.inc.lag"(line 294, column 9)
            (_typevariablesOnameType@_) =
                Def_Typ
            -- "./ModuleInformation.inc.lag"(line 162, column 8)
            (_typeOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 161, column 8)
            (_typevariablesOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 160, column 8)
            (_kindargumentOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 417, column 9)
            (_lhsOname@_) =
                _nameIself
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _kindargumentImodules `Set.union` _typevariablesImodules `Set.union` _typeImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _kindargumentIres ++ _typevariablesIres ++ _typeIres
            -- self rule
            (_self@_) =
                KindIndexedBinding_KindIndexedBinding _rangeIself _nameIself _kindargumentIself _typevariablesIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _typeIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _typeImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _typeImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_kindargumentOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_kindargumentOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_kindargumentOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_kindargumentOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_kindargumentOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_kindargumentOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_kindargumentOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_kindargumentOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_kindargumentOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (down)
            (_kindargumentOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_kindargumentOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_kindargumentOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_kindargumentOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_kindargumentOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_kindargumentOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_kindargumentOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_kindargumentOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_kindargumentOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_kindargumentOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_typevariablesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typevariablesOconstructors_collect@_) =
                _kindargumentIconstructors_collect
            -- copy rule (down)
            (_typevariablesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typevariablesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typevariablesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typevariablesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typevariablesOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_typevariablesOknownKinds_collect@_) =
                _kindargumentIknownKinds_collect
            -- copy rule (down)
            (_typevariablesOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_typevariablesOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_typevariablesOknownValues_collect@_) =
                _kindargumentIknownValues_collect
            -- copy rule (chain)
            (_typevariablesOlabels_collect@_) =
                _kindargumentIlabels_collect
            -- copy rule (down)
            (_typevariablesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typevariablesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typevariablesOmethods_collect@_) =
                _kindargumentImethods_collect
            -- copy rule (down)
            (_typevariablesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_typevariablesOmoduleTypes@_) =
                _kindargumentImoduleTypes
            -- copy rule (chain)
            (_typevariablesOmoduleValues@_) =
                _kindargumentImoduleValues
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _typevariablesIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typeOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (chain)
            (_typeOknownKinds_collect@_) =
                _typevariablesIknownKinds_collect
            -- copy rule (chain)
            (_typeOknownTypes_collect@_) =
                _typevariablesIknownTypes_collect
            -- copy rule (down)
            (_typeOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_typeOknownValues_collect@_) =
                _typevariablesIknownValues_collect
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _typevariablesIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _typevariablesImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_typeOmoduleTypes@_) =
                _typevariablesImoduleTypes
            -- copy rule (chain)
            (_typeOmoduleValues@_) =
                _typevariablesImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOname,_lhsOres,_lhsOself)
-- KindIndexedBindings -----------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      name                 : Name
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for KindIndexedBindings.Cons:
      self

-}
{-
   local variables for KindIndexedBindings.Nil:
      self

-}
-- semantic domain
type T_KindIndexedBindings = (Maybe Name) ->
                             (FMap Name Names) ->
                             (FMap Name Names) ->
                             (Strings) ->
                             (Bool) ->
                             (Maybe Name) ->
                             (FMap Name [Name]) ->
                             (FMap Name [Name]) ->
                             (FMap Name [Name]) ->
                             (FMap Name [Name]) ->
                             (FMap Name [Name]) ->
                             (FMap Name [Name]) ->
                             (FMap Name [Name]) ->
                             (FMap Name Names) ->
                             (FMap Name Names) ->
                             (Bool) ->
                             (FMap Name Names) ->
                             (FMap Name Names) ->
                             (FMap ModuleName [Name]) ->
                             (FMap ModuleName [Name]) ->
                             (NameType) ->
                             (Bool) ->
                             ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),(Name),([ResolveResult]),(KindIndexedBindings))
-- cata
sem_KindIndexedBindings :: (KindIndexedBindings) ->
                           (T_KindIndexedBindings)
sem_KindIndexedBindings (list) =
    (foldr (sem_KindIndexedBindings_Cons) (sem_KindIndexedBindings_Nil) ((map sem_KindIndexedBinding list)))
sem_KindIndexedBindings_Cons :: (T_KindIndexedBinding) ->
                                (T_KindIndexedBindings) ->
                                (T_KindIndexedBindings)
sem_KindIndexedBindings_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOname :: (Name)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (KindIndexedBindings)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIknownKinds_collect :: (FMap Name [Name])
            _hdIknownTypes_collect :: (FMap Name [Name])
            _hdIknownValues_collect :: (FMap Name [Name])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdImoduleTypes :: (FMap ModuleName [Name])
            _hdImoduleValues :: (FMap ModuleName [Name])
            _hdImodules :: (Set.Set Strings)
            _hdIname :: (Name)
            _hdIres :: ([ResolveResult])
            _hdIself :: (KindIndexedBinding)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOknownGenerics :: (FMap Name [Name])
            _hdOknownKinds :: (FMap Name [Name])
            _hdOknownKinds_collect :: (FMap Name [Name])
            _hdOknownTypes :: (FMap Name [Name])
            _hdOknownTypes_collect :: (FMap Name [Name])
            _hdOknownValues :: (FMap Name [Name])
            _hdOknownValues_collect :: (FMap Name [Name])
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmoduleTypes :: (FMap ModuleName [Name])
            _hdOmoduleValues :: (FMap ModuleName [Name])
            _hdOnameType :: (NameType)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIknownKinds_collect :: (FMap Name [Name])
            _tlIknownTypes_collect :: (FMap Name [Name])
            _tlIknownValues_collect :: (FMap Name [Name])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlImoduleTypes :: (FMap ModuleName [Name])
            _tlImoduleValues :: (FMap ModuleName [Name])
            _tlImodules :: (Set.Set Strings)
            _tlIname :: (Name)
            _tlIres :: ([ResolveResult])
            _tlIself :: (KindIndexedBindings)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOknownGenerics :: (FMap Name [Name])
            _tlOknownKinds :: (FMap Name [Name])
            _tlOknownKinds_collect :: (FMap Name [Name])
            _tlOknownTypes :: (FMap Name [Name])
            _tlOknownTypes_collect :: (FMap Name [Name])
            _tlOknownValues :: (FMap Name [Name])
            _tlOknownValues_collect :: (FMap Name [Name])
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmoduleTypes :: (FMap ModuleName [Name])
            _tlOmoduleValues :: (FMap ModuleName [Name])
            _tlOnameType :: (NameType)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIknownKinds_collect,_hdIknownTypes_collect,_hdIknownValues_collect,_hdIlabels_collect,_hdImethods_collect,_hdImoduleTypes,_hdImoduleValues,_hdImodules,_hdIname,_hdIres,_hdIself) =
                (hd_ (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOknownGenerics)
                     (_hdOknownKinds)
                     (_hdOknownKinds_collect)
                     (_hdOknownTypes)
                     (_hdOknownTypes_collect)
                     (_hdOknownValues)
                     (_hdOknownValues_collect)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmoduleTypes)
                     (_hdOmoduleValues)
                     (_hdOnameType)
                     (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIknownKinds_collect,_tlIknownTypes_collect,_tlIknownValues_collect,_tlIlabels_collect,_tlImethods_collect,_tlImoduleTypes,_tlImoduleValues,_tlImodules,_tlIname,_tlIres,_tlIself) =
                (tl_ (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOknownGenerics)
                     (_tlOknownKinds)
                     (_tlOknownKinds_collect)
                     (_tlOknownTypes)
                     (_tlOknownTypes_collect)
                     (_tlOknownValues)
                     (_tlOknownValues_collect)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmoduleTypes)
                     (_tlOmoduleValues)
                     (_tlOnameType)
                     (_tlOtoplevel))
            -- "./NameTypes.inc.lag"(line 290, column 9)
            (_tlOnameType@_) =
                softref_Typ
            -- "./ModuleInformation.inc.lag"(line 410, column 9)
            (_lhsOname@_) =
                _hdIname
            -- use rule
            (_lhsOmodules@_) =
                _hdImodules `Set.union` _tlImodules
            -- use rule
            (_lhsOres@_) =
                _hdIres ++ _tlIres
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _tlIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _tlIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _tlIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _tlImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _tlImoduleValues
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_hdOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_hdOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_hdOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_hdOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_hdOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_hdOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_hdOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_hdOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_tlOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_tlOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_tlOknownKinds_collect@_) =
                _hdIknownKinds_collect
            -- copy rule (down)
            (_tlOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_tlOknownTypes_collect@_) =
                _hdIknownTypes_collect
            -- copy rule (down)
            (_tlOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_tlOknownValues_collect@_) =
                _hdIknownValues_collect
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_tlOmoduleTypes@_) =
                _hdImoduleTypes
            -- copy rule (chain)
            (_tlOmoduleValues@_) =
                _hdImoduleValues
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOname,_lhsOres,_lhsOself)
sem_KindIndexedBindings_Nil :: (T_KindIndexedBindings)
sem_KindIndexedBindings_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOname :: (Name)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (KindIndexedBindings)
            -- "./ModuleInformation.inc.lag"(line 412, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.KindIndexedBindings.Nil.lhs.name: no bindings"
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOname,_lhsOres,_lhsOself)
-- LeftHandSide ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValuesForBody_collect : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      name                 : Name
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for LeftHandSide.Function:
      self

-}
{-
   local variables for LeftHandSide.Infix:
      self

-}
{-
   local variables for LeftHandSide.Parenthesized:
      self

-}
-- semantic domain
type T_LeftHandSide = (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Strings) ->
                      (Bool) ->
                      (Maybe Name) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (FMap ModuleName [Name]) ->
                      (FMap ModuleName [Name]) ->
                      (NameType) ->
                      (Bool) ->
                      ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),(Name),([ResolveResult]),(LeftHandSide))
-- cata
sem_LeftHandSide :: (LeftHandSide) ->
                    (T_LeftHandSide)
sem_LeftHandSide ((LeftHandSide_Function (_range) (_name) (_patterns))) =
    (sem_LeftHandSide_Function ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Patterns (_patterns))))
sem_LeftHandSide ((LeftHandSide_Infix (_range) (_leftPattern) (_operator) (_rightPattern))) =
    (sem_LeftHandSide_Infix ((sem_Range (_range))) ((sem_Pattern (_leftPattern))) ((sem_Name (_operator))) ((sem_Pattern (_rightPattern))))
sem_LeftHandSide ((LeftHandSide_Parenthesized (_range) (_lefthandside) (_patterns))) =
    (sem_LeftHandSide_Parenthesized ((sem_Range (_range))) ((sem_LeftHandSide (_lefthandside))) ((sem_Patterns (_patterns))))
sem_LeftHandSide_Function :: (T_Range) ->
                             (T_Name) ->
                             (T_Patterns) ->
                             (T_LeftHandSide)
sem_LeftHandSide_Function (range_) (name_) (patterns_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValuesForBody_collect
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValuesForBody_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOname :: (Name)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (LeftHandSide)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _patternsIconstructors_collect :: (FMap Name Names)
            _patternsIknownKinds_collect :: (FMap Name [Name])
            _patternsIknownTypes_collect :: (FMap Name [Name])
            _patternsIknownValues_collect :: (FMap Name [Name])
            _patternsIlabels_collect :: (FMap Name Names)
            _patternsImethods_collect :: (FMap Name Names)
            _patternsImoduleTypes :: (FMap ModuleName [Name])
            _patternsImoduleValues :: (FMap ModuleName [Name])
            _patternsImodules :: (Set.Set Strings)
            _patternsIres :: ([ResolveResult])
            _patternsIself :: (Patterns)
            _patternsOclassname :: (Maybe Name)
            _patternsOconstructors_collect :: (FMap Name Names)
            _patternsOconstructors_dist :: (FMap Name Names)
            _patternsOcurrentModule :: (Strings)
            _patternsOimportedModule :: (Bool)
            _patternsOinstancename :: (Maybe Name)
            _patternsOknownKinds :: (FMap Name [Name])
            _patternsOknownKinds_collect :: (FMap Name [Name])
            _patternsOknownTypes :: (FMap Name [Name])
            _patternsOknownTypes_collect :: (FMap Name [Name])
            _patternsOknownValues :: (FMap Name [Name])
            _patternsOknownValues_collect :: (FMap Name [Name])
            _patternsOlabels_collect :: (FMap Name Names)
            _patternsOlabels_dist :: (FMap Name Names)
            _patternsOlocal :: (Bool)
            _patternsOmethods_collect :: (FMap Name Names)
            _patternsOmethods_dist :: (FMap Name Names)
            _patternsOmoduleTypes :: (FMap ModuleName [Name])
            _patternsOmoduleValues :: (FMap ModuleName [Name])
            _patternsOnameType :: (NameType)
            _patternsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _patternsIconstructors_collect,_patternsIknownKinds_collect,_patternsIknownTypes_collect,_patternsIknownValues_collect,_patternsIlabels_collect,_patternsImethods_collect,_patternsImoduleTypes,_patternsImoduleValues,_patternsImodules,_patternsIres,_patternsIself) =
                (patterns_ (_patternsOclassname)
                           (_patternsOconstructors_collect)
                           (_patternsOconstructors_dist)
                           (_patternsOcurrentModule)
                           (_patternsOimportedModule)
                           (_patternsOinstancename)
                           (_patternsOknownKinds)
                           (_patternsOknownKinds_collect)
                           (_patternsOknownTypes)
                           (_patternsOknownTypes_collect)
                           (_patternsOknownValues)
                           (_patternsOknownValues_collect)
                           (_patternsOlabels_collect)
                           (_patternsOlabels_dist)
                           (_patternsOlocal)
                           (_patternsOmethods_collect)
                           (_patternsOmethods_dist)
                           (_patternsOmoduleTypes)
                           (_patternsOmoduleValues)
                           (_patternsOnameType)
                           (_patternsOtoplevel))
            -- "./Names.inc.lag"(line 654, column 9)
            (_nameOknownValues@_) =
                classMethods
                  _lhsIinstancename
                  _lhsIknownValues
                  _lhsImethods_dist
            -- "./Names.inc.lag"(line 652, column 9)
            (_lhsOknownValuesForBody_collect@_) =
                _patternsIknownValues_collect
            -- "./Names.inc.lag"(line 651, column 9)
            (_patternsOknownValues_collect@_) =
                _lhsIknownValuesForBody_collect
            -- "./Names.inc.lag"(line 650, column 9)
            (_lhsOknownValues_collect@_) =
                _nameIknownValues_collect
            -- "./Names.inc.lag"(line 649, column 9)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- "./ModuleInformation.inc.lag"(line 176, column 8)
            (_patternsOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 404, column 9)
            (_lhsOname@_) =
                _nameIself
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _patternsImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _patternsIres
            -- self rule
            (_self@_) =
                LeftHandSide_Function _rangeIself _nameIself _patternsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _patternsIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _patternsIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _patternsIknownTypes_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _patternsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _patternsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _patternsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _patternsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_patternsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_patternsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_patternsOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_patternsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_patternsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (down)
            (_patternsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_patternsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_patternsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_patternsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_patternsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_patternsOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_patternsOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_patternsOnameType@_) =
                _lhsInameType
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValuesForBody_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOname,_lhsOres,_lhsOself)
sem_LeftHandSide_Infix :: (T_Range) ->
                          (T_Pattern) ->
                          (T_Name) ->
                          (T_Pattern) ->
                          (T_LeftHandSide)
sem_LeftHandSide_Infix (range_) (leftPattern_) (operator_) (rightPattern_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValuesForBody_collect
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValuesForBody_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOname :: (Name)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (LeftHandSide)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _leftPatternIconstructors_collect :: (FMap Name Names)
            _leftPatternIknownKinds_collect :: (FMap Name [Name])
            _leftPatternIknownTypes_collect :: (FMap Name [Name])
            _leftPatternIknownValues_collect :: (FMap Name [Name])
            _leftPatternIlabels_collect :: (FMap Name Names)
            _leftPatternImethods_collect :: (FMap Name Names)
            _leftPatternImoduleTypes :: (FMap ModuleName [Name])
            _leftPatternImoduleValues :: (FMap ModuleName [Name])
            _leftPatternImodules :: (Set.Set Strings)
            _leftPatternIname :: (Name)
            _leftPatternIres :: ([ResolveResult])
            _leftPatternIself :: (Pattern)
            _leftPatternOclassname :: (Maybe Name)
            _leftPatternOconstructors_collect :: (FMap Name Names)
            _leftPatternOconstructors_dist :: (FMap Name Names)
            _leftPatternOcurrentModule :: (Strings)
            _leftPatternOimportedModule :: (Bool)
            _leftPatternOinstancename :: (Maybe Name)
            _leftPatternOknownKinds :: (FMap Name [Name])
            _leftPatternOknownKinds_collect :: (FMap Name [Name])
            _leftPatternOknownTypes :: (FMap Name [Name])
            _leftPatternOknownTypes_collect :: (FMap Name [Name])
            _leftPatternOknownValues :: (FMap Name [Name])
            _leftPatternOknownValues_collect :: (FMap Name [Name])
            _leftPatternOlabels_collect :: (FMap Name Names)
            _leftPatternOlabels_dist :: (FMap Name Names)
            _leftPatternOlocal :: (Bool)
            _leftPatternOmethods_collect :: (FMap Name Names)
            _leftPatternOmethods_dist :: (FMap Name Names)
            _leftPatternOmoduleTypes :: (FMap ModuleName [Name])
            _leftPatternOmoduleValues :: (FMap ModuleName [Name])
            _leftPatternOnameType :: (NameType)
            _leftPatternOtoplevel :: (Bool)
            _operatorIconstructors_collect :: (FMap Name Names)
            _operatorIentityName :: (Name)
            _operatorIfullName :: (Name)
            _operatorIknownKinds_collect :: (FMap Name [Name])
            _operatorIknownTypes_collect :: (FMap Name [Name])
            _operatorIknownValues_collect :: (FMap Name [Name])
            _operatorIlabels_collect :: (FMap Name Names)
            _operatorImethods_collect :: (FMap Name Names)
            _operatorImoduleTypes :: (FMap ModuleName [Name])
            _operatorImoduleValues :: (FMap ModuleName [Name])
            _operatorImodules :: (Set.Set Strings)
            _operatorIoriginalSelf :: (Name)
            _operatorIres :: ([ResolveResult])
            _operatorIself :: (Name)
            _operatorOclassname :: (Maybe Name)
            _operatorOconstructors_collect :: (FMap Name Names)
            _operatorOconstructors_dist :: (FMap Name Names)
            _operatorOcurrentModule :: (Strings)
            _operatorOimportedModule :: (Bool)
            _operatorOinstancename :: (Maybe Name)
            _operatorOknownKinds :: (FMap Name [Name])
            _operatorOknownKinds_collect :: (FMap Name [Name])
            _operatorOknownTypes :: (FMap Name [Name])
            _operatorOknownTypes_collect :: (FMap Name [Name])
            _operatorOknownValues :: (FMap Name [Name])
            _operatorOknownValues_collect :: (FMap Name [Name])
            _operatorOlabels_collect :: (FMap Name Names)
            _operatorOlabels_dist :: (FMap Name Names)
            _operatorOlocal :: (Bool)
            _operatorOmethods_collect :: (FMap Name Names)
            _operatorOmethods_dist :: (FMap Name Names)
            _operatorOmoduleTypes :: (FMap ModuleName [Name])
            _operatorOmoduleValues :: (FMap ModuleName [Name])
            _operatorOnameType :: (NameType)
            _operatorOtoplevel :: (Bool)
            _rightPatternIconstructors_collect :: (FMap Name Names)
            _rightPatternIknownKinds_collect :: (FMap Name [Name])
            _rightPatternIknownTypes_collect :: (FMap Name [Name])
            _rightPatternIknownValues_collect :: (FMap Name [Name])
            _rightPatternIlabels_collect :: (FMap Name Names)
            _rightPatternImethods_collect :: (FMap Name Names)
            _rightPatternImoduleTypes :: (FMap ModuleName [Name])
            _rightPatternImoduleValues :: (FMap ModuleName [Name])
            _rightPatternImodules :: (Set.Set Strings)
            _rightPatternIname :: (Name)
            _rightPatternIres :: ([ResolveResult])
            _rightPatternIself :: (Pattern)
            _rightPatternOclassname :: (Maybe Name)
            _rightPatternOconstructors_collect :: (FMap Name Names)
            _rightPatternOconstructors_dist :: (FMap Name Names)
            _rightPatternOcurrentModule :: (Strings)
            _rightPatternOimportedModule :: (Bool)
            _rightPatternOinstancename :: (Maybe Name)
            _rightPatternOknownKinds :: (FMap Name [Name])
            _rightPatternOknownKinds_collect :: (FMap Name [Name])
            _rightPatternOknownTypes :: (FMap Name [Name])
            _rightPatternOknownTypes_collect :: (FMap Name [Name])
            _rightPatternOknownValues :: (FMap Name [Name])
            _rightPatternOknownValues_collect :: (FMap Name [Name])
            _rightPatternOlabels_collect :: (FMap Name Names)
            _rightPatternOlabels_dist :: (FMap Name Names)
            _rightPatternOlocal :: (Bool)
            _rightPatternOmethods_collect :: (FMap Name Names)
            _rightPatternOmethods_dist :: (FMap Name Names)
            _rightPatternOmoduleTypes :: (FMap ModuleName [Name])
            _rightPatternOmoduleValues :: (FMap ModuleName [Name])
            _rightPatternOnameType :: (NameType)
            _rightPatternOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _leftPatternIconstructors_collect,_leftPatternIknownKinds_collect,_leftPatternIknownTypes_collect,_leftPatternIknownValues_collect,_leftPatternIlabels_collect,_leftPatternImethods_collect,_leftPatternImoduleTypes,_leftPatternImoduleValues,_leftPatternImodules,_leftPatternIname,_leftPatternIres,_leftPatternIself) =
                (leftPattern_ (_leftPatternOclassname)
                              (_leftPatternOconstructors_collect)
                              (_leftPatternOconstructors_dist)
                              (_leftPatternOcurrentModule)
                              (_leftPatternOimportedModule)
                              (_leftPatternOinstancename)
                              (_leftPatternOknownKinds)
                              (_leftPatternOknownKinds_collect)
                              (_leftPatternOknownTypes)
                              (_leftPatternOknownTypes_collect)
                              (_leftPatternOknownValues)
                              (_leftPatternOknownValues_collect)
                              (_leftPatternOlabels_collect)
                              (_leftPatternOlabels_dist)
                              (_leftPatternOlocal)
                              (_leftPatternOmethods_collect)
                              (_leftPatternOmethods_dist)
                              (_leftPatternOmoduleTypes)
                              (_leftPatternOmoduleValues)
                              (_leftPatternOnameType)
                              (_leftPatternOtoplevel))
            ( _operatorIconstructors_collect,_operatorIentityName,_operatorIfullName,_operatorIknownKinds_collect,_operatorIknownTypes_collect,_operatorIknownValues_collect,_operatorIlabels_collect,_operatorImethods_collect,_operatorImoduleTypes,_operatorImoduleValues,_operatorImodules,_operatorIoriginalSelf,_operatorIres,_operatorIself) =
                (operator_ (_operatorOclassname)
                           (_operatorOconstructors_collect)
                           (_operatorOconstructors_dist)
                           (_operatorOcurrentModule)
                           (_operatorOimportedModule)
                           (_operatorOinstancename)
                           (_operatorOknownKinds)
                           (_operatorOknownKinds_collect)
                           (_operatorOknownTypes)
                           (_operatorOknownTypes_collect)
                           (_operatorOknownValues)
                           (_operatorOknownValues_collect)
                           (_operatorOlabels_collect)
                           (_operatorOlabels_dist)
                           (_operatorOlocal)
                           (_operatorOmethods_collect)
                           (_operatorOmethods_dist)
                           (_operatorOmoduleTypes)
                           (_operatorOmoduleValues)
                           (_operatorOnameType)
                           (_operatorOtoplevel))
            ( _rightPatternIconstructors_collect,_rightPatternIknownKinds_collect,_rightPatternIknownTypes_collect,_rightPatternIknownValues_collect,_rightPatternIlabels_collect,_rightPatternImethods_collect,_rightPatternImoduleTypes,_rightPatternImoduleValues,_rightPatternImodules,_rightPatternIname,_rightPatternIres,_rightPatternIself) =
                (rightPattern_ (_rightPatternOclassname)
                               (_rightPatternOconstructors_collect)
                               (_rightPatternOconstructors_dist)
                               (_rightPatternOcurrentModule)
                               (_rightPatternOimportedModule)
                               (_rightPatternOinstancename)
                               (_rightPatternOknownKinds)
                               (_rightPatternOknownKinds_collect)
                               (_rightPatternOknownTypes)
                               (_rightPatternOknownTypes_collect)
                               (_rightPatternOknownValues)
                               (_rightPatternOknownValues_collect)
                               (_rightPatternOlabels_collect)
                               (_rightPatternOlabels_dist)
                               (_rightPatternOlocal)
                               (_rightPatternOmethods_collect)
                               (_rightPatternOmethods_dist)
                               (_rightPatternOmoduleTypes)
                               (_rightPatternOmoduleValues)
                               (_rightPatternOnameType)
                               (_rightPatternOtoplevel))
            -- "./Names.inc.lag"(line 666, column 9)
            (_operatorOknownValues@_) =
                classMethods
                  _lhsIinstancename
                  _lhsIknownValues
                  _lhsImethods_dist
            -- "./Names.inc.lag"(line 664, column 9)
            (_lhsOknownValuesForBody_collect@_) =
                _rightPatternIknownValues_collect
            -- "./Names.inc.lag"(line 663, column 9)
            (_rightPatternOknownValues_collect@_) =
                _leftPatternIknownValues_collect
            -- "./Names.inc.lag"(line 662, column 9)
            (_leftPatternOknownValues_collect@_) =
                _lhsIknownValuesForBody_collect
            -- "./Names.inc.lag"(line 661, column 9)
            (_lhsOknownValues_collect@_) =
                _operatorIknownValues_collect
            -- "./Names.inc.lag"(line 660, column 9)
            (_operatorOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- "./NameTypes.inc.lag"(line 369, column 9)
            (_rightPatternOnameType@_) =
                Def_Val
            -- "./NameTypes.inc.lag"(line 368, column 9)
            (_leftPatternOnameType@_) =
                Def_Val
            -- "./ModuleInformation.inc.lag"(line 179, column 8)
            (_rightPatternOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 178, column 8)
            (_leftPatternOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 406, column 9)
            (_lhsOname@_) =
                _operatorIself
            -- use rule
            (_lhsOmodules@_) =
                _leftPatternImodules `Set.union` _operatorImodules `Set.union` _rightPatternImodules
            -- use rule
            (_lhsOres@_) =
                _leftPatternIres ++ _operatorIres ++ _rightPatternIres
            -- self rule
            (_self@_) =
                LeftHandSide_Infix _rangeIself _leftPatternIself _operatorIself _rightPatternIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _rightPatternIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _rightPatternIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _rightPatternIknownTypes_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _rightPatternIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _rightPatternImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _rightPatternImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _rightPatternImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_leftPatternOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_leftPatternOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_leftPatternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_leftPatternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_leftPatternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_leftPatternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_leftPatternOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_leftPatternOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_leftPatternOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_leftPatternOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_leftPatternOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_leftPatternOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_leftPatternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_leftPatternOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_leftPatternOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_leftPatternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_leftPatternOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_leftPatternOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_operatorOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_operatorOconstructors_collect@_) =
                _leftPatternIconstructors_collect
            -- copy rule (down)
            (_operatorOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_operatorOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_operatorOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_operatorOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_operatorOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_operatorOknownKinds_collect@_) =
                _leftPatternIknownKinds_collect
            -- copy rule (down)
            (_operatorOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_operatorOknownTypes_collect@_) =
                _leftPatternIknownTypes_collect
            -- copy rule (chain)
            (_operatorOlabels_collect@_) =
                _leftPatternIlabels_collect
            -- copy rule (down)
            (_operatorOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_operatorOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_operatorOmethods_collect@_) =
                _leftPatternImethods_collect
            -- copy rule (down)
            (_operatorOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_operatorOmoduleTypes@_) =
                _leftPatternImoduleTypes
            -- copy rule (chain)
            (_operatorOmoduleValues@_) =
                _leftPatternImoduleValues
            -- copy rule (down)
            (_operatorOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_operatorOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_rightPatternOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_rightPatternOconstructors_collect@_) =
                _operatorIconstructors_collect
            -- copy rule (down)
            (_rightPatternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_rightPatternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rightPatternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rightPatternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rightPatternOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_rightPatternOknownKinds_collect@_) =
                _operatorIknownKinds_collect
            -- copy rule (down)
            (_rightPatternOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_rightPatternOknownTypes_collect@_) =
                _operatorIknownTypes_collect
            -- copy rule (down)
            (_rightPatternOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_rightPatternOlabels_collect@_) =
                _operatorIlabels_collect
            -- copy rule (down)
            (_rightPatternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_rightPatternOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_rightPatternOmethods_collect@_) =
                _operatorImethods_collect
            -- copy rule (down)
            (_rightPatternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_rightPatternOmoduleTypes@_) =
                _operatorImoduleTypes
            -- copy rule (chain)
            (_rightPatternOmoduleValues@_) =
                _operatorImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValuesForBody_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOname,_lhsOres,_lhsOself)
sem_LeftHandSide_Parenthesized :: (T_Range) ->
                                  (T_LeftHandSide) ->
                                  (T_Patterns) ->
                                  (T_LeftHandSide)
sem_LeftHandSide_Parenthesized (range_) (lefthandside_) (patterns_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValuesForBody_collect
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValuesForBody_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOname :: (Name)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (LeftHandSide)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _lefthandsideIconstructors_collect :: (FMap Name Names)
            _lefthandsideIknownKinds_collect :: (FMap Name [Name])
            _lefthandsideIknownTypes_collect :: (FMap Name [Name])
            _lefthandsideIknownValuesForBody_collect :: (FMap Name [Name])
            _lefthandsideIknownValues_collect :: (FMap Name [Name])
            _lefthandsideIlabels_collect :: (FMap Name Names)
            _lefthandsideImethods_collect :: (FMap Name Names)
            _lefthandsideImoduleTypes :: (FMap ModuleName [Name])
            _lefthandsideImoduleValues :: (FMap ModuleName [Name])
            _lefthandsideImodules :: (Set.Set Strings)
            _lefthandsideIname :: (Name)
            _lefthandsideIres :: ([ResolveResult])
            _lefthandsideIself :: (LeftHandSide)
            _lefthandsideOclassname :: (Maybe Name)
            _lefthandsideOconstructors_collect :: (FMap Name Names)
            _lefthandsideOconstructors_dist :: (FMap Name Names)
            _lefthandsideOcurrentModule :: (Strings)
            _lefthandsideOimportedModule :: (Bool)
            _lefthandsideOinstancename :: (Maybe Name)
            _lefthandsideOknownKinds :: (FMap Name [Name])
            _lefthandsideOknownKinds_collect :: (FMap Name [Name])
            _lefthandsideOknownTypes :: (FMap Name [Name])
            _lefthandsideOknownTypes_collect :: (FMap Name [Name])
            _lefthandsideOknownValues :: (FMap Name [Name])
            _lefthandsideOknownValuesForBody_collect :: (FMap Name [Name])
            _lefthandsideOknownValues_collect :: (FMap Name [Name])
            _lefthandsideOlabels_collect :: (FMap Name Names)
            _lefthandsideOlabels_dist :: (FMap Name Names)
            _lefthandsideOlocal :: (Bool)
            _lefthandsideOmethods_collect :: (FMap Name Names)
            _lefthandsideOmethods_dist :: (FMap Name Names)
            _lefthandsideOmoduleTypes :: (FMap ModuleName [Name])
            _lefthandsideOmoduleValues :: (FMap ModuleName [Name])
            _lefthandsideOnameType :: (NameType)
            _lefthandsideOtoplevel :: (Bool)
            _patternsIconstructors_collect :: (FMap Name Names)
            _patternsIknownKinds_collect :: (FMap Name [Name])
            _patternsIknownTypes_collect :: (FMap Name [Name])
            _patternsIknownValues_collect :: (FMap Name [Name])
            _patternsIlabels_collect :: (FMap Name Names)
            _patternsImethods_collect :: (FMap Name Names)
            _patternsImoduleTypes :: (FMap ModuleName [Name])
            _patternsImoduleValues :: (FMap ModuleName [Name])
            _patternsImodules :: (Set.Set Strings)
            _patternsIres :: ([ResolveResult])
            _patternsIself :: (Patterns)
            _patternsOclassname :: (Maybe Name)
            _patternsOconstructors_collect :: (FMap Name Names)
            _patternsOconstructors_dist :: (FMap Name Names)
            _patternsOcurrentModule :: (Strings)
            _patternsOimportedModule :: (Bool)
            _patternsOinstancename :: (Maybe Name)
            _patternsOknownKinds :: (FMap Name [Name])
            _patternsOknownKinds_collect :: (FMap Name [Name])
            _patternsOknownTypes :: (FMap Name [Name])
            _patternsOknownTypes_collect :: (FMap Name [Name])
            _patternsOknownValues :: (FMap Name [Name])
            _patternsOknownValues_collect :: (FMap Name [Name])
            _patternsOlabels_collect :: (FMap Name Names)
            _patternsOlabels_dist :: (FMap Name Names)
            _patternsOlocal :: (Bool)
            _patternsOmethods_collect :: (FMap Name Names)
            _patternsOmethods_dist :: (FMap Name Names)
            _patternsOmoduleTypes :: (FMap ModuleName [Name])
            _patternsOmoduleValues :: (FMap ModuleName [Name])
            _patternsOnameType :: (NameType)
            _patternsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _lefthandsideIconstructors_collect,_lefthandsideIknownKinds_collect,_lefthandsideIknownTypes_collect,_lefthandsideIknownValuesForBody_collect,_lefthandsideIknownValues_collect,_lefthandsideIlabels_collect,_lefthandsideImethods_collect,_lefthandsideImoduleTypes,_lefthandsideImoduleValues,_lefthandsideImodules,_lefthandsideIname,_lefthandsideIres,_lefthandsideIself) =
                (lefthandside_ (_lefthandsideOclassname)
                               (_lefthandsideOconstructors_collect)
                               (_lefthandsideOconstructors_dist)
                               (_lefthandsideOcurrentModule)
                               (_lefthandsideOimportedModule)
                               (_lefthandsideOinstancename)
                               (_lefthandsideOknownKinds)
                               (_lefthandsideOknownKinds_collect)
                               (_lefthandsideOknownTypes)
                               (_lefthandsideOknownTypes_collect)
                               (_lefthandsideOknownValues)
                               (_lefthandsideOknownValuesForBody_collect)
                               (_lefthandsideOknownValues_collect)
                               (_lefthandsideOlabels_collect)
                               (_lefthandsideOlabels_dist)
                               (_lefthandsideOlocal)
                               (_lefthandsideOmethods_collect)
                               (_lefthandsideOmethods_dist)
                               (_lefthandsideOmoduleTypes)
                               (_lefthandsideOmoduleValues)
                               (_lefthandsideOnameType)
                               (_lefthandsideOtoplevel))
            ( _patternsIconstructors_collect,_patternsIknownKinds_collect,_patternsIknownTypes_collect,_patternsIknownValues_collect,_patternsIlabels_collect,_patternsImethods_collect,_patternsImoduleTypes,_patternsImoduleValues,_patternsImodules,_patternsIres,_patternsIself) =
                (patterns_ (_patternsOclassname)
                           (_patternsOconstructors_collect)
                           (_patternsOconstructors_dist)
                           (_patternsOcurrentModule)
                           (_patternsOimportedModule)
                           (_patternsOinstancename)
                           (_patternsOknownKinds)
                           (_patternsOknownKinds_collect)
                           (_patternsOknownTypes)
                           (_patternsOknownTypes_collect)
                           (_patternsOknownValues)
                           (_patternsOknownValues_collect)
                           (_patternsOlabels_collect)
                           (_patternsOlabels_dist)
                           (_patternsOlocal)
                           (_patternsOmethods_collect)
                           (_patternsOmethods_dist)
                           (_patternsOmoduleTypes)
                           (_patternsOmoduleValues)
                           (_patternsOnameType)
                           (_patternsOtoplevel))
            -- "./Names.inc.lag"(line 674, column 9)
            (_lhsOknownValuesForBody_collect@_) =
                _patternsIknownValues_collect
            -- "./Names.inc.lag"(line 673, column 9)
            (_patternsOknownValues_collect@_) =
                _lefthandsideIknownValuesForBody_collect
            -- "./Names.inc.lag"(line 672, column 9)
            (_lhsOknownValues_collect@_) =
                _lefthandsideIknownValues_collect
            -- "./ModuleInformation.inc.lag"(line 181, column 8)
            (_patternsOtoplevel@_) =
                False
            -- use rule
            (_lhsOmodules@_) =
                _lefthandsideImodules `Set.union` _patternsImodules
            -- use rule
            (_lhsOres@_) =
                _lefthandsideIres ++ _patternsIres
            -- self rule
            (_self@_) =
                LeftHandSide_Parenthesized _rangeIself _lefthandsideIself _patternsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _patternsIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _patternsIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _patternsIknownTypes_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _patternsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _patternsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _patternsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _patternsImoduleValues
            -- copy rule (up)
            (_lhsOname@_) =
                _lefthandsideIname
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_lefthandsideOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_lefthandsideOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_lefthandsideOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_lefthandsideOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_lefthandsideOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_lefthandsideOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_lefthandsideOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_lefthandsideOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_lefthandsideOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_lefthandsideOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_lefthandsideOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_lefthandsideOknownValuesForBody_collect@_) =
                _lhsIknownValuesForBody_collect
            -- copy rule (down)
            (_lefthandsideOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_lefthandsideOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_lefthandsideOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_lefthandsideOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_lefthandsideOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_lefthandsideOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_lefthandsideOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_lefthandsideOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_lefthandsideOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_lefthandsideOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_patternsOconstructors_collect@_) =
                _lefthandsideIconstructors_collect
            -- copy rule (down)
            (_patternsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_patternsOknownKinds_collect@_) =
                _lefthandsideIknownKinds_collect
            -- copy rule (down)
            (_patternsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_patternsOknownTypes_collect@_) =
                _lefthandsideIknownTypes_collect
            -- copy rule (down)
            (_patternsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_patternsOlabels_collect@_) =
                _lefthandsideIlabels_collect
            -- copy rule (down)
            (_patternsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_patternsOmethods_collect@_) =
                _lefthandsideImethods_collect
            -- copy rule (down)
            (_patternsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_patternsOmoduleTypes@_) =
                _lefthandsideImoduleTypes
            -- copy rule (chain)
            (_patternsOmoduleValues@_) =
                _lefthandsideImoduleValues
            -- copy rule (down)
            (_patternsOnameType@_) =
                _lhsInameType
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValuesForBody_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOname,_lhsOres,_lhsOself)
-- Literal -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for Literal.Char:
      self

-}
{-
   local variables for Literal.Float:
      self

-}
{-
   local variables for Literal.Int:
      self

-}
{-
   local variables for Literal.String:
      self

-}
-- semantic domain
type T_Literal = (Maybe Name) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Strings) ->
                 (Bool) ->
                 (Maybe Name) ->
                 (FMap Name [Name]) ->
                 (FMap Name [Name]) ->
                 (FMap Name [Name]) ->
                 (FMap Name [Name]) ->
                 (FMap Name [Name]) ->
                 (FMap Name [Name]) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Bool) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (FMap ModuleName [Name]) ->
                 (FMap ModuleName [Name]) ->
                 (NameType) ->
                 (Bool) ->
                 ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(Literal))
-- cata
sem_Literal :: (Literal) ->
               (T_Literal)
sem_Literal ((Literal_Char (_range) (_value))) =
    (sem_Literal_Char ((sem_Range (_range))) (_value))
sem_Literal ((Literal_Float (_range) (_value))) =
    (sem_Literal_Float ((sem_Range (_range))) (_value))
sem_Literal ((Literal_Int (_range) (_value))) =
    (sem_Literal_Int ((sem_Range (_range))) (_value))
sem_Literal ((Literal_String (_range) (_value))) =
    (sem_Literal_String ((sem_Range (_range))) (_value))
sem_Literal_Char :: (T_Range) ->
                    (String) ->
                    (T_Literal)
sem_Literal_Char (range_) (value_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Literal)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                Literal_Char _rangeIself value_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Literal_Float :: (T_Range) ->
                     (String) ->
                     (T_Literal)
sem_Literal_Float (range_) (value_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Literal)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                Literal_Float _rangeIself value_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Literal_Int :: (T_Range) ->
                   (String) ->
                   (T_Literal)
sem_Literal_Int (range_) (value_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Literal)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                Literal_Int _rangeIself value_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Literal_String :: (T_Range) ->
                      (String) ->
                      (T_Literal)
sem_Literal_String (range_) (value_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Literal)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                Literal_String _rangeIself value_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- MaybeDeclarations -------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for MaybeDeclarations.Just:
      self

-}
{-
   local variables for MaybeDeclarations.Nothing:
      self

-}
-- semantic domain
type T_MaybeDeclarations = (Maybe Name) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Strings) ->
                           (Bool) ->
                           (Maybe Name) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name [Name]) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Bool) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (FMap ModuleName [Name]) ->
                           (FMap ModuleName [Name]) ->
                           (NameType) ->
                           (Bool) ->
                           ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(MaybeDeclarations))
-- cata
sem_MaybeDeclarations :: (MaybeDeclarations) ->
                         (T_MaybeDeclarations)
sem_MaybeDeclarations ((MaybeDeclarations_Just (_declarations))) =
    (sem_MaybeDeclarations_Just ((sem_Declarations (_declarations))))
sem_MaybeDeclarations ((MaybeDeclarations_Nothing )) =
    (sem_MaybeDeclarations_Nothing )
sem_MaybeDeclarations_Just :: (T_Declarations) ->
                              (T_MaybeDeclarations)
sem_MaybeDeclarations_Just (declarations_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (MaybeDeclarations)
            _declarationsIconstructors_collect :: (FMap Name Names)
            _declarationsIknownKinds_collect :: (FMap Name [Name])
            _declarationsIknownTypes_collect :: (FMap Name [Name])
            _declarationsIknownValues_collect :: (FMap Name [Name])
            _declarationsIlabels_collect :: (FMap Name Names)
            _declarationsImethods_collect :: (FMap Name Names)
            _declarationsImoduleTypes :: (FMap ModuleName [Name])
            _declarationsImoduleValues :: (FMap ModuleName [Name])
            _declarationsImodules :: (Set.Set Strings)
            _declarationsIres :: ([ResolveResult])
            _declarationsIself :: (Declarations)
            _declarationsOclassname :: (Maybe Name)
            _declarationsOconstructors_collect :: (FMap Name Names)
            _declarationsOconstructors_dist :: (FMap Name Names)
            _declarationsOcurrentModule :: (Strings)
            _declarationsOimportedModule :: (Bool)
            _declarationsOinstancename :: (Maybe Name)
            _declarationsOknownGenerics :: (FMap Name [Name])
            _declarationsOknownKinds :: (FMap Name [Name])
            _declarationsOknownKinds_collect :: (FMap Name [Name])
            _declarationsOknownTypes :: (FMap Name [Name])
            _declarationsOknownTypes_collect :: (FMap Name [Name])
            _declarationsOknownValues :: (FMap Name [Name])
            _declarationsOknownValues_collect :: (FMap Name [Name])
            _declarationsOlabels_collect :: (FMap Name Names)
            _declarationsOlabels_dist :: (FMap Name Names)
            _declarationsOlocal :: (Bool)
            _declarationsOmethods_collect :: (FMap Name Names)
            _declarationsOmethods_dist :: (FMap Name Names)
            _declarationsOmoduleTypes :: (FMap ModuleName [Name])
            _declarationsOmoduleValues :: (FMap ModuleName [Name])
            _declarationsOnameType :: (NameType)
            _declarationsOtoplevel :: (Bool)
            ( _declarationsIconstructors_collect,_declarationsIknownKinds_collect,_declarationsIknownTypes_collect,_declarationsIknownValues_collect,_declarationsIlabels_collect,_declarationsImethods_collect,_declarationsImoduleTypes,_declarationsImoduleValues,_declarationsImodules,_declarationsIres,_declarationsIself) =
                (declarations_ (_declarationsOclassname)
                               (_declarationsOconstructors_collect)
                               (_declarationsOconstructors_dist)
                               (_declarationsOcurrentModule)
                               (_declarationsOimportedModule)
                               (_declarationsOinstancename)
                               (_declarationsOknownGenerics)
                               (_declarationsOknownKinds)
                               (_declarationsOknownKinds_collect)
                               (_declarationsOknownTypes)
                               (_declarationsOknownTypes_collect)
                               (_declarationsOknownValues)
                               (_declarationsOknownValues_collect)
                               (_declarationsOlabels_collect)
                               (_declarationsOlabels_dist)
                               (_declarationsOlocal)
                               (_declarationsOmethods_collect)
                               (_declarationsOmethods_dist)
                               (_declarationsOmoduleTypes)
                               (_declarationsOmoduleValues)
                               (_declarationsOnameType)
                               (_declarationsOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _declarationsImodules
            -- use rule
            (_lhsOres@_) =
                _declarationsIres
            -- self rule
            (_self@_) =
                MaybeDeclarations_Just _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _declarationsIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _declarationsIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _declarationsIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _declarationsIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _declarationsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _declarationsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _declarationsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _declarationsImoduleValues
            -- copy rule (down)
            (_declarationsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_declarationsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_declarationsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_declarationsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_declarationsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_declarationsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_declarationsOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_declarationsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_declarationsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_declarationsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_declarationsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_declarationsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_declarationsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_declarationsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_declarationsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_declarationsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_declarationsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_declarationsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_declarationsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_declarationsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_declarationsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_declarationsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_MaybeDeclarations_Nothing :: (T_MaybeDeclarations)
sem_MaybeDeclarations_Nothing  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (MaybeDeclarations)
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                MaybeDeclarations_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- MaybeExports ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      replace              : Exports
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for MaybeExports.Just:
      self

-}
{-
   local variables for MaybeExports.Nothing:
      replace
      relevantValues
      relevantTypes
      self

-}
-- semantic domain
type T_MaybeExports = (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Strings) ->
                      (Bool) ->
                      (Maybe Name) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (FMap ModuleName [Name]) ->
                      (FMap ModuleName [Name]) ->
                      (NameType) ->
                      (Bool) ->
                      ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),(Exports),([ResolveResult]),(MaybeExports))
-- cata
sem_MaybeExports :: (MaybeExports) ->
                    (T_MaybeExports)
sem_MaybeExports ((MaybeExports_Just (_exports))) =
    (sem_MaybeExports_Just ((sem_Exports (_exports))))
sem_MaybeExports ((MaybeExports_Nothing )) =
    (sem_MaybeExports_Nothing )
sem_MaybeExports_Just :: (T_Exports) ->
                         (T_MaybeExports)
sem_MaybeExports_Just (exports_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOreplace :: (Exports)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (MaybeExports)
            _exportsIconstructors_collect :: (FMap Name Names)
            _exportsIknownKinds_collect :: (FMap Name [Name])
            _exportsIknownTypes_collect :: (FMap Name [Name])
            _exportsIknownValues_collect :: (FMap Name [Name])
            _exportsIlabels_collect :: (FMap Name Names)
            _exportsImethods_collect :: (FMap Name Names)
            _exportsImoduleTypes :: (FMap ModuleName [Name])
            _exportsImoduleValues :: (FMap ModuleName [Name])
            _exportsImodules :: (Set.Set Strings)
            _exportsIreplace :: (Exports)
            _exportsIres :: ([ResolveResult])
            _exportsIself :: (Exports)
            _exportsOclassname :: (Maybe Name)
            _exportsOconstructors_collect :: (FMap Name Names)
            _exportsOconstructors_dist :: (FMap Name Names)
            _exportsOcurrentModule :: (Strings)
            _exportsOimportedModule :: (Bool)
            _exportsOinstancename :: (Maybe Name)
            _exportsOknownKinds :: (FMap Name [Name])
            _exportsOknownKinds_collect :: (FMap Name [Name])
            _exportsOknownTypes :: (FMap Name [Name])
            _exportsOknownTypes_collect :: (FMap Name [Name])
            _exportsOknownValues :: (FMap Name [Name])
            _exportsOknownValues_collect :: (FMap Name [Name])
            _exportsOlabels_collect :: (FMap Name Names)
            _exportsOlabels_dist :: (FMap Name Names)
            _exportsOlocal :: (Bool)
            _exportsOmethods_collect :: (FMap Name Names)
            _exportsOmethods_dist :: (FMap Name Names)
            _exportsOmoduleTypes :: (FMap ModuleName [Name])
            _exportsOmoduleValues :: (FMap ModuleName [Name])
            _exportsOnameType :: (NameType)
            _exportsOtoplevel :: (Bool)
            ( _exportsIconstructors_collect,_exportsIknownKinds_collect,_exportsIknownTypes_collect,_exportsIknownValues_collect,_exportsIlabels_collect,_exportsImethods_collect,_exportsImoduleTypes,_exportsImoduleValues,_exportsImodules,_exportsIreplace,_exportsIres,_exportsIself) =
                (exports_ (_exportsOclassname)
                          (_exportsOconstructors_collect)
                          (_exportsOconstructors_dist)
                          (_exportsOcurrentModule)
                          (_exportsOimportedModule)
                          (_exportsOinstancename)
                          (_exportsOknownKinds)
                          (_exportsOknownKinds_collect)
                          (_exportsOknownTypes)
                          (_exportsOknownTypes_collect)
                          (_exportsOknownValues)
                          (_exportsOknownValues_collect)
                          (_exportsOlabels_collect)
                          (_exportsOlabels_dist)
                          (_exportsOlocal)
                          (_exportsOmethods_collect)
                          (_exportsOmethods_dist)
                          (_exportsOmoduleTypes)
                          (_exportsOmoduleValues)
                          (_exportsOnameType)
                          (_exportsOtoplevel))
            -- "NameReplace.lag"(line 246, column 9)
            (_lhsOself@_) =
                MaybeExports_Just _exportsIreplace
            -- use rule
            (_lhsOmodules@_) =
                _exportsImodules
            -- use rule
            (_lhsOres@_) =
                _exportsIres
            -- self rule
            (_self@_) =
                MaybeExports_Just _exportsIself
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _exportsIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _exportsIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _exportsIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _exportsIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _exportsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _exportsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _exportsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _exportsImoduleValues
            -- copy rule (up)
            (_lhsOreplace@_) =
                _exportsIreplace
            -- copy rule (down)
            (_exportsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_exportsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_exportsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_exportsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_exportsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_exportsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_exportsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_exportsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_exportsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_exportsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_exportsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_exportsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_exportsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_exportsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_exportsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_exportsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_exportsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_exportsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_exportsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_exportsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_exportsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOreplace,_lhsOres,_lhsOself)
sem_MaybeExports_Nothing :: (T_MaybeExports)
sem_MaybeExports_Nothing  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOreplace :: (Exports)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (MaybeExports)
            -- "NameReplace.lag"(line 232, column 9)
            (_lhsOreplace@_) =
                _replace
            -- "NameReplace.lag"(line 227, column 9)
            (_replace@_) =
                prepareExportList
                  _relevantValues
                  _relevantTypes
                  _lhsIconstructors_dist
                  _lhsImethods_dist
            -- "NameReplace.lag"(line 223, column 9)
            (_relevantValues@_) =
                makeRelevant
                  _lhsIcurrentModule
                  _lhsIknownValues
            -- "NameReplace.lag"(line 220, column 9)
            (_relevantTypes@_) =
                makeRelevant
                  _lhsIcurrentModule
                  _lhsIknownTypes
            -- "NameReplace.lag"(line 243, column 9)
            (_lhsOself@_) =
                MaybeExports_Just _replace
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                MaybeExports_Nothing
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOreplace,_lhsOres,_lhsOself)
-- MaybeExpression ---------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for MaybeExpression.Just:
      self

-}
{-
   local variables for MaybeExpression.Nothing:
      self

-}
-- semantic domain
type T_MaybeExpression = (Maybe Name) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (Strings) ->
                         (Bool) ->
                         (Maybe Name) ->
                         (FMap Name [Name]) ->
                         (FMap Name [Name]) ->
                         (FMap Name [Name]) ->
                         (FMap Name [Name]) ->
                         (FMap Name [Name]) ->
                         (FMap Name [Name]) ->
                         (FMap Name [Name]) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (Bool) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (FMap ModuleName [Name]) ->
                         (FMap ModuleName [Name]) ->
                         (NameType) ->
                         (Bool) ->
                         ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(MaybeExpression))
-- cata
sem_MaybeExpression :: (MaybeExpression) ->
                       (T_MaybeExpression)
sem_MaybeExpression ((MaybeExpression_Just (_expression))) =
    (sem_MaybeExpression_Just ((sem_Expression (_expression))))
sem_MaybeExpression ((MaybeExpression_Nothing )) =
    (sem_MaybeExpression_Nothing )
sem_MaybeExpression_Just :: (T_Expression) ->
                            (T_MaybeExpression)
sem_MaybeExpression_Just (expression_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (MaybeExpression)
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIknownKinds_collect :: (FMap Name [Name])
            _expressionIknownTypes_collect :: (FMap Name [Name])
            _expressionIknownValues_collect :: (FMap Name [Name])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionImoduleTypes :: (FMap ModuleName [Name])
            _expressionImoduleValues :: (FMap ModuleName [Name])
            _expressionImodules :: (Set.Set Strings)
            _expressionIres :: ([ResolveResult])
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOknownGenerics :: (FMap Name [Name])
            _expressionOknownKinds :: (FMap Name [Name])
            _expressionOknownKinds_collect :: (FMap Name [Name])
            _expressionOknownTypes :: (FMap Name [Name])
            _expressionOknownTypes_collect :: (FMap Name [Name])
            _expressionOknownValues :: (FMap Name [Name])
            _expressionOknownValues_collect :: (FMap Name [Name])
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmoduleTypes :: (FMap ModuleName [Name])
            _expressionOmoduleValues :: (FMap ModuleName [Name])
            _expressionOnameType :: (NameType)
            _expressionOtoplevel :: (Bool)
            ( _expressionIconstructors_collect,_expressionIknownKinds_collect,_expressionIknownTypes_collect,_expressionIknownValues_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionImoduleTypes,_expressionImoduleValues,_expressionImodules,_expressionIres,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOknownGenerics)
                             (_expressionOknownKinds)
                             (_expressionOknownKinds_collect)
                             (_expressionOknownTypes)
                             (_expressionOknownTypes_collect)
                             (_expressionOknownValues)
                             (_expressionOknownValues_collect)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmoduleTypes)
                             (_expressionOmoduleValues)
                             (_expressionOnameType)
                             (_expressionOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _expressionImodules
            -- use rule
            (_lhsOres@_) =
                _expressionIres
            -- self rule
            (_self@_) =
                MaybeExpression_Just _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _expressionIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _expressionIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _expressionIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _expressionImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _expressionImoduleValues
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_expressionOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_expressionOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_expressionOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_expressionOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_expressionOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_expressionOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_expressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_expressionOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_expressionOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_MaybeExpression_Nothing :: (T_MaybeExpression)
sem_MaybeExpression_Nothing  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (MaybeExpression)
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                MaybeExpression_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- MaybeImportSpecification ------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      hiddenTypes_collect  : FMap Name [Name]
      hiddenValues_collect : FMap Name [Name]
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for MaybeImportSpecification.Just:
      self

-}
{-
   local variables for MaybeImportSpecification.Nothing:
      self

-}
-- semantic domain
type T_MaybeImportSpecification = (Maybe Name) ->
                                  (FMap Name Names) ->
                                  (FMap Name Names) ->
                                  (Strings) ->
                                  (Bool) ->
                                  (Maybe Name) ->
                                  (FMap Name [Name]) ->
                                  (FMap Name [Name]) ->
                                  (FMap Name [Name]) ->
                                  (FMap Name [Name]) ->
                                  (FMap Name [Name]) ->
                                  (FMap Name [Name]) ->
                                  (FMap Name Names) ->
                                  (FMap Name Names) ->
                                  (Bool) ->
                                  (FMap Name Names) ->
                                  (FMap Name Names) ->
                                  (FMap ModuleName [Name]) ->
                                  (FMap ModuleName [Name]) ->
                                  (NameType) ->
                                  (Bool) ->
                                  ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(MaybeImportSpecification))
-- cata
sem_MaybeImportSpecification :: (MaybeImportSpecification) ->
                                (T_MaybeImportSpecification)
sem_MaybeImportSpecification ((MaybeImportSpecification_Just (_importspecification))) =
    (sem_MaybeImportSpecification_Just ((sem_ImportSpecification (_importspecification))))
sem_MaybeImportSpecification ((MaybeImportSpecification_Nothing )) =
    (sem_MaybeImportSpecification_Nothing )
sem_MaybeImportSpecification_Just :: (T_ImportSpecification) ->
                                     (T_MaybeImportSpecification)
sem_MaybeImportSpecification_Just (importspecification_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOhiddenTypes_collect :: (FMap Name [Name])
            _lhsOhiddenValues_collect :: (FMap Name [Name])
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (MaybeImportSpecification)
            _importspecificationIconstructors_collect :: (FMap Name Names)
            _importspecificationIhiddenTypes_collect :: (FMap Name [Name])
            _importspecificationIhiddenValues_collect :: (FMap Name [Name])
            _importspecificationIknownKinds_collect :: (FMap Name [Name])
            _importspecificationIknownTypes_collect :: (FMap Name [Name])
            _importspecificationIknownValues_collect :: (FMap Name [Name])
            _importspecificationIlabels_collect :: (FMap Name Names)
            _importspecificationImethods_collect :: (FMap Name Names)
            _importspecificationImoduleTypes :: (FMap ModuleName [Name])
            _importspecificationImoduleValues :: (FMap ModuleName [Name])
            _importspecificationImodules :: (Set.Set Strings)
            _importspecificationIres :: ([ResolveResult])
            _importspecificationIself :: (ImportSpecification)
            _importspecificationOclassname :: (Maybe Name)
            _importspecificationOconstructors_collect :: (FMap Name Names)
            _importspecificationOconstructors_dist :: (FMap Name Names)
            _importspecificationOcurrentModule :: (Strings)
            _importspecificationOimportedModule :: (Bool)
            _importspecificationOinstancename :: (Maybe Name)
            _importspecificationOknownKinds :: (FMap Name [Name])
            _importspecificationOknownKinds_collect :: (FMap Name [Name])
            _importspecificationOknownTypes :: (FMap Name [Name])
            _importspecificationOknownTypes_collect :: (FMap Name [Name])
            _importspecificationOknownValues :: (FMap Name [Name])
            _importspecificationOknownValues_collect :: (FMap Name [Name])
            _importspecificationOlabels_collect :: (FMap Name Names)
            _importspecificationOlabels_dist :: (FMap Name Names)
            _importspecificationOlocal :: (Bool)
            _importspecificationOmethods_collect :: (FMap Name Names)
            _importspecificationOmethods_dist :: (FMap Name Names)
            _importspecificationOmoduleTypes :: (FMap ModuleName [Name])
            _importspecificationOmoduleValues :: (FMap ModuleName [Name])
            _importspecificationOnameType :: (NameType)
            _importspecificationOtoplevel :: (Bool)
            ( _importspecificationIconstructors_collect
             ,_importspecificationIhiddenTypes_collect
             ,_importspecificationIhiddenValues_collect
             ,_importspecificationIknownKinds_collect
             ,_importspecificationIknownTypes_collect
             ,_importspecificationIknownValues_collect
             ,_importspecificationIlabels_collect
             ,_importspecificationImethods_collect
             ,_importspecificationImoduleTypes
             ,_importspecificationImoduleValues
             ,_importspecificationImodules
             ,_importspecificationIres
             ,_importspecificationIself
             ) =
                (importspecification_ (_importspecificationOclassname)
                                      (_importspecificationOconstructors_collect)
                                      (_importspecificationOconstructors_dist)
                                      (_importspecificationOcurrentModule)
                                      (_importspecificationOimportedModule)
                                      (_importspecificationOinstancename)
                                      (_importspecificationOknownKinds)
                                      (_importspecificationOknownKinds_collect)
                                      (_importspecificationOknownTypes)
                                      (_importspecificationOknownTypes_collect)
                                      (_importspecificationOknownValues)
                                      (_importspecificationOknownValues_collect)
                                      (_importspecificationOlabels_collect)
                                      (_importspecificationOlabels_dist)
                                      (_importspecificationOlocal)
                                      (_importspecificationOmethods_collect)
                                      (_importspecificationOmethods_dist)
                                      (_importspecificationOmoduleTypes)
                                      (_importspecificationOmoduleValues)
                                      (_importspecificationOnameType)
                                      (_importspecificationOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _importspecificationImodules
            -- use rule
            (_lhsOres@_) =
                _importspecificationIres
            -- self rule
            (_self@_) =
                MaybeImportSpecification_Just _importspecificationIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _importspecificationIconstructors_collect
            -- copy rule (up)
            (_lhsOhiddenTypes_collect@_) =
                _importspecificationIhiddenTypes_collect
            -- copy rule (up)
            (_lhsOhiddenValues_collect@_) =
                _importspecificationIhiddenValues_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _importspecificationIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _importspecificationIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _importspecificationIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _importspecificationIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _importspecificationImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _importspecificationImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _importspecificationImoduleValues
            -- copy rule (down)
            (_importspecificationOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_importspecificationOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_importspecificationOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_importspecificationOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_importspecificationOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_importspecificationOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_importspecificationOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_importspecificationOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_importspecificationOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_importspecificationOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_importspecificationOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_importspecificationOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_importspecificationOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_importspecificationOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_importspecificationOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_importspecificationOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_importspecificationOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_importspecificationOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_importspecificationOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_importspecificationOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_importspecificationOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOhiddenTypes_collect,_lhsOhiddenValues_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_MaybeImportSpecification_Nothing :: (T_MaybeImportSpecification)
sem_MaybeImportSpecification_Nothing  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOhiddenTypes_collect :: (FMap Name [Name])
            _lhsOhiddenValues_collect :: (FMap Name [Name])
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (MaybeImportSpecification)
            -- "./Names.inc.lag"(line 938, column 9)
            (_lhsOhiddenTypes_collect@_) =
                emptyFM
            -- "./Names.inc.lag"(line 937, column 9)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- "./Names.inc.lag"(line 936, column 9)
            (_lhsOhiddenValues_collect@_) =
                emptyFM
            -- "./Names.inc.lag"(line 935, column 9)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                MaybeImportSpecification_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOhiddenTypes_collect,_lhsOhiddenValues_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- MaybeInt ----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for MaybeInt.Just:
      self

-}
{-
   local variables for MaybeInt.Nothing:
      self

-}
-- semantic domain
type T_MaybeInt = (Maybe Name) ->
                  (FMap Name Names) ->
                  (FMap Name Names) ->
                  (Strings) ->
                  (Bool) ->
                  (Maybe Name) ->
                  (FMap Name [Name]) ->
                  (FMap Name [Name]) ->
                  (FMap Name [Name]) ->
                  (FMap Name [Name]) ->
                  (FMap Name [Name]) ->
                  (FMap Name [Name]) ->
                  (FMap Name Names) ->
                  (FMap Name Names) ->
                  (Bool) ->
                  (FMap Name Names) ->
                  (FMap Name Names) ->
                  (FMap ModuleName [Name]) ->
                  (FMap ModuleName [Name]) ->
                  (NameType) ->
                  (Bool) ->
                  ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(MaybeInt))
-- cata
sem_MaybeInt :: (MaybeInt) ->
                (T_MaybeInt)
sem_MaybeInt ((MaybeInt_Just (_int))) =
    (sem_MaybeInt_Just (_int))
sem_MaybeInt ((MaybeInt_Nothing )) =
    (sem_MaybeInt_Nothing )
sem_MaybeInt_Just :: (Int) ->
                     (T_MaybeInt)
sem_MaybeInt_Just (int_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (MaybeInt)
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                MaybeInt_Just int_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_MaybeInt_Nothing :: (T_MaybeInt)
sem_MaybeInt_Nothing  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (MaybeInt)
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                MaybeInt_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- MaybeKind ---------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for MaybeKind.Just:
      self

-}
{-
   local variables for MaybeKind.Nothing:
      self

-}
-- semantic domain
type T_MaybeKind = (Maybe Name) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (Strings) ->
                   (Bool) ->
                   (Maybe Name) ->
                   (FMap Name [Name]) ->
                   (FMap Name [Name]) ->
                   (FMap Name [Name]) ->
                   (FMap Name [Name]) ->
                   (FMap Name [Name]) ->
                   (FMap Name [Name]) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (Bool) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (FMap ModuleName [Name]) ->
                   (FMap ModuleName [Name]) ->
                   (NameType) ->
                   (Bool) ->
                   ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(MaybeKind))
-- cata
sem_MaybeKind :: (MaybeKind) ->
                 (T_MaybeKind)
sem_MaybeKind ((MaybeKind_Just (_kind))) =
    (sem_MaybeKind_Just ((sem_Kind (_kind))))
sem_MaybeKind ((MaybeKind_Nothing )) =
    (sem_MaybeKind_Nothing )
sem_MaybeKind_Just :: (T_Kind) ->
                      (T_MaybeKind)
sem_MaybeKind_Just (kind_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (MaybeKind)
            _kindIconstructors_collect :: (FMap Name Names)
            _kindIknownKinds_collect :: (FMap Name [Name])
            _kindIknownTypes_collect :: (FMap Name [Name])
            _kindIknownValues_collect :: (FMap Name [Name])
            _kindIlabels_collect :: (FMap Name Names)
            _kindImethods_collect :: (FMap Name Names)
            _kindImoduleTypes :: (FMap ModuleName [Name])
            _kindImoduleValues :: (FMap ModuleName [Name])
            _kindImodules :: (Set.Set Strings)
            _kindIres :: ([ResolveResult])
            _kindIself :: (Kind)
            _kindOclassname :: (Maybe Name)
            _kindOconstructors_collect :: (FMap Name Names)
            _kindOconstructors_dist :: (FMap Name Names)
            _kindOcurrentModule :: (Strings)
            _kindOimportedModule :: (Bool)
            _kindOinstancename :: (Maybe Name)
            _kindOknownKinds :: (FMap Name [Name])
            _kindOknownKinds_collect :: (FMap Name [Name])
            _kindOknownTypes :: (FMap Name [Name])
            _kindOknownTypes_collect :: (FMap Name [Name])
            _kindOknownValues :: (FMap Name [Name])
            _kindOknownValues_collect :: (FMap Name [Name])
            _kindOlabels_collect :: (FMap Name Names)
            _kindOlabels_dist :: (FMap Name Names)
            _kindOlocal :: (Bool)
            _kindOmethods_collect :: (FMap Name Names)
            _kindOmethods_dist :: (FMap Name Names)
            _kindOmoduleTypes :: (FMap ModuleName [Name])
            _kindOmoduleValues :: (FMap ModuleName [Name])
            _kindOnameType :: (NameType)
            _kindOtoplevel :: (Bool)
            ( _kindIconstructors_collect,_kindIknownKinds_collect,_kindIknownTypes_collect,_kindIknownValues_collect,_kindIlabels_collect,_kindImethods_collect,_kindImoduleTypes,_kindImoduleValues,_kindImodules,_kindIres,_kindIself) =
                (kind_ (_kindOclassname)
                       (_kindOconstructors_collect)
                       (_kindOconstructors_dist)
                       (_kindOcurrentModule)
                       (_kindOimportedModule)
                       (_kindOinstancename)
                       (_kindOknownKinds)
                       (_kindOknownKinds_collect)
                       (_kindOknownTypes)
                       (_kindOknownTypes_collect)
                       (_kindOknownValues)
                       (_kindOknownValues_collect)
                       (_kindOlabels_collect)
                       (_kindOlabels_dist)
                       (_kindOlocal)
                       (_kindOmethods_collect)
                       (_kindOmethods_dist)
                       (_kindOmoduleTypes)
                       (_kindOmoduleValues)
                       (_kindOnameType)
                       (_kindOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _kindImodules
            -- use rule
            (_lhsOres@_) =
                _kindIres
            -- self rule
            (_self@_) =
                MaybeKind_Just _kindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _kindIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _kindIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _kindIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _kindIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _kindIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _kindImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _kindImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _kindImoduleValues
            -- copy rule (down)
            (_kindOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_kindOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_kindOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_kindOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_kindOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_kindOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_kindOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_kindOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_kindOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_kindOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_kindOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_kindOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_kindOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_kindOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_kindOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_kindOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_kindOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_kindOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_kindOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_kindOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_kindOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_MaybeKind_Nothing :: (T_MaybeKind)
sem_MaybeKind_Nothing  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (MaybeKind)
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                MaybeKind_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- MaybeModuleName ---------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for MaybeModuleName.Just:
      self

-}
{-
   local variables for MaybeModuleName.Nothing:
      self

-}
-- semantic domain
type T_MaybeModuleName = (Maybe Name) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (Strings) ->
                         (Bool) ->
                         (Maybe Name) ->
                         (FMap Name [Name]) ->
                         (FMap Name [Name]) ->
                         (FMap Name [Name]) ->
                         (FMap Name [Name]) ->
                         (FMap Name [Name]) ->
                         (FMap Name [Name]) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (Bool) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (FMap ModuleName [Name]) ->
                         (FMap ModuleName [Name]) ->
                         (NameType) ->
                         (Bool) ->
                         ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(MaybeModuleName))
-- cata
sem_MaybeModuleName :: (MaybeModuleName) ->
                       (T_MaybeModuleName)
sem_MaybeModuleName ((MaybeModuleName_Just (_modulename))) =
    (sem_MaybeModuleName_Just ((sem_ModuleName (_modulename))))
sem_MaybeModuleName ((MaybeModuleName_Nothing )) =
    (sem_MaybeModuleName_Nothing )
sem_MaybeModuleName_Just :: (T_ModuleName) ->
                            (T_MaybeModuleName)
sem_MaybeModuleName_Just (modulename_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (MaybeModuleName)
            _modulenameIconstructors_collect :: (FMap Name Names)
            _modulenameIknownKinds_collect :: (FMap Name [Name])
            _modulenameIknownTypes_collect :: (FMap Name [Name])
            _modulenameIknownValues_collect :: (FMap Name [Name])
            _modulenameIlabels_collect :: (FMap Name Names)
            _modulenameImethods_collect :: (FMap Name Names)
            _modulenameImoduleTypes :: (FMap ModuleName [Name])
            _modulenameImoduleValues :: (FMap ModuleName [Name])
            _modulenameImodules :: (Set.Set Strings)
            _modulenameIres :: ([ResolveResult])
            _modulenameIself :: (ModuleName)
            _modulenameOclassname :: (Maybe Name)
            _modulenameOconstructors_collect :: (FMap Name Names)
            _modulenameOconstructors_dist :: (FMap Name Names)
            _modulenameOcurrentModule :: (Strings)
            _modulenameOimportedModule :: (Bool)
            _modulenameOinstancename :: (Maybe Name)
            _modulenameOknownKinds :: (FMap Name [Name])
            _modulenameOknownKinds_collect :: (FMap Name [Name])
            _modulenameOknownTypes :: (FMap Name [Name])
            _modulenameOknownTypes_collect :: (FMap Name [Name])
            _modulenameOknownValues :: (FMap Name [Name])
            _modulenameOknownValues_collect :: (FMap Name [Name])
            _modulenameOlabels_collect :: (FMap Name Names)
            _modulenameOlabels_dist :: (FMap Name Names)
            _modulenameOlocal :: (Bool)
            _modulenameOmethods_collect :: (FMap Name Names)
            _modulenameOmethods_dist :: (FMap Name Names)
            _modulenameOmoduleTypes :: (FMap ModuleName [Name])
            _modulenameOmoduleValues :: (FMap ModuleName [Name])
            _modulenameOnameType :: (NameType)
            _modulenameOtoplevel :: (Bool)
            ( _modulenameIconstructors_collect,_modulenameIknownKinds_collect,_modulenameIknownTypes_collect,_modulenameIknownValues_collect,_modulenameIlabels_collect,_modulenameImethods_collect,_modulenameImoduleTypes,_modulenameImoduleValues,_modulenameImodules,_modulenameIres,_modulenameIself) =
                (modulename_ (_modulenameOclassname)
                             (_modulenameOconstructors_collect)
                             (_modulenameOconstructors_dist)
                             (_modulenameOcurrentModule)
                             (_modulenameOimportedModule)
                             (_modulenameOinstancename)
                             (_modulenameOknownKinds)
                             (_modulenameOknownKinds_collect)
                             (_modulenameOknownTypes)
                             (_modulenameOknownTypes_collect)
                             (_modulenameOknownValues)
                             (_modulenameOknownValues_collect)
                             (_modulenameOlabels_collect)
                             (_modulenameOlabels_dist)
                             (_modulenameOlocal)
                             (_modulenameOmethods_collect)
                             (_modulenameOmethods_dist)
                             (_modulenameOmoduleTypes)
                             (_modulenameOmoduleValues)
                             (_modulenameOnameType)
                             (_modulenameOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _modulenameImodules
            -- use rule
            (_lhsOres@_) =
                _modulenameIres
            -- self rule
            (_self@_) =
                MaybeModuleName_Just _modulenameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _modulenameIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _modulenameIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _modulenameIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _modulenameIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _modulenameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _modulenameImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _modulenameImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _modulenameImoduleValues
            -- copy rule (down)
            (_modulenameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_modulenameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_modulenameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_modulenameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_modulenameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_modulenameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_modulenameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_modulenameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_modulenameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_modulenameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_modulenameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_modulenameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_modulenameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_modulenameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_modulenameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_modulenameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_modulenameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_modulenameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_modulenameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_modulenameOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_modulenameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_MaybeModuleName_Nothing :: (T_MaybeModuleName)
sem_MaybeModuleName_Nothing  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (MaybeModuleName)
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                MaybeModuleName_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- MaybeName ---------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      originalSelf         : MaybeName
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for MaybeName.Just:
      originalSelf
      self

-}
{-
   local variables for MaybeName.Nothing:
      originalSelf
      self

-}
-- semantic domain
type T_MaybeName = (Maybe Name) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (Strings) ->
                   (Bool) ->
                   (Maybe Name) ->
                   (FMap Name [Name]) ->
                   (FMap Name [Name]) ->
                   (FMap Name [Name]) ->
                   (FMap Name [Name]) ->
                   (FMap Name [Name]) ->
                   (FMap Name [Name]) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (Bool) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (FMap ModuleName [Name]) ->
                   (FMap ModuleName [Name]) ->
                   (NameType) ->
                   (Bool) ->
                   ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),(MaybeName),([ResolveResult]),(MaybeName))
-- cata
sem_MaybeName :: (MaybeName) ->
                 (T_MaybeName)
sem_MaybeName ((MaybeName_Just (_name))) =
    (sem_MaybeName_Just ((sem_Name (_name))))
sem_MaybeName ((MaybeName_Nothing )) =
    (sem_MaybeName_Nothing )
sem_MaybeName_Just :: (T_Name) ->
                      (T_MaybeName)
sem_MaybeName_Just (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOoriginalSelf :: (MaybeName)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (MaybeName)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            -- "./Names.inc.lag"(line 64, column 9)
            (_lhsOoriginalSelf@_) =
                _originalSelf
            -- "./Names.inc.lag"(line 63, column 9)
            (_originalSelf@_) =
                MaybeName_Just _nameIoriginalSelf
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres
            -- self rule
            (_self@_) =
                MaybeName_Just _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOoriginalSelf,_lhsOres,_lhsOself)
sem_MaybeName_Nothing :: (T_MaybeName)
sem_MaybeName_Nothing  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOoriginalSelf :: (MaybeName)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (MaybeName)
            -- "./Names.inc.lag"(line 67, column 9)
            (_lhsOoriginalSelf@_) =
                _originalSelf
            -- "./Names.inc.lag"(line 66, column 9)
            (_originalSelf@_) =
                MaybeName_Nothing
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                MaybeName_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOoriginalSelf,_lhsOres,_lhsOself)
-- MaybeNames --------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for MaybeNames.Just:
      self

-}
{-
   local variables for MaybeNames.Nothing:
      self

-}
-- semantic domain
type T_MaybeNames = (Maybe Name) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Strings) ->
                    (Bool) ->
                    (Maybe Name) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Bool) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (FMap ModuleName [Name]) ->
                    (FMap ModuleName [Name]) ->
                    (NameType) ->
                    (Bool) ->
                    ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(MaybeNames))
-- cata
sem_MaybeNames :: (MaybeNames) ->
                  (T_MaybeNames)
sem_MaybeNames ((MaybeNames_Just (_names))) =
    (sem_MaybeNames_Just ((sem_Names (_names))))
sem_MaybeNames ((MaybeNames_Nothing )) =
    (sem_MaybeNames_Nothing )
sem_MaybeNames_Just :: (T_Names) ->
                       (T_MaybeNames)
sem_MaybeNames_Just (names_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (MaybeNames)
            _namesIconstructors_collect :: (FMap Name Names)
            _namesIknownKinds_collect :: (FMap Name [Name])
            _namesIknownTypes_collect :: (FMap Name [Name])
            _namesIknownValues_collect :: (FMap Name [Name])
            _namesIlabels_collect :: (FMap Name Names)
            _namesImethods_collect :: (FMap Name Names)
            _namesImoduleTypes :: (FMap ModuleName [Name])
            _namesImoduleValues :: (FMap ModuleName [Name])
            _namesImodules :: (Set.Set Strings)
            _namesIoriginalSelf :: (Names)
            _namesIres :: ([ResolveResult])
            _namesIself :: (Names)
            _namesOclassname :: (Maybe Name)
            _namesOconstructors_collect :: (FMap Name Names)
            _namesOconstructors_dist :: (FMap Name Names)
            _namesOcurrentModule :: (Strings)
            _namesOimportedModule :: (Bool)
            _namesOinstancename :: (Maybe Name)
            _namesOknownKinds :: (FMap Name [Name])
            _namesOknownKinds_collect :: (FMap Name [Name])
            _namesOknownTypes :: (FMap Name [Name])
            _namesOknownTypes_collect :: (FMap Name [Name])
            _namesOknownValues :: (FMap Name [Name])
            _namesOknownValues_collect :: (FMap Name [Name])
            _namesOlabels_collect :: (FMap Name Names)
            _namesOlabels_dist :: (FMap Name Names)
            _namesOlocal :: (Bool)
            _namesOmethods_collect :: (FMap Name Names)
            _namesOmethods_dist :: (FMap Name Names)
            _namesOmoduleTypes :: (FMap ModuleName [Name])
            _namesOmoduleValues :: (FMap ModuleName [Name])
            _namesOnameType :: (NameType)
            _namesOtoplevel :: (Bool)
            ( _namesIconstructors_collect,_namesIknownKinds_collect,_namesIknownTypes_collect,_namesIknownValues_collect,_namesIlabels_collect,_namesImethods_collect,_namesImoduleTypes,_namesImoduleValues,_namesImodules,_namesIoriginalSelf,_namesIres,_namesIself) =
                (names_ (_namesOclassname)
                        (_namesOconstructors_collect)
                        (_namesOconstructors_dist)
                        (_namesOcurrentModule)
                        (_namesOimportedModule)
                        (_namesOinstancename)
                        (_namesOknownKinds)
                        (_namesOknownKinds_collect)
                        (_namesOknownTypes)
                        (_namesOknownTypes_collect)
                        (_namesOknownValues)
                        (_namesOknownValues_collect)
                        (_namesOlabels_collect)
                        (_namesOlabels_dist)
                        (_namesOlocal)
                        (_namesOmethods_collect)
                        (_namesOmethods_dist)
                        (_namesOmoduleTypes)
                        (_namesOmoduleValues)
                        (_namesOnameType)
                        (_namesOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _namesImodules
            -- use rule
            (_lhsOres@_) =
                _namesIres
            -- self rule
            (_self@_) =
                MaybeNames_Just _namesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _namesIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _namesIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _namesIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _namesIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _namesIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _namesImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _namesImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _namesImoduleValues
            -- copy rule (down)
            (_namesOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_namesOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_namesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_namesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_namesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_namesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_namesOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_namesOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_namesOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_namesOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_namesOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_namesOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_namesOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_namesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_namesOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_namesOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_namesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_namesOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_namesOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_namesOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_namesOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_MaybeNames_Nothing :: (T_MaybeNames)
sem_MaybeNames_Nothing  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (MaybeNames)
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                MaybeNames_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- MaybeReassignments ------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for MaybeReassignments.Just:
      self

-}
{-
   local variables for MaybeReassignments.Nothing:
      self

-}
-- semantic domain
type T_MaybeReassignments = (Maybe Name) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Strings) ->
                            (Bool) ->
                            (Maybe Name) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Bool) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (FMap ModuleName [Name]) ->
                            (FMap ModuleName [Name]) ->
                            (NameType) ->
                            (Bool) ->
                            ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(MaybeReassignments))
-- cata
sem_MaybeReassignments :: (MaybeReassignments) ->
                          (T_MaybeReassignments)
sem_MaybeReassignments ((MaybeReassignments_Just (_reassignments))) =
    (sem_MaybeReassignments_Just ((sem_Reassignments (_reassignments))))
sem_MaybeReassignments ((MaybeReassignments_Nothing )) =
    (sem_MaybeReassignments_Nothing )
sem_MaybeReassignments_Just :: (T_Reassignments) ->
                               (T_MaybeReassignments)
sem_MaybeReassignments_Just (reassignments_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (MaybeReassignments)
            _reassignmentsIconstructors_collect :: (FMap Name Names)
            _reassignmentsIknownKinds_collect :: (FMap Name [Name])
            _reassignmentsIknownTypes_collect :: (FMap Name [Name])
            _reassignmentsIknownValues_collect :: (FMap Name [Name])
            _reassignmentsIlabels_collect :: (FMap Name Names)
            _reassignmentsImethods_collect :: (FMap Name Names)
            _reassignmentsImoduleTypes :: (FMap ModuleName [Name])
            _reassignmentsImoduleValues :: (FMap ModuleName [Name])
            _reassignmentsImodules :: (Set.Set Strings)
            _reassignmentsIres :: ([ResolveResult])
            _reassignmentsIself :: (Reassignments)
            _reassignmentsOclassname :: (Maybe Name)
            _reassignmentsOconstructors_collect :: (FMap Name Names)
            _reassignmentsOconstructors_dist :: (FMap Name Names)
            _reassignmentsOcurrentModule :: (Strings)
            _reassignmentsOimportedModule :: (Bool)
            _reassignmentsOinstancename :: (Maybe Name)
            _reassignmentsOknownKinds :: (FMap Name [Name])
            _reassignmentsOknownKinds_collect :: (FMap Name [Name])
            _reassignmentsOknownTypes :: (FMap Name [Name])
            _reassignmentsOknownTypes_collect :: (FMap Name [Name])
            _reassignmentsOknownValues :: (FMap Name [Name])
            _reassignmentsOknownValues_collect :: (FMap Name [Name])
            _reassignmentsOlabels_collect :: (FMap Name Names)
            _reassignmentsOlabels_dist :: (FMap Name Names)
            _reassignmentsOlocal :: (Bool)
            _reassignmentsOmethods_collect :: (FMap Name Names)
            _reassignmentsOmethods_dist :: (FMap Name Names)
            _reassignmentsOmoduleTypes :: (FMap ModuleName [Name])
            _reassignmentsOmoduleValues :: (FMap ModuleName [Name])
            _reassignmentsOnameType :: (NameType)
            _reassignmentsOtoplevel :: (Bool)
            ( _reassignmentsIconstructors_collect,_reassignmentsIknownKinds_collect,_reassignmentsIknownTypes_collect,_reassignmentsIknownValues_collect,_reassignmentsIlabels_collect,_reassignmentsImethods_collect,_reassignmentsImoduleTypes,_reassignmentsImoduleValues,_reassignmentsImodules,_reassignmentsIres,_reassignmentsIself) =
                (reassignments_ (_reassignmentsOclassname)
                                (_reassignmentsOconstructors_collect)
                                (_reassignmentsOconstructors_dist)
                                (_reassignmentsOcurrentModule)
                                (_reassignmentsOimportedModule)
                                (_reassignmentsOinstancename)
                                (_reassignmentsOknownKinds)
                                (_reassignmentsOknownKinds_collect)
                                (_reassignmentsOknownTypes)
                                (_reassignmentsOknownTypes_collect)
                                (_reassignmentsOknownValues)
                                (_reassignmentsOknownValues_collect)
                                (_reassignmentsOlabels_collect)
                                (_reassignmentsOlabels_dist)
                                (_reassignmentsOlocal)
                                (_reassignmentsOmethods_collect)
                                (_reassignmentsOmethods_dist)
                                (_reassignmentsOmoduleTypes)
                                (_reassignmentsOmoduleValues)
                                (_reassignmentsOnameType)
                                (_reassignmentsOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _reassignmentsImodules
            -- use rule
            (_lhsOres@_) =
                _reassignmentsIres
            -- self rule
            (_self@_) =
                MaybeReassignments_Just _reassignmentsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _reassignmentsIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _reassignmentsIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _reassignmentsIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _reassignmentsIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _reassignmentsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _reassignmentsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _reassignmentsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _reassignmentsImoduleValues
            -- copy rule (down)
            (_reassignmentsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_reassignmentsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_reassignmentsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_reassignmentsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_reassignmentsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_reassignmentsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_reassignmentsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_reassignmentsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_reassignmentsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_reassignmentsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_reassignmentsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_reassignmentsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_reassignmentsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_reassignmentsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_reassignmentsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_reassignmentsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_reassignmentsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_reassignmentsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_reassignmentsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_reassignmentsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_reassignmentsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_MaybeReassignments_Nothing :: (T_MaybeReassignments)
sem_MaybeReassignments_Nothing  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (MaybeReassignments)
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                MaybeReassignments_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- Module ------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      compiledModule       : Strings
      exports              : Exports
      hiddenEntities       : [(Set Name,Set Name)]
      importedEntities     : [(Set Name,Set Name)]
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for Module.Module:
      local
      compiledModule
      currentModule
      moduleName
      moduleName_
      self

-}
-- semantic domain
type T_Module = (Maybe Name) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (Bool) ->
                (Maybe Name) ->
                (FMap Name [Name]) ->
                (FMap Name [Name]) ->
                (FMap Name [Name]) ->
                (FMap Name [Name]) ->
                (FMap Name [Name]) ->
                (FMap Name [Name]) ->
                (FMap Name [Name]) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (FMap ModuleName [Name]) ->
                (FMap ModuleName [Name]) ->
                (NameType) ->
                (Bool) ->
                ( (Strings),(FMap Name Names),(Exports),([(Set Name,Set Name)]),([(Set Name,Set Name)]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(Module))
-- cata
sem_Module :: (Module) ->
              (T_Module)
sem_Module ((Module_Module (_range) (_name) (_exports) (_body))) =
    (sem_Module_Module ((sem_Range (_range))) ((sem_MaybeModuleName (_name))) ((sem_MaybeExports (_exports))) ((sem_Body (_body))))
sem_Module_Module :: (T_Range) ->
                     (T_MaybeModuleName) ->
                     (T_MaybeExports) ->
                     (T_Body) ->
                     (T_Module)
sem_Module_Module (range_) (name_) (exports_) (body_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOcompiledModule :: (Strings)
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOexports :: (Exports)
            _lhsOhiddenEntities :: ([(Set Name,Set Name)])
            _lhsOimportedEntities :: ([(Set Name,Set Name)])
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Module)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIres :: ([ResolveResult])
            _nameIself :: (MaybeModuleName)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _exportsIconstructors_collect :: (FMap Name Names)
            _exportsIknownKinds_collect :: (FMap Name [Name])
            _exportsIknownTypes_collect :: (FMap Name [Name])
            _exportsIknownValues_collect :: (FMap Name [Name])
            _exportsIlabels_collect :: (FMap Name Names)
            _exportsImethods_collect :: (FMap Name Names)
            _exportsImoduleTypes :: (FMap ModuleName [Name])
            _exportsImoduleValues :: (FMap ModuleName [Name])
            _exportsImodules :: (Set.Set Strings)
            _exportsIreplace :: (Exports)
            _exportsIres :: ([ResolveResult])
            _exportsIself :: (MaybeExports)
            _exportsOclassname :: (Maybe Name)
            _exportsOconstructors_collect :: (FMap Name Names)
            _exportsOconstructors_dist :: (FMap Name Names)
            _exportsOcurrentModule :: (Strings)
            _exportsOimportedModule :: (Bool)
            _exportsOinstancename :: (Maybe Name)
            _exportsOknownKinds :: (FMap Name [Name])
            _exportsOknownKinds_collect :: (FMap Name [Name])
            _exportsOknownTypes :: (FMap Name [Name])
            _exportsOknownTypes_collect :: (FMap Name [Name])
            _exportsOknownValues :: (FMap Name [Name])
            _exportsOknownValues_collect :: (FMap Name [Name])
            _exportsOlabels_collect :: (FMap Name Names)
            _exportsOlabels_dist :: (FMap Name Names)
            _exportsOlocal :: (Bool)
            _exportsOmethods_collect :: (FMap Name Names)
            _exportsOmethods_dist :: (FMap Name Names)
            _exportsOmoduleTypes :: (FMap ModuleName [Name])
            _exportsOmoduleValues :: (FMap ModuleName [Name])
            _exportsOnameType :: (NameType)
            _exportsOtoplevel :: (Bool)
            _bodyIconstructors_collect :: (FMap Name Names)
            _bodyIhiddenEntities :: ([(Set Name,Set Name)])
            _bodyIimportedEntities :: ([(Set Name,Set Name)])
            _bodyIknownKinds_collect :: (FMap Name [Name])
            _bodyIknownTypes_collect :: (FMap Name [Name])
            _bodyIknownValues_collect :: (FMap Name [Name])
            _bodyIlabels_collect :: (FMap Name Names)
            _bodyImethods_collect :: (FMap Name Names)
            _bodyImoduleTypes :: (FMap ModuleName [Name])
            _bodyImoduleValues :: (FMap ModuleName [Name])
            _bodyImodules :: (Set.Set Strings)
            _bodyIres :: ([ResolveResult])
            _bodyIself :: (Body)
            _bodyOclassname :: (Maybe Name)
            _bodyOconstructors_collect :: (FMap Name Names)
            _bodyOconstructors_dist :: (FMap Name Names)
            _bodyOcurrentModule :: (Strings)
            _bodyOimportedModule :: (Bool)
            _bodyOinstancename :: (Maybe Name)
            _bodyOknownGenerics :: (FMap Name [Name])
            _bodyOknownKinds :: (FMap Name [Name])
            _bodyOknownKinds_collect :: (FMap Name [Name])
            _bodyOknownTypes :: (FMap Name [Name])
            _bodyOknownTypes_collect :: (FMap Name [Name])
            _bodyOknownValues :: (FMap Name [Name])
            _bodyOknownValues_collect :: (FMap Name [Name])
            _bodyOlabels_collect :: (FMap Name Names)
            _bodyOlabels_dist :: (FMap Name Names)
            _bodyOlocal :: (Bool)
            _bodyOmethods_collect :: (FMap Name Names)
            _bodyOmethods_dist :: (FMap Name Names)
            _bodyOmoduleTypes :: (FMap ModuleName [Name])
            _bodyOmoduleValues :: (FMap ModuleName [Name])
            _bodyOnameType :: (NameType)
            _bodyOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _exportsIconstructors_collect,_exportsIknownKinds_collect,_exportsIknownTypes_collect,_exportsIknownValues_collect,_exportsIlabels_collect,_exportsImethods_collect,_exportsImoduleTypes,_exportsImoduleValues,_exportsImodules,_exportsIreplace,_exportsIres,_exportsIself) =
                (exports_ (_exportsOclassname)
                          (_exportsOconstructors_collect)
                          (_exportsOconstructors_dist)
                          (_exportsOcurrentModule)
                          (_exportsOimportedModule)
                          (_exportsOinstancename)
                          (_exportsOknownKinds)
                          (_exportsOknownKinds_collect)
                          (_exportsOknownTypes)
                          (_exportsOknownTypes_collect)
                          (_exportsOknownValues)
                          (_exportsOknownValues_collect)
                          (_exportsOlabels_collect)
                          (_exportsOlabels_dist)
                          (_exportsOlocal)
                          (_exportsOmethods_collect)
                          (_exportsOmethods_dist)
                          (_exportsOmoduleTypes)
                          (_exportsOmoduleValues)
                          (_exportsOnameType)
                          (_exportsOtoplevel))
            ( _bodyIconstructors_collect,_bodyIhiddenEntities,_bodyIimportedEntities,_bodyIknownKinds_collect,_bodyIknownTypes_collect,_bodyIknownValues_collect,_bodyIlabels_collect,_bodyImethods_collect,_bodyImoduleTypes,_bodyImoduleValues,_bodyImodules,_bodyIres,_bodyIself) =
                (body_ (_bodyOclassname)
                       (_bodyOconstructors_collect)
                       (_bodyOconstructors_dist)
                       (_bodyOcurrentModule)
                       (_bodyOimportedModule)
                       (_bodyOinstancename)
                       (_bodyOknownGenerics)
                       (_bodyOknownKinds)
                       (_bodyOknownKinds_collect)
                       (_bodyOknownTypes)
                       (_bodyOknownTypes_collect)
                       (_bodyOknownValues)
                       (_bodyOknownValues_collect)
                       (_bodyOlabels_collect)
                       (_bodyOlabels_dist)
                       (_bodyOlocal)
                       (_bodyOmethods_collect)
                       (_bodyOmethods_dist)
                       (_bodyOmoduleTypes)
                       (_bodyOmoduleValues)
                       (_bodyOnameType)
                       (_bodyOtoplevel))
            -- "NameReplace.lag"(line 250, column 9)
            (_lhsOself@_) =
                Module_Module
                  _rangeIself
                  (MaybeModuleName_Just _moduleName_)
                  _exportsIself
                  _bodyIself
            -- "NameReplace.lag"(line 273, column 9)
            (_lhsOexports@_) =
                _exportsIreplace
            -- "./ModuleInformation.inc.lag"(line 113, column 8)
            (_local@_) =
                True
            -- "./ModuleInformation.inc.lag"(line 111, column 8)
            (_lhsOcompiledModule@_) =
                _compiledModule
            -- "./ModuleInformation.inc.lag"(line 110, column 8)
            (_compiledModule@_) =
                _moduleName
            -- "./ModuleInformation.inc.lag"(line 109, column 8)
            (_currentModule@_) =
                _moduleName
            -- "./ModuleInformation.inc.lag"(line 107, column 8)
            (_moduleName@_) =
                getModuleName _moduleName_
            -- "./ModuleInformation.inc.lag"(line 101, column 8)
            (_moduleName_@_) =
                case _nameIself of
                  MaybeModuleName_Nothing -> ModuleName_ModuleName
                                               unknownRange
                                               ["Main"]
                  MaybeModuleName_Just x  -> x
            -- use rule
            (_lhsOhiddenEntities@_) =
                _bodyIhiddenEntities
            -- use rule
            (_lhsOimportedEntities@_) =
                _bodyIimportedEntities
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _exportsImodules `Set.union` _bodyImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _exportsIres ++ _bodyIres
            -- self rule
            (_self@_) =
                Module_Module _rangeIself _nameIself _exportsIself _bodyIself
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _bodyIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _bodyIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _bodyIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _bodyIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _bodyIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _bodyImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _bodyImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _bodyImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_rangeOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_rangeOlocal@_) =
                _local
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_nameOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_nameOlocal@_) =
                _local
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_exportsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_exportsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_exportsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_exportsOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_exportsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_exportsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_exportsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_exportsOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_exportsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_exportsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (down)
            (_exportsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_exportsOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_exportsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_exportsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_exportsOlocal@_) =
                _local
            -- copy rule (chain)
            (_exportsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_exportsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_exportsOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_exportsOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_exportsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_exportsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_bodyOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_bodyOconstructors_collect@_) =
                _exportsIconstructors_collect
            -- copy rule (down)
            (_bodyOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_bodyOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_bodyOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_bodyOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_bodyOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_bodyOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_bodyOknownKinds_collect@_) =
                _exportsIknownKinds_collect
            -- copy rule (down)
            (_bodyOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_bodyOknownTypes_collect@_) =
                _exportsIknownTypes_collect
            -- copy rule (down)
            (_bodyOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_bodyOknownValues_collect@_) =
                _exportsIknownValues_collect
            -- copy rule (chain)
            (_bodyOlabels_collect@_) =
                _exportsIlabels_collect
            -- copy rule (down)
            (_bodyOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_bodyOlocal@_) =
                _local
            -- copy rule (chain)
            (_bodyOmethods_collect@_) =
                _exportsImethods_collect
            -- copy rule (down)
            (_bodyOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_bodyOmoduleTypes@_) =
                _exportsImoduleTypes
            -- copy rule (chain)
            (_bodyOmoduleValues@_) =
                _exportsImoduleValues
            -- copy rule (down)
            (_bodyOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_bodyOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOcompiledModule,_lhsOconstructors_collect,_lhsOexports,_lhsOhiddenEntities,_lhsOimportedEntities,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- ModuleInterface ---------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for ModuleInterface.ModuleInterface:
      local
      toplevel
      importedModule
      currentModule
      self

-}
{-
   local variables for ModuleInterface.Unavailable:
      local
      toplevel
      importedModule
      currentModule
      self

-}
-- semantic domain
type T_ModuleInterface = (Maybe Name) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (Bool) ->
                         (Maybe Name) ->
                         (FMap Name [Name]) ->
                         (FMap Name [Name]) ->
                         (FMap Name [Name]) ->
                         (FMap Name [Name]) ->
                         (FMap Name [Name]) ->
                         (FMap Name [Name]) ->
                         (FMap Name [Name]) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (FMap ModuleName [Name]) ->
                         (FMap ModuleName [Name]) ->
                         (NameType) ->
                         (Bool) ->
                         ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(ModuleInterface))
-- cata
sem_ModuleInterface :: (ModuleInterface) ->
                       (T_ModuleInterface)
sem_ModuleInterface ((ModuleInterface_ModuleInterface (_range) (_name) (_exportedTypes) (_exportedValues) (_declarations))) =
    (sem_ModuleInterface_ModuleInterface ((sem_Range (_range))) ((sem_ModuleName (_name))) ((sem_Names (_exportedTypes))) ((sem_Names (_exportedValues))) ((sem_InterfaceDeclarations (_declarations))))
sem_ModuleInterface ((ModuleInterface_Unavailable (_name))) =
    (sem_ModuleInterface_Unavailable ((sem_ModuleName (_name))))
sem_ModuleInterface_ModuleInterface :: (T_Range) ->
                                       (T_ModuleName) ->
                                       (T_Names) ->
                                       (T_Names) ->
                                       (T_InterfaceDeclarations) ->
                                       (T_ModuleInterface)
sem_ModuleInterface_ModuleInterface (range_) (name_) (exportedTypes_) (exportedValues_) (declarations_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (ModuleInterface)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIres :: ([ResolveResult])
            _nameIself :: (ModuleName)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _exportedTypesIconstructors_collect :: (FMap Name Names)
            _exportedTypesIknownKinds_collect :: (FMap Name [Name])
            _exportedTypesIknownTypes_collect :: (FMap Name [Name])
            _exportedTypesIknownValues_collect :: (FMap Name [Name])
            _exportedTypesIlabels_collect :: (FMap Name Names)
            _exportedTypesImethods_collect :: (FMap Name Names)
            _exportedTypesImoduleTypes :: (FMap ModuleName [Name])
            _exportedTypesImoduleValues :: (FMap ModuleName [Name])
            _exportedTypesImodules :: (Set.Set Strings)
            _exportedTypesIoriginalSelf :: (Names)
            _exportedTypesIres :: ([ResolveResult])
            _exportedTypesIself :: (Names)
            _exportedTypesOclassname :: (Maybe Name)
            _exportedTypesOconstructors_collect :: (FMap Name Names)
            _exportedTypesOconstructors_dist :: (FMap Name Names)
            _exportedTypesOcurrentModule :: (Strings)
            _exportedTypesOimportedModule :: (Bool)
            _exportedTypesOinstancename :: (Maybe Name)
            _exportedTypesOknownKinds :: (FMap Name [Name])
            _exportedTypesOknownKinds_collect :: (FMap Name [Name])
            _exportedTypesOknownTypes :: (FMap Name [Name])
            _exportedTypesOknownTypes_collect :: (FMap Name [Name])
            _exportedTypesOknownValues :: (FMap Name [Name])
            _exportedTypesOknownValues_collect :: (FMap Name [Name])
            _exportedTypesOlabels_collect :: (FMap Name Names)
            _exportedTypesOlabels_dist :: (FMap Name Names)
            _exportedTypesOlocal :: (Bool)
            _exportedTypesOmethods_collect :: (FMap Name Names)
            _exportedTypesOmethods_dist :: (FMap Name Names)
            _exportedTypesOmoduleTypes :: (FMap ModuleName [Name])
            _exportedTypesOmoduleValues :: (FMap ModuleName [Name])
            _exportedTypesOnameType :: (NameType)
            _exportedTypesOtoplevel :: (Bool)
            _exportedValuesIconstructors_collect :: (FMap Name Names)
            _exportedValuesIknownKinds_collect :: (FMap Name [Name])
            _exportedValuesIknownTypes_collect :: (FMap Name [Name])
            _exportedValuesIknownValues_collect :: (FMap Name [Name])
            _exportedValuesIlabels_collect :: (FMap Name Names)
            _exportedValuesImethods_collect :: (FMap Name Names)
            _exportedValuesImoduleTypes :: (FMap ModuleName [Name])
            _exportedValuesImoduleValues :: (FMap ModuleName [Name])
            _exportedValuesImodules :: (Set.Set Strings)
            _exportedValuesIoriginalSelf :: (Names)
            _exportedValuesIres :: ([ResolveResult])
            _exportedValuesIself :: (Names)
            _exportedValuesOclassname :: (Maybe Name)
            _exportedValuesOconstructors_collect :: (FMap Name Names)
            _exportedValuesOconstructors_dist :: (FMap Name Names)
            _exportedValuesOcurrentModule :: (Strings)
            _exportedValuesOimportedModule :: (Bool)
            _exportedValuesOinstancename :: (Maybe Name)
            _exportedValuesOknownKinds :: (FMap Name [Name])
            _exportedValuesOknownKinds_collect :: (FMap Name [Name])
            _exportedValuesOknownTypes :: (FMap Name [Name])
            _exportedValuesOknownTypes_collect :: (FMap Name [Name])
            _exportedValuesOknownValues :: (FMap Name [Name])
            _exportedValuesOknownValues_collect :: (FMap Name [Name])
            _exportedValuesOlabels_collect :: (FMap Name Names)
            _exportedValuesOlabels_dist :: (FMap Name Names)
            _exportedValuesOlocal :: (Bool)
            _exportedValuesOmethods_collect :: (FMap Name Names)
            _exportedValuesOmethods_dist :: (FMap Name Names)
            _exportedValuesOmoduleTypes :: (FMap ModuleName [Name])
            _exportedValuesOmoduleValues :: (FMap ModuleName [Name])
            _exportedValuesOnameType :: (NameType)
            _exportedValuesOtoplevel :: (Bool)
            _declarationsIconstructors_collect :: (FMap Name Names)
            _declarationsIknownKinds_collect :: (FMap Name [Name])
            _declarationsIknownTypes_collect :: (FMap Name [Name])
            _declarationsIknownValues_collect :: (FMap Name [Name])
            _declarationsIlabels_collect :: (FMap Name Names)
            _declarationsImethods_collect :: (FMap Name Names)
            _declarationsImoduleTypes :: (FMap ModuleName [Name])
            _declarationsImoduleValues :: (FMap ModuleName [Name])
            _declarationsImodules :: (Set.Set Strings)
            _declarationsIres :: ([ResolveResult])
            _declarationsIself :: (InterfaceDeclarations)
            _declarationsOclassname :: (Maybe Name)
            _declarationsOconstructors_collect :: (FMap Name Names)
            _declarationsOconstructors_dist :: (FMap Name Names)
            _declarationsOcurrentModule :: (Strings)
            _declarationsOimportedModule :: (Bool)
            _declarationsOinstancename :: (Maybe Name)
            _declarationsOknownGenerics :: (FMap Name [Name])
            _declarationsOknownKinds :: (FMap Name [Name])
            _declarationsOknownKinds_collect :: (FMap Name [Name])
            _declarationsOknownTypes :: (FMap Name [Name])
            _declarationsOknownTypes_collect :: (FMap Name [Name])
            _declarationsOknownValues :: (FMap Name [Name])
            _declarationsOknownValues_collect :: (FMap Name [Name])
            _declarationsOlabels_collect :: (FMap Name Names)
            _declarationsOlabels_dist :: (FMap Name Names)
            _declarationsOlocal :: (Bool)
            _declarationsOmethods_collect :: (FMap Name Names)
            _declarationsOmethods_dist :: (FMap Name Names)
            _declarationsOmoduleTypes :: (FMap ModuleName [Name])
            _declarationsOmoduleValues :: (FMap ModuleName [Name])
            _declarationsOnameType :: (NameType)
            _declarationsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _exportedTypesIconstructors_collect,_exportedTypesIknownKinds_collect,_exportedTypesIknownTypes_collect,_exportedTypesIknownValues_collect,_exportedTypesIlabels_collect,_exportedTypesImethods_collect,_exportedTypesImoduleTypes,_exportedTypesImoduleValues,_exportedTypesImodules,_exportedTypesIoriginalSelf,_exportedTypesIres,_exportedTypesIself) =
                (exportedTypes_ (_exportedTypesOclassname)
                                (_exportedTypesOconstructors_collect)
                                (_exportedTypesOconstructors_dist)
                                (_exportedTypesOcurrentModule)
                                (_exportedTypesOimportedModule)
                                (_exportedTypesOinstancename)
                                (_exportedTypesOknownKinds)
                                (_exportedTypesOknownKinds_collect)
                                (_exportedTypesOknownTypes)
                                (_exportedTypesOknownTypes_collect)
                                (_exportedTypesOknownValues)
                                (_exportedTypesOknownValues_collect)
                                (_exportedTypesOlabels_collect)
                                (_exportedTypesOlabels_dist)
                                (_exportedTypesOlocal)
                                (_exportedTypesOmethods_collect)
                                (_exportedTypesOmethods_dist)
                                (_exportedTypesOmoduleTypes)
                                (_exportedTypesOmoduleValues)
                                (_exportedTypesOnameType)
                                (_exportedTypesOtoplevel))
            ( _exportedValuesIconstructors_collect,_exportedValuesIknownKinds_collect,_exportedValuesIknownTypes_collect,_exportedValuesIknownValues_collect,_exportedValuesIlabels_collect,_exportedValuesImethods_collect,_exportedValuesImoduleTypes,_exportedValuesImoduleValues,_exportedValuesImodules,_exportedValuesIoriginalSelf,_exportedValuesIres,_exportedValuesIself) =
                (exportedValues_ (_exportedValuesOclassname)
                                 (_exportedValuesOconstructors_collect)
                                 (_exportedValuesOconstructors_dist)
                                 (_exportedValuesOcurrentModule)
                                 (_exportedValuesOimportedModule)
                                 (_exportedValuesOinstancename)
                                 (_exportedValuesOknownKinds)
                                 (_exportedValuesOknownKinds_collect)
                                 (_exportedValuesOknownTypes)
                                 (_exportedValuesOknownTypes_collect)
                                 (_exportedValuesOknownValues)
                                 (_exportedValuesOknownValues_collect)
                                 (_exportedValuesOlabels_collect)
                                 (_exportedValuesOlabels_dist)
                                 (_exportedValuesOlocal)
                                 (_exportedValuesOmethods_collect)
                                 (_exportedValuesOmethods_dist)
                                 (_exportedValuesOmoduleTypes)
                                 (_exportedValuesOmoduleValues)
                                 (_exportedValuesOnameType)
                                 (_exportedValuesOtoplevel))
            ( _declarationsIconstructors_collect,_declarationsIknownKinds_collect,_declarationsIknownTypes_collect,_declarationsIknownValues_collect,_declarationsIlabels_collect,_declarationsImethods_collect,_declarationsImoduleTypes,_declarationsImoduleValues,_declarationsImodules,_declarationsIres,_declarationsIself) =
                (declarations_ (_declarationsOclassname)
                               (_declarationsOconstructors_collect)
                               (_declarationsOconstructors_dist)
                               (_declarationsOcurrentModule)
                               (_declarationsOimportedModule)
                               (_declarationsOinstancename)
                               (_declarationsOknownGenerics)
                               (_declarationsOknownKinds)
                               (_declarationsOknownKinds_collect)
                               (_declarationsOknownTypes)
                               (_declarationsOknownTypes_collect)
                               (_declarationsOknownValues)
                               (_declarationsOknownValues_collect)
                               (_declarationsOlabels_collect)
                               (_declarationsOlabels_dist)
                               (_declarationsOlocal)
                               (_declarationsOmethods_collect)
                               (_declarationsOmethods_dist)
                               (_declarationsOmoduleTypes)
                               (_declarationsOmoduleValues)
                               (_declarationsOnameType)
                               (_declarationsOtoplevel))
            -- "./Names.inc.lag"(line 1046, column 9)
            (_lhsOmoduleTypes@_) =
                add _lhsImoduleTypes  (_nameIself,_exportedTypesIself)
            -- "./Names.inc.lag"(line 1045, column 9)
            (_lhsOmoduleValues@_) =
                add _lhsImoduleValues (_nameIself,_exportedValuesIself)
            -- "./Names.inc.lag"(line 1043, column 9)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- "./Names.inc.lag"(line 1042, column 9)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- "./Names.inc.lag"(line 1039, column 9)
            (_declarationsOknownTypes@_) =
                internalError $
                   "Names.ModuleInterface.ModuleInterface.declarations.knownTypes: not used"
            -- "./Names.inc.lag"(line 1037, column 9)
            (_declarationsOknownValues@_) =
                internalError $
                   "Names.ModuleInterface.ModuleInterface.declarations.knownValues: not used"
            -- "./Names.inc.lag"(line 1035, column 9)
            (_declarationsOknownTypes_collect@_) =
                emptyFM
            -- "./Names.inc.lag"(line 1034, column 9)
            (_declarationsOknownValues_collect@_) =
                emptyFM
            -- "./ModuleInformation.inc.lag"(line 125, column 8)
            (_local@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 124, column 8)
            (_toplevel@_) =
                True
            -- "./ModuleInformation.inc.lag"(line 123, column 8)
            (_importedModule@_) =
                True
            -- "./ModuleInformation.inc.lag"(line 122, column 8)
            (_currentModule@_) =
                getModuleName _nameIself
            -- "./ModuleInformation.inc.lag"(line 348, column 9)
            (_lhsOmethods_collect@_) =
                mergeFM _lhsImethods_collect
                        _declarationsImethods_collect
            -- "./ModuleInformation.inc.lag"(line 346, column 9)
            (_lhsOconstructors_collect@_) =
                mergeFM _lhsIconstructors_collect
                        _declarationsIconstructors_collect
            -- "./ModuleInformation.inc.lag"(line 344, column 9)
            (_declarationsOmethods_collect@_) =
                emptyFM
            -- "./ModuleInformation.inc.lag"(line 343, column 9)
            (_declarationsOconstructors_collect@_) =
                emptyFM
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _exportedTypesImodules `Set.union` _exportedValuesImodules `Set.union` _declarationsImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _exportedTypesIres ++ _exportedValuesIres ++ _declarationsIres
            -- self rule
            (_self@_) =
                ModuleInterface_ModuleInterface _rangeIself _nameIself _exportedTypesIself _exportedValuesIself _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _declarationsIknownKinds_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _declarationsIlabels_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_rangeOcurrentModule@_) =
                _currentModule
            -- copy rule (chain)
            (_rangeOimportedModule@_) =
                _importedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_rangeOlocal@_) =
                _local
            -- copy rule (chain)
            (_rangeOtoplevel@_) =
                _toplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_nameOcurrentModule@_) =
                _currentModule
            -- copy rule (chain)
            (_nameOimportedModule@_) =
                _importedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_nameOlocal@_) =
                _local
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOnameType@_) =
                _lhsInameType
            -- copy rule (chain)
            (_nameOtoplevel@_) =
                _toplevel
            -- copy rule (down)
            (_exportedTypesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_exportedTypesOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_exportedTypesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_exportedTypesOcurrentModule@_) =
                _currentModule
            -- copy rule (chain)
            (_exportedTypesOimportedModule@_) =
                _importedModule
            -- copy rule (down)
            (_exportedTypesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_exportedTypesOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_exportedTypesOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_exportedTypesOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_exportedTypesOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (down)
            (_exportedTypesOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_exportedTypesOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_exportedTypesOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_exportedTypesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_exportedTypesOlocal@_) =
                _local
            -- copy rule (chain)
            (_exportedTypesOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_exportedTypesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_exportedTypesOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_exportedTypesOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_exportedTypesOnameType@_) =
                _lhsInameType
            -- copy rule (chain)
            (_exportedTypesOtoplevel@_) =
                _toplevel
            -- copy rule (down)
            (_exportedValuesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_exportedValuesOconstructors_collect@_) =
                _exportedTypesIconstructors_collect
            -- copy rule (down)
            (_exportedValuesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_exportedValuesOcurrentModule@_) =
                _currentModule
            -- copy rule (chain)
            (_exportedValuesOimportedModule@_) =
                _importedModule
            -- copy rule (down)
            (_exportedValuesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_exportedValuesOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_exportedValuesOknownKinds_collect@_) =
                _exportedTypesIknownKinds_collect
            -- copy rule (down)
            (_exportedValuesOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_exportedValuesOknownTypes_collect@_) =
                _exportedTypesIknownTypes_collect
            -- copy rule (down)
            (_exportedValuesOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_exportedValuesOknownValues_collect@_) =
                _exportedTypesIknownValues_collect
            -- copy rule (chain)
            (_exportedValuesOlabels_collect@_) =
                _exportedTypesIlabels_collect
            -- copy rule (down)
            (_exportedValuesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_exportedValuesOlocal@_) =
                _local
            -- copy rule (chain)
            (_exportedValuesOmethods_collect@_) =
                _exportedTypesImethods_collect
            -- copy rule (down)
            (_exportedValuesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_exportedValuesOmoduleTypes@_) =
                _exportedTypesImoduleTypes
            -- copy rule (chain)
            (_exportedValuesOmoduleValues@_) =
                _exportedTypesImoduleValues
            -- copy rule (down)
            (_exportedValuesOnameType@_) =
                _lhsInameType
            -- copy rule (chain)
            (_exportedValuesOtoplevel@_) =
                _toplevel
            -- copy rule (down)
            (_declarationsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_declarationsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_declarationsOcurrentModule@_) =
                _currentModule
            -- copy rule (chain)
            (_declarationsOimportedModule@_) =
                _importedModule
            -- copy rule (down)
            (_declarationsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_declarationsOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_declarationsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_declarationsOknownKinds_collect@_) =
                _exportedValuesIknownKinds_collect
            -- copy rule (chain)
            (_declarationsOlabels_collect@_) =
                _exportedValuesIlabels_collect
            -- copy rule (down)
            (_declarationsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_declarationsOlocal@_) =
                _local
            -- copy rule (down)
            (_declarationsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_declarationsOmoduleTypes@_) =
                _exportedValuesImoduleTypes
            -- copy rule (chain)
            (_declarationsOmoduleValues@_) =
                _exportedValuesImoduleValues
            -- copy rule (down)
            (_declarationsOnameType@_) =
                _lhsInameType
            -- copy rule (chain)
            (_declarationsOtoplevel@_) =
                _toplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_ModuleInterface_Unavailable :: (T_ModuleName) ->
                                   (T_ModuleInterface)
sem_ModuleInterface_Unavailable (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (ModuleInterface)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIres :: ([ResolveResult])
            _nameIself :: (ModuleName)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            ( _nameIconstructors_collect,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 130, column 8)
            (_local@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 129, column 8)
            (_toplevel@_) =
                True
            -- "./ModuleInformation.inc.lag"(line 128, column 8)
            (_importedModule@_) =
                True
            -- "./ModuleInformation.inc.lag"(line 127, column 8)
            (_currentModule@_) =
                getModuleName _nameIself
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres
            -- self rule
            (_self@_) =
                ModuleInterface_Unavailable _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_nameOcurrentModule@_) =
                _currentModule
            -- copy rule (chain)
            (_nameOimportedModule@_) =
                _importedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_nameOlocal@_) =
                _local
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOnameType@_) =
                _lhsInameType
            -- copy rule (chain)
            (_nameOtoplevel@_) =
                _toplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- ModuleInterfaces --------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for ModuleInterfaces.Cons:
      self

-}
{-
   local variables for ModuleInterfaces.Nil:
      self

-}
-- semantic domain
type T_ModuleInterfaces = (Maybe Name) ->
                          (FMap Name Names) ->
                          (FMap Name Names) ->
                          (Bool) ->
                          (Maybe Name) ->
                          (FMap Name [Name]) ->
                          (FMap Name [Name]) ->
                          (FMap Name [Name]) ->
                          (FMap Name [Name]) ->
                          (FMap Name [Name]) ->
                          (FMap Name [Name]) ->
                          (FMap Name [Name]) ->
                          (FMap Name Names) ->
                          (FMap Name Names) ->
                          (FMap Name Names) ->
                          (FMap Name Names) ->
                          (FMap ModuleName [Name]) ->
                          (FMap ModuleName [Name]) ->
                          (NameType) ->
                          (Bool) ->
                          ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(ModuleInterfaces))
-- cata
sem_ModuleInterfaces :: (ModuleInterfaces) ->
                        (T_ModuleInterfaces)
sem_ModuleInterfaces (list) =
    (foldr (sem_ModuleInterfaces_Cons) (sem_ModuleInterfaces_Nil) ((map sem_ModuleInterface list)))
sem_ModuleInterfaces_Cons :: (T_ModuleInterface) ->
                             (T_ModuleInterfaces) ->
                             (T_ModuleInterfaces)
sem_ModuleInterfaces_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (ModuleInterfaces)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIknownKinds_collect :: (FMap Name [Name])
            _hdIknownTypes_collect :: (FMap Name [Name])
            _hdIknownValues_collect :: (FMap Name [Name])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdImoduleTypes :: (FMap ModuleName [Name])
            _hdImoduleValues :: (FMap ModuleName [Name])
            _hdImodules :: (Set.Set Strings)
            _hdIres :: ([ResolveResult])
            _hdIself :: (ModuleInterface)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOknownGenerics :: (FMap Name [Name])
            _hdOknownKinds :: (FMap Name [Name])
            _hdOknownKinds_collect :: (FMap Name [Name])
            _hdOknownTypes :: (FMap Name [Name])
            _hdOknownTypes_collect :: (FMap Name [Name])
            _hdOknownValues :: (FMap Name [Name])
            _hdOknownValues_collect :: (FMap Name [Name])
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmoduleTypes :: (FMap ModuleName [Name])
            _hdOmoduleValues :: (FMap ModuleName [Name])
            _hdOnameType :: (NameType)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIknownKinds_collect :: (FMap Name [Name])
            _tlIknownTypes_collect :: (FMap Name [Name])
            _tlIknownValues_collect :: (FMap Name [Name])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlImoduleTypes :: (FMap ModuleName [Name])
            _tlImoduleValues :: (FMap ModuleName [Name])
            _tlImodules :: (Set.Set Strings)
            _tlIres :: ([ResolveResult])
            _tlIself :: (ModuleInterfaces)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOknownGenerics :: (FMap Name [Name])
            _tlOknownKinds :: (FMap Name [Name])
            _tlOknownKinds_collect :: (FMap Name [Name])
            _tlOknownTypes :: (FMap Name [Name])
            _tlOknownTypes_collect :: (FMap Name [Name])
            _tlOknownValues :: (FMap Name [Name])
            _tlOknownValues_collect :: (FMap Name [Name])
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmoduleTypes :: (FMap ModuleName [Name])
            _tlOmoduleValues :: (FMap ModuleName [Name])
            _tlOnameType :: (NameType)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIknownKinds_collect,_hdIknownTypes_collect,_hdIknownValues_collect,_hdIlabels_collect,_hdImethods_collect,_hdImoduleTypes,_hdImoduleValues,_hdImodules,_hdIres,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOimportedModule) (_hdOinstancename) (_hdOknownGenerics) (_hdOknownKinds) (_hdOknownKinds_collect) (_hdOknownTypes) (_hdOknownTypes_collect) (_hdOknownValues) (_hdOknownValues_collect) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOmoduleTypes) (_hdOmoduleValues) (_hdOnameType) (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIknownKinds_collect,_tlIknownTypes_collect,_tlIknownValues_collect,_tlIlabels_collect,_tlImethods_collect,_tlImoduleTypes,_tlImoduleValues,_tlImodules,_tlIres,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOimportedModule) (_tlOinstancename) (_tlOknownGenerics) (_tlOknownKinds) (_tlOknownKinds_collect) (_tlOknownTypes) (_tlOknownTypes_collect) (_tlOknownValues) (_tlOknownValues_collect) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOmoduleTypes) (_tlOmoduleValues) (_tlOnameType) (_tlOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _hdImodules `Set.union` _tlImodules
            -- use rule
            (_lhsOres@_) =
                _hdIres ++ _tlIres
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _tlIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _tlIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _tlIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _tlImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _tlImoduleValues
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_hdOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_hdOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_hdOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_hdOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_hdOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_hdOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_hdOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_hdOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_tlOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_tlOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_tlOknownKinds_collect@_) =
                _hdIknownKinds_collect
            -- copy rule (down)
            (_tlOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_tlOknownTypes_collect@_) =
                _hdIknownTypes_collect
            -- copy rule (down)
            (_tlOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_tlOknownValues_collect@_) =
                _hdIknownValues_collect
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_tlOmoduleTypes@_) =
                _hdImoduleTypes
            -- copy rule (chain)
            (_tlOmoduleValues@_) =
                _hdImoduleValues
            -- copy rule (down)
            (_tlOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_ModuleInterfaces_Nil :: (T_ModuleInterfaces)
sem_ModuleInterfaces_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (ModuleInterfaces)
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- ModuleName --------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for ModuleName.ModuleName:
      self

-}
-- semantic domain
type T_ModuleName = (Maybe Name) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Strings) ->
                    (Bool) ->
                    (Maybe Name) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Bool) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (FMap ModuleName [Name]) ->
                    (FMap ModuleName [Name]) ->
                    (NameType) ->
                    (Bool) ->
                    ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(ModuleName))
-- cata
sem_ModuleName :: (ModuleName) ->
                  (T_ModuleName)
sem_ModuleName ((ModuleName_ModuleName (_range) (_name))) =
    (sem_ModuleName_ModuleName ((sem_Range (_range))) ((sem_Strings (_name))))
sem_ModuleName_ModuleName :: (T_Range) ->
                             (T_Strings) ->
                             (T_ModuleName)
sem_ModuleName_ModuleName (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (ModuleName)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Strings)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres
            -- self rule
            (_self@_) =
                ModuleName_ModuleName _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- ModuleSystem ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      compiledModule       : Strings
      exports              : Exports
      hiddenEntities       : [(Set Name,Set Name)]
      importedEntities     : [(Set Name,Set Name)]
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for ModuleSystem.ModuleSystem:
      self

-}
-- semantic domain
type T_ModuleSystem = (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      (Maybe Name) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (FMap ModuleName [Name]) ->
                      (FMap ModuleName [Name]) ->
                      (NameType) ->
                      (Bool) ->
                      ( (Strings),(FMap Name Names),(Exports),([(Set Name,Set Name)]),([(Set Name,Set Name)]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(ModuleSystem))
-- cata
sem_ModuleSystem :: (ModuleSystem) ->
                    (T_ModuleSystem)
sem_ModuleSystem ((ModuleSystem_ModuleSystem (_interfaces) (_module))) =
    (sem_ModuleSystem_ModuleSystem ((sem_ModuleInterfaces (_interfaces))) ((sem_Module (_module))))
sem_ModuleSystem_ModuleSystem :: (T_ModuleInterfaces) ->
                                 (T_Module) ->
                                 (T_ModuleSystem)
sem_ModuleSystem_ModuleSystem (interfaces_) (module_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOcompiledModule :: (Strings)
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOexports :: (Exports)
            _lhsOhiddenEntities :: ([(Set Name,Set Name)])
            _lhsOimportedEntities :: ([(Set Name,Set Name)])
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (ModuleSystem)
            _interfacesIconstructors_collect :: (FMap Name Names)
            _interfacesIknownKinds_collect :: (FMap Name [Name])
            _interfacesIknownTypes_collect :: (FMap Name [Name])
            _interfacesIknownValues_collect :: (FMap Name [Name])
            _interfacesIlabels_collect :: (FMap Name Names)
            _interfacesImethods_collect :: (FMap Name Names)
            _interfacesImoduleTypes :: (FMap ModuleName [Name])
            _interfacesImoduleValues :: (FMap ModuleName [Name])
            _interfacesImodules :: (Set.Set Strings)
            _interfacesIres :: ([ResolveResult])
            _interfacesIself :: (ModuleInterfaces)
            _interfacesOclassname :: (Maybe Name)
            _interfacesOconstructors_collect :: (FMap Name Names)
            _interfacesOconstructors_dist :: (FMap Name Names)
            _interfacesOimportedModule :: (Bool)
            _interfacesOinstancename :: (Maybe Name)
            _interfacesOknownGenerics :: (FMap Name [Name])
            _interfacesOknownKinds :: (FMap Name [Name])
            _interfacesOknownKinds_collect :: (FMap Name [Name])
            _interfacesOknownTypes :: (FMap Name [Name])
            _interfacesOknownTypes_collect :: (FMap Name [Name])
            _interfacesOknownValues :: (FMap Name [Name])
            _interfacesOknownValues_collect :: (FMap Name [Name])
            _interfacesOlabels_collect :: (FMap Name Names)
            _interfacesOlabels_dist :: (FMap Name Names)
            _interfacesOmethods_collect :: (FMap Name Names)
            _interfacesOmethods_dist :: (FMap Name Names)
            _interfacesOmoduleTypes :: (FMap ModuleName [Name])
            _interfacesOmoduleValues :: (FMap ModuleName [Name])
            _interfacesOnameType :: (NameType)
            _interfacesOtoplevel :: (Bool)
            _moduleIcompiledModule :: (Strings)
            _moduleIconstructors_collect :: (FMap Name Names)
            _moduleIexports :: (Exports)
            _moduleIhiddenEntities :: ([(Set Name,Set Name)])
            _moduleIimportedEntities :: ([(Set Name,Set Name)])
            _moduleIknownKinds_collect :: (FMap Name [Name])
            _moduleIknownTypes_collect :: (FMap Name [Name])
            _moduleIknownValues_collect :: (FMap Name [Name])
            _moduleIlabels_collect :: (FMap Name Names)
            _moduleImethods_collect :: (FMap Name Names)
            _moduleImoduleTypes :: (FMap ModuleName [Name])
            _moduleImoduleValues :: (FMap ModuleName [Name])
            _moduleImodules :: (Set.Set Strings)
            _moduleIres :: ([ResolveResult])
            _moduleIself :: (Module)
            _moduleOclassname :: (Maybe Name)
            _moduleOconstructors_collect :: (FMap Name Names)
            _moduleOconstructors_dist :: (FMap Name Names)
            _moduleOimportedModule :: (Bool)
            _moduleOinstancename :: (Maybe Name)
            _moduleOknownGenerics :: (FMap Name [Name])
            _moduleOknownKinds :: (FMap Name [Name])
            _moduleOknownKinds_collect :: (FMap Name [Name])
            _moduleOknownTypes :: (FMap Name [Name])
            _moduleOknownTypes_collect :: (FMap Name [Name])
            _moduleOknownValues :: (FMap Name [Name])
            _moduleOknownValues_collect :: (FMap Name [Name])
            _moduleOlabels_collect :: (FMap Name Names)
            _moduleOlabels_dist :: (FMap Name Names)
            _moduleOmethods_collect :: (FMap Name Names)
            _moduleOmethods_dist :: (FMap Name Names)
            _moduleOmoduleTypes :: (FMap ModuleName [Name])
            _moduleOmoduleValues :: (FMap ModuleName [Name])
            _moduleOnameType :: (NameType)
            _moduleOtoplevel :: (Bool)
            ( _interfacesIconstructors_collect,_interfacesIknownKinds_collect,_interfacesIknownTypes_collect,_interfacesIknownValues_collect,_interfacesIlabels_collect,_interfacesImethods_collect,_interfacesImoduleTypes,_interfacesImoduleValues,_interfacesImodules,_interfacesIres,_interfacesIself) =
                (interfaces_ (_interfacesOclassname)
                             (_interfacesOconstructors_collect)
                             (_interfacesOconstructors_dist)
                             (_interfacesOimportedModule)
                             (_interfacesOinstancename)
                             (_interfacesOknownGenerics)
                             (_interfacesOknownKinds)
                             (_interfacesOknownKinds_collect)
                             (_interfacesOknownTypes)
                             (_interfacesOknownTypes_collect)
                             (_interfacesOknownValues)
                             (_interfacesOknownValues_collect)
                             (_interfacesOlabels_collect)
                             (_interfacesOlabels_dist)
                             (_interfacesOmethods_collect)
                             (_interfacesOmethods_dist)
                             (_interfacesOmoduleTypes)
                             (_interfacesOmoduleValues)
                             (_interfacesOnameType)
                             (_interfacesOtoplevel))
            ( _moduleIcompiledModule,_moduleIconstructors_collect,_moduleIexports,_moduleIhiddenEntities,_moduleIimportedEntities,_moduleIknownKinds_collect,_moduleIknownTypes_collect,_moduleIknownValues_collect,_moduleIlabels_collect,_moduleImethods_collect,_moduleImoduleTypes,_moduleImoduleValues,_moduleImodules,_moduleIres,_moduleIself) =
                (module_ (_moduleOclassname)
                         (_moduleOconstructors_collect)
                         (_moduleOconstructors_dist)
                         (_moduleOimportedModule)
                         (_moduleOinstancename)
                         (_moduleOknownGenerics)
                         (_moduleOknownKinds)
                         (_moduleOknownKinds_collect)
                         (_moduleOknownTypes)
                         (_moduleOknownTypes_collect)
                         (_moduleOknownValues)
                         (_moduleOknownValues_collect)
                         (_moduleOlabels_collect)
                         (_moduleOlabels_dist)
                         (_moduleOmethods_collect)
                         (_moduleOmethods_dist)
                         (_moduleOmoduleTypes)
                         (_moduleOmoduleValues)
                         (_moduleOnameType)
                         (_moduleOtoplevel))
            -- "NameReplace.lag"(line 426, column 9)
            (_lhsOres@_) =
                _moduleIres
            -- use rule
            (_lhsOhiddenEntities@_) =
                _moduleIhiddenEntities
            -- use rule
            (_lhsOimportedEntities@_) =
                _moduleIimportedEntities
            -- use rule
            (_lhsOmodules@_) =
                _interfacesImodules `Set.union` _moduleImodules
            -- self rule
            (_self@_) =
                ModuleSystem_ModuleSystem _interfacesIself _moduleIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOcompiledModule@_) =
                _moduleIcompiledModule
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _moduleIconstructors_collect
            -- copy rule (up)
            (_lhsOexports@_) =
                _moduleIexports
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _moduleIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _moduleIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _moduleIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _moduleIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _moduleImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _moduleImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _moduleImoduleValues
            -- copy rule (down)
            (_interfacesOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_interfacesOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_interfacesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_interfacesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_interfacesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_interfacesOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_interfacesOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_interfacesOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_interfacesOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_interfacesOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_interfacesOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_interfacesOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_interfacesOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_interfacesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_interfacesOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_interfacesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_interfacesOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_interfacesOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_interfacesOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_interfacesOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_moduleOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_moduleOconstructors_collect@_) =
                _interfacesIconstructors_collect
            -- copy rule (down)
            (_moduleOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_moduleOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_moduleOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_moduleOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_moduleOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_moduleOknownKinds_collect@_) =
                _interfacesIknownKinds_collect
            -- copy rule (down)
            (_moduleOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_moduleOknownTypes_collect@_) =
                _interfacesIknownTypes_collect
            -- copy rule (down)
            (_moduleOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_moduleOknownValues_collect@_) =
                _interfacesIknownValues_collect
            -- copy rule (chain)
            (_moduleOlabels_collect@_) =
                _interfacesIlabels_collect
            -- copy rule (down)
            (_moduleOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_moduleOmethods_collect@_) =
                _interfacesImethods_collect
            -- copy rule (down)
            (_moduleOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_moduleOmoduleTypes@_) =
                _interfacesImoduleTypes
            -- copy rule (chain)
            (_moduleOmoduleValues@_) =
                _interfacesImoduleValues
            -- copy rule (down)
            (_moduleOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_moduleOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOcompiledModule,_lhsOconstructors_collect,_lhsOexports,_lhsOhiddenEntities,_lhsOimportedEntities,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- Name --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      entityName           : Name
      fullName             : Name
      modules              : Set.Set Strings
      originalSelf         : Name
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for Name.Entity:
      self
      originalSelf
      fullName

-}
{-
   local variables for Name.Identifier:
      self
      originalSelf
      fullName
      realModule
      entity_ref
      r_ref
      n_ref
      refEnvironment
      r_def
      entity_def
      module_def
      defEnvironment
      entityName
      res

-}
{-
   local variables for Name.Operator:
      self
      originalSelf
      fullName
      realModule
      entity_ref
      r_ref
      refEnvironment
      entity_def
      r_def
      module_def
      entityName
      res

-}
{-
   local variables for Name.Special:
      self
      originalSelf
      fullName
      realModule
      entity_ref
      r_ref
      refEnvironment
      entity_def
      r_def
      module_def
      entityName
      res

-}
-- semantic domain
type T_Name = (Maybe Name) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (Strings) ->
              (Bool) ->
              (Maybe Name) ->
              (FMap Name [Name]) ->
              (FMap Name [Name]) ->
              (FMap Name [Name]) ->
              (FMap Name [Name]) ->
              (FMap Name [Name]) ->
              (FMap Name [Name]) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (Bool) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (FMap ModuleName [Name]) ->
              (FMap ModuleName [Name]) ->
              (NameType) ->
              (Bool) ->
              ( (FMap Name Names),(Name),(Name),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),(Name),([ResolveResult]),(Name))
-- cata
sem_Name :: (Name) ->
            (T_Name)
sem_Name ((Name_Entity (_range) (_entity) (_inscope))) =
    (sem_Name_Entity ((sem_Range (_range))) ((sem_Name (_entity))) ((sem_MaybeName (_inscope))))
sem_Name ((Name_Identifier (_range) (_module) (_name))) =
    (sem_Name_Identifier ((sem_Range (_range))) ((sem_Strings (_module))) (_name))
sem_Name ((Name_Operator (_range) (_module) (_name))) =
    (sem_Name_Operator ((sem_Range (_range))) ((sem_Strings (_module))) (_name))
sem_Name ((Name_Special (_range) (_module) (_name))) =
    (sem_Name_Special ((sem_Range (_range))) ((sem_Strings (_module))) (_name))
sem_Name_Entity :: (T_Range) ->
                   (T_Name) ->
                   (T_MaybeName) ->
                   (T_Name)
sem_Name_Entity (range_) (entity_) (inscope_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOentityName :: (Name)
            _lhsOfullName :: (Name)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOoriginalSelf :: (Name)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Name)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _entityIconstructors_collect :: (FMap Name Names)
            _entityIentityName :: (Name)
            _entityIfullName :: (Name)
            _entityIknownKinds_collect :: (FMap Name [Name])
            _entityIknownTypes_collect :: (FMap Name [Name])
            _entityIknownValues_collect :: (FMap Name [Name])
            _entityIlabels_collect :: (FMap Name Names)
            _entityImethods_collect :: (FMap Name Names)
            _entityImoduleTypes :: (FMap ModuleName [Name])
            _entityImoduleValues :: (FMap ModuleName [Name])
            _entityImodules :: (Set.Set Strings)
            _entityIoriginalSelf :: (Name)
            _entityIres :: ([ResolveResult])
            _entityIself :: (Name)
            _entityOclassname :: (Maybe Name)
            _entityOconstructors_collect :: (FMap Name Names)
            _entityOconstructors_dist :: (FMap Name Names)
            _entityOcurrentModule :: (Strings)
            _entityOimportedModule :: (Bool)
            _entityOinstancename :: (Maybe Name)
            _entityOknownKinds :: (FMap Name [Name])
            _entityOknownKinds_collect :: (FMap Name [Name])
            _entityOknownTypes :: (FMap Name [Name])
            _entityOknownTypes_collect :: (FMap Name [Name])
            _entityOknownValues :: (FMap Name [Name])
            _entityOknownValues_collect :: (FMap Name [Name])
            _entityOlabels_collect :: (FMap Name Names)
            _entityOlabels_dist :: (FMap Name Names)
            _entityOlocal :: (Bool)
            _entityOmethods_collect :: (FMap Name Names)
            _entityOmethods_dist :: (FMap Name Names)
            _entityOmoduleTypes :: (FMap ModuleName [Name])
            _entityOmoduleValues :: (FMap ModuleName [Name])
            _entityOnameType :: (NameType)
            _entityOtoplevel :: (Bool)
            _inscopeIconstructors_collect :: (FMap Name Names)
            _inscopeIknownKinds_collect :: (FMap Name [Name])
            _inscopeIknownTypes_collect :: (FMap Name [Name])
            _inscopeIknownValues_collect :: (FMap Name [Name])
            _inscopeIlabels_collect :: (FMap Name Names)
            _inscopeImethods_collect :: (FMap Name Names)
            _inscopeImoduleTypes :: (FMap ModuleName [Name])
            _inscopeImoduleValues :: (FMap ModuleName [Name])
            _inscopeImodules :: (Set.Set Strings)
            _inscopeIoriginalSelf :: (MaybeName)
            _inscopeIres :: ([ResolveResult])
            _inscopeIself :: (MaybeName)
            _inscopeOclassname :: (Maybe Name)
            _inscopeOconstructors_collect :: (FMap Name Names)
            _inscopeOconstructors_dist :: (FMap Name Names)
            _inscopeOcurrentModule :: (Strings)
            _inscopeOimportedModule :: (Bool)
            _inscopeOinstancename :: (Maybe Name)
            _inscopeOknownKinds :: (FMap Name [Name])
            _inscopeOknownKinds_collect :: (FMap Name [Name])
            _inscopeOknownTypes :: (FMap Name [Name])
            _inscopeOknownTypes_collect :: (FMap Name [Name])
            _inscopeOknownValues :: (FMap Name [Name])
            _inscopeOknownValues_collect :: (FMap Name [Name])
            _inscopeOlabels_collect :: (FMap Name Names)
            _inscopeOlabels_dist :: (FMap Name Names)
            _inscopeOlocal :: (Bool)
            _inscopeOmethods_collect :: (FMap Name Names)
            _inscopeOmethods_dist :: (FMap Name Names)
            _inscopeOmoduleTypes :: (FMap ModuleName [Name])
            _inscopeOmoduleValues :: (FMap ModuleName [Name])
            _inscopeOnameType :: (NameType)
            _inscopeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _entityIconstructors_collect,_entityIentityName,_entityIfullName,_entityIknownKinds_collect,_entityIknownTypes_collect,_entityIknownValues_collect,_entityIlabels_collect,_entityImethods_collect,_entityImoduleTypes,_entityImoduleValues,_entityImodules,_entityIoriginalSelf,_entityIres,_entityIself) =
                (entity_ (_entityOclassname)
                         (_entityOconstructors_collect)
                         (_entityOconstructors_dist)
                         (_entityOcurrentModule)
                         (_entityOimportedModule)
                         (_entityOinstancename)
                         (_entityOknownKinds)
                         (_entityOknownKinds_collect)
                         (_entityOknownTypes)
                         (_entityOknownTypes_collect)
                         (_entityOknownValues)
                         (_entityOknownValues_collect)
                         (_entityOlabels_collect)
                         (_entityOlabels_dist)
                         (_entityOlocal)
                         (_entityOmethods_collect)
                         (_entityOmethods_dist)
                         (_entityOmoduleTypes)
                         (_entityOmoduleValues)
                         (_entityOnameType)
                         (_entityOtoplevel))
            ( _inscopeIconstructors_collect,_inscopeIknownKinds_collect,_inscopeIknownTypes_collect,_inscopeIknownValues_collect,_inscopeIlabels_collect,_inscopeImethods_collect,_inscopeImoduleTypes,_inscopeImoduleValues,_inscopeImodules,_inscopeIoriginalSelf,_inscopeIres,_inscopeIself) =
                (inscope_ (_inscopeOclassname)
                          (_inscopeOconstructors_collect)
                          (_inscopeOconstructors_dist)
                          (_inscopeOcurrentModule)
                          (_inscopeOimportedModule)
                          (_inscopeOinstancename)
                          (_inscopeOknownKinds)
                          (_inscopeOknownKinds_collect)
                          (_inscopeOknownTypes)
                          (_inscopeOknownTypes_collect)
                          (_inscopeOknownValues)
                          (_inscopeOknownValues_collect)
                          (_inscopeOlabels_collect)
                          (_inscopeOlabels_dist)
                          (_inscopeOlocal)
                          (_inscopeOmethods_collect)
                          (_inscopeOmethods_dist)
                          (_inscopeOmoduleTypes)
                          (_inscopeOmoduleValues)
                          (_inscopeOnameType)
                          (_inscopeOtoplevel))
            -- "NameReplace.lag"(line 96, column 9)
            (_lhsOself@_) =
                _self
            -- "NameReplace.lag"(line 95, column 9)
            (_self@_) =
                _originalSelf
            -- "./Names.inc.lag"(line 86, column 9)
            (_lhsOoriginalSelf@_) =
                _originalSelf
            -- "./Names.inc.lag"(line 85, column 9)
            (_originalSelf@_) =
                Name_Entity _rangeIself _entityIoriginalSelf _inscopeIoriginalSelf
            -- "./Names.inc.lag"(line 84, column 9)
            (_lhsOfullName@_) =
                _fullName
            -- "./Names.inc.lag"(line 83, column 9)
            (_fullName@_) =
                internalError "Names.Name.Entity.loc.fullName: not used"
            -- "./Names.inc.lag"(line 176, column 9)
            (_lhsOentityName@_) =
                internalError "Names.Name.Entity.loc.entityName: not used"
            -- use rule
            (_lhsOmodules@_) =
                _entityImodules `Set.union` _inscopeImodules
            -- use rule
            (_lhsOres@_) =
                _entityIres ++ _inscopeIres
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _inscopeIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _inscopeIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _inscopeIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _inscopeIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _inscopeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _inscopeImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _inscopeImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _inscopeImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_entityOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_entityOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_entityOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_entityOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_entityOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_entityOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_entityOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_entityOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_entityOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_entityOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_entityOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_entityOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_entityOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_entityOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_entityOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_entityOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_entityOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_entityOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_entityOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_entityOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_entityOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_inscopeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_inscopeOconstructors_collect@_) =
                _entityIconstructors_collect
            -- copy rule (down)
            (_inscopeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_inscopeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_inscopeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_inscopeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_inscopeOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_inscopeOknownKinds_collect@_) =
                _entityIknownKinds_collect
            -- copy rule (down)
            (_inscopeOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_inscopeOknownTypes_collect@_) =
                _entityIknownTypes_collect
            -- copy rule (down)
            (_inscopeOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_inscopeOknownValues_collect@_) =
                _entityIknownValues_collect
            -- copy rule (chain)
            (_inscopeOlabels_collect@_) =
                _entityIlabels_collect
            -- copy rule (down)
            (_inscopeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_inscopeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_inscopeOmethods_collect@_) =
                _entityImethods_collect
            -- copy rule (down)
            (_inscopeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_inscopeOmoduleTypes@_) =
                _entityImoduleTypes
            -- copy rule (chain)
            (_inscopeOmoduleValues@_) =
                _entityImoduleValues
            -- copy rule (down)
            (_inscopeOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_inscopeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOentityName,_lhsOfullName,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOoriginalSelf,_lhsOres,_lhsOself)
sem_Name_Identifier :: (T_Range) ->
                       (T_Strings) ->
                       (String) ->
                       (T_Name)
sem_Name_Identifier (range_) (module_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOentityName :: (Name)
            _lhsOfullName :: (Name)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOoriginalSelf :: (Name)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Name)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _moduleIconstructors_collect :: (FMap Name Names)
            _moduleIknownKinds_collect :: (FMap Name [Name])
            _moduleIknownTypes_collect :: (FMap Name [Name])
            _moduleIknownValues_collect :: (FMap Name [Name])
            _moduleIlabels_collect :: (FMap Name Names)
            _moduleImethods_collect :: (FMap Name Names)
            _moduleImoduleTypes :: (FMap ModuleName [Name])
            _moduleImoduleValues :: (FMap ModuleName [Name])
            _moduleImodules :: (Set.Set Strings)
            _moduleIres :: ([ResolveResult])
            _moduleIself :: (Strings)
            _moduleOclassname :: (Maybe Name)
            _moduleOconstructors_collect :: (FMap Name Names)
            _moduleOconstructors_dist :: (FMap Name Names)
            _moduleOcurrentModule :: (Strings)
            _moduleOimportedModule :: (Bool)
            _moduleOinstancename :: (Maybe Name)
            _moduleOknownKinds :: (FMap Name [Name])
            _moduleOknownKinds_collect :: (FMap Name [Name])
            _moduleOknownTypes :: (FMap Name [Name])
            _moduleOknownTypes_collect :: (FMap Name [Name])
            _moduleOknownValues :: (FMap Name [Name])
            _moduleOknownValues_collect :: (FMap Name [Name])
            _moduleOlabels_collect :: (FMap Name Names)
            _moduleOlabels_dist :: (FMap Name Names)
            _moduleOlocal :: (Bool)
            _moduleOmethods_collect :: (FMap Name Names)
            _moduleOmethods_dist :: (FMap Name Names)
            _moduleOmoduleTypes :: (FMap ModuleName [Name])
            _moduleOmoduleValues :: (FMap ModuleName [Name])
            _moduleOnameType :: (NameType)
            _moduleOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _moduleIconstructors_collect,_moduleIknownKinds_collect,_moduleIknownTypes_collect,_moduleIknownValues_collect,_moduleIlabels_collect,_moduleImethods_collect,_moduleImoduleTypes,_moduleImoduleValues,_moduleImodules,_moduleIres,_moduleIself) =
                (module_ (_moduleOclassname)
                         (_moduleOconstructors_collect)
                         (_moduleOconstructors_dist)
                         (_moduleOcurrentModule)
                         (_moduleOimportedModule)
                         (_moduleOinstancename)
                         (_moduleOknownKinds)
                         (_moduleOknownKinds_collect)
                         (_moduleOknownTypes)
                         (_moduleOknownTypes_collect)
                         (_moduleOknownValues)
                         (_moduleOknownValues_collect)
                         (_moduleOlabels_collect)
                         (_moduleOlabels_dist)
                         (_moduleOlocal)
                         (_moduleOmethods_collect)
                         (_moduleOmethods_dist)
                         (_moduleOmoduleTypes)
                         (_moduleOmoduleValues)
                         (_moduleOnameType)
                         (_moduleOtoplevel))
            -- "NameReplace.lag"(line 74, column 9)
            (_lhsOself@_) =
                _self
            -- "NameReplace.lag"(line 68, column 9)
            (_self@_) =
                if _lhsInameType == NameType_None then
                  _originalSelf
                else
                  Name_Entity _rangeIself _entityName
                    (if _lhsIlocal then (MaybeName_Just _originalSelf)
                                   else MaybeName_Nothing)
            -- "./Names.inc.lag"(line 73, column 9)
            (_originalSelf@_) =
                Name_Identifier _rangeIself _moduleIself name_
            -- "./Names.inc.lag"(line 72, column 9)
            (_fullName@_) =
                Name_Identifier _rangeIself _realModule  name_
            -- "./Names.inc.lag"(line 71, column 9)
            (_realModule@_) =
                if null _moduleIself then _lhsIcurrentModule else _moduleIself
            -- "./Names.inc.lag"(line 307, column 9)
            (_lhsOmodules@_) =
                if _lhsIimportedModule then
                  if not (null _moduleIself) then
                    Set.unitSet _moduleIself
                  else if isDef _lhsInameType then
                    Set.unitSet _lhsIcurrentModule
                  else
                    Set.emptySet
                else
                  Set.emptySet
            -- "./Names.inc.lag"(line 298, column 9)
            (_lhsOknownKinds_collect@_) =
                case _lhsInameType of
                  Def_Kind -> foldl addLReplace _lhsIknownKinds_collect
                                    [(_originalSelf,[_entityName])
                                    ,(_fullName    ,[_entityName])
                                    ]
                  _        -> _lhsIknownKinds_collect
            -- "./Names.inc.lag"(line 286, column 9)
            (_lhsOknownTypes_collect@_) =
                case _lhsInameType of
                  Def_Typ  -> foldl addLReplace _lhsIknownTypes_collect
                                    [(_originalSelf,[_entityName])
                                    ,(_fullName    ,[_entityName])
                                    ]
                  DefOrRef_Typ _ | _n_ref == 0
                           -> foldl addLReplace _lhsIknownTypes_collect
                                    [(_originalSelf,[_entityName])
                                    ,(_fullName    ,[_entityName])
                                    ]
                  _        -> _lhsIknownTypes_collect
            -- "./Names.inc.lag"(line 279, column 9)
            (_lhsOknownValues_collect@_) =
                case _lhsInameType of
                  Def_Val  -> foldl addLReplace _lhsIknownValues_collect
                                    [(_originalSelf,[_entityName])
                                    ,(_fullName    ,[_entityName])
                                    ]
                  _        -> _lhsIknownValues_collect
            -- "./Names.inc.lag"(line 247, column 13)
            (((_entity_ref@_,_r_ref@_),_n_ref@_)) =
                if _lhsIimportedModule then
                   ((_entity_def,[Resolved _originalSelf _entity_def]),1)
                else
                   let es = if softRef _lhsInameType then
                               filter (\ n -> getModule n `elem` [_lhsIcurrentModule,[]])
                                  $ findL _refEnvironment _originalSelf
                            else
                               findL _refEnvironment _originalSelf
                   in  (case es of
                         [entity] ->
                                     (entity,[Resolved _originalSelf entity])
                         []       ->
                                     (Name_Identifier _rangeIself [] name_
                                     ,[UnResolved
                                         _originalSelf (domain _refEnvironment)
                                         (GHError_ResolveError _rangeIself _originalSelf)
                                      ]
                                     )
                         _        ->
                                     (head es
                                     ,[UnResolved
                                         _originalSelf (domain _refEnvironment)
                                         (GHError_NameClashError _rangeIself _originalSelf es)
                                      ]
                                     )
                       ,length es
                       )
            -- "./Names.inc.lag"(line 237, column 9)
            (_refEnvironment@_) =
                case _lhsInameType of
                  Ref_Val  _ -> _lhsIknownValues
                  Ref_Typ  _ -> _lhsIknownTypes
                  Ref_Kind _ -> _lhsIknownKinds
                  DefOrRef_Typ _ -> _lhsIknownTypes_collect
                  _          -> internalError $
                                   "Names.Name.Identifier.loc.refEnvironment: "
                                      ++ "definition treated as reference: "
                                      ++ unPretty (ppName _originalSelf)
            -- "./Names.inc.lag"(line 221, column 9)
            (_r_def@_) =
                let es = findL _defEnvironment _originalSelf
                in  case es of
                      [] ->
                            [Defined _entity_def]
                      (e:_) ->
                            [Collision _originalSelf e
                               (GHError_DoubleDefinitionError
                                  _originalSelf
                                  (getRange e)
                                  (getRange _originalSelf)
                               )
                            ]
            -- "./Names.inc.lag"(line 220, column 9)
            (_entity_def@_) =
                Name_Identifier _rangeIself _module_def name_
            -- "./Names.inc.lag"(line 213, column 9)
            (_module_def@_) =
                case _moduleIself of
                  [] | _lhsItoplevel ->
                                        _lhsIcurrentModule
                     | otherwise     ->
                                        []
                  m  -> m
            -- "./Names.inc.lag"(line 203, column 9)
            (_defEnvironment@_) =
                case _lhsInameType of
                  Def_Val  -> _lhsIknownValues_collect
                  Def_Typ  -> _lhsIknownTypes_collect
                  Def_Kind -> _lhsIknownKinds_collect
                  DefOrRef_Typ _ -> _lhsIknownTypes_collect
                  _        -> internalError $
                                 "Names.Name.Identifier.loc.defEnvironment: "
                                   ++ "reference treated as definition: "
                                   ++ unPretty (ppName _originalSelf)
            -- "./Names.inc.lag"(line 183, column 13)
            ((_entityName@_,_res@_)) =
                if isDef _lhsInameType then
                  (_entity_def,_r_def)
                else if isRef _lhsInameType then
                  (_entity_ref,_r_ref)
                else if isDefRef _lhsInameType then
                  if _n_ref == 0 then
                    (_entity_def,_r_def)
                  else
                    (_entity_ref,_r_ref)
                else
                  (internalError $
                        "Names.Name.Identifier.refEnvironment: non-resolved name used `"
                           ++ unPretty (ppName _originalSelf) ++ "'"
                  ,[]
                  )
            -- use rule
            (_lhsOres@_) =
                _res
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _moduleIconstructors_collect
            -- copy rule (up)
            (_lhsOentityName@_) =
                _entityName
            -- copy rule (up)
            (_lhsOfullName@_) =
                _fullName
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _moduleIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _moduleImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _moduleImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _moduleImoduleValues
            -- copy rule (up)
            (_lhsOoriginalSelf@_) =
                _originalSelf
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_moduleOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_moduleOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_moduleOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_moduleOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_moduleOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_moduleOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_moduleOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_moduleOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_moduleOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_moduleOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_moduleOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_moduleOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_moduleOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_moduleOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_moduleOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_moduleOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_moduleOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_moduleOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_moduleOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_moduleOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_moduleOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOentityName,_lhsOfullName,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOoriginalSelf,_lhsOres,_lhsOself)
sem_Name_Operator :: (T_Range) ->
                     (T_Strings) ->
                     (String) ->
                     (T_Name)
sem_Name_Operator (range_) (module_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOentityName :: (Name)
            _lhsOfullName :: (Name)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOoriginalSelf :: (Name)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Name)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _moduleIconstructors_collect :: (FMap Name Names)
            _moduleIknownKinds_collect :: (FMap Name [Name])
            _moduleIknownTypes_collect :: (FMap Name [Name])
            _moduleIknownValues_collect :: (FMap Name [Name])
            _moduleIlabels_collect :: (FMap Name Names)
            _moduleImethods_collect :: (FMap Name Names)
            _moduleImoduleTypes :: (FMap ModuleName [Name])
            _moduleImoduleValues :: (FMap ModuleName [Name])
            _moduleImodules :: (Set.Set Strings)
            _moduleIres :: ([ResolveResult])
            _moduleIself :: (Strings)
            _moduleOclassname :: (Maybe Name)
            _moduleOconstructors_collect :: (FMap Name Names)
            _moduleOconstructors_dist :: (FMap Name Names)
            _moduleOcurrentModule :: (Strings)
            _moduleOimportedModule :: (Bool)
            _moduleOinstancename :: (Maybe Name)
            _moduleOknownKinds :: (FMap Name [Name])
            _moduleOknownKinds_collect :: (FMap Name [Name])
            _moduleOknownTypes :: (FMap Name [Name])
            _moduleOknownTypes_collect :: (FMap Name [Name])
            _moduleOknownValues :: (FMap Name [Name])
            _moduleOknownValues_collect :: (FMap Name [Name])
            _moduleOlabels_collect :: (FMap Name Names)
            _moduleOlabels_dist :: (FMap Name Names)
            _moduleOlocal :: (Bool)
            _moduleOmethods_collect :: (FMap Name Names)
            _moduleOmethods_dist :: (FMap Name Names)
            _moduleOmoduleTypes :: (FMap ModuleName [Name])
            _moduleOmoduleValues :: (FMap ModuleName [Name])
            _moduleOnameType :: (NameType)
            _moduleOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _moduleIconstructors_collect,_moduleIknownKinds_collect,_moduleIknownTypes_collect,_moduleIknownValues_collect,_moduleIlabels_collect,_moduleImethods_collect,_moduleImoduleTypes,_moduleImoduleValues,_moduleImodules,_moduleIres,_moduleIself) =
                (module_ (_moduleOclassname)
                         (_moduleOconstructors_collect)
                         (_moduleOconstructors_dist)
                         (_moduleOcurrentModule)
                         (_moduleOimportedModule)
                         (_moduleOinstancename)
                         (_moduleOknownKinds)
                         (_moduleOknownKinds_collect)
                         (_moduleOknownTypes)
                         (_moduleOknownTypes_collect)
                         (_moduleOknownValues)
                         (_moduleOknownValues_collect)
                         (_moduleOlabels_collect)
                         (_moduleOlabels_dist)
                         (_moduleOlocal)
                         (_moduleOmethods_collect)
                         (_moduleOmethods_dist)
                         (_moduleOmoduleTypes)
                         (_moduleOmoduleValues)
                         (_moduleOnameType)
                         (_moduleOtoplevel))
            -- "NameReplace.lag"(line 83, column 9)
            (_lhsOself@_) =
                _self
            -- "NameReplace.lag"(line 77, column 9)
            (_self@_) =
                if _lhsInameType == NameType_None then
                  _originalSelf
                else
                  Name_Entity _rangeIself _entityName
                    (if _lhsIlocal then (MaybeName_Just _originalSelf)
                                   else MaybeName_Nothing)
            -- "./Names.inc.lag"(line 77, column 9)
            (_originalSelf@_) =
                Name_Operator   _rangeIself _moduleIself name_
            -- "./Names.inc.lag"(line 76, column 9)
            (_fullName@_) =
                Name_Operator   _rangeIself _realModule  name_
            -- "./Names.inc.lag"(line 75, column 9)
            (_realModule@_) =
                if null _moduleIself then _lhsIcurrentModule else _moduleIself
            -- "./Names.inc.lag"(line 401, column 9)
            (_lhsOmodules@_) =
                if _lhsIimportedModule then
                  if not (null _moduleIself) then
                    Set.unitSet _moduleIself
                  else if isDef _lhsInameType then
                    Set.unitSet _lhsIcurrentModule
                  else
                    Set.emptySet
                else
                  Set.emptySet
            -- "./Names.inc.lag"(line 392, column 9)
            (_lhsOknownKinds_collect@_) =
                case _lhsInameType of
                  Def_Kind -> foldl addLReplace _lhsIknownKinds_collect
                                    [(_originalSelf,[_entityName])
                                    ,(_fullName    ,[_entityName])
                                    ]
                  _        -> _lhsIknownKinds_collect
            -- "./Names.inc.lag"(line 385, column 9)
            (_lhsOknownTypes_collect@_) =
                case _lhsInameType of
                  Def_Typ  -> foldl addLReplace _lhsIknownTypes_collect
                                    [(_originalSelf,[_entityName])
                                    ,(_fullName    ,[_entityName])
                                    ]
                  _        -> _lhsIknownTypes_collect
            -- "./Names.inc.lag"(line 378, column 9)
            (_lhsOknownValues_collect@_) =
                case _lhsInameType of
                  Def_Val  -> foldl addLReplace _lhsIknownValues_collect
                                    [(_originalSelf,[_entityName])
                                    ,(_fullName    ,[_entityName])
                                    ]
                  _        -> _lhsIknownValues_collect
            -- "./Names.inc.lag"(line 353, column 13)
            ((_entity_ref@_,_r_ref@_)) =
                if _lhsIimportedModule then
                   (_entity_def,[Resolved _originalSelf _entity_def])
                else
                   let es = findL _refEnvironment _originalSelf
                   in  case es of
                         [entity] ->
                                     (entity,[Resolved _originalSelf entity])
                         []       ->
                                     (Name_Operator _rangeIself [] name_
                                     ,[UnResolved
                                         _originalSelf (domain _refEnvironment)
                                         (GHError_ResolveError _rangeIself _originalSelf)
                                      ]
                                     )
                         _        ->
                                     (head es
                                     ,[UnResolved
                                         _originalSelf (domain _refEnvironment)
                                         (GHError_NameClashError _rangeIself _originalSelf es)
                                      ]
                                     )
            -- "./Names.inc.lag"(line 345, column 9)
            (_refEnvironment@_) =
                case _lhsInameType of
                  Ref_Val  _ -> _lhsIknownValues
                  Ref_Typ  _ -> _lhsIknownTypes
                  Ref_Kind _ -> _lhsIknownKinds
                  _          -> internalError $
                                   "Names.Name.Operator.loc.refEnvironment: definition treated as reference `"
                                      ++ unPretty (ppName _originalSelf) ++ "'"
            -- "./Names.inc.lag"(line 340, column 13)
            ((_entity_def@_,_r_def@_)) =
                let new_entity = Name_Operator _rangeIself _module_def name_
                in  (new_entity,[Defined new_entity])
            -- "./Names.inc.lag"(line 333, column 9)
            (_module_def@_) =
                case _moduleIself of
                  [] | _lhsItoplevel ->
                                        _lhsIcurrentModule
                     | otherwise     ->
                                        []
                  m  -> m
            -- "./Names.inc.lag"(line 321, column 13)
            ((_entityName@_,_res@_)) =
                if isDef _lhsInameType then
                  (_entity_def,_r_def)
                else if isRef _lhsInameType then
                  (_entity_ref,_r_ref)
                else (internalError $
                        "Names.Name.Operator.refEnvironment: non-resolved name used `"
                           ++ unPretty (ppName _originalSelf) ++ "'"
                     ,[]
                     )
            -- use rule
            (_lhsOres@_) =
                _res
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _moduleIconstructors_collect
            -- copy rule (up)
            (_lhsOentityName@_) =
                _entityName
            -- copy rule (up)
            (_lhsOfullName@_) =
                _fullName
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _moduleIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _moduleImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _moduleImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _moduleImoduleValues
            -- copy rule (up)
            (_lhsOoriginalSelf@_) =
                _originalSelf
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_moduleOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_moduleOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_moduleOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_moduleOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_moduleOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_moduleOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_moduleOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_moduleOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_moduleOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_moduleOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_moduleOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_moduleOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_moduleOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_moduleOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_moduleOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_moduleOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_moduleOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_moduleOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_moduleOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_moduleOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_moduleOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOentityName,_lhsOfullName,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOoriginalSelf,_lhsOres,_lhsOself)
sem_Name_Special :: (T_Range) ->
                    (T_Strings) ->
                    (String) ->
                    (T_Name)
sem_Name_Special (range_) (module_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOentityName :: (Name)
            _lhsOfullName :: (Name)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOoriginalSelf :: (Name)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Name)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _moduleIconstructors_collect :: (FMap Name Names)
            _moduleIknownKinds_collect :: (FMap Name [Name])
            _moduleIknownTypes_collect :: (FMap Name [Name])
            _moduleIknownValues_collect :: (FMap Name [Name])
            _moduleIlabels_collect :: (FMap Name Names)
            _moduleImethods_collect :: (FMap Name Names)
            _moduleImoduleTypes :: (FMap ModuleName [Name])
            _moduleImoduleValues :: (FMap ModuleName [Name])
            _moduleImodules :: (Set.Set Strings)
            _moduleIres :: ([ResolveResult])
            _moduleIself :: (Strings)
            _moduleOclassname :: (Maybe Name)
            _moduleOconstructors_collect :: (FMap Name Names)
            _moduleOconstructors_dist :: (FMap Name Names)
            _moduleOcurrentModule :: (Strings)
            _moduleOimportedModule :: (Bool)
            _moduleOinstancename :: (Maybe Name)
            _moduleOknownKinds :: (FMap Name [Name])
            _moduleOknownKinds_collect :: (FMap Name [Name])
            _moduleOknownTypes :: (FMap Name [Name])
            _moduleOknownTypes_collect :: (FMap Name [Name])
            _moduleOknownValues :: (FMap Name [Name])
            _moduleOknownValues_collect :: (FMap Name [Name])
            _moduleOlabels_collect :: (FMap Name Names)
            _moduleOlabels_dist :: (FMap Name Names)
            _moduleOlocal :: (Bool)
            _moduleOmethods_collect :: (FMap Name Names)
            _moduleOmethods_dist :: (FMap Name Names)
            _moduleOmoduleTypes :: (FMap ModuleName [Name])
            _moduleOmoduleValues :: (FMap ModuleName [Name])
            _moduleOnameType :: (NameType)
            _moduleOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _moduleIconstructors_collect,_moduleIknownKinds_collect,_moduleIknownTypes_collect,_moduleIknownValues_collect,_moduleIlabels_collect,_moduleImethods_collect,_moduleImoduleTypes,_moduleImoduleValues,_moduleImodules,_moduleIres,_moduleIself) =
                (module_ (_moduleOclassname)
                         (_moduleOconstructors_collect)
                         (_moduleOconstructors_dist)
                         (_moduleOcurrentModule)
                         (_moduleOimportedModule)
                         (_moduleOinstancename)
                         (_moduleOknownKinds)
                         (_moduleOknownKinds_collect)
                         (_moduleOknownTypes)
                         (_moduleOknownTypes_collect)
                         (_moduleOknownValues)
                         (_moduleOknownValues_collect)
                         (_moduleOlabels_collect)
                         (_moduleOlabels_dist)
                         (_moduleOlocal)
                         (_moduleOmethods_collect)
                         (_moduleOmethods_dist)
                         (_moduleOmoduleTypes)
                         (_moduleOmoduleValues)
                         (_moduleOnameType)
                         (_moduleOtoplevel))
            -- "NameReplace.lag"(line 92, column 9)
            (_lhsOself@_) =
                _self
            -- "NameReplace.lag"(line 86, column 9)
            (_self@_) =
                if _lhsInameType == NameType_None then
                  _originalSelf
                else
                  Name_Entity _rangeIself _entityName
                    (if _lhsIlocal then (MaybeName_Just _originalSelf)
                                   else MaybeName_Nothing)
            -- "./Names.inc.lag"(line 81, column 9)
            (_originalSelf@_) =
                Name_Special    _rangeIself _moduleIself name_
            -- "./Names.inc.lag"(line 80, column 9)
            (_fullName@_) =
                Name_Special    _rangeIself _realModule  name_
            -- "./Names.inc.lag"(line 79, column 9)
            (_realModule@_) =
                if null _moduleIself then _lhsIcurrentModule else _moduleIself
            -- "./Names.inc.lag"(line 495, column 9)
            (_lhsOmodules@_) =
                if _lhsIimportedModule then
                  if not (null _moduleIself) then
                    Set.unitSet _moduleIself
                  else if isDef _lhsInameType then
                    Set.unitSet _lhsIcurrentModule
                  else
                    Set.emptySet
                else
                  Set.emptySet
            -- "./Names.inc.lag"(line 486, column 9)
            (_lhsOknownKinds_collect@_) =
                case _lhsInameType of
                  Def_Kind -> foldl addLReplace _lhsIknownKinds_collect
                                    [(_originalSelf,[_entityName])
                                    ,(_fullName    ,[_entityName])
                                    ]
                  _        -> _lhsIknownKinds_collect
            -- "./Names.inc.lag"(line 479, column 9)
            (_lhsOknownTypes_collect@_) =
                case _lhsInameType of
                  Def_Typ  -> foldl addLReplace _lhsIknownTypes_collect
                                    [(_originalSelf,[_entityName])
                                    ,(_fullName    ,[_entityName])
                                    ]
                  _        -> _lhsIknownTypes_collect
            -- "./Names.inc.lag"(line 472, column 9)
            (_lhsOknownValues_collect@_) =
                case _lhsInameType of
                  Def_Val  -> foldl addLReplace _lhsIknownValues_collect
                                    [(_originalSelf,[_entityName])
                                    ,(_fullName    ,[_entityName])
                                    ]
                  _        -> _lhsIknownValues_collect
            -- "./Names.inc.lag"(line 447, column 13)
            ((_entity_ref@_,_r_ref@_)) =
                if _lhsIimportedModule then
                   (_entity_def,[Resolved _originalSelf _entity_def])
                else
                   let es = findL _refEnvironment _originalSelf
                   in  case es of
                         [entity] ->
                                     (entity,[Resolved _originalSelf entity])
                         []       ->
                                     (Name_Special _rangeIself [] name_
                                     ,[UnResolved
                                         _originalSelf (domain _refEnvironment)
                                         (GHError_ResolveError _rangeIself _originalSelf)
                                      ]
                                     )
                         _        ->
                                     (head es
                                     ,[UnResolved
                                         _originalSelf (domain _refEnvironment)
                                         (GHError_NameClashError _rangeIself _originalSelf es)
                                      ]
                                     )
            -- "./Names.inc.lag"(line 439, column 9)
            (_refEnvironment@_) =
                case _lhsInameType of
                  Ref_Val  _ -> _lhsIknownValues
                  Ref_Typ  _ -> _lhsIknownTypes
                  Ref_Kind _ -> _lhsIknownKinds
                  _          -> internalError $
                                   "Names.Name.Special.loc.refEnvironment: definition treated as reference `"
                                      ++ unPretty (ppName _originalSelf) ++ "'"
            -- "./Names.inc.lag"(line 434, column 13)
            ((_entity_def@_,_r_def@_)) =
                let new_entity = Name_Special _rangeIself _module_def name_
                in  (new_entity,[Defined new_entity])
            -- "./Names.inc.lag"(line 427, column 9)
            (_module_def@_) =
                case _moduleIself of
                  [] | _lhsItoplevel ->
                                        _lhsIcurrentModule
                     | otherwise     ->
                                        []
                  m  -> m
            -- "./Names.inc.lag"(line 415, column 13)
            ((_entityName@_,_res@_)) =
                if isDef _lhsInameType then
                  (_entity_def,_r_def)
                else if isRef _lhsInameType then
                  (_entity_ref,_r_ref)
                else (internalError $
                        "Names.Name.Special.refEnvironment: non-resolved name used `"
                           ++ unPretty (ppName _originalSelf) ++ "'"
                     ,[]
                     )
            -- use rule
            (_lhsOres@_) =
                _res
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _moduleIconstructors_collect
            -- copy rule (up)
            (_lhsOentityName@_) =
                _entityName
            -- copy rule (up)
            (_lhsOfullName@_) =
                _fullName
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _moduleIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _moduleImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _moduleImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _moduleImoduleValues
            -- copy rule (up)
            (_lhsOoriginalSelf@_) =
                _originalSelf
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_moduleOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_moduleOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_moduleOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_moduleOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_moduleOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_moduleOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_moduleOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_moduleOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_moduleOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_moduleOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_moduleOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_moduleOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_moduleOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_moduleOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_moduleOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_moduleOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_moduleOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_moduleOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_moduleOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_moduleOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_moduleOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOentityName,_lhsOfullName,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOoriginalSelf,_lhsOres,_lhsOself)
-- Names -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      originalSelf         : Names
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for Names.Cons:
      self

-}
{-
   local variables for Names.Nil:
      self

-}
-- semantic domain
type T_Names = (Maybe Name) ->
               (FMap Name Names) ->
               (FMap Name Names) ->
               (Strings) ->
               (Bool) ->
               (Maybe Name) ->
               (FMap Name [Name]) ->
               (FMap Name [Name]) ->
               (FMap Name [Name]) ->
               (FMap Name [Name]) ->
               (FMap Name [Name]) ->
               (FMap Name [Name]) ->
               (FMap Name Names) ->
               (FMap Name Names) ->
               (Bool) ->
               (FMap Name Names) ->
               (FMap Name Names) ->
               (FMap ModuleName [Name]) ->
               (FMap ModuleName [Name]) ->
               (NameType) ->
               (Bool) ->
               ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),(Names),([ResolveResult]),(Names))
-- cata
sem_Names :: (Names) ->
             (T_Names)
sem_Names (list) =
    (foldr (sem_Names_Cons) (sem_Names_Nil) ((map sem_Name list)))
sem_Names_Cons :: (T_Name) ->
                  (T_Names) ->
                  (T_Names)
sem_Names_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOoriginalSelf :: (Names)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Names)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIentityName :: (Name)
            _hdIfullName :: (Name)
            _hdIknownKinds_collect :: (FMap Name [Name])
            _hdIknownTypes_collect :: (FMap Name [Name])
            _hdIknownValues_collect :: (FMap Name [Name])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdImoduleTypes :: (FMap ModuleName [Name])
            _hdImoduleValues :: (FMap ModuleName [Name])
            _hdImodules :: (Set.Set Strings)
            _hdIoriginalSelf :: (Name)
            _hdIres :: ([ResolveResult])
            _hdIself :: (Name)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOknownKinds :: (FMap Name [Name])
            _hdOknownKinds_collect :: (FMap Name [Name])
            _hdOknownTypes :: (FMap Name [Name])
            _hdOknownTypes_collect :: (FMap Name [Name])
            _hdOknownValues :: (FMap Name [Name])
            _hdOknownValues_collect :: (FMap Name [Name])
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmoduleTypes :: (FMap ModuleName [Name])
            _hdOmoduleValues :: (FMap ModuleName [Name])
            _hdOnameType :: (NameType)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIknownKinds_collect :: (FMap Name [Name])
            _tlIknownTypes_collect :: (FMap Name [Name])
            _tlIknownValues_collect :: (FMap Name [Name])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlImoduleTypes :: (FMap ModuleName [Name])
            _tlImoduleValues :: (FMap ModuleName [Name])
            _tlImodules :: (Set.Set Strings)
            _tlIoriginalSelf :: (Names)
            _tlIres :: ([ResolveResult])
            _tlIself :: (Names)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOknownKinds :: (FMap Name [Name])
            _tlOknownKinds_collect :: (FMap Name [Name])
            _tlOknownTypes :: (FMap Name [Name])
            _tlOknownTypes_collect :: (FMap Name [Name])
            _tlOknownValues :: (FMap Name [Name])
            _tlOknownValues_collect :: (FMap Name [Name])
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmoduleTypes :: (FMap ModuleName [Name])
            _tlOmoduleValues :: (FMap ModuleName [Name])
            _tlOnameType :: (NameType)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIentityName,_hdIfullName,_hdIknownKinds_collect,_hdIknownTypes_collect,_hdIknownValues_collect,_hdIlabels_collect,_hdImethods_collect,_hdImoduleTypes,_hdImoduleValues,_hdImodules,_hdIoriginalSelf,_hdIres,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOimportedModule) (_hdOinstancename) (_hdOknownKinds) (_hdOknownKinds_collect) (_hdOknownTypes) (_hdOknownTypes_collect) (_hdOknownValues) (_hdOknownValues_collect) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOmoduleTypes) (_hdOmoduleValues) (_hdOnameType) (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIknownKinds_collect,_tlIknownTypes_collect,_tlIknownValues_collect,_tlIlabels_collect,_tlImethods_collect,_tlImoduleTypes,_tlImoduleValues,_tlImodules,_tlIoriginalSelf,_tlIres,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOimportedModule) (_tlOinstancename) (_tlOknownKinds) (_tlOknownKinds_collect) (_tlOknownTypes) (_tlOknownTypes_collect) (_tlOknownValues) (_tlOknownValues_collect) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOmoduleTypes) (_tlOmoduleValues) (_tlOnameType) (_tlOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _hdImodules `Set.union` _tlImodules
            -- use rule
            (_lhsOoriginalSelf@_) =
                _hdIoriginalSelf : _tlIoriginalSelf
            -- use rule
            (_lhsOres@_) =
                _hdIres ++ _tlIres
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _tlIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _tlIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _tlIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _tlImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _tlImoduleValues
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_hdOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_hdOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_hdOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_hdOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_hdOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_hdOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_hdOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_tlOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_tlOknownKinds_collect@_) =
                _hdIknownKinds_collect
            -- copy rule (down)
            (_tlOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_tlOknownTypes_collect@_) =
                _hdIknownTypes_collect
            -- copy rule (down)
            (_tlOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_tlOknownValues_collect@_) =
                _hdIknownValues_collect
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_tlOmoduleTypes@_) =
                _hdImoduleTypes
            -- copy rule (chain)
            (_tlOmoduleValues@_) =
                _hdImoduleValues
            -- copy rule (down)
            (_tlOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOoriginalSelf,_lhsOres,_lhsOself)
sem_Names_Nil :: (T_Names)
sem_Names_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOoriginalSelf :: (Names)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Names)
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOoriginalSelf@_) =
                []
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOoriginalSelf,_lhsOres,_lhsOself)
-- Pattern -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      name                 : Name
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for Pattern.As:
      self

-}
{-
   local variables for Pattern.Constructor:
      self

-}
{-
   local variables for Pattern.InfixConstructor:
      self

-}
{-
   local variables for Pattern.Irrefutable:
      self

-}
{-
   local variables for Pattern.List:
      self

-}
{-
   local variables for Pattern.Literal:
      self

-}
{-
   local variables for Pattern.Negate:
      self

-}
{-
   local variables for Pattern.Parenthesized:
      self

-}
{-
   local variables for Pattern.Record:
      self

-}
{-
   local variables for Pattern.Successor:
      self

-}
{-
   local variables for Pattern.Tuple:
      self

-}
{-
   local variables for Pattern.Variable:
      self

-}
{-
   local variables for Pattern.Wildcard:
      self

-}
-- semantic domain
type T_Pattern = (Maybe Name) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Strings) ->
                 (Bool) ->
                 (Maybe Name) ->
                 (FMap Name [Name]) ->
                 (FMap Name [Name]) ->
                 (FMap Name [Name]) ->
                 (FMap Name [Name]) ->
                 (FMap Name [Name]) ->
                 (FMap Name [Name]) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Bool) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (FMap ModuleName [Name]) ->
                 (FMap ModuleName [Name]) ->
                 (NameType) ->
                 (Bool) ->
                 ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),(Name),([ResolveResult]),(Pattern))
-- cata
sem_Pattern :: (Pattern) ->
               (T_Pattern)
sem_Pattern ((Pattern_As (_range) (_name) (_pattern))) =
    (sem_Pattern_As ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_Constructor (_range) (_name) (_patterns))) =
    (sem_Pattern_Constructor ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Patterns (_patterns))))
sem_Pattern ((Pattern_InfixConstructor (_range) (_leftPattern) (_constructorOperator) (_rightPattern))) =
    (sem_Pattern_InfixConstructor ((sem_Range (_range))) ((sem_Pattern (_leftPattern))) ((sem_Name (_constructorOperator))) ((sem_Pattern (_rightPattern))))
sem_Pattern ((Pattern_Irrefutable (_range) (_pattern))) =
    (sem_Pattern_Irrefutable ((sem_Range (_range))) ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_List (_range) (_patterns))) =
    (sem_Pattern_List ((sem_Range (_range))) ((sem_Patterns (_patterns))))
sem_Pattern ((Pattern_Literal (_range) (_literal))) =
    (sem_Pattern_Literal ((sem_Range (_range))) ((sem_Literal (_literal))))
sem_Pattern ((Pattern_Negate (_range) (_literal))) =
    (sem_Pattern_Negate ((sem_Range (_range))) ((sem_Literal (_literal))))
sem_Pattern ((Pattern_Parenthesized (_range) (_pattern))) =
    (sem_Pattern_Parenthesized ((sem_Range (_range))) ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_Record (_range) (_name) (_recordPatternBindings))) =
    (sem_Pattern_Record ((sem_Range (_range))) ((sem_Name (_name))) ((sem_RecordPatternBindings (_recordPatternBindings))))
sem_Pattern ((Pattern_Successor (_range) (_name) (_literal))) =
    (sem_Pattern_Successor ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Literal (_literal))))
sem_Pattern ((Pattern_Tuple (_range) (_patterns))) =
    (sem_Pattern_Tuple ((sem_Range (_range))) ((sem_Patterns (_patterns))))
sem_Pattern ((Pattern_Variable (_range) (_name))) =
    (sem_Pattern_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Pattern ((Pattern_Wildcard (_range))) =
    (sem_Pattern_Wildcard ((sem_Range (_range))))
sem_Pattern_As :: (T_Range) ->
                  (T_Name) ->
                  (T_Pattern) ->
                  (T_Pattern)
sem_Pattern_As (range_) (name_) (pattern_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOname :: (Name)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _patternIconstructors_collect :: (FMap Name Names)
            _patternIknownKinds_collect :: (FMap Name [Name])
            _patternIknownTypes_collect :: (FMap Name [Name])
            _patternIknownValues_collect :: (FMap Name [Name])
            _patternIlabels_collect :: (FMap Name Names)
            _patternImethods_collect :: (FMap Name Names)
            _patternImoduleTypes :: (FMap ModuleName [Name])
            _patternImoduleValues :: (FMap ModuleName [Name])
            _patternImodules :: (Set.Set Strings)
            _patternIname :: (Name)
            _patternIres :: ([ResolveResult])
            _patternIself :: (Pattern)
            _patternOclassname :: (Maybe Name)
            _patternOconstructors_collect :: (FMap Name Names)
            _patternOconstructors_dist :: (FMap Name Names)
            _patternOcurrentModule :: (Strings)
            _patternOimportedModule :: (Bool)
            _patternOinstancename :: (Maybe Name)
            _patternOknownKinds :: (FMap Name [Name])
            _patternOknownKinds_collect :: (FMap Name [Name])
            _patternOknownTypes :: (FMap Name [Name])
            _patternOknownTypes_collect :: (FMap Name [Name])
            _patternOknownValues :: (FMap Name [Name])
            _patternOknownValues_collect :: (FMap Name [Name])
            _patternOlabels_collect :: (FMap Name Names)
            _patternOlabels_dist :: (FMap Name Names)
            _patternOlocal :: (Bool)
            _patternOmethods_collect :: (FMap Name Names)
            _patternOmethods_dist :: (FMap Name Names)
            _patternOmoduleTypes :: (FMap ModuleName [Name])
            _patternOmoduleValues :: (FMap ModuleName [Name])
            _patternOnameType :: (NameType)
            _patternOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _patternIconstructors_collect,_patternIknownKinds_collect,_patternIknownTypes_collect,_patternIknownValues_collect,_patternIlabels_collect,_patternImethods_collect,_patternImoduleTypes,_patternImoduleValues,_patternImodules,_patternIname,_patternIres,_patternIself) =
                (pattern_ (_patternOclassname)
                          (_patternOconstructors_collect)
                          (_patternOconstructors_dist)
                          (_patternOcurrentModule)
                          (_patternOimportedModule)
                          (_patternOinstancename)
                          (_patternOknownKinds)
                          (_patternOknownKinds_collect)
                          (_patternOknownTypes)
                          (_patternOknownTypes_collect)
                          (_patternOknownValues)
                          (_patternOknownValues_collect)
                          (_patternOlabels_collect)
                          (_patternOlabels_dist)
                          (_patternOlocal)
                          (_patternOmethods_collect)
                          (_patternOmethods_dist)
                          (_patternOmoduleTypes)
                          (_patternOmoduleValues)
                          (_patternOnameType)
                          (_patternOtoplevel))
            -- "./NameTypes.inc.lag"(line 172, column 9)
            (_nameOnameType@_) =
                Def_Val
            -- "./ModuleInformation.inc.lag"(line 462, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.Pattern.As.name: pattern binding in class/instance"
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _patternImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _patternIres
            -- self rule
            (_self@_) =
                Pattern_As _rangeIself _nameIself _patternIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _patternIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _patternIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _patternIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _patternIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _patternIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _patternImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _patternImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _patternImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_patternOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_patternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_patternOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_patternOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_patternOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (down)
            (_patternOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_patternOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_patternOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_patternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_patternOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_patternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_patternOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_patternOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_patternOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_patternOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOname,_lhsOres,_lhsOself)
sem_Pattern_Constructor :: (T_Range) ->
                           (T_Name) ->
                           (T_Patterns) ->
                           (T_Pattern)
sem_Pattern_Constructor (range_) (name_) (patterns_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOname :: (Name)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _patternsIconstructors_collect :: (FMap Name Names)
            _patternsIknownKinds_collect :: (FMap Name [Name])
            _patternsIknownTypes_collect :: (FMap Name [Name])
            _patternsIknownValues_collect :: (FMap Name [Name])
            _patternsIlabels_collect :: (FMap Name Names)
            _patternsImethods_collect :: (FMap Name Names)
            _patternsImoduleTypes :: (FMap ModuleName [Name])
            _patternsImoduleValues :: (FMap ModuleName [Name])
            _patternsImodules :: (Set.Set Strings)
            _patternsIres :: ([ResolveResult])
            _patternsIself :: (Patterns)
            _patternsOclassname :: (Maybe Name)
            _patternsOconstructors_collect :: (FMap Name Names)
            _patternsOconstructors_dist :: (FMap Name Names)
            _patternsOcurrentModule :: (Strings)
            _patternsOimportedModule :: (Bool)
            _patternsOinstancename :: (Maybe Name)
            _patternsOknownKinds :: (FMap Name [Name])
            _patternsOknownKinds_collect :: (FMap Name [Name])
            _patternsOknownTypes :: (FMap Name [Name])
            _patternsOknownTypes_collect :: (FMap Name [Name])
            _patternsOknownValues :: (FMap Name [Name])
            _patternsOknownValues_collect :: (FMap Name [Name])
            _patternsOlabels_collect :: (FMap Name Names)
            _patternsOlabels_dist :: (FMap Name Names)
            _patternsOlocal :: (Bool)
            _patternsOmethods_collect :: (FMap Name Names)
            _patternsOmethods_dist :: (FMap Name Names)
            _patternsOmoduleTypes :: (FMap ModuleName [Name])
            _patternsOmoduleValues :: (FMap ModuleName [Name])
            _patternsOnameType :: (NameType)
            _patternsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _patternsIconstructors_collect,_patternsIknownKinds_collect,_patternsIknownTypes_collect,_patternsIknownValues_collect,_patternsIlabels_collect,_patternsImethods_collect,_patternsImoduleTypes,_patternsImoduleValues,_patternsImodules,_patternsIres,_patternsIself) =
                (patterns_ (_patternsOclassname)
                           (_patternsOconstructors_collect)
                           (_patternsOconstructors_dist)
                           (_patternsOcurrentModule)
                           (_patternsOimportedModule)
                           (_patternsOinstancename)
                           (_patternsOknownKinds)
                           (_patternsOknownKinds_collect)
                           (_patternsOknownTypes)
                           (_patternsOknownTypes_collect)
                           (_patternsOknownValues)
                           (_patternsOknownValues_collect)
                           (_patternsOlabels_collect)
                           (_patternsOlabels_dist)
                           (_patternsOlocal)
                           (_patternsOmethods_collect)
                           (_patternsOmethods_dist)
                           (_patternsOmoduleTypes)
                           (_patternsOmoduleValues)
                           (_patternsOnameType)
                           (_patternsOtoplevel))
            -- "./NameTypes.inc.lag"(line 165, column 9)
            (_nameOnameType@_) =
                ref_Val
            -- "./ModuleInformation.inc.lag"(line 444, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.Pattern.Constructor.name: pattern binding in class/instance"
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _patternsImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _patternsIres
            -- self rule
            (_self@_) =
                Pattern_Constructor _rangeIself _nameIself _patternsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _patternsIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _patternsIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _patternsIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _patternsIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _patternsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _patternsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _patternsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _patternsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_patternsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_patternsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_patternsOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_patternsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_patternsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (down)
            (_patternsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_patternsOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_patternsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_patternsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_patternsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_patternsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_patternsOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_patternsOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_patternsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_patternsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOname,_lhsOres,_lhsOself)
sem_Pattern_InfixConstructor :: (T_Range) ->
                                (T_Pattern) ->
                                (T_Name) ->
                                (T_Pattern) ->
                                (T_Pattern)
sem_Pattern_InfixConstructor (range_) (leftPattern_) (constructorOperator_) (rightPattern_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOname :: (Name)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _leftPatternIconstructors_collect :: (FMap Name Names)
            _leftPatternIknownKinds_collect :: (FMap Name [Name])
            _leftPatternIknownTypes_collect :: (FMap Name [Name])
            _leftPatternIknownValues_collect :: (FMap Name [Name])
            _leftPatternIlabels_collect :: (FMap Name Names)
            _leftPatternImethods_collect :: (FMap Name Names)
            _leftPatternImoduleTypes :: (FMap ModuleName [Name])
            _leftPatternImoduleValues :: (FMap ModuleName [Name])
            _leftPatternImodules :: (Set.Set Strings)
            _leftPatternIname :: (Name)
            _leftPatternIres :: ([ResolveResult])
            _leftPatternIself :: (Pattern)
            _leftPatternOclassname :: (Maybe Name)
            _leftPatternOconstructors_collect :: (FMap Name Names)
            _leftPatternOconstructors_dist :: (FMap Name Names)
            _leftPatternOcurrentModule :: (Strings)
            _leftPatternOimportedModule :: (Bool)
            _leftPatternOinstancename :: (Maybe Name)
            _leftPatternOknownKinds :: (FMap Name [Name])
            _leftPatternOknownKinds_collect :: (FMap Name [Name])
            _leftPatternOknownTypes :: (FMap Name [Name])
            _leftPatternOknownTypes_collect :: (FMap Name [Name])
            _leftPatternOknownValues :: (FMap Name [Name])
            _leftPatternOknownValues_collect :: (FMap Name [Name])
            _leftPatternOlabels_collect :: (FMap Name Names)
            _leftPatternOlabels_dist :: (FMap Name Names)
            _leftPatternOlocal :: (Bool)
            _leftPatternOmethods_collect :: (FMap Name Names)
            _leftPatternOmethods_dist :: (FMap Name Names)
            _leftPatternOmoduleTypes :: (FMap ModuleName [Name])
            _leftPatternOmoduleValues :: (FMap ModuleName [Name])
            _leftPatternOnameType :: (NameType)
            _leftPatternOtoplevel :: (Bool)
            _constructorOperatorIconstructors_collect :: (FMap Name Names)
            _constructorOperatorIentityName :: (Name)
            _constructorOperatorIfullName :: (Name)
            _constructorOperatorIknownKinds_collect :: (FMap Name [Name])
            _constructorOperatorIknownTypes_collect :: (FMap Name [Name])
            _constructorOperatorIknownValues_collect :: (FMap Name [Name])
            _constructorOperatorIlabels_collect :: (FMap Name Names)
            _constructorOperatorImethods_collect :: (FMap Name Names)
            _constructorOperatorImoduleTypes :: (FMap ModuleName [Name])
            _constructorOperatorImoduleValues :: (FMap ModuleName [Name])
            _constructorOperatorImodules :: (Set.Set Strings)
            _constructorOperatorIoriginalSelf :: (Name)
            _constructorOperatorIres :: ([ResolveResult])
            _constructorOperatorIself :: (Name)
            _constructorOperatorOclassname :: (Maybe Name)
            _constructorOperatorOconstructors_collect :: (FMap Name Names)
            _constructorOperatorOconstructors_dist :: (FMap Name Names)
            _constructorOperatorOcurrentModule :: (Strings)
            _constructorOperatorOimportedModule :: (Bool)
            _constructorOperatorOinstancename :: (Maybe Name)
            _constructorOperatorOknownKinds :: (FMap Name [Name])
            _constructorOperatorOknownKinds_collect :: (FMap Name [Name])
            _constructorOperatorOknownTypes :: (FMap Name [Name])
            _constructorOperatorOknownTypes_collect :: (FMap Name [Name])
            _constructorOperatorOknownValues :: (FMap Name [Name])
            _constructorOperatorOknownValues_collect :: (FMap Name [Name])
            _constructorOperatorOlabels_collect :: (FMap Name Names)
            _constructorOperatorOlabels_dist :: (FMap Name Names)
            _constructorOperatorOlocal :: (Bool)
            _constructorOperatorOmethods_collect :: (FMap Name Names)
            _constructorOperatorOmethods_dist :: (FMap Name Names)
            _constructorOperatorOmoduleTypes :: (FMap ModuleName [Name])
            _constructorOperatorOmoduleValues :: (FMap ModuleName [Name])
            _constructorOperatorOnameType :: (NameType)
            _constructorOperatorOtoplevel :: (Bool)
            _rightPatternIconstructors_collect :: (FMap Name Names)
            _rightPatternIknownKinds_collect :: (FMap Name [Name])
            _rightPatternIknownTypes_collect :: (FMap Name [Name])
            _rightPatternIknownValues_collect :: (FMap Name [Name])
            _rightPatternIlabels_collect :: (FMap Name Names)
            _rightPatternImethods_collect :: (FMap Name Names)
            _rightPatternImoduleTypes :: (FMap ModuleName [Name])
            _rightPatternImoduleValues :: (FMap ModuleName [Name])
            _rightPatternImodules :: (Set.Set Strings)
            _rightPatternIname :: (Name)
            _rightPatternIres :: ([ResolveResult])
            _rightPatternIself :: (Pattern)
            _rightPatternOclassname :: (Maybe Name)
            _rightPatternOconstructors_collect :: (FMap Name Names)
            _rightPatternOconstructors_dist :: (FMap Name Names)
            _rightPatternOcurrentModule :: (Strings)
            _rightPatternOimportedModule :: (Bool)
            _rightPatternOinstancename :: (Maybe Name)
            _rightPatternOknownKinds :: (FMap Name [Name])
            _rightPatternOknownKinds_collect :: (FMap Name [Name])
            _rightPatternOknownTypes :: (FMap Name [Name])
            _rightPatternOknownTypes_collect :: (FMap Name [Name])
            _rightPatternOknownValues :: (FMap Name [Name])
            _rightPatternOknownValues_collect :: (FMap Name [Name])
            _rightPatternOlabels_collect :: (FMap Name Names)
            _rightPatternOlabels_dist :: (FMap Name Names)
            _rightPatternOlocal :: (Bool)
            _rightPatternOmethods_collect :: (FMap Name Names)
            _rightPatternOmethods_dist :: (FMap Name Names)
            _rightPatternOmoduleTypes :: (FMap ModuleName [Name])
            _rightPatternOmoduleValues :: (FMap ModuleName [Name])
            _rightPatternOnameType :: (NameType)
            _rightPatternOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _leftPatternIconstructors_collect,_leftPatternIknownKinds_collect,_leftPatternIknownTypes_collect,_leftPatternIknownValues_collect,_leftPatternIlabels_collect,_leftPatternImethods_collect,_leftPatternImoduleTypes,_leftPatternImoduleValues,_leftPatternImodules,_leftPatternIname,_leftPatternIres,_leftPatternIself) =
                (leftPattern_ (_leftPatternOclassname)
                              (_leftPatternOconstructors_collect)
                              (_leftPatternOconstructors_dist)
                              (_leftPatternOcurrentModule)
                              (_leftPatternOimportedModule)
                              (_leftPatternOinstancename)
                              (_leftPatternOknownKinds)
                              (_leftPatternOknownKinds_collect)
                              (_leftPatternOknownTypes)
                              (_leftPatternOknownTypes_collect)
                              (_leftPatternOknownValues)
                              (_leftPatternOknownValues_collect)
                              (_leftPatternOlabels_collect)
                              (_leftPatternOlabels_dist)
                              (_leftPatternOlocal)
                              (_leftPatternOmethods_collect)
                              (_leftPatternOmethods_dist)
                              (_leftPatternOmoduleTypes)
                              (_leftPatternOmoduleValues)
                              (_leftPatternOnameType)
                              (_leftPatternOtoplevel))
            ( _constructorOperatorIconstructors_collect
             ,_constructorOperatorIentityName
             ,_constructorOperatorIfullName
             ,_constructorOperatorIknownKinds_collect
             ,_constructorOperatorIknownTypes_collect
             ,_constructorOperatorIknownValues_collect
             ,_constructorOperatorIlabels_collect
             ,_constructorOperatorImethods_collect
             ,_constructorOperatorImoduleTypes
             ,_constructorOperatorImoduleValues
             ,_constructorOperatorImodules
             ,_constructorOperatorIoriginalSelf
             ,_constructorOperatorIres
             ,_constructorOperatorIself
             ) =
                (constructorOperator_ (_constructorOperatorOclassname)
                                      (_constructorOperatorOconstructors_collect)
                                      (_constructorOperatorOconstructors_dist)
                                      (_constructorOperatorOcurrentModule)
                                      (_constructorOperatorOimportedModule)
                                      (_constructorOperatorOinstancename)
                                      (_constructorOperatorOknownKinds)
                                      (_constructorOperatorOknownKinds_collect)
                                      (_constructorOperatorOknownTypes)
                                      (_constructorOperatorOknownTypes_collect)
                                      (_constructorOperatorOknownValues)
                                      (_constructorOperatorOknownValues_collect)
                                      (_constructorOperatorOlabels_collect)
                                      (_constructorOperatorOlabels_dist)
                                      (_constructorOperatorOlocal)
                                      (_constructorOperatorOmethods_collect)
                                      (_constructorOperatorOmethods_dist)
                                      (_constructorOperatorOmoduleTypes)
                                      (_constructorOperatorOmoduleValues)
                                      (_constructorOperatorOnameType)
                                      (_constructorOperatorOtoplevel))
            ( _rightPatternIconstructors_collect,_rightPatternIknownKinds_collect,_rightPatternIknownTypes_collect,_rightPatternIknownValues_collect,_rightPatternIlabels_collect,_rightPatternImethods_collect,_rightPatternImoduleTypes,_rightPatternImoduleValues,_rightPatternImodules,_rightPatternIname,_rightPatternIres,_rightPatternIself) =
                (rightPattern_ (_rightPatternOclassname)
                               (_rightPatternOconstructors_collect)
                               (_rightPatternOconstructors_dist)
                               (_rightPatternOcurrentModule)
                               (_rightPatternOimportedModule)
                               (_rightPatternOinstancename)
                               (_rightPatternOknownKinds)
                               (_rightPatternOknownKinds_collect)
                               (_rightPatternOknownTypes)
                               (_rightPatternOknownTypes_collect)
                               (_rightPatternOknownValues)
                               (_rightPatternOknownValues_collect)
                               (_rightPatternOlabels_collect)
                               (_rightPatternOlabels_dist)
                               (_rightPatternOlocal)
                               (_rightPatternOmethods_collect)
                               (_rightPatternOmethods_dist)
                               (_rightPatternOmoduleTypes)
                               (_rightPatternOmoduleValues)
                               (_rightPatternOnameType)
                               (_rightPatternOtoplevel))
            -- "./NameTypes.inc.lag"(line 167, column 9)
            (_constructorOperatorOnameType@_) =
                ref_Val
            -- "./ModuleInformation.inc.lag"(line 447, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.Pattern.InfixConstructor.name: pattern binding in class/instance"
            -- use rule
            (_lhsOmodules@_) =
                _leftPatternImodules `Set.union` _constructorOperatorImodules `Set.union` _rightPatternImodules
            -- use rule
            (_lhsOres@_) =
                _leftPatternIres ++ _constructorOperatorIres ++ _rightPatternIres
            -- self rule
            (_self@_) =
                Pattern_InfixConstructor _rangeIself _leftPatternIself _constructorOperatorIself _rightPatternIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _rightPatternIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _rightPatternIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _rightPatternIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _rightPatternIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _rightPatternIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _rightPatternImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _rightPatternImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _rightPatternImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_leftPatternOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_leftPatternOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_leftPatternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_leftPatternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_leftPatternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_leftPatternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_leftPatternOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_leftPatternOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_leftPatternOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_leftPatternOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_leftPatternOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_leftPatternOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_leftPatternOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_leftPatternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_leftPatternOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_leftPatternOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_leftPatternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_leftPatternOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_leftPatternOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_leftPatternOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_leftPatternOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_constructorOperatorOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_constructorOperatorOconstructors_collect@_) =
                _leftPatternIconstructors_collect
            -- copy rule (down)
            (_constructorOperatorOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_constructorOperatorOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_constructorOperatorOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_constructorOperatorOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_constructorOperatorOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_constructorOperatorOknownKinds_collect@_) =
                _leftPatternIknownKinds_collect
            -- copy rule (down)
            (_constructorOperatorOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_constructorOperatorOknownTypes_collect@_) =
                _leftPatternIknownTypes_collect
            -- copy rule (down)
            (_constructorOperatorOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_constructorOperatorOknownValues_collect@_) =
                _leftPatternIknownValues_collect
            -- copy rule (chain)
            (_constructorOperatorOlabels_collect@_) =
                _leftPatternIlabels_collect
            -- copy rule (down)
            (_constructorOperatorOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_constructorOperatorOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_constructorOperatorOmethods_collect@_) =
                _leftPatternImethods_collect
            -- copy rule (down)
            (_constructorOperatorOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_constructorOperatorOmoduleTypes@_) =
                _leftPatternImoduleTypes
            -- copy rule (chain)
            (_constructorOperatorOmoduleValues@_) =
                _leftPatternImoduleValues
            -- copy rule (down)
            (_constructorOperatorOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_rightPatternOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_rightPatternOconstructors_collect@_) =
                _constructorOperatorIconstructors_collect
            -- copy rule (down)
            (_rightPatternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_rightPatternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rightPatternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rightPatternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rightPatternOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_rightPatternOknownKinds_collect@_) =
                _constructorOperatorIknownKinds_collect
            -- copy rule (down)
            (_rightPatternOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_rightPatternOknownTypes_collect@_) =
                _constructorOperatorIknownTypes_collect
            -- copy rule (down)
            (_rightPatternOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_rightPatternOknownValues_collect@_) =
                _constructorOperatorIknownValues_collect
            -- copy rule (chain)
            (_rightPatternOlabels_collect@_) =
                _constructorOperatorIlabels_collect
            -- copy rule (down)
            (_rightPatternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_rightPatternOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_rightPatternOmethods_collect@_) =
                _constructorOperatorImethods_collect
            -- copy rule (down)
            (_rightPatternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_rightPatternOmoduleTypes@_) =
                _constructorOperatorImoduleTypes
            -- copy rule (chain)
            (_rightPatternOmoduleValues@_) =
                _constructorOperatorImoduleValues
            -- copy rule (down)
            (_rightPatternOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_rightPatternOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOname,_lhsOres,_lhsOself)
sem_Pattern_Irrefutable :: (T_Range) ->
                           (T_Pattern) ->
                           (T_Pattern)
sem_Pattern_Irrefutable (range_) (pattern_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOname :: (Name)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _patternIconstructors_collect :: (FMap Name Names)
            _patternIknownKinds_collect :: (FMap Name [Name])
            _patternIknownTypes_collect :: (FMap Name [Name])
            _patternIknownValues_collect :: (FMap Name [Name])
            _patternIlabels_collect :: (FMap Name Names)
            _patternImethods_collect :: (FMap Name Names)
            _patternImoduleTypes :: (FMap ModuleName [Name])
            _patternImoduleValues :: (FMap ModuleName [Name])
            _patternImodules :: (Set.Set Strings)
            _patternIname :: (Name)
            _patternIres :: ([ResolveResult])
            _patternIself :: (Pattern)
            _patternOclassname :: (Maybe Name)
            _patternOconstructors_collect :: (FMap Name Names)
            _patternOconstructors_dist :: (FMap Name Names)
            _patternOcurrentModule :: (Strings)
            _patternOimportedModule :: (Bool)
            _patternOinstancename :: (Maybe Name)
            _patternOknownKinds :: (FMap Name [Name])
            _patternOknownKinds_collect :: (FMap Name [Name])
            _patternOknownTypes :: (FMap Name [Name])
            _patternOknownTypes_collect :: (FMap Name [Name])
            _patternOknownValues :: (FMap Name [Name])
            _patternOknownValues_collect :: (FMap Name [Name])
            _patternOlabels_collect :: (FMap Name Names)
            _patternOlabels_dist :: (FMap Name Names)
            _patternOlocal :: (Bool)
            _patternOmethods_collect :: (FMap Name Names)
            _patternOmethods_dist :: (FMap Name Names)
            _patternOmoduleTypes :: (FMap ModuleName [Name])
            _patternOmoduleValues :: (FMap ModuleName [Name])
            _patternOnameType :: (NameType)
            _patternOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _patternIconstructors_collect,_patternIknownKinds_collect,_patternIknownTypes_collect,_patternIknownValues_collect,_patternIlabels_collect,_patternImethods_collect,_patternImoduleTypes,_patternImoduleValues,_patternImodules,_patternIname,_patternIres,_patternIself) =
                (pattern_ (_patternOclassname)
                          (_patternOconstructors_collect)
                          (_patternOconstructors_dist)
                          (_patternOcurrentModule)
                          (_patternOimportedModule)
                          (_patternOinstancename)
                          (_patternOknownKinds)
                          (_patternOknownKinds_collect)
                          (_patternOknownTypes)
                          (_patternOknownTypes_collect)
                          (_patternOknownValues)
                          (_patternOknownValues_collect)
                          (_patternOlabels_collect)
                          (_patternOlabels_dist)
                          (_patternOlocal)
                          (_patternOmethods_collect)
                          (_patternOmethods_dist)
                          (_patternOmoduleTypes)
                          (_patternOmoduleValues)
                          (_patternOnameType)
                          (_patternOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _patternImodules
            -- use rule
            (_lhsOres@_) =
                _patternIres
            -- self rule
            (_self@_) =
                Pattern_Irrefutable _rangeIself _patternIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _patternIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _patternIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _patternIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _patternIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _patternIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _patternImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _patternImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _patternImoduleValues
            -- copy rule (up)
            (_lhsOname@_) =
                _patternIname
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_patternOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_patternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_patternOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_patternOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_patternOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_patternOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_patternOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_patternOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_patternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_patternOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_patternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_patternOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_patternOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_patternOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOname,_lhsOres,_lhsOself)
sem_Pattern_List :: (T_Range) ->
                    (T_Patterns) ->
                    (T_Pattern)
sem_Pattern_List (range_) (patterns_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOname :: (Name)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _patternsIconstructors_collect :: (FMap Name Names)
            _patternsIknownKinds_collect :: (FMap Name [Name])
            _patternsIknownTypes_collect :: (FMap Name [Name])
            _patternsIknownValues_collect :: (FMap Name [Name])
            _patternsIlabels_collect :: (FMap Name Names)
            _patternsImethods_collect :: (FMap Name Names)
            _patternsImoduleTypes :: (FMap ModuleName [Name])
            _patternsImoduleValues :: (FMap ModuleName [Name])
            _patternsImodules :: (Set.Set Strings)
            _patternsIres :: ([ResolveResult])
            _patternsIself :: (Patterns)
            _patternsOclassname :: (Maybe Name)
            _patternsOconstructors_collect :: (FMap Name Names)
            _patternsOconstructors_dist :: (FMap Name Names)
            _patternsOcurrentModule :: (Strings)
            _patternsOimportedModule :: (Bool)
            _patternsOinstancename :: (Maybe Name)
            _patternsOknownKinds :: (FMap Name [Name])
            _patternsOknownKinds_collect :: (FMap Name [Name])
            _patternsOknownTypes :: (FMap Name [Name])
            _patternsOknownTypes_collect :: (FMap Name [Name])
            _patternsOknownValues :: (FMap Name [Name])
            _patternsOknownValues_collect :: (FMap Name [Name])
            _patternsOlabels_collect :: (FMap Name Names)
            _patternsOlabels_dist :: (FMap Name Names)
            _patternsOlocal :: (Bool)
            _patternsOmethods_collect :: (FMap Name Names)
            _patternsOmethods_dist :: (FMap Name Names)
            _patternsOmoduleTypes :: (FMap ModuleName [Name])
            _patternsOmoduleValues :: (FMap ModuleName [Name])
            _patternsOnameType :: (NameType)
            _patternsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _patternsIconstructors_collect,_patternsIknownKinds_collect,_patternsIknownTypes_collect,_patternsIknownValues_collect,_patternsIlabels_collect,_patternsImethods_collect,_patternsImoduleTypes,_patternsImoduleValues,_patternsImodules,_patternsIres,_patternsIself) =
                (patterns_ (_patternsOclassname)
                           (_patternsOconstructors_collect)
                           (_patternsOconstructors_dist)
                           (_patternsOcurrentModule)
                           (_patternsOimportedModule)
                           (_patternsOinstancename)
                           (_patternsOknownKinds)
                           (_patternsOknownKinds_collect)
                           (_patternsOknownTypes)
                           (_patternsOknownTypes_collect)
                           (_patternsOknownValues)
                           (_patternsOknownValues_collect)
                           (_patternsOlabels_collect)
                           (_patternsOlabels_dist)
                           (_patternsOlocal)
                           (_patternsOmethods_collect)
                           (_patternsOmethods_dist)
                           (_patternsOmoduleTypes)
                           (_patternsOmoduleValues)
                           (_patternsOnameType)
                           (_patternsOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 450, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.Pattern.List.name: pattern binding in class/instance"
            -- use rule
            (_lhsOmodules@_) =
                _patternsImodules
            -- use rule
            (_lhsOres@_) =
                _patternsIres
            -- self rule
            (_self@_) =
                Pattern_List _rangeIself _patternsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _patternsIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _patternsIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _patternsIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _patternsIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _patternsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _patternsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _patternsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _patternsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_patternsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_patternsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_patternsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_patternsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_patternsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_patternsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_patternsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_patternsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_patternsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_patternsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_patternsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_patternsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_patternsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_patternsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOname,_lhsOres,_lhsOself)
sem_Pattern_Literal :: (T_Range) ->
                       (T_Literal) ->
                       (T_Pattern)
sem_Pattern_Literal (range_) (literal_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOname :: (Name)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _literalIconstructors_collect :: (FMap Name Names)
            _literalIknownKinds_collect :: (FMap Name [Name])
            _literalIknownTypes_collect :: (FMap Name [Name])
            _literalIknownValues_collect :: (FMap Name [Name])
            _literalIlabels_collect :: (FMap Name Names)
            _literalImethods_collect :: (FMap Name Names)
            _literalImoduleTypes :: (FMap ModuleName [Name])
            _literalImoduleValues :: (FMap ModuleName [Name])
            _literalImodules :: (Set.Set Strings)
            _literalIres :: ([ResolveResult])
            _literalIself :: (Literal)
            _literalOclassname :: (Maybe Name)
            _literalOconstructors_collect :: (FMap Name Names)
            _literalOconstructors_dist :: (FMap Name Names)
            _literalOcurrentModule :: (Strings)
            _literalOimportedModule :: (Bool)
            _literalOinstancename :: (Maybe Name)
            _literalOknownKinds :: (FMap Name [Name])
            _literalOknownKinds_collect :: (FMap Name [Name])
            _literalOknownTypes :: (FMap Name [Name])
            _literalOknownTypes_collect :: (FMap Name [Name])
            _literalOknownValues :: (FMap Name [Name])
            _literalOknownValues_collect :: (FMap Name [Name])
            _literalOlabels_collect :: (FMap Name Names)
            _literalOlabels_dist :: (FMap Name Names)
            _literalOlocal :: (Bool)
            _literalOmethods_collect :: (FMap Name Names)
            _literalOmethods_dist :: (FMap Name Names)
            _literalOmoduleTypes :: (FMap ModuleName [Name])
            _literalOmoduleValues :: (FMap ModuleName [Name])
            _literalOnameType :: (NameType)
            _literalOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _literalIconstructors_collect,_literalIknownKinds_collect,_literalIknownTypes_collect,_literalIknownValues_collect,_literalIlabels_collect,_literalImethods_collect,_literalImoduleTypes,_literalImoduleValues,_literalImodules,_literalIres,_literalIself) =
                (literal_ (_literalOclassname)
                          (_literalOconstructors_collect)
                          (_literalOconstructors_dist)
                          (_literalOcurrentModule)
                          (_literalOimportedModule)
                          (_literalOinstancename)
                          (_literalOknownKinds)
                          (_literalOknownKinds_collect)
                          (_literalOknownTypes)
                          (_literalOknownTypes_collect)
                          (_literalOknownValues)
                          (_literalOknownValues_collect)
                          (_literalOlabels_collect)
                          (_literalOlabels_dist)
                          (_literalOlocal)
                          (_literalOmethods_collect)
                          (_literalOmethods_dist)
                          (_literalOmoduleTypes)
                          (_literalOmoduleValues)
                          (_literalOnameType)
                          (_literalOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 441, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.Pattern.Literal.name: pattern binding in class/instance"
            -- use rule
            (_lhsOmodules@_) =
                _literalImodules
            -- use rule
            (_lhsOres@_) =
                _literalIres
            -- self rule
            (_self@_) =
                Pattern_Literal _rangeIself _literalIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _literalIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _literalIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _literalIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _literalIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _literalIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _literalImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _literalImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _literalImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_literalOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_literalOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_literalOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_literalOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_literalOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_literalOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_literalOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_literalOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_literalOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_literalOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_literalOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_literalOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_literalOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_literalOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_literalOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_literalOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_literalOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_literalOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_literalOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_literalOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_literalOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOname,_lhsOres,_lhsOself)
sem_Pattern_Negate :: (T_Range) ->
                      (T_Literal) ->
                      (T_Pattern)
sem_Pattern_Negate (range_) (literal_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOname :: (Name)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _literalIconstructors_collect :: (FMap Name Names)
            _literalIknownKinds_collect :: (FMap Name [Name])
            _literalIknownTypes_collect :: (FMap Name [Name])
            _literalIknownValues_collect :: (FMap Name [Name])
            _literalIlabels_collect :: (FMap Name Names)
            _literalImethods_collect :: (FMap Name Names)
            _literalImoduleTypes :: (FMap ModuleName [Name])
            _literalImoduleValues :: (FMap ModuleName [Name])
            _literalImodules :: (Set.Set Strings)
            _literalIres :: ([ResolveResult])
            _literalIself :: (Literal)
            _literalOclassname :: (Maybe Name)
            _literalOconstructors_collect :: (FMap Name Names)
            _literalOconstructors_dist :: (FMap Name Names)
            _literalOcurrentModule :: (Strings)
            _literalOimportedModule :: (Bool)
            _literalOinstancename :: (Maybe Name)
            _literalOknownKinds :: (FMap Name [Name])
            _literalOknownKinds_collect :: (FMap Name [Name])
            _literalOknownTypes :: (FMap Name [Name])
            _literalOknownTypes_collect :: (FMap Name [Name])
            _literalOknownValues :: (FMap Name [Name])
            _literalOknownValues_collect :: (FMap Name [Name])
            _literalOlabels_collect :: (FMap Name Names)
            _literalOlabels_dist :: (FMap Name Names)
            _literalOlocal :: (Bool)
            _literalOmethods_collect :: (FMap Name Names)
            _literalOmethods_dist :: (FMap Name Names)
            _literalOmoduleTypes :: (FMap ModuleName [Name])
            _literalOmoduleValues :: (FMap ModuleName [Name])
            _literalOnameType :: (NameType)
            _literalOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _literalIconstructors_collect,_literalIknownKinds_collect,_literalIknownTypes_collect,_literalIknownValues_collect,_literalIlabels_collect,_literalImethods_collect,_literalImoduleTypes,_literalImoduleValues,_literalImodules,_literalIres,_literalIself) =
                (literal_ (_literalOclassname)
                          (_literalOconstructors_collect)
                          (_literalOconstructors_dist)
                          (_literalOcurrentModule)
                          (_literalOimportedModule)
                          (_literalOinstancename)
                          (_literalOknownKinds)
                          (_literalOknownKinds_collect)
                          (_literalOknownTypes)
                          (_literalOknownTypes_collect)
                          (_literalOknownValues)
                          (_literalOknownValues_collect)
                          (_literalOlabels_collect)
                          (_literalOlabels_dist)
                          (_literalOlocal)
                          (_literalOmethods_collect)
                          (_literalOmethods_dist)
                          (_literalOmoduleTypes)
                          (_literalOmoduleValues)
                          (_literalOnameType)
                          (_literalOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 459, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.Pattern.Negate.name: pattern binding in class/instance"
            -- use rule
            (_lhsOmodules@_) =
                _literalImodules
            -- use rule
            (_lhsOres@_) =
                _literalIres
            -- self rule
            (_self@_) =
                Pattern_Negate _rangeIself _literalIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _literalIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _literalIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _literalIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _literalIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _literalIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _literalImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _literalImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _literalImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_literalOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_literalOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_literalOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_literalOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_literalOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_literalOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_literalOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_literalOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_literalOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_literalOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_literalOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_literalOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_literalOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_literalOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_literalOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_literalOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_literalOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_literalOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_literalOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_literalOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_literalOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOname,_lhsOres,_lhsOself)
sem_Pattern_Parenthesized :: (T_Range) ->
                             (T_Pattern) ->
                             (T_Pattern)
sem_Pattern_Parenthesized (range_) (pattern_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOname :: (Name)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _patternIconstructors_collect :: (FMap Name Names)
            _patternIknownKinds_collect :: (FMap Name [Name])
            _patternIknownTypes_collect :: (FMap Name [Name])
            _patternIknownValues_collect :: (FMap Name [Name])
            _patternIlabels_collect :: (FMap Name Names)
            _patternImethods_collect :: (FMap Name Names)
            _patternImoduleTypes :: (FMap ModuleName [Name])
            _patternImoduleValues :: (FMap ModuleName [Name])
            _patternImodules :: (Set.Set Strings)
            _patternIname :: (Name)
            _patternIres :: ([ResolveResult])
            _patternIself :: (Pattern)
            _patternOclassname :: (Maybe Name)
            _patternOconstructors_collect :: (FMap Name Names)
            _patternOconstructors_dist :: (FMap Name Names)
            _patternOcurrentModule :: (Strings)
            _patternOimportedModule :: (Bool)
            _patternOinstancename :: (Maybe Name)
            _patternOknownKinds :: (FMap Name [Name])
            _patternOknownKinds_collect :: (FMap Name [Name])
            _patternOknownTypes :: (FMap Name [Name])
            _patternOknownTypes_collect :: (FMap Name [Name])
            _patternOknownValues :: (FMap Name [Name])
            _patternOknownValues_collect :: (FMap Name [Name])
            _patternOlabels_collect :: (FMap Name Names)
            _patternOlabels_dist :: (FMap Name Names)
            _patternOlocal :: (Bool)
            _patternOmethods_collect :: (FMap Name Names)
            _patternOmethods_dist :: (FMap Name Names)
            _patternOmoduleTypes :: (FMap ModuleName [Name])
            _patternOmoduleValues :: (FMap ModuleName [Name])
            _patternOnameType :: (NameType)
            _patternOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _patternIconstructors_collect,_patternIknownKinds_collect,_patternIknownTypes_collect,_patternIknownValues_collect,_patternIlabels_collect,_patternImethods_collect,_patternImoduleTypes,_patternImoduleValues,_patternImodules,_patternIname,_patternIres,_patternIself) =
                (pattern_ (_patternOclassname)
                          (_patternOconstructors_collect)
                          (_patternOconstructors_dist)
                          (_patternOcurrentModule)
                          (_patternOimportedModule)
                          (_patternOinstancename)
                          (_patternOknownKinds)
                          (_patternOknownKinds_collect)
                          (_patternOknownTypes)
                          (_patternOknownTypes_collect)
                          (_patternOknownValues)
                          (_patternOknownValues_collect)
                          (_patternOlabels_collect)
                          (_patternOlabels_dist)
                          (_patternOlocal)
                          (_patternOmethods_collect)
                          (_patternOmethods_dist)
                          (_patternOmoduleTypes)
                          (_patternOmoduleValues)
                          (_patternOnameType)
                          (_patternOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _patternImodules
            -- use rule
            (_lhsOres@_) =
                _patternIres
            -- self rule
            (_self@_) =
                Pattern_Parenthesized _rangeIself _patternIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _patternIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _patternIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _patternIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _patternIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _patternIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _patternImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _patternImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _patternImoduleValues
            -- copy rule (up)
            (_lhsOname@_) =
                _patternIname
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_patternOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_patternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_patternOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_patternOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_patternOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_patternOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_patternOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_patternOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_patternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_patternOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_patternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_patternOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_patternOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_patternOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOname,_lhsOres,_lhsOself)
sem_Pattern_Record :: (T_Range) ->
                      (T_Name) ->
                      (T_RecordPatternBindings) ->
                      (T_Pattern)
sem_Pattern_Record (range_) (name_) (recordPatternBindings_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOname :: (Name)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _recordPatternBindingsIconstructors_collect :: (FMap Name Names)
            _recordPatternBindingsIknownKinds_collect :: (FMap Name [Name])
            _recordPatternBindingsIknownTypes_collect :: (FMap Name [Name])
            _recordPatternBindingsIknownValues_collect :: (FMap Name [Name])
            _recordPatternBindingsIlabels_collect :: (FMap Name Names)
            _recordPatternBindingsImethods_collect :: (FMap Name Names)
            _recordPatternBindingsImoduleTypes :: (FMap ModuleName [Name])
            _recordPatternBindingsImoduleValues :: (FMap ModuleName [Name])
            _recordPatternBindingsImodules :: (Set.Set Strings)
            _recordPatternBindingsIres :: ([ResolveResult])
            _recordPatternBindingsIself :: (RecordPatternBindings)
            _recordPatternBindingsOclassname :: (Maybe Name)
            _recordPatternBindingsOconstructors_collect :: (FMap Name Names)
            _recordPatternBindingsOconstructors_dist :: (FMap Name Names)
            _recordPatternBindingsOcurrentModule :: (Strings)
            _recordPatternBindingsOimportedModule :: (Bool)
            _recordPatternBindingsOinstancename :: (Maybe Name)
            _recordPatternBindingsOknownKinds :: (FMap Name [Name])
            _recordPatternBindingsOknownKinds_collect :: (FMap Name [Name])
            _recordPatternBindingsOknownTypes :: (FMap Name [Name])
            _recordPatternBindingsOknownTypes_collect :: (FMap Name [Name])
            _recordPatternBindingsOknownValues :: (FMap Name [Name])
            _recordPatternBindingsOknownValues_collect :: (FMap Name [Name])
            _recordPatternBindingsOlabels_collect :: (FMap Name Names)
            _recordPatternBindingsOlabels_dist :: (FMap Name Names)
            _recordPatternBindingsOlocal :: (Bool)
            _recordPatternBindingsOmethods_collect :: (FMap Name Names)
            _recordPatternBindingsOmethods_dist :: (FMap Name Names)
            _recordPatternBindingsOmoduleTypes :: (FMap ModuleName [Name])
            _recordPatternBindingsOmoduleValues :: (FMap ModuleName [Name])
            _recordPatternBindingsOnameType :: (NameType)
            _recordPatternBindingsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _recordPatternBindingsIconstructors_collect,_recordPatternBindingsIknownKinds_collect,_recordPatternBindingsIknownTypes_collect,_recordPatternBindingsIknownValues_collect,_recordPatternBindingsIlabels_collect,_recordPatternBindingsImethods_collect,_recordPatternBindingsImoduleTypes,_recordPatternBindingsImoduleValues,_recordPatternBindingsImodules,_recordPatternBindingsIres,_recordPatternBindingsIself) =
                (recordPatternBindings_ (_recordPatternBindingsOclassname)
                                        (_recordPatternBindingsOconstructors_collect)
                                        (_recordPatternBindingsOconstructors_dist)
                                        (_recordPatternBindingsOcurrentModule)
                                        (_recordPatternBindingsOimportedModule)
                                        (_recordPatternBindingsOinstancename)
                                        (_recordPatternBindingsOknownKinds)
                                        (_recordPatternBindingsOknownKinds_collect)
                                        (_recordPatternBindingsOknownTypes)
                                        (_recordPatternBindingsOknownTypes_collect)
                                        (_recordPatternBindingsOknownValues)
                                        (_recordPatternBindingsOknownValues_collect)
                                        (_recordPatternBindingsOlabels_collect)
                                        (_recordPatternBindingsOlabels_dist)
                                        (_recordPatternBindingsOlocal)
                                        (_recordPatternBindingsOmethods_collect)
                                        (_recordPatternBindingsOmethods_dist)
                                        (_recordPatternBindingsOmoduleTypes)
                                        (_recordPatternBindingsOmoduleValues)
                                        (_recordPatternBindingsOnameType)
                                        (_recordPatternBindingsOtoplevel))
            -- "./NameTypes.inc.lag"(line 170, column 9)
            (_nameOnameType@_) =
                ref_Val
            -- "./ModuleInformation.inc.lag"(line 456, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.Pattern.Record.name: pattern binding in class/instance"
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _recordPatternBindingsImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _recordPatternBindingsIres
            -- self rule
            (_self@_) =
                Pattern_Record _rangeIself _nameIself _recordPatternBindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _recordPatternBindingsIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _recordPatternBindingsIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _recordPatternBindingsIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _recordPatternBindingsIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _recordPatternBindingsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _recordPatternBindingsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _recordPatternBindingsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _recordPatternBindingsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_recordPatternBindingsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_recordPatternBindingsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_recordPatternBindingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_recordPatternBindingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_recordPatternBindingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_recordPatternBindingsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_recordPatternBindingsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_recordPatternBindingsOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_recordPatternBindingsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_recordPatternBindingsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (down)
            (_recordPatternBindingsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_recordPatternBindingsOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_recordPatternBindingsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_recordPatternBindingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_recordPatternBindingsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_recordPatternBindingsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_recordPatternBindingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_recordPatternBindingsOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_recordPatternBindingsOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_recordPatternBindingsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_recordPatternBindingsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOname,_lhsOres,_lhsOself)
sem_Pattern_Successor :: (T_Range) ->
                         (T_Name) ->
                         (T_Literal) ->
                         (T_Pattern)
sem_Pattern_Successor (range_) (name_) (literal_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOname :: (Name)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _literalIconstructors_collect :: (FMap Name Names)
            _literalIknownKinds_collect :: (FMap Name [Name])
            _literalIknownTypes_collect :: (FMap Name [Name])
            _literalIknownValues_collect :: (FMap Name [Name])
            _literalIlabels_collect :: (FMap Name Names)
            _literalImethods_collect :: (FMap Name Names)
            _literalImoduleTypes :: (FMap ModuleName [Name])
            _literalImoduleValues :: (FMap ModuleName [Name])
            _literalImodules :: (Set.Set Strings)
            _literalIres :: ([ResolveResult])
            _literalIself :: (Literal)
            _literalOclassname :: (Maybe Name)
            _literalOconstructors_collect :: (FMap Name Names)
            _literalOconstructors_dist :: (FMap Name Names)
            _literalOcurrentModule :: (Strings)
            _literalOimportedModule :: (Bool)
            _literalOinstancename :: (Maybe Name)
            _literalOknownKinds :: (FMap Name [Name])
            _literalOknownKinds_collect :: (FMap Name [Name])
            _literalOknownTypes :: (FMap Name [Name])
            _literalOknownTypes_collect :: (FMap Name [Name])
            _literalOknownValues :: (FMap Name [Name])
            _literalOknownValues_collect :: (FMap Name [Name])
            _literalOlabels_collect :: (FMap Name Names)
            _literalOlabels_dist :: (FMap Name Names)
            _literalOlocal :: (Bool)
            _literalOmethods_collect :: (FMap Name Names)
            _literalOmethods_dist :: (FMap Name Names)
            _literalOmoduleTypes :: (FMap ModuleName [Name])
            _literalOmoduleValues :: (FMap ModuleName [Name])
            _literalOnameType :: (NameType)
            _literalOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _literalIconstructors_collect,_literalIknownKinds_collect,_literalIknownTypes_collect,_literalIknownValues_collect,_literalIlabels_collect,_literalImethods_collect,_literalImoduleTypes,_literalImoduleValues,_literalImodules,_literalIres,_literalIself) =
                (literal_ (_literalOclassname)
                          (_literalOconstructors_collect)
                          (_literalOconstructors_dist)
                          (_literalOcurrentModule)
                          (_literalOimportedModule)
                          (_literalOinstancename)
                          (_literalOknownKinds)
                          (_literalOknownKinds_collect)
                          (_literalOknownTypes)
                          (_literalOknownTypes_collect)
                          (_literalOknownValues)
                          (_literalOknownValues_collect)
                          (_literalOlabels_collect)
                          (_literalOlabels_dist)
                          (_literalOlocal)
                          (_literalOmethods_collect)
                          (_literalOmethods_dist)
                          (_literalOmoduleTypes)
                          (_literalOmoduleValues)
                          (_literalOnameType)
                          (_literalOtoplevel))
            -- "./NameTypes.inc.lag"(line 174, column 9)
            (_nameOnameType@_) =
                Def_Val
            -- "./ModuleInformation.inc.lag"(line 468, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.Pattern.Successor.name: pattern binding in class/instance"
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _literalImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _literalIres
            -- self rule
            (_self@_) =
                Pattern_Successor _rangeIself _nameIself _literalIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _literalIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _literalIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _literalIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _literalIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _literalIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _literalImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _literalImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _literalImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_literalOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_literalOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_literalOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_literalOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_literalOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_literalOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_literalOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_literalOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_literalOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_literalOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (down)
            (_literalOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_literalOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_literalOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_literalOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_literalOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_literalOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_literalOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_literalOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_literalOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_literalOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_literalOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOname,_lhsOres,_lhsOself)
sem_Pattern_Tuple :: (T_Range) ->
                     (T_Patterns) ->
                     (T_Pattern)
sem_Pattern_Tuple (range_) (patterns_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOname :: (Name)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _patternsIconstructors_collect :: (FMap Name Names)
            _patternsIknownKinds_collect :: (FMap Name [Name])
            _patternsIknownTypes_collect :: (FMap Name [Name])
            _patternsIknownValues_collect :: (FMap Name [Name])
            _patternsIlabels_collect :: (FMap Name Names)
            _patternsImethods_collect :: (FMap Name Names)
            _patternsImoduleTypes :: (FMap ModuleName [Name])
            _patternsImoduleValues :: (FMap ModuleName [Name])
            _patternsImodules :: (Set.Set Strings)
            _patternsIres :: ([ResolveResult])
            _patternsIself :: (Patterns)
            _patternsOclassname :: (Maybe Name)
            _patternsOconstructors_collect :: (FMap Name Names)
            _patternsOconstructors_dist :: (FMap Name Names)
            _patternsOcurrentModule :: (Strings)
            _patternsOimportedModule :: (Bool)
            _patternsOinstancename :: (Maybe Name)
            _patternsOknownKinds :: (FMap Name [Name])
            _patternsOknownKinds_collect :: (FMap Name [Name])
            _patternsOknownTypes :: (FMap Name [Name])
            _patternsOknownTypes_collect :: (FMap Name [Name])
            _patternsOknownValues :: (FMap Name [Name])
            _patternsOknownValues_collect :: (FMap Name [Name])
            _patternsOlabels_collect :: (FMap Name Names)
            _patternsOlabels_dist :: (FMap Name Names)
            _patternsOlocal :: (Bool)
            _patternsOmethods_collect :: (FMap Name Names)
            _patternsOmethods_dist :: (FMap Name Names)
            _patternsOmoduleTypes :: (FMap ModuleName [Name])
            _patternsOmoduleValues :: (FMap ModuleName [Name])
            _patternsOnameType :: (NameType)
            _patternsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _patternsIconstructors_collect,_patternsIknownKinds_collect,_patternsIknownTypes_collect,_patternsIknownValues_collect,_patternsIlabels_collect,_patternsImethods_collect,_patternsImoduleTypes,_patternsImoduleValues,_patternsImodules,_patternsIres,_patternsIself) =
                (patterns_ (_patternsOclassname)
                           (_patternsOconstructors_collect)
                           (_patternsOconstructors_dist)
                           (_patternsOcurrentModule)
                           (_patternsOimportedModule)
                           (_patternsOinstancename)
                           (_patternsOknownKinds)
                           (_patternsOknownKinds_collect)
                           (_patternsOknownTypes)
                           (_patternsOknownTypes_collect)
                           (_patternsOknownValues)
                           (_patternsOknownValues_collect)
                           (_patternsOlabels_collect)
                           (_patternsOlabels_dist)
                           (_patternsOlocal)
                           (_patternsOmethods_collect)
                           (_patternsOmethods_dist)
                           (_patternsOmoduleTypes)
                           (_patternsOmoduleValues)
                           (_patternsOnameType)
                           (_patternsOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 453, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.Pattern.Tuple.name: pattern binding in class/instance"
            -- use rule
            (_lhsOmodules@_) =
                _patternsImodules
            -- use rule
            (_lhsOres@_) =
                _patternsIres
            -- self rule
            (_self@_) =
                Pattern_Tuple _rangeIself _patternsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _patternsIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _patternsIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _patternsIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _patternsIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _patternsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _patternsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _patternsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _patternsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_patternsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_patternsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_patternsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_patternsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_patternsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_patternsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_patternsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_patternsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_patternsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_patternsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_patternsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_patternsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_patternsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_patternsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOname,_lhsOres,_lhsOself)
sem_Pattern_Variable :: (T_Range) ->
                        (T_Name) ->
                        (T_Pattern)
sem_Pattern_Variable (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOname :: (Name)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            -- "./NameTypes.inc.lag"(line 163, column 9)
            (_nameOnameType@_) =
                _lhsInameType
            -- "./ModuleInformation.inc.lag"(line 439, column 9)
            (_lhsOname@_) =
                _nameIself
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres
            -- self rule
            (_self@_) =
                Pattern_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOname,_lhsOres,_lhsOself)
sem_Pattern_Wildcard :: (T_Range) ->
                        (T_Pattern)
sem_Pattern_Wildcard (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOname :: (Name)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 465, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.Pattern.Wildcard.name: pattern binding in class/instance"
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                Pattern_Wildcard _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOname,_lhsOres,_lhsOself)
-- Patterns ----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for Patterns.Cons:
      self

-}
{-
   local variables for Patterns.Nil:
      self

-}
-- semantic domain
type T_Patterns = (Maybe Name) ->
                  (FMap Name Names) ->
                  (FMap Name Names) ->
                  (Strings) ->
                  (Bool) ->
                  (Maybe Name) ->
                  (FMap Name [Name]) ->
                  (FMap Name [Name]) ->
                  (FMap Name [Name]) ->
                  (FMap Name [Name]) ->
                  (FMap Name [Name]) ->
                  (FMap Name [Name]) ->
                  (FMap Name Names) ->
                  (FMap Name Names) ->
                  (Bool) ->
                  (FMap Name Names) ->
                  (FMap Name Names) ->
                  (FMap ModuleName [Name]) ->
                  (FMap ModuleName [Name]) ->
                  (NameType) ->
                  (Bool) ->
                  ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(Patterns))
-- cata
sem_Patterns :: (Patterns) ->
                (T_Patterns)
sem_Patterns (list) =
    (foldr (sem_Patterns_Cons) (sem_Patterns_Nil) ((map sem_Pattern list)))
sem_Patterns_Cons :: (T_Pattern) ->
                     (T_Patterns) ->
                     (T_Patterns)
sem_Patterns_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Patterns)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIknownKinds_collect :: (FMap Name [Name])
            _hdIknownTypes_collect :: (FMap Name [Name])
            _hdIknownValues_collect :: (FMap Name [Name])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdImoduleTypes :: (FMap ModuleName [Name])
            _hdImoduleValues :: (FMap ModuleName [Name])
            _hdImodules :: (Set.Set Strings)
            _hdIname :: (Name)
            _hdIres :: ([ResolveResult])
            _hdIself :: (Pattern)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOknownKinds :: (FMap Name [Name])
            _hdOknownKinds_collect :: (FMap Name [Name])
            _hdOknownTypes :: (FMap Name [Name])
            _hdOknownTypes_collect :: (FMap Name [Name])
            _hdOknownValues :: (FMap Name [Name])
            _hdOknownValues_collect :: (FMap Name [Name])
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmoduleTypes :: (FMap ModuleName [Name])
            _hdOmoduleValues :: (FMap ModuleName [Name])
            _hdOnameType :: (NameType)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIknownKinds_collect :: (FMap Name [Name])
            _tlIknownTypes_collect :: (FMap Name [Name])
            _tlIknownValues_collect :: (FMap Name [Name])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlImoduleTypes :: (FMap ModuleName [Name])
            _tlImoduleValues :: (FMap ModuleName [Name])
            _tlImodules :: (Set.Set Strings)
            _tlIres :: ([ResolveResult])
            _tlIself :: (Patterns)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOknownKinds :: (FMap Name [Name])
            _tlOknownKinds_collect :: (FMap Name [Name])
            _tlOknownTypes :: (FMap Name [Name])
            _tlOknownTypes_collect :: (FMap Name [Name])
            _tlOknownValues :: (FMap Name [Name])
            _tlOknownValues_collect :: (FMap Name [Name])
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmoduleTypes :: (FMap ModuleName [Name])
            _tlOmoduleValues :: (FMap ModuleName [Name])
            _tlOnameType :: (NameType)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIknownKinds_collect,_hdIknownTypes_collect,_hdIknownValues_collect,_hdIlabels_collect,_hdImethods_collect,_hdImoduleTypes,_hdImoduleValues,_hdImodules,_hdIname,_hdIres,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOimportedModule) (_hdOinstancename) (_hdOknownKinds) (_hdOknownKinds_collect) (_hdOknownTypes) (_hdOknownTypes_collect) (_hdOknownValues) (_hdOknownValues_collect) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOmoduleTypes) (_hdOmoduleValues) (_hdOnameType) (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIknownKinds_collect,_tlIknownTypes_collect,_tlIknownValues_collect,_tlIlabels_collect,_tlImethods_collect,_tlImoduleTypes,_tlImoduleValues,_tlImodules,_tlIres,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOimportedModule) (_tlOinstancename) (_tlOknownKinds) (_tlOknownKinds_collect) (_tlOknownTypes) (_tlOknownTypes_collect) (_tlOknownValues) (_tlOknownValues_collect) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOmoduleTypes) (_tlOmoduleValues) (_tlOnameType) (_tlOtoplevel))
            -- "./NameTypes.inc.lag"(line 348, column 9)
            (_tlOnameType@_) =
                Def_Val
            -- "./NameTypes.inc.lag"(line 347, column 9)
            (_hdOnameType@_) =
                Def_Val
            -- use rule
            (_lhsOmodules@_) =
                _hdImodules `Set.union` _tlImodules
            -- use rule
            (_lhsOres@_) =
                _hdIres ++ _tlIres
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _tlIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _tlIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _tlIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _tlImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _tlImoduleValues
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_hdOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_hdOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_hdOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_hdOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_hdOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_hdOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_tlOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_tlOknownKinds_collect@_) =
                _hdIknownKinds_collect
            -- copy rule (down)
            (_tlOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_tlOknownTypes_collect@_) =
                _hdIknownTypes_collect
            -- copy rule (down)
            (_tlOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_tlOknownValues_collect@_) =
                _hdIknownValues_collect
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_tlOmoduleTypes@_) =
                _hdImoduleTypes
            -- copy rule (chain)
            (_tlOmoduleValues@_) =
                _hdImoduleValues
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Patterns_Nil :: (T_Patterns)
sem_Patterns_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Patterns)
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- Position ----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      local                : Bool
      toplevel             : Bool

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Position.Position:
      self

-}
{-
   local variables for Position.Unknown:
      self

-}
-- semantic domain
type T_Position = (Maybe Name) ->
                  (Strings) ->
                  (Bool) ->
                  (Maybe Name) ->
                  (Bool) ->
                  (Bool) ->
                  ( (Position))
-- cata
sem_Position :: (Position) ->
                (T_Position)
sem_Position ((Position_Position (_filename) (_line) (_column))) =
    (sem_Position_Position (_filename) (_line) (_column))
sem_Position ((Position_Unknown )) =
    (sem_Position_Unknown )
sem_Position_Position :: (String) ->
                         (Int) ->
                         (Int) ->
                         (T_Position)
sem_Position_Position (filename_) (line_) (column_) =
    \ _lhsIclassname
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlocal
      _lhsItoplevel ->
        let _lhsOself :: (Position)
            -- self rule
            (_self@_) =
                Position_Position filename_ line_ column_
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOself)
sem_Position_Unknown :: (T_Position)
sem_Position_Unknown  =
    \ _lhsIclassname
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlocal
      _lhsItoplevel ->
        let _lhsOself :: (Position)
            -- self rule
            (_self@_) =
                Position_Unknown
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOself)
-- Qualifier ---------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for Qualifier.Empty:
      self

-}
{-
   local variables for Qualifier.Generator:
      self

-}
{-
   local variables for Qualifier.Guard:
      self

-}
{-
   local variables for Qualifier.Let:
      self

-}
-- semantic domain
type T_Qualifier = (Maybe Name) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (Strings) ->
                   (Bool) ->
                   (Maybe Name) ->
                   (FMap Name [Name]) ->
                   (FMap Name [Name]) ->
                   (FMap Name [Name]) ->
                   (FMap Name [Name]) ->
                   (FMap Name [Name]) ->
                   (FMap Name [Name]) ->
                   (FMap Name [Name]) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (Bool) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (FMap ModuleName [Name]) ->
                   (FMap ModuleName [Name]) ->
                   (NameType) ->
                   (Bool) ->
                   ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(Qualifier))
-- cata
sem_Qualifier :: (Qualifier) ->
                 (T_Qualifier)
sem_Qualifier ((Qualifier_Empty (_range))) =
    (sem_Qualifier_Empty ((sem_Range (_range))))
sem_Qualifier ((Qualifier_Generator (_range) (_pattern) (_expression))) =
    (sem_Qualifier_Generator ((sem_Range (_range))) ((sem_Pattern (_pattern))) ((sem_Expression (_expression))))
sem_Qualifier ((Qualifier_Guard (_range) (_guard))) =
    (sem_Qualifier_Guard ((sem_Range (_range))) ((sem_Expression (_guard))))
sem_Qualifier ((Qualifier_Let (_range) (_declarations))) =
    (sem_Qualifier_Let ((sem_Range (_range))) ((sem_Declarations (_declarations))))
sem_Qualifier_Empty :: (T_Range) ->
                       (T_Qualifier)
sem_Qualifier_Empty (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Qualifier)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                Qualifier_Empty _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Qualifier_Generator :: (T_Range) ->
                           (T_Pattern) ->
                           (T_Expression) ->
                           (T_Qualifier)
sem_Qualifier_Generator (range_) (pattern_) (expression_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Qualifier)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _patternIconstructors_collect :: (FMap Name Names)
            _patternIknownKinds_collect :: (FMap Name [Name])
            _patternIknownTypes_collect :: (FMap Name [Name])
            _patternIknownValues_collect :: (FMap Name [Name])
            _patternIlabels_collect :: (FMap Name Names)
            _patternImethods_collect :: (FMap Name Names)
            _patternImoduleTypes :: (FMap ModuleName [Name])
            _patternImoduleValues :: (FMap ModuleName [Name])
            _patternImodules :: (Set.Set Strings)
            _patternIname :: (Name)
            _patternIres :: ([ResolveResult])
            _patternIself :: (Pattern)
            _patternOclassname :: (Maybe Name)
            _patternOconstructors_collect :: (FMap Name Names)
            _patternOconstructors_dist :: (FMap Name Names)
            _patternOcurrentModule :: (Strings)
            _patternOimportedModule :: (Bool)
            _patternOinstancename :: (Maybe Name)
            _patternOknownKinds :: (FMap Name [Name])
            _patternOknownKinds_collect :: (FMap Name [Name])
            _patternOknownTypes :: (FMap Name [Name])
            _patternOknownTypes_collect :: (FMap Name [Name])
            _patternOknownValues :: (FMap Name [Name])
            _patternOknownValues_collect :: (FMap Name [Name])
            _patternOlabels_collect :: (FMap Name Names)
            _patternOlabels_dist :: (FMap Name Names)
            _patternOlocal :: (Bool)
            _patternOmethods_collect :: (FMap Name Names)
            _patternOmethods_dist :: (FMap Name Names)
            _patternOmoduleTypes :: (FMap ModuleName [Name])
            _patternOmoduleValues :: (FMap ModuleName [Name])
            _patternOnameType :: (NameType)
            _patternOtoplevel :: (Bool)
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIknownKinds_collect :: (FMap Name [Name])
            _expressionIknownTypes_collect :: (FMap Name [Name])
            _expressionIknownValues_collect :: (FMap Name [Name])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionImoduleTypes :: (FMap ModuleName [Name])
            _expressionImoduleValues :: (FMap ModuleName [Name])
            _expressionImodules :: (Set.Set Strings)
            _expressionIres :: ([ResolveResult])
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOknownGenerics :: (FMap Name [Name])
            _expressionOknownKinds :: (FMap Name [Name])
            _expressionOknownKinds_collect :: (FMap Name [Name])
            _expressionOknownTypes :: (FMap Name [Name])
            _expressionOknownTypes_collect :: (FMap Name [Name])
            _expressionOknownValues :: (FMap Name [Name])
            _expressionOknownValues_collect :: (FMap Name [Name])
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmoduleTypes :: (FMap ModuleName [Name])
            _expressionOmoduleValues :: (FMap ModuleName [Name])
            _expressionOnameType :: (NameType)
            _expressionOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _patternIconstructors_collect,_patternIknownKinds_collect,_patternIknownTypes_collect,_patternIknownValues_collect,_patternIlabels_collect,_patternImethods_collect,_patternImoduleTypes,_patternImoduleValues,_patternImodules,_patternIname,_patternIres,_patternIself) =
                (pattern_ (_patternOclassname)
                          (_patternOconstructors_collect)
                          (_patternOconstructors_dist)
                          (_patternOcurrentModule)
                          (_patternOimportedModule)
                          (_patternOinstancename)
                          (_patternOknownKinds)
                          (_patternOknownKinds_collect)
                          (_patternOknownTypes)
                          (_patternOknownTypes_collect)
                          (_patternOknownValues)
                          (_patternOknownValues_collect)
                          (_patternOlabels_collect)
                          (_patternOlabels_dist)
                          (_patternOlocal)
                          (_patternOmethods_collect)
                          (_patternOmethods_dist)
                          (_patternOmoduleTypes)
                          (_patternOmoduleValues)
                          (_patternOnameType)
                          (_patternOtoplevel))
            ( _expressionIconstructors_collect,_expressionIknownKinds_collect,_expressionIknownTypes_collect,_expressionIknownValues_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionImoduleTypes,_expressionImoduleValues,_expressionImodules,_expressionIres,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOknownGenerics)
                             (_expressionOknownKinds)
                             (_expressionOknownKinds_collect)
                             (_expressionOknownTypes)
                             (_expressionOknownTypes_collect)
                             (_expressionOknownValues)
                             (_expressionOknownValues_collect)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmoduleTypes)
                             (_expressionOmoduleValues)
                             (_expressionOnameType)
                             (_expressionOtoplevel))
            -- "./NameTypes.inc.lag"(line 356, column 9)
            (_patternOnameType@_) =
                Def_Val
            -- use rule
            (_lhsOmodules@_) =
                _patternImodules `Set.union` _expressionImodules
            -- use rule
            (_lhsOres@_) =
                _patternIres ++ _expressionIres
            -- self rule
            (_self@_) =
                Qualifier_Generator _rangeIself _patternIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _expressionIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _expressionIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _expressionIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _expressionImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _expressionImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_patternOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_patternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_patternOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_patternOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_patternOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_patternOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_patternOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_patternOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_patternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_patternOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_patternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_patternOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_patternOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_expressionOconstructors_collect@_) =
                _patternIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_expressionOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_expressionOknownKinds_collect@_) =
                _patternIknownKinds_collect
            -- copy rule (down)
            (_expressionOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_expressionOknownTypes_collect@_) =
                _patternIknownTypes_collect
            -- copy rule (down)
            (_expressionOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_expressionOknownValues_collect@_) =
                _patternIknownValues_collect
            -- copy rule (chain)
            (_expressionOlabels_collect@_) =
                _patternIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_expressionOmethods_collect@_) =
                _patternImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_expressionOmoduleTypes@_) =
                _patternImoduleTypes
            -- copy rule (chain)
            (_expressionOmoduleValues@_) =
                _patternImoduleValues
            -- copy rule (down)
            (_expressionOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Qualifier_Guard :: (T_Range) ->
                       (T_Expression) ->
                       (T_Qualifier)
sem_Qualifier_Guard (range_) (guard_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Qualifier)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _guardIconstructors_collect :: (FMap Name Names)
            _guardIknownKinds_collect :: (FMap Name [Name])
            _guardIknownTypes_collect :: (FMap Name [Name])
            _guardIknownValues_collect :: (FMap Name [Name])
            _guardIlabels_collect :: (FMap Name Names)
            _guardImethods_collect :: (FMap Name Names)
            _guardImoduleTypes :: (FMap ModuleName [Name])
            _guardImoduleValues :: (FMap ModuleName [Name])
            _guardImodules :: (Set.Set Strings)
            _guardIres :: ([ResolveResult])
            _guardIself :: (Expression)
            _guardOclassname :: (Maybe Name)
            _guardOconstructors_collect :: (FMap Name Names)
            _guardOconstructors_dist :: (FMap Name Names)
            _guardOcurrentModule :: (Strings)
            _guardOimportedModule :: (Bool)
            _guardOinstancename :: (Maybe Name)
            _guardOknownGenerics :: (FMap Name [Name])
            _guardOknownKinds :: (FMap Name [Name])
            _guardOknownKinds_collect :: (FMap Name [Name])
            _guardOknownTypes :: (FMap Name [Name])
            _guardOknownTypes_collect :: (FMap Name [Name])
            _guardOknownValues :: (FMap Name [Name])
            _guardOknownValues_collect :: (FMap Name [Name])
            _guardOlabels_collect :: (FMap Name Names)
            _guardOlabels_dist :: (FMap Name Names)
            _guardOlocal :: (Bool)
            _guardOmethods_collect :: (FMap Name Names)
            _guardOmethods_dist :: (FMap Name Names)
            _guardOmoduleTypes :: (FMap ModuleName [Name])
            _guardOmoduleValues :: (FMap ModuleName [Name])
            _guardOnameType :: (NameType)
            _guardOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _guardIconstructors_collect,_guardIknownKinds_collect,_guardIknownTypes_collect,_guardIknownValues_collect,_guardIlabels_collect,_guardImethods_collect,_guardImoduleTypes,_guardImoduleValues,_guardImodules,_guardIres,_guardIself) =
                (guard_ (_guardOclassname)
                        (_guardOconstructors_collect)
                        (_guardOconstructors_dist)
                        (_guardOcurrentModule)
                        (_guardOimportedModule)
                        (_guardOinstancename)
                        (_guardOknownGenerics)
                        (_guardOknownKinds)
                        (_guardOknownKinds_collect)
                        (_guardOknownTypes)
                        (_guardOknownTypes_collect)
                        (_guardOknownValues)
                        (_guardOknownValues_collect)
                        (_guardOlabels_collect)
                        (_guardOlabels_dist)
                        (_guardOlocal)
                        (_guardOmethods_collect)
                        (_guardOmethods_dist)
                        (_guardOmoduleTypes)
                        (_guardOmoduleValues)
                        (_guardOnameType)
                        (_guardOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _guardImodules
            -- use rule
            (_lhsOres@_) =
                _guardIres
            -- self rule
            (_self@_) =
                Qualifier_Guard _rangeIself _guardIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _guardIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _guardIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _guardIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _guardIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _guardIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _guardImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _guardImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _guardImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_guardOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_guardOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_guardOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_guardOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_guardOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_guardOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_guardOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_guardOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_guardOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_guardOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_guardOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_guardOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_guardOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_guardOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_guardOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_guardOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_guardOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_guardOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_guardOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_guardOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_guardOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_guardOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Qualifier_Let :: (T_Range) ->
                     (T_Declarations) ->
                     (T_Qualifier)
sem_Qualifier_Let (range_) (declarations_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Qualifier)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _declarationsIconstructors_collect :: (FMap Name Names)
            _declarationsIknownKinds_collect :: (FMap Name [Name])
            _declarationsIknownTypes_collect :: (FMap Name [Name])
            _declarationsIknownValues_collect :: (FMap Name [Name])
            _declarationsIlabels_collect :: (FMap Name Names)
            _declarationsImethods_collect :: (FMap Name Names)
            _declarationsImoduleTypes :: (FMap ModuleName [Name])
            _declarationsImoduleValues :: (FMap ModuleName [Name])
            _declarationsImodules :: (Set.Set Strings)
            _declarationsIres :: ([ResolveResult])
            _declarationsIself :: (Declarations)
            _declarationsOclassname :: (Maybe Name)
            _declarationsOconstructors_collect :: (FMap Name Names)
            _declarationsOconstructors_dist :: (FMap Name Names)
            _declarationsOcurrentModule :: (Strings)
            _declarationsOimportedModule :: (Bool)
            _declarationsOinstancename :: (Maybe Name)
            _declarationsOknownGenerics :: (FMap Name [Name])
            _declarationsOknownKinds :: (FMap Name [Name])
            _declarationsOknownKinds_collect :: (FMap Name [Name])
            _declarationsOknownTypes :: (FMap Name [Name])
            _declarationsOknownTypes_collect :: (FMap Name [Name])
            _declarationsOknownValues :: (FMap Name [Name])
            _declarationsOknownValues_collect :: (FMap Name [Name])
            _declarationsOlabels_collect :: (FMap Name Names)
            _declarationsOlabels_dist :: (FMap Name Names)
            _declarationsOlocal :: (Bool)
            _declarationsOmethods_collect :: (FMap Name Names)
            _declarationsOmethods_dist :: (FMap Name Names)
            _declarationsOmoduleTypes :: (FMap ModuleName [Name])
            _declarationsOmoduleValues :: (FMap ModuleName [Name])
            _declarationsOnameType :: (NameType)
            _declarationsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _declarationsIconstructors_collect,_declarationsIknownKinds_collect,_declarationsIknownTypes_collect,_declarationsIknownValues_collect,_declarationsIlabels_collect,_declarationsImethods_collect,_declarationsImoduleTypes,_declarationsImoduleValues,_declarationsImodules,_declarationsIres,_declarationsIself) =
                (declarations_ (_declarationsOclassname)
                               (_declarationsOconstructors_collect)
                               (_declarationsOconstructors_dist)
                               (_declarationsOcurrentModule)
                               (_declarationsOimportedModule)
                               (_declarationsOinstancename)
                               (_declarationsOknownGenerics)
                               (_declarationsOknownKinds)
                               (_declarationsOknownKinds_collect)
                               (_declarationsOknownTypes)
                               (_declarationsOknownTypes_collect)
                               (_declarationsOknownValues)
                               (_declarationsOknownValues_collect)
                               (_declarationsOlabels_collect)
                               (_declarationsOlabels_dist)
                               (_declarationsOlocal)
                               (_declarationsOmethods_collect)
                               (_declarationsOmethods_dist)
                               (_declarationsOmoduleTypes)
                               (_declarationsOmoduleValues)
                               (_declarationsOnameType)
                               (_declarationsOtoplevel))
            -- "./Names.inc.lag"(line 705, column 9)
            (_declarationsOknownValues@_) =
                _declarationsIknownValues_collect `mergeFM` _lhsIknownValues
            -- use rule
            (_lhsOmodules@_) =
                _declarationsImodules
            -- use rule
            (_lhsOres@_) =
                _declarationsIres
            -- self rule
            (_self@_) =
                Qualifier_Let _rangeIself _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _declarationsIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _declarationsIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _declarationsIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _declarationsIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _declarationsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _declarationsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _declarationsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _declarationsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_declarationsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_declarationsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_declarationsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_declarationsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_declarationsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_declarationsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_declarationsOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_declarationsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_declarationsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_declarationsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_declarationsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_declarationsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_declarationsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_declarationsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_declarationsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_declarationsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_declarationsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_declarationsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_declarationsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_declarationsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_declarationsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- Qualifiers --------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for Qualifiers.Cons:
      self

-}
{-
   local variables for Qualifiers.Nil:
      self

-}
-- semantic domain
type T_Qualifiers = (Maybe Name) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Strings) ->
                    (Bool) ->
                    (Maybe Name) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Bool) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (FMap ModuleName [Name]) ->
                    (FMap ModuleName [Name]) ->
                    (NameType) ->
                    (Bool) ->
                    ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(Qualifiers))
-- cata
sem_Qualifiers :: (Qualifiers) ->
                  (T_Qualifiers)
sem_Qualifiers (list) =
    (foldr (sem_Qualifiers_Cons) (sem_Qualifiers_Nil) ((map sem_Qualifier list)))
sem_Qualifiers_Cons :: (T_Qualifier) ->
                       (T_Qualifiers) ->
                       (T_Qualifiers)
sem_Qualifiers_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Qualifiers)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIknownKinds_collect :: (FMap Name [Name])
            _hdIknownTypes_collect :: (FMap Name [Name])
            _hdIknownValues_collect :: (FMap Name [Name])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdImoduleTypes :: (FMap ModuleName [Name])
            _hdImoduleValues :: (FMap ModuleName [Name])
            _hdImodules :: (Set.Set Strings)
            _hdIres :: ([ResolveResult])
            _hdIself :: (Qualifier)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOknownGenerics :: (FMap Name [Name])
            _hdOknownKinds :: (FMap Name [Name])
            _hdOknownKinds_collect :: (FMap Name [Name])
            _hdOknownTypes :: (FMap Name [Name])
            _hdOknownTypes_collect :: (FMap Name [Name])
            _hdOknownValues :: (FMap Name [Name])
            _hdOknownValues_collect :: (FMap Name [Name])
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmoduleTypes :: (FMap ModuleName [Name])
            _hdOmoduleValues :: (FMap ModuleName [Name])
            _hdOnameType :: (NameType)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIknownKinds_collect :: (FMap Name [Name])
            _tlIknownTypes_collect :: (FMap Name [Name])
            _tlIknownValues_collect :: (FMap Name [Name])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlImoduleTypes :: (FMap ModuleName [Name])
            _tlImoduleValues :: (FMap ModuleName [Name])
            _tlImodules :: (Set.Set Strings)
            _tlIres :: ([ResolveResult])
            _tlIself :: (Qualifiers)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOknownGenerics :: (FMap Name [Name])
            _tlOknownKinds :: (FMap Name [Name])
            _tlOknownKinds_collect :: (FMap Name [Name])
            _tlOknownTypes :: (FMap Name [Name])
            _tlOknownTypes_collect :: (FMap Name [Name])
            _tlOknownValues :: (FMap Name [Name])
            _tlOknownValues_collect :: (FMap Name [Name])
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmoduleTypes :: (FMap ModuleName [Name])
            _tlOmoduleValues :: (FMap ModuleName [Name])
            _tlOnameType :: (NameType)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIknownKinds_collect,_hdIknownTypes_collect,_hdIknownValues_collect,_hdIlabels_collect,_hdImethods_collect,_hdImoduleTypes,_hdImoduleValues,_hdImodules,_hdIres,_hdIself) =
                (hd_ (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOknownGenerics)
                     (_hdOknownKinds)
                     (_hdOknownKinds_collect)
                     (_hdOknownTypes)
                     (_hdOknownTypes_collect)
                     (_hdOknownValues)
                     (_hdOknownValues_collect)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmoduleTypes)
                     (_hdOmoduleValues)
                     (_hdOnameType)
                     (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIknownKinds_collect,_tlIknownTypes_collect,_tlIknownValues_collect,_tlIlabels_collect,_tlImethods_collect,_tlImoduleTypes,_tlImoduleValues,_tlImodules,_tlIres,_tlIself) =
                (tl_ (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOknownGenerics)
                     (_tlOknownKinds)
                     (_tlOknownKinds_collect)
                     (_tlOknownTypes)
                     (_tlOknownTypes_collect)
                     (_tlOknownValues)
                     (_tlOknownValues_collect)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmoduleTypes)
                     (_tlOmoduleValues)
                     (_tlOnameType)
                     (_tlOtoplevel))
            -- "./Names.inc.lag"(line 701, column 9)
            (_lhsOknownValues_collect@_) =
                _tlIknownValues_collect
            -- "./Names.inc.lag"(line 700, column 9)
            (_tlOknownValues@_) =
                _hdIknownValues_collect `mergeFM` _lhsIknownValues
            -- "./Names.inc.lag"(line 699, column 9)
            (_hdOknownValues_collect@_) =
                emptyFM
            -- use rule
            (_lhsOmodules@_) =
                _hdImodules `Set.union` _tlImodules
            -- use rule
            (_lhsOres@_) =
                _hdIres ++ _tlIres
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _tlIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _tlIknownTypes_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _tlImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _tlImoduleValues
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_hdOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_hdOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_hdOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_hdOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_hdOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_hdOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_hdOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_tlOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_tlOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_tlOknownKinds_collect@_) =
                _hdIknownKinds_collect
            -- copy rule (down)
            (_tlOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_tlOknownTypes_collect@_) =
                _hdIknownTypes_collect
            -- copy rule (chain)
            (_tlOknownValues_collect@_) =
                _hdIknownValues_collect
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_tlOmoduleTypes@_) =
                _hdImoduleTypes
            -- copy rule (chain)
            (_tlOmoduleValues@_) =
                _hdImoduleValues
            -- copy rule (down)
            (_tlOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Qualifiers_Nil :: (T_Qualifiers)
sem_Qualifiers_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Qualifiers)
            -- "./Names.inc.lag"(line 697, column 9)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- Range -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      local                : Bool
      toplevel             : Bool

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Range.Range:
      self

-}
-- semantic domain
type T_Range = (Maybe Name) ->
               (Strings) ->
               (Bool) ->
               (Maybe Name) ->
               (Bool) ->
               (Bool) ->
               ( (Range))
-- cata
sem_Range :: (Range) ->
             (T_Range)
sem_Range ((Range_Range (_start) (_stop))) =
    (sem_Range_Range ((sem_Position (_start))) ((sem_Position (_stop))))
sem_Range_Range :: (T_Position) ->
                   (T_Position) ->
                   (T_Range)
sem_Range_Range (start_) (stop_) =
    \ _lhsIclassname
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlocal
      _lhsItoplevel ->
        let _lhsOself :: (Range)
            _startIself :: (Position)
            _startOclassname :: (Maybe Name)
            _startOcurrentModule :: (Strings)
            _startOimportedModule :: (Bool)
            _startOinstancename :: (Maybe Name)
            _startOlocal :: (Bool)
            _startOtoplevel :: (Bool)
            _stopIself :: (Position)
            _stopOclassname :: (Maybe Name)
            _stopOcurrentModule :: (Strings)
            _stopOimportedModule :: (Bool)
            _stopOinstancename :: (Maybe Name)
            _stopOlocal :: (Bool)
            _stopOtoplevel :: (Bool)
            ( _startIself) =
                (start_ (_startOclassname) (_startOcurrentModule) (_startOimportedModule) (_startOinstancename) (_startOlocal) (_startOtoplevel))
            ( _stopIself) =
                (stop_ (_stopOclassname) (_stopOcurrentModule) (_stopOimportedModule) (_stopOinstancename) (_stopOlocal) (_stopOtoplevel))
            -- self rule
            (_self@_) =
                Range_Range _startIself _stopIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_startOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_startOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_startOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_startOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_startOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_startOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_stopOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_stopOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_stopOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_stopOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_stopOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_stopOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOself)
-- Reassignment ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for Reassignment.Reassignment:
      self

-}
-- semantic domain
type T_Reassignment = (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Strings) ->
                      (Bool) ->
                      (Maybe Name) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (FMap ModuleName [Name]) ->
                      (FMap ModuleName [Name]) ->
                      (NameType) ->
                      (Bool) ->
                      ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(Reassignment))
-- cata
sem_Reassignment :: (Reassignment) ->
                    (T_Reassignment)
sem_Reassignment ((Reassignment_Reassignment (_range) (_name) (_as))) =
    (sem_Reassignment_Reassignment ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Name (_as))))
sem_Reassignment_Reassignment :: (T_Range) ->
                                 (T_Name) ->
                                 (T_Name) ->
                                 (T_Reassignment)
sem_Reassignment_Reassignment (range_) (name_) (as_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Reassignment)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _asIconstructors_collect :: (FMap Name Names)
            _asIentityName :: (Name)
            _asIfullName :: (Name)
            _asIknownKinds_collect :: (FMap Name [Name])
            _asIknownTypes_collect :: (FMap Name [Name])
            _asIknownValues_collect :: (FMap Name [Name])
            _asIlabels_collect :: (FMap Name Names)
            _asImethods_collect :: (FMap Name Names)
            _asImoduleTypes :: (FMap ModuleName [Name])
            _asImoduleValues :: (FMap ModuleName [Name])
            _asImodules :: (Set.Set Strings)
            _asIoriginalSelf :: (Name)
            _asIres :: ([ResolveResult])
            _asIself :: (Name)
            _asOclassname :: (Maybe Name)
            _asOconstructors_collect :: (FMap Name Names)
            _asOconstructors_dist :: (FMap Name Names)
            _asOcurrentModule :: (Strings)
            _asOimportedModule :: (Bool)
            _asOinstancename :: (Maybe Name)
            _asOknownKinds :: (FMap Name [Name])
            _asOknownKinds_collect :: (FMap Name [Name])
            _asOknownTypes :: (FMap Name [Name])
            _asOknownTypes_collect :: (FMap Name [Name])
            _asOknownValues :: (FMap Name [Name])
            _asOknownValues_collect :: (FMap Name [Name])
            _asOlabels_collect :: (FMap Name Names)
            _asOlabels_dist :: (FMap Name Names)
            _asOlocal :: (Bool)
            _asOmethods_collect :: (FMap Name Names)
            _asOmethods_dist :: (FMap Name Names)
            _asOmoduleTypes :: (FMap ModuleName [Name])
            _asOmoduleValues :: (FMap ModuleName [Name])
            _asOnameType :: (NameType)
            _asOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _asIconstructors_collect,_asIentityName,_asIfullName,_asIknownKinds_collect,_asIknownTypes_collect,_asIknownValues_collect,_asIlabels_collect,_asImethods_collect,_asImoduleTypes,_asImoduleValues,_asImodules,_asIoriginalSelf,_asIres,_asIself) =
                (as_ (_asOclassname) (_asOconstructors_collect) (_asOconstructors_dist) (_asOcurrentModule) (_asOimportedModule) (_asOinstancename) (_asOknownKinds) (_asOknownKinds_collect) (_asOknownTypes) (_asOknownTypes_collect) (_asOknownValues) (_asOknownValues_collect) (_asOlabels_collect) (_asOlabels_dist) (_asOlocal) (_asOmethods_collect) (_asOmethods_dist) (_asOmoduleTypes) (_asOmoduleValues) (_asOnameType) (_asOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _asImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _asIres
            -- self rule
            (_self@_) =
                Reassignment_Reassignment _rangeIself _nameIself _asIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _asIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _asIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _asIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _asIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _asIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _asImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _asImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _asImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_asOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_asOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_asOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_asOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_asOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_asOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_asOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_asOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_asOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_asOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (down)
            (_asOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_asOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_asOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_asOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_asOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_asOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_asOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_asOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_asOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_asOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_asOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- Reassignments -----------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for Reassignments.Cons:
      self

-}
{-
   local variables for Reassignments.Nil:
      self

-}
-- semantic domain
type T_Reassignments = (Maybe Name) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (Strings) ->
                       (Bool) ->
                       (Maybe Name) ->
                       (FMap Name [Name]) ->
                       (FMap Name [Name]) ->
                       (FMap Name [Name]) ->
                       (FMap Name [Name]) ->
                       (FMap Name [Name]) ->
                       (FMap Name [Name]) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (Bool) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (FMap ModuleName [Name]) ->
                       (FMap ModuleName [Name]) ->
                       (NameType) ->
                       (Bool) ->
                       ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(Reassignments))
-- cata
sem_Reassignments :: (Reassignments) ->
                     (T_Reassignments)
sem_Reassignments (list) =
    (foldr (sem_Reassignments_Cons) (sem_Reassignments_Nil) ((map sem_Reassignment list)))
sem_Reassignments_Cons :: (T_Reassignment) ->
                          (T_Reassignments) ->
                          (T_Reassignments)
sem_Reassignments_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Reassignments)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIknownKinds_collect :: (FMap Name [Name])
            _hdIknownTypes_collect :: (FMap Name [Name])
            _hdIknownValues_collect :: (FMap Name [Name])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdImoduleTypes :: (FMap ModuleName [Name])
            _hdImoduleValues :: (FMap ModuleName [Name])
            _hdImodules :: (Set.Set Strings)
            _hdIres :: ([ResolveResult])
            _hdIself :: (Reassignment)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOknownKinds :: (FMap Name [Name])
            _hdOknownKinds_collect :: (FMap Name [Name])
            _hdOknownTypes :: (FMap Name [Name])
            _hdOknownTypes_collect :: (FMap Name [Name])
            _hdOknownValues :: (FMap Name [Name])
            _hdOknownValues_collect :: (FMap Name [Name])
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmoduleTypes :: (FMap ModuleName [Name])
            _hdOmoduleValues :: (FMap ModuleName [Name])
            _hdOnameType :: (NameType)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIknownKinds_collect :: (FMap Name [Name])
            _tlIknownTypes_collect :: (FMap Name [Name])
            _tlIknownValues_collect :: (FMap Name [Name])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlImoduleTypes :: (FMap ModuleName [Name])
            _tlImoduleValues :: (FMap ModuleName [Name])
            _tlImodules :: (Set.Set Strings)
            _tlIres :: ([ResolveResult])
            _tlIself :: (Reassignments)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOknownKinds :: (FMap Name [Name])
            _tlOknownKinds_collect :: (FMap Name [Name])
            _tlOknownTypes :: (FMap Name [Name])
            _tlOknownTypes_collect :: (FMap Name [Name])
            _tlOknownValues :: (FMap Name [Name])
            _tlOknownValues_collect :: (FMap Name [Name])
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmoduleTypes :: (FMap ModuleName [Name])
            _tlOmoduleValues :: (FMap ModuleName [Name])
            _tlOnameType :: (NameType)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIknownKinds_collect,_hdIknownTypes_collect,_hdIknownValues_collect,_hdIlabels_collect,_hdImethods_collect,_hdImoduleTypes,_hdImoduleValues,_hdImodules,_hdIres,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOimportedModule) (_hdOinstancename) (_hdOknownKinds) (_hdOknownKinds_collect) (_hdOknownTypes) (_hdOknownTypes_collect) (_hdOknownValues) (_hdOknownValues_collect) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOmoduleTypes) (_hdOmoduleValues) (_hdOnameType) (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIknownKinds_collect,_tlIknownTypes_collect,_tlIknownValues_collect,_tlIlabels_collect,_tlImethods_collect,_tlImoduleTypes,_tlImoduleValues,_tlImodules,_tlIres,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOimportedModule) (_tlOinstancename) (_tlOknownKinds) (_tlOknownKinds_collect) (_tlOknownTypes) (_tlOknownTypes_collect) (_tlOknownValues) (_tlOknownValues_collect) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOmoduleTypes) (_tlOmoduleValues) (_tlOnameType) (_tlOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _hdImodules `Set.union` _tlImodules
            -- use rule
            (_lhsOres@_) =
                _hdIres ++ _tlIres
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _tlIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _tlIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _tlIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _tlImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _tlImoduleValues
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_hdOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_hdOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_hdOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_hdOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_hdOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_hdOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_hdOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_tlOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_tlOknownKinds_collect@_) =
                _hdIknownKinds_collect
            -- copy rule (down)
            (_tlOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_tlOknownTypes_collect@_) =
                _hdIknownTypes_collect
            -- copy rule (down)
            (_tlOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_tlOknownValues_collect@_) =
                _hdIknownValues_collect
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_tlOmoduleTypes@_) =
                _hdImoduleTypes
            -- copy rule (chain)
            (_tlOmoduleValues@_) =
                _hdImoduleValues
            -- copy rule (down)
            (_tlOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Reassignments_Nil :: (T_Reassignments)
sem_Reassignments_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Reassignments)
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- RecordExpressionBinding -------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for RecordExpressionBinding.RecordExpressionBinding:
      self

-}
-- semantic domain
type T_RecordExpressionBinding = (Maybe Name) ->
                                 (FMap Name Names) ->
                                 (FMap Name Names) ->
                                 (Strings) ->
                                 (Bool) ->
                                 (Maybe Name) ->
                                 (FMap Name [Name]) ->
                                 (FMap Name [Name]) ->
                                 (FMap Name [Name]) ->
                                 (FMap Name [Name]) ->
                                 (FMap Name [Name]) ->
                                 (FMap Name [Name]) ->
                                 (FMap Name [Name]) ->
                                 (FMap Name Names) ->
                                 (FMap Name Names) ->
                                 (Bool) ->
                                 (FMap Name Names) ->
                                 (FMap Name Names) ->
                                 (FMap ModuleName [Name]) ->
                                 (FMap ModuleName [Name]) ->
                                 (NameType) ->
                                 (Bool) ->
                                 ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(RecordExpressionBinding))
-- cata
sem_RecordExpressionBinding :: (RecordExpressionBinding) ->
                               (T_RecordExpressionBinding)
sem_RecordExpressionBinding ((RecordExpressionBinding_RecordExpressionBinding (_range) (_name) (_expression))) =
    (sem_RecordExpressionBinding_RecordExpressionBinding ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Expression (_expression))))
sem_RecordExpressionBinding_RecordExpressionBinding :: (T_Range) ->
                                                       (T_Name) ->
                                                       (T_Expression) ->
                                                       (T_RecordExpressionBinding)
sem_RecordExpressionBinding_RecordExpressionBinding (range_) (name_) (expression_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (RecordExpressionBinding)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIknownKinds_collect :: (FMap Name [Name])
            _expressionIknownTypes_collect :: (FMap Name [Name])
            _expressionIknownValues_collect :: (FMap Name [Name])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionImoduleTypes :: (FMap ModuleName [Name])
            _expressionImoduleValues :: (FMap ModuleName [Name])
            _expressionImodules :: (Set.Set Strings)
            _expressionIres :: ([ResolveResult])
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOknownGenerics :: (FMap Name [Name])
            _expressionOknownKinds :: (FMap Name [Name])
            _expressionOknownKinds_collect :: (FMap Name [Name])
            _expressionOknownTypes :: (FMap Name [Name])
            _expressionOknownTypes_collect :: (FMap Name [Name])
            _expressionOknownValues :: (FMap Name [Name])
            _expressionOknownValues_collect :: (FMap Name [Name])
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmoduleTypes :: (FMap ModuleName [Name])
            _expressionOmoduleValues :: (FMap ModuleName [Name])
            _expressionOnameType :: (NameType)
            _expressionOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _expressionIconstructors_collect,_expressionIknownKinds_collect,_expressionIknownTypes_collect,_expressionIknownValues_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionImoduleTypes,_expressionImoduleValues,_expressionImodules,_expressionIres,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOknownGenerics)
                             (_expressionOknownKinds)
                             (_expressionOknownKinds_collect)
                             (_expressionOknownTypes)
                             (_expressionOknownTypes_collect)
                             (_expressionOknownValues)
                             (_expressionOknownValues_collect)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmoduleTypes)
                             (_expressionOmoduleValues)
                             (_expressionOnameType)
                             (_expressionOtoplevel))
            -- "./NameTypes.inc.lag"(line 155, column 9)
            (_nameOnameType@_) =
                ref_Val
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _expressionImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _expressionIres
            -- self rule
            (_self@_) =
                RecordExpressionBinding_RecordExpressionBinding _rangeIself _nameIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _expressionIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _expressionIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _expressionIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _expressionImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _expressionImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_expressionOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_expressionOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_expressionOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_expressionOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_expressionOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (down)
            (_expressionOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_expressionOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_expressionOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_expressionOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_expressionOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_expressionOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_expressionOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- RecordExpressionBindings ------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for RecordExpressionBindings.Cons:
      self

-}
{-
   local variables for RecordExpressionBindings.Nil:
      self

-}
-- semantic domain
type T_RecordExpressionBindings = (Maybe Name) ->
                                  (FMap Name Names) ->
                                  (FMap Name Names) ->
                                  (Strings) ->
                                  (Bool) ->
                                  (Maybe Name) ->
                                  (FMap Name [Name]) ->
                                  (FMap Name [Name]) ->
                                  (FMap Name [Name]) ->
                                  (FMap Name [Name]) ->
                                  (FMap Name [Name]) ->
                                  (FMap Name [Name]) ->
                                  (FMap Name [Name]) ->
                                  (FMap Name Names) ->
                                  (FMap Name Names) ->
                                  (Bool) ->
                                  (FMap Name Names) ->
                                  (FMap Name Names) ->
                                  (FMap ModuleName [Name]) ->
                                  (FMap ModuleName [Name]) ->
                                  (NameType) ->
                                  (Bool) ->
                                  ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(RecordExpressionBindings))
-- cata
sem_RecordExpressionBindings :: (RecordExpressionBindings) ->
                                (T_RecordExpressionBindings)
sem_RecordExpressionBindings (list) =
    (foldr (sem_RecordExpressionBindings_Cons) (sem_RecordExpressionBindings_Nil) ((map sem_RecordExpressionBinding list)))
sem_RecordExpressionBindings_Cons :: (T_RecordExpressionBinding) ->
                                     (T_RecordExpressionBindings) ->
                                     (T_RecordExpressionBindings)
sem_RecordExpressionBindings_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (RecordExpressionBindings)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIknownKinds_collect :: (FMap Name [Name])
            _hdIknownTypes_collect :: (FMap Name [Name])
            _hdIknownValues_collect :: (FMap Name [Name])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdImoduleTypes :: (FMap ModuleName [Name])
            _hdImoduleValues :: (FMap ModuleName [Name])
            _hdImodules :: (Set.Set Strings)
            _hdIres :: ([ResolveResult])
            _hdIself :: (RecordExpressionBinding)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOknownGenerics :: (FMap Name [Name])
            _hdOknownKinds :: (FMap Name [Name])
            _hdOknownKinds_collect :: (FMap Name [Name])
            _hdOknownTypes :: (FMap Name [Name])
            _hdOknownTypes_collect :: (FMap Name [Name])
            _hdOknownValues :: (FMap Name [Name])
            _hdOknownValues_collect :: (FMap Name [Name])
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmoduleTypes :: (FMap ModuleName [Name])
            _hdOmoduleValues :: (FMap ModuleName [Name])
            _hdOnameType :: (NameType)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIknownKinds_collect :: (FMap Name [Name])
            _tlIknownTypes_collect :: (FMap Name [Name])
            _tlIknownValues_collect :: (FMap Name [Name])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlImoduleTypes :: (FMap ModuleName [Name])
            _tlImoduleValues :: (FMap ModuleName [Name])
            _tlImodules :: (Set.Set Strings)
            _tlIres :: ([ResolveResult])
            _tlIself :: (RecordExpressionBindings)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOknownGenerics :: (FMap Name [Name])
            _tlOknownKinds :: (FMap Name [Name])
            _tlOknownKinds_collect :: (FMap Name [Name])
            _tlOknownTypes :: (FMap Name [Name])
            _tlOknownTypes_collect :: (FMap Name [Name])
            _tlOknownValues :: (FMap Name [Name])
            _tlOknownValues_collect :: (FMap Name [Name])
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmoduleTypes :: (FMap ModuleName [Name])
            _tlOmoduleValues :: (FMap ModuleName [Name])
            _tlOnameType :: (NameType)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIknownKinds_collect,_hdIknownTypes_collect,_hdIknownValues_collect,_hdIlabels_collect,_hdImethods_collect,_hdImoduleTypes,_hdImoduleValues,_hdImodules,_hdIres,_hdIself) =
                (hd_ (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOknownGenerics)
                     (_hdOknownKinds)
                     (_hdOknownKinds_collect)
                     (_hdOknownTypes)
                     (_hdOknownTypes_collect)
                     (_hdOknownValues)
                     (_hdOknownValues_collect)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmoduleTypes)
                     (_hdOmoduleValues)
                     (_hdOnameType)
                     (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIknownKinds_collect,_tlIknownTypes_collect,_tlIknownValues_collect,_tlIlabels_collect,_tlImethods_collect,_tlImoduleTypes,_tlImoduleValues,_tlImodules,_tlIres,_tlIself) =
                (tl_ (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOknownGenerics)
                     (_tlOknownKinds)
                     (_tlOknownKinds_collect)
                     (_tlOknownTypes)
                     (_tlOknownTypes_collect)
                     (_tlOknownValues)
                     (_tlOknownValues_collect)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmoduleTypes)
                     (_tlOmoduleValues)
                     (_tlOnameType)
                     (_tlOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _hdImodules `Set.union` _tlImodules
            -- use rule
            (_lhsOres@_) =
                _hdIres ++ _tlIres
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _tlIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _tlIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _tlIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _tlImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _tlImoduleValues
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_hdOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_hdOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_hdOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_hdOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_hdOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_hdOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_hdOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_hdOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_tlOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_tlOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_tlOknownKinds_collect@_) =
                _hdIknownKinds_collect
            -- copy rule (down)
            (_tlOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_tlOknownTypes_collect@_) =
                _hdIknownTypes_collect
            -- copy rule (down)
            (_tlOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_tlOknownValues_collect@_) =
                _hdIknownValues_collect
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_tlOmoduleTypes@_) =
                _hdImoduleTypes
            -- copy rule (chain)
            (_tlOmoduleValues@_) =
                _hdImoduleValues
            -- copy rule (down)
            (_tlOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_RecordExpressionBindings_Nil :: (T_RecordExpressionBindings)
sem_RecordExpressionBindings_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (RecordExpressionBindings)
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- RecordPatternBinding ----------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for RecordPatternBinding.RecordPatternBinding:
      self

-}
-- semantic domain
type T_RecordPatternBinding = (Maybe Name) ->
                              (FMap Name Names) ->
                              (FMap Name Names) ->
                              (Strings) ->
                              (Bool) ->
                              (Maybe Name) ->
                              (FMap Name [Name]) ->
                              (FMap Name [Name]) ->
                              (FMap Name [Name]) ->
                              (FMap Name [Name]) ->
                              (FMap Name [Name]) ->
                              (FMap Name [Name]) ->
                              (FMap Name Names) ->
                              (FMap Name Names) ->
                              (Bool) ->
                              (FMap Name Names) ->
                              (FMap Name Names) ->
                              (FMap ModuleName [Name]) ->
                              (FMap ModuleName [Name]) ->
                              (NameType) ->
                              (Bool) ->
                              ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(RecordPatternBinding))
-- cata
sem_RecordPatternBinding :: (RecordPatternBinding) ->
                            (T_RecordPatternBinding)
sem_RecordPatternBinding ((RecordPatternBinding_RecordPatternBinding (_range) (_name) (_pattern))) =
    (sem_RecordPatternBinding_RecordPatternBinding ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Pattern (_pattern))))
sem_RecordPatternBinding_RecordPatternBinding :: (T_Range) ->
                                                 (T_Name) ->
                                                 (T_Pattern) ->
                                                 (T_RecordPatternBinding)
sem_RecordPatternBinding_RecordPatternBinding (range_) (name_) (pattern_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (RecordPatternBinding)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _patternIconstructors_collect :: (FMap Name Names)
            _patternIknownKinds_collect :: (FMap Name [Name])
            _patternIknownTypes_collect :: (FMap Name [Name])
            _patternIknownValues_collect :: (FMap Name [Name])
            _patternIlabels_collect :: (FMap Name Names)
            _patternImethods_collect :: (FMap Name Names)
            _patternImoduleTypes :: (FMap ModuleName [Name])
            _patternImoduleValues :: (FMap ModuleName [Name])
            _patternImodules :: (Set.Set Strings)
            _patternIname :: (Name)
            _patternIres :: ([ResolveResult])
            _patternIself :: (Pattern)
            _patternOclassname :: (Maybe Name)
            _patternOconstructors_collect :: (FMap Name Names)
            _patternOconstructors_dist :: (FMap Name Names)
            _patternOcurrentModule :: (Strings)
            _patternOimportedModule :: (Bool)
            _patternOinstancename :: (Maybe Name)
            _patternOknownKinds :: (FMap Name [Name])
            _patternOknownKinds_collect :: (FMap Name [Name])
            _patternOknownTypes :: (FMap Name [Name])
            _patternOknownTypes_collect :: (FMap Name [Name])
            _patternOknownValues :: (FMap Name [Name])
            _patternOknownValues_collect :: (FMap Name [Name])
            _patternOlabels_collect :: (FMap Name Names)
            _patternOlabels_dist :: (FMap Name Names)
            _patternOlocal :: (Bool)
            _patternOmethods_collect :: (FMap Name Names)
            _patternOmethods_dist :: (FMap Name Names)
            _patternOmoduleTypes :: (FMap ModuleName [Name])
            _patternOmoduleValues :: (FMap ModuleName [Name])
            _patternOnameType :: (NameType)
            _patternOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _patternIconstructors_collect,_patternIknownKinds_collect,_patternIknownTypes_collect,_patternIknownValues_collect,_patternIlabels_collect,_patternImethods_collect,_patternImoduleTypes,_patternImoduleValues,_patternImodules,_patternIname,_patternIres,_patternIself) =
                (pattern_ (_patternOclassname)
                          (_patternOconstructors_collect)
                          (_patternOconstructors_dist)
                          (_patternOcurrentModule)
                          (_patternOimportedModule)
                          (_patternOinstancename)
                          (_patternOknownKinds)
                          (_patternOknownKinds_collect)
                          (_patternOknownTypes)
                          (_patternOknownTypes_collect)
                          (_patternOknownValues)
                          (_patternOknownValues_collect)
                          (_patternOlabels_collect)
                          (_patternOlabels_dist)
                          (_patternOlocal)
                          (_patternOmethods_collect)
                          (_patternOmethods_dist)
                          (_patternOmoduleTypes)
                          (_patternOmoduleValues)
                          (_patternOnameType)
                          (_patternOtoplevel))
            -- "./NameTypes.inc.lag"(line 159, column 9)
            (_nameOnameType@_) =
                ref_Val
            -- "./NameTypes.inc.lag"(line 364, column 9)
            (_patternOnameType@_) =
                Def_Val
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _patternImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _patternIres
            -- self rule
            (_self@_) =
                RecordPatternBinding_RecordPatternBinding _rangeIself _nameIself _patternIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _patternIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _patternIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _patternIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _patternIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _patternIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _patternImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _patternImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _patternImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_patternOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_patternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_patternOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_patternOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_patternOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (down)
            (_patternOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_patternOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_patternOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_patternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_patternOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_patternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_patternOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_patternOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_patternOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- RecordPatternBindings ---------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for RecordPatternBindings.Cons:
      self

-}
{-
   local variables for RecordPatternBindings.Nil:
      self

-}
-- semantic domain
type T_RecordPatternBindings = (Maybe Name) ->
                               (FMap Name Names) ->
                               (FMap Name Names) ->
                               (Strings) ->
                               (Bool) ->
                               (Maybe Name) ->
                               (FMap Name [Name]) ->
                               (FMap Name [Name]) ->
                               (FMap Name [Name]) ->
                               (FMap Name [Name]) ->
                               (FMap Name [Name]) ->
                               (FMap Name [Name]) ->
                               (FMap Name Names) ->
                               (FMap Name Names) ->
                               (Bool) ->
                               (FMap Name Names) ->
                               (FMap Name Names) ->
                               (FMap ModuleName [Name]) ->
                               (FMap ModuleName [Name]) ->
                               (NameType) ->
                               (Bool) ->
                               ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(RecordPatternBindings))
-- cata
sem_RecordPatternBindings :: (RecordPatternBindings) ->
                             (T_RecordPatternBindings)
sem_RecordPatternBindings (list) =
    (foldr (sem_RecordPatternBindings_Cons) (sem_RecordPatternBindings_Nil) ((map sem_RecordPatternBinding list)))
sem_RecordPatternBindings_Cons :: (T_RecordPatternBinding) ->
                                  (T_RecordPatternBindings) ->
                                  (T_RecordPatternBindings)
sem_RecordPatternBindings_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (RecordPatternBindings)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIknownKinds_collect :: (FMap Name [Name])
            _hdIknownTypes_collect :: (FMap Name [Name])
            _hdIknownValues_collect :: (FMap Name [Name])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdImoduleTypes :: (FMap ModuleName [Name])
            _hdImoduleValues :: (FMap ModuleName [Name])
            _hdImodules :: (Set.Set Strings)
            _hdIres :: ([ResolveResult])
            _hdIself :: (RecordPatternBinding)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOknownKinds :: (FMap Name [Name])
            _hdOknownKinds_collect :: (FMap Name [Name])
            _hdOknownTypes :: (FMap Name [Name])
            _hdOknownTypes_collect :: (FMap Name [Name])
            _hdOknownValues :: (FMap Name [Name])
            _hdOknownValues_collect :: (FMap Name [Name])
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmoduleTypes :: (FMap ModuleName [Name])
            _hdOmoduleValues :: (FMap ModuleName [Name])
            _hdOnameType :: (NameType)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIknownKinds_collect :: (FMap Name [Name])
            _tlIknownTypes_collect :: (FMap Name [Name])
            _tlIknownValues_collect :: (FMap Name [Name])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlImoduleTypes :: (FMap ModuleName [Name])
            _tlImoduleValues :: (FMap ModuleName [Name])
            _tlImodules :: (Set.Set Strings)
            _tlIres :: ([ResolveResult])
            _tlIself :: (RecordPatternBindings)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOknownKinds :: (FMap Name [Name])
            _tlOknownKinds_collect :: (FMap Name [Name])
            _tlOknownTypes :: (FMap Name [Name])
            _tlOknownTypes_collect :: (FMap Name [Name])
            _tlOknownValues :: (FMap Name [Name])
            _tlOknownValues_collect :: (FMap Name [Name])
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmoduleTypes :: (FMap ModuleName [Name])
            _tlOmoduleValues :: (FMap ModuleName [Name])
            _tlOnameType :: (NameType)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIknownKinds_collect,_hdIknownTypes_collect,_hdIknownValues_collect,_hdIlabels_collect,_hdImethods_collect,_hdImoduleTypes,_hdImoduleValues,_hdImodules,_hdIres,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOimportedModule) (_hdOinstancename) (_hdOknownKinds) (_hdOknownKinds_collect) (_hdOknownTypes) (_hdOknownTypes_collect) (_hdOknownValues) (_hdOknownValues_collect) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOmoduleTypes) (_hdOmoduleValues) (_hdOnameType) (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIknownKinds_collect,_tlIknownTypes_collect,_tlIknownValues_collect,_tlIlabels_collect,_tlImethods_collect,_tlImoduleTypes,_tlImoduleValues,_tlImodules,_tlIres,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOimportedModule) (_tlOinstancename) (_tlOknownKinds) (_tlOknownKinds_collect) (_tlOknownTypes) (_tlOknownTypes_collect) (_tlOknownValues) (_tlOknownValues_collect) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOmoduleTypes) (_tlOmoduleValues) (_tlOnameType) (_tlOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _hdImodules `Set.union` _tlImodules
            -- use rule
            (_lhsOres@_) =
                _hdIres ++ _tlIres
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _tlIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _tlIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _tlIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _tlImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _tlImoduleValues
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_hdOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_hdOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_hdOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_hdOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_hdOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_hdOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_hdOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_tlOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_tlOknownKinds_collect@_) =
                _hdIknownKinds_collect
            -- copy rule (down)
            (_tlOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_tlOknownTypes_collect@_) =
                _hdIknownTypes_collect
            -- copy rule (down)
            (_tlOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_tlOknownValues_collect@_) =
                _hdIknownValues_collect
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_tlOmoduleTypes@_) =
                _hdImoduleTypes
            -- copy rule (chain)
            (_tlOmoduleValues@_) =
                _hdImoduleValues
            -- copy rule (down)
            (_tlOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_RecordPatternBindings_Nil :: (T_RecordPatternBindings)
sem_RecordPatternBindings_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (RecordPatternBindings)
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- RightHandSide -----------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for RightHandSide.Expression:
      knownValues
      instancename
      classname
      self

-}
{-
   local variables for RightHandSide.Guarded:
      knownValues
      instancename
      classname
      self

-}
-- semantic domain
type T_RightHandSide = (Maybe Name) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (Strings) ->
                       (Bool) ->
                       (Maybe Name) ->
                       (FMap Name [Name]) ->
                       (FMap Name [Name]) ->
                       (FMap Name [Name]) ->
                       (FMap Name [Name]) ->
                       (FMap Name [Name]) ->
                       (FMap Name [Name]) ->
                       (FMap Name [Name]) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (Bool) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (FMap ModuleName [Name]) ->
                       (FMap ModuleName [Name]) ->
                       (NameType) ->
                       (Bool) ->
                       ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(RightHandSide))
-- cata
sem_RightHandSide :: (RightHandSide) ->
                     (T_RightHandSide)
sem_RightHandSide ((RightHandSide_Expression (_range) (_expression) (_where))) =
    (sem_RightHandSide_Expression ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_MaybeDeclarations (_where))))
sem_RightHandSide ((RightHandSide_Guarded (_range) (_guardedexpressions) (_where))) =
    (sem_RightHandSide_Guarded ((sem_Range (_range))) ((sem_GuardedExpressions (_guardedexpressions))) ((sem_MaybeDeclarations (_where))))
sem_RightHandSide_Expression :: (T_Range) ->
                                (T_Expression) ->
                                (T_MaybeDeclarations) ->
                                (T_RightHandSide)
sem_RightHandSide_Expression (range_) (expression_) (where_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (RightHandSide)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIknownKinds_collect :: (FMap Name [Name])
            _expressionIknownTypes_collect :: (FMap Name [Name])
            _expressionIknownValues_collect :: (FMap Name [Name])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionImoduleTypes :: (FMap ModuleName [Name])
            _expressionImoduleValues :: (FMap ModuleName [Name])
            _expressionImodules :: (Set.Set Strings)
            _expressionIres :: ([ResolveResult])
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOknownGenerics :: (FMap Name [Name])
            _expressionOknownKinds :: (FMap Name [Name])
            _expressionOknownKinds_collect :: (FMap Name [Name])
            _expressionOknownTypes :: (FMap Name [Name])
            _expressionOknownTypes_collect :: (FMap Name [Name])
            _expressionOknownValues :: (FMap Name [Name])
            _expressionOknownValues_collect :: (FMap Name [Name])
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmoduleTypes :: (FMap ModuleName [Name])
            _expressionOmoduleValues :: (FMap ModuleName [Name])
            _expressionOnameType :: (NameType)
            _expressionOtoplevel :: (Bool)
            _whereIconstructors_collect :: (FMap Name Names)
            _whereIknownKinds_collect :: (FMap Name [Name])
            _whereIknownTypes_collect :: (FMap Name [Name])
            _whereIknownValues_collect :: (FMap Name [Name])
            _whereIlabels_collect :: (FMap Name Names)
            _whereImethods_collect :: (FMap Name Names)
            _whereImoduleTypes :: (FMap ModuleName [Name])
            _whereImoduleValues :: (FMap ModuleName [Name])
            _whereImodules :: (Set.Set Strings)
            _whereIres :: ([ResolveResult])
            _whereIself :: (MaybeDeclarations)
            _whereOclassname :: (Maybe Name)
            _whereOconstructors_collect :: (FMap Name Names)
            _whereOconstructors_dist :: (FMap Name Names)
            _whereOcurrentModule :: (Strings)
            _whereOimportedModule :: (Bool)
            _whereOinstancename :: (Maybe Name)
            _whereOknownGenerics :: (FMap Name [Name])
            _whereOknownKinds :: (FMap Name [Name])
            _whereOknownKinds_collect :: (FMap Name [Name])
            _whereOknownTypes :: (FMap Name [Name])
            _whereOknownTypes_collect :: (FMap Name [Name])
            _whereOknownValues :: (FMap Name [Name])
            _whereOknownValues_collect :: (FMap Name [Name])
            _whereOlabels_collect :: (FMap Name Names)
            _whereOlabels_dist :: (FMap Name Names)
            _whereOlocal :: (Bool)
            _whereOmethods_collect :: (FMap Name Names)
            _whereOmethods_dist :: (FMap Name Names)
            _whereOmoduleTypes :: (FMap ModuleName [Name])
            _whereOmoduleValues :: (FMap ModuleName [Name])
            _whereOnameType :: (NameType)
            _whereOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionIconstructors_collect,_expressionIknownKinds_collect,_expressionIknownTypes_collect,_expressionIknownValues_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionImoduleTypes,_expressionImoduleValues,_expressionImodules,_expressionIres,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOknownGenerics)
                             (_expressionOknownKinds)
                             (_expressionOknownKinds_collect)
                             (_expressionOknownTypes)
                             (_expressionOknownTypes_collect)
                             (_expressionOknownValues)
                             (_expressionOknownValues_collect)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmoduleTypes)
                             (_expressionOmoduleValues)
                             (_expressionOnameType)
                             (_expressionOtoplevel))
            ( _whereIconstructors_collect,_whereIknownKinds_collect,_whereIknownTypes_collect,_whereIknownValues_collect,_whereIlabels_collect,_whereImethods_collect,_whereImoduleTypes,_whereImoduleValues,_whereImodules,_whereIres,_whereIself) =
                (where_ (_whereOclassname)
                        (_whereOconstructors_collect)
                        (_whereOconstructors_dist)
                        (_whereOcurrentModule)
                        (_whereOimportedModule)
                        (_whereOinstancename)
                        (_whereOknownGenerics)
                        (_whereOknownKinds)
                        (_whereOknownKinds_collect)
                        (_whereOknownTypes)
                        (_whereOknownTypes_collect)
                        (_whereOknownValues)
                        (_whereOknownValues_collect)
                        (_whereOlabels_collect)
                        (_whereOlabels_dist)
                        (_whereOlocal)
                        (_whereOmethods_collect)
                        (_whereOmethods_dist)
                        (_whereOmoduleTypes)
                        (_whereOmoduleValues)
                        (_whereOnameType)
                        (_whereOtoplevel))
            -- "./Names.inc.lag"(line 635, column 9)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- "./Names.inc.lag"(line 634, column 9)
            (_knownValues@_) =
                _whereIknownValues_collect `mergeFM` _lhsIknownValues
            -- "./Names.inc.lag"(line 633, column 9)
            (_whereOknownValues_collect@_) =
                emptyFM
            -- "./ModuleInformation.inc.lag"(line 196, column 8)
            (_instancename@_) =
                Nothing
            -- "./ModuleInformation.inc.lag"(line 195, column 8)
            (_classname@_) =
                Nothing
            -- use rule
            (_lhsOmodules@_) =
                _expressionImodules `Set.union` _whereImodules
            -- use rule
            (_lhsOres@_) =
                _expressionIres ++ _whereIres
            -- self rule
            (_self@_) =
                RightHandSide_Expression _rangeIself _expressionIself _whereIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _whereIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _whereIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _whereIknownTypes_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _whereIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _whereImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _whereImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _whereImoduleValues
            -- copy rule (chain)
            (_rangeOclassname@_) =
                _classname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (chain)
            (_rangeOinstancename@_) =
                _instancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_expressionOclassname@_) =
                _classname
            -- copy rule (down)
            (_expressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (chain)
            (_expressionOinstancename@_) =
                _instancename
            -- copy rule (down)
            (_expressionOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_expressionOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_expressionOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_expressionOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_expressionOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_expressionOknownValues@_) =
                _knownValues
            -- copy rule (down)
            (_expressionOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_expressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_expressionOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_expressionOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_whereOclassname@_) =
                _classname
            -- copy rule (chain)
            (_whereOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (down)
            (_whereOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_whereOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_whereOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (chain)
            (_whereOinstancename@_) =
                _instancename
            -- copy rule (down)
            (_whereOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_whereOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_whereOknownKinds_collect@_) =
                _expressionIknownKinds_collect
            -- copy rule (down)
            (_whereOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_whereOknownTypes_collect@_) =
                _expressionIknownTypes_collect
            -- copy rule (chain)
            (_whereOknownValues@_) =
                _knownValues
            -- copy rule (chain)
            (_whereOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (down)
            (_whereOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_whereOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_whereOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (down)
            (_whereOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_whereOmoduleTypes@_) =
                _expressionImoduleTypes
            -- copy rule (chain)
            (_whereOmoduleValues@_) =
                _expressionImoduleValues
            -- copy rule (down)
            (_whereOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_whereOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_RightHandSide_Guarded :: (T_Range) ->
                             (T_GuardedExpressions) ->
                             (T_MaybeDeclarations) ->
                             (T_RightHandSide)
sem_RightHandSide_Guarded (range_) (guardedexpressions_) (where_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (RightHandSide)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _guardedexpressionsIconstructors_collect :: (FMap Name Names)
            _guardedexpressionsIknownKinds_collect :: (FMap Name [Name])
            _guardedexpressionsIknownTypes_collect :: (FMap Name [Name])
            _guardedexpressionsIknownValues_collect :: (FMap Name [Name])
            _guardedexpressionsIlabels_collect :: (FMap Name Names)
            _guardedexpressionsImethods_collect :: (FMap Name Names)
            _guardedexpressionsImoduleTypes :: (FMap ModuleName [Name])
            _guardedexpressionsImoduleValues :: (FMap ModuleName [Name])
            _guardedexpressionsImodules :: (Set.Set Strings)
            _guardedexpressionsIres :: ([ResolveResult])
            _guardedexpressionsIself :: (GuardedExpressions)
            _guardedexpressionsOclassname :: (Maybe Name)
            _guardedexpressionsOconstructors_collect :: (FMap Name Names)
            _guardedexpressionsOconstructors_dist :: (FMap Name Names)
            _guardedexpressionsOcurrentModule :: (Strings)
            _guardedexpressionsOimportedModule :: (Bool)
            _guardedexpressionsOinstancename :: (Maybe Name)
            _guardedexpressionsOknownGenerics :: (FMap Name [Name])
            _guardedexpressionsOknownKinds :: (FMap Name [Name])
            _guardedexpressionsOknownKinds_collect :: (FMap Name [Name])
            _guardedexpressionsOknownTypes :: (FMap Name [Name])
            _guardedexpressionsOknownTypes_collect :: (FMap Name [Name])
            _guardedexpressionsOknownValues :: (FMap Name [Name])
            _guardedexpressionsOknownValues_collect :: (FMap Name [Name])
            _guardedexpressionsOlabels_collect :: (FMap Name Names)
            _guardedexpressionsOlabels_dist :: (FMap Name Names)
            _guardedexpressionsOlocal :: (Bool)
            _guardedexpressionsOmethods_collect :: (FMap Name Names)
            _guardedexpressionsOmethods_dist :: (FMap Name Names)
            _guardedexpressionsOmoduleTypes :: (FMap ModuleName [Name])
            _guardedexpressionsOmoduleValues :: (FMap ModuleName [Name])
            _guardedexpressionsOnameType :: (NameType)
            _guardedexpressionsOtoplevel :: (Bool)
            _whereIconstructors_collect :: (FMap Name Names)
            _whereIknownKinds_collect :: (FMap Name [Name])
            _whereIknownTypes_collect :: (FMap Name [Name])
            _whereIknownValues_collect :: (FMap Name [Name])
            _whereIlabels_collect :: (FMap Name Names)
            _whereImethods_collect :: (FMap Name Names)
            _whereImoduleTypes :: (FMap ModuleName [Name])
            _whereImoduleValues :: (FMap ModuleName [Name])
            _whereImodules :: (Set.Set Strings)
            _whereIres :: ([ResolveResult])
            _whereIself :: (MaybeDeclarations)
            _whereOclassname :: (Maybe Name)
            _whereOconstructors_collect :: (FMap Name Names)
            _whereOconstructors_dist :: (FMap Name Names)
            _whereOcurrentModule :: (Strings)
            _whereOimportedModule :: (Bool)
            _whereOinstancename :: (Maybe Name)
            _whereOknownGenerics :: (FMap Name [Name])
            _whereOknownKinds :: (FMap Name [Name])
            _whereOknownKinds_collect :: (FMap Name [Name])
            _whereOknownTypes :: (FMap Name [Name])
            _whereOknownTypes_collect :: (FMap Name [Name])
            _whereOknownValues :: (FMap Name [Name])
            _whereOknownValues_collect :: (FMap Name [Name])
            _whereOlabels_collect :: (FMap Name Names)
            _whereOlabels_dist :: (FMap Name Names)
            _whereOlocal :: (Bool)
            _whereOmethods_collect :: (FMap Name Names)
            _whereOmethods_dist :: (FMap Name Names)
            _whereOmoduleTypes :: (FMap ModuleName [Name])
            _whereOmoduleValues :: (FMap ModuleName [Name])
            _whereOnameType :: (NameType)
            _whereOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _guardedexpressionsIconstructors_collect,_guardedexpressionsIknownKinds_collect,_guardedexpressionsIknownTypes_collect,_guardedexpressionsIknownValues_collect,_guardedexpressionsIlabels_collect,_guardedexpressionsImethods_collect,_guardedexpressionsImoduleTypes,_guardedexpressionsImoduleValues,_guardedexpressionsImodules,_guardedexpressionsIres,_guardedexpressionsIself) =
                (guardedexpressions_ (_guardedexpressionsOclassname)
                                     (_guardedexpressionsOconstructors_collect)
                                     (_guardedexpressionsOconstructors_dist)
                                     (_guardedexpressionsOcurrentModule)
                                     (_guardedexpressionsOimportedModule)
                                     (_guardedexpressionsOinstancename)
                                     (_guardedexpressionsOknownGenerics)
                                     (_guardedexpressionsOknownKinds)
                                     (_guardedexpressionsOknownKinds_collect)
                                     (_guardedexpressionsOknownTypes)
                                     (_guardedexpressionsOknownTypes_collect)
                                     (_guardedexpressionsOknownValues)
                                     (_guardedexpressionsOknownValues_collect)
                                     (_guardedexpressionsOlabels_collect)
                                     (_guardedexpressionsOlabels_dist)
                                     (_guardedexpressionsOlocal)
                                     (_guardedexpressionsOmethods_collect)
                                     (_guardedexpressionsOmethods_dist)
                                     (_guardedexpressionsOmoduleTypes)
                                     (_guardedexpressionsOmoduleValues)
                                     (_guardedexpressionsOnameType)
                                     (_guardedexpressionsOtoplevel))
            ( _whereIconstructors_collect,_whereIknownKinds_collect,_whereIknownTypes_collect,_whereIknownValues_collect,_whereIlabels_collect,_whereImethods_collect,_whereImoduleTypes,_whereImoduleValues,_whereImodules,_whereIres,_whereIself) =
                (where_ (_whereOclassname)
                        (_whereOconstructors_collect)
                        (_whereOconstructors_dist)
                        (_whereOcurrentModule)
                        (_whereOimportedModule)
                        (_whereOinstancename)
                        (_whereOknownGenerics)
                        (_whereOknownKinds)
                        (_whereOknownKinds_collect)
                        (_whereOknownTypes)
                        (_whereOknownTypes_collect)
                        (_whereOknownValues)
                        (_whereOknownValues_collect)
                        (_whereOlabels_collect)
                        (_whereOlabels_dist)
                        (_whereOlocal)
                        (_whereOmethods_collect)
                        (_whereOmethods_dist)
                        (_whereOmoduleTypes)
                        (_whereOmoduleValues)
                        (_whereOnameType)
                        (_whereOtoplevel))
            -- "./Names.inc.lag"(line 640, column 9)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- "./Names.inc.lag"(line 639, column 9)
            (_knownValues@_) =
                _whereIknownValues_collect `mergeFM` _lhsIknownValues
            -- "./Names.inc.lag"(line 638, column 9)
            (_whereOknownValues_collect@_) =
                emptyFM
            -- "./ModuleInformation.inc.lag"(line 199, column 8)
            (_instancename@_) =
                Nothing
            -- "./ModuleInformation.inc.lag"(line 198, column 8)
            (_classname@_) =
                Nothing
            -- use rule
            (_lhsOmodules@_) =
                _guardedexpressionsImodules `Set.union` _whereImodules
            -- use rule
            (_lhsOres@_) =
                _guardedexpressionsIres ++ _whereIres
            -- self rule
            (_self@_) =
                RightHandSide_Guarded _rangeIself _guardedexpressionsIself _whereIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _whereIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _whereIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _whereIknownTypes_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _whereIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _whereImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _whereImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _whereImoduleValues
            -- copy rule (chain)
            (_rangeOclassname@_) =
                _classname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (chain)
            (_rangeOinstancename@_) =
                _instancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_guardedexpressionsOclassname@_) =
                _classname
            -- copy rule (down)
            (_guardedexpressionsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_guardedexpressionsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_guardedexpressionsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_guardedexpressionsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (chain)
            (_guardedexpressionsOinstancename@_) =
                _instancename
            -- copy rule (down)
            (_guardedexpressionsOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_guardedexpressionsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_guardedexpressionsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_guardedexpressionsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_guardedexpressionsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_guardedexpressionsOknownValues@_) =
                _knownValues
            -- copy rule (down)
            (_guardedexpressionsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_guardedexpressionsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_guardedexpressionsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_guardedexpressionsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_guardedexpressionsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_guardedexpressionsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_guardedexpressionsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_guardedexpressionsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_guardedexpressionsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_guardedexpressionsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_whereOclassname@_) =
                _classname
            -- copy rule (chain)
            (_whereOconstructors_collect@_) =
                _guardedexpressionsIconstructors_collect
            -- copy rule (down)
            (_whereOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_whereOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_whereOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (chain)
            (_whereOinstancename@_) =
                _instancename
            -- copy rule (down)
            (_whereOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_whereOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_whereOknownKinds_collect@_) =
                _guardedexpressionsIknownKinds_collect
            -- copy rule (down)
            (_whereOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_whereOknownTypes_collect@_) =
                _guardedexpressionsIknownTypes_collect
            -- copy rule (chain)
            (_whereOknownValues@_) =
                _knownValues
            -- copy rule (chain)
            (_whereOlabels_collect@_) =
                _guardedexpressionsIlabels_collect
            -- copy rule (down)
            (_whereOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_whereOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_whereOmethods_collect@_) =
                _guardedexpressionsImethods_collect
            -- copy rule (down)
            (_whereOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_whereOmoduleTypes@_) =
                _guardedexpressionsImoduleTypes
            -- copy rule (chain)
            (_whereOmoduleValues@_) =
                _guardedexpressionsImoduleValues
            -- copy rule (down)
            (_whereOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_whereOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- Root --------------------------------------------------------
{-
   inherited attributes:
      in                   : Int

   chained attributes:

   synthesised attributes:
      out                  : NameReplaceType
      self                 : SELF

-}
{-
   local variables for Root.Root:
      exportedStructures
      exportedTypes
      exportedValues
      res
      debug
      the_errors
      stop
      errors
      verbosity
      moduleTypes
      moduleValues
      knownGenerics
      knownKinds
      knownTypes
      knownValues
      knownKinds_collect
      knownTypes_collect
      knownValues_collect
      self

-}
-- semantic domain
type T_Root = (Int) ->
              ( (NameReplaceType),(Root))
-- cata
sem_Root :: (Root) ->
            (T_Root)
sem_Root ((Root_Root (_contents))) =
    (sem_Root_Root ((sem_ModuleSystem (_contents))))
sem_Root_Root :: (T_ModuleSystem) ->
                 (T_Root)
sem_Root_Root (contents_) =
    \ _lhsIin ->
        let _lhsOout :: (NameReplaceType)
            _lhsOself :: (Root)
            _contentsIcompiledModule :: (Strings)
            _contentsIconstructors_collect :: (FMap Name Names)
            _contentsIexports :: (Exports)
            _contentsIhiddenEntities :: ([(Set Name,Set Name)])
            _contentsIimportedEntities :: ([(Set Name,Set Name)])
            _contentsIknownKinds_collect :: (FMap Name [Name])
            _contentsIknownTypes_collect :: (FMap Name [Name])
            _contentsIknownValues_collect :: (FMap Name [Name])
            _contentsIlabels_collect :: (FMap Name Names)
            _contentsImethods_collect :: (FMap Name Names)
            _contentsImoduleTypes :: (FMap ModuleName [Name])
            _contentsImoduleValues :: (FMap ModuleName [Name])
            _contentsImodules :: (Set.Set Strings)
            _contentsIres :: ([ResolveResult])
            _contentsIself :: (ModuleSystem)
            _contentsOclassname :: (Maybe Name)
            _contentsOconstructors_collect :: (FMap Name Names)
            _contentsOconstructors_dist :: (FMap Name Names)
            _contentsOimportedModule :: (Bool)
            _contentsOinstancename :: (Maybe Name)
            _contentsOknownGenerics :: (FMap Name [Name])
            _contentsOknownKinds :: (FMap Name [Name])
            _contentsOknownKinds_collect :: (FMap Name [Name])
            _contentsOknownTypes :: (FMap Name [Name])
            _contentsOknownTypes_collect :: (FMap Name [Name])
            _contentsOknownValues :: (FMap Name [Name])
            _contentsOknownValues_collect :: (FMap Name [Name])
            _contentsOlabels_collect :: (FMap Name Names)
            _contentsOlabels_dist :: (FMap Name Names)
            _contentsOmethods_collect :: (FMap Name Names)
            _contentsOmethods_dist :: (FMap Name Names)
            _contentsOmoduleTypes :: (FMap ModuleName [Name])
            _contentsOmoduleValues :: (FMap ModuleName [Name])
            _contentsOnameType :: (NameType)
            _contentsOtoplevel :: (Bool)
            ( _contentsIcompiledModule,_contentsIconstructors_collect,_contentsIexports,_contentsIhiddenEntities,_contentsIimportedEntities,_contentsIknownKinds_collect,_contentsIknownTypes_collect,_contentsIknownValues_collect,_contentsIlabels_collect,_contentsImethods_collect,_contentsImoduleTypes,_contentsImoduleValues,_contentsImodules,_contentsIres,_contentsIself) =
                (contents_ (_contentsOclassname)
                           (_contentsOconstructors_collect)
                           (_contentsOconstructors_dist)
                           (_contentsOimportedModule)
                           (_contentsOinstancename)
                           (_contentsOknownGenerics)
                           (_contentsOknownKinds)
                           (_contentsOknownKinds_collect)
                           (_contentsOknownTypes)
                           (_contentsOknownTypes_collect)
                           (_contentsOknownValues)
                           (_contentsOknownValues_collect)
                           (_contentsOlabels_collect)
                           (_contentsOlabels_dist)
                           (_contentsOmethods_collect)
                           (_contentsOmethods_dist)
                           (_contentsOmoduleTypes)
                           (_contentsOmoduleValues)
                           (_contentsOnameType)
                           (_contentsOtoplevel))
            -- "NameReplace.lag"(line 285, column 9)
            (_exportedStructures@_) =
                selectEFromS
                  _knownTypes _contentsIexports
            -- "NameReplace.lag"(line 283, column 9)
            (_exportedTypes@_) =
                selectEFromT
                  _knownTypes _contentsIexports
            -- "NameReplace.lag"(line 277, column 9)
            (_exportedValues@_) =
                selectEFromV
                  _knownValues _knownTypes
                  _contentsIexports
                  _contentsIconstructors_collect
                  _contentsImethods_collect
                  _contentsIlabels_collect
            -- "NameReplace.lag"(line 388, column 9)
            (_res@_) =
                _contentsIres ++
                [Set "exported values"     _exportedValues
                ,Set "exported types"      _exportedTypes
                ,Set "exported structures" _exportedStructures
                ]
            -- "NameReplace.lag"(line 386, column 9)
            (_debug@_) =
                vcat (map filterMessages     _res)
            -- "NameReplace.lag"(line 385, column 9)
            (_the_errors@_) =
                concatMap filterResolveError _res
            -- "NameReplace.lag"(line 513, column 9)
            (_stop@_) =
                any isError _the_errors
            -- "NameReplace.lag"(line 507, column 9)
            (_errors@_) =
                (if _verbosity >= 3 then
                   (\ x -> _debug <$> x)
                 else
                   id
                ) $ printErrorsV _verbosity _the_errors
            -- "NameReplace.lag"(line 498, column 9)
            (_lhsOout@_) =
                (_errors
                ,_stop
                ,_contentsIself
                ,_exportedValues,_exportedTypes,_exportedStructures
                ,_contentsIimportedEntities
                ,_contentsIhiddenEntities
                ,_contentsImodules
                )
            -- "NameReplace.lag"(line 496, column 9)
            (_verbosity@_) =
                _lhsIin
            -- "./Names.inc.lag"(line 158, column 9)
            (_moduleTypes@_) =
                emptyFM
            -- "./Names.inc.lag"(line 157, column 9)
            (_moduleValues@_) =
                emptyFM
            -- "./Names.inc.lag"(line 155, column 9)
            (_knownGenerics@_) =
                emptyFM
            -- "./Names.inc.lag"(line 154, column 9)
            (_knownKinds@_) =
                _contentsIknownKinds_collect
            -- "./Names.inc.lag"(line 153, column 9)
            (_knownTypes@_) =
                _contentsIknownTypes_collect
            -- "./Names.inc.lag"(line 152, column 9)
            (_knownValues@_) =
                _contentsIknownValues_collect
            -- "./Names.inc.lag"(line 150, column 9)
            (_knownKinds_collect@_) =
                emptyFM
            -- "./Names.inc.lag"(line 149, column 9)
            (_knownTypes_collect@_) =
                emptyFM
            -- "./Names.inc.lag"(line 148, column 9)
            (_knownValues_collect@_) =
                emptyFM
            -- "./NameTypes.inc.lag"(line 94, column 9)
            (_contentsOnameType@_) =
                Def_Typ
            -- "./ModuleInformation.inc.lag"(line 97, column 8)
            (_contentsOinstancename@_) =
                Nothing
            -- "./ModuleInformation.inc.lag"(line 96, column 8)
            (_contentsOclassname@_) =
                Nothing
            -- "./ModuleInformation.inc.lag"(line 95, column 8)
            (_contentsOtoplevel@_) =
                True
            -- "./ModuleInformation.inc.lag"(line 94, column 8)
            (_contentsOimportedModule@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 311, column 9)
            (_contentsOlabels_dist@_) =
                _contentsIlabels_collect
            -- "./ModuleInformation.inc.lag"(line 310, column 9)
            (_contentsOmethods_dist@_) =
                _contentsImethods_collect
            -- "./ModuleInformation.inc.lag"(line 309, column 9)
            (_contentsOconstructors_dist@_) =
                _contentsIconstructors_collect
            -- "./ModuleInformation.inc.lag"(line 307, column 9)
            (_contentsOlabels_collect@_) =
                emptyFM
            -- "./ModuleInformation.inc.lag"(line 306, column 9)
            (_contentsOmethods_collect@_) =
                emptyFM
            -- "./ModuleInformation.inc.lag"(line 305, column 9)
            (_contentsOconstructors_collect@_) =
                emptyFM
            -- self rule
            (_self@_) =
                Root_Root _contentsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_contentsOknownGenerics@_) =
                _knownGenerics
            -- copy rule (chain)
            (_contentsOknownKinds@_) =
                _knownKinds
            -- copy rule (chain)
            (_contentsOknownKinds_collect@_) =
                _knownKinds_collect
            -- copy rule (chain)
            (_contentsOknownTypes@_) =
                _knownTypes
            -- copy rule (chain)
            (_contentsOknownTypes_collect@_) =
                _knownTypes_collect
            -- copy rule (chain)
            (_contentsOknownValues@_) =
                _knownValues
            -- copy rule (chain)
            (_contentsOknownValues_collect@_) =
                _knownValues_collect
            -- copy rule (chain)
            (_contentsOmoduleTypes@_) =
                _moduleTypes
            -- copy rule (chain)
            (_contentsOmoduleValues@_) =
                _moduleValues
        in  ( _lhsOout,_lhsOself)
-- SimpleType --------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypesForBody_collect : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      name                 : Name
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for SimpleType.SimpleType:
      self

-}
-- semantic domain
type T_SimpleType = (Maybe Name) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Strings) ->
                    (Bool) ->
                    (Maybe Name) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Bool) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (FMap ModuleName [Name]) ->
                    (FMap ModuleName [Name]) ->
                    (NameType) ->
                    (Bool) ->
                    ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),(Name),([ResolveResult]),(SimpleType))
-- cata
sem_SimpleType :: (SimpleType) ->
                  (T_SimpleType)
sem_SimpleType ((SimpleType_SimpleType (_range) (_name) (_typevariables))) =
    (sem_SimpleType_SimpleType ((sem_Range (_range))) ((sem_Name (_name))) ((sem_KindAnnotatedNames (_typevariables))))
sem_SimpleType_SimpleType :: (T_Range) ->
                             (T_Name) ->
                             (T_KindAnnotatedNames) ->
                             (T_SimpleType)
sem_SimpleType_SimpleType (range_) (name_) (typevariables_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypesForBody_collect
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypesForBody_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOname :: (Name)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (SimpleType)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _typevariablesIakinds :: ([MaybeKind])
            _typevariablesIconstructors_collect :: (FMap Name Names)
            _typevariablesIknownKinds_collect :: (FMap Name [Name])
            _typevariablesIknownTypes_collect :: (FMap Name [Name])
            _typevariablesIknownValues_collect :: (FMap Name [Name])
            _typevariablesIlabels_collect :: (FMap Name Names)
            _typevariablesImethods_collect :: (FMap Name Names)
            _typevariablesImoduleTypes :: (FMap ModuleName [Name])
            _typevariablesImoduleValues :: (FMap ModuleName [Name])
            _typevariablesImodules :: (Set.Set Strings)
            _typevariablesIres :: ([ResolveResult])
            _typevariablesIself :: (KindAnnotatedNames)
            _typevariablesOclassname :: (Maybe Name)
            _typevariablesOconstructors_collect :: (FMap Name Names)
            _typevariablesOconstructors_dist :: (FMap Name Names)
            _typevariablesOcurrentModule :: (Strings)
            _typevariablesOimportedModule :: (Bool)
            _typevariablesOinstancename :: (Maybe Name)
            _typevariablesOknownKinds :: (FMap Name [Name])
            _typevariablesOknownKinds_collect :: (FMap Name [Name])
            _typevariablesOknownTypes :: (FMap Name [Name])
            _typevariablesOknownTypes_collect :: (FMap Name [Name])
            _typevariablesOknownValues :: (FMap Name [Name])
            _typevariablesOknownValues_collect :: (FMap Name [Name])
            _typevariablesOlabels_collect :: (FMap Name Names)
            _typevariablesOlabels_dist :: (FMap Name Names)
            _typevariablesOlocal :: (Bool)
            _typevariablesOmethods_collect :: (FMap Name Names)
            _typevariablesOmethods_dist :: (FMap Name Names)
            _typevariablesOmoduleTypes :: (FMap ModuleName [Name])
            _typevariablesOmoduleValues :: (FMap ModuleName [Name])
            _typevariablesOnameType :: (NameType)
            _typevariablesOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _typevariablesIakinds,_typevariablesIconstructors_collect,_typevariablesIknownKinds_collect,_typevariablesIknownTypes_collect,_typevariablesIknownValues_collect,_typevariablesIlabels_collect,_typevariablesImethods_collect,_typevariablesImoduleTypes,_typevariablesImoduleValues,_typevariablesImodules,_typevariablesIres,_typevariablesIself) =
                (typevariables_ (_typevariablesOclassname)
                                (_typevariablesOconstructors_collect)
                                (_typevariablesOconstructors_dist)
                                (_typevariablesOcurrentModule)
                                (_typevariablesOimportedModule)
                                (_typevariablesOinstancename)
                                (_typevariablesOknownKinds)
                                (_typevariablesOknownKinds_collect)
                                (_typevariablesOknownTypes)
                                (_typevariablesOknownTypes_collect)
                                (_typevariablesOknownValues)
                                (_typevariablesOknownValues_collect)
                                (_typevariablesOlabels_collect)
                                (_typevariablesOlabels_dist)
                                (_typevariablesOlocal)
                                (_typevariablesOmethods_collect)
                                (_typevariablesOmethods_dist)
                                (_typevariablesOmoduleTypes)
                                (_typevariablesOmoduleValues)
                                (_typevariablesOnameType)
                                (_typevariablesOtoplevel))
            -- "./Names.inc.lag"(line 717, column 9)
            (_lhsOknownTypesForBody_collect@_) =
                _typevariablesIknownTypes_collect
            -- "./Names.inc.lag"(line 716, column 9)
            (_typevariablesOknownTypes_collect@_) =
                _lhsIknownTypesForBody_collect
            -- "./Names.inc.lag"(line 715, column 9)
            (_lhsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- "./Names.inc.lag"(line 714, column 9)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- "./NameTypes.inc.lag"(line 219, column 9)
            (_typevariablesOnameType@_) =
                Def_Typ
            -- "./NameTypes.inc.lag"(line 218, column 9)
            (_nameOnameType@_) =
                Def_Typ
            -- "./ModuleInformation.inc.lag"(line 156, column 8)
            (_typevariablesOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 393, column 9)
            (_lhsOname@_) =
                _nameIself
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _typevariablesImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _typevariablesIres
            -- self rule
            (_self@_) =
                SimpleType_SimpleType _rangeIself _nameIself _typevariablesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typevariablesIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _typevariablesIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _typevariablesIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typevariablesIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typevariablesImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _typevariablesImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _typevariablesImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typevariablesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typevariablesOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_typevariablesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typevariablesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typevariablesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typevariablesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typevariablesOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_typevariablesOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_typevariablesOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_typevariablesOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_typevariablesOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_typevariablesOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_typevariablesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typevariablesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typevariablesOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_typevariablesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_typevariablesOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_typevariablesOmoduleValues@_) =
                _nameImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypesForBody_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOname,_lhsOres,_lhsOself)
-- Statement ---------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for Statement.Empty:
      self

-}
{-
   local variables for Statement.Expression:
      self

-}
{-
   local variables for Statement.Generator:
      self

-}
{-
   local variables for Statement.Let:
      self

-}
-- semantic domain
type T_Statement = (Maybe Name) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (Strings) ->
                   (Bool) ->
                   (Maybe Name) ->
                   (FMap Name [Name]) ->
                   (FMap Name [Name]) ->
                   (FMap Name [Name]) ->
                   (FMap Name [Name]) ->
                   (FMap Name [Name]) ->
                   (FMap Name [Name]) ->
                   (FMap Name [Name]) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (Bool) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (FMap ModuleName [Name]) ->
                   (FMap ModuleName [Name]) ->
                   (NameType) ->
                   (Bool) ->
                   ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(Statement))
-- cata
sem_Statement :: (Statement) ->
                 (T_Statement)
sem_Statement ((Statement_Empty (_range))) =
    (sem_Statement_Empty ((sem_Range (_range))))
sem_Statement ((Statement_Expression (_range) (_expression))) =
    (sem_Statement_Expression ((sem_Range (_range))) ((sem_Expression (_expression))))
sem_Statement ((Statement_Generator (_range) (_pattern) (_expression))) =
    (sem_Statement_Generator ((sem_Range (_range))) ((sem_Pattern (_pattern))) ((sem_Expression (_expression))))
sem_Statement ((Statement_Let (_range) (_declarations))) =
    (sem_Statement_Let ((sem_Range (_range))) ((sem_Declarations (_declarations))))
sem_Statement_Empty :: (T_Range) ->
                       (T_Statement)
sem_Statement_Empty (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Statement)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                Statement_Empty _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Statement_Expression :: (T_Range) ->
                            (T_Expression) ->
                            (T_Statement)
sem_Statement_Expression (range_) (expression_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Statement)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIknownKinds_collect :: (FMap Name [Name])
            _expressionIknownTypes_collect :: (FMap Name [Name])
            _expressionIknownValues_collect :: (FMap Name [Name])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionImoduleTypes :: (FMap ModuleName [Name])
            _expressionImoduleValues :: (FMap ModuleName [Name])
            _expressionImodules :: (Set.Set Strings)
            _expressionIres :: ([ResolveResult])
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOknownGenerics :: (FMap Name [Name])
            _expressionOknownKinds :: (FMap Name [Name])
            _expressionOknownKinds_collect :: (FMap Name [Name])
            _expressionOknownTypes :: (FMap Name [Name])
            _expressionOknownTypes_collect :: (FMap Name [Name])
            _expressionOknownValues :: (FMap Name [Name])
            _expressionOknownValues_collect :: (FMap Name [Name])
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmoduleTypes :: (FMap ModuleName [Name])
            _expressionOmoduleValues :: (FMap ModuleName [Name])
            _expressionOnameType :: (NameType)
            _expressionOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionIconstructors_collect,_expressionIknownKinds_collect,_expressionIknownTypes_collect,_expressionIknownValues_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionImoduleTypes,_expressionImoduleValues,_expressionImodules,_expressionIres,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOknownGenerics)
                             (_expressionOknownKinds)
                             (_expressionOknownKinds_collect)
                             (_expressionOknownTypes)
                             (_expressionOknownTypes_collect)
                             (_expressionOknownValues)
                             (_expressionOknownValues_collect)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmoduleTypes)
                             (_expressionOmoduleValues)
                             (_expressionOnameType)
                             (_expressionOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _expressionImodules
            -- use rule
            (_lhsOres@_) =
                _expressionIres
            -- self rule
            (_self@_) =
                Statement_Expression _rangeIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _expressionIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _expressionIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _expressionIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _expressionImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _expressionImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_expressionOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_expressionOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_expressionOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_expressionOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_expressionOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_expressionOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_expressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_expressionOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_expressionOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Statement_Generator :: (T_Range) ->
                           (T_Pattern) ->
                           (T_Expression) ->
                           (T_Statement)
sem_Statement_Generator (range_) (pattern_) (expression_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Statement)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _patternIconstructors_collect :: (FMap Name Names)
            _patternIknownKinds_collect :: (FMap Name [Name])
            _patternIknownTypes_collect :: (FMap Name [Name])
            _patternIknownValues_collect :: (FMap Name [Name])
            _patternIlabels_collect :: (FMap Name Names)
            _patternImethods_collect :: (FMap Name Names)
            _patternImoduleTypes :: (FMap ModuleName [Name])
            _patternImoduleValues :: (FMap ModuleName [Name])
            _patternImodules :: (Set.Set Strings)
            _patternIname :: (Name)
            _patternIres :: ([ResolveResult])
            _patternIself :: (Pattern)
            _patternOclassname :: (Maybe Name)
            _patternOconstructors_collect :: (FMap Name Names)
            _patternOconstructors_dist :: (FMap Name Names)
            _patternOcurrentModule :: (Strings)
            _patternOimportedModule :: (Bool)
            _patternOinstancename :: (Maybe Name)
            _patternOknownKinds :: (FMap Name [Name])
            _patternOknownKinds_collect :: (FMap Name [Name])
            _patternOknownTypes :: (FMap Name [Name])
            _patternOknownTypes_collect :: (FMap Name [Name])
            _patternOknownValues :: (FMap Name [Name])
            _patternOknownValues_collect :: (FMap Name [Name])
            _patternOlabels_collect :: (FMap Name Names)
            _patternOlabels_dist :: (FMap Name Names)
            _patternOlocal :: (Bool)
            _patternOmethods_collect :: (FMap Name Names)
            _patternOmethods_dist :: (FMap Name Names)
            _patternOmoduleTypes :: (FMap ModuleName [Name])
            _patternOmoduleValues :: (FMap ModuleName [Name])
            _patternOnameType :: (NameType)
            _patternOtoplevel :: (Bool)
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIknownKinds_collect :: (FMap Name [Name])
            _expressionIknownTypes_collect :: (FMap Name [Name])
            _expressionIknownValues_collect :: (FMap Name [Name])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionImoduleTypes :: (FMap ModuleName [Name])
            _expressionImoduleValues :: (FMap ModuleName [Name])
            _expressionImodules :: (Set.Set Strings)
            _expressionIres :: ([ResolveResult])
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOimportedModule :: (Bool)
            _expressionOinstancename :: (Maybe Name)
            _expressionOknownGenerics :: (FMap Name [Name])
            _expressionOknownKinds :: (FMap Name [Name])
            _expressionOknownKinds_collect :: (FMap Name [Name])
            _expressionOknownTypes :: (FMap Name [Name])
            _expressionOknownTypes_collect :: (FMap Name [Name])
            _expressionOknownValues :: (FMap Name [Name])
            _expressionOknownValues_collect :: (FMap Name [Name])
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOmoduleTypes :: (FMap ModuleName [Name])
            _expressionOmoduleValues :: (FMap ModuleName [Name])
            _expressionOnameType :: (NameType)
            _expressionOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _patternIconstructors_collect,_patternIknownKinds_collect,_patternIknownTypes_collect,_patternIknownValues_collect,_patternIlabels_collect,_patternImethods_collect,_patternImoduleTypes,_patternImoduleValues,_patternImodules,_patternIname,_patternIres,_patternIself) =
                (pattern_ (_patternOclassname)
                          (_patternOconstructors_collect)
                          (_patternOconstructors_dist)
                          (_patternOcurrentModule)
                          (_patternOimportedModule)
                          (_patternOinstancename)
                          (_patternOknownKinds)
                          (_patternOknownKinds_collect)
                          (_patternOknownTypes)
                          (_patternOknownTypes_collect)
                          (_patternOknownValues)
                          (_patternOknownValues_collect)
                          (_patternOlabels_collect)
                          (_patternOlabels_dist)
                          (_patternOlocal)
                          (_patternOmethods_collect)
                          (_patternOmethods_dist)
                          (_patternOmoduleTypes)
                          (_patternOmoduleValues)
                          (_patternOnameType)
                          (_patternOtoplevel))
            ( _expressionIconstructors_collect,_expressionIknownKinds_collect,_expressionIknownTypes_collect,_expressionIknownValues_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionImoduleTypes,_expressionImoduleValues,_expressionImodules,_expressionIres,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOimportedModule)
                             (_expressionOinstancename)
                             (_expressionOknownGenerics)
                             (_expressionOknownKinds)
                             (_expressionOknownKinds_collect)
                             (_expressionOknownTypes)
                             (_expressionOknownTypes_collect)
                             (_expressionOknownValues)
                             (_expressionOknownValues_collect)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOmoduleTypes)
                             (_expressionOmoduleValues)
                             (_expressionOnameType)
                             (_expressionOtoplevel))
            -- "./NameTypes.inc.lag"(line 352, column 9)
            (_patternOnameType@_) =
                Def_Val
            -- use rule
            (_lhsOmodules@_) =
                _patternImodules `Set.union` _expressionImodules
            -- use rule
            (_lhsOres@_) =
                _patternIres ++ _expressionIres
            -- self rule
            (_self@_) =
                Statement_Generator _rangeIself _patternIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _expressionIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _expressionIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _expressionIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _expressionImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _expressionImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_patternOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_patternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_patternOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_patternOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_patternOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_patternOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_patternOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_patternOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_patternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_patternOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_patternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_patternOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_patternOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_expressionOconstructors_collect@_) =
                _patternIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_expressionOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_expressionOknownKinds_collect@_) =
                _patternIknownKinds_collect
            -- copy rule (down)
            (_expressionOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_expressionOknownTypes_collect@_) =
                _patternIknownTypes_collect
            -- copy rule (down)
            (_expressionOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_expressionOknownValues_collect@_) =
                _patternIknownValues_collect
            -- copy rule (chain)
            (_expressionOlabels_collect@_) =
                _patternIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_expressionOmethods_collect@_) =
                _patternImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_expressionOmoduleTypes@_) =
                _patternImoduleTypes
            -- copy rule (chain)
            (_expressionOmoduleValues@_) =
                _patternImoduleValues
            -- copy rule (down)
            (_expressionOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Statement_Let :: (T_Range) ->
                     (T_Declarations) ->
                     (T_Statement)
sem_Statement_Let (range_) (declarations_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Statement)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _declarationsIconstructors_collect :: (FMap Name Names)
            _declarationsIknownKinds_collect :: (FMap Name [Name])
            _declarationsIknownTypes_collect :: (FMap Name [Name])
            _declarationsIknownValues_collect :: (FMap Name [Name])
            _declarationsIlabels_collect :: (FMap Name Names)
            _declarationsImethods_collect :: (FMap Name Names)
            _declarationsImoduleTypes :: (FMap ModuleName [Name])
            _declarationsImoduleValues :: (FMap ModuleName [Name])
            _declarationsImodules :: (Set.Set Strings)
            _declarationsIres :: ([ResolveResult])
            _declarationsIself :: (Declarations)
            _declarationsOclassname :: (Maybe Name)
            _declarationsOconstructors_collect :: (FMap Name Names)
            _declarationsOconstructors_dist :: (FMap Name Names)
            _declarationsOcurrentModule :: (Strings)
            _declarationsOimportedModule :: (Bool)
            _declarationsOinstancename :: (Maybe Name)
            _declarationsOknownGenerics :: (FMap Name [Name])
            _declarationsOknownKinds :: (FMap Name [Name])
            _declarationsOknownKinds_collect :: (FMap Name [Name])
            _declarationsOknownTypes :: (FMap Name [Name])
            _declarationsOknownTypes_collect :: (FMap Name [Name])
            _declarationsOknownValues :: (FMap Name [Name])
            _declarationsOknownValues_collect :: (FMap Name [Name])
            _declarationsOlabels_collect :: (FMap Name Names)
            _declarationsOlabels_dist :: (FMap Name Names)
            _declarationsOlocal :: (Bool)
            _declarationsOmethods_collect :: (FMap Name Names)
            _declarationsOmethods_dist :: (FMap Name Names)
            _declarationsOmoduleTypes :: (FMap ModuleName [Name])
            _declarationsOmoduleValues :: (FMap ModuleName [Name])
            _declarationsOnameType :: (NameType)
            _declarationsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _declarationsIconstructors_collect,_declarationsIknownKinds_collect,_declarationsIknownTypes_collect,_declarationsIknownValues_collect,_declarationsIlabels_collect,_declarationsImethods_collect,_declarationsImoduleTypes,_declarationsImoduleValues,_declarationsImodules,_declarationsIres,_declarationsIself) =
                (declarations_ (_declarationsOclassname)
                               (_declarationsOconstructors_collect)
                               (_declarationsOconstructors_dist)
                               (_declarationsOcurrentModule)
                               (_declarationsOimportedModule)
                               (_declarationsOinstancename)
                               (_declarationsOknownGenerics)
                               (_declarationsOknownKinds)
                               (_declarationsOknownKinds_collect)
                               (_declarationsOknownTypes)
                               (_declarationsOknownTypes_collect)
                               (_declarationsOknownValues)
                               (_declarationsOknownValues_collect)
                               (_declarationsOlabels_collect)
                               (_declarationsOlabels_dist)
                               (_declarationsOlocal)
                               (_declarationsOmethods_collect)
                               (_declarationsOmethods_dist)
                               (_declarationsOmoduleTypes)
                               (_declarationsOmoduleValues)
                               (_declarationsOnameType)
                               (_declarationsOtoplevel))
            -- "./Names.inc.lag"(line 693, column 9)
            (_declarationsOknownValues@_) =
                _declarationsIknownValues_collect `mergeFM` _lhsIknownValues
            -- use rule
            (_lhsOmodules@_) =
                _declarationsImodules
            -- use rule
            (_lhsOres@_) =
                _declarationsIres
            -- self rule
            (_self@_) =
                Statement_Let _rangeIself _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _declarationsIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _declarationsIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _declarationsIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _declarationsIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _declarationsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _declarationsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _declarationsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _declarationsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_declarationsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_declarationsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_declarationsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_declarationsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_declarationsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_declarationsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_declarationsOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_declarationsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_declarationsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_declarationsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_declarationsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_declarationsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_declarationsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_declarationsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_declarationsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_declarationsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_declarationsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_declarationsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_declarationsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_declarationsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_declarationsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- Statements --------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for Statements.Cons:
      self

-}
{-
   local variables for Statements.Nil:
      self

-}
-- semantic domain
type T_Statements = (Maybe Name) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Strings) ->
                    (Bool) ->
                    (Maybe Name) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name [Name]) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Bool) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (FMap ModuleName [Name]) ->
                    (FMap ModuleName [Name]) ->
                    (NameType) ->
                    (Bool) ->
                    ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(Statements))
-- cata
sem_Statements :: (Statements) ->
                  (T_Statements)
sem_Statements (list) =
    (foldr (sem_Statements_Cons) (sem_Statements_Nil) ((map sem_Statement list)))
sem_Statements_Cons :: (T_Statement) ->
                       (T_Statements) ->
                       (T_Statements)
sem_Statements_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Statements)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIknownKinds_collect :: (FMap Name [Name])
            _hdIknownTypes_collect :: (FMap Name [Name])
            _hdIknownValues_collect :: (FMap Name [Name])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdImoduleTypes :: (FMap ModuleName [Name])
            _hdImoduleValues :: (FMap ModuleName [Name])
            _hdImodules :: (Set.Set Strings)
            _hdIres :: ([ResolveResult])
            _hdIself :: (Statement)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOknownGenerics :: (FMap Name [Name])
            _hdOknownKinds :: (FMap Name [Name])
            _hdOknownKinds_collect :: (FMap Name [Name])
            _hdOknownTypes :: (FMap Name [Name])
            _hdOknownTypes_collect :: (FMap Name [Name])
            _hdOknownValues :: (FMap Name [Name])
            _hdOknownValues_collect :: (FMap Name [Name])
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmoduleTypes :: (FMap ModuleName [Name])
            _hdOmoduleValues :: (FMap ModuleName [Name])
            _hdOnameType :: (NameType)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIknownKinds_collect :: (FMap Name [Name])
            _tlIknownTypes_collect :: (FMap Name [Name])
            _tlIknownValues_collect :: (FMap Name [Name])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlImoduleTypes :: (FMap ModuleName [Name])
            _tlImoduleValues :: (FMap ModuleName [Name])
            _tlImodules :: (Set.Set Strings)
            _tlIres :: ([ResolveResult])
            _tlIself :: (Statements)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOknownGenerics :: (FMap Name [Name])
            _tlOknownKinds :: (FMap Name [Name])
            _tlOknownKinds_collect :: (FMap Name [Name])
            _tlOknownTypes :: (FMap Name [Name])
            _tlOknownTypes_collect :: (FMap Name [Name])
            _tlOknownValues :: (FMap Name [Name])
            _tlOknownValues_collect :: (FMap Name [Name])
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmoduleTypes :: (FMap ModuleName [Name])
            _tlOmoduleValues :: (FMap ModuleName [Name])
            _tlOnameType :: (NameType)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIknownKinds_collect,_hdIknownTypes_collect,_hdIknownValues_collect,_hdIlabels_collect,_hdImethods_collect,_hdImoduleTypes,_hdImoduleValues,_hdImodules,_hdIres,_hdIself) =
                (hd_ (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOknownGenerics)
                     (_hdOknownKinds)
                     (_hdOknownKinds_collect)
                     (_hdOknownTypes)
                     (_hdOknownTypes_collect)
                     (_hdOknownValues)
                     (_hdOknownValues_collect)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmoduleTypes)
                     (_hdOmoduleValues)
                     (_hdOnameType)
                     (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIknownKinds_collect,_tlIknownTypes_collect,_tlIknownValues_collect,_tlIlabels_collect,_tlImethods_collect,_tlImoduleTypes,_tlImoduleValues,_tlImodules,_tlIres,_tlIself) =
                (tl_ (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOknownGenerics)
                     (_tlOknownKinds)
                     (_tlOknownKinds_collect)
                     (_tlOknownTypes)
                     (_tlOknownTypes_collect)
                     (_tlOknownValues)
                     (_tlOknownValues_collect)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmoduleTypes)
                     (_tlOmoduleValues)
                     (_tlOnameType)
                     (_tlOtoplevel))
            -- "./Names.inc.lag"(line 689, column 9)
            (_lhsOknownValues_collect@_) =
                _tlIknownValues_collect
            -- "./Names.inc.lag"(line 688, column 9)
            (_tlOknownValues@_) =
                _hdIknownValues_collect `mergeFM` _lhsIknownValues
            -- "./Names.inc.lag"(line 687, column 9)
            (_hdOknownValues_collect@_) =
                emptyFM
            -- use rule
            (_lhsOmodules@_) =
                _hdImodules `Set.union` _tlImodules
            -- use rule
            (_lhsOres@_) =
                _hdIres ++ _tlIres
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _tlIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _tlIknownTypes_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _tlImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _tlImoduleValues
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_hdOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_hdOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_hdOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_hdOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_hdOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_hdOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_hdOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_tlOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_tlOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_tlOknownKinds_collect@_) =
                _hdIknownKinds_collect
            -- copy rule (down)
            (_tlOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_tlOknownTypes_collect@_) =
                _hdIknownTypes_collect
            -- copy rule (chain)
            (_tlOknownValues_collect@_) =
                _hdIknownValues_collect
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_tlOmoduleTypes@_) =
                _hdImoduleTypes
            -- copy rule (chain)
            (_tlOmoduleValues@_) =
                _hdImoduleValues
            -- copy rule (down)
            (_tlOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Statements_Nil :: (T_Statements)
sem_Statements_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Statements)
            -- "./Names.inc.lag"(line 685, column 9)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- Strings -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for Strings.Cons:
      self

-}
{-
   local variables for Strings.Nil:
      self

-}
-- semantic domain
type T_Strings = (Maybe Name) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Strings) ->
                 (Bool) ->
                 (Maybe Name) ->
                 (FMap Name [Name]) ->
                 (FMap Name [Name]) ->
                 (FMap Name [Name]) ->
                 (FMap Name [Name]) ->
                 (FMap Name [Name]) ->
                 (FMap Name [Name]) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Bool) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (FMap ModuleName [Name]) ->
                 (FMap ModuleName [Name]) ->
                 (NameType) ->
                 (Bool) ->
                 ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(Strings))
-- cata
sem_Strings :: (Strings) ->
               (T_Strings)
sem_Strings (list) =
    (foldr (sem_Strings_Cons) (sem_Strings_Nil) (list))
sem_Strings_Cons :: (String) ->
                    (T_Strings) ->
                    (T_Strings)
sem_Strings_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Strings)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIknownKinds_collect :: (FMap Name [Name])
            _tlIknownTypes_collect :: (FMap Name [Name])
            _tlIknownValues_collect :: (FMap Name [Name])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlImoduleTypes :: (FMap ModuleName [Name])
            _tlImoduleValues :: (FMap ModuleName [Name])
            _tlImodules :: (Set.Set Strings)
            _tlIres :: ([ResolveResult])
            _tlIself :: (Strings)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOknownKinds :: (FMap Name [Name])
            _tlOknownKinds_collect :: (FMap Name [Name])
            _tlOknownTypes :: (FMap Name [Name])
            _tlOknownTypes_collect :: (FMap Name [Name])
            _tlOknownValues :: (FMap Name [Name])
            _tlOknownValues_collect :: (FMap Name [Name])
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmoduleTypes :: (FMap ModuleName [Name])
            _tlOmoduleValues :: (FMap ModuleName [Name])
            _tlOnameType :: (NameType)
            _tlOtoplevel :: (Bool)
            ( _tlIconstructors_collect,_tlIknownKinds_collect,_tlIknownTypes_collect,_tlIknownValues_collect,_tlIlabels_collect,_tlImethods_collect,_tlImoduleTypes,_tlImoduleValues,_tlImodules,_tlIres,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOimportedModule) (_tlOinstancename) (_tlOknownKinds) (_tlOknownKinds_collect) (_tlOknownTypes) (_tlOknownTypes_collect) (_tlOknownValues) (_tlOknownValues_collect) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOmoduleTypes) (_tlOmoduleValues) (_tlOnameType) (_tlOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _tlImodules
            -- use rule
            (_lhsOres@_) =
                _tlIres
            -- self rule
            (_self@_) =
                (:) hd_ _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _tlIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _tlIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _tlIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _tlImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _tlImoduleValues
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_tlOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_tlOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_tlOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_tlOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_tlOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_tlOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_tlOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_tlOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_tlOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_tlOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_tlOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Strings_Nil :: (T_Strings)
sem_Strings_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Strings)
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- Type --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for Type.Application:
      self

-}
{-
   local variables for Type.Con:
      self

-}
{-
   local variables for Type.Constructor:
      self

-}
{-
   local variables for Type.ConstructorCase:
      self

-}
{-
   local variables for Type.Exists:
      knownTypes
      self

-}
{-
   local variables for Type.Forall:
      knownTypes
      self

-}
{-
   local variables for Type.KindApplication:
      self

-}
{-
   local variables for Type.KindStarCase:
      self

-}
{-
   local variables for Type.Kinded:
      self

-}
{-
   local variables for Type.Label:
      self

-}
{-
   local variables for Type.Parenthesized:
      self

-}
{-
   local variables for Type.Qualified:
      self

-}
{-
   local variables for Type.TypeApplication:
      self

-}
{-
   local variables for Type.TypeSignature:
      self

-}
{-
   local variables for Type.Variable:
      self

-}
-- semantic domain
type T_Type = (Maybe Name) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (Strings) ->
              (Bool) ->
              (Maybe Name) ->
              (FMap Name [Name]) ->
              (FMap Name [Name]) ->
              (FMap Name [Name]) ->
              (FMap Name [Name]) ->
              (FMap Name [Name]) ->
              (FMap Name [Name]) ->
              (FMap Name [Name]) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (Bool) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (FMap ModuleName [Name]) ->
              (FMap ModuleName [Name]) ->
              (NameType) ->
              (Bool) ->
              ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(Type))
-- cata
sem_Type :: (Type) ->
            (T_Type)
sem_Type ((Type_Application (_range) (_prefix) (_function) (_arguments))) =
    (sem_Type_Application ((sem_Range (_range))) (_prefix) ((sem_Type (_function))) ((sem_Types (_arguments))))
sem_Type ((Type_Con (_range) (_name))) =
    (sem_Type_Con ((sem_Range (_range))) ((sem_Name (_name))))
sem_Type ((Type_Constructor (_range) (_name))) =
    (sem_Type_Constructor ((sem_Range (_range))) ((sem_Name (_name))))
sem_Type ((Type_ConstructorCase (_range) (_name))) =
    (sem_Type_ConstructorCase ((sem_Range (_range))) ((sem_Name (_name))))
sem_Type ((Type_Exists (_range) (_typevariables) (_type))) =
    (sem_Type_Exists ((sem_Range (_range))) ((sem_Names (_typevariables))) ((sem_Type (_type))))
sem_Type ((Type_Forall (_range) (_typevariables) (_type))) =
    (sem_Type_Forall ((sem_Range (_range))) ((sem_Names (_typevariables))) ((sem_Type (_type))))
sem_Type ((Type_KindApplication (_range) (_name) (_kind))) =
    (sem_Type_KindApplication ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Kind (_kind))))
sem_Type ((Type_KindStarCase (_range))) =
    (sem_Type_KindStarCase ((sem_Range (_range))))
sem_Type ((Type_Kinded (_range) (_name) (_kind))) =
    (sem_Type_Kinded ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Kind (_kind))))
sem_Type ((Type_Label (_range) (_name))) =
    (sem_Type_Label ((sem_Range (_range))) ((sem_Name (_name))))
sem_Type ((Type_Parenthesized (_range) (_type))) =
    (sem_Type_Parenthesized ((sem_Range (_range))) ((sem_Type (_type))))
sem_Type ((Type_Qualified (_range) (_context) (_type))) =
    (sem_Type_Qualified ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_Type (_type))))
sem_Type ((Type_TypeApplication (_range) (_name) (_type))) =
    (sem_Type_TypeApplication ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Type (_type))))
sem_Type ((Type_TypeSignature (_range) (_generics) (_parametrics))) =
    (sem_Type_TypeSignature ((sem_Range (_range))) ((sem_KindAnnotatedNames (_generics))) ((sem_Types (_parametrics))))
sem_Type ((Type_Variable (_range) (_name))) =
    (sem_Type_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Type_Application :: (T_Range) ->
                        (Bool) ->
                        (T_Type) ->
                        (T_Types) ->
                        (T_Type)
sem_Type_Application (range_) (prefix_) (function_) (arguments_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _functionIconstructors_collect :: (FMap Name Names)
            _functionIknownKinds_collect :: (FMap Name [Name])
            _functionIknownTypes_collect :: (FMap Name [Name])
            _functionIknownValues_collect :: (FMap Name [Name])
            _functionIlabels_collect :: (FMap Name Names)
            _functionImethods_collect :: (FMap Name Names)
            _functionImoduleTypes :: (FMap ModuleName [Name])
            _functionImoduleValues :: (FMap ModuleName [Name])
            _functionImodules :: (Set.Set Strings)
            _functionIres :: ([ResolveResult])
            _functionIself :: (Type)
            _functionOclassname :: (Maybe Name)
            _functionOconstructors_collect :: (FMap Name Names)
            _functionOconstructors_dist :: (FMap Name Names)
            _functionOcurrentModule :: (Strings)
            _functionOimportedModule :: (Bool)
            _functionOinstancename :: (Maybe Name)
            _functionOknownGenerics :: (FMap Name [Name])
            _functionOknownKinds :: (FMap Name [Name])
            _functionOknownKinds_collect :: (FMap Name [Name])
            _functionOknownTypes :: (FMap Name [Name])
            _functionOknownTypes_collect :: (FMap Name [Name])
            _functionOknownValues :: (FMap Name [Name])
            _functionOknownValues_collect :: (FMap Name [Name])
            _functionOlabels_collect :: (FMap Name Names)
            _functionOlabels_dist :: (FMap Name Names)
            _functionOlocal :: (Bool)
            _functionOmethods_collect :: (FMap Name Names)
            _functionOmethods_dist :: (FMap Name Names)
            _functionOmoduleTypes :: (FMap ModuleName [Name])
            _functionOmoduleValues :: (FMap ModuleName [Name])
            _functionOnameType :: (NameType)
            _functionOtoplevel :: (Bool)
            _argumentsIconstructors_collect :: (FMap Name Names)
            _argumentsIknownKinds_collect :: (FMap Name [Name])
            _argumentsIknownTypes_collect :: (FMap Name [Name])
            _argumentsIknownValues_collect :: (FMap Name [Name])
            _argumentsIlabels_collect :: (FMap Name Names)
            _argumentsImethods_collect :: (FMap Name Names)
            _argumentsImoduleTypes :: (FMap ModuleName [Name])
            _argumentsImoduleValues :: (FMap ModuleName [Name])
            _argumentsImodules :: (Set.Set Strings)
            _argumentsIres :: ([ResolveResult])
            _argumentsIself :: (Types)
            _argumentsOclassname :: (Maybe Name)
            _argumentsOconstructors_collect :: (FMap Name Names)
            _argumentsOconstructors_dist :: (FMap Name Names)
            _argumentsOcurrentModule :: (Strings)
            _argumentsOimportedModule :: (Bool)
            _argumentsOinstancename :: (Maybe Name)
            _argumentsOknownGenerics :: (FMap Name [Name])
            _argumentsOknownKinds :: (FMap Name [Name])
            _argumentsOknownKinds_collect :: (FMap Name [Name])
            _argumentsOknownTypes :: (FMap Name [Name])
            _argumentsOknownTypes_collect :: (FMap Name [Name])
            _argumentsOknownValues :: (FMap Name [Name])
            _argumentsOknownValues_collect :: (FMap Name [Name])
            _argumentsOlabels_collect :: (FMap Name Names)
            _argumentsOlabels_dist :: (FMap Name Names)
            _argumentsOlocal :: (Bool)
            _argumentsOmethods_collect :: (FMap Name Names)
            _argumentsOmethods_dist :: (FMap Name Names)
            _argumentsOmoduleTypes :: (FMap ModuleName [Name])
            _argumentsOmoduleValues :: (FMap ModuleName [Name])
            _argumentsOnameType :: (NameType)
            _argumentsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _functionIconstructors_collect,_functionIknownKinds_collect,_functionIknownTypes_collect,_functionIknownValues_collect,_functionIlabels_collect,_functionImethods_collect,_functionImoduleTypes,_functionImoduleValues,_functionImodules,_functionIres,_functionIself) =
                (function_ (_functionOclassname)
                           (_functionOconstructors_collect)
                           (_functionOconstructors_dist)
                           (_functionOcurrentModule)
                           (_functionOimportedModule)
                           (_functionOinstancename)
                           (_functionOknownGenerics)
                           (_functionOknownKinds)
                           (_functionOknownKinds_collect)
                           (_functionOknownTypes)
                           (_functionOknownTypes_collect)
                           (_functionOknownValues)
                           (_functionOknownValues_collect)
                           (_functionOlabels_collect)
                           (_functionOlabels_dist)
                           (_functionOlocal)
                           (_functionOmethods_collect)
                           (_functionOmethods_dist)
                           (_functionOmoduleTypes)
                           (_functionOmoduleValues)
                           (_functionOnameType)
                           (_functionOtoplevel))
            ( _argumentsIconstructors_collect,_argumentsIknownKinds_collect,_argumentsIknownTypes_collect,_argumentsIknownValues_collect,_argumentsIlabels_collect,_argumentsImethods_collect,_argumentsImoduleTypes,_argumentsImoduleValues,_argumentsImodules,_argumentsIres,_argumentsIself) =
                (arguments_ (_argumentsOclassname)
                            (_argumentsOconstructors_collect)
                            (_argumentsOconstructors_dist)
                            (_argumentsOcurrentModule)
                            (_argumentsOimportedModule)
                            (_argumentsOinstancename)
                            (_argumentsOknownGenerics)
                            (_argumentsOknownKinds)
                            (_argumentsOknownKinds_collect)
                            (_argumentsOknownTypes)
                            (_argumentsOknownTypes_collect)
                            (_argumentsOknownValues)
                            (_argumentsOknownValues_collect)
                            (_argumentsOlabels_collect)
                            (_argumentsOlabels_dist)
                            (_argumentsOlocal)
                            (_argumentsOmethods_collect)
                            (_argumentsOmethods_dist)
                            (_argumentsOmoduleTypes)
                            (_argumentsOmoduleValues)
                            (_argumentsOnameType)
                            (_argumentsOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _functionImodules `Set.union` _argumentsImodules
            -- use rule
            (_lhsOres@_) =
                _functionIres ++ _argumentsIres
            -- self rule
            (_self@_) =
                Type_Application _rangeIself prefix_ _functionIself _argumentsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _argumentsIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _argumentsIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _argumentsIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _argumentsIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _argumentsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _argumentsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _argumentsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _argumentsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_functionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_functionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_functionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_functionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_functionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_functionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_functionOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_functionOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_functionOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_functionOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_functionOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_functionOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_functionOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_functionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_functionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_functionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_functionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_functionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_functionOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_functionOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_functionOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_functionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_argumentsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_argumentsOconstructors_collect@_) =
                _functionIconstructors_collect
            -- copy rule (down)
            (_argumentsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_argumentsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_argumentsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_argumentsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_argumentsOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_argumentsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_argumentsOknownKinds_collect@_) =
                _functionIknownKinds_collect
            -- copy rule (down)
            (_argumentsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_argumentsOknownTypes_collect@_) =
                _functionIknownTypes_collect
            -- copy rule (down)
            (_argumentsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_argumentsOknownValues_collect@_) =
                _functionIknownValues_collect
            -- copy rule (chain)
            (_argumentsOlabels_collect@_) =
                _functionIlabels_collect
            -- copy rule (down)
            (_argumentsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_argumentsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_argumentsOmethods_collect@_) =
                _functionImethods_collect
            -- copy rule (down)
            (_argumentsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_argumentsOmoduleTypes@_) =
                _functionImoduleTypes
            -- copy rule (chain)
            (_argumentsOmoduleValues@_) =
                _functionImoduleValues
            -- copy rule (down)
            (_argumentsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_argumentsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Type_Con :: (T_Range) ->
                (T_Name) ->
                (T_Type)
sem_Type_Con (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres
            -- self rule
            (_self@_) =
                Type_Con _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Type_Constructor :: (T_Range) ->
                        (T_Name) ->
                        (T_Type)
sem_Type_Constructor (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            -- "./NameTypes.inc.lag"(line 180, column 9)
            (_nameOnameType@_) =
                ref_Typ
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres
            -- self rule
            (_self@_) =
                Type_Constructor _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Type_ConstructorCase :: (T_Range) ->
                            (T_Name) ->
                            (T_Type)
sem_Type_ConstructorCase (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            -- "./NameTypes.inc.lag"(line 191, column 9)
            (_nameOnameType@_) =
                ref_Val
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres
            -- self rule
            (_self@_) =
                Type_ConstructorCase _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Type_Exists :: (T_Range) ->
                   (T_Names) ->
                   (T_Type) ->
                   (T_Type)
sem_Type_Exists (range_) (typevariables_) (type_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _typevariablesIconstructors_collect :: (FMap Name Names)
            _typevariablesIknownKinds_collect :: (FMap Name [Name])
            _typevariablesIknownTypes_collect :: (FMap Name [Name])
            _typevariablesIknownValues_collect :: (FMap Name [Name])
            _typevariablesIlabels_collect :: (FMap Name Names)
            _typevariablesImethods_collect :: (FMap Name Names)
            _typevariablesImoduleTypes :: (FMap ModuleName [Name])
            _typevariablesImoduleValues :: (FMap ModuleName [Name])
            _typevariablesImodules :: (Set.Set Strings)
            _typevariablesIoriginalSelf :: (Names)
            _typevariablesIres :: ([ResolveResult])
            _typevariablesIself :: (Names)
            _typevariablesOclassname :: (Maybe Name)
            _typevariablesOconstructors_collect :: (FMap Name Names)
            _typevariablesOconstructors_dist :: (FMap Name Names)
            _typevariablesOcurrentModule :: (Strings)
            _typevariablesOimportedModule :: (Bool)
            _typevariablesOinstancename :: (Maybe Name)
            _typevariablesOknownKinds :: (FMap Name [Name])
            _typevariablesOknownKinds_collect :: (FMap Name [Name])
            _typevariablesOknownTypes :: (FMap Name [Name])
            _typevariablesOknownTypes_collect :: (FMap Name [Name])
            _typevariablesOknownValues :: (FMap Name [Name])
            _typevariablesOknownValues_collect :: (FMap Name [Name])
            _typevariablesOlabels_collect :: (FMap Name Names)
            _typevariablesOlabels_dist :: (FMap Name Names)
            _typevariablesOlocal :: (Bool)
            _typevariablesOmethods_collect :: (FMap Name Names)
            _typevariablesOmethods_dist :: (FMap Name Names)
            _typevariablesOmoduleTypes :: (FMap ModuleName [Name])
            _typevariablesOmoduleValues :: (FMap ModuleName [Name])
            _typevariablesOnameType :: (NameType)
            _typevariablesOtoplevel :: (Bool)
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIknownKinds_collect :: (FMap Name [Name])
            _typeIknownTypes_collect :: (FMap Name [Name])
            _typeIknownValues_collect :: (FMap Name [Name])
            _typeIlabels_collect :: (FMap Name Names)
            _typeImethods_collect :: (FMap Name Names)
            _typeImoduleTypes :: (FMap ModuleName [Name])
            _typeImoduleValues :: (FMap ModuleName [Name])
            _typeImodules :: (Set.Set Strings)
            _typeIres :: ([ResolveResult])
            _typeIself :: (Type)
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOimportedModule :: (Bool)
            _typeOinstancename :: (Maybe Name)
            _typeOknownGenerics :: (FMap Name [Name])
            _typeOknownKinds :: (FMap Name [Name])
            _typeOknownKinds_collect :: (FMap Name [Name])
            _typeOknownTypes :: (FMap Name [Name])
            _typeOknownTypes_collect :: (FMap Name [Name])
            _typeOknownValues :: (FMap Name [Name])
            _typeOknownValues_collect :: (FMap Name [Name])
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOmoduleTypes :: (FMap ModuleName [Name])
            _typeOmoduleValues :: (FMap ModuleName [Name])
            _typeOnameType :: (NameType)
            _typeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _typevariablesIconstructors_collect,_typevariablesIknownKinds_collect,_typevariablesIknownTypes_collect,_typevariablesIknownValues_collect,_typevariablesIlabels_collect,_typevariablesImethods_collect,_typevariablesImoduleTypes,_typevariablesImoduleValues,_typevariablesImodules,_typevariablesIoriginalSelf,_typevariablesIres,_typevariablesIself) =
                (typevariables_ (_typevariablesOclassname)
                                (_typevariablesOconstructors_collect)
                                (_typevariablesOconstructors_dist)
                                (_typevariablesOcurrentModule)
                                (_typevariablesOimportedModule)
                                (_typevariablesOinstancename)
                                (_typevariablesOknownKinds)
                                (_typevariablesOknownKinds_collect)
                                (_typevariablesOknownTypes)
                                (_typevariablesOknownTypes_collect)
                                (_typevariablesOknownValues)
                                (_typevariablesOknownValues_collect)
                                (_typevariablesOlabels_collect)
                                (_typevariablesOlabels_dist)
                                (_typevariablesOlocal)
                                (_typevariablesOmethods_collect)
                                (_typevariablesOmethods_dist)
                                (_typevariablesOmoduleTypes)
                                (_typevariablesOmoduleValues)
                                (_typevariablesOnameType)
                                (_typevariablesOtoplevel))
            ( _typeIconstructors_collect,_typeIknownKinds_collect,_typeIknownTypes_collect,_typeIknownValues_collect,_typeIlabels_collect,_typeImethods_collect,_typeImoduleTypes,_typeImoduleValues,_typeImodules,_typeIres,_typeIself) =
                (type_ (_typeOclassname)
                       (_typeOconstructors_collect)
                       (_typeOconstructors_dist)
                       (_typeOcurrentModule)
                       (_typeOimportedModule)
                       (_typeOinstancename)
                       (_typeOknownGenerics)
                       (_typeOknownKinds)
                       (_typeOknownKinds_collect)
                       (_typeOknownTypes)
                       (_typeOknownTypes_collect)
                       (_typeOknownValues)
                       (_typeOknownValues_collect)
                       (_typeOlabels_collect)
                       (_typeOlabels_dist)
                       (_typeOlocal)
                       (_typeOmethods_collect)
                       (_typeOmethods_dist)
                       (_typeOmoduleTypes)
                       (_typeOmoduleValues)
                       (_typeOnameType)
                       (_typeOtoplevel))
            -- "./Names.inc.lag"(line 613, column 9)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- "./Names.inc.lag"(line 612, column 9)
            (_knownTypes@_) =
                _typevariablesIknownTypes_collect `mergeFM` _lhsIknownTypes
            -- "./Names.inc.lag"(line 611, column 9)
            (_typevariablesOknownTypes_collect@_) =
                emptyFM
            -- "./NameTypes.inc.lag"(line 184, column 9)
            (_typevariablesOnameType@_) =
                Def_Typ
            -- use rule
            (_lhsOmodules@_) =
                _typevariablesImodules `Set.union` _typeImodules
            -- use rule
            (_lhsOres@_) =
                _typevariablesIres ++ _typeIres
            -- self rule
            (_self@_) =
                Type_Exists _rangeIself _typevariablesIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _typeIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _typeIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _typeImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _typeImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typevariablesOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_typevariablesOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_typevariablesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typevariablesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typevariablesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typevariablesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typevariablesOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_typevariablesOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_typevariablesOknownTypes@_) =
                _knownTypes
            -- copy rule (down)
            (_typevariablesOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_typevariablesOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_typevariablesOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_typevariablesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typevariablesOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_typevariablesOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_typevariablesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typevariablesOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_typevariablesOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_typevariablesOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _typevariablesIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typeOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_typeOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_typeOknownKinds_collect@_) =
                _typevariablesIknownKinds_collect
            -- copy rule (chain)
            (_typeOknownTypes@_) =
                _knownTypes
            -- copy rule (chain)
            (_typeOknownTypes_collect@_) =
                _typevariablesIknownTypes_collect
            -- copy rule (down)
            (_typeOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_typeOknownValues_collect@_) =
                _typevariablesIknownValues_collect
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _typevariablesIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _typevariablesImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_typeOmoduleTypes@_) =
                _typevariablesImoduleTypes
            -- copy rule (chain)
            (_typeOmoduleValues@_) =
                _typevariablesImoduleValues
            -- copy rule (down)
            (_typeOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_typeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Type_Forall :: (T_Range) ->
                   (T_Names) ->
                   (T_Type) ->
                   (T_Type)
sem_Type_Forall (range_) (typevariables_) (type_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _typevariablesIconstructors_collect :: (FMap Name Names)
            _typevariablesIknownKinds_collect :: (FMap Name [Name])
            _typevariablesIknownTypes_collect :: (FMap Name [Name])
            _typevariablesIknownValues_collect :: (FMap Name [Name])
            _typevariablesIlabels_collect :: (FMap Name Names)
            _typevariablesImethods_collect :: (FMap Name Names)
            _typevariablesImoduleTypes :: (FMap ModuleName [Name])
            _typevariablesImoduleValues :: (FMap ModuleName [Name])
            _typevariablesImodules :: (Set.Set Strings)
            _typevariablesIoriginalSelf :: (Names)
            _typevariablesIres :: ([ResolveResult])
            _typevariablesIself :: (Names)
            _typevariablesOclassname :: (Maybe Name)
            _typevariablesOconstructors_collect :: (FMap Name Names)
            _typevariablesOconstructors_dist :: (FMap Name Names)
            _typevariablesOcurrentModule :: (Strings)
            _typevariablesOimportedModule :: (Bool)
            _typevariablesOinstancename :: (Maybe Name)
            _typevariablesOknownKinds :: (FMap Name [Name])
            _typevariablesOknownKinds_collect :: (FMap Name [Name])
            _typevariablesOknownTypes :: (FMap Name [Name])
            _typevariablesOknownTypes_collect :: (FMap Name [Name])
            _typevariablesOknownValues :: (FMap Name [Name])
            _typevariablesOknownValues_collect :: (FMap Name [Name])
            _typevariablesOlabels_collect :: (FMap Name Names)
            _typevariablesOlabels_dist :: (FMap Name Names)
            _typevariablesOlocal :: (Bool)
            _typevariablesOmethods_collect :: (FMap Name Names)
            _typevariablesOmethods_dist :: (FMap Name Names)
            _typevariablesOmoduleTypes :: (FMap ModuleName [Name])
            _typevariablesOmoduleValues :: (FMap ModuleName [Name])
            _typevariablesOnameType :: (NameType)
            _typevariablesOtoplevel :: (Bool)
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIknownKinds_collect :: (FMap Name [Name])
            _typeIknownTypes_collect :: (FMap Name [Name])
            _typeIknownValues_collect :: (FMap Name [Name])
            _typeIlabels_collect :: (FMap Name Names)
            _typeImethods_collect :: (FMap Name Names)
            _typeImoduleTypes :: (FMap ModuleName [Name])
            _typeImoduleValues :: (FMap ModuleName [Name])
            _typeImodules :: (Set.Set Strings)
            _typeIres :: ([ResolveResult])
            _typeIself :: (Type)
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOimportedModule :: (Bool)
            _typeOinstancename :: (Maybe Name)
            _typeOknownGenerics :: (FMap Name [Name])
            _typeOknownKinds :: (FMap Name [Name])
            _typeOknownKinds_collect :: (FMap Name [Name])
            _typeOknownTypes :: (FMap Name [Name])
            _typeOknownTypes_collect :: (FMap Name [Name])
            _typeOknownValues :: (FMap Name [Name])
            _typeOknownValues_collect :: (FMap Name [Name])
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOmoduleTypes :: (FMap ModuleName [Name])
            _typeOmoduleValues :: (FMap ModuleName [Name])
            _typeOnameType :: (NameType)
            _typeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _typevariablesIconstructors_collect,_typevariablesIknownKinds_collect,_typevariablesIknownTypes_collect,_typevariablesIknownValues_collect,_typevariablesIlabels_collect,_typevariablesImethods_collect,_typevariablesImoduleTypes,_typevariablesImoduleValues,_typevariablesImodules,_typevariablesIoriginalSelf,_typevariablesIres,_typevariablesIself) =
                (typevariables_ (_typevariablesOclassname)
                                (_typevariablesOconstructors_collect)
                                (_typevariablesOconstructors_dist)
                                (_typevariablesOcurrentModule)
                                (_typevariablesOimportedModule)
                                (_typevariablesOinstancename)
                                (_typevariablesOknownKinds)
                                (_typevariablesOknownKinds_collect)
                                (_typevariablesOknownTypes)
                                (_typevariablesOknownTypes_collect)
                                (_typevariablesOknownValues)
                                (_typevariablesOknownValues_collect)
                                (_typevariablesOlabels_collect)
                                (_typevariablesOlabels_dist)
                                (_typevariablesOlocal)
                                (_typevariablesOmethods_collect)
                                (_typevariablesOmethods_dist)
                                (_typevariablesOmoduleTypes)
                                (_typevariablesOmoduleValues)
                                (_typevariablesOnameType)
                                (_typevariablesOtoplevel))
            ( _typeIconstructors_collect,_typeIknownKinds_collect,_typeIknownTypes_collect,_typeIknownValues_collect,_typeIlabels_collect,_typeImethods_collect,_typeImoduleTypes,_typeImoduleValues,_typeImodules,_typeIres,_typeIself) =
                (type_ (_typeOclassname)
                       (_typeOconstructors_collect)
                       (_typeOconstructors_dist)
                       (_typeOcurrentModule)
                       (_typeOimportedModule)
                       (_typeOinstancename)
                       (_typeOknownGenerics)
                       (_typeOknownKinds)
                       (_typeOknownKinds_collect)
                       (_typeOknownTypes)
                       (_typeOknownTypes_collect)
                       (_typeOknownValues)
                       (_typeOknownValues_collect)
                       (_typeOlabels_collect)
                       (_typeOlabels_dist)
                       (_typeOlocal)
                       (_typeOmethods_collect)
                       (_typeOmethods_dist)
                       (_typeOmoduleTypes)
                       (_typeOmoduleValues)
                       (_typeOnameType)
                       (_typeOtoplevel))
            -- "./Names.inc.lag"(line 608, column 9)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- "./Names.inc.lag"(line 607, column 9)
            (_knownTypes@_) =
                _typevariablesIknownTypes_collect `mergeFM` _lhsIknownTypes
            -- "./Names.inc.lag"(line 606, column 9)
            (_typevariablesOknownTypes_collect@_) =
                emptyFM
            -- "./NameTypes.inc.lag"(line 182, column 9)
            (_typevariablesOnameType@_) =
                Def_Typ
            -- use rule
            (_lhsOmodules@_) =
                _typevariablesImodules `Set.union` _typeImodules
            -- use rule
            (_lhsOres@_) =
                _typevariablesIres ++ _typeIres
            -- self rule
            (_self@_) =
                Type_Forall _rangeIself _typevariablesIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _typeIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _typeIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _typeImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _typeImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typevariablesOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_typevariablesOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_typevariablesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typevariablesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typevariablesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typevariablesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typevariablesOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_typevariablesOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_typevariablesOknownTypes@_) =
                _knownTypes
            -- copy rule (down)
            (_typevariablesOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_typevariablesOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_typevariablesOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_typevariablesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typevariablesOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_typevariablesOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_typevariablesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typevariablesOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_typevariablesOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_typevariablesOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _typevariablesIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typeOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_typeOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_typeOknownKinds_collect@_) =
                _typevariablesIknownKinds_collect
            -- copy rule (chain)
            (_typeOknownTypes@_) =
                _knownTypes
            -- copy rule (chain)
            (_typeOknownTypes_collect@_) =
                _typevariablesIknownTypes_collect
            -- copy rule (down)
            (_typeOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_typeOknownValues_collect@_) =
                _typevariablesIknownValues_collect
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _typevariablesIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _typevariablesImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_typeOmoduleTypes@_) =
                _typevariablesImoduleTypes
            -- copy rule (chain)
            (_typeOmoduleValues@_) =
                _typevariablesImoduleValues
            -- copy rule (down)
            (_typeOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_typeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Type_KindApplication :: (T_Range) ->
                            (T_Name) ->
                            (T_Kind) ->
                            (T_Type)
sem_Type_KindApplication (range_) (name_) (kind_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _kindIconstructors_collect :: (FMap Name Names)
            _kindIknownKinds_collect :: (FMap Name [Name])
            _kindIknownTypes_collect :: (FMap Name [Name])
            _kindIknownValues_collect :: (FMap Name [Name])
            _kindIlabels_collect :: (FMap Name Names)
            _kindImethods_collect :: (FMap Name Names)
            _kindImoduleTypes :: (FMap ModuleName [Name])
            _kindImoduleValues :: (FMap ModuleName [Name])
            _kindImodules :: (Set.Set Strings)
            _kindIres :: ([ResolveResult])
            _kindIself :: (Kind)
            _kindOclassname :: (Maybe Name)
            _kindOconstructors_collect :: (FMap Name Names)
            _kindOconstructors_dist :: (FMap Name Names)
            _kindOcurrentModule :: (Strings)
            _kindOimportedModule :: (Bool)
            _kindOinstancename :: (Maybe Name)
            _kindOknownKinds :: (FMap Name [Name])
            _kindOknownKinds_collect :: (FMap Name [Name])
            _kindOknownTypes :: (FMap Name [Name])
            _kindOknownTypes_collect :: (FMap Name [Name])
            _kindOknownValues :: (FMap Name [Name])
            _kindOknownValues_collect :: (FMap Name [Name])
            _kindOlabels_collect :: (FMap Name Names)
            _kindOlabels_dist :: (FMap Name Names)
            _kindOlocal :: (Bool)
            _kindOmethods_collect :: (FMap Name Names)
            _kindOmethods_dist :: (FMap Name Names)
            _kindOmoduleTypes :: (FMap ModuleName [Name])
            _kindOmoduleValues :: (FMap ModuleName [Name])
            _kindOnameType :: (NameType)
            _kindOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _kindIconstructors_collect,_kindIknownKinds_collect,_kindIknownTypes_collect,_kindIknownValues_collect,_kindIlabels_collect,_kindImethods_collect,_kindImoduleTypes,_kindImoduleValues,_kindImodules,_kindIres,_kindIself) =
                (kind_ (_kindOclassname)
                       (_kindOconstructors_collect)
                       (_kindOconstructors_dist)
                       (_kindOcurrentModule)
                       (_kindOimportedModule)
                       (_kindOinstancename)
                       (_kindOknownKinds)
                       (_kindOknownKinds_collect)
                       (_kindOknownTypes)
                       (_kindOknownTypes_collect)
                       (_kindOknownValues)
                       (_kindOknownValues_collect)
                       (_kindOlabels_collect)
                       (_kindOlabels_dist)
                       (_kindOlocal)
                       (_kindOmethods_collect)
                       (_kindOmethods_dist)
                       (_kindOmoduleTypes)
                       (_kindOmoduleValues)
                       (_kindOnameType)
                       (_kindOtoplevel))
            -- "./NameTypes.inc.lag"(line 189, column 9)
            (_kindOnameType@_) =
                ref_Kind
            -- "./NameTypes.inc.lag"(line 188, column 9)
            (_nameOnameType@_) =
                ref_Typ
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _kindImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _kindIres
            -- self rule
            (_self@_) =
                Type_KindApplication _rangeIself _nameIself _kindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _kindIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _kindIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _kindIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _kindIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _kindIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _kindImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _kindImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _kindImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_kindOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_kindOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_kindOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_kindOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_kindOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_kindOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_kindOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_kindOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_kindOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_kindOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (down)
            (_kindOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_kindOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_kindOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_kindOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_kindOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_kindOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_kindOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_kindOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_kindOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_kindOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Type_KindStarCase :: (T_Range) ->
                         (T_Type)
sem_Type_KindStarCase (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                Type_KindStarCase _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Type_Kinded :: (T_Range) ->
                   (T_Name) ->
                   (T_Kind) ->
                   (T_Type)
sem_Type_Kinded (range_) (name_) (kind_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _kindIconstructors_collect :: (FMap Name Names)
            _kindIknownKinds_collect :: (FMap Name [Name])
            _kindIknownTypes_collect :: (FMap Name [Name])
            _kindIknownValues_collect :: (FMap Name [Name])
            _kindIlabels_collect :: (FMap Name Names)
            _kindImethods_collect :: (FMap Name Names)
            _kindImoduleTypes :: (FMap ModuleName [Name])
            _kindImoduleValues :: (FMap ModuleName [Name])
            _kindImodules :: (Set.Set Strings)
            _kindIres :: ([ResolveResult])
            _kindIself :: (Kind)
            _kindOclassname :: (Maybe Name)
            _kindOconstructors_collect :: (FMap Name Names)
            _kindOconstructors_dist :: (FMap Name Names)
            _kindOcurrentModule :: (Strings)
            _kindOimportedModule :: (Bool)
            _kindOinstancename :: (Maybe Name)
            _kindOknownKinds :: (FMap Name [Name])
            _kindOknownKinds_collect :: (FMap Name [Name])
            _kindOknownTypes :: (FMap Name [Name])
            _kindOknownTypes_collect :: (FMap Name [Name])
            _kindOknownValues :: (FMap Name [Name])
            _kindOknownValues_collect :: (FMap Name [Name])
            _kindOlabels_collect :: (FMap Name Names)
            _kindOlabels_dist :: (FMap Name Names)
            _kindOlocal :: (Bool)
            _kindOmethods_collect :: (FMap Name Names)
            _kindOmethods_dist :: (FMap Name Names)
            _kindOmoduleTypes :: (FMap ModuleName [Name])
            _kindOmoduleValues :: (FMap ModuleName [Name])
            _kindOnameType :: (NameType)
            _kindOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _kindIconstructors_collect,_kindIknownKinds_collect,_kindIknownTypes_collect,_kindIknownValues_collect,_kindIlabels_collect,_kindImethods_collect,_kindImoduleTypes,_kindImoduleValues,_kindImodules,_kindIres,_kindIself) =
                (kind_ (_kindOclassname)
                       (_kindOconstructors_collect)
                       (_kindOconstructors_dist)
                       (_kindOcurrentModule)
                       (_kindOimportedModule)
                       (_kindOinstancename)
                       (_kindOknownKinds)
                       (_kindOknownKinds_collect)
                       (_kindOknownTypes)
                       (_kindOknownTypes_collect)
                       (_kindOknownValues)
                       (_kindOknownValues_collect)
                       (_kindOlabels_collect)
                       (_kindOlabels_dist)
                       (_kindOlocal)
                       (_kindOmethods_collect)
                       (_kindOmethods_dist)
                       (_kindOmoduleTypes)
                       (_kindOmoduleValues)
                       (_kindOnameType)
                       (_kindOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _kindImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _kindIres
            -- self rule
            (_self@_) =
                Type_Kinded _rangeIself _nameIself _kindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _kindIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _kindIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _kindIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _kindIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _kindIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _kindImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _kindImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _kindImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_kindOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_kindOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_kindOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_kindOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_kindOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_kindOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_kindOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_kindOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_kindOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_kindOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (down)
            (_kindOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_kindOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_kindOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_kindOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_kindOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_kindOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_kindOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_kindOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_kindOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_kindOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_kindOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Type_Label :: (T_Range) ->
                  (T_Name) ->
                  (T_Type)
sem_Type_Label (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres
            -- self rule
            (_self@_) =
                Type_Label _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Type_Parenthesized :: (T_Range) ->
                          (T_Type) ->
                          (T_Type)
sem_Type_Parenthesized (range_) (type_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIknownKinds_collect :: (FMap Name [Name])
            _typeIknownTypes_collect :: (FMap Name [Name])
            _typeIknownValues_collect :: (FMap Name [Name])
            _typeIlabels_collect :: (FMap Name Names)
            _typeImethods_collect :: (FMap Name Names)
            _typeImoduleTypes :: (FMap ModuleName [Name])
            _typeImoduleValues :: (FMap ModuleName [Name])
            _typeImodules :: (Set.Set Strings)
            _typeIres :: ([ResolveResult])
            _typeIself :: (Type)
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOimportedModule :: (Bool)
            _typeOinstancename :: (Maybe Name)
            _typeOknownGenerics :: (FMap Name [Name])
            _typeOknownKinds :: (FMap Name [Name])
            _typeOknownKinds_collect :: (FMap Name [Name])
            _typeOknownTypes :: (FMap Name [Name])
            _typeOknownTypes_collect :: (FMap Name [Name])
            _typeOknownValues :: (FMap Name [Name])
            _typeOknownValues_collect :: (FMap Name [Name])
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOmoduleTypes :: (FMap ModuleName [Name])
            _typeOmoduleValues :: (FMap ModuleName [Name])
            _typeOnameType :: (NameType)
            _typeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _typeIconstructors_collect,_typeIknownKinds_collect,_typeIknownTypes_collect,_typeIknownValues_collect,_typeIlabels_collect,_typeImethods_collect,_typeImoduleTypes,_typeImoduleValues,_typeImodules,_typeIres,_typeIself) =
                (type_ (_typeOclassname)
                       (_typeOconstructors_collect)
                       (_typeOconstructors_dist)
                       (_typeOcurrentModule)
                       (_typeOimportedModule)
                       (_typeOinstancename)
                       (_typeOknownGenerics)
                       (_typeOknownKinds)
                       (_typeOknownKinds_collect)
                       (_typeOknownTypes)
                       (_typeOknownTypes_collect)
                       (_typeOknownValues)
                       (_typeOknownValues_collect)
                       (_typeOlabels_collect)
                       (_typeOlabels_dist)
                       (_typeOlocal)
                       (_typeOmethods_collect)
                       (_typeOmethods_dist)
                       (_typeOmoduleTypes)
                       (_typeOmoduleValues)
                       (_typeOnameType)
                       (_typeOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _typeImodules
            -- use rule
            (_lhsOres@_) =
                _typeIres
            -- self rule
            (_self@_) =
                Type_Parenthesized _rangeIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _typeIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _typeIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _typeIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _typeImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _typeImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_typeOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typeOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_typeOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_typeOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_typeOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_typeOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_typeOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_typeOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_typeOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_typeOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typeOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_typeOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_typeOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_typeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Type_Qualified :: (T_Range) ->
                      (T_ContextItems) ->
                      (T_Type) ->
                      (T_Type)
sem_Type_Qualified (range_) (context_) (type_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _contextIconstructors_collect :: (FMap Name Names)
            _contextIknownKinds_collect :: (FMap Name [Name])
            _contextIknownTypes_collect :: (FMap Name [Name])
            _contextIknownValues_collect :: (FMap Name [Name])
            _contextIlabels_collect :: (FMap Name Names)
            _contextImethods_collect :: (FMap Name Names)
            _contextImoduleTypes :: (FMap ModuleName [Name])
            _contextImoduleValues :: (FMap ModuleName [Name])
            _contextImodules :: (Set.Set Strings)
            _contextIres :: ([ResolveResult])
            _contextIself :: (ContextItems)
            _contextOclassname :: (Maybe Name)
            _contextOconstructors_collect :: (FMap Name Names)
            _contextOconstructors_dist :: (FMap Name Names)
            _contextOcurrentModule :: (Strings)
            _contextOimportedModule :: (Bool)
            _contextOinstancename :: (Maybe Name)
            _contextOknownGenerics :: (FMap Name [Name])
            _contextOknownKinds :: (FMap Name [Name])
            _contextOknownKinds_collect :: (FMap Name [Name])
            _contextOknownTypes :: (FMap Name [Name])
            _contextOknownTypes_collect :: (FMap Name [Name])
            _contextOknownValues :: (FMap Name [Name])
            _contextOknownValues_collect :: (FMap Name [Name])
            _contextOlabels_collect :: (FMap Name Names)
            _contextOlabels_dist :: (FMap Name Names)
            _contextOlocal :: (Bool)
            _contextOmethods_collect :: (FMap Name Names)
            _contextOmethods_dist :: (FMap Name Names)
            _contextOmoduleTypes :: (FMap ModuleName [Name])
            _contextOmoduleValues :: (FMap ModuleName [Name])
            _contextOnameType :: (NameType)
            _contextOtoplevel :: (Bool)
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIknownKinds_collect :: (FMap Name [Name])
            _typeIknownTypes_collect :: (FMap Name [Name])
            _typeIknownValues_collect :: (FMap Name [Name])
            _typeIlabels_collect :: (FMap Name Names)
            _typeImethods_collect :: (FMap Name Names)
            _typeImoduleTypes :: (FMap ModuleName [Name])
            _typeImoduleValues :: (FMap ModuleName [Name])
            _typeImodules :: (Set.Set Strings)
            _typeIres :: ([ResolveResult])
            _typeIself :: (Type)
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOimportedModule :: (Bool)
            _typeOinstancename :: (Maybe Name)
            _typeOknownGenerics :: (FMap Name [Name])
            _typeOknownKinds :: (FMap Name [Name])
            _typeOknownKinds_collect :: (FMap Name [Name])
            _typeOknownTypes :: (FMap Name [Name])
            _typeOknownTypes_collect :: (FMap Name [Name])
            _typeOknownValues :: (FMap Name [Name])
            _typeOknownValues_collect :: (FMap Name [Name])
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOmoduleTypes :: (FMap ModuleName [Name])
            _typeOmoduleValues :: (FMap ModuleName [Name])
            _typeOnameType :: (NameType)
            _typeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _contextIconstructors_collect,_contextIknownKinds_collect,_contextIknownTypes_collect,_contextIknownValues_collect,_contextIlabels_collect,_contextImethods_collect,_contextImoduleTypes,_contextImoduleValues,_contextImodules,_contextIres,_contextIself) =
                (context_ (_contextOclassname)
                          (_contextOconstructors_collect)
                          (_contextOconstructors_dist)
                          (_contextOcurrentModule)
                          (_contextOimportedModule)
                          (_contextOinstancename)
                          (_contextOknownGenerics)
                          (_contextOknownKinds)
                          (_contextOknownKinds_collect)
                          (_contextOknownTypes)
                          (_contextOknownTypes_collect)
                          (_contextOknownValues)
                          (_contextOknownValues_collect)
                          (_contextOlabels_collect)
                          (_contextOlabels_dist)
                          (_contextOlocal)
                          (_contextOmethods_collect)
                          (_contextOmethods_dist)
                          (_contextOmoduleTypes)
                          (_contextOmoduleValues)
                          (_contextOnameType)
                          (_contextOtoplevel))
            ( _typeIconstructors_collect,_typeIknownKinds_collect,_typeIknownTypes_collect,_typeIknownValues_collect,_typeIlabels_collect,_typeImethods_collect,_typeImoduleTypes,_typeImoduleValues,_typeImodules,_typeIres,_typeIself) =
                (type_ (_typeOclassname)
                       (_typeOconstructors_collect)
                       (_typeOconstructors_dist)
                       (_typeOcurrentModule)
                       (_typeOimportedModule)
                       (_typeOinstancename)
                       (_typeOknownGenerics)
                       (_typeOknownKinds)
                       (_typeOknownKinds_collect)
                       (_typeOknownTypes)
                       (_typeOknownTypes_collect)
                       (_typeOknownValues)
                       (_typeOknownValues_collect)
                       (_typeOlabels_collect)
                       (_typeOlabels_dist)
                       (_typeOlocal)
                       (_typeOmethods_collect)
                       (_typeOmethods_dist)
                       (_typeOmoduleTypes)
                       (_typeOmoduleValues)
                       (_typeOnameType)
                       (_typeOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _contextImodules `Set.union` _typeImodules
            -- use rule
            (_lhsOres@_) =
                _contextIres ++ _typeIres
            -- self rule
            (_self@_) =
                Type_Qualified _rangeIself _contextIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _typeIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _typeIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _typeIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _typeImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _typeImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_contextOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_contextOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_contextOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_contextOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_contextOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_contextOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_contextOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_contextOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_contextOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_contextOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_contextOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_contextOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_contextOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_contextOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_contextOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_contextOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_contextOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_contextOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_contextOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_contextOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_contextOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_contextOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _contextIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typeOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_typeOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_typeOknownKinds_collect@_) =
                _contextIknownKinds_collect
            -- copy rule (down)
            (_typeOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_typeOknownTypes_collect@_) =
                _contextIknownTypes_collect
            -- copy rule (down)
            (_typeOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_typeOknownValues_collect@_) =
                _contextIknownValues_collect
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _contextIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _contextImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_typeOmoduleTypes@_) =
                _contextImoduleTypes
            -- copy rule (chain)
            (_typeOmoduleValues@_) =
                _contextImoduleValues
            -- copy rule (down)
            (_typeOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_typeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Type_TypeApplication :: (T_Range) ->
                            (T_Name) ->
                            (T_Type) ->
                            (T_Type)
sem_Type_TypeApplication (range_) (name_) (type_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIknownKinds_collect :: (FMap Name [Name])
            _typeIknownTypes_collect :: (FMap Name [Name])
            _typeIknownValues_collect :: (FMap Name [Name])
            _typeIlabels_collect :: (FMap Name Names)
            _typeImethods_collect :: (FMap Name Names)
            _typeImoduleTypes :: (FMap ModuleName [Name])
            _typeImoduleValues :: (FMap ModuleName [Name])
            _typeImodules :: (Set.Set Strings)
            _typeIres :: ([ResolveResult])
            _typeIself :: (Type)
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOimportedModule :: (Bool)
            _typeOinstancename :: (Maybe Name)
            _typeOknownGenerics :: (FMap Name [Name])
            _typeOknownKinds :: (FMap Name [Name])
            _typeOknownKinds_collect :: (FMap Name [Name])
            _typeOknownTypes :: (FMap Name [Name])
            _typeOknownTypes_collect :: (FMap Name [Name])
            _typeOknownValues :: (FMap Name [Name])
            _typeOknownValues_collect :: (FMap Name [Name])
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOmoduleTypes :: (FMap ModuleName [Name])
            _typeOmoduleValues :: (FMap ModuleName [Name])
            _typeOnameType :: (NameType)
            _typeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _typeIconstructors_collect,_typeIknownKinds_collect,_typeIknownTypes_collect,_typeIknownValues_collect,_typeIlabels_collect,_typeImethods_collect,_typeImoduleTypes,_typeImoduleValues,_typeImodules,_typeIres,_typeIself) =
                (type_ (_typeOclassname)
                       (_typeOconstructors_collect)
                       (_typeOconstructors_dist)
                       (_typeOcurrentModule)
                       (_typeOimportedModule)
                       (_typeOinstancename)
                       (_typeOknownGenerics)
                       (_typeOknownKinds)
                       (_typeOknownKinds_collect)
                       (_typeOknownTypes)
                       (_typeOknownTypes_collect)
                       (_typeOknownValues)
                       (_typeOknownValues_collect)
                       (_typeOlabels_collect)
                       (_typeOlabels_dist)
                       (_typeOlocal)
                       (_typeOmethods_collect)
                       (_typeOmethods_dist)
                       (_typeOmoduleTypes)
                       (_typeOmoduleValues)
                       (_typeOnameType)
                       (_typeOtoplevel))
            -- "./NameTypes.inc.lag"(line 186, column 9)
            (_nameOnameType@_) =
                ref_Typ
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _typeImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _typeIres
            -- self rule
            (_self@_) =
                Type_TypeApplication _rangeIself _nameIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _typeIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _typeIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _typeIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _typeImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _typeImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typeOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_typeOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_typeOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_typeOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_typeOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (down)
            (_typeOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_typeOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_typeOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_typeOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_typeOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_typeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Type_TypeSignature :: (T_Range) ->
                          (T_KindAnnotatedNames) ->
                          (T_Types) ->
                          (T_Type)
sem_Type_TypeSignature (range_) (generics_) (parametrics_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _genericsIakinds :: ([MaybeKind])
            _genericsIconstructors_collect :: (FMap Name Names)
            _genericsIknownKinds_collect :: (FMap Name [Name])
            _genericsIknownTypes_collect :: (FMap Name [Name])
            _genericsIknownValues_collect :: (FMap Name [Name])
            _genericsIlabels_collect :: (FMap Name Names)
            _genericsImethods_collect :: (FMap Name Names)
            _genericsImoduleTypes :: (FMap ModuleName [Name])
            _genericsImoduleValues :: (FMap ModuleName [Name])
            _genericsImodules :: (Set.Set Strings)
            _genericsIres :: ([ResolveResult])
            _genericsIself :: (KindAnnotatedNames)
            _genericsOclassname :: (Maybe Name)
            _genericsOconstructors_collect :: (FMap Name Names)
            _genericsOconstructors_dist :: (FMap Name Names)
            _genericsOcurrentModule :: (Strings)
            _genericsOimportedModule :: (Bool)
            _genericsOinstancename :: (Maybe Name)
            _genericsOknownKinds :: (FMap Name [Name])
            _genericsOknownKinds_collect :: (FMap Name [Name])
            _genericsOknownTypes :: (FMap Name [Name])
            _genericsOknownTypes_collect :: (FMap Name [Name])
            _genericsOknownValues :: (FMap Name [Name])
            _genericsOknownValues_collect :: (FMap Name [Name])
            _genericsOlabels_collect :: (FMap Name Names)
            _genericsOlabels_dist :: (FMap Name Names)
            _genericsOlocal :: (Bool)
            _genericsOmethods_collect :: (FMap Name Names)
            _genericsOmethods_dist :: (FMap Name Names)
            _genericsOmoduleTypes :: (FMap ModuleName [Name])
            _genericsOmoduleValues :: (FMap ModuleName [Name])
            _genericsOnameType :: (NameType)
            _genericsOtoplevel :: (Bool)
            _parametricsIconstructors_collect :: (FMap Name Names)
            _parametricsIknownKinds_collect :: (FMap Name [Name])
            _parametricsIknownTypes_collect :: (FMap Name [Name])
            _parametricsIknownValues_collect :: (FMap Name [Name])
            _parametricsIlabels_collect :: (FMap Name Names)
            _parametricsImethods_collect :: (FMap Name Names)
            _parametricsImoduleTypes :: (FMap ModuleName [Name])
            _parametricsImoduleValues :: (FMap ModuleName [Name])
            _parametricsImodules :: (Set.Set Strings)
            _parametricsIres :: ([ResolveResult])
            _parametricsIself :: (Types)
            _parametricsOclassname :: (Maybe Name)
            _parametricsOconstructors_collect :: (FMap Name Names)
            _parametricsOconstructors_dist :: (FMap Name Names)
            _parametricsOcurrentModule :: (Strings)
            _parametricsOimportedModule :: (Bool)
            _parametricsOinstancename :: (Maybe Name)
            _parametricsOknownGenerics :: (FMap Name [Name])
            _parametricsOknownKinds :: (FMap Name [Name])
            _parametricsOknownKinds_collect :: (FMap Name [Name])
            _parametricsOknownTypes :: (FMap Name [Name])
            _parametricsOknownTypes_collect :: (FMap Name [Name])
            _parametricsOknownValues :: (FMap Name [Name])
            _parametricsOknownValues_collect :: (FMap Name [Name])
            _parametricsOlabels_collect :: (FMap Name Names)
            _parametricsOlabels_dist :: (FMap Name Names)
            _parametricsOlocal :: (Bool)
            _parametricsOmethods_collect :: (FMap Name Names)
            _parametricsOmethods_dist :: (FMap Name Names)
            _parametricsOmoduleTypes :: (FMap ModuleName [Name])
            _parametricsOmoduleValues :: (FMap ModuleName [Name])
            _parametricsOnameType :: (NameType)
            _parametricsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _genericsIakinds,_genericsIconstructors_collect,_genericsIknownKinds_collect,_genericsIknownTypes_collect,_genericsIknownValues_collect,_genericsIlabels_collect,_genericsImethods_collect,_genericsImoduleTypes,_genericsImoduleValues,_genericsImodules,_genericsIres,_genericsIself) =
                (generics_ (_genericsOclassname)
                           (_genericsOconstructors_collect)
                           (_genericsOconstructors_dist)
                           (_genericsOcurrentModule)
                           (_genericsOimportedModule)
                           (_genericsOinstancename)
                           (_genericsOknownKinds)
                           (_genericsOknownKinds_collect)
                           (_genericsOknownTypes)
                           (_genericsOknownTypes_collect)
                           (_genericsOknownValues)
                           (_genericsOknownValues_collect)
                           (_genericsOlabels_collect)
                           (_genericsOlabels_dist)
                           (_genericsOlocal)
                           (_genericsOmethods_collect)
                           (_genericsOmethods_dist)
                           (_genericsOmoduleTypes)
                           (_genericsOmoduleValues)
                           (_genericsOnameType)
                           (_genericsOtoplevel))
            ( _parametricsIconstructors_collect,_parametricsIknownKinds_collect,_parametricsIknownTypes_collect,_parametricsIknownValues_collect,_parametricsIlabels_collect,_parametricsImethods_collect,_parametricsImoduleTypes,_parametricsImoduleValues,_parametricsImodules,_parametricsIres,_parametricsIself) =
                (parametrics_ (_parametricsOclassname)
                              (_parametricsOconstructors_collect)
                              (_parametricsOconstructors_dist)
                              (_parametricsOcurrentModule)
                              (_parametricsOimportedModule)
                              (_parametricsOinstancename)
                              (_parametricsOknownGenerics)
                              (_parametricsOknownKinds)
                              (_parametricsOknownKinds_collect)
                              (_parametricsOknownTypes)
                              (_parametricsOknownTypes_collect)
                              (_parametricsOknownValues)
                              (_parametricsOknownValues_collect)
                              (_parametricsOlabels_collect)
                              (_parametricsOlabels_dist)
                              (_parametricsOlocal)
                              (_parametricsOmethods_collect)
                              (_parametricsOmethods_dist)
                              (_parametricsOmoduleTypes)
                              (_parametricsOmoduleValues)
                              (_parametricsOnameType)
                              (_parametricsOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _genericsImodules `Set.union` _parametricsImodules
            -- use rule
            (_lhsOres@_) =
                _genericsIres ++ _parametricsIres
            -- self rule
            (_self@_) =
                Type_TypeSignature _rangeIself _genericsIself _parametricsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _parametricsIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _parametricsIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _parametricsIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _parametricsIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _parametricsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _parametricsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _parametricsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _parametricsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_genericsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_genericsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_genericsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_genericsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_genericsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_genericsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_genericsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_genericsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_genericsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_genericsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_genericsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_genericsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_genericsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_genericsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_genericsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_genericsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_genericsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_genericsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_genericsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_genericsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_genericsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_parametricsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_parametricsOconstructors_collect@_) =
                _genericsIconstructors_collect
            -- copy rule (down)
            (_parametricsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_parametricsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_parametricsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_parametricsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_parametricsOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_parametricsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_parametricsOknownKinds_collect@_) =
                _genericsIknownKinds_collect
            -- copy rule (down)
            (_parametricsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_parametricsOknownTypes_collect@_) =
                _genericsIknownTypes_collect
            -- copy rule (down)
            (_parametricsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_parametricsOknownValues_collect@_) =
                _genericsIknownValues_collect
            -- copy rule (chain)
            (_parametricsOlabels_collect@_) =
                _genericsIlabels_collect
            -- copy rule (down)
            (_parametricsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_parametricsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_parametricsOmethods_collect@_) =
                _genericsImethods_collect
            -- copy rule (down)
            (_parametricsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_parametricsOmoduleTypes@_) =
                _genericsImoduleTypes
            -- copy rule (chain)
            (_parametricsOmoduleValues@_) =
                _genericsImoduleValues
            -- copy rule (down)
            (_parametricsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_parametricsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Type_Variable :: (T_Range) ->
                     (T_Name) ->
                     (T_Type)
sem_Type_Variable (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            -- "./NameTypes.inc.lag"(line 178, column 9)
            (_nameOnameType@_) =
                _lhsInameType
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres
            -- self rule
            (_self@_) =
                Type_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- TypeArgument ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for TypeArgument.Constructor:
      self

-}
{-
   local variables for TypeArgument.ConstructorCase:
      self

-}
{-
   local variables for TypeArgument.DependencyStyle:
      self

-}
{-
   local variables for TypeArgument.KindStarCase:
      self

-}
{-
   local variables for TypeArgument.Label:
      self

-}
{-
   local variables for TypeArgument.NamedType:
      self

-}
{-
   local variables for TypeArgument.Variable:
      self

-}
-- semantic domain
type T_TypeArgument = (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Strings) ->
                      (Bool) ->
                      (Maybe Name) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name [Name]) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (FMap ModuleName [Name]) ->
                      (FMap ModuleName [Name]) ->
                      (NameType) ->
                      (Bool) ->
                      ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(TypeArgument))
-- cata
sem_TypeArgument :: (TypeArgument) ->
                    (T_TypeArgument)
sem_TypeArgument ((TypeArgument_Constructor (_range) (_variable))) =
    (sem_TypeArgument_Constructor ((sem_Range (_range))) ((sem_Name (_variable))))
sem_TypeArgument ((TypeArgument_ConstructorCase (_range) (_name))) =
    (sem_TypeArgument_ConstructorCase ((sem_Range (_range))) ((sem_Name (_name))))
sem_TypeArgument ((TypeArgument_DependencyStyle (_range) (_name) (_descriptor) (_variables))) =
    (sem_TypeArgument_DependencyStyle ((sem_Range (_range))) ((sem_Name (_name))) ((sem_MaybeName (_descriptor))) ((sem_Names (_variables))))
sem_TypeArgument ((TypeArgument_KindStarCase (_range))) =
    (sem_TypeArgument_KindStarCase ((sem_Range (_range))))
sem_TypeArgument ((TypeArgument_Label (_range) (_variable))) =
    (sem_TypeArgument_Label ((sem_Range (_range))) ((sem_Name (_variable))))
sem_TypeArgument ((TypeArgument_NamedType (_range) (_name))) =
    (sem_TypeArgument_NamedType ((sem_Range (_range))) ((sem_Name (_name))))
sem_TypeArgument ((TypeArgument_Variable (_range) (_name))) =
    (sem_TypeArgument_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_TypeArgument_Constructor :: (T_Range) ->
                                (T_Name) ->
                                (T_TypeArgument)
sem_TypeArgument_Constructor (range_) (variable_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (TypeArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _variableIconstructors_collect :: (FMap Name Names)
            _variableIentityName :: (Name)
            _variableIfullName :: (Name)
            _variableIknownKinds_collect :: (FMap Name [Name])
            _variableIknownTypes_collect :: (FMap Name [Name])
            _variableIknownValues_collect :: (FMap Name [Name])
            _variableIlabels_collect :: (FMap Name Names)
            _variableImethods_collect :: (FMap Name Names)
            _variableImoduleTypes :: (FMap ModuleName [Name])
            _variableImoduleValues :: (FMap ModuleName [Name])
            _variableImodules :: (Set.Set Strings)
            _variableIoriginalSelf :: (Name)
            _variableIres :: ([ResolveResult])
            _variableIself :: (Name)
            _variableOclassname :: (Maybe Name)
            _variableOconstructors_collect :: (FMap Name Names)
            _variableOconstructors_dist :: (FMap Name Names)
            _variableOcurrentModule :: (Strings)
            _variableOimportedModule :: (Bool)
            _variableOinstancename :: (Maybe Name)
            _variableOknownKinds :: (FMap Name [Name])
            _variableOknownKinds_collect :: (FMap Name [Name])
            _variableOknownTypes :: (FMap Name [Name])
            _variableOknownTypes_collect :: (FMap Name [Name])
            _variableOknownValues :: (FMap Name [Name])
            _variableOknownValues_collect :: (FMap Name [Name])
            _variableOlabels_collect :: (FMap Name Names)
            _variableOlabels_dist :: (FMap Name Names)
            _variableOlocal :: (Bool)
            _variableOmethods_collect :: (FMap Name Names)
            _variableOmethods_dist :: (FMap Name Names)
            _variableOmoduleTypes :: (FMap ModuleName [Name])
            _variableOmoduleValues :: (FMap ModuleName [Name])
            _variableOnameType :: (NameType)
            _variableOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _variableIconstructors_collect,_variableIentityName,_variableIfullName,_variableIknownKinds_collect,_variableIknownTypes_collect,_variableIknownValues_collect,_variableIlabels_collect,_variableImethods_collect,_variableImoduleTypes,_variableImoduleValues,_variableImodules,_variableIoriginalSelf,_variableIres,_variableIself) =
                (variable_ (_variableOclassname)
                           (_variableOconstructors_collect)
                           (_variableOconstructors_dist)
                           (_variableOcurrentModule)
                           (_variableOimportedModule)
                           (_variableOinstancename)
                           (_variableOknownKinds)
                           (_variableOknownKinds_collect)
                           (_variableOknownTypes)
                           (_variableOknownTypes_collect)
                           (_variableOknownValues)
                           (_variableOknownValues_collect)
                           (_variableOlabels_collect)
                           (_variableOlabels_dist)
                           (_variableOlocal)
                           (_variableOmethods_collect)
                           (_variableOmethods_dist)
                           (_variableOmoduleTypes)
                           (_variableOmoduleValues)
                           (_variableOnameType)
                           (_variableOtoplevel))
            -- "./NameTypes.inc.lag"(line 205, column 9)
            (_variableOnameType@_) =
                Def_Val
            -- use rule
            (_lhsOmodules@_) =
                _variableImodules
            -- use rule
            (_lhsOres@_) =
                _variableIres
            -- self rule
            (_self@_) =
                TypeArgument_Constructor _rangeIself _variableIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _variableIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _variableIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _variableIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _variableIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _variableIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _variableImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _variableImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _variableImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_variableOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_variableOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_variableOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_variableOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_variableOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_variableOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_variableOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_variableOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_variableOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_variableOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_variableOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_variableOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_variableOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_variableOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_variableOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_variableOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_variableOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_variableOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_variableOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_variableOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_TypeArgument_ConstructorCase :: (T_Range) ->
                                    (T_Name) ->
                                    (T_TypeArgument)
sem_TypeArgument_ConstructorCase (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (TypeArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            -- "./NameTypes.inc.lag"(line 209, column 9)
            (_nameOnameType@_) =
                ref_Val
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres
            -- self rule
            (_self@_) =
                TypeArgument_ConstructorCase _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_TypeArgument_DependencyStyle :: (T_Range) ->
                                    (T_Name) ->
                                    (T_MaybeName) ->
                                    (T_Names) ->
                                    (T_TypeArgument)
sem_TypeArgument_DependencyStyle (range_) (name_) (descriptor_) (variables_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (TypeArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _descriptorIconstructors_collect :: (FMap Name Names)
            _descriptorIknownKinds_collect :: (FMap Name [Name])
            _descriptorIknownTypes_collect :: (FMap Name [Name])
            _descriptorIknownValues_collect :: (FMap Name [Name])
            _descriptorIlabels_collect :: (FMap Name Names)
            _descriptorImethods_collect :: (FMap Name Names)
            _descriptorImoduleTypes :: (FMap ModuleName [Name])
            _descriptorImoduleValues :: (FMap ModuleName [Name])
            _descriptorImodules :: (Set.Set Strings)
            _descriptorIoriginalSelf :: (MaybeName)
            _descriptorIres :: ([ResolveResult])
            _descriptorIself :: (MaybeName)
            _descriptorOclassname :: (Maybe Name)
            _descriptorOconstructors_collect :: (FMap Name Names)
            _descriptorOconstructors_dist :: (FMap Name Names)
            _descriptorOcurrentModule :: (Strings)
            _descriptorOimportedModule :: (Bool)
            _descriptorOinstancename :: (Maybe Name)
            _descriptorOknownKinds :: (FMap Name [Name])
            _descriptorOknownKinds_collect :: (FMap Name [Name])
            _descriptorOknownTypes :: (FMap Name [Name])
            _descriptorOknownTypes_collect :: (FMap Name [Name])
            _descriptorOknownValues :: (FMap Name [Name])
            _descriptorOknownValues_collect :: (FMap Name [Name])
            _descriptorOlabels_collect :: (FMap Name Names)
            _descriptorOlabels_dist :: (FMap Name Names)
            _descriptorOlocal :: (Bool)
            _descriptorOmethods_collect :: (FMap Name Names)
            _descriptorOmethods_dist :: (FMap Name Names)
            _descriptorOmoduleTypes :: (FMap ModuleName [Name])
            _descriptorOmoduleValues :: (FMap ModuleName [Name])
            _descriptorOnameType :: (NameType)
            _descriptorOtoplevel :: (Bool)
            _variablesIconstructors_collect :: (FMap Name Names)
            _variablesIknownKinds_collect :: (FMap Name [Name])
            _variablesIknownTypes_collect :: (FMap Name [Name])
            _variablesIknownValues_collect :: (FMap Name [Name])
            _variablesIlabels_collect :: (FMap Name Names)
            _variablesImethods_collect :: (FMap Name Names)
            _variablesImoduleTypes :: (FMap ModuleName [Name])
            _variablesImoduleValues :: (FMap ModuleName [Name])
            _variablesImodules :: (Set.Set Strings)
            _variablesIoriginalSelf :: (Names)
            _variablesIres :: ([ResolveResult])
            _variablesIself :: (Names)
            _variablesOclassname :: (Maybe Name)
            _variablesOconstructors_collect :: (FMap Name Names)
            _variablesOconstructors_dist :: (FMap Name Names)
            _variablesOcurrentModule :: (Strings)
            _variablesOimportedModule :: (Bool)
            _variablesOinstancename :: (Maybe Name)
            _variablesOknownKinds :: (FMap Name [Name])
            _variablesOknownKinds_collect :: (FMap Name [Name])
            _variablesOknownTypes :: (FMap Name [Name])
            _variablesOknownTypes_collect :: (FMap Name [Name])
            _variablesOknownValues :: (FMap Name [Name])
            _variablesOknownValues_collect :: (FMap Name [Name])
            _variablesOlabels_collect :: (FMap Name Names)
            _variablesOlabels_dist :: (FMap Name Names)
            _variablesOlocal :: (Bool)
            _variablesOmethods_collect :: (FMap Name Names)
            _variablesOmethods_dist :: (FMap Name Names)
            _variablesOmoduleTypes :: (FMap ModuleName [Name])
            _variablesOmoduleValues :: (FMap ModuleName [Name])
            _variablesOnameType :: (NameType)
            _variablesOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _descriptorIconstructors_collect,_descriptorIknownKinds_collect,_descriptorIknownTypes_collect,_descriptorIknownValues_collect,_descriptorIlabels_collect,_descriptorImethods_collect,_descriptorImoduleTypes,_descriptorImoduleValues,_descriptorImodules,_descriptorIoriginalSelf,_descriptorIres,_descriptorIself) =
                (descriptor_ (_descriptorOclassname)
                             (_descriptorOconstructors_collect)
                             (_descriptorOconstructors_dist)
                             (_descriptorOcurrentModule)
                             (_descriptorOimportedModule)
                             (_descriptorOinstancename)
                             (_descriptorOknownKinds)
                             (_descriptorOknownKinds_collect)
                             (_descriptorOknownTypes)
                             (_descriptorOknownTypes_collect)
                             (_descriptorOknownValues)
                             (_descriptorOknownValues_collect)
                             (_descriptorOlabels_collect)
                             (_descriptorOlabels_dist)
                             (_descriptorOlocal)
                             (_descriptorOmethods_collect)
                             (_descriptorOmethods_dist)
                             (_descriptorOmoduleTypes)
                             (_descriptorOmoduleValues)
                             (_descriptorOnameType)
                             (_descriptorOtoplevel))
            ( _variablesIconstructors_collect,_variablesIknownKinds_collect,_variablesIknownTypes_collect,_variablesIknownValues_collect,_variablesIlabels_collect,_variablesImethods_collect,_variablesImoduleTypes,_variablesImoduleValues,_variablesImodules,_variablesIoriginalSelf,_variablesIres,_variablesIself) =
                (variables_ (_variablesOclassname)
                            (_variablesOconstructors_collect)
                            (_variablesOconstructors_dist)
                            (_variablesOcurrentModule)
                            (_variablesOimportedModule)
                            (_variablesOinstancename)
                            (_variablesOknownKinds)
                            (_variablesOknownKinds_collect)
                            (_variablesOknownTypes)
                            (_variablesOknownTypes_collect)
                            (_variablesOknownValues)
                            (_variablesOknownValues_collect)
                            (_variablesOlabels_collect)
                            (_variablesOlabels_dist)
                            (_variablesOlocal)
                            (_variablesOmethods_collect)
                            (_variablesOmethods_dist)
                            (_variablesOmoduleTypes)
                            (_variablesOmoduleValues)
                            (_variablesOnameType)
                            (_variablesOtoplevel))
            -- "./NameTypes.inc.lag"(line 199, column 9)
            (_variablesOnameType@_) =
                Def_Typ
            -- "./NameTypes.inc.lag"(line 198, column 9)
            (_descriptorOnameType@_) =
                Def_Val
            -- "./NameTypes.inc.lag"(line 197, column 9)
            (_nameOnameType@_) =
                ref_Typ
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _descriptorImodules `Set.union` _variablesImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _descriptorIres ++ _variablesIres
            -- self rule
            (_self@_) =
                TypeArgument_DependencyStyle _rangeIself _nameIself _descriptorIself _variablesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _variablesIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _variablesIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _variablesIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _variablesIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _variablesIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _variablesImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _variablesImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _variablesImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_descriptorOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_descriptorOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_descriptorOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_descriptorOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_descriptorOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_descriptorOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_descriptorOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_descriptorOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_descriptorOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_descriptorOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (down)
            (_descriptorOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_descriptorOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_descriptorOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_descriptorOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_descriptorOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_descriptorOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_descriptorOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_descriptorOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_descriptorOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_descriptorOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_variablesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_variablesOconstructors_collect@_) =
                _descriptorIconstructors_collect
            -- copy rule (down)
            (_variablesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_variablesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_variablesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_variablesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_variablesOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_variablesOknownKinds_collect@_) =
                _descriptorIknownKinds_collect
            -- copy rule (down)
            (_variablesOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_variablesOknownTypes_collect@_) =
                _descriptorIknownTypes_collect
            -- copy rule (down)
            (_variablesOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_variablesOknownValues_collect@_) =
                _descriptorIknownValues_collect
            -- copy rule (chain)
            (_variablesOlabels_collect@_) =
                _descriptorIlabels_collect
            -- copy rule (down)
            (_variablesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_variablesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_variablesOmethods_collect@_) =
                _descriptorImethods_collect
            -- copy rule (down)
            (_variablesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_variablesOmoduleTypes@_) =
                _descriptorImoduleTypes
            -- copy rule (chain)
            (_variablesOmoduleValues@_) =
                _descriptorImoduleValues
            -- copy rule (down)
            (_variablesOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_TypeArgument_KindStarCase :: (T_Range) ->
                                 (T_TypeArgument)
sem_TypeArgument_KindStarCase (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (TypeArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                TypeArgument_KindStarCase _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_TypeArgument_Label :: (T_Range) ->
                          (T_Name) ->
                          (T_TypeArgument)
sem_TypeArgument_Label (range_) (variable_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (TypeArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _variableIconstructors_collect :: (FMap Name Names)
            _variableIentityName :: (Name)
            _variableIfullName :: (Name)
            _variableIknownKinds_collect :: (FMap Name [Name])
            _variableIknownTypes_collect :: (FMap Name [Name])
            _variableIknownValues_collect :: (FMap Name [Name])
            _variableIlabels_collect :: (FMap Name Names)
            _variableImethods_collect :: (FMap Name Names)
            _variableImoduleTypes :: (FMap ModuleName [Name])
            _variableImoduleValues :: (FMap ModuleName [Name])
            _variableImodules :: (Set.Set Strings)
            _variableIoriginalSelf :: (Name)
            _variableIres :: ([ResolveResult])
            _variableIself :: (Name)
            _variableOclassname :: (Maybe Name)
            _variableOconstructors_collect :: (FMap Name Names)
            _variableOconstructors_dist :: (FMap Name Names)
            _variableOcurrentModule :: (Strings)
            _variableOimportedModule :: (Bool)
            _variableOinstancename :: (Maybe Name)
            _variableOknownKinds :: (FMap Name [Name])
            _variableOknownKinds_collect :: (FMap Name [Name])
            _variableOknownTypes :: (FMap Name [Name])
            _variableOknownTypes_collect :: (FMap Name [Name])
            _variableOknownValues :: (FMap Name [Name])
            _variableOknownValues_collect :: (FMap Name [Name])
            _variableOlabels_collect :: (FMap Name Names)
            _variableOlabels_dist :: (FMap Name Names)
            _variableOlocal :: (Bool)
            _variableOmethods_collect :: (FMap Name Names)
            _variableOmethods_dist :: (FMap Name Names)
            _variableOmoduleTypes :: (FMap ModuleName [Name])
            _variableOmoduleValues :: (FMap ModuleName [Name])
            _variableOnameType :: (NameType)
            _variableOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _variableIconstructors_collect,_variableIentityName,_variableIfullName,_variableIknownKinds_collect,_variableIknownTypes_collect,_variableIknownValues_collect,_variableIlabels_collect,_variableImethods_collect,_variableImoduleTypes,_variableImoduleValues,_variableImodules,_variableIoriginalSelf,_variableIres,_variableIself) =
                (variable_ (_variableOclassname)
                           (_variableOconstructors_collect)
                           (_variableOconstructors_dist)
                           (_variableOcurrentModule)
                           (_variableOimportedModule)
                           (_variableOinstancename)
                           (_variableOknownKinds)
                           (_variableOknownKinds_collect)
                           (_variableOknownTypes)
                           (_variableOknownTypes_collect)
                           (_variableOknownValues)
                           (_variableOknownValues_collect)
                           (_variableOlabels_collect)
                           (_variableOlabels_dist)
                           (_variableOlocal)
                           (_variableOmethods_collect)
                           (_variableOmethods_dist)
                           (_variableOmoduleTypes)
                           (_variableOmoduleValues)
                           (_variableOnameType)
                           (_variableOtoplevel))
            -- "./NameTypes.inc.lag"(line 207, column 9)
            (_variableOnameType@_) =
                Def_Val
            -- use rule
            (_lhsOmodules@_) =
                _variableImodules
            -- use rule
            (_lhsOres@_) =
                _variableIres
            -- self rule
            (_self@_) =
                TypeArgument_Label _rangeIself _variableIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _variableIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _variableIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _variableIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _variableIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _variableIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _variableImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _variableImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _variableImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_variableOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_variableOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_variableOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_variableOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_variableOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_variableOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_variableOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_variableOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_variableOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_variableOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_variableOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_variableOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_variableOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_variableOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_variableOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_variableOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_variableOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_variableOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_variableOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_variableOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_TypeArgument_NamedType :: (T_Range) ->
                              (T_Name) ->
                              (T_TypeArgument)
sem_TypeArgument_NamedType (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (TypeArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            -- "./NameTypes.inc.lag"(line 195, column 9)
            (_nameOnameType@_) =
                ref_Typ
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres
            -- self rule
            (_self@_) =
                TypeArgument_NamedType _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_TypeArgument_Variable :: (T_Range) ->
                             (T_Name) ->
                             (T_TypeArgument)
sem_TypeArgument_Variable (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (TypeArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            -- "./NameTypes.inc.lag"(line 201, column 9)
            (_nameOnameType@_) =
                deforref_Typ
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres
            -- self rule
            (_self@_) =
                TypeArgument_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- TypeArguments -----------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for TypeArguments.Cons:
      self

-}
{-
   local variables for TypeArguments.Nil:
      self

-}
-- semantic domain
type T_TypeArguments = (Maybe Name) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (Strings) ->
                       (Bool) ->
                       (Maybe Name) ->
                       (FMap Name [Name]) ->
                       (FMap Name [Name]) ->
                       (FMap Name [Name]) ->
                       (FMap Name [Name]) ->
                       (FMap Name [Name]) ->
                       (FMap Name [Name]) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (Bool) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (FMap ModuleName [Name]) ->
                       (FMap ModuleName [Name]) ->
                       (NameType) ->
                       (Bool) ->
                       ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(TypeArguments))
-- cata
sem_TypeArguments :: (TypeArguments) ->
                     (T_TypeArguments)
sem_TypeArguments (list) =
    (foldr (sem_TypeArguments_Cons) (sem_TypeArguments_Nil) ((map sem_TypeArgument list)))
sem_TypeArguments_Cons :: (T_TypeArgument) ->
                          (T_TypeArguments) ->
                          (T_TypeArguments)
sem_TypeArguments_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (TypeArguments)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIknownKinds_collect :: (FMap Name [Name])
            _hdIknownTypes_collect :: (FMap Name [Name])
            _hdIknownValues_collect :: (FMap Name [Name])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdImoduleTypes :: (FMap ModuleName [Name])
            _hdImoduleValues :: (FMap ModuleName [Name])
            _hdImodules :: (Set.Set Strings)
            _hdIres :: ([ResolveResult])
            _hdIself :: (TypeArgument)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOknownKinds :: (FMap Name [Name])
            _hdOknownKinds_collect :: (FMap Name [Name])
            _hdOknownTypes :: (FMap Name [Name])
            _hdOknownTypes_collect :: (FMap Name [Name])
            _hdOknownValues :: (FMap Name [Name])
            _hdOknownValues_collect :: (FMap Name [Name])
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmoduleTypes :: (FMap ModuleName [Name])
            _hdOmoduleValues :: (FMap ModuleName [Name])
            _hdOnameType :: (NameType)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIknownKinds_collect :: (FMap Name [Name])
            _tlIknownTypes_collect :: (FMap Name [Name])
            _tlIknownValues_collect :: (FMap Name [Name])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlImoduleTypes :: (FMap ModuleName [Name])
            _tlImoduleValues :: (FMap ModuleName [Name])
            _tlImodules :: (Set.Set Strings)
            _tlIres :: ([ResolveResult])
            _tlIself :: (TypeArguments)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOknownKinds :: (FMap Name [Name])
            _tlOknownKinds_collect :: (FMap Name [Name])
            _tlOknownTypes :: (FMap Name [Name])
            _tlOknownTypes_collect :: (FMap Name [Name])
            _tlOknownValues :: (FMap Name [Name])
            _tlOknownValues_collect :: (FMap Name [Name])
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmoduleTypes :: (FMap ModuleName [Name])
            _tlOmoduleValues :: (FMap ModuleName [Name])
            _tlOnameType :: (NameType)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIknownKinds_collect,_hdIknownTypes_collect,_hdIknownValues_collect,_hdIlabels_collect,_hdImethods_collect,_hdImoduleTypes,_hdImoduleValues,_hdImodules,_hdIres,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOimportedModule) (_hdOinstancename) (_hdOknownKinds) (_hdOknownKinds_collect) (_hdOknownTypes) (_hdOknownTypes_collect) (_hdOknownValues) (_hdOknownValues_collect) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOmoduleTypes) (_hdOmoduleValues) (_hdOnameType) (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIknownKinds_collect,_tlIknownTypes_collect,_tlIknownValues_collect,_tlIlabels_collect,_tlImethods_collect,_tlImoduleTypes,_tlImoduleValues,_tlImodules,_tlIres,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOimportedModule) (_tlOinstancename) (_tlOknownKinds) (_tlOknownKinds_collect) (_tlOknownTypes) (_tlOknownTypes_collect) (_tlOknownValues) (_tlOknownValues_collect) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOmoduleTypes) (_tlOmoduleValues) (_tlOnameType) (_tlOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _hdImodules `Set.union` _tlImodules
            -- use rule
            (_lhsOres@_) =
                _hdIres ++ _tlIres
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _tlIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _tlIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _tlIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _tlImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _tlImoduleValues
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_hdOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_hdOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_hdOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_hdOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_hdOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_hdOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_hdOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_tlOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_tlOknownKinds_collect@_) =
                _hdIknownKinds_collect
            -- copy rule (down)
            (_tlOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_tlOknownTypes_collect@_) =
                _hdIknownTypes_collect
            -- copy rule (down)
            (_tlOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_tlOknownValues_collect@_) =
                _hdIknownValues_collect
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_tlOmoduleTypes@_) =
                _hdImoduleTypes
            -- copy rule (chain)
            (_tlOmoduleValues@_) =
                _hdImoduleValues
            -- copy rule (down)
            (_tlOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_TypeArguments_Nil :: (T_TypeArguments)
sem_TypeArguments_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (TypeArguments)
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
-- TypeIndexedBinding ------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      name                 : Name
      res                  : [ResolveResult]
      self                 : SELF
      typeargument         : Maybe TypeArgument

-}
{-
   local variables for TypeIndexedBinding.DefaultCase:
      self

-}
{-
   local variables for TypeIndexedBinding.TypeIndexedBinding:
      self

-}
-- semantic domain
type T_TypeIndexedBinding = (Maybe Name) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Strings) ->
                            (Bool) ->
                            (Maybe Name) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name [Name]) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Bool) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (FMap ModuleName [Name]) ->
                            (FMap ModuleName [Name]) ->
                            (NameType) ->
                            (Bool) ->
                            ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),(Name),([ResolveResult]),(TypeIndexedBinding),(Maybe TypeArgument))
-- cata
sem_TypeIndexedBinding :: (TypeIndexedBinding) ->
                          (T_TypeIndexedBinding)
sem_TypeIndexedBinding ((TypeIndexedBinding_DefaultCase (_range) (_name) (_extended) (_reassignments))) =
    (sem_TypeIndexedBinding_DefaultCase ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Name (_extended))) ((sem_MaybeReassignments (_reassignments))))
sem_TypeIndexedBinding ((TypeIndexedBinding_TypeIndexedBinding (_range) (_name) (_typeargument) (_patterns) (_righthandside))) =
    (sem_TypeIndexedBinding_TypeIndexedBinding ((sem_Range (_range))) ((sem_Name (_name))) ((sem_TypeArgument (_typeargument))) ((sem_Patterns (_patterns))) ((sem_RightHandSide (_righthandside))))
sem_TypeIndexedBinding_DefaultCase :: (T_Range) ->
                                      (T_Name) ->
                                      (T_Name) ->
                                      (T_MaybeReassignments) ->
                                      (T_TypeIndexedBinding)
sem_TypeIndexedBinding_DefaultCase (range_) (name_) (extended_) (reassignments_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOname :: (Name)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (TypeIndexedBinding)
            _lhsOtypeargument :: (Maybe TypeArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _extendedIconstructors_collect :: (FMap Name Names)
            _extendedIentityName :: (Name)
            _extendedIfullName :: (Name)
            _extendedIknownKinds_collect :: (FMap Name [Name])
            _extendedIknownTypes_collect :: (FMap Name [Name])
            _extendedIknownValues_collect :: (FMap Name [Name])
            _extendedIlabels_collect :: (FMap Name Names)
            _extendedImethods_collect :: (FMap Name Names)
            _extendedImoduleTypes :: (FMap ModuleName [Name])
            _extendedImoduleValues :: (FMap ModuleName [Name])
            _extendedImodules :: (Set.Set Strings)
            _extendedIoriginalSelf :: (Name)
            _extendedIres :: ([ResolveResult])
            _extendedIself :: (Name)
            _extendedOclassname :: (Maybe Name)
            _extendedOconstructors_collect :: (FMap Name Names)
            _extendedOconstructors_dist :: (FMap Name Names)
            _extendedOcurrentModule :: (Strings)
            _extendedOimportedModule :: (Bool)
            _extendedOinstancename :: (Maybe Name)
            _extendedOknownKinds :: (FMap Name [Name])
            _extendedOknownKinds_collect :: (FMap Name [Name])
            _extendedOknownTypes :: (FMap Name [Name])
            _extendedOknownTypes_collect :: (FMap Name [Name])
            _extendedOknownValues :: (FMap Name [Name])
            _extendedOknownValues_collect :: (FMap Name [Name])
            _extendedOlabels_collect :: (FMap Name Names)
            _extendedOlabels_dist :: (FMap Name Names)
            _extendedOlocal :: (Bool)
            _extendedOmethods_collect :: (FMap Name Names)
            _extendedOmethods_dist :: (FMap Name Names)
            _extendedOmoduleTypes :: (FMap ModuleName [Name])
            _extendedOmoduleValues :: (FMap ModuleName [Name])
            _extendedOnameType :: (NameType)
            _extendedOtoplevel :: (Bool)
            _reassignmentsIconstructors_collect :: (FMap Name Names)
            _reassignmentsIknownKinds_collect :: (FMap Name [Name])
            _reassignmentsIknownTypes_collect :: (FMap Name [Name])
            _reassignmentsIknownValues_collect :: (FMap Name [Name])
            _reassignmentsIlabels_collect :: (FMap Name Names)
            _reassignmentsImethods_collect :: (FMap Name Names)
            _reassignmentsImoduleTypes :: (FMap ModuleName [Name])
            _reassignmentsImoduleValues :: (FMap ModuleName [Name])
            _reassignmentsImodules :: (Set.Set Strings)
            _reassignmentsIres :: ([ResolveResult])
            _reassignmentsIself :: (MaybeReassignments)
            _reassignmentsOclassname :: (Maybe Name)
            _reassignmentsOconstructors_collect :: (FMap Name Names)
            _reassignmentsOconstructors_dist :: (FMap Name Names)
            _reassignmentsOcurrentModule :: (Strings)
            _reassignmentsOimportedModule :: (Bool)
            _reassignmentsOinstancename :: (Maybe Name)
            _reassignmentsOknownKinds :: (FMap Name [Name])
            _reassignmentsOknownKinds_collect :: (FMap Name [Name])
            _reassignmentsOknownTypes :: (FMap Name [Name])
            _reassignmentsOknownTypes_collect :: (FMap Name [Name])
            _reassignmentsOknownValues :: (FMap Name [Name])
            _reassignmentsOknownValues_collect :: (FMap Name [Name])
            _reassignmentsOlabels_collect :: (FMap Name Names)
            _reassignmentsOlabels_dist :: (FMap Name Names)
            _reassignmentsOlocal :: (Bool)
            _reassignmentsOmethods_collect :: (FMap Name Names)
            _reassignmentsOmethods_dist :: (FMap Name Names)
            _reassignmentsOmoduleTypes :: (FMap ModuleName [Name])
            _reassignmentsOmoduleValues :: (FMap ModuleName [Name])
            _reassignmentsOnameType :: (NameType)
            _reassignmentsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _extendedIconstructors_collect,_extendedIentityName,_extendedIfullName,_extendedIknownKinds_collect,_extendedIknownTypes_collect,_extendedIknownValues_collect,_extendedIlabels_collect,_extendedImethods_collect,_extendedImoduleTypes,_extendedImoduleValues,_extendedImodules,_extendedIoriginalSelf,_extendedIres,_extendedIself) =
                (extended_ (_extendedOclassname)
                           (_extendedOconstructors_collect)
                           (_extendedOconstructors_dist)
                           (_extendedOcurrentModule)
                           (_extendedOimportedModule)
                           (_extendedOinstancename)
                           (_extendedOknownKinds)
                           (_extendedOknownKinds_collect)
                           (_extendedOknownTypes)
                           (_extendedOknownTypes_collect)
                           (_extendedOknownValues)
                           (_extendedOknownValues_collect)
                           (_extendedOlabels_collect)
                           (_extendedOlabels_dist)
                           (_extendedOlocal)
                           (_extendedOmethods_collect)
                           (_extendedOmethods_dist)
                           (_extendedOmoduleTypes)
                           (_extendedOmoduleValues)
                           (_extendedOnameType)
                           (_extendedOtoplevel))
            ( _reassignmentsIconstructors_collect,_reassignmentsIknownKinds_collect,_reassignmentsIknownTypes_collect,_reassignmentsIknownValues_collect,_reassignmentsIlabels_collect,_reassignmentsImethods_collect,_reassignmentsImoduleTypes,_reassignmentsImoduleValues,_reassignmentsImodules,_reassignmentsIres,_reassignmentsIself) =
                (reassignments_ (_reassignmentsOclassname)
                                (_reassignmentsOconstructors_collect)
                                (_reassignmentsOconstructors_dist)
                                (_reassignmentsOcurrentModule)
                                (_reassignmentsOimportedModule)
                                (_reassignmentsOinstancename)
                                (_reassignmentsOknownKinds)
                                (_reassignmentsOknownKinds_collect)
                                (_reassignmentsOknownTypes)
                                (_reassignmentsOknownTypes_collect)
                                (_reassignmentsOknownValues)
                                (_reassignmentsOknownValues_collect)
                                (_reassignmentsOlabels_collect)
                                (_reassignmentsOlabels_dist)
                                (_reassignmentsOlocal)
                                (_reassignmentsOmethods_collect)
                                (_reassignmentsOmethods_dist)
                                (_reassignmentsOmoduleTypes)
                                (_reassignmentsOmoduleValues)
                                (_reassignmentsOnameType)
                                (_reassignmentsOtoplevel))
            -- "./NameTypes.inc.lag"(line 286, column 9)
            (_reassignmentsOnameType@_) =
                ref_Val
            -- "./NameTypes.inc.lag"(line 285, column 9)
            (_extendedOnameType@_) =
                ref_Val
            -- "./ModuleInformation.inc.lag"(line 435, column 9)
            (_lhsOtypeargument@_) =
                Nothing
            -- "./ModuleInformation.inc.lag"(line 434, column 9)
            (_lhsOname@_) =
                _nameIself
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _extendedImodules `Set.union` _reassignmentsImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _extendedIres ++ _reassignmentsIres
            -- self rule
            (_self@_) =
                TypeIndexedBinding_DefaultCase _rangeIself _nameIself _extendedIself _reassignmentsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _reassignmentsIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _reassignmentsIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _reassignmentsIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _reassignmentsIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _reassignmentsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _reassignmentsImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _reassignmentsImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _reassignmentsImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_extendedOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_extendedOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_extendedOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_extendedOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_extendedOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_extendedOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_extendedOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_extendedOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_extendedOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_extendedOknownTypes_collect@_) =
                _nameIknownTypes_collect
            -- copy rule (down)
            (_extendedOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_extendedOknownValues_collect@_) =
                _nameIknownValues_collect
            -- copy rule (chain)
            (_extendedOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_extendedOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_extendedOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_extendedOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_extendedOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_extendedOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_extendedOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_extendedOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_reassignmentsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_reassignmentsOconstructors_collect@_) =
                _extendedIconstructors_collect
            -- copy rule (down)
            (_reassignmentsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_reassignmentsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_reassignmentsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_reassignmentsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_reassignmentsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_reassignmentsOknownKinds_collect@_) =
                _extendedIknownKinds_collect
            -- copy rule (down)
            (_reassignmentsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_reassignmentsOknownTypes_collect@_) =
                _extendedIknownTypes_collect
            -- copy rule (down)
            (_reassignmentsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_reassignmentsOknownValues_collect@_) =
                _extendedIknownValues_collect
            -- copy rule (chain)
            (_reassignmentsOlabels_collect@_) =
                _extendedIlabels_collect
            -- copy rule (down)
            (_reassignmentsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_reassignmentsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_reassignmentsOmethods_collect@_) =
                _extendedImethods_collect
            -- copy rule (down)
            (_reassignmentsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_reassignmentsOmoduleTypes@_) =
                _extendedImoduleTypes
            -- copy rule (chain)
            (_reassignmentsOmoduleValues@_) =
                _extendedImoduleValues
            -- copy rule (down)
            (_reassignmentsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOname,_lhsOres,_lhsOself,_lhsOtypeargument)
sem_TypeIndexedBinding_TypeIndexedBinding :: (T_Range) ->
                                             (T_Name) ->
                                             (T_TypeArgument) ->
                                             (T_Patterns) ->
                                             (T_RightHandSide) ->
                                             (T_TypeIndexedBinding)
sem_TypeIndexedBinding_TypeIndexedBinding (range_) (name_) (typeargument_) (patterns_) (righthandside_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOname :: (Name)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (TypeIndexedBinding)
            _lhsOtypeargument :: (Maybe TypeArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIentityName :: (Name)
            _nameIfullName :: (Name)
            _nameIknownKinds_collect :: (FMap Name [Name])
            _nameIknownTypes_collect :: (FMap Name [Name])
            _nameIknownValues_collect :: (FMap Name [Name])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameImoduleTypes :: (FMap ModuleName [Name])
            _nameImoduleValues :: (FMap ModuleName [Name])
            _nameImodules :: (Set.Set Strings)
            _nameIoriginalSelf :: (Name)
            _nameIres :: ([ResolveResult])
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOimportedModule :: (Bool)
            _nameOinstancename :: (Maybe Name)
            _nameOknownKinds :: (FMap Name [Name])
            _nameOknownKinds_collect :: (FMap Name [Name])
            _nameOknownTypes :: (FMap Name [Name])
            _nameOknownTypes_collect :: (FMap Name [Name])
            _nameOknownValues :: (FMap Name [Name])
            _nameOknownValues_collect :: (FMap Name [Name])
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOmoduleTypes :: (FMap ModuleName [Name])
            _nameOmoduleValues :: (FMap ModuleName [Name])
            _nameOnameType :: (NameType)
            _nameOtoplevel :: (Bool)
            _typeargumentIconstructors_collect :: (FMap Name Names)
            _typeargumentIknownKinds_collect :: (FMap Name [Name])
            _typeargumentIknownTypes_collect :: (FMap Name [Name])
            _typeargumentIknownValues_collect :: (FMap Name [Name])
            _typeargumentIlabels_collect :: (FMap Name Names)
            _typeargumentImethods_collect :: (FMap Name Names)
            _typeargumentImoduleTypes :: (FMap ModuleName [Name])
            _typeargumentImoduleValues :: (FMap ModuleName [Name])
            _typeargumentImodules :: (Set.Set Strings)
            _typeargumentIres :: ([ResolveResult])
            _typeargumentIself :: (TypeArgument)
            _typeargumentOclassname :: (Maybe Name)
            _typeargumentOconstructors_collect :: (FMap Name Names)
            _typeargumentOconstructors_dist :: (FMap Name Names)
            _typeargumentOcurrentModule :: (Strings)
            _typeargumentOimportedModule :: (Bool)
            _typeargumentOinstancename :: (Maybe Name)
            _typeargumentOknownKinds :: (FMap Name [Name])
            _typeargumentOknownKinds_collect :: (FMap Name [Name])
            _typeargumentOknownTypes :: (FMap Name [Name])
            _typeargumentOknownTypes_collect :: (FMap Name [Name])
            _typeargumentOknownValues :: (FMap Name [Name])
            _typeargumentOknownValues_collect :: (FMap Name [Name])
            _typeargumentOlabels_collect :: (FMap Name Names)
            _typeargumentOlabels_dist :: (FMap Name Names)
            _typeargumentOlocal :: (Bool)
            _typeargumentOmethods_collect :: (FMap Name Names)
            _typeargumentOmethods_dist :: (FMap Name Names)
            _typeargumentOmoduleTypes :: (FMap ModuleName [Name])
            _typeargumentOmoduleValues :: (FMap ModuleName [Name])
            _typeargumentOnameType :: (NameType)
            _typeargumentOtoplevel :: (Bool)
            _patternsIconstructors_collect :: (FMap Name Names)
            _patternsIknownKinds_collect :: (FMap Name [Name])
            _patternsIknownTypes_collect :: (FMap Name [Name])
            _patternsIknownValues_collect :: (FMap Name [Name])
            _patternsIlabels_collect :: (FMap Name Names)
            _patternsImethods_collect :: (FMap Name Names)
            _patternsImoduleTypes :: (FMap ModuleName [Name])
            _patternsImoduleValues :: (FMap ModuleName [Name])
            _patternsImodules :: (Set.Set Strings)
            _patternsIres :: ([ResolveResult])
            _patternsIself :: (Patterns)
            _patternsOclassname :: (Maybe Name)
            _patternsOconstructors_collect :: (FMap Name Names)
            _patternsOconstructors_dist :: (FMap Name Names)
            _patternsOcurrentModule :: (Strings)
            _patternsOimportedModule :: (Bool)
            _patternsOinstancename :: (Maybe Name)
            _patternsOknownKinds :: (FMap Name [Name])
            _patternsOknownKinds_collect :: (FMap Name [Name])
            _patternsOknownTypes :: (FMap Name [Name])
            _patternsOknownTypes_collect :: (FMap Name [Name])
            _patternsOknownValues :: (FMap Name [Name])
            _patternsOknownValues_collect :: (FMap Name [Name])
            _patternsOlabels_collect :: (FMap Name Names)
            _patternsOlabels_dist :: (FMap Name Names)
            _patternsOlocal :: (Bool)
            _patternsOmethods_collect :: (FMap Name Names)
            _patternsOmethods_dist :: (FMap Name Names)
            _patternsOmoduleTypes :: (FMap ModuleName [Name])
            _patternsOmoduleValues :: (FMap ModuleName [Name])
            _patternsOnameType :: (NameType)
            _patternsOtoplevel :: (Bool)
            _righthandsideIconstructors_collect :: (FMap Name Names)
            _righthandsideIknownKinds_collect :: (FMap Name [Name])
            _righthandsideIknownTypes_collect :: (FMap Name [Name])
            _righthandsideIknownValues_collect :: (FMap Name [Name])
            _righthandsideIlabels_collect :: (FMap Name Names)
            _righthandsideImethods_collect :: (FMap Name Names)
            _righthandsideImoduleTypes :: (FMap ModuleName [Name])
            _righthandsideImoduleValues :: (FMap ModuleName [Name])
            _righthandsideImodules :: (Set.Set Strings)
            _righthandsideIres :: ([ResolveResult])
            _righthandsideIself :: (RightHandSide)
            _righthandsideOclassname :: (Maybe Name)
            _righthandsideOconstructors_collect :: (FMap Name Names)
            _righthandsideOconstructors_dist :: (FMap Name Names)
            _righthandsideOcurrentModule :: (Strings)
            _righthandsideOimportedModule :: (Bool)
            _righthandsideOinstancename :: (Maybe Name)
            _righthandsideOknownGenerics :: (FMap Name [Name])
            _righthandsideOknownKinds :: (FMap Name [Name])
            _righthandsideOknownKinds_collect :: (FMap Name [Name])
            _righthandsideOknownTypes :: (FMap Name [Name])
            _righthandsideOknownTypes_collect :: (FMap Name [Name])
            _righthandsideOknownValues :: (FMap Name [Name])
            _righthandsideOknownValues_collect :: (FMap Name [Name])
            _righthandsideOlabels_collect :: (FMap Name Names)
            _righthandsideOlabels_dist :: (FMap Name Names)
            _righthandsideOlocal :: (Bool)
            _righthandsideOmethods_collect :: (FMap Name Names)
            _righthandsideOmethods_dist :: (FMap Name Names)
            _righthandsideOmoduleTypes :: (FMap ModuleName [Name])
            _righthandsideOmoduleValues :: (FMap ModuleName [Name])
            _righthandsideOnameType :: (NameType)
            _righthandsideOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIentityName,_nameIfullName,_nameIknownKinds_collect,_nameIknownTypes_collect,_nameIknownValues_collect,_nameIlabels_collect,_nameImethods_collect,_nameImoduleTypes,_nameImoduleValues,_nameImodules,_nameIoriginalSelf,_nameIres,_nameIself) =
                (name_ (_nameOclassname)
                       (_nameOconstructors_collect)
                       (_nameOconstructors_dist)
                       (_nameOcurrentModule)
                       (_nameOimportedModule)
                       (_nameOinstancename)
                       (_nameOknownKinds)
                       (_nameOknownKinds_collect)
                       (_nameOknownTypes)
                       (_nameOknownTypes_collect)
                       (_nameOknownValues)
                       (_nameOknownValues_collect)
                       (_nameOlabels_collect)
                       (_nameOlabels_dist)
                       (_nameOlocal)
                       (_nameOmethods_collect)
                       (_nameOmethods_dist)
                       (_nameOmoduleTypes)
                       (_nameOmoduleValues)
                       (_nameOnameType)
                       (_nameOtoplevel))
            ( _typeargumentIconstructors_collect,_typeargumentIknownKinds_collect,_typeargumentIknownTypes_collect,_typeargumentIknownValues_collect,_typeargumentIlabels_collect,_typeargumentImethods_collect,_typeargumentImoduleTypes,_typeargumentImoduleValues,_typeargumentImodules,_typeargumentIres,_typeargumentIself) =
                (typeargument_ (_typeargumentOclassname)
                               (_typeargumentOconstructors_collect)
                               (_typeargumentOconstructors_dist)
                               (_typeargumentOcurrentModule)
                               (_typeargumentOimportedModule)
                               (_typeargumentOinstancename)
                               (_typeargumentOknownKinds)
                               (_typeargumentOknownKinds_collect)
                               (_typeargumentOknownTypes)
                               (_typeargumentOknownTypes_collect)
                               (_typeargumentOknownValues)
                               (_typeargumentOknownValues_collect)
                               (_typeargumentOlabels_collect)
                               (_typeargumentOlabels_dist)
                               (_typeargumentOlocal)
                               (_typeargumentOmethods_collect)
                               (_typeargumentOmethods_dist)
                               (_typeargumentOmoduleTypes)
                               (_typeargumentOmoduleValues)
                               (_typeargumentOnameType)
                               (_typeargumentOtoplevel))
            ( _patternsIconstructors_collect,_patternsIknownKinds_collect,_patternsIknownTypes_collect,_patternsIknownValues_collect,_patternsIlabels_collect,_patternsImethods_collect,_patternsImoduleTypes,_patternsImoduleValues,_patternsImodules,_patternsIres,_patternsIself) =
                (patterns_ (_patternsOclassname)
                           (_patternsOconstructors_collect)
                           (_patternsOconstructors_dist)
                           (_patternsOcurrentModule)
                           (_patternsOimportedModule)
                           (_patternsOinstancename)
                           (_patternsOknownKinds)
                           (_patternsOknownKinds_collect)
                           (_patternsOknownTypes)
                           (_patternsOknownTypes_collect)
                           (_patternsOknownValues)
                           (_patternsOknownValues_collect)
                           (_patternsOlabels_collect)
                           (_patternsOlabels_dist)
                           (_patternsOlocal)
                           (_patternsOmethods_collect)
                           (_patternsOmethods_dist)
                           (_patternsOmoduleTypes)
                           (_patternsOmoduleValues)
                           (_patternsOnameType)
                           (_patternsOtoplevel))
            ( _righthandsideIconstructors_collect,_righthandsideIknownKinds_collect,_righthandsideIknownTypes_collect,_righthandsideIknownValues_collect,_righthandsideIlabels_collect,_righthandsideImethods_collect,_righthandsideImoduleTypes,_righthandsideImoduleValues,_righthandsideImodules,_righthandsideIres,_righthandsideIself) =
                (righthandside_ (_righthandsideOclassname)
                                (_righthandsideOconstructors_collect)
                                (_righthandsideOconstructors_dist)
                                (_righthandsideOcurrentModule)
                                (_righthandsideOimportedModule)
                                (_righthandsideOinstancename)
                                (_righthandsideOknownGenerics)
                                (_righthandsideOknownKinds)
                                (_righthandsideOknownKinds_collect)
                                (_righthandsideOknownTypes)
                                (_righthandsideOknownTypes_collect)
                                (_righthandsideOknownValues)
                                (_righthandsideOknownValues_collect)
                                (_righthandsideOlabels_collect)
                                (_righthandsideOlabels_dist)
                                (_righthandsideOlocal)
                                (_righthandsideOmethods_collect)
                                (_righthandsideOmethods_dist)
                                (_righthandsideOmoduleTypes)
                                (_righthandsideOmoduleValues)
                                (_righthandsideOnameType)
                                (_righthandsideOtoplevel))
            -- "./Names.inc.lag"(line 812, column 9)
            (_lhsOknownValues_collect@_) =
                _nameIknownValues_collect
            -- "./Names.inc.lag"(line 811, column 9)
            (_nameOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- "./Names.inc.lag"(line 810, column 9)
            (_righthandsideOknownValues@_) =
                _patternsIknownValues_collect `mergeFM` _lhsIknownValues
            -- "./Names.inc.lag"(line 809, column 9)
            (_patternsOknownValues_collect@_) =
                _typeargumentIknownValues_collect
            -- "./Names.inc.lag"(line 808, column 9)
            (_typeargumentOknownValues_collect@_) =
                emptyFM
            -- "./Names.inc.lag"(line 805, column 9)
            (_lhsOknownTypes_collect@_) =
                if _lhsItoplevel then _lhsIknownTypes_collect
                                 else _typeargumentIknownTypes_collect
            -- "./Names.inc.lag"(line 804, column 9)
            (_righthandsideOknownTypes@_) =
                _typeargumentIknownTypes_collect `mergeFM` _lhsIknownTypes
            -- "./Names.inc.lag"(line 801, column 9)
            (_typeargumentOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- "./ModuleInformation.inc.lag"(line 172, column 8)
            (_righthandsideOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 171, column 8)
            (_patternsOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 170, column 8)
            (_typeargumentOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 432, column 9)
            (_lhsOtypeargument@_) =
                Just _typeargumentIself
            -- "./ModuleInformation.inc.lag"(line 431, column 9)
            (_lhsOname@_) =
                _nameIself
            -- use rule
            (_lhsOmodules@_) =
                _nameImodules `Set.union` _typeargumentImodules `Set.union` _patternsImodules `Set.union` _righthandsideImodules
            -- use rule
            (_lhsOres@_) =
                _nameIres ++ _typeargumentIres ++ _patternsIres ++ _righthandsideIres
            -- self rule
            (_self@_) =
                TypeIndexedBinding_TypeIndexedBinding _rangeIself _nameIself _typeargumentIself _patternsIself _righthandsideIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _righthandsideIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _righthandsideIknownKinds_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _righthandsideIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _righthandsideImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _righthandsideImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _righthandsideImoduleValues
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_nameOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_nameOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_nameOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_nameOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_nameOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_nameOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeargumentOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeargumentOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_typeargumentOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeargumentOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeargumentOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeargumentOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typeargumentOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_typeargumentOknownKinds_collect@_) =
                _nameIknownKinds_collect
            -- copy rule (down)
            (_typeargumentOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_typeargumentOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_typeargumentOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_typeargumentOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeargumentOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeargumentOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_typeargumentOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_typeargumentOmoduleTypes@_) =
                _nameImoduleTypes
            -- copy rule (chain)
            (_typeargumentOmoduleValues@_) =
                _nameImoduleValues
            -- copy rule (down)
            (_typeargumentOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_patternsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_patternsOconstructors_collect@_) =
                _typeargumentIconstructors_collect
            -- copy rule (down)
            (_patternsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternsOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_patternsOknownKinds_collect@_) =
                _typeargumentIknownKinds_collect
            -- copy rule (down)
            (_patternsOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_patternsOknownTypes_collect@_) =
                _typeargumentIknownTypes_collect
            -- copy rule (down)
            (_patternsOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_patternsOlabels_collect@_) =
                _typeargumentIlabels_collect
            -- copy rule (down)
            (_patternsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_patternsOmethods_collect@_) =
                _typeargumentImethods_collect
            -- copy rule (down)
            (_patternsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_patternsOmoduleTypes@_) =
                _typeargumentImoduleTypes
            -- copy rule (chain)
            (_patternsOmoduleValues@_) =
                _typeargumentImoduleValues
            -- copy rule (down)
            (_patternsOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_righthandsideOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_righthandsideOconstructors_collect@_) =
                _patternsIconstructors_collect
            -- copy rule (down)
            (_righthandsideOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_righthandsideOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_righthandsideOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_righthandsideOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_righthandsideOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_righthandsideOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_righthandsideOknownKinds_collect@_) =
                _patternsIknownKinds_collect
            -- copy rule (chain)
            (_righthandsideOknownTypes_collect@_) =
                _patternsIknownTypes_collect
            -- copy rule (chain)
            (_righthandsideOknownValues_collect@_) =
                _patternsIknownValues_collect
            -- copy rule (chain)
            (_righthandsideOlabels_collect@_) =
                _patternsIlabels_collect
            -- copy rule (down)
            (_righthandsideOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_righthandsideOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_righthandsideOmethods_collect@_) =
                _patternsImethods_collect
            -- copy rule (down)
            (_righthandsideOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_righthandsideOmoduleTypes@_) =
                _patternsImoduleTypes
            -- copy rule (chain)
            (_righthandsideOmoduleValues@_) =
                _patternsImoduleValues
            -- copy rule (down)
            (_righthandsideOnameType@_) =
                _lhsInameType
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOname,_lhsOres,_lhsOself,_lhsOtypeargument)
-- TypeIndexedBindings -----------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      name                 : Name
      res                  : [ResolveResult]
      self                 : SELF
      typeargument         : Maybe TypeArgument

-}
{-
   local variables for TypeIndexedBindings.Cons:
      self

-}
{-
   local variables for TypeIndexedBindings.Nil:
      self

-}
-- semantic domain
type T_TypeIndexedBindings = (Maybe Name) ->
                             (FMap Name Names) ->
                             (FMap Name Names) ->
                             (Strings) ->
                             (Bool) ->
                             (Maybe Name) ->
                             (FMap Name [Name]) ->
                             (FMap Name [Name]) ->
                             (FMap Name [Name]) ->
                             (FMap Name [Name]) ->
                             (FMap Name [Name]) ->
                             (FMap Name [Name]) ->
                             (FMap Name [Name]) ->
                             (FMap Name Names) ->
                             (FMap Name Names) ->
                             (Bool) ->
                             (FMap Name Names) ->
                             (FMap Name Names) ->
                             (FMap ModuleName [Name]) ->
                             (FMap ModuleName [Name]) ->
                             (NameType) ->
                             (Bool) ->
                             ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),(Name),([ResolveResult]),(TypeIndexedBindings),(Maybe TypeArgument))
-- cata
sem_TypeIndexedBindings :: (TypeIndexedBindings) ->
                           (T_TypeIndexedBindings)
sem_TypeIndexedBindings (list) =
    (foldr (sem_TypeIndexedBindings_Cons) (sem_TypeIndexedBindings_Nil) ((map sem_TypeIndexedBinding list)))
sem_TypeIndexedBindings_Cons :: (T_TypeIndexedBinding) ->
                                (T_TypeIndexedBindings) ->
                                (T_TypeIndexedBindings)
sem_TypeIndexedBindings_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOname :: (Name)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (TypeIndexedBindings)
            _lhsOtypeargument :: (Maybe TypeArgument)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIknownKinds_collect :: (FMap Name [Name])
            _hdIknownTypes_collect :: (FMap Name [Name])
            _hdIknownValues_collect :: (FMap Name [Name])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdImoduleTypes :: (FMap ModuleName [Name])
            _hdImoduleValues :: (FMap ModuleName [Name])
            _hdImodules :: (Set.Set Strings)
            _hdIname :: (Name)
            _hdIres :: ([ResolveResult])
            _hdIself :: (TypeIndexedBinding)
            _hdItypeargument :: (Maybe TypeArgument)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOknownGenerics :: (FMap Name [Name])
            _hdOknownKinds :: (FMap Name [Name])
            _hdOknownKinds_collect :: (FMap Name [Name])
            _hdOknownTypes :: (FMap Name [Name])
            _hdOknownTypes_collect :: (FMap Name [Name])
            _hdOknownValues :: (FMap Name [Name])
            _hdOknownValues_collect :: (FMap Name [Name])
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmoduleTypes :: (FMap ModuleName [Name])
            _hdOmoduleValues :: (FMap ModuleName [Name])
            _hdOnameType :: (NameType)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIknownKinds_collect :: (FMap Name [Name])
            _tlIknownTypes_collect :: (FMap Name [Name])
            _tlIknownValues_collect :: (FMap Name [Name])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlImoduleTypes :: (FMap ModuleName [Name])
            _tlImoduleValues :: (FMap ModuleName [Name])
            _tlImodules :: (Set.Set Strings)
            _tlIname :: (Name)
            _tlIres :: ([ResolveResult])
            _tlIself :: (TypeIndexedBindings)
            _tlItypeargument :: (Maybe TypeArgument)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOknownGenerics :: (FMap Name [Name])
            _tlOknownKinds :: (FMap Name [Name])
            _tlOknownKinds_collect :: (FMap Name [Name])
            _tlOknownTypes :: (FMap Name [Name])
            _tlOknownTypes_collect :: (FMap Name [Name])
            _tlOknownValues :: (FMap Name [Name])
            _tlOknownValues_collect :: (FMap Name [Name])
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmoduleTypes :: (FMap ModuleName [Name])
            _tlOmoduleValues :: (FMap ModuleName [Name])
            _tlOnameType :: (NameType)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIknownKinds_collect,_hdIknownTypes_collect,_hdIknownValues_collect,_hdIlabels_collect,_hdImethods_collect,_hdImoduleTypes,_hdImoduleValues,_hdImodules,_hdIname,_hdIres,_hdIself,_hdItypeargument) =
                (hd_ (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOknownGenerics)
                     (_hdOknownKinds)
                     (_hdOknownKinds_collect)
                     (_hdOknownTypes)
                     (_hdOknownTypes_collect)
                     (_hdOknownValues)
                     (_hdOknownValues_collect)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmoduleTypes)
                     (_hdOmoduleValues)
                     (_hdOnameType)
                     (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIknownKinds_collect,_tlIknownTypes_collect,_tlIknownValues_collect,_tlIlabels_collect,_tlImethods_collect,_tlImoduleTypes,_tlImoduleValues,_tlImodules,_tlIname,_tlIres,_tlIself,_tlItypeargument) =
                (tl_ (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOknownGenerics)
                     (_tlOknownKinds)
                     (_tlOknownKinds_collect)
                     (_tlOknownTypes)
                     (_tlOknownTypes_collect)
                     (_tlOknownValues)
                     (_tlOknownValues_collect)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmoduleTypes)
                     (_tlOmoduleValues)
                     (_tlOnameType)
                     (_tlOtoplevel))
            -- "./NameTypes.inc.lag"(line 280, column 9)
            (_tlOnameType@_) =
                if _lhsItoplevel then softref_Val
                                 else ref_Val
            -- "./NameTypes.inc.lag"(line 278, column 9)
            (_hdOnameType@_) =
                if _lhsItoplevel then softref_Val
                                 else ref_Val
            -- "./ModuleInformation.inc.lag"(line 422, column 9)
            (_lhsOtypeargument@_) =
                _hdItypeargument
            -- "./ModuleInformation.inc.lag"(line 421, column 9)
            (_lhsOname@_) =
                _hdIname
            -- use rule
            (_lhsOmodules@_) =
                _hdImodules `Set.union` _tlImodules
            -- use rule
            (_lhsOres@_) =
                _hdIres ++ _tlIres
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _tlIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _tlIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _tlIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _tlImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _tlImoduleValues
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_hdOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_hdOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_hdOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_hdOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_hdOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_hdOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_hdOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_tlOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_tlOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_tlOknownKinds_collect@_) =
                _hdIknownKinds_collect
            -- copy rule (down)
            (_tlOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_tlOknownTypes_collect@_) =
                _hdIknownTypes_collect
            -- copy rule (down)
            (_tlOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_tlOknownValues_collect@_) =
                _hdIknownValues_collect
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_tlOmoduleTypes@_) =
                _hdImoduleTypes
            -- copy rule (chain)
            (_tlOmoduleValues@_) =
                _hdImoduleValues
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOname,_lhsOres,_lhsOself,_lhsOtypeargument)
sem_TypeIndexedBindings_Nil :: (T_TypeIndexedBindings)
sem_TypeIndexedBindings_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOname :: (Name)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (TypeIndexedBindings)
            _lhsOtypeargument :: (Maybe TypeArgument)
            -- "./ModuleInformation.inc.lag"(line 426, column 9)
            (_lhsOtypeargument@_) =
                internalError $
                  "ModuleInformation.TypeIndexedBindings.Nil.lhs.typeargument: no bindings"
            -- "./ModuleInformation.inc.lag"(line 424, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.TypeIndexedBindings.Nil.lhs.name: no bindings"
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOname,_lhsOres,_lhsOself,_lhsOtypeargument)
-- Types -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      knownGenerics        : FMap Name [Name]
      knownKinds           : FMap Name [Name]
      knownTypes           : FMap Name [Name]
      knownValues          : FMap Name [Name]
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      knownKinds_collect   : FMap Name [Name]
      knownTypes_collect   : FMap Name [Name]
      knownValues_collect  : FMap Name [Name]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      moduleTypes          : FMap ModuleName [Name]
      moduleValues         : FMap ModuleName [Name]

   synthesised attributes:
      modules              : Set.Set Strings
      res                  : [ResolveResult]
      self                 : SELF

-}
{-
   local variables for Types.Cons:
      self

-}
{-
   local variables for Types.Nil:
      self

-}
-- semantic domain
type T_Types = (Maybe Name) ->
               (FMap Name Names) ->
               (FMap Name Names) ->
               (Strings) ->
               (Bool) ->
               (Maybe Name) ->
               (FMap Name [Name]) ->
               (FMap Name [Name]) ->
               (FMap Name [Name]) ->
               (FMap Name [Name]) ->
               (FMap Name [Name]) ->
               (FMap Name [Name]) ->
               (FMap Name [Name]) ->
               (FMap Name Names) ->
               (FMap Name Names) ->
               (Bool) ->
               (FMap Name Names) ->
               (FMap Name Names) ->
               (FMap ModuleName [Name]) ->
               (FMap ModuleName [Name]) ->
               (NameType) ->
               (Bool) ->
               ( (FMap Name Names),(FMap Name [Name]),(FMap Name [Name]),(FMap Name [Name]),(FMap Name Names),(FMap Name Names),(FMap ModuleName [Name]),(FMap ModuleName [Name]),(Set.Set Strings),([ResolveResult]),(Types))
-- cata
sem_Types :: (Types) ->
             (T_Types)
sem_Types (list) =
    (foldr (sem_Types_Cons) (sem_Types_Nil) ((map sem_Type list)))
sem_Types_Cons :: (T_Type) ->
                  (T_Types) ->
                  (T_Types)
sem_Types_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Types)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIknownKinds_collect :: (FMap Name [Name])
            _hdIknownTypes_collect :: (FMap Name [Name])
            _hdIknownValues_collect :: (FMap Name [Name])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdImoduleTypes :: (FMap ModuleName [Name])
            _hdImoduleValues :: (FMap ModuleName [Name])
            _hdImodules :: (Set.Set Strings)
            _hdIres :: ([ResolveResult])
            _hdIself :: (Type)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOimportedModule :: (Bool)
            _hdOinstancename :: (Maybe Name)
            _hdOknownGenerics :: (FMap Name [Name])
            _hdOknownKinds :: (FMap Name [Name])
            _hdOknownKinds_collect :: (FMap Name [Name])
            _hdOknownTypes :: (FMap Name [Name])
            _hdOknownTypes_collect :: (FMap Name [Name])
            _hdOknownValues :: (FMap Name [Name])
            _hdOknownValues_collect :: (FMap Name [Name])
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOmoduleTypes :: (FMap ModuleName [Name])
            _hdOmoduleValues :: (FMap ModuleName [Name])
            _hdOnameType :: (NameType)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIknownKinds_collect :: (FMap Name [Name])
            _tlIknownTypes_collect :: (FMap Name [Name])
            _tlIknownValues_collect :: (FMap Name [Name])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlImoduleTypes :: (FMap ModuleName [Name])
            _tlImoduleValues :: (FMap ModuleName [Name])
            _tlImodules :: (Set.Set Strings)
            _tlIres :: ([ResolveResult])
            _tlIself :: (Types)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOimportedModule :: (Bool)
            _tlOinstancename :: (Maybe Name)
            _tlOknownGenerics :: (FMap Name [Name])
            _tlOknownKinds :: (FMap Name [Name])
            _tlOknownKinds_collect :: (FMap Name [Name])
            _tlOknownTypes :: (FMap Name [Name])
            _tlOknownTypes_collect :: (FMap Name [Name])
            _tlOknownValues :: (FMap Name [Name])
            _tlOknownValues_collect :: (FMap Name [Name])
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOmoduleTypes :: (FMap ModuleName [Name])
            _tlOmoduleValues :: (FMap ModuleName [Name])
            _tlOnameType :: (NameType)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIknownKinds_collect,_hdIknownTypes_collect,_hdIknownValues_collect,_hdIlabels_collect,_hdImethods_collect,_hdImoduleTypes,_hdImoduleValues,_hdImodules,_hdIres,_hdIself) =
                (hd_ (_hdOclassname)
                     (_hdOconstructors_collect)
                     (_hdOconstructors_dist)
                     (_hdOcurrentModule)
                     (_hdOimportedModule)
                     (_hdOinstancename)
                     (_hdOknownGenerics)
                     (_hdOknownKinds)
                     (_hdOknownKinds_collect)
                     (_hdOknownTypes)
                     (_hdOknownTypes_collect)
                     (_hdOknownValues)
                     (_hdOknownValues_collect)
                     (_hdOlabels_collect)
                     (_hdOlabels_dist)
                     (_hdOlocal)
                     (_hdOmethods_collect)
                     (_hdOmethods_dist)
                     (_hdOmoduleTypes)
                     (_hdOmoduleValues)
                     (_hdOnameType)
                     (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIknownKinds_collect,_tlIknownTypes_collect,_tlIknownValues_collect,_tlIlabels_collect,_tlImethods_collect,_tlImoduleTypes,_tlImoduleValues,_tlImodules,_tlIres,_tlIself) =
                (tl_ (_tlOclassname)
                     (_tlOconstructors_collect)
                     (_tlOconstructors_dist)
                     (_tlOcurrentModule)
                     (_tlOimportedModule)
                     (_tlOinstancename)
                     (_tlOknownGenerics)
                     (_tlOknownKinds)
                     (_tlOknownKinds_collect)
                     (_tlOknownTypes)
                     (_tlOknownTypes_collect)
                     (_tlOknownValues)
                     (_tlOknownValues_collect)
                     (_tlOlabels_collect)
                     (_tlOlabels_dist)
                     (_tlOlocal)
                     (_tlOmethods_collect)
                     (_tlOmethods_dist)
                     (_tlOmoduleTypes)
                     (_tlOmoduleValues)
                     (_tlOnameType)
                     (_tlOtoplevel))
            -- use rule
            (_lhsOmodules@_) =
                _hdImodules `Set.union` _tlImodules
            -- use rule
            (_lhsOres@_) =
                _hdIres ++ _tlIres
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOknownKinds_collect@_) =
                _tlIknownKinds_collect
            -- copy rule (up)
            (_lhsOknownTypes_collect@_) =
                _tlIknownTypes_collect
            -- copy rule (up)
            (_lhsOknownValues_collect@_) =
                _tlIknownValues_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOmoduleTypes@_) =
                _tlImoduleTypes
            -- copy rule (up)
            (_lhsOmoduleValues@_) =
                _tlImoduleValues
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_hdOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (down)
            (_hdOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (down)
            (_hdOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (down)
            (_hdOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (down)
            (_hdOknownValues@_) =
                _lhsIknownValues
            -- copy rule (down)
            (_hdOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (down)
            (_hdOmoduleValues@_) =
                _lhsImoduleValues
            -- copy rule (down)
            (_hdOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_tlOknownGenerics@_) =
                _lhsIknownGenerics
            -- copy rule (down)
            (_tlOknownKinds@_) =
                _lhsIknownKinds
            -- copy rule (chain)
            (_tlOknownKinds_collect@_) =
                _hdIknownKinds_collect
            -- copy rule (down)
            (_tlOknownTypes@_) =
                _lhsIknownTypes
            -- copy rule (chain)
            (_tlOknownTypes_collect@_) =
                _hdIknownTypes_collect
            -- copy rule (down)
            (_tlOknownValues@_) =
                _lhsIknownValues
            -- copy rule (chain)
            (_tlOknownValues_collect@_) =
                _hdIknownValues_collect
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_tlOmoduleTypes@_) =
                _hdImoduleTypes
            -- copy rule (chain)
            (_tlOmoduleValues@_) =
                _hdImoduleValues
            -- copy rule (down)
            (_tlOnameType@_) =
                _lhsInameType
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)
sem_Types_Nil :: (T_Types)
sem_Types_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIknownGenerics
      _lhsIknownKinds
      _lhsIknownKinds_collect
      _lhsIknownTypes
      _lhsIknownTypes_collect
      _lhsIknownValues
      _lhsIknownValues_collect
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsImoduleTypes
      _lhsImoduleValues
      _lhsInameType
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOknownKinds_collect :: (FMap Name [Name])
            _lhsOknownTypes_collect :: (FMap Name [Name])
            _lhsOknownValues_collect :: (FMap Name [Name])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOmoduleTypes :: (FMap ModuleName [Name])
            _lhsOmoduleValues :: (FMap ModuleName [Name])
            _lhsOmodules :: (Set.Set Strings)
            _lhsOres :: ([ResolveResult])
            _lhsOself :: (Types)
            -- use rule
            (_lhsOmodules@_) =
                Set.emptySet
            -- use rule
            (_lhsOres@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOknownKinds_collect@_) =
                _lhsIknownKinds_collect
            -- copy rule (chain)
            (_lhsOknownTypes_collect@_) =
                _lhsIknownTypes_collect
            -- copy rule (chain)
            (_lhsOknownValues_collect@_) =
                _lhsIknownValues_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOmoduleTypes@_) =
                _lhsImoduleTypes
            -- copy rule (chain)
            (_lhsOmoduleValues@_) =
                _lhsImoduleValues
        in  ( _lhsOconstructors_collect,_lhsOknownKinds_collect,_lhsOknownTypes_collect,_lhsOknownValues_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOmoduleTypes,_lhsOmoduleValues,_lhsOmodules,_lhsOres,_lhsOself)


