-- do not edit; automatically generated by UU.AG
module Pretty where


import AbstractSyntax
import List (intersperse)
import Set
import Name
import Utils
import Char
import ErrorUtils
import FMap
import KindUtils
import TypeConstruction



import PPrint hiding (empty)
import qualified PPrint
import PPUtils hiding (empty)
import KindUtils (splitKind)
import Maybe (isJust)



{- interface -}

stdPPMode :: PPMode
stdPPMode =  PPMode 
               { interface = False
               , unqualified = False
               , prefixed = False
               , infixpos = False 
               , nosymbol = False 
               }

ppModule :: Module -> Doc
ppModule m = let (_,r) = sem_Module m stdPPMode in r

instance Show Module where
  show = unPretty . ppModule

ppName :: Name -> Doc
ppName n = let (_,_,_,_,r) = sem_Name n stdPPMode in r

{-
instance Show Name where
  show = unPretty . ppName
-}

ppEntity :: Name -> Doc
ppEntity e = let (_,_,_,_,r) = sem_Name e (stdPPMode { interface = True }) in r

ppQEntity :: Name -> Doc
ppQEntity e = let (_,_,_,_,r) = sem_Name e (stdPPMode { interface = True, nosymbol = True }) in r

ppKind :: Kind -> Doc
ppKind k = let (_,_,r) = sem_Kind k stdPPMode in r

instance Show Kind where
  show = unPretty . ppKind

ppType :: Type -> Doc
ppType t = let (_,r) = sem_Type t stdPPMode in r

ppLambdaType :: LambdaType -> Doc
ppLambdaType (vs,t) = text "/\\" <> hsep (map ppName vs) <> text "." <+> ppType t

instance Show Type where
  show = unPretty . ppType

ppExpression :: Expression -> Doc
ppExpression e = let (_,r) = sem_Expression e stdPPMode in r

{-
(conflicts with OptimizerUtils; should be resolved there)

instance Show Expression where
  show = unPretty . ppExpression

-}

ppMaybeModuleName :: Bool -> MaybeModuleName -> Maybe Doc
ppMaybeModuleName i x = let (_,r) = sem_MaybeModuleName x (stdPPMode { interface = i }) in r

ppModuleName :: Bool -> ModuleName -> Doc
ppModuleName i x = let (_,r) = sem_ModuleName x (stdPPMode { interface = i }) in r

ppMaybeExports :: Bool -> MaybeExports -> Maybe [Doc]
ppMaybeExports i x = let (_,r) = sem_MaybeExports x (stdPPMode { interface = i }) in r

ppImportDeclaration :: Bool -> ImportDeclaration -> Doc
ppImportDeclaration i x = let (_,r) = sem_ImportDeclaration x (stdPPMode { interface = i }) in r

ppDeclarations :: Bool -> Declarations -> [Doc]
ppDeclarations i x = let (_,r) = sem_Declarations x Nothing (stdPPMode { interface = i }) in r

ppDeclarationsWithKind :: Bool -> Declarations -> Kind -> Bool -> [Doc]
ppDeclarationsWithKind i x _ False = ppDeclarations i x
ppDeclarationsWithKind i x k True = let (_,r) = sem_Declarations x (Just k) (stdPPMode { interface = i }) in r

ppDeclaration :: Bool -> Declaration -> Doc
ppDeclaration i x = let (_,r) = sem_Declaration x Nothing (stdPPMode {interface = i }) in vcat r

ppDeclarationWithKind :: Bool -> Declaration -> Kind -> Bool -> Doc
ppDeclarationWithKind i x _ False = ppDeclaration i x
ppDeclarationWithKind i x k True = let (_,r) = sem_Declaration x (Just k) (stdPPMode { interface = i}) in vcat r

ppInterfaceDeclaration :: Bool -> InterfaceDeclaration -> Doc
ppInterfaceDeclaration i x = let (_,r) = sem_InterfaceDeclaration x (stdPPMode {interface = i }) in r

ppComment :: String -> Doc
ppComment t = vcat $ map (\l -> text ("-- " ++ l)) (lines t)

instance Show Declaration where
  show = unPretty . ppDeclaration False

{- should not be in this module -}

{-
instance Show a => Show (Set a) where
  show xs = "{" ++ concat (intersperse "," (map show (setToList xs))) ++ "}"
-}


{- Show a substitution -}

prettyFM                       :: (a -> Doc) -> (b -> Doc) -> FMap a b -> Doc
prettyFM pa pb f               = vcat
                               $ map (\ (a,b) -> fill 30 (pa a) <+> text "|->" <+> nest 35 (pb b))
                               $ toList f


{- Show a kind substitution (nicely). -}

ppKSubst                        :: Strings -> KSubst -> Doc
ppKSubst m                      =  prettyFM ppEntity ppKind 
				     . fromList 
				     . filter (\ (n,k) -> getModule n == m)
				     . toList



data PPMode = PPMode { interface :: Bool
                         -- in interface files, always print entity names
                     , unqualified :: Bool 
                         -- in some positions, force names to be unqualified
                     , prefixed :: Bool
                         -- sometimes, add the module prefix "GHM_"
                     , infixpos :: Bool
                         -- operators have to be written differently in prefix/infix positions
                     , nosymbol :: Bool
                         -- at some positions, symbols have to be "quoted"
                     }



unPretty :: Doc -> String
unPretty d = displayS (renderPretty 1.0 (maxBound `div` 2) d) ""

{- strangely, did not work correctly with maxBound -}



emptyPP = PPrint.empty

opt = maybe emptyPP (\ x -> emptyPP <+> x)

parensIf     p  n  = if p then parens n else n
parensIfList ps ns = map (uncurry parensIf) (zip ps ns)

backquotesIf     p  n  = if p then backquotes n else n
backquotesIfList ps ns = map (uncurry backquotesIf) (zip ps ns)
backquotes x = backquote <> x <> backquote
backquote = text "`"

tupled1 []  = emptyPP
tupled1 xs  = tupled xs

tupled2 []  = emptyPP
tupled2 xs  = tupledUnit xs

tupledUnit [x] = x
tupledUnit xs  = tupled xs

moduleText :: Bool {- add module prefix? -} -> [Doc] -> Doc
moduleText pre ds =  (if pre then (\d -> text modulePrefix <> d)
                             else id)
                  $  hcat (punctuate (text ".") ds)

contextText :: [Doc] -> Doc
contextText citems = case citems of
                       []  -> emptyPP
                       [x] -> x <+> text "=>" <+> emptyPP
                       xs  -> uuTuple xs <+> text "=>" <+> emptyPP

derivingsText :: [Doc] -> Doc
derivingsText []  = emptyPP
derivingsText [d] = text "deriving" <+> d
derivingsText ds  = text "deriving" <+> uuTuple ds

whereText :: Maybe [Doc] -> Doc
whereText Nothing   = emptyPP
whereText (Just []) = emptyPP <+> text "where"
whereText (Just ws) = emptyPP <+> text "where" <$> vcat ws

uuSep :: Doc -> Doc -> Doc -> [Doc] -> Doc
uuSep left right sep ds
   = case ds of
        []  -> left <> right
        [d] -> left <> d <> right
        _   -> align (cat (zipWith (<>) (left : repeat sep) ds ++ [right]))

uuList,uuTuple,uuRecord,uuDecls:: [Doc] -> Doc
uuList   = uuSep lsquare rsquare comma
uuTuple  = uuSep lparen  rparen  comma
uuRecord = uuSep lbrace  rbrace  comma

uuDecls ds
   = case ds of
        []  -> lbrace <> rbrace
        [d] -> lbrace <+> d <+> rbrace
        _   -> align (cat (zipWith (<>) ((lbrace <> space) : repeat (semi <> space)) ds) <$> rbrace)



ppModuleHeader                   :: Maybe Doc -> Maybe [Doc] -> Doc
ppModuleHeader x e               =  maybe
				      emptyPP
                                      (\ n -> maybe (text "module" <+> n <+> text "where" <$> emptyPP)
                                                    (\ exports
					             -> (group . hang 4 $
							   text "module" <+> n
					                     <$> uuTuple exports <+> text "where"
							) <$> emptyPP 
						    )
                                                    e
				      )
				      x



ppAnnotatedVars :: (Doc -> Doc) {- parens? -} -> Maybe Kind -> [Doc] -> [Doc]
ppAnnotatedVars _ Nothing   vs  =  vs
ppAnnotatedVars p (Just k)  vs  =  let  ks = splitKind k
                                   in   zipWith (\k v -> p (v <+> text "::" <+> ppKind k)) ks vs

-- Alternative -------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for Alternative.Alternative:
      text
      self

-}
{-
   local variables for Alternative.Empty:
      text
      self

-}
-- semantic domain
type T_Alternative = (PPMode) ->
                     ( (Alternative),(Doc))
-- cata
sem_Alternative :: (Alternative) ->
                   (T_Alternative)
sem_Alternative ((Alternative_Alternative (_range) (_pattern) (_righthandside))) =
    (sem_Alternative_Alternative ((sem_Range (_range))) ((sem_Pattern (_pattern))) ((sem_RightHandSide (_righthandside))))
sem_Alternative ((Alternative_Empty (_range))) =
    (sem_Alternative_Empty ((sem_Range (_range))))
sem_Alternative_Alternative :: (T_Range) ->
                               (T_Pattern) ->
                               (T_RightHandSide) ->
                               (T_Alternative)
sem_Alternative_Alternative (range_) (pattern_) (righthandside_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Alternative)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _patternIself :: (Pattern)
            _patternItext :: (Doc)
            _patternOppMode :: (PPMode)
            _righthandsideIself :: (RightHandSide)
            _righthandsideItext :: ( Doc -> Doc  )
            _righthandsideOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _patternIself,_patternItext) =
                (pattern_ (_patternOppMode))
            ( _righthandsideIself,_righthandsideItext) =
                (righthandside_ (_righthandsideOppMode))
            -- "./Pretty.inc.ag"(line 919, column 9)
            (_text@_) =
                hang 2 $ _patternItext </> _righthandsideItext (text "->")
            -- self rule
            (_self@_) =
                Alternative_Alternative _rangeIself _patternIself _righthandsideIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_patternOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_righthandsideOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Alternative_Empty :: (T_Range) ->
                         (T_Alternative)
sem_Alternative_Empty (range_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Alternative)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            -- "./Pretty.inc.ag"(line 921, column 9)
            (_text@_) =
                emptyPP
            -- self rule
            (_self@_) =
                Alternative_Empty _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
-- Alternatives ------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : [Doc]

-}
{-
   local variables for Alternatives.Cons:
      self

-}
{-
   local variables for Alternatives.Nil:
      self

-}
-- semantic domain
type T_Alternatives = (PPMode) ->
                      ( (Alternatives),([Doc]))
-- cata
sem_Alternatives :: (Alternatives) ->
                    (T_Alternatives)
sem_Alternatives (list) =
    (foldr (sem_Alternatives_Cons) (sem_Alternatives_Nil) ((map sem_Alternative list)))
sem_Alternatives_Cons :: (T_Alternative) ->
                         (T_Alternatives) ->
                         (T_Alternatives)
sem_Alternatives_Cons (hd_) (tl_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Alternatives)
            _lhsOtext :: ([Doc])
            _hdIself :: (Alternative)
            _hdItext :: (Doc)
            _hdOppMode :: (PPMode)
            _tlIself :: (Alternatives)
            _tlItext :: ([Doc])
            _tlOppMode :: (PPMode)
            ( _hdIself,_hdItext) =
                (hd_ (_hdOppMode))
            ( _tlIself,_tlItext) =
                (tl_ (_tlOppMode))
            -- use rule
            (_lhsOtext@_) =
                _hdItext : _tlItext
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_hdOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_tlOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Alternatives_Nil :: (T_Alternatives)
sem_Alternatives_Nil  =
    \ _lhsIppMode ->
        let _lhsOself :: (Alternatives)
            _lhsOtext :: ([Doc])
            -- use rule
            (_lhsOtext@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOself,_lhsOtext)
-- AnnotatedType -----------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for AnnotatedType.AnnotatedType:
      text
      self

-}
-- semantic domain
type T_AnnotatedType = (PPMode) ->
                       ( (AnnotatedType),(Doc))
-- cata
sem_AnnotatedType :: (AnnotatedType) ->
                     (T_AnnotatedType)
sem_AnnotatedType ((AnnotatedType_AnnotatedType (_range) (_strict) (_type))) =
    (sem_AnnotatedType_AnnotatedType ((sem_Range (_range))) (_strict) ((sem_Type (_type))))
sem_AnnotatedType_AnnotatedType :: (T_Range) ->
                                   (Bool) ->
                                   (T_Type) ->
                                   (T_AnnotatedType)
sem_AnnotatedType_AnnotatedType (range_) (strict_) (type_) =
    \ _lhsIppMode ->
        let _lhsOself :: (AnnotatedType)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _typeIself :: (Type)
            _typeItext :: (Doc)
            _typeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _typeIself,_typeItext) =
                (type_ (_typeOppMode))
            -- "./Pretty.inc.ag"(line 791, column 9)
            (_text@_) =
                (if strict_ then (text "!" <>) else id) _typeItext
            -- self rule
            (_self@_) =
                AnnotatedType_AnnotatedType _rangeIself strict_ _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_typeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
-- AnnotatedTypes ----------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : [Doc]

-}
{-
   local variables for AnnotatedTypes.Cons:
      self

-}
{-
   local variables for AnnotatedTypes.Nil:
      self

-}
-- semantic domain
type T_AnnotatedTypes = (PPMode) ->
                        ( (AnnotatedTypes),([Doc]))
-- cata
sem_AnnotatedTypes :: (AnnotatedTypes) ->
                      (T_AnnotatedTypes)
sem_AnnotatedTypes (list) =
    (foldr (sem_AnnotatedTypes_Cons) (sem_AnnotatedTypes_Nil) ((map sem_AnnotatedType list)))
sem_AnnotatedTypes_Cons :: (T_AnnotatedType) ->
                           (T_AnnotatedTypes) ->
                           (T_AnnotatedTypes)
sem_AnnotatedTypes_Cons (hd_) (tl_) =
    \ _lhsIppMode ->
        let _lhsOself :: (AnnotatedTypes)
            _lhsOtext :: ([Doc])
            _hdIself :: (AnnotatedType)
            _hdItext :: (Doc)
            _hdOppMode :: (PPMode)
            _tlIself :: (AnnotatedTypes)
            _tlItext :: ([Doc])
            _tlOppMode :: (PPMode)
            ( _hdIself,_hdItext) =
                (hd_ (_hdOppMode))
            ( _tlIself,_tlItext) =
                (tl_ (_tlOppMode))
            -- use rule
            (_lhsOtext@_) =
                _hdItext : _tlItext
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_hdOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_tlOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_AnnotatedTypes_Nil :: (T_AnnotatedTypes)
sem_AnnotatedTypes_Nil  =
    \ _lhsIppMode ->
        let _lhsOself :: (AnnotatedTypes)
            _lhsOtext :: ([Doc])
            -- use rule
            (_lhsOtext@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOself,_lhsOtext)
-- Body --------------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for Body.Body:
      text
      self

-}
-- semantic domain
type T_Body = (PPMode) ->
              ( (Body),(Doc))
-- cata
sem_Body :: (Body) ->
            (T_Body)
sem_Body ((Body_Body (_range) (_importdeclarations) (_declarations))) =
    (sem_Body_Body ((sem_Range (_range))) ((sem_ImportDeclarations (_importdeclarations))) ((sem_Declarations (_declarations))))
sem_Body_Body :: (T_Range) ->
                 (T_ImportDeclarations) ->
                 (T_Declarations) ->
                 (T_Body)
sem_Body_Body (range_) (importdeclarations_) (declarations_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Body)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _importdeclarationsIself :: (ImportDeclarations)
            _importdeclarationsItext :: ([Doc])
            _importdeclarationsOppMode :: (PPMode)
            _declarationsIself :: (Declarations)
            _declarationsItext :: ([Doc])
            _declarationsOkind :: (Maybe Kind)
            _declarationsOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _importdeclarationsIself,_importdeclarationsItext) =
                (importdeclarations_ (_importdeclarationsOppMode))
            ( _declarationsIself,_declarationsItext) =
                (declarations_ (_declarationsOkind) (_declarationsOppMode))
            -- "./Pretty.inc.ag"(line 364, column 9)
            (_declarationsOkind@_) =
                Nothing
            -- "./Pretty.inc.ag"(line 361, column 9)
            (_text@_) =
                vcat (  _importdeclarationsItext
                     ++ intersperse emptyPP _declarationsItext
                     )
            -- self rule
            (_self@_) =
                Body_Body _rangeIself _importdeclarationsIself _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_importdeclarationsOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_declarationsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
-- Constructor -------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for Constructor.Constructor:
      text
      self

-}
{-
   local variables for Constructor.Infix:
      text
      self

-}
{-
   local variables for Constructor.Record:
      text
      self

-}
-- semantic domain
type T_Constructor = (PPMode) ->
                     ( (Constructor),(Doc))
-- cata
sem_Constructor :: (Constructor) ->
                   (T_Constructor)
sem_Constructor ((Constructor_Constructor (_range) (_constructor) (_types))) =
    (sem_Constructor_Constructor ((sem_Range (_range))) ((sem_Name (_constructor))) ((sem_AnnotatedTypes (_types))))
sem_Constructor ((Constructor_Infix (_range) (_leftType) (_constructorOperator) (_rightType))) =
    (sem_Constructor_Infix ((sem_Range (_range))) ((sem_AnnotatedType (_leftType))) ((sem_Name (_constructorOperator))) ((sem_AnnotatedType (_rightType))))
sem_Constructor ((Constructor_Record (_range) (_constructor) (_fieldDeclarations))) =
    (sem_Constructor_Record ((sem_Range (_range))) ((sem_Name (_constructor))) ((sem_FieldDeclarations (_fieldDeclarations))))
sem_Constructor_Constructor :: (T_Range) ->
                               (T_Name) ->
                               (T_AnnotatedTypes) ->
                               (T_Constructor)
sem_Constructor_Constructor (range_) (constructor_) (types_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Constructor)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _constructorIisIdentifier :: (Bool)
            _constructorIisOperator :: (Bool)
            _constructorIisSpecial :: (Bool)
            _constructorIself :: (Name)
            _constructorItext :: (Doc)
            _constructorOppMode :: (PPMode)
            _typesIself :: (AnnotatedTypes)
            _typesItext :: ([Doc])
            _typesOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _constructorIisIdentifier,_constructorIisOperator,_constructorIisSpecial,_constructorIself,_constructorItext) =
                (constructor_ (_constructorOppMode))
            ( _typesIself,_typesItext) =
                (types_ (_typesOppMode))
            -- "./Pretty.inc.ag"(line 759, column 9)
            (_constructorOppMode@_) =
                _lhsIppMode
                  { unqualified = True
                  , infixpos    = False
                  , nosymbol    = True
                  }
            -- "./Pretty.inc.ag"(line 758, column 9)
            (_text@_) =
                _constructorItext <+> align (sep _typesItext)
            -- self rule
            (_self@_) =
                Constructor_Constructor _rangeIself _constructorIself _typesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_typesOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Constructor_Infix :: (T_Range) ->
                         (T_AnnotatedType) ->
                         (T_Name) ->
                         (T_AnnotatedType) ->
                         (T_Constructor)
sem_Constructor_Infix (range_) (leftType_) (constructorOperator_) (rightType_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Constructor)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _leftTypeIself :: (AnnotatedType)
            _leftTypeItext :: (Doc)
            _leftTypeOppMode :: (PPMode)
            _constructorOperatorIisIdentifier :: (Bool)
            _constructorOperatorIisOperator :: (Bool)
            _constructorOperatorIisSpecial :: (Bool)
            _constructorOperatorIself :: (Name)
            _constructorOperatorItext :: (Doc)
            _constructorOperatorOppMode :: (PPMode)
            _rightTypeIself :: (AnnotatedType)
            _rightTypeItext :: (Doc)
            _rightTypeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _leftTypeIself,_leftTypeItext) =
                (leftType_ (_leftTypeOppMode))
            ( _constructorOperatorIisIdentifier,_constructorOperatorIisOperator,_constructorOperatorIisSpecial,_constructorOperatorIself,_constructorOperatorItext) =
                (constructorOperator_ (_constructorOperatorOppMode))
            ( _rightTypeIself,_rightTypeItext) =
                (rightType_ (_rightTypeOppMode))
            -- "./Pretty.inc.ag"(line 768, column 9)
            (_constructorOperatorOppMode@_) =
                _lhsIppMode
                  { unqualified = True
                  , infixpos    = True
                  }
            -- "./Pretty.inc.ag"(line 766, column 9)
            (_text@_) =
                group . hang 2 $
                  _leftTypeItext <$> _constructorOperatorItext <+> _rightTypeItext
            -- self rule
            (_self@_) =
                Constructor_Infix _rangeIself _leftTypeIself _constructorOperatorIself _rightTypeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_leftTypeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_rightTypeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Constructor_Record :: (T_Range) ->
                          (T_Name) ->
                          (T_FieldDeclarations) ->
                          (T_Constructor)
sem_Constructor_Record (range_) (constructor_) (fieldDeclarations_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Constructor)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _constructorIisIdentifier :: (Bool)
            _constructorIisOperator :: (Bool)
            _constructorIisSpecial :: (Bool)
            _constructorIself :: (Name)
            _constructorItext :: (Doc)
            _constructorOppMode :: (PPMode)
            _fieldDeclarationsIself :: (FieldDeclarations)
            _fieldDeclarationsItext :: ([Doc])
            _fieldDeclarationsOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _constructorIisIdentifier,_constructorIisOperator,_constructorIisSpecial,_constructorIself,_constructorItext) =
                (constructor_ (_constructorOppMode))
            ( _fieldDeclarationsIself,_fieldDeclarationsItext) =
                (fieldDeclarations_ (_fieldDeclarationsOppMode))
            -- "./Pretty.inc.ag"(line 777, column 9)
            (_constructorOppMode@_) =
                _lhsIppMode
                  { unqualified = True
                  , infixpos    = False
                  , nosymbol    = True
                  }
            -- "./Pretty.inc.ag"(line 775, column 9)
            (_text@_) =
                hang 2 $
                  _constructorItext </> uuRecord _fieldDeclarationsItext
            -- self rule
            (_self@_) =
                Constructor_Record _rangeIself _constructorIself _fieldDeclarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_fieldDeclarationsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
-- Constructors ------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : [Doc]

-}
{-
   local variables for Constructors.Cons:
      self

-}
{-
   local variables for Constructors.Nil:
      self

-}
-- semantic domain
type T_Constructors = (PPMode) ->
                      ( (Constructors),([Doc]))
-- cata
sem_Constructors :: (Constructors) ->
                    (T_Constructors)
sem_Constructors (list) =
    (foldr (sem_Constructors_Cons) (sem_Constructors_Nil) ((map sem_Constructor list)))
sem_Constructors_Cons :: (T_Constructor) ->
                         (T_Constructors) ->
                         (T_Constructors)
sem_Constructors_Cons (hd_) (tl_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Constructors)
            _lhsOtext :: ([Doc])
            _hdIself :: (Constructor)
            _hdItext :: (Doc)
            _hdOppMode :: (PPMode)
            _tlIself :: (Constructors)
            _tlItext :: ([Doc])
            _tlOppMode :: (PPMode)
            ( _hdIself,_hdItext) =
                (hd_ (_hdOppMode))
            ( _tlIself,_tlItext) =
                (tl_ (_tlOppMode))
            -- use rule
            (_lhsOtext@_) =
                _hdItext : _tlItext
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_hdOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_tlOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Constructors_Nil :: (T_Constructors)
sem_Constructors_Nil  =
    \ _lhsIppMode ->
        let _lhsOself :: (Constructors)
            _lhsOtext :: ([Doc])
            -- use rule
            (_lhsOtext@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOself,_lhsOtext)
-- ContextItem -------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for ContextItem.ContextItem:
      text
      self

-}
{-
   local variables for ContextItem.DependencyConstraint:
      text
      self

-}
{-
   local variables for ContextItem.DependencyItem:
      asDoc
      text
      self

-}
-- semantic domain
type T_ContextItem = (PPMode) ->
                     ( (ContextItem),(Doc))
-- cata
sem_ContextItem :: (ContextItem) ->
                   (T_ContextItem)
sem_ContextItem ((ContextItem_ContextItem (_range) (_name) (_types))) =
    (sem_ContextItem_ContextItem ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Types (_types))))
sem_ContextItem ((ContextItem_DependencyConstraint (_range) (_name) (_typevariable) (_type))) =
    (sem_ContextItem_DependencyConstraint ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Name (_typevariable))) ((sem_Type (_type))))
sem_ContextItem ((ContextItem_DependencyItem (_range) (_name) (_generics) (_parametrics) (_asname))) =
    (sem_ContextItem_DependencyItem ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Names (_generics))) ((sem_Types (_parametrics))) ((sem_MaybeName (_asname))))
sem_ContextItem_ContextItem :: (T_Range) ->
                               (T_Name) ->
                               (T_Types) ->
                               (T_ContextItem)
sem_ContextItem_ContextItem (range_) (name_) (types_) =
    \ _lhsIppMode ->
        let _lhsOself :: (ContextItem)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _typesIself :: (Types)
            _typesItext :: ([Doc])
            _typesOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _typesIself,_typesItext) =
                (types_ (_typesOppMode))
            -- "./Pretty.inc.ag"(line 740, column 9)
            (_text@_) =
                _nameItext <+> align (sep _typesItext)
            -- self rule
            (_self@_) =
                ContextItem_ContextItem _rangeIself _nameIself _typesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_typesOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_ContextItem_DependencyConstraint :: (T_Range) ->
                                        (T_Name) ->
                                        (T_Name) ->
                                        (T_Type) ->
                                        (T_ContextItem)
sem_ContextItem_DependencyConstraint (range_) (name_) (typevariable_) (type_) =
    \ _lhsIppMode ->
        let _lhsOself :: (ContextItem)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _typevariableIisIdentifier :: (Bool)
            _typevariableIisOperator :: (Bool)
            _typevariableIisSpecial :: (Bool)
            _typevariableIself :: (Name)
            _typevariableItext :: (Doc)
            _typevariableOppMode :: (PPMode)
            _typeIself :: (Type)
            _typeItext :: (Doc)
            _typeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _typevariableIisIdentifier,_typevariableIisOperator,_typevariableIisSpecial,_typevariableIself,_typevariableItext) =
                (typevariable_ (_typevariableOppMode))
            ( _typeIself,_typeItext) =
                (type_ (_typeOppMode))
            -- "./Pretty.inc.ag"(line 742, column 9)
            (_text@_) =
                _nameItext <+>
                  text "{|" <+> _typevariableItext <+> text "|}" <+>
                  _typeItext
            -- self rule
            (_self@_) =
                ContextItem_DependencyConstraint _rangeIself _nameIself _typevariableIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_typevariableOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_typeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_ContextItem_DependencyItem :: (T_Range) ->
                                  (T_Name) ->
                                  (T_Names) ->
                                  (T_Types) ->
                                  (T_MaybeName) ->
                                  (T_ContextItem)
sem_ContextItem_DependencyItem (range_) (name_) (generics_) (parametrics_) (asname_) =
    \ _lhsIppMode ->
        let _lhsOself :: (ContextItem)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _genericsIisIdentifier :: ([Bool])
            _genericsIisOperator :: ([Bool])
            _genericsIisSpecial :: ([Bool])
            _genericsIself :: (Names)
            _genericsItext :: ([Doc])
            _genericsOppMode :: (PPMode)
            _parametricsIself :: (Types)
            _parametricsItext :: ([Doc])
            _parametricsOppMode :: (PPMode)
            _asnameIself :: (MaybeName)
            _asnameItext :: ( Maybe Doc )
            _asnameOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _genericsIisIdentifier,_genericsIisOperator,_genericsIisSpecial,_genericsIself,_genericsItext) =
                (generics_ (_genericsOppMode))
            ( _parametricsIself,_parametricsItext) =
                (parametrics_ (_parametricsOppMode))
            ( _asnameIself,_asnameItext) =
                (asname_ (_asnameOppMode))
            -- "./Pretty.inc.ag"(line 754, column 9)
            (_asnameOppMode@_) =
                _lhsIppMode { unqualified = True, infixpos = False }
            -- "./Pretty.inc.ag"(line 753, column 9)
            (_asDoc@_) =
                maybe emptyPP (\ x -> emptyPP <+> text "as" <+> x) _asnameItext
            -- "./Pretty.inc.ag"(line 746, column 9)
            (_text@_) =
                _nameItext <+>
                  text "{|" <+> commas _genericsItext
                            <+> text "|"
                            <+> commas _parametricsItext
                            <+> text "|}"
                  <> _asDoc
            -- self rule
            (_self@_) =
                ContextItem_DependencyItem _rangeIself _nameIself _genericsIself _parametricsIself _asnameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_genericsOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_parametricsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
-- ContextItems ------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : [Doc]

-}
{-
   local variables for ContextItems.Cons:
      self

-}
{-
   local variables for ContextItems.Nil:
      self

-}
-- semantic domain
type T_ContextItems = (PPMode) ->
                      ( (ContextItems),([Doc]))
-- cata
sem_ContextItems :: (ContextItems) ->
                    (T_ContextItems)
sem_ContextItems (list) =
    (foldr (sem_ContextItems_Cons) (sem_ContextItems_Nil) ((map sem_ContextItem list)))
sem_ContextItems_Cons :: (T_ContextItem) ->
                         (T_ContextItems) ->
                         (T_ContextItems)
sem_ContextItems_Cons (hd_) (tl_) =
    \ _lhsIppMode ->
        let _lhsOself :: (ContextItems)
            _lhsOtext :: ([Doc])
            _hdIself :: (ContextItem)
            _hdItext :: (Doc)
            _hdOppMode :: (PPMode)
            _tlIself :: (ContextItems)
            _tlItext :: ([Doc])
            _tlOppMode :: (PPMode)
            ( _hdIself,_hdItext) =
                (hd_ (_hdOppMode))
            ( _tlIself,_tlItext) =
                (tl_ (_tlOppMode))
            -- use rule
            (_lhsOtext@_) =
                _hdItext : _tlItext
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_hdOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_tlOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_ContextItems_Nil :: (T_ContextItems)
sem_ContextItems_Nil  =
    \ _lhsIppMode ->
        let _lhsOself :: (ContextItems)
            _lhsOtext :: ([Doc])
            -- use rule
            (_lhsOtext@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOself,_lhsOtext)
-- Declaration -------------------------------------------------
{-
   inherited attributes:
      kind                 : Maybe Kind
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : [Doc]

-}
{-
   local variables for Declaration.Class:
      whereDoc
      contextDoc
      text
      self

-}
{-
   local variables for Declaration.Data:
      derivingDoc
      contextDoc
      text
      self

-}
{-
   local variables for Declaration.Default:
      text
      self

-}
{-
   local variables for Declaration.Dependency:
      text
      self

-}
{-
   local variables for Declaration.Empty:
      text
      self

-}
{-
   local variables for Declaration.Fixity:
      ops
      text
      self

-}
{-
   local variables for Declaration.FunctionBindings:
      text
      self

-}
{-
   local variables for Declaration.GenericTypeSignature:
      nameDoc
      text
      typevariable
      kind
      self

-}
{-
   local variables for Declaration.Instance:
      whereDoc
      contextDoc
      text
      self

-}
{-
   local variables for Declaration.KindIndexedType:
      text
      self

-}
{-
   local variables for Declaration.Newtype:
      derivingDoc
      contextDoc
      text
      self

-}
{-
   local variables for Declaration.PatternBinding:
      text
      self

-}
{-
   local variables for Declaration.Type:
      text
      self

-}
{-
   local variables for Declaration.TypeIndexedType:
      derivingDoc
      text
      self

-}
{-
   local variables for Declaration.TypeIndexedValue:
      text
      self

-}
{-
   local variables for Declaration.TypeSignature:
      namesDocs
      text
      self

-}
-- semantic domain
type T_Declaration = (Maybe Kind) ->
                     (PPMode) ->
                     ( (Declaration),([Doc]))
-- cata
sem_Declaration :: (Declaration) ->
                   (T_Declaration)
sem_Declaration ((Declaration_Class (_range) (_context) (_simpletype) (_where))) =
    (sem_Declaration_Class ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_SimpleType (_simpletype))) ((sem_MaybeDeclarations (_where))))
sem_Declaration ((Declaration_Data (_range) (_context) (_simpletype) (_constructors) (_derivings))) =
    (sem_Declaration_Data ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_SimpleType (_simpletype))) ((sem_Constructors (_constructors))) ((sem_Names (_derivings))))
sem_Declaration ((Declaration_Default (_range) (_types))) =
    (sem_Declaration_Default ((sem_Range (_range))) ((sem_Types (_types))))
sem_Declaration ((Declaration_Dependency (_range) (_typelevel) (_name) (_bindings))) =
    (sem_Declaration_Dependency ((sem_Range (_range))) (_typelevel) ((sem_Name (_name))) ((sem_DependencyBindings (_bindings))))
sem_Declaration ((Declaration_Empty (_range))) =
    (sem_Declaration_Empty ((sem_Range (_range))))
sem_Declaration ((Declaration_Fixity (_range) (_fixity) (_priority) (_operators))) =
    (sem_Declaration_Fixity ((sem_Range (_range))) ((sem_Fixity (_fixity))) ((sem_MaybeInt (_priority))) ((sem_Names (_operators))))
sem_Declaration ((Declaration_FunctionBindings (_range) (_bindings))) =
    (sem_Declaration_FunctionBindings ((sem_Range (_range))) ((sem_FunctionBindings (_bindings))))
sem_Declaration ((Declaration_GenericTypeSignature (_range) (_name) (_generics) (_parametrics) (_type))) =
    (sem_Declaration_GenericTypeSignature ((sem_Range (_range))) ((sem_Name (_name))) ((sem_KindAnnotatedNames (_generics))) ((sem_KindAnnotatedNames (_parametrics))) ((sem_Type (_type))))
sem_Declaration ((Declaration_Instance (_range) (_context) (_name) (_types) (_where))) =
    (sem_Declaration_Instance ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_Name (_name))) ((sem_Types (_types))) ((sem_MaybeDeclarations (_where))))
sem_Declaration ((Declaration_KindIndexedType (_range) (_bindings))) =
    (sem_Declaration_KindIndexedType ((sem_Range (_range))) ((sem_KindIndexedBindings (_bindings))))
sem_Declaration ((Declaration_Newtype (_range) (_context) (_simpletype) (_constructor) (_derivings))) =
    (sem_Declaration_Newtype ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_SimpleType (_simpletype))) ((sem_Constructor (_constructor))) ((sem_Names (_derivings))))
sem_Declaration ((Declaration_PatternBinding (_range) (_pattern) (_righthandside))) =
    (sem_Declaration_PatternBinding ((sem_Range (_range))) ((sem_Pattern (_pattern))) ((sem_RightHandSide (_righthandside))))
sem_Declaration ((Declaration_Type (_range) (_simpletype) (_type))) =
    (sem_Declaration_Type ((sem_Range (_range))) ((sem_SimpleType (_simpletype))) ((sem_Type (_type))))
sem_Declaration ((Declaration_TypeIndexedType (_range) (_name) (_typeargument) (_typevariables) (_constructor) (_derivings))) =
    (sem_Declaration_TypeIndexedType ((sem_Range (_range))) ((sem_Name (_name))) ((sem_TypeArgument (_typeargument))) ((sem_Names (_typevariables))) ((sem_Constructor (_constructor))) ((sem_Names (_derivings))))
sem_Declaration ((Declaration_TypeIndexedValue (_range) (_bindings))) =
    (sem_Declaration_TypeIndexedValue ((sem_Range (_range))) ((sem_TypeIndexedBindings (_bindings))))
sem_Declaration ((Declaration_TypeSignature (_range) (_names) (_type))) =
    (sem_Declaration_TypeSignature ((sem_Range (_range))) ((sem_Names (_names))) ((sem_Type (_type))))
sem_Declaration_Class :: (T_Range) ->
                         (T_ContextItems) ->
                         (T_SimpleType) ->
                         (T_MaybeDeclarations) ->
                         (T_Declaration)
sem_Declaration_Class (range_) (context_) (simpletype_) (where_) =
    \ _lhsIkind
      _lhsIppMode ->
        let _lhsOself :: (Declaration)
            _lhsOtext :: ([Doc])
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _contextIself :: (ContextItems)
            _contextItext :: ([Doc])
            _contextOppMode :: (PPMode)
            _simpletypeIself :: (SimpleType)
            _simpletypeItext :: (Doc)
            _simpletypeOkind :: (Maybe Kind)
            _simpletypeOppMode :: (PPMode)
            _whereIself :: (MaybeDeclarations)
            _whereItext :: ( Maybe [Doc] )
            _whereOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _contextIself,_contextItext) =
                (context_ (_contextOppMode))
            ( _simpletypeIself,_simpletypeItext) =
                (simpletype_ (_simpletypeOkind) (_simpletypeOppMode))
            ( _whereIself,_whereItext) =
                (where_ (_whereOppMode))
            -- "./Pretty.inc.ag"(line 456, column 9)
            (_whereDoc@_) =
                whereText _whereItext
            -- "./Pretty.inc.ag"(line 455, column 9)
            (_contextDoc@_) =
                contextText _contextItext
            -- "./Pretty.inc.ag"(line 453, column 9)
            (_lhsOtext@_) =
                [_text]
            -- "./Pretty.inc.ag"(line 451, column 9)
            (_text@_) =
                hang 4 $
                  text "class" <+> _contextDoc <> _simpletypeItext <> _whereDoc
            -- self rule
            (_self@_) =
                Declaration_Class _rangeIself _contextIself _simpletypeIself _whereIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_contextOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_simpletypeOkind@_) =
                _lhsIkind
            -- copy rule (down)
            (_simpletypeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_whereOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Declaration_Data :: (T_Range) ->
                        (T_ContextItems) ->
                        (T_SimpleType) ->
                        (T_Constructors) ->
                        (T_Names) ->
                        (T_Declaration)
sem_Declaration_Data (range_) (context_) (simpletype_) (constructors_) (derivings_) =
    \ _lhsIkind
      _lhsIppMode ->
        let _lhsOself :: (Declaration)
            _lhsOtext :: ([Doc])
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _contextIself :: (ContextItems)
            _contextItext :: ([Doc])
            _contextOppMode :: (PPMode)
            _simpletypeIself :: (SimpleType)
            _simpletypeItext :: (Doc)
            _simpletypeOkind :: (Maybe Kind)
            _simpletypeOppMode :: (PPMode)
            _constructorsIself :: (Constructors)
            _constructorsItext :: ([Doc])
            _constructorsOppMode :: (PPMode)
            _derivingsIisIdentifier :: ([Bool])
            _derivingsIisOperator :: ([Bool])
            _derivingsIisSpecial :: ([Bool])
            _derivingsIself :: (Names)
            _derivingsItext :: ([Doc])
            _derivingsOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _contextIself,_contextItext) =
                (context_ (_contextOppMode))
            ( _simpletypeIself,_simpletypeItext) =
                (simpletype_ (_simpletypeOkind) (_simpletypeOppMode))
            ( _constructorsIself,_constructorsItext) =
                (constructors_ (_constructorsOppMode))
            ( _derivingsIisIdentifier,_derivingsIisOperator,_derivingsIisSpecial,_derivingsIself,_derivingsItext) =
                (derivings_ (_derivingsOppMode))
            -- "./Pretty.inc.ag"(line 438, column 9)
            (_derivingDoc@_) =
                derivingsText _derivingsItext
            -- "./Pretty.inc.ag"(line 437, column 9)
            (_contextDoc@_) =
                contextText _contextItext
            -- "./Pretty.inc.ag"(line 435, column 9)
            (_lhsOtext@_) =
                [_text]
            -- "./Pretty.inc.ag"(line 430, column 9)
            (_text@_) =
                group . hang 4 $
                  text "data" <+> _contextDoc <> _simpletypeItext
                    <$$> uuSep (space <> text "=" <> space) (emptyPP) (space <> text "|" <> space)
                               _constructorsItext
                    <$> _derivingDoc
            -- self rule
            (_self@_) =
                Declaration_Data _rangeIself _contextIself _simpletypeIself _constructorsIself _derivingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_contextOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_simpletypeOkind@_) =
                _lhsIkind
            -- copy rule (down)
            (_simpletypeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_constructorsOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_derivingsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Declaration_Default :: (T_Range) ->
                           (T_Types) ->
                           (T_Declaration)
sem_Declaration_Default (range_) (types_) =
    \ _lhsIkind
      _lhsIppMode ->
        let _lhsOself :: (Declaration)
            _lhsOtext :: ([Doc])
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _typesIself :: (Types)
            _typesItext :: ([Doc])
            _typesOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _typesIself,_typesItext) =
                (types_ (_typesOppMode))
            -- "./Pretty.inc.ag"(line 469, column 9)
            (_lhsOtext@_) =
                [_text]
            -- "./Pretty.inc.ag"(line 468, column 9)
            (_text@_) =
                text "default" <+> uuTuple _typesItext
            -- self rule
            (_self@_) =
                Declaration_Default _rangeIself _typesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_typesOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Declaration_Dependency :: (T_Range) ->
                              (Bool) ->
                              (T_Name) ->
                              (T_DependencyBindings) ->
                              (T_Declaration)
sem_Declaration_Dependency (range_) (typelevel_) (name_) (bindings_) =
    \ _lhsIkind
      _lhsIppMode ->
        let _lhsOself :: (Declaration)
            _lhsOtext :: ([Doc])
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _bindingsIself :: (DependencyBindings)
            _bindingsItext :: ([Doc])
            _bindingsOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _bindingsIself,_bindingsItext) =
                (bindings_ (_bindingsOppMode))
            -- "./Pretty.inc.ag"(line 513, column 9)
            (_lhsOtext@_) =
                [_text]
            -- "./Pretty.inc.ag"(line 512, column 9)
            (_text@_) =
                text "dependency" <+> _nameItext <+> text "<-" <+> align (sep _bindingsItext)
            -- self rule
            (_self@_) =
                Declaration_Dependency _rangeIself typelevel_ _nameIself _bindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_bindingsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Declaration_Empty :: (T_Range) ->
                         (T_Declaration)
sem_Declaration_Empty (range_) =
    \ _lhsIkind
      _lhsIppMode ->
        let _lhsOself :: (Declaration)
            _lhsOtext :: ([Doc])
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            -- "./Pretty.inc.ag"(line 548, column 9)
            (_lhsOtext@_) =
                [_text]
            -- "./Pretty.inc.ag"(line 547, column 9)
            (_text@_) =
                emptyPP
            -- self rule
            (_self@_) =
                Declaration_Empty _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Declaration_Fixity :: (T_Range) ->
                          (T_Fixity) ->
                          (T_MaybeInt) ->
                          (T_Names) ->
                          (T_Declaration)
sem_Declaration_Fixity (range_) (fixity_) (priority_) (operators_) =
    \ _lhsIkind
      _lhsIppMode ->
        let _lhsOself :: (Declaration)
            _lhsOtext :: ([Doc])
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _fixityIself :: (Fixity)
            _fixityItext :: (Doc)
            _fixityOppMode :: (PPMode)
            _priorityIself :: (MaybeInt)
            _priorityItext :: ( Maybe Doc )
            _priorityOppMode :: (PPMode)
            _operatorsIisIdentifier :: ([Bool])
            _operatorsIisOperator :: ([Bool])
            _operatorsIisSpecial :: ([Bool])
            _operatorsIself :: (Names)
            _operatorsItext :: ([Doc])
            _operatorsOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _fixityIself,_fixityItext) =
                (fixity_ (_fixityOppMode))
            ( _priorityIself,_priorityItext) =
                (priority_ (_priorityOppMode))
            ( _operatorsIisIdentifier,_operatorsIisOperator,_operatorsIisSpecial,_operatorsIself,_operatorsItext) =
                (operators_ (_operatorsOppMode))
            -- "./Pretty.inc.ag"(line 544, column 9)
            (_operatorsOppMode@_) =
                _lhsIppMode { infixpos = True }
            -- "./Pretty.inc.ag"(line 542, column 9)
            (_ops@_) =
                opt _priorityItext
                  <+> commas _operatorsItext
            -- "./Pretty.inc.ag"(line 540, column 9)
            (_lhsOtext@_) =
                [_text]
            -- "./Pretty.inc.ag"(line 539, column 9)
            (_text@_) =
                _fixityItext <> _ops
            -- self rule
            (_self@_) =
                Declaration_Fixity _rangeIself _fixityIself _priorityIself _operatorsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_fixityOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_priorityOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Declaration_FunctionBindings :: (T_Range) ->
                                    (T_FunctionBindings) ->
                                    (T_Declaration)
sem_Declaration_FunctionBindings (range_) (bindings_) =
    \ _lhsIkind
      _lhsIppMode ->
        let _lhsOself :: (Declaration)
            _lhsOtext :: ([Doc])
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _bindingsIself :: (FunctionBindings)
            _bindingsItext :: ([Doc])
            _bindingsOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _bindingsIself,_bindingsItext) =
                (bindings_ (_bindingsOppMode))
            -- "./Pretty.inc.ag"(line 472, column 9)
            (_text@_) =
                _bindingsItext
            -- self rule
            (_self@_) =
                Declaration_FunctionBindings _rangeIself _bindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_bindingsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Declaration_GenericTypeSignature :: (T_Range) ->
                                        (T_Name) ->
                                        (T_KindAnnotatedNames) ->
                                        (T_KindAnnotatedNames) ->
                                        (T_Type) ->
                                        (T_Declaration)
sem_Declaration_GenericTypeSignature (range_) (name_) (generics_) (parametrics_) (type_) =
    \ _lhsIkind
      _lhsIppMode ->
        let _lhsOself :: (Declaration)
            _lhsOtext :: ([Doc])
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _genericsIfull :: ([Doc])
            _genericsIself :: (KindAnnotatedNames)
            _genericsItext :: ([Doc])
            _genericsOppMode :: (PPMode)
            _parametricsIfull :: ([Doc])
            _parametricsIself :: (KindAnnotatedNames)
            _parametricsItext :: ([Doc])
            _parametricsOppMode :: (PPMode)
            _typeIself :: (Type)
            _typeItext :: (Doc)
            _typeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _genericsIfull,_genericsIself,_genericsItext) =
                (generics_ (_genericsOppMode))
            ( _parametricsIfull,_parametricsIself,_parametricsItext) =
                (parametrics_ (_parametricsOppMode))
            ( _typeIself,_typeItext) =
                (type_ (_typeOppMode))
            -- "./Pretty.inc.ag"(line 503, column 9)
            (_nameOppMode@_) =
                _lhsIppMode { unqualified = True, infixpos = False }
            -- "./Pretty.inc.ag"(line 502, column 9)
            (_nameDoc@_) =
                _nameItext
            -- "./Pretty.inc.ag"(line 500, column 9)
            (_lhsOtext@_) =
                [_text]
            -- "./Pretty.inc.ag"(line 486, column 9)
            (_text@_) =
                let  pars     =  if isJust _lhsIkind
                                 then  ppAnnotatedVars id _lhsIkind (_genericsItext ++ _parametricsItext)
                                 else  _genericsIfull ++ _parametricsIfull
                     g        =  length _genericsIself
                     p        =  length _parametricsIself
                     (gd,pd)  =  splitAt g pars
                in   group . hang 4 $
                       _nameDoc
                         <+> text "{|" <+> commas gd
                                       <>  (  if p == 0
                                              then  emptyPP
                                              else  text " |" <+> commas pd)
                                       <+> text "|}"
                         <$> text "::" <+> _typeItext
            -- "./Pretty.inc.ag"(line 482, column 13)
            ((_typevariable@_,_kind@_)) =
                let (KindAnnotatedName_KindAnnotatedName _ t k) = head _genericsIself
                    (MaybeKind_Just j)                          = k
                in  (t,j)
            -- self rule
            (_self@_) =
                Declaration_GenericTypeSignature _rangeIself _nameIself _genericsIself _parametricsIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_genericsOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_parametricsOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_typeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Declaration_Instance :: (T_Range) ->
                            (T_ContextItems) ->
                            (T_Name) ->
                            (T_Types) ->
                            (T_MaybeDeclarations) ->
                            (T_Declaration)
sem_Declaration_Instance (range_) (context_) (name_) (types_) (where_) =
    \ _lhsIkind
      _lhsIppMode ->
        let _lhsOself :: (Declaration)
            _lhsOtext :: ([Doc])
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _contextIself :: (ContextItems)
            _contextItext :: ([Doc])
            _contextOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _typesIself :: (Types)
            _typesItext :: ([Doc])
            _typesOppMode :: (PPMode)
            _whereIself :: (MaybeDeclarations)
            _whereItext :: ( Maybe [Doc] )
            _whereOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _contextIself,_contextItext) =
                (context_ (_contextOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _typesIself,_typesItext) =
                (types_ (_typesOppMode))
            ( _whereIself,_whereItext) =
                (where_ (_whereOppMode))
            -- "./Pretty.inc.ag"(line 465, column 9)
            (_whereDoc@_) =
                whereText _whereItext
            -- "./Pretty.inc.ag"(line 464, column 9)
            (_contextDoc@_) =
                contextText _contextItext
            -- "./Pretty.inc.ag"(line 462, column 9)
            (_lhsOtext@_) =
                [_text]
            -- "./Pretty.inc.ag"(line 459, column 9)
            (_text@_) =
                hang 4 $
                  text "instance" <+> _contextDoc <> _nameItext <+> align (sep _typesItext)
                    <> _whereDoc
            -- self rule
            (_self@_) =
                Declaration_Instance _rangeIself _contextIself _nameIself _typesIself _whereIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_contextOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_typesOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_whereOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Declaration_KindIndexedType :: (T_Range) ->
                                   (T_KindIndexedBindings) ->
                                   (T_Declaration)
sem_Declaration_KindIndexedType (range_) (bindings_) =
    \ _lhsIkind
      _lhsIppMode ->
        let _lhsOself :: (Declaration)
            _lhsOtext :: ([Doc])
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _bindingsIself :: (KindIndexedBindings)
            _bindingsItext :: ([Doc])
            _bindingsOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _bindingsIself,_bindingsItext) =
                (bindings_ (_bindingsOppMode))
            -- "./Pretty.inc.ag"(line 506, column 9)
            (_text@_) =
                _bindingsItext
            -- self rule
            (_self@_) =
                Declaration_KindIndexedType _rangeIself _bindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_bindingsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Declaration_Newtype :: (T_Range) ->
                           (T_ContextItems) ->
                           (T_SimpleType) ->
                           (T_Constructor) ->
                           (T_Names) ->
                           (T_Declaration)
sem_Declaration_Newtype (range_) (context_) (simpletype_) (constructor_) (derivings_) =
    \ _lhsIkind
      _lhsIppMode ->
        let _lhsOself :: (Declaration)
            _lhsOtext :: ([Doc])
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _contextIself :: (ContextItems)
            _contextItext :: ([Doc])
            _contextOppMode :: (PPMode)
            _simpletypeIself :: (SimpleType)
            _simpletypeItext :: (Doc)
            _simpletypeOkind :: (Maybe Kind)
            _simpletypeOppMode :: (PPMode)
            _constructorIself :: (Constructor)
            _constructorItext :: (Doc)
            _constructorOppMode :: (PPMode)
            _derivingsIisIdentifier :: ([Bool])
            _derivingsIisOperator :: ([Bool])
            _derivingsIisSpecial :: ([Bool])
            _derivingsIself :: (Names)
            _derivingsItext :: ([Doc])
            _derivingsOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _contextIself,_contextItext) =
                (context_ (_contextOppMode))
            ( _simpletypeIself,_simpletypeItext) =
                (simpletype_ (_simpletypeOkind) (_simpletypeOppMode))
            ( _constructorIself,_constructorItext) =
                (constructor_ (_constructorOppMode))
            ( _derivingsIisIdentifier,_derivingsIisOperator,_derivingsIisSpecial,_derivingsIself,_derivingsItext) =
                (derivings_ (_derivingsOppMode))
            -- "./Pretty.inc.ag"(line 448, column 9)
            (_derivingDoc@_) =
                derivingsText _derivingsItext
            -- "./Pretty.inc.ag"(line 447, column 9)
            (_contextDoc@_) =
                contextText _contextItext
            -- "./Pretty.inc.ag"(line 445, column 9)
            (_lhsOtext@_) =
                [_text]
            -- "./Pretty.inc.ag"(line 441, column 9)
            (_text@_) =
                group . hang 4 $
                  text "newtype" <+> _contextDoc <> _simpletypeItext
                    <$> text "=" <+> _constructorItext
                    <$> _derivingDoc
            -- self rule
            (_self@_) =
                Declaration_Newtype _rangeIself _contextIself _simpletypeIself _constructorIself _derivingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_contextOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_simpletypeOkind@_) =
                _lhsIkind
            -- copy rule (down)
            (_simpletypeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_constructorOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_derivingsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Declaration_PatternBinding :: (T_Range) ->
                                  (T_Pattern) ->
                                  (T_RightHandSide) ->
                                  (T_Declaration)
sem_Declaration_PatternBinding (range_) (pattern_) (righthandside_) =
    \ _lhsIkind
      _lhsIppMode ->
        let _lhsOself :: (Declaration)
            _lhsOtext :: ([Doc])
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _patternIself :: (Pattern)
            _patternItext :: (Doc)
            _patternOppMode :: (PPMode)
            _righthandsideIself :: (RightHandSide)
            _righthandsideItext :: ( Doc -> Doc  )
            _righthandsideOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _patternIself,_patternItext) =
                (pattern_ (_patternOppMode))
            ( _righthandsideIself,_righthandsideItext) =
                (righthandside_ (_righthandsideOppMode))
            -- "./Pretty.inc.ag"(line 476, column 9)
            (_lhsOtext@_) =
                [_text]
            -- "./Pretty.inc.ag"(line 475, column 9)
            (_text@_) =
                hang 2 $ _patternItext </> _righthandsideItext (text "=")
            -- self rule
            (_self@_) =
                Declaration_PatternBinding _rangeIself _patternIself _righthandsideIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_patternOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_righthandsideOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Declaration_Type :: (T_Range) ->
                        (T_SimpleType) ->
                        (T_Type) ->
                        (T_Declaration)
sem_Declaration_Type (range_) (simpletype_) (type_) =
    \ _lhsIkind
      _lhsIppMode ->
        let _lhsOself :: (Declaration)
            _lhsOtext :: ([Doc])
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _simpletypeIself :: (SimpleType)
            _simpletypeItext :: (Doc)
            _simpletypeOkind :: (Maybe Kind)
            _simpletypeOppMode :: (PPMode)
            _typeIself :: (Type)
            _typeItext :: (Doc)
            _typeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _simpletypeIself,_simpletypeItext) =
                (simpletype_ (_simpletypeOkind) (_simpletypeOppMode))
            ( _typeIself,_typeItext) =
                (type_ (_typeOppMode))
            -- "./Pretty.inc.ag"(line 427, column 9)
            (_lhsOtext@_) =
                [_text]
            -- "./Pretty.inc.ag"(line 424, column 9)
            (_text@_) =
                group . hang 4 $
                  text "type" <+> _simpletypeItext
                    <$> text "=" <+> _typeItext
            -- self rule
            (_self@_) =
                Declaration_Type _rangeIself _simpletypeIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_simpletypeOkind@_) =
                _lhsIkind
            -- copy rule (down)
            (_simpletypeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_typeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Declaration_TypeIndexedType :: (T_Range) ->
                                   (T_Name) ->
                                   (T_TypeArgument) ->
                                   (T_Names) ->
                                   (T_Constructor) ->
                                   (T_Names) ->
                                   (T_Declaration)
sem_Declaration_TypeIndexedType (range_) (name_) (typeargument_) (typevariables_) (constructor_) (derivings_) =
    \ _lhsIkind
      _lhsIppMode ->
        let _lhsOself :: (Declaration)
            _lhsOtext :: ([Doc])
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _typeargumentIself :: (TypeArgument)
            _typeargumentItext :: (Doc)
            _typeargumentOppMode :: (PPMode)
            _typevariablesIisIdentifier :: ([Bool])
            _typevariablesIisOperator :: ([Bool])
            _typevariablesIisSpecial :: ([Bool])
            _typevariablesIself :: (Names)
            _typevariablesItext :: ([Doc])
            _typevariablesOppMode :: (PPMode)
            _constructorIself :: (Constructor)
            _constructorItext :: (Doc)
            _constructorOppMode :: (PPMode)
            _derivingsIisIdentifier :: ([Bool])
            _derivingsIisOperator :: ([Bool])
            _derivingsIisSpecial :: ([Bool])
            _derivingsIself :: (Names)
            _derivingsItext :: ([Doc])
            _derivingsOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _typeargumentIself,_typeargumentItext) =
                (typeargument_ (_typeargumentOppMode))
            ( _typevariablesIisIdentifier,_typevariablesIisOperator,_typevariablesIisSpecial,_typevariablesIself,_typevariablesItext) =
                (typevariables_ (_typevariablesOppMode))
            ( _constructorIself,_constructorItext) =
                (constructor_ (_constructorOppMode))
            ( _derivingsIisIdentifier,_derivingsIisOperator,_derivingsIisSpecial,_derivingsIself,_derivingsItext) =
                (derivings_ (_derivingsOppMode))
            -- "./Pretty.inc.ag"(line 525, column 9)
            (_nameOppMode@_) =
                _lhsIppMode { unqualified = True }
            -- "./Pretty.inc.ag"(line 524, column 9)
            (_derivingDoc@_) =
                derivingsText _derivingsItext
            -- "./Pretty.inc.ag"(line 522, column 9)
            (_lhsOtext@_) =
                [_text]
            -- "./Pretty.inc.ag"(line 516, column 9)
            (_text@_) =
                group . hang 4 $
                  text "type" <+> _nameItext
                    <+> text "{|" <+> _typeargumentItext <+> text "|}"
                    <>  foldl (<+>) emptyPP _typevariablesItext
                    <$> text "=" <+> _constructorItext
                    <$> _derivingDoc
            -- self rule
            (_self@_) =
                Declaration_TypeIndexedType _rangeIself _nameIself _typeargumentIself _typevariablesIself _constructorIself _derivingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_typeargumentOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_typevariablesOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_constructorOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_derivingsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Declaration_TypeIndexedValue :: (T_Range) ->
                                    (T_TypeIndexedBindings) ->
                                    (T_Declaration)
sem_Declaration_TypeIndexedValue (range_) (bindings_) =
    \ _lhsIkind
      _lhsIppMode ->
        let _lhsOself :: (Declaration)
            _lhsOtext :: ([Doc])
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _bindingsIself :: (TypeIndexedBindings)
            _bindingsItext :: ([Doc])
            _bindingsOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _bindingsIself,_bindingsItext) =
                (bindings_ (_bindingsOppMode))
            -- "./Pretty.inc.ag"(line 509, column 9)
            (_text@_) =
                _bindingsItext
            -- self rule
            (_self@_) =
                Declaration_TypeIndexedValue _rangeIself _bindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_bindingsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Declaration_TypeSignature :: (T_Range) ->
                                 (T_Names) ->
                                 (T_Type) ->
                                 (T_Declaration)
sem_Declaration_TypeSignature (range_) (names_) (type_) =
    \ _lhsIkind
      _lhsIppMode ->
        let _lhsOself :: (Declaration)
            _lhsOtext :: ([Doc])
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _namesIisIdentifier :: ([Bool])
            _namesIisOperator :: ([Bool])
            _namesIisSpecial :: ([Bool])
            _namesIself :: (Names)
            _namesItext :: ([Doc])
            _namesOppMode :: (PPMode)
            _typeIself :: (Type)
            _typeItext :: (Doc)
            _typeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _namesIisIdentifier,_namesIisOperator,_namesIisSpecial,_namesIself,_namesItext) =
                (names_ (_namesOppMode))
            ( _typeIself,_typeItext) =
                (type_ (_typeOppMode))
            -- "./Pretty.inc.ag"(line 536, column 9)
            (_namesOppMode@_) =
                _lhsIppMode { unqualified = True, infixpos = False }
            -- "./Pretty.inc.ag"(line 535, column 9)
            (_namesDocs@_) =
                _namesItext
            -- "./Pretty.inc.ag"(line 533, column 9)
            (_lhsOtext@_) =
                [_text]
            -- "./Pretty.inc.ag"(line 530, column 9)
            (_text@_) =
                group . hang 4 $
                  commas _namesDocs
                    <$> text "::" <+> _typeItext
            -- self rule
            (_self@_) =
                Declaration_TypeSignature _rangeIself _namesIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_typeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
-- Declarations ------------------------------------------------
{-
   inherited attributes:
      kind                 : Maybe Kind
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : [Doc]

-}
{-
   local variables for Declarations.Cons:
      self

-}
{-
   local variables for Declarations.Nil:
      self

-}
-- semantic domain
type T_Declarations = (Maybe Kind) ->
                      (PPMode) ->
                      ( (Declarations),([Doc]))
-- cata
sem_Declarations :: (Declarations) ->
                    (T_Declarations)
sem_Declarations (list) =
    (foldr (sem_Declarations_Cons) (sem_Declarations_Nil) ((map sem_Declaration list)))
sem_Declarations_Cons :: (T_Declaration) ->
                         (T_Declarations) ->
                         (T_Declarations)
sem_Declarations_Cons (hd_) (tl_) =
    \ _lhsIkind
      _lhsIppMode ->
        let _lhsOself :: (Declarations)
            _lhsOtext :: ([Doc])
            _hdIself :: (Declaration)
            _hdItext :: ([Doc])
            _hdOkind :: (Maybe Kind)
            _hdOppMode :: (PPMode)
            _tlIself :: (Declarations)
            _tlItext :: ([Doc])
            _tlOkind :: (Maybe Kind)
            _tlOppMode :: (PPMode)
            ( _hdIself,_hdItext) =
                (hd_ (_hdOkind) (_hdOppMode))
            ( _tlIself,_tlItext) =
                (tl_ (_tlOkind) (_tlOppMode))
            -- use rule
            (_lhsOtext@_) =
                _hdItext ++ _tlItext
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_hdOkind@_) =
                _lhsIkind
            -- copy rule (down)
            (_hdOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_tlOkind@_) =
                _lhsIkind
            -- copy rule (down)
            (_tlOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Declarations_Nil :: (T_Declarations)
sem_Declarations_Nil  =
    \ _lhsIkind
      _lhsIppMode ->
        let _lhsOself :: (Declarations)
            _lhsOtext :: ([Doc])
            -- use rule
            (_lhsOtext@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOself,_lhsOtext)
-- DependencyBinding -------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for DependencyBinding.Rename:
      text
      self

-}
{-
   local variables for DependencyBinding.Simple:
      self

-}
-- semantic domain
type T_DependencyBinding = (PPMode) ->
                           ( (DependencyBinding),(Doc))
-- cata
sem_DependencyBinding :: (DependencyBinding) ->
                         (T_DependencyBinding)
sem_DependencyBinding ((DependencyBinding_Rename (_range) (_name) (_as))) =
    (sem_DependencyBinding_Rename ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Name (_as))))
sem_DependencyBinding ((DependencyBinding_Simple (_range) (_name))) =
    (sem_DependencyBinding_Simple ((sem_Range (_range))) ((sem_Name (_name))))
sem_DependencyBinding_Rename :: (T_Range) ->
                                (T_Name) ->
                                (T_Name) ->
                                (T_DependencyBinding)
sem_DependencyBinding_Rename (range_) (name_) (as_) =
    \ _lhsIppMode ->
        let _lhsOself :: (DependencyBinding)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _asIisIdentifier :: (Bool)
            _asIisOperator :: (Bool)
            _asIisSpecial :: (Bool)
            _asIself :: (Name)
            _asItext :: (Doc)
            _asOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _asIisIdentifier,_asIisOperator,_asIisSpecial,_asIself,_asItext) =
                (as_ (_asOppMode))
            -- "./Pretty.inc.ag"(line 693, column 9)
            (_text@_) =
                parens
                  (_nameItext <+> text "as" <+> _asItext)
            -- self rule
            (_self@_) =
                DependencyBinding_Rename _rangeIself _nameIself _asIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_asOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_DependencyBinding_Simple :: (T_Range) ->
                                (T_Name) ->
                                (T_DependencyBinding)
sem_DependencyBinding_Simple (range_) (name_) =
    \ _lhsIppMode ->
        let _lhsOself :: (DependencyBinding)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            -- self rule
            (_self@_) =
                DependencyBinding_Simple _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOtext@_) =
                _nameItext
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
-- DependencyBindings ------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : [Doc]

-}
{-
   local variables for DependencyBindings.Cons:
      self

-}
{-
   local variables for DependencyBindings.Nil:
      self

-}
-- semantic domain
type T_DependencyBindings = (PPMode) ->
                            ( (DependencyBindings),([Doc]))
-- cata
sem_DependencyBindings :: (DependencyBindings) ->
                          (T_DependencyBindings)
sem_DependencyBindings (list) =
    (foldr (sem_DependencyBindings_Cons) (sem_DependencyBindings_Nil) ((map sem_DependencyBinding list)))
sem_DependencyBindings_Cons :: (T_DependencyBinding) ->
                               (T_DependencyBindings) ->
                               (T_DependencyBindings)
sem_DependencyBindings_Cons (hd_) (tl_) =
    \ _lhsIppMode ->
        let _lhsOself :: (DependencyBindings)
            _lhsOtext :: ([Doc])
            _hdIself :: (DependencyBinding)
            _hdItext :: (Doc)
            _hdOppMode :: (PPMode)
            _tlIself :: (DependencyBindings)
            _tlItext :: ([Doc])
            _tlOppMode :: (PPMode)
            ( _hdIself,_hdItext) =
                (hd_ (_hdOppMode))
            ( _tlIself,_tlItext) =
                (tl_ (_tlOppMode))
            -- use rule
            (_lhsOtext@_) =
                _hdItext : _tlItext
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_hdOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_tlOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_DependencyBindings_Nil :: (T_DependencyBindings)
sem_DependencyBindings_Nil  =
    \ _lhsIppMode ->
        let _lhsOself :: (DependencyBindings)
            _lhsOtext :: ([Doc])
            -- use rule
            (_lhsOtext@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOself,_lhsOtext)
-- Export ------------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : [Doc]

-}
{-
   local variables for Export.Module:
      text
      self

-}
{-
   local variables for Export.TypeOrClass:
      text
      self

-}
{-
   local variables for Export.TypeOrClassComplete:
      text
      self

-}
{-
   local variables for Export.Variable:
      text
      self

-}
-- semantic domain
type T_Export = (PPMode) ->
                ( (Export),([Doc]))
-- cata
sem_Export :: (Export) ->
              (T_Export)
sem_Export ((Export_Module (_range) (_name))) =
    (sem_Export_Module ((sem_Range (_range))) ((sem_ModuleName (_name))))
sem_Export ((Export_TypeOrClass (_range) (_name) (_names))) =
    (sem_Export_TypeOrClass ((sem_Range (_range))) ((sem_Name (_name))) ((sem_MaybeNames (_names))))
sem_Export ((Export_TypeOrClassComplete (_range) (_name))) =
    (sem_Export_TypeOrClassComplete ((sem_Range (_range))) ((sem_Name (_name))))
sem_Export ((Export_Variable (_range) (_name))) =
    (sem_Export_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Export_Module :: (T_Range) ->
                     (T_ModuleName) ->
                     (T_Export)
sem_Export_Module (range_) (name_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Export)
            _lhsOtext :: ([Doc])
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIself :: (ModuleName)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIself,_nameItext) =
                (name_ (_nameOppMode))
            -- "./Pretty.inc.ag"(line 350, column 9)
            (_text@_) =
                [text "module" <+> _nameItext]
            -- self rule
            (_self@_) =
                Export_Module _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Export_TypeOrClass :: (T_Range) ->
                          (T_Name) ->
                          (T_MaybeNames) ->
                          (T_Export)
sem_Export_TypeOrClass (range_) (name_) (names_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Export)
            _lhsOtext :: ([Doc])
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _namesIself :: (MaybeNames)
            _namesItext :: ( Maybe [Doc] )
            _namesOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _namesIself,_namesItext) =
                (names_ (_namesOppMode))
            -- "./Pretty.inc.ag"(line 331, column 9)
            (_text@_) =
                if _nameIisSpecial then
                  []
                else
                  [_nameItext
                     <> maybe
                          emptyPP
                          uuTuple
                          (_namesItext)
                  ]
            -- self rule
            (_self@_) =
                Export_TypeOrClass _rangeIself _nameIself _namesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_namesOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Export_TypeOrClassComplete :: (T_Range) ->
                                  (T_Name) ->
                                  (T_Export)
sem_Export_TypeOrClassComplete (range_) (name_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Export)
            _lhsOtext :: ([Doc])
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            -- "./Pretty.inc.ag"(line 344, column 9)
            (_text@_) =
                if _nameIisSpecial then
                  []
                else
                  [_nameItext <> text "(..)"]
            -- self rule
            (_self@_) =
                Export_TypeOrClassComplete _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Export_Variable :: (T_Range) ->
                       (T_Name) ->
                       (T_Export)
sem_Export_Variable (range_) (name_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Export)
            _lhsOtext :: ([Doc])
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            -- "./Pretty.inc.ag"(line 325, column 9)
            (_text@_) =
                [_nameItext]
            -- self rule
            (_self@_) =
                Export_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
-- Exports -----------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : [Doc]

-}
{-
   local variables for Exports.Cons:
      self

-}
{-
   local variables for Exports.Nil:
      self

-}
-- semantic domain
type T_Exports = (PPMode) ->
                 ( (Exports),([Doc]))
-- cata
sem_Exports :: (Exports) ->
               (T_Exports)
sem_Exports (list) =
    (foldr (sem_Exports_Cons) (sem_Exports_Nil) ((map sem_Export list)))
sem_Exports_Cons :: (T_Export) ->
                    (T_Exports) ->
                    (T_Exports)
sem_Exports_Cons (hd_) (tl_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Exports)
            _lhsOtext :: ([Doc])
            _hdIself :: (Export)
            _hdItext :: ([Doc])
            _hdOppMode :: (PPMode)
            _tlIself :: (Exports)
            _tlItext :: ([Doc])
            _tlOppMode :: (PPMode)
            ( _hdIself,_hdItext) =
                (hd_ (_hdOppMode))
            ( _tlIself,_tlItext) =
                (tl_ (_tlOppMode))
            -- use rule
            (_lhsOtext@_) =
                _hdItext ++ _tlItext
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_hdOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_tlOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Exports_Nil :: (T_Exports)
sem_Exports_Nil  =
    \ _lhsIppMode ->
        let _lhsOself :: (Exports)
            _lhsOtext :: ([Doc])
            -- use rule
            (_lhsOtext@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOself,_lhsOtext)
-- Expression --------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for Expression.As:
      self

-}
{-
   local variables for Expression.Case:
      text
      self

-}
{-
   local variables for Expression.Comprehension:
      text
      self

-}
{-
   local variables for Expression.Constructor:
      text
      self

-}
{-
   local variables for Expression.Do:
      text
      self

-}
{-
   local variables for Expression.Enum:
      text
      self

-}
{-
   local variables for Expression.If:
      text
      self

-}
{-
   local variables for Expression.InfixApplication:
      text
      self

-}
{-
   local variables for Expression.Irrefutable:
      self

-}
{-
   local variables for Expression.Lambda:
      text
      self

-}
{-
   local variables for Expression.Let:
      text
      self

-}
{-
   local variables for Expression.List:
      text
      self

-}
{-
   local variables for Expression.Literal:
      text
      self

-}
{-
   local variables for Expression.Negate:
      text
      self

-}
{-
   local variables for Expression.NormalApplication:
      text
      self

-}
{-
   local variables for Expression.Parenthesized:
      text
      self

-}
{-
   local variables for Expression.RecordConstruction:
      text
      self

-}
{-
   local variables for Expression.RecordUpdate:
      text
      self

-}
{-
   local variables for Expression.Tuple:
      text
      self

-}
{-
   local variables for Expression.TypeApplication:
      text
      self

-}
{-
   local variables for Expression.Typed:
      text
      self

-}
{-
   local variables for Expression.Variable:
      text
      self

-}
{-
   local variables for Expression.Wildcard:
      self

-}
-- semantic domain
type T_Expression = (PPMode) ->
                    ( (Expression),(Doc))
-- cata
sem_Expression :: (Expression) ->
                  (T_Expression)
sem_Expression ((Expression_As (_range) (_name) (_expression))) =
    (sem_Expression_As ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Expression (_expression))))
sem_Expression ((Expression_Case (_range) (_expression) (_alternatives))) =
    (sem_Expression_Case ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_Alternatives (_alternatives))))
sem_Expression ((Expression_Comprehension (_range) (_expression) (_qualifiers))) =
    (sem_Expression_Comprehension ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_Qualifiers (_qualifiers))))
sem_Expression ((Expression_Constructor (_range) (_name))) =
    (sem_Expression_Constructor ((sem_Range (_range))) ((sem_Name (_name))))
sem_Expression ((Expression_Do (_range) (_statements))) =
    (sem_Expression_Do ((sem_Range (_range))) ((sem_Statements (_statements))))
sem_Expression ((Expression_Enum (_range) (_from) (_then) (_to))) =
    (sem_Expression_Enum ((sem_Range (_range))) ((sem_Expression (_from))) ((sem_MaybeExpression (_then))) ((sem_MaybeExpression (_to))))
sem_Expression ((Expression_If (_range) (_guardExpression) (_thenExpression) (_elseExpression))) =
    (sem_Expression_If ((sem_Range (_range))) ((sem_Expression (_guardExpression))) ((sem_Expression (_thenExpression))) ((sem_Expression (_elseExpression))))
sem_Expression ((Expression_InfixApplication (_range) (_leftExpression) (_operator) (_rightExpression))) =
    (sem_Expression_InfixApplication ((sem_Range (_range))) ((sem_MaybeExpression (_leftExpression))) ((sem_Expression (_operator))) ((sem_MaybeExpression (_rightExpression))))
sem_Expression ((Expression_Irrefutable (_range) (_expression))) =
    (sem_Expression_Irrefutable ((sem_Range (_range))) ((sem_Expression (_expression))))
sem_Expression ((Expression_Lambda (_range) (_patterns) (_expression))) =
    (sem_Expression_Lambda ((sem_Range (_range))) ((sem_Patterns (_patterns))) ((sem_Expression (_expression))))
sem_Expression ((Expression_Let (_range) (_declarations) (_expression))) =
    (sem_Expression_Let ((sem_Range (_range))) ((sem_Declarations (_declarations))) ((sem_Expression (_expression))))
sem_Expression ((Expression_List (_range) (_expressions))) =
    (sem_Expression_List ((sem_Range (_range))) ((sem_Expressions (_expressions))))
sem_Expression ((Expression_Literal (_range) (_literal))) =
    (sem_Expression_Literal ((sem_Range (_range))) ((sem_Literal (_literal))))
sem_Expression ((Expression_Negate (_range) (_expression))) =
    (sem_Expression_Negate ((sem_Range (_range))) ((sem_Expression (_expression))))
sem_Expression ((Expression_NormalApplication (_range) (_function) (_arguments))) =
    (sem_Expression_NormalApplication ((sem_Range (_range))) ((sem_Expression (_function))) ((sem_Expressions (_arguments))))
sem_Expression ((Expression_Parenthesized (_range) (_expression))) =
    (sem_Expression_Parenthesized ((sem_Range (_range))) ((sem_Expression (_expression))))
sem_Expression ((Expression_RecordConstruction (_range) (_name) (_recordExpressionBindings))) =
    (sem_Expression_RecordConstruction ((sem_Range (_range))) ((sem_Name (_name))) ((sem_RecordExpressionBindings (_recordExpressionBindings))))
sem_Expression ((Expression_RecordUpdate (_range) (_expression) (_recordExpressionBindings))) =
    (sem_Expression_RecordUpdate ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_RecordExpressionBindings (_recordExpressionBindings))))
sem_Expression ((Expression_Tuple (_range) (_expressions))) =
    (sem_Expression_Tuple ((sem_Range (_range))) ((sem_Expressions (_expressions))))
sem_Expression ((Expression_TypeApplication (_range) (_name) (_type))) =
    (sem_Expression_TypeApplication ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Type (_type))))
sem_Expression ((Expression_Typed (_range) (_expression) (_type))) =
    (sem_Expression_Typed ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_Type (_type))))
sem_Expression ((Expression_Variable (_range) (_name))) =
    (sem_Expression_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Expression ((Expression_Wildcard (_range))) =
    (sem_Expression_Wildcard ((sem_Range (_range))))
sem_Expression_As :: (T_Range) ->
                     (T_Name) ->
                     (T_Expression) ->
                     (T_Expression)
sem_Expression_As (range_) (name_) (expression_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Expression)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _expressionIself :: (Expression)
            _expressionItext :: (Doc)
            _expressionOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _expressionIself,_expressionItext) =
                (expression_ (_expressionOppMode))
            -- self rule
            (_self@_) =
                Expression_As _rangeIself _nameIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOtext@_) =
                _expressionItext
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_expressionOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Expression_Case :: (T_Range) ->
                       (T_Expression) ->
                       (T_Alternatives) ->
                       (T_Expression)
sem_Expression_Case (range_) (expression_) (alternatives_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Expression)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _expressionIself :: (Expression)
            _expressionItext :: (Doc)
            _expressionOppMode :: (PPMode)
            _alternativesIself :: (Alternatives)
            _alternativesItext :: ([Doc])
            _alternativesOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _expressionIself,_expressionItext) =
                (expression_ (_expressionOppMode))
            ( _alternativesIself,_alternativesItext) =
                (alternatives_ (_alternativesOppMode))
            -- "./Pretty.inc.ag"(line 843, column 9)
            (_text@_) =
                hang 2 $ text "case" <+> _expressionItext <+> text "of"
                  <$> uuDecls _alternativesItext
                  <$> emptyPP
            -- self rule
            (_self@_) =
                Expression_Case _rangeIself _expressionIself _alternativesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_expressionOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_alternativesOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Expression_Comprehension :: (T_Range) ->
                                (T_Expression) ->
                                (T_Qualifiers) ->
                                (T_Expression)
sem_Expression_Comprehension (range_) (expression_) (qualifiers_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Expression)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _expressionIself :: (Expression)
            _expressionItext :: (Doc)
            _expressionOppMode :: (PPMode)
            _qualifiersIself :: (Qualifiers)
            _qualifiersItext :: ([Doc])
            _qualifiersOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _expressionIself,_expressionItext) =
                (expression_ (_expressionOppMode))
            ( _qualifiersIself,_qualifiersItext) =
                (qualifiers_ (_qualifiersOppMode))
            -- "./Pretty.inc.ag"(line 867, column 9)
            (_text@_) =
                align $ text "[" <+> _expressionItext
                  </> uuSep (text "| ") rsquare (comma <> space) _qualifiersItext
            -- self rule
            (_self@_) =
                Expression_Comprehension _rangeIself _expressionIself _qualifiersIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_expressionOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_qualifiersOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Expression_Constructor :: (T_Range) ->
                              (T_Name) ->
                              (T_Expression)
sem_Expression_Constructor (range_) (name_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Expression)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            -- "./Pretty.inc.ag"(line 811, column 9)
            (_text@_) =
                _nameItext
            -- self rule
            (_self@_) =
                Expression_Constructor _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Expression_Do :: (T_Range) ->
                     (T_Statements) ->
                     (T_Expression)
sem_Expression_Do (range_) (statements_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Expression)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _statementsIself :: (Statements)
            _statementsItext :: ([Doc])
            _statementsOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _statementsIself,_statementsItext) =
                (statements_ (_statementsOppMode))
            -- "./Pretty.inc.ag"(line 858, column 9)
            (_text@_) =
                hang 2 $ text "do" <$> uuDecls _statementsItext <$> emptyPP
            -- self rule
            (_self@_) =
                Expression_Do _rangeIself _statementsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_statementsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Expression_Enum :: (T_Range) ->
                       (T_Expression) ->
                       (T_MaybeExpression) ->
                       (T_MaybeExpression) ->
                       (T_Expression)
sem_Expression_Enum (range_) (from_) (then_) (to_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Expression)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _fromIself :: (Expression)
            _fromItext :: (Doc)
            _fromOppMode :: (PPMode)
            _thenIself :: (MaybeExpression)
            _thenItext :: ( Maybe Doc )
            _thenOppMode :: (PPMode)
            _toIself :: (MaybeExpression)
            _toItext :: ( Maybe Doc )
            _toOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _fromIself,_fromItext) =
                (from_ (_fromOppMode))
            ( _thenIself,_thenItext) =
                (then_ (_thenOppMode))
            ( _toIself,_toItext) =
                (to_ (_toOppMode))
            -- "./Pretty.inc.ag"(line 881, column 9)
            (_text@_) =
                hang 2 $ lsquare <> _fromItext
                  <//> maybe emptyPP (comma <>) _thenItext
                  </>  text ".." <> opt _toItext <> rsquare
            -- self rule
            (_self@_) =
                Expression_Enum _rangeIself _fromIself _thenIself _toIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_fromOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_thenOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_toOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Expression_If :: (T_Range) ->
                     (T_Expression) ->
                     (T_Expression) ->
                     (T_Expression) ->
                     (T_Expression)
sem_Expression_If (range_) (guardExpression_) (thenExpression_) (elseExpression_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Expression)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _guardExpressionIself :: (Expression)
            _guardExpressionItext :: (Doc)
            _guardExpressionOppMode :: (PPMode)
            _thenExpressionIself :: (Expression)
            _thenExpressionItext :: (Doc)
            _thenExpressionOppMode :: (PPMode)
            _elseExpressionIself :: (Expression)
            _elseExpressionItext :: (Doc)
            _elseExpressionOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _guardExpressionIself,_guardExpressionItext) =
                (guardExpression_ (_guardExpressionOppMode))
            ( _thenExpressionIself,_thenExpressionItext) =
                (thenExpression_ (_thenExpressionOppMode))
            ( _elseExpressionIself,_elseExpressionItext) =
                (elseExpression_ (_elseExpressionOppMode))
            -- "./Pretty.inc.ag"(line 833, column 9)
            (_text@_) =
                hang 2 $
                  text "if" <+> _guardExpressionItext
                    </> text "then" <+> _thenExpressionItext
                    </> text "else" <+> _elseExpressionItext
            -- self rule
            (_self@_) =
                Expression_If _rangeIself _guardExpressionIself _thenExpressionIself _elseExpressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_guardExpressionOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_thenExpressionOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_elseExpressionOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Expression_InfixApplication :: (T_Range) ->
                                   (T_MaybeExpression) ->
                                   (T_Expression) ->
                                   (T_MaybeExpression) ->
                                   (T_Expression)
sem_Expression_InfixApplication (range_) (leftExpression_) (operator_) (rightExpression_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Expression)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _leftExpressionIself :: (MaybeExpression)
            _leftExpressionItext :: ( Maybe Doc )
            _leftExpressionOppMode :: (PPMode)
            _operatorIself :: (Expression)
            _operatorItext :: (Doc)
            _operatorOppMode :: (PPMode)
            _rightExpressionIself :: (MaybeExpression)
            _rightExpressionItext :: ( Maybe Doc )
            _rightExpressionOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _leftExpressionIself,_leftExpressionItext) =
                (leftExpression_ (_leftExpressionOppMode))
            ( _operatorIself,_operatorItext) =
                (operator_ (_operatorOppMode))
            ( _rightExpressionIself,_rightExpressionItext) =
                (rightExpression_ (_rightExpressionOppMode))
            -- "./Pretty.inc.ag"(line 830, column 9)
            (_operatorOppMode@_) =
                _lhsIppMode { infixpos = True }
            -- "./Pretty.inc.ag"(line 821, column 9)
            (_text@_) =
                case (_leftExpressionItext, _rightExpressionItext) of
                      (Nothing, Nothing) ->
                         parens _operatorItext
                      (Just l , Nothing) ->
                         parens (l <+> _operatorItext)
                      (Nothing, Just r ) ->
                         parens (_operatorItext <+> r)
                      (Just l , Just r ) ->
                         hang 2 $ l </> _operatorItext <+> r
            -- self rule
            (_self@_) =
                Expression_InfixApplication _rangeIself _leftExpressionIself _operatorIself _rightExpressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_leftExpressionOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_rightExpressionOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Expression_Irrefutable :: (T_Range) ->
                              (T_Expression) ->
                              (T_Expression)
sem_Expression_Irrefutable (range_) (expression_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Expression)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _expressionIself :: (Expression)
            _expressionItext :: (Doc)
            _expressionOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _expressionIself,_expressionItext) =
                (expression_ (_expressionOppMode))
            -- self rule
            (_self@_) =
                Expression_Irrefutable _rangeIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOtext@_) =
                _expressionItext
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_expressionOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Expression_Lambda :: (T_Range) ->
                         (T_Patterns) ->
                         (T_Expression) ->
                         (T_Expression)
sem_Expression_Lambda (range_) (patterns_) (expression_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Expression)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _patternsIself :: (Patterns)
            _patternsItext :: ([Doc])
            _patternsOppMode :: (PPMode)
            _expressionIself :: (Expression)
            _expressionItext :: (Doc)
            _expressionOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _patternsIself,_patternsItext) =
                (patterns_ (_patternsOppMode))
            ( _expressionIself,_expressionItext) =
                (expression_ (_expressionOppMode))
            -- "./Pretty.inc.ag"(line 839, column 9)
            (_text@_) =
                hang 2 $ text "\\" <+> align (sep _patternsItext)
                  </> text "->" <+> _expressionItext
            -- self rule
            (_self@_) =
                Expression_Lambda _rangeIself _patternsIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_patternsOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_expressionOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Expression_Let :: (T_Range) ->
                      (T_Declarations) ->
                      (T_Expression) ->
                      (T_Expression)
sem_Expression_Let (range_) (declarations_) (expression_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Expression)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _declarationsIself :: (Declarations)
            _declarationsItext :: ([Doc])
            _declarationsOkind :: (Maybe Kind)
            _declarationsOppMode :: (PPMode)
            _expressionIself :: (Expression)
            _expressionItext :: (Doc)
            _expressionOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _declarationsIself,_declarationsItext) =
                (declarations_ (_declarationsOkind) (_declarationsOppMode))
            ( _expressionIself,_expressionItext) =
                (expression_ (_expressionOppMode))
            -- "./Pretty.inc.ag"(line 855, column 9)
            (_declarationsOkind@_) =
                Nothing
            -- "./Pretty.inc.ag"(line 848, column 9)
            (_text@_) =
                if length _declarationsItext < 2 then
                  group . hang 2 $ text "let" <+> uuDecls _declarationsItext <+> text "in"
                    <$> _expressionItext
                else
                  group . hang 2 $ text "let" <+> uuDecls _declarationsItext <+> text "in"
                    <$> _expressionItext
                    <$> emptyPP
            -- self rule
            (_self@_) =
                Expression_Let _rangeIself _declarationsIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_declarationsOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_expressionOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Expression_List :: (T_Range) ->
                       (T_Expressions) ->
                       (T_Expression)
sem_Expression_List (range_) (expressions_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Expression)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _expressionsIself :: (Expressions)
            _expressionsItext :: ([Doc])
            _expressionsOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _expressionsIself,_expressionsItext) =
                (expressions_ (_expressionsOppMode))
            -- "./Pretty.inc.ag"(line 861, column 9)
            (_text@_) =
                uuList _expressionsItext
            -- self rule
            (_self@_) =
                Expression_List _rangeIself _expressionsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_expressionsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Expression_Literal :: (T_Range) ->
                          (T_Literal) ->
                          (T_Expression)
sem_Expression_Literal (range_) (literal_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Expression)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _literalIself :: (Literal)
            _literalItext :: (Doc)
            _literalOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _literalIself,_literalItext) =
                (literal_ (_literalOppMode))
            -- "./Pretty.inc.ag"(line 805, column 9)
            (_text@_) =
                _literalItext
            -- self rule
            (_self@_) =
                Expression_Literal _rangeIself _literalIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_literalOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Expression_Negate :: (T_Range) ->
                         (T_Expression) ->
                         (T_Expression)
sem_Expression_Negate (range_) (expression_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Expression)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _expressionIself :: (Expression)
            _expressionItext :: (Doc)
            _expressionOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _expressionIself,_expressionItext) =
                (expression_ (_expressionOppMode))
            -- "./Pretty.inc.ag"(line 886, column 9)
            (_text@_) =
                text "-" <+> _expressionItext
            -- self rule
            (_self@_) =
                Expression_Negate _rangeIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_expressionOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Expression_NormalApplication :: (T_Range) ->
                                    (T_Expression) ->
                                    (T_Expressions) ->
                                    (T_Expression)
sem_Expression_NormalApplication (range_) (function_) (arguments_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Expression)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _functionIself :: (Expression)
            _functionItext :: (Doc)
            _functionOppMode :: (PPMode)
            _argumentsIself :: (Expressions)
            _argumentsItext :: ([Doc])
            _argumentsOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _functionIself,_functionItext) =
                (function_ (_functionOppMode))
            ( _argumentsIself,_argumentsItext) =
                (arguments_ (_argumentsOppMode))
            -- "./Pretty.inc.ag"(line 817, column 9)
            (_text@_) =
                hang 2 $
                  _functionItext </> fillSep _argumentsItext
            -- self rule
            (_self@_) =
                Expression_NormalApplication _rangeIself _functionIself _argumentsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_functionOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_argumentsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Expression_Parenthesized :: (T_Range) ->
                                (T_Expression) ->
                                (T_Expression)
sem_Expression_Parenthesized (range_) (expression_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Expression)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _expressionIself :: (Expression)
            _expressionItext :: (Doc)
            _expressionOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _expressionIself,_expressionItext) =
                (expression_ (_expressionOppMode))
            -- "./Pretty.inc.ag"(line 814, column 9)
            (_text@_) =
                parens _expressionItext
            -- self rule
            (_self@_) =
                Expression_Parenthesized _rangeIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_expressionOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Expression_RecordConstruction :: (T_Range) ->
                                     (T_Name) ->
                                     (T_RecordExpressionBindings) ->
                                     (T_Expression)
sem_Expression_RecordConstruction (range_) (name_) (recordExpressionBindings_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Expression)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _recordExpressionBindingsIself :: (RecordExpressionBindings)
            _recordExpressionBindingsItext :: ([Doc])
            _recordExpressionBindingsOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _recordExpressionBindingsIself,_recordExpressionBindingsItext) =
                (recordExpressionBindings_ (_recordExpressionBindingsOppMode))
            -- "./Pretty.inc.ag"(line 875, column 9)
            (_text@_) =
                hang 2 $ _nameItext </> uuRecord _recordExpressionBindingsItext
            -- self rule
            (_self@_) =
                Expression_RecordConstruction _rangeIself _nameIself _recordExpressionBindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_recordExpressionBindingsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Expression_RecordUpdate :: (T_Range) ->
                               (T_Expression) ->
                               (T_RecordExpressionBindings) ->
                               (T_Expression)
sem_Expression_RecordUpdate (range_) (expression_) (recordExpressionBindings_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Expression)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _expressionIself :: (Expression)
            _expressionItext :: (Doc)
            _expressionOppMode :: (PPMode)
            _recordExpressionBindingsIself :: (RecordExpressionBindings)
            _recordExpressionBindingsItext :: ([Doc])
            _recordExpressionBindingsOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _expressionIself,_expressionItext) =
                (expression_ (_expressionOppMode))
            ( _recordExpressionBindingsIself,_recordExpressionBindingsItext) =
                (recordExpressionBindings_ (_recordExpressionBindingsOppMode))
            -- "./Pretty.inc.ag"(line 878, column 9)
            (_text@_) =
                hang 2 $ _expressionItext </> uuRecord _recordExpressionBindingsItext
            -- self rule
            (_self@_) =
                Expression_RecordUpdate _rangeIself _expressionIself _recordExpressionBindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_expressionOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_recordExpressionBindingsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Expression_Tuple :: (T_Range) ->
                        (T_Expressions) ->
                        (T_Expression)
sem_Expression_Tuple (range_) (expressions_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Expression)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _expressionsIself :: (Expressions)
            _expressionsItext :: ([Doc])
            _expressionsOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _expressionsIself,_expressionsItext) =
                (expressions_ (_expressionsOppMode))
            -- "./Pretty.inc.ag"(line 864, column 9)
            (_text@_) =
                uuTuple _expressionsItext
            -- self rule
            (_self@_) =
                Expression_Tuple _rangeIself _expressionsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_expressionsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Expression_TypeApplication :: (T_Range) ->
                                  (T_Name) ->
                                  (T_Type) ->
                                  (T_Expression)
sem_Expression_TypeApplication (range_) (name_) (type_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Expression)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _typeIself :: (Type)
            _typeItext :: (Doc)
            _typeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _typeIself,_typeItext) =
                (type_ (_typeOppMode))
            -- "./Pretty.inc.ag"(line 891, column 9)
            (_text@_) =
                _nameItext <+> text "{|" <+> _typeItext <+> text "|}"
            -- self rule
            (_self@_) =
                Expression_TypeApplication _rangeIself _nameIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_typeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Expression_Typed :: (T_Range) ->
                        (T_Expression) ->
                        (T_Type) ->
                        (T_Expression)
sem_Expression_Typed (range_) (expression_) (type_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Expression)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _expressionIself :: (Expression)
            _expressionItext :: (Doc)
            _expressionOppMode :: (PPMode)
            _typeIself :: (Type)
            _typeItext :: (Doc)
            _typeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _expressionIself,_expressionItext) =
                (expression_ (_expressionOppMode))
            ( _typeIself,_typeItext) =
                (type_ (_typeOppMode))
            -- "./Pretty.inc.ag"(line 871, column 9)
            (_text@_) =
                hang 2 $ _expressionItext
                  </> text "::" <+> _typeItext
            -- self rule
            (_self@_) =
                Expression_Typed _rangeIself _expressionIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_expressionOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_typeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Expression_Variable :: (T_Range) ->
                           (T_Name) ->
                           (T_Expression)
sem_Expression_Variable (range_) (name_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Expression)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            -- "./Pretty.inc.ag"(line 808, column 9)
            (_text@_) =
                _nameItext
            -- self rule
            (_self@_) =
                Expression_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Expression_Wildcard :: (T_Range) ->
                           (T_Expression)
sem_Expression_Wildcard (range_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Expression)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            -- self rule
            (_self@_) =
                Expression_Wildcard _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOtext@_) =
                _rangeItext
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
-- Expressions -------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : [Doc]

-}
{-
   local variables for Expressions.Cons:
      self

-}
{-
   local variables for Expressions.Nil:
      self

-}
-- semantic domain
type T_Expressions = (PPMode) ->
                     ( (Expressions),([Doc]))
-- cata
sem_Expressions :: (Expressions) ->
                   (T_Expressions)
sem_Expressions (list) =
    (foldr (sem_Expressions_Cons) (sem_Expressions_Nil) ((map sem_Expression list)))
sem_Expressions_Cons :: (T_Expression) ->
                        (T_Expressions) ->
                        (T_Expressions)
sem_Expressions_Cons (hd_) (tl_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Expressions)
            _lhsOtext :: ([Doc])
            _hdIself :: (Expression)
            _hdItext :: (Doc)
            _hdOppMode :: (PPMode)
            _tlIself :: (Expressions)
            _tlItext :: ([Doc])
            _tlOppMode :: (PPMode)
            ( _hdIself,_hdItext) =
                (hd_ (_hdOppMode))
            ( _tlIself,_tlItext) =
                (tl_ (_tlOppMode))
            -- use rule
            (_lhsOtext@_) =
                _hdItext : _tlItext
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_hdOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_tlOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Expressions_Nil :: (T_Expressions)
sem_Expressions_Nil  =
    \ _lhsIppMode ->
        let _lhsOself :: (Expressions)
            _lhsOtext :: ([Doc])
            -- use rule
            (_lhsOtext@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOself,_lhsOtext)
-- FieldDeclaration --------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for FieldDeclaration.FieldDeclaration:
      text
      self

-}
-- semantic domain
type T_FieldDeclaration = (PPMode) ->
                          ( (FieldDeclaration),(Doc))
-- cata
sem_FieldDeclaration :: (FieldDeclaration) ->
                        (T_FieldDeclaration)
sem_FieldDeclaration ((FieldDeclaration_FieldDeclaration (_range) (_names) (_type))) =
    (sem_FieldDeclaration_FieldDeclaration ((sem_Range (_range))) ((sem_Names (_names))) ((sem_AnnotatedType (_type))))
sem_FieldDeclaration_FieldDeclaration :: (T_Range) ->
                                         (T_Names) ->
                                         (T_AnnotatedType) ->
                                         (T_FieldDeclaration)
sem_FieldDeclaration_FieldDeclaration (range_) (names_) (type_) =
    \ _lhsIppMode ->
        let _lhsOself :: (FieldDeclaration)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _namesIisIdentifier :: ([Bool])
            _namesIisOperator :: ([Bool])
            _namesIisSpecial :: ([Bool])
            _namesIself :: (Names)
            _namesItext :: ([Doc])
            _namesOppMode :: (PPMode)
            _typeIself :: (AnnotatedType)
            _typeItext :: (Doc)
            _typeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _namesIisIdentifier,_namesIisOperator,_namesIisSpecial,_namesIself,_namesItext) =
                (names_ (_namesOppMode))
            ( _typeIself,_typeItext) =
                (type_ (_typeOppMode))
            -- "./Pretty.inc.ag"(line 787, column 9)
            (_namesOppMode@_) =
                _lhsIppMode { unqualified = True }
            -- "./Pretty.inc.ag"(line 785, column 9)
            (_text@_) =
                hang 2 $
                  commas _namesItext </> text "::" <+> _typeItext
            -- self rule
            (_self@_) =
                FieldDeclaration_FieldDeclaration _rangeIself _namesIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_typeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
-- FieldDeclarations -------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : [Doc]

-}
{-
   local variables for FieldDeclarations.Cons:
      self

-}
{-
   local variables for FieldDeclarations.Nil:
      self

-}
-- semantic domain
type T_FieldDeclarations = (PPMode) ->
                           ( (FieldDeclarations),([Doc]))
-- cata
sem_FieldDeclarations :: (FieldDeclarations) ->
                         (T_FieldDeclarations)
sem_FieldDeclarations (list) =
    (foldr (sem_FieldDeclarations_Cons) (sem_FieldDeclarations_Nil) ((map sem_FieldDeclaration list)))
sem_FieldDeclarations_Cons :: (T_FieldDeclaration) ->
                              (T_FieldDeclarations) ->
                              (T_FieldDeclarations)
sem_FieldDeclarations_Cons (hd_) (tl_) =
    \ _lhsIppMode ->
        let _lhsOself :: (FieldDeclarations)
            _lhsOtext :: ([Doc])
            _hdIself :: (FieldDeclaration)
            _hdItext :: (Doc)
            _hdOppMode :: (PPMode)
            _tlIself :: (FieldDeclarations)
            _tlItext :: ([Doc])
            _tlOppMode :: (PPMode)
            ( _hdIself,_hdItext) =
                (hd_ (_hdOppMode))
            ( _tlIself,_tlItext) =
                (tl_ (_tlOppMode))
            -- use rule
            (_lhsOtext@_) =
                _hdItext : _tlItext
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_hdOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_tlOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_FieldDeclarations_Nil :: (T_FieldDeclarations)
sem_FieldDeclarations_Nil  =
    \ _lhsIppMode ->
        let _lhsOself :: (FieldDeclarations)
            _lhsOtext :: ([Doc])
            -- use rule
            (_lhsOtext@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOself,_lhsOtext)
-- Fixity ------------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for Fixity.Infix:
      text
      self

-}
{-
   local variables for Fixity.Infixl:
      text
      self

-}
{-
   local variables for Fixity.Infixr:
      text
      self

-}
-- semantic domain
type T_Fixity = (PPMode) ->
                ( (Fixity),(Doc))
-- cata
sem_Fixity :: (Fixity) ->
              (T_Fixity)
sem_Fixity ((Fixity_Infix (_range))) =
    (sem_Fixity_Infix ((sem_Range (_range))))
sem_Fixity ((Fixity_Infixl (_range))) =
    (sem_Fixity_Infixl ((sem_Range (_range))))
sem_Fixity ((Fixity_Infixr (_range))) =
    (sem_Fixity_Infixr ((sem_Range (_range))))
sem_Fixity_Infix :: (T_Range) ->
                    (T_Fixity)
sem_Fixity_Infix (range_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Fixity)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            -- "./Pretty.inc.ag"(line 556, column 9)
            (_text@_) =
                text "infix "
            -- self rule
            (_self@_) =
                Fixity_Infix _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Fixity_Infixl :: (T_Range) ->
                     (T_Fixity)
sem_Fixity_Infixl (range_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Fixity)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            -- "./Pretty.inc.ag"(line 552, column 9)
            (_text@_) =
                text "infixl"
            -- self rule
            (_self@_) =
                Fixity_Infixl _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Fixity_Infixr :: (T_Range) ->
                     (T_Fixity)
sem_Fixity_Infixr (range_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Fixity)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            -- "./Pretty.inc.ag"(line 554, column 9)
            (_text@_) =
                text "infixr"
            -- self rule
            (_self@_) =
                Fixity_Infixr _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
-- FunctionBinding ---------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for FunctionBinding.FunctionBinding:
      text
      self

-}
-- semantic domain
type T_FunctionBinding = (PPMode) ->
                         ( (FunctionBinding),(Doc))
-- cata
sem_FunctionBinding :: (FunctionBinding) ->
                       (T_FunctionBinding)
sem_FunctionBinding ((FunctionBinding_FunctionBinding (_range) (_lefthandside) (_righthandside))) =
    (sem_FunctionBinding_FunctionBinding ((sem_Range (_range))) ((sem_LeftHandSide (_lefthandside))) ((sem_RightHandSide (_righthandside))))
sem_FunctionBinding_FunctionBinding :: (T_Range) ->
                                       (T_LeftHandSide) ->
                                       (T_RightHandSide) ->
                                       (T_FunctionBinding)
sem_FunctionBinding_FunctionBinding (range_) (lefthandside_) (righthandside_) =
    \ _lhsIppMode ->
        let _lhsOself :: (FunctionBinding)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _lefthandsideIself :: (LeftHandSide)
            _lefthandsideItext :: (Doc)
            _lefthandsideOppMode :: (PPMode)
            _righthandsideIself :: (RightHandSide)
            _righthandsideItext :: ( Doc -> Doc  )
            _righthandsideOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _lefthandsideIself,_lefthandsideItext) =
                (lefthandside_ (_lefthandsideOppMode))
            ( _righthandsideIself,_righthandsideItext) =
                (righthandside_ (_righthandsideOppMode))
            -- "./Pretty.inc.ag"(line 937, column 9)
            (_text@_) =
                hang 2 $ _lefthandsideItext </> _righthandsideItext (text "=")
            -- self rule
            (_self@_) =
                FunctionBinding_FunctionBinding _rangeIself _lefthandsideIself _righthandsideIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_lefthandsideOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_righthandsideOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
-- FunctionBindings --------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : [Doc]

-}
{-
   local variables for FunctionBindings.Cons:
      self

-}
{-
   local variables for FunctionBindings.Nil:
      self

-}
-- semantic domain
type T_FunctionBindings = (PPMode) ->
                          ( (FunctionBindings),([Doc]))
-- cata
sem_FunctionBindings :: (FunctionBindings) ->
                        (T_FunctionBindings)
sem_FunctionBindings (list) =
    (foldr (sem_FunctionBindings_Cons) (sem_FunctionBindings_Nil) ((map sem_FunctionBinding list)))
sem_FunctionBindings_Cons :: (T_FunctionBinding) ->
                             (T_FunctionBindings) ->
                             (T_FunctionBindings)
sem_FunctionBindings_Cons (hd_) (tl_) =
    \ _lhsIppMode ->
        let _lhsOself :: (FunctionBindings)
            _lhsOtext :: ([Doc])
            _hdIself :: (FunctionBinding)
            _hdItext :: (Doc)
            _hdOppMode :: (PPMode)
            _tlIself :: (FunctionBindings)
            _tlItext :: ([Doc])
            _tlOppMode :: (PPMode)
            ( _hdIself,_hdItext) =
                (hd_ (_hdOppMode))
            ( _tlIself,_tlItext) =
                (tl_ (_tlOppMode))
            -- use rule
            (_lhsOtext@_) =
                _hdItext : _tlItext
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_hdOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_tlOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_FunctionBindings_Nil :: (T_FunctionBindings)
sem_FunctionBindings_Nil  =
    \ _lhsIppMode ->
        let _lhsOself :: (FunctionBindings)
            _lhsOtext :: ([Doc])
            -- use rule
            (_lhsOtext@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOself,_lhsOtext)
-- GuardedExpression -------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 :  Doc -> Doc  

-}
{-
   local variables for GuardedExpression.GuardedExpression:
      text
      self

-}
-- semantic domain
type T_GuardedExpression = (PPMode) ->
                           ( (GuardedExpression),( Doc -> Doc  ))
-- cata
sem_GuardedExpression :: (GuardedExpression) ->
                         (T_GuardedExpression)
sem_GuardedExpression ((GuardedExpression_GuardedExpression (_range) (_guard) (_expression))) =
    (sem_GuardedExpression_GuardedExpression ((sem_Range (_range))) ((sem_Expression (_guard))) ((sem_Expression (_expression))))
sem_GuardedExpression_GuardedExpression :: (T_Range) ->
                                           (T_Expression) ->
                                           (T_Expression) ->
                                           (T_GuardedExpression)
sem_GuardedExpression_GuardedExpression (range_) (guard_) (expression_) =
    \ _lhsIppMode ->
        let _lhsOself :: (GuardedExpression)
            _lhsOtext :: ( Doc -> Doc  )
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _guardIself :: (Expression)
            _guardItext :: (Doc)
            _guardOppMode :: (PPMode)
            _expressionIself :: (Expression)
            _expressionItext :: (Doc)
            _expressionOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _guardIself,_guardItext) =
                (guard_ (_guardOppMode))
            ( _expressionIself,_expressionItext) =
                (expression_ (_expressionOppMode))
            -- "./Pretty.inc.ag"(line 925, column 9)
            (_text@_) =
                \ assign -> hang 2 $ text "|" <+> _guardItext </> assign <+> _expressionItext
            -- self rule
            (_self@_) =
                GuardedExpression_GuardedExpression _rangeIself _guardIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_guardOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_expressionOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
-- GuardedExpressions ------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 :  [ Doc -> Doc ] 

-}
{-
   local variables for GuardedExpressions.Cons:
      self

-}
{-
   local variables for GuardedExpressions.Nil:
      self

-}
-- semantic domain
type T_GuardedExpressions = (PPMode) ->
                            ( (GuardedExpressions),( [ Doc -> Doc ] ))
-- cata
sem_GuardedExpressions :: (GuardedExpressions) ->
                          (T_GuardedExpressions)
sem_GuardedExpressions (list) =
    (foldr (sem_GuardedExpressions_Cons) (sem_GuardedExpressions_Nil) ((map sem_GuardedExpression list)))
sem_GuardedExpressions_Cons :: (T_GuardedExpression) ->
                               (T_GuardedExpressions) ->
                               (T_GuardedExpressions)
sem_GuardedExpressions_Cons (hd_) (tl_) =
    \ _lhsIppMode ->
        let _lhsOself :: (GuardedExpressions)
            _lhsOtext :: ( [ Doc -> Doc ] )
            _hdIself :: (GuardedExpression)
            _hdItext :: ( Doc -> Doc  )
            _hdOppMode :: (PPMode)
            _tlIself :: (GuardedExpressions)
            _tlItext :: ( [ Doc -> Doc ] )
            _tlOppMode :: (PPMode)
            ( _hdIself,_hdItext) =
                (hd_ (_hdOppMode))
            ( _tlIself,_tlItext) =
                (tl_ (_tlOppMode))
            -- use rule
            (_lhsOtext@_) =
                _hdItext : _tlItext
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_hdOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_tlOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_GuardedExpressions_Nil :: (T_GuardedExpressions)
sem_GuardedExpressions_Nil  =
    \ _lhsIppMode ->
        let _lhsOself :: (GuardedExpressions)
            _lhsOtext :: ( [ Doc -> Doc ] )
            -- use rule
            (_lhsOtext@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOself,_lhsOtext)
-- Import ------------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for Import.TypeOrClass:
      ppMode
      text
      self

-}
{-
   local variables for Import.TypeOrClassComplete:
      ppMode
      text
      self

-}
{-
   local variables for Import.Variable:
      ppMode
      text
      self

-}
-- semantic domain
type T_Import = (PPMode) ->
                ( (Import),(Doc))
-- cata
sem_Import :: (Import) ->
              (T_Import)
sem_Import ((Import_TypeOrClass (_range) (_name) (_names))) =
    (sem_Import_TypeOrClass ((sem_Range (_range))) ((sem_Name (_name))) ((sem_MaybeNames (_names))))
sem_Import ((Import_TypeOrClassComplete (_range) (_name))) =
    (sem_Import_TypeOrClassComplete ((sem_Range (_range))) ((sem_Name (_name))))
sem_Import ((Import_Variable (_range) (_name))) =
    (sem_Import_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Import_TypeOrClass :: (T_Range) ->
                          (T_Name) ->
                          (T_MaybeNames) ->
                          (T_Import)
sem_Import_TypeOrClass (range_) (name_) (names_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Import)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _namesIself :: (MaybeNames)
            _namesItext :: ( Maybe [Doc] )
            _namesOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _namesIself,_namesItext) =
                (names_ (_namesOppMode))
            -- "./Pretty.inc.ag"(line 399, column 9)
            (_ppMode@_) =
                _lhsIppMode
                  { unqualified = True
                  , nosymbol    = True
                  }
            -- "./Pretty.inc.ag"(line 398, column 9)
            (_text@_) =
                _nameItext <> maybe emptyPP uuTuple _namesItext
            -- self rule
            (_self@_) =
                Import_TypeOrClass _rangeIself _nameIself _namesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (from local)
            (_rangeOppMode@_) =
                _ppMode
            -- copy rule (from local)
            (_nameOppMode@_) =
                _ppMode
            -- copy rule (from local)
            (_namesOppMode@_) =
                _ppMode
        in  ( _lhsOself,_lhsOtext)
sem_Import_TypeOrClassComplete :: (T_Range) ->
                                  (T_Name) ->
                                  (T_Import)
sem_Import_TypeOrClassComplete (range_) (name_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Import)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            -- "./Pretty.inc.ag"(line 406, column 9)
            (_ppMode@_) =
                _lhsIppMode
                  { unqualified = True
                  , nosymbol    = True
                  }
            -- "./Pretty.inc.ag"(line 405, column 9)
            (_text@_) =
                _nameItext <> text "(..)"
            -- self rule
            (_self@_) =
                Import_TypeOrClassComplete _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (from local)
            (_rangeOppMode@_) =
                _ppMode
            -- copy rule (from local)
            (_nameOppMode@_) =
                _ppMode
        in  ( _lhsOself,_lhsOtext)
sem_Import_Variable :: (T_Range) ->
                       (T_Name) ->
                       (T_Import)
sem_Import_Variable (range_) (name_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Import)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            -- "./Pretty.inc.ag"(line 392, column 9)
            (_ppMode@_) =
                _lhsIppMode
                  { unqualified = True
                  , nosymbol    = True
                  }
            -- "./Pretty.inc.ag"(line 391, column 9)
            (_text@_) =
                _nameItext
            -- self rule
            (_self@_) =
                Import_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (from local)
            (_rangeOppMode@_) =
                _ppMode
            -- copy rule (from local)
            (_nameOppMode@_) =
                _ppMode
        in  ( _lhsOself,_lhsOtext)
-- ImportDeclaration -------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for ImportDeclaration.Empty:
      text
      self

-}
{-
   local variables for ImportDeclaration.Import:
      asDoc
      text
      self

-}
-- semantic domain
type T_ImportDeclaration = (PPMode) ->
                           ( (ImportDeclaration),(Doc))
-- cata
sem_ImportDeclaration :: (ImportDeclaration) ->
                         (T_ImportDeclaration)
sem_ImportDeclaration ((ImportDeclaration_Empty (_range))) =
    (sem_ImportDeclaration_Empty ((sem_Range (_range))))
sem_ImportDeclaration ((ImportDeclaration_Import (_range) (_qualified) (_name) (_asname) (_importspecification))) =
    (sem_ImportDeclaration_Import ((sem_Range (_range))) (_qualified) ((sem_ModuleName (_name))) ((sem_MaybeModuleName (_asname))) ((sem_MaybeImportSpecification (_importspecification))))
sem_ImportDeclaration_Empty :: (T_Range) ->
                               (T_ImportDeclaration)
sem_ImportDeclaration_Empty (range_) =
    \ _lhsIppMode ->
        let _lhsOself :: (ImportDeclaration)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            -- "./Pretty.inc.ag"(line 376, column 9)
            (_text@_) =
                emptyPP
            -- self rule
            (_self@_) =
                ImportDeclaration_Empty _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_ImportDeclaration_Import :: (T_Range) ->
                                (Bool) ->
                                (T_ModuleName) ->
                                (T_MaybeModuleName) ->
                                (T_MaybeImportSpecification) ->
                                (T_ImportDeclaration)
sem_ImportDeclaration_Import (range_) (qualified_) (name_) (asname_) (importspecification_) =
    \ _lhsIppMode ->
        let _lhsOself :: (ImportDeclaration)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIself :: (ModuleName)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _asnameIself :: (MaybeModuleName)
            _asnameItext :: ( Maybe Doc )
            _asnameOppMode :: (PPMode)
            _importspecificationIself :: (MaybeImportSpecification)
            _importspecificationItext :: ( Maybe Doc )
            _importspecificationOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _asnameIself,_asnameItext) =
                (asname_ (_asnameOppMode))
            ( _importspecificationIself,_importspecificationItext) =
                (importspecification_ (_importspecificationOppMode))
            -- "./Pretty.inc.ag"(line 373, column 9)
            (_asDoc@_) =
                maybe emptyPP (\ x -> emptyPP <+> text "as" <+> x) _asnameItext
            -- "./Pretty.inc.ag"(line 368, column 9)
            (_text@_) =
                text "import"
                  <+> (if qualified_ then (text "qualified" <+>) else id) _nameItext
                  <>  _asDoc
                  <+> maybe emptyPP id _importspecificationItext
            -- self rule
            (_self@_) =
                ImportDeclaration_Import _rangeIself qualified_ _nameIself _asnameIself _importspecificationIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_asnameOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_importspecificationOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
-- ImportDeclarations ------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : [Doc]

-}
{-
   local variables for ImportDeclarations.Cons:
      self

-}
{-
   local variables for ImportDeclarations.Nil:
      self

-}
-- semantic domain
type T_ImportDeclarations = (PPMode) ->
                            ( (ImportDeclarations),([Doc]))
-- cata
sem_ImportDeclarations :: (ImportDeclarations) ->
                          (T_ImportDeclarations)
sem_ImportDeclarations (list) =
    (foldr (sem_ImportDeclarations_Cons) (sem_ImportDeclarations_Nil) ((map sem_ImportDeclaration list)))
sem_ImportDeclarations_Cons :: (T_ImportDeclaration) ->
                               (T_ImportDeclarations) ->
                               (T_ImportDeclarations)
sem_ImportDeclarations_Cons (hd_) (tl_) =
    \ _lhsIppMode ->
        let _lhsOself :: (ImportDeclarations)
            _lhsOtext :: ([Doc])
            _hdIself :: (ImportDeclaration)
            _hdItext :: (Doc)
            _hdOppMode :: (PPMode)
            _tlIself :: (ImportDeclarations)
            _tlItext :: ([Doc])
            _tlOppMode :: (PPMode)
            ( _hdIself,_hdItext) =
                (hd_ (_hdOppMode))
            ( _tlIself,_tlItext) =
                (tl_ (_tlOppMode))
            -- use rule
            (_lhsOtext@_) =
                _hdItext : _tlItext
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_hdOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_tlOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_ImportDeclarations_Nil :: (T_ImportDeclarations)
sem_ImportDeclarations_Nil  =
    \ _lhsIppMode ->
        let _lhsOself :: (ImportDeclarations)
            _lhsOtext :: ([Doc])
            -- use rule
            (_lhsOtext@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOself,_lhsOtext)
-- ImportSpecification -----------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for ImportSpecification.Import:
      text
      self

-}
-- semantic domain
type T_ImportSpecification = (PPMode) ->
                             ( (ImportSpecification),(Doc))
-- cata
sem_ImportSpecification :: (ImportSpecification) ->
                           (T_ImportSpecification)
sem_ImportSpecification ((ImportSpecification_Import (_range) (_hiding) (_imports))) =
    (sem_ImportSpecification_Import ((sem_Range (_range))) (_hiding) ((sem_Imports (_imports))))
sem_ImportSpecification_Import :: (T_Range) ->
                                  (Bool) ->
                                  (T_Imports) ->
                                  (T_ImportSpecification)
sem_ImportSpecification_Import (range_) (hiding_) (imports_) =
    \ _lhsIppMode ->
        let _lhsOself :: (ImportSpecification)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _importsIself :: (Imports)
            _importsItext :: ([Doc])
            _importsOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _importsIself,_importsItext) =
                (imports_ (_importsOppMode))
            -- "./Pretty.inc.ag"(line 386, column 9)
            (_text@_) =
                (if hiding_ then (text "hiding" <+>) else id)
                   (uuTuple _importsItext)
            -- self rule
            (_self@_) =
                ImportSpecification_Import _rangeIself hiding_ _importsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_importsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
-- Imports -----------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : [Doc]

-}
{-
   local variables for Imports.Cons:
      self

-}
{-
   local variables for Imports.Nil:
      self

-}
-- semantic domain
type T_Imports = (PPMode) ->
                 ( (Imports),([Doc]))
-- cata
sem_Imports :: (Imports) ->
               (T_Imports)
sem_Imports (list) =
    (foldr (sem_Imports_Cons) (sem_Imports_Nil) ((map sem_Import list)))
sem_Imports_Cons :: (T_Import) ->
                    (T_Imports) ->
                    (T_Imports)
sem_Imports_Cons (hd_) (tl_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Imports)
            _lhsOtext :: ([Doc])
            _hdIself :: (Import)
            _hdItext :: (Doc)
            _hdOppMode :: (PPMode)
            _tlIself :: (Imports)
            _tlItext :: ([Doc])
            _tlOppMode :: (PPMode)
            ( _hdIself,_hdItext) =
                (hd_ (_hdOppMode))
            ( _tlIself,_tlItext) =
                (tl_ (_tlOppMode))
            -- use rule
            (_lhsOtext@_) =
                _hdItext : _tlItext
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_hdOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_tlOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Imports_Nil :: (T_Imports)
sem_Imports_Nil  =
    \ _lhsIppMode ->
        let _lhsOself :: (Imports)
            _lhsOtext :: ([Doc])
            -- use rule
            (_lhsOtext@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOself,_lhsOtext)
-- InterfaceDeclaration ----------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for InterfaceDeclaration.Abstract:
      text
      self

-}
{-
   local variables for InterfaceDeclaration.Binding:
      text
      self

-}
{-
   local variables for InterfaceDeclaration.Consig:
      text
      self

-}
{-
   local variables for InterfaceDeclaration.Declarations:
      text
      self

-}
{-
   local variables for InterfaceDeclaration.Dependency:
      text
      self

-}
{-
   local variables for InterfaceDeclaration.Import:
      text
      self

-}
{-
   local variables for InterfaceDeclaration.SetModule:
      text
      self

-}
-- semantic domain
type T_InterfaceDeclaration = (PPMode) ->
                              ( (InterfaceDeclaration),(Doc))
-- cata
sem_InterfaceDeclaration :: (InterfaceDeclaration) ->
                            (T_InterfaceDeclaration)
sem_InterfaceDeclaration ((InterfaceDeclaration_Abstract (_range) (_name) (_constructors) (_types) (_kind))) =
    (sem_InterfaceDeclaration_Abstract ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Names (_constructors))) ((sem_Types (_types))) ((sem_Kind (_kind))))
sem_InterfaceDeclaration ((InterfaceDeclaration_Binding (_range) (_name))) =
    (sem_InterfaceDeclaration_Binding ((sem_Range (_range))) ((sem_Name (_name))))
sem_InterfaceDeclaration ((InterfaceDeclaration_Consig (_range) (_typelevel) (_name) (_types))) =
    (sem_InterfaceDeclaration_Consig ((sem_Range (_range))) (_typelevel) ((sem_Name (_name))) ((sem_TypeArguments (_types))))
sem_InterfaceDeclaration ((InterfaceDeclaration_Declarations (_range) (_declarations))) =
    (sem_InterfaceDeclaration_Declarations ((sem_Range (_range))) ((sem_Declarations (_declarations))))
sem_InterfaceDeclaration ((InterfaceDeclaration_Dependency (_range) (_name) (_kind) (_bindings))) =
    (sem_InterfaceDeclaration_Dependency ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Kind (_kind))) ((sem_DependencyBindings (_bindings))))
sem_InterfaceDeclaration ((InterfaceDeclaration_Import (_range) (_module))) =
    (sem_InterfaceDeclaration_Import ((sem_Range (_range))) ((sem_ModuleName (_module))))
sem_InterfaceDeclaration ((InterfaceDeclaration_SetModule (_range) (_module) (_declarations))) =
    (sem_InterfaceDeclaration_SetModule ((sem_Range (_range))) ((sem_ModuleName (_module))) ((sem_InterfaceDeclarations (_declarations))))
sem_InterfaceDeclaration_Abstract :: (T_Range) ->
                                     (T_Name) ->
                                     (T_Names) ->
                                     (T_Types) ->
                                     (T_Kind) ->
                                     (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Abstract (range_) (name_) (constructors_) (types_) (kind_) =
    \ _lhsIppMode ->
        let _lhsOself :: (InterfaceDeclaration)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _constructorsIisIdentifier :: ([Bool])
            _constructorsIisOperator :: ([Bool])
            _constructorsIisSpecial :: ([Bool])
            _constructorsIself :: (Names)
            _constructorsItext :: ([Doc])
            _constructorsOppMode :: (PPMode)
            _typesIself :: (Types)
            _typesItext :: ([Doc])
            _typesOppMode :: (PPMode)
            _kindIneedsparens :: (Bool)
            _kindIself :: (Kind)
            _kindItext :: (Doc)
            _kindOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _constructorsIisIdentifier,_constructorsIisOperator,_constructorsIisSpecial,_constructorsIself,_constructorsItext) =
                (constructors_ (_constructorsOppMode))
            ( _typesIself,_typesItext) =
                (types_ (_typesOppMode))
            ( _kindIneedsparens,_kindIself,_kindItext) =
                (kind_ (_kindOppMode))
            -- "./Pretty.inc.ag"(line 259, column 9)
            (_constructorsOppMode@_) =
                _lhsIppMode { unqualified = True }
            -- "./Pretty.inc.ag"(line 258, column 9)
            (_nameOppMode@_) =
                _lhsIppMode { unqualified = True, nosymbol = True }
            -- "./Pretty.inc.ag"(line 241, column 9)
            (_text@_) =
                group . hang 4 $
                  text "__ghi_abstract"
                    <+> _nameItext
                    <+> text "::"
                    <+> _kindItext
                    <$$> uuSep
                           (space <> text "=" <> space)
                           emptyPP
                           (space <> text "|" <> space)
                           (zipWith
                              (\l r -> l
                                 <+> text "::"
                                 <+> r
                              )
                            _constructorsItext
                            _typesItext
                           )
            -- self rule
            (_self@_) =
                InterfaceDeclaration_Abstract _rangeIself _nameIself _constructorsIself _typesIself _kindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_typesOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_kindOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_InterfaceDeclaration_Binding :: (T_Range) ->
                                    (T_Name) ->
                                    (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Binding (range_) (name_) =
    \ _lhsIppMode ->
        let _lhsOself :: (InterfaceDeclaration)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            -- "./Pretty.inc.ag"(line 271, column 9)
            (_nameOppMode@_) =
                _lhsIppMode { unqualified = True }
            -- "./Pretty.inc.ag"(line 270, column 9)
            (_text@_) =
                text "__ghi_binding" <+> _nameItext
            -- self rule
            (_self@_) =
                InterfaceDeclaration_Binding _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_InterfaceDeclaration_Consig :: (T_Range) ->
                                   (Bool) ->
                                   (T_Name) ->
                                   (T_TypeArguments) ->
                                   (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Consig (range_) (typelevel_) (name_) (types_) =
    \ _lhsIppMode ->
        let _lhsOself :: (InterfaceDeclaration)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _typesIself :: (TypeArguments)
            _typesItext :: ([Doc])
            _typesOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _typesIself,_typesItext) =
                (types_ (_typesOppMode))
            -- "./Pretty.inc.ag"(line 267, column 9)
            (_nameOppMode@_) =
                _lhsIppMode { unqualified = True }
            -- "./Pretty.inc.ag"(line 262, column 9)
            (_text@_) =
                group . hang 4 $
                  text "__ghi_consig"
                    <+> _nameItext
                    <+> text "="
                    <+> uuList _typesItext
            -- self rule
            (_self@_) =
                InterfaceDeclaration_Consig _rangeIself typelevel_ _nameIself _typesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_typesOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_InterfaceDeclaration_Declarations :: (T_Range) ->
                                         (T_Declarations) ->
                                         (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Declarations (range_) (declarations_) =
    \ _lhsIppMode ->
        let _lhsOself :: (InterfaceDeclaration)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _declarationsIself :: (Declarations)
            _declarationsItext :: ([Doc])
            _declarationsOkind :: (Maybe Kind)
            _declarationsOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _declarationsIself,_declarationsItext) =
                (declarations_ (_declarationsOkind) (_declarationsOppMode))
            -- "./Pretty.inc.ag"(line 238, column 9)
            (_declarationsOkind@_) =
                Nothing
            -- "./Pretty.inc.ag"(line 237, column 9)
            (_text@_) =
                vcat $ _declarationsItext
            -- self rule
            (_self@_) =
                InterfaceDeclaration_Declarations _rangeIself _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_declarationsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_InterfaceDeclaration_Dependency :: (T_Range) ->
                                       (T_Name) ->
                                       (T_Kind) ->
                                       (T_DependencyBindings) ->
                                       (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Dependency (range_) (name_) (kind_) (bindings_) =
    \ _lhsIppMode ->
        let _lhsOself :: (InterfaceDeclaration)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _kindIneedsparens :: (Bool)
            _kindIself :: (Kind)
            _kindItext :: (Doc)
            _kindOppMode :: (PPMode)
            _bindingsIself :: (DependencyBindings)
            _bindingsItext :: ([Doc])
            _bindingsOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _kindIneedsparens,_kindIself,_kindItext) =
                (kind_ (_kindOppMode))
            ( _bindingsIself,_bindingsItext) =
                (bindings_ (_bindingsOppMode))
            -- "./Pretty.inc.ag"(line 284, column 9)
            (_text@_) =
                text "__ghi_dependency"
                  <+> _nameItext
                  <+> text "{["
                  <+> _kindItext
                  <+> text "]}"
                  <+> text "<-"
                  <+> align (sep _bindingsItext)
            -- self rule
            (_self@_) =
                InterfaceDeclaration_Dependency _rangeIself _nameIself _kindIself _bindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_kindOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_bindingsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_InterfaceDeclaration_Import :: (T_Range) ->
                                   (T_ModuleName) ->
                                   (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Import (range_) (module_) =
    \ _lhsIppMode ->
        let _lhsOself :: (InterfaceDeclaration)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _moduleIself :: (ModuleName)
            _moduleItext :: (Doc)
            _moduleOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _moduleIself,_moduleItext) =
                (module_ (_moduleOppMode))
            -- "./Pretty.inc.ag"(line 281, column 9)
            (_text@_) =
                text "__ghi_import" <+> _moduleItext
            -- self rule
            (_self@_) =
                InterfaceDeclaration_Import _rangeIself _moduleIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_moduleOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_InterfaceDeclaration_SetModule :: (T_Range) ->
                                      (T_ModuleName) ->
                                      (T_InterfaceDeclarations) ->
                                      (T_InterfaceDeclaration)
sem_InterfaceDeclaration_SetModule (range_) (module_) (declarations_) =
    \ _lhsIppMode ->
        let _lhsOself :: (InterfaceDeclaration)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _moduleIself :: (ModuleName)
            _moduleItext :: (Doc)
            _moduleOppMode :: (PPMode)
            _declarationsIself :: (InterfaceDeclarations)
            _declarationsItext :: ([Doc])
            _declarationsOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _moduleIself,_moduleItext) =
                (module_ (_moduleOppMode))
            ( _declarationsIself,_declarationsItext) =
                (declarations_ (_declarationsOppMode))
            -- "./Pretty.inc.ag"(line 274, column 9)
            (_text@_) =
                group . hang 4 $
                  text "__ghi_set_module"
                    <+> _moduleItext
                    <+> text "where"
                   <$$> uuDecls _declarationsItext
            -- self rule
            (_self@_) =
                InterfaceDeclaration_SetModule _rangeIself _moduleIself _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_moduleOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_declarationsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
-- InterfaceDeclarations ---------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : [Doc]

-}
{-
   local variables for InterfaceDeclarations.Cons:
      self

-}
{-
   local variables for InterfaceDeclarations.Nil:
      self

-}
-- semantic domain
type T_InterfaceDeclarations = (PPMode) ->
                               ( (InterfaceDeclarations),([Doc]))
-- cata
sem_InterfaceDeclarations :: (InterfaceDeclarations) ->
                             (T_InterfaceDeclarations)
sem_InterfaceDeclarations (list) =
    (foldr (sem_InterfaceDeclarations_Cons) (sem_InterfaceDeclarations_Nil) ((map sem_InterfaceDeclaration list)))
sem_InterfaceDeclarations_Cons :: (T_InterfaceDeclaration) ->
                                  (T_InterfaceDeclarations) ->
                                  (T_InterfaceDeclarations)
sem_InterfaceDeclarations_Cons (hd_) (tl_) =
    \ _lhsIppMode ->
        let _lhsOself :: (InterfaceDeclarations)
            _lhsOtext :: ([Doc])
            _hdIself :: (InterfaceDeclaration)
            _hdItext :: (Doc)
            _hdOppMode :: (PPMode)
            _tlIself :: (InterfaceDeclarations)
            _tlItext :: ([Doc])
            _tlOppMode :: (PPMode)
            ( _hdIself,_hdItext) =
                (hd_ (_hdOppMode))
            ( _tlIself,_tlItext) =
                (tl_ (_tlOppMode))
            -- use rule
            (_lhsOtext@_) =
                _hdItext : _tlItext
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_hdOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_tlOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_InterfaceDeclarations_Nil :: (T_InterfaceDeclarations)
sem_InterfaceDeclarations_Nil  =
    \ _lhsIppMode ->
        let _lhsOself :: (InterfaceDeclarations)
            _lhsOtext :: ([Doc])
            -- use rule
            (_lhsOtext@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOself,_lhsOtext)
-- Kind --------------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      needsparens          : Bool
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for Kind.Arrow:
      text
      self

-}
{-
   local variables for Kind.Error:
      text
      self

-}
{-
   local variables for Kind.Parenthesized:
      self

-}
{-
   local variables for Kind.Star:
      text
      self

-}
{-
   local variables for Kind.Variable:
      ppMode
      text
      self

-}
-- semantic domain
type T_Kind = (PPMode) ->
              ( (Bool),(Kind),(Doc))
-- cata
sem_Kind :: (Kind) ->
            (T_Kind)
sem_Kind ((Kind_Arrow (_range) (_leftKind) (_rightKind))) =
    (sem_Kind_Arrow ((sem_Range (_range))) ((sem_Kind (_leftKind))) ((sem_Kind (_rightKind))))
sem_Kind ((Kind_Error )) =
    (sem_Kind_Error )
sem_Kind ((Kind_Parenthesized (_range) (_kind))) =
    (sem_Kind_Parenthesized ((sem_Range (_range))) ((sem_Kind (_kind))))
sem_Kind ((Kind_Star (_range))) =
    (sem_Kind_Star ((sem_Range (_range))))
sem_Kind ((Kind_Variable (_range) (_name))) =
    (sem_Kind_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Kind_Arrow :: (T_Range) ->
                  (T_Kind) ->
                  (T_Kind) ->
                  (T_Kind)
sem_Kind_Arrow (range_) (leftKind_) (rightKind_) =
    \ _lhsIppMode ->
        let _lhsOneedsparens :: (Bool)
            _lhsOself :: (Kind)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _leftKindIneedsparens :: (Bool)
            _leftKindIself :: (Kind)
            _leftKindItext :: (Doc)
            _leftKindOppMode :: (PPMode)
            _rightKindIneedsparens :: (Bool)
            _rightKindIself :: (Kind)
            _rightKindItext :: (Doc)
            _rightKindOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _leftKindIneedsparens,_leftKindIself,_leftKindItext) =
                (leftKind_ (_leftKindOppMode))
            ( _rightKindIneedsparens,_rightKindIself,_rightKindItext) =
                (rightKind_ (_rightKindOppMode))
            -- "./Pretty.inc.ag"(line 679, column 9)
            (_lhsOneedsparens@_) =
                True
            -- "./Pretty.inc.ag"(line 674, column 9)
            (_text@_) =
                (if _leftKindIneedsparens
                 then parens
                 else id
                ) _leftKindItext
                <+> text "->" <+> _rightKindItext
            -- self rule
            (_self@_) =
                Kind_Arrow _rangeIself _leftKindIself _rightKindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_leftKindOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_rightKindOppMode@_) =
                _lhsIppMode
        in  ( _lhsOneedsparens,_lhsOself,_lhsOtext)
sem_Kind_Error :: (T_Kind)
sem_Kind_Error  =
    \ _lhsIppMode ->
        let _lhsOneedsparens :: (Bool)
            _lhsOself :: (Kind)
            _lhsOtext :: (Doc)
            -- "./Pretty.inc.ag"(line 682, column 9)
            (_lhsOneedsparens@_) =
                False
            -- "./Pretty.inc.ag"(line 681, column 9)
            (_text@_) =
                text "{- error kind -}"
            -- self rule
            (_self@_) =
                Kind_Error
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
        in  ( _lhsOneedsparens,_lhsOself,_lhsOtext)
sem_Kind_Parenthesized :: (T_Range) ->
                          (T_Kind) ->
                          (T_Kind)
sem_Kind_Parenthesized (range_) (kind_) =
    \ _lhsIppMode ->
        let _lhsOneedsparens :: (Bool)
            _lhsOself :: (Kind)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _kindIneedsparens :: (Bool)
            _kindIself :: (Kind)
            _kindItext :: (Doc)
            _kindOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _kindIneedsparens,_kindIself,_kindItext) =
                (kind_ (_kindOppMode))
            -- self rule
            (_self@_) =
                Kind_Parenthesized _rangeIself _kindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOneedsparens@_) =
                _kindIneedsparens
            -- copy rule (up)
            (_lhsOtext@_) =
                _kindItext
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_kindOppMode@_) =
                _lhsIppMode
        in  ( _lhsOneedsparens,_lhsOself,_lhsOtext)
sem_Kind_Star :: (T_Range) ->
                 (T_Kind)
sem_Kind_Star (range_) =
    \ _lhsIppMode ->
        let _lhsOneedsparens :: (Bool)
            _lhsOself :: (Kind)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            -- "./Pretty.inc.ag"(line 668, column 9)
            (_lhsOneedsparens@_) =
                False
            -- "./Pretty.inc.ag"(line 667, column 9)
            (_text@_) =
                text "*"
            -- self rule
            (_self@_) =
                Kind_Star _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOneedsparens,_lhsOself,_lhsOtext)
sem_Kind_Variable :: (T_Range) ->
                     (T_Name) ->
                     (T_Kind)
sem_Kind_Variable (range_) (name_) =
    \ _lhsIppMode ->
        let _lhsOneedsparens :: (Bool)
            _lhsOself :: (Kind)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            -- "./Pretty.inc.ag"(line 672, column 9)
            (_lhsOneedsparens@_) =
                False
            -- "./Pretty.inc.ag"(line 671, column 9)
            (_ppMode@_) =
                _lhsIppMode { unqualified = True }
            -- "./Pretty.inc.ag"(line 670, column 9)
            (_text@_) =
                _nameItext
            -- self rule
            (_self@_) =
                Kind_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (from local)
            (_rangeOppMode@_) =
                _ppMode
            -- copy rule (from local)
            (_nameOppMode@_) =
                _ppMode
        in  ( _lhsOneedsparens,_lhsOself,_lhsOtext)
-- KindAnnotatedName -------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      full                 : Doc
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for KindAnnotatedName.KindAnnotatedName:
      text
      full
      self

-}
-- semantic domain
type T_KindAnnotatedName = (PPMode) ->
                           ( (Doc),(KindAnnotatedName),(Doc))
-- cata
sem_KindAnnotatedName :: (KindAnnotatedName) ->
                         (T_KindAnnotatedName)
sem_KindAnnotatedName ((KindAnnotatedName_KindAnnotatedName (_range) (_name) (_kind))) =
    (sem_KindAnnotatedName_KindAnnotatedName ((sem_Range (_range))) ((sem_Name (_name))) ((sem_MaybeKind (_kind))))
sem_KindAnnotatedName_KindAnnotatedName :: (T_Range) ->
                                           (T_Name) ->
                                           (T_MaybeKind) ->
                                           (T_KindAnnotatedName)
sem_KindAnnotatedName_KindAnnotatedName (range_) (name_) (kind_) =
    \ _lhsIppMode ->
        let _lhsOfull :: (Doc)
            _lhsOself :: (KindAnnotatedName)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _kindIself :: (MaybeKind)
            _kindItext :: (Doc)
            _kindOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _kindIself,_kindItext) =
                (kind_ (_kindOppMode))
            -- "./Pretty.inc.ag"(line 714, column 9)
            (_text@_) =
                _nameItext
            -- "./Pretty.inc.ag"(line 718, column 9)
            (_full@_) =
                _nameItext <> case _kindIself of
                                MaybeKind_Nothing  ->  emptyPP
                                MaybeKind_Just _   ->  text " ::" <+> _kindItext
            -- self rule
            (_self@_) =
                KindAnnotatedName_KindAnnotatedName _rangeIself _nameIself _kindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOfull@_) =
                _full
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_kindOppMode@_) =
                _lhsIppMode
        in  ( _lhsOfull,_lhsOself,_lhsOtext)
-- KindAnnotatedNames ------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      full                 : [Doc]
      self                 : SELF
      text                 : [Doc]

-}
{-
   local variables for KindAnnotatedNames.Cons:
      self

-}
{-
   local variables for KindAnnotatedNames.Nil:
      self

-}
-- semantic domain
type T_KindAnnotatedNames = (PPMode) ->
                            ( ([Doc]),(KindAnnotatedNames),([Doc]))
-- cata
sem_KindAnnotatedNames :: (KindAnnotatedNames) ->
                          (T_KindAnnotatedNames)
sem_KindAnnotatedNames (list) =
    (foldr (sem_KindAnnotatedNames_Cons) (sem_KindAnnotatedNames_Nil) ((map sem_KindAnnotatedName list)))
sem_KindAnnotatedNames_Cons :: (T_KindAnnotatedName) ->
                               (T_KindAnnotatedNames) ->
                               (T_KindAnnotatedNames)
sem_KindAnnotatedNames_Cons (hd_) (tl_) =
    \ _lhsIppMode ->
        let _lhsOfull :: ([Doc])
            _lhsOself :: (KindAnnotatedNames)
            _lhsOtext :: ([Doc])
            _hdIfull :: (Doc)
            _hdIself :: (KindAnnotatedName)
            _hdItext :: (Doc)
            _hdOppMode :: (PPMode)
            _tlIfull :: ([Doc])
            _tlIself :: (KindAnnotatedNames)
            _tlItext :: ([Doc])
            _tlOppMode :: (PPMode)
            ( _hdIfull,_hdIself,_hdItext) =
                (hd_ (_hdOppMode))
            ( _tlIfull,_tlIself,_tlItext) =
                (tl_ (_tlOppMode))
            -- use rule
            (_lhsOfull@_) =
                _hdIfull : _tlIfull
            -- use rule
            (_lhsOtext@_) =
                _hdItext : _tlItext
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_hdOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_tlOppMode@_) =
                _lhsIppMode
        in  ( _lhsOfull,_lhsOself,_lhsOtext)
sem_KindAnnotatedNames_Nil :: (T_KindAnnotatedNames)
sem_KindAnnotatedNames_Nil  =
    \ _lhsIppMode ->
        let _lhsOfull :: ([Doc])
            _lhsOself :: (KindAnnotatedNames)
            _lhsOtext :: ([Doc])
            -- use rule
            (_lhsOfull@_) =
                []
            -- use rule
            (_lhsOtext@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOfull,_lhsOself,_lhsOtext)
-- KindArgument ------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for KindArgument.Arrow:
      ppMode
      text
      self

-}
{-
   local variables for KindArgument.Star:
      text
      self

-}
-- semantic domain
type T_KindArgument = (PPMode) ->
                      ( (KindArgument),(Doc))
-- cata
sem_KindArgument :: (KindArgument) ->
                    (T_KindArgument)
sem_KindArgument ((KindArgument_Arrow (_range) (_leftkindvariable) (_rightkindvariable))) =
    (sem_KindArgument_Arrow ((sem_Range (_range))) ((sem_Name (_leftkindvariable))) ((sem_Name (_rightkindvariable))))
sem_KindArgument ((KindArgument_Star (_range))) =
    (sem_KindArgument_Star ((sem_Range (_range))))
sem_KindArgument_Arrow :: (T_Range) ->
                          (T_Name) ->
                          (T_Name) ->
                          (T_KindArgument)
sem_KindArgument_Arrow (range_) (leftkindvariable_) (rightkindvariable_) =
    \ _lhsIppMode ->
        let _lhsOself :: (KindArgument)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _leftkindvariableIisIdentifier :: (Bool)
            _leftkindvariableIisOperator :: (Bool)
            _leftkindvariableIisSpecial :: (Bool)
            _leftkindvariableIself :: (Name)
            _leftkindvariableItext :: (Doc)
            _leftkindvariableOppMode :: (PPMode)
            _rightkindvariableIisIdentifier :: (Bool)
            _rightkindvariableIisOperator :: (Bool)
            _rightkindvariableIisSpecial :: (Bool)
            _rightkindvariableIself :: (Name)
            _rightkindvariableItext :: (Doc)
            _rightkindvariableOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _leftkindvariableIisIdentifier,_leftkindvariableIisOperator,_leftkindvariableIisSpecial,_leftkindvariableIself,_leftkindvariableItext) =
                (leftkindvariable_ (_leftkindvariableOppMode))
            ( _rightkindvariableIisIdentifier,_rightkindvariableIisOperator,_rightkindvariableIisSpecial,_rightkindvariableIself,_rightkindvariableItext) =
                (rightkindvariable_ (_rightkindvariableOppMode))
            -- "./Pretty.inc.ag"(line 689, column 9)
            (_ppMode@_) =
                _lhsIppMode { unqualified = True }
            -- "./Pretty.inc.ag"(line 688, column 9)
            (_text@_) =
                _leftkindvariableItext <+> text "->" <+> _rightkindvariableItext
            -- self rule
            (_self@_) =
                KindArgument_Arrow _rangeIself _leftkindvariableIself _rightkindvariableIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (from local)
            (_rangeOppMode@_) =
                _ppMode
            -- copy rule (from local)
            (_leftkindvariableOppMode@_) =
                _ppMode
            -- copy rule (from local)
            (_rightkindvariableOppMode@_) =
                _ppMode
        in  ( _lhsOself,_lhsOtext)
sem_KindArgument_Star :: (T_Range) ->
                         (T_KindArgument)
sem_KindArgument_Star (range_) =
    \ _lhsIppMode ->
        let _lhsOself :: (KindArgument)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            -- "./Pretty.inc.ag"(line 686, column 9)
            (_text@_) =
                text "*"
            -- self rule
            (_self@_) =
                KindArgument_Star _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
-- KindIndexedBinding ------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for KindIndexedBinding.KindIndexedBinding:
      text
      self

-}
-- semantic domain
type T_KindIndexedBinding = (PPMode) ->
                            ( (KindIndexedBinding),(Doc))
-- cata
sem_KindIndexedBinding :: (KindIndexedBinding) ->
                          (T_KindIndexedBinding)
sem_KindIndexedBinding ((KindIndexedBinding_KindIndexedBinding (_range) (_name) (_kindargument) (_typevariables) (_type))) =
    (sem_KindIndexedBinding_KindIndexedBinding ((sem_Range (_range))) ((sem_Name (_name))) ((sem_KindArgument (_kindargument))) ((sem_Names (_typevariables))) ((sem_Type (_type))))
sem_KindIndexedBinding_KindIndexedBinding :: (T_Range) ->
                                             (T_Name) ->
                                             (T_KindArgument) ->
                                             (T_Names) ->
                                             (T_Type) ->
                                             (T_KindIndexedBinding)
sem_KindIndexedBinding_KindIndexedBinding (range_) (name_) (kindargument_) (typevariables_) (type_) =
    \ _lhsIppMode ->
        let _lhsOself :: (KindIndexedBinding)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _kindargumentIself :: (KindArgument)
            _kindargumentItext :: (Doc)
            _kindargumentOppMode :: (PPMode)
            _typevariablesIisIdentifier :: ([Bool])
            _typevariablesIisOperator :: ([Bool])
            _typevariablesIisSpecial :: ([Bool])
            _typevariablesIself :: (Names)
            _typevariablesItext :: ([Doc])
            _typevariablesOppMode :: (PPMode)
            _typeIself :: (Type)
            _typeItext :: (Doc)
            _typeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _kindargumentIself,_kindargumentItext) =
                (kindargument_ (_kindargumentOppMode))
            ( _typevariablesIisIdentifier,_typevariablesIisOperator,_typevariablesIisSpecial,_typevariablesIself,_typevariablesItext) =
                (typevariables_ (_typevariablesOppMode))
            ( _typeIself,_typeItext) =
                (type_ (_typeOppMode))
            -- "./Pretty.inc.ag"(line 971, column 9)
            (_nameOppMode@_) =
                _lhsIppMode { unqualified = True }
            -- "./Pretty.inc.ag"(line 966, column 9)
            (_text@_) =
                hang 2 $
                  foldl (<+>) (text "type" <+> _nameItext
                                 <+> text "{[" <+> _kindargumentItext <+> text "]}")
                              _typevariablesItext
                  </> text "=" <+> _typeItext
            -- self rule
            (_self@_) =
                KindIndexedBinding_KindIndexedBinding _rangeIself _nameIself _kindargumentIself _typevariablesIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_kindargumentOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_typevariablesOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_typeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
-- KindIndexedBindings -----------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : [Doc]

-}
{-
   local variables for KindIndexedBindings.Cons:
      self

-}
{-
   local variables for KindIndexedBindings.Nil:
      self

-}
-- semantic domain
type T_KindIndexedBindings = (PPMode) ->
                             ( (KindIndexedBindings),([Doc]))
-- cata
sem_KindIndexedBindings :: (KindIndexedBindings) ->
                           (T_KindIndexedBindings)
sem_KindIndexedBindings (list) =
    (foldr (sem_KindIndexedBindings_Cons) (sem_KindIndexedBindings_Nil) ((map sem_KindIndexedBinding list)))
sem_KindIndexedBindings_Cons :: (T_KindIndexedBinding) ->
                                (T_KindIndexedBindings) ->
                                (T_KindIndexedBindings)
sem_KindIndexedBindings_Cons (hd_) (tl_) =
    \ _lhsIppMode ->
        let _lhsOself :: (KindIndexedBindings)
            _lhsOtext :: ([Doc])
            _hdIself :: (KindIndexedBinding)
            _hdItext :: (Doc)
            _hdOppMode :: (PPMode)
            _tlIself :: (KindIndexedBindings)
            _tlItext :: ([Doc])
            _tlOppMode :: (PPMode)
            ( _hdIself,_hdItext) =
                (hd_ (_hdOppMode))
            ( _tlIself,_tlItext) =
                (tl_ (_tlOppMode))
            -- use rule
            (_lhsOtext@_) =
                _hdItext : _tlItext
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_hdOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_tlOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_KindIndexedBindings_Nil :: (T_KindIndexedBindings)
sem_KindIndexedBindings_Nil  =
    \ _lhsIppMode ->
        let _lhsOself :: (KindIndexedBindings)
            _lhsOtext :: ([Doc])
            -- use rule
            (_lhsOtext@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOself,_lhsOtext)
-- LeftHandSide ------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for LeftHandSide.Function:
      text
      self

-}
{-
   local variables for LeftHandSide.Infix:
      text
      self

-}
{-
   local variables for LeftHandSide.Parenthesized:
      text
      self

-}
-- semantic domain
type T_LeftHandSide = (PPMode) ->
                      ( (LeftHandSide),(Doc))
-- cata
sem_LeftHandSide :: (LeftHandSide) ->
                    (T_LeftHandSide)
sem_LeftHandSide ((LeftHandSide_Function (_range) (_name) (_patterns))) =
    (sem_LeftHandSide_Function ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Patterns (_patterns))))
sem_LeftHandSide ((LeftHandSide_Infix (_range) (_leftPattern) (_operator) (_rightPattern))) =
    (sem_LeftHandSide_Infix ((sem_Range (_range))) ((sem_Pattern (_leftPattern))) ((sem_Name (_operator))) ((sem_Pattern (_rightPattern))))
sem_LeftHandSide ((LeftHandSide_Parenthesized (_range) (_lefthandside) (_patterns))) =
    (sem_LeftHandSide_Parenthesized ((sem_Range (_range))) ((sem_LeftHandSide (_lefthandside))) ((sem_Patterns (_patterns))))
sem_LeftHandSide_Function :: (T_Range) ->
                             (T_Name) ->
                             (T_Patterns) ->
                             (T_LeftHandSide)
sem_LeftHandSide_Function (range_) (name_) (patterns_) =
    \ _lhsIppMode ->
        let _lhsOself :: (LeftHandSide)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _patternsIself :: (Patterns)
            _patternsItext :: ([Doc])
            _patternsOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _patternsIself,_patternsItext) =
                (patterns_ (_patternsOppMode))
            -- "./Pretty.inc.ag"(line 978, column 9)
            (_nameOppMode@_) =
                _lhsIppMode { unqualified = True }
            -- "./Pretty.inc.ag"(line 977, column 9)
            (_text@_) =
                _nameItext <+> align (sep _patternsItext)
            -- self rule
            (_self@_) =
                LeftHandSide_Function _rangeIself _nameIself _patternsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_patternsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_LeftHandSide_Infix :: (T_Range) ->
                          (T_Pattern) ->
                          (T_Name) ->
                          (T_Pattern) ->
                          (T_LeftHandSide)
sem_LeftHandSide_Infix (range_) (leftPattern_) (operator_) (rightPattern_) =
    \ _lhsIppMode ->
        let _lhsOself :: (LeftHandSide)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _leftPatternIself :: (Pattern)
            _leftPatternItext :: (Doc)
            _leftPatternOppMode :: (PPMode)
            _operatorIisIdentifier :: (Bool)
            _operatorIisOperator :: (Bool)
            _operatorIisSpecial :: (Bool)
            _operatorIself :: (Name)
            _operatorItext :: (Doc)
            _operatorOppMode :: (PPMode)
            _rightPatternIself :: (Pattern)
            _rightPatternItext :: (Doc)
            _rightPatternOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _leftPatternIself,_leftPatternItext) =
                (leftPattern_ (_leftPatternOppMode))
            ( _operatorIisIdentifier,_operatorIisOperator,_operatorIisSpecial,_operatorIself,_operatorItext) =
                (operator_ (_operatorOppMode))
            ( _rightPatternIself,_rightPatternItext) =
                (rightPattern_ (_rightPatternOppMode))
            -- "./Pretty.inc.ag"(line 981, column 9)
            (_operatorOppMode@_) =
                _lhsIppMode
                  { unqualified = True
                  , infixpos = True
                  }
            -- "./Pretty.inc.ag"(line 980, column 9)
            (_text@_) =
                _leftPatternItext <+> _operatorItext <+> _rightPatternItext
            -- self rule
            (_self@_) =
                LeftHandSide_Infix _rangeIself _leftPatternIself _operatorIself _rightPatternIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_leftPatternOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_rightPatternOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_LeftHandSide_Parenthesized :: (T_Range) ->
                                  (T_LeftHandSide) ->
                                  (T_Patterns) ->
                                  (T_LeftHandSide)
sem_LeftHandSide_Parenthesized (range_) (lefthandside_) (patterns_) =
    \ _lhsIppMode ->
        let _lhsOself :: (LeftHandSide)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _lefthandsideIself :: (LeftHandSide)
            _lefthandsideItext :: (Doc)
            _lefthandsideOppMode :: (PPMode)
            _patternsIself :: (Patterns)
            _patternsItext :: ([Doc])
            _patternsOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _lefthandsideIself,_lefthandsideItext) =
                (lefthandside_ (_lefthandsideOppMode))
            ( _patternsIself,_patternsItext) =
                (patterns_ (_patternsOppMode))
            -- "./Pretty.inc.ag"(line 986, column 9)
            (_text@_) =
                (parens _lefthandsideItext) <+> align (sep _patternsItext)
            -- self rule
            (_self@_) =
                LeftHandSide_Parenthesized _rangeIself _lefthandsideIself _patternsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_lefthandsideOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_patternsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
-- Literal -----------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for Literal.Char:
      text
      self

-}
{-
   local variables for Literal.Float:
      text
      self

-}
{-
   local variables for Literal.Int:
      text
      self

-}
{-
   local variables for Literal.String:
      text
      self

-}
-- semantic domain
type T_Literal = (PPMode) ->
                 ( (Literal),(Doc))
-- cata
sem_Literal :: (Literal) ->
               (T_Literal)
sem_Literal ((Literal_Char (_range) (_value))) =
    (sem_Literal_Char ((sem_Range (_range))) (_value))
sem_Literal ((Literal_Float (_range) (_value))) =
    (sem_Literal_Float ((sem_Range (_range))) (_value))
sem_Literal ((Literal_Int (_range) (_value))) =
    (sem_Literal_Int ((sem_Range (_range))) (_value))
sem_Literal ((Literal_String (_range) (_value))) =
    (sem_Literal_String ((sem_Range (_range))) (_value))
sem_Literal_Char :: (T_Range) ->
                    (String) ->
                    (T_Literal)
sem_Literal_Char (range_) (value_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Literal)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            -- "./Pretty.inc.ag"(line 1064, column 9)
            (_text@_) =
                let
                   f cs = if head cs == '\'' then '\\':cs else cs
                in
                   char '\'' <> ((text . f . init . tail . show) value_) <> char '\''
            -- self rule
            (_self@_) =
                Literal_Char _rangeIself value_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Literal_Float :: (T_Range) ->
                     (String) ->
                     (T_Literal)
sem_Literal_Float (range_) (value_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Literal)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            -- "./Pretty.inc.ag"(line 1070, column 9)
            (_text@_) =
                text value_
            -- self rule
            (_self@_) =
                Literal_Float _rangeIself value_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Literal_Int :: (T_Range) ->
                   (String) ->
                   (T_Literal)
sem_Literal_Int (range_) (value_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Literal)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            -- "./Pretty.inc.ag"(line 1061, column 9)
            (_text@_) =
                text value_
            -- self rule
            (_self@_) =
                Literal_Int _rangeIself value_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Literal_String :: (T_Range) ->
                      (String) ->
                      (T_Literal)
sem_Literal_String (range_) (value_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Literal)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            -- "./Pretty.inc.ag"(line 1073, column 9)
            (_text@_) =
                text (show value_)
            -- self rule
            (_self@_) =
                Literal_String _rangeIself value_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
-- MaybeDeclarations -------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 :  Maybe [Doc] 

-}
{-
   local variables for MaybeDeclarations.Just:
      text
      self

-}
{-
   local variables for MaybeDeclarations.Nothing:
      text
      self

-}
-- semantic domain
type T_MaybeDeclarations = (PPMode) ->
                           ( (MaybeDeclarations),( Maybe [Doc] ))
-- cata
sem_MaybeDeclarations :: (MaybeDeclarations) ->
                         (T_MaybeDeclarations)
sem_MaybeDeclarations ((MaybeDeclarations_Just (_declarations))) =
    (sem_MaybeDeclarations_Just ((sem_Declarations (_declarations))))
sem_MaybeDeclarations ((MaybeDeclarations_Nothing )) =
    (sem_MaybeDeclarations_Nothing )
sem_MaybeDeclarations_Just :: (T_Declarations) ->
                              (T_MaybeDeclarations)
sem_MaybeDeclarations_Just (declarations_) =
    \ _lhsIppMode ->
        let _lhsOself :: (MaybeDeclarations)
            _lhsOtext :: ( Maybe [Doc] )
            _declarationsIself :: (Declarations)
            _declarationsItext :: ([Doc])
            _declarationsOkind :: (Maybe Kind)
            _declarationsOppMode :: (PPMode)
            ( _declarationsIself,_declarationsItext) =
                (declarations_ (_declarationsOkind) (_declarationsOppMode))
            -- "./Pretty.inc.ag"(line 420, column 9)
            (_declarationsOkind@_) =
                Nothing
            -- "./Pretty.inc.ag"(line 419, column 9)
            (_text@_) =
                Just _declarationsItext
            -- self rule
            (_self@_) =
                MaybeDeclarations_Just _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_declarationsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_MaybeDeclarations_Nothing :: (T_MaybeDeclarations)
sem_MaybeDeclarations_Nothing  =
    \ _lhsIppMode ->
        let _lhsOself :: (MaybeDeclarations)
            _lhsOtext :: ( Maybe [Doc] )
            -- "./Pretty.inc.ag"(line 417, column 9)
            (_text@_) =
                Nothing
            -- self rule
            (_self@_) =
                MaybeDeclarations_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
        in  ( _lhsOself,_lhsOtext)
-- MaybeExports ------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 :  Maybe [Doc] 

-}
{-
   local variables for MaybeExports.Just:
      text
      self

-}
{-
   local variables for MaybeExports.Nothing:
      text
      self

-}
-- semantic domain
type T_MaybeExports = (PPMode) ->
                      ( (MaybeExports),( Maybe [Doc] ))
-- cata
sem_MaybeExports :: (MaybeExports) ->
                    (T_MaybeExports)
sem_MaybeExports ((MaybeExports_Just (_exports))) =
    (sem_MaybeExports_Just ((sem_Exports (_exports))))
sem_MaybeExports ((MaybeExports_Nothing )) =
    (sem_MaybeExports_Nothing )
sem_MaybeExports_Just :: (T_Exports) ->
                         (T_MaybeExports)
sem_MaybeExports_Just (exports_) =
    \ _lhsIppMode ->
        let _lhsOself :: (MaybeExports)
            _lhsOtext :: ( Maybe [Doc] )
            _exportsIself :: (Exports)
            _exportsItext :: ([Doc])
            _exportsOppMode :: (PPMode)
            ( _exportsIself,_exportsItext) =
                (exports_ (_exportsOppMode))
            -- "./Pretty.inc.ag"(line 321, column 9)
            (_text@_) =
                Just _exportsItext
            -- self rule
            (_self@_) =
                MaybeExports_Just _exportsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_exportsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_MaybeExports_Nothing :: (T_MaybeExports)
sem_MaybeExports_Nothing  =
    \ _lhsIppMode ->
        let _lhsOself :: (MaybeExports)
            _lhsOtext :: ( Maybe [Doc] )
            -- "./Pretty.inc.ag"(line 318, column 9)
            (_text@_) =
                Nothing
            -- self rule
            (_self@_) =
                MaybeExports_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
        in  ( _lhsOself,_lhsOtext)
-- MaybeExpression ---------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 :  Maybe Doc 

-}
{-
   local variables for MaybeExpression.Just:
      text
      self

-}
{-
   local variables for MaybeExpression.Nothing:
      text
      self

-}
-- semantic domain
type T_MaybeExpression = (PPMode) ->
                         ( (MaybeExpression),( Maybe Doc ))
-- cata
sem_MaybeExpression :: (MaybeExpression) ->
                       (T_MaybeExpression)
sem_MaybeExpression ((MaybeExpression_Just (_expression))) =
    (sem_MaybeExpression_Just ((sem_Expression (_expression))))
sem_MaybeExpression ((MaybeExpression_Nothing )) =
    (sem_MaybeExpression_Nothing )
sem_MaybeExpression_Just :: (T_Expression) ->
                            (T_MaybeExpression)
sem_MaybeExpression_Just (expression_) =
    \ _lhsIppMode ->
        let _lhsOself :: (MaybeExpression)
            _lhsOtext :: ( Maybe Doc )
            _expressionIself :: (Expression)
            _expressionItext :: (Doc)
            _expressionOppMode :: (PPMode)
            ( _expressionIself,_expressionItext) =
                (expression_ (_expressionOppMode))
            -- "./Pretty.inc.ag"(line 801, column 9)
            (_text@_) =
                Just _expressionItext
            -- self rule
            (_self@_) =
                MaybeExpression_Just _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_expressionOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_MaybeExpression_Nothing :: (T_MaybeExpression)
sem_MaybeExpression_Nothing  =
    \ _lhsIppMode ->
        let _lhsOself :: (MaybeExpression)
            _lhsOtext :: ( Maybe Doc )
            -- "./Pretty.inc.ag"(line 799, column 9)
            (_text@_) =
                Nothing
            -- self rule
            (_self@_) =
                MaybeExpression_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
        in  ( _lhsOself,_lhsOtext)
-- MaybeImportSpecification ------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 :  Maybe Doc 

-}
{-
   local variables for MaybeImportSpecification.Just:
      text
      self

-}
{-
   local variables for MaybeImportSpecification.Nothing:
      text
      self

-}
-- semantic domain
type T_MaybeImportSpecification = (PPMode) ->
                                  ( (MaybeImportSpecification),( Maybe Doc ))
-- cata
sem_MaybeImportSpecification :: (MaybeImportSpecification) ->
                                (T_MaybeImportSpecification)
sem_MaybeImportSpecification ((MaybeImportSpecification_Just (_importspecification))) =
    (sem_MaybeImportSpecification_Just ((sem_ImportSpecification (_importspecification))))
sem_MaybeImportSpecification ((MaybeImportSpecification_Nothing )) =
    (sem_MaybeImportSpecification_Nothing )
sem_MaybeImportSpecification_Just :: (T_ImportSpecification) ->
                                     (T_MaybeImportSpecification)
sem_MaybeImportSpecification_Just (importspecification_) =
    \ _lhsIppMode ->
        let _lhsOself :: (MaybeImportSpecification)
            _lhsOtext :: ( Maybe Doc )
            _importspecificationIself :: (ImportSpecification)
            _importspecificationItext :: (Doc)
            _importspecificationOppMode :: (PPMode)
            ( _importspecificationIself,_importspecificationItext) =
                (importspecification_ (_importspecificationOppMode))
            -- "./Pretty.inc.ag"(line 382, column 9)
            (_text@_) =
                Just _importspecificationItext
            -- self rule
            (_self@_) =
                MaybeImportSpecification_Just _importspecificationIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_importspecificationOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_MaybeImportSpecification_Nothing :: (T_MaybeImportSpecification)
sem_MaybeImportSpecification_Nothing  =
    \ _lhsIppMode ->
        let _lhsOself :: (MaybeImportSpecification)
            _lhsOtext :: ( Maybe Doc )
            -- "./Pretty.inc.ag"(line 380, column 9)
            (_text@_) =
                Nothing
            -- self rule
            (_self@_) =
                MaybeImportSpecification_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
        in  ( _lhsOself,_lhsOtext)
-- MaybeInt ----------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 :  Maybe Doc 

-}
{-
   local variables for MaybeInt.Just:
      text
      self

-}
{-
   local variables for MaybeInt.Nothing:
      text
      self

-}
-- semantic domain
type T_MaybeInt = (PPMode) ->
                  ( (MaybeInt),( Maybe Doc ))
-- cata
sem_MaybeInt :: (MaybeInt) ->
                (T_MaybeInt)
sem_MaybeInt ((MaybeInt_Just (_int))) =
    (sem_MaybeInt_Just (_int))
sem_MaybeInt ((MaybeInt_Nothing )) =
    (sem_MaybeInt_Nothing )
sem_MaybeInt_Just :: (Int) ->
                     (T_MaybeInt)
sem_MaybeInt_Just (int_) =
    \ _lhsIppMode ->
        let _lhsOself :: (MaybeInt)
            _lhsOtext :: ( Maybe Doc )
            -- "./Pretty.inc.ag"(line 1166, column 9)
            (_text@_) =
                Just (int int_)
            -- self rule
            (_self@_) =
                MaybeInt_Just int_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
        in  ( _lhsOself,_lhsOtext)
sem_MaybeInt_Nothing :: (T_MaybeInt)
sem_MaybeInt_Nothing  =
    \ _lhsIppMode ->
        let _lhsOself :: (MaybeInt)
            _lhsOtext :: ( Maybe Doc )
            -- "./Pretty.inc.ag"(line 1164, column 9)
            (_text@_) =
                Nothing
            -- self rule
            (_self@_) =
                MaybeInt_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
        in  ( _lhsOself,_lhsOtext)
-- MaybeKind ---------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for MaybeKind.Just:
      self

-}
{-
   local variables for MaybeKind.Nothing:
      text
      self

-}
-- semantic domain
type T_MaybeKind = (PPMode) ->
                   ( (MaybeKind),(Doc))
-- cata
sem_MaybeKind :: (MaybeKind) ->
                 (T_MaybeKind)
sem_MaybeKind ((MaybeKind_Just (_kind))) =
    (sem_MaybeKind_Just ((sem_Kind (_kind))))
sem_MaybeKind ((MaybeKind_Nothing )) =
    (sem_MaybeKind_Nothing )
sem_MaybeKind_Just :: (T_Kind) ->
                      (T_MaybeKind)
sem_MaybeKind_Just (kind_) =
    \ _lhsIppMode ->
        let _lhsOself :: (MaybeKind)
            _lhsOtext :: (Doc)
            _kindIneedsparens :: (Bool)
            _kindIself :: (Kind)
            _kindItext :: (Doc)
            _kindOppMode :: (PPMode)
            ( _kindIneedsparens,_kindIself,_kindItext) =
                (kind_ (_kindOppMode))
            -- self rule
            (_self@_) =
                MaybeKind_Just _kindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOtext@_) =
                _kindItext
            -- copy rule (down)
            (_kindOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_MaybeKind_Nothing :: (T_MaybeKind)
sem_MaybeKind_Nothing  =
    \ _lhsIppMode ->
        let _lhsOself :: (MaybeKind)
            _lhsOtext :: (Doc)
            -- "./Pretty.inc.ag"(line 724, column 9)
            (_text@_) =
                text ""
            -- self rule
            (_self@_) =
                MaybeKind_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
        in  ( _lhsOself,_lhsOtext)
-- MaybeModuleName ---------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 :  Maybe Doc 

-}
{-
   local variables for MaybeModuleName.Just:
      text
      self

-}
{-
   local variables for MaybeModuleName.Nothing:
      text
      self

-}
-- semantic domain
type T_MaybeModuleName = (PPMode) ->
                         ( (MaybeModuleName),( Maybe Doc ))
-- cata
sem_MaybeModuleName :: (MaybeModuleName) ->
                       (T_MaybeModuleName)
sem_MaybeModuleName ((MaybeModuleName_Just (_modulename))) =
    (sem_MaybeModuleName_Just ((sem_ModuleName (_modulename))))
sem_MaybeModuleName ((MaybeModuleName_Nothing )) =
    (sem_MaybeModuleName_Nothing )
sem_MaybeModuleName_Just :: (T_ModuleName) ->
                            (T_MaybeModuleName)
sem_MaybeModuleName_Just (modulename_) =
    \ _lhsIppMode ->
        let _lhsOself :: (MaybeModuleName)
            _lhsOtext :: ( Maybe Doc )
            _modulenameIself :: (ModuleName)
            _modulenameItext :: (Doc)
            _modulenameOppMode :: (PPMode)
            ( _modulenameIself,_modulenameItext) =
                (modulename_ (_modulenameOppMode))
            -- "./Pretty.inc.ag"(line 1156, column 9)
            (_text@_) =
                Just _modulenameItext
            -- self rule
            (_self@_) =
                MaybeModuleName_Just _modulenameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_modulenameOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_MaybeModuleName_Nothing :: (T_MaybeModuleName)
sem_MaybeModuleName_Nothing  =
    \ _lhsIppMode ->
        let _lhsOself :: (MaybeModuleName)
            _lhsOtext :: ( Maybe Doc )
            -- "./Pretty.inc.ag"(line 1154, column 9)
            (_text@_) =
                Nothing
            -- self rule
            (_self@_) =
                MaybeModuleName_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
        in  ( _lhsOself,_lhsOtext)
-- MaybeName ---------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 :  Maybe Doc 

-}
{-
   local variables for MaybeName.Just:
      text
      self

-}
{-
   local variables for MaybeName.Nothing:
      text
      self

-}
-- semantic domain
type T_MaybeName = (PPMode) ->
                   ( (MaybeName),( Maybe Doc ))
-- cata
sem_MaybeName :: (MaybeName) ->
                 (T_MaybeName)
sem_MaybeName ((MaybeName_Just (_name))) =
    (sem_MaybeName_Just ((sem_Name (_name))))
sem_MaybeName ((MaybeName_Nothing )) =
    (sem_MaybeName_Nothing )
sem_MaybeName_Just :: (T_Name) ->
                      (T_MaybeName)
sem_MaybeName_Just (name_) =
    \ _lhsIppMode ->
        let _lhsOself :: (MaybeName)
            _lhsOtext :: ( Maybe Doc )
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            -- "./Pretty.inc.ag"(line 1079, column 9)
            (_text@_) =
                Just _nameItext
            -- self rule
            (_self@_) =
                MaybeName_Just _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_MaybeName_Nothing :: (T_MaybeName)
sem_MaybeName_Nothing  =
    \ _lhsIppMode ->
        let _lhsOself :: (MaybeName)
            _lhsOtext :: ( Maybe Doc )
            -- "./Pretty.inc.ag"(line 1077, column 9)
            (_text@_) =
                Nothing
            -- self rule
            (_self@_) =
                MaybeName_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
        in  ( _lhsOself,_lhsOtext)
-- MaybeNames --------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 :  Maybe [Doc] 

-}
{-
   local variables for MaybeNames.Just:
      text
      self

-}
{-
   local variables for MaybeNames.Nothing:
      text
      self

-}
-- semantic domain
type T_MaybeNames = (PPMode) ->
                    ( (MaybeNames),( Maybe [Doc] ))
-- cata
sem_MaybeNames :: (MaybeNames) ->
                  (T_MaybeNames)
sem_MaybeNames ((MaybeNames_Just (_names))) =
    (sem_MaybeNames_Just ((sem_Names (_names))))
sem_MaybeNames ((MaybeNames_Nothing )) =
    (sem_MaybeNames_Nothing )
sem_MaybeNames_Just :: (T_Names) ->
                       (T_MaybeNames)
sem_MaybeNames_Just (names_) =
    \ _lhsIppMode ->
        let _lhsOself :: (MaybeNames)
            _lhsOtext :: ( Maybe [Doc] )
            _namesIisIdentifier :: ([Bool])
            _namesIisOperator :: ([Bool])
            _namesIisSpecial :: ([Bool])
            _namesIself :: (Names)
            _namesItext :: ([Doc])
            _namesOppMode :: (PPMode)
            ( _namesIisIdentifier,_namesIisOperator,_namesIisSpecial,_namesIself,_namesItext) =
                (names_ (_namesOppMode))
            -- "./Pretty.inc.ag"(line 357, column 9)
            (_text@_) =
                Just _namesItext
            -- self rule
            (_self@_) =
                MaybeNames_Just _namesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_namesOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_MaybeNames_Nothing :: (T_MaybeNames)
sem_MaybeNames_Nothing  =
    \ _lhsIppMode ->
        let _lhsOself :: (MaybeNames)
            _lhsOtext :: ( Maybe [Doc] )
            -- "./Pretty.inc.ag"(line 354, column 9)
            (_text@_) =
                Nothing
            -- self rule
            (_self@_) =
                MaybeNames_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
        in  ( _lhsOself,_lhsOtext)
-- MaybeReassignments ------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 :  Maybe [Doc] 

-}
{-
   local variables for MaybeReassignments.Just:
      text
      self

-}
{-
   local variables for MaybeReassignments.Nothing:
      text
      self

-}
-- semantic domain
type T_MaybeReassignments = (PPMode) ->
                            ( (MaybeReassignments),( Maybe [Doc] ))
-- cata
sem_MaybeReassignments :: (MaybeReassignments) ->
                          (T_MaybeReassignments)
sem_MaybeReassignments ((MaybeReassignments_Just (_reassignments))) =
    (sem_MaybeReassignments_Just ((sem_Reassignments (_reassignments))))
sem_MaybeReassignments ((MaybeReassignments_Nothing )) =
    (sem_MaybeReassignments_Nothing )
sem_MaybeReassignments_Just :: (T_Reassignments) ->
                               (T_MaybeReassignments)
sem_MaybeReassignments_Just (reassignments_) =
    \ _lhsIppMode ->
        let _lhsOself :: (MaybeReassignments)
            _lhsOtext :: ( Maybe [Doc] )
            _reassignmentsIself :: (Reassignments)
            _reassignmentsItext :: ([Doc])
            _reassignmentsOppMode :: (PPMode)
            ( _reassignmentsIself,_reassignmentsItext) =
                (reassignments_ (_reassignmentsOppMode))
            -- "./Pretty.inc.ag"(line 958, column 9)
            (_text@_) =
                Just _reassignmentsItext
            -- self rule
            (_self@_) =
                MaybeReassignments_Just _reassignmentsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_reassignmentsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_MaybeReassignments_Nothing :: (T_MaybeReassignments)
sem_MaybeReassignments_Nothing  =
    \ _lhsIppMode ->
        let _lhsOself :: (MaybeReassignments)
            _lhsOtext :: ( Maybe [Doc] )
            -- "./Pretty.inc.ag"(line 955, column 9)
            (_text@_) =
                Nothing
            -- self rule
            (_self@_) =
                MaybeReassignments_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
        in  ( _lhsOself,_lhsOtext)
-- Module ------------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for Module.Module:
      text
      self

-}
-- semantic domain
type T_Module = (PPMode) ->
                ( (Module),(Doc))
-- cata
sem_Module :: (Module) ->
              (T_Module)
sem_Module ((Module_Module (_range) (_name) (_exports) (_body))) =
    (sem_Module_Module ((sem_Range (_range))) ((sem_MaybeModuleName (_name))) ((sem_MaybeExports (_exports))) ((sem_Body (_body))))
sem_Module_Module :: (T_Range) ->
                     (T_MaybeModuleName) ->
                     (T_MaybeExports) ->
                     (T_Body) ->
                     (T_Module)
sem_Module_Module (range_) (name_) (exports_) (body_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Module)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIself :: (MaybeModuleName)
            _nameItext :: ( Maybe Doc )
            _nameOppMode :: (PPMode)
            _exportsIself :: (MaybeExports)
            _exportsItext :: ( Maybe [Doc] )
            _exportsOppMode :: (PPMode)
            _bodyIself :: (Body)
            _bodyItext :: (Doc)
            _bodyOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _exportsIself,_exportsItext) =
                (exports_ (_exportsOppMode))
            ( _bodyIself,_bodyItext) =
                (body_ (_bodyOppMode))
            -- "./Pretty.inc.ag"(line 296, column 9)
            (_text@_) =
                ppModuleHeader _nameItext _exportsItext <$> _bodyItext
            -- self rule
            (_self@_) =
                Module_Module _rangeIself _nameIself _exportsIself _bodyIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_exportsOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_bodyOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
-- ModuleInterface ---------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for ModuleInterface.ModuleInterface:
      self

-}
{-
   local variables for ModuleInterface.Unavailable:
      self

-}
-- semantic domain
type T_ModuleInterface = (PPMode) ->
                         ( (ModuleInterface))
-- cata
sem_ModuleInterface :: (ModuleInterface) ->
                       (T_ModuleInterface)
sem_ModuleInterface ((ModuleInterface_ModuleInterface (_range) (_name) (_exportedTypes) (_exportedValues) (_declarations))) =
    (sem_ModuleInterface_ModuleInterface ((sem_Range (_range))) ((sem_ModuleName (_name))) ((sem_Names (_exportedTypes))) ((sem_Names (_exportedValues))) ((sem_InterfaceDeclarations (_declarations))))
sem_ModuleInterface ((ModuleInterface_Unavailable (_name))) =
    (sem_ModuleInterface_Unavailable ((sem_ModuleName (_name))))
sem_ModuleInterface_ModuleInterface :: (T_Range) ->
                                       (T_ModuleName) ->
                                       (T_Names) ->
                                       (T_Names) ->
                                       (T_InterfaceDeclarations) ->
                                       (T_ModuleInterface)
sem_ModuleInterface_ModuleInterface (range_) (name_) (exportedTypes_) (exportedValues_) (declarations_) =
    \ _lhsIppMode ->
        let _lhsOself :: (ModuleInterface)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIself :: (ModuleName)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _exportedTypesIisIdentifier :: ([Bool])
            _exportedTypesIisOperator :: ([Bool])
            _exportedTypesIisSpecial :: ([Bool])
            _exportedTypesIself :: (Names)
            _exportedTypesItext :: ([Doc])
            _exportedTypesOppMode :: (PPMode)
            _exportedValuesIisIdentifier :: ([Bool])
            _exportedValuesIisOperator :: ([Bool])
            _exportedValuesIisSpecial :: ([Bool])
            _exportedValuesIself :: (Names)
            _exportedValuesItext :: ([Doc])
            _exportedValuesOppMode :: (PPMode)
            _declarationsIself :: (InterfaceDeclarations)
            _declarationsItext :: ([Doc])
            _declarationsOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _exportedTypesIisIdentifier,_exportedTypesIisOperator,_exportedTypesIisSpecial,_exportedTypesIself,_exportedTypesItext) =
                (exportedTypes_ (_exportedTypesOppMode))
            ( _exportedValuesIisIdentifier,_exportedValuesIisOperator,_exportedValuesIisSpecial,_exportedValuesIself,_exportedValuesItext) =
                (exportedValues_ (_exportedValuesOppMode))
            ( _declarationsIself,_declarationsItext) =
                (declarations_ (_declarationsOppMode))
            -- self rule
            (_self@_) =
                ModuleInterface_ModuleInterface _rangeIself _nameIself _exportedTypesIself _exportedValuesIself _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_exportedTypesOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_exportedValuesOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_declarationsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself)
sem_ModuleInterface_Unavailable :: (T_ModuleName) ->
                                   (T_ModuleInterface)
sem_ModuleInterface_Unavailable (name_) =
    \ _lhsIppMode ->
        let _lhsOself :: (ModuleInterface)
            _nameIself :: (ModuleName)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            ( _nameIself,_nameItext) =
                (name_ (_nameOppMode))
            -- self rule
            (_self@_) =
                ModuleInterface_Unavailable _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself)
-- ModuleInterfaces --------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for ModuleInterfaces.Cons:
      self

-}
{-
   local variables for ModuleInterfaces.Nil:
      self

-}
-- semantic domain
type T_ModuleInterfaces = (PPMode) ->
                          ( (ModuleInterfaces))
-- cata
sem_ModuleInterfaces :: (ModuleInterfaces) ->
                        (T_ModuleInterfaces)
sem_ModuleInterfaces (list) =
    (foldr (sem_ModuleInterfaces_Cons) (sem_ModuleInterfaces_Nil) ((map sem_ModuleInterface list)))
sem_ModuleInterfaces_Cons :: (T_ModuleInterface) ->
                             (T_ModuleInterfaces) ->
                             (T_ModuleInterfaces)
sem_ModuleInterfaces_Cons (hd_) (tl_) =
    \ _lhsIppMode ->
        let _lhsOself :: (ModuleInterfaces)
            _hdIself :: (ModuleInterface)
            _hdOppMode :: (PPMode)
            _tlIself :: (ModuleInterfaces)
            _tlOppMode :: (PPMode)
            ( _hdIself) =
                (hd_ (_hdOppMode))
            ( _tlIself) =
                (tl_ (_tlOppMode))
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_hdOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_tlOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself)
sem_ModuleInterfaces_Nil :: (T_ModuleInterfaces)
sem_ModuleInterfaces_Nil  =
    \ _lhsIppMode ->
        let _lhsOself :: (ModuleInterfaces)
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOself)
-- ModuleName --------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for ModuleName.ModuleName:
      text
      self

-}
-- semantic domain
type T_ModuleName = (PPMode) ->
                    ( (ModuleName),(Doc))
-- cata
sem_ModuleName :: (ModuleName) ->
                  (T_ModuleName)
sem_ModuleName ((ModuleName_ModuleName (_range) (_name))) =
    (sem_ModuleName_ModuleName ((sem_Range (_range))) ((sem_Strings (_name))))
sem_ModuleName_ModuleName :: (T_Range) ->
                             (T_Strings) ->
                             (T_ModuleName)
sem_ModuleName_ModuleName (range_) (name_) =
    \ _lhsIppMode ->
        let _lhsOself :: (ModuleName)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIself :: (Strings)
            _nameItext :: ([Doc])
            _nameOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIself,_nameItext) =
                (name_ (_nameOppMode))
            -- "./Pretty.inc.ag"(line 1160, column 9)
            (_text@_) =
                moduleText False _nameItext
            -- self rule
            (_self@_) =
                ModuleName_ModuleName _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
-- ModuleSystem ------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for ModuleSystem.ModuleSystem:
      self

-}
-- semantic domain
type T_ModuleSystem = (PPMode) ->
                      ( (ModuleSystem))
-- cata
sem_ModuleSystem :: (ModuleSystem) ->
                    (T_ModuleSystem)
sem_ModuleSystem ((ModuleSystem_ModuleSystem (_interfaces) (_module))) =
    (sem_ModuleSystem_ModuleSystem ((sem_ModuleInterfaces (_interfaces))) ((sem_Module (_module))))
sem_ModuleSystem_ModuleSystem :: (T_ModuleInterfaces) ->
                                 (T_Module) ->
                                 (T_ModuleSystem)
sem_ModuleSystem_ModuleSystem (interfaces_) (module_) =
    \ _lhsIppMode ->
        let _lhsOself :: (ModuleSystem)
            _interfacesIself :: (ModuleInterfaces)
            _interfacesOppMode :: (PPMode)
            _moduleIself :: (Module)
            _moduleItext :: (Doc)
            _moduleOppMode :: (PPMode)
            ( _interfacesIself) =
                (interfaces_ (_interfacesOppMode))
            ( _moduleIself,_moduleItext) =
                (module_ (_moduleOppMode))
            -- self rule
            (_self@_) =
                ModuleSystem_ModuleSystem _interfacesIself _moduleIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_interfacesOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_moduleOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself)
-- Name --------------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      isIdentifier         : Bool
      isOperator           : Bool
      isSpecial            : Bool
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for Name.Entity:
      text
      self

-}
{-
   local variables for Name.Identifier:
      text
      opmod
      self

-}
{-
   local variables for Name.Operator:
      text
      opmod
      self

-}
{-
   local variables for Name.Special:
      text
      self

-}
-- semantic domain
type T_Name = (PPMode) ->
              ( (Bool),(Bool),(Bool),(Name),(Doc))
-- cata
sem_Name :: (Name) ->
            (T_Name)
sem_Name ((Name_Entity (_range) (_entity) (_inscope))) =
    (sem_Name_Entity ((sem_Range (_range))) ((sem_Name (_entity))) ((sem_MaybeName (_inscope))))
sem_Name ((Name_Identifier (_range) (_module) (_name))) =
    (sem_Name_Identifier ((sem_Range (_range))) ((sem_Strings (_module))) (_name))
sem_Name ((Name_Operator (_range) (_module) (_name))) =
    (sem_Name_Operator ((sem_Range (_range))) ((sem_Strings (_module))) (_name))
sem_Name ((Name_Special (_range) (_module) (_name))) =
    (sem_Name_Special ((sem_Range (_range))) ((sem_Strings (_module))) (_name))
sem_Name_Entity :: (T_Range) ->
                   (T_Name) ->
                   (T_MaybeName) ->
                   (T_Name)
sem_Name_Entity (range_) (entity_) (inscope_) =
    \ _lhsIppMode ->
        let _lhsOisIdentifier :: (Bool)
            _lhsOisOperator :: (Bool)
            _lhsOisSpecial :: (Bool)
            _lhsOself :: (Name)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _entityIisIdentifier :: (Bool)
            _entityIisOperator :: (Bool)
            _entityIisSpecial :: (Bool)
            _entityIself :: (Name)
            _entityItext :: (Doc)
            _entityOppMode :: (PPMode)
            _inscopeIself :: (MaybeName)
            _inscopeItext :: ( Maybe Doc )
            _inscopeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _entityIisIdentifier,_entityIisOperator,_entityIisSpecial,_entityIself,_entityItext) =
                (entity_ (_entityOppMode))
            ( _inscopeIself,_inscopeItext) =
                (inscope_ (_inscopeOppMode))
            -- "./Pretty.inc.ag"(line 1144, column 9)
            (_text@_) =
                if interface _lhsIppMode then
                  _entityItext
                else
                  case _inscopeItext of
                    Just x
                      | not (isQualifiedName _self) -> x
                    _ -> _entityItext
            -- use rule
            (_lhsOisIdentifier@_) =
                _entityIisIdentifier
            -- use rule
            (_lhsOisOperator@_) =
                _entityIisOperator
            -- use rule
            (_lhsOisSpecial@_) =
                _entityIisSpecial
            -- self rule
            (_self@_) =
                Name_Entity _rangeIself _entityIself _inscopeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_entityOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_inscopeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOisIdentifier,_lhsOisOperator,_lhsOisSpecial,_lhsOself,_lhsOtext)
sem_Name_Identifier :: (T_Range) ->
                       (T_Strings) ->
                       (String) ->
                       (T_Name)
sem_Name_Identifier (range_) (module_) (name_) =
    \ _lhsIppMode ->
        let _lhsOisIdentifier :: (Bool)
            _lhsOisOperator :: (Bool)
            _lhsOisSpecial :: (Bool)
            _lhsOself :: (Name)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _moduleIself :: (Strings)
            _moduleItext :: ([Doc])
            _moduleOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _moduleIself,_moduleItext) =
                (module_ (_moduleOppMode))
            -- "./Pretty.inc.ag"(line 1094, column 9)
            (_lhsOisIdentifier@_) =
                True
            -- "./Pretty.inc.ag"(line 1087, column 9)
            (_text@_) =
                if unqualified _lhsIppMode then
                  _opmod (text name_)
                else
                  _opmod $
                  moduleText (prefixed _lhsIppMode) $
                    _moduleItext ++ [text name_]
            -- "./Pretty.inc.ag"(line 1083, column 9)
            (_opmod@_) =
                if infixpos _lhsIppMode then
                  (\d -> text "`" <> d <> text "`")
                else
                  id
            -- use rule
            (_lhsOisOperator@_) =
                False
            -- use rule
            (_lhsOisSpecial@_) =
                False
            -- self rule
            (_self@_) =
                Name_Identifier _rangeIself _moduleIself name_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_moduleOppMode@_) =
                _lhsIppMode
        in  ( _lhsOisIdentifier,_lhsOisOperator,_lhsOisSpecial,_lhsOself,_lhsOtext)
sem_Name_Operator :: (T_Range) ->
                     (T_Strings) ->
                     (String) ->
                     (T_Name)
sem_Name_Operator (range_) (module_) (name_) =
    \ _lhsIppMode ->
        let _lhsOisIdentifier :: (Bool)
            _lhsOisOperator :: (Bool)
            _lhsOisSpecial :: (Bool)
            _lhsOself :: (Name)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _moduleIself :: (Strings)
            _moduleItext :: ([Doc])
            _moduleOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _moduleIself,_moduleItext) =
                (module_ (_moduleOppMode))
            -- "./Pretty.inc.ag"(line 1113, column 9)
            (_lhsOisOperator@_) =
                True
            -- "./Pretty.inc.ag"(line 1101, column 9)
            (_text@_) =
                if unqualified _lhsIppMode
                   || (_moduleIself == ["Prelude"]
                       && name_ == ":"
                       && not (interface _lhsIppMode))
                then
                  _opmod (text name_)
                else
                  _opmod $
                  moduleText (prefixed _lhsIppMode) $
                    _moduleItext ++ [text name_]
            -- "./Pretty.inc.ag"(line 1097, column 9)
            (_opmod@_) =
                if infixpos _lhsIppMode then
                  id
                else
                  parens
            -- use rule
            (_lhsOisIdentifier@_) =
                False
            -- use rule
            (_lhsOisSpecial@_) =
                False
            -- self rule
            (_self@_) =
                Name_Operator _rangeIself _moduleIself name_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_moduleOppMode@_) =
                _lhsIppMode
        in  ( _lhsOisIdentifier,_lhsOisOperator,_lhsOisSpecial,_lhsOself,_lhsOtext)
sem_Name_Special :: (T_Range) ->
                    (T_Strings) ->
                    (String) ->
                    (T_Name)
sem_Name_Special (range_) (module_) (name_) =
    \ _lhsIppMode ->
        let _lhsOisIdentifier :: (Bool)
            _lhsOisOperator :: (Bool)
            _lhsOisSpecial :: (Bool)
            _lhsOself :: (Name)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _moduleIself :: (Strings)
            _moduleItext :: ([Doc])
            _moduleOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _moduleIself,_moduleItext) =
                (module_ (_moduleOppMode))
            -- "./Pretty.inc.ag"(line 1141, column 9)
            (_lhsOisSpecial@_) =
                True
            -- "./Pretty.inc.ag"(line 1125, column 9)
            (_text@_) =
                if nosymbol _lhsIppMode then
                  if unqualified _lhsIppMode then
                    text $ mangleName _self
                  else
                    moduleText (prefixed _lhsIppMode) $
                      _moduleItext
                        ++ [text $ mangleName _self]
                else
                  if name_ == ":" || name_ == "->"
                       && not (infixpos _lhsIppMode)
                  then
                    parens (text name_)
                  else
                    text name_
            -- use rule
            (_lhsOisIdentifier@_) =
                False
            -- use rule
            (_lhsOisOperator@_) =
                False
            -- self rule
            (_self@_) =
                Name_Special _rangeIself _moduleIself name_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_moduleOppMode@_) =
                _lhsIppMode
        in  ( _lhsOisIdentifier,_lhsOisOperator,_lhsOisSpecial,_lhsOself,_lhsOtext)
-- Names -------------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      isIdentifier         : [Bool]
      isOperator           : [Bool]
      isSpecial            : [Bool]
      self                 : SELF
      text                 : [Doc]

-}
{-
   local variables for Names.Cons:
      self

-}
{-
   local variables for Names.Nil:
      self

-}
-- semantic domain
type T_Names = (PPMode) ->
               ( ([Bool]),([Bool]),([Bool]),(Names),([Doc]))
-- cata
sem_Names :: (Names) ->
             (T_Names)
sem_Names (list) =
    (foldr (sem_Names_Cons) (sem_Names_Nil) ((map sem_Name list)))
sem_Names_Cons :: (T_Name) ->
                  (T_Names) ->
                  (T_Names)
sem_Names_Cons (hd_) (tl_) =
    \ _lhsIppMode ->
        let _lhsOisIdentifier :: ([Bool])
            _lhsOisOperator :: ([Bool])
            _lhsOisSpecial :: ([Bool])
            _lhsOself :: (Names)
            _lhsOtext :: ([Doc])
            _hdIisIdentifier :: (Bool)
            _hdIisOperator :: (Bool)
            _hdIisSpecial :: (Bool)
            _hdIself :: (Name)
            _hdItext :: (Doc)
            _hdOppMode :: (PPMode)
            _tlIisIdentifier :: ([Bool])
            _tlIisOperator :: ([Bool])
            _tlIisSpecial :: ([Bool])
            _tlIself :: (Names)
            _tlItext :: ([Doc])
            _tlOppMode :: (PPMode)
            ( _hdIisIdentifier,_hdIisOperator,_hdIisSpecial,_hdIself,_hdItext) =
                (hd_ (_hdOppMode))
            ( _tlIisIdentifier,_tlIisOperator,_tlIisSpecial,_tlIself,_tlItext) =
                (tl_ (_tlOppMode))
            -- use rule
            (_lhsOisIdentifier@_) =
                _hdIisIdentifier : _tlIisIdentifier
            -- use rule
            (_lhsOisOperator@_) =
                _hdIisOperator : _tlIisOperator
            -- use rule
            (_lhsOisSpecial@_) =
                _hdIisSpecial : _tlIisSpecial
            -- use rule
            (_lhsOtext@_) =
                _hdItext : _tlItext
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_hdOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_tlOppMode@_) =
                _lhsIppMode
        in  ( _lhsOisIdentifier,_lhsOisOperator,_lhsOisSpecial,_lhsOself,_lhsOtext)
sem_Names_Nil :: (T_Names)
sem_Names_Nil  =
    \ _lhsIppMode ->
        let _lhsOisIdentifier :: ([Bool])
            _lhsOisOperator :: ([Bool])
            _lhsOisSpecial :: ([Bool])
            _lhsOself :: (Names)
            _lhsOtext :: ([Doc])
            -- use rule
            (_lhsOisIdentifier@_) =
                []
            -- use rule
            (_lhsOisOperator@_) =
                []
            -- use rule
            (_lhsOisSpecial@_) =
                []
            -- use rule
            (_lhsOtext@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOisIdentifier,_lhsOisOperator,_lhsOisSpecial,_lhsOself,_lhsOtext)
-- Pattern -----------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for Pattern.As:
      text
      self

-}
{-
   local variables for Pattern.Constructor:
      text
      self

-}
{-
   local variables for Pattern.InfixConstructor:
      text
      self

-}
{-
   local variables for Pattern.Irrefutable:
      text
      self

-}
{-
   local variables for Pattern.List:
      text
      self

-}
{-
   local variables for Pattern.Literal:
      text
      self

-}
{-
   local variables for Pattern.Negate:
      text
      self

-}
{-
   local variables for Pattern.Parenthesized:
      text
      self

-}
{-
   local variables for Pattern.Record:
      text
      self

-}
{-
   local variables for Pattern.Successor:
      text
      self

-}
{-
   local variables for Pattern.Tuple:
      text
      self

-}
{-
   local variables for Pattern.Variable:
      text
      self

-}
{-
   local variables for Pattern.Wildcard:
      text
      self

-}
-- semantic domain
type T_Pattern = (PPMode) ->
                 ( (Pattern),(Doc))
-- cata
sem_Pattern :: (Pattern) ->
               (T_Pattern)
sem_Pattern ((Pattern_As (_range) (_name) (_pattern))) =
    (sem_Pattern_As ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_Constructor (_range) (_name) (_patterns))) =
    (sem_Pattern_Constructor ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Patterns (_patterns))))
sem_Pattern ((Pattern_InfixConstructor (_range) (_leftPattern) (_constructorOperator) (_rightPattern))) =
    (sem_Pattern_InfixConstructor ((sem_Range (_range))) ((sem_Pattern (_leftPattern))) ((sem_Name (_constructorOperator))) ((sem_Pattern (_rightPattern))))
sem_Pattern ((Pattern_Irrefutable (_range) (_pattern))) =
    (sem_Pattern_Irrefutable ((sem_Range (_range))) ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_List (_range) (_patterns))) =
    (sem_Pattern_List ((sem_Range (_range))) ((sem_Patterns (_patterns))))
sem_Pattern ((Pattern_Literal (_range) (_literal))) =
    (sem_Pattern_Literal ((sem_Range (_range))) ((sem_Literal (_literal))))
sem_Pattern ((Pattern_Negate (_range) (_literal))) =
    (sem_Pattern_Negate ((sem_Range (_range))) ((sem_Literal (_literal))))
sem_Pattern ((Pattern_Parenthesized (_range) (_pattern))) =
    (sem_Pattern_Parenthesized ((sem_Range (_range))) ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_Record (_range) (_name) (_recordPatternBindings))) =
    (sem_Pattern_Record ((sem_Range (_range))) ((sem_Name (_name))) ((sem_RecordPatternBindings (_recordPatternBindings))))
sem_Pattern ((Pattern_Successor (_range) (_name) (_literal))) =
    (sem_Pattern_Successor ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Literal (_literal))))
sem_Pattern ((Pattern_Tuple (_range) (_patterns))) =
    (sem_Pattern_Tuple ((sem_Range (_range))) ((sem_Patterns (_patterns))))
sem_Pattern ((Pattern_Variable (_range) (_name))) =
    (sem_Pattern_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Pattern ((Pattern_Wildcard (_range))) =
    (sem_Pattern_Wildcard ((sem_Range (_range))))
sem_Pattern_As :: (T_Range) ->
                  (T_Name) ->
                  (T_Pattern) ->
                  (T_Pattern)
sem_Pattern_As (range_) (name_) (pattern_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Pattern)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _patternIself :: (Pattern)
            _patternItext :: (Doc)
            _patternOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _patternIself,_patternItext) =
                (pattern_ (_patternOppMode))
            -- "./Pretty.inc.ag"(line 1044, column 9)
            (_text@_) =
                _nameItext <> text "@" <> _patternItext
            -- self rule
            (_self@_) =
                Pattern_As _rangeIself _nameIself _patternIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_patternOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Pattern_Constructor :: (T_Range) ->
                           (T_Name) ->
                           (T_Patterns) ->
                           (T_Pattern)
sem_Pattern_Constructor (range_) (name_) (patterns_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Pattern)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _patternsIself :: (Patterns)
            _patternsItext :: ([Doc])
            _patternsOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _patternsIself,_patternsItext) =
                (patterns_ (_patternsOppMode))
            -- "./Pretty.inc.ag"(line 1018, column 9)
            (_nameOppMode@_) =
                _lhsIppMode { infixpos = False }
            -- "./Pretty.inc.ag"(line 1016, column 9)
            (_text@_) =
                hang 2 $
                  _nameItext </> align (sep _patternsItext)
            -- self rule
            (_self@_) =
                Pattern_Constructor _rangeIself _nameIself _patternsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_patternsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Pattern_InfixConstructor :: (T_Range) ->
                                (T_Pattern) ->
                                (T_Name) ->
                                (T_Pattern) ->
                                (T_Pattern)
sem_Pattern_InfixConstructor (range_) (leftPattern_) (constructorOperator_) (rightPattern_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Pattern)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _leftPatternIself :: (Pattern)
            _leftPatternItext :: (Doc)
            _leftPatternOppMode :: (PPMode)
            _constructorOperatorIisIdentifier :: (Bool)
            _constructorOperatorIisOperator :: (Bool)
            _constructorOperatorIisSpecial :: (Bool)
            _constructorOperatorIself :: (Name)
            _constructorOperatorItext :: (Doc)
            _constructorOperatorOppMode :: (PPMode)
            _rightPatternIself :: (Pattern)
            _rightPatternItext :: (Doc)
            _rightPatternOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _leftPatternIself,_leftPatternItext) =
                (leftPattern_ (_leftPatternOppMode))
            ( _constructorOperatorIisIdentifier,_constructorOperatorIisOperator,_constructorOperatorIisSpecial,_constructorOperatorIself,_constructorOperatorItext) =
                (constructorOperator_ (_constructorOperatorOppMode))
            ( _rightPatternIself,_rightPatternItext) =
                (rightPattern_ (_rightPatternOppMode))
            -- "./Pretty.inc.ag"(line 1028, column 9)
            (_constructorOperatorOppMode@_) =
                _lhsIppMode { infixpos = True }
            -- "./Pretty.inc.ag"(line 1024, column 9)
            (_text@_) =
                hang 2 $
                  _leftPatternItext
                    </> _constructorOperatorItext
                    <+> _rightPatternItext
            -- self rule
            (_self@_) =
                Pattern_InfixConstructor _rangeIself _leftPatternIself _constructorOperatorIself _rightPatternIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_leftPatternOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_rightPatternOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Pattern_Irrefutable :: (T_Range) ->
                           (T_Pattern) ->
                           (T_Pattern)
sem_Pattern_Irrefutable (range_) (pattern_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Pattern)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _patternIself :: (Pattern)
            _patternItext :: (Doc)
            _patternOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _patternIself,_patternItext) =
                (pattern_ (_patternOppMode))
            -- "./Pretty.inc.ag"(line 1050, column 9)
            (_text@_) =
                text "~" <> _patternItext
            -- self rule
            (_self@_) =
                Pattern_Irrefutable _rangeIself _patternIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_patternOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Pattern_List :: (T_Range) ->
                    (T_Patterns) ->
                    (T_Pattern)
sem_Pattern_List (range_) (patterns_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Pattern)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _patternsIself :: (Patterns)
            _patternsItext :: ([Doc])
            _patternsOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _patternsIself,_patternsItext) =
                (patterns_ (_patternsOppMode))
            -- "./Pretty.inc.ag"(line 1032, column 9)
            (_text@_) =
                uuList _patternsItext
            -- self rule
            (_self@_) =
                Pattern_List _rangeIself _patternsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_patternsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Pattern_Literal :: (T_Range) ->
                       (T_Literal) ->
                       (T_Pattern)
sem_Pattern_Literal (range_) (literal_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Pattern)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _literalIself :: (Literal)
            _literalItext :: (Doc)
            _literalOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _literalIself,_literalItext) =
                (literal_ (_literalOppMode))
            -- "./Pretty.inc.ag"(line 1009, column 9)
            (_text@_) =
                _literalItext
            -- self rule
            (_self@_) =
                Pattern_Literal _rangeIself _literalIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_literalOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Pattern_Negate :: (T_Range) ->
                      (T_Literal) ->
                      (T_Pattern)
sem_Pattern_Negate (range_) (literal_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Pattern)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _literalIself :: (Literal)
            _literalItext :: (Doc)
            _literalOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _literalIself,_literalItext) =
                (literal_ (_literalOppMode))
            -- "./Pretty.inc.ag"(line 1041, column 9)
            (_text@_) =
                text "-" <> _literalItext
            -- self rule
            (_self@_) =
                Pattern_Negate _rangeIself _literalIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_literalOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Pattern_Parenthesized :: (T_Range) ->
                             (T_Pattern) ->
                             (T_Pattern)
sem_Pattern_Parenthesized (range_) (pattern_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Pattern)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _patternIself :: (Pattern)
            _patternItext :: (Doc)
            _patternOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _patternIself,_patternItext) =
                (pattern_ (_patternOppMode))
            -- "./Pretty.inc.ag"(line 1021, column 9)
            (_text@_) =
                parens _patternItext
            -- self rule
            (_self@_) =
                Pattern_Parenthesized _rangeIself _patternIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_patternOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Pattern_Record :: (T_Range) ->
                      (T_Name) ->
                      (T_RecordPatternBindings) ->
                      (T_Pattern)
sem_Pattern_Record (range_) (name_) (recordPatternBindings_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Pattern)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _recordPatternBindingsIself :: (RecordPatternBindings)
            _recordPatternBindingsItext :: ([Doc])
            _recordPatternBindingsOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _recordPatternBindingsIself,_recordPatternBindingsItext) =
                (recordPatternBindings_ (_recordPatternBindingsOppMode))
            -- "./Pretty.inc.ag"(line 1038, column 9)
            (_text@_) =
                hang 2 $ _nameItext </> uuRecord _recordPatternBindingsItext
            -- self rule
            (_self@_) =
                Pattern_Record _rangeIself _nameIself _recordPatternBindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_recordPatternBindingsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Pattern_Successor :: (T_Range) ->
                         (T_Name) ->
                         (T_Literal) ->
                         (T_Pattern)
sem_Pattern_Successor (range_) (name_) (literal_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Pattern)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _literalIself :: (Literal)
            _literalItext :: (Doc)
            _literalOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _literalIself,_literalItext) =
                (literal_ (_literalOppMode))
            -- "./Pretty.inc.ag"(line 1053, column 9)
            (_text@_) =
                _nameItext <+> text "+" <+> _literalItext
            -- self rule
            (_self@_) =
                Pattern_Successor _rangeIself _nameIself _literalIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_literalOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Pattern_Tuple :: (T_Range) ->
                     (T_Patterns) ->
                     (T_Pattern)
sem_Pattern_Tuple (range_) (patterns_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Pattern)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _patternsIself :: (Patterns)
            _patternsItext :: ([Doc])
            _patternsOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _patternsIself,_patternsItext) =
                (patterns_ (_patternsOppMode))
            -- "./Pretty.inc.ag"(line 1035, column 9)
            (_text@_) =
                uuTuple _patternsItext
            -- self rule
            (_self@_) =
                Pattern_Tuple _rangeIself _patternsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_patternsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Pattern_Variable :: (T_Range) ->
                        (T_Name) ->
                        (T_Pattern)
sem_Pattern_Variable (range_) (name_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Pattern)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            -- "./Pretty.inc.ag"(line 1013, column 9)
            (_nameOppMode@_) =
                _lhsIppMode { unqualified = True }
            -- "./Pretty.inc.ag"(line 1012, column 9)
            (_text@_) =
                _nameItext
            -- self rule
            (_self@_) =
                Pattern_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Pattern_Wildcard :: (T_Range) ->
                        (T_Pattern)
sem_Pattern_Wildcard (range_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Pattern)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            -- "./Pretty.inc.ag"(line 1047, column 9)
            (_text@_) =
                text "_"
            -- self rule
            (_self@_) =
                Pattern_Wildcard _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
-- Patterns ----------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : [Doc]

-}
{-
   local variables for Patterns.Cons:
      self

-}
{-
   local variables for Patterns.Nil:
      self

-}
-- semantic domain
type T_Patterns = (PPMode) ->
                  ( (Patterns),([Doc]))
-- cata
sem_Patterns :: (Patterns) ->
                (T_Patterns)
sem_Patterns (list) =
    (foldr (sem_Patterns_Cons) (sem_Patterns_Nil) ((map sem_Pattern list)))
sem_Patterns_Cons :: (T_Pattern) ->
                     (T_Patterns) ->
                     (T_Patterns)
sem_Patterns_Cons (hd_) (tl_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Patterns)
            _lhsOtext :: ([Doc])
            _hdIself :: (Pattern)
            _hdItext :: (Doc)
            _hdOppMode :: (PPMode)
            _tlIself :: (Patterns)
            _tlItext :: ([Doc])
            _tlOppMode :: (PPMode)
            ( _hdIself,_hdItext) =
                (hd_ (_hdOppMode))
            ( _tlIself,_tlItext) =
                (tl_ (_tlOppMode))
            -- use rule
            (_lhsOtext@_) =
                _hdItext : _tlItext
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_hdOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_tlOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Patterns_Nil :: (T_Patterns)
sem_Patterns_Nil  =
    \ _lhsIppMode ->
        let _lhsOself :: (Patterns)
            _lhsOtext :: ([Doc])
            -- use rule
            (_lhsOtext@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOself,_lhsOtext)
-- Position ----------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for Position.Position:
      text
      self

-}
{-
   local variables for Position.Unknown:
      text
      self

-}
-- semantic domain
type T_Position = (PPMode) ->
                  ( (Position),(Doc))
-- cata
sem_Position :: (Position) ->
                (T_Position)
sem_Position ((Position_Position (_filename) (_line) (_column))) =
    (sem_Position_Position (_filename) (_line) (_column))
sem_Position ((Position_Unknown )) =
    (sem_Position_Unknown )
sem_Position_Position :: (String) ->
                         (Int) ->
                         (Int) ->
                         (T_Position)
sem_Position_Position (filename_) (line_) (column_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Position)
            _lhsOtext :: (Doc)
            -- "./Pretty.inc.ag"(line 1174, column 9)
            (_text@_) =
                text filename_ <> tupled [int line_, int column_]
            -- self rule
            (_self@_) =
                Position_Position filename_ line_ column_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
        in  ( _lhsOself,_lhsOtext)
sem_Position_Unknown :: (T_Position)
sem_Position_Unknown  =
    \ _lhsIppMode ->
        let _lhsOself :: (Position)
            _lhsOtext :: (Doc)
            -- "./Pretty.inc.ag"(line 1176, column 9)
            (_text@_) =
                text "?unknown?"
            -- self rule
            (_self@_) =
                Position_Unknown
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
        in  ( _lhsOself,_lhsOtext)
-- Qualifier ---------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for Qualifier.Empty:
      text
      self

-}
{-
   local variables for Qualifier.Generator:
      text
      self

-}
{-
   local variables for Qualifier.Guard:
      text
      self

-}
{-
   local variables for Qualifier.Let:
      text
      self

-}
-- semantic domain
type T_Qualifier = (PPMode) ->
                   ( (Qualifier),(Doc))
-- cata
sem_Qualifier :: (Qualifier) ->
                 (T_Qualifier)
sem_Qualifier ((Qualifier_Empty (_range))) =
    (sem_Qualifier_Empty ((sem_Range (_range))))
sem_Qualifier ((Qualifier_Generator (_range) (_pattern) (_expression))) =
    (sem_Qualifier_Generator ((sem_Range (_range))) ((sem_Pattern (_pattern))) ((sem_Expression (_expression))))
sem_Qualifier ((Qualifier_Guard (_range) (_guard))) =
    (sem_Qualifier_Guard ((sem_Range (_range))) ((sem_Expression (_guard))))
sem_Qualifier ((Qualifier_Let (_range) (_declarations))) =
    (sem_Qualifier_Let ((sem_Range (_range))) ((sem_Declarations (_declarations))))
sem_Qualifier_Empty :: (T_Range) ->
                       (T_Qualifier)
sem_Qualifier_Empty (range_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Qualifier)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            -- "./Pretty.inc.ag"(line 915, column 9)
            (_text@_) =
                emptyPP
            -- self rule
            (_self@_) =
                Qualifier_Empty _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Qualifier_Generator :: (T_Range) ->
                           (T_Pattern) ->
                           (T_Expression) ->
                           (T_Qualifier)
sem_Qualifier_Generator (range_) (pattern_) (expression_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Qualifier)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _patternIself :: (Pattern)
            _patternItext :: (Doc)
            _patternOppMode :: (PPMode)
            _expressionIself :: (Expression)
            _expressionItext :: (Doc)
            _expressionOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _patternIself,_patternItext) =
                (pattern_ (_patternOppMode))
            ( _expressionIself,_expressionItext) =
                (expression_ (_expressionOppMode))
            -- "./Pretty.inc.ag"(line 913, column 9)
            (_text@_) =
                hang 2 $ _patternItext </> text "<-" <+> _expressionItext
            -- self rule
            (_self@_) =
                Qualifier_Generator _rangeIself _patternIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_patternOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_expressionOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Qualifier_Guard :: (T_Range) ->
                       (T_Expression) ->
                       (T_Qualifier)
sem_Qualifier_Guard (range_) (guard_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Qualifier)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _guardIself :: (Expression)
            _guardItext :: (Doc)
            _guardOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _guardIself,_guardItext) =
                (guard_ (_guardOppMode))
            -- "./Pretty.inc.ag"(line 908, column 9)
            (_text@_) =
                _guardItext
            -- self rule
            (_self@_) =
                Qualifier_Guard _rangeIself _guardIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_guardOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Qualifier_Let :: (T_Range) ->
                     (T_Declarations) ->
                     (T_Qualifier)
sem_Qualifier_Let (range_) (declarations_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Qualifier)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _declarationsIself :: (Declarations)
            _declarationsItext :: ([Doc])
            _declarationsOkind :: (Maybe Kind)
            _declarationsOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _declarationsIself,_declarationsItext) =
                (declarations_ (_declarationsOkind) (_declarationsOppMode))
            -- "./Pretty.inc.ag"(line 911, column 9)
            (_declarationsOkind@_) =
                Nothing
            -- "./Pretty.inc.ag"(line 910, column 9)
            (_text@_) =
                hang 2 $ text "let" </> uuDecls _declarationsItext
            -- self rule
            (_self@_) =
                Qualifier_Let _rangeIself _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_declarationsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
-- Qualifiers --------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : [Doc]

-}
{-
   local variables for Qualifiers.Cons:
      self

-}
{-
   local variables for Qualifiers.Nil:
      self

-}
-- semantic domain
type T_Qualifiers = (PPMode) ->
                    ( (Qualifiers),([Doc]))
-- cata
sem_Qualifiers :: (Qualifiers) ->
                  (T_Qualifiers)
sem_Qualifiers (list) =
    (foldr (sem_Qualifiers_Cons) (sem_Qualifiers_Nil) ((map sem_Qualifier list)))
sem_Qualifiers_Cons :: (T_Qualifier) ->
                       (T_Qualifiers) ->
                       (T_Qualifiers)
sem_Qualifiers_Cons (hd_) (tl_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Qualifiers)
            _lhsOtext :: ([Doc])
            _hdIself :: (Qualifier)
            _hdItext :: (Doc)
            _hdOppMode :: (PPMode)
            _tlIself :: (Qualifiers)
            _tlItext :: ([Doc])
            _tlOppMode :: (PPMode)
            ( _hdIself,_hdItext) =
                (hd_ (_hdOppMode))
            ( _tlIself,_tlItext) =
                (tl_ (_tlOppMode))
            -- use rule
            (_lhsOtext@_) =
                _hdItext : _tlItext
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_hdOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_tlOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Qualifiers_Nil :: (T_Qualifiers)
sem_Qualifiers_Nil  =
    \ _lhsIppMode ->
        let _lhsOself :: (Qualifiers)
            _lhsOtext :: ([Doc])
            -- use rule
            (_lhsOtext@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOself,_lhsOtext)
-- Range -------------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for Range.Range:
      text
      self

-}
-- semantic domain
type T_Range = (PPMode) ->
               ( (Range),(Doc))
-- cata
sem_Range :: (Range) ->
             (T_Range)
sem_Range ((Range_Range (_start) (_stop))) =
    (sem_Range_Range ((sem_Position (_start))) ((sem_Position (_stop))))
sem_Range_Range :: (T_Position) ->
                   (T_Position) ->
                   (T_Range)
sem_Range_Range (start_) (stop_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Range)
            _lhsOtext :: (Doc)
            _startIself :: (Position)
            _startItext :: (Doc)
            _startOppMode :: (PPMode)
            _stopIself :: (Position)
            _stopItext :: (Doc)
            _stopOppMode :: (PPMode)
            ( _startIself,_startItext) =
                (start_ (_startOppMode))
            ( _stopIself,_stopItext) =
                (stop_ (_stopOppMode))
            -- "./Pretty.inc.ag"(line 1170, column 9)
            (_text@_) =
                text "{-" <+> _startItext <+> text ", " <+> _stopItext <+> text "-}"
            -- self rule
            (_self@_) =
                Range_Range _startIself _stopIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_startOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_stopOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
-- Reassignment ------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for Reassignment.Reassignment:
      text
      self

-}
-- semantic domain
type T_Reassignment = (PPMode) ->
                      ( (Reassignment),(Doc))
-- cata
sem_Reassignment :: (Reassignment) ->
                    (T_Reassignment)
sem_Reassignment ((Reassignment_Reassignment (_range) (_name) (_as))) =
    (sem_Reassignment_Reassignment ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Name (_as))))
sem_Reassignment_Reassignment :: (T_Range) ->
                                 (T_Name) ->
                                 (T_Name) ->
                                 (T_Reassignment)
sem_Reassignment_Reassignment (range_) (name_) (as_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Reassignment)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _asIisIdentifier :: (Bool)
            _asIisOperator :: (Bool)
            _asIisSpecial :: (Bool)
            _asIself :: (Name)
            _asItext :: (Doc)
            _asOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _asIisIdentifier,_asIisOperator,_asIisSpecial,_asIself,_asItext) =
                (as_ (_asOppMode))
            -- "./Pretty.inc.ag"(line 962, column 9)
            (_text@_) =
                _nameItext <+> text "as" <+> _asItext
            -- self rule
            (_self@_) =
                Reassignment_Reassignment _rangeIself _nameIself _asIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_asOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
-- Reassignments -----------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : [Doc]

-}
{-
   local variables for Reassignments.Cons:
      self

-}
{-
   local variables for Reassignments.Nil:
      self

-}
-- semantic domain
type T_Reassignments = (PPMode) ->
                       ( (Reassignments),([Doc]))
-- cata
sem_Reassignments :: (Reassignments) ->
                     (T_Reassignments)
sem_Reassignments (list) =
    (foldr (sem_Reassignments_Cons) (sem_Reassignments_Nil) ((map sem_Reassignment list)))
sem_Reassignments_Cons :: (T_Reassignment) ->
                          (T_Reassignments) ->
                          (T_Reassignments)
sem_Reassignments_Cons (hd_) (tl_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Reassignments)
            _lhsOtext :: ([Doc])
            _hdIself :: (Reassignment)
            _hdItext :: (Doc)
            _hdOppMode :: (PPMode)
            _tlIself :: (Reassignments)
            _tlItext :: ([Doc])
            _tlOppMode :: (PPMode)
            ( _hdIself,_hdItext) =
                (hd_ (_hdOppMode))
            ( _tlIself,_tlItext) =
                (tl_ (_tlOppMode))
            -- use rule
            (_lhsOtext@_) =
                _hdItext : _tlItext
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_hdOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_tlOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Reassignments_Nil :: (T_Reassignments)
sem_Reassignments_Nil  =
    \ _lhsIppMode ->
        let _lhsOself :: (Reassignments)
            _lhsOtext :: ([Doc])
            -- use rule
            (_lhsOtext@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOself,_lhsOtext)
-- RecordExpressionBinding -------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for RecordExpressionBinding.RecordExpressionBinding:
      text
      self

-}
-- semantic domain
type T_RecordExpressionBinding = (PPMode) ->
                                 ( (RecordExpressionBinding),(Doc))
-- cata
sem_RecordExpressionBinding :: (RecordExpressionBinding) ->
                               (T_RecordExpressionBinding)
sem_RecordExpressionBinding ((RecordExpressionBinding_RecordExpressionBinding (_range) (_name) (_expression))) =
    (sem_RecordExpressionBinding_RecordExpressionBinding ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Expression (_expression))))
sem_RecordExpressionBinding_RecordExpressionBinding :: (T_Range) ->
                                                       (T_Name) ->
                                                       (T_Expression) ->
                                                       (T_RecordExpressionBinding)
sem_RecordExpressionBinding_RecordExpressionBinding (range_) (name_) (expression_) =
    \ _lhsIppMode ->
        let _lhsOself :: (RecordExpressionBinding)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _expressionIself :: (Expression)
            _expressionItext :: (Doc)
            _expressionOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _expressionIself,_expressionItext) =
                (expression_ (_expressionOppMode))
            -- "./Pretty.inc.ag"(line 929, column 9)
            (_text@_) =
                hang 2 $ _nameItext </> text "=" <+> _expressionItext
            -- self rule
            (_self@_) =
                RecordExpressionBinding_RecordExpressionBinding _rangeIself _nameIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_expressionOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
-- RecordExpressionBindings ------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : [Doc]

-}
{-
   local variables for RecordExpressionBindings.Cons:
      self

-}
{-
   local variables for RecordExpressionBindings.Nil:
      self

-}
-- semantic domain
type T_RecordExpressionBindings = (PPMode) ->
                                  ( (RecordExpressionBindings),([Doc]))
-- cata
sem_RecordExpressionBindings :: (RecordExpressionBindings) ->
                                (T_RecordExpressionBindings)
sem_RecordExpressionBindings (list) =
    (foldr (sem_RecordExpressionBindings_Cons) (sem_RecordExpressionBindings_Nil) ((map sem_RecordExpressionBinding list)))
sem_RecordExpressionBindings_Cons :: (T_RecordExpressionBinding) ->
                                     (T_RecordExpressionBindings) ->
                                     (T_RecordExpressionBindings)
sem_RecordExpressionBindings_Cons (hd_) (tl_) =
    \ _lhsIppMode ->
        let _lhsOself :: (RecordExpressionBindings)
            _lhsOtext :: ([Doc])
            _hdIself :: (RecordExpressionBinding)
            _hdItext :: (Doc)
            _hdOppMode :: (PPMode)
            _tlIself :: (RecordExpressionBindings)
            _tlItext :: ([Doc])
            _tlOppMode :: (PPMode)
            ( _hdIself,_hdItext) =
                (hd_ (_hdOppMode))
            ( _tlIself,_tlItext) =
                (tl_ (_tlOppMode))
            -- use rule
            (_lhsOtext@_) =
                _hdItext : _tlItext
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_hdOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_tlOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_RecordExpressionBindings_Nil :: (T_RecordExpressionBindings)
sem_RecordExpressionBindings_Nil  =
    \ _lhsIppMode ->
        let _lhsOself :: (RecordExpressionBindings)
            _lhsOtext :: ([Doc])
            -- use rule
            (_lhsOtext@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOself,_lhsOtext)
-- RecordPatternBinding ----------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for RecordPatternBinding.RecordPatternBinding:
      text
      self

-}
-- semantic domain
type T_RecordPatternBinding = (PPMode) ->
                              ( (RecordPatternBinding),(Doc))
-- cata
sem_RecordPatternBinding :: (RecordPatternBinding) ->
                            (T_RecordPatternBinding)
sem_RecordPatternBinding ((RecordPatternBinding_RecordPatternBinding (_range) (_name) (_pattern))) =
    (sem_RecordPatternBinding_RecordPatternBinding ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Pattern (_pattern))))
sem_RecordPatternBinding_RecordPatternBinding :: (T_Range) ->
                                                 (T_Name) ->
                                                 (T_Pattern) ->
                                                 (T_RecordPatternBinding)
sem_RecordPatternBinding_RecordPatternBinding (range_) (name_) (pattern_) =
    \ _lhsIppMode ->
        let _lhsOself :: (RecordPatternBinding)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _patternIself :: (Pattern)
            _patternItext :: (Doc)
            _patternOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _patternIself,_patternItext) =
                (pattern_ (_patternOppMode))
            -- "./Pretty.inc.ag"(line 933, column 9)
            (_text@_) =
                hang 2 $ _nameItext </> text "=" <+> _patternItext
            -- self rule
            (_self@_) =
                RecordPatternBinding_RecordPatternBinding _rangeIself _nameIself _patternIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_patternOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
-- RecordPatternBindings ---------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : [Doc]

-}
{-
   local variables for RecordPatternBindings.Cons:
      self

-}
{-
   local variables for RecordPatternBindings.Nil:
      self

-}
-- semantic domain
type T_RecordPatternBindings = (PPMode) ->
                               ( (RecordPatternBindings),([Doc]))
-- cata
sem_RecordPatternBindings :: (RecordPatternBindings) ->
                             (T_RecordPatternBindings)
sem_RecordPatternBindings (list) =
    (foldr (sem_RecordPatternBindings_Cons) (sem_RecordPatternBindings_Nil) ((map sem_RecordPatternBinding list)))
sem_RecordPatternBindings_Cons :: (T_RecordPatternBinding) ->
                                  (T_RecordPatternBindings) ->
                                  (T_RecordPatternBindings)
sem_RecordPatternBindings_Cons (hd_) (tl_) =
    \ _lhsIppMode ->
        let _lhsOself :: (RecordPatternBindings)
            _lhsOtext :: ([Doc])
            _hdIself :: (RecordPatternBinding)
            _hdItext :: (Doc)
            _hdOppMode :: (PPMode)
            _tlIself :: (RecordPatternBindings)
            _tlItext :: ([Doc])
            _tlOppMode :: (PPMode)
            ( _hdIself,_hdItext) =
                (hd_ (_hdOppMode))
            ( _tlIself,_tlItext) =
                (tl_ (_tlOppMode))
            -- use rule
            (_lhsOtext@_) =
                _hdItext : _tlItext
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_hdOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_tlOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_RecordPatternBindings_Nil :: (T_RecordPatternBindings)
sem_RecordPatternBindings_Nil  =
    \ _lhsIppMode ->
        let _lhsOself :: (RecordPatternBindings)
            _lhsOtext :: ([Doc])
            -- use rule
            (_lhsOtext@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOself,_lhsOtext)
-- RightHandSide -----------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 :  Doc -> Doc  

-}
{-
   local variables for RightHandSide.Expression:
      justText
      text
      self

-}
{-
   local variables for RightHandSide.Guarded:
      text
      self

-}
-- semantic domain
type T_RightHandSide = (PPMode) ->
                       ( (RightHandSide),( Doc -> Doc  ))
-- cata
sem_RightHandSide :: (RightHandSide) ->
                     (T_RightHandSide)
sem_RightHandSide ((RightHandSide_Expression (_range) (_expression) (_where))) =
    (sem_RightHandSide_Expression ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_MaybeDeclarations (_where))))
sem_RightHandSide ((RightHandSide_Guarded (_range) (_guardedexpressions) (_where))) =
    (sem_RightHandSide_Guarded ((sem_Range (_range))) ((sem_GuardedExpressions (_guardedexpressions))) ((sem_MaybeDeclarations (_where))))
sem_RightHandSide_Expression :: (T_Range) ->
                                (T_Expression) ->
                                (T_MaybeDeclarations) ->
                                (T_RightHandSide)
sem_RightHandSide_Expression (range_) (expression_) (where_) =
    \ _lhsIppMode ->
        let _lhsOself :: (RightHandSide)
            _lhsOtext :: ( Doc -> Doc  )
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _expressionIself :: (Expression)
            _expressionItext :: (Doc)
            _expressionOppMode :: (PPMode)
            _whereIself :: (MaybeDeclarations)
            _whereItext :: ( Maybe [Doc] )
            _whereOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _expressionIself,_expressionItext) =
                (expression_ (_expressionOppMode))
            ( _whereIself,_whereItext) =
                (where_ (_whereOppMode))
            -- "./Pretty.inc.ag"(line 992, column 9)
            (_justText@_) =
                _expressionItext
                  <> maybe emptyPP
                           (\ds -> emptyPP <$> (hang 2 $ text "where" <$> uuDecls ds))
                           _whereItext
            -- "./Pretty.inc.ag"(line 990, column 9)
            (_text@_) =
                \ assign -> assign <+> _justText
            -- self rule
            (_self@_) =
                RightHandSide_Expression _rangeIself _expressionIself _whereIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_expressionOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_whereOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_RightHandSide_Guarded :: (T_Range) ->
                             (T_GuardedExpressions) ->
                             (T_MaybeDeclarations) ->
                             (T_RightHandSide)
sem_RightHandSide_Guarded (range_) (guardedexpressions_) (where_) =
    \ _lhsIppMode ->
        let _lhsOself :: (RightHandSide)
            _lhsOtext :: ( Doc -> Doc  )
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _guardedexpressionsIself :: (GuardedExpressions)
            _guardedexpressionsItext :: ( [ Doc -> Doc ] )
            _guardedexpressionsOppMode :: (PPMode)
            _whereIself :: (MaybeDeclarations)
            _whereItext :: ( Maybe [Doc] )
            _whereOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _guardedexpressionsIself,_guardedexpressionsItext) =
                (guardedexpressions_ (_guardedexpressionsOppMode))
            ( _whereIself,_whereItext) =
                (where_ (_whereOppMode))
            -- "./Pretty.inc.ag"(line 998, column 9)
            (_text@_) =
                \ assign -> vsep (zipWith ($) _guardedexpressionsItext (repeat assign))
                  <> maybe emptyPP
                           (\ds -> emptyPP <$> (hang 2 $ text "where" <$> uuDecls ds))
                           _whereItext
            -- self rule
            (_self@_) =
                RightHandSide_Guarded _rangeIself _guardedexpressionsIself _whereIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_guardedexpressionsOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_whereOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
-- SimpleType --------------------------------------------------
{-
   inherited attributes:
      kind                 : Maybe Kind
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for SimpleType.SimpleType:
      ppMode
      text
      self

-}
-- semantic domain
type T_SimpleType = (Maybe Kind) ->
                    (PPMode) ->
                    ( (SimpleType),(Doc))
-- cata
sem_SimpleType :: (SimpleType) ->
                  (T_SimpleType)
sem_SimpleType ((SimpleType_SimpleType (_range) (_name) (_typevariables))) =
    (sem_SimpleType_SimpleType ((sem_Range (_range))) ((sem_Name (_name))) ((sem_KindAnnotatedNames (_typevariables))))
sem_SimpleType_SimpleType :: (T_Range) ->
                             (T_Name) ->
                             (T_KindAnnotatedNames) ->
                             (T_SimpleType)
sem_SimpleType_SimpleType (range_) (name_) (typevariables_) =
    \ _lhsIkind
      _lhsIppMode ->
        let _lhsOself :: (SimpleType)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _typevariablesIfull :: ([Doc])
            _typevariablesIself :: (KindAnnotatedNames)
            _typevariablesItext :: ([Doc])
            _typevariablesOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _typevariablesIfull,_typevariablesIself,_typevariablesItext) =
                (typevariables_ (_typevariablesOppMode))
            -- "./Pretty.inc.ag"(line 702, column 9)
            (_ppMode@_) =
                _lhsIppMode { unqualified = True, nosymbol = True }
            -- "./Pretty.inc.ag"(line 700, column 9)
            (_text@_) =
                foldl (<+>) _nameItext
                            (ppAnnotatedVars parens _lhsIkind _typevariablesItext)
            -- self rule
            (_self@_) =
                SimpleType_SimpleType _rangeIself _nameIself _typevariablesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (from local)
            (_rangeOppMode@_) =
                _ppMode
            -- copy rule (from local)
            (_nameOppMode@_) =
                _ppMode
            -- copy rule (from local)
            (_typevariablesOppMode@_) =
                _ppMode
        in  ( _lhsOself,_lhsOtext)
-- Statement ---------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for Statement.Empty:
      text
      self

-}
{-
   local variables for Statement.Expression:
      text
      self

-}
{-
   local variables for Statement.Generator:
      text
      self

-}
{-
   local variables for Statement.Let:
      text
      self

-}
-- semantic domain
type T_Statement = (PPMode) ->
                   ( (Statement),(Doc))
-- cata
sem_Statement :: (Statement) ->
                 (T_Statement)
sem_Statement ((Statement_Empty (_range))) =
    (sem_Statement_Empty ((sem_Range (_range))))
sem_Statement ((Statement_Expression (_range) (_expression))) =
    (sem_Statement_Expression ((sem_Range (_range))) ((sem_Expression (_expression))))
sem_Statement ((Statement_Generator (_range) (_pattern) (_expression))) =
    (sem_Statement_Generator ((sem_Range (_range))) ((sem_Pattern (_pattern))) ((sem_Expression (_expression))))
sem_Statement ((Statement_Let (_range) (_declarations))) =
    (sem_Statement_Let ((sem_Range (_range))) ((sem_Declarations (_declarations))))
sem_Statement_Empty :: (T_Range) ->
                       (T_Statement)
sem_Statement_Empty (range_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Statement)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            -- "./Pretty.inc.ag"(line 904, column 9)
            (_text@_) =
                emptyPP
            -- self rule
            (_self@_) =
                Statement_Empty _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Statement_Expression :: (T_Range) ->
                            (T_Expression) ->
                            (T_Statement)
sem_Statement_Expression (range_) (expression_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Statement)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _expressionIself :: (Expression)
            _expressionItext :: (Doc)
            _expressionOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _expressionIself,_expressionItext) =
                (expression_ (_expressionOppMode))
            -- "./Pretty.inc.ag"(line 897, column 9)
            (_text@_) =
                _expressionItext
            -- self rule
            (_self@_) =
                Statement_Expression _rangeIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_expressionOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Statement_Generator :: (T_Range) ->
                           (T_Pattern) ->
                           (T_Expression) ->
                           (T_Statement)
sem_Statement_Generator (range_) (pattern_) (expression_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Statement)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _patternIself :: (Pattern)
            _patternItext :: (Doc)
            _patternOppMode :: (PPMode)
            _expressionIself :: (Expression)
            _expressionItext :: (Doc)
            _expressionOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _patternIself,_patternItext) =
                (pattern_ (_patternOppMode))
            ( _expressionIself,_expressionItext) =
                (expression_ (_expressionOppMode))
            -- "./Pretty.inc.ag"(line 902, column 9)
            (_text@_) =
                hang 2 $ _patternItext </> text "<-" <+> _expressionItext
            -- self rule
            (_self@_) =
                Statement_Generator _rangeIself _patternIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_patternOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_expressionOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Statement_Let :: (T_Range) ->
                     (T_Declarations) ->
                     (T_Statement)
sem_Statement_Let (range_) (declarations_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Statement)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _declarationsIself :: (Declarations)
            _declarationsItext :: ([Doc])
            _declarationsOkind :: (Maybe Kind)
            _declarationsOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _declarationsIself,_declarationsItext) =
                (declarations_ (_declarationsOkind) (_declarationsOppMode))
            -- "./Pretty.inc.ag"(line 900, column 9)
            (_declarationsOkind@_) =
                Nothing
            -- "./Pretty.inc.ag"(line 899, column 9)
            (_text@_) =
                hang 2 $ text "let" </> uuDecls _declarationsItext
            -- self rule
            (_self@_) =
                Statement_Let _rangeIself _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_declarationsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
-- Statements --------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : [Doc]

-}
{-
   local variables for Statements.Cons:
      self

-}
{-
   local variables for Statements.Nil:
      self

-}
-- semantic domain
type T_Statements = (PPMode) ->
                    ( (Statements),([Doc]))
-- cata
sem_Statements :: (Statements) ->
                  (T_Statements)
sem_Statements (list) =
    (foldr (sem_Statements_Cons) (sem_Statements_Nil) ((map sem_Statement list)))
sem_Statements_Cons :: (T_Statement) ->
                       (T_Statements) ->
                       (T_Statements)
sem_Statements_Cons (hd_) (tl_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Statements)
            _lhsOtext :: ([Doc])
            _hdIself :: (Statement)
            _hdItext :: (Doc)
            _hdOppMode :: (PPMode)
            _tlIself :: (Statements)
            _tlItext :: ([Doc])
            _tlOppMode :: (PPMode)
            ( _hdIself,_hdItext) =
                (hd_ (_hdOppMode))
            ( _tlIself,_tlItext) =
                (tl_ (_tlOppMode))
            -- use rule
            (_lhsOtext@_) =
                _hdItext : _tlItext
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_hdOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_tlOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Statements_Nil :: (T_Statements)
sem_Statements_Nil  =
    \ _lhsIppMode ->
        let _lhsOself :: (Statements)
            _lhsOtext :: ([Doc])
            -- use rule
            (_lhsOtext@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOself,_lhsOtext)
-- Strings -----------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : [Doc]

-}
{-
   local variables for Strings.Cons:
      text
      self

-}
{-
   local variables for Strings.Nil:
      text
      self

-}
-- semantic domain
type T_Strings = (PPMode) ->
                 ( (Strings),([Doc]))
-- cata
sem_Strings :: (Strings) ->
               (T_Strings)
sem_Strings (list) =
    (foldr (sem_Strings_Cons) (sem_Strings_Nil) (list))
sem_Strings_Cons :: (String) ->
                    (T_Strings) ->
                    (T_Strings)
sem_Strings_Cons (hd_) (tl_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Strings)
            _lhsOtext :: ([Doc])
            _tlIself :: (Strings)
            _tlItext :: ([Doc])
            _tlOppMode :: (PPMode)
            ( _tlIself,_tlItext) =
                (tl_ (_tlOppMode))
            -- "./Pretty.inc.ag"(line 1180, column 9)
            (_text@_) =
                text hd_ : _tlItext
            -- use rule
            (_lhsOtext@_) =
                _text
            -- self rule
            (_self@_) =
                (:) hd_ _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_tlOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Strings_Nil :: (T_Strings)
sem_Strings_Nil  =
    \ _lhsIppMode ->
        let _lhsOself :: (Strings)
            _lhsOtext :: ([Doc])
            -- "./Pretty.inc.ag"(line 1182, column 9)
            (_text@_) =
                []
            -- use rule
            (_lhsOtext@_) =
                _text
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOself,_lhsOtext)
-- Type --------------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for Type.Application:
      text
      self

-}
{-
   local variables for Type.Con:
      text
      self

-}
{-
   local variables for Type.Constructor:
      text
      self

-}
{-
   local variables for Type.ConstructorCase:
      text
      self

-}
{-
   local variables for Type.Exists:
      text
      self

-}
{-
   local variables for Type.Forall:
      text
      self

-}
{-
   local variables for Type.KindApplication:
      text
      self

-}
{-
   local variables for Type.KindStarCase:
      text
      self

-}
{-
   local variables for Type.Kinded:
      self

-}
{-
   local variables for Type.Label:
      text
      self

-}
{-
   local variables for Type.Parenthesized:
      text
      self

-}
{-
   local variables for Type.Qualified:
      contextDoc
      text
      self

-}
{-
   local variables for Type.TypeApplication:
      text
      self

-}
{-
   local variables for Type.TypeSignature:
      text
      self

-}
{-
   local variables for Type.Variable:
      ppMode
      text
      self

-}
-- semantic domain
type T_Type = (PPMode) ->
              ( (Type),(Doc))
-- cata
sem_Type :: (Type) ->
            (T_Type)
sem_Type ((Type_Application (_range) (_prefix) (_function) (_arguments))) =
    (sem_Type_Application ((sem_Range (_range))) (_prefix) ((sem_Type (_function))) ((sem_Types (_arguments))))
sem_Type ((Type_Con (_range) (_name))) =
    (sem_Type_Con ((sem_Range (_range))) ((sem_Name (_name))))
sem_Type ((Type_Constructor (_range) (_name))) =
    (sem_Type_Constructor ((sem_Range (_range))) ((sem_Name (_name))))
sem_Type ((Type_ConstructorCase (_range) (_name))) =
    (sem_Type_ConstructorCase ((sem_Range (_range))) ((sem_Name (_name))))
sem_Type ((Type_Exists (_range) (_typevariables) (_type))) =
    (sem_Type_Exists ((sem_Range (_range))) ((sem_Names (_typevariables))) ((sem_Type (_type))))
sem_Type ((Type_Forall (_range) (_typevariables) (_type))) =
    (sem_Type_Forall ((sem_Range (_range))) ((sem_Names (_typevariables))) ((sem_Type (_type))))
sem_Type ((Type_KindApplication (_range) (_name) (_kind))) =
    (sem_Type_KindApplication ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Kind (_kind))))
sem_Type ((Type_KindStarCase (_range))) =
    (sem_Type_KindStarCase ((sem_Range (_range))))
sem_Type ((Type_Kinded (_range) (_name) (_kind))) =
    (sem_Type_Kinded ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Kind (_kind))))
sem_Type ((Type_Label (_range) (_name))) =
    (sem_Type_Label ((sem_Range (_range))) ((sem_Name (_name))))
sem_Type ((Type_Parenthesized (_range) (_type))) =
    (sem_Type_Parenthesized ((sem_Range (_range))) ((sem_Type (_type))))
sem_Type ((Type_Qualified (_range) (_context) (_type))) =
    (sem_Type_Qualified ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_Type (_type))))
sem_Type ((Type_TypeApplication (_range) (_name) (_type))) =
    (sem_Type_TypeApplication ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Type (_type))))
sem_Type ((Type_TypeSignature (_range) (_generics) (_parametrics))) =
    (sem_Type_TypeSignature ((sem_Range (_range))) ((sem_KindAnnotatedNames (_generics))) ((sem_Types (_parametrics))))
sem_Type ((Type_Variable (_range) (_name))) =
    (sem_Type_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Type_Application :: (T_Range) ->
                        (Bool) ->
                        (T_Type) ->
                        (T_Types) ->
                        (T_Type)
sem_Type_Application (range_) (prefix_) (function_) (arguments_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Type)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _functionIself :: (Type)
            _functionItext :: (Doc)
            _functionOppMode :: (PPMode)
            _argumentsIself :: (Types)
            _argumentsItext :: ([Doc])
            _argumentsOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _functionIself,_functionItext) =
                (function_ (_functionOppMode))
            ( _argumentsIself,_argumentsItext) =
                (arguments_ (_argumentsOppMode))
            -- "./Pretty.inc.ag"(line 574, column 9)
            (_functionOppMode@_) =
                _lhsIppMode { infixpos = not prefix_ }
            -- "./Pretty.inc.ag"(line 564, column 9)
            (_text@_) =
                if prefix_ then
                  group . hang 2 $ _functionItext <$> (vsep _argumentsItext)
                else if show _functionItext == "[]" then
                  uuList _argumentsItext
                else if isTupleString (show _functionItext) then
                  uuTuple _argumentsItext
                else
                  case _argumentsItext of
                    [a,b] -> group . hang 2 $ a <$> _functionItext <+> b
                    as    -> text "{- error: Unknown special application notation -}"
            -- self rule
            (_self@_) =
                Type_Application _rangeIself prefix_ _functionIself _argumentsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_argumentsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Type_Con :: (T_Range) ->
                (T_Name) ->
                (T_Type)
sem_Type_Con (range_) (name_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Type)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            -- "./Pretty.inc.ag"(line 613, column 9)
            (_text@_) =
                text "GH.Prelude.Con"
                  <+> text "{-" <+> _nameItext
                  <+> text "-}"
            -- self rule
            (_self@_) =
                Type_Con _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Type_Constructor :: (T_Range) ->
                        (T_Name) ->
                        (T_Type)
sem_Type_Constructor (range_) (name_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Type)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            -- "./Pretty.inc.ag"(line 581, column 9)
            (_text@_) =
                _nameItext
            -- self rule
            (_self@_) =
                Type_Constructor _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Type_ConstructorCase :: (T_Range) ->
                            (T_Name) ->
                            (T_Type)
sem_Type_ConstructorCase (range_) (name_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Type)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            -- "./Pretty.inc.ag"(line 623, column 9)
            (_text@_) =
                text "case" <+> _nameItext
            -- self rule
            (_self@_) =
                Type_ConstructorCase _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Type_Exists :: (T_Range) ->
                   (T_Names) ->
                   (T_Type) ->
                   (T_Type)
sem_Type_Exists (range_) (typevariables_) (type_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Type)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _typevariablesIisIdentifier :: ([Bool])
            _typevariablesIisOperator :: ([Bool])
            _typevariablesIisSpecial :: ([Bool])
            _typevariablesIself :: (Names)
            _typevariablesItext :: ([Doc])
            _typevariablesOppMode :: (PPMode)
            _typeIself :: (Type)
            _typeItext :: (Doc)
            _typeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _typevariablesIisIdentifier,_typevariablesIisOperator,_typevariablesIisSpecial,_typevariablesIself,_typevariablesItext) =
                (typevariables_ (_typevariablesOppMode))
            ( _typeIself,_typeItext) =
                (type_ (_typeOppMode))
            -- "./Pretty.inc.ag"(line 599, column 9)
            (_typevariablesOppMode@_) =
                _lhsIppMode { unqualified = True }
            -- "./Pretty.inc.ag"(line 596, column 9)
            (_text@_) =
                group . hang 2 $
                  foldl (<+>) (text "exists") _typevariablesItext <> text "."
                    <$> _typeItext
            -- self rule
            (_self@_) =
                Type_Exists _rangeIself _typevariablesIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_typeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Type_Forall :: (T_Range) ->
                   (T_Names) ->
                   (T_Type) ->
                   (T_Type)
sem_Type_Forall (range_) (typevariables_) (type_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Type)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _typevariablesIisIdentifier :: ([Bool])
            _typevariablesIisOperator :: ([Bool])
            _typevariablesIisSpecial :: ([Bool])
            _typevariablesIself :: (Names)
            _typevariablesItext :: ([Doc])
            _typevariablesOppMode :: (PPMode)
            _typeIself :: (Type)
            _typeItext :: (Doc)
            _typeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _typevariablesIisIdentifier,_typevariablesIisOperator,_typevariablesIisSpecial,_typevariablesIself,_typevariablesItext) =
                (typevariables_ (_typevariablesOppMode))
            ( _typeIself,_typeItext) =
                (type_ (_typeOppMode))
            -- "./Pretty.inc.ag"(line 593, column 9)
            (_typevariablesOppMode@_) =
                _lhsIppMode { unqualified = True }
            -- "./Pretty.inc.ag"(line 590, column 9)
            (_text@_) =
                group . hang 2 $
                  foldl (<+>) (text "forall") _typevariablesItext <> text "."
                    <$> _typeItext
            -- self rule
            (_self@_) =
                Type_Forall _rangeIself _typevariablesIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_typeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Type_KindApplication :: (T_Range) ->
                            (T_Name) ->
                            (T_Kind) ->
                            (T_Type)
sem_Type_KindApplication (range_) (name_) (kind_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Type)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _kindIneedsparens :: (Bool)
            _kindIself :: (Kind)
            _kindItext :: (Doc)
            _kindOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _kindIneedsparens,_kindIself,_kindItext) =
                (kind_ (_kindOppMode))
            -- "./Pretty.inc.ag"(line 610, column 9)
            (_text@_) =
                _nameItext <+> text "{[" <+> _kindItext <+> text "]}"
            -- self rule
            (_self@_) =
                Type_KindApplication _rangeIself _nameIself _kindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_kindOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Type_KindStarCase :: (T_Range) ->
                         (T_Type)
sem_Type_KindStarCase (range_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Type)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            -- "./Pretty.inc.ag"(line 626, column 9)
            (_text@_) =
                text "{- !!! error: Type.KindStarCase -}"
            -- self rule
            (_self@_) =
                Type_KindStarCase _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Type_Kinded :: (T_Range) ->
                   (T_Name) ->
                   (T_Kind) ->
                   (T_Type)
sem_Type_Kinded (range_) (name_) (kind_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Type)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _kindIneedsparens :: (Bool)
            _kindIself :: (Kind)
            _kindItext :: (Doc)
            _kindOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _kindIneedsparens,_kindIself,_kindItext) =
                (kind_ (_kindOppMode))
            -- self rule
            (_self@_) =
                Type_Kinded _rangeIself _nameIself _kindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOtext@_) =
                _kindItext
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_kindOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Type_Label :: (T_Range) ->
                  (T_Name) ->
                  (T_Type)
sem_Type_Label (range_) (name_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Type)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            -- "./Pretty.inc.ag"(line 618, column 9)
            (_text@_) =
                text "GH.Prelude.Label"
                  <+> text "{-" <+> _nameItext
                  <+> text "-}"
            -- self rule
            (_self@_) =
                Type_Label _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Type_Parenthesized :: (T_Range) ->
                          (T_Type) ->
                          (T_Type)
sem_Type_Parenthesized (range_) (type_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Type)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _typeIself :: (Type)
            _typeItext :: (Doc)
            _typeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _typeIself,_typeItext) =
                (type_ (_typeOppMode))
            -- "./Pretty.inc.ag"(line 602, column 9)
            (_text@_) =
                parens _typeItext
            -- self rule
            (_self@_) =
                Type_Parenthesized _rangeIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_typeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Type_Qualified :: (T_Range) ->
                      (T_ContextItems) ->
                      (T_Type) ->
                      (T_Type)
sem_Type_Qualified (range_) (context_) (type_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Type)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _contextIself :: (ContextItems)
            _contextItext :: ([Doc])
            _contextOppMode :: (PPMode)
            _typeIself :: (Type)
            _typeItext :: (Doc)
            _typeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _contextIself,_contextItext) =
                (context_ (_contextOppMode))
            ( _typeIself,_typeItext) =
                (type_ (_typeOppMode))
            -- "./Pretty.inc.ag"(line 587, column 9)
            (_contextDoc@_) =
                contextText _contextItext
            -- "./Pretty.inc.ag"(line 584, column 9)
            (_text@_) =
                group . hang 2 $
                  _contextDoc <$$> _typeItext
            -- self rule
            (_self@_) =
                Type_Qualified _rangeIself _contextIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_contextOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_typeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Type_TypeApplication :: (T_Range) ->
                            (T_Name) ->
                            (T_Type) ->
                            (T_Type)
sem_Type_TypeApplication (range_) (name_) (type_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Type)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _typeIself :: (Type)
            _typeItext :: (Doc)
            _typeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _typeIself,_typeItext) =
                (type_ (_typeOppMode))
            -- "./Pretty.inc.ag"(line 607, column 9)
            (_text@_) =
                _nameItext <+> text "{|" <+> _typeItext <+> text "|}"
            -- self rule
            (_self@_) =
                Type_TypeApplication _rangeIself _nameIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_typeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Type_TypeSignature :: (T_Range) ->
                          (T_KindAnnotatedNames) ->
                          (T_Types) ->
                          (T_Type)
sem_Type_TypeSignature (range_) (generics_) (parametrics_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Type)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _genericsIfull :: ([Doc])
            _genericsIself :: (KindAnnotatedNames)
            _genericsItext :: ([Doc])
            _genericsOppMode :: (PPMode)
            _parametricsIself :: (Types)
            _parametricsItext :: ([Doc])
            _parametricsOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _genericsIfull,_genericsIself,_genericsItext) =
                (generics_ (_genericsOppMode))
            ( _parametricsIself,_parametricsItext) =
                (parametrics_ (_parametricsOppMode))
            -- "./Pretty.inc.ag"(line 629, column 9)
            (_text@_) =
                text "{- !!! error: Type.TypeSignature -}"
            -- self rule
            (_self@_) =
                Type_TypeSignature _rangeIself _genericsIself _parametricsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_genericsOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_parametricsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Type_Variable :: (T_Range) ->
                     (T_Name) ->
                     (T_Type)
sem_Type_Variable (range_) (name_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Type)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            -- "./Pretty.inc.ag"(line 578, column 9)
            (_ppMode@_) =
                _lhsIppMode { unqualified = True }
            -- "./Pretty.inc.ag"(line 577, column 9)
            (_text@_) =
                _nameItext
            -- self rule
            (_self@_) =
                Type_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (from local)
            (_rangeOppMode@_) =
                _ppMode
            -- copy rule (from local)
            (_nameOppMode@_) =
                _ppMode
        in  ( _lhsOself,_lhsOtext)
-- TypeArgument ------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for TypeArgument.Constructor:
      text
      self

-}
{-
   local variables for TypeArgument.ConstructorCase:
      text
      self

-}
{-
   local variables for TypeArgument.DependencyStyle:
      text
      self

-}
{-
   local variables for TypeArgument.KindStarCase:
      text
      self

-}
{-
   local variables for TypeArgument.Label:
      text
      self

-}
{-
   local variables for TypeArgument.NamedType:
      text
      self

-}
{-
   local variables for TypeArgument.Variable:
      ppMode
      text
      self

-}
-- semantic domain
type T_TypeArgument = (PPMode) ->
                      ( (TypeArgument),(Doc))
-- cata
sem_TypeArgument :: (TypeArgument) ->
                    (T_TypeArgument)
sem_TypeArgument ((TypeArgument_Constructor (_range) (_variable))) =
    (sem_TypeArgument_Constructor ((sem_Range (_range))) ((sem_Name (_variable))))
sem_TypeArgument ((TypeArgument_ConstructorCase (_range) (_name))) =
    (sem_TypeArgument_ConstructorCase ((sem_Range (_range))) ((sem_Name (_name))))
sem_TypeArgument ((TypeArgument_DependencyStyle (_range) (_name) (_descriptor) (_variables))) =
    (sem_TypeArgument_DependencyStyle ((sem_Range (_range))) ((sem_Name (_name))) ((sem_MaybeName (_descriptor))) ((sem_Names (_variables))))
sem_TypeArgument ((TypeArgument_KindStarCase (_range))) =
    (sem_TypeArgument_KindStarCase ((sem_Range (_range))))
sem_TypeArgument ((TypeArgument_Label (_range) (_variable))) =
    (sem_TypeArgument_Label ((sem_Range (_range))) ((sem_Name (_variable))))
sem_TypeArgument ((TypeArgument_NamedType (_range) (_name))) =
    (sem_TypeArgument_NamedType ((sem_Range (_range))) ((sem_Name (_name))))
sem_TypeArgument ((TypeArgument_Variable (_range) (_name))) =
    (sem_TypeArgument_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_TypeArgument_Constructor :: (T_Range) ->
                                (T_Name) ->
                                (T_TypeArgument)
sem_TypeArgument_Constructor (range_) (variable_) =
    \ _lhsIppMode ->
        let _lhsOself :: (TypeArgument)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _variableIisIdentifier :: (Bool)
            _variableIisOperator :: (Bool)
            _variableIisSpecial :: (Bool)
            _variableIself :: (Name)
            _variableItext :: (Doc)
            _variableOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _variableIisIdentifier,_variableIisOperator,_variableIisSpecial,_variableIself,_variableItext) =
                (variable_ (_variableOppMode))
            -- "./Pretty.inc.ag"(line 650, column 9)
            (_variableOppMode@_) =
                _lhsIppMode { unqualified = True }
            -- "./Pretty.inc.ag"(line 649, column 9)
            (_text@_) =
                text "Con" <+> _variableItext
            -- self rule
            (_self@_) =
                TypeArgument_Constructor _rangeIself _variableIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_TypeArgument_ConstructorCase :: (T_Range) ->
                                    (T_Name) ->
                                    (T_TypeArgument)
sem_TypeArgument_ConstructorCase (range_) (name_) =
    \ _lhsIppMode ->
        let _lhsOself :: (TypeArgument)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            -- "./Pretty.inc.ag"(line 657, column 9)
            (_text@_) =
                text "case" <+> _nameItext
            -- self rule
            (_self@_) =
                TypeArgument_ConstructorCase _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_TypeArgument_DependencyStyle :: (T_Range) ->
                                    (T_Name) ->
                                    (T_MaybeName) ->
                                    (T_Names) ->
                                    (T_TypeArgument)
sem_TypeArgument_DependencyStyle (range_) (name_) (descriptor_) (variables_) =
    \ _lhsIppMode ->
        let _lhsOself :: (TypeArgument)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _descriptorIself :: (MaybeName)
            _descriptorItext :: ( Maybe Doc )
            _descriptorOppMode :: (PPMode)
            _variablesIisIdentifier :: ([Bool])
            _variablesIisOperator :: ([Bool])
            _variablesIisSpecial :: ([Bool])
            _variablesIself :: (Names)
            _variablesItext :: ([Doc])
            _variablesOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _descriptorIself,_descriptorItext) =
                (descriptor_ (_descriptorOppMode))
            ( _variablesIisIdentifier,_variablesIisOperator,_variablesIisSpecial,_variablesIself,_variablesItext) =
                (variables_ (_variablesOppMode))
            -- "./Pretty.inc.ag"(line 642, column 9)
            (_variablesOppMode@_) =
                _lhsIppMode { unqualified = True }
            -- "./Pretty.inc.ag"(line 641, column 9)
            (_descriptorOppMode@_) =
                _lhsIppMode { unqualified = True }
            -- "./Pretty.inc.ag"(line 640, column 9)
            (_text@_) =
                group . hang 2 $ _nameItext <$> (vsep _variablesItext)
            -- self rule
            (_self@_) =
                TypeArgument_DependencyStyle _rangeIself _nameIself _descriptorIself _variablesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_TypeArgument_KindStarCase :: (T_Range) ->
                                 (T_TypeArgument)
sem_TypeArgument_KindStarCase (range_) =
    \ _lhsIppMode ->
        let _lhsOself :: (TypeArgument)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            -- "./Pretty.inc.ag"(line 660, column 9)
            (_text@_) =
                text ":: *"
            -- self rule
            (_self@_) =
                TypeArgument_KindStarCase _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_TypeArgument_Label :: (T_Range) ->
                          (T_Name) ->
                          (T_TypeArgument)
sem_TypeArgument_Label (range_) (variable_) =
    \ _lhsIppMode ->
        let _lhsOself :: (TypeArgument)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _variableIisIdentifier :: (Bool)
            _variableIisOperator :: (Bool)
            _variableIisSpecial :: (Bool)
            _variableIself :: (Name)
            _variableItext :: (Doc)
            _variableOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _variableIisIdentifier,_variableIisOperator,_variableIisSpecial,_variableIself,_variableItext) =
                (variable_ (_variableOppMode))
            -- "./Pretty.inc.ag"(line 654, column 9)
            (_variableOppMode@_) =
                _lhsIppMode { unqualified = True }
            -- "./Pretty.inc.ag"(line 653, column 9)
            (_text@_) =
                text "Label" <+> _variableItext
            -- self rule
            (_self@_) =
                TypeArgument_Label _rangeIself _variableIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_TypeArgument_NamedType :: (T_Range) ->
                              (T_Name) ->
                              (T_TypeArgument)
sem_TypeArgument_NamedType (range_) (name_) =
    \ _lhsIppMode ->
        let _lhsOself :: (TypeArgument)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            -- "./Pretty.inc.ag"(line 637, column 9)
            (_text@_) =
                _nameItext
            -- self rule
            (_self@_) =
                TypeArgument_NamedType _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_TypeArgument_Variable :: (T_Range) ->
                             (T_Name) ->
                             (T_TypeArgument)
sem_TypeArgument_Variable (range_) (name_) =
    \ _lhsIppMode ->
        let _lhsOself :: (TypeArgument)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            -- "./Pretty.inc.ag"(line 646, column 9)
            (_ppMode@_) =
                _lhsIppMode { unqualified = True }
            -- "./Pretty.inc.ag"(line 645, column 9)
            (_text@_) =
                _nameItext
            -- self rule
            (_self@_) =
                TypeArgument_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (from local)
            (_rangeOppMode@_) =
                _ppMode
            -- copy rule (from local)
            (_nameOppMode@_) =
                _ppMode
        in  ( _lhsOself,_lhsOtext)
-- TypeArguments -----------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : [Doc]

-}
{-
   local variables for TypeArguments.Cons:
      self

-}
{-
   local variables for TypeArguments.Nil:
      self

-}
-- semantic domain
type T_TypeArguments = (PPMode) ->
                       ( (TypeArguments),([Doc]))
-- cata
sem_TypeArguments :: (TypeArguments) ->
                     (T_TypeArguments)
sem_TypeArguments (list) =
    (foldr (sem_TypeArguments_Cons) (sem_TypeArguments_Nil) ((map sem_TypeArgument list)))
sem_TypeArguments_Cons :: (T_TypeArgument) ->
                          (T_TypeArguments) ->
                          (T_TypeArguments)
sem_TypeArguments_Cons (hd_) (tl_) =
    \ _lhsIppMode ->
        let _lhsOself :: (TypeArguments)
            _lhsOtext :: ([Doc])
            _hdIself :: (TypeArgument)
            _hdItext :: (Doc)
            _hdOppMode :: (PPMode)
            _tlIself :: (TypeArguments)
            _tlItext :: ([Doc])
            _tlOppMode :: (PPMode)
            ( _hdIself,_hdItext) =
                (hd_ (_hdOppMode))
            ( _tlIself,_tlItext) =
                (tl_ (_tlOppMode))
            -- use rule
            (_lhsOtext@_) =
                _hdItext : _tlItext
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_hdOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_tlOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_TypeArguments_Nil :: (T_TypeArguments)
sem_TypeArguments_Nil  =
    \ _lhsIppMode ->
        let _lhsOself :: (TypeArguments)
            _lhsOtext :: ([Doc])
            -- use rule
            (_lhsOtext@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOself,_lhsOtext)
-- TypeIndexedBinding ------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : Doc

-}
{-
   local variables for TypeIndexedBinding.DefaultCase:
      text
      self

-}
{-
   local variables for TypeIndexedBinding.TypeIndexedBinding:
      text
      self

-}
-- semantic domain
type T_TypeIndexedBinding = (PPMode) ->
                            ( (TypeIndexedBinding),(Doc))
-- cata
sem_TypeIndexedBinding :: (TypeIndexedBinding) ->
                          (T_TypeIndexedBinding)
sem_TypeIndexedBinding ((TypeIndexedBinding_DefaultCase (_range) (_name) (_extended) (_reassignments))) =
    (sem_TypeIndexedBinding_DefaultCase ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Name (_extended))) ((sem_MaybeReassignments (_reassignments))))
sem_TypeIndexedBinding ((TypeIndexedBinding_TypeIndexedBinding (_range) (_name) (_typeargument) (_patterns) (_righthandside))) =
    (sem_TypeIndexedBinding_TypeIndexedBinding ((sem_Range (_range))) ((sem_Name (_name))) ((sem_TypeArgument (_typeargument))) ((sem_Patterns (_patterns))) ((sem_RightHandSide (_righthandside))))
sem_TypeIndexedBinding_DefaultCase :: (T_Range) ->
                                      (T_Name) ->
                                      (T_Name) ->
                                      (T_MaybeReassignments) ->
                                      (T_TypeIndexedBinding)
sem_TypeIndexedBinding_DefaultCase (range_) (name_) (extended_) (reassignments_) =
    \ _lhsIppMode ->
        let _lhsOself :: (TypeIndexedBinding)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _extendedIisIdentifier :: (Bool)
            _extendedIisOperator :: (Bool)
            _extendedIisSpecial :: (Bool)
            _extendedIself :: (Name)
            _extendedItext :: (Doc)
            _extendedOppMode :: (PPMode)
            _reassignmentsIself :: (MaybeReassignments)
            _reassignmentsItext :: ( Maybe [Doc] )
            _reassignmentsOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _extendedIisIdentifier,_extendedIisOperator,_extendedIisSpecial,_extendedIself,_extendedItext) =
                (extended_ (_extendedOppMode))
            ( _reassignmentsIself,_reassignmentsItext) =
                (reassignments_ (_reassignmentsOppMode))
            -- "./Pretty.inc.ag"(line 950, column 9)
            (_text@_) =
                hang 4 $ _nameItext <+> text "extends" <+> _extendedItext
                  <> whereText _reassignmentsItext
            -- self rule
            (_self@_) =
                TypeIndexedBinding_DefaultCase _rangeIself _nameIself _extendedIself _reassignmentsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_nameOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_extendedOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_reassignmentsOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_TypeIndexedBinding_TypeIndexedBinding :: (T_Range) ->
                                             (T_Name) ->
                                             (T_TypeArgument) ->
                                             (T_Patterns) ->
                                             (T_RightHandSide) ->
                                             (T_TypeIndexedBinding)
sem_TypeIndexedBinding_TypeIndexedBinding (range_) (name_) (typeargument_) (patterns_) (righthandside_) =
    \ _lhsIppMode ->
        let _lhsOself :: (TypeIndexedBinding)
            _lhsOtext :: (Doc)
            _rangeIself :: (Range)
            _rangeItext :: (Doc)
            _rangeOppMode :: (PPMode)
            _nameIisIdentifier :: (Bool)
            _nameIisOperator :: (Bool)
            _nameIisSpecial :: (Bool)
            _nameIself :: (Name)
            _nameItext :: (Doc)
            _nameOppMode :: (PPMode)
            _typeargumentIself :: (TypeArgument)
            _typeargumentItext :: (Doc)
            _typeargumentOppMode :: (PPMode)
            _patternsIself :: (Patterns)
            _patternsItext :: ([Doc])
            _patternsOppMode :: (PPMode)
            _righthandsideIself :: (RightHandSide)
            _righthandsideItext :: ( Doc -> Doc  )
            _righthandsideOppMode :: (PPMode)
            ( _rangeIself,_rangeItext) =
                (range_ (_rangeOppMode))
            ( _nameIisIdentifier,_nameIisOperator,_nameIisSpecial,_nameIself,_nameItext) =
                (name_ (_nameOppMode))
            ( _typeargumentIself,_typeargumentItext) =
                (typeargument_ (_typeargumentOppMode))
            ( _patternsIself,_patternsItext) =
                (patterns_ (_patternsOppMode))
            ( _righthandsideIself,_righthandsideItext) =
                (righthandside_ (_righthandsideOppMode))
            -- "./Pretty.inc.ag"(line 947, column 9)
            (_nameOppMode@_) =
                _lhsIppMode { unqualified = True }
            -- "./Pretty.inc.ag"(line 943, column 9)
            (_text@_) =
                hang 2 $
                  _nameItext <+> text "{|" <+> _typeargumentItext <+> text "|}"
                    <+> align (sep _patternsItext)
                    </> _righthandsideItext (text "=")
            -- self rule
            (_self@_) =
                TypeIndexedBinding_TypeIndexedBinding _rangeIself _nameIself _typeargumentIself _patternsIself _righthandsideIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (from local)
            (_lhsOtext@_) =
                _text
            -- copy rule (down)
            (_rangeOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_typeargumentOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_patternsOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_righthandsideOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
-- TypeIndexedBindings -----------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : [Doc]

-}
{-
   local variables for TypeIndexedBindings.Cons:
      self

-}
{-
   local variables for TypeIndexedBindings.Nil:
      self

-}
-- semantic domain
type T_TypeIndexedBindings = (PPMode) ->
                             ( (TypeIndexedBindings),([Doc]))
-- cata
sem_TypeIndexedBindings :: (TypeIndexedBindings) ->
                           (T_TypeIndexedBindings)
sem_TypeIndexedBindings (list) =
    (foldr (sem_TypeIndexedBindings_Cons) (sem_TypeIndexedBindings_Nil) ((map sem_TypeIndexedBinding list)))
sem_TypeIndexedBindings_Cons :: (T_TypeIndexedBinding) ->
                                (T_TypeIndexedBindings) ->
                                (T_TypeIndexedBindings)
sem_TypeIndexedBindings_Cons (hd_) (tl_) =
    \ _lhsIppMode ->
        let _lhsOself :: (TypeIndexedBindings)
            _lhsOtext :: ([Doc])
            _hdIself :: (TypeIndexedBinding)
            _hdItext :: (Doc)
            _hdOppMode :: (PPMode)
            _tlIself :: (TypeIndexedBindings)
            _tlItext :: ([Doc])
            _tlOppMode :: (PPMode)
            ( _hdIself,_hdItext) =
                (hd_ (_hdOppMode))
            ( _tlIself,_tlItext) =
                (tl_ (_tlOppMode))
            -- use rule
            (_lhsOtext@_) =
                _hdItext : _tlItext
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_hdOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_tlOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_TypeIndexedBindings_Nil :: (T_TypeIndexedBindings)
sem_TypeIndexedBindings_Nil  =
    \ _lhsIppMode ->
        let _lhsOself :: (TypeIndexedBindings)
            _lhsOtext :: ([Doc])
            -- use rule
            (_lhsOtext@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOself,_lhsOtext)
-- Types -------------------------------------------------------
{-
   inherited attributes:
      ppMode               : PPMode

   chained attributes:

   synthesised attributes:
      self                 : SELF
      text                 : [Doc]

-}
{-
   local variables for Types.Cons:
      self

-}
{-
   local variables for Types.Nil:
      self

-}
-- semantic domain
type T_Types = (PPMode) ->
               ( (Types),([Doc]))
-- cata
sem_Types :: (Types) ->
             (T_Types)
sem_Types (list) =
    (foldr (sem_Types_Cons) (sem_Types_Nil) ((map sem_Type list)))
sem_Types_Cons :: (T_Type) ->
                  (T_Types) ->
                  (T_Types)
sem_Types_Cons (hd_) (tl_) =
    \ _lhsIppMode ->
        let _lhsOself :: (Types)
            _lhsOtext :: ([Doc])
            _hdIself :: (Type)
            _hdItext :: (Doc)
            _hdOppMode :: (PPMode)
            _tlIself :: (Types)
            _tlItext :: ([Doc])
            _tlOppMode :: (PPMode)
            ( _hdIself,_hdItext) =
                (hd_ (_hdOppMode))
            ( _tlIself,_tlItext) =
                (tl_ (_tlOppMode))
            -- use rule
            (_lhsOtext@_) =
                _hdItext : _tlItext
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_hdOppMode@_) =
                _lhsIppMode
            -- copy rule (down)
            (_tlOppMode@_) =
                _lhsIppMode
        in  ( _lhsOself,_lhsOtext)
sem_Types_Nil :: (T_Types)
sem_Types_Nil  =
    \ _lhsIppMode ->
        let _lhsOself :: (Types)
            _lhsOtext :: ([Doc])
            -- use rule
            (_lhsOtext@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOself,_lhsOtext)


