-- do not edit; automatically generated by UU.AG
module ResolveOperators where


import AbstractSyntax
import FMap
import UHA_Range
import ErrorMessages
import ErrorUtils
import PPrint



type OperatorTable = FMap Name (Int,Fixity)



data Flat a b
    = FUnaryMinus
    | FOperator a
    | FItem b

type FlatExpression = Flat Expression Expression
type FlatPattern    = Flat Name       Pattern



lookupOp :: OperatorTable -> Name -> (Int,Fixity)
lookupOp t n = applyFMM t (const (9,Fixity_Infixl unknownRange)) n

resolveMaybeExpression :: OperatorTable -> [FlatExpression] 
                       -> (MaybeExpression,[GHError])
resolveMaybeExpression opTable [] = (MaybeExpression_Nothing,[])
resolveMaybeExpression opTable es = (\(x,y) -> (MaybeExpression_Just x,y))
                                      (resolveExpression opTable es)

resolveExpression :: OperatorTable -> [FlatExpression] -> (Expression,[GHError])
resolveExpression opTable es = resolve es (getOp, applyMinus, applyBinary,getName) ([],[],[]) 
  where
    getOp :: FlatExpression -> Either (FlatExpression,(Int,Fixity)) Expression
    getOp e@(FOperator (Expression_Variable _ n)) 
                          = Left  (e,lookupOp opTable n)
    getOp e@(FOperator (Expression_Constructor _ n)) 
                          = Left  (e,lookupOp opTable n)
    getOp e@(FUnaryMinus) = Left  (e,(6,Fixity_Infixl unknownRange))
    getOp (FItem e)       = Right e

    applyMinus :: Expression -> Expression
    applyMinus e = Expression_Negate 
		     (getRange e) {- inaccurate -}
		     e

    applyBinary :: Expression -> Expression -> Expression -> Expression
    applyBinary op e1 e2 =
        Expression_InfixApplication
            (rangeFromTo (getRange e1) (getRange e2))
	    (MaybeExpression_Just e1)
	    op
	    (MaybeExpression_Just e2)

    getName :: Expression -> Name
    getName (Expression_Variable _ n) = n
    getName (Expression_Constructor _ n) = n
    getName _ = internalError "ResolveOperators.resolveExpression.getName: illegal call"

resolvePattern :: OperatorTable -> [FlatPattern] -> (Pattern,[GHError])
resolvePattern opTable es = resolve es (getOp, applyMinus, applyBinary,getName) ([],[],[]) 
  where
    getOp :: FlatPattern -> Either (FlatPattern,(Int,Fixity)) Pattern
    getOp e@(FOperator n) = Left  (e,lookupOp opTable n)
    getOp e@(FUnaryMinus) = Left  (e,(6,Fixity_Infixl unknownRange))
    getOp (FItem e)       = Right e

    applyMinus :: Pattern -> Pattern
    applyMinus (Pattern_Literal r l) = Pattern_Negate r {- inaccurate -} l
    applyMinus _ = internalError "ResolveOperators.resolvePattern.applyMinus: illegal call"

    applyBinary :: Name -> Pattern -> Pattern -> Pattern
    applyBinary op e1 e2 =
        Pattern_InfixConstructor
            (rangeFromTo (getRange e1) (getRange e2))
	    e1 op e2

    getName :: Name -> Name
    getName = id

type State op expr = 
    ( [(Flat op expr,(Int,Fixity))]   -- operator stack
    , [expr]                          -- expression/pattern stack
    , [GHError]                       -- accumulated errors
    )

resolve :: 
    [Flat op expr] -> 
    ( Flat op expr -> Either (Flat op expr,(Int,Fixity)) expr -- get operator name (if it is one)
    , expr -> expr -- apply minus
    , op -> expr -> expr -> expr -- apply binary
    , op -> Name -- get name of operator
    ) 
    -> State op expr -> (expr,[GHError])
resolve exprs fs@(getOp, applyMinus, applyBinary,getName) state = 
    case exprs of 
        [] -> cleanup state
        (expr:exprs) ->
            let newState = 
                    case getOp expr of
                        Right item -> pushExpr item state
                        Left  op   -> pushOp op state
            in
                resolve exprs fs newState
  where
--    pushExpr :: expr -> State op expr -> State op expr
    pushExpr expr (ops,exprs,errs) = (ops,expr:exprs,errs)
--    popOp :: State op expr -> State op expr
    popOp ((FUnaryMinus,_):ops, exprs, errs) 
        = case exprs of
                (expr:rest) -> (ops, applyMinus expr : rest, errs)
                _ -> internalError "ResolveOperators.popOp: no expressions for unary minus"
    popOp ((FOperator op,_):ops, exprs, errs) 
        = case exprs of
                (expr2:expr1:rest) -> (ops, applyBinary op expr1 expr2 : rest, errs)
                _ -> internalError "ResolveOperators.popOp: no expressions for operator"
--    pushOp :: Flat op expr -> State op expr -> State op expr
    pushOp op state@(top:ops, exprs, errs) =
	case strongerOp (top,op) getName of
          (True,(ntop,nop),ne)  -> pushOp nop (popOp (ntop:ops,exprs,errs ++ ne))
          (False,(ntop,nop),ne) -> (nop:ntop:ops,exprs,errs ++ ne)
    pushOp op ([], exprs, errs) =
        ([op], exprs, errs)
--    cleanup :: State op expr -> expr
    cleanup state@(_:_, _, _)       = cleanup (popOp state)
    cleanup state@(_, [expr], errs) = (expr,errs)
    cleanup _ = internalError "ResolveOperators.cleanup: invalid state"

strongerOp :: ((Flat op a,(Int,Fixity))  -- first op
              ,(Flat op a,(Int,Fixity))  -- second op
	      )
           -> (op -> Name)               -- for error messages
           -> (Bool   -- is first stronger than second?
              ,((Flat op a,(Int,Fixity)) -- rewritten first op
               ,(Flat op a,(Int,Fixity)) -- rewritten second op
	       )
              ,[GHError]                -- errors
              )
strongerOp ops@((FOperator o1,(prio1,assoc1)),(FOperator o2,(prio2,assoc2))) getName
    | prio1 == prio2 = case (assoc1,assoc2) of
		         (Fixity_Infixl _,Fixity_Infixl _) -> (True,ops,[])
			 (Fixity_Infixr _,Fixity_Infixr _) -> (False,ops,[])
			 _ -> (False
			      ,((FOperator o1,(prio2,assoc2)) -- sic!
			       ,(FOperator o2,(prio2,assoc2))
			       )
			      ,[GHError_OperatorAmbiguityError 
				  (getName o1,prio1,assoc1)
			          (getName o2,prio2,assoc2)
			       ]
			      )
    | otherwise      = (prio1 > prio2,ops,[])

strongerOp ops@((FUnaryMinus,(prio1,assoc1)),(FOperator o2,(prio2,assoc2))) _
                     = (prio1 >= prio2,ops,[])

strongerOp ops@((_,(prio1,assoc1)),(FUnaryMinus,(prio2,assoc2))) _
                     = (False,ops,[])

strongerOp _ _       = internalError "ResolveOperators.strongerOp: illegal call"



data Root
    = Root_Root ModuleSystem



resolveOperators :: ModuleSystem -> (ModuleSystem,Bool,Doc)
resolveOperators msys = fst $ sem_Root (Root_Root msys)

-- Alternative -------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for Alternative.Alternative:
      self

-}
{-
   local variables for Alternative.Empty:
      self

-}
-- semantic domain
type T_Alternative = (OperatorTable) ->
                     (OperatorTable) ->
                     ( ([GHError]),(OperatorTable),(Alternative))
-- cata
sem_Alternative :: (Alternative) ->
                   (T_Alternative)
sem_Alternative ((Alternative_Alternative (_range) (_pattern) (_righthandside))) =
    (sem_Alternative_Alternative ((sem_Range (_range))) ((sem_Pattern (_pattern))) ((sem_RightHandSide (_righthandside))))
sem_Alternative ((Alternative_Empty (_range))) =
    (sem_Alternative_Empty ((sem_Range (_range))))
sem_Alternative_Alternative :: (T_Range) ->
                               (T_Pattern) ->
                               (T_RightHandSide) ->
                               (T_Alternative)
sem_Alternative_Alternative (range_) (pattern_) (righthandside_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Alternative)
            _rangeIself :: (Range)
            _patternIerrors :: ([GHError])
            _patternIflatten :: ([FlatPattern])
            _patternIoperatorTable_collect :: (OperatorTable)
            _patternIself :: (Pattern)
            _patternOoperatorTable :: (OperatorTable)
            _patternOoperatorTable_collect :: (OperatorTable)
            _righthandsideIerrors :: ([GHError])
            _righthandsideIoperatorTable_collect :: (OperatorTable)
            _righthandsideIself :: (RightHandSide)
            _righthandsideOoperatorTable :: (OperatorTable)
            _righthandsideOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _patternIerrors,_patternIflatten,_patternIoperatorTable_collect,_patternIself) =
                (pattern_ (_patternOoperatorTable) (_patternOoperatorTable_collect))
            ( _righthandsideIerrors,_righthandsideIoperatorTable_collect,_righthandsideIself) =
                (righthandside_ (_righthandsideOoperatorTable) (_righthandsideOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _patternIerrors ++ _righthandsideIerrors
            -- self rule
            (_self@_) =
                Alternative_Alternative _rangeIself _patternIself _righthandsideIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _righthandsideIoperatorTable_collect
            -- copy rule (down)
            (_patternOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_patternOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_righthandsideOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_righthandsideOoperatorTable_collect@_) =
                _patternIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Alternative_Empty :: (T_Range) ->
                         (T_Alternative)
sem_Alternative_Empty (range_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Alternative)
            _rangeIself :: (Range)
            ( _rangeIself) =
                (range_ )
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                Alternative_Empty _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- Alternatives ------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for Alternatives.Cons:
      self

-}
{-
   local variables for Alternatives.Nil:
      self

-}
-- semantic domain
type T_Alternatives = (OperatorTable) ->
                      (OperatorTable) ->
                      ( ([GHError]),(OperatorTable),(Alternatives))
-- cata
sem_Alternatives :: (Alternatives) ->
                    (T_Alternatives)
sem_Alternatives (list) =
    (foldr (sem_Alternatives_Cons) (sem_Alternatives_Nil) ((map sem_Alternative list)))
sem_Alternatives_Cons :: (T_Alternative) ->
                         (T_Alternatives) ->
                         (T_Alternatives)
sem_Alternatives_Cons (hd_) (tl_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Alternatives)
            _hdIerrors :: ([GHError])
            _hdIoperatorTable_collect :: (OperatorTable)
            _hdIself :: (Alternative)
            _hdOoperatorTable :: (OperatorTable)
            _hdOoperatorTable_collect :: (OperatorTable)
            _tlIerrors :: ([GHError])
            _tlIoperatorTable_collect :: (OperatorTable)
            _tlIself :: (Alternatives)
            _tlOoperatorTable :: (OperatorTable)
            _tlOoperatorTable_collect :: (OperatorTable)
            ( _hdIerrors,_hdIoperatorTable_collect,_hdIself) =
                (hd_ (_hdOoperatorTable) (_hdOoperatorTable_collect))
            ( _tlIerrors,_tlIoperatorTable_collect,_tlIself) =
                (tl_ (_tlOoperatorTable) (_tlOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _hdIerrors ++ _tlIerrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _tlIoperatorTable_collect
            -- copy rule (down)
            (_hdOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_hdOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_tlOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_tlOoperatorTable_collect@_) =
                _hdIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Alternatives_Nil :: (T_Alternatives)
sem_Alternatives_Nil  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Alternatives)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- AnnotatedType -----------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for AnnotatedType.AnnotatedType:
      self

-}
-- semantic domain
type T_AnnotatedType = (OperatorTable) ->
                       (OperatorTable) ->
                       ( ([GHError]),(OperatorTable),(AnnotatedType))
-- cata
sem_AnnotatedType :: (AnnotatedType) ->
                     (T_AnnotatedType)
sem_AnnotatedType ((AnnotatedType_AnnotatedType (_range) (_strict) (_type))) =
    (sem_AnnotatedType_AnnotatedType ((sem_Range (_range))) (_strict) ((sem_Type (_type))))
sem_AnnotatedType_AnnotatedType :: (T_Range) ->
                                   (Bool) ->
                                   (T_Type) ->
                                   (T_AnnotatedType)
sem_AnnotatedType_AnnotatedType (range_) (strict_) (type_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (AnnotatedType)
            _rangeIself :: (Range)
            _typeIerrors :: ([GHError])
            _typeIoperatorTable_collect :: (OperatorTable)
            _typeIself :: (Type)
            _typeOoperatorTable :: (OperatorTable)
            _typeOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _typeIerrors,_typeIoperatorTable_collect,_typeIself) =
                (type_ (_typeOoperatorTable) (_typeOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _typeIerrors
            -- self rule
            (_self@_) =
                AnnotatedType_AnnotatedType _rangeIself strict_ _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _typeIoperatorTable_collect
            -- copy rule (down)
            (_typeOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_typeOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- AnnotatedTypes ----------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for AnnotatedTypes.Cons:
      self

-}
{-
   local variables for AnnotatedTypes.Nil:
      self

-}
-- semantic domain
type T_AnnotatedTypes = (OperatorTable) ->
                        (OperatorTable) ->
                        ( ([GHError]),(OperatorTable),(AnnotatedTypes))
-- cata
sem_AnnotatedTypes :: (AnnotatedTypes) ->
                      (T_AnnotatedTypes)
sem_AnnotatedTypes (list) =
    (foldr (sem_AnnotatedTypes_Cons) (sem_AnnotatedTypes_Nil) ((map sem_AnnotatedType list)))
sem_AnnotatedTypes_Cons :: (T_AnnotatedType) ->
                           (T_AnnotatedTypes) ->
                           (T_AnnotatedTypes)
sem_AnnotatedTypes_Cons (hd_) (tl_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (AnnotatedTypes)
            _hdIerrors :: ([GHError])
            _hdIoperatorTable_collect :: (OperatorTable)
            _hdIself :: (AnnotatedType)
            _hdOoperatorTable :: (OperatorTable)
            _hdOoperatorTable_collect :: (OperatorTable)
            _tlIerrors :: ([GHError])
            _tlIoperatorTable_collect :: (OperatorTable)
            _tlIself :: (AnnotatedTypes)
            _tlOoperatorTable :: (OperatorTable)
            _tlOoperatorTable_collect :: (OperatorTable)
            ( _hdIerrors,_hdIoperatorTable_collect,_hdIself) =
                (hd_ (_hdOoperatorTable) (_hdOoperatorTable_collect))
            ( _tlIerrors,_tlIoperatorTable_collect,_tlIself) =
                (tl_ (_tlOoperatorTable) (_tlOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _hdIerrors ++ _tlIerrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _tlIoperatorTable_collect
            -- copy rule (down)
            (_hdOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_hdOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_tlOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_tlOoperatorTable_collect@_) =
                _hdIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_AnnotatedTypes_Nil :: (T_AnnotatedTypes)
sem_AnnotatedTypes_Nil  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (AnnotatedTypes)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- Body --------------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for Body.Body:
      self

-}
-- semantic domain
type T_Body = (OperatorTable) ->
              (OperatorTable) ->
              ( ([GHError]),(OperatorTable),(Body))
-- cata
sem_Body :: (Body) ->
            (T_Body)
sem_Body ((Body_Body (_range) (_importdeclarations) (_declarations))) =
    (sem_Body_Body ((sem_Range (_range))) ((sem_ImportDeclarations (_importdeclarations))) ((sem_Declarations (_declarations))))
sem_Body_Body :: (T_Range) ->
                 (T_ImportDeclarations) ->
                 (T_Declarations) ->
                 (T_Body)
sem_Body_Body (range_) (importdeclarations_) (declarations_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Body)
            _rangeIself :: (Range)
            _importdeclarationsIerrors :: ([GHError])
            _importdeclarationsIoperatorTable_collect :: (OperatorTable)
            _importdeclarationsIself :: (ImportDeclarations)
            _importdeclarationsOoperatorTable :: (OperatorTable)
            _importdeclarationsOoperatorTable_collect :: (OperatorTable)
            _declarationsIerrors :: ([GHError])
            _declarationsIoperatorTable_collect :: (OperatorTable)
            _declarationsIself :: (Declarations)
            _declarationsOoperatorTable :: (OperatorTable)
            _declarationsOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _importdeclarationsIerrors,_importdeclarationsIoperatorTable_collect,_importdeclarationsIself) =
                (importdeclarations_ (_importdeclarationsOoperatorTable) (_importdeclarationsOoperatorTable_collect))
            ( _declarationsIerrors,_declarationsIoperatorTable_collect,_declarationsIself) =
                (declarations_ (_declarationsOoperatorTable) (_declarationsOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _importdeclarationsIerrors ++ _declarationsIerrors
            -- self rule
            (_self@_) =
                Body_Body _rangeIself _importdeclarationsIself _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _declarationsIoperatorTable_collect
            -- copy rule (down)
            (_importdeclarationsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_importdeclarationsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_declarationsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_declarationsOoperatorTable_collect@_) =
                _importdeclarationsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- Constructor -------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for Constructor.Constructor:
      self

-}
{-
   local variables for Constructor.Infix:
      self

-}
{-
   local variables for Constructor.Record:
      self

-}
-- semantic domain
type T_Constructor = (OperatorTable) ->
                     (OperatorTable) ->
                     ( ([GHError]),(OperatorTable),(Constructor))
-- cata
sem_Constructor :: (Constructor) ->
                   (T_Constructor)
sem_Constructor ((Constructor_Constructor (_range) (_constructor) (_types))) =
    (sem_Constructor_Constructor ((sem_Range (_range))) ((sem_Name (_constructor))) ((sem_AnnotatedTypes (_types))))
sem_Constructor ((Constructor_Infix (_range) (_leftType) (_constructorOperator) (_rightType))) =
    (sem_Constructor_Infix ((sem_Range (_range))) ((sem_AnnotatedType (_leftType))) ((sem_Name (_constructorOperator))) ((sem_AnnotatedType (_rightType))))
sem_Constructor ((Constructor_Record (_range) (_constructor) (_fieldDeclarations))) =
    (sem_Constructor_Record ((sem_Range (_range))) ((sem_Name (_constructor))) ((sem_FieldDeclarations (_fieldDeclarations))))
sem_Constructor_Constructor :: (T_Range) ->
                               (T_Name) ->
                               (T_AnnotatedTypes) ->
                               (T_Constructor)
sem_Constructor_Constructor (range_) (constructor_) (types_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Constructor)
            _rangeIself :: (Range)
            _constructorIerrors :: ([GHError])
            _constructorIoperatorTable_collect :: (OperatorTable)
            _constructorIself :: (Name)
            _constructorOoperatorTable :: (OperatorTable)
            _constructorOoperatorTable_collect :: (OperatorTable)
            _typesIerrors :: ([GHError])
            _typesIoperatorTable_collect :: (OperatorTable)
            _typesIself :: (AnnotatedTypes)
            _typesOoperatorTable :: (OperatorTable)
            _typesOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _constructorIerrors,_constructorIoperatorTable_collect,_constructorIself) =
                (constructor_ (_constructorOoperatorTable) (_constructorOoperatorTable_collect))
            ( _typesIerrors,_typesIoperatorTable_collect,_typesIself) =
                (types_ (_typesOoperatorTable) (_typesOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _constructorIerrors ++ _typesIerrors
            -- self rule
            (_self@_) =
                Constructor_Constructor _rangeIself _constructorIself _typesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _typesIoperatorTable_collect
            -- copy rule (down)
            (_constructorOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_constructorOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_typesOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_typesOoperatorTable_collect@_) =
                _constructorIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Constructor_Infix :: (T_Range) ->
                         (T_AnnotatedType) ->
                         (T_Name) ->
                         (T_AnnotatedType) ->
                         (T_Constructor)
sem_Constructor_Infix (range_) (leftType_) (constructorOperator_) (rightType_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Constructor)
            _rangeIself :: (Range)
            _leftTypeIerrors :: ([GHError])
            _leftTypeIoperatorTable_collect :: (OperatorTable)
            _leftTypeIself :: (AnnotatedType)
            _leftTypeOoperatorTable :: (OperatorTable)
            _leftTypeOoperatorTable_collect :: (OperatorTable)
            _constructorOperatorIerrors :: ([GHError])
            _constructorOperatorIoperatorTable_collect :: (OperatorTable)
            _constructorOperatorIself :: (Name)
            _constructorOperatorOoperatorTable :: (OperatorTable)
            _constructorOperatorOoperatorTable_collect :: (OperatorTable)
            _rightTypeIerrors :: ([GHError])
            _rightTypeIoperatorTable_collect :: (OperatorTable)
            _rightTypeIself :: (AnnotatedType)
            _rightTypeOoperatorTable :: (OperatorTable)
            _rightTypeOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _leftTypeIerrors,_leftTypeIoperatorTable_collect,_leftTypeIself) =
                (leftType_ (_leftTypeOoperatorTable) (_leftTypeOoperatorTable_collect))
            ( _constructorOperatorIerrors,_constructorOperatorIoperatorTable_collect,_constructorOperatorIself) =
                (constructorOperator_ (_constructorOperatorOoperatorTable) (_constructorOperatorOoperatorTable_collect))
            ( _rightTypeIerrors,_rightTypeIoperatorTable_collect,_rightTypeIself) =
                (rightType_ (_rightTypeOoperatorTable) (_rightTypeOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _leftTypeIerrors ++ _constructorOperatorIerrors ++ _rightTypeIerrors
            -- self rule
            (_self@_) =
                Constructor_Infix _rangeIself _leftTypeIself _constructorOperatorIself _rightTypeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _rightTypeIoperatorTable_collect
            -- copy rule (down)
            (_leftTypeOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_leftTypeOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_constructorOperatorOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_constructorOperatorOoperatorTable_collect@_) =
                _leftTypeIoperatorTable_collect
            -- copy rule (down)
            (_rightTypeOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_rightTypeOoperatorTable_collect@_) =
                _constructorOperatorIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Constructor_Record :: (T_Range) ->
                          (T_Name) ->
                          (T_FieldDeclarations) ->
                          (T_Constructor)
sem_Constructor_Record (range_) (constructor_) (fieldDeclarations_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Constructor)
            _rangeIself :: (Range)
            _constructorIerrors :: ([GHError])
            _constructorIoperatorTable_collect :: (OperatorTable)
            _constructorIself :: (Name)
            _constructorOoperatorTable :: (OperatorTable)
            _constructorOoperatorTable_collect :: (OperatorTable)
            _fieldDeclarationsIerrors :: ([GHError])
            _fieldDeclarationsIoperatorTable_collect :: (OperatorTable)
            _fieldDeclarationsIself :: (FieldDeclarations)
            _fieldDeclarationsOoperatorTable :: (OperatorTable)
            _fieldDeclarationsOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _constructorIerrors,_constructorIoperatorTable_collect,_constructorIself) =
                (constructor_ (_constructorOoperatorTable) (_constructorOoperatorTable_collect))
            ( _fieldDeclarationsIerrors,_fieldDeclarationsIoperatorTable_collect,_fieldDeclarationsIself) =
                (fieldDeclarations_ (_fieldDeclarationsOoperatorTable) (_fieldDeclarationsOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _constructorIerrors ++ _fieldDeclarationsIerrors
            -- self rule
            (_self@_) =
                Constructor_Record _rangeIself _constructorIself _fieldDeclarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _fieldDeclarationsIoperatorTable_collect
            -- copy rule (down)
            (_constructorOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_constructorOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_fieldDeclarationsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_fieldDeclarationsOoperatorTable_collect@_) =
                _constructorIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- Constructors ------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for Constructors.Cons:
      self

-}
{-
   local variables for Constructors.Nil:
      self

-}
-- semantic domain
type T_Constructors = (OperatorTable) ->
                      (OperatorTable) ->
                      ( ([GHError]),(OperatorTable),(Constructors))
-- cata
sem_Constructors :: (Constructors) ->
                    (T_Constructors)
sem_Constructors (list) =
    (foldr (sem_Constructors_Cons) (sem_Constructors_Nil) ((map sem_Constructor list)))
sem_Constructors_Cons :: (T_Constructor) ->
                         (T_Constructors) ->
                         (T_Constructors)
sem_Constructors_Cons (hd_) (tl_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Constructors)
            _hdIerrors :: ([GHError])
            _hdIoperatorTable_collect :: (OperatorTable)
            _hdIself :: (Constructor)
            _hdOoperatorTable :: (OperatorTable)
            _hdOoperatorTable_collect :: (OperatorTable)
            _tlIerrors :: ([GHError])
            _tlIoperatorTable_collect :: (OperatorTable)
            _tlIself :: (Constructors)
            _tlOoperatorTable :: (OperatorTable)
            _tlOoperatorTable_collect :: (OperatorTable)
            ( _hdIerrors,_hdIoperatorTable_collect,_hdIself) =
                (hd_ (_hdOoperatorTable) (_hdOoperatorTable_collect))
            ( _tlIerrors,_tlIoperatorTable_collect,_tlIself) =
                (tl_ (_tlOoperatorTable) (_tlOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _hdIerrors ++ _tlIerrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _tlIoperatorTable_collect
            -- copy rule (down)
            (_hdOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_hdOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_tlOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_tlOoperatorTable_collect@_) =
                _hdIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Constructors_Nil :: (T_Constructors)
sem_Constructors_Nil  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Constructors)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- ContextItem -------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for ContextItem.ContextItem:
      self

-}
{-
   local variables for ContextItem.DependencyConstraint:
      self

-}
{-
   local variables for ContextItem.DependencyItem:
      self

-}
-- semantic domain
type T_ContextItem = (OperatorTable) ->
                     (OperatorTable) ->
                     ( ([GHError]),(OperatorTable),(ContextItem))
-- cata
sem_ContextItem :: (ContextItem) ->
                   (T_ContextItem)
sem_ContextItem ((ContextItem_ContextItem (_range) (_name) (_types))) =
    (sem_ContextItem_ContextItem ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Types (_types))))
sem_ContextItem ((ContextItem_DependencyConstraint (_range) (_name) (_typevariable) (_type))) =
    (sem_ContextItem_DependencyConstraint ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Name (_typevariable))) ((sem_Type (_type))))
sem_ContextItem ((ContextItem_DependencyItem (_range) (_name) (_generics) (_parametrics) (_asname))) =
    (sem_ContextItem_DependencyItem ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Names (_generics))) ((sem_Types (_parametrics))) ((sem_MaybeName (_asname))))
sem_ContextItem_ContextItem :: (T_Range) ->
                               (T_Name) ->
                               (T_Types) ->
                               (T_ContextItem)
sem_ContextItem_ContextItem (range_) (name_) (types_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (ContextItem)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _typesIerrors :: ([GHError])
            _typesIoperatorTable_collect :: (OperatorTable)
            _typesIself :: (Types)
            _typesOoperatorTable :: (OperatorTable)
            _typesOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _typesIerrors,_typesIoperatorTable_collect,_typesIself) =
                (types_ (_typesOoperatorTable) (_typesOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _typesIerrors
            -- self rule
            (_self@_) =
                ContextItem_ContextItem _rangeIself _nameIself _typesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _typesIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_typesOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_typesOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_ContextItem_DependencyConstraint :: (T_Range) ->
                                        (T_Name) ->
                                        (T_Name) ->
                                        (T_Type) ->
                                        (T_ContextItem)
sem_ContextItem_DependencyConstraint (range_) (name_) (typevariable_) (type_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (ContextItem)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _typevariableIerrors :: ([GHError])
            _typevariableIoperatorTable_collect :: (OperatorTable)
            _typevariableIself :: (Name)
            _typevariableOoperatorTable :: (OperatorTable)
            _typevariableOoperatorTable_collect :: (OperatorTable)
            _typeIerrors :: ([GHError])
            _typeIoperatorTable_collect :: (OperatorTable)
            _typeIself :: (Type)
            _typeOoperatorTable :: (OperatorTable)
            _typeOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _typevariableIerrors,_typevariableIoperatorTable_collect,_typevariableIself) =
                (typevariable_ (_typevariableOoperatorTable) (_typevariableOoperatorTable_collect))
            ( _typeIerrors,_typeIoperatorTable_collect,_typeIself) =
                (type_ (_typeOoperatorTable) (_typeOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _typevariableIerrors ++ _typeIerrors
            -- self rule
            (_self@_) =
                ContextItem_DependencyConstraint _rangeIself _nameIself _typevariableIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _typeIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_typevariableOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_typevariableOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_typeOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_typeOoperatorTable_collect@_) =
                _typevariableIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_ContextItem_DependencyItem :: (T_Range) ->
                                  (T_Name) ->
                                  (T_Names) ->
                                  (T_Types) ->
                                  (T_MaybeName) ->
                                  (T_ContextItem)
sem_ContextItem_DependencyItem (range_) (name_) (generics_) (parametrics_) (asname_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (ContextItem)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _genericsIerrors :: ([GHError])
            _genericsIoperatorTable_collect :: (OperatorTable)
            _genericsIself :: (Names)
            _genericsOoperatorTable :: (OperatorTable)
            _genericsOoperatorTable_collect :: (OperatorTable)
            _parametricsIerrors :: ([GHError])
            _parametricsIoperatorTable_collect :: (OperatorTable)
            _parametricsIself :: (Types)
            _parametricsOoperatorTable :: (OperatorTable)
            _parametricsOoperatorTable_collect :: (OperatorTable)
            _asnameIerrors :: ([GHError])
            _asnameIoperatorTable_collect :: (OperatorTable)
            _asnameIself :: (MaybeName)
            _asnameOoperatorTable :: (OperatorTable)
            _asnameOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _genericsIerrors,_genericsIoperatorTable_collect,_genericsIself) =
                (generics_ (_genericsOoperatorTable) (_genericsOoperatorTable_collect))
            ( _parametricsIerrors,_parametricsIoperatorTable_collect,_parametricsIself) =
                (parametrics_ (_parametricsOoperatorTable) (_parametricsOoperatorTable_collect))
            ( _asnameIerrors,_asnameIoperatorTable_collect,_asnameIself) =
                (asname_ (_asnameOoperatorTable) (_asnameOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _genericsIerrors ++ _parametricsIerrors ++ _asnameIerrors
            -- self rule
            (_self@_) =
                ContextItem_DependencyItem _rangeIself _nameIself _genericsIself _parametricsIself _asnameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _asnameIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_genericsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_genericsOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_parametricsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_parametricsOoperatorTable_collect@_) =
                _genericsIoperatorTable_collect
            -- copy rule (down)
            (_asnameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_asnameOoperatorTable_collect@_) =
                _parametricsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- ContextItems ------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for ContextItems.Cons:
      self

-}
{-
   local variables for ContextItems.Nil:
      self

-}
-- semantic domain
type T_ContextItems = (OperatorTable) ->
                      (OperatorTable) ->
                      ( ([GHError]),(OperatorTable),(ContextItems))
-- cata
sem_ContextItems :: (ContextItems) ->
                    (T_ContextItems)
sem_ContextItems (list) =
    (foldr (sem_ContextItems_Cons) (sem_ContextItems_Nil) ((map sem_ContextItem list)))
sem_ContextItems_Cons :: (T_ContextItem) ->
                         (T_ContextItems) ->
                         (T_ContextItems)
sem_ContextItems_Cons (hd_) (tl_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (ContextItems)
            _hdIerrors :: ([GHError])
            _hdIoperatorTable_collect :: (OperatorTable)
            _hdIself :: (ContextItem)
            _hdOoperatorTable :: (OperatorTable)
            _hdOoperatorTable_collect :: (OperatorTable)
            _tlIerrors :: ([GHError])
            _tlIoperatorTable_collect :: (OperatorTable)
            _tlIself :: (ContextItems)
            _tlOoperatorTable :: (OperatorTable)
            _tlOoperatorTable_collect :: (OperatorTable)
            ( _hdIerrors,_hdIoperatorTable_collect,_hdIself) =
                (hd_ (_hdOoperatorTable) (_hdOoperatorTable_collect))
            ( _tlIerrors,_tlIoperatorTable_collect,_tlIself) =
                (tl_ (_tlOoperatorTable) (_tlOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _hdIerrors ++ _tlIerrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _tlIoperatorTable_collect
            -- copy rule (down)
            (_hdOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_hdOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_tlOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_tlOoperatorTable_collect@_) =
                _hdIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_ContextItems_Nil :: (T_ContextItems)
sem_ContextItems_Nil  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (ContextItems)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- Declaration -------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for Declaration.Class:
      self

-}
{-
   local variables for Declaration.Data:
      self

-}
{-
   local variables for Declaration.Default:
      self

-}
{-
   local variables for Declaration.Dependency:
      self

-}
{-
   local variables for Declaration.Empty:
      self

-}
{-
   local variables for Declaration.Fixity:
      self

-}
{-
   local variables for Declaration.FunctionBindings:
      self

-}
{-
   local variables for Declaration.GenericTypeSignature:
      self

-}
{-
   local variables for Declaration.Instance:
      self

-}
{-
   local variables for Declaration.KindIndexedType:
      self

-}
{-
   local variables for Declaration.Newtype:
      self

-}
{-
   local variables for Declaration.PatternBinding:
      self

-}
{-
   local variables for Declaration.Type:
      self

-}
{-
   local variables for Declaration.TypeIndexedType:
      self

-}
{-
   local variables for Declaration.TypeIndexedValue:
      self

-}
{-
   local variables for Declaration.TypeSignature:
      self

-}
-- semantic domain
type T_Declaration = (OperatorTable) ->
                     (OperatorTable) ->
                     ( ([GHError]),(OperatorTable),(Declaration))
-- cata
sem_Declaration :: (Declaration) ->
                   (T_Declaration)
sem_Declaration ((Declaration_Class (_range) (_context) (_simpletype) (_where))) =
    (sem_Declaration_Class ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_SimpleType (_simpletype))) ((sem_MaybeDeclarations (_where))))
sem_Declaration ((Declaration_Data (_range) (_context) (_simpletype) (_constructors) (_derivings))) =
    (sem_Declaration_Data ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_SimpleType (_simpletype))) ((sem_Constructors (_constructors))) ((sem_Names (_derivings))))
sem_Declaration ((Declaration_Default (_range) (_types))) =
    (sem_Declaration_Default ((sem_Range (_range))) ((sem_Types (_types))))
sem_Declaration ((Declaration_Dependency (_range) (_typelevel) (_name) (_bindings))) =
    (sem_Declaration_Dependency ((sem_Range (_range))) (_typelevel) ((sem_Name (_name))) ((sem_DependencyBindings (_bindings))))
sem_Declaration ((Declaration_Empty (_range))) =
    (sem_Declaration_Empty ((sem_Range (_range))))
sem_Declaration ((Declaration_Fixity (_range) (_fixity) (_priority) (_operators))) =
    (sem_Declaration_Fixity ((sem_Range (_range))) ((sem_Fixity (_fixity))) ((sem_MaybeInt (_priority))) ((sem_Names (_operators))))
sem_Declaration ((Declaration_FunctionBindings (_range) (_bindings))) =
    (sem_Declaration_FunctionBindings ((sem_Range (_range))) ((sem_FunctionBindings (_bindings))))
sem_Declaration ((Declaration_GenericTypeSignature (_range) (_name) (_generics) (_parametrics) (_type))) =
    (sem_Declaration_GenericTypeSignature ((sem_Range (_range))) ((sem_Name (_name))) ((sem_KindAnnotatedNames (_generics))) ((sem_KindAnnotatedNames (_parametrics))) ((sem_Type (_type))))
sem_Declaration ((Declaration_Instance (_range) (_context) (_name) (_types) (_where))) =
    (sem_Declaration_Instance ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_Name (_name))) ((sem_Types (_types))) ((sem_MaybeDeclarations (_where))))
sem_Declaration ((Declaration_KindIndexedType (_range) (_bindings))) =
    (sem_Declaration_KindIndexedType ((sem_Range (_range))) ((sem_KindIndexedBindings (_bindings))))
sem_Declaration ((Declaration_Newtype (_range) (_context) (_simpletype) (_constructor) (_derivings))) =
    (sem_Declaration_Newtype ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_SimpleType (_simpletype))) ((sem_Constructor (_constructor))) ((sem_Names (_derivings))))
sem_Declaration ((Declaration_PatternBinding (_range) (_pattern) (_righthandside))) =
    (sem_Declaration_PatternBinding ((sem_Range (_range))) ((sem_Pattern (_pattern))) ((sem_RightHandSide (_righthandside))))
sem_Declaration ((Declaration_Type (_range) (_simpletype) (_type))) =
    (sem_Declaration_Type ((sem_Range (_range))) ((sem_SimpleType (_simpletype))) ((sem_Type (_type))))
sem_Declaration ((Declaration_TypeIndexedType (_range) (_name) (_typeargument) (_typevariables) (_constructor) (_derivings))) =
    (sem_Declaration_TypeIndexedType ((sem_Range (_range))) ((sem_Name (_name))) ((sem_TypeArgument (_typeargument))) ((sem_Names (_typevariables))) ((sem_Constructor (_constructor))) ((sem_Names (_derivings))))
sem_Declaration ((Declaration_TypeIndexedValue (_range) (_bindings))) =
    (sem_Declaration_TypeIndexedValue ((sem_Range (_range))) ((sem_TypeIndexedBindings (_bindings))))
sem_Declaration ((Declaration_TypeSignature (_range) (_names) (_type))) =
    (sem_Declaration_TypeSignature ((sem_Range (_range))) ((sem_Names (_names))) ((sem_Type (_type))))
sem_Declaration_Class :: (T_Range) ->
                         (T_ContextItems) ->
                         (T_SimpleType) ->
                         (T_MaybeDeclarations) ->
                         (T_Declaration)
sem_Declaration_Class (range_) (context_) (simpletype_) (where_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _contextIerrors :: ([GHError])
            _contextIoperatorTable_collect :: (OperatorTable)
            _contextIself :: (ContextItems)
            _contextOoperatorTable :: (OperatorTable)
            _contextOoperatorTable_collect :: (OperatorTable)
            _simpletypeIerrors :: ([GHError])
            _simpletypeIoperatorTable_collect :: (OperatorTable)
            _simpletypeIself :: (SimpleType)
            _simpletypeOoperatorTable :: (OperatorTable)
            _simpletypeOoperatorTable_collect :: (OperatorTable)
            _whereIerrors :: ([GHError])
            _whereIoperatorTable_collect :: (OperatorTable)
            _whereIself :: (MaybeDeclarations)
            _whereOoperatorTable :: (OperatorTable)
            _whereOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _contextIerrors,_contextIoperatorTable_collect,_contextIself) =
                (context_ (_contextOoperatorTable) (_contextOoperatorTable_collect))
            ( _simpletypeIerrors,_simpletypeIoperatorTable_collect,_simpletypeIself) =
                (simpletype_ (_simpletypeOoperatorTable) (_simpletypeOoperatorTable_collect))
            ( _whereIerrors,_whereIoperatorTable_collect,_whereIself) =
                (where_ (_whereOoperatorTable) (_whereOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _contextIerrors ++ _simpletypeIerrors ++ _whereIerrors
            -- self rule
            (_self@_) =
                Declaration_Class _rangeIself _contextIself _simpletypeIself _whereIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _whereIoperatorTable_collect
            -- copy rule (down)
            (_contextOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_contextOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_simpletypeOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_simpletypeOoperatorTable_collect@_) =
                _contextIoperatorTable_collect
            -- copy rule (down)
            (_whereOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_whereOoperatorTable_collect@_) =
                _simpletypeIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Declaration_Data :: (T_Range) ->
                        (T_ContextItems) ->
                        (T_SimpleType) ->
                        (T_Constructors) ->
                        (T_Names) ->
                        (T_Declaration)
sem_Declaration_Data (range_) (context_) (simpletype_) (constructors_) (derivings_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _contextIerrors :: ([GHError])
            _contextIoperatorTable_collect :: (OperatorTable)
            _contextIself :: (ContextItems)
            _contextOoperatorTable :: (OperatorTable)
            _contextOoperatorTable_collect :: (OperatorTable)
            _simpletypeIerrors :: ([GHError])
            _simpletypeIoperatorTable_collect :: (OperatorTable)
            _simpletypeIself :: (SimpleType)
            _simpletypeOoperatorTable :: (OperatorTable)
            _simpletypeOoperatorTable_collect :: (OperatorTable)
            _constructorsIerrors :: ([GHError])
            _constructorsIoperatorTable_collect :: (OperatorTable)
            _constructorsIself :: (Constructors)
            _constructorsOoperatorTable :: (OperatorTable)
            _constructorsOoperatorTable_collect :: (OperatorTable)
            _derivingsIerrors :: ([GHError])
            _derivingsIoperatorTable_collect :: (OperatorTable)
            _derivingsIself :: (Names)
            _derivingsOoperatorTable :: (OperatorTable)
            _derivingsOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _contextIerrors,_contextIoperatorTable_collect,_contextIself) =
                (context_ (_contextOoperatorTable) (_contextOoperatorTable_collect))
            ( _simpletypeIerrors,_simpletypeIoperatorTable_collect,_simpletypeIself) =
                (simpletype_ (_simpletypeOoperatorTable) (_simpletypeOoperatorTable_collect))
            ( _constructorsIerrors,_constructorsIoperatorTable_collect,_constructorsIself) =
                (constructors_ (_constructorsOoperatorTable) (_constructorsOoperatorTable_collect))
            ( _derivingsIerrors,_derivingsIoperatorTable_collect,_derivingsIself) =
                (derivings_ (_derivingsOoperatorTable) (_derivingsOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _contextIerrors ++ _simpletypeIerrors ++ _constructorsIerrors ++ _derivingsIerrors
            -- self rule
            (_self@_) =
                Declaration_Data _rangeIself _contextIself _simpletypeIself _constructorsIself _derivingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _derivingsIoperatorTable_collect
            -- copy rule (down)
            (_contextOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_contextOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_simpletypeOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_simpletypeOoperatorTable_collect@_) =
                _contextIoperatorTable_collect
            -- copy rule (down)
            (_constructorsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_constructorsOoperatorTable_collect@_) =
                _simpletypeIoperatorTable_collect
            -- copy rule (down)
            (_derivingsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_derivingsOoperatorTable_collect@_) =
                _constructorsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Declaration_Default :: (T_Range) ->
                           (T_Types) ->
                           (T_Declaration)
sem_Declaration_Default (range_) (types_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _typesIerrors :: ([GHError])
            _typesIoperatorTable_collect :: (OperatorTable)
            _typesIself :: (Types)
            _typesOoperatorTable :: (OperatorTable)
            _typesOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _typesIerrors,_typesIoperatorTable_collect,_typesIself) =
                (types_ (_typesOoperatorTable) (_typesOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _typesIerrors
            -- self rule
            (_self@_) =
                Declaration_Default _rangeIself _typesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _typesIoperatorTable_collect
            -- copy rule (down)
            (_typesOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_typesOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Declaration_Dependency :: (T_Range) ->
                              (Bool) ->
                              (T_Name) ->
                              (T_DependencyBindings) ->
                              (T_Declaration)
sem_Declaration_Dependency (range_) (typelevel_) (name_) (bindings_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _bindingsIerrors :: ([GHError])
            _bindingsIoperatorTable_collect :: (OperatorTable)
            _bindingsIself :: (DependencyBindings)
            _bindingsOoperatorTable :: (OperatorTable)
            _bindingsOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _bindingsIerrors,_bindingsIoperatorTable_collect,_bindingsIself) =
                (bindings_ (_bindingsOoperatorTable) (_bindingsOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _bindingsIerrors
            -- self rule
            (_self@_) =
                Declaration_Dependency _rangeIself typelevel_ _nameIself _bindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _bindingsIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_bindingsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_bindingsOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Declaration_Empty :: (T_Range) ->
                         (T_Declaration)
sem_Declaration_Empty (range_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            ( _rangeIself) =
                (range_ )
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                Declaration_Empty _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Declaration_Fixity :: (T_Range) ->
                          (T_Fixity) ->
                          (T_MaybeInt) ->
                          (T_Names) ->
                          (T_Declaration)
sem_Declaration_Fixity (range_) (fixity_) (priority_) (operators_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _fixityIerrors :: ([GHError])
            _fixityIoperatorTable_collect :: (OperatorTable)
            _fixityIself :: (Fixity)
            _fixityOoperatorTable :: (OperatorTable)
            _fixityOoperatorTable_collect :: (OperatorTable)
            _priorityIerrors :: ([GHError])
            _priorityIoperatorTable_collect :: (OperatorTable)
            _priorityIself :: (MaybeInt)
            _priorityItoInt :: (Int)
            _priorityOoperatorTable :: (OperatorTable)
            _priorityOoperatorTable_collect :: (OperatorTable)
            _operatorsIerrors :: ([GHError])
            _operatorsIoperatorTable_collect :: (OperatorTable)
            _operatorsIself :: (Names)
            _operatorsOoperatorTable :: (OperatorTable)
            _operatorsOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _fixityIerrors,_fixityIoperatorTable_collect,_fixityIself) =
                (fixity_ (_fixityOoperatorTable) (_fixityOoperatorTable_collect))
            ( _priorityIerrors,_priorityIoperatorTable_collect,_priorityIself,_priorityItoInt) =
                (priority_ (_priorityOoperatorTable) (_priorityOoperatorTable_collect))
            ( _operatorsIerrors,_operatorsIoperatorTable_collect,_operatorsIself) =
                (operators_ (_operatorsOoperatorTable) (_operatorsOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 154, column 9)
            (_lhsOoperatorTable_collect@_) =
                foldl
                  (\ t o -> add t (o,(_priorityItoInt,_fixityIself)) )
                  _lhsIoperatorTable_collect
                  _operatorsIself
            -- use rule
            (_lhsOerrors@_) =
                _fixityIerrors ++ _priorityIerrors ++ _operatorsIerrors
            -- self rule
            (_self@_) =
                Declaration_Fixity _rangeIself _fixityIself _priorityIself _operatorsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_fixityOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_fixityOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_priorityOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_priorityOoperatorTable_collect@_) =
                _fixityIoperatorTable_collect
            -- copy rule (down)
            (_operatorsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_operatorsOoperatorTable_collect@_) =
                _priorityIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Declaration_FunctionBindings :: (T_Range) ->
                                    (T_FunctionBindings) ->
                                    (T_Declaration)
sem_Declaration_FunctionBindings (range_) (bindings_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _bindingsIerrors :: ([GHError])
            _bindingsIoperatorTable_collect :: (OperatorTable)
            _bindingsIself :: (FunctionBindings)
            _bindingsOoperatorTable :: (OperatorTable)
            _bindingsOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _bindingsIerrors,_bindingsIoperatorTable_collect,_bindingsIself) =
                (bindings_ (_bindingsOoperatorTable) (_bindingsOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _bindingsIerrors
            -- self rule
            (_self@_) =
                Declaration_FunctionBindings _rangeIself _bindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _bindingsIoperatorTable_collect
            -- copy rule (down)
            (_bindingsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_bindingsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Declaration_GenericTypeSignature :: (T_Range) ->
                                        (T_Name) ->
                                        (T_KindAnnotatedNames) ->
                                        (T_KindAnnotatedNames) ->
                                        (T_Type) ->
                                        (T_Declaration)
sem_Declaration_GenericTypeSignature (range_) (name_) (generics_) (parametrics_) (type_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _genericsIerrors :: ([GHError])
            _genericsIoperatorTable_collect :: (OperatorTable)
            _genericsIself :: (KindAnnotatedNames)
            _genericsOoperatorTable :: (OperatorTable)
            _genericsOoperatorTable_collect :: (OperatorTable)
            _parametricsIerrors :: ([GHError])
            _parametricsIoperatorTable_collect :: (OperatorTable)
            _parametricsIself :: (KindAnnotatedNames)
            _parametricsOoperatorTable :: (OperatorTable)
            _parametricsOoperatorTable_collect :: (OperatorTable)
            _typeIerrors :: ([GHError])
            _typeIoperatorTable_collect :: (OperatorTable)
            _typeIself :: (Type)
            _typeOoperatorTable :: (OperatorTable)
            _typeOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _genericsIerrors,_genericsIoperatorTable_collect,_genericsIself) =
                (generics_ (_genericsOoperatorTable) (_genericsOoperatorTable_collect))
            ( _parametricsIerrors,_parametricsIoperatorTable_collect,_parametricsIself) =
                (parametrics_ (_parametricsOoperatorTable) (_parametricsOoperatorTable_collect))
            ( _typeIerrors,_typeIoperatorTable_collect,_typeIself) =
                (type_ (_typeOoperatorTable) (_typeOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _genericsIerrors ++ _parametricsIerrors ++ _typeIerrors
            -- self rule
            (_self@_) =
                Declaration_GenericTypeSignature _rangeIself _nameIself _genericsIself _parametricsIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _typeIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_genericsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_genericsOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_parametricsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_parametricsOoperatorTable_collect@_) =
                _genericsIoperatorTable_collect
            -- copy rule (down)
            (_typeOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_typeOoperatorTable_collect@_) =
                _parametricsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Declaration_Instance :: (T_Range) ->
                            (T_ContextItems) ->
                            (T_Name) ->
                            (T_Types) ->
                            (T_MaybeDeclarations) ->
                            (T_Declaration)
sem_Declaration_Instance (range_) (context_) (name_) (types_) (where_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _contextIerrors :: ([GHError])
            _contextIoperatorTable_collect :: (OperatorTable)
            _contextIself :: (ContextItems)
            _contextOoperatorTable :: (OperatorTable)
            _contextOoperatorTable_collect :: (OperatorTable)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _typesIerrors :: ([GHError])
            _typesIoperatorTable_collect :: (OperatorTable)
            _typesIself :: (Types)
            _typesOoperatorTable :: (OperatorTable)
            _typesOoperatorTable_collect :: (OperatorTable)
            _whereIerrors :: ([GHError])
            _whereIoperatorTable_collect :: (OperatorTable)
            _whereIself :: (MaybeDeclarations)
            _whereOoperatorTable :: (OperatorTable)
            _whereOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _contextIerrors,_contextIoperatorTable_collect,_contextIself) =
                (context_ (_contextOoperatorTable) (_contextOoperatorTable_collect))
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _typesIerrors,_typesIoperatorTable_collect,_typesIself) =
                (types_ (_typesOoperatorTable) (_typesOoperatorTable_collect))
            ( _whereIerrors,_whereIoperatorTable_collect,_whereIself) =
                (where_ (_whereOoperatorTable) (_whereOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _contextIerrors ++ _nameIerrors ++ _typesIerrors ++ _whereIerrors
            -- self rule
            (_self@_) =
                Declaration_Instance _rangeIself _contextIself _nameIself _typesIself _whereIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _whereIoperatorTable_collect
            -- copy rule (down)
            (_contextOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_contextOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_nameOoperatorTable_collect@_) =
                _contextIoperatorTable_collect
            -- copy rule (down)
            (_typesOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_typesOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_whereOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_whereOoperatorTable_collect@_) =
                _typesIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Declaration_KindIndexedType :: (T_Range) ->
                                   (T_KindIndexedBindings) ->
                                   (T_Declaration)
sem_Declaration_KindIndexedType (range_) (bindings_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _bindingsIerrors :: ([GHError])
            _bindingsIoperatorTable_collect :: (OperatorTable)
            _bindingsIself :: (KindIndexedBindings)
            _bindingsOoperatorTable :: (OperatorTable)
            _bindingsOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _bindingsIerrors,_bindingsIoperatorTable_collect,_bindingsIself) =
                (bindings_ (_bindingsOoperatorTable) (_bindingsOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _bindingsIerrors
            -- self rule
            (_self@_) =
                Declaration_KindIndexedType _rangeIself _bindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _bindingsIoperatorTable_collect
            -- copy rule (down)
            (_bindingsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_bindingsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Declaration_Newtype :: (T_Range) ->
                           (T_ContextItems) ->
                           (T_SimpleType) ->
                           (T_Constructor) ->
                           (T_Names) ->
                           (T_Declaration)
sem_Declaration_Newtype (range_) (context_) (simpletype_) (constructor_) (derivings_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _contextIerrors :: ([GHError])
            _contextIoperatorTable_collect :: (OperatorTable)
            _contextIself :: (ContextItems)
            _contextOoperatorTable :: (OperatorTable)
            _contextOoperatorTable_collect :: (OperatorTable)
            _simpletypeIerrors :: ([GHError])
            _simpletypeIoperatorTable_collect :: (OperatorTable)
            _simpletypeIself :: (SimpleType)
            _simpletypeOoperatorTable :: (OperatorTable)
            _simpletypeOoperatorTable_collect :: (OperatorTable)
            _constructorIerrors :: ([GHError])
            _constructorIoperatorTable_collect :: (OperatorTable)
            _constructorIself :: (Constructor)
            _constructorOoperatorTable :: (OperatorTable)
            _constructorOoperatorTable_collect :: (OperatorTable)
            _derivingsIerrors :: ([GHError])
            _derivingsIoperatorTable_collect :: (OperatorTable)
            _derivingsIself :: (Names)
            _derivingsOoperatorTable :: (OperatorTable)
            _derivingsOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _contextIerrors,_contextIoperatorTable_collect,_contextIself) =
                (context_ (_contextOoperatorTable) (_contextOoperatorTable_collect))
            ( _simpletypeIerrors,_simpletypeIoperatorTable_collect,_simpletypeIself) =
                (simpletype_ (_simpletypeOoperatorTable) (_simpletypeOoperatorTable_collect))
            ( _constructorIerrors,_constructorIoperatorTable_collect,_constructorIself) =
                (constructor_ (_constructorOoperatorTable) (_constructorOoperatorTable_collect))
            ( _derivingsIerrors,_derivingsIoperatorTable_collect,_derivingsIself) =
                (derivings_ (_derivingsOoperatorTable) (_derivingsOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _contextIerrors ++ _simpletypeIerrors ++ _constructorIerrors ++ _derivingsIerrors
            -- self rule
            (_self@_) =
                Declaration_Newtype _rangeIself _contextIself _simpletypeIself _constructorIself _derivingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _derivingsIoperatorTable_collect
            -- copy rule (down)
            (_contextOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_contextOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_simpletypeOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_simpletypeOoperatorTable_collect@_) =
                _contextIoperatorTable_collect
            -- copy rule (down)
            (_constructorOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_constructorOoperatorTable_collect@_) =
                _simpletypeIoperatorTable_collect
            -- copy rule (down)
            (_derivingsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_derivingsOoperatorTable_collect@_) =
                _constructorIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Declaration_PatternBinding :: (T_Range) ->
                                  (T_Pattern) ->
                                  (T_RightHandSide) ->
                                  (T_Declaration)
sem_Declaration_PatternBinding (range_) (pattern_) (righthandside_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _patternIerrors :: ([GHError])
            _patternIflatten :: ([FlatPattern])
            _patternIoperatorTable_collect :: (OperatorTable)
            _patternIself :: (Pattern)
            _patternOoperatorTable :: (OperatorTable)
            _patternOoperatorTable_collect :: (OperatorTable)
            _righthandsideIerrors :: ([GHError])
            _righthandsideIoperatorTable_collect :: (OperatorTable)
            _righthandsideIself :: (RightHandSide)
            _righthandsideOoperatorTable :: (OperatorTable)
            _righthandsideOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _patternIerrors,_patternIflatten,_patternIoperatorTable_collect,_patternIself) =
                (pattern_ (_patternOoperatorTable) (_patternOoperatorTable_collect))
            ( _righthandsideIerrors,_righthandsideIoperatorTable_collect,_righthandsideIself) =
                (righthandside_ (_righthandsideOoperatorTable) (_righthandsideOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _patternIerrors ++ _righthandsideIerrors
            -- self rule
            (_self@_) =
                Declaration_PatternBinding _rangeIself _patternIself _righthandsideIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _righthandsideIoperatorTable_collect
            -- copy rule (down)
            (_patternOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_patternOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_righthandsideOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_righthandsideOoperatorTable_collect@_) =
                _patternIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Declaration_Type :: (T_Range) ->
                        (T_SimpleType) ->
                        (T_Type) ->
                        (T_Declaration)
sem_Declaration_Type (range_) (simpletype_) (type_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _simpletypeIerrors :: ([GHError])
            _simpletypeIoperatorTable_collect :: (OperatorTable)
            _simpletypeIself :: (SimpleType)
            _simpletypeOoperatorTable :: (OperatorTable)
            _simpletypeOoperatorTable_collect :: (OperatorTable)
            _typeIerrors :: ([GHError])
            _typeIoperatorTable_collect :: (OperatorTable)
            _typeIself :: (Type)
            _typeOoperatorTable :: (OperatorTable)
            _typeOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _simpletypeIerrors,_simpletypeIoperatorTable_collect,_simpletypeIself) =
                (simpletype_ (_simpletypeOoperatorTable) (_simpletypeOoperatorTable_collect))
            ( _typeIerrors,_typeIoperatorTable_collect,_typeIself) =
                (type_ (_typeOoperatorTable) (_typeOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _simpletypeIerrors ++ _typeIerrors
            -- self rule
            (_self@_) =
                Declaration_Type _rangeIself _simpletypeIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _typeIoperatorTable_collect
            -- copy rule (down)
            (_simpletypeOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_simpletypeOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_typeOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_typeOoperatorTable_collect@_) =
                _simpletypeIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Declaration_TypeIndexedType :: (T_Range) ->
                                   (T_Name) ->
                                   (T_TypeArgument) ->
                                   (T_Names) ->
                                   (T_Constructor) ->
                                   (T_Names) ->
                                   (T_Declaration)
sem_Declaration_TypeIndexedType (range_) (name_) (typeargument_) (typevariables_) (constructor_) (derivings_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _typeargumentIerrors :: ([GHError])
            _typeargumentIoperatorTable_collect :: (OperatorTable)
            _typeargumentIself :: (TypeArgument)
            _typeargumentOoperatorTable :: (OperatorTable)
            _typeargumentOoperatorTable_collect :: (OperatorTable)
            _typevariablesIerrors :: ([GHError])
            _typevariablesIoperatorTable_collect :: (OperatorTable)
            _typevariablesIself :: (Names)
            _typevariablesOoperatorTable :: (OperatorTable)
            _typevariablesOoperatorTable_collect :: (OperatorTable)
            _constructorIerrors :: ([GHError])
            _constructorIoperatorTable_collect :: (OperatorTable)
            _constructorIself :: (Constructor)
            _constructorOoperatorTable :: (OperatorTable)
            _constructorOoperatorTable_collect :: (OperatorTable)
            _derivingsIerrors :: ([GHError])
            _derivingsIoperatorTable_collect :: (OperatorTable)
            _derivingsIself :: (Names)
            _derivingsOoperatorTable :: (OperatorTable)
            _derivingsOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _typeargumentIerrors,_typeargumentIoperatorTable_collect,_typeargumentIself) =
                (typeargument_ (_typeargumentOoperatorTable) (_typeargumentOoperatorTable_collect))
            ( _typevariablesIerrors,_typevariablesIoperatorTable_collect,_typevariablesIself) =
                (typevariables_ (_typevariablesOoperatorTable) (_typevariablesOoperatorTable_collect))
            ( _constructorIerrors,_constructorIoperatorTable_collect,_constructorIself) =
                (constructor_ (_constructorOoperatorTable) (_constructorOoperatorTable_collect))
            ( _derivingsIerrors,_derivingsIoperatorTable_collect,_derivingsIself) =
                (derivings_ (_derivingsOoperatorTable) (_derivingsOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _typeargumentIerrors ++ _typevariablesIerrors ++ _constructorIerrors ++ _derivingsIerrors
            -- self rule
            (_self@_) =
                Declaration_TypeIndexedType _rangeIself _nameIself _typeargumentIself _typevariablesIself _constructorIself _derivingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _derivingsIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_typeargumentOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_typeargumentOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_typevariablesOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_typevariablesOoperatorTable_collect@_) =
                _typeargumentIoperatorTable_collect
            -- copy rule (down)
            (_constructorOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_constructorOoperatorTable_collect@_) =
                _typevariablesIoperatorTable_collect
            -- copy rule (down)
            (_derivingsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_derivingsOoperatorTable_collect@_) =
                _constructorIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Declaration_TypeIndexedValue :: (T_Range) ->
                                    (T_TypeIndexedBindings) ->
                                    (T_Declaration)
sem_Declaration_TypeIndexedValue (range_) (bindings_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _bindingsIerrors :: ([GHError])
            _bindingsIoperatorTable_collect :: (OperatorTable)
            _bindingsIself :: (TypeIndexedBindings)
            _bindingsOoperatorTable :: (OperatorTable)
            _bindingsOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _bindingsIerrors,_bindingsIoperatorTable_collect,_bindingsIself) =
                (bindings_ (_bindingsOoperatorTable) (_bindingsOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _bindingsIerrors
            -- self rule
            (_self@_) =
                Declaration_TypeIndexedValue _rangeIself _bindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _bindingsIoperatorTable_collect
            -- copy rule (down)
            (_bindingsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_bindingsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Declaration_TypeSignature :: (T_Range) ->
                                 (T_Names) ->
                                 (T_Type) ->
                                 (T_Declaration)
sem_Declaration_TypeSignature (range_) (names_) (type_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _namesIerrors :: ([GHError])
            _namesIoperatorTable_collect :: (OperatorTable)
            _namesIself :: (Names)
            _namesOoperatorTable :: (OperatorTable)
            _namesOoperatorTable_collect :: (OperatorTable)
            _typeIerrors :: ([GHError])
            _typeIoperatorTable_collect :: (OperatorTable)
            _typeIself :: (Type)
            _typeOoperatorTable :: (OperatorTable)
            _typeOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _namesIerrors,_namesIoperatorTable_collect,_namesIself) =
                (names_ (_namesOoperatorTable) (_namesOoperatorTable_collect))
            ( _typeIerrors,_typeIoperatorTable_collect,_typeIself) =
                (type_ (_typeOoperatorTable) (_typeOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _namesIerrors ++ _typeIerrors
            -- self rule
            (_self@_) =
                Declaration_TypeSignature _rangeIself _namesIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _typeIoperatorTable_collect
            -- copy rule (down)
            (_namesOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_namesOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_typeOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_typeOoperatorTable_collect@_) =
                _namesIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- Declarations ------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for Declarations.Cons:
      self

-}
{-
   local variables for Declarations.Nil:
      self

-}
-- semantic domain
type T_Declarations = (OperatorTable) ->
                      (OperatorTable) ->
                      ( ([GHError]),(OperatorTable),(Declarations))
-- cata
sem_Declarations :: (Declarations) ->
                    (T_Declarations)
sem_Declarations (list) =
    (foldr (sem_Declarations_Cons) (sem_Declarations_Nil) ((map sem_Declaration list)))
sem_Declarations_Cons :: (T_Declaration) ->
                         (T_Declarations) ->
                         (T_Declarations)
sem_Declarations_Cons (hd_) (tl_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Declarations)
            _hdIerrors :: ([GHError])
            _hdIoperatorTable_collect :: (OperatorTable)
            _hdIself :: (Declaration)
            _hdOoperatorTable :: (OperatorTable)
            _hdOoperatorTable_collect :: (OperatorTable)
            _tlIerrors :: ([GHError])
            _tlIoperatorTable_collect :: (OperatorTable)
            _tlIself :: (Declarations)
            _tlOoperatorTable :: (OperatorTable)
            _tlOoperatorTable_collect :: (OperatorTable)
            ( _hdIerrors,_hdIoperatorTable_collect,_hdIself) =
                (hd_ (_hdOoperatorTable) (_hdOoperatorTable_collect))
            ( _tlIerrors,_tlIoperatorTable_collect,_tlIself) =
                (tl_ (_tlOoperatorTable) (_tlOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _hdIerrors ++ _tlIerrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _tlIoperatorTable_collect
            -- copy rule (down)
            (_hdOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_hdOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_tlOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_tlOoperatorTable_collect@_) =
                _hdIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Declarations_Nil :: (T_Declarations)
sem_Declarations_Nil  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Declarations)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- DependencyBinding -------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for DependencyBinding.Rename:
      self

-}
{-
   local variables for DependencyBinding.Simple:
      self

-}
-- semantic domain
type T_DependencyBinding = (OperatorTable) ->
                           (OperatorTable) ->
                           ( ([GHError]),(OperatorTable),(DependencyBinding))
-- cata
sem_DependencyBinding :: (DependencyBinding) ->
                         (T_DependencyBinding)
sem_DependencyBinding ((DependencyBinding_Rename (_range) (_name) (_as))) =
    (sem_DependencyBinding_Rename ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Name (_as))))
sem_DependencyBinding ((DependencyBinding_Simple (_range) (_name))) =
    (sem_DependencyBinding_Simple ((sem_Range (_range))) ((sem_Name (_name))))
sem_DependencyBinding_Rename :: (T_Range) ->
                                (T_Name) ->
                                (T_Name) ->
                                (T_DependencyBinding)
sem_DependencyBinding_Rename (range_) (name_) (as_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (DependencyBinding)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _asIerrors :: ([GHError])
            _asIoperatorTable_collect :: (OperatorTable)
            _asIself :: (Name)
            _asOoperatorTable :: (OperatorTable)
            _asOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _asIerrors,_asIoperatorTable_collect,_asIself) =
                (as_ (_asOoperatorTable) (_asOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _asIerrors
            -- self rule
            (_self@_) =
                DependencyBinding_Rename _rangeIself _nameIself _asIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _asIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_asOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_asOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_DependencyBinding_Simple :: (T_Range) ->
                                (T_Name) ->
                                (T_DependencyBinding)
sem_DependencyBinding_Simple (range_) (name_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (DependencyBinding)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors
            -- self rule
            (_self@_) =
                DependencyBinding_Simple _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- DependencyBindings ------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for DependencyBindings.Cons:
      self

-}
{-
   local variables for DependencyBindings.Nil:
      self

-}
-- semantic domain
type T_DependencyBindings = (OperatorTable) ->
                            (OperatorTable) ->
                            ( ([GHError]),(OperatorTable),(DependencyBindings))
-- cata
sem_DependencyBindings :: (DependencyBindings) ->
                          (T_DependencyBindings)
sem_DependencyBindings (list) =
    (foldr (sem_DependencyBindings_Cons) (sem_DependencyBindings_Nil) ((map sem_DependencyBinding list)))
sem_DependencyBindings_Cons :: (T_DependencyBinding) ->
                               (T_DependencyBindings) ->
                               (T_DependencyBindings)
sem_DependencyBindings_Cons (hd_) (tl_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (DependencyBindings)
            _hdIerrors :: ([GHError])
            _hdIoperatorTable_collect :: (OperatorTable)
            _hdIself :: (DependencyBinding)
            _hdOoperatorTable :: (OperatorTable)
            _hdOoperatorTable_collect :: (OperatorTable)
            _tlIerrors :: ([GHError])
            _tlIoperatorTable_collect :: (OperatorTable)
            _tlIself :: (DependencyBindings)
            _tlOoperatorTable :: (OperatorTable)
            _tlOoperatorTable_collect :: (OperatorTable)
            ( _hdIerrors,_hdIoperatorTable_collect,_hdIself) =
                (hd_ (_hdOoperatorTable) (_hdOoperatorTable_collect))
            ( _tlIerrors,_tlIoperatorTable_collect,_tlIself) =
                (tl_ (_tlOoperatorTable) (_tlOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _hdIerrors ++ _tlIerrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _tlIoperatorTable_collect
            -- copy rule (down)
            (_hdOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_hdOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_tlOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_tlOoperatorTable_collect@_) =
                _hdIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_DependencyBindings_Nil :: (T_DependencyBindings)
sem_DependencyBindings_Nil  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (DependencyBindings)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- Export ------------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for Export.Module:
      self

-}
{-
   local variables for Export.TypeOrClass:
      self

-}
{-
   local variables for Export.TypeOrClassComplete:
      self

-}
{-
   local variables for Export.Variable:
      self

-}
-- semantic domain
type T_Export = (OperatorTable) ->
                (OperatorTable) ->
                ( ([GHError]),(OperatorTable),(Export))
-- cata
sem_Export :: (Export) ->
              (T_Export)
sem_Export ((Export_Module (_range) (_name))) =
    (sem_Export_Module ((sem_Range (_range))) ((sem_ModuleName (_name))))
sem_Export ((Export_TypeOrClass (_range) (_name) (_names))) =
    (sem_Export_TypeOrClass ((sem_Range (_range))) ((sem_Name (_name))) ((sem_MaybeNames (_names))))
sem_Export ((Export_TypeOrClassComplete (_range) (_name))) =
    (sem_Export_TypeOrClassComplete ((sem_Range (_range))) ((sem_Name (_name))))
sem_Export ((Export_Variable (_range) (_name))) =
    (sem_Export_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Export_Module :: (T_Range) ->
                     (T_ModuleName) ->
                     (T_Export)
sem_Export_Module (range_) (name_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Export)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (ModuleName)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors
            -- self rule
            (_self@_) =
                Export_Module _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Export_TypeOrClass :: (T_Range) ->
                          (T_Name) ->
                          (T_MaybeNames) ->
                          (T_Export)
sem_Export_TypeOrClass (range_) (name_) (names_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Export)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _namesIerrors :: ([GHError])
            _namesIoperatorTable_collect :: (OperatorTable)
            _namesIself :: (MaybeNames)
            _namesOoperatorTable :: (OperatorTable)
            _namesOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _namesIerrors,_namesIoperatorTable_collect,_namesIself) =
                (names_ (_namesOoperatorTable) (_namesOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _namesIerrors
            -- self rule
            (_self@_) =
                Export_TypeOrClass _rangeIself _nameIself _namesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _namesIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_namesOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_namesOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Export_TypeOrClassComplete :: (T_Range) ->
                                  (T_Name) ->
                                  (T_Export)
sem_Export_TypeOrClassComplete (range_) (name_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Export)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors
            -- self rule
            (_self@_) =
                Export_TypeOrClassComplete _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Export_Variable :: (T_Range) ->
                       (T_Name) ->
                       (T_Export)
sem_Export_Variable (range_) (name_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Export)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors
            -- self rule
            (_self@_) =
                Export_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- Exports -----------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for Exports.Cons:
      self

-}
{-
   local variables for Exports.Nil:
      self

-}
-- semantic domain
type T_Exports = (OperatorTable) ->
                 (OperatorTable) ->
                 ( ([GHError]),(OperatorTable),(Exports))
-- cata
sem_Exports :: (Exports) ->
               (T_Exports)
sem_Exports (list) =
    (foldr (sem_Exports_Cons) (sem_Exports_Nil) ((map sem_Export list)))
sem_Exports_Cons :: (T_Export) ->
                    (T_Exports) ->
                    (T_Exports)
sem_Exports_Cons (hd_) (tl_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Exports)
            _hdIerrors :: ([GHError])
            _hdIoperatorTable_collect :: (OperatorTable)
            _hdIself :: (Export)
            _hdOoperatorTable :: (OperatorTable)
            _hdOoperatorTable_collect :: (OperatorTable)
            _tlIerrors :: ([GHError])
            _tlIoperatorTable_collect :: (OperatorTable)
            _tlIself :: (Exports)
            _tlOoperatorTable :: (OperatorTable)
            _tlOoperatorTable_collect :: (OperatorTable)
            ( _hdIerrors,_hdIoperatorTable_collect,_hdIself) =
                (hd_ (_hdOoperatorTable) (_hdOoperatorTable_collect))
            ( _tlIerrors,_tlIoperatorTable_collect,_tlIself) =
                (tl_ (_tlOoperatorTable) (_tlOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _hdIerrors ++ _tlIerrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _tlIoperatorTable_collect
            -- copy rule (down)
            (_hdOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_hdOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_tlOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_tlOoperatorTable_collect@_) =
                _hdIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Exports_Nil :: (T_Exports)
sem_Exports_Nil  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Exports)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- Expression --------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      flatten              : [FlatExpression]
      self                 : SELF

-}
{-
   local variables for Expression.As:
      self

-}
{-
   local variables for Expression.Case:
      self

-}
{-
   local variables for Expression.Comprehension:
      self

-}
{-
   local variables for Expression.Constructor:
      self

-}
{-
   local variables for Expression.Do:
      self

-}
{-
   local variables for Expression.Enum:
      self

-}
{-
   local variables for Expression.If:
      self

-}
{-
   local variables for Expression.InfixApplication:
      fullyapplied
      flatten
      resolved
      errors
      self

-}
{-
   local variables for Expression.Irrefutable:
      self

-}
{-
   local variables for Expression.Lambda:
      self

-}
{-
   local variables for Expression.Let:
      operatorTable
      self

-}
{-
   local variables for Expression.List:
      self

-}
{-
   local variables for Expression.Literal:
      self

-}
{-
   local variables for Expression.Negate:
      self

-}
{-
   local variables for Expression.NormalApplication:
      self

-}
{-
   local variables for Expression.Parenthesized:
      self

-}
{-
   local variables for Expression.RecordConstruction:
      self

-}
{-
   local variables for Expression.RecordUpdate:
      self

-}
{-
   local variables for Expression.Tuple:
      self

-}
{-
   local variables for Expression.TypeApplication:
      self

-}
{-
   local variables for Expression.Typed:
      self

-}
{-
   local variables for Expression.Variable:
      self

-}
{-
   local variables for Expression.Wildcard:
      self

-}
-- semantic domain
type T_Expression = (OperatorTable) ->
                    (OperatorTable) ->
                    ( ([GHError]),([FlatExpression]),(OperatorTable),(Expression))
-- cata
sem_Expression :: (Expression) ->
                  (T_Expression)
sem_Expression ((Expression_As (_range) (_name) (_expression))) =
    (sem_Expression_As ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Expression (_expression))))
sem_Expression ((Expression_Case (_range) (_expression) (_alternatives))) =
    (sem_Expression_Case ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_Alternatives (_alternatives))))
sem_Expression ((Expression_Comprehension (_range) (_expression) (_qualifiers))) =
    (sem_Expression_Comprehension ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_Qualifiers (_qualifiers))))
sem_Expression ((Expression_Constructor (_range) (_name))) =
    (sem_Expression_Constructor ((sem_Range (_range))) ((sem_Name (_name))))
sem_Expression ((Expression_Do (_range) (_statements))) =
    (sem_Expression_Do ((sem_Range (_range))) ((sem_Statements (_statements))))
sem_Expression ((Expression_Enum (_range) (_from) (_then) (_to))) =
    (sem_Expression_Enum ((sem_Range (_range))) ((sem_Expression (_from))) ((sem_MaybeExpression (_then))) ((sem_MaybeExpression (_to))))
sem_Expression ((Expression_If (_range) (_guardExpression) (_thenExpression) (_elseExpression))) =
    (sem_Expression_If ((sem_Range (_range))) ((sem_Expression (_guardExpression))) ((sem_Expression (_thenExpression))) ((sem_Expression (_elseExpression))))
sem_Expression ((Expression_InfixApplication (_range) (_leftExpression) (_operator) (_rightExpression))) =
    (sem_Expression_InfixApplication ((sem_Range (_range))) ((sem_MaybeExpression (_leftExpression))) ((sem_Expression (_operator))) ((sem_MaybeExpression (_rightExpression))))
sem_Expression ((Expression_Irrefutable (_range) (_expression))) =
    (sem_Expression_Irrefutable ((sem_Range (_range))) ((sem_Expression (_expression))))
sem_Expression ((Expression_Lambda (_range) (_patterns) (_expression))) =
    (sem_Expression_Lambda ((sem_Range (_range))) ((sem_Patterns (_patterns))) ((sem_Expression (_expression))))
sem_Expression ((Expression_Let (_range) (_declarations) (_expression))) =
    (sem_Expression_Let ((sem_Range (_range))) ((sem_Declarations (_declarations))) ((sem_Expression (_expression))))
sem_Expression ((Expression_List (_range) (_expressions))) =
    (sem_Expression_List ((sem_Range (_range))) ((sem_Expressions (_expressions))))
sem_Expression ((Expression_Literal (_range) (_literal))) =
    (sem_Expression_Literal ((sem_Range (_range))) ((sem_Literal (_literal))))
sem_Expression ((Expression_Negate (_range) (_expression))) =
    (sem_Expression_Negate ((sem_Range (_range))) ((sem_Expression (_expression))))
sem_Expression ((Expression_NormalApplication (_range) (_function) (_arguments))) =
    (sem_Expression_NormalApplication ((sem_Range (_range))) ((sem_Expression (_function))) ((sem_Expressions (_arguments))))
sem_Expression ((Expression_Parenthesized (_range) (_expression))) =
    (sem_Expression_Parenthesized ((sem_Range (_range))) ((sem_Expression (_expression))))
sem_Expression ((Expression_RecordConstruction (_range) (_name) (_recordExpressionBindings))) =
    (sem_Expression_RecordConstruction ((sem_Range (_range))) ((sem_Name (_name))) ((sem_RecordExpressionBindings (_recordExpressionBindings))))
sem_Expression ((Expression_RecordUpdate (_range) (_expression) (_recordExpressionBindings))) =
    (sem_Expression_RecordUpdate ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_RecordExpressionBindings (_recordExpressionBindings))))
sem_Expression ((Expression_Tuple (_range) (_expressions))) =
    (sem_Expression_Tuple ((sem_Range (_range))) ((sem_Expressions (_expressions))))
sem_Expression ((Expression_TypeApplication (_range) (_name) (_type))) =
    (sem_Expression_TypeApplication ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Type (_type))))
sem_Expression ((Expression_Typed (_range) (_expression) (_type))) =
    (sem_Expression_Typed ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_Type (_type))))
sem_Expression ((Expression_Variable (_range) (_name))) =
    (sem_Expression_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Expression ((Expression_Wildcard (_range))) =
    (sem_Expression_Wildcard ((sem_Range (_range))))
sem_Expression_As :: (T_Range) ->
                     (T_Name) ->
                     (T_Expression) ->
                     (T_Expression)
sem_Expression_As (range_) (name_) (expression_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatExpression])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _expressionIerrors :: ([GHError])
            _expressionIflatten :: ([FlatExpression])
            _expressionIoperatorTable_collect :: (OperatorTable)
            _expressionIself :: (Expression)
            _expressionOoperatorTable :: (OperatorTable)
            _expressionOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _expressionIerrors,_expressionIflatten,_expressionIoperatorTable_collect,_expressionIself) =
                (expression_ (_expressionOoperatorTable) (_expressionOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _expressionIerrors
            -- use rule
            (_lhsOflatten@_) =
                _expressionIflatten
            -- self rule
            (_self@_) =
                Expression_As _rangeIself _nameIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _expressionIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_expressionOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_expressionOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Expression_Case :: (T_Range) ->
                       (T_Expression) ->
                       (T_Alternatives) ->
                       (T_Expression)
sem_Expression_Case (range_) (expression_) (alternatives_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatExpression])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _expressionIerrors :: ([GHError])
            _expressionIflatten :: ([FlatExpression])
            _expressionIoperatorTable_collect :: (OperatorTable)
            _expressionIself :: (Expression)
            _expressionOoperatorTable :: (OperatorTable)
            _expressionOoperatorTable_collect :: (OperatorTable)
            _alternativesIerrors :: ([GHError])
            _alternativesIoperatorTable_collect :: (OperatorTable)
            _alternativesIself :: (Alternatives)
            _alternativesOoperatorTable :: (OperatorTable)
            _alternativesOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _expressionIerrors,_expressionIflatten,_expressionIoperatorTable_collect,_expressionIself) =
                (expression_ (_expressionOoperatorTable) (_expressionOoperatorTable_collect))
            ( _alternativesIerrors,_alternativesIoperatorTable_collect,_alternativesIself) =
                (alternatives_ (_alternativesOoperatorTable) (_alternativesOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 290, column 9)
            (_lhsOflatten@_) =
                [FItem _self]
            -- use rule
            (_lhsOerrors@_) =
                _expressionIerrors ++ _alternativesIerrors
            -- self rule
            (_self@_) =
                Expression_Case _rangeIself _expressionIself _alternativesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _alternativesIoperatorTable_collect
            -- copy rule (down)
            (_expressionOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_expressionOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_alternativesOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_alternativesOoperatorTable_collect@_) =
                _expressionIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Expression_Comprehension :: (T_Range) ->
                                (T_Expression) ->
                                (T_Qualifiers) ->
                                (T_Expression)
sem_Expression_Comprehension (range_) (expression_) (qualifiers_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatExpression])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _expressionIerrors :: ([GHError])
            _expressionIflatten :: ([FlatExpression])
            _expressionIoperatorTable_collect :: (OperatorTable)
            _expressionIself :: (Expression)
            _expressionOoperatorTable :: (OperatorTable)
            _expressionOoperatorTable_collect :: (OperatorTable)
            _qualifiersIerrors :: ([GHError])
            _qualifiersIoperatorTable_collect :: (OperatorTable)
            _qualifiersIself :: (Qualifiers)
            _qualifiersOoperatorTable :: (OperatorTable)
            _qualifiersOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _expressionIerrors,_expressionIflatten,_expressionIoperatorTable_collect,_expressionIself) =
                (expression_ (_expressionOoperatorTable) (_expressionOoperatorTable_collect))
            ( _qualifiersIerrors,_qualifiersIoperatorTable_collect,_qualifiersIself) =
                (qualifiers_ (_qualifiersOoperatorTable) (_qualifiersOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 185, column 9)
            (_qualifiersOoperatorTable@_) =
                _lhsIoperatorTable
            -- "ResolveOperators.lag"(line 184, column 9)
            (_expressionOoperatorTable@_) =
                _qualifiersIoperatorTable_collect
            -- "ResolveOperators.lag"(line 182, column 9)
            (_qualifiersOoperatorTable_collect@_) =
                _lhsIoperatorTable
            -- "ResolveOperators.lag"(line 181, column 9)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- "ResolveOperators.lag"(line 300, column 9)
            (_lhsOflatten@_) =
                [FItem _self]
            -- use rule
            (_lhsOerrors@_) =
                _expressionIerrors ++ _qualifiersIerrors
            -- self rule
            (_self@_) =
                Expression_Comprehension _rangeIself _expressionIself _qualifiersIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_expressionOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Expression_Constructor :: (T_Range) ->
                              (T_Name) ->
                              (T_Expression)
sem_Expression_Constructor (range_) (name_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatExpression])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 268, column 9)
            (_lhsOflatten@_) =
                [FItem _self]
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors
            -- self rule
            (_self@_) =
                Expression_Constructor _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Expression_Do :: (T_Range) ->
                     (T_Statements) ->
                     (T_Expression)
sem_Expression_Do (range_) (statements_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatExpression])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _statementsIerrors :: ([GHError])
            _statementsIoperatorTable_collect :: (OperatorTable)
            _statementsIself :: (Statements)
            _statementsOoperatorTable :: (OperatorTable)
            _statementsOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _statementsIerrors,_statementsIoperatorTable_collect,_statementsIself) =
                (statements_ (_statementsOoperatorTable) (_statementsOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 178, column 9)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- "ResolveOperators.lag"(line 294, column 9)
            (_lhsOflatten@_) =
                [FItem _self]
            -- use rule
            (_lhsOerrors@_) =
                _statementsIerrors
            -- self rule
            (_self@_) =
                Expression_Do _rangeIself _statementsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_statementsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_statementsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Expression_Enum :: (T_Range) ->
                       (T_Expression) ->
                       (T_MaybeExpression) ->
                       (T_MaybeExpression) ->
                       (T_Expression)
sem_Expression_Enum (range_) (from_) (then_) (to_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatExpression])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _fromIerrors :: ([GHError])
            _fromIflatten :: ([FlatExpression])
            _fromIoperatorTable_collect :: (OperatorTable)
            _fromIself :: (Expression)
            _fromOoperatorTable :: (OperatorTable)
            _fromOoperatorTable_collect :: (OperatorTable)
            _thenIerrors :: ([GHError])
            _thenIflatten :: ([FlatExpression])
            _thenIoperatorTable_collect :: (OperatorTable)
            _thenIself :: (MaybeExpression)
            _thenOoperatorTable :: (OperatorTable)
            _thenOoperatorTable_collect :: (OperatorTable)
            _toIerrors :: ([GHError])
            _toIflatten :: ([FlatExpression])
            _toIoperatorTable_collect :: (OperatorTable)
            _toIself :: (MaybeExpression)
            _toOoperatorTable :: (OperatorTable)
            _toOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _fromIerrors,_fromIflatten,_fromIoperatorTable_collect,_fromIself) =
                (from_ (_fromOoperatorTable) (_fromOoperatorTable_collect))
            ( _thenIerrors,_thenIflatten,_thenIoperatorTable_collect,_thenIself) =
                (then_ (_thenOoperatorTable) (_thenOoperatorTable_collect))
            ( _toIerrors,_toIflatten,_toIoperatorTable_collect,_toIself) =
                (to_ (_toOoperatorTable) (_toOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 308, column 9)
            (_lhsOflatten@_) =
                [FItem _self]
            -- use rule
            (_lhsOerrors@_) =
                _fromIerrors ++ _thenIerrors ++ _toIerrors
            -- self rule
            (_self@_) =
                Expression_Enum _rangeIself _fromIself _thenIself _toIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _toIoperatorTable_collect
            -- copy rule (down)
            (_fromOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_fromOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_thenOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_thenOoperatorTable_collect@_) =
                _fromIoperatorTable_collect
            -- copy rule (down)
            (_toOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_toOoperatorTable_collect@_) =
                _thenIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Expression_If :: (T_Range) ->
                     (T_Expression) ->
                     (T_Expression) ->
                     (T_Expression) ->
                     (T_Expression)
sem_Expression_If (range_) (guardExpression_) (thenExpression_) (elseExpression_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatExpression])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _guardExpressionIerrors :: ([GHError])
            _guardExpressionIflatten :: ([FlatExpression])
            _guardExpressionIoperatorTable_collect :: (OperatorTable)
            _guardExpressionIself :: (Expression)
            _guardExpressionOoperatorTable :: (OperatorTable)
            _guardExpressionOoperatorTable_collect :: (OperatorTable)
            _thenExpressionIerrors :: ([GHError])
            _thenExpressionIflatten :: ([FlatExpression])
            _thenExpressionIoperatorTable_collect :: (OperatorTable)
            _thenExpressionIself :: (Expression)
            _thenExpressionOoperatorTable :: (OperatorTable)
            _thenExpressionOoperatorTable_collect :: (OperatorTable)
            _elseExpressionIerrors :: ([GHError])
            _elseExpressionIflatten :: ([FlatExpression])
            _elseExpressionIoperatorTable_collect :: (OperatorTable)
            _elseExpressionIself :: (Expression)
            _elseExpressionOoperatorTable :: (OperatorTable)
            _elseExpressionOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _guardExpressionIerrors,_guardExpressionIflatten,_guardExpressionIoperatorTable_collect,_guardExpressionIself) =
                (guardExpression_ (_guardExpressionOoperatorTable) (_guardExpressionOoperatorTable_collect))
            ( _thenExpressionIerrors,_thenExpressionIflatten,_thenExpressionIoperatorTable_collect,_thenExpressionIself) =
                (thenExpression_ (_thenExpressionOoperatorTable) (_thenExpressionOoperatorTable_collect))
            ( _elseExpressionIerrors,_elseExpressionIflatten,_elseExpressionIoperatorTable_collect,_elseExpressionIself) =
                (elseExpression_ (_elseExpressionOoperatorTable) (_elseExpressionOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 286, column 9)
            (_lhsOflatten@_) =
                [FItem _self]
            -- use rule
            (_lhsOerrors@_) =
                _guardExpressionIerrors ++ _thenExpressionIerrors ++ _elseExpressionIerrors
            -- self rule
            (_self@_) =
                Expression_If _rangeIself _guardExpressionIself _thenExpressionIself _elseExpressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _elseExpressionIoperatorTable_collect
            -- copy rule (down)
            (_guardExpressionOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_guardExpressionOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_thenExpressionOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_thenExpressionOoperatorTable_collect@_) =
                _guardExpressionIoperatorTable_collect
            -- copy rule (down)
            (_elseExpressionOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_elseExpressionOoperatorTable_collect@_) =
                _thenExpressionIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Expression_InfixApplication :: (T_Range) ->
                                   (T_MaybeExpression) ->
                                   (T_Expression) ->
                                   (T_MaybeExpression) ->
                                   (T_Expression)
sem_Expression_InfixApplication (range_) (leftExpression_) (operator_) (rightExpression_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatExpression])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _leftExpressionIerrors :: ([GHError])
            _leftExpressionIflatten :: ([FlatExpression])
            _leftExpressionIoperatorTable_collect :: (OperatorTable)
            _leftExpressionIself :: (MaybeExpression)
            _leftExpressionOoperatorTable :: (OperatorTable)
            _leftExpressionOoperatorTable_collect :: (OperatorTable)
            _operatorIerrors :: ([GHError])
            _operatorIflatten :: ([FlatExpression])
            _operatorIoperatorTable_collect :: (OperatorTable)
            _operatorIself :: (Expression)
            _operatorOoperatorTable :: (OperatorTable)
            _operatorOoperatorTable_collect :: (OperatorTable)
            _rightExpressionIerrors :: ([GHError])
            _rightExpressionIflatten :: ([FlatExpression])
            _rightExpressionIoperatorTable_collect :: (OperatorTable)
            _rightExpressionIself :: (MaybeExpression)
            _rightExpressionOoperatorTable :: (OperatorTable)
            _rightExpressionOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _leftExpressionIerrors,_leftExpressionIflatten,_leftExpressionIoperatorTable_collect,_leftExpressionIself) =
                (leftExpression_ (_leftExpressionOoperatorTable) (_leftExpressionOoperatorTable_collect))
            ( _operatorIerrors,_operatorIflatten,_operatorIoperatorTable_collect,_operatorIself) =
                (operator_ (_operatorOoperatorTable) (_operatorOoperatorTable_collect))
            ( _rightExpressionIerrors,_rightExpressionIflatten,_rightExpressionIoperatorTable_collect,_rightExpressionIself) =
                (rightExpression_ (_rightExpressionOoperatorTable) (_rightExpressionOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 281, column 9)
            (_lhsOflatten@_) =
                if _fullyapplied then
                  _flatten
                else
                  [FItem _resolved]
            -- "ResolveOperators.lag"(line 277, column 9)
            (_fullyapplied@_) =
                not (null _leftExpressionIflatten
                      ||
                     null _rightExpressionIflatten
                    )
            -- "ResolveOperators.lag"(line 274, column 9)
            (_flatten@_) =
                _leftExpressionIflatten
                  ++ [FOperator _operatorIself]
                  ++ _rightExpressionIflatten
            -- "ResolveOperators.lag"(line 380, column 9)
            (_lhsOself@_) =
                _resolved
            -- "ResolveOperators.lag"(line 360, column 13)
            ((_resolved@_,_errors@_)) =
                if _fullyapplied then
                  resolveExpression
                    _lhsIoperatorTable
                    _flatten
                else
                  let
                    (rl,el) = resolveMaybeExpression
                                _lhsIoperatorTable
                                _leftExpressionIflatten
                    (rr,er) = resolveMaybeExpression
                                _lhsIoperatorTable
                                _rightExpressionIflatten
                  in
                    (Expression_InfixApplication
                       unknownRange
                       rl
                       _operatorIself
                       rr
                    ,el ++ er
                    )
            -- use rule
            (_lhsOerrors@_) =
                _errors
            -- self rule
            (_self@_) =
                Expression_InfixApplication _rangeIself _leftExpressionIself _operatorIself _rightExpressionIself
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _rightExpressionIoperatorTable_collect
            -- copy rule (down)
            (_leftExpressionOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_leftExpressionOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_operatorOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_operatorOoperatorTable_collect@_) =
                _leftExpressionIoperatorTable_collect
            -- copy rule (down)
            (_rightExpressionOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_rightExpressionOoperatorTable_collect@_) =
                _operatorIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Expression_Irrefutable :: (T_Range) ->
                              (T_Expression) ->
                              (T_Expression)
sem_Expression_Irrefutable (range_) (expression_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatExpression])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _expressionIerrors :: ([GHError])
            _expressionIflatten :: ([FlatExpression])
            _expressionIoperatorTable_collect :: (OperatorTable)
            _expressionIself :: (Expression)
            _expressionOoperatorTable :: (OperatorTable)
            _expressionOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _expressionIerrors,_expressionIflatten,_expressionIoperatorTable_collect,_expressionIself) =
                (expression_ (_expressionOoperatorTable) (_expressionOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _expressionIerrors
            -- use rule
            (_lhsOflatten@_) =
                _expressionIflatten
            -- self rule
            (_self@_) =
                Expression_Irrefutable _rangeIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _expressionIoperatorTable_collect
            -- copy rule (down)
            (_expressionOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_expressionOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Expression_Lambda :: (T_Range) ->
                         (T_Patterns) ->
                         (T_Expression) ->
                         (T_Expression)
sem_Expression_Lambda (range_) (patterns_) (expression_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatExpression])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _patternsIerrors :: ([GHError])
            _patternsIoperatorTable_collect :: (OperatorTable)
            _patternsIself :: (Patterns)
            _patternsOoperatorTable :: (OperatorTable)
            _patternsOoperatorTable_collect :: (OperatorTable)
            _expressionIerrors :: ([GHError])
            _expressionIflatten :: ([FlatExpression])
            _expressionIoperatorTable_collect :: (OperatorTable)
            _expressionIself :: (Expression)
            _expressionOoperatorTable :: (OperatorTable)
            _expressionOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _patternsIerrors,_patternsIoperatorTable_collect,_patternsIself) =
                (patterns_ (_patternsOoperatorTable) (_patternsOoperatorTable_collect))
            ( _expressionIerrors,_expressionIflatten,_expressionIoperatorTable_collect,_expressionIself) =
                (expression_ (_expressionOoperatorTable) (_expressionOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 288, column 9)
            (_lhsOflatten@_) =
                [FItem _self]
            -- use rule
            (_lhsOerrors@_) =
                _patternsIerrors ++ _expressionIerrors
            -- self rule
            (_self@_) =
                Expression_Lambda _rangeIself _patternsIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _expressionIoperatorTable_collect
            -- copy rule (down)
            (_patternsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_patternsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_expressionOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_expressionOoperatorTable_collect@_) =
                _patternsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Expression_Let :: (T_Range) ->
                      (T_Declarations) ->
                      (T_Expression) ->
                      (T_Expression)
sem_Expression_Let (range_) (declarations_) (expression_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatExpression])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _declarationsIerrors :: ([GHError])
            _declarationsIoperatorTable_collect :: (OperatorTable)
            _declarationsIself :: (Declarations)
            _declarationsOoperatorTable :: (OperatorTable)
            _declarationsOoperatorTable_collect :: (OperatorTable)
            _expressionIerrors :: ([GHError])
            _expressionIflatten :: ([FlatExpression])
            _expressionIoperatorTable_collect :: (OperatorTable)
            _expressionIself :: (Expression)
            _expressionOoperatorTable :: (OperatorTable)
            _expressionOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _declarationsIerrors,_declarationsIoperatorTable_collect,_declarationsIself) =
                (declarations_ (_declarationsOoperatorTable) (_declarationsOoperatorTable_collect))
            ( _expressionIerrors,_expressionIflatten,_expressionIoperatorTable_collect,_expressionIself) =
                (expression_ (_expressionOoperatorTable) (_expressionOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 173, column 9)
            (_operatorTable@_) =
                mergeFM
                  _declarationsIoperatorTable_collect
                  _lhsIoperatorTable
            -- "ResolveOperators.lag"(line 171, column 9)
            (_declarationsOoperatorTable_collect@_) =
                emptyFM
            -- "ResolveOperators.lag"(line 170, column 9)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- "ResolveOperators.lag"(line 292, column 9)
            (_lhsOflatten@_) =
                [FItem _self]
            -- use rule
            (_lhsOerrors@_) =
                _declarationsIerrors ++ _expressionIerrors
            -- self rule
            (_self@_) =
                Expression_Let _rangeIself _declarationsIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_declarationsOoperatorTable@_) =
                _operatorTable
            -- copy rule (chain)
            (_expressionOoperatorTable@_) =
                _operatorTable
            -- copy rule (chain)
            (_expressionOoperatorTable_collect@_) =
                _declarationsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Expression_List :: (T_Range) ->
                       (T_Expressions) ->
                       (T_Expression)
sem_Expression_List (range_) (expressions_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatExpression])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _expressionsIerrors :: ([GHError])
            _expressionsIoperatorTable_collect :: (OperatorTable)
            _expressionsIself :: (Expressions)
            _expressionsOoperatorTable :: (OperatorTable)
            _expressionsOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _expressionsIerrors,_expressionsIoperatorTable_collect,_expressionsIself) =
                (expressions_ (_expressionsOoperatorTable) (_expressionsOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 296, column 9)
            (_lhsOflatten@_) =
                [FItem _self]
            -- use rule
            (_lhsOerrors@_) =
                _expressionsIerrors
            -- self rule
            (_self@_) =
                Expression_List _rangeIself _expressionsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _expressionsIoperatorTable_collect
            -- copy rule (down)
            (_expressionsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_expressionsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Expression_Literal :: (T_Range) ->
                          (T_Literal) ->
                          (T_Expression)
sem_Expression_Literal (range_) (literal_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatExpression])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _literalIerrors :: ([GHError])
            _literalIoperatorTable_collect :: (OperatorTable)
            _literalIself :: (Literal)
            _literalOoperatorTable :: (OperatorTable)
            _literalOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _literalIerrors,_literalIoperatorTable_collect,_literalIself) =
                (literal_ (_literalOoperatorTable) (_literalOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 264, column 9)
            (_lhsOflatten@_) =
                [FItem _self]
            -- use rule
            (_lhsOerrors@_) =
                _literalIerrors
            -- self rule
            (_self@_) =
                Expression_Literal _rangeIself _literalIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _literalIoperatorTable_collect
            -- copy rule (down)
            (_literalOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_literalOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Expression_Negate :: (T_Range) ->
                         (T_Expression) ->
                         (T_Expression)
sem_Expression_Negate (range_) (expression_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatExpression])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _expressionIerrors :: ([GHError])
            _expressionIflatten :: ([FlatExpression])
            _expressionIoperatorTable_collect :: (OperatorTable)
            _expressionIself :: (Expression)
            _expressionOoperatorTable :: (OperatorTable)
            _expressionOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _expressionIerrors,_expressionIflatten,_expressionIoperatorTable_collect,_expressionIself) =
                (expression_ (_expressionOoperatorTable) (_expressionOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 310, column 9)
            (_lhsOflatten@_) =
                [FUnaryMinus,FItem _expressionIself]
            -- use rule
            (_lhsOerrors@_) =
                _expressionIerrors
            -- self rule
            (_self@_) =
                Expression_Negate _rangeIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _expressionIoperatorTable_collect
            -- copy rule (down)
            (_expressionOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_expressionOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Expression_NormalApplication :: (T_Range) ->
                                    (T_Expression) ->
                                    (T_Expressions) ->
                                    (T_Expression)
sem_Expression_NormalApplication (range_) (function_) (arguments_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatExpression])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _functionIerrors :: ([GHError])
            _functionIflatten :: ([FlatExpression])
            _functionIoperatorTable_collect :: (OperatorTable)
            _functionIself :: (Expression)
            _functionOoperatorTable :: (OperatorTable)
            _functionOoperatorTable_collect :: (OperatorTable)
            _argumentsIerrors :: ([GHError])
            _argumentsIoperatorTable_collect :: (OperatorTable)
            _argumentsIself :: (Expressions)
            _argumentsOoperatorTable :: (OperatorTable)
            _argumentsOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _functionIerrors,_functionIflatten,_functionIoperatorTable_collect,_functionIself) =
                (function_ (_functionOoperatorTable) (_functionOoperatorTable_collect))
            ( _argumentsIerrors,_argumentsIoperatorTable_collect,_argumentsIself) =
                (arguments_ (_argumentsOoperatorTable) (_argumentsOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 272, column 9)
            (_lhsOflatten@_) =
                [FItem _self]
            -- use rule
            (_lhsOerrors@_) =
                _functionIerrors ++ _argumentsIerrors
            -- self rule
            (_self@_) =
                Expression_NormalApplication _rangeIself _functionIself _argumentsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _argumentsIoperatorTable_collect
            -- copy rule (down)
            (_functionOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_functionOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_argumentsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_argumentsOoperatorTable_collect@_) =
                _functionIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Expression_Parenthesized :: (T_Range) ->
                                (T_Expression) ->
                                (T_Expression)
sem_Expression_Parenthesized (range_) (expression_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatExpression])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _expressionIerrors :: ([GHError])
            _expressionIflatten :: ([FlatExpression])
            _expressionIoperatorTable_collect :: (OperatorTable)
            _expressionIself :: (Expression)
            _expressionOoperatorTable :: (OperatorTable)
            _expressionOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _expressionIerrors,_expressionIflatten,_expressionIoperatorTable_collect,_expressionIself) =
                (expression_ (_expressionOoperatorTable) (_expressionOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 270, column 9)
            (_lhsOflatten@_) =
                [FItem _self]
            -- use rule
            (_lhsOerrors@_) =
                _expressionIerrors
            -- self rule
            (_self@_) =
                Expression_Parenthesized _rangeIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _expressionIoperatorTable_collect
            -- copy rule (down)
            (_expressionOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_expressionOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Expression_RecordConstruction :: (T_Range) ->
                                     (T_Name) ->
                                     (T_RecordExpressionBindings) ->
                                     (T_Expression)
sem_Expression_RecordConstruction (range_) (name_) (recordExpressionBindings_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatExpression])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _recordExpressionBindingsIerrors :: ([GHError])
            _recordExpressionBindingsIoperatorTable_collect :: (OperatorTable)
            _recordExpressionBindingsIself :: (RecordExpressionBindings)
            _recordExpressionBindingsOoperatorTable :: (OperatorTable)
            _recordExpressionBindingsOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _recordExpressionBindingsIerrors,_recordExpressionBindingsIoperatorTable_collect,_recordExpressionBindingsIself) =
                (recordExpressionBindings_ (_recordExpressionBindingsOoperatorTable) (_recordExpressionBindingsOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 304, column 9)
            (_lhsOflatten@_) =
                [FItem _self]
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _recordExpressionBindingsIerrors
            -- self rule
            (_self@_) =
                Expression_RecordConstruction _rangeIself _nameIself _recordExpressionBindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _recordExpressionBindingsIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_recordExpressionBindingsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_recordExpressionBindingsOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Expression_RecordUpdate :: (T_Range) ->
                               (T_Expression) ->
                               (T_RecordExpressionBindings) ->
                               (T_Expression)
sem_Expression_RecordUpdate (range_) (expression_) (recordExpressionBindings_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatExpression])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _expressionIerrors :: ([GHError])
            _expressionIflatten :: ([FlatExpression])
            _expressionIoperatorTable_collect :: (OperatorTable)
            _expressionIself :: (Expression)
            _expressionOoperatorTable :: (OperatorTable)
            _expressionOoperatorTable_collect :: (OperatorTable)
            _recordExpressionBindingsIerrors :: ([GHError])
            _recordExpressionBindingsIoperatorTable_collect :: (OperatorTable)
            _recordExpressionBindingsIself :: (RecordExpressionBindings)
            _recordExpressionBindingsOoperatorTable :: (OperatorTable)
            _recordExpressionBindingsOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _expressionIerrors,_expressionIflatten,_expressionIoperatorTable_collect,_expressionIself) =
                (expression_ (_expressionOoperatorTable) (_expressionOoperatorTable_collect))
            ( _recordExpressionBindingsIerrors,_recordExpressionBindingsIoperatorTable_collect,_recordExpressionBindingsIself) =
                (recordExpressionBindings_ (_recordExpressionBindingsOoperatorTable) (_recordExpressionBindingsOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 306, column 9)
            (_lhsOflatten@_) =
                [FItem _self]
            -- use rule
            (_lhsOerrors@_) =
                _expressionIerrors ++ _recordExpressionBindingsIerrors
            -- self rule
            (_self@_) =
                Expression_RecordUpdate _rangeIself _expressionIself _recordExpressionBindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _recordExpressionBindingsIoperatorTable_collect
            -- copy rule (down)
            (_expressionOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_expressionOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_recordExpressionBindingsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_recordExpressionBindingsOoperatorTable_collect@_) =
                _expressionIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Expression_Tuple :: (T_Range) ->
                        (T_Expressions) ->
                        (T_Expression)
sem_Expression_Tuple (range_) (expressions_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatExpression])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _expressionsIerrors :: ([GHError])
            _expressionsIoperatorTable_collect :: (OperatorTable)
            _expressionsIself :: (Expressions)
            _expressionsOoperatorTable :: (OperatorTable)
            _expressionsOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _expressionsIerrors,_expressionsIoperatorTable_collect,_expressionsIself) =
                (expressions_ (_expressionsOoperatorTable) (_expressionsOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 298, column 9)
            (_lhsOflatten@_) =
                [FItem _self]
            -- use rule
            (_lhsOerrors@_) =
                _expressionsIerrors
            -- self rule
            (_self@_) =
                Expression_Tuple _rangeIself _expressionsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _expressionsIoperatorTable_collect
            -- copy rule (down)
            (_expressionsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_expressionsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Expression_TypeApplication :: (T_Range) ->
                                  (T_Name) ->
                                  (T_Type) ->
                                  (T_Expression)
sem_Expression_TypeApplication (range_) (name_) (type_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatExpression])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _typeIerrors :: ([GHError])
            _typeIoperatorTable_collect :: (OperatorTable)
            _typeIself :: (Type)
            _typeOoperatorTable :: (OperatorTable)
            _typeOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _typeIerrors,_typeIoperatorTable_collect,_typeIself) =
                (type_ (_typeOoperatorTable) (_typeOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 312, column 9)
            (_lhsOflatten@_) =
                [FItem _self]
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _typeIerrors
            -- self rule
            (_self@_) =
                Expression_TypeApplication _rangeIself _nameIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _typeIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_typeOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_typeOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Expression_Typed :: (T_Range) ->
                        (T_Expression) ->
                        (T_Type) ->
                        (T_Expression)
sem_Expression_Typed (range_) (expression_) (type_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatExpression])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _expressionIerrors :: ([GHError])
            _expressionIflatten :: ([FlatExpression])
            _expressionIoperatorTable_collect :: (OperatorTable)
            _expressionIself :: (Expression)
            _expressionOoperatorTable :: (OperatorTable)
            _expressionOoperatorTable_collect :: (OperatorTable)
            _typeIerrors :: ([GHError])
            _typeIoperatorTable_collect :: (OperatorTable)
            _typeIself :: (Type)
            _typeOoperatorTable :: (OperatorTable)
            _typeOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _expressionIerrors,_expressionIflatten,_expressionIoperatorTable_collect,_expressionIself) =
                (expression_ (_expressionOoperatorTable) (_expressionOoperatorTable_collect))
            ( _typeIerrors,_typeIoperatorTable_collect,_typeIself) =
                (type_ (_typeOoperatorTable) (_typeOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 302, column 9)
            (_lhsOflatten@_) =
                [FItem _self]
            -- use rule
            (_lhsOerrors@_) =
                _expressionIerrors ++ _typeIerrors
            -- self rule
            (_self@_) =
                Expression_Typed _rangeIself _expressionIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _typeIoperatorTable_collect
            -- copy rule (down)
            (_expressionOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_expressionOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_typeOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_typeOoperatorTable_collect@_) =
                _expressionIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Expression_Variable :: (T_Range) ->
                           (T_Name) ->
                           (T_Expression)
sem_Expression_Variable (range_) (name_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatExpression])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 266, column 9)
            (_lhsOflatten@_) =
                [FItem _self]
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors
            -- self rule
            (_self@_) =
                Expression_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Expression_Wildcard :: (T_Range) ->
                           (T_Expression)
sem_Expression_Wildcard (range_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatExpression])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            ( _rangeIself) =
                (range_ )
            -- use rule
            (_lhsOerrors@_) =
                []
            -- use rule
            (_lhsOflatten@_) =
                []
            -- self rule
            (_self@_) =
                Expression_Wildcard _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
-- Expressions -------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for Expressions.Cons:
      self

-}
{-
   local variables for Expressions.Nil:
      self

-}
-- semantic domain
type T_Expressions = (OperatorTable) ->
                     (OperatorTable) ->
                     ( ([GHError]),(OperatorTable),(Expressions))
-- cata
sem_Expressions :: (Expressions) ->
                   (T_Expressions)
sem_Expressions (list) =
    (foldr (sem_Expressions_Cons) (sem_Expressions_Nil) ((map sem_Expression list)))
sem_Expressions_Cons :: (T_Expression) ->
                        (T_Expressions) ->
                        (T_Expressions)
sem_Expressions_Cons (hd_) (tl_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Expressions)
            _hdIerrors :: ([GHError])
            _hdIflatten :: ([FlatExpression])
            _hdIoperatorTable_collect :: (OperatorTable)
            _hdIself :: (Expression)
            _hdOoperatorTable :: (OperatorTable)
            _hdOoperatorTable_collect :: (OperatorTable)
            _tlIerrors :: ([GHError])
            _tlIoperatorTable_collect :: (OperatorTable)
            _tlIself :: (Expressions)
            _tlOoperatorTable :: (OperatorTable)
            _tlOoperatorTable_collect :: (OperatorTable)
            ( _hdIerrors,_hdIflatten,_hdIoperatorTable_collect,_hdIself) =
                (hd_ (_hdOoperatorTable) (_hdOoperatorTable_collect))
            ( _tlIerrors,_tlIoperatorTable_collect,_tlIself) =
                (tl_ (_tlOoperatorTable) (_tlOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _hdIerrors ++ _tlIerrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _tlIoperatorTable_collect
            -- copy rule (down)
            (_hdOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_hdOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_tlOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_tlOoperatorTable_collect@_) =
                _hdIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Expressions_Nil :: (T_Expressions)
sem_Expressions_Nil  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Expressions)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- FieldDeclaration --------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for FieldDeclaration.FieldDeclaration:
      self

-}
-- semantic domain
type T_FieldDeclaration = (OperatorTable) ->
                          (OperatorTable) ->
                          ( ([GHError]),(OperatorTable),(FieldDeclaration))
-- cata
sem_FieldDeclaration :: (FieldDeclaration) ->
                        (T_FieldDeclaration)
sem_FieldDeclaration ((FieldDeclaration_FieldDeclaration (_range) (_names) (_type))) =
    (sem_FieldDeclaration_FieldDeclaration ((sem_Range (_range))) ((sem_Names (_names))) ((sem_AnnotatedType (_type))))
sem_FieldDeclaration_FieldDeclaration :: (T_Range) ->
                                         (T_Names) ->
                                         (T_AnnotatedType) ->
                                         (T_FieldDeclaration)
sem_FieldDeclaration_FieldDeclaration (range_) (names_) (type_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (FieldDeclaration)
            _rangeIself :: (Range)
            _namesIerrors :: ([GHError])
            _namesIoperatorTable_collect :: (OperatorTable)
            _namesIself :: (Names)
            _namesOoperatorTable :: (OperatorTable)
            _namesOoperatorTable_collect :: (OperatorTable)
            _typeIerrors :: ([GHError])
            _typeIoperatorTable_collect :: (OperatorTable)
            _typeIself :: (AnnotatedType)
            _typeOoperatorTable :: (OperatorTable)
            _typeOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _namesIerrors,_namesIoperatorTable_collect,_namesIself) =
                (names_ (_namesOoperatorTable) (_namesOoperatorTable_collect))
            ( _typeIerrors,_typeIoperatorTable_collect,_typeIself) =
                (type_ (_typeOoperatorTable) (_typeOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _namesIerrors ++ _typeIerrors
            -- self rule
            (_self@_) =
                FieldDeclaration_FieldDeclaration _rangeIself _namesIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _typeIoperatorTable_collect
            -- copy rule (down)
            (_namesOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_namesOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_typeOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_typeOoperatorTable_collect@_) =
                _namesIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- FieldDeclarations -------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for FieldDeclarations.Cons:
      self

-}
{-
   local variables for FieldDeclarations.Nil:
      self

-}
-- semantic domain
type T_FieldDeclarations = (OperatorTable) ->
                           (OperatorTable) ->
                           ( ([GHError]),(OperatorTable),(FieldDeclarations))
-- cata
sem_FieldDeclarations :: (FieldDeclarations) ->
                         (T_FieldDeclarations)
sem_FieldDeclarations (list) =
    (foldr (sem_FieldDeclarations_Cons) (sem_FieldDeclarations_Nil) ((map sem_FieldDeclaration list)))
sem_FieldDeclarations_Cons :: (T_FieldDeclaration) ->
                              (T_FieldDeclarations) ->
                              (T_FieldDeclarations)
sem_FieldDeclarations_Cons (hd_) (tl_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (FieldDeclarations)
            _hdIerrors :: ([GHError])
            _hdIoperatorTable_collect :: (OperatorTable)
            _hdIself :: (FieldDeclaration)
            _hdOoperatorTable :: (OperatorTable)
            _hdOoperatorTable_collect :: (OperatorTable)
            _tlIerrors :: ([GHError])
            _tlIoperatorTable_collect :: (OperatorTable)
            _tlIself :: (FieldDeclarations)
            _tlOoperatorTable :: (OperatorTable)
            _tlOoperatorTable_collect :: (OperatorTable)
            ( _hdIerrors,_hdIoperatorTable_collect,_hdIself) =
                (hd_ (_hdOoperatorTable) (_hdOoperatorTable_collect))
            ( _tlIerrors,_tlIoperatorTable_collect,_tlIself) =
                (tl_ (_tlOoperatorTable) (_tlOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _hdIerrors ++ _tlIerrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _tlIoperatorTable_collect
            -- copy rule (down)
            (_hdOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_hdOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_tlOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_tlOoperatorTable_collect@_) =
                _hdIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_FieldDeclarations_Nil :: (T_FieldDeclarations)
sem_FieldDeclarations_Nil  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (FieldDeclarations)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- Fixity ------------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for Fixity.Infix:
      self

-}
{-
   local variables for Fixity.Infixl:
      self

-}
{-
   local variables for Fixity.Infixr:
      self

-}
-- semantic domain
type T_Fixity = (OperatorTable) ->
                (OperatorTable) ->
                ( ([GHError]),(OperatorTable),(Fixity))
-- cata
sem_Fixity :: (Fixity) ->
              (T_Fixity)
sem_Fixity ((Fixity_Infix (_range))) =
    (sem_Fixity_Infix ((sem_Range (_range))))
sem_Fixity ((Fixity_Infixl (_range))) =
    (sem_Fixity_Infixl ((sem_Range (_range))))
sem_Fixity ((Fixity_Infixr (_range))) =
    (sem_Fixity_Infixr ((sem_Range (_range))))
sem_Fixity_Infix :: (T_Range) ->
                    (T_Fixity)
sem_Fixity_Infix (range_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Fixity)
            _rangeIself :: (Range)
            ( _rangeIself) =
                (range_ )
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                Fixity_Infix _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Fixity_Infixl :: (T_Range) ->
                     (T_Fixity)
sem_Fixity_Infixl (range_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Fixity)
            _rangeIself :: (Range)
            ( _rangeIself) =
                (range_ )
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                Fixity_Infixl _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Fixity_Infixr :: (T_Range) ->
                     (T_Fixity)
sem_Fixity_Infixr (range_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Fixity)
            _rangeIself :: (Range)
            ( _rangeIself) =
                (range_ )
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                Fixity_Infixr _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- FunctionBinding ---------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for FunctionBinding.FunctionBinding:
      self

-}
-- semantic domain
type T_FunctionBinding = (OperatorTable) ->
                         (OperatorTable) ->
                         ( ([GHError]),(OperatorTable),(FunctionBinding))
-- cata
sem_FunctionBinding :: (FunctionBinding) ->
                       (T_FunctionBinding)
sem_FunctionBinding ((FunctionBinding_FunctionBinding (_range) (_lefthandside) (_righthandside))) =
    (sem_FunctionBinding_FunctionBinding ((sem_Range (_range))) ((sem_LeftHandSide (_lefthandside))) ((sem_RightHandSide (_righthandside))))
sem_FunctionBinding_FunctionBinding :: (T_Range) ->
                                       (T_LeftHandSide) ->
                                       (T_RightHandSide) ->
                                       (T_FunctionBinding)
sem_FunctionBinding_FunctionBinding (range_) (lefthandside_) (righthandside_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (FunctionBinding)
            _rangeIself :: (Range)
            _lefthandsideIerrors :: ([GHError])
            _lefthandsideIoperatorTable_collect :: (OperatorTable)
            _lefthandsideIself :: (LeftHandSide)
            _lefthandsideOoperatorTable :: (OperatorTable)
            _lefthandsideOoperatorTable_collect :: (OperatorTable)
            _righthandsideIerrors :: ([GHError])
            _righthandsideIoperatorTable_collect :: (OperatorTable)
            _righthandsideIself :: (RightHandSide)
            _righthandsideOoperatorTable :: (OperatorTable)
            _righthandsideOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _lefthandsideIerrors,_lefthandsideIoperatorTable_collect,_lefthandsideIself) =
                (lefthandside_ (_lefthandsideOoperatorTable) (_lefthandsideOoperatorTable_collect))
            ( _righthandsideIerrors,_righthandsideIoperatorTable_collect,_righthandsideIself) =
                (righthandside_ (_righthandsideOoperatorTable) (_righthandsideOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _lefthandsideIerrors ++ _righthandsideIerrors
            -- self rule
            (_self@_) =
                FunctionBinding_FunctionBinding _rangeIself _lefthandsideIself _righthandsideIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _righthandsideIoperatorTable_collect
            -- copy rule (down)
            (_lefthandsideOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_lefthandsideOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_righthandsideOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_righthandsideOoperatorTable_collect@_) =
                _lefthandsideIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- FunctionBindings --------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for FunctionBindings.Cons:
      self

-}
{-
   local variables for FunctionBindings.Nil:
      self

-}
-- semantic domain
type T_FunctionBindings = (OperatorTable) ->
                          (OperatorTable) ->
                          ( ([GHError]),(OperatorTable),(FunctionBindings))
-- cata
sem_FunctionBindings :: (FunctionBindings) ->
                        (T_FunctionBindings)
sem_FunctionBindings (list) =
    (foldr (sem_FunctionBindings_Cons) (sem_FunctionBindings_Nil) ((map sem_FunctionBinding list)))
sem_FunctionBindings_Cons :: (T_FunctionBinding) ->
                             (T_FunctionBindings) ->
                             (T_FunctionBindings)
sem_FunctionBindings_Cons (hd_) (tl_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (FunctionBindings)
            _hdIerrors :: ([GHError])
            _hdIoperatorTable_collect :: (OperatorTable)
            _hdIself :: (FunctionBinding)
            _hdOoperatorTable :: (OperatorTable)
            _hdOoperatorTable_collect :: (OperatorTable)
            _tlIerrors :: ([GHError])
            _tlIoperatorTable_collect :: (OperatorTable)
            _tlIself :: (FunctionBindings)
            _tlOoperatorTable :: (OperatorTable)
            _tlOoperatorTable_collect :: (OperatorTable)
            ( _hdIerrors,_hdIoperatorTable_collect,_hdIself) =
                (hd_ (_hdOoperatorTable) (_hdOoperatorTable_collect))
            ( _tlIerrors,_tlIoperatorTable_collect,_tlIself) =
                (tl_ (_tlOoperatorTable) (_tlOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _hdIerrors ++ _tlIerrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _tlIoperatorTable_collect
            -- copy rule (down)
            (_hdOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_hdOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_tlOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_tlOoperatorTable_collect@_) =
                _hdIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_FunctionBindings_Nil :: (T_FunctionBindings)
sem_FunctionBindings_Nil  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (FunctionBindings)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- GuardedExpression -------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for GuardedExpression.GuardedExpression:
      self

-}
-- semantic domain
type T_GuardedExpression = (OperatorTable) ->
                           (OperatorTable) ->
                           ( ([GHError]),(OperatorTable),(GuardedExpression))
-- cata
sem_GuardedExpression :: (GuardedExpression) ->
                         (T_GuardedExpression)
sem_GuardedExpression ((GuardedExpression_GuardedExpression (_range) (_guard) (_expression))) =
    (sem_GuardedExpression_GuardedExpression ((sem_Range (_range))) ((sem_Expression (_guard))) ((sem_Expression (_expression))))
sem_GuardedExpression_GuardedExpression :: (T_Range) ->
                                           (T_Expression) ->
                                           (T_Expression) ->
                                           (T_GuardedExpression)
sem_GuardedExpression_GuardedExpression (range_) (guard_) (expression_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (GuardedExpression)
            _rangeIself :: (Range)
            _guardIerrors :: ([GHError])
            _guardIflatten :: ([FlatExpression])
            _guardIoperatorTable_collect :: (OperatorTable)
            _guardIself :: (Expression)
            _guardOoperatorTable :: (OperatorTable)
            _guardOoperatorTable_collect :: (OperatorTable)
            _expressionIerrors :: ([GHError])
            _expressionIflatten :: ([FlatExpression])
            _expressionIoperatorTable_collect :: (OperatorTable)
            _expressionIself :: (Expression)
            _expressionOoperatorTable :: (OperatorTable)
            _expressionOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _guardIerrors,_guardIflatten,_guardIoperatorTable_collect,_guardIself) =
                (guard_ (_guardOoperatorTable) (_guardOoperatorTable_collect))
            ( _expressionIerrors,_expressionIflatten,_expressionIoperatorTable_collect,_expressionIself) =
                (expression_ (_expressionOoperatorTable) (_expressionOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _guardIerrors ++ _expressionIerrors
            -- self rule
            (_self@_) =
                GuardedExpression_GuardedExpression _rangeIself _guardIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _expressionIoperatorTable_collect
            -- copy rule (down)
            (_guardOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_guardOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_expressionOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_expressionOoperatorTable_collect@_) =
                _guardIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- GuardedExpressions ------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for GuardedExpressions.Cons:
      self

-}
{-
   local variables for GuardedExpressions.Nil:
      self

-}
-- semantic domain
type T_GuardedExpressions = (OperatorTable) ->
                            (OperatorTable) ->
                            ( ([GHError]),(OperatorTable),(GuardedExpressions))
-- cata
sem_GuardedExpressions :: (GuardedExpressions) ->
                          (T_GuardedExpressions)
sem_GuardedExpressions (list) =
    (foldr (sem_GuardedExpressions_Cons) (sem_GuardedExpressions_Nil) ((map sem_GuardedExpression list)))
sem_GuardedExpressions_Cons :: (T_GuardedExpression) ->
                               (T_GuardedExpressions) ->
                               (T_GuardedExpressions)
sem_GuardedExpressions_Cons (hd_) (tl_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (GuardedExpressions)
            _hdIerrors :: ([GHError])
            _hdIoperatorTable_collect :: (OperatorTable)
            _hdIself :: (GuardedExpression)
            _hdOoperatorTable :: (OperatorTable)
            _hdOoperatorTable_collect :: (OperatorTable)
            _tlIerrors :: ([GHError])
            _tlIoperatorTable_collect :: (OperatorTable)
            _tlIself :: (GuardedExpressions)
            _tlOoperatorTable :: (OperatorTable)
            _tlOoperatorTable_collect :: (OperatorTable)
            ( _hdIerrors,_hdIoperatorTable_collect,_hdIself) =
                (hd_ (_hdOoperatorTable) (_hdOoperatorTable_collect))
            ( _tlIerrors,_tlIoperatorTable_collect,_tlIself) =
                (tl_ (_tlOoperatorTable) (_tlOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _hdIerrors ++ _tlIerrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _tlIoperatorTable_collect
            -- copy rule (down)
            (_hdOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_hdOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_tlOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_tlOoperatorTable_collect@_) =
                _hdIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_GuardedExpressions_Nil :: (T_GuardedExpressions)
sem_GuardedExpressions_Nil  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (GuardedExpressions)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- Import ------------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for Import.TypeOrClass:
      self

-}
{-
   local variables for Import.TypeOrClassComplete:
      self

-}
{-
   local variables for Import.Variable:
      self

-}
-- semantic domain
type T_Import = (OperatorTable) ->
                (OperatorTable) ->
                ( ([GHError]),(OperatorTable),(Import))
-- cata
sem_Import :: (Import) ->
              (T_Import)
sem_Import ((Import_TypeOrClass (_range) (_name) (_names))) =
    (sem_Import_TypeOrClass ((sem_Range (_range))) ((sem_Name (_name))) ((sem_MaybeNames (_names))))
sem_Import ((Import_TypeOrClassComplete (_range) (_name))) =
    (sem_Import_TypeOrClassComplete ((sem_Range (_range))) ((sem_Name (_name))))
sem_Import ((Import_Variable (_range) (_name))) =
    (sem_Import_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Import_TypeOrClass :: (T_Range) ->
                          (T_Name) ->
                          (T_MaybeNames) ->
                          (T_Import)
sem_Import_TypeOrClass (range_) (name_) (names_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Import)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _namesIerrors :: ([GHError])
            _namesIoperatorTable_collect :: (OperatorTable)
            _namesIself :: (MaybeNames)
            _namesOoperatorTable :: (OperatorTable)
            _namesOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _namesIerrors,_namesIoperatorTable_collect,_namesIself) =
                (names_ (_namesOoperatorTable) (_namesOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _namesIerrors
            -- self rule
            (_self@_) =
                Import_TypeOrClass _rangeIself _nameIself _namesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _namesIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_namesOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_namesOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Import_TypeOrClassComplete :: (T_Range) ->
                                  (T_Name) ->
                                  (T_Import)
sem_Import_TypeOrClassComplete (range_) (name_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Import)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors
            -- self rule
            (_self@_) =
                Import_TypeOrClassComplete _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Import_Variable :: (T_Range) ->
                       (T_Name) ->
                       (T_Import)
sem_Import_Variable (range_) (name_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Import)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors
            -- self rule
            (_self@_) =
                Import_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- ImportDeclaration -------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for ImportDeclaration.Empty:
      self

-}
{-
   local variables for ImportDeclaration.Import:
      self

-}
-- semantic domain
type T_ImportDeclaration = (OperatorTable) ->
                           (OperatorTable) ->
                           ( ([GHError]),(OperatorTable),(ImportDeclaration))
-- cata
sem_ImportDeclaration :: (ImportDeclaration) ->
                         (T_ImportDeclaration)
sem_ImportDeclaration ((ImportDeclaration_Empty (_range))) =
    (sem_ImportDeclaration_Empty ((sem_Range (_range))))
sem_ImportDeclaration ((ImportDeclaration_Import (_range) (_qualified) (_name) (_asname) (_importspecification))) =
    (sem_ImportDeclaration_Import ((sem_Range (_range))) (_qualified) ((sem_ModuleName (_name))) ((sem_MaybeModuleName (_asname))) ((sem_MaybeImportSpecification (_importspecification))))
sem_ImportDeclaration_Empty :: (T_Range) ->
                               (T_ImportDeclaration)
sem_ImportDeclaration_Empty (range_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (ImportDeclaration)
            _rangeIself :: (Range)
            ( _rangeIself) =
                (range_ )
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                ImportDeclaration_Empty _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_ImportDeclaration_Import :: (T_Range) ->
                                (Bool) ->
                                (T_ModuleName) ->
                                (T_MaybeModuleName) ->
                                (T_MaybeImportSpecification) ->
                                (T_ImportDeclaration)
sem_ImportDeclaration_Import (range_) (qualified_) (name_) (asname_) (importspecification_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (ImportDeclaration)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (ModuleName)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _asnameIerrors :: ([GHError])
            _asnameIoperatorTable_collect :: (OperatorTable)
            _asnameIself :: (MaybeModuleName)
            _asnameOoperatorTable :: (OperatorTable)
            _asnameOoperatorTable_collect :: (OperatorTable)
            _importspecificationIerrors :: ([GHError])
            _importspecificationIoperatorTable_collect :: (OperatorTable)
            _importspecificationIself :: (MaybeImportSpecification)
            _importspecificationOoperatorTable :: (OperatorTable)
            _importspecificationOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _asnameIerrors,_asnameIoperatorTable_collect,_asnameIself) =
                (asname_ (_asnameOoperatorTable) (_asnameOoperatorTable_collect))
            ( _importspecificationIerrors,_importspecificationIoperatorTable_collect,_importspecificationIself) =
                (importspecification_ (_importspecificationOoperatorTable) (_importspecificationOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _asnameIerrors ++ _importspecificationIerrors
            -- self rule
            (_self@_) =
                ImportDeclaration_Import _rangeIself qualified_ _nameIself _asnameIself _importspecificationIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _importspecificationIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_asnameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_asnameOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_importspecificationOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_importspecificationOoperatorTable_collect@_) =
                _asnameIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- ImportDeclarations ------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for ImportDeclarations.Cons:
      self

-}
{-
   local variables for ImportDeclarations.Nil:
      self

-}
-- semantic domain
type T_ImportDeclarations = (OperatorTable) ->
                            (OperatorTable) ->
                            ( ([GHError]),(OperatorTable),(ImportDeclarations))
-- cata
sem_ImportDeclarations :: (ImportDeclarations) ->
                          (T_ImportDeclarations)
sem_ImportDeclarations (list) =
    (foldr (sem_ImportDeclarations_Cons) (sem_ImportDeclarations_Nil) ((map sem_ImportDeclaration list)))
sem_ImportDeclarations_Cons :: (T_ImportDeclaration) ->
                               (T_ImportDeclarations) ->
                               (T_ImportDeclarations)
sem_ImportDeclarations_Cons (hd_) (tl_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (ImportDeclarations)
            _hdIerrors :: ([GHError])
            _hdIoperatorTable_collect :: (OperatorTable)
            _hdIself :: (ImportDeclaration)
            _hdOoperatorTable :: (OperatorTable)
            _hdOoperatorTable_collect :: (OperatorTable)
            _tlIerrors :: ([GHError])
            _tlIoperatorTable_collect :: (OperatorTable)
            _tlIself :: (ImportDeclarations)
            _tlOoperatorTable :: (OperatorTable)
            _tlOoperatorTable_collect :: (OperatorTable)
            ( _hdIerrors,_hdIoperatorTable_collect,_hdIself) =
                (hd_ (_hdOoperatorTable) (_hdOoperatorTable_collect))
            ( _tlIerrors,_tlIoperatorTable_collect,_tlIself) =
                (tl_ (_tlOoperatorTable) (_tlOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _hdIerrors ++ _tlIerrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _tlIoperatorTable_collect
            -- copy rule (down)
            (_hdOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_hdOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_tlOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_tlOoperatorTable_collect@_) =
                _hdIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_ImportDeclarations_Nil :: (T_ImportDeclarations)
sem_ImportDeclarations_Nil  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (ImportDeclarations)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- ImportSpecification -----------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for ImportSpecification.Import:
      self

-}
-- semantic domain
type T_ImportSpecification = (OperatorTable) ->
                             (OperatorTable) ->
                             ( ([GHError]),(OperatorTable),(ImportSpecification))
-- cata
sem_ImportSpecification :: (ImportSpecification) ->
                           (T_ImportSpecification)
sem_ImportSpecification ((ImportSpecification_Import (_range) (_hiding) (_imports))) =
    (sem_ImportSpecification_Import ((sem_Range (_range))) (_hiding) ((sem_Imports (_imports))))
sem_ImportSpecification_Import :: (T_Range) ->
                                  (Bool) ->
                                  (T_Imports) ->
                                  (T_ImportSpecification)
sem_ImportSpecification_Import (range_) (hiding_) (imports_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (ImportSpecification)
            _rangeIself :: (Range)
            _importsIerrors :: ([GHError])
            _importsIoperatorTable_collect :: (OperatorTable)
            _importsIself :: (Imports)
            _importsOoperatorTable :: (OperatorTable)
            _importsOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _importsIerrors,_importsIoperatorTable_collect,_importsIself) =
                (imports_ (_importsOoperatorTable) (_importsOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _importsIerrors
            -- self rule
            (_self@_) =
                ImportSpecification_Import _rangeIself hiding_ _importsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _importsIoperatorTable_collect
            -- copy rule (down)
            (_importsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_importsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- Imports -----------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for Imports.Cons:
      self

-}
{-
   local variables for Imports.Nil:
      self

-}
-- semantic domain
type T_Imports = (OperatorTable) ->
                 (OperatorTable) ->
                 ( ([GHError]),(OperatorTable),(Imports))
-- cata
sem_Imports :: (Imports) ->
               (T_Imports)
sem_Imports (list) =
    (foldr (sem_Imports_Cons) (sem_Imports_Nil) ((map sem_Import list)))
sem_Imports_Cons :: (T_Import) ->
                    (T_Imports) ->
                    (T_Imports)
sem_Imports_Cons (hd_) (tl_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Imports)
            _hdIerrors :: ([GHError])
            _hdIoperatorTable_collect :: (OperatorTable)
            _hdIself :: (Import)
            _hdOoperatorTable :: (OperatorTable)
            _hdOoperatorTable_collect :: (OperatorTable)
            _tlIerrors :: ([GHError])
            _tlIoperatorTable_collect :: (OperatorTable)
            _tlIself :: (Imports)
            _tlOoperatorTable :: (OperatorTable)
            _tlOoperatorTable_collect :: (OperatorTable)
            ( _hdIerrors,_hdIoperatorTable_collect,_hdIself) =
                (hd_ (_hdOoperatorTable) (_hdOoperatorTable_collect))
            ( _tlIerrors,_tlIoperatorTable_collect,_tlIself) =
                (tl_ (_tlOoperatorTable) (_tlOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _hdIerrors ++ _tlIerrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _tlIoperatorTable_collect
            -- copy rule (down)
            (_hdOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_hdOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_tlOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_tlOoperatorTable_collect@_) =
                _hdIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Imports_Nil :: (T_Imports)
sem_Imports_Nil  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Imports)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- InterfaceDeclaration ----------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for InterfaceDeclaration.Abstract:
      self

-}
{-
   local variables for InterfaceDeclaration.Binding:
      self

-}
{-
   local variables for InterfaceDeclaration.Consig:
      self

-}
{-
   local variables for InterfaceDeclaration.Declarations:
      self

-}
{-
   local variables for InterfaceDeclaration.Dependency:
      self

-}
{-
   local variables for InterfaceDeclaration.Import:
      self

-}
{-
   local variables for InterfaceDeclaration.SetModule:
      self

-}
-- semantic domain
type T_InterfaceDeclaration = (OperatorTable) ->
                              (OperatorTable) ->
                              ( ([GHError]),(OperatorTable),(InterfaceDeclaration))
-- cata
sem_InterfaceDeclaration :: (InterfaceDeclaration) ->
                            (T_InterfaceDeclaration)
sem_InterfaceDeclaration ((InterfaceDeclaration_Abstract (_range) (_name) (_constructors) (_types) (_kind))) =
    (sem_InterfaceDeclaration_Abstract ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Names (_constructors))) ((sem_Types (_types))) ((sem_Kind (_kind))))
sem_InterfaceDeclaration ((InterfaceDeclaration_Binding (_range) (_name))) =
    (sem_InterfaceDeclaration_Binding ((sem_Range (_range))) ((sem_Name (_name))))
sem_InterfaceDeclaration ((InterfaceDeclaration_Consig (_range) (_typelevel) (_name) (_types))) =
    (sem_InterfaceDeclaration_Consig ((sem_Range (_range))) (_typelevel) ((sem_Name (_name))) ((sem_TypeArguments (_types))))
sem_InterfaceDeclaration ((InterfaceDeclaration_Declarations (_range) (_declarations))) =
    (sem_InterfaceDeclaration_Declarations ((sem_Range (_range))) ((sem_Declarations (_declarations))))
sem_InterfaceDeclaration ((InterfaceDeclaration_Dependency (_range) (_name) (_kind) (_bindings))) =
    (sem_InterfaceDeclaration_Dependency ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Kind (_kind))) ((sem_DependencyBindings (_bindings))))
sem_InterfaceDeclaration ((InterfaceDeclaration_Import (_range) (_module))) =
    (sem_InterfaceDeclaration_Import ((sem_Range (_range))) ((sem_ModuleName (_module))))
sem_InterfaceDeclaration ((InterfaceDeclaration_SetModule (_range) (_module) (_declarations))) =
    (sem_InterfaceDeclaration_SetModule ((sem_Range (_range))) ((sem_ModuleName (_module))) ((sem_InterfaceDeclarations (_declarations))))
sem_InterfaceDeclaration_Abstract :: (T_Range) ->
                                     (T_Name) ->
                                     (T_Names) ->
                                     (T_Types) ->
                                     (T_Kind) ->
                                     (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Abstract (range_) (name_) (constructors_) (types_) (kind_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (InterfaceDeclaration)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _constructorsIerrors :: ([GHError])
            _constructorsIoperatorTable_collect :: (OperatorTable)
            _constructorsIself :: (Names)
            _constructorsOoperatorTable :: (OperatorTable)
            _constructorsOoperatorTable_collect :: (OperatorTable)
            _typesIerrors :: ([GHError])
            _typesIoperatorTable_collect :: (OperatorTable)
            _typesIself :: (Types)
            _typesOoperatorTable :: (OperatorTable)
            _typesOoperatorTable_collect :: (OperatorTable)
            _kindIerrors :: ([GHError])
            _kindIoperatorTable_collect :: (OperatorTable)
            _kindIself :: (Kind)
            _kindOoperatorTable :: (OperatorTable)
            _kindOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _constructorsIerrors,_constructorsIoperatorTable_collect,_constructorsIself) =
                (constructors_ (_constructorsOoperatorTable) (_constructorsOoperatorTable_collect))
            ( _typesIerrors,_typesIoperatorTable_collect,_typesIself) =
                (types_ (_typesOoperatorTable) (_typesOoperatorTable_collect))
            ( _kindIerrors,_kindIoperatorTable_collect,_kindIself) =
                (kind_ (_kindOoperatorTable) (_kindOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _constructorsIerrors ++ _typesIerrors ++ _kindIerrors
            -- self rule
            (_self@_) =
                InterfaceDeclaration_Abstract _rangeIself _nameIself _constructorsIself _typesIself _kindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _kindIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_constructorsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_constructorsOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_typesOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_typesOoperatorTable_collect@_) =
                _constructorsIoperatorTable_collect
            -- copy rule (down)
            (_kindOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_kindOoperatorTable_collect@_) =
                _typesIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_InterfaceDeclaration_Binding :: (T_Range) ->
                                    (T_Name) ->
                                    (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Binding (range_) (name_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (InterfaceDeclaration)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors
            -- self rule
            (_self@_) =
                InterfaceDeclaration_Binding _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_InterfaceDeclaration_Consig :: (T_Range) ->
                                   (Bool) ->
                                   (T_Name) ->
                                   (T_TypeArguments) ->
                                   (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Consig (range_) (typelevel_) (name_) (types_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (InterfaceDeclaration)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _typesIerrors :: ([GHError])
            _typesIoperatorTable_collect :: (OperatorTable)
            _typesIself :: (TypeArguments)
            _typesOoperatorTable :: (OperatorTable)
            _typesOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _typesIerrors,_typesIoperatorTable_collect,_typesIself) =
                (types_ (_typesOoperatorTable) (_typesOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _typesIerrors
            -- self rule
            (_self@_) =
                InterfaceDeclaration_Consig _rangeIself typelevel_ _nameIself _typesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _typesIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_typesOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_typesOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_InterfaceDeclaration_Declarations :: (T_Range) ->
                                         (T_Declarations) ->
                                         (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Declarations (range_) (declarations_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (InterfaceDeclaration)
            _rangeIself :: (Range)
            _declarationsIerrors :: ([GHError])
            _declarationsIoperatorTable_collect :: (OperatorTable)
            _declarationsIself :: (Declarations)
            _declarationsOoperatorTable :: (OperatorTable)
            _declarationsOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _declarationsIerrors,_declarationsIoperatorTable_collect,_declarationsIself) =
                (declarations_ (_declarationsOoperatorTable) (_declarationsOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _declarationsIerrors
            -- self rule
            (_self@_) =
                InterfaceDeclaration_Declarations _rangeIself _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _declarationsIoperatorTable_collect
            -- copy rule (down)
            (_declarationsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_declarationsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_InterfaceDeclaration_Dependency :: (T_Range) ->
                                       (T_Name) ->
                                       (T_Kind) ->
                                       (T_DependencyBindings) ->
                                       (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Dependency (range_) (name_) (kind_) (bindings_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (InterfaceDeclaration)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _kindIerrors :: ([GHError])
            _kindIoperatorTable_collect :: (OperatorTable)
            _kindIself :: (Kind)
            _kindOoperatorTable :: (OperatorTable)
            _kindOoperatorTable_collect :: (OperatorTable)
            _bindingsIerrors :: ([GHError])
            _bindingsIoperatorTable_collect :: (OperatorTable)
            _bindingsIself :: (DependencyBindings)
            _bindingsOoperatorTable :: (OperatorTable)
            _bindingsOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _kindIerrors,_kindIoperatorTable_collect,_kindIself) =
                (kind_ (_kindOoperatorTable) (_kindOoperatorTable_collect))
            ( _bindingsIerrors,_bindingsIoperatorTable_collect,_bindingsIself) =
                (bindings_ (_bindingsOoperatorTable) (_bindingsOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _kindIerrors ++ _bindingsIerrors
            -- self rule
            (_self@_) =
                InterfaceDeclaration_Dependency _rangeIself _nameIself _kindIself _bindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _bindingsIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_kindOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_kindOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_bindingsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_bindingsOoperatorTable_collect@_) =
                _kindIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_InterfaceDeclaration_Import :: (T_Range) ->
                                   (T_ModuleName) ->
                                   (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Import (range_) (module_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (InterfaceDeclaration)
            _rangeIself :: (Range)
            _moduleIerrors :: ([GHError])
            _moduleIoperatorTable_collect :: (OperatorTable)
            _moduleIself :: (ModuleName)
            _moduleOoperatorTable :: (OperatorTable)
            _moduleOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _moduleIerrors,_moduleIoperatorTable_collect,_moduleIself) =
                (module_ (_moduleOoperatorTable) (_moduleOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _moduleIerrors
            -- self rule
            (_self@_) =
                InterfaceDeclaration_Import _rangeIself _moduleIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _moduleIoperatorTable_collect
            -- copy rule (down)
            (_moduleOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_moduleOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_InterfaceDeclaration_SetModule :: (T_Range) ->
                                      (T_ModuleName) ->
                                      (T_InterfaceDeclarations) ->
                                      (T_InterfaceDeclaration)
sem_InterfaceDeclaration_SetModule (range_) (module_) (declarations_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (InterfaceDeclaration)
            _rangeIself :: (Range)
            _moduleIerrors :: ([GHError])
            _moduleIoperatorTable_collect :: (OperatorTable)
            _moduleIself :: (ModuleName)
            _moduleOoperatorTable :: (OperatorTable)
            _moduleOoperatorTable_collect :: (OperatorTable)
            _declarationsIerrors :: ([GHError])
            _declarationsIoperatorTable_collect :: (OperatorTable)
            _declarationsIself :: (InterfaceDeclarations)
            _declarationsOoperatorTable :: (OperatorTable)
            _declarationsOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _moduleIerrors,_moduleIoperatorTable_collect,_moduleIself) =
                (module_ (_moduleOoperatorTable) (_moduleOoperatorTable_collect))
            ( _declarationsIerrors,_declarationsIoperatorTable_collect,_declarationsIself) =
                (declarations_ (_declarationsOoperatorTable) (_declarationsOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _moduleIerrors ++ _declarationsIerrors
            -- self rule
            (_self@_) =
                InterfaceDeclaration_SetModule _rangeIself _moduleIself _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _declarationsIoperatorTable_collect
            -- copy rule (down)
            (_moduleOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_moduleOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_declarationsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_declarationsOoperatorTable_collect@_) =
                _moduleIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- InterfaceDeclarations ---------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for InterfaceDeclarations.Cons:
      self

-}
{-
   local variables for InterfaceDeclarations.Nil:
      self

-}
-- semantic domain
type T_InterfaceDeclarations = (OperatorTable) ->
                               (OperatorTable) ->
                               ( ([GHError]),(OperatorTable),(InterfaceDeclarations))
-- cata
sem_InterfaceDeclarations :: (InterfaceDeclarations) ->
                             (T_InterfaceDeclarations)
sem_InterfaceDeclarations (list) =
    (foldr (sem_InterfaceDeclarations_Cons) (sem_InterfaceDeclarations_Nil) ((map sem_InterfaceDeclaration list)))
sem_InterfaceDeclarations_Cons :: (T_InterfaceDeclaration) ->
                                  (T_InterfaceDeclarations) ->
                                  (T_InterfaceDeclarations)
sem_InterfaceDeclarations_Cons (hd_) (tl_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (InterfaceDeclarations)
            _hdIerrors :: ([GHError])
            _hdIoperatorTable_collect :: (OperatorTable)
            _hdIself :: (InterfaceDeclaration)
            _hdOoperatorTable :: (OperatorTable)
            _hdOoperatorTable_collect :: (OperatorTable)
            _tlIerrors :: ([GHError])
            _tlIoperatorTable_collect :: (OperatorTable)
            _tlIself :: (InterfaceDeclarations)
            _tlOoperatorTable :: (OperatorTable)
            _tlOoperatorTable_collect :: (OperatorTable)
            ( _hdIerrors,_hdIoperatorTable_collect,_hdIself) =
                (hd_ (_hdOoperatorTable) (_hdOoperatorTable_collect))
            ( _tlIerrors,_tlIoperatorTable_collect,_tlIself) =
                (tl_ (_tlOoperatorTable) (_tlOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _hdIerrors ++ _tlIerrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _tlIoperatorTable_collect
            -- copy rule (down)
            (_hdOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_hdOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_tlOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_tlOoperatorTable_collect@_) =
                _hdIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_InterfaceDeclarations_Nil :: (T_InterfaceDeclarations)
sem_InterfaceDeclarations_Nil  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (InterfaceDeclarations)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- Kind --------------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for Kind.Arrow:
      self

-}
{-
   local variables for Kind.Error:
      self

-}
{-
   local variables for Kind.Parenthesized:
      self

-}
{-
   local variables for Kind.Star:
      self

-}
{-
   local variables for Kind.Variable:
      self

-}
-- semantic domain
type T_Kind = (OperatorTable) ->
              (OperatorTable) ->
              ( ([GHError]),(OperatorTable),(Kind))
-- cata
sem_Kind :: (Kind) ->
            (T_Kind)
sem_Kind ((Kind_Arrow (_range) (_leftKind) (_rightKind))) =
    (sem_Kind_Arrow ((sem_Range (_range))) ((sem_Kind (_leftKind))) ((sem_Kind (_rightKind))))
sem_Kind ((Kind_Error )) =
    (sem_Kind_Error )
sem_Kind ((Kind_Parenthesized (_range) (_kind))) =
    (sem_Kind_Parenthesized ((sem_Range (_range))) ((sem_Kind (_kind))))
sem_Kind ((Kind_Star (_range))) =
    (sem_Kind_Star ((sem_Range (_range))))
sem_Kind ((Kind_Variable (_range) (_name))) =
    (sem_Kind_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Kind_Arrow :: (T_Range) ->
                  (T_Kind) ->
                  (T_Kind) ->
                  (T_Kind)
sem_Kind_Arrow (range_) (leftKind_) (rightKind_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Kind)
            _rangeIself :: (Range)
            _leftKindIerrors :: ([GHError])
            _leftKindIoperatorTable_collect :: (OperatorTable)
            _leftKindIself :: (Kind)
            _leftKindOoperatorTable :: (OperatorTable)
            _leftKindOoperatorTable_collect :: (OperatorTable)
            _rightKindIerrors :: ([GHError])
            _rightKindIoperatorTable_collect :: (OperatorTable)
            _rightKindIself :: (Kind)
            _rightKindOoperatorTable :: (OperatorTable)
            _rightKindOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _leftKindIerrors,_leftKindIoperatorTable_collect,_leftKindIself) =
                (leftKind_ (_leftKindOoperatorTable) (_leftKindOoperatorTable_collect))
            ( _rightKindIerrors,_rightKindIoperatorTable_collect,_rightKindIself) =
                (rightKind_ (_rightKindOoperatorTable) (_rightKindOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _leftKindIerrors ++ _rightKindIerrors
            -- self rule
            (_self@_) =
                Kind_Arrow _rangeIself _leftKindIself _rightKindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _rightKindIoperatorTable_collect
            -- copy rule (down)
            (_leftKindOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_leftKindOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_rightKindOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_rightKindOoperatorTable_collect@_) =
                _leftKindIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Kind_Error :: (T_Kind)
sem_Kind_Error  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Kind)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                Kind_Error
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Kind_Parenthesized :: (T_Range) ->
                          (T_Kind) ->
                          (T_Kind)
sem_Kind_Parenthesized (range_) (kind_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Kind)
            _rangeIself :: (Range)
            _kindIerrors :: ([GHError])
            _kindIoperatorTable_collect :: (OperatorTable)
            _kindIself :: (Kind)
            _kindOoperatorTable :: (OperatorTable)
            _kindOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _kindIerrors,_kindIoperatorTable_collect,_kindIself) =
                (kind_ (_kindOoperatorTable) (_kindOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _kindIerrors
            -- self rule
            (_self@_) =
                Kind_Parenthesized _rangeIself _kindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _kindIoperatorTable_collect
            -- copy rule (down)
            (_kindOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_kindOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Kind_Star :: (T_Range) ->
                 (T_Kind)
sem_Kind_Star (range_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Kind)
            _rangeIself :: (Range)
            ( _rangeIself) =
                (range_ )
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                Kind_Star _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Kind_Variable :: (T_Range) ->
                     (T_Name) ->
                     (T_Kind)
sem_Kind_Variable (range_) (name_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Kind)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors
            -- self rule
            (_self@_) =
                Kind_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- KindAnnotatedName -------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for KindAnnotatedName.KindAnnotatedName:
      self

-}
-- semantic domain
type T_KindAnnotatedName = (OperatorTable) ->
                           (OperatorTable) ->
                           ( ([GHError]),(OperatorTable),(KindAnnotatedName))
-- cata
sem_KindAnnotatedName :: (KindAnnotatedName) ->
                         (T_KindAnnotatedName)
sem_KindAnnotatedName ((KindAnnotatedName_KindAnnotatedName (_range) (_name) (_kind))) =
    (sem_KindAnnotatedName_KindAnnotatedName ((sem_Range (_range))) ((sem_Name (_name))) ((sem_MaybeKind (_kind))))
sem_KindAnnotatedName_KindAnnotatedName :: (T_Range) ->
                                           (T_Name) ->
                                           (T_MaybeKind) ->
                                           (T_KindAnnotatedName)
sem_KindAnnotatedName_KindAnnotatedName (range_) (name_) (kind_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (KindAnnotatedName)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _kindIerrors :: ([GHError])
            _kindIoperatorTable_collect :: (OperatorTable)
            _kindIself :: (MaybeKind)
            _kindOoperatorTable :: (OperatorTable)
            _kindOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _kindIerrors,_kindIoperatorTable_collect,_kindIself) =
                (kind_ (_kindOoperatorTable) (_kindOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _kindIerrors
            -- self rule
            (_self@_) =
                KindAnnotatedName_KindAnnotatedName _rangeIself _nameIself _kindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _kindIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_kindOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_kindOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- KindAnnotatedNames ------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for KindAnnotatedNames.Cons:
      self

-}
{-
   local variables for KindAnnotatedNames.Nil:
      self

-}
-- semantic domain
type T_KindAnnotatedNames = (OperatorTable) ->
                            (OperatorTable) ->
                            ( ([GHError]),(OperatorTable),(KindAnnotatedNames))
-- cata
sem_KindAnnotatedNames :: (KindAnnotatedNames) ->
                          (T_KindAnnotatedNames)
sem_KindAnnotatedNames (list) =
    (foldr (sem_KindAnnotatedNames_Cons) (sem_KindAnnotatedNames_Nil) ((map sem_KindAnnotatedName list)))
sem_KindAnnotatedNames_Cons :: (T_KindAnnotatedName) ->
                               (T_KindAnnotatedNames) ->
                               (T_KindAnnotatedNames)
sem_KindAnnotatedNames_Cons (hd_) (tl_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (KindAnnotatedNames)
            _hdIerrors :: ([GHError])
            _hdIoperatorTable_collect :: (OperatorTable)
            _hdIself :: (KindAnnotatedName)
            _hdOoperatorTable :: (OperatorTable)
            _hdOoperatorTable_collect :: (OperatorTable)
            _tlIerrors :: ([GHError])
            _tlIoperatorTable_collect :: (OperatorTable)
            _tlIself :: (KindAnnotatedNames)
            _tlOoperatorTable :: (OperatorTable)
            _tlOoperatorTable_collect :: (OperatorTable)
            ( _hdIerrors,_hdIoperatorTable_collect,_hdIself) =
                (hd_ (_hdOoperatorTable) (_hdOoperatorTable_collect))
            ( _tlIerrors,_tlIoperatorTable_collect,_tlIself) =
                (tl_ (_tlOoperatorTable) (_tlOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _hdIerrors ++ _tlIerrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _tlIoperatorTable_collect
            -- copy rule (down)
            (_hdOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_hdOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_tlOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_tlOoperatorTable_collect@_) =
                _hdIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_KindAnnotatedNames_Nil :: (T_KindAnnotatedNames)
sem_KindAnnotatedNames_Nil  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (KindAnnotatedNames)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- KindArgument ------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for KindArgument.Arrow:
      self

-}
{-
   local variables for KindArgument.Star:
      self

-}
-- semantic domain
type T_KindArgument = (OperatorTable) ->
                      (OperatorTable) ->
                      ( ([GHError]),(OperatorTable),(KindArgument))
-- cata
sem_KindArgument :: (KindArgument) ->
                    (T_KindArgument)
sem_KindArgument ((KindArgument_Arrow (_range) (_leftkindvariable) (_rightkindvariable))) =
    (sem_KindArgument_Arrow ((sem_Range (_range))) ((sem_Name (_leftkindvariable))) ((sem_Name (_rightkindvariable))))
sem_KindArgument ((KindArgument_Star (_range))) =
    (sem_KindArgument_Star ((sem_Range (_range))))
sem_KindArgument_Arrow :: (T_Range) ->
                          (T_Name) ->
                          (T_Name) ->
                          (T_KindArgument)
sem_KindArgument_Arrow (range_) (leftkindvariable_) (rightkindvariable_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (KindArgument)
            _rangeIself :: (Range)
            _leftkindvariableIerrors :: ([GHError])
            _leftkindvariableIoperatorTable_collect :: (OperatorTable)
            _leftkindvariableIself :: (Name)
            _leftkindvariableOoperatorTable :: (OperatorTable)
            _leftkindvariableOoperatorTable_collect :: (OperatorTable)
            _rightkindvariableIerrors :: ([GHError])
            _rightkindvariableIoperatorTable_collect :: (OperatorTable)
            _rightkindvariableIself :: (Name)
            _rightkindvariableOoperatorTable :: (OperatorTable)
            _rightkindvariableOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _leftkindvariableIerrors,_leftkindvariableIoperatorTable_collect,_leftkindvariableIself) =
                (leftkindvariable_ (_leftkindvariableOoperatorTable) (_leftkindvariableOoperatorTable_collect))
            ( _rightkindvariableIerrors,_rightkindvariableIoperatorTable_collect,_rightkindvariableIself) =
                (rightkindvariable_ (_rightkindvariableOoperatorTable) (_rightkindvariableOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _leftkindvariableIerrors ++ _rightkindvariableIerrors
            -- self rule
            (_self@_) =
                KindArgument_Arrow _rangeIself _leftkindvariableIself _rightkindvariableIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _rightkindvariableIoperatorTable_collect
            -- copy rule (down)
            (_leftkindvariableOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_leftkindvariableOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_rightkindvariableOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_rightkindvariableOoperatorTable_collect@_) =
                _leftkindvariableIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_KindArgument_Star :: (T_Range) ->
                         (T_KindArgument)
sem_KindArgument_Star (range_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (KindArgument)
            _rangeIself :: (Range)
            ( _rangeIself) =
                (range_ )
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                KindArgument_Star _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- KindIndexedBinding ------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for KindIndexedBinding.KindIndexedBinding:
      self

-}
-- semantic domain
type T_KindIndexedBinding = (OperatorTable) ->
                            (OperatorTable) ->
                            ( ([GHError]),(OperatorTable),(KindIndexedBinding))
-- cata
sem_KindIndexedBinding :: (KindIndexedBinding) ->
                          (T_KindIndexedBinding)
sem_KindIndexedBinding ((KindIndexedBinding_KindIndexedBinding (_range) (_name) (_kindargument) (_typevariables) (_type))) =
    (sem_KindIndexedBinding_KindIndexedBinding ((sem_Range (_range))) ((sem_Name (_name))) ((sem_KindArgument (_kindargument))) ((sem_Names (_typevariables))) ((sem_Type (_type))))
sem_KindIndexedBinding_KindIndexedBinding :: (T_Range) ->
                                             (T_Name) ->
                                             (T_KindArgument) ->
                                             (T_Names) ->
                                             (T_Type) ->
                                             (T_KindIndexedBinding)
sem_KindIndexedBinding_KindIndexedBinding (range_) (name_) (kindargument_) (typevariables_) (type_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (KindIndexedBinding)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _kindargumentIerrors :: ([GHError])
            _kindargumentIoperatorTable_collect :: (OperatorTable)
            _kindargumentIself :: (KindArgument)
            _kindargumentOoperatorTable :: (OperatorTable)
            _kindargumentOoperatorTable_collect :: (OperatorTable)
            _typevariablesIerrors :: ([GHError])
            _typevariablesIoperatorTable_collect :: (OperatorTable)
            _typevariablesIself :: (Names)
            _typevariablesOoperatorTable :: (OperatorTable)
            _typevariablesOoperatorTable_collect :: (OperatorTable)
            _typeIerrors :: ([GHError])
            _typeIoperatorTable_collect :: (OperatorTable)
            _typeIself :: (Type)
            _typeOoperatorTable :: (OperatorTable)
            _typeOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _kindargumentIerrors,_kindargumentIoperatorTable_collect,_kindargumentIself) =
                (kindargument_ (_kindargumentOoperatorTable) (_kindargumentOoperatorTable_collect))
            ( _typevariablesIerrors,_typevariablesIoperatorTable_collect,_typevariablesIself) =
                (typevariables_ (_typevariablesOoperatorTable) (_typevariablesOoperatorTable_collect))
            ( _typeIerrors,_typeIoperatorTable_collect,_typeIself) =
                (type_ (_typeOoperatorTable) (_typeOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _kindargumentIerrors ++ _typevariablesIerrors ++ _typeIerrors
            -- self rule
            (_self@_) =
                KindIndexedBinding_KindIndexedBinding _rangeIself _nameIself _kindargumentIself _typevariablesIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _typeIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_kindargumentOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_kindargumentOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_typevariablesOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_typevariablesOoperatorTable_collect@_) =
                _kindargumentIoperatorTable_collect
            -- copy rule (down)
            (_typeOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_typeOoperatorTable_collect@_) =
                _typevariablesIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- KindIndexedBindings -----------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for KindIndexedBindings.Cons:
      self

-}
{-
   local variables for KindIndexedBindings.Nil:
      self

-}
-- semantic domain
type T_KindIndexedBindings = (OperatorTable) ->
                             (OperatorTable) ->
                             ( ([GHError]),(OperatorTable),(KindIndexedBindings))
-- cata
sem_KindIndexedBindings :: (KindIndexedBindings) ->
                           (T_KindIndexedBindings)
sem_KindIndexedBindings (list) =
    (foldr (sem_KindIndexedBindings_Cons) (sem_KindIndexedBindings_Nil) ((map sem_KindIndexedBinding list)))
sem_KindIndexedBindings_Cons :: (T_KindIndexedBinding) ->
                                (T_KindIndexedBindings) ->
                                (T_KindIndexedBindings)
sem_KindIndexedBindings_Cons (hd_) (tl_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (KindIndexedBindings)
            _hdIerrors :: ([GHError])
            _hdIoperatorTable_collect :: (OperatorTable)
            _hdIself :: (KindIndexedBinding)
            _hdOoperatorTable :: (OperatorTable)
            _hdOoperatorTable_collect :: (OperatorTable)
            _tlIerrors :: ([GHError])
            _tlIoperatorTable_collect :: (OperatorTable)
            _tlIself :: (KindIndexedBindings)
            _tlOoperatorTable :: (OperatorTable)
            _tlOoperatorTable_collect :: (OperatorTable)
            ( _hdIerrors,_hdIoperatorTable_collect,_hdIself) =
                (hd_ (_hdOoperatorTable) (_hdOoperatorTable_collect))
            ( _tlIerrors,_tlIoperatorTable_collect,_tlIself) =
                (tl_ (_tlOoperatorTable) (_tlOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _hdIerrors ++ _tlIerrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _tlIoperatorTable_collect
            -- copy rule (down)
            (_hdOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_hdOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_tlOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_tlOoperatorTable_collect@_) =
                _hdIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_KindIndexedBindings_Nil :: (T_KindIndexedBindings)
sem_KindIndexedBindings_Nil  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (KindIndexedBindings)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- LeftHandSide ------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for LeftHandSide.Function:
      self

-}
{-
   local variables for LeftHandSide.Infix:
      self

-}
{-
   local variables for LeftHandSide.Parenthesized:
      self

-}
-- semantic domain
type T_LeftHandSide = (OperatorTable) ->
                      (OperatorTable) ->
                      ( ([GHError]),(OperatorTable),(LeftHandSide))
-- cata
sem_LeftHandSide :: (LeftHandSide) ->
                    (T_LeftHandSide)
sem_LeftHandSide ((LeftHandSide_Function (_range) (_name) (_patterns))) =
    (sem_LeftHandSide_Function ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Patterns (_patterns))))
sem_LeftHandSide ((LeftHandSide_Infix (_range) (_leftPattern) (_operator) (_rightPattern))) =
    (sem_LeftHandSide_Infix ((sem_Range (_range))) ((sem_Pattern (_leftPattern))) ((sem_Name (_operator))) ((sem_Pattern (_rightPattern))))
sem_LeftHandSide ((LeftHandSide_Parenthesized (_range) (_lefthandside) (_patterns))) =
    (sem_LeftHandSide_Parenthesized ((sem_Range (_range))) ((sem_LeftHandSide (_lefthandside))) ((sem_Patterns (_patterns))))
sem_LeftHandSide_Function :: (T_Range) ->
                             (T_Name) ->
                             (T_Patterns) ->
                             (T_LeftHandSide)
sem_LeftHandSide_Function (range_) (name_) (patterns_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (LeftHandSide)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _patternsIerrors :: ([GHError])
            _patternsIoperatorTable_collect :: (OperatorTable)
            _patternsIself :: (Patterns)
            _patternsOoperatorTable :: (OperatorTable)
            _patternsOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _patternsIerrors,_patternsIoperatorTable_collect,_patternsIself) =
                (patterns_ (_patternsOoperatorTable) (_patternsOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _patternsIerrors
            -- self rule
            (_self@_) =
                LeftHandSide_Function _rangeIself _nameIself _patternsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _patternsIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_patternsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_patternsOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_LeftHandSide_Infix :: (T_Range) ->
                          (T_Pattern) ->
                          (T_Name) ->
                          (T_Pattern) ->
                          (T_LeftHandSide)
sem_LeftHandSide_Infix (range_) (leftPattern_) (operator_) (rightPattern_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (LeftHandSide)
            _rangeIself :: (Range)
            _leftPatternIerrors :: ([GHError])
            _leftPatternIflatten :: ([FlatPattern])
            _leftPatternIoperatorTable_collect :: (OperatorTable)
            _leftPatternIself :: (Pattern)
            _leftPatternOoperatorTable :: (OperatorTable)
            _leftPatternOoperatorTable_collect :: (OperatorTable)
            _operatorIerrors :: ([GHError])
            _operatorIoperatorTable_collect :: (OperatorTable)
            _operatorIself :: (Name)
            _operatorOoperatorTable :: (OperatorTable)
            _operatorOoperatorTable_collect :: (OperatorTable)
            _rightPatternIerrors :: ([GHError])
            _rightPatternIflatten :: ([FlatPattern])
            _rightPatternIoperatorTable_collect :: (OperatorTable)
            _rightPatternIself :: (Pattern)
            _rightPatternOoperatorTable :: (OperatorTable)
            _rightPatternOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _leftPatternIerrors,_leftPatternIflatten,_leftPatternIoperatorTable_collect,_leftPatternIself) =
                (leftPattern_ (_leftPatternOoperatorTable) (_leftPatternOoperatorTable_collect))
            ( _operatorIerrors,_operatorIoperatorTable_collect,_operatorIself) =
                (operator_ (_operatorOoperatorTable) (_operatorOoperatorTable_collect))
            ( _rightPatternIerrors,_rightPatternIflatten,_rightPatternIoperatorTable_collect,_rightPatternIself) =
                (rightPattern_ (_rightPatternOoperatorTable) (_rightPatternOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _leftPatternIerrors ++ _operatorIerrors ++ _rightPatternIerrors
            -- self rule
            (_self@_) =
                LeftHandSide_Infix _rangeIself _leftPatternIself _operatorIself _rightPatternIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _rightPatternIoperatorTable_collect
            -- copy rule (down)
            (_leftPatternOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_leftPatternOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_operatorOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_operatorOoperatorTable_collect@_) =
                _leftPatternIoperatorTable_collect
            -- copy rule (down)
            (_rightPatternOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_rightPatternOoperatorTable_collect@_) =
                _operatorIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_LeftHandSide_Parenthesized :: (T_Range) ->
                                  (T_LeftHandSide) ->
                                  (T_Patterns) ->
                                  (T_LeftHandSide)
sem_LeftHandSide_Parenthesized (range_) (lefthandside_) (patterns_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (LeftHandSide)
            _rangeIself :: (Range)
            _lefthandsideIerrors :: ([GHError])
            _lefthandsideIoperatorTable_collect :: (OperatorTable)
            _lefthandsideIself :: (LeftHandSide)
            _lefthandsideOoperatorTable :: (OperatorTable)
            _lefthandsideOoperatorTable_collect :: (OperatorTable)
            _patternsIerrors :: ([GHError])
            _patternsIoperatorTable_collect :: (OperatorTable)
            _patternsIself :: (Patterns)
            _patternsOoperatorTable :: (OperatorTable)
            _patternsOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _lefthandsideIerrors,_lefthandsideIoperatorTable_collect,_lefthandsideIself) =
                (lefthandside_ (_lefthandsideOoperatorTable) (_lefthandsideOoperatorTable_collect))
            ( _patternsIerrors,_patternsIoperatorTable_collect,_patternsIself) =
                (patterns_ (_patternsOoperatorTable) (_patternsOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _lefthandsideIerrors ++ _patternsIerrors
            -- self rule
            (_self@_) =
                LeftHandSide_Parenthesized _rangeIself _lefthandsideIself _patternsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _patternsIoperatorTable_collect
            -- copy rule (down)
            (_lefthandsideOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_lefthandsideOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_patternsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_patternsOoperatorTable_collect@_) =
                _lefthandsideIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- Literal -----------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for Literal.Char:
      self

-}
{-
   local variables for Literal.Float:
      self

-}
{-
   local variables for Literal.Int:
      self

-}
{-
   local variables for Literal.String:
      self

-}
-- semantic domain
type T_Literal = (OperatorTable) ->
                 (OperatorTable) ->
                 ( ([GHError]),(OperatorTable),(Literal))
-- cata
sem_Literal :: (Literal) ->
               (T_Literal)
sem_Literal ((Literal_Char (_range) (_value))) =
    (sem_Literal_Char ((sem_Range (_range))) (_value))
sem_Literal ((Literal_Float (_range) (_value))) =
    (sem_Literal_Float ((sem_Range (_range))) (_value))
sem_Literal ((Literal_Int (_range) (_value))) =
    (sem_Literal_Int ((sem_Range (_range))) (_value))
sem_Literal ((Literal_String (_range) (_value))) =
    (sem_Literal_String ((sem_Range (_range))) (_value))
sem_Literal_Char :: (T_Range) ->
                    (String) ->
                    (T_Literal)
sem_Literal_Char (range_) (value_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Literal)
            _rangeIself :: (Range)
            ( _rangeIself) =
                (range_ )
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                Literal_Char _rangeIself value_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Literal_Float :: (T_Range) ->
                     (String) ->
                     (T_Literal)
sem_Literal_Float (range_) (value_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Literal)
            _rangeIself :: (Range)
            ( _rangeIself) =
                (range_ )
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                Literal_Float _rangeIself value_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Literal_Int :: (T_Range) ->
                   (String) ->
                   (T_Literal)
sem_Literal_Int (range_) (value_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Literal)
            _rangeIself :: (Range)
            ( _rangeIself) =
                (range_ )
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                Literal_Int _rangeIself value_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Literal_String :: (T_Range) ->
                      (String) ->
                      (T_Literal)
sem_Literal_String (range_) (value_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Literal)
            _rangeIself :: (Range)
            ( _rangeIself) =
                (range_ )
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                Literal_String _rangeIself value_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- MaybeDeclarations -------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for MaybeDeclarations.Just:
      self

-}
{-
   local variables for MaybeDeclarations.Nothing:
      self

-}
-- semantic domain
type T_MaybeDeclarations = (OperatorTable) ->
                           (OperatorTable) ->
                           ( ([GHError]),(OperatorTable),(MaybeDeclarations))
-- cata
sem_MaybeDeclarations :: (MaybeDeclarations) ->
                         (T_MaybeDeclarations)
sem_MaybeDeclarations ((MaybeDeclarations_Just (_declarations))) =
    (sem_MaybeDeclarations_Just ((sem_Declarations (_declarations))))
sem_MaybeDeclarations ((MaybeDeclarations_Nothing )) =
    (sem_MaybeDeclarations_Nothing )
sem_MaybeDeclarations_Just :: (T_Declarations) ->
                              (T_MaybeDeclarations)
sem_MaybeDeclarations_Just (declarations_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (MaybeDeclarations)
            _declarationsIerrors :: ([GHError])
            _declarationsIoperatorTable_collect :: (OperatorTable)
            _declarationsIself :: (Declarations)
            _declarationsOoperatorTable :: (OperatorTable)
            _declarationsOoperatorTable_collect :: (OperatorTable)
            ( _declarationsIerrors,_declarationsIoperatorTable_collect,_declarationsIself) =
                (declarations_ (_declarationsOoperatorTable) (_declarationsOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _declarationsIerrors
            -- self rule
            (_self@_) =
                MaybeDeclarations_Just _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _declarationsIoperatorTable_collect
            -- copy rule (down)
            (_declarationsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_declarationsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_MaybeDeclarations_Nothing :: (T_MaybeDeclarations)
sem_MaybeDeclarations_Nothing  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (MaybeDeclarations)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                MaybeDeclarations_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- MaybeExports ------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for MaybeExports.Just:
      self

-}
{-
   local variables for MaybeExports.Nothing:
      self

-}
-- semantic domain
type T_MaybeExports = (OperatorTable) ->
                      (OperatorTable) ->
                      ( ([GHError]),(OperatorTable),(MaybeExports))
-- cata
sem_MaybeExports :: (MaybeExports) ->
                    (T_MaybeExports)
sem_MaybeExports ((MaybeExports_Just (_exports))) =
    (sem_MaybeExports_Just ((sem_Exports (_exports))))
sem_MaybeExports ((MaybeExports_Nothing )) =
    (sem_MaybeExports_Nothing )
sem_MaybeExports_Just :: (T_Exports) ->
                         (T_MaybeExports)
sem_MaybeExports_Just (exports_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (MaybeExports)
            _exportsIerrors :: ([GHError])
            _exportsIoperatorTable_collect :: (OperatorTable)
            _exportsIself :: (Exports)
            _exportsOoperatorTable :: (OperatorTable)
            _exportsOoperatorTable_collect :: (OperatorTable)
            ( _exportsIerrors,_exportsIoperatorTable_collect,_exportsIself) =
                (exports_ (_exportsOoperatorTable) (_exportsOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _exportsIerrors
            -- self rule
            (_self@_) =
                MaybeExports_Just _exportsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _exportsIoperatorTable_collect
            -- copy rule (down)
            (_exportsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_exportsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_MaybeExports_Nothing :: (T_MaybeExports)
sem_MaybeExports_Nothing  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (MaybeExports)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                MaybeExports_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- MaybeExpression ---------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      flatten              : [FlatExpression]
      self                 : SELF

-}
{-
   local variables for MaybeExpression.Just:
      self

-}
{-
   local variables for MaybeExpression.Nothing:
      self

-}
-- semantic domain
type T_MaybeExpression = (OperatorTable) ->
                         (OperatorTable) ->
                         ( ([GHError]),([FlatExpression]),(OperatorTable),(MaybeExpression))
-- cata
sem_MaybeExpression :: (MaybeExpression) ->
                       (T_MaybeExpression)
sem_MaybeExpression ((MaybeExpression_Just (_expression))) =
    (sem_MaybeExpression_Just ((sem_Expression (_expression))))
sem_MaybeExpression ((MaybeExpression_Nothing )) =
    (sem_MaybeExpression_Nothing )
sem_MaybeExpression_Just :: (T_Expression) ->
                            (T_MaybeExpression)
sem_MaybeExpression_Just (expression_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatExpression])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (MaybeExpression)
            _expressionIerrors :: ([GHError])
            _expressionIflatten :: ([FlatExpression])
            _expressionIoperatorTable_collect :: (OperatorTable)
            _expressionIself :: (Expression)
            _expressionOoperatorTable :: (OperatorTable)
            _expressionOoperatorTable_collect :: (OperatorTable)
            ( _expressionIerrors,_expressionIflatten,_expressionIoperatorTable_collect,_expressionIself) =
                (expression_ (_expressionOoperatorTable) (_expressionOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _expressionIerrors
            -- use rule
            (_lhsOflatten@_) =
                _expressionIflatten
            -- self rule
            (_self@_) =
                MaybeExpression_Just _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _expressionIoperatorTable_collect
            -- copy rule (down)
            (_expressionOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_expressionOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_MaybeExpression_Nothing :: (T_MaybeExpression)
sem_MaybeExpression_Nothing  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatExpression])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (MaybeExpression)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- use rule
            (_lhsOflatten@_) =
                []
            -- self rule
            (_self@_) =
                MaybeExpression_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
-- MaybeImportSpecification ------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for MaybeImportSpecification.Just:
      self

-}
{-
   local variables for MaybeImportSpecification.Nothing:
      self

-}
-- semantic domain
type T_MaybeImportSpecification = (OperatorTable) ->
                                  (OperatorTable) ->
                                  ( ([GHError]),(OperatorTable),(MaybeImportSpecification))
-- cata
sem_MaybeImportSpecification :: (MaybeImportSpecification) ->
                                (T_MaybeImportSpecification)
sem_MaybeImportSpecification ((MaybeImportSpecification_Just (_importspecification))) =
    (sem_MaybeImportSpecification_Just ((sem_ImportSpecification (_importspecification))))
sem_MaybeImportSpecification ((MaybeImportSpecification_Nothing )) =
    (sem_MaybeImportSpecification_Nothing )
sem_MaybeImportSpecification_Just :: (T_ImportSpecification) ->
                                     (T_MaybeImportSpecification)
sem_MaybeImportSpecification_Just (importspecification_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (MaybeImportSpecification)
            _importspecificationIerrors :: ([GHError])
            _importspecificationIoperatorTable_collect :: (OperatorTable)
            _importspecificationIself :: (ImportSpecification)
            _importspecificationOoperatorTable :: (OperatorTable)
            _importspecificationOoperatorTable_collect :: (OperatorTable)
            ( _importspecificationIerrors,_importspecificationIoperatorTable_collect,_importspecificationIself) =
                (importspecification_ (_importspecificationOoperatorTable) (_importspecificationOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _importspecificationIerrors
            -- self rule
            (_self@_) =
                MaybeImportSpecification_Just _importspecificationIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _importspecificationIoperatorTable_collect
            -- copy rule (down)
            (_importspecificationOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_importspecificationOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_MaybeImportSpecification_Nothing :: (T_MaybeImportSpecification)
sem_MaybeImportSpecification_Nothing  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (MaybeImportSpecification)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                MaybeImportSpecification_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- MaybeInt ----------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF
      toInt                : Int

-}
{-
   local variables for MaybeInt.Just:
      self

-}
{-
   local variables for MaybeInt.Nothing:
      self

-}
-- semantic domain
type T_MaybeInt = (OperatorTable) ->
                  (OperatorTable) ->
                  ( ([GHError]),(OperatorTable),(MaybeInt),(Int))
-- cata
sem_MaybeInt :: (MaybeInt) ->
                (T_MaybeInt)
sem_MaybeInt ((MaybeInt_Just (_int))) =
    (sem_MaybeInt_Just (_int))
sem_MaybeInt ((MaybeInt_Nothing )) =
    (sem_MaybeInt_Nothing )
sem_MaybeInt_Just :: (Int) ->
                     (T_MaybeInt)
sem_MaybeInt_Just (int_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (MaybeInt)
            _lhsOtoInt :: (Int)
            -- "ResolveOperators.lag"(line 166, column 9)
            (_lhsOtoInt@_) =
                int_
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                MaybeInt_Just int_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself,_lhsOtoInt)
sem_MaybeInt_Nothing :: (T_MaybeInt)
sem_MaybeInt_Nothing  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (MaybeInt)
            _lhsOtoInt :: (Int)
            -- "ResolveOperators.lag"(line 164, column 9)
            (_lhsOtoInt@_) =
                9
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                MaybeInt_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself,_lhsOtoInt)
-- MaybeKind ---------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for MaybeKind.Just:
      self

-}
{-
   local variables for MaybeKind.Nothing:
      self

-}
-- semantic domain
type T_MaybeKind = (OperatorTable) ->
                   (OperatorTable) ->
                   ( ([GHError]),(OperatorTable),(MaybeKind))
-- cata
sem_MaybeKind :: (MaybeKind) ->
                 (T_MaybeKind)
sem_MaybeKind ((MaybeKind_Just (_kind))) =
    (sem_MaybeKind_Just ((sem_Kind (_kind))))
sem_MaybeKind ((MaybeKind_Nothing )) =
    (sem_MaybeKind_Nothing )
sem_MaybeKind_Just :: (T_Kind) ->
                      (T_MaybeKind)
sem_MaybeKind_Just (kind_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (MaybeKind)
            _kindIerrors :: ([GHError])
            _kindIoperatorTable_collect :: (OperatorTable)
            _kindIself :: (Kind)
            _kindOoperatorTable :: (OperatorTable)
            _kindOoperatorTable_collect :: (OperatorTable)
            ( _kindIerrors,_kindIoperatorTable_collect,_kindIself) =
                (kind_ (_kindOoperatorTable) (_kindOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _kindIerrors
            -- self rule
            (_self@_) =
                MaybeKind_Just _kindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _kindIoperatorTable_collect
            -- copy rule (down)
            (_kindOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_kindOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_MaybeKind_Nothing :: (T_MaybeKind)
sem_MaybeKind_Nothing  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (MaybeKind)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                MaybeKind_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- MaybeModuleName ---------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for MaybeModuleName.Just:
      self

-}
{-
   local variables for MaybeModuleName.Nothing:
      self

-}
-- semantic domain
type T_MaybeModuleName = (OperatorTable) ->
                         (OperatorTable) ->
                         ( ([GHError]),(OperatorTable),(MaybeModuleName))
-- cata
sem_MaybeModuleName :: (MaybeModuleName) ->
                       (T_MaybeModuleName)
sem_MaybeModuleName ((MaybeModuleName_Just (_modulename))) =
    (sem_MaybeModuleName_Just ((sem_ModuleName (_modulename))))
sem_MaybeModuleName ((MaybeModuleName_Nothing )) =
    (sem_MaybeModuleName_Nothing )
sem_MaybeModuleName_Just :: (T_ModuleName) ->
                            (T_MaybeModuleName)
sem_MaybeModuleName_Just (modulename_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (MaybeModuleName)
            _modulenameIerrors :: ([GHError])
            _modulenameIoperatorTable_collect :: (OperatorTable)
            _modulenameIself :: (ModuleName)
            _modulenameOoperatorTable :: (OperatorTable)
            _modulenameOoperatorTable_collect :: (OperatorTable)
            ( _modulenameIerrors,_modulenameIoperatorTable_collect,_modulenameIself) =
                (modulename_ (_modulenameOoperatorTable) (_modulenameOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _modulenameIerrors
            -- self rule
            (_self@_) =
                MaybeModuleName_Just _modulenameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _modulenameIoperatorTable_collect
            -- copy rule (down)
            (_modulenameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_modulenameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_MaybeModuleName_Nothing :: (T_MaybeModuleName)
sem_MaybeModuleName_Nothing  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (MaybeModuleName)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                MaybeModuleName_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- MaybeName ---------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for MaybeName.Just:
      self

-}
{-
   local variables for MaybeName.Nothing:
      self

-}
-- semantic domain
type T_MaybeName = (OperatorTable) ->
                   (OperatorTable) ->
                   ( ([GHError]),(OperatorTable),(MaybeName))
-- cata
sem_MaybeName :: (MaybeName) ->
                 (T_MaybeName)
sem_MaybeName ((MaybeName_Just (_name))) =
    (sem_MaybeName_Just ((sem_Name (_name))))
sem_MaybeName ((MaybeName_Nothing )) =
    (sem_MaybeName_Nothing )
sem_MaybeName_Just :: (T_Name) ->
                      (T_MaybeName)
sem_MaybeName_Just (name_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (MaybeName)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors
            -- self rule
            (_self@_) =
                MaybeName_Just _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_MaybeName_Nothing :: (T_MaybeName)
sem_MaybeName_Nothing  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (MaybeName)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                MaybeName_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- MaybeNames --------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for MaybeNames.Just:
      self

-}
{-
   local variables for MaybeNames.Nothing:
      self

-}
-- semantic domain
type T_MaybeNames = (OperatorTable) ->
                    (OperatorTable) ->
                    ( ([GHError]),(OperatorTable),(MaybeNames))
-- cata
sem_MaybeNames :: (MaybeNames) ->
                  (T_MaybeNames)
sem_MaybeNames ((MaybeNames_Just (_names))) =
    (sem_MaybeNames_Just ((sem_Names (_names))))
sem_MaybeNames ((MaybeNames_Nothing )) =
    (sem_MaybeNames_Nothing )
sem_MaybeNames_Just :: (T_Names) ->
                       (T_MaybeNames)
sem_MaybeNames_Just (names_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (MaybeNames)
            _namesIerrors :: ([GHError])
            _namesIoperatorTable_collect :: (OperatorTable)
            _namesIself :: (Names)
            _namesOoperatorTable :: (OperatorTable)
            _namesOoperatorTable_collect :: (OperatorTable)
            ( _namesIerrors,_namesIoperatorTable_collect,_namesIself) =
                (names_ (_namesOoperatorTable) (_namesOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _namesIerrors
            -- self rule
            (_self@_) =
                MaybeNames_Just _namesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _namesIoperatorTable_collect
            -- copy rule (down)
            (_namesOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_namesOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_MaybeNames_Nothing :: (T_MaybeNames)
sem_MaybeNames_Nothing  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (MaybeNames)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                MaybeNames_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- MaybeReassignments ------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for MaybeReassignments.Just:
      self

-}
{-
   local variables for MaybeReassignments.Nothing:
      self

-}
-- semantic domain
type T_MaybeReassignments = (OperatorTable) ->
                            (OperatorTable) ->
                            ( ([GHError]),(OperatorTable),(MaybeReassignments))
-- cata
sem_MaybeReassignments :: (MaybeReassignments) ->
                          (T_MaybeReassignments)
sem_MaybeReassignments ((MaybeReassignments_Just (_reassignments))) =
    (sem_MaybeReassignments_Just ((sem_Reassignments (_reassignments))))
sem_MaybeReassignments ((MaybeReassignments_Nothing )) =
    (sem_MaybeReassignments_Nothing )
sem_MaybeReassignments_Just :: (T_Reassignments) ->
                               (T_MaybeReassignments)
sem_MaybeReassignments_Just (reassignments_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (MaybeReassignments)
            _reassignmentsIerrors :: ([GHError])
            _reassignmentsIoperatorTable_collect :: (OperatorTable)
            _reassignmentsIself :: (Reassignments)
            _reassignmentsOoperatorTable :: (OperatorTable)
            _reassignmentsOoperatorTable_collect :: (OperatorTable)
            ( _reassignmentsIerrors,_reassignmentsIoperatorTable_collect,_reassignmentsIself) =
                (reassignments_ (_reassignmentsOoperatorTable) (_reassignmentsOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _reassignmentsIerrors
            -- self rule
            (_self@_) =
                MaybeReassignments_Just _reassignmentsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _reassignmentsIoperatorTable_collect
            -- copy rule (down)
            (_reassignmentsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_reassignmentsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_MaybeReassignments_Nothing :: (T_MaybeReassignments)
sem_MaybeReassignments_Nothing  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (MaybeReassignments)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                MaybeReassignments_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- Module ------------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for Module.Module:
      self

-}
-- semantic domain
type T_Module = (OperatorTable) ->
                (OperatorTable) ->
                ( ([GHError]),(OperatorTable),(Module))
-- cata
sem_Module :: (Module) ->
              (T_Module)
sem_Module ((Module_Module (_range) (_name) (_exports) (_body))) =
    (sem_Module_Module ((sem_Range (_range))) ((sem_MaybeModuleName (_name))) ((sem_MaybeExports (_exports))) ((sem_Body (_body))))
sem_Module_Module :: (T_Range) ->
                     (T_MaybeModuleName) ->
                     (T_MaybeExports) ->
                     (T_Body) ->
                     (T_Module)
sem_Module_Module (range_) (name_) (exports_) (body_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Module)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (MaybeModuleName)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _exportsIerrors :: ([GHError])
            _exportsIoperatorTable_collect :: (OperatorTable)
            _exportsIself :: (MaybeExports)
            _exportsOoperatorTable :: (OperatorTable)
            _exportsOoperatorTable_collect :: (OperatorTable)
            _bodyIerrors :: ([GHError])
            _bodyIoperatorTable_collect :: (OperatorTable)
            _bodyIself :: (Body)
            _bodyOoperatorTable :: (OperatorTable)
            _bodyOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _exportsIerrors,_exportsIoperatorTable_collect,_exportsIself) =
                (exports_ (_exportsOoperatorTable) (_exportsOoperatorTable_collect))
            ( _bodyIerrors,_bodyIoperatorTable_collect,_bodyIself) =
                (body_ (_bodyOoperatorTable) (_bodyOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _exportsIerrors ++ _bodyIerrors
            -- self rule
            (_self@_) =
                Module_Module _rangeIself _nameIself _exportsIself _bodyIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _bodyIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_exportsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_exportsOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_bodyOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_bodyOoperatorTable_collect@_) =
                _exportsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- ModuleInterface ---------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for ModuleInterface.ModuleInterface:
      self

-}
{-
   local variables for ModuleInterface.Unavailable:
      self

-}
-- semantic domain
type T_ModuleInterface = (OperatorTable) ->
                         (OperatorTable) ->
                         ( ([GHError]),(OperatorTable),(ModuleInterface))
-- cata
sem_ModuleInterface :: (ModuleInterface) ->
                       (T_ModuleInterface)
sem_ModuleInterface ((ModuleInterface_ModuleInterface (_range) (_name) (_exportedTypes) (_exportedValues) (_declarations))) =
    (sem_ModuleInterface_ModuleInterface ((sem_Range (_range))) ((sem_ModuleName (_name))) ((sem_Names (_exportedTypes))) ((sem_Names (_exportedValues))) ((sem_InterfaceDeclarations (_declarations))))
sem_ModuleInterface ((ModuleInterface_Unavailable (_name))) =
    (sem_ModuleInterface_Unavailable ((sem_ModuleName (_name))))
sem_ModuleInterface_ModuleInterface :: (T_Range) ->
                                       (T_ModuleName) ->
                                       (T_Names) ->
                                       (T_Names) ->
                                       (T_InterfaceDeclarations) ->
                                       (T_ModuleInterface)
sem_ModuleInterface_ModuleInterface (range_) (name_) (exportedTypes_) (exportedValues_) (declarations_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (ModuleInterface)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (ModuleName)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _exportedTypesIerrors :: ([GHError])
            _exportedTypesIoperatorTable_collect :: (OperatorTable)
            _exportedTypesIself :: (Names)
            _exportedTypesOoperatorTable :: (OperatorTable)
            _exportedTypesOoperatorTable_collect :: (OperatorTable)
            _exportedValuesIerrors :: ([GHError])
            _exportedValuesIoperatorTable_collect :: (OperatorTable)
            _exportedValuesIself :: (Names)
            _exportedValuesOoperatorTable :: (OperatorTable)
            _exportedValuesOoperatorTable_collect :: (OperatorTable)
            _declarationsIerrors :: ([GHError])
            _declarationsIoperatorTable_collect :: (OperatorTable)
            _declarationsIself :: (InterfaceDeclarations)
            _declarationsOoperatorTable :: (OperatorTable)
            _declarationsOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _exportedTypesIerrors,_exportedTypesIoperatorTable_collect,_exportedTypesIself) =
                (exportedTypes_ (_exportedTypesOoperatorTable) (_exportedTypesOoperatorTable_collect))
            ( _exportedValuesIerrors,_exportedValuesIoperatorTable_collect,_exportedValuesIself) =
                (exportedValues_ (_exportedValuesOoperatorTable) (_exportedValuesOoperatorTable_collect))
            ( _declarationsIerrors,_declarationsIoperatorTable_collect,_declarationsIself) =
                (declarations_ (_declarationsOoperatorTable) (_declarationsOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _exportedTypesIerrors ++ _exportedValuesIerrors ++ _declarationsIerrors
            -- self rule
            (_self@_) =
                ModuleInterface_ModuleInterface _rangeIself _nameIself _exportedTypesIself _exportedValuesIself _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _declarationsIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_exportedTypesOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_exportedTypesOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_exportedValuesOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_exportedValuesOoperatorTable_collect@_) =
                _exportedTypesIoperatorTable_collect
            -- copy rule (down)
            (_declarationsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_declarationsOoperatorTable_collect@_) =
                _exportedValuesIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_ModuleInterface_Unavailable :: (T_ModuleName) ->
                                   (T_ModuleInterface)
sem_ModuleInterface_Unavailable (name_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (ModuleInterface)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (ModuleName)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors
            -- self rule
            (_self@_) =
                ModuleInterface_Unavailable _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- ModuleInterfaces --------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for ModuleInterfaces.Cons:
      self

-}
{-
   local variables for ModuleInterfaces.Nil:
      self

-}
-- semantic domain
type T_ModuleInterfaces = (OperatorTable) ->
                          (OperatorTable) ->
                          ( ([GHError]),(OperatorTable),(ModuleInterfaces))
-- cata
sem_ModuleInterfaces :: (ModuleInterfaces) ->
                        (T_ModuleInterfaces)
sem_ModuleInterfaces (list) =
    (foldr (sem_ModuleInterfaces_Cons) (sem_ModuleInterfaces_Nil) ((map sem_ModuleInterface list)))
sem_ModuleInterfaces_Cons :: (T_ModuleInterface) ->
                             (T_ModuleInterfaces) ->
                             (T_ModuleInterfaces)
sem_ModuleInterfaces_Cons (hd_) (tl_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (ModuleInterfaces)
            _hdIerrors :: ([GHError])
            _hdIoperatorTable_collect :: (OperatorTable)
            _hdIself :: (ModuleInterface)
            _hdOoperatorTable :: (OperatorTable)
            _hdOoperatorTable_collect :: (OperatorTable)
            _tlIerrors :: ([GHError])
            _tlIoperatorTable_collect :: (OperatorTable)
            _tlIself :: (ModuleInterfaces)
            _tlOoperatorTable :: (OperatorTable)
            _tlOoperatorTable_collect :: (OperatorTable)
            ( _hdIerrors,_hdIoperatorTable_collect,_hdIself) =
                (hd_ (_hdOoperatorTable) (_hdOoperatorTable_collect))
            ( _tlIerrors,_tlIoperatorTable_collect,_tlIself) =
                (tl_ (_tlOoperatorTable) (_tlOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 137, column 9)
            (_lhsOoperatorTable_collect@_) =
                mergeFM
                  _hdIoperatorTable_collect
                  _tlIoperatorTable_collect
            -- "ResolveOperators.lag"(line 136, column 9)
            (_tlOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- "ResolveOperators.lag"(line 135, column 9)
            (_hdOoperatorTable_collect@_) =
                emptyFM
            -- use rule
            (_lhsOerrors@_) =
                _hdIerrors ++ _tlIerrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_hdOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_tlOoperatorTable@_) =
                _lhsIoperatorTable
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_ModuleInterfaces_Nil :: (T_ModuleInterfaces)
sem_ModuleInterfaces_Nil  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (ModuleInterfaces)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- ModuleName --------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for ModuleName.ModuleName:
      self

-}
-- semantic domain
type T_ModuleName = (OperatorTable) ->
                    (OperatorTable) ->
                    ( ([GHError]),(OperatorTable),(ModuleName))
-- cata
sem_ModuleName :: (ModuleName) ->
                  (T_ModuleName)
sem_ModuleName ((ModuleName_ModuleName (_range) (_name))) =
    (sem_ModuleName_ModuleName ((sem_Range (_range))) ((sem_Strings (_name))))
sem_ModuleName_ModuleName :: (T_Range) ->
                             (T_Strings) ->
                             (T_ModuleName)
sem_ModuleName_ModuleName (range_) (name_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (ModuleName)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Strings)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors
            -- self rule
            (_self@_) =
                ModuleName_ModuleName _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- ModuleSystem ------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for ModuleSystem.ModuleSystem:
      self

-}
-- semantic domain
type T_ModuleSystem = (OperatorTable) ->
                      (OperatorTable) ->
                      ( ([GHError]),(OperatorTable),(ModuleSystem))
-- cata
sem_ModuleSystem :: (ModuleSystem) ->
                    (T_ModuleSystem)
sem_ModuleSystem ((ModuleSystem_ModuleSystem (_interfaces) (_module))) =
    (sem_ModuleSystem_ModuleSystem ((sem_ModuleInterfaces (_interfaces))) ((sem_Module (_module))))
sem_ModuleSystem_ModuleSystem :: (T_ModuleInterfaces) ->
                                 (T_Module) ->
                                 (T_ModuleSystem)
sem_ModuleSystem_ModuleSystem (interfaces_) (module_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (ModuleSystem)
            _interfacesIerrors :: ([GHError])
            _interfacesIoperatorTable_collect :: (OperatorTable)
            _interfacesIself :: (ModuleInterfaces)
            _interfacesOoperatorTable :: (OperatorTable)
            _interfacesOoperatorTable_collect :: (OperatorTable)
            _moduleIerrors :: ([GHError])
            _moduleIoperatorTable_collect :: (OperatorTable)
            _moduleIself :: (Module)
            _moduleOoperatorTable :: (OperatorTable)
            _moduleOoperatorTable_collect :: (OperatorTable)
            ( _interfacesIerrors,_interfacesIoperatorTable_collect,_interfacesIself) =
                (interfaces_ (_interfacesOoperatorTable) (_interfacesOoperatorTable_collect))
            ( _moduleIerrors,_moduleIoperatorTable_collect,_moduleIself) =
                (module_ (_moduleOoperatorTable) (_moduleOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 131, column 9)
            (_moduleOoperatorTable@_) =
                _moduleIoperatorTable_collect
            -- use rule
            (_lhsOerrors@_) =
                _interfacesIerrors ++ _moduleIerrors
            -- self rule
            (_self@_) =
                ModuleSystem_ModuleSystem _interfacesIself _moduleIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _moduleIoperatorTable_collect
            -- copy rule (down)
            (_interfacesOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_interfacesOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (chain)
            (_moduleOoperatorTable_collect@_) =
                _interfacesIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- Name --------------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for Name.Entity:
      self

-}
{-
   local variables for Name.Identifier:
      self

-}
{-
   local variables for Name.Operator:
      self

-}
{-
   local variables for Name.Special:
      self

-}
-- semantic domain
type T_Name = (OperatorTable) ->
              (OperatorTable) ->
              ( ([GHError]),(OperatorTable),(Name))
-- cata
sem_Name :: (Name) ->
            (T_Name)
sem_Name ((Name_Entity (_range) (_entity) (_inscope))) =
    (sem_Name_Entity ((sem_Range (_range))) ((sem_Name (_entity))) ((sem_MaybeName (_inscope))))
sem_Name ((Name_Identifier (_range) (_module) (_name))) =
    (sem_Name_Identifier ((sem_Range (_range))) ((sem_Strings (_module))) (_name))
sem_Name ((Name_Operator (_range) (_module) (_name))) =
    (sem_Name_Operator ((sem_Range (_range))) ((sem_Strings (_module))) (_name))
sem_Name ((Name_Special (_range) (_module) (_name))) =
    (sem_Name_Special ((sem_Range (_range))) ((sem_Strings (_module))) (_name))
sem_Name_Entity :: (T_Range) ->
                   (T_Name) ->
                   (T_MaybeName) ->
                   (T_Name)
sem_Name_Entity (range_) (entity_) (inscope_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Name)
            _rangeIself :: (Range)
            _entityIerrors :: ([GHError])
            _entityIoperatorTable_collect :: (OperatorTable)
            _entityIself :: (Name)
            _entityOoperatorTable :: (OperatorTable)
            _entityOoperatorTable_collect :: (OperatorTable)
            _inscopeIerrors :: ([GHError])
            _inscopeIoperatorTable_collect :: (OperatorTable)
            _inscopeIself :: (MaybeName)
            _inscopeOoperatorTable :: (OperatorTable)
            _inscopeOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _entityIerrors,_entityIoperatorTable_collect,_entityIself) =
                (entity_ (_entityOoperatorTable) (_entityOoperatorTable_collect))
            ( _inscopeIerrors,_inscopeIoperatorTable_collect,_inscopeIself) =
                (inscope_ (_inscopeOoperatorTable) (_inscopeOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _entityIerrors ++ _inscopeIerrors
            -- self rule
            (_self@_) =
                Name_Entity _rangeIself _entityIself _inscopeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _inscopeIoperatorTable_collect
            -- copy rule (down)
            (_entityOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_entityOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_inscopeOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_inscopeOoperatorTable_collect@_) =
                _entityIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Name_Identifier :: (T_Range) ->
                       (T_Strings) ->
                       (String) ->
                       (T_Name)
sem_Name_Identifier (range_) (module_) (name_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Name)
            _rangeIself :: (Range)
            _moduleIerrors :: ([GHError])
            _moduleIoperatorTable_collect :: (OperatorTable)
            _moduleIself :: (Strings)
            _moduleOoperatorTable :: (OperatorTable)
            _moduleOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _moduleIerrors,_moduleIoperatorTable_collect,_moduleIself) =
                (module_ (_moduleOoperatorTable) (_moduleOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _moduleIerrors
            -- self rule
            (_self@_) =
                Name_Identifier _rangeIself _moduleIself name_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _moduleIoperatorTable_collect
            -- copy rule (down)
            (_moduleOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_moduleOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Name_Operator :: (T_Range) ->
                     (T_Strings) ->
                     (String) ->
                     (T_Name)
sem_Name_Operator (range_) (module_) (name_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Name)
            _rangeIself :: (Range)
            _moduleIerrors :: ([GHError])
            _moduleIoperatorTable_collect :: (OperatorTable)
            _moduleIself :: (Strings)
            _moduleOoperatorTable :: (OperatorTable)
            _moduleOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _moduleIerrors,_moduleIoperatorTable_collect,_moduleIself) =
                (module_ (_moduleOoperatorTable) (_moduleOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _moduleIerrors
            -- self rule
            (_self@_) =
                Name_Operator _rangeIself _moduleIself name_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _moduleIoperatorTable_collect
            -- copy rule (down)
            (_moduleOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_moduleOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Name_Special :: (T_Range) ->
                    (T_Strings) ->
                    (String) ->
                    (T_Name)
sem_Name_Special (range_) (module_) (name_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Name)
            _rangeIself :: (Range)
            _moduleIerrors :: ([GHError])
            _moduleIoperatorTable_collect :: (OperatorTable)
            _moduleIself :: (Strings)
            _moduleOoperatorTable :: (OperatorTable)
            _moduleOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _moduleIerrors,_moduleIoperatorTable_collect,_moduleIself) =
                (module_ (_moduleOoperatorTable) (_moduleOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _moduleIerrors
            -- self rule
            (_self@_) =
                Name_Special _rangeIself _moduleIself name_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _moduleIoperatorTable_collect
            -- copy rule (down)
            (_moduleOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_moduleOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- Names -------------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for Names.Cons:
      self

-}
{-
   local variables for Names.Nil:
      self

-}
-- semantic domain
type T_Names = (OperatorTable) ->
               (OperatorTable) ->
               ( ([GHError]),(OperatorTable),(Names))
-- cata
sem_Names :: (Names) ->
             (T_Names)
sem_Names (list) =
    (foldr (sem_Names_Cons) (sem_Names_Nil) ((map sem_Name list)))
sem_Names_Cons :: (T_Name) ->
                  (T_Names) ->
                  (T_Names)
sem_Names_Cons (hd_) (tl_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Names)
            _hdIerrors :: ([GHError])
            _hdIoperatorTable_collect :: (OperatorTable)
            _hdIself :: (Name)
            _hdOoperatorTable :: (OperatorTable)
            _hdOoperatorTable_collect :: (OperatorTable)
            _tlIerrors :: ([GHError])
            _tlIoperatorTable_collect :: (OperatorTable)
            _tlIself :: (Names)
            _tlOoperatorTable :: (OperatorTable)
            _tlOoperatorTable_collect :: (OperatorTable)
            ( _hdIerrors,_hdIoperatorTable_collect,_hdIself) =
                (hd_ (_hdOoperatorTable) (_hdOoperatorTable_collect))
            ( _tlIerrors,_tlIoperatorTable_collect,_tlIself) =
                (tl_ (_tlOoperatorTable) (_tlOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _hdIerrors ++ _tlIerrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _tlIoperatorTable_collect
            -- copy rule (down)
            (_hdOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_hdOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_tlOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_tlOoperatorTable_collect@_) =
                _hdIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Names_Nil :: (T_Names)
sem_Names_Nil  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Names)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- Pattern -----------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      flatten              : [FlatPattern]
      self                 : SELF

-}
{-
   local variables for Pattern.As:
      self

-}
{-
   local variables for Pattern.Constructor:
      self

-}
{-
   local variables for Pattern.InfixConstructor:
      flatten
      resolved
      errors
      self

-}
{-
   local variables for Pattern.Irrefutable:
      self

-}
{-
   local variables for Pattern.List:
      self

-}
{-
   local variables for Pattern.Literal:
      self

-}
{-
   local variables for Pattern.Negate:
      self

-}
{-
   local variables for Pattern.Parenthesized:
      self

-}
{-
   local variables for Pattern.Record:
      self

-}
{-
   local variables for Pattern.Successor:
      self

-}
{-
   local variables for Pattern.Tuple:
      self

-}
{-
   local variables for Pattern.Variable:
      self

-}
{-
   local variables for Pattern.Wildcard:
      self

-}
-- semantic domain
type T_Pattern = (OperatorTable) ->
                 (OperatorTable) ->
                 ( ([GHError]),([FlatPattern]),(OperatorTable),(Pattern))
-- cata
sem_Pattern :: (Pattern) ->
               (T_Pattern)
sem_Pattern ((Pattern_As (_range) (_name) (_pattern))) =
    (sem_Pattern_As ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_Constructor (_range) (_name) (_patterns))) =
    (sem_Pattern_Constructor ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Patterns (_patterns))))
sem_Pattern ((Pattern_InfixConstructor (_range) (_leftPattern) (_constructorOperator) (_rightPattern))) =
    (sem_Pattern_InfixConstructor ((sem_Range (_range))) ((sem_Pattern (_leftPattern))) ((sem_Name (_constructorOperator))) ((sem_Pattern (_rightPattern))))
sem_Pattern ((Pattern_Irrefutable (_range) (_pattern))) =
    (sem_Pattern_Irrefutable ((sem_Range (_range))) ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_List (_range) (_patterns))) =
    (sem_Pattern_List ((sem_Range (_range))) ((sem_Patterns (_patterns))))
sem_Pattern ((Pattern_Literal (_range) (_literal))) =
    (sem_Pattern_Literal ((sem_Range (_range))) ((sem_Literal (_literal))))
sem_Pattern ((Pattern_Negate (_range) (_literal))) =
    (sem_Pattern_Negate ((sem_Range (_range))) ((sem_Literal (_literal))))
sem_Pattern ((Pattern_Parenthesized (_range) (_pattern))) =
    (sem_Pattern_Parenthesized ((sem_Range (_range))) ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_Record (_range) (_name) (_recordPatternBindings))) =
    (sem_Pattern_Record ((sem_Range (_range))) ((sem_Name (_name))) ((sem_RecordPatternBindings (_recordPatternBindings))))
sem_Pattern ((Pattern_Successor (_range) (_name) (_literal))) =
    (sem_Pattern_Successor ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Literal (_literal))))
sem_Pattern ((Pattern_Tuple (_range) (_patterns))) =
    (sem_Pattern_Tuple ((sem_Range (_range))) ((sem_Patterns (_patterns))))
sem_Pattern ((Pattern_Variable (_range) (_name))) =
    (sem_Pattern_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Pattern ((Pattern_Wildcard (_range))) =
    (sem_Pattern_Wildcard ((sem_Range (_range))))
sem_Pattern_As :: (T_Range) ->
                  (T_Name) ->
                  (T_Pattern) ->
                  (T_Pattern)
sem_Pattern_As (range_) (name_) (pattern_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatPattern])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _patternIerrors :: ([GHError])
            _patternIflatten :: ([FlatPattern])
            _patternIoperatorTable_collect :: (OperatorTable)
            _patternIself :: (Pattern)
            _patternOoperatorTable :: (OperatorTable)
            _patternOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _patternIerrors,_patternIflatten,_patternIoperatorTable_collect,_patternIself) =
                (pattern_ (_patternOoperatorTable) (_patternOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 338, column 9)
            (_lhsOflatten@_) =
                [FItem _self]
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _patternIerrors
            -- self rule
            (_self@_) =
                Pattern_As _rangeIself _nameIself _patternIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _patternIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_patternOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_patternOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Pattern_Constructor :: (T_Range) ->
                           (T_Name) ->
                           (T_Patterns) ->
                           (T_Pattern)
sem_Pattern_Constructor (range_) (name_) (patterns_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatPattern])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _patternsIerrors :: ([GHError])
            _patternsIoperatorTable_collect :: (OperatorTable)
            _patternsIself :: (Patterns)
            _patternsOoperatorTable :: (OperatorTable)
            _patternsOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _patternsIerrors,_patternsIoperatorTable_collect,_patternsIself) =
                (patterns_ (_patternsOoperatorTable) (_patternsOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 321, column 9)
            (_lhsOflatten@_) =
                [FItem _self]
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _patternsIerrors
            -- self rule
            (_self@_) =
                Pattern_Constructor _rangeIself _nameIself _patternsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _patternsIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_patternsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_patternsOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Pattern_InfixConstructor :: (T_Range) ->
                                (T_Pattern) ->
                                (T_Name) ->
                                (T_Pattern) ->
                                (T_Pattern)
sem_Pattern_InfixConstructor (range_) (leftPattern_) (constructorOperator_) (rightPattern_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatPattern])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _leftPatternIerrors :: ([GHError])
            _leftPatternIflatten :: ([FlatPattern])
            _leftPatternIoperatorTable_collect :: (OperatorTable)
            _leftPatternIself :: (Pattern)
            _leftPatternOoperatorTable :: (OperatorTable)
            _leftPatternOoperatorTable_collect :: (OperatorTable)
            _constructorOperatorIerrors :: ([GHError])
            _constructorOperatorIoperatorTable_collect :: (OperatorTable)
            _constructorOperatorIself :: (Name)
            _constructorOperatorOoperatorTable :: (OperatorTable)
            _constructorOperatorOoperatorTable_collect :: (OperatorTable)
            _rightPatternIerrors :: ([GHError])
            _rightPatternIflatten :: ([FlatPattern])
            _rightPatternIoperatorTable_collect :: (OperatorTable)
            _rightPatternIself :: (Pattern)
            _rightPatternOoperatorTable :: (OperatorTable)
            _rightPatternOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _leftPatternIerrors,_leftPatternIflatten,_leftPatternIoperatorTable_collect,_leftPatternIself) =
                (leftPattern_ (_leftPatternOoperatorTable) (_leftPatternOoperatorTable_collect))
            ( _constructorOperatorIerrors,_constructorOperatorIoperatorTable_collect,_constructorOperatorIself) =
                (constructorOperator_ (_constructorOperatorOoperatorTable) (_constructorOperatorOoperatorTable_collect))
            ( _rightPatternIerrors,_rightPatternIflatten,_rightPatternIoperatorTable_collect,_rightPatternIself) =
                (rightPattern_ (_rightPatternOoperatorTable) (_rightPatternOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 328, column 9)
            (_lhsOflatten@_) =
                _flatten
            -- "ResolveOperators.lag"(line 325, column 9)
            (_flatten@_) =
                _leftPatternIflatten
                  ++ [FOperator _constructorOperatorIself]
                  ++ _rightPatternIflatten
            -- "ResolveOperators.lag"(line 387, column 9)
            (_lhsOself@_) =
                _resolved
            -- "ResolveOperators.lag"(line 384, column 13)
            ((_resolved@_,_errors@_)) =
                resolvePattern
                  _lhsIoperatorTable
                  _flatten
            -- use rule
            (_lhsOerrors@_) =
                _errors
            -- self rule
            (_self@_) =
                Pattern_InfixConstructor _rangeIself _leftPatternIself _constructorOperatorIself _rightPatternIself
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _rightPatternIoperatorTable_collect
            -- copy rule (down)
            (_leftPatternOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_leftPatternOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_constructorOperatorOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_constructorOperatorOoperatorTable_collect@_) =
                _leftPatternIoperatorTable_collect
            -- copy rule (down)
            (_rightPatternOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_rightPatternOoperatorTable_collect@_) =
                _constructorOperatorIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Pattern_Irrefutable :: (T_Range) ->
                           (T_Pattern) ->
                           (T_Pattern)
sem_Pattern_Irrefutable (range_) (pattern_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatPattern])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _patternIerrors :: ([GHError])
            _patternIflatten :: ([FlatPattern])
            _patternIoperatorTable_collect :: (OperatorTable)
            _patternIself :: (Pattern)
            _patternOoperatorTable :: (OperatorTable)
            _patternOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _patternIerrors,_patternIflatten,_patternIoperatorTable_collect,_patternIself) =
                (pattern_ (_patternOoperatorTable) (_patternOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 342, column 9)
            (_lhsOflatten@_) =
                [FItem _self]
            -- use rule
            (_lhsOerrors@_) =
                _patternIerrors
            -- self rule
            (_self@_) =
                Pattern_Irrefutable _rangeIself _patternIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _patternIoperatorTable_collect
            -- copy rule (down)
            (_patternOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_patternOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Pattern_List :: (T_Range) ->
                    (T_Patterns) ->
                    (T_Pattern)
sem_Pattern_List (range_) (patterns_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatPattern])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _patternsIerrors :: ([GHError])
            _patternsIoperatorTable_collect :: (OperatorTable)
            _patternsIself :: (Patterns)
            _patternsOoperatorTable :: (OperatorTable)
            _patternsOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _patternsIerrors,_patternsIoperatorTable_collect,_patternsIself) =
                (patterns_ (_patternsOoperatorTable) (_patternsOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 330, column 9)
            (_lhsOflatten@_) =
                [FItem _self]
            -- use rule
            (_lhsOerrors@_) =
                _patternsIerrors
            -- self rule
            (_self@_) =
                Pattern_List _rangeIself _patternsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _patternsIoperatorTable_collect
            -- copy rule (down)
            (_patternsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_patternsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Pattern_Literal :: (T_Range) ->
                       (T_Literal) ->
                       (T_Pattern)
sem_Pattern_Literal (range_) (literal_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatPattern])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _literalIerrors :: ([GHError])
            _literalIoperatorTable_collect :: (OperatorTable)
            _literalIself :: (Literal)
            _literalOoperatorTable :: (OperatorTable)
            _literalOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _literalIerrors,_literalIoperatorTable_collect,_literalIself) =
                (literal_ (_literalOoperatorTable) (_literalOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 317, column 9)
            (_lhsOflatten@_) =
                [FItem _self]
            -- use rule
            (_lhsOerrors@_) =
                _literalIerrors
            -- self rule
            (_self@_) =
                Pattern_Literal _rangeIself _literalIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _literalIoperatorTable_collect
            -- copy rule (down)
            (_literalOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_literalOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Pattern_Negate :: (T_Range) ->
                      (T_Literal) ->
                      (T_Pattern)
sem_Pattern_Negate (range_) (literal_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatPattern])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _literalIerrors :: ([GHError])
            _literalIoperatorTable_collect :: (OperatorTable)
            _literalIself :: (Literal)
            _literalOoperatorTable :: (OperatorTable)
            _literalOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _literalIerrors,_literalIoperatorTable_collect,_literalIself) =
                (literal_ (_literalOoperatorTable) (_literalOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 336, column 9)
            (_lhsOflatten@_) =
                [FItem _self]
            -- use rule
            (_lhsOerrors@_) =
                _literalIerrors
            -- self rule
            (_self@_) =
                Pattern_Negate _rangeIself _literalIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _literalIoperatorTable_collect
            -- copy rule (down)
            (_literalOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_literalOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Pattern_Parenthesized :: (T_Range) ->
                             (T_Pattern) ->
                             (T_Pattern)
sem_Pattern_Parenthesized (range_) (pattern_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatPattern])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _patternIerrors :: ([GHError])
            _patternIflatten :: ([FlatPattern])
            _patternIoperatorTable_collect :: (OperatorTable)
            _patternIself :: (Pattern)
            _patternOoperatorTable :: (OperatorTable)
            _patternOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _patternIerrors,_patternIflatten,_patternIoperatorTable_collect,_patternIself) =
                (pattern_ (_patternOoperatorTable) (_patternOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 323, column 9)
            (_lhsOflatten@_) =
                [FItem _self]
            -- use rule
            (_lhsOerrors@_) =
                _patternIerrors
            -- self rule
            (_self@_) =
                Pattern_Parenthesized _rangeIself _patternIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _patternIoperatorTable_collect
            -- copy rule (down)
            (_patternOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_patternOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Pattern_Record :: (T_Range) ->
                      (T_Name) ->
                      (T_RecordPatternBindings) ->
                      (T_Pattern)
sem_Pattern_Record (range_) (name_) (recordPatternBindings_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatPattern])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _recordPatternBindingsIerrors :: ([GHError])
            _recordPatternBindingsIoperatorTable_collect :: (OperatorTable)
            _recordPatternBindingsIself :: (RecordPatternBindings)
            _recordPatternBindingsOoperatorTable :: (OperatorTable)
            _recordPatternBindingsOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _recordPatternBindingsIerrors,_recordPatternBindingsIoperatorTable_collect,_recordPatternBindingsIself) =
                (recordPatternBindings_ (_recordPatternBindingsOoperatorTable) (_recordPatternBindingsOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 334, column 9)
            (_lhsOflatten@_) =
                [FItem _self]
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _recordPatternBindingsIerrors
            -- self rule
            (_self@_) =
                Pattern_Record _rangeIself _nameIself _recordPatternBindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _recordPatternBindingsIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_recordPatternBindingsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_recordPatternBindingsOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Pattern_Successor :: (T_Range) ->
                         (T_Name) ->
                         (T_Literal) ->
                         (T_Pattern)
sem_Pattern_Successor (range_) (name_) (literal_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatPattern])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _literalIerrors :: ([GHError])
            _literalIoperatorTable_collect :: (OperatorTable)
            _literalIself :: (Literal)
            _literalOoperatorTable :: (OperatorTable)
            _literalOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _literalIerrors,_literalIoperatorTable_collect,_literalIself) =
                (literal_ (_literalOoperatorTable) (_literalOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 344, column 9)
            (_lhsOflatten@_) =
                [FItem _self]
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _literalIerrors
            -- self rule
            (_self@_) =
                Pattern_Successor _rangeIself _nameIself _literalIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _literalIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_literalOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_literalOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Pattern_Tuple :: (T_Range) ->
                     (T_Patterns) ->
                     (T_Pattern)
sem_Pattern_Tuple (range_) (patterns_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatPattern])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _patternsIerrors :: ([GHError])
            _patternsIoperatorTable_collect :: (OperatorTable)
            _patternsIself :: (Patterns)
            _patternsOoperatorTable :: (OperatorTable)
            _patternsOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _patternsIerrors,_patternsIoperatorTable_collect,_patternsIself) =
                (patterns_ (_patternsOoperatorTable) (_patternsOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 332, column 9)
            (_lhsOflatten@_) =
                [FItem _self]
            -- use rule
            (_lhsOerrors@_) =
                _patternsIerrors
            -- self rule
            (_self@_) =
                Pattern_Tuple _rangeIself _patternsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _patternsIoperatorTable_collect
            -- copy rule (down)
            (_patternsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_patternsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Pattern_Variable :: (T_Range) ->
                        (T_Name) ->
                        (T_Pattern)
sem_Pattern_Variable (range_) (name_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatPattern])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 319, column 9)
            (_lhsOflatten@_) =
                [FItem _self]
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors
            -- self rule
            (_self@_) =
                Pattern_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
sem_Pattern_Wildcard :: (T_Range) ->
                        (T_Pattern)
sem_Pattern_Wildcard (range_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOflatten :: ([FlatPattern])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            ( _rangeIself) =
                (range_ )
            -- "ResolveOperators.lag"(line 340, column 9)
            (_lhsOflatten@_) =
                [FItem _self]
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                Pattern_Wildcard _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOflatten,_lhsOoperatorTable_collect,_lhsOself)
-- Patterns ----------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for Patterns.Cons:
      self

-}
{-
   local variables for Patterns.Nil:
      self

-}
-- semantic domain
type T_Patterns = (OperatorTable) ->
                  (OperatorTable) ->
                  ( ([GHError]),(OperatorTable),(Patterns))
-- cata
sem_Patterns :: (Patterns) ->
                (T_Patterns)
sem_Patterns (list) =
    (foldr (sem_Patterns_Cons) (sem_Patterns_Nil) ((map sem_Pattern list)))
sem_Patterns_Cons :: (T_Pattern) ->
                     (T_Patterns) ->
                     (T_Patterns)
sem_Patterns_Cons (hd_) (tl_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Patterns)
            _hdIerrors :: ([GHError])
            _hdIflatten :: ([FlatPattern])
            _hdIoperatorTable_collect :: (OperatorTable)
            _hdIself :: (Pattern)
            _hdOoperatorTable :: (OperatorTable)
            _hdOoperatorTable_collect :: (OperatorTable)
            _tlIerrors :: ([GHError])
            _tlIoperatorTable_collect :: (OperatorTable)
            _tlIself :: (Patterns)
            _tlOoperatorTable :: (OperatorTable)
            _tlOoperatorTable_collect :: (OperatorTable)
            ( _hdIerrors,_hdIflatten,_hdIoperatorTable_collect,_hdIself) =
                (hd_ (_hdOoperatorTable) (_hdOoperatorTable_collect))
            ( _tlIerrors,_tlIoperatorTable_collect,_tlIself) =
                (tl_ (_tlOoperatorTable) (_tlOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _hdIerrors ++ _tlIerrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _tlIoperatorTable_collect
            -- copy rule (down)
            (_hdOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_hdOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_tlOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_tlOoperatorTable_collect@_) =
                _hdIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Patterns_Nil :: (T_Patterns)
sem_Patterns_Nil  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Patterns)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- Position ----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Position.Position:
      self

-}
{-
   local variables for Position.Unknown:
      self

-}
-- semantic domain
type T_Position = ( (Position))
-- cata
sem_Position :: (Position) ->
                (T_Position)
sem_Position ((Position_Position (_filename) (_line) (_column))) =
    (sem_Position_Position (_filename) (_line) (_column))
sem_Position ((Position_Unknown )) =
    (sem_Position_Unknown )
sem_Position_Position :: (String) ->
                         (Int) ->
                         (Int) ->
                         (T_Position)
sem_Position_Position (filename_) (line_) (column_) =
    let _lhsOself :: (Position)
        -- self rule
        (_self@_) =
            Position_Position filename_ line_ column_
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Position_Unknown :: (T_Position)
sem_Position_Unknown  =
    let _lhsOself :: (Position)
        -- self rule
        (_self@_) =
            Position_Unknown
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- Qualifier ---------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for Qualifier.Empty:
      self

-}
{-
   local variables for Qualifier.Generator:
      self

-}
{-
   local variables for Qualifier.Guard:
      self

-}
{-
   local variables for Qualifier.Let:
      self

-}
-- semantic domain
type T_Qualifier = (OperatorTable) ->
                   (OperatorTable) ->
                   ( ([GHError]),(OperatorTable),(Qualifier))
-- cata
sem_Qualifier :: (Qualifier) ->
                 (T_Qualifier)
sem_Qualifier ((Qualifier_Empty (_range))) =
    (sem_Qualifier_Empty ((sem_Range (_range))))
sem_Qualifier ((Qualifier_Generator (_range) (_pattern) (_expression))) =
    (sem_Qualifier_Generator ((sem_Range (_range))) ((sem_Pattern (_pattern))) ((sem_Expression (_expression))))
sem_Qualifier ((Qualifier_Guard (_range) (_guard))) =
    (sem_Qualifier_Guard ((sem_Range (_range))) ((sem_Expression (_guard))))
sem_Qualifier ((Qualifier_Let (_range) (_declarations))) =
    (sem_Qualifier_Let ((sem_Range (_range))) ((sem_Declarations (_declarations))))
sem_Qualifier_Empty :: (T_Range) ->
                       (T_Qualifier)
sem_Qualifier_Empty (range_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Qualifier)
            _rangeIself :: (Range)
            ( _rangeIself) =
                (range_ )
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                Qualifier_Empty _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Qualifier_Generator :: (T_Range) ->
                           (T_Pattern) ->
                           (T_Expression) ->
                           (T_Qualifier)
sem_Qualifier_Generator (range_) (pattern_) (expression_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Qualifier)
            _rangeIself :: (Range)
            _patternIerrors :: ([GHError])
            _patternIflatten :: ([FlatPattern])
            _patternIoperatorTable_collect :: (OperatorTable)
            _patternIself :: (Pattern)
            _patternOoperatorTable :: (OperatorTable)
            _patternOoperatorTable_collect :: (OperatorTable)
            _expressionIerrors :: ([GHError])
            _expressionIflatten :: ([FlatExpression])
            _expressionIoperatorTable_collect :: (OperatorTable)
            _expressionIself :: (Expression)
            _expressionOoperatorTable :: (OperatorTable)
            _expressionOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _patternIerrors,_patternIflatten,_patternIoperatorTable_collect,_patternIself) =
                (pattern_ (_patternOoperatorTable) (_patternOoperatorTable_collect))
            ( _expressionIerrors,_expressionIflatten,_expressionIoperatorTable_collect,_expressionIself) =
                (expression_ (_expressionOoperatorTable) (_expressionOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _patternIerrors ++ _expressionIerrors
            -- self rule
            (_self@_) =
                Qualifier_Generator _rangeIself _patternIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _expressionIoperatorTable_collect
            -- copy rule (down)
            (_patternOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_patternOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_expressionOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_expressionOoperatorTable_collect@_) =
                _patternIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Qualifier_Guard :: (T_Range) ->
                       (T_Expression) ->
                       (T_Qualifier)
sem_Qualifier_Guard (range_) (guard_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Qualifier)
            _rangeIself :: (Range)
            _guardIerrors :: ([GHError])
            _guardIflatten :: ([FlatExpression])
            _guardIoperatorTable_collect :: (OperatorTable)
            _guardIself :: (Expression)
            _guardOoperatorTable :: (OperatorTable)
            _guardOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _guardIerrors,_guardIflatten,_guardIoperatorTable_collect,_guardIself) =
                (guard_ (_guardOoperatorTable) (_guardOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _guardIerrors
            -- self rule
            (_self@_) =
                Qualifier_Guard _rangeIself _guardIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _guardIoperatorTable_collect
            -- copy rule (down)
            (_guardOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_guardOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Qualifier_Let :: (T_Range) ->
                     (T_Declarations) ->
                     (T_Qualifier)
sem_Qualifier_Let (range_) (declarations_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Qualifier)
            _rangeIself :: (Range)
            _declarationsIerrors :: ([GHError])
            _declarationsIoperatorTable_collect :: (OperatorTable)
            _declarationsIself :: (Declarations)
            _declarationsOoperatorTable :: (OperatorTable)
            _declarationsOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _declarationsIerrors,_declarationsIoperatorTable_collect,_declarationsIself) =
                (declarations_ (_declarationsOoperatorTable) (_declarationsOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 217, column 9)
            (_declarationsOoperatorTable@_) =
                mergeFM
                  _declarationsIoperatorTable_collect
                  _lhsIoperatorTable
            -- use rule
            (_lhsOerrors@_) =
                _declarationsIerrors
            -- self rule
            (_self@_) =
                Qualifier_Let _rangeIself _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _declarationsIoperatorTable_collect
            -- copy rule (down)
            (_declarationsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- Qualifiers --------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for Qualifiers.Cons:
      self

-}
{-
   local variables for Qualifiers.Nil:
      self

-}
-- semantic domain
type T_Qualifiers = (OperatorTable) ->
                    (OperatorTable) ->
                    ( ([GHError]),(OperatorTable),(Qualifiers))
-- cata
sem_Qualifiers :: (Qualifiers) ->
                  (T_Qualifiers)
sem_Qualifiers (list) =
    (foldr (sem_Qualifiers_Cons) (sem_Qualifiers_Nil) ((map sem_Qualifier list)))
sem_Qualifiers_Cons :: (T_Qualifier) ->
                       (T_Qualifiers) ->
                       (T_Qualifiers)
sem_Qualifiers_Cons (hd_) (tl_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Qualifiers)
            _hdIerrors :: ([GHError])
            _hdIoperatorTable_collect :: (OperatorTable)
            _hdIself :: (Qualifier)
            _hdOoperatorTable :: (OperatorTable)
            _hdOoperatorTable_collect :: (OperatorTable)
            _tlIerrors :: ([GHError])
            _tlIoperatorTable_collect :: (OperatorTable)
            _tlIself :: (Qualifiers)
            _tlOoperatorTable :: (OperatorTable)
            _tlOoperatorTable_collect :: (OperatorTable)
            ( _hdIerrors,_hdIoperatorTable_collect,_hdIself) =
                (hd_ (_hdOoperatorTable) (_hdOoperatorTable_collect))
            ( _tlIerrors,_tlIoperatorTable_collect,_tlIself) =
                (tl_ (_tlOoperatorTable) (_tlOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 213, column 9)
            (_lhsOoperatorTable_collect@_) =
                _tlIoperatorTable_collect
            -- "ResolveOperators.lag"(line 210, column 9)
            (_tlOoperatorTable@_) =
                mergeFM
                  _hdIoperatorTable_collect
                  _lhsIoperatorTable
            -- "ResolveOperators.lag"(line 209, column 9)
            (_hdOoperatorTable_collect@_) =
                emptyFM
            -- use rule
            (_lhsOerrors@_) =
                _hdIerrors ++ _tlIerrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_hdOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_tlOoperatorTable_collect@_) =
                _hdIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Qualifiers_Nil :: (T_Qualifiers)
sem_Qualifiers_Nil  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Qualifiers)
            -- "ResolveOperators.lag"(line 206, column 9)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- Range -------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Range.Range:
      self

-}
-- semantic domain
type T_Range = ( (Range))
-- cata
sem_Range :: (Range) ->
             (T_Range)
sem_Range ((Range_Range (_start) (_stop))) =
    (sem_Range_Range ((sem_Position (_start))) ((sem_Position (_stop))))
sem_Range_Range :: (T_Position) ->
                   (T_Position) ->
                   (T_Range)
sem_Range_Range (start_) (stop_) =
    let _lhsOself :: (Range)
        _startIself :: (Position)
        _stopIself :: (Position)
        ( _startIself) =
            (start_ )
        ( _stopIself) =
            (stop_ )
        -- self rule
        (_self@_) =
            Range_Range _startIself _stopIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- Reassignment ------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for Reassignment.Reassignment:
      self

-}
-- semantic domain
type T_Reassignment = (OperatorTable) ->
                      (OperatorTable) ->
                      ( ([GHError]),(OperatorTable),(Reassignment))
-- cata
sem_Reassignment :: (Reassignment) ->
                    (T_Reassignment)
sem_Reassignment ((Reassignment_Reassignment (_range) (_name) (_as))) =
    (sem_Reassignment_Reassignment ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Name (_as))))
sem_Reassignment_Reassignment :: (T_Range) ->
                                 (T_Name) ->
                                 (T_Name) ->
                                 (T_Reassignment)
sem_Reassignment_Reassignment (range_) (name_) (as_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Reassignment)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _asIerrors :: ([GHError])
            _asIoperatorTable_collect :: (OperatorTable)
            _asIself :: (Name)
            _asOoperatorTable :: (OperatorTable)
            _asOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _asIerrors,_asIoperatorTable_collect,_asIself) =
                (as_ (_asOoperatorTable) (_asOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _asIerrors
            -- self rule
            (_self@_) =
                Reassignment_Reassignment _rangeIself _nameIself _asIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _asIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_asOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_asOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- Reassignments -----------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for Reassignments.Cons:
      self

-}
{-
   local variables for Reassignments.Nil:
      self

-}
-- semantic domain
type T_Reassignments = (OperatorTable) ->
                       (OperatorTable) ->
                       ( ([GHError]),(OperatorTable),(Reassignments))
-- cata
sem_Reassignments :: (Reassignments) ->
                     (T_Reassignments)
sem_Reassignments (list) =
    (foldr (sem_Reassignments_Cons) (sem_Reassignments_Nil) ((map sem_Reassignment list)))
sem_Reassignments_Cons :: (T_Reassignment) ->
                          (T_Reassignments) ->
                          (T_Reassignments)
sem_Reassignments_Cons (hd_) (tl_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Reassignments)
            _hdIerrors :: ([GHError])
            _hdIoperatorTable_collect :: (OperatorTable)
            _hdIself :: (Reassignment)
            _hdOoperatorTable :: (OperatorTable)
            _hdOoperatorTable_collect :: (OperatorTable)
            _tlIerrors :: ([GHError])
            _tlIoperatorTable_collect :: (OperatorTable)
            _tlIself :: (Reassignments)
            _tlOoperatorTable :: (OperatorTable)
            _tlOoperatorTable_collect :: (OperatorTable)
            ( _hdIerrors,_hdIoperatorTable_collect,_hdIself) =
                (hd_ (_hdOoperatorTable) (_hdOoperatorTable_collect))
            ( _tlIerrors,_tlIoperatorTable_collect,_tlIself) =
                (tl_ (_tlOoperatorTable) (_tlOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _hdIerrors ++ _tlIerrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _tlIoperatorTable_collect
            -- copy rule (down)
            (_hdOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_hdOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_tlOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_tlOoperatorTable_collect@_) =
                _hdIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Reassignments_Nil :: (T_Reassignments)
sem_Reassignments_Nil  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Reassignments)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- RecordExpressionBinding -------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for RecordExpressionBinding.RecordExpressionBinding:
      self

-}
-- semantic domain
type T_RecordExpressionBinding = (OperatorTable) ->
                                 (OperatorTable) ->
                                 ( ([GHError]),(OperatorTable),(RecordExpressionBinding))
-- cata
sem_RecordExpressionBinding :: (RecordExpressionBinding) ->
                               (T_RecordExpressionBinding)
sem_RecordExpressionBinding ((RecordExpressionBinding_RecordExpressionBinding (_range) (_name) (_expression))) =
    (sem_RecordExpressionBinding_RecordExpressionBinding ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Expression (_expression))))
sem_RecordExpressionBinding_RecordExpressionBinding :: (T_Range) ->
                                                       (T_Name) ->
                                                       (T_Expression) ->
                                                       (T_RecordExpressionBinding)
sem_RecordExpressionBinding_RecordExpressionBinding (range_) (name_) (expression_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (RecordExpressionBinding)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _expressionIerrors :: ([GHError])
            _expressionIflatten :: ([FlatExpression])
            _expressionIoperatorTable_collect :: (OperatorTable)
            _expressionIself :: (Expression)
            _expressionOoperatorTable :: (OperatorTable)
            _expressionOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _expressionIerrors,_expressionIflatten,_expressionIoperatorTable_collect,_expressionIself) =
                (expression_ (_expressionOoperatorTable) (_expressionOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _expressionIerrors
            -- self rule
            (_self@_) =
                RecordExpressionBinding_RecordExpressionBinding _rangeIself _nameIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _expressionIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_expressionOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_expressionOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- RecordExpressionBindings ------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for RecordExpressionBindings.Cons:
      self

-}
{-
   local variables for RecordExpressionBindings.Nil:
      self

-}
-- semantic domain
type T_RecordExpressionBindings = (OperatorTable) ->
                                  (OperatorTable) ->
                                  ( ([GHError]),(OperatorTable),(RecordExpressionBindings))
-- cata
sem_RecordExpressionBindings :: (RecordExpressionBindings) ->
                                (T_RecordExpressionBindings)
sem_RecordExpressionBindings (list) =
    (foldr (sem_RecordExpressionBindings_Cons) (sem_RecordExpressionBindings_Nil) ((map sem_RecordExpressionBinding list)))
sem_RecordExpressionBindings_Cons :: (T_RecordExpressionBinding) ->
                                     (T_RecordExpressionBindings) ->
                                     (T_RecordExpressionBindings)
sem_RecordExpressionBindings_Cons (hd_) (tl_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (RecordExpressionBindings)
            _hdIerrors :: ([GHError])
            _hdIoperatorTable_collect :: (OperatorTable)
            _hdIself :: (RecordExpressionBinding)
            _hdOoperatorTable :: (OperatorTable)
            _hdOoperatorTable_collect :: (OperatorTable)
            _tlIerrors :: ([GHError])
            _tlIoperatorTable_collect :: (OperatorTable)
            _tlIself :: (RecordExpressionBindings)
            _tlOoperatorTable :: (OperatorTable)
            _tlOoperatorTable_collect :: (OperatorTable)
            ( _hdIerrors,_hdIoperatorTable_collect,_hdIself) =
                (hd_ (_hdOoperatorTable) (_hdOoperatorTable_collect))
            ( _tlIerrors,_tlIoperatorTable_collect,_tlIself) =
                (tl_ (_tlOoperatorTable) (_tlOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _hdIerrors ++ _tlIerrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _tlIoperatorTable_collect
            -- copy rule (down)
            (_hdOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_hdOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_tlOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_tlOoperatorTable_collect@_) =
                _hdIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_RecordExpressionBindings_Nil :: (T_RecordExpressionBindings)
sem_RecordExpressionBindings_Nil  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (RecordExpressionBindings)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- RecordPatternBinding ----------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for RecordPatternBinding.RecordPatternBinding:
      self

-}
-- semantic domain
type T_RecordPatternBinding = (OperatorTable) ->
                              (OperatorTable) ->
                              ( ([GHError]),(OperatorTable),(RecordPatternBinding))
-- cata
sem_RecordPatternBinding :: (RecordPatternBinding) ->
                            (T_RecordPatternBinding)
sem_RecordPatternBinding ((RecordPatternBinding_RecordPatternBinding (_range) (_name) (_pattern))) =
    (sem_RecordPatternBinding_RecordPatternBinding ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Pattern (_pattern))))
sem_RecordPatternBinding_RecordPatternBinding :: (T_Range) ->
                                                 (T_Name) ->
                                                 (T_Pattern) ->
                                                 (T_RecordPatternBinding)
sem_RecordPatternBinding_RecordPatternBinding (range_) (name_) (pattern_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (RecordPatternBinding)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _patternIerrors :: ([GHError])
            _patternIflatten :: ([FlatPattern])
            _patternIoperatorTable_collect :: (OperatorTable)
            _patternIself :: (Pattern)
            _patternOoperatorTable :: (OperatorTable)
            _patternOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _patternIerrors,_patternIflatten,_patternIoperatorTable_collect,_patternIself) =
                (pattern_ (_patternOoperatorTable) (_patternOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _patternIerrors
            -- self rule
            (_self@_) =
                RecordPatternBinding_RecordPatternBinding _rangeIself _nameIself _patternIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _patternIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_patternOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_patternOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- RecordPatternBindings ---------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for RecordPatternBindings.Cons:
      self

-}
{-
   local variables for RecordPatternBindings.Nil:
      self

-}
-- semantic domain
type T_RecordPatternBindings = (OperatorTable) ->
                               (OperatorTable) ->
                               ( ([GHError]),(OperatorTable),(RecordPatternBindings))
-- cata
sem_RecordPatternBindings :: (RecordPatternBindings) ->
                             (T_RecordPatternBindings)
sem_RecordPatternBindings (list) =
    (foldr (sem_RecordPatternBindings_Cons) (sem_RecordPatternBindings_Nil) ((map sem_RecordPatternBinding list)))
sem_RecordPatternBindings_Cons :: (T_RecordPatternBinding) ->
                                  (T_RecordPatternBindings) ->
                                  (T_RecordPatternBindings)
sem_RecordPatternBindings_Cons (hd_) (tl_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (RecordPatternBindings)
            _hdIerrors :: ([GHError])
            _hdIoperatorTable_collect :: (OperatorTable)
            _hdIself :: (RecordPatternBinding)
            _hdOoperatorTable :: (OperatorTable)
            _hdOoperatorTable_collect :: (OperatorTable)
            _tlIerrors :: ([GHError])
            _tlIoperatorTable_collect :: (OperatorTable)
            _tlIself :: (RecordPatternBindings)
            _tlOoperatorTable :: (OperatorTable)
            _tlOoperatorTable_collect :: (OperatorTable)
            ( _hdIerrors,_hdIoperatorTable_collect,_hdIself) =
                (hd_ (_hdOoperatorTable) (_hdOoperatorTable_collect))
            ( _tlIerrors,_tlIoperatorTable_collect,_tlIself) =
                (tl_ (_tlOoperatorTable) (_tlOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _hdIerrors ++ _tlIerrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _tlIoperatorTable_collect
            -- copy rule (down)
            (_hdOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_hdOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_tlOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_tlOoperatorTable_collect@_) =
                _hdIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_RecordPatternBindings_Nil :: (T_RecordPatternBindings)
sem_RecordPatternBindings_Nil  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (RecordPatternBindings)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- RightHandSide -----------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for RightHandSide.Expression:
      operatorTable
      self

-}
{-
   local variables for RightHandSide.Guarded:
      operatorTable
      self

-}
-- semantic domain
type T_RightHandSide = (OperatorTable) ->
                       (OperatorTable) ->
                       ( ([GHError]),(OperatorTable),(RightHandSide))
-- cata
sem_RightHandSide :: (RightHandSide) ->
                     (T_RightHandSide)
sem_RightHandSide ((RightHandSide_Expression (_range) (_expression) (_where))) =
    (sem_RightHandSide_Expression ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_MaybeDeclarations (_where))))
sem_RightHandSide ((RightHandSide_Guarded (_range) (_guardedexpressions) (_where))) =
    (sem_RightHandSide_Guarded ((sem_Range (_range))) ((sem_GuardedExpressions (_guardedexpressions))) ((sem_MaybeDeclarations (_where))))
sem_RightHandSide_Expression :: (T_Range) ->
                                (T_Expression) ->
                                (T_MaybeDeclarations) ->
                                (T_RightHandSide)
sem_RightHandSide_Expression (range_) (expression_) (where_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (RightHandSide)
            _rangeIself :: (Range)
            _expressionIerrors :: ([GHError])
            _expressionIflatten :: ([FlatExpression])
            _expressionIoperatorTable_collect :: (OperatorTable)
            _expressionIself :: (Expression)
            _expressionOoperatorTable :: (OperatorTable)
            _expressionOoperatorTable_collect :: (OperatorTable)
            _whereIerrors :: ([GHError])
            _whereIoperatorTable_collect :: (OperatorTable)
            _whereIself :: (MaybeDeclarations)
            _whereOoperatorTable :: (OperatorTable)
            _whereOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _expressionIerrors,_expressionIflatten,_expressionIoperatorTable_collect,_expressionIself) =
                (expression_ (_expressionOoperatorTable) (_expressionOoperatorTable_collect))
            ( _whereIerrors,_whereIoperatorTable_collect,_whereIself) =
                (where_ (_whereOoperatorTable) (_whereOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 227, column 9)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- "ResolveOperators.lag"(line 224, column 9)
            (_operatorTable@_) =
                mergeFM
                  _whereIoperatorTable_collect
                  _lhsIoperatorTable
            -- "ResolveOperators.lag"(line 223, column 9)
            (_whereOoperatorTable_collect@_) =
                emptyFM
            -- use rule
            (_lhsOerrors@_) =
                _expressionIerrors ++ _whereIerrors
            -- self rule
            (_self@_) =
                RightHandSide_Expression _rangeIself _expressionIself _whereIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_expressionOoperatorTable@_) =
                _operatorTable
            -- copy rule (down)
            (_expressionOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (chain)
            (_whereOoperatorTable@_) =
                _operatorTable
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_RightHandSide_Guarded :: (T_Range) ->
                             (T_GuardedExpressions) ->
                             (T_MaybeDeclarations) ->
                             (T_RightHandSide)
sem_RightHandSide_Guarded (range_) (guardedexpressions_) (where_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (RightHandSide)
            _rangeIself :: (Range)
            _guardedexpressionsIerrors :: ([GHError])
            _guardedexpressionsIoperatorTable_collect :: (OperatorTable)
            _guardedexpressionsIself :: (GuardedExpressions)
            _guardedexpressionsOoperatorTable :: (OperatorTable)
            _guardedexpressionsOoperatorTable_collect :: (OperatorTable)
            _whereIerrors :: ([GHError])
            _whereIoperatorTable_collect :: (OperatorTable)
            _whereIself :: (MaybeDeclarations)
            _whereOoperatorTable :: (OperatorTable)
            _whereOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _guardedexpressionsIerrors,_guardedexpressionsIoperatorTable_collect,_guardedexpressionsIself) =
                (guardedexpressions_ (_guardedexpressionsOoperatorTable) (_guardedexpressionsOoperatorTable_collect))
            ( _whereIerrors,_whereIoperatorTable_collect,_whereIself) =
                (where_ (_whereOoperatorTable) (_whereOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 234, column 9)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- "ResolveOperators.lag"(line 231, column 9)
            (_operatorTable@_) =
                mergeFM
                  _whereIoperatorTable_collect
                  _lhsIoperatorTable
            -- "ResolveOperators.lag"(line 230, column 9)
            (_whereOoperatorTable_collect@_) =
                emptyFM
            -- use rule
            (_lhsOerrors@_) =
                _guardedexpressionsIerrors ++ _whereIerrors
            -- self rule
            (_self@_) =
                RightHandSide_Guarded _rangeIself _guardedexpressionsIself _whereIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_guardedexpressionsOoperatorTable@_) =
                _operatorTable
            -- copy rule (down)
            (_guardedexpressionsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (chain)
            (_whereOoperatorTable@_) =
                _operatorTable
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- Root --------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      out                  : (ModuleSystem,Bool,Doc)
      self                 : SELF

-}
{-
   local variables for Root.Root:
      self

-}
-- semantic domain
type T_Root = ( ((ModuleSystem,Bool,Doc)),(Root))
-- cata
sem_Root :: (Root) ->
            (T_Root)
sem_Root ((Root_Root (_contents))) =
    (sem_Root_Root ((sem_ModuleSystem (_contents))))
sem_Root_Root :: (T_ModuleSystem) ->
                 (T_Root)
sem_Root_Root (contents_) =
    let _lhsOout :: ((ModuleSystem,Bool,Doc))
        _lhsOself :: (Root)
        _contentsIerrors :: ([GHError])
        _contentsIoperatorTable_collect :: (OperatorTable)
        _contentsIself :: (ModuleSystem)
        _contentsOoperatorTable :: (OperatorTable)
        _contentsOoperatorTable_collect :: (OperatorTable)
        ( _contentsIerrors,_contentsIoperatorTable_collect,_contentsIself) =
            (contents_ (_contentsOoperatorTable) (_contentsOoperatorTable_collect))
        -- "ResolveOperators.lag"(line 91, column 9)
        (_lhsOout@_) =
            (_contentsIself
            ,any isError _contentsIerrors
            ,printErrors _contentsIerrors
            )
        -- "ResolveOperators.lag"(line 127, column 9)
        (_contentsOoperatorTable@_) =
            emptyFM
        -- "ResolveOperators.lag"(line 126, column 9)
        (_contentsOoperatorTable_collect@_) =
            emptyFM
        -- self rule
        (_self@_) =
            Root_Root _contentsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOout,_lhsOself)
-- SimpleType --------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for SimpleType.SimpleType:
      self

-}
-- semantic domain
type T_SimpleType = (OperatorTable) ->
                    (OperatorTable) ->
                    ( ([GHError]),(OperatorTable),(SimpleType))
-- cata
sem_SimpleType :: (SimpleType) ->
                  (T_SimpleType)
sem_SimpleType ((SimpleType_SimpleType (_range) (_name) (_typevariables))) =
    (sem_SimpleType_SimpleType ((sem_Range (_range))) ((sem_Name (_name))) ((sem_KindAnnotatedNames (_typevariables))))
sem_SimpleType_SimpleType :: (T_Range) ->
                             (T_Name) ->
                             (T_KindAnnotatedNames) ->
                             (T_SimpleType)
sem_SimpleType_SimpleType (range_) (name_) (typevariables_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (SimpleType)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _typevariablesIerrors :: ([GHError])
            _typevariablesIoperatorTable_collect :: (OperatorTable)
            _typevariablesIself :: (KindAnnotatedNames)
            _typevariablesOoperatorTable :: (OperatorTable)
            _typevariablesOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _typevariablesIerrors,_typevariablesIoperatorTable_collect,_typevariablesIself) =
                (typevariables_ (_typevariablesOoperatorTable) (_typevariablesOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _typevariablesIerrors
            -- self rule
            (_self@_) =
                SimpleType_SimpleType _rangeIself _nameIself _typevariablesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _typevariablesIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_typevariablesOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_typevariablesOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- Statement ---------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for Statement.Empty:
      self

-}
{-
   local variables for Statement.Expression:
      self

-}
{-
   local variables for Statement.Generator:
      self

-}
{-
   local variables for Statement.Let:
      self

-}
-- semantic domain
type T_Statement = (OperatorTable) ->
                   (OperatorTable) ->
                   ( ([GHError]),(OperatorTable),(Statement))
-- cata
sem_Statement :: (Statement) ->
                 (T_Statement)
sem_Statement ((Statement_Empty (_range))) =
    (sem_Statement_Empty ((sem_Range (_range))))
sem_Statement ((Statement_Expression (_range) (_expression))) =
    (sem_Statement_Expression ((sem_Range (_range))) ((sem_Expression (_expression))))
sem_Statement ((Statement_Generator (_range) (_pattern) (_expression))) =
    (sem_Statement_Generator ((sem_Range (_range))) ((sem_Pattern (_pattern))) ((sem_Expression (_expression))))
sem_Statement ((Statement_Let (_range) (_declarations))) =
    (sem_Statement_Let ((sem_Range (_range))) ((sem_Declarations (_declarations))))
sem_Statement_Empty :: (T_Range) ->
                       (T_Statement)
sem_Statement_Empty (range_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Statement)
            _rangeIself :: (Range)
            ( _rangeIself) =
                (range_ )
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                Statement_Empty _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Statement_Expression :: (T_Range) ->
                            (T_Expression) ->
                            (T_Statement)
sem_Statement_Expression (range_) (expression_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Statement)
            _rangeIself :: (Range)
            _expressionIerrors :: ([GHError])
            _expressionIflatten :: ([FlatExpression])
            _expressionIoperatorTable_collect :: (OperatorTable)
            _expressionIself :: (Expression)
            _expressionOoperatorTable :: (OperatorTable)
            _expressionOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _expressionIerrors,_expressionIflatten,_expressionIoperatorTable_collect,_expressionIself) =
                (expression_ (_expressionOoperatorTable) (_expressionOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _expressionIerrors
            -- self rule
            (_self@_) =
                Statement_Expression _rangeIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _expressionIoperatorTable_collect
            -- copy rule (down)
            (_expressionOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_expressionOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Statement_Generator :: (T_Range) ->
                           (T_Pattern) ->
                           (T_Expression) ->
                           (T_Statement)
sem_Statement_Generator (range_) (pattern_) (expression_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Statement)
            _rangeIself :: (Range)
            _patternIerrors :: ([GHError])
            _patternIflatten :: ([FlatPattern])
            _patternIoperatorTable_collect :: (OperatorTable)
            _patternIself :: (Pattern)
            _patternOoperatorTable :: (OperatorTable)
            _patternOoperatorTable_collect :: (OperatorTable)
            _expressionIerrors :: ([GHError])
            _expressionIflatten :: ([FlatExpression])
            _expressionIoperatorTable_collect :: (OperatorTable)
            _expressionIself :: (Expression)
            _expressionOoperatorTable :: (OperatorTable)
            _expressionOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _patternIerrors,_patternIflatten,_patternIoperatorTable_collect,_patternIself) =
                (pattern_ (_patternOoperatorTable) (_patternOoperatorTable_collect))
            ( _expressionIerrors,_expressionIflatten,_expressionIoperatorTable_collect,_expressionIself) =
                (expression_ (_expressionOoperatorTable) (_expressionOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _patternIerrors ++ _expressionIerrors
            -- self rule
            (_self@_) =
                Statement_Generator _rangeIself _patternIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _expressionIoperatorTable_collect
            -- copy rule (down)
            (_patternOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_patternOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_expressionOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_expressionOoperatorTable_collect@_) =
                _patternIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Statement_Let :: (T_Range) ->
                     (T_Declarations) ->
                     (T_Statement)
sem_Statement_Let (range_) (declarations_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Statement)
            _rangeIself :: (Range)
            _declarationsIerrors :: ([GHError])
            _declarationsIoperatorTable_collect :: (OperatorTable)
            _declarationsIself :: (Declarations)
            _declarationsOoperatorTable :: (OperatorTable)
            _declarationsOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _declarationsIerrors,_declarationsIoperatorTable_collect,_declarationsIself) =
                (declarations_ (_declarationsOoperatorTable) (_declarationsOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 200, column 9)
            (_declarationsOoperatorTable@_) =
                mergeFM
                  _declarationsIoperatorTable_collect
                  _lhsIoperatorTable
            -- use rule
            (_lhsOerrors@_) =
                _declarationsIerrors
            -- self rule
            (_self@_) =
                Statement_Let _rangeIself _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _declarationsIoperatorTable_collect
            -- copy rule (down)
            (_declarationsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- Statements --------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for Statements.Cons:
      self

-}
{-
   local variables for Statements.Nil:
      self

-}
-- semantic domain
type T_Statements = (OperatorTable) ->
                    (OperatorTable) ->
                    ( ([GHError]),(OperatorTable),(Statements))
-- cata
sem_Statements :: (Statements) ->
                  (T_Statements)
sem_Statements (list) =
    (foldr (sem_Statements_Cons) (sem_Statements_Nil) ((map sem_Statement list)))
sem_Statements_Cons :: (T_Statement) ->
                       (T_Statements) ->
                       (T_Statements)
sem_Statements_Cons (hd_) (tl_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Statements)
            _hdIerrors :: ([GHError])
            _hdIoperatorTable_collect :: (OperatorTable)
            _hdIself :: (Statement)
            _hdOoperatorTable :: (OperatorTable)
            _hdOoperatorTable_collect :: (OperatorTable)
            _tlIerrors :: ([GHError])
            _tlIoperatorTable_collect :: (OperatorTable)
            _tlIself :: (Statements)
            _tlOoperatorTable :: (OperatorTable)
            _tlOoperatorTable_collect :: (OperatorTable)
            ( _hdIerrors,_hdIoperatorTable_collect,_hdIself) =
                (hd_ (_hdOoperatorTable) (_hdOoperatorTable_collect))
            ( _tlIerrors,_tlIoperatorTable_collect,_tlIself) =
                (tl_ (_tlOoperatorTable) (_tlOoperatorTable_collect))
            -- "ResolveOperators.lag"(line 196, column 9)
            (_lhsOoperatorTable_collect@_) =
                _tlIoperatorTable_collect
            -- "ResolveOperators.lag"(line 193, column 9)
            (_tlOoperatorTable@_) =
                mergeFM
                  _hdIoperatorTable_collect
                  _lhsIoperatorTable
            -- "ResolveOperators.lag"(line 192, column 9)
            (_hdOoperatorTable_collect@_) =
                emptyFM
            -- use rule
            (_lhsOerrors@_) =
                _hdIerrors ++ _tlIerrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_hdOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_tlOoperatorTable_collect@_) =
                _hdIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Statements_Nil :: (T_Statements)
sem_Statements_Nil  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Statements)
            -- "ResolveOperators.lag"(line 189, column 9)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- Strings -----------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for Strings.Cons:
      self

-}
{-
   local variables for Strings.Nil:
      self

-}
-- semantic domain
type T_Strings = (OperatorTable) ->
                 (OperatorTable) ->
                 ( ([GHError]),(OperatorTable),(Strings))
-- cata
sem_Strings :: (Strings) ->
               (T_Strings)
sem_Strings (list) =
    (foldr (sem_Strings_Cons) (sem_Strings_Nil) (list))
sem_Strings_Cons :: (String) ->
                    (T_Strings) ->
                    (T_Strings)
sem_Strings_Cons (hd_) (tl_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Strings)
            _tlIerrors :: ([GHError])
            _tlIoperatorTable_collect :: (OperatorTable)
            _tlIself :: (Strings)
            _tlOoperatorTable :: (OperatorTable)
            _tlOoperatorTable_collect :: (OperatorTable)
            ( _tlIerrors,_tlIoperatorTable_collect,_tlIself) =
                (tl_ (_tlOoperatorTable) (_tlOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _tlIerrors
            -- self rule
            (_self@_) =
                (:) hd_ _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _tlIoperatorTable_collect
            -- copy rule (down)
            (_tlOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_tlOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Strings_Nil :: (T_Strings)
sem_Strings_Nil  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Strings)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- Type --------------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for Type.Application:
      self

-}
{-
   local variables for Type.Con:
      self

-}
{-
   local variables for Type.Constructor:
      self

-}
{-
   local variables for Type.ConstructorCase:
      self

-}
{-
   local variables for Type.Exists:
      self

-}
{-
   local variables for Type.Forall:
      self

-}
{-
   local variables for Type.KindApplication:
      self

-}
{-
   local variables for Type.KindStarCase:
      self

-}
{-
   local variables for Type.Kinded:
      self

-}
{-
   local variables for Type.Label:
      self

-}
{-
   local variables for Type.Parenthesized:
      self

-}
{-
   local variables for Type.Qualified:
      self

-}
{-
   local variables for Type.TypeApplication:
      self

-}
{-
   local variables for Type.TypeSignature:
      self

-}
{-
   local variables for Type.Variable:
      self

-}
-- semantic domain
type T_Type = (OperatorTable) ->
              (OperatorTable) ->
              ( ([GHError]),(OperatorTable),(Type))
-- cata
sem_Type :: (Type) ->
            (T_Type)
sem_Type ((Type_Application (_range) (_prefix) (_function) (_arguments))) =
    (sem_Type_Application ((sem_Range (_range))) (_prefix) ((sem_Type (_function))) ((sem_Types (_arguments))))
sem_Type ((Type_Con (_range) (_name))) =
    (sem_Type_Con ((sem_Range (_range))) ((sem_Name (_name))))
sem_Type ((Type_Constructor (_range) (_name))) =
    (sem_Type_Constructor ((sem_Range (_range))) ((sem_Name (_name))))
sem_Type ((Type_ConstructorCase (_range) (_name))) =
    (sem_Type_ConstructorCase ((sem_Range (_range))) ((sem_Name (_name))))
sem_Type ((Type_Exists (_range) (_typevariables) (_type))) =
    (sem_Type_Exists ((sem_Range (_range))) ((sem_Names (_typevariables))) ((sem_Type (_type))))
sem_Type ((Type_Forall (_range) (_typevariables) (_type))) =
    (sem_Type_Forall ((sem_Range (_range))) ((sem_Names (_typevariables))) ((sem_Type (_type))))
sem_Type ((Type_KindApplication (_range) (_name) (_kind))) =
    (sem_Type_KindApplication ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Kind (_kind))))
sem_Type ((Type_KindStarCase (_range))) =
    (sem_Type_KindStarCase ((sem_Range (_range))))
sem_Type ((Type_Kinded (_range) (_name) (_kind))) =
    (sem_Type_Kinded ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Kind (_kind))))
sem_Type ((Type_Label (_range) (_name))) =
    (sem_Type_Label ((sem_Range (_range))) ((sem_Name (_name))))
sem_Type ((Type_Parenthesized (_range) (_type))) =
    (sem_Type_Parenthesized ((sem_Range (_range))) ((sem_Type (_type))))
sem_Type ((Type_Qualified (_range) (_context) (_type))) =
    (sem_Type_Qualified ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_Type (_type))))
sem_Type ((Type_TypeApplication (_range) (_name) (_type))) =
    (sem_Type_TypeApplication ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Type (_type))))
sem_Type ((Type_TypeSignature (_range) (_generics) (_parametrics))) =
    (sem_Type_TypeSignature ((sem_Range (_range))) ((sem_KindAnnotatedNames (_generics))) ((sem_Types (_parametrics))))
sem_Type ((Type_Variable (_range) (_name))) =
    (sem_Type_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Type_Application :: (T_Range) ->
                        (Bool) ->
                        (T_Type) ->
                        (T_Types) ->
                        (T_Type)
sem_Type_Application (range_) (prefix_) (function_) (arguments_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _functionIerrors :: ([GHError])
            _functionIoperatorTable_collect :: (OperatorTable)
            _functionIself :: (Type)
            _functionOoperatorTable :: (OperatorTable)
            _functionOoperatorTable_collect :: (OperatorTable)
            _argumentsIerrors :: ([GHError])
            _argumentsIoperatorTable_collect :: (OperatorTable)
            _argumentsIself :: (Types)
            _argumentsOoperatorTable :: (OperatorTable)
            _argumentsOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _functionIerrors,_functionIoperatorTable_collect,_functionIself) =
                (function_ (_functionOoperatorTable) (_functionOoperatorTable_collect))
            ( _argumentsIerrors,_argumentsIoperatorTable_collect,_argumentsIself) =
                (arguments_ (_argumentsOoperatorTable) (_argumentsOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _functionIerrors ++ _argumentsIerrors
            -- self rule
            (_self@_) =
                Type_Application _rangeIself prefix_ _functionIself _argumentsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _argumentsIoperatorTable_collect
            -- copy rule (down)
            (_functionOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_functionOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_argumentsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_argumentsOoperatorTable_collect@_) =
                _functionIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Type_Con :: (T_Range) ->
                (T_Name) ->
                (T_Type)
sem_Type_Con (range_) (name_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors
            -- self rule
            (_self@_) =
                Type_Con _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Type_Constructor :: (T_Range) ->
                        (T_Name) ->
                        (T_Type)
sem_Type_Constructor (range_) (name_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors
            -- self rule
            (_self@_) =
                Type_Constructor _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Type_ConstructorCase :: (T_Range) ->
                            (T_Name) ->
                            (T_Type)
sem_Type_ConstructorCase (range_) (name_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors
            -- self rule
            (_self@_) =
                Type_ConstructorCase _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Type_Exists :: (T_Range) ->
                   (T_Names) ->
                   (T_Type) ->
                   (T_Type)
sem_Type_Exists (range_) (typevariables_) (type_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _typevariablesIerrors :: ([GHError])
            _typevariablesIoperatorTable_collect :: (OperatorTable)
            _typevariablesIself :: (Names)
            _typevariablesOoperatorTable :: (OperatorTable)
            _typevariablesOoperatorTable_collect :: (OperatorTable)
            _typeIerrors :: ([GHError])
            _typeIoperatorTable_collect :: (OperatorTable)
            _typeIself :: (Type)
            _typeOoperatorTable :: (OperatorTable)
            _typeOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _typevariablesIerrors,_typevariablesIoperatorTable_collect,_typevariablesIself) =
                (typevariables_ (_typevariablesOoperatorTable) (_typevariablesOoperatorTable_collect))
            ( _typeIerrors,_typeIoperatorTable_collect,_typeIself) =
                (type_ (_typeOoperatorTable) (_typeOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _typevariablesIerrors ++ _typeIerrors
            -- self rule
            (_self@_) =
                Type_Exists _rangeIself _typevariablesIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _typeIoperatorTable_collect
            -- copy rule (down)
            (_typevariablesOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_typevariablesOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_typeOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_typeOoperatorTable_collect@_) =
                _typevariablesIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Type_Forall :: (T_Range) ->
                   (T_Names) ->
                   (T_Type) ->
                   (T_Type)
sem_Type_Forall (range_) (typevariables_) (type_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _typevariablesIerrors :: ([GHError])
            _typevariablesIoperatorTable_collect :: (OperatorTable)
            _typevariablesIself :: (Names)
            _typevariablesOoperatorTable :: (OperatorTable)
            _typevariablesOoperatorTable_collect :: (OperatorTable)
            _typeIerrors :: ([GHError])
            _typeIoperatorTable_collect :: (OperatorTable)
            _typeIself :: (Type)
            _typeOoperatorTable :: (OperatorTable)
            _typeOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _typevariablesIerrors,_typevariablesIoperatorTable_collect,_typevariablesIself) =
                (typevariables_ (_typevariablesOoperatorTable) (_typevariablesOoperatorTable_collect))
            ( _typeIerrors,_typeIoperatorTable_collect,_typeIself) =
                (type_ (_typeOoperatorTable) (_typeOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _typevariablesIerrors ++ _typeIerrors
            -- self rule
            (_self@_) =
                Type_Forall _rangeIself _typevariablesIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _typeIoperatorTable_collect
            -- copy rule (down)
            (_typevariablesOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_typevariablesOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_typeOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_typeOoperatorTable_collect@_) =
                _typevariablesIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Type_KindApplication :: (T_Range) ->
                            (T_Name) ->
                            (T_Kind) ->
                            (T_Type)
sem_Type_KindApplication (range_) (name_) (kind_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _kindIerrors :: ([GHError])
            _kindIoperatorTable_collect :: (OperatorTable)
            _kindIself :: (Kind)
            _kindOoperatorTable :: (OperatorTable)
            _kindOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _kindIerrors,_kindIoperatorTable_collect,_kindIself) =
                (kind_ (_kindOoperatorTable) (_kindOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _kindIerrors
            -- self rule
            (_self@_) =
                Type_KindApplication _rangeIself _nameIself _kindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _kindIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_kindOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_kindOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Type_KindStarCase :: (T_Range) ->
                         (T_Type)
sem_Type_KindStarCase (range_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            ( _rangeIself) =
                (range_ )
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                Type_KindStarCase _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Type_Kinded :: (T_Range) ->
                   (T_Name) ->
                   (T_Kind) ->
                   (T_Type)
sem_Type_Kinded (range_) (name_) (kind_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _kindIerrors :: ([GHError])
            _kindIoperatorTable_collect :: (OperatorTable)
            _kindIself :: (Kind)
            _kindOoperatorTable :: (OperatorTable)
            _kindOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _kindIerrors,_kindIoperatorTable_collect,_kindIself) =
                (kind_ (_kindOoperatorTable) (_kindOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _kindIerrors
            -- self rule
            (_self@_) =
                Type_Kinded _rangeIself _nameIself _kindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _kindIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_kindOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_kindOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Type_Label :: (T_Range) ->
                  (T_Name) ->
                  (T_Type)
sem_Type_Label (range_) (name_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors
            -- self rule
            (_self@_) =
                Type_Label _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Type_Parenthesized :: (T_Range) ->
                          (T_Type) ->
                          (T_Type)
sem_Type_Parenthesized (range_) (type_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _typeIerrors :: ([GHError])
            _typeIoperatorTable_collect :: (OperatorTable)
            _typeIself :: (Type)
            _typeOoperatorTable :: (OperatorTable)
            _typeOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _typeIerrors,_typeIoperatorTable_collect,_typeIself) =
                (type_ (_typeOoperatorTable) (_typeOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _typeIerrors
            -- self rule
            (_self@_) =
                Type_Parenthesized _rangeIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _typeIoperatorTable_collect
            -- copy rule (down)
            (_typeOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_typeOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Type_Qualified :: (T_Range) ->
                      (T_ContextItems) ->
                      (T_Type) ->
                      (T_Type)
sem_Type_Qualified (range_) (context_) (type_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _contextIerrors :: ([GHError])
            _contextIoperatorTable_collect :: (OperatorTable)
            _contextIself :: (ContextItems)
            _contextOoperatorTable :: (OperatorTable)
            _contextOoperatorTable_collect :: (OperatorTable)
            _typeIerrors :: ([GHError])
            _typeIoperatorTable_collect :: (OperatorTable)
            _typeIself :: (Type)
            _typeOoperatorTable :: (OperatorTable)
            _typeOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _contextIerrors,_contextIoperatorTable_collect,_contextIself) =
                (context_ (_contextOoperatorTable) (_contextOoperatorTable_collect))
            ( _typeIerrors,_typeIoperatorTable_collect,_typeIself) =
                (type_ (_typeOoperatorTable) (_typeOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _contextIerrors ++ _typeIerrors
            -- self rule
            (_self@_) =
                Type_Qualified _rangeIself _contextIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _typeIoperatorTable_collect
            -- copy rule (down)
            (_contextOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_contextOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_typeOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_typeOoperatorTable_collect@_) =
                _contextIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Type_TypeApplication :: (T_Range) ->
                            (T_Name) ->
                            (T_Type) ->
                            (T_Type)
sem_Type_TypeApplication (range_) (name_) (type_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _typeIerrors :: ([GHError])
            _typeIoperatorTable_collect :: (OperatorTable)
            _typeIself :: (Type)
            _typeOoperatorTable :: (OperatorTable)
            _typeOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _typeIerrors,_typeIoperatorTable_collect,_typeIself) =
                (type_ (_typeOoperatorTable) (_typeOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _typeIerrors
            -- self rule
            (_self@_) =
                Type_TypeApplication _rangeIself _nameIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _typeIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_typeOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_typeOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Type_TypeSignature :: (T_Range) ->
                          (T_KindAnnotatedNames) ->
                          (T_Types) ->
                          (T_Type)
sem_Type_TypeSignature (range_) (generics_) (parametrics_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _genericsIerrors :: ([GHError])
            _genericsIoperatorTable_collect :: (OperatorTable)
            _genericsIself :: (KindAnnotatedNames)
            _genericsOoperatorTable :: (OperatorTable)
            _genericsOoperatorTable_collect :: (OperatorTable)
            _parametricsIerrors :: ([GHError])
            _parametricsIoperatorTable_collect :: (OperatorTable)
            _parametricsIself :: (Types)
            _parametricsOoperatorTable :: (OperatorTable)
            _parametricsOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _genericsIerrors,_genericsIoperatorTable_collect,_genericsIself) =
                (generics_ (_genericsOoperatorTable) (_genericsOoperatorTable_collect))
            ( _parametricsIerrors,_parametricsIoperatorTable_collect,_parametricsIself) =
                (parametrics_ (_parametricsOoperatorTable) (_parametricsOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _genericsIerrors ++ _parametricsIerrors
            -- self rule
            (_self@_) =
                Type_TypeSignature _rangeIself _genericsIself _parametricsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _parametricsIoperatorTable_collect
            -- copy rule (down)
            (_genericsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_genericsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_parametricsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_parametricsOoperatorTable_collect@_) =
                _genericsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Type_Variable :: (T_Range) ->
                     (T_Name) ->
                     (T_Type)
sem_Type_Variable (range_) (name_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors
            -- self rule
            (_self@_) =
                Type_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- TypeArgument ------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for TypeArgument.Constructor:
      self

-}
{-
   local variables for TypeArgument.ConstructorCase:
      self

-}
{-
   local variables for TypeArgument.DependencyStyle:
      self

-}
{-
   local variables for TypeArgument.KindStarCase:
      self

-}
{-
   local variables for TypeArgument.Label:
      self

-}
{-
   local variables for TypeArgument.NamedType:
      self

-}
{-
   local variables for TypeArgument.Variable:
      self

-}
-- semantic domain
type T_TypeArgument = (OperatorTable) ->
                      (OperatorTable) ->
                      ( ([GHError]),(OperatorTable),(TypeArgument))
-- cata
sem_TypeArgument :: (TypeArgument) ->
                    (T_TypeArgument)
sem_TypeArgument ((TypeArgument_Constructor (_range) (_variable))) =
    (sem_TypeArgument_Constructor ((sem_Range (_range))) ((sem_Name (_variable))))
sem_TypeArgument ((TypeArgument_ConstructorCase (_range) (_name))) =
    (sem_TypeArgument_ConstructorCase ((sem_Range (_range))) ((sem_Name (_name))))
sem_TypeArgument ((TypeArgument_DependencyStyle (_range) (_name) (_descriptor) (_variables))) =
    (sem_TypeArgument_DependencyStyle ((sem_Range (_range))) ((sem_Name (_name))) ((sem_MaybeName (_descriptor))) ((sem_Names (_variables))))
sem_TypeArgument ((TypeArgument_KindStarCase (_range))) =
    (sem_TypeArgument_KindStarCase ((sem_Range (_range))))
sem_TypeArgument ((TypeArgument_Label (_range) (_variable))) =
    (sem_TypeArgument_Label ((sem_Range (_range))) ((sem_Name (_variable))))
sem_TypeArgument ((TypeArgument_NamedType (_range) (_name))) =
    (sem_TypeArgument_NamedType ((sem_Range (_range))) ((sem_Name (_name))))
sem_TypeArgument ((TypeArgument_Variable (_range) (_name))) =
    (sem_TypeArgument_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_TypeArgument_Constructor :: (T_Range) ->
                                (T_Name) ->
                                (T_TypeArgument)
sem_TypeArgument_Constructor (range_) (variable_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (TypeArgument)
            _rangeIself :: (Range)
            _variableIerrors :: ([GHError])
            _variableIoperatorTable_collect :: (OperatorTable)
            _variableIself :: (Name)
            _variableOoperatorTable :: (OperatorTable)
            _variableOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _variableIerrors,_variableIoperatorTable_collect,_variableIself) =
                (variable_ (_variableOoperatorTable) (_variableOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _variableIerrors
            -- self rule
            (_self@_) =
                TypeArgument_Constructor _rangeIself _variableIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _variableIoperatorTable_collect
            -- copy rule (down)
            (_variableOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_variableOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_TypeArgument_ConstructorCase :: (T_Range) ->
                                    (T_Name) ->
                                    (T_TypeArgument)
sem_TypeArgument_ConstructorCase (range_) (name_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (TypeArgument)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors
            -- self rule
            (_self@_) =
                TypeArgument_ConstructorCase _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_TypeArgument_DependencyStyle :: (T_Range) ->
                                    (T_Name) ->
                                    (T_MaybeName) ->
                                    (T_Names) ->
                                    (T_TypeArgument)
sem_TypeArgument_DependencyStyle (range_) (name_) (descriptor_) (variables_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (TypeArgument)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _descriptorIerrors :: ([GHError])
            _descriptorIoperatorTable_collect :: (OperatorTable)
            _descriptorIself :: (MaybeName)
            _descriptorOoperatorTable :: (OperatorTable)
            _descriptorOoperatorTable_collect :: (OperatorTable)
            _variablesIerrors :: ([GHError])
            _variablesIoperatorTable_collect :: (OperatorTable)
            _variablesIself :: (Names)
            _variablesOoperatorTable :: (OperatorTable)
            _variablesOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _descriptorIerrors,_descriptorIoperatorTable_collect,_descriptorIself) =
                (descriptor_ (_descriptorOoperatorTable) (_descriptorOoperatorTable_collect))
            ( _variablesIerrors,_variablesIoperatorTable_collect,_variablesIself) =
                (variables_ (_variablesOoperatorTable) (_variablesOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _descriptorIerrors ++ _variablesIerrors
            -- self rule
            (_self@_) =
                TypeArgument_DependencyStyle _rangeIself _nameIself _descriptorIself _variablesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _variablesIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_descriptorOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_descriptorOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_variablesOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_variablesOoperatorTable_collect@_) =
                _descriptorIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_TypeArgument_KindStarCase :: (T_Range) ->
                                 (T_TypeArgument)
sem_TypeArgument_KindStarCase (range_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (TypeArgument)
            _rangeIself :: (Range)
            ( _rangeIself) =
                (range_ )
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                TypeArgument_KindStarCase _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_TypeArgument_Label :: (T_Range) ->
                          (T_Name) ->
                          (T_TypeArgument)
sem_TypeArgument_Label (range_) (variable_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (TypeArgument)
            _rangeIself :: (Range)
            _variableIerrors :: ([GHError])
            _variableIoperatorTable_collect :: (OperatorTable)
            _variableIself :: (Name)
            _variableOoperatorTable :: (OperatorTable)
            _variableOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _variableIerrors,_variableIoperatorTable_collect,_variableIself) =
                (variable_ (_variableOoperatorTable) (_variableOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _variableIerrors
            -- self rule
            (_self@_) =
                TypeArgument_Label _rangeIself _variableIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _variableIoperatorTable_collect
            -- copy rule (down)
            (_variableOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_variableOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_TypeArgument_NamedType :: (T_Range) ->
                              (T_Name) ->
                              (T_TypeArgument)
sem_TypeArgument_NamedType (range_) (name_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (TypeArgument)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors
            -- self rule
            (_self@_) =
                TypeArgument_NamedType _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_TypeArgument_Variable :: (T_Range) ->
                             (T_Name) ->
                             (T_TypeArgument)
sem_TypeArgument_Variable (range_) (name_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (TypeArgument)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors
            -- self rule
            (_self@_) =
                TypeArgument_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- TypeArguments -----------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for TypeArguments.Cons:
      self

-}
{-
   local variables for TypeArguments.Nil:
      self

-}
-- semantic domain
type T_TypeArguments = (OperatorTable) ->
                       (OperatorTable) ->
                       ( ([GHError]),(OperatorTable),(TypeArguments))
-- cata
sem_TypeArguments :: (TypeArguments) ->
                     (T_TypeArguments)
sem_TypeArguments (list) =
    (foldr (sem_TypeArguments_Cons) (sem_TypeArguments_Nil) ((map sem_TypeArgument list)))
sem_TypeArguments_Cons :: (T_TypeArgument) ->
                          (T_TypeArguments) ->
                          (T_TypeArguments)
sem_TypeArguments_Cons (hd_) (tl_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (TypeArguments)
            _hdIerrors :: ([GHError])
            _hdIoperatorTable_collect :: (OperatorTable)
            _hdIself :: (TypeArgument)
            _hdOoperatorTable :: (OperatorTable)
            _hdOoperatorTable_collect :: (OperatorTable)
            _tlIerrors :: ([GHError])
            _tlIoperatorTable_collect :: (OperatorTable)
            _tlIself :: (TypeArguments)
            _tlOoperatorTable :: (OperatorTable)
            _tlOoperatorTable_collect :: (OperatorTable)
            ( _hdIerrors,_hdIoperatorTable_collect,_hdIself) =
                (hd_ (_hdOoperatorTable) (_hdOoperatorTable_collect))
            ( _tlIerrors,_tlIoperatorTable_collect,_tlIself) =
                (tl_ (_tlOoperatorTable) (_tlOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _hdIerrors ++ _tlIerrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _tlIoperatorTable_collect
            -- copy rule (down)
            (_hdOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_hdOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_tlOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_tlOoperatorTable_collect@_) =
                _hdIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_TypeArguments_Nil :: (T_TypeArguments)
sem_TypeArguments_Nil  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (TypeArguments)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- TypeIndexedBinding ------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for TypeIndexedBinding.DefaultCase:
      self

-}
{-
   local variables for TypeIndexedBinding.TypeIndexedBinding:
      self

-}
-- semantic domain
type T_TypeIndexedBinding = (OperatorTable) ->
                            (OperatorTable) ->
                            ( ([GHError]),(OperatorTable),(TypeIndexedBinding))
-- cata
sem_TypeIndexedBinding :: (TypeIndexedBinding) ->
                          (T_TypeIndexedBinding)
sem_TypeIndexedBinding ((TypeIndexedBinding_DefaultCase (_range) (_name) (_extended) (_reassignments))) =
    (sem_TypeIndexedBinding_DefaultCase ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Name (_extended))) ((sem_MaybeReassignments (_reassignments))))
sem_TypeIndexedBinding ((TypeIndexedBinding_TypeIndexedBinding (_range) (_name) (_typeargument) (_patterns) (_righthandside))) =
    (sem_TypeIndexedBinding_TypeIndexedBinding ((sem_Range (_range))) ((sem_Name (_name))) ((sem_TypeArgument (_typeargument))) ((sem_Patterns (_patterns))) ((sem_RightHandSide (_righthandside))))
sem_TypeIndexedBinding_DefaultCase :: (T_Range) ->
                                      (T_Name) ->
                                      (T_Name) ->
                                      (T_MaybeReassignments) ->
                                      (T_TypeIndexedBinding)
sem_TypeIndexedBinding_DefaultCase (range_) (name_) (extended_) (reassignments_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (TypeIndexedBinding)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _extendedIerrors :: ([GHError])
            _extendedIoperatorTable_collect :: (OperatorTable)
            _extendedIself :: (Name)
            _extendedOoperatorTable :: (OperatorTable)
            _extendedOoperatorTable_collect :: (OperatorTable)
            _reassignmentsIerrors :: ([GHError])
            _reassignmentsIoperatorTable_collect :: (OperatorTable)
            _reassignmentsIself :: (MaybeReassignments)
            _reassignmentsOoperatorTable :: (OperatorTable)
            _reassignmentsOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _extendedIerrors,_extendedIoperatorTable_collect,_extendedIself) =
                (extended_ (_extendedOoperatorTable) (_extendedOoperatorTable_collect))
            ( _reassignmentsIerrors,_reassignmentsIoperatorTable_collect,_reassignmentsIself) =
                (reassignments_ (_reassignmentsOoperatorTable) (_reassignmentsOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _extendedIerrors ++ _reassignmentsIerrors
            -- self rule
            (_self@_) =
                TypeIndexedBinding_DefaultCase _rangeIself _nameIself _extendedIself _reassignmentsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _reassignmentsIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_extendedOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_extendedOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_reassignmentsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_reassignmentsOoperatorTable_collect@_) =
                _extendedIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_TypeIndexedBinding_TypeIndexedBinding :: (T_Range) ->
                                             (T_Name) ->
                                             (T_TypeArgument) ->
                                             (T_Patterns) ->
                                             (T_RightHandSide) ->
                                             (T_TypeIndexedBinding)
sem_TypeIndexedBinding_TypeIndexedBinding (range_) (name_) (typeargument_) (patterns_) (righthandside_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (TypeIndexedBinding)
            _rangeIself :: (Range)
            _nameIerrors :: ([GHError])
            _nameIoperatorTable_collect :: (OperatorTable)
            _nameIself :: (Name)
            _nameOoperatorTable :: (OperatorTable)
            _nameOoperatorTable_collect :: (OperatorTable)
            _typeargumentIerrors :: ([GHError])
            _typeargumentIoperatorTable_collect :: (OperatorTable)
            _typeargumentIself :: (TypeArgument)
            _typeargumentOoperatorTable :: (OperatorTable)
            _typeargumentOoperatorTable_collect :: (OperatorTable)
            _patternsIerrors :: ([GHError])
            _patternsIoperatorTable_collect :: (OperatorTable)
            _patternsIself :: (Patterns)
            _patternsOoperatorTable :: (OperatorTable)
            _patternsOoperatorTable_collect :: (OperatorTable)
            _righthandsideIerrors :: ([GHError])
            _righthandsideIoperatorTable_collect :: (OperatorTable)
            _righthandsideIself :: (RightHandSide)
            _righthandsideOoperatorTable :: (OperatorTable)
            _righthandsideOoperatorTable_collect :: (OperatorTable)
            ( _rangeIself) =
                (range_ )
            ( _nameIerrors,_nameIoperatorTable_collect,_nameIself) =
                (name_ (_nameOoperatorTable) (_nameOoperatorTable_collect))
            ( _typeargumentIerrors,_typeargumentIoperatorTable_collect,_typeargumentIself) =
                (typeargument_ (_typeargumentOoperatorTable) (_typeargumentOoperatorTable_collect))
            ( _patternsIerrors,_patternsIoperatorTable_collect,_patternsIself) =
                (patterns_ (_patternsOoperatorTable) (_patternsOoperatorTable_collect))
            ( _righthandsideIerrors,_righthandsideIoperatorTable_collect,_righthandsideIself) =
                (righthandside_ (_righthandsideOoperatorTable) (_righthandsideOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _nameIerrors ++ _typeargumentIerrors ++ _patternsIerrors ++ _righthandsideIerrors
            -- self rule
            (_self@_) =
                TypeIndexedBinding_TypeIndexedBinding _rangeIself _nameIself _typeargumentIself _patternsIself _righthandsideIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _righthandsideIoperatorTable_collect
            -- copy rule (down)
            (_nameOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_nameOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_typeargumentOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_typeargumentOoperatorTable_collect@_) =
                _nameIoperatorTable_collect
            -- copy rule (down)
            (_patternsOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_patternsOoperatorTable_collect@_) =
                _typeargumentIoperatorTable_collect
            -- copy rule (down)
            (_righthandsideOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_righthandsideOoperatorTable_collect@_) =
                _patternsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- TypeIndexedBindings -----------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for TypeIndexedBindings.Cons:
      self

-}
{-
   local variables for TypeIndexedBindings.Nil:
      self

-}
-- semantic domain
type T_TypeIndexedBindings = (OperatorTable) ->
                             (OperatorTable) ->
                             ( ([GHError]),(OperatorTable),(TypeIndexedBindings))
-- cata
sem_TypeIndexedBindings :: (TypeIndexedBindings) ->
                           (T_TypeIndexedBindings)
sem_TypeIndexedBindings (list) =
    (foldr (sem_TypeIndexedBindings_Cons) (sem_TypeIndexedBindings_Nil) ((map sem_TypeIndexedBinding list)))
sem_TypeIndexedBindings_Cons :: (T_TypeIndexedBinding) ->
                                (T_TypeIndexedBindings) ->
                                (T_TypeIndexedBindings)
sem_TypeIndexedBindings_Cons (hd_) (tl_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (TypeIndexedBindings)
            _hdIerrors :: ([GHError])
            _hdIoperatorTable_collect :: (OperatorTable)
            _hdIself :: (TypeIndexedBinding)
            _hdOoperatorTable :: (OperatorTable)
            _hdOoperatorTable_collect :: (OperatorTable)
            _tlIerrors :: ([GHError])
            _tlIoperatorTable_collect :: (OperatorTable)
            _tlIself :: (TypeIndexedBindings)
            _tlOoperatorTable :: (OperatorTable)
            _tlOoperatorTable_collect :: (OperatorTable)
            ( _hdIerrors,_hdIoperatorTable_collect,_hdIself) =
                (hd_ (_hdOoperatorTable) (_hdOoperatorTable_collect))
            ( _tlIerrors,_tlIoperatorTable_collect,_tlIself) =
                (tl_ (_tlOoperatorTable) (_tlOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _hdIerrors ++ _tlIerrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _tlIoperatorTable_collect
            -- copy rule (down)
            (_hdOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_hdOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_tlOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_tlOoperatorTable_collect@_) =
                _hdIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_TypeIndexedBindings_Nil :: (T_TypeIndexedBindings)
sem_TypeIndexedBindings_Nil  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (TypeIndexedBindings)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
-- Types -------------------------------------------------------
{-
   inherited attributes:
      operatorTable        : OperatorTable

   chained attributes:
      operatorTable_collect : OperatorTable

   synthesised attributes:
      errors               : [GHError]
      self                 : SELF

-}
{-
   local variables for Types.Cons:
      self

-}
{-
   local variables for Types.Nil:
      self

-}
-- semantic domain
type T_Types = (OperatorTable) ->
               (OperatorTable) ->
               ( ([GHError]),(OperatorTable),(Types))
-- cata
sem_Types :: (Types) ->
             (T_Types)
sem_Types (list) =
    (foldr (sem_Types_Cons) (sem_Types_Nil) ((map sem_Type list)))
sem_Types_Cons :: (T_Type) ->
                  (T_Types) ->
                  (T_Types)
sem_Types_Cons (hd_) (tl_) =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Types)
            _hdIerrors :: ([GHError])
            _hdIoperatorTable_collect :: (OperatorTable)
            _hdIself :: (Type)
            _hdOoperatorTable :: (OperatorTable)
            _hdOoperatorTable_collect :: (OperatorTable)
            _tlIerrors :: ([GHError])
            _tlIoperatorTable_collect :: (OperatorTable)
            _tlIself :: (Types)
            _tlOoperatorTable :: (OperatorTable)
            _tlOoperatorTable_collect :: (OperatorTable)
            ( _hdIerrors,_hdIoperatorTable_collect,_hdIself) =
                (hd_ (_hdOoperatorTable) (_hdOoperatorTable_collect))
            ( _tlIerrors,_tlIoperatorTable_collect,_tlIself) =
                (tl_ (_tlOoperatorTable) (_tlOoperatorTable_collect))
            -- use rule
            (_lhsOerrors@_) =
                _hdIerrors ++ _tlIerrors
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOoperatorTable_collect@_) =
                _tlIoperatorTable_collect
            -- copy rule (down)
            (_hdOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (down)
            (_hdOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
            -- copy rule (down)
            (_tlOoperatorTable@_) =
                _lhsIoperatorTable
            -- copy rule (chain)
            (_tlOoperatorTable_collect@_) =
                _hdIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)
sem_Types_Nil :: (T_Types)
sem_Types_Nil  =
    \ _lhsIoperatorTable
      _lhsIoperatorTable_collect ->
        let _lhsOerrors :: ([GHError])
            _lhsOoperatorTable_collect :: (OperatorTable)
            _lhsOself :: (Types)
            -- use rule
            (_lhsOerrors@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOoperatorTable_collect@_) =
                _lhsIoperatorTable_collect
        in  ( _lhsOerrors,_lhsOoperatorTable_collect,_lhsOself)


