-- do not edit; automatically generated by UU.AG
module ScanDependencies where


import Name
import Utils
import ErrorUtils
import FMap
import Set
import List (nub)
import AbstractSyntax
import UHA_Range
import KindUtils
import BuildSyntax
import qualified Pretty as PP

import qualified Types



import Maybe (isNothing)



import KindUtils (isRestricted)
import qualified List
import Monad (msum)



type PreSignatures  =  FMap Name PreSignature
type Signatures     =  FMap Name Signature
type PreSignature   =  (Signature,(Maybe Name))
type Signature      =  [TypeArgument]



expandSignatures :: PreSignatures -> Signatures -> Signatures
expandSignatures pss ss = mapFM expandSignature pss
  where
  expandSignature :: PreSignature -> Signature
  expandSignature (stps,  Nothing  )  =  stps
  expandSignature (stps,  Just n   )  = 
    let  stps' = applyOrSignatureError ss n "Signature.expandSignature: no signature"
    in   {- trace (" unifying: " ++ show stps ++ "\n and: " ++ show stps') $ -}
         stps `List.union` stps'



simplifyTypeArgument :: TypeArgument -> TypeArgument
simplifyTypeArgument (TypeArgument_DependencyStyle _ n (MaybeName_Just d) _)
  | n == conName    =  TypeArgument_Constructor  unknownRange d
  | n == labelName  =  TypeArgument_Label        unknownRange d
  | otherwise =
     internalError $
       "Signature.simplifyTypeArgument: illegal type argument with descriptor"
simplifyTypeArgument (TypeArgument_DependencyStyle _ n _ _) 
  = TypeArgument_NamedType unknownRange n
simplifyTypeArgument x = x



isGASignature :: Signatures -> Name -> Bool
isGASignature sigs n = 
    case sig of
      [TypeArgument_Variable _ _]  ->  True
      _                            ->  False
  where  sig = applyFMM sigs err n
         err = internalError $
                 "ScanDependencies.isGASignature: no signature for " ++
                 PP.unPretty (PP.ppName n)



applyOrSignatureError sigs name errmsg =
  applyFMM sigs
    (const $ internalError $
       errmsg ++ " " ++
       (PP.unPretty $ PP.ppName name)
{-
       "\navailable names:\n" ++
       (PP.unPretty $ 
          PP.prettyFM PP.ppName (PP.hsep . map (PP.ppType . typeArgumentToType))
            sigs)
-}
    )
    name

doubleDefaultCaseError           ::  Name -> a
doubleDefaultCaseError v         =
  unstaticError $
    "Signature.TypeIndexedValue: "
      ++ "Multiple default cases in generic function " 
      ++ PP.unPretty (PP.ppName v)
      ++ "."

illegalDefaultCaseError          ::  Name -> a
illegalDefaultCaseError v        =
  unstaticError $
    "Signature.TypeIndexedValue: "
      ++ "Illegal default case in generic function " 
      ++ PP.unPretty (PP.ppName v)
      ++ "."



dependency_iterate             :: FMap Name [(Name,Name)] -- dependencies
                               -> FMap Name [(Name,Name)] -- final dependencies
dependency_iterate dependencies =
    iterate' (mapFM  (\d -> (map (\y -> (y,True)) d,False)) 
                     dependencies
                :: FMap Name ([((Name,Name),Bool)],Bool))
  where
    iterate' :: FMap Name ([((Name,Name),Bool)],Bool) -> FMap Name [(Name,Name)]
    iterate' dependencies
      | and (codomain (mapFM snd dependencies)) =
          -- all finished, done!
          mapFM (map fst . fst) dependencies
          -- ... eliminates the booleans
      | otherwise =
          iterate' 
            (mapFM mapGA dependencies)
      where
        mapGA :: ([((Name,Name),Bool)],Bool) -> ([((Name,Name),Bool)],Bool)
        mapGA current@(deps,finished) =
            if finished then
              current
            else
              let  newdeps =
                     [ (candidate,isnew)
                     | (dep,wasnew) <- deps
                     , -- resolve dep
                       candidate <- if not wasnew 
                                    then  [dep]
                                    else  case find dependencies (fst dep) of
                                            Nothing         ->  [dep] -- should not occur
                                            Just (ndeps,_)  ->  map fst ndeps
                     , -- is the candidate new?
                       let isnew = not (elem candidate (map fst deps))
                       -- TODO: will not work properly with renamings
                     ]
              in   if or (map snd newdeps) 
                   then  -- at least one new dependency
                         (nub newdeps,False)
                   else  -- finished, nothing new
                         (deps,True)



scanDependencies               :: ModuleSystem
                               -> FMap Name [(Name,Name)]

scanDependencies ms =
    case sem_Root (Root_Root ms) of
      (d,self) -> d



data Root = Root_Root { contents :: ModuleSystem }

-- Alternative -------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      bodyDependencies     : [(Name,Name)]
      self                 : SELF

-}
{-
   local variables for Alternative.Alternative:
      self

-}
{-
   local variables for Alternative.Empty:
      self

-}
-- semantic domain
type T_Alternative = (Maybe Name) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Strings) ->
                     (FMap Name [(Name,Name)]) ->
                     (Bool) ->
                     (FMap Name [(Name,Name)]) ->
                     (FMap Name [(Name,Name)]) ->
                     (Maybe Name) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Bool) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (PreSignatures) ->
                     (PreSignatures) ->
                     (Signatures) ->
                     (Bool) ->
                     ( ([(Name,Name)]),(FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(PreSignatures),(Alternative))
-- cata
sem_Alternative :: (Alternative) ->
                   (T_Alternative)
sem_Alternative ((Alternative_Alternative (_range) (_pattern) (_righthandside))) =
    (sem_Alternative_Alternative ((sem_Range (_range))) ((sem_Pattern (_pattern))) ((sem_RightHandSide (_righthandside))))
sem_Alternative ((Alternative_Empty (_range))) =
    (sem_Alternative_Empty ((sem_Range (_range))))
sem_Alternative_Alternative :: (T_Range) ->
                               (T_Pattern) ->
                               (T_RightHandSide) ->
                               (T_Alternative)
sem_Alternative_Alternative (range_) (pattern_) (righthandside_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Alternative)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _patternIconstructors_collect :: (FMap Name Names)
            _patternIdependencies_collect :: (FMap Name [(Name,Name)])
            _patternIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _patternIlabels_collect :: (FMap Name Names)
            _patternImethods_collect :: (FMap Name Names)
            _patternIname :: (Name)
            _patternIself :: (Pattern)
            _patternOclassname :: (Maybe Name)
            _patternOconstructors_collect :: (FMap Name Names)
            _patternOconstructors_dist :: (FMap Name Names)
            _patternOcurrentModule :: (Strings)
            _patternOdependencies_collect :: (FMap Name [(Name,Name)])
            _patternOimportedModule :: (Bool)
            _patternOinferredDependencies :: (FMap Name [(Name,Name)])
            _patternOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _patternOinstancename :: (Maybe Name)
            _patternOlabels_collect :: (FMap Name Names)
            _patternOlabels_dist :: (FMap Name Names)
            _patternOlocal :: (Bool)
            _patternOmethods_collect :: (FMap Name Names)
            _patternOmethods_dist :: (FMap Name Names)
            _patternOtoplevel :: (Bool)
            _righthandsideIbodyDependencies :: ([(Name,Name)])
            _righthandsideIconstructors_collect :: (FMap Name Names)
            _righthandsideIdependencies_collect :: (FMap Name [(Name,Name)])
            _righthandsideIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _righthandsideIlabels_collect :: (FMap Name Names)
            _righthandsideImethods_collect :: (FMap Name Names)
            _righthandsideIpresignatures_collect :: (PreSignatures)
            _righthandsideIself :: (RightHandSide)
            _righthandsideOclassname :: (Maybe Name)
            _righthandsideOconstructors_collect :: (FMap Name Names)
            _righthandsideOconstructors_dist :: (FMap Name Names)
            _righthandsideOcurrentModule :: (Strings)
            _righthandsideOdependencies_collect :: (FMap Name [(Name,Name)])
            _righthandsideOimportedModule :: (Bool)
            _righthandsideOinferredDependencies :: (FMap Name [(Name,Name)])
            _righthandsideOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _righthandsideOinstancename :: (Maybe Name)
            _righthandsideOlabels_collect :: (FMap Name Names)
            _righthandsideOlabels_dist :: (FMap Name Names)
            _righthandsideOlocal :: (Bool)
            _righthandsideOmethods_collect :: (FMap Name Names)
            _righthandsideOmethods_dist :: (FMap Name Names)
            _righthandsideOpresignatures :: (PreSignatures)
            _righthandsideOpresignatures_collect :: (PreSignatures)
            _righthandsideOsignatures :: (Signatures)
            _righthandsideOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _patternIconstructors_collect,_patternIdependencies_collect,_patternIinferredDependencies_collect,_patternIlabels_collect,_patternImethods_collect,_patternIname,_patternIself) =
                (pattern_ (_patternOclassname) (_patternOconstructors_collect) (_patternOconstructors_dist) (_patternOcurrentModule) (_patternOdependencies_collect) (_patternOimportedModule) (_patternOinferredDependencies) (_patternOinferredDependencies_collect) (_patternOinstancename) (_patternOlabels_collect) (_patternOlabels_dist) (_patternOlocal) (_patternOmethods_collect) (_patternOmethods_dist) (_patternOtoplevel))
            ( _righthandsideIbodyDependencies,_righthandsideIconstructors_collect,_righthandsideIdependencies_collect,_righthandsideIinferredDependencies_collect,_righthandsideIlabels_collect,_righthandsideImethods_collect,_righthandsideIpresignatures_collect,_righthandsideIself) =
                (righthandside_ (_righthandsideOclassname)
                                (_righthandsideOconstructors_collect)
                                (_righthandsideOconstructors_dist)
                                (_righthandsideOcurrentModule)
                                (_righthandsideOdependencies_collect)
                                (_righthandsideOimportedModule)
                                (_righthandsideOinferredDependencies)
                                (_righthandsideOinferredDependencies_collect)
                                (_righthandsideOinstancename)
                                (_righthandsideOlabels_collect)
                                (_righthandsideOlabels_dist)
                                (_righthandsideOlocal)
                                (_righthandsideOmethods_collect)
                                (_righthandsideOmethods_dist)
                                (_righthandsideOpresignatures)
                                (_righthandsideOpresignatures_collect)
                                (_righthandsideOsignatures)
                                (_righthandsideOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _righthandsideIbodyDependencies
            -- self rule
            (_self@_) =
                Alternative_Alternative _rangeIself _patternIself _righthandsideIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _righthandsideIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _righthandsideIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _righthandsideIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _righthandsideIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _righthandsideImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _righthandsideIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_patternOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_patternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_patternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_patternOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_patternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_patternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_patternOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_patternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_righthandsideOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_righthandsideOconstructors_collect@_) =
                _patternIconstructors_collect
            -- copy rule (down)
            (_righthandsideOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_righthandsideOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_righthandsideOdependencies_collect@_) =
                _patternIdependencies_collect
            -- copy rule (down)
            (_righthandsideOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_righthandsideOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_righthandsideOinferredDependencies_collect@_) =
                _patternIinferredDependencies_collect
            -- copy rule (down)
            (_righthandsideOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_righthandsideOlabels_collect@_) =
                _patternIlabels_collect
            -- copy rule (down)
            (_righthandsideOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_righthandsideOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_righthandsideOmethods_collect@_) =
                _patternImethods_collect
            -- copy rule (down)
            (_righthandsideOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_righthandsideOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_righthandsideOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_righthandsideOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_righthandsideOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Alternative_Empty :: (T_Range) ->
                         (T_Alternative)
sem_Alternative_Empty (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Alternative)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                []
            -- self rule
            (_self@_) =
                Alternative_Empty _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- Alternatives ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      bodyDependencies     : [(Name,Name)]
      self                 : SELF

-}
{-
   local variables for Alternatives.Cons:
      self

-}
{-
   local variables for Alternatives.Nil:
      self

-}
-- semantic domain
type T_Alternatives = (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Strings) ->
                      (FMap Name [(Name,Name)]) ->
                      (Bool) ->
                      (FMap Name [(Name,Name)]) ->
                      (FMap Name [(Name,Name)]) ->
                      (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (PreSignatures) ->
                      (PreSignatures) ->
                      (Signatures) ->
                      (Bool) ->
                      ( ([(Name,Name)]),(FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(PreSignatures),(Alternatives))
-- cata
sem_Alternatives :: (Alternatives) ->
                    (T_Alternatives)
sem_Alternatives (list) =
    (foldr (sem_Alternatives_Cons) (sem_Alternatives_Nil) ((map sem_Alternative list)))
sem_Alternatives_Cons :: (T_Alternative) ->
                         (T_Alternatives) ->
                         (T_Alternatives)
sem_Alternatives_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Alternatives)
            _hdIbodyDependencies :: ([(Name,Name)])
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdependencies_collect :: (FMap Name [(Name,Name)])
            _hdIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIpresignatures_collect :: (PreSignatures)
            _hdIself :: (Alternative)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies_collect :: (FMap Name [(Name,Name)])
            _hdOimportedModule :: (Bool)
            _hdOinferredDependencies :: (FMap Name [(Name,Name)])
            _hdOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdOinstancename :: (Maybe Name)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOpresignatures :: (PreSignatures)
            _hdOpresignatures_collect :: (PreSignatures)
            _hdOsignatures :: (Signatures)
            _hdOtoplevel :: (Bool)
            _tlIbodyDependencies :: ([(Name,Name)])
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdependencies_collect :: (FMap Name [(Name,Name)])
            _tlIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIpresignatures_collect :: (PreSignatures)
            _tlIself :: (Alternatives)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies_collect :: (FMap Name [(Name,Name)])
            _tlOimportedModule :: (Bool)
            _tlOinferredDependencies :: (FMap Name [(Name,Name)])
            _tlOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOpresignatures :: (PreSignatures)
            _tlOpresignatures_collect :: (PreSignatures)
            _tlOsignatures :: (Signatures)
            _tlOtoplevel :: (Bool)
            ( _hdIbodyDependencies,_hdIconstructors_collect,_hdIdependencies_collect,_hdIinferredDependencies_collect,_hdIlabels_collect,_hdImethods_collect,_hdIpresignatures_collect,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOdependencies_collect) (_hdOimportedModule) (_hdOinferredDependencies) (_hdOinferredDependencies_collect) (_hdOinstancename) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOpresignatures) (_hdOpresignatures_collect) (_hdOsignatures) (_hdOtoplevel))
            ( _tlIbodyDependencies,_tlIconstructors_collect,_tlIdependencies_collect,_tlIinferredDependencies_collect,_tlIlabels_collect,_tlImethods_collect,_tlIpresignatures_collect,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOdependencies_collect) (_tlOimportedModule) (_tlOinferredDependencies) (_tlOinferredDependencies_collect) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOpresignatures) (_tlOpresignatures_collect) (_tlOsignatures) (_tlOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _hdIbodyDependencies ++ _tlIbodyDependencies
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _tlIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _tlIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _tlIpresignatures_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_hdOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_hdOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_hdOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_tlOdependencies_collect@_) =
                _hdIdependencies_collect
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_tlOinferredDependencies_collect@_) =
                _hdIinferredDependencies_collect
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_tlOpresignatures_collect@_) =
                _hdIpresignatures_collect
            -- copy rule (down)
            (_tlOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Alternatives_Nil :: (T_Alternatives)
sem_Alternatives_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Alternatives)
            -- use rule
            (_lhsObodyDependencies@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- AnnotatedType -----------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for AnnotatedType.AnnotatedType:
      self

-}
-- semantic domain
type T_AnnotatedType = (Maybe Name) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (Strings) ->
                       (FMap Name [(Name,Name)]) ->
                       (Bool) ->
                       (FMap Name [(Name,Name)]) ->
                       (FMap Name [(Name,Name)]) ->
                       (Maybe Name) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (Bool) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (Bool) ->
                       ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(AnnotatedType))
-- cata
sem_AnnotatedType :: (AnnotatedType) ->
                     (T_AnnotatedType)
sem_AnnotatedType ((AnnotatedType_AnnotatedType (_range) (_strict) (_type))) =
    (sem_AnnotatedType_AnnotatedType ((sem_Range (_range))) (_strict) ((sem_Type (_type))))
sem_AnnotatedType_AnnotatedType :: (T_Range) ->
                                   (Bool) ->
                                   (T_Type) ->
                                   (T_AnnotatedType)
sem_AnnotatedType_AnnotatedType (range_) (strict_) (type_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (AnnotatedType)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIdependencies_collect :: (FMap Name [(Name,Name)])
            _typeIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typeIlabels_collect :: (FMap Name Names)
            _typeIlocalDependencies :: ([(Name,Name)])
            _typeImethods_collect :: (FMap Name Names)
            _typeIself :: (Type)
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOdependencies_collect :: (FMap Name [(Name,Name)])
            _typeOimportedModule :: (Bool)
            _typeOinferredDependencies :: (FMap Name [(Name,Name)])
            _typeOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typeOinstancename :: (Maybe Name)
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _typeIconstructors_collect,_typeIdependencies_collect,_typeIinferredDependencies_collect,_typeIlabels_collect,_typeIlocalDependencies,_typeImethods_collect,_typeIself) =
                (type_ (_typeOclassname) (_typeOconstructors_collect) (_typeOconstructors_dist) (_typeOcurrentModule) (_typeOdependencies_collect) (_typeOimportedModule) (_typeOinferredDependencies) (_typeOinferredDependencies_collect) (_typeOinstancename) (_typeOlabels_collect) (_typeOlabels_dist) (_typeOlocal) (_typeOmethods_collect) (_typeOmethods_dist) (_typeOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 203, column 8)
            (_typeOtoplevel@_) =
                False
            -- self rule
            (_self@_) =
                AnnotatedType_AnnotatedType _rangeIself strict_ _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _typeIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _typeIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_typeOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_typeOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typeOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_typeOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- AnnotatedTypes ----------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for AnnotatedTypes.Cons:
      self

-}
{-
   local variables for AnnotatedTypes.Nil:
      self

-}
-- semantic domain
type T_AnnotatedTypes = (Maybe Name) ->
                        (FMap Name Names) ->
                        (FMap Name Names) ->
                        (Strings) ->
                        (FMap Name [(Name,Name)]) ->
                        (Bool) ->
                        (FMap Name [(Name,Name)]) ->
                        (FMap Name [(Name,Name)]) ->
                        (Maybe Name) ->
                        (FMap Name Names) ->
                        (FMap Name Names) ->
                        (Bool) ->
                        (FMap Name Names) ->
                        (FMap Name Names) ->
                        (Bool) ->
                        ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(AnnotatedTypes))
-- cata
sem_AnnotatedTypes :: (AnnotatedTypes) ->
                      (T_AnnotatedTypes)
sem_AnnotatedTypes (list) =
    (foldr (sem_AnnotatedTypes_Cons) (sem_AnnotatedTypes_Nil) ((map sem_AnnotatedType list)))
sem_AnnotatedTypes_Cons :: (T_AnnotatedType) ->
                           (T_AnnotatedTypes) ->
                           (T_AnnotatedTypes)
sem_AnnotatedTypes_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (AnnotatedTypes)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdependencies_collect :: (FMap Name [(Name,Name)])
            _hdIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIself :: (AnnotatedType)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies_collect :: (FMap Name [(Name,Name)])
            _hdOimportedModule :: (Bool)
            _hdOinferredDependencies :: (FMap Name [(Name,Name)])
            _hdOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdOinstancename :: (Maybe Name)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdependencies_collect :: (FMap Name [(Name,Name)])
            _tlIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIself :: (AnnotatedTypes)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies_collect :: (FMap Name [(Name,Name)])
            _tlOimportedModule :: (Bool)
            _tlOinferredDependencies :: (FMap Name [(Name,Name)])
            _tlOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIdependencies_collect,_hdIinferredDependencies_collect,_hdIlabels_collect,_hdImethods_collect,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOdependencies_collect) (_hdOimportedModule) (_hdOinferredDependencies) (_hdOinferredDependencies_collect) (_hdOinstancename) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIdependencies_collect,_tlIinferredDependencies_collect,_tlIlabels_collect,_tlImethods_collect,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOdependencies_collect) (_tlOimportedModule) (_tlOinferredDependencies) (_tlOinferredDependencies_collect) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOtoplevel))
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _tlIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _tlIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_hdOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_tlOdependencies_collect@_) =
                _hdIdependencies_collect
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_tlOinferredDependencies_collect@_) =
                _hdIinferredDependencies_collect
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_AnnotatedTypes_Nil :: (T_AnnotatedTypes)
sem_AnnotatedTypes_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (AnnotatedTypes)
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- Body --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Body.Body:
      self

-}
-- semantic domain
type T_Body = (Maybe Name) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (Strings) ->
              (FMap Name [(Name,Name)]) ->
              (Bool) ->
              (FMap Name [(Name,Name)]) ->
              (FMap Name [(Name,Name)]) ->
              (Maybe Name) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (Bool) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (PreSignatures) ->
              (PreSignatures) ->
              (Signatures) ->
              (Bool) ->
              ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(PreSignatures),(Body))
-- cata
sem_Body :: (Body) ->
            (T_Body)
sem_Body ((Body_Body (_range) (_importdeclarations) (_declarations))) =
    (sem_Body_Body ((sem_Range (_range))) ((sem_ImportDeclarations (_importdeclarations))) ((sem_Declarations (_declarations))))
sem_Body_Body :: (T_Range) ->
                 (T_ImportDeclarations) ->
                 (T_Declarations) ->
                 (T_Body)
sem_Body_Body (range_) (importdeclarations_) (declarations_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Body)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _importdeclarationsIconstructors_collect :: (FMap Name Names)
            _importdeclarationsIdependencies_collect :: (FMap Name [(Name,Name)])
            _importdeclarationsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _importdeclarationsIlabels_collect :: (FMap Name Names)
            _importdeclarationsImethods_collect :: (FMap Name Names)
            _importdeclarationsIpresignatures_collect :: (PreSignatures)
            _importdeclarationsIself :: (ImportDeclarations)
            _importdeclarationsOclassname :: (Maybe Name)
            _importdeclarationsOconstructors_collect :: (FMap Name Names)
            _importdeclarationsOconstructors_dist :: (FMap Name Names)
            _importdeclarationsOcurrentModule :: (Strings)
            _importdeclarationsOdependencies_collect :: (FMap Name [(Name,Name)])
            _importdeclarationsOimportedModule :: (Bool)
            _importdeclarationsOinferredDependencies :: (FMap Name [(Name,Name)])
            _importdeclarationsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _importdeclarationsOinstancename :: (Maybe Name)
            _importdeclarationsOlabels_collect :: (FMap Name Names)
            _importdeclarationsOlabels_dist :: (FMap Name Names)
            _importdeclarationsOlocal :: (Bool)
            _importdeclarationsOmethods_collect :: (FMap Name Names)
            _importdeclarationsOmethods_dist :: (FMap Name Names)
            _importdeclarationsOpresignatures :: (PreSignatures)
            _importdeclarationsOpresignatures_collect :: (PreSignatures)
            _importdeclarationsOsignatures :: (Signatures)
            _importdeclarationsOtoplevel :: (Bool)
            _declarationsIbodyDependencies :: ([(Name,Name)])
            _declarationsIconstructors_collect :: (FMap Name Names)
            _declarationsIdependencies_collect :: (FMap Name [(Name,Name)])
            _declarationsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _declarationsIlabels_collect :: (FMap Name Names)
            _declarationsImethods_collect :: (FMap Name Names)
            _declarationsIpresignatures_collect :: (PreSignatures)
            _declarationsIself :: (Declarations)
            _declarationsOclassname :: (Maybe Name)
            _declarationsOconstructors_collect :: (FMap Name Names)
            _declarationsOconstructors_dist :: (FMap Name Names)
            _declarationsOcurrentModule :: (Strings)
            _declarationsOdependencies_collect :: (FMap Name [(Name,Name)])
            _declarationsOimportedModule :: (Bool)
            _declarationsOinferredDependencies :: (FMap Name [(Name,Name)])
            _declarationsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _declarationsOinstancename :: (Maybe Name)
            _declarationsOlabels_collect :: (FMap Name Names)
            _declarationsOlabels_dist :: (FMap Name Names)
            _declarationsOlocal :: (Bool)
            _declarationsOmethods_collect :: (FMap Name Names)
            _declarationsOmethods_dist :: (FMap Name Names)
            _declarationsOpresignatures :: (PreSignatures)
            _declarationsOpresignatures_collect :: (PreSignatures)
            _declarationsOsignatures :: (Signatures)
            _declarationsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _importdeclarationsIconstructors_collect,_importdeclarationsIdependencies_collect,_importdeclarationsIinferredDependencies_collect,_importdeclarationsIlabels_collect,_importdeclarationsImethods_collect,_importdeclarationsIpresignatures_collect,_importdeclarationsIself) =
                (importdeclarations_ (_importdeclarationsOclassname)
                                     (_importdeclarationsOconstructors_collect)
                                     (_importdeclarationsOconstructors_dist)
                                     (_importdeclarationsOcurrentModule)
                                     (_importdeclarationsOdependencies_collect)
                                     (_importdeclarationsOimportedModule)
                                     (_importdeclarationsOinferredDependencies)
                                     (_importdeclarationsOinferredDependencies_collect)
                                     (_importdeclarationsOinstancename)
                                     (_importdeclarationsOlabels_collect)
                                     (_importdeclarationsOlabels_dist)
                                     (_importdeclarationsOlocal)
                                     (_importdeclarationsOmethods_collect)
                                     (_importdeclarationsOmethods_dist)
                                     (_importdeclarationsOpresignatures)
                                     (_importdeclarationsOpresignatures_collect)
                                     (_importdeclarationsOsignatures)
                                     (_importdeclarationsOtoplevel))
            ( _declarationsIbodyDependencies,_declarationsIconstructors_collect,_declarationsIdependencies_collect,_declarationsIinferredDependencies_collect,_declarationsIlabels_collect,_declarationsImethods_collect,_declarationsIpresignatures_collect,_declarationsIself) =
                (declarations_ (_declarationsOclassname)
                               (_declarationsOconstructors_collect)
                               (_declarationsOconstructors_dist)
                               (_declarationsOcurrentModule)
                               (_declarationsOdependencies_collect)
                               (_declarationsOimportedModule)
                               (_declarationsOinferredDependencies)
                               (_declarationsOinferredDependencies_collect)
                               (_declarationsOinstancename)
                               (_declarationsOlabels_collect)
                               (_declarationsOlabels_dist)
                               (_declarationsOlocal)
                               (_declarationsOmethods_collect)
                               (_declarationsOmethods_dist)
                               (_declarationsOpresignatures)
                               (_declarationsOpresignatures_collect)
                               (_declarationsOsignatures)
                               (_declarationsOtoplevel))
            -- self rule
            (_self@_) =
                Body_Body _rangeIself _importdeclarationsIself _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _declarationsIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _declarationsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _declarationsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _declarationsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _declarationsImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _declarationsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_importdeclarationsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_importdeclarationsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_importdeclarationsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_importdeclarationsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_importdeclarationsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_importdeclarationsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_importdeclarationsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_importdeclarationsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_importdeclarationsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_importdeclarationsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_importdeclarationsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_importdeclarationsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_importdeclarationsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_importdeclarationsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_importdeclarationsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_importdeclarationsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_importdeclarationsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_importdeclarationsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_declarationsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_declarationsOconstructors_collect@_) =
                _importdeclarationsIconstructors_collect
            -- copy rule (down)
            (_declarationsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_declarationsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_declarationsOdependencies_collect@_) =
                _importdeclarationsIdependencies_collect
            -- copy rule (down)
            (_declarationsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_declarationsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_declarationsOinferredDependencies_collect@_) =
                _importdeclarationsIinferredDependencies_collect
            -- copy rule (down)
            (_declarationsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_declarationsOlabels_collect@_) =
                _importdeclarationsIlabels_collect
            -- copy rule (down)
            (_declarationsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_declarationsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_declarationsOmethods_collect@_) =
                _importdeclarationsImethods_collect
            -- copy rule (down)
            (_declarationsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_declarationsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_declarationsOpresignatures_collect@_) =
                _importdeclarationsIpresignatures_collect
            -- copy rule (down)
            (_declarationsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_declarationsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- Constructor -------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      constructors         : Names
      labels               : Names
      self                 : SELF

-}
{-
   local variables for Constructor.Constructor:
      self

-}
{-
   local variables for Constructor.Infix:
      self

-}
{-
   local variables for Constructor.Record:
      self

-}
-- semantic domain
type T_Constructor = (Maybe Name) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Strings) ->
                     (FMap Name [(Name,Name)]) ->
                     (Bool) ->
                     (FMap Name [(Name,Name)]) ->
                     (FMap Name [(Name,Name)]) ->
                     (Maybe Name) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Bool) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Bool) ->
                     ( (Names),(FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(Names),(FMap Name Names),(FMap Name Names),(Constructor))
-- cata
sem_Constructor :: (Constructor) ->
                   (T_Constructor)
sem_Constructor ((Constructor_Constructor (_range) (_constructor) (_types))) =
    (sem_Constructor_Constructor ((sem_Range (_range))) ((sem_Name (_constructor))) ((sem_AnnotatedTypes (_types))))
sem_Constructor ((Constructor_Infix (_range) (_leftType) (_constructorOperator) (_rightType))) =
    (sem_Constructor_Infix ((sem_Range (_range))) ((sem_AnnotatedType (_leftType))) ((sem_Name (_constructorOperator))) ((sem_AnnotatedType (_rightType))))
sem_Constructor ((Constructor_Record (_range) (_constructor) (_fieldDeclarations))) =
    (sem_Constructor_Record ((sem_Range (_range))) ((sem_Name (_constructor))) ((sem_FieldDeclarations (_fieldDeclarations))))
sem_Constructor_Constructor :: (T_Range) ->
                               (T_Name) ->
                               (T_AnnotatedTypes) ->
                               (T_Constructor)
sem_Constructor_Constructor (range_) (constructor_) (types_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors :: (Names)
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels :: (Names)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Constructor)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _constructorIconstructors_collect :: (FMap Name Names)
            _constructorIdependencies_collect :: (FMap Name [(Name,Name)])
            _constructorIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _constructorIlabels_collect :: (FMap Name Names)
            _constructorImethods_collect :: (FMap Name Names)
            _constructorIself :: (Name)
            _constructorOclassname :: (Maybe Name)
            _constructorOconstructors_collect :: (FMap Name Names)
            _constructorOconstructors_dist :: (FMap Name Names)
            _constructorOcurrentModule :: (Strings)
            _constructorOdependencies_collect :: (FMap Name [(Name,Name)])
            _constructorOimportedModule :: (Bool)
            _constructorOinferredDependencies :: (FMap Name [(Name,Name)])
            _constructorOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _constructorOinstancename :: (Maybe Name)
            _constructorOlabels_collect :: (FMap Name Names)
            _constructorOlabels_dist :: (FMap Name Names)
            _constructorOlocal :: (Bool)
            _constructorOmethods_collect :: (FMap Name Names)
            _constructorOmethods_dist :: (FMap Name Names)
            _constructorOtoplevel :: (Bool)
            _typesIconstructors_collect :: (FMap Name Names)
            _typesIdependencies_collect :: (FMap Name [(Name,Name)])
            _typesIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typesIlabels_collect :: (FMap Name Names)
            _typesImethods_collect :: (FMap Name Names)
            _typesIself :: (AnnotatedTypes)
            _typesOclassname :: (Maybe Name)
            _typesOconstructors_collect :: (FMap Name Names)
            _typesOconstructors_dist :: (FMap Name Names)
            _typesOcurrentModule :: (Strings)
            _typesOdependencies_collect :: (FMap Name [(Name,Name)])
            _typesOimportedModule :: (Bool)
            _typesOinferredDependencies :: (FMap Name [(Name,Name)])
            _typesOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typesOinstancename :: (Maybe Name)
            _typesOlabels_collect :: (FMap Name Names)
            _typesOlabels_dist :: (FMap Name Names)
            _typesOlocal :: (Bool)
            _typesOmethods_collect :: (FMap Name Names)
            _typesOmethods_dist :: (FMap Name Names)
            _typesOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _constructorIconstructors_collect,_constructorIdependencies_collect,_constructorIinferredDependencies_collect,_constructorIlabels_collect,_constructorImethods_collect,_constructorIself) =
                (constructor_ (_constructorOclassname)
                              (_constructorOconstructors_collect)
                              (_constructorOconstructors_dist)
                              (_constructorOcurrentModule)
                              (_constructorOdependencies_collect)
                              (_constructorOimportedModule)
                              (_constructorOinferredDependencies)
                              (_constructorOinferredDependencies_collect)
                              (_constructorOinstancename)
                              (_constructorOlabels_collect)
                              (_constructorOlabels_dist)
                              (_constructorOlocal)
                              (_constructorOmethods_collect)
                              (_constructorOmethods_dist)
                              (_constructorOtoplevel))
            ( _typesIconstructors_collect,_typesIdependencies_collect,_typesIinferredDependencies_collect,_typesIlabels_collect,_typesImethods_collect,_typesIself) =
                (types_ (_typesOclassname) (_typesOconstructors_collect) (_typesOconstructors_dist) (_typesOcurrentModule) (_typesOdependencies_collect) (_typesOimportedModule) (_typesOinferredDependencies) (_typesOinferredDependencies_collect) (_typesOinstancename) (_typesOlabels_collect) (_typesOlabels_dist) (_typesOlocal) (_typesOmethods_collect) (_typesOmethods_dist) (_typesOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 360, column 9)
            (_lhsOconstructors@_) =
                [_constructorIself]
            -- use rule
            (_lhsOlabels@_) =
                []
            -- self rule
            (_self@_) =
                Constructor_Constructor _rangeIself _constructorIself _typesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typesIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _typesIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _typesIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typesIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typesImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_constructorOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_constructorOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_constructorOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_constructorOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_constructorOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_constructorOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_constructorOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_constructorOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_constructorOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_constructorOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_constructorOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_constructorOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_constructorOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_constructorOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_constructorOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typesOconstructors_collect@_) =
                _constructorIconstructors_collect
            -- copy rule (down)
            (_typesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_typesOdependencies_collect@_) =
                _constructorIdependencies_collect
            -- copy rule (down)
            (_typesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typesOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_typesOinferredDependencies_collect@_) =
                _constructorIinferredDependencies_collect
            -- copy rule (down)
            (_typesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typesOlabels_collect@_) =
                _constructorIlabels_collect
            -- copy rule (down)
            (_typesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typesOmethods_collect@_) =
                _constructorImethods_collect
            -- copy rule (down)
            (_typesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typesOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Constructor_Infix :: (T_Range) ->
                         (T_AnnotatedType) ->
                         (T_Name) ->
                         (T_AnnotatedType) ->
                         (T_Constructor)
sem_Constructor_Infix (range_) (leftType_) (constructorOperator_) (rightType_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors :: (Names)
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels :: (Names)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Constructor)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _leftTypeIconstructors_collect :: (FMap Name Names)
            _leftTypeIdependencies_collect :: (FMap Name [(Name,Name)])
            _leftTypeIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _leftTypeIlabels_collect :: (FMap Name Names)
            _leftTypeImethods_collect :: (FMap Name Names)
            _leftTypeIself :: (AnnotatedType)
            _leftTypeOclassname :: (Maybe Name)
            _leftTypeOconstructors_collect :: (FMap Name Names)
            _leftTypeOconstructors_dist :: (FMap Name Names)
            _leftTypeOcurrentModule :: (Strings)
            _leftTypeOdependencies_collect :: (FMap Name [(Name,Name)])
            _leftTypeOimportedModule :: (Bool)
            _leftTypeOinferredDependencies :: (FMap Name [(Name,Name)])
            _leftTypeOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _leftTypeOinstancename :: (Maybe Name)
            _leftTypeOlabels_collect :: (FMap Name Names)
            _leftTypeOlabels_dist :: (FMap Name Names)
            _leftTypeOlocal :: (Bool)
            _leftTypeOmethods_collect :: (FMap Name Names)
            _leftTypeOmethods_dist :: (FMap Name Names)
            _leftTypeOtoplevel :: (Bool)
            _constructorOperatorIconstructors_collect :: (FMap Name Names)
            _constructorOperatorIdependencies_collect :: (FMap Name [(Name,Name)])
            _constructorOperatorIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _constructorOperatorIlabels_collect :: (FMap Name Names)
            _constructorOperatorImethods_collect :: (FMap Name Names)
            _constructorOperatorIself :: (Name)
            _constructorOperatorOclassname :: (Maybe Name)
            _constructorOperatorOconstructors_collect :: (FMap Name Names)
            _constructorOperatorOconstructors_dist :: (FMap Name Names)
            _constructorOperatorOcurrentModule :: (Strings)
            _constructorOperatorOdependencies_collect :: (FMap Name [(Name,Name)])
            _constructorOperatorOimportedModule :: (Bool)
            _constructorOperatorOinferredDependencies :: (FMap Name [(Name,Name)])
            _constructorOperatorOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _constructorOperatorOinstancename :: (Maybe Name)
            _constructorOperatorOlabels_collect :: (FMap Name Names)
            _constructorOperatorOlabels_dist :: (FMap Name Names)
            _constructorOperatorOlocal :: (Bool)
            _constructorOperatorOmethods_collect :: (FMap Name Names)
            _constructorOperatorOmethods_dist :: (FMap Name Names)
            _constructorOperatorOtoplevel :: (Bool)
            _rightTypeIconstructors_collect :: (FMap Name Names)
            _rightTypeIdependencies_collect :: (FMap Name [(Name,Name)])
            _rightTypeIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _rightTypeIlabels_collect :: (FMap Name Names)
            _rightTypeImethods_collect :: (FMap Name Names)
            _rightTypeIself :: (AnnotatedType)
            _rightTypeOclassname :: (Maybe Name)
            _rightTypeOconstructors_collect :: (FMap Name Names)
            _rightTypeOconstructors_dist :: (FMap Name Names)
            _rightTypeOcurrentModule :: (Strings)
            _rightTypeOdependencies_collect :: (FMap Name [(Name,Name)])
            _rightTypeOimportedModule :: (Bool)
            _rightTypeOinferredDependencies :: (FMap Name [(Name,Name)])
            _rightTypeOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _rightTypeOinstancename :: (Maybe Name)
            _rightTypeOlabels_collect :: (FMap Name Names)
            _rightTypeOlabels_dist :: (FMap Name Names)
            _rightTypeOlocal :: (Bool)
            _rightTypeOmethods_collect :: (FMap Name Names)
            _rightTypeOmethods_dist :: (FMap Name Names)
            _rightTypeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _leftTypeIconstructors_collect,_leftTypeIdependencies_collect,_leftTypeIinferredDependencies_collect,_leftTypeIlabels_collect,_leftTypeImethods_collect,_leftTypeIself) =
                (leftType_ (_leftTypeOclassname) (_leftTypeOconstructors_collect) (_leftTypeOconstructors_dist) (_leftTypeOcurrentModule) (_leftTypeOdependencies_collect) (_leftTypeOimportedModule) (_leftTypeOinferredDependencies) (_leftTypeOinferredDependencies_collect) (_leftTypeOinstancename) (_leftTypeOlabels_collect) (_leftTypeOlabels_dist) (_leftTypeOlocal) (_leftTypeOmethods_collect) (_leftTypeOmethods_dist) (_leftTypeOtoplevel))
            ( _constructorOperatorIconstructors_collect,_constructorOperatorIdependencies_collect,_constructorOperatorIinferredDependencies_collect,_constructorOperatorIlabels_collect,_constructorOperatorImethods_collect,_constructorOperatorIself) =
                (constructorOperator_ (_constructorOperatorOclassname)
                                      (_constructorOperatorOconstructors_collect)
                                      (_constructorOperatorOconstructors_dist)
                                      (_constructorOperatorOcurrentModule)
                                      (_constructorOperatorOdependencies_collect)
                                      (_constructorOperatorOimportedModule)
                                      (_constructorOperatorOinferredDependencies)
                                      (_constructorOperatorOinferredDependencies_collect)
                                      (_constructorOperatorOinstancename)
                                      (_constructorOperatorOlabels_collect)
                                      (_constructorOperatorOlabels_dist)
                                      (_constructorOperatorOlocal)
                                      (_constructorOperatorOmethods_collect)
                                      (_constructorOperatorOmethods_dist)
                                      (_constructorOperatorOtoplevel))
            ( _rightTypeIconstructors_collect,_rightTypeIdependencies_collect,_rightTypeIinferredDependencies_collect,_rightTypeIlabels_collect,_rightTypeImethods_collect,_rightTypeIself) =
                (rightType_ (_rightTypeOclassname)
                            (_rightTypeOconstructors_collect)
                            (_rightTypeOconstructors_dist)
                            (_rightTypeOcurrentModule)
                            (_rightTypeOdependencies_collect)
                            (_rightTypeOimportedModule)
                            (_rightTypeOinferredDependencies)
                            (_rightTypeOinferredDependencies_collect)
                            (_rightTypeOinstancename)
                            (_rightTypeOlabels_collect)
                            (_rightTypeOlabels_dist)
                            (_rightTypeOlocal)
                            (_rightTypeOmethods_collect)
                            (_rightTypeOmethods_dist)
                            (_rightTypeOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 362, column 9)
            (_lhsOconstructors@_) =
                [_constructorOperatorIself]
            -- use rule
            (_lhsOlabels@_) =
                []
            -- self rule
            (_self@_) =
                Constructor_Infix _rangeIself _leftTypeIself _constructorOperatorIself _rightTypeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _rightTypeIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _rightTypeIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _rightTypeIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _rightTypeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _rightTypeImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_leftTypeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_leftTypeOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_leftTypeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_leftTypeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_leftTypeOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_leftTypeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_leftTypeOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_leftTypeOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_leftTypeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_leftTypeOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_leftTypeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_leftTypeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_leftTypeOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_leftTypeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_leftTypeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_constructorOperatorOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_constructorOperatorOconstructors_collect@_) =
                _leftTypeIconstructors_collect
            -- copy rule (down)
            (_constructorOperatorOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_constructorOperatorOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_constructorOperatorOdependencies_collect@_) =
                _leftTypeIdependencies_collect
            -- copy rule (down)
            (_constructorOperatorOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_constructorOperatorOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_constructorOperatorOinferredDependencies_collect@_) =
                _leftTypeIinferredDependencies_collect
            -- copy rule (down)
            (_constructorOperatorOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_constructorOperatorOlabels_collect@_) =
                _leftTypeIlabels_collect
            -- copy rule (down)
            (_constructorOperatorOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_constructorOperatorOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_constructorOperatorOmethods_collect@_) =
                _leftTypeImethods_collect
            -- copy rule (down)
            (_constructorOperatorOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_constructorOperatorOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_rightTypeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_rightTypeOconstructors_collect@_) =
                _constructorOperatorIconstructors_collect
            -- copy rule (down)
            (_rightTypeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_rightTypeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_rightTypeOdependencies_collect@_) =
                _constructorOperatorIdependencies_collect
            -- copy rule (down)
            (_rightTypeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rightTypeOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_rightTypeOinferredDependencies_collect@_) =
                _constructorOperatorIinferredDependencies_collect
            -- copy rule (down)
            (_rightTypeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_rightTypeOlabels_collect@_) =
                _constructorOperatorIlabels_collect
            -- copy rule (down)
            (_rightTypeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_rightTypeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_rightTypeOmethods_collect@_) =
                _constructorOperatorImethods_collect
            -- copy rule (down)
            (_rightTypeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_rightTypeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Constructor_Record :: (T_Range) ->
                          (T_Name) ->
                          (T_FieldDeclarations) ->
                          (T_Constructor)
sem_Constructor_Record (range_) (constructor_) (fieldDeclarations_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors :: (Names)
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels :: (Names)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Constructor)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _constructorIconstructors_collect :: (FMap Name Names)
            _constructorIdependencies_collect :: (FMap Name [(Name,Name)])
            _constructorIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _constructorIlabels_collect :: (FMap Name Names)
            _constructorImethods_collect :: (FMap Name Names)
            _constructorIself :: (Name)
            _constructorOclassname :: (Maybe Name)
            _constructorOconstructors_collect :: (FMap Name Names)
            _constructorOconstructors_dist :: (FMap Name Names)
            _constructorOcurrentModule :: (Strings)
            _constructorOdependencies_collect :: (FMap Name [(Name,Name)])
            _constructorOimportedModule :: (Bool)
            _constructorOinferredDependencies :: (FMap Name [(Name,Name)])
            _constructorOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _constructorOinstancename :: (Maybe Name)
            _constructorOlabels_collect :: (FMap Name Names)
            _constructorOlabels_dist :: (FMap Name Names)
            _constructorOlocal :: (Bool)
            _constructorOmethods_collect :: (FMap Name Names)
            _constructorOmethods_dist :: (FMap Name Names)
            _constructorOtoplevel :: (Bool)
            _fieldDeclarationsIconstructors :: (Names)
            _fieldDeclarationsIconstructors_collect :: (FMap Name Names)
            _fieldDeclarationsIdependencies_collect :: (FMap Name [(Name,Name)])
            _fieldDeclarationsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _fieldDeclarationsIlabels :: (Names)
            _fieldDeclarationsIlabels_collect :: (FMap Name Names)
            _fieldDeclarationsImethods_collect :: (FMap Name Names)
            _fieldDeclarationsIself :: (FieldDeclarations)
            _fieldDeclarationsOclassname :: (Maybe Name)
            _fieldDeclarationsOconstructors_collect :: (FMap Name Names)
            _fieldDeclarationsOconstructors_dist :: (FMap Name Names)
            _fieldDeclarationsOcurrentModule :: (Strings)
            _fieldDeclarationsOdependencies_collect :: (FMap Name [(Name,Name)])
            _fieldDeclarationsOimportedModule :: (Bool)
            _fieldDeclarationsOinferredDependencies :: (FMap Name [(Name,Name)])
            _fieldDeclarationsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _fieldDeclarationsOinstancename :: (Maybe Name)
            _fieldDeclarationsOlabels_collect :: (FMap Name Names)
            _fieldDeclarationsOlabels_dist :: (FMap Name Names)
            _fieldDeclarationsOlocal :: (Bool)
            _fieldDeclarationsOmethods_collect :: (FMap Name Names)
            _fieldDeclarationsOmethods_dist :: (FMap Name Names)
            _fieldDeclarationsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _constructorIconstructors_collect,_constructorIdependencies_collect,_constructorIinferredDependencies_collect,_constructorIlabels_collect,_constructorImethods_collect,_constructorIself) =
                (constructor_ (_constructorOclassname)
                              (_constructorOconstructors_collect)
                              (_constructorOconstructors_dist)
                              (_constructorOcurrentModule)
                              (_constructorOdependencies_collect)
                              (_constructorOimportedModule)
                              (_constructorOinferredDependencies)
                              (_constructorOinferredDependencies_collect)
                              (_constructorOinstancename)
                              (_constructorOlabels_collect)
                              (_constructorOlabels_dist)
                              (_constructorOlocal)
                              (_constructorOmethods_collect)
                              (_constructorOmethods_dist)
                              (_constructorOtoplevel))
            ( _fieldDeclarationsIconstructors,_fieldDeclarationsIconstructors_collect,_fieldDeclarationsIdependencies_collect,_fieldDeclarationsIinferredDependencies_collect,_fieldDeclarationsIlabels,_fieldDeclarationsIlabels_collect,_fieldDeclarationsImethods_collect,_fieldDeclarationsIself) =
                (fieldDeclarations_ (_fieldDeclarationsOclassname)
                                    (_fieldDeclarationsOconstructors_collect)
                                    (_fieldDeclarationsOconstructors_dist)
                                    (_fieldDeclarationsOcurrentModule)
                                    (_fieldDeclarationsOdependencies_collect)
                                    (_fieldDeclarationsOimportedModule)
                                    (_fieldDeclarationsOinferredDependencies)
                                    (_fieldDeclarationsOinferredDependencies_collect)
                                    (_fieldDeclarationsOinstancename)
                                    (_fieldDeclarationsOlabels_collect)
                                    (_fieldDeclarationsOlabels_dist)
                                    (_fieldDeclarationsOlocal)
                                    (_fieldDeclarationsOmethods_collect)
                                    (_fieldDeclarationsOmethods_dist)
                                    (_fieldDeclarationsOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 364, column 9)
            (_lhsOconstructors@_) =
                [_constructorIself]
            -- use rule
            (_lhsOlabels@_) =
                _fieldDeclarationsIlabels
            -- self rule
            (_self@_) =
                Constructor_Record _rangeIself _constructorIself _fieldDeclarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _fieldDeclarationsIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _fieldDeclarationsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _fieldDeclarationsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _fieldDeclarationsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _fieldDeclarationsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_constructorOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_constructorOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_constructorOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_constructorOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_constructorOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_constructorOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_constructorOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_constructorOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_constructorOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_constructorOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_constructorOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_constructorOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_constructorOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_constructorOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_constructorOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_fieldDeclarationsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_fieldDeclarationsOconstructors_collect@_) =
                _constructorIconstructors_collect
            -- copy rule (down)
            (_fieldDeclarationsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_fieldDeclarationsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_fieldDeclarationsOdependencies_collect@_) =
                _constructorIdependencies_collect
            -- copy rule (down)
            (_fieldDeclarationsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_fieldDeclarationsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_fieldDeclarationsOinferredDependencies_collect@_) =
                _constructorIinferredDependencies_collect
            -- copy rule (down)
            (_fieldDeclarationsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_fieldDeclarationsOlabels_collect@_) =
                _constructorIlabels_collect
            -- copy rule (down)
            (_fieldDeclarationsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_fieldDeclarationsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_fieldDeclarationsOmethods_collect@_) =
                _constructorImethods_collect
            -- copy rule (down)
            (_fieldDeclarationsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_fieldDeclarationsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- Constructors ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      constructors         : Names
      labels               : Names
      self                 : SELF

-}
{-
   local variables for Constructors.Cons:
      self

-}
{-
   local variables for Constructors.Nil:
      self

-}
-- semantic domain
type T_Constructors = (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Strings) ->
                      (FMap Name [(Name,Name)]) ->
                      (Bool) ->
                      (FMap Name [(Name,Name)]) ->
                      (FMap Name [(Name,Name)]) ->
                      (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      ( (Names),(FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(Names),(FMap Name Names),(FMap Name Names),(Constructors))
-- cata
sem_Constructors :: (Constructors) ->
                    (T_Constructors)
sem_Constructors (list) =
    (foldr (sem_Constructors_Cons) (sem_Constructors_Nil) ((map sem_Constructor list)))
sem_Constructors_Cons :: (T_Constructor) ->
                         (T_Constructors) ->
                         (T_Constructors)
sem_Constructors_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors :: (Names)
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels :: (Names)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Constructors)
            _hdIconstructors :: (Names)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdependencies_collect :: (FMap Name [(Name,Name)])
            _hdIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdIlabels :: (Names)
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIself :: (Constructor)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies_collect :: (FMap Name [(Name,Name)])
            _hdOimportedModule :: (Bool)
            _hdOinferredDependencies :: (FMap Name [(Name,Name)])
            _hdOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdOinstancename :: (Maybe Name)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOtoplevel :: (Bool)
            _tlIconstructors :: (Names)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdependencies_collect :: (FMap Name [(Name,Name)])
            _tlIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlIlabels :: (Names)
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIself :: (Constructors)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies_collect :: (FMap Name [(Name,Name)])
            _tlOimportedModule :: (Bool)
            _tlOinferredDependencies :: (FMap Name [(Name,Name)])
            _tlOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors,_hdIconstructors_collect,_hdIdependencies_collect,_hdIinferredDependencies_collect,_hdIlabels,_hdIlabels_collect,_hdImethods_collect,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOdependencies_collect) (_hdOimportedModule) (_hdOinferredDependencies) (_hdOinferredDependencies_collect) (_hdOinstancename) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOtoplevel))
            ( _tlIconstructors,_tlIconstructors_collect,_tlIdependencies_collect,_tlIinferredDependencies_collect,_tlIlabels,_tlIlabels_collect,_tlImethods_collect,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOdependencies_collect) (_tlOimportedModule) (_tlOinferredDependencies) (_tlOinferredDependencies_collect) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOtoplevel))
            -- use rule
            (_lhsOconstructors@_) =
                _hdIconstructors ++ _tlIconstructors
            -- use rule
            (_lhsOlabels@_) =
                _hdIlabels `List.union` _tlIlabels
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _tlIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _tlIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_hdOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_tlOdependencies_collect@_) =
                _hdIdependencies_collect
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_tlOinferredDependencies_collect@_) =
                _hdIinferredDependencies_collect
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Constructors_Nil :: (T_Constructors)
sem_Constructors_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors :: (Names)
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels :: (Names)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Constructors)
            -- use rule
            (_lhsOconstructors@_) =
                []
            -- use rule
            (_lhsOlabels@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- ContextItem -------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      localDependencies    : [(Name,Name)]
      self                 : SELF

-}
{-
   local variables for ContextItem.ContextItem:
      self

-}
{-
   local variables for ContextItem.DependencyConstraint:
      self

-}
{-
   local variables for ContextItem.DependencyItem:
      self

-}
-- semantic domain
type T_ContextItem = (Maybe Name) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Strings) ->
                     (FMap Name [(Name,Name)]) ->
                     (Bool) ->
                     (FMap Name [(Name,Name)]) ->
                     (FMap Name [(Name,Name)]) ->
                     (Maybe Name) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Bool) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Bool) ->
                     ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),([(Name,Name)]),(FMap Name Names),(ContextItem))
-- cata
sem_ContextItem :: (ContextItem) ->
                   (T_ContextItem)
sem_ContextItem ((ContextItem_ContextItem (_range) (_name) (_types))) =
    (sem_ContextItem_ContextItem ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Types (_types))))
sem_ContextItem ((ContextItem_DependencyConstraint (_range) (_name) (_typevariable) (_type))) =
    (sem_ContextItem_DependencyConstraint ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Name (_typevariable))) ((sem_Type (_type))))
sem_ContextItem ((ContextItem_DependencyItem (_range) (_name) (_generics) (_parametrics) (_asname))) =
    (sem_ContextItem_DependencyItem ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Names (_generics))) ((sem_Types (_parametrics))) ((sem_MaybeName (_asname))))
sem_ContextItem_ContextItem :: (T_Range) ->
                               (T_Name) ->
                               (T_Types) ->
                               (T_ContextItem)
sem_ContextItem_ContextItem (range_) (name_) (types_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOlocalDependencies :: ([(Name,Name)])
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (ContextItem)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _typesIconstructors_collect :: (FMap Name Names)
            _typesIdependencies_collect :: (FMap Name [(Name,Name)])
            _typesIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typesIlabels_collect :: (FMap Name Names)
            _typesImethods_collect :: (FMap Name Names)
            _typesIself :: (Types)
            _typesOclassname :: (Maybe Name)
            _typesOconstructors_collect :: (FMap Name Names)
            _typesOconstructors_dist :: (FMap Name Names)
            _typesOcurrentModule :: (Strings)
            _typesOdependencies_collect :: (FMap Name [(Name,Name)])
            _typesOimportedModule :: (Bool)
            _typesOinferredDependencies :: (FMap Name [(Name,Name)])
            _typesOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typesOinstancename :: (Maybe Name)
            _typesOlabels_collect :: (FMap Name Names)
            _typesOlabels_dist :: (FMap Name Names)
            _typesOlocal :: (Bool)
            _typesOmethods_collect :: (FMap Name Names)
            _typesOmethods_dist :: (FMap Name Names)
            _typesOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _typesIconstructors_collect,_typesIdependencies_collect,_typesIinferredDependencies_collect,_typesIlabels_collect,_typesImethods_collect,_typesIself) =
                (types_ (_typesOclassname) (_typesOconstructors_collect) (_typesOconstructors_dist) (_typesOcurrentModule) (_typesOdependencies_collect) (_typesOimportedModule) (_typesOinferredDependencies) (_typesOinferredDependencies_collect) (_typesOinstancename) (_typesOlabels_collect) (_typesOlabels_dist) (_typesOlocal) (_typesOmethods_collect) (_typesOmethods_dist) (_typesOtoplevel))
            -- use rule
            (_lhsOlocalDependencies@_) =
                []
            -- self rule
            (_self@_) =
                ContextItem_ContextItem _rangeIself _nameIself _typesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typesIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _typesIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _typesIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typesIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typesImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typesOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_typesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_typesOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_typesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typesOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_typesOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_typesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typesOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_typesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typesOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_typesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typesOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOlocalDependencies,_lhsOmethods_collect,_lhsOself)
sem_ContextItem_DependencyConstraint :: (T_Range) ->
                                        (T_Name) ->
                                        (T_Name) ->
                                        (T_Type) ->
                                        (T_ContextItem)
sem_ContextItem_DependencyConstraint (range_) (name_) (typevariable_) (type_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOlocalDependencies :: ([(Name,Name)])
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (ContextItem)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _typevariableIconstructors_collect :: (FMap Name Names)
            _typevariableIdependencies_collect :: (FMap Name [(Name,Name)])
            _typevariableIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typevariableIlabels_collect :: (FMap Name Names)
            _typevariableImethods_collect :: (FMap Name Names)
            _typevariableIself :: (Name)
            _typevariableOclassname :: (Maybe Name)
            _typevariableOconstructors_collect :: (FMap Name Names)
            _typevariableOconstructors_dist :: (FMap Name Names)
            _typevariableOcurrentModule :: (Strings)
            _typevariableOdependencies_collect :: (FMap Name [(Name,Name)])
            _typevariableOimportedModule :: (Bool)
            _typevariableOinferredDependencies :: (FMap Name [(Name,Name)])
            _typevariableOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typevariableOinstancename :: (Maybe Name)
            _typevariableOlabels_collect :: (FMap Name Names)
            _typevariableOlabels_dist :: (FMap Name Names)
            _typevariableOlocal :: (Bool)
            _typevariableOmethods_collect :: (FMap Name Names)
            _typevariableOmethods_dist :: (FMap Name Names)
            _typevariableOtoplevel :: (Bool)
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIdependencies_collect :: (FMap Name [(Name,Name)])
            _typeIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typeIlabels_collect :: (FMap Name Names)
            _typeIlocalDependencies :: ([(Name,Name)])
            _typeImethods_collect :: (FMap Name Names)
            _typeIself :: (Type)
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOdependencies_collect :: (FMap Name [(Name,Name)])
            _typeOimportedModule :: (Bool)
            _typeOinferredDependencies :: (FMap Name [(Name,Name)])
            _typeOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typeOinstancename :: (Maybe Name)
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _typevariableIconstructors_collect,_typevariableIdependencies_collect,_typevariableIinferredDependencies_collect,_typevariableIlabels_collect,_typevariableImethods_collect,_typevariableIself) =
                (typevariable_ (_typevariableOclassname)
                               (_typevariableOconstructors_collect)
                               (_typevariableOconstructors_dist)
                               (_typevariableOcurrentModule)
                               (_typevariableOdependencies_collect)
                               (_typevariableOimportedModule)
                               (_typevariableOinferredDependencies)
                               (_typevariableOinferredDependencies_collect)
                               (_typevariableOinstancename)
                               (_typevariableOlabels_collect)
                               (_typevariableOlabels_dist)
                               (_typevariableOlocal)
                               (_typevariableOmethods_collect)
                               (_typevariableOmethods_dist)
                               (_typevariableOtoplevel))
            ( _typeIconstructors_collect,_typeIdependencies_collect,_typeIinferredDependencies_collect,_typeIlabels_collect,_typeIlocalDependencies,_typeImethods_collect,_typeIself) =
                (type_ (_typeOclassname) (_typeOconstructors_collect) (_typeOconstructors_dist) (_typeOcurrentModule) (_typeOdependencies_collect) (_typeOimportedModule) (_typeOinferredDependencies) (_typeOinferredDependencies_collect) (_typeOinstancename) (_typeOlabels_collect) (_typeOlabels_dist) (_typeOlocal) (_typeOmethods_collect) (_typeOmethods_dist) (_typeOtoplevel))
            -- use rule
            (_lhsOlocalDependencies@_) =
                _typeIlocalDependencies
            -- self rule
            (_self@_) =
                ContextItem_DependencyConstraint _rangeIself _nameIself _typevariableIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _typeIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _typeIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typevariableOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typevariableOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_typevariableOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typevariableOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_typevariableOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_typevariableOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typevariableOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_typevariableOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_typevariableOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typevariableOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_typevariableOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typevariableOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typevariableOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_typevariableOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typevariableOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _typevariableIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_typeOdependencies_collect@_) =
                _typevariableIdependencies_collect
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_typeOinferredDependencies_collect@_) =
                _typevariableIinferredDependencies_collect
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _typevariableIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _typevariableImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOlocalDependencies,_lhsOmethods_collect,_lhsOself)
sem_ContextItem_DependencyItem :: (T_Range) ->
                                  (T_Name) ->
                                  (T_Names) ->
                                  (T_Types) ->
                                  (T_MaybeName) ->
                                  (T_ContextItem)
sem_ContextItem_DependencyItem (range_) (name_) (generics_) (parametrics_) (asname_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOlocalDependencies :: ([(Name,Name)])
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (ContextItem)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _genericsIconstructors_collect :: (FMap Name Names)
            _genericsIdependencies_collect :: (FMap Name [(Name,Name)])
            _genericsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _genericsIlabels_collect :: (FMap Name Names)
            _genericsImethods_collect :: (FMap Name Names)
            _genericsIself :: (Names)
            _genericsOclassname :: (Maybe Name)
            _genericsOconstructors_collect :: (FMap Name Names)
            _genericsOconstructors_dist :: (FMap Name Names)
            _genericsOcurrentModule :: (Strings)
            _genericsOdependencies_collect :: (FMap Name [(Name,Name)])
            _genericsOimportedModule :: (Bool)
            _genericsOinferredDependencies :: (FMap Name [(Name,Name)])
            _genericsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _genericsOinstancename :: (Maybe Name)
            _genericsOlabels_collect :: (FMap Name Names)
            _genericsOlabels_dist :: (FMap Name Names)
            _genericsOlocal :: (Bool)
            _genericsOmethods_collect :: (FMap Name Names)
            _genericsOmethods_dist :: (FMap Name Names)
            _genericsOtoplevel :: (Bool)
            _parametricsIconstructors_collect :: (FMap Name Names)
            _parametricsIdependencies_collect :: (FMap Name [(Name,Name)])
            _parametricsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _parametricsIlabels_collect :: (FMap Name Names)
            _parametricsImethods_collect :: (FMap Name Names)
            _parametricsIself :: (Types)
            _parametricsOclassname :: (Maybe Name)
            _parametricsOconstructors_collect :: (FMap Name Names)
            _parametricsOconstructors_dist :: (FMap Name Names)
            _parametricsOcurrentModule :: (Strings)
            _parametricsOdependencies_collect :: (FMap Name [(Name,Name)])
            _parametricsOimportedModule :: (Bool)
            _parametricsOinferredDependencies :: (FMap Name [(Name,Name)])
            _parametricsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _parametricsOinstancename :: (Maybe Name)
            _parametricsOlabels_collect :: (FMap Name Names)
            _parametricsOlabels_dist :: (FMap Name Names)
            _parametricsOlocal :: (Bool)
            _parametricsOmethods_collect :: (FMap Name Names)
            _parametricsOmethods_dist :: (FMap Name Names)
            _parametricsOtoplevel :: (Bool)
            _asnameIconstructors_collect :: (FMap Name Names)
            _asnameIdependencies_collect :: (FMap Name [(Name,Name)])
            _asnameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _asnameIlabels_collect :: (FMap Name Names)
            _asnameImethods_collect :: (FMap Name Names)
            _asnameIself :: (MaybeName)
            _asnameOclassname :: (Maybe Name)
            _asnameOconstructors_collect :: (FMap Name Names)
            _asnameOconstructors_dist :: (FMap Name Names)
            _asnameOcurrentModule :: (Strings)
            _asnameOdependencies_collect :: (FMap Name [(Name,Name)])
            _asnameOimportedModule :: (Bool)
            _asnameOinferredDependencies :: (FMap Name [(Name,Name)])
            _asnameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _asnameOinstancename :: (Maybe Name)
            _asnameOlabels_collect :: (FMap Name Names)
            _asnameOlabels_dist :: (FMap Name Names)
            _asnameOlocal :: (Bool)
            _asnameOmethods_collect :: (FMap Name Names)
            _asnameOmethods_dist :: (FMap Name Names)
            _asnameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _genericsIconstructors_collect,_genericsIdependencies_collect,_genericsIinferredDependencies_collect,_genericsIlabels_collect,_genericsImethods_collect,_genericsIself) =
                (generics_ (_genericsOclassname) (_genericsOconstructors_collect) (_genericsOconstructors_dist) (_genericsOcurrentModule) (_genericsOdependencies_collect) (_genericsOimportedModule) (_genericsOinferredDependencies) (_genericsOinferredDependencies_collect) (_genericsOinstancename) (_genericsOlabels_collect) (_genericsOlabels_dist) (_genericsOlocal) (_genericsOmethods_collect) (_genericsOmethods_dist) (_genericsOtoplevel))
            ( _parametricsIconstructors_collect,_parametricsIdependencies_collect,_parametricsIinferredDependencies_collect,_parametricsIlabels_collect,_parametricsImethods_collect,_parametricsIself) =
                (parametrics_ (_parametricsOclassname)
                              (_parametricsOconstructors_collect)
                              (_parametricsOconstructors_dist)
                              (_parametricsOcurrentModule)
                              (_parametricsOdependencies_collect)
                              (_parametricsOimportedModule)
                              (_parametricsOinferredDependencies)
                              (_parametricsOinferredDependencies_collect)
                              (_parametricsOinstancename)
                              (_parametricsOlabels_collect)
                              (_parametricsOlabels_dist)
                              (_parametricsOlocal)
                              (_parametricsOmethods_collect)
                              (_parametricsOmethods_dist)
                              (_parametricsOtoplevel))
            ( _asnameIconstructors_collect,_asnameIdependencies_collect,_asnameIinferredDependencies_collect,_asnameIlabels_collect,_asnameImethods_collect,_asnameIself) =
                (asname_ (_asnameOclassname) (_asnameOconstructors_collect) (_asnameOconstructors_dist) (_asnameOcurrentModule) (_asnameOdependencies_collect) (_asnameOimportedModule) (_asnameOinferredDependencies) (_asnameOinferredDependencies_collect) (_asnameOinstancename) (_asnameOlabels_collect) (_asnameOlabels_dist) (_asnameOlocal) (_asnameOmethods_collect) (_asnameOmethods_dist) (_asnameOtoplevel))
            -- "ScanDependencies.lag"(line 92, column 9)
            (_lhsOlocalDependencies@_) =
                case _asnameIself of
                  MaybeName_Nothing   -> [(_nameIself,_nameIself)]
                  MaybeName_Just asn  -> [(_nameIself,asn)]
            -- self rule
            (_self@_) =
                ContextItem_DependencyItem _rangeIself _nameIself _genericsIself _parametricsIself _asnameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _asnameIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _asnameIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _asnameIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _asnameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _asnameImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_genericsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_genericsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_genericsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_genericsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_genericsOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_genericsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_genericsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_genericsOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_genericsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_genericsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_genericsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_genericsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_genericsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_genericsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_genericsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_parametricsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_parametricsOconstructors_collect@_) =
                _genericsIconstructors_collect
            -- copy rule (down)
            (_parametricsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_parametricsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_parametricsOdependencies_collect@_) =
                _genericsIdependencies_collect
            -- copy rule (down)
            (_parametricsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_parametricsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_parametricsOinferredDependencies_collect@_) =
                _genericsIinferredDependencies_collect
            -- copy rule (down)
            (_parametricsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_parametricsOlabels_collect@_) =
                _genericsIlabels_collect
            -- copy rule (down)
            (_parametricsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_parametricsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_parametricsOmethods_collect@_) =
                _genericsImethods_collect
            -- copy rule (down)
            (_parametricsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_parametricsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_asnameOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_asnameOconstructors_collect@_) =
                _parametricsIconstructors_collect
            -- copy rule (down)
            (_asnameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_asnameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_asnameOdependencies_collect@_) =
                _parametricsIdependencies_collect
            -- copy rule (down)
            (_asnameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_asnameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_asnameOinferredDependencies_collect@_) =
                _parametricsIinferredDependencies_collect
            -- copy rule (down)
            (_asnameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_asnameOlabels_collect@_) =
                _parametricsIlabels_collect
            -- copy rule (down)
            (_asnameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_asnameOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_asnameOmethods_collect@_) =
                _parametricsImethods_collect
            -- copy rule (down)
            (_asnameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_asnameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOlocalDependencies,_lhsOmethods_collect,_lhsOself)
-- ContextItems ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      localDependencies    : [(Name,Name)]
      self                 : SELF

-}
{-
   local variables for ContextItems.Cons:
      self

-}
{-
   local variables for ContextItems.Nil:
      self

-}
-- semantic domain
type T_ContextItems = (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Strings) ->
                      (FMap Name [(Name,Name)]) ->
                      (Bool) ->
                      (FMap Name [(Name,Name)]) ->
                      (FMap Name [(Name,Name)]) ->
                      (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),([(Name,Name)]),(FMap Name Names),(ContextItems))
-- cata
sem_ContextItems :: (ContextItems) ->
                    (T_ContextItems)
sem_ContextItems (list) =
    (foldr (sem_ContextItems_Cons) (sem_ContextItems_Nil) ((map sem_ContextItem list)))
sem_ContextItems_Cons :: (T_ContextItem) ->
                         (T_ContextItems) ->
                         (T_ContextItems)
sem_ContextItems_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOlocalDependencies :: ([(Name,Name)])
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (ContextItems)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdependencies_collect :: (FMap Name [(Name,Name)])
            _hdIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdIlabels_collect :: (FMap Name Names)
            _hdIlocalDependencies :: ([(Name,Name)])
            _hdImethods_collect :: (FMap Name Names)
            _hdIself :: (ContextItem)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies_collect :: (FMap Name [(Name,Name)])
            _hdOimportedModule :: (Bool)
            _hdOinferredDependencies :: (FMap Name [(Name,Name)])
            _hdOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdOinstancename :: (Maybe Name)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdependencies_collect :: (FMap Name [(Name,Name)])
            _tlIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlIlabels_collect :: (FMap Name Names)
            _tlIlocalDependencies :: ([(Name,Name)])
            _tlImethods_collect :: (FMap Name Names)
            _tlIself :: (ContextItems)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies_collect :: (FMap Name [(Name,Name)])
            _tlOimportedModule :: (Bool)
            _tlOinferredDependencies :: (FMap Name [(Name,Name)])
            _tlOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIdependencies_collect,_hdIinferredDependencies_collect,_hdIlabels_collect,_hdIlocalDependencies,_hdImethods_collect,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOdependencies_collect) (_hdOimportedModule) (_hdOinferredDependencies) (_hdOinferredDependencies_collect) (_hdOinstancename) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIdependencies_collect,_tlIinferredDependencies_collect,_tlIlabels_collect,_tlIlocalDependencies,_tlImethods_collect,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOdependencies_collect) (_tlOimportedModule) (_tlOinferredDependencies) (_tlOinferredDependencies_collect) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOtoplevel))
            -- use rule
            (_lhsOlocalDependencies@_) =
                _hdIlocalDependencies ++ _tlIlocalDependencies
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _tlIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _tlIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_hdOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_tlOdependencies_collect@_) =
                _hdIdependencies_collect
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_tlOinferredDependencies_collect@_) =
                _hdIinferredDependencies_collect
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOlocalDependencies,_lhsOmethods_collect,_lhsOself)
sem_ContextItems_Nil :: (T_ContextItems)
sem_ContextItems_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOlocalDependencies :: ([(Name,Name)])
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (ContextItems)
            -- use rule
            (_lhsOlocalDependencies@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOlocalDependencies,_lhsOmethods_collect,_lhsOself)
-- Declaration -------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      bodyDependencies     : [(Name,Name)]
      self                 : SELF

-}
{-
   local variables for Declaration.Class:
      classname
      self

-}
{-
   local variables for Declaration.Data:
      self

-}
{-
   local variables for Declaration.Default:
      self

-}
{-
   local variables for Declaration.Dependency:
      self

-}
{-
   local variables for Declaration.Empty:
      self

-}
{-
   local variables for Declaration.Fixity:
      self

-}
{-
   local variables for Declaration.FunctionBindings:
      self

-}
{-
   local variables for Declaration.GenericTypeSignature:
      signature
      isMPCstyle
      self

-}
{-
   local variables for Declaration.Instance:
      instancename
      self

-}
{-
   local variables for Declaration.KindIndexedType:
      self

-}
{-
   local variables for Declaration.Newtype:
      self

-}
{-
   local variables for Declaration.PatternBinding:
      self

-}
{-
   local variables for Declaration.Type:
      self

-}
{-
   local variables for Declaration.TypeIndexedType:
      signature
      presignatures_collect
      first
      self

-}
{-
   local variables for Declaration.TypeIndexedValue:
      linkname
      signature_link
      presignature
      signature
      typeargument
      defaultcase
      presignatures_collect
      first
      self

-}
{-
   local variables for Declaration.TypeSignature:
      self

-}
-- semantic domain
type T_Declaration = (Maybe Name) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Strings) ->
                     (FMap Name [(Name,Name)]) ->
                     (Bool) ->
                     (FMap Name [(Name,Name)]) ->
                     (FMap Name [(Name,Name)]) ->
                     (Maybe Name) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Bool) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (PreSignatures) ->
                     (PreSignatures) ->
                     (Signatures) ->
                     (Bool) ->
                     ( ([(Name,Name)]),(FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(PreSignatures),(Declaration))
-- cata
sem_Declaration :: (Declaration) ->
                   (T_Declaration)
sem_Declaration ((Declaration_Class (_range) (_context) (_simpletype) (_where))) =
    (sem_Declaration_Class ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_SimpleType (_simpletype))) ((sem_MaybeDeclarations (_where))))
sem_Declaration ((Declaration_Data (_range) (_context) (_simpletype) (_constructors) (_derivings))) =
    (sem_Declaration_Data ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_SimpleType (_simpletype))) ((sem_Constructors (_constructors))) ((sem_Names (_derivings))))
sem_Declaration ((Declaration_Default (_range) (_types))) =
    (sem_Declaration_Default ((sem_Range (_range))) ((sem_Types (_types))))
sem_Declaration ((Declaration_Dependency (_range) (_typelevel) (_name) (_bindings))) =
    (sem_Declaration_Dependency ((sem_Range (_range))) (_typelevel) ((sem_Name (_name))) ((sem_DependencyBindings (_bindings))))
sem_Declaration ((Declaration_Empty (_range))) =
    (sem_Declaration_Empty ((sem_Range (_range))))
sem_Declaration ((Declaration_Fixity (_range) (_fixity) (_priority) (_operators))) =
    (sem_Declaration_Fixity ((sem_Range (_range))) ((sem_Fixity (_fixity))) ((sem_MaybeInt (_priority))) ((sem_Names (_operators))))
sem_Declaration ((Declaration_FunctionBindings (_range) (_bindings))) =
    (sem_Declaration_FunctionBindings ((sem_Range (_range))) ((sem_FunctionBindings (_bindings))))
sem_Declaration ((Declaration_GenericTypeSignature (_range) (_name) (_generics) (_parametrics) (_type))) =
    (sem_Declaration_GenericTypeSignature ((sem_Range (_range))) ((sem_Name (_name))) ((sem_KindAnnotatedNames (_generics))) ((sem_KindAnnotatedNames (_parametrics))) ((sem_Type (_type))))
sem_Declaration ((Declaration_Instance (_range) (_context) (_name) (_types) (_where))) =
    (sem_Declaration_Instance ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_Name (_name))) ((sem_Types (_types))) ((sem_MaybeDeclarations (_where))))
sem_Declaration ((Declaration_KindIndexedType (_range) (_bindings))) =
    (sem_Declaration_KindIndexedType ((sem_Range (_range))) ((sem_KindIndexedBindings (_bindings))))
sem_Declaration ((Declaration_Newtype (_range) (_context) (_simpletype) (_constructor) (_derivings))) =
    (sem_Declaration_Newtype ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_SimpleType (_simpletype))) ((sem_Constructor (_constructor))) ((sem_Names (_derivings))))
sem_Declaration ((Declaration_PatternBinding (_range) (_pattern) (_righthandside))) =
    (sem_Declaration_PatternBinding ((sem_Range (_range))) ((sem_Pattern (_pattern))) ((sem_RightHandSide (_righthandside))))
sem_Declaration ((Declaration_Type (_range) (_simpletype) (_type))) =
    (sem_Declaration_Type ((sem_Range (_range))) ((sem_SimpleType (_simpletype))) ((sem_Type (_type))))
sem_Declaration ((Declaration_TypeIndexedType (_range) (_name) (_typeargument) (_typevariables) (_constructor) (_derivings))) =
    (sem_Declaration_TypeIndexedType ((sem_Range (_range))) ((sem_Name (_name))) ((sem_TypeArgument (_typeargument))) ((sem_Names (_typevariables))) ((sem_Constructor (_constructor))) ((sem_Names (_derivings))))
sem_Declaration ((Declaration_TypeIndexedValue (_range) (_bindings))) =
    (sem_Declaration_TypeIndexedValue ((sem_Range (_range))) ((sem_TypeIndexedBindings (_bindings))))
sem_Declaration ((Declaration_TypeSignature (_range) (_names) (_type))) =
    (sem_Declaration_TypeSignature ((sem_Range (_range))) ((sem_Names (_names))) ((sem_Type (_type))))
sem_Declaration_Class :: (T_Range) ->
                         (T_ContextItems) ->
                         (T_SimpleType) ->
                         (T_MaybeDeclarations) ->
                         (T_Declaration)
sem_Declaration_Class (range_) (context_) (simpletype_) (where_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _contextIconstructors_collect :: (FMap Name Names)
            _contextIdependencies_collect :: (FMap Name [(Name,Name)])
            _contextIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _contextIlabels_collect :: (FMap Name Names)
            _contextIlocalDependencies :: ([(Name,Name)])
            _contextImethods_collect :: (FMap Name Names)
            _contextIself :: (ContextItems)
            _contextOclassname :: (Maybe Name)
            _contextOconstructors_collect :: (FMap Name Names)
            _contextOconstructors_dist :: (FMap Name Names)
            _contextOcurrentModule :: (Strings)
            _contextOdependencies_collect :: (FMap Name [(Name,Name)])
            _contextOimportedModule :: (Bool)
            _contextOinferredDependencies :: (FMap Name [(Name,Name)])
            _contextOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _contextOinstancename :: (Maybe Name)
            _contextOlabels_collect :: (FMap Name Names)
            _contextOlabels_dist :: (FMap Name Names)
            _contextOlocal :: (Bool)
            _contextOmethods_collect :: (FMap Name Names)
            _contextOmethods_dist :: (FMap Name Names)
            _contextOtoplevel :: (Bool)
            _simpletypeIconstructors_collect :: (FMap Name Names)
            _simpletypeIdependencies_collect :: (FMap Name [(Name,Name)])
            _simpletypeIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _simpletypeIlabels_collect :: (FMap Name Names)
            _simpletypeImethods_collect :: (FMap Name Names)
            _simpletypeIname :: (Name)
            _simpletypeIself :: (SimpleType)
            _simpletypeOclassname :: (Maybe Name)
            _simpletypeOconstructors_collect :: (FMap Name Names)
            _simpletypeOconstructors_dist :: (FMap Name Names)
            _simpletypeOcurrentModule :: (Strings)
            _simpletypeOdependencies_collect :: (FMap Name [(Name,Name)])
            _simpletypeOimportedModule :: (Bool)
            _simpletypeOinferredDependencies :: (FMap Name [(Name,Name)])
            _simpletypeOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _simpletypeOinstancename :: (Maybe Name)
            _simpletypeOlabels_collect :: (FMap Name Names)
            _simpletypeOlabels_dist :: (FMap Name Names)
            _simpletypeOlocal :: (Bool)
            _simpletypeOmethods_collect :: (FMap Name Names)
            _simpletypeOmethods_dist :: (FMap Name Names)
            _simpletypeOtoplevel :: (Bool)
            _whereIbodyDependencies :: ([(Name,Name)])
            _whereIconstructors_collect :: (FMap Name Names)
            _whereIdependencies_collect :: (FMap Name [(Name,Name)])
            _whereIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _whereIlabels_collect :: (FMap Name Names)
            _whereImethods_collect :: (FMap Name Names)
            _whereIpresignatures_collect :: (PreSignatures)
            _whereIself :: (MaybeDeclarations)
            _whereOclassname :: (Maybe Name)
            _whereOconstructors_collect :: (FMap Name Names)
            _whereOconstructors_dist :: (FMap Name Names)
            _whereOcurrentModule :: (Strings)
            _whereOdependencies_collect :: (FMap Name [(Name,Name)])
            _whereOimportedModule :: (Bool)
            _whereOinferredDependencies :: (FMap Name [(Name,Name)])
            _whereOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _whereOinstancename :: (Maybe Name)
            _whereOlabels_collect :: (FMap Name Names)
            _whereOlabels_dist :: (FMap Name Names)
            _whereOlocal :: (Bool)
            _whereOmethods_collect :: (FMap Name Names)
            _whereOmethods_dist :: (FMap Name Names)
            _whereOpresignatures :: (PreSignatures)
            _whereOpresignatures_collect :: (PreSignatures)
            _whereOsignatures :: (Signatures)
            _whereOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _contextIconstructors_collect,_contextIdependencies_collect,_contextIinferredDependencies_collect,_contextIlabels_collect,_contextIlocalDependencies,_contextImethods_collect,_contextIself) =
                (context_ (_contextOclassname) (_contextOconstructors_collect) (_contextOconstructors_dist) (_contextOcurrentModule) (_contextOdependencies_collect) (_contextOimportedModule) (_contextOinferredDependencies) (_contextOinferredDependencies_collect) (_contextOinstancename) (_contextOlabels_collect) (_contextOlabels_dist) (_contextOlocal) (_contextOmethods_collect) (_contextOmethods_dist) (_contextOtoplevel))
            ( _simpletypeIconstructors_collect,_simpletypeIdependencies_collect,_simpletypeIinferredDependencies_collect,_simpletypeIlabels_collect,_simpletypeImethods_collect,_simpletypeIname,_simpletypeIself) =
                (simpletype_ (_simpletypeOclassname)
                             (_simpletypeOconstructors_collect)
                             (_simpletypeOconstructors_dist)
                             (_simpletypeOcurrentModule)
                             (_simpletypeOdependencies_collect)
                             (_simpletypeOimportedModule)
                             (_simpletypeOinferredDependencies)
                             (_simpletypeOinferredDependencies_collect)
                             (_simpletypeOinstancename)
                             (_simpletypeOlabels_collect)
                             (_simpletypeOlabels_dist)
                             (_simpletypeOlocal)
                             (_simpletypeOmethods_collect)
                             (_simpletypeOmethods_dist)
                             (_simpletypeOtoplevel))
            ( _whereIbodyDependencies,_whereIconstructors_collect,_whereIdependencies_collect,_whereIinferredDependencies_collect,_whereIlabels_collect,_whereImethods_collect,_whereIpresignatures_collect,_whereIself) =
                (where_ (_whereOclassname)
                        (_whereOconstructors_collect)
                        (_whereOconstructors_dist)
                        (_whereOcurrentModule)
                        (_whereOdependencies_collect)
                        (_whereOimportedModule)
                        (_whereOinferredDependencies)
                        (_whereOinferredDependencies_collect)
                        (_whereOinstancename)
                        (_whereOlabels_collect)
                        (_whereOlabels_dist)
                        (_whereOlocal)
                        (_whereOmethods_collect)
                        (_whereOmethods_dist)
                        (_whereOpresignatures)
                        (_whereOpresignatures_collect)
                        (_whereOsignatures)
                        (_whereOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 138, column 8)
            (_classname@_) =
                Just _simpletypeIname
            -- "./ModuleInformation.inc.lag"(line 331, column 9)
            (_whereOmethods_collect@_) =
                add _lhsImethods_collect
                    (_simpletypeIname,[])
            -- use rule
            (_lhsObodyDependencies@_) =
                _whereIbodyDependencies
            -- self rule
            (_self@_) =
                Declaration_Class _rangeIself _contextIself _simpletypeIself _whereIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _whereIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _whereIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _whereIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _whereIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _whereImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _whereIpresignatures_collect
            -- copy rule (chain)
            (_rangeOclassname@_) =
                _classname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_contextOclassname@_) =
                _classname
            -- copy rule (down)
            (_contextOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_contextOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_contextOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_contextOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_contextOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_contextOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_contextOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_contextOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_contextOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_contextOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_contextOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_contextOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_contextOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_contextOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_simpletypeOclassname@_) =
                _classname
            -- copy rule (chain)
            (_simpletypeOconstructors_collect@_) =
                _contextIconstructors_collect
            -- copy rule (down)
            (_simpletypeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_simpletypeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_simpletypeOdependencies_collect@_) =
                _contextIdependencies_collect
            -- copy rule (down)
            (_simpletypeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_simpletypeOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_simpletypeOinferredDependencies_collect@_) =
                _contextIinferredDependencies_collect
            -- copy rule (down)
            (_simpletypeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_simpletypeOlabels_collect@_) =
                _contextIlabels_collect
            -- copy rule (down)
            (_simpletypeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_simpletypeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_simpletypeOmethods_collect@_) =
                _contextImethods_collect
            -- copy rule (down)
            (_simpletypeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_simpletypeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_whereOclassname@_) =
                _classname
            -- copy rule (chain)
            (_whereOconstructors_collect@_) =
                _simpletypeIconstructors_collect
            -- copy rule (down)
            (_whereOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_whereOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_whereOdependencies_collect@_) =
                _simpletypeIdependencies_collect
            -- copy rule (down)
            (_whereOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_whereOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_whereOinferredDependencies_collect@_) =
                _simpletypeIinferredDependencies_collect
            -- copy rule (down)
            (_whereOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_whereOlabels_collect@_) =
                _simpletypeIlabels_collect
            -- copy rule (down)
            (_whereOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_whereOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_whereOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_whereOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_whereOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_whereOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_whereOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Declaration_Data :: (T_Range) ->
                        (T_ContextItems) ->
                        (T_SimpleType) ->
                        (T_Constructors) ->
                        (T_Names) ->
                        (T_Declaration)
sem_Declaration_Data (range_) (context_) (simpletype_) (constructors_) (derivings_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _contextIconstructors_collect :: (FMap Name Names)
            _contextIdependencies_collect :: (FMap Name [(Name,Name)])
            _contextIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _contextIlabels_collect :: (FMap Name Names)
            _contextIlocalDependencies :: ([(Name,Name)])
            _contextImethods_collect :: (FMap Name Names)
            _contextIself :: (ContextItems)
            _contextOclassname :: (Maybe Name)
            _contextOconstructors_collect :: (FMap Name Names)
            _contextOconstructors_dist :: (FMap Name Names)
            _contextOcurrentModule :: (Strings)
            _contextOdependencies_collect :: (FMap Name [(Name,Name)])
            _contextOimportedModule :: (Bool)
            _contextOinferredDependencies :: (FMap Name [(Name,Name)])
            _contextOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _contextOinstancename :: (Maybe Name)
            _contextOlabels_collect :: (FMap Name Names)
            _contextOlabels_dist :: (FMap Name Names)
            _contextOlocal :: (Bool)
            _contextOmethods_collect :: (FMap Name Names)
            _contextOmethods_dist :: (FMap Name Names)
            _contextOtoplevel :: (Bool)
            _simpletypeIconstructors_collect :: (FMap Name Names)
            _simpletypeIdependencies_collect :: (FMap Name [(Name,Name)])
            _simpletypeIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _simpletypeIlabels_collect :: (FMap Name Names)
            _simpletypeImethods_collect :: (FMap Name Names)
            _simpletypeIname :: (Name)
            _simpletypeIself :: (SimpleType)
            _simpletypeOclassname :: (Maybe Name)
            _simpletypeOconstructors_collect :: (FMap Name Names)
            _simpletypeOconstructors_dist :: (FMap Name Names)
            _simpletypeOcurrentModule :: (Strings)
            _simpletypeOdependencies_collect :: (FMap Name [(Name,Name)])
            _simpletypeOimportedModule :: (Bool)
            _simpletypeOinferredDependencies :: (FMap Name [(Name,Name)])
            _simpletypeOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _simpletypeOinstancename :: (Maybe Name)
            _simpletypeOlabels_collect :: (FMap Name Names)
            _simpletypeOlabels_dist :: (FMap Name Names)
            _simpletypeOlocal :: (Bool)
            _simpletypeOmethods_collect :: (FMap Name Names)
            _simpletypeOmethods_dist :: (FMap Name Names)
            _simpletypeOtoplevel :: (Bool)
            _constructorsIconstructors :: (Names)
            _constructorsIconstructors_collect :: (FMap Name Names)
            _constructorsIdependencies_collect :: (FMap Name [(Name,Name)])
            _constructorsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _constructorsIlabels :: (Names)
            _constructorsIlabels_collect :: (FMap Name Names)
            _constructorsImethods_collect :: (FMap Name Names)
            _constructorsIself :: (Constructors)
            _constructorsOclassname :: (Maybe Name)
            _constructorsOconstructors_collect :: (FMap Name Names)
            _constructorsOconstructors_dist :: (FMap Name Names)
            _constructorsOcurrentModule :: (Strings)
            _constructorsOdependencies_collect :: (FMap Name [(Name,Name)])
            _constructorsOimportedModule :: (Bool)
            _constructorsOinferredDependencies :: (FMap Name [(Name,Name)])
            _constructorsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _constructorsOinstancename :: (Maybe Name)
            _constructorsOlabels_collect :: (FMap Name Names)
            _constructorsOlabels_dist :: (FMap Name Names)
            _constructorsOlocal :: (Bool)
            _constructorsOmethods_collect :: (FMap Name Names)
            _constructorsOmethods_dist :: (FMap Name Names)
            _constructorsOtoplevel :: (Bool)
            _derivingsIconstructors_collect :: (FMap Name Names)
            _derivingsIdependencies_collect :: (FMap Name [(Name,Name)])
            _derivingsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _derivingsIlabels_collect :: (FMap Name Names)
            _derivingsImethods_collect :: (FMap Name Names)
            _derivingsIself :: (Names)
            _derivingsOclassname :: (Maybe Name)
            _derivingsOconstructors_collect :: (FMap Name Names)
            _derivingsOconstructors_dist :: (FMap Name Names)
            _derivingsOcurrentModule :: (Strings)
            _derivingsOdependencies_collect :: (FMap Name [(Name,Name)])
            _derivingsOimportedModule :: (Bool)
            _derivingsOinferredDependencies :: (FMap Name [(Name,Name)])
            _derivingsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _derivingsOinstancename :: (Maybe Name)
            _derivingsOlabels_collect :: (FMap Name Names)
            _derivingsOlabels_dist :: (FMap Name Names)
            _derivingsOlocal :: (Bool)
            _derivingsOmethods_collect :: (FMap Name Names)
            _derivingsOmethods_dist :: (FMap Name Names)
            _derivingsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _contextIconstructors_collect,_contextIdependencies_collect,_contextIinferredDependencies_collect,_contextIlabels_collect,_contextIlocalDependencies,_contextImethods_collect,_contextIself) =
                (context_ (_contextOclassname) (_contextOconstructors_collect) (_contextOconstructors_dist) (_contextOcurrentModule) (_contextOdependencies_collect) (_contextOimportedModule) (_contextOinferredDependencies) (_contextOinferredDependencies_collect) (_contextOinstancename) (_contextOlabels_collect) (_contextOlabels_dist) (_contextOlocal) (_contextOmethods_collect) (_contextOmethods_dist) (_contextOtoplevel))
            ( _simpletypeIconstructors_collect,_simpletypeIdependencies_collect,_simpletypeIinferredDependencies_collect,_simpletypeIlabels_collect,_simpletypeImethods_collect,_simpletypeIname,_simpletypeIself) =
                (simpletype_ (_simpletypeOclassname)
                             (_simpletypeOconstructors_collect)
                             (_simpletypeOconstructors_dist)
                             (_simpletypeOcurrentModule)
                             (_simpletypeOdependencies_collect)
                             (_simpletypeOimportedModule)
                             (_simpletypeOinferredDependencies)
                             (_simpletypeOinferredDependencies_collect)
                             (_simpletypeOinstancename)
                             (_simpletypeOlabels_collect)
                             (_simpletypeOlabels_dist)
                             (_simpletypeOlocal)
                             (_simpletypeOmethods_collect)
                             (_simpletypeOmethods_dist)
                             (_simpletypeOtoplevel))
            ( _constructorsIconstructors,_constructorsIconstructors_collect,_constructorsIdependencies_collect,_constructorsIinferredDependencies_collect,_constructorsIlabels,_constructorsIlabels_collect,_constructorsImethods_collect,_constructorsIself) =
                (constructors_ (_constructorsOclassname)
                               (_constructorsOconstructors_collect)
                               (_constructorsOconstructors_dist)
                               (_constructorsOcurrentModule)
                               (_constructorsOdependencies_collect)
                               (_constructorsOimportedModule)
                               (_constructorsOinferredDependencies)
                               (_constructorsOinferredDependencies_collect)
                               (_constructorsOinstancename)
                               (_constructorsOlabels_collect)
                               (_constructorsOlabels_dist)
                               (_constructorsOlocal)
                               (_constructorsOmethods_collect)
                               (_constructorsOmethods_dist)
                               (_constructorsOtoplevel))
            ( _derivingsIconstructors_collect,_derivingsIdependencies_collect,_derivingsIinferredDependencies_collect,_derivingsIlabels_collect,_derivingsImethods_collect,_derivingsIself) =
                (derivings_ (_derivingsOclassname)
                            (_derivingsOconstructors_collect)
                            (_derivingsOconstructors_dist)
                            (_derivingsOcurrentModule)
                            (_derivingsOdependencies_collect)
                            (_derivingsOimportedModule)
                            (_derivingsOinferredDependencies)
                            (_derivingsOinferredDependencies_collect)
                            (_derivingsOinstancename)
                            (_derivingsOlabels_collect)
                            (_derivingsOlabels_dist)
                            (_derivingsOlocal)
                            (_derivingsOmethods_collect)
                            (_derivingsOmethods_dist)
                            (_derivingsOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 317, column 9)
            (_lhsOlabels_collect@_) =
                add _lhsIlabels_collect
                    (_simpletypeIname,_constructorsIlabels)
            -- "./ModuleInformation.inc.lag"(line 315, column 9)
            (_lhsOconstructors_collect@_) =
                add _lhsIconstructors_collect
                    (_simpletypeIname,_constructorsIconstructors)
            -- use rule
            (_lhsObodyDependencies@_) =
                []
            -- self rule
            (_self@_) =
                Declaration_Data _rangeIself _contextIself _simpletypeIself _constructorsIself _derivingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _derivingsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _derivingsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _derivingsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_contextOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_contextOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_contextOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_contextOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_contextOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_contextOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_contextOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_contextOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_contextOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_contextOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_contextOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_contextOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_contextOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_contextOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_contextOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_simpletypeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_simpletypeOconstructors_collect@_) =
                _contextIconstructors_collect
            -- copy rule (down)
            (_simpletypeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_simpletypeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_simpletypeOdependencies_collect@_) =
                _contextIdependencies_collect
            -- copy rule (down)
            (_simpletypeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_simpletypeOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_simpletypeOinferredDependencies_collect@_) =
                _contextIinferredDependencies_collect
            -- copy rule (down)
            (_simpletypeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_simpletypeOlabels_collect@_) =
                _contextIlabels_collect
            -- copy rule (down)
            (_simpletypeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_simpletypeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_simpletypeOmethods_collect@_) =
                _contextImethods_collect
            -- copy rule (down)
            (_simpletypeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_simpletypeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_constructorsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_constructorsOconstructors_collect@_) =
                _simpletypeIconstructors_collect
            -- copy rule (down)
            (_constructorsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_constructorsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_constructorsOdependencies_collect@_) =
                _simpletypeIdependencies_collect
            -- copy rule (down)
            (_constructorsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_constructorsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_constructorsOinferredDependencies_collect@_) =
                _simpletypeIinferredDependencies_collect
            -- copy rule (down)
            (_constructorsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_constructorsOlabels_collect@_) =
                _simpletypeIlabels_collect
            -- copy rule (down)
            (_constructorsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_constructorsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_constructorsOmethods_collect@_) =
                _simpletypeImethods_collect
            -- copy rule (down)
            (_constructorsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_constructorsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_derivingsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_derivingsOconstructors_collect@_) =
                _constructorsIconstructors_collect
            -- copy rule (down)
            (_derivingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_derivingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_derivingsOdependencies_collect@_) =
                _constructorsIdependencies_collect
            -- copy rule (down)
            (_derivingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_derivingsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_derivingsOinferredDependencies_collect@_) =
                _constructorsIinferredDependencies_collect
            -- copy rule (down)
            (_derivingsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_derivingsOlabels_collect@_) =
                _constructorsIlabels_collect
            -- copy rule (down)
            (_derivingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_derivingsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_derivingsOmethods_collect@_) =
                _constructorsImethods_collect
            -- copy rule (down)
            (_derivingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_derivingsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Declaration_Default :: (T_Range) ->
                           (T_Types) ->
                           (T_Declaration)
sem_Declaration_Default (range_) (types_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _typesIconstructors_collect :: (FMap Name Names)
            _typesIdependencies_collect :: (FMap Name [(Name,Name)])
            _typesIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typesIlabels_collect :: (FMap Name Names)
            _typesImethods_collect :: (FMap Name Names)
            _typesIself :: (Types)
            _typesOclassname :: (Maybe Name)
            _typesOconstructors_collect :: (FMap Name Names)
            _typesOconstructors_dist :: (FMap Name Names)
            _typesOcurrentModule :: (Strings)
            _typesOdependencies_collect :: (FMap Name [(Name,Name)])
            _typesOimportedModule :: (Bool)
            _typesOinferredDependencies :: (FMap Name [(Name,Name)])
            _typesOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typesOinstancename :: (Maybe Name)
            _typesOlabels_collect :: (FMap Name Names)
            _typesOlabels_dist :: (FMap Name Names)
            _typesOlocal :: (Bool)
            _typesOmethods_collect :: (FMap Name Names)
            _typesOmethods_dist :: (FMap Name Names)
            _typesOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _typesIconstructors_collect,_typesIdependencies_collect,_typesIinferredDependencies_collect,_typesIlabels_collect,_typesImethods_collect,_typesIself) =
                (types_ (_typesOclassname) (_typesOconstructors_collect) (_typesOconstructors_dist) (_typesOcurrentModule) (_typesOdependencies_collect) (_typesOimportedModule) (_typesOinferredDependencies) (_typesOinferredDependencies_collect) (_typesOinstancename) (_typesOlabels_collect) (_typesOlabels_dist) (_typesOlocal) (_typesOmethods_collect) (_typesOmethods_dist) (_typesOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                []
            -- self rule
            (_self@_) =
                Declaration_Default _rangeIself _typesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typesIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _typesIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _typesIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typesIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typesImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typesOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_typesOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_typesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typesOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_typesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typesOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_typesOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_typesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typesOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_typesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typesOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_typesOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_typesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typesOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Declaration_Dependency :: (T_Range) ->
                              (Bool) ->
                              (T_Name) ->
                              (T_DependencyBindings) ->
                              (T_Declaration)
sem_Declaration_Dependency (range_) (typelevel_) (name_) (bindings_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _bindingsIconstructors_collect :: (FMap Name Names)
            _bindingsIdependencies_collect :: (FMap Name [(Name,Name)])
            _bindingsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _bindingsIlabels_collect :: (FMap Name Names)
            _bindingsIlocalDependencies :: ([(Name,Name)])
            _bindingsImethods_collect :: (FMap Name Names)
            _bindingsIself :: (DependencyBindings)
            _bindingsOclassname :: (Maybe Name)
            _bindingsOconstructors_collect :: (FMap Name Names)
            _bindingsOconstructors_dist :: (FMap Name Names)
            _bindingsOcurrentModule :: (Strings)
            _bindingsOdependencies_collect :: (FMap Name [(Name,Name)])
            _bindingsOimportedModule :: (Bool)
            _bindingsOinferredDependencies :: (FMap Name [(Name,Name)])
            _bindingsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _bindingsOinstancename :: (Maybe Name)
            _bindingsOlabels_collect :: (FMap Name Names)
            _bindingsOlabels_dist :: (FMap Name Names)
            _bindingsOlocal :: (Bool)
            _bindingsOmethods_collect :: (FMap Name Names)
            _bindingsOmethods_dist :: (FMap Name Names)
            _bindingsOtoplevel :: (Bool)
            _bindingsOtypelevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _bindingsIconstructors_collect,_bindingsIdependencies_collect,_bindingsIinferredDependencies_collect,_bindingsIlabels_collect,_bindingsIlocalDependencies,_bindingsImethods_collect,_bindingsIself) =
                (bindings_ (_bindingsOclassname)
                           (_bindingsOconstructors_collect)
                           (_bindingsOconstructors_dist)
                           (_bindingsOcurrentModule)
                           (_bindingsOdependencies_collect)
                           (_bindingsOimportedModule)
                           (_bindingsOinferredDependencies)
                           (_bindingsOinferredDependencies_collect)
                           (_bindingsOinstancename)
                           (_bindingsOlabels_collect)
                           (_bindingsOlabels_dist)
                           (_bindingsOlocal)
                           (_bindingsOmethods_collect)
                           (_bindingsOmethods_dist)
                           (_bindingsOtoplevel)
                           (_bindingsOtypelevel))
            -- "ScanDependencies.lag"(line 127, column 9)
            (_lhsOdependencies_collect@_) =
                add  _lhsIdependencies_collect
                     (_nameIself,_bindingsIlocalDependencies)
            -- "./ModuleInformation.inc.lag"(line 223, column 9)
            (_bindingsOtypelevel@_) =
                typelevel_
            -- use rule
            (_lhsObodyDependencies@_) =
                []
            -- self rule
            (_self@_) =
                Declaration_Dependency _rangeIself typelevel_ _nameIself _bindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _bindingsIconstructors_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _bindingsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _bindingsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _bindingsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_bindingsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_bindingsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_bindingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_bindingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_bindingsOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_bindingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_bindingsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_bindingsOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_bindingsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_bindingsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_bindingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_bindingsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_bindingsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_bindingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_bindingsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Declaration_Empty :: (T_Range) ->
                         (T_Declaration)
sem_Declaration_Empty (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                []
            -- self rule
            (_self@_) =
                Declaration_Empty _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Declaration_Fixity :: (T_Range) ->
                          (T_Fixity) ->
                          (T_MaybeInt) ->
                          (T_Names) ->
                          (T_Declaration)
sem_Declaration_Fixity (range_) (fixity_) (priority_) (operators_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _fixityIconstructors_collect :: (FMap Name Names)
            _fixityIdependencies_collect :: (FMap Name [(Name,Name)])
            _fixityIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _fixityIlabels_collect :: (FMap Name Names)
            _fixityImethods_collect :: (FMap Name Names)
            _fixityIself :: (Fixity)
            _fixityOclassname :: (Maybe Name)
            _fixityOconstructors_collect :: (FMap Name Names)
            _fixityOconstructors_dist :: (FMap Name Names)
            _fixityOcurrentModule :: (Strings)
            _fixityOdependencies_collect :: (FMap Name [(Name,Name)])
            _fixityOimportedModule :: (Bool)
            _fixityOinferredDependencies :: (FMap Name [(Name,Name)])
            _fixityOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _fixityOinstancename :: (Maybe Name)
            _fixityOlabels_collect :: (FMap Name Names)
            _fixityOlabels_dist :: (FMap Name Names)
            _fixityOlocal :: (Bool)
            _fixityOmethods_collect :: (FMap Name Names)
            _fixityOmethods_dist :: (FMap Name Names)
            _fixityOtoplevel :: (Bool)
            _priorityIconstructors_collect :: (FMap Name Names)
            _priorityIdependencies_collect :: (FMap Name [(Name,Name)])
            _priorityIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _priorityIlabels_collect :: (FMap Name Names)
            _priorityImethods_collect :: (FMap Name Names)
            _priorityIself :: (MaybeInt)
            _priorityOclassname :: (Maybe Name)
            _priorityOconstructors_collect :: (FMap Name Names)
            _priorityOconstructors_dist :: (FMap Name Names)
            _priorityOcurrentModule :: (Strings)
            _priorityOdependencies_collect :: (FMap Name [(Name,Name)])
            _priorityOimportedModule :: (Bool)
            _priorityOinferredDependencies :: (FMap Name [(Name,Name)])
            _priorityOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _priorityOinstancename :: (Maybe Name)
            _priorityOlabels_collect :: (FMap Name Names)
            _priorityOlabels_dist :: (FMap Name Names)
            _priorityOlocal :: (Bool)
            _priorityOmethods_collect :: (FMap Name Names)
            _priorityOmethods_dist :: (FMap Name Names)
            _priorityOtoplevel :: (Bool)
            _operatorsIconstructors_collect :: (FMap Name Names)
            _operatorsIdependencies_collect :: (FMap Name [(Name,Name)])
            _operatorsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _operatorsIlabels_collect :: (FMap Name Names)
            _operatorsImethods_collect :: (FMap Name Names)
            _operatorsIself :: (Names)
            _operatorsOclassname :: (Maybe Name)
            _operatorsOconstructors_collect :: (FMap Name Names)
            _operatorsOconstructors_dist :: (FMap Name Names)
            _operatorsOcurrentModule :: (Strings)
            _operatorsOdependencies_collect :: (FMap Name [(Name,Name)])
            _operatorsOimportedModule :: (Bool)
            _operatorsOinferredDependencies :: (FMap Name [(Name,Name)])
            _operatorsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _operatorsOinstancename :: (Maybe Name)
            _operatorsOlabels_collect :: (FMap Name Names)
            _operatorsOlabels_dist :: (FMap Name Names)
            _operatorsOlocal :: (Bool)
            _operatorsOmethods_collect :: (FMap Name Names)
            _operatorsOmethods_dist :: (FMap Name Names)
            _operatorsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _fixityIconstructors_collect,_fixityIdependencies_collect,_fixityIinferredDependencies_collect,_fixityIlabels_collect,_fixityImethods_collect,_fixityIself) =
                (fixity_ (_fixityOclassname) (_fixityOconstructors_collect) (_fixityOconstructors_dist) (_fixityOcurrentModule) (_fixityOdependencies_collect) (_fixityOimportedModule) (_fixityOinferredDependencies) (_fixityOinferredDependencies_collect) (_fixityOinstancename) (_fixityOlabels_collect) (_fixityOlabels_dist) (_fixityOlocal) (_fixityOmethods_collect) (_fixityOmethods_dist) (_fixityOtoplevel))
            ( _priorityIconstructors_collect,_priorityIdependencies_collect,_priorityIinferredDependencies_collect,_priorityIlabels_collect,_priorityImethods_collect,_priorityIself) =
                (priority_ (_priorityOclassname) (_priorityOconstructors_collect) (_priorityOconstructors_dist) (_priorityOcurrentModule) (_priorityOdependencies_collect) (_priorityOimportedModule) (_priorityOinferredDependencies) (_priorityOinferredDependencies_collect) (_priorityOinstancename) (_priorityOlabels_collect) (_priorityOlabels_dist) (_priorityOlocal) (_priorityOmethods_collect) (_priorityOmethods_dist) (_priorityOtoplevel))
            ( _operatorsIconstructors_collect,_operatorsIdependencies_collect,_operatorsIinferredDependencies_collect,_operatorsIlabels_collect,_operatorsImethods_collect,_operatorsIself) =
                (operators_ (_operatorsOclassname)
                            (_operatorsOconstructors_collect)
                            (_operatorsOconstructors_dist)
                            (_operatorsOcurrentModule)
                            (_operatorsOdependencies_collect)
                            (_operatorsOimportedModule)
                            (_operatorsOinferredDependencies)
                            (_operatorsOinferredDependencies_collect)
                            (_operatorsOinstancename)
                            (_operatorsOlabels_collect)
                            (_operatorsOlabels_dist)
                            (_operatorsOlocal)
                            (_operatorsOmethods_collect)
                            (_operatorsOmethods_dist)
                            (_operatorsOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                []
            -- self rule
            (_self@_) =
                Declaration_Fixity _rangeIself _fixityIself _priorityIself _operatorsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _operatorsIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _operatorsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _operatorsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _operatorsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _operatorsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_fixityOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_fixityOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_fixityOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_fixityOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_fixityOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_fixityOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_fixityOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_fixityOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_fixityOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_fixityOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_fixityOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_fixityOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_fixityOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_fixityOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_fixityOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_priorityOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_priorityOconstructors_collect@_) =
                _fixityIconstructors_collect
            -- copy rule (down)
            (_priorityOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_priorityOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_priorityOdependencies_collect@_) =
                _fixityIdependencies_collect
            -- copy rule (down)
            (_priorityOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_priorityOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_priorityOinferredDependencies_collect@_) =
                _fixityIinferredDependencies_collect
            -- copy rule (down)
            (_priorityOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_priorityOlabels_collect@_) =
                _fixityIlabels_collect
            -- copy rule (down)
            (_priorityOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_priorityOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_priorityOmethods_collect@_) =
                _fixityImethods_collect
            -- copy rule (down)
            (_priorityOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_priorityOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_operatorsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_operatorsOconstructors_collect@_) =
                _priorityIconstructors_collect
            -- copy rule (down)
            (_operatorsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_operatorsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_operatorsOdependencies_collect@_) =
                _priorityIdependencies_collect
            -- copy rule (down)
            (_operatorsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_operatorsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_operatorsOinferredDependencies_collect@_) =
                _priorityIinferredDependencies_collect
            -- copy rule (down)
            (_operatorsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_operatorsOlabels_collect@_) =
                _priorityIlabels_collect
            -- copy rule (down)
            (_operatorsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_operatorsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_operatorsOmethods_collect@_) =
                _priorityImethods_collect
            -- copy rule (down)
            (_operatorsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_operatorsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Declaration_FunctionBindings :: (T_Range) ->
                                    (T_FunctionBindings) ->
                                    (T_Declaration)
sem_Declaration_FunctionBindings (range_) (bindings_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _bindingsIbodyDependencies :: ([(Name,Name)])
            _bindingsIconstructors_collect :: (FMap Name Names)
            _bindingsIdependencies_collect :: (FMap Name [(Name,Name)])
            _bindingsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _bindingsIlabels_collect :: (FMap Name Names)
            _bindingsImethods_collect :: (FMap Name Names)
            _bindingsIname :: (Name)
            _bindingsIpresignatures_collect :: (PreSignatures)
            _bindingsIself :: (FunctionBindings)
            _bindingsOclassname :: (Maybe Name)
            _bindingsOconstructors_collect :: (FMap Name Names)
            _bindingsOconstructors_dist :: (FMap Name Names)
            _bindingsOcurrentModule :: (Strings)
            _bindingsOdependencies_collect :: (FMap Name [(Name,Name)])
            _bindingsOimportedModule :: (Bool)
            _bindingsOinferredDependencies :: (FMap Name [(Name,Name)])
            _bindingsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _bindingsOinstancename :: (Maybe Name)
            _bindingsOlabels_collect :: (FMap Name Names)
            _bindingsOlabels_dist :: (FMap Name Names)
            _bindingsOlocal :: (Bool)
            _bindingsOmethods_collect :: (FMap Name Names)
            _bindingsOmethods_dist :: (FMap Name Names)
            _bindingsOpresignatures :: (PreSignatures)
            _bindingsOpresignatures_collect :: (PreSignatures)
            _bindingsOsignatures :: (Signatures)
            _bindingsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _bindingsIbodyDependencies,_bindingsIconstructors_collect,_bindingsIdependencies_collect,_bindingsIinferredDependencies_collect,_bindingsIlabels_collect,_bindingsImethods_collect,_bindingsIname,_bindingsIpresignatures_collect,_bindingsIself) =
                (bindings_ (_bindingsOclassname)
                           (_bindingsOconstructors_collect)
                           (_bindingsOconstructors_dist)
                           (_bindingsOcurrentModule)
                           (_bindingsOdependencies_collect)
                           (_bindingsOimportedModule)
                           (_bindingsOinferredDependencies)
                           (_bindingsOinferredDependencies_collect)
                           (_bindingsOinstancename)
                           (_bindingsOlabels_collect)
                           (_bindingsOlabels_dist)
                           (_bindingsOlocal)
                           (_bindingsOmethods_collect)
                           (_bindingsOmethods_dist)
                           (_bindingsOpresignatures)
                           (_bindingsOpresignatures_collect)
                           (_bindingsOsignatures)
                           (_bindingsOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _bindingsIbodyDependencies
            -- self rule
            (_self@_) =
                Declaration_FunctionBindings _rangeIself _bindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _bindingsIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _bindingsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _bindingsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _bindingsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _bindingsImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _bindingsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_bindingsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_bindingsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_bindingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_bindingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_bindingsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_bindingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_bindingsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_bindingsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_bindingsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_bindingsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_bindingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_bindingsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_bindingsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_bindingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_bindingsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_bindingsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_bindingsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_bindingsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Declaration_GenericTypeSignature :: (T_Range) ->
                                        (T_Name) ->
                                        (T_KindAnnotatedNames) ->
                                        (T_KindAnnotatedNames) ->
                                        (T_Type) ->
                                        (T_Declaration)
sem_Declaration_GenericTypeSignature (range_) (name_) (generics_) (parametrics_) (type_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _genericsIakinds :: ([MaybeKind])
            _genericsIconstructors_collect :: (FMap Name Names)
            _genericsIdependencies_collect :: (FMap Name [(Name,Name)])
            _genericsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _genericsIlabels_collect :: (FMap Name Names)
            _genericsImethods_collect :: (FMap Name Names)
            _genericsIself :: (KindAnnotatedNames)
            _genericsOclassname :: (Maybe Name)
            _genericsOconstructors_collect :: (FMap Name Names)
            _genericsOconstructors_dist :: (FMap Name Names)
            _genericsOcurrentModule :: (Strings)
            _genericsOdependencies_collect :: (FMap Name [(Name,Name)])
            _genericsOimportedModule :: (Bool)
            _genericsOinferredDependencies :: (FMap Name [(Name,Name)])
            _genericsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _genericsOinstancename :: (Maybe Name)
            _genericsOlabels_collect :: (FMap Name Names)
            _genericsOlabels_dist :: (FMap Name Names)
            _genericsOlocal :: (Bool)
            _genericsOmethods_collect :: (FMap Name Names)
            _genericsOmethods_dist :: (FMap Name Names)
            _genericsOtoplevel :: (Bool)
            _parametricsIakinds :: ([MaybeKind])
            _parametricsIconstructors_collect :: (FMap Name Names)
            _parametricsIdependencies_collect :: (FMap Name [(Name,Name)])
            _parametricsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _parametricsIlabels_collect :: (FMap Name Names)
            _parametricsImethods_collect :: (FMap Name Names)
            _parametricsIself :: (KindAnnotatedNames)
            _parametricsOclassname :: (Maybe Name)
            _parametricsOconstructors_collect :: (FMap Name Names)
            _parametricsOconstructors_dist :: (FMap Name Names)
            _parametricsOcurrentModule :: (Strings)
            _parametricsOdependencies_collect :: (FMap Name [(Name,Name)])
            _parametricsOimportedModule :: (Bool)
            _parametricsOinferredDependencies :: (FMap Name [(Name,Name)])
            _parametricsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _parametricsOinstancename :: (Maybe Name)
            _parametricsOlabels_collect :: (FMap Name Names)
            _parametricsOlabels_dist :: (FMap Name Names)
            _parametricsOlocal :: (Bool)
            _parametricsOmethods_collect :: (FMap Name Names)
            _parametricsOmethods_dist :: (FMap Name Names)
            _parametricsOtoplevel :: (Bool)
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIdependencies_collect :: (FMap Name [(Name,Name)])
            _typeIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typeIlabels_collect :: (FMap Name Names)
            _typeIlocalDependencies :: ([(Name,Name)])
            _typeImethods_collect :: (FMap Name Names)
            _typeIself :: (Type)
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOdependencies_collect :: (FMap Name [(Name,Name)])
            _typeOimportedModule :: (Bool)
            _typeOinferredDependencies :: (FMap Name [(Name,Name)])
            _typeOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typeOinstancename :: (Maybe Name)
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _genericsIakinds,_genericsIconstructors_collect,_genericsIdependencies_collect,_genericsIinferredDependencies_collect,_genericsIlabels_collect,_genericsImethods_collect,_genericsIself) =
                (generics_ (_genericsOclassname) (_genericsOconstructors_collect) (_genericsOconstructors_dist) (_genericsOcurrentModule) (_genericsOdependencies_collect) (_genericsOimportedModule) (_genericsOinferredDependencies) (_genericsOinferredDependencies_collect) (_genericsOinstancename) (_genericsOlabels_collect) (_genericsOlabels_dist) (_genericsOlocal) (_genericsOmethods_collect) (_genericsOmethods_dist) (_genericsOtoplevel))
            ( _parametricsIakinds,_parametricsIconstructors_collect,_parametricsIdependencies_collect,_parametricsIinferredDependencies_collect,_parametricsIlabels_collect,_parametricsImethods_collect,_parametricsIself) =
                (parametrics_ (_parametricsOclassname)
                              (_parametricsOconstructors_collect)
                              (_parametricsOconstructors_dist)
                              (_parametricsOcurrentModule)
                              (_parametricsOdependencies_collect)
                              (_parametricsOimportedModule)
                              (_parametricsOinferredDependencies)
                              (_parametricsOinferredDependencies_collect)
                              (_parametricsOinstancename)
                              (_parametricsOlabels_collect)
                              (_parametricsOlabels_dist)
                              (_parametricsOlocal)
                              (_parametricsOmethods_collect)
                              (_parametricsOmethods_dist)
                              (_parametricsOtoplevel))
            ( _typeIconstructors_collect,_typeIdependencies_collect,_typeIinferredDependencies_collect,_typeIlabels_collect,_typeIlocalDependencies,_typeImethods_collect,_typeIself) =
                (type_ (_typeOclassname) (_typeOconstructors_collect) (_typeOconstructors_dist) (_typeOcurrentModule) (_typeOdependencies_collect) (_typeOimportedModule) (_typeOinferredDependencies) (_typeOinferredDependencies_collect) (_typeOinstancename) (_typeOlabels_collect) (_typeOlabels_dist) (_typeOlocal) (_typeOmethods_collect) (_typeOmethods_dist) (_typeOtoplevel))
            -- "ScanDependencies.lag"(line 131, column 9)
            (_lhsOdependencies_collect@_) =
                if _isMPCstyle
                then  _lhsIdependencies_collect
                else  if null _typeIlocalDependencies
                      then  add'  _lhsIdependencies_collect
                                  (_nameIself,
                                   applyFMM _lhsIinferredDependencies (const []) _nameIself)
                      else  add'  _lhsIdependencies_collect
                                  (_nameIself,_typeIlocalDependencies)
            -- "./Signature.inc.lag"(line 289, column 9)
            (_signature@_) =
                applyOrSignatureError _lhsIsignatures _nameIself $
                  "Signature.Declaration.GenericTypeSignature: " ++
                  "no signature"
            -- "./ModuleInformation.inc.lag"(line 152, column 8)
            (_typeOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 151, column 8)
            (_parametricsOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 150, column 8)
            (_genericsOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 244, column 9)
            (_isMPCstyle@_) =
                length _genericsIself == 1 && length _parametricsIself == 0
                  && let  (KindAnnotatedName_KindAnnotatedName _ t k) = head _genericsIself
                     in   case k of
                            MaybeKind_Just j   ->  not (isRestricted j)
                            MaybeKind_Nothing  ->  False
            -- use rule
            (_lhsObodyDependencies@_) =
                []
            -- self rule
            (_self@_) =
                Declaration_GenericTypeSignature _rangeIself _nameIself _genericsIself _parametricsIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _typeIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_genericsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_genericsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_genericsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_genericsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_genericsOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_genericsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_genericsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_genericsOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_genericsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_genericsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_genericsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_genericsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_genericsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_genericsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_parametricsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_parametricsOconstructors_collect@_) =
                _genericsIconstructors_collect
            -- copy rule (down)
            (_parametricsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_parametricsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_parametricsOdependencies_collect@_) =
                _genericsIdependencies_collect
            -- copy rule (down)
            (_parametricsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_parametricsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_parametricsOinferredDependencies_collect@_) =
                _genericsIinferredDependencies_collect
            -- copy rule (down)
            (_parametricsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_parametricsOlabels_collect@_) =
                _genericsIlabels_collect
            -- copy rule (down)
            (_parametricsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_parametricsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_parametricsOmethods_collect@_) =
                _genericsImethods_collect
            -- copy rule (down)
            (_parametricsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _parametricsIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_typeOdependencies_collect@_) =
                _parametricsIdependencies_collect
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_typeOinferredDependencies_collect@_) =
                _parametricsIinferredDependencies_collect
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _parametricsIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _parametricsImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Declaration_Instance :: (T_Range) ->
                            (T_ContextItems) ->
                            (T_Name) ->
                            (T_Types) ->
                            (T_MaybeDeclarations) ->
                            (T_Declaration)
sem_Declaration_Instance (range_) (context_) (name_) (types_) (where_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _contextIconstructors_collect :: (FMap Name Names)
            _contextIdependencies_collect :: (FMap Name [(Name,Name)])
            _contextIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _contextIlabels_collect :: (FMap Name Names)
            _contextIlocalDependencies :: ([(Name,Name)])
            _contextImethods_collect :: (FMap Name Names)
            _contextIself :: (ContextItems)
            _contextOclassname :: (Maybe Name)
            _contextOconstructors_collect :: (FMap Name Names)
            _contextOconstructors_dist :: (FMap Name Names)
            _contextOcurrentModule :: (Strings)
            _contextOdependencies_collect :: (FMap Name [(Name,Name)])
            _contextOimportedModule :: (Bool)
            _contextOinferredDependencies :: (FMap Name [(Name,Name)])
            _contextOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _contextOinstancename :: (Maybe Name)
            _contextOlabels_collect :: (FMap Name Names)
            _contextOlabels_dist :: (FMap Name Names)
            _contextOlocal :: (Bool)
            _contextOmethods_collect :: (FMap Name Names)
            _contextOmethods_dist :: (FMap Name Names)
            _contextOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _typesIconstructors_collect :: (FMap Name Names)
            _typesIdependencies_collect :: (FMap Name [(Name,Name)])
            _typesIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typesIlabels_collect :: (FMap Name Names)
            _typesImethods_collect :: (FMap Name Names)
            _typesIself :: (Types)
            _typesOclassname :: (Maybe Name)
            _typesOconstructors_collect :: (FMap Name Names)
            _typesOconstructors_dist :: (FMap Name Names)
            _typesOcurrentModule :: (Strings)
            _typesOdependencies_collect :: (FMap Name [(Name,Name)])
            _typesOimportedModule :: (Bool)
            _typesOinferredDependencies :: (FMap Name [(Name,Name)])
            _typesOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typesOinstancename :: (Maybe Name)
            _typesOlabels_collect :: (FMap Name Names)
            _typesOlabels_dist :: (FMap Name Names)
            _typesOlocal :: (Bool)
            _typesOmethods_collect :: (FMap Name Names)
            _typesOmethods_dist :: (FMap Name Names)
            _typesOtoplevel :: (Bool)
            _whereIbodyDependencies :: ([(Name,Name)])
            _whereIconstructors_collect :: (FMap Name Names)
            _whereIdependencies_collect :: (FMap Name [(Name,Name)])
            _whereIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _whereIlabels_collect :: (FMap Name Names)
            _whereImethods_collect :: (FMap Name Names)
            _whereIpresignatures_collect :: (PreSignatures)
            _whereIself :: (MaybeDeclarations)
            _whereOclassname :: (Maybe Name)
            _whereOconstructors_collect :: (FMap Name Names)
            _whereOconstructors_dist :: (FMap Name Names)
            _whereOcurrentModule :: (Strings)
            _whereOdependencies_collect :: (FMap Name [(Name,Name)])
            _whereOimportedModule :: (Bool)
            _whereOinferredDependencies :: (FMap Name [(Name,Name)])
            _whereOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _whereOinstancename :: (Maybe Name)
            _whereOlabels_collect :: (FMap Name Names)
            _whereOlabels_dist :: (FMap Name Names)
            _whereOlocal :: (Bool)
            _whereOmethods_collect :: (FMap Name Names)
            _whereOmethods_dist :: (FMap Name Names)
            _whereOpresignatures :: (PreSignatures)
            _whereOpresignatures_collect :: (PreSignatures)
            _whereOsignatures :: (Signatures)
            _whereOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _contextIconstructors_collect,_contextIdependencies_collect,_contextIinferredDependencies_collect,_contextIlabels_collect,_contextIlocalDependencies,_contextImethods_collect,_contextIself) =
                (context_ (_contextOclassname) (_contextOconstructors_collect) (_contextOconstructors_dist) (_contextOcurrentModule) (_contextOdependencies_collect) (_contextOimportedModule) (_contextOinferredDependencies) (_contextOinferredDependencies_collect) (_contextOinstancename) (_contextOlabels_collect) (_contextOlabels_dist) (_contextOlocal) (_contextOmethods_collect) (_contextOmethods_dist) (_contextOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _typesIconstructors_collect,_typesIdependencies_collect,_typesIinferredDependencies_collect,_typesIlabels_collect,_typesImethods_collect,_typesIself) =
                (types_ (_typesOclassname) (_typesOconstructors_collect) (_typesOconstructors_dist) (_typesOcurrentModule) (_typesOdependencies_collect) (_typesOimportedModule) (_typesOinferredDependencies) (_typesOinferredDependencies_collect) (_typesOinstancename) (_typesOlabels_collect) (_typesOlabels_dist) (_typesOlocal) (_typesOmethods_collect) (_typesOmethods_dist) (_typesOtoplevel))
            ( _whereIbodyDependencies,_whereIconstructors_collect,_whereIdependencies_collect,_whereIinferredDependencies_collect,_whereIlabels_collect,_whereImethods_collect,_whereIpresignatures_collect,_whereIself) =
                (where_ (_whereOclassname)
                        (_whereOconstructors_collect)
                        (_whereOconstructors_dist)
                        (_whereOcurrentModule)
                        (_whereOdependencies_collect)
                        (_whereOimportedModule)
                        (_whereOinferredDependencies)
                        (_whereOinferredDependencies_collect)
                        (_whereOinstancename)
                        (_whereOlabels_collect)
                        (_whereOlabels_dist)
                        (_whereOlocal)
                        (_whereOmethods_collect)
                        (_whereOmethods_dist)
                        (_whereOpresignatures)
                        (_whereOpresignatures_collect)
                        (_whereOsignatures)
                        (_whereOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 140, column 8)
            (_instancename@_) =
                Just _nameIself
            -- use rule
            (_lhsObodyDependencies@_) =
                _whereIbodyDependencies
            -- self rule
            (_self@_) =
                Declaration_Instance _rangeIself _contextIself _nameIself _typesIself _whereIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _whereIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _whereIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _whereIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _whereIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _whereImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _whereIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (chain)
            (_rangeOinstancename@_) =
                _instancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_contextOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_contextOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_contextOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_contextOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_contextOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_contextOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_contextOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_contextOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_contextOinstancename@_) =
                _instancename
            -- copy rule (down)
            (_contextOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_contextOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_contextOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_contextOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_contextOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_contextOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_nameOconstructors_collect@_) =
                _contextIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_nameOdependencies_collect@_) =
                _contextIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_nameOinferredDependencies_collect@_) =
                _contextIinferredDependencies_collect
            -- copy rule (chain)
            (_nameOinstancename@_) =
                _instancename
            -- copy rule (chain)
            (_nameOlabels_collect@_) =
                _contextIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_nameOmethods_collect@_) =
                _contextImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typesOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_typesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_typesOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_typesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typesOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_typesOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (chain)
            (_typesOinstancename@_) =
                _instancename
            -- copy rule (chain)
            (_typesOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_typesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typesOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_typesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typesOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_whereOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_whereOconstructors_collect@_) =
                _typesIconstructors_collect
            -- copy rule (down)
            (_whereOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_whereOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_whereOdependencies_collect@_) =
                _typesIdependencies_collect
            -- copy rule (down)
            (_whereOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_whereOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_whereOinferredDependencies_collect@_) =
                _typesIinferredDependencies_collect
            -- copy rule (chain)
            (_whereOinstancename@_) =
                _instancename
            -- copy rule (chain)
            (_whereOlabels_collect@_) =
                _typesIlabels_collect
            -- copy rule (down)
            (_whereOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_whereOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_whereOmethods_collect@_) =
                _typesImethods_collect
            -- copy rule (down)
            (_whereOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_whereOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_whereOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_whereOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_whereOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Declaration_KindIndexedType :: (T_Range) ->
                                   (T_KindIndexedBindings) ->
                                   (T_Declaration)
sem_Declaration_KindIndexedType (range_) (bindings_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _bindingsIconstructors_collect :: (FMap Name Names)
            _bindingsIdependencies_collect :: (FMap Name [(Name,Name)])
            _bindingsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _bindingsIlabels_collect :: (FMap Name Names)
            _bindingsImethods_collect :: (FMap Name Names)
            _bindingsIname :: (Name)
            _bindingsIself :: (KindIndexedBindings)
            _bindingsOclassname :: (Maybe Name)
            _bindingsOconstructors_collect :: (FMap Name Names)
            _bindingsOconstructors_dist :: (FMap Name Names)
            _bindingsOcurrentModule :: (Strings)
            _bindingsOdependencies_collect :: (FMap Name [(Name,Name)])
            _bindingsOimportedModule :: (Bool)
            _bindingsOinferredDependencies :: (FMap Name [(Name,Name)])
            _bindingsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _bindingsOinstancename :: (Maybe Name)
            _bindingsOlabels_collect :: (FMap Name Names)
            _bindingsOlabels_dist :: (FMap Name Names)
            _bindingsOlocal :: (Bool)
            _bindingsOmethods_collect :: (FMap Name Names)
            _bindingsOmethods_dist :: (FMap Name Names)
            _bindingsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _bindingsIconstructors_collect,_bindingsIdependencies_collect,_bindingsIinferredDependencies_collect,_bindingsIlabels_collect,_bindingsImethods_collect,_bindingsIname,_bindingsIself) =
                (bindings_ (_bindingsOclassname) (_bindingsOconstructors_collect) (_bindingsOconstructors_dist) (_bindingsOcurrentModule) (_bindingsOdependencies_collect) (_bindingsOimportedModule) (_bindingsOinferredDependencies) (_bindingsOinferredDependencies_collect) (_bindingsOinstancename) (_bindingsOlabels_collect) (_bindingsOlabels_dist) (_bindingsOlocal) (_bindingsOmethods_collect) (_bindingsOmethods_dist) (_bindingsOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                []
            -- self rule
            (_self@_) =
                Declaration_KindIndexedType _rangeIself _bindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _bindingsIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _bindingsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _bindingsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _bindingsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _bindingsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_bindingsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_bindingsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_bindingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_bindingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_bindingsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_bindingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_bindingsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_bindingsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_bindingsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_bindingsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_bindingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_bindingsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_bindingsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_bindingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_bindingsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Declaration_Newtype :: (T_Range) ->
                           (T_ContextItems) ->
                           (T_SimpleType) ->
                           (T_Constructor) ->
                           (T_Names) ->
                           (T_Declaration)
sem_Declaration_Newtype (range_) (context_) (simpletype_) (constructor_) (derivings_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _contextIconstructors_collect :: (FMap Name Names)
            _contextIdependencies_collect :: (FMap Name [(Name,Name)])
            _contextIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _contextIlabels_collect :: (FMap Name Names)
            _contextIlocalDependencies :: ([(Name,Name)])
            _contextImethods_collect :: (FMap Name Names)
            _contextIself :: (ContextItems)
            _contextOclassname :: (Maybe Name)
            _contextOconstructors_collect :: (FMap Name Names)
            _contextOconstructors_dist :: (FMap Name Names)
            _contextOcurrentModule :: (Strings)
            _contextOdependencies_collect :: (FMap Name [(Name,Name)])
            _contextOimportedModule :: (Bool)
            _contextOinferredDependencies :: (FMap Name [(Name,Name)])
            _contextOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _contextOinstancename :: (Maybe Name)
            _contextOlabels_collect :: (FMap Name Names)
            _contextOlabels_dist :: (FMap Name Names)
            _contextOlocal :: (Bool)
            _contextOmethods_collect :: (FMap Name Names)
            _contextOmethods_dist :: (FMap Name Names)
            _contextOtoplevel :: (Bool)
            _simpletypeIconstructors_collect :: (FMap Name Names)
            _simpletypeIdependencies_collect :: (FMap Name [(Name,Name)])
            _simpletypeIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _simpletypeIlabels_collect :: (FMap Name Names)
            _simpletypeImethods_collect :: (FMap Name Names)
            _simpletypeIname :: (Name)
            _simpletypeIself :: (SimpleType)
            _simpletypeOclassname :: (Maybe Name)
            _simpletypeOconstructors_collect :: (FMap Name Names)
            _simpletypeOconstructors_dist :: (FMap Name Names)
            _simpletypeOcurrentModule :: (Strings)
            _simpletypeOdependencies_collect :: (FMap Name [(Name,Name)])
            _simpletypeOimportedModule :: (Bool)
            _simpletypeOinferredDependencies :: (FMap Name [(Name,Name)])
            _simpletypeOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _simpletypeOinstancename :: (Maybe Name)
            _simpletypeOlabels_collect :: (FMap Name Names)
            _simpletypeOlabels_dist :: (FMap Name Names)
            _simpletypeOlocal :: (Bool)
            _simpletypeOmethods_collect :: (FMap Name Names)
            _simpletypeOmethods_dist :: (FMap Name Names)
            _simpletypeOtoplevel :: (Bool)
            _constructorIconstructors :: (Names)
            _constructorIconstructors_collect :: (FMap Name Names)
            _constructorIdependencies_collect :: (FMap Name [(Name,Name)])
            _constructorIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _constructorIlabels :: (Names)
            _constructorIlabels_collect :: (FMap Name Names)
            _constructorImethods_collect :: (FMap Name Names)
            _constructorIself :: (Constructor)
            _constructorOclassname :: (Maybe Name)
            _constructorOconstructors_collect :: (FMap Name Names)
            _constructorOconstructors_dist :: (FMap Name Names)
            _constructorOcurrentModule :: (Strings)
            _constructorOdependencies_collect :: (FMap Name [(Name,Name)])
            _constructorOimportedModule :: (Bool)
            _constructorOinferredDependencies :: (FMap Name [(Name,Name)])
            _constructorOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _constructorOinstancename :: (Maybe Name)
            _constructorOlabels_collect :: (FMap Name Names)
            _constructorOlabels_dist :: (FMap Name Names)
            _constructorOlocal :: (Bool)
            _constructorOmethods_collect :: (FMap Name Names)
            _constructorOmethods_dist :: (FMap Name Names)
            _constructorOtoplevel :: (Bool)
            _derivingsIconstructors_collect :: (FMap Name Names)
            _derivingsIdependencies_collect :: (FMap Name [(Name,Name)])
            _derivingsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _derivingsIlabels_collect :: (FMap Name Names)
            _derivingsImethods_collect :: (FMap Name Names)
            _derivingsIself :: (Names)
            _derivingsOclassname :: (Maybe Name)
            _derivingsOconstructors_collect :: (FMap Name Names)
            _derivingsOconstructors_dist :: (FMap Name Names)
            _derivingsOcurrentModule :: (Strings)
            _derivingsOdependencies_collect :: (FMap Name [(Name,Name)])
            _derivingsOimportedModule :: (Bool)
            _derivingsOinferredDependencies :: (FMap Name [(Name,Name)])
            _derivingsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _derivingsOinstancename :: (Maybe Name)
            _derivingsOlabels_collect :: (FMap Name Names)
            _derivingsOlabels_dist :: (FMap Name Names)
            _derivingsOlocal :: (Bool)
            _derivingsOmethods_collect :: (FMap Name Names)
            _derivingsOmethods_dist :: (FMap Name Names)
            _derivingsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _contextIconstructors_collect,_contextIdependencies_collect,_contextIinferredDependencies_collect,_contextIlabels_collect,_contextIlocalDependencies,_contextImethods_collect,_contextIself) =
                (context_ (_contextOclassname) (_contextOconstructors_collect) (_contextOconstructors_dist) (_contextOcurrentModule) (_contextOdependencies_collect) (_contextOimportedModule) (_contextOinferredDependencies) (_contextOinferredDependencies_collect) (_contextOinstancename) (_contextOlabels_collect) (_contextOlabels_dist) (_contextOlocal) (_contextOmethods_collect) (_contextOmethods_dist) (_contextOtoplevel))
            ( _simpletypeIconstructors_collect,_simpletypeIdependencies_collect,_simpletypeIinferredDependencies_collect,_simpletypeIlabels_collect,_simpletypeImethods_collect,_simpletypeIname,_simpletypeIself) =
                (simpletype_ (_simpletypeOclassname)
                             (_simpletypeOconstructors_collect)
                             (_simpletypeOconstructors_dist)
                             (_simpletypeOcurrentModule)
                             (_simpletypeOdependencies_collect)
                             (_simpletypeOimportedModule)
                             (_simpletypeOinferredDependencies)
                             (_simpletypeOinferredDependencies_collect)
                             (_simpletypeOinstancename)
                             (_simpletypeOlabels_collect)
                             (_simpletypeOlabels_dist)
                             (_simpletypeOlocal)
                             (_simpletypeOmethods_collect)
                             (_simpletypeOmethods_dist)
                             (_simpletypeOtoplevel))
            ( _constructorIconstructors,_constructorIconstructors_collect,_constructorIdependencies_collect,_constructorIinferredDependencies_collect,_constructorIlabels,_constructorIlabels_collect,_constructorImethods_collect,_constructorIself) =
                (constructor_ (_constructorOclassname)
                              (_constructorOconstructors_collect)
                              (_constructorOconstructors_dist)
                              (_constructorOcurrentModule)
                              (_constructorOdependencies_collect)
                              (_constructorOimportedModule)
                              (_constructorOinferredDependencies)
                              (_constructorOinferredDependencies_collect)
                              (_constructorOinstancename)
                              (_constructorOlabels_collect)
                              (_constructorOlabels_dist)
                              (_constructorOlocal)
                              (_constructorOmethods_collect)
                              (_constructorOmethods_dist)
                              (_constructorOtoplevel))
            ( _derivingsIconstructors_collect,_derivingsIdependencies_collect,_derivingsIinferredDependencies_collect,_derivingsIlabels_collect,_derivingsImethods_collect,_derivingsIself) =
                (derivings_ (_derivingsOclassname)
                            (_derivingsOconstructors_collect)
                            (_derivingsOconstructors_dist)
                            (_derivingsOcurrentModule)
                            (_derivingsOdependencies_collect)
                            (_derivingsOimportedModule)
                            (_derivingsOinferredDependencies)
                            (_derivingsOinferredDependencies_collect)
                            (_derivingsOinstancename)
                            (_derivingsOlabels_collect)
                            (_derivingsOlabels_dist)
                            (_derivingsOlocal)
                            (_derivingsOmethods_collect)
                            (_derivingsOmethods_dist)
                            (_derivingsOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 323, column 9)
            (_lhsOlabels_collect@_) =
                add _lhsIlabels_collect
                    (_simpletypeIname,_constructorIlabels)
            -- "./ModuleInformation.inc.lag"(line 321, column 9)
            (_lhsOconstructors_collect@_) =
                add _lhsIconstructors_collect
                    (_simpletypeIname,_constructorIconstructors)
            -- use rule
            (_lhsObodyDependencies@_) =
                []
            -- self rule
            (_self@_) =
                Declaration_Newtype _rangeIself _contextIself _simpletypeIself _constructorIself _derivingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _derivingsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _derivingsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _derivingsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_contextOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_contextOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_contextOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_contextOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_contextOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_contextOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_contextOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_contextOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_contextOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_contextOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_contextOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_contextOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_contextOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_contextOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_contextOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_simpletypeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_simpletypeOconstructors_collect@_) =
                _contextIconstructors_collect
            -- copy rule (down)
            (_simpletypeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_simpletypeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_simpletypeOdependencies_collect@_) =
                _contextIdependencies_collect
            -- copy rule (down)
            (_simpletypeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_simpletypeOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_simpletypeOinferredDependencies_collect@_) =
                _contextIinferredDependencies_collect
            -- copy rule (down)
            (_simpletypeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_simpletypeOlabels_collect@_) =
                _contextIlabels_collect
            -- copy rule (down)
            (_simpletypeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_simpletypeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_simpletypeOmethods_collect@_) =
                _contextImethods_collect
            -- copy rule (down)
            (_simpletypeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_simpletypeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_constructorOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_constructorOconstructors_collect@_) =
                _simpletypeIconstructors_collect
            -- copy rule (down)
            (_constructorOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_constructorOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_constructorOdependencies_collect@_) =
                _simpletypeIdependencies_collect
            -- copy rule (down)
            (_constructorOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_constructorOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_constructorOinferredDependencies_collect@_) =
                _simpletypeIinferredDependencies_collect
            -- copy rule (down)
            (_constructorOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_constructorOlabels_collect@_) =
                _simpletypeIlabels_collect
            -- copy rule (down)
            (_constructorOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_constructorOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_constructorOmethods_collect@_) =
                _simpletypeImethods_collect
            -- copy rule (down)
            (_constructorOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_constructorOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_derivingsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_derivingsOconstructors_collect@_) =
                _constructorIconstructors_collect
            -- copy rule (down)
            (_derivingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_derivingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_derivingsOdependencies_collect@_) =
                _constructorIdependencies_collect
            -- copy rule (down)
            (_derivingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_derivingsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_derivingsOinferredDependencies_collect@_) =
                _constructorIinferredDependencies_collect
            -- copy rule (down)
            (_derivingsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_derivingsOlabels_collect@_) =
                _constructorIlabels_collect
            -- copy rule (down)
            (_derivingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_derivingsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_derivingsOmethods_collect@_) =
                _constructorImethods_collect
            -- copy rule (down)
            (_derivingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_derivingsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Declaration_PatternBinding :: (T_Range) ->
                                  (T_Pattern) ->
                                  (T_RightHandSide) ->
                                  (T_Declaration)
sem_Declaration_PatternBinding (range_) (pattern_) (righthandside_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _patternIconstructors_collect :: (FMap Name Names)
            _patternIdependencies_collect :: (FMap Name [(Name,Name)])
            _patternIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _patternIlabels_collect :: (FMap Name Names)
            _patternImethods_collect :: (FMap Name Names)
            _patternIname :: (Name)
            _patternIself :: (Pattern)
            _patternOclassname :: (Maybe Name)
            _patternOconstructors_collect :: (FMap Name Names)
            _patternOconstructors_dist :: (FMap Name Names)
            _patternOcurrentModule :: (Strings)
            _patternOdependencies_collect :: (FMap Name [(Name,Name)])
            _patternOimportedModule :: (Bool)
            _patternOinferredDependencies :: (FMap Name [(Name,Name)])
            _patternOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _patternOinstancename :: (Maybe Name)
            _patternOlabels_collect :: (FMap Name Names)
            _patternOlabels_dist :: (FMap Name Names)
            _patternOlocal :: (Bool)
            _patternOmethods_collect :: (FMap Name Names)
            _patternOmethods_dist :: (FMap Name Names)
            _patternOtoplevel :: (Bool)
            _righthandsideIbodyDependencies :: ([(Name,Name)])
            _righthandsideIconstructors_collect :: (FMap Name Names)
            _righthandsideIdependencies_collect :: (FMap Name [(Name,Name)])
            _righthandsideIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _righthandsideIlabels_collect :: (FMap Name Names)
            _righthandsideImethods_collect :: (FMap Name Names)
            _righthandsideIpresignatures_collect :: (PreSignatures)
            _righthandsideIself :: (RightHandSide)
            _righthandsideOclassname :: (Maybe Name)
            _righthandsideOconstructors_collect :: (FMap Name Names)
            _righthandsideOconstructors_dist :: (FMap Name Names)
            _righthandsideOcurrentModule :: (Strings)
            _righthandsideOdependencies_collect :: (FMap Name [(Name,Name)])
            _righthandsideOimportedModule :: (Bool)
            _righthandsideOinferredDependencies :: (FMap Name [(Name,Name)])
            _righthandsideOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _righthandsideOinstancename :: (Maybe Name)
            _righthandsideOlabels_collect :: (FMap Name Names)
            _righthandsideOlabels_dist :: (FMap Name Names)
            _righthandsideOlocal :: (Bool)
            _righthandsideOmethods_collect :: (FMap Name Names)
            _righthandsideOmethods_dist :: (FMap Name Names)
            _righthandsideOpresignatures :: (PreSignatures)
            _righthandsideOpresignatures_collect :: (PreSignatures)
            _righthandsideOsignatures :: (Signatures)
            _righthandsideOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _patternIconstructors_collect,_patternIdependencies_collect,_patternIinferredDependencies_collect,_patternIlabels_collect,_patternImethods_collect,_patternIname,_patternIself) =
                (pattern_ (_patternOclassname) (_patternOconstructors_collect) (_patternOconstructors_dist) (_patternOcurrentModule) (_patternOdependencies_collect) (_patternOimportedModule) (_patternOinferredDependencies) (_patternOinferredDependencies_collect) (_patternOinstancename) (_patternOlabels_collect) (_patternOlabels_dist) (_patternOlocal) (_patternOmethods_collect) (_patternOmethods_dist) (_patternOtoplevel))
            ( _righthandsideIbodyDependencies,_righthandsideIconstructors_collect,_righthandsideIdependencies_collect,_righthandsideIinferredDependencies_collect,_righthandsideIlabels_collect,_righthandsideImethods_collect,_righthandsideIpresignatures_collect,_righthandsideIself) =
                (righthandside_ (_righthandsideOclassname)
                                (_righthandsideOconstructors_collect)
                                (_righthandsideOconstructors_dist)
                                (_righthandsideOcurrentModule)
                                (_righthandsideOdependencies_collect)
                                (_righthandsideOimportedModule)
                                (_righthandsideOinferredDependencies)
                                (_righthandsideOinferredDependencies_collect)
                                (_righthandsideOinstancename)
                                (_righthandsideOlabels_collect)
                                (_righthandsideOlabels_dist)
                                (_righthandsideOlocal)
                                (_righthandsideOmethods_collect)
                                (_righthandsideOmethods_dist)
                                (_righthandsideOpresignatures)
                                (_righthandsideOpresignatures_collect)
                                (_righthandsideOsignatures)
                                (_righthandsideOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 148, column 8)
            (_righthandsideOtoplevel@_) =
                False
            -- use rule
            (_lhsObodyDependencies@_) =
                _righthandsideIbodyDependencies
            -- self rule
            (_self@_) =
                Declaration_PatternBinding _rangeIself _patternIself _righthandsideIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _righthandsideIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _righthandsideIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _righthandsideIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _righthandsideIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _righthandsideImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _righthandsideIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_patternOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_patternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_patternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_patternOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_patternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_patternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_patternOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_patternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_righthandsideOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_righthandsideOconstructors_collect@_) =
                _patternIconstructors_collect
            -- copy rule (down)
            (_righthandsideOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_righthandsideOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_righthandsideOdependencies_collect@_) =
                _patternIdependencies_collect
            -- copy rule (down)
            (_righthandsideOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_righthandsideOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_righthandsideOinferredDependencies_collect@_) =
                _patternIinferredDependencies_collect
            -- copy rule (down)
            (_righthandsideOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_righthandsideOlabels_collect@_) =
                _patternIlabels_collect
            -- copy rule (down)
            (_righthandsideOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_righthandsideOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_righthandsideOmethods_collect@_) =
                _patternImethods_collect
            -- copy rule (down)
            (_righthandsideOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_righthandsideOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_righthandsideOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_righthandsideOsignatures@_) =
                _lhsIsignatures
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Declaration_Type :: (T_Range) ->
                        (T_SimpleType) ->
                        (T_Type) ->
                        (T_Declaration)
sem_Declaration_Type (range_) (simpletype_) (type_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _simpletypeIconstructors_collect :: (FMap Name Names)
            _simpletypeIdependencies_collect :: (FMap Name [(Name,Name)])
            _simpletypeIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _simpletypeIlabels_collect :: (FMap Name Names)
            _simpletypeImethods_collect :: (FMap Name Names)
            _simpletypeIname :: (Name)
            _simpletypeIself :: (SimpleType)
            _simpletypeOclassname :: (Maybe Name)
            _simpletypeOconstructors_collect :: (FMap Name Names)
            _simpletypeOconstructors_dist :: (FMap Name Names)
            _simpletypeOcurrentModule :: (Strings)
            _simpletypeOdependencies_collect :: (FMap Name [(Name,Name)])
            _simpletypeOimportedModule :: (Bool)
            _simpletypeOinferredDependencies :: (FMap Name [(Name,Name)])
            _simpletypeOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _simpletypeOinstancename :: (Maybe Name)
            _simpletypeOlabels_collect :: (FMap Name Names)
            _simpletypeOlabels_dist :: (FMap Name Names)
            _simpletypeOlocal :: (Bool)
            _simpletypeOmethods_collect :: (FMap Name Names)
            _simpletypeOmethods_dist :: (FMap Name Names)
            _simpletypeOtoplevel :: (Bool)
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIdependencies_collect :: (FMap Name [(Name,Name)])
            _typeIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typeIlabels_collect :: (FMap Name Names)
            _typeIlocalDependencies :: ([(Name,Name)])
            _typeImethods_collect :: (FMap Name Names)
            _typeIself :: (Type)
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOdependencies_collect :: (FMap Name [(Name,Name)])
            _typeOimportedModule :: (Bool)
            _typeOinferredDependencies :: (FMap Name [(Name,Name)])
            _typeOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typeOinstancename :: (Maybe Name)
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _simpletypeIconstructors_collect,_simpletypeIdependencies_collect,_simpletypeIinferredDependencies_collect,_simpletypeIlabels_collect,_simpletypeImethods_collect,_simpletypeIname,_simpletypeIself) =
                (simpletype_ (_simpletypeOclassname)
                             (_simpletypeOconstructors_collect)
                             (_simpletypeOconstructors_dist)
                             (_simpletypeOcurrentModule)
                             (_simpletypeOdependencies_collect)
                             (_simpletypeOimportedModule)
                             (_simpletypeOinferredDependencies)
                             (_simpletypeOinferredDependencies_collect)
                             (_simpletypeOinstancename)
                             (_simpletypeOlabels_collect)
                             (_simpletypeOlabels_dist)
                             (_simpletypeOlocal)
                             (_simpletypeOmethods_collect)
                             (_simpletypeOmethods_dist)
                             (_simpletypeOtoplevel))
            ( _typeIconstructors_collect,_typeIdependencies_collect,_typeIinferredDependencies_collect,_typeIlabels_collect,_typeIlocalDependencies,_typeImethods_collect,_typeIself) =
                (type_ (_typeOclassname) (_typeOconstructors_collect) (_typeOconstructors_dist) (_typeOcurrentModule) (_typeOdependencies_collect) (_typeOimportedModule) (_typeOinferredDependencies) (_typeOinferredDependencies_collect) (_typeOinstancename) (_typeOlabels_collect) (_typeOlabels_dist) (_typeOlocal) (_typeOmethods_collect) (_typeOmethods_dist) (_typeOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 142, column 8)
            (_typeOtoplevel@_) =
                False
            -- use rule
            (_lhsObodyDependencies@_) =
                []
            -- self rule
            (_self@_) =
                Declaration_Type _rangeIself _simpletypeIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _typeIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _typeIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_simpletypeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_simpletypeOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_simpletypeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_simpletypeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_simpletypeOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_simpletypeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_simpletypeOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_simpletypeOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_simpletypeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_simpletypeOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_simpletypeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_simpletypeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_simpletypeOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_simpletypeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_simpletypeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _simpletypeIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_typeOdependencies_collect@_) =
                _simpletypeIdependencies_collect
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_typeOinferredDependencies_collect@_) =
                _simpletypeIinferredDependencies_collect
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _simpletypeIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _simpletypeImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Declaration_TypeIndexedType :: (T_Range) ->
                                   (T_Name) ->
                                   (T_TypeArgument) ->
                                   (T_Names) ->
                                   (T_Constructor) ->
                                   (T_Names) ->
                                   (T_Declaration)
sem_Declaration_TypeIndexedType (range_) (name_) (typeargument_) (typevariables_) (constructor_) (derivings_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _typeargumentIconstructors_collect :: (FMap Name Names)
            _typeargumentIdependencies_collect :: (FMap Name [(Name,Name)])
            _typeargumentIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typeargumentIlabels_collect :: (FMap Name Names)
            _typeargumentImethods_collect :: (FMap Name Names)
            _typeargumentIself :: (TypeArgument)
            _typeargumentOclassname :: (Maybe Name)
            _typeargumentOconstructors_collect :: (FMap Name Names)
            _typeargumentOconstructors_dist :: (FMap Name Names)
            _typeargumentOcurrentModule :: (Strings)
            _typeargumentOdependencies_collect :: (FMap Name [(Name,Name)])
            _typeargumentOimportedModule :: (Bool)
            _typeargumentOinferredDependencies :: (FMap Name [(Name,Name)])
            _typeargumentOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typeargumentOinstancename :: (Maybe Name)
            _typeargumentOlabels_collect :: (FMap Name Names)
            _typeargumentOlabels_dist :: (FMap Name Names)
            _typeargumentOlocal :: (Bool)
            _typeargumentOmethods_collect :: (FMap Name Names)
            _typeargumentOmethods_dist :: (FMap Name Names)
            _typeargumentOtoplevel :: (Bool)
            _typevariablesIconstructors_collect :: (FMap Name Names)
            _typevariablesIdependencies_collect :: (FMap Name [(Name,Name)])
            _typevariablesIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typevariablesIlabels_collect :: (FMap Name Names)
            _typevariablesImethods_collect :: (FMap Name Names)
            _typevariablesIself :: (Names)
            _typevariablesOclassname :: (Maybe Name)
            _typevariablesOconstructors_collect :: (FMap Name Names)
            _typevariablesOconstructors_dist :: (FMap Name Names)
            _typevariablesOcurrentModule :: (Strings)
            _typevariablesOdependencies_collect :: (FMap Name [(Name,Name)])
            _typevariablesOimportedModule :: (Bool)
            _typevariablesOinferredDependencies :: (FMap Name [(Name,Name)])
            _typevariablesOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typevariablesOinstancename :: (Maybe Name)
            _typevariablesOlabels_collect :: (FMap Name Names)
            _typevariablesOlabels_dist :: (FMap Name Names)
            _typevariablesOlocal :: (Bool)
            _typevariablesOmethods_collect :: (FMap Name Names)
            _typevariablesOmethods_dist :: (FMap Name Names)
            _typevariablesOtoplevel :: (Bool)
            _constructorIconstructors :: (Names)
            _constructorIconstructors_collect :: (FMap Name Names)
            _constructorIdependencies_collect :: (FMap Name [(Name,Name)])
            _constructorIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _constructorIlabels :: (Names)
            _constructorIlabels_collect :: (FMap Name Names)
            _constructorImethods_collect :: (FMap Name Names)
            _constructorIself :: (Constructor)
            _constructorOclassname :: (Maybe Name)
            _constructorOconstructors_collect :: (FMap Name Names)
            _constructorOconstructors_dist :: (FMap Name Names)
            _constructorOcurrentModule :: (Strings)
            _constructorOdependencies_collect :: (FMap Name [(Name,Name)])
            _constructorOimportedModule :: (Bool)
            _constructorOinferredDependencies :: (FMap Name [(Name,Name)])
            _constructorOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _constructorOinstancename :: (Maybe Name)
            _constructorOlabels_collect :: (FMap Name Names)
            _constructorOlabels_dist :: (FMap Name Names)
            _constructorOlocal :: (Bool)
            _constructorOmethods_collect :: (FMap Name Names)
            _constructorOmethods_dist :: (FMap Name Names)
            _constructorOtoplevel :: (Bool)
            _derivingsIconstructors_collect :: (FMap Name Names)
            _derivingsIdependencies_collect :: (FMap Name [(Name,Name)])
            _derivingsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _derivingsIlabels_collect :: (FMap Name Names)
            _derivingsImethods_collect :: (FMap Name Names)
            _derivingsIself :: (Names)
            _derivingsOclassname :: (Maybe Name)
            _derivingsOconstructors_collect :: (FMap Name Names)
            _derivingsOconstructors_dist :: (FMap Name Names)
            _derivingsOcurrentModule :: (Strings)
            _derivingsOdependencies_collect :: (FMap Name [(Name,Name)])
            _derivingsOimportedModule :: (Bool)
            _derivingsOinferredDependencies :: (FMap Name [(Name,Name)])
            _derivingsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _derivingsOinstancename :: (Maybe Name)
            _derivingsOlabels_collect :: (FMap Name Names)
            _derivingsOlabels_dist :: (FMap Name Names)
            _derivingsOlocal :: (Bool)
            _derivingsOmethods_collect :: (FMap Name Names)
            _derivingsOmethods_dist :: (FMap Name Names)
            _derivingsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _typeargumentIconstructors_collect,_typeargumentIdependencies_collect,_typeargumentIinferredDependencies_collect,_typeargumentIlabels_collect,_typeargumentImethods_collect,_typeargumentIself) =
                (typeargument_ (_typeargumentOclassname)
                               (_typeargumentOconstructors_collect)
                               (_typeargumentOconstructors_dist)
                               (_typeargumentOcurrentModule)
                               (_typeargumentOdependencies_collect)
                               (_typeargumentOimportedModule)
                               (_typeargumentOinferredDependencies)
                               (_typeargumentOinferredDependencies_collect)
                               (_typeargumentOinstancename)
                               (_typeargumentOlabels_collect)
                               (_typeargumentOlabels_dist)
                               (_typeargumentOlocal)
                               (_typeargumentOmethods_collect)
                               (_typeargumentOmethods_dist)
                               (_typeargumentOtoplevel))
            ( _typevariablesIconstructors_collect,_typevariablesIdependencies_collect,_typevariablesIinferredDependencies_collect,_typevariablesIlabels_collect,_typevariablesImethods_collect,_typevariablesIself) =
                (typevariables_ (_typevariablesOclassname)
                                (_typevariablesOconstructors_collect)
                                (_typevariablesOconstructors_dist)
                                (_typevariablesOcurrentModule)
                                (_typevariablesOdependencies_collect)
                                (_typevariablesOimportedModule)
                                (_typevariablesOinferredDependencies)
                                (_typevariablesOinferredDependencies_collect)
                                (_typevariablesOinstancename)
                                (_typevariablesOlabels_collect)
                                (_typevariablesOlabels_dist)
                                (_typevariablesOlocal)
                                (_typevariablesOmethods_collect)
                                (_typevariablesOmethods_dist)
                                (_typevariablesOtoplevel))
            ( _constructorIconstructors,_constructorIconstructors_collect,_constructorIdependencies_collect,_constructorIinferredDependencies_collect,_constructorIlabels,_constructorIlabels_collect,_constructorImethods_collect,_constructorIself) =
                (constructor_ (_constructorOclassname)
                              (_constructorOconstructors_collect)
                              (_constructorOconstructors_dist)
                              (_constructorOcurrentModule)
                              (_constructorOdependencies_collect)
                              (_constructorOimportedModule)
                              (_constructorOinferredDependencies)
                              (_constructorOinferredDependencies_collect)
                              (_constructorOinstancename)
                              (_constructorOlabels_collect)
                              (_constructorOlabels_dist)
                              (_constructorOlocal)
                              (_constructorOmethods_collect)
                              (_constructorOmethods_dist)
                              (_constructorOtoplevel))
            ( _derivingsIconstructors_collect,_derivingsIdependencies_collect,_derivingsIinferredDependencies_collect,_derivingsIlabels_collect,_derivingsImethods_collect,_derivingsIself) =
                (derivings_ (_derivingsOclassname)
                            (_derivingsOconstructors_collect)
                            (_derivingsOconstructors_dist)
                            (_derivingsOcurrentModule)
                            (_derivingsOdependencies_collect)
                            (_derivingsOimportedModule)
                            (_derivingsOinferredDependencies)
                            (_derivingsOinferredDependencies_collect)
                            (_derivingsOinstancename)
                            (_derivingsOlabels_collect)
                            (_derivingsOlabels_dist)
                            (_derivingsOlocal)
                            (_derivingsOmethods_collect)
                            (_derivingsOmethods_dist)
                            (_derivingsOtoplevel))
            -- "./Signature.inc.lag"(line 177, column 9)
            (_signature@_) =
                applyFMM
                  _lhsIsignatures
                  (const $ internalError $
                     "Signature.Declaration.TypeIndexedType: "
                     ++ "no signature"
                  )
                  _nameIself
            -- "./Signature.inc.lag"(line 171, column 9)
            (_lhsOpresignatures_collect@_) =
                modify
                  _presignatures_collect
                  _nameIself
                  (\(types,link) -> (simplifyTypeArgument _typeargumentIself:types,link))
            -- "./Signature.inc.lag"(line 155, column 9)
            (_presignatures_collect@_) =
                if _first then
                  add
                    _lhsIpresignatures_collect
                    (_nameIself,([],Nothing))
                 else
                  _lhsIpresignatures_collect
            -- "./Signature.inc.lag"(line 148, column 9)
            (_first@_) =
                case  find
                        _lhsIpresignatures_collect
                        _nameIself
                of
                  Nothing  ->  True
                  Just _   ->  False
            -- "./ModuleInformation.inc.lag"(line 144, column 8)
            (_typevariablesOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 327, column 9)
            (_lhsOconstructors_collect@_) =
                addLBack _lhsIconstructors_collect
                         (_nameIself,_constructorIconstructors)
            -- use rule
            (_lhsObodyDependencies@_) =
                []
            -- self rule
            (_self@_) =
                Declaration_TypeIndexedType _rangeIself _nameIself _typeargumentIself _typevariablesIself _constructorIself _derivingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _derivingsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _derivingsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _derivingsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _derivingsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeargumentOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeargumentOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_typeargumentOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeargumentOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_typeargumentOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_typeargumentOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeargumentOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_typeargumentOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_typeargumentOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typeargumentOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_typeargumentOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeargumentOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeargumentOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_typeargumentOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typeargumentOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typevariablesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typevariablesOconstructors_collect@_) =
                _typeargumentIconstructors_collect
            -- copy rule (down)
            (_typevariablesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typevariablesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_typevariablesOdependencies_collect@_) =
                _typeargumentIdependencies_collect
            -- copy rule (down)
            (_typevariablesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typevariablesOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_typevariablesOinferredDependencies_collect@_) =
                _typeargumentIinferredDependencies_collect
            -- copy rule (down)
            (_typevariablesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typevariablesOlabels_collect@_) =
                _typeargumentIlabels_collect
            -- copy rule (down)
            (_typevariablesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typevariablesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typevariablesOmethods_collect@_) =
                _typeargumentImethods_collect
            -- copy rule (down)
            (_typevariablesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_constructorOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_constructorOconstructors_collect@_) =
                _typevariablesIconstructors_collect
            -- copy rule (down)
            (_constructorOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_constructorOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_constructorOdependencies_collect@_) =
                _typevariablesIdependencies_collect
            -- copy rule (down)
            (_constructorOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_constructorOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_constructorOinferredDependencies_collect@_) =
                _typevariablesIinferredDependencies_collect
            -- copy rule (down)
            (_constructorOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_constructorOlabels_collect@_) =
                _typevariablesIlabels_collect
            -- copy rule (down)
            (_constructorOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_constructorOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_constructorOmethods_collect@_) =
                _typevariablesImethods_collect
            -- copy rule (down)
            (_constructorOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_constructorOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_derivingsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_derivingsOconstructors_collect@_) =
                _constructorIconstructors_collect
            -- copy rule (down)
            (_derivingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_derivingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_derivingsOdependencies_collect@_) =
                _constructorIdependencies_collect
            -- copy rule (down)
            (_derivingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_derivingsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_derivingsOinferredDependencies_collect@_) =
                _constructorIinferredDependencies_collect
            -- copy rule (down)
            (_derivingsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_derivingsOlabels_collect@_) =
                _constructorIlabels_collect
            -- copy rule (down)
            (_derivingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_derivingsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_derivingsOmethods_collect@_) =
                _constructorImethods_collect
            -- copy rule (down)
            (_derivingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_derivingsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Declaration_TypeIndexedValue :: (T_Range) ->
                                    (T_TypeIndexedBindings) ->
                                    (T_Declaration)
sem_Declaration_TypeIndexedValue (range_) (bindings_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _bindingsIbodyDependencies :: ([(Name,Name)])
            _bindingsIconstructors_collect :: (FMap Name Names)
            _bindingsIdependencies_collect :: (FMap Name [(Name,Name)])
            _bindingsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _bindingsIlabels_collect :: (FMap Name Names)
            _bindingsIlinkname :: (Maybe Name)
            _bindingsImethods_collect :: (FMap Name Names)
            _bindingsIname :: (Name)
            _bindingsIpresignatures_collect :: (PreSignatures)
            _bindingsIself :: (TypeIndexedBindings)
            _bindingsItypeargument :: (Maybe TypeArgument)
            _bindingsOclassname :: (Maybe Name)
            _bindingsOconstructors_collect :: (FMap Name Names)
            _bindingsOconstructors_dist :: (FMap Name Names)
            _bindingsOcurrentModule :: (Strings)
            _bindingsOdependencies_collect :: (FMap Name [(Name,Name)])
            _bindingsOimportedModule :: (Bool)
            _bindingsOinferredDependencies :: (FMap Name [(Name,Name)])
            _bindingsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _bindingsOinstancename :: (Maybe Name)
            _bindingsOlabels_collect :: (FMap Name Names)
            _bindingsOlabels_dist :: (FMap Name Names)
            _bindingsOlocal :: (Bool)
            _bindingsOmethods_collect :: (FMap Name Names)
            _bindingsOmethods_dist :: (FMap Name Names)
            _bindingsOpresignatures :: (PreSignatures)
            _bindingsOpresignatures_collect :: (PreSignatures)
            _bindingsOsignatures :: (Signatures)
            _bindingsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _bindingsIbodyDependencies,_bindingsIconstructors_collect,_bindingsIdependencies_collect,_bindingsIinferredDependencies_collect,_bindingsIlabels_collect,_bindingsIlinkname,_bindingsImethods_collect,_bindingsIname,_bindingsIpresignatures_collect,_bindingsIself,_bindingsItypeargument) =
                (bindings_ (_bindingsOclassname)
                           (_bindingsOconstructors_collect)
                           (_bindingsOconstructors_dist)
                           (_bindingsOcurrentModule)
                           (_bindingsOdependencies_collect)
                           (_bindingsOimportedModule)
                           (_bindingsOinferredDependencies)
                           (_bindingsOinferredDependencies_collect)
                           (_bindingsOinstancename)
                           (_bindingsOlabels_collect)
                           (_bindingsOlabels_dist)
                           (_bindingsOlocal)
                           (_bindingsOmethods_collect)
                           (_bindingsOmethods_dist)
                           (_bindingsOpresignatures)
                           (_bindingsOpresignatures_collect)
                           (_bindingsOsignatures)
                           (_bindingsOtoplevel))
            -- "./Signature.inc.lag"(line 283, column 9)
            (_linkname@_) =
                maybe
                  (illegalDefaultCaseError _bindingsIname)
                  id
                  _bindingsIlinkname
            -- "./Signature.inc.lag"(line 269, column 9)
            (_signature_link@_) =
                applyOrSignatureError _lhsIsignatures _linkname $
                  "Signature.Declaration.TypeIndexedValue: " ++
                  "no signature for link"
            -- "./Signature.inc.lag"(line 264, column 9)
            (_presignature@_) =
                applyOrSignatureError _lhsIpresignatures _bindingsIname $
                  "Signature.Declaration.TypeIndexedValue: " ++
                  "no presignature for "
            -- "./Signature.inc.lag"(line 259, column 9)
            (_signature@_) =
                applyOrSignatureError _lhsIsignatures _bindingsIname $
                  "Signature.Declaration.TypeIndexedValue: " ++
                  "no signature for "
            -- "./Signature.inc.lag"(line 238, column 9)
            (_lhsOpresignatures_collect@_) =
                if not _lhsItoplevel then
                  _presignatures_collect
                 else if _defaultcase then
                  modify
                    _presignatures_collect
                    _bindingsIname
                    (\(types,link) ->
                        case link of
                          Nothing  ->  (types,Just _linkname)
                          _        ->  doubleDefaultCaseError
                                         _bindingsIname
                    )
                 else
                  modify
                    _presignatures_collect
                    _bindingsIname
                    (\(types,link) ->
                        (simplifyTypeArgument _typeargument:types,link)
                    )
            -- "./Signature.inc.lag"(line 220, column 9)
            (_typeargument@_) =
                case _bindingsItypeargument of
                  Nothing  ->
                    internalError $
                      "Signature.TypeIndexedValue.typeargument: " ++
                      "type argument accessed in a default case"
                  Just t   ->  t
            -- "./Signature.inc.lag"(line 218, column 9)
            (_defaultcase@_) =
                isNothing _bindingsItypeargument
            -- "./Signature.inc.lag"(line 202, column 9)
            (_presignatures_collect@_) =
                if _first then
                  add
                    _lhsIpresignatures_collect
                    (_bindingsIname,([],Nothing))
                 else
                  _lhsIpresignatures_collect
            -- "./Signature.inc.lag"(line 195, column 9)
            (_first@_) =
                case  find
                        _lhsIpresignatures_collect
                        _bindingsIname
                of
                      Nothing  ->  True
                      Just _   ->  False
            -- use rule
            (_lhsObodyDependencies@_) =
                _bindingsIbodyDependencies
            -- self rule
            (_self@_) =
                Declaration_TypeIndexedValue _rangeIself _bindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _bindingsIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _bindingsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _bindingsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _bindingsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _bindingsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_bindingsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_bindingsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_bindingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_bindingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_bindingsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_bindingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_bindingsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_bindingsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_bindingsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_bindingsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_bindingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_bindingsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_bindingsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_bindingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_bindingsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_bindingsOpresignatures_collect@_) =
                _presignatures_collect
            -- copy rule (down)
            (_bindingsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_bindingsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Declaration_TypeSignature :: (T_Range) ->
                                 (T_Names) ->
                                 (T_Type) ->
                                 (T_Declaration)
sem_Declaration_TypeSignature (range_) (names_) (type_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Declaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _namesIconstructors_collect :: (FMap Name Names)
            _namesIdependencies_collect :: (FMap Name [(Name,Name)])
            _namesIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _namesIlabels_collect :: (FMap Name Names)
            _namesImethods_collect :: (FMap Name Names)
            _namesIself :: (Names)
            _namesOclassname :: (Maybe Name)
            _namesOconstructors_collect :: (FMap Name Names)
            _namesOconstructors_dist :: (FMap Name Names)
            _namesOcurrentModule :: (Strings)
            _namesOdependencies_collect :: (FMap Name [(Name,Name)])
            _namesOimportedModule :: (Bool)
            _namesOinferredDependencies :: (FMap Name [(Name,Name)])
            _namesOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _namesOinstancename :: (Maybe Name)
            _namesOlabels_collect :: (FMap Name Names)
            _namesOlabels_dist :: (FMap Name Names)
            _namesOlocal :: (Bool)
            _namesOmethods_collect :: (FMap Name Names)
            _namesOmethods_dist :: (FMap Name Names)
            _namesOtoplevel :: (Bool)
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIdependencies_collect :: (FMap Name [(Name,Name)])
            _typeIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typeIlabels_collect :: (FMap Name Names)
            _typeIlocalDependencies :: ([(Name,Name)])
            _typeImethods_collect :: (FMap Name Names)
            _typeIself :: (Type)
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOdependencies_collect :: (FMap Name [(Name,Name)])
            _typeOimportedModule :: (Bool)
            _typeOinferredDependencies :: (FMap Name [(Name,Name)])
            _typeOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typeOinstancename :: (Maybe Name)
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _namesIconstructors_collect,_namesIdependencies_collect,_namesIinferredDependencies_collect,_namesIlabels_collect,_namesImethods_collect,_namesIself) =
                (names_ (_namesOclassname) (_namesOconstructors_collect) (_namesOconstructors_dist) (_namesOcurrentModule) (_namesOdependencies_collect) (_namesOimportedModule) (_namesOinferredDependencies) (_namesOinferredDependencies_collect) (_namesOinstancename) (_namesOlabels_collect) (_namesOlabels_dist) (_namesOlocal) (_namesOmethods_collect) (_namesOmethods_dist) (_namesOtoplevel))
            ( _typeIconstructors_collect,_typeIdependencies_collect,_typeIinferredDependencies_collect,_typeIlabels_collect,_typeIlocalDependencies,_typeImethods_collect,_typeIself) =
                (type_ (_typeOclassname) (_typeOconstructors_collect) (_typeOconstructors_dist) (_typeOcurrentModule) (_typeOdependencies_collect) (_typeOimportedModule) (_typeOinferredDependencies) (_typeOinferredDependencies_collect) (_typeOinstancename) (_typeOlabels_collect) (_typeOlabels_dist) (_typeOlocal) (_typeOmethods_collect) (_typeOmethods_dist) (_typeOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 146, column 8)
            (_typeOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 335, column 9)
            (_lhsOmethods_collect@_) =
                case _lhsIclassname of
                  Nothing -> _lhsImethods_collect
                  Just c  -> addLBack _lhsImethods_collect
                                      (c,_namesIself)
            -- use rule
            (_lhsObodyDependencies@_) =
                []
            -- self rule
            (_self@_) =
                Declaration_TypeSignature _rangeIself _namesIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _typeIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _typeIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_namesOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_namesOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_namesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_namesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_namesOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_namesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_namesOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_namesOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_namesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_namesOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_namesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_namesOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_namesOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_namesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_namesOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _namesIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_typeOdependencies_collect@_) =
                _namesIdependencies_collect
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_typeOinferredDependencies_collect@_) =
                _namesIinferredDependencies_collect
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _namesIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _namesImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- Declarations ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      bodyDependencies     : [(Name,Name)]
      self                 : SELF

-}
{-
   local variables for Declarations.Cons:
      self

-}
{-
   local variables for Declarations.Nil:
      self

-}
-- semantic domain
type T_Declarations = (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Strings) ->
                      (FMap Name [(Name,Name)]) ->
                      (Bool) ->
                      (FMap Name [(Name,Name)]) ->
                      (FMap Name [(Name,Name)]) ->
                      (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (PreSignatures) ->
                      (PreSignatures) ->
                      (Signatures) ->
                      (Bool) ->
                      ( ([(Name,Name)]),(FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(PreSignatures),(Declarations))
-- cata
sem_Declarations :: (Declarations) ->
                    (T_Declarations)
sem_Declarations (list) =
    (foldr (sem_Declarations_Cons) (sem_Declarations_Nil) ((map sem_Declaration list)))
sem_Declarations_Cons :: (T_Declaration) ->
                         (T_Declarations) ->
                         (T_Declarations)
sem_Declarations_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Declarations)
            _hdIbodyDependencies :: ([(Name,Name)])
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdependencies_collect :: (FMap Name [(Name,Name)])
            _hdIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIpresignatures_collect :: (PreSignatures)
            _hdIself :: (Declaration)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies_collect :: (FMap Name [(Name,Name)])
            _hdOimportedModule :: (Bool)
            _hdOinferredDependencies :: (FMap Name [(Name,Name)])
            _hdOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdOinstancename :: (Maybe Name)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOpresignatures :: (PreSignatures)
            _hdOpresignatures_collect :: (PreSignatures)
            _hdOsignatures :: (Signatures)
            _hdOtoplevel :: (Bool)
            _tlIbodyDependencies :: ([(Name,Name)])
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdependencies_collect :: (FMap Name [(Name,Name)])
            _tlIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIpresignatures_collect :: (PreSignatures)
            _tlIself :: (Declarations)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies_collect :: (FMap Name [(Name,Name)])
            _tlOimportedModule :: (Bool)
            _tlOinferredDependencies :: (FMap Name [(Name,Name)])
            _tlOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOpresignatures :: (PreSignatures)
            _tlOpresignatures_collect :: (PreSignatures)
            _tlOsignatures :: (Signatures)
            _tlOtoplevel :: (Bool)
            ( _hdIbodyDependencies,_hdIconstructors_collect,_hdIdependencies_collect,_hdIinferredDependencies_collect,_hdIlabels_collect,_hdImethods_collect,_hdIpresignatures_collect,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOdependencies_collect) (_hdOimportedModule) (_hdOinferredDependencies) (_hdOinferredDependencies_collect) (_hdOinstancename) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOpresignatures) (_hdOpresignatures_collect) (_hdOsignatures) (_hdOtoplevel))
            ( _tlIbodyDependencies,_tlIconstructors_collect,_tlIdependencies_collect,_tlIinferredDependencies_collect,_tlIlabels_collect,_tlImethods_collect,_tlIpresignatures_collect,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOdependencies_collect) (_tlOimportedModule) (_tlOinferredDependencies) (_tlOinferredDependencies_collect) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOpresignatures) (_tlOpresignatures_collect) (_tlOsignatures) (_tlOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _hdIbodyDependencies ++ _tlIbodyDependencies
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _tlIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _tlIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _tlIpresignatures_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_hdOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_hdOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_hdOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_tlOdependencies_collect@_) =
                _hdIdependencies_collect
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_tlOinferredDependencies_collect@_) =
                _hdIinferredDependencies_collect
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_tlOpresignatures_collect@_) =
                _hdIpresignatures_collect
            -- copy rule (down)
            (_tlOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Declarations_Nil :: (T_Declarations)
sem_Declarations_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Declarations)
            -- use rule
            (_lhsObodyDependencies@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- DependencyBinding -------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool
      typelevel            : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      localDependencies    : [(Name,Name)]
      self                 : SELF

-}
{-
   local variables for DependencyBinding.Rename:
      self

-}
{-
   local variables for DependencyBinding.Simple:
      self

-}
-- semantic domain
type T_DependencyBinding = (Maybe Name) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Strings) ->
                           (FMap Name [(Name,Name)]) ->
                           (Bool) ->
                           (FMap Name [(Name,Name)]) ->
                           (FMap Name [(Name,Name)]) ->
                           (Maybe Name) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Bool) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Bool) ->
                           (Bool) ->
                           ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),([(Name,Name)]),(FMap Name Names),(DependencyBinding))
-- cata
sem_DependencyBinding :: (DependencyBinding) ->
                         (T_DependencyBinding)
sem_DependencyBinding ((DependencyBinding_Rename (_range) (_name) (_as))) =
    (sem_DependencyBinding_Rename ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Name (_as))))
sem_DependencyBinding ((DependencyBinding_Simple (_range) (_name))) =
    (sem_DependencyBinding_Simple ((sem_Range (_range))) ((sem_Name (_name))))
sem_DependencyBinding_Rename :: (T_Range) ->
                                (T_Name) ->
                                (T_Name) ->
                                (T_DependencyBinding)
sem_DependencyBinding_Rename (range_) (name_) (as_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel
      _lhsItypelevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOlocalDependencies :: ([(Name,Name)])
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (DependencyBinding)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _asIconstructors_collect :: (FMap Name Names)
            _asIdependencies_collect :: (FMap Name [(Name,Name)])
            _asIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _asIlabels_collect :: (FMap Name Names)
            _asImethods_collect :: (FMap Name Names)
            _asIself :: (Name)
            _asOclassname :: (Maybe Name)
            _asOconstructors_collect :: (FMap Name Names)
            _asOconstructors_dist :: (FMap Name Names)
            _asOcurrentModule :: (Strings)
            _asOdependencies_collect :: (FMap Name [(Name,Name)])
            _asOimportedModule :: (Bool)
            _asOinferredDependencies :: (FMap Name [(Name,Name)])
            _asOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _asOinstancename :: (Maybe Name)
            _asOlabels_collect :: (FMap Name Names)
            _asOlabels_dist :: (FMap Name Names)
            _asOlocal :: (Bool)
            _asOmethods_collect :: (FMap Name Names)
            _asOmethods_dist :: (FMap Name Names)
            _asOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _asIconstructors_collect,_asIdependencies_collect,_asIinferredDependencies_collect,_asIlabels_collect,_asImethods_collect,_asIself) =
                (as_ (_asOclassname) (_asOconstructors_collect) (_asOconstructors_dist) (_asOcurrentModule) (_asOdependencies_collect) (_asOimportedModule) (_asOinferredDependencies) (_asOinferredDependencies_collect) (_asOinstancename) (_asOlabels_collect) (_asOlabels_dist) (_asOlocal) (_asOmethods_collect) (_asOmethods_dist) (_asOtoplevel))
            -- "ScanDependencies.lag"(line 88, column 9)
            (_lhsOlocalDependencies@_) =
                [(_nameIself,_asIself)]
            -- self rule
            (_self@_) =
                DependencyBinding_Rename _rangeIself _nameIself _asIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _asIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _asIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _asIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _asIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _asImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_asOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_asOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_asOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_asOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_asOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_asOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_asOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_asOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_asOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_asOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_asOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_asOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_asOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_asOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_asOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOlocalDependencies,_lhsOmethods_collect,_lhsOself)
sem_DependencyBinding_Simple :: (T_Range) ->
                                (T_Name) ->
                                (T_DependencyBinding)
sem_DependencyBinding_Simple (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel
      _lhsItypelevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOlocalDependencies :: ([(Name,Name)])
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (DependencyBinding)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            -- "ScanDependencies.lag"(line 86, column 9)
            (_lhsOlocalDependencies@_) =
                [(_nameIself,_nameIself)]
            -- self rule
            (_self@_) =
                DependencyBinding_Simple _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOlocalDependencies,_lhsOmethods_collect,_lhsOself)
-- DependencyBindings ------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool
      typelevel            : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      localDependencies    : [(Name,Name)]
      self                 : SELF

-}
{-
   local variables for DependencyBindings.Cons:
      self

-}
{-
   local variables for DependencyBindings.Nil:
      self

-}
-- semantic domain
type T_DependencyBindings = (Maybe Name) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Strings) ->
                            (FMap Name [(Name,Name)]) ->
                            (Bool) ->
                            (FMap Name [(Name,Name)]) ->
                            (FMap Name [(Name,Name)]) ->
                            (Maybe Name) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Bool) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Bool) ->
                            (Bool) ->
                            ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),([(Name,Name)]),(FMap Name Names),(DependencyBindings))
-- cata
sem_DependencyBindings :: (DependencyBindings) ->
                          (T_DependencyBindings)
sem_DependencyBindings (list) =
    (foldr (sem_DependencyBindings_Cons) (sem_DependencyBindings_Nil) ((map sem_DependencyBinding list)))
sem_DependencyBindings_Cons :: (T_DependencyBinding) ->
                               (T_DependencyBindings) ->
                               (T_DependencyBindings)
sem_DependencyBindings_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel
      _lhsItypelevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOlocalDependencies :: ([(Name,Name)])
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (DependencyBindings)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdependencies_collect :: (FMap Name [(Name,Name)])
            _hdIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdIlabels_collect :: (FMap Name Names)
            _hdIlocalDependencies :: ([(Name,Name)])
            _hdImethods_collect :: (FMap Name Names)
            _hdIself :: (DependencyBinding)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies_collect :: (FMap Name [(Name,Name)])
            _hdOimportedModule :: (Bool)
            _hdOinferredDependencies :: (FMap Name [(Name,Name)])
            _hdOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdOinstancename :: (Maybe Name)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOtoplevel :: (Bool)
            _hdOtypelevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdependencies_collect :: (FMap Name [(Name,Name)])
            _tlIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlIlabels_collect :: (FMap Name Names)
            _tlIlocalDependencies :: ([(Name,Name)])
            _tlImethods_collect :: (FMap Name Names)
            _tlIself :: (DependencyBindings)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies_collect :: (FMap Name [(Name,Name)])
            _tlOimportedModule :: (Bool)
            _tlOinferredDependencies :: (FMap Name [(Name,Name)])
            _tlOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOtoplevel :: (Bool)
            _tlOtypelevel :: (Bool)
            ( _hdIconstructors_collect,_hdIdependencies_collect,_hdIinferredDependencies_collect,_hdIlabels_collect,_hdIlocalDependencies,_hdImethods_collect,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOdependencies_collect) (_hdOimportedModule) (_hdOinferredDependencies) (_hdOinferredDependencies_collect) (_hdOinstancename) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOtoplevel) (_hdOtypelevel))
            ( _tlIconstructors_collect,_tlIdependencies_collect,_tlIinferredDependencies_collect,_tlIlabels_collect,_tlIlocalDependencies,_tlImethods_collect,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOdependencies_collect) (_tlOimportedModule) (_tlOinferredDependencies) (_tlOinferredDependencies_collect) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOtoplevel) (_tlOtypelevel))
            -- use rule
            (_lhsOlocalDependencies@_) =
                _hdIlocalDependencies ++ _tlIlocalDependencies
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _tlIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _tlIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_hdOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_hdOtypelevel@_) =
                _lhsItypelevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_tlOdependencies_collect@_) =
                _hdIdependencies_collect
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_tlOinferredDependencies_collect@_) =
                _hdIinferredDependencies_collect
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOtypelevel@_) =
                _lhsItypelevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOlocalDependencies,_lhsOmethods_collect,_lhsOself)
sem_DependencyBindings_Nil :: (T_DependencyBindings)
sem_DependencyBindings_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel
      _lhsItypelevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOlocalDependencies :: ([(Name,Name)])
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (DependencyBindings)
            -- use rule
            (_lhsOlocalDependencies@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOlocalDependencies,_lhsOmethods_collect,_lhsOself)
-- Export ------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Export.Module:
      self

-}
{-
   local variables for Export.TypeOrClass:
      self

-}
{-
   local variables for Export.TypeOrClassComplete:
      self

-}
{-
   local variables for Export.Variable:
      self

-}
-- semantic domain
type T_Export = (Maybe Name) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (Strings) ->
                (FMap Name [(Name,Name)]) ->
                (Bool) ->
                (FMap Name [(Name,Name)]) ->
                (FMap Name [(Name,Name)]) ->
                (Maybe Name) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (Bool) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (Bool) ->
                ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(Export))
-- cata
sem_Export :: (Export) ->
              (T_Export)
sem_Export ((Export_Module (_range) (_name))) =
    (sem_Export_Module ((sem_Range (_range))) ((sem_ModuleName (_name))))
sem_Export ((Export_TypeOrClass (_range) (_name) (_names))) =
    (sem_Export_TypeOrClass ((sem_Range (_range))) ((sem_Name (_name))) ((sem_MaybeNames (_names))))
sem_Export ((Export_TypeOrClassComplete (_range) (_name))) =
    (sem_Export_TypeOrClassComplete ((sem_Range (_range))) ((sem_Name (_name))))
sem_Export ((Export_Variable (_range) (_name))) =
    (sem_Export_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Export_Module :: (T_Range) ->
                     (T_ModuleName) ->
                     (T_Export)
sem_Export_Module (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Export)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (ModuleName)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            -- self rule
            (_self@_) =
                Export_Module _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Export_TypeOrClass :: (T_Range) ->
                          (T_Name) ->
                          (T_MaybeNames) ->
                          (T_Export)
sem_Export_TypeOrClass (range_) (name_) (names_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Export)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _namesIconstructors_collect :: (FMap Name Names)
            _namesIdependencies_collect :: (FMap Name [(Name,Name)])
            _namesIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _namesIlabels_collect :: (FMap Name Names)
            _namesImethods_collect :: (FMap Name Names)
            _namesIself :: (MaybeNames)
            _namesOclassname :: (Maybe Name)
            _namesOconstructors_collect :: (FMap Name Names)
            _namesOconstructors_dist :: (FMap Name Names)
            _namesOcurrentModule :: (Strings)
            _namesOdependencies_collect :: (FMap Name [(Name,Name)])
            _namesOimportedModule :: (Bool)
            _namesOinferredDependencies :: (FMap Name [(Name,Name)])
            _namesOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _namesOinstancename :: (Maybe Name)
            _namesOlabels_collect :: (FMap Name Names)
            _namesOlabels_dist :: (FMap Name Names)
            _namesOlocal :: (Bool)
            _namesOmethods_collect :: (FMap Name Names)
            _namesOmethods_dist :: (FMap Name Names)
            _namesOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _namesIconstructors_collect,_namesIdependencies_collect,_namesIinferredDependencies_collect,_namesIlabels_collect,_namesImethods_collect,_namesIself) =
                (names_ (_namesOclassname) (_namesOconstructors_collect) (_namesOconstructors_dist) (_namesOcurrentModule) (_namesOdependencies_collect) (_namesOimportedModule) (_namesOinferredDependencies) (_namesOinferredDependencies_collect) (_namesOinstancename) (_namesOlabels_collect) (_namesOlabels_dist) (_namesOlocal) (_namesOmethods_collect) (_namesOmethods_dist) (_namesOtoplevel))
            -- self rule
            (_self@_) =
                Export_TypeOrClass _rangeIself _nameIself _namesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _namesIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _namesIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _namesIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _namesIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _namesImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_namesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_namesOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_namesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_namesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_namesOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_namesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_namesOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_namesOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_namesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_namesOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_namesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_namesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_namesOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_namesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_namesOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Export_TypeOrClassComplete :: (T_Range) ->
                                  (T_Name) ->
                                  (T_Export)
sem_Export_TypeOrClassComplete (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Export)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            -- self rule
            (_self@_) =
                Export_TypeOrClassComplete _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Export_Variable :: (T_Range) ->
                       (T_Name) ->
                       (T_Export)
sem_Export_Variable (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Export)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            -- self rule
            (_self@_) =
                Export_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- Exports -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Exports.Cons:
      self

-}
{-
   local variables for Exports.Nil:
      self

-}
-- semantic domain
type T_Exports = (Maybe Name) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Strings) ->
                 (FMap Name [(Name,Name)]) ->
                 (Bool) ->
                 (FMap Name [(Name,Name)]) ->
                 (FMap Name [(Name,Name)]) ->
                 (Maybe Name) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Bool) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Bool) ->
                 ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(Exports))
-- cata
sem_Exports :: (Exports) ->
               (T_Exports)
sem_Exports (list) =
    (foldr (sem_Exports_Cons) (sem_Exports_Nil) ((map sem_Export list)))
sem_Exports_Cons :: (T_Export) ->
                    (T_Exports) ->
                    (T_Exports)
sem_Exports_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Exports)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdependencies_collect :: (FMap Name [(Name,Name)])
            _hdIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIself :: (Export)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies_collect :: (FMap Name [(Name,Name)])
            _hdOimportedModule :: (Bool)
            _hdOinferredDependencies :: (FMap Name [(Name,Name)])
            _hdOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdOinstancename :: (Maybe Name)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdependencies_collect :: (FMap Name [(Name,Name)])
            _tlIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIself :: (Exports)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies_collect :: (FMap Name [(Name,Name)])
            _tlOimportedModule :: (Bool)
            _tlOinferredDependencies :: (FMap Name [(Name,Name)])
            _tlOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIdependencies_collect,_hdIinferredDependencies_collect,_hdIlabels_collect,_hdImethods_collect,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOdependencies_collect) (_hdOimportedModule) (_hdOinferredDependencies) (_hdOinferredDependencies_collect) (_hdOinstancename) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIdependencies_collect,_tlIinferredDependencies_collect,_tlIlabels_collect,_tlImethods_collect,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOdependencies_collect) (_tlOimportedModule) (_tlOinferredDependencies) (_tlOinferredDependencies_collect) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOtoplevel))
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _tlIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _tlIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_hdOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_tlOdependencies_collect@_) =
                _hdIdependencies_collect
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_tlOinferredDependencies_collect@_) =
                _hdIinferredDependencies_collect
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Exports_Nil :: (T_Exports)
sem_Exports_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Exports)
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- Expression --------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      bodyDependencies     : [(Name,Name)]
      self                 : SELF

-}
{-
   local variables for Expression.As:
      self

-}
{-
   local variables for Expression.Case:
      self

-}
{-
   local variables for Expression.Comprehension:
      self

-}
{-
   local variables for Expression.Constructor:
      self

-}
{-
   local variables for Expression.Do:
      self

-}
{-
   local variables for Expression.Enum:
      self

-}
{-
   local variables for Expression.If:
      self

-}
{-
   local variables for Expression.InfixApplication:
      self

-}
{-
   local variables for Expression.Irrefutable:
      self

-}
{-
   local variables for Expression.Lambda:
      self

-}
{-
   local variables for Expression.Let:
      self

-}
{-
   local variables for Expression.List:
      self

-}
{-
   local variables for Expression.Literal:
      self

-}
{-
   local variables for Expression.Negate:
      self

-}
{-
   local variables for Expression.NormalApplication:
      self

-}
{-
   local variables for Expression.Parenthesized:
      self

-}
{-
   local variables for Expression.RecordConstruction:
      self

-}
{-
   local variables for Expression.RecordUpdate:
      self

-}
{-
   local variables for Expression.Tuple:
      self

-}
{-
   local variables for Expression.TypeApplication:
      self

-}
{-
   local variables for Expression.Typed:
      self

-}
{-
   local variables for Expression.Variable:
      self

-}
{-
   local variables for Expression.Wildcard:
      self

-}
-- semantic domain
type T_Expression = (Maybe Name) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Strings) ->
                    (FMap Name [(Name,Name)]) ->
                    (Bool) ->
                    (FMap Name [(Name,Name)]) ->
                    (FMap Name [(Name,Name)]) ->
                    (Maybe Name) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Bool) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (PreSignatures) ->
                    (PreSignatures) ->
                    (Signatures) ->
                    (Bool) ->
                    ( ([(Name,Name)]),(FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(PreSignatures),(Expression))
-- cata
sem_Expression :: (Expression) ->
                  (T_Expression)
sem_Expression ((Expression_As (_range) (_name) (_expression))) =
    (sem_Expression_As ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Expression (_expression))))
sem_Expression ((Expression_Case (_range) (_expression) (_alternatives))) =
    (sem_Expression_Case ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_Alternatives (_alternatives))))
sem_Expression ((Expression_Comprehension (_range) (_expression) (_qualifiers))) =
    (sem_Expression_Comprehension ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_Qualifiers (_qualifiers))))
sem_Expression ((Expression_Constructor (_range) (_name))) =
    (sem_Expression_Constructor ((sem_Range (_range))) ((sem_Name (_name))))
sem_Expression ((Expression_Do (_range) (_statements))) =
    (sem_Expression_Do ((sem_Range (_range))) ((sem_Statements (_statements))))
sem_Expression ((Expression_Enum (_range) (_from) (_then) (_to))) =
    (sem_Expression_Enum ((sem_Range (_range))) ((sem_Expression (_from))) ((sem_MaybeExpression (_then))) ((sem_MaybeExpression (_to))))
sem_Expression ((Expression_If (_range) (_guardExpression) (_thenExpression) (_elseExpression))) =
    (sem_Expression_If ((sem_Range (_range))) ((sem_Expression (_guardExpression))) ((sem_Expression (_thenExpression))) ((sem_Expression (_elseExpression))))
sem_Expression ((Expression_InfixApplication (_range) (_leftExpression) (_operator) (_rightExpression))) =
    (sem_Expression_InfixApplication ((sem_Range (_range))) ((sem_MaybeExpression (_leftExpression))) ((sem_Expression (_operator))) ((sem_MaybeExpression (_rightExpression))))
sem_Expression ((Expression_Irrefutable (_range) (_expression))) =
    (sem_Expression_Irrefutable ((sem_Range (_range))) ((sem_Expression (_expression))))
sem_Expression ((Expression_Lambda (_range) (_patterns) (_expression))) =
    (sem_Expression_Lambda ((sem_Range (_range))) ((sem_Patterns (_patterns))) ((sem_Expression (_expression))))
sem_Expression ((Expression_Let (_range) (_declarations) (_expression))) =
    (sem_Expression_Let ((sem_Range (_range))) ((sem_Declarations (_declarations))) ((sem_Expression (_expression))))
sem_Expression ((Expression_List (_range) (_expressions))) =
    (sem_Expression_List ((sem_Range (_range))) ((sem_Expressions (_expressions))))
sem_Expression ((Expression_Literal (_range) (_literal))) =
    (sem_Expression_Literal ((sem_Range (_range))) ((sem_Literal (_literal))))
sem_Expression ((Expression_Negate (_range) (_expression))) =
    (sem_Expression_Negate ((sem_Range (_range))) ((sem_Expression (_expression))))
sem_Expression ((Expression_NormalApplication (_range) (_function) (_arguments))) =
    (sem_Expression_NormalApplication ((sem_Range (_range))) ((sem_Expression (_function))) ((sem_Expressions (_arguments))))
sem_Expression ((Expression_Parenthesized (_range) (_expression))) =
    (sem_Expression_Parenthesized ((sem_Range (_range))) ((sem_Expression (_expression))))
sem_Expression ((Expression_RecordConstruction (_range) (_name) (_recordExpressionBindings))) =
    (sem_Expression_RecordConstruction ((sem_Range (_range))) ((sem_Name (_name))) ((sem_RecordExpressionBindings (_recordExpressionBindings))))
sem_Expression ((Expression_RecordUpdate (_range) (_expression) (_recordExpressionBindings))) =
    (sem_Expression_RecordUpdate ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_RecordExpressionBindings (_recordExpressionBindings))))
sem_Expression ((Expression_Tuple (_range) (_expressions))) =
    (sem_Expression_Tuple ((sem_Range (_range))) ((sem_Expressions (_expressions))))
sem_Expression ((Expression_TypeApplication (_range) (_name) (_type))) =
    (sem_Expression_TypeApplication ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Type (_type))))
sem_Expression ((Expression_Typed (_range) (_expression) (_type))) =
    (sem_Expression_Typed ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_Type (_type))))
sem_Expression ((Expression_Variable (_range) (_name))) =
    (sem_Expression_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Expression ((Expression_Wildcard (_range))) =
    (sem_Expression_Wildcard ((sem_Range (_range))))
sem_Expression_As :: (T_Range) ->
                     (T_Name) ->
                     (T_Expression) ->
                     (T_Expression)
sem_Expression_As (range_) (name_) (expression_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _expressionIbodyDependencies :: ([(Name,Name)])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOimportedModule :: (Bool)
            _expressionOinferredDependencies :: (FMap Name [(Name,Name)])
            _expressionOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOinstancename :: (Maybe Name)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOsignatures :: (Signatures)
            _expressionOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _expressionIbodyDependencies,_expressionIconstructors_collect,_expressionIdependencies_collect,_expressionIinferredDependencies_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionIpresignatures_collect,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies_collect)
                             (_expressionOimportedModule)
                             (_expressionOinferredDependencies)
                             (_expressionOinferredDependencies_collect)
                             (_expressionOinstancename)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOsignatures)
                             (_expressionOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _expressionIbodyDependencies
            -- self rule
            (_self@_) =
                Expression_As _rangeIself _nameIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _expressionIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _expressionIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_expressionOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_expressionOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_expressionOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_expressionOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_expressionOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Expression_Case :: (T_Range) ->
                       (T_Expression) ->
                       (T_Alternatives) ->
                       (T_Expression)
sem_Expression_Case (range_) (expression_) (alternatives_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionIbodyDependencies :: ([(Name,Name)])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOimportedModule :: (Bool)
            _expressionOinferredDependencies :: (FMap Name [(Name,Name)])
            _expressionOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOinstancename :: (Maybe Name)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOsignatures :: (Signatures)
            _expressionOtoplevel :: (Bool)
            _alternativesIbodyDependencies :: ([(Name,Name)])
            _alternativesIconstructors_collect :: (FMap Name Names)
            _alternativesIdependencies_collect :: (FMap Name [(Name,Name)])
            _alternativesIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _alternativesIlabels_collect :: (FMap Name Names)
            _alternativesImethods_collect :: (FMap Name Names)
            _alternativesIpresignatures_collect :: (PreSignatures)
            _alternativesIself :: (Alternatives)
            _alternativesOclassname :: (Maybe Name)
            _alternativesOconstructors_collect :: (FMap Name Names)
            _alternativesOconstructors_dist :: (FMap Name Names)
            _alternativesOcurrentModule :: (Strings)
            _alternativesOdependencies_collect :: (FMap Name [(Name,Name)])
            _alternativesOimportedModule :: (Bool)
            _alternativesOinferredDependencies :: (FMap Name [(Name,Name)])
            _alternativesOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _alternativesOinstancename :: (Maybe Name)
            _alternativesOlabels_collect :: (FMap Name Names)
            _alternativesOlabels_dist :: (FMap Name Names)
            _alternativesOlocal :: (Bool)
            _alternativesOmethods_collect :: (FMap Name Names)
            _alternativesOmethods_dist :: (FMap Name Names)
            _alternativesOpresignatures :: (PreSignatures)
            _alternativesOpresignatures_collect :: (PreSignatures)
            _alternativesOsignatures :: (Signatures)
            _alternativesOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionIbodyDependencies,_expressionIconstructors_collect,_expressionIdependencies_collect,_expressionIinferredDependencies_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionIpresignatures_collect,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies_collect)
                             (_expressionOimportedModule)
                             (_expressionOinferredDependencies)
                             (_expressionOinferredDependencies_collect)
                             (_expressionOinstancename)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOsignatures)
                             (_expressionOtoplevel))
            ( _alternativesIbodyDependencies,_alternativesIconstructors_collect,_alternativesIdependencies_collect,_alternativesIinferredDependencies_collect,_alternativesIlabels_collect,_alternativesImethods_collect,_alternativesIpresignatures_collect,_alternativesIself) =
                (alternatives_ (_alternativesOclassname)
                               (_alternativesOconstructors_collect)
                               (_alternativesOconstructors_dist)
                               (_alternativesOcurrentModule)
                               (_alternativesOdependencies_collect)
                               (_alternativesOimportedModule)
                               (_alternativesOinferredDependencies)
                               (_alternativesOinferredDependencies_collect)
                               (_alternativesOinstancename)
                               (_alternativesOlabels_collect)
                               (_alternativesOlabels_dist)
                               (_alternativesOlocal)
                               (_alternativesOmethods_collect)
                               (_alternativesOmethods_dist)
                               (_alternativesOpresignatures)
                               (_alternativesOpresignatures_collect)
                               (_alternativesOsignatures)
                               (_alternativesOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _expressionIbodyDependencies ++ _alternativesIbodyDependencies
            -- self rule
            (_self@_) =
                Expression_Case _rangeIself _expressionIself _alternativesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _alternativesIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _alternativesIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _alternativesIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _alternativesIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _alternativesImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _alternativesIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_expressionOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_alternativesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_alternativesOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (down)
            (_alternativesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_alternativesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_alternativesOdependencies_collect@_) =
                _expressionIdependencies_collect
            -- copy rule (down)
            (_alternativesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_alternativesOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_alternativesOinferredDependencies_collect@_) =
                _expressionIinferredDependencies_collect
            -- copy rule (down)
            (_alternativesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_alternativesOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (down)
            (_alternativesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_alternativesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_alternativesOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (down)
            (_alternativesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_alternativesOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_alternativesOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (down)
            (_alternativesOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_alternativesOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Expression_Comprehension :: (T_Range) ->
                                (T_Expression) ->
                                (T_Qualifiers) ->
                                (T_Expression)
sem_Expression_Comprehension (range_) (expression_) (qualifiers_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionIbodyDependencies :: ([(Name,Name)])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOimportedModule :: (Bool)
            _expressionOinferredDependencies :: (FMap Name [(Name,Name)])
            _expressionOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOinstancename :: (Maybe Name)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOsignatures :: (Signatures)
            _expressionOtoplevel :: (Bool)
            _qualifiersIbodyDependencies :: ([(Name,Name)])
            _qualifiersIconstructors_collect :: (FMap Name Names)
            _qualifiersIdependencies_collect :: (FMap Name [(Name,Name)])
            _qualifiersIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _qualifiersIlabels_collect :: (FMap Name Names)
            _qualifiersImethods_collect :: (FMap Name Names)
            _qualifiersIpresignatures_collect :: (PreSignatures)
            _qualifiersIself :: (Qualifiers)
            _qualifiersOclassname :: (Maybe Name)
            _qualifiersOconstructors_collect :: (FMap Name Names)
            _qualifiersOconstructors_dist :: (FMap Name Names)
            _qualifiersOcurrentModule :: (Strings)
            _qualifiersOdependencies_collect :: (FMap Name [(Name,Name)])
            _qualifiersOimportedModule :: (Bool)
            _qualifiersOinferredDependencies :: (FMap Name [(Name,Name)])
            _qualifiersOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _qualifiersOinstancename :: (Maybe Name)
            _qualifiersOlabels_collect :: (FMap Name Names)
            _qualifiersOlabels_dist :: (FMap Name Names)
            _qualifiersOlocal :: (Bool)
            _qualifiersOmethods_collect :: (FMap Name Names)
            _qualifiersOmethods_dist :: (FMap Name Names)
            _qualifiersOpresignatures :: (PreSignatures)
            _qualifiersOpresignatures_collect :: (PreSignatures)
            _qualifiersOsignatures :: (Signatures)
            _qualifiersOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionIbodyDependencies,_expressionIconstructors_collect,_expressionIdependencies_collect,_expressionIinferredDependencies_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionIpresignatures_collect,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies_collect)
                             (_expressionOimportedModule)
                             (_expressionOinferredDependencies)
                             (_expressionOinferredDependencies_collect)
                             (_expressionOinstancename)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOsignatures)
                             (_expressionOtoplevel))
            ( _qualifiersIbodyDependencies,_qualifiersIconstructors_collect,_qualifiersIdependencies_collect,_qualifiersIinferredDependencies_collect,_qualifiersIlabels_collect,_qualifiersImethods_collect,_qualifiersIpresignatures_collect,_qualifiersIself) =
                (qualifiers_ (_qualifiersOclassname)
                             (_qualifiersOconstructors_collect)
                             (_qualifiersOconstructors_dist)
                             (_qualifiersOcurrentModule)
                             (_qualifiersOdependencies_collect)
                             (_qualifiersOimportedModule)
                             (_qualifiersOinferredDependencies)
                             (_qualifiersOinferredDependencies_collect)
                             (_qualifiersOinstancename)
                             (_qualifiersOlabels_collect)
                             (_qualifiersOlabels_dist)
                             (_qualifiersOlocal)
                             (_qualifiersOmethods_collect)
                             (_qualifiersOmethods_dist)
                             (_qualifiersOpresignatures)
                             (_qualifiersOpresignatures_collect)
                             (_qualifiersOsignatures)
                             (_qualifiersOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _expressionIbodyDependencies ++ _qualifiersIbodyDependencies
            -- self rule
            (_self@_) =
                Expression_Comprehension _rangeIself _expressionIself _qualifiersIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _qualifiersIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _qualifiersIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _qualifiersIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _qualifiersIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _qualifiersImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _qualifiersIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_expressionOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_qualifiersOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_qualifiersOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (down)
            (_qualifiersOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_qualifiersOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_qualifiersOdependencies_collect@_) =
                _expressionIdependencies_collect
            -- copy rule (down)
            (_qualifiersOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_qualifiersOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_qualifiersOinferredDependencies_collect@_) =
                _expressionIinferredDependencies_collect
            -- copy rule (down)
            (_qualifiersOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_qualifiersOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (down)
            (_qualifiersOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_qualifiersOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_qualifiersOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (down)
            (_qualifiersOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_qualifiersOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_qualifiersOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (down)
            (_qualifiersOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_qualifiersOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Expression_Constructor :: (T_Range) ->
                              (T_Name) ->
                              (T_Expression)
sem_Expression_Constructor (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                []
            -- self rule
            (_self@_) =
                Expression_Constructor _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Expression_Do :: (T_Range) ->
                     (T_Statements) ->
                     (T_Expression)
sem_Expression_Do (range_) (statements_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _statementsIbodyDependencies :: ([(Name,Name)])
            _statementsIconstructors_collect :: (FMap Name Names)
            _statementsIdependencies_collect :: (FMap Name [(Name,Name)])
            _statementsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _statementsIlabels_collect :: (FMap Name Names)
            _statementsImethods_collect :: (FMap Name Names)
            _statementsIpresignatures_collect :: (PreSignatures)
            _statementsIself :: (Statements)
            _statementsOclassname :: (Maybe Name)
            _statementsOconstructors_collect :: (FMap Name Names)
            _statementsOconstructors_dist :: (FMap Name Names)
            _statementsOcurrentModule :: (Strings)
            _statementsOdependencies_collect :: (FMap Name [(Name,Name)])
            _statementsOimportedModule :: (Bool)
            _statementsOinferredDependencies :: (FMap Name [(Name,Name)])
            _statementsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _statementsOinstancename :: (Maybe Name)
            _statementsOlabels_collect :: (FMap Name Names)
            _statementsOlabels_dist :: (FMap Name Names)
            _statementsOlocal :: (Bool)
            _statementsOmethods_collect :: (FMap Name Names)
            _statementsOmethods_dist :: (FMap Name Names)
            _statementsOpresignatures :: (PreSignatures)
            _statementsOpresignatures_collect :: (PreSignatures)
            _statementsOsignatures :: (Signatures)
            _statementsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _statementsIbodyDependencies,_statementsIconstructors_collect,_statementsIdependencies_collect,_statementsIinferredDependencies_collect,_statementsIlabels_collect,_statementsImethods_collect,_statementsIpresignatures_collect,_statementsIself) =
                (statements_ (_statementsOclassname)
                             (_statementsOconstructors_collect)
                             (_statementsOconstructors_dist)
                             (_statementsOcurrentModule)
                             (_statementsOdependencies_collect)
                             (_statementsOimportedModule)
                             (_statementsOinferredDependencies)
                             (_statementsOinferredDependencies_collect)
                             (_statementsOinstancename)
                             (_statementsOlabels_collect)
                             (_statementsOlabels_dist)
                             (_statementsOlocal)
                             (_statementsOmethods_collect)
                             (_statementsOmethods_dist)
                             (_statementsOpresignatures)
                             (_statementsOpresignatures_collect)
                             (_statementsOsignatures)
                             (_statementsOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _statementsIbodyDependencies
            -- self rule
            (_self@_) =
                Expression_Do _rangeIself _statementsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _statementsIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _statementsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _statementsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _statementsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _statementsImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _statementsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_statementsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_statementsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_statementsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_statementsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_statementsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_statementsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_statementsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_statementsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_statementsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_statementsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_statementsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_statementsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_statementsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_statementsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_statementsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_statementsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_statementsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_statementsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Expression_Enum :: (T_Range) ->
                       (T_Expression) ->
                       (T_MaybeExpression) ->
                       (T_MaybeExpression) ->
                       (T_Expression)
sem_Expression_Enum (range_) (from_) (then_) (to_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _fromIbodyDependencies :: ([(Name,Name)])
            _fromIconstructors_collect :: (FMap Name Names)
            _fromIdependencies_collect :: (FMap Name [(Name,Name)])
            _fromIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _fromIlabels_collect :: (FMap Name Names)
            _fromImethods_collect :: (FMap Name Names)
            _fromIpresignatures_collect :: (PreSignatures)
            _fromIself :: (Expression)
            _fromOclassname :: (Maybe Name)
            _fromOconstructors_collect :: (FMap Name Names)
            _fromOconstructors_dist :: (FMap Name Names)
            _fromOcurrentModule :: (Strings)
            _fromOdependencies_collect :: (FMap Name [(Name,Name)])
            _fromOimportedModule :: (Bool)
            _fromOinferredDependencies :: (FMap Name [(Name,Name)])
            _fromOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _fromOinstancename :: (Maybe Name)
            _fromOlabels_collect :: (FMap Name Names)
            _fromOlabels_dist :: (FMap Name Names)
            _fromOlocal :: (Bool)
            _fromOmethods_collect :: (FMap Name Names)
            _fromOmethods_dist :: (FMap Name Names)
            _fromOpresignatures :: (PreSignatures)
            _fromOpresignatures_collect :: (PreSignatures)
            _fromOsignatures :: (Signatures)
            _fromOtoplevel :: (Bool)
            _thenIbodyDependencies :: ([(Name,Name)])
            _thenIconstructors_collect :: (FMap Name Names)
            _thenIdependencies_collect :: (FMap Name [(Name,Name)])
            _thenIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _thenIlabels_collect :: (FMap Name Names)
            _thenImethods_collect :: (FMap Name Names)
            _thenIpresignatures_collect :: (PreSignatures)
            _thenIself :: (MaybeExpression)
            _thenOclassname :: (Maybe Name)
            _thenOconstructors_collect :: (FMap Name Names)
            _thenOconstructors_dist :: (FMap Name Names)
            _thenOcurrentModule :: (Strings)
            _thenOdependencies_collect :: (FMap Name [(Name,Name)])
            _thenOimportedModule :: (Bool)
            _thenOinferredDependencies :: (FMap Name [(Name,Name)])
            _thenOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _thenOinstancename :: (Maybe Name)
            _thenOlabels_collect :: (FMap Name Names)
            _thenOlabels_dist :: (FMap Name Names)
            _thenOlocal :: (Bool)
            _thenOmethods_collect :: (FMap Name Names)
            _thenOmethods_dist :: (FMap Name Names)
            _thenOpresignatures :: (PreSignatures)
            _thenOpresignatures_collect :: (PreSignatures)
            _thenOsignatures :: (Signatures)
            _thenOtoplevel :: (Bool)
            _toIbodyDependencies :: ([(Name,Name)])
            _toIconstructors_collect :: (FMap Name Names)
            _toIdependencies_collect :: (FMap Name [(Name,Name)])
            _toIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _toIlabels_collect :: (FMap Name Names)
            _toImethods_collect :: (FMap Name Names)
            _toIpresignatures_collect :: (PreSignatures)
            _toIself :: (MaybeExpression)
            _toOclassname :: (Maybe Name)
            _toOconstructors_collect :: (FMap Name Names)
            _toOconstructors_dist :: (FMap Name Names)
            _toOcurrentModule :: (Strings)
            _toOdependencies_collect :: (FMap Name [(Name,Name)])
            _toOimportedModule :: (Bool)
            _toOinferredDependencies :: (FMap Name [(Name,Name)])
            _toOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _toOinstancename :: (Maybe Name)
            _toOlabels_collect :: (FMap Name Names)
            _toOlabels_dist :: (FMap Name Names)
            _toOlocal :: (Bool)
            _toOmethods_collect :: (FMap Name Names)
            _toOmethods_dist :: (FMap Name Names)
            _toOpresignatures :: (PreSignatures)
            _toOpresignatures_collect :: (PreSignatures)
            _toOsignatures :: (Signatures)
            _toOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _fromIbodyDependencies,_fromIconstructors_collect,_fromIdependencies_collect,_fromIinferredDependencies_collect,_fromIlabels_collect,_fromImethods_collect,_fromIpresignatures_collect,_fromIself) =
                (from_ (_fromOclassname) (_fromOconstructors_collect) (_fromOconstructors_dist) (_fromOcurrentModule) (_fromOdependencies_collect) (_fromOimportedModule) (_fromOinferredDependencies) (_fromOinferredDependencies_collect) (_fromOinstancename) (_fromOlabels_collect) (_fromOlabels_dist) (_fromOlocal) (_fromOmethods_collect) (_fromOmethods_dist) (_fromOpresignatures) (_fromOpresignatures_collect) (_fromOsignatures) (_fromOtoplevel))
            ( _thenIbodyDependencies,_thenIconstructors_collect,_thenIdependencies_collect,_thenIinferredDependencies_collect,_thenIlabels_collect,_thenImethods_collect,_thenIpresignatures_collect,_thenIself) =
                (then_ (_thenOclassname) (_thenOconstructors_collect) (_thenOconstructors_dist) (_thenOcurrentModule) (_thenOdependencies_collect) (_thenOimportedModule) (_thenOinferredDependencies) (_thenOinferredDependencies_collect) (_thenOinstancename) (_thenOlabels_collect) (_thenOlabels_dist) (_thenOlocal) (_thenOmethods_collect) (_thenOmethods_dist) (_thenOpresignatures) (_thenOpresignatures_collect) (_thenOsignatures) (_thenOtoplevel))
            ( _toIbodyDependencies,_toIconstructors_collect,_toIdependencies_collect,_toIinferredDependencies_collect,_toIlabels_collect,_toImethods_collect,_toIpresignatures_collect,_toIself) =
                (to_ (_toOclassname) (_toOconstructors_collect) (_toOconstructors_dist) (_toOcurrentModule) (_toOdependencies_collect) (_toOimportedModule) (_toOinferredDependencies) (_toOinferredDependencies_collect) (_toOinstancename) (_toOlabels_collect) (_toOlabels_dist) (_toOlocal) (_toOmethods_collect) (_toOmethods_dist) (_toOpresignatures) (_toOpresignatures_collect) (_toOsignatures) (_toOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _fromIbodyDependencies ++ _thenIbodyDependencies ++ _toIbodyDependencies
            -- self rule
            (_self@_) =
                Expression_Enum _rangeIself _fromIself _thenIself _toIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _toIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _toIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _toIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _toIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _toImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _toIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_fromOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_fromOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_fromOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_fromOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_fromOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_fromOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_fromOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_fromOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_fromOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_fromOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_fromOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_fromOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_fromOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_fromOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_fromOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_fromOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_fromOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_fromOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_thenOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_thenOconstructors_collect@_) =
                _fromIconstructors_collect
            -- copy rule (down)
            (_thenOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_thenOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_thenOdependencies_collect@_) =
                _fromIdependencies_collect
            -- copy rule (down)
            (_thenOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_thenOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_thenOinferredDependencies_collect@_) =
                _fromIinferredDependencies_collect
            -- copy rule (down)
            (_thenOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_thenOlabels_collect@_) =
                _fromIlabels_collect
            -- copy rule (down)
            (_thenOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_thenOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_thenOmethods_collect@_) =
                _fromImethods_collect
            -- copy rule (down)
            (_thenOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_thenOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_thenOpresignatures_collect@_) =
                _fromIpresignatures_collect
            -- copy rule (down)
            (_thenOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_thenOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_toOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_toOconstructors_collect@_) =
                _thenIconstructors_collect
            -- copy rule (down)
            (_toOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_toOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_toOdependencies_collect@_) =
                _thenIdependencies_collect
            -- copy rule (down)
            (_toOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_toOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_toOinferredDependencies_collect@_) =
                _thenIinferredDependencies_collect
            -- copy rule (down)
            (_toOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_toOlabels_collect@_) =
                _thenIlabels_collect
            -- copy rule (down)
            (_toOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_toOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_toOmethods_collect@_) =
                _thenImethods_collect
            -- copy rule (down)
            (_toOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_toOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_toOpresignatures_collect@_) =
                _thenIpresignatures_collect
            -- copy rule (down)
            (_toOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_toOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Expression_If :: (T_Range) ->
                     (T_Expression) ->
                     (T_Expression) ->
                     (T_Expression) ->
                     (T_Expression)
sem_Expression_If (range_) (guardExpression_) (thenExpression_) (elseExpression_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _guardExpressionIbodyDependencies :: ([(Name,Name)])
            _guardExpressionIconstructors_collect :: (FMap Name Names)
            _guardExpressionIdependencies_collect :: (FMap Name [(Name,Name)])
            _guardExpressionIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _guardExpressionIlabels_collect :: (FMap Name Names)
            _guardExpressionImethods_collect :: (FMap Name Names)
            _guardExpressionIpresignatures_collect :: (PreSignatures)
            _guardExpressionIself :: (Expression)
            _guardExpressionOclassname :: (Maybe Name)
            _guardExpressionOconstructors_collect :: (FMap Name Names)
            _guardExpressionOconstructors_dist :: (FMap Name Names)
            _guardExpressionOcurrentModule :: (Strings)
            _guardExpressionOdependencies_collect :: (FMap Name [(Name,Name)])
            _guardExpressionOimportedModule :: (Bool)
            _guardExpressionOinferredDependencies :: (FMap Name [(Name,Name)])
            _guardExpressionOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _guardExpressionOinstancename :: (Maybe Name)
            _guardExpressionOlabels_collect :: (FMap Name Names)
            _guardExpressionOlabels_dist :: (FMap Name Names)
            _guardExpressionOlocal :: (Bool)
            _guardExpressionOmethods_collect :: (FMap Name Names)
            _guardExpressionOmethods_dist :: (FMap Name Names)
            _guardExpressionOpresignatures :: (PreSignatures)
            _guardExpressionOpresignatures_collect :: (PreSignatures)
            _guardExpressionOsignatures :: (Signatures)
            _guardExpressionOtoplevel :: (Bool)
            _thenExpressionIbodyDependencies :: ([(Name,Name)])
            _thenExpressionIconstructors_collect :: (FMap Name Names)
            _thenExpressionIdependencies_collect :: (FMap Name [(Name,Name)])
            _thenExpressionIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _thenExpressionIlabels_collect :: (FMap Name Names)
            _thenExpressionImethods_collect :: (FMap Name Names)
            _thenExpressionIpresignatures_collect :: (PreSignatures)
            _thenExpressionIself :: (Expression)
            _thenExpressionOclassname :: (Maybe Name)
            _thenExpressionOconstructors_collect :: (FMap Name Names)
            _thenExpressionOconstructors_dist :: (FMap Name Names)
            _thenExpressionOcurrentModule :: (Strings)
            _thenExpressionOdependencies_collect :: (FMap Name [(Name,Name)])
            _thenExpressionOimportedModule :: (Bool)
            _thenExpressionOinferredDependencies :: (FMap Name [(Name,Name)])
            _thenExpressionOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _thenExpressionOinstancename :: (Maybe Name)
            _thenExpressionOlabels_collect :: (FMap Name Names)
            _thenExpressionOlabels_dist :: (FMap Name Names)
            _thenExpressionOlocal :: (Bool)
            _thenExpressionOmethods_collect :: (FMap Name Names)
            _thenExpressionOmethods_dist :: (FMap Name Names)
            _thenExpressionOpresignatures :: (PreSignatures)
            _thenExpressionOpresignatures_collect :: (PreSignatures)
            _thenExpressionOsignatures :: (Signatures)
            _thenExpressionOtoplevel :: (Bool)
            _elseExpressionIbodyDependencies :: ([(Name,Name)])
            _elseExpressionIconstructors_collect :: (FMap Name Names)
            _elseExpressionIdependencies_collect :: (FMap Name [(Name,Name)])
            _elseExpressionIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _elseExpressionIlabels_collect :: (FMap Name Names)
            _elseExpressionImethods_collect :: (FMap Name Names)
            _elseExpressionIpresignatures_collect :: (PreSignatures)
            _elseExpressionIself :: (Expression)
            _elseExpressionOclassname :: (Maybe Name)
            _elseExpressionOconstructors_collect :: (FMap Name Names)
            _elseExpressionOconstructors_dist :: (FMap Name Names)
            _elseExpressionOcurrentModule :: (Strings)
            _elseExpressionOdependencies_collect :: (FMap Name [(Name,Name)])
            _elseExpressionOimportedModule :: (Bool)
            _elseExpressionOinferredDependencies :: (FMap Name [(Name,Name)])
            _elseExpressionOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _elseExpressionOinstancename :: (Maybe Name)
            _elseExpressionOlabels_collect :: (FMap Name Names)
            _elseExpressionOlabels_dist :: (FMap Name Names)
            _elseExpressionOlocal :: (Bool)
            _elseExpressionOmethods_collect :: (FMap Name Names)
            _elseExpressionOmethods_dist :: (FMap Name Names)
            _elseExpressionOpresignatures :: (PreSignatures)
            _elseExpressionOpresignatures_collect :: (PreSignatures)
            _elseExpressionOsignatures :: (Signatures)
            _elseExpressionOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _guardExpressionIbodyDependencies,_guardExpressionIconstructors_collect,_guardExpressionIdependencies_collect,_guardExpressionIinferredDependencies_collect,_guardExpressionIlabels_collect,_guardExpressionImethods_collect,_guardExpressionIpresignatures_collect,_guardExpressionIself) =
                (guardExpression_ (_guardExpressionOclassname)
                                  (_guardExpressionOconstructors_collect)
                                  (_guardExpressionOconstructors_dist)
                                  (_guardExpressionOcurrentModule)
                                  (_guardExpressionOdependencies_collect)
                                  (_guardExpressionOimportedModule)
                                  (_guardExpressionOinferredDependencies)
                                  (_guardExpressionOinferredDependencies_collect)
                                  (_guardExpressionOinstancename)
                                  (_guardExpressionOlabels_collect)
                                  (_guardExpressionOlabels_dist)
                                  (_guardExpressionOlocal)
                                  (_guardExpressionOmethods_collect)
                                  (_guardExpressionOmethods_dist)
                                  (_guardExpressionOpresignatures)
                                  (_guardExpressionOpresignatures_collect)
                                  (_guardExpressionOsignatures)
                                  (_guardExpressionOtoplevel))
            ( _thenExpressionIbodyDependencies,_thenExpressionIconstructors_collect,_thenExpressionIdependencies_collect,_thenExpressionIinferredDependencies_collect,_thenExpressionIlabels_collect,_thenExpressionImethods_collect,_thenExpressionIpresignatures_collect,_thenExpressionIself) =
                (thenExpression_ (_thenExpressionOclassname)
                                 (_thenExpressionOconstructors_collect)
                                 (_thenExpressionOconstructors_dist)
                                 (_thenExpressionOcurrentModule)
                                 (_thenExpressionOdependencies_collect)
                                 (_thenExpressionOimportedModule)
                                 (_thenExpressionOinferredDependencies)
                                 (_thenExpressionOinferredDependencies_collect)
                                 (_thenExpressionOinstancename)
                                 (_thenExpressionOlabels_collect)
                                 (_thenExpressionOlabels_dist)
                                 (_thenExpressionOlocal)
                                 (_thenExpressionOmethods_collect)
                                 (_thenExpressionOmethods_dist)
                                 (_thenExpressionOpresignatures)
                                 (_thenExpressionOpresignatures_collect)
                                 (_thenExpressionOsignatures)
                                 (_thenExpressionOtoplevel))
            ( _elseExpressionIbodyDependencies,_elseExpressionIconstructors_collect,_elseExpressionIdependencies_collect,_elseExpressionIinferredDependencies_collect,_elseExpressionIlabels_collect,_elseExpressionImethods_collect,_elseExpressionIpresignatures_collect,_elseExpressionIself) =
                (elseExpression_ (_elseExpressionOclassname)
                                 (_elseExpressionOconstructors_collect)
                                 (_elseExpressionOconstructors_dist)
                                 (_elseExpressionOcurrentModule)
                                 (_elseExpressionOdependencies_collect)
                                 (_elseExpressionOimportedModule)
                                 (_elseExpressionOinferredDependencies)
                                 (_elseExpressionOinferredDependencies_collect)
                                 (_elseExpressionOinstancename)
                                 (_elseExpressionOlabels_collect)
                                 (_elseExpressionOlabels_dist)
                                 (_elseExpressionOlocal)
                                 (_elseExpressionOmethods_collect)
                                 (_elseExpressionOmethods_dist)
                                 (_elseExpressionOpresignatures)
                                 (_elseExpressionOpresignatures_collect)
                                 (_elseExpressionOsignatures)
                                 (_elseExpressionOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _guardExpressionIbodyDependencies ++ _thenExpressionIbodyDependencies ++ _elseExpressionIbodyDependencies
            -- self rule
            (_self@_) =
                Expression_If _rangeIself _guardExpressionIself _thenExpressionIself _elseExpressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _elseExpressionIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _elseExpressionIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _elseExpressionIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _elseExpressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _elseExpressionImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _elseExpressionIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_guardExpressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_guardExpressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_guardExpressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_guardExpressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_guardExpressionOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_guardExpressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_guardExpressionOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_guardExpressionOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_guardExpressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_guardExpressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_guardExpressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_guardExpressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_guardExpressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_guardExpressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_guardExpressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_guardExpressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_guardExpressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_guardExpressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_thenExpressionOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_thenExpressionOconstructors_collect@_) =
                _guardExpressionIconstructors_collect
            -- copy rule (down)
            (_thenExpressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_thenExpressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_thenExpressionOdependencies_collect@_) =
                _guardExpressionIdependencies_collect
            -- copy rule (down)
            (_thenExpressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_thenExpressionOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_thenExpressionOinferredDependencies_collect@_) =
                _guardExpressionIinferredDependencies_collect
            -- copy rule (down)
            (_thenExpressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_thenExpressionOlabels_collect@_) =
                _guardExpressionIlabels_collect
            -- copy rule (down)
            (_thenExpressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_thenExpressionOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_thenExpressionOmethods_collect@_) =
                _guardExpressionImethods_collect
            -- copy rule (down)
            (_thenExpressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_thenExpressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_thenExpressionOpresignatures_collect@_) =
                _guardExpressionIpresignatures_collect
            -- copy rule (down)
            (_thenExpressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_thenExpressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_elseExpressionOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_elseExpressionOconstructors_collect@_) =
                _thenExpressionIconstructors_collect
            -- copy rule (down)
            (_elseExpressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_elseExpressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_elseExpressionOdependencies_collect@_) =
                _thenExpressionIdependencies_collect
            -- copy rule (down)
            (_elseExpressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_elseExpressionOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_elseExpressionOinferredDependencies_collect@_) =
                _thenExpressionIinferredDependencies_collect
            -- copy rule (down)
            (_elseExpressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_elseExpressionOlabels_collect@_) =
                _thenExpressionIlabels_collect
            -- copy rule (down)
            (_elseExpressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_elseExpressionOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_elseExpressionOmethods_collect@_) =
                _thenExpressionImethods_collect
            -- copy rule (down)
            (_elseExpressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_elseExpressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_elseExpressionOpresignatures_collect@_) =
                _thenExpressionIpresignatures_collect
            -- copy rule (down)
            (_elseExpressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_elseExpressionOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Expression_InfixApplication :: (T_Range) ->
                                   (T_MaybeExpression) ->
                                   (T_Expression) ->
                                   (T_MaybeExpression) ->
                                   (T_Expression)
sem_Expression_InfixApplication (range_) (leftExpression_) (operator_) (rightExpression_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _leftExpressionIbodyDependencies :: ([(Name,Name)])
            _leftExpressionIconstructors_collect :: (FMap Name Names)
            _leftExpressionIdependencies_collect :: (FMap Name [(Name,Name)])
            _leftExpressionIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _leftExpressionIlabels_collect :: (FMap Name Names)
            _leftExpressionImethods_collect :: (FMap Name Names)
            _leftExpressionIpresignatures_collect :: (PreSignatures)
            _leftExpressionIself :: (MaybeExpression)
            _leftExpressionOclassname :: (Maybe Name)
            _leftExpressionOconstructors_collect :: (FMap Name Names)
            _leftExpressionOconstructors_dist :: (FMap Name Names)
            _leftExpressionOcurrentModule :: (Strings)
            _leftExpressionOdependencies_collect :: (FMap Name [(Name,Name)])
            _leftExpressionOimportedModule :: (Bool)
            _leftExpressionOinferredDependencies :: (FMap Name [(Name,Name)])
            _leftExpressionOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _leftExpressionOinstancename :: (Maybe Name)
            _leftExpressionOlabels_collect :: (FMap Name Names)
            _leftExpressionOlabels_dist :: (FMap Name Names)
            _leftExpressionOlocal :: (Bool)
            _leftExpressionOmethods_collect :: (FMap Name Names)
            _leftExpressionOmethods_dist :: (FMap Name Names)
            _leftExpressionOpresignatures :: (PreSignatures)
            _leftExpressionOpresignatures_collect :: (PreSignatures)
            _leftExpressionOsignatures :: (Signatures)
            _leftExpressionOtoplevel :: (Bool)
            _operatorIbodyDependencies :: ([(Name,Name)])
            _operatorIconstructors_collect :: (FMap Name Names)
            _operatorIdependencies_collect :: (FMap Name [(Name,Name)])
            _operatorIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _operatorIlabels_collect :: (FMap Name Names)
            _operatorImethods_collect :: (FMap Name Names)
            _operatorIpresignatures_collect :: (PreSignatures)
            _operatorIself :: (Expression)
            _operatorOclassname :: (Maybe Name)
            _operatorOconstructors_collect :: (FMap Name Names)
            _operatorOconstructors_dist :: (FMap Name Names)
            _operatorOcurrentModule :: (Strings)
            _operatorOdependencies_collect :: (FMap Name [(Name,Name)])
            _operatorOimportedModule :: (Bool)
            _operatorOinferredDependencies :: (FMap Name [(Name,Name)])
            _operatorOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _operatorOinstancename :: (Maybe Name)
            _operatorOlabels_collect :: (FMap Name Names)
            _operatorOlabels_dist :: (FMap Name Names)
            _operatorOlocal :: (Bool)
            _operatorOmethods_collect :: (FMap Name Names)
            _operatorOmethods_dist :: (FMap Name Names)
            _operatorOpresignatures :: (PreSignatures)
            _operatorOpresignatures_collect :: (PreSignatures)
            _operatorOsignatures :: (Signatures)
            _operatorOtoplevel :: (Bool)
            _rightExpressionIbodyDependencies :: ([(Name,Name)])
            _rightExpressionIconstructors_collect :: (FMap Name Names)
            _rightExpressionIdependencies_collect :: (FMap Name [(Name,Name)])
            _rightExpressionIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _rightExpressionIlabels_collect :: (FMap Name Names)
            _rightExpressionImethods_collect :: (FMap Name Names)
            _rightExpressionIpresignatures_collect :: (PreSignatures)
            _rightExpressionIself :: (MaybeExpression)
            _rightExpressionOclassname :: (Maybe Name)
            _rightExpressionOconstructors_collect :: (FMap Name Names)
            _rightExpressionOconstructors_dist :: (FMap Name Names)
            _rightExpressionOcurrentModule :: (Strings)
            _rightExpressionOdependencies_collect :: (FMap Name [(Name,Name)])
            _rightExpressionOimportedModule :: (Bool)
            _rightExpressionOinferredDependencies :: (FMap Name [(Name,Name)])
            _rightExpressionOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _rightExpressionOinstancename :: (Maybe Name)
            _rightExpressionOlabels_collect :: (FMap Name Names)
            _rightExpressionOlabels_dist :: (FMap Name Names)
            _rightExpressionOlocal :: (Bool)
            _rightExpressionOmethods_collect :: (FMap Name Names)
            _rightExpressionOmethods_dist :: (FMap Name Names)
            _rightExpressionOpresignatures :: (PreSignatures)
            _rightExpressionOpresignatures_collect :: (PreSignatures)
            _rightExpressionOsignatures :: (Signatures)
            _rightExpressionOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _leftExpressionIbodyDependencies,_leftExpressionIconstructors_collect,_leftExpressionIdependencies_collect,_leftExpressionIinferredDependencies_collect,_leftExpressionIlabels_collect,_leftExpressionImethods_collect,_leftExpressionIpresignatures_collect,_leftExpressionIself) =
                (leftExpression_ (_leftExpressionOclassname)
                                 (_leftExpressionOconstructors_collect)
                                 (_leftExpressionOconstructors_dist)
                                 (_leftExpressionOcurrentModule)
                                 (_leftExpressionOdependencies_collect)
                                 (_leftExpressionOimportedModule)
                                 (_leftExpressionOinferredDependencies)
                                 (_leftExpressionOinferredDependencies_collect)
                                 (_leftExpressionOinstancename)
                                 (_leftExpressionOlabels_collect)
                                 (_leftExpressionOlabels_dist)
                                 (_leftExpressionOlocal)
                                 (_leftExpressionOmethods_collect)
                                 (_leftExpressionOmethods_dist)
                                 (_leftExpressionOpresignatures)
                                 (_leftExpressionOpresignatures_collect)
                                 (_leftExpressionOsignatures)
                                 (_leftExpressionOtoplevel))
            ( _operatorIbodyDependencies,_operatorIconstructors_collect,_operatorIdependencies_collect,_operatorIinferredDependencies_collect,_operatorIlabels_collect,_operatorImethods_collect,_operatorIpresignatures_collect,_operatorIself) =
                (operator_ (_operatorOclassname)
                           (_operatorOconstructors_collect)
                           (_operatorOconstructors_dist)
                           (_operatorOcurrentModule)
                           (_operatorOdependencies_collect)
                           (_operatorOimportedModule)
                           (_operatorOinferredDependencies)
                           (_operatorOinferredDependencies_collect)
                           (_operatorOinstancename)
                           (_operatorOlabels_collect)
                           (_operatorOlabels_dist)
                           (_operatorOlocal)
                           (_operatorOmethods_collect)
                           (_operatorOmethods_dist)
                           (_operatorOpresignatures)
                           (_operatorOpresignatures_collect)
                           (_operatorOsignatures)
                           (_operatorOtoplevel))
            ( _rightExpressionIbodyDependencies,_rightExpressionIconstructors_collect,_rightExpressionIdependencies_collect,_rightExpressionIinferredDependencies_collect,_rightExpressionIlabels_collect,_rightExpressionImethods_collect,_rightExpressionIpresignatures_collect,_rightExpressionIself) =
                (rightExpression_ (_rightExpressionOclassname)
                                  (_rightExpressionOconstructors_collect)
                                  (_rightExpressionOconstructors_dist)
                                  (_rightExpressionOcurrentModule)
                                  (_rightExpressionOdependencies_collect)
                                  (_rightExpressionOimportedModule)
                                  (_rightExpressionOinferredDependencies)
                                  (_rightExpressionOinferredDependencies_collect)
                                  (_rightExpressionOinstancename)
                                  (_rightExpressionOlabels_collect)
                                  (_rightExpressionOlabels_dist)
                                  (_rightExpressionOlocal)
                                  (_rightExpressionOmethods_collect)
                                  (_rightExpressionOmethods_dist)
                                  (_rightExpressionOpresignatures)
                                  (_rightExpressionOpresignatures_collect)
                                  (_rightExpressionOsignatures)
                                  (_rightExpressionOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _leftExpressionIbodyDependencies ++ _operatorIbodyDependencies ++ _rightExpressionIbodyDependencies
            -- self rule
            (_self@_) =
                Expression_InfixApplication _rangeIself _leftExpressionIself _operatorIself _rightExpressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _rightExpressionIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _rightExpressionIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _rightExpressionIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _rightExpressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _rightExpressionImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _rightExpressionIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_leftExpressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_leftExpressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_leftExpressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_leftExpressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_leftExpressionOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_leftExpressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_leftExpressionOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_leftExpressionOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_leftExpressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_leftExpressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_leftExpressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_leftExpressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_leftExpressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_leftExpressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_leftExpressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_leftExpressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_leftExpressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_leftExpressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_operatorOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_operatorOconstructors_collect@_) =
                _leftExpressionIconstructors_collect
            -- copy rule (down)
            (_operatorOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_operatorOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_operatorOdependencies_collect@_) =
                _leftExpressionIdependencies_collect
            -- copy rule (down)
            (_operatorOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_operatorOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_operatorOinferredDependencies_collect@_) =
                _leftExpressionIinferredDependencies_collect
            -- copy rule (down)
            (_operatorOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_operatorOlabels_collect@_) =
                _leftExpressionIlabels_collect
            -- copy rule (down)
            (_operatorOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_operatorOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_operatorOmethods_collect@_) =
                _leftExpressionImethods_collect
            -- copy rule (down)
            (_operatorOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_operatorOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_operatorOpresignatures_collect@_) =
                _leftExpressionIpresignatures_collect
            -- copy rule (down)
            (_operatorOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_operatorOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_rightExpressionOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_rightExpressionOconstructors_collect@_) =
                _operatorIconstructors_collect
            -- copy rule (down)
            (_rightExpressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_rightExpressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_rightExpressionOdependencies_collect@_) =
                _operatorIdependencies_collect
            -- copy rule (down)
            (_rightExpressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rightExpressionOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_rightExpressionOinferredDependencies_collect@_) =
                _operatorIinferredDependencies_collect
            -- copy rule (down)
            (_rightExpressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_rightExpressionOlabels_collect@_) =
                _operatorIlabels_collect
            -- copy rule (down)
            (_rightExpressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_rightExpressionOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_rightExpressionOmethods_collect@_) =
                _operatorImethods_collect
            -- copy rule (down)
            (_rightExpressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_rightExpressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_rightExpressionOpresignatures_collect@_) =
                _operatorIpresignatures_collect
            -- copy rule (down)
            (_rightExpressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_rightExpressionOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Expression_Irrefutable :: (T_Range) ->
                              (T_Expression) ->
                              (T_Expression)
sem_Expression_Irrefutable (range_) (expression_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionIbodyDependencies :: ([(Name,Name)])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOimportedModule :: (Bool)
            _expressionOinferredDependencies :: (FMap Name [(Name,Name)])
            _expressionOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOinstancename :: (Maybe Name)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOsignatures :: (Signatures)
            _expressionOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionIbodyDependencies,_expressionIconstructors_collect,_expressionIdependencies_collect,_expressionIinferredDependencies_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionIpresignatures_collect,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies_collect)
                             (_expressionOimportedModule)
                             (_expressionOinferredDependencies)
                             (_expressionOinferredDependencies_collect)
                             (_expressionOinstancename)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOsignatures)
                             (_expressionOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _expressionIbodyDependencies
            -- self rule
            (_self@_) =
                Expression_Irrefutable _rangeIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _expressionIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _expressionIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_expressionOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Expression_Lambda :: (T_Range) ->
                         (T_Patterns) ->
                         (T_Expression) ->
                         (T_Expression)
sem_Expression_Lambda (range_) (patterns_) (expression_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _patternsIconstructors_collect :: (FMap Name Names)
            _patternsIdependencies_collect :: (FMap Name [(Name,Name)])
            _patternsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _patternsIlabels_collect :: (FMap Name Names)
            _patternsImethods_collect :: (FMap Name Names)
            _patternsIself :: (Patterns)
            _patternsOclassname :: (Maybe Name)
            _patternsOconstructors_collect :: (FMap Name Names)
            _patternsOconstructors_dist :: (FMap Name Names)
            _patternsOcurrentModule :: (Strings)
            _patternsOdependencies_collect :: (FMap Name [(Name,Name)])
            _patternsOimportedModule :: (Bool)
            _patternsOinferredDependencies :: (FMap Name [(Name,Name)])
            _patternsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _patternsOinstancename :: (Maybe Name)
            _patternsOlabels_collect :: (FMap Name Names)
            _patternsOlabels_dist :: (FMap Name Names)
            _patternsOlocal :: (Bool)
            _patternsOmethods_collect :: (FMap Name Names)
            _patternsOmethods_dist :: (FMap Name Names)
            _patternsOtoplevel :: (Bool)
            _expressionIbodyDependencies :: ([(Name,Name)])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOimportedModule :: (Bool)
            _expressionOinferredDependencies :: (FMap Name [(Name,Name)])
            _expressionOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOinstancename :: (Maybe Name)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOsignatures :: (Signatures)
            _expressionOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _patternsIconstructors_collect,_patternsIdependencies_collect,_patternsIinferredDependencies_collect,_patternsIlabels_collect,_patternsImethods_collect,_patternsIself) =
                (patterns_ (_patternsOclassname) (_patternsOconstructors_collect) (_patternsOconstructors_dist) (_patternsOcurrentModule) (_patternsOdependencies_collect) (_patternsOimportedModule) (_patternsOinferredDependencies) (_patternsOinferredDependencies_collect) (_patternsOinstancename) (_patternsOlabels_collect) (_patternsOlabels_dist) (_patternsOlocal) (_patternsOmethods_collect) (_patternsOmethods_dist) (_patternsOtoplevel))
            ( _expressionIbodyDependencies,_expressionIconstructors_collect,_expressionIdependencies_collect,_expressionIinferredDependencies_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionIpresignatures_collect,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies_collect)
                             (_expressionOimportedModule)
                             (_expressionOinferredDependencies)
                             (_expressionOinferredDependencies_collect)
                             (_expressionOinstancename)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOsignatures)
                             (_expressionOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _expressionIbodyDependencies
            -- self rule
            (_self@_) =
                Expression_Lambda _rangeIself _patternsIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _expressionIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _expressionIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_patternsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_patternsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_patternsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_patternsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_patternsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_patternsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_patternsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_patternsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_expressionOconstructors_collect@_) =
                _patternsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_expressionOdependencies_collect@_) =
                _patternsIdependencies_collect
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_expressionOinferredDependencies_collect@_) =
                _patternsIinferredDependencies_collect
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_expressionOlabels_collect@_) =
                _patternsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_expressionOmethods_collect@_) =
                _patternsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Expression_Let :: (T_Range) ->
                      (T_Declarations) ->
                      (T_Expression) ->
                      (T_Expression)
sem_Expression_Let (range_) (declarations_) (expression_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _declarationsIbodyDependencies :: ([(Name,Name)])
            _declarationsIconstructors_collect :: (FMap Name Names)
            _declarationsIdependencies_collect :: (FMap Name [(Name,Name)])
            _declarationsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _declarationsIlabels_collect :: (FMap Name Names)
            _declarationsImethods_collect :: (FMap Name Names)
            _declarationsIpresignatures_collect :: (PreSignatures)
            _declarationsIself :: (Declarations)
            _declarationsOclassname :: (Maybe Name)
            _declarationsOconstructors_collect :: (FMap Name Names)
            _declarationsOconstructors_dist :: (FMap Name Names)
            _declarationsOcurrentModule :: (Strings)
            _declarationsOdependencies_collect :: (FMap Name [(Name,Name)])
            _declarationsOimportedModule :: (Bool)
            _declarationsOinferredDependencies :: (FMap Name [(Name,Name)])
            _declarationsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _declarationsOinstancename :: (Maybe Name)
            _declarationsOlabels_collect :: (FMap Name Names)
            _declarationsOlabels_dist :: (FMap Name Names)
            _declarationsOlocal :: (Bool)
            _declarationsOmethods_collect :: (FMap Name Names)
            _declarationsOmethods_dist :: (FMap Name Names)
            _declarationsOpresignatures :: (PreSignatures)
            _declarationsOpresignatures_collect :: (PreSignatures)
            _declarationsOsignatures :: (Signatures)
            _declarationsOtoplevel :: (Bool)
            _expressionIbodyDependencies :: ([(Name,Name)])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOimportedModule :: (Bool)
            _expressionOinferredDependencies :: (FMap Name [(Name,Name)])
            _expressionOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOinstancename :: (Maybe Name)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOsignatures :: (Signatures)
            _expressionOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _declarationsIbodyDependencies,_declarationsIconstructors_collect,_declarationsIdependencies_collect,_declarationsIinferredDependencies_collect,_declarationsIlabels_collect,_declarationsImethods_collect,_declarationsIpresignatures_collect,_declarationsIself) =
                (declarations_ (_declarationsOclassname)
                               (_declarationsOconstructors_collect)
                               (_declarationsOconstructors_dist)
                               (_declarationsOcurrentModule)
                               (_declarationsOdependencies_collect)
                               (_declarationsOimportedModule)
                               (_declarationsOinferredDependencies)
                               (_declarationsOinferredDependencies_collect)
                               (_declarationsOinstancename)
                               (_declarationsOlabels_collect)
                               (_declarationsOlabels_dist)
                               (_declarationsOlocal)
                               (_declarationsOmethods_collect)
                               (_declarationsOmethods_dist)
                               (_declarationsOpresignatures)
                               (_declarationsOpresignatures_collect)
                               (_declarationsOsignatures)
                               (_declarationsOtoplevel))
            ( _expressionIbodyDependencies,_expressionIconstructors_collect,_expressionIdependencies_collect,_expressionIinferredDependencies_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionIpresignatures_collect,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies_collect)
                             (_expressionOimportedModule)
                             (_expressionOinferredDependencies)
                             (_expressionOinferredDependencies_collect)
                             (_expressionOinstancename)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOsignatures)
                             (_expressionOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _declarationsIbodyDependencies ++ _expressionIbodyDependencies
            -- self rule
            (_self@_) =
                Expression_Let _rangeIself _declarationsIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _expressionIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _expressionIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_declarationsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_declarationsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_declarationsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_declarationsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_declarationsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_declarationsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_declarationsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_declarationsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_declarationsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_declarationsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_declarationsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_declarationsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_declarationsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_declarationsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_declarationsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_declarationsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_declarationsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_declarationsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_expressionOconstructors_collect@_) =
                _declarationsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_expressionOdependencies_collect@_) =
                _declarationsIdependencies_collect
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_expressionOinferredDependencies_collect@_) =
                _declarationsIinferredDependencies_collect
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_expressionOlabels_collect@_) =
                _declarationsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_expressionOmethods_collect@_) =
                _declarationsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_expressionOpresignatures_collect@_) =
                _declarationsIpresignatures_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Expression_List :: (T_Range) ->
                       (T_Expressions) ->
                       (T_Expression)
sem_Expression_List (range_) (expressions_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionsIbodyDependencies :: ([(Name,Name)])
            _expressionsIconstructors_collect :: (FMap Name Names)
            _expressionsIdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionsIlabels_collect :: (FMap Name Names)
            _expressionsImethods_collect :: (FMap Name Names)
            _expressionsIpresignatures_collect :: (PreSignatures)
            _expressionsIself :: (Expressions)
            _expressionsOclassname :: (Maybe Name)
            _expressionsOconstructors_collect :: (FMap Name Names)
            _expressionsOconstructors_dist :: (FMap Name Names)
            _expressionsOcurrentModule :: (Strings)
            _expressionsOdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionsOimportedModule :: (Bool)
            _expressionsOinferredDependencies :: (FMap Name [(Name,Name)])
            _expressionsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionsOinstancename :: (Maybe Name)
            _expressionsOlabels_collect :: (FMap Name Names)
            _expressionsOlabels_dist :: (FMap Name Names)
            _expressionsOlocal :: (Bool)
            _expressionsOmethods_collect :: (FMap Name Names)
            _expressionsOmethods_dist :: (FMap Name Names)
            _expressionsOpresignatures :: (PreSignatures)
            _expressionsOpresignatures_collect :: (PreSignatures)
            _expressionsOsignatures :: (Signatures)
            _expressionsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionsIbodyDependencies,_expressionsIconstructors_collect,_expressionsIdependencies_collect,_expressionsIinferredDependencies_collect,_expressionsIlabels_collect,_expressionsImethods_collect,_expressionsIpresignatures_collect,_expressionsIself) =
                (expressions_ (_expressionsOclassname)
                              (_expressionsOconstructors_collect)
                              (_expressionsOconstructors_dist)
                              (_expressionsOcurrentModule)
                              (_expressionsOdependencies_collect)
                              (_expressionsOimportedModule)
                              (_expressionsOinferredDependencies)
                              (_expressionsOinferredDependencies_collect)
                              (_expressionsOinstancename)
                              (_expressionsOlabels_collect)
                              (_expressionsOlabels_dist)
                              (_expressionsOlocal)
                              (_expressionsOmethods_collect)
                              (_expressionsOmethods_dist)
                              (_expressionsOpresignatures)
                              (_expressionsOpresignatures_collect)
                              (_expressionsOsignatures)
                              (_expressionsOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _expressionsIbodyDependencies
            -- self rule
            (_self@_) =
                Expression_List _rangeIself _expressionsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionsIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _expressionsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _expressionsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionsImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _expressionsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_expressionsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_expressionsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_expressionsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Expression_Literal :: (T_Range) ->
                          (T_Literal) ->
                          (T_Expression)
sem_Expression_Literal (range_) (literal_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _literalIconstructors_collect :: (FMap Name Names)
            _literalIdependencies_collect :: (FMap Name [(Name,Name)])
            _literalIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _literalIlabels_collect :: (FMap Name Names)
            _literalImethods_collect :: (FMap Name Names)
            _literalIself :: (Literal)
            _literalOclassname :: (Maybe Name)
            _literalOconstructors_collect :: (FMap Name Names)
            _literalOconstructors_dist :: (FMap Name Names)
            _literalOcurrentModule :: (Strings)
            _literalOdependencies_collect :: (FMap Name [(Name,Name)])
            _literalOimportedModule :: (Bool)
            _literalOinferredDependencies :: (FMap Name [(Name,Name)])
            _literalOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _literalOinstancename :: (Maybe Name)
            _literalOlabels_collect :: (FMap Name Names)
            _literalOlabels_dist :: (FMap Name Names)
            _literalOlocal :: (Bool)
            _literalOmethods_collect :: (FMap Name Names)
            _literalOmethods_dist :: (FMap Name Names)
            _literalOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _literalIconstructors_collect,_literalIdependencies_collect,_literalIinferredDependencies_collect,_literalIlabels_collect,_literalImethods_collect,_literalIself) =
                (literal_ (_literalOclassname) (_literalOconstructors_collect) (_literalOconstructors_dist) (_literalOcurrentModule) (_literalOdependencies_collect) (_literalOimportedModule) (_literalOinferredDependencies) (_literalOinferredDependencies_collect) (_literalOinstancename) (_literalOlabels_collect) (_literalOlabels_dist) (_literalOlocal) (_literalOmethods_collect) (_literalOmethods_dist) (_literalOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                []
            -- self rule
            (_self@_) =
                Expression_Literal _rangeIself _literalIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _literalIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _literalIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _literalIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _literalIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _literalImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_literalOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_literalOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_literalOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_literalOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_literalOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_literalOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_literalOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_literalOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_literalOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_literalOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_literalOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_literalOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_literalOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_literalOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_literalOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Expression_Negate :: (T_Range) ->
                         (T_Expression) ->
                         (T_Expression)
sem_Expression_Negate (range_) (expression_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionIbodyDependencies :: ([(Name,Name)])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOimportedModule :: (Bool)
            _expressionOinferredDependencies :: (FMap Name [(Name,Name)])
            _expressionOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOinstancename :: (Maybe Name)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOsignatures :: (Signatures)
            _expressionOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionIbodyDependencies,_expressionIconstructors_collect,_expressionIdependencies_collect,_expressionIinferredDependencies_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionIpresignatures_collect,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies_collect)
                             (_expressionOimportedModule)
                             (_expressionOinferredDependencies)
                             (_expressionOinferredDependencies_collect)
                             (_expressionOinstancename)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOsignatures)
                             (_expressionOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _expressionIbodyDependencies
            -- self rule
            (_self@_) =
                Expression_Negate _rangeIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _expressionIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _expressionIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_expressionOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Expression_NormalApplication :: (T_Range) ->
                                    (T_Expression) ->
                                    (T_Expressions) ->
                                    (T_Expression)
sem_Expression_NormalApplication (range_) (function_) (arguments_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _functionIbodyDependencies :: ([(Name,Name)])
            _functionIconstructors_collect :: (FMap Name Names)
            _functionIdependencies_collect :: (FMap Name [(Name,Name)])
            _functionIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _functionIlabels_collect :: (FMap Name Names)
            _functionImethods_collect :: (FMap Name Names)
            _functionIpresignatures_collect :: (PreSignatures)
            _functionIself :: (Expression)
            _functionOclassname :: (Maybe Name)
            _functionOconstructors_collect :: (FMap Name Names)
            _functionOconstructors_dist :: (FMap Name Names)
            _functionOcurrentModule :: (Strings)
            _functionOdependencies_collect :: (FMap Name [(Name,Name)])
            _functionOimportedModule :: (Bool)
            _functionOinferredDependencies :: (FMap Name [(Name,Name)])
            _functionOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _functionOinstancename :: (Maybe Name)
            _functionOlabels_collect :: (FMap Name Names)
            _functionOlabels_dist :: (FMap Name Names)
            _functionOlocal :: (Bool)
            _functionOmethods_collect :: (FMap Name Names)
            _functionOmethods_dist :: (FMap Name Names)
            _functionOpresignatures :: (PreSignatures)
            _functionOpresignatures_collect :: (PreSignatures)
            _functionOsignatures :: (Signatures)
            _functionOtoplevel :: (Bool)
            _argumentsIbodyDependencies :: ([(Name,Name)])
            _argumentsIconstructors_collect :: (FMap Name Names)
            _argumentsIdependencies_collect :: (FMap Name [(Name,Name)])
            _argumentsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _argumentsIlabels_collect :: (FMap Name Names)
            _argumentsImethods_collect :: (FMap Name Names)
            _argumentsIpresignatures_collect :: (PreSignatures)
            _argumentsIself :: (Expressions)
            _argumentsOclassname :: (Maybe Name)
            _argumentsOconstructors_collect :: (FMap Name Names)
            _argumentsOconstructors_dist :: (FMap Name Names)
            _argumentsOcurrentModule :: (Strings)
            _argumentsOdependencies_collect :: (FMap Name [(Name,Name)])
            _argumentsOimportedModule :: (Bool)
            _argumentsOinferredDependencies :: (FMap Name [(Name,Name)])
            _argumentsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _argumentsOinstancename :: (Maybe Name)
            _argumentsOlabels_collect :: (FMap Name Names)
            _argumentsOlabels_dist :: (FMap Name Names)
            _argumentsOlocal :: (Bool)
            _argumentsOmethods_collect :: (FMap Name Names)
            _argumentsOmethods_dist :: (FMap Name Names)
            _argumentsOpresignatures :: (PreSignatures)
            _argumentsOpresignatures_collect :: (PreSignatures)
            _argumentsOsignatures :: (Signatures)
            _argumentsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _functionIbodyDependencies,_functionIconstructors_collect,_functionIdependencies_collect,_functionIinferredDependencies_collect,_functionIlabels_collect,_functionImethods_collect,_functionIpresignatures_collect,_functionIself) =
                (function_ (_functionOclassname)
                           (_functionOconstructors_collect)
                           (_functionOconstructors_dist)
                           (_functionOcurrentModule)
                           (_functionOdependencies_collect)
                           (_functionOimportedModule)
                           (_functionOinferredDependencies)
                           (_functionOinferredDependencies_collect)
                           (_functionOinstancename)
                           (_functionOlabels_collect)
                           (_functionOlabels_dist)
                           (_functionOlocal)
                           (_functionOmethods_collect)
                           (_functionOmethods_dist)
                           (_functionOpresignatures)
                           (_functionOpresignatures_collect)
                           (_functionOsignatures)
                           (_functionOtoplevel))
            ( _argumentsIbodyDependencies,_argumentsIconstructors_collect,_argumentsIdependencies_collect,_argumentsIinferredDependencies_collect,_argumentsIlabels_collect,_argumentsImethods_collect,_argumentsIpresignatures_collect,_argumentsIself) =
                (arguments_ (_argumentsOclassname)
                            (_argumentsOconstructors_collect)
                            (_argumentsOconstructors_dist)
                            (_argumentsOcurrentModule)
                            (_argumentsOdependencies_collect)
                            (_argumentsOimportedModule)
                            (_argumentsOinferredDependencies)
                            (_argumentsOinferredDependencies_collect)
                            (_argumentsOinstancename)
                            (_argumentsOlabels_collect)
                            (_argumentsOlabels_dist)
                            (_argumentsOlocal)
                            (_argumentsOmethods_collect)
                            (_argumentsOmethods_dist)
                            (_argumentsOpresignatures)
                            (_argumentsOpresignatures_collect)
                            (_argumentsOsignatures)
                            (_argumentsOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _functionIbodyDependencies ++ _argumentsIbodyDependencies
            -- self rule
            (_self@_) =
                Expression_NormalApplication _rangeIself _functionIself _argumentsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _argumentsIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _argumentsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _argumentsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _argumentsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _argumentsImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _argumentsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_functionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_functionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_functionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_functionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_functionOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_functionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_functionOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_functionOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_functionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_functionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_functionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_functionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_functionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_functionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_functionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_functionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_functionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_functionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_argumentsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_argumentsOconstructors_collect@_) =
                _functionIconstructors_collect
            -- copy rule (down)
            (_argumentsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_argumentsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_argumentsOdependencies_collect@_) =
                _functionIdependencies_collect
            -- copy rule (down)
            (_argumentsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_argumentsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_argumentsOinferredDependencies_collect@_) =
                _functionIinferredDependencies_collect
            -- copy rule (down)
            (_argumentsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_argumentsOlabels_collect@_) =
                _functionIlabels_collect
            -- copy rule (down)
            (_argumentsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_argumentsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_argumentsOmethods_collect@_) =
                _functionImethods_collect
            -- copy rule (down)
            (_argumentsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_argumentsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_argumentsOpresignatures_collect@_) =
                _functionIpresignatures_collect
            -- copy rule (down)
            (_argumentsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_argumentsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Expression_Parenthesized :: (T_Range) ->
                                (T_Expression) ->
                                (T_Expression)
sem_Expression_Parenthesized (range_) (expression_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionIbodyDependencies :: ([(Name,Name)])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOimportedModule :: (Bool)
            _expressionOinferredDependencies :: (FMap Name [(Name,Name)])
            _expressionOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOinstancename :: (Maybe Name)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOsignatures :: (Signatures)
            _expressionOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionIbodyDependencies,_expressionIconstructors_collect,_expressionIdependencies_collect,_expressionIinferredDependencies_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionIpresignatures_collect,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies_collect)
                             (_expressionOimportedModule)
                             (_expressionOinferredDependencies)
                             (_expressionOinferredDependencies_collect)
                             (_expressionOinstancename)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOsignatures)
                             (_expressionOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _expressionIbodyDependencies
            -- self rule
            (_self@_) =
                Expression_Parenthesized _rangeIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _expressionIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _expressionIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_expressionOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Expression_RecordConstruction :: (T_Range) ->
                                     (T_Name) ->
                                     (T_RecordExpressionBindings) ->
                                     (T_Expression)
sem_Expression_RecordConstruction (range_) (name_) (recordExpressionBindings_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _recordExpressionBindingsIbodyDependencies :: ([(Name,Name)])
            _recordExpressionBindingsIconstructors_collect :: (FMap Name Names)
            _recordExpressionBindingsIdependencies_collect :: (FMap Name [(Name,Name)])
            _recordExpressionBindingsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _recordExpressionBindingsIlabels_collect :: (FMap Name Names)
            _recordExpressionBindingsImethods_collect :: (FMap Name Names)
            _recordExpressionBindingsIpresignatures_collect :: (PreSignatures)
            _recordExpressionBindingsIself :: (RecordExpressionBindings)
            _recordExpressionBindingsOclassname :: (Maybe Name)
            _recordExpressionBindingsOconstructors_collect :: (FMap Name Names)
            _recordExpressionBindingsOconstructors_dist :: (FMap Name Names)
            _recordExpressionBindingsOcurrentModule :: (Strings)
            _recordExpressionBindingsOdependencies_collect :: (FMap Name [(Name,Name)])
            _recordExpressionBindingsOimportedModule :: (Bool)
            _recordExpressionBindingsOinferredDependencies :: (FMap Name [(Name,Name)])
            _recordExpressionBindingsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _recordExpressionBindingsOinstancename :: (Maybe Name)
            _recordExpressionBindingsOlabels_collect :: (FMap Name Names)
            _recordExpressionBindingsOlabels_dist :: (FMap Name Names)
            _recordExpressionBindingsOlocal :: (Bool)
            _recordExpressionBindingsOmethods_collect :: (FMap Name Names)
            _recordExpressionBindingsOmethods_dist :: (FMap Name Names)
            _recordExpressionBindingsOpresignatures :: (PreSignatures)
            _recordExpressionBindingsOpresignatures_collect :: (PreSignatures)
            _recordExpressionBindingsOsignatures :: (Signatures)
            _recordExpressionBindingsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _recordExpressionBindingsIbodyDependencies,_recordExpressionBindingsIconstructors_collect,_recordExpressionBindingsIdependencies_collect,_recordExpressionBindingsIinferredDependencies_collect,_recordExpressionBindingsIlabels_collect,_recordExpressionBindingsImethods_collect,_recordExpressionBindingsIpresignatures_collect,_recordExpressionBindingsIself) =
                (recordExpressionBindings_ (_recordExpressionBindingsOclassname)
                                           (_recordExpressionBindingsOconstructors_collect)
                                           (_recordExpressionBindingsOconstructors_dist)
                                           (_recordExpressionBindingsOcurrentModule)
                                           (_recordExpressionBindingsOdependencies_collect)
                                           (_recordExpressionBindingsOimportedModule)
                                           (_recordExpressionBindingsOinferredDependencies)
                                           (_recordExpressionBindingsOinferredDependencies_collect)
                                           (_recordExpressionBindingsOinstancename)
                                           (_recordExpressionBindingsOlabels_collect)
                                           (_recordExpressionBindingsOlabels_dist)
                                           (_recordExpressionBindingsOlocal)
                                           (_recordExpressionBindingsOmethods_collect)
                                           (_recordExpressionBindingsOmethods_dist)
                                           (_recordExpressionBindingsOpresignatures)
                                           (_recordExpressionBindingsOpresignatures_collect)
                                           (_recordExpressionBindingsOsignatures)
                                           (_recordExpressionBindingsOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _recordExpressionBindingsIbodyDependencies
            -- self rule
            (_self@_) =
                Expression_RecordConstruction _rangeIself _nameIself _recordExpressionBindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _recordExpressionBindingsIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _recordExpressionBindingsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _recordExpressionBindingsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _recordExpressionBindingsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _recordExpressionBindingsImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _recordExpressionBindingsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_recordExpressionBindingsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_recordExpressionBindingsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_recordExpressionBindingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_recordExpressionBindingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_recordExpressionBindingsOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_recordExpressionBindingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_recordExpressionBindingsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_recordExpressionBindingsOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_recordExpressionBindingsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_recordExpressionBindingsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_recordExpressionBindingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_recordExpressionBindingsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_recordExpressionBindingsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_recordExpressionBindingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_recordExpressionBindingsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_recordExpressionBindingsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_recordExpressionBindingsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_recordExpressionBindingsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Expression_RecordUpdate :: (T_Range) ->
                               (T_Expression) ->
                               (T_RecordExpressionBindings) ->
                               (T_Expression)
sem_Expression_RecordUpdate (range_) (expression_) (recordExpressionBindings_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionIbodyDependencies :: ([(Name,Name)])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOimportedModule :: (Bool)
            _expressionOinferredDependencies :: (FMap Name [(Name,Name)])
            _expressionOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOinstancename :: (Maybe Name)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOsignatures :: (Signatures)
            _expressionOtoplevel :: (Bool)
            _recordExpressionBindingsIbodyDependencies :: ([(Name,Name)])
            _recordExpressionBindingsIconstructors_collect :: (FMap Name Names)
            _recordExpressionBindingsIdependencies_collect :: (FMap Name [(Name,Name)])
            _recordExpressionBindingsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _recordExpressionBindingsIlabels_collect :: (FMap Name Names)
            _recordExpressionBindingsImethods_collect :: (FMap Name Names)
            _recordExpressionBindingsIpresignatures_collect :: (PreSignatures)
            _recordExpressionBindingsIself :: (RecordExpressionBindings)
            _recordExpressionBindingsOclassname :: (Maybe Name)
            _recordExpressionBindingsOconstructors_collect :: (FMap Name Names)
            _recordExpressionBindingsOconstructors_dist :: (FMap Name Names)
            _recordExpressionBindingsOcurrentModule :: (Strings)
            _recordExpressionBindingsOdependencies_collect :: (FMap Name [(Name,Name)])
            _recordExpressionBindingsOimportedModule :: (Bool)
            _recordExpressionBindingsOinferredDependencies :: (FMap Name [(Name,Name)])
            _recordExpressionBindingsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _recordExpressionBindingsOinstancename :: (Maybe Name)
            _recordExpressionBindingsOlabels_collect :: (FMap Name Names)
            _recordExpressionBindingsOlabels_dist :: (FMap Name Names)
            _recordExpressionBindingsOlocal :: (Bool)
            _recordExpressionBindingsOmethods_collect :: (FMap Name Names)
            _recordExpressionBindingsOmethods_dist :: (FMap Name Names)
            _recordExpressionBindingsOpresignatures :: (PreSignatures)
            _recordExpressionBindingsOpresignatures_collect :: (PreSignatures)
            _recordExpressionBindingsOsignatures :: (Signatures)
            _recordExpressionBindingsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionIbodyDependencies,_expressionIconstructors_collect,_expressionIdependencies_collect,_expressionIinferredDependencies_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionIpresignatures_collect,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies_collect)
                             (_expressionOimportedModule)
                             (_expressionOinferredDependencies)
                             (_expressionOinferredDependencies_collect)
                             (_expressionOinstancename)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOsignatures)
                             (_expressionOtoplevel))
            ( _recordExpressionBindingsIbodyDependencies,_recordExpressionBindingsIconstructors_collect,_recordExpressionBindingsIdependencies_collect,_recordExpressionBindingsIinferredDependencies_collect,_recordExpressionBindingsIlabels_collect,_recordExpressionBindingsImethods_collect,_recordExpressionBindingsIpresignatures_collect,_recordExpressionBindingsIself) =
                (recordExpressionBindings_ (_recordExpressionBindingsOclassname)
                                           (_recordExpressionBindingsOconstructors_collect)
                                           (_recordExpressionBindingsOconstructors_dist)
                                           (_recordExpressionBindingsOcurrentModule)
                                           (_recordExpressionBindingsOdependencies_collect)
                                           (_recordExpressionBindingsOimportedModule)
                                           (_recordExpressionBindingsOinferredDependencies)
                                           (_recordExpressionBindingsOinferredDependencies_collect)
                                           (_recordExpressionBindingsOinstancename)
                                           (_recordExpressionBindingsOlabels_collect)
                                           (_recordExpressionBindingsOlabels_dist)
                                           (_recordExpressionBindingsOlocal)
                                           (_recordExpressionBindingsOmethods_collect)
                                           (_recordExpressionBindingsOmethods_dist)
                                           (_recordExpressionBindingsOpresignatures)
                                           (_recordExpressionBindingsOpresignatures_collect)
                                           (_recordExpressionBindingsOsignatures)
                                           (_recordExpressionBindingsOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _expressionIbodyDependencies ++ _recordExpressionBindingsIbodyDependencies
            -- self rule
            (_self@_) =
                Expression_RecordUpdate _rangeIself _expressionIself _recordExpressionBindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _recordExpressionBindingsIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _recordExpressionBindingsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _recordExpressionBindingsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _recordExpressionBindingsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _recordExpressionBindingsImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _recordExpressionBindingsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_expressionOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_recordExpressionBindingsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_recordExpressionBindingsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (down)
            (_recordExpressionBindingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_recordExpressionBindingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_recordExpressionBindingsOdependencies_collect@_) =
                _expressionIdependencies_collect
            -- copy rule (down)
            (_recordExpressionBindingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_recordExpressionBindingsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_recordExpressionBindingsOinferredDependencies_collect@_) =
                _expressionIinferredDependencies_collect
            -- copy rule (down)
            (_recordExpressionBindingsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_recordExpressionBindingsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (down)
            (_recordExpressionBindingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_recordExpressionBindingsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_recordExpressionBindingsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (down)
            (_recordExpressionBindingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_recordExpressionBindingsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_recordExpressionBindingsOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (down)
            (_recordExpressionBindingsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_recordExpressionBindingsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Expression_Tuple :: (T_Range) ->
                        (T_Expressions) ->
                        (T_Expression)
sem_Expression_Tuple (range_) (expressions_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionsIbodyDependencies :: ([(Name,Name)])
            _expressionsIconstructors_collect :: (FMap Name Names)
            _expressionsIdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionsIlabels_collect :: (FMap Name Names)
            _expressionsImethods_collect :: (FMap Name Names)
            _expressionsIpresignatures_collect :: (PreSignatures)
            _expressionsIself :: (Expressions)
            _expressionsOclassname :: (Maybe Name)
            _expressionsOconstructors_collect :: (FMap Name Names)
            _expressionsOconstructors_dist :: (FMap Name Names)
            _expressionsOcurrentModule :: (Strings)
            _expressionsOdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionsOimportedModule :: (Bool)
            _expressionsOinferredDependencies :: (FMap Name [(Name,Name)])
            _expressionsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionsOinstancename :: (Maybe Name)
            _expressionsOlabels_collect :: (FMap Name Names)
            _expressionsOlabels_dist :: (FMap Name Names)
            _expressionsOlocal :: (Bool)
            _expressionsOmethods_collect :: (FMap Name Names)
            _expressionsOmethods_dist :: (FMap Name Names)
            _expressionsOpresignatures :: (PreSignatures)
            _expressionsOpresignatures_collect :: (PreSignatures)
            _expressionsOsignatures :: (Signatures)
            _expressionsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionsIbodyDependencies,_expressionsIconstructors_collect,_expressionsIdependencies_collect,_expressionsIinferredDependencies_collect,_expressionsIlabels_collect,_expressionsImethods_collect,_expressionsIpresignatures_collect,_expressionsIself) =
                (expressions_ (_expressionsOclassname)
                              (_expressionsOconstructors_collect)
                              (_expressionsOconstructors_dist)
                              (_expressionsOcurrentModule)
                              (_expressionsOdependencies_collect)
                              (_expressionsOimportedModule)
                              (_expressionsOinferredDependencies)
                              (_expressionsOinferredDependencies_collect)
                              (_expressionsOinstancename)
                              (_expressionsOlabels_collect)
                              (_expressionsOlabels_dist)
                              (_expressionsOlocal)
                              (_expressionsOmethods_collect)
                              (_expressionsOmethods_dist)
                              (_expressionsOpresignatures)
                              (_expressionsOpresignatures_collect)
                              (_expressionsOsignatures)
                              (_expressionsOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _expressionsIbodyDependencies
            -- self rule
            (_self@_) =
                Expression_Tuple _rangeIself _expressionsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionsIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _expressionsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _expressionsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionsImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _expressionsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_expressionsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_expressionsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_expressionsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Expression_TypeApplication :: (T_Range) ->
                                  (T_Name) ->
                                  (T_Type) ->
                                  (T_Expression)
sem_Expression_TypeApplication (range_) (name_) (type_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIdependencies_collect :: (FMap Name [(Name,Name)])
            _typeIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typeIlabels_collect :: (FMap Name Names)
            _typeIlocalDependencies :: ([(Name,Name)])
            _typeImethods_collect :: (FMap Name Names)
            _typeIself :: (Type)
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOdependencies_collect :: (FMap Name [(Name,Name)])
            _typeOimportedModule :: (Bool)
            _typeOinferredDependencies :: (FMap Name [(Name,Name)])
            _typeOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typeOinstancename :: (Maybe Name)
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _typeIconstructors_collect,_typeIdependencies_collect,_typeIinferredDependencies_collect,_typeIlabels_collect,_typeIlocalDependencies,_typeImethods_collect,_typeIself) =
                (type_ (_typeOclassname) (_typeOconstructors_collect) (_typeOconstructors_dist) (_typeOcurrentModule) (_typeOdependencies_collect) (_typeOimportedModule) (_typeOinferredDependencies) (_typeOinferredDependencies_collect) (_typeOinstancename) (_typeOlabels_collect) (_typeOlabels_dist) (_typeOlocal) (_typeOmethods_collect) (_typeOmethods_dist) (_typeOtoplevel))
            -- "ScanDependencies.lag"(line 105, column 9)
            (_lhsObodyDependencies@_) =
                [ (_nameIself,v)
                | v <- setToList $ Types.freeVars _typeIself
                ]
            -- self rule
            (_self@_) =
                Expression_TypeApplication _rangeIself _nameIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _typeIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _typeIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_typeOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_typeOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Expression_Typed :: (T_Range) ->
                        (T_Expression) ->
                        (T_Type) ->
                        (T_Expression)
sem_Expression_Typed (range_) (expression_) (type_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionIbodyDependencies :: ([(Name,Name)])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOimportedModule :: (Bool)
            _expressionOinferredDependencies :: (FMap Name [(Name,Name)])
            _expressionOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOinstancename :: (Maybe Name)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOsignatures :: (Signatures)
            _expressionOtoplevel :: (Bool)
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIdependencies_collect :: (FMap Name [(Name,Name)])
            _typeIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typeIlabels_collect :: (FMap Name Names)
            _typeIlocalDependencies :: ([(Name,Name)])
            _typeImethods_collect :: (FMap Name Names)
            _typeIself :: (Type)
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOdependencies_collect :: (FMap Name [(Name,Name)])
            _typeOimportedModule :: (Bool)
            _typeOinferredDependencies :: (FMap Name [(Name,Name)])
            _typeOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typeOinstancename :: (Maybe Name)
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionIbodyDependencies,_expressionIconstructors_collect,_expressionIdependencies_collect,_expressionIinferredDependencies_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionIpresignatures_collect,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies_collect)
                             (_expressionOimportedModule)
                             (_expressionOinferredDependencies)
                             (_expressionOinferredDependencies_collect)
                             (_expressionOinstancename)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOsignatures)
                             (_expressionOtoplevel))
            ( _typeIconstructors_collect,_typeIdependencies_collect,_typeIinferredDependencies_collect,_typeIlabels_collect,_typeIlocalDependencies,_typeImethods_collect,_typeIself) =
                (type_ (_typeOclassname) (_typeOconstructors_collect) (_typeOconstructors_dist) (_typeOcurrentModule) (_typeOdependencies_collect) (_typeOimportedModule) (_typeOinferredDependencies) (_typeOinferredDependencies_collect) (_typeOinstancename) (_typeOlabels_collect) (_typeOlabels_dist) (_typeOlocal) (_typeOmethods_collect) (_typeOmethods_dist) (_typeOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _expressionIbodyDependencies
            -- self rule
            (_self@_) =
                Expression_Typed _rangeIself _expressionIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _typeIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _typeIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_expressionOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_typeOdependencies_collect@_) =
                _expressionIdependencies_collect
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_typeOinferredDependencies_collect@_) =
                _expressionIinferredDependencies_collect
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Expression_Variable :: (T_Range) ->
                           (T_Name) ->
                           (T_Expression)
sem_Expression_Variable (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                []
            -- self rule
            (_self@_) =
                Expression_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Expression_Wildcard :: (T_Range) ->
                           (T_Expression)
sem_Expression_Wildcard (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Expression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                []
            -- self rule
            (_self@_) =
                Expression_Wildcard _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- Expressions -------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      bodyDependencies     : [(Name,Name)]
      self                 : SELF

-}
{-
   local variables for Expressions.Cons:
      self

-}
{-
   local variables for Expressions.Nil:
      self

-}
-- semantic domain
type T_Expressions = (Maybe Name) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Strings) ->
                     (FMap Name [(Name,Name)]) ->
                     (Bool) ->
                     (FMap Name [(Name,Name)]) ->
                     (FMap Name [(Name,Name)]) ->
                     (Maybe Name) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (Bool) ->
                     (FMap Name Names) ->
                     (FMap Name Names) ->
                     (PreSignatures) ->
                     (PreSignatures) ->
                     (Signatures) ->
                     (Bool) ->
                     ( ([(Name,Name)]),(FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(PreSignatures),(Expressions))
-- cata
sem_Expressions :: (Expressions) ->
                   (T_Expressions)
sem_Expressions (list) =
    (foldr (sem_Expressions_Cons) (sem_Expressions_Nil) ((map sem_Expression list)))
sem_Expressions_Cons :: (T_Expression) ->
                        (T_Expressions) ->
                        (T_Expressions)
sem_Expressions_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Expressions)
            _hdIbodyDependencies :: ([(Name,Name)])
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdependencies_collect :: (FMap Name [(Name,Name)])
            _hdIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIpresignatures_collect :: (PreSignatures)
            _hdIself :: (Expression)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies_collect :: (FMap Name [(Name,Name)])
            _hdOimportedModule :: (Bool)
            _hdOinferredDependencies :: (FMap Name [(Name,Name)])
            _hdOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdOinstancename :: (Maybe Name)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOpresignatures :: (PreSignatures)
            _hdOpresignatures_collect :: (PreSignatures)
            _hdOsignatures :: (Signatures)
            _hdOtoplevel :: (Bool)
            _tlIbodyDependencies :: ([(Name,Name)])
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdependencies_collect :: (FMap Name [(Name,Name)])
            _tlIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIpresignatures_collect :: (PreSignatures)
            _tlIself :: (Expressions)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies_collect :: (FMap Name [(Name,Name)])
            _tlOimportedModule :: (Bool)
            _tlOinferredDependencies :: (FMap Name [(Name,Name)])
            _tlOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOpresignatures :: (PreSignatures)
            _tlOpresignatures_collect :: (PreSignatures)
            _tlOsignatures :: (Signatures)
            _tlOtoplevel :: (Bool)
            ( _hdIbodyDependencies,_hdIconstructors_collect,_hdIdependencies_collect,_hdIinferredDependencies_collect,_hdIlabels_collect,_hdImethods_collect,_hdIpresignatures_collect,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOdependencies_collect) (_hdOimportedModule) (_hdOinferredDependencies) (_hdOinferredDependencies_collect) (_hdOinstancename) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOpresignatures) (_hdOpresignatures_collect) (_hdOsignatures) (_hdOtoplevel))
            ( _tlIbodyDependencies,_tlIconstructors_collect,_tlIdependencies_collect,_tlIinferredDependencies_collect,_tlIlabels_collect,_tlImethods_collect,_tlIpresignatures_collect,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOdependencies_collect) (_tlOimportedModule) (_tlOinferredDependencies) (_tlOinferredDependencies_collect) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOpresignatures) (_tlOpresignatures_collect) (_tlOsignatures) (_tlOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _hdIbodyDependencies ++ _tlIbodyDependencies
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _tlIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _tlIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _tlIpresignatures_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_hdOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_hdOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_hdOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_tlOdependencies_collect@_) =
                _hdIdependencies_collect
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_tlOinferredDependencies_collect@_) =
                _hdIinferredDependencies_collect
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_tlOpresignatures_collect@_) =
                _hdIpresignatures_collect
            -- copy rule (down)
            (_tlOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Expressions_Nil :: (T_Expressions)
sem_Expressions_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Expressions)
            -- use rule
            (_lhsObodyDependencies@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- FieldDeclaration --------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      constructors         : Names
      labels               : Names
      self                 : SELF

-}
{-
   local variables for FieldDeclaration.FieldDeclaration:
      self

-}
-- semantic domain
type T_FieldDeclaration = (Maybe Name) ->
                          (FMap Name Names) ->
                          (FMap Name Names) ->
                          (Strings) ->
                          (FMap Name [(Name,Name)]) ->
                          (Bool) ->
                          (FMap Name [(Name,Name)]) ->
                          (FMap Name [(Name,Name)]) ->
                          (Maybe Name) ->
                          (FMap Name Names) ->
                          (FMap Name Names) ->
                          (Bool) ->
                          (FMap Name Names) ->
                          (FMap Name Names) ->
                          (Bool) ->
                          ( (Names),(FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(Names),(FMap Name Names),(FMap Name Names),(FieldDeclaration))
-- cata
sem_FieldDeclaration :: (FieldDeclaration) ->
                        (T_FieldDeclaration)
sem_FieldDeclaration ((FieldDeclaration_FieldDeclaration (_range) (_names) (_type))) =
    (sem_FieldDeclaration_FieldDeclaration ((sem_Range (_range))) ((sem_Names (_names))) ((sem_AnnotatedType (_type))))
sem_FieldDeclaration_FieldDeclaration :: (T_Range) ->
                                         (T_Names) ->
                                         (T_AnnotatedType) ->
                                         (T_FieldDeclaration)
sem_FieldDeclaration_FieldDeclaration (range_) (names_) (type_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors :: (Names)
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels :: (Names)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (FieldDeclaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _namesIconstructors_collect :: (FMap Name Names)
            _namesIdependencies_collect :: (FMap Name [(Name,Name)])
            _namesIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _namesIlabels_collect :: (FMap Name Names)
            _namesImethods_collect :: (FMap Name Names)
            _namesIself :: (Names)
            _namesOclassname :: (Maybe Name)
            _namesOconstructors_collect :: (FMap Name Names)
            _namesOconstructors_dist :: (FMap Name Names)
            _namesOcurrentModule :: (Strings)
            _namesOdependencies_collect :: (FMap Name [(Name,Name)])
            _namesOimportedModule :: (Bool)
            _namesOinferredDependencies :: (FMap Name [(Name,Name)])
            _namesOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _namesOinstancename :: (Maybe Name)
            _namesOlabels_collect :: (FMap Name Names)
            _namesOlabels_dist :: (FMap Name Names)
            _namesOlocal :: (Bool)
            _namesOmethods_collect :: (FMap Name Names)
            _namesOmethods_dist :: (FMap Name Names)
            _namesOtoplevel :: (Bool)
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIdependencies_collect :: (FMap Name [(Name,Name)])
            _typeIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typeIlabels_collect :: (FMap Name Names)
            _typeImethods_collect :: (FMap Name Names)
            _typeIself :: (AnnotatedType)
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOdependencies_collect :: (FMap Name [(Name,Name)])
            _typeOimportedModule :: (Bool)
            _typeOinferredDependencies :: (FMap Name [(Name,Name)])
            _typeOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typeOinstancename :: (Maybe Name)
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _namesIconstructors_collect,_namesIdependencies_collect,_namesIinferredDependencies_collect,_namesIlabels_collect,_namesImethods_collect,_namesIself) =
                (names_ (_namesOclassname) (_namesOconstructors_collect) (_namesOconstructors_dist) (_namesOcurrentModule) (_namesOdependencies_collect) (_namesOimportedModule) (_namesOinferredDependencies) (_namesOinferredDependencies_collect) (_namesOinstancename) (_namesOlabels_collect) (_namesOlabels_dist) (_namesOlocal) (_namesOmethods_collect) (_namesOmethods_dist) (_namesOtoplevel))
            ( _typeIconstructors_collect,_typeIdependencies_collect,_typeIinferredDependencies_collect,_typeIlabels_collect,_typeImethods_collect,_typeIself) =
                (type_ (_typeOclassname) (_typeOconstructors_collect) (_typeOconstructors_dist) (_typeOcurrentModule) (_typeOdependencies_collect) (_typeOimportedModule) (_typeOinferredDependencies) (_typeOinferredDependencies_collect) (_typeOinstancename) (_typeOlabels_collect) (_typeOlabels_dist) (_typeOlocal) (_typeOmethods_collect) (_typeOmethods_dist) (_typeOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 369, column 9)
            (_lhsOlabels@_) =
                _namesIself
            -- "./ModuleInformation.inc.lag"(line 368, column 9)
            (_lhsOconstructors@_) =
                _namesIself
            -- self rule
            (_self@_) =
                FieldDeclaration_FieldDeclaration _rangeIself _namesIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _typeIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _typeIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_namesOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_namesOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_namesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_namesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_namesOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_namesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_namesOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_namesOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_namesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_namesOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_namesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_namesOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_namesOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_namesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_namesOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _namesIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_typeOdependencies_collect@_) =
                _namesIdependencies_collect
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_typeOinferredDependencies_collect@_) =
                _namesIinferredDependencies_collect
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _namesIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _namesImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- FieldDeclarations -------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      constructors         : Names
      labels               : Names
      self                 : SELF

-}
{-
   local variables for FieldDeclarations.Cons:
      self

-}
{-
   local variables for FieldDeclarations.Nil:
      self

-}
-- semantic domain
type T_FieldDeclarations = (Maybe Name) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Strings) ->
                           (FMap Name [(Name,Name)]) ->
                           (Bool) ->
                           (FMap Name [(Name,Name)]) ->
                           (FMap Name [(Name,Name)]) ->
                           (Maybe Name) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Bool) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Bool) ->
                           ( (Names),(FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(Names),(FMap Name Names),(FMap Name Names),(FieldDeclarations))
-- cata
sem_FieldDeclarations :: (FieldDeclarations) ->
                         (T_FieldDeclarations)
sem_FieldDeclarations (list) =
    (foldr (sem_FieldDeclarations_Cons) (sem_FieldDeclarations_Nil) ((map sem_FieldDeclaration list)))
sem_FieldDeclarations_Cons :: (T_FieldDeclaration) ->
                              (T_FieldDeclarations) ->
                              (T_FieldDeclarations)
sem_FieldDeclarations_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors :: (Names)
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels :: (Names)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (FieldDeclarations)
            _hdIconstructors :: (Names)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdependencies_collect :: (FMap Name [(Name,Name)])
            _hdIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdIlabels :: (Names)
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIself :: (FieldDeclaration)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies_collect :: (FMap Name [(Name,Name)])
            _hdOimportedModule :: (Bool)
            _hdOinferredDependencies :: (FMap Name [(Name,Name)])
            _hdOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdOinstancename :: (Maybe Name)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOtoplevel :: (Bool)
            _tlIconstructors :: (Names)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdependencies_collect :: (FMap Name [(Name,Name)])
            _tlIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlIlabels :: (Names)
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIself :: (FieldDeclarations)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies_collect :: (FMap Name [(Name,Name)])
            _tlOimportedModule :: (Bool)
            _tlOinferredDependencies :: (FMap Name [(Name,Name)])
            _tlOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors,_hdIconstructors_collect,_hdIdependencies_collect,_hdIinferredDependencies_collect,_hdIlabels,_hdIlabels_collect,_hdImethods_collect,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOdependencies_collect) (_hdOimportedModule) (_hdOinferredDependencies) (_hdOinferredDependencies_collect) (_hdOinstancename) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOtoplevel))
            ( _tlIconstructors,_tlIconstructors_collect,_tlIdependencies_collect,_tlIinferredDependencies_collect,_tlIlabels,_tlIlabels_collect,_tlImethods_collect,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOdependencies_collect) (_tlOimportedModule) (_tlOinferredDependencies) (_tlOinferredDependencies_collect) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOtoplevel))
            -- use rule
            (_lhsOconstructors@_) =
                _hdIconstructors ++ _tlIconstructors
            -- use rule
            (_lhsOlabels@_) =
                _hdIlabels `List.union` _tlIlabels
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _tlIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _tlIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_hdOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_tlOdependencies_collect@_) =
                _hdIdependencies_collect
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_tlOinferredDependencies_collect@_) =
                _hdIinferredDependencies_collect
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_FieldDeclarations_Nil :: (T_FieldDeclarations)
sem_FieldDeclarations_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors :: (Names)
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels :: (Names)
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (FieldDeclarations)
            -- use rule
            (_lhsOconstructors@_) =
                []
            -- use rule
            (_lhsOlabels@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- Fixity ------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Fixity.Infix:
      self

-}
{-
   local variables for Fixity.Infixl:
      self

-}
{-
   local variables for Fixity.Infixr:
      self

-}
-- semantic domain
type T_Fixity = (Maybe Name) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (Strings) ->
                (FMap Name [(Name,Name)]) ->
                (Bool) ->
                (FMap Name [(Name,Name)]) ->
                (FMap Name [(Name,Name)]) ->
                (Maybe Name) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (Bool) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (Bool) ->
                ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(Fixity))
-- cata
sem_Fixity :: (Fixity) ->
              (T_Fixity)
sem_Fixity ((Fixity_Infix (_range))) =
    (sem_Fixity_Infix ((sem_Range (_range))))
sem_Fixity ((Fixity_Infixl (_range))) =
    (sem_Fixity_Infixl ((sem_Range (_range))))
sem_Fixity ((Fixity_Infixr (_range))) =
    (sem_Fixity_Infixr ((sem_Range (_range))))
sem_Fixity_Infix :: (T_Range) ->
                    (T_Fixity)
sem_Fixity_Infix (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Fixity)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- self rule
            (_self@_) =
                Fixity_Infix _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Fixity_Infixl :: (T_Range) ->
                     (T_Fixity)
sem_Fixity_Infixl (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Fixity)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- self rule
            (_self@_) =
                Fixity_Infixl _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Fixity_Infixr :: (T_Range) ->
                     (T_Fixity)
sem_Fixity_Infixr (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Fixity)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- self rule
            (_self@_) =
                Fixity_Infixr _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- FunctionBinding ---------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      bodyDependencies     : [(Name,Name)]
      name                 : Name
      self                 : SELF

-}
{-
   local variables for FunctionBinding.FunctionBinding:
      self

-}
-- semantic domain
type T_FunctionBinding = (Maybe Name) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (Strings) ->
                         (FMap Name [(Name,Name)]) ->
                         (Bool) ->
                         (FMap Name [(Name,Name)]) ->
                         (FMap Name [(Name,Name)]) ->
                         (Maybe Name) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (Bool) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (PreSignatures) ->
                         (PreSignatures) ->
                         (Signatures) ->
                         (Bool) ->
                         ( ([(Name,Name)]),(FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(Name),(PreSignatures),(FunctionBinding))
-- cata
sem_FunctionBinding :: (FunctionBinding) ->
                       (T_FunctionBinding)
sem_FunctionBinding ((FunctionBinding_FunctionBinding (_range) (_lefthandside) (_righthandside))) =
    (sem_FunctionBinding_FunctionBinding ((sem_Range (_range))) ((sem_LeftHandSide (_lefthandside))) ((sem_RightHandSide (_righthandside))))
sem_FunctionBinding_FunctionBinding :: (T_Range) ->
                                       (T_LeftHandSide) ->
                                       (T_RightHandSide) ->
                                       (T_FunctionBinding)
sem_FunctionBinding_FunctionBinding (range_) (lefthandside_) (righthandside_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (FunctionBinding)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _lefthandsideIconstructors_collect :: (FMap Name Names)
            _lefthandsideIdependencies_collect :: (FMap Name [(Name,Name)])
            _lefthandsideIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lefthandsideIlabels_collect :: (FMap Name Names)
            _lefthandsideImethods_collect :: (FMap Name Names)
            _lefthandsideIname :: (Name)
            _lefthandsideIself :: (LeftHandSide)
            _lefthandsideOclassname :: (Maybe Name)
            _lefthandsideOconstructors_collect :: (FMap Name Names)
            _lefthandsideOconstructors_dist :: (FMap Name Names)
            _lefthandsideOcurrentModule :: (Strings)
            _lefthandsideOdependencies_collect :: (FMap Name [(Name,Name)])
            _lefthandsideOimportedModule :: (Bool)
            _lefthandsideOinferredDependencies :: (FMap Name [(Name,Name)])
            _lefthandsideOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lefthandsideOinstancename :: (Maybe Name)
            _lefthandsideOlabels_collect :: (FMap Name Names)
            _lefthandsideOlabels_dist :: (FMap Name Names)
            _lefthandsideOlocal :: (Bool)
            _lefthandsideOmethods_collect :: (FMap Name Names)
            _lefthandsideOmethods_dist :: (FMap Name Names)
            _lefthandsideOtoplevel :: (Bool)
            _righthandsideIbodyDependencies :: ([(Name,Name)])
            _righthandsideIconstructors_collect :: (FMap Name Names)
            _righthandsideIdependencies_collect :: (FMap Name [(Name,Name)])
            _righthandsideIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _righthandsideIlabels_collect :: (FMap Name Names)
            _righthandsideImethods_collect :: (FMap Name Names)
            _righthandsideIpresignatures_collect :: (PreSignatures)
            _righthandsideIself :: (RightHandSide)
            _righthandsideOclassname :: (Maybe Name)
            _righthandsideOconstructors_collect :: (FMap Name Names)
            _righthandsideOconstructors_dist :: (FMap Name Names)
            _righthandsideOcurrentModule :: (Strings)
            _righthandsideOdependencies_collect :: (FMap Name [(Name,Name)])
            _righthandsideOimportedModule :: (Bool)
            _righthandsideOinferredDependencies :: (FMap Name [(Name,Name)])
            _righthandsideOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _righthandsideOinstancename :: (Maybe Name)
            _righthandsideOlabels_collect :: (FMap Name Names)
            _righthandsideOlabels_dist :: (FMap Name Names)
            _righthandsideOlocal :: (Bool)
            _righthandsideOmethods_collect :: (FMap Name Names)
            _righthandsideOmethods_dist :: (FMap Name Names)
            _righthandsideOpresignatures :: (PreSignatures)
            _righthandsideOpresignatures_collect :: (PreSignatures)
            _righthandsideOsignatures :: (Signatures)
            _righthandsideOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _lefthandsideIconstructors_collect,_lefthandsideIdependencies_collect,_lefthandsideIinferredDependencies_collect,_lefthandsideIlabels_collect,_lefthandsideImethods_collect,_lefthandsideIname,_lefthandsideIself) =
                (lefthandside_ (_lefthandsideOclassname)
                               (_lefthandsideOconstructors_collect)
                               (_lefthandsideOconstructors_dist)
                               (_lefthandsideOcurrentModule)
                               (_lefthandsideOdependencies_collect)
                               (_lefthandsideOimportedModule)
                               (_lefthandsideOinferredDependencies)
                               (_lefthandsideOinferredDependencies_collect)
                               (_lefthandsideOinstancename)
                               (_lefthandsideOlabels_collect)
                               (_lefthandsideOlabels_dist)
                               (_lefthandsideOlocal)
                               (_lefthandsideOmethods_collect)
                               (_lefthandsideOmethods_dist)
                               (_lefthandsideOtoplevel))
            ( _righthandsideIbodyDependencies,_righthandsideIconstructors_collect,_righthandsideIdependencies_collect,_righthandsideIinferredDependencies_collect,_righthandsideIlabels_collect,_righthandsideImethods_collect,_righthandsideIpresignatures_collect,_righthandsideIself) =
                (righthandside_ (_righthandsideOclassname)
                                (_righthandsideOconstructors_collect)
                                (_righthandsideOconstructors_dist)
                                (_righthandsideOcurrentModule)
                                (_righthandsideOdependencies_collect)
                                (_righthandsideOimportedModule)
                                (_righthandsideOinferredDependencies)
                                (_righthandsideOinferredDependencies_collect)
                                (_righthandsideOinstancename)
                                (_righthandsideOlabels_collect)
                                (_righthandsideOlabels_dist)
                                (_righthandsideOlocal)
                                (_righthandsideOmethods_collect)
                                (_righthandsideOmethods_dist)
                                (_righthandsideOpresignatures)
                                (_righthandsideOpresignatures_collect)
                                (_righthandsideOsignatures)
                                (_righthandsideOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 166, column 8)
            (_righthandsideOtoplevel@_) =
                False
            -- use rule
            (_lhsObodyDependencies@_) =
                _righthandsideIbodyDependencies
            -- self rule
            (_self@_) =
                FunctionBinding_FunctionBinding _rangeIself _lefthandsideIself _righthandsideIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _righthandsideIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _righthandsideIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _righthandsideIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _righthandsideIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _righthandsideImethods_collect
            -- copy rule (up)
            (_lhsOname@_) =
                _lefthandsideIname
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _righthandsideIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_lefthandsideOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_lefthandsideOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_lefthandsideOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_lefthandsideOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_lefthandsideOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_lefthandsideOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_lefthandsideOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_lefthandsideOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_lefthandsideOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_lefthandsideOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_lefthandsideOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_lefthandsideOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_lefthandsideOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_lefthandsideOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_lefthandsideOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_righthandsideOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_righthandsideOconstructors_collect@_) =
                _lefthandsideIconstructors_collect
            -- copy rule (down)
            (_righthandsideOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_righthandsideOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_righthandsideOdependencies_collect@_) =
                _lefthandsideIdependencies_collect
            -- copy rule (down)
            (_righthandsideOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_righthandsideOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_righthandsideOinferredDependencies_collect@_) =
                _lefthandsideIinferredDependencies_collect
            -- copy rule (down)
            (_righthandsideOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_righthandsideOlabels_collect@_) =
                _lefthandsideIlabels_collect
            -- copy rule (down)
            (_righthandsideOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_righthandsideOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_righthandsideOmethods_collect@_) =
                _lefthandsideImethods_collect
            -- copy rule (down)
            (_righthandsideOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_righthandsideOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_righthandsideOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_righthandsideOsignatures@_) =
                _lhsIsignatures
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOpresignatures_collect,_lhsOself)
-- FunctionBindings --------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      bodyDependencies     : [(Name,Name)]
      name                 : Name
      self                 : SELF

-}
{-
   local variables for FunctionBindings.Cons:
      self

-}
{-
   local variables for FunctionBindings.Nil:
      self

-}
-- semantic domain
type T_FunctionBindings = (Maybe Name) ->
                          (FMap Name Names) ->
                          (FMap Name Names) ->
                          (Strings) ->
                          (FMap Name [(Name,Name)]) ->
                          (Bool) ->
                          (FMap Name [(Name,Name)]) ->
                          (FMap Name [(Name,Name)]) ->
                          (Maybe Name) ->
                          (FMap Name Names) ->
                          (FMap Name Names) ->
                          (Bool) ->
                          (FMap Name Names) ->
                          (FMap Name Names) ->
                          (PreSignatures) ->
                          (PreSignatures) ->
                          (Signatures) ->
                          (Bool) ->
                          ( ([(Name,Name)]),(FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(Name),(PreSignatures),(FunctionBindings))
-- cata
sem_FunctionBindings :: (FunctionBindings) ->
                        (T_FunctionBindings)
sem_FunctionBindings (list) =
    (foldr (sem_FunctionBindings_Cons) (sem_FunctionBindings_Nil) ((map sem_FunctionBinding list)))
sem_FunctionBindings_Cons :: (T_FunctionBinding) ->
                             (T_FunctionBindings) ->
                             (T_FunctionBindings)
sem_FunctionBindings_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (FunctionBindings)
            _hdIbodyDependencies :: ([(Name,Name)])
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdependencies_collect :: (FMap Name [(Name,Name)])
            _hdIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIname :: (Name)
            _hdIpresignatures_collect :: (PreSignatures)
            _hdIself :: (FunctionBinding)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies_collect :: (FMap Name [(Name,Name)])
            _hdOimportedModule :: (Bool)
            _hdOinferredDependencies :: (FMap Name [(Name,Name)])
            _hdOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdOinstancename :: (Maybe Name)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOpresignatures :: (PreSignatures)
            _hdOpresignatures_collect :: (PreSignatures)
            _hdOsignatures :: (Signatures)
            _hdOtoplevel :: (Bool)
            _tlIbodyDependencies :: ([(Name,Name)])
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdependencies_collect :: (FMap Name [(Name,Name)])
            _tlIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIname :: (Name)
            _tlIpresignatures_collect :: (PreSignatures)
            _tlIself :: (FunctionBindings)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies_collect :: (FMap Name [(Name,Name)])
            _tlOimportedModule :: (Bool)
            _tlOinferredDependencies :: (FMap Name [(Name,Name)])
            _tlOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOpresignatures :: (PreSignatures)
            _tlOpresignatures_collect :: (PreSignatures)
            _tlOsignatures :: (Signatures)
            _tlOtoplevel :: (Bool)
            ( _hdIbodyDependencies,_hdIconstructors_collect,_hdIdependencies_collect,_hdIinferredDependencies_collect,_hdIlabels_collect,_hdImethods_collect,_hdIname,_hdIpresignatures_collect,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOdependencies_collect) (_hdOimportedModule) (_hdOinferredDependencies) (_hdOinferredDependencies_collect) (_hdOinstancename) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOpresignatures) (_hdOpresignatures_collect) (_hdOsignatures) (_hdOtoplevel))
            ( _tlIbodyDependencies,_tlIconstructors_collect,_tlIdependencies_collect,_tlIinferredDependencies_collect,_tlIlabels_collect,_tlImethods_collect,_tlIname,_tlIpresignatures_collect,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOdependencies_collect) (_tlOimportedModule) (_tlOinferredDependencies) (_tlOinferredDependencies_collect) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOpresignatures) (_tlOpresignatures_collect) (_tlOsignatures) (_tlOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 397, column 9)
            (_lhsOname@_) =
                _hdIname
            -- use rule
            (_lhsObodyDependencies@_) =
                _hdIbodyDependencies ++ _tlIbodyDependencies
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _tlIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _tlIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _tlIpresignatures_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_hdOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_hdOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_hdOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_tlOdependencies_collect@_) =
                _hdIdependencies_collect
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_tlOinferredDependencies_collect@_) =
                _hdIinferredDependencies_collect
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_tlOpresignatures_collect@_) =
                _hdIpresignatures_collect
            -- copy rule (down)
            (_tlOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOpresignatures_collect,_lhsOself)
sem_FunctionBindings_Nil :: (T_FunctionBindings)
sem_FunctionBindings_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (FunctionBindings)
            -- "./ModuleInformation.inc.lag"(line 399, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.FunctionBindings.Nil.lhs.name: no bindings"
            -- use rule
            (_lhsObodyDependencies@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOpresignatures_collect,_lhsOself)
-- GuardedExpression -------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      bodyDependencies     : [(Name,Name)]
      self                 : SELF

-}
{-
   local variables for GuardedExpression.GuardedExpression:
      self

-}
-- semantic domain
type T_GuardedExpression = (Maybe Name) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Strings) ->
                           (FMap Name [(Name,Name)]) ->
                           (Bool) ->
                           (FMap Name [(Name,Name)]) ->
                           (FMap Name [(Name,Name)]) ->
                           (Maybe Name) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Bool) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (PreSignatures) ->
                           (PreSignatures) ->
                           (Signatures) ->
                           (Bool) ->
                           ( ([(Name,Name)]),(FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(PreSignatures),(GuardedExpression))
-- cata
sem_GuardedExpression :: (GuardedExpression) ->
                         (T_GuardedExpression)
sem_GuardedExpression ((GuardedExpression_GuardedExpression (_range) (_guard) (_expression))) =
    (sem_GuardedExpression_GuardedExpression ((sem_Range (_range))) ((sem_Expression (_guard))) ((sem_Expression (_expression))))
sem_GuardedExpression_GuardedExpression :: (T_Range) ->
                                           (T_Expression) ->
                                           (T_Expression) ->
                                           (T_GuardedExpression)
sem_GuardedExpression_GuardedExpression (range_) (guard_) (expression_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (GuardedExpression)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _guardIbodyDependencies :: ([(Name,Name)])
            _guardIconstructors_collect :: (FMap Name Names)
            _guardIdependencies_collect :: (FMap Name [(Name,Name)])
            _guardIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _guardIlabels_collect :: (FMap Name Names)
            _guardImethods_collect :: (FMap Name Names)
            _guardIpresignatures_collect :: (PreSignatures)
            _guardIself :: (Expression)
            _guardOclassname :: (Maybe Name)
            _guardOconstructors_collect :: (FMap Name Names)
            _guardOconstructors_dist :: (FMap Name Names)
            _guardOcurrentModule :: (Strings)
            _guardOdependencies_collect :: (FMap Name [(Name,Name)])
            _guardOimportedModule :: (Bool)
            _guardOinferredDependencies :: (FMap Name [(Name,Name)])
            _guardOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _guardOinstancename :: (Maybe Name)
            _guardOlabels_collect :: (FMap Name Names)
            _guardOlabels_dist :: (FMap Name Names)
            _guardOlocal :: (Bool)
            _guardOmethods_collect :: (FMap Name Names)
            _guardOmethods_dist :: (FMap Name Names)
            _guardOpresignatures :: (PreSignatures)
            _guardOpresignatures_collect :: (PreSignatures)
            _guardOsignatures :: (Signatures)
            _guardOtoplevel :: (Bool)
            _expressionIbodyDependencies :: ([(Name,Name)])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOimportedModule :: (Bool)
            _expressionOinferredDependencies :: (FMap Name [(Name,Name)])
            _expressionOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOinstancename :: (Maybe Name)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOsignatures :: (Signatures)
            _expressionOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _guardIbodyDependencies,_guardIconstructors_collect,_guardIdependencies_collect,_guardIinferredDependencies_collect,_guardIlabels_collect,_guardImethods_collect,_guardIpresignatures_collect,_guardIself) =
                (guard_ (_guardOclassname)
                        (_guardOconstructors_collect)
                        (_guardOconstructors_dist)
                        (_guardOcurrentModule)
                        (_guardOdependencies_collect)
                        (_guardOimportedModule)
                        (_guardOinferredDependencies)
                        (_guardOinferredDependencies_collect)
                        (_guardOinstancename)
                        (_guardOlabels_collect)
                        (_guardOlabels_dist)
                        (_guardOlocal)
                        (_guardOmethods_collect)
                        (_guardOmethods_dist)
                        (_guardOpresignatures)
                        (_guardOpresignatures_collect)
                        (_guardOsignatures)
                        (_guardOtoplevel))
            ( _expressionIbodyDependencies,_expressionIconstructors_collect,_expressionIdependencies_collect,_expressionIinferredDependencies_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionIpresignatures_collect,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies_collect)
                             (_expressionOimportedModule)
                             (_expressionOinferredDependencies)
                             (_expressionOinferredDependencies_collect)
                             (_expressionOinstancename)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOsignatures)
                             (_expressionOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _guardIbodyDependencies ++ _expressionIbodyDependencies
            -- self rule
            (_self@_) =
                GuardedExpression_GuardedExpression _rangeIself _guardIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _expressionIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _expressionIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_guardOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_guardOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_guardOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_guardOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_guardOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_guardOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_guardOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_guardOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_guardOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_guardOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_guardOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_guardOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_guardOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_guardOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_guardOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_guardOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_guardOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_guardOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_expressionOconstructors_collect@_) =
                _guardIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_expressionOdependencies_collect@_) =
                _guardIdependencies_collect
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_expressionOinferredDependencies_collect@_) =
                _guardIinferredDependencies_collect
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_expressionOlabels_collect@_) =
                _guardIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_expressionOmethods_collect@_) =
                _guardImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_expressionOpresignatures_collect@_) =
                _guardIpresignatures_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- GuardedExpressions ------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      bodyDependencies     : [(Name,Name)]
      self                 : SELF

-}
{-
   local variables for GuardedExpressions.Cons:
      self

-}
{-
   local variables for GuardedExpressions.Nil:
      self

-}
-- semantic domain
type T_GuardedExpressions = (Maybe Name) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Strings) ->
                            (FMap Name [(Name,Name)]) ->
                            (Bool) ->
                            (FMap Name [(Name,Name)]) ->
                            (FMap Name [(Name,Name)]) ->
                            (Maybe Name) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Bool) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (PreSignatures) ->
                            (PreSignatures) ->
                            (Signatures) ->
                            (Bool) ->
                            ( ([(Name,Name)]),(FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(PreSignatures),(GuardedExpressions))
-- cata
sem_GuardedExpressions :: (GuardedExpressions) ->
                          (T_GuardedExpressions)
sem_GuardedExpressions (list) =
    (foldr (sem_GuardedExpressions_Cons) (sem_GuardedExpressions_Nil) ((map sem_GuardedExpression list)))
sem_GuardedExpressions_Cons :: (T_GuardedExpression) ->
                               (T_GuardedExpressions) ->
                               (T_GuardedExpressions)
sem_GuardedExpressions_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (GuardedExpressions)
            _hdIbodyDependencies :: ([(Name,Name)])
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdependencies_collect :: (FMap Name [(Name,Name)])
            _hdIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIpresignatures_collect :: (PreSignatures)
            _hdIself :: (GuardedExpression)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies_collect :: (FMap Name [(Name,Name)])
            _hdOimportedModule :: (Bool)
            _hdOinferredDependencies :: (FMap Name [(Name,Name)])
            _hdOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdOinstancename :: (Maybe Name)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOpresignatures :: (PreSignatures)
            _hdOpresignatures_collect :: (PreSignatures)
            _hdOsignatures :: (Signatures)
            _hdOtoplevel :: (Bool)
            _tlIbodyDependencies :: ([(Name,Name)])
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdependencies_collect :: (FMap Name [(Name,Name)])
            _tlIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIpresignatures_collect :: (PreSignatures)
            _tlIself :: (GuardedExpressions)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies_collect :: (FMap Name [(Name,Name)])
            _tlOimportedModule :: (Bool)
            _tlOinferredDependencies :: (FMap Name [(Name,Name)])
            _tlOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOpresignatures :: (PreSignatures)
            _tlOpresignatures_collect :: (PreSignatures)
            _tlOsignatures :: (Signatures)
            _tlOtoplevel :: (Bool)
            ( _hdIbodyDependencies,_hdIconstructors_collect,_hdIdependencies_collect,_hdIinferredDependencies_collect,_hdIlabels_collect,_hdImethods_collect,_hdIpresignatures_collect,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOdependencies_collect) (_hdOimportedModule) (_hdOinferredDependencies) (_hdOinferredDependencies_collect) (_hdOinstancename) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOpresignatures) (_hdOpresignatures_collect) (_hdOsignatures) (_hdOtoplevel))
            ( _tlIbodyDependencies,_tlIconstructors_collect,_tlIdependencies_collect,_tlIinferredDependencies_collect,_tlIlabels_collect,_tlImethods_collect,_tlIpresignatures_collect,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOdependencies_collect) (_tlOimportedModule) (_tlOinferredDependencies) (_tlOinferredDependencies_collect) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOpresignatures) (_tlOpresignatures_collect) (_tlOsignatures) (_tlOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _hdIbodyDependencies ++ _tlIbodyDependencies
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _tlIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _tlIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _tlIpresignatures_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_hdOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_hdOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_hdOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_tlOdependencies_collect@_) =
                _hdIdependencies_collect
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_tlOinferredDependencies_collect@_) =
                _hdIinferredDependencies_collect
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_tlOpresignatures_collect@_) =
                _hdIpresignatures_collect
            -- copy rule (down)
            (_tlOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_GuardedExpressions_Nil :: (T_GuardedExpressions)
sem_GuardedExpressions_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (GuardedExpressions)
            -- use rule
            (_lhsObodyDependencies@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- Import ------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Import.TypeOrClass:
      self

-}
{-
   local variables for Import.TypeOrClassComplete:
      self

-}
{-
   local variables for Import.Variable:
      self

-}
-- semantic domain
type T_Import = (Maybe Name) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (Strings) ->
                (FMap Name [(Name,Name)]) ->
                (Bool) ->
                (FMap Name [(Name,Name)]) ->
                (FMap Name [(Name,Name)]) ->
                (Maybe Name) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (Bool) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (PreSignatures) ->
                (PreSignatures) ->
                (Signatures) ->
                (Bool) ->
                ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(PreSignatures),(Import))
-- cata
sem_Import :: (Import) ->
              (T_Import)
sem_Import ((Import_TypeOrClass (_range) (_name) (_names))) =
    (sem_Import_TypeOrClass ((sem_Range (_range))) ((sem_Name (_name))) ((sem_MaybeNames (_names))))
sem_Import ((Import_TypeOrClassComplete (_range) (_name))) =
    (sem_Import_TypeOrClassComplete ((sem_Range (_range))) ((sem_Name (_name))))
sem_Import ((Import_Variable (_range) (_name))) =
    (sem_Import_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Import_TypeOrClass :: (T_Range) ->
                          (T_Name) ->
                          (T_MaybeNames) ->
                          (T_Import)
sem_Import_TypeOrClass (range_) (name_) (names_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Import)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _namesIconstructors_collect :: (FMap Name Names)
            _namesIdependencies_collect :: (FMap Name [(Name,Name)])
            _namesIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _namesIlabels_collect :: (FMap Name Names)
            _namesImethods_collect :: (FMap Name Names)
            _namesIself :: (MaybeNames)
            _namesOclassname :: (Maybe Name)
            _namesOconstructors_collect :: (FMap Name Names)
            _namesOconstructors_dist :: (FMap Name Names)
            _namesOcurrentModule :: (Strings)
            _namesOdependencies_collect :: (FMap Name [(Name,Name)])
            _namesOimportedModule :: (Bool)
            _namesOinferredDependencies :: (FMap Name [(Name,Name)])
            _namesOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _namesOinstancename :: (Maybe Name)
            _namesOlabels_collect :: (FMap Name Names)
            _namesOlabels_dist :: (FMap Name Names)
            _namesOlocal :: (Bool)
            _namesOmethods_collect :: (FMap Name Names)
            _namesOmethods_dist :: (FMap Name Names)
            _namesOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _namesIconstructors_collect,_namesIdependencies_collect,_namesIinferredDependencies_collect,_namesIlabels_collect,_namesImethods_collect,_namesIself) =
                (names_ (_namesOclassname) (_namesOconstructors_collect) (_namesOconstructors_dist) (_namesOcurrentModule) (_namesOdependencies_collect) (_namesOimportedModule) (_namesOinferredDependencies) (_namesOinferredDependencies_collect) (_namesOinstancename) (_namesOlabels_collect) (_namesOlabels_dist) (_namesOlocal) (_namesOmethods_collect) (_namesOmethods_dist) (_namesOtoplevel))
            -- self rule
            (_self@_) =
                Import_TypeOrClass _rangeIself _nameIself _namesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _namesIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _namesIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _namesIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _namesIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _namesImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_namesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_namesOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_namesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_namesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_namesOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_namesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_namesOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_namesOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_namesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_namesOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_namesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_namesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_namesOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_namesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_namesOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Import_TypeOrClassComplete :: (T_Range) ->
                                  (T_Name) ->
                                  (T_Import)
sem_Import_TypeOrClassComplete (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Import)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            -- self rule
            (_self@_) =
                Import_TypeOrClassComplete _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Import_Variable :: (T_Range) ->
                       (T_Name) ->
                       (T_Import)
sem_Import_Variable (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Import)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            -- self rule
            (_self@_) =
                Import_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- ImportDeclaration -------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for ImportDeclaration.Empty:
      self

-}
{-
   local variables for ImportDeclaration.Import:
      local
      currentModule
      self

-}
-- semantic domain
type T_ImportDeclaration = (Maybe Name) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Strings) ->
                           (FMap Name [(Name,Name)]) ->
                           (Bool) ->
                           (FMap Name [(Name,Name)]) ->
                           (FMap Name [(Name,Name)]) ->
                           (Maybe Name) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Bool) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (PreSignatures) ->
                           (PreSignatures) ->
                           (Signatures) ->
                           (Bool) ->
                           ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(PreSignatures),(ImportDeclaration))
-- cata
sem_ImportDeclaration :: (ImportDeclaration) ->
                         (T_ImportDeclaration)
sem_ImportDeclaration ((ImportDeclaration_Empty (_range))) =
    (sem_ImportDeclaration_Empty ((sem_Range (_range))))
sem_ImportDeclaration ((ImportDeclaration_Import (_range) (_qualified) (_name) (_asname) (_importspecification))) =
    (sem_ImportDeclaration_Import ((sem_Range (_range))) (_qualified) ((sem_ModuleName (_name))) ((sem_MaybeModuleName (_asname))) ((sem_MaybeImportSpecification (_importspecification))))
sem_ImportDeclaration_Empty :: (T_Range) ->
                               (T_ImportDeclaration)
sem_ImportDeclaration_Empty (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (ImportDeclaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- self rule
            (_self@_) =
                ImportDeclaration_Empty _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_ImportDeclaration_Import :: (T_Range) ->
                                (Bool) ->
                                (T_ModuleName) ->
                                (T_MaybeModuleName) ->
                                (T_MaybeImportSpecification) ->
                                (T_ImportDeclaration)
sem_ImportDeclaration_Import (range_) (qualified_) (name_) (asname_) (importspecification_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (ImportDeclaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (ModuleName)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _asnameIconstructors_collect :: (FMap Name Names)
            _asnameIdependencies_collect :: (FMap Name [(Name,Name)])
            _asnameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _asnameIlabels_collect :: (FMap Name Names)
            _asnameImethods_collect :: (FMap Name Names)
            _asnameIself :: (MaybeModuleName)
            _asnameOclassname :: (Maybe Name)
            _asnameOconstructors_collect :: (FMap Name Names)
            _asnameOconstructors_dist :: (FMap Name Names)
            _asnameOcurrentModule :: (Strings)
            _asnameOdependencies_collect :: (FMap Name [(Name,Name)])
            _asnameOimportedModule :: (Bool)
            _asnameOinferredDependencies :: (FMap Name [(Name,Name)])
            _asnameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _asnameOinstancename :: (Maybe Name)
            _asnameOlabels_collect :: (FMap Name Names)
            _asnameOlabels_dist :: (FMap Name Names)
            _asnameOlocal :: (Bool)
            _asnameOmethods_collect :: (FMap Name Names)
            _asnameOmethods_dist :: (FMap Name Names)
            _asnameOtoplevel :: (Bool)
            _importspecificationIconstructors_collect :: (FMap Name Names)
            _importspecificationIdependencies_collect :: (FMap Name [(Name,Name)])
            _importspecificationIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _importspecificationIlabels_collect :: (FMap Name Names)
            _importspecificationImethods_collect :: (FMap Name Names)
            _importspecificationIpresignatures_collect :: (PreSignatures)
            _importspecificationIself :: (MaybeImportSpecification)
            _importspecificationOclassname :: (Maybe Name)
            _importspecificationOconstructors_collect :: (FMap Name Names)
            _importspecificationOconstructors_dist :: (FMap Name Names)
            _importspecificationOcurrentModule :: (Strings)
            _importspecificationOdependencies_collect :: (FMap Name [(Name,Name)])
            _importspecificationOimportedModule :: (Bool)
            _importspecificationOinferredDependencies :: (FMap Name [(Name,Name)])
            _importspecificationOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _importspecificationOinstancename :: (Maybe Name)
            _importspecificationOlabels_collect :: (FMap Name Names)
            _importspecificationOlabels_dist :: (FMap Name Names)
            _importspecificationOlocal :: (Bool)
            _importspecificationOmethods_collect :: (FMap Name Names)
            _importspecificationOmethods_dist :: (FMap Name Names)
            _importspecificationOpresignatures :: (PreSignatures)
            _importspecificationOpresignatures_collect :: (PreSignatures)
            _importspecificationOsignatures :: (Signatures)
            _importspecificationOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _asnameIconstructors_collect,_asnameIdependencies_collect,_asnameIinferredDependencies_collect,_asnameIlabels_collect,_asnameImethods_collect,_asnameIself) =
                (asname_ (_asnameOclassname) (_asnameOconstructors_collect) (_asnameOconstructors_dist) (_asnameOcurrentModule) (_asnameOdependencies_collect) (_asnameOimportedModule) (_asnameOinferredDependencies) (_asnameOinferredDependencies_collect) (_asnameOinstancename) (_asnameOlabels_collect) (_asnameOlabels_dist) (_asnameOlocal) (_asnameOmethods_collect) (_asnameOmethods_dist) (_asnameOtoplevel))
            ( _importspecificationIconstructors_collect,_importspecificationIdependencies_collect,_importspecificationIinferredDependencies_collect,_importspecificationIlabels_collect,_importspecificationImethods_collect,_importspecificationIpresignatures_collect,_importspecificationIself) =
                (importspecification_ (_importspecificationOclassname)
                                      (_importspecificationOconstructors_collect)
                                      (_importspecificationOconstructors_dist)
                                      (_importspecificationOcurrentModule)
                                      (_importspecificationOdependencies_collect)
                                      (_importspecificationOimportedModule)
                                      (_importspecificationOinferredDependencies)
                                      (_importspecificationOinferredDependencies_collect)
                                      (_importspecificationOinstancename)
                                      (_importspecificationOlabels_collect)
                                      (_importspecificationOlabels_dist)
                                      (_importspecificationOlocal)
                                      (_importspecificationOmethods_collect)
                                      (_importspecificationOmethods_dist)
                                      (_importspecificationOpresignatures)
                                      (_importspecificationOpresignatures_collect)
                                      (_importspecificationOsignatures)
                                      (_importspecificationOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 118, column 8)
            (_local@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 117, column 8)
            (_currentModule@_) =
                getModuleName _nameIself
            -- self rule
            (_self@_) =
                ImportDeclaration_Import _rangeIself qualified_ _nameIself _asnameIself _importspecificationIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _importspecificationIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _importspecificationIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _importspecificationIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _importspecificationIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _importspecificationImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _importspecificationIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_rangeOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_rangeOlocal@_) =
                _local
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_nameOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_nameOlocal@_) =
                _local
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_asnameOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_asnameOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_asnameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_asnameOcurrentModule@_) =
                _currentModule
            -- copy rule (chain)
            (_asnameOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_asnameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_asnameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_asnameOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_asnameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_asnameOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_asnameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_asnameOlocal@_) =
                _local
            -- copy rule (chain)
            (_asnameOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_asnameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_asnameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_importspecificationOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_importspecificationOconstructors_collect@_) =
                _asnameIconstructors_collect
            -- copy rule (down)
            (_importspecificationOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_importspecificationOcurrentModule@_) =
                _currentModule
            -- copy rule (chain)
            (_importspecificationOdependencies_collect@_) =
                _asnameIdependencies_collect
            -- copy rule (down)
            (_importspecificationOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_importspecificationOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_importspecificationOinferredDependencies_collect@_) =
                _asnameIinferredDependencies_collect
            -- copy rule (down)
            (_importspecificationOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_importspecificationOlabels_collect@_) =
                _asnameIlabels_collect
            -- copy rule (down)
            (_importspecificationOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_importspecificationOlocal@_) =
                _local
            -- copy rule (chain)
            (_importspecificationOmethods_collect@_) =
                _asnameImethods_collect
            -- copy rule (down)
            (_importspecificationOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_importspecificationOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_importspecificationOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_importspecificationOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_importspecificationOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- ImportDeclarations ------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for ImportDeclarations.Cons:
      self

-}
{-
   local variables for ImportDeclarations.Nil:
      self

-}
-- semantic domain
type T_ImportDeclarations = (Maybe Name) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Strings) ->
                            (FMap Name [(Name,Name)]) ->
                            (Bool) ->
                            (FMap Name [(Name,Name)]) ->
                            (FMap Name [(Name,Name)]) ->
                            (Maybe Name) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Bool) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (PreSignatures) ->
                            (PreSignatures) ->
                            (Signatures) ->
                            (Bool) ->
                            ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(PreSignatures),(ImportDeclarations))
-- cata
sem_ImportDeclarations :: (ImportDeclarations) ->
                          (T_ImportDeclarations)
sem_ImportDeclarations (list) =
    (foldr (sem_ImportDeclarations_Cons) (sem_ImportDeclarations_Nil) ((map sem_ImportDeclaration list)))
sem_ImportDeclarations_Cons :: (T_ImportDeclaration) ->
                               (T_ImportDeclarations) ->
                               (T_ImportDeclarations)
sem_ImportDeclarations_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (ImportDeclarations)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdependencies_collect :: (FMap Name [(Name,Name)])
            _hdIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIpresignatures_collect :: (PreSignatures)
            _hdIself :: (ImportDeclaration)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies_collect :: (FMap Name [(Name,Name)])
            _hdOimportedModule :: (Bool)
            _hdOinferredDependencies :: (FMap Name [(Name,Name)])
            _hdOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdOinstancename :: (Maybe Name)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOpresignatures :: (PreSignatures)
            _hdOpresignatures_collect :: (PreSignatures)
            _hdOsignatures :: (Signatures)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdependencies_collect :: (FMap Name [(Name,Name)])
            _tlIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIpresignatures_collect :: (PreSignatures)
            _tlIself :: (ImportDeclarations)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies_collect :: (FMap Name [(Name,Name)])
            _tlOimportedModule :: (Bool)
            _tlOinferredDependencies :: (FMap Name [(Name,Name)])
            _tlOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOpresignatures :: (PreSignatures)
            _tlOpresignatures_collect :: (PreSignatures)
            _tlOsignatures :: (Signatures)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIdependencies_collect,_hdIinferredDependencies_collect,_hdIlabels_collect,_hdImethods_collect,_hdIpresignatures_collect,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOdependencies_collect) (_hdOimportedModule) (_hdOinferredDependencies) (_hdOinferredDependencies_collect) (_hdOinstancename) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOpresignatures) (_hdOpresignatures_collect) (_hdOsignatures) (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIdependencies_collect,_tlIinferredDependencies_collect,_tlIlabels_collect,_tlImethods_collect,_tlIpresignatures_collect,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOdependencies_collect) (_tlOimportedModule) (_tlOinferredDependencies) (_tlOinferredDependencies_collect) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOpresignatures) (_tlOpresignatures_collect) (_tlOsignatures) (_tlOtoplevel))
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _tlIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _tlIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _tlIpresignatures_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_hdOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_hdOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_hdOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_tlOdependencies_collect@_) =
                _hdIdependencies_collect
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_tlOinferredDependencies_collect@_) =
                _hdIinferredDependencies_collect
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_tlOpresignatures_collect@_) =
                _hdIpresignatures_collect
            -- copy rule (down)
            (_tlOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_ImportDeclarations_Nil :: (T_ImportDeclarations)
sem_ImportDeclarations_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (ImportDeclarations)
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- ImportSpecification -----------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for ImportSpecification.Import:
      self

-}
-- semantic domain
type T_ImportSpecification = (Maybe Name) ->
                             (FMap Name Names) ->
                             (FMap Name Names) ->
                             (Strings) ->
                             (FMap Name [(Name,Name)]) ->
                             (Bool) ->
                             (FMap Name [(Name,Name)]) ->
                             (FMap Name [(Name,Name)]) ->
                             (Maybe Name) ->
                             (FMap Name Names) ->
                             (FMap Name Names) ->
                             (Bool) ->
                             (FMap Name Names) ->
                             (FMap Name Names) ->
                             (PreSignatures) ->
                             (PreSignatures) ->
                             (Signatures) ->
                             (Bool) ->
                             ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(PreSignatures),(ImportSpecification))
-- cata
sem_ImportSpecification :: (ImportSpecification) ->
                           (T_ImportSpecification)
sem_ImportSpecification ((ImportSpecification_Import (_range) (_hiding) (_imports))) =
    (sem_ImportSpecification_Import ((sem_Range (_range))) (_hiding) ((sem_Imports (_imports))))
sem_ImportSpecification_Import :: (T_Range) ->
                                  (Bool) ->
                                  (T_Imports) ->
                                  (T_ImportSpecification)
sem_ImportSpecification_Import (range_) (hiding_) (imports_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (ImportSpecification)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _importsIconstructors_collect :: (FMap Name Names)
            _importsIdependencies_collect :: (FMap Name [(Name,Name)])
            _importsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _importsIlabels_collect :: (FMap Name Names)
            _importsImethods_collect :: (FMap Name Names)
            _importsIpresignatures_collect :: (PreSignatures)
            _importsIself :: (Imports)
            _importsOclassname :: (Maybe Name)
            _importsOconstructors_collect :: (FMap Name Names)
            _importsOconstructors_dist :: (FMap Name Names)
            _importsOcurrentModule :: (Strings)
            _importsOdependencies_collect :: (FMap Name [(Name,Name)])
            _importsOimportedModule :: (Bool)
            _importsOinferredDependencies :: (FMap Name [(Name,Name)])
            _importsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _importsOinstancename :: (Maybe Name)
            _importsOlabels_collect :: (FMap Name Names)
            _importsOlabels_dist :: (FMap Name Names)
            _importsOlocal :: (Bool)
            _importsOmethods_collect :: (FMap Name Names)
            _importsOmethods_dist :: (FMap Name Names)
            _importsOpresignatures :: (PreSignatures)
            _importsOpresignatures_collect :: (PreSignatures)
            _importsOsignatures :: (Signatures)
            _importsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _importsIconstructors_collect,_importsIdependencies_collect,_importsIinferredDependencies_collect,_importsIlabels_collect,_importsImethods_collect,_importsIpresignatures_collect,_importsIself) =
                (imports_ (_importsOclassname)
                          (_importsOconstructors_collect)
                          (_importsOconstructors_dist)
                          (_importsOcurrentModule)
                          (_importsOdependencies_collect)
                          (_importsOimportedModule)
                          (_importsOinferredDependencies)
                          (_importsOinferredDependencies_collect)
                          (_importsOinstancename)
                          (_importsOlabels_collect)
                          (_importsOlabels_dist)
                          (_importsOlocal)
                          (_importsOmethods_collect)
                          (_importsOmethods_dist)
                          (_importsOpresignatures)
                          (_importsOpresignatures_collect)
                          (_importsOsignatures)
                          (_importsOtoplevel))
            -- self rule
            (_self@_) =
                ImportSpecification_Import _rangeIself hiding_ _importsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _importsIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _importsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _importsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _importsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _importsImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _importsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_importsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_importsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_importsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_importsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_importsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_importsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_importsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_importsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_importsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_importsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_importsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_importsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_importsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_importsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_importsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_importsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_importsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_importsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- Imports -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Imports.Cons:
      self

-}
{-
   local variables for Imports.Nil:
      self

-}
-- semantic domain
type T_Imports = (Maybe Name) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Strings) ->
                 (FMap Name [(Name,Name)]) ->
                 (Bool) ->
                 (FMap Name [(Name,Name)]) ->
                 (FMap Name [(Name,Name)]) ->
                 (Maybe Name) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Bool) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (PreSignatures) ->
                 (PreSignatures) ->
                 (Signatures) ->
                 (Bool) ->
                 ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(PreSignatures),(Imports))
-- cata
sem_Imports :: (Imports) ->
               (T_Imports)
sem_Imports (list) =
    (foldr (sem_Imports_Cons) (sem_Imports_Nil) ((map sem_Import list)))
sem_Imports_Cons :: (T_Import) ->
                    (T_Imports) ->
                    (T_Imports)
sem_Imports_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Imports)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdependencies_collect :: (FMap Name [(Name,Name)])
            _hdIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIpresignatures_collect :: (PreSignatures)
            _hdIself :: (Import)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies_collect :: (FMap Name [(Name,Name)])
            _hdOimportedModule :: (Bool)
            _hdOinferredDependencies :: (FMap Name [(Name,Name)])
            _hdOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdOinstancename :: (Maybe Name)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOpresignatures :: (PreSignatures)
            _hdOpresignatures_collect :: (PreSignatures)
            _hdOsignatures :: (Signatures)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdependencies_collect :: (FMap Name [(Name,Name)])
            _tlIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIpresignatures_collect :: (PreSignatures)
            _tlIself :: (Imports)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies_collect :: (FMap Name [(Name,Name)])
            _tlOimportedModule :: (Bool)
            _tlOinferredDependencies :: (FMap Name [(Name,Name)])
            _tlOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOpresignatures :: (PreSignatures)
            _tlOpresignatures_collect :: (PreSignatures)
            _tlOsignatures :: (Signatures)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIdependencies_collect,_hdIinferredDependencies_collect,_hdIlabels_collect,_hdImethods_collect,_hdIpresignatures_collect,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOdependencies_collect) (_hdOimportedModule) (_hdOinferredDependencies) (_hdOinferredDependencies_collect) (_hdOinstancename) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOpresignatures) (_hdOpresignatures_collect) (_hdOsignatures) (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIdependencies_collect,_tlIinferredDependencies_collect,_tlIlabels_collect,_tlImethods_collect,_tlIpresignatures_collect,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOdependencies_collect) (_tlOimportedModule) (_tlOinferredDependencies) (_tlOinferredDependencies_collect) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOpresignatures) (_tlOpresignatures_collect) (_tlOsignatures) (_tlOtoplevel))
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _tlIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _tlIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _tlIpresignatures_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_hdOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_hdOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_hdOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_tlOdependencies_collect@_) =
                _hdIdependencies_collect
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_tlOinferredDependencies_collect@_) =
                _hdIinferredDependencies_collect
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_tlOpresignatures_collect@_) =
                _hdIpresignatures_collect
            -- copy rule (down)
            (_tlOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Imports_Nil :: (T_Imports)
sem_Imports_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Imports)
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- InterfaceDeclaration ----------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for InterfaceDeclaration.Abstract:
      self

-}
{-
   local variables for InterfaceDeclaration.Binding:
      self

-}
{-
   local variables for InterfaceDeclaration.Consig:
      self

-}
{-
   local variables for InterfaceDeclaration.Declarations:
      self

-}
{-
   local variables for InterfaceDeclaration.Dependency:
      self

-}
{-
   local variables for InterfaceDeclaration.Import:
      self

-}
{-
   local variables for InterfaceDeclaration.SetModule:
      currentModule
      self

-}
-- semantic domain
type T_InterfaceDeclaration = (Maybe Name) ->
                              (FMap Name Names) ->
                              (FMap Name Names) ->
                              (Strings) ->
                              (FMap Name [(Name,Name)]) ->
                              (Bool) ->
                              (FMap Name [(Name,Name)]) ->
                              (FMap Name [(Name,Name)]) ->
                              (Maybe Name) ->
                              (FMap Name Names) ->
                              (FMap Name Names) ->
                              (Bool) ->
                              (FMap Name Names) ->
                              (FMap Name Names) ->
                              (PreSignatures) ->
                              (PreSignatures) ->
                              (Signatures) ->
                              (Bool) ->
                              ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(PreSignatures),(InterfaceDeclaration))
-- cata
sem_InterfaceDeclaration :: (InterfaceDeclaration) ->
                            (T_InterfaceDeclaration)
sem_InterfaceDeclaration ((InterfaceDeclaration_Abstract (_range) (_name) (_constructors) (_types) (_kind))) =
    (sem_InterfaceDeclaration_Abstract ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Names (_constructors))) ((sem_Types (_types))) ((sem_Kind (_kind))))
sem_InterfaceDeclaration ((InterfaceDeclaration_Binding (_range) (_name))) =
    (sem_InterfaceDeclaration_Binding ((sem_Range (_range))) ((sem_Name (_name))))
sem_InterfaceDeclaration ((InterfaceDeclaration_Consig (_range) (_typelevel) (_name) (_types))) =
    (sem_InterfaceDeclaration_Consig ((sem_Range (_range))) (_typelevel) ((sem_Name (_name))) ((sem_TypeArguments (_types))))
sem_InterfaceDeclaration ((InterfaceDeclaration_Declarations (_range) (_declarations))) =
    (sem_InterfaceDeclaration_Declarations ((sem_Range (_range))) ((sem_Declarations (_declarations))))
sem_InterfaceDeclaration ((InterfaceDeclaration_Dependency (_range) (_name) (_kind) (_bindings))) =
    (sem_InterfaceDeclaration_Dependency ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Kind (_kind))) ((sem_DependencyBindings (_bindings))))
sem_InterfaceDeclaration ((InterfaceDeclaration_Import (_range) (_module))) =
    (sem_InterfaceDeclaration_Import ((sem_Range (_range))) ((sem_ModuleName (_module))))
sem_InterfaceDeclaration ((InterfaceDeclaration_SetModule (_range) (_module) (_declarations))) =
    (sem_InterfaceDeclaration_SetModule ((sem_Range (_range))) ((sem_ModuleName (_module))) ((sem_InterfaceDeclarations (_declarations))))
sem_InterfaceDeclaration_Abstract :: (T_Range) ->
                                     (T_Name) ->
                                     (T_Names) ->
                                     (T_Types) ->
                                     (T_Kind) ->
                                     (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Abstract (range_) (name_) (constructors_) (types_) (kind_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (InterfaceDeclaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _constructorsIconstructors_collect :: (FMap Name Names)
            _constructorsIdependencies_collect :: (FMap Name [(Name,Name)])
            _constructorsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _constructorsIlabels_collect :: (FMap Name Names)
            _constructorsImethods_collect :: (FMap Name Names)
            _constructorsIself :: (Names)
            _constructorsOclassname :: (Maybe Name)
            _constructorsOconstructors_collect :: (FMap Name Names)
            _constructorsOconstructors_dist :: (FMap Name Names)
            _constructorsOcurrentModule :: (Strings)
            _constructorsOdependencies_collect :: (FMap Name [(Name,Name)])
            _constructorsOimportedModule :: (Bool)
            _constructorsOinferredDependencies :: (FMap Name [(Name,Name)])
            _constructorsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _constructorsOinstancename :: (Maybe Name)
            _constructorsOlabels_collect :: (FMap Name Names)
            _constructorsOlabels_dist :: (FMap Name Names)
            _constructorsOlocal :: (Bool)
            _constructorsOmethods_collect :: (FMap Name Names)
            _constructorsOmethods_dist :: (FMap Name Names)
            _constructorsOtoplevel :: (Bool)
            _typesIconstructors_collect :: (FMap Name Names)
            _typesIdependencies_collect :: (FMap Name [(Name,Name)])
            _typesIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typesIlabels_collect :: (FMap Name Names)
            _typesImethods_collect :: (FMap Name Names)
            _typesIself :: (Types)
            _typesOclassname :: (Maybe Name)
            _typesOconstructors_collect :: (FMap Name Names)
            _typesOconstructors_dist :: (FMap Name Names)
            _typesOcurrentModule :: (Strings)
            _typesOdependencies_collect :: (FMap Name [(Name,Name)])
            _typesOimportedModule :: (Bool)
            _typesOinferredDependencies :: (FMap Name [(Name,Name)])
            _typesOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typesOinstancename :: (Maybe Name)
            _typesOlabels_collect :: (FMap Name Names)
            _typesOlabels_dist :: (FMap Name Names)
            _typesOlocal :: (Bool)
            _typesOmethods_collect :: (FMap Name Names)
            _typesOmethods_dist :: (FMap Name Names)
            _typesOtoplevel :: (Bool)
            _kindIconstructors_collect :: (FMap Name Names)
            _kindIdependencies_collect :: (FMap Name [(Name,Name)])
            _kindIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _kindIlabels_collect :: (FMap Name Names)
            _kindImethods_collect :: (FMap Name Names)
            _kindIself :: (Kind)
            _kindOclassname :: (Maybe Name)
            _kindOconstructors_collect :: (FMap Name Names)
            _kindOconstructors_dist :: (FMap Name Names)
            _kindOcurrentModule :: (Strings)
            _kindOdependencies_collect :: (FMap Name [(Name,Name)])
            _kindOimportedModule :: (Bool)
            _kindOinferredDependencies :: (FMap Name [(Name,Name)])
            _kindOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _kindOinstancename :: (Maybe Name)
            _kindOlabels_collect :: (FMap Name Names)
            _kindOlabels_dist :: (FMap Name Names)
            _kindOlocal :: (Bool)
            _kindOmethods_collect :: (FMap Name Names)
            _kindOmethods_dist :: (FMap Name Names)
            _kindOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _constructorsIconstructors_collect,_constructorsIdependencies_collect,_constructorsIinferredDependencies_collect,_constructorsIlabels_collect,_constructorsImethods_collect,_constructorsIself) =
                (constructors_ (_constructorsOclassname)
                               (_constructorsOconstructors_collect)
                               (_constructorsOconstructors_dist)
                               (_constructorsOcurrentModule)
                               (_constructorsOdependencies_collect)
                               (_constructorsOimportedModule)
                               (_constructorsOinferredDependencies)
                               (_constructorsOinferredDependencies_collect)
                               (_constructorsOinstancename)
                               (_constructorsOlabels_collect)
                               (_constructorsOlabels_dist)
                               (_constructorsOlocal)
                               (_constructorsOmethods_collect)
                               (_constructorsOmethods_dist)
                               (_constructorsOtoplevel))
            ( _typesIconstructors_collect,_typesIdependencies_collect,_typesIinferredDependencies_collect,_typesIlabels_collect,_typesImethods_collect,_typesIself) =
                (types_ (_typesOclassname) (_typesOconstructors_collect) (_typesOconstructors_dist) (_typesOcurrentModule) (_typesOdependencies_collect) (_typesOimportedModule) (_typesOinferredDependencies) (_typesOinferredDependencies_collect) (_typesOinstancename) (_typesOlabels_collect) (_typesOlabels_dist) (_typesOlocal) (_typesOmethods_collect) (_typesOmethods_dist) (_typesOtoplevel))
            ( _kindIconstructors_collect,_kindIdependencies_collect,_kindIinferredDependencies_collect,_kindIlabels_collect,_kindImethods_collect,_kindIself) =
                (kind_ (_kindOclassname) (_kindOconstructors_collect) (_kindOconstructors_dist) (_kindOcurrentModule) (_kindOdependencies_collect) (_kindOimportedModule) (_kindOinferredDependencies) (_kindOinferredDependencies_collect) (_kindOinstancename) (_kindOlabels_collect) (_kindOlabels_dist) (_kindOlocal) (_kindOmethods_collect) (_kindOmethods_dist) (_kindOtoplevel))
            -- self rule
            (_self@_) =
                InterfaceDeclaration_Abstract _rangeIself _nameIself _constructorsIself _typesIself _kindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _kindIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _kindIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _kindIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _kindIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _kindImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_constructorsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_constructorsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_constructorsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_constructorsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_constructorsOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_constructorsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_constructorsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_constructorsOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_constructorsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_constructorsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_constructorsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_constructorsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_constructorsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_constructorsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_constructorsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typesOconstructors_collect@_) =
                _constructorsIconstructors_collect
            -- copy rule (down)
            (_typesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_typesOdependencies_collect@_) =
                _constructorsIdependencies_collect
            -- copy rule (down)
            (_typesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typesOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_typesOinferredDependencies_collect@_) =
                _constructorsIinferredDependencies_collect
            -- copy rule (down)
            (_typesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typesOlabels_collect@_) =
                _constructorsIlabels_collect
            -- copy rule (down)
            (_typesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typesOmethods_collect@_) =
                _constructorsImethods_collect
            -- copy rule (down)
            (_typesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typesOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_kindOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_kindOconstructors_collect@_) =
                _typesIconstructors_collect
            -- copy rule (down)
            (_kindOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_kindOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_kindOdependencies_collect@_) =
                _typesIdependencies_collect
            -- copy rule (down)
            (_kindOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_kindOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_kindOinferredDependencies_collect@_) =
                _typesIinferredDependencies_collect
            -- copy rule (down)
            (_kindOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_kindOlabels_collect@_) =
                _typesIlabels_collect
            -- copy rule (down)
            (_kindOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_kindOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_kindOmethods_collect@_) =
                _typesImethods_collect
            -- copy rule (down)
            (_kindOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_kindOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_InterfaceDeclaration_Binding :: (T_Range) ->
                                    (T_Name) ->
                                    (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Binding (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (InterfaceDeclaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            -- self rule
            (_self@_) =
                InterfaceDeclaration_Binding _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_InterfaceDeclaration_Consig :: (T_Range) ->
                                   (Bool) ->
                                   (T_Name) ->
                                   (T_TypeArguments) ->
                                   (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Consig (range_) (typelevel_) (name_) (types_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (InterfaceDeclaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _typesIconstructors_collect :: (FMap Name Names)
            _typesIdependencies_collect :: (FMap Name [(Name,Name)])
            _typesIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typesIlabels_collect :: (FMap Name Names)
            _typesImethods_collect :: (FMap Name Names)
            _typesIself :: (TypeArguments)
            _typesOclassname :: (Maybe Name)
            _typesOconstructors_collect :: (FMap Name Names)
            _typesOconstructors_dist :: (FMap Name Names)
            _typesOcurrentModule :: (Strings)
            _typesOdependencies_collect :: (FMap Name [(Name,Name)])
            _typesOimportedModule :: (Bool)
            _typesOinferredDependencies :: (FMap Name [(Name,Name)])
            _typesOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typesOinstancename :: (Maybe Name)
            _typesOlabels_collect :: (FMap Name Names)
            _typesOlabels_dist :: (FMap Name Names)
            _typesOlocal :: (Bool)
            _typesOmethods_collect :: (FMap Name Names)
            _typesOmethods_dist :: (FMap Name Names)
            _typesOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _typesIconstructors_collect,_typesIdependencies_collect,_typesIinferredDependencies_collect,_typesIlabels_collect,_typesImethods_collect,_typesIself) =
                (types_ (_typesOclassname) (_typesOconstructors_collect) (_typesOconstructors_dist) (_typesOcurrentModule) (_typesOdependencies_collect) (_typesOimportedModule) (_typesOinferredDependencies) (_typesOinferredDependencies_collect) (_typesOinstancename) (_typesOlabels_collect) (_typesOlabels_dist) (_typesOlocal) (_typesOmethods_collect) (_typesOmethods_dist) (_typesOtoplevel))
            -- "./Signature.inc.lag"(line 121, column 9)
            (_lhsOpresignatures_collect@_) =
                case  find
                        _lhsIpresignatures_collect
                        _nameIself
                of
                  Nothing  ->  add _lhsIpresignatures_collect
                                   (_nameIself,(_typesIself,Nothing))
                  Just _   ->  _lhsIpresignatures_collect
            -- self rule
            (_self@_) =
                InterfaceDeclaration_Consig _rangeIself typelevel_ _nameIself _typesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typesIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _typesIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _typesIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typesIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typesImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typesOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_typesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_typesOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_typesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typesOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_typesOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_typesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typesOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_typesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typesOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_typesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typesOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_InterfaceDeclaration_Declarations :: (T_Range) ->
                                         (T_Declarations) ->
                                         (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Declarations (range_) (declarations_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (InterfaceDeclaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _declarationsIbodyDependencies :: ([(Name,Name)])
            _declarationsIconstructors_collect :: (FMap Name Names)
            _declarationsIdependencies_collect :: (FMap Name [(Name,Name)])
            _declarationsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _declarationsIlabels_collect :: (FMap Name Names)
            _declarationsImethods_collect :: (FMap Name Names)
            _declarationsIpresignatures_collect :: (PreSignatures)
            _declarationsIself :: (Declarations)
            _declarationsOclassname :: (Maybe Name)
            _declarationsOconstructors_collect :: (FMap Name Names)
            _declarationsOconstructors_dist :: (FMap Name Names)
            _declarationsOcurrentModule :: (Strings)
            _declarationsOdependencies_collect :: (FMap Name [(Name,Name)])
            _declarationsOimportedModule :: (Bool)
            _declarationsOinferredDependencies :: (FMap Name [(Name,Name)])
            _declarationsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _declarationsOinstancename :: (Maybe Name)
            _declarationsOlabels_collect :: (FMap Name Names)
            _declarationsOlabels_dist :: (FMap Name Names)
            _declarationsOlocal :: (Bool)
            _declarationsOmethods_collect :: (FMap Name Names)
            _declarationsOmethods_dist :: (FMap Name Names)
            _declarationsOpresignatures :: (PreSignatures)
            _declarationsOpresignatures_collect :: (PreSignatures)
            _declarationsOsignatures :: (Signatures)
            _declarationsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _declarationsIbodyDependencies,_declarationsIconstructors_collect,_declarationsIdependencies_collect,_declarationsIinferredDependencies_collect,_declarationsIlabels_collect,_declarationsImethods_collect,_declarationsIpresignatures_collect,_declarationsIself) =
                (declarations_ (_declarationsOclassname)
                               (_declarationsOconstructors_collect)
                               (_declarationsOconstructors_dist)
                               (_declarationsOcurrentModule)
                               (_declarationsOdependencies_collect)
                               (_declarationsOimportedModule)
                               (_declarationsOinferredDependencies)
                               (_declarationsOinferredDependencies_collect)
                               (_declarationsOinstancename)
                               (_declarationsOlabels_collect)
                               (_declarationsOlabels_dist)
                               (_declarationsOlocal)
                               (_declarationsOmethods_collect)
                               (_declarationsOmethods_dist)
                               (_declarationsOpresignatures)
                               (_declarationsOpresignatures_collect)
                               (_declarationsOsignatures)
                               (_declarationsOtoplevel))
            -- self rule
            (_self@_) =
                InterfaceDeclaration_Declarations _rangeIself _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _declarationsIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _declarationsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _declarationsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _declarationsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _declarationsImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _declarationsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_declarationsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_declarationsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_declarationsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_declarationsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_declarationsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_declarationsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_declarationsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_declarationsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_declarationsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_declarationsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_declarationsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_declarationsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_declarationsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_declarationsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_declarationsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_declarationsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_declarationsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_declarationsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_InterfaceDeclaration_Dependency :: (T_Range) ->
                                       (T_Name) ->
                                       (T_Kind) ->
                                       (T_DependencyBindings) ->
                                       (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Dependency (range_) (name_) (kind_) (bindings_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (InterfaceDeclaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _kindIconstructors_collect :: (FMap Name Names)
            _kindIdependencies_collect :: (FMap Name [(Name,Name)])
            _kindIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _kindIlabels_collect :: (FMap Name Names)
            _kindImethods_collect :: (FMap Name Names)
            _kindIself :: (Kind)
            _kindOclassname :: (Maybe Name)
            _kindOconstructors_collect :: (FMap Name Names)
            _kindOconstructors_dist :: (FMap Name Names)
            _kindOcurrentModule :: (Strings)
            _kindOdependencies_collect :: (FMap Name [(Name,Name)])
            _kindOimportedModule :: (Bool)
            _kindOinferredDependencies :: (FMap Name [(Name,Name)])
            _kindOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _kindOinstancename :: (Maybe Name)
            _kindOlabels_collect :: (FMap Name Names)
            _kindOlabels_dist :: (FMap Name Names)
            _kindOlocal :: (Bool)
            _kindOmethods_collect :: (FMap Name Names)
            _kindOmethods_dist :: (FMap Name Names)
            _kindOtoplevel :: (Bool)
            _bindingsIconstructors_collect :: (FMap Name Names)
            _bindingsIdependencies_collect :: (FMap Name [(Name,Name)])
            _bindingsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _bindingsIlabels_collect :: (FMap Name Names)
            _bindingsIlocalDependencies :: ([(Name,Name)])
            _bindingsImethods_collect :: (FMap Name Names)
            _bindingsIself :: (DependencyBindings)
            _bindingsOclassname :: (Maybe Name)
            _bindingsOconstructors_collect :: (FMap Name Names)
            _bindingsOconstructors_dist :: (FMap Name Names)
            _bindingsOcurrentModule :: (Strings)
            _bindingsOdependencies_collect :: (FMap Name [(Name,Name)])
            _bindingsOimportedModule :: (Bool)
            _bindingsOinferredDependencies :: (FMap Name [(Name,Name)])
            _bindingsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _bindingsOinstancename :: (Maybe Name)
            _bindingsOlabels_collect :: (FMap Name Names)
            _bindingsOlabels_dist :: (FMap Name Names)
            _bindingsOlocal :: (Bool)
            _bindingsOmethods_collect :: (FMap Name Names)
            _bindingsOmethods_dist :: (FMap Name Names)
            _bindingsOtoplevel :: (Bool)
            _bindingsOtypelevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _kindIconstructors_collect,_kindIdependencies_collect,_kindIinferredDependencies_collect,_kindIlabels_collect,_kindImethods_collect,_kindIself) =
                (kind_ (_kindOclassname) (_kindOconstructors_collect) (_kindOconstructors_dist) (_kindOcurrentModule) (_kindOdependencies_collect) (_kindOimportedModule) (_kindOinferredDependencies) (_kindOinferredDependencies_collect) (_kindOinstancename) (_kindOlabels_collect) (_kindOlabels_dist) (_kindOlocal) (_kindOmethods_collect) (_kindOmethods_dist) (_kindOtoplevel))
            ( _bindingsIconstructors_collect,_bindingsIdependencies_collect,_bindingsIinferredDependencies_collect,_bindingsIlabels_collect,_bindingsIlocalDependencies,_bindingsImethods_collect,_bindingsIself) =
                (bindings_ (_bindingsOclassname)
                           (_bindingsOconstructors_collect)
                           (_bindingsOconstructors_dist)
                           (_bindingsOcurrentModule)
                           (_bindingsOdependencies_collect)
                           (_bindingsOimportedModule)
                           (_bindingsOinferredDependencies)
                           (_bindingsOinferredDependencies_collect)
                           (_bindingsOinstancename)
                           (_bindingsOlabels_collect)
                           (_bindingsOlabels_dist)
                           (_bindingsOlocal)
                           (_bindingsOmethods_collect)
                           (_bindingsOmethods_dist)
                           (_bindingsOtoplevel)
                           (_bindingsOtypelevel))
            -- "ScanDependencies.lag"(line 98, column 9)
            (_lhsOdependencies_collect@_) =
                add
                  _lhsIdependencies_collect
                  (_nameIself,_bindingsIlocalDependencies)
            -- "./ModuleInformation.inc.lag"(line 219, column 9)
            (_bindingsOtypelevel@_) =
                False
            -- self rule
            (_self@_) =
                InterfaceDeclaration_Dependency _rangeIself _nameIself _kindIself _bindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _bindingsIconstructors_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _bindingsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _bindingsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _bindingsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_kindOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_kindOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_kindOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_kindOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_kindOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_kindOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_kindOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_kindOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_kindOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_kindOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_kindOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_kindOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_kindOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_kindOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_kindOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_bindingsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_bindingsOconstructors_collect@_) =
                _kindIconstructors_collect
            -- copy rule (down)
            (_bindingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_bindingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_bindingsOdependencies_collect@_) =
                _kindIdependencies_collect
            -- copy rule (down)
            (_bindingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_bindingsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_bindingsOinferredDependencies_collect@_) =
                _kindIinferredDependencies_collect
            -- copy rule (down)
            (_bindingsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_bindingsOlabels_collect@_) =
                _kindIlabels_collect
            -- copy rule (down)
            (_bindingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_bindingsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_bindingsOmethods_collect@_) =
                _kindImethods_collect
            -- copy rule (down)
            (_bindingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_bindingsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_InterfaceDeclaration_Import :: (T_Range) ->
                                   (T_ModuleName) ->
                                   (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Import (range_) (module_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (InterfaceDeclaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _moduleIconstructors_collect :: (FMap Name Names)
            _moduleIdependencies_collect :: (FMap Name [(Name,Name)])
            _moduleIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _moduleIlabels_collect :: (FMap Name Names)
            _moduleImethods_collect :: (FMap Name Names)
            _moduleIself :: (ModuleName)
            _moduleOclassname :: (Maybe Name)
            _moduleOconstructors_collect :: (FMap Name Names)
            _moduleOconstructors_dist :: (FMap Name Names)
            _moduleOcurrentModule :: (Strings)
            _moduleOdependencies_collect :: (FMap Name [(Name,Name)])
            _moduleOimportedModule :: (Bool)
            _moduleOinferredDependencies :: (FMap Name [(Name,Name)])
            _moduleOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _moduleOinstancename :: (Maybe Name)
            _moduleOlabels_collect :: (FMap Name Names)
            _moduleOlabels_dist :: (FMap Name Names)
            _moduleOlocal :: (Bool)
            _moduleOmethods_collect :: (FMap Name Names)
            _moduleOmethods_dist :: (FMap Name Names)
            _moduleOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _moduleIconstructors_collect,_moduleIdependencies_collect,_moduleIinferredDependencies_collect,_moduleIlabels_collect,_moduleImethods_collect,_moduleIself) =
                (module_ (_moduleOclassname) (_moduleOconstructors_collect) (_moduleOconstructors_dist) (_moduleOcurrentModule) (_moduleOdependencies_collect) (_moduleOimportedModule) (_moduleOinferredDependencies) (_moduleOinferredDependencies_collect) (_moduleOinstancename) (_moduleOlabels_collect) (_moduleOlabels_dist) (_moduleOlocal) (_moduleOmethods_collect) (_moduleOmethods_dist) (_moduleOtoplevel))
            -- self rule
            (_self@_) =
                InterfaceDeclaration_Import _rangeIself _moduleIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _moduleIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _moduleIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _moduleIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _moduleIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _moduleImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_moduleOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_moduleOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_moduleOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_moduleOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_moduleOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_moduleOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_moduleOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_moduleOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_moduleOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_moduleOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_moduleOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_moduleOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_moduleOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_moduleOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_moduleOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_InterfaceDeclaration_SetModule :: (T_Range) ->
                                      (T_ModuleName) ->
                                      (T_InterfaceDeclarations) ->
                                      (T_InterfaceDeclaration)
sem_InterfaceDeclaration_SetModule (range_) (module_) (declarations_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (InterfaceDeclaration)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _moduleIconstructors_collect :: (FMap Name Names)
            _moduleIdependencies_collect :: (FMap Name [(Name,Name)])
            _moduleIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _moduleIlabels_collect :: (FMap Name Names)
            _moduleImethods_collect :: (FMap Name Names)
            _moduleIself :: (ModuleName)
            _moduleOclassname :: (Maybe Name)
            _moduleOconstructors_collect :: (FMap Name Names)
            _moduleOconstructors_dist :: (FMap Name Names)
            _moduleOcurrentModule :: (Strings)
            _moduleOdependencies_collect :: (FMap Name [(Name,Name)])
            _moduleOimportedModule :: (Bool)
            _moduleOinferredDependencies :: (FMap Name [(Name,Name)])
            _moduleOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _moduleOinstancename :: (Maybe Name)
            _moduleOlabels_collect :: (FMap Name Names)
            _moduleOlabels_dist :: (FMap Name Names)
            _moduleOlocal :: (Bool)
            _moduleOmethods_collect :: (FMap Name Names)
            _moduleOmethods_dist :: (FMap Name Names)
            _moduleOtoplevel :: (Bool)
            _declarationsIconstructors_collect :: (FMap Name Names)
            _declarationsIdependencies_collect :: (FMap Name [(Name,Name)])
            _declarationsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _declarationsIlabels_collect :: (FMap Name Names)
            _declarationsImethods_collect :: (FMap Name Names)
            _declarationsIpresignatures_collect :: (PreSignatures)
            _declarationsIself :: (InterfaceDeclarations)
            _declarationsOclassname :: (Maybe Name)
            _declarationsOconstructors_collect :: (FMap Name Names)
            _declarationsOconstructors_dist :: (FMap Name Names)
            _declarationsOcurrentModule :: (Strings)
            _declarationsOdependencies_collect :: (FMap Name [(Name,Name)])
            _declarationsOimportedModule :: (Bool)
            _declarationsOinferredDependencies :: (FMap Name [(Name,Name)])
            _declarationsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _declarationsOinstancename :: (Maybe Name)
            _declarationsOlabels_collect :: (FMap Name Names)
            _declarationsOlabels_dist :: (FMap Name Names)
            _declarationsOlocal :: (Bool)
            _declarationsOmethods_collect :: (FMap Name Names)
            _declarationsOmethods_dist :: (FMap Name Names)
            _declarationsOpresignatures :: (PreSignatures)
            _declarationsOpresignatures_collect :: (PreSignatures)
            _declarationsOsignatures :: (Signatures)
            _declarationsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _moduleIconstructors_collect,_moduleIdependencies_collect,_moduleIinferredDependencies_collect,_moduleIlabels_collect,_moduleImethods_collect,_moduleIself) =
                (module_ (_moduleOclassname) (_moduleOconstructors_collect) (_moduleOconstructors_dist) (_moduleOcurrentModule) (_moduleOdependencies_collect) (_moduleOimportedModule) (_moduleOinferredDependencies) (_moduleOinferredDependencies_collect) (_moduleOinstancename) (_moduleOlabels_collect) (_moduleOlabels_dist) (_moduleOlocal) (_moduleOmethods_collect) (_moduleOmethods_dist) (_moduleOtoplevel))
            ( _declarationsIconstructors_collect,_declarationsIdependencies_collect,_declarationsIinferredDependencies_collect,_declarationsIlabels_collect,_declarationsImethods_collect,_declarationsIpresignatures_collect,_declarationsIself) =
                (declarations_ (_declarationsOclassname)
                               (_declarationsOconstructors_collect)
                               (_declarationsOconstructors_dist)
                               (_declarationsOcurrentModule)
                               (_declarationsOdependencies_collect)
                               (_declarationsOimportedModule)
                               (_declarationsOinferredDependencies)
                               (_declarationsOinferredDependencies_collect)
                               (_declarationsOinstancename)
                               (_declarationsOlabels_collect)
                               (_declarationsOlabels_dist)
                               (_declarationsOlocal)
                               (_declarationsOmethods_collect)
                               (_declarationsOmethods_dist)
                               (_declarationsOpresignatures)
                               (_declarationsOpresignatures_collect)
                               (_declarationsOsignatures)
                               (_declarationsOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 134, column 8)
            (_currentModule@_) =
                getModuleName _moduleIself
            -- self rule
            (_self@_) =
                InterfaceDeclaration_SetModule _rangeIself _moduleIself _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _declarationsIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _declarationsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _declarationsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _declarationsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _declarationsImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _declarationsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_rangeOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_moduleOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_moduleOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_moduleOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_moduleOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_moduleOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_moduleOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_moduleOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_moduleOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_moduleOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_moduleOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_moduleOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_moduleOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_moduleOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_moduleOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_moduleOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_declarationsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_declarationsOconstructors_collect@_) =
                _moduleIconstructors_collect
            -- copy rule (down)
            (_declarationsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_declarationsOcurrentModule@_) =
                _currentModule
            -- copy rule (chain)
            (_declarationsOdependencies_collect@_) =
                _moduleIdependencies_collect
            -- copy rule (down)
            (_declarationsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_declarationsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_declarationsOinferredDependencies_collect@_) =
                _moduleIinferredDependencies_collect
            -- copy rule (down)
            (_declarationsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_declarationsOlabels_collect@_) =
                _moduleIlabels_collect
            -- copy rule (down)
            (_declarationsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_declarationsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_declarationsOmethods_collect@_) =
                _moduleImethods_collect
            -- copy rule (down)
            (_declarationsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_declarationsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_declarationsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_declarationsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_declarationsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- InterfaceDeclarations ---------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for InterfaceDeclarations.Cons:
      self

-}
{-
   local variables for InterfaceDeclarations.Nil:
      self

-}
-- semantic domain
type T_InterfaceDeclarations = (Maybe Name) ->
                               (FMap Name Names) ->
                               (FMap Name Names) ->
                               (Strings) ->
                               (FMap Name [(Name,Name)]) ->
                               (Bool) ->
                               (FMap Name [(Name,Name)]) ->
                               (FMap Name [(Name,Name)]) ->
                               (Maybe Name) ->
                               (FMap Name Names) ->
                               (FMap Name Names) ->
                               (Bool) ->
                               (FMap Name Names) ->
                               (FMap Name Names) ->
                               (PreSignatures) ->
                               (PreSignatures) ->
                               (Signatures) ->
                               (Bool) ->
                               ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(PreSignatures),(InterfaceDeclarations))
-- cata
sem_InterfaceDeclarations :: (InterfaceDeclarations) ->
                             (T_InterfaceDeclarations)
sem_InterfaceDeclarations (list) =
    (foldr (sem_InterfaceDeclarations_Cons) (sem_InterfaceDeclarations_Nil) ((map sem_InterfaceDeclaration list)))
sem_InterfaceDeclarations_Cons :: (T_InterfaceDeclaration) ->
                                  (T_InterfaceDeclarations) ->
                                  (T_InterfaceDeclarations)
sem_InterfaceDeclarations_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (InterfaceDeclarations)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdependencies_collect :: (FMap Name [(Name,Name)])
            _hdIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIpresignatures_collect :: (PreSignatures)
            _hdIself :: (InterfaceDeclaration)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies_collect :: (FMap Name [(Name,Name)])
            _hdOimportedModule :: (Bool)
            _hdOinferredDependencies :: (FMap Name [(Name,Name)])
            _hdOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdOinstancename :: (Maybe Name)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOpresignatures :: (PreSignatures)
            _hdOpresignatures_collect :: (PreSignatures)
            _hdOsignatures :: (Signatures)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdependencies_collect :: (FMap Name [(Name,Name)])
            _tlIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIpresignatures_collect :: (PreSignatures)
            _tlIself :: (InterfaceDeclarations)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies_collect :: (FMap Name [(Name,Name)])
            _tlOimportedModule :: (Bool)
            _tlOinferredDependencies :: (FMap Name [(Name,Name)])
            _tlOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOpresignatures :: (PreSignatures)
            _tlOpresignatures_collect :: (PreSignatures)
            _tlOsignatures :: (Signatures)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIdependencies_collect,_hdIinferredDependencies_collect,_hdIlabels_collect,_hdImethods_collect,_hdIpresignatures_collect,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOdependencies_collect) (_hdOimportedModule) (_hdOinferredDependencies) (_hdOinferredDependencies_collect) (_hdOinstancename) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOpresignatures) (_hdOpresignatures_collect) (_hdOsignatures) (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIdependencies_collect,_tlIinferredDependencies_collect,_tlIlabels_collect,_tlImethods_collect,_tlIpresignatures_collect,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOdependencies_collect) (_tlOimportedModule) (_tlOinferredDependencies) (_tlOinferredDependencies_collect) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOpresignatures) (_tlOpresignatures_collect) (_tlOsignatures) (_tlOtoplevel))
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _tlIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _tlIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _tlIpresignatures_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_hdOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_hdOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_hdOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_tlOdependencies_collect@_) =
                _hdIdependencies_collect
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_tlOinferredDependencies_collect@_) =
                _hdIinferredDependencies_collect
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_tlOpresignatures_collect@_) =
                _hdIpresignatures_collect
            -- copy rule (down)
            (_tlOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_InterfaceDeclarations_Nil :: (T_InterfaceDeclarations)
sem_InterfaceDeclarations_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (InterfaceDeclarations)
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- Kind --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Kind.Arrow:
      self

-}
{-
   local variables for Kind.Error:
      self

-}
{-
   local variables for Kind.Parenthesized:
      self

-}
{-
   local variables for Kind.Star:
      self

-}
{-
   local variables for Kind.Variable:
      self

-}
-- semantic domain
type T_Kind = (Maybe Name) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (Strings) ->
              (FMap Name [(Name,Name)]) ->
              (Bool) ->
              (FMap Name [(Name,Name)]) ->
              (FMap Name [(Name,Name)]) ->
              (Maybe Name) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (Bool) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (Bool) ->
              ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(Kind))
-- cata
sem_Kind :: (Kind) ->
            (T_Kind)
sem_Kind ((Kind_Arrow (_range) (_leftKind) (_rightKind))) =
    (sem_Kind_Arrow ((sem_Range (_range))) ((sem_Kind (_leftKind))) ((sem_Kind (_rightKind))))
sem_Kind ((Kind_Error )) =
    (sem_Kind_Error )
sem_Kind ((Kind_Parenthesized (_range) (_kind))) =
    (sem_Kind_Parenthesized ((sem_Range (_range))) ((sem_Kind (_kind))))
sem_Kind ((Kind_Star (_range))) =
    (sem_Kind_Star ((sem_Range (_range))))
sem_Kind ((Kind_Variable (_range) (_name))) =
    (sem_Kind_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Kind_Arrow :: (T_Range) ->
                  (T_Kind) ->
                  (T_Kind) ->
                  (T_Kind)
sem_Kind_Arrow (range_) (leftKind_) (rightKind_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Kind)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _leftKindIconstructors_collect :: (FMap Name Names)
            _leftKindIdependencies_collect :: (FMap Name [(Name,Name)])
            _leftKindIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _leftKindIlabels_collect :: (FMap Name Names)
            _leftKindImethods_collect :: (FMap Name Names)
            _leftKindIself :: (Kind)
            _leftKindOclassname :: (Maybe Name)
            _leftKindOconstructors_collect :: (FMap Name Names)
            _leftKindOconstructors_dist :: (FMap Name Names)
            _leftKindOcurrentModule :: (Strings)
            _leftKindOdependencies_collect :: (FMap Name [(Name,Name)])
            _leftKindOimportedModule :: (Bool)
            _leftKindOinferredDependencies :: (FMap Name [(Name,Name)])
            _leftKindOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _leftKindOinstancename :: (Maybe Name)
            _leftKindOlabels_collect :: (FMap Name Names)
            _leftKindOlabels_dist :: (FMap Name Names)
            _leftKindOlocal :: (Bool)
            _leftKindOmethods_collect :: (FMap Name Names)
            _leftKindOmethods_dist :: (FMap Name Names)
            _leftKindOtoplevel :: (Bool)
            _rightKindIconstructors_collect :: (FMap Name Names)
            _rightKindIdependencies_collect :: (FMap Name [(Name,Name)])
            _rightKindIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _rightKindIlabels_collect :: (FMap Name Names)
            _rightKindImethods_collect :: (FMap Name Names)
            _rightKindIself :: (Kind)
            _rightKindOclassname :: (Maybe Name)
            _rightKindOconstructors_collect :: (FMap Name Names)
            _rightKindOconstructors_dist :: (FMap Name Names)
            _rightKindOcurrentModule :: (Strings)
            _rightKindOdependencies_collect :: (FMap Name [(Name,Name)])
            _rightKindOimportedModule :: (Bool)
            _rightKindOinferredDependencies :: (FMap Name [(Name,Name)])
            _rightKindOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _rightKindOinstancename :: (Maybe Name)
            _rightKindOlabels_collect :: (FMap Name Names)
            _rightKindOlabels_dist :: (FMap Name Names)
            _rightKindOlocal :: (Bool)
            _rightKindOmethods_collect :: (FMap Name Names)
            _rightKindOmethods_dist :: (FMap Name Names)
            _rightKindOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _leftKindIconstructors_collect,_leftKindIdependencies_collect,_leftKindIinferredDependencies_collect,_leftKindIlabels_collect,_leftKindImethods_collect,_leftKindIself) =
                (leftKind_ (_leftKindOclassname) (_leftKindOconstructors_collect) (_leftKindOconstructors_dist) (_leftKindOcurrentModule) (_leftKindOdependencies_collect) (_leftKindOimportedModule) (_leftKindOinferredDependencies) (_leftKindOinferredDependencies_collect) (_leftKindOinstancename) (_leftKindOlabels_collect) (_leftKindOlabels_dist) (_leftKindOlocal) (_leftKindOmethods_collect) (_leftKindOmethods_dist) (_leftKindOtoplevel))
            ( _rightKindIconstructors_collect,_rightKindIdependencies_collect,_rightKindIinferredDependencies_collect,_rightKindIlabels_collect,_rightKindImethods_collect,_rightKindIself) =
                (rightKind_ (_rightKindOclassname)
                            (_rightKindOconstructors_collect)
                            (_rightKindOconstructors_dist)
                            (_rightKindOcurrentModule)
                            (_rightKindOdependencies_collect)
                            (_rightKindOimportedModule)
                            (_rightKindOinferredDependencies)
                            (_rightKindOinferredDependencies_collect)
                            (_rightKindOinstancename)
                            (_rightKindOlabels_collect)
                            (_rightKindOlabels_dist)
                            (_rightKindOlocal)
                            (_rightKindOmethods_collect)
                            (_rightKindOmethods_dist)
                            (_rightKindOtoplevel))
            -- self rule
            (_self@_) =
                Kind_Arrow _rangeIself _leftKindIself _rightKindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _rightKindIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _rightKindIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _rightKindIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _rightKindIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _rightKindImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_leftKindOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_leftKindOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_leftKindOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_leftKindOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_leftKindOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_leftKindOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_leftKindOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_leftKindOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_leftKindOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_leftKindOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_leftKindOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_leftKindOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_leftKindOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_leftKindOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_leftKindOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_rightKindOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_rightKindOconstructors_collect@_) =
                _leftKindIconstructors_collect
            -- copy rule (down)
            (_rightKindOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_rightKindOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_rightKindOdependencies_collect@_) =
                _leftKindIdependencies_collect
            -- copy rule (down)
            (_rightKindOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rightKindOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_rightKindOinferredDependencies_collect@_) =
                _leftKindIinferredDependencies_collect
            -- copy rule (down)
            (_rightKindOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_rightKindOlabels_collect@_) =
                _leftKindIlabels_collect
            -- copy rule (down)
            (_rightKindOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_rightKindOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_rightKindOmethods_collect@_) =
                _leftKindImethods_collect
            -- copy rule (down)
            (_rightKindOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_rightKindOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Kind_Error :: (T_Kind)
sem_Kind_Error  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Kind)
            -- self rule
            (_self@_) =
                Kind_Error
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Kind_Parenthesized :: (T_Range) ->
                          (T_Kind) ->
                          (T_Kind)
sem_Kind_Parenthesized (range_) (kind_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Kind)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _kindIconstructors_collect :: (FMap Name Names)
            _kindIdependencies_collect :: (FMap Name [(Name,Name)])
            _kindIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _kindIlabels_collect :: (FMap Name Names)
            _kindImethods_collect :: (FMap Name Names)
            _kindIself :: (Kind)
            _kindOclassname :: (Maybe Name)
            _kindOconstructors_collect :: (FMap Name Names)
            _kindOconstructors_dist :: (FMap Name Names)
            _kindOcurrentModule :: (Strings)
            _kindOdependencies_collect :: (FMap Name [(Name,Name)])
            _kindOimportedModule :: (Bool)
            _kindOinferredDependencies :: (FMap Name [(Name,Name)])
            _kindOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _kindOinstancename :: (Maybe Name)
            _kindOlabels_collect :: (FMap Name Names)
            _kindOlabels_dist :: (FMap Name Names)
            _kindOlocal :: (Bool)
            _kindOmethods_collect :: (FMap Name Names)
            _kindOmethods_dist :: (FMap Name Names)
            _kindOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _kindIconstructors_collect,_kindIdependencies_collect,_kindIinferredDependencies_collect,_kindIlabels_collect,_kindImethods_collect,_kindIself) =
                (kind_ (_kindOclassname) (_kindOconstructors_collect) (_kindOconstructors_dist) (_kindOcurrentModule) (_kindOdependencies_collect) (_kindOimportedModule) (_kindOinferredDependencies) (_kindOinferredDependencies_collect) (_kindOinstancename) (_kindOlabels_collect) (_kindOlabels_dist) (_kindOlocal) (_kindOmethods_collect) (_kindOmethods_dist) (_kindOtoplevel))
            -- self rule
            (_self@_) =
                Kind_Parenthesized _rangeIself _kindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _kindIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _kindIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _kindIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _kindIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _kindImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_kindOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_kindOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_kindOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_kindOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_kindOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_kindOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_kindOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_kindOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_kindOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_kindOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_kindOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_kindOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_kindOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_kindOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_kindOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Kind_Star :: (T_Range) ->
                 (T_Kind)
sem_Kind_Star (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Kind)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- self rule
            (_self@_) =
                Kind_Star _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Kind_Variable :: (T_Range) ->
                     (T_Name) ->
                     (T_Kind)
sem_Kind_Variable (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Kind)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            -- self rule
            (_self@_) =
                Kind_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- KindAnnotatedName -------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      akinds               : [MaybeKind]
      self                 : SELF

-}
{-
   local variables for KindAnnotatedName.KindAnnotatedName:
      self

-}
-- semantic domain
type T_KindAnnotatedName = (Maybe Name) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Strings) ->
                           (FMap Name [(Name,Name)]) ->
                           (Bool) ->
                           (FMap Name [(Name,Name)]) ->
                           (FMap Name [(Name,Name)]) ->
                           (Maybe Name) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Bool) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Bool) ->
                           ( ([MaybeKind]),(FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(KindAnnotatedName))
-- cata
sem_KindAnnotatedName :: (KindAnnotatedName) ->
                         (T_KindAnnotatedName)
sem_KindAnnotatedName ((KindAnnotatedName_KindAnnotatedName (_range) (_name) (_kind))) =
    (sem_KindAnnotatedName_KindAnnotatedName ((sem_Range (_range))) ((sem_Name (_name))) ((sem_MaybeKind (_kind))))
sem_KindAnnotatedName_KindAnnotatedName :: (T_Range) ->
                                           (T_Name) ->
                                           (T_MaybeKind) ->
                                           (T_KindAnnotatedName)
sem_KindAnnotatedName_KindAnnotatedName (range_) (name_) (kind_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOakinds :: ([MaybeKind])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (KindAnnotatedName)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _kindIconstructors_collect :: (FMap Name Names)
            _kindIdependencies_collect :: (FMap Name [(Name,Name)])
            _kindIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _kindIlabels_collect :: (FMap Name Names)
            _kindImethods_collect :: (FMap Name Names)
            _kindIself :: (MaybeKind)
            _kindOclassname :: (Maybe Name)
            _kindOconstructors_collect :: (FMap Name Names)
            _kindOconstructors_dist :: (FMap Name Names)
            _kindOcurrentModule :: (Strings)
            _kindOdependencies_collect :: (FMap Name [(Name,Name)])
            _kindOimportedModule :: (Bool)
            _kindOinferredDependencies :: (FMap Name [(Name,Name)])
            _kindOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _kindOinstancename :: (Maybe Name)
            _kindOlabels_collect :: (FMap Name Names)
            _kindOlabels_dist :: (FMap Name Names)
            _kindOlocal :: (Bool)
            _kindOmethods_collect :: (FMap Name Names)
            _kindOmethods_dist :: (FMap Name Names)
            _kindOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _kindIconstructors_collect,_kindIdependencies_collect,_kindIinferredDependencies_collect,_kindIlabels_collect,_kindImethods_collect,_kindIself) =
                (kind_ (_kindOclassname) (_kindOconstructors_collect) (_kindOconstructors_dist) (_kindOcurrentModule) (_kindOdependencies_collect) (_kindOimportedModule) (_kindOinferredDependencies) (_kindOinferredDependencies_collect) (_kindOinstancename) (_kindOlabels_collect) (_kindOlabels_dist) (_kindOlocal) (_kindOmethods_collect) (_kindOmethods_dist) (_kindOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 272, column 9)
            (_lhsOakinds@_) =
                [_kindIself]
            -- self rule
            (_self@_) =
                KindAnnotatedName_KindAnnotatedName _rangeIself _nameIself _kindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _kindIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _kindIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _kindIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _kindIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _kindImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_kindOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_kindOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_kindOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_kindOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_kindOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_kindOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_kindOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_kindOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_kindOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_kindOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_kindOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_kindOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_kindOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_kindOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_kindOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOakinds,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- KindAnnotatedNames ------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      akinds               : [MaybeKind]
      self                 : SELF

-}
{-
   local variables for KindAnnotatedNames.Cons:
      self

-}
{-
   local variables for KindAnnotatedNames.Nil:
      self

-}
-- semantic domain
type T_KindAnnotatedNames = (Maybe Name) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Strings) ->
                            (FMap Name [(Name,Name)]) ->
                            (Bool) ->
                            (FMap Name [(Name,Name)]) ->
                            (FMap Name [(Name,Name)]) ->
                            (Maybe Name) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Bool) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Bool) ->
                            ( ([MaybeKind]),(FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(KindAnnotatedNames))
-- cata
sem_KindAnnotatedNames :: (KindAnnotatedNames) ->
                          (T_KindAnnotatedNames)
sem_KindAnnotatedNames (list) =
    (foldr (sem_KindAnnotatedNames_Cons) (sem_KindAnnotatedNames_Nil) ((map sem_KindAnnotatedName list)))
sem_KindAnnotatedNames_Cons :: (T_KindAnnotatedName) ->
                               (T_KindAnnotatedNames) ->
                               (T_KindAnnotatedNames)
sem_KindAnnotatedNames_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOakinds :: ([MaybeKind])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (KindAnnotatedNames)
            _hdIakinds :: ([MaybeKind])
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdependencies_collect :: (FMap Name [(Name,Name)])
            _hdIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIself :: (KindAnnotatedName)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies_collect :: (FMap Name [(Name,Name)])
            _hdOimportedModule :: (Bool)
            _hdOinferredDependencies :: (FMap Name [(Name,Name)])
            _hdOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdOinstancename :: (Maybe Name)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOtoplevel :: (Bool)
            _tlIakinds :: ([MaybeKind])
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdependencies_collect :: (FMap Name [(Name,Name)])
            _tlIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIself :: (KindAnnotatedNames)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies_collect :: (FMap Name [(Name,Name)])
            _tlOimportedModule :: (Bool)
            _tlOinferredDependencies :: (FMap Name [(Name,Name)])
            _tlOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOtoplevel :: (Bool)
            ( _hdIakinds,_hdIconstructors_collect,_hdIdependencies_collect,_hdIinferredDependencies_collect,_hdIlabels_collect,_hdImethods_collect,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOdependencies_collect) (_hdOimportedModule) (_hdOinferredDependencies) (_hdOinferredDependencies_collect) (_hdOinstancename) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOtoplevel))
            ( _tlIakinds,_tlIconstructors_collect,_tlIdependencies_collect,_tlIinferredDependencies_collect,_tlIlabels_collect,_tlImethods_collect,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOdependencies_collect) (_tlOimportedModule) (_tlOinferredDependencies) (_tlOinferredDependencies_collect) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOtoplevel))
            -- use rule
            (_lhsOakinds@_) =
                _hdIakinds ++ _tlIakinds
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _tlIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _tlIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_hdOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_tlOdependencies_collect@_) =
                _hdIdependencies_collect
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_tlOinferredDependencies_collect@_) =
                _hdIinferredDependencies_collect
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOakinds,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_KindAnnotatedNames_Nil :: (T_KindAnnotatedNames)
sem_KindAnnotatedNames_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOakinds :: ([MaybeKind])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (KindAnnotatedNames)
            -- use rule
            (_lhsOakinds@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOakinds,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- KindArgument ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for KindArgument.Arrow:
      self

-}
{-
   local variables for KindArgument.Star:
      self

-}
-- semantic domain
type T_KindArgument = (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Strings) ->
                      (FMap Name [(Name,Name)]) ->
                      (Bool) ->
                      (FMap Name [(Name,Name)]) ->
                      (FMap Name [(Name,Name)]) ->
                      (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(KindArgument))
-- cata
sem_KindArgument :: (KindArgument) ->
                    (T_KindArgument)
sem_KindArgument ((KindArgument_Arrow (_range) (_leftkindvariable) (_rightkindvariable))) =
    (sem_KindArgument_Arrow ((sem_Range (_range))) ((sem_Name (_leftkindvariable))) ((sem_Name (_rightkindvariable))))
sem_KindArgument ((KindArgument_Star (_range))) =
    (sem_KindArgument_Star ((sem_Range (_range))))
sem_KindArgument_Arrow :: (T_Range) ->
                          (T_Name) ->
                          (T_Name) ->
                          (T_KindArgument)
sem_KindArgument_Arrow (range_) (leftkindvariable_) (rightkindvariable_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (KindArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _leftkindvariableIconstructors_collect :: (FMap Name Names)
            _leftkindvariableIdependencies_collect :: (FMap Name [(Name,Name)])
            _leftkindvariableIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _leftkindvariableIlabels_collect :: (FMap Name Names)
            _leftkindvariableImethods_collect :: (FMap Name Names)
            _leftkindvariableIself :: (Name)
            _leftkindvariableOclassname :: (Maybe Name)
            _leftkindvariableOconstructors_collect :: (FMap Name Names)
            _leftkindvariableOconstructors_dist :: (FMap Name Names)
            _leftkindvariableOcurrentModule :: (Strings)
            _leftkindvariableOdependencies_collect :: (FMap Name [(Name,Name)])
            _leftkindvariableOimportedModule :: (Bool)
            _leftkindvariableOinferredDependencies :: (FMap Name [(Name,Name)])
            _leftkindvariableOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _leftkindvariableOinstancename :: (Maybe Name)
            _leftkindvariableOlabels_collect :: (FMap Name Names)
            _leftkindvariableOlabels_dist :: (FMap Name Names)
            _leftkindvariableOlocal :: (Bool)
            _leftkindvariableOmethods_collect :: (FMap Name Names)
            _leftkindvariableOmethods_dist :: (FMap Name Names)
            _leftkindvariableOtoplevel :: (Bool)
            _rightkindvariableIconstructors_collect :: (FMap Name Names)
            _rightkindvariableIdependencies_collect :: (FMap Name [(Name,Name)])
            _rightkindvariableIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _rightkindvariableIlabels_collect :: (FMap Name Names)
            _rightkindvariableImethods_collect :: (FMap Name Names)
            _rightkindvariableIself :: (Name)
            _rightkindvariableOclassname :: (Maybe Name)
            _rightkindvariableOconstructors_collect :: (FMap Name Names)
            _rightkindvariableOconstructors_dist :: (FMap Name Names)
            _rightkindvariableOcurrentModule :: (Strings)
            _rightkindvariableOdependencies_collect :: (FMap Name [(Name,Name)])
            _rightkindvariableOimportedModule :: (Bool)
            _rightkindvariableOinferredDependencies :: (FMap Name [(Name,Name)])
            _rightkindvariableOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _rightkindvariableOinstancename :: (Maybe Name)
            _rightkindvariableOlabels_collect :: (FMap Name Names)
            _rightkindvariableOlabels_dist :: (FMap Name Names)
            _rightkindvariableOlocal :: (Bool)
            _rightkindvariableOmethods_collect :: (FMap Name Names)
            _rightkindvariableOmethods_dist :: (FMap Name Names)
            _rightkindvariableOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _leftkindvariableIconstructors_collect,_leftkindvariableIdependencies_collect,_leftkindvariableIinferredDependencies_collect,_leftkindvariableIlabels_collect,_leftkindvariableImethods_collect,_leftkindvariableIself) =
                (leftkindvariable_ (_leftkindvariableOclassname)
                                   (_leftkindvariableOconstructors_collect)
                                   (_leftkindvariableOconstructors_dist)
                                   (_leftkindvariableOcurrentModule)
                                   (_leftkindvariableOdependencies_collect)
                                   (_leftkindvariableOimportedModule)
                                   (_leftkindvariableOinferredDependencies)
                                   (_leftkindvariableOinferredDependencies_collect)
                                   (_leftkindvariableOinstancename)
                                   (_leftkindvariableOlabels_collect)
                                   (_leftkindvariableOlabels_dist)
                                   (_leftkindvariableOlocal)
                                   (_leftkindvariableOmethods_collect)
                                   (_leftkindvariableOmethods_dist)
                                   (_leftkindvariableOtoplevel))
            ( _rightkindvariableIconstructors_collect,_rightkindvariableIdependencies_collect,_rightkindvariableIinferredDependencies_collect,_rightkindvariableIlabels_collect,_rightkindvariableImethods_collect,_rightkindvariableIself) =
                (rightkindvariable_ (_rightkindvariableOclassname)
                                    (_rightkindvariableOconstructors_collect)
                                    (_rightkindvariableOconstructors_dist)
                                    (_rightkindvariableOcurrentModule)
                                    (_rightkindvariableOdependencies_collect)
                                    (_rightkindvariableOimportedModule)
                                    (_rightkindvariableOinferredDependencies)
                                    (_rightkindvariableOinferredDependencies_collect)
                                    (_rightkindvariableOinstancename)
                                    (_rightkindvariableOlabels_collect)
                                    (_rightkindvariableOlabels_dist)
                                    (_rightkindvariableOlocal)
                                    (_rightkindvariableOmethods_collect)
                                    (_rightkindvariableOmethods_dist)
                                    (_rightkindvariableOtoplevel))
            -- self rule
            (_self@_) =
                KindArgument_Arrow _rangeIself _leftkindvariableIself _rightkindvariableIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _rightkindvariableIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _rightkindvariableIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _rightkindvariableIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _rightkindvariableIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _rightkindvariableImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_leftkindvariableOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_leftkindvariableOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_leftkindvariableOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_leftkindvariableOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_leftkindvariableOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_leftkindvariableOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_leftkindvariableOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_leftkindvariableOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_leftkindvariableOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_leftkindvariableOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_leftkindvariableOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_leftkindvariableOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_leftkindvariableOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_leftkindvariableOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_leftkindvariableOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_rightkindvariableOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_rightkindvariableOconstructors_collect@_) =
                _leftkindvariableIconstructors_collect
            -- copy rule (down)
            (_rightkindvariableOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_rightkindvariableOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_rightkindvariableOdependencies_collect@_) =
                _leftkindvariableIdependencies_collect
            -- copy rule (down)
            (_rightkindvariableOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rightkindvariableOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_rightkindvariableOinferredDependencies_collect@_) =
                _leftkindvariableIinferredDependencies_collect
            -- copy rule (down)
            (_rightkindvariableOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_rightkindvariableOlabels_collect@_) =
                _leftkindvariableIlabels_collect
            -- copy rule (down)
            (_rightkindvariableOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_rightkindvariableOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_rightkindvariableOmethods_collect@_) =
                _leftkindvariableImethods_collect
            -- copy rule (down)
            (_rightkindvariableOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_rightkindvariableOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_KindArgument_Star :: (T_Range) ->
                         (T_KindArgument)
sem_KindArgument_Star (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (KindArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- self rule
            (_self@_) =
                KindArgument_Star _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- KindIndexedBinding ------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      name                 : Name
      self                 : SELF

-}
{-
   local variables for KindIndexedBinding.KindIndexedBinding:
      self

-}
-- semantic domain
type T_KindIndexedBinding = (Maybe Name) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Strings) ->
                            (FMap Name [(Name,Name)]) ->
                            (Bool) ->
                            (FMap Name [(Name,Name)]) ->
                            (FMap Name [(Name,Name)]) ->
                            (Maybe Name) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Bool) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Bool) ->
                            ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(Name),(KindIndexedBinding))
-- cata
sem_KindIndexedBinding :: (KindIndexedBinding) ->
                          (T_KindIndexedBinding)
sem_KindIndexedBinding ((KindIndexedBinding_KindIndexedBinding (_range) (_name) (_kindargument) (_typevariables) (_type))) =
    (sem_KindIndexedBinding_KindIndexedBinding ((sem_Range (_range))) ((sem_Name (_name))) ((sem_KindArgument (_kindargument))) ((sem_Names (_typevariables))) ((sem_Type (_type))))
sem_KindIndexedBinding_KindIndexedBinding :: (T_Range) ->
                                             (T_Name) ->
                                             (T_KindArgument) ->
                                             (T_Names) ->
                                             (T_Type) ->
                                             (T_KindIndexedBinding)
sem_KindIndexedBinding_KindIndexedBinding (range_) (name_) (kindargument_) (typevariables_) (type_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (KindIndexedBinding)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _kindargumentIconstructors_collect :: (FMap Name Names)
            _kindargumentIdependencies_collect :: (FMap Name [(Name,Name)])
            _kindargumentIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _kindargumentIlabels_collect :: (FMap Name Names)
            _kindargumentImethods_collect :: (FMap Name Names)
            _kindargumentIself :: (KindArgument)
            _kindargumentOclassname :: (Maybe Name)
            _kindargumentOconstructors_collect :: (FMap Name Names)
            _kindargumentOconstructors_dist :: (FMap Name Names)
            _kindargumentOcurrentModule :: (Strings)
            _kindargumentOdependencies_collect :: (FMap Name [(Name,Name)])
            _kindargumentOimportedModule :: (Bool)
            _kindargumentOinferredDependencies :: (FMap Name [(Name,Name)])
            _kindargumentOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _kindargumentOinstancename :: (Maybe Name)
            _kindargumentOlabels_collect :: (FMap Name Names)
            _kindargumentOlabels_dist :: (FMap Name Names)
            _kindargumentOlocal :: (Bool)
            _kindargumentOmethods_collect :: (FMap Name Names)
            _kindargumentOmethods_dist :: (FMap Name Names)
            _kindargumentOtoplevel :: (Bool)
            _typevariablesIconstructors_collect :: (FMap Name Names)
            _typevariablesIdependencies_collect :: (FMap Name [(Name,Name)])
            _typevariablesIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typevariablesIlabels_collect :: (FMap Name Names)
            _typevariablesImethods_collect :: (FMap Name Names)
            _typevariablesIself :: (Names)
            _typevariablesOclassname :: (Maybe Name)
            _typevariablesOconstructors_collect :: (FMap Name Names)
            _typevariablesOconstructors_dist :: (FMap Name Names)
            _typevariablesOcurrentModule :: (Strings)
            _typevariablesOdependencies_collect :: (FMap Name [(Name,Name)])
            _typevariablesOimportedModule :: (Bool)
            _typevariablesOinferredDependencies :: (FMap Name [(Name,Name)])
            _typevariablesOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typevariablesOinstancename :: (Maybe Name)
            _typevariablesOlabels_collect :: (FMap Name Names)
            _typevariablesOlabels_dist :: (FMap Name Names)
            _typevariablesOlocal :: (Bool)
            _typevariablesOmethods_collect :: (FMap Name Names)
            _typevariablesOmethods_dist :: (FMap Name Names)
            _typevariablesOtoplevel :: (Bool)
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIdependencies_collect :: (FMap Name [(Name,Name)])
            _typeIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typeIlabels_collect :: (FMap Name Names)
            _typeIlocalDependencies :: ([(Name,Name)])
            _typeImethods_collect :: (FMap Name Names)
            _typeIself :: (Type)
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOdependencies_collect :: (FMap Name [(Name,Name)])
            _typeOimportedModule :: (Bool)
            _typeOinferredDependencies :: (FMap Name [(Name,Name)])
            _typeOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typeOinstancename :: (Maybe Name)
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _kindargumentIconstructors_collect,_kindargumentIdependencies_collect,_kindargumentIinferredDependencies_collect,_kindargumentIlabels_collect,_kindargumentImethods_collect,_kindargumentIself) =
                (kindargument_ (_kindargumentOclassname)
                               (_kindargumentOconstructors_collect)
                               (_kindargumentOconstructors_dist)
                               (_kindargumentOcurrentModule)
                               (_kindargumentOdependencies_collect)
                               (_kindargumentOimportedModule)
                               (_kindargumentOinferredDependencies)
                               (_kindargumentOinferredDependencies_collect)
                               (_kindargumentOinstancename)
                               (_kindargumentOlabels_collect)
                               (_kindargumentOlabels_dist)
                               (_kindargumentOlocal)
                               (_kindargumentOmethods_collect)
                               (_kindargumentOmethods_dist)
                               (_kindargumentOtoplevel))
            ( _typevariablesIconstructors_collect,_typevariablesIdependencies_collect,_typevariablesIinferredDependencies_collect,_typevariablesIlabels_collect,_typevariablesImethods_collect,_typevariablesIself) =
                (typevariables_ (_typevariablesOclassname)
                                (_typevariablesOconstructors_collect)
                                (_typevariablesOconstructors_dist)
                                (_typevariablesOcurrentModule)
                                (_typevariablesOdependencies_collect)
                                (_typevariablesOimportedModule)
                                (_typevariablesOinferredDependencies)
                                (_typevariablesOinferredDependencies_collect)
                                (_typevariablesOinstancename)
                                (_typevariablesOlabels_collect)
                                (_typevariablesOlabels_dist)
                                (_typevariablesOlocal)
                                (_typevariablesOmethods_collect)
                                (_typevariablesOmethods_dist)
                                (_typevariablesOtoplevel))
            ( _typeIconstructors_collect,_typeIdependencies_collect,_typeIinferredDependencies_collect,_typeIlabels_collect,_typeIlocalDependencies,_typeImethods_collect,_typeIself) =
                (type_ (_typeOclassname) (_typeOconstructors_collect) (_typeOconstructors_dist) (_typeOcurrentModule) (_typeOdependencies_collect) (_typeOimportedModule) (_typeOinferredDependencies) (_typeOinferredDependencies_collect) (_typeOinstancename) (_typeOlabels_collect) (_typeOlabels_dist) (_typeOlocal) (_typeOmethods_collect) (_typeOmethods_dist) (_typeOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 162, column 8)
            (_typeOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 161, column 8)
            (_typevariablesOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 160, column 8)
            (_kindargumentOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 417, column 9)
            (_lhsOname@_) =
                _nameIself
            -- self rule
            (_self@_) =
                KindIndexedBinding_KindIndexedBinding _rangeIself _nameIself _kindargumentIself _typevariablesIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _typeIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _typeIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_kindargumentOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_kindargumentOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_kindargumentOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_kindargumentOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_kindargumentOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_kindargumentOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_kindargumentOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_kindargumentOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_kindargumentOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_kindargumentOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_kindargumentOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_kindargumentOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_kindargumentOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_kindargumentOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typevariablesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typevariablesOconstructors_collect@_) =
                _kindargumentIconstructors_collect
            -- copy rule (down)
            (_typevariablesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typevariablesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_typevariablesOdependencies_collect@_) =
                _kindargumentIdependencies_collect
            -- copy rule (down)
            (_typevariablesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typevariablesOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_typevariablesOinferredDependencies_collect@_) =
                _kindargumentIinferredDependencies_collect
            -- copy rule (down)
            (_typevariablesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typevariablesOlabels_collect@_) =
                _kindargumentIlabels_collect
            -- copy rule (down)
            (_typevariablesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typevariablesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typevariablesOmethods_collect@_) =
                _kindargumentImethods_collect
            -- copy rule (down)
            (_typevariablesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _typevariablesIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_typeOdependencies_collect@_) =
                _typevariablesIdependencies_collect
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_typeOinferredDependencies_collect@_) =
                _typevariablesIinferredDependencies_collect
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _typevariablesIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _typevariablesImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
-- KindIndexedBindings -----------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      name                 : Name
      self                 : SELF

-}
{-
   local variables for KindIndexedBindings.Cons:
      self

-}
{-
   local variables for KindIndexedBindings.Nil:
      self

-}
-- semantic domain
type T_KindIndexedBindings = (Maybe Name) ->
                             (FMap Name Names) ->
                             (FMap Name Names) ->
                             (Strings) ->
                             (FMap Name [(Name,Name)]) ->
                             (Bool) ->
                             (FMap Name [(Name,Name)]) ->
                             (FMap Name [(Name,Name)]) ->
                             (Maybe Name) ->
                             (FMap Name Names) ->
                             (FMap Name Names) ->
                             (Bool) ->
                             (FMap Name Names) ->
                             (FMap Name Names) ->
                             (Bool) ->
                             ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(Name),(KindIndexedBindings))
-- cata
sem_KindIndexedBindings :: (KindIndexedBindings) ->
                           (T_KindIndexedBindings)
sem_KindIndexedBindings (list) =
    (foldr (sem_KindIndexedBindings_Cons) (sem_KindIndexedBindings_Nil) ((map sem_KindIndexedBinding list)))
sem_KindIndexedBindings_Cons :: (T_KindIndexedBinding) ->
                                (T_KindIndexedBindings) ->
                                (T_KindIndexedBindings)
sem_KindIndexedBindings_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (KindIndexedBindings)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdependencies_collect :: (FMap Name [(Name,Name)])
            _hdIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIname :: (Name)
            _hdIself :: (KindIndexedBinding)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies_collect :: (FMap Name [(Name,Name)])
            _hdOimportedModule :: (Bool)
            _hdOinferredDependencies :: (FMap Name [(Name,Name)])
            _hdOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdOinstancename :: (Maybe Name)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdependencies_collect :: (FMap Name [(Name,Name)])
            _tlIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIname :: (Name)
            _tlIself :: (KindIndexedBindings)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies_collect :: (FMap Name [(Name,Name)])
            _tlOimportedModule :: (Bool)
            _tlOinferredDependencies :: (FMap Name [(Name,Name)])
            _tlOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIdependencies_collect,_hdIinferredDependencies_collect,_hdIlabels_collect,_hdImethods_collect,_hdIname,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOdependencies_collect) (_hdOimportedModule) (_hdOinferredDependencies) (_hdOinferredDependencies_collect) (_hdOinstancename) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIdependencies_collect,_tlIinferredDependencies_collect,_tlIlabels_collect,_tlImethods_collect,_tlIname,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOdependencies_collect) (_tlOimportedModule) (_tlOinferredDependencies) (_tlOinferredDependencies_collect) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 410, column 9)
            (_lhsOname@_) =
                _hdIname
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _tlIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _tlIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_hdOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_tlOdependencies_collect@_) =
                _hdIdependencies_collect
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_tlOinferredDependencies_collect@_) =
                _hdIinferredDependencies_collect
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
sem_KindIndexedBindings_Nil :: (T_KindIndexedBindings)
sem_KindIndexedBindings_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (KindIndexedBindings)
            -- "./ModuleInformation.inc.lag"(line 412, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.KindIndexedBindings.Nil.lhs.name: no bindings"
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
-- LeftHandSide ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      name                 : Name
      self                 : SELF

-}
{-
   local variables for LeftHandSide.Function:
      self

-}
{-
   local variables for LeftHandSide.Infix:
      self

-}
{-
   local variables for LeftHandSide.Parenthesized:
      self

-}
-- semantic domain
type T_LeftHandSide = (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Strings) ->
                      (FMap Name [(Name,Name)]) ->
                      (Bool) ->
                      (FMap Name [(Name,Name)]) ->
                      (FMap Name [(Name,Name)]) ->
                      (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(Name),(LeftHandSide))
-- cata
sem_LeftHandSide :: (LeftHandSide) ->
                    (T_LeftHandSide)
sem_LeftHandSide ((LeftHandSide_Function (_range) (_name) (_patterns))) =
    (sem_LeftHandSide_Function ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Patterns (_patterns))))
sem_LeftHandSide ((LeftHandSide_Infix (_range) (_leftPattern) (_operator) (_rightPattern))) =
    (sem_LeftHandSide_Infix ((sem_Range (_range))) ((sem_Pattern (_leftPattern))) ((sem_Name (_operator))) ((sem_Pattern (_rightPattern))))
sem_LeftHandSide ((LeftHandSide_Parenthesized (_range) (_lefthandside) (_patterns))) =
    (sem_LeftHandSide_Parenthesized ((sem_Range (_range))) ((sem_LeftHandSide (_lefthandside))) ((sem_Patterns (_patterns))))
sem_LeftHandSide_Function :: (T_Range) ->
                             (T_Name) ->
                             (T_Patterns) ->
                             (T_LeftHandSide)
sem_LeftHandSide_Function (range_) (name_) (patterns_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (LeftHandSide)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _patternsIconstructors_collect :: (FMap Name Names)
            _patternsIdependencies_collect :: (FMap Name [(Name,Name)])
            _patternsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _patternsIlabels_collect :: (FMap Name Names)
            _patternsImethods_collect :: (FMap Name Names)
            _patternsIself :: (Patterns)
            _patternsOclassname :: (Maybe Name)
            _patternsOconstructors_collect :: (FMap Name Names)
            _patternsOconstructors_dist :: (FMap Name Names)
            _patternsOcurrentModule :: (Strings)
            _patternsOdependencies_collect :: (FMap Name [(Name,Name)])
            _patternsOimportedModule :: (Bool)
            _patternsOinferredDependencies :: (FMap Name [(Name,Name)])
            _patternsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _patternsOinstancename :: (Maybe Name)
            _patternsOlabels_collect :: (FMap Name Names)
            _patternsOlabels_dist :: (FMap Name Names)
            _patternsOlocal :: (Bool)
            _patternsOmethods_collect :: (FMap Name Names)
            _patternsOmethods_dist :: (FMap Name Names)
            _patternsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _patternsIconstructors_collect,_patternsIdependencies_collect,_patternsIinferredDependencies_collect,_patternsIlabels_collect,_patternsImethods_collect,_patternsIself) =
                (patterns_ (_patternsOclassname) (_patternsOconstructors_collect) (_patternsOconstructors_dist) (_patternsOcurrentModule) (_patternsOdependencies_collect) (_patternsOimportedModule) (_patternsOinferredDependencies) (_patternsOinferredDependencies_collect) (_patternsOinstancename) (_patternsOlabels_collect) (_patternsOlabels_dist) (_patternsOlocal) (_patternsOmethods_collect) (_patternsOmethods_dist) (_patternsOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 176, column 8)
            (_patternsOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 404, column 9)
            (_lhsOname@_) =
                _nameIself
            -- self rule
            (_self@_) =
                LeftHandSide_Function _rangeIself _nameIself _patternsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _patternsIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _patternsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _patternsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _patternsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _patternsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_patternsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_patternsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_patternsOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_patternsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_patternsOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_patternsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_patternsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_patternsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_patternsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_patternsOmethods_dist@_) =
                _lhsImethods_dist
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
sem_LeftHandSide_Infix :: (T_Range) ->
                          (T_Pattern) ->
                          (T_Name) ->
                          (T_Pattern) ->
                          (T_LeftHandSide)
sem_LeftHandSide_Infix (range_) (leftPattern_) (operator_) (rightPattern_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (LeftHandSide)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _leftPatternIconstructors_collect :: (FMap Name Names)
            _leftPatternIdependencies_collect :: (FMap Name [(Name,Name)])
            _leftPatternIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _leftPatternIlabels_collect :: (FMap Name Names)
            _leftPatternImethods_collect :: (FMap Name Names)
            _leftPatternIname :: (Name)
            _leftPatternIself :: (Pattern)
            _leftPatternOclassname :: (Maybe Name)
            _leftPatternOconstructors_collect :: (FMap Name Names)
            _leftPatternOconstructors_dist :: (FMap Name Names)
            _leftPatternOcurrentModule :: (Strings)
            _leftPatternOdependencies_collect :: (FMap Name [(Name,Name)])
            _leftPatternOimportedModule :: (Bool)
            _leftPatternOinferredDependencies :: (FMap Name [(Name,Name)])
            _leftPatternOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _leftPatternOinstancename :: (Maybe Name)
            _leftPatternOlabels_collect :: (FMap Name Names)
            _leftPatternOlabels_dist :: (FMap Name Names)
            _leftPatternOlocal :: (Bool)
            _leftPatternOmethods_collect :: (FMap Name Names)
            _leftPatternOmethods_dist :: (FMap Name Names)
            _leftPatternOtoplevel :: (Bool)
            _operatorIconstructors_collect :: (FMap Name Names)
            _operatorIdependencies_collect :: (FMap Name [(Name,Name)])
            _operatorIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _operatorIlabels_collect :: (FMap Name Names)
            _operatorImethods_collect :: (FMap Name Names)
            _operatorIself :: (Name)
            _operatorOclassname :: (Maybe Name)
            _operatorOconstructors_collect :: (FMap Name Names)
            _operatorOconstructors_dist :: (FMap Name Names)
            _operatorOcurrentModule :: (Strings)
            _operatorOdependencies_collect :: (FMap Name [(Name,Name)])
            _operatorOimportedModule :: (Bool)
            _operatorOinferredDependencies :: (FMap Name [(Name,Name)])
            _operatorOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _operatorOinstancename :: (Maybe Name)
            _operatorOlabels_collect :: (FMap Name Names)
            _operatorOlabels_dist :: (FMap Name Names)
            _operatorOlocal :: (Bool)
            _operatorOmethods_collect :: (FMap Name Names)
            _operatorOmethods_dist :: (FMap Name Names)
            _operatorOtoplevel :: (Bool)
            _rightPatternIconstructors_collect :: (FMap Name Names)
            _rightPatternIdependencies_collect :: (FMap Name [(Name,Name)])
            _rightPatternIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _rightPatternIlabels_collect :: (FMap Name Names)
            _rightPatternImethods_collect :: (FMap Name Names)
            _rightPatternIname :: (Name)
            _rightPatternIself :: (Pattern)
            _rightPatternOclassname :: (Maybe Name)
            _rightPatternOconstructors_collect :: (FMap Name Names)
            _rightPatternOconstructors_dist :: (FMap Name Names)
            _rightPatternOcurrentModule :: (Strings)
            _rightPatternOdependencies_collect :: (FMap Name [(Name,Name)])
            _rightPatternOimportedModule :: (Bool)
            _rightPatternOinferredDependencies :: (FMap Name [(Name,Name)])
            _rightPatternOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _rightPatternOinstancename :: (Maybe Name)
            _rightPatternOlabels_collect :: (FMap Name Names)
            _rightPatternOlabels_dist :: (FMap Name Names)
            _rightPatternOlocal :: (Bool)
            _rightPatternOmethods_collect :: (FMap Name Names)
            _rightPatternOmethods_dist :: (FMap Name Names)
            _rightPatternOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _leftPatternIconstructors_collect,_leftPatternIdependencies_collect,_leftPatternIinferredDependencies_collect,_leftPatternIlabels_collect,_leftPatternImethods_collect,_leftPatternIname,_leftPatternIself) =
                (leftPattern_ (_leftPatternOclassname)
                              (_leftPatternOconstructors_collect)
                              (_leftPatternOconstructors_dist)
                              (_leftPatternOcurrentModule)
                              (_leftPatternOdependencies_collect)
                              (_leftPatternOimportedModule)
                              (_leftPatternOinferredDependencies)
                              (_leftPatternOinferredDependencies_collect)
                              (_leftPatternOinstancename)
                              (_leftPatternOlabels_collect)
                              (_leftPatternOlabels_dist)
                              (_leftPatternOlocal)
                              (_leftPatternOmethods_collect)
                              (_leftPatternOmethods_dist)
                              (_leftPatternOtoplevel))
            ( _operatorIconstructors_collect,_operatorIdependencies_collect,_operatorIinferredDependencies_collect,_operatorIlabels_collect,_operatorImethods_collect,_operatorIself) =
                (operator_ (_operatorOclassname) (_operatorOconstructors_collect) (_operatorOconstructors_dist) (_operatorOcurrentModule) (_operatorOdependencies_collect) (_operatorOimportedModule) (_operatorOinferredDependencies) (_operatorOinferredDependencies_collect) (_operatorOinstancename) (_operatorOlabels_collect) (_operatorOlabels_dist) (_operatorOlocal) (_operatorOmethods_collect) (_operatorOmethods_dist) (_operatorOtoplevel))
            ( _rightPatternIconstructors_collect,_rightPatternIdependencies_collect,_rightPatternIinferredDependencies_collect,_rightPatternIlabels_collect,_rightPatternImethods_collect,_rightPatternIname,_rightPatternIself) =
                (rightPattern_ (_rightPatternOclassname)
                               (_rightPatternOconstructors_collect)
                               (_rightPatternOconstructors_dist)
                               (_rightPatternOcurrentModule)
                               (_rightPatternOdependencies_collect)
                               (_rightPatternOimportedModule)
                               (_rightPatternOinferredDependencies)
                               (_rightPatternOinferredDependencies_collect)
                               (_rightPatternOinstancename)
                               (_rightPatternOlabels_collect)
                               (_rightPatternOlabels_dist)
                               (_rightPatternOlocal)
                               (_rightPatternOmethods_collect)
                               (_rightPatternOmethods_dist)
                               (_rightPatternOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 179, column 8)
            (_rightPatternOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 178, column 8)
            (_leftPatternOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 406, column 9)
            (_lhsOname@_) =
                _operatorIself
            -- self rule
            (_self@_) =
                LeftHandSide_Infix _rangeIself _leftPatternIself _operatorIself _rightPatternIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _rightPatternIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _rightPatternIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _rightPatternIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _rightPatternIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _rightPatternImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_leftPatternOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_leftPatternOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_leftPatternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_leftPatternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_leftPatternOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_leftPatternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_leftPatternOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_leftPatternOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_leftPatternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_leftPatternOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_leftPatternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_leftPatternOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_leftPatternOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_leftPatternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_operatorOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_operatorOconstructors_collect@_) =
                _leftPatternIconstructors_collect
            -- copy rule (down)
            (_operatorOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_operatorOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_operatorOdependencies_collect@_) =
                _leftPatternIdependencies_collect
            -- copy rule (down)
            (_operatorOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_operatorOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_operatorOinferredDependencies_collect@_) =
                _leftPatternIinferredDependencies_collect
            -- copy rule (down)
            (_operatorOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_operatorOlabels_collect@_) =
                _leftPatternIlabels_collect
            -- copy rule (down)
            (_operatorOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_operatorOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_operatorOmethods_collect@_) =
                _leftPatternImethods_collect
            -- copy rule (down)
            (_operatorOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_operatorOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_rightPatternOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_rightPatternOconstructors_collect@_) =
                _operatorIconstructors_collect
            -- copy rule (down)
            (_rightPatternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_rightPatternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_rightPatternOdependencies_collect@_) =
                _operatorIdependencies_collect
            -- copy rule (down)
            (_rightPatternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rightPatternOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_rightPatternOinferredDependencies_collect@_) =
                _operatorIinferredDependencies_collect
            -- copy rule (down)
            (_rightPatternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_rightPatternOlabels_collect@_) =
                _operatorIlabels_collect
            -- copy rule (down)
            (_rightPatternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_rightPatternOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_rightPatternOmethods_collect@_) =
                _operatorImethods_collect
            -- copy rule (down)
            (_rightPatternOmethods_dist@_) =
                _lhsImethods_dist
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
sem_LeftHandSide_Parenthesized :: (T_Range) ->
                                  (T_LeftHandSide) ->
                                  (T_Patterns) ->
                                  (T_LeftHandSide)
sem_LeftHandSide_Parenthesized (range_) (lefthandside_) (patterns_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (LeftHandSide)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _lefthandsideIconstructors_collect :: (FMap Name Names)
            _lefthandsideIdependencies_collect :: (FMap Name [(Name,Name)])
            _lefthandsideIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lefthandsideIlabels_collect :: (FMap Name Names)
            _lefthandsideImethods_collect :: (FMap Name Names)
            _lefthandsideIname :: (Name)
            _lefthandsideIself :: (LeftHandSide)
            _lefthandsideOclassname :: (Maybe Name)
            _lefthandsideOconstructors_collect :: (FMap Name Names)
            _lefthandsideOconstructors_dist :: (FMap Name Names)
            _lefthandsideOcurrentModule :: (Strings)
            _lefthandsideOdependencies_collect :: (FMap Name [(Name,Name)])
            _lefthandsideOimportedModule :: (Bool)
            _lefthandsideOinferredDependencies :: (FMap Name [(Name,Name)])
            _lefthandsideOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lefthandsideOinstancename :: (Maybe Name)
            _lefthandsideOlabels_collect :: (FMap Name Names)
            _lefthandsideOlabels_dist :: (FMap Name Names)
            _lefthandsideOlocal :: (Bool)
            _lefthandsideOmethods_collect :: (FMap Name Names)
            _lefthandsideOmethods_dist :: (FMap Name Names)
            _lefthandsideOtoplevel :: (Bool)
            _patternsIconstructors_collect :: (FMap Name Names)
            _patternsIdependencies_collect :: (FMap Name [(Name,Name)])
            _patternsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _patternsIlabels_collect :: (FMap Name Names)
            _patternsImethods_collect :: (FMap Name Names)
            _patternsIself :: (Patterns)
            _patternsOclassname :: (Maybe Name)
            _patternsOconstructors_collect :: (FMap Name Names)
            _patternsOconstructors_dist :: (FMap Name Names)
            _patternsOcurrentModule :: (Strings)
            _patternsOdependencies_collect :: (FMap Name [(Name,Name)])
            _patternsOimportedModule :: (Bool)
            _patternsOinferredDependencies :: (FMap Name [(Name,Name)])
            _patternsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _patternsOinstancename :: (Maybe Name)
            _patternsOlabels_collect :: (FMap Name Names)
            _patternsOlabels_dist :: (FMap Name Names)
            _patternsOlocal :: (Bool)
            _patternsOmethods_collect :: (FMap Name Names)
            _patternsOmethods_dist :: (FMap Name Names)
            _patternsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _lefthandsideIconstructors_collect,_lefthandsideIdependencies_collect,_lefthandsideIinferredDependencies_collect,_lefthandsideIlabels_collect,_lefthandsideImethods_collect,_lefthandsideIname,_lefthandsideIself) =
                (lefthandside_ (_lefthandsideOclassname)
                               (_lefthandsideOconstructors_collect)
                               (_lefthandsideOconstructors_dist)
                               (_lefthandsideOcurrentModule)
                               (_lefthandsideOdependencies_collect)
                               (_lefthandsideOimportedModule)
                               (_lefthandsideOinferredDependencies)
                               (_lefthandsideOinferredDependencies_collect)
                               (_lefthandsideOinstancename)
                               (_lefthandsideOlabels_collect)
                               (_lefthandsideOlabels_dist)
                               (_lefthandsideOlocal)
                               (_lefthandsideOmethods_collect)
                               (_lefthandsideOmethods_dist)
                               (_lefthandsideOtoplevel))
            ( _patternsIconstructors_collect,_patternsIdependencies_collect,_patternsIinferredDependencies_collect,_patternsIlabels_collect,_patternsImethods_collect,_patternsIself) =
                (patterns_ (_patternsOclassname) (_patternsOconstructors_collect) (_patternsOconstructors_dist) (_patternsOcurrentModule) (_patternsOdependencies_collect) (_patternsOimportedModule) (_patternsOinferredDependencies) (_patternsOinferredDependencies_collect) (_patternsOinstancename) (_patternsOlabels_collect) (_patternsOlabels_dist) (_patternsOlocal) (_patternsOmethods_collect) (_patternsOmethods_dist) (_patternsOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 181, column 8)
            (_patternsOtoplevel@_) =
                False
            -- self rule
            (_self@_) =
                LeftHandSide_Parenthesized _rangeIself _lefthandsideIself _patternsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _patternsIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _patternsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _patternsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _patternsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _patternsImethods_collect
            -- copy rule (up)
            (_lhsOname@_) =
                _lefthandsideIname
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_lefthandsideOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_lefthandsideOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_lefthandsideOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_lefthandsideOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_lefthandsideOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_lefthandsideOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_lefthandsideOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_lefthandsideOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_lefthandsideOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_lefthandsideOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_lefthandsideOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_lefthandsideOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_lefthandsideOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_lefthandsideOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_lefthandsideOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_patternsOconstructors_collect@_) =
                _lefthandsideIconstructors_collect
            -- copy rule (down)
            (_patternsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_patternsOdependencies_collect@_) =
                _lefthandsideIdependencies_collect
            -- copy rule (down)
            (_patternsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_patternsOinferredDependencies_collect@_) =
                _lefthandsideIinferredDependencies_collect
            -- copy rule (down)
            (_patternsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_patternsOlabels_collect@_) =
                _lefthandsideIlabels_collect
            -- copy rule (down)
            (_patternsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_patternsOmethods_collect@_) =
                _lefthandsideImethods_collect
            -- copy rule (down)
            (_patternsOmethods_dist@_) =
                _lhsImethods_dist
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
-- Literal -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Literal.Char:
      self

-}
{-
   local variables for Literal.Float:
      self

-}
{-
   local variables for Literal.Int:
      self

-}
{-
   local variables for Literal.String:
      self

-}
-- semantic domain
type T_Literal = (Maybe Name) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Strings) ->
                 (FMap Name [(Name,Name)]) ->
                 (Bool) ->
                 (FMap Name [(Name,Name)]) ->
                 (FMap Name [(Name,Name)]) ->
                 (Maybe Name) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Bool) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Bool) ->
                 ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(Literal))
-- cata
sem_Literal :: (Literal) ->
               (T_Literal)
sem_Literal ((Literal_Char (_range) (_value))) =
    (sem_Literal_Char ((sem_Range (_range))) (_value))
sem_Literal ((Literal_Float (_range) (_value))) =
    (sem_Literal_Float ((sem_Range (_range))) (_value))
sem_Literal ((Literal_Int (_range) (_value))) =
    (sem_Literal_Int ((sem_Range (_range))) (_value))
sem_Literal ((Literal_String (_range) (_value))) =
    (sem_Literal_String ((sem_Range (_range))) (_value))
sem_Literal_Char :: (T_Range) ->
                    (String) ->
                    (T_Literal)
sem_Literal_Char (range_) (value_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Literal)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- self rule
            (_self@_) =
                Literal_Char _rangeIself value_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Literal_Float :: (T_Range) ->
                     (String) ->
                     (T_Literal)
sem_Literal_Float (range_) (value_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Literal)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- self rule
            (_self@_) =
                Literal_Float _rangeIself value_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Literal_Int :: (T_Range) ->
                   (String) ->
                   (T_Literal)
sem_Literal_Int (range_) (value_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Literal)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- self rule
            (_self@_) =
                Literal_Int _rangeIself value_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Literal_String :: (T_Range) ->
                      (String) ->
                      (T_Literal)
sem_Literal_String (range_) (value_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Literal)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- self rule
            (_self@_) =
                Literal_String _rangeIself value_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- MaybeDeclarations -------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      bodyDependencies     : [(Name,Name)]
      self                 : SELF

-}
{-
   local variables for MaybeDeclarations.Just:
      self

-}
{-
   local variables for MaybeDeclarations.Nothing:
      self

-}
-- semantic domain
type T_MaybeDeclarations = (Maybe Name) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Strings) ->
                           (FMap Name [(Name,Name)]) ->
                           (Bool) ->
                           (FMap Name [(Name,Name)]) ->
                           (FMap Name [(Name,Name)]) ->
                           (Maybe Name) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (Bool) ->
                           (FMap Name Names) ->
                           (FMap Name Names) ->
                           (PreSignatures) ->
                           (PreSignatures) ->
                           (Signatures) ->
                           (Bool) ->
                           ( ([(Name,Name)]),(FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(PreSignatures),(MaybeDeclarations))
-- cata
sem_MaybeDeclarations :: (MaybeDeclarations) ->
                         (T_MaybeDeclarations)
sem_MaybeDeclarations ((MaybeDeclarations_Just (_declarations))) =
    (sem_MaybeDeclarations_Just ((sem_Declarations (_declarations))))
sem_MaybeDeclarations ((MaybeDeclarations_Nothing )) =
    (sem_MaybeDeclarations_Nothing )
sem_MaybeDeclarations_Just :: (T_Declarations) ->
                              (T_MaybeDeclarations)
sem_MaybeDeclarations_Just (declarations_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (MaybeDeclarations)
            _declarationsIbodyDependencies :: ([(Name,Name)])
            _declarationsIconstructors_collect :: (FMap Name Names)
            _declarationsIdependencies_collect :: (FMap Name [(Name,Name)])
            _declarationsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _declarationsIlabels_collect :: (FMap Name Names)
            _declarationsImethods_collect :: (FMap Name Names)
            _declarationsIpresignatures_collect :: (PreSignatures)
            _declarationsIself :: (Declarations)
            _declarationsOclassname :: (Maybe Name)
            _declarationsOconstructors_collect :: (FMap Name Names)
            _declarationsOconstructors_dist :: (FMap Name Names)
            _declarationsOcurrentModule :: (Strings)
            _declarationsOdependencies_collect :: (FMap Name [(Name,Name)])
            _declarationsOimportedModule :: (Bool)
            _declarationsOinferredDependencies :: (FMap Name [(Name,Name)])
            _declarationsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _declarationsOinstancename :: (Maybe Name)
            _declarationsOlabels_collect :: (FMap Name Names)
            _declarationsOlabels_dist :: (FMap Name Names)
            _declarationsOlocal :: (Bool)
            _declarationsOmethods_collect :: (FMap Name Names)
            _declarationsOmethods_dist :: (FMap Name Names)
            _declarationsOpresignatures :: (PreSignatures)
            _declarationsOpresignatures_collect :: (PreSignatures)
            _declarationsOsignatures :: (Signatures)
            _declarationsOtoplevel :: (Bool)
            ( _declarationsIbodyDependencies,_declarationsIconstructors_collect,_declarationsIdependencies_collect,_declarationsIinferredDependencies_collect,_declarationsIlabels_collect,_declarationsImethods_collect,_declarationsIpresignatures_collect,_declarationsIself) =
                (declarations_ (_declarationsOclassname)
                               (_declarationsOconstructors_collect)
                               (_declarationsOconstructors_dist)
                               (_declarationsOcurrentModule)
                               (_declarationsOdependencies_collect)
                               (_declarationsOimportedModule)
                               (_declarationsOinferredDependencies)
                               (_declarationsOinferredDependencies_collect)
                               (_declarationsOinstancename)
                               (_declarationsOlabels_collect)
                               (_declarationsOlabels_dist)
                               (_declarationsOlocal)
                               (_declarationsOmethods_collect)
                               (_declarationsOmethods_dist)
                               (_declarationsOpresignatures)
                               (_declarationsOpresignatures_collect)
                               (_declarationsOsignatures)
                               (_declarationsOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _declarationsIbodyDependencies
            -- self rule
            (_self@_) =
                MaybeDeclarations_Just _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _declarationsIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _declarationsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _declarationsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _declarationsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _declarationsImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _declarationsIpresignatures_collect
            -- copy rule (down)
            (_declarationsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_declarationsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_declarationsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_declarationsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_declarationsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_declarationsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_declarationsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_declarationsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_declarationsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_declarationsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_declarationsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_declarationsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_declarationsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_declarationsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_declarationsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_declarationsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_declarationsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_declarationsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_MaybeDeclarations_Nothing :: (T_MaybeDeclarations)
sem_MaybeDeclarations_Nothing  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (MaybeDeclarations)
            -- use rule
            (_lhsObodyDependencies@_) =
                []
            -- self rule
            (_self@_) =
                MaybeDeclarations_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- MaybeExports ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for MaybeExports.Just:
      self

-}
{-
   local variables for MaybeExports.Nothing:
      self

-}
-- semantic domain
type T_MaybeExports = (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Strings) ->
                      (FMap Name [(Name,Name)]) ->
                      (Bool) ->
                      (FMap Name [(Name,Name)]) ->
                      (FMap Name [(Name,Name)]) ->
                      (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(MaybeExports))
-- cata
sem_MaybeExports :: (MaybeExports) ->
                    (T_MaybeExports)
sem_MaybeExports ((MaybeExports_Just (_exports))) =
    (sem_MaybeExports_Just ((sem_Exports (_exports))))
sem_MaybeExports ((MaybeExports_Nothing )) =
    (sem_MaybeExports_Nothing )
sem_MaybeExports_Just :: (T_Exports) ->
                         (T_MaybeExports)
sem_MaybeExports_Just (exports_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (MaybeExports)
            _exportsIconstructors_collect :: (FMap Name Names)
            _exportsIdependencies_collect :: (FMap Name [(Name,Name)])
            _exportsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _exportsIlabels_collect :: (FMap Name Names)
            _exportsImethods_collect :: (FMap Name Names)
            _exportsIself :: (Exports)
            _exportsOclassname :: (Maybe Name)
            _exportsOconstructors_collect :: (FMap Name Names)
            _exportsOconstructors_dist :: (FMap Name Names)
            _exportsOcurrentModule :: (Strings)
            _exportsOdependencies_collect :: (FMap Name [(Name,Name)])
            _exportsOimportedModule :: (Bool)
            _exportsOinferredDependencies :: (FMap Name [(Name,Name)])
            _exportsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _exportsOinstancename :: (Maybe Name)
            _exportsOlabels_collect :: (FMap Name Names)
            _exportsOlabels_dist :: (FMap Name Names)
            _exportsOlocal :: (Bool)
            _exportsOmethods_collect :: (FMap Name Names)
            _exportsOmethods_dist :: (FMap Name Names)
            _exportsOtoplevel :: (Bool)
            ( _exportsIconstructors_collect,_exportsIdependencies_collect,_exportsIinferredDependencies_collect,_exportsIlabels_collect,_exportsImethods_collect,_exportsIself) =
                (exports_ (_exportsOclassname) (_exportsOconstructors_collect) (_exportsOconstructors_dist) (_exportsOcurrentModule) (_exportsOdependencies_collect) (_exportsOimportedModule) (_exportsOinferredDependencies) (_exportsOinferredDependencies_collect) (_exportsOinstancename) (_exportsOlabels_collect) (_exportsOlabels_dist) (_exportsOlocal) (_exportsOmethods_collect) (_exportsOmethods_dist) (_exportsOtoplevel))
            -- self rule
            (_self@_) =
                MaybeExports_Just _exportsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _exportsIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _exportsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _exportsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _exportsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _exportsImethods_collect
            -- copy rule (down)
            (_exportsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_exportsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_exportsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_exportsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_exportsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_exportsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_exportsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_exportsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_exportsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_exportsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_exportsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_exportsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_exportsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_exportsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_exportsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_MaybeExports_Nothing :: (T_MaybeExports)
sem_MaybeExports_Nothing  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (MaybeExports)
            -- self rule
            (_self@_) =
                MaybeExports_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- MaybeExpression ---------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      bodyDependencies     : [(Name,Name)]
      self                 : SELF

-}
{-
   local variables for MaybeExpression.Just:
      self

-}
{-
   local variables for MaybeExpression.Nothing:
      self

-}
-- semantic domain
type T_MaybeExpression = (Maybe Name) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (Strings) ->
                         (FMap Name [(Name,Name)]) ->
                         (Bool) ->
                         (FMap Name [(Name,Name)]) ->
                         (FMap Name [(Name,Name)]) ->
                         (Maybe Name) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (Bool) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (PreSignatures) ->
                         (PreSignatures) ->
                         (Signatures) ->
                         (Bool) ->
                         ( ([(Name,Name)]),(FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(PreSignatures),(MaybeExpression))
-- cata
sem_MaybeExpression :: (MaybeExpression) ->
                       (T_MaybeExpression)
sem_MaybeExpression ((MaybeExpression_Just (_expression))) =
    (sem_MaybeExpression_Just ((sem_Expression (_expression))))
sem_MaybeExpression ((MaybeExpression_Nothing )) =
    (sem_MaybeExpression_Nothing )
sem_MaybeExpression_Just :: (T_Expression) ->
                            (T_MaybeExpression)
sem_MaybeExpression_Just (expression_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (MaybeExpression)
            _expressionIbodyDependencies :: ([(Name,Name)])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOimportedModule :: (Bool)
            _expressionOinferredDependencies :: (FMap Name [(Name,Name)])
            _expressionOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOinstancename :: (Maybe Name)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOsignatures :: (Signatures)
            _expressionOtoplevel :: (Bool)
            ( _expressionIbodyDependencies,_expressionIconstructors_collect,_expressionIdependencies_collect,_expressionIinferredDependencies_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionIpresignatures_collect,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies_collect)
                             (_expressionOimportedModule)
                             (_expressionOinferredDependencies)
                             (_expressionOinferredDependencies_collect)
                             (_expressionOinstancename)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOsignatures)
                             (_expressionOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _expressionIbodyDependencies
            -- self rule
            (_self@_) =
                MaybeExpression_Just _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _expressionIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _expressionIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_expressionOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_MaybeExpression_Nothing :: (T_MaybeExpression)
sem_MaybeExpression_Nothing  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (MaybeExpression)
            -- use rule
            (_lhsObodyDependencies@_) =
                []
            -- self rule
            (_self@_) =
                MaybeExpression_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- MaybeImportSpecification ------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for MaybeImportSpecification.Just:
      self

-}
{-
   local variables for MaybeImportSpecification.Nothing:
      self

-}
-- semantic domain
type T_MaybeImportSpecification = (Maybe Name) ->
                                  (FMap Name Names) ->
                                  (FMap Name Names) ->
                                  (Strings) ->
                                  (FMap Name [(Name,Name)]) ->
                                  (Bool) ->
                                  (FMap Name [(Name,Name)]) ->
                                  (FMap Name [(Name,Name)]) ->
                                  (Maybe Name) ->
                                  (FMap Name Names) ->
                                  (FMap Name Names) ->
                                  (Bool) ->
                                  (FMap Name Names) ->
                                  (FMap Name Names) ->
                                  (PreSignatures) ->
                                  (PreSignatures) ->
                                  (Signatures) ->
                                  (Bool) ->
                                  ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(PreSignatures),(MaybeImportSpecification))
-- cata
sem_MaybeImportSpecification :: (MaybeImportSpecification) ->
                                (T_MaybeImportSpecification)
sem_MaybeImportSpecification ((MaybeImportSpecification_Just (_importspecification))) =
    (sem_MaybeImportSpecification_Just ((sem_ImportSpecification (_importspecification))))
sem_MaybeImportSpecification ((MaybeImportSpecification_Nothing )) =
    (sem_MaybeImportSpecification_Nothing )
sem_MaybeImportSpecification_Just :: (T_ImportSpecification) ->
                                     (T_MaybeImportSpecification)
sem_MaybeImportSpecification_Just (importspecification_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (MaybeImportSpecification)
            _importspecificationIconstructors_collect :: (FMap Name Names)
            _importspecificationIdependencies_collect :: (FMap Name [(Name,Name)])
            _importspecificationIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _importspecificationIlabels_collect :: (FMap Name Names)
            _importspecificationImethods_collect :: (FMap Name Names)
            _importspecificationIpresignatures_collect :: (PreSignatures)
            _importspecificationIself :: (ImportSpecification)
            _importspecificationOclassname :: (Maybe Name)
            _importspecificationOconstructors_collect :: (FMap Name Names)
            _importspecificationOconstructors_dist :: (FMap Name Names)
            _importspecificationOcurrentModule :: (Strings)
            _importspecificationOdependencies_collect :: (FMap Name [(Name,Name)])
            _importspecificationOimportedModule :: (Bool)
            _importspecificationOinferredDependencies :: (FMap Name [(Name,Name)])
            _importspecificationOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _importspecificationOinstancename :: (Maybe Name)
            _importspecificationOlabels_collect :: (FMap Name Names)
            _importspecificationOlabels_dist :: (FMap Name Names)
            _importspecificationOlocal :: (Bool)
            _importspecificationOmethods_collect :: (FMap Name Names)
            _importspecificationOmethods_dist :: (FMap Name Names)
            _importspecificationOpresignatures :: (PreSignatures)
            _importspecificationOpresignatures_collect :: (PreSignatures)
            _importspecificationOsignatures :: (Signatures)
            _importspecificationOtoplevel :: (Bool)
            ( _importspecificationIconstructors_collect,_importspecificationIdependencies_collect,_importspecificationIinferredDependencies_collect,_importspecificationIlabels_collect,_importspecificationImethods_collect,_importspecificationIpresignatures_collect,_importspecificationIself) =
                (importspecification_ (_importspecificationOclassname)
                                      (_importspecificationOconstructors_collect)
                                      (_importspecificationOconstructors_dist)
                                      (_importspecificationOcurrentModule)
                                      (_importspecificationOdependencies_collect)
                                      (_importspecificationOimportedModule)
                                      (_importspecificationOinferredDependencies)
                                      (_importspecificationOinferredDependencies_collect)
                                      (_importspecificationOinstancename)
                                      (_importspecificationOlabels_collect)
                                      (_importspecificationOlabels_dist)
                                      (_importspecificationOlocal)
                                      (_importspecificationOmethods_collect)
                                      (_importspecificationOmethods_dist)
                                      (_importspecificationOpresignatures)
                                      (_importspecificationOpresignatures_collect)
                                      (_importspecificationOsignatures)
                                      (_importspecificationOtoplevel))
            -- self rule
            (_self@_) =
                MaybeImportSpecification_Just _importspecificationIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _importspecificationIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _importspecificationIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _importspecificationIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _importspecificationIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _importspecificationImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _importspecificationIpresignatures_collect
            -- copy rule (down)
            (_importspecificationOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_importspecificationOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_importspecificationOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_importspecificationOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_importspecificationOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_importspecificationOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_importspecificationOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_importspecificationOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_importspecificationOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_importspecificationOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_importspecificationOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_importspecificationOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_importspecificationOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_importspecificationOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_importspecificationOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_importspecificationOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_importspecificationOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_importspecificationOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_MaybeImportSpecification_Nothing :: (T_MaybeImportSpecification)
sem_MaybeImportSpecification_Nothing  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (MaybeImportSpecification)
            -- self rule
            (_self@_) =
                MaybeImportSpecification_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- MaybeInt ----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for MaybeInt.Just:
      self

-}
{-
   local variables for MaybeInt.Nothing:
      self

-}
-- semantic domain
type T_MaybeInt = (Maybe Name) ->
                  (FMap Name Names) ->
                  (FMap Name Names) ->
                  (Strings) ->
                  (FMap Name [(Name,Name)]) ->
                  (Bool) ->
                  (FMap Name [(Name,Name)]) ->
                  (FMap Name [(Name,Name)]) ->
                  (Maybe Name) ->
                  (FMap Name Names) ->
                  (FMap Name Names) ->
                  (Bool) ->
                  (FMap Name Names) ->
                  (FMap Name Names) ->
                  (Bool) ->
                  ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(MaybeInt))
-- cata
sem_MaybeInt :: (MaybeInt) ->
                (T_MaybeInt)
sem_MaybeInt ((MaybeInt_Just (_int))) =
    (sem_MaybeInt_Just (_int))
sem_MaybeInt ((MaybeInt_Nothing )) =
    (sem_MaybeInt_Nothing )
sem_MaybeInt_Just :: (Int) ->
                     (T_MaybeInt)
sem_MaybeInt_Just (int_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (MaybeInt)
            -- self rule
            (_self@_) =
                MaybeInt_Just int_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_MaybeInt_Nothing :: (T_MaybeInt)
sem_MaybeInt_Nothing  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (MaybeInt)
            -- self rule
            (_self@_) =
                MaybeInt_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- MaybeKind ---------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for MaybeKind.Just:
      self

-}
{-
   local variables for MaybeKind.Nothing:
      self

-}
-- semantic domain
type T_MaybeKind = (Maybe Name) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (Strings) ->
                   (FMap Name [(Name,Name)]) ->
                   (Bool) ->
                   (FMap Name [(Name,Name)]) ->
                   (FMap Name [(Name,Name)]) ->
                   (Maybe Name) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (Bool) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (Bool) ->
                   ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(MaybeKind))
-- cata
sem_MaybeKind :: (MaybeKind) ->
                 (T_MaybeKind)
sem_MaybeKind ((MaybeKind_Just (_kind))) =
    (sem_MaybeKind_Just ((sem_Kind (_kind))))
sem_MaybeKind ((MaybeKind_Nothing )) =
    (sem_MaybeKind_Nothing )
sem_MaybeKind_Just :: (T_Kind) ->
                      (T_MaybeKind)
sem_MaybeKind_Just (kind_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (MaybeKind)
            _kindIconstructors_collect :: (FMap Name Names)
            _kindIdependencies_collect :: (FMap Name [(Name,Name)])
            _kindIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _kindIlabels_collect :: (FMap Name Names)
            _kindImethods_collect :: (FMap Name Names)
            _kindIself :: (Kind)
            _kindOclassname :: (Maybe Name)
            _kindOconstructors_collect :: (FMap Name Names)
            _kindOconstructors_dist :: (FMap Name Names)
            _kindOcurrentModule :: (Strings)
            _kindOdependencies_collect :: (FMap Name [(Name,Name)])
            _kindOimportedModule :: (Bool)
            _kindOinferredDependencies :: (FMap Name [(Name,Name)])
            _kindOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _kindOinstancename :: (Maybe Name)
            _kindOlabels_collect :: (FMap Name Names)
            _kindOlabels_dist :: (FMap Name Names)
            _kindOlocal :: (Bool)
            _kindOmethods_collect :: (FMap Name Names)
            _kindOmethods_dist :: (FMap Name Names)
            _kindOtoplevel :: (Bool)
            ( _kindIconstructors_collect,_kindIdependencies_collect,_kindIinferredDependencies_collect,_kindIlabels_collect,_kindImethods_collect,_kindIself) =
                (kind_ (_kindOclassname) (_kindOconstructors_collect) (_kindOconstructors_dist) (_kindOcurrentModule) (_kindOdependencies_collect) (_kindOimportedModule) (_kindOinferredDependencies) (_kindOinferredDependencies_collect) (_kindOinstancename) (_kindOlabels_collect) (_kindOlabels_dist) (_kindOlocal) (_kindOmethods_collect) (_kindOmethods_dist) (_kindOtoplevel))
            -- self rule
            (_self@_) =
                MaybeKind_Just _kindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _kindIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _kindIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _kindIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _kindIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _kindImethods_collect
            -- copy rule (down)
            (_kindOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_kindOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_kindOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_kindOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_kindOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_kindOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_kindOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_kindOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_kindOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_kindOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_kindOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_kindOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_kindOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_kindOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_kindOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_MaybeKind_Nothing :: (T_MaybeKind)
sem_MaybeKind_Nothing  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (MaybeKind)
            -- self rule
            (_self@_) =
                MaybeKind_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- MaybeModuleName ---------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for MaybeModuleName.Just:
      self

-}
{-
   local variables for MaybeModuleName.Nothing:
      self

-}
-- semantic domain
type T_MaybeModuleName = (Maybe Name) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (Strings) ->
                         (FMap Name [(Name,Name)]) ->
                         (Bool) ->
                         (FMap Name [(Name,Name)]) ->
                         (FMap Name [(Name,Name)]) ->
                         (Maybe Name) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (Bool) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (Bool) ->
                         ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(MaybeModuleName))
-- cata
sem_MaybeModuleName :: (MaybeModuleName) ->
                       (T_MaybeModuleName)
sem_MaybeModuleName ((MaybeModuleName_Just (_modulename))) =
    (sem_MaybeModuleName_Just ((sem_ModuleName (_modulename))))
sem_MaybeModuleName ((MaybeModuleName_Nothing )) =
    (sem_MaybeModuleName_Nothing )
sem_MaybeModuleName_Just :: (T_ModuleName) ->
                            (T_MaybeModuleName)
sem_MaybeModuleName_Just (modulename_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (MaybeModuleName)
            _modulenameIconstructors_collect :: (FMap Name Names)
            _modulenameIdependencies_collect :: (FMap Name [(Name,Name)])
            _modulenameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _modulenameIlabels_collect :: (FMap Name Names)
            _modulenameImethods_collect :: (FMap Name Names)
            _modulenameIself :: (ModuleName)
            _modulenameOclassname :: (Maybe Name)
            _modulenameOconstructors_collect :: (FMap Name Names)
            _modulenameOconstructors_dist :: (FMap Name Names)
            _modulenameOcurrentModule :: (Strings)
            _modulenameOdependencies_collect :: (FMap Name [(Name,Name)])
            _modulenameOimportedModule :: (Bool)
            _modulenameOinferredDependencies :: (FMap Name [(Name,Name)])
            _modulenameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _modulenameOinstancename :: (Maybe Name)
            _modulenameOlabels_collect :: (FMap Name Names)
            _modulenameOlabels_dist :: (FMap Name Names)
            _modulenameOlocal :: (Bool)
            _modulenameOmethods_collect :: (FMap Name Names)
            _modulenameOmethods_dist :: (FMap Name Names)
            _modulenameOtoplevel :: (Bool)
            ( _modulenameIconstructors_collect,_modulenameIdependencies_collect,_modulenameIinferredDependencies_collect,_modulenameIlabels_collect,_modulenameImethods_collect,_modulenameIself) =
                (modulename_ (_modulenameOclassname)
                             (_modulenameOconstructors_collect)
                             (_modulenameOconstructors_dist)
                             (_modulenameOcurrentModule)
                             (_modulenameOdependencies_collect)
                             (_modulenameOimportedModule)
                             (_modulenameOinferredDependencies)
                             (_modulenameOinferredDependencies_collect)
                             (_modulenameOinstancename)
                             (_modulenameOlabels_collect)
                             (_modulenameOlabels_dist)
                             (_modulenameOlocal)
                             (_modulenameOmethods_collect)
                             (_modulenameOmethods_dist)
                             (_modulenameOtoplevel))
            -- self rule
            (_self@_) =
                MaybeModuleName_Just _modulenameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _modulenameIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _modulenameIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _modulenameIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _modulenameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _modulenameImethods_collect
            -- copy rule (down)
            (_modulenameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_modulenameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_modulenameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_modulenameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_modulenameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_modulenameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_modulenameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_modulenameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_modulenameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_modulenameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_modulenameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_modulenameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_modulenameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_modulenameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_modulenameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_MaybeModuleName_Nothing :: (T_MaybeModuleName)
sem_MaybeModuleName_Nothing  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (MaybeModuleName)
            -- self rule
            (_self@_) =
                MaybeModuleName_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- MaybeName ---------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for MaybeName.Just:
      self

-}
{-
   local variables for MaybeName.Nothing:
      self

-}
-- semantic domain
type T_MaybeName = (Maybe Name) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (Strings) ->
                   (FMap Name [(Name,Name)]) ->
                   (Bool) ->
                   (FMap Name [(Name,Name)]) ->
                   (FMap Name [(Name,Name)]) ->
                   (Maybe Name) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (Bool) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (Bool) ->
                   ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(MaybeName))
-- cata
sem_MaybeName :: (MaybeName) ->
                 (T_MaybeName)
sem_MaybeName ((MaybeName_Just (_name))) =
    (sem_MaybeName_Just ((sem_Name (_name))))
sem_MaybeName ((MaybeName_Nothing )) =
    (sem_MaybeName_Nothing )
sem_MaybeName_Just :: (T_Name) ->
                      (T_MaybeName)
sem_MaybeName_Just (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (MaybeName)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            -- self rule
            (_self@_) =
                MaybeName_Just _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_MaybeName_Nothing :: (T_MaybeName)
sem_MaybeName_Nothing  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (MaybeName)
            -- self rule
            (_self@_) =
                MaybeName_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- MaybeNames --------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for MaybeNames.Just:
      self

-}
{-
   local variables for MaybeNames.Nothing:
      self

-}
-- semantic domain
type T_MaybeNames = (Maybe Name) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Strings) ->
                    (FMap Name [(Name,Name)]) ->
                    (Bool) ->
                    (FMap Name [(Name,Name)]) ->
                    (FMap Name [(Name,Name)]) ->
                    (Maybe Name) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Bool) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Bool) ->
                    ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(MaybeNames))
-- cata
sem_MaybeNames :: (MaybeNames) ->
                  (T_MaybeNames)
sem_MaybeNames ((MaybeNames_Just (_names))) =
    (sem_MaybeNames_Just ((sem_Names (_names))))
sem_MaybeNames ((MaybeNames_Nothing )) =
    (sem_MaybeNames_Nothing )
sem_MaybeNames_Just :: (T_Names) ->
                       (T_MaybeNames)
sem_MaybeNames_Just (names_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (MaybeNames)
            _namesIconstructors_collect :: (FMap Name Names)
            _namesIdependencies_collect :: (FMap Name [(Name,Name)])
            _namesIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _namesIlabels_collect :: (FMap Name Names)
            _namesImethods_collect :: (FMap Name Names)
            _namesIself :: (Names)
            _namesOclassname :: (Maybe Name)
            _namesOconstructors_collect :: (FMap Name Names)
            _namesOconstructors_dist :: (FMap Name Names)
            _namesOcurrentModule :: (Strings)
            _namesOdependencies_collect :: (FMap Name [(Name,Name)])
            _namesOimportedModule :: (Bool)
            _namesOinferredDependencies :: (FMap Name [(Name,Name)])
            _namesOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _namesOinstancename :: (Maybe Name)
            _namesOlabels_collect :: (FMap Name Names)
            _namesOlabels_dist :: (FMap Name Names)
            _namesOlocal :: (Bool)
            _namesOmethods_collect :: (FMap Name Names)
            _namesOmethods_dist :: (FMap Name Names)
            _namesOtoplevel :: (Bool)
            ( _namesIconstructors_collect,_namesIdependencies_collect,_namesIinferredDependencies_collect,_namesIlabels_collect,_namesImethods_collect,_namesIself) =
                (names_ (_namesOclassname) (_namesOconstructors_collect) (_namesOconstructors_dist) (_namesOcurrentModule) (_namesOdependencies_collect) (_namesOimportedModule) (_namesOinferredDependencies) (_namesOinferredDependencies_collect) (_namesOinstancename) (_namesOlabels_collect) (_namesOlabels_dist) (_namesOlocal) (_namesOmethods_collect) (_namesOmethods_dist) (_namesOtoplevel))
            -- self rule
            (_self@_) =
                MaybeNames_Just _namesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _namesIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _namesIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _namesIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _namesIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _namesImethods_collect
            -- copy rule (down)
            (_namesOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_namesOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_namesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_namesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_namesOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_namesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_namesOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_namesOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_namesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_namesOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_namesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_namesOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_namesOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_namesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_namesOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_MaybeNames_Nothing :: (T_MaybeNames)
sem_MaybeNames_Nothing  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (MaybeNames)
            -- self rule
            (_self@_) =
                MaybeNames_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- MaybeReassignments ------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for MaybeReassignments.Just:
      self

-}
{-
   local variables for MaybeReassignments.Nothing:
      self

-}
-- semantic domain
type T_MaybeReassignments = (Maybe Name) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Strings) ->
                            (FMap Name [(Name,Name)]) ->
                            (Bool) ->
                            (FMap Name [(Name,Name)]) ->
                            (FMap Name [(Name,Name)]) ->
                            (Maybe Name) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Bool) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Bool) ->
                            ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(MaybeReassignments))
-- cata
sem_MaybeReassignments :: (MaybeReassignments) ->
                          (T_MaybeReassignments)
sem_MaybeReassignments ((MaybeReassignments_Just (_reassignments))) =
    (sem_MaybeReassignments_Just ((sem_Reassignments (_reassignments))))
sem_MaybeReassignments ((MaybeReassignments_Nothing )) =
    (sem_MaybeReassignments_Nothing )
sem_MaybeReassignments_Just :: (T_Reassignments) ->
                               (T_MaybeReassignments)
sem_MaybeReassignments_Just (reassignments_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (MaybeReassignments)
            _reassignmentsIconstructors_collect :: (FMap Name Names)
            _reassignmentsIdependencies_collect :: (FMap Name [(Name,Name)])
            _reassignmentsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _reassignmentsIlabels_collect :: (FMap Name Names)
            _reassignmentsImethods_collect :: (FMap Name Names)
            _reassignmentsIself :: (Reassignments)
            _reassignmentsOclassname :: (Maybe Name)
            _reassignmentsOconstructors_collect :: (FMap Name Names)
            _reassignmentsOconstructors_dist :: (FMap Name Names)
            _reassignmentsOcurrentModule :: (Strings)
            _reassignmentsOdependencies_collect :: (FMap Name [(Name,Name)])
            _reassignmentsOimportedModule :: (Bool)
            _reassignmentsOinferredDependencies :: (FMap Name [(Name,Name)])
            _reassignmentsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _reassignmentsOinstancename :: (Maybe Name)
            _reassignmentsOlabels_collect :: (FMap Name Names)
            _reassignmentsOlabels_dist :: (FMap Name Names)
            _reassignmentsOlocal :: (Bool)
            _reassignmentsOmethods_collect :: (FMap Name Names)
            _reassignmentsOmethods_dist :: (FMap Name Names)
            _reassignmentsOtoplevel :: (Bool)
            ( _reassignmentsIconstructors_collect,_reassignmentsIdependencies_collect,_reassignmentsIinferredDependencies_collect,_reassignmentsIlabels_collect,_reassignmentsImethods_collect,_reassignmentsIself) =
                (reassignments_ (_reassignmentsOclassname)
                                (_reassignmentsOconstructors_collect)
                                (_reassignmentsOconstructors_dist)
                                (_reassignmentsOcurrentModule)
                                (_reassignmentsOdependencies_collect)
                                (_reassignmentsOimportedModule)
                                (_reassignmentsOinferredDependencies)
                                (_reassignmentsOinferredDependencies_collect)
                                (_reassignmentsOinstancename)
                                (_reassignmentsOlabels_collect)
                                (_reassignmentsOlabels_dist)
                                (_reassignmentsOlocal)
                                (_reassignmentsOmethods_collect)
                                (_reassignmentsOmethods_dist)
                                (_reassignmentsOtoplevel))
            -- self rule
            (_self@_) =
                MaybeReassignments_Just _reassignmentsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _reassignmentsIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _reassignmentsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _reassignmentsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _reassignmentsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _reassignmentsImethods_collect
            -- copy rule (down)
            (_reassignmentsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_reassignmentsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_reassignmentsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_reassignmentsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_reassignmentsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_reassignmentsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_reassignmentsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_reassignmentsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_reassignmentsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_reassignmentsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_reassignmentsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_reassignmentsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_reassignmentsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_reassignmentsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_reassignmentsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_MaybeReassignments_Nothing :: (T_MaybeReassignments)
sem_MaybeReassignments_Nothing  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (MaybeReassignments)
            -- self rule
            (_self@_) =
                MaybeReassignments_Nothing
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- Module ------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      compiledModule       : Strings
      self                 : SELF

-}
{-
   local variables for Module.Module:
      local
      compiledModule
      currentModule
      moduleName
      moduleName_
      self

-}
-- semantic domain
type T_Module = (Maybe Name) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (FMap Name [(Name,Name)]) ->
                (Bool) ->
                (FMap Name [(Name,Name)]) ->
                (FMap Name [(Name,Name)]) ->
                (Maybe Name) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (FMap Name Names) ->
                (PreSignatures) ->
                (PreSignatures) ->
                (Signatures) ->
                (Bool) ->
                ( (Strings),(FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(PreSignatures),(Module))
-- cata
sem_Module :: (Module) ->
              (T_Module)
sem_Module ((Module_Module (_range) (_name) (_exports) (_body))) =
    (sem_Module_Module ((sem_Range (_range))) ((sem_MaybeModuleName (_name))) ((sem_MaybeExports (_exports))) ((sem_Body (_body))))
sem_Module_Module :: (T_Range) ->
                     (T_MaybeModuleName) ->
                     (T_MaybeExports) ->
                     (T_Body) ->
                     (T_Module)
sem_Module_Module (range_) (name_) (exports_) (body_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsOcompiledModule :: (Strings)
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Module)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (MaybeModuleName)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _exportsIconstructors_collect :: (FMap Name Names)
            _exportsIdependencies_collect :: (FMap Name [(Name,Name)])
            _exportsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _exportsIlabels_collect :: (FMap Name Names)
            _exportsImethods_collect :: (FMap Name Names)
            _exportsIself :: (MaybeExports)
            _exportsOclassname :: (Maybe Name)
            _exportsOconstructors_collect :: (FMap Name Names)
            _exportsOconstructors_dist :: (FMap Name Names)
            _exportsOcurrentModule :: (Strings)
            _exportsOdependencies_collect :: (FMap Name [(Name,Name)])
            _exportsOimportedModule :: (Bool)
            _exportsOinferredDependencies :: (FMap Name [(Name,Name)])
            _exportsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _exportsOinstancename :: (Maybe Name)
            _exportsOlabels_collect :: (FMap Name Names)
            _exportsOlabels_dist :: (FMap Name Names)
            _exportsOlocal :: (Bool)
            _exportsOmethods_collect :: (FMap Name Names)
            _exportsOmethods_dist :: (FMap Name Names)
            _exportsOtoplevel :: (Bool)
            _bodyIconstructors_collect :: (FMap Name Names)
            _bodyIdependencies_collect :: (FMap Name [(Name,Name)])
            _bodyIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _bodyIlabels_collect :: (FMap Name Names)
            _bodyImethods_collect :: (FMap Name Names)
            _bodyIpresignatures_collect :: (PreSignatures)
            _bodyIself :: (Body)
            _bodyOclassname :: (Maybe Name)
            _bodyOconstructors_collect :: (FMap Name Names)
            _bodyOconstructors_dist :: (FMap Name Names)
            _bodyOcurrentModule :: (Strings)
            _bodyOdependencies_collect :: (FMap Name [(Name,Name)])
            _bodyOimportedModule :: (Bool)
            _bodyOinferredDependencies :: (FMap Name [(Name,Name)])
            _bodyOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _bodyOinstancename :: (Maybe Name)
            _bodyOlabels_collect :: (FMap Name Names)
            _bodyOlabels_dist :: (FMap Name Names)
            _bodyOlocal :: (Bool)
            _bodyOmethods_collect :: (FMap Name Names)
            _bodyOmethods_dist :: (FMap Name Names)
            _bodyOpresignatures :: (PreSignatures)
            _bodyOpresignatures_collect :: (PreSignatures)
            _bodyOsignatures :: (Signatures)
            _bodyOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _exportsIconstructors_collect,_exportsIdependencies_collect,_exportsIinferredDependencies_collect,_exportsIlabels_collect,_exportsImethods_collect,_exportsIself) =
                (exports_ (_exportsOclassname) (_exportsOconstructors_collect) (_exportsOconstructors_dist) (_exportsOcurrentModule) (_exportsOdependencies_collect) (_exportsOimportedModule) (_exportsOinferredDependencies) (_exportsOinferredDependencies_collect) (_exportsOinstancename) (_exportsOlabels_collect) (_exportsOlabels_dist) (_exportsOlocal) (_exportsOmethods_collect) (_exportsOmethods_dist) (_exportsOtoplevel))
            ( _bodyIconstructors_collect,_bodyIdependencies_collect,_bodyIinferredDependencies_collect,_bodyIlabels_collect,_bodyImethods_collect,_bodyIpresignatures_collect,_bodyIself) =
                (body_ (_bodyOclassname) (_bodyOconstructors_collect) (_bodyOconstructors_dist) (_bodyOcurrentModule) (_bodyOdependencies_collect) (_bodyOimportedModule) (_bodyOinferredDependencies) (_bodyOinferredDependencies_collect) (_bodyOinstancename) (_bodyOlabels_collect) (_bodyOlabels_dist) (_bodyOlocal) (_bodyOmethods_collect) (_bodyOmethods_dist) (_bodyOpresignatures) (_bodyOpresignatures_collect) (_bodyOsignatures) (_bodyOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 113, column 8)
            (_local@_) =
                True
            -- "./ModuleInformation.inc.lag"(line 111, column 8)
            (_lhsOcompiledModule@_) =
                _compiledModule
            -- "./ModuleInformation.inc.lag"(line 110, column 8)
            (_compiledModule@_) =
                _moduleName
            -- "./ModuleInformation.inc.lag"(line 109, column 8)
            (_currentModule@_) =
                _moduleName
            -- "./ModuleInformation.inc.lag"(line 107, column 8)
            (_moduleName@_) =
                getModuleName _moduleName_
            -- "./ModuleInformation.inc.lag"(line 101, column 8)
            (_moduleName_@_) =
                case _nameIself of
                  MaybeModuleName_Nothing -> ModuleName_ModuleName
                                               unknownRange
                                               ["Main"]
                  MaybeModuleName_Just x  -> x
            -- self rule
            (_self@_) =
                Module_Module _rangeIself _nameIself _exportsIself _bodyIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _bodyIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _bodyIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _bodyIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _bodyIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _bodyImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _bodyIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_rangeOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_rangeOlocal@_) =
                _local
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_nameOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_nameOlocal@_) =
                _local
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_exportsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_exportsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_exportsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_exportsOcurrentModule@_) =
                _currentModule
            -- copy rule (chain)
            (_exportsOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_exportsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_exportsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_exportsOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_exportsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_exportsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_exportsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_exportsOlocal@_) =
                _local
            -- copy rule (chain)
            (_exportsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_exportsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_exportsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_bodyOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_bodyOconstructors_collect@_) =
                _exportsIconstructors_collect
            -- copy rule (down)
            (_bodyOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_bodyOcurrentModule@_) =
                _currentModule
            -- copy rule (chain)
            (_bodyOdependencies_collect@_) =
                _exportsIdependencies_collect
            -- copy rule (down)
            (_bodyOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_bodyOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_bodyOinferredDependencies_collect@_) =
                _exportsIinferredDependencies_collect
            -- copy rule (down)
            (_bodyOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_bodyOlabels_collect@_) =
                _exportsIlabels_collect
            -- copy rule (down)
            (_bodyOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_bodyOlocal@_) =
                _local
            -- copy rule (chain)
            (_bodyOmethods_collect@_) =
                _exportsImethods_collect
            -- copy rule (down)
            (_bodyOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_bodyOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_bodyOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_bodyOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_bodyOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOcompiledModule,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- ModuleInterface ---------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for ModuleInterface.ModuleInterface:
      local
      toplevel
      importedModule
      currentModule
      self

-}
{-
   local variables for ModuleInterface.Unavailable:
      local
      toplevel
      importedModule
      currentModule
      self

-}
-- semantic domain
type T_ModuleInterface = (Maybe Name) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (FMap Name [(Name,Name)]) ->
                         (Bool) ->
                         (FMap Name [(Name,Name)]) ->
                         (FMap Name [(Name,Name)]) ->
                         (Maybe Name) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (FMap Name Names) ->
                         (PreSignatures) ->
                         (PreSignatures) ->
                         (Signatures) ->
                         (Bool) ->
                         ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(PreSignatures),(ModuleInterface))
-- cata
sem_ModuleInterface :: (ModuleInterface) ->
                       (T_ModuleInterface)
sem_ModuleInterface ((ModuleInterface_ModuleInterface (_range) (_name) (_exportedTypes) (_exportedValues) (_declarations))) =
    (sem_ModuleInterface_ModuleInterface ((sem_Range (_range))) ((sem_ModuleName (_name))) ((sem_Names (_exportedTypes))) ((sem_Names (_exportedValues))) ((sem_InterfaceDeclarations (_declarations))))
sem_ModuleInterface ((ModuleInterface_Unavailable (_name))) =
    (sem_ModuleInterface_Unavailable ((sem_ModuleName (_name))))
sem_ModuleInterface_ModuleInterface :: (T_Range) ->
                                       (T_ModuleName) ->
                                       (T_Names) ->
                                       (T_Names) ->
                                       (T_InterfaceDeclarations) ->
                                       (T_ModuleInterface)
sem_ModuleInterface_ModuleInterface (range_) (name_) (exportedTypes_) (exportedValues_) (declarations_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (ModuleInterface)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (ModuleName)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _exportedTypesIconstructors_collect :: (FMap Name Names)
            _exportedTypesIdependencies_collect :: (FMap Name [(Name,Name)])
            _exportedTypesIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _exportedTypesIlabels_collect :: (FMap Name Names)
            _exportedTypesImethods_collect :: (FMap Name Names)
            _exportedTypesIself :: (Names)
            _exportedTypesOclassname :: (Maybe Name)
            _exportedTypesOconstructors_collect :: (FMap Name Names)
            _exportedTypesOconstructors_dist :: (FMap Name Names)
            _exportedTypesOcurrentModule :: (Strings)
            _exportedTypesOdependencies_collect :: (FMap Name [(Name,Name)])
            _exportedTypesOimportedModule :: (Bool)
            _exportedTypesOinferredDependencies :: (FMap Name [(Name,Name)])
            _exportedTypesOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _exportedTypesOinstancename :: (Maybe Name)
            _exportedTypesOlabels_collect :: (FMap Name Names)
            _exportedTypesOlabels_dist :: (FMap Name Names)
            _exportedTypesOlocal :: (Bool)
            _exportedTypesOmethods_collect :: (FMap Name Names)
            _exportedTypesOmethods_dist :: (FMap Name Names)
            _exportedTypesOtoplevel :: (Bool)
            _exportedValuesIconstructors_collect :: (FMap Name Names)
            _exportedValuesIdependencies_collect :: (FMap Name [(Name,Name)])
            _exportedValuesIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _exportedValuesIlabels_collect :: (FMap Name Names)
            _exportedValuesImethods_collect :: (FMap Name Names)
            _exportedValuesIself :: (Names)
            _exportedValuesOclassname :: (Maybe Name)
            _exportedValuesOconstructors_collect :: (FMap Name Names)
            _exportedValuesOconstructors_dist :: (FMap Name Names)
            _exportedValuesOcurrentModule :: (Strings)
            _exportedValuesOdependencies_collect :: (FMap Name [(Name,Name)])
            _exportedValuesOimportedModule :: (Bool)
            _exportedValuesOinferredDependencies :: (FMap Name [(Name,Name)])
            _exportedValuesOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _exportedValuesOinstancename :: (Maybe Name)
            _exportedValuesOlabels_collect :: (FMap Name Names)
            _exportedValuesOlabels_dist :: (FMap Name Names)
            _exportedValuesOlocal :: (Bool)
            _exportedValuesOmethods_collect :: (FMap Name Names)
            _exportedValuesOmethods_dist :: (FMap Name Names)
            _exportedValuesOtoplevel :: (Bool)
            _declarationsIconstructors_collect :: (FMap Name Names)
            _declarationsIdependencies_collect :: (FMap Name [(Name,Name)])
            _declarationsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _declarationsIlabels_collect :: (FMap Name Names)
            _declarationsImethods_collect :: (FMap Name Names)
            _declarationsIpresignatures_collect :: (PreSignatures)
            _declarationsIself :: (InterfaceDeclarations)
            _declarationsOclassname :: (Maybe Name)
            _declarationsOconstructors_collect :: (FMap Name Names)
            _declarationsOconstructors_dist :: (FMap Name Names)
            _declarationsOcurrentModule :: (Strings)
            _declarationsOdependencies_collect :: (FMap Name [(Name,Name)])
            _declarationsOimportedModule :: (Bool)
            _declarationsOinferredDependencies :: (FMap Name [(Name,Name)])
            _declarationsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _declarationsOinstancename :: (Maybe Name)
            _declarationsOlabels_collect :: (FMap Name Names)
            _declarationsOlabels_dist :: (FMap Name Names)
            _declarationsOlocal :: (Bool)
            _declarationsOmethods_collect :: (FMap Name Names)
            _declarationsOmethods_dist :: (FMap Name Names)
            _declarationsOpresignatures :: (PreSignatures)
            _declarationsOpresignatures_collect :: (PreSignatures)
            _declarationsOsignatures :: (Signatures)
            _declarationsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _exportedTypesIconstructors_collect,_exportedTypesIdependencies_collect,_exportedTypesIinferredDependencies_collect,_exportedTypesIlabels_collect,_exportedTypesImethods_collect,_exportedTypesIself) =
                (exportedTypes_ (_exportedTypesOclassname)
                                (_exportedTypesOconstructors_collect)
                                (_exportedTypesOconstructors_dist)
                                (_exportedTypesOcurrentModule)
                                (_exportedTypesOdependencies_collect)
                                (_exportedTypesOimportedModule)
                                (_exportedTypesOinferredDependencies)
                                (_exportedTypesOinferredDependencies_collect)
                                (_exportedTypesOinstancename)
                                (_exportedTypesOlabels_collect)
                                (_exportedTypesOlabels_dist)
                                (_exportedTypesOlocal)
                                (_exportedTypesOmethods_collect)
                                (_exportedTypesOmethods_dist)
                                (_exportedTypesOtoplevel))
            ( _exportedValuesIconstructors_collect,_exportedValuesIdependencies_collect,_exportedValuesIinferredDependencies_collect,_exportedValuesIlabels_collect,_exportedValuesImethods_collect,_exportedValuesIself) =
                (exportedValues_ (_exportedValuesOclassname)
                                 (_exportedValuesOconstructors_collect)
                                 (_exportedValuesOconstructors_dist)
                                 (_exportedValuesOcurrentModule)
                                 (_exportedValuesOdependencies_collect)
                                 (_exportedValuesOimportedModule)
                                 (_exportedValuesOinferredDependencies)
                                 (_exportedValuesOinferredDependencies_collect)
                                 (_exportedValuesOinstancename)
                                 (_exportedValuesOlabels_collect)
                                 (_exportedValuesOlabels_dist)
                                 (_exportedValuesOlocal)
                                 (_exportedValuesOmethods_collect)
                                 (_exportedValuesOmethods_dist)
                                 (_exportedValuesOtoplevel))
            ( _declarationsIconstructors_collect,_declarationsIdependencies_collect,_declarationsIinferredDependencies_collect,_declarationsIlabels_collect,_declarationsImethods_collect,_declarationsIpresignatures_collect,_declarationsIself) =
                (declarations_ (_declarationsOclassname)
                               (_declarationsOconstructors_collect)
                               (_declarationsOconstructors_dist)
                               (_declarationsOcurrentModule)
                               (_declarationsOdependencies_collect)
                               (_declarationsOimportedModule)
                               (_declarationsOinferredDependencies)
                               (_declarationsOinferredDependencies_collect)
                               (_declarationsOinstancename)
                               (_declarationsOlabels_collect)
                               (_declarationsOlabels_dist)
                               (_declarationsOlocal)
                               (_declarationsOmethods_collect)
                               (_declarationsOmethods_dist)
                               (_declarationsOpresignatures)
                               (_declarationsOpresignatures_collect)
                               (_declarationsOsignatures)
                               (_declarationsOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 125, column 8)
            (_local@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 124, column 8)
            (_toplevel@_) =
                True
            -- "./ModuleInformation.inc.lag"(line 123, column 8)
            (_importedModule@_) =
                True
            -- "./ModuleInformation.inc.lag"(line 122, column 8)
            (_currentModule@_) =
                getModuleName _nameIself
            -- "./ModuleInformation.inc.lag"(line 348, column 9)
            (_lhsOmethods_collect@_) =
                mergeFM _lhsImethods_collect
                        _declarationsImethods_collect
            -- "./ModuleInformation.inc.lag"(line 346, column 9)
            (_lhsOconstructors_collect@_) =
                mergeFM _lhsIconstructors_collect
                        _declarationsIconstructors_collect
            -- "./ModuleInformation.inc.lag"(line 344, column 9)
            (_declarationsOmethods_collect@_) =
                emptyFM
            -- "./ModuleInformation.inc.lag"(line 343, column 9)
            (_declarationsOconstructors_collect@_) =
                emptyFM
            -- self rule
            (_self@_) =
                ModuleInterface_ModuleInterface _rangeIself _nameIself _exportedTypesIself _exportedValuesIself _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _declarationsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _declarationsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _declarationsIlabels_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _declarationsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_rangeOcurrentModule@_) =
                _currentModule
            -- copy rule (chain)
            (_rangeOimportedModule@_) =
                _importedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_rangeOlocal@_) =
                _local
            -- copy rule (chain)
            (_rangeOtoplevel@_) =
                _toplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_nameOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_nameOimportedModule@_) =
                _importedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_nameOlocal@_) =
                _local
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_nameOtoplevel@_) =
                _toplevel
            -- copy rule (down)
            (_exportedTypesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_exportedTypesOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_exportedTypesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_exportedTypesOcurrentModule@_) =
                _currentModule
            -- copy rule (chain)
            (_exportedTypesOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (chain)
            (_exportedTypesOimportedModule@_) =
                _importedModule
            -- copy rule (down)
            (_exportedTypesOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_exportedTypesOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_exportedTypesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_exportedTypesOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_exportedTypesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_exportedTypesOlocal@_) =
                _local
            -- copy rule (chain)
            (_exportedTypesOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_exportedTypesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_exportedTypesOtoplevel@_) =
                _toplevel
            -- copy rule (down)
            (_exportedValuesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_exportedValuesOconstructors_collect@_) =
                _exportedTypesIconstructors_collect
            -- copy rule (down)
            (_exportedValuesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_exportedValuesOcurrentModule@_) =
                _currentModule
            -- copy rule (chain)
            (_exportedValuesOdependencies_collect@_) =
                _exportedTypesIdependencies_collect
            -- copy rule (chain)
            (_exportedValuesOimportedModule@_) =
                _importedModule
            -- copy rule (down)
            (_exportedValuesOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_exportedValuesOinferredDependencies_collect@_) =
                _exportedTypesIinferredDependencies_collect
            -- copy rule (down)
            (_exportedValuesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_exportedValuesOlabels_collect@_) =
                _exportedTypesIlabels_collect
            -- copy rule (down)
            (_exportedValuesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_exportedValuesOlocal@_) =
                _local
            -- copy rule (chain)
            (_exportedValuesOmethods_collect@_) =
                _exportedTypesImethods_collect
            -- copy rule (down)
            (_exportedValuesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_exportedValuesOtoplevel@_) =
                _toplevel
            -- copy rule (down)
            (_declarationsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_declarationsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_declarationsOcurrentModule@_) =
                _currentModule
            -- copy rule (chain)
            (_declarationsOdependencies_collect@_) =
                _exportedValuesIdependencies_collect
            -- copy rule (chain)
            (_declarationsOimportedModule@_) =
                _importedModule
            -- copy rule (down)
            (_declarationsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_declarationsOinferredDependencies_collect@_) =
                _exportedValuesIinferredDependencies_collect
            -- copy rule (down)
            (_declarationsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_declarationsOlabels_collect@_) =
                _exportedValuesIlabels_collect
            -- copy rule (down)
            (_declarationsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_declarationsOlocal@_) =
                _local
            -- copy rule (down)
            (_declarationsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_declarationsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_declarationsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_declarationsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (chain)
            (_declarationsOtoplevel@_) =
                _toplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_ModuleInterface_Unavailable :: (T_ModuleName) ->
                                   (T_ModuleInterface)
sem_ModuleInterface_Unavailable (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (ModuleInterface)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (ModuleName)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 130, column 8)
            (_local@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 129, column 8)
            (_toplevel@_) =
                True
            -- "./ModuleInformation.inc.lag"(line 128, column 8)
            (_importedModule@_) =
                True
            -- "./ModuleInformation.inc.lag"(line 127, column 8)
            (_currentModule@_) =
                getModuleName _nameIself
            -- self rule
            (_self@_) =
                ModuleInterface_Unavailable _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_nameOcurrentModule@_) =
                _currentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_nameOimportedModule@_) =
                _importedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_nameOlocal@_) =
                _local
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (chain)
            (_nameOtoplevel@_) =
                _toplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- ModuleInterfaces --------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for ModuleInterfaces.Cons:
      self

-}
{-
   local variables for ModuleInterfaces.Nil:
      self

-}
-- semantic domain
type T_ModuleInterfaces = (Maybe Name) ->
                          (FMap Name Names) ->
                          (FMap Name Names) ->
                          (FMap Name [(Name,Name)]) ->
                          (Bool) ->
                          (FMap Name [(Name,Name)]) ->
                          (FMap Name [(Name,Name)]) ->
                          (Maybe Name) ->
                          (FMap Name Names) ->
                          (FMap Name Names) ->
                          (FMap Name Names) ->
                          (FMap Name Names) ->
                          (PreSignatures) ->
                          (PreSignatures) ->
                          (Signatures) ->
                          (Bool) ->
                          ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(PreSignatures),(ModuleInterfaces))
-- cata
sem_ModuleInterfaces :: (ModuleInterfaces) ->
                        (T_ModuleInterfaces)
sem_ModuleInterfaces (list) =
    (foldr (sem_ModuleInterfaces_Cons) (sem_ModuleInterfaces_Nil) ((map sem_ModuleInterface list)))
sem_ModuleInterfaces_Cons :: (T_ModuleInterface) ->
                             (T_ModuleInterfaces) ->
                             (T_ModuleInterfaces)
sem_ModuleInterfaces_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (ModuleInterfaces)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdependencies_collect :: (FMap Name [(Name,Name)])
            _hdIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIpresignatures_collect :: (PreSignatures)
            _hdIself :: (ModuleInterface)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOdependencies_collect :: (FMap Name [(Name,Name)])
            _hdOimportedModule :: (Bool)
            _hdOinferredDependencies :: (FMap Name [(Name,Name)])
            _hdOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdOinstancename :: (Maybe Name)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOpresignatures :: (PreSignatures)
            _hdOpresignatures_collect :: (PreSignatures)
            _hdOsignatures :: (Signatures)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdependencies_collect :: (FMap Name [(Name,Name)])
            _tlIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIpresignatures_collect :: (PreSignatures)
            _tlIself :: (ModuleInterfaces)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOdependencies_collect :: (FMap Name [(Name,Name)])
            _tlOimportedModule :: (Bool)
            _tlOinferredDependencies :: (FMap Name [(Name,Name)])
            _tlOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOpresignatures :: (PreSignatures)
            _tlOpresignatures_collect :: (PreSignatures)
            _tlOsignatures :: (Signatures)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIdependencies_collect,_hdIinferredDependencies_collect,_hdIlabels_collect,_hdImethods_collect,_hdIpresignatures_collect,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOdependencies_collect) (_hdOimportedModule) (_hdOinferredDependencies) (_hdOinferredDependencies_collect) (_hdOinstancename) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOpresignatures) (_hdOpresignatures_collect) (_hdOsignatures) (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIdependencies_collect,_tlIinferredDependencies_collect,_tlIlabels_collect,_tlImethods_collect,_tlIpresignatures_collect,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOdependencies_collect) (_tlOimportedModule) (_tlOinferredDependencies) (_tlOinferredDependencies_collect) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOpresignatures) (_tlOpresignatures_collect) (_tlOsignatures) (_tlOtoplevel))
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _tlIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _tlIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _tlIpresignatures_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_hdOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_hdOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_hdOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_tlOdependencies_collect@_) =
                _hdIdependencies_collect
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_tlOinferredDependencies_collect@_) =
                _hdIinferredDependencies_collect
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_tlOpresignatures_collect@_) =
                _hdIpresignatures_collect
            -- copy rule (down)
            (_tlOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_ModuleInterfaces_Nil :: (T_ModuleInterfaces)
sem_ModuleInterfaces_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (ModuleInterfaces)
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- ModuleName --------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for ModuleName.ModuleName:
      self

-}
-- semantic domain
type T_ModuleName = (Maybe Name) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Strings) ->
                    (FMap Name [(Name,Name)]) ->
                    (Bool) ->
                    (FMap Name [(Name,Name)]) ->
                    (FMap Name [(Name,Name)]) ->
                    (Maybe Name) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Bool) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Bool) ->
                    ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(ModuleName))
-- cata
sem_ModuleName :: (ModuleName) ->
                  (T_ModuleName)
sem_ModuleName ((ModuleName_ModuleName (_range) (_name))) =
    (sem_ModuleName_ModuleName ((sem_Range (_range))) ((sem_Strings (_name))))
sem_ModuleName_ModuleName :: (T_Range) ->
                             (T_Strings) ->
                             (T_ModuleName)
sem_ModuleName_ModuleName (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (ModuleName)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Strings)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            -- self rule
            (_self@_) =
                ModuleName_ModuleName _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- ModuleSystem ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      compiledModule       : Strings
      self                 : SELF

-}
{-
   local variables for ModuleSystem.ModuleSystem:
      self

-}
-- semantic domain
type T_ModuleSystem = (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (FMap Name [(Name,Name)]) ->
                      (Bool) ->
                      (FMap Name [(Name,Name)]) ->
                      (FMap Name [(Name,Name)]) ->
                      (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (PreSignatures) ->
                      (PreSignatures) ->
                      (Signatures) ->
                      (Bool) ->
                      ( (Strings),(FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(PreSignatures),(ModuleSystem))
-- cata
sem_ModuleSystem :: (ModuleSystem) ->
                    (T_ModuleSystem)
sem_ModuleSystem ((ModuleSystem_ModuleSystem (_interfaces) (_module))) =
    (sem_ModuleSystem_ModuleSystem ((sem_ModuleInterfaces (_interfaces))) ((sem_Module (_module))))
sem_ModuleSystem_ModuleSystem :: (T_ModuleInterfaces) ->
                                 (T_Module) ->
                                 (T_ModuleSystem)
sem_ModuleSystem_ModuleSystem (interfaces_) (module_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsOcompiledModule :: (Strings)
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (ModuleSystem)
            _interfacesIconstructors_collect :: (FMap Name Names)
            _interfacesIdependencies_collect :: (FMap Name [(Name,Name)])
            _interfacesIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _interfacesIlabels_collect :: (FMap Name Names)
            _interfacesImethods_collect :: (FMap Name Names)
            _interfacesIpresignatures_collect :: (PreSignatures)
            _interfacesIself :: (ModuleInterfaces)
            _interfacesOclassname :: (Maybe Name)
            _interfacesOconstructors_collect :: (FMap Name Names)
            _interfacesOconstructors_dist :: (FMap Name Names)
            _interfacesOdependencies_collect :: (FMap Name [(Name,Name)])
            _interfacesOimportedModule :: (Bool)
            _interfacesOinferredDependencies :: (FMap Name [(Name,Name)])
            _interfacesOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _interfacesOinstancename :: (Maybe Name)
            _interfacesOlabels_collect :: (FMap Name Names)
            _interfacesOlabels_dist :: (FMap Name Names)
            _interfacesOmethods_collect :: (FMap Name Names)
            _interfacesOmethods_dist :: (FMap Name Names)
            _interfacesOpresignatures :: (PreSignatures)
            _interfacesOpresignatures_collect :: (PreSignatures)
            _interfacesOsignatures :: (Signatures)
            _interfacesOtoplevel :: (Bool)
            _moduleIcompiledModule :: (Strings)
            _moduleIconstructors_collect :: (FMap Name Names)
            _moduleIdependencies_collect :: (FMap Name [(Name,Name)])
            _moduleIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _moduleIlabels_collect :: (FMap Name Names)
            _moduleImethods_collect :: (FMap Name Names)
            _moduleIpresignatures_collect :: (PreSignatures)
            _moduleIself :: (Module)
            _moduleOclassname :: (Maybe Name)
            _moduleOconstructors_collect :: (FMap Name Names)
            _moduleOconstructors_dist :: (FMap Name Names)
            _moduleOdependencies_collect :: (FMap Name [(Name,Name)])
            _moduleOimportedModule :: (Bool)
            _moduleOinferredDependencies :: (FMap Name [(Name,Name)])
            _moduleOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _moduleOinstancename :: (Maybe Name)
            _moduleOlabels_collect :: (FMap Name Names)
            _moduleOlabels_dist :: (FMap Name Names)
            _moduleOmethods_collect :: (FMap Name Names)
            _moduleOmethods_dist :: (FMap Name Names)
            _moduleOpresignatures :: (PreSignatures)
            _moduleOpresignatures_collect :: (PreSignatures)
            _moduleOsignatures :: (Signatures)
            _moduleOtoplevel :: (Bool)
            ( _interfacesIconstructors_collect,_interfacesIdependencies_collect,_interfacesIinferredDependencies_collect,_interfacesIlabels_collect,_interfacesImethods_collect,_interfacesIpresignatures_collect,_interfacesIself) =
                (interfaces_ (_interfacesOclassname)
                             (_interfacesOconstructors_collect)
                             (_interfacesOconstructors_dist)
                             (_interfacesOdependencies_collect)
                             (_interfacesOimportedModule)
                             (_interfacesOinferredDependencies)
                             (_interfacesOinferredDependencies_collect)
                             (_interfacesOinstancename)
                             (_interfacesOlabels_collect)
                             (_interfacesOlabels_dist)
                             (_interfacesOmethods_collect)
                             (_interfacesOmethods_dist)
                             (_interfacesOpresignatures)
                             (_interfacesOpresignatures_collect)
                             (_interfacesOsignatures)
                             (_interfacesOtoplevel))
            ( _moduleIcompiledModule,_moduleIconstructors_collect,_moduleIdependencies_collect,_moduleIinferredDependencies_collect,_moduleIlabels_collect,_moduleImethods_collect,_moduleIpresignatures_collect,_moduleIself) =
                (module_ (_moduleOclassname) (_moduleOconstructors_collect) (_moduleOconstructors_dist) (_moduleOdependencies_collect) (_moduleOimportedModule) (_moduleOinferredDependencies) (_moduleOinferredDependencies_collect) (_moduleOinstancename) (_moduleOlabels_collect) (_moduleOlabels_dist) (_moduleOmethods_collect) (_moduleOmethods_dist) (_moduleOpresignatures) (_moduleOpresignatures_collect) (_moduleOsignatures) (_moduleOtoplevel))
            -- self rule
            (_self@_) =
                ModuleSystem_ModuleSystem _interfacesIself _moduleIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOcompiledModule@_) =
                _moduleIcompiledModule
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _moduleIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _moduleIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _moduleIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _moduleIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _moduleImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _moduleIpresignatures_collect
            -- copy rule (down)
            (_interfacesOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_interfacesOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_interfacesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_interfacesOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_interfacesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_interfacesOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_interfacesOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_interfacesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_interfacesOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_interfacesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_interfacesOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_interfacesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_interfacesOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_interfacesOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_interfacesOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_interfacesOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_moduleOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_moduleOconstructors_collect@_) =
                _interfacesIconstructors_collect
            -- copy rule (down)
            (_moduleOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (chain)
            (_moduleOdependencies_collect@_) =
                _interfacesIdependencies_collect
            -- copy rule (down)
            (_moduleOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_moduleOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_moduleOinferredDependencies_collect@_) =
                _interfacesIinferredDependencies_collect
            -- copy rule (down)
            (_moduleOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_moduleOlabels_collect@_) =
                _interfacesIlabels_collect
            -- copy rule (down)
            (_moduleOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (chain)
            (_moduleOmethods_collect@_) =
                _interfacesImethods_collect
            -- copy rule (down)
            (_moduleOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_moduleOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_moduleOpresignatures_collect@_) =
                _interfacesIpresignatures_collect
            -- copy rule (down)
            (_moduleOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_moduleOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOcompiledModule,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- Name --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Name.Entity:
      self

-}
{-
   local variables for Name.Identifier:
      self

-}
{-
   local variables for Name.Operator:
      self

-}
{-
   local variables for Name.Special:
      self

-}
-- semantic domain
type T_Name = (Maybe Name) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (Strings) ->
              (FMap Name [(Name,Name)]) ->
              (Bool) ->
              (FMap Name [(Name,Name)]) ->
              (FMap Name [(Name,Name)]) ->
              (Maybe Name) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (Bool) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (Bool) ->
              ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(Name))
-- cata
sem_Name :: (Name) ->
            (T_Name)
sem_Name ((Name_Entity (_range) (_entity) (_inscope))) =
    (sem_Name_Entity ((sem_Range (_range))) ((sem_Name (_entity))) ((sem_MaybeName (_inscope))))
sem_Name ((Name_Identifier (_range) (_module) (_name))) =
    (sem_Name_Identifier ((sem_Range (_range))) ((sem_Strings (_module))) (_name))
sem_Name ((Name_Operator (_range) (_module) (_name))) =
    (sem_Name_Operator ((sem_Range (_range))) ((sem_Strings (_module))) (_name))
sem_Name ((Name_Special (_range) (_module) (_name))) =
    (sem_Name_Special ((sem_Range (_range))) ((sem_Strings (_module))) (_name))
sem_Name_Entity :: (T_Range) ->
                   (T_Name) ->
                   (T_MaybeName) ->
                   (T_Name)
sem_Name_Entity (range_) (entity_) (inscope_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Name)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _entityIconstructors_collect :: (FMap Name Names)
            _entityIdependencies_collect :: (FMap Name [(Name,Name)])
            _entityIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _entityIlabels_collect :: (FMap Name Names)
            _entityImethods_collect :: (FMap Name Names)
            _entityIself :: (Name)
            _entityOclassname :: (Maybe Name)
            _entityOconstructors_collect :: (FMap Name Names)
            _entityOconstructors_dist :: (FMap Name Names)
            _entityOcurrentModule :: (Strings)
            _entityOdependencies_collect :: (FMap Name [(Name,Name)])
            _entityOimportedModule :: (Bool)
            _entityOinferredDependencies :: (FMap Name [(Name,Name)])
            _entityOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _entityOinstancename :: (Maybe Name)
            _entityOlabels_collect :: (FMap Name Names)
            _entityOlabels_dist :: (FMap Name Names)
            _entityOlocal :: (Bool)
            _entityOmethods_collect :: (FMap Name Names)
            _entityOmethods_dist :: (FMap Name Names)
            _entityOtoplevel :: (Bool)
            _inscopeIconstructors_collect :: (FMap Name Names)
            _inscopeIdependencies_collect :: (FMap Name [(Name,Name)])
            _inscopeIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _inscopeIlabels_collect :: (FMap Name Names)
            _inscopeImethods_collect :: (FMap Name Names)
            _inscopeIself :: (MaybeName)
            _inscopeOclassname :: (Maybe Name)
            _inscopeOconstructors_collect :: (FMap Name Names)
            _inscopeOconstructors_dist :: (FMap Name Names)
            _inscopeOcurrentModule :: (Strings)
            _inscopeOdependencies_collect :: (FMap Name [(Name,Name)])
            _inscopeOimportedModule :: (Bool)
            _inscopeOinferredDependencies :: (FMap Name [(Name,Name)])
            _inscopeOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _inscopeOinstancename :: (Maybe Name)
            _inscopeOlabels_collect :: (FMap Name Names)
            _inscopeOlabels_dist :: (FMap Name Names)
            _inscopeOlocal :: (Bool)
            _inscopeOmethods_collect :: (FMap Name Names)
            _inscopeOmethods_dist :: (FMap Name Names)
            _inscopeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _entityIconstructors_collect,_entityIdependencies_collect,_entityIinferredDependencies_collect,_entityIlabels_collect,_entityImethods_collect,_entityIself) =
                (entity_ (_entityOclassname) (_entityOconstructors_collect) (_entityOconstructors_dist) (_entityOcurrentModule) (_entityOdependencies_collect) (_entityOimportedModule) (_entityOinferredDependencies) (_entityOinferredDependencies_collect) (_entityOinstancename) (_entityOlabels_collect) (_entityOlabels_dist) (_entityOlocal) (_entityOmethods_collect) (_entityOmethods_dist) (_entityOtoplevel))
            ( _inscopeIconstructors_collect,_inscopeIdependencies_collect,_inscopeIinferredDependencies_collect,_inscopeIlabels_collect,_inscopeImethods_collect,_inscopeIself) =
                (inscope_ (_inscopeOclassname) (_inscopeOconstructors_collect) (_inscopeOconstructors_dist) (_inscopeOcurrentModule) (_inscopeOdependencies_collect) (_inscopeOimportedModule) (_inscopeOinferredDependencies) (_inscopeOinferredDependencies_collect) (_inscopeOinstancename) (_inscopeOlabels_collect) (_inscopeOlabels_dist) (_inscopeOlocal) (_inscopeOmethods_collect) (_inscopeOmethods_dist) (_inscopeOtoplevel))
            -- self rule
            (_self@_) =
                Name_Entity _rangeIself _entityIself _inscopeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _inscopeIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _inscopeIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _inscopeIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _inscopeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _inscopeImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_entityOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_entityOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_entityOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_entityOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_entityOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_entityOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_entityOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_entityOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_entityOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_entityOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_entityOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_entityOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_entityOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_entityOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_entityOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_inscopeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_inscopeOconstructors_collect@_) =
                _entityIconstructors_collect
            -- copy rule (down)
            (_inscopeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_inscopeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_inscopeOdependencies_collect@_) =
                _entityIdependencies_collect
            -- copy rule (down)
            (_inscopeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_inscopeOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_inscopeOinferredDependencies_collect@_) =
                _entityIinferredDependencies_collect
            -- copy rule (down)
            (_inscopeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_inscopeOlabels_collect@_) =
                _entityIlabels_collect
            -- copy rule (down)
            (_inscopeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_inscopeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_inscopeOmethods_collect@_) =
                _entityImethods_collect
            -- copy rule (down)
            (_inscopeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_inscopeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Name_Identifier :: (T_Range) ->
                       (T_Strings) ->
                       (String) ->
                       (T_Name)
sem_Name_Identifier (range_) (module_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Name)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _moduleIconstructors_collect :: (FMap Name Names)
            _moduleIdependencies_collect :: (FMap Name [(Name,Name)])
            _moduleIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _moduleIlabels_collect :: (FMap Name Names)
            _moduleImethods_collect :: (FMap Name Names)
            _moduleIself :: (Strings)
            _moduleOclassname :: (Maybe Name)
            _moduleOconstructors_collect :: (FMap Name Names)
            _moduleOconstructors_dist :: (FMap Name Names)
            _moduleOcurrentModule :: (Strings)
            _moduleOdependencies_collect :: (FMap Name [(Name,Name)])
            _moduleOimportedModule :: (Bool)
            _moduleOinferredDependencies :: (FMap Name [(Name,Name)])
            _moduleOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _moduleOinstancename :: (Maybe Name)
            _moduleOlabels_collect :: (FMap Name Names)
            _moduleOlabels_dist :: (FMap Name Names)
            _moduleOlocal :: (Bool)
            _moduleOmethods_collect :: (FMap Name Names)
            _moduleOmethods_dist :: (FMap Name Names)
            _moduleOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _moduleIconstructors_collect,_moduleIdependencies_collect,_moduleIinferredDependencies_collect,_moduleIlabels_collect,_moduleImethods_collect,_moduleIself) =
                (module_ (_moduleOclassname) (_moduleOconstructors_collect) (_moduleOconstructors_dist) (_moduleOcurrentModule) (_moduleOdependencies_collect) (_moduleOimportedModule) (_moduleOinferredDependencies) (_moduleOinferredDependencies_collect) (_moduleOinstancename) (_moduleOlabels_collect) (_moduleOlabels_dist) (_moduleOlocal) (_moduleOmethods_collect) (_moduleOmethods_dist) (_moduleOtoplevel))
            -- self rule
            (_self@_) =
                Name_Identifier _rangeIself _moduleIself name_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _moduleIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _moduleIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _moduleIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _moduleIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _moduleImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_moduleOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_moduleOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_moduleOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_moduleOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_moduleOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_moduleOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_moduleOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_moduleOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_moduleOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_moduleOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_moduleOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_moduleOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_moduleOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_moduleOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_moduleOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Name_Operator :: (T_Range) ->
                     (T_Strings) ->
                     (String) ->
                     (T_Name)
sem_Name_Operator (range_) (module_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Name)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _moduleIconstructors_collect :: (FMap Name Names)
            _moduleIdependencies_collect :: (FMap Name [(Name,Name)])
            _moduleIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _moduleIlabels_collect :: (FMap Name Names)
            _moduleImethods_collect :: (FMap Name Names)
            _moduleIself :: (Strings)
            _moduleOclassname :: (Maybe Name)
            _moduleOconstructors_collect :: (FMap Name Names)
            _moduleOconstructors_dist :: (FMap Name Names)
            _moduleOcurrentModule :: (Strings)
            _moduleOdependencies_collect :: (FMap Name [(Name,Name)])
            _moduleOimportedModule :: (Bool)
            _moduleOinferredDependencies :: (FMap Name [(Name,Name)])
            _moduleOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _moduleOinstancename :: (Maybe Name)
            _moduleOlabels_collect :: (FMap Name Names)
            _moduleOlabels_dist :: (FMap Name Names)
            _moduleOlocal :: (Bool)
            _moduleOmethods_collect :: (FMap Name Names)
            _moduleOmethods_dist :: (FMap Name Names)
            _moduleOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _moduleIconstructors_collect,_moduleIdependencies_collect,_moduleIinferredDependencies_collect,_moduleIlabels_collect,_moduleImethods_collect,_moduleIself) =
                (module_ (_moduleOclassname) (_moduleOconstructors_collect) (_moduleOconstructors_dist) (_moduleOcurrentModule) (_moduleOdependencies_collect) (_moduleOimportedModule) (_moduleOinferredDependencies) (_moduleOinferredDependencies_collect) (_moduleOinstancename) (_moduleOlabels_collect) (_moduleOlabels_dist) (_moduleOlocal) (_moduleOmethods_collect) (_moduleOmethods_dist) (_moduleOtoplevel))
            -- self rule
            (_self@_) =
                Name_Operator _rangeIself _moduleIself name_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _moduleIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _moduleIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _moduleIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _moduleIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _moduleImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_moduleOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_moduleOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_moduleOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_moduleOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_moduleOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_moduleOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_moduleOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_moduleOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_moduleOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_moduleOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_moduleOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_moduleOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_moduleOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_moduleOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_moduleOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Name_Special :: (T_Range) ->
                    (T_Strings) ->
                    (String) ->
                    (T_Name)
sem_Name_Special (range_) (module_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Name)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _moduleIconstructors_collect :: (FMap Name Names)
            _moduleIdependencies_collect :: (FMap Name [(Name,Name)])
            _moduleIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _moduleIlabels_collect :: (FMap Name Names)
            _moduleImethods_collect :: (FMap Name Names)
            _moduleIself :: (Strings)
            _moduleOclassname :: (Maybe Name)
            _moduleOconstructors_collect :: (FMap Name Names)
            _moduleOconstructors_dist :: (FMap Name Names)
            _moduleOcurrentModule :: (Strings)
            _moduleOdependencies_collect :: (FMap Name [(Name,Name)])
            _moduleOimportedModule :: (Bool)
            _moduleOinferredDependencies :: (FMap Name [(Name,Name)])
            _moduleOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _moduleOinstancename :: (Maybe Name)
            _moduleOlabels_collect :: (FMap Name Names)
            _moduleOlabels_dist :: (FMap Name Names)
            _moduleOlocal :: (Bool)
            _moduleOmethods_collect :: (FMap Name Names)
            _moduleOmethods_dist :: (FMap Name Names)
            _moduleOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _moduleIconstructors_collect,_moduleIdependencies_collect,_moduleIinferredDependencies_collect,_moduleIlabels_collect,_moduleImethods_collect,_moduleIself) =
                (module_ (_moduleOclassname) (_moduleOconstructors_collect) (_moduleOconstructors_dist) (_moduleOcurrentModule) (_moduleOdependencies_collect) (_moduleOimportedModule) (_moduleOinferredDependencies) (_moduleOinferredDependencies_collect) (_moduleOinstancename) (_moduleOlabels_collect) (_moduleOlabels_dist) (_moduleOlocal) (_moduleOmethods_collect) (_moduleOmethods_dist) (_moduleOtoplevel))
            -- self rule
            (_self@_) =
                Name_Special _rangeIself _moduleIself name_
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _moduleIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _moduleIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _moduleIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _moduleIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _moduleImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_moduleOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_moduleOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_moduleOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_moduleOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_moduleOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_moduleOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_moduleOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_moduleOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_moduleOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_moduleOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_moduleOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_moduleOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_moduleOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_moduleOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_moduleOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- Names -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Names.Cons:
      self

-}
{-
   local variables for Names.Nil:
      self

-}
-- semantic domain
type T_Names = (Maybe Name) ->
               (FMap Name Names) ->
               (FMap Name Names) ->
               (Strings) ->
               (FMap Name [(Name,Name)]) ->
               (Bool) ->
               (FMap Name [(Name,Name)]) ->
               (FMap Name [(Name,Name)]) ->
               (Maybe Name) ->
               (FMap Name Names) ->
               (FMap Name Names) ->
               (Bool) ->
               (FMap Name Names) ->
               (FMap Name Names) ->
               (Bool) ->
               ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(Names))
-- cata
sem_Names :: (Names) ->
             (T_Names)
sem_Names (list) =
    (foldr (sem_Names_Cons) (sem_Names_Nil) ((map sem_Name list)))
sem_Names_Cons :: (T_Name) ->
                  (T_Names) ->
                  (T_Names)
sem_Names_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Names)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdependencies_collect :: (FMap Name [(Name,Name)])
            _hdIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIself :: (Name)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies_collect :: (FMap Name [(Name,Name)])
            _hdOimportedModule :: (Bool)
            _hdOinferredDependencies :: (FMap Name [(Name,Name)])
            _hdOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdOinstancename :: (Maybe Name)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdependencies_collect :: (FMap Name [(Name,Name)])
            _tlIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIself :: (Names)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies_collect :: (FMap Name [(Name,Name)])
            _tlOimportedModule :: (Bool)
            _tlOinferredDependencies :: (FMap Name [(Name,Name)])
            _tlOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIdependencies_collect,_hdIinferredDependencies_collect,_hdIlabels_collect,_hdImethods_collect,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOdependencies_collect) (_hdOimportedModule) (_hdOinferredDependencies) (_hdOinferredDependencies_collect) (_hdOinstancename) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIdependencies_collect,_tlIinferredDependencies_collect,_tlIlabels_collect,_tlImethods_collect,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOdependencies_collect) (_tlOimportedModule) (_tlOinferredDependencies) (_tlOinferredDependencies_collect) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOtoplevel))
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _tlIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _tlIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_hdOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_tlOdependencies_collect@_) =
                _hdIdependencies_collect
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_tlOinferredDependencies_collect@_) =
                _hdIinferredDependencies_collect
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Names_Nil :: (T_Names)
sem_Names_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Names)
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- Pattern -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      name                 : Name
      self                 : SELF

-}
{-
   local variables for Pattern.As:
      self

-}
{-
   local variables for Pattern.Constructor:
      self

-}
{-
   local variables for Pattern.InfixConstructor:
      self

-}
{-
   local variables for Pattern.Irrefutable:
      self

-}
{-
   local variables for Pattern.List:
      self

-}
{-
   local variables for Pattern.Literal:
      self

-}
{-
   local variables for Pattern.Negate:
      self

-}
{-
   local variables for Pattern.Parenthesized:
      self

-}
{-
   local variables for Pattern.Record:
      self

-}
{-
   local variables for Pattern.Successor:
      self

-}
{-
   local variables for Pattern.Tuple:
      self

-}
{-
   local variables for Pattern.Variable:
      self

-}
{-
   local variables for Pattern.Wildcard:
      self

-}
-- semantic domain
type T_Pattern = (Maybe Name) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Strings) ->
                 (FMap Name [(Name,Name)]) ->
                 (Bool) ->
                 (FMap Name [(Name,Name)]) ->
                 (FMap Name [(Name,Name)]) ->
                 (Maybe Name) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Bool) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Bool) ->
                 ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(Name),(Pattern))
-- cata
sem_Pattern :: (Pattern) ->
               (T_Pattern)
sem_Pattern ((Pattern_As (_range) (_name) (_pattern))) =
    (sem_Pattern_As ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_Constructor (_range) (_name) (_patterns))) =
    (sem_Pattern_Constructor ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Patterns (_patterns))))
sem_Pattern ((Pattern_InfixConstructor (_range) (_leftPattern) (_constructorOperator) (_rightPattern))) =
    (sem_Pattern_InfixConstructor ((sem_Range (_range))) ((sem_Pattern (_leftPattern))) ((sem_Name (_constructorOperator))) ((sem_Pattern (_rightPattern))))
sem_Pattern ((Pattern_Irrefutable (_range) (_pattern))) =
    (sem_Pattern_Irrefutable ((sem_Range (_range))) ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_List (_range) (_patterns))) =
    (sem_Pattern_List ((sem_Range (_range))) ((sem_Patterns (_patterns))))
sem_Pattern ((Pattern_Literal (_range) (_literal))) =
    (sem_Pattern_Literal ((sem_Range (_range))) ((sem_Literal (_literal))))
sem_Pattern ((Pattern_Negate (_range) (_literal))) =
    (sem_Pattern_Negate ((sem_Range (_range))) ((sem_Literal (_literal))))
sem_Pattern ((Pattern_Parenthesized (_range) (_pattern))) =
    (sem_Pattern_Parenthesized ((sem_Range (_range))) ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_Record (_range) (_name) (_recordPatternBindings))) =
    (sem_Pattern_Record ((sem_Range (_range))) ((sem_Name (_name))) ((sem_RecordPatternBindings (_recordPatternBindings))))
sem_Pattern ((Pattern_Successor (_range) (_name) (_literal))) =
    (sem_Pattern_Successor ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Literal (_literal))))
sem_Pattern ((Pattern_Tuple (_range) (_patterns))) =
    (sem_Pattern_Tuple ((sem_Range (_range))) ((sem_Patterns (_patterns))))
sem_Pattern ((Pattern_Variable (_range) (_name))) =
    (sem_Pattern_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Pattern ((Pattern_Wildcard (_range))) =
    (sem_Pattern_Wildcard ((sem_Range (_range))))
sem_Pattern_As :: (T_Range) ->
                  (T_Name) ->
                  (T_Pattern) ->
                  (T_Pattern)
sem_Pattern_As (range_) (name_) (pattern_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _patternIconstructors_collect :: (FMap Name Names)
            _patternIdependencies_collect :: (FMap Name [(Name,Name)])
            _patternIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _patternIlabels_collect :: (FMap Name Names)
            _patternImethods_collect :: (FMap Name Names)
            _patternIname :: (Name)
            _patternIself :: (Pattern)
            _patternOclassname :: (Maybe Name)
            _patternOconstructors_collect :: (FMap Name Names)
            _patternOconstructors_dist :: (FMap Name Names)
            _patternOcurrentModule :: (Strings)
            _patternOdependencies_collect :: (FMap Name [(Name,Name)])
            _patternOimportedModule :: (Bool)
            _patternOinferredDependencies :: (FMap Name [(Name,Name)])
            _patternOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _patternOinstancename :: (Maybe Name)
            _patternOlabels_collect :: (FMap Name Names)
            _patternOlabels_dist :: (FMap Name Names)
            _patternOlocal :: (Bool)
            _patternOmethods_collect :: (FMap Name Names)
            _patternOmethods_dist :: (FMap Name Names)
            _patternOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _patternIconstructors_collect,_patternIdependencies_collect,_patternIinferredDependencies_collect,_patternIlabels_collect,_patternImethods_collect,_patternIname,_patternIself) =
                (pattern_ (_patternOclassname) (_patternOconstructors_collect) (_patternOconstructors_dist) (_patternOcurrentModule) (_patternOdependencies_collect) (_patternOimportedModule) (_patternOinferredDependencies) (_patternOinferredDependencies_collect) (_patternOinstancename) (_patternOlabels_collect) (_patternOlabels_dist) (_patternOlocal) (_patternOmethods_collect) (_patternOmethods_dist) (_patternOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 462, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.Pattern.As.name: pattern binding in class/instance"
            -- self rule
            (_self@_) =
                Pattern_As _rangeIself _nameIself _patternIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _patternIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _patternIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _patternIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _patternIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _patternImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_patternOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_patternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_patternOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_patternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_patternOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_patternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_patternOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_patternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_patternOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_patternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
sem_Pattern_Constructor :: (T_Range) ->
                           (T_Name) ->
                           (T_Patterns) ->
                           (T_Pattern)
sem_Pattern_Constructor (range_) (name_) (patterns_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _patternsIconstructors_collect :: (FMap Name Names)
            _patternsIdependencies_collect :: (FMap Name [(Name,Name)])
            _patternsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _patternsIlabels_collect :: (FMap Name Names)
            _patternsImethods_collect :: (FMap Name Names)
            _patternsIself :: (Patterns)
            _patternsOclassname :: (Maybe Name)
            _patternsOconstructors_collect :: (FMap Name Names)
            _patternsOconstructors_dist :: (FMap Name Names)
            _patternsOcurrentModule :: (Strings)
            _patternsOdependencies_collect :: (FMap Name [(Name,Name)])
            _patternsOimportedModule :: (Bool)
            _patternsOinferredDependencies :: (FMap Name [(Name,Name)])
            _patternsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _patternsOinstancename :: (Maybe Name)
            _patternsOlabels_collect :: (FMap Name Names)
            _patternsOlabels_dist :: (FMap Name Names)
            _patternsOlocal :: (Bool)
            _patternsOmethods_collect :: (FMap Name Names)
            _patternsOmethods_dist :: (FMap Name Names)
            _patternsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _patternsIconstructors_collect,_patternsIdependencies_collect,_patternsIinferredDependencies_collect,_patternsIlabels_collect,_patternsImethods_collect,_patternsIself) =
                (patterns_ (_patternsOclassname) (_patternsOconstructors_collect) (_patternsOconstructors_dist) (_patternsOcurrentModule) (_patternsOdependencies_collect) (_patternsOimportedModule) (_patternsOinferredDependencies) (_patternsOinferredDependencies_collect) (_patternsOinstancename) (_patternsOlabels_collect) (_patternsOlabels_dist) (_patternsOlocal) (_patternsOmethods_collect) (_patternsOmethods_dist) (_patternsOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 444, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.Pattern.Constructor.name: pattern binding in class/instance"
            -- self rule
            (_self@_) =
                Pattern_Constructor _rangeIself _nameIself _patternsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _patternsIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _patternsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _patternsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _patternsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _patternsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_patternsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_patternsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_patternsOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_patternsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_patternsOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_patternsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_patternsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_patternsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_patternsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_patternsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
sem_Pattern_InfixConstructor :: (T_Range) ->
                                (T_Pattern) ->
                                (T_Name) ->
                                (T_Pattern) ->
                                (T_Pattern)
sem_Pattern_InfixConstructor (range_) (leftPattern_) (constructorOperator_) (rightPattern_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _leftPatternIconstructors_collect :: (FMap Name Names)
            _leftPatternIdependencies_collect :: (FMap Name [(Name,Name)])
            _leftPatternIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _leftPatternIlabels_collect :: (FMap Name Names)
            _leftPatternImethods_collect :: (FMap Name Names)
            _leftPatternIname :: (Name)
            _leftPatternIself :: (Pattern)
            _leftPatternOclassname :: (Maybe Name)
            _leftPatternOconstructors_collect :: (FMap Name Names)
            _leftPatternOconstructors_dist :: (FMap Name Names)
            _leftPatternOcurrentModule :: (Strings)
            _leftPatternOdependencies_collect :: (FMap Name [(Name,Name)])
            _leftPatternOimportedModule :: (Bool)
            _leftPatternOinferredDependencies :: (FMap Name [(Name,Name)])
            _leftPatternOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _leftPatternOinstancename :: (Maybe Name)
            _leftPatternOlabels_collect :: (FMap Name Names)
            _leftPatternOlabels_dist :: (FMap Name Names)
            _leftPatternOlocal :: (Bool)
            _leftPatternOmethods_collect :: (FMap Name Names)
            _leftPatternOmethods_dist :: (FMap Name Names)
            _leftPatternOtoplevel :: (Bool)
            _constructorOperatorIconstructors_collect :: (FMap Name Names)
            _constructorOperatorIdependencies_collect :: (FMap Name [(Name,Name)])
            _constructorOperatorIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _constructorOperatorIlabels_collect :: (FMap Name Names)
            _constructorOperatorImethods_collect :: (FMap Name Names)
            _constructorOperatorIself :: (Name)
            _constructorOperatorOclassname :: (Maybe Name)
            _constructorOperatorOconstructors_collect :: (FMap Name Names)
            _constructorOperatorOconstructors_dist :: (FMap Name Names)
            _constructorOperatorOcurrentModule :: (Strings)
            _constructorOperatorOdependencies_collect :: (FMap Name [(Name,Name)])
            _constructorOperatorOimportedModule :: (Bool)
            _constructorOperatorOinferredDependencies :: (FMap Name [(Name,Name)])
            _constructorOperatorOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _constructorOperatorOinstancename :: (Maybe Name)
            _constructorOperatorOlabels_collect :: (FMap Name Names)
            _constructorOperatorOlabels_dist :: (FMap Name Names)
            _constructorOperatorOlocal :: (Bool)
            _constructorOperatorOmethods_collect :: (FMap Name Names)
            _constructorOperatorOmethods_dist :: (FMap Name Names)
            _constructorOperatorOtoplevel :: (Bool)
            _rightPatternIconstructors_collect :: (FMap Name Names)
            _rightPatternIdependencies_collect :: (FMap Name [(Name,Name)])
            _rightPatternIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _rightPatternIlabels_collect :: (FMap Name Names)
            _rightPatternImethods_collect :: (FMap Name Names)
            _rightPatternIname :: (Name)
            _rightPatternIself :: (Pattern)
            _rightPatternOclassname :: (Maybe Name)
            _rightPatternOconstructors_collect :: (FMap Name Names)
            _rightPatternOconstructors_dist :: (FMap Name Names)
            _rightPatternOcurrentModule :: (Strings)
            _rightPatternOdependencies_collect :: (FMap Name [(Name,Name)])
            _rightPatternOimportedModule :: (Bool)
            _rightPatternOinferredDependencies :: (FMap Name [(Name,Name)])
            _rightPatternOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _rightPatternOinstancename :: (Maybe Name)
            _rightPatternOlabels_collect :: (FMap Name Names)
            _rightPatternOlabels_dist :: (FMap Name Names)
            _rightPatternOlocal :: (Bool)
            _rightPatternOmethods_collect :: (FMap Name Names)
            _rightPatternOmethods_dist :: (FMap Name Names)
            _rightPatternOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _leftPatternIconstructors_collect,_leftPatternIdependencies_collect,_leftPatternIinferredDependencies_collect,_leftPatternIlabels_collect,_leftPatternImethods_collect,_leftPatternIname,_leftPatternIself) =
                (leftPattern_ (_leftPatternOclassname)
                              (_leftPatternOconstructors_collect)
                              (_leftPatternOconstructors_dist)
                              (_leftPatternOcurrentModule)
                              (_leftPatternOdependencies_collect)
                              (_leftPatternOimportedModule)
                              (_leftPatternOinferredDependencies)
                              (_leftPatternOinferredDependencies_collect)
                              (_leftPatternOinstancename)
                              (_leftPatternOlabels_collect)
                              (_leftPatternOlabels_dist)
                              (_leftPatternOlocal)
                              (_leftPatternOmethods_collect)
                              (_leftPatternOmethods_dist)
                              (_leftPatternOtoplevel))
            ( _constructorOperatorIconstructors_collect,_constructorOperatorIdependencies_collect,_constructorOperatorIinferredDependencies_collect,_constructorOperatorIlabels_collect,_constructorOperatorImethods_collect,_constructorOperatorIself) =
                (constructorOperator_ (_constructorOperatorOclassname)
                                      (_constructorOperatorOconstructors_collect)
                                      (_constructorOperatorOconstructors_dist)
                                      (_constructorOperatorOcurrentModule)
                                      (_constructorOperatorOdependencies_collect)
                                      (_constructorOperatorOimportedModule)
                                      (_constructorOperatorOinferredDependencies)
                                      (_constructorOperatorOinferredDependencies_collect)
                                      (_constructorOperatorOinstancename)
                                      (_constructorOperatorOlabels_collect)
                                      (_constructorOperatorOlabels_dist)
                                      (_constructorOperatorOlocal)
                                      (_constructorOperatorOmethods_collect)
                                      (_constructorOperatorOmethods_dist)
                                      (_constructorOperatorOtoplevel))
            ( _rightPatternIconstructors_collect,_rightPatternIdependencies_collect,_rightPatternIinferredDependencies_collect,_rightPatternIlabels_collect,_rightPatternImethods_collect,_rightPatternIname,_rightPatternIself) =
                (rightPattern_ (_rightPatternOclassname)
                               (_rightPatternOconstructors_collect)
                               (_rightPatternOconstructors_dist)
                               (_rightPatternOcurrentModule)
                               (_rightPatternOdependencies_collect)
                               (_rightPatternOimportedModule)
                               (_rightPatternOinferredDependencies)
                               (_rightPatternOinferredDependencies_collect)
                               (_rightPatternOinstancename)
                               (_rightPatternOlabels_collect)
                               (_rightPatternOlabels_dist)
                               (_rightPatternOlocal)
                               (_rightPatternOmethods_collect)
                               (_rightPatternOmethods_dist)
                               (_rightPatternOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 447, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.Pattern.InfixConstructor.name: pattern binding in class/instance"
            -- self rule
            (_self@_) =
                Pattern_InfixConstructor _rangeIself _leftPatternIself _constructorOperatorIself _rightPatternIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _rightPatternIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _rightPatternIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _rightPatternIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _rightPatternIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _rightPatternImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_leftPatternOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_leftPatternOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_leftPatternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_leftPatternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_leftPatternOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_leftPatternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_leftPatternOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_leftPatternOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_leftPatternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_leftPatternOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_leftPatternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_leftPatternOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_leftPatternOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_leftPatternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_leftPatternOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_constructorOperatorOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_constructorOperatorOconstructors_collect@_) =
                _leftPatternIconstructors_collect
            -- copy rule (down)
            (_constructorOperatorOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_constructorOperatorOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_constructorOperatorOdependencies_collect@_) =
                _leftPatternIdependencies_collect
            -- copy rule (down)
            (_constructorOperatorOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_constructorOperatorOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_constructorOperatorOinferredDependencies_collect@_) =
                _leftPatternIinferredDependencies_collect
            -- copy rule (down)
            (_constructorOperatorOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_constructorOperatorOlabels_collect@_) =
                _leftPatternIlabels_collect
            -- copy rule (down)
            (_constructorOperatorOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_constructorOperatorOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_constructorOperatorOmethods_collect@_) =
                _leftPatternImethods_collect
            -- copy rule (down)
            (_constructorOperatorOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_constructorOperatorOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_rightPatternOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_rightPatternOconstructors_collect@_) =
                _constructorOperatorIconstructors_collect
            -- copy rule (down)
            (_rightPatternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_rightPatternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_rightPatternOdependencies_collect@_) =
                _constructorOperatorIdependencies_collect
            -- copy rule (down)
            (_rightPatternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rightPatternOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_rightPatternOinferredDependencies_collect@_) =
                _constructorOperatorIinferredDependencies_collect
            -- copy rule (down)
            (_rightPatternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_rightPatternOlabels_collect@_) =
                _constructorOperatorIlabels_collect
            -- copy rule (down)
            (_rightPatternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_rightPatternOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_rightPatternOmethods_collect@_) =
                _constructorOperatorImethods_collect
            -- copy rule (down)
            (_rightPatternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_rightPatternOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
sem_Pattern_Irrefutable :: (T_Range) ->
                           (T_Pattern) ->
                           (T_Pattern)
sem_Pattern_Irrefutable (range_) (pattern_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _patternIconstructors_collect :: (FMap Name Names)
            _patternIdependencies_collect :: (FMap Name [(Name,Name)])
            _patternIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _patternIlabels_collect :: (FMap Name Names)
            _patternImethods_collect :: (FMap Name Names)
            _patternIname :: (Name)
            _patternIself :: (Pattern)
            _patternOclassname :: (Maybe Name)
            _patternOconstructors_collect :: (FMap Name Names)
            _patternOconstructors_dist :: (FMap Name Names)
            _patternOcurrentModule :: (Strings)
            _patternOdependencies_collect :: (FMap Name [(Name,Name)])
            _patternOimportedModule :: (Bool)
            _patternOinferredDependencies :: (FMap Name [(Name,Name)])
            _patternOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _patternOinstancename :: (Maybe Name)
            _patternOlabels_collect :: (FMap Name Names)
            _patternOlabels_dist :: (FMap Name Names)
            _patternOlocal :: (Bool)
            _patternOmethods_collect :: (FMap Name Names)
            _patternOmethods_dist :: (FMap Name Names)
            _patternOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _patternIconstructors_collect,_patternIdependencies_collect,_patternIinferredDependencies_collect,_patternIlabels_collect,_patternImethods_collect,_patternIname,_patternIself) =
                (pattern_ (_patternOclassname) (_patternOconstructors_collect) (_patternOconstructors_dist) (_patternOcurrentModule) (_patternOdependencies_collect) (_patternOimportedModule) (_patternOinferredDependencies) (_patternOinferredDependencies_collect) (_patternOinstancename) (_patternOlabels_collect) (_patternOlabels_dist) (_patternOlocal) (_patternOmethods_collect) (_patternOmethods_dist) (_patternOtoplevel))
            -- self rule
            (_self@_) =
                Pattern_Irrefutable _rangeIself _patternIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _patternIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _patternIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _patternIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _patternIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _patternImethods_collect
            -- copy rule (up)
            (_lhsOname@_) =
                _patternIname
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_patternOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_patternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_patternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_patternOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_patternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_patternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_patternOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_patternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
sem_Pattern_List :: (T_Range) ->
                    (T_Patterns) ->
                    (T_Pattern)
sem_Pattern_List (range_) (patterns_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _patternsIconstructors_collect :: (FMap Name Names)
            _patternsIdependencies_collect :: (FMap Name [(Name,Name)])
            _patternsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _patternsIlabels_collect :: (FMap Name Names)
            _patternsImethods_collect :: (FMap Name Names)
            _patternsIself :: (Patterns)
            _patternsOclassname :: (Maybe Name)
            _patternsOconstructors_collect :: (FMap Name Names)
            _patternsOconstructors_dist :: (FMap Name Names)
            _patternsOcurrentModule :: (Strings)
            _patternsOdependencies_collect :: (FMap Name [(Name,Name)])
            _patternsOimportedModule :: (Bool)
            _patternsOinferredDependencies :: (FMap Name [(Name,Name)])
            _patternsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _patternsOinstancename :: (Maybe Name)
            _patternsOlabels_collect :: (FMap Name Names)
            _patternsOlabels_dist :: (FMap Name Names)
            _patternsOlocal :: (Bool)
            _patternsOmethods_collect :: (FMap Name Names)
            _patternsOmethods_dist :: (FMap Name Names)
            _patternsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _patternsIconstructors_collect,_patternsIdependencies_collect,_patternsIinferredDependencies_collect,_patternsIlabels_collect,_patternsImethods_collect,_patternsIself) =
                (patterns_ (_patternsOclassname) (_patternsOconstructors_collect) (_patternsOconstructors_dist) (_patternsOcurrentModule) (_patternsOdependencies_collect) (_patternsOimportedModule) (_patternsOinferredDependencies) (_patternsOinferredDependencies_collect) (_patternsOinstancename) (_patternsOlabels_collect) (_patternsOlabels_dist) (_patternsOlocal) (_patternsOmethods_collect) (_patternsOmethods_dist) (_patternsOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 450, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.Pattern.List.name: pattern binding in class/instance"
            -- self rule
            (_self@_) =
                Pattern_List _rangeIself _patternsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _patternsIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _patternsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _patternsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _patternsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _patternsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_patternsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_patternsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_patternsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_patternsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_patternsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_patternsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_patternsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_patternsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
sem_Pattern_Literal :: (T_Range) ->
                       (T_Literal) ->
                       (T_Pattern)
sem_Pattern_Literal (range_) (literal_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _literalIconstructors_collect :: (FMap Name Names)
            _literalIdependencies_collect :: (FMap Name [(Name,Name)])
            _literalIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _literalIlabels_collect :: (FMap Name Names)
            _literalImethods_collect :: (FMap Name Names)
            _literalIself :: (Literal)
            _literalOclassname :: (Maybe Name)
            _literalOconstructors_collect :: (FMap Name Names)
            _literalOconstructors_dist :: (FMap Name Names)
            _literalOcurrentModule :: (Strings)
            _literalOdependencies_collect :: (FMap Name [(Name,Name)])
            _literalOimportedModule :: (Bool)
            _literalOinferredDependencies :: (FMap Name [(Name,Name)])
            _literalOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _literalOinstancename :: (Maybe Name)
            _literalOlabels_collect :: (FMap Name Names)
            _literalOlabels_dist :: (FMap Name Names)
            _literalOlocal :: (Bool)
            _literalOmethods_collect :: (FMap Name Names)
            _literalOmethods_dist :: (FMap Name Names)
            _literalOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _literalIconstructors_collect,_literalIdependencies_collect,_literalIinferredDependencies_collect,_literalIlabels_collect,_literalImethods_collect,_literalIself) =
                (literal_ (_literalOclassname) (_literalOconstructors_collect) (_literalOconstructors_dist) (_literalOcurrentModule) (_literalOdependencies_collect) (_literalOimportedModule) (_literalOinferredDependencies) (_literalOinferredDependencies_collect) (_literalOinstancename) (_literalOlabels_collect) (_literalOlabels_dist) (_literalOlocal) (_literalOmethods_collect) (_literalOmethods_dist) (_literalOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 441, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.Pattern.Literal.name: pattern binding in class/instance"
            -- self rule
            (_self@_) =
                Pattern_Literal _rangeIself _literalIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _literalIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _literalIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _literalIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _literalIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _literalImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_literalOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_literalOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_literalOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_literalOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_literalOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_literalOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_literalOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_literalOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_literalOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_literalOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_literalOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_literalOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_literalOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_literalOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_literalOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
sem_Pattern_Negate :: (T_Range) ->
                      (T_Literal) ->
                      (T_Pattern)
sem_Pattern_Negate (range_) (literal_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _literalIconstructors_collect :: (FMap Name Names)
            _literalIdependencies_collect :: (FMap Name [(Name,Name)])
            _literalIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _literalIlabels_collect :: (FMap Name Names)
            _literalImethods_collect :: (FMap Name Names)
            _literalIself :: (Literal)
            _literalOclassname :: (Maybe Name)
            _literalOconstructors_collect :: (FMap Name Names)
            _literalOconstructors_dist :: (FMap Name Names)
            _literalOcurrentModule :: (Strings)
            _literalOdependencies_collect :: (FMap Name [(Name,Name)])
            _literalOimportedModule :: (Bool)
            _literalOinferredDependencies :: (FMap Name [(Name,Name)])
            _literalOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _literalOinstancename :: (Maybe Name)
            _literalOlabels_collect :: (FMap Name Names)
            _literalOlabels_dist :: (FMap Name Names)
            _literalOlocal :: (Bool)
            _literalOmethods_collect :: (FMap Name Names)
            _literalOmethods_dist :: (FMap Name Names)
            _literalOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _literalIconstructors_collect,_literalIdependencies_collect,_literalIinferredDependencies_collect,_literalIlabels_collect,_literalImethods_collect,_literalIself) =
                (literal_ (_literalOclassname) (_literalOconstructors_collect) (_literalOconstructors_dist) (_literalOcurrentModule) (_literalOdependencies_collect) (_literalOimportedModule) (_literalOinferredDependencies) (_literalOinferredDependencies_collect) (_literalOinstancename) (_literalOlabels_collect) (_literalOlabels_dist) (_literalOlocal) (_literalOmethods_collect) (_literalOmethods_dist) (_literalOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 459, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.Pattern.Negate.name: pattern binding in class/instance"
            -- self rule
            (_self@_) =
                Pattern_Negate _rangeIself _literalIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _literalIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _literalIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _literalIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _literalIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _literalImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_literalOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_literalOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_literalOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_literalOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_literalOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_literalOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_literalOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_literalOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_literalOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_literalOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_literalOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_literalOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_literalOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_literalOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_literalOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
sem_Pattern_Parenthesized :: (T_Range) ->
                             (T_Pattern) ->
                             (T_Pattern)
sem_Pattern_Parenthesized (range_) (pattern_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _patternIconstructors_collect :: (FMap Name Names)
            _patternIdependencies_collect :: (FMap Name [(Name,Name)])
            _patternIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _patternIlabels_collect :: (FMap Name Names)
            _patternImethods_collect :: (FMap Name Names)
            _patternIname :: (Name)
            _patternIself :: (Pattern)
            _patternOclassname :: (Maybe Name)
            _patternOconstructors_collect :: (FMap Name Names)
            _patternOconstructors_dist :: (FMap Name Names)
            _patternOcurrentModule :: (Strings)
            _patternOdependencies_collect :: (FMap Name [(Name,Name)])
            _patternOimportedModule :: (Bool)
            _patternOinferredDependencies :: (FMap Name [(Name,Name)])
            _patternOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _patternOinstancename :: (Maybe Name)
            _patternOlabels_collect :: (FMap Name Names)
            _patternOlabels_dist :: (FMap Name Names)
            _patternOlocal :: (Bool)
            _patternOmethods_collect :: (FMap Name Names)
            _patternOmethods_dist :: (FMap Name Names)
            _patternOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _patternIconstructors_collect,_patternIdependencies_collect,_patternIinferredDependencies_collect,_patternIlabels_collect,_patternImethods_collect,_patternIname,_patternIself) =
                (pattern_ (_patternOclassname) (_patternOconstructors_collect) (_patternOconstructors_dist) (_patternOcurrentModule) (_patternOdependencies_collect) (_patternOimportedModule) (_patternOinferredDependencies) (_patternOinferredDependencies_collect) (_patternOinstancename) (_patternOlabels_collect) (_patternOlabels_dist) (_patternOlocal) (_patternOmethods_collect) (_patternOmethods_dist) (_patternOtoplevel))
            -- self rule
            (_self@_) =
                Pattern_Parenthesized _rangeIself _patternIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _patternIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _patternIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _patternIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _patternIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _patternImethods_collect
            -- copy rule (up)
            (_lhsOname@_) =
                _patternIname
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_patternOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_patternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_patternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_patternOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_patternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_patternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_patternOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_patternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
sem_Pattern_Record :: (T_Range) ->
                      (T_Name) ->
                      (T_RecordPatternBindings) ->
                      (T_Pattern)
sem_Pattern_Record (range_) (name_) (recordPatternBindings_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _recordPatternBindingsIconstructors_collect :: (FMap Name Names)
            _recordPatternBindingsIdependencies_collect :: (FMap Name [(Name,Name)])
            _recordPatternBindingsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _recordPatternBindingsIlabels_collect :: (FMap Name Names)
            _recordPatternBindingsImethods_collect :: (FMap Name Names)
            _recordPatternBindingsIself :: (RecordPatternBindings)
            _recordPatternBindingsOclassname :: (Maybe Name)
            _recordPatternBindingsOconstructors_collect :: (FMap Name Names)
            _recordPatternBindingsOconstructors_dist :: (FMap Name Names)
            _recordPatternBindingsOcurrentModule :: (Strings)
            _recordPatternBindingsOdependencies_collect :: (FMap Name [(Name,Name)])
            _recordPatternBindingsOimportedModule :: (Bool)
            _recordPatternBindingsOinferredDependencies :: (FMap Name [(Name,Name)])
            _recordPatternBindingsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _recordPatternBindingsOinstancename :: (Maybe Name)
            _recordPatternBindingsOlabels_collect :: (FMap Name Names)
            _recordPatternBindingsOlabels_dist :: (FMap Name Names)
            _recordPatternBindingsOlocal :: (Bool)
            _recordPatternBindingsOmethods_collect :: (FMap Name Names)
            _recordPatternBindingsOmethods_dist :: (FMap Name Names)
            _recordPatternBindingsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _recordPatternBindingsIconstructors_collect,_recordPatternBindingsIdependencies_collect,_recordPatternBindingsIinferredDependencies_collect,_recordPatternBindingsIlabels_collect,_recordPatternBindingsImethods_collect,_recordPatternBindingsIself) =
                (recordPatternBindings_ (_recordPatternBindingsOclassname)
                                        (_recordPatternBindingsOconstructors_collect)
                                        (_recordPatternBindingsOconstructors_dist)
                                        (_recordPatternBindingsOcurrentModule)
                                        (_recordPatternBindingsOdependencies_collect)
                                        (_recordPatternBindingsOimportedModule)
                                        (_recordPatternBindingsOinferredDependencies)
                                        (_recordPatternBindingsOinferredDependencies_collect)
                                        (_recordPatternBindingsOinstancename)
                                        (_recordPatternBindingsOlabels_collect)
                                        (_recordPatternBindingsOlabels_dist)
                                        (_recordPatternBindingsOlocal)
                                        (_recordPatternBindingsOmethods_collect)
                                        (_recordPatternBindingsOmethods_dist)
                                        (_recordPatternBindingsOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 456, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.Pattern.Record.name: pattern binding in class/instance"
            -- self rule
            (_self@_) =
                Pattern_Record _rangeIself _nameIself _recordPatternBindingsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _recordPatternBindingsIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _recordPatternBindingsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _recordPatternBindingsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _recordPatternBindingsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _recordPatternBindingsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_recordPatternBindingsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_recordPatternBindingsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_recordPatternBindingsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_recordPatternBindingsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_recordPatternBindingsOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_recordPatternBindingsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_recordPatternBindingsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_recordPatternBindingsOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_recordPatternBindingsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_recordPatternBindingsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_recordPatternBindingsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_recordPatternBindingsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_recordPatternBindingsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_recordPatternBindingsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_recordPatternBindingsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
sem_Pattern_Successor :: (T_Range) ->
                         (T_Name) ->
                         (T_Literal) ->
                         (T_Pattern)
sem_Pattern_Successor (range_) (name_) (literal_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _literalIconstructors_collect :: (FMap Name Names)
            _literalIdependencies_collect :: (FMap Name [(Name,Name)])
            _literalIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _literalIlabels_collect :: (FMap Name Names)
            _literalImethods_collect :: (FMap Name Names)
            _literalIself :: (Literal)
            _literalOclassname :: (Maybe Name)
            _literalOconstructors_collect :: (FMap Name Names)
            _literalOconstructors_dist :: (FMap Name Names)
            _literalOcurrentModule :: (Strings)
            _literalOdependencies_collect :: (FMap Name [(Name,Name)])
            _literalOimportedModule :: (Bool)
            _literalOinferredDependencies :: (FMap Name [(Name,Name)])
            _literalOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _literalOinstancename :: (Maybe Name)
            _literalOlabels_collect :: (FMap Name Names)
            _literalOlabels_dist :: (FMap Name Names)
            _literalOlocal :: (Bool)
            _literalOmethods_collect :: (FMap Name Names)
            _literalOmethods_dist :: (FMap Name Names)
            _literalOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _literalIconstructors_collect,_literalIdependencies_collect,_literalIinferredDependencies_collect,_literalIlabels_collect,_literalImethods_collect,_literalIself) =
                (literal_ (_literalOclassname) (_literalOconstructors_collect) (_literalOconstructors_dist) (_literalOcurrentModule) (_literalOdependencies_collect) (_literalOimportedModule) (_literalOinferredDependencies) (_literalOinferredDependencies_collect) (_literalOinstancename) (_literalOlabels_collect) (_literalOlabels_dist) (_literalOlocal) (_literalOmethods_collect) (_literalOmethods_dist) (_literalOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 468, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.Pattern.Successor.name: pattern binding in class/instance"
            -- self rule
            (_self@_) =
                Pattern_Successor _rangeIself _nameIself _literalIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _literalIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _literalIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _literalIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _literalIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _literalImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_literalOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_literalOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_literalOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_literalOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_literalOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_literalOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_literalOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_literalOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_literalOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_literalOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_literalOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_literalOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_literalOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_literalOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_literalOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
sem_Pattern_Tuple :: (T_Range) ->
                     (T_Patterns) ->
                     (T_Pattern)
sem_Pattern_Tuple (range_) (patterns_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _patternsIconstructors_collect :: (FMap Name Names)
            _patternsIdependencies_collect :: (FMap Name [(Name,Name)])
            _patternsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _patternsIlabels_collect :: (FMap Name Names)
            _patternsImethods_collect :: (FMap Name Names)
            _patternsIself :: (Patterns)
            _patternsOclassname :: (Maybe Name)
            _patternsOconstructors_collect :: (FMap Name Names)
            _patternsOconstructors_dist :: (FMap Name Names)
            _patternsOcurrentModule :: (Strings)
            _patternsOdependencies_collect :: (FMap Name [(Name,Name)])
            _patternsOimportedModule :: (Bool)
            _patternsOinferredDependencies :: (FMap Name [(Name,Name)])
            _patternsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _patternsOinstancename :: (Maybe Name)
            _patternsOlabels_collect :: (FMap Name Names)
            _patternsOlabels_dist :: (FMap Name Names)
            _patternsOlocal :: (Bool)
            _patternsOmethods_collect :: (FMap Name Names)
            _patternsOmethods_dist :: (FMap Name Names)
            _patternsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _patternsIconstructors_collect,_patternsIdependencies_collect,_patternsIinferredDependencies_collect,_patternsIlabels_collect,_patternsImethods_collect,_patternsIself) =
                (patterns_ (_patternsOclassname) (_patternsOconstructors_collect) (_patternsOconstructors_dist) (_patternsOcurrentModule) (_patternsOdependencies_collect) (_patternsOimportedModule) (_patternsOinferredDependencies) (_patternsOinferredDependencies_collect) (_patternsOinstancename) (_patternsOlabels_collect) (_patternsOlabels_dist) (_patternsOlocal) (_patternsOmethods_collect) (_patternsOmethods_dist) (_patternsOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 453, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.Pattern.Tuple.name: pattern binding in class/instance"
            -- self rule
            (_self@_) =
                Pattern_Tuple _rangeIself _patternsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _patternsIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _patternsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _patternsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _patternsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _patternsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_patternsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_patternsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_patternsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_patternsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_patternsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_patternsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_patternsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_patternsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
sem_Pattern_Variable :: (T_Range) ->
                        (T_Name) ->
                        (T_Pattern)
sem_Pattern_Variable (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 439, column 9)
            (_lhsOname@_) =
                _nameIself
            -- self rule
            (_self@_) =
                Pattern_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
sem_Pattern_Wildcard :: (T_Range) ->
                        (T_Pattern)
sem_Pattern_Wildcard (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (Pattern)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 465, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.Pattern.Wildcard.name: pattern binding in class/instance"
            -- self rule
            (_self@_) =
                Pattern_Wildcard _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
-- Patterns ----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Patterns.Cons:
      self

-}
{-
   local variables for Patterns.Nil:
      self

-}
-- semantic domain
type T_Patterns = (Maybe Name) ->
                  (FMap Name Names) ->
                  (FMap Name Names) ->
                  (Strings) ->
                  (FMap Name [(Name,Name)]) ->
                  (Bool) ->
                  (FMap Name [(Name,Name)]) ->
                  (FMap Name [(Name,Name)]) ->
                  (Maybe Name) ->
                  (FMap Name Names) ->
                  (FMap Name Names) ->
                  (Bool) ->
                  (FMap Name Names) ->
                  (FMap Name Names) ->
                  (Bool) ->
                  ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(Patterns))
-- cata
sem_Patterns :: (Patterns) ->
                (T_Patterns)
sem_Patterns (list) =
    (foldr (sem_Patterns_Cons) (sem_Patterns_Nil) ((map sem_Pattern list)))
sem_Patterns_Cons :: (T_Pattern) ->
                     (T_Patterns) ->
                     (T_Patterns)
sem_Patterns_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Patterns)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdependencies_collect :: (FMap Name [(Name,Name)])
            _hdIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIname :: (Name)
            _hdIself :: (Pattern)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies_collect :: (FMap Name [(Name,Name)])
            _hdOimportedModule :: (Bool)
            _hdOinferredDependencies :: (FMap Name [(Name,Name)])
            _hdOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdOinstancename :: (Maybe Name)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdependencies_collect :: (FMap Name [(Name,Name)])
            _tlIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIself :: (Patterns)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies_collect :: (FMap Name [(Name,Name)])
            _tlOimportedModule :: (Bool)
            _tlOinferredDependencies :: (FMap Name [(Name,Name)])
            _tlOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIdependencies_collect,_hdIinferredDependencies_collect,_hdIlabels_collect,_hdImethods_collect,_hdIname,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOdependencies_collect) (_hdOimportedModule) (_hdOinferredDependencies) (_hdOinferredDependencies_collect) (_hdOinstancename) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIdependencies_collect,_tlIinferredDependencies_collect,_tlIlabels_collect,_tlImethods_collect,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOdependencies_collect) (_tlOimportedModule) (_tlOinferredDependencies) (_tlOinferredDependencies_collect) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOtoplevel))
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _tlIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _tlIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_hdOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_tlOdependencies_collect@_) =
                _hdIdependencies_collect
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_tlOinferredDependencies_collect@_) =
                _hdIinferredDependencies_collect
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Patterns_Nil :: (T_Patterns)
sem_Patterns_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Patterns)
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- Position ----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      local                : Bool
      toplevel             : Bool

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Position.Position:
      self

-}
{-
   local variables for Position.Unknown:
      self

-}
-- semantic domain
type T_Position = (Maybe Name) ->
                  (Strings) ->
                  (Bool) ->
                  (Maybe Name) ->
                  (Bool) ->
                  (Bool) ->
                  ( (Position))
-- cata
sem_Position :: (Position) ->
                (T_Position)
sem_Position ((Position_Position (_filename) (_line) (_column))) =
    (sem_Position_Position (_filename) (_line) (_column))
sem_Position ((Position_Unknown )) =
    (sem_Position_Unknown )
sem_Position_Position :: (String) ->
                         (Int) ->
                         (Int) ->
                         (T_Position)
sem_Position_Position (filename_) (line_) (column_) =
    \ _lhsIclassname
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlocal
      _lhsItoplevel ->
        let _lhsOself :: (Position)
            -- self rule
            (_self@_) =
                Position_Position filename_ line_ column_
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOself)
sem_Position_Unknown :: (T_Position)
sem_Position_Unknown  =
    \ _lhsIclassname
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlocal
      _lhsItoplevel ->
        let _lhsOself :: (Position)
            -- self rule
            (_self@_) =
                Position_Unknown
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOself)
-- Qualifier ---------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      bodyDependencies     : [(Name,Name)]
      self                 : SELF

-}
{-
   local variables for Qualifier.Empty:
      self

-}
{-
   local variables for Qualifier.Generator:
      self

-}
{-
   local variables for Qualifier.Guard:
      self

-}
{-
   local variables for Qualifier.Let:
      self

-}
-- semantic domain
type T_Qualifier = (Maybe Name) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (Strings) ->
                   (FMap Name [(Name,Name)]) ->
                   (Bool) ->
                   (FMap Name [(Name,Name)]) ->
                   (FMap Name [(Name,Name)]) ->
                   (Maybe Name) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (Bool) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (PreSignatures) ->
                   (PreSignatures) ->
                   (Signatures) ->
                   (Bool) ->
                   ( ([(Name,Name)]),(FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(PreSignatures),(Qualifier))
-- cata
sem_Qualifier :: (Qualifier) ->
                 (T_Qualifier)
sem_Qualifier ((Qualifier_Empty (_range))) =
    (sem_Qualifier_Empty ((sem_Range (_range))))
sem_Qualifier ((Qualifier_Generator (_range) (_pattern) (_expression))) =
    (sem_Qualifier_Generator ((sem_Range (_range))) ((sem_Pattern (_pattern))) ((sem_Expression (_expression))))
sem_Qualifier ((Qualifier_Guard (_range) (_guard))) =
    (sem_Qualifier_Guard ((sem_Range (_range))) ((sem_Expression (_guard))))
sem_Qualifier ((Qualifier_Let (_range) (_declarations))) =
    (sem_Qualifier_Let ((sem_Range (_range))) ((sem_Declarations (_declarations))))
sem_Qualifier_Empty :: (T_Range) ->
                       (T_Qualifier)
sem_Qualifier_Empty (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Qualifier)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                []
            -- self rule
            (_self@_) =
                Qualifier_Empty _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Qualifier_Generator :: (T_Range) ->
                           (T_Pattern) ->
                           (T_Expression) ->
                           (T_Qualifier)
sem_Qualifier_Generator (range_) (pattern_) (expression_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Qualifier)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _patternIconstructors_collect :: (FMap Name Names)
            _patternIdependencies_collect :: (FMap Name [(Name,Name)])
            _patternIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _patternIlabels_collect :: (FMap Name Names)
            _patternImethods_collect :: (FMap Name Names)
            _patternIname :: (Name)
            _patternIself :: (Pattern)
            _patternOclassname :: (Maybe Name)
            _patternOconstructors_collect :: (FMap Name Names)
            _patternOconstructors_dist :: (FMap Name Names)
            _patternOcurrentModule :: (Strings)
            _patternOdependencies_collect :: (FMap Name [(Name,Name)])
            _patternOimportedModule :: (Bool)
            _patternOinferredDependencies :: (FMap Name [(Name,Name)])
            _patternOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _patternOinstancename :: (Maybe Name)
            _patternOlabels_collect :: (FMap Name Names)
            _patternOlabels_dist :: (FMap Name Names)
            _patternOlocal :: (Bool)
            _patternOmethods_collect :: (FMap Name Names)
            _patternOmethods_dist :: (FMap Name Names)
            _patternOtoplevel :: (Bool)
            _expressionIbodyDependencies :: ([(Name,Name)])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOimportedModule :: (Bool)
            _expressionOinferredDependencies :: (FMap Name [(Name,Name)])
            _expressionOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOinstancename :: (Maybe Name)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOsignatures :: (Signatures)
            _expressionOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _patternIconstructors_collect,_patternIdependencies_collect,_patternIinferredDependencies_collect,_patternIlabels_collect,_patternImethods_collect,_patternIname,_patternIself) =
                (pattern_ (_patternOclassname) (_patternOconstructors_collect) (_patternOconstructors_dist) (_patternOcurrentModule) (_patternOdependencies_collect) (_patternOimportedModule) (_patternOinferredDependencies) (_patternOinferredDependencies_collect) (_patternOinstancename) (_patternOlabels_collect) (_patternOlabels_dist) (_patternOlocal) (_patternOmethods_collect) (_patternOmethods_dist) (_patternOtoplevel))
            ( _expressionIbodyDependencies,_expressionIconstructors_collect,_expressionIdependencies_collect,_expressionIinferredDependencies_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionIpresignatures_collect,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies_collect)
                             (_expressionOimportedModule)
                             (_expressionOinferredDependencies)
                             (_expressionOinferredDependencies_collect)
                             (_expressionOinstancename)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOsignatures)
                             (_expressionOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _expressionIbodyDependencies
            -- self rule
            (_self@_) =
                Qualifier_Generator _rangeIself _patternIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _expressionIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _expressionIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_patternOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_patternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_patternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_patternOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_patternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_patternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_patternOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_patternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_expressionOconstructors_collect@_) =
                _patternIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_expressionOdependencies_collect@_) =
                _patternIdependencies_collect
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_expressionOinferredDependencies_collect@_) =
                _patternIinferredDependencies_collect
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_expressionOlabels_collect@_) =
                _patternIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_expressionOmethods_collect@_) =
                _patternImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Qualifier_Guard :: (T_Range) ->
                       (T_Expression) ->
                       (T_Qualifier)
sem_Qualifier_Guard (range_) (guard_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Qualifier)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _guardIbodyDependencies :: ([(Name,Name)])
            _guardIconstructors_collect :: (FMap Name Names)
            _guardIdependencies_collect :: (FMap Name [(Name,Name)])
            _guardIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _guardIlabels_collect :: (FMap Name Names)
            _guardImethods_collect :: (FMap Name Names)
            _guardIpresignatures_collect :: (PreSignatures)
            _guardIself :: (Expression)
            _guardOclassname :: (Maybe Name)
            _guardOconstructors_collect :: (FMap Name Names)
            _guardOconstructors_dist :: (FMap Name Names)
            _guardOcurrentModule :: (Strings)
            _guardOdependencies_collect :: (FMap Name [(Name,Name)])
            _guardOimportedModule :: (Bool)
            _guardOinferredDependencies :: (FMap Name [(Name,Name)])
            _guardOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _guardOinstancename :: (Maybe Name)
            _guardOlabels_collect :: (FMap Name Names)
            _guardOlabels_dist :: (FMap Name Names)
            _guardOlocal :: (Bool)
            _guardOmethods_collect :: (FMap Name Names)
            _guardOmethods_dist :: (FMap Name Names)
            _guardOpresignatures :: (PreSignatures)
            _guardOpresignatures_collect :: (PreSignatures)
            _guardOsignatures :: (Signatures)
            _guardOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _guardIbodyDependencies,_guardIconstructors_collect,_guardIdependencies_collect,_guardIinferredDependencies_collect,_guardIlabels_collect,_guardImethods_collect,_guardIpresignatures_collect,_guardIself) =
                (guard_ (_guardOclassname)
                        (_guardOconstructors_collect)
                        (_guardOconstructors_dist)
                        (_guardOcurrentModule)
                        (_guardOdependencies_collect)
                        (_guardOimportedModule)
                        (_guardOinferredDependencies)
                        (_guardOinferredDependencies_collect)
                        (_guardOinstancename)
                        (_guardOlabels_collect)
                        (_guardOlabels_dist)
                        (_guardOlocal)
                        (_guardOmethods_collect)
                        (_guardOmethods_dist)
                        (_guardOpresignatures)
                        (_guardOpresignatures_collect)
                        (_guardOsignatures)
                        (_guardOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _guardIbodyDependencies
            -- self rule
            (_self@_) =
                Qualifier_Guard _rangeIself _guardIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _guardIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _guardIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _guardIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _guardIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _guardImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _guardIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_guardOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_guardOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_guardOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_guardOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_guardOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_guardOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_guardOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_guardOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_guardOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_guardOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_guardOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_guardOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_guardOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_guardOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_guardOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_guardOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_guardOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_guardOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Qualifier_Let :: (T_Range) ->
                     (T_Declarations) ->
                     (T_Qualifier)
sem_Qualifier_Let (range_) (declarations_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Qualifier)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _declarationsIbodyDependencies :: ([(Name,Name)])
            _declarationsIconstructors_collect :: (FMap Name Names)
            _declarationsIdependencies_collect :: (FMap Name [(Name,Name)])
            _declarationsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _declarationsIlabels_collect :: (FMap Name Names)
            _declarationsImethods_collect :: (FMap Name Names)
            _declarationsIpresignatures_collect :: (PreSignatures)
            _declarationsIself :: (Declarations)
            _declarationsOclassname :: (Maybe Name)
            _declarationsOconstructors_collect :: (FMap Name Names)
            _declarationsOconstructors_dist :: (FMap Name Names)
            _declarationsOcurrentModule :: (Strings)
            _declarationsOdependencies_collect :: (FMap Name [(Name,Name)])
            _declarationsOimportedModule :: (Bool)
            _declarationsOinferredDependencies :: (FMap Name [(Name,Name)])
            _declarationsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _declarationsOinstancename :: (Maybe Name)
            _declarationsOlabels_collect :: (FMap Name Names)
            _declarationsOlabels_dist :: (FMap Name Names)
            _declarationsOlocal :: (Bool)
            _declarationsOmethods_collect :: (FMap Name Names)
            _declarationsOmethods_dist :: (FMap Name Names)
            _declarationsOpresignatures :: (PreSignatures)
            _declarationsOpresignatures_collect :: (PreSignatures)
            _declarationsOsignatures :: (Signatures)
            _declarationsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _declarationsIbodyDependencies,_declarationsIconstructors_collect,_declarationsIdependencies_collect,_declarationsIinferredDependencies_collect,_declarationsIlabels_collect,_declarationsImethods_collect,_declarationsIpresignatures_collect,_declarationsIself) =
                (declarations_ (_declarationsOclassname)
                               (_declarationsOconstructors_collect)
                               (_declarationsOconstructors_dist)
                               (_declarationsOcurrentModule)
                               (_declarationsOdependencies_collect)
                               (_declarationsOimportedModule)
                               (_declarationsOinferredDependencies)
                               (_declarationsOinferredDependencies_collect)
                               (_declarationsOinstancename)
                               (_declarationsOlabels_collect)
                               (_declarationsOlabels_dist)
                               (_declarationsOlocal)
                               (_declarationsOmethods_collect)
                               (_declarationsOmethods_dist)
                               (_declarationsOpresignatures)
                               (_declarationsOpresignatures_collect)
                               (_declarationsOsignatures)
                               (_declarationsOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _declarationsIbodyDependencies
            -- self rule
            (_self@_) =
                Qualifier_Let _rangeIself _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _declarationsIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _declarationsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _declarationsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _declarationsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _declarationsImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _declarationsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_declarationsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_declarationsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_declarationsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_declarationsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_declarationsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_declarationsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_declarationsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_declarationsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_declarationsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_declarationsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_declarationsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_declarationsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_declarationsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_declarationsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_declarationsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_declarationsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_declarationsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_declarationsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- Qualifiers --------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      bodyDependencies     : [(Name,Name)]
      self                 : SELF

-}
{-
   local variables for Qualifiers.Cons:
      self

-}
{-
   local variables for Qualifiers.Nil:
      self

-}
-- semantic domain
type T_Qualifiers = (Maybe Name) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Strings) ->
                    (FMap Name [(Name,Name)]) ->
                    (Bool) ->
                    (FMap Name [(Name,Name)]) ->
                    (FMap Name [(Name,Name)]) ->
                    (Maybe Name) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Bool) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (PreSignatures) ->
                    (PreSignatures) ->
                    (Signatures) ->
                    (Bool) ->
                    ( ([(Name,Name)]),(FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(PreSignatures),(Qualifiers))
-- cata
sem_Qualifiers :: (Qualifiers) ->
                  (T_Qualifiers)
sem_Qualifiers (list) =
    (foldr (sem_Qualifiers_Cons) (sem_Qualifiers_Nil) ((map sem_Qualifier list)))
sem_Qualifiers_Cons :: (T_Qualifier) ->
                       (T_Qualifiers) ->
                       (T_Qualifiers)
sem_Qualifiers_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Qualifiers)
            _hdIbodyDependencies :: ([(Name,Name)])
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdependencies_collect :: (FMap Name [(Name,Name)])
            _hdIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIpresignatures_collect :: (PreSignatures)
            _hdIself :: (Qualifier)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies_collect :: (FMap Name [(Name,Name)])
            _hdOimportedModule :: (Bool)
            _hdOinferredDependencies :: (FMap Name [(Name,Name)])
            _hdOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdOinstancename :: (Maybe Name)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOpresignatures :: (PreSignatures)
            _hdOpresignatures_collect :: (PreSignatures)
            _hdOsignatures :: (Signatures)
            _hdOtoplevel :: (Bool)
            _tlIbodyDependencies :: ([(Name,Name)])
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdependencies_collect :: (FMap Name [(Name,Name)])
            _tlIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIpresignatures_collect :: (PreSignatures)
            _tlIself :: (Qualifiers)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies_collect :: (FMap Name [(Name,Name)])
            _tlOimportedModule :: (Bool)
            _tlOinferredDependencies :: (FMap Name [(Name,Name)])
            _tlOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOpresignatures :: (PreSignatures)
            _tlOpresignatures_collect :: (PreSignatures)
            _tlOsignatures :: (Signatures)
            _tlOtoplevel :: (Bool)
            ( _hdIbodyDependencies,_hdIconstructors_collect,_hdIdependencies_collect,_hdIinferredDependencies_collect,_hdIlabels_collect,_hdImethods_collect,_hdIpresignatures_collect,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOdependencies_collect) (_hdOimportedModule) (_hdOinferredDependencies) (_hdOinferredDependencies_collect) (_hdOinstancename) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOpresignatures) (_hdOpresignatures_collect) (_hdOsignatures) (_hdOtoplevel))
            ( _tlIbodyDependencies,_tlIconstructors_collect,_tlIdependencies_collect,_tlIinferredDependencies_collect,_tlIlabels_collect,_tlImethods_collect,_tlIpresignatures_collect,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOdependencies_collect) (_tlOimportedModule) (_tlOinferredDependencies) (_tlOinferredDependencies_collect) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOpresignatures) (_tlOpresignatures_collect) (_tlOsignatures) (_tlOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _hdIbodyDependencies ++ _tlIbodyDependencies
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _tlIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _tlIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _tlIpresignatures_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_hdOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_hdOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_hdOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_tlOdependencies_collect@_) =
                _hdIdependencies_collect
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_tlOinferredDependencies_collect@_) =
                _hdIinferredDependencies_collect
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_tlOpresignatures_collect@_) =
                _hdIpresignatures_collect
            -- copy rule (down)
            (_tlOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Qualifiers_Nil :: (T_Qualifiers)
sem_Qualifiers_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Qualifiers)
            -- use rule
            (_lhsObodyDependencies@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- Range -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      currentModule        : Strings
      importedModule       : Bool
      instancename         : Maybe Name
      local                : Bool
      toplevel             : Bool

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Range.Range:
      self

-}
-- semantic domain
type T_Range = (Maybe Name) ->
               (Strings) ->
               (Bool) ->
               (Maybe Name) ->
               (Bool) ->
               (Bool) ->
               ( (Range))
-- cata
sem_Range :: (Range) ->
             (T_Range)
sem_Range ((Range_Range (_start) (_stop))) =
    (sem_Range_Range ((sem_Position (_start))) ((sem_Position (_stop))))
sem_Range_Range :: (T_Position) ->
                   (T_Position) ->
                   (T_Range)
sem_Range_Range (start_) (stop_) =
    \ _lhsIclassname
      _lhsIcurrentModule
      _lhsIimportedModule
      _lhsIinstancename
      _lhsIlocal
      _lhsItoplevel ->
        let _lhsOself :: (Range)
            _startIself :: (Position)
            _startOclassname :: (Maybe Name)
            _startOcurrentModule :: (Strings)
            _startOimportedModule :: (Bool)
            _startOinstancename :: (Maybe Name)
            _startOlocal :: (Bool)
            _startOtoplevel :: (Bool)
            _stopIself :: (Position)
            _stopOclassname :: (Maybe Name)
            _stopOcurrentModule :: (Strings)
            _stopOimportedModule :: (Bool)
            _stopOinstancename :: (Maybe Name)
            _stopOlocal :: (Bool)
            _stopOtoplevel :: (Bool)
            ( _startIself) =
                (start_ (_startOclassname) (_startOcurrentModule) (_startOimportedModule) (_startOinstancename) (_startOlocal) (_startOtoplevel))
            ( _stopIself) =
                (stop_ (_stopOclassname) (_stopOcurrentModule) (_stopOimportedModule) (_stopOinstancename) (_stopOlocal) (_stopOtoplevel))
            -- self rule
            (_self@_) =
                Range_Range _startIself _stopIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_startOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_startOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_startOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_startOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_startOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_startOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_stopOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_stopOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_stopOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_stopOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_stopOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_stopOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOself)
-- Reassignment ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Reassignment.Reassignment:
      self

-}
-- semantic domain
type T_Reassignment = (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Strings) ->
                      (FMap Name [(Name,Name)]) ->
                      (Bool) ->
                      (FMap Name [(Name,Name)]) ->
                      (FMap Name [(Name,Name)]) ->
                      (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(Reassignment))
-- cata
sem_Reassignment :: (Reassignment) ->
                    (T_Reassignment)
sem_Reassignment ((Reassignment_Reassignment (_range) (_name) (_as))) =
    (sem_Reassignment_Reassignment ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Name (_as))))
sem_Reassignment_Reassignment :: (T_Range) ->
                                 (T_Name) ->
                                 (T_Name) ->
                                 (T_Reassignment)
sem_Reassignment_Reassignment (range_) (name_) (as_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Reassignment)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _asIconstructors_collect :: (FMap Name Names)
            _asIdependencies_collect :: (FMap Name [(Name,Name)])
            _asIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _asIlabels_collect :: (FMap Name Names)
            _asImethods_collect :: (FMap Name Names)
            _asIself :: (Name)
            _asOclassname :: (Maybe Name)
            _asOconstructors_collect :: (FMap Name Names)
            _asOconstructors_dist :: (FMap Name Names)
            _asOcurrentModule :: (Strings)
            _asOdependencies_collect :: (FMap Name [(Name,Name)])
            _asOimportedModule :: (Bool)
            _asOinferredDependencies :: (FMap Name [(Name,Name)])
            _asOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _asOinstancename :: (Maybe Name)
            _asOlabels_collect :: (FMap Name Names)
            _asOlabels_dist :: (FMap Name Names)
            _asOlocal :: (Bool)
            _asOmethods_collect :: (FMap Name Names)
            _asOmethods_dist :: (FMap Name Names)
            _asOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _asIconstructors_collect,_asIdependencies_collect,_asIinferredDependencies_collect,_asIlabels_collect,_asImethods_collect,_asIself) =
                (as_ (_asOclassname) (_asOconstructors_collect) (_asOconstructors_dist) (_asOcurrentModule) (_asOdependencies_collect) (_asOimportedModule) (_asOinferredDependencies) (_asOinferredDependencies_collect) (_asOinstancename) (_asOlabels_collect) (_asOlabels_dist) (_asOlocal) (_asOmethods_collect) (_asOmethods_dist) (_asOtoplevel))
            -- self rule
            (_self@_) =
                Reassignment_Reassignment _rangeIself _nameIself _asIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _asIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _asIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _asIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _asIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _asImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_asOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_asOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_asOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_asOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_asOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_asOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_asOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_asOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_asOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_asOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_asOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_asOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_asOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_asOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_asOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- Reassignments -----------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Reassignments.Cons:
      self

-}
{-
   local variables for Reassignments.Nil:
      self

-}
-- semantic domain
type T_Reassignments = (Maybe Name) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (Strings) ->
                       (FMap Name [(Name,Name)]) ->
                       (Bool) ->
                       (FMap Name [(Name,Name)]) ->
                       (FMap Name [(Name,Name)]) ->
                       (Maybe Name) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (Bool) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (Bool) ->
                       ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(Reassignments))
-- cata
sem_Reassignments :: (Reassignments) ->
                     (T_Reassignments)
sem_Reassignments (list) =
    (foldr (sem_Reassignments_Cons) (sem_Reassignments_Nil) ((map sem_Reassignment list)))
sem_Reassignments_Cons :: (T_Reassignment) ->
                          (T_Reassignments) ->
                          (T_Reassignments)
sem_Reassignments_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Reassignments)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdependencies_collect :: (FMap Name [(Name,Name)])
            _hdIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIself :: (Reassignment)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies_collect :: (FMap Name [(Name,Name)])
            _hdOimportedModule :: (Bool)
            _hdOinferredDependencies :: (FMap Name [(Name,Name)])
            _hdOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdOinstancename :: (Maybe Name)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdependencies_collect :: (FMap Name [(Name,Name)])
            _tlIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIself :: (Reassignments)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies_collect :: (FMap Name [(Name,Name)])
            _tlOimportedModule :: (Bool)
            _tlOinferredDependencies :: (FMap Name [(Name,Name)])
            _tlOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIdependencies_collect,_hdIinferredDependencies_collect,_hdIlabels_collect,_hdImethods_collect,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOdependencies_collect) (_hdOimportedModule) (_hdOinferredDependencies) (_hdOinferredDependencies_collect) (_hdOinstancename) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIdependencies_collect,_tlIinferredDependencies_collect,_tlIlabels_collect,_tlImethods_collect,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOdependencies_collect) (_tlOimportedModule) (_tlOinferredDependencies) (_tlOinferredDependencies_collect) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOtoplevel))
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _tlIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _tlIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_hdOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_tlOdependencies_collect@_) =
                _hdIdependencies_collect
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_tlOinferredDependencies_collect@_) =
                _hdIinferredDependencies_collect
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Reassignments_Nil :: (T_Reassignments)
sem_Reassignments_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Reassignments)
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- RecordExpressionBinding -------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      bodyDependencies     : [(Name,Name)]
      self                 : SELF

-}
{-
   local variables for RecordExpressionBinding.RecordExpressionBinding:
      self

-}
-- semantic domain
type T_RecordExpressionBinding = (Maybe Name) ->
                                 (FMap Name Names) ->
                                 (FMap Name Names) ->
                                 (Strings) ->
                                 (FMap Name [(Name,Name)]) ->
                                 (Bool) ->
                                 (FMap Name [(Name,Name)]) ->
                                 (FMap Name [(Name,Name)]) ->
                                 (Maybe Name) ->
                                 (FMap Name Names) ->
                                 (FMap Name Names) ->
                                 (Bool) ->
                                 (FMap Name Names) ->
                                 (FMap Name Names) ->
                                 (PreSignatures) ->
                                 (PreSignatures) ->
                                 (Signatures) ->
                                 (Bool) ->
                                 ( ([(Name,Name)]),(FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(PreSignatures),(RecordExpressionBinding))
-- cata
sem_RecordExpressionBinding :: (RecordExpressionBinding) ->
                               (T_RecordExpressionBinding)
sem_RecordExpressionBinding ((RecordExpressionBinding_RecordExpressionBinding (_range) (_name) (_expression))) =
    (sem_RecordExpressionBinding_RecordExpressionBinding ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Expression (_expression))))
sem_RecordExpressionBinding_RecordExpressionBinding :: (T_Range) ->
                                                       (T_Name) ->
                                                       (T_Expression) ->
                                                       (T_RecordExpressionBinding)
sem_RecordExpressionBinding_RecordExpressionBinding (range_) (name_) (expression_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (RecordExpressionBinding)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _expressionIbodyDependencies :: ([(Name,Name)])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOimportedModule :: (Bool)
            _expressionOinferredDependencies :: (FMap Name [(Name,Name)])
            _expressionOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOinstancename :: (Maybe Name)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOsignatures :: (Signatures)
            _expressionOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _expressionIbodyDependencies,_expressionIconstructors_collect,_expressionIdependencies_collect,_expressionIinferredDependencies_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionIpresignatures_collect,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies_collect)
                             (_expressionOimportedModule)
                             (_expressionOinferredDependencies)
                             (_expressionOinferredDependencies_collect)
                             (_expressionOinstancename)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOsignatures)
                             (_expressionOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _expressionIbodyDependencies
            -- self rule
            (_self@_) =
                RecordExpressionBinding_RecordExpressionBinding _rangeIself _nameIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _expressionIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _expressionIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_expressionOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_expressionOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_expressionOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_expressionOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_expressionOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- RecordExpressionBindings ------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      bodyDependencies     : [(Name,Name)]
      self                 : SELF

-}
{-
   local variables for RecordExpressionBindings.Cons:
      self

-}
{-
   local variables for RecordExpressionBindings.Nil:
      self

-}
-- semantic domain
type T_RecordExpressionBindings = (Maybe Name) ->
                                  (FMap Name Names) ->
                                  (FMap Name Names) ->
                                  (Strings) ->
                                  (FMap Name [(Name,Name)]) ->
                                  (Bool) ->
                                  (FMap Name [(Name,Name)]) ->
                                  (FMap Name [(Name,Name)]) ->
                                  (Maybe Name) ->
                                  (FMap Name Names) ->
                                  (FMap Name Names) ->
                                  (Bool) ->
                                  (FMap Name Names) ->
                                  (FMap Name Names) ->
                                  (PreSignatures) ->
                                  (PreSignatures) ->
                                  (Signatures) ->
                                  (Bool) ->
                                  ( ([(Name,Name)]),(FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(PreSignatures),(RecordExpressionBindings))
-- cata
sem_RecordExpressionBindings :: (RecordExpressionBindings) ->
                                (T_RecordExpressionBindings)
sem_RecordExpressionBindings (list) =
    (foldr (sem_RecordExpressionBindings_Cons) (sem_RecordExpressionBindings_Nil) ((map sem_RecordExpressionBinding list)))
sem_RecordExpressionBindings_Cons :: (T_RecordExpressionBinding) ->
                                     (T_RecordExpressionBindings) ->
                                     (T_RecordExpressionBindings)
sem_RecordExpressionBindings_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (RecordExpressionBindings)
            _hdIbodyDependencies :: ([(Name,Name)])
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdependencies_collect :: (FMap Name [(Name,Name)])
            _hdIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIpresignatures_collect :: (PreSignatures)
            _hdIself :: (RecordExpressionBinding)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies_collect :: (FMap Name [(Name,Name)])
            _hdOimportedModule :: (Bool)
            _hdOinferredDependencies :: (FMap Name [(Name,Name)])
            _hdOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdOinstancename :: (Maybe Name)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOpresignatures :: (PreSignatures)
            _hdOpresignatures_collect :: (PreSignatures)
            _hdOsignatures :: (Signatures)
            _hdOtoplevel :: (Bool)
            _tlIbodyDependencies :: ([(Name,Name)])
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdependencies_collect :: (FMap Name [(Name,Name)])
            _tlIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIpresignatures_collect :: (PreSignatures)
            _tlIself :: (RecordExpressionBindings)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies_collect :: (FMap Name [(Name,Name)])
            _tlOimportedModule :: (Bool)
            _tlOinferredDependencies :: (FMap Name [(Name,Name)])
            _tlOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOpresignatures :: (PreSignatures)
            _tlOpresignatures_collect :: (PreSignatures)
            _tlOsignatures :: (Signatures)
            _tlOtoplevel :: (Bool)
            ( _hdIbodyDependencies,_hdIconstructors_collect,_hdIdependencies_collect,_hdIinferredDependencies_collect,_hdIlabels_collect,_hdImethods_collect,_hdIpresignatures_collect,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOdependencies_collect) (_hdOimportedModule) (_hdOinferredDependencies) (_hdOinferredDependencies_collect) (_hdOinstancename) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOpresignatures) (_hdOpresignatures_collect) (_hdOsignatures) (_hdOtoplevel))
            ( _tlIbodyDependencies,_tlIconstructors_collect,_tlIdependencies_collect,_tlIinferredDependencies_collect,_tlIlabels_collect,_tlImethods_collect,_tlIpresignatures_collect,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOdependencies_collect) (_tlOimportedModule) (_tlOinferredDependencies) (_tlOinferredDependencies_collect) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOpresignatures) (_tlOpresignatures_collect) (_tlOsignatures) (_tlOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _hdIbodyDependencies ++ _tlIbodyDependencies
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _tlIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _tlIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _tlIpresignatures_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_hdOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_hdOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_hdOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_tlOdependencies_collect@_) =
                _hdIdependencies_collect
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_tlOinferredDependencies_collect@_) =
                _hdIinferredDependencies_collect
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_tlOpresignatures_collect@_) =
                _hdIpresignatures_collect
            -- copy rule (down)
            (_tlOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_RecordExpressionBindings_Nil :: (T_RecordExpressionBindings)
sem_RecordExpressionBindings_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (RecordExpressionBindings)
            -- use rule
            (_lhsObodyDependencies@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- RecordPatternBinding ----------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for RecordPatternBinding.RecordPatternBinding:
      self

-}
-- semantic domain
type T_RecordPatternBinding = (Maybe Name) ->
                              (FMap Name Names) ->
                              (FMap Name Names) ->
                              (Strings) ->
                              (FMap Name [(Name,Name)]) ->
                              (Bool) ->
                              (FMap Name [(Name,Name)]) ->
                              (FMap Name [(Name,Name)]) ->
                              (Maybe Name) ->
                              (FMap Name Names) ->
                              (FMap Name Names) ->
                              (Bool) ->
                              (FMap Name Names) ->
                              (FMap Name Names) ->
                              (Bool) ->
                              ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(RecordPatternBinding))
-- cata
sem_RecordPatternBinding :: (RecordPatternBinding) ->
                            (T_RecordPatternBinding)
sem_RecordPatternBinding ((RecordPatternBinding_RecordPatternBinding (_range) (_name) (_pattern))) =
    (sem_RecordPatternBinding_RecordPatternBinding ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Pattern (_pattern))))
sem_RecordPatternBinding_RecordPatternBinding :: (T_Range) ->
                                                 (T_Name) ->
                                                 (T_Pattern) ->
                                                 (T_RecordPatternBinding)
sem_RecordPatternBinding_RecordPatternBinding (range_) (name_) (pattern_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (RecordPatternBinding)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _patternIconstructors_collect :: (FMap Name Names)
            _patternIdependencies_collect :: (FMap Name [(Name,Name)])
            _patternIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _patternIlabels_collect :: (FMap Name Names)
            _patternImethods_collect :: (FMap Name Names)
            _patternIname :: (Name)
            _patternIself :: (Pattern)
            _patternOclassname :: (Maybe Name)
            _patternOconstructors_collect :: (FMap Name Names)
            _patternOconstructors_dist :: (FMap Name Names)
            _patternOcurrentModule :: (Strings)
            _patternOdependencies_collect :: (FMap Name [(Name,Name)])
            _patternOimportedModule :: (Bool)
            _patternOinferredDependencies :: (FMap Name [(Name,Name)])
            _patternOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _patternOinstancename :: (Maybe Name)
            _patternOlabels_collect :: (FMap Name Names)
            _patternOlabels_dist :: (FMap Name Names)
            _patternOlocal :: (Bool)
            _patternOmethods_collect :: (FMap Name Names)
            _patternOmethods_dist :: (FMap Name Names)
            _patternOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _patternIconstructors_collect,_patternIdependencies_collect,_patternIinferredDependencies_collect,_patternIlabels_collect,_patternImethods_collect,_patternIname,_patternIself) =
                (pattern_ (_patternOclassname) (_patternOconstructors_collect) (_patternOconstructors_dist) (_patternOcurrentModule) (_patternOdependencies_collect) (_patternOimportedModule) (_patternOinferredDependencies) (_patternOinferredDependencies_collect) (_patternOinstancename) (_patternOlabels_collect) (_patternOlabels_dist) (_patternOlocal) (_patternOmethods_collect) (_patternOmethods_dist) (_patternOtoplevel))
            -- self rule
            (_self@_) =
                RecordPatternBinding_RecordPatternBinding _rangeIself _nameIself _patternIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _patternIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _patternIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _patternIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _patternIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _patternImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_patternOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_patternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_patternOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_patternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_patternOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_patternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_patternOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_patternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_patternOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_patternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- RecordPatternBindings ---------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for RecordPatternBindings.Cons:
      self

-}
{-
   local variables for RecordPatternBindings.Nil:
      self

-}
-- semantic domain
type T_RecordPatternBindings = (Maybe Name) ->
                               (FMap Name Names) ->
                               (FMap Name Names) ->
                               (Strings) ->
                               (FMap Name [(Name,Name)]) ->
                               (Bool) ->
                               (FMap Name [(Name,Name)]) ->
                               (FMap Name [(Name,Name)]) ->
                               (Maybe Name) ->
                               (FMap Name Names) ->
                               (FMap Name Names) ->
                               (Bool) ->
                               (FMap Name Names) ->
                               (FMap Name Names) ->
                               (Bool) ->
                               ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(RecordPatternBindings))
-- cata
sem_RecordPatternBindings :: (RecordPatternBindings) ->
                             (T_RecordPatternBindings)
sem_RecordPatternBindings (list) =
    (foldr (sem_RecordPatternBindings_Cons) (sem_RecordPatternBindings_Nil) ((map sem_RecordPatternBinding list)))
sem_RecordPatternBindings_Cons :: (T_RecordPatternBinding) ->
                                  (T_RecordPatternBindings) ->
                                  (T_RecordPatternBindings)
sem_RecordPatternBindings_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (RecordPatternBindings)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdependencies_collect :: (FMap Name [(Name,Name)])
            _hdIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIself :: (RecordPatternBinding)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies_collect :: (FMap Name [(Name,Name)])
            _hdOimportedModule :: (Bool)
            _hdOinferredDependencies :: (FMap Name [(Name,Name)])
            _hdOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdOinstancename :: (Maybe Name)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdependencies_collect :: (FMap Name [(Name,Name)])
            _tlIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIself :: (RecordPatternBindings)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies_collect :: (FMap Name [(Name,Name)])
            _tlOimportedModule :: (Bool)
            _tlOinferredDependencies :: (FMap Name [(Name,Name)])
            _tlOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIdependencies_collect,_hdIinferredDependencies_collect,_hdIlabels_collect,_hdImethods_collect,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOdependencies_collect) (_hdOimportedModule) (_hdOinferredDependencies) (_hdOinferredDependencies_collect) (_hdOinstancename) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIdependencies_collect,_tlIinferredDependencies_collect,_tlIlabels_collect,_tlImethods_collect,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOdependencies_collect) (_tlOimportedModule) (_tlOinferredDependencies) (_tlOinferredDependencies_collect) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOtoplevel))
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _tlIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _tlIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_hdOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_tlOdependencies_collect@_) =
                _hdIdependencies_collect
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_tlOinferredDependencies_collect@_) =
                _hdIinferredDependencies_collect
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_RecordPatternBindings_Nil :: (T_RecordPatternBindings)
sem_RecordPatternBindings_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (RecordPatternBindings)
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- RightHandSide -----------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      bodyDependencies     : [(Name,Name)]
      self                 : SELF

-}
{-
   local variables for RightHandSide.Expression:
      instancename
      classname
      self

-}
{-
   local variables for RightHandSide.Guarded:
      instancename
      classname
      self

-}
-- semantic domain
type T_RightHandSide = (Maybe Name) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (Strings) ->
                       (FMap Name [(Name,Name)]) ->
                       (Bool) ->
                       (FMap Name [(Name,Name)]) ->
                       (FMap Name [(Name,Name)]) ->
                       (Maybe Name) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (Bool) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (PreSignatures) ->
                       (PreSignatures) ->
                       (Signatures) ->
                       (Bool) ->
                       ( ([(Name,Name)]),(FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(PreSignatures),(RightHandSide))
-- cata
sem_RightHandSide :: (RightHandSide) ->
                     (T_RightHandSide)
sem_RightHandSide ((RightHandSide_Expression (_range) (_expression) (_where))) =
    (sem_RightHandSide_Expression ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_MaybeDeclarations (_where))))
sem_RightHandSide ((RightHandSide_Guarded (_range) (_guardedexpressions) (_where))) =
    (sem_RightHandSide_Guarded ((sem_Range (_range))) ((sem_GuardedExpressions (_guardedexpressions))) ((sem_MaybeDeclarations (_where))))
sem_RightHandSide_Expression :: (T_Range) ->
                                (T_Expression) ->
                                (T_MaybeDeclarations) ->
                                (T_RightHandSide)
sem_RightHandSide_Expression (range_) (expression_) (where_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (RightHandSide)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionIbodyDependencies :: ([(Name,Name)])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOimportedModule :: (Bool)
            _expressionOinferredDependencies :: (FMap Name [(Name,Name)])
            _expressionOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOinstancename :: (Maybe Name)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOsignatures :: (Signatures)
            _expressionOtoplevel :: (Bool)
            _whereIbodyDependencies :: ([(Name,Name)])
            _whereIconstructors_collect :: (FMap Name Names)
            _whereIdependencies_collect :: (FMap Name [(Name,Name)])
            _whereIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _whereIlabels_collect :: (FMap Name Names)
            _whereImethods_collect :: (FMap Name Names)
            _whereIpresignatures_collect :: (PreSignatures)
            _whereIself :: (MaybeDeclarations)
            _whereOclassname :: (Maybe Name)
            _whereOconstructors_collect :: (FMap Name Names)
            _whereOconstructors_dist :: (FMap Name Names)
            _whereOcurrentModule :: (Strings)
            _whereOdependencies_collect :: (FMap Name [(Name,Name)])
            _whereOimportedModule :: (Bool)
            _whereOinferredDependencies :: (FMap Name [(Name,Name)])
            _whereOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _whereOinstancename :: (Maybe Name)
            _whereOlabels_collect :: (FMap Name Names)
            _whereOlabels_dist :: (FMap Name Names)
            _whereOlocal :: (Bool)
            _whereOmethods_collect :: (FMap Name Names)
            _whereOmethods_dist :: (FMap Name Names)
            _whereOpresignatures :: (PreSignatures)
            _whereOpresignatures_collect :: (PreSignatures)
            _whereOsignatures :: (Signatures)
            _whereOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionIbodyDependencies,_expressionIconstructors_collect,_expressionIdependencies_collect,_expressionIinferredDependencies_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionIpresignatures_collect,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies_collect)
                             (_expressionOimportedModule)
                             (_expressionOinferredDependencies)
                             (_expressionOinferredDependencies_collect)
                             (_expressionOinstancename)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOsignatures)
                             (_expressionOtoplevel))
            ( _whereIbodyDependencies,_whereIconstructors_collect,_whereIdependencies_collect,_whereIinferredDependencies_collect,_whereIlabels_collect,_whereImethods_collect,_whereIpresignatures_collect,_whereIself) =
                (where_ (_whereOclassname)
                        (_whereOconstructors_collect)
                        (_whereOconstructors_dist)
                        (_whereOcurrentModule)
                        (_whereOdependencies_collect)
                        (_whereOimportedModule)
                        (_whereOinferredDependencies)
                        (_whereOinferredDependencies_collect)
                        (_whereOinstancename)
                        (_whereOlabels_collect)
                        (_whereOlabels_dist)
                        (_whereOlocal)
                        (_whereOmethods_collect)
                        (_whereOmethods_dist)
                        (_whereOpresignatures)
                        (_whereOpresignatures_collect)
                        (_whereOsignatures)
                        (_whereOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 196, column 8)
            (_instancename@_) =
                Nothing
            -- "./ModuleInformation.inc.lag"(line 195, column 8)
            (_classname@_) =
                Nothing
            -- use rule
            (_lhsObodyDependencies@_) =
                _expressionIbodyDependencies ++ _whereIbodyDependencies
            -- self rule
            (_self@_) =
                RightHandSide_Expression _rangeIself _expressionIself _whereIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _whereIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _whereIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _whereIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _whereIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _whereImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _whereIpresignatures_collect
            -- copy rule (chain)
            (_rangeOclassname@_) =
                _classname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (chain)
            (_rangeOinstancename@_) =
                _instancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_expressionOclassname@_) =
                _classname
            -- copy rule (down)
            (_expressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_expressionOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_expressionOinstancename@_) =
                _instancename
            -- copy rule (down)
            (_expressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_whereOclassname@_) =
                _classname
            -- copy rule (chain)
            (_whereOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (down)
            (_whereOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_whereOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_whereOdependencies_collect@_) =
                _expressionIdependencies_collect
            -- copy rule (down)
            (_whereOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_whereOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_whereOinferredDependencies_collect@_) =
                _expressionIinferredDependencies_collect
            -- copy rule (chain)
            (_whereOinstancename@_) =
                _instancename
            -- copy rule (chain)
            (_whereOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (down)
            (_whereOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_whereOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_whereOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (down)
            (_whereOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_whereOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_whereOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (down)
            (_whereOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_whereOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_RightHandSide_Guarded :: (T_Range) ->
                             (T_GuardedExpressions) ->
                             (T_MaybeDeclarations) ->
                             (T_RightHandSide)
sem_RightHandSide_Guarded (range_) (guardedexpressions_) (where_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (RightHandSide)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _guardedexpressionsIbodyDependencies :: ([(Name,Name)])
            _guardedexpressionsIconstructors_collect :: (FMap Name Names)
            _guardedexpressionsIdependencies_collect :: (FMap Name [(Name,Name)])
            _guardedexpressionsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _guardedexpressionsIlabels_collect :: (FMap Name Names)
            _guardedexpressionsImethods_collect :: (FMap Name Names)
            _guardedexpressionsIpresignatures_collect :: (PreSignatures)
            _guardedexpressionsIself :: (GuardedExpressions)
            _guardedexpressionsOclassname :: (Maybe Name)
            _guardedexpressionsOconstructors_collect :: (FMap Name Names)
            _guardedexpressionsOconstructors_dist :: (FMap Name Names)
            _guardedexpressionsOcurrentModule :: (Strings)
            _guardedexpressionsOdependencies_collect :: (FMap Name [(Name,Name)])
            _guardedexpressionsOimportedModule :: (Bool)
            _guardedexpressionsOinferredDependencies :: (FMap Name [(Name,Name)])
            _guardedexpressionsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _guardedexpressionsOinstancename :: (Maybe Name)
            _guardedexpressionsOlabels_collect :: (FMap Name Names)
            _guardedexpressionsOlabels_dist :: (FMap Name Names)
            _guardedexpressionsOlocal :: (Bool)
            _guardedexpressionsOmethods_collect :: (FMap Name Names)
            _guardedexpressionsOmethods_dist :: (FMap Name Names)
            _guardedexpressionsOpresignatures :: (PreSignatures)
            _guardedexpressionsOpresignatures_collect :: (PreSignatures)
            _guardedexpressionsOsignatures :: (Signatures)
            _guardedexpressionsOtoplevel :: (Bool)
            _whereIbodyDependencies :: ([(Name,Name)])
            _whereIconstructors_collect :: (FMap Name Names)
            _whereIdependencies_collect :: (FMap Name [(Name,Name)])
            _whereIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _whereIlabels_collect :: (FMap Name Names)
            _whereImethods_collect :: (FMap Name Names)
            _whereIpresignatures_collect :: (PreSignatures)
            _whereIself :: (MaybeDeclarations)
            _whereOclassname :: (Maybe Name)
            _whereOconstructors_collect :: (FMap Name Names)
            _whereOconstructors_dist :: (FMap Name Names)
            _whereOcurrentModule :: (Strings)
            _whereOdependencies_collect :: (FMap Name [(Name,Name)])
            _whereOimportedModule :: (Bool)
            _whereOinferredDependencies :: (FMap Name [(Name,Name)])
            _whereOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _whereOinstancename :: (Maybe Name)
            _whereOlabels_collect :: (FMap Name Names)
            _whereOlabels_dist :: (FMap Name Names)
            _whereOlocal :: (Bool)
            _whereOmethods_collect :: (FMap Name Names)
            _whereOmethods_dist :: (FMap Name Names)
            _whereOpresignatures :: (PreSignatures)
            _whereOpresignatures_collect :: (PreSignatures)
            _whereOsignatures :: (Signatures)
            _whereOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _guardedexpressionsIbodyDependencies,_guardedexpressionsIconstructors_collect,_guardedexpressionsIdependencies_collect,_guardedexpressionsIinferredDependencies_collect,_guardedexpressionsIlabels_collect,_guardedexpressionsImethods_collect,_guardedexpressionsIpresignatures_collect,_guardedexpressionsIself) =
                (guardedexpressions_ (_guardedexpressionsOclassname)
                                     (_guardedexpressionsOconstructors_collect)
                                     (_guardedexpressionsOconstructors_dist)
                                     (_guardedexpressionsOcurrentModule)
                                     (_guardedexpressionsOdependencies_collect)
                                     (_guardedexpressionsOimportedModule)
                                     (_guardedexpressionsOinferredDependencies)
                                     (_guardedexpressionsOinferredDependencies_collect)
                                     (_guardedexpressionsOinstancename)
                                     (_guardedexpressionsOlabels_collect)
                                     (_guardedexpressionsOlabels_dist)
                                     (_guardedexpressionsOlocal)
                                     (_guardedexpressionsOmethods_collect)
                                     (_guardedexpressionsOmethods_dist)
                                     (_guardedexpressionsOpresignatures)
                                     (_guardedexpressionsOpresignatures_collect)
                                     (_guardedexpressionsOsignatures)
                                     (_guardedexpressionsOtoplevel))
            ( _whereIbodyDependencies,_whereIconstructors_collect,_whereIdependencies_collect,_whereIinferredDependencies_collect,_whereIlabels_collect,_whereImethods_collect,_whereIpresignatures_collect,_whereIself) =
                (where_ (_whereOclassname)
                        (_whereOconstructors_collect)
                        (_whereOconstructors_dist)
                        (_whereOcurrentModule)
                        (_whereOdependencies_collect)
                        (_whereOimportedModule)
                        (_whereOinferredDependencies)
                        (_whereOinferredDependencies_collect)
                        (_whereOinstancename)
                        (_whereOlabels_collect)
                        (_whereOlabels_dist)
                        (_whereOlocal)
                        (_whereOmethods_collect)
                        (_whereOmethods_dist)
                        (_whereOpresignatures)
                        (_whereOpresignatures_collect)
                        (_whereOsignatures)
                        (_whereOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 199, column 8)
            (_instancename@_) =
                Nothing
            -- "./ModuleInformation.inc.lag"(line 198, column 8)
            (_classname@_) =
                Nothing
            -- use rule
            (_lhsObodyDependencies@_) =
                _guardedexpressionsIbodyDependencies ++ _whereIbodyDependencies
            -- self rule
            (_self@_) =
                RightHandSide_Guarded _rangeIself _guardedexpressionsIself _whereIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _whereIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _whereIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _whereIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _whereIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _whereImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _whereIpresignatures_collect
            -- copy rule (chain)
            (_rangeOclassname@_) =
                _classname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (chain)
            (_rangeOinstancename@_) =
                _instancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_guardedexpressionsOclassname@_) =
                _classname
            -- copy rule (down)
            (_guardedexpressionsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_guardedexpressionsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_guardedexpressionsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_guardedexpressionsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_guardedexpressionsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_guardedexpressionsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_guardedexpressionsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_guardedexpressionsOinstancename@_) =
                _instancename
            -- copy rule (down)
            (_guardedexpressionsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_guardedexpressionsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_guardedexpressionsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_guardedexpressionsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_guardedexpressionsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_guardedexpressionsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_guardedexpressionsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_guardedexpressionsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_guardedexpressionsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (chain)
            (_whereOclassname@_) =
                _classname
            -- copy rule (chain)
            (_whereOconstructors_collect@_) =
                _guardedexpressionsIconstructors_collect
            -- copy rule (down)
            (_whereOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_whereOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_whereOdependencies_collect@_) =
                _guardedexpressionsIdependencies_collect
            -- copy rule (down)
            (_whereOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_whereOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_whereOinferredDependencies_collect@_) =
                _guardedexpressionsIinferredDependencies_collect
            -- copy rule (chain)
            (_whereOinstancename@_) =
                _instancename
            -- copy rule (chain)
            (_whereOlabels_collect@_) =
                _guardedexpressionsIlabels_collect
            -- copy rule (down)
            (_whereOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_whereOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_whereOmethods_collect@_) =
                _guardedexpressionsImethods_collect
            -- copy rule (down)
            (_whereOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_whereOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_whereOpresignatures_collect@_) =
                _guardedexpressionsIpresignatures_collect
            -- copy rule (down)
            (_whereOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_whereOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- Root --------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      dependencies         : FMap Name [(Name,Name)]
      self                 : SELF

-}
{-
   local variables for Root.Root:
      signatures
      self

-}
-- semantic domain
type T_Root = ( (FMap Name [(Name,Name)]),(Root))
-- cata
sem_Root :: (Root) ->
            (T_Root)
sem_Root ((Root_Root (_contents))) =
    (sem_Root_Root ((sem_ModuleSystem (_contents))))
sem_Root_Root :: (T_ModuleSystem) ->
                 (T_Root)
sem_Root_Root (contents_) =
    let _lhsOdependencies :: (FMap Name [(Name,Name)])
        _lhsOself :: (Root)
        _contentsIcompiledModule :: (Strings)
        _contentsIconstructors_collect :: (FMap Name Names)
        _contentsIdependencies_collect :: (FMap Name [(Name,Name)])
        _contentsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
        _contentsIlabels_collect :: (FMap Name Names)
        _contentsImethods_collect :: (FMap Name Names)
        _contentsIpresignatures_collect :: (PreSignatures)
        _contentsIself :: (ModuleSystem)
        _contentsOclassname :: (Maybe Name)
        _contentsOconstructors_collect :: (FMap Name Names)
        _contentsOconstructors_dist :: (FMap Name Names)
        _contentsOdependencies_collect :: (FMap Name [(Name,Name)])
        _contentsOimportedModule :: (Bool)
        _contentsOinferredDependencies :: (FMap Name [(Name,Name)])
        _contentsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
        _contentsOinstancename :: (Maybe Name)
        _contentsOlabels_collect :: (FMap Name Names)
        _contentsOlabels_dist :: (FMap Name Names)
        _contentsOmethods_collect :: (FMap Name Names)
        _contentsOmethods_dist :: (FMap Name Names)
        _contentsOpresignatures :: (PreSignatures)
        _contentsOpresignatures_collect :: (PreSignatures)
        _contentsOsignatures :: (Signatures)
        _contentsOtoplevel :: (Bool)
        ( _contentsIcompiledModule,_contentsIconstructors_collect,_contentsIdependencies_collect,_contentsIinferredDependencies_collect,_contentsIlabels_collect,_contentsImethods_collect,_contentsIpresignatures_collect,_contentsIself) =
            (contents_ (_contentsOclassname)
                       (_contentsOconstructors_collect)
                       (_contentsOconstructors_dist)
                       (_contentsOdependencies_collect)
                       (_contentsOimportedModule)
                       (_contentsOinferredDependencies)
                       (_contentsOinferredDependencies_collect)
                       (_contentsOinstancename)
                       (_contentsOlabels_collect)
                       (_contentsOlabels_dist)
                       (_contentsOmethods_collect)
                       (_contentsOmethods_dist)
                       (_contentsOpresignatures)
                       (_contentsOpresignatures_collect)
                       (_contentsOsignatures)
                       (_contentsOtoplevel))
        -- "ScanDependencies.lag"(line 258, column 9)
        (_lhsOdependencies@_) =
            dependency_iterate
              _contentsIdependencies_collect
        -- "ScanDependencies.lag"(line 254, column 9)
        (_contentsOinferredDependencies@_) =
            _contentsIinferredDependencies_collect
        -- "ScanDependencies.lag"(line 251, column 9)
        (_contentsOinferredDependencies_collect@_) =
            emptyFM
        -- "ScanDependencies.lag"(line 250, column 9)
        (_contentsOdependencies_collect@_) =
            emptyFM
        -- "./Signature.inc.lag"(line 104, column 9)
        (_contentsOsignatures@_) =
            _signatures
        -- "./Signature.inc.lag"(line 101, column 9)
        (_signatures@_) =
            expandSignatures
              _contentsIpresignatures_collect
              _signatures
        -- "./Signature.inc.lag"(line 100, column 9)
        (_contentsOpresignatures@_) =
            _contentsIpresignatures_collect
        -- "./Signature.inc.lag"(line 98, column 9)
        (_contentsOpresignatures_collect@_) =
            emptyFM
        -- "./ModuleInformation.inc.lag"(line 97, column 8)
        (_contentsOinstancename@_) =
            Nothing
        -- "./ModuleInformation.inc.lag"(line 96, column 8)
        (_contentsOclassname@_) =
            Nothing
        -- "./ModuleInformation.inc.lag"(line 95, column 8)
        (_contentsOtoplevel@_) =
            True
        -- "./ModuleInformation.inc.lag"(line 94, column 8)
        (_contentsOimportedModule@_) =
            False
        -- "./ModuleInformation.inc.lag"(line 311, column 9)
        (_contentsOlabels_dist@_) =
            _contentsIlabels_collect
        -- "./ModuleInformation.inc.lag"(line 310, column 9)
        (_contentsOmethods_dist@_) =
            _contentsImethods_collect
        -- "./ModuleInformation.inc.lag"(line 309, column 9)
        (_contentsOconstructors_dist@_) =
            _contentsIconstructors_collect
        -- "./ModuleInformation.inc.lag"(line 307, column 9)
        (_contentsOlabels_collect@_) =
            emptyFM
        -- "./ModuleInformation.inc.lag"(line 306, column 9)
        (_contentsOmethods_collect@_) =
            emptyFM
        -- "./ModuleInformation.inc.lag"(line 305, column 9)
        (_contentsOconstructors_collect@_) =
            emptyFM
        -- self rule
        (_self@_) =
            Root_Root _contentsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOdependencies,_lhsOself)
-- SimpleType --------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      name                 : Name
      self                 : SELF

-}
{-
   local variables for SimpleType.SimpleType:
      self

-}
-- semantic domain
type T_SimpleType = (Maybe Name) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Strings) ->
                    (FMap Name [(Name,Name)]) ->
                    (Bool) ->
                    (FMap Name [(Name,Name)]) ->
                    (FMap Name [(Name,Name)]) ->
                    (Maybe Name) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Bool) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Bool) ->
                    ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(Name),(SimpleType))
-- cata
sem_SimpleType :: (SimpleType) ->
                  (T_SimpleType)
sem_SimpleType ((SimpleType_SimpleType (_range) (_name) (_typevariables))) =
    (sem_SimpleType_SimpleType ((sem_Range (_range))) ((sem_Name (_name))) ((sem_KindAnnotatedNames (_typevariables))))
sem_SimpleType_SimpleType :: (T_Range) ->
                             (T_Name) ->
                             (T_KindAnnotatedNames) ->
                             (T_SimpleType)
sem_SimpleType_SimpleType (range_) (name_) (typevariables_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOself :: (SimpleType)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _typevariablesIakinds :: ([MaybeKind])
            _typevariablesIconstructors_collect :: (FMap Name Names)
            _typevariablesIdependencies_collect :: (FMap Name [(Name,Name)])
            _typevariablesIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typevariablesIlabels_collect :: (FMap Name Names)
            _typevariablesImethods_collect :: (FMap Name Names)
            _typevariablesIself :: (KindAnnotatedNames)
            _typevariablesOclassname :: (Maybe Name)
            _typevariablesOconstructors_collect :: (FMap Name Names)
            _typevariablesOconstructors_dist :: (FMap Name Names)
            _typevariablesOcurrentModule :: (Strings)
            _typevariablesOdependencies_collect :: (FMap Name [(Name,Name)])
            _typevariablesOimportedModule :: (Bool)
            _typevariablesOinferredDependencies :: (FMap Name [(Name,Name)])
            _typevariablesOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typevariablesOinstancename :: (Maybe Name)
            _typevariablesOlabels_collect :: (FMap Name Names)
            _typevariablesOlabels_dist :: (FMap Name Names)
            _typevariablesOlocal :: (Bool)
            _typevariablesOmethods_collect :: (FMap Name Names)
            _typevariablesOmethods_dist :: (FMap Name Names)
            _typevariablesOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _typevariablesIakinds,_typevariablesIconstructors_collect,_typevariablesIdependencies_collect,_typevariablesIinferredDependencies_collect,_typevariablesIlabels_collect,_typevariablesImethods_collect,_typevariablesIself) =
                (typevariables_ (_typevariablesOclassname)
                                (_typevariablesOconstructors_collect)
                                (_typevariablesOconstructors_dist)
                                (_typevariablesOcurrentModule)
                                (_typevariablesOdependencies_collect)
                                (_typevariablesOimportedModule)
                                (_typevariablesOinferredDependencies)
                                (_typevariablesOinferredDependencies_collect)
                                (_typevariablesOinstancename)
                                (_typevariablesOlabels_collect)
                                (_typevariablesOlabels_dist)
                                (_typevariablesOlocal)
                                (_typevariablesOmethods_collect)
                                (_typevariablesOmethods_dist)
                                (_typevariablesOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 156, column 8)
            (_typevariablesOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 393, column 9)
            (_lhsOname@_) =
                _nameIself
            -- self rule
            (_self@_) =
                SimpleType_SimpleType _rangeIself _nameIself _typevariablesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typevariablesIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _typevariablesIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _typevariablesIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typevariablesIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typevariablesImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typevariablesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typevariablesOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_typevariablesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typevariablesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_typevariablesOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_typevariablesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typevariablesOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_typevariablesOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_typevariablesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typevariablesOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_typevariablesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typevariablesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typevariablesOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_typevariablesOmethods_dist@_) =
                _lhsImethods_dist
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOname,_lhsOself)
-- Statement ---------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      bodyDependencies     : [(Name,Name)]
      self                 : SELF

-}
{-
   local variables for Statement.Empty:
      self

-}
{-
   local variables for Statement.Expression:
      self

-}
{-
   local variables for Statement.Generator:
      self

-}
{-
   local variables for Statement.Let:
      self

-}
-- semantic domain
type T_Statement = (Maybe Name) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (Strings) ->
                   (FMap Name [(Name,Name)]) ->
                   (Bool) ->
                   (FMap Name [(Name,Name)]) ->
                   (FMap Name [(Name,Name)]) ->
                   (Maybe Name) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (Bool) ->
                   (FMap Name Names) ->
                   (FMap Name Names) ->
                   (PreSignatures) ->
                   (PreSignatures) ->
                   (Signatures) ->
                   (Bool) ->
                   ( ([(Name,Name)]),(FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(PreSignatures),(Statement))
-- cata
sem_Statement :: (Statement) ->
                 (T_Statement)
sem_Statement ((Statement_Empty (_range))) =
    (sem_Statement_Empty ((sem_Range (_range))))
sem_Statement ((Statement_Expression (_range) (_expression))) =
    (sem_Statement_Expression ((sem_Range (_range))) ((sem_Expression (_expression))))
sem_Statement ((Statement_Generator (_range) (_pattern) (_expression))) =
    (sem_Statement_Generator ((sem_Range (_range))) ((sem_Pattern (_pattern))) ((sem_Expression (_expression))))
sem_Statement ((Statement_Let (_range) (_declarations))) =
    (sem_Statement_Let ((sem_Range (_range))) ((sem_Declarations (_declarations))))
sem_Statement_Empty :: (T_Range) ->
                       (T_Statement)
sem_Statement_Empty (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Statement)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                []
            -- self rule
            (_self@_) =
                Statement_Empty _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Statement_Expression :: (T_Range) ->
                            (T_Expression) ->
                            (T_Statement)
sem_Statement_Expression (range_) (expression_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Statement)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _expressionIbodyDependencies :: ([(Name,Name)])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOimportedModule :: (Bool)
            _expressionOinferredDependencies :: (FMap Name [(Name,Name)])
            _expressionOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOinstancename :: (Maybe Name)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOsignatures :: (Signatures)
            _expressionOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _expressionIbodyDependencies,_expressionIconstructors_collect,_expressionIdependencies_collect,_expressionIinferredDependencies_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionIpresignatures_collect,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies_collect)
                             (_expressionOimportedModule)
                             (_expressionOinferredDependencies)
                             (_expressionOinferredDependencies_collect)
                             (_expressionOinstancename)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOsignatures)
                             (_expressionOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _expressionIbodyDependencies
            -- self rule
            (_self@_) =
                Statement_Expression _rangeIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _expressionIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _expressionIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_expressionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_expressionOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_expressionOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_expressionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_expressionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Statement_Generator :: (T_Range) ->
                           (T_Pattern) ->
                           (T_Expression) ->
                           (T_Statement)
sem_Statement_Generator (range_) (pattern_) (expression_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Statement)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _patternIconstructors_collect :: (FMap Name Names)
            _patternIdependencies_collect :: (FMap Name [(Name,Name)])
            _patternIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _patternIlabels_collect :: (FMap Name Names)
            _patternImethods_collect :: (FMap Name Names)
            _patternIname :: (Name)
            _patternIself :: (Pattern)
            _patternOclassname :: (Maybe Name)
            _patternOconstructors_collect :: (FMap Name Names)
            _patternOconstructors_dist :: (FMap Name Names)
            _patternOcurrentModule :: (Strings)
            _patternOdependencies_collect :: (FMap Name [(Name,Name)])
            _patternOimportedModule :: (Bool)
            _patternOinferredDependencies :: (FMap Name [(Name,Name)])
            _patternOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _patternOinstancename :: (Maybe Name)
            _patternOlabels_collect :: (FMap Name Names)
            _patternOlabels_dist :: (FMap Name Names)
            _patternOlocal :: (Bool)
            _patternOmethods_collect :: (FMap Name Names)
            _patternOmethods_dist :: (FMap Name Names)
            _patternOtoplevel :: (Bool)
            _expressionIbodyDependencies :: ([(Name,Name)])
            _expressionIconstructors_collect :: (FMap Name Names)
            _expressionIdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionIlabels_collect :: (FMap Name Names)
            _expressionImethods_collect :: (FMap Name Names)
            _expressionIpresignatures_collect :: (PreSignatures)
            _expressionIself :: (Expression)
            _expressionOclassname :: (Maybe Name)
            _expressionOconstructors_collect :: (FMap Name Names)
            _expressionOconstructors_dist :: (FMap Name Names)
            _expressionOcurrentModule :: (Strings)
            _expressionOdependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOimportedModule :: (Bool)
            _expressionOinferredDependencies :: (FMap Name [(Name,Name)])
            _expressionOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _expressionOinstancename :: (Maybe Name)
            _expressionOlabels_collect :: (FMap Name Names)
            _expressionOlabels_dist :: (FMap Name Names)
            _expressionOlocal :: (Bool)
            _expressionOmethods_collect :: (FMap Name Names)
            _expressionOmethods_dist :: (FMap Name Names)
            _expressionOpresignatures :: (PreSignatures)
            _expressionOpresignatures_collect :: (PreSignatures)
            _expressionOsignatures :: (Signatures)
            _expressionOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _patternIconstructors_collect,_patternIdependencies_collect,_patternIinferredDependencies_collect,_patternIlabels_collect,_patternImethods_collect,_patternIname,_patternIself) =
                (pattern_ (_patternOclassname) (_patternOconstructors_collect) (_patternOconstructors_dist) (_patternOcurrentModule) (_patternOdependencies_collect) (_patternOimportedModule) (_patternOinferredDependencies) (_patternOinferredDependencies_collect) (_patternOinstancename) (_patternOlabels_collect) (_patternOlabels_dist) (_patternOlocal) (_patternOmethods_collect) (_patternOmethods_dist) (_patternOtoplevel))
            ( _expressionIbodyDependencies,_expressionIconstructors_collect,_expressionIdependencies_collect,_expressionIinferredDependencies_collect,_expressionIlabels_collect,_expressionImethods_collect,_expressionIpresignatures_collect,_expressionIself) =
                (expression_ (_expressionOclassname)
                             (_expressionOconstructors_collect)
                             (_expressionOconstructors_dist)
                             (_expressionOcurrentModule)
                             (_expressionOdependencies_collect)
                             (_expressionOimportedModule)
                             (_expressionOinferredDependencies)
                             (_expressionOinferredDependencies_collect)
                             (_expressionOinstancename)
                             (_expressionOlabels_collect)
                             (_expressionOlabels_dist)
                             (_expressionOlocal)
                             (_expressionOmethods_collect)
                             (_expressionOmethods_dist)
                             (_expressionOpresignatures)
                             (_expressionOpresignatures_collect)
                             (_expressionOsignatures)
                             (_expressionOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _expressionIbodyDependencies
            -- self rule
            (_self@_) =
                Statement_Generator _rangeIself _patternIself _expressionIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _expressionIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _expressionIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _expressionIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _expressionIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _expressionImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _expressionIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_patternOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_patternOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_patternOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_patternOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_patternOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_patternOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_patternOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_patternOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_patternOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_patternOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_patternOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_expressionOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_expressionOconstructors_collect@_) =
                _patternIconstructors_collect
            -- copy rule (down)
            (_expressionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_expressionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_expressionOdependencies_collect@_) =
                _patternIdependencies_collect
            -- copy rule (down)
            (_expressionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_expressionOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_expressionOinferredDependencies_collect@_) =
                _patternIinferredDependencies_collect
            -- copy rule (down)
            (_expressionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_expressionOlabels_collect@_) =
                _patternIlabels_collect
            -- copy rule (down)
            (_expressionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_expressionOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_expressionOmethods_collect@_) =
                _patternImethods_collect
            -- copy rule (down)
            (_expressionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_expressionOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_expressionOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_expressionOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_expressionOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Statement_Let :: (T_Range) ->
                     (T_Declarations) ->
                     (T_Statement)
sem_Statement_Let (range_) (declarations_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Statement)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _declarationsIbodyDependencies :: ([(Name,Name)])
            _declarationsIconstructors_collect :: (FMap Name Names)
            _declarationsIdependencies_collect :: (FMap Name [(Name,Name)])
            _declarationsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _declarationsIlabels_collect :: (FMap Name Names)
            _declarationsImethods_collect :: (FMap Name Names)
            _declarationsIpresignatures_collect :: (PreSignatures)
            _declarationsIself :: (Declarations)
            _declarationsOclassname :: (Maybe Name)
            _declarationsOconstructors_collect :: (FMap Name Names)
            _declarationsOconstructors_dist :: (FMap Name Names)
            _declarationsOcurrentModule :: (Strings)
            _declarationsOdependencies_collect :: (FMap Name [(Name,Name)])
            _declarationsOimportedModule :: (Bool)
            _declarationsOinferredDependencies :: (FMap Name [(Name,Name)])
            _declarationsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _declarationsOinstancename :: (Maybe Name)
            _declarationsOlabels_collect :: (FMap Name Names)
            _declarationsOlabels_dist :: (FMap Name Names)
            _declarationsOlocal :: (Bool)
            _declarationsOmethods_collect :: (FMap Name Names)
            _declarationsOmethods_dist :: (FMap Name Names)
            _declarationsOpresignatures :: (PreSignatures)
            _declarationsOpresignatures_collect :: (PreSignatures)
            _declarationsOsignatures :: (Signatures)
            _declarationsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _declarationsIbodyDependencies,_declarationsIconstructors_collect,_declarationsIdependencies_collect,_declarationsIinferredDependencies_collect,_declarationsIlabels_collect,_declarationsImethods_collect,_declarationsIpresignatures_collect,_declarationsIself) =
                (declarations_ (_declarationsOclassname)
                               (_declarationsOconstructors_collect)
                               (_declarationsOconstructors_dist)
                               (_declarationsOcurrentModule)
                               (_declarationsOdependencies_collect)
                               (_declarationsOimportedModule)
                               (_declarationsOinferredDependencies)
                               (_declarationsOinferredDependencies_collect)
                               (_declarationsOinstancename)
                               (_declarationsOlabels_collect)
                               (_declarationsOlabels_dist)
                               (_declarationsOlocal)
                               (_declarationsOmethods_collect)
                               (_declarationsOmethods_dist)
                               (_declarationsOpresignatures)
                               (_declarationsOpresignatures_collect)
                               (_declarationsOsignatures)
                               (_declarationsOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _declarationsIbodyDependencies
            -- self rule
            (_self@_) =
                Statement_Let _rangeIself _declarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _declarationsIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _declarationsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _declarationsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _declarationsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _declarationsImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _declarationsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_declarationsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_declarationsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_declarationsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_declarationsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_declarationsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_declarationsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_declarationsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_declarationsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_declarationsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_declarationsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_declarationsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_declarationsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_declarationsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_declarationsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_declarationsOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_declarationsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_declarationsOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_declarationsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- Statements --------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      bodyDependencies     : [(Name,Name)]
      self                 : SELF

-}
{-
   local variables for Statements.Cons:
      self

-}
{-
   local variables for Statements.Nil:
      self

-}
-- semantic domain
type T_Statements = (Maybe Name) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Strings) ->
                    (FMap Name [(Name,Name)]) ->
                    (Bool) ->
                    (FMap Name [(Name,Name)]) ->
                    (FMap Name [(Name,Name)]) ->
                    (Maybe Name) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (Bool) ->
                    (FMap Name Names) ->
                    (FMap Name Names) ->
                    (PreSignatures) ->
                    (PreSignatures) ->
                    (Signatures) ->
                    (Bool) ->
                    ( ([(Name,Name)]),(FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(PreSignatures),(Statements))
-- cata
sem_Statements :: (Statements) ->
                  (T_Statements)
sem_Statements (list) =
    (foldr (sem_Statements_Cons) (sem_Statements_Nil) ((map sem_Statement list)))
sem_Statements_Cons :: (T_Statement) ->
                       (T_Statements) ->
                       (T_Statements)
sem_Statements_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Statements)
            _hdIbodyDependencies :: ([(Name,Name)])
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdependencies_collect :: (FMap Name [(Name,Name)])
            _hdIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIpresignatures_collect :: (PreSignatures)
            _hdIself :: (Statement)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies_collect :: (FMap Name [(Name,Name)])
            _hdOimportedModule :: (Bool)
            _hdOinferredDependencies :: (FMap Name [(Name,Name)])
            _hdOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdOinstancename :: (Maybe Name)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOpresignatures :: (PreSignatures)
            _hdOpresignatures_collect :: (PreSignatures)
            _hdOsignatures :: (Signatures)
            _hdOtoplevel :: (Bool)
            _tlIbodyDependencies :: ([(Name,Name)])
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdependencies_collect :: (FMap Name [(Name,Name)])
            _tlIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIpresignatures_collect :: (PreSignatures)
            _tlIself :: (Statements)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies_collect :: (FMap Name [(Name,Name)])
            _tlOimportedModule :: (Bool)
            _tlOinferredDependencies :: (FMap Name [(Name,Name)])
            _tlOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOpresignatures :: (PreSignatures)
            _tlOpresignatures_collect :: (PreSignatures)
            _tlOsignatures :: (Signatures)
            _tlOtoplevel :: (Bool)
            ( _hdIbodyDependencies,_hdIconstructors_collect,_hdIdependencies_collect,_hdIinferredDependencies_collect,_hdIlabels_collect,_hdImethods_collect,_hdIpresignatures_collect,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOdependencies_collect) (_hdOimportedModule) (_hdOinferredDependencies) (_hdOinferredDependencies_collect) (_hdOinstancename) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOpresignatures) (_hdOpresignatures_collect) (_hdOsignatures) (_hdOtoplevel))
            ( _tlIbodyDependencies,_tlIconstructors_collect,_tlIdependencies_collect,_tlIinferredDependencies_collect,_tlIlabels_collect,_tlImethods_collect,_tlIpresignatures_collect,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOdependencies_collect) (_tlOimportedModule) (_tlOinferredDependencies) (_tlOinferredDependencies_collect) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOpresignatures) (_tlOpresignatures_collect) (_tlOsignatures) (_tlOtoplevel))
            -- use rule
            (_lhsObodyDependencies@_) =
                _hdIbodyDependencies ++ _tlIbodyDependencies
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _tlIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _tlIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _tlIpresignatures_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_hdOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_hdOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_hdOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_tlOdependencies_collect@_) =
                _hdIdependencies_collect
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_tlOinferredDependencies_collect@_) =
                _hdIinferredDependencies_collect
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_tlOpresignatures_collect@_) =
                _hdIpresignatures_collect
            -- copy rule (down)
            (_tlOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
sem_Statements_Nil :: (T_Statements)
sem_Statements_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (Statements)
            -- use rule
            (_lhsObodyDependencies@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOpresignatures_collect,_lhsOself)
-- Strings -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Strings.Cons:
      self

-}
{-
   local variables for Strings.Nil:
      self

-}
-- semantic domain
type T_Strings = (Maybe Name) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Strings) ->
                 (FMap Name [(Name,Name)]) ->
                 (Bool) ->
                 (FMap Name [(Name,Name)]) ->
                 (FMap Name [(Name,Name)]) ->
                 (Maybe Name) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Bool) ->
                 (FMap Name Names) ->
                 (FMap Name Names) ->
                 (Bool) ->
                 ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(Strings))
-- cata
sem_Strings :: (Strings) ->
               (T_Strings)
sem_Strings (list) =
    (foldr (sem_Strings_Cons) (sem_Strings_Nil) (list))
sem_Strings_Cons :: (String) ->
                    (T_Strings) ->
                    (T_Strings)
sem_Strings_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Strings)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdependencies_collect :: (FMap Name [(Name,Name)])
            _tlIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIself :: (Strings)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies_collect :: (FMap Name [(Name,Name)])
            _tlOimportedModule :: (Bool)
            _tlOinferredDependencies :: (FMap Name [(Name,Name)])
            _tlOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOtoplevel :: (Bool)
            ( _tlIconstructors_collect,_tlIdependencies_collect,_tlIinferredDependencies_collect,_tlIlabels_collect,_tlImethods_collect,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOdependencies_collect) (_tlOimportedModule) (_tlOinferredDependencies) (_tlOinferredDependencies_collect) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOtoplevel))
            -- self rule
            (_self@_) =
                (:) hd_ _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _tlIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _tlIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_tlOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_tlOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_tlOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_tlOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_tlOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Strings_Nil :: (T_Strings)
sem_Strings_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Strings)
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- Type --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      localDependencies    : [(Name,Name)]
      self                 : SELF

-}
{-
   local variables for Type.Application:
      self

-}
{-
   local variables for Type.Con:
      self

-}
{-
   local variables for Type.Constructor:
      self

-}
{-
   local variables for Type.ConstructorCase:
      self

-}
{-
   local variables for Type.Exists:
      self

-}
{-
   local variables for Type.Forall:
      self

-}
{-
   local variables for Type.KindApplication:
      self

-}
{-
   local variables for Type.KindStarCase:
      self

-}
{-
   local variables for Type.Kinded:
      self

-}
{-
   local variables for Type.Label:
      self

-}
{-
   local variables for Type.Parenthesized:
      self

-}
{-
   local variables for Type.Qualified:
      self

-}
{-
   local variables for Type.TypeApplication:
      self

-}
{-
   local variables for Type.TypeSignature:
      self

-}
{-
   local variables for Type.Variable:
      self

-}
-- semantic domain
type T_Type = (Maybe Name) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (Strings) ->
              (FMap Name [(Name,Name)]) ->
              (Bool) ->
              (FMap Name [(Name,Name)]) ->
              (FMap Name [(Name,Name)]) ->
              (Maybe Name) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (Bool) ->
              (FMap Name Names) ->
              (FMap Name Names) ->
              (Bool) ->
              ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),([(Name,Name)]),(FMap Name Names),(Type))
-- cata
sem_Type :: (Type) ->
            (T_Type)
sem_Type ((Type_Application (_range) (_prefix) (_function) (_arguments))) =
    (sem_Type_Application ((sem_Range (_range))) (_prefix) ((sem_Type (_function))) ((sem_Types (_arguments))))
sem_Type ((Type_Con (_range) (_name))) =
    (sem_Type_Con ((sem_Range (_range))) ((sem_Name (_name))))
sem_Type ((Type_Constructor (_range) (_name))) =
    (sem_Type_Constructor ((sem_Range (_range))) ((sem_Name (_name))))
sem_Type ((Type_ConstructorCase (_range) (_name))) =
    (sem_Type_ConstructorCase ((sem_Range (_range))) ((sem_Name (_name))))
sem_Type ((Type_Exists (_range) (_typevariables) (_type))) =
    (sem_Type_Exists ((sem_Range (_range))) ((sem_Names (_typevariables))) ((sem_Type (_type))))
sem_Type ((Type_Forall (_range) (_typevariables) (_type))) =
    (sem_Type_Forall ((sem_Range (_range))) ((sem_Names (_typevariables))) ((sem_Type (_type))))
sem_Type ((Type_KindApplication (_range) (_name) (_kind))) =
    (sem_Type_KindApplication ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Kind (_kind))))
sem_Type ((Type_KindStarCase (_range))) =
    (sem_Type_KindStarCase ((sem_Range (_range))))
sem_Type ((Type_Kinded (_range) (_name) (_kind))) =
    (sem_Type_Kinded ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Kind (_kind))))
sem_Type ((Type_Label (_range) (_name))) =
    (sem_Type_Label ((sem_Range (_range))) ((sem_Name (_name))))
sem_Type ((Type_Parenthesized (_range) (_type))) =
    (sem_Type_Parenthesized ((sem_Range (_range))) ((sem_Type (_type))))
sem_Type ((Type_Qualified (_range) (_context) (_type))) =
    (sem_Type_Qualified ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_Type (_type))))
sem_Type ((Type_TypeApplication (_range) (_name) (_type))) =
    (sem_Type_TypeApplication ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Type (_type))))
sem_Type ((Type_TypeSignature (_range) (_generics) (_parametrics))) =
    (sem_Type_TypeSignature ((sem_Range (_range))) ((sem_KindAnnotatedNames (_generics))) ((sem_Types (_parametrics))))
sem_Type ((Type_Variable (_range) (_name))) =
    (sem_Type_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Type_Application :: (T_Range) ->
                        (Bool) ->
                        (T_Type) ->
                        (T_Types) ->
                        (T_Type)
sem_Type_Application (range_) (prefix_) (function_) (arguments_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOlocalDependencies :: ([(Name,Name)])
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _functionIconstructors_collect :: (FMap Name Names)
            _functionIdependencies_collect :: (FMap Name [(Name,Name)])
            _functionIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _functionIlabels_collect :: (FMap Name Names)
            _functionIlocalDependencies :: ([(Name,Name)])
            _functionImethods_collect :: (FMap Name Names)
            _functionIself :: (Type)
            _functionOclassname :: (Maybe Name)
            _functionOconstructors_collect :: (FMap Name Names)
            _functionOconstructors_dist :: (FMap Name Names)
            _functionOcurrentModule :: (Strings)
            _functionOdependencies_collect :: (FMap Name [(Name,Name)])
            _functionOimportedModule :: (Bool)
            _functionOinferredDependencies :: (FMap Name [(Name,Name)])
            _functionOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _functionOinstancename :: (Maybe Name)
            _functionOlabels_collect :: (FMap Name Names)
            _functionOlabels_dist :: (FMap Name Names)
            _functionOlocal :: (Bool)
            _functionOmethods_collect :: (FMap Name Names)
            _functionOmethods_dist :: (FMap Name Names)
            _functionOtoplevel :: (Bool)
            _argumentsIconstructors_collect :: (FMap Name Names)
            _argumentsIdependencies_collect :: (FMap Name [(Name,Name)])
            _argumentsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _argumentsIlabels_collect :: (FMap Name Names)
            _argumentsImethods_collect :: (FMap Name Names)
            _argumentsIself :: (Types)
            _argumentsOclassname :: (Maybe Name)
            _argumentsOconstructors_collect :: (FMap Name Names)
            _argumentsOconstructors_dist :: (FMap Name Names)
            _argumentsOcurrentModule :: (Strings)
            _argumentsOdependencies_collect :: (FMap Name [(Name,Name)])
            _argumentsOimportedModule :: (Bool)
            _argumentsOinferredDependencies :: (FMap Name [(Name,Name)])
            _argumentsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _argumentsOinstancename :: (Maybe Name)
            _argumentsOlabels_collect :: (FMap Name Names)
            _argumentsOlabels_dist :: (FMap Name Names)
            _argumentsOlocal :: (Bool)
            _argumentsOmethods_collect :: (FMap Name Names)
            _argumentsOmethods_dist :: (FMap Name Names)
            _argumentsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _functionIconstructors_collect,_functionIdependencies_collect,_functionIinferredDependencies_collect,_functionIlabels_collect,_functionIlocalDependencies,_functionImethods_collect,_functionIself) =
                (function_ (_functionOclassname) (_functionOconstructors_collect) (_functionOconstructors_dist) (_functionOcurrentModule) (_functionOdependencies_collect) (_functionOimportedModule) (_functionOinferredDependencies) (_functionOinferredDependencies_collect) (_functionOinstancename) (_functionOlabels_collect) (_functionOlabels_dist) (_functionOlocal) (_functionOmethods_collect) (_functionOmethods_dist) (_functionOtoplevel))
            ( _argumentsIconstructors_collect,_argumentsIdependencies_collect,_argumentsIinferredDependencies_collect,_argumentsIlabels_collect,_argumentsImethods_collect,_argumentsIself) =
                (arguments_ (_argumentsOclassname)
                            (_argumentsOconstructors_collect)
                            (_argumentsOconstructors_dist)
                            (_argumentsOcurrentModule)
                            (_argumentsOdependencies_collect)
                            (_argumentsOimportedModule)
                            (_argumentsOinferredDependencies)
                            (_argumentsOinferredDependencies_collect)
                            (_argumentsOinstancename)
                            (_argumentsOlabels_collect)
                            (_argumentsOlabels_dist)
                            (_argumentsOlocal)
                            (_argumentsOmethods_collect)
                            (_argumentsOmethods_dist)
                            (_argumentsOtoplevel))
            -- use rule
            (_lhsOlocalDependencies@_) =
                _functionIlocalDependencies
            -- self rule
            (_self@_) =
                Type_Application _rangeIself prefix_ _functionIself _argumentsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _argumentsIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _argumentsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _argumentsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _argumentsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _argumentsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_functionOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_functionOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_functionOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_functionOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_functionOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_functionOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_functionOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_functionOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_functionOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_functionOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_functionOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_functionOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_functionOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_functionOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_functionOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_argumentsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_argumentsOconstructors_collect@_) =
                _functionIconstructors_collect
            -- copy rule (down)
            (_argumentsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_argumentsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_argumentsOdependencies_collect@_) =
                _functionIdependencies_collect
            -- copy rule (down)
            (_argumentsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_argumentsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_argumentsOinferredDependencies_collect@_) =
                _functionIinferredDependencies_collect
            -- copy rule (down)
            (_argumentsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_argumentsOlabels_collect@_) =
                _functionIlabels_collect
            -- copy rule (down)
            (_argumentsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_argumentsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_argumentsOmethods_collect@_) =
                _functionImethods_collect
            -- copy rule (down)
            (_argumentsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_argumentsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOlocalDependencies,_lhsOmethods_collect,_lhsOself)
sem_Type_Con :: (T_Range) ->
                (T_Name) ->
                (T_Type)
sem_Type_Con (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOlocalDependencies :: ([(Name,Name)])
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            -- use rule
            (_lhsOlocalDependencies@_) =
                []
            -- self rule
            (_self@_) =
                Type_Con _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOlocalDependencies,_lhsOmethods_collect,_lhsOself)
sem_Type_Constructor :: (T_Range) ->
                        (T_Name) ->
                        (T_Type)
sem_Type_Constructor (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOlocalDependencies :: ([(Name,Name)])
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            -- use rule
            (_lhsOlocalDependencies@_) =
                []
            -- self rule
            (_self@_) =
                Type_Constructor _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOlocalDependencies,_lhsOmethods_collect,_lhsOself)
sem_Type_ConstructorCase :: (T_Range) ->
                            (T_Name) ->
                            (T_Type)
sem_Type_ConstructorCase (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOlocalDependencies :: ([(Name,Name)])
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            -- use rule
            (_lhsOlocalDependencies@_) =
                []
            -- self rule
            (_self@_) =
                Type_ConstructorCase _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOlocalDependencies,_lhsOmethods_collect,_lhsOself)
sem_Type_Exists :: (T_Range) ->
                   (T_Names) ->
                   (T_Type) ->
                   (T_Type)
sem_Type_Exists (range_) (typevariables_) (type_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOlocalDependencies :: ([(Name,Name)])
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _typevariablesIconstructors_collect :: (FMap Name Names)
            _typevariablesIdependencies_collect :: (FMap Name [(Name,Name)])
            _typevariablesIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typevariablesIlabels_collect :: (FMap Name Names)
            _typevariablesImethods_collect :: (FMap Name Names)
            _typevariablesIself :: (Names)
            _typevariablesOclassname :: (Maybe Name)
            _typevariablesOconstructors_collect :: (FMap Name Names)
            _typevariablesOconstructors_dist :: (FMap Name Names)
            _typevariablesOcurrentModule :: (Strings)
            _typevariablesOdependencies_collect :: (FMap Name [(Name,Name)])
            _typevariablesOimportedModule :: (Bool)
            _typevariablesOinferredDependencies :: (FMap Name [(Name,Name)])
            _typevariablesOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typevariablesOinstancename :: (Maybe Name)
            _typevariablesOlabels_collect :: (FMap Name Names)
            _typevariablesOlabels_dist :: (FMap Name Names)
            _typevariablesOlocal :: (Bool)
            _typevariablesOmethods_collect :: (FMap Name Names)
            _typevariablesOmethods_dist :: (FMap Name Names)
            _typevariablesOtoplevel :: (Bool)
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIdependencies_collect :: (FMap Name [(Name,Name)])
            _typeIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typeIlabels_collect :: (FMap Name Names)
            _typeIlocalDependencies :: ([(Name,Name)])
            _typeImethods_collect :: (FMap Name Names)
            _typeIself :: (Type)
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOdependencies_collect :: (FMap Name [(Name,Name)])
            _typeOimportedModule :: (Bool)
            _typeOinferredDependencies :: (FMap Name [(Name,Name)])
            _typeOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typeOinstancename :: (Maybe Name)
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _typevariablesIconstructors_collect,_typevariablesIdependencies_collect,_typevariablesIinferredDependencies_collect,_typevariablesIlabels_collect,_typevariablesImethods_collect,_typevariablesIself) =
                (typevariables_ (_typevariablesOclassname)
                                (_typevariablesOconstructors_collect)
                                (_typevariablesOconstructors_dist)
                                (_typevariablesOcurrentModule)
                                (_typevariablesOdependencies_collect)
                                (_typevariablesOimportedModule)
                                (_typevariablesOinferredDependencies)
                                (_typevariablesOinferredDependencies_collect)
                                (_typevariablesOinstancename)
                                (_typevariablesOlabels_collect)
                                (_typevariablesOlabels_dist)
                                (_typevariablesOlocal)
                                (_typevariablesOmethods_collect)
                                (_typevariablesOmethods_dist)
                                (_typevariablesOtoplevel))
            ( _typeIconstructors_collect,_typeIdependencies_collect,_typeIinferredDependencies_collect,_typeIlabels_collect,_typeIlocalDependencies,_typeImethods_collect,_typeIself) =
                (type_ (_typeOclassname) (_typeOconstructors_collect) (_typeOconstructors_dist) (_typeOcurrentModule) (_typeOdependencies_collect) (_typeOimportedModule) (_typeOinferredDependencies) (_typeOinferredDependencies_collect) (_typeOinstancename) (_typeOlabels_collect) (_typeOlabels_dist) (_typeOlocal) (_typeOmethods_collect) (_typeOmethods_dist) (_typeOtoplevel))
            -- use rule
            (_lhsOlocalDependencies@_) =
                _typeIlocalDependencies
            -- self rule
            (_self@_) =
                Type_Exists _rangeIself _typevariablesIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _typeIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _typeIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typevariablesOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_typevariablesOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_typevariablesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typevariablesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typevariablesOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_typevariablesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typevariablesOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_typevariablesOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_typevariablesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typevariablesOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_typevariablesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typevariablesOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_typevariablesOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_typevariablesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typevariablesOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _typevariablesIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_typeOdependencies_collect@_) =
                _typevariablesIdependencies_collect
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_typeOinferredDependencies_collect@_) =
                _typevariablesIinferredDependencies_collect
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _typevariablesIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _typevariablesImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOlocalDependencies,_lhsOmethods_collect,_lhsOself)
sem_Type_Forall :: (T_Range) ->
                   (T_Names) ->
                   (T_Type) ->
                   (T_Type)
sem_Type_Forall (range_) (typevariables_) (type_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOlocalDependencies :: ([(Name,Name)])
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _typevariablesIconstructors_collect :: (FMap Name Names)
            _typevariablesIdependencies_collect :: (FMap Name [(Name,Name)])
            _typevariablesIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typevariablesIlabels_collect :: (FMap Name Names)
            _typevariablesImethods_collect :: (FMap Name Names)
            _typevariablesIself :: (Names)
            _typevariablesOclassname :: (Maybe Name)
            _typevariablesOconstructors_collect :: (FMap Name Names)
            _typevariablesOconstructors_dist :: (FMap Name Names)
            _typevariablesOcurrentModule :: (Strings)
            _typevariablesOdependencies_collect :: (FMap Name [(Name,Name)])
            _typevariablesOimportedModule :: (Bool)
            _typevariablesOinferredDependencies :: (FMap Name [(Name,Name)])
            _typevariablesOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typevariablesOinstancename :: (Maybe Name)
            _typevariablesOlabels_collect :: (FMap Name Names)
            _typevariablesOlabels_dist :: (FMap Name Names)
            _typevariablesOlocal :: (Bool)
            _typevariablesOmethods_collect :: (FMap Name Names)
            _typevariablesOmethods_dist :: (FMap Name Names)
            _typevariablesOtoplevel :: (Bool)
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIdependencies_collect :: (FMap Name [(Name,Name)])
            _typeIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typeIlabels_collect :: (FMap Name Names)
            _typeIlocalDependencies :: ([(Name,Name)])
            _typeImethods_collect :: (FMap Name Names)
            _typeIself :: (Type)
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOdependencies_collect :: (FMap Name [(Name,Name)])
            _typeOimportedModule :: (Bool)
            _typeOinferredDependencies :: (FMap Name [(Name,Name)])
            _typeOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typeOinstancename :: (Maybe Name)
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _typevariablesIconstructors_collect,_typevariablesIdependencies_collect,_typevariablesIinferredDependencies_collect,_typevariablesIlabels_collect,_typevariablesImethods_collect,_typevariablesIself) =
                (typevariables_ (_typevariablesOclassname)
                                (_typevariablesOconstructors_collect)
                                (_typevariablesOconstructors_dist)
                                (_typevariablesOcurrentModule)
                                (_typevariablesOdependencies_collect)
                                (_typevariablesOimportedModule)
                                (_typevariablesOinferredDependencies)
                                (_typevariablesOinferredDependencies_collect)
                                (_typevariablesOinstancename)
                                (_typevariablesOlabels_collect)
                                (_typevariablesOlabels_dist)
                                (_typevariablesOlocal)
                                (_typevariablesOmethods_collect)
                                (_typevariablesOmethods_dist)
                                (_typevariablesOtoplevel))
            ( _typeIconstructors_collect,_typeIdependencies_collect,_typeIinferredDependencies_collect,_typeIlabels_collect,_typeIlocalDependencies,_typeImethods_collect,_typeIself) =
                (type_ (_typeOclassname) (_typeOconstructors_collect) (_typeOconstructors_dist) (_typeOcurrentModule) (_typeOdependencies_collect) (_typeOimportedModule) (_typeOinferredDependencies) (_typeOinferredDependencies_collect) (_typeOinstancename) (_typeOlabels_collect) (_typeOlabels_dist) (_typeOlocal) (_typeOmethods_collect) (_typeOmethods_dist) (_typeOtoplevel))
            -- use rule
            (_lhsOlocalDependencies@_) =
                _typeIlocalDependencies
            -- self rule
            (_self@_) =
                Type_Forall _rangeIself _typevariablesIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _typeIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _typeIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typevariablesOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_typevariablesOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_typevariablesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typevariablesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typevariablesOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_typevariablesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typevariablesOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_typevariablesOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_typevariablesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typevariablesOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_typevariablesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typevariablesOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_typevariablesOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_typevariablesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typevariablesOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _typevariablesIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_typeOdependencies_collect@_) =
                _typevariablesIdependencies_collect
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_typeOinferredDependencies_collect@_) =
                _typevariablesIinferredDependencies_collect
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _typevariablesIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _typevariablesImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOlocalDependencies,_lhsOmethods_collect,_lhsOself)
sem_Type_KindApplication :: (T_Range) ->
                            (T_Name) ->
                            (T_Kind) ->
                            (T_Type)
sem_Type_KindApplication (range_) (name_) (kind_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOlocalDependencies :: ([(Name,Name)])
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _kindIconstructors_collect :: (FMap Name Names)
            _kindIdependencies_collect :: (FMap Name [(Name,Name)])
            _kindIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _kindIlabels_collect :: (FMap Name Names)
            _kindImethods_collect :: (FMap Name Names)
            _kindIself :: (Kind)
            _kindOclassname :: (Maybe Name)
            _kindOconstructors_collect :: (FMap Name Names)
            _kindOconstructors_dist :: (FMap Name Names)
            _kindOcurrentModule :: (Strings)
            _kindOdependencies_collect :: (FMap Name [(Name,Name)])
            _kindOimportedModule :: (Bool)
            _kindOinferredDependencies :: (FMap Name [(Name,Name)])
            _kindOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _kindOinstancename :: (Maybe Name)
            _kindOlabels_collect :: (FMap Name Names)
            _kindOlabels_dist :: (FMap Name Names)
            _kindOlocal :: (Bool)
            _kindOmethods_collect :: (FMap Name Names)
            _kindOmethods_dist :: (FMap Name Names)
            _kindOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _kindIconstructors_collect,_kindIdependencies_collect,_kindIinferredDependencies_collect,_kindIlabels_collect,_kindImethods_collect,_kindIself) =
                (kind_ (_kindOclassname) (_kindOconstructors_collect) (_kindOconstructors_dist) (_kindOcurrentModule) (_kindOdependencies_collect) (_kindOimportedModule) (_kindOinferredDependencies) (_kindOinferredDependencies_collect) (_kindOinstancename) (_kindOlabels_collect) (_kindOlabels_dist) (_kindOlocal) (_kindOmethods_collect) (_kindOmethods_dist) (_kindOtoplevel))
            -- use rule
            (_lhsOlocalDependencies@_) =
                []
            -- self rule
            (_self@_) =
                Type_KindApplication _rangeIself _nameIself _kindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _kindIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _kindIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _kindIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _kindIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _kindImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_kindOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_kindOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_kindOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_kindOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_kindOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_kindOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_kindOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_kindOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_kindOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_kindOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_kindOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_kindOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_kindOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_kindOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_kindOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOlocalDependencies,_lhsOmethods_collect,_lhsOself)
sem_Type_KindStarCase :: (T_Range) ->
                         (T_Type)
sem_Type_KindStarCase (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOlocalDependencies :: ([(Name,Name)])
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- use rule
            (_lhsOlocalDependencies@_) =
                []
            -- self rule
            (_self@_) =
                Type_KindStarCase _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOlocalDependencies,_lhsOmethods_collect,_lhsOself)
sem_Type_Kinded :: (T_Range) ->
                   (T_Name) ->
                   (T_Kind) ->
                   (T_Type)
sem_Type_Kinded (range_) (name_) (kind_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOlocalDependencies :: ([(Name,Name)])
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _kindIconstructors_collect :: (FMap Name Names)
            _kindIdependencies_collect :: (FMap Name [(Name,Name)])
            _kindIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _kindIlabels_collect :: (FMap Name Names)
            _kindImethods_collect :: (FMap Name Names)
            _kindIself :: (Kind)
            _kindOclassname :: (Maybe Name)
            _kindOconstructors_collect :: (FMap Name Names)
            _kindOconstructors_dist :: (FMap Name Names)
            _kindOcurrentModule :: (Strings)
            _kindOdependencies_collect :: (FMap Name [(Name,Name)])
            _kindOimportedModule :: (Bool)
            _kindOinferredDependencies :: (FMap Name [(Name,Name)])
            _kindOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _kindOinstancename :: (Maybe Name)
            _kindOlabels_collect :: (FMap Name Names)
            _kindOlabels_dist :: (FMap Name Names)
            _kindOlocal :: (Bool)
            _kindOmethods_collect :: (FMap Name Names)
            _kindOmethods_dist :: (FMap Name Names)
            _kindOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _kindIconstructors_collect,_kindIdependencies_collect,_kindIinferredDependencies_collect,_kindIlabels_collect,_kindImethods_collect,_kindIself) =
                (kind_ (_kindOclassname) (_kindOconstructors_collect) (_kindOconstructors_dist) (_kindOcurrentModule) (_kindOdependencies_collect) (_kindOimportedModule) (_kindOinferredDependencies) (_kindOinferredDependencies_collect) (_kindOinstancename) (_kindOlabels_collect) (_kindOlabels_dist) (_kindOlocal) (_kindOmethods_collect) (_kindOmethods_dist) (_kindOtoplevel))
            -- use rule
            (_lhsOlocalDependencies@_) =
                []
            -- self rule
            (_self@_) =
                Type_Kinded _rangeIself _nameIself _kindIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _kindIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _kindIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _kindIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _kindIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _kindImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_kindOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_kindOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_kindOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_kindOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_kindOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_kindOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_kindOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_kindOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_kindOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_kindOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_kindOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_kindOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_kindOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_kindOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_kindOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOlocalDependencies,_lhsOmethods_collect,_lhsOself)
sem_Type_Label :: (T_Range) ->
                  (T_Name) ->
                  (T_Type)
sem_Type_Label (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOlocalDependencies :: ([(Name,Name)])
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            -- use rule
            (_lhsOlocalDependencies@_) =
                []
            -- self rule
            (_self@_) =
                Type_Label _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOlocalDependencies,_lhsOmethods_collect,_lhsOself)
sem_Type_Parenthesized :: (T_Range) ->
                          (T_Type) ->
                          (T_Type)
sem_Type_Parenthesized (range_) (type_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOlocalDependencies :: ([(Name,Name)])
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIdependencies_collect :: (FMap Name [(Name,Name)])
            _typeIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typeIlabels_collect :: (FMap Name Names)
            _typeIlocalDependencies :: ([(Name,Name)])
            _typeImethods_collect :: (FMap Name Names)
            _typeIself :: (Type)
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOdependencies_collect :: (FMap Name [(Name,Name)])
            _typeOimportedModule :: (Bool)
            _typeOinferredDependencies :: (FMap Name [(Name,Name)])
            _typeOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typeOinstancename :: (Maybe Name)
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _typeIconstructors_collect,_typeIdependencies_collect,_typeIinferredDependencies_collect,_typeIlabels_collect,_typeIlocalDependencies,_typeImethods_collect,_typeIself) =
                (type_ (_typeOclassname) (_typeOconstructors_collect) (_typeOconstructors_dist) (_typeOcurrentModule) (_typeOdependencies_collect) (_typeOimportedModule) (_typeOinferredDependencies) (_typeOinferredDependencies_collect) (_typeOinstancename) (_typeOlabels_collect) (_typeOlabels_dist) (_typeOlocal) (_typeOmethods_collect) (_typeOmethods_dist) (_typeOtoplevel))
            -- use rule
            (_lhsOlocalDependencies@_) =
                _typeIlocalDependencies
            -- self rule
            (_self@_) =
                Type_Parenthesized _rangeIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _typeIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _typeIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_typeOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_typeOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_typeOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_typeOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_typeOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOlocalDependencies,_lhsOmethods_collect,_lhsOself)
sem_Type_Qualified :: (T_Range) ->
                      (T_ContextItems) ->
                      (T_Type) ->
                      (T_Type)
sem_Type_Qualified (range_) (context_) (type_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOlocalDependencies :: ([(Name,Name)])
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _contextIconstructors_collect :: (FMap Name Names)
            _contextIdependencies_collect :: (FMap Name [(Name,Name)])
            _contextIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _contextIlabels_collect :: (FMap Name Names)
            _contextIlocalDependencies :: ([(Name,Name)])
            _contextImethods_collect :: (FMap Name Names)
            _contextIself :: (ContextItems)
            _contextOclassname :: (Maybe Name)
            _contextOconstructors_collect :: (FMap Name Names)
            _contextOconstructors_dist :: (FMap Name Names)
            _contextOcurrentModule :: (Strings)
            _contextOdependencies_collect :: (FMap Name [(Name,Name)])
            _contextOimportedModule :: (Bool)
            _contextOinferredDependencies :: (FMap Name [(Name,Name)])
            _contextOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _contextOinstancename :: (Maybe Name)
            _contextOlabels_collect :: (FMap Name Names)
            _contextOlabels_dist :: (FMap Name Names)
            _contextOlocal :: (Bool)
            _contextOmethods_collect :: (FMap Name Names)
            _contextOmethods_dist :: (FMap Name Names)
            _contextOtoplevel :: (Bool)
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIdependencies_collect :: (FMap Name [(Name,Name)])
            _typeIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typeIlabels_collect :: (FMap Name Names)
            _typeIlocalDependencies :: ([(Name,Name)])
            _typeImethods_collect :: (FMap Name Names)
            _typeIself :: (Type)
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOdependencies_collect :: (FMap Name [(Name,Name)])
            _typeOimportedModule :: (Bool)
            _typeOinferredDependencies :: (FMap Name [(Name,Name)])
            _typeOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typeOinstancename :: (Maybe Name)
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _contextIconstructors_collect,_contextIdependencies_collect,_contextIinferredDependencies_collect,_contextIlabels_collect,_contextIlocalDependencies,_contextImethods_collect,_contextIself) =
                (context_ (_contextOclassname) (_contextOconstructors_collect) (_contextOconstructors_dist) (_contextOcurrentModule) (_contextOdependencies_collect) (_contextOimportedModule) (_contextOinferredDependencies) (_contextOinferredDependencies_collect) (_contextOinstancename) (_contextOlabels_collect) (_contextOlabels_dist) (_contextOlocal) (_contextOmethods_collect) (_contextOmethods_dist) (_contextOtoplevel))
            ( _typeIconstructors_collect,_typeIdependencies_collect,_typeIinferredDependencies_collect,_typeIlabels_collect,_typeIlocalDependencies,_typeImethods_collect,_typeIself) =
                (type_ (_typeOclassname) (_typeOconstructors_collect) (_typeOconstructors_dist) (_typeOcurrentModule) (_typeOdependencies_collect) (_typeOimportedModule) (_typeOinferredDependencies) (_typeOinferredDependencies_collect) (_typeOinstancename) (_typeOlabels_collect) (_typeOlabels_dist) (_typeOlocal) (_typeOmethods_collect) (_typeOmethods_dist) (_typeOtoplevel))
            -- use rule
            (_lhsOlocalDependencies@_) =
                _contextIlocalDependencies ++ _typeIlocalDependencies
            -- self rule
            (_self@_) =
                Type_Qualified _rangeIself _contextIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _typeIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _typeIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_contextOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_contextOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_contextOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_contextOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_contextOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_contextOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_contextOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_contextOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_contextOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_contextOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_contextOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_contextOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_contextOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_contextOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_contextOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _contextIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_typeOdependencies_collect@_) =
                _contextIdependencies_collect
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_typeOinferredDependencies_collect@_) =
                _contextIinferredDependencies_collect
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _contextIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _contextImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOlocalDependencies,_lhsOmethods_collect,_lhsOself)
sem_Type_TypeApplication :: (T_Range) ->
                            (T_Name) ->
                            (T_Type) ->
                            (T_Type)
sem_Type_TypeApplication (range_) (name_) (type_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOlocalDependencies :: ([(Name,Name)])
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _typeIconstructors_collect :: (FMap Name Names)
            _typeIdependencies_collect :: (FMap Name [(Name,Name)])
            _typeIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typeIlabels_collect :: (FMap Name Names)
            _typeIlocalDependencies :: ([(Name,Name)])
            _typeImethods_collect :: (FMap Name Names)
            _typeIself :: (Type)
            _typeOclassname :: (Maybe Name)
            _typeOconstructors_collect :: (FMap Name Names)
            _typeOconstructors_dist :: (FMap Name Names)
            _typeOcurrentModule :: (Strings)
            _typeOdependencies_collect :: (FMap Name [(Name,Name)])
            _typeOimportedModule :: (Bool)
            _typeOinferredDependencies :: (FMap Name [(Name,Name)])
            _typeOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typeOinstancename :: (Maybe Name)
            _typeOlabels_collect :: (FMap Name Names)
            _typeOlabels_dist :: (FMap Name Names)
            _typeOlocal :: (Bool)
            _typeOmethods_collect :: (FMap Name Names)
            _typeOmethods_dist :: (FMap Name Names)
            _typeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _typeIconstructors_collect,_typeIdependencies_collect,_typeIinferredDependencies_collect,_typeIlabels_collect,_typeIlocalDependencies,_typeImethods_collect,_typeIself) =
                (type_ (_typeOclassname) (_typeOconstructors_collect) (_typeOconstructors_dist) (_typeOcurrentModule) (_typeOdependencies_collect) (_typeOimportedModule) (_typeOinferredDependencies) (_typeOinferredDependencies_collect) (_typeOinstancename) (_typeOlabels_collect) (_typeOlabels_dist) (_typeOlocal) (_typeOmethods_collect) (_typeOmethods_dist) (_typeOtoplevel))
            -- use rule
            (_lhsOlocalDependencies@_) =
                _typeIlocalDependencies
            -- self rule
            (_self@_) =
                Type_TypeApplication _rangeIself _nameIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _typeIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _typeIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _typeIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _typeIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _typeImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_typeOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_typeOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_typeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_typeOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_typeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typeOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_typeOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_typeOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_typeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOlocalDependencies,_lhsOmethods_collect,_lhsOself)
sem_Type_TypeSignature :: (T_Range) ->
                          (T_KindAnnotatedNames) ->
                          (T_Types) ->
                          (T_Type)
sem_Type_TypeSignature (range_) (generics_) (parametrics_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOlocalDependencies :: ([(Name,Name)])
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _genericsIakinds :: ([MaybeKind])
            _genericsIconstructors_collect :: (FMap Name Names)
            _genericsIdependencies_collect :: (FMap Name [(Name,Name)])
            _genericsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _genericsIlabels_collect :: (FMap Name Names)
            _genericsImethods_collect :: (FMap Name Names)
            _genericsIself :: (KindAnnotatedNames)
            _genericsOclassname :: (Maybe Name)
            _genericsOconstructors_collect :: (FMap Name Names)
            _genericsOconstructors_dist :: (FMap Name Names)
            _genericsOcurrentModule :: (Strings)
            _genericsOdependencies_collect :: (FMap Name [(Name,Name)])
            _genericsOimportedModule :: (Bool)
            _genericsOinferredDependencies :: (FMap Name [(Name,Name)])
            _genericsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _genericsOinstancename :: (Maybe Name)
            _genericsOlabels_collect :: (FMap Name Names)
            _genericsOlabels_dist :: (FMap Name Names)
            _genericsOlocal :: (Bool)
            _genericsOmethods_collect :: (FMap Name Names)
            _genericsOmethods_dist :: (FMap Name Names)
            _genericsOtoplevel :: (Bool)
            _parametricsIconstructors_collect :: (FMap Name Names)
            _parametricsIdependencies_collect :: (FMap Name [(Name,Name)])
            _parametricsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _parametricsIlabels_collect :: (FMap Name Names)
            _parametricsImethods_collect :: (FMap Name Names)
            _parametricsIself :: (Types)
            _parametricsOclassname :: (Maybe Name)
            _parametricsOconstructors_collect :: (FMap Name Names)
            _parametricsOconstructors_dist :: (FMap Name Names)
            _parametricsOcurrentModule :: (Strings)
            _parametricsOdependencies_collect :: (FMap Name [(Name,Name)])
            _parametricsOimportedModule :: (Bool)
            _parametricsOinferredDependencies :: (FMap Name [(Name,Name)])
            _parametricsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _parametricsOinstancename :: (Maybe Name)
            _parametricsOlabels_collect :: (FMap Name Names)
            _parametricsOlabels_dist :: (FMap Name Names)
            _parametricsOlocal :: (Bool)
            _parametricsOmethods_collect :: (FMap Name Names)
            _parametricsOmethods_dist :: (FMap Name Names)
            _parametricsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _genericsIakinds,_genericsIconstructors_collect,_genericsIdependencies_collect,_genericsIinferredDependencies_collect,_genericsIlabels_collect,_genericsImethods_collect,_genericsIself) =
                (generics_ (_genericsOclassname) (_genericsOconstructors_collect) (_genericsOconstructors_dist) (_genericsOcurrentModule) (_genericsOdependencies_collect) (_genericsOimportedModule) (_genericsOinferredDependencies) (_genericsOinferredDependencies_collect) (_genericsOinstancename) (_genericsOlabels_collect) (_genericsOlabels_dist) (_genericsOlocal) (_genericsOmethods_collect) (_genericsOmethods_dist) (_genericsOtoplevel))
            ( _parametricsIconstructors_collect,_parametricsIdependencies_collect,_parametricsIinferredDependencies_collect,_parametricsIlabels_collect,_parametricsImethods_collect,_parametricsIself) =
                (parametrics_ (_parametricsOclassname)
                              (_parametricsOconstructors_collect)
                              (_parametricsOconstructors_dist)
                              (_parametricsOcurrentModule)
                              (_parametricsOdependencies_collect)
                              (_parametricsOimportedModule)
                              (_parametricsOinferredDependencies)
                              (_parametricsOinferredDependencies_collect)
                              (_parametricsOinstancename)
                              (_parametricsOlabels_collect)
                              (_parametricsOlabels_dist)
                              (_parametricsOlocal)
                              (_parametricsOmethods_collect)
                              (_parametricsOmethods_dist)
                              (_parametricsOtoplevel))
            -- use rule
            (_lhsOlocalDependencies@_) =
                []
            -- self rule
            (_self@_) =
                Type_TypeSignature _rangeIself _genericsIself _parametricsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _parametricsIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _parametricsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _parametricsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _parametricsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _parametricsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_genericsOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_genericsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_genericsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_genericsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_genericsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_genericsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_genericsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_genericsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_genericsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_genericsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_genericsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_genericsOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_genericsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_genericsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_genericsOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_parametricsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_parametricsOconstructors_collect@_) =
                _genericsIconstructors_collect
            -- copy rule (down)
            (_parametricsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_parametricsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_parametricsOdependencies_collect@_) =
                _genericsIdependencies_collect
            -- copy rule (down)
            (_parametricsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_parametricsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_parametricsOinferredDependencies_collect@_) =
                _genericsIinferredDependencies_collect
            -- copy rule (down)
            (_parametricsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_parametricsOlabels_collect@_) =
                _genericsIlabels_collect
            -- copy rule (down)
            (_parametricsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_parametricsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_parametricsOmethods_collect@_) =
                _genericsImethods_collect
            -- copy rule (down)
            (_parametricsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_parametricsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOlocalDependencies,_lhsOmethods_collect,_lhsOself)
sem_Type_Variable :: (T_Range) ->
                     (T_Name) ->
                     (T_Type)
sem_Type_Variable (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOlocalDependencies :: ([(Name,Name)])
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Type)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            -- use rule
            (_lhsOlocalDependencies@_) =
                []
            -- self rule
            (_self@_) =
                Type_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOlocalDependencies,_lhsOmethods_collect,_lhsOself)
-- TypeArgument ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for TypeArgument.Constructor:
      self

-}
{-
   local variables for TypeArgument.ConstructorCase:
      self

-}
{-
   local variables for TypeArgument.DependencyStyle:
      self

-}
{-
   local variables for TypeArgument.KindStarCase:
      self

-}
{-
   local variables for TypeArgument.Label:
      self

-}
{-
   local variables for TypeArgument.NamedType:
      self

-}
{-
   local variables for TypeArgument.Variable:
      self

-}
-- semantic domain
type T_TypeArgument = (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Strings) ->
                      (FMap Name [(Name,Name)]) ->
                      (Bool) ->
                      (FMap Name [(Name,Name)]) ->
                      (FMap Name [(Name,Name)]) ->
                      (Maybe Name) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      (FMap Name Names) ->
                      (FMap Name Names) ->
                      (Bool) ->
                      ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(TypeArgument))
-- cata
sem_TypeArgument :: (TypeArgument) ->
                    (T_TypeArgument)
sem_TypeArgument ((TypeArgument_Constructor (_range) (_variable))) =
    (sem_TypeArgument_Constructor ((sem_Range (_range))) ((sem_Name (_variable))))
sem_TypeArgument ((TypeArgument_ConstructorCase (_range) (_name))) =
    (sem_TypeArgument_ConstructorCase ((sem_Range (_range))) ((sem_Name (_name))))
sem_TypeArgument ((TypeArgument_DependencyStyle (_range) (_name) (_descriptor) (_variables))) =
    (sem_TypeArgument_DependencyStyle ((sem_Range (_range))) ((sem_Name (_name))) ((sem_MaybeName (_descriptor))) ((sem_Names (_variables))))
sem_TypeArgument ((TypeArgument_KindStarCase (_range))) =
    (sem_TypeArgument_KindStarCase ((sem_Range (_range))))
sem_TypeArgument ((TypeArgument_Label (_range) (_variable))) =
    (sem_TypeArgument_Label ((sem_Range (_range))) ((sem_Name (_variable))))
sem_TypeArgument ((TypeArgument_NamedType (_range) (_name))) =
    (sem_TypeArgument_NamedType ((sem_Range (_range))) ((sem_Name (_name))))
sem_TypeArgument ((TypeArgument_Variable (_range) (_name))) =
    (sem_TypeArgument_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_TypeArgument_Constructor :: (T_Range) ->
                                (T_Name) ->
                                (T_TypeArgument)
sem_TypeArgument_Constructor (range_) (variable_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (TypeArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _variableIconstructors_collect :: (FMap Name Names)
            _variableIdependencies_collect :: (FMap Name [(Name,Name)])
            _variableIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _variableIlabels_collect :: (FMap Name Names)
            _variableImethods_collect :: (FMap Name Names)
            _variableIself :: (Name)
            _variableOclassname :: (Maybe Name)
            _variableOconstructors_collect :: (FMap Name Names)
            _variableOconstructors_dist :: (FMap Name Names)
            _variableOcurrentModule :: (Strings)
            _variableOdependencies_collect :: (FMap Name [(Name,Name)])
            _variableOimportedModule :: (Bool)
            _variableOinferredDependencies :: (FMap Name [(Name,Name)])
            _variableOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _variableOinstancename :: (Maybe Name)
            _variableOlabels_collect :: (FMap Name Names)
            _variableOlabels_dist :: (FMap Name Names)
            _variableOlocal :: (Bool)
            _variableOmethods_collect :: (FMap Name Names)
            _variableOmethods_dist :: (FMap Name Names)
            _variableOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _variableIconstructors_collect,_variableIdependencies_collect,_variableIinferredDependencies_collect,_variableIlabels_collect,_variableImethods_collect,_variableIself) =
                (variable_ (_variableOclassname) (_variableOconstructors_collect) (_variableOconstructors_dist) (_variableOcurrentModule) (_variableOdependencies_collect) (_variableOimportedModule) (_variableOinferredDependencies) (_variableOinferredDependencies_collect) (_variableOinstancename) (_variableOlabels_collect) (_variableOlabels_dist) (_variableOlocal) (_variableOmethods_collect) (_variableOmethods_dist) (_variableOtoplevel))
            -- self rule
            (_self@_) =
                TypeArgument_Constructor _rangeIself _variableIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _variableIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _variableIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _variableIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _variableIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _variableImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_variableOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_variableOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_variableOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_variableOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_variableOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_variableOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_variableOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_variableOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_variableOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_variableOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_variableOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_variableOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_variableOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_variableOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_variableOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_TypeArgument_ConstructorCase :: (T_Range) ->
                                    (T_Name) ->
                                    (T_TypeArgument)
sem_TypeArgument_ConstructorCase (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (TypeArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            -- self rule
            (_self@_) =
                TypeArgument_ConstructorCase _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_TypeArgument_DependencyStyle :: (T_Range) ->
                                    (T_Name) ->
                                    (T_MaybeName) ->
                                    (T_Names) ->
                                    (T_TypeArgument)
sem_TypeArgument_DependencyStyle (range_) (name_) (descriptor_) (variables_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (TypeArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _descriptorIconstructors_collect :: (FMap Name Names)
            _descriptorIdependencies_collect :: (FMap Name [(Name,Name)])
            _descriptorIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _descriptorIlabels_collect :: (FMap Name Names)
            _descriptorImethods_collect :: (FMap Name Names)
            _descriptorIself :: (MaybeName)
            _descriptorOclassname :: (Maybe Name)
            _descriptorOconstructors_collect :: (FMap Name Names)
            _descriptorOconstructors_dist :: (FMap Name Names)
            _descriptorOcurrentModule :: (Strings)
            _descriptorOdependencies_collect :: (FMap Name [(Name,Name)])
            _descriptorOimportedModule :: (Bool)
            _descriptorOinferredDependencies :: (FMap Name [(Name,Name)])
            _descriptorOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _descriptorOinstancename :: (Maybe Name)
            _descriptorOlabels_collect :: (FMap Name Names)
            _descriptorOlabels_dist :: (FMap Name Names)
            _descriptorOlocal :: (Bool)
            _descriptorOmethods_collect :: (FMap Name Names)
            _descriptorOmethods_dist :: (FMap Name Names)
            _descriptorOtoplevel :: (Bool)
            _variablesIconstructors_collect :: (FMap Name Names)
            _variablesIdependencies_collect :: (FMap Name [(Name,Name)])
            _variablesIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _variablesIlabels_collect :: (FMap Name Names)
            _variablesImethods_collect :: (FMap Name Names)
            _variablesIself :: (Names)
            _variablesOclassname :: (Maybe Name)
            _variablesOconstructors_collect :: (FMap Name Names)
            _variablesOconstructors_dist :: (FMap Name Names)
            _variablesOcurrentModule :: (Strings)
            _variablesOdependencies_collect :: (FMap Name [(Name,Name)])
            _variablesOimportedModule :: (Bool)
            _variablesOinferredDependencies :: (FMap Name [(Name,Name)])
            _variablesOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _variablesOinstancename :: (Maybe Name)
            _variablesOlabels_collect :: (FMap Name Names)
            _variablesOlabels_dist :: (FMap Name Names)
            _variablesOlocal :: (Bool)
            _variablesOmethods_collect :: (FMap Name Names)
            _variablesOmethods_dist :: (FMap Name Names)
            _variablesOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _descriptorIconstructors_collect,_descriptorIdependencies_collect,_descriptorIinferredDependencies_collect,_descriptorIlabels_collect,_descriptorImethods_collect,_descriptorIself) =
                (descriptor_ (_descriptorOclassname)
                             (_descriptorOconstructors_collect)
                             (_descriptorOconstructors_dist)
                             (_descriptorOcurrentModule)
                             (_descriptorOdependencies_collect)
                             (_descriptorOimportedModule)
                             (_descriptorOinferredDependencies)
                             (_descriptorOinferredDependencies_collect)
                             (_descriptorOinstancename)
                             (_descriptorOlabels_collect)
                             (_descriptorOlabels_dist)
                             (_descriptorOlocal)
                             (_descriptorOmethods_collect)
                             (_descriptorOmethods_dist)
                             (_descriptorOtoplevel))
            ( _variablesIconstructors_collect,_variablesIdependencies_collect,_variablesIinferredDependencies_collect,_variablesIlabels_collect,_variablesImethods_collect,_variablesIself) =
                (variables_ (_variablesOclassname)
                            (_variablesOconstructors_collect)
                            (_variablesOconstructors_dist)
                            (_variablesOcurrentModule)
                            (_variablesOdependencies_collect)
                            (_variablesOimportedModule)
                            (_variablesOinferredDependencies)
                            (_variablesOinferredDependencies_collect)
                            (_variablesOinstancename)
                            (_variablesOlabels_collect)
                            (_variablesOlabels_dist)
                            (_variablesOlocal)
                            (_variablesOmethods_collect)
                            (_variablesOmethods_dist)
                            (_variablesOtoplevel))
            -- self rule
            (_self@_) =
                TypeArgument_DependencyStyle _rangeIself _nameIself _descriptorIself _variablesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _variablesIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _variablesIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _variablesIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _variablesIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _variablesImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_descriptorOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_descriptorOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_descriptorOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_descriptorOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_descriptorOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_descriptorOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_descriptorOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_descriptorOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_descriptorOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_descriptorOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_descriptorOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_descriptorOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_descriptorOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_descriptorOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_descriptorOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_variablesOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_variablesOconstructors_collect@_) =
                _descriptorIconstructors_collect
            -- copy rule (down)
            (_variablesOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_variablesOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_variablesOdependencies_collect@_) =
                _descriptorIdependencies_collect
            -- copy rule (down)
            (_variablesOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_variablesOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_variablesOinferredDependencies_collect@_) =
                _descriptorIinferredDependencies_collect
            -- copy rule (down)
            (_variablesOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_variablesOlabels_collect@_) =
                _descriptorIlabels_collect
            -- copy rule (down)
            (_variablesOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_variablesOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_variablesOmethods_collect@_) =
                _descriptorImethods_collect
            -- copy rule (down)
            (_variablesOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_variablesOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_TypeArgument_KindStarCase :: (T_Range) ->
                                 (T_TypeArgument)
sem_TypeArgument_KindStarCase (range_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (TypeArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            -- self rule
            (_self@_) =
                TypeArgument_KindStarCase _rangeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_TypeArgument_Label :: (T_Range) ->
                          (T_Name) ->
                          (T_TypeArgument)
sem_TypeArgument_Label (range_) (variable_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (TypeArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _variableIconstructors_collect :: (FMap Name Names)
            _variableIdependencies_collect :: (FMap Name [(Name,Name)])
            _variableIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _variableIlabels_collect :: (FMap Name Names)
            _variableImethods_collect :: (FMap Name Names)
            _variableIself :: (Name)
            _variableOclassname :: (Maybe Name)
            _variableOconstructors_collect :: (FMap Name Names)
            _variableOconstructors_dist :: (FMap Name Names)
            _variableOcurrentModule :: (Strings)
            _variableOdependencies_collect :: (FMap Name [(Name,Name)])
            _variableOimportedModule :: (Bool)
            _variableOinferredDependencies :: (FMap Name [(Name,Name)])
            _variableOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _variableOinstancename :: (Maybe Name)
            _variableOlabels_collect :: (FMap Name Names)
            _variableOlabels_dist :: (FMap Name Names)
            _variableOlocal :: (Bool)
            _variableOmethods_collect :: (FMap Name Names)
            _variableOmethods_dist :: (FMap Name Names)
            _variableOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _variableIconstructors_collect,_variableIdependencies_collect,_variableIinferredDependencies_collect,_variableIlabels_collect,_variableImethods_collect,_variableIself) =
                (variable_ (_variableOclassname) (_variableOconstructors_collect) (_variableOconstructors_dist) (_variableOcurrentModule) (_variableOdependencies_collect) (_variableOimportedModule) (_variableOinferredDependencies) (_variableOinferredDependencies_collect) (_variableOinstancename) (_variableOlabels_collect) (_variableOlabels_dist) (_variableOlocal) (_variableOmethods_collect) (_variableOmethods_dist) (_variableOtoplevel))
            -- self rule
            (_self@_) =
                TypeArgument_Label _rangeIself _variableIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _variableIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _variableIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _variableIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _variableIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _variableImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_variableOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_variableOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_variableOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_variableOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_variableOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_variableOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_variableOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_variableOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_variableOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_variableOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_variableOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_variableOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_variableOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_variableOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_variableOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_TypeArgument_NamedType :: (T_Range) ->
                              (T_Name) ->
                              (T_TypeArgument)
sem_TypeArgument_NamedType (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (TypeArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            -- self rule
            (_self@_) =
                TypeArgument_NamedType _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_TypeArgument_Variable :: (T_Range) ->
                             (T_Name) ->
                             (T_TypeArgument)
sem_TypeArgument_Variable (range_) (name_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (TypeArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            -- self rule
            (_self@_) =
                TypeArgument_Variable _rangeIself _nameIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- TypeArguments -----------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for TypeArguments.Cons:
      self

-}
{-
   local variables for TypeArguments.Nil:
      self

-}
-- semantic domain
type T_TypeArguments = (Maybe Name) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (Strings) ->
                       (FMap Name [(Name,Name)]) ->
                       (Bool) ->
                       (FMap Name [(Name,Name)]) ->
                       (FMap Name [(Name,Name)]) ->
                       (Maybe Name) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (Bool) ->
                       (FMap Name Names) ->
                       (FMap Name Names) ->
                       (Bool) ->
                       ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(TypeArguments))
-- cata
sem_TypeArguments :: (TypeArguments) ->
                     (T_TypeArguments)
sem_TypeArguments (list) =
    (foldr (sem_TypeArguments_Cons) (sem_TypeArguments_Nil) ((map sem_TypeArgument list)))
sem_TypeArguments_Cons :: (T_TypeArgument) ->
                          (T_TypeArguments) ->
                          (T_TypeArguments)
sem_TypeArguments_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (TypeArguments)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdependencies_collect :: (FMap Name [(Name,Name)])
            _hdIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdIlabels_collect :: (FMap Name Names)
            _hdImethods_collect :: (FMap Name Names)
            _hdIself :: (TypeArgument)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies_collect :: (FMap Name [(Name,Name)])
            _hdOimportedModule :: (Bool)
            _hdOinferredDependencies :: (FMap Name [(Name,Name)])
            _hdOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdOinstancename :: (Maybe Name)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdependencies_collect :: (FMap Name [(Name,Name)])
            _tlIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIself :: (TypeArguments)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies_collect :: (FMap Name [(Name,Name)])
            _tlOimportedModule :: (Bool)
            _tlOinferredDependencies :: (FMap Name [(Name,Name)])
            _tlOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIdependencies_collect,_hdIinferredDependencies_collect,_hdIlabels_collect,_hdImethods_collect,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOdependencies_collect) (_hdOimportedModule) (_hdOinferredDependencies) (_hdOinferredDependencies_collect) (_hdOinstancename) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIdependencies_collect,_tlIinferredDependencies_collect,_tlIlabels_collect,_tlImethods_collect,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOdependencies_collect) (_tlOimportedModule) (_tlOinferredDependencies) (_tlOinferredDependencies_collect) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOtoplevel))
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _tlIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _tlIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_hdOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_tlOdependencies_collect@_) =
                _hdIdependencies_collect
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_tlOinferredDependencies_collect@_) =
                _hdIinferredDependencies_collect
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_TypeArguments_Nil :: (T_TypeArguments)
sem_TypeArguments_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (TypeArguments)
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
-- TypeIndexedBinding ------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      bodyDependencies     : [(Name,Name)]
      linkname             : Maybe Name
      name                 : Name
      self                 : SELF
      typeargument         : Maybe TypeArgument

-}
{-
   local variables for TypeIndexedBinding.DefaultCase:
      self

-}
{-
   local variables for TypeIndexedBinding.TypeIndexedBinding:
      self

-}
-- semantic domain
type T_TypeIndexedBinding = (Maybe Name) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Strings) ->
                            (FMap Name [(Name,Name)]) ->
                            (Bool) ->
                            (FMap Name [(Name,Name)]) ->
                            (FMap Name [(Name,Name)]) ->
                            (Maybe Name) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (Bool) ->
                            (FMap Name Names) ->
                            (FMap Name Names) ->
                            (PreSignatures) ->
                            (PreSignatures) ->
                            (Signatures) ->
                            (Bool) ->
                            ( ([(Name,Name)]),(FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(Maybe Name),(FMap Name Names),(Name),(PreSignatures),(TypeIndexedBinding),(Maybe TypeArgument))
-- cata
sem_TypeIndexedBinding :: (TypeIndexedBinding) ->
                          (T_TypeIndexedBinding)
sem_TypeIndexedBinding ((TypeIndexedBinding_DefaultCase (_range) (_name) (_extended) (_reassignments))) =
    (sem_TypeIndexedBinding_DefaultCase ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Name (_extended))) ((sem_MaybeReassignments (_reassignments))))
sem_TypeIndexedBinding ((TypeIndexedBinding_TypeIndexedBinding (_range) (_name) (_typeargument) (_patterns) (_righthandside))) =
    (sem_TypeIndexedBinding_TypeIndexedBinding ((sem_Range (_range))) ((sem_Name (_name))) ((sem_TypeArgument (_typeargument))) ((sem_Patterns (_patterns))) ((sem_RightHandSide (_righthandside))))
sem_TypeIndexedBinding_DefaultCase :: (T_Range) ->
                                      (T_Name) ->
                                      (T_Name) ->
                                      (T_MaybeReassignments) ->
                                      (T_TypeIndexedBinding)
sem_TypeIndexedBinding_DefaultCase (range_) (name_) (extended_) (reassignments_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOlinkname :: (Maybe Name)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (TypeIndexedBinding)
            _lhsOtypeargument :: (Maybe TypeArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _extendedIconstructors_collect :: (FMap Name Names)
            _extendedIdependencies_collect :: (FMap Name [(Name,Name)])
            _extendedIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _extendedIlabels_collect :: (FMap Name Names)
            _extendedImethods_collect :: (FMap Name Names)
            _extendedIself :: (Name)
            _extendedOclassname :: (Maybe Name)
            _extendedOconstructors_collect :: (FMap Name Names)
            _extendedOconstructors_dist :: (FMap Name Names)
            _extendedOcurrentModule :: (Strings)
            _extendedOdependencies_collect :: (FMap Name [(Name,Name)])
            _extendedOimportedModule :: (Bool)
            _extendedOinferredDependencies :: (FMap Name [(Name,Name)])
            _extendedOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _extendedOinstancename :: (Maybe Name)
            _extendedOlabels_collect :: (FMap Name Names)
            _extendedOlabels_dist :: (FMap Name Names)
            _extendedOlocal :: (Bool)
            _extendedOmethods_collect :: (FMap Name Names)
            _extendedOmethods_dist :: (FMap Name Names)
            _extendedOtoplevel :: (Bool)
            _reassignmentsIconstructors_collect :: (FMap Name Names)
            _reassignmentsIdependencies_collect :: (FMap Name [(Name,Name)])
            _reassignmentsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _reassignmentsIlabels_collect :: (FMap Name Names)
            _reassignmentsImethods_collect :: (FMap Name Names)
            _reassignmentsIself :: (MaybeReassignments)
            _reassignmentsOclassname :: (Maybe Name)
            _reassignmentsOconstructors_collect :: (FMap Name Names)
            _reassignmentsOconstructors_dist :: (FMap Name Names)
            _reassignmentsOcurrentModule :: (Strings)
            _reassignmentsOdependencies_collect :: (FMap Name [(Name,Name)])
            _reassignmentsOimportedModule :: (Bool)
            _reassignmentsOinferredDependencies :: (FMap Name [(Name,Name)])
            _reassignmentsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _reassignmentsOinstancename :: (Maybe Name)
            _reassignmentsOlabels_collect :: (FMap Name Names)
            _reassignmentsOlabels_dist :: (FMap Name Names)
            _reassignmentsOlocal :: (Bool)
            _reassignmentsOmethods_collect :: (FMap Name Names)
            _reassignmentsOmethods_dist :: (FMap Name Names)
            _reassignmentsOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _extendedIconstructors_collect,_extendedIdependencies_collect,_extendedIinferredDependencies_collect,_extendedIlabels_collect,_extendedImethods_collect,_extendedIself) =
                (extended_ (_extendedOclassname) (_extendedOconstructors_collect) (_extendedOconstructors_dist) (_extendedOcurrentModule) (_extendedOdependencies_collect) (_extendedOimportedModule) (_extendedOinferredDependencies) (_extendedOinferredDependencies_collect) (_extendedOinstancename) (_extendedOlabels_collect) (_extendedOlabels_dist) (_extendedOlocal) (_extendedOmethods_collect) (_extendedOmethods_dist) (_extendedOtoplevel))
            ( _reassignmentsIconstructors_collect,_reassignmentsIdependencies_collect,_reassignmentsIinferredDependencies_collect,_reassignmentsIlabels_collect,_reassignmentsImethods_collect,_reassignmentsIself) =
                (reassignments_ (_reassignmentsOclassname)
                                (_reassignmentsOconstructors_collect)
                                (_reassignmentsOconstructors_dist)
                                (_reassignmentsOcurrentModule)
                                (_reassignmentsOdependencies_collect)
                                (_reassignmentsOimportedModule)
                                (_reassignmentsOinferredDependencies)
                                (_reassignmentsOinferredDependencies_collect)
                                (_reassignmentsOinstancename)
                                (_reassignmentsOlabels_collect)
                                (_reassignmentsOlabels_dist)
                                (_reassignmentsOlocal)
                                (_reassignmentsOmethods_collect)
                                (_reassignmentsOmethods_dist)
                                (_reassignmentsOtoplevel))
            -- "./Signature.inc.lag"(line 387, column 10)
            (_lhsOlinkname@_) =
                Just _extendedIself
            -- "./ModuleInformation.inc.lag"(line 435, column 9)
            (_lhsOtypeargument@_) =
                Nothing
            -- "./ModuleInformation.inc.lag"(line 434, column 9)
            (_lhsOname@_) =
                _nameIself
            -- use rule
            (_lhsObodyDependencies@_) =
                []
            -- self rule
            (_self@_) =
                TypeIndexedBinding_DefaultCase _rangeIself _nameIself _extendedIself _reassignmentsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _reassignmentsIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _reassignmentsIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _reassignmentsIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _reassignmentsIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _reassignmentsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_extendedOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_extendedOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_extendedOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_extendedOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_extendedOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_extendedOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_extendedOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_extendedOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_extendedOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_extendedOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_extendedOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_extendedOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_extendedOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_extendedOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_extendedOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_reassignmentsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_reassignmentsOconstructors_collect@_) =
                _extendedIconstructors_collect
            -- copy rule (down)
            (_reassignmentsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_reassignmentsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_reassignmentsOdependencies_collect@_) =
                _extendedIdependencies_collect
            -- copy rule (down)
            (_reassignmentsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_reassignmentsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_reassignmentsOinferredDependencies_collect@_) =
                _extendedIinferredDependencies_collect
            -- copy rule (down)
            (_reassignmentsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_reassignmentsOlabels_collect@_) =
                _extendedIlabels_collect
            -- copy rule (down)
            (_reassignmentsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_reassignmentsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_reassignmentsOmethods_collect@_) =
                _extendedImethods_collect
            -- copy rule (down)
            (_reassignmentsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_reassignmentsOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOlinkname,_lhsOmethods_collect,_lhsOname,_lhsOpresignatures_collect,_lhsOself,_lhsOtypeargument)
sem_TypeIndexedBinding_TypeIndexedBinding :: (T_Range) ->
                                             (T_Name) ->
                                             (T_TypeArgument) ->
                                             (T_Patterns) ->
                                             (T_RightHandSide) ->
                                             (T_TypeIndexedBinding)
sem_TypeIndexedBinding_TypeIndexedBinding (range_) (name_) (typeargument_) (patterns_) (righthandside_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOlinkname :: (Maybe Name)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (TypeIndexedBinding)
            _lhsOtypeargument :: (Maybe TypeArgument)
            _rangeIself :: (Range)
            _rangeOclassname :: (Maybe Name)
            _rangeOcurrentModule :: (Strings)
            _rangeOimportedModule :: (Bool)
            _rangeOinstancename :: (Maybe Name)
            _rangeOlocal :: (Bool)
            _rangeOtoplevel :: (Bool)
            _nameIconstructors_collect :: (FMap Name Names)
            _nameIdependencies_collect :: (FMap Name [(Name,Name)])
            _nameIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameIlabels_collect :: (FMap Name Names)
            _nameImethods_collect :: (FMap Name Names)
            _nameIself :: (Name)
            _nameOclassname :: (Maybe Name)
            _nameOconstructors_collect :: (FMap Name Names)
            _nameOconstructors_dist :: (FMap Name Names)
            _nameOcurrentModule :: (Strings)
            _nameOdependencies_collect :: (FMap Name [(Name,Name)])
            _nameOimportedModule :: (Bool)
            _nameOinferredDependencies :: (FMap Name [(Name,Name)])
            _nameOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _nameOinstancename :: (Maybe Name)
            _nameOlabels_collect :: (FMap Name Names)
            _nameOlabels_dist :: (FMap Name Names)
            _nameOlocal :: (Bool)
            _nameOmethods_collect :: (FMap Name Names)
            _nameOmethods_dist :: (FMap Name Names)
            _nameOtoplevel :: (Bool)
            _typeargumentIconstructors_collect :: (FMap Name Names)
            _typeargumentIdependencies_collect :: (FMap Name [(Name,Name)])
            _typeargumentIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typeargumentIlabels_collect :: (FMap Name Names)
            _typeargumentImethods_collect :: (FMap Name Names)
            _typeargumentIself :: (TypeArgument)
            _typeargumentOclassname :: (Maybe Name)
            _typeargumentOconstructors_collect :: (FMap Name Names)
            _typeargumentOconstructors_dist :: (FMap Name Names)
            _typeargumentOcurrentModule :: (Strings)
            _typeargumentOdependencies_collect :: (FMap Name [(Name,Name)])
            _typeargumentOimportedModule :: (Bool)
            _typeargumentOinferredDependencies :: (FMap Name [(Name,Name)])
            _typeargumentOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _typeargumentOinstancename :: (Maybe Name)
            _typeargumentOlabels_collect :: (FMap Name Names)
            _typeargumentOlabels_dist :: (FMap Name Names)
            _typeargumentOlocal :: (Bool)
            _typeargumentOmethods_collect :: (FMap Name Names)
            _typeargumentOmethods_dist :: (FMap Name Names)
            _typeargumentOtoplevel :: (Bool)
            _patternsIconstructors_collect :: (FMap Name Names)
            _patternsIdependencies_collect :: (FMap Name [(Name,Name)])
            _patternsIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _patternsIlabels_collect :: (FMap Name Names)
            _patternsImethods_collect :: (FMap Name Names)
            _patternsIself :: (Patterns)
            _patternsOclassname :: (Maybe Name)
            _patternsOconstructors_collect :: (FMap Name Names)
            _patternsOconstructors_dist :: (FMap Name Names)
            _patternsOcurrentModule :: (Strings)
            _patternsOdependencies_collect :: (FMap Name [(Name,Name)])
            _patternsOimportedModule :: (Bool)
            _patternsOinferredDependencies :: (FMap Name [(Name,Name)])
            _patternsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _patternsOinstancename :: (Maybe Name)
            _patternsOlabels_collect :: (FMap Name Names)
            _patternsOlabels_dist :: (FMap Name Names)
            _patternsOlocal :: (Bool)
            _patternsOmethods_collect :: (FMap Name Names)
            _patternsOmethods_dist :: (FMap Name Names)
            _patternsOtoplevel :: (Bool)
            _righthandsideIbodyDependencies :: ([(Name,Name)])
            _righthandsideIconstructors_collect :: (FMap Name Names)
            _righthandsideIdependencies_collect :: (FMap Name [(Name,Name)])
            _righthandsideIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _righthandsideIlabels_collect :: (FMap Name Names)
            _righthandsideImethods_collect :: (FMap Name Names)
            _righthandsideIpresignatures_collect :: (PreSignatures)
            _righthandsideIself :: (RightHandSide)
            _righthandsideOclassname :: (Maybe Name)
            _righthandsideOconstructors_collect :: (FMap Name Names)
            _righthandsideOconstructors_dist :: (FMap Name Names)
            _righthandsideOcurrentModule :: (Strings)
            _righthandsideOdependencies_collect :: (FMap Name [(Name,Name)])
            _righthandsideOimportedModule :: (Bool)
            _righthandsideOinferredDependencies :: (FMap Name [(Name,Name)])
            _righthandsideOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _righthandsideOinstancename :: (Maybe Name)
            _righthandsideOlabels_collect :: (FMap Name Names)
            _righthandsideOlabels_dist :: (FMap Name Names)
            _righthandsideOlocal :: (Bool)
            _righthandsideOmethods_collect :: (FMap Name Names)
            _righthandsideOmethods_dist :: (FMap Name Names)
            _righthandsideOpresignatures :: (PreSignatures)
            _righthandsideOpresignatures_collect :: (PreSignatures)
            _righthandsideOsignatures :: (Signatures)
            _righthandsideOtoplevel :: (Bool)
            ( _rangeIself) =
                (range_ (_rangeOclassname) (_rangeOcurrentModule) (_rangeOimportedModule) (_rangeOinstancename) (_rangeOlocal) (_rangeOtoplevel))
            ( _nameIconstructors_collect,_nameIdependencies_collect,_nameIinferredDependencies_collect,_nameIlabels_collect,_nameImethods_collect,_nameIself) =
                (name_ (_nameOclassname) (_nameOconstructors_collect) (_nameOconstructors_dist) (_nameOcurrentModule) (_nameOdependencies_collect) (_nameOimportedModule) (_nameOinferredDependencies) (_nameOinferredDependencies_collect) (_nameOinstancename) (_nameOlabels_collect) (_nameOlabels_dist) (_nameOlocal) (_nameOmethods_collect) (_nameOmethods_dist) (_nameOtoplevel))
            ( _typeargumentIconstructors_collect,_typeargumentIdependencies_collect,_typeargumentIinferredDependencies_collect,_typeargumentIlabels_collect,_typeargumentImethods_collect,_typeargumentIself) =
                (typeargument_ (_typeargumentOclassname)
                               (_typeargumentOconstructors_collect)
                               (_typeargumentOconstructors_dist)
                               (_typeargumentOcurrentModule)
                               (_typeargumentOdependencies_collect)
                               (_typeargumentOimportedModule)
                               (_typeargumentOinferredDependencies)
                               (_typeargumentOinferredDependencies_collect)
                               (_typeargumentOinstancename)
                               (_typeargumentOlabels_collect)
                               (_typeargumentOlabels_dist)
                               (_typeargumentOlocal)
                               (_typeargumentOmethods_collect)
                               (_typeargumentOmethods_dist)
                               (_typeargumentOtoplevel))
            ( _patternsIconstructors_collect,_patternsIdependencies_collect,_patternsIinferredDependencies_collect,_patternsIlabels_collect,_patternsImethods_collect,_patternsIself) =
                (patterns_ (_patternsOclassname) (_patternsOconstructors_collect) (_patternsOconstructors_dist) (_patternsOcurrentModule) (_patternsOdependencies_collect) (_patternsOimportedModule) (_patternsOinferredDependencies) (_patternsOinferredDependencies_collect) (_patternsOinstancename) (_patternsOlabels_collect) (_patternsOlabels_dist) (_patternsOlocal) (_patternsOmethods_collect) (_patternsOmethods_dist) (_patternsOtoplevel))
            ( _righthandsideIbodyDependencies,_righthandsideIconstructors_collect,_righthandsideIdependencies_collect,_righthandsideIinferredDependencies_collect,_righthandsideIlabels_collect,_righthandsideImethods_collect,_righthandsideIpresignatures_collect,_righthandsideIself) =
                (righthandside_ (_righthandsideOclassname)
                                (_righthandsideOconstructors_collect)
                                (_righthandsideOconstructors_dist)
                                (_righthandsideOcurrentModule)
                                (_righthandsideOdependencies_collect)
                                (_righthandsideOimportedModule)
                                (_righthandsideOinferredDependencies)
                                (_righthandsideOinferredDependencies_collect)
                                (_righthandsideOinstancename)
                                (_righthandsideOlabels_collect)
                                (_righthandsideOlabels_dist)
                                (_righthandsideOlocal)
                                (_righthandsideOmethods_collect)
                                (_righthandsideOmethods_dist)
                                (_righthandsideOpresignatures)
                                (_righthandsideOpresignatures_collect)
                                (_righthandsideOsignatures)
                                (_righthandsideOtoplevel))
            -- "ScanDependencies.lag"(line 111, column 9)
            (_lhsObodyDependencies@_) =
                case _typeargumentIself of
                  TypeArgument_Variable _ n ->
                    filter
                      (\(_,v) -> v /= n)
                      _righthandsideIbodyDependencies
                  _ -> _righthandsideIbodyDependencies
            -- "ScanDependencies.lag"(line 149, column 9)
            (_lhsOinferredDependencies_collect@_) =
                case _typeargumentIself of
                  TypeArgument_Variable _ n ->
                    addLFront  _lhsIinferredDependencies_collect
                               (_nameIself,
                                [ (d,d)
                                | (d,v) <- _righthandsideIbodyDependencies,
                                  v == n
                                ])
                  TypeArgument_DependencyStyle _ _ _ vs ->
                    addLFront  _lhsIinferredDependencies_collect
                               (_nameIself,
                                [ (d,d)
                                | (d,v) <- _righthandsideIbodyDependencies,
                                  v `elem` vs
                                ])
                  _ -> _lhsIinferredDependencies_collect
            -- "./ModuleInformation.inc.lag"(line 172, column 8)
            (_righthandsideOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 171, column 8)
            (_patternsOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 170, column 8)
            (_typeargumentOtoplevel@_) =
                False
            -- "./ModuleInformation.inc.lag"(line 432, column 9)
            (_lhsOtypeargument@_) =
                Just _typeargumentIself
            -- "./ModuleInformation.inc.lag"(line 431, column 9)
            (_lhsOname@_) =
                _nameIself
            -- use rule
            (_lhsOlinkname@_) =
                Nothing
            -- self rule
            (_self@_) =
                TypeIndexedBinding_TypeIndexedBinding _rangeIself _nameIself _typeargumentIself _patternsIself _righthandsideIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _righthandsideIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _righthandsideIdependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _righthandsideIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _righthandsideImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _righthandsideIpresignatures_collect
            -- copy rule (down)
            (_rangeOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_rangeOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_rangeOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_rangeOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_rangeOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_rangeOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_nameOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_nameOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_nameOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_nameOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_nameOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_nameOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_nameOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_nameOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_nameOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_nameOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_nameOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_nameOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_nameOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_nameOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_nameOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_typeargumentOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_typeargumentOconstructors_collect@_) =
                _nameIconstructors_collect
            -- copy rule (down)
            (_typeargumentOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_typeargumentOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_typeargumentOdependencies_collect@_) =
                _nameIdependencies_collect
            -- copy rule (down)
            (_typeargumentOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_typeargumentOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_typeargumentOinferredDependencies_collect@_) =
                _nameIinferredDependencies_collect
            -- copy rule (down)
            (_typeargumentOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_typeargumentOlabels_collect@_) =
                _nameIlabels_collect
            -- copy rule (down)
            (_typeargumentOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_typeargumentOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_typeargumentOmethods_collect@_) =
                _nameImethods_collect
            -- copy rule (down)
            (_typeargumentOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_patternsOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_patternsOconstructors_collect@_) =
                _typeargumentIconstructors_collect
            -- copy rule (down)
            (_patternsOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_patternsOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_patternsOdependencies_collect@_) =
                _typeargumentIdependencies_collect
            -- copy rule (down)
            (_patternsOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_patternsOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_patternsOinferredDependencies_collect@_) =
                _typeargumentIinferredDependencies_collect
            -- copy rule (down)
            (_patternsOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_patternsOlabels_collect@_) =
                _typeargumentIlabels_collect
            -- copy rule (down)
            (_patternsOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_patternsOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_patternsOmethods_collect@_) =
                _typeargumentImethods_collect
            -- copy rule (down)
            (_patternsOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_righthandsideOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_righthandsideOconstructors_collect@_) =
                _patternsIconstructors_collect
            -- copy rule (down)
            (_righthandsideOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_righthandsideOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_righthandsideOdependencies_collect@_) =
                _patternsIdependencies_collect
            -- copy rule (down)
            (_righthandsideOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_righthandsideOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_righthandsideOinferredDependencies_collect@_) =
                _patternsIinferredDependencies_collect
            -- copy rule (down)
            (_righthandsideOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_righthandsideOlabels_collect@_) =
                _patternsIlabels_collect
            -- copy rule (down)
            (_righthandsideOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_righthandsideOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_righthandsideOmethods_collect@_) =
                _patternsImethods_collect
            -- copy rule (down)
            (_righthandsideOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_righthandsideOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_righthandsideOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_righthandsideOsignatures@_) =
                _lhsIsignatures
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOlinkname,_lhsOmethods_collect,_lhsOname,_lhsOpresignatures_collect,_lhsOself,_lhsOtypeargument)
-- TypeIndexedBindings -----------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      presignatures        : PreSignatures
      signatures           : Signatures
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names
      presignatures_collect : PreSignatures

   synthesised attributes:
      bodyDependencies     : [(Name,Name)]
      linkname             : Maybe Name
      name                 : Name
      self                 : SELF
      typeargument         : Maybe TypeArgument

-}
{-
   local variables for TypeIndexedBindings.Cons:
      self

-}
{-
   local variables for TypeIndexedBindings.Nil:
      self

-}
-- semantic domain
type T_TypeIndexedBindings = (Maybe Name) ->
                             (FMap Name Names) ->
                             (FMap Name Names) ->
                             (Strings) ->
                             (FMap Name [(Name,Name)]) ->
                             (Bool) ->
                             (FMap Name [(Name,Name)]) ->
                             (FMap Name [(Name,Name)]) ->
                             (Maybe Name) ->
                             (FMap Name Names) ->
                             (FMap Name Names) ->
                             (Bool) ->
                             (FMap Name Names) ->
                             (FMap Name Names) ->
                             (PreSignatures) ->
                             (PreSignatures) ->
                             (Signatures) ->
                             (Bool) ->
                             ( ([(Name,Name)]),(FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(Maybe Name),(FMap Name Names),(Name),(PreSignatures),(TypeIndexedBindings),(Maybe TypeArgument))
-- cata
sem_TypeIndexedBindings :: (TypeIndexedBindings) ->
                           (T_TypeIndexedBindings)
sem_TypeIndexedBindings (list) =
    (foldr (sem_TypeIndexedBindings_Cons) (sem_TypeIndexedBindings_Nil) ((map sem_TypeIndexedBinding list)))
sem_TypeIndexedBindings_Cons :: (T_TypeIndexedBinding) ->
                                (T_TypeIndexedBindings) ->
                                (T_TypeIndexedBindings)
sem_TypeIndexedBindings_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOlinkname :: (Maybe Name)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (TypeIndexedBindings)
            _lhsOtypeargument :: (Maybe TypeArgument)
            _hdIbodyDependencies :: ([(Name,Name)])
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdependencies_collect :: (FMap Name [(Name,Name)])
            _hdIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdIlabels_collect :: (FMap Name Names)
            _hdIlinkname :: (Maybe Name)
            _hdImethods_collect :: (FMap Name Names)
            _hdIname :: (Name)
            _hdIpresignatures_collect :: (PreSignatures)
            _hdIself :: (TypeIndexedBinding)
            _hdItypeargument :: (Maybe TypeArgument)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies_collect :: (FMap Name [(Name,Name)])
            _hdOimportedModule :: (Bool)
            _hdOinferredDependencies :: (FMap Name [(Name,Name)])
            _hdOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdOinstancename :: (Maybe Name)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOpresignatures :: (PreSignatures)
            _hdOpresignatures_collect :: (PreSignatures)
            _hdOsignatures :: (Signatures)
            _hdOtoplevel :: (Bool)
            _tlIbodyDependencies :: ([(Name,Name)])
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdependencies_collect :: (FMap Name [(Name,Name)])
            _tlIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlIlabels_collect :: (FMap Name Names)
            _tlIlinkname :: (Maybe Name)
            _tlImethods_collect :: (FMap Name Names)
            _tlIname :: (Name)
            _tlIpresignatures_collect :: (PreSignatures)
            _tlIself :: (TypeIndexedBindings)
            _tlItypeargument :: (Maybe TypeArgument)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies_collect :: (FMap Name [(Name,Name)])
            _tlOimportedModule :: (Bool)
            _tlOinferredDependencies :: (FMap Name [(Name,Name)])
            _tlOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOpresignatures :: (PreSignatures)
            _tlOpresignatures_collect :: (PreSignatures)
            _tlOsignatures :: (Signatures)
            _tlOtoplevel :: (Bool)
            ( _hdIbodyDependencies,_hdIconstructors_collect,_hdIdependencies_collect,_hdIinferredDependencies_collect,_hdIlabels_collect,_hdIlinkname,_hdImethods_collect,_hdIname,_hdIpresignatures_collect,_hdIself,_hdItypeargument) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOdependencies_collect) (_hdOimportedModule) (_hdOinferredDependencies) (_hdOinferredDependencies_collect) (_hdOinstancename) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOpresignatures) (_hdOpresignatures_collect) (_hdOsignatures) (_hdOtoplevel))
            ( _tlIbodyDependencies,_tlIconstructors_collect,_tlIdependencies_collect,_tlIinferredDependencies_collect,_tlIlabels_collect,_tlIlinkname,_tlImethods_collect,_tlIname,_tlIpresignatures_collect,_tlIself,_tlItypeargument) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOdependencies_collect) (_tlOimportedModule) (_tlOinferredDependencies) (_tlOinferredDependencies_collect) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOpresignatures) (_tlOpresignatures_collect) (_tlOsignatures) (_tlOtoplevel))
            -- "./ModuleInformation.inc.lag"(line 422, column 9)
            (_lhsOtypeargument@_) =
                _hdItypeargument
            -- "./ModuleInformation.inc.lag"(line 421, column 9)
            (_lhsOname@_) =
                _hdIname
            -- use rule
            (_lhsObodyDependencies@_) =
                _hdIbodyDependencies ++ _tlIbodyDependencies
            -- use rule
            (_lhsOlinkname@_) =
                _hdIlinkname `const` _tlIlinkname
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _tlIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _tlIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (up)
            (_lhsOpresignatures_collect@_) =
                _tlIpresignatures_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_hdOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (down)
            (_hdOpresignatures_collect@_) =
                _lhsIpresignatures_collect
            -- copy rule (down)
            (_hdOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_tlOdependencies_collect@_) =
                _hdIdependencies_collect
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_tlOinferredDependencies_collect@_) =
                _hdIinferredDependencies_collect
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOpresignatures@_) =
                _lhsIpresignatures
            -- copy rule (chain)
            (_tlOpresignatures_collect@_) =
                _hdIpresignatures_collect
            -- copy rule (down)
            (_tlOsignatures@_) =
                _lhsIsignatures
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOlinkname,_lhsOmethods_collect,_lhsOname,_lhsOpresignatures_collect,_lhsOself,_lhsOtypeargument)
sem_TypeIndexedBindings_Nil :: (T_TypeIndexedBindings)
sem_TypeIndexedBindings_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsIpresignatures
      _lhsIpresignatures_collect
      _lhsIsignatures
      _lhsItoplevel ->
        let _lhsObodyDependencies :: ([(Name,Name)])
            _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOlinkname :: (Maybe Name)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOname :: (Name)
            _lhsOpresignatures_collect :: (PreSignatures)
            _lhsOself :: (TypeIndexedBindings)
            _lhsOtypeargument :: (Maybe TypeArgument)
            -- "./ModuleInformation.inc.lag"(line 426, column 9)
            (_lhsOtypeargument@_) =
                internalError $
                  "ModuleInformation.TypeIndexedBindings.Nil.lhs.typeargument: no bindings"
            -- "./ModuleInformation.inc.lag"(line 424, column 9)
            (_lhsOname@_) =
                internalError $
                  "ModuleInformation.TypeIndexedBindings.Nil.lhs.name: no bindings"
            -- use rule
            (_lhsObodyDependencies@_) =
                []
            -- use rule
            (_lhsOlinkname@_) =
                Nothing
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (chain)
            (_lhsOpresignatures_collect@_) =
                _lhsIpresignatures_collect
        in  ( _lhsObodyDependencies,_lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOlinkname,_lhsOmethods_collect,_lhsOname,_lhsOpresignatures_collect,_lhsOself,_lhsOtypeargument)
-- Types -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe Name
      constructors_dist    : FMap Name Names
      currentModule        : Strings
      importedModule       : Bool
      inferredDependencies : FMap Name [(Name,Name)]
      instancename         : Maybe Name
      labels_dist          : FMap Name Names
      local                : Bool
      methods_dist         : FMap Name Names
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap Name Names
      dependencies_collect : FMap Name [(Name,Name)]
      inferredDependencies_collect : FMap Name [(Name,Name)]
      labels_collect       : FMap Name Names
      methods_collect      : FMap Name Names

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Types.Cons:
      self

-}
{-
   local variables for Types.Nil:
      self

-}
-- semantic domain
type T_Types = (Maybe Name) ->
               (FMap Name Names) ->
               (FMap Name Names) ->
               (Strings) ->
               (FMap Name [(Name,Name)]) ->
               (Bool) ->
               (FMap Name [(Name,Name)]) ->
               (FMap Name [(Name,Name)]) ->
               (Maybe Name) ->
               (FMap Name Names) ->
               (FMap Name Names) ->
               (Bool) ->
               (FMap Name Names) ->
               (FMap Name Names) ->
               (Bool) ->
               ( (FMap Name Names),(FMap Name [(Name,Name)]),(FMap Name [(Name,Name)]),(FMap Name Names),(FMap Name Names),(Types))
-- cata
sem_Types :: (Types) ->
             (T_Types)
sem_Types (list) =
    (foldr (sem_Types_Cons) (sem_Types_Nil) ((map sem_Type list)))
sem_Types_Cons :: (T_Type) ->
                  (T_Types) ->
                  (T_Types)
sem_Types_Cons (hd_) (tl_) =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Types)
            _hdIconstructors_collect :: (FMap Name Names)
            _hdIdependencies_collect :: (FMap Name [(Name,Name)])
            _hdIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdIlabels_collect :: (FMap Name Names)
            _hdIlocalDependencies :: ([(Name,Name)])
            _hdImethods_collect :: (FMap Name Names)
            _hdIself :: (Type)
            _hdOclassname :: (Maybe Name)
            _hdOconstructors_collect :: (FMap Name Names)
            _hdOconstructors_dist :: (FMap Name Names)
            _hdOcurrentModule :: (Strings)
            _hdOdependencies_collect :: (FMap Name [(Name,Name)])
            _hdOimportedModule :: (Bool)
            _hdOinferredDependencies :: (FMap Name [(Name,Name)])
            _hdOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _hdOinstancename :: (Maybe Name)
            _hdOlabels_collect :: (FMap Name Names)
            _hdOlabels_dist :: (FMap Name Names)
            _hdOlocal :: (Bool)
            _hdOmethods_collect :: (FMap Name Names)
            _hdOmethods_dist :: (FMap Name Names)
            _hdOtoplevel :: (Bool)
            _tlIconstructors_collect :: (FMap Name Names)
            _tlIdependencies_collect :: (FMap Name [(Name,Name)])
            _tlIinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlIlabels_collect :: (FMap Name Names)
            _tlImethods_collect :: (FMap Name Names)
            _tlIself :: (Types)
            _tlOclassname :: (Maybe Name)
            _tlOconstructors_collect :: (FMap Name Names)
            _tlOconstructors_dist :: (FMap Name Names)
            _tlOcurrentModule :: (Strings)
            _tlOdependencies_collect :: (FMap Name [(Name,Name)])
            _tlOimportedModule :: (Bool)
            _tlOinferredDependencies :: (FMap Name [(Name,Name)])
            _tlOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _tlOinstancename :: (Maybe Name)
            _tlOlabels_collect :: (FMap Name Names)
            _tlOlabels_dist :: (FMap Name Names)
            _tlOlocal :: (Bool)
            _tlOmethods_collect :: (FMap Name Names)
            _tlOmethods_dist :: (FMap Name Names)
            _tlOtoplevel :: (Bool)
            ( _hdIconstructors_collect,_hdIdependencies_collect,_hdIinferredDependencies_collect,_hdIlabels_collect,_hdIlocalDependencies,_hdImethods_collect,_hdIself) =
                (hd_ (_hdOclassname) (_hdOconstructors_collect) (_hdOconstructors_dist) (_hdOcurrentModule) (_hdOdependencies_collect) (_hdOimportedModule) (_hdOinferredDependencies) (_hdOinferredDependencies_collect) (_hdOinstancename) (_hdOlabels_collect) (_hdOlabels_dist) (_hdOlocal) (_hdOmethods_collect) (_hdOmethods_dist) (_hdOtoplevel))
            ( _tlIconstructors_collect,_tlIdependencies_collect,_tlIinferredDependencies_collect,_tlIlabels_collect,_tlImethods_collect,_tlIself) =
                (tl_ (_tlOclassname) (_tlOconstructors_collect) (_tlOconstructors_dist) (_tlOcurrentModule) (_tlOdependencies_collect) (_tlOimportedModule) (_tlOinferredDependencies) (_tlOinferredDependencies_collect) (_tlOinstancename) (_tlOlabels_collect) (_tlOlabels_dist) (_tlOlocal) (_tlOmethods_collect) (_tlOmethods_dist) (_tlOtoplevel))
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOconstructors_collect@_) =
                _tlIconstructors_collect
            -- copy rule (up)
            (_lhsOdependencies_collect@_) =
                _tlIdependencies_collect
            -- copy rule (up)
            (_lhsOinferredDependencies_collect@_) =
                _tlIinferredDependencies_collect
            -- copy rule (up)
            (_lhsOlabels_collect@_) =
                _tlIlabels_collect
            -- copy rule (up)
            (_lhsOmethods_collect@_) =
                _tlImethods_collect
            -- copy rule (down)
            (_hdOclassname@_) =
                _lhsIclassname
            -- copy rule (down)
            (_hdOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (down)
            (_hdOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_hdOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (down)
            (_hdOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (down)
            (_hdOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_hdOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (down)
            (_hdOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (down)
            (_hdOinstancename@_) =
                _lhsIinstancename
            -- copy rule (down)
            (_hdOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (down)
            (_hdOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_hdOlocal@_) =
                _lhsIlocal
            -- copy rule (down)
            (_hdOmethods_collect@_) =
                _lhsImethods_collect
            -- copy rule (down)
            (_hdOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_hdOtoplevel@_) =
                _lhsItoplevel
            -- copy rule (down)
            (_tlOclassname@_) =
                _lhsIclassname
            -- copy rule (chain)
            (_tlOconstructors_collect@_) =
                _hdIconstructors_collect
            -- copy rule (down)
            (_tlOconstructors_dist@_) =
                _lhsIconstructors_dist
            -- copy rule (down)
            (_tlOcurrentModule@_) =
                _lhsIcurrentModule
            -- copy rule (chain)
            (_tlOdependencies_collect@_) =
                _hdIdependencies_collect
            -- copy rule (down)
            (_tlOimportedModule@_) =
                _lhsIimportedModule
            -- copy rule (down)
            (_tlOinferredDependencies@_) =
                _lhsIinferredDependencies
            -- copy rule (chain)
            (_tlOinferredDependencies_collect@_) =
                _hdIinferredDependencies_collect
            -- copy rule (down)
            (_tlOinstancename@_) =
                _lhsIinstancename
            -- copy rule (chain)
            (_tlOlabels_collect@_) =
                _hdIlabels_collect
            -- copy rule (down)
            (_tlOlabels_dist@_) =
                _lhsIlabels_dist
            -- copy rule (down)
            (_tlOlocal@_) =
                _lhsIlocal
            -- copy rule (chain)
            (_tlOmethods_collect@_) =
                _hdImethods_collect
            -- copy rule (down)
            (_tlOmethods_dist@_) =
                _lhsImethods_dist
            -- copy rule (down)
            (_tlOtoplevel@_) =
                _lhsItoplevel
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)
sem_Types_Nil :: (T_Types)
sem_Types_Nil  =
    \ _lhsIclassname
      _lhsIconstructors_collect
      _lhsIconstructors_dist
      _lhsIcurrentModule
      _lhsIdependencies_collect
      _lhsIimportedModule
      _lhsIinferredDependencies
      _lhsIinferredDependencies_collect
      _lhsIinstancename
      _lhsIlabels_collect
      _lhsIlabels_dist
      _lhsIlocal
      _lhsImethods_collect
      _lhsImethods_dist
      _lhsItoplevel ->
        let _lhsOconstructors_collect :: (FMap Name Names)
            _lhsOdependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOinferredDependencies_collect :: (FMap Name [(Name,Name)])
            _lhsOlabels_collect :: (FMap Name Names)
            _lhsOmethods_collect :: (FMap Name Names)
            _lhsOself :: (Types)
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOconstructors_collect@_) =
                _lhsIconstructors_collect
            -- copy rule (chain)
            (_lhsOdependencies_collect@_) =
                _lhsIdependencies_collect
            -- copy rule (chain)
            (_lhsOinferredDependencies_collect@_) =
                _lhsIinferredDependencies_collect
            -- copy rule (chain)
            (_lhsOlabels_collect@_) =
                _lhsIlabels_collect
            -- copy rule (chain)
            (_lhsOmethods_collect@_) =
                _lhsImethods_collect
        in  ( _lhsOconstructors_collect,_lhsOdependencies_collect,_lhsOinferredDependencies_collect,_lhsOlabels_collect,_lhsOmethods_collect,_lhsOself)


