-- do not edit; automatically generated by UU.AG
module StructureTypes where


import AbstractSyntax
import BuildSyntax
import Name
import qualified List
import ErrorUtils
import Utils
import UHA_Range



unitType                         :: Type
unitType                         =  conT unitName

prodType, sumType                :: Type -> Type -> Type
prodType                         =  bopType prodName
sumType                          =  bopType sumName

bopType                          :: Name -> Type -> Type -> Type
bopType opName tl tr             =  let
                                      tpl = parT tl
                                      tpr = parT tr
                                      op  = conT opName
                                    in
                                      appT op [tpl,tpr]

conType, labType                 :: Name -> Type -> Type
conType n                        =  uopType (Type_Con   unknownRange n)
labType n                        =  uopType (Type_Label unknownRange n)

uopType                          :: Type -> Type -> Type
uopType opType ta                =  appT opType [parT ta]



prefixedid :: String -> Name
prefixedid = prefixName . Name_Identifier unknownRange []

lDescrUnion :: [(Name,Declarations)] 
            -> [(Name,Declarations)] 
            -> [(Name,Declarations)]
lDescrUnion =  List.unionBy (\x y -> fst x == fst y)



mkStrType                        :: Name -> Names -> Type -> Declaration
mkStrType nm tvs tp              =  Declaration_Type unknownRange
                                      (SimpleType_SimpleType
				         unknownRange (strName nm) 
                                         (map (\x -> KindAnnotatedName_KindAnnotatedName
                                                       unknownRange x MaybeKind_Nothing
                                              ) tvs
                                         )
			              ) tp

mkidEP                           :: Name -> Names -> Declarations
mkidEP nm tvs                    =  [ {- type signature -}
                                      Declaration_TypeSignature unknownRange
                                        [epName nm] eptype
                                    , {- binding -}
                                      Declaration_FunctionBindings unknownRange
                                        epbinds
                                    ]
  where 
    eptype                       =  appT (conT epTypeName)
                                      [tp nm,tp (strName nm)]

    tp x                         =  if null tvs then
                                      conT x
				    else
                                      parT $ appT (conT x) (map varT tvs)

    epbinds                      =  [simpleFunBinding (epName nm) [] (varE idEPName)]

mkEP                             :: Name -> Name -> ContextItems -> Names
                                 -> FunctionBindings -> FunctionBindings
                                 -> Declarations
mkEP nm nm' ctx tvs from to      =  [ {- type signature -}
                                      Declaration_TypeSignature unknownRange
                                        [epName nm] eptype
                                    , {- binding -}
                                      Declaration_FunctionBindings unknownRange
                                        epbinds
                                    ]
  where 
    eptype_                      =  appT (conT epTypeName)
                                      [tp nm,tp nm']
    eptype                       =  if null ctx then
                                      eptype_
                                    else
                                      Type_Qualified unknownRange ctx eptype_

    tp x                         =  if null tvs then
				      conT x
				    else
				      parT $ appT (conT x) (map varT tvs)

    epbinds                      =  [simpleFunBinding (epName nm) [] eplet]

    eplet                        =  Expression_Let 
                                      unknownRange
                                      [f,t]
                                      (appE (varE epTypeName)
                                         [varE localFromName
                                         ,varE localToName
                                         ]
                                      )

    f                            =  Declaration_FunctionBindings unknownRange from
    t                            =  Declaration_FunctionBindings unknownRange to

localFromName                    =  prefixedid "From"
localToName                      =  prefixedid "To"

fromBinding                      =  simpleFunBinding localFromName
toBinding                        =  simpleFunBinding localToName



unitExp                          :: Expression
unitExp                          =  varE unitunitName

unitPat                          :: Pattern
unitPat                          =  conP  unitunitName []

conExp                           :: Expression -> Expression
conExp e                         =  appE (varE conconName) [e]

conPat                           :: Pattern -> Pattern
conPat p                         =  conP conconName [p]

labExp                           :: Expression -> Expression
labExp e                         =  appE (varE labellabelName) [e]

labPat                           :: Pattern -> Pattern
labPat p                         =  conP labellabelName [p]

prodExp                          :: Expression -> Expression -> Expression
prodExp le re                    =  parE $ infE (varE prodprodName) le re

prodPat                          :: Pattern -> Pattern -> Pattern
prodPat lp rp                    =  parP $ infconP lp prodprodName rp

injectSumExp                     :: Int {- current -} -> Int {- total -}
                                 -> Expression -> Expression
injectSumExp _ 1 e               =  e
injectSumExp 0 _ e               =  appE (varE sumleftName ) [parE e]
injectSumExp 1 2 e               =  appE (varE sumrightName) [parE e]
injectSumExp m n e               =  appE (varE sumrightName)
                                      [parE (injectSumExp (m-1) (n-1) e)]

injectSumPat                     :: Int {- current -} -> Int {- total -}
                                 -> Pattern -> Pattern
injectSumPat _ 1 p               =  p
injectSumPat 0 _ p               =  conP sumleftName  [parP p]
injectSumPat 1 2 p               =  conP sumrightName [parP p]
injectSumPat m n p               =  conP sumrightName
                                      [parP (injectSumPat (m-1) (n-1) p)]


strTypeInternalError           :: a
strTypeInternalError           =  
  internalError "structure type called for illegal TDecl"

epInternalError                :: a
epInternalError                =
  internalError "EP generation called for illegal TDecl"


data Root = Root_Root Declaration



strtype     d                    = (\(x,_,_,_) -> x) $ fst $ sem_Root . Root_Root $ d 
ep          d                    = (\(_,x,_,_) -> x) $ fst $ sem_Root . Root_Root $ d 
contype     d                    = (\(_,_,x,_) -> x) $ fst $ sem_Root . Root_Root $ d 
descriptors d                    = (\(_,_,_,x) -> x) $ fst $ sem_Root . Root_Root $ d
all         d                    =                     fst $ sem_Root . Root_Root $ d

-- Alternative -------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Alternative.Alternative:
      self

-}
{-
   local variables for Alternative.Empty:
      self

-}
-- semantic domain
type T_Alternative = ( (Alternative))
-- cata
sem_Alternative :: (Alternative) ->
                   (T_Alternative)
sem_Alternative ((Alternative_Alternative (_range) (_pattern) (_righthandside))) =
    (sem_Alternative_Alternative ((sem_Range (_range))) ((sem_Pattern (_pattern))) ((sem_RightHandSide (_righthandside))))
sem_Alternative ((Alternative_Empty (_range))) =
    (sem_Alternative_Empty ((sem_Range (_range))))
sem_Alternative_Alternative :: (T_Range) ->
                               (T_Pattern) ->
                               (T_RightHandSide) ->
                               (T_Alternative)
sem_Alternative_Alternative (range_) (pattern_) (righthandside_) =
    let _lhsOself :: (Alternative)
        _rangeIself :: (Range)
        _patternIself :: (Pattern)
        _righthandsideIself :: (RightHandSide)
        ( _rangeIself) =
            (range_ )
        ( _patternIself) =
            (pattern_ )
        ( _righthandsideIself) =
            (righthandside_ )
        -- self rule
        (_self@_) =
            Alternative_Alternative _rangeIself _patternIself _righthandsideIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Alternative_Empty :: (T_Range) ->
                         (T_Alternative)
sem_Alternative_Empty (range_) =
    let _lhsOself :: (Alternative)
        _rangeIself :: (Range)
        ( _rangeIself) =
            (range_ )
        -- self rule
        (_self@_) =
            Alternative_Empty _rangeIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- Alternatives ------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Alternatives.Cons:
      self

-}
{-
   local variables for Alternatives.Nil:
      self

-}
-- semantic domain
type T_Alternatives = ( (Alternatives))
-- cata
sem_Alternatives :: (Alternatives) ->
                    (T_Alternatives)
sem_Alternatives (list) =
    (foldr (sem_Alternatives_Cons) (sem_Alternatives_Nil) ((map sem_Alternative list)))
sem_Alternatives_Cons :: (T_Alternative) ->
                         (T_Alternatives) ->
                         (T_Alternatives)
sem_Alternatives_Cons (hd_) (tl_) =
    let _lhsOself :: (Alternatives)
        _hdIself :: (Alternative)
        _tlIself :: (Alternatives)
        ( _hdIself) =
            (hd_ )
        ( _tlIself) =
            (tl_ )
        -- self rule
        (_self@_) =
            (:) _hdIself _tlIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Alternatives_Nil :: (T_Alternatives)
sem_Alternatives_Nil  =
    let _lhsOself :: (Alternatives)
        -- self rule
        (_self@_) =
            []
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- AnnotatedType -----------------------------------------------
{-
   inherited attributes:

   chained attributes:
      typename             : Name
      vars                 : Names

   synthesised attributes:
      from                 : Expression
      from_plain           : Pattern
      self                 : SELF
      strict               : Bool
      strtype              : Types
      to                   : Pattern
      to_plain             : Expression

-}
{-
   local variables for AnnotatedType.AnnotatedType:
      from_plain
      from
      to_plain
      to
      var
      self

-}
-- semantic domain
type T_AnnotatedType = (Name) ->
                       (Names) ->
                       ( (Expression),(Pattern),(AnnotatedType),(Bool),(Types),(Pattern),(Expression),(Name),(Names))
-- cata
sem_AnnotatedType :: (AnnotatedType) ->
                     (T_AnnotatedType)
sem_AnnotatedType ((AnnotatedType_AnnotatedType (_range) (_strict) (_type))) =
    (sem_AnnotatedType_AnnotatedType ((sem_Range (_range))) (_strict) ((sem_Type (_type))))
sem_AnnotatedType_AnnotatedType :: (T_Range) ->
                                   (Bool) ->
                                   (T_Type) ->
                                   (T_AnnotatedType)
sem_AnnotatedType_AnnotatedType (range_) (strict_) (type_) =
    \ _lhsItypename
      _lhsIvars ->
        let _lhsOfrom :: (Expression)
            _lhsOfrom_plain :: (Pattern)
            _lhsOself :: (AnnotatedType)
            _lhsOstrict :: (Bool)
            _lhsOstrtype :: (Types)
            _lhsOto :: (Pattern)
            _lhsOto_plain :: (Expression)
            _lhsOtypename :: (Name)
            _lhsOvars :: (Names)
            _rangeIself :: (Range)
            _typeIself :: (Type)
            ( _rangeIself) =
                (range_ )
            ( _typeIself) =
                (type_ )
            -- "StructureTypes.lag"(line 133, column 9)
            (_lhsOstrict@_) =
                strict_
            -- "StructureTypes.lag"(line 498, column 9)
            (_from_plain@_) =
                _to
            -- "StructureTypes.lag"(line 497, column 9)
            (_from@_) =
                varE _var
            -- "StructureTypes.lag"(line 496, column 9)
            (_to_plain@_) =
                _from
            -- "StructureTypes.lag"(line 495, column 9)
            (_to@_) =
                varP _var
            -- "StructureTypes.lag"(line 494, column 9)
            (_lhsOstrtype@_) =
                [_typeIself]
            -- "StructureTypes.lag"(line 493, column 9)
            (_lhsOvars@_) =
                tail _lhsIvars
            -- "StructureTypes.lag"(line 492, column 9)
            (_var@_) =
                head _lhsIvars
            -- self rule
            (_self@_) =
                AnnotatedType_AnnotatedType _rangeIself strict_ _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOfrom@_) =
                _from
            -- copy rule (up)
            (_lhsOfrom_plain@_) =
                _from_plain
            -- copy rule (up)
            (_lhsOto@_) =
                _to
            -- copy rule (up)
            (_lhsOto_plain@_) =
                _to_plain
            -- copy rule (chain)
            (_lhsOtypename@_) =
                _lhsItypename
        in  ( _lhsOfrom,_lhsOfrom_plain,_lhsOself,_lhsOstrict,_lhsOstrtype,_lhsOto,_lhsOto_plain,_lhsOtypename,_lhsOvars)
-- AnnotatedTypes ----------------------------------------------
{-
   inherited attributes:

   chained attributes:
      typename             : Name
      vars                 : Names

   synthesised attributes:
      from                 : Expressions
      from_plain           : Patterns
      self                 : SELF
      strtype              : Types
      to                   : Patterns
      to_plain             : Expressions

-}
{-
   local variables for AnnotatedTypes.Cons:
      self

-}
{-
   local variables for AnnotatedTypes.Nil:
      self

-}
-- semantic domain
type T_AnnotatedTypes = (Name) ->
                        (Names) ->
                        ( (Expressions),(Patterns),(AnnotatedTypes),(Types),(Patterns),(Expressions),(Name),(Names))
-- cata
sem_AnnotatedTypes :: (AnnotatedTypes) ->
                      (T_AnnotatedTypes)
sem_AnnotatedTypes (list) =
    (foldr (sem_AnnotatedTypes_Cons) (sem_AnnotatedTypes_Nil) ((map sem_AnnotatedType list)))
sem_AnnotatedTypes_Cons :: (T_AnnotatedType) ->
                           (T_AnnotatedTypes) ->
                           (T_AnnotatedTypes)
sem_AnnotatedTypes_Cons (hd_) (tl_) =
    \ _lhsItypename
      _lhsIvars ->
        let _lhsOfrom :: (Expressions)
            _lhsOfrom_plain :: (Patterns)
            _lhsOself :: (AnnotatedTypes)
            _lhsOstrtype :: (Types)
            _lhsOto :: (Patterns)
            _lhsOto_plain :: (Expressions)
            _lhsOtypename :: (Name)
            _lhsOvars :: (Names)
            _hdIfrom :: (Expression)
            _hdIfrom_plain :: (Pattern)
            _hdIself :: (AnnotatedType)
            _hdIstrict :: (Bool)
            _hdIstrtype :: (Types)
            _hdIto :: (Pattern)
            _hdIto_plain :: (Expression)
            _hdItypename :: (Name)
            _hdIvars :: (Names)
            _hdOtypename :: (Name)
            _hdOvars :: (Names)
            _tlIfrom :: (Expressions)
            _tlIfrom_plain :: (Patterns)
            _tlIself :: (AnnotatedTypes)
            _tlIstrtype :: (Types)
            _tlIto :: (Patterns)
            _tlIto_plain :: (Expressions)
            _tlItypename :: (Name)
            _tlIvars :: (Names)
            _tlOtypename :: (Name)
            _tlOvars :: (Names)
            ( _hdIfrom,_hdIfrom_plain,_hdIself,_hdIstrict,_hdIstrtype,_hdIto,_hdIto_plain,_hdItypename,_hdIvars) =
                (hd_ (_hdOtypename) (_hdOvars))
            ( _tlIfrom,_tlIfrom_plain,_tlIself,_tlIstrtype,_tlIto,_tlIto_plain,_tlItypename,_tlIvars) =
                (tl_ (_tlOtypename) (_tlOvars))
            -- use rule
            (_lhsOfrom@_) =
                _hdIfrom : _tlIfrom
            -- use rule
            (_lhsOfrom_plain@_) =
                _hdIfrom_plain : _tlIfrom_plain
            -- use rule
            (_lhsOstrtype@_) =
                _hdIstrtype ++ _tlIstrtype
            -- use rule
            (_lhsOto@_) =
                _hdIto : _tlIto
            -- use rule
            (_lhsOto_plain@_) =
                _hdIto_plain : _tlIto_plain
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOtypename@_) =
                _tlItypename
            -- copy rule (up)
            (_lhsOvars@_) =
                _tlIvars
            -- copy rule (down)
            (_hdOtypename@_) =
                _lhsItypename
            -- copy rule (down)
            (_hdOvars@_) =
                _lhsIvars
            -- copy rule (chain)
            (_tlOtypename@_) =
                _hdItypename
            -- copy rule (chain)
            (_tlOvars@_) =
                _hdIvars
        in  ( _lhsOfrom,_lhsOfrom_plain,_lhsOself,_lhsOstrtype,_lhsOto,_lhsOto_plain,_lhsOtypename,_lhsOvars)
sem_AnnotatedTypes_Nil :: (T_AnnotatedTypes)
sem_AnnotatedTypes_Nil  =
    \ _lhsItypename
      _lhsIvars ->
        let _lhsOfrom :: (Expressions)
            _lhsOfrom_plain :: (Patterns)
            _lhsOself :: (AnnotatedTypes)
            _lhsOstrtype :: (Types)
            _lhsOto :: (Patterns)
            _lhsOto_plain :: (Expressions)
            _lhsOtypename :: (Name)
            _lhsOvars :: (Names)
            -- use rule
            (_lhsOfrom@_) =
                []
            -- use rule
            (_lhsOfrom_plain@_) =
                []
            -- use rule
            (_lhsOstrtype@_) =
                []
            -- use rule
            (_lhsOto@_) =
                []
            -- use rule
            (_lhsOto_plain@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOtypename@_) =
                _lhsItypename
            -- copy rule (chain)
            (_lhsOvars@_) =
                _lhsIvars
        in  ( _lhsOfrom,_lhsOfrom_plain,_lhsOself,_lhsOstrtype,_lhsOto,_lhsOto_plain,_lhsOtypename,_lhsOvars)
-- Body --------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Body.Body:
      self

-}
-- semantic domain
type T_Body = ( (Body))
-- cata
sem_Body :: (Body) ->
            (T_Body)
sem_Body ((Body_Body (_range) (_importdeclarations) (_declarations))) =
    (sem_Body_Body ((sem_Range (_range))) ((sem_ImportDeclarations (_importdeclarations))) ((sem_Declarations (_declarations))))
sem_Body_Body :: (T_Range) ->
                 (T_ImportDeclarations) ->
                 (T_Declarations) ->
                 (T_Body)
sem_Body_Body (range_) (importdeclarations_) (declarations_) =
    let _lhsOself :: (Body)
        _rangeIself :: (Range)
        _importdeclarationsIself :: (ImportDeclarations)
        _declarationsIself :: (Declarations)
        ( _rangeIself) =
            (range_ )
        ( _importdeclarationsIself) =
            (importdeclarations_ )
        ( _declarationsIself) =
            (declarations_ )
        -- self rule
        (_self@_) =
            Body_Body _rangeIself _importdeclarationsIself _declarationsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- Constructor -------------------------------------------------
{-
   inherited attributes:
      nrOfCon              : Int
      totalNrOfCons        : Int
      typename             : Name
      typevariables        : Names

   chained attributes:

   synthesised attributes:
      condescr             : Type
      contype              : Declarations
      descriptors          : Declarations
      ep                   : Declarations
      from                 : FunctionBinding
      labDescriptors       : [(Name,Declarations)]
      self                 : SELF
      strtype              : Declarations
      to                   : FunctionBinding

-}
{-
   local variables for Constructor.Constructor:
      ep
      toC
      fromC
      body
      self

-}
{-
   local variables for Constructor.Infix:
      ep
      toC
      fromC
      body
      self

-}
{-
   local variables for Constructor.Record:
      ep
      toC
      fromC
      body
      self

-}
-- semantic domain
type T_Constructor = (Int) ->
                     (Int) ->
                     (Name) ->
                     (Names) ->
                     ( (Type),(Declarations),(Declarations),(Declarations),(FunctionBinding),([(Name,Declarations)]),(Constructor),(Declarations),(FunctionBinding))
-- cata
sem_Constructor :: (Constructor) ->
                   (T_Constructor)
sem_Constructor ((Constructor_Constructor (_range) (_constructor) (_types))) =
    (sem_Constructor_Constructor ((sem_Range (_range))) ((sem_Name (_constructor))) ((sem_AnnotatedTypes (_types))))
sem_Constructor ((Constructor_Infix (_range) (_leftType) (_constructorOperator) (_rightType))) =
    (sem_Constructor_Infix ((sem_Range (_range))) ((sem_AnnotatedType (_leftType))) ((sem_Name (_constructorOperator))) ((sem_AnnotatedType (_rightType))))
sem_Constructor ((Constructor_Record (_range) (_constructor) (_fieldDeclarations))) =
    (sem_Constructor_Record ((sem_Range (_range))) ((sem_Name (_constructor))) ((sem_FieldDeclarations (_fieldDeclarations))))
sem_Constructor_Constructor :: (T_Range) ->
                               (T_Name) ->
                               (T_AnnotatedTypes) ->
                               (T_Constructor)
sem_Constructor_Constructor (range_) (constructor_) (types_) =
    \ _lhsInrOfCon
      _lhsItotalNrOfCons
      _lhsItypename
      _lhsItypevariables ->
        let _lhsOcondescr :: (Type)
            _lhsOcontype :: (Declarations)
            _lhsOdescriptors :: (Declarations)
            _lhsOep :: (Declarations)
            _lhsOfrom :: (FunctionBinding)
            _lhsOlabDescriptors :: ([(Name,Declarations)])
            _lhsOself :: (Constructor)
            _lhsOstrtype :: (Declarations)
            _lhsOto :: (FunctionBinding)
            _rangeIself :: (Range)
            _constructorIself :: (Name)
            _typesIfrom :: (Expressions)
            _typesIfrom_plain :: (Patterns)
            _typesIself :: (AnnotatedTypes)
            _typesIstrtype :: (Types)
            _typesIto :: (Patterns)
            _typesIto_plain :: (Expressions)
            _typesItypename :: (Name)
            _typesIvars :: (Names)
            _typesOtypename :: (Name)
            _typesOvars :: (Names)
            ( _rangeIself) =
                (range_ )
            ( _constructorIself) =
                (constructor_ )
            ( _typesIfrom,_typesIfrom_plain,_typesIself,_typesIstrtype,_typesIto,_typesIto_plain,_typesItypename,_typesIvars) =
                (types_ (_typesOtypename) (_typesOvars))
            -- "StructureTypes.lag"(line 272, column 9)
            (_lhsOcontype@_) =
                [Declaration_Type unknownRange
                   (SimpleType_SimpleType
                      unknownRange
                      (concaseName _constructorIself)
                      (map (\n -> KindAnnotatedName_KindAnnotatedName
                                    unknownRange
                                    n
                                    MaybeKind_Nothing
                           )
                           _lhsItypevariables
                      )
                   )
                   (appT (conT _lhsItypename)
                      (map varT _lhsItypevariables)
                   )
                ]
            -- "StructureTypes.lag"(line 266, column 9)
            (_lhsOcondescr@_) =
                let
                  body = appT (conT (concaseName _constructorIself))
                            (map varT _lhsItypevariables)
                in
                  conType _constructorIself body
            -- "StructureTypes.lag"(line 260, column 9)
            (_lhsOdescriptors@_) =
                mkCondescrDecl
                  _constructorIself _lhsItypename
                  (length _typesIself)
                  (_lhsInrOfCon,_lhsItotalNrOfCons)
                  False
            -- "StructureTypes.lag"(line 250, column 9)
            (_ep@_) =
                let
                  oriname = concaseName _constructorIself
                  strname = strName oriname
                in
                  mkEP
                    oriname strname
                    []
                    _lhsItypevariables
                    [_fromC] [_toC]
            -- "StructureTypes.lag"(line 243, column 9)
            (_toC@_) =
                let
                  l     = [ foldr01 unitPat prodPat _typesIto ]
                  r     = appE (conE _constructorIself) _typesIto_plain
                in
                  toBinding l r
            -- "StructureTypes.lag"(line 235, column 9)
            (_fromC@_) =
                let
                  l     = [ (if null _typesIself then id else parP)
                          $ conP _constructorIself _typesIfrom_plain
                          ]
                  r     = foldr01 unitExp prodExp _typesIfrom
                in
                  fromBinding l r
            -- "StructureTypes.lag"(line 224, column 9)
            (_lhsOto@_) =
                let
                  var   = prefixedid "A"
                  l     = [ Pattern_Parenthesized unknownRange
                          $ injectSumPat _lhsInrOfCon _lhsItotalNrOfCons
                              cexpr
                          ]
                  r     = varE var
                  cexpr = conPat (varP var)
                in
                  toBinding l r
            -- "StructureTypes.lag"(line 212, column 9)
            (_lhsOfrom@_) =
                let
                  var   = prefixedid "A"
                  l     = [ Pattern_As unknownRange var
                          $ (if null _typesIself then id else parP)
                          $ conP _constructorIself _typesIfrom_plain
                          ]
                  r     = injectSumExp _lhsInrOfCon _lhsItotalNrOfCons
                            cexpr
                  cexpr = conExp (varE var)
                in
                  fromBinding l r
            -- "StructureTypes.lag"(line 209, column 9)
            (_typesOvars@_) =
                prefixedVarNames
            -- "StructureTypes.lag"(line 207, column 9)
            (_lhsOstrtype@_) =
                [mkStrType (concaseName _constructorIself) _lhsItypevariables _body]
            -- "StructureTypes.lag"(line 206, column 9)
            (_body@_) =
                foldr01 unitType prodType $ _typesIstrtype
            -- use rule
            (_lhsOlabDescriptors@_) =
                []
            -- self rule
            (_self@_) =
                Constructor_Constructor _rangeIself _constructorIself _typesIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOep@_) =
                _ep
            -- copy rule (down)
            (_typesOtypename@_) =
                _lhsItypename
        in  ( _lhsOcondescr,_lhsOcontype,_lhsOdescriptors,_lhsOep,_lhsOfrom,_lhsOlabDescriptors,_lhsOself,_lhsOstrtype,_lhsOto)
sem_Constructor_Infix :: (T_Range) ->
                         (T_AnnotatedType) ->
                         (T_Name) ->
                         (T_AnnotatedType) ->
                         (T_Constructor)
sem_Constructor_Infix (range_) (leftType_) (constructorOperator_) (rightType_) =
    \ _lhsInrOfCon
      _lhsItotalNrOfCons
      _lhsItypename
      _lhsItypevariables ->
        let _lhsOcondescr :: (Type)
            _lhsOcontype :: (Declarations)
            _lhsOdescriptors :: (Declarations)
            _lhsOep :: (Declarations)
            _lhsOfrom :: (FunctionBinding)
            _lhsOlabDescriptors :: ([(Name,Declarations)])
            _lhsOself :: (Constructor)
            _lhsOstrtype :: (Declarations)
            _lhsOto :: (FunctionBinding)
            _rangeIself :: (Range)
            _leftTypeIfrom :: (Expression)
            _leftTypeIfrom_plain :: (Pattern)
            _leftTypeIself :: (AnnotatedType)
            _leftTypeIstrict :: (Bool)
            _leftTypeIstrtype :: (Types)
            _leftTypeIto :: (Pattern)
            _leftTypeIto_plain :: (Expression)
            _leftTypeItypename :: (Name)
            _leftTypeIvars :: (Names)
            _leftTypeOtypename :: (Name)
            _leftTypeOvars :: (Names)
            _constructorOperatorIself :: (Name)
            _rightTypeIfrom :: (Expression)
            _rightTypeIfrom_plain :: (Pattern)
            _rightTypeIself :: (AnnotatedType)
            _rightTypeIstrict :: (Bool)
            _rightTypeIstrtype :: (Types)
            _rightTypeIto :: (Pattern)
            _rightTypeIto_plain :: (Expression)
            _rightTypeItypename :: (Name)
            _rightTypeIvars :: (Names)
            _rightTypeOtypename :: (Name)
            _rightTypeOvars :: (Names)
            ( _rangeIself) =
                (range_ )
            ( _leftTypeIfrom,_leftTypeIfrom_plain,_leftTypeIself,_leftTypeIstrict,_leftTypeIstrtype,_leftTypeIto,_leftTypeIto_plain,_leftTypeItypename,_leftTypeIvars) =
                (leftType_ (_leftTypeOtypename) (_leftTypeOvars))
            ( _constructorOperatorIself) =
                (constructorOperator_ )
            ( _rightTypeIfrom,_rightTypeIfrom_plain,_rightTypeIself,_rightTypeIstrict,_rightTypeIstrtype,_rightTypeIto,_rightTypeIto_plain,_rightTypeItypename,_rightTypeIvars) =
                (rightType_ (_rightTypeOtypename) (_rightTypeOvars))
            -- "StructureTypes.lag"(line 373, column 9)
            (_lhsOcontype@_) =
                [Declaration_Type unknownRange
                   (SimpleType_SimpleType
                      unknownRange
                      (concaseName _constructorOperatorIself)
                      (map (\n -> KindAnnotatedName_KindAnnotatedName
                                    unknownRange
                                    n
                                    MaybeKind_Nothing
                           )
                           _lhsItypevariables
                      )
                   )
                   (appT (conT _lhsItypename)
                      (map varT _lhsItypevariables)
                   )
                ]
            -- "StructureTypes.lag"(line 367, column 9)
            (_lhsOcondescr@_) =
                let
                  body = appT (conT (concaseName _constructorOperatorIself))
                            (map varT _lhsItypevariables)
                in
                  conType _constructorOperatorIself body
            -- "StructureTypes.lag"(line 361, column 9)
            (_lhsOdescriptors@_) =
                mkCondescrDecl
                  _constructorOperatorIself _lhsItypename
                  2
                  (_lhsInrOfCon,_lhsItotalNrOfCons)
                  False
            -- "StructureTypes.lag"(line 350, column 9)
            (_ep@_) =
                let
                  oriname = concaseName _constructorOperatorIself
                  strname = strName oriname
                in
                  mkEP
                    oriname strname
                    []
                    _lhsItypevariables
                    [_fromC] [_toC]
            -- "StructureTypes.lag"(line 338, column 9)
            (_toC@_) =
                let
                  l     = [ foldr01 unitPat prodPat
                              [_leftTypeIto,_rightTypeIto]
                          ]
                  r     = infE
                            (conE _constructorOperatorIself)
                            _leftTypeIto_plain
                            _rightTypeIto_plain
                in
                  toBinding l r
            -- "StructureTypes.lag"(line 326, column 9)
            (_fromC@_) =
                let
                  l     = [ parP
                          $ Pattern_InfixConstructor unknownRange
                              _leftTypeIfrom_plain
                              _constructorOperatorIself
                              _rightTypeIfrom_plain
                          ]
                  r     = foldr01 unitExp prodExp
                            [_leftTypeIfrom,_rightTypeIfrom]
                in
                  fromBinding l r
            -- "StructureTypes.lag"(line 315, column 9)
            (_lhsOto@_) =
                let
                  var   = prefixedid "A"
                  l     = [ Pattern_Parenthesized unknownRange
                          $ injectSumPat _lhsInrOfCon _lhsItotalNrOfCons
                              cexpr
                          ]
                  r     = varE var
                  cexpr = conPat (varP var)
                in
                  toBinding l r
            -- "StructureTypes.lag"(line 300, column 9)
            (_lhsOfrom@_) =
                let
                  var   = prefixedid "A"
                  l     = [ Pattern_As unknownRange var
                          $ parP
                          $ Pattern_InfixConstructor unknownRange
                              _leftTypeIfrom_plain
                              _constructorOperatorIself
                              _rightTypeIfrom_plain
                          ]
                  r     = injectSumExp _lhsInrOfCon _lhsItotalNrOfCons
                            cexpr
                  cexpr = conExp (varE var)
                in
                  fromBinding l r
            -- "StructureTypes.lag"(line 297, column 9)
            (_rightTypeOvars@_) =
                _leftTypeIvars
            -- "StructureTypes.lag"(line 296, column 9)
            (_leftTypeOvars@_) =
                prefixedVarNames
            -- "StructureTypes.lag"(line 294, column 9)
            (_lhsOstrtype@_) =
                [mkStrType (concaseName _constructorOperatorIself) _lhsItypevariables _body]
            -- "StructureTypes.lag"(line 292, column 9)
            (_body@_) =
                foldr01 unitType prodType
                  $ _leftTypeIstrtype ++ _rightTypeIstrtype
            -- use rule
            (_lhsOlabDescriptors@_) =
                []
            -- self rule
            (_self@_) =
                Constructor_Infix _rangeIself _leftTypeIself _constructorOperatorIself _rightTypeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOep@_) =
                _ep
            -- copy rule (down)
            (_leftTypeOtypename@_) =
                _lhsItypename
            -- copy rule (chain)
            (_rightTypeOtypename@_) =
                _leftTypeItypename
        in  ( _lhsOcondescr,_lhsOcontype,_lhsOdescriptors,_lhsOep,_lhsOfrom,_lhsOlabDescriptors,_lhsOself,_lhsOstrtype,_lhsOto)
sem_Constructor_Record :: (T_Range) ->
                          (T_Name) ->
                          (T_FieldDeclarations) ->
                          (T_Constructor)
sem_Constructor_Record (range_) (constructor_) (fieldDeclarations_) =
    \ _lhsInrOfCon
      _lhsItotalNrOfCons
      _lhsItypename
      _lhsItypevariables ->
        let _lhsOcondescr :: (Type)
            _lhsOcontype :: (Declarations)
            _lhsOdescriptors :: (Declarations)
            _lhsOep :: (Declarations)
            _lhsOfrom :: (FunctionBinding)
            _lhsOlabDescriptors :: ([(Name,Declarations)])
            _lhsOself :: (Constructor)
            _lhsOstrtype :: (Declarations)
            _lhsOto :: (FunctionBinding)
            _rangeIself :: (Range)
            _constructorIself :: (Name)
            _fieldDeclarationsIdescriptors :: (Declarations)
            _fieldDeclarationsIfrom :: (Expressions)
            _fieldDeclarationsIfrom_plain :: (Patterns)
            _fieldDeclarationsIlabDescriptors :: ([(Name,Declarations)])
            _fieldDeclarationsIself :: (FieldDeclarations)
            _fieldDeclarationsIstrtype :: (Types)
            _fieldDeclarationsIto :: (Patterns)
            _fieldDeclarationsIto_plain :: (Expressions)
            _fieldDeclarationsItypename :: (Name)
            _fieldDeclarationsIvars :: (Names)
            _fieldDeclarationsOtypename :: (Name)
            _fieldDeclarationsOvars :: (Names)
            ( _rangeIself) =
                (range_ )
            ( _constructorIself) =
                (constructor_ )
            ( _fieldDeclarationsIdescriptors,_fieldDeclarationsIfrom,_fieldDeclarationsIfrom_plain,_fieldDeclarationsIlabDescriptors,_fieldDeclarationsIself,_fieldDeclarationsIstrtype,_fieldDeclarationsIto,_fieldDeclarationsIto_plain,_fieldDeclarationsItypename,_fieldDeclarationsIvars) =
                (fieldDeclarations_ (_fieldDeclarationsOtypename) (_fieldDeclarationsOvars))
            -- "StructureTypes.lag"(line 461, column 9)
            (_lhsOcontype@_) =
                [Declaration_Type unknownRange
                   (SimpleType_SimpleType
                      unknownRange
                      (concaseName _constructorIself)
                      (map (\n -> KindAnnotatedName_KindAnnotatedName
                                    unknownRange
                                    n
                                    MaybeKind_Nothing
                           )
                           _lhsItypevariables
                      )
                   )
                   (appT (conT _lhsItypename)
                      (map varT _lhsItypevariables)
                   )
                ]
            -- "StructureTypes.lag"(line 455, column 9)
            (_lhsOcondescr@_) =
                let
                  body = appT (conT (concaseName _constructorIself))
                            (map varT _lhsItypevariables)
                in
                  conType _constructorIself body
            -- "StructureTypes.lag"(line 448, column 9)
            (_lhsOdescriptors@_) =
                mkCondescrDecl
                  _constructorIself _lhsItypename
                  (length _fieldDeclarationsIself)
                  (_lhsInrOfCon,_lhsItotalNrOfCons)
                  True
                 ++ _fieldDeclarationsIdescriptors
            -- "StructureTypes.lag"(line 437, column 9)
            (_ep@_) =
                let
                  oriname = concaseName _constructorIself
                  strname = strName oriname
                in
                  mkEP
                    oriname strname
                    []
                    _lhsItypevariables
                    [_fromC] [_toC]
            -- "StructureTypes.lag"(line 430, column 9)
            (_toC@_) =
                let
                  l     = [ foldr01 unitPat prodPat _fieldDeclarationsIto ]
                  r     = appE (conE _constructorIself) _fieldDeclarationsIto_plain
                in
                  toBinding l r
            -- "StructureTypes.lag"(line 422, column 9)
            (_fromC@_) =
                let
                  l     = [ (if null _fieldDeclarationsIself then id else parP)
                          $ conP _constructorIself _fieldDeclarationsIfrom_plain
                          ]
                  r     = foldr01 unitExp prodExp _fieldDeclarationsIfrom
                in
                  fromBinding l r
            -- "StructureTypes.lag"(line 411, column 9)
            (_lhsOto@_) =
                let
                  var   = prefixedid "A"
                  l     = [ Pattern_Parenthesized unknownRange
                          $ injectSumPat _lhsInrOfCon _lhsItotalNrOfCons
                              cexpr
                          ]
                  r     = varE var
                  cexpr = conPat (varP var)
                in
                  toBinding l r
            -- "StructureTypes.lag"(line 399, column 9)
            (_lhsOfrom@_) =
                let
                  var   = prefixedid "A"
                  l     = [ Pattern_As unknownRange var
                          $ (if null _fieldDeclarationsIself then id else parP)
                          $ conP _constructorIself _fieldDeclarationsIfrom_plain
                          ]
                  r     = injectSumExp _lhsInrOfCon _lhsItotalNrOfCons
                            cexpr
                  cexpr = conExp (varE var)
                in
                  fromBinding l r
            -- "StructureTypes.lag"(line 396, column 9)
            (_fieldDeclarationsOvars@_) =
                prefixedVarNames
            -- "StructureTypes.lag"(line 394, column 9)
            (_lhsOstrtype@_) =
                [mkStrType (concaseName _constructorIself) _lhsItypevariables _body]
            -- "StructureTypes.lag"(line 393, column 9)
            (_body@_) =
                foldr01 unitType prodType $ _fieldDeclarationsIstrtype
            -- use rule
            (_lhsOlabDescriptors@_) =
                _fieldDeclarationsIlabDescriptors
            -- self rule
            (_self@_) =
                Constructor_Record _rangeIself _constructorIself _fieldDeclarationsIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOep@_) =
                _ep
            -- copy rule (down)
            (_fieldDeclarationsOtypename@_) =
                _lhsItypename
        in  ( _lhsOcondescr,_lhsOcontype,_lhsOdescriptors,_lhsOep,_lhsOfrom,_lhsOlabDescriptors,_lhsOself,_lhsOstrtype,_lhsOto)
-- Constructors ------------------------------------------------
{-
   inherited attributes:
      nrOfCon              : Int
      totalNrOfCons        : Int
      typename             : Name
      typevariables        : Names

   chained attributes:

   synthesised attributes:
      condescr             : Types
      contype              : Declarations
      descriptors          : Declarations
      ep                   : Declarations
      from                 : FunctionBindings
      labDescriptors       : [(Name,Declarations)]
      self                 : SELF
      strtype              : Declarations
      to                   : FunctionBindings

-}
{-
   local variables for Constructors.Cons:
      self

-}
{-
   local variables for Constructors.Nil:
      self

-}
-- semantic domain
type T_Constructors = (Int) ->
                      (Int) ->
                      (Name) ->
                      (Names) ->
                      ( (Types),(Declarations),(Declarations),(Declarations),(FunctionBindings),([(Name,Declarations)]),(Constructors),(Declarations),(FunctionBindings))
-- cata
sem_Constructors :: (Constructors) ->
                    (T_Constructors)
sem_Constructors (list) =
    (foldr (sem_Constructors_Cons) (sem_Constructors_Nil) ((map sem_Constructor list)))
sem_Constructors_Cons :: (T_Constructor) ->
                         (T_Constructors) ->
                         (T_Constructors)
sem_Constructors_Cons (hd_) (tl_) =
    \ _lhsInrOfCon
      _lhsItotalNrOfCons
      _lhsItypename
      _lhsItypevariables ->
        let _lhsOcondescr :: (Types)
            _lhsOcontype :: (Declarations)
            _lhsOdescriptors :: (Declarations)
            _lhsOep :: (Declarations)
            _lhsOfrom :: (FunctionBindings)
            _lhsOlabDescriptors :: ([(Name,Declarations)])
            _lhsOself :: (Constructors)
            _lhsOstrtype :: (Declarations)
            _lhsOto :: (FunctionBindings)
            _hdIcondescr :: (Type)
            _hdIcontype :: (Declarations)
            _hdIdescriptors :: (Declarations)
            _hdIep :: (Declarations)
            _hdIfrom :: (FunctionBinding)
            _hdIlabDescriptors :: ([(Name,Declarations)])
            _hdIself :: (Constructor)
            _hdIstrtype :: (Declarations)
            _hdIto :: (FunctionBinding)
            _hdOnrOfCon :: (Int)
            _hdOtotalNrOfCons :: (Int)
            _hdOtypename :: (Name)
            _hdOtypevariables :: (Names)
            _tlIcondescr :: (Types)
            _tlIcontype :: (Declarations)
            _tlIdescriptors :: (Declarations)
            _tlIep :: (Declarations)
            _tlIfrom :: (FunctionBindings)
            _tlIlabDescriptors :: ([(Name,Declarations)])
            _tlIself :: (Constructors)
            _tlIstrtype :: (Declarations)
            _tlIto :: (FunctionBindings)
            _tlOnrOfCon :: (Int)
            _tlOtotalNrOfCons :: (Int)
            _tlOtypename :: (Name)
            _tlOtypevariables :: (Names)
            ( _hdIcondescr,_hdIcontype,_hdIdescriptors,_hdIep,_hdIfrom,_hdIlabDescriptors,_hdIself,_hdIstrtype,_hdIto) =
                (hd_ (_hdOnrOfCon) (_hdOtotalNrOfCons) (_hdOtypename) (_hdOtypevariables))
            ( _tlIcondescr,_tlIcontype,_tlIdescriptors,_tlIep,_tlIfrom,_tlIlabDescriptors,_tlIself,_tlIstrtype,_tlIto) =
                (tl_ (_tlOnrOfCon) (_tlOtotalNrOfCons) (_tlOtypename) (_tlOtypevariables))
            -- "StructureTypes.lag"(line 169, column 9)
            (_tlOnrOfCon@_) =
                _lhsInrOfCon + 1
            -- use rule
            (_lhsOcondescr@_) =
                _hdIcondescr : _tlIcondescr
            -- use rule
            (_lhsOcontype@_) =
                _hdIcontype ++ _tlIcontype
            -- use rule
            (_lhsOdescriptors@_) =
                _hdIdescriptors ++ _tlIdescriptors
            -- use rule
            (_lhsOep@_) =
                _hdIep ++ _tlIep
            -- use rule
            (_lhsOfrom@_) =
                _hdIfrom : _tlIfrom
            -- use rule
            (_lhsOlabDescriptors@_) =
                _hdIlabDescriptors `lDescrUnion` _tlIlabDescriptors
            -- use rule
            (_lhsOstrtype@_) =
                _hdIstrtype ++ _tlIstrtype
            -- use rule
            (_lhsOto@_) =
                _hdIto : _tlIto
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (down)
            (_hdOnrOfCon@_) =
                _lhsInrOfCon
            -- copy rule (down)
            (_hdOtotalNrOfCons@_) =
                _lhsItotalNrOfCons
            -- copy rule (down)
            (_hdOtypename@_) =
                _lhsItypename
            -- copy rule (down)
            (_hdOtypevariables@_) =
                _lhsItypevariables
            -- copy rule (down)
            (_tlOtotalNrOfCons@_) =
                _lhsItotalNrOfCons
            -- copy rule (down)
            (_tlOtypename@_) =
                _lhsItypename
            -- copy rule (down)
            (_tlOtypevariables@_) =
                _lhsItypevariables
        in  ( _lhsOcondescr,_lhsOcontype,_lhsOdescriptors,_lhsOep,_lhsOfrom,_lhsOlabDescriptors,_lhsOself,_lhsOstrtype,_lhsOto)
sem_Constructors_Nil :: (T_Constructors)
sem_Constructors_Nil  =
    \ _lhsInrOfCon
      _lhsItotalNrOfCons
      _lhsItypename
      _lhsItypevariables ->
        let _lhsOcondescr :: (Types)
            _lhsOcontype :: (Declarations)
            _lhsOdescriptors :: (Declarations)
            _lhsOep :: (Declarations)
            _lhsOfrom :: (FunctionBindings)
            _lhsOlabDescriptors :: ([(Name,Declarations)])
            _lhsOself :: (Constructors)
            _lhsOstrtype :: (Declarations)
            _lhsOto :: (FunctionBindings)
            -- use rule
            (_lhsOcondescr@_) =
                []
            -- use rule
            (_lhsOcontype@_) =
                []
            -- use rule
            (_lhsOdescriptors@_) =
                []
            -- use rule
            (_lhsOep@_) =
                []
            -- use rule
            (_lhsOfrom@_) =
                []
            -- use rule
            (_lhsOlabDescriptors@_) =
                []
            -- use rule
            (_lhsOstrtype@_) =
                []
            -- use rule
            (_lhsOto@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
        in  ( _lhsOcondescr,_lhsOcontype,_lhsOdescriptors,_lhsOep,_lhsOfrom,_lhsOlabDescriptors,_lhsOself,_lhsOstrtype,_lhsOto)
-- ContextItem -------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for ContextItem.ContextItem:
      self

-}
{-
   local variables for ContextItem.DependencyConstraint:
      self

-}
{-
   local variables for ContextItem.DependencyItem:
      self

-}
-- semantic domain
type T_ContextItem = ( (ContextItem))
-- cata
sem_ContextItem :: (ContextItem) ->
                   (T_ContextItem)
sem_ContextItem ((ContextItem_ContextItem (_range) (_name) (_types))) =
    (sem_ContextItem_ContextItem ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Types (_types))))
sem_ContextItem ((ContextItem_DependencyConstraint (_range) (_name) (_typevariable) (_type))) =
    (sem_ContextItem_DependencyConstraint ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Name (_typevariable))) ((sem_Type (_type))))
sem_ContextItem ((ContextItem_DependencyItem (_range) (_name) (_generics) (_parametrics) (_asname))) =
    (sem_ContextItem_DependencyItem ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Names (_generics))) ((sem_Types (_parametrics))) ((sem_MaybeName (_asname))))
sem_ContextItem_ContextItem :: (T_Range) ->
                               (T_Name) ->
                               (T_Types) ->
                               (T_ContextItem)
sem_ContextItem_ContextItem (range_) (name_) (types_) =
    let _lhsOself :: (ContextItem)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        _typesIself :: (Types)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _typesIself) =
            (types_ )
        -- self rule
        (_self@_) =
            ContextItem_ContextItem _rangeIself _nameIself _typesIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_ContextItem_DependencyConstraint :: (T_Range) ->
                                        (T_Name) ->
                                        (T_Name) ->
                                        (T_Type) ->
                                        (T_ContextItem)
sem_ContextItem_DependencyConstraint (range_) (name_) (typevariable_) (type_) =
    let _lhsOself :: (ContextItem)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        _typevariableIself :: (Name)
        _typeIself :: (Type)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _typevariableIself) =
            (typevariable_ )
        ( _typeIself) =
            (type_ )
        -- self rule
        (_self@_) =
            ContextItem_DependencyConstraint _rangeIself _nameIself _typevariableIself _typeIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_ContextItem_DependencyItem :: (T_Range) ->
                                  (T_Name) ->
                                  (T_Names) ->
                                  (T_Types) ->
                                  (T_MaybeName) ->
                                  (T_ContextItem)
sem_ContextItem_DependencyItem (range_) (name_) (generics_) (parametrics_) (asname_) =
    let _lhsOself :: (ContextItem)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        _genericsIself :: (Names)
        _parametricsIself :: (Types)
        _asnameIself :: (MaybeName)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _genericsIself) =
            (generics_ )
        ( _parametricsIself) =
            (parametrics_ )
        ( _asnameIself) =
            (asname_ )
        -- self rule
        (_self@_) =
            ContextItem_DependencyItem _rangeIself _nameIself _genericsIself _parametricsIself _asnameIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- ContextItems ------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for ContextItems.Cons:
      self

-}
{-
   local variables for ContextItems.Nil:
      self

-}
-- semantic domain
type T_ContextItems = ( (ContextItems))
-- cata
sem_ContextItems :: (ContextItems) ->
                    (T_ContextItems)
sem_ContextItems (list) =
    (foldr (sem_ContextItems_Cons) (sem_ContextItems_Nil) ((map sem_ContextItem list)))
sem_ContextItems_Cons :: (T_ContextItem) ->
                         (T_ContextItems) ->
                         (T_ContextItems)
sem_ContextItems_Cons (hd_) (tl_) =
    let _lhsOself :: (ContextItems)
        _hdIself :: (ContextItem)
        _tlIself :: (ContextItems)
        ( _hdIself) =
            (hd_ )
        ( _tlIself) =
            (tl_ )
        -- self rule
        (_self@_) =
            (:) _hdIself _tlIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_ContextItems_Nil :: (T_ContextItems)
sem_ContextItems_Nil  =
    let _lhsOself :: (ContextItems)
        -- self rule
        (_self@_) =
            []
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- Declaration -------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      contype              : Declarations
      descriptors          : Declarations
      ep                   : Declarations
      labDescriptors       : [(Name,Declarations)]
      self                 : SELF
      strtype              : Declarations

-}
{-
   local variables for Declaration.Class:
      self

-}
{-
   local variables for Declaration.Data:
      body
      self

-}
{-
   local variables for Declaration.Default:
      self

-}
{-
   local variables for Declaration.Dependency:
      self

-}
{-
   local variables for Declaration.Empty:
      self

-}
{-
   local variables for Declaration.Fixity:
      self

-}
{-
   local variables for Declaration.FunctionBindings:
      self

-}
{-
   local variables for Declaration.GenericTypeSignature:
      self

-}
{-
   local variables for Declaration.Instance:
      self

-}
{-
   local variables for Declaration.KindIndexedType:
      self

-}
{-
   local variables for Declaration.Newtype:
      firstarg
      isConOrLabel
      body
      self

-}
{-
   local variables for Declaration.PatternBinding:
      self

-}
{-
   local variables for Declaration.Type:
      body
      self

-}
{-
   local variables for Declaration.TypeIndexedType:
      self

-}
{-
   local variables for Declaration.TypeIndexedValue:
      self

-}
{-
   local variables for Declaration.TypeSignature:
      self

-}
-- semantic domain
type T_Declaration = ( (Declarations),(Declarations),(Declarations),([(Name,Declarations)]),(Declaration),(Declarations))
-- cata
sem_Declaration :: (Declaration) ->
                   (T_Declaration)
sem_Declaration ((Declaration_Class (_range) (_context) (_simpletype) (_where))) =
    (sem_Declaration_Class ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_SimpleType (_simpletype))) ((sem_MaybeDeclarations (_where))))
sem_Declaration ((Declaration_Data (_range) (_context) (_simpletype) (_constructors) (_derivings))) =
    (sem_Declaration_Data ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_SimpleType (_simpletype))) ((sem_Constructors (_constructors))) ((sem_Names (_derivings))))
sem_Declaration ((Declaration_Default (_range) (_types))) =
    (sem_Declaration_Default ((sem_Range (_range))) ((sem_Types (_types))))
sem_Declaration ((Declaration_Dependency (_range) (_typelevel) (_name) (_bindings))) =
    (sem_Declaration_Dependency ((sem_Range (_range))) (_typelevel) ((sem_Name (_name))) ((sem_DependencyBindings (_bindings))))
sem_Declaration ((Declaration_Empty (_range))) =
    (sem_Declaration_Empty ((sem_Range (_range))))
sem_Declaration ((Declaration_Fixity (_range) (_fixity) (_priority) (_operators))) =
    (sem_Declaration_Fixity ((sem_Range (_range))) ((sem_Fixity (_fixity))) ((sem_MaybeInt (_priority))) ((sem_Names (_operators))))
sem_Declaration ((Declaration_FunctionBindings (_range) (_bindings))) =
    (sem_Declaration_FunctionBindings ((sem_Range (_range))) ((sem_FunctionBindings (_bindings))))
sem_Declaration ((Declaration_GenericTypeSignature (_range) (_name) (_generics) (_parametrics) (_type))) =
    (sem_Declaration_GenericTypeSignature ((sem_Range (_range))) ((sem_Name (_name))) ((sem_KindAnnotatedNames (_generics))) ((sem_KindAnnotatedNames (_parametrics))) ((sem_Type (_type))))
sem_Declaration ((Declaration_Instance (_range) (_context) (_name) (_types) (_where))) =
    (sem_Declaration_Instance ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_Name (_name))) ((sem_Types (_types))) ((sem_MaybeDeclarations (_where))))
sem_Declaration ((Declaration_KindIndexedType (_range) (_bindings))) =
    (sem_Declaration_KindIndexedType ((sem_Range (_range))) ((sem_KindIndexedBindings (_bindings))))
sem_Declaration ((Declaration_Newtype (_range) (_context) (_simpletype) (_constructor) (_derivings))) =
    (sem_Declaration_Newtype ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_SimpleType (_simpletype))) ((sem_Constructor (_constructor))) ((sem_Names (_derivings))))
sem_Declaration ((Declaration_PatternBinding (_range) (_pattern) (_righthandside))) =
    (sem_Declaration_PatternBinding ((sem_Range (_range))) ((sem_Pattern (_pattern))) ((sem_RightHandSide (_righthandside))))
sem_Declaration ((Declaration_Type (_range) (_simpletype) (_type))) =
    (sem_Declaration_Type ((sem_Range (_range))) ((sem_SimpleType (_simpletype))) ((sem_Type (_type))))
sem_Declaration ((Declaration_TypeIndexedType (_range) (_name) (_typeargument) (_typevariables) (_constructor) (_derivings))) =
    (sem_Declaration_TypeIndexedType ((sem_Range (_range))) ((sem_Name (_name))) ((sem_TypeArgument (_typeargument))) ((sem_Names (_typevariables))) ((sem_Constructor (_constructor))) ((sem_Names (_derivings))))
sem_Declaration ((Declaration_TypeIndexedValue (_range) (_bindings))) =
    (sem_Declaration_TypeIndexedValue ((sem_Range (_range))) ((sem_TypeIndexedBindings (_bindings))))
sem_Declaration ((Declaration_TypeSignature (_range) (_names) (_type))) =
    (sem_Declaration_TypeSignature ((sem_Range (_range))) ((sem_Names (_names))) ((sem_Type (_type))))
sem_Declaration_Class :: (T_Range) ->
                         (T_ContextItems) ->
                         (T_SimpleType) ->
                         (T_MaybeDeclarations) ->
                         (T_Declaration)
sem_Declaration_Class (range_) (context_) (simpletype_) (where_) =
    let _lhsOcontype :: (Declarations)
        _lhsOdescriptors :: (Declarations)
        _lhsOep :: (Declarations)
        _lhsOlabDescriptors :: ([(Name,Declarations)])
        _lhsOself :: (Declaration)
        _lhsOstrtype :: (Declarations)
        _rangeIself :: (Range)
        _contextIself :: (ContextItems)
        _simpletypeIname :: (Name)
        _simpletypeIself :: (SimpleType)
        _simpletypeItypevariables :: (Names)
        _whereIself :: (MaybeDeclarations)
        ( _rangeIself) =
            (range_ )
        ( _contextIself) =
            (context_ )
        ( _simpletypeIname,_simpletypeIself,_simpletypeItypevariables) =
            (simpletype_ )
        ( _whereIself) =
            (where_ )
        -- use rule
        (_lhsOcontype@_) =
            []
        -- use rule
        (_lhsOdescriptors@_) =
            []
        -- use rule
        (_lhsOep@_) =
            []
        -- use rule
        (_lhsOlabDescriptors@_) =
            []
        -- use rule
        (_lhsOstrtype@_) =
            []
        -- self rule
        (_self@_) =
            Declaration_Class _rangeIself _contextIself _simpletypeIself _whereIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOcontype,_lhsOdescriptors,_lhsOep,_lhsOlabDescriptors,_lhsOself,_lhsOstrtype)
sem_Declaration_Data :: (T_Range) ->
                        (T_ContextItems) ->
                        (T_SimpleType) ->
                        (T_Constructors) ->
                        (T_Names) ->
                        (T_Declaration)
sem_Declaration_Data (range_) (context_) (simpletype_) (constructors_) (derivings_) =
    let _lhsOcontype :: (Declarations)
        _lhsOdescriptors :: (Declarations)
        _lhsOep :: (Declarations)
        _lhsOlabDescriptors :: ([(Name,Declarations)])
        _lhsOself :: (Declaration)
        _lhsOstrtype :: (Declarations)
        _rangeIself :: (Range)
        _contextIself :: (ContextItems)
        _simpletypeIname :: (Name)
        _simpletypeIself :: (SimpleType)
        _simpletypeItypevariables :: (Names)
        _constructorsIcondescr :: (Types)
        _constructorsIcontype :: (Declarations)
        _constructorsIdescriptors :: (Declarations)
        _constructorsIep :: (Declarations)
        _constructorsIfrom :: (FunctionBindings)
        _constructorsIlabDescriptors :: ([(Name,Declarations)])
        _constructorsIself :: (Constructors)
        _constructorsIstrtype :: (Declarations)
        _constructorsIto :: (FunctionBindings)
        _constructorsOnrOfCon :: (Int)
        _constructorsOtotalNrOfCons :: (Int)
        _constructorsOtypename :: (Name)
        _constructorsOtypevariables :: (Names)
        _derivingsIself :: (Names)
        ( _rangeIself) =
            (range_ )
        ( _contextIself) =
            (context_ )
        ( _simpletypeIname,_simpletypeIself,_simpletypeItypevariables) =
            (simpletype_ )
        ( _constructorsIcondescr,_constructorsIcontype,_constructorsIdescriptors,_constructorsIep,_constructorsIfrom,_constructorsIlabDescriptors,_constructorsIself,_constructorsIstrtype,_constructorsIto) =
            (constructors_ (_constructorsOnrOfCon) (_constructorsOtotalNrOfCons) (_constructorsOtypename) (_constructorsOtypevariables))
        ( _derivingsIself) =
            (derivings_ )
        -- "StructureTypes.lag"(line 159, column 9)
        (_constructorsOtypename@_) =
            _simpletypeIname
        -- "StructureTypes.lag"(line 158, column 9)
        (_constructorsOtotalNrOfCons@_) =
            length _constructorsIself
        -- "StructureTypes.lag"(line 157, column 9)
        (_constructorsOnrOfCon@_) =
            0
        -- "StructureTypes.lag"(line 541, column 9)
        (_constructorsOtypevariables@_) =
            _simpletypeItypevariables
        -- "StructureTypes.lag"(line 534, column 9)
        (_lhsOep@_) =
            mkEP
                _simpletypeIname
                (strName _simpletypeIname)
                _contextIself _simpletypeItypevariables
                _constructorsIfrom _constructorsIto
              ++ _constructorsIep
        -- "StructureTypes.lag"(line 531, column 9)
        (_lhsOstrtype@_) =
            mkStrType _simpletypeIname _simpletypeItypevariables _body
              : _constructorsIstrtype
        -- "StructureTypes.lag"(line 530, column 9)
        (_body@_) =
            foldr1 sumType _constructorsIcondescr
        -- use rule
        (_lhsOcontype@_) =
            _constructorsIcontype
        -- use rule
        (_lhsOdescriptors@_) =
            _constructorsIdescriptors
        -- use rule
        (_lhsOlabDescriptors@_) =
            _constructorsIlabDescriptors
        -- self rule
        (_self@_) =
            Declaration_Data _rangeIself _contextIself _simpletypeIself _constructorsIself _derivingsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOcontype,_lhsOdescriptors,_lhsOep,_lhsOlabDescriptors,_lhsOself,_lhsOstrtype)
sem_Declaration_Default :: (T_Range) ->
                           (T_Types) ->
                           (T_Declaration)
sem_Declaration_Default (range_) (types_) =
    let _lhsOcontype :: (Declarations)
        _lhsOdescriptors :: (Declarations)
        _lhsOep :: (Declarations)
        _lhsOlabDescriptors :: ([(Name,Declarations)])
        _lhsOself :: (Declaration)
        _lhsOstrtype :: (Declarations)
        _rangeIself :: (Range)
        _typesIself :: (Types)
        ( _rangeIself) =
            (range_ )
        ( _typesIself) =
            (types_ )
        -- use rule
        (_lhsOcontype@_) =
            []
        -- use rule
        (_lhsOdescriptors@_) =
            []
        -- use rule
        (_lhsOep@_) =
            []
        -- use rule
        (_lhsOlabDescriptors@_) =
            []
        -- use rule
        (_lhsOstrtype@_) =
            []
        -- self rule
        (_self@_) =
            Declaration_Default _rangeIself _typesIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOcontype,_lhsOdescriptors,_lhsOep,_lhsOlabDescriptors,_lhsOself,_lhsOstrtype)
sem_Declaration_Dependency :: (T_Range) ->
                              (Bool) ->
                              (T_Name) ->
                              (T_DependencyBindings) ->
                              (T_Declaration)
sem_Declaration_Dependency (range_) (typelevel_) (name_) (bindings_) =
    let _lhsOcontype :: (Declarations)
        _lhsOdescriptors :: (Declarations)
        _lhsOep :: (Declarations)
        _lhsOlabDescriptors :: ([(Name,Declarations)])
        _lhsOself :: (Declaration)
        _lhsOstrtype :: (Declarations)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        _bindingsIself :: (DependencyBindings)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _bindingsIself) =
            (bindings_ )
        -- use rule
        (_lhsOcontype@_) =
            []
        -- use rule
        (_lhsOdescriptors@_) =
            []
        -- use rule
        (_lhsOep@_) =
            []
        -- use rule
        (_lhsOlabDescriptors@_) =
            []
        -- use rule
        (_lhsOstrtype@_) =
            []
        -- self rule
        (_self@_) =
            Declaration_Dependency _rangeIself typelevel_ _nameIself _bindingsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOcontype,_lhsOdescriptors,_lhsOep,_lhsOlabDescriptors,_lhsOself,_lhsOstrtype)
sem_Declaration_Empty :: (T_Range) ->
                         (T_Declaration)
sem_Declaration_Empty (range_) =
    let _lhsOcontype :: (Declarations)
        _lhsOdescriptors :: (Declarations)
        _lhsOep :: (Declarations)
        _lhsOlabDescriptors :: ([(Name,Declarations)])
        _lhsOself :: (Declaration)
        _lhsOstrtype :: (Declarations)
        _rangeIself :: (Range)
        ( _rangeIself) =
            (range_ )
        -- use rule
        (_lhsOcontype@_) =
            []
        -- use rule
        (_lhsOdescriptors@_) =
            []
        -- use rule
        (_lhsOep@_) =
            []
        -- use rule
        (_lhsOlabDescriptors@_) =
            []
        -- use rule
        (_lhsOstrtype@_) =
            []
        -- self rule
        (_self@_) =
            Declaration_Empty _rangeIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOcontype,_lhsOdescriptors,_lhsOep,_lhsOlabDescriptors,_lhsOself,_lhsOstrtype)
sem_Declaration_Fixity :: (T_Range) ->
                          (T_Fixity) ->
                          (T_MaybeInt) ->
                          (T_Names) ->
                          (T_Declaration)
sem_Declaration_Fixity (range_) (fixity_) (priority_) (operators_) =
    let _lhsOcontype :: (Declarations)
        _lhsOdescriptors :: (Declarations)
        _lhsOep :: (Declarations)
        _lhsOlabDescriptors :: ([(Name,Declarations)])
        _lhsOself :: (Declaration)
        _lhsOstrtype :: (Declarations)
        _rangeIself :: (Range)
        _fixityIself :: (Fixity)
        _priorityIself :: (MaybeInt)
        _operatorsIself :: (Names)
        ( _rangeIself) =
            (range_ )
        ( _fixityIself) =
            (fixity_ )
        ( _priorityIself) =
            (priority_ )
        ( _operatorsIself) =
            (operators_ )
        -- use rule
        (_lhsOcontype@_) =
            []
        -- use rule
        (_lhsOdescriptors@_) =
            []
        -- use rule
        (_lhsOep@_) =
            []
        -- use rule
        (_lhsOlabDescriptors@_) =
            []
        -- use rule
        (_lhsOstrtype@_) =
            []
        -- self rule
        (_self@_) =
            Declaration_Fixity _rangeIself _fixityIself _priorityIself _operatorsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOcontype,_lhsOdescriptors,_lhsOep,_lhsOlabDescriptors,_lhsOself,_lhsOstrtype)
sem_Declaration_FunctionBindings :: (T_Range) ->
                                    (T_FunctionBindings) ->
                                    (T_Declaration)
sem_Declaration_FunctionBindings (range_) (bindings_) =
    let _lhsOcontype :: (Declarations)
        _lhsOdescriptors :: (Declarations)
        _lhsOep :: (Declarations)
        _lhsOlabDescriptors :: ([(Name,Declarations)])
        _lhsOself :: (Declaration)
        _lhsOstrtype :: (Declarations)
        _rangeIself :: (Range)
        _bindingsIself :: (FunctionBindings)
        ( _rangeIself) =
            (range_ )
        ( _bindingsIself) =
            (bindings_ )
        -- use rule
        (_lhsOcontype@_) =
            []
        -- use rule
        (_lhsOdescriptors@_) =
            []
        -- use rule
        (_lhsOep@_) =
            []
        -- use rule
        (_lhsOlabDescriptors@_) =
            []
        -- use rule
        (_lhsOstrtype@_) =
            []
        -- self rule
        (_self@_) =
            Declaration_FunctionBindings _rangeIself _bindingsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOcontype,_lhsOdescriptors,_lhsOep,_lhsOlabDescriptors,_lhsOself,_lhsOstrtype)
sem_Declaration_GenericTypeSignature :: (T_Range) ->
                                        (T_Name) ->
                                        (T_KindAnnotatedNames) ->
                                        (T_KindAnnotatedNames) ->
                                        (T_Type) ->
                                        (T_Declaration)
sem_Declaration_GenericTypeSignature (range_) (name_) (generics_) (parametrics_) (type_) =
    let _lhsOcontype :: (Declarations)
        _lhsOdescriptors :: (Declarations)
        _lhsOep :: (Declarations)
        _lhsOlabDescriptors :: ([(Name,Declarations)])
        _lhsOself :: (Declaration)
        _lhsOstrtype :: (Declarations)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        _genericsIself :: (KindAnnotatedNames)
        _genericsItypevariables :: (Names)
        _parametricsIself :: (KindAnnotatedNames)
        _parametricsItypevariables :: (Names)
        _typeIself :: (Type)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _genericsIself,_genericsItypevariables) =
            (generics_ )
        ( _parametricsIself,_parametricsItypevariables) =
            (parametrics_ )
        ( _typeIself) =
            (type_ )
        -- use rule
        (_lhsOcontype@_) =
            []
        -- use rule
        (_lhsOdescriptors@_) =
            []
        -- use rule
        (_lhsOep@_) =
            []
        -- use rule
        (_lhsOlabDescriptors@_) =
            []
        -- use rule
        (_lhsOstrtype@_) =
            []
        -- self rule
        (_self@_) =
            Declaration_GenericTypeSignature _rangeIself _nameIself _genericsIself _parametricsIself _typeIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOcontype,_lhsOdescriptors,_lhsOep,_lhsOlabDescriptors,_lhsOself,_lhsOstrtype)
sem_Declaration_Instance :: (T_Range) ->
                            (T_ContextItems) ->
                            (T_Name) ->
                            (T_Types) ->
                            (T_MaybeDeclarations) ->
                            (T_Declaration)
sem_Declaration_Instance (range_) (context_) (name_) (types_) (where_) =
    let _lhsOcontype :: (Declarations)
        _lhsOdescriptors :: (Declarations)
        _lhsOep :: (Declarations)
        _lhsOlabDescriptors :: ([(Name,Declarations)])
        _lhsOself :: (Declaration)
        _lhsOstrtype :: (Declarations)
        _rangeIself :: (Range)
        _contextIself :: (ContextItems)
        _nameIself :: (Name)
        _typesIself :: (Types)
        _whereIself :: (MaybeDeclarations)
        ( _rangeIself) =
            (range_ )
        ( _contextIself) =
            (context_ )
        ( _nameIself) =
            (name_ )
        ( _typesIself) =
            (types_ )
        ( _whereIself) =
            (where_ )
        -- use rule
        (_lhsOcontype@_) =
            []
        -- use rule
        (_lhsOdescriptors@_) =
            []
        -- use rule
        (_lhsOep@_) =
            []
        -- use rule
        (_lhsOlabDescriptors@_) =
            []
        -- use rule
        (_lhsOstrtype@_) =
            []
        -- self rule
        (_self@_) =
            Declaration_Instance _rangeIself _contextIself _nameIself _typesIself _whereIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOcontype,_lhsOdescriptors,_lhsOep,_lhsOlabDescriptors,_lhsOself,_lhsOstrtype)
sem_Declaration_KindIndexedType :: (T_Range) ->
                                   (T_KindIndexedBindings) ->
                                   (T_Declaration)
sem_Declaration_KindIndexedType (range_) (bindings_) =
    let _lhsOcontype :: (Declarations)
        _lhsOdescriptors :: (Declarations)
        _lhsOep :: (Declarations)
        _lhsOlabDescriptors :: ([(Name,Declarations)])
        _lhsOself :: (Declaration)
        _lhsOstrtype :: (Declarations)
        _rangeIself :: (Range)
        _bindingsIself :: (KindIndexedBindings)
        ( _rangeIself) =
            (range_ )
        ( _bindingsIself) =
            (bindings_ )
        -- use rule
        (_lhsOcontype@_) =
            []
        -- use rule
        (_lhsOdescriptors@_) =
            []
        -- use rule
        (_lhsOep@_) =
            []
        -- use rule
        (_lhsOlabDescriptors@_) =
            []
        -- use rule
        (_lhsOstrtype@_) =
            []
        -- self rule
        (_self@_) =
            Declaration_KindIndexedType _rangeIself _bindingsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOcontype,_lhsOdescriptors,_lhsOep,_lhsOlabDescriptors,_lhsOself,_lhsOstrtype)
sem_Declaration_Newtype :: (T_Range) ->
                           (T_ContextItems) ->
                           (T_SimpleType) ->
                           (T_Constructor) ->
                           (T_Names) ->
                           (T_Declaration)
sem_Declaration_Newtype (range_) (context_) (simpletype_) (constructor_) (derivings_) =
    let _lhsOcontype :: (Declarations)
        _lhsOdescriptors :: (Declarations)
        _lhsOep :: (Declarations)
        _lhsOlabDescriptors :: ([(Name,Declarations)])
        _lhsOself :: (Declaration)
        _lhsOstrtype :: (Declarations)
        _rangeIself :: (Range)
        _contextIself :: (ContextItems)
        _simpletypeIname :: (Name)
        _simpletypeIself :: (SimpleType)
        _simpletypeItypevariables :: (Names)
        _constructorIcondescr :: (Type)
        _constructorIcontype :: (Declarations)
        _constructorIdescriptors :: (Declarations)
        _constructorIep :: (Declarations)
        _constructorIfrom :: (FunctionBinding)
        _constructorIlabDescriptors :: ([(Name,Declarations)])
        _constructorIself :: (Constructor)
        _constructorIstrtype :: (Declarations)
        _constructorIto :: (FunctionBinding)
        _constructorOnrOfCon :: (Int)
        _constructorOtotalNrOfCons :: (Int)
        _constructorOtypename :: (Name)
        _constructorOtypevariables :: (Names)
        _derivingsIself :: (Names)
        ( _rangeIself) =
            (range_ )
        ( _contextIself) =
            (context_ )
        ( _simpletypeIname,_simpletypeIself,_simpletypeItypevariables) =
            (simpletype_ )
        ( _constructorIcondescr,_constructorIcontype,_constructorIdescriptors,_constructorIep,_constructorIfrom,_constructorIlabDescriptors,_constructorIself,_constructorIstrtype,_constructorIto) =
            (constructor_ (_constructorOnrOfCon) (_constructorOtotalNrOfCons) (_constructorOtypename) (_constructorOtypevariables))
        ( _derivingsIself) =
            (derivings_ )
        -- "StructureTypes.lag"(line 154, column 9)
        (_constructorOtypename@_) =
            _simpletypeIname
        -- "StructureTypes.lag"(line 153, column 9)
        (_constructorOtotalNrOfCons@_) =
            1
        -- "StructureTypes.lag"(line 152, column 9)
        (_constructorOnrOfCon@_) =
            0
        -- "StructureTypes.lag"(line 592, column 9)
        (_constructorOtypevariables@_) =
            _simpletypeItypevariables
        -- "StructureTypes.lag"(line 589, column 9)
        (_firstarg@_) =
            safeHead _simpletypeItypevariables
              "StructureTypes.New.loc.firstarg: corrupted GHPrelude"
        -- "StructureTypes.lag"(line 587, column 9)
        (_isConOrLabel@_) =
            _simpletypeIname `elem` [conName,labelName]
        -- "StructureTypes.lag"(line 565, column 9)
        (_lhsOep@_) =
            if _isConOrLabel then
              (mkEP
                 _simpletypeIname (strName _simpletypeIname)
                 _contextIself _simpletypeItypevariables
                 [fromBinding
                    [parP $ conP _simpletypeIname [varP _firstarg]]
                    (varE _firstarg)
                 ]
                 [toBinding
                    [varP _firstarg]
                    (appE (conE _simpletypeIname) [varE _firstarg])
                 ]
              ) ++ _constructorIep
            else
              (mkEP
                 _simpletypeIname (strName _simpletypeIname)
                 _contextIself _simpletypeItypevariables
                 [_constructorIfrom] [_constructorIto]
              ) ++ _constructorIep
        -- "StructureTypes.lag"(line 562, column 9)
        (_lhsOstrtype@_) =
            [mkStrType _simpletypeIname _simpletypeItypevariables _body]
              ++ _constructorIstrtype
        -- "StructureTypes.lag"(line 558, column 9)
        (_body@_) =
            if _isConOrLabel then
              varT _firstarg
            else
              _constructorIcondescr
        -- use rule
        (_lhsOcontype@_) =
            _constructorIcontype
        -- use rule
        (_lhsOdescriptors@_) =
            _constructorIdescriptors
        -- use rule
        (_lhsOlabDescriptors@_) =
            _constructorIlabDescriptors
        -- self rule
        (_self@_) =
            Declaration_Newtype _rangeIself _contextIself _simpletypeIself _constructorIself _derivingsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOcontype,_lhsOdescriptors,_lhsOep,_lhsOlabDescriptors,_lhsOself,_lhsOstrtype)
sem_Declaration_PatternBinding :: (T_Range) ->
                                  (T_Pattern) ->
                                  (T_RightHandSide) ->
                                  (T_Declaration)
sem_Declaration_PatternBinding (range_) (pattern_) (righthandside_) =
    let _lhsOcontype :: (Declarations)
        _lhsOdescriptors :: (Declarations)
        _lhsOep :: (Declarations)
        _lhsOlabDescriptors :: ([(Name,Declarations)])
        _lhsOself :: (Declaration)
        _lhsOstrtype :: (Declarations)
        _rangeIself :: (Range)
        _patternIself :: (Pattern)
        _righthandsideIself :: (RightHandSide)
        ( _rangeIself) =
            (range_ )
        ( _patternIself) =
            (pattern_ )
        ( _righthandsideIself) =
            (righthandside_ )
        -- use rule
        (_lhsOcontype@_) =
            []
        -- use rule
        (_lhsOdescriptors@_) =
            []
        -- use rule
        (_lhsOep@_) =
            []
        -- use rule
        (_lhsOlabDescriptors@_) =
            []
        -- use rule
        (_lhsOstrtype@_) =
            []
        -- self rule
        (_self@_) =
            Declaration_PatternBinding _rangeIself _patternIself _righthandsideIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOcontype,_lhsOdescriptors,_lhsOep,_lhsOlabDescriptors,_lhsOself,_lhsOstrtype)
sem_Declaration_Type :: (T_Range) ->
                        (T_SimpleType) ->
                        (T_Type) ->
                        (T_Declaration)
sem_Declaration_Type (range_) (simpletype_) (type_) =
    let _lhsOcontype :: (Declarations)
        _lhsOdescriptors :: (Declarations)
        _lhsOep :: (Declarations)
        _lhsOlabDescriptors :: ([(Name,Declarations)])
        _lhsOself :: (Declaration)
        _lhsOstrtype :: (Declarations)
        _rangeIself :: (Range)
        _simpletypeIname :: (Name)
        _simpletypeIself :: (SimpleType)
        _simpletypeItypevariables :: (Names)
        _typeIself :: (Type)
        ( _rangeIself) =
            (range_ )
        ( _simpletypeIname,_simpletypeIself,_simpletypeItypevariables) =
            (simpletype_ )
        ( _typeIself) =
            (type_ )
        -- "StructureTypes.lag"(line 527, column 9)
        (_lhsOep@_) =
            mkidEP _simpletypeIname _simpletypeItypevariables
        -- "StructureTypes.lag"(line 526, column 9)
        (_lhsOstrtype@_) =
            [mkStrType _simpletypeIname _simpletypeItypevariables _body]
        -- "StructureTypes.lag"(line 525, column 9)
        (_body@_) =
            _typeIself
        -- use rule
        (_lhsOcontype@_) =
            []
        -- use rule
        (_lhsOdescriptors@_) =
            []
        -- use rule
        (_lhsOlabDescriptors@_) =
            []
        -- self rule
        (_self@_) =
            Declaration_Type _rangeIself _simpletypeIself _typeIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOcontype,_lhsOdescriptors,_lhsOep,_lhsOlabDescriptors,_lhsOself,_lhsOstrtype)
sem_Declaration_TypeIndexedType :: (T_Range) ->
                                   (T_Name) ->
                                   (T_TypeArgument) ->
                                   (T_Names) ->
                                   (T_Constructor) ->
                                   (T_Names) ->
                                   (T_Declaration)
sem_Declaration_TypeIndexedType (range_) (name_) (typeargument_) (typevariables_) (constructor_) (derivings_) =
    let _lhsOcontype :: (Declarations)
        _lhsOdescriptors :: (Declarations)
        _lhsOep :: (Declarations)
        _lhsOlabDescriptors :: ([(Name,Declarations)])
        _lhsOself :: (Declaration)
        _lhsOstrtype :: (Declarations)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        _typeargumentIself :: (TypeArgument)
        _typevariablesIself :: (Names)
        _constructorIcondescr :: (Type)
        _constructorIcontype :: (Declarations)
        _constructorIdescriptors :: (Declarations)
        _constructorIep :: (Declarations)
        _constructorIfrom :: (FunctionBinding)
        _constructorIlabDescriptors :: ([(Name,Declarations)])
        _constructorIself :: (Constructor)
        _constructorIstrtype :: (Declarations)
        _constructorIto :: (FunctionBinding)
        _constructorOnrOfCon :: (Int)
        _constructorOtotalNrOfCons :: (Int)
        _constructorOtypename :: (Name)
        _constructorOtypevariables :: (Names)
        _derivingsIself :: (Names)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _typeargumentIself) =
            (typeargument_ )
        ( _typevariablesIself) =
            (typevariables_ )
        ( _constructorIcondescr,_constructorIcontype,_constructorIdescriptors,_constructorIep,_constructorIfrom,_constructorIlabDescriptors,_constructorIself,_constructorIstrtype,_constructorIto) =
            (constructor_ (_constructorOnrOfCon) (_constructorOtotalNrOfCons) (_constructorOtypename) (_constructorOtypevariables))
        ( _derivingsIself) =
            (derivings_ )
        -- "StructureTypes.lag"(line 164, column 9)
        (_constructorOtypename@_) =
            _nameIself
        -- "StructureTypes.lag"(line 163, column 9)
        (_constructorOtotalNrOfCons@_) =
            1
        -- "StructureTypes.lag"(line 162, column 9)
        (_constructorOnrOfCon@_) =
            0
        -- "StructureTypes.lag"(line 599, column 9)
        (_constructorOtypevariables@_) =
            _typevariablesIself
        -- "StructureTypes.lag"(line 597, column 9)
        (_lhsOep@_) =
            []
        -- "StructureTypes.lag"(line 596, column 9)
        (_lhsOstrtype@_) =
            []
        -- use rule
        (_lhsOcontype@_) =
            _constructorIcontype
        -- use rule
        (_lhsOdescriptors@_) =
            _constructorIdescriptors
        -- use rule
        (_lhsOlabDescriptors@_) =
            _constructorIlabDescriptors
        -- self rule
        (_self@_) =
            Declaration_TypeIndexedType _rangeIself _nameIself _typeargumentIself _typevariablesIself _constructorIself _derivingsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOcontype,_lhsOdescriptors,_lhsOep,_lhsOlabDescriptors,_lhsOself,_lhsOstrtype)
sem_Declaration_TypeIndexedValue :: (T_Range) ->
                                    (T_TypeIndexedBindings) ->
                                    (T_Declaration)
sem_Declaration_TypeIndexedValue (range_) (bindings_) =
    let _lhsOcontype :: (Declarations)
        _lhsOdescriptors :: (Declarations)
        _lhsOep :: (Declarations)
        _lhsOlabDescriptors :: ([(Name,Declarations)])
        _lhsOself :: (Declaration)
        _lhsOstrtype :: (Declarations)
        _rangeIself :: (Range)
        _bindingsIself :: (TypeIndexedBindings)
        ( _rangeIself) =
            (range_ )
        ( _bindingsIself) =
            (bindings_ )
        -- use rule
        (_lhsOcontype@_) =
            []
        -- use rule
        (_lhsOdescriptors@_) =
            []
        -- use rule
        (_lhsOep@_) =
            []
        -- use rule
        (_lhsOlabDescriptors@_) =
            []
        -- use rule
        (_lhsOstrtype@_) =
            []
        -- self rule
        (_self@_) =
            Declaration_TypeIndexedValue _rangeIself _bindingsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOcontype,_lhsOdescriptors,_lhsOep,_lhsOlabDescriptors,_lhsOself,_lhsOstrtype)
sem_Declaration_TypeSignature :: (T_Range) ->
                                 (T_Names) ->
                                 (T_Type) ->
                                 (T_Declaration)
sem_Declaration_TypeSignature (range_) (names_) (type_) =
    let _lhsOcontype :: (Declarations)
        _lhsOdescriptors :: (Declarations)
        _lhsOep :: (Declarations)
        _lhsOlabDescriptors :: ([(Name,Declarations)])
        _lhsOself :: (Declaration)
        _lhsOstrtype :: (Declarations)
        _rangeIself :: (Range)
        _namesIself :: (Names)
        _typeIself :: (Type)
        ( _rangeIself) =
            (range_ )
        ( _namesIself) =
            (names_ )
        ( _typeIself) =
            (type_ )
        -- use rule
        (_lhsOcontype@_) =
            []
        -- use rule
        (_lhsOdescriptors@_) =
            []
        -- use rule
        (_lhsOep@_) =
            []
        -- use rule
        (_lhsOlabDescriptors@_) =
            []
        -- use rule
        (_lhsOstrtype@_) =
            []
        -- self rule
        (_self@_) =
            Declaration_TypeSignature _rangeIself _namesIself _typeIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOcontype,_lhsOdescriptors,_lhsOep,_lhsOlabDescriptors,_lhsOself,_lhsOstrtype)
-- Declarations ------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Declarations.Cons:
      self

-}
{-
   local variables for Declarations.Nil:
      self

-}
-- semantic domain
type T_Declarations = ( (Declarations))
-- cata
sem_Declarations :: (Declarations) ->
                    (T_Declarations)
sem_Declarations (list) =
    (foldr (sem_Declarations_Cons) (sem_Declarations_Nil) ((map sem_Declaration list)))
sem_Declarations_Cons :: (T_Declaration) ->
                         (T_Declarations) ->
                         (T_Declarations)
sem_Declarations_Cons (hd_) (tl_) =
    let _lhsOself :: (Declarations)
        _hdIcontype :: (Declarations)
        _hdIdescriptors :: (Declarations)
        _hdIep :: (Declarations)
        _hdIlabDescriptors :: ([(Name,Declarations)])
        _hdIself :: (Declaration)
        _hdIstrtype :: (Declarations)
        _tlIself :: (Declarations)
        ( _hdIcontype,_hdIdescriptors,_hdIep,_hdIlabDescriptors,_hdIself,_hdIstrtype) =
            (hd_ )
        ( _tlIself) =
            (tl_ )
        -- self rule
        (_self@_) =
            (:) _hdIself _tlIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Declarations_Nil :: (T_Declarations)
sem_Declarations_Nil  =
    let _lhsOself :: (Declarations)
        -- self rule
        (_self@_) =
            []
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- DependencyBinding -------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for DependencyBinding.Rename:
      self

-}
{-
   local variables for DependencyBinding.Simple:
      self

-}
-- semantic domain
type T_DependencyBinding = ( (DependencyBinding))
-- cata
sem_DependencyBinding :: (DependencyBinding) ->
                         (T_DependencyBinding)
sem_DependencyBinding ((DependencyBinding_Rename (_range) (_name) (_as))) =
    (sem_DependencyBinding_Rename ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Name (_as))))
sem_DependencyBinding ((DependencyBinding_Simple (_range) (_name))) =
    (sem_DependencyBinding_Simple ((sem_Range (_range))) ((sem_Name (_name))))
sem_DependencyBinding_Rename :: (T_Range) ->
                                (T_Name) ->
                                (T_Name) ->
                                (T_DependencyBinding)
sem_DependencyBinding_Rename (range_) (name_) (as_) =
    let _lhsOself :: (DependencyBinding)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        _asIself :: (Name)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _asIself) =
            (as_ )
        -- self rule
        (_self@_) =
            DependencyBinding_Rename _rangeIself _nameIself _asIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_DependencyBinding_Simple :: (T_Range) ->
                                (T_Name) ->
                                (T_DependencyBinding)
sem_DependencyBinding_Simple (range_) (name_) =
    let _lhsOself :: (DependencyBinding)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        -- self rule
        (_self@_) =
            DependencyBinding_Simple _rangeIself _nameIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- DependencyBindings ------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for DependencyBindings.Cons:
      self

-}
{-
   local variables for DependencyBindings.Nil:
      self

-}
-- semantic domain
type T_DependencyBindings = ( (DependencyBindings))
-- cata
sem_DependencyBindings :: (DependencyBindings) ->
                          (T_DependencyBindings)
sem_DependencyBindings (list) =
    (foldr (sem_DependencyBindings_Cons) (sem_DependencyBindings_Nil) ((map sem_DependencyBinding list)))
sem_DependencyBindings_Cons :: (T_DependencyBinding) ->
                               (T_DependencyBindings) ->
                               (T_DependencyBindings)
sem_DependencyBindings_Cons (hd_) (tl_) =
    let _lhsOself :: (DependencyBindings)
        _hdIself :: (DependencyBinding)
        _tlIself :: (DependencyBindings)
        ( _hdIself) =
            (hd_ )
        ( _tlIself) =
            (tl_ )
        -- self rule
        (_self@_) =
            (:) _hdIself _tlIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_DependencyBindings_Nil :: (T_DependencyBindings)
sem_DependencyBindings_Nil  =
    let _lhsOself :: (DependencyBindings)
        -- self rule
        (_self@_) =
            []
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- Export ------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Export.Module:
      self

-}
{-
   local variables for Export.TypeOrClass:
      self

-}
{-
   local variables for Export.TypeOrClassComplete:
      self

-}
{-
   local variables for Export.Variable:
      self

-}
-- semantic domain
type T_Export = ( (Export))
-- cata
sem_Export :: (Export) ->
              (T_Export)
sem_Export ((Export_Module (_range) (_name))) =
    (sem_Export_Module ((sem_Range (_range))) ((sem_ModuleName (_name))))
sem_Export ((Export_TypeOrClass (_range) (_name) (_names))) =
    (sem_Export_TypeOrClass ((sem_Range (_range))) ((sem_Name (_name))) ((sem_MaybeNames (_names))))
sem_Export ((Export_TypeOrClassComplete (_range) (_name))) =
    (sem_Export_TypeOrClassComplete ((sem_Range (_range))) ((sem_Name (_name))))
sem_Export ((Export_Variable (_range) (_name))) =
    (sem_Export_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Export_Module :: (T_Range) ->
                     (T_ModuleName) ->
                     (T_Export)
sem_Export_Module (range_) (name_) =
    let _lhsOself :: (Export)
        _rangeIself :: (Range)
        _nameIself :: (ModuleName)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        -- self rule
        (_self@_) =
            Export_Module _rangeIself _nameIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Export_TypeOrClass :: (T_Range) ->
                          (T_Name) ->
                          (T_MaybeNames) ->
                          (T_Export)
sem_Export_TypeOrClass (range_) (name_) (names_) =
    let _lhsOself :: (Export)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        _namesIself :: (MaybeNames)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _namesIself) =
            (names_ )
        -- self rule
        (_self@_) =
            Export_TypeOrClass _rangeIself _nameIself _namesIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Export_TypeOrClassComplete :: (T_Range) ->
                                  (T_Name) ->
                                  (T_Export)
sem_Export_TypeOrClassComplete (range_) (name_) =
    let _lhsOself :: (Export)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        -- self rule
        (_self@_) =
            Export_TypeOrClassComplete _rangeIself _nameIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Export_Variable :: (T_Range) ->
                       (T_Name) ->
                       (T_Export)
sem_Export_Variable (range_) (name_) =
    let _lhsOself :: (Export)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        -- self rule
        (_self@_) =
            Export_Variable _rangeIself _nameIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- Exports -----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Exports.Cons:
      self

-}
{-
   local variables for Exports.Nil:
      self

-}
-- semantic domain
type T_Exports = ( (Exports))
-- cata
sem_Exports :: (Exports) ->
               (T_Exports)
sem_Exports (list) =
    (foldr (sem_Exports_Cons) (sem_Exports_Nil) ((map sem_Export list)))
sem_Exports_Cons :: (T_Export) ->
                    (T_Exports) ->
                    (T_Exports)
sem_Exports_Cons (hd_) (tl_) =
    let _lhsOself :: (Exports)
        _hdIself :: (Export)
        _tlIself :: (Exports)
        ( _hdIself) =
            (hd_ )
        ( _tlIself) =
            (tl_ )
        -- self rule
        (_self@_) =
            (:) _hdIself _tlIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Exports_Nil :: (T_Exports)
sem_Exports_Nil  =
    let _lhsOself :: (Exports)
        -- self rule
        (_self@_) =
            []
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- Expression --------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Expression.As:
      self

-}
{-
   local variables for Expression.Case:
      self

-}
{-
   local variables for Expression.Comprehension:
      self

-}
{-
   local variables for Expression.Constructor:
      self

-}
{-
   local variables for Expression.Do:
      self

-}
{-
   local variables for Expression.Enum:
      self

-}
{-
   local variables for Expression.If:
      self

-}
{-
   local variables for Expression.InfixApplication:
      self

-}
{-
   local variables for Expression.Irrefutable:
      self

-}
{-
   local variables for Expression.Lambda:
      self

-}
{-
   local variables for Expression.Let:
      self

-}
{-
   local variables for Expression.List:
      self

-}
{-
   local variables for Expression.Literal:
      self

-}
{-
   local variables for Expression.Negate:
      self

-}
{-
   local variables for Expression.NormalApplication:
      self

-}
{-
   local variables for Expression.Parenthesized:
      self

-}
{-
   local variables for Expression.RecordConstruction:
      self

-}
{-
   local variables for Expression.RecordUpdate:
      self

-}
{-
   local variables for Expression.Tuple:
      self

-}
{-
   local variables for Expression.TypeApplication:
      self

-}
{-
   local variables for Expression.Typed:
      self

-}
{-
   local variables for Expression.Variable:
      self

-}
{-
   local variables for Expression.Wildcard:
      self

-}
-- semantic domain
type T_Expression = ( (Expression))
-- cata
sem_Expression :: (Expression) ->
                  (T_Expression)
sem_Expression ((Expression_As (_range) (_name) (_expression))) =
    (sem_Expression_As ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Expression (_expression))))
sem_Expression ((Expression_Case (_range) (_expression) (_alternatives))) =
    (sem_Expression_Case ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_Alternatives (_alternatives))))
sem_Expression ((Expression_Comprehension (_range) (_expression) (_qualifiers))) =
    (sem_Expression_Comprehension ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_Qualifiers (_qualifiers))))
sem_Expression ((Expression_Constructor (_range) (_name))) =
    (sem_Expression_Constructor ((sem_Range (_range))) ((sem_Name (_name))))
sem_Expression ((Expression_Do (_range) (_statements))) =
    (sem_Expression_Do ((sem_Range (_range))) ((sem_Statements (_statements))))
sem_Expression ((Expression_Enum (_range) (_from) (_then) (_to))) =
    (sem_Expression_Enum ((sem_Range (_range))) ((sem_Expression (_from))) ((sem_MaybeExpression (_then))) ((sem_MaybeExpression (_to))))
sem_Expression ((Expression_If (_range) (_guardExpression) (_thenExpression) (_elseExpression))) =
    (sem_Expression_If ((sem_Range (_range))) ((sem_Expression (_guardExpression))) ((sem_Expression (_thenExpression))) ((sem_Expression (_elseExpression))))
sem_Expression ((Expression_InfixApplication (_range) (_leftExpression) (_operator) (_rightExpression))) =
    (sem_Expression_InfixApplication ((sem_Range (_range))) ((sem_MaybeExpression (_leftExpression))) ((sem_Expression (_operator))) ((sem_MaybeExpression (_rightExpression))))
sem_Expression ((Expression_Irrefutable (_range) (_expression))) =
    (sem_Expression_Irrefutable ((sem_Range (_range))) ((sem_Expression (_expression))))
sem_Expression ((Expression_Lambda (_range) (_patterns) (_expression))) =
    (sem_Expression_Lambda ((sem_Range (_range))) ((sem_Patterns (_patterns))) ((sem_Expression (_expression))))
sem_Expression ((Expression_Let (_range) (_declarations) (_expression))) =
    (sem_Expression_Let ((sem_Range (_range))) ((sem_Declarations (_declarations))) ((sem_Expression (_expression))))
sem_Expression ((Expression_List (_range) (_expressions))) =
    (sem_Expression_List ((sem_Range (_range))) ((sem_Expressions (_expressions))))
sem_Expression ((Expression_Literal (_range) (_literal))) =
    (sem_Expression_Literal ((sem_Range (_range))) ((sem_Literal (_literal))))
sem_Expression ((Expression_Negate (_range) (_expression))) =
    (sem_Expression_Negate ((sem_Range (_range))) ((sem_Expression (_expression))))
sem_Expression ((Expression_NormalApplication (_range) (_function) (_arguments))) =
    (sem_Expression_NormalApplication ((sem_Range (_range))) ((sem_Expression (_function))) ((sem_Expressions (_arguments))))
sem_Expression ((Expression_Parenthesized (_range) (_expression))) =
    (sem_Expression_Parenthesized ((sem_Range (_range))) ((sem_Expression (_expression))))
sem_Expression ((Expression_RecordConstruction (_range) (_name) (_recordExpressionBindings))) =
    (sem_Expression_RecordConstruction ((sem_Range (_range))) ((sem_Name (_name))) ((sem_RecordExpressionBindings (_recordExpressionBindings))))
sem_Expression ((Expression_RecordUpdate (_range) (_expression) (_recordExpressionBindings))) =
    (sem_Expression_RecordUpdate ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_RecordExpressionBindings (_recordExpressionBindings))))
sem_Expression ((Expression_Tuple (_range) (_expressions))) =
    (sem_Expression_Tuple ((sem_Range (_range))) ((sem_Expressions (_expressions))))
sem_Expression ((Expression_TypeApplication (_range) (_name) (_type))) =
    (sem_Expression_TypeApplication ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Type (_type))))
sem_Expression ((Expression_Typed (_range) (_expression) (_type))) =
    (sem_Expression_Typed ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_Type (_type))))
sem_Expression ((Expression_Variable (_range) (_name))) =
    (sem_Expression_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Expression ((Expression_Wildcard (_range))) =
    (sem_Expression_Wildcard ((sem_Range (_range))))
sem_Expression_As :: (T_Range) ->
                     (T_Name) ->
                     (T_Expression) ->
                     (T_Expression)
sem_Expression_As (range_) (name_) (expression_) =
    let _lhsOself :: (Expression)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        _expressionIself :: (Expression)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _expressionIself) =
            (expression_ )
        -- self rule
        (_self@_) =
            Expression_As _rangeIself _nameIself _expressionIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Expression_Case :: (T_Range) ->
                       (T_Expression) ->
                       (T_Alternatives) ->
                       (T_Expression)
sem_Expression_Case (range_) (expression_) (alternatives_) =
    let _lhsOself :: (Expression)
        _rangeIself :: (Range)
        _expressionIself :: (Expression)
        _alternativesIself :: (Alternatives)
        ( _rangeIself) =
            (range_ )
        ( _expressionIself) =
            (expression_ )
        ( _alternativesIself) =
            (alternatives_ )
        -- self rule
        (_self@_) =
            Expression_Case _rangeIself _expressionIself _alternativesIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Expression_Comprehension :: (T_Range) ->
                                (T_Expression) ->
                                (T_Qualifiers) ->
                                (T_Expression)
sem_Expression_Comprehension (range_) (expression_) (qualifiers_) =
    let _lhsOself :: (Expression)
        _rangeIself :: (Range)
        _expressionIself :: (Expression)
        _qualifiersIself :: (Qualifiers)
        ( _rangeIself) =
            (range_ )
        ( _expressionIself) =
            (expression_ )
        ( _qualifiersIself) =
            (qualifiers_ )
        -- self rule
        (_self@_) =
            Expression_Comprehension _rangeIself _expressionIself _qualifiersIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Expression_Constructor :: (T_Range) ->
                              (T_Name) ->
                              (T_Expression)
sem_Expression_Constructor (range_) (name_) =
    let _lhsOself :: (Expression)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        -- self rule
        (_self@_) =
            Expression_Constructor _rangeIself _nameIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Expression_Do :: (T_Range) ->
                     (T_Statements) ->
                     (T_Expression)
sem_Expression_Do (range_) (statements_) =
    let _lhsOself :: (Expression)
        _rangeIself :: (Range)
        _statementsIself :: (Statements)
        ( _rangeIself) =
            (range_ )
        ( _statementsIself) =
            (statements_ )
        -- self rule
        (_self@_) =
            Expression_Do _rangeIself _statementsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Expression_Enum :: (T_Range) ->
                       (T_Expression) ->
                       (T_MaybeExpression) ->
                       (T_MaybeExpression) ->
                       (T_Expression)
sem_Expression_Enum (range_) (from_) (then_) (to_) =
    let _lhsOself :: (Expression)
        _rangeIself :: (Range)
        _fromIself :: (Expression)
        _thenIself :: (MaybeExpression)
        _toIself :: (MaybeExpression)
        ( _rangeIself) =
            (range_ )
        ( _fromIself) =
            (from_ )
        ( _thenIself) =
            (then_ )
        ( _toIself) =
            (to_ )
        -- self rule
        (_self@_) =
            Expression_Enum _rangeIself _fromIself _thenIself _toIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Expression_If :: (T_Range) ->
                     (T_Expression) ->
                     (T_Expression) ->
                     (T_Expression) ->
                     (T_Expression)
sem_Expression_If (range_) (guardExpression_) (thenExpression_) (elseExpression_) =
    let _lhsOself :: (Expression)
        _rangeIself :: (Range)
        _guardExpressionIself :: (Expression)
        _thenExpressionIself :: (Expression)
        _elseExpressionIself :: (Expression)
        ( _rangeIself) =
            (range_ )
        ( _guardExpressionIself) =
            (guardExpression_ )
        ( _thenExpressionIself) =
            (thenExpression_ )
        ( _elseExpressionIself) =
            (elseExpression_ )
        -- self rule
        (_self@_) =
            Expression_If _rangeIself _guardExpressionIself _thenExpressionIself _elseExpressionIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Expression_InfixApplication :: (T_Range) ->
                                   (T_MaybeExpression) ->
                                   (T_Expression) ->
                                   (T_MaybeExpression) ->
                                   (T_Expression)
sem_Expression_InfixApplication (range_) (leftExpression_) (operator_) (rightExpression_) =
    let _lhsOself :: (Expression)
        _rangeIself :: (Range)
        _leftExpressionIself :: (MaybeExpression)
        _operatorIself :: (Expression)
        _rightExpressionIself :: (MaybeExpression)
        ( _rangeIself) =
            (range_ )
        ( _leftExpressionIself) =
            (leftExpression_ )
        ( _operatorIself) =
            (operator_ )
        ( _rightExpressionIself) =
            (rightExpression_ )
        -- self rule
        (_self@_) =
            Expression_InfixApplication _rangeIself _leftExpressionIself _operatorIself _rightExpressionIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Expression_Irrefutable :: (T_Range) ->
                              (T_Expression) ->
                              (T_Expression)
sem_Expression_Irrefutable (range_) (expression_) =
    let _lhsOself :: (Expression)
        _rangeIself :: (Range)
        _expressionIself :: (Expression)
        ( _rangeIself) =
            (range_ )
        ( _expressionIself) =
            (expression_ )
        -- self rule
        (_self@_) =
            Expression_Irrefutable _rangeIself _expressionIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Expression_Lambda :: (T_Range) ->
                         (T_Patterns) ->
                         (T_Expression) ->
                         (T_Expression)
sem_Expression_Lambda (range_) (patterns_) (expression_) =
    let _lhsOself :: (Expression)
        _rangeIself :: (Range)
        _patternsIself :: (Patterns)
        _expressionIself :: (Expression)
        ( _rangeIself) =
            (range_ )
        ( _patternsIself) =
            (patterns_ )
        ( _expressionIself) =
            (expression_ )
        -- self rule
        (_self@_) =
            Expression_Lambda _rangeIself _patternsIself _expressionIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Expression_Let :: (T_Range) ->
                      (T_Declarations) ->
                      (T_Expression) ->
                      (T_Expression)
sem_Expression_Let (range_) (declarations_) (expression_) =
    let _lhsOself :: (Expression)
        _rangeIself :: (Range)
        _declarationsIself :: (Declarations)
        _expressionIself :: (Expression)
        ( _rangeIself) =
            (range_ )
        ( _declarationsIself) =
            (declarations_ )
        ( _expressionIself) =
            (expression_ )
        -- self rule
        (_self@_) =
            Expression_Let _rangeIself _declarationsIself _expressionIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Expression_List :: (T_Range) ->
                       (T_Expressions) ->
                       (T_Expression)
sem_Expression_List (range_) (expressions_) =
    let _lhsOself :: (Expression)
        _rangeIself :: (Range)
        _expressionsIself :: (Expressions)
        ( _rangeIself) =
            (range_ )
        ( _expressionsIself) =
            (expressions_ )
        -- self rule
        (_self@_) =
            Expression_List _rangeIself _expressionsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Expression_Literal :: (T_Range) ->
                          (T_Literal) ->
                          (T_Expression)
sem_Expression_Literal (range_) (literal_) =
    let _lhsOself :: (Expression)
        _rangeIself :: (Range)
        _literalIself :: (Literal)
        ( _rangeIself) =
            (range_ )
        ( _literalIself) =
            (literal_ )
        -- self rule
        (_self@_) =
            Expression_Literal _rangeIself _literalIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Expression_Negate :: (T_Range) ->
                         (T_Expression) ->
                         (T_Expression)
sem_Expression_Negate (range_) (expression_) =
    let _lhsOself :: (Expression)
        _rangeIself :: (Range)
        _expressionIself :: (Expression)
        ( _rangeIself) =
            (range_ )
        ( _expressionIself) =
            (expression_ )
        -- self rule
        (_self@_) =
            Expression_Negate _rangeIself _expressionIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Expression_NormalApplication :: (T_Range) ->
                                    (T_Expression) ->
                                    (T_Expressions) ->
                                    (T_Expression)
sem_Expression_NormalApplication (range_) (function_) (arguments_) =
    let _lhsOself :: (Expression)
        _rangeIself :: (Range)
        _functionIself :: (Expression)
        _argumentsIself :: (Expressions)
        ( _rangeIself) =
            (range_ )
        ( _functionIself) =
            (function_ )
        ( _argumentsIself) =
            (arguments_ )
        -- self rule
        (_self@_) =
            Expression_NormalApplication _rangeIself _functionIself _argumentsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Expression_Parenthesized :: (T_Range) ->
                                (T_Expression) ->
                                (T_Expression)
sem_Expression_Parenthesized (range_) (expression_) =
    let _lhsOself :: (Expression)
        _rangeIself :: (Range)
        _expressionIself :: (Expression)
        ( _rangeIself) =
            (range_ )
        ( _expressionIself) =
            (expression_ )
        -- self rule
        (_self@_) =
            Expression_Parenthesized _rangeIself _expressionIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Expression_RecordConstruction :: (T_Range) ->
                                     (T_Name) ->
                                     (T_RecordExpressionBindings) ->
                                     (T_Expression)
sem_Expression_RecordConstruction (range_) (name_) (recordExpressionBindings_) =
    let _lhsOself :: (Expression)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        _recordExpressionBindingsIself :: (RecordExpressionBindings)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _recordExpressionBindingsIself) =
            (recordExpressionBindings_ )
        -- self rule
        (_self@_) =
            Expression_RecordConstruction _rangeIself _nameIself _recordExpressionBindingsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Expression_RecordUpdate :: (T_Range) ->
                               (T_Expression) ->
                               (T_RecordExpressionBindings) ->
                               (T_Expression)
sem_Expression_RecordUpdate (range_) (expression_) (recordExpressionBindings_) =
    let _lhsOself :: (Expression)
        _rangeIself :: (Range)
        _expressionIself :: (Expression)
        _recordExpressionBindingsIself :: (RecordExpressionBindings)
        ( _rangeIself) =
            (range_ )
        ( _expressionIself) =
            (expression_ )
        ( _recordExpressionBindingsIself) =
            (recordExpressionBindings_ )
        -- self rule
        (_self@_) =
            Expression_RecordUpdate _rangeIself _expressionIself _recordExpressionBindingsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Expression_Tuple :: (T_Range) ->
                        (T_Expressions) ->
                        (T_Expression)
sem_Expression_Tuple (range_) (expressions_) =
    let _lhsOself :: (Expression)
        _rangeIself :: (Range)
        _expressionsIself :: (Expressions)
        ( _rangeIself) =
            (range_ )
        ( _expressionsIself) =
            (expressions_ )
        -- self rule
        (_self@_) =
            Expression_Tuple _rangeIself _expressionsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Expression_TypeApplication :: (T_Range) ->
                                  (T_Name) ->
                                  (T_Type) ->
                                  (T_Expression)
sem_Expression_TypeApplication (range_) (name_) (type_) =
    let _lhsOself :: (Expression)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        _typeIself :: (Type)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _typeIself) =
            (type_ )
        -- self rule
        (_self@_) =
            Expression_TypeApplication _rangeIself _nameIself _typeIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Expression_Typed :: (T_Range) ->
                        (T_Expression) ->
                        (T_Type) ->
                        (T_Expression)
sem_Expression_Typed (range_) (expression_) (type_) =
    let _lhsOself :: (Expression)
        _rangeIself :: (Range)
        _expressionIself :: (Expression)
        _typeIself :: (Type)
        ( _rangeIself) =
            (range_ )
        ( _expressionIself) =
            (expression_ )
        ( _typeIself) =
            (type_ )
        -- self rule
        (_self@_) =
            Expression_Typed _rangeIself _expressionIself _typeIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Expression_Variable :: (T_Range) ->
                           (T_Name) ->
                           (T_Expression)
sem_Expression_Variable (range_) (name_) =
    let _lhsOself :: (Expression)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        -- self rule
        (_self@_) =
            Expression_Variable _rangeIself _nameIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Expression_Wildcard :: (T_Range) ->
                           (T_Expression)
sem_Expression_Wildcard (range_) =
    let _lhsOself :: (Expression)
        _rangeIself :: (Range)
        ( _rangeIself) =
            (range_ )
        -- self rule
        (_self@_) =
            Expression_Wildcard _rangeIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- Expressions -------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Expressions.Cons:
      self

-}
{-
   local variables for Expressions.Nil:
      self

-}
-- semantic domain
type T_Expressions = ( (Expressions))
-- cata
sem_Expressions :: (Expressions) ->
                   (T_Expressions)
sem_Expressions (list) =
    (foldr (sem_Expressions_Cons) (sem_Expressions_Nil) ((map sem_Expression list)))
sem_Expressions_Cons :: (T_Expression) ->
                        (T_Expressions) ->
                        (T_Expressions)
sem_Expressions_Cons (hd_) (tl_) =
    let _lhsOself :: (Expressions)
        _hdIself :: (Expression)
        _tlIself :: (Expressions)
        ( _hdIself) =
            (hd_ )
        ( _tlIself) =
            (tl_ )
        -- self rule
        (_self@_) =
            (:) _hdIself _tlIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Expressions_Nil :: (T_Expressions)
sem_Expressions_Nil  =
    let _lhsOself :: (Expressions)
        -- self rule
        (_self@_) =
            []
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- FieldDeclaration --------------------------------------------
{-
   inherited attributes:

   chained attributes:
      typename             : Name
      vars                 : Names

   synthesised attributes:
      descriptors          : Declarations
      from                 : Expression
      from_plain           : Pattern
      labDescriptors       : [(Name,Declarations)]
      self                 : SELF
      strtype              : Types
      to                   : Pattern
      to_plain             : Expression

-}
{-
   local variables for FieldDeclaration.FieldDeclaration:
      from_plain
      var
      self

-}
-- semantic domain
type T_FieldDeclaration = (Name) ->
                          (Names) ->
                          ( (Declarations),(Expression),(Pattern),([(Name,Declarations)]),(FieldDeclaration),(Types),(Pattern),(Expression),(Name),(Names))
-- cata
sem_FieldDeclaration :: (FieldDeclaration) ->
                        (T_FieldDeclaration)
sem_FieldDeclaration ((FieldDeclaration_FieldDeclaration (_range) (_names) (_type))) =
    (sem_FieldDeclaration_FieldDeclaration ((sem_Range (_range))) ((sem_Names (_names))) ((sem_AnnotatedType (_type))))
sem_FieldDeclaration_FieldDeclaration :: (T_Range) ->
                                         (T_Names) ->
                                         (T_AnnotatedType) ->
                                         (T_FieldDeclaration)
sem_FieldDeclaration_FieldDeclaration (range_) (names_) (type_) =
    \ _lhsItypename
      _lhsIvars ->
        let _lhsOdescriptors :: (Declarations)
            _lhsOfrom :: (Expression)
            _lhsOfrom_plain :: (Pattern)
            _lhsOlabDescriptors :: ([(Name,Declarations)])
            _lhsOself :: (FieldDeclaration)
            _lhsOstrtype :: (Types)
            _lhsOto :: (Pattern)
            _lhsOto_plain :: (Expression)
            _lhsOtypename :: (Name)
            _lhsOvars :: (Names)
            _rangeIself :: (Range)
            _namesIself :: (Names)
            _typeIfrom :: (Expression)
            _typeIfrom_plain :: (Pattern)
            _typeIself :: (AnnotatedType)
            _typeIstrict :: (Bool)
            _typeIstrtype :: (Types)
            _typeIto :: (Pattern)
            _typeIto_plain :: (Expression)
            _typeItypename :: (Name)
            _typeIvars :: (Names)
            _typeOtypename :: (Name)
            _typeOvars :: (Names)
            ( _rangeIself) =
                (range_ )
            ( _namesIself) =
                (names_ )
            ( _typeIfrom,_typeIfrom_plain,_typeIself,_typeIstrict,_typeIstrtype,_typeIto,_typeIto_plain,_typeItypename,_typeIvars) =
                (type_ (_typeOtypename) (_typeOvars))
            -- "StructureTypes.lag"(line 513, column 9)
            (_lhsOlabDescriptors@_) =
                map
                  (\n -> (n
                         ,mkLabdescrDecl
                            _lhsItypename
                            _typeIstrict
                            n
                         )
                  )
                  _namesIself
            -- "StructureTypes.lag"(line 512, column 9)
            (_from_plain@_) =
                varP _var
            -- "StructureTypes.lag"(line 511, column 9)
            (_lhsOfrom@_) =
                parE $ labExp $ varE _var
            -- "StructureTypes.lag"(line 510, column 9)
            (_lhsOto_plain@_) =
                varE _var
            -- "StructureTypes.lag"(line 509, column 9)
            (_lhsOto@_) =
                parP $ labPat $ varP _var
            -- "StructureTypes.lag"(line 505, column 9)
            (_lhsOstrtype@_) =
                [ labType n t
                | t <- _typeIstrtype
                , n <- _namesIself
                ]
            -- "StructureTypes.lag"(line 504, column 9)
            (_lhsOvars@_) =
                tail _lhsIvars
            -- "StructureTypes.lag"(line 503, column 9)
            (_var@_) =
                head _lhsIvars
            -- use rule
            (_lhsOdescriptors@_) =
                []
            -- self rule
            (_self@_) =
                FieldDeclaration_FieldDeclaration _rangeIself _namesIself _typeIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- modified copy rule
            (_lhsOfrom_plain@_) =
                _typeIfrom_plain
            -- copy rule (up)
            (_lhsOtypename@_) =
                _typeItypename
            -- copy rule (down)
            (_typeOtypename@_) =
                _lhsItypename
            -- copy rule (down)
            (_typeOvars@_) =
                _lhsIvars
        in  ( _lhsOdescriptors,_lhsOfrom,_lhsOfrom_plain,_lhsOlabDescriptors,_lhsOself,_lhsOstrtype,_lhsOto,_lhsOto_plain,_lhsOtypename,_lhsOvars)
-- FieldDeclarations -------------------------------------------
{-
   inherited attributes:

   chained attributes:
      typename             : Name
      vars                 : Names

   synthesised attributes:
      descriptors          : Declarations
      from                 : Expressions
      from_plain           : Patterns
      labDescriptors       : [(Name,Declarations)]
      self                 : SELF
      strtype              : Types
      to                   : Patterns
      to_plain             : Expressions

-}
{-
   local variables for FieldDeclarations.Cons:
      self

-}
{-
   local variables for FieldDeclarations.Nil:
      self

-}
-- semantic domain
type T_FieldDeclarations = (Name) ->
                           (Names) ->
                           ( (Declarations),(Expressions),(Patterns),([(Name,Declarations)]),(FieldDeclarations),(Types),(Patterns),(Expressions),(Name),(Names))
-- cata
sem_FieldDeclarations :: (FieldDeclarations) ->
                         (T_FieldDeclarations)
sem_FieldDeclarations (list) =
    (foldr (sem_FieldDeclarations_Cons) (sem_FieldDeclarations_Nil) ((map sem_FieldDeclaration list)))
sem_FieldDeclarations_Cons :: (T_FieldDeclaration) ->
                              (T_FieldDeclarations) ->
                              (T_FieldDeclarations)
sem_FieldDeclarations_Cons (hd_) (tl_) =
    \ _lhsItypename
      _lhsIvars ->
        let _lhsOdescriptors :: (Declarations)
            _lhsOfrom :: (Expressions)
            _lhsOfrom_plain :: (Patterns)
            _lhsOlabDescriptors :: ([(Name,Declarations)])
            _lhsOself :: (FieldDeclarations)
            _lhsOstrtype :: (Types)
            _lhsOto :: (Patterns)
            _lhsOto_plain :: (Expressions)
            _lhsOtypename :: (Name)
            _lhsOvars :: (Names)
            _hdIdescriptors :: (Declarations)
            _hdIfrom :: (Expression)
            _hdIfrom_plain :: (Pattern)
            _hdIlabDescriptors :: ([(Name,Declarations)])
            _hdIself :: (FieldDeclaration)
            _hdIstrtype :: (Types)
            _hdIto :: (Pattern)
            _hdIto_plain :: (Expression)
            _hdItypename :: (Name)
            _hdIvars :: (Names)
            _hdOtypename :: (Name)
            _hdOvars :: (Names)
            _tlIdescriptors :: (Declarations)
            _tlIfrom :: (Expressions)
            _tlIfrom_plain :: (Patterns)
            _tlIlabDescriptors :: ([(Name,Declarations)])
            _tlIself :: (FieldDeclarations)
            _tlIstrtype :: (Types)
            _tlIto :: (Patterns)
            _tlIto_plain :: (Expressions)
            _tlItypename :: (Name)
            _tlIvars :: (Names)
            _tlOtypename :: (Name)
            _tlOvars :: (Names)
            ( _hdIdescriptors,_hdIfrom,_hdIfrom_plain,_hdIlabDescriptors,_hdIself,_hdIstrtype,_hdIto,_hdIto_plain,_hdItypename,_hdIvars) =
                (hd_ (_hdOtypename) (_hdOvars))
            ( _tlIdescriptors,_tlIfrom,_tlIfrom_plain,_tlIlabDescriptors,_tlIself,_tlIstrtype,_tlIto,_tlIto_plain,_tlItypename,_tlIvars) =
                (tl_ (_tlOtypename) (_tlOvars))
            -- use rule
            (_lhsOdescriptors@_) =
                _hdIdescriptors ++ _tlIdescriptors
            -- use rule
            (_lhsOfrom@_) =
                _hdIfrom : _tlIfrom
            -- use rule
            (_lhsOfrom_plain@_) =
                _hdIfrom_plain : _tlIfrom_plain
            -- use rule
            (_lhsOlabDescriptors@_) =
                _hdIlabDescriptors `lDescrUnion` _tlIlabDescriptors
            -- use rule
            (_lhsOstrtype@_) =
                _hdIstrtype ++ _tlIstrtype
            -- use rule
            (_lhsOto@_) =
                _hdIto : _tlIto
            -- use rule
            (_lhsOto_plain@_) =
                _hdIto_plain : _tlIto_plain
            -- self rule
            (_self@_) =
                (:) _hdIself _tlIself
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (up)
            (_lhsOtypename@_) =
                _tlItypename
            -- copy rule (up)
            (_lhsOvars@_) =
                _tlIvars
            -- copy rule (down)
            (_hdOtypename@_) =
                _lhsItypename
            -- copy rule (down)
            (_hdOvars@_) =
                _lhsIvars
            -- copy rule (chain)
            (_tlOtypename@_) =
                _hdItypename
            -- copy rule (chain)
            (_tlOvars@_) =
                _hdIvars
        in  ( _lhsOdescriptors,_lhsOfrom,_lhsOfrom_plain,_lhsOlabDescriptors,_lhsOself,_lhsOstrtype,_lhsOto,_lhsOto_plain,_lhsOtypename,_lhsOvars)
sem_FieldDeclarations_Nil :: (T_FieldDeclarations)
sem_FieldDeclarations_Nil  =
    \ _lhsItypename
      _lhsIvars ->
        let _lhsOdescriptors :: (Declarations)
            _lhsOfrom :: (Expressions)
            _lhsOfrom_plain :: (Patterns)
            _lhsOlabDescriptors :: ([(Name,Declarations)])
            _lhsOself :: (FieldDeclarations)
            _lhsOstrtype :: (Types)
            _lhsOto :: (Patterns)
            _lhsOto_plain :: (Expressions)
            _lhsOtypename :: (Name)
            _lhsOvars :: (Names)
            -- use rule
            (_lhsOdescriptors@_) =
                []
            -- use rule
            (_lhsOfrom@_) =
                []
            -- use rule
            (_lhsOfrom_plain@_) =
                []
            -- use rule
            (_lhsOlabDescriptors@_) =
                []
            -- use rule
            (_lhsOstrtype@_) =
                []
            -- use rule
            (_lhsOto@_) =
                []
            -- use rule
            (_lhsOto_plain@_) =
                []
            -- self rule
            (_self@_) =
                []
            -- self rule
            (_lhsOself@_) =
                _self
            -- copy rule (chain)
            (_lhsOtypename@_) =
                _lhsItypename
            -- copy rule (chain)
            (_lhsOvars@_) =
                _lhsIvars
        in  ( _lhsOdescriptors,_lhsOfrom,_lhsOfrom_plain,_lhsOlabDescriptors,_lhsOself,_lhsOstrtype,_lhsOto,_lhsOto_plain,_lhsOtypename,_lhsOvars)
-- Fixity ------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Fixity.Infix:
      self

-}
{-
   local variables for Fixity.Infixl:
      self

-}
{-
   local variables for Fixity.Infixr:
      self

-}
-- semantic domain
type T_Fixity = ( (Fixity))
-- cata
sem_Fixity :: (Fixity) ->
              (T_Fixity)
sem_Fixity ((Fixity_Infix (_range))) =
    (sem_Fixity_Infix ((sem_Range (_range))))
sem_Fixity ((Fixity_Infixl (_range))) =
    (sem_Fixity_Infixl ((sem_Range (_range))))
sem_Fixity ((Fixity_Infixr (_range))) =
    (sem_Fixity_Infixr ((sem_Range (_range))))
sem_Fixity_Infix :: (T_Range) ->
                    (T_Fixity)
sem_Fixity_Infix (range_) =
    let _lhsOself :: (Fixity)
        _rangeIself :: (Range)
        ( _rangeIself) =
            (range_ )
        -- self rule
        (_self@_) =
            Fixity_Infix _rangeIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Fixity_Infixl :: (T_Range) ->
                     (T_Fixity)
sem_Fixity_Infixl (range_) =
    let _lhsOself :: (Fixity)
        _rangeIself :: (Range)
        ( _rangeIself) =
            (range_ )
        -- self rule
        (_self@_) =
            Fixity_Infixl _rangeIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Fixity_Infixr :: (T_Range) ->
                     (T_Fixity)
sem_Fixity_Infixr (range_) =
    let _lhsOself :: (Fixity)
        _rangeIself :: (Range)
        ( _rangeIself) =
            (range_ )
        -- self rule
        (_self@_) =
            Fixity_Infixr _rangeIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- FunctionBinding ---------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for FunctionBinding.FunctionBinding:
      self

-}
-- semantic domain
type T_FunctionBinding = ( (FunctionBinding))
-- cata
sem_FunctionBinding :: (FunctionBinding) ->
                       (T_FunctionBinding)
sem_FunctionBinding ((FunctionBinding_FunctionBinding (_range) (_lefthandside) (_righthandside))) =
    (sem_FunctionBinding_FunctionBinding ((sem_Range (_range))) ((sem_LeftHandSide (_lefthandside))) ((sem_RightHandSide (_righthandside))))
sem_FunctionBinding_FunctionBinding :: (T_Range) ->
                                       (T_LeftHandSide) ->
                                       (T_RightHandSide) ->
                                       (T_FunctionBinding)
sem_FunctionBinding_FunctionBinding (range_) (lefthandside_) (righthandside_) =
    let _lhsOself :: (FunctionBinding)
        _rangeIself :: (Range)
        _lefthandsideIself :: (LeftHandSide)
        _righthandsideIself :: (RightHandSide)
        ( _rangeIself) =
            (range_ )
        ( _lefthandsideIself) =
            (lefthandside_ )
        ( _righthandsideIself) =
            (righthandside_ )
        -- self rule
        (_self@_) =
            FunctionBinding_FunctionBinding _rangeIself _lefthandsideIself _righthandsideIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- FunctionBindings --------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for FunctionBindings.Cons:
      self

-}
{-
   local variables for FunctionBindings.Nil:
      self

-}
-- semantic domain
type T_FunctionBindings = ( (FunctionBindings))
-- cata
sem_FunctionBindings :: (FunctionBindings) ->
                        (T_FunctionBindings)
sem_FunctionBindings (list) =
    (foldr (sem_FunctionBindings_Cons) (sem_FunctionBindings_Nil) ((map sem_FunctionBinding list)))
sem_FunctionBindings_Cons :: (T_FunctionBinding) ->
                             (T_FunctionBindings) ->
                             (T_FunctionBindings)
sem_FunctionBindings_Cons (hd_) (tl_) =
    let _lhsOself :: (FunctionBindings)
        _hdIself :: (FunctionBinding)
        _tlIself :: (FunctionBindings)
        ( _hdIself) =
            (hd_ )
        ( _tlIself) =
            (tl_ )
        -- self rule
        (_self@_) =
            (:) _hdIself _tlIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_FunctionBindings_Nil :: (T_FunctionBindings)
sem_FunctionBindings_Nil  =
    let _lhsOself :: (FunctionBindings)
        -- self rule
        (_self@_) =
            []
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- GuardedExpression -------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for GuardedExpression.GuardedExpression:
      self

-}
-- semantic domain
type T_GuardedExpression = ( (GuardedExpression))
-- cata
sem_GuardedExpression :: (GuardedExpression) ->
                         (T_GuardedExpression)
sem_GuardedExpression ((GuardedExpression_GuardedExpression (_range) (_guard) (_expression))) =
    (sem_GuardedExpression_GuardedExpression ((sem_Range (_range))) ((sem_Expression (_guard))) ((sem_Expression (_expression))))
sem_GuardedExpression_GuardedExpression :: (T_Range) ->
                                           (T_Expression) ->
                                           (T_Expression) ->
                                           (T_GuardedExpression)
sem_GuardedExpression_GuardedExpression (range_) (guard_) (expression_) =
    let _lhsOself :: (GuardedExpression)
        _rangeIself :: (Range)
        _guardIself :: (Expression)
        _expressionIself :: (Expression)
        ( _rangeIself) =
            (range_ )
        ( _guardIself) =
            (guard_ )
        ( _expressionIself) =
            (expression_ )
        -- self rule
        (_self@_) =
            GuardedExpression_GuardedExpression _rangeIself _guardIself _expressionIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- GuardedExpressions ------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for GuardedExpressions.Cons:
      self

-}
{-
   local variables for GuardedExpressions.Nil:
      self

-}
-- semantic domain
type T_GuardedExpressions = ( (GuardedExpressions))
-- cata
sem_GuardedExpressions :: (GuardedExpressions) ->
                          (T_GuardedExpressions)
sem_GuardedExpressions (list) =
    (foldr (sem_GuardedExpressions_Cons) (sem_GuardedExpressions_Nil) ((map sem_GuardedExpression list)))
sem_GuardedExpressions_Cons :: (T_GuardedExpression) ->
                               (T_GuardedExpressions) ->
                               (T_GuardedExpressions)
sem_GuardedExpressions_Cons (hd_) (tl_) =
    let _lhsOself :: (GuardedExpressions)
        _hdIself :: (GuardedExpression)
        _tlIself :: (GuardedExpressions)
        ( _hdIself) =
            (hd_ )
        ( _tlIself) =
            (tl_ )
        -- self rule
        (_self@_) =
            (:) _hdIself _tlIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_GuardedExpressions_Nil :: (T_GuardedExpressions)
sem_GuardedExpressions_Nil  =
    let _lhsOself :: (GuardedExpressions)
        -- self rule
        (_self@_) =
            []
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- Import ------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Import.TypeOrClass:
      self

-}
{-
   local variables for Import.TypeOrClassComplete:
      self

-}
{-
   local variables for Import.Variable:
      self

-}
-- semantic domain
type T_Import = ( (Import))
-- cata
sem_Import :: (Import) ->
              (T_Import)
sem_Import ((Import_TypeOrClass (_range) (_name) (_names))) =
    (sem_Import_TypeOrClass ((sem_Range (_range))) ((sem_Name (_name))) ((sem_MaybeNames (_names))))
sem_Import ((Import_TypeOrClassComplete (_range) (_name))) =
    (sem_Import_TypeOrClassComplete ((sem_Range (_range))) ((sem_Name (_name))))
sem_Import ((Import_Variable (_range) (_name))) =
    (sem_Import_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Import_TypeOrClass :: (T_Range) ->
                          (T_Name) ->
                          (T_MaybeNames) ->
                          (T_Import)
sem_Import_TypeOrClass (range_) (name_) (names_) =
    let _lhsOself :: (Import)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        _namesIself :: (MaybeNames)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _namesIself) =
            (names_ )
        -- self rule
        (_self@_) =
            Import_TypeOrClass _rangeIself _nameIself _namesIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Import_TypeOrClassComplete :: (T_Range) ->
                                  (T_Name) ->
                                  (T_Import)
sem_Import_TypeOrClassComplete (range_) (name_) =
    let _lhsOself :: (Import)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        -- self rule
        (_self@_) =
            Import_TypeOrClassComplete _rangeIself _nameIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Import_Variable :: (T_Range) ->
                       (T_Name) ->
                       (T_Import)
sem_Import_Variable (range_) (name_) =
    let _lhsOself :: (Import)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        -- self rule
        (_self@_) =
            Import_Variable _rangeIself _nameIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- ImportDeclaration -------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for ImportDeclaration.Empty:
      self

-}
{-
   local variables for ImportDeclaration.Import:
      self

-}
-- semantic domain
type T_ImportDeclaration = ( (ImportDeclaration))
-- cata
sem_ImportDeclaration :: (ImportDeclaration) ->
                         (T_ImportDeclaration)
sem_ImportDeclaration ((ImportDeclaration_Empty (_range))) =
    (sem_ImportDeclaration_Empty ((sem_Range (_range))))
sem_ImportDeclaration ((ImportDeclaration_Import (_range) (_qualified) (_name) (_asname) (_importspecification))) =
    (sem_ImportDeclaration_Import ((sem_Range (_range))) (_qualified) ((sem_ModuleName (_name))) ((sem_MaybeModuleName (_asname))) ((sem_MaybeImportSpecification (_importspecification))))
sem_ImportDeclaration_Empty :: (T_Range) ->
                               (T_ImportDeclaration)
sem_ImportDeclaration_Empty (range_) =
    let _lhsOself :: (ImportDeclaration)
        _rangeIself :: (Range)
        ( _rangeIself) =
            (range_ )
        -- self rule
        (_self@_) =
            ImportDeclaration_Empty _rangeIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_ImportDeclaration_Import :: (T_Range) ->
                                (Bool) ->
                                (T_ModuleName) ->
                                (T_MaybeModuleName) ->
                                (T_MaybeImportSpecification) ->
                                (T_ImportDeclaration)
sem_ImportDeclaration_Import (range_) (qualified_) (name_) (asname_) (importspecification_) =
    let _lhsOself :: (ImportDeclaration)
        _rangeIself :: (Range)
        _nameIself :: (ModuleName)
        _asnameIself :: (MaybeModuleName)
        _importspecificationIself :: (MaybeImportSpecification)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _asnameIself) =
            (asname_ )
        ( _importspecificationIself) =
            (importspecification_ )
        -- self rule
        (_self@_) =
            ImportDeclaration_Import _rangeIself qualified_ _nameIself _asnameIself _importspecificationIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- ImportDeclarations ------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for ImportDeclarations.Cons:
      self

-}
{-
   local variables for ImportDeclarations.Nil:
      self

-}
-- semantic domain
type T_ImportDeclarations = ( (ImportDeclarations))
-- cata
sem_ImportDeclarations :: (ImportDeclarations) ->
                          (T_ImportDeclarations)
sem_ImportDeclarations (list) =
    (foldr (sem_ImportDeclarations_Cons) (sem_ImportDeclarations_Nil) ((map sem_ImportDeclaration list)))
sem_ImportDeclarations_Cons :: (T_ImportDeclaration) ->
                               (T_ImportDeclarations) ->
                               (T_ImportDeclarations)
sem_ImportDeclarations_Cons (hd_) (tl_) =
    let _lhsOself :: (ImportDeclarations)
        _hdIself :: (ImportDeclaration)
        _tlIself :: (ImportDeclarations)
        ( _hdIself) =
            (hd_ )
        ( _tlIself) =
            (tl_ )
        -- self rule
        (_self@_) =
            (:) _hdIself _tlIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_ImportDeclarations_Nil :: (T_ImportDeclarations)
sem_ImportDeclarations_Nil  =
    let _lhsOself :: (ImportDeclarations)
        -- self rule
        (_self@_) =
            []
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- ImportSpecification -----------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for ImportSpecification.Import:
      self

-}
-- semantic domain
type T_ImportSpecification = ( (ImportSpecification))
-- cata
sem_ImportSpecification :: (ImportSpecification) ->
                           (T_ImportSpecification)
sem_ImportSpecification ((ImportSpecification_Import (_range) (_hiding) (_imports))) =
    (sem_ImportSpecification_Import ((sem_Range (_range))) (_hiding) ((sem_Imports (_imports))))
sem_ImportSpecification_Import :: (T_Range) ->
                                  (Bool) ->
                                  (T_Imports) ->
                                  (T_ImportSpecification)
sem_ImportSpecification_Import (range_) (hiding_) (imports_) =
    let _lhsOself :: (ImportSpecification)
        _rangeIself :: (Range)
        _importsIself :: (Imports)
        ( _rangeIself) =
            (range_ )
        ( _importsIself) =
            (imports_ )
        -- self rule
        (_self@_) =
            ImportSpecification_Import _rangeIself hiding_ _importsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- Imports -----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Imports.Cons:
      self

-}
{-
   local variables for Imports.Nil:
      self

-}
-- semantic domain
type T_Imports = ( (Imports))
-- cata
sem_Imports :: (Imports) ->
               (T_Imports)
sem_Imports (list) =
    (foldr (sem_Imports_Cons) (sem_Imports_Nil) ((map sem_Import list)))
sem_Imports_Cons :: (T_Import) ->
                    (T_Imports) ->
                    (T_Imports)
sem_Imports_Cons (hd_) (tl_) =
    let _lhsOself :: (Imports)
        _hdIself :: (Import)
        _tlIself :: (Imports)
        ( _hdIself) =
            (hd_ )
        ( _tlIself) =
            (tl_ )
        -- self rule
        (_self@_) =
            (:) _hdIself _tlIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Imports_Nil :: (T_Imports)
sem_Imports_Nil  =
    let _lhsOself :: (Imports)
        -- self rule
        (_self@_) =
            []
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- InterfaceDeclaration ----------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for InterfaceDeclaration.Abstract:
      self

-}
{-
   local variables for InterfaceDeclaration.Binding:
      self

-}
{-
   local variables for InterfaceDeclaration.Consig:
      self

-}
{-
   local variables for InterfaceDeclaration.Declarations:
      self

-}
{-
   local variables for InterfaceDeclaration.Dependency:
      self

-}
{-
   local variables for InterfaceDeclaration.Import:
      self

-}
{-
   local variables for InterfaceDeclaration.SetModule:
      self

-}
-- semantic domain
type T_InterfaceDeclaration = ( (InterfaceDeclaration))
-- cata
sem_InterfaceDeclaration :: (InterfaceDeclaration) ->
                            (T_InterfaceDeclaration)
sem_InterfaceDeclaration ((InterfaceDeclaration_Abstract (_range) (_name) (_constructors) (_types) (_kind))) =
    (sem_InterfaceDeclaration_Abstract ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Names (_constructors))) ((sem_Types (_types))) ((sem_Kind (_kind))))
sem_InterfaceDeclaration ((InterfaceDeclaration_Binding (_range) (_name))) =
    (sem_InterfaceDeclaration_Binding ((sem_Range (_range))) ((sem_Name (_name))))
sem_InterfaceDeclaration ((InterfaceDeclaration_Consig (_range) (_typelevel) (_name) (_types))) =
    (sem_InterfaceDeclaration_Consig ((sem_Range (_range))) (_typelevel) ((sem_Name (_name))) ((sem_TypeArguments (_types))))
sem_InterfaceDeclaration ((InterfaceDeclaration_Declarations (_range) (_declarations))) =
    (sem_InterfaceDeclaration_Declarations ((sem_Range (_range))) ((sem_Declarations (_declarations))))
sem_InterfaceDeclaration ((InterfaceDeclaration_Dependency (_range) (_name) (_kind) (_bindings))) =
    (sem_InterfaceDeclaration_Dependency ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Kind (_kind))) ((sem_DependencyBindings (_bindings))))
sem_InterfaceDeclaration ((InterfaceDeclaration_Import (_range) (_module))) =
    (sem_InterfaceDeclaration_Import ((sem_Range (_range))) ((sem_ModuleName (_module))))
sem_InterfaceDeclaration ((InterfaceDeclaration_SetModule (_range) (_module) (_declarations))) =
    (sem_InterfaceDeclaration_SetModule ((sem_Range (_range))) ((sem_ModuleName (_module))) ((sem_InterfaceDeclarations (_declarations))))
sem_InterfaceDeclaration_Abstract :: (T_Range) ->
                                     (T_Name) ->
                                     (T_Names) ->
                                     (T_Types) ->
                                     (T_Kind) ->
                                     (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Abstract (range_) (name_) (constructors_) (types_) (kind_) =
    let _lhsOself :: (InterfaceDeclaration)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        _constructorsIself :: (Names)
        _typesIself :: (Types)
        _kindIself :: (Kind)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _constructorsIself) =
            (constructors_ )
        ( _typesIself) =
            (types_ )
        ( _kindIself) =
            (kind_ )
        -- self rule
        (_self@_) =
            InterfaceDeclaration_Abstract _rangeIself _nameIself _constructorsIself _typesIself _kindIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_InterfaceDeclaration_Binding :: (T_Range) ->
                                    (T_Name) ->
                                    (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Binding (range_) (name_) =
    let _lhsOself :: (InterfaceDeclaration)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        -- self rule
        (_self@_) =
            InterfaceDeclaration_Binding _rangeIself _nameIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_InterfaceDeclaration_Consig :: (T_Range) ->
                                   (Bool) ->
                                   (T_Name) ->
                                   (T_TypeArguments) ->
                                   (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Consig (range_) (typelevel_) (name_) (types_) =
    let _lhsOself :: (InterfaceDeclaration)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        _typesIself :: (TypeArguments)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _typesIself) =
            (types_ )
        -- self rule
        (_self@_) =
            InterfaceDeclaration_Consig _rangeIself typelevel_ _nameIself _typesIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_InterfaceDeclaration_Declarations :: (T_Range) ->
                                         (T_Declarations) ->
                                         (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Declarations (range_) (declarations_) =
    let _lhsOself :: (InterfaceDeclaration)
        _rangeIself :: (Range)
        _declarationsIself :: (Declarations)
        ( _rangeIself) =
            (range_ )
        ( _declarationsIself) =
            (declarations_ )
        -- self rule
        (_self@_) =
            InterfaceDeclaration_Declarations _rangeIself _declarationsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_InterfaceDeclaration_Dependency :: (T_Range) ->
                                       (T_Name) ->
                                       (T_Kind) ->
                                       (T_DependencyBindings) ->
                                       (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Dependency (range_) (name_) (kind_) (bindings_) =
    let _lhsOself :: (InterfaceDeclaration)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        _kindIself :: (Kind)
        _bindingsIself :: (DependencyBindings)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _kindIself) =
            (kind_ )
        ( _bindingsIself) =
            (bindings_ )
        -- self rule
        (_self@_) =
            InterfaceDeclaration_Dependency _rangeIself _nameIself _kindIself _bindingsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_InterfaceDeclaration_Import :: (T_Range) ->
                                   (T_ModuleName) ->
                                   (T_InterfaceDeclaration)
sem_InterfaceDeclaration_Import (range_) (module_) =
    let _lhsOself :: (InterfaceDeclaration)
        _rangeIself :: (Range)
        _moduleIself :: (ModuleName)
        ( _rangeIself) =
            (range_ )
        ( _moduleIself) =
            (module_ )
        -- self rule
        (_self@_) =
            InterfaceDeclaration_Import _rangeIself _moduleIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_InterfaceDeclaration_SetModule :: (T_Range) ->
                                      (T_ModuleName) ->
                                      (T_InterfaceDeclarations) ->
                                      (T_InterfaceDeclaration)
sem_InterfaceDeclaration_SetModule (range_) (module_) (declarations_) =
    let _lhsOself :: (InterfaceDeclaration)
        _rangeIself :: (Range)
        _moduleIself :: (ModuleName)
        _declarationsIself :: (InterfaceDeclarations)
        ( _rangeIself) =
            (range_ )
        ( _moduleIself) =
            (module_ )
        ( _declarationsIself) =
            (declarations_ )
        -- self rule
        (_self@_) =
            InterfaceDeclaration_SetModule _rangeIself _moduleIself _declarationsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- InterfaceDeclarations ---------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for InterfaceDeclarations.Cons:
      self

-}
{-
   local variables for InterfaceDeclarations.Nil:
      self

-}
-- semantic domain
type T_InterfaceDeclarations = ( (InterfaceDeclarations))
-- cata
sem_InterfaceDeclarations :: (InterfaceDeclarations) ->
                             (T_InterfaceDeclarations)
sem_InterfaceDeclarations (list) =
    (foldr (sem_InterfaceDeclarations_Cons) (sem_InterfaceDeclarations_Nil) ((map sem_InterfaceDeclaration list)))
sem_InterfaceDeclarations_Cons :: (T_InterfaceDeclaration) ->
                                  (T_InterfaceDeclarations) ->
                                  (T_InterfaceDeclarations)
sem_InterfaceDeclarations_Cons (hd_) (tl_) =
    let _lhsOself :: (InterfaceDeclarations)
        _hdIself :: (InterfaceDeclaration)
        _tlIself :: (InterfaceDeclarations)
        ( _hdIself) =
            (hd_ )
        ( _tlIself) =
            (tl_ )
        -- self rule
        (_self@_) =
            (:) _hdIself _tlIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_InterfaceDeclarations_Nil :: (T_InterfaceDeclarations)
sem_InterfaceDeclarations_Nil  =
    let _lhsOself :: (InterfaceDeclarations)
        -- self rule
        (_self@_) =
            []
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- Kind --------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Kind.Arrow:
      self

-}
{-
   local variables for Kind.Error:
      self

-}
{-
   local variables for Kind.Parenthesized:
      self

-}
{-
   local variables for Kind.Star:
      self

-}
{-
   local variables for Kind.Variable:
      self

-}
-- semantic domain
type T_Kind = ( (Kind))
-- cata
sem_Kind :: (Kind) ->
            (T_Kind)
sem_Kind ((Kind_Arrow (_range) (_leftKind) (_rightKind))) =
    (sem_Kind_Arrow ((sem_Range (_range))) ((sem_Kind (_leftKind))) ((sem_Kind (_rightKind))))
sem_Kind ((Kind_Error )) =
    (sem_Kind_Error )
sem_Kind ((Kind_Parenthesized (_range) (_kind))) =
    (sem_Kind_Parenthesized ((sem_Range (_range))) ((sem_Kind (_kind))))
sem_Kind ((Kind_Star (_range))) =
    (sem_Kind_Star ((sem_Range (_range))))
sem_Kind ((Kind_Variable (_range) (_name))) =
    (sem_Kind_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Kind_Arrow :: (T_Range) ->
                  (T_Kind) ->
                  (T_Kind) ->
                  (T_Kind)
sem_Kind_Arrow (range_) (leftKind_) (rightKind_) =
    let _lhsOself :: (Kind)
        _rangeIself :: (Range)
        _leftKindIself :: (Kind)
        _rightKindIself :: (Kind)
        ( _rangeIself) =
            (range_ )
        ( _leftKindIself) =
            (leftKind_ )
        ( _rightKindIself) =
            (rightKind_ )
        -- self rule
        (_self@_) =
            Kind_Arrow _rangeIself _leftKindIself _rightKindIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Kind_Error :: (T_Kind)
sem_Kind_Error  =
    let _lhsOself :: (Kind)
        -- self rule
        (_self@_) =
            Kind_Error
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Kind_Parenthesized :: (T_Range) ->
                          (T_Kind) ->
                          (T_Kind)
sem_Kind_Parenthesized (range_) (kind_) =
    let _lhsOself :: (Kind)
        _rangeIself :: (Range)
        _kindIself :: (Kind)
        ( _rangeIself) =
            (range_ )
        ( _kindIself) =
            (kind_ )
        -- self rule
        (_self@_) =
            Kind_Parenthesized _rangeIself _kindIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Kind_Star :: (T_Range) ->
                 (T_Kind)
sem_Kind_Star (range_) =
    let _lhsOself :: (Kind)
        _rangeIself :: (Range)
        ( _rangeIself) =
            (range_ )
        -- self rule
        (_self@_) =
            Kind_Star _rangeIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Kind_Variable :: (T_Range) ->
                     (T_Name) ->
                     (T_Kind)
sem_Kind_Variable (range_) (name_) =
    let _lhsOself :: (Kind)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        -- self rule
        (_self@_) =
            Kind_Variable _rangeIself _nameIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- KindAnnotatedName -------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF
      typevariables        : Names

-}
{-
   local variables for KindAnnotatedName.KindAnnotatedName:
      self

-}
-- semantic domain
type T_KindAnnotatedName = ( (KindAnnotatedName),(Names))
-- cata
sem_KindAnnotatedName :: (KindAnnotatedName) ->
                         (T_KindAnnotatedName)
sem_KindAnnotatedName ((KindAnnotatedName_KindAnnotatedName (_range) (_name) (_kind))) =
    (sem_KindAnnotatedName_KindAnnotatedName ((sem_Range (_range))) ((sem_Name (_name))) ((sem_MaybeKind (_kind))))
sem_KindAnnotatedName_KindAnnotatedName :: (T_Range) ->
                                           (T_Name) ->
                                           (T_MaybeKind) ->
                                           (T_KindAnnotatedName)
sem_KindAnnotatedName_KindAnnotatedName (range_) (name_) (kind_) =
    let _lhsOself :: (KindAnnotatedName)
        _lhsOtypevariables :: (Names)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        _kindIself :: (MaybeKind)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _kindIself) =
            (kind_ )
        -- "StructureTypes.lag"(line 137, column 9)
        (_lhsOtypevariables@_) =
            [_nameIself]
        -- self rule
        (_self@_) =
            KindAnnotatedName_KindAnnotatedName _rangeIself _nameIself _kindIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself,_lhsOtypevariables)
-- KindAnnotatedNames ------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF
      typevariables        : Names

-}
{-
   local variables for KindAnnotatedNames.Cons:
      self

-}
{-
   local variables for KindAnnotatedNames.Nil:
      self

-}
-- semantic domain
type T_KindAnnotatedNames = ( (KindAnnotatedNames),(Names))
-- cata
sem_KindAnnotatedNames :: (KindAnnotatedNames) ->
                          (T_KindAnnotatedNames)
sem_KindAnnotatedNames (list) =
    (foldr (sem_KindAnnotatedNames_Cons) (sem_KindAnnotatedNames_Nil) ((map sem_KindAnnotatedName list)))
sem_KindAnnotatedNames_Cons :: (T_KindAnnotatedName) ->
                               (T_KindAnnotatedNames) ->
                               (T_KindAnnotatedNames)
sem_KindAnnotatedNames_Cons (hd_) (tl_) =
    let _lhsOself :: (KindAnnotatedNames)
        _lhsOtypevariables :: (Names)
        _hdIself :: (KindAnnotatedName)
        _hdItypevariables :: (Names)
        _tlIself :: (KindAnnotatedNames)
        _tlItypevariables :: (Names)
        ( _hdIself,_hdItypevariables) =
            (hd_ )
        ( _tlIself,_tlItypevariables) =
            (tl_ )
        -- use rule
        (_lhsOtypevariables@_) =
            _hdItypevariables ++ _tlItypevariables
        -- self rule
        (_self@_) =
            (:) _hdIself _tlIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself,_lhsOtypevariables)
sem_KindAnnotatedNames_Nil :: (T_KindAnnotatedNames)
sem_KindAnnotatedNames_Nil  =
    let _lhsOself :: (KindAnnotatedNames)
        _lhsOtypevariables :: (Names)
        -- use rule
        (_lhsOtypevariables@_) =
            []
        -- self rule
        (_self@_) =
            []
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself,_lhsOtypevariables)
-- KindArgument ------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for KindArgument.Arrow:
      self

-}
{-
   local variables for KindArgument.Star:
      self

-}
-- semantic domain
type T_KindArgument = ( (KindArgument))
-- cata
sem_KindArgument :: (KindArgument) ->
                    (T_KindArgument)
sem_KindArgument ((KindArgument_Arrow (_range) (_leftkindvariable) (_rightkindvariable))) =
    (sem_KindArgument_Arrow ((sem_Range (_range))) ((sem_Name (_leftkindvariable))) ((sem_Name (_rightkindvariable))))
sem_KindArgument ((KindArgument_Star (_range))) =
    (sem_KindArgument_Star ((sem_Range (_range))))
sem_KindArgument_Arrow :: (T_Range) ->
                          (T_Name) ->
                          (T_Name) ->
                          (T_KindArgument)
sem_KindArgument_Arrow (range_) (leftkindvariable_) (rightkindvariable_) =
    let _lhsOself :: (KindArgument)
        _rangeIself :: (Range)
        _leftkindvariableIself :: (Name)
        _rightkindvariableIself :: (Name)
        ( _rangeIself) =
            (range_ )
        ( _leftkindvariableIself) =
            (leftkindvariable_ )
        ( _rightkindvariableIself) =
            (rightkindvariable_ )
        -- self rule
        (_self@_) =
            KindArgument_Arrow _rangeIself _leftkindvariableIself _rightkindvariableIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_KindArgument_Star :: (T_Range) ->
                         (T_KindArgument)
sem_KindArgument_Star (range_) =
    let _lhsOself :: (KindArgument)
        _rangeIself :: (Range)
        ( _rangeIself) =
            (range_ )
        -- self rule
        (_self@_) =
            KindArgument_Star _rangeIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- KindIndexedBinding ------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for KindIndexedBinding.KindIndexedBinding:
      self

-}
-- semantic domain
type T_KindIndexedBinding = ( (KindIndexedBinding))
-- cata
sem_KindIndexedBinding :: (KindIndexedBinding) ->
                          (T_KindIndexedBinding)
sem_KindIndexedBinding ((KindIndexedBinding_KindIndexedBinding (_range) (_name) (_kindargument) (_typevariables) (_type))) =
    (sem_KindIndexedBinding_KindIndexedBinding ((sem_Range (_range))) ((sem_Name (_name))) ((sem_KindArgument (_kindargument))) ((sem_Names (_typevariables))) ((sem_Type (_type))))
sem_KindIndexedBinding_KindIndexedBinding :: (T_Range) ->
                                             (T_Name) ->
                                             (T_KindArgument) ->
                                             (T_Names) ->
                                             (T_Type) ->
                                             (T_KindIndexedBinding)
sem_KindIndexedBinding_KindIndexedBinding (range_) (name_) (kindargument_) (typevariables_) (type_) =
    let _lhsOself :: (KindIndexedBinding)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        _kindargumentIself :: (KindArgument)
        _typevariablesIself :: (Names)
        _typeIself :: (Type)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _kindargumentIself) =
            (kindargument_ )
        ( _typevariablesIself) =
            (typevariables_ )
        ( _typeIself) =
            (type_ )
        -- self rule
        (_self@_) =
            KindIndexedBinding_KindIndexedBinding _rangeIself _nameIself _kindargumentIself _typevariablesIself _typeIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- KindIndexedBindings -----------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for KindIndexedBindings.Cons:
      self

-}
{-
   local variables for KindIndexedBindings.Nil:
      self

-}
-- semantic domain
type T_KindIndexedBindings = ( (KindIndexedBindings))
-- cata
sem_KindIndexedBindings :: (KindIndexedBindings) ->
                           (T_KindIndexedBindings)
sem_KindIndexedBindings (list) =
    (foldr (sem_KindIndexedBindings_Cons) (sem_KindIndexedBindings_Nil) ((map sem_KindIndexedBinding list)))
sem_KindIndexedBindings_Cons :: (T_KindIndexedBinding) ->
                                (T_KindIndexedBindings) ->
                                (T_KindIndexedBindings)
sem_KindIndexedBindings_Cons (hd_) (tl_) =
    let _lhsOself :: (KindIndexedBindings)
        _hdIself :: (KindIndexedBinding)
        _tlIself :: (KindIndexedBindings)
        ( _hdIself) =
            (hd_ )
        ( _tlIself) =
            (tl_ )
        -- self rule
        (_self@_) =
            (:) _hdIself _tlIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_KindIndexedBindings_Nil :: (T_KindIndexedBindings)
sem_KindIndexedBindings_Nil  =
    let _lhsOself :: (KindIndexedBindings)
        -- self rule
        (_self@_) =
            []
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- LeftHandSide ------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for LeftHandSide.Function:
      self

-}
{-
   local variables for LeftHandSide.Infix:
      self

-}
{-
   local variables for LeftHandSide.Parenthesized:
      self

-}
-- semantic domain
type T_LeftHandSide = ( (LeftHandSide))
-- cata
sem_LeftHandSide :: (LeftHandSide) ->
                    (T_LeftHandSide)
sem_LeftHandSide ((LeftHandSide_Function (_range) (_name) (_patterns))) =
    (sem_LeftHandSide_Function ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Patterns (_patterns))))
sem_LeftHandSide ((LeftHandSide_Infix (_range) (_leftPattern) (_operator) (_rightPattern))) =
    (sem_LeftHandSide_Infix ((sem_Range (_range))) ((sem_Pattern (_leftPattern))) ((sem_Name (_operator))) ((sem_Pattern (_rightPattern))))
sem_LeftHandSide ((LeftHandSide_Parenthesized (_range) (_lefthandside) (_patterns))) =
    (sem_LeftHandSide_Parenthesized ((sem_Range (_range))) ((sem_LeftHandSide (_lefthandside))) ((sem_Patterns (_patterns))))
sem_LeftHandSide_Function :: (T_Range) ->
                             (T_Name) ->
                             (T_Patterns) ->
                             (T_LeftHandSide)
sem_LeftHandSide_Function (range_) (name_) (patterns_) =
    let _lhsOself :: (LeftHandSide)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        _patternsIself :: (Patterns)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _patternsIself) =
            (patterns_ )
        -- self rule
        (_self@_) =
            LeftHandSide_Function _rangeIself _nameIself _patternsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_LeftHandSide_Infix :: (T_Range) ->
                          (T_Pattern) ->
                          (T_Name) ->
                          (T_Pattern) ->
                          (T_LeftHandSide)
sem_LeftHandSide_Infix (range_) (leftPattern_) (operator_) (rightPattern_) =
    let _lhsOself :: (LeftHandSide)
        _rangeIself :: (Range)
        _leftPatternIself :: (Pattern)
        _operatorIself :: (Name)
        _rightPatternIself :: (Pattern)
        ( _rangeIself) =
            (range_ )
        ( _leftPatternIself) =
            (leftPattern_ )
        ( _operatorIself) =
            (operator_ )
        ( _rightPatternIself) =
            (rightPattern_ )
        -- self rule
        (_self@_) =
            LeftHandSide_Infix _rangeIself _leftPatternIself _operatorIself _rightPatternIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_LeftHandSide_Parenthesized :: (T_Range) ->
                                  (T_LeftHandSide) ->
                                  (T_Patterns) ->
                                  (T_LeftHandSide)
sem_LeftHandSide_Parenthesized (range_) (lefthandside_) (patterns_) =
    let _lhsOself :: (LeftHandSide)
        _rangeIself :: (Range)
        _lefthandsideIself :: (LeftHandSide)
        _patternsIself :: (Patterns)
        ( _rangeIself) =
            (range_ )
        ( _lefthandsideIself) =
            (lefthandside_ )
        ( _patternsIself) =
            (patterns_ )
        -- self rule
        (_self@_) =
            LeftHandSide_Parenthesized _rangeIself _lefthandsideIself _patternsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- Literal -----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Literal.Char:
      self

-}
{-
   local variables for Literal.Float:
      self

-}
{-
   local variables for Literal.Int:
      self

-}
{-
   local variables for Literal.String:
      self

-}
-- semantic domain
type T_Literal = ( (Literal))
-- cata
sem_Literal :: (Literal) ->
               (T_Literal)
sem_Literal ((Literal_Char (_range) (_value))) =
    (sem_Literal_Char ((sem_Range (_range))) (_value))
sem_Literal ((Literal_Float (_range) (_value))) =
    (sem_Literal_Float ((sem_Range (_range))) (_value))
sem_Literal ((Literal_Int (_range) (_value))) =
    (sem_Literal_Int ((sem_Range (_range))) (_value))
sem_Literal ((Literal_String (_range) (_value))) =
    (sem_Literal_String ((sem_Range (_range))) (_value))
sem_Literal_Char :: (T_Range) ->
                    (String) ->
                    (T_Literal)
sem_Literal_Char (range_) (value_) =
    let _lhsOself :: (Literal)
        _rangeIself :: (Range)
        ( _rangeIself) =
            (range_ )
        -- self rule
        (_self@_) =
            Literal_Char _rangeIself value_
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Literal_Float :: (T_Range) ->
                     (String) ->
                     (T_Literal)
sem_Literal_Float (range_) (value_) =
    let _lhsOself :: (Literal)
        _rangeIself :: (Range)
        ( _rangeIself) =
            (range_ )
        -- self rule
        (_self@_) =
            Literal_Float _rangeIself value_
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Literal_Int :: (T_Range) ->
                   (String) ->
                   (T_Literal)
sem_Literal_Int (range_) (value_) =
    let _lhsOself :: (Literal)
        _rangeIself :: (Range)
        ( _rangeIself) =
            (range_ )
        -- self rule
        (_self@_) =
            Literal_Int _rangeIself value_
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Literal_String :: (T_Range) ->
                      (String) ->
                      (T_Literal)
sem_Literal_String (range_) (value_) =
    let _lhsOself :: (Literal)
        _rangeIself :: (Range)
        ( _rangeIself) =
            (range_ )
        -- self rule
        (_self@_) =
            Literal_String _rangeIself value_
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- MaybeDeclarations -------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for MaybeDeclarations.Just:
      self

-}
{-
   local variables for MaybeDeclarations.Nothing:
      self

-}
-- semantic domain
type T_MaybeDeclarations = ( (MaybeDeclarations))
-- cata
sem_MaybeDeclarations :: (MaybeDeclarations) ->
                         (T_MaybeDeclarations)
sem_MaybeDeclarations ((MaybeDeclarations_Just (_declarations))) =
    (sem_MaybeDeclarations_Just ((sem_Declarations (_declarations))))
sem_MaybeDeclarations ((MaybeDeclarations_Nothing )) =
    (sem_MaybeDeclarations_Nothing )
sem_MaybeDeclarations_Just :: (T_Declarations) ->
                              (T_MaybeDeclarations)
sem_MaybeDeclarations_Just (declarations_) =
    let _lhsOself :: (MaybeDeclarations)
        _declarationsIself :: (Declarations)
        ( _declarationsIself) =
            (declarations_ )
        -- self rule
        (_self@_) =
            MaybeDeclarations_Just _declarationsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_MaybeDeclarations_Nothing :: (T_MaybeDeclarations)
sem_MaybeDeclarations_Nothing  =
    let _lhsOself :: (MaybeDeclarations)
        -- self rule
        (_self@_) =
            MaybeDeclarations_Nothing
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- MaybeExports ------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for MaybeExports.Just:
      self

-}
{-
   local variables for MaybeExports.Nothing:
      self

-}
-- semantic domain
type T_MaybeExports = ( (MaybeExports))
-- cata
sem_MaybeExports :: (MaybeExports) ->
                    (T_MaybeExports)
sem_MaybeExports ((MaybeExports_Just (_exports))) =
    (sem_MaybeExports_Just ((sem_Exports (_exports))))
sem_MaybeExports ((MaybeExports_Nothing )) =
    (sem_MaybeExports_Nothing )
sem_MaybeExports_Just :: (T_Exports) ->
                         (T_MaybeExports)
sem_MaybeExports_Just (exports_) =
    let _lhsOself :: (MaybeExports)
        _exportsIself :: (Exports)
        ( _exportsIself) =
            (exports_ )
        -- self rule
        (_self@_) =
            MaybeExports_Just _exportsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_MaybeExports_Nothing :: (T_MaybeExports)
sem_MaybeExports_Nothing  =
    let _lhsOself :: (MaybeExports)
        -- self rule
        (_self@_) =
            MaybeExports_Nothing
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- MaybeExpression ---------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for MaybeExpression.Just:
      self

-}
{-
   local variables for MaybeExpression.Nothing:
      self

-}
-- semantic domain
type T_MaybeExpression = ( (MaybeExpression))
-- cata
sem_MaybeExpression :: (MaybeExpression) ->
                       (T_MaybeExpression)
sem_MaybeExpression ((MaybeExpression_Just (_expression))) =
    (sem_MaybeExpression_Just ((sem_Expression (_expression))))
sem_MaybeExpression ((MaybeExpression_Nothing )) =
    (sem_MaybeExpression_Nothing )
sem_MaybeExpression_Just :: (T_Expression) ->
                            (T_MaybeExpression)
sem_MaybeExpression_Just (expression_) =
    let _lhsOself :: (MaybeExpression)
        _expressionIself :: (Expression)
        ( _expressionIself) =
            (expression_ )
        -- self rule
        (_self@_) =
            MaybeExpression_Just _expressionIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_MaybeExpression_Nothing :: (T_MaybeExpression)
sem_MaybeExpression_Nothing  =
    let _lhsOself :: (MaybeExpression)
        -- self rule
        (_self@_) =
            MaybeExpression_Nothing
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- MaybeImportSpecification ------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for MaybeImportSpecification.Just:
      self

-}
{-
   local variables for MaybeImportSpecification.Nothing:
      self

-}
-- semantic domain
type T_MaybeImportSpecification = ( (MaybeImportSpecification))
-- cata
sem_MaybeImportSpecification :: (MaybeImportSpecification) ->
                                (T_MaybeImportSpecification)
sem_MaybeImportSpecification ((MaybeImportSpecification_Just (_importspecification))) =
    (sem_MaybeImportSpecification_Just ((sem_ImportSpecification (_importspecification))))
sem_MaybeImportSpecification ((MaybeImportSpecification_Nothing )) =
    (sem_MaybeImportSpecification_Nothing )
sem_MaybeImportSpecification_Just :: (T_ImportSpecification) ->
                                     (T_MaybeImportSpecification)
sem_MaybeImportSpecification_Just (importspecification_) =
    let _lhsOself :: (MaybeImportSpecification)
        _importspecificationIself :: (ImportSpecification)
        ( _importspecificationIself) =
            (importspecification_ )
        -- self rule
        (_self@_) =
            MaybeImportSpecification_Just _importspecificationIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_MaybeImportSpecification_Nothing :: (T_MaybeImportSpecification)
sem_MaybeImportSpecification_Nothing  =
    let _lhsOself :: (MaybeImportSpecification)
        -- self rule
        (_self@_) =
            MaybeImportSpecification_Nothing
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- MaybeInt ----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for MaybeInt.Just:
      self

-}
{-
   local variables for MaybeInt.Nothing:
      self

-}
-- semantic domain
type T_MaybeInt = ( (MaybeInt))
-- cata
sem_MaybeInt :: (MaybeInt) ->
                (T_MaybeInt)
sem_MaybeInt ((MaybeInt_Just (_int))) =
    (sem_MaybeInt_Just (_int))
sem_MaybeInt ((MaybeInt_Nothing )) =
    (sem_MaybeInt_Nothing )
sem_MaybeInt_Just :: (Int) ->
                     (T_MaybeInt)
sem_MaybeInt_Just (int_) =
    let _lhsOself :: (MaybeInt)
        -- self rule
        (_self@_) =
            MaybeInt_Just int_
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_MaybeInt_Nothing :: (T_MaybeInt)
sem_MaybeInt_Nothing  =
    let _lhsOself :: (MaybeInt)
        -- self rule
        (_self@_) =
            MaybeInt_Nothing
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- MaybeKind ---------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for MaybeKind.Just:
      self

-}
{-
   local variables for MaybeKind.Nothing:
      self

-}
-- semantic domain
type T_MaybeKind = ( (MaybeKind))
-- cata
sem_MaybeKind :: (MaybeKind) ->
                 (T_MaybeKind)
sem_MaybeKind ((MaybeKind_Just (_kind))) =
    (sem_MaybeKind_Just ((sem_Kind (_kind))))
sem_MaybeKind ((MaybeKind_Nothing )) =
    (sem_MaybeKind_Nothing )
sem_MaybeKind_Just :: (T_Kind) ->
                      (T_MaybeKind)
sem_MaybeKind_Just (kind_) =
    let _lhsOself :: (MaybeKind)
        _kindIself :: (Kind)
        ( _kindIself) =
            (kind_ )
        -- self rule
        (_self@_) =
            MaybeKind_Just _kindIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_MaybeKind_Nothing :: (T_MaybeKind)
sem_MaybeKind_Nothing  =
    let _lhsOself :: (MaybeKind)
        -- self rule
        (_self@_) =
            MaybeKind_Nothing
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- MaybeModuleName ---------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for MaybeModuleName.Just:
      self

-}
{-
   local variables for MaybeModuleName.Nothing:
      self

-}
-- semantic domain
type T_MaybeModuleName = ( (MaybeModuleName))
-- cata
sem_MaybeModuleName :: (MaybeModuleName) ->
                       (T_MaybeModuleName)
sem_MaybeModuleName ((MaybeModuleName_Just (_modulename))) =
    (sem_MaybeModuleName_Just ((sem_ModuleName (_modulename))))
sem_MaybeModuleName ((MaybeModuleName_Nothing )) =
    (sem_MaybeModuleName_Nothing )
sem_MaybeModuleName_Just :: (T_ModuleName) ->
                            (T_MaybeModuleName)
sem_MaybeModuleName_Just (modulename_) =
    let _lhsOself :: (MaybeModuleName)
        _modulenameIself :: (ModuleName)
        ( _modulenameIself) =
            (modulename_ )
        -- self rule
        (_self@_) =
            MaybeModuleName_Just _modulenameIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_MaybeModuleName_Nothing :: (T_MaybeModuleName)
sem_MaybeModuleName_Nothing  =
    let _lhsOself :: (MaybeModuleName)
        -- self rule
        (_self@_) =
            MaybeModuleName_Nothing
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- MaybeName ---------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for MaybeName.Just:
      self

-}
{-
   local variables for MaybeName.Nothing:
      self

-}
-- semantic domain
type T_MaybeName = ( (MaybeName))
-- cata
sem_MaybeName :: (MaybeName) ->
                 (T_MaybeName)
sem_MaybeName ((MaybeName_Just (_name))) =
    (sem_MaybeName_Just ((sem_Name (_name))))
sem_MaybeName ((MaybeName_Nothing )) =
    (sem_MaybeName_Nothing )
sem_MaybeName_Just :: (T_Name) ->
                      (T_MaybeName)
sem_MaybeName_Just (name_) =
    let _lhsOself :: (MaybeName)
        _nameIself :: (Name)
        ( _nameIself) =
            (name_ )
        -- self rule
        (_self@_) =
            MaybeName_Just _nameIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_MaybeName_Nothing :: (T_MaybeName)
sem_MaybeName_Nothing  =
    let _lhsOself :: (MaybeName)
        -- self rule
        (_self@_) =
            MaybeName_Nothing
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- MaybeNames --------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for MaybeNames.Just:
      self

-}
{-
   local variables for MaybeNames.Nothing:
      self

-}
-- semantic domain
type T_MaybeNames = ( (MaybeNames))
-- cata
sem_MaybeNames :: (MaybeNames) ->
                  (T_MaybeNames)
sem_MaybeNames ((MaybeNames_Just (_names))) =
    (sem_MaybeNames_Just ((sem_Names (_names))))
sem_MaybeNames ((MaybeNames_Nothing )) =
    (sem_MaybeNames_Nothing )
sem_MaybeNames_Just :: (T_Names) ->
                       (T_MaybeNames)
sem_MaybeNames_Just (names_) =
    let _lhsOself :: (MaybeNames)
        _namesIself :: (Names)
        ( _namesIself) =
            (names_ )
        -- self rule
        (_self@_) =
            MaybeNames_Just _namesIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_MaybeNames_Nothing :: (T_MaybeNames)
sem_MaybeNames_Nothing  =
    let _lhsOself :: (MaybeNames)
        -- self rule
        (_self@_) =
            MaybeNames_Nothing
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- MaybeReassignments ------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for MaybeReassignments.Just:
      self

-}
{-
   local variables for MaybeReassignments.Nothing:
      self

-}
-- semantic domain
type T_MaybeReassignments = ( (MaybeReassignments))
-- cata
sem_MaybeReassignments :: (MaybeReassignments) ->
                          (T_MaybeReassignments)
sem_MaybeReassignments ((MaybeReassignments_Just (_reassignments))) =
    (sem_MaybeReassignments_Just ((sem_Reassignments (_reassignments))))
sem_MaybeReassignments ((MaybeReassignments_Nothing )) =
    (sem_MaybeReassignments_Nothing )
sem_MaybeReassignments_Just :: (T_Reassignments) ->
                               (T_MaybeReassignments)
sem_MaybeReassignments_Just (reassignments_) =
    let _lhsOself :: (MaybeReassignments)
        _reassignmentsIself :: (Reassignments)
        ( _reassignmentsIself) =
            (reassignments_ )
        -- self rule
        (_self@_) =
            MaybeReassignments_Just _reassignmentsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_MaybeReassignments_Nothing :: (T_MaybeReassignments)
sem_MaybeReassignments_Nothing  =
    let _lhsOself :: (MaybeReassignments)
        -- self rule
        (_self@_) =
            MaybeReassignments_Nothing
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- Module ------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Module.Module:
      self

-}
-- semantic domain
type T_Module = ( (Module))
-- cata
sem_Module :: (Module) ->
              (T_Module)
sem_Module ((Module_Module (_range) (_name) (_exports) (_body))) =
    (sem_Module_Module ((sem_Range (_range))) ((sem_MaybeModuleName (_name))) ((sem_MaybeExports (_exports))) ((sem_Body (_body))))
sem_Module_Module :: (T_Range) ->
                     (T_MaybeModuleName) ->
                     (T_MaybeExports) ->
                     (T_Body) ->
                     (T_Module)
sem_Module_Module (range_) (name_) (exports_) (body_) =
    let _lhsOself :: (Module)
        _rangeIself :: (Range)
        _nameIself :: (MaybeModuleName)
        _exportsIself :: (MaybeExports)
        _bodyIself :: (Body)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _exportsIself) =
            (exports_ )
        ( _bodyIself) =
            (body_ )
        -- self rule
        (_self@_) =
            Module_Module _rangeIself _nameIself _exportsIself _bodyIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- ModuleInterface ---------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for ModuleInterface.ModuleInterface:
      self

-}
{-
   local variables for ModuleInterface.Unavailable:
      self

-}
-- semantic domain
type T_ModuleInterface = ( (ModuleInterface))
-- cata
sem_ModuleInterface :: (ModuleInterface) ->
                       (T_ModuleInterface)
sem_ModuleInterface ((ModuleInterface_ModuleInterface (_range) (_name) (_exportedTypes) (_exportedValues) (_declarations))) =
    (sem_ModuleInterface_ModuleInterface ((sem_Range (_range))) ((sem_ModuleName (_name))) ((sem_Names (_exportedTypes))) ((sem_Names (_exportedValues))) ((sem_InterfaceDeclarations (_declarations))))
sem_ModuleInterface ((ModuleInterface_Unavailable (_name))) =
    (sem_ModuleInterface_Unavailable ((sem_ModuleName (_name))))
sem_ModuleInterface_ModuleInterface :: (T_Range) ->
                                       (T_ModuleName) ->
                                       (T_Names) ->
                                       (T_Names) ->
                                       (T_InterfaceDeclarations) ->
                                       (T_ModuleInterface)
sem_ModuleInterface_ModuleInterface (range_) (name_) (exportedTypes_) (exportedValues_) (declarations_) =
    let _lhsOself :: (ModuleInterface)
        _rangeIself :: (Range)
        _nameIself :: (ModuleName)
        _exportedTypesIself :: (Names)
        _exportedValuesIself :: (Names)
        _declarationsIself :: (InterfaceDeclarations)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _exportedTypesIself) =
            (exportedTypes_ )
        ( _exportedValuesIself) =
            (exportedValues_ )
        ( _declarationsIself) =
            (declarations_ )
        -- self rule
        (_self@_) =
            ModuleInterface_ModuleInterface _rangeIself _nameIself _exportedTypesIself _exportedValuesIself _declarationsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_ModuleInterface_Unavailable :: (T_ModuleName) ->
                                   (T_ModuleInterface)
sem_ModuleInterface_Unavailable (name_) =
    let _lhsOself :: (ModuleInterface)
        _nameIself :: (ModuleName)
        ( _nameIself) =
            (name_ )
        -- self rule
        (_self@_) =
            ModuleInterface_Unavailable _nameIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- ModuleInterfaces --------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for ModuleInterfaces.Cons:
      self

-}
{-
   local variables for ModuleInterfaces.Nil:
      self

-}
-- semantic domain
type T_ModuleInterfaces = ( (ModuleInterfaces))
-- cata
sem_ModuleInterfaces :: (ModuleInterfaces) ->
                        (T_ModuleInterfaces)
sem_ModuleInterfaces (list) =
    (foldr (sem_ModuleInterfaces_Cons) (sem_ModuleInterfaces_Nil) ((map sem_ModuleInterface list)))
sem_ModuleInterfaces_Cons :: (T_ModuleInterface) ->
                             (T_ModuleInterfaces) ->
                             (T_ModuleInterfaces)
sem_ModuleInterfaces_Cons (hd_) (tl_) =
    let _lhsOself :: (ModuleInterfaces)
        _hdIself :: (ModuleInterface)
        _tlIself :: (ModuleInterfaces)
        ( _hdIself) =
            (hd_ )
        ( _tlIself) =
            (tl_ )
        -- self rule
        (_self@_) =
            (:) _hdIself _tlIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_ModuleInterfaces_Nil :: (T_ModuleInterfaces)
sem_ModuleInterfaces_Nil  =
    let _lhsOself :: (ModuleInterfaces)
        -- self rule
        (_self@_) =
            []
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- ModuleName --------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for ModuleName.ModuleName:
      self

-}
-- semantic domain
type T_ModuleName = ( (ModuleName))
-- cata
sem_ModuleName :: (ModuleName) ->
                  (T_ModuleName)
sem_ModuleName ((ModuleName_ModuleName (_range) (_name))) =
    (sem_ModuleName_ModuleName ((sem_Range (_range))) ((sem_Strings (_name))))
sem_ModuleName_ModuleName :: (T_Range) ->
                             (T_Strings) ->
                             (T_ModuleName)
sem_ModuleName_ModuleName (range_) (name_) =
    let _lhsOself :: (ModuleName)
        _rangeIself :: (Range)
        _nameIself :: (Strings)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        -- self rule
        (_self@_) =
            ModuleName_ModuleName _rangeIself _nameIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- ModuleSystem ------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for ModuleSystem.ModuleSystem:
      self

-}
-- semantic domain
type T_ModuleSystem = ( (ModuleSystem))
-- cata
sem_ModuleSystem :: (ModuleSystem) ->
                    (T_ModuleSystem)
sem_ModuleSystem ((ModuleSystem_ModuleSystem (_interfaces) (_module))) =
    (sem_ModuleSystem_ModuleSystem ((sem_ModuleInterfaces (_interfaces))) ((sem_Module (_module))))
sem_ModuleSystem_ModuleSystem :: (T_ModuleInterfaces) ->
                                 (T_Module) ->
                                 (T_ModuleSystem)
sem_ModuleSystem_ModuleSystem (interfaces_) (module_) =
    let _lhsOself :: (ModuleSystem)
        _interfacesIself :: (ModuleInterfaces)
        _moduleIself :: (Module)
        ( _interfacesIself) =
            (interfaces_ )
        ( _moduleIself) =
            (module_ )
        -- self rule
        (_self@_) =
            ModuleSystem_ModuleSystem _interfacesIself _moduleIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- Name --------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Name.Entity:
      self

-}
{-
   local variables for Name.Identifier:
      self

-}
{-
   local variables for Name.Operator:
      self

-}
{-
   local variables for Name.Special:
      self

-}
-- semantic domain
type T_Name = ( (Name))
-- cata
sem_Name :: (Name) ->
            (T_Name)
sem_Name ((Name_Entity (_range) (_entity) (_inscope))) =
    (sem_Name_Entity ((sem_Range (_range))) ((sem_Name (_entity))) ((sem_MaybeName (_inscope))))
sem_Name ((Name_Identifier (_range) (_module) (_name))) =
    (sem_Name_Identifier ((sem_Range (_range))) ((sem_Strings (_module))) (_name))
sem_Name ((Name_Operator (_range) (_module) (_name))) =
    (sem_Name_Operator ((sem_Range (_range))) ((sem_Strings (_module))) (_name))
sem_Name ((Name_Special (_range) (_module) (_name))) =
    (sem_Name_Special ((sem_Range (_range))) ((sem_Strings (_module))) (_name))
sem_Name_Entity :: (T_Range) ->
                   (T_Name) ->
                   (T_MaybeName) ->
                   (T_Name)
sem_Name_Entity (range_) (entity_) (inscope_) =
    let _lhsOself :: (Name)
        _rangeIself :: (Range)
        _entityIself :: (Name)
        _inscopeIself :: (MaybeName)
        ( _rangeIself) =
            (range_ )
        ( _entityIself) =
            (entity_ )
        ( _inscopeIself) =
            (inscope_ )
        -- self rule
        (_self@_) =
            Name_Entity _rangeIself _entityIself _inscopeIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Name_Identifier :: (T_Range) ->
                       (T_Strings) ->
                       (String) ->
                       (T_Name)
sem_Name_Identifier (range_) (module_) (name_) =
    let _lhsOself :: (Name)
        _rangeIself :: (Range)
        _moduleIself :: (Strings)
        ( _rangeIself) =
            (range_ )
        ( _moduleIself) =
            (module_ )
        -- self rule
        (_self@_) =
            Name_Identifier _rangeIself _moduleIself name_
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Name_Operator :: (T_Range) ->
                     (T_Strings) ->
                     (String) ->
                     (T_Name)
sem_Name_Operator (range_) (module_) (name_) =
    let _lhsOself :: (Name)
        _rangeIself :: (Range)
        _moduleIself :: (Strings)
        ( _rangeIself) =
            (range_ )
        ( _moduleIself) =
            (module_ )
        -- self rule
        (_self@_) =
            Name_Operator _rangeIself _moduleIself name_
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Name_Special :: (T_Range) ->
                    (T_Strings) ->
                    (String) ->
                    (T_Name)
sem_Name_Special (range_) (module_) (name_) =
    let _lhsOself :: (Name)
        _rangeIself :: (Range)
        _moduleIself :: (Strings)
        ( _rangeIself) =
            (range_ )
        ( _moduleIself) =
            (module_ )
        -- self rule
        (_self@_) =
            Name_Special _rangeIself _moduleIself name_
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- Names -------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Names.Cons:
      self

-}
{-
   local variables for Names.Nil:
      self

-}
-- semantic domain
type T_Names = ( (Names))
-- cata
sem_Names :: (Names) ->
             (T_Names)
sem_Names (list) =
    (foldr (sem_Names_Cons) (sem_Names_Nil) ((map sem_Name list)))
sem_Names_Cons :: (T_Name) ->
                  (T_Names) ->
                  (T_Names)
sem_Names_Cons (hd_) (tl_) =
    let _lhsOself :: (Names)
        _hdIself :: (Name)
        _tlIself :: (Names)
        ( _hdIself) =
            (hd_ )
        ( _tlIself) =
            (tl_ )
        -- self rule
        (_self@_) =
            (:) _hdIself _tlIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Names_Nil :: (T_Names)
sem_Names_Nil  =
    let _lhsOself :: (Names)
        -- self rule
        (_self@_) =
            []
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- Pattern -----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Pattern.As:
      self

-}
{-
   local variables for Pattern.Constructor:
      self

-}
{-
   local variables for Pattern.InfixConstructor:
      self

-}
{-
   local variables for Pattern.Irrefutable:
      self

-}
{-
   local variables for Pattern.List:
      self

-}
{-
   local variables for Pattern.Literal:
      self

-}
{-
   local variables for Pattern.Negate:
      self

-}
{-
   local variables for Pattern.Parenthesized:
      self

-}
{-
   local variables for Pattern.Record:
      self

-}
{-
   local variables for Pattern.Successor:
      self

-}
{-
   local variables for Pattern.Tuple:
      self

-}
{-
   local variables for Pattern.Variable:
      self

-}
{-
   local variables for Pattern.Wildcard:
      self

-}
-- semantic domain
type T_Pattern = ( (Pattern))
-- cata
sem_Pattern :: (Pattern) ->
               (T_Pattern)
sem_Pattern ((Pattern_As (_range) (_name) (_pattern))) =
    (sem_Pattern_As ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_Constructor (_range) (_name) (_patterns))) =
    (sem_Pattern_Constructor ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Patterns (_patterns))))
sem_Pattern ((Pattern_InfixConstructor (_range) (_leftPattern) (_constructorOperator) (_rightPattern))) =
    (sem_Pattern_InfixConstructor ((sem_Range (_range))) ((sem_Pattern (_leftPattern))) ((sem_Name (_constructorOperator))) ((sem_Pattern (_rightPattern))))
sem_Pattern ((Pattern_Irrefutable (_range) (_pattern))) =
    (sem_Pattern_Irrefutable ((sem_Range (_range))) ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_List (_range) (_patterns))) =
    (sem_Pattern_List ((sem_Range (_range))) ((sem_Patterns (_patterns))))
sem_Pattern ((Pattern_Literal (_range) (_literal))) =
    (sem_Pattern_Literal ((sem_Range (_range))) ((sem_Literal (_literal))))
sem_Pattern ((Pattern_Negate (_range) (_literal))) =
    (sem_Pattern_Negate ((sem_Range (_range))) ((sem_Literal (_literal))))
sem_Pattern ((Pattern_Parenthesized (_range) (_pattern))) =
    (sem_Pattern_Parenthesized ((sem_Range (_range))) ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_Record (_range) (_name) (_recordPatternBindings))) =
    (sem_Pattern_Record ((sem_Range (_range))) ((sem_Name (_name))) ((sem_RecordPatternBindings (_recordPatternBindings))))
sem_Pattern ((Pattern_Successor (_range) (_name) (_literal))) =
    (sem_Pattern_Successor ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Literal (_literal))))
sem_Pattern ((Pattern_Tuple (_range) (_patterns))) =
    (sem_Pattern_Tuple ((sem_Range (_range))) ((sem_Patterns (_patterns))))
sem_Pattern ((Pattern_Variable (_range) (_name))) =
    (sem_Pattern_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Pattern ((Pattern_Wildcard (_range))) =
    (sem_Pattern_Wildcard ((sem_Range (_range))))
sem_Pattern_As :: (T_Range) ->
                  (T_Name) ->
                  (T_Pattern) ->
                  (T_Pattern)
sem_Pattern_As (range_) (name_) (pattern_) =
    let _lhsOself :: (Pattern)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        _patternIself :: (Pattern)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _patternIself) =
            (pattern_ )
        -- self rule
        (_self@_) =
            Pattern_As _rangeIself _nameIself _patternIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Pattern_Constructor :: (T_Range) ->
                           (T_Name) ->
                           (T_Patterns) ->
                           (T_Pattern)
sem_Pattern_Constructor (range_) (name_) (patterns_) =
    let _lhsOself :: (Pattern)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        _patternsIself :: (Patterns)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _patternsIself) =
            (patterns_ )
        -- self rule
        (_self@_) =
            Pattern_Constructor _rangeIself _nameIself _patternsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Pattern_InfixConstructor :: (T_Range) ->
                                (T_Pattern) ->
                                (T_Name) ->
                                (T_Pattern) ->
                                (T_Pattern)
sem_Pattern_InfixConstructor (range_) (leftPattern_) (constructorOperator_) (rightPattern_) =
    let _lhsOself :: (Pattern)
        _rangeIself :: (Range)
        _leftPatternIself :: (Pattern)
        _constructorOperatorIself :: (Name)
        _rightPatternIself :: (Pattern)
        ( _rangeIself) =
            (range_ )
        ( _leftPatternIself) =
            (leftPattern_ )
        ( _constructorOperatorIself) =
            (constructorOperator_ )
        ( _rightPatternIself) =
            (rightPattern_ )
        -- self rule
        (_self@_) =
            Pattern_InfixConstructor _rangeIself _leftPatternIself _constructorOperatorIself _rightPatternIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Pattern_Irrefutable :: (T_Range) ->
                           (T_Pattern) ->
                           (T_Pattern)
sem_Pattern_Irrefutable (range_) (pattern_) =
    let _lhsOself :: (Pattern)
        _rangeIself :: (Range)
        _patternIself :: (Pattern)
        ( _rangeIself) =
            (range_ )
        ( _patternIself) =
            (pattern_ )
        -- self rule
        (_self@_) =
            Pattern_Irrefutable _rangeIself _patternIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Pattern_List :: (T_Range) ->
                    (T_Patterns) ->
                    (T_Pattern)
sem_Pattern_List (range_) (patterns_) =
    let _lhsOself :: (Pattern)
        _rangeIself :: (Range)
        _patternsIself :: (Patterns)
        ( _rangeIself) =
            (range_ )
        ( _patternsIself) =
            (patterns_ )
        -- self rule
        (_self@_) =
            Pattern_List _rangeIself _patternsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Pattern_Literal :: (T_Range) ->
                       (T_Literal) ->
                       (T_Pattern)
sem_Pattern_Literal (range_) (literal_) =
    let _lhsOself :: (Pattern)
        _rangeIself :: (Range)
        _literalIself :: (Literal)
        ( _rangeIself) =
            (range_ )
        ( _literalIself) =
            (literal_ )
        -- self rule
        (_self@_) =
            Pattern_Literal _rangeIself _literalIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Pattern_Negate :: (T_Range) ->
                      (T_Literal) ->
                      (T_Pattern)
sem_Pattern_Negate (range_) (literal_) =
    let _lhsOself :: (Pattern)
        _rangeIself :: (Range)
        _literalIself :: (Literal)
        ( _rangeIself) =
            (range_ )
        ( _literalIself) =
            (literal_ )
        -- self rule
        (_self@_) =
            Pattern_Negate _rangeIself _literalIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Pattern_Parenthesized :: (T_Range) ->
                             (T_Pattern) ->
                             (T_Pattern)
sem_Pattern_Parenthesized (range_) (pattern_) =
    let _lhsOself :: (Pattern)
        _rangeIself :: (Range)
        _patternIself :: (Pattern)
        ( _rangeIself) =
            (range_ )
        ( _patternIself) =
            (pattern_ )
        -- self rule
        (_self@_) =
            Pattern_Parenthesized _rangeIself _patternIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Pattern_Record :: (T_Range) ->
                      (T_Name) ->
                      (T_RecordPatternBindings) ->
                      (T_Pattern)
sem_Pattern_Record (range_) (name_) (recordPatternBindings_) =
    let _lhsOself :: (Pattern)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        _recordPatternBindingsIself :: (RecordPatternBindings)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _recordPatternBindingsIself) =
            (recordPatternBindings_ )
        -- self rule
        (_self@_) =
            Pattern_Record _rangeIself _nameIself _recordPatternBindingsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Pattern_Successor :: (T_Range) ->
                         (T_Name) ->
                         (T_Literal) ->
                         (T_Pattern)
sem_Pattern_Successor (range_) (name_) (literal_) =
    let _lhsOself :: (Pattern)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        _literalIself :: (Literal)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _literalIself) =
            (literal_ )
        -- self rule
        (_self@_) =
            Pattern_Successor _rangeIself _nameIself _literalIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Pattern_Tuple :: (T_Range) ->
                     (T_Patterns) ->
                     (T_Pattern)
sem_Pattern_Tuple (range_) (patterns_) =
    let _lhsOself :: (Pattern)
        _rangeIself :: (Range)
        _patternsIself :: (Patterns)
        ( _rangeIself) =
            (range_ )
        ( _patternsIself) =
            (patterns_ )
        -- self rule
        (_self@_) =
            Pattern_Tuple _rangeIself _patternsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Pattern_Variable :: (T_Range) ->
                        (T_Name) ->
                        (T_Pattern)
sem_Pattern_Variable (range_) (name_) =
    let _lhsOself :: (Pattern)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        -- self rule
        (_self@_) =
            Pattern_Variable _rangeIself _nameIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Pattern_Wildcard :: (T_Range) ->
                        (T_Pattern)
sem_Pattern_Wildcard (range_) =
    let _lhsOself :: (Pattern)
        _rangeIself :: (Range)
        ( _rangeIself) =
            (range_ )
        -- self rule
        (_self@_) =
            Pattern_Wildcard _rangeIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- Patterns ----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Patterns.Cons:
      self

-}
{-
   local variables for Patterns.Nil:
      self

-}
-- semantic domain
type T_Patterns = ( (Patterns))
-- cata
sem_Patterns :: (Patterns) ->
                (T_Patterns)
sem_Patterns (list) =
    (foldr (sem_Patterns_Cons) (sem_Patterns_Nil) ((map sem_Pattern list)))
sem_Patterns_Cons :: (T_Pattern) ->
                     (T_Patterns) ->
                     (T_Patterns)
sem_Patterns_Cons (hd_) (tl_) =
    let _lhsOself :: (Patterns)
        _hdIself :: (Pattern)
        _tlIself :: (Patterns)
        ( _hdIself) =
            (hd_ )
        ( _tlIself) =
            (tl_ )
        -- self rule
        (_self@_) =
            (:) _hdIself _tlIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Patterns_Nil :: (T_Patterns)
sem_Patterns_Nil  =
    let _lhsOself :: (Patterns)
        -- self rule
        (_self@_) =
            []
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- Position ----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Position.Position:
      self

-}
{-
   local variables for Position.Unknown:
      self

-}
-- semantic domain
type T_Position = ( (Position))
-- cata
sem_Position :: (Position) ->
                (T_Position)
sem_Position ((Position_Position (_filename) (_line) (_column))) =
    (sem_Position_Position (_filename) (_line) (_column))
sem_Position ((Position_Unknown )) =
    (sem_Position_Unknown )
sem_Position_Position :: (String) ->
                         (Int) ->
                         (Int) ->
                         (T_Position)
sem_Position_Position (filename_) (line_) (column_) =
    let _lhsOself :: (Position)
        -- self rule
        (_self@_) =
            Position_Position filename_ line_ column_
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Position_Unknown :: (T_Position)
sem_Position_Unknown  =
    let _lhsOself :: (Position)
        -- self rule
        (_self@_) =
            Position_Unknown
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- Qualifier ---------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Qualifier.Empty:
      self

-}
{-
   local variables for Qualifier.Generator:
      self

-}
{-
   local variables for Qualifier.Guard:
      self

-}
{-
   local variables for Qualifier.Let:
      self

-}
-- semantic domain
type T_Qualifier = ( (Qualifier))
-- cata
sem_Qualifier :: (Qualifier) ->
                 (T_Qualifier)
sem_Qualifier ((Qualifier_Empty (_range))) =
    (sem_Qualifier_Empty ((sem_Range (_range))))
sem_Qualifier ((Qualifier_Generator (_range) (_pattern) (_expression))) =
    (sem_Qualifier_Generator ((sem_Range (_range))) ((sem_Pattern (_pattern))) ((sem_Expression (_expression))))
sem_Qualifier ((Qualifier_Guard (_range) (_guard))) =
    (sem_Qualifier_Guard ((sem_Range (_range))) ((sem_Expression (_guard))))
sem_Qualifier ((Qualifier_Let (_range) (_declarations))) =
    (sem_Qualifier_Let ((sem_Range (_range))) ((sem_Declarations (_declarations))))
sem_Qualifier_Empty :: (T_Range) ->
                       (T_Qualifier)
sem_Qualifier_Empty (range_) =
    let _lhsOself :: (Qualifier)
        _rangeIself :: (Range)
        ( _rangeIself) =
            (range_ )
        -- self rule
        (_self@_) =
            Qualifier_Empty _rangeIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Qualifier_Generator :: (T_Range) ->
                           (T_Pattern) ->
                           (T_Expression) ->
                           (T_Qualifier)
sem_Qualifier_Generator (range_) (pattern_) (expression_) =
    let _lhsOself :: (Qualifier)
        _rangeIself :: (Range)
        _patternIself :: (Pattern)
        _expressionIself :: (Expression)
        ( _rangeIself) =
            (range_ )
        ( _patternIself) =
            (pattern_ )
        ( _expressionIself) =
            (expression_ )
        -- self rule
        (_self@_) =
            Qualifier_Generator _rangeIself _patternIself _expressionIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Qualifier_Guard :: (T_Range) ->
                       (T_Expression) ->
                       (T_Qualifier)
sem_Qualifier_Guard (range_) (guard_) =
    let _lhsOself :: (Qualifier)
        _rangeIself :: (Range)
        _guardIself :: (Expression)
        ( _rangeIself) =
            (range_ )
        ( _guardIself) =
            (guard_ )
        -- self rule
        (_self@_) =
            Qualifier_Guard _rangeIself _guardIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Qualifier_Let :: (T_Range) ->
                     (T_Declarations) ->
                     (T_Qualifier)
sem_Qualifier_Let (range_) (declarations_) =
    let _lhsOself :: (Qualifier)
        _rangeIself :: (Range)
        _declarationsIself :: (Declarations)
        ( _rangeIself) =
            (range_ )
        ( _declarationsIself) =
            (declarations_ )
        -- self rule
        (_self@_) =
            Qualifier_Let _rangeIself _declarationsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- Qualifiers --------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Qualifiers.Cons:
      self

-}
{-
   local variables for Qualifiers.Nil:
      self

-}
-- semantic domain
type T_Qualifiers = ( (Qualifiers))
-- cata
sem_Qualifiers :: (Qualifiers) ->
                  (T_Qualifiers)
sem_Qualifiers (list) =
    (foldr (sem_Qualifiers_Cons) (sem_Qualifiers_Nil) ((map sem_Qualifier list)))
sem_Qualifiers_Cons :: (T_Qualifier) ->
                       (T_Qualifiers) ->
                       (T_Qualifiers)
sem_Qualifiers_Cons (hd_) (tl_) =
    let _lhsOself :: (Qualifiers)
        _hdIself :: (Qualifier)
        _tlIself :: (Qualifiers)
        ( _hdIself) =
            (hd_ )
        ( _tlIself) =
            (tl_ )
        -- self rule
        (_self@_) =
            (:) _hdIself _tlIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Qualifiers_Nil :: (T_Qualifiers)
sem_Qualifiers_Nil  =
    let _lhsOself :: (Qualifiers)
        -- self rule
        (_self@_) =
            []
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- Range -------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Range.Range:
      self

-}
-- semantic domain
type T_Range = ( (Range))
-- cata
sem_Range :: (Range) ->
             (T_Range)
sem_Range ((Range_Range (_start) (_stop))) =
    (sem_Range_Range ((sem_Position (_start))) ((sem_Position (_stop))))
sem_Range_Range :: (T_Position) ->
                   (T_Position) ->
                   (T_Range)
sem_Range_Range (start_) (stop_) =
    let _lhsOself :: (Range)
        _startIself :: (Position)
        _stopIself :: (Position)
        ( _startIself) =
            (start_ )
        ( _stopIself) =
            (stop_ )
        -- self rule
        (_self@_) =
            Range_Range _startIself _stopIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- Reassignment ------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Reassignment.Reassignment:
      self

-}
-- semantic domain
type T_Reassignment = ( (Reassignment))
-- cata
sem_Reassignment :: (Reassignment) ->
                    (T_Reassignment)
sem_Reassignment ((Reassignment_Reassignment (_range) (_name) (_as))) =
    (sem_Reassignment_Reassignment ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Name (_as))))
sem_Reassignment_Reassignment :: (T_Range) ->
                                 (T_Name) ->
                                 (T_Name) ->
                                 (T_Reassignment)
sem_Reassignment_Reassignment (range_) (name_) (as_) =
    let _lhsOself :: (Reassignment)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        _asIself :: (Name)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _asIself) =
            (as_ )
        -- self rule
        (_self@_) =
            Reassignment_Reassignment _rangeIself _nameIself _asIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- Reassignments -----------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Reassignments.Cons:
      self

-}
{-
   local variables for Reassignments.Nil:
      self

-}
-- semantic domain
type T_Reassignments = ( (Reassignments))
-- cata
sem_Reassignments :: (Reassignments) ->
                     (T_Reassignments)
sem_Reassignments (list) =
    (foldr (sem_Reassignments_Cons) (sem_Reassignments_Nil) ((map sem_Reassignment list)))
sem_Reassignments_Cons :: (T_Reassignment) ->
                          (T_Reassignments) ->
                          (T_Reassignments)
sem_Reassignments_Cons (hd_) (tl_) =
    let _lhsOself :: (Reassignments)
        _hdIself :: (Reassignment)
        _tlIself :: (Reassignments)
        ( _hdIself) =
            (hd_ )
        ( _tlIself) =
            (tl_ )
        -- self rule
        (_self@_) =
            (:) _hdIself _tlIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Reassignments_Nil :: (T_Reassignments)
sem_Reassignments_Nil  =
    let _lhsOself :: (Reassignments)
        -- self rule
        (_self@_) =
            []
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- RecordExpressionBinding -------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for RecordExpressionBinding.RecordExpressionBinding:
      self

-}
-- semantic domain
type T_RecordExpressionBinding = ( (RecordExpressionBinding))
-- cata
sem_RecordExpressionBinding :: (RecordExpressionBinding) ->
                               (T_RecordExpressionBinding)
sem_RecordExpressionBinding ((RecordExpressionBinding_RecordExpressionBinding (_range) (_name) (_expression))) =
    (sem_RecordExpressionBinding_RecordExpressionBinding ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Expression (_expression))))
sem_RecordExpressionBinding_RecordExpressionBinding :: (T_Range) ->
                                                       (T_Name) ->
                                                       (T_Expression) ->
                                                       (T_RecordExpressionBinding)
sem_RecordExpressionBinding_RecordExpressionBinding (range_) (name_) (expression_) =
    let _lhsOself :: (RecordExpressionBinding)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        _expressionIself :: (Expression)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _expressionIself) =
            (expression_ )
        -- self rule
        (_self@_) =
            RecordExpressionBinding_RecordExpressionBinding _rangeIself _nameIself _expressionIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- RecordExpressionBindings ------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for RecordExpressionBindings.Cons:
      self

-}
{-
   local variables for RecordExpressionBindings.Nil:
      self

-}
-- semantic domain
type T_RecordExpressionBindings = ( (RecordExpressionBindings))
-- cata
sem_RecordExpressionBindings :: (RecordExpressionBindings) ->
                                (T_RecordExpressionBindings)
sem_RecordExpressionBindings (list) =
    (foldr (sem_RecordExpressionBindings_Cons) (sem_RecordExpressionBindings_Nil) ((map sem_RecordExpressionBinding list)))
sem_RecordExpressionBindings_Cons :: (T_RecordExpressionBinding) ->
                                     (T_RecordExpressionBindings) ->
                                     (T_RecordExpressionBindings)
sem_RecordExpressionBindings_Cons (hd_) (tl_) =
    let _lhsOself :: (RecordExpressionBindings)
        _hdIself :: (RecordExpressionBinding)
        _tlIself :: (RecordExpressionBindings)
        ( _hdIself) =
            (hd_ )
        ( _tlIself) =
            (tl_ )
        -- self rule
        (_self@_) =
            (:) _hdIself _tlIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_RecordExpressionBindings_Nil :: (T_RecordExpressionBindings)
sem_RecordExpressionBindings_Nil  =
    let _lhsOself :: (RecordExpressionBindings)
        -- self rule
        (_self@_) =
            []
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- RecordPatternBinding ----------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for RecordPatternBinding.RecordPatternBinding:
      self

-}
-- semantic domain
type T_RecordPatternBinding = ( (RecordPatternBinding))
-- cata
sem_RecordPatternBinding :: (RecordPatternBinding) ->
                            (T_RecordPatternBinding)
sem_RecordPatternBinding ((RecordPatternBinding_RecordPatternBinding (_range) (_name) (_pattern))) =
    (sem_RecordPatternBinding_RecordPatternBinding ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Pattern (_pattern))))
sem_RecordPatternBinding_RecordPatternBinding :: (T_Range) ->
                                                 (T_Name) ->
                                                 (T_Pattern) ->
                                                 (T_RecordPatternBinding)
sem_RecordPatternBinding_RecordPatternBinding (range_) (name_) (pattern_) =
    let _lhsOself :: (RecordPatternBinding)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        _patternIself :: (Pattern)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _patternIself) =
            (pattern_ )
        -- self rule
        (_self@_) =
            RecordPatternBinding_RecordPatternBinding _rangeIself _nameIself _patternIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- RecordPatternBindings ---------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for RecordPatternBindings.Cons:
      self

-}
{-
   local variables for RecordPatternBindings.Nil:
      self

-}
-- semantic domain
type T_RecordPatternBindings = ( (RecordPatternBindings))
-- cata
sem_RecordPatternBindings :: (RecordPatternBindings) ->
                             (T_RecordPatternBindings)
sem_RecordPatternBindings (list) =
    (foldr (sem_RecordPatternBindings_Cons) (sem_RecordPatternBindings_Nil) ((map sem_RecordPatternBinding list)))
sem_RecordPatternBindings_Cons :: (T_RecordPatternBinding) ->
                                  (T_RecordPatternBindings) ->
                                  (T_RecordPatternBindings)
sem_RecordPatternBindings_Cons (hd_) (tl_) =
    let _lhsOself :: (RecordPatternBindings)
        _hdIself :: (RecordPatternBinding)
        _tlIself :: (RecordPatternBindings)
        ( _hdIself) =
            (hd_ )
        ( _tlIself) =
            (tl_ )
        -- self rule
        (_self@_) =
            (:) _hdIself _tlIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_RecordPatternBindings_Nil :: (T_RecordPatternBindings)
sem_RecordPatternBindings_Nil  =
    let _lhsOself :: (RecordPatternBindings)
        -- self rule
        (_self@_) =
            []
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- RightHandSide -----------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for RightHandSide.Expression:
      self

-}
{-
   local variables for RightHandSide.Guarded:
      self

-}
-- semantic domain
type T_RightHandSide = ( (RightHandSide))
-- cata
sem_RightHandSide :: (RightHandSide) ->
                     (T_RightHandSide)
sem_RightHandSide ((RightHandSide_Expression (_range) (_expression) (_where))) =
    (sem_RightHandSide_Expression ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_MaybeDeclarations (_where))))
sem_RightHandSide ((RightHandSide_Guarded (_range) (_guardedexpressions) (_where))) =
    (sem_RightHandSide_Guarded ((sem_Range (_range))) ((sem_GuardedExpressions (_guardedexpressions))) ((sem_MaybeDeclarations (_where))))
sem_RightHandSide_Expression :: (T_Range) ->
                                (T_Expression) ->
                                (T_MaybeDeclarations) ->
                                (T_RightHandSide)
sem_RightHandSide_Expression (range_) (expression_) (where_) =
    let _lhsOself :: (RightHandSide)
        _rangeIself :: (Range)
        _expressionIself :: (Expression)
        _whereIself :: (MaybeDeclarations)
        ( _rangeIself) =
            (range_ )
        ( _expressionIself) =
            (expression_ )
        ( _whereIself) =
            (where_ )
        -- self rule
        (_self@_) =
            RightHandSide_Expression _rangeIself _expressionIself _whereIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_RightHandSide_Guarded :: (T_Range) ->
                             (T_GuardedExpressions) ->
                             (T_MaybeDeclarations) ->
                             (T_RightHandSide)
sem_RightHandSide_Guarded (range_) (guardedexpressions_) (where_) =
    let _lhsOself :: (RightHandSide)
        _rangeIself :: (Range)
        _guardedexpressionsIself :: (GuardedExpressions)
        _whereIself :: (MaybeDeclarations)
        ( _rangeIself) =
            (range_ )
        ( _guardedexpressionsIself) =
            (guardedexpressions_ )
        ( _whereIself) =
            (where_ )
        -- self rule
        (_self@_) =
            RightHandSide_Guarded _rangeIself _guardedexpressionsIself _whereIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- Root --------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      out                  : (Declarations,Declarations,Declarations,Declarations)
      self                 : SELF

-}
{-
   local variables for Root.Root:
      self

-}
-- semantic domain
type T_Root = ( ((Declarations,Declarations,Declarations,Declarations)),(Root))
-- cata
sem_Root :: (Root) ->
            (T_Root)
sem_Root ((Root_Root (_contents))) =
    (sem_Root_Root ((sem_Declaration (_contents))))
sem_Root_Root :: (T_Declaration) ->
                 (T_Root)
sem_Root_Root (contents_) =
    let _lhsOout :: ((Declarations,Declarations,Declarations,Declarations))
        _lhsOself :: (Root)
        _contentsIcontype :: (Declarations)
        _contentsIdescriptors :: (Declarations)
        _contentsIep :: (Declarations)
        _contentsIlabDescriptors :: ([(Name,Declarations)])
        _contentsIself :: (Declaration)
        _contentsIstrtype :: (Declarations)
        ( _contentsIcontype,_contentsIdescriptors,_contentsIep,_contentsIlabDescriptors,_contentsIself,_contentsIstrtype) =
            (contents_ )
        -- "StructureTypes.lag"(line 761, column 9)
        (_lhsOout@_) =
            (_contentsIstrtype
            ,_contentsIep
            ,_contentsIcontype
            ,_contentsIdescriptors
               ++
             concatMap snd _contentsIlabDescriptors
            )
        -- self rule
        (_self@_) =
            Root_Root _contentsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOout,_lhsOself)
-- SimpleType --------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      name                 : Name
      self                 : SELF
      typevariables        : Names

-}
{-
   local variables for SimpleType.SimpleType:
      self

-}
-- semantic domain
type T_SimpleType = ( (Name),(SimpleType),(Names))
-- cata
sem_SimpleType :: (SimpleType) ->
                  (T_SimpleType)
sem_SimpleType ((SimpleType_SimpleType (_range) (_name) (_typevariables))) =
    (sem_SimpleType_SimpleType ((sem_Range (_range))) ((sem_Name (_name))) ((sem_KindAnnotatedNames (_typevariables))))
sem_SimpleType_SimpleType :: (T_Range) ->
                             (T_Name) ->
                             (T_KindAnnotatedNames) ->
                             (T_SimpleType)
sem_SimpleType_SimpleType (range_) (name_) (typevariables_) =
    let _lhsOname :: (Name)
        _lhsOself :: (SimpleType)
        _lhsOtypevariables :: (Names)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        _typevariablesIself :: (KindAnnotatedNames)
        _typevariablesItypevariables :: (Names)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _typevariablesIself,_typevariablesItypevariables) =
            (typevariables_ )
        -- "StructureTypes.lag"(line 124, column 9)
        (_lhsOname@_) =
            _nameIself
        -- self rule
        (_self@_) =
            SimpleType_SimpleType _rangeIself _nameIself _typevariablesIself
        -- self rule
        (_lhsOself@_) =
            _self
        -- copy rule (up)
        (_lhsOtypevariables@_) =
            _typevariablesItypevariables
    in  ( _lhsOname,_lhsOself,_lhsOtypevariables)
-- Statement ---------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Statement.Empty:
      self

-}
{-
   local variables for Statement.Expression:
      self

-}
{-
   local variables for Statement.Generator:
      self

-}
{-
   local variables for Statement.Let:
      self

-}
-- semantic domain
type T_Statement = ( (Statement))
-- cata
sem_Statement :: (Statement) ->
                 (T_Statement)
sem_Statement ((Statement_Empty (_range))) =
    (sem_Statement_Empty ((sem_Range (_range))))
sem_Statement ((Statement_Expression (_range) (_expression))) =
    (sem_Statement_Expression ((sem_Range (_range))) ((sem_Expression (_expression))))
sem_Statement ((Statement_Generator (_range) (_pattern) (_expression))) =
    (sem_Statement_Generator ((sem_Range (_range))) ((sem_Pattern (_pattern))) ((sem_Expression (_expression))))
sem_Statement ((Statement_Let (_range) (_declarations))) =
    (sem_Statement_Let ((sem_Range (_range))) ((sem_Declarations (_declarations))))
sem_Statement_Empty :: (T_Range) ->
                       (T_Statement)
sem_Statement_Empty (range_) =
    let _lhsOself :: (Statement)
        _rangeIself :: (Range)
        ( _rangeIself) =
            (range_ )
        -- self rule
        (_self@_) =
            Statement_Empty _rangeIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Statement_Expression :: (T_Range) ->
                            (T_Expression) ->
                            (T_Statement)
sem_Statement_Expression (range_) (expression_) =
    let _lhsOself :: (Statement)
        _rangeIself :: (Range)
        _expressionIself :: (Expression)
        ( _rangeIself) =
            (range_ )
        ( _expressionIself) =
            (expression_ )
        -- self rule
        (_self@_) =
            Statement_Expression _rangeIself _expressionIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Statement_Generator :: (T_Range) ->
                           (T_Pattern) ->
                           (T_Expression) ->
                           (T_Statement)
sem_Statement_Generator (range_) (pattern_) (expression_) =
    let _lhsOself :: (Statement)
        _rangeIself :: (Range)
        _patternIself :: (Pattern)
        _expressionIself :: (Expression)
        ( _rangeIself) =
            (range_ )
        ( _patternIself) =
            (pattern_ )
        ( _expressionIself) =
            (expression_ )
        -- self rule
        (_self@_) =
            Statement_Generator _rangeIself _patternIself _expressionIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Statement_Let :: (T_Range) ->
                     (T_Declarations) ->
                     (T_Statement)
sem_Statement_Let (range_) (declarations_) =
    let _lhsOself :: (Statement)
        _rangeIself :: (Range)
        _declarationsIself :: (Declarations)
        ( _rangeIself) =
            (range_ )
        ( _declarationsIself) =
            (declarations_ )
        -- self rule
        (_self@_) =
            Statement_Let _rangeIself _declarationsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- Statements --------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Statements.Cons:
      self

-}
{-
   local variables for Statements.Nil:
      self

-}
-- semantic domain
type T_Statements = ( (Statements))
-- cata
sem_Statements :: (Statements) ->
                  (T_Statements)
sem_Statements (list) =
    (foldr (sem_Statements_Cons) (sem_Statements_Nil) ((map sem_Statement list)))
sem_Statements_Cons :: (T_Statement) ->
                       (T_Statements) ->
                       (T_Statements)
sem_Statements_Cons (hd_) (tl_) =
    let _lhsOself :: (Statements)
        _hdIself :: (Statement)
        _tlIself :: (Statements)
        ( _hdIself) =
            (hd_ )
        ( _tlIself) =
            (tl_ )
        -- self rule
        (_self@_) =
            (:) _hdIself _tlIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Statements_Nil :: (T_Statements)
sem_Statements_Nil  =
    let _lhsOself :: (Statements)
        -- self rule
        (_self@_) =
            []
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- Strings -----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Strings.Cons:
      self

-}
{-
   local variables for Strings.Nil:
      self

-}
-- semantic domain
type T_Strings = ( (Strings))
-- cata
sem_Strings :: (Strings) ->
               (T_Strings)
sem_Strings (list) =
    (foldr (sem_Strings_Cons) (sem_Strings_Nil) (list))
sem_Strings_Cons :: (String) ->
                    (T_Strings) ->
                    (T_Strings)
sem_Strings_Cons (hd_) (tl_) =
    let _lhsOself :: (Strings)
        _tlIself :: (Strings)
        ( _tlIself) =
            (tl_ )
        -- self rule
        (_self@_) =
            (:) hd_ _tlIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Strings_Nil :: (T_Strings)
sem_Strings_Nil  =
    let _lhsOself :: (Strings)
        -- self rule
        (_self@_) =
            []
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- Type --------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Type.Application:
      self

-}
{-
   local variables for Type.Con:
      self

-}
{-
   local variables for Type.Constructor:
      self

-}
{-
   local variables for Type.ConstructorCase:
      self

-}
{-
   local variables for Type.Exists:
      self

-}
{-
   local variables for Type.Forall:
      self

-}
{-
   local variables for Type.KindApplication:
      self

-}
{-
   local variables for Type.KindStarCase:
      self

-}
{-
   local variables for Type.Kinded:
      self

-}
{-
   local variables for Type.Label:
      self

-}
{-
   local variables for Type.Parenthesized:
      self

-}
{-
   local variables for Type.Qualified:
      self

-}
{-
   local variables for Type.TypeApplication:
      self

-}
{-
   local variables for Type.TypeSignature:
      self

-}
{-
   local variables for Type.Variable:
      self

-}
-- semantic domain
type T_Type = ( (Type))
-- cata
sem_Type :: (Type) ->
            (T_Type)
sem_Type ((Type_Application (_range) (_prefix) (_function) (_arguments))) =
    (sem_Type_Application ((sem_Range (_range))) (_prefix) ((sem_Type (_function))) ((sem_Types (_arguments))))
sem_Type ((Type_Con (_range) (_name))) =
    (sem_Type_Con ((sem_Range (_range))) ((sem_Name (_name))))
sem_Type ((Type_Constructor (_range) (_name))) =
    (sem_Type_Constructor ((sem_Range (_range))) ((sem_Name (_name))))
sem_Type ((Type_ConstructorCase (_range) (_name))) =
    (sem_Type_ConstructorCase ((sem_Range (_range))) ((sem_Name (_name))))
sem_Type ((Type_Exists (_range) (_typevariables) (_type))) =
    (sem_Type_Exists ((sem_Range (_range))) ((sem_Names (_typevariables))) ((sem_Type (_type))))
sem_Type ((Type_Forall (_range) (_typevariables) (_type))) =
    (sem_Type_Forall ((sem_Range (_range))) ((sem_Names (_typevariables))) ((sem_Type (_type))))
sem_Type ((Type_KindApplication (_range) (_name) (_kind))) =
    (sem_Type_KindApplication ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Kind (_kind))))
sem_Type ((Type_KindStarCase (_range))) =
    (sem_Type_KindStarCase ((sem_Range (_range))))
sem_Type ((Type_Kinded (_range) (_name) (_kind))) =
    (sem_Type_Kinded ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Kind (_kind))))
sem_Type ((Type_Label (_range) (_name))) =
    (sem_Type_Label ((sem_Range (_range))) ((sem_Name (_name))))
sem_Type ((Type_Parenthesized (_range) (_type))) =
    (sem_Type_Parenthesized ((sem_Range (_range))) ((sem_Type (_type))))
sem_Type ((Type_Qualified (_range) (_context) (_type))) =
    (sem_Type_Qualified ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_Type (_type))))
sem_Type ((Type_TypeApplication (_range) (_name) (_type))) =
    (sem_Type_TypeApplication ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Type (_type))))
sem_Type ((Type_TypeSignature (_range) (_generics) (_parametrics))) =
    (sem_Type_TypeSignature ((sem_Range (_range))) ((sem_KindAnnotatedNames (_generics))) ((sem_Types (_parametrics))))
sem_Type ((Type_Variable (_range) (_name))) =
    (sem_Type_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Type_Application :: (T_Range) ->
                        (Bool) ->
                        (T_Type) ->
                        (T_Types) ->
                        (T_Type)
sem_Type_Application (range_) (prefix_) (function_) (arguments_) =
    let _lhsOself :: (Type)
        _rangeIself :: (Range)
        _functionIself :: (Type)
        _argumentsIself :: (Types)
        ( _rangeIself) =
            (range_ )
        ( _functionIself) =
            (function_ )
        ( _argumentsIself) =
            (arguments_ )
        -- self rule
        (_self@_) =
            Type_Application _rangeIself prefix_ _functionIself _argumentsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Type_Con :: (T_Range) ->
                (T_Name) ->
                (T_Type)
sem_Type_Con (range_) (name_) =
    let _lhsOself :: (Type)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        -- self rule
        (_self@_) =
            Type_Con _rangeIself _nameIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Type_Constructor :: (T_Range) ->
                        (T_Name) ->
                        (T_Type)
sem_Type_Constructor (range_) (name_) =
    let _lhsOself :: (Type)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        -- self rule
        (_self@_) =
            Type_Constructor _rangeIself _nameIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Type_ConstructorCase :: (T_Range) ->
                            (T_Name) ->
                            (T_Type)
sem_Type_ConstructorCase (range_) (name_) =
    let _lhsOself :: (Type)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        -- self rule
        (_self@_) =
            Type_ConstructorCase _rangeIself _nameIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Type_Exists :: (T_Range) ->
                   (T_Names) ->
                   (T_Type) ->
                   (T_Type)
sem_Type_Exists (range_) (typevariables_) (type_) =
    let _lhsOself :: (Type)
        _rangeIself :: (Range)
        _typevariablesIself :: (Names)
        _typeIself :: (Type)
        ( _rangeIself) =
            (range_ )
        ( _typevariablesIself) =
            (typevariables_ )
        ( _typeIself) =
            (type_ )
        -- self rule
        (_self@_) =
            Type_Exists _rangeIself _typevariablesIself _typeIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Type_Forall :: (T_Range) ->
                   (T_Names) ->
                   (T_Type) ->
                   (T_Type)
sem_Type_Forall (range_) (typevariables_) (type_) =
    let _lhsOself :: (Type)
        _rangeIself :: (Range)
        _typevariablesIself :: (Names)
        _typeIself :: (Type)
        ( _rangeIself) =
            (range_ )
        ( _typevariablesIself) =
            (typevariables_ )
        ( _typeIself) =
            (type_ )
        -- self rule
        (_self@_) =
            Type_Forall _rangeIself _typevariablesIself _typeIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Type_KindApplication :: (T_Range) ->
                            (T_Name) ->
                            (T_Kind) ->
                            (T_Type)
sem_Type_KindApplication (range_) (name_) (kind_) =
    let _lhsOself :: (Type)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        _kindIself :: (Kind)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _kindIself) =
            (kind_ )
        -- self rule
        (_self@_) =
            Type_KindApplication _rangeIself _nameIself _kindIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Type_KindStarCase :: (T_Range) ->
                         (T_Type)
sem_Type_KindStarCase (range_) =
    let _lhsOself :: (Type)
        _rangeIself :: (Range)
        ( _rangeIself) =
            (range_ )
        -- self rule
        (_self@_) =
            Type_KindStarCase _rangeIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Type_Kinded :: (T_Range) ->
                   (T_Name) ->
                   (T_Kind) ->
                   (T_Type)
sem_Type_Kinded (range_) (name_) (kind_) =
    let _lhsOself :: (Type)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        _kindIself :: (Kind)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _kindIself) =
            (kind_ )
        -- self rule
        (_self@_) =
            Type_Kinded _rangeIself _nameIself _kindIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Type_Label :: (T_Range) ->
                  (T_Name) ->
                  (T_Type)
sem_Type_Label (range_) (name_) =
    let _lhsOself :: (Type)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        -- self rule
        (_self@_) =
            Type_Label _rangeIself _nameIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Type_Parenthesized :: (T_Range) ->
                          (T_Type) ->
                          (T_Type)
sem_Type_Parenthesized (range_) (type_) =
    let _lhsOself :: (Type)
        _rangeIself :: (Range)
        _typeIself :: (Type)
        ( _rangeIself) =
            (range_ )
        ( _typeIself) =
            (type_ )
        -- self rule
        (_self@_) =
            Type_Parenthesized _rangeIself _typeIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Type_Qualified :: (T_Range) ->
                      (T_ContextItems) ->
                      (T_Type) ->
                      (T_Type)
sem_Type_Qualified (range_) (context_) (type_) =
    let _lhsOself :: (Type)
        _rangeIself :: (Range)
        _contextIself :: (ContextItems)
        _typeIself :: (Type)
        ( _rangeIself) =
            (range_ )
        ( _contextIself) =
            (context_ )
        ( _typeIself) =
            (type_ )
        -- self rule
        (_self@_) =
            Type_Qualified _rangeIself _contextIself _typeIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Type_TypeApplication :: (T_Range) ->
                            (T_Name) ->
                            (T_Type) ->
                            (T_Type)
sem_Type_TypeApplication (range_) (name_) (type_) =
    let _lhsOself :: (Type)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        _typeIself :: (Type)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _typeIself) =
            (type_ )
        -- self rule
        (_self@_) =
            Type_TypeApplication _rangeIself _nameIself _typeIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Type_TypeSignature :: (T_Range) ->
                          (T_KindAnnotatedNames) ->
                          (T_Types) ->
                          (T_Type)
sem_Type_TypeSignature (range_) (generics_) (parametrics_) =
    let _lhsOself :: (Type)
        _rangeIself :: (Range)
        _genericsIself :: (KindAnnotatedNames)
        _genericsItypevariables :: (Names)
        _parametricsIself :: (Types)
        ( _rangeIself) =
            (range_ )
        ( _genericsIself,_genericsItypevariables) =
            (generics_ )
        ( _parametricsIself) =
            (parametrics_ )
        -- self rule
        (_self@_) =
            Type_TypeSignature _rangeIself _genericsIself _parametricsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Type_Variable :: (T_Range) ->
                     (T_Name) ->
                     (T_Type)
sem_Type_Variable (range_) (name_) =
    let _lhsOself :: (Type)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        -- self rule
        (_self@_) =
            Type_Variable _rangeIself _nameIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- TypeArgument ------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for TypeArgument.Constructor:
      self

-}
{-
   local variables for TypeArgument.ConstructorCase:
      self

-}
{-
   local variables for TypeArgument.DependencyStyle:
      self

-}
{-
   local variables for TypeArgument.KindStarCase:
      self

-}
{-
   local variables for TypeArgument.Label:
      self

-}
{-
   local variables for TypeArgument.NamedType:
      self

-}
{-
   local variables for TypeArgument.Variable:
      self

-}
-- semantic domain
type T_TypeArgument = ( (TypeArgument))
-- cata
sem_TypeArgument :: (TypeArgument) ->
                    (T_TypeArgument)
sem_TypeArgument ((TypeArgument_Constructor (_range) (_variable))) =
    (sem_TypeArgument_Constructor ((sem_Range (_range))) ((sem_Name (_variable))))
sem_TypeArgument ((TypeArgument_ConstructorCase (_range) (_name))) =
    (sem_TypeArgument_ConstructorCase ((sem_Range (_range))) ((sem_Name (_name))))
sem_TypeArgument ((TypeArgument_DependencyStyle (_range) (_name) (_descriptor) (_variables))) =
    (sem_TypeArgument_DependencyStyle ((sem_Range (_range))) ((sem_Name (_name))) ((sem_MaybeName (_descriptor))) ((sem_Names (_variables))))
sem_TypeArgument ((TypeArgument_KindStarCase (_range))) =
    (sem_TypeArgument_KindStarCase ((sem_Range (_range))))
sem_TypeArgument ((TypeArgument_Label (_range) (_variable))) =
    (sem_TypeArgument_Label ((sem_Range (_range))) ((sem_Name (_variable))))
sem_TypeArgument ((TypeArgument_NamedType (_range) (_name))) =
    (sem_TypeArgument_NamedType ((sem_Range (_range))) ((sem_Name (_name))))
sem_TypeArgument ((TypeArgument_Variable (_range) (_name))) =
    (sem_TypeArgument_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_TypeArgument_Constructor :: (T_Range) ->
                                (T_Name) ->
                                (T_TypeArgument)
sem_TypeArgument_Constructor (range_) (variable_) =
    let _lhsOself :: (TypeArgument)
        _rangeIself :: (Range)
        _variableIself :: (Name)
        ( _rangeIself) =
            (range_ )
        ( _variableIself) =
            (variable_ )
        -- self rule
        (_self@_) =
            TypeArgument_Constructor _rangeIself _variableIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_TypeArgument_ConstructorCase :: (T_Range) ->
                                    (T_Name) ->
                                    (T_TypeArgument)
sem_TypeArgument_ConstructorCase (range_) (name_) =
    let _lhsOself :: (TypeArgument)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        -- self rule
        (_self@_) =
            TypeArgument_ConstructorCase _rangeIself _nameIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_TypeArgument_DependencyStyle :: (T_Range) ->
                                    (T_Name) ->
                                    (T_MaybeName) ->
                                    (T_Names) ->
                                    (T_TypeArgument)
sem_TypeArgument_DependencyStyle (range_) (name_) (descriptor_) (variables_) =
    let _lhsOself :: (TypeArgument)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        _descriptorIself :: (MaybeName)
        _variablesIself :: (Names)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _descriptorIself) =
            (descriptor_ )
        ( _variablesIself) =
            (variables_ )
        -- self rule
        (_self@_) =
            TypeArgument_DependencyStyle _rangeIself _nameIself _descriptorIself _variablesIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_TypeArgument_KindStarCase :: (T_Range) ->
                                 (T_TypeArgument)
sem_TypeArgument_KindStarCase (range_) =
    let _lhsOself :: (TypeArgument)
        _rangeIself :: (Range)
        ( _rangeIself) =
            (range_ )
        -- self rule
        (_self@_) =
            TypeArgument_KindStarCase _rangeIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_TypeArgument_Label :: (T_Range) ->
                          (T_Name) ->
                          (T_TypeArgument)
sem_TypeArgument_Label (range_) (variable_) =
    let _lhsOself :: (TypeArgument)
        _rangeIself :: (Range)
        _variableIself :: (Name)
        ( _rangeIself) =
            (range_ )
        ( _variableIself) =
            (variable_ )
        -- self rule
        (_self@_) =
            TypeArgument_Label _rangeIself _variableIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_TypeArgument_NamedType :: (T_Range) ->
                              (T_Name) ->
                              (T_TypeArgument)
sem_TypeArgument_NamedType (range_) (name_) =
    let _lhsOself :: (TypeArgument)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        -- self rule
        (_self@_) =
            TypeArgument_NamedType _rangeIself _nameIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_TypeArgument_Variable :: (T_Range) ->
                             (T_Name) ->
                             (T_TypeArgument)
sem_TypeArgument_Variable (range_) (name_) =
    let _lhsOself :: (TypeArgument)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        -- self rule
        (_self@_) =
            TypeArgument_Variable _rangeIself _nameIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- TypeArguments -----------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for TypeArguments.Cons:
      self

-}
{-
   local variables for TypeArguments.Nil:
      self

-}
-- semantic domain
type T_TypeArguments = ( (TypeArguments))
-- cata
sem_TypeArguments :: (TypeArguments) ->
                     (T_TypeArguments)
sem_TypeArguments (list) =
    (foldr (sem_TypeArguments_Cons) (sem_TypeArguments_Nil) ((map sem_TypeArgument list)))
sem_TypeArguments_Cons :: (T_TypeArgument) ->
                          (T_TypeArguments) ->
                          (T_TypeArguments)
sem_TypeArguments_Cons (hd_) (tl_) =
    let _lhsOself :: (TypeArguments)
        _hdIself :: (TypeArgument)
        _tlIself :: (TypeArguments)
        ( _hdIself) =
            (hd_ )
        ( _tlIself) =
            (tl_ )
        -- self rule
        (_self@_) =
            (:) _hdIself _tlIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_TypeArguments_Nil :: (T_TypeArguments)
sem_TypeArguments_Nil  =
    let _lhsOself :: (TypeArguments)
        -- self rule
        (_self@_) =
            []
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- TypeIndexedBinding ------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for TypeIndexedBinding.DefaultCase:
      self

-}
{-
   local variables for TypeIndexedBinding.TypeIndexedBinding:
      self

-}
-- semantic domain
type T_TypeIndexedBinding = ( (TypeIndexedBinding))
-- cata
sem_TypeIndexedBinding :: (TypeIndexedBinding) ->
                          (T_TypeIndexedBinding)
sem_TypeIndexedBinding ((TypeIndexedBinding_DefaultCase (_range) (_name) (_extended) (_reassignments))) =
    (sem_TypeIndexedBinding_DefaultCase ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Name (_extended))) ((sem_MaybeReassignments (_reassignments))))
sem_TypeIndexedBinding ((TypeIndexedBinding_TypeIndexedBinding (_range) (_name) (_typeargument) (_patterns) (_righthandside))) =
    (sem_TypeIndexedBinding_TypeIndexedBinding ((sem_Range (_range))) ((sem_Name (_name))) ((sem_TypeArgument (_typeargument))) ((sem_Patterns (_patterns))) ((sem_RightHandSide (_righthandside))))
sem_TypeIndexedBinding_DefaultCase :: (T_Range) ->
                                      (T_Name) ->
                                      (T_Name) ->
                                      (T_MaybeReassignments) ->
                                      (T_TypeIndexedBinding)
sem_TypeIndexedBinding_DefaultCase (range_) (name_) (extended_) (reassignments_) =
    let _lhsOself :: (TypeIndexedBinding)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        _extendedIself :: (Name)
        _reassignmentsIself :: (MaybeReassignments)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _extendedIself) =
            (extended_ )
        ( _reassignmentsIself) =
            (reassignments_ )
        -- self rule
        (_self@_) =
            TypeIndexedBinding_DefaultCase _rangeIself _nameIself _extendedIself _reassignmentsIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_TypeIndexedBinding_TypeIndexedBinding :: (T_Range) ->
                                             (T_Name) ->
                                             (T_TypeArgument) ->
                                             (T_Patterns) ->
                                             (T_RightHandSide) ->
                                             (T_TypeIndexedBinding)
sem_TypeIndexedBinding_TypeIndexedBinding (range_) (name_) (typeargument_) (patterns_) (righthandside_) =
    let _lhsOself :: (TypeIndexedBinding)
        _rangeIself :: (Range)
        _nameIself :: (Name)
        _typeargumentIself :: (TypeArgument)
        _patternsIself :: (Patterns)
        _righthandsideIself :: (RightHandSide)
        ( _rangeIself) =
            (range_ )
        ( _nameIself) =
            (name_ )
        ( _typeargumentIself) =
            (typeargument_ )
        ( _patternsIself) =
            (patterns_ )
        ( _righthandsideIself) =
            (righthandside_ )
        -- self rule
        (_self@_) =
            TypeIndexedBinding_TypeIndexedBinding _rangeIself _nameIself _typeargumentIself _patternsIself _righthandsideIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- TypeIndexedBindings -----------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for TypeIndexedBindings.Cons:
      self

-}
{-
   local variables for TypeIndexedBindings.Nil:
      self

-}
-- semantic domain
type T_TypeIndexedBindings = ( (TypeIndexedBindings))
-- cata
sem_TypeIndexedBindings :: (TypeIndexedBindings) ->
                           (T_TypeIndexedBindings)
sem_TypeIndexedBindings (list) =
    (foldr (sem_TypeIndexedBindings_Cons) (sem_TypeIndexedBindings_Nil) ((map sem_TypeIndexedBinding list)))
sem_TypeIndexedBindings_Cons :: (T_TypeIndexedBinding) ->
                                (T_TypeIndexedBindings) ->
                                (T_TypeIndexedBindings)
sem_TypeIndexedBindings_Cons (hd_) (tl_) =
    let _lhsOself :: (TypeIndexedBindings)
        _hdIself :: (TypeIndexedBinding)
        _tlIself :: (TypeIndexedBindings)
        ( _hdIself) =
            (hd_ )
        ( _tlIself) =
            (tl_ )
        -- self rule
        (_self@_) =
            (:) _hdIself _tlIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_TypeIndexedBindings_Nil :: (T_TypeIndexedBindings)
sem_TypeIndexedBindings_Nil  =
    let _lhsOself :: (TypeIndexedBindings)
        -- self rule
        (_self@_) =
            []
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
-- Types -------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SELF

-}
{-
   local variables for Types.Cons:
      self

-}
{-
   local variables for Types.Nil:
      self

-}
-- semantic domain
type T_Types = ( (Types))
-- cata
sem_Types :: (Types) ->
             (T_Types)
sem_Types (list) =
    (foldr (sem_Types_Cons) (sem_Types_Nil) ((map sem_Type list)))
sem_Types_Cons :: (T_Type) ->
                  (T_Types) ->
                  (T_Types)
sem_Types_Cons (hd_) (tl_) =
    let _lhsOself :: (Types)
        _hdIself :: (Type)
        _tlIself :: (Types)
        ( _hdIself) =
            (hd_ )
        ( _tlIself) =
            (tl_ )
        -- self rule
        (_self@_) =
            (:) _hdIself _tlIself
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)
sem_Types_Nil :: (T_Types)
sem_Types_Nil  =
    let _lhsOself :: (Types)
        -- self rule
        (_self@_) =
            []
        -- self rule
        (_lhsOself@_) =
            _self
    in  ( _lhsOself)


